:- package(abs_interval_tab).
:- export([
		call_domain_projection/2,
		answer_domain_projection/2,
		call_store_projection/3,
		answer_store_projection/3,
		call_entail/4,
		answer_check_entail/5,
		apply_answer/3
	    ]).

:- use_package(library(abs_interval)).
:- active_tclp.

%% tabling interface %%


call_domain_projection(Vars,(Space,Dom)) :-
	aux_dump_attributes(Vars,Space,Dom).
answer_domain_projection(Vars,(Space,Dom)) :-
	aux_dump_attributes(Vars,Space,Dom).

call_store_projection(Vars, (SpaceA, _D), 'project') :-
%	print(['          --     ', Vars, '        ', SpaceA]),nl,nl,
	aux_clean_vars(Vars, SpaceA).
%	print(['          ++     ', Vars, '        ', SpaceA]),nl,nl.
answer_store_projection(_X, _A, 'project').

call_entail(_V, (SpaceA,DomA),(SpaceB,DomB), _Space) :-
	\+ \+ aux_entail(SpaceA,DomA,SpaceB,DomB).
answer_check_entail(_V, (SpaceA,DomA),(SpaceB,DomB), _Space, 1) :-
	\+ \+ aux_entail(SpaceA,DomA,SpaceB,DomB).

apply_answer(Vars,(SpaceA,DomA),_Space) :-
	aux_apply_answer(Vars,SpaceA,DomA).




