:- package(abs_new_constraint_tab).
:- export([
		call_domain_projection/2,
		answer_domain_projection/2,
		call_store_projection/3,
		answer_store_projection/3,
		call_entail/4,
		answer_check_entail/6,
		apply_answer/3
	    ]).

:- use_package(library(abs_new_constraint)).
:- active_tclp.

%% tabling interface %%


call_domain_projection(Vars, (Space, Dom)) :-
	aux_project_domain(Vars, Space, Dom).
answer_domain_projection(Vars, (Space, Dom)) :-
	aux_project_domain(Vars, Space, Dom).

call_store_projection(Vars, (SpaceA, _D), _P) :-
	aux_clean_vars(Vars, SpaceA).
answer_store_projection(_, _, _).

call_entail(_V, (SpaceA, DomA), (SpaceB, DomB), _Space) :-
	\+ \+ aux_entail(SpaceA, DomA, SpaceB, DomB).

answer_check_entail(_V, (SpaceA, DomA), (SpaceB, DomB), _Space, 1, _) :-
	\+ \+ aux_entail(SpaceA, DomA, SpaceB, DomB), !.
answer_check_entail(_V, (SpaceA, DomA), (SpaceB, DomB), _Space, -1, _) :-
	\+ \+ aux_entail(SpaceB, DomB, SpaceA, DomA), !.

apply_answer(Vars, (SpaceA, DomA), _) :-
	aux_apply_answer(Vars, SpaceA, DomA).


