:- module(tabling_constraint_example, _).

% :- use_package(library(expander)).


:- use_package(library(tabling)).
:- use_package(library(abs_new_constraint/abs_new_constraint_tab)).



:- table test/2.

test(X, Y) :-
	abs(Z, zero),
	Y .<. X,
	X .<. Z.


abstraction(X, P) :-
	abs(X, P).


reinstall(Goal) :-
	call(Goal).

:- table entail_answers/1.
entail_answers(X) :-
	abs(X,pos).
entail_answers(X) :-
	abs(X,pos+z).
% entail_answers(X) :-
% 	abs(X,pos).
entail_answers(X) :-
	abs(X, neg).



:- table p/1.
p(P) :-
	abs(P,pos),
 	p(P).
p(P) :-
	abs(T, pos+z),
	P .>. T.


:- table pos/2.
pos(X,Y) :-
	X .>. 0, Y .=. 0.

pos(X,Y) :-
	X .=.0 , Y .>. 0.

:- table space/3.

space(X,Y,Z) :-
	X .<. Y,
	space(X,Y,Z),
	Y .<. 0,
	Z .=. (-3),
	abs(X,Px),
	display(['first call = ',Px]), nl.

space(X,Y,_Z) :-
	X .<. 0,
	Y .>. 0.

space(X,Y,Z) :-
	X .<. Y,
	space(X,Y,Z),
	abs(X,Px),
	Y .>. 0,
	Z .=. 5,
	display(['second call = ',Px]), nl.


:- table count1/2.
count1(A,B) :-
	A .>. 0, 
	A1 abs_is A + (-1), 
	nl,print(['a',A,A1,B]),nl, 
	count1(A1, B1), 
	nl,print(['d',A,A1,B,B1]),nl,
	B abs_is B1 + 1,
	nl,print(['e',A,A1,B,B1]),nl.
count1(A,B) :-
	nl,print(['b1',A,B]),nl,
	A .=:=. 0, 
	nl,print(['b2',A,B]),nl,
	B abs_is A + 0,
	nl,print(['c',A,B]),nl.
