
:- module(_, _).

:- use_module(library(sets)).

:- use_package(library(tabling)).
:- const_table_module(library(clpq/clpq_tab)).
:- table noExtremo/1.

:- use_package(library(clpq)).

%set([p(2, 2), p(4, 1), p(8, 2), p(6, 3), p(5, 6), p(4, 3), p(2, 8), p(1, 4)]).
set([p(2, 2), p(4, 1), p(8, 2), p(6, 3), p(5, 6), p(4, 3), p(2, 8), p(1, 4), p(-1, 6), p(6, 1)]).
%set([p(0.5, 0), p(0, 0), p(1, 0), p(1, 1), p(0, 1), p(1, 0.5)]).

set_ord(X) :-
	set(S),
	sort(S, X).


izquierda(p(X1, Y1), p(X2, Y2), p(X3, Y3)) :-
	X2*Y3-X3*Y2-(X1*Y3-X3*Y1) +X1*Y2-X2*Y1 .>=. 0.

% ++++++++++++++++

noExtremo(Ph) :-
	izquierda(Ph, Pi, Pj),
	izquierda(Ph, Pj, Pk),
	izquierda(Ph, Pk, Pi),
	set_ord(X),
	select(Pi, X,  Si),
	select(Pj, Si, Sj),
	select(Pk, Sj, Sk),
	member(Ph, Sk).
program2(X) :-
	setof(C, noExtremo(C), I),
	set_ord(S1),
	ord_subtract(S1, I, X).


measure2(X, Time) :-
	statistics(runtime, _),
	program2(X),
	statistics(runtime, [_, Time]).
