 %% - Call examples: f(10,F), f(N,89).
 %% - You can commet line ':- table fib/2.' not to use tabling
 %% - times(N,fib(N,F)) repeats the execution of fib(N,F)
 %%   to get its execution time on average.
 %%    N is the minimum time we want to execute times/2.

:- module(fibo_clp, 
	[
%	    times/2,
	    fib_clp/2,
	    fib_clp2/2,
	    fib_lp/2,
	    fib_dc_clp/2
%           fib_dc/2
	], []).

 :- use_package(library(tabling)).
 :- const_table_module(library(clpq/clpq_tab)).
:- use_package(library(clpq)).

%:- include(times).

:- table fib_clp/2, fib_lp/2, fib_dc_clp/2, fib_clp2/2.

 %   statistics(runtime, [_,_]), fib_lp(11,P), statistics(runtime,[_,T]).


fib_clp(0, 0).
fib_clp(1, 1). 
fib_clp(N, F) :-
	N .>=. 2,
 	N1 .=. N - 1,
  	N2 .=. N - 2,
 	F1 .>=. 0,
 	F2 .>=. 0,
	F .=. F1 + F2,
        fib_clp(N1, F1),
        fib_clp(N2, F2).

fib_clp2(0, 0).
fib_clp2(1, 1). 
fib_clp2(N, F) :-
	N .>=. 2,
 	N1 .=. N - 1,
  	N2 .=. N - 2,
 	F1 .=<. F,
 	F2 .=<. F1,
	F .=. F1 + F2,
        fib_clp2(N1, F1),
        fib_clp2(N2, F2).

fib_lp(0,0).
fib_lp(1,1).
fib_lp(N,F) :-
	N > 1,
	N1 is N - 1,
	N2 is N - 2,
	fib_lp(N1, F1),
	fib_lp(N2, F2),
	F is F1 + F2.

fib_dc_clp(0, 0).
fib_dc_clp(1, 1).
fib_dc_clp(N, F) :-
	N .>=. 2,
 	N1 .=. N - 1,
  	N2 .=. N - 2,
 	F1 .=<. F,
 	F2 .=<. F1,
        fib_dc_clp(N1, F1),
        fib_dc_clp(N2, F2),
	F .=. F1 + F2.

% fib_dc(N, F) :- 
% 	N #= 0, 
% 	F #= 0.
% fib_dc(N, F) :- 
% 	N #= 1,
% 	F #= 1.
% fib_dc(N, F):-
% 	N #>= 2,
%  	N1 #= N - 1,
%   	N2 #= N - 2,
%  	F1 #=< F,
%  	F2 #=< F1,
%         fib(N1, F1),
%         fib(N2, F2),
% 	F #= F1 + F2. 
