


% :- use_package(library(tabling)).
% :- const_table_module(library(clpq/clpq_tab)).
% :- table path_1/3, path_2/3, path_3/3, path_4/3, path_5/3, path_6/3.

:- use_package(library(clpq)).

%% Benchmark with tabling and clpq - edges 1 - 10 with circle edge(3,1,10)
%% statistics(runtime, [_,_]), findall([X,Y], ( P .>. 0, P .<. 200, path_4(X,Y,P)), _List ), statistics(runtime, [_,T]), length(_List,L).
%% segmentation fault with 5 and 6.

%% Benchmark with tabling and clpq - edges 1 - 10 without circle edge(3,1,10)
%% statistics(runtime, [_,_]), findall([X,Y], ( P .>. 0, P .<. 200, path_4(X,Y,P)), _List ), statistics(runtime, [_,T]), length(_List,L).
%% segmentation fault with 5 and 6.


flight(melbourne, sydney,    1000).
flight(melbourne, perth,     4000).
flight(perth,     singapore, 5000).
flight(sydney,    singapore, 8500).
flight(melbourne, cairns,    4000).
flight(sydney,    cairns,    3200).
flight(cairns,    singapore, 4900).
flight(singapore, london,    10000).
flight(perth,     bahrain,   8000).
flight(bahrain,   london,    6500).
flight(sydney,    melbourne, 1000).



path_1(A,B,D) :-
	edge(A,B,D).
path_1(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	edge(A,Z,D1),
	path_1(Z,B,D2).

path_2(A,B,D) :-
	edge(A,B,D).
path_2(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	path_2(Z,B,D2),
	edge(A,Z,D1).

path_3(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	edge(A,Z,D1),
	path_3(Z,B,D2).
path_3(A,B,D) :-
	edge(A,B,D).

path_4(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	path_4(Z,B,D2),
	edge(A,Z,D1).
path_4(A,B,D) :-
	edge(A,B,D).

path_5(A,B,D) :-
	edge(A,B,D).
path_5(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	path_5(A,Z,D1),
	path_5(Z,B,D2).

path_6(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	path_6(A,Z,D1),
	path_6(Z,B,D2).
path_6(A,B,D) :-
	edge(A,B,D).

%% 5 %%


path_clp(S, E, D) :-
	flight(S, E, D).
path_clp(S, E, D) :-
	D .=. D1 + D2,
	path_clp(S,  A1, D1),
	path_clp(A1, E,  D2).

path_clp2(S, E, D) :-
	flight(S, E, D).
path_clp2(S, E, D) :-
	D .=. D1 + D2,
	flight(S, A1, D1),
	path_clp2(A1, E, D2).

path(S, E, D) :-
	flight(S, E, D).
path(S, E, D) :-
	D .=. D1 + D2,
	flight(S, A1, D1),
	path(A1, E, D2).



go1 :-
	statistics(runtime, [_,_]), findall([X,Y], ( P .<. 2000, path(X,Y,P)), _List ), statistics(runtime, [_,T]), length(_List,L),
	display(L), nl,
	display(T), nl.



% edge(30, 16, 460).
% edge(30, 14, 440).
% edge(30, 27, 570).
% edge(30, 22, 520).
% edge(30, 29, 590).
% edge(30, 6, 360).
% edge(30, 5, 350).
% edge(30, 23, 530).
% edge(30, 19, 490).
% edge(30, 7, 370).
% edge(30, 18, 480).
% edge(30, 9, 390).
% edge(30, 16, 460).
% edge(30, 8, 380).
% edge(30, 26, 560).
% edge(30, 19, 490).
% edge(30, 3, 330).
% edge(30, 9, 390).
% edge(30, 29, 590).
% edge(30, 15, 450).
% edge(30, 6, 360).
% edge(30, 24, 540).
% edge(30, 13, 430).
% edge(30, 25, 550).
% edge(30, 2, 320).
% edge(30, 4, 340).
% edge(29, 7, 360).
% edge(29, 16, 450).
% edge(29, 2, 310).
% edge(29, 6, 350).
% edge(29, 13, 420).
% edge(29, 18, 470).
% edge(29, 28, 570).
% edge(29, 3, 320).
% edge(29, 4, 330).
% edge(29, 22, 510).
% edge(29, 26, 550).
% edge(29, 25, 540).
% edge(29, 26, 550).
% edge(29, 23, 520).
% edge(29, 27, 560).
% edge(29, 15, 440).
% edge(29, 19, 480).
% edge(29, 14, 430).
% edge(29, 6, 350).
% edge(29, 8, 370).
% edge(29, 12, 410).
% edge(29, 9, 380).
% edge(29, 5, 340).
% edge(29, 9, 380).
% edge(28, 23, 510).
% edge(28, 19, 470).
% edge(28, 9, 370).
% edge(28, 12, 400).
% edge(28, 27, 550).
% edge(28, 7, 350).
% edge(28, 16, 440).
% edge(28, 2, 300).
% edge(28, 24, 520).
% edge(28, 6, 340).
% edge(28, 3, 310).
% edge(28, 26, 540).
% edge(28, 4, 320).
% edge(28, 15, 430).
% edge(28, 19, 470).
% edge(28, 29, 570).
% edge(28, 17, 450).
% edge(28, 29, 570).
% edge(28, 26, 540).
% edge(28, 6, 340).
% edge(28, 25, 530).
% edge(28, 13, 410).
% edge(28, 18, 460).
% edge(28, 5, 330).
% edge(28, 16, 440).
% edge(27, 26, 530).
% edge(27, 2, 290).
% edge(27, 16, 430).
% edge(27, 15, 420).
% edge(27, 25, 520).
% edge(27, 29, 560).
% edge(27, 5, 320).
% edge(27, 23, 500).
% edge(27, 28, 550).
% edge(27, 4, 310).
% edge(27, 16, 430).
% edge(27, 12, 390).
% edge(27, 18, 450).
% edge(27, 26, 530).
% edge(27, 22, 490).
% edge(27, 6, 330).
% edge(27, 14, 410).
% edge(27, 7, 340).
% edge(27, 29, 560).
% edge(27, 17, 440).
% edge(27, 19, 460).
% edge(27, 9, 360).
% edge(27, 13, 400).
% edge(27, 6, 330).
% edge(27, 9, 360).
% edge(27, 3, 300).
% edge(27, 24, 510).
% edge(26, 19, 450).
% edge(26, 7, 330).
% edge(26, 17, 430).
% edge(26, 6, 320).
% edge(26, 5, 310).
% edge(26, 4, 300).
% edge(26, 25, 510).
% edge(26, 6, 320).
% edge(26, 15, 410).
% edge(26, 2, 280).
% edge(26, 19, 450).
% edge(26, 27, 530).
% edge(26, 24, 500).
% edge(26, 12, 380).
% edge(26, 29, 550).
% edge(26, 28, 540).
% edge(26, 29, 550).
% edge(26, 9, 350).
% edge(26, 26, 520).
% edge(26, 23, 490).
% edge(26, 14, 400).
% edge(26, 13, 390).
% edge(26, 9, 350).
% edge(26, 18, 440).
% edge(26, 16, 420).
% edge(25, 29, 540).
% edge(25, 5, 300).
% edge(25, 3, 280).
% edge(25, 17, 420).
% edge(25, 18, 430).
% edge(25, 28, 530).
% edge(25, 27, 520).
% edge(25, 26, 510).
% edge(25, 16, 410).
% edge(25, 8, 330).
% edge(25, 14, 390).
% edge(25, 4, 290).
% edge(25, 9, 340).
% edge(25, 12, 370).
% edge(25, 13, 380).
% edge(25, 19, 440).
% edge(25, 19, 440).
% edge(25, 23, 480).
% edge(25, 26, 510).
% edge(25, 22, 470).
% edge(25, 16, 410).
% edge(25, 9, 340).
% edge(25, 7, 320).
% edge(25, 15, 400).
% edge(25, 6, 310).
% edge(25, 6, 310).
% edge(25, 2, 270).
% edge(24, 19, 430).
% edge(24, 19, 430).
% edge(24, 5, 290).
% edge(24, 28, 520).
% edge(24, 29, 530).
% edge(24, 16, 400).
% edge(24, 17, 410).
% edge(24, 16, 400).
% edge(24, 14, 380).
% edge(24, 25, 490).
% edge(24, 12, 360).
% edge(24, 3, 270).
% edge(24, 7, 310).
% edge(24, 18, 420).
% edge(24, 6, 300).
% edge(24, 26, 500).
% edge(24, 15, 390).
% edge(24, 23, 470).
% edge(24, 29, 530).
% edge(24, 27, 510).
% edge(24, 9, 330).
% edge(23, 15, 380).
% edge(23, 17, 400).
% edge(23, 2, 250).
% edge(23, 9, 320).
% edge(23, 12, 350).
% edge(23, 4, 270).
% edge(23, 16, 390).
% edge(23, 29, 520).
% edge(23, 29, 520).
% edge(23, 19, 420).
% edge(23, 9, 320).
% edge(23, 25, 480).
% edge(23, 28, 510).
% edge(23, 19, 420).
% edge(23, 24, 470).
% edge(23, 26, 490).
% edge(23, 16, 390).
% edge(23, 7, 300).
% edge(23, 22, 450).
% edge(23, 8, 310).
% edge(23, 5, 280).
% edge(23, 14, 370).
% edge(23, 6, 290).
% edge(23, 27, 500).
% edge(22, 19, 410).
% edge(22, 5, 270).
% edge(22, 3, 250).
% edge(22, 23, 450).
% edge(22, 28, 500).
% edge(22, 9, 310).
% edge(22, 19, 410).
% edge(22, 7, 290).
% edge(22, 13, 350).
% edge(22, 26, 480).
% edge(22, 29, 510).
% edge(22, 17, 390).
% edge(22, 24, 460).
% edge(22, 15, 370).
% edge(22, 25, 470).
% edge(22, 6, 280).
% edge(22, 16, 380).
% edge(22, 2, 240).
% edge(22, 9, 310).
% edge(22, 27, 490).
% edge(22, 26, 480).
% edge(22, 6, 280).
% edge(22, 12, 340).
% edge(21, 16, 370).
% edge(21, 7, 280).
% edge(21, 25, 460).
% edge(21, 15, 360).
% edge(21, 26, 470).
% edge(21, 24, 450).
% edge(21, 14, 350).
% edge(21, 12, 330).
% edge(21, 22, 430).
% edge(21, 13, 340).
% edge(21, 9, 300).
% edge(21, 23, 440).
% edge(21, 18, 390).
% edge(21, 28, 490).
% edge(21, 16, 370).
% edge(21, 5, 260).
% edge(21, 29, 500).
% edge(21, 6, 270).
% edge(21, 17, 380).
% edge(21, 2, 230).
% edge(21, 9, 300).
% edge(21, 4, 250).
% edge(21, 19, 400).
% edge(21, 3, 240).
% edge(21, 27, 480).
% edge(21, 19, 400).
% edge(20, 7, 270).
% edge(20, 12, 320).
% edge(20, 16, 360).
% edge(20, 5, 250).
% edge(20, 23, 430).
% edge(20, 22, 420).
% edge(20, 3, 230).
% edge(20, 9, 290).
% edge(20, 26, 460).
% edge(20, 29, 490).
% edge(20, 24, 440).
% edge(20, 18, 380).
% edge(20, 6, 260).
% edge(20, 26, 460).
% edge(20, 27, 470).
% edge(20, 25, 450).
% edge(20, 4, 240).
% edge(20, 28, 480).
% edge(20, 19, 390).
% edge(20, 2, 220).
% edge(20, 9, 290).
% edge(20, 6, 260).
% edge(20, 16, 360).
% edge(20, 15, 350).
% edge(20, 14, 340).
% edge(19, 17, 360).
% edge(19, 28, 470).
% edge(19, 26, 450).
% edge(19, 18, 370).
% edge(19, 2, 210).
% edge(19, 6, 250).
% edge(19, 7, 260).
% edge(19, 23, 420).
% edge(19, 12, 310).
% edge(19, 16, 350).
% edge(19, 27, 460).
% edge(19, 25, 440).
% edge(19, 6, 250).
% edge(19, 29, 480).
% edge(19, 3, 220).
% edge(19, 22, 410).
% edge(19, 24, 430).
% edge(19, 9, 280).
% edge(19, 5, 240).
% edge(19, 16, 350).
% edge(19, 14, 330).
% edge(19, 15, 340).
% edge(19, 9, 280).
% edge(19, 13, 320).
% edge(19, 8, 270).
% edge(18, 16, 340).
% edge(18, 14, 320).
% edge(18, 15, 330).
% edge(18, 9, 270).
% edge(18, 9, 270).
% edge(18, 27, 450).
% edge(18, 19, 370).
% edge(18, 3, 210).
% edge(18, 4, 220).
% edge(18, 12, 300).
% edge(18, 29, 470).
% edge(18, 23, 410).
% edge(18, 7, 250).
% edge(18, 26, 440).
% edge(18, 5, 230).
% edge(18, 8, 260).
% edge(18, 19, 370).
% edge(18, 16, 340).
% edge(18, 6, 240).
% edge(18, 22, 400).
% edge(18, 13, 310).
% edge(18, 6, 240).
% edge(18, 17, 350).
% edge(17, 26, 430).
% edge(17, 9, 260).
% edge(17, 22, 390).
% edge(17, 26, 430).
% edge(17, 28, 450).
% edge(17, 3, 200).
% edge(17, 29, 460).
% edge(17, 15, 320).
% edge(17, 14, 310).
% edge(17, 6, 230).
% edge(17, 13, 300).
% edge(17, 27, 440).
% edge(17, 2, 190).
% edge(17, 6, 230).
% edge(17, 12, 290).
% edge(17, 9, 260).
% edge(17, 16, 330).
% edge(17, 19, 360).
% edge(17, 24, 410).
% edge(17, 16, 330).
% edge(17, 4, 210).
% edge(17, 8, 250).
% edge(17, 23, 400).
% edge(17, 5, 220).
% edge(17, 19, 360).
% edge(17, 18, 350).
% edge(17, 7, 240).
% edge(17, 29, 460).
% edge(16, 14, 300).
% edge(16, 6, 220).
% edge(16, 9, 250).
% edge(16, 2, 180).
% edge(16, 18, 340).
% edge(16, 28, 440).
% edge(16, 6, 220).
% edge(16, 19, 350).
% edge(16, 26, 420).
% edge(16, 5, 210).
% edge(16, 27, 430).
% edge(16, 25, 410).
% edge(16, 16, 320).
% edge(16, 13, 290).
% edge(16, 26, 420).
% edge(16, 9, 250).
% edge(16, 7, 230).
% edge(16, 15, 310).
% edge(16, 8, 240).
% edge(16, 22, 380).
% edge(16, 24, 400).
% edge(16, 17, 330).
% edge(16, 19, 350).
% edge(16, 4, 200).
% edge(15, 24, 390).
% edge(15, 8, 230).
% edge(15, 14, 290).
% edge(15, 19, 340).
% edge(15, 29, 440).
% edge(15, 6, 210).
% edge(15, 19, 340).
% edge(15, 16, 310).
% edge(15, 5, 200).
% edge(15, 7, 220).
% edge(15, 28, 430).
% edge(15, 29, 440).
% edge(15, 12, 270).
% edge(15, 25, 400).
% edge(15, 3, 180).
% edge(15, 17, 320).
% edge(15, 2, 170).
% edge(15, 16, 310).
% edge(15, 9, 240).
% edge(15, 9, 240).
% edge(15, 27, 420).
% edge(15, 22, 370).
% edge(15, 4, 190).
% edge(15, 23, 380).
% edge(15, 13, 280).
% edge(14, 13, 270).
% edge(14, 15, 290).
% edge(14, 19, 330).
% edge(14, 6, 200).
% edge(14, 6, 200).
% edge(14, 28, 420).
% edge(14, 26, 400).
% edge(14, 22, 360).
% edge(14, 4, 180).
% edge(14, 16, 300).
% edge(14, 17, 310).
% edge(14, 3, 170).
% edge(14, 19, 330).
% edge(14, 12, 260).
% edge(14, 24, 380).
% edge(14, 5, 190).
% edge(14, 29, 430).
% edge(14, 18, 320).
% edge(14, 16, 300).
% edge(14, 29, 430).
% edge(14, 2, 160).
% edge(14, 9, 230).
% edge(14, 26, 400).
% edge(14, 9, 230).
% edge(14, 23, 370).
% edge(13, 6, 190).
% edge(13, 24, 370).
% edge(13, 18, 310).
% edge(13, 19, 320).
% edge(13, 12, 250).
% edge(13, 16, 290).
% edge(13, 9, 220).
% edge(13, 5, 180).
% edge(13, 23, 360).
% edge(13, 9, 220).
% edge(13, 6, 190).
% edge(13, 26, 390).
% edge(13, 25, 380).
% edge(13, 29, 420).
% edge(13, 7, 200).
% edge(13, 17, 300).
% edge(13, 8, 210).
% edge(13, 2, 150).
% edge(13, 28, 410).
% edge(13, 15, 280).
% edge(13, 4, 170).
% edge(13, 22, 350).
% edge(13, 14, 270).
% edge(13, 29, 420).
% edge(12, 24, 360).
% edge(12, 16, 280).
% edge(12, 19, 310).
% edge(12, 23, 350).
% edge(12, 9, 210).
% edge(12, 6, 180).
% edge(12, 8, 200).
% edge(12, 26, 380).
% edge(12, 26, 380).
% edge(12, 29, 410).
% edge(12, 6, 180).
% edge(12, 4, 160).
% edge(12, 19, 310).
% edge(12, 18, 300).
% edge(12, 15, 270).
% edge(12, 5, 170).
% edge(12, 27, 390).
% edge(12, 28, 400).
% edge(12, 29, 410).
% edge(12, 2, 140).
% edge(12, 14, 260).
% edge(12, 17, 290).
% edge(12, 22, 340).
% edge(12, 3, 150).
% edge(11, 13, 240).
% edge(11, 9, 200).
% edge(11, 26, 370).
% edge(11, 5, 160).
% edge(11, 28, 390).
% edge(11, 25, 360).
% edge(11, 12, 230).
% edge(11, 27, 380).
% edge(11, 19, 300).
% edge(11, 3, 140).
% edge(11, 29, 400).
% edge(11, 24, 350).
% edge(11, 7, 180).
% edge(11, 2, 130).
% edge(11, 17, 280).
% edge(11, 4, 150).
% edge(11, 15, 260).
% edge(11, 18, 290).
% edge(11, 6, 170).
% edge(11, 26, 370).
% edge(11, 22, 330).
% edge(11, 14, 250).
% edge(11, 6, 170).
% edge(11, 8, 190).
% edge(11, 19, 300).
% edge(11, 16, 270).
% edge(11, 23, 340).
edge(10, 14, 240).
edge(10, 9, 190).
edge(10, 15, 250).
edge(10, 29, 390).
edge(10, 27, 370).
edge(10, 18, 280).
edge(10, 3, 130).
edge(10, 26, 360).
edge(10, 19, 290).
edge(10, 23, 330).
edge(10, 9, 190).
edge(10, 12, 220).
edge(10, 2, 120).
edge(10, 7, 170).
edge(10, 17, 270).
edge(10, 8, 180).
edge(10, 28, 380).
edge(10, 29, 390).
edge(10, 6, 160).
edge(10, 26, 360).
edge(10, 4, 140).
edge(10, 13, 230).
edge(10, 24, 340).
edge(10, 16, 260).
edge(10, 6, 160).
edge(9, 22, 310).
edge(9, 19, 280).
edge(9, 18, 270).
edge(9, 29, 380).
edge(9, 29, 380).
edge(9, 4, 130).
edge(9, 17, 260).
edge(9, 5, 140).
edge(9, 15, 240).
edge(9, 8, 170).
edge(9, 19, 280).
edge(9, 26, 350).
edge(9, 14, 230).
edge(9, 12, 210).
edge(9, 3, 120).
edge(9, 6, 150).
edge(9, 6, 150).
edge(9, 25, 340).
edge(9, 16, 250).
edge(9, 7, 160).
edge(9, 16, 250).
edge(9, 27, 360).
edge(9, 23, 320).
edge(9, 26, 350).
edge(8, 5, 130).
edge(8, 9, 170).
edge(8, 29, 370).
edge(8, 15, 230).
edge(8, 19, 270).
edge(8, 22, 300).
edge(8, 19, 270).
edge(8, 18, 260).
edge(8, 6, 140).
edge(8, 7, 150).
edge(8, 17, 250).
edge(8, 2, 100).
edge(8, 3, 110).
edge(8, 13, 210).
edge(8, 16, 240).
edge(8, 28, 360).
edge(8, 6, 140).
edge(8, 12, 200).
edge(8, 23, 310).
edge(8, 4, 120).
edge(8, 26, 340).
edge(8, 9, 170).
edge(7, 9, 160).
edge(7, 15, 220).
edge(7, 26, 330).
edge(7, 22, 290).
edge(7, 29, 360).
edge(7, 26, 330).
edge(7, 29, 360).
edge(7, 5, 120).
edge(7, 3, 100).
edge(7, 18, 250).
edge(7, 27, 340).
edge(7, 2, 90).
edge(7, 16, 230).
edge(7, 6, 130).
edge(7, 9, 160).
edge(7, 23, 300).
edge(7, 6, 130).
edge(7, 8, 150).
edge(7, 4, 110).
edge(7, 13, 200).
edge(6, 18, 240).
edge(6, 16, 220).
edge(6, 8, 140).
edge(6, 4, 100).
edge(6, 27, 330).
edge(6, 25, 310).
edge(6, 3, 90).
edge(6, 29, 350).
edge(6, 26, 320).
edge(6, 6, 120).
edge(6, 22, 280).
edge(6, 12, 180).
edge(6, 7, 130).
edge(6, 13, 190).
edge(6, 5, 110).
edge(6, 16, 220).
edge(6, 15, 210).
edge(6, 9, 150).
edge(6, 19, 250).
edge(6, 23, 290).
edge(6, 19, 250).
edge(6, 28, 340).
edge(6, 14, 200).
edge(6, 2, 80).
edge(6, 17, 230).
edge(5, 24, 290).
edge(5, 14, 190).
edge(5, 26, 310).
edge(5, 7, 120).
edge(5, 6, 110).
edge(5, 27, 320).
edge(5, 19, 240).
edge(5, 28, 330).
edge(5, 15, 200).
edge(5, 4, 90).
edge(5, 16, 210).
edge(5, 13, 180).
edge(5, 22, 270).
edge(5, 23, 280).
edge(5, 16, 210).
edge(5, 26, 310).
edge(5, 8, 130).
edge(5, 6, 110).
edge(5, 9, 140).
edge(5, 9, 140).
edge(5, 29, 340).
edge(5, 18, 230).
edge(5, 19, 240).
edge(5, 3, 80).
edge(5, 29, 340).
edge(5, 17, 220).
edge(5, 12, 170).
edge(4, 6, 100).
edge(4, 7, 110).
edge(4, 17, 210).
edge(4, 12, 160).
edge(4, 18, 220).
edge(4, 19, 230).
edge(4, 27, 310).
edge(4, 16, 200).
edge(4, 26, 300).
edge(4, 29, 330).
edge(4, 19, 230).
edge(4, 3, 70).
edge(4, 6, 100).
edge(4, 25, 290).
edge(4, 26, 300).
edge(4, 5, 90).
edge(4, 24, 280).
edge(4, 13, 170).
edge(4, 9, 130).
edge(4, 16, 200).
edge(4, 23, 270).
edge(4, 9, 130).
edge(4, 22, 260).
edge(4, 14, 180).
edge(4, 8, 120).
edge(3, 16, 190).
edge(3, 9, 120).
edge(3, 8, 110).
edge(3, 6, 90).
edge(3, 7, 100).
edge(3, 14, 170).
edge(3, 28, 310).
edge(3, 29, 320).
edge(3, 5, 80).
edge(3, 17, 200).
edge(3, 25, 280).
edge(3, 26, 290).
edge(3, 22, 250).
edge(3, 29, 320).
edge(3, 26, 290).
edge(3, 12, 150).
edge(3, 19, 220).
edge(3, 9, 120).
edge(3, 4, 70).
edge(3, 27, 300).
edge(3, 16, 190).
edge(3, 6, 90).
edge(3, 13, 160).
edge(3, 19, 220).
edge(3, 23, 260).
edge(3, 24, 270).
edge(3, 18, 210).
edge(3, 2, 50).
edge(3, 1, 10). %% circle
edge(2, 16, 180).
edge(2, 6, 80).
edge(2, 15, 170).
edge(2, 24, 260).
edge(2, 5, 70).
edge(2, 13, 150).
edge(2, 19, 210).
edge(2, 4, 60).
edge(2, 8, 100).
edge(2, 6, 80).
edge(2, 14, 160).
edge(2, 19, 210).
edge(2, 28, 300).
edge(2, 16, 180).
edge(2, 22, 240).
edge(2, 23, 250).
edge(2, 27, 290).
edge(2, 9, 110).
edge(2, 29, 310).
edge(2, 12, 140).
edge(2, 3, 50).
edge(2, 25, 270).
edge(2, 18, 200).
edge(2, 7, 90).
edge(2, 26, 280).
edge(1, 2, 30).
edge(1, 25, 260).
edge(1, 22, 230).
edge(1, 14, 150).
edge(1, 13, 140).
edge(1, 28, 290).
edge(1, 24, 250).
edge(1, 19, 200).
edge(1, 3, 40).
edge(1, 8, 90).
edge(1, 18, 190).
edge(1, 4, 50).
edge(1, 7, 80).
edge(1, 16, 170).
edge(1, 26, 270).
edge(1, 15, 160).
edge(1, 9, 100).
edge(1, 19, 200).
edge(1, 6, 70).
edge(1, 29, 300).
edge(1, 5, 60).
edge(1, 27, 280).
edge(1, 29, 300).
 