%% USER MANUAL
%% - path_dc(N) executes an standard query (N is the maximun path length)
%% - times(N,path_dc(N)) repeats the execution of path_dc(N)  
%%   to get its execution time on average.
%%   N is the minimum time we want to execute times/2.

:- module(scheduling_clp,
	    [
		% times/2,
		% p/1,
		edge_small/3,
		path/2,
		reach/3,
		time/3
	    ], []).

:- use_package(library(tabling)).
:- const_table_module(library(clpq/clpq_tab)).
%:- table path/2.
% :- table time/3.
:- table reach/3.


%:- include(times).
:- use_package(library(clpq)).



%% TCHR %%

reach(A, A, _X).
reach(A, C, X) :-
	edge(A, B, X, NX),
	reach(B, C, NX).

%% X .>=. 0, X .=<. 10, reach(1,16,X) %%

edge(a,b,Xa,Xb) :- Xa .<. 10, Xb .=. Xa.
edge(b,a,Xb,Xa) :- Xb .>. 0, Xa .=. Xb + 1.
edge(b,c,Xb,Xc) :- Xb .>. 3, Xc .=. Xb.



%% statistics(runtime, [_,_]), findall(O, ( P .>. 0, P .<. 5, time(1,O,P) ), List), statistics(runtime, [_,T]).


% p(N) :- 
% 	X .<. N,
% 	time(start,_,X).


time(A,B,X) :-
	edge_small(A,B,X).
time(A,C,X) :-
	X .=. X1 + X2,
	time(A,B,X1),
	time(B,C,X2).
% time(A,C,X) :-
% 	X .=. X1 + X2,
% 	edge_small(A,B,X1),
% 	time(B,C,X2).


% % time(A, C, X) :-
% % 	X .=. X1 + X2,
% % 	edge(A, B, X1),
% %	time(B, C, X2).
% time(A, C, X) :-
% 	X .=. X1 + X2,
% 	time(A, B, X1),
% 	time(B, C, X2).
% time(A, B, X) :-
% 	edge(A, B, X).

% path(A, B) :-
% 	edge(A, B, _).
% path(A, C) :-
% 	edge(A, B, _),
% 	path(B, C).

edge_small(start, 1, X) :-
	X .>=. 0,
	X .=<. 10.
edge_small(1, 2, X) :-
	X .>=. 3,
	X .=<. 4.
edge_small(1, 3, X) :-
	X .>=. 4,
	X .=<. 6.
edge_small(1, 4, X) :-
	X .=. 2.
edge_small(2, 4, X) :-
	X .=. 1.
edge_small(2, 5, X) :-
	X .>. 0,
	X .<. 9.
edge_small(5, fin, X) :-
	edge_small(start, 1, X1),
	X .=. 2 * X1.
edge_small(4, 5, X) :-
	X .>. 8,
	X .<. 9.


edge(_,_,_).

% edge(30, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(30, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(30, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(30, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(30, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(30, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(30, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(30, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(30, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(30, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(30, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(30, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(30, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(30, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(30, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(30, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(30, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(30, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(30, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(30, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(30, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(30, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(30, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(30, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(30, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(30, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(29, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(29, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(29, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(29, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(29, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(29, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(29, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(29, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(29, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(29, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(29, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(29, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(29, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(29, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(29, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(29, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(29, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(29, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(29, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(29, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(29, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(29, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(29, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(29, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(28, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(28, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(28, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(28, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(28, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(28, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(28, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(28, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(28, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(28, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(28, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(28, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(28, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(28, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(28, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(28, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(28, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(28, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(28, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(28, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(28, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(28, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(28, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(28, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(28, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(27, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(27, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(27, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(27, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(27, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(27, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(27, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(27, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(27, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(27, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(27, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(27, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(27, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(27, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(27, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(27, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(27, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(27, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(27, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(27, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(27, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(27, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(27, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(27, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(27, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(27, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(27, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(26, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(26, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(26, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(26, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(26, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(26, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(26, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(26, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(26, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(26, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(26, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(26, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(26, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(26, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(26, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(26, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(26, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(26, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(26, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(26, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(26, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(26, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(26, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(26, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(26, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(25, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(25, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(25, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(25, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(25, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(25, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(25, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(25, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(25, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(25, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(25, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(25, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(25, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(25, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(25, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(25, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(25, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(25, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(25, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(25, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(25, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(25, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(25, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(25, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(25, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(25, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(25, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(24, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(24, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(24, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(24, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(24, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(24, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(24, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(24, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(24, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(24, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(24, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(24, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(24, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(24, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(24, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(24, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(24, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(24, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(24, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(24, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(24, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(23, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(23, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(23, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(23, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(23, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(23, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(23, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(23, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(23, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(23, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(23, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(23, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(23, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(23, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(23, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(23, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(23, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(23, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(23, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(23, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(23, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(23, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(23, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(23, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(22, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(22, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(22, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(22, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(22, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(22, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(22, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(22, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(22, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(22, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(22, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(22, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(22, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(22, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(22, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(22, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(22, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(22, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(22, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(22, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(22, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(22, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(22, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(21, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(21, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(21, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(21, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(21, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(21, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(21, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(21, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(21, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(21, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(21, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(21, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(21, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(21, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(21, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(21, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(21, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(21, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(21, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(21, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(21, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(21, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(21, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(21, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(21, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(21, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(20, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(20, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(20, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(20, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(20, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(20, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(20, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(20, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(20, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(20, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(20, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(20, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(20, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(20, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(20, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(20, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(20, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(20, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(20, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(20, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(20, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(20, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(20, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(20, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(20, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(19, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(19, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(19, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(19, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(19, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(19, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(19, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(19, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(19, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(19, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(19, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(19, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(19, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(19, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(19, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(19, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(19, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(19, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(19, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(19, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(19, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(19, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(19, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(19, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(19, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(18, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(18, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(18, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(18, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(18, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(18, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(18, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(18, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(18, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(18, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(18, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(18, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(18, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(18, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(18, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(18, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(18, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(18, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(18, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(18, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(18, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(18, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(18, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(17, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(17, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(17, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(17, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(17, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(17, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(17, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(17, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(17, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(17, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(17, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(17, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(17, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(17, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(17, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(17, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(17, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(17, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(17, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(17, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(17, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(17, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(17, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(17, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(17, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(17, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(17, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(17, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(16, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(16, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(16, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(16, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(16, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(16, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(16, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(16, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(16, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(16, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(16, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(16, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(16, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(16, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(16, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(16, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(16, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(16, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(16, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(16, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(16, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(16, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(16, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(16, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(15, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(15, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(15, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(15, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(15, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(15, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(15, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(15, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(15, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(15, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(15, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(15, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(15, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(15, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(15, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(15, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(15, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(15, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(15, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(15, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(15, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(15, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(15, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(15, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(15, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(14, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(14, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(14, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(14, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(14, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(14, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(14, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(14, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(14, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(14, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(14, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(14, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(14, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(14, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(14, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(14, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(14, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(14, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(14, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(14, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(14, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(14, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(14, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(14, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(14, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(13, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(13, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(13, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(13, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(13, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(13, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(13, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(13, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(13, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(13, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(13, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(13, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(13, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(13, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(13, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(13, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(13, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(13, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(13, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(13, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(13, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(13, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(13, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(13, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(12, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(12, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(12, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(12, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(12, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(12, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(12, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(12, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(12, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(12, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(12, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(12, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(12, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(12, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(12, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(12, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(12, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(12, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(12, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(12, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(12, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(12, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(12, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(12, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(11, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(11, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(11, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(11, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(11, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(11, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(11, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(11, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(11, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(11, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(11, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(11, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(11, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(11, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(11, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(11, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(11, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(11, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(11, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(11, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(11, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(11, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(11, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(11, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(11, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(11, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(11, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(10, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(10, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(10, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(10, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(10, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(10, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(10, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(10, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(10, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(10, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(10, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(10, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(10, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(10, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(10, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(10, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(10, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(10, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(10, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(10, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(10, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(10, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(10, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(10, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(10, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(9, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(9, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(9, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(9, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(9, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(9, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(9, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(9, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(9, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(9, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(9, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(9, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(9, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(9, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(9, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(9, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(9, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(9, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(9, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(9, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(9, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(9, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(9, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(9, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(8, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(8, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(8, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(8, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(8, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(8, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(8, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(8, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(8, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(8, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(8, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(8, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(8, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(8, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(8, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(8, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(8, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(8, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(8, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(8, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(8, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(8, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(7, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(7, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(7, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(7, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(7, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(7, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(7, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(7, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(7, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(7, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(7, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(7, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(7, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(7, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(7, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(7, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(7, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(7, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(7, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(7, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(6, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(6, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(6, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(6, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(6, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(6, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(6, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(6, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(6, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(6, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(6, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(6, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(6, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(6, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(6, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(6, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(6, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(6, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(6, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(6, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(6, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(6, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(6, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(6, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(6, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(5, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(5, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(5, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(5, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(5, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(5, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(5, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(5, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(5, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(5, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(5, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(5, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(5, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(5, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(5, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(5, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(5, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(5, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(5, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(5, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(5, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(5, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(5, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(5, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(5, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(5, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(5, 12, X) :-
% 	X .>=. 0,
%	X .=<. 4.
% edge(4, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(4, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(4, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(4, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(4, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(4, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(4, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(4, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(4, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(4, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(4, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(4, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(4, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(4, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(4, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(4, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(4, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(4, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(4, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(4, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(4, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(4, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(4, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(4, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(4, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(3, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(3, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(3, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(3, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(3, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(3, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(3, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(3, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(3, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(3, 17, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(3, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(3, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(3, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(3, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(3, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(3, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(3, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(3, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(3, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(3, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(3, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(3, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(3, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(3, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(3, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(3, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(3, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(3, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(2, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(2, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(2, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(2, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(2, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(2, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(2, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(2, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(2, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(2, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(2, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(2, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(2, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(2, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(2, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(2, 23, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(2, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(2, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(2, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(2, 12, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(2, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(2, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(2, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(2, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(2, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(1, 2, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(1, 25, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(1, 22, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(1, 14, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(1, 13, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(1, 28, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(1, 24, X) :-
% 	X .>=. 0,
% 	X .=<. 4.
% edge(1, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(1, 3, X) :-
% 	X .>=. 10,
% 	X .=<. 14.
% edge(1, 8, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(1, 18, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(1, 4, X) :-
% 	X .>=. 0,
% 	X .=<. 6.
% edge(1, 7, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(1, 16, X) :-
% 	X .>=. 3,
% 	X .=<. 4.
% edge(1, 26, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(1, 15, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(1, 9, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(1, 19, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(1, 6, X) :-
% 	X .>=. 3,
% 	X .=<. 7.
% edge(1, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 1.
% edge(1, 5, X) :-
% 	X .>=. 0,
% 	X .=<. 3.
% edge(1, 27, X) :-
% 	X .>=. 7,
% 	X .=<. 11.
% edge(1, 29, X) :-
% 	X .>=. 0,
% 	X .=<. 3.


 % edge(10,14,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(10,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(10,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(10,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(10,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(10,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(10,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(10,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(10,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,2,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(10,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(10,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,28,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(10,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(10,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(10,24,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(9,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(9,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(9,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(9,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(9,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(9,5,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,14,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(9,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(9,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(9,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(9,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,25,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(9,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(9,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(9,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(9,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(8,5,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(8,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(8,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(8,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(8,2,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(8,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(8,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(8,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,28,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(8,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(8,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(8,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(8,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(7,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(7,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(7,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(7,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(7,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(7,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(7,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(7,5,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(7,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(7,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(7,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(7,2,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(7,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(7,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(7,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(7,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(7,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(7,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(7,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(7,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(6,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(6,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(6,25,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(6,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(6,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(6,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(6,5,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(6,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(6,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,28,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,14,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,2,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(5,24,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(5,14,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(5,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(5,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(5,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(5,28,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(5,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(5,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(5,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(5,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(5,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(5,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(5,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(5,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(5,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(5,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(5,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(5,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(5,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(5,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(5,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 edge(4,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,17,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(4,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,9,Xa,Xb) :- 	 
  	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(4,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,17,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(3,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(3,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,2,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(2,15,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(2,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(2,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(2,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(2,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(1,2,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(1,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(1,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(1,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(1,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,15,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(1,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 