%% USER MANUAL
%% - path_dc(N) executes an standard query (N is the maximun path length)
%% - times(N,path_dc(N)) repeats the execution of path_dc(N)  
%%   to get its execution time on average.
%%   N is the minimum time we want to execute times/2.

:- module(tchr_example_clp,
	    [
		reach/3,
		p/1
	    ], []).

:- use_package(library(tabling)).
:- const_table_module(library(clpq/clpq_tab)).
:- table reach/3.
:- table p/1.

:- use_package(library(clpq)).



%% TCHR %%
p(X) :-
	X .=. 1 - Y,
	q(Y).
p(X) :-
	X .=. 0.

q(X) :- true, 
	p(X).

reach(A, A, _X).
reach(A, C, X) :-
	edge(A, B, X, NX),
	reach(B, C, NX).

edge(a,b,Xa,Xb) :- Xa .<. 10, Xb .=. Xa.
edge(b,a,Xb,Xa) :- Xb .>. 0, Xa .=. Xb + 1.
edge(b,c,Xb,Xc) :- Xb .>. 3, Xc .=. Xb.




% % ?-  statistics(runtime, [_,_]), findall(O, ( P .>. 0, P .<. 4, reach(1,O,P) ), _List), statistics(runtime, [_,T]), length(_List, L).
% % L = 701350, sortL = 25,
% % T = 33451.71 ? ;
% % ?-  statistics(runtime, [_,_]), findall(O, ( P .>. 0, P .<. 4, reach(1,O,P) ), _List), statistics(runtime, [_,T]), length(_List, L).
% % L = 25,
% % T = 1549.404 ? 

% % ?-  statistics(runtime, [_,_]), findall(O, ( P .>. 0, P .<. 8, reach(1,O,P) ), _List), statistics(runtime, [_,T]), length(_List, L).
% % L = 39,
% % T = 746.728 ? ;


 % edge(10,14,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(10,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(10,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(10,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(10,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(10,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(10,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(10,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(10,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,2,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(10,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(10,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,28,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(10,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(10,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(10,24,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(10,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(10,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(9,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(9,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(9,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(9,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(9,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(9,5,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,14,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(9,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(9,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(9,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(9,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,25,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(9,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(9,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(9,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(9,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(9,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(9,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(8,5,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(8,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(8,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(8,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(8,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(8,2,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(8,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(8,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(8,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,28,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(8,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(8,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(8,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(8,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(8,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(7,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(7,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(7,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(7,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(7,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(7,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(7,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(7,5,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(7,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(7,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(7,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(7,2,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(7,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(7,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(7,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(7,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(7,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(7,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(7,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(7,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(6,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(6,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(6,25,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(6,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(6,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(6,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(6,5,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(6,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(6,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(6,28,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(6,14,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,2,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(6,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.


 % % % edge(6,8,Xa,Xb) :- 	 
 % % % 	Xa .>. 3, 
 % % % 	Xb = Xa.
 % % % edge(6,6,Xa,Xb) :- 	 
 % % % 	Xa .>. 3, 
 % % % 	Xb .=. Xa - 1.
 % % % edge(6,8,Xa,Xb) :- 	 
 % % % 	Xa .>. 3, 
 % % % 	Xb = Xa.
 % % % edge(6,4,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. 1 + Xa.
 % % % edge(6,7,Xa,Xb) :- 	 
 % % % 	Xa .<. 7, 
 % % % 	Xb = Xa.
 % % % edge(6,5,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. Xa + 3.
 % % % edge(6,3,Xa,Xb) :- 	 
 % % % 	Xa .<. 10, 
 % % % 	Xb = Xa.
 % % % edge(6,9,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. Xa + 3.
 % % % edge(6,6,Xa,Xb) :- 	 
 % % % 	Xa .>. 3, 
 % % % 	Xb = Xa.
 % % % edge(6,6,Xa,Xb) :- 	 
 % % % 	Xa .>. 3, 
 % % % 	Xb .=. Xa - 1.
 % % % edge(6,2,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. 1 + Xa.
 % % % edge(6,2,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. 1 + Xa.
 % % % edge(6,7,Xa,Xb) :- 	 
 % % % 	Xa .<. 7, 
 % % % 	Xb = Xa.
 % % % edge(6,3,Xa,Xb) :- 	 
 % % % 	Xa .<. 10, 
 % % % 	Xb = Xa.
 % % % edge(6,5,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. Xa + 3.
 % % % edge(6,6,Xa,Xb) :- 	 
 % % % 	Xa .>. 3, 
 % % % 	Xb = Xa.
 % % % edge(6,5,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. Xa + 3.
 % % % edge(6,9,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. Xa + 3.
 % % % edge(6,9,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. Xa - 1.
 % % % edge(6,3,Xa,Xb) :- 	 
 % % % 	Xa .<. 10, 
 % % % 	Xb = Xa.
 % % % edge(6,9,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. Xa + 3.
 % % % edge(6,8,Xa,Xb) :- 	 
 % % % 	Xa .>. 3, 
 % % % 	Xb = Xa.
 % % % edge(6,4,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. 1 + Xa.
 % % % edge(6,2,Xa,Xb) :- 	 
 % % % 	Xa .>. 0, 
 % % % 	Xb .=. 1 + Xa.
 % % % edge(6,7,Xa,Xb) :- 	 
 % % % 	Xa .<. 7, 
 % % % 	Xb = Xa.

 % edge(5,24,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(5,14,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(5,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,7,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(5,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,27,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(5,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(5,28,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,15,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(5,4,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(5,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(5,13,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(5,22,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 % edge(5,23,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(5,16,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,26,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(5,8,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,6,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb .=. Xa - 1.
 % edge(5,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(5,9,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(5,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(5,18,Xa,Xb) :- 	 
 % 	Xa .>. 3, 
 % 	Xb = Xa.
 % edge(5,19,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa - 1.
 % edge(5,3,Xa,Xb) :- 	 
 % 	Xa .<. 10, 
 % 	Xb = Xa.
 % edge(5,29,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. Xa + 3.
 % edge(5,17,Xa,Xb) :- 	 
 % 	Xa .<. 7, 
 % 	Xb = Xa.
 % edge(5,12,Xa,Xb) :- 	 
 % 	Xa .>. 0, 
 % 	Xb .=. 1 + Xa.
 edge(4,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,17,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(4,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,9,Xa,Xb) :- 	 
  	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(4,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,17,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(3,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(3,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,2,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(2,15,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(2,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(2,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(2,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(2,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(1,2,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(1,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(1,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(1,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(1,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,15,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(1,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
  edge(1,100,Xa,Xb) :- 	 
  	Xa .>. 6, 
  	Xb .=. Xa + 3.
 