:- use_package(clpq).

:- use_module(library(prolog_sys)).
:- use_module(library(write)).
:- use_module(library(format)).

:-include(mainfile).

cputime(T) :-
  statistics(runtime,[T,_]).

writeln(T) :-
  write(T),
  nl.

fibonacci(0, 0).
fibonacci(1, 1).
fibonacci(N, F) :-
	N .>=. 2,
	N1 .=. N - 1,
	N2 .=. N - 2,
	F1 .>=. 0,
	F2 .>=. 0,
	F .=. F1 + F2,
	fibonacci(N1, F1),
	fibonacci(N2, F2).


go :- 
  cputime(Start),
  fibonacci(N, 610),
  cputime(End),
  T is End - Start,
  write('% fibonacci610_clpq.pl: execution time = '), format('~2f',T), write(' milliseconds  '), display([N,610]),nl.
