:- use_package(library(difference_constraints)).

:- use_module(library(prolog_sys)).
:- use_module(library(write)).
:- use_module(library(format)).

:-include(mainfile).

cputime(T) :-
  statistics(runtime,[T,_]).

writeln(T) :-
  write(T),
  nl.

fibonacci(N, F) :- 
	N #= 0, 
	F #= 0.
fibonacci(N, F) :- 
	N #= 1,
	F #= 1.
fibonacci(N, F):-
	N #>= 2,
 	N1 #= N - 1,
  	N2 #= N - 2,
 	F1 #=< F,
 	F2 #=< F1,
        fibonacci(N1, F1),
        fibonacci(N2, F2),
	F #= F1 + F2. %this is possible since F1, F2 are always integers here.


go :- 
  cputime(Start),
  fibonacci(_N, 610),
  cputime(End),
  T is End - Start,
  write('% fibonacci610_dc.pl: execution time = '), format('~2f',T), write(' milliseconds  '),nl.
