:- use_package(tabling).

:- use_module(library(prolog_sys)).
:- use_module(library(write)).
:- use_module(library(format)).

%% :-include(mainfile).


%% USE IT TO TRACE generators AND answers %%
start_trace:-
	set_tabling_flag(trace,on).
stop_trace:-
	set_tabling_flag(trace,off).
%% ++++++++++++++++++++++++++++++++++++++ %%


cputime(T) :-
  statistics(runtime,[T,_]).

writeln(T) :-
  write(T),
  nl.

% :- table fibonacci_rel/2.

fibonacci_rel(N,F) :-
	gen(N),
	fibonacci(N,F).

:- table fibonacci/2.

fibonacci(0, 0).
fibonacci(1, 1).
fibonacci(N, F) :-
	N > 1,
	N1 is N - 1,
	N2 is N - 2,
	fibonacci(N1, F1),
	fibonacci(N2, F2),
	F is F1 + F2.

gen(0).
gen(N) :- gen(N1), N is N1 + 1.

go :- 
  cputime(Start),
  fibonacci_rel(N, 4181),
  cputime(End),
  T is End - Start,
  write('% fibonacci4181_tabling.pl: execution time = '), format('~2f',T), write(' milliseconds  '), display([N,4181]),nl.




:- table p/3.
p(a,1,k).
p(s,2,l).
p(a,1,d).
p(s,3,l).