:- module(_, _).

:- use_module(library(format)).

:- include(mainfile_4).


cputime(T) :-
	statistics(runtime, [T, _]).

writeln(T) :-
	write(T),
	nl.

:- use_package(library(tabling)).
:- use_package(library(t_clpq)).
:- table dist_1/3, dist_2/3, dist_3/3, dist_4/3.


go1 :-
	cputime(Start),
	findall([X,Y,D], ( D .>. 0, D .<. 350, dist_1(X,Y,D) ), _List),
	cputime(End),
	T is End - Start,
	write('% dist_wo_cycles_tclp.pl: execution time dist_1 = '), write(T),
	write(' milliseconds'), nl.
go2 :-
	cputime(Start),
	findall([X,Y,D], ( D .>. 0, D .<. 350, dist_2(X,Y,D) ), _List),
	cputime(End),
	T is End - Start,
	write('% dist_wo_cycles_tclp.pl: execution time dist_2 = '), write(T),
	write(' milliseconds'), nl.
go3 :-
	cputime(Start),
	findall([X,Y,D], ( D .>. 0, D .<. 350, dist_3(X,Y,D) ), _List),
	cputime(End),
	T is End - Start,
	write('% dist_wo_cycles_tclp.pl: execution time dist_3 = '), write(T),
	write(' milliseconds'), nl.
go4 :-
	cputime(Start),
	findall([X,Y,D], ( D .>. 0, D .<. 350, dist_4(X,Y,D) ), _List),
	cputime(End),
	T is End - Start,
	write('% dist_wo_cycles_tclp.pl: execution time dist_4 = '), write(T),
	write(' milliseconds'), nl.


dist_1(A,B,D) :-
	edge(A,B,D).
dist_1(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	edge(A,Z,D1),
	dist_1(Z,B,D2).

dist_2(A,B,D) :-
	edge(A,B,D).
dist_2(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	dist_2(A,Z,D2),
	edge(Z,B,D1).

dist_3(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	edge(A,Z,D1),
	dist_3(Z,B,D2).
dist_3(A,B,D) :-
	edge(A,B,D).

dist_4(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	dist_4(A,Z,D2),
	edge(Z,B,D1).
dist_4(A,B,D) :-
	edge(A,B,D).

:- include(edge_wo_cycles).
