:- use_package(tabling).
:- use_package(t_clpq).

:- use_module(library(prolog_sys)).
:- use_module(library(write)).
:- use_module(library(format)).
:- use_module(library(aggregates)).
:- use_module(library(sort)).
:- use_module(library(lists)).
:- use_module(library(idlists)).

:-include(mainfile).

cputime(T) :-
  statistics(runtime,[T,_]).

writeln(T) :-
  write(T),
  nl.

:- table reach/3.


reach(A, A, _X).
reach(A, C, X) :-
	edge(A, B, X, NX),
	reach(B, C, NX).

go :- 
  cputime(Start),
  findall(O, ( P .>. 0, P .<. 4, reach(1,O,P) ), List),
  cputime(End),
  T is End - Start,
  length(List, Length),
  write('% reach4.pl: execution time = '), format('~2f',T), write(' milliseconds - % answers = '),display(Length), nl.


print_sort(X) :-
  findall([K-O-P], ( P .>. 0, P .<. 4, reach(K,O,P) ), List),
  sort(List, SList),
  member(X,SList),
  \+ once(X,SList).

once(X,List) :-
	member(X,List),
	subtract(List,[X],Rest),
	\+ member(X, Rest).

edge(4,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,17,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(4,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(4,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(4,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,9,Xa,Xb) :- 	 
  	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(4,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(4,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(4,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(4,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(4,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,17,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(3,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(3,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(3,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(3,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(3,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(3,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(3,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(3,2,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(2,15,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(2,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(2,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,23,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(2,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,12,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(2,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(2,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(2,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(2,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(2,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(1,2,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,25,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,22,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,14,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,13,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(1,28,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,24,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,3,Xa,Xb) :- 	 
 	Xa .<. 10, 
 	Xb = Xa.
 edge(1,8,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,18,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,4,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. 1 + Xa.
 edge(1,7,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(1,16,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb .=. Xa - 1.
 edge(1,26,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,15,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,9,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,19,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,6,Xa,Xb) :- 	 
 	Xa .>. 3, 
 	Xb = Xa.
 edge(1,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa - 1.
 edge(1,5,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
 edge(1,27,Xa,Xb) :- 	 
 	Xa .<. 7, 
 	Xb = Xa.
 edge(1,29,Xa,Xb) :- 	 
 	Xa .>. 0, 
 	Xb .=. Xa + 3.
  edge(1,100,Xa,Xb) :- 	 
  	Xa .>. 6, 
  	Xb .=. Xa + 3.
 



