/*
 *  debug.c
 *
 *  Code for debuging tabling.
 *
 *  XS
 */

#include <stdio.h> 
#include <string.h> 

#include <ciao/ciao_prolog.h>
#include <ciao/termdefs.h>
#include <ciao/tabling.h> 

#include "debug.h"
#include "engine.h" 


//#if defined(DEBUG_ALL)
tagged_t tabling_debug;
tagged_t tabling_debug_tries;
tagged_t tabling_trace;
tagged_t tabling_print;
tagged_t tabling_bypass;
//#endif

#if defined(ANS_COUNTER)
int ans_no_saved, ans_removed, ans_saved, ans_aggregated;

CBOOL__PROTO(print_counters_c) 
{
  printf("answers saved      = %10d \n", ans_saved);
  printf("answers discarded  = %10d \n", ans_no_saved);
  printf("answers removed    = %10d \n", ans_removed);
  printf("answers aggregated = %10d \n", ans_aggregated);
  return TRUE;
}
#endif

CBOOL__PROTO(set_tabling_flag_c) {
#if defined(TABLING)
#if defined(DEBUG_ALL)
  if (tabling_debug == atom_on)
    printf("Set_tabling_flag\n"); //XS
#endif

  char * flag, * value;
  tagged_t newvalue;

  /* check value is on or off */

  DEREF(ARG2,ARG2);
  value = (char *)TagToAtom(ARG2)->name;
  
  if (strcmp(value, "off")==0) newvalue = atom_off;
  else if (strcmp(value, "on")==0) newvalue = atom_on;
  else  return FALSE;

  /* check flag is correct */

  DEREF(ARG1,ARG1);
  flag = (char *)TagToAtom(ARG1)->name;

  //#if defined(DEBUG_ALL)
  if (strcmp(flag, "debug")==0) tabling_debug = newvalue;
  else if (strcmp(flag, "debug_tries")==0) tabling_debug_tries = newvalue;
  else if (strcmp(flag, "trace")==0) tabling_trace = newvalue;
  else if (strcmp(flag, "print")==0) tabling_print = newvalue;
  else if (strcmp(flag, "bypass")==0) tabling_bypass = newvalue;
  else return FALSE; 
  //#endif

  return TRUE;

#else
  printf("\nTABLING Flag must be activated\n");
  return FALSE;
#endif
}

// TODO XS: current_tabling_flag can NOT be used to request flags as current_prolog_flag(X,Y).
CBOOL__PROTO(current_tabling_flag_c) {
#if defined(TABLING)
#if defined(DEBUG_ALL)
  if (tabling_debug == atom_on)
    printf("Set_tabling_flag\n"); //XS
#endif

  char * flag, * value;
  tagged_t newvalue;

  /* check flag is correct */

  DEREF(ARG1,ARG1);
  if (IsAtom(ARG1))
    flag = (char *)TagToAtom(ARG1)->name;
  else {
    printf("First argument it is not instanciated\n"); 
    return FALSE;
  }

  //#if defined(DEBUG_ALL)
  if (strcmp(flag, "debug")==0) return Unify(ARG2,tabling_debug);
  else if (strcmp(flag, "debug_tries")==0) return Unify(ARG2,tabling_debug_tries);
  else if (strcmp(flag, "trace")==0) return Unify(ARG2,tabling_trace);
  else if (strcmp(flag, "print")==0) return Unify(ARG2,tabling_print);
  else if (strcmp(flag, "bypass")==0) return Unify(ARG2,tabling_bypass);
  //#endif

  printf("The flag '%s' does not exists\n", flag);
  return FALSE;

#else
  printf("\nTABLING Flag must be activated\n");
  return FALSE;
#endif
}
