:- module(example,_).

% :- use_package(expander).

:- use_package(tabling).


programs([member_sum_count([1,2,2,5,5,5,5,5,5], _E1, _S1),
	member_count([1,2,2,5,5,5,5,5,5], _S2),
	member_sum([1,2,2,5,5,5,5,5,5], _S3),
	member_average([2,2,2,2,2,2,2,2,2,2], _C),
	member_average([8,8,2,2], _C),
	nl,
	dist('A', _X, _D, _P)]).
		    
go :-
	programs(Ps),
	member(P, Ps),
	call(P),
	P \= nl, display(P), nl,
	fail.


:- table s(_,min/2).
s(b,1).
s(a,2).	
s(a,3).
s(b,4).

:- table s1(min/2).
s1(1).
s1(2).	
s1(3).



%% Lattice %% - sum, count...

:- table member_sum(_,sum/3).
member_sum(List, S) :-
	member(S, List).

:- table member_count(_,count/3).
member_count(List, c(1)) :- %% The answer for lattice_aggregates should be
	                    %% the expected answer when there is only one solution
	member(_, List).

% :- table member_count_uniques(_,count_uniques/3).
% member_count_uniques(List, c(1,[L])) :- 
% 	member(L, List).
% :- use_module(library(sets)).
% count_uniques(c(C1, List1), c(C2, List2), c(C, List)) :-
% 	ord_intersect(List1,List2),
	


:- table member_sum_count(_, sum/3,count/3).
member_sum_count(List, S, c(1)) :-
	member(S, List).

:- table member_average_aux(_, average/3).
member_average(List, Average) :-
	member_average_aux(List, av(Average, _)).
member_average_aux(List, av(S, c(1))) :- 
	member(S, List).

average(av(Prev,c(P)), av(New,c(1)), av(Final, c(F))) :-  %% To compute the average 
	F is P + 1,
	Final is ((Prev * P) + New) // F.   %% TCLP can not work with float -> aprox.
sum(X,Y,Z) :-
	num(X),
	num(Y),
	Z is X + Y.
count(c(C),_,c(C1)) :- !,
	ground(C),
	C1 is C + 1.

%% Example I %%
:- table dist(_,_,min/2,nt).

dist(A,B,D,Path) :-
	dist(A,C,D1,Path1),
	cost(C,B,D2),
	D is D1 + D2,
	append(Path1, [B], Path).
dist(A,B,C1,[A,B]) :-
	cost(A,B,C1).

% dist(A,B,D,[A|Path]) :-
% 	cost(A,C,C1),
% 	dist(C,B,C2,Path),
% 	D is C1 + C2.
% dist(A,B,C1,[A,B]) :-
% 	cost(A,B,C1).


cost('A', 1, 10).
cost('A', 1, 30).
cost(n,'B', 40).
cost(n,1, 20).
cost(1,n, 25).
cost(1,2,23).
cost(2,3,23).
cost(3,4,23).
cost(4,5,23).
cost(5,6,23).
cost(6,7,23).
cost(7,8,23).
cost(8,9,23).
cost(9,10,23).
cost(10,n,23).

min(X,Y) :-
	X =< Y.


% min(X,Y,X) :-
% 	X =< Y.
% min(X,Y,Y) :-
% 	X > Y.
% min(X,Y,Y):- \+ number(X),!.
% min(X,Y,X):- \+ number(Y),!.
% min(One,Two,Min):- One > Two -> Min = Two ; Min = One.



%% Example II %%
:- use_module(library(terms_check)).

:- table p(subsumes_term/2).
p(X) :- p(f(X)).
p(_).
	


