:- package(tab_subsumption).

:- use_package(attr).
:- use_module(library(terms_check)).


make_attr(Pred, AttPred) :-
	Pred =.. [X| Args],
	put_attr_local(AttArg, Args),  % NewVar ^ [V1, ... Vn]
	AttPred =.. [X,AttArg].  % Overhead in the case of predicates with same name and different arity

undo_attr(AttPred, Pred) :-
	AttPred =.. [N, AttArg],
	get_attr_local(AttArg, Args),
	Pred =.. [N| Args].

reuse_strategy(X,Y):-
%	subsumes_term(X,Y).
	variant(X,Y).

%% Tabling interface %%
call_domain_projection([AttArg], Args) :-         get_attr_local(AttArg, Args).
call_entail(_, Args, Args_gen, _) :-              reuse_strategy(Args_gen,Args).
call_store_projection(_, _, _).

answer_domain_projection([AttArg], Args) :-            get_attr_local(AttArg, Args).
answer_check_entail(_, Args, Args_ans, _,  1, _) :-   reuse_strategy(Args_ans, Args), !.
%answer_check_entail(_, Args, Args_ans, _, -1, _) :-   reuse_strategy(Args, Args_ans).
answer_store_projection(_, _, _).

apply_answer([AttArg], Args, _) :-               get_attr_local(AttArg, Args).
%% Tabling interface %%

% :- multifile attr_unify_hook/2. %% needed
attr_unify_hook(Att, X) :-
	get_attr_local(X, Att1),
	Att = Att1.
