:- module(clpr_tab, 
	[ 
		project_domain/2,
		entail/4,
		apply_answer/3,
		project_gen_store/3,
		project_answer_store/3,
		current_store/1,
		reinstall_store/3
	], 
	[ assertions, 
	  library(clpr/clpr_src), 
	  library(clpqr/clpqr_options)
	]).

:- use_module(library(clpr/solver_r)).
:- use_module(library(clpr/clpr_dump), [clpqr_dump_constraints/3]).

:- use_module(library(clpr/clpr_attr)).

:- include(library(clpqr/clpqr_rt)).
:- include(library(clpqr/clpqr_attr_hooks)).

:- use_module(library(clpr/clpr_meta)).



project_domain(_X,_).

entail(X, _, _, (X-S2)) :-
	clpr_entailed(S2).

apply_answer(X, _A, (X-S1)) :-
	clpr_meta(S1).

project_gen_store(X, _A, (V-S)) :-
	clpqr_dump_constraints(X, V ,S).
project_answer_store(X, _A, (V-S)) :-
	clpqr_dump_constraints(X, V, S).

current_store(_).
reinstall_store(_X, _O, _).