:- use_package(tabling).
:- use_module(library(prolog_sys)).
:- use_module(library(write)).
:- use_module(library(format)).

:-include(mainfile).

cputime(T) :-
  % Not sure whether to pick walltime, runtime, usertime or systemtime
  statistics(runtime,[T,_]).

writeln(T) :-
  write(T),
  nl.

%:- import format/2 from format.

go :-
  cputime(Start),
  queryrule(_X,_Y,_Z),
  cputime(End),
  T is End - Start,
  write('% rocha8-ciao.pl: execution time = '), format('~2f',T), write(' milliseconds'),nl.

print_solutions :-
  queryrule(X,Y,Z),
  format('CIAOsol queryrule(~w,~w,~w)~n',[X,Y,Z]),
  fail.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% File:     test_large_joins_mondial.pl
%% Added by: Miguel Areias and Ricardo Rocha
%% Program:  Downloaded from OpenRuleBench web site at
%%           http://rulebench.projects.semwebcentral.org
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% time_query:- queryrule(X,Y,Z),
%              fail.
% 
% debug_query:- queryrule(X,Y,Z),
%               query_output([X, ' - ', Y, ' - ', Z, '\n']),
%             fail.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

:- table p/4.
:- table queryrule/3.
% tabled_predicate(p/4).
% tabled_predicate(queryrule/3).

isa(prov(Y,X),provi):- p(_,_,X,Y).

att(prov(Y,X),number,A):- p(A,_,X,Y).
att(prov(Y,X),number2,D):- p(_,D,X,Y).

p(A,D,X,Y):- 
   province(Y,X,D,_,_,_), 
   city(_,X,Y,A,_,_).

queryrule(X,A,D):-
   isa(prov(X,'cn'),provi),
   att(prov(X,'cn'),number,A),
   att(prov(X,'cn'),number2,D).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

city('Eskasem','af','Badakhshan',12120.0,71.56,36.72).
city('Fayzabad','af','Badakhshan',40289.0,70.58,37.13).
city('Hzandud','af','Badakhshan',5521.0,72.32,36.93).
city('Jurm','af','Badakhshan',12121.0,70.0,36.85).
city('Qaleh-ye Panjeh','af','Badakhshan',9152.0,72.76,37.0).
city('Bala Morgab','af','Badgis',15088.0,63.33,35.56).
city('Qaleh-ye Naw','af','Badgis',52571.0,63.12,34.99).
city('Andarab','af','Baglan',27034.0,69.21,35.62).
city('Baglan','af','Baglan',108481.0,68.7,36.14).
city('Dahaneh-ye Gawri','af','Baglan',3308.0,68.48,35.9).
city('Nahrin','af','Baglan',22389.0,69.13,36.07).
city('Pol-e Hzumri','af','Baglan',56388.0,68.7,35.95).
city('Balhz','af','Balhz',115035.0,66.9,36.75).
city('Dawlataba','af','Balhz',17674.0,66.82,36.98).
city('Mazar-e Sarif','af','Balhz',303385.0,67.1,36.7).
city('Qarchi Gak','af','Balhz',8942.0,66.77,37.03).
city('Sulgara','af','Balhz',21546.0,66.87,36.33).
city('Tas Gozar','af','Balhz',38981.0,67.19,37.13).
city('Bamiyan','af','Bamiyan',125422.0,67.52,34.82).
city('Panjab','af','Bamiyan',13471.0,67.03,34.4).
city('Qil Qaleh','af','Bamiyan',9239.0,67.05,35.27).
city('Anar Darreh','af','Farah',10023.0,61.65,32.75).
city('Farah','af','Farah',43574.0,62.1,32.39).
city('Sindand','af','Farah',29273.0,62.16,33.31).
city('Andhzvoy','af','Faryab',29218.0,65.1,36.93).
city('Darzi Ab','af','Faryab',9653.0,65.4,35.98).
city('Dawlatabad','af','Faryab',13603.0,64.91,36.41).
city('Maymanah','af','Faryab',79287.0,64.77,35.93).
city('Cagcaran','af','Gawr',31495.0,65.25,34.52).
city('Sahrak','af','Gawr',15967.0,64.3,34.1).
city('Taywarah','af','Gawr',14398.0,64.42,33.51).
city('Gazni','af','Gazni',143049.0,68.42,33.56).
city('Awbeh','af','Herat',7293.0,63.14,34.39).
city('Eslam Qaleh','af','Herat',18085.0,61.07,34.67).
city('Gurian','af','Herat',49518.0,61.47,34.34).
city('Herat','af','Herat',272880.0,62.18,34.35).
city('Karuhz','af','Herat',17490.0,62.59,34.49).
city('Kuhestan','af','Herat',12087.0,61.18,34.65).
city('Kusk','af','Herat',16952.0,61.95,33.28).
city('Qarabag','af','Herat',12412.0,61.76,34.93).
city('Tawragudi','af','Herat',20197.0,62.26,35.22).
city('Tir Pol','af','Herat',6979.0,61.26,34.59).
city('Zendejan','af','Herat',10104.0,61.74,34.34).
city('Bagran','af','Hilmand',25918.0,65.09,33.06).
city('Darwisan','af','Hilmand',9012.0,64.18,31.12).
city('Deh Su','af','Hilmand',9196.0,63.3,30.43).
city('Geresk','af','Hilmand',43638.0,64.56,31.83).
city('Laskar Gah','af','Hilmand',43949.0,64.35,31.59).
city('Sangin','af','Hilmand',13579.0,64.82,32.07).
city('Aqcah','af','Jawzjan',49526.0,66.16,36.93).
city('Qarqin','af','Jawzjan',15023.0,66.02,37.41).
city('Sang-e Carak','af','Jawzjan',15377.0,66.44,35.85).
city('Shibarghan','af','Jawzjan',55658.0,65.74,36.66).
city('Bagrami','af','Kabul',30256.0,69.27,34.49).
city('Kabul','af','Kabul',3043589.0,69.17,34.53).
city('Mir Baccekut','af','Kabul',5405.0,69.12,34.73).
city('Pagman','af','Kabul',49173.0,68.95,34.58).
city('Qarabag','af','Kabul',12347.0,69.15,34.83).
city('Sarawbi','af','Kabul',21598.0,69.74,34.62).
city('Mahmud-e Raqi','af','Kapisa',6626.0,69.32,35.02).
city('Tagab','af','Kapisa',6400.0,69.63,34.85).
city('Khowst','af','Khowst',96246.0,69.92,33.34).
city('Asadabad','af','Kunar',48400.0,71.15,34.87).
city('Asmar','af','Kunar',15708.0,71.37,35.03).
city('Mehtar Lam','af','Lagman',17350.0,70.2,34.65).
city('Azrow','af','Lawgar',12526.0,69.63,34.17).
city('Baraki Barak','af','Lawgar',22305.0,68.93,33.97).
city('Pol-e Alam','af','Lawgar',13251.0,69.03,33.99).
city('Acin','af','Nangarhar',15098.0,70.7,34.12).
city('Batsawul','af','Nangarhar',6835.0,70.87,34.25).
city('Hugyani','af','Nangarhar',17082.0,70.07,34.3).
city('Jalalabad','af','Nangarhar',200389.0,70.44,34.44).
city('Nader Sah Kawt','af','Nangarhar',12305.0,70.71,34.23).
city('Cahar Burjak','af','Nimruz',11935.0,62.2,34.25).
city('Cahzansur','af','Nimruz',15070.0,62.05,31.19).
city('Hzas','af','Nimruz',15133.0,62.78,31.52).
city('Mirabad','af','Nimruz',14160.0,61.83,30.43).
city('Rudbar','af','Nimruz',11034.0,62.6,30.15).
city('Zaranj','af','Nimruz',33894.0,61.88,31.12).
city('Nuristan','af','Nuristan',17072.0,70.38,34.94).
city('Orgun','af','Paktika',10665.0,69.17,32.96).
city('Sharan','af','Paktika',7368.0,68.78,33.13).
city('Zargun Sahr','af','Paktika',13737.0,68.45,32.86).
city('Ali Hzayl','af','Paktiya',12687.0,69.7,33.94).
city('Gardez','af','Paktiya',103732.0,69.22,33.6).
city('Carikar','af','Parwan',53693.0,69.17,35.02).
city('Jabal-os-Saraj','af','Parwan',15055.0,69.24,35.13).
city('Qandahar','af','Qandahar',391230.0,65.69,31.61).
city('Dast-e Arca','af','Qunduz',8266.0,69.17,37.13).
city('Emam Saheb','af','Qunduz',9659.0,68.9,37.19).
city('Hazart Imam','af','Qunduz',24552.0,68.76,37.22).
city('Hzanabad','af','Qunduz',71552.0,69.11,36.68).
city('Qaleh-ye Zal','af','Qunduz',15104.0,68.41,37.0).
city('Qunduz','af','Qunduz',161943.0,68.86,36.73).
city('Aybak','af','Samangan',47877.0,68.04,36.26).
city('Kholm','af','Samangan',64954.0,67.69,36.69).
city('Ciras','af','Sar-e Pul',12778.0,65.98,35.42).
city('Lar Gerd','af','Sar-e Pul',11635.0,66.65,35.49).
city('Margi','af','Sar-e Pul',14333.0,66.4,35.18).
city('Qaleh Sahr','af','Sar-e Pul',7756.0,65.57,35.54).
city('Sar-e Pul','af','Sar-e Pul',52138.0,65.93,36.22).
city('Tagaw Bay','af','Sar-e Pul',9095.0,66.05,35.7).
city('Tokzar','af','Sar-e Pul',12021.0,66.42,35.95).
city('Cah Ab','af','Tahzar',23424.0,69.8,37.4).
city('Eskames','af','Tahzar',6602.0,69.32,36.38).
city('Farhzar','af','Tahzar',10492.0,69.85,36.57).
city('Hzwajeh Gar','af','Tahzar',18654.0,69.47,37.09).
city('Rostaq','af','Tahzar',25644.0,69.82,37.12).
city('Taloqan','af','Tahzar',64275.0,69.53,36.73).
city('Yangi Qaleh','af','Tahzar',6543.0,69.6,37.47).
city('Deh Rawud','af','Uruzgan',25683.0,65.45,32.62).
city('Gaz Ab','af','Uruzgan',5647.0,66.27,33.37).
city('Tarin Kawt','af','Uruzgan',15598.0,65.86,32.63).
city('Uruzgan','af','Uruzgan',13400.0,66.63,32.94).
city('Gardan Diwal','af','Wardag',6815.0,68.26,34.5).
city('Maydansahr','af','Wardag',14922.0,68.78,34.45).
city('Qalat-e Gilzay','af','Zabul',12195.0,66.89,32.11).
city('Berat','al','Bera',47606.0,19.96,40.71).
city('Polican','al','Berat',10663.0,20.1,40.6).
city('Ure Vajgurore','al','Berat',4893.0,19.88,40.78).
city('Bulqize','al','Bulqize',11212.0,20.23,41.49).
city('Delvine','al','Delvine',3916.0,20.09,39.96).
city('Bilisht','al','Devoll',7114.0,20.98,40.62).
city('Peshkopi','al','Dibre',15261.0,20.44,41.69).
city('Durres','al','Durres',122034.0,19.45,41.33).
city('Shijak','al','Durres',14138.0,19.56,41.34).
city('Cerrik','al','Elbasan',14269.0,19.96,41.02).
city('Elbasan','al','Elbasan',100903.0,20.09,41.12).
city('Kerrabe','al','Elbasan',1177.0,19.98,41.21).
city('Fier','al','Fier',59719.0,19.57,40.73).
city('Patos','al','Fier',22679.0,19.65,40.64).
city('Roskovec','al','Fier',6657.0,19.71,40.74).
city('Gjirokaster','al','Gjirokaster',23437.0,20.15,40.08).
city('Libohove','al','Gjirokaster',3651.0,20.26,40.04).
city('Gramsh','al','Gramsh',11556.0,20.18,40.87).
city('Krume','al','Has',3215.0,19.9,42.2).
city('Kavaje','al','Kavaje',29354.0,19.56,41.2).
city('Erseke','al','Kolonje',7890.0,20.68,40.34).
city('Leskovik','al','Kolonje',2655.0,20.58,40.15).
city('Korce','al','Korce',58259.0,20.79,40.63).
city('Maliq','al','Korce',3735.0,20.68,40.72).
city('Fushe-Kruje','al','Kruje',10458.0,19.71,41.48).
city('Kruje','al','Kruje',21286.0,19.8,41.52).
city('Mamurras','al','Kruje',8282.0,19.68,41.57).
city('Milot','al','Kruje',2157.0,19.73,41.69).
city('Kucove','al','Kucove',18166.0,19.93,40.81).
city('Kukes','al','Kukes',17972.0,20.43,42.09).
city('Lac','al','Kurbin',24825.0,19.71,41.64).
city('Lezhe','al','Lezhe',18695.0,19.65,41.79).
city('Shengjin','al','Lezhe',2698.0,19.58,41.82).
city('Librazhd','al','Librazhd',12691.0,20.32,41.19).
city('Perrenjas','al','Librazhd',4015.0,20.53,41.07).
city('Lushnje','al','Lushnje',41423.0,19.71,40.95).
city('Rrogozhine','al','Lushnje',5620.0,19.66,41.09).
city('Ballsh','al','Mallakaster',10361.0,19.73,40.6).
city('Koplik','al','Malsi e Madhe',4078.0,19.43,42.2).
city('Burrel','al','Mat',15539.0,20.02,41.63).
city('Klos','al','Mat',683.0,20.1,41.49).
city('Kraste','al','Mat',1168.0,20.13,41.44).
city('Ulze','al','Mat',600.0,19.9,41.69).
city('Kurbnesh','al','Mirdite',1429.0,20.08,41.78).
city('Rreshen','al','Mirdite',10064.0,19.88,41.77).
city('Rubik','al','Mirdite',2332.0,19.78,41.77).
city('Peqin','al','Peqin',7513.0,19.76,41.06).
city('Kelcyre','al','Permet',2486.0,20.18,40.32).
city('Permet','al','Permet',10686.0,20.35,40.24).
city('Pogradec','al','Pogradec',25758.0,20.7,40.87).
city('Fierze','al','Puke',742.0,20.0,42.25).
city('Fushe-Arrez','al','Puke',2438.0,20.01,42.05).
city('Puke','al','Puke',6495.0,19.9,42.07).
city('Konispol','al','Sarande',1349.0,20.17,39.66).
city('Sarande','al','Sarande',15147.0,20.0,39.88).
city('Shkoder','al','Shkoder',89102.0,19.51,42.07).
city('Corovode','al','Skrapar',14046.0,20.21,40.5).
city('Memaliaj','al','Tepelene',4951.0,19.97,40.35).
city('Tepelene','al','Tepelene',11955.0,20.01,40.3).
city('Kamze','al','Tirana',11026.0,19.76,41.39).
city('Tirana','al','Tirana',374801.0,19.82,41.33).
city('Vore','al','Tirana',4973.0,19.66,41.39).
city('Bajram Curri','al','Tropoje',7967.0,20.08,42.36).
city('Himare','al','Vlore',4596.0,19.74,40.13).
city('Orikum','al','Vlore',2604.0,19.47,40.32).
city('Selenice','al','Vlore',6912.0,19.65,40.55).
city('Vlore','al','Vlore',89528.0,19.49,40.48).
city('Adrar','dz','Adrar',89441.0,-0.29,27.87).
city('Awlaf','dz','Adrar',24919.0,1.08,26.97).
city('Riqqan','dz','Adrar',33143.0,0.16,26.72).
city('Timimun','dz','Adrar',49433.0,0.23,29.26).
city('Algiers','dz','Algiers',1980242.0,3.04,36.77).
city('Bab Azwar','dz','Algiers',277580.0,3.18,36.72).
city('Baraqi','dz','Algiers',105400.0,3.1,36.67).
city('Bir Hzadam','dz','Algiers',71732.0,3.03,36.72).
city('Burj-al-Kifan','dz','Algiers',123263.0,3.18,36.75).
city('ad-Dar-al-Bayda','dz','Algiers',37493.0,3.2,36.7).
city('Annabah','dz','Annabah',206684.0,7.76,36.91).
city('Birrahhal','dz','Annabah',19407.0,7.45,36.83).
city('al-Hajar','dz','Annabah',46843.0,7.75,36.8).
city('Ayn Timusanat','dz','Ayn Timusanat',57361.0,-1.15,35.3).
city('Bani Saf','dz','Ayn Timusanat',46558.0,-1.4,35.31).
city('Hammam Bu Hajjar','dz','Ayn Timusanat',36037.0,-0.97,35.39).
city('al-Amriyah','dz','Ayn Timusanat',26513.0,-1.02,35.54).
city('al-Malah','dz','Ayn Timusanat',19496.0,-1.09,35.39).
city('Ayn ad-Daflah','dz','Ayn ad-Dafla',48917.0,1.96,36.27).
city('Hzamis Milyanah','dz','Ayn ad-Dafla',75874.0,2.21,36.26).
city('Milyanah','dz','Ayn ad-Dafla',40095.0,2.21,36.29).
city('al-Abadiyah','dz','Ayn ad-Dafla',28872.0,1.68,36.27).
city('al-Attaf','dz','Ayn ad-Dafla',44016.0,1.66,36.22).
city('Bassar','dz','Bassar',143390.0,-2.23,31.61).
city('Aris','dz','Batnah',36797.0,6.35,35.25).
city('Ayn at-Tutah','dz','Batnah',72576.0,5.89,35.39).
city('Barikah','dz','Batnah',98858.0,5.37,35.39).
city('Batnah','dz','Batnah',280825.0,6.17,35.57).
city('Marwanah','dz','Batn',47892.0,5.92,35.64).
city('Naqaus','dz','Batnah',31084.0,5.6,35.55).
city('Ras-al-Ayun','dz','Batnah',34389.0,5.65,35.69).
city('Tazult','dz','Batnah',41811.0,6.26,35.49).
city('Amizur','dz','Bijayah',25935.0,4.91,36.64).
city('Aqbu','dz','Bijayah',66922.0,4.53,36.46).
city('Barbasa','dz','Bijayah',32171.0,4.97,36.57).
city('Bijayah','dz','Bijayah',164121.0,5.07,36.76).
city('Farawn','dz','Bijayah',21793.0,4.87,36.55).
city('Igram','dz','Bijayah',15096.0,4.51,36.47).
city('Sadduk','dz','Bijayah',19969.0,4.68,36.54).
city('Samini','dz','Bijayah',21677.0,4.62,36.6).
city('Taskaryut','dz','Bijayah',18670.0,5.25,36.57).
city('Tazmalt','dz','Bijayah',21497.0,4.4,36.39).
city('Timazrit','dz','Bijayah',32025.0,4.77,36.65).
city('al-Qasr','dz','Bijayah',26161.0,4.85,36.69).
city('Awlad Jallal','dz','Biskrah',61746.0,5.06,34.43).
city('Biskrah','dz','Biskrah',196320.0,5.73,34.86).
city('Sidi Hzalid','dz','Biskrah',64739.0,5.0,34.39).
city('Sidi Uqbah','dz','Biskrah',35137.0,5.9,34.75).
city('Tulqah','dz','Biskrah',68524.0,5.38,34.73).
city('Umas','dz','Biskrah',10471.0,5.68,34.7).
city('Zarbiyat-al-Wad','dz','Biskrah',23288.0,6.51,34.69).
city('Awlad Yais','dz','Blidah',52881.0,2.85,36.5).
city('Awlad as-Salamah','dz','Blidah',28128.0,3.33,36.62).
city('Bani Marad','dz','Blidah',92813.0,2.87,36.54).
city('Bani Tamu','dz','Blidah',25455.0,2.83,36.53).
city('Bu Arfa','dz','Blidah',44436.0,2.81,36.47).
city('Bu Inan','dz','Blidah',30395.0,2.98,36.5).
city('Bufarik','dz','Blidah',59980.0,2.9,36.58).
city('Buqarah','dz','Blidah',63458.0,3.06,36.54).
city('Maftah','dz','Blidah',60280.0,3.22,36.62).
city('Muzayah','dz','Blidah',33116.0,2.68,36.47).
city('Sidi Mussa','dz','Blidah',58207.0,3.08,36.6).
city('Siffa','dz','Blidah',23314.0,2.74,36.47).
city('Wadi al-Allayaq','dz','Blidah',21233.0,2.78,36.55).
city('al-Afrun','dz','Blidah',42799.0,2.61,36.47).
city('al-Arbaa','dz','Blidah',69567.0,3.15,36.57).
city('al-Blidah','dz','Blidah',161585.0,2.83,36.48).
city('as-Sabli','dz','Blidah',20027.0,3.02,36.58).
city('as-Sumaah','dz','Blidah',40909.0,2.92,36.52).
city('Awlad Haddaj','dz','Bumardas',12515.0,3.35,36.72).
city('Awlad Mussa','dz','Bumardas',13529.0,3.37,36.69).
city('Ayn Tayah','dz','Bumardas',21903.0,3.29,36.8).
city('Bani Amran','dz','Bumardas',18505.0,3.58,36.67).
city('Budwawu','dz','Bumardas',45367.0,3.41,36.72).
city('Bumardas','dz','Bumardas',27272.0,3.46,36.77).
city('Burj Minayal','dz','Bumardas',45807.0,3.72,36.73).
city('Dalis','dz','Bumardas',26489.0,3.89,36.92).
city('Hzamis-al-Hzasnah','dz','Bumardas',49990.0,3.33,36.65).
city('Issar','dz','Bumardas',18025.0,3.67,36.72).
city('Nasiriyah','dz','Bumardas',15450.0,3.83,36.75).
city('Saabat','dz','Bumardas',19618.0,3.7,36.63).
city('Tinyah','dz','Bumardas',16246.0,3.54,36.73).
city('al-Arbaa Tas','dz','Bumardas',17580.0,3.38,36.64).
city('ar-Ragayah','dz','Bumardas',55217.0,3.35,36.73).
city('ar-Ruwibah','dz','Bumardas',20826.0,3.27,36.73).
city('Burj Bu Arririj','dz','Burj Bu Arririj',158349.0,4.63,36.06).
city('Burj Gadir','dz','Burj Bu Arririj',34280.0,4.89,35.9).
city('Burj Zamura','dz','Burj Bu Arririj',19869.0,4.85,36.27).
city('Ras-al-Wad','dz','Burj Bu Arririj',56956.0,5.04,35.95).
city('al-Asir','dz','Burj Bu Arririj',34703.0,4.62,36.07).
city('al-Mansurah','dz','Burj Bu Arririj',22212.0,4.46,36.08).
city('Ayn Abid','dz','Constantine',29638.0,6.94,36.23).
city('Ayn Samara','dz','Constantine',29154.0,6.5,36.27).
city('Constantine','dz','Constantine',450126.0,6.6,36.36).
city('Didus Murad','dz','Constantine',25897.0,6.63,36.45).
city('Hamma Bu Ziyan','dz','Constantine',63269.0,6.6,36.42).
city('Zigut Yusuf','dz','Constantine',35912.0,6.7,36.53).
city('al-Hzurub','dz','Constantine',83807.0,6.69,36.27).
city('Ammi Mussa','dz','Galizan',23096.0,1.1,35.87).
city('Galizan','dz','Galizan',117591.0,0.55,35.75).
city('Jidiwiyah','dz','Galizan',32156.0,0.82,35.93).
city('Mazunah','dz','Galizan',22460.0,0.9,36.12).
city('Sidi Muhammad Ban Ali','dz','Galizan',19435.0,0.85,36.15).
city('Wadi Rahiyu','dz','Galizan',60152.0,0.92,35.97).
city('Zammurah','dz','Galizan',21860.0,0.76,35.73).
city('Biryan','dz','Gardayah',44758.0,3.77,32.84).
city('Bu Nura','dz','Gardayah',63612.0,3.72,32.49).
city('Gardayah','dz','Gardayah',82519.0,3.67,32.49).
city('Matlili','dz','Gardayah',50312.0,3.63,32.27).
city('al-Guliah','dz','Gardayah',37182.0,2.88,30.57).
city('al-Qararah','dz','Gardayah',84007.0,4.49,32.79).
city('Hzansalah','dz','Hzansalah',130336.0,7.15,35.44).
city('Ilizi','dz','Ilizi',6657.0,8.47,26.5).
city('Am','dz','Jijili',29294.0,5.85,36.75).
city('Jijili','dz','Jijili',137184.0,5.77,36.83).
city('al-Miliyah','dz','Jijili',79964.0,6.27,36.76).
city('al-Tahir','dz','Jijili',64828.0,5.94,36.41).
city('as-Siqfah','dz','Jijili',28307.0,5.97,36.77).
city('Ayn Bu Sif','dz','Medea',12051.0,3.15,35.9).
city('Bir Waqiyah','dz','Medea',80615.0,2.91,36.14).
city('Medea','dz','Medea',147710.0,2.77,36.27).
city('Qasr-al-Buhzari','dz','Medea',77175.0,2.74,35.89).
city('Sillalah','dz','Medea',2518.0,3.41,35.93).
city('Milah','dz','Milah',68840.0,6.26,36.45).
city('Qararam Quqa','dz','Milah',52767.0,6.31,36.52).
city('Ruwasad','dz','Milah',40537.0,6.03,36.45).
city('Salgum-al-Ayd','dz','Milah',71953.0,6.17,36.16).
city('Sidi Marwan','dz','Milah',25239.0,6.25,36.52).
city('Tajananah','dz','Milah',58272.0,5.99,36.13).
city('Taligmah','dz','Milah',51923.0,6.37,36.12).
city('Wadi Atzmaniyah','dz','Milah',43938.0,6.28,36.25).
city('Ayn Tadalas','dz','Mostaghanem',22270.0,0.37,35.94).
city('Mostaghanem','dz','Mostaghanem',126183.0,0.09,35.94).
city('Sidi Ali','dz','Mostaghanem',25309.0,0.42,36.1).
city('Bu Hanifiyah','dz','Muaskar',27716.0,-0.05,35.32).
city('Muaskar','dz','Muaskar',86873.0,0.14,35.4).
city('Siq','dz','Muaskar',58884.0,-0.18,35.53).
city('Tiginnif','dz','Muaskar',46094.0,0.24,35.42).
city('Wadi al-Abtal','dz','Muaskar',22936.0,0.68,35.46).
city('Zahanah','dz','Muaskar',20176.0,-0.42,35.52).
city('al-Muhammadiyah','dz','Muaskar',50621.0,0.06,35.6).
city('Bumahra Ahmad','dz','Qalmah',23139.0,7.52,36.45).
city('Hammam Awlad Ali','dz','Qalmah',40361.0,7.45,36.5).
city('Qalmah','dz','Qalmah',123602.0,7.43,36.47).
city('Wadi Zinati','dz','Qalmah',34774.0,7.17,36.32).
city('Ayn-al-Hajar','dz','Saidah',13050.0,0.15,34.77).
city('Saidah','dz','Saidah',127506.0,0.14,34.84).
city('Azzabah','dz','Sakikdah',75618.0,7.1,36.75).
city('Fil Fila','dz','Sakikdah',15569.0,37.1,36.9).
city('Karkira','dz','Sakikdah',47017.0,6.58,36.94).
city('Sakikdah','dz','Sakikdah',162720.0,6.9,36.0).
city('Tamalus','dz','Sakikdah',32716.0,6.65,36.83).
city('al-Harus','dz','Sakikdah',60224.0,6.83,36.66).
city('al-Qull','dz','Sakikdah',53523.0,6.55,37.02).
city('Ayn Arnat','dz','Satif',35275.0,5.31,36.19).
city('Ayn Azl','dz','Satif',44104.0,5.5,35.85).
city('Ayn Wilman','dz','Satif',68165.0,5.3,35.93).
city('Ayn-al-Hzabira','dz','Satif',43076.0,5.48,36.33).
city('Buqah','dz','Satif',38766.0,5.08,36.33).
city('Salah Bay','dz','Satif',23443.0,5.29,35.86).
city('Satif','dz','Satif',226315.0,5.41,36.19).
city('al-Ulmah','dz','Satif',128366.0,5.69,36.16).
city('Ayn-al-Bard','dz','Sidi balabbas',16619.0,-0.52,35.35).
city('Ras-al-Ma','dz','Sidi balabbas',20687.0,-0.82,34.51).
city('Safizaf','dz','Sidi balabbas',31210.0,-0.25,35.24).
city('Sidi Balabbas','dz','Sidi balabbas',191786.0,-0.64,35.19).
city('Talag','dz','Sidi balabbas',28681.0,-0.57,34.8).
city('Madawrus','dz','Suq Ahras',33270.0,7.82,36.08).
city('Sadratah','dz','Suq Ahras',53523.0,7.53,36.13).
city('Suq Ahras','dz','Suq Ahras',137507.0,7.95,36.29).
city('Ayn Qazzam','dz','Tamanrasat',62402.0,5.69,19.53).
city('Ayn Salah','dz','Tamanrasat',49401.0,2.47,27.2).
city('Tamanrasat','dz','Tamanrasat',73135.0,5.52,22.79).
city('Ayn Binyan','dz','Tibazah',30978.0,2.92,36.8).
city('Bu Ismail','dz','Tibazah',22321.0,2.68,36.64).
city('Duwirah','dz','Tibazah',26769.0,2.95,36.67).
city('Hajut','dz','Tibazah',27410.0,2.41,36.51).
city('Sawlah','dz','Tibazah',16691.0,3.02,36.7).
city('Sirsall','dz','Tibazah',20123.0,2.19,36.61).
city('Staw','dz','Tibazah',19229.0,2.89,36.76).
city('Tibazah','dz','Tibazah',8373.0,2.48,36.56).
city('Ziralda','dz','Tibazah',17473.0,2.83,36.72).
city('al-Qullah','dz','Tibazah',31657.0,2.77,36.63).
city('as Siraga','dz','Tibazah',27695.0,2.97,36.77).
city('Bir-al-Itir','dz','Tibissah',68711.0,8.05,34.75).
city('Hammamat','dz','Tibissah',28686.0,7.95,35.45).
city('Sariah','dz','Tibissah',72139.0,7.75,35.28).
city('Tibissah','dz','Tibissah',182465.0,8.12,35.41).
city('al-Awaynat','dz','Tibissah',3314.0,7.89,35.87).
city('al-Winzah','dz','Tibissah',64438.0,8.12,35.96).
city('Awlad Mimun','dz','Tilimsan',34029.0,-1.04,34.92).
city('Bani Mastar','dz','Tilimsan',19893.0,-1.42,34.87).
city('Bin Sikran','dz','Tilimsan',21373.0,-1.22,35.07).
city('Magniyah','dz','Tilimsan',79138.0,-1.73,34.86).
city('Nidrumah','dz','Tilimsan',37149.0,-1.74,35.02).
city('Sabrah','dz','Tilimsan',33354.0,-1.53,34.83).
city('Satwan','dz','Tilimsan',40077.0,-1.29,34.92).
city('Sibdu','dz','Tilimsan',41355.0,-1.33,34.65).
city('Sidi Abdalli','dz','Tilimsan',23665.0,-1.13,35.07).
city('Tilimsan','dz','Tilimsan',120996.0,-1.32,34.89).
city('al-Gazawat','dz','Tilimsan',48925.0,-1.86,35.1).
city('al-Hannayah','dz','Tilimsan',42133.0,-1.37,34.95).
city('al-Mansurah','dz','Tilimsan',52645.0,-1.34,34.87).
city('ar-Ramsi','dz','Tilimsan',51433.0,-1.44,35.07).
city('Tinduf','dz','Tinduf',41688.0,8.16,27.67).
city('Tisamsilt','dz','Tisamsilt',70319.0,1.81,35.62).
city('Tzaniyat-al-Had','dz','Tisamsilt',27793.0,2.03,35.88).
city('Ayn Dahab','dz','Tiyarat',36297.0,1.55,34.85).
city('Firindah','dz','Tiyarat',63576.0,1.04,35.06).
city('Mahdiyah','dz','Tiyarat',39437.0,1.76,35.43).
city('Qasr as-Sillalah','dz','Tiyarat',58716.0,2.3,35.21).
city('Sugar','dz','Tiyarat',68662.0,1.5,35.2).
city('Tiyarat','dz','Tiyarat',176016.0,1.32,35.38).
city('Agrib','dz','Tizi Wazu',24113.0,4.33,36.8).
city('Arbaa Nayat','dz','Tizi Wazu',30741.0,4.2,36.63).
city('Ayn-al-Hammam','dz','Tizi Wazu',28149.0,4.31,36.57).
city('Azazgah','dz','Tizi Wazu',40793.0,4.37,36.75).
city('Bani Duwala','dz','Tizi Wazu',33753.0,4.08,36.62).
city('Bugni','dz','Tizi Wazu',54940.0,3.95,36.53).
city('Bujima','dz','Tizi Wazu',20644.0,4.15,36.82).
city('Buzqan','dz','Tizi Wazu',35649.0,4.47,36.77).
city('Dara-al-Mizan','dz','Tizi Wazu',41474.0,3.83,36.54).
city('Daraa Ban Hzaddah','dz','Tizi Wazu',37601.0,3.95,36.74).
city('Fariha','dz','Tizi Wazu',31251.0,4.32,36.75).
city('Maklah','dz','Tizi Wazu',29685.0,4.27,36.69).
city('Makuda','dz','Tizi Wazu',34717.0,4.07,36.79).
city('Tadmait','dz','Tizi Wazu',21042.0,3.9,36.73).
city('Tigzirt','dz','Tizi Wazu',19748.0,4.12,36.9).
city('Timizart','dz','Tizi Wazu',41398.0,4.27,36.8).
city('Tirmirtin','dz','Tizi Wazu',26372.0,3.98,36.65).
city('Tizi Ganif','dz','Tizi Wazu',28117.0,3.77,36.58).
city('Tizi Natzlata','dz','Tizi Wazu',22500.0,4.05,36.55).
city('Tizi Rasid','dz','Tizi Wazu',17949.0,4.2,36.69).
city('Tizi Wazu','dz','Tizi Wazu',144221.0,4.05,36.72).
city('Wadiyah','dz','Tizi Wazu',21800.0,4.09,36.56).
city('Ayn Fakrun','dz','Umm-al-',68702.0,6.87,35.98).
city('Ayn Kirsah','dz','Umm-al-Bawagi',32634.0,6.7,35.93).
city('Ayn Malilah','dz','Umm-al-Bawagi',71078.0,6.57,36.04).
city('Ayn al-Bayda','dz','Umm-al-Bawagi',105777.0,7.39,35.81).
city('Miskyanah','dz','Umm-al-Bawagi',30200.0,7.66,35.64).
city('Umm-al-Bawagi','dz','Umm-al-Bawagi',101278.0,7.11,35.88).
city('Arzu','dz','Wahran',62187.0,-0.32,35.87).
city('Ayn Biya','dz','Wahran',37482.0,-0.29,35.82).
city('Ayn-at-Turk','dz','Wahran',45515.0,-0.77,35.74).
city('Bir-al-Jir','dz','Wahran',68506.0,-0.57,35.72).
city('Butlilis','dz','Wahran',26256.0,-0.91,35.58).
city('Hassi Bu Nif','dz','Wahran',49838.0,-0.5,35.7).
city('Mars-al-Kabir','dz','Wahran',20266.0,-0.72,35.74).
city('Qadayal','dz','Wahran',42910.0,-0.42,35.78).
city('Sidi as-Sami','dz','Wahran',35724.0,-0.52,35.65).
city('Wadi Tzalatza','dz','Wahran',13735.0,-0.45,35.55).
city('Wahran','dz','Wahran',646025.0,-0.62,35.7).
city('as-Saniyah','dz','Wahran',68367.0,-0.63,35.65).
city('Tabisbast','dz','Warqla',41274.0,6.08,33.12).
city('Tam','dz','Warqla',27811.0,6.02,33.02).
city('Tuggurt','dz','Warqla',49051.0,6.06,33.1).
city('Warqla','dz','Warqla',150611.0,5.34,31.97).
city('al-Hajirah','dz','Warqla',39916.0,5.52,32.62).
city('ar-Ruwisat','dz','Warqla',81176.0,5.37,31.92).
city('Aflu','dz','al-Agwat',84998.0,2.09,34.12).
city('al-Agwat','dz','al-Agwat',113883.0,2.88,33.81).
city('Brizyanah','dz','al-Bayad',19166.0,1.25,33.11).
city('al-Abyad Sidi Sayhz','dz','al-Bayad',39437.0,0.53,32.9).
city('al-Bayad','dz','al-Bayad',715.0,1.01,33.69).
city('Ayn Bissam','dz','al-Buirah',29584.0,3.67,36.29).
city('Sur-al-Guzlan','dz','al-Buirah',50404.0,3.68,36.15).
city('al-Ahzdariyah','dz','al-Buirah',56944.0,3.58,36.57).
city('al-Buirah','dz','al-Buirah',86219.0,3.9,36.38).
city('as-Surfa','dz','al-Buirah',20642.0,4.32,36.37).
city('Ayn Wissarah','dz','al-Jilfah',118703.0,2.9,35.46).
city('Ayn-al-Ibl','dz','al-Jilfah',32074.0,3.21,34.35).
city('Birin','dz','al-Jilfah',51460.0,3.21,35.62).
city('Dar Siyuhz','dz','al-Jilfah',54285.0,3.48,34.0).
city('Hassi Bahbah','dz','al-Jilfah',84852.0,3.02,35.08).
city('Misad','dz','al-Jilfah',99499.0,3.5,34.16).
city('al-Idrisiyah','dz','al-Jilfah',38907.0,2.52,34.46).
city('al-Jilfah','dz','al-Jilfah',213251.0,3.25,34.68).
city('as-Sarif','dz','al-Jilfah',27839.0,2.8,34.62).
city('Ayn-al-Hajal','dz','al-Masilah',42751.0,3.87,35.69).
city('Ayn-al-Milh','dz','al-Masilah',39968.0,4.16,34.85).
city('Bu Saadah','dz','al-Masilah',116299.0,4.18,35.21).
city('Hammam Dalaa','dz','al-Masilah',48934.0,4.4,35.93).
city('Maadid','dz','al-Masilah',42459.0,4.88,35.78).
city('Maqrah','dz','al-Masilah',40712.0,5.07,35.6).
city('Sidi Aysa','dz','al-Masilah',69748.0,3.77,35.9).
city('Wanuga','dz','al-Masilah',25815.0,4.2,35.98).
city('al-Masilah','dz','al-Masilah',118167.0,4.54,35.71).
city('Dabilah','dz','al-Wad',36991.0,6.95,33.52).
city('Hassi Halifa','dz','al-Wad',44116.0,7.03,33.59).
city('Jamaa','dz','al-Wad',53105.0,5.96,33.52).
city('Maqran','dz','al-Wad',31849.0,6.1,33.2).
city('Qamar','dz','al-Wad',41874.0,6.79,33.5).
city('Raqiba','dz','al-Wad',62494.0,6.72,33.57).
city('Rubbah','dz','al-Wad',30578.0,6.91,33.28).
city('Sidi Amran','dz','al-Wad',29865.0,6.02,33.5).
city('al-Migair','dz','al-Wad',66009.0,5.92,33.96).
city('al-Wad','dz','al-Wad',127254.0,6.86,33.37).
city('Ayn as-Safra','dz','an-Naamah',63621.0,-0.58,32.76).
city('al-Misriyah','dz','an-Naamah',60237.0,-0.29,33.56).
city('an-Naamah','dz','an-Naamah',8427.0,-0.32,33.27).
city('Abu al-Hassan','dz','as-Salif',24127.0,1.18,36.42).
city('Ayn Maran','dz','as-Salif',34619.0,0.98,36.15).
city('Bani Hawa','dz','as-Salif',5405.0,1.56,36.54).
city('Bu Qadir','dz','as-Salif',26777.0,1.12,36.07).
city('Sidi Akasah','dz','as-Salif',26673.0,1.3,36.47).
city('Tanas','dz','as-Salif',46301.0,1.31,36.51).
city('Wad Sali','dz','as-Salif',30635.0,1.2,36.1).
city('Wadi al-Fiddah','dz','as-Salif',44713.0,1.52,36.19).
city('as-Salif','dz','as-Salif',154478.0,1.32,36.17).
city('as-Sattiyah','dz','as-Salif',168992.0,1.25,36.18).
city('Ban Mahdi','dz','at-Tarif',28514.0,7.9,36.77).
city('Basbas','dz','at-Tarif',66626.0,7.85,36.7).
city('Dariyan','dz','at-Tarif',55356.0,7.75,36.69).
city('al-Qalah','dz','at-Tarif',35592.0,8.44,36.91).
city('at-Tarif','dz','at-Tarif',27983.0,8.32,36.77).
city('Afono','as','Eastern',527.0,-170.65,-14.26).
city('Alao','as','Eastern',508.0,-170.53,-14.27).
city('Alofau','as','Eastern',465.0,-170.6,-14.3).
city('Amouli','as','Eastern',497.0,-170.57,-14.31).
city('Aoa','as','Eastern',466.0,-170.59,-14.27).
city('Atuu','as','Eastern',376.0,-170.68,-14.28).
city('Aua','as','Eastern',2125.0,-170.66,-14.28).
city('Aunuu','as','Eastern',436.0,-170.55,-14.29).
city('Fagaalu','as','Eastern',1054.0,-170.68,-14.3).
city('Fagaitua','as','Eastern',450.0,-170.61,-14.28).
city('Fagasa','as','Eastern',906.0,-170.76,-14.26).
city('Fagatogo','as','Eastern',1868.0,-170.69,-14.29).
city('Laulii','as','Eastern',906.0,-170.66,-14.31).
city('Leloaloa','as','Eastern',546.0,-170.68,-14.27).
city('Nuuuli','as','Eastern',5304.0,-170.7,-14.33).
city('Pago Pago','as','Eastern',4197.0,-170.72,-14.24).
city('Tula','as','Eastern',370.0,-170.55,-14.23).
city('Utulei','as','Eastern',683.0,-170.68,-14.29).
city('Vatia','as','Eastern',604.0,-170.65,-14.2).
city('Ofu','as','Manua',254.0,-169.68,-14.15).
city('Aoloau','as','Western',967.0,-170.78,-14.29).
city('Faleniu','as','Western',3204.0,-170.74,-14.33).
city('Futiga','as','Western',773.0,-170.76,-14.4).
city('Iliili','as','Western',3093.0,-170.71,-14.39).
city('Leone','as','Western',4051.0,-170.78,-14.34).
city('Malaeimi','as','Western',1261.0,-170.74,-14.31).
city('Malaeloa-Aitulagi','as','Western',633.0,-170.77,-14.34).
city('Malaeloa-Ituau','as','Western',717.0,-170.77,-14.35).
city('Mapusagafou','as','Western',2052.0,-170.75,-14.32).
city('Mesepa','as','Western',553.0,-170.75,-14.33).
city('Pavaiai','as','Western',2613.0,-170.75,-14.34).
city('Tafuna','as','Western',11019.0,-170.72,-14.32).
city('Taputimu','as','Western',741.0,-170.77,-14.36).
city('Vailoatai','as','Western',1144.0,-170.78,-14.39).
city('Vaitogi','as','Western',1436.0,-170.73,-14.39).
city('Andorra la Vella','ad','Andorra la Vella',20430.0,1.51,42.51).
city('Canillo','ad','Canillo',3292.0,1.6,42.57).
city('Encamp','ad','Encamp',11224.0,1.57,42.54).
city('Les Escaldes','ad','Escaldes-Engordany',15854.0,1.53,42.5).
city('La Massana','ad','La Massana',7211.0,1.51,42.55).
city('Ordino','ad','Ordino',2553.0,1.55,42.6).
city('Sant Julia de Loria','ad','Sant Julia de Loria',8020.0,1.5,42.47).
city('Caxito','ao','Bengo',282.0,13.66,-8.58).
city('Benguela','ao','Benguela',151235.0,13.4,-12.58).
city('Lobito','ao','Benguela',207957.0,13.53,-12.36).
city('Camacupa','ao','Bie',19150.0,17.47,-12.02).
city('Catabola','ao','Bie',18858.0,17.28,-12.15).
city('Catumbela','ao','Bie',16980.0,13.55,-12.43).
city('Chissamba','ao','Bie',7677.0,17.33,-12.17).
city('Kuito','ao','Bie',113624.0,16.94,-12.38).
city('Cabinda','ao','Cabinda',66020.0,12.19,-5.55).
city('Ondjiva','ao','Cunene',10169.0,15.73,-17.07).
city('Caala','ao','Huambo',21205.0,15.58,-12.85).
city('Catchiungo','ao','Huambo',8784.0,16.22,-12.56).
city('Huambo','ao','Huambo',226177.0,15.73,-12.76).
city('Longonjo','ao','Huambo',24350.0,15.25,-12.9).
city('Caconda','ao','Huila',10551.0,15.06,-13.73).
city('Caluquembe','ao','Huila',30305.0,14.68,-13.78).
city('Lubango','ao','Huila',102541.0,13.49,-14.91).
city('Menongue','ao','Kuando-Kubango',19141.0,17.65,-14.65).
city('Ndalatando','ao','Kwanza Norte',21236.0,14.91,-9.3).
city('Kibala','ao','Kwanza Sul',8915.0,14.98,-10.73).
city('Sumbe','ao','Kwanza Sul',33278.0,13.85,-11.21).
city('Waku-Kungo','ao','Kwanza Sul',10970.0,15.11,-11.34).
city('Luanda','ao','Luanda',2776125.0,13.24,-8.82).
city('Lucapa','ao','Lunda Norte',20115.0,20.74,-8.42).
city('Saurimo','ao','Lunda Sul',40498.0,20.38,-9.65).
city('Malanje','ao','Malanje',87047.0,16.34,-9.54).
city('Cazaje','ao','Moxico',4764.0,20.71,-11.07).
city('Leua','ao','Moxico',5168.0,20.44,-11.65).
city('Luau','ao','Moxico',18465.0,22.22,-10.7).
city('Luena','ao','Moxico',21115.0,19.9,-11.79).
city('Lumeje','ao','Moxico',4972.0,20.78,-11.55).
city('Namibe','ao','Namibe',80150.0,12.16,-15.17).
city('Camabatela','ao','Uige',12839.0,15.37,-8.19).
city('Uige','ao','Uige',60008.0,15.05,-7.62).
city('Mbanza-Kongo','ao','Zaire',24220.0,14.24,-6.27).
city('Nzeto','ao','Zaire',18354.0,12.86,-7.23).
city('Soyo','ao','Zaire',67553.0,12.37,-6.13).
city('Codrington','ag','Barbuda',682.0,-61.82,17.64).
city('Carlisle','ag','Saint George',831.0,-61.8,17.13).
city('All Saints','ag','Saint John',2526.0,-61.8,17.05).
city('Saint Johns','ag','Saint John',25150.0,-61.85,17.11).
city('Bolands','ag','Saint Mary',1657.0,-62.88,17.06).
city('Old Road','ag','Saint Mary',623.0,-61.84,17.02).
city('English Harbour','ag','Saint Paul',666.0,-61.77,17.02).
city('Liberta','ag','Saint Paul',1668.0,-61.79,17.04).
city('Swetes','ag','Saint Paul',727.0,-61.81,17.03).
city('Parham','ag','Saint Peter',969.0,-61.77,17.11).
city('Freetown','ag','Saint Philip',623.0,-61.0,17.04).
city('Azul','ar','Buenos Aires',52333.0,-59.87,-36.78).
city('Bahia Blanca','ar','Buenos Aires',282950.0,-62.28,-38.72).
city('Buenos Aires','ar','Buenos Aires',1.1548541E7,-58.37,-34.61).
city('Campana','ar','Buenos Aires',83175.0,-58.96,-34.16).
city('Chacabuco','ar','Buenos Aires',34587.0,-60.49,-34.65).
city('Chivilcoy','ar','Buenos Aires',52307.0,-60.04,-34.9).
city('Dolores','ar','Buenos Aires',25190.0,-57.69,-36.33).
city('Junin','ar','Buenos Aires',76369.0,-60.96,-34.59).
city('La Plata','ar','Buenos Aires',684318.0,-57.96,-34.92).
city('Lincoln','ar','Buenos Aires',24798.0,-61.54,-34.88).
city('Lujan','ar','Buenos Aires',74823.0,-59.11,-34.58).
city('Mar del Plata','ar','Buenos Aires',645771.0,-57.58,-38.0).
city('Mercedes','ar','Buenos Aires',49067.0,-59.44,-34.66).
city('Necochea','ar','Buenos Aires',84969.0,-58.75,-38.56).
city('Nueve de Julio','ar','Buenos Aires',34717.0,-60.89,-35.46).
city('Olavarria','ar','Buenos Aires',80005.0,-60.33,-36.9).
city('Pergamino','ar','Buenos Aires',86708.0,-60.57,-33.9).
city('Punta Alta','ar','Buenos Aires',53117.0,-62.08,-38.88).
city('San Nicolas','ar','Buenos Aires',130705.0,-60.24,-33.33).
city('San Pedro','ar','Buenos Aires',67514.0,-59.69,-33.67).
city('San Vicente','ar','Buenos Aires',84333.0,-58.42,-35.03).
city('Tandil','ar','Buenos Aires',100127.0,-59.15,-37.32).
city('Tres Arroyos','ar','Buenos Aires',47143.0,-60.27,-38.37).
city('Veinticinco de Mayo','ar','Buenos Aires',24668.0,-60.18,-35.43).
city('Zarate','ar','Buenos Aires',88222.0,-59.04,-34.09).
city('Catamarca','ar','Catamarca',213601.0,-65.78,-28.47).
city('Presidencia Roque Saenz Pena','ar','Chaco',89584.0,-60.45,-26.79).
city('Resistencia','ar','Chaco',406967.0,-58.99,-27.46).
city('Comodoro Rivadavia','ar','Chubut',142597.0,-67.49,-45.86).
city('Puerto Madryn','ar','Chubut',95547.0,-65.04,-42.77).
city('Rawson','ar','Chubut',26341.0,-65.11,-43.3).
city('Trelew','ar','Chubut',107883.0,-65.33,-43.25).
city('Alta Gracia','ar','Cordoba',40385.0,-64.43,-31.66).
city('Bell Ville','ar','Cordoba',35106.0,-62.68,-32.6).
city('Cordoba','ar','Cordoba',1441007.0,-64.19,-31.4).
city('Rio Cuarto','ar','Cordoba',174058.0,-64.35,-33.13).
city('Rio Tercero','ar','Cordoba',53396.0,-64.12,-32.18).
city('San Francisco','ar','Cordoba',71444.0,-62.09,-31.43).
city('Villa Carlos Paz','ar','Cordoba',61095.0,-64.5,-31.42).
city('Villa Maria','ar','Cordoba',92337.0,-63.26,-32.41).
city('Corrientes','ar','Corrientes',390481.0,-58.81,-27.49).
city('Goya','ar','Corrientes',70340.0,-59.27,-29.14).
city('Mercedes','ar','Corrientes',30649.0,-58.08,-29.18).
city('San Lorenzo','ar','Corrientes',47627.0,-58.77,-28.12).
city('Concepcion del Uruguay','ar','Entre Rios',72904.0,-58.24,-32.48).
city('Concordia','ar','Entre Rios',155686.0,-58.03,-31.39).
city('Gualeguay','ar','Entre Rios',33120.0,-59.34,-33.15).
city('Gualeguaychu','ar','Entre Rios',88218.0,-58.52,-33.02).
city('Parana','ar','Entre Rios',299257.0,-60.52,-31.74).
city('Victoria','ar','Entre Rios',25139.0,-60.18,-32.61).
city('Formosa','ar','Formosa',248756.0,-58.18,-26.18).
city('Jujuy','ar','Jujuy',277150.0,-65.3,-24.19).
city('Libertador General San Martin','ar','Jujuy',49273.0,-64.79,-23.82).
city('San Pedro','ar','Jujuy',43124.0,-64.87,-24.22).
city('General Pico','ar','La Pampa',55900.0,-63.77,-35.66).
city('Santa Rosa','ar','La Pampa',89478.0,-64.3,-36.62).
city('La Rioja','ar','La Rioja',178497.0,-66.85,-29.41).
city('Lujan','ar','Mendoza',77625.0,-68.9,-33.03).
city('Mendoza','ar','Mendoza',973047.0,-68.83,-32.89).
city('Rivadavia','ar','Mendoza',65641.0,-68.47,-33.19).
city('San Martin','ar','Mendoza',107554.0,-68.49,-33.07).
city('San Rafael','ar','Mendoza',125033.0,-68.34,-34.62).
city('Eldorado','ar','Misiones',62823.0,-54.6,-26.2).
city('Obera','ar','Misiones',58939.0,-55.13,-27.48).
city('Posadas','ar','Misiones',313438.0,-55.91,-27.4).
city('Cutral Co','ar','Neuquen',47396.0,-69.24,-38.94).
city('Neuquen','ar','Neuquen',359037.0,-68.06,-38.95).
city('General Roca','ar','Rio Negro',76066.0,-67.61,-39.02).
city('San Carlos de Bariloche','ar','Rio Negro',110044.0,-71.32,-41.14).
city('Viedma','ar','Rio Negro',76553.0,-63.0,-40.81).
city('Salta','ar','Salta',548288.0,-65.41,-24.79).
city('San Ramon de la Nueva Oran','ar','Salta',84504.0,-64.32,-23.14).
city('Tartagal','ar','Salta',63600.0,-63.81,-22.55).
city('San Juan','ar','San Juan',469958.0,-68.53,-31.54).
city('Mercedes','ar','San Luis',126559.0,-65.47,-33.69).
city('San Luis','ar','San Luis',184869.0,-66.35,-33.31).
city('Rio Gallegos','ar','Santa Cruz',93234.0,-69.24,-51.62).
city('Rafaela','ar','Santa Fe',84025.0,-61.5,-31.25).
city('Reconquista','ar','Santa Fe',95979.0,-59.65,-29.14).
city('Rosario','ar','Santa Fe',1218497.0,-60.67,-32.94).
city('Santa Fe','ar','Santa Fe',456044.0,-60.69,-31.6).
city('Venado Tuerto','ar','Santa Fe',71794.0,-61.97,-33.75).
city('Villa Constitucion','ar','Santa Fe',44278.0,-60.35,-33.23).
city('Santiago del Estero','ar','Santiago del Estero',407636.0,-64.28,-27.8).
city('Ushuaia','ar','Tierra del Fuego',58045.0,-68.31,-54.79).
city('Tucuman','ar','Tucuman',828402.0,-65.22,-26.83).
city('Agarak','am','Aragatsotn',1575.0,44.07,40.33).
city('Aghdzk','am','Aragatsotn',1643.0,44.25,40.32).
city('Aparan','am','Aragatsotn',5670.0,44.35,40.6).
city('Aragats','am','Aragatsotn',3900.0,44.29,40.36).
city('Arteni','am','Aragatsotn',3086.0,43.75,40.3).
city('Ashnak','am','Aragatsotn',1131.0,43.92,40.33).
city('Ashtarak','am','Aragatsotn',18779.0,44.35,40.3).
city('Byurakan','am','Aragatsotn',3902.0,44.27,40.34).
city('Hnaberd','am','Aragatsotn',1817.0,44.14,40.64).
city('Karbi','am','Aragatsotn',3521.0,44.38,40.33).
city('Kosh','am','Aragatsotn',2581.0,44.16,40.31).
city('Melikgyugh','am','Aragatsotn',1072.0,44.36,40.67).
city('Nerqin Bazmaberd','am','Aragatsotn',1324.0,44.06,40.35).
city('Ohanavan','am','Aragatsotn',2223.0,44.39,40.34).
city('Oshakan','am','Aragatsotn',4768.0,44.27,40.27).
city('Parpi','am','Aragatsotn',1886.0,44.31,40.33).
city('Quchak','am','Aragatsotn',1864.0,44.39,40.53).
city('Sasunik','am','Aragatsotn',1959.0,44.34,40.25).
city('Shenavan','am','Aragatsotn',1587.0,44.38,40.49).
city('Talin','am','Aragatsotn',4945.0,43.87,40.39).
city('Tsaghkahovit','am','Aragatsotn',1551.0,44.22,40.64).
city('Udjan','am','Aragatsotn',2492.0,44.21,40.3).
city('Ushi','am','Aragatsotn',1276.0,44.37,40.35).
city('Voskevaz','am','Aragatsotn',3789.0,44.3,40.28).
city('Abovyan','am','Ararat',1379.0,44.55,40.05).
city('Aralez','am','Ararat',2354.0,44.65,39.9).
city('Ararat','am','Ararat',13162.0,44.71,39.83).
city('Arbat','am','Ararat',1884.0,44.4,40.14).
city('Arevabuyr','am','Ararat',1041.0,44.47,40.04).
city('Arevshat','am','Ararat',2089.0,44.54,40.04).
city('Argavand','am','Ararat',1703.0,44.44,40.16).
city('Armash','am','Ararat',2434.0,44.81,39.77).
city('Artashat','am','Ararat',20562.0,44.57,39.94).
city('Avshar','am','Ararat',4215.0,44.68,39.84).
city('Aygavan','am','Ararat',3758.0,44.65,39.89).
city('Aygepat','am','Ararat',1349.0,44.6,39.95).
city('Aygestan','am','Ararat',2431.0,44.56,40.0).
city('Aygezard','am','Ararat',3192.0,44.61,39.95).
city('Ayntap','am','Ararat',7299.0,44.47,40.1).
city('Azatavan','am','Ararat',2886.0,44.07,40.13).
city('Baghramyan','am','Ararat',1690.0,43.85,40.19).
city('Bardzrashen','am','Ararat',1273.0,44.58,40.09).
city('Berqanush','am','Ararat',1682.0,44.52,39.98).
city('Burastam','am','Ararat',1998.0,44.5,39.98).
city('Byuravan','am','Ararat',1228.0,44.52,40.02).
city('Dalar','am','Ararat',2504.0,44.54,39.97).
city('Darakert','am','Ararat',2325.0,44.41,40.11).
city('Dashtavan','am','Ararat',1762.0,44.39,40.1).
city('Dimitrov','am','Ararat',1212.0,44.49,40.01).
city('Dvin','am','Ararat',2795.0,44.59,40.02).
city('Geghanist','am','Ararat',2409.0,44.43,40.15).
city('Getapnya','am','Ararat',1191.0,44.43,40.14).
city('Getazat','am','Ararat',1947.0,44.56,40.04).
city('Ghukasavan','am','Ararat',2113.0,44.42,40.13).
city('Goravan','am','Ararat',2238.0,44.73,39.9).
city('Hayanist','am','Ararat',2031.0,44.38,40.12).
city('Hovtashat','am','Ararat',3472.0,44.34,40.1).
city('Hovtashen','am','Ararat',1134.0,44.45,40.02).
city('Jrahovit','am','Ararat',1032.0,44.47,40.05).
city('Jrashen','am','Ararat',1696.0,44.5,40.05).
city('Kaghtsrashen','am','Ararat',2965.0,44.62,39.97).
city('Kanachut','am','Ararat',1182.0,44.54,40.01).
city('Khachpar','am','Ararat',1598.0,44.4,40.13).
city('Landjazat','am','Ararat',1430.0,44.58,40.06).
city('Lusarat','am','Ararat',2195.0,44.6,39.87).
city('Marmarashen','am','Ararat',2946.0,44.47,40.06).
city('Masis','am','Ararat',10168.0,44.46,40.07).
city('Mkhchyan','am','Ararat',4498.0,44.49,40.02).
city('Mrganush','am','Ararat',1032.0,44.56,40.03).
city('Mrgavan','am','Ararat',1713.0,44.53,39.97).
city('Mrgavet','am','Ararat',2131.0,44.48,40.03).
city('Nizami','am','Ararat',1060.0,44.4,40.09).
city('Nor Khaberd','am','Ararat',5730.0,44.48,40.09).
city('Nor Kyanq','am','Ararat',2217.0,44.62,39.9).
city('Norabats','am','Ararat',1973.0,44.43,40.11).
city('Noramarg','am','Ararat',1811.0,44.42,40.02).
city('Norashen','am','Ararat',3049.0,44.6,40.0).
city('Noyakert','am','Ararat',1751.0,44.67,39.82).
city('Nshavan','am','Ararat',1916.0,44.53,40.03).
city('Pokr Vedi','am','Ararat',2910.0,44.61,39.9).
city('Ranchpar','am','Ararat',989.0,44.37,40.03).
city('Sayat-Nova','am','Ararat',1726.0,44.4,40.07).
city('Shahumyan','am','Ararat',3905.0,44.58,39.93).
city('Sis','am','Ararat',1135.0,44.39,40.06).
city('Sisavan','am','Ararat',1793.0,44.67,39.9).
city('Surenavan','am','Ararat',2241.0,44.8,39.75).
city('Taperakan','am','Ararat',3412.0,44.61,39.92).
city('Urtsadzor','am','Ararat',2799.0,44.82,39.91).
city('Vedi','am','Ararat',12192.0,44.73,39.91).
city('Verin Artashat','am','Ararat',3931.0,44.59,40.0).
city('Verin Dvin','am','Ararat',1853.0,44.59,40.03).
city('Vosketap','am','Ararat',4080.0,44.65,39.87).
city('Vostan','am','Ararat',2925.0,44.56,39.96).
city('Yeghegnavan','am','Ararat',1221.0,44.64,39.83).
city('Zangakatun','am','Ararat',1130.0,45.05,39.81).
city('Zorak','am','Ararat',1390.0,44.39,40.09).
city('Aghavnatun','am','Armavir',2913.0,44.25,40.23).
city('Aknalich','am','Armavir',2654.0,44.15,40.14).
city('Aknashen','am','Armavir',1362.0,44.29,40.1).
city('Amberd','am','Armavir',1267.0,44.27,40.24).
city('Apaga','am','Armavir',1634.0,44.25,40.1).
city('Aragats','am','Armavir',2952.0,43.67,40.33).
city('Araks','am','Armavir',1442.0,44.3,40.07).
city('Aratashen','am','Armavir',2669.0,44.43,40.13).
city('Arazap','am','Armavir',1373.0,44.15,40.04).
city('Arevashat','am','Armavir',1403.0,44.37,40.14).
city('Arevik','am','Armavir',2455.0,44.1,40.1).
city('Argavand','am','Armavir',2047.0,44.1,40.06).
city('Armavir','am','Armavir',14359.0,44.05,40.12).
city('Arshaluys','am','Armavir',3808.0,44.21,40.17).
city('Artimet','am','Armavir',1501.0,44.27,40.15).
city('Aygek','am','Armavir',1095.0,44.38,40.19).
city('Aygeshat','am','Armavir',1482.0,44.18,40.15).
city('Baghramyan','am','Armavir',2346.0,44.37,40.19).
city('Bambakashat','am','Armavir',3089.0,44.01,40.11).
city('Dalarik','am','Armavir',3080.0,43.86,40.22).
city('Doghs','am','Armavir',1186.0,44.27,40.22).
city('Gay','am','Armavir',3309.0,44.31,40.08).
city('Getashen','am','Armavir',2114.0,43.94,40.04).
city('Griboyedov','am','Armavir',1879.0,44.27,40.11).
city('Hatsik','am','Armavir',2355.0,43.94,40.16).
city('Haykashen','am','Armavir',1140.0,44.31,40.07).
city('Haykavan','am','Armavir',1201.0,43.77,40.76).
city('Haytagh','am','Armavir',2423.0,44.23,40.18).
city('Hoktember','am','Armavir',5348.0,44.01,40.14).
city('Hovtamech','am','Armavir',1018.0,44.26,40.18).
city('Janfida','am','Armavir',2986.0,44.02,40.05).
city('Jrarat','am','Armavir',2608.0,44.26,44.07).
city('Karakert','am','Armavir',3413.0,43.81,40.24).
city('Khoronk','am','Armavir',2148.0,44.24,40.14).
city('Lenughi','am','Armavir',1499.0,43.97,40.12).
city('Lernagog','am','Armavir',1664.0,44.12,40.35).
city('Lukashin','am','Armavir',2197.0,44.02,40.18).
city('Margara','am','Armavir',1360.0,44.17,40.03).
city('Merdzavan','am','Armavir',2702.0,44.4,40.18).
city('Metsamor','am','Armavir',4935.0,44.21,40.11).
city('Mrgashat','am','Armavir',4961.0,44.08,40.13).
city('Musaler','am','Armavir',2323.0,44.38,40.15).
city('Myasnikyan','am','Armavir',3458.0,43.91,40.18).
city('Nalbandyan','am','Armavir',4019.0,43.98,40.06).
city('Nor Armavir','am','Armavir',1597.0,43.99,40.09).
city('Nor Kesaria','am','Armavir',1279.0,44.45,40.18).
city('Norakert','am','Armavir',2485.0,44.35,40.19).
city('Parakar','am','Armavir',4781.0,44.41,40.16).
city('Pshatavan','am','Armavir',2159.0,44.07,40.04).
city('Ptghunk','am','Armavir',1345.0,44.36,40.16).
city('Samaghar','am','Armavir',2343.0,44.24,40.19).
city('Shenavan','am','Armavir',1757.0,43.93,40.05).
city('Sovetakan','am','Armavir',1613.0,44.06,40.11).
city('Tairov','am','Armavir',2076.0,44.42,40.16).
city('Tandzut','am','Armavir',1816.0,44.09,40.08).
city('Taronik','am','Armavir',1874.0,44.2,40.13).
city('Tsaghkalandj','am','Armavir',1216.0,44.23,40.2).
city('Tsaghkunk','am','Armavir',1089.0,44.27,40.18).
city('Tsiatsan','am','Armavir',1050.0,44.27,40.19).
city('Vagharshapat','am','Armavir',49514.0,44.29,40.16).
city('Voskehat','am','Armavir',2181.0,44.33,40.14).
city('Yeghegnut','am','Armavir',1746.0,44.16,40.09).
city('Yeraskhahun','am','Armavir',1346.0,44.22,40.07).
city('Zartonk','am','Armavir',1818.0,44.16,40.11).
city('Zhdanov','am','Armavir',1512.0,44.09,40.16).
city('Akunk','am','Gegharkunik',3444.0,45.72,40.15).
city('Artsvanist','am','Gegharkunik',2819.0,45.5,40.15).
city('Astghadzor','am','Gegharkunik',3520.0,45.36,40.12).
city('Aygut','am','Gegharkunik',997.0,45.17,40.69).
city('Chambarak','am','Gegharkunik',6153.0,45.35,40.6).
city('Ddmashen','am','Gegharkunik',2157.0,44.0,40.57).
city('Drakhtik','am','Gegharkunik',1016.0,45.23,40.57).
city('Dzoragyukh','am','Gegharkunik',3570.0,45.18,40.18).
city('Gagarin','am','Gegharkunik',1305.0,44.86,40.54).
city('Gandzak','am','Gegharkunik',3841.0,45.11,40.31).
city('Gavar','am','Gegharkunik',21681.0,45.14,40.33).
city('Geghamasar','am','Gegharkunik',1060.0,45.68,40.31).
city('Geghamavan','am','Gegharkunik',1597.0,44.88,40.56).
city('Gegharkunik','am','Gegharkunik',1681.0,45.14,40.26).
city('Geghhovit','am','Gegharkunik',5104.0,45.28,40.1).
city('Karchaghbyur','am','Gegharkunik',2274.0,45.57,40.16).
city('Karmirgyukh','am','Gegharkunik',5069.0,45.14,40.34).
city('Khachaghbyur','am','Gegharkunik',1137.0,45.69,40.17).
city('Lanjaghbyur','am','Gegharkunik',2097.0,45.14,40.27).
city('Lchap','am','Gegharkunik',1032.0,45.07,40.46).
city('Lchashen','am','Gegharkunik',4182.0,44.93,40.52).
city('Lichk','am','Gegharkunik',4105.0,45.23,40.16).
city('Madina','am','Gegharkunik',1024.0,45.25,40.08).
city('Martuni','am','Gegharkunik',11037.0,45.32,40.14).
city('Mets Masrik','am','Gegharkunik',2570.0,45.75,40.22).
city('Nerkin Getashen','am','Gegharkunik',7010.0,45.26,40.15).
city('Noratus','am','Gegharkunik',5426.0,45.18,40.38).
city('Sarukhan','am','Gegharkunik',6173.0,45.13,40.29).
city('Sevan','am','Gegharkunik',17083.0,44.95,40.55).
city('Sotk','am','Gegharkunik',1045.0,45.86,40.2).
city('Tazagyukh','am','Gegharkunik',2248.0,45.19,40.14).
city('Tsakqar','am','Gegharkunik',2125.0,45.2,40.17).
city('Tsovagyugh','am','Gegharkunik',3857.0,44.95,40.63).
city('Tsovak','am','Gegharkunik',2531.0,45.64,40.18).
city('Tsovazard','am','Gegharkunik',1949.0,45.04,40.48).
city('Tsovinar','am','Gegharkunik',3968.0,45.46,40.16).
city('Ttujur','am','Gegharkunik',1046.0,45.31,40.65).
city('Vaghashen','am','Gegharkunik',3235.0,45.33,40.14).
city('Vahan','am','Gegharkunik',1153.0,45.4,40.57).
city('Vardadzor','am','Gegharkunik',2095.0,45.19,40.19).
city('Vardenik','am','Gegharkunik',7709.0,45.44,40.14).
city('Vardenis','am','Gegharkunik',11382.0,45.72,40.18).
city('Varser','am','Gegharkunik',1614.0,44.91,40.56).
city('Verin Getashen','am','Gegharkunik',4173.0,45.25,40.13).
city('Yeranus','am','Gegharkunik',4233.0,45.19,40.21).
city('Zolakar','am','Gegharkunik',5679.0,45.38,40.13).
city('Zovaber','am','Gegharkunik',1470.0,44.79,40.57).
city('Abovyan','am','Kotayk',35677.0,44.62,40.27).
city('Aghavnadzor','am','Kotayk',1252.0,44.69,40.58).
city('Akunk','am','Kotayk',1787.0,44.68,40.27).
city('Alapars','am','Kotayk',2337.0,44.63,40.43).
city('Aragyukh','am','Kotayk',999.0,44.54,40.4).
city('Aramus','am','Kotayk',3214.0,44.66,40.25).
city('Argel','am','Kotayk',2528.0,44.6,40.38).
city('Arinj','am','Kotayk',5181.0,44.57,40.23).
city('Arzakan','am','Kotayk',2660.0,44.61,40.45).
city('Arzni','am','Kotayk',2244.0,44.6,40.31).
city('Balahovit','am','Kotayk',2982.0,44.6,40.25).
city('Bjini','am','Kotayk',2771.0,44.65,40.46).
city('Buzhakan','am','Kotayk',1678.0,44.52,40.46).
city('Byureghavan','am','Kotayk',6972.0,44.59,40.31).
city('Charentsavan','am','Kotayk',17620.0,44.6,40.35).
city('Dzoraghbyur','am','Kotayk',2011.0,44.64,40.21).
city('Fantan','am','Kotayk',1019.0,44.69,40.39).
city('Garni','am','Kotayk',6827.0,44.72,40.12).
city('Geghashen','am','Kotayk',3666.0,44.64,40.41).
city('Goght','am','Kotayk',1877.0,44.78,40.14).
city('Hrazdan','am','Kotayk',40796.0,44.75,40.5).
city('Jrvesh','am','Kotayk',5358.0,44.59,40.19).
city('Kaghsi','am','Kotayk',2180.0,44.74,40.48).
city('Kamaris','am','Kotayk',2064.0,44.69,40.24).
city('Kanakeravan','am','Kotayk',2950.0,44.54,40.25).
city('Kaputan','am','Kotayk',1252.0,44.69,40.32).
city('Kasakh','am','Kotayk',4247.0,44.42,40.53).
city('Kotayk','am','Kotayk',1510.0,44.66,40.28).
city('Lernanist','am','Kotayk',2511.0,44.8,40.47).
city('Mayakovski','am','Kotayk',1727.0,44.64,40.25).
city('Meghradzor','am','Kotayk',2659.0,44.65,40.61).
city('Mrgashen','am','Kotayk',1623.0,44.54,40.29).
city('Nor Geghi','am','Kotayk',4896.0,44.58,40.32).
city('Nor Gyukh','am','Kotayk',1462.0,44.66,40.27).
city('Nor Hachn','am','Kotayk',9390.0,44.58,40.3).
city('Nor Yerznka','am','Kotayk',1459.0,44.4,40.31).
city('Proshyan','am','Kotayk',4333.0,44.42,40.25).
city('Ptghni','am','Kotayk',1231.0,44.59,40.26).
city('Solak','am','Kotayk',2295.0,44.71,40.46).
city('Tsaghkadzor','am','Kotayk',1408.0,44.75,40.55).
city('Yeghvard','am','Kotayk',10705.0,44.48,40.32).
city('Zar','am','Kotayk',1340.0,44.74,40.26).
city('Zoravan','am','Kotayk',1167.0,44.52,40.36).
city('Zovuni','am','Kotayk',4484.0,44.43,40.51).
city('Agarak','am','Lori',1278.0,44.47,41.01).
city('Akhtala','am','Lori',1990.0,44.77,41.15).
city('Alaverdi','am','Lori',13186.0,44.65,41.13).
city('Aqori','am','Lori',2272.0,44.62,41.1).
city('Arevashogh','am','Lori',2435.0,44.27,40.86).
city('Bazum','am','Lori',1114.0,44.45,40.87).
city('Chochkan','am','Lori',1740.0,44.83,41.19).
city('Darpas','am','Lori',1785.0,44.42,40.84).
city('Dsegh','am','Lori',2484.0,44.65,40.96).
city('Fioletovo','am','Lori',1264.0,44.71,40.72).
city('Gargar','am','Lori',1398.0,44.44,40.96).
city('Gogaran','am','Lori',1088.0,44.2,40.9).
city('Gugark','am','Lori',4705.0,44.54,40.81).
city('Gyulagarak','am','Lori',2109.0,44.49,40.97).
city('Hartagyukh','am','Lori',1165.0,44.05,40.84).
city('Jrashen','am','Lori',3078.0,44.2,40.79).
city('Katnajur','am','Lori',1677.0,44.14,40.83).
city('Kurtan','am','Lori',2005.0,44.57,40.96).
city('Lernahovit','am','Lori',1403.0,44.31,41.17).
city('Lernantsk','am','Lori',1192.0,44.27,40.78).
city('Lernapat','am','Lori',1710.0,44.4,40.82).
city('Lernavan','am','Lori',1517.0,44.18,40.79).
city('Lorut','am','Lori',1101.0,44.77,40.94).
city('Margahovit','am','Lori',3308.0,44.69,40.74).
city('Mets Parni','am','Lori',1934.0,44.11,40.84).
city('Metsavan','am','Lori',4767.0,44.23,41.2).
city('Norashen','am','Lori',1386.0,44.33,41.19).
city('Odzun','am','Lori',4524.0,44.61,41.05).
city('Sarahart','am','Lori',1364.0,44.21,40.87).
city('Saramech','am','Lori',1111.0,44.22,40.77).
city('Sarchapet','am','Lori',1942.0,44.39,41.2).
city('Shahumyan','am','Lori',1843.0,44.53,40.79).
city('Shirakamut','am','Lori',2008.0,44.15,40.86).
city('Shnogh','am','Lori',2872.0,44.84,41.15).
city('Spitak','am','Lori',15063.0,44.27,40.84).
city('Stepanavan','am','Lori',15923.0,44.39,41.01).
city('Tashir','am','Lori',7318.0,44.28,41.12).
city('Tsaghkaber','am','Lori',1207.0,44.11,40.8).
city('Tumanyan','am','Lori',1693.0,44.66,40.99).
city('Urut','am','Lori',1102.0,44.4,41.07).
city('Vahagni','am','Lori',1184.0,44.61,40.91).
city('Vanadzor','am','Lori',101099.0,44.49,40.8).
city('Vardablur','am','Lori',1297.0,44.51,40.97).
city('Yeghegnut','am','Lori',1154.0,44.63,40.9).
city('Akhuryan','am','Shirak',7672.0,43.9,40.78).
city('Amasia','am','Shirak',1675.0,43.78,40.95).
city('Anushavan','am','Shirak',1532.0,43.98,40.64).
city('Arapi','am','Shirak',1738.0,43.8,40.78).
city('Arevik','am','Shirak',1522.0,43.89,40.74).
city('Arevshat','am','Shirak',1623.0,44.04,40.65).
city('Artik','am','Shirak',14580.0,43.97,40.62).
city('Ashotsk','am','Shirak',2161.0,43.86,41.04).
city('Azatan','am','Shirak',4448.0,43.82,40.72).
city('Dzitankov','am','Shirak',1162.0,43.81,40.52).
city('Gyumri','am','Shirak',148383.0,43.83,40.78).
city('Harich','am','Shirak',984.0,44.01,40.6).
city('Hatsik','am','Shirak',1039.0,43.87,40.85).
city('Haykavan','am','Shirak',1184.0,45.1,40.43).
city('Horom','am','Shirak',1893.0,43.88,40.65).
city('Kamo','am','Shirak',1340.0,43.95,40.83).
city('Lernakert','am','Shirak',1306.0,43.94,40.57).
city('Maisyan','am','Shirak',1521.0,43.83,40.85).
city('Maralik','am','Shirak',4959.0,43.87,40.58).
city('Marmashen','am','Shirak',1644.0,43.77,40.84).
city('Meghrashen','am','Shirak',1107.0,43.95,40.68).
city('Mets Mantash','am','Shirak',1973.0,44.05,40.64).
city('Musayelyan','am','Shirak',1499.0,43.99,40.77).
city('Nor Kyanq','am','Shirak',1242.0,43.92,40.65).
city('Panik','am','Shirak',2273.0,43.94,40.66).
city('Pemzashen','am','Shirak',2436.0,43.94,40.59).
city('Pokr Mantash','am','Shirak',1838.0,44.05,40.65).
city('Saralanj','am','Shirak',1014.0,44.02,40.63).
city('Saratak','am','Shirak',1115.0,43.87,40.67).
city('Sarnaghbyur','am','Shirak',2542.0,45.15,40.07).
city('Shirak','am','Shirak',1007.0,43.92,40.85).
city('Spandaryan','am','Shirak',1226.0,44.02,40.67).
city('Voskehask','am','Shirak',1803.0,43.78,40.74).
city('Yerazgavors','am','Shirak',1285.0,43.77,40.7).
city('Agarak','am','Syunik',4707.0,46.55,39.22).
city('Angeghakot','am','Syunik',1726.0,45.94,39.57).
city('Brnakot','am','Syunik',1912.0,45.97,39.5).
city('Brun','am','Syunik',1028.0,46.3,39.53).
city('Goris','am','Syunik',20379.0,46.33,39.51).
city('Kajaran','am','Syunik',8275.0,46.15,39.15).
city('Kapan','am','Syunik',33161.0,46.4,39.2).
city('Karahunj','am','Syunik',1173.0,46.36,39.48).
city('Karnidzor','am','Syunik',1039.0,46.55,39.53).
city('Khndzoresk','am','Syunik',1940.0,46.43,39.51).
city('Meghri','am','Syunik',4540.0,46.26,38.9).
city('Shaghat','am','Syunik',1011.0,45.91,39.56).
city('Shaki','am','Syunik',1228.0,46.0,39.56).
city('Shinuhayr','am','Syunik',2206.0,46.32,39.43).
city('Sisian','am','Syunik',15208.0,45.98,39.47).
city('Tegh','am','Syunik',2120.0,46.48,39.55).
city('Verishen','am','Syunik',2114.0,46.31,39.54).
city('Achajur','am','Tavush',3873.0,45.15,40.99).
city('Archis','am','Tavush',1235.0,44.87,41.16).
city('Artsvaberd','am','Tavush',3193.0,45.47,40.83).
city('Aygedzor','am','Tavush',2535.0,46.42,39.47).
city('Aygehovit','am','Tavush',2888.0,45.25,40.97).
city('Ayrum','am','Tavush',2174.0,44.9,41.2).
city('Azatamut','am','Tavush',1850.0,45.2,40.98).
city('Bagratashen','am','Tavush',3024.0,44.82,41.25).
city('Berd','am','Tavush',8374.0,45.39,40.88).
city('Berdavan','am','Tavush',3150.0,45.0,41.2).
city('Chinari','am','Tavush',1157.0,45.57,40.85).
city('Dilijan','am','Tavush',13480.0,44.87,40.75).
city('Dzoratan','am','Tavush',1034.0,46.36,39.27).
city('Gandzakar','am','Tavush',3221.0,45.16,40.84).
city('Getahovit','am','Tavush',2005.0,45.13,40.9).
city('Gosh','am','Tavush',994.0,45.0,40.72).
city('Haghartsin','am','Tavush',3370.0,44.96,40.78).
city('Haghtanak','am','Tavush',1117.0,44.94,41.22).
city('Ijevan','am','Tavush',14737.0,45.14,40.88).
city('Khashtarak','am','Tavush',1728.0,45.18,40.94).
city('Koghbi','am','Tavush',4357.0,44.97,41.18).
city('Koti','am','Tavush',2082.0,45.13,41.14).
city('Mosesgegh','am','Tavush',1964.0,45.49,40.91).
city('Navur','am','Tavush',1227.0,45.32,40.86).
city('Noyemberyan','am','Tavush',5119.0,44.99,41.17).
city('Paravakar','am','Tavush',1637.0,45.4,40.98).
city('Sarigyukh','am','Tavush',1096.0,45.15,41.06).
city('Sevkar','am','Tavush',2089.0,45.14,41.02).
city('Teghut','am','Tavush',1198.0,44.94,40.78).
city('Tovuz','am','Tavush',1549.0,45.4,40.91).
city('Verin Karmir Aghbyur','am','Tavush',1865.0,45.44,40.88).
city('Voskevan','am','Tavush',1287.0,45.07,41.12).
city('Agarakadzor','am','Vayots Dzor',1195.0,45.35,39.74).
city('Aghavnadzor','am','Vayots Dzor',1925.0,45.23,39.78).
city('Areni','am','Vayots Dzor',1718.0,45.18,39.72).
city('Arpi','am','Vayots Dzor',1053.0,45.26,39.74).
city('Artabuynk','am','Vayots Dzor',1045.0,45.35,39.86).
city('Getap','am','Vayots Dzor',1842.0,45.31,39.76).
city('Gladzor','am','Vayots Dzor',2080.0,45.35,39.78).
city('Jermuk','am','Vayots Dzor',4582.0,45.67,39.84).
city('Kechut','am','Vayots Dzor',997.0,45.66,39.8).
city('Malishka','am','Vayots Dzor',4174.0,45.39,39.74).
city('Rind','am','Vayots Dzor',1368.0,45.18,39.76).
city('Shatin','am','Vayots Dzor',1671.0,45.3,39.83).
city('Vayk','am','Vayots Dzor',5419.0,45.47,39.69).
city('Vernashen','am','Vayots Dzor',1162.0,45.36,39.79).
city('Yegheknadzor','am','Vayots Dzor',7668.0,45.33,39.75).
city('Yelpin','am','Vayots Dzor',1305.0,45.11,39.81).
city('Zaritap','am','Vayots Dzor',1323.0,45.51,39.64).
city('Yerevan','am','Yerevan',1093499.0,44.52,40.17).
city('Canberra','au','Australian Capital Territory',324025.0,149.13,-35.31).
city('Albury','au','New South Wales',104261.0,146.92,-36.06).
city('Armidale','au','New South Wales',22673.0,151.66,-30.51).
city('Ballina','au','New South Wales',14248.0,153.56,-28.86).
city('Batemans Bay','au','New South Wales',10557.0,150.19,-35.7).
city('Bathurst-Orange','au','New South Wales',27882.0,149.57,-33.42).
city('Bowral','au','New South Wales',9605.0,150.4,-34.5).
city('Broken Hill','au','New South Wales',17395.0,141.44,-31.95).
city('Byron Bay','au','New South Wales',6764.0,153.61,-28.66).
city('Camden Haven','au','New South Wales',6425.0,150.7,-34.07).
city('Casino','au','New South Wales',9539.0,153.04,-28.87).
city('Cessnock','au','New South Wales',16394.0,151.36,-32.83).
city('Coffs Harbour','au','New South Wales',62978.0,153.12,-30.3).
city('Cooma','au','New South Wales',6520.0,149.12,-36.24).
city('Cootamundra','au','New South Wales',4934.0,148.01,-34.65).
city('Corowa','au','New South Wales',5179.0,146.38,-36.0).
city('Cowra','au','New South Wales',6799.0,148.68,-33.83).
city('Deniliquin','au','New South Wales',8024.0,144.95,-35.53).
city('Dubbo','au','New South Wales',29362.0,148.6,-32.25).
city('Forbes','au','New South Wales',4838.0,148.0,-33.39).
city('Forster-Tuncurry','au','New South Wales',17591.0,152.52,-32.19).
city('Glenn Innes','au','New South Wales',6732.0,151.74,-29.74).
city('Goulburn','au','New South Wales',20941.0,149.71,-34.75).
city('Grafton','au','New South Wales',16399.0,152.94,-29.71).
city('Griffith','au','New South Wales',15456.0,14.0,-34.29).
city('Gunnedah','au','New South Wales',7148.0,150.26,-30.98).
city('Inverell','au','New South Wales',8561.0,151.11,-29.77).
city('Katoomba-Wentworth Falls','au','New South Wales',18593.0,150.32,-33.71).
city('Kempsey','au','New South Wales',9522.0,152.83,-31.08).
city('Kiama','au','New South Wales',10380.0,150.84,-34.71).
city('Kurri Kurri','au','New South Wales',10991.0,151.46,-32.82).
city('Lawson-Hazelbrook','au','New South Wales',10598.0,150.43,-33.72).
city('Leeton','au','New South Wales',7299.0,146.4,-34.55).
city('Lemon Tree Passage','au','New South Wales',5865.0,152.01,-32.77).
city('Lismore','au','New South Wales',31433.0,153.29,-28.81).
city('Lithgow','au','New South Wales',11129.0,150.14,-33.49).
city('Medowie','au','New South Wales',5841.0,151.86,-32.74).
city('Mittagong','au','New South Wales',6717.0,150.43,-34.45).
city('Moree','au','New South Wales',8205.0,149.84,-29.47).
city('Moss Vale','au','New South Wales',6739.0,150.37,-34.55).
city('Mudgee','au','New South Wales',9042.0,149.58,-32.59).
city('Murwillumbah','au','New South Wales',6868.0,153.4,-28.33).
city('Muswellbrook','au','New South Wales',11630.0,150.89,-32.27).
city('Nambucca Heads','au','New South Wales',6899.0,152.98,-30.6).
city('Narrabri','au','New South Wales',7082.0,149.78,-30.33).
city('Nelson Bay','au','New South Wales',7725.0,152.15,-32.72).
city('Newcastle','au','New South Wales',497961.0,151.75,-32.92).
city('Orange','au','New South Wales',30402.0,149.1,-33.28).
city('Parkes','au','New South Wales',11137.0,148.17,-33.13).
city('Port Macquarie','au','New South Wales',48553.0,152.91,-31.44).
city('Queanbeyan','au','New South Wales',32249.0,149.22,-35.35).
city('Raymond Terrace','au','New South Wales',13606.0,151.84,-32.8).
city('Richmond-Windsor','au','New South Wales',18347.0,150.74,-33.6).
city('Sawtell','au','New South Wales',14608.0,153.09,-30.37).
city('Shoalhaven','au','New South Wales',94782.0,150.59,-34.88).
city('Singleton','au','New South Wales',13813.0,151.16,-32.57).
city('Sydney','au','New South Wales',4394585.0,151.21,-33.87).
city('Tamworth','au','New South Wales',38552.0,150.92,-31.1).
city('Taree','au','New South Wales',44183.0,152.47,-31.9).
city('Tumut','au','New South Wales',6526.0,148.22,-35.31).
city('Ulladulla','au','New South Wales',9250.0,150.47,-35.35).
city('Wagga Wagga','au','New South Wales',55382.0,147.35,-35.12).
city('Wangi-Rathmines','au','New South Wales',8944.0,151.6,-33.03).
city('Wellington','au','New South Wales',5428.0,148.95,-32.56).
city('Wollongong','au','New South Wales',260918.0,150.87,-34.42).
city('Young','au','New South Wales',7501.0,148.29,-34.31).
city('Alice Springs','au','Northern Territory',26188.0,133.87,-23.7).
city('Alyangula','au','Northern Territory',1289.0,136.42,-13.83).
city('Coonawarra','au','Northern Territory',945.0,130.88,-12.38).
city('Darwin','au','Northern Territory',93081.0,130.85,-12.43).
city('Galiwinku','au','Northern Territory',1347.0,135.56,-11.98).
city('Howard Springs','au','Northern Territory',3359.0,131.04,-12.47).
city('Humpty Doo-MacMinns Lagoon','au','Northern Territory',5025.0,131.05,-12.53).
city('Jabiru','au','Northern Territory',1892.0,132.88,-12.67).
city('Katherine','au','Northern Territory',10142.0,132.26,-14.47).
city('Maningrida','au','Northern Territory',1391.0,134.08,-12.07).
city('Milingimbi','au','Northern Territory',986.0,134.91,-12.1).
city('Nguiu','au','Northern Territory',1250.0,130.63,-11.76).
city('Ngukurr','au','Northern Territory',947.0,134.56,-14.68).
city('Nhulunbuy','au','Northern Territory',3202.0,136.76,-12.19).
city('Palmerston','au','Northern Territory',31075.0,130.9,-12.4).
city('Port Keats','au','Northern Territory',1351.0,129.54,-14.25).
city('Tennant Creek','au','Northern Territory',3889.0,134.18,-19.65).
city('Yulara','au','Northern Territory',3903.0,131.06,-25.23).
city('Atherton','au','Queensland',6959.0,145.47,-17.26).
city('Ayr','au','Queensland',9079.0,147.4,-19.57).
city('Biloela','au','Queensland',6309.0,150.51,-24.4).
city('Blackwater','au','Queensland',7250.0,148.88,-23.58).
city('Bongaree','au','Queensland',13649.0,153.16,-27.09).
city('Bowen','au','Queensland',10983.0,148.21,-20.0).
city('Brisbane','au','Queensland',1843459.0,153.02,-27.46).
city('Buderim','au','Queensland',15228.0,153.05,-26.68).
city('Bundaberg','au','Queensland',52478.0,152.35,-24.87).
city('Burpengary','au','Queensland',8280.0,152.95,-27.17).
city('Caboolture','au','Queensland',21478.0,152.95,-27.09).
city('Cairns','au','Queensland',154318.0,145.75,-16.92).
city('Cairns Northern Beaches','au','Queensland',18052.0,145.7,-16.84).
city('Caloundra','au','Queensland',38714.0,153.13,-26.81).
city('Charters Towers','au','Queensland',9574.0,146.25,-20.08).
city('Coolum Beach','au','Queensland',8555.0,153.07,-26.5).
city('Dalby','au','Queensland',9848.0,151.26,-27.19).
city('Deception Bay','au','Queensland',16090.0,153.02,-27.2).
city('Emerald','au','Queensland',9399.0,148.16,-23.52).
city('Gatton','au','Queensland',6513.0,152.28,-27.56).
city('Gladstone','au','Queensland',30493.0,151.25,-23.85).
city('Gold Coast','au','Queensland',501175.0,153.44,-28.07).
city('Gympie','au','Queensland',11029.0,152.67,-26.19).
city('Helensvale','au','Queensland',16897.0,145.23,-15.71).
city('Hervey Bay','au','Queensland',47561.0,152.84,-25.29).
city('Ingham','au','Queensland',6127.0,146.15,-18.65).
city('Innisfail','au','Queensland',10144.0,146.03,-17.53).
city('Kawana Waters','au','Queensland',19881.0,153.13,-26.76).
city('Kingaroy','au','Queensland',8573.0,151.84,-26.54).
city('Mackay','au','Queensland',75924.0,149.18,-21.14).
city('Mareeba','au','Queensland',8403.0,145.42,-16.98).
city('Maroochydore-Mooloolaba','au','Queensland',44502.0,153.12,-26.68).
city('Maryborough','au','Queensland',20680.0,152.72,-25.54).
city('Moranbah','au','Queensland',7955.0,148.04,-22.0).
city('Morayfield','au','Queensland',10261.0,152.95,-27.11).
city('Mount Isa','au','Queensland',22564.0,139.48,-20.73).
city('Nambour','au','Queensland',14919.0,152.97,-26.63).
city('Nerang','au','Queensland',17684.0,153.33,-27.99).
city('Rockhampton','au','Queensland',65851.0,150.51,-23.37).
city('Roma','au','Queensland',5497.0,148.78,-26.57).
city('Sunshine C','au','Queensland',311430.0,152.56,-25.88).
city('Tewantin-Noosa','au','Queensland',32799.0,153.03,-26.39).
city('Toowoomba','au','Queensland',92802.0,151.96,-27.56).
city('Townsville','au','Queensland',138959.0,146.78,-19.26).
city('Victoria Point','au','Queensland',11930.0,153.3,-27.58).
city('Warwick','au','Queensland',12347.0,152.03,-28.22).
city('Yeppoon','au','Queensland',10769.0,150.74,-23.13).
city('Adelaide','au','South Australia',1074168.0,138.6,-34.93).
city('Crafers-Bridgewater','au','South Australia',14717.0,138.7,-35.0).
city('Gawler','au','South Australia',16362.0,138.73,-34.61).
city('Mount Barker','au','South Australia',8357.0,138.84,-35.07).
city('Mount Gambier','au','South Australia',23210.0,140.77,-37.84).
city('Murray Bridge','au','South Australia',11356.0,139.26,-35.13).
city('Port Augusta','au','South Australia',12133.0,137.77,-32.49).
city('Port Lincoln','au','South Australia',11247.0,135.85,-34.72).
city('Port Pirie','au','South Australia',12328.0,137.98,-33.19).
city('Victor Harbor','au','South Australia',7760.0,138.62,-35.55).
city('Whyalla','au','South Australia',19646.0,137.57,-33.03).
city('Br','au','Tasmania',7790.0,147.22,-42.74).
city('Burnie','au','Tasmania',19976.0,145.89,-41.06).
city('Devonport','au','Tasmania',19318.0,146.33,-41.2).
city('Hobart','au','Tasmania',204863.0,147.29,-42.85).
city('Kingston-Blackmans Bay','au','Tasmania',14371.0,147.31,-42.99).
city('Launceston','au','Tasmania',72462.0,147.13,-41.45).
city('New Norfolk','au','Tasmania',5526.0,147.05,-42.78).
city('Ulverstone','au','Tasmania',9605.0,146.16,-41.16).
city('Ararat','au','Victoria',6111.0,142.93,-37.28).
city('Baccus Marsh','au','Victoria',13576.0,144.43,-37.67).
city('Bairnsdale','au','Victoria',11006.0,147.61,-37.83).
city('Ballarat','au','Victoria',85110.0,143.84,-37.56).
city('Benalla','au','Victoria',9020.0,145.97,-36.55).
city('Bendigo','au','Victoria',81658.0,144.28,-36.76).
city('Castlemaine','au','Victoria',6604.0,144.21,-37.07).
city('Clifton Springs','au','Victoria',7413.0,144.57,-38.15).
city('Colac','au','Victoria',9089.0,143.58,-38.34).
city('Craigieburn','au','Victoria',19728.0,144.93,-37.6).
city('Cranbourne','au','Victoria',39420.0,145.27,-38.11).
city('Crib Point','au','Victoria',6908.0,145.02,-38.38).
city('Echuca-Moama','au','Victoria',19458.0,144.75,-36.13).
city('Geelong','au','Victoria',150438.0,144.32,-38.14).
city('Hamilton','au','Victoria',8869.0,142.02,-37.73).
city('Hastings','au','Victoria',6583.0,145.19,-38.31).
city('Healesville','au','Victoria',7098.0,145.52,-37.66).
city('Horsham','au','Victoria',12830.0,142.19,-36.71).
city('Kyabram','au','Victoria',6396.0,145.05,-36.32).
city('Lakes Entrance','au','Victoria',5849.0,147.99,-37.88).
city('Lara','au','Victoria',8179.0,144.41,-38.03).
city('Leopold','au','Victoria',6120.0,144.46,-38.18).
city('Maryborough','au','Victoria',7046.0,143.73,-37.05).
city('Melbourne','au','Victoria',3730212.0,144.96,-37.81).
city('Melton','au','Victoria',32369.0,144.57,-37.69).
city('Mildura','au','Victoria',47867.0,142.16,-34.19).
city('Moe-Yallourn','au','Victoria',12948.0,146.25,-38.18).
city('Morwell','au','Victoria',11585.0,146.4,-38.23).
city('Ocean Grove-Barwon Heads','au','Victoria',13619.0,144.52,-38.25).
city('Pakenham','au','Victoria',10602.0,145.4,-38.06).
city('Portland','au','Victoria',8842.0,141.59,-38.34).
city('Sale','au','Victoria',12917.0,147.06,-38.11).
city('Shepparton-Mooroopna','au','Victoria',33551.0,145.4,-36.37).
city('Somerville','au','Victoria',7015.0,145.17,-38.22).
city('Stawell','au','Victoria',6991.0,142.76,-37.06).
city('Sunbury','au','Victoria',29926.0,144.71,-37.57).
city('Swan Hill','au','Victoria',9276.0,143.54,-35.34).
city('Torquay','au','Victoria',6670.0,152.87,-25.28).
city('Traralgon','au','Victoria',18226.0,146.53,-38.2).
city('Wangaratta','au','Victoria',14023.0,146.3,-36.36).
city('Warragul','au','Victoria',9128.0,145.93,-38.16).
city('Warrnambool','au','Victoria',29928.0,142.47,-38.38).
city('Wodonga','au','Victoria',31518.0,146.88,-36.13).
city('Wonthaggi','au','Victoria',5985.0,145.59,-38.61).
city('Yarrawonga-Mulwala','au','Victoria',5604.0,146.0,-36.02).
city('Albany','au','Western Australia',23913.0,117.88,-35.02).
city('Australind','au','Western Australia',6621.0,115.7,-33.31).
city('Broome','au','Western Australia',13218.0,122.23,-17.96).
city('Bunbury','au','Western Australia',26370.0,115.65,-33.35).
city('Busselton','au','Western Australia',12374.0,115.35,-33.66).
city('Carnarvon','au','Western Australia',7392.0,113.64,-24.89).
city('Collie','au','Western Australia',6337.0,116.15,-33.36).
city('Esperance','au','Western Australia',7889.0,121.89,-33.86).
city('Geraldton','au','Western Australia',27259.0,114.59,-28.77).
city('Kalgoorlie-Boulder','au','Western Australia',36852.0,121.46,-30.74).
city('Karratha','au','Western Australia',11694.0,116.87,-20.73).
city('Kununurra','au','Western',5679.0,128.73,-15.76).
city('Kwinana','au','Western Australia',20087.0,115.77,-32.25).
city('Mandurah','au','Western Australia',73369.0,115.75,-32.53).
city('Northam','au','Western Australia',5858.0,116.66,-31.66).
city('Perth','au','Western Australia',1446715.0,115.84,-31.96).
city('Port Hedland','au','Western Australia',14289.0,118.6,-20.31).
city('Roebourne','au','Western Australia',19264.0,117.13,-20.77).
city('Eisenstadt','at','Burgenland',11767.0,16.7,47.91).
city('Grosspetersdorf','at','Burgenland',3525.0,16.31,47.24).
city('Jennersdorf','at','Bur',4319.0,16.13,46.94).
city('Mattersburg','at','Burgenland',6448.0,16.39,47.73).
city('Neudoerfl','at','Burgenland',4183.0,16.3,47.8).
city('Neusiedl am See','at','Burgenland',5949.0,16.84,47.95).
city('Oberwart','at','Burgenland',6879.0,16.2,47.29).
city('Pinkafeld','at','Burgenland',5257.0,16.12,47.37).
city('Rust','at','Burgenland',1726.0,16.66,47.8).
city('Althofen','at','Kaernten',4833.0,14.23,47.15).
city('Arnoldstein','at','Kaernten',6923.0,13.71,46.55).
city('Bad Sankt Leonhard','at','Kaernten',4775.0,14.79,46.97).
city('Ebenthal','at','Kaernten',7809.0,14.34,46.61).
city('Eberndorf','at','Kaernten',6089.0,14.63,46.59).
city('Feldkirchen','at','Kaernten',14440.0,14.08,46.73).
city('Ferlach','at','Kaernten',7661.0,14.3,46.53).
city('Finkenstein','at','Kaernten',8406.0,13.86,46.58).
city('Friesach','at','Kaernten',5369.0,14.4,46.95).
city('Hermagor','at','Kaernten',7242.0,13.36,46.62).
city('Klagenfurt','at','Kaernten',90610.0,14.31,46.62).
city('Moosburg','at','Kaernten',4602.0,14.17,46.66).
city('Paternion','at','Kaernten',6301.0,13.63,46.72).
city('Radentheim','at','Kaernten',6559.0,13.71,46.8).
city('Sankt Andrae','at','Kaernten',10825.0,14.81,46.76).
city('Sankt Jakob','at','Kaernten',4481.0,14.07,46.55).
city('Sankt Veit','at','Kaernten',13116.0,14.35,46.77).
city('Seeboden','at','Kaernten',6221.0,13.5,46.82).
city('Spittal','at','Kaernten',16363.0,13.5,46.8).
city('Velden am Woerthersee','at','Kaernten',8817.0,14.05,46.62).
city('Villach','at','Kaernten',58882.0,13.85,46.62).
city('Voelkermarkt','at','Kaernten',11543.0,14.63,46.66).
city('Wernberg','at','Kaernten',5070.0,13.93,46.62).
city('Wolfsberg','at','Kaernten',25610.0,14.85,46.85).
city('Amstetten','at','Niederoesterreich',22832.0,14.86,48.13).
city('Bad Voeslau','at','Niederoesterreich',11013.0,16.22,47.97).
city('Baden','at','Niederoesterreich',24893.0,16.24,48.01).
city('Berndorf','at','Niederoesterreich',8796.0,16.11,47.95).
city('Bruck an der Leitha','at','Niederoesterreich',7339.0,16.78,48.02).
city('Deutsch-Wagram','at','Niederoesterreich',7153.0,16.57,48.3).
city('Ebreichsdorf','at','Niederoesterre',9509.0,16.4,47.95).
city('Fischamend','at','Niederoesterreich',4471.0,16.6,48.12).
city('Gaenserndorf','at','Niederoesterreich',8588.0,16.75,48.34).
city('Gerasdorf','at','Niederoesterreich',8948.0,16.47,48.3).
city('Gloggnitz','at','Niederoesterreich',6213.0,15.93,47.67).
city('Gmuend','at','Niederoesterreich',5811.0,14.99,48.77).
city('Gross-Enzersdorf','at','Niederoesterreich',8791.0,16.55,48.2).
city('Guntramsdorf','at','Niederoesterreich',9071.0,16.33,48.07).
city('Haag','at','Niederoesterreich',5164.0,15.49,48.15).
city('Hainburg','at','Niederoesterreich',5622.0,16.94,48.15).
city('Heidenreichstein','at','Niederoesterreich',4472.0,15.11,48.87).
city('Herzogenburg','at','Niederoesterreich',7866.0,15.68,48.27).
city('Himberg','at','Niederoesterreich',5534.0,16.43,48.08).
city('Hollabrunn','at','Niederoesterreich',10966.0,16.09,48.56).
city('Horn','at','Niederoesterreich',6485.0,15.65,48.67).
city('Klosterneuburg','at','Niederoesterreich',24843.0,16.31,48.31).
city('Korneuburg','at','Niederoesterreich',11498.0,16.35,48.35).
city('Kottingbrunn','at','Niederoesterreich',7184.0,16.21,47.95).
city('Krems','at','Niederoeste',24092.0,15.59,48.42).
city('Laa','at','Niederoesterreich',6084.0,16.39,48.72).
city('Langenlois','at','Niederoesterreich',7081.0,15.66,48.47).
city('Langenzersdorf','at','Niederoesterreich',7733.0,16.35,48.3).
city('Maria Enzersdorf','at','Niederoesterreich',8085.0,16.29,48.11).
city('Melk','at','Niederoesterreich',5272.0,15.32,48.22).
city('Mistelbach','at','Niederoesterreich',10820.0,16.57,48.57).
city('Moedling','at','Niederoesterreich',20710.0,16.3,48.1).
city('Neulengbach','at','Niederoesterreich',7521.0,15.97,48.18).
city('Neunkirchen','at','Niederoest',11313.0,16.08,47.72).
city('Perchtoldsdorf','at','Niederoesterreich',14041.0,16.28,48.11).
city('Pottendorf','at','Niederoesterreich',6105.0,16.4,47.92).
city('Poysdorf','at','Niederoesterreich',5653.0,16.63,48.67).
city('Pressbaum','at','Niederoesterreich',6083.0,16.08,48.19).
city('Purgstall','at','Niederoesterreich',5247.0,15.13,48.05).
city('Purkersdorf','at','Niederoesterreich',8327.0,16.18,48.22).
city('Reichenau','at','Niederoesterreich',2673.0,15.83,47.7).
city('Retz','at','Niederoesterreich',4139.0,15.95,48.76).
city('Sankt Andrae-Woerdern','at','Niederoesterreich',6886.0,16.22,48.34).
city('Sankt Poelten','at','Niederoesterreich',49000.0,15.61,48.21).
city('Sankt Valentin','at','Niederoesterreich',9063.0,14.51,48.17).
city('Schrems','at','Niederoesterreich',5811.0,15.07,48.79).
city('Schwechat','at','Niederoesterreich',15711.0,16.5,48.14).
city('Stockerau','at','Niederoesterreich',14831.0,16.23,48.39).
city('Strasshof','at','Niederoesterreich',7637.0,16.69,48.33).
city('Ternitz','at','Niederoesterreich',15153.0,16.03,47.72).
city('Traiskirchen','at','Niederoesterreich',16212.0,16.3,48.02).
city('Traismauer','at','Niederoesterreich',5815.0,15.75,48.35).
city('Tulln','at','Niederoesterreich',14201.0,16.06,48.33).
city('Waidhofen','at','Niederoesterreich',8806.0,15.04,48.39).
city('Wiener Neudorf','at','Niederoesterreich',8530.0,16.33,48.08).
city('Wiener Neustadt','at','Niederoesterreich',38481.0,16.24,47.82).
city('Wilhelmsburg','at','Niederoesterreich',6718.0,15.6,48.1).
city('Wolkersdorf','at','Niederoesterreich',6416.0,16.53,48.39).
city('Ybbs','at','Niederoesterreich',5676.0,15.07,48.18).
city('Zistersdorf','at','Niederoesterreich',5661.0,16.76,48.54).
city('Zwettl','at','Niederoesterreich',11718.0,15.17,48.61).
city('Altmuenster','at','Oberoesterreich',9652.0,13.75,47.9).
city('Ansfelden','at','Oberoesterreich',14936.0,14.3,48.22).
city('Asten','at','Oberoesterreich',6517.0,14.41,48.23).
city('Bad Goisern','at','Oberoesterreich',7869.0,13.61,47.64).
city('Bad Hall','at','Oberoesterreich',4935.0,14.2,48.03).
city('Bad Ischl','at','Oberoesterreich',14267.0,13.61,47.72).
city('Braunau','at','Oberoesterreich',16403.0,13.04,48.26).
city('Ebensee','at','Oberoesterreich',8376.0,13.76,47.8).
city('Engerwitzdorf','at','Oberoesterre',8510.0,14.45,48.35).
city('Enns','at','Oberoesterreich',10816.0,14.48,48.22).
city('Feldkirchen an der Donau','at','Oberoesterreich',5286.0,14.05,48.35).
city('Frankenburg','at','Oberoesterreich',5162.0,13.49,48.07).
city('Freistadt','at','Oberoesterreich',7574.0,14.5,48.52).
city('Gallneukirchen','at','Oberoesterreich',6282.0,14.41,48.36).
city('Garsten','at','Oberoesterreich',6657.0,14.4,48.02).
city('Gmunden','at','Oberoesterreich',13287.0,13.81,47.92).
city('Grieskirchen','at','Oberoesterreich',4766.0,13.83,48.23).
city('Hoersching','at','Oberoesterreich',5312.0,14.17,48.23).
city('Kremsmuenster','at','Oberoesterreich',6626.0,14.12,48.05).
city('Laakirchen','at','Oberoesterreich',9569.0,13.82,47.98).
city('Lenzing','at','Oberoesterreich',5044.0,13.63,47.98).
city('Leonding','at','Oberoesterreich',22736.0,14.23,48.28).
city('Linz','at','Oberoesterreich',181163.0,14.29,48.31).
city('Marchtrenk','at','Oberoesterreich',11666.0,14.11,48.19).
city('Micheldorf','at','Oberoesterreich',5902.0,14.14,47.88).
city('Pasching','at','Oberoesterreich',6143.0,14.2,48.27).
city('Perg','at','Oberoesterreich',7644.0,14.62,48.25).
city('Regau','at','Oberoesterreich',5556.0,13.69,47.99).
city('Ried','at','Oberoesterreich',11511.0,13.48,48.21).
city('Sankt Florian','at','Oberoesterreich',5760.0,13.13,48.17).
city('Sankt Georgen','at','Oberoesterreich',4180.0,13.49,47.94).
city('Schaerding','at','Oberoesterreich',4919.0,13.44,48.46).
city('Scharnstein','at','Oberoesterreich',4631.0,13.97,47.9).
city('Seewalchen','at','Oberoesterreich',4959.0,13.6,47.95).
city('Sierning','at','Oberoesterreich',8722.0,14.3,48.04).
city('Steyr','at','Oberoesterreich',39567.0,14.41,48.04).
city('Steyregg','at','Oberoesterreich',4856.0,14.39,48.29).
city('Timelkam','at','Oberoesterreich',5855.0,13.6,48.01).
city('Traun','at','Oberoesterreich',23959.0,14.24,48.23).
city('Voecklabruck','at','Oberoesterreich',11887.0,13.66,48.01).
city('Voecklamarkt','at','Oberoesterreich',4869.0,13.48,48.0).
city('Vorchdorf','at','Oberoesterreich',7456.0,13.92,48.0).
city('Wels','at','Oberoesterreich',57947.0,14.03,48.17).
city('Abtenau','at','Salzburg',5829.0,13.35,47.55).
city('Anif','at','Salzburg',4154.0,13.06,47.75).
city('Bad Gastein','at','Salzburg',5947.0,13.13,47.12).
city('Bad Hofgastein','at','Salzburg',7002.0,13.1,47.17).
city('Bergheim','at','Salzburg',5031.0,13.02,47.84).
city('Bischofshofen','at','Salzburg',10145.0,13.21,47.42).
city('Bruck an der Grossglocknerstrasse','at','Salzburg',4649.0,12.82,47.3).
city('Groedig','at','Salzburg',6918.0,13.03,47.73).
city('Hallein','at','Salzburg',18980.0,13.11,47.68).
city('Kuchl','at','Salzburg',6668.0,13.14,47.63).
city('Mittersill','at','Salzburg',5680.0,12.48,47.27).
city('Oberndorf','at','Salzburg',5738.0,13.33,48.25).
city('Radstadt','at','Salzburg',4926.0,13.45,47.39).
city('Saalfelden','at','Salzburg',16119.0,12.85,47.44).
city('Salzburg','at','Salzburg',145310.0,13.04,47.81).
city('Sankt Johann im Pongau','at','Salzburg',10887.0,13.21,47.35).
city('Seekirchen','at','Salzburg',9865.0,13.13,47.9).
city('Sieghartskirchen','at','Salzburg',7062.0,16.0,48.25).
city('Strasswalchen','at','Salzburg',7145.0,13.26,48.0).
city('Tamsweg','at','Salzburg',6126.0,13.8,47.14).
city('Thalgau','at','Salz',5501.0,13.25,47.84).
city('Wals-Siezenheim','at','Salzburg',11771.0,12.97,47.79).
city('Zell am See','at','Salzburg',10046.0,12.78,47.32).
city('Bad Aussee','at','Steiermark',5210.0,13.78,47.6).
city('Baernbach','at','Steiermark',4850.0,15.85,47.03).
city('Bruck an der Mur','at','Steiermark',13254.0,15.27,47.42).
city('Deutschlandsberg','at','Steiermark',8049.0,15.21,46.82).
city('Eisenerz','at','Steiermark',5987.0,14.89,47.54).
city('Feldbach','at','Steiermark',4877.0,15.89,46.96).
city('Fohnsdorf','at','Steiermark',8203.0,14.66,47.21).
city('Frohnleiten','at','Steiermark',6629.0,15.32,47.27).
city('Fuerstenfeld','at','Steiermark',5962.0,16.07,47.05).
city('Gleisdorf','at','Steiermark',5245.0,15.71,47.11).
city('Gratkorn','at','Steiermark',6806.0,15.35,47.13).
city('Graz','at','Steiermark',222326.0,15.42,47.08).
city('Judenburg','at','Steiermark',9992.0,14.66,47.17).
city('Kapfenberg','at','Steiermark',21819.0,15.29,47.45).
city('Kindberg','at','Steiermark',5790.0,15.46,47.52).
city('Knittelfeld','at','Steiermark',12704.0,14.83,47.22).
city('Koeflach','at','Steiermark',10447.0,15.07,47.06).
city('Krieglach','at','Steiermark',5236.0,15.57,47.55).
city('Leibnitz','at','Steiermark',7029.0,15.56,46.78).
city('Leoben','at','Steiermark',24809.0,15.09,47.38).
city('Liezen','at','Steiermark',6903.0,14.24,47.57).
city('Muerzzuschlag','at','Steiermark',9410.0,15.67,47.6).
city('Rottenmann','at','Steiermark',5561.0,14.35,47.52).
city('Schladming','at','Steiermark',4659.0,13.7,47.4).
city('Trofaiach','at','Steiermark',8313.0,14.99,47.42).
city('Voitsberg','at','Steiermark',9980.0,15.15,47.04).
city('Weiz','at','Steiermark',9128.0,15.62,47.22).
city('Zeltweg','at','Steiermark',7726.0,14.75,47.19).
city('Absam','at','Tirol',6594.0,11.5,47.3).
city('Axams','at','Tirol',5560.0,11.39,47.21).
city('Ebbs','at','Tirol',5088.0,12.22,47.63).
city('Fuegen','at','Tirol',3734.0,11.85,47.35).
city('Hall','at','Tirol',11197.0,14.44,47.6).
city('Hopfgarten','at','Tirol',5314.0,12.16,47.46).
city('Imst','at','Tirol',9225.0,10.73,47.25).
city('Innsbruck','at','Tirol',112467.0,11.41,47.28).
city('Jenbach','at','Tirol',6806.0,11.75,47.39).
city('Kirchbichl','at','Tirol',5115.0,12.08,47.52).
city('Kitzbuehel','at','Tirol',8818.0,12.38,47.45).
city('Kufstein','at','Tirol',16116.0,12.19,47.62).
city('Landeck','at','Tirol',7351.0,10.56,47.14).
city('Lienz','at','Tirol',12270.0,12.76,46.83).
city('Matrei','at','Tirol',5076.0,12.54,47.0).
city('Reutte','at','Tirol',5851.0,10.72,47.49).
city('Rum','at','Tirol',8498.0,11.46,47.29).
city('Sankt Johann in Tirol','at','Tirol',8315.0,14.47,46.64).
city('Schwaz','at','Tirol',12507.0,11.73,47.34).
city('Telfs','at','Tirol',14028.0,11.07,47.3).
city('Voels','at','Tirol',6573.0,11.33,47.25).
city('Vomp','at','Tirol',4628.0,11.68,47.35).
city('Wattens','at','Tirol',7517.0,11.59,47.29).
city('Woergl','at','Tirol',11265.0,12.08,47.49).
city('Zirl','at','Tirol',6567.0,11.23,47.29).
city('Altach','at','Vorarlberg',6040.0,9.65,47.35).
city('Bludenz','at','Vorarlberg',13904.0,9.82,47.16).
city('Bregenz','at','Vorarlberg',26928.0,9.73,47.51).
city('Dornbirn','at','Vorarlberg',43013.0,9.74,47.42).
city('Feldkirch','at','Vorarlberg',29446.0,9.59,47.25).
city('Frastanz','at','Vorarlberg',6360.0,9.62,47.21).
city('Goetzis','at','Vorarlberg',10342.0,9.63,47.33).
city('Hard','at','Vorarlberg',11766.0,9.68,47.48).
city('Hoechst','at','Vorarlberg',7207.0,9.63,47.47).
city('Hoerbranz','at','Vorarlberg',6414.0,9.75,47.55).
city('Hohenems','at','Vor',14072.0,9.68,47.37).
city('Lauterach','at','Vorarlberg',9212.0,9.73,47.48).
city('Lochau','at','Vorarlberg',5209.0,9.76,47.53).
city('Lustenau','at','Vorarlberg',20218.0,9.66,47.44).
city('Mittelberg','at','Vorarlberg',4627.0,9.65,47.2).
city('Nenzing','at','Vorarlberg',5856.0,9.7,47.18).
city('Nueziders','at','Vorarlberg',4628.0,9.8,47.18).
city('Rankweil','at','Vorarlberg',11455.0,9.65,47.28).
city('Schruns','at','Vorarlberg',3506.0,9.91,47.09).
city('Wolfurt','at','Vorarlberg',8110.0,9.75,47.47).
city('Vienna','at','Wien',1569315.0,16.37,48.22).
city('Balaxani','az','Abseron',10863.0,49.91,40.47).
city('Ceyranbatan','az','Abseron',5684.0,49.66,40.54).
city('Diqex','az','Abseron',3211.0,49.87,40.49).
city('Guezdak','az','Abseron',2462.0,49.68,40.37).
city('Hoekmeli','az','Abseron',4389.0,49.74,40.43).
city('Kirovskiy','az','Abseron',34488.0,49.78,40.44).
city('Qobu','az','Abseron',7377.0,49.71,40.4).
city('Resulzade','az','Abseron',44735.0,49.83,40.43).
city('Saray','az','Abseron',10173.0,49.72,40.53).
city('Agcabedi','az','Agcabedi',34989.0,47.44,40.05).
city('Agdam','az','Agdam',39451.0,46.92,39.99).
city('Agdas','az','Agdas',23528.0,47.46,40.65).
city('Leki','az','Agdas',3891.0,47.43,40.56).
city('Turyancay','az','Agdas',307.0,47.54,40.71).
city('Agstafa','az','Agstafa',12542.0,45.45,41.11).
city('Vurgun','az','Agstafa',2635.0,45.48,41.1).
city('Agsu','az','Agsu',17209.0,48.39,40.57).
city('Astara','az','Astara',15190.0,48.85,38.4).
city('Kijaba','az','Astara',4567.0,48.82,38.53).
city('Babek','az','Babek',3312.0,45.4,39.12).
city('Artyom','az','Baki',13435.0,50.33,40.47).
city('Badamdar','az','Baki',11398.0,49.8,40.34).
city('Bakixanov','az','Baki',66686.0,49.93,40.41).
city('Baku','az','Baki',1116513.0,49.86,40.39).
city('Bileceri','az','Baki',42194.0,49.8,40.43).
city('Bilqex','az','Baki',8983.0,50.03,40.57).
city('Bine','az','Baki',24596.0,50.08,40.45).
city('Bineqedi','az','Baki',14012.0,49.82,40.47).
city('Buelbuele','az','Baki',16386.0,49.97,40.43).
city('Buzovna','az','Baki',24795.0,50.12,40.52).
city('Ceyildag','az','Baki',1018.0,49.27,40.29).
city('Cilov','az','Baki',814.0,50.59,40.33).
city('Ehmedli','az','Baki',7206.0,49.96,40.38).
city('Elet','az','Baki',12298.0,49.4,39.94).
city('Emircan','az','Baki',26798.0,49.98,40.43).
city('Guergan','az','Baki',712.0,50.33,40.4).
city('Hoevsan','az','Baki',36293.0,50.08,40.39).
city('Kesla','az','Baki',17913.0,49.9,40.4).
city('Korgoez','az','Baki',2036.0,49.62,40.3).
city('Kuerdexani','az','Baki',4987.0,49.92,40.55).
city('Loekbatan','az','Baki',30694.0,49.73,40.32).
city('Mastaga','az','Baki',40092.0,49.99,40.54).
city('Merdekan','az','Baki',14997.0,50.14,40.49).
city('Nardaran','az','Baki',7700.0,50.01,40.56).
city('Neft Daslari','az','Baki',916.0,50.58,40.32).
city('Pirsagi','az','Baki',5102.0,49.89,40.56).
city('Puta','az','Baki',1018.0,49.68,40.31).
city('Qala','az','Baki',2709.0,50.18,40.44).
city('Qaracuxur','az','Baki',72989.0,49.96,40.42).
city('Qizil Das','az','Baki',4173.0,49.6,40.31).
city('Qobustan','az','Baki',13398.0,49.4,40.09).
city('Ramana','az','Baki',8855.0,49.98,40.44).
city('Sabuncu','az','Baki',20996.0,49.95,40.44).
city('Sengecal','az','Baki',3664.0,49.46,40.17).
city('Sonqar','az','Baki',730.0,49.6,40.32).
city('Suevelan','az','Baki',15267.0,50.16,40.49).
city('Tuerkan','az','Ba',9699.0,50.22,40.36).
city('Xocasan','az','Baki',5089.0,49.77,40.41).
city('Yeni Suraxani','az','Baki',14603.0,50.1,40.43).
city('Zabrat','az','Baki',21396.0,49.95,40.49).
city('Zig','az','Baki',6001.0,49.98,40.37).
city('Zire','az','Baki',10099.0,50.28,40.37).
city('Balaken','az','Balaken',9182.0,46.39,41.73).
city('Qabaqcoel','az','Balaken',1293.0,46.28,41.71).
city('Berde','az','Berde',37372.0,47.11,40.39).
city('Araz','az','Beyleqan',229.0,47.57,39.57).
city('Beyleqan','az','Beyleqan',14307.0,47.59,39.77).
city('Qehremanli','az','Beyleqan',1557.0,47.71,39.63).
city('Pushkino','az','Bilesuvar',18182.0,48.54,39.45).
city('Cebrayil','az','Cebrayil',8396.0,47.03,39.39).
city('Daskesen','az','Cebrayil',421.0,47.11,39.43).
city('Celilabad','az','Celilabad',36258.0,48.49,39.21).
city('Goeytepe','az','Celilabad',13340.0,48.6,39.12).
city('Culfa','az','Culfa',10820.0,45.64,38.96).
city('Alunitdag','az','Daskesen',857.0,46.05,40.55).
city('Daskesen','az','Daskesen',9595.0,46.07,40.45).
city('Quscu','az','Daskesen',408.0,46.09,40.56).
city('Yuxari','az','Daskesen',1837.0,46.08,40.49).
city('Deveci','az','Deveci',21565.0,48.98,41.21).
city('Eli Bayramli','az','Eli Bayramli',70220.0,48.91,39.93).
city('Haciqehremenli','az','Eli Bayramli',2247.0,48.92,39.88).
city('Fuezuli','az','Fuezuli',26582.0,48.15,39.6).
city('Horadiz','az','Fuezuli',2714.0,47.34,39.45).
city('Gedebey','az','Gedebey',8657.0,45.78,40.57).
city('Gence','az','Gence',303268.0,46.35,40.68).
city('Hacikand','az','Gence',504.0,46.33,40.51).
city('Goeycay','az','Goeycay',35348.0,47.73,40.66).
city('Asagi Agcakend','az','Goranboy',204.0,46.57,40.42).
city('Delimemmedli','az','Goranboy',4747.0,46.56,40.69).
city('Goranboy','az','Goranboy',7334.0,46.8,40.62).
city('Qazanbulaq','az','Goranboy',980.0,46.65,40.65).
city('Qizilhacili','az','Goranboy',6330.0,46.84,40.58).
city('Mugan','az','Haciqabul',4410.0,48.82,40.1).
city('Qazi Memmed','az','Haciqabul',23102.0,48.93,40.04).
city('Behremtepe','az','Imisli',4307.0,47.95,39.74).
city('Imisli','az','Imisli',31381.0,48.05,39.87).
city('Basqal','az','Ismayilli',1234.0,48.4,40.75).
city('Ismayilli','az','Ismayilli',13610.0,48.15,40.79).
city('Lahic','az','Ismayilli',925.0,48.4,40.85).
city('Istisu','az','Kelbecer',929.0,45.95,39.97).
city('Kelbecer','az','Kelbecer',8470.0,46.03,40.11).
city('Kuerdemir','az','Kuerdemir',18001.0,48.14,40.35).
city('Lacin','az','Lacin',11344.0,46.53,39.6).
city('Asagi Nuevedi','az','Lenkeran',2951.0,48.86,38.72).
city('Germatuek','az','Lenkeran',4071.0,48.85,38.72).
city('Haftoni','az','Lenkeran',2003.0,48.77,38.76).
city('Lenkeran','az','Lenkeran',48964.0,48.84,38.75).
city('Liman','az','Lenkeran',9923.0,48.8,38.88).
city('Nerimanabad','az','Lenkeran',4603.0,48.84,38.87).
city('Lerik','az','Lerik',7094.0,48.42,38.78).
city('Boradiqex','az','Masalli',5904.0,48.69,38.93).
city('Masalli','az','Masalli',9603.0,48.66,39.02).
city('Mingecevir','az','Mingecevir',95454.0,47.04,40.77).
city('Naft','az','Naftalan',7045.0,46.82,40.52).
city('Naxcivan','az','Naxcivan',64754.0,45.41,39.22).
city('Banke','az','Neftcala',7075.0,49.25,39.42).
city('Hasanabad','az','Neftcala',4308.0,49.21,39.32).
city('Neftcala','az','Neftcala',18661.0,49.25,39.35).
city('Xilli','az','Neftcala',3896.0,49.11,39.43).
city('Oguz','az','Oguz',6808.0,46.86,41.75).
city('Ordubad','az','Ordubad',9781.0,46.01,38.9).
city('Paraqacay','az','Ordubad',102.0,45.94,39.1).
city('Qax','az','Qax',11993.0,46.93,41.42).
city('Qazax','az','Qazax',18904.0,45.35,41.1).
city('Qebele','az','Qebele',11867.0,47.84,40.98).
city('Mereze','az','Qobustan',3754.0,48.91,40.54).
city('Qonaqkend','az','Quba',1533.0,48.61,41.07).
city('Quba','az','Quba',22405.0,48.5,41.37).
city('Qubadli','az','Qubadli',6890.0,46.58,39.34).
city('Qusar','az','Qusar',16022.0,48.42,41.42).
city('Samur','az','Qusar',1760.0,48.43,41.63).
city('Saatli','az','Saatli',17243.0,48.38,39.9).
city('Sabirabad','az','Sabirabad',28076.0,48.48,40.0).
city('Sahbuz','az','Sahbuz',2674.0,45.57,39.41).
city('Qaracala','az','Salyan',4211.0,48.93,39.81).
city('Salyan','az','Salyan',36555.0,48.96,39.59).
city('Medrese','az','Samaxi',2375.0,48.56,40.61).
city('Samaxi','az','Samaxi',29403.0,48.63,40.64).
city('Institut','az','Samux',1214.0,46.41,40.73).
city('Nebiagali','az','Samux',5666.0,46.41,40.77).
city('Qarayeri','az','Samux',5565.0,46.32,40.79).
city('Sederek','az','Sederek',1853.0,44.86,39.7).
city('Seki','az','Seki',62191.0,47.17,41.2).
city('Turan','az','Seki',1658.0,47.11,41.33).
city('Cinarli','az','Semkir',6508.0,46.91,41.48).
city('Kuer','az','Semkir',6708.0,46.07,40.99).
city('Semkir','az','Semkir',35421.0,46.01,40.83).
city('Zeyem','az','Semkir',7442.0,45.92,40.9).
city('Serur','az','Serur',6546.0,45.05,39.56).
city('Gil-Gil Cay','az','Siyezen',1197.0,49.09,41.14).
city('Siyezen','az','Siyezen',22401.0,49.1,41.08).
city('Corat','az','Sumqayit',8624.0,49.71,40.57).
city('Haci Zeynalabdin Tagiyev','az','Sumqayit',19019.0,49.54,40.63).
city('Sumqayit','az','Sumqayit',265150.0,49.64,40.59).
city('Susa','az','Susa',18663.0,46.75,39.76).
city('Agdere','az','Terter',10167.0,46.8,40.22).
city('Sixarx','az','Terter',304.0,46.88,40.33).
city('Terter','az','Terter',18185.0,46.93,40.34).
city('Qovlar','az','Tovuz',12819.0,45.81,40.93).
city('Tovuz','az','Tovuz',12626.0,45.62,40.99).
city('Ucar','az','Ucar',15741.0,47.64,40.52).
city('Muxtedir','az','Xacmaz',2464.0,48.78,41.66).
city('Sollar','az','Xacmaz',205.0,48.67,41.64).
city('Xacmaz','az','Xacmaz',37175.0,48.8,41.47).
city('Xudat','az','Xacmaz',13625.0,48.68,41.64).
city('Kerkicahan','az','Xankendi',1703.0,46.75,39.8).
city('Xankendi','az','Xankendi',52996.0,46.75,39.82).
city('Xanlar','az','Xanlar',17816.0,46.32,40.58).
city('Altiagac','az','Xizi',1126.0,48.94,40.88).
city('Gilazi','az','Xizi',3277.0,49.34,40.87).
city('Suraabad','az','Xizi',1945.0,49.47,40.82).
city('Xizi','az','Xizi',1024.0,49.07,40.91).
city('Esgeran','az','Xocali',1639.0,46.83,39.94).
city('Xocali','az','Xocali',5810.0,46.79,39.91).
city('Hadrut','az','Xocavend',2523.0,47.03,39.52).
city('Qirmizi Bazar','az','Xocavend',1211.0,46.95,39.68).
city('Xocavend','az','Xocavend',5079.0,47.11,39.79).
city('Yardimli','az','Yardimli',4004.0,48.24,38.92).
city('Aran','az','Yevlax',6724.0,46.98,40.63).
city('Yevlax','az','Yevlax',53715.0,47.14,40.62).
city('Eliabad','az','Zaqatala',9103.0,46.59,41.49).
city('Zaqatala','az','Zaqatala',18277.0,46.64,41.64).
city('Mincivan','az','Zengilan',6353.0,46.72,39.03).
city('Zengilen','az','Zengilan',7483.0,46.66,39.08).
city('Beyimli','az','Zerdab',830.0,47.82,40.26).
city('Zerdab','az','Zerdab',10612.0,47.71,40.22).
city('Coopers Town','bs','Abaco',8414.0,-77.52,26.87).
city('Marsh Harbour','bs','Abaco',5314.0,-77.05,26.55).
city('Snug Corner','bs','Acklins Island',407.0,-73.88,22.56).
city('Andros Town','bs','Andros',2456.0,-77.77,24.7).
city('Nicholls Town','bs','Andros',270.0,-78.01,25.14).
city('Great Harbour','bs','Berry Islands',377.0,-77.85,25.76).
city('Alice Town','bs','Biminis',950.0,-79.3,25.74).
city('Arthurs Town','bs','Cat Island',1272.0,-75.73,24.66).
city('Albert Town','bs','Crooked Island',25.0,-74.35,22.6).
city('Colonel Hill','bs','Crooked Island',240.0,-74.22,22.77).
city('Dunmore Town','bs','Eleuthera',1523.0,-76.63,25.5).
city('Freetown','bs','Eleuthera',4074.0,-76.27,24.77).
city('Rock Sound','bs','Eleuthera',1396.0,-76.2,24.9).
city('George Town','bs','Exuma and Cays',1071.0,-75.78,23.52).
city('Freeport','bs','Grand Bahama',46535.0,-78.64,26.54).
city('High Rock','bs','Grand Bahama',3744.0,-78.28,26.63).
city('Sweeting Cay','bs','Grand Bahama',483.0,-77.88,26.6).
city('Matthew Town','bs','Inagua Islands',452.0,-73.68,20.96).
city('Clarence Town','bs','Long Island',1751.0,-74.98,23.1).
city('Pirates Well','bs','Mayaguana',217.0,-73.08,22.43).
city('Nassau','bs','New Providence',227936.0,-77.33,25.06).
city('Duncan Town','bs','Ragged Island',70.0,-75.73,22.19).
city('Port Nelson','bs','Rum Cay',91.0,-74.83,23.66).
city('Cockburn Town','bs','San Salvador',831.0,-74.52,24.03).
city('Isa','bh','Isa',38089.0,50.55,26.17).
city('Jidhafs','bh','Jidhafs',31735.0,50.53,26.22).
city('Madinat Hamad','bh','Madinat Hamad',65467.0,50.51,26.11).
city('Manama','bh','Manama',147097.0,50.58,26.21).
city('Sitrah','bh','Sitrah',37690.0,50.63,26.15).
city('al-Malikiyah','bh','al-Garbiyah',14573.0,50.48,26.11).
city('al-Hidd','bh','al-Hidd',12797.0,50.65,26.25).
city('al-Mu','bh','al-Muharraq',97458.0,50.62,26.26).
city('Ali','bh','al-Wusta',55052.0,50.53,26.15).
city('ar-Rifaa','bh','ar-Rifaa',94344.0,50.54,26.12).
city('al-Budayyi','bh','as-Samaliyah',33700.0,50.47,26.21).
city('Bagar Hat','bd','Bagar Hat',65144.0,89.8,22.66).
city('Morrelganj','bd','Bagar Hat',31651.0,89.85,22.47).
city('Mungla','bd','Bagar Hat',76641.0,89.54,22.22).
city('Sarankhola','bd','Bagar Hat',36475.0,89.78,22.3).
city('Bandarban','bd','Bandarban',32526.0,92.22,22.2).
city('Barguna','bd','Barguna',38403.0,90.08,22.18).
city('Barisal','bd','Barisal',280437.0,90.37,22.7).
city('Gaurnadi','bd','Barisal',40524.0,90.23,22.97).
city('Mehendiganj','bd','Barisal',39429.0,90.53,22.82).
city('Nalchiti','bd','Barisal',38708.0,90.29,22.62).
city('Bhola','bd','Bhola',99090.0,90.64,22.68).
city('Burhanuddin','bd','Bhola',45676.0,90.71,22.5).
city('Char Fasson','bd','Bhola',48311.0,90.73,22.22).
city('Lalmohan','bd','Bhola',42225.0,90.72,22.32).
city('Bogora','bd','Bogora',267631.0,89.37,24.84).
city('Sherpur','bd','Bogora',47731.0,89.41,24.68).
city('Brahman Bariya','bd','Brahman Bariya',233462.0,91.1,23.97).
city('Nabinagar','bd','Brahman Bariya',31675.0,90.96,23.89).
city('Sarail','bd','Brahman Bariya',63316.0,91.11,24.07).
city('Chandpur','bd','Chandpur',120183.0,90.67,23.22).
city('Hajiganj','bd','Chandpur',44349.0,90.86,23.24).
city('Chattagam','bd','Chattagam',3672603.0,91.81,22.33).
city('Fatikchhari','bd','Chattagam',39974.0,91.8,22.69).
city('Lohagara','bd','Chattagam',26858.0,92.08,21.99).
city('Patiya','bd','Chattagam',51367.0,91.97,22.29).
city('Rangunia','bd','Chattagam',32625.0,92.06,22.46).
city('Raozan','bd','Chattagam',25711.0,91.91,22.54).
city('Sandip','bd','Chattagam',52158.0,91.43,22.49).
city('Satkaniya','bd','Chattagam',52012.0,92.06,22.09).
city('Alamdanga','bd','Chuadanga',70736.0,88.93,23.74).
city('Chuadanga','bd','Chuadanga',111941.0,88.86,23.64).
city('Damurhuda','bd','Chuadanga',58895.0,88.79,23.61).
city('Dhaka','bd','Dhaka',6493177.0,90.39,23.7).
city('Dhamrai','bd','Dhaka',380.0,90.2,23.89).
city('Dohar','bd','Dhaka',45549.0,90.15,23.59).
city('Dinajpur','bd','Dinajpur',206251.0,88.64,25.63).
city('Fulbari','bd','Dinajpur',35882.0,88.97,25.5).
city('Parbatipur','bd','Dinajpur',48026.0,88.91,25.66).
city('Bhanga','bd','Faridpur',44833.0,89.98,23.37).
city('Char Bhadrasan','bd','Faridpur',34427.0,90.21,23.32).
city('Faridpur','bd','Faridpur',112200.0,89.85,23.61).
city('Chhagalnaiya','bd','Feni',39339.0,91.52,23.04).
city('Feni','bd','Feni',84038.0,91.39,23.01).
city('Gaybanda','bd','Gaybanda',139463.0,89.54,25.33).
city('Gazipur','bd','Gazipur',132249.0,90.65,23.8).
city('Tungi','bd','Gazipur',337620.0,90.4,23.88).
city('Gopalganj','bd','Gopalganj',50646.0,89.8,23.02).
city('Tungi Para','bd','Gopalganj',62217.0,89.91,22.9).
city('Baniachang','bd','Habiganj',37812.0,91.35,24.52).
city('Habiganj','bd','Habiganj',88770.0,91.41,24.38).
city('Jaipur Hat','bd','Jaipur Hat',73076.0,89.03,25.1).
city('Jamalpur','bd','Jamalpur',167914.0,89.94,24.92).
city('Sarishabari','bd','Jamalpur',81334.0,89.83,24.74).
city('Abhaynagar','bd','Jessor',42658.0,89.47,23.02).
city('Jessor','bd','Jessor',244006.0,89.21,23.17).
city('Jhikargachha','bd','Jessor',41962.0,89.12,23.12).
city('Keshabpur','bd','Jessor',30930.0,89.23,22.91).
city('Jhalakati','bd','Jhalakati',52751.0,90.21,22.64).
city('Jhanaydah','bd','Jhanaydah',96021.0,89.18,23.55).
city('Kaliganj','bd','Jhanaydah',45636.0,89.13,23.42).
city('Kotchandpur','bd','Jhanaydah',35250.0,89.02,23.4).
city('Khagrachari','bd','Khagrachhari',50364.0,91.96,23.09).
city('Manikchhari','bd','Khagrachhari',24836.0,91.83,22.85).
city('Ramgarh','bd','Khagrachhari',28017.0,91.73,22.99).
city('Khulna','bd','Khulna',1342429.0,89.56,22.84).
city('Phultala','bd','Khulna',37990.0,89.52,22.7).
city('Bajitpur','bd','Kishorganj',34564.0,90.94,24.21).
city('Bhairab Bazar','bd','Kishorganj',105470.0,90.96,24.06).
city('Kishorganj','bd','Kishorganj',90700.0,90.77,24.44).
city('Koks Bazar','bd','Koks Bazar',121236.0,91.98,21.44).
city('Kutubdia','bd','Koks Bazar',30542.0,91.86,21.84).
city('Ramu','bd','Koks Bazar',45825.0,92.1,21.43).
city('Teknaf','bd','Koks Bazar',40562.0,92.3,20.87).
city('Komilla','bd','Komilla',389441.0,91.17,23.46).
city('Laksham','bd','Komilla',82299.0,91.12,23.24).
city('Chilmari','bd','Kurigram',49742.0,89.72,25.55).
city('Kurigram','bd','Kurigram',75996.0,89.7,25.83).
city('Nageshwari','bd','Kurigram',49431.0,89.72,25.97).
city('Ulipur','bd','Kurigram',29985.0,89.61,25.65).
city('Bheramara','bd','Kushtiya',38164.0,88.98,24.03).
city('Kushtiya','bd','Kushtiya',135740.0,89.14,23.91).
city('Lakshmipur','bd','Lakshmipur',61710.0,90.8,22.95).
city('Ramganj','bd','Lakshmipur',55247.0,90.86,23.1).
city('Raypur','bd','Lakshmipur',64659.0,90.77,23.05).
city('Lalmanir Hat','bd','Lalmanir Hat',65135.0,89.45,25.91).
city('Madaripur','bd','Madaripur',84799.0,90.2,23.18).
city('Magura','bd','Magura',73297.0,89.42,23.5).
city('Bhaluka','bd','Maimansingh',28086.0,90.38,24.4).
city('Fulbaria','bd','Maimansingh',64528.0,90.73,24.62).
city('Gafargaon','bd','Maimansingh',34181.0,90.57,24.44).
city('Ishwarganj','bd','Maimansingh',25812.0,90.56,24.76).
city('Maimansingh','bd','Maimansingh',330163.0,90.39,24.75).
city('Muktagachha','bd','Maimansingh',24687.0,90.25,24.76).
city('Manikganj','bd','Manikganj',85800.0,90.09,23.83).
city('Maulvi Bazar','bd','Maulvi Bazar',57448.0,91.76,24.48).
city('Sri Mangal','bd','Maulvi Bazar',45380.0,91.71,24.3).
city('Meherpur','bd','Meherpur',47798.0,88.64,23.78).
city('Munshiganj','bd','Munshiganj',116410.0,90.38,23.49).
city('Kalia','bd','Naral',40497.0,89.63,23.05).
city('Naral','bd','Naral',55118.0,89.5,23.17).
city('Narayanganj','bd','Narayanganj',223773.0,90.5,23.62).
city('Narsingdi','bd','Narsingdi',281110.0,90.72,23.92).
city('Roypura','bd','Narsingdi',42231.0,90.85,23.99).
city('Nator','bd','Nator',94275.0,88.98,24.41).
city('Naugaon','bd','Naugaon',192485.0,88.96,24.82).
city('Nawabganj','bd','Nawabganj',142373.0,88.27,24.59).
city('Shibganj','bd','Nawabganj',35965.0,88.17,24.68).
city('Netrakona','bd','Netrakona',79025.0,90.73,24.89).
city('Domar','bd','Nilphamari',22402.0,88.82,26.11).
city('Nilphamari','bd','Nilphamari',31142.0,88.85,25.94).
city('Saidpur','bd','Nilphamari',100034.0,88.89,25.78).
city('Begamganj','bd','Noakhali',128394.0,91.1,23.04).
city('Noakhali','bd','Noakhali',118424.0,91.09,22.81).
city('Bera','bd','Pabna',39608.0,89.62,24.09).
city('Ishurdi','bd','Pabna',82005.0,89.07,24.14).
city('Pabna','bd','Pabna',137904.0,89.24,24.0).
city('Panchagarh','bd','Panchagarh',48536.0,88.55,26.33).
city('Patuakhali','bd','Patuakhali',76059.0,90.24,22.36).
city('Bhandaria','bd','Pirojpur',30222.0,90.07,22.47).
city('Mathbaria','bd','Pirojpur',29764.0,89.95,22.3).
city('Pirojpur','bd','Pirojpur',54424.0,89.99,22.57).
city('Pangsha','bd','Rajbari',42017.0,89.45,23.78).
city('Rajbari','bd','Rajbari',69492.0,89.66,23.76).
city('Rajshahi','bd','Rajshahi',700206.0,88.59,24.37).
city('Kaptai','bd','Rangamati',59624.0,92.2,22.47).
city('Rangamati','bd','Rangamati',52730.0,92.04,22.78).
city('Badarganj','bd','Rangpur',32604.0,89.05,25.67).
city('Rangpur','bd','Rangpur',285586.0,89.25,25.74).
city('Satkhira','bd','Satkhira',128933.0,89.08,22.71).
city('Palang','bd','Shariatpur',67659.0,90.35,23.22).
city('Nalitabari','bd','Sherpur',43016.0,90.21,25.09).
city('Sherpur','bd','Sherpur',107431.0,90.0,25.02).
city('Silhat','bd','Silhat',326387.0,91.87,24.9).
city('Shahjadpur','bd','Sirajganj',102432.0,89.6,24.19).
city('Sirajganj','bd','Sirajganj',167501.0,89.7,24.46).
city('Chhatak','bd','Sunamganj',39223.0,91.67,25.04).
city('Sunamganj','bd','Sunamganj',76491.0,91.37,25.06).
city('Gopalpur','bd','Tangayal',80539.0,89.8,24.54).
city('Mirzapur','bd','Tangayal',41142.0,90.1,24.1).
city('Sakhipur','bd','Tangayal',40874.0,90.18,24.3).
city('Tangayal','bd','Tangayal',180159.0,89.92,24.25).
city('Pirganj','bd','Thakurgaon',34610.0,88.35,25.87).
city('Thakurgaon','bd','Thakurgaon',71104.0,88.46,26.03).
city('Oistins','bb','Christ Church',2285.0,-59.55,13.07).
city('Greenland','bb','Saint Andrew',623.0,-59.57,13.25).
city('Bulkeley','bb','Saint George',1142.0,-59.54,13.12).
city('Holetown','bb','Saint James',1350.0,-59.63,13.18).
city('Blackmans','bb','Saint John',623.0,-59.54,13.19).
city('Bathsheba','bb','Saint Joseph',1765.0,-59.53,13.2).
city('Crab Hill','bb','Saint Lucy',727.0,-59.62,13.32).
city('Bridgetown','bb','Saint Michael',98511.0,-59.61,13.11).
city('Speightstown','bb','Saint Peter',3634.0,-59.63,13.25).
city('Crane','bb','Saint Philip',935.0,-59.45,13.11).
city('Hillaby','bb','Saint Thomas',519.0,-59.57,13.2).
city('Baranavicy','by','Brest',168773.0,26.02,53.14).
city('Bjaroza','by','Brest',29645.0,24.98,52.53).
city('Bjeloozersk','by','Brest',10691.0,25.16,52.47).
city('Brest','by','Brest',300716.0,23.68,52.12).
city('David-Haradok','by','Brest',7694.0,27.22,52.06).
city('Drahicyn','by','Brest',13389.0,25.15,52.19).
city('Hancavicy','by','Brest',14088.0,26.44,52.76).
city('Ivacevicy','by','Brest',24546.0,25.35,52.72).
city('Ivanava','by','Brest',13614.0,25.54,52.15).
city('Kamjenec','by','Brest',8293.0,23.81,52.4).
city('Kobryn','by','Brest',50691.0,24.35,52.21).
city('Kosava','by','Brest',2698.0,25.16,52.76).
city('Ljahavicy','by','Brest',10696.0,26.27,53.04).
city('Luninjec','by','Brest',23775.0,26.82,52.25).
city('Malaryta','by','Brest',9692.0,24.08,51.8).
city('Mikasevicy','by','Brest',10491.0,27.46,52.22).
city('Pinsk','by','Brest',130777.0,26.1,52.12).
city('Pruzany','by','Brest',19135.0,24.46,52.56).
city('Stolin','by','Brest',10491.0,26.85,51.9).
city('Vysokoje','by','Brest',4496.0,23.39,52.36).
city('Zabinka','by','Brest',10921.0,24.0,52.21).
city('Buda Koseljovo','by','Homjel',8002.0,30.57,52.71).
city('Cecersk','by','Homjel',8618.0,30.91,52.92).
city('Dobrus','by','Homjel',19083.0,31.32,52.42).
city('Hojniki','by','Homjel',15037.0,29.97,51.89).
city('Homjel','by','Homjel',480950.0,30.99,52.43).
city('Jelsk','by','Homjel',8442.0,29.16,51.81).
city('Kalinkavicy','by','Homjel',37190.0,29.33,52.13).
city('Kascjukovka','by','Homjel',10552.0,30.93,52.54).
city('Mazyr','by','Homjel',112136.0,29.27,52.05).
city('Narovlja','by','Homjel',9849.0,29.5,51.8).
city('Pjetrykav','by','Homjel',10552.0,28.49,52.13).
city('Rahacow','by','Homjel',34544.0,30.05,53.09).
city('Recyca','by','Homjel',65532.0,30.4,52.36).
city('Svetlahorsk','by','Homjel',71250.0,29.76,52.64).
city('Vasilevicy','by','Homjel',4749.0,29.83,52.25).
city('Vjetka','by','Homjel',8969.0,31.17,52.56).
city('Zlobin','by','Homjel',73089.0,30.03,52.89).
city('Zytkavicy','by','Homjel',13630.0,27.86,52.22).
city('Asmjany','by','Hrodna',14345.0,25.93,54.43).
city('Berjozovka','by','Hrodna',9778.0,25.49,53.72).
city('Hrodna','by','Hrodna',317366.0,23.83,53.67).
city('Lida','by','Hrodna',98036.0,25.28,53.89).
city('Masty','by','Hrodna',16102.0,24.53,53.41).
city('Navahrudak','by','Hrodna',30748.0,25.82,53.6).
city('Scucyn','by','Hrodna',15029.0,24.75,53.61).
city('Skidel','by','Hrodna',10637.0,24.25,53.59).
city('Slonim','by','Hrodna',51435.0,25.32,53.1).
city('Smarhon','by','Hrodna',36664.0,26.41,54.49).
city('Vawkavysk','by','Hrodna',47300.0,24.44,53.16).
city('Asipovicy','by','Mahiljow',34591.0,28.65,53.3).
city('Babrujsk','by','Mahiljow',220517.0,29.19,53.13).
city('Byhau','by','Mahiljow',16860.0,30.24,53.52).
city('Causy','by','Mahiljow',11313.0,30.97,53.82).
city('Cerikov','by','Mahiljow',7874.0,31.39,53.57).
city('Horki','by','Mahiljow',33897.0,30.98,54.29).
city('Kascjukovicy','by','Mahiljow',11946.0,32.06,53.35).
city('Klimavicy','by','Mahiljow',14951.0,31.94,53.61).
city('Krycaw','by','Mahiljow',27681.0,31.72,53.7).
city('Mahiljow','by','Mahiljow',365887.0,30.33,53.9).
city('Mstislav','by','Mahiljow',10156.0,31.72,54.03).
city('Sklov','by','Mahiljow',13485.0,30.28,54.23).
city('Slauharad','by','Mahiljow',7331.0,31.0,53.45).
city('Minsk','by','Minsk',1742123.0,27.55,53.91).
city('Barisaw','by','Minskaja Voblasts',150372.0,28.51,54.22).
city('Bjarezina','by','Minskaja Voblasts',11654.0,28.99,53.85).
city('Cerven','by','Minskaja Voblasts',10553.0,28.44,53.71).
city('Dzerzhinsk','by','Minskaja Voblasts',24610.0,27.14,53.69).
city('Kapyl','by','Minskaja Voblasts',8717.0,27.09,53.16).
city('Kleck','by','Minskaja Voblasts',9641.0,26.62,53.07).
city('Lyuban','by','Minskaja Voblasts',10107.0,28.0,52.8).
city('Maladzecna','by','Minskaja Voblasts',98396.0,26.86,54.32).
city('Marjina Horka','by','Minskaja Voblasts',23449.0,28.15,53.51).
city('Njasviz','by','Minskaja Voblasts',12847.0,26.68,53.22).
city('Salihorsk','by','Minskaja Voblasts',101614.0,27.53,52.82).
city('Sluck','by','Minskaja Voblasts',62229.0,27.55,53.03).
city('Smaljavicy','by','Minskaja Voblasts',12516.0,28.09,54.03).
city('Staryja Darohi','by','Minskaja Voblasts',10094.0,28.28,53.04).
city('Stovbcy','by','Minskaja Voblasts',12480.0,26.74,53.48).
city('Valozyn','by','Minskaja Voblasts',9727.0,26.53,54.1).
city('Viljejka','by','Minskaja Voblasts',30039.0,26.91,54.49).
city('Zaslavje','by','Minskaja Voblasts',9543.0,27.28,54.0).
city('Zodzina','by','Minskaja Voblasts',61007.0,28.35,54.1).
city('Baran','by','Vicebsk',12725.0,30.34,54.48).
city('Braslav','by','Vicebsk',12378.0,27.04,55.64).
city('Casniki','by','Vicebsk',11485.0,29.16,54.86).
city('Disna','by','Vicebsk',2738.0,28.22,55.57).
city('Doksicy','by','Vicebsk',8190.0,27.77,54.9).
city('Dubrovna','by','Vicebsk',9504.0,30.69,54.58).
city('Haradok','by','Vicebsk',13380.0,29.98,55.47).
city('Hlybokaje','by','Vicebsk',19953.0,27.68,55.14).
city('Ljepjel','by','Vicebsk',20826.0,28.69,54.89).
city('Mjory','by','Vicebsk',10649.0,27.63,55.62).
city('Navapolack','by','Vicebsk',100885.0,28.66,55.54).
city('Novalukoml','by','Vicebsk',17848.0,29.22,54.65).
city('Orsha','by','Vicebsk',125347.0,30.41,54.51).
city('Pastavy','by','Vicebsk',20218.0,26.84,55.12).
city('Polack','by','Vicebsk',82258.0,28.79,55.49).
city('Senno','by','Vicebsk',9987.0,29.7,54.82).
city('Talacyn','by','Vicebsk',11381.0,29.69,54.41).
city('Verhnjadzvimsk','by','Vicebsk',9518.0,27.93,55.78).
city('Vicebsk','by','Vicebsk',342077.0,30.18,55.19).
city('Aartselaar','be','Antwerp',14193.0,4.38,51.13).
city('Antwerp','be','Antwerp',459805.0,4.42,51.22).
city('Arendonk','be','Antwerp',12247.0,5.08,51.32).
city('Baarle-Hertog','be','Antwerp',2305.0,4.93,51.45).
city('Balen','be','Antwerp',19978.0,5.15,51.17).
city('Beerse','be','Antwerp',16208.0,4.87,51.32).
city('Berlaar','be','Antwerp',10370.0,4.65,51.12).
city('Boechout','be','Antwerp',12145.0,4.5,51.17).
city('Bonheiden','be','Antwerp',14260.0,4.53,51.03).
city('Boom','be','Antwerp',15810.0,4.37,51.08).
city('Bornem','be','Antwerp',19997.0,4.23,51.1).
city('Borsbeek','be','Antwerp',10334.0,4.48,51.2).
city('Br','be','Antwerp',37040.0,4.45,51.28).
city('Brecht','be','Antwerp',25908.0,4.63,51.35).
city('Dessel','be','Antwerp',8707.0,5.12,51.23).
city('Duffel','be','Antwerp',16011.0,4.52,51.1).
city('Edegem','be','Antwerp',21839.0,4.45,51.15).
city('Essen','be','Antwerp',16754.0,4.47,51.47).
city('Geel','be','Antwerp',34697.0,5.0,51.17).
city('Grobbendonk','be','Antwerp',10724.0,4.72,51.2).
city('Heist-op-den-Berg','be','Antwerp',37873.0,4.72,51.08).
city('Hemiksem','be','Antwerp',9504.0,4.35,51.15).
city('Herentals','be','Antwerp',25912.0,4.83,51.18).
city('Herenthout','be','Antwerp',8379.0,4.77,51.15).
city('Herselt','be','Antwerp',13493.0,4.88,51.05).
city('Hoogstraten','be','Antwerp',18524.0,4.77,51.4).
city('Hove','be','Antwerp',7968.0,4.47,51.15).
city('Hulshout','be','Antwerp',9198.0,4.78,51.08).
city('Kalmthout','be','Antwerp',17485.0,4.47,51.38).
city('Kapellen','be','Antwerp',26410.0,4.43,51.32).
city('Kasterlee','be','Antwerp',17765.0,4.95,51.25).
city('Kon','be','Antwerp',20290.0,4.45,51.13).
city('Lier','be','Antwerp',33003.0,4.57,51.14).
city('Lille','be','Antwerp',15466.0,4.83,51.23).
city('Lint','be','Antwerp',7982.0,4.5,51.13).
city('Mechelen','be','Antwerp',77531.0,4.47,51.03).
city('Meerhout','be','Antwerp',9346.0,5.08,51.13).
city('Merksplas','be','Antwerp',7963.0,4.87,51.37).
city('Mol','be','Antwerp',32659.0,5.1,51.18).
city('Mortsel','be','Antwerp',24525.0,4.47,51.17).
city('Niel','be','Antwerp',8656.0,4.33,51.12).
city('Nijlen','be','Antwerp',20792.0,4.65,51.17).
city('Olen','be','Antwerp',11070.0,4.85,51.15).
city('Oud-Turnhout','be','Antwerp',12354.0,4.98,51.32).
city('Putte','be','Antwerp',15276.0,4.63,51.07).
city('Puurs','be','Antwerp',15944.0,4.28,51.08).
city('Ranst','be','Antwerp',17405.0,4.55,51.2).
city('Ravels','be','Antwerp',13560.0,5.0,51.37).
city('Retie','be','Antwerp',10069.0,5.07,51.27).
city('Rijkevorsel','be','Antwerp',10606.0,4.77,51.35).
city('Rumst','be','Antwerp',14521.0,4.42,51.08).
city('Schelle','be','Antwerp',7675.0,4.33,51.13).
city('Schilde','be','Antwerp',20373.0,4.57,51.23).
city('Schoten','be','Antwerp',33622.0,4.5,51.25).
city('Sint-Amands','be','Antwerp',7653.0,4.2,51.05).
city('Sint-Katelijne-Waver','be','Antwerp',19487.0,4.53,51.07).
city('Stabroek','be','Antwerp',17294.0,4.37,51.33).
city('Turnhout','be','Antwerp',39654.0,4.95,51.32).
city('Vorselaar','be','Antwerp',7238.0,4.77,51.2).
city('Vosselaar','be','Antwerp',10317.0,4.88,51.32).
city('Westerlo','be','Antwerp',22579.0,4.92,51.08).
city('Wijnegem','be','Antwerp',8932.0,4.53,51.23).
city('Willebroek','be','Antwerp',22808.0,4.37,51.07).
city('Wommelgem','be','Antwerp',11917.0,4.52,51.2).
city('Wuustwezel','be','Antwerp',18117.0,4.6,51.38).
city('Zandhoven','be','Antwerp',12306.0,4.65,51.22).
city('Zoersel','be','Antwerp',20642.0,4.7,51.27).
city('Zwijndrecht','be','Antwerp',18249.0,4.33,51.22).
city('Beauvechain','be','Brabant Wallon',6334.0,4.77,50.78).
city('Braine-lAlleud','be','Brabant Wallon',36776.0,4.37,50.69).
city('Braine-le-Chateau','be','Brabant Wallon',9627.0,4.27,50.68).
city('Chastre','be','Brabant Wallon',6243.0,4.63,50.6).
city('Chaumont-Gistoux','be','Brabant Wallon',10943.0,4.73,50.68).
city('Court-Saint-Etienne','be','Brabant Wallon',9353.0,4.57,50.65).
city('Genappe','be','Brabant Wallon',14266.0,4.45,50.6).
city('Grez-Doiceau','be','Brabant Wallon',12367.0,4.7,50.73).
city('Incourt','be','Brabant Wallon',4395.0,4.78,50.7).
city('Ittre','be','Brabant Wallon',6014.0,4.27,50.65).
city('Jodoigne','be','Brabant Wallon',11930.0,4.87,50.72).
city('La Hulpe','be','Brabant Wallon',7415.0,4.48,50.73).
city('Lasne','be','Brabant Wallon',13861.0,4.49,50.68).
city('Mont-Saint-Guibert','be','Brabant Wallon',6557.0,4.62,50.63).
city('Nivelles','be','Brabant Wallon',24149.0,4.33,50.6).
city('Orp-Jauche','be','Brabant Wallon',7826.0,4.96,50.68).
city('Ottignies-Louvain-la-Neuve','be','Brabant Wallon',29282.0,4.56,50.67).
city('Perwez','be','Brabant Wallon',7340.0,4.82,50.62).
city('Ramillies','be','Brabant Wallon',5749.0,4.92,50.64).
city('Rebecq','be','Brabant Wallon',10049.0,4.13,50.66).
city('Rixensart','be','Brabant Wallon',21616.0,4.53,50.72).
city('Tubize','be','Brabant Wallon',21859.0,4.2,50.68).
city('Villers-la-Ville','be','Brabant Wallon',9592.0,4.53,50.58).
city('Walhain','be','Brabant Wallon',5992.0,4.7,50.62).
city('Waterloo','be','Brabant Wallon',28910.0,4.38,50.72).
city('Wavre','be','Brabant Wallon',32112.0,4.62,50.72).
city('Brussels','be','Brussels',1019022.0,4.33,50.83).
city('Aalst','be','East Flanders',77534.0,4.03,50.93).
city('Aalter','be','East Flanders',18802.0,3.45,51.08).
city('Assenede','be','East Flanders',13495.0,3.75,51.23).
city('Berlare','be','East Flanders',13853.0,4.0,51.03).
city('Beveren','be','East Flanders',45179.0,4.25,51.22).
city('Brakel','be','East Flanders',13539.0,3.77,50.8).
city('Buggenhout','be','East Flanders',13510.0,4.2,51.02).
city('De Pinte','be','East Flanders',10020.0,3.65,51.0).
city('Deinze','be','East Flanders',27777.0,3.53,50.98).
city('Denderleeuw','be','East Flanders',16969.0,4.07,50.88).
city('Dendermonde','be','East Flanders',43055.0,4.12,51.03).
city('Destelbergen','be','East Flanders',16853.0,3.8,51.05).
city('Eeklo','be','East Flanders',19116.0,3.57,51.18).
city('Erpe-Mere','be','East Flanders',18976.0,3.98,50.93).
city('Evergem','be','East Flanders',31615.0,3.7,51.12).
city('Gavere','be','East Flanders',11888.0,3.67,50.93).
city('Gent','be','East Flanders',231493.0,3.72,51.05).
city('Geraardsbergen','be','East Flanders',30807.0,3.87,50.77).
city('Haaltert','be','East Flanders',17129.0,4.0,50.9).
city('Hamme','be','East Flanders',22891.0,4.13,51.1).
city('Herzele','be','East Flanders',16523.0,3.88,50.88).
city('Kaprijke','be','East Flanders',6114.0,3.6,51.22).
city('Knesselare','be','East Flanders',7889.0,3.42,51.13).
city('Kruibeke','be','East Flanders',14815.0,4.32,51.17).
city('Kruishoutem','be','East Flanders',8179.0,3.52,50.9).
city('Laarne','be','East Flanders',11600.0,3.85,51.03).
city('Lebbeke','be','East Flanders',17372.0,4.13,51.0).
city('Lede','be','East Flanders',16813.0,3.98,50.97).
city('Lierde','be','East Flanders',6449.0,3.85,50.82).
city('Lochristi','be','East Flanders',19696.0,3.83,51.1).
city('Lokeren','be','East Flanders',37567.0,3.98,51.1).
city('Lovendegem','be','East Flanders',9272.0,3.6,51.1).
city('Maldegem','be','East Flanders',22092.0,3.45,51.22).
city('Melle','be','East Flanders',10687.0,3.8,51.0).
city('Merelbeke','be','East Flanders',22047.0,3.75,51.0).
city('Moerbeke','be','East Flanders',5855.0,3.93,51.17).
city('Nazareth','be','East Flanders',10890.0,3.6,50.97).
city('Nevele','be','East Flanders',11153.0,3.55,51.03).
city('Ninove','be','East Flanders',34795.0,4.02,50.83).
city('Oosterzele','be','East Flanders',13151.0,3.8,50.95).
city('Oudenaarde','be','East Flanders',27935.0,3.6,50.85).
city('Ronse','be','East Flanders',24204.0,3.6,50.75).
city('Sint-Gillis-Waas','be','East Flanders',17658.0,4.13,51.22).
city('Sint-Laureins','be','East Flanders',6657.0,3.52,51.25).
city('Sint-Lievens-Houtem','be','East Flanders',9146.0,3.85,50.92).
city('Sint-Martens-Latem','be','East Flanders',8303.0,3.63,51.02).
city('Sint-Niklaas','be','East Flanders',69010.0,4.13,51.17).
city('Stekene','be','East Flanders',16989.0,4.03,51.2).
city('Temse','be','East Flanders',26054.0,4.22,51.13).
city('Waarschoot','be','East Flanders',7762.0,3.6,51.15).
city('Waasmunster','be','East Flanders',10460.0,4.08,51.1).
city('Wachtebeke','be','East Flanders',6911.0,3.87,51.17).
city('Wetteren','be','East Flanders',22930.0,3.88,51.0).
city('Wichelen','be','East Flanders',11014.0,3.98,51.0).
city('Wortegem-Petegem','be','East Flanders',5933.0,3.51,50.85).
city('Zele','be','East Flanders',20236.0,4.03,51.07).
city('Zelzate','be','East Flanders',11901.0,3.82,51.2).
city('Zingem','be','East Flanders',6588.0,3.65,50.9).
city('Zomergem','be','East Flanders',8158.0,3.55,51.12).
city('Zottegem','be','East Flanders',24434.0,3.8,50.87).
city('Zulte','be','East Flanders',14670.0,3.43,50.92).
city('Zwalm','be','East Flanders',7698.0,3.71,50.78).
city('Aarschot','be','Flemish Brabant',27656.0,4.83,50.98).
city('Asse','be','Flemish Brabant',28985.0,4.2,50.92).
city('Beersel','be','Flemish Brabant',23228.0,4.3,50.77).
city('Begijnendijk','be','Flemish Brabant',9178.0,4.77,51.02).
city('Bekkevoort','be','Flemish Brabant',5714.0,4.97,50.95).
city('Bertem','be','Flemish Brabant',9215.0,4.63,50.87).
city('Bever','be','Flemish Brabant',1932.0,4.32,50.92).
city('Bierbeek','be','Flemish Brabant',8994.0,4.77,50.83).
city('Boortmeerbeek','be','Flemish Brabant',11570.0,4.57,50.98).
city('Boutersem','be','Flemish Brabant',7702.0,4.83,50.85).
city('Diest','be','Flemish Brabant',22516.0,5.05,50.98).
city('Dilbeek','be','Flemish Brabant',39482.0,4.27,50.85).
city('Drogenbos','be','Flemish Brabant',4843.0,4.32,50.78).
city('Galmaarden','be','Flemish Brabant',7939.0,3.97,50.75).
city('Geetbets','be','Flemish Brabant',5813.0,5.12,50.88).
city('Glabbeek','be','Flemish Brabant',5070.0,4.95,50.87).
city('Gooik','be','Flemish Brabant',8957.0,4.12,50.8).
city('Grimbergen','be','Flemish Brabant',33561.0,4.38,50.93).
city('Haacht','be','Flemish Brabant',13541.0,4.63,50.98).
city('Halle','be','Flemish Brabant',34479.0,4.23,50.73).
city('Herent','be','Flemish Brabant',19218.0,4.67,50.9).
city('Herne','be','Flemish Brabant',6459.0,4.03,50.72).
city('Hoegaarden','be','Flemish Brabant',6110.0,4.9,50.78).
city('Hoeilaart','be','Flemish Brabant',10272.0,4.47,50.77).
city('Holsbeek','be','Flemish Brabant',9094.0,4.75,50.92).
city('Huldenberg','be','Flemish Brabant',9137.0,4.58,50.78).
city('Kampenhout','be','Flemish Brabant',10784.0,4.55,50.95).
city('Kapelle-op-den-Bos','be','Flemish Brabant',8859.0,4.37,51.02).
city('Keerbergen','be','Flemish Brabant',12363.0,4.62,51.0).
city('Kortenaken','be','Flemish Brabant',7374.0,5.07,50.92).
city('Kortenberg','be','Flemish Brabant',17774.0,4.53,50.88).
city('Kraainem','be','Flemish Brabant',12815.0,4.47,50.87).
city('Landen','be','Flemish Brabant',14458.0,5.08,50.75).
city('Lennik','be','Flemish Brabant',8818.0,4.15,50.8).
city('Leuven','be','Flemish Brabant',92892.0,4.7,50.88).
city('Liedekerke','be','Flemish Brabant',11980.0,4.08,50.87).
city('Linkebeek','be','Flemish Brabant',4823.0,4.33,50.77).
city('Londerzeel','be','Flemish Brabant',17274.0,4.3,51.0).
city('Lubbeek','be','Flemish Brabant',13574.0,4.83,50.88).
city('Machelen','be','Flemish Brabant',12252.0,4.43,50.92).
city('Meise','be','Flemish Brabant',18497.0,4.33,50.93).
city('Merchtem','be','Flemish Brabant',14660.0,4.23,50.97).
city('Opwijk','be','Flemish Brabant',12045.0,4.18,50.97).
city('Oud-Heverlee','be','Flemish Brabant',10533.0,4.67,50.83).
city('Overijse','be','Flemish Brabant',23486.0,4.53,50.77).
city('Pepingen','be','Flemish Brabant',4261.0,4.15,50.75).
city('Rotselaar','be','Flemish Brabant',15007.0,4.72,50.95).
city('Scherpenheuvel-Zichem','be','Flemish Brabant',21848.0,4.98,50.99).
city('Sint-Genesius-Rode','be','Flemish Brabant',17990.0,4.35,50.75).
city('Sint-Pieters-Leeuw','be','Flemish Brabant',30446.0,4.23,50.78).
city('Steenokkerzeel','be','Flemish Brabant',10566.0,4.52,50.92).
city('Ternat','be','Flemish Brabant',14569.0,4.18,50.87).
city('Tervuren','be','Flemish Brabant',20623.0,4.52,50.82).
city('Tielt-Winge','be','Flemish Brabant',9902.0,4.91,50.93).
city('Tienen','be','Flemish Brabant',31743.0,4.95,50.8).
city('Tremelo','be','Flemish Brabant',13721.0,4.7,50.98).
city('Vilvoorde','be','Flemish Brabant',36955.0,4.43,50.93).
city('Wemmel','be','Flemish Brabant',14406.0,4.3,50.92).
city('Wezembeek-Oppem','be','Flemish Brabant',13245.0,4.48,50.85).
city('Zaventem','be','Flemish Brabant',28188.0,4.47,50.88).
city('Zemst','be','Flemish Brabant',21096.0,4.47,50.98).
city('Zoutleeuw','be','Flemish Brabant',7897.0,5.1,50.83).
city('Aiseau-Presles','be','Hainaut',10906.0,4.59,50.41).
city('Anderlues','be','Hainaut',11597.0,4.27,50.4).
city('Antoing','be','Hainaut',7507.0,3.45,50.57).
city('Ath','be','Hainaut',26681.0,3.78,50.63).
city('Beaumont','be','Hainaut',6645.0,4.23,50.23).
city('Beloeil','be','Hainaut',13405.0,3.72,50.55).
city('Bernissart','be','Hainaut',11588.0,3.63,50.47).
city('Binche','be','Hainaut',32030.0,4.17,50.4).
city('Boussu','be','Hainaut',20058.0,3.8,50.43).
city('Braine-le-Comte','be','Hainaut',20133.0,4.13,50.6).
city('Brugelette','be','Hainaut',3358.0,3.85,50.6).
city('Brunehaut','be','Hainaut',7592.0,4.42,50.5).
city('Celles','be','Hainaut',5471.0,3.45,50.72).
city('Chapelle-lez-Herlaimont','be','Hainaut',14353.0,4.28,50.47).
city('Charleroi','be','Hainaut',200132.0,4.43,50.42).
city('Chatelet','be','Hainaut',35238.0,4.51,50.4).
city('Chievres','be','Hainaut',6045.0,3.8,50.59).
city('Chimay','be','Hainaut',9720.0,4.32,50.05).
city('Colfontaine','be','Hainaut',19964.0,3.87,50.38).
city('Comines-Warneton','be','Hainaut',17447.0,3.0,50.77).
city('Courcelles','be','Hainaut',29473.0,4.37,50.47).
city('Dour','be','Hainaut',16861.0,3.78,50.4).
city('Ecaussinnes','be','Hainaut',9802.0,4.15,50.56).
city('Ellezelles','be','Hainaut',5566.0,3.68,50.73).
city('Enghien','be','Hainaut',11367.0,4.03,50.7).
city('Er','be','Hainaut',9396.0,4.12,50.3).
city('Estaimpuis','be','Hainaut',9340.0,3.25,50.7).
city('Estinnes','be','Hainaut',7573.0,4.1,50.4).
city('Farciennes','be','Hainaut',11488.0,4.55,50.43).
city('Fleurus','be','Hainaut',22080.0,4.53,50.48).
city('Flobecq','be','Hainaut',3142.0,3.73,50.73).
city('Fontaine-lEveque','be','Hainaut',16851.0,4.32,50.41).
city('Frameries','be','Hainaut',20598.0,3.9,50.4).
city('Frasnes-lez-Anvaing','be','Hainaut',10936.0,3.62,50.67).
city('Froidchapelle','be','Hainaut',3579.0,4.32,50.15).
city('Gerpinnes','be','Hainaut',11977.0,4.52,50.33).
city('Ham-sur-Heure-Nalinnes','be','Hainaut',13062.0,4.38,50.32).
city('Hensies','be','Hainaut',6390.0,3.67,50.43).
city('Jurbise','be','Hainaut',9483.0,3.93,50.53).
city('La Louviere','be','Hainaut',76668.0,4.23,50.49).
city('Le Roeulx','be','Hainaut',7968.0,4.11,50.5).
city('Lens','be','Hainaut',3902.0,3.9,50.55).
city('Lessines','be','Hainaut',17687.0,3.83,50.72).
city('Leuze-en-Hainaut','be','Hainaut',13018.0,3.6,50.6).
city('Lobbes','be','Hainaut',5467.0,4.25,50.35).
city('Manage','be','Hainaut',22196.0,4.22,50.5).
city('Merbes-le-Chateau','be','Hainaut',3999.0,4.16,50.33).
city('Momignies','be','Hainaut',5183.0,4.17,50.03).
city('Mons','be','Hainaut',91277.0,3.93,50.45).
city('Montigny-le-Tilleul','be','Hainaut',10283.0,4.37,50.38).
city('Morlanwelz','be','Hainaut',18233.0,4.23,50.45).
city('Mouscron','be','Hainaut',52069.0,3.22,50.73).
city('Pecq','be','Hainaut',5302.0,3.33,50.68).
city('Peruwelz','be','Hainaut',16647.0,3.58,50.52).
city('Pont-a-Celles','be','Hainaut',15909.0,4.35,50.5).
city('Quaregnon','be','Hainaut',18491.0,3.85,50.43).
city('Quevy','be','Hainaut',7689.0,3.95,50.35).
city('Quievrain','be','Hainaut',6560.0,3.68,50.4).
city('Rumes','be','Hainaut',4918.0,3.3,50.55).
city('Saint-Ghislain','be','Hainaut',22500.0,3.82,50.45).
city('Seneffe','be','Hainaut',11025.0,4.25,50.52).
city('Silly','be','Hainaut',7887.0,3.92,50.65).
city('Sivry-Rance','be','Hainaut',4566.0,4.18,50.17).
city('Soignies','be','Hainaut',24869.0,4.07,50.58).
city('Thuin','be','Hainaut',14682.0,4.28,50.33).
city('Tournai','be','Hainaut',67720.0,3.38,50.6).
city('Amay','be','Liege',13307.0,5.32,50.55).
city('Amel','be','Liege',5221.0,6.15,50.35).
city('Ans','be','Liege',27297.0,5.53,50.65).
city('Anthisnes','be','Liege',4116.0,5.52,50.48).
city('Aubel','be','Liege',4119.0,5.85,50.7).
city('Awans','be','Liege',8612.0,5.47,50.67).
city('Aywaille','be','Liege',10636.0,5.67,50.47).
city('Baelen','be','Liege',3928.0,5.97,50.63).
city('Bassenge','be','Liege',8151.0,5.6,50.77).
city('Berloz','be','Liege',2770.0,5.22,50.7).
city('Beyne-Heusay','be','Liege',11608.0,5.65,50.62).
city('Blegny','be','Liege',12745.0,5.73,50.67).
city('Braives','be','Liege',5672.0,5.15,50.63).
city('Buellingen','be','Liege',5340.0,6.26,50.41).
city('Buetgenbach','be','Liege',5516.0,6.2,50.43).
city('Burdinne','be','Liege',2799.0,5.07,50.58).
city('Burg-Reuland','be','Liege',3847.0,6.13,50.2).
city('Chaudfontaine','be','Liege',20960.0,5.63,50.58).
city('Clavier','be','Liege',4092.0,5.37,50.42).
city('Comblain-au-Pont','be','Liege',5308.0,5.58,50.47).
city('Crisnee','be','Liege',2587.0,5.4,50.72).
city('Dalhem','be','Liege',6391.0,5.72,50.72).
city('Dison','be','Liege',13642.0,5.85,50.62).
city('Donceel','be','Liege',2712.0,5.32,50.65).
city('Engis','be','Liege',5737.0,5.42,50.58).
city('Esneux','be','Liege',13497.0,5.57,50.53).
city('Eupen','be','Liege',18029.0,6.03,50.63).
city('Faimes','be','Liege',3349.0,5.27,50.67).
city('Ferrieres','be','Liege',4434.0,5.6,50.4).
city('Fexhe-le-Haut-Clocher','be','Liege',3082.0,5.4,50.67).
city('Flemalle','be','Liege',25144.0,5.47,50.62).
city('Fleron','be','Liege',15994.0,5.69,50.62).
city('Geer','be','Liege',2682.0,5.17,50.67).
city('Grace-Hollogne','be','Liege',21357.0,5.2,50.68).
city('Hamoir','be','Liege',3500.0,5.53,50.43).
city('Hannut','be','Liege',14129.0,5.08,50.67).
city('Heron','be','Liege',4305.0,5.1,50.55).
city('Herstal','be','Liege',36503.0,5.63,50.67).
city('Herve','be','Liege',16544.0,5.8,50.63).
city('Huy','be','Liege',19973.0,5.23,50.52).
city('Jalhay','be','Liege',7688.0,5.97,50.57).
city('Juprelle','be','Liege',8354.0,5.53,50.72).
city('Kelmis','be','Liege',10232.0,6.0,50.71).
city('Liege','be','Liege',182597.0,5.57,50.64).
city('Lierneux','be','Liege',3332.0,5.8,50.28).
city('Limbourg','be','Liege',5612.0,5.93,50.62).
city('Lincent','be','Liege',2884.0,5.03,50.72).
city('Lontzen','be','Liege',4862.0,6.0,50.68).
city('Malmedy','be','Liege',11514.0,6.03,50.42).
city('Marchin','be','Liege',5063.0,5.23,50.47).
city('Modave','be','Liege',3825.0,5.3,50.45).
city('Nandrin','be','Liege',5480.0,5.42,50.5).
city('Olne','be','Liege',3836.0,5.75,50.58).
city('Oreye','be','Liege',3373.0,5.37,50.73).
city('Ouffet','be','Liege',2477.0,5.47,50.43).
city('Oupeye','be','Liege',23594.0,5.65,50.7).
city('Pepinster','be','Liege',9530.0,5.82,50.57).
city('Plombieres','be','Liege',9596.0,5.95,50.73).
city('Raeren','be','Liege',9925.0,6.12,50.68).
city('Remicourt','be','Liege',5050.0,5.33,50.68).
city('Saint-Georges-sur-Meuse','be','Liege',6016.0,5.36,50.6).
city('Saint-Nicolas','be','Liege',22586.0,5.53,50.63).
city('Sankt Vith','be','Liege',9135.0,6.13,50.29).
city('Seraing','be','Liege',60737.0,5.48,50.6).
city('Soumagne','be','Liege',15237.0,5.75,50.62).
city('Spa','be','Liege',10756.0,5.87,50.5).
city('Sprimont','be','Liege',12945.0,5.67,50.5).
city('Stavelot','be','Liege',6646.0,5.93,50.38).
city('Stoumont','be','Liege',2970.0,5.8,50.42).
city('Theux','be','Liege',11587.0,5.82,50.53).
city('Thimister-Clermont','be','Liege',5382.0,5.87,50.65).
city('Tinlot','be','Liege',2236.0,5.37,50.48).
city('Trois-Ponts','be','Liege',2533.0,5.87,50.37).
city('Trooz','be','Liege',7559.0,5.68,50.57).
city('Verlaine','be','Liege',3600.0,5.32,50.6).
city('Verviers','be','Liege',52824.0,5.87,50.58).
city('Villers-le-Bouillet','be','Liege',6059.0,5.27,50.58).
city('Vise','be','Liege',17054.0,5.7,50.74).
city('Waimes','be','Liege',6661.0,6.12,50.42).
city('Wanze','be','Liege',12918.0,5.22,50.53).
city('Waremme','be','Liege',13737.0,5.25,50.68).
city('Wasseiges','be','Liege',2471.0,5.0,50.62).
city('Welkenraedt','be','Liege',9006.0,5.97,50.65).
city('Alken','be','Lim',10933.0,5.3,50.87).
city('As','be','Limburg',7250.0,5.58,51.02).
city('Beringen','be','Limburg',40930.0,5.22,51.05).
city('Bilzen','be','Limburg',29622.0,5.52,50.87).
city('Bocholt','be','Limburg',12346.0,5.58,51.17).
city('Borgloon','be','Limburg',9955.0,5.33,50.8).
city('Bree','be','Limburg',14363.0,5.6,51.13).
city('Diepenbeek','be','Limburg',17699.0,5.4,50.9).
city('Dilsen-Stokkem','be','Limburg',18898.0,5.73,51.03).
city('Genk','be','Limburg',63666.0,5.5,50.97).
city('Gingelom','be','Limburg',7930.0,5.12,50.75).
city('Halen','be','Limburg',8548.0,5.1,50.95).
city('Hamont-Achel','be','Limburg',13740.0,5.55,51.25).
city('Hasselt','be','Limburg',69222.0,5.33,50.93).
city('Hechtel-Eksel','be','Limburg',11260.0,5.35,51.14).
city('Heers','be','Limburg',6689.0,5.28,50.75).
city('Herk-de-Stad','be','Limburg',11566.0,5.17,50.93).
city('Herstappe','be','Limburg',93.0,5.42,50.73).
city('Heusden-Zolder','be','Limburg',30988.0,5.26,51.03).
city('Hoeselt','be','Limbur',9265.0,5.48,50.85).
city('Houthalen-Helchteren','be','Limburg',29362.0,5.38,51.03).
city('Kinrooi','be','Limburg',11946.0,5.75,51.15).
city('Kortessem','be','Limburg',8042.0,5.37,50.87).
city('Lanaken','be','Limburg',24771.0,5.65,50.88).
city('Leopoldsburg','be','Limburg',14149.0,5.25,51.12).
city('Lommel','be','Limburg',31993.0,5.3,51.23).
city('Lummen','be','Limburg',13689.0,5.2,50.98).
city('Maaseik','be','Limburg',23684.0,5.8,51.1).
city('Maasmechelen','be','Limburg',36251.0,5.67,50.82).
city('Meeuwen-Gruitrode','be','Limburg',12527.0,5.52,51.1).
city('Neerpelt','be','Limburg',16122.0,5.42,51.22).
city('Nieuwerkerken','be','Limburg',6466.0,5.18,50.87).
city('Opglabbeek','be','Limburg',9452.0,5.58,51.05).
city('Overpelt','be','Limburg',13344.0,5.41,51.22).
city('Peer','be','Limburg',15551.0,5.47,51.13).
city('Riemst','be','Limburg',15809.0,5.6,50.8).
city('Sint-Truiden','be','Limburg',37859.0,5.2,50.8).
city('Tessenderlo','be','Limburg',16574.0,5.08,51.07).
city('Tongeren','be','Limburg',29816.0,5.47,50.78).
city('Voeren','be','Limburg',4235.0,5.81,50.75).
city('Wellen','be','Limburg',6804.0,5.32,50.85).
city('Zonhoven','be','Limburg',19922.0,5.35,50.98).
city('Zutendaal','be','Limburg',6962.0,5.57,50.93).
city('Arlon','be','Luxemburg',26179.0,5.82,49.68).
city('Attert','be','Luxemburg',4491.0,5.78,49.77).
city('Aubange','be','Luxemburg',14932.0,5.8,49.58).
city('Bastogne','be','Luxemburg',14395.0,5.72,50.0).
city('Bertogne','be','Luxemburg',2852.0,5.67,50.08).
city('Bertrix','be','Luxemburg',8063.0,5.25,49.85).
city('Bouillon','be','Luxemburg',5347.0,5.07,49.8).
city('Chiny','be','Luxemburg',4897.0,5.33,49.73).
city('Daverdisse','be','Luxemburg',1299.0,5.12,50.02).
city('Durbuy','be','Luxemburg',10251.0,5.47,50.35).
city('Erezee','be','Luxemburg',2930.0,5.56,50.3).
city('Etalle','be','Luxemburg',5228.0,5.6,49.68).
city('Fauvillers','be','Luxemburg',1952.0,5.67,49.85).
city('Florenville','be','Luxemburg',5464.0,5.3,49.7).
city('Gouvy','be','Luxemburg',4706.0,5.94,50.19).
city('Habay','be','Luxemburg',7704.0,5.62,49.73).
city('Herbeumont','be','Luxemburg',1612.0,5.23,49.78).
city('Hotton','be','Luxemburg',4969.0,5.45,50.27).
city('Houffalize','be','Luxemburg',4614.0,5.78,50.13).
city('La Roche-en-Ardenne','be','Luxemburg',4200.0,5.58,50.18).
city('Leglise','be','Luxemburg',3865.0,5.54,49.8).
city('Libin','be','Luxemburg',4609.0,5.25,49.98).
city('Libramont-Chevigny','be','Luxemburg',9831.0,5.38,49.92).
city('Manhay','be','Luxemburg',3128.0,5.67,50.3).
city('Marche-en-Famenne','be','Luxemburg',16856.0,5.33,50.2).
city('Martelange','be','Luxemburg',1440.0,5.73,49.83).
city('Meix-devant-Virton','be','Luxemburg',2637.0,5.48,49.6).
city('Messancy','be','Luxemburg',7144.0,5.82,49.6).
city('Musson','be','Luxemburg',4225.0,5.7,49.57).
city('Nassogne','be','Luxemburg',5081.0,5.35,50.13).
city('Neufchateau','be','Luxemburg',6416.0,5.44,49.83).
city('Paliseul','be','Luxemburg',5037.0,5.13,49.9).
city('Rendeux','be','Luxemburg',2320.0,5.5,50.23).
city('Rouvroy','be','Luxemburg',1946.0,5.5,49.53).
city('Saint-Hubert','be','Luxemburg',5538.0,5.38,50.02).
city('Saint-Leger','be','Luxemburg',3092.0,5.66,49.61).
city('Sainte-Ode','be','Luxemburg',2310.0,5.53,50.08).
city('Tellin','be','Luxemburg',2353.0,5.22,50.08).
city('Tenneville','be','Luxemburg',2510.0,5.53,50.1).
city('Tintigny','be','Luxemburg',3538.0,5.52,49.68).
city('Vaux-sur-Sure','be','Luxemburg',4581.0,5.58,49.92).
city('Vielsalm','be','Luxemburg',7291.0,5.92,50.28).
city('Virton','be','Luxemburg',11259.0,5.53,49.57).
city('Wellin','be','Luxemburg',2937.0,5.12,50.08).
city('Andenne','be','Namur',24055.0,5.1,50.48).
city('Anhee','be','Namur',7125.0,4.88,50.31).
city('Assesse','be','Namur',6279.0,5.02,50.37).
city('Beauraing','be','Namur',8242.0,4.97,50.12).
city('Bievre','be','Namur',3207.0,5.02,49.92).
city('Cerfontaine','be','Namur',4500.0,4.42,50.17).
city('Ciney','be','Namur',14830.0,5.1,50.3).
city('Couvin','be','Namur',13518.0,4.48,50.05).
city('Dinant','be','Namur',12875.0,4.92,50.27).
city('Doische','be','Namur',2739.0,4.75,50.13).
city('Eghezee','be','Namur',14352.0,4.92,50.59).
city('Floreffe','be','Namur',7480.0,4.78,50.43).
city('Florennes','be','Namur',10723.0,4.62,50.25).
city('Fosses-la-Ville','be','Namur',9062.0,4.7,50.4).
city('Gedinne','be','Namur',4416.0,4.93,49.98).
city('Gembloux','be','Namur',21676.0,4.68,50.57).
city('Gesves','be','Namur',6150.0,5.07,50.4).
city('Hamois','be','Namur',6662.0,5.13,50.33).
city('Hastiere','be','Namur',5147.0,4.83,50.22).
city('Havelange','be','Namur',4790.0,5.23,50.38).
city('Houyet','be','Namur',4505.0,5.02,50.18).
city('Jemeppe-sur-Sambre','be','Namur',17774.0,4.67,50.46).
city('La Bruyere','be','Namur',8194.0,4.61,50.38).
city('Mettet','be','Namur',12014.0,4.67,50.32).
city('Namur','be','Namur',106284.0,4.87,50.47).
city('Ohey','be','Namur',4324.0,5.13,50.43).
city('Onhaye','be','Namur',3014.0,4.83,50.25).
city('Philippeville','be','Namur',8051.0,4.53,50.2).
city('Profondeville','be','Namur',11401.0,4.87,50.38).
city('Rochefort','be','Namur',11978.0,5.22,50.17).
city('Sombreffe','be','Namur',7452.0,4.6,50.52).
city('Somme-Leuze','be','Namur',4532.0,5.37,50.33).
city('Vresse-sur-Semois','be','Namur',2921.0,4.93,49.87).
city('Walcourt','be','Namur',17501.0,4.42,50.25).
city('Yvoir','be','Namur',8169.0,4.88,50.33).
city('Alveringem','be','West Flanders',4910.0,2.72,51.02).
city('Anzegem','be','West Flanders',13920.0,3.47,50.83).
city('Ardooie','be','West Flanders',9161.0,3.2,50.98).
city('Avelgem','be','West Flanders',9106.0,3.43,50.77).
city('Beernem','be','West Flanders',14512.0,3.33,51.15).
city('Blankenberge','be','West Flanders',18230.0,3.13,51.32).
city('Bredene','be','West Flanders',14862.0,2.97,51.23).
city('Brugge','be','West Flanders',116709.0,3.23,51.22).
city('Damme','be','West Flanders',10924.0,3.28,51.25).
city('De Haan','be','West Flanders',11766.0,3.03,51.27).
city('De Panne','be','West Flanders',9799.0,2.58,51.1).
city('Deerlijk','be','West Flanders',11292.0,3.35,50.85).
city('Dentergem','be','West Flanders',8038.0,3.42,50.97).
city('Diksmuide','be','West Flanders',15515.0,2.87,51.03).
city('Gistel','be','West Flanders',11084.0,2.95,51.17).
city('Harelbeke','be','West Flanders',25978.0,3.3,50.85).
city('Hooglede','be','West Flanders',9900.0,3.08,50.98).
city('Houthulst','be','West Flanders',8951.0,2.95,50.98).
city('Ichtegem','be','West Flanders',13582.0,3.0,51.1).
city('Ieper','be','West Flanders',35089.0,2.88,50.85).
city('Ingelmunster','be','West Flanders',10603.0,3.25,50.92).
city('Izegem','be','West Flanders',26382.0,3.2,50.92).
city('Jabbeke','be','West Flanders',13488.0,3.08,51.18).
city('Knokke-Heist','be','West Flanders',33781.0,3.27,51.35).
city('Koekelare','be','West Flanders',8317.0,2.97,51.08).
city('Koksijde','be','West Flanders',21027.0,2.65,51.1).
city('Kortemark','be','West Flanders',11937.0,3.03,51.03).
city('Kortrijk','be','West Flanders',73879.0,3.27,50.83).
city('Kuurne','be','West Flanders',12638.0,3.28,50.85).
city('Langemark-Poelkapelle','be','West Flanders',7755.0,2.92,50.92).
city('Ledegem','be','West Flanders',9102.0,3.12,50.85).
city('Lendelede','be','West Flanders',5393.0,3.23,50.88).
city('Lichtervelde','be','West Flanders',8169.0,3.15,51.03).
city('Lo-Reninge','be','West Flanders',3300.0,2.79,50.95).
city('Menen','be','West Flanders',31916.0,3.12,50.8).
city('Mesen','be','West Flanders',975.0,2.9,50.77).
city('Meulebeke','be','West Flanders',10948.0,3.28,50.95).
city('Middelkerke','be','West Flanders',17789.0,2.82,51.18).
city('Moorslede','be','West Flanders',10720.0,3.07,50.88).
city('Nieuwpoort','be','West Flanders',10845.0,2.75,51.13).
city('Oostkamp','be','West Flanders',21489.0,3.23,51.15).
city('Oostrozebeke','be','West Flanders',7489.0,3.33,50.92).
city('Ostend','be','West Flanders',69011.0,2.92,51.22).
city('Oudenburg','be','West Flanders',8752.0,3.0,51.18).
city('Pittem','be','West Flanders',6589.0,3.27,51.0).
city('Poperinge','be','West Flanders',19537.0,2.72,50.85).
city('Roeselare','be','West Flanders',56016.0,3.13,50.95).
city('Ruiselede','be','West Flanders',5129.0,3.4,51.05).
city('Spiere-Helkijn','be','West Flanders',2070.0,3.36,50.72).
city('Staden','be','West Flanders',10786.0,3.02,50.98).
city('Tielt','be','West Flanders',19299.0,3.33,51.0).
city('Torhout','be','West Flanders',18933.0,3.1,51.07).
city('Veurne','be','West Flanders',11983.0,2.67,51.07).
city('Waregem','be','West Flanders',35896.0,3.42,50.88).
city('Wervik','be','West Flanders',17340.0,3.03,50.78).
city('Wevelgem','be','West Flanders',30954.0,3.17,50.8).
city('Wielsbeke','be','West Flanders',8828.0,3.37,50.9).
city('Wingene','be','West Flanders',12887.0,3.27,51.07).
city('Zedelgem','be','West Flanders',21968.0,3.13,51.15).
city('Zonnebeke','be','West Flanders',11581.0,2.98,50.87).
city('Zuienkerke','be','West Flanders',2736.0,3.17,51.27).
city('Zwevegem','be','West Flanders',23358.0,3.33,50.8).
city('Belize','bz','Belize',61462.0,-88.19,17.5).
city('San Pedro','bz','Belize',8418.0,-87.96,17.92).
city('Belmopan','bz','Cayo',13381.0,-88.79,17.25).
city('Benque Viejo','bz','Cayo',7092.0,-89.12,17.09).
city('San Ignacio','bz','Cayo',16813.0,-89.06,17.16).
city('Corozal','bz','Corozal',8724.0,-88.39,18.4).
city('Orange Walk','bz','Orange Walk',15298.0,-88.56,18.09).
city('Dangriga','bz','Stann Creek',10750.0,-88.22,16.97).
city('Punta Gorda','bz','Toledo',5026.0,-88.81,16.1).
city('Banikoara','bj','Alibori',22487.0,2.44,11.29).
city('Kandi','bj','Alibori',109705.0,2.94,11.13).
city('Malanville','bj','Alibori',37117.0,3.38,11.87).
city('Kouande','bj','Atacora',6306.0,1.7,10.33).
city('Natitingou','bj','Atacora',80896.0,1.39,10.32).
city('Abomey-Calavi','bj','Atlantique',385823.0,2.36,6.44).
city('Allada','bj','Atlantique',20094.0,2.15,6.65).
city('Ouidah','bj','Atlantique',83506.0,2.09,6.36).
city('Tanguiete','bj','Atlantique',19833.0,1.27,10.62).
city('Bembereke','bj','Borgou',24006.0,2.67,10.22).
city('Nikki','bj','Borgou',54009.0,3.22,9.93).
city('Parakou','bj','Borgou',163759.0,2.62,9.34).
city('Tchaourou','bj','Borgou',20971.0,2.6,8.88).
city('Dassa','bj','Collines',21672.0,2.2,7.77).
city('Savalou','bj','Collines',30187.0,1.97,7.93).
city('Save','bj','Collines',75973.0,2.49,8.03).
city('Aplahoue','bj','Couffo',19862.0,1.67,6.94).
city('Dogbo','bj','Couffo',41312.0,1.77,6.8).
city('Bassila','bj','Donga',23616.0,1.67,9.01).
city('Djougou','bj','Donga',202834.0,1.68,9.7).
city('Cotonou','bj','Littoral',690584.0,2.44,6.36).
city('Athieme','bj','Mono',13585.0,1.71,6.6).
city('Come','bj','Mono',29208.0,1.88,6.4).
city('Grand Popo','bj','Mono',9847.0,1.83,6.28).
city('Lokossa','bj','Mono',86987.0,1.71,6.62).
city('Porto Novo','bj','Oueme',234176.0,2.63,6.48).
city('Ketou','bj','Plateau',22341.0,2.61,7.36).
city('Pobe','bj','Plateau',32983.0,2.68,6.97).
city('Sakete','bj','Plateau',30111.0,2.67,6.72).
city('Abomey','bj','Zou',82158.0,1.99,7.19).
city('Bohicon','bj','Zou',125116.0,2.07,7.17).
city('Cove','bj','Zou',38566.0,2.3,7.24).
city('Hamilton','bm','Hamilton',902.0,-64.79,32.3).
city('Saint George','bm','Saint George',1802.0,-64.67,32.37).
city('Jakar','bt','Bumthang',4829.0,90.82,27.6).
city('Chhukha','bt','Chhukha',1203.0,89.54,27.09).
city('Damphu','bt','Chirang',2040.0,90.1,27.07).
city('Taga Dzong','bt','Daga',3168.0,89.88,27.07).
city('Geylegphug','bt','Geylegphug',7464.0,90.25,26.87).
city('Ha','bt','Ha',1505.0,89.28,27.37).
city('Lhuntshi','bt','Lhuntshi',1935.0,91.16,27.65).
city('Mongar','bt','Mongar',1397.0,91.2,27.25).
city('Pemagatsel','bt','Pemagatsel',1720.0,91.38,27.08).
city('Gasa','bt','Punakha',1612.0,89.57,27.93).
city('Punakha','bt','Punakha',18170.0,89.9,27.78).
city('Paro','bt','Rinpung',4536.0,89.42,27.44).
city('Phuntsholing','bt','Samchi',65892.0,89.38,26.85).
city('Samchi','bt','Samchi',1193.0,90.62,27.3).
city('Deothang','bt','Samdrup Jongkhar',3545.0,91.53,26.89).
city('Samdrup Jongkhar','bt','Samdrup Jongkhar',14134.0,91.5,26.88).
city('Shemgang','bt','Shemgang',1182.0,90.65,27.23).
city('Tashigang','bt','Tashigang',4519.0,91.57,27.33).
city('Timphu','bt','Timphu',66206.0,89.7,27.48).
city('Tongsa','bt','Tongsa',2365.0,90.5,27.5).
city('Wangdiphodrang','bt','Wangdiphodrang',3393.0,89.9,27.48).
city('Guayaramerin','bo','Beni',36010.0,-65.41,-10.83).
city('Magdalena','bo','Beni',7790.0,-64.13,-13.35).
city('Reyes','bo','Beni',7376.0,-67.37,-14.31).
city('Riberalta','bo','Beni',74018.0,-66.1,-11.0).
city('Rurrenabaque','bo','Beni',11750.0,-67.56,-14.46).
city('San Borja','bo','Beni',19641.0,-66.85,-14.82).
city('San Ignacio','bo','Beni',11705.0,-65.6,-14.88).
city('San Joaquin','bo','Beni',3557.0,-59.56,-18.44).
city('San Ramon','bo','Beni',4390.0,-64.71,-13.29).
city('Santa Ana','bo','Beni',12582.0,-65.58,-13.76).
city('Santa Rosa','bo','Beni',4459.0,-66.88,-14.17).
city('Trinidad','bo','Beni',84264.0,-64.91,-14.84).
city('Camargo','bo','Chuquisaca',4715.0,-65.21,-20.64).
city('Monteagudo','bo','Chuquisaca',8290.0,-63.99,-19.82).
city('Padilla','bo','Chuquisaca',2920.0,-64.31,-19.3).
city('Sucre','bo','Chuquisaca',224846.0,-65.26,-19.06).
city('Tara','bo','Chuquisaca',2428.0,-64.92,-19.18).
city('Villa Serano','bo','Chuquisaca',3016.0,-64.32,-19.12).
city('Aiquile','bo','Cochabamba',8225.0,-65.18,-18.19).
city('Arani','bo','Cochabamba',3906.0,-65.77,-17.58).
city('Capinota','bo','Cochabamba',5157.0,-66.26,-17.72).
city('Chimore','bo','Cochabamba',5147.0,-65.13,-16.98).
city('Cliza','bo','Cochabamba',8655.0,-65.93,-17.59).
city('Cochabamba','bo','Cochabamba',900440.0,-66.17,-17.38).
city('Colomi','bo','Cochabamba',3923.0,-65.87,-17.34).
city('Irpa Irpa','bo','Coch',2968.0,-66.28,-17.7).
city('Mizque','bo','Cochabamba',2911.0,-65.34,-17.92).
city('Punata','bo','Cochabamba',15195.0,-65.84,-17.55).
city('Sipe Sipe','bo','Cochabamba',3777.0,-66.36,-17.44).
city('Tarata','bo','Cochabamba',8045.0,-66.03,-17.62).
city('Achacachi','bo','La Paz',8447.0,-68.69,-16.05).
city('Caranavi','bo','La Paz',14915.0,-67.62,-15.76).
city('Chulumani','bo','La Paz',2953.0,-67.52,-16.41).
city('Colquiri','bo','La Paz',3934.0,-67.13,-17.39).
city('Copacabana','bo','La Paz',4508.0,-69.08,-16.17).
city('Coripata','bo','La Paz',2107.0,-67.6,-16.31).
city('Coroico','bo','La Paz',2361.0,-67.72,-16.19).
city('El Alto','bo','La Paz',834176.0,-68.17,-16.5).
city('Guanay','bo','La Paz',3915.0,-67.85,-15.45).
city('La Paz','bo','La Paz',812819.0,-68.15,-16.5).
city('Lahuachaca','bo','La Paz',3235.0,-67.66,-17.35).
city('Mapiri','bo','La Paz',2598.0,-68.16,-15.26).
city('Patacamaya','bo','La Paz',12261.0,-67.92,-17.24).
city('Quime','bo','La Paz',2405.0,-67.22,-16.98).
city('Sorata','bo','La Paz',2190.0,-68.66,-15.79).
city('Tipuani','bo','La Paz',2585.0,-68.0,-15.36).
city('Viloco','bo','La Paz',1900.0,-67.55,-16.93).
city('Caracollo','bo','Oruro',4708.0,-67.22,-17.64).
city('Challapata','bo','Oruro',8016.0,-66.78,-18.9).
city('Eucaliptus','bo','Oruro',2373.0,-67.51,-17.6).
city('Huanuni','bo','Oruro',15492.0,-66.84,-18.29).
city('Machacamarca','bo','Oruro',2045.0,-67.03,-18.17).
city('Oruro','bo','Oruro',208687.0,-67.12,-17.98).
city('Poopo','bo','Oruro',1720.0,-66.97,-18.37).
city('Santiago de Huari','bo','Oruro',3181.0,-66.81,-19.0).
city('Totoral','bo','Oruro',1645.0,-66.87,-18.52).
city('Cobija','bo','Pando',26583.0,-68.77,-11.02).
city('Atocha','bo','Potosi',1833.0,-66.24,-20.92).
city('Betanzos','bo','Potosi',4847.0,-65.45,-19.56).
city('Colquechaca','bo','Potosi',1706.0,-66.02,-18.67).
city('Llallagua','bo','Potosi',28070.0,-66.64,-18.42).
city('Potosi','bo','Potosi',141254.0,-65.75,-19.57).
city('Santa Barbara','bo','Potosi',2434.0,-66.06,-20.91).
city('Tupiza','bo','Potosi',22234.0,-65.72,-21.44).
city('Uncia','bo','Potosi',5142.0,-66.57,-18.47).
city('Uyuni','bo','Potosi',10294.0,-66.83,-20.46).
city('Villazon','bo','Potosi',30254.0,-65.6,-22.08).
city('Abapo','bo','Santa Cruz',2419.0,-63.46,-18.83).
city('Agustin Saavedra','bo','Santa Cruz',4150.0,-63.21,-17.23).
city('Ascension','bo','Santa Cruz',14431.0,-63.08,-15.7).
city('Boyuibe','bo','Santa Cruz',3075.0,-63.28,-20.4).
city('Buena Vista','bo','Santa Cruz',4283.0,-63.66,-17.45).
city('Camiri','bo','Santa',27971.0,-63.52,-20.05).
city('Charagua','bo','Santa Cruz',3026.0,-63.22,-19.8).
city('Comarapa','bo','Santa Cruz',4446.0,-64.48,-17.9).
city('Concepcion','bo','Santa Cruz',6901.0,-60.9,-16.43).
city('Cotoca','bo','Santa Cruz',18349.0,-63.05,-17.82).
city('El Carmen','bo','Santa Cruz',8591.0,-63.06,-17.06).
city('El Torno','bo','Santa Cruz',15544.0,-63.38,-17.98).
city('Jorochito','bo','Santa Cruz',4013.0,-63.43,-18.06).
city('La Angostura','bo','Santa Cruz',2513.0,-64.21,-18.13).
city('La Belgica','bo','Santa Cruz',5504.0,-63.21,-17.55).
city('La Guardia','bo','Santa Cruz',10259.0,-63.38,-17.88).
city('Limoncito','bo','Santa Cruz',3622.0,-63.4,-18.03).
city('Los Negros','bo','Santa Cruz',3046.0,-63.43,-17.73).
city('Mairana','bo','Santa Cruz',4298.0,-63.96,-18.13).
city('Mineros','bo','Santa Cruz',14386.0,-63.24,-17.12).
city('Montero','bo','Santa Cruz',88623.0,-63.26,-17.35).
city('Okinawa','bo','Santa Cruz',4945.0,-62.83,-17.23).
city('Pailon','bo','Santa Cruz',9304.0,-62.75,-17.64).
city('Portachuelo','bo','Santa Cruz',11486.0,-63.4,-1.0).
city('Puerto Pailas','bo','Santa Cruz',2675.0,-62.81,-17.65).
city('Puerto Quijarro','bo','Santa Cruz',10393.0,-57.77,-17.78).
city('Puerto Suarez','bo','Santa Cruz',12254.0,-57.85,-18.95).
city('Robore','bo','Santa Cruz',9883.0,-59.76,-18.33).
city('Samaipata','bo','Santa Cruz',3250.0,-63.77,-18.18).
city('San Carlos','bo','Santa Cruz',4180.0,-63.73,-17.4).
city('San Ignacio','bo','Santa Cruz',23570.0,-60.96,-16.37).
city('San Javier','bo','Santa Cruz',7025.0,-62.5,-16.29).
city('San Jose','bo','Santa Cruz',9749.0,-60.78,-17.85).
city('San Juan','bo','Santa Cruz',3707.0,-63.7,-17.49).
city('San Julian','bo','Santa Cruz',7706.0,-62.88,-17.79).
city('San Matias','bo','Santa Cruz',6352.0,-58.42,-16.36).
city('San Miguel','bo','Santa Cruz',4906.0,-60.97,-16.69).
city('San Pedro','bo','Santa Cruz',2990.0,-59.82,-18.29).
city('San Rafael','bo','Santa Cruz',2384.0,-60.68,-16.78).
city('San Ramon','bo','Santa Cruz',6422.0,-63.16,-14.49).
city('Santa Cruz','bo','Santa Cruz',1342640.0,-63.21,-17.77).
city('Santa Fe','bo','Santa Cruz',6845.0,-63.86,-17.39).
city('Santa Rita','bo','Santa Cruz',2444.0,-63.36,-17.98).
city('Santa Rosa','bo','Santa Cruz',4575.0,-61.83,-16.85).
city('Urubicha','bo','Santa Cruz',3269.0,-62.95,-15.39).
city('Valle Grande','bo','Santa Cruz',8423.0,-64.11,-18.49).
city('Warnes','bo','Santa Cruz',22038.0,-63.18,-17.52).
city('Yapacani','bo','Santa Cruz',18189.0,-63.87,-17.39).
city('Bermejo','bo','Tarija',28287.0,-64.35,-22.73).
city('Entre Rios','bo','Tarija',2685.0,-64.19,-21.53).
city('San Lorenzo','bo','Tarija',2921.0,-64.77,-21.48).
city('Tarija','bo','Tarija',159275.0,-64.74,-21.53).
city('Villamontes','bo','Tarija',18762.0,-63.5,-21.25).
city('Yacuiba','bo','Tarija',82808.0,-63.7,-22.03).
city('Banovici','ba','Federacija Bosna i Hercegovina',7211.0,18.52,44.41).
city('Barice','ba','Federacija Bosna i Hercegovina',3697.0,18.48,44.54).
city('Bihac','ba','Federacija Bosna i Hercegovina',75641.0,15.87,44.82).
city('Bijela','ba','Federacija Bosna i Hercegovina',3484.0,17.95,43.61).
city('Bila','ba','Federacija Bosna i Hercegovina',4397.0,16.93,43.78).
city('Blagaj','ba','Federacija Bosna i Hercegovina',4715.0,17.89,43.26).
city('Bosanska Krupa','ba','Federacija Bosna i Hercegovina',15193.0,16.15,44.88).
city('Bosansko Grahovo','ba','Federacija Bosna i Hercegovina',5642.0,16.36,44.18).
city('Brestovsko','ba','Federacija Bosna i Hercegovina',4043.0,18.04,44.02).
city('Breza','ba','Federacija Bosna i Hercegovina',3732.0,18.24,44.04).
city('Bugojno','ba','Federacija Bosna i Hercegovina',41378.0,17.45,44.06).
city('Busovaca','ba','Federacija Bosna i Hercegovina',4775.0,17.88,44.1).
city('Buzim','ba','Federacija Bosna i Hercegovina',7229.0,16.03,45.05).
city('Capljina','ba','Federacija Bosna i Hercegovina',7923.0,17.7,43.11).
city('Careva Cuprija','ba','Federacija Bosna i Hercegovina',3954.0,18.43,44.27).
city('Cazin','ba','Federacija Bosna i Hercegovina',21741.0,15.94,44.97).
city('Cim','ba','Federacija Bosna i Hercegovina',3966.0,17.78,43.35).
city('Citluk','ba','Federacija Bosna i Hercegovina',5718.0,17.7,43.23).
city('Coralici','ba','Federacija Bosna i Hercegovina',5223.0,15.87,45.01).
city('Crnici','ba','Federacija Bosna i Hercegovina',5789.0,17.86,43.13).
city('Divicani','ba','Federacija Bosna i Hercegovina',7250.0,17.33,44.37).
city('Djurdjevik','ba','Federacija Bosna i Hercegovina',6867.0,18.65,44.41).
city('Dobrinje','ba','Federacija Bosna i Hercegovina',3987.0,18.12,44.05).
city('Donja Dubica','ba','Federacija Bosna i H',3489.0,18.41,45.08).
city('Donja Mahala','ba','Federacija Bosna i Hercegovina',5565.0,18.67,45.05).
city('Donja Medjidja','ba','Federacija Bosna i Hercegovina',3782.0,18.4,44.8).
city('Donja Orahovica','ba','Federacija Bosna i Hercegovina',5612.0,18.37,44.65).
city('Donje Dubrave','ba','Federacija Bosna i Hercegovina',3811.0,18.7,44.48).
city('Donje Vukovije','ba','Federacija Bosna i Hercegovina',3535.0,18.75,44.46).
city('Donji Vakuf','ba','Federacija Bosna i Hercegovina',7955.0,17.4,44.14).
city('Dreznica','ba','Federacija Bosna i Hercegovina',3908.0,17.28,43.53).
city('Drinovci','ba','Federacija Bosna i Hercegovina',3791.0,17.35,43.36).
city('Dubravica','ba','Federacija Bosna i Hercegovina',3868.0,18.12,44.44).
city('Fojnica','ba','Federacija Bosna i Hercegovina',8244.0,17.9,43.96).
city('Glamoc','ba','Federacija Bosna i Hercegovina',4015.0,16.85,44.05).
city('Gnojnica','ba','Federacija Bosna i Hercegovina',3985.0,18.45,44.62).
city('Gorazde','ba','Federacija Bosna i Hercegovina',17649.0,18.98,43.67).
city('Gornja Koprivna','ba','Federacija Bosna i Hercegovina',4600.0,15.96,45.01).
city('Gornja Tuzla','ba','Federacija Bosna i Hercegovina',4864.0,18.76,44.56).
city('Gornje Dubrave','ba','Federacija Bosna i Hercegovina',4821.0,18.73,44.47).
city('Gornje Zivinice','ba','Feder',4661.0,18.62,44.43).
city('Gornji Poljice','ba','Federacija Bosna i Hercegovina',3734.0,18.51,44.48).
city('Gornji Vakuf','ba','Federacija Bosna i Hercegovina',7014.0,17.59,43.94).
city('Gostovici','ba','Federacija Bosna i Hercegovina',5802.0,18.16,44.42).
city('Gracanica','ba','Federacija Bosna i Hercegovina',9815.0,18.3,44.22).
city('Gradacac','ba','Federacija Bosna i Hercegovina',15659.0,18.43,44.88).
city('Gromiljak','ba','Federacija Bosna i Hercegovina',6457.0,18.05,43.97).
city('Grude','ba','Federacija Bosna i Hercegovina',4627.0,17.42,43.36).
city('Hadzici','ba','Federacija Bosna i Hercegovina',7173.0,18.21,43.0).
city('Hajdarevici','ba','Federacija Bosna i Hercegovina',6958.0,18.26,44.46).
city('Hotonj','ba','Federacija Bosna i Hercegovina',4013.0,18.37,43.89).
city('Ilici','ba','Federacija Bosna i Hercegovina',3688.0,17.77,43.35).
city('Ilijas','ba','Federacija Bosna i Hercegovina',5854.0,18.27,43.95).
city('Izacic','ba','Federacija Bosna i Hercegovina',4089.0,15.78,44.88).
city('Jablanica','ba','Federacija Bosna i Hercegovina',6209.0,17.77,43.66).
city('Jajce','ba','Federacija Bosna i Hercegovina',9762.0,17.27,44.34).
city('Jelah','ba','Federacija Bosna i Hercegovina',5291.0,17.96,44.65).
city('Jezerski','ba','Federacija Bosna i Hercegovina',4361.0,16.08,44.98).
city('Kacuni','ba','Federacija Bosna i Hercegovina',5042.0,17.94,44.07).
city('Kakanj','ba','Federacija Bosna i Hercegovina',12405.0,18.12,44.13).
city('Karadaglije','ba','Federacija Bosna i Hercegovina',3700.0,18.02,44.57).
city('Kiseljak','ba','Federacija Bosna i Hercegovina',5961.0,18.33,44.22).
city('Kladanj','ba','Federacija Bosna i Hercegovina',6783.0,18.69,44.23).
city('Kljuc','ba','Federacija Bosna i Hercegovina',7244.0,16.77,44.54).
city('Kobilja Glava','ba','Federacija Bosna i Hercegovina',3666.0,18.39,43.88).
city('Kocerin','ba','Federacija Bosna i Hercegovina',3516.0,17.49,43.39).
city('Konjic','ba','Federacija Bosna i Hercegovina',15950.0,17.96,43.65).
city('Kovaci','ba','Federacija Bosna i Hercegovina',6410.0,18.21,44.45).
city('Lijesnica','ba','Federacija Bosna i Hercegovina',3559.0,18.07,44.49).
city('Liskovac','ba','Federacija Bosna i Hercegovina',4359.0,16.05,44.94).
city('Listica','ba','Federacija Bosna i Hercegovina',9370.0,17.59,43.38).
city('Livno','ba','Federacija Bosna i Hercegovina',11748.0,17.01,43.83).
city('Ljubuski','ba','Federacija Bosna i Hercegovina',9987.0,17.55,43.2).
city('Lokvine','ba','Federacija Bosna i Hercegovina',3928.0,17.86,44.2).
city('Lukavac','ba','Federacija Bosna i Hercegovina',12607.0,18.42,44.52).
city('Lukavica','ba','Federacija Bosna i Hercegovina',4084.0,18.17,44.76).
city('Maglaj','ba','Federacija Bosna i Hercegovina',7398.0,18.1,44.55).
city('Mahale','ba','Federacija Bosna i Hercegovina',5062.0,18.26,44.01).
city('Mala Kladusa','ba','Federacija Bosna i Hercegovina',6033.0,15.86,45.13).
city('Malesici','ba','Federacija Bosna i Hercegovina',3764.0,18.27,44.74).
city('Mionica','ba','Federacija Bosna i Hercegovina',8701.0,18.46,44.87).
city('Mostar','ba','Federacija Bosna i Hercegovina',104517.0,17.81,43.34).
city('Mostre','ba','Federacija Bosna i Hercegovina',4009.0,18.14,44.03).
city('Mramor','ba','Federacija Bosna i Hercegovina',3918.0,18.56,44.59).
city('Novi Miljanovci','ba','Federacija Bosna i Hercegovina',3590.0,17.93,44.7).
city('Novi Seher','ba','Federacija Bosna i Hercegovina',4416.0,18.03,44.51).
city('Novi Travnik','ba','Federacija Bosna i Hercegovina',10006.0,17.66,44.17).
city('Odzak','ba','Federacija Bosna i Hercegovina',11621.0,18.33,45.01).
city('Olovo','ba','Federacija Bosna i Hercegovina',3305.0,18.58,44.13).
city('Orasac','ba','Federacija Bosna i Hercegovina',3856.0,16.07,44.63).
city('Orasje','ba','Federacija Bosna i Hercegovina',3613.0,18.69,45.04).
city('Orguz','ba','Federacija Bosna i Hercegovina',4371.0,16.86,43.77).
city('Ostra Luka','ba','Federacija Bosna i Hercegovina',3923.0,18.59,45.0).
city('Ostrozac','ba','Federacija Bosna i Hercegovina',5456.0,15.94,44.91).
city('Otoka','ba','Federacija Bosna i Hercegovina',6595.0,16.18,44.96).
city('Pajic Polje','ba','Federacija Bosna i Hercegovina',4026.0,17.53,43.98).
city('Pazaric','ba','Federacija Bosna i Hercegovina',4787.0,18.16,43.79).
city('Peci','ba','Federacija Bosna i Hercegovina',3650.0,16.79,44.63).
city('Pecigrad','ba','Federacija Bosna i Hercegovina',6514.0,15.9,45.05).
city('Pjanici','ba','Federacija Bosna i Hercegovina',3537.0,15.82,44.98).
city('Podhum','ba','Federacij',5801.0,17.0,43.72).
city('Podvelez','ba','Federacija Bosna i Hercegovina',4198.0,17.9,43.31).
city('Podzvizd','ba','Federacija Bosna i Hercegovina',6665.0,15.87,45.17).
city('Polje','ba','Federacija Bosna i Hercegovina',3799.0,18.07,43.88).
city('Posusje','ba','Federacija Bosna i Hercegovina',5114.0,17.33,43.47).
city('Potoci','ba','Federacija Bosna i Hercegovina',8311.0,17.88,43.41).
city('Prozor','ba','Federacija Bosna i Hercegovina',10349.0,17.61,43.82).
city('Puracic','ba','Federacija Bosna i Hercegovina',3461.0,18.48,44.55).
city('Radisici','ba','Federacija Bosna i Hercegovina',4071.0,17.54,43.22).
city('Rodoc','ba','Federacija Bosna i Hercegovina',5159.0,17.81,43.31).
city('Rumboci','ba','Federacija Bosna i Hercegovina',3854.0,17.5,43.83).
city('Sanica','ba','Federacija Bosna i Hercegovina',5666.0,16.64,44.61).
city('Sanski Most','ba','Federacija Bosna i Hercegovina',13550.0,16.67,44.77).
city('Sarajevo','ba','Federacija Bosna i Hercegovina',696726.0,18.38,43.85).
city('Serici','ba','Federacija Bosna i Hercegovina',3663.0,18.56,44.47).
city('Skokovi','ba','Federacija Bosna i Hercegovina',3553.0,15.91,45.03).
city('Sladna','ba','Federacija Bosna i Hercegovina',4304.0,18.42,44.73).
city('Solina','ba','Federacija Bosna i Hercegovina',4780.0,18.69,44.56).
city('Srebrenik','ba','Federacija Bosna i Hercegovina',6723.0,18.49,44.71).
city('Stijena','ba','Federacija Bosna i Hercegovina',10844.0,16.02,44.94).
city('Stjepan Polje','ba','Federacija Bosna i Hercegovina',4341.0,18.27,44.73).
city('Stolac','ba','Federacija Bosna i Hercegovina',7733.0,17.96,43.08).
city('Stupari','ba','Federacija Bosna i Hercegovina',4424.0,18.68,44.31).
city('Sturlic','ba','Federacija Bosna i Hercegovina',5013.0,15.78,45.06).
city('Sumatac','ba','Federacija Bosna i Hercegovina',4987.0,15.86,45.1).
city('Svojat','ba','Federacija Bosna i Hercegovina',3515.0,18.74,44.39).
city('Tesanj','ba','Federacija Bosna i Hercegovina',7549.0,17.99,44.61).
city('Tesanjka','ba','Federacija Bosna i Hercegovina',5666.0,18.01,44.67).
city('Todorovo','ba','Federacija Bosna i Hercegovina',9560.0,15.93,45.09).
city('Tojsici','ba','Federacija Bosna i Hercegovina',6587.0,18.79,44.5).
city('Tolisa','ba','Federacija Bosna i Hercegovina',4282.0,18.64,45.04).
city('Tomislavgrad','ba','Federacija Bosna i Hercegovina',7737.0,17.23,43.72).
city('Travnik','ba','Federacija Bosna i Hercegovina',31127.0,17.67,44.23).
city('Trzacka Rastela','ba','Federacija Bosna i Hercegovina',6617.0,15.79,44.97).
city('Turbe','ba','Federacija Bosna i Hercegovina',4766.0,17.57,44.24).
city('Tuzla','ba','Federacija Bosna i Hercegovina',142484.0,18.67,44.54).
city('Ustikolina','ba','Federacija Bosna i Hercegovina',4446.0,18.79,43.58).
city('Vares','ba','Federacija Bosna i Hercegovina',7193.0,18.33,44.16).
city('Varoska Rijeka','ba','Federacija Bosna i Hercegovina',6573.0,16.01,45.08).
city('Velagici','ba','Federacija Bosna i Hercegovina',4972.0,16.73,44.56).
city('Velika Kladusa','ba','Federacija Bosna i Hercegovina',19330.0,15.81,45.19).
city('Vidosi','ba','Federacija Bosna i Hercegovina',3905.0,17.03,43.77).
city('Visoko','ba','Federacija Bosna i Hercegovina',17890.0,18.18,43.99).
city('Vitez','ba','Federacija Bosna i Hercegovina',8140.0,17.79,44.15).
city('Vitina','ba','Federacija Bosna i Hercegovina',4384.0,17.5,43.25).
city('Vogosca','ba','Federacija Bosna i Hercegovina',8179.0,18.35,43.9).
city('Voljevac','ba','Federacija Bosna i Hercegovina',3764.0,17.66,43.88).
city('Vozuca','ba','Federacija Bosna i Hercegovina',3209.0,18.37,44.38).
city('Vrnograc','ba','Federacija Bosna i Hercegovina',6859.0,15.95,45.16).
city('Zabrisce','ba','Federacija Bosna i Hercegovina',4261.0,16.94,43.79).
city('Zavidovici','ba','Federacija Bosna i Hercegovina',14380.0,18.15,44.45).
city('Zboriste','ba','Federacija Bosna i Hercegovina',4922.0,16.02,45.15).
city('Zeljezno Polje','ba','Federacija Bosna i Hercegovina',5783.0,17.93,44.41).
city('Zenica','ba','Federacija Bosna i Hercegovina',164422.0,17.91,44.2).
city('Zepce','ba','Federacija Bosna i Hercegovina',8502.0,18.04,44.43).
city('Zivinice','ba','Federacija Bosna i Hercegovina',13640.0,18.65,44.45).
city('Banja Luka','ba','Republika Srpska',221100.0,17.19,44.78).
city('Batkovici','ba','Republika Srpska',4923.0,19.2,44.85).
city('Bijeljina','ba','Republika Srpska',37691.0,19.22,44.76).
city('Bileca','ba','Republika Srpska',13256.0,18.43,42.87).
city('Blatnica','ba','Republika Srpska',5675.0,17.83,44.46).
city('Bosanska Dubica','ba','Republika Srpska',9959.0,16.81,45.18).
city('Bosanska Gradiska','ba','Republika Srpska',13345.0,17.25,45.14).
city('Bosanska Kostajnica','ba','Republika Srpska',4739.0,16.54,45.22).
city('Bosanski Brod','ba','Republika Srpska',9249.0,17.99,45.14).
city('Bosanski Novi','ba','Republika Srpska',8920.0,16.38,45.05).
city('Bosanski Samac','ba','Republika Srpska',3599.0,18.47,45.06).
city('Bratunac','ba','Republika Srpska',4717.0,19.34,44.19).
city('Brcko','ba','Republika Srpska',38478.0,18.81,44.87).
city('Bronzani Majdan','ba','Republika Srpska',3945.0,16.93,44.79).
city('Cajnice','ba','Republika Srpska',3908.0,19.07,43.56).
city('Cecava','ba','Republika Srpska',3847.0,17.77,44.69).
city('Celinac','ba','Republika Srpska',6670.0,17.33,44.72).
city('Derventa','ba','Republika Srpska',9772.0,17.91,44.98).
city('Doboj','ba','Republika Srpska',27234.0,18.09,44.73).
city('Dobrljin','ba','Republika Srpska',3581.0,16.48,45.15).
city('Foca','ba','Republika Srpska',14614.0,18.78,43.51).
city('Gacko','ba','Republika Srpska',3417.0,18.54,43.17).
city('Han Pjesak','ba','Republika Srpska',4206.0,18.95,44.08).
city('Janja','ba','Republika Srpska',5543.0,19.25,44.67).
city('Kalenderovci','ba','Republika Srpska',5890.0,17.81,44.94).
city('Knezica','ba','Republika Srpska',4792.0,16.68,45.1).
city('Koran','ba','Republika Srpska',3394.0,18.57,43.81).
city('Kotor Varos','ba','Republika Srpska',5068.0,17.37,44.62).
city('Laktasi','ba','Republika Srpska',6464.0,17.3,44.91).
city('Lamovita','ba','Republika Srpska',4582.0,16.91,44.93).
city('Ljubinje','ba','Republika Srpska',4235.0,18.09,42.95).
city('Lopare','ba','Republika Srpska',3614.0,18.84,44.64).
city('Maglajani','ba','Republika Srpska',4221.0,17.35,44.95).
city('Maricka','ba','Republika Srpska',3707.0,16.84,44.87).
city('Maslovare','ba','Republika Srpska',4899.0,17.53,44.57).
city('Milici','ba','Republika Srpska',8210.0,19.09,44.17).
city('Modrica','ba','Republika Srpska',5135.0,18.3,44.95).
city('Mrkonjic Grad','ba','Republika Srpska',14737.0,17.09,44.42).
city('Nevesinje','ba','Republika Srpska',7312.0,18.11,43.26).
city('Obudovac','ba','Republika Srpska',2171.0,18.59,44.97).
city('Omarska','ba','Republika Srpska',6466.0,16.9,44.89).
city('Pale','ba','Republika Srpska',7458.0,18.57,43.82).
city('Petkovci','ba','Republika Srpska',2211.0,19.06,44.47).
city('Piskavica','ba','Republika Srpska',3797.0,17.0,44.87).
city('Podbrdo','ba','Republika Srpska',4028.0,17.01,44.44).
city('Pribinic','ba','Republika Srpska',3558.0,17.69,44.61).
city('Priboj','ba','Republika Srpska',4351.0,18.93,44.6).
city('Prijedor','ba','Republika Srpska',36346.0,16.71,44.98).
city('Prnjavor','ba','Republika Srpska',7098.0,17.66,44.87).
city('Razboj Lijevce','ba','Republika Srpska',3809.0,17.45,45.06).
city('Rogatica','ba','Republika Srpska',4946.0,19.0,43.8).
city('Sekovici','ba','Republika Srpska',6315.0,18.85,44.3).
city('Sipovo','ba','Republika Srpska',10737.0,17.08,44.28).
city('Skender Vakuf','ba','Republika Srpska',6866.0,17.38,44.49).
city('Sokolac','ba','Republika Srpska',8842.0,18.8,43.94).
city('Srbac','ba','Republika Srpska',7380.0,17.53,45.1).
city('Srebrenica','ba','Republika Srpska',2861.0,19.3,44.11).
city('Stanari','ba','Republika Srpska',3590.0,17.83,44.75).
city('Svodna','ba','Republika Srpska',4387.0,16.54,45.04).
city('Teslic','ba','Republika Srpska',6404.0,17.86,44.61).
city('Trebinje','ba','Republika Srpska',33177.0,18.34,42.71).
city('Trn','ba','Republika Srpska',7553.0,17.24,44.86).
city('Ugljevik','ba','Republika Srpska',3452.0,19.01,44.67).
city('Velika Obarska','ba','Republika Srpska',5142.0,19.16,44.81).
city('Visegrad','ba','Republika Srpska',6086.0,19.3,43.78).
city('Vlasenica','ba','Republika Srpska',4508.0,18.94,44.18).
city('Zivinice','ba','Republika Srpska',3718.0,17.38,44.55).
city('Zvornik','ba','Republika Srpska',8024.0,19.1,44.39).
city('Bobonong','bw','Bobonong',18136.0,28.42,-21.97).
city('Kobojango','bw','Bobonong',1756.0,28.78,-21.82).
city('Mathathane','bw','Bobonong',1987.0,28.75,-22.27).
city('Mmadinare','bw','Bobonong',12874.0,27.75,-21.88).
city('Mopipi','bw','Bobonong',3301.0,24.88,-21.18).
city('Sefophe','bw','Bobonong',4114.0,27.97,-22.18).
city('Tobane','bw','Bobonong',1925.0,27.9,-21.95).
city('Tsienyane','bw','Bobonong',5222.0,24.33,-21.02).
city('Letlhakane','bw','Boteti',18137.0,25.59,-21.42).
city('Kachikau','bw','Chobe',961.0,24.47,-18.17).
city('Kasane','bw','Chobe',9250.0,25.15,-17.81).
city('Pandamatenga','bw','Chobe',1685.0,25.65,-18.27).
city('Francistown','bw','Francistown',89979.0,27.5,-21.17).
city('Gaborone','bw','Gaborone',208411.0,25.91,-24.65).
city('Dekar','bw','Ghanzi',1043.0,21.93,-21.53).
city('Ghanzi','bw','Ghanzi',12141.0,21.64,-21.7).
city('Jwaneng','bw','Jwaneng',16854.0,25.55,-25.42).
city('Hukuntsi','bw','Kgalagadi North',4403.0,21.75,-24.0).
city('Kang','bw','Kgalagadi North',4229.0,22.83,-23.75).
city('Lehututu','bw','Kgalagadi North',1942.0,21.87,-23.97).
city('Lokgwabe','bw','Kgalagadi North',1473.0,21.83,-24.17).
city('Tshane','bw','Kgalagadi North',969.0,21.88,-24.02).
city('Bogogobo','bw','Kgalagadi South',374.0,21.92,-26.65).
city('Bokspits','bw','Kgalagadi South',547.0,20.7,-26.9).
city('Tsabong','bw','Kgalagadi South',8326.0,22.4,-26.01).
city('Werda','bw','Kgalagadi South',2149.0,23.28,-25.27).
city('Artisia','bw','Kgatleng',1584.0,26.33,-24.05).
city('Bokaa','bw','Kgatleng',4131.0,26.02,-24.45).
city('Mm','bw','Kgatleng',2221.0,26.43,-24.6).
city('Mochudi','bw','Kgatleng',41834.0,26.15,-24.37).
city('Pilane','bw','Kgatleng',1277.0,26.13,-24.45).
city('Boatlaname','bw','Kweneng',853.0,25.83,-23.6).
city('Botlhapatlou','bw','Kweneng',1013.0,25.53,-24.03).
city('Dumadumane','bw','Kweneng',866.0,25.87,-24.59).
city('Dutlwe','bw','Kweneng',1126.0,23.9,-23.98).
city('Gabane','bw','Kweneng',12884.0,25.78,-24.66).
city('Gaphatshwa','bw','Kweneng',1678.0,25.83,-24.57).
city('Khudumelapye','bw','Kweneng',2035.0,24.75,-23.88).
city('Kopong','bw','Kweneng',6896.0,25.88,-24.48).
city('Lentsweletau','bw','Kweneng',4992.0,25.85,-24.38).
city('Lephepe','bw','Kweneng',822.0,25.85,-23.36).
city('Letlhakeng','bw','Kweneng',6782.0,25.03,-24.07).
city('Metsimotlhaba','bw','Kweneng',5547.0,25.8,-24.55).
city('Mmopane','bw','Kweneng',4930.0,25.87,-24.57).
city('Mogoditshane','bw','Kweneng',43417.0,25.87,-24.63).
city('Mogoditshane Botswana Defence Force','bw','Kweneng',3787.0,25.81,-24.68).
city('Molepolole','bw','Kweneng',63251.0,25.51,-24.4).
city('Nkoyaphiri','bw','Kweneng',1578.0,25.83,-24.63).
city('Takatokwane','bw','Kweneng',1761.0,24.17,-24.03).
city('Thamaga','bw','Kweneng',20757.0,25.53,-24.72).
city('Lobatse','bw','Lobatse',30883.0,25.68,-25.22).
city('Bonwapitse','bw','Mahalapye',568.0,26.67,-23.02).
city('Chadibe','bw','Mahalapye',2986.0,27.55,-22.98).
city('Dibete','bw','Mahalapye',1046.0,26.48,-23.75).
city('Dinokwe','bw','Mahalapye',1099.0,26.68,-23.4).
city('Kalamare','bw','Mahalapye',2339.0,26.5,-22.87).
city('Kudumat','bw','Mahalapye',1397.0,27.07,-23.4).
city('Maape','bw','Mahalapye',1275.0,27.33,-22.77).
city('Machaneng','bw','Mahalapye',2139.0,27.5,-23.18).
city('Mahalapye','bw','Mahalapye',44473.0,26.82,-23.1).
city('Makwate','bw','Mahalapye',1660.0,27.3,-23.28).
city('Mokobeng','bw','Mahalapye',1822.0,27.58,-22.98).
city('Mookane','bw','Mahalapye',2397.0,26.63,-23.73).
city('Pilikwe','bw','Mahalapye',1375.0,27.23,-22.78).
city('Ramokgonami','bw','Mahalapye',3681.0,27.47,-22.93).
city('Shoshong','bw','Mahalapye',8299.0,26.48,-22.95).
city('Boro','bw','Ngamiland',919.0,23.5,-19.92).
city('Makalamabedi','bw','Ngamiland',376.0,23.82,-20.33).
city('Sehithwa','bw','Ngamiland',1614.0,22.72,-20.47).
city('Shakawe','bw','Ngamiland',5651.0,21.84,-18.36).
city('Tsao','bw','Ngamiland',1409.0,22.46,-20.16).
city('Kanye','bw','Ngwaketse',44718.0,25.34,-24.97).
city('Khakhea','bw','Ngwaketse',2133.0,23.5,-24.65).
city('Lotlhakane','bw','Ngwaketse',5236.0,25.58,-21.42).
city('Mabule','bw','Ngwaketse',1665.0,24.6,-25.78).
city('Magotlhawane','bw','Ngwaketse',1174.0,27.0,-23.57).
city('Manyana','bw','Ngwaketse',3338.0,21.72,-23.4).
city('Maokane','bw','Ngwaketse',1024.0,24.7,-24.97).
city('Moshupa','bw','Ngwaketse',19563.0,25.41,-24.77).
city('Pitsane','bw','Ngwaketse',3101.0,25.58,-25.47).
city('Rakhuna','bw','Ngwaketse',1143.0,25.58,-25.57).
city('Sekoma','bw','Ngwaketse',1083.0,23.88,-24.4).
city('Kalakamati','bw','North East',962.0,27.3,-20.63).
city('Makaleng','bw','North East',1166.0,27.28,-20.9).
city('Masunga','bw','North East',3640.0,27.42,-20.67).
city('Matsiloje','bw','North East',1488.0,27.87,-21.37).
city('Ramokgwebana','bw','North East',1538.0,28.0,-21.57).
city('Tati','bw','North East',5236.0,27.45,-21.35).
city('Tsamaya','bw','North East',1762.0,27.57,-20.87).
city('Tshesebe','bw','North East',1580.0,27.57,-20.75).
city('Gumare','bw','Okavango',7388.0,22.2,-19.22).
city('Maun','bw','Okavango',49948.0,23.42,-19.99).
city('Mohembo West','bw','Okavango',1440.0,21.8,-18.3).
city('Nokaneng','bw','Okavango',1763.0,22.27,-19.67).
city('Orapa','bw','Orapa',9190.0,25.37,-21.28).
city('Selibe Phikwe','bw','Selibe Phikwe',53727.0,27.83,-21.98).
city('Lecheng','bw','Serowe-Palapye',2696.0,27.27,-22.65).
city('Mabeleapudi','bw','Serowe-Palapye',1882.0,26.68,-22.28).
city('Matlhakola','bw','Serowe-Palapye',1159.0,27.37,-22.6).
city('Maunatlala','bw','Serowe-Palapye',3361.0,27.57,-22.57).
city('Mogapi','bw','Serowe-Palapye',1917.0,27.83,-22.33).
city('Mogapinyana','bw','Serowe-Palapye',1515.0,27.6,-22.37).
city('Moiyabana','bw','Serowe-Palapye',2768.0,26.42,-22.43).
city('Palapye','bw','Serowe-Palapye',30652.0,27.13,-22.56).
city('Radisele','bw','Serowe-Palapye',2897.0,27.0,-22.82).
city('Ratholo','bw','Serowe-Palapye',2377.0,27.58,-22.68).
city('Seolwane','bw','Serowe-Palapye',1401.0,27.65,-22.68).
city('Serowe','bw','Serowe-Palapye',47421.0,26.71,-22.39).
city('Serule','bw','Serowe-Palapye',2397.0,27.3,-21.95).
city('Tamasane','bw','Serowe-Palapye',1070.0,27.37,-22.32).
city('Topisi','bw','Serowe-Palapye',1363.0,27.23,-22.17).
city('Otse','bw','South East',6275.0,25.73,-25.02).
city('Ramotswa','bw','South East',21451.0,25.84,-24.83).
city('Ramotswa Station-Taung','bw','South East',2859.0,25.87,-24.83).
city('Tlokweng','bw','South East',25542.0,25.97,-24.53).
city('Sowa','bw','Sowa',3138.0,26.2,-20.05).
city('Dukwi','bw','Tutume',2037.0,26.42,-20.58).
city('Gweta','bw','Tutume',4689.0,25.25,-20.2).
city('Maitengwe','bw','Tutume',5450.0,26.43,-19.98).
city('Makobo','bw','Tutume',1006.0,27.12,-23.48).
city('Mandunyane','bw','Tutume',2749.0,27.4,-21.33).
city('Marapong','bw','Tutume',1692.0,28.17,-22.25).
city('Mathangwane','bw','Tutume',4676.0,27.32,-21.03).
city('Mosetse','bw','Tutume',1780.0,26.65,-20.75).
city('Nata','bw','Tutume',4794.0,26.19,-20.21).
city('Sebina','bw','Tutume',3030.0,27.25,-20.87).
city('Shashe Mooke','bw','Tutume',2458.0,27.45,-21.4).
city('Tonota','bw','Tutume',17760.0,27.48,-21.44).
city('Tutume','bw','Tutume',15862.0,27.05,-20.51).
city('Brasileia','br','Acre',11200.0,-68.74,-11.0).
city('Cruzeiro do Sul','br','Acre',45517.0,-72.67,-7.63).
city('Feijo','br','Acre',12951.0,-70.36,-8.16).
city('Mancio Lima','br','Acre',7086.0,-72.9,-7.62).
city('Manoel Urbano','br','Acre',4066.0,-69.29,-8.89).
city('Marechal Thaumaturgo','br','Acre',1809.0,-72.81,-8.94).
city('Placido de Castro','br','Acre',11950.0,-67.19,-10.33).
city('Porto Walter','br','Acre',1816.0,-72.75,-8.25).
city('Rio Branco','br','Acre',257645.0,-67.82,-9.98).
city('Rodrigues Alves','br','Acre',3827.0,-65.02,-11.88).
city('Sena Madureira','br','Acre',20516.0,-68.67,-9.07).
city('Senador Guiomard','br','Acre',11727.0,-67.84,-10.17).
city('Tarauaca','br','Acre',16526.0,-70.78,-8.16).
city('Xapuri','br','Acre',5721.0,-68.53,-10.65).
city('Agua Branca','br','Alagoas',5161.0,-37.94,-9.27).
city('Anadia','br','Alagoas',9574.0,-36.31,-9.68).
city('Arapiraca','br','Alagoas',166566.0,-36.67,-9.75).
city('Atalaia','br','Alagoas',18908.0,-36.04,-9.52).
city('Barra de Santo Antonio','br','Alagoas',10057.0,-35.5,9.4).
city('Batalha','br','Alagoas',11820.0,-37.13,-9.66).
city('Boca da Mata','br','Alagoas',17834.0,-36.22,-9.63).
city('Cacimbinhas','br','Alagoas',4618.0,-37.0,-9.39).
city('Cajueiro','br','Alagoas',15063.0,-36.45,-9.72).
city('Campo Alegre','br','Alagoas',16786.0,-36.36,-9.78).
city('Campo Grande','br','Alagoas',3054.0,-36.5,-10.23).
city('Canapi','br','Alagoas',4219.0,-37.6,-9.11).
city('Capela','br','Alagoas',12520.0,-36.09,-9.42).
city('Coite do Noia','br','Alagoas',2529.0,-36.5,-9.67).
city('Colonia Leopoldina','br','Alagoas',11914.0,-35.65,-8.95).
city('Coruripe','br','Alagoas',31428.0,-36.18,-10.12).
city('Craibas','br','Alagoas',7527.0,-36.45,-9.7).
city('Delmiro Gouveia','br','Alagoas',35260.0,-37.99,-9.38).
city('Dois Riachos','br','Alagoas',4565.0,-37.08,-9.38).
city('Feira Grande','br','Alagoas',3985.0,-36.67,-9.91).
city('Flexeiras','br','Alagoas',7783.0,-35.72,-9.27).
city('Girau do Ponciano','br','Alagoas',9606.0,-36.84,-9.91).
city('Ibateguara','br','Alagoas',8755.0,-35.87,-8.98).
city('Igaci','br','Alagoas',6480.0,-36.63,-9.54).
city('Igreja Nova','br','Alagoas',4606.0,-36.65,-10.12).
city('Inhapi','br','Alagoas',7550.0,-37.75,-9.23).
city('Joaquim Gomes','br','Alagoas',14808.0,-35.74,-9.12).
city('Jundia','br','Alagoas',2267.0,-35.57,-8.93).
city('Junqueiro','br','Alagoas',7740.0,-36.47,-9.92).
city('Lagoa da Canoa','br','Alagoas',13428.0,-36.75,-9.83).
city('Limoeiro de Anadia','br','Alagoas',2770.0,-36.51,-9.73).
city('Maceio','br','Alagoas',955010.0,-35.75,-9.65).
city('Major Isidoro','br','Alagoas',8507.0,-36.98,-9.53).
city('Maragogi','br','Alagoas',16066.0,-35.23,-9.0).
city('Maravilha','br','Alagoas',5909.0,-37.84,-8.27).
city('Marechal Deodoro','br','Alagoas',50579.0,-35.9,-9.72).
city('Maribondo','br','Alagoas',10475.0,-36.24,-9.58).
city('Mata Grande','br','Alagoas',4654.0,-37.74,-9.13).
city('Matriz de Camaragibe','br','Alagoas',18705.0,-35.52,-9.15).
city('Messias','br','Alagoas',12376.0,-35.84,-9.41).
city('Minador do Negrao','br','Alagoas',1986.0,-36.87,-9.31).
city('Murici','br','Alagoas',20420.0,-35.94,-9.3).
city('Novo Lino','br','Alagoas',5538.0,-35.62,-9.01).
city('Olho dAgua das Flores','br','Alagoas',15243.0,-37.29,-9.53).
city('Olivenca','br','Alagoas',2848.0,-37.19,-9.51).
city('Palmeira dos Indios','br','Alagoas',49241.0,-36.64,-9.93).
city('Pao de Acucar','br','Alagoas',11497.0,-37.44,-9.73).
city('Passo de Camaragibe','br','Alagoas',5523.0,-35.5,-9.23).
city('Penedo','br','Alagoas',42099.0,-36.58,-10.27).
city('Piacabucu','br','Alagoas',9862.0,-36.43,-10.4).
city('Pilar','br','Alagoas',30617.0,-35.95,-9.59).
city('Piranhas','br','Alagoas',1170.0,-37.76,-9.62).
city('Poco das Trincheiras','br','Alagoas',1775.0,-37.27,-9.31).
city('Porto Calvo','br','Alagoas',17347.0,-35.38,-9.05).
city('Porto Real do Colegio','br','Alagoas',6001.0,-36.82,-10.18).
city('Quebrangulo','br','Alagoas',6587.0,-36.48,-9.32).
city('Rio Largo','br','Alagoas',63389.0,-35.84,-9.48).
city('Santana do Ipanema','br','Alagoas',26147.0,-37.24,-9.36).
city('Santana do Mundau','br','Alagoas',6439.0,-36.21,-9.18).
city('Sao Jose da Laje','br','Alagoas',12811.0,-36.06,-9.0).
city('Sao Jose da Tapera','br','Alagoas',12392.0,-37.39,-9.63).
city('Sao Luis do Quitunde','br','Alagoas',20564.0,-35.56,-9.33).
city('Sao Miguel dos Campos','br','Alagoas',40891.0,-36.09,-9.78).
city('Sao Sebastiao','br','Alagoas',9551.0,-36.57,-9.93).
city('Satuba','br','Alagoas',15898.0,-35.82,-9.57).
city('Taquarana','br','Alagoas',5288.0,-36.49,-9.63).
city('Teotonio Vilela','br','Alagoas',34474.0,-36.37,-9.9).
city('Traipu','br','Alagoas',8427.0,-36.99,-9.96).
city('Uniao dos Palmares','br','Alagoas',41179.0,-36.03,-9.16).
city('Vicosa','br','Alagoas',19574.0,-36.24,-9.37).
city('Amapa','br','Amapa',6256.0,-50.78,2.02).
city('Laranjal do Jari','br','Amapa',31025.0,-52.48,-0.85).
city('Macapa','br','Amapa',338937.0,-51.05,0.04).
city('Mazagao','br','Amapa',6500.0,-51.29,-0.12).
city('Oiapoque','br','Amapa',10706.0,-51.83,-3.85).
city('Santana','br','Amapa',83927.0,-51.18,-0.04).
city('Alvaraes','br','Amazonas',5527.0,-64.82,-3.2).
city('Anori','br','Amazonas',8064.0,-61.64,-3.78).
city('Apui','br','Amazonas',8279.0,-69.15,1.22).
city('Autazes','br','Amazonas',9614.0,-59.14,-3.59).
city('Barcelos','br','Amazonas',7356.0,-62.94,-0.97).
city('Barreirinha','br','Amazonas',11257.0,-57.07,-2.8).
city('Benjamin Constant','br','Amazonas',13998.0,-70.04,-4.37).
city('Boca do Acre','br','Amazonas',14427.0,-67.4,-8.74).
city('Borba','br','Amazonas',11918.0,-59.59,-4.4).
city('Canutama','br','Amazonas',6320.0,-64.34,-6.53).
city('Carauari','br','Amazonas',18059.0,-66.9,-4.87).
city('Careiro','br','Amazonas',6659.0,-59.77,-3.19).
city('Careiro da Varzea','br','Amazonas',1092.0,-59.76,-3.19).
city('Coari','br','Amazonas',50491.0,-63.13,-4.08).
city('Codajas','br','Amazonas',11185.0,-62.07,-3.82).
city('Eirunepe','br','Amazonas',17175.0,-69.87,-6.67).
city('Envira','br','Amazonas',9957.0,-70.24,-7.31).
city('Fonte Boa','br','Amazonas',16060.0,-66.02,-2.53).
city('Guajara','br','Amazonas',9776.0,-57.69,-2.98).
city('Humaita','br','Amazonas',31207.0,-63.03,-7.51).
city('Ipixuna','br','Amazonas',5814.0,-71.74,-7.08).
city('Iranduba','br','Amazonas',11181.0,-60.09,-3.25).
city('Itacoatiara','br','Amazonas',45995.0,-58.44,-3.14).
city('Japura','br','Amazonas',1908.0,-69.4,-1.43).
city('Jutai','br','Amazonas',5863.0,-68.91,-5.18).
city('Labrea','br','Amazonas',19624.0,-64.81,-7.26).
city('Manacapuru','br','Amazonas',52460.0,-60.62,-3.29).
city('Manaquiri','br','Amazonas',9986.0,-60.35,-3.32).
city('Manaus','br','Amazonas',1598227.0,-60.02,-3.12).
city('Manicore','br','Amazonas',14058.0,-61.28,-5.82).
city('Maraa','br','Amazonas',4387.0,-65.36,-1.82).
city('Maues','br','Amazonas',22476.0,-57.72,-3.39).
city('Nhamunda','br','Amazonas',7772.0,-56.72,-2.23).
city('Nova Olinda do Norte','br','Amazonas',12344.0,-59.06,-3.75).
city('Novo Airao','br','Amazonas',9716.0,-61.36,-1.94).
city('Novo Aripuana','br','Amazonas',11044.0,-60.38,-5.12).
city('Parintins','br','Amazonas',64429.0,-56.74,-2.61).
city('Pauini','br','Amazonas',7633.0,-66.98,-7.66).
city('Rio Preto da Eva','br','Amazonas',16827.0,-59.62,-2.75).
city('Santa Isabel do Rio Negro','br','Amazonas',4142.0,-65.03,-0.39).
city('Santo Antonio do Ica','br','Amazonas',9302.0,-67.95,-3.07).
city('Sao Gabriel da Cachoeira','br','Amazonas',15232.0,-67.09,-0.13).
city('Sao Paulo de Olivenca','br','Amazonas',11763.0,-68.81,-3.45).
city('Tabatinga','br','Amazonas',28230.0,-69.93,-4.25).
city('Tapaua','br','Amazonas',13211.0,-63.39,-5.75).
city('Tefe','br','Amazonas',44943.0,-64.7,-3.36).
city('Tonantins','br','Amazonas',4561.0,-67.78,-2.78).
city('Uarini','br','Amazonas',2796.0,-65.15,-2.92).
city('Urucara','br','Amazonas',8603.0,-57.76,-2.54).
city('Urucurituba','br','Amazonas',10180.0,-57.68,-2.68).
city('Acajutiba','br','Bahia',14349.0,-38.02,-11.66).
city('Alagoinhas','br','Bahia',122692.0,-38.43,-12.14).
city('Amargosa','br','Bahia',22531.0,-39.59,-13.02).
city('America Dourada','br','Bahia',14018.0,-41.42,-11.46).
city('Anage','br','Bahia',3762.0,-41.13,-14.61).
city('Araci','br','Bahia',15089.0,-38.97,-11.32).
city('Aurelino Leal','br','Bahia',15495.0,-39.34,-14.33).
city('Baixa Grande','br','Bahia',7534.0,-40.17,-11.95).
city('Barra','br','Bahia',20895.0,-43.15,-11.09).
city('Barra da Estiva','br','Bahia',12618.0,-41.32,-13.63).
city('Barra do Choca','br','Bahia',18868.0,-40.58,-14.86).
city('Barreiras','br','Bahia',158296.0,-45.0,-12.14).
city('Belmonte','br','Bahia',9806.0,-38.92,-15.83).
city('Boa Vista do Tupim','br','Bahia',6013.0,-40.6,-12.66).
city('Bom Jesus da Lapa','br','Bahia',40693.0,-43.44,-13.25).
city('Boquira','br','Bahia',6306.0,-42.74,-12.82).
city('Brumado','br','Bahia',41990.0,-41.67,-14.21).
city('Buerarema','br','Bahia',16002.0,-39.31,-14.96).
city('Cachoeira','br','Bahia',16145.0,-38.97,-12.6).
city('Cacule','br','Bahia',12143.0,-42.24,-14.49).
city('Caetite','br','Bahia',27188.0,-42.5,-14.07).
city('Cafarnaum','br','Bahia',12940.0,-41.46,-11.69).
city('Camacan','br','Bahia',36574.0,39.5,-15.42).
city('Camacari','br','Bahia',188763.0,-38.33,-12.7).
city('Camamu','br','Bahia',13924.0,-39.1,-13.93).
city('Campo Alegre de Lourdes','br','Bahia',5789.0,-43.02,-9.53).
city('Campo Formoso','br','Bahia',23921.0,-40.32,-10.5).
city('Canarana','br','Bahia',10785.0,-41.76,-11.68).
city('Canavieiras','br','Bahia',26376.0,-38.96,-15.64).
city('Candeias','br','Bahia',75673.0,-38.51,-12.71).
city('Cansancao','br','Bahia',9905.0,-39.5,-10.63).
city('Capim Grosso','br','Bahia',17322.0,-40.02,-11.37).
city('Caravelas','br','Bahia',11322.0,-39.26,-17.63).
city('Carinhanha','br','Bahia',11408.0,-43.78,-14.3).
city('Casa Nova','br','Bahia',33319.0,-41.17,-9.38).
city('Castro Alves','br','Bahia',13869.0,-39.43,-12.76).
city('Catu','br','Bahia',39933.0,-38.38,-12.35).
city('Cicero Dantas','br','Bahia',18317.0,-38.4,-10.58).
city('Cipo','br','Bahia',10822.0,38.52,-11.11).
city('Coaraci','br','Bahia',32345.0,-39.55,-14.67).
city('Conceicao da Feira','br','Bahia',15838.0,-38.99,-12.49).
city('Conceicao do Almeida','br','Bahia',9691.0,-39.2,-12.8).
city('Conceicao do Coite','br','Bahia',35172.0,-39.27,-11.56).
city('Conceicao do Jacuipe','br','Bahia',21597.0,-38.76,-12.32).
city('Conde','br','Bahia',15565.0,-37.62,-11.82).
city('Coracao de Maria','br','Bahia',6571.0,-38.74,-12.24).
city('Coronel Joao Sa','br','Bahia',4323.0,-37.93,-10.29).
city('Correntina','br','Bahia',13187.0,-44.64,-13.33).
city('Cruz das Almas','br','Bahia',47846.0,-39.11,-12.67).
city('Curaca','br','Bahia',11858.0,-39.9,-8.99).
city('Dias dAvila','br','Bahia',57027.0,-38.3,-12.61).
city('Encruzilhada','br','Bahia',4711.0,-40.91,-15.54).
city('Entre Rios','br','Bahia',27406.0,-38.09,-11.94).
city('Esplanada','br','Bahia',18859.0,-37.96,-11.78).
city('Euclides da Cunha','br','Bahia',29739.0,-39.02,-10.51).
city('Eunapolis','br','Bahia',84424.0,-39.58,-16.36).
city('Feira de Santana','br','Bahia',481926.0,-38.97,-12.25).
city('Formosa do Rio Preto','br','Bahia',14365.0,-45.05,-11.04).
city('Gandu','br','Bahia',21566.0,-39.49,-13.75).
city('Guanambi','br','Bahia',58879.0,-42.79,-14.23).
city('Guaratinga','br','Bahia',9519.0,-39.57,-16.57).
city('Iacu','br','Bahia',22665.0,-40.21,-12.77).
city('Ibicarai','br','Bahia',19575.0,-39.6,-14.87).
city('Ibicui','br','Bahia',10640.0,-39.98,-14.85).
city('Ibipeba','br','Bahia',14444.0,-42.02,-11.62).
city('Ibirapitanga','br','Bahia',7302.0,-39.38,-14.15).
city('Ibirataia','br','Bahia',19943.0,-39.64,-14.07).
city('Ibotirama','br','Bahia',17354.0,-43.22,-12.18).
city('Iguai','br','Bahia',14218.0,-40.09,-14.74).
city('Ilheus','br','Bahia',155503.0,-39.05,-14.78).
city('Inhambupe','br','Bahia',14735.0,-38.36,-11.8).
city('Ipiau','br','Bahia',38763.0,-39.73,-14.13).
city('Ipira','br','Bahia',27218.0,-39.74,-12.15).
city('Iraquara','br','Bahia',5131.0,-41.6,-12.25).
city('Irara','br','Bahia',9099.0,-38.76,-12.04).
city('Irece','br','Bahia',63628.0,-41.87,-11.3).
city('Itaberaba','br','Bahia',47303.0,-40.3,-12.52).
city('Itabuna','br','Bahia',205666.0,-39.28,-14.79).
city('Itacare','br','Bahia',12490.0,-39.01,-14.28).
city('Itagi','br','Bahia',10534.0,-40.01,-14.17).
city('Itagiba','br','Bahia',9843.0,-39.86,-14.28).
city('Itajuipe','br','Bahia',15517.0,-39.35,-14.67).
city('Itamaraju','br','Bahia',47630.0,-39.53,-17.04).
city('Itambe','br','Bahia',23559.0,-40.63,-15.24).
city('Itanhem','br','Bahia',13517.0,-40.33,-17.16).
city('Itaparica','br','Bahia',20101.0,-38.68,-12.89).
city('Itapetinga','br','Bahia',59723.0,-40.25,-15.25).
city('Itapicuru','br','Bahia',4994.0,-38.23,-11.3).
city('Itarantim','br','Bahia',12370.0,-40.06,-15.65).
city('Itirucu','br','Bahia',11499.0,-40.14,-13.51).
city('Itiuba','br','Bahia',9410.0,-39.86,-10.68).
city('Itororo','br','Bahia',17325.0,-40.08,-15.11).
city('Ituacu','br','Bahia',4891.0,-41.31,-13.81).
city('Itubera','br','Bahia',19888.0,-39.15,-13.72).
city('Jacobina','br','Bahia',47639.0,-40.52,-11.18).
city('Jag','br','Bahia',41499.0,-39.97,-13.53).
city('Jaguarari','br','Bahia',22617.0,-40.2,-10.25).
city('Jequie','br','Bahia',127479.0,-40.08,-13.85).
city('Jeremoabo','br','Bahia',16642.0,-38.35,-10.07).
city('Jitauna','br','Bahia',11619.0,-39.95,-14.02).
city('Juazeiro','br','Bahia',137807.0,-40.5,-9.42).
city('Jussara','br','Bahia',11254.0,41.97,-11.05).
city('Laje','br','Bahia',4708.0,-40.97,-10.18).
city('Lapao','br','Bahia',11253.0,-41.84,-11.4).
city('Lauro de Freitas','br','Bahia',203716.0,-38.35,-12.91).
city('Livramento','br','Bahia',19914.0,-41.85,-13.65).
city('Macaubas','br','Bahia',14598.0,-42.71,-13.02).
city('Madre de Deus','br','Bahia',14887.0,-38.62,-12.73).
city('Mairi','br','Bahia',13475.0,-40.16,-11.7).
city('Maracas','br','Bahia',22050.0,-40.44,-13.44).
city('Maragogipe','br','Bahia',20921.0,-38.94,-12.78).
city('Marau','br','Bahia',2956.0,-39.02,-14.11).
city('Mascote','br','Bahia',18899.0,-39.28,-15.55).
city('Mata de Sao Joao','br','Bahia',26680.0,-38.3,-12.54).
city('Medeiros Neto','br','Bahia',15255.0,-40.24,-17.33).
city('Miguel Calmon','br','Bahia',13748.0,-40.61,-11.42).
city('Monte Santo','br','Bahia',7398.0,-39.34,-10.43).
city('Morro de Chapeu','br','Bahia',21671.0,-41.16,-11.54).
city('Mucuri','br','Bahia',26823.0,-39.57,-18.08).
city('Mundo Novo','br','Bahia',11912.0,-40.47,-11.86).
city('Muritiba','br','Bahia',22388.0,-39.26,-12.91).
city('Mutuipe','br','Bahia',10016.0,-39.53,-13.22).
city('Nazare','br','Bahia',25604.0,-39.01,-13.02).
city('Nova Soure','br','Bahia',11340.0,-38.5,-11.23).
city('Nova Vicosa','br','Bahia',56001.0,-39.37,-17.88).
city('Olindina','br','Bahia',12317.0,-38.35,-11.36).
city('Oliveira dos Brejinhos','br','Bahia',5596.0,-42.9,-12.3).
city('Palmas de Monte Alto','br','Bahia',7091.0,-43.18,-14.26).
city('Paramirim','br','Bahia',7421.0,-42.25,-13.43).
city('Paratinga','br','Bahia',10262.0,-43.2,-12.68).
city('Paripiranga','br','Bahia',6965.0,-37.87,-10.68).
city('Pau Brasil','br','Bahia',8136.0,-39.65,-15.46).
city('Paulo Afonso','br','Bahia',85353.0,-38.27,-9.33).
city('Pilao Arcado','br','Bahia',6715.0,-42.34,-10.18).
city('Pindobacu','br','Bahia',17242.0,-40.37,-10.74).
city('Piritiba','br','Bahia',16230.0,-40.57,-11.71).
city('Planalto','br','Bahia',14720.0,-40.48,-14.67).
city('Pocoes','br','Bahia',35255.0,-40.37,-14.52).
city('Pojuca','br','Bahia',25102.0,-38.33,-12.43).
city('Ponto Novo','br','Bahia',7141.0,-40.14,-10.86).
city('Porto Seguro','br','Bahia',123196.0,-39.08,-16.43).
city('Prado','br','Bahia',15466.0,-39.22,-17.35).
city('Queimadas','br','Bahia',10439.0,-39.63,-10.98).
city('Quijingue','br','Bahia',4293.0,-39.21,-10.75).
city('Remanso','br','Bahia',22780.0,-42.11,-9.6).
city('Riachao das Neves','br','Bahia',11236.0,-44.92,-11.77).
city('Riachao do Jacuipe','br','Bahia',16911.0,-39.38,-11.79).
city('Riacho de Santana','br','Bahia',12658.0,-42.94,-13.61).
city('Ribeira do Pombal','br','Bahia',28236.0,-38.53,-10.83).
city('Rio Real','br','Bahia',24006.0,-37.94,-11.47).
city('Ruy Barbosa','br','Bahia',21093.0,-40.45,-12.26).
city('Salvador','br','Bahia',2711903.0,-38.5,-12.97).
city('Santa Cruz Cabralia','br','Bahia',19549.0,-39.03,-16.28).
city('Santa Ines','br','Bahia',10521.0,-39.81,-13.28).
city('Santa Maria da Vitoria','br','Bahia',23489.0,-44.21,-13.39).
city('Santaluz','br','Bahia',24740.0,-39.37,-11.24).
city('Santana','br','Bahia',12629.0,-41.81,-14.48).
city('Santo Amaro','br','Bahia',46749.0,-38.72,-12.55).
city('Santo Antonio de Jesus','br','Bahia',73959.0,-39.27,-12.97).
city('Santo Estevao','br','Bahia',27280.0,-39.24,-12.44).
city('Sao Desiderio','br','Bahia',7295.0,-44.98,-12.36).
city('Sao Felipe','br','Bahia',9574.0,-41.39,-14.82).
city('Sao Francisco do Conde','br','Bahia',24615.0,-38.67,-12.62).
city('Sao Goncalo dos Campos','br','Bahia',14822.0,-38.95,-12.43).
city('Sao Sebastiao do Passe','br','Bahia',31050.0,-38.49,-12.52).
city('Saubara','br','Bahia',15669.0,-38.74,-12.74).
city('Seabra','br','Bahia',16765.0,-41.77,-12.42).
city('Senhor do Bonfim','br','Bahia',48472.0,-40.19,-10.45).
city('Sento Se','br','Bahia',19596.0,-41.3,-9.72).
city('Serra Dourada','br','Bahia',5862.0,-43.95,-12.77).
city('Serrinha','br','Bahia',49079.0,-39.01,-11.65).
city('Simoes Filho','br','Bahia',121231.0,-38.4,-12.82).
city('Sobradinho','br','Bahia',19304.0,-39.1,-12.83).
city('Tanhacu','br','Bahia',6620.0,-41.29,-14.02).
city('Taperoa','br','Bahia',8095.0,-39.1,-13.54).
city('Tapiramuta','br','Bahia',16549.0,-40.78,-11.84).
city('Teixeira de Freitas','br','Bahia',121952.0,-39.71,-17.53).
city('Teofilandia','br','Bahia',5461.0,-39.02,-11.48).
city('Terra Nova','br','Bahia',11169.0,-40.67,-12.37).
city('Tremedal','br','Bahia',3252.0,-41.4,-14.97).
city('Tucano','br','Bahia',31209.0,-38.79,-10.97).
city('Uaua','br','Bahia',11425.0,-39.49,-9.84).
city('Ubaira','br','Bahia',8069.0,-39.67,-13.26).
city('Ubaitaba','br','Bahia',28376.0,-39.33,-14.3).
city('Ubata','br','Bahia',15605.0,-39.54,-14.21).
city('Una','br','Bahia',22650.0,-39.08,-15.29).
city('Urucuca','br','Bahia',24414.0,-39.3,-14.59).
city('Utinga','br','Bahia',11949.0,-43.09,-10.92).
city('Valenca','br','Bahia',63233.0,-39.08,-13.36).
city('Valente','br','Bahia',12591.0,-39.44,-11.56).
city('Vera Cruz','br','Bahia',30557.0,-41.03,-12.63).
city('Vitoria da Conquista','br','Bahia',253144.0,-40.84,-14.85).
city('Xique-Xique','br','Bahia',35435.0,-42.73,-10.82).
city('Acarau','br','Ceara',28389.0,-40.12,-2.89).
city('Acopiara','br','Ceara',24562.0,-39.46,-6.1).
city('Amontada','br','Ceara',13520.0,-39.84,-3.38).
city('Aquiraz','br','Ceara',65117.0,-38.37,-3.9).
city('Aracati','br','Ceara',44294.0,-37.77,-4.56).
city('Aracoiaba','br','Ceara',13425.0,-38.82,-4.38).
city('Araripe','br','Ceara',11860.0,-40.12,-7.19).
city('Assare','br','Ceara',11369.0,-39.88,-6.87).
city('Aurora','br','Ceara',10757.0,-38.97,-6.94).
city('Barbalha','br','Ceara',33944.0,-39.28,-7.32).
city('Barro','br','Ceara',11519.0,-38.87,-6.72).
city('Barroquinha','br','Ceara',12410.0,-41.07,-2.97).
city('Baturite','br','Ceara',22417.0,-38.88,-4.33).
city('Beberibe','br','Ceara',37028.0,-38.13,-4.18).
city('Bela Cruz','br','Ceara',12715.0,-40.19,-3.05).
city('Boa Viagem','br','Ceara',24671.0,-39.74,-5.12).
city('Brejo Santo','br','Ceara',27384.0,-38.99,-7.5).
city('Camocim','br','Ceara',44482.0,-40.85,-2.9).
city('Campos Sales','br','Ceara',17648.0,-40.38,-7.08).
city('Caninde','br','Ceara',42721.0,-39.31,-4.35).
city('Carire','br','Ceara',5488.0,-40.45,-3.94).
city('Caririacu','br','Ceara',12971.0,-39.29,-7.04).
city('Cascavel','br','Ceara',52357.0,-38.25,-4.13).
city('Caucaia','br','Ceara',275023.0,-38.67,-3.74).
city('Cedro','br','Ceara',14644.0,-39.06,-6.6).
city('Chorozinho','br','Ceara',9755.0,-38.49,-4.3).
city('Coreau','br','Ceara',12383.0,-40.65,-3.55).
city('Crateus','br','Ceara',52934.0,-40.67,-5.18).
city('Crato','br','Ceara',88788.0,-39.42,-7.23).
city('Cruz','br','Ceara',8723.0,-40.18,-2.95).
city('Eusebio','br','Ceara',37290.0,-38.45,-3.9).
city('Farias Brito','br','Ceara',11288.0,-39.58,-6.93).
city('Forquilha','br','Ceara',13410.0,40.25,-3.8).
city('Fortaleza','br','Ceara',2311911.0,-38.59,-3.78).
city('Granja','br','Ceara',25880.0,-40.84,-3.12).
city('Guaiuba','br','Ceara',21822.0,-38.64,-4.03).
city('Guaraciaba do Norte','br','Ceara',18186.0,-40.77,-4.17).
city('Hidrolandia','br','Ceara',10299.0,-40.41,-4.41).
city('Horizonte','br','Ceara',51181.0,-38.49,-4.1).
city('Ibiapina','br','Ceara',9205.0,-40.89,-3.92).
city('Ico','br','Ceara',28323.0,-38.85,-6.4).
city('Iguatu','br','Ceara',70381.0,-39.3,-6.36).
city('Independencia','br','Ceara',11113.0,-40.32,-5.4).
city('Ipu','br','Ceara',26679.0,-40.72,-4.32).
city('Ipueiras','br','Ceara',17111.0,-40.45,-7.03).
city('Iraucuba','br','Ceara',13282.0,-39.78,-3.75).
city('Itaitinga','br','Ceara',30939.0,-38.53,-3.97).
city('Itapage','br','Ceara',32043.0,-39.59,-3.69).
city('Itapipoca','br','Ceara',55785.0,-39.58,-3.5).
city('Itarema','br','Ceara',10330.0,-39.92,-2.92).
city('Jaguaribe','br','Ceara',23066.0,-38.62,-5.89).
city('Jaguaruana','br','Ceara',21791.0,-37.78,-4.83).
city('Jardim','br','Ceara',7189.0,-39.02,-3.43).
city('Juazeiro do Norte','br','Ceara',225234.0,-39.32,-7.21).
city('Jucas','br','Ceara',14822.0,-39.53,-6.52).
city('Lavras da Mangabeira','br','Ceara',17221.0,-38.96,-6.75).
city('Limoeiro do Norte','br','Ceara',29450.0,-38.1,-5.15).
city('Maracanau','br','Ceara',193532.0,-38.64,-3.89).
city('Maranguape','br','Ceara',68229.0,-38.71,-3.96).
city('Marco','br','Ceara',14502.0,-40.16,-3.12).
city('Massape','br','Ceara',22193.0,-40.35,-3.53).
city('Mauriti','br','Ceara',20064.0,-38.71,-7.33).
city('Milagres','br','Ceara',12588.0,-38.95,-7.32).
city('Missao Velha','br','Ceara',13106.0,-39.14,-7.26).
city('Mombaca','br','Ceara',17065.0,-39.63,-5.74).
city('Morada Nova','br','Ceara',37390.0,-38.38,-5.1).
city('Nova Russas','br','Ceara',21986.0,-40.57,-4.7).
city('Novo Oriente','br','Ceara',14529.0,-40.78,-5.53).
city('Ocara','br','Ceara',6793.0,-38.62,-4.48).
city('Oros','br','Ceara',16329.0,-38.92,-6.24).
city('Pacajus','br','Ceara',41558.0,-38.47,-4.16).
city('Pacatuba','br','Ceara',55292.0,-38.62,-3.97).
city('Paracuru','br','Ceara',21197.0,-39.04,-3.4).
city('Paraipaba','br','Ceara',18424.0,-39.12,-3.43).
city('Parambu','br','Ceara',14656.0,-40.7,-6.2).
city('Pedra Branca','br','Ceara',20072.0,-39.72,-5.45).
city('Pentecoste','br','Ceara',19681.0,-39.27,-3.79).
city('Quixada','br','Ceara',49328.0,-39.02,-4.97).
city('Quixeramobim','br','Ceara',34322.0,-39.3,-5.19).
city('Quixere','br','Ceara',11258.0,-37.97,-5.07).
city('Redencao','br','Ceara',14174.0,-38.73,-4.22).
city('Reriutaba','br','Ceara',12076.0,-40.59,-4.14).
city('Russas','br','Ceara',39465.0,-37.98,-4.94).
city('Santa Quiteria','br','Ceara',24391.0,-40.17,-4.32).
city('Santana do Acarau','br','Ceara',14707.0,-40.2,-3.45).
city('Sao Benedito','br','Ceara',24506.0,-40.76,-4.05).
city('Sao Goncalo do Amarante','br','Ceara',23583.0,-38.97,-3.6).
city('Senador Pompeu','br','Ceara',16516.0,-39.38,-5.59).
city('Sobral','br','Ceara',157998.0,-40.35,-3.69).
city('Tabuleiro do Norte','br','Ceara',16633.0,-38.18,-5.3).
city('Tamboril','br','Ceara',14292.0,-40.32,-4.83).
city('Taua','br','Ceara',29189.0,-40.31,-6.0).
city('Tiangua','br','Ceara',45697.0,-41.0,-3.73).
city('Trairi','br','Ceara',23135.0,-39.25,-3.28).
city('Ubajara','br','Ceara',13802.0,-40.94,-3.85).
city('Umirim','br','Ceara',12220.0,-39.32,-3.67).
city('Uruburetama','br','Ceara',12076.0,-39.51,-3.63).
city('Varjota','br','Ceara',16462.0,-40.5,-4.13).
city('Varzea Alegre','br','Ceara',21842.0,-40.39,-5.35).
city('Vicosa do Ceara','br','Cear',16637.0,-41.09,-3.56).
city('Brasilia','br','Distrito Federal',2207812.0,-47.91,-15.78).
city('Afonso Claudio','br','Espirito Santo',13543.0,-41.12,-20.08).
city('Agua Doce do Norte','br','Espirito Santo',6696.0,-40.99,-18.55).
city('Aguia Branca','br','Espirito Santo',2554.0,-40.74,-18.98).
city('Alegre','br','Espirito Santo',19758.0,-41.54,-20.76).
city('Alfredo Chaves','br','Espirito Santo',6422.0,-40.75,-20.63).
city('Aracruz','br','Espirito Santo',58272.0,-40.27,-19.82).
city('Baixo Guandu','br','Espirito Santo',19292.0,-41.02,-19.51).
city('Barra de Sao Francisco','br','Espirito Santo',20743.0,-40.87,-18.75).
city('Boa Esperanca','br','Espirito Santo',9254.0,-40.28,-18.55).
city('Cachoeiro de Itapemirim','br','Espirito Santo',187023.0,-41.13,-20.85).
city('Cariacica','br','Espirito Santo',330681.0,-40.37,-20.23).
city('Castelo','br','Espirito Santo',20198.0,-41.21,-20.61).
city('Colatina','br','Espirito Santo',101193.0,-40.63,-19.54).
city('Conceicao da Barra','br','Espirito Santo',19310.0,-39.74,-18.59).
city('Conceicao do Castelo','br','Espirito Santo',4538.0,-41.25,-20.37).
city('Domingos Martins','br','Espirito Santo',6061.0,-40.67,-20.37).
city('Ecoporanga','br','Espirito Santo',13774.0,-40.84,-18.37).
city('Fundao','br','Espirito Santo',12715.0,-40.41,-19.94).
city('Guacui','br','Espirito Santo',19787.0,-41.68,-20.77).
city('Guarapari','br','Espirito Santo',100927.0,-40.5,-20.66).
city('Ibatiba','br','Espirito Santo',12265.0,-41.52,-20.23).
city('Ibiracu','br','Espirito Santo',8921.0,-40.37,-19.83).
city('Iconha','br','Espirito Santo',5051.0,-40.8,-20.8).
city('Irupi','br','Espirito Santo',3505.0,-41.64,-20.35).
city('Itaguacu','br','Espirito Santo',8202.0,-40.85,-19.8).
city('Itapemirim','br','Espirito Santo',17536.0,-40.83,-21.02).
city('Itarana','br','Espirito Santo',4060.0,-40.87,-19.87).
city('Iuna','br','Espirito Santo',14290.0,-41.54,-20.34).
city('Jeronimo Monteiro','br','Espirito Santo',6902.0,-41.4,-20.78).
city('Joao Neiva','br','Espirito Santo',10383.0,-40.4,-19.75).
city('Laranja da Terra','br','Espirito Santo',3016.0,-41.07,-19.9).
city('Linhares','br','Espirito Santo',105084.0,-40.05,-19.39).
city('Mantenopolis','br','Espirito Santo',8547.0,-41.1,-18.88).
city('Marataizes','br','Espirito Santo',25397.0,-40.84,-21.03).
city('Marechal Floriano','br','Espirito Santo',5869.0,-40.67,-20.42).
city('Marilandia','br','Espirito Santo',3900.0,-40.53,-19.42).
city('Mimoso do Sul','br','Espirito Santo',14045.0,-41.37,-21.06).
city('Montanha','br','Espirito Santo',11934.0,-40.37,-18.13).
city('Mucurici','br','Espirito Santo',9524.0,-40.52,-18.1).
city('Muniz Freire','br','Espirito Santo',8312.0,-41.43,-20.46).
city('Muqui','br','Espirito Santo',8614.0,-41.32,-20.93).
city('Nova Venecia','br','Espirito Santo',28363.0,-40.4,-18.7).
city('Pancas','br','Espirito Santo',8184.0,-40.85,-19.23).
city('Pinheiros','br','Espirito Santo',13309.0,-40.22,-18.41).
city('Piuma','br','Espirito Santo',17634.0,-40.72,-20.83).
city('Rio Bananal','br','Espirito Santo',4814.0,-40.34,-19.26).
city('Rio Novo do Sul','br','Espirito Santo',6717.0,-40.94,-20.87).
city('Santa Leopoldina','br','Espirito Santo',2327.0,-40.54,-20.1).
city('Santa Maria de Jetiba','br','Espirito Santo',5883.0,-40.67,-20.05).
city('Santa Teresa','br','Espirito Santo',9160.0,-40.59,-19.94).
city('Sao Gabriel da Palha','br','Espirito Santo',17057.0,-40.54,-19.01).
city('Sao Jose do Calcado','br','Espirito Santo',7442.0,-41.67,-21.03).
city('Sao Mateus','br','Espirito Santo',77119.0,-39.86,-18.73).
city('Serra','br','Espirito Santo',394160.0,-40.32,-20.13).
city('Vargem Alta','br','Espirito Santo',4672.0,-41.0,-20.67).
city('Viana','br','Espirito Santo',55123.0,-40.51,-20.38).
city('Vila Velha','br','Espirito Santo',394937.0,-40.28,-20.32).
city('Vitoria','br','Espirito Santo',312662.0,-40.31,-20.31).
city('Abadiania','br','Goias',7062.0,-48.8,-16.1).
city('Aguas Lindas de Goias','br','Goias',116309.0,-48.25,-15.74).
city('Anapolis','br','Goias',319592.0,-48.96,-16.32).
city('Anicuns','br','Goias',15685.0,-49.96,-16.45).
city('Aparecida de Goiania','br','Goias',441181.0,-49.24,-16.82).
city('Aragarcas','br','Goias',16781.0,-52.25,-15.92).
city('Bela Vista de Goias','br','Goias',14289.0,-48.95,-16.97).
city('Buriti Alegre','br','Goias',9427.0,-49.05,-18.13).
city('Cacu','br','Goias',10098.0,-51.07,-18.61).
city('Caiaponia','br','Goias',10947.0,-51.81,-16.96).
city('Caldas Novas','br','Goias',63681.0,-48.62,-17.74).
city('Campos Belos','br','Goias',15583.0,-46.89,-13.05).
city('Carmo do Rio Verde','br','Goias',6053.0,-49.71,-15.37).
city('Catalao','br','Goias',63545.0,-47.95,-18.18).
city('Cavalcante','br','Goias',3747.0,-47.51,-13.79).
city('Ceres','br','Goias',18760.0,-49.6,-15.28).
city('Cocalzinho de Coias','br','Goias',7039.0,-46.66,-2.97).
city('Cristalina','br','Goias',36532.0,-47.61,-16.77).
city('Crixas','br','Goias',11560.0,-49.96,-14.45).
city('Edeia','br','Goias',9838.0,-49.93,-17.33).
city('Firminopolis','br','Goias',9084.0,-50.32,-16.67).
city('Formosa','br','Goias',81233.0,-47.34,-15.54).
city('Goianapolis','br','Goias',10114.0,-49.02,-16.49).
city('Goianesia','br','Goias',47884.0,-49.13,-15.31).
city('Goiania','br','Goias',1171209.0,-49.26,-16.72).
city('Goianira','br','Goias',22823.0,-49.44,-16.5).
city('Goias','br','Goias',19098.0,-50.13,-15.93).
city('Goiatuba','br','Goias',25925.0,-49.37,-18.01).
city('Guapo','br','Goias',10075.0,-49.54,-16.82).
city('Hidrolandia','br','Goias',7082.0,-49.24,-16.97).
city('Iaciara','br','Goias',9207.0,-46.66,-14.16).
city('Inhumas','br','Goias',44058.0,-49.5,-16.36).
city('Ipameri','br','Goias',18607.0,-48.16,-17.72).
city('Ipora','br','Goias',28254.0,-51.13,-16.45).
city('Itaberai','br','Goias',22130.0,-49.81,-16.02).
city('Itapaci','br','Goias',16118.0,-49.57,-14.94).
city('Itapirapua','br','Goias',7923.0,-50.6,-15.87).
city('Itapuranga','br','Goias',19709.0,-49.99,-15.59).
city('Itumbiara','br','Goias',79583.0,-49.21,-18.4).
city('Jaragua','br','Goias',30410.0,-49.34,-15.75).
city('Jatai','br','Goias',76548.0,-51.75,-17.88).
city('Jussara','br','Goias',16374.0,-52.47,-23.6).
city('Luziania','br','Goias',143601.0,-47.92,-16.25).
city('Minacu','br','Goias',28400.0,-48.21,-13.54).
city('Mineiros','br','Goias',38951.0,-52.56,-17.57).
city('Morrinhos','br','Goias',34144.0,-49.11,-17.73).
city('Mozarlandia','br','Goias',11252.0,-50.58,-14.79).
city('Neropolis','br','Goias',21870.0,-49.22,-16.4).
city('Niquelandia','br','Goias',27544.0,-48.47,-14.47).
city('Orizona','br','Goias',7583.0,-48.3,-17.02).
city('Padre Bernardo','br','Goias',16118.0,-48.52,-15.35).
city('Palmeiras de Goias','br','Goias',13573.0,-49.93,-16.79).
city('Parauna','br','Goias',9731.0,-50.46,-17.02).
city('Petrolina de Goias','br','Goias',7710.0,-49.34,-16.09).
city('Piracanjuba','br','Goias',16736.0,-49.02,-17.3).
city('Piranhas','br','Goias',9887.0,-51.85,-16.51).
city('Pirenopolis','br','Goias',13615.0,-48.97,-15.85).
city('Pires do Rio','br','Goias',24823.0,-48.28,-17.3).
city('Planaltina','br','Goias',88855.0,-47.67,-15.62).
city('Pontalina','br','Goias',13640.0,-49.45,-17.51).
city('Porangatu','br','Goias',32758.0,-49.18,-13.43).
city('Posse','br','Goias',20003.0,-46.38,-14.08).
city('Quirinopolis','br','Goias',32104.0,-50.5,-18.53).
city('Rialma','br','Goias',9270.0,-49.57,-15.3).
city('Rio Verde','br','Goias',123672.0,-50.93,-17.82).
city('Rubiataba','br','Goias',16128.0,-49.81,-15.14).
city('Santa Helena de Goias','br','Goias',34254.0,-50.59,-17.71).
city('Santa Terezinha de Goias','br','Goias',8116.0,-49.75,-14.38).
city('Santo Antonio do Descoberto','br','Goias',49427.0,-48.26,-15.97).
city('Sao Domingos','br','Goias',4784.0,-46.32,-13.39).
city('Sao Luis de Montes Belos','br','Goias',23619.0,-50.34,-16.53).
city('Sao Miguel do Araguaia','br','Goias',18810.0,-50.22,-13.32).
city('Sao Simao','br','Goias',14753.0,-50.58,-19.03).
city('Senador Canedo','br','Goias',61801.0,-49.1,-16.71).
city('Silvania','br','Goias',11377.0,-48.61,-16.67).
city('Trindade','br','Goias',97523.0,-49.5,-16.65).
city('Uruacu','br','Goias',30088.0,-49.16,-14.52).
city('Uruana','br','Goias',10258.0,-49.7,-15.5).
city('Vianopolis','br','Goias',7807.0,-48.54,-16.75).
city('Acailandia','br','Maranhao',87900.0,-47.54,-5.06).
city('Alcantara','br','Maranhao',5655.0,-44.4,-2.4).
city('Amarante do Maranhao','br','Maranhao',11510.0,-46.76,-5.56).
city('Anajatuba','br','Maranhao',5627.0,-44.62,-3.26).
city('Araioses','br','Maranhao',8667.0,-41.91,-2.88).
city('Arari','br','Maranhao',16777.0,-44.79,-3.46).
city('Bacabal','br','Maranhao',72374.0,-44.8,-4.23).
city('Balsas','br','Maranhao',68058.0,-46.05,-7.52).
city('Barra do Corda','br','Maranhao',48902.0,-45.26,-5.51).
city('Barreirinhas','br','Maranhao',17437.0,-42.84,-2.76).
city('Bequimao','br','Maranhao',5695.0,-44.79,-2.43).
city('Bom Jardim','br','Maranhao',12343.0,-46.5,-7.02).
city('Brejo','br','Maranhao',11636.0,-42.76,-3.68).
city('Buriti','br','Maranhao',7025.0,-42.93,-3.94).
city('Buriti Bravo','br','Maranhao',17693.0,-43.85,-5.84).
city('Candido Mendes','br','Maranhao',8613.0,-45.72,-1.45).
city('Cantanhede','br','Maranhao',8344.0,-44.41,-3.64).
city('Carolina','br','Maranhao',16229.0,-47.47,-7.33).
city('Carutapera','br','Maranhao',12819.0,-46.02,-1.22).
city('Caxias','br','Maranhao',117393.0,-43.38,-4.88).
city('Chapadinha','br','Maranhao',40805.0,-43.36,-3.74).
city('Codo','br','Maranhao',83289.0,-43.88,-4.48).
city('Coelho Neto','br','Maranhao',36185.0,-43.01,-4.25).
city('Colinas','br','Maranhao',25159.0,-44.24,-6.04).
city('Coroata','br','Maranhao',34130.0,-44.15,-4.13).
city('Cururupu','br','Maranhao',22007.0,-44.89,-1.83).
city('Dom Pedro','br','Maranhao',15570.0,-44.45,-4.48).
city('Esperantinopolis','br','Maranhao',13167.0,-44.88,-4.88).
city('Estreito','br','Maranhao',17647.0,-43.25,-5.78).
city('Fortuna','br','Maranhao',9755.0,-44.06,-5.67).
city('Grajau','br','Maranhao',30218.0,-46.15,-5.81).
city('Humberto de Campos','br','Maranhao',5208.0,-43.45,-2.62).
city('Icatu','br','Maranhao',3648.0,-44.07,-2.78).
city('Imperatriz','br','Maranhao',218110.0,-47.49,-5.52).
city('Itapecuru Mirim','br','Maranhao',34944.0,-44.36,-3.4).
city('Joao Lisboa','br','Maranhao',19989.0,-47.29,-5.47).
city('Lago da Pedra','br','Maranhao',25996.0,-45.17,-4.33).
city('Lago do Junco','br','Maranhao',3312.0,-44.97,-4.43).
city('Maracacume','br','Maranhao',14164.0,-45.92,-2.04).
city('Matinha','br','Maranhao',6851.0,-45.03,-3.1).
city('Matoes','br','Maranhao',11756.0,-43.3,-5.76).
city('Mirador','br','Maranhao',6955.0,-44.38,-6.36).
city('Moncao','br','Maranhao',11051.0,-45.26,-3.48).
city('Montes Altos','br','Maranhao',3518.0,-47.07,-5.82).
city('Morros','br','Maranhao',4829.0,-46.3,-9.45).
city('Nova Olinda do Maranhao','br','Maranhao',7989.0,-43.46,-6.69).
city('Paco do Lumiar','br','Maranhao',1266.0,-44.09,-2.47).
city('Paraibano','br','Maranhao',12364.0,-44.02,-6.49).
city('Parnarama','br','Maranhao',12202.0,-43.11,-5.68).
city('Passagem Franca','br','Maranhao',7376.0,-43.79,-6.18).
city('Pastos Bons','br','Maranhao',10469.0,-44.07,-6.59).
city('Paulo Ramos','br','Maranhao',8888.0,-45.19,-4.21).
city('Pedreiras','br','Maranhao',33909.0,-44.67,-4.57).
city('Penalva','br','Maranhao',17186.0,-45.18,-3.28).
city('Pindare Mirim','br','Maranhao',22934.0,-45.35,-3.61).
city('Pinheiro','br','Maranhao',38894.0,-45.09,-2.52).
city('Pio XII','br','Maranhao',14773.0,-45.29,-3.88).
city('Pirapemas','br','Maranhao',6441.0,-44.24,-3.71).
city('Pocao de Pedras','br','Maranhao',12337.0,-44.94,-4.74).
city('Porto Franco','br','Maranhao',14874.0,-47.4,-6.32).
city('Presidente Dutra','br','Maranhao',30330.0,-44.52,-5.25).
city('Raposa','br','Maranhao',11883.0,-44.17,-6.51).
city('Riachao','br','Maranhao',12428.0,-46.63,-7.35).
city('Rosario','br','Maranhao',23271.0,-44.26,-2.94).
city('Santa Helena','br','Maranhao',16045.0,-45.31,-2.23).
city('Santa Ines','br','Maranhao',67426.0,-45.39,-3.66).
city('Santa Luzia','br','Maranhao',22910.0,-47.21,-7.64).
city('Santa Quiteria do Maranhao','br','Maranhao',17180.0,-42.54,-3.52).
city('Santa Rita','br','Maranhao',13226.0,-43.89,-3.85).
city('Sao Benedito do Rio Preto','br','Maranhao',12081.0,-43.57,-3.32).
city('Sao Bento','br','Maranhao',17245.0,-44.84,-2.69).
city('Sao Bernardo','br','Maranhao',11171.0,-42.4,-3.36).
city('Sao Domingos do Maranhao','br','Maranhao',18275.0,-44.37,-5.7).
city('Sao Joao Batista','br','Maranhao',3634.0,-44.85,-2.97).
city('Sao Joao dos Patos','br','Maranhao',19539.0,-43.71,-6.49).
city('Sao Jose de Ribamar','br','Maranhao',27777.0,-44.07,-2.55).
city('Sao Luis','br','Maranhao',917252.0,-44.3,-2.5).
city('Sao Mateus do Maranhao','br','Maranhao',28234.0,-44.47,-4.03).
city('Sao Raimundo das Mangabeiras','br','Maranhao',10216.0,-45.49,-7.02).
city('Timbiras','br','Maranhao',17875.0,-43.94,-4.26).
city('Timon','br','Maranhao',124429.0,-42.84,-5.1).
city('Tuntum','br','Maranhao',16402.0,-44.65,-5.23).
city('Tu','br','Maranhao',10471.0,-45.38,-1.67).
city('Tutoia','br','Maranhao',12212.0,-42.27,-2.75).
city('Urbano Santos','br','Maranhao',12268.0,-43.41,-3.21).
city('Vargem Grande','br','Maranhao',21420.0,-43.95,-3.55).
city('Viana','br','Maranhao',26690.0,-45.0,-3.21).
city('Vitoria do Mearim','br','Maranhao',15775.0,-44.89,-3.47).
city('Vitorino Freire','br','Maranhao',13267.0,-45.17,-4.07).
city('Ze Doca','br','Maranhao',32795.0,-45.57,-3.29).
city('Amambai','br','Mato Grosso do Sul',20261.0,-55.23,-23.11).
city('Anastacio','br','Mato Grosso do Sul',18817.0,-55.8,-20.51).
city('Aparecida do Taboado','br','Mato Grosso do Sul',17332.0,-51.1,-20.09).
city('Aquidauana','br','Mato Grosso do Sul',35304.0,-55.79,-20.47).
city('Bataguassu','br','Mato Grosso do Sul',12130.0,-52.39,-21.62).
city('Bataipora','br','Mato Grosso do Sul',7346.0,-53.29,-22.33).
city('Bela Vista','br','Mato Grosso do Sul',18127.0,-56.54,-22.11).
city('Bonito','br','Mato Grosso do Sul',14504.0,-56.48,-21.12).
city('Caarapo','br','Mato Grosso do Sul',13863.0,-54.82,-22.64).
city('Camapua','br','Mato Grosso do Sul',11119.0,-54.05,-19.53).
city('Campo Grande','br','Mato Grosso do Sul',729164.0,-54.63,-20.45).
city('Cassilandia','br','Mato Grosso do Sul',18498.0,-51.74,-19.11).
city('Coronel Sapucaia','br','Mato Grosso do Sul',9195.0,-55.52,-23.25).
city('Corumba','br','Mato Grosso do Sul',96523.0,-57.64,-19.01).
city('Costa Rica','br','Mato Grosso do Sul',12931.0,-54.65,-23.42).
city('Coxim','br','Mato Grosso do Sul',30216.0,-54.75,-18.5).
city('Dourados','br','Mato Grosso do Sul',162206.0,-54.81,-22.23).
city('Eldorado','br','Mato Grosso do Sul',9075.0,-54.3,-23.79).
city('Gloria de Dourados','br','Mato Grosso do Sul',8574.0,-54.22,-22.35).
city('Guia Lopes da Laguna','br','Mato Grosso do Sul',9681.0,-56.12,-21.45).
city('Iguatemi','br','Mato Grosso do Sul',9619.0,-54.56,-23.67).
city('Itapora','br','Mato Grosso do Sul',12327.0,-54.79,-22.08).
city('Ivinhema','br','Mato Grosso do Sul',14528.0,-53.67,-22.97).
city('Jardim','br','Mato Grosso do Sul',23781.0,-56.15,-21.48).
city('Ladario','br','Mato Grosso do Sul',15790.0,-57.59,-19.02).
city('Maracaju','br','Mato Grosso do Sul',22690.0,-55.18,-21.61).
city('Miranda','br','Mato Grosso do Sul',13189.0,-56.39,-20.24).
city('Navirai','br','Mato Grosso do Sul',36453.0,-54.22,-23.13).
city('Nioaque','br','Mato Grosso do Sul',6899.0,-55.84,-21.16).
city('Nova Andradina','br','Mato Grosso do Sul',31857.0,-53.33,-22.21).
city('Paranaiba','br','Mato Grosso do Sul',32218.0,-51.2,-19.68).
city('Paranhos','br','Mato Grosso do Sul',6516.0,-55.44,-23.89).
city('Ponta Pora','br','Mato Grosso do Sul',55765.0,-55.73,-22.53).
city('Porto Murtinho','br','Mato Grosso do Sul',12672.0,-57.89,-21.68).
city('Ribas do Rio Pardo','br','Mato Grosso do Sul',11935.0,-53.76,-20.45).
city('Rio Brilhante','br','Mato Grosso do Sul',18837.0,-54.54,-21.8).
city('Rio Verde de Mato Grosso','br','Mato Grosso do Sul',16613.0,-54.88,-18.92).
city('Sidrolandia','br','Mato Grosso do Sul',16878.0,-54.95,-20.92).
city('Terenos','br','Mato Grosso do Sul',6086.0,-54.88,-20.44).
city('Tres Lagoas','br','Mato Grosso do Sul',78714.0,-51.72,-20.79).
city('Alta Floresta','br','Mato Grosso',40468.0,-55.91,-9.9).
city('Alto Araguaia','br','Mato Grosso',8780.0,-53.22,-17.31).
city('Alto Paraguai','br','Mato Grosso',6149.0,-56.55,-14.56).
city('Arenapolis','br','Mato Grosso',9060.0,-56.83,-14.43).
city('Aripuana','br','Mato Grosso',27043.0,-60.64,-9.17).
city('Barao de Melgaco','br','Mato Grosso',4353.0,-55.97,-16.21).
city('Barra do Bugres','br','Mato Grosso',31313.0,-57.19,-15.07).
city('Barra do Garcas','br','Mato Grosso',52402.0,-52.26,-15.88).
city('Caceres','br','Mato Grosso',73431.0,-57.51,-16.05).
city('Campo Verde','br','Mato Grosso',22842.0,-54.07,-20.42).
city('Castanheira','br','Mato Grosso',5209.0,-55.99,-10.33).
city('Chapada dos Guimaraes','br','Mato Grosso',13657.0,-55.77,-15.44).
city('Colider','br','Mato Grosso',21754.0,-55.5,-10.7).
city('Confresa','br','Mato Grosso',5532.0,-51.36,-10.6).
city('Cuiaba','br','Mato Grosso',5219.0,-56.09,-15.61).
city('Diamantino','br','Mato Grosso',15700.0,-56.45,-14.41).
city('Guaranta do Norte','br','Mato Grosso',27106.0,-54.9,-10.01).
city('Guiratinga','br','Mato Grosso',10938.0,-53.77,-16.35).
city('Jaciara','br','Mato Grosso',22739.0,-54.96,-15.99).
city('Juina','br','Mato Grosso',37187.0,-59.5,-11.4).
city('Lucas do Rio Verde','br','Mato Grosso',27692.0,-55.93,-16.33).
city('Matupa','br','Mato Grosso',10247.0,-54.92,-10.18).
city('Nobres','br','Mato Grosso',12010.0,-56.34,-14.73).
city('Nortelandia','br','Mato Grosso',9636.0,-56.81,-14.44).
city('Nova Olimpia','br','Mato Grosso',19283.0,-57.34,-14.79).
city('Nova Xavantina','br','Mato Grosso',14156.0,-52.35,-14.68).
city('Peixoto de Azevedo','br','Mato Grosso',16072.0,-54.98,-10.25).
city('Pocone','br','Mato Grosso',21485.0,-56.63,-16.26).
city('Pontes e Lacerda','br','Mato Grosso',29383.0,-59.35,-15.22).
city('Poxoreo','br','Mato Grosso',12481.0,-54.39,-15.83).
city('Primavera do Leste','br','Mato Grosso',72274.0,-54.28,-15.55).
city('Rondonopolis','br','Mato Grosso',152921.0,-54.64,-16.47).
city('Rosario Oeste','br','Mato Grosso',10469.0,-56.43,-14.82).
city('Santo Antonio do Leverger','br','Mato Grosso',6387.0,-56.09,-15.86).
city('Sao Felix do Araguaia','br','Mato Grosso',7512.0,-50.67,-11.6).
city('Sao Jose do Rio Claro','br','Mato Grosso',11954.0,-56.8,-16.67).
city('Sinop','br','Mato Grosso',100077.0,-55.46,-11.85).
city('Tangara da Serra','br','Mato Grosso',57621.0,-57.48,-14.63).
city('Terra Nova do Norte','br','Mato Grosso',7649.0,-55.3,-10.49).
city('Varzea Grande','br','Mato Grosso',249766.0,-56.14,-15.65).
city('Vila Rica','br','Mato Grosso',13409.0,-51.11,-9.95).
city('Abaete','br','Minas Gerais',2037.0,-45.46,-19.16).
city('Acucena','br','Minas Gerais',14506.0,-42.54,-19.06).
city('Aguas Formosas','br','Minas Gerais',11512.0,-40.94,-17.08).
city('Aguas Vermelhas','br','Minas Gerais',16410.0,-41.46,-15.76).
city('Aimores','br','Minas Gerais',19133.0,-41.07,-19.5).
city('Alem Paraiba','br','Minas Gerais',33907.0,-42.69,-21.87).
city('Alfenas','br','Minas Gerais',71407.0,-45.95,-21.41).
city('Almenara','br','Minas Gerais',29333.0,-40.7,-16.17).
city('Alpinopolis','br','Minas Gerais',13286.0,-46.4,-20.86).
city('Alterosa','br','Minas Gerais',9277.0,-46.12,-21.24).
city('Alvinopolis','br','Minas Gerais',12068.0,-43.06,-20.12).
city('Andradas','br','Minas Gerais',26773.0,-46.57,-22.07).
city('Andrelandia','br','Minas Gerais',10079.0,-44.31,-21.74).
city('Aracuai','br','Minas Gerais',22005.0,-42.07,-16.86).
city('Araguari','br','Minas Gerais',96567.0,-48.2,-18.64).
city('Araxa','br','Minas Gerais',82597.0,-46.95,-19.58).
city('Arcos','br','Minas Gerais',33356.0,-45.54,-20.28).
city('Areado','br','Minas Gerais',10689.0,-46.15,-21.35).
city('Arinos','br','Minas Gerais',10078.0,-46.07,-15.92).
city('Astolfo Dutra','br','Minas Gerais',10999.0,-42.87,-21.32).
city('Baependi','br','Minas Gerais',12853.0,-44.89,-21.97).
city('Bambui','br','Minas Gerais',18840.0,-45.98,-20.01).
city('Barao de Cocais','br','Minas Gerais',22387.0,-43.48,-19.94).
city('Barbacena','br','Minas Gerais',122213.0,-43.77,-21.22).
city('Barroso','br','Minas Gerais',16975.0,-43.97,-21.18).
city('Bela Vista de Minas','br','Minas Gerais',8690.0,-45.99,-21.0).
city('Belo Horizonte','br','Minas Gerais',2373255.0,-43.94,-19.92).
city('Belo Oriente','br','Minas Gerais',18471.0,-42.47,-19.23).
city('Betim','br','Minas Gerais',384038.0,-44.19,-19.97).
city('Bicas','br','Minas Gerais',12684.0,-43.06,-21.72).
city('Boa Esperanca','br','Minas Gerais',33840.0,-45.56,-21.09).
city('Bocaiuva','br','Minas Gerais',32115.0,-43.81,-17.11).
city('Bom Despacho','br','Minas Gerais',40304.0,-45.26,-19.73).
city('Bom Jesus do Galho','br','Minas Gerais',12476.0,-42.31,-19.82).
city('Bom Sucesso','br','Minas Gerais',13786.0,-44.77,-21.04).
city('Borda da Mata','br','Minas Gerais',12814.0,-46.17,-22.27).
city('Botelhos','br','Minas Gerais',11073.0,-46.4,-2.0).
city('Brasilia de Minas','br','Minas Gerais',14730.0,-44.43,-16.21).
city('Brumadinho','br','Minas Gerais',27564.0,-44.22,-20.13).
city('Bueno Brandao','br','Minas Gerais',5777.0,-46.35,-22.45).
city('Buritis','br','Minas Gerais',16243.0,-46.43,-15.61).
city('Buritizeiro','br','Minas Gerais',25104.0,-44.93,-17.37).
city('Caete','br','Minas Gerais',33232.0,-43.68,-19.88).
city('Camanducaia','br','Minas Gerais',17823.0,-46.15,-22.77).
city('Cambui','br','Minas Gerais',21247.0,-46.07,-22.62).
city('Cambuquira','br','Minas Gerais',10116.0,-45.3,-21.85).
city('Campanha','br','Minas Gerais',12507.0,-45.4,-21.84).
city('Campestre','br','Minas Gerais',11802.0,-46.25,-21.72).
city('Campina Verde','br','Minas Gerais',13137.0,-49.49,-19.53).
city('Campo Belo','br','Minas Gerais',47492.0,-45.28,-20.89).
city('Campos Altos','br','Minas Gerais',12648.0,-46.17,-19.68).
city('Campos Gerais','br','Minas Gerais',22260.0,-45.77,-21.23).
city('Capelinha','br','Minas Gerais',20074.0,-42.54,-17.69).
city('Capinopolis','br','Minas Gerais',12486.0,-49.57,-18.68).
city('Carai','br','Minas Gerais',6750.0,-41.7,-17.2).
city('Carandai','br','Minas Gerais',16657.0,-43.81,-20.96).
city('Carangola','br','Minas Gerais',25322.0,-42.04,-20.74).
city('Caratinga','br','Minas Gerais',60067.0,-42.14,-19.79).
city('Carlos Chagas','br','Minas Gerais',13206.0,-40.77,-17.7).
city('Carmo do Cajuru','br','Minas Gerais',16333.0,-44.77,-20.18).
city('Carmo do Paranaiba','br','Minas Gerais',26537.0,-46.35,-18.98).
city('Carmo do Rio Claro','br','Minas Gerais',14446.0,-46.1,-20.97).
city('Cassia','br','Minas Gerais',14391.0,-46.93,-20.56).
city('Cataguases','br','Minas Gerais',62619.0,-42.7,-21.39).
city('Caxambu','br','Minas Gerais',22701.0,-44.93,-21.98).
city('Centralina','br','Minas Gerais',9497.0,-49.22,-18.57).
city('Claudio','br','Minas Gerais',21825.0,-44.77,-20.44).
city('Conceicao das Alagoas','br','Minas Gerais',16152.0,-48.38,-19.91).
city('Conceicao do Mato Dentro','br','Minas Gerais',10708.0,-43.43,-19.03).
city('Conceicao do Rio Verde','br','Minas Gerais',12402.0,-45.09,-21.88).
city('Congonhas','br','Minas Gerais',48819.0,-43.87,-20.5).
city('Conselheiro Lafaiete','br','Minas Gerais',111598.0,-43.79,-20.67).
city('Conselheiro Pena','br','Minas Gerais',12735.0,-41.48,-19.0).
city('Contagem','br','Minas Gerais',627132.0,-44.1,-19.91).
city('Coracao de Jesus','br','Minas Gerais',12410.0,-44.36,-16.68).
city('Corinto','br','Minas Gerais',22121.0,-44.46,-18.36).
city('Coromandel','br','Minas Gerais',22648.0,-47.2,-18.47).
city('Coronel Fabriciano','br','Minas Gerais',100918.0,-42.64,-19.53).
city('Cruzilia','br','Minas Gerais',12816.0,-44.8,-21.83).
city('Curvelo','br','Minas Gerais',63955.0,-44.43,-18.76).
city('Diamantina','br','Minas Gerais',37344.0,-43.61,-18.24).
city('Divino','br','Minas Gerais',9058.0,-41.48,-18.77).
city('Divinopolis','br','Minas Gerais',193835.0,-44.9,-20.15).
city('Dores do Indaia','br','Minas Gerais',12859.0,-45.6,-19.46).
city('Eloi Mendes','br','Minas Gerais',19413.0,-45.57,-21.61).
city('Esmeraldas','br','Minas Gerais',103252.0,-44.32,-19.75).
city('Espera Feliz','br','Minas Gerais',13031.0,-41.92,-20.65).
city('Espinosa','br','Minas Gerais',17549.0,-42.83,-14.93).
city('Extrema','br','Minas Gerais',13682.0,-46.34,-22.86).
city('Felixandia','br','Minas Gerais',11996.0,44.92,-18.78).
city('Formiga','br','Minas Gerais',56405.0,-45.43,-20.46).
city('Francisco Sa','br','Minas Gerais',13997.0,-43.49,-16.47).
city('Frutal','br','Minas Gerais',40931.0,-48.94,-20.03).
city('Governador Valadares','br','Minas Gerais',250882.0,-41.97,-18.87).
city('Grao Mogol','br','Minas Gerais',3278.0,-42.87,-16.71).
city('Guanhaes','br','Minas Gerais',23728.0,-42.95,-18.78).
city('Guaranesia','br','Minas Gerais',17437.0,-46.8,-21.3).
city('Guaxupe','br','Minas Gerais',47890.0,-46.71,-21.29).
city('Ibia','br','Minas Gerais',18428.0,-46.54,-19.48).
city('Ibirite','br','Minas Gerais',141376.0,-44.07,-20.03).
city('Ig','br','Minas Gerais',21427.0,-44.3,-20.07).
city('Inhapim','br','Minas Gerais',13594.0,-42.12,-19.55).
city('Ipaba','br','Minas Gerais',15971.0,-42.42,-19.38).
city('Ipanema','br','Minas Gerais',11705.0,-41.71,-19.8).
city('Ipatinga','br','Minas Gerais',228750.0,-42.52,-19.48).
city('Itabira','br','Minas Gerais',99498.0,-43.23,-19.62).
city('Itabirito','br','Minas Gerais',39453.0,-43.81,-20.24).
city('Itacarambi','br','Minas Gerais',13084.0,-44.12,-15.08).
city('Itajuba','br','Minas Gerais',81871.0,-45.45,-22.42).
city('Itamarandiba','br','Minas Gerais',18064.0,-42.85,-17.85).
city('Itambacuri','br','Minas Gerais',14652.0,-41.7,-18.01).
city('Itanhandu','br','Minas Gerais',11274.0,-44.95,-22.3).
city('Itaobim','br','Minas Gerais',15938.0,-41.51,-16.55).
city('Itapecerica','br','Minas Gerais',16684.0,-45.13,-20.47).
city('Itau de Minas','br','Minas Gerais',14888.0,-46.75,-20.72).
city('Itauna','br','Minas Gerais',77402.0,-44.57,-20.06).
city('Itinga','br','Minas Gerais',4917.0,-41.78,-16.6).
city('Ituiutaba','br','Minas Gerais',85346.0,-49.46,-18.97).
city('Iturama','br','Minas',29805.0,-50.2,-19.73).
city('Jacutinga','br','Minas Gerais',18470.0,-46.61,-22.29).
city('Jaiba','br','Minas Gerais',18168.0,-43.6,-15.62).
city('Janauba','br','Minas Gerais',56573.0,-43.31,-15.8).
city('Januaria','br','Minas Gerais',34812.0,-44.37,-15.48).
city('Jequitinhonha','br','Minas Gerais',15463.0,-41.01,-16.43).
city('Joaima','br','Minas Gerais',9022.0,-41.04,-16.65).
city('Joao Monlevade','br','Minas Gerais',72763.0,-43.16,-19.83).
city('Joao Pinheiro','br','Minas Gerais',28083.0,-46.17,-17.74).
city('Juatuba','br','Minas Gerais',24551.0,-44.32,-19.95).
city('Juiz de Fora','br','Minas Gerais',470201.0,-43.36,-21.75).
city('Lagoa Formosa','br','Minas Gerais',11822.0,-46.4,-18.78).
city('Lagoa Santa','br','Minas Gerais',38487.0,-43.9,-19.65).
city('Lagoa da Prata','br','Minas Gerais',43119.0,-45.54,-20.02).
city('Lajinha','br','Minas Gerais',15731.0,41.62,-20.16).
city('Lambari','br','Minas Gerais',14516.0,-45.35,-21.98).
city('Lavras','br','Minas Gerais',81474.0,-45.01,-21.25).
city('Leopoldina','br','Minas Gerais',46743.0,-42.64,-21.53).
city('Lima Duarte','br','Minas Gerais',1348.0,-43.79,-21.84).
city('Luz','br','Minas Gerais',14396.0,-45.68,-19.79).
city('Machado','br','Minas Gerais',33003.0,-45.92,-21.68).
city('Malacacheta','br','Minas Gerais',8820.0,-42.08,-17.85).
city('Manga','br','Minas Gerais',11733.0,-43.95,-14.75).
city('Manhuacu','br','Minas Gerais',54608.0,-42.04,-20.26).
city('Manhumirim','br','Minas Gerais',15544.0,-41.96,-20.36).
city('Mantena','br','Minas Gerais',18715.0,-40.93,-18.77).
city('Mar de Espanha','br','Minas Gerais',9678.0,-43.0,-21.86).
city('Mariana','br','Minas Gerais',45237.0,-43.4,-20.38).
city('Martinho Campos','br','Minas Gerais',9198.0,-45.24,-19.33).
city('Mateus Leme','br','Minas Gerais',24890.0,-44.43,-19.99).
city('Matias Barbosa','br','Minas Gerais',12072.0,-43.33,-21.88).
city('Matipo','br','Minas Gerais',12997.0,-42.35,-20.28).
city('Mato Verde','br','Minas Gerais',7783.0,-42.87,-15.38).
city('Matozinhos','br','Minas Gerais',30844.0,-44.12,-19.58).
city('Medina','br','Minas Gerais',14686.0,-41.49,-16.25).
city('Minas Novas','br','Minas Gerais',7365.0,-42.6,-17.25).
city('Mirabela','br','Minas Gerais',8934.0,-44.19,-16.25).
city('Mirai','br','Minas Gerais',8500.0,-42.62,-21.2).
city('Monte Alegre de Minas','br','Minas Gerais',12451.0,-48.87,-18.87).
city('Monte Azul','br','Minas Gerais',11222.0,-42.88,-15.15).
city('Monte Carmelo','br','Minas Gerais',44041.0,-47.5,-18.72).
city('Monte Santo de Minas','br','Minas Gerais',16617.0,-46.98,-21.18).
city('Monte Siao','br','Minas Gerais',11090.0,-46.57,-22.43).
city('Montes Claros','br','Minas Gerais',332384.0,-43.86,-16.72).
city('Muriae','br','Minas Gerais',91174.0,-42.39,-21.13).
city('Mutum','br','Minas Gerais',12582.0,-41.44,-19.81).
city('Muzambinho','br','Minas Gerais',16254.0,-46.54,-21.36).
city('Nanuque','br','Minas Gerais',37825.0,-40.35,-17.84).
city('Nepomuceno','br','Minas Gerais',18911.0,-45.25,-21.23).
city('Nova Era','br','Minas Gerais',15595.0,-43.05,-19.77).
city('Nova Lima','br','Minas Gerais',88400.0,-43.85,-19.98).
city('Nova Serrana','br','Minas Gerais',51103.0,-44.9,-19.86).
city('Novo Cruzeiro','br','Minas Gerais',10385.0,-41.89,-17.48).
city('Oliveira','br','Minas Gerais',34711.0,-44.83,-20.69).
city('Ouro Branco','br','Minas Gerais',26687.0,-43.7,-20.53).
city('Ouro Fino','br','Minas Gerais',21076.0,-52.82,-28.98).
city('Ouro Preto','br','Minas Gerais',63679.0,-43.51,-20.38).
city('Padre Paraiso','br','Minas Gerais',10608.0,-41.53,-17.11).
city('Papagaios','br','Minas Gerais',11850.0,-44.74,-19.52).
city('Para de Minas','br','Minas Gerais',75787.0,-44.61,-19.84).
city('Paracatu','br','Minas Gerais',70754.0,-46.87,-17.2).
city('Paraguacu','br','Minas Gerais',15742.0,-45.74,-21.55).
city('Paraisopolis','br','Minas Gerais',13563.0,-45.78,-22.59).
city('Paraopeba','br','Minas Gerais',19151.0,-44.41,-19.27).
city('Passa Quatro','br','Minas Gerais',12765.0,-44.97,-22.38).
city('Passos','br','Minas Gerais',98753.0,-46.61,-20.71).
city('Patos de Minas','br','Minas Gerais',126236.0,-46.52,-18.58).
city('Patrocinio','br','Minas Gerais',71964.0,-47.0,-18.93).
city('Pecanha','br','Minas Gerais',6903.0,-42.57,-18.55).
city('Pedra Azul','br','Minas Gerais',20899.0,-41.28,-15.99).
city('Pedro Leopoldo','br','Minas Gerais',49262.0,-44.04,-19.61).
city('Perdoes','br','Minas Gerais',17821.0,-45.1,-21.11).
city('Pirapora','br','Minas Gerais',51657.0,-44.93,-17.33).
city('Pitangui','br','Minas Gerais',18859.0,-44.89,-19.68).
city('Piumhi','br','Minas Gerais',27328.0,-45.96,-20.47).
city('Pocos de Caldas','br','Minas Gerais',146590.0,-46.57,-21.78).
city('Pompeu','br','Minas Gerais',25278.0,-45.0,-19.22).
city('Ponte Nova','br','Minas Gerais',48188.0,-42.9,-20.41).
city('Porteirinha','br','Minas Gerais',14144.0,-43.03,-15.74).
city('Pouso Alegre','br','Minas Gerais',115203.0,-45.94,-22.22).
city('Prata','br','Minas Gerais',19896.0,-48.93,-19.3).
city('Presidente Olegario','br','Minas Gerais',13587.0,-46.42,-18.4).
city('Raposo','br','Minas Gerais',13263.0,-43.8,-19.95).
city('Raul Soares','br','Minas Gerais',13210.0,-42.45,-20.1).
city('Recreio','br','Minas Gerais',8882.0,-42.47,-21.53).
city('Resplendor','br','Minas Gerais',15131.0,-41.25,-19.33).
city('Ribeirao das Neves','br','Minas Gerais',406840.0,-44.08,-19.76).
city('Rio Casca','br','Minas Gerais',11769.0,-42.66,-20.22).
city('Rio Novo','br','Minas Gerais',6258.0,-43.13,-21.46).
city('Rio Pardo de Minas','br','Minas Gerais',9540.0,-42.55,-15.62).
city('Rio Piracicaba','br','Minas Gerais',10439.0,-43.19,-19.92).
city('Rio Pomba','br','Minas Gerais',13707.0,-43.18,-21.27).
city('Sabara','br','Minas Gerais',158359.0,-43.87,-19.89).
city('Sabinopolis','br','Minas Gerais',9713.0,-43.1,-18.67).
city('Sacramento','br','Minas Gerais',16983.0,-47.45,-19.87).
city('Salinas','br','Minas Gerais',25747.0,-42.3,-16.17).
city('Santa Barbara','br','Minas Gerais',19991.0,-43.41,-19.97).
city('Santa Luzia','br','Minas Gerais',243506.0,-43.87,-19.78).
city('Santa Maria do Suacui','br','Minas Gerais',9936.0,-42.42,-18.2).
city('Santa Rita do Sapucai','br','Minas Gerais',28766.0,-45.72,-22.25).
city('Santa Vit','br','Minas Gerais',11657.0,-50.12,-18.85).
city('Santana do Paraiso','br','Minas Gerais',25537.0,-42.52,-19.36).
city('Santo Antonio do Amparo','br','Minas Gerais',16730.0,-44.92,-20.95).
city('Santo Antonio do Monte','br','Minas Gerais',22592.0,-45.3,-20.09).
city('Santos Dumont','br','Minas Gerais',41582.0,-43.56,-21.46).
city('Sao Domingos do Prata','br','Minas Gerais',9466.0,-42.97,-19.86).
city('Sao Francisco','br','Minas Gerais',33033.0,-44.86,-15.95).
city('Sao Goncalo do Sapucai','br','Minas Gerais',19487.0,-45.6,-21.89).
city('Sao Gotardo','br','Minas Gerais',34145.0,-46.05,-19.31).
city('Sao Joao Evangelista','br','Minas Gerais',10049.0,-42.74,-18.52).
city('Sao Joao Nepomuceno','br','Minas Gerais',23155.0,-43.01,-21.55).
city('Sao Joao da Ponte','br','Minas Gerais',8373.0,-44.02,-15.93).
city('Sao Joao del Rei','br','Minas Gerais',78593.0,-44.25,-21.13).
city('Sao Joao do Paraiso','br','Minas Gerais',8859.0,-42.02,-15.32).
city('Sao Joaquim de Bicas','br','Minas Gerais',14630.0,-44.27,-20.04).
city('Sao Lourenco','br','Minas Gerais',41144.0,-45.05,-22.12).
city('Sao Sebastiao do Paraiso','br','Minas Gerais',57239.0,-46.99,-20.92).
city('Sarzedo','br','Minas Gerais',20800.0,-44.14,-20.02).
city('Serro','br','Minas Gerais',12616.0,-43.38,-18.6).
city('Sete Lagoas','br','Minas Gerais',201337.0,-44.25,-19.45).
city('Taiobeiras','br','Minas Gerais',24351.0,-42.24,-15.81).
city('Teofilo Otoni','br','Minas Gerais',101172.0,-41.5,-17.87).
city('Timoteo','br','Minas Gerais',91723.0,-42.67,-19.58).
city('Tiradentes','br','Minas Gerais',4439.0,-44.19,-21.12).
city('Tocantins','br','Minas Gerais',12876.0,-43.04,-21.17).
city('Tres Coracoes','br','Minas Gerais',63458.0,-45.26,-21.69).
city('Tres Pontas','br','Minas Gerais',43750.0,-45.52,-21.36).
city('Tupaciguara','br','Minas Gerais',24398.0,-48.7,-18.59).
city('Turmalina','br','Minas Gerais',8798.0,-42.74,-17.29).
city('Uba','br','Minas Gerais',97829.0,-42.95,-21.12).
city('Uberaba','br','Minas Gerais',260847.0,-47.94,-19.76).
city('Uberlandia','br','Minas Gerais',563545.0,-48.28,-18.9).
city('Unai','br','Minas Gerais',60203.0,-46.9,-16.36).
city('Varginha','br','Minas Gerais',116573.0,-45.43,-21.56).
city('Varzea da Palma','br','Minas Gerais',28706.0,-44.73,-17.59).
city('Varzelandia','br','Minas Gerais',6398.0,-44.04,-15.7).
city('Vazante','br','Minas Gerais',15459.0,-46.91,-17.98).
city('Vespasiano','br','Minas Gerais',94750.0,-43.93,-19.69).
city('Vicosa','br','Minas Gerais',68681.0,-42.88,-20.76).
city('Visconde do Rio Branco','br','Minas Gerais',29010.0,-42.84,-21.03).
city('Abaetetuba','br','Para',78052.0,-48.89,-1.72).
city('Acara','br','Para',12803.0,-48.2,-1.96).
city('Afua','br','Para',7031.0,-50.39,-0.16).
city('Agua Azul do Norte','br','Para',2707.0,-50.88,-6.9).
city('Alenquer','br','Para',26291.0,-54.79,-1.94).
city('Almei','br','Para',20464.0,-52.58,-1.53).
city('Altamira','br','Para',70890.0,-52.21,-3.2).
city('Ananindeua','br','Para',433956.0,-48.38,-1.38).
city('Augusto Correa','br','Para',16280.0,-46.67,-1.03).
city('Baiao','br','Para',12316.0,-49.68,-2.68).
city('Barcarena','br','Para',29872.0,-48.66,-1.51).
city('Belem','br','Para',1407737.0,-48.5,-1.44).
city('Benevides','br','Para',49813.0,-48.24,-1.36).
city('Braganca','br','Para',57164.0,-46.77,-1.05).
city('Breu Branco','br','Para',26984.0,-49.47,-3.69).
city('Breves','br','Para',46474.0,-50.49,-1.68).
city('Bujaru','br','Para',6189.0,-48.02,-1.52).
city('Cameta','br','Para',45202.0,-49.51,-2.24).
city('Capanema','br','Para',47768.0,-47.18,-1.19).
city('Capitao Poco','br','Para',32704.0,-47.09,-1.75).
city('Castanhal','br','Para',137410.0,-47.93,-1.29).
city('Conceicao do Araguaia','br','Para',27116.0,-49.29,-8.25).
city('Curionopolis','br','Para',11898.0,-50.69,-6.14).
city('Curuca','br','Para',10843.0,-47.85,-0.72).
city('Eldorado dos Carajas','br','Para',21992.0,-49.37,-6.12).
city('Gurupa','br','Para',6461.0,-51.66,-1.4).
city('Igarape-Acu','br','Para',24136.0,-47.63,-1.12).
city('Igarape-Miri','br','Para',26838.0,-48.97,-1.98).
city('Irituia','br','Para',5602.0,-47.44,-1.76).
city('Itaituba','br','Para',64758.0,-55.99,-4.27).
city('Itupiranga','br','Para',21301.0,-49.3,-5.12).
city('Jacareacanga','br','Para',1402.0,-57.66,-6.27).
city('Jacunda','br','Para',46470.0,-49.39,-4.6).
city('Juruti','br','Para',13333.0,-56.08,-2.15).
city('Limoeiro do Ajuru','br','Para',4109.0,-49.39,-1.9).
city('Maraba','br','Para',145865.0,-49.13,-5.34).
city('Maracana','br','Para',12683.0,-47.46,-0.76).
city('Marapanim','br','Para',10236.0,-47.7,-0.7).
city('Medicilandia','br','Para',5158.0,-52.7,-3.42).
city('Mocajuba','br','Para',16567.0,-49.51,-2.58).
city('Moju','br','Para',21511.0,-48.77,-1.88).
city('Monte Alegre','br','Para',22841.0,-54.08,-2.0).
city('Muana','br','Para',7464.0,-49.23,-1.52).
city('Novo Progresso','br','Para',15654.0,55.44,-7.0).
city('Novo Repartimento','br','Para',24416.0,-50.12,-4.25).
city('Obidos','br','Para',24971.0,-55.52,-1.91).
city('Oeiras do Para','br','Para',10163.0,-49.86,-1.96).
city('Oriximina','br','Para',35582.0,-55.87,-1.76).
city('Ourem','br','Para',8145.0,-47.11,-1.55).
city('Ourilandia','br','Para',8803.0,-51.15,-6.83).
city('Pacaja','br','Para',5610.0,-50.92,-3.82).
city('Paragominas','br','Para',69616.0,-47.49,-2.96).
city('Parauapebas','br','Para',77528.0,-49.89,-6.05).
city('Portel','br','Para',21315.0,-50.82,-1.95).
city('Porto de Moz','br','Para',9912.0,-52.24,-1.74).
city('Prainha','br','Para',6481.0,-53.48,-1.8).
city('Redencao','br','Para',65104.0,-50.08,-8.01).
city('Rondon do Para','br','Para',32910.0,-48.01,-4.73).
city('Ruropolis','br','Para',6137.0,-54.9,-4.09).
city('Salinopolis','br','Para',40999.0,-47.34,-0.61).
city('Santa Isabel do Para','br','Para',39284.0,-48.16,-1.29).
city('Santa Maria do Para','br','Para',12915.0,-47.57,-1.35).
city('Santana do Araguaia','br','Para',26234.0,-50.42,-9.22).
city('Santarem','br','Para',189053.0,-54.72,-2.43).
city('Santo Antonio do Taua','br','Para',8921.0,-48.14,-1.18).
city('Sao Caetano de Odivelas','br','Para',8862.0,-48.04,-0.75).
city('Sao Felix do Xingu','br','Para',16478.0,-51.99,-6.63).
city('Sao Geraldo do Araguaia','br','Para',12925.0,-48.56,-6.38).
city('Sao Joao de Pirabas','br','Para',10065.0,-47.17,-0.76).
city('Sao Miguel do Guama','br','Para',28266.0,-47.48,-1.62).
city('Senador Jose Porfirio','br','Para',5708.0,-51.92,-2.58).
city('Soure','br','Para',18212.0,-48.52,-0.72).
city('Tailandia','br','Para',48539.0,-48.99,-2.96).
city('Terra Santa','br','Para',13512.0,-56.48,-2.11).
city('Tome-Acu','br','Para',34054.0,-48.16,-2.41).
city('Tucuma','br','Para',15031.0,-50.05,-0.18).
city('Tucurui','br','Para',76339.0,-49.72,-3.68).
city('Uruara','br','Para',21600.0,-54.03,-3.83).
city('Vigia','br','Para',29229.0,-48.14,-0.8).
city('Viseu','br','Para',18958.0,-46.14,-1.2).
city('Xinguara','br','Para',26978.0,-50.23,-7.0).
city('Alagoa Grande','br','Paraiba',16406.0,-35.63,-7.04).
city('Alagoa Nova','br','Paraiba',9182.0,-35.77,-7.06).
city('Alagoinha','br','Paraiba',7474.0,-35.55,-6.93).
city('Alhandra','br','Paraiba',10788.0,-34.9,-7.43).
city('Aracagi','br','Paraiba',6252.0,-35.37,-6.65).
city('Arara','br','Paraiba',7641.0,-35.75,-6.83).
city('Araruna','br','Paraiba',7667.0,-35.74,-6.53).
city('Areia','br','Paraiba',13825.0,-35.7,-6.97).
city('Aroeiras','br','Paraiba',7019.0,-35.69,-7.51).
city('Bananeiras','br','Paraiba',7371.0,-35.62,-6.75).
city('Barra de Santa Rosa','br','Paraiba',7351.0,-35.48,-6.62).
city('Bayeux','br','Paraiba',91058.0,-34.92,-7.13).
city('Belem','br','Paraiba',15550.0,-35.5,-6.71).
city('Boqueirao','br','Paraiba',11566.0,-36.14,-7.5).
city('Brejo do Cruz','br','Paraiba',8777.0,-37.53,-6.18).
city('Caapora','br','Paraiba',13770.0,-34.9,-7.52).
city('Cabedelo','br','Paraiba',54841.0,-34.83,-6.98).
city('Cacimba de Dentro','br','Paraiba',7447.0,-35.79,-6.65).
city('Cajazeiras','br','Paraiba',43914.0,-38.56,-6.89).
city('Campina Grande','br','Paraiba',348943.0,-35.88,-7.23).
city('Catole do Rocha','br','Paraiba',19812.0,-37.75,-6.34).
city('Conceicao','br','Paraiba',9649.0,-38.41,-7.5).
city('Conde','br','Paraiba',15865.0,34.89,-7.23).
city('Coremas','br','Paraiba',11897.0,-37.95,-7.01).
city('Cruz do Espirito Santo','br','Paraiba',5812.0,-35.1,-7.13).
city('Cuite','br','Paraiba',11392.0,-36.15,-6.48).
city('Desterro','br','Paraiba',5374.0,-37.1,-7.29).
city('Dona Ines','br','Paraiba',3709.0,-35.64,-6.62).
city('Esperanca','br','Paraiba',18817.0,-35.85,-7.02).
city('Fagundes','br','Paraiba',5137.0,-35.8,-7.35).
city('Guarabira','br','Paraiba',43750.0,-35.49,-6.86).
city('Gurinhem','br','Paraiba',5618.0,-35.46,-7.13).
city('Imaculada','br','Paraiba',4014.0,-37.5,-7.37).
city('Inga','br','Paraiba',8751.0,-35.61,-7.29).
city('Itabaiana','br','Paraiba',19101.0,-35.34,-7.33).
city('Itaporanga','br','Paraiba',15890.0,-38.15,-7.3).
city('Itapororoca','br','Paraiba',7452.0,-35.24,-7.83).
city('Itatuba','br','Paraiba',4951.0,-35.65,-7.38).
city('Jacarau','br','Paraiba',7035.0,-35.3,-6.66).
city('Joao Pessoa','br','Paraiba',650896.0,-34.86,-7.12).
city('Juazeirinho','br','Paraiba',8846.0,-38.05,-6.82).
city('Juripiranga','br','Paraiba',8320.0,-35.24,-7.37).
city('Juru','br','Paraiba',3796.0,-37.82,-7.53).
city('Lagoa Seca','br','Paraiba',8103.0,-35.85,-7.15).
city('Mamanguape','br','Paraiba',27607.0,-35.14,-6.85).
city('Manaira','br','Paraiba',4913.0,-38.17,-7.7).
city('Mari','br','Parai',17535.0,-35.31,-7.06).
city('Massaranduba','br','Paraiba',3153.0,-35.77,-7.18).
city('Mogeiro','br','Paraiba',4767.0,-35.47,-7.3).
city('Monteiro','br','Paraiba',17727.0,-37.13,-7.88).
city('Mulungu','br','Paraiba',4181.0,-35.47,-7.03).
city('Natuba','br','Paraiba',3333.0,-35.57,-7.63).
city('Nova Floresta','br','Paraiba',8623.0,-36.2,-6.45).
city('Patos','br','Paraiba',92577.0,-37.29,-7.02).
city('Paulista','br','Paraiba',3677.0,-37.62,-6.58).
city('Pedras de Fogo','br','Paraiba',13894.0,-35.12,-7.38).
city('Pianco','br','Paraiba',10482.0,-37.93,-7.19).
city('Picui','br','Paraiba',10779.0,-36.35,-6.51).
city('Pilar','br','Paraiba',7588.0,-35.27,-7.25).
city('Pirpirituba','br','Paraiba',8355.0,-35.5,-6.77).
city('Pitimbu','br','Paraiba',7862.0,-34.81,-7.46).
city('Pocinhos','br','Paraiba',7803.0,-36.07,-7.07).
city('Pombal','br','Paraiba',21751.0,-37.81,-6.76).
city('Princesa Isabel','br','Paraiba',12616.0,-38.0,-7.73).
city('Puxinana','br','Paraiba',3210.0,-35.97,-7.14).
city('Queimadas','br','Paraiba',20446.0,-35.89,-7.36).
city('Remigio','br','Paraiba',9659.0,-35.79,-6.93).
city('Rio Tinto','br','Paraiba',11804.0,-35.07,-6.81).
city('Salgado de Sao Felix','br','Paraiba',4266.0,-35.44,-7.35).
city('Santa Luzia','br','Paraiba',13243.0,-36.92,-6.87).
city('Santa Rita','br','Paraiba',119895.0,-34.96,-7.13).
city('Sao Bento','br','Paraiba',24749.0,-37.75,-6.28).
city('Sao Joao do Rio do Peixe','br','Paraiba',7338.0,-38.47,-6.55).
city('Sao Jose de Piranhas','br','Paraiba',7628.0,-38.51,-7.12).
city('Sao Sebastiao de Lagoa de Roca','br','Paraiba',3570.0,-35.87,-7.08).
city('Sape','br','Paraiba',36149.0,-35.15,-7.13).
city('Serra Branca','br','Paraiba',8765.0,-38.27,-6.53).
city('Solanea','br','Paraiba',17031.0,-35.65,-6.75).
city('Soledade','br','Paraiba',8090.0,-36.37,-7.06).
city('Sousa','br','Paraiba',47927.0,-38.23,-6.76).
city('Sume','br','Paraiba',10441.0,-36.89,-7.67).
city('Taperoa','br','Paraiba',8879.0,-36.83,-7.21).
city('Tavares','br','Paraiba',4939.0,-37.88,-7.63).
city('Teixeira','br','Paraiba',9954.0,-37.26,-7.22).
city('Triunfo','br','Paraiba',3871.0,-38.6,-6.57).
city('Uirauna','br','Paraiba',7823.0,-38.42,-6.52).
city('Umbuzeiro','br','Paraiba',4588.0,-35.67,-7.68).
city('Almirante Tamandare','br','Parana',89500.0,-49.32,-25.3).
city('Alto Parana','br','Parana',10888.0,-52.37,-23.08).
city('Alto Piquiri','br','Parana',10039.0,-53.45,-24.02).
city('Altonia','br','Parana',11242.0,-53.9,-23.93).
city('Ampere','br','Parana',14275.0,-53.46,-25.91).
city('Andira','br','Parana',20758.0,-50.23,-23.04).
city('Ant','br','Parana',16152.0,-48.71,-25.44).
city('Apucarana','br','Parana',107086.0,-51.47,-23.55).
city('Arapongas','br','Parana',97513.0,-51.43,-23.41).
city('Arapoti','br','Parana',19996.0,-49.83,-24.15).
city('Araucaria','br','Parana',111303.0,-49.4,-25.58).
city('Assai','br','Parana',12545.0,-50.85,-23.37).
city('Assis Chateaubriand','br','Parana',25665.0,-53.51,-24.41).
city('Astorga','br','Parana',20129.0,-51.67,-23.24).
city('Bandeirantes','br','Parana',29495.0,-50.37,-23.1).
city('Barbosa Ferraz','br','Parana',9048.0,-52.01,-24.03).
city('Bela Vista do Paraiso','br','Parana',14332.0,-51.19,-23.0).
city('Cambara','br','Parana',21380.0,-50.09,-23.04).
city('Cambe','br','Parana',91081.0,-51.26,-23.23).
city('Campina Grande do Sul','br','Parana',31112.0,-49.08,-25.31).
city('Campina da Lagoa','br','Parana',11893.0,-52.81,-24.62).
city('Campo Largo','br','Parana',94669.0,-49.54,-25.44).
city('Campo Murao','br','Parana',75402.0,-52.42,-24.05).
city('Candido de Abreu','br','Parana',5102.0,-51.34,-24.57).
city('Carambei','br','Parana',13466.0,-50.07,-24.92).
city('Cascavel','br','Parana',257174.0,-53.46,-24.96).
city('Castro','br','Parana',42092.0,-50.01,-24.79).
city('Centenario do Sul','br','Parana',8358.0,-51.62,-22.8).
city('Chopinzinho','br','Parana',14142.0,-52.54,-25.85).
city('Cianorte','br','Parana',55995.0,-52.62,-23.65).
city('Clevelandia','br','Parana',14701.0,-52.37,-26.41).
city('Colombo','br','Parana',217002.0,-49.24,-25.29).
city('Colorado','br','Parana',20449.0,-51.98,-22.83).
city('Corbelia','br','Parana',12725.0,-53.3,-24.8).
city('Cornelio Procopio','br','Parana',45031.0,-50.65,-23.18).
city('Coronel Vivida','br','Parana',15841.0,-52.58,-25.98).
city('Cruzeiro do Oeste','br','Parana',15058.0,-53.08,-23.78).
city('Curitiba','br','Parana',1718433.0,-49.29,-25.42).
city('Dois Vizinhos','br','Parana',22766.0,-53.06,-25.75).
city('Engenheiro Beltrao','br','Parana',14955.0,-52.24,-23.77).
city('Faxinal','br','Parana',13464.0,-51.37,-23.98).
city('Florestopolis','br','Parana',13250.0,-51.39,-22.86).
city('Foz do Iguacu','br','Parana',293526.0,-54.58,-25.55).
city('Francis','br','Parana',57618.0,-53.07,-26.07).
city('Goioere','br','Parana',20711.0,-53.04,-24.18).
city('Guaira','br','Parana',27611.0,-54.27,-24.09).
city('Guaraniacu','br','Parana',7781.0,-52.87,-25.1).
city('Guarapuava','br','Parana',150851.0,-51.48,-25.38).
city('Guaratuba','br','Parana',18906.0,-48.59,-25.92).
city('Ibaiti','br','Parana',25797.0,-50.19,-23.84).
city('Ibipora','br','Parana',44791.0,-51.05,-23.28).
city('Imbituva','br','Parana',19671.0,-50.61,-25.23).
city('Ipora','br','Parana',10353.0,-53.62,-23.98).
city('Irati','br','Parana',45831.0,-50.66,-25.47).
city('Itaperucu','br','Parana',26552.0,-49.37,-25.2).
city('Ivaipora','br','Parana',23316.0,-51.68,-24.24).
city('Jacarezinho','br','Parana',35090.0,-49.98,-23.16).
city('Jaguariaiva','br','Parana',30627.0,-49.72,-24.24).
city('Jandaia do Sul','br','Parana',17507.0,-51.65,-23.6).
city('Jataizinho','br','Parana',10014.0,-50.97,-23.22).
city('Lapa','br','Parana',25621.0,-49.73,-25.76).
city('Laranjeiras do Sul','br','Parana',18425.0,-52.43,-25.41).
city('Loanda','br','Parana',18233.0,-53.14,-22.93).
city('Londrina','br','Parana',471836.0,-51.18,-23.3).
city('Mandaguacu','br','Parana',14866.0,-52.11,-23.35).
city('Mandaguari','br','Parana',38239.0,-51.68,-23.53).
city('Marechal Candido Rondon','br','Parana',43028.0,-54.07,-24.56).
city('Marialva','br','Parana',26001.0,-51.7,-23.47).
city('Maringa','br','Parana',311727.0,-51.93,-23.41).
city('Matelandia','br','Parana',10816.0,-53.99,-25.23).
city('Matinhos','br','Parana',32008.0,-48.56,-25.83).
city('Media','br','Parana',34069.0,-54.12,-25.27).
city('Moreira Sales','br','Parana',8699.0,-53.06,-24.01).
city('Nova Aurora','br','Parana',9013.0,-52.57,-22.87).
city('Nova Esperanca','br','Parana',24833.0,-52.21,-23.18).
city('Nova Londrina','br','Parana',11042.0,-53.0,-22.76).
city('Ortigueira','br','Parana',11541.0,-50.93,-24.21).
city('Paicandu','br','Parana',34365.0,-52.04,-23.44).
city('Palmas','br','Parana',39150.0,-52.0,-26.48).
city('Palmeira','br','Parana',18630.0,-50.02,-25.42).
city('Palotina','br','Parana',23059.0,-53.85,-24.28).
city('Paranagua','br','Parana',141014.0,-48.54,-25.51).
city('Paranavai','br','Parana',72849.0,-52.47,-23.08).
city('Pato Branco','br','Parana',65754.0,-52.7,-26.23).
city('Peabiru','br','Parana',12345.0,-52.35,-23.91).
city('Pinhais','br','Parana',124225.0,-49.22,-25.54).
city('Pinhao','br','Parana',15141.0,-51.64,-25.71).
city('Pirai do Sul','br','Parana',16409.0,-49.95,-24.53).
city('Piraquara','br','Parana',41162.0,-49.07,-25.43).
city('Pitanga','br','Parana',18652.0,-51.77,-24.76).
city('Ponta Grossa','br','Parana',292179.0,-50.16,-25.09).
city('Pontal do Parana','br','Parana',14969.0,-48.34,-25.57).
city('Porecatu','br','Parana',11390.0,-51.39,-22.76).
city('Primero de Maio','br','Parana',9940.0,-51.02,-22.85).
city('Prudentopolis','br','Parana',19611.0,-50.95,-25.19).
city('Quatro Barras','br','Parana',17526.0,-49.09,-25.36).
city('Quedas do Iguacu','br','Parana',20754.0,-52.86,-25.44).
city('Realeza','br','Parana',10389.0,-53.54,-25.77).
city('Reserva','br','Parana',11097.0,-50.85,-24.65).
city('Ribeirao do Pinhal','br','Parana',11275.0,-50.37,-23.4).
city('Rio Branco do Sul','br','Parana',26441.0,-49.32,-25.17).
city('Rio Negro','br','Parana',23007.0,-49.79,-26.1).
city('Rolandia','br','Parana',51005.0,-51.38,-23.31).
city('Santa Terezinha de Itaipu','br','Parana',18593.0,-54.4,-25.43).
city('Santo Antonio da Platina','br','Parana',35260.0,-50.08,-23.3).
city('Santo Antonio do Sudoeste','br','Parana',11723.0,-53.73,-26.06).
city('Sao Jose dos Pinhais','br','Parana',229988.0,-49.18,-25.57).
city('Sao Mateus do Sul','br','Parana',24904.0,-50.39,-25.88).
city('Sao Miguel do Iguacu','br','Parana',15434.0,-54.17,-25.35).
city('Sarandi','br','Parana',84698.0,-51.87,-23.43).
city('Senges','br','Parana',14868.0,-49.49,-24.1).
city('Sertanopolis','br','Parana',13904.0,-51.03,-23.06).
city('Siquera Campos','br','Parana',13866.0,-49.83,-23.69).
city('Tapejara','br','Parana',10726.0,-52.89,-23.68).
city('Telemaco Borba','br','Parana',58880.0,-50.62,-24.33).
city('Terra Boa','br','Parana',12958.0,-52.47,-23.76).
city('Terra Rica','br','Parana',10346.0,-52.63,-22.72).
city('Terra Roxa','br','Parana',10911.0,-50.02,-23.85).
city('Tibagi','br','Parana',12644.0,-50.39,-24.49).
city('Toledo','br','Parana',97846.0,-53.74,-24.73).
city('Umuarama','br','Parana',89688.0,-53.32,-23.76).
city('Uniao da Victoria','br','Parana',48741.0,-51.07,-26.23).
city('Wenceslau Braz','br','Parana',15726.0,-49.81,-23.88).
city('Abreu e Lima','br','Pernambuco',81960.0,-34.88,-7.95).
city('Afogados da Ingazeira','br','Pernambuco',25060.0,-37.64,-7.75).
city('Agrestina','br','Pernambuco',14453.0,-35.96,-8.45).
city('Agua Preta','br','Pernambuco',16444.0,-35.53,-8.7).
city('Aguas Belas','br','Pernambuco',22563.0,-37.12,-9.11).
city('Alianca','br','Pernambuco',17329.0,-35.24,-7.6).
city('Altinho','br','Pernambuco',11913.0,-36.06,-8.49).
city('Amaraji','br','Pernambuco',16660.0,-35.45,-8.38).
city('Aracoiaba','br','Pernambuco',13095.0,-35.04,-7.79).
city('Araripina','br','Pernambuco',38570.0,-40.57,-7.55).
city('Arcoverde','br','Pernambuco',57164.0,-37.07,-8.42).
city('Barra de Guabiraba','br','Pernambuco',9286.0,-35.67,-8.41).
city('Barreiros','br','Pernambuco',35565.0,-35.2,-8.83).
city('Belem de Sao Francisco','br','Pernambuco',11124.0,-38.95,-8.74).
city('Belo Jardim','br','Pernambuco',49923.0,-36.42,-8.33).
city('Bezerros','br','Pernambuco',51437.0,-35.75,-8.23).
city('Bodoco','br','Pernambuco',11329.0,-39.95,-7.78).
city('Bom Conselho','br','Pernambuco',27801.0,-36.69,-9.16).
city('Bom Jardim','br','Pernambuco',13523.0,-35.59,-7.78).
city('Bonito','br','Pernambuco',8867.0,-35.73,-8.46).
city('Brejo da Madre de Deus','br','Pernambuco',27370.0,-36.37,-8.14).
city('Buique','br','Pernambuco',20324.0,-37.16,-8.61).
city('Cabo de Santo Agostinho','br','Pernambuco',143108.0,-35.03,-8.29).
city('Cabrobo','br','Pernambuco',16096.0,-39.31,-8.51).
city('Cachoeirinha','br','Pernambuco',12905.0,-36.24,-8.49).
city('Caetes','br','Pernambuco',5386.0,-36.64,-8.76).
city('Camaragibe','br','Pernambuco',148966.0,-35.04,-8.0).
city('Camocim de Sao Felix','br','Pernambuco',10270.0,-35.76,-8.35).
city('Canhotinho','br','Pernambuco',12074.0,-36.19,-8.87).
city('Capoeiras','br','Pernambuco',4861.0,-36.63,-8.73).
city('Carnaiba','br','Pernambuco',6019.0,-37.67,-8.7).
city('Carpina','br','Pernambuco',70690.0,-35.26,-7.84).
city('Caruaru','br','Pernambuco',235375.0,-35.98,-8.28).
city('Catende','br','Pernambuco',23323.0,-35.72,-8.66).
city('Cha Grande','br','Pernambuco',17117.0,-35.44,-8.22).
city('Condado','br','Pernambuco',19585.0,-35.1,-7.58).
city('Cumaru','br','Pernambuco',6861.0,-35.7,-8.0).
city('Cupira','br','Pernambuco',19096.0,-35.96,-8.62).
city('Custodia','br','Pernambuco',18107.0,-37.64,-8.08).
city('Escada','br','Pernambuco',48084.0,-35.24,-8.36).
city('Exu','br','Pernambuco',10875.0,-39.73,-7.51).
city('Feira Nova','br','Pernambuco',12985.0,-35.35,-7.93).
city('Fernando de Noronha','br','Pernambuco',2116.0,-32.43,-3.85).
city('Flores','br','Pernambuco',11694.0,-37.98,-7.86).
city('Floresta','br','Pernambuco',18100.0,-38.58,-8.59).
city('Gameleira','br','Pernambuco',19424.0,-35.38,-8.58).
city('Garanhuns','br','Pernambuco',110087.0,-36.5,-8.89).
city('Gloria do Goita','br','Pernambuco',17374.0,-35.29,-8.02).
city('Goiana','br','Pernambuco',43981.0,-35.0,-7.56).
city('Gravata','br','Pernambuco',61250.0,-35.55,-8.19).
city('Ibimirim','br','Pernambuco',12272.0,-37.69,-8.54).
city('Igarassu','br','Pernambuco',86458.0,-34.9,-7.83).
city('Ipojuca','br','Pernambuco',53365.0,-35.07,-8.4).
city('Ipubi','br','Pernambuco',16424.0,-40.16,-7.65).
city('Itaiba','br','Pernambuco',13870.0,-37.43,-8.94).
city('Itamaraca','br','Pernambuco',14969.0,-34.84,-7.75).
city('Itapissuma','br','Pernambuco',16674.0,-34.9,-7.77).
city('Itaquitinga','br','Pernambuco',11128.0,-35.1,-7.66).
city('Jaboatao','br','Pernambuco',702632.0,-35.02,-8.11).
city('Joao Alfredo','br','Pernambuco',11334.0,-35.59,-7.87).
city('Joaquim Nabuco','br','Pernambuco',9965.0,-35.54,-8.61).
city('Lagoa do Itaenga','br','Pernambuco',17719.0,-35.34,-7.92).
city('Lajedo','br','Pernambuco',25262.0,-36.32,-8.66).
city('Limoeiro','br','Pernambuco',42329.0,-35.45,-7.87).
city('Macaparana','br','Pernambuco',14363.0,-35.45,-7.57).
city('Maraial','br','Pernambuco',14204.0,-35.83,-8.78).
city('Moreno','br','Pernambuco',45238.0,-35.1,-8.11).
city('Nazare da Mata','br','Pernambuco',26485.0,-35.22,-7.73).
city('Olinda','br','Pernambuco',366761.0,-34.85,-8.0).
city('Orobo','br','Pernambuco',5884.0,-35.6,-7.73).
city('Ouricuri','br','Pernambuco',29318.0,-40.09,-7.88).
city('Palmares','br','Pernambuco',41680.0,-35.59,-8.66).
city('Panelas','br','Pernambuco',12625.0,-36.11,-8.64).
city('Parnamirim','br','Pernambuco',7928.0,-39.59,-8.08).
city('Passira','br','Pernambuco',12664.0,-35.65,-7.94).
city('Paudalho','br','Pernambuco',35673.0,-35.17,-7.89).
city('Paulista','br','Pernambuco',289977.0,-34.91,-7.9).
city('Pedra','br','Pernambuco',11197.0,-36.95,-8.49).
city('Pesqueira','br','Pernambuco',41896.0,-36.72,-8.35).
city('Petrolandia','br','Pernambuco',20575.0,-38.3,-9.07).
city('Petrolina','br','Pernambuco',194653.0,-40.51,-9.38).
city('Pombos','br','Pernambuco',15895.0,-35.4,-8.14).
city('Quipapa','br','Pernambuco',11533.0,-36.02,-8.81).
city('Recife','br','Pernambuco',1478118.0,-34.92,-8.08).
city('Ribeirao','br','Pernambuco',29819.0,-35.38,-8.5).
city('Rio Formoso','br','Pernambuco',15518.0,-35.15,-8.67).
city('Salgueiro','br','Pernambuco',42153.0,-39.13,-8.06).
city('Santa Cruz do Capibaribe','br','Pernambuco',76451.0,-36.21,-7.96).
city('Santa Maria da Boa Vista','br','Pernambuco',14695.0,-39.82,-8.8).
city('Sao Bento do Una','br','Pernambuco',24506.0,-36.45,-8.51).
city('Sao Caitano','br','Pernambuco',25259.0,-36.14,-8.33).
city('Sao Joao','br','Pernambuco',6926.0,-36.37,-8.86).
city('Sao Joaquim do Monte','br','Pernambuco',13520.0,-35.85,-8.41).
city('Sao Jose da Coroa Grande','br','Pernambuco',11512.0,-35.14,-8.89).
city('Sao Jose do Belmonte','br','Pernambuco',14211.0,-38.76,-7.86).
city('Sao Jose do Egito','br','Pernambuco',18219.0,-37.28,-7.48).
city('Sao Lourenco da Mata','br','Pernambuco',88417.0,-35.05,-8.0).
city('Serra Talhada','br','Pernambuco',51204.0,-38.3,-7.99).
city('Sertania','br','Pernambuco',18190.0,-37.27,-8.06).
city('Sirinhaem','br','Pernambuco',14220.0,-36.12,-8.59).
city('Surubim','br','Pernambuco',34581.0,-35.75,-7.83).
city('Tabira','br','Pernambuco',16926.0,-37.55,-7.59).
city('Tamandare','br','Pernambuco',17954.0,-35.09,-8.74).
city('Taquaritinga do Norte','br','Pernambuco',13379.0,-36.05,-7.9).
city('Timbauba','br','Pernambuco',45122.0,-35.32,-7.5).
city('Toritama','br','Pernambuco',23941.0,-36.06,-8.0).
city('Trindade','br','Pernambuco',19313.0,-40.27,-7.77).
city('Tupanatinga','br','Pernambuco',5768.0,-37.34,-8.75).
city('Vicencia','br','Pernambuco',10378.0,-35.32,-7.65).
city('Vitoria de Santo Antao','br','Pernambuco',107385.0,-35.3,-8.12).
city('Agua Branca','br','Piaui',13912.0,-42.65,-5.9).
city('Alto Longa','br','Piaui',4435.0,-42.21,-5.24).
city('Altos','br','Piaui',28769.0,-42.46,-5.05).
city('Amarante','br','Piaui',8828.0,-4.0,-6.23).
city('Barras','br','Piaui',21597.0,-42.3,-4.25).
city('Batalha','br','Piaui',8744.0,-42.09,-4.03).
city('Beneditinos','br','Piaui',5005.0,-42.36,-5.45).
city('Bom Jesus','br','Piaui',12666.0,-44.37,-9.07).
city('Buriti dos Lopes','br','Piaui',9475.0,-41.87,-3.17).
city('Campo Maior','br','Piaui',31740.0,-42.18,-4.82).
city('Canto do Buriti','br','Piaui',11715.0,-42.97,-8.1).
city('Castelo do Piaui','br','Piaui',8589.0,-41.57,-5.33).
city('Cocal','br','Piaui',12097.0,-41.55,-3.47).
city('Cor','br','Piaui',13967.0,-45.17,-10.44).
city('Demerval Lobao','br','Piaui',15285.0,-42.69,-5.37).
city('Elesbao Veloso','br','Piaui',10430.0,-42.14,-6.21).
city('Esperantina','br','Piaui',21044.0,-42.24,-3.9).
city('Floriano','br','Piaui',48588.0,-43.03,-6.77).
city('Gilbues','br','Piaui',4920.0,-45.36,-9.83).
city('Guadalupe','br','Piaui',9684.0,-43.56,-6.78).
city('Inhuma','br','Piaui',7056.0,-41.71,-6.67).
city('Itainopolis','br','Piaui',2922.0,-41.52,-7.4).
city('Itaueira','br','Piaui',5146.0,-43.03,-7.6).
city('Jaicos','br','Piaui',7107.0,-41.14,-7.35).
city('Jose de Freitas','br','Piaui',21433.0,-42.58,-4.76).
city('Luis Correia','br','Piaui',11480.0,-41.67,-2.88).
city('Luzilandia','br','Piaui',12999.0,-42.38,-3.47).
city('Matias Olimpio','br','Piaui',4012.0,-42.56,-3.72).
city('Miguel Alves','br','Piaui',10439.0,-42.9,-4.17).
city('Monsenhor Gil','br','Piaui',4751.0,-42.62,-5.58).
city('Oeiras','br','Piaui',21071.0,-42.13,-7.01).
city('Palmeirais','br','Piaui',4262.0,-43.07,-5.96).
city('Parnaiba','br','Piaui',138011.0,-41.77,-2.91).
city('Pedro II','br','Piaui',22039.0,-41.46,-4.42).
city('Picos','br','Piaui',57496.0,-41.44,-7.08).
city('Pimenteiras','br','Piaui',3819.0,-41.42,-6.23).
city('Pio IX','br','Piaui',4973.0,-40.62,-6.83).
city('Piracuruca','br','Piaui',18852.0,-41.72,-3.93).
city('Piripiri','br','Piaui',44866.0,-41.79,-4.27).
city('Porto','br','Piaui',6535.0,-42.7,-3.9).
city('Regeneracao','br','Piaui',13608.0,-42.69,-6.24).
city('Sao Joao do Piaui','br','Piaui',12689.0,-42.25,-8.35).
city('Sao Miguel do Tapuio','br','Piaui',7964.0,-41.33,-5.5).
city('Sao Pedro do Piaui','br','Piaui',7408.0,-42.72,-5.93).
city('Sao Raimundo Nonato','br','Piaui',19569.0,-42.69,-9.0).
city('Simoes','br','Piaui',4332.0,-40.82,-7.6).
city('Simplicio Mendes','br','Piaui',7076.0,-41.91,-7.86).
city('Teresina','br','Piaui',744526.0,-42.8,-5.1).
city('Uniao','br','Piaui',15678.0,-42.87,-4.59).
city('Urucui','br','Piaui',12243.0,-44.56,-7.24).
city('Valenca do Piaui','br','Piaui',15881.0,-41.74,-6.4).
city('Acari','br','Rio Grande do Norte',9159.0,-36.64,-6.43).
city('Acu','br','Rio Grande do Norte',36126.0,-36.91,-5.58).
city('Afonso Bezerra','br','Rio Grande do Norte',6947.0,-36.51,-5.5).
city('Alexandria','br','Rio Grande do Norte',9769.0,-38.02,-6.42).
city('Angicos','br','Rio Grande do Norte',7729.0,-36.6,-5.67).
city('Apodi','br','Rio Grande do Norte',16757.0,-37.8,-5.66).
city('Areia Branca','br','Rio Grande do Norte',18372.0,-37.16,-4.98).
city('Ares','br','Rio Grande do Norte',7231.0,-35.15,-6.18).
city('Barauna','br','Rio Grande do Norte',14113.0,-37.62,-5.08).
city('Brejinho','br','Rio Grande do Norte',7625.0,-35.35,-6.18).
city('Caico','br','Rio Grande do Norte',54935.0,-37.1,-6.46).
city('Canguaretama','br','Rio Grande do Norte',18873.0,-35.13,-6.37).
city('Caraubas','br','Rio Grande do Norte',12462.0,-37.56,-5.78).
city('Ceara-Mirim','br','Rio Grande do Norte',32668.0,-35.43,-5.64).
city('Cerro Cora','br','Rio Grande do Norte',4927.0,-36.35,-6.05).
city('Currais Novos','br','Rio Grande do Norte',35561.0,-36.51,-6.26).
city('Extremoz','br','Rio Grande do Norte',17992.0,-35.3,-5.7).
city('Goianinha','br','Rio Grande do Norte',13434.0,-35.2,-6.27).
city('Governador Dix-Sept Rosado','br','Rio Grande do Norte',6626.0,-37.52,-5.45).
city('Ipanguacu','br','Rio Grande do Norte',4624.0,-36.87,-5.5).
city('Jardim de Piranhas','br','Rio Grande do Norte',10935.0,-37.34,-6.37).
city('Jardim do Serido','br','Rio Grande do Norte',9520.0,-36.77,-6.58).
city('Joao Camara','br','Rio Grande do Norte',19886.0,-35.82,-5.54).
city('Jucurutu','br','Rio Grande do Norte',11535.0,-37.02,-6.04).
city('Lagoa Nova','br','Rio Grande do Norte',5984.0,-36.49,-6.1).
city('Macaiba','br','Rio Grande do Norte',40016.0,-35.35,-5.85).
city('Macau','br','Rio Grande do Norte',18070.0,-36.64,-5.11).
city('Montanhas','br','Rio Grande do Norte',8442.0,-35.3,-6.48).
city('Monte Alegre','br','Rio Grande do Norte',6643.0,-36.3,-5.88).
city('Mossoro','br','Rio Grande do Norte',202010.0,-37.34,-5.19).
city('Natal','br','Rio Grande do Norte',763057.0,-35.22,-5.8).
city('Nisia Floresta','br','Rio Grande do Norte',10115.0,-35.14,-6.06).
city('Nova Cruz','br','Rio Grande do Norte',23166.0,-35.44,-6.47).
city('Parelhas','br','Rio Grande do Norte',16377.0,-36.66,-6.68).
city('Parnamirim','br','Rio Grande do Norte',150347.0,-35.26,-5.91).
city('Patu','br','Rio Grande do Norte',8842.0,-37.64,-6.1).
city('Pau dos Ferros','br','Rio Grande do Norte',25051.0,-38.21,-6.11).
city('Pedro Velho','br','Rio Grande do Norte',6366.0,-35.22,-6.43).
city('Pendencias','br','Rio Grande do Norte',9363.0,-36.72,-5.26).
city('Poco Branco','br','Rio Grande do Norte',7112.0,-35.67,-5.63).
city('Santa Cruz','br','Rio Grande do Norte',27776.0,-36.03,-6.22).
city('Santana do Matos','br','Rio Grande do Norte',8050.0,-36.66,-5.95).
city('Santo Antonio','br','Rio Grande do Norte',12529.0,-35.47,-6.31).
city('Sao Goncalo do Amarante','br','Rio Grande do Norte',10381.0,-35.34,-5.77).
city('Sao Jose de Mipibu','br','Rio Grande do Norte',15317.0,-35.24,-6.08).
city('Sao Jose do Campestre','br','Rio Grande do Norte',10254.0,-35.7,-6.3).
city('Sao Miguel','br','Rio Grande do Norte',12838.0,-35.37,-5.47).
city('Sao Paulo do Potengi','br','Rio Grande do Norte',9334.0,-35.75,-5.92).
city('Sao Tome','br','Rio Grande do Norte',6137.0,-36.07,-5.97).
city('Severiano Melo','br','Rio Grande do Norte',2503.0,-37.95,-5.77).
city('Taipu','br','Rio Grande do Norte',4606.0,-35.6,-5.62).
city('Tangara','br','Rio Grande do Norte',8067.0,-35.81,-6.2).
city('Touros','br','Rio Grande do Norte',7662.0,-35.47,-5.2).
city('Umarizal','br','Rio Grande do Norte',8781.0,-37.82,-5.99).
city('Upanema','br','Rio Grande do Norte',6704.0,-37.25,-5.63).
city('Alegrete','br','Rio Grande do Sul',77540.0,-55.79,-29.78).
city('Alvorada','br','Rio Grande do Sul',208909.0,-51.09,-30.02).
city('Arroio Grande','br','Rio Grande do Sul',16117.0,-53.09,-32.24).
city('Arroio do Meio','br','Rio Grande do Sul',16331.0,-51.95,-29.4).
city('Arroio dos Ratos','br','Rio Grande do Sul',13405.0,-51.72,-30.08).
city('Bage','br','Rio Grande do Sul',98943.0,-54.1,-31.32).
city('Bento Goncalves','br','Rio Grande do Sul',90854.0,-51.52,-29.17).
city('Butia','br','Rio Grande do Sul',19494.0,-51.96,-30.11).
city('Cacapava do Sul','br','Rio Grande do Sul',17522.0,-53.48,-30.51).
city('Cacequi','br','Rio Grande do Sul',12868.0,-54.83,-29.89).
city('Cachoeira do Sul','br','Rio Grande do Sul',74696.0,-52.91,-30.03).
city('Cachoeirinha','br','Rio Grande do Sul',121086.0,-51.09,-29.95).
city('Camaqua','br','Rio Grande do Sul',53170.0,-51.81,-30.84).
city('Campo Bom','br','Rio Grande do Sul',54762.0,-51.09,-29.58).
city('Candelaria','br','Rio Grande do Sul',15200.0,-52.8,-29.66).
city('Canela','br','Rio Gran',33529.0,-50.81,-29.36).
city('Cangucu','br','Rio Grande do Sul',20134.0,-52.68,-31.4).
city('Canoas','br','Rio Grande do Sul',328297.0,-51.18,-29.92).
city('Capao da Canoa','br','Rio Grande do Sul',35896.0,-50.02,-29.76).
city('Capao de Leao','br','Rio Grande do Sul',24707.0,-52.5,-31.77).
city('Carazinho','br','Rio Grande do Sul',59418.0,-52.8,-28.29).
city('Carlos Barbosa','br','Rio Grande do Sul',19106.0,-51.51,-29.29).
city('Caxias do Sul','br','Rio Grande do Sul',381277.0,-51.17,-29.18).
city('Cerro Largo','br','Rio Grande do Sul',9548.0,-54.74,-28.14).
city('Charqueadas','br','Rio Grande do Sul',32076.0,-51.64,-29.96).
city('Cidreira','br','Rio Grande do Sul',8965.0,-50.21,-30.18).
city('Cruz Alta','br','Rio Grande do Sul',65276.0,-53.62,-28.64).
city('Dois Irmaos','br','Rio Grande do Sul',28926.0,-51.02,-29.63).
city('Dom Pedrito','br','Rio Grande do Sul',36912.0,-54.68,-30.98).
city('Encantado','br','Rio Grande do Sul',16637.0,-51.88,-29.24).
city('Encruzilhada do Sul','br','Rio Grande do Sul',17199.0,-52.52,-30.54).
city('Erechim','br','Rio Grande do Sul',96089.0,-52.27,-27.63).
city('Espumoso','br','Rio Grande do Sul',10340.0,-52.86,-28.72).
city('Estancia Velha','br','Rio Grande do Sul',40391.0,-51.19,-29.65).
city('Esteio','br','Rio Grande do Sul',84903.0,-51.17,-29.83).
city('Estrela','br','Rio Grande do Sul',24200.0,-50.98,-28.1).
city('Farroupilha','br','Rio Grande do Sul',57651.0,-51.35,-29.23).
city('Flores da Cunha','br','Rio Grande do Sul',20522.0,-51.19,-29.03).
city('Frederico Westphalen','br','Rio Grande do Sul',20896.0,-53.41,-27.35).
city('Garibaldi','br','Rio Grande do Sul',30364.0,-51.53,-29.25).
city('Getulio Vargas','br','Rio Grande do Sul',13695.0,-52.27,-27.91).
city('Girua','br','Rio Grande do Sul',12170.0,-54.36,-28.03).
city('Gramado','br','Rio Grande do Sul',26365.0,-50.89,-29.37).
city('Gravatai','br','Rio Grande do Sul',238782.0,-50.99,-29.95).
city('Guaiba','br','Rio Grande do Sul',101026.0,-51.32,-30.11).
city('Guapore','br','Rio Grande do Sul',20050.0,-51.89,-28.85).
city('Horizontina','br','Rio Grande do Sul',14416.0,-54.32,-27.63).
city('Ibiruba','br','Rio Grande do Sul',14180.0,-53.11,-28.63).
city('Igrejinha','br','Rio Grande do Sul',28680.0,-50.8,-29.58).
city('Ijui','br','Rio Grande do Sul',71203.0,-53.92,-28.39).
city('Itaqui','br','Rio Grande do Sul',34631.0,-56.55,-29.13).
city('Ivoti','br','Rio Grande do Sul',18172.0,-51.17,-29.6).
city('Jaguarao','br','Rio Grande do Sul',29613.0,-53.37,-32.56).
city('Julio de Castilhos','br','Rio Grande do Sul',16487.0,-53.69,-29.23).
city('Lagoa Vermelha','br','Rio Grande do Sul',24446.0,-51.52,-28.21).
city('Lajeado','br','Rio Grande do Sul',65408.0,-51.96,-29.45).
city('Marau','br','Rio Grande do Sul',26860.0,-52.21,-28.45).
city('Montenegro','br','Rio Grande do Sul',54058.0,-51.48,-29.67).
city('Nao-Me-Toque','br','Rio Grande do Sul',12556.0,-52.82,-28.47).
city('Nova Petropolis','br','Rio Grande do Sul',16050.0,-51.14,-29.36).
city('Nova Prata','br','Rio Grande do Sul',17943.0,-51.6,-28.78).
city('Novo Hamburgo','br','Rio Grande do Sul',253846.0,-51.14,-29.71).
city('Osorio','br','Rio Grande do Sul',34628.0,-50.27,-29.88).
city('Palmares do Sul','br','Rio Grande do Sul',8393.0,-50.52,-30.26).
city('Palmeira das Missoes','br','Rio Grande do Sul',30954.0,-53.32,-27.9).
city('Panambi','br','Rio Grande do Sul',30408.0,-53.51,-28.29).
city('Parobe','br','Rio Grande do Sul',48560.0,-50.84,-29.63).
city('Passo Fundo','br','Rio Grande do Sul',179532.0,-52.42,-28.25).
city('Pedro Osorio','br','Rio Grande do Sul',6176.0,-52.84,-31.86).
city('Pelotas','br','Rio Grande do Sul',320680.0,-52.34,-31.76).
city('Pinheiro Machado','br','Rio Grande do Sul',11176.0,-53.38,-31.58).
city('Portao','br','Rio Grande do Sul',21051.0,-51.25,-29.69).
city('Porto Alegre','br','Rio Grande do Sul',1372763.0,-51.22,-30.04).
city('Quarai','br','Rio Grande do Sul',23229.0,-56.46,-30.38).
city('Rio Grande','br','Rio Grande do Sul',187842.0,-52.11,-32.05).
city('Rio Pardo','br','Rio Grande do Sul',26999.0,-52.37,-29.98).
city('Rolante','br','Rio Grande do Sul',15594.0,-50.57,-29.67).
city('Rosario do Sul','br','Rio G',36722.0,-54.92,-30.25).
city('Sananduva','br','Rio Grande do Sul',9601.0,-51.79,-27.94).
city('Santa Cruz do Sul','br','Rio Grande do Sul',106115.0,-52.44,-29.71).
city('Santa Maria','br','Rio Grande do Sul',249224.0,-53.83,-29.69).
city('Santa Rosa','br','Rio Grande do Sul',58958.0,-54.46,-27.87).
city('Santa Vitoria do Palmar','br','Rio Grande do Sul',27776.0,-53.37,-33.52).
city('Santana do Livramento','br','Rio Grande do Sul',89696.0,-55.53,-30.88).
city('Santiago','br','Rio Grande do Sul',46612.0,-54.88,-29.18).
city('Santo Angelo','br','Rio Grande do Sul',64607.0,-54.28,-28.3).
city('Santo','br','Rio Grande do Sul',10305.0,-53.78,-27.85).
city('Sao Borja','br','Rio Grande do Sul',59614.0,-56.01,-28.66).
city('Sao Francisco de Assis','br','Rio Grande do Sul',14305.0,-55.13,-29.55).
city('Sao Francisco de Paula','br','Rio Grande do Sul',13292.0,-50.58,-29.44).
city('Sao Gabriel','br','Rio Grande do Sul',55435.0,-54.32,-30.32).
city('Sao Jeronimo','br','Rio Grande do Sul',17057.0,-51.72,-29.97).
city('Sao Leopoldo','br','Rio Grande do Sul',209233.0,-51.15,-29.78).
city('Sao Lourenco do Sul','br','Rio Grande do Sul',25341.0,-51.98,-31.37).
city('Sao Luiz Gonzaga','br','Rio Grande do Sul',31798.0,-54.96,-28.41).
city('Sao Marcos','br','Rio Grande do Sul',18591.0,-51.08,-28.97).
city('Sao Pedro do Sul','br','Rio Grande do Sul',12137.0,-54.18,-29.62).
city('Sao Sebastiao do Cai','br','Rio Grande do Sul',19013.0,-51.39,-29.58).
city('Sao Sepe','br','Rio Grande do Sul',19182.0,-53.59,-30.16).
city('Sapiranga','br','Rio Grande do Sul',76053.0,-51.0,-29.63).
city('Sapucaia','br','Rio Grande do Sul',130939.0,-51.16,-29.83).
city('Sarandi','br','Rio Grande do Sul',15159.0,-52.93,-27.94).
city('Sobradinho','br','Rio Grande do Sul',13397.0,-53.13,-29.42).
city('Soledade','br','Rio Grande do Sul',24791.0,-52.52,-28.83).
city('Tapejara','br','Rio Grande do Sul',14064.0,-52.01,-28.07).
city('Tapes','br','Rio Grande do Sul',18570.0,-51.4,-30.67).
city('Taquara','br','Rio Grande do Sul',48052.0,-50.79,-29.65).
city('Taquari','br','Rio Grande do Sul',27108.0,-51.86,-29.8).
city('Teutonia','br','Rio Grande do Sul',21834.0,-51.8,-29.43).
city('Torres','br','Rio Grande do Sul',32791.0,-49.74,-29.35).
city('Tramandai','br','Rio Grande do Sul',34735.0,-50.13,-29.97).
city('Tres Coroas','br','Rio Grande do Sul',21051.0,-50.8,-29.53).
city('Tres Passos','br','Rio Grande do Sul',17286.0,-53.94,-27.45).
city('Tres de Maio','br','Rio Grande do Sul',18278.0,-54.26,-27.78).
city('Triunfo','br','Rio Grande do Sul',14749.0,-51.72,-29.93).
city('Tupancireta','br','Rio Grande do Sul',17488.0,-53.85,-29.08).
city('Uruguaiana','br','Rio Grande do Sul',123482.0,-57.09,-29.77).
city('Vacaria','br','Rio Grande do Sul',56766.0,-50.94,-28.5).
city('Venancio Aires','br','Rio Grande do Sul',40628.0,-52.2,-29.61).
city('Veranopolis','br','Rio Grande do Sul',19862.0,-51.56,-28.94).
city('Viamao','br','Rio Grande do Sul',285274.0,-50.98,-30.09).
city('Angra dos Reis','br','Rio',153637.0,-44.32,-23.0).
city('Araruama','br','Rio de Janeiro',109638.0,-42.36,-22.87).
city('Areal','br','Rio de Janeiro',11041.0,-43.1,-22.22).
city('Armacao dos Buzios','br','Rio de Janeiro',23463.0,-41.87,-22.74).
city('Arraial do Cabo','br','Rio de Janeiro',26164.0,-42.02,-22.96).
city('Barra Mansa','br','Rio de Janeiro',164054.0,-44.17,-22.56).
city('Barra do Pirai','br','Rio de Janeiro',87669.0,-43.83,-22.47).
city('Belford Roxo','br','Rio de Janeiro',466101.0,-43.42,-22.75).
city('Bom Jardim','br','Rio de Janeiro',11716.0,-42.45,-22.14).
city('Bom Jesus do Itabapoana','br','Rio de Janeiro',30822.0,-41.69,-21.14).
city('Cabo Frio','br','Rio de Janeiro',108241.0,-42.04,-22.89).
city('Cachoeiras de Macacu','br','Rio de Janeiro',46178.0,-42.66,-22.48).
city('Cambuci','br','Rio de Janeiro',9395.0,-41.91,-21.56).
city('Campos','br','Rio de Janeiro',387422.0,-41.34,-21.75).
city('Cantagalo','br','Rio de Janeiro',14019.0,-42.36,-21.96).
city('Carmo','br','Rio de Janeiro',11555.0,-42.6,-21.92).
city('Casimiro de Abreu','br','Rio de Janeiro',19087.0,-42.22,-22.48).
city('Conceicao da Macabu','br','Rio de Janeiro',17553.0,-41.87,-22.09).
city('Cordeiro','br','Rio de Janeiro',15602.0,-42.37,-22.03).
city('Duque de Caxias','br','Rio de Janeiro',818339.0,-43.31,-22.77).
city('Guapimirim','br','Rio de Janeiro',31202.0,-42.98,-22.53).
city('Iguaba Grande','br','Rio de Janeiro',11104.0,-42.21,-22.82).
city('Itaborai','br','Rio de Janeiro',182500.0,-42.87,-22.75).
city('Itaguai','br','Rio de Janeiro',100756.0,-43.78,-22.87).
city('Itaocara','br','Rio de Janeiro',16763.0,-42.07,-21.68).
city('Itaperuna','br','Rio de Janeiro',84436.0,-41.89,-21.21).
city('Itatiaia','br','Rio de Janeiro',12571.0,-44.57,-22.5).
city('Japeri','br','Rio de Janeiro',95102.0,-43.66,-22.65).
city('Macae','br','Rio de Janeiro',143031.0,-41.79,-22.38).
city('Mage','br','Rio de Janeiro',216342.0,-43.05,-22.65).
city('Mangaratiba','br','Rio de Janeiro',27023.0,-44.04,-22.96).
city('Marica','br','Rio de Janeiro',79552.0,-42.82,-22.92).
city('Mendes','br','Rio de Janeiro',17308.0,-43.71,-22.53).
city('Miguel Pereira','br','Rio de Janeiro',23850.0,-43.48,-22.46).
city('Miracema','br','Rio de Janeiro',26684.0,-42.2,-21.41).
city('Natividade','br','Rio de Janeiro',12014.0,-41.99,-21.05).
city('Nilopolis','br','Rio de Janeiro',147283.0,-43.42,-22.8).
city('Niteroi','br','Rio de Janeiro',456461.0,-43.13,-22.9).
city('Nova Friburgo','br','Rio de Janeiro',153363.0,-42.54,-22.26).
city('Nova Iguacu','br','Rio de Janeiro',1002129.0,-43.47,-22.74).
city('Paracambi','br','Rio de Janeiro',36099.0,-43.72,-22.6).
city('Paraiba do Sul','br','Rio de Janeiro',35518.0,-43.3,-22.15).
city('Parati','br','Rio de Janeiro',15118.0,-44.72,-23.21).
city('Paty do Alferes','br','Rio de Janeiro',20659.0,-43.43,-22.43).
city('Petropolis','br','Rio de Janeiro',272694.0,-43.2,-22.51).
city('Pinheiral','br','Rio de Janeiro',19469.0,-43.97,-22.51).
city('Pirai','br','Rio de Janeiro',19105.0,-43.9,-22.63).
city('Porciuncula','br','Rio de Janeiro',12511.0,-42.04,-20.97).
city('Porto Real','br','Rio de Janeiro',12061.0,-44.32,-22.41).
city('Quatis','br','Rio de Janeiro',10289.0,-44.26,-22.41).
city('Queimados','br','Rio de Janeiro',135742.0,-43.58,-22.7).
city('Resende','br','Rio de Janeiro',111515.0,-44.45,-22.46).
city('Rio Bonito','br','Rio de Janeiro',35997.0,-42.63,-22.71).
city('Rio Claro','br','Rio de Janeiro',12620.0,-44.15,-22.72).
city('Rio das Ostras','br','Rio de Janeiro',46619.0,-41.95,-22.53).
city('Rio de Janeiro','br','Rio de Janeiro',6023742.0,-43.2,-22.91).
city('Santo Antonio de Padua','br','Rio de Janeiro',33076.0,-42.19,-21.56).
city('Sao Fidelis','br','Rio de Janeiro',27793.0,-41.74,-21.65).
city('Sao Goncalo','br','Rio de Janeiro',939101.0,-43.07,-22.84).
city('Sao Joao da Barra','br','Rio de Janeiro',20606.0,-41.05,-21.64).
city('Sao Joao de Meriti','br','Rio de Janeiro',454855.0,-43.35,-22.8).
city('Sao Jose do Valle do Rio Preto','br','Rio de Janeiro',11886.0,42.95,-22.17).
city('Sao Pedro da Aldeia','br','Rio de Janeiro',55014.0,-42.11,-22.83).
city('Sapucaia','br','Rio de Janeiro',12329.0,-42.92,-22.01).
city('Saquarema','br','Rio de Janeiro',62057.0,-42.53,-22.93).
city('Seropedica','br','Rio de Janeiro',54846.0,-43.72,-22.75).
city('Silva Jardim','br','Rio de Janeiro',16889.0,-42.41,-22.65).
city('Tangua','br','Rio de Janeiro',23740.0,-42.72,-22.73).
city('Teresopolis','br','Rio de Janeiro',123980.0,-42.98,-22.41).
city('Tres Rios','br','Rio de Janeiro',71945.0,-43.21,-22.11).
city('Valenca','br','Rio de Janeiro',61145.0,-43.71,-22.25).
city('Vassouras','br','Rio de Janeiro',21175.0,-43.67,-22.4).
city('Volta Redonda','br','Rio de Janeiro',249584.0,-44.12,-22.51).
city('Alta Floresta dOeste','br','Rondonia',12488.0,-61.38,-11.74).
city('Alto Paraiso','br','Rondonia',3009.0,-63.31,-9.85).
city('Ariquemes','br','Rondonia',58102.0,-63.08,-9.94).
city('Cacoal','br','Rondonia',55566.0,-61.42,-11.5).
city('Candeias do Jamari','br','Rondonia',13075.0,-63.79,-8.79).
city('Espigao dOeste','br','Rondonia',14458.0,-60.99,-11.58).
city('Guajara-Mirim','br','Rondonia',34123.0,-65.37,-10.8).
city('Jaru','br','Rondonia',28018.0,-62.45,-10.43).
city('Ji-Parana','br','Rondonia',100128.0,-61.95,-10.9).
city('Machadinho dOeste','br','Rondonia',16929.0,-62.16,-9.57).
city('Ouro Preto do Oeste','br','Rondonia',26686.0,-62.31,-10.66).
city('Pimenta Bueno','br','Rondonia',25785.0,-61.21,-11.64).
city('Porto Velho','br','Rondonia',306206.0,-63.91,-8.76).
city('Presidente Medici','br','Rondonia',11923.0,-61.92,-11.27).
city('Rolim de Moura','br','Rondonia',37953.0,-62.3,-13.07).
city('Vilhena','br','Rondonia',63237.0,-60.11,-12.7).
city('Alto Alegre','br','Roraima',6283.0,-61.47,2.9).
city('Boa Vista','br','Roraima',235159.0,-60.66,2.83).
city('Bonfim','br','Roraima',5769.0,-59.85,3.34).
city('Caracarai','br','Roraima',14795.0,-61.14,-1.82).
city('Mucajai','br','Roraima',7026.0,-60.95,2.45).
city('Araquari','br','Santa Catarina',35691.0,-48.62,-26.38).
city('Ararangua','br','Santa Catarina',43445.0,-49.5,-28.94).
city('Balneario Camboriu','br','Santa Catarina',94797.0,-48.63,-26.98).
city('Barra Velha','br','Santa Catarina',17665.0,-48.72,-26.65).
city('Biguacu','br','Santa Catarina',51993.0,-48.66,-27.5).
city('Blumenau','br','Santa Catarina',293955.0,-49.09,-26.92).
city('Braco do Norte','br','Santa Catarina',22375.0,-49.18,-28.28).
city('Brusque','br','Santa Catarina',88286.0,-48.93,-27.13).
city('Cacador','br','Santa Catarina',63727.0,-51.02,-26.77).
city('Camboriu','br','Santa Catarina',49101.0,-48.65,-26.99).
city('Campos Novos','br','Santa Catarina',22563.0,-51.24,-27.39).
city('Canoinhas','br','Santa Catarina',38863.0,-50.4,-26.18).
city('Capinzal','br','Santa Catarina',23799.0,-51.63,-27.33).
city('Chapeco','br','Santa Catarina',160160.0,-52.64,-27.1).
city('Cocal do Sul','br','Santa Catarina',13303.0,-49.34,-28.6).
city('Concordia','br','Santa Catarina',55368.0,-52.03,-27.23).
city('Correia Pinto','br','Santa Catarina',13752.0,-50.37,-27.59).
city('Criciuma','br','Santa Catarina',161957.0,-49.39,-28.68).
city('Curitibanos','br','Santa Catarina',32142.0,-50.58,-27.29).
city('Florianopolis','br','Santa Catarina',412731.0,-48.54,-27.6).
city('Forquilhinha','br','Santa Catarina',23021.0,-49.46,-28.74).
city('Garopaba','br','Santa Catarina',18702.0,48.61,-28.03).
city('Gaspar','br','Santa Catarina',33659.0,-48.96,-26.94).
city('Governador Celso Ramos','br','Santa Catarina',15164.0,-51.39,-27.61).
city('Guaramirim','br','Santa Catarina',21422.0,-49.0,-26.45).
city('Herval dOeste','br','Santa Catarina',18063.0,-53.4,-32.03).
city('Ibirama','br','Santa Catarina',18360.0,-49.52,-27.06).
city('Icara','br','Santa Catarina',51455.0,-49.3,-28.7).
city('Imbituba','br','Santa Catarina',43450.0,-48.66,-28.23).
city('Indaial','br','Santa Catarina',44360.0,-49.26,-26.91).
city('Itajai','br','Santa Catarina',155719.0,-48.68,-26.9).
city('Itapema','br','Santa Catarina',36766.0,-48.62,-27.1).
city('Ituporanga','br','Santa Catarina',13038.0,-49.61,-27.37).
city('Jaguaruna','br','Santa Catarina',11650.0,-49.03,-28.62).
city('Jaragua do Sul','br','Santa Catarina',130132.0,-49.1,-26.48).
city('Joacaba','br','Santa Catarina',23516.0,-51.5,-27.17).
city('Joinville','br','Santa Catarina',461312.0,-48.84,-26.32).
city('Lages','br','Santa Catarina',164679.0,-50.31,-27.81).
city('Laguna','br','Santa Catarina',39712.0,-48.78,-28.48).
city('Lauro Muller','br','Santa Catarina',10036.0,-49.4,-28.37).
city('Mafra','br','Santa Catarina',40081.0,-49.81,-26.11).
city('Maravilha','br','Santa Catarina',13865.0,-53.07,-26.78).
city('Morro da Fumaca','br','Santa Catarina',13952.0,-49.2,-28.67).
city('Navegantes','br','Santa Catarina',47782.0,-48.65,-26.9).
city('Orleans','br','Santa Catarina',16422.0,-49.3,-28.35).
city('Otacilio Costa','br','Santa Catarina',14557.0,-50.12,-27.57).
city('Palhoca','br','Santa Catarina',122425.0,-48.68,-27.64).
city('Penha','br','Santa Catarina',20097.0,-48.67,-26.77).
city('Pomerode','br','Santa Catarina',21898.0,-49.18,-26.75).
city('Porto Belo','br','Santa Catarina',14722.0,-48.53,-27.15).
city('Porto Uniao','br','Santa Catarina',28907.0,-51.08,-26.24).
city('Rio Negrinho','br','Santa Catarina',41915.0,-49.53,-26.25).
city('Rio do Sul','br','Santa Catarina',51945.0,-49.65,-27.21).
city('Santa Cecilia','br','Santa Catarina',15092.0,-50.42,-26.96).
city('Santo Amaro da Imperatriz','br','Santa Catarina',18420.0,-48.76,-27.67).
city('Sao Bento do Sul','br','Santa Catarina',77598.0,-49.42,-26.22).
city('Sao Francisco do Sul','br','Santa Catarina',36225.0,-48.64,-26.25).
city('Sao Joao Batista','br','Santa Catarina',14539.0,-48.82,-27.26).
city('Sao Joaquim','br','Santa Catarina',16250.0,-49.95,-28.29).
city('Sao Jose','br','Santa Catarina',203142.0,-48.62,-27.59).
city('Sao Lourenco do Oeste','br','Santa Catarina',14872.0,-52.77,-26.4).
city('Sao Miguel do Oeste','br','Santa Catarina',27360.0,-53.51,-26.72).
city('Schroeder','br','Santa Catarina',15515.0,-49.06,-26.42).
city('Seara','br','Santa Catarina',10976.0,-52.32,-27.15).
city('Sideropolis','br','Santa Catarina',8536.0,-49.43,-28.6).
city('Sombrio','br','Santa Catarina',14864.0,-49.63,-29.11).
city('Tijucas','br','Santa Catarina',22482.0,-48.61,-27.21).
city('Timbo','br','Santa Catarina',33766.0,-49.28,-26.85).
city('Tres Barras','br','Santa Catarina',14855.0,-50.32,-26.11).
city('Tubarao','br','Santa Catarina',67246.0,-49.02,-28.48).
city('Urussanga','br','Santa Catarina',10670.0,-49.34,-28.53).
city('Videira','br','Santa Catarina',42441.0,-51.15,-27.01).
city('Xanxere','br','Santa Catarina',32958.0,-52.39,-26.88).
city('Xaxim','br','Santa Catarina',21376.0,-52.55,-26.97).
city('Adamantina','br','Sao Paulo',31079.0,-51.08,-21.68).
city('Aguai','br','Sao Paulo',27503.0,-46.98,-22.06).
city('Aguas de Lindoia','br','Sao Paulo',18806.0,-46.65,-22.48).
city('Agudos','br','Sao Paulo',30808.0,-49.0,-22.47).
city('Altinopolis','br','Sao Paulo',14616.0,-47.38,-21.02).
city('Alvares Machado','br','Sao Paulo',21642.0,-51.5,-22.13).
city('Americana','br','Sao Paulo',196026.0,-47.33,-22.75).
city('Americo Brasiliense','br','Sao Paulo',34332.0,-48.12,-21.72).
city('Amparo','br','Sao Paulo',41498.0,-46.77,-22.71).
city('Andradina','br','Sao Paulo',52407.0,-51.38,-20.91).
city('Angatuba','br','Sao Paulo',14476.0,-48.42,-23.49).
city('Aparecida','br','Sao Paulo',34237.0,-45.23,-22.83).
city('Apiai','br','Sao Paulo',18260.0,-48.84,-24.51).
city('Aracatuba','br','Sao Paulo',170028.0,-50.45,-21.21).
city('Aracoiaba da Serra','br','Sao Paulo',15395.0,-47.62,-23.5).
city('Araraquara','br','Sao Paulo',185191.0,-48.13,-21.75).
city('Araras','br','Sao Paulo',107465.0,-47.39,-22.36).
city('Artur Nogueira','br','Sao Paulo',40404.0,-47.15,-22.58).
city('Aruja','br','Sao Paulo',72078.0,-46.34,-23.4).
city('Assis','br','Sao Paulo',87473.0,-50.42,-22.66).
city('Atibaia','br','Sao Paulo',110970.0,-46.57,-23.12).
city('Auriflama','br','Sao Paulo',11971.0,-50.55,-20.69).
city('Avare','br','Sao Paulo',81287.0,-48.93,-23.11).
city('Bady Bassitt','br','Sao Paulo',14216.0,-49.46,-20.92).
city('Bariri','br','Sao Paulo',28802.0,-48.74,-22.07).
city('Barra Bonita','br','Sao Paulo',37247.0,-48.54,-22.48).
city('Barretos','br','Sao Paulo',101222.0,-48.58,-20.55).
city('Barrinha','br','Sao Paulo',26981.0,-48.15,-21.2).
city('Barueri','br','Sao Paulo',251999.0,-46.86,-23.49).
city('Bastos','br','Sao Paulo',17681.0,-50.74,-21.91).
city('Batatais','br','Sao Paulo',51977.0,-47.59,-20.8).
city('Bauru','br','Sao Paulo',335031.0,-49.08,-22.33).
city('Bebedouro','br','Sao Paulo',71863.0,-48.49,-20.95).
city('Bernardino de Campos','br','Sao Paulo',9342.0,-49.49,-23.03).
city('Birigui','br','Sao Paulo',102279.0,-50.34,-21.29).
city('Biritiba-Mirim','br','Sao Paulo',26459.0,-46.03,-23.58).
city('Boa Esperanca do Sul','br','Sao Paulo',10787.0,-48.39,-21.98).
city('Boituva','br','Sao Paulo',48756.0,-47.69,-23.28).
city('Bom Jesus dos Perdoes','br','Sao Paulo',12422.0,-46.47,-23.13).
city('Borborema','br','Sao Paulo',11759.0,-49.07,-21.62).
city('Botucatu','br','Sao Paulo',113865.0,-48.45,-22.88).
city('Braganca Paulista','br','Sao Paulo',125099.0,-46.55,-22.95).
city('Brodowski','br','Sao Paulo',18366.0,-47.67,-20.98).
city('Brotas','br','Sao Paulo',18690.0,-48.12,-22.28).
city('Buri','br','Sao Paulo',15959.0,-48.59,-23.8).
city('Buritama','br','Sao Paulo',12712.0,-50.16,-21.07).
city('Cabreuva','br','Sao Paulo',38743.0,-47.14,-23.3).
city('Cacapava','br','Sao Paulo',72341.0,-45.71,-23.1).
city('Caconde','br','Sao Paulo',12434.0,-46.63,-21.55).
city('Cafelandia','br','Sao Paulo',13777.0,-49.59,-21.82).
city('Caieiras','br','Sao Paulo',87199.0,-46.74,-23.36).
city('Cajamar','br','Sao Paulo',56684.0,-46.89,-23.35).
city('Cajati','br','Sao Paulo',27566.0,-48.12,-24.71).
city('Cajuru','br','Sao Paulo',19540.0,-47.31,-21.26).
city('Campinas','br','Sao Paulo',1031573.0,-47.08,-22.91).
city('Campo Limpo Paulista','br','Sao Paulo',76913.0,-46.8,-23.2).
city('Campos do Jordao','br','Sao Paulo',53320.0,-45.59,-22.73).
city('Cananeia','br','Sao Paulo',13786.0,-47.94,-25.01).
city('Candido Mota','br','Sao',28145.0,-50.38,-22.71).
city('Capao Bonito','br','Sao Paulo',37207.0,-48.35,-24.03).
city('Capela do Alto','br','Sao Paulo',11991.0,-47.75,-23.47).
city('Capivari','br','Sao Paulo',35519.0,-47.52,-23.01).
city('Caraguatatuba','br','Sao Paulo',90844.0,-45.43,-23.62).
city('Carapicuiba','br','Sao Paulo',361120.0,-46.84,-23.52).
city('Cardoso','br','Sao Paulo',10556.0,-49.91,-20.07).
city('Casa Branca','br','Sao Paulo',22498.0,-47.08,-21.78).
city('Castilho','br','Sao Paulo',11419.0,-51.5,-20.88).
city('Catanduva','br','Sao Paulo',10.0,-48.98,-21.14).
city('Cerqueira Cesar','br','Sao Paulo',14261.0,-49.17,-23.05).
city('Cerquilho','br','Sao Paulo',35367.0,-47.75,-23.15).
city('Charqueada','br','Sao Paulo',12391.0,-47.77,-22.5).
city('Chavantes','br','Sao Paulo',10306.0,-49.72,-23.03).
city('Colina','br','Sao Paulo',15042.0,-48.55,-20.72).
city('Conchal','br','Sao Paulo',21351.0,-47.17,-22.33).
city('Conchas','br','Sao Paulo',14301.0,-48.0,-23.02).
city('Cordeiropolis','br','Sao Paulo',25639.0,-47.46,-22.48).
city('Cosmopolis','br','Sao Paulo',47773.0,-47.2,-22.63).
city('Cotia','br','Sao Paulo',174832.0,-46.94,-23.6).
city('Cravinhos','br','Sao Paulo',32690.0,-47.75,-21.32).
city('Cruzeiro','br','Sao Paulo',72023.0,-44.97,-22.57).
city('Cubatao','br','Sao Paulo',118412.0,-46.42,-23.89).
city('Cunha','br','Sao Paulo',11896.0,-44.96,-23.08).
city('Descalvado','br','Sao Paulo',26138.0,-47.62,-21.9).
city('Diadema','br','Sao Paulo',390641.0,-46.61,-23.69).
city('Dois Corregos','br','Sao Paulo',20975.0,-48.35,-22.36).
city('Dracena','br','Sao Paulo',37940.0,-51.54,-21.48).
city('Duartina','br','Sao Paulo',11903.0,-49.42,-22.4).
city('Elias Fausto','br','Sao Paulo',12705.0,-47.37,-23.02).
city('Embu','br','Sao Paulo',221737.0,-46.84,-23.64).
city('Embu-Guacu','br','Sao Paulo',76311.0,-46.8,-23.82).
city('Espirito Santo do Pinhal','br','Sao Paulo',37449.0,-46.75,-22.2).
city('Fartura','br','Sao Paulo',12405.0,-49.5,-23.38).
city('Fernandopolis','br','Sao Paulo',61932.0,-50.26,-20.27).
city('Ferraz de Vasconcelos','br','Sao Paulo',167904.0,-46.37,-23.54).
city('Florida Paulista','br','Sao Paulo',8865.0,-51.17,-21.61).
city('Franca','br','Sao Paulo',305047.0,-47.39,-20.53).
city('Francisco Morato','br','Sao Paulo',171793.0,-46.75,-23.27).
city('Franco da Rocha','br','Sao Paulo',108860.0,-46.72,-23.33).
city('Garca','br','Sao Paulo',41303.0,-49.66,-22.22).
city('General Salgado','br','Sao Paulo',8084.0,-50.37,-20.65).
city('Guaira','br','Sao Paulo',34093.0,-48.32,-20.33).
city('Guapiacu','br','Sao Paulo',14065.0,-49.22,-20.83).
city('Guara','br','Sao Paulo',18263.0,-47.84,-20.43).
city('Guararapes','br','Sao Paulo',27558.0,-50.65,-21.25).
city('Guararema','br','Sao Paulo',23572.0,-46.04,-23.42).
city('Guaratingueta','br','Sao Paulo',105882.0,-45.19,-22.82).
city('Guariba','br','Sao Paulo',30464.0,-48.24,-21.35).
city('Guaruja','br','Sao Paulo',310430.0,-46.27,-24.0).
city('Guarulhos','br','Sao Paulo',1169601.0,-46.49,-23.46).
city('Hortolandia','br','Sao Paulo',203537.0,-47.26,-22.85).
city('Ibate','br','Sao Paulo',29550.0,-48.0,-21.95).
city('Ibitinga','br','Sao Paulo',49075.0,-48.83,-21.76).
city('Ibiuna','br','Sao Paulo',22860.0,-47.22,-23.65).
city('Igaracu do Tiete','br','Sao Paulo',22758.0,-48.57,-22.52).
city('Igarapava','br','Sao Paulo',29058.0,-47.79,-20.05).
city('Iguape','br','Sao Paulo',23785.0,-47.57,-24.72).
city('Ilha Soltera','br','Sao Paulo',24997.0,-51.34,-20.38).
city('Ilhabela','br','Sao Paulo',32903.0,-45.34,-23.78).
city('Indaiatuba','br','Sao Paulo',179914.0,-47.21,-23.09).
city('Ipaussu','br','Sao Paulo',10833.0,-49.62,-23.05).
city('Ipero','br','Sao Paulo',17161.0,-47.69,-23.35).
city('Ipua','br','Sao Paulo',12370.0,-48.04,-20.45).
city('Iracemapolis','br','Sao Paulo',16796.0,-47.54,-22.58).
city('Itabera','br','Sao Paulo',11098.0,-49.15,-23.85).
city('Itai','br','Sao Paulo',22305.0,-49.1,-23.4).
city('Itajobi','br','Sao Paulo',12231.0,-49.07,-21.32).
city('Itanhaem','br','Sao Paulo',90387.0,-46.8,-24.18).
city('Itapecerica da Serra','br','Sao Paulo',151608.0,-46.83,-23.72).
city('Itapetininga','br','Sao Paulo',126245.0,-48.04,-23.59).
city('Itapeva','br','Sao Paulo',62958.0,-48.88,-23.98).
city('Itapevi','br','Sao Paulo',201752.0,-46.94,-23.55).
city('Itapira','br','Sao Paulo',61608.0,-46.83,-22.43).
city('Itapolis','br','Sao Paulo',34553.0,-48.77,-21.58).
city('Itaporanga','br','Sao Paulo',10202.0,-49.49,-23.71).
city('Itapui','br','Sao Paulo',10445.0,-48.67,-22.22).
city('Itaquaquecetuba','br','Sao Paulo',336686.0,-46.35,-23.47).
city('Itarare','br','Sao Paulo',44810.0,-49.36,-24.12).
city('Itatiba','br','Sao Paulo',67935.0,-46.84,-22.99).
city('Itatinga','br','Sao Paulo',15696.0,-48.6,-23.12).
city('Itirapina','br','Sao Paulo',13229.0,-47.83,-22.26).
city('Itu','br','Sao Paulo',137589.0,-47.3,-23.26).
city('Itupeva','br','Sao Paulo',25183.0,-40.48,-17.48).
city('Ituverava','br','Sao Paulo',36998.0,-47.79,-20.33).
city('Jaboticabal','br','Sao Paulo',69396.0,-48.33,-21.25).
city('Jacarei','br','Sao Paulo',213114.0,-45.96,-23.3).
city('Jacupiranga','br','Sao Paulo',11149.0,-48.02,-24.71).
city('Jaguariuna','br','Sao Paulo',31718.0,-46.99,-22.68).
city('Jales','br','Sao Paulo',43832.0,-50.55,-20.26).
city('Jandira','br','Sao Paulo',113607.0,-46.92,-23.54).
city('Jardinopolis','br','Sao Paulo',34719.0,-47.77,-21.03).
city('Jarinu','br','Sao Paulo',17905.0,-46.72,-23.09).
city('Jau','br','Sao Paulo',119209.0,-48.57,-22.29).
city('Joanopolis','br','Sao Paulo',11772.0,-46.29,-22.93).
city('Jose Bonifacio','br','Sao Paulo',27828.0,-49.69,-21.05).
city('Jundiai','br','Sao Paulo',321595.0,-46.88,-23.2).
city('Junqueiropolis','br','Sao Paulo',13965.0,-51.44,-21.51).
city('Juquia','br','Sao Paulo',13497.0,-47.63,-24.32).
city('Juquitiba','br','Sao Paulo',13961.0,-47.05,-23.95).
city('Laranjal Paulista','br','Sao Paulo',21264.0,-47.85,-23.07).
city('Leme','br','Sao Paulo',81211.0,-47.38,-22.18).
city('Lencois Paulista','br','Sao Paulo',57376.0,-48.8,-22.59).
city('Limeira','br','Sao Paulo',289671.0,-47.4,-22.55).
city('Lins','br','Sao Paulo',69452.0,-49.76,-21.67).
city('Lorena','br','Sao Paulo',76507.0,-45.11,-22.73).
city('Louveira','br','Sao Paulo',31098.0,-46.97,-23.07).
city('Lucelia','br','Sao Paulo',14807.0,-51.02,-21.72).
city('Macatuba','br','Sao Paulo',16180.0,-48.69,-22.52).
city('Mairinque','br','Sao Paulo',44457.0,-47.17,-23.55).
city('Mairipora','br','Sao Paulo',54417.0,-46.59,-23.32).
city('Maracai','br','Sao Paulo',11960.0,-50.65,-22.6).
city('Marilia','br','Sao Paulo',212222.0,-49.95,-22.21).
city('Martinopolis','br','Sao Paulo',18488.0,-51.2,-22.18).
city('Matao','br','Sao Paulo',72469.0,-48.37,-21.58).
city('Maua','br','Sao Paulo',386077.0,-46.46,-23.66).
city('Miguelopolis','br','Sao Paulo',18262.0,-48.05,-20.2).
city('Mineros do Tiete','br','Sao Paulo',11443.0,-48.44,-22.4).
city('Miracatu','br','Sao Paulo',11679.0,-47.47,-24.28).
city('Mirandopolis','br','Sao Paulo',23379.0,-51.11,-21.13).
city('Mirante','br','Sao Paulo',9387.0,-51.91,-22.3).
city('Mirassol','br','Sao Paulo',51559.0,-49.52,-20.82).
city('Mococa','br','Sao Paulo',59656.0,-47.01,-21.46).
city('Mogi Guacu','br','Sao Paulo',128868.0,-46.95,-22.37).
city('Moji das Cruzes','br','Sao Paulo',325753.0,-46.21,-23.52).
city('Moji-Mirim','br','Sao Paulo',78245.0,-46.96,-22.43).
city('Mongagua','br','Sao Paulo',45931.0,-46.64,-24.1).
city('Monte Alto','br','Sao Paulo',41894.0,-48.49,-21.28).
city('Monte Aprazivel','br','Sao Paulo',16308.0,-49.72,-20.78).
city('Monte Azul Paulista','br','Sao Paulo',18117.0,-48.64,-20.92).
city('Monte Mor','br','Sao Paulo',40291.0,-47.34,-22.94).
city('Morro Agudo','br','Sao Paulo',25266.0,-48.07,-20.73).
city('Nova Granada','br','Sao Paulo',15716.0,-49.32,-20.48).
city('Nova Odessa','br','Sao Paulo',49433.0,-47.3,-22.78).
city('Novo Horizonte','br','Sao Paulo',30159.0,-49.22,-21.46).
city('Olimpia','br','Sao Paulo',45200.0,-48.92,-20.73).
city('Orlandia','br','Sao Paulo',44767.0,-47.89,-20.71).
city('Osasco','br','Sao Paulo',677869.0,-46.78,-23.53).
city('Osvaldo Cruz','br','Sao',25747.0,-50.88,-21.79).
city('Ourinhos','br','Sao Paulo',97801.0,-49.87,-22.97).
city('Pacaembu','br','Sao Paulo',10101.0,-51.27,-21.56).
city('Palmital','br','Sao Paulo',18540.0,-50.22,-22.78).
city('Panorama','br','Sao Paulo',14227.0,-51.85,-21.36).
city('Paraguacu Paulista','br','Sao Paulo',39120.0,-50.58,-22.41).
city('Paranapanema','br','Sao Paulo',16218.0,-48.72,-23.38).
city('Pariquera-Acu','br','Sao Paulo',13436.0,-47.88,-24.71).
city('Paulinia','br','Sao Paulo',65596.0,-47.17,-22.75).
city('Pederneiras','br','Sao Paulo',38.0,-48.77,-22.38).
city('Pedregulho','br','Sao Paulo',11216.0,-47.49,-20.26).
city('Pedreira','br','Sao Paulo',39199.0,-46.92,-22.71).
city('Penapolis','br','Sao Paulo',54478.0,-50.08,-21.41).
city('Pereira Barreto','br','Sao Paulo',22537.0,-51.11,-20.63).
city('Peruibe','br','Sao Paulo',63032.0,-46.99,-24.3).
city('Piedade','br','Sao Paulo',27913.0,-47.42,-23.71).
city('Pilar do Sul','br','Sao Paulo',19107.0,-47.7,-23.81).
city('Pindamonhangaba','br','Sao Paulo',132220.0,-45.47,-22.92).
city('Pindorama','br','Sao Paulo',12248.0,-48.92,-21.2).
city('Piquete','br','Sao Paulo',13845.0,-45.19,-22.61).
city('Piracaia','br','Sao Paulo',26076.0,-46.36,-23.05).
city('Piracicaba','br','Sao Paulo',342216.0,-47.64,-22.71).
city('Piraju','br','Sao Paulo',25271.0,-49.39,-23.2).
city('Pirajui','br','Sao Paulo',17503.0,-49.46,-22.0).
city('Pirapora do Bom Jesus','br','Sao Paulo',14690.0,-47.0,-23.4).
city('Pirapozinho','br','Sao Paulo',21711.0,-51.5,-22.26).
city('Pirassununga','br','Sao Paulo',60414.0,-47.43,-21.99).
city('Pitangueiras','br','Sao Paulo',28541.0,-48.22,-21.03).
city('Poa','br','Sao Paulo',107434.0,-46.35,-23.52).
city('Pompeia','br','Sao Paulo',18015.0,-50.18,-22.11).
city('Pontal','br','Sao Paulo',32567.0,-48.09,-21.05).
city('Porto Feliz','br','Sao Paulo',41016.0,-47.53,-23.2).
city('Porto Ferreira','br','Sao Paulo',49128.0,-47.48,-21.85).
city('Potirendaba','br','Sao Paulo',13865.0,-50.07,-21.84).
city('Pradopolis','br','Sao Paulo',13193.0,-48.07,-21.37).
city('Praia Grande','br','Sao Paulo',250032.0,-46.4,-24.0).
city('Presidente Bernardes','br','Sao Paulo',12954.0,-51.54,-22.04).
city('Presid','br','Sao Paulo',38742.0,-52.11,-21.76).
city('Presidente Prudente','br','Sao Paulo',209507.0,-51.39,-22.12).
city('Presidente Venceslau','br','Sao Paulo',34026.0,-51.84,-21.86).
city('Promissao','br','Sao Paulo',27032.0,-49.86,-21.53).
city('Quata','br','Sao Paulo',10370.0,-50.69,-22.25).
city('Rancharia','br','Sao Paulo',25531.0,-50.89,-22.23).
city('Regente Feijo','br','Sao Paulo',17219.0,-51.31,-22.22).
city('Registro','br','Sao Paulo',45698.0,-47.84,-24.49).
city('Ribeirao Bonito','br','Sao Paulo',10877.0,-48.17,-22.07).
city('Ribeirao Branco','br','Sao Paulo',9718.0,-48.77,-24.22).
city('Ribeirao Pires','br','Sao Paulo',111890.0,-46.41,-23.72).
city('Ribeirao Preto','br','Sao Paulo',551278.0,-47.8,-21.17).
city('Rio Claro','br','Sao Paulo',180151.0,-47.56,-22.41).
city('Rio Grande da Serra','br','Sao Paulo',38162.0,-46.34,-23.8).
city('Rio das Pedras','br','Sao Paulo',23722.0,-47.6,-22.83).
city('Salto','br','Sao Paulo',98389.0,-47.29,-23.19).
city('Salto de Pirapora','br','Sao Paulo',32228.0,-47.57,-23.6).
city('Santa Adelia','br','Sao Paulo',12585.0,-48.8,-21.27).
city('Santa Barbara dOeste','br','Sao Paulo',177382.0,-47.42,-22.75).
city('Santa Branca','br','Sao Paulo',8661.0,-45.89,-23.4).
city('Santa Cruz das Palmeiras','br','Sao Paulo',25801.0,-47.25,-21.82).
city('Santa Cruz do Rio Pardo','br','Sao Paulo',37336.0,-49.62,-22.92).
city('Santa Fe do Sul','br','Sao Paulo',25802.0,-50.94,-20.21).
city('Santa Gertrudes','br','Sao Paulo',18490.0,-47.52,-22.47).
city('Santa Isabel','br','Sao Paulo',33709.0,-46.23,-23.31).
city('Santa Rita do Passa Quatro','br','Sao Paulo',24579.0,-47.47,-21.7).
city('Santa Rosa de Viterbo','br','Sao Paulo',21473.0,-47.37,-21.48).
city('Santana de Parnaiba','br','Sao Paulo',98991.0,-46.92,-23.45).
city('Santo Anastacio','br','Sao Paulo',17233.0,-51.66,-21.98).
city('Santo Andre','br','Sao Paulo',662387.0,-46.53,-23.65).
city('Santo Antonio de Posse','br','Sao Paulo',18149.0,-46.92,-22.6).
city('Santos','br','Sao Paulo',411411.0,-46.33,-23.95).
city('Sao Bernardo do Campo','br','Sao Paulo',743386.0,-46.54,-23.71).
city('Sao Caetano do Sul','br','Sao Paulo',136456.0,-46.58,-23.58).
city('Sao Carlos','br','Sao Paulo',205039.0,-47.89,-22.02).
city('Sao Joao da Boa Vista','br','Sao Paulo',76541.0,-46.79,-21.98).
city('Sao Joaquim da Barra','br','Sao Paulo',42720.0,-47.86,-20.58).
city('Sao Jose do Rio Pardo','br','Sao Paulo',46990.0,-46.89,-21.59).
city('Sao Jose do Rio Preto','br','Sao Paulo',374706.0,-49.39,-20.8).
city('Sao Jose dos Campos','br','Sao Paulo',613776.0,-45.88,-23.2).
city('Sao Lourenco da Serra','br','Sao Paulo',13331.0,-46.94,-23.86).
city('Sao Manuel','br','Sao Paulo',33588.0,-48.57,-22.73).
city('Sao Miguel Arcanjo','br','Sao Paulo',19570.0,-47.73,-23.81).
city('Sao Paulo','br','Sao Paulo',1.0021437E7,-46.63,-23.53).
city('Sao Pedro','br','Sao Paulo',27068.0,-47.9,-22.56).
city('Sao Roque','br','Sao Paulo',50541.0,-47.14,-23.53).
city('Sao Sebastiao','br','Sao Paulo',76369.0,-45.41,-23.79).
city('Sao Simao','br','Sao Paulo',12351.0,-47.55,-21.48).
city('Sao Vicente','br','Sao Paulo',324464.0,-46.39,-23.96).
city('Serra Negra','br','Sao Paulo',22632.0,-46.7,-22.6).
city('Serrana','br','Sao Paulo',39826.0,-47.6,-21.23).
city('Sertaozinho','br','Sao Paulo',99213.0,-47.99,-21.14).
city('Severinia','br','Sao Paulo',13212.0,-48.8,-20.83).
city('Socorro','br','Sao Paulo',24272.0,-46.53,-22.6).
city('Soroc','br','Sao Paulo',558874.0,-47.47,-23.49).
city('Sumare','br','Sao Paulo',227982.0,-47.29,-22.8).
city('Suzano','br','Sao Paulo',283319.0,-46.31,-23.55).
city('Tabatinga','br','Sao Paulo',11617.0,-48.69,-21.72).
city('Taboao da Serra','br','Sao Paulo',214527.0,-46.78,-23.6).
city('Tambau','br','Sao Paulo',19957.0,-47.27,-21.7).
city('Tanabi','br','Sao Paulo',18228.0,-49.62,-20.62).
city('Taquaritinga','br','Sao Paulo',50099.0,-48.51,-21.41).
city('Taquarituba','br','Sao Paulo',21493.0,-49.25,-23.52).
city('Taruma','br','Sao Paulo',10337.0,-50.56,-22.74).
city('Tatui','br','Sao Paulo',93582.0,-47.86,-23.35).
city('Taubate','br','Sao Paulo',251647.0,-45.56,-23.02).
city('Teodoro Sampaio','br','Sao Paulo',15193.0,-52.17,-22.52).
city('Tiete','br','Sao Paulo',32062.0,-47.72,-23.12).
city('Tremembe','br','Sao Paulo',31720.0,-45.55,-22.97).
city('Tupa','br','Sao Paulo',62036.0,-50.52,-21.93).
city('Tupi Paulista','br','Sao Paulo',10877.0,-51.58,-21.39).
city('Ubatuba','br','Sao Paulo',79008.0,-45.08,-23.45).
city('Urupes','br','Sao Paulo',10745.0,-49.29,-21.21).
city('Valinhos','br','Sao Paulo',88631.0,-46.99,-22.97).
city('Valparaiso','br','Sao Paulo',15939.0,-50.87,-21.23).
city('Vargem Grande do Sul','br','Sao Paulo',36214.0,-46.89,-21.83).
city('Varzea Paulista','br','Sao Paulo',110938.0,-46.84,-23.2).
city('Vinhedo','br','Sao Paulo',56493.0,-46.99,-23.02).
city('Viradouro','br','Sao Paulo',17172.0,-48.3,-20.88).
city('Votorantim','br','Sao Paulo',99392.0,-47.43,-23.55).
city('Votuporonga','br','Sao Paulo',79576.0,-49.98,-20.43).
city('Aquidaba','br','Sergipe',10596.0,-37.02,-10.27).
city('Aracaju','br','Sergipe',490184.0,-37.07,-10.91).
city('Araua','br','Sergipe',4747.0,-37.63,-11.25).
city('Areia Branca','br','Sergipe',7414.0,-37.32,-10.77).
city('Barra dos Coqueiros','br','Sergipe',28590.0,-37.05,-10.9).
city('Boquim','br','Sergipe',14848.0,-37.62,-11.15).
city('Campo do Brito','br','Sergipe',8011.0,-37.5,-10.75).
city('Caninde de Sao Francisco','br','Sergipe',11053.0,-37.81,-9.66).
city('Capela','br','Sergipe',16024.0,-37.09,-10.5).
city('Carira','br','Sergipe',10276.0,-37.69,-10.34).
city('Cristinapolis','br','Sergipe',6430.0,-37.77,-11.48).
city('Estancia','br','Sergipe',55655.0,-37.45,-11.27).
city('Frei Paulo','br','Sergipe',7047.0,-37.54,-10.54).
city('Gararu','br','Sergipe',2977.0,-37.08,-9.98).
city('Indiaroba','br','Sergipe',4989.0,-37.52,-11.52).
city('Itabaiana','br','Sergipe',63889.0,-37.43,-10.68).
city('Itabaianinha','br','Sergipe',17149.0,-37.8,-11.27).
city('Itaporanga dAjuda','br','Sergipe',10183.0,-37.31,-10.98).
city('Japaratuba','br','Sergipe',8092.0,-36.94,-10.59).
city('Japoata','br','Sergipe',4207.0,-36.8,-10.33).
city('Lagarto','br','Sergipe',45446.0,-37.67,-10.9).
city('Laranjeiras','br','Sergipe',23251.0,-37.18,-10.79).
city('Malhador','br','Sergipe',5574.0,-37.31,-10.66).
city('Maruim','br','Sergipe',12153.0,-37.08,-10.74).
city('Moita Bonita','br','Sergipe',3602.0,-37.37,-10.58).
city('Monte Alegre de Sergipe','br','Sergipe',6816.0,-37.55,-10.02).
city('Neopolis','br','Sergipe',12422.0,-36.6,-10.32).
city('Nossa Senhora da Gloria','br','Sergipe',18613.0,-37.42,-10.21).
city('Nossa Senhora das Dores','br','Sergipe',14550.0,-37.22,-10.49).
city('Nossa Senhora do Socorro','br','Sergipe',163996.0,-37.12,-10.87).
city('Pacatuba','br','Sergipe',2616.0,-36.65,-10.43).
city('Poco Verde','br','Sergipe',12167.0,-38.19,-10.72).
city('Porto da Folha','br','Sergipe',9420.0,-37.28,-9.9).
city('Propria','br','Sergipe',23787.0,-36.85,-10.21).
city('Riachao do Dantas','br','Sergipe',4615.0,-37.73,-11.06).
city('Ribeiropolis','br','Sergipe',11215.0,-37.44,-10.54).
city('Salgado','br','Sergipe',5457.0,-37.48,-11.02).
city('Santa Luzia do Itanhy','br','Sergipe',2707.0,-37.46,-11.35).
city('Santo Amaro das Brotas','br','Sergipe',9302.0,-37.07,-10.78).
city('Sao Cristovao','br','Sergipe',71540.0,-37.21,-11.01).
city('Simao Dias','br','Sergipe',18386.0,-37.8,-10.73).
city('Tobias Barreto','br','Sergipe',29741.0,-38.02,-11.18).
city('Tomar do Geru','br','Sergipe',4394.0,-37.85,-11.37).
city('Umbauba','br','Sergipe',12880.0,-37.67,-11.36).
city('Alvorada','br','Tocantins',10232.0,-49.1,-12.47).
city('Ananas','br','Tocantins',8874.0,-48.1,-6.37).
city('Araguacu','br','Tocantins',7603.0,-49.86,-12.82).
city('Araguaina','br','Tocantins',114959.0,-48.21,-7.19).
city('Araguatins','br','Tocantins',17106.0,-48.13,-5.65).
city('Arraias','br','Tocantins',6881.0,-46.95,-12.92).
city('Axixa do Tocantins','br','Tocantins',9007.0,-47.75,-5.72).
city('Dianopolis','br','Tocantins',12896.0,-46.83,-11.63).
city('Formoso do Araguaia','br','Tocantins',14963.0,-49.54,-11.79).
city('Gurupi','br','Tocantins',64790.0,-49.06,-11.72).
city('Miracema do Tocantins','br','Tocantins',29181.0,-48.4,-9.55).
city('Miranorte','br','Tocantins',12446.0,-48.55,-9.48).
city('Palmas','br','Tocantins',196332.0,-48.31,-10.27).
city('Paraiso','br','Tocantins',38418.0,-48.77,-10.03).
city('Parana','br','Tocantins',2751.0,-47.86,-12.55).
city('Porto Nacional','br','Tocantins',40862.0,-48.42,-10.7).
city('Sitio Novo do Tocantins','br','Tocantins',5787.0,-47.54,-5.63).
city('Taguatinga','br','Tocantins',9330.0,-46.44,-12.41).
city('Tocantinopolis','br','Tocantins',23383.0,-47.42,-6.32).
city('Wanderlandia','br','Tocantins',6545.0,-47.88,-6.92).
city('Xambioa','br','Tocantins',9281.0,-48.67,-6.42).
city('Settlement','vg','Anegada',119.0,-64.32,18.73).
city('Little Harbour','vg','Jost van Dyke',84.0,-64.71,18.43).
city('Road Town','vg','Tortola',8449.0,-64.63,18.43).
city('Kuala Belait','bn','Belait',31178.0,114.18,4.59).
city('Seria','bn','Belait',30147.0,114.28,4.61).
city('Bandar Seri Begawan','bn','Brunei-Muara',64413.0,114.95,4.93).
city('Bangar','bn','Temburong',3536.0,115.08,4.71).
city('Tutong','bn','Tutong',19151.0,114.64,4.81).
city('Bansko','bg','Blagoevgrad',8412.0,23.5,41.84).
city('Belica','bg','Blagoevgr',3334.0,23.56,41.95).
city('Blagoevgrad','bg','Blagoevgrad',69547.0,23.09,42.03).
city('Goce Delcev','bg','Blagoevgrad',19301.0,23.74,41.58).
city('Hadzidimovo','bg','Blagoevgrad',2907.0,23.85,41.52).
city('Jakoruda','bg','Blagoevgrad',5931.0,23.69,42.02).
city('Kresna','bg','Blagoevgrad',3756.0,23.18,41.78).
city('Melnik','bg','Blagoevgrad',251.0,23.38,41.52).
city('Petric','bg','Blagoevgrad',29956.0,23.22,41.4).
city('Razlog','bg','Blagoevgrad',12347.0,23.48,41.89).
city('Sandanski','bg','Blagoevgrad',26282.0,23.29,41.56).
city('Simitli','bg','Blagoevgrad',7275.0,23.11,41.9).
city('Ahtopol','bg','Burgas',857.0,27.94,42.1).
city('Ajtos','bg','Burgas',21177.0,27.26,42.72).
city('Balgarovo','bg','Burgas',2344.0,27.3,42.62).
city('Burgas','bg','Burgas',188554.0,27.47,42.51).
city('Carevo','bg','Burgas',5023.0,27.93,42.12).
city('Kableskovo','bg','Burgas',2651.0,27.58,42.67).
city('Kameno','bg','Burgas',5133.0,27.3,42.58).
city('Karnobat','bg','Burgas',19902.0,26.99,42.66).
city('Malko Tarnovo','bg','Burgas',2920.0,27.53,41.98).
city('Nesebar','bg','Burgas',5864.0,27.72,42.67).
city('Obzor','bg','Burgas',1864.0,27.87,42.82).
city('Pomorie','bg','Burgas',12941.0,27.64,42.58).
city('Primorsko','bg','Burgas',1807.0,27.75,42.27).
city('Sozopol','bg','Burgas',3548.0,27.7,42.42).
city('Sredec','bg','Burgas',9362.0,27.19,42.35).
city('Sungurlare','bg','Burgas',3441.0,26.77,42.76).
city('Tvardica','bg','Burgas',6434.0,25.86,42.71).
city('Balcik','bg','Dobric',10718.0,28.17,43.41).
city('Dobric','bg','Dobric',92309.0,27.83,43.58).
city('General-Tosevo','bg','Dobric',7413.0,28.04,43.71).
city('Kavarna','bg','Dobric',10626.0,28.34,43.44).
city('Loznica','bg','Dobric',2512.0,27.91,43.95).
city('Sabla','bg','Dobric',3603.0,28.54,43.55).
city('Tervel','bg','Dobric',7019.0,27.42,43.75).
city('Drjanovo','bg','Gabrovo',8017.0,25.48,42.98).
city('Gabrovo','bg','Gabrovo',61109.0,25.31,42.9).
city('Plackovci','bg','Gabrovo',2098.0,25.47,42.83).
city('Sevlievo','bg','Gabrovo',23574.0,25.1,43.03).
city('Trjavna','bg','Gabrovo',10180.0,25.5,42.87).
city('Dimitrovgrad','bg','Haskovo',42827.0,25.61,42.06).
city('Harmanli','bg','Haskovo',20065.0,25.91,41.93).
city('Haskovo','bg','Haskovo',78865.0,25.56,41.94).
city('Ivajlovgrad','bg','Haskovo',4451.0,26.12,41.53).
city('Ljubimec','bg','Haskovo',7623.0,26.09,41.85).
city('Madzarovo','bg','Haskovo',1050.0,25.88,41.64).
city('Mericleri','bg','Haskovo',2233.0,25.5,42.13).
city('Simeonovgrad','bg','Haskovo',7509.0,25.84,42.04).
city('Svilengrad','bg','Haskovo',17378.0,26.2,41.78).
city('Boljarovo','bg','Jambol',1474.0,26.83,42.15).
city('Elhovo','bg','Jambol',11723.0,26.57,42.17).
city('Jambol','bg','Jambol',75290.0,26.52,42.5).
city('Straldza','bg','Jambol',5865.0,26.69,42.61).
city('Topolovgrad','bg','Jambol',5824.0,26.33,42.09).
city('Ardino','bg','Kardzali',3497.0,25.14,41.59).
city('Dzebel','bg','Kardzali',2309.0,25.29,41.46).
city('Kardzali','bg','Kardzali',44097.0,25.37,41.65).
city('Krumovgrad','bg','Kardzali',4478.0,25.67,41.48).
city('Momcilgrad','bg','Kardzali',6974.0,25.42,41.54).
city('Bobosevo','bg','Kjustendil',1528.0,22.99,42.18).
city('Bobovdol','bg','Kjustendil',7222.0,23.01,42.38).
city('Dupnica','bg','Kjustendil',38656.0,23.12,42.27).
city('Kjustendil','bg','Kjustendil',47315.0,22.69,42.3).
city('Kocerinovo','bg','Kjustendil',2431.0,23.07,42.09).
city('Rila','bg','Kjustendil',2936.0,23.12,42.12).
city('Sapareva Banja','bg','Kjustendil',4150.0,23.3,42.2).
city('Zemen','bg','Kjustendil',2145.0,22.76,42.47).
city('Aprilci','bg','Lovec',3218.0,24.92,42.84).
city('Jablanica','bg','Lovec',2662.0,24.06,42.97).
city('Letnica','bg','Lovec',3980.0,25.05,43.3).
city('Lovec','bg','Lovec',39788.0,24.72,43.15).
city('Lukovit','bg','Lovec',9020.0,24.16,43.22).
city('Sopot','bg','Lovec',10141.0,24.42,43.04).
city('Teteven','bg','Lovec',10697.0,24.28,42.93).
city('Trojan','bg','Lovec',22431.0,24.72,42.9).
city('Ugarcin','bg','Lovec',2896.0,24.42,43.1).
city('Be','bg','Montana',13574.0,23.14,43.24).
city('Bojcinovci','bg','Montana',1950.0,23.33,43.47).
city('Brusarci','bg','Montana',1391.0,23.08,43.66).
city('Ciprovci','bg','Montana',2277.0,22.88,43.39).
city('Lom','bg','Montana',24906.0,23.25,43.83).
city('Montana','bg','Montana',44982.0,23.23,43.42).
city('Valcedram','bg','Montana',4387.0,23.45,43.69).
city('Varsec','bg','Montana',6279.0,23.28,43.2).
city('Batak','bg','Pazardzik',4103.0,24.22,41.95).
city('Belovo','bg','Pazardzik',4533.0,24.02,42.2).
city('Bracigovo','bg','Pazardzik',4600.0,24.37,42.02).
city('Koprivstica','bg','Pazardzik',2618.0,24.35,42.64).
city('Panagjuriste','bg','Pazardzik',18755.0,24.18,42.51).
city('Pazardzik','bg','Pazardzik',76254.0,24.33,42.2).
city('Pestera','bg','Pazardzik',19161.0,24.31,42.04).
city('Rakitovo','bg','Pazardzik',8029.0,24.1,42.0).
city('Septemvri','bg','Pazardzik',8741.0,24.13,42.22).
city('Strelca','bg','Pazardzik',4699.0,24.32,42.51).
city('Velingrad','bg','Pazardzik',24129.0,24.0,42.03).
city('Bankja','bg','Pernik',8104.0,23.14,42.71).
city('Batanovci','bg','Pernik',2532.0,22.98,42.6).
city('Breznik','bg','Pernik',4150.0,22.92,42.75).
city('Pernik','bg','Pernik',82185.0,23.03,42.61).
city('Radomir','bg','Pernik',14971.0,22.97,42.56).
city('Tran','bg','Pernik',2608.0,22.65,42.83).
city('Belene','bg','Pleven',10401.0,25.14,43.65).
city('Cerven Brjag','bg','Pleven',17478.0,24.13,43.28).
city('Dolna Mitropolija','bg','Pleven',3746.0,24.52,43.47).
city('Dolni Dabnik','bg','Pleven',5561.0,24.44,43.4).
city('Guljanci','bg','Pleven',4135.0,24.7,43.65).
city('Levski','bg','Pleven',13203.0,25.15,43.37).
city('Nikopol','bg','Pleven',4884.0,24.9,43.7).
city('Pleven','bg','Pleven',132542.0,24.62,43.42).
city('Pordim','bg','Pleven',2711.0,24.85,43.38).
city('Slavjanovo','bg','Pleven',5160.0,24.88,43.47).
city('Trastenik','bg','Pleven',5627.0,24.48,43.52).
city('Varbica','bg','Pleven',3644.0,24.7,43.47).
city('Asenovgrad','bg','Plovdiv',50735.0,24.88,42.02).
city('Brezovo','bg','Plovdiv',1920.0,25.08,42.36).
city('Car Kalojan','bg','Plovdiv',4425.0,24.7,42.02).
city('Hisarja','bg','Plovdiv',8420.0,24.71,42.51).
city('Kalofer','bg','Plovdiv',3736.0,24.98,42.62).
city('Karlovo','bg','Plovdiv',24464.0,24.81,42.66).
city('Klisura','bg','Plovdiv',1708.0,24.45,42.7).
city('Kricim','bg','Plovdiv',8478.0,24.47,42.05).
city('Parvomaj','bg','Plovdiv',15472.0,25.22,42.1).
city('Perustica','bg','Plovdiv',5248.0,24.55,42.06).
city('Plovdiv','bg','Plovdiv',332088.0,24.75,42.15).
city('Rakovski','bg','Plovdiv',16009.0,24.97,42.29).
city('Sadovo','bg','Plovdiv',2461.0,24.95,42.14).
city('Saedinenie','bg','Plovdiv',6363.0,24.55,42.27).
city('Stambolijski','bg','Plovdiv',12406.0,24.55,42.14).
city('Isperih','bg','Razgrad',8276.0,26.83,43.72).
city('Kubrat','bg','Razgrad',7327.0,26.51,43.8).
city('Razgrad','bg','Razgrad',31791.0,26.53,43.53).
city('Senovo','bg','Razgrad',1481.0,26.36,43.65).
city('Zavet','bg','Razgrad',2979.0,26.68,43.76).
city('Bjala','bg','Ruse',1753.0,25.74,43.47).
city('Borovo','bg','Ruse',2520.0,25.81,43.49).
city('Dve Mogili','bg','Ruse',4561.0,25.88,43.6).
city('Ruse','bg','Ruse',157519.0,25.98,43.85).
city('Vetovo','bg','Ruse',4835.0,26.27,43.71).
city('Alfatar','bg','Silistra',1941.0,27.3,43.96).
city('Dulovo','bg','Silistra',6463.0,27.14,43.83).
city('Glavinica','bg','Silistra',1919.0,26.87,43.9).
city('Silistra','bg','Silistra',38166.0,27.27,44.11).
city('Tutrakan','bg','Silistra',9472.0,26.62,44.06).
city('Kermen','bg','Sliven',2172.0,26.26,42.51).
city('Kotel','bg','Sliven',7117.0,26.45,42.9).
city('Nova Zagora','bg','Sliven',24034.0,26.02,42.5).
city('Sivacevo','bg','Sliven',3827.0,26.03,42.69).
city('Sliven','bg','Sliven',94252.0,26.32,42.68).
city('Cepelare','bg','Smoljan',5342.0,24.69,41.74).
city('Devin','bg','Smoljan',6766.0,24.4,41.73).
city('Dospat','bg','Smoljan',2391.0,24.17,41.66).
city('Laki','bg','Smoljan',2720.0,24.82,41.85).
city('Madan','bg','Smoljan',7179.0,24.95,41.5).
city('Nedelino','bg','Smoljan',4676.0,25.09,41.46).
city('Rudozem','bg','Smoljan',4041.0,24.86,41.5).
city('Smoljan','bg','Smoljan',31870.0,24.7,41.59).
city('Zlatograd','bg','Smoljan',7673.0,25.11,41.39).
city('Sofia','bg','Sofija grad',1062065.0,23.31,42.69).
city('Botevgrad','bg','Sofijska oblast',20497.0,23.78,42.92).
city('Bozuriste','bg','Sofijska oblast',3832.0,23.17,42.75).
city('Buhovo','bg','Sofijska oblast',3069.0,23.57,42.77).
city('Dolna Banja','bg','Sofijska ob',4471.0,23.71,42.32).
city('Dragoman','bg','Sofijska oblast',3196.0,22.93,42.93).
city('Elin Pelin','bg','Sofijska oblast',4699.0,23.6,42.67).
city('Etropole','bg','Sofijska oblast',11024.0,24.01,42.84).
city('Godec','bg','Sofijska oblast',4551.0,23.05,43.03).
city('Ihtiman','bg','Sofijska oblast',11554.0,23.83,42.45).
city('Kostenec','bg','Sofijska oblast',9660.0,23.87,42.31).
city('Kostinbrod','bg','Sofijska oblast',11239.0,23.22,42.82).
city('Novi Iskar','bg','Sofijska oblast',13194.0,23.33,42.81).
city('Pirdop','bg','Sofijska oblast',7923.0,24.19,42.71).
city('Pravec','bg','Sofijska oblast',5071.0,23.92,42.9).
city('Samokov','bg','Sofijska oblast',26582.0,23.57,42.35).
city('Slivnica','bg','Sofijska oblast',7821.0,23.05,42.86).
city('Svoge','bg','Sofijska oblast',7093.0,23.34,42.97).
city('Zlatica','bg','Sofijska oblast',4881.0,24.15,42.71).
city('Cirpan','bg','Stara Zagora',17622.0,25.33,42.2).
city('Galabovo','bg','Stara Zagora',9080.0,25.85,42.14).
city('Gurkovo','bg','Stara Zagora',2933.0,25.79,42.66).
city('Kazanlak','bg','Stara Zagora',50336.0,25.4,42.63).
city('Magliz','bg','Stara Zagora',3465.0,25.54,42.61).
city('Pavel Banja','bg','Stara Zagora',2800.0,25.2,42.59).
city('Radnevo','bg','Stara Zagora',13157.0,25.95,42.3).
city('Sipka','bg','Stara Zagora',1520.0,25.33,42.72).
city('Stara Zagora','bg','Stara Zagora',137760.0,25.63,42.42).
city('Kaolinovo','bg','Sumen',1489.0,27.1,43.62).
city('Kaspican','bg','Sumen',3211.0,27.16,43.32).
city('Novi Pazar','bg','Sumen',13017.0,27.2,43.35).
city('Pliska','bg','Sumen',1115.0,27.12,43.36).
city('Smjadovo','bg','Sumen',4262.0,27.02,43.07).
city('Sumen','bg','Sumen',85394.0,26.93,43.28).
city('Veliki Preslav','bg','Sumen',8669.0,26.82,43.16).
city('Antonovo','bg','Targoviste',1950.0,26.17,43.16).
city('Omurtag','bg','Targoviste',8858.0,26.43,43.11).
city('Opaka','bg','Targoviste',3353.0,26.18,43.45).
city('Popovo','bg','Targoviste',18836.0,26.23,43.36).
city('Targoviste','bg','Targoviste',42242.0,26.58,43.25).
city('Beloslav','bg','Varna',7817.0,27.71,43.18).
city('Bjala','bg','Varna',10284.0,27.88,42.88).
city('Dalgopol','bg','Varna',4911.0,27.35,43.06).
city('Devnja','bg','Varna',8442.0,27.6,43.23).
city('Iskar','bg','Varna',4109.0,27.48,43.39).
city('Provadija','bg','Varna',14253.0,27.45,43.18).
city('Suvorovo','bg','Varna',4514.0,27.6,43.34).
city('Valci Dol','bg','Varna',3403.0,27.55,43.41).
city('Varna','bg','Varna',307952.0,27.9,43.21).
city('Bjala Cerkva','bg','Veliko Tarnovo',2989.0,25.3,43.2).
city('Debelec','bg','Veliko Tarnovo',4396.0,25.63,43.04).
city('Dolna Orjahovica','bg','Veliko Tarnovo',3255.0,25.73,43.17).
city('Elena','bg','Veliko Tarnovo',6171.0,25.89,42.94).
city('Gorna Orjahovica','bg','Veliko Tarnovo',33317.0,25.7,43.13).
city('Kilifarevo','bg','Veliko Tarnovo',2484.0,25.63,42.98).
city('Ljaskovec','bg','Veliko Tarnovo',9000.0,25.73,43.11).
city('Nikolaevo','bg','Veliko Tarnovo',2834.0,25.98,43.32).
city('Pavlikeni','bg','Veliko Tarnovo',12129.0,25.31,43.24).
city('Polski Trambes','bg','Veliko Tarnovo',4815.0,25.63,43.37).
city('Strazica','bg','Veliko Tarnovo',5006.0,25.97,43.23).
city('Suhindol','bg','Veliko Tarnovo',2407.0,25.17,43.18).
city('Svistov','bg','Veliko Tarnovo',29762.0,25.35,43.62).
city('Veliko Tarnovo','bg','Veliko Tarnovo',64799.0,25.63,43.09).
city('Zlatarica','bg','Veliko Tarnovo',2847.0,25.9,43.05).
city('Belogradcik','bg','Vidin',4865.0,22.68,43.65).
city('Bregovo','bg','Vidin',2629.0,22.65,44.15).
city('Dimovo','bg','Vidin',1145.0,22.73,43.73).
city('Dolni Ciflik','bg','Vidin',5943.0,22.67,43.6).
city('Dunavci','bg','Vidin',2705.0,22.82,43.92).
city('Gramada','bg','Vidin',1812.0,22.66,43.84).
city('Kula','bg','Vidin',3393.0,22.53,43.9).
city('Vidin','bg','Vidin',50315.0,22.87,44.01).
city('Bjala Slatina','bg','Vraca',10174.0,23.96,43.48).
city('Kneza','bg','Vraca',9201.0,24.09,43.5).
city('Kojnare','bg','Vraca',3678.0,24.15,43.37).
city('Kozloduj','bg','Vraca',10602.0,23.73,43.79).
city('Krivodol','bg','Vraca',2646.0,23.48,43.37).
city('Mezdra','bg','Vraca',8667.0,23.72,43.15).
city('Mizija','bg','Vraca',2918.0,23.86,43.69).
city('Orjahovo','bg','Vraca',4464.0,23.97,43.74).
city('Roman','bg','Vraca',2329.0,23.9,43.19).
city('Vraca','bg','Vraca',48995.0,23.56,43.22).
city('Boromo','bf','Bale',13240.0,-2.93,11.75).
city('Kongoussi','bf','Bam',26338.0,-1.53,13.32).
city('Solenzo','bf','Banwa',10451.0,-4.09,12.18).
city('Kombissiri','bf','Bazega',19180.0,-1.34,12.07).
city('Diebougou','bf','Bougouriba',12814.0,-3.25,10.96).
city('Garango','bf','Boulgou',29076.0,-0.55,11.8).
city('Tenkodogo','bf','Boulgou',37123.0,-0.36,11.77).
city('Gouloure','bf','Boulkiemde',6719.0,-1.93,12.23).
city('Kokologo','bf','Boulkiemde',25958.0,-1.88,12.2).
city('Koudougou','bf','Boulkiemde',86965.0,-2.37,12.25).
city('Pitmoaga','bf','Boulkiemde',8041.0,-1.89,12.25).
city('Banfora','bf','Comoe',63883.0,-4.76,10.63).
city('Zorgo','bf','Ganzourgou',19789.0,-0.61,12.24).
city('Bogande','bf','Gnagna',9916.0,-0.14,12.97).
city('Fada Ngourma','bf','Gourma',34726.0,0.36,12.06).
city('Bobo Dioulasso','bf','Houet',370809.0,-4.29,11.18).
city('Dano','bf','Ioba',11224.0,-3.06,11.15).
city('Ouagadougou','bf','Kadiogo',1031330.0,-1.53,12.37).
city('Orodara','bf','Kenedougou',18635.0,-4.91,10.97).
city('Gayeri','bf','Komandjari',2004.0,0.49,12.63).
city('Pama','bf','Kompienga',14028.0,-0.72,11.24).
city('Nouna','bf','Kossi',21144.0,-3.87,12.73).
city('Ouargaye','bf','Koulpelogo',30726.0,0.02,11.54).
city('Koupela','bf','Kouritenga',19850.0,-0.36,12.18).
city('Bousse','bf','Kourweogo',11093.0,-3.41,13.1).
city('Sindou','bf','Leraba',3942.0,-5.17,10.66).
city('Titao','bf','Loroum',15872.0,-2.05,13.26).
city('Dedougou','bf','Mouhoun',47235.0,-3.47,12.46).
city('Po','bf','Nahouri',21003.0,-1.14,11.17).
city('Boulsa','bf','Namentenga',17623.0,-0.57,12.66).
city('Toma','bf','Nayala',9926.0,-4.43,12.65).
city('Batie','bf','Noumbiel',6525.0,-2.92,9.87).
city('Ziniare','bf','Oubritenga',12783.0,-1.3,12.58).
city('Gorom-Gorom','bf','Oudalan',6743.0,-0.23,14.44).
city('Yako','bf','Passore',23080.0,-2.27,12.96).
city('Gaoua','bf','Poni',7300.0,-3.18,10.33).
city('Reo','bf','Sanguie',24616.0,-2.47,12.32).
city('Kaya','bf','Sanmatenga',39130.0,-1.09,13.09).
city('Dori','bf','Seno',27554.0,-0.03,14.04).
city('Leo','bf','Sissili',21151.0,-2.1,11.1).
city('Djibo','bf','Soum',22821.0,-1.63,14.1).
city('Tougan','bf','Sourou',17702.0,-3.08,13.07).
city('Diapaga','bf','Tapoa',24302.0,1.79,12.08).
city('Hounde','bf','Tuy',23617.0,-3.52,11.49).
city('Sebba','bf','Yagha',4895.0,-1.0,13.43).
city('Ouahigouya','bf','Yatenga',61439.0,-2.42,13.57).
city('Sapouy','bf','Ziro',3862.0,-1.78,11.55).
city('Gourcy','bf','Zondoma',17982.0,-2.36,13.21).
city('Manga','bf','Zoundweogo',15269.0,-1.07,11.66).
city('Bogale','mm','Ayeyarwady',68947.0,95.4,16.29).
city('Henzada','mm','Ayeyarwady',134964.0,95.47,17.65).
city('Kyaiklat','mm','Ayeyarwady',52432.0,95.73,16.45).
city('Labutta','mm','Ayeyarwady',41769.0,94.7,16.16).
city('Maubin','mm','Ayeyarwady',51542.0,95.65,16.73).
city('Moulmeingyun','mm','Ayeyarwady',39115.0,95.26,16.38).
city('Myanaung','mm','Ayeyarwady',42252.0,95.32,18.28).
city('Pathein','mm','Ayeyarwady',237119.0,94.73,16.78).
city('Pyapon','mm','Ayeyarwady',65610.0,95.68,16.29).
city('Wakema','mm','Ayeyarwady',42705.0,95.18,16.61).
city('Yandoon','mm','Ayeyarwady',40092.0,95.64,17.04).
city('Ye','mm','Ayeyarwady',55682.0,97.86,15.25).
city('Bago','mm','Bago',244407.0,96.5,17.33).
city('Letpadan','mm','Bago',38936.0,95.74,17.78).
city('Nyaunglebin','mm','Bago',89638.0,96.72,17.96).
city('Paungde','mm','Bago',36971.0,95.5,18.48).
city('Pyay','mm','Bago',135325.0,95.21,18.82).
city('Pyu','mm','Bago',40386.0,96.44,18.48).
city('Thanatpin','mm','Bago',38059.0,96.59,17.29).
city('Tharrawaddy','mm','Bago',54393.0,95.79,17.65).
city('Toungoo','mm','Bago',106959.0,96.42,18.95).
city('Falam','mm','Chin',5404.0,93.68,22.91).
city('Banmo','mm','Kachin',47920.0,97.24,24.26).
city('Myitkyina','mm','Kachin',90905.0,97.38,25.38).
city('Loikaw','mm','Kayah',17293.0,97.2,19.67).
city('Allanmyo','mm','Magway',57904.0,95.23,19.38).
city('Chauk','mm','Magway',90882.0,94.82,20.9).
city('Magway','mm','Magway',96966.0,94.92,20.14).
city('Minbu','mm','Magway',57350.0,94.88,20.18).
city('Pakokku','mm','Magway',126954.0,95.09,21.33).
city('Taungdwingyi','mm','Magway',70103.0,95.54,20.01).
city('Thayetmyo','mm','Magway',98197.0,95.18,19.33).
city('Yenangyaung','mm','Magway',110567.0,94.87,20.46).
city('Kyaukse','mm','Mandalay',50486.0,96.13,21.62).
city('Mandalay','mm','Mandalay',1208227.0,96.09,21.98).
city('Maymyo','mm','Mandalay',117318.0,96.46,22.04).
city('Meiktila','mm','Mandalay',177464.0,95.85,20.88).
city('Mogok','mm','Mandalay',90854.0,96.51,22.93).
city('Myingyan','mm','Mandalay',141731.0,95.39,21.46).
city('Pyinmana','mm','Mandalay',97421.0,96.2,19.74).
city('Yamethin','mm','Mandalay',59874.0,96.14,20.43).
city('Kyaikkami','mm','Mon',48100.0,97.57,16.07).
city('Kyaikto','mm','Mon',48658.0,97.02,17.3).
city('Mart','mm','Mon',48629.0,97.6,16.53).
city('Mawlamyine','mm','Mon',438907.0,97.63,16.49).
city('Mudon','mm','Mon',89134.0,97.72,16.26).
city('Thaton','mm','Mon',123742.0,97.36,16.93).
city('Akyab','mm','Rakhine',177765.0,92.89,20.14).
city('Arakan','mm','Rakhine',59909.0,94.37,18.46).
city('Kanbe','mm','Rangoon',58146.0,96.02,16.7).
city('Kayan','mm','Rangoon',40322.0,96.56,16.9).
city('Rangoon','mm','Rangoon',4477782.0,96.15,16.79).
city('Syriam','mm','Rangoon',69448.0,96.24,16.77).
city('Thongwa','mm','Rangoon',52496.0,96.52,16.76).
city('Twante','mm','Rangoon',46516.0,95.93,16.72).
city('Kalay','mm','Sagaing',89682.0,97.9,16.1).
city('Katha','mm','Sagaing',38634.0,96.44,24.21).
city('Mawlaik','mm','Sagaing',44540.0,94.41,23.63).
city('Monywa','mm','Sagaing',182034.0,95.13,22.11).
city('Sagaing','mm','Sagaing',78749.0,95.96,21.86).
city('Shwebo','mm','Sagaing',88926.0,95.69,22.57).
city('Keng Tung','mm','Shan',69457.0,99.62,21.29).
city('Lashio','mm','Shan',131033.0,97.74,22.95).
city('Taunggyi','mm','Shan',160136.0,97.04,20.78).
city('Dawei','mm','Tanintharyi',136798.0,98.2,14.09).
city('Mergui','mm','Tanintharyi',173317.0,98.6,12.45).
city('Bubanza','bi','Bubanza',12728.0,29.39,-3.1).
city('Bujumbura','bi','Bujumbura',330539.0,29.35,-3.37).
city('Bururi','bi','Bururi',19740.0,29.61,-3.95).
city('Rumonge','bi','Bururi',6074.0,29.43,-3.98).
city('Cankuzo','bi','Cankuzo',6585.0,30.54,-3.21).
city('Cibitoke','bi','Cibitoke',14220.0,29.12,-2.9).
city('Gitega','bi','Gitega',23168.0,29.93,-3.43).
city('Mwaro','bi','Gitega',4924.0,29.7,-3.52).
city('Karuzi','bi','Karuzi',10705.0,30.17,-3.09).
city('Kayanza','bi','Kayanza',19443.0,29.62,-2.92).
city('Kirundo','bi','Kirundo',6084.0,30.1,-2.58).
city('Makamba','bi','Makamba',19642.0,29.8,-4.13).
city('Muramvya','bi','Muramvya',18039.0,29.61,-3.26).
city('Muyinga','bi','Muyinga',71095.0,30.32,-2.86).
city('Ngozi','bi','Ngozi',21506.0,29.82,-2.91).
city('Rutana','bi','Rutana',20894.0,29.99,-3.93).
city('Ruyigi','bi','Ruyigi',38459.0,30.24,-3.47).
city('Sisophon','kh','Banteay Mean Chey',23215.0,102.98,13.58).
city('Bat Dambang','kh','Bat Dambang',150463.0,103.21,13.11).
city('Kampong Cham','kh','Kampong Cham',61761.0,105.46,12.0).
city('Kampong Chhnang','kh','Kampong Chhnang',75304.0,104.66,12.26).
city('Kampong Spoeu','kh','Kampong Spoeu',33231.0,104.52,11.45).
city('Kampong Thum','kh','Kampong Thum',19955.0,104.89,12.72).
city('Kampot','kh','Kampot',22696.0,104.18,10.61).
city('Ta Khmau','kh','Kandal',52066.0,104.94,11.48).
city('Dong Tong','kh','Kaoh Kong',33134.0,102.98,11.62).
city('Kracheh','kh','Kracheh',19979.0,106.03,12.48).
city('Krong Kaeb','kh','Krong Kaeb',11658.0,104.32,10.49).
city('Krong Pailin','kh','Krong Pailin',17850.0,102.61,12.85).
city('Preah Sihanouk','kh','Krong Preah Sihanouk',157096.0,103.53,10.61).
city('Senmonorom','kh','Mondol Kiri',7944.0,107.19,12.45).
city('Phumd Samraong','kh','Otdar Mean Chey',27858.0,105.57,12.47).
city('Phnum Penh','kh','Phnum Penh',1573523.0,104.92,11.57).
city('Pousat','kh','Pousat',52486.0,103.92,12.53).
city('Tbeng Mean Chey','kh','Preah Vihear',24380.0,104.97,13.82).
city('Prey Veaeng','kh','Prey Veaeng',66551.0,105.33,11.49).
city('Banlung','kh','Rotanak Kiri',7461.0,106.79,13.99).
city('Lumphat','kh','Rotanak Kiri',19205.0,106.98,13.51).
city('Siem Reab','kh','Siem Reab',122733.0,103.86,13.37).
city('Stueng Traeng','kh','Stueng Traeng',27671.0,105.97,13.52).
city('Svay Rieng','kh','Svay Rieng',23956.0,105.8,11.08).
city('Phumd Takaev','kh','Takaev',44270.0,104.78,10.98).
city('Banyo','cm','Adamaoua',40936.0,11.81,6.75).
city('Meiganga','cm','Adamaoua',80355.0,14.29,6.52).
city('Ngaoundere','cm','Adamaoua',231376.0,13.58,7.32).
city('Tibati','cm','Adamaoua',35711.0,12.62,6.47).
city('Tignere','cm','Adamaoua',4353.0,12.65,7.37).
city('Akonolinga','cm','Centre',17181.0,12.25,3.77).
city('Bafia','cm','Centre',69511.0,11.23,4.75).
city('Eseka','cm','Centre',22221.0,10.77,3.65).
city('Mbalmayo','cm','Centre',80483.0,11.5,3.52).
city('Mfou','cm','Centre',10033.0,11.93,3.97).
city('Monatele','cm','Centre',11327.0,11.27,4.27).
city('Nanga Eboko','cm','Centre',29909.0,12.37,4.67).
city('Nkoteng','cm','Centre',50622.0,12.03,4.51).
city('Obala','cm','Centre',30012.0,11.53,4.17).
city('Ombessa','cm','Centre',1833.0,11.25,4.6).
city('Saa','cm','Centre',5727.0,11.45,4.37).
city('Yaounde','cm','Centre',1299446.0,11.52,3.87).
city('Abong Mbang','cm','Est',14661.0,13.17,3.99).
city('Batouri','cm','Est',43970.0,14.36,4.43).
city('Bertoua','cm','Est',218217.0,13.68,4.58).
city('Betare Oya','cm','Est',11866.0,14.08,5.6).
city('Doume','cm','Est',5609.0,13.45,4.25).
city('Garoua Boulai','cm','Est',46771.0,14.55,5.89).
city('Yokadouma','cm','Est',13287.0,15.05,3.51).
city('Bonaberi','cm','Littoral',8091.0,9.67,4.08).
city('Dibombari','cm','Littoral',4811.0,9.67,4.17).
city('Douala','cm','Littoral',1338144.0,9.71,4.06).
city('Edea','cm','Littoral',203170.0,10.12,3.8).
city('Loum','cm','Littoral',177448.0,9.73,4.72).
city('Manjo','cm','Littoral',37795.0,9.82,4.85).
city('Mbanga','cm','Littoral',42741.0,9.57,4.51).
city('Melong','cm','Littoral',37216.0,9.94,5.12).
city('Nkongsamba','cm','Littoral',117076.0,9.94,4.96).
city('Yabassi','cm','Littoral',7560.0,9.97,4.47).
city('Bogo','cm','Nord Extreme',16952.0,14.6,10.74).
city('Kaele','cm','Nord Extreme',25199.0,14.45,10.12).
city('Kousseri','cm','Nord Extreme',435986.0,15.03,12.08).
city('Maroua','cm','Nord Extreme',319974.0,14.33,10.58).
city('Mindif','cm','Nord Extreme',10538.0,14.43,10.4).
city('Mokolo','cm','Nord Extreme',275750.0,13.81,10.75).
city('Mora','cm','Nord Extreme',55488.0,14.14,11.04).
city('Yagoua','cm','Nord Extreme',80510.0,15.24,10.35).
city('Figuif','cm','Nord',11327.0,13.96,9.76).
city('Garoua','cm','Nord',436932.0,13.39,9.3).
city('Guider','cm','Nord',84928.0,13.94,9.93).
city('Lagdo','cm','Nord',24596.0,13.73,9.05).
city('Ndop','cm','Nord',47450.0,10.47,6.07).
city('Poli','cm','Nord',5727.0,13.24,8.47).
city('Rey Bouba','cm','Nord',11454.0,14.18,8.67).
city('Tchollire','cm','Nord',23267.0,14.17,8.4).
city('Bamenda','cm','Nordouest',393871.0,10.15,5.96).
city('Fundong','cm','Nordouest',43693.0,10.27,6.25).
city('Kumbo','cm','Nordouest',53970.0,10.68,6.22).
city('Mbengwi','cm','Nordouest',9785.0,10.0,6.02).
city('Mme','cm','Nordouest',6149.0,10.23,6.33).
city('Njinikom','cm','Nordouest',8247.0,10.28,6.24).
city('Wum','cm','Nordouest',69072.0,10.07,6.4).
city('Bafang','cm','Ouest',80966.0,10.18,5.17).
city('Bafoussam','cm','Ouest',290798.0,10.41,5.49).
city('Bafut','cm','Ouest',18946.0,10.1,6.08).
city('Bali','cm','Ouest',72909.0,10.01,5.9).
city('Bana','cm','Ouest',5727.0,10.26,5.15).
city('Bangangte','cm','Ouest',65608.0,10.51,5.15).
city('Djang','cm','Ouest',96436.0,10.05,5.46).
city('Fontem','cm','Ouest',42835.0,9.88,5.47).
city('Foumban','cm','Ouest',92673.0,10.9,5.73).
city('Foumbot','cm','Ouest',84417.0,10.63,5.52).
city('Mbouda','cm','Ouest',111690.0,10.25,5.64).
city('Akom','cm','Sud',9709.0,10.56,2.79).
city('Ambam','cm','Sud',8476.0,11.28,2.39).
city('Ebolowa','cm','Sud',88140.0,11.14,2.93).
city('Kribi','cm','Sud',55401.0,9.91,2.94).
city('Lolodorf','cm','Sud',22345.0,10.72,3.25).
city('Mvangue','cm','Sud',1908.0,11.52,2.97).
city('Sangmelima','cm','Sud',54427.0,11.97,2.94).
city('Buea','cm','Sudouest',64372.0,9.23,4.16).
city('Idenao','cm','Sudouest',17800.0,8.98,4.24).
city('Kumba','cm','Sudouest',144428.0,9.44,4.64).
city('Limbe','cm','Sudouest',72106.0,9.19,4.02).
city('Mutengene','cm','Sudouest',47638.0,9.28,4.08).
city('Muyuka','cm','Sudouest',31384.0,9.42,4.29).
city('Tiko','cm','Sudouest',56104.0,9.37,4.08).
city('Airdrie','ca','Alberta',24673.0,-114.02,51.3).
city('Athabasca','ca','Alberta',2539.0,-113.27,54.72).
city('Banff','ca','Alberta',7502.0,-115.57,51.17).
city('Barrhead','ca','Alberta',4430.0,-114.4,54.12).
city('Bassano','ca','Alberta',1388.0,-112.47,50.78).
city('Beaumont','ca','Alberta',7366.0,-113.42,53.35).
city('Beaverlodge','ca','Alberta',2219.0,-119.45,55.2).
city('Black Diamond','ca','Alberta',3663.0,-114.23,50.7).
city('Blackfalds','ca','Alberta',3198.0,-113.8,52.38).
city('Blairmore','ca','Alberta',2095.0,-114.43,49.6).
city('Bon Accord','ca','Alberta',1611.0,-113.42,53.83).
city('Bonnyville','ca','Alberta',6003.0,-110.75,54.27).
city('Bow Island','ca','Alberta',1792.0,-111.37,49.87).
city('Brooks','ca','Alberta',12745.0,-111.91,50.57).
city('Calgary','ca','Alberta',968475.0,-114.06,51.05).
city('Calmar','ca','Alberta',2000.0,-113.78,53.25).
city('Camrose','ca','Alberta',15687.0,-112.84,53.02).
city('Canmore','ca','Alberta',12289.0,-115.35,51.09).
city('Cardston','ca','Alberta',3654.0,-113.32,49.2).
city('Carstairs','ca','Alberta',2370.0,-114.1,51.53).
city('Chateau Lake Louise','ca','Alberta',1095.0,-116.18,51.43).
city('Chestermere','ca','Alberta',3590.0,-113.78,51.06).
city('Clairmont','ca','Alberta',1483.0,-118.8,55.27).
city('Claresholm','ca','Alberta',3808.0,-113.58,50.03).
city('Coaldale','ca','Alberta',6317.0,-112.62,49.73).
city('Coalhurst','ca','Alberta',1552.0,-112.92,49.74).
city('Cochrane','ca','Alberta',16367.0,-114.47,51.19).
city('Crossfield','ca','Alberta',2512.0,-114.03,51.43).
city('Devon','ca','Alberta',5225.0,-113.73,53.37).
city('Didsbury','ca','Alberta',4134.0,-114.13,51.67).
city('Drayton Valley','ca','Alberta',6099.0,-114.98,53.22).
city('Drumheller','ca','Alberta',6557.0,-112.71,51.47).
city('Edmonton','ca','Alberta',822319.0,-113.54,53.57).
city('Edson','ca','Alberta',7975.0,-116.42,53.58).
city('Elk Point','ca','Alberta',1514.0,-110.9,53.9).
city('Fairview','ca','Alberta',3312.0,-118.4,56.07).
city('Falher','ca','Alberta',1166.0,-117.2,55.74).
city('Fort MacLeod','ca','Alberta',3060.0,-113.4,49.73).
city('Fox Creek','ca','Alberta',2457.0,-116.84,54.4).
city('Gibbons','ca','Alberta',2790.0,-113.33,53.84).
city('Grand Centre','ca','Alberta',12386.0,-110.22,54.42).
city('Grande Cache','ca','Alberta',4025.0,-119.12,53.88).
city('Grande','ca','Alberta',41463.0,-118.8,55.18).
city('Grimshaw','ca','Alberta',2560.0,-117.6,56.18).
city('Hanna','ca','Alberta',3140.0,-111.92,51.63).
city('High Level','ca','Alberta',3621.0,-117.13,58.52).
city('High Prairie','ca','Alberta',2878.0,-116.48,55.43).
city('High River','ca','Alberta',9826.0,-113.87,50.58).
city('Hinton','ca','Alberta',9889.0,-117.58,53.4).
city('Irricana','ca','Alberta',1091.0,-113.62,51.32).
city('Jasper','ca','Alberta',3907.0,-118.08,52.88).
city('Killam','ca','Alberta',1056.0,-111.85,52.78).
city('La Crete','ca','Alberta',1483.0,-117.55,59.13).
city('Lac la Biche','ca','Alberta',2919.0,-111.96,5.77).
city('Lacombe','ca','Alberta',10059.0,-113.73,52.47).
city('Lamont','ca','Alberta',1779.0,-112.78,53.75).
city('Leduc','ca','Alberta',15562.0,-113.56,53.26).
city('Lethbridge','ca','Alberta',70619.0,-112.83,49.69).
city('Lloydminster','ca','Alberta',22677.0,-110.01,53.28).
city('Magrath','ca','Alberta',2095.0,-112.88,49.42).
city('Manning','ca','Alberta',1359.0,-117.61,56.93).
city('Mayerthorpe','ca','Alberta',1651.0,-115.14,53.95).
city('Medicine Hat','ca','Alberta',63140.0,-110.69,50.04).
city('Millet','ca','Alberta',2142.0,-113.47,53.08).
city('Morinville','ca','Alberta',8108.0,-113.65,53.8).
city('Nanton','ca','Alberta',1936.0,-113.77,50.35).
city('Okotoks','ca','Alberta',14827.0,-113.96,50.72).
city('Olds','ca','Alberta',6947.0,-114.1,51.78).
city('Peace River','ca','Alberta',5340.0,-117.28,56.23).
city('Penhold','ca','Alberta',1818.0,-113.87,52.13).
city('Picture Butte','ca','Alberta',1788.0,-112.8,49.88).
city('Pincher Creek','ca','Alberta',3855.0,-113.95,49.48).
city('Ponoka','ca','Alberta',6656.0,-113.57,52.68).
city('Provost','ca','Alberta',2082.0,-110.27,52.35).
city('Raymond','ca','Alberta',3365.0,-112.67,49.47).
city('Red Deer','ca','Alberta',73595.0,-113.83,52.27).
city('Redwater','ca','Alberta',2284.0,-79.63,46.9).
city('Rimbey','ca','Alberta',2227.0,-114.22,52.63).
city('Rocky Mountain House','ca','Alberta',6527.0,-114.92,52.37).
city('Saint Paul','ca','Alberta',5321.0,-111.28,53.98).
city('Sexsmith','ca','Alberta',1743.0,-118.78,55.35).
city('Slave Lake','ca','Alberta',7661.0,-114.78,55.28).
city('Smoky Lake','ca','Alberta',1063.0,-112.47,54.11).
city('Spirit River','ca','Alberta',1157.0,-118.83,55.78).
city('Spruce Grove','ca','Alberta',17767.0,-113.92,53.53).
city('Stettler','ca','Alberta',5494.0,-112.68,52.33).
city('Stony Plain','ca','Alberta',8939.0,-114.0,53.53).
city('Strathmore','ca','Alberta',10009.0,-113.4,51.04).
city('Sundre','ca','Alberta',2384.0,-114.65,51.8).
city('Swan Hills','ca','Alberta',1900.0,-115.43,54.71).
city('Sylvan Lake','ca','Alberta',10520.0,-114.1,52.31).
city('Taber','ca','Alberta',8163.0,-112.15,49.78).
city('Three Hills','ca','Alberta',3051.0,-113.27,51.7).
city('Tofield','ca','Alberta',1911.0,-112.67,53.37).
city('Two Hills','ca','Alberta',1147.0,-111.75,53.72).
city('Valleyview','ca','Alberta',1951.0,-117.28,55.07).
city('Vegreville','ca','Alberta',5678.0,-112.05,53.5).
city('Vermilion','ca','Alberta',4151.0,-110.85,53.35).
city('Viking','ca','Alberta',1106.0,-111.78,53.08).
city('Vulcan','ca','Alberta',1853.0,-113.25,50.4).
city('Wainwright','ca','Alberta',5380.0,-110.87,52.83).
city('Wembley','ca','Alberta',1574.0,-119.15,55.15).
city('Westlock','ca','Alberta',5067.0,-113.87,54.15).
city('Wetaskiwin','ca','Alberta',11302.0,-113.38,52.97).
city('Whitecourt','ca','Alberta',8763.0,-115.68,54.13).
city('Wood Buffalo','ca','Alberta',40976.0,-111.43,56.74).
city('Abbotsford','ca','British Columbia',151685.0,-122.3,49.06).
city('Aldergrove','ca','British Columbia',11963.0,-122.5,49.06).
city('Armstrong','ca','British Columbia',4275.0,-119.18,50.45).
city('Ashcroft','ca','British Columbia',1796.0,-121.27,50.72).
city('Blind Bay','ca','British Columbia',1428.0,-119.35,50.85).
city('Burns Lake','ca','British Columbia',2635.0,-125.77,54.22).
city('Cache Creek','ca','British Columbia',1061.0,-121.32,50.8).
city('Campbell River','ca','British Columbia',33430.0,-125.23,49.99).
city('Castlegar','ca','British Columbia',8715.0,-117.67,49.32).
city('Central Okanagan','ca','British Columbia',35392.0,-119.87,50.03).
city('Chase','ca','British Col',2471.0,-119.68,50.82).
city('Chemainus','ca','British Columbia',2718.0,-123.7,48.92).
city('Chetwynd','ca','British Columbia',2587.0,-121.62,55.7).
city('Chilliwack','ca','British Columbia',51942.0,-121.96,49.17).
city('Courtenay','ca','British Columbia',32793.0,-125.0,49.69).
city('Cowichan Valley','ca','British Columbia',3177.0,-123.62,48.73).
city('Cranbrook','ca','British Columbia',18610.0,-115.77,49.51).
city('Creston','ca','British Columbia',4816.0,-116.52,49.1).
city('Cultus Lake','ca','British Columbia',1262.0,-121.96,49.05).
city('Cumberland','ca','Bri',2630.0,-125.02,49.62).
city('Dallas','ca','British Columbia',4363.0,-120.46,50.66).
city('Dawson Creek','ca','British Columbia',10802.0,-120.24,55.76).
city('Duck Lake','ca','British Columbia',5628.0,-116.63,49.23).
city('Duncan','ca','British Columbia',22199.0,-123.7,48.78).
city('Elkford','ca','British Columbia',2585.0,-114.88,50.06).
city('Enderby','ca','British Columbia',2830.0,-119.13,50.55).
city('Fernie','ca','British Columbia',5019.0,-115.07,49.5).
city('Fort Langley','ca','British Columbia',2653.0,-122.5,49.03).
city('Fort Nelson','ca','Briti',4207.0,-122.53,58.82).
city('Fort Saint James','ca','British Columbia',2392.0,-124.25,54.43).
city('Fort Saint John','ca','British Columbia',16656.0,-120.85,56.25).
city('Fraser Lake','ca','British Columbia',1274.0,-135.05,59.72).
city('Fruitvale','ca','British Columbia',3790.0,-117.55,49.12).
city('Gibsons','ca','British Columbia',6821.0,-123.5,49.4).
city('Gold River','ca','British Columbia',1365.0,-126.05,49.78).
city('Golden','ca','British Columbia',4038.0,-116.97,51.3).
city('Grand Forks','ca','British Columbia',4208.0,-118.47,49.05).
city('Hope','ca','British Columbia',4598.0,-121.43,49.38).
city('Houston','ca','British Columbia',2884.0,-126.65,54.4).
city('Invermere','ca','British Columbia',2871.0,-116.03,50.5).
city('Kamloops','ca','British Columbia',68715.0,-120.34,50.68).
city('Kelowna','ca','British Columbia',125110.0,-119.46,49.89).
city('Kent','ca','British Columbia',2533.0,-121.81,49.24).
city('Kimberley','ca','British Columbia',6513.0,-115.98,49.68).
city('Kitimat','ca','British Columbia',10278.0,-128.7,54.01).
city('Ladysmith','ca','British Columbia',8740.0,-123.82,48.99).
city('Lake Cowichan','ca','British Columbia',2870.0,-124.03,48.82).
city('Lillooet','ca','British Columbia',2585.0,-121.93,50.68).
city('Lions Bay','ca','British Columbia',1385.0,-123.24,49.46).
city('Logan Lake','ca','British Columbia',2190.0,-120.83,50.49).
city('Lumby','ca','British Columbia',1625.0,-118.97,50.25).
city('Mackenzie','ca','British Columbia',4978.0,-123.08,55.32).
city('Merritt','ca','British Columbia',7179.0,-120.78,50.12).
city('Nakusp','ca','British Columbia',1706.0,-117.8,50.23).
city('Nanaimo','ca','British Columbia',84906.0,-123.97,49.21).
city('Nelson','ca','British Columbia',9813.0,-117.3,49.49).
city('North Cowichan','ca','British Columbia',32272.0,-123.73,48.82).
city('Oliver','ca','British Columbia',4647.0,-119.55,49.18).
city('One Hundred Mile House','ca','British Columbia',1737.0,-121.28,51.65).
city('Osoyoos','ca','British Columbia',4314.0,-119.47,49.03).
city('Parksville','ca','British Columbia',21150.0,-124.33,49.33).
city('Peachland','ca','British Columbia',1305.0,-119.75,49.77).
city('Pemberton','ca','British Columbia',1644.0,-122.82,50.32).
city('Penticton','ca','British Columbia',37721.0,-119.59,49.5).
city('Port Alberni','ca','British Columbia',21282.0,-124.82,49.27).
city('Port Hardy','ca','British Columbia',4628.0,-127.5,50.72).
city('Port MacNeill','ca','British Columbia',2834.0,-127.1,50.58).
city('Powell River','ca','British Columbia',12779.0,-124.52,49.85).
city('Prince George','ca','British Columbia',65558.0,-122.77,53.91).
city('Prince Rupert','ca','British Columbia',14708.0,-130.31,54.32).
city('Princeton','ca','British Columbia',2706.0,-120.5,49.45).
city('Quesnel','ca','British Columbia',13788.0,-122.48,52.98).
city('Revelstoke','ca','British Columbia',7533.0,-118.18,51.0).
city('Rossland','ca','British Columbia',3619.0,-117.82,49.08).
city('Salmo','ca','British Columbia',1125.0,-117.28,49.2).
city('Salmon Arm','ca','British Columbia',10093.0,-119.29,50.7).
city('Sechelt','ca','British Columbia',5977.0,-123.77,49.47).
city('Sicamous','ca','British Columbia',2732.0,-119.0,50.83).
city('Smithers','ca','British Columbia',5438.0,-127.17,54.77).
city('Sooke','ca','British Columbia',6145.0,-123.73,48.38).
city('Sparwood','ca','British Columbia',2264.0,-114.87,49.77).
city('Squamish','ca','British Columbia',12691.0,-13.17,49.71).
city('Summerland','ca','British Columbia',6292.0,-119.69,49.61).
city('Terrace','ca','British Columbia',19443.0,-128.61,54.52).
city('Trail','ca','British Columbia',9707.0,-117.73,49.1).
city('Tumbler Ridge','ca','British Columbia',1844.0,-121.0,55.13).
city('Ucluelet','ca','British Columbia',1566.0,-125.52,48.93).
city('Vancouver','ca','British Columbia',1837970.0,-123.13,49.28).
city('Vanderhoof','ca','British Columbia',1462.0,-124.02,54.02).
city('Vernon','ca','British Columbia',47275.0,-119.28,50.27).
city('Victoria','ca','British Columbia',289625.0,-123.37,48.43).
city('Walnut Grove','ca','British Columbia',21506.0,-122.62,49.19).
city('Whistler','ca','British Columbia',10601.0,-122.97,50.13).
city('White Rock','ca','British Columbia',66450.0,-122.83,49.03).
city('Williams Lake','ca','British Columbia',14168.0,-122.14,52.13).
city('Altona','ca','Manitoba',3613.0,-97.57,49.1).
city('Beausejour','ca','Manitoba',2886.0,-96.52,50.07).
city('Boissevain','ca','Manitoba',1557.0,-100.05,49.23).
city('Brandon','ca','Manitoba',26234.0,-99.96,49.84).
city('Carberry','ca','Manitoba',1575.0,-99.35,49.87).
city('Carman','ca','Manitoba',2948.0,-98.0,49.5).
city('Dauphin','ca','Manitoba',8418.0,-100.05,51.15).
city('Deloraine','ca','Manitoba',1068.0,-100.5,49.18).
city('Flin Flon','ca','Manitoba',6002.0,-101.89,54.77).
city('Gimli','ca','Manitoba',2009.0,-97.0,50.63).
city('Killarney','ca','Manitoba',2362.0,-99.67,49.18).
city('Lac du Bonnet','ca','Manitoba',1134.0,-96.05,50.27).
city('Leaf Rapids','ca','Manitoba',1358.0,-100.0,56.46).
city('Melita','ca','Manitoba',1167.0,-100.98,49.27).
city('Minnedosa','ca','Manitoba',2526.0,-99.0,50.25).
city('Morden','ca','Manitoba',6395.0,-98.1,49.18).
city('Morris','ca','Manitoba',1742.0,-97.37,49.35).
city('Neepawa','ca','Manitoba',3151.0,-99.45,50.23).
city('Niverville','ca','Manitoba',2000.0,-97.06,49.62).
city('Pinawa','ca','Manitoba',1562.0,-95.88,50.15).
city('Portage la Prairie','ca','Manitoba',12958.0,-98.31,49.98).
city('Ritchot','ca','Manitoba',1061.0,-97.12,49.61).
city('Rivers','ca','Manitoba',1165.0,-100.22,50.03).
city('Roblin','ca','Manitoba',1903.0,-101.35,51.23).
city('Sai','ca','Manitoba',1187.0,-97.12,49.69).
city('Sainte Anne','ca','Manitoba',1575.0,-96.67,49.67).
city('Sainte Rose du Lac','ca','Manitoba',1090.0,-99.53,51.05).
city('Selkirk','ca','Manitoba',9653.0,-96.89,50.14).
city('Shilo','ca','Manitoba',1238.0,-99.97,49.73).
city('Snow Lake','ca','Manitoba',1185.0,-114.18,64.18).
city('Souris','ca','Manitoba',1752.0,-100.25,49.62).
city('Springfield','ca','Manitoba',2066.0,-96.84,49.88).
city('Steinbach','ca','Manitoba',9607.0,-96.68,49.52).
city('Stonewall','ca','Manitoba',4177.0,-97.32,50.13).
city('Stony Mountain','ca','Manitoba',1770.0,-97.22,50.07).
city('Swan River','ca','Manitoba',4198.0,-101.27,52.1).
city('The Pas','ca','Manitoba',6055.0,-101.26,53.82).
city('Thompson','ca','Manitoba',12467.0,-97.86,55.74).
city('Virden','ca','Manitoba',3237.0,-100.93,49.85).
city('Winkler','ca','Manitoba',8270.0,-97.93,49.18).
city('Winnipeg','ca','Manitoba',632069.0,-97.17,49.88).
city('Bathurst','ca','New Brunswick',18179.0,-65.65,47.62).
city('Bouctouche','ca','New Brunswick',1895.0,-64.72,46.48).
city('Campbellton','ca','New Brunswick',12064.0,-66.68,48.0).
city('Caraquet','ca','New Brunswick',4620.0,-64.95,47.78).
city('Chatham-Douglastown','ca','New Brunswick',13343.0,-65.46,47.03).
city('Dalhousie','ca','New Brunswick',4137.0,-66.37,48.07).
city('Edmundston','ca','New Brunswick',17937.0,-68.34,47.38).
city('Fredericton','ca','New Brunswick',52337.0,-66.66,45.96).
city('Grand Falls','ca','New Brunswick',5675.0,-67.73,47.05).
city('Hampton','ca','New Brunswick',2637.0,-65.83,45.53).
city('Kedgwick','ca','New Brunswick',1146.0,-67.33,47.63).
city('MacAdam','ca','New Brunswick',1465.0,-67.33,45.58).
city('MacEwen','ca','New Brunswick',1238.0,-64.99,46.16).
city('Moncton','ca','New Brunswick',87467.0,-64.78,46.09).
city('Nackawic','ca','New Brunswick',1009.0,-67.24,46.0).
city('Oromocto','ca','New Brunswick',8998.0,-66.47,45.85).
city('Perth-Andover','ca','New Brunswick',1847.0,-67.7,46.73).
city('Petit Rocher','ca','New Brunswick',2101.0,-65.73,47.79).
city('Plaster Rock','ca','New Brunswick',1180.0,-67.38,46.9).
city('Richibukto','ca','New Brunswick',1298.0,-64.87,46.68).
city('Rogersville','ca','New Brunswick',1208.0,-79.45,46.72).
city('Sackville','ca','New Brunswick',2891.0,-64.35,45.88).
city('Saint Andrews','ca','New Brunswick',1809.0,-67.03,45.07).
city('Saint John','ca','New Brunswick',87857.0,-66.06,45.29).
city('Saint Leonard','ca','New Brunswick',1350.0,-67.92,47.17).
city('Saint Quentin','ca','New Brunswick',2207.0,-67.38,47.5).
city('Saint Stephen','ca','New Brunswick',4518.0,-67.27,45.2).
city('Sainte-Anne-de-Madawaska','ca','New Brunswick',1131.0,-68.03,47.25).
city('Salisbury','ca','New Brunswick',1891.0,-65.05,46.03).
city('Shediac','ca','New Brunswick',4735.0,-64.53,46.22).
city('Shippagan','ca','New Brunswick',2780.0,-64.7,47.73).
city('Sussex','ca','New Brunswick',4048.0,-65.52,45.72).
city('Tracadie-Sheila','ca','New Brunswick',2430.0,-64.92,47.5).
city('Woodstock','ca','New Brunswick',5032.0,-67.57,46.15).
city('Arnolds Cove','ca','Newfoundland and Labrador',935.0,-53.99,47.77).
city('Bay Roberts','ca','Newfoundland and Labrador',13735.0,-53.29,47.59).
city('Bishops Falls','ca','Newfoundland and Labrador',3292.0,-55.52,49.02).
city('Bonavista','ca','Newfoundland and Labrador',3658.0,-53.13,48.65).
city('Botwood','ca','Newfoundland and Labrador',2940.0,-55.37,49.15).
city('Burgeo','ca','Newfoundland and Labrador',1627.0,-57.63,47.6).
city('Carbonear','ca','Newfoundland and Labrador',6814.0,-53.24,47.75).
city('Catalina','ca','Newfoundland and Labrador',1352.0,-53.08,48.52).
city('Channel-Port aux Basques','ca','Newfoundland and Labrador',4220.0,-59.17,47.58).
city('Clarenville-Shoal Harbour','ca','Newfoundland and Labrador',3478.0,-53.97,48.15).
city('Conception Bay South','ca','Newfoundland and Labrador',17086.0,-53.0,47.5).
city('Corner Brook','ca','Newfoundland and Labrador',18693.0,-57.96,48.96).
city('Deer Lake','ca','Newf',4163.0,-57.43,49.18).
city('Dunville','ca','Newfoundland and Labrador',3333.0,-53.88,48.28).
city('Gambo','ca','Newfoundland and Labrador',1614.0,-54.22,48.78).
city('Gander','ca','Newfoundland and Labrador',8772.0,-54.65,48.95).
city('Goulds','ca','Newfoundland and Labrador',4014.0,-52.79,47.4).
city('Grand Bank','ca','Newfoundland and Labrador',4623.0,-55.76,47.1).
city('Grand Falls-Windsor','ca','Newfoundland and Labrador',12076.0,-55.66,48.93).
city('Happy Valley-Goose Bay','ca','Newfoundland and Labrador',6169.0,-60.4,53.34).
city('Harbour Breton','ca','Newfoundland and Labrador',1898.0,-55.83,47.48).
city('Hare Bay','ca','Newfoundland and Labrador',968.0,-54.02,48.85).
city('Humber Arm South','ca','Newfoundland and Labrador',1148.0,-58.18,49.07).
city('LAscie','ca','Newfoundland and Labrador',970.0,-55.58,49.97).
city('Labrador City','ca','Newfoundland and Labrador',10313.0,-66.92,52.94).
city('Lewisporte','ca','Newfoundland and Labrador',2935.0,-55.07,49.23).
city('Marystown','ca','Newfoundland and Labrador',4558.0,-55.19,47.17).
city('Musgrave Harbour','ca','Newfoundland and Labrador',1125.0,-53.88,48.42).
city('Pasadena','ca','Newfoundland and Labrador',2248.0,-57.61,49.03).
city('Saint Anthony','ca','Newfoundland and Labrador',2492.0,-55.6,51.38).
city('Saint Johns','ca','Newfoundland and Labrador',112007.0,-52.69,47.58).
city('Springdale','ca','Newfoundland and Labrador',2779.0,-56.1,49.48).
city('Stephenville','ca','Newfoundland and Labrador',6278.0,-58.57,48.56).
city('Stephenville Crossing','ca','Newfoundland and Labrador',1183.0,-58.42,48.52).
city('Torbay','ca','Newfoundland and Labrador',3097.0,-52.73,47.65).
city('Wabana','ca','Newfoundland and Labrador',2362.0,-52.98,47.64).
city('Aklavik','ca','Northwest Territories',648.0,-135.0,68.22).
city('Fort MacPherson','ca','Northwest Territories',1069.0,-134.84,67.43).
city('Hay River','ca','Northwest Territories',3030.0,-115.75,60.86).
city('Inuvik','ca','Northwest Territories',3022.0,-133.73,68.37).
city('Norman Wells','ca','Northwest Territories',1027.0,-126.86,65.29).
city('Tuktoyaktuk','ca','Northwest Territories',978.0,-133.01,69.42).
city('Yellowknife','ca','Northwest Territories',15866.0,-114.36,62.46).
city('Amherst','ca','Nova Scotia',9336.0,-64.21,45.83).
city('Antigonish','ca','Nova Scotia',5003.0,-61.97,45.62).
city('Berwick','ca','Nova Scotia',2271.0,-64.73,45.03).
city('Bridgetown','ca','Nova Scotia',1063.0,-65.15,44.85).
city('Bridgewater','ca','Nova Scotia',8070.0,-64.52,44.38).
city('Brookside','ca','Nova Scotia',1238.0,-63.38,44.72).
city('Chester','ca','Nova Scotia',1531.0,-64.23,44.53).
city('Digby','ca','Nova Scotia',2052.0,-65.77,44.62).
city('Enfield','ca','Nova Scotia',3125.0,-63.54,44.93).
city('Glace Bay','ca','Nova Scotia',21504.0,-59.97,46.2).
city('Halifax','ca','Nova Scotia',266012.0,-63.61,44.67).
city('Hammonds Plains Road','ca','Nova Scotia',1119.0,-63.71,44.79).
city('Hantsport','ca','Nova Scotia',1253.0,-64.18,45.07).
city('Inverness','ca','Nova Scoti',1639.0,-61.31,46.24).
city('Kentville','ca','Nova Scotia',12636.0,-64.51,45.08).
city('Kingston-Greenwood','ca','Nova Scotia',6915.0,-64.9,44.98).
city('Lake Echo','ca','Nova Scotia',3530.0,-63.44,44.82).
city('Lantz','ca','Nova Scotia',1450.0,-63.71,45.12).
city('Liverpool','ca','Nova Scotia',2781.0,-64.72,44.03).
city('Louisbourg','ca','Nova Scotia',1031.0,-59.98,45.92).
city('Lunenburg','ca','Nova Scotia',2473.0,-64.32,44.37).
city('Middleton','ca','Nova Scotia',1680.0,-65.07,44.95).
city('New Glasgow','ca','Nova Scotia',20322.0,-62.65,45.59).
city('New Waterford','ca','Nova Scotia',11026.0,-60.11,46.26).
city('Oxford','ca','Nova Scotia',1283.0,-63.87,45.73).
city('Parrsboro','ca','Nova Scotia',1472.0,-64.32,45.4).
city('Pictou','ca','Nova Scotia',3732.0,-62.71,45.68).
city('Port Hawkesbury','ca','Nova Scotia',3564.0,-61.35,45.6).
city('Shelburne','ca','Nova Scotia',1939.0,-65.32,43.77).
city('Springhill','ca','Nova Scotia',3940.0,-64.05,45.63).
city('Sydney','ca','Nova Scotia',32660.0,-60.17,46.15).
city('Sydney Mines','ca','Nova Scotia',15474.0,-60.25,46.26).
city('Truro','ca','Nova Scotia',20650.0,-63.28,45.36).
city('Waverley','ca','Nova Scotia',966.0,-63.61,44.79).
city('Western Shore-Gold River','ca','Nova Scotia',977.0,-64.34,44.57).
city('Windsor','ca','Nova Scotia',3864.0,-64.13,44.98).
city('Wolfville','ca','Nova Scotia',3523.0,-64.37,45.08).
city('Yarmouth','ca','Nova Scotia',7500.0,-66.12,43.84).
city('Clyde River','ca','Nunavut',1017.0,-68.63,70.46).
city('Iqaluit','ca','Nunavut',6124.0,-68.55,63.74).
city('Kangerdlinerk','ca','Nunavut',2334.0,-92.12,62.82).
city('Oqsuqtooq','ca','Nunavut',1109.0,-95.86,68.64).
city('Pangnirtung','ca','Nunavut',1320.0,-65.72,66.13).
city('Tununirusiq','ca','Nunavut',842.0,-85.2,73.04).
city('Acton','ca','Ontario',8204.0,-80.03,43.63).
city('Alexandria','ca','Ontario',3559.0,-74.63,45.3).
city('Alfred','ca','Ontario',1424.0,-74.87,45.55).
city('Alliston','ca','Ontario',10224.0,-79.87,44.15).
city('Almonte','ca','Ontario',4921.0,-76.2,45.22).
city('Amherstburg','ca','Ontario',11459.0,-83.1,42.1).
city('Amigo Beach','ca','Ont',1130.0,-79.34,44.77).
city('Angus-Borden','ca','Ontario',10269.0,-79.88,44.32).
city('Arnprior','ca','Ontario',9607.0,-76.37,45.43).
city('Arthur','ca','Ontario',2413.0,-80.53,43.83).
city('Atikokan','ca','Ontario',3760.0,-91.62,48.75).
city('Attawapiskat','ca','Ontario',1366.0,-82.43,52.92).
city('Aylmer','ca','Ontario',7527.0,-80.98,42.78).
city('Ayr','ca','Ontario',3841.0,-80.45,43.28).
city('Barrie','ca','Ontario',182070.0,-79.68,44.38).
city('Barrys Bay','ca','Ontario',1330.0,-77.68,45.48).
city('Beamsville','ca','Ontario',9556.0,-79.47,43.17).
city('Beaverton','ca','Ontario',3237.0,-79.15,44.43).
city('Beeton','ca','Ontario',4037.0,-79.79,44.11).
city('Belleville','ca','Ontario',65368.0,-77.38,44.17).
city('Belmont','ca','Ontario',1921.0,-81.06,42.88).
city('Blenheim','ca','Ontario',5065.0,-82.0,42.33).
city('Blind River','ca','Ontario',2966.0,-82.95,46.18).
city('Bobcaygeon','ca','Ontario',3015.0,-78.55,44.53).
city('Bolton','ca','Ontario',21709.0,-79.73,43.88).
city('Bourget','ca','Ontario',1062.0,-75.16,45.44).
city('Bowmanville-Newcastle','ca','Ontario',34388.0,-78.68,43.9).
city('Bracebridge','ca','Ontario',8238.0,-79.3,45.03).
city('Bradford','ca','Ontario',18811.0,-79.56,44.12).
city('Brantford','ca','Ontario',87761.0,-80.26,43.15).
city('Bridgenorth-Chemong Park Area','ca','Ontario',2407.0,-78.33,44.5).
city('Brighton','ca','Ontario',5152.0,-77.73,44.03).
city('Brockville','ca','Ontario',23887.0,-75.7,44.61).
city('Brooklin','ca','Ontario',6115.0,-78.96,43.95).
city('Brussels','ca','Ontario',1207.0,-81.25,43.75).
city('Burford','ca','Ontario',1945.0,-80.42,43.11).
city('Caledon','ca','Ontario',1744.0,-79.83,43.81).
city('Caledon East','ca','Ontario',2085.0,-79.87,43.87).
city('Caledonia','ca','Ontario',9065.0,-79.95,43.07).
city('Campbellford','ca','Ontario',3882.0,-77.8,44.3).
city('Cannington','ca','Ontario',2120.0,-79.03,44.35).
city('Capreol','ca','Ontario',3666.0,-80.92,46.7).
city('Cardinal','ca','Ontario',1837.0,-75.37,44.78).
city('Carleton Place','ca','Ontario',9743.0,-76.13,45.0).
city('Carlisle','ca','Ontario',2303.0,-81.54,43.15).
city('Casselman','ca','Ontario',3074.0,-75.08,45.3).
city('Cayuga','ca','Ontario',1735.0,-79.95,42.93).
city('Chapleau','ca','Ontario',2991.0,-83.4,47.83).
city('Chatham','ca','Ontario',44554.0,-82.19,42.41).
city('Chesley','ca','Ontario',1986.0,-81.1,44.3).
city('Chesterville','ca','Ontario',1582.0,-75.22,45.1).
city('Clinton','ca','Ontario',3292.0,-81.53,43.6).
city('Cobourg','ca','Ontario',18100.0,-78.17,43.96).
city('Cochrane','ca','Ontario',4407.0,-81.02,49.07).
city('Colborne','ca','Ontario',2155.0,-77.88,44.02).
city('Colchester','ca','Ontario',2307.0,-82.93,41.98).
city('Collingwood','ca','Ontario',15809.0,-80.21,44.49).
city('Constance Bay','ca','Ontario',2458.0,-75.5,45.25).
city('Cookstown','ca','Ontario',1531.0,-79.65,44.21).
city('Cornwall','ca','Ontario',48823.0,-74.74,45.03).
city('Creemore','ca','Ontario',1391.0,-80.1,44.32).
city('Crystal Beach','ca','Ontario',7062.0,-79.4,45.05).
city('Deep River','ca','Ontario',4296.0,-77.5,46.1).
city('Delhi','ca','Ontario',4227.0,-80.5,42.85).
city('Deseronto','ca','Ontario',1897.0,-77.03,44.2).
city('Drayton','ca','Ontario',1606.0,-80.67,43.75).
city('Dresden','ca','Ontario',2727.0,-82.17,42.58).
city('Dryden','ca','Ontario',6924.0,-92.83,49.78).
city('Dundalk','ca','Ontario',2083.0,-80.38,4.17).
city('Dunnville','ca','Ontario',6006.0,-79.62,42.91).
city('Durham','ca','Ontario',2861.0,-80.82,44.18).
city('Dutton','ca','Ontario',1451.0,-81.5,42.66).
city('Eganville','ca','Ontario',1299.0,-77.1,45.53).
city('Elliot Lake','ca','Ontario',12508.0,-82.66,46.39).
city('Elmira','ca','Ontario',8614.0,-80.55,43.6).
city('Elmvale','ca','Ontario',2298.0,-79.87,44.58).
city('Embrun','ca','Ontario',4719.0,-75.3,45.29).
city('Englehart','ca','Ontario',1685.0,-79.87,47.82).
city('Erin','ca','Ontario',3053.0,-80.07,43.77).
city('Espanola','ca','Ontario',4682.0,-81.77,46.25).
city('Essex','ca','Ontario',7396.0,-82.82,42.17).
city('Everett','ca','Ontario',1210.0,-80.0,44.25).
city('Exeter','ca','Ontario',4702.0,-81.48,43.35).
city('Fenelon Falls','ca','Ontario',1979.0,-78.75,44.53).
city('Fergus','ca','Ontario',17673.0,-80.37,43.7).
city('Forest','ca','Ontario',3018.0,-82.0,43.1).
city('Fort Erie','ca','Ontario',15953.0,-78.93,42.91).
city('Fort Frances','ca','Ontario',7931.0,-93.42,48.62).
city('Frankford','ca','Ontario',2627.0,77.6,44.2).
city('Gananoque','ca','Ontario',5458.0,-76.17,44.33).
city('Georgetown','ca','Ontario',32372.0,-79.93,43.66).
city('Georgina','ca','Ontario',45481.0,-79.25,44.27).
city('Geraldton','ca','Ontario',2349.0,-86.97,49.72).
city('Glencoe','ca','Ontario',2273.0,-81.7,42.75).
city('Goderich','ca','Ontario',8032.0,-81.7,43.73).
city('Golden','ca','Ontario',1275.0,-77.25,45.58).
city('Grand Bend','ca','Ontario',2059.0,-81.75,43.32).
city('Grand Valley','ca','Ontario',1856.0,-80.32,43.9).
city('Gravenhurst','ca','Ontario',5839.0,-79.37,44.92).
city('Guelph','ca','Ontario',115763.0,-80.26,43.56).
city('Hagersville','ca','Ontario',2624.0,-80.05,42.95).
city('Haileybury','ca','Ontario',10991.0,-79.63,47.43).
city('Hamilton','ca','Ontario',653637.0,-79.85,43.26).
city('Hanover','ca','Ontario',7255.0,-81.03,44.15).
city('Harriston','ca','Ontario',2148.0,-80.88,43.92).
city('Harrow','ca','Ontario',3100.0,-82.92,42.03).
city('Hastings','ca','Ontario',1276.0,-77.95,44.3).
city('Havelock','ca','Ontario',1403.0,-77.88,44.44).
city('Hawkesbury','ca','Ontario',12283.0,-74.6,45.62).
city('Hearst','ca','Ontario',4746.0,-83.67,49.7).
city('Hensall','ca','Ontario',1261.0,-81.5,43.43).
city('Hillsburgh','ca','Ontario',1265.0,-80.15,43.81).
city('Hornepayne','ca','Ontario',1386.0,-84.78,49.22).
city('Huntsville','ca','Ontario',7972.0,-79.22,45.32).
city('Ingersoll','ca','Ontario',11874.0,-80.88,43.03).
city('Innisfil','ca','Ontario',7345.0,-79.64,44.26).
city('Iroquois','ca','Ontario',1297.0,-75.32,44.85).
city('Iroquois Falls','ca','Ontario',4232.0,-80.69,48.77).
city('Jarvis','ca','Ontario',2303.0,-79.7,42.99).
city('Kanata','ca','Ontario',93541.0,-75.88,45.34).
city('Kapuskasing','ca','Ontario',9240.0,-82.42,49.43).
city('Kars','ca','Ontario',1626.0,-84.0,49.0).
city('Kemptville','ca','Ontario',4229.0,-75.63,45.02).
city('Kenora','ca','Ontario',13075.0,-94.49,49.78).
city('Kincardine','ca','Ontario',6771.0,-81.63,44.17).
city('Kingston','ca','Ontario',114243.0,-76.5,44.23).
city('Kirkland Lake','ca','Ontario',7776.0,-80.03,48.17).
city('Kitchener','ca','Ontario',409111.0,-80.5,43.46).
city('LOriginal','ca','Ontario',2147.0,-74.68,45.62).
city('Lakefield','ca','Ontario',2888.0,-78.27,44.43).
city('Leamington','ca','Ontario',30428.0,-82.6,42.06).
city('Lindsay','ca','Ontario',17987.0,-78.74,44.35).
city('Listowel','ca','Ontario',6237.0,-80.97,43.73).
city('Little Current','ca','Ontario',1652.0,-81.93,45.97).
city('Lively','ca','Ontario',7081.0,-81.15,46.43).
city('London','ca','Ontario',346774.0,-81.24,42.97).
city('Longlac','ca','Ontario',1846.0,-86.55,49.78).
city('Lucan','ca','Ontario',2123.0,-81.4,43.18).
city('Lucknow','ca','Ontario',1275.0,-81.52,43.95).
city('Madoc','ca','Ontario',1827.0,-77.48,44.52).
city('Manitouwadge','ca','Ontario',3115.0,-85.8,49.13).
city('Marathon','ca','Ontario',4627.0,-86.37,48.75).
city('Markdale','ca','Ontario',1514.0,-80.65,44.32).
city('Marmora','ca','Ontario',1678.0,-77.68,44.48).
city('Mattawa','ca','Ontario',2415.0,-78.7,46.32).
city('Meaford','ca','Ontario',4816.0,-80.58,44.6).
city('Metcalfe','ca','Ontario',1701.0,-81.69,42.9).
city('Midland','ca','Ontario',31502.0,-79.89,44.75).
city('Mildmay','ca','Ontario',1258.0,-81.12,44.03).
city('Millbrook','ca','Ontario',1550.0,-78.45,44.15).
city('Milton','ca','Ontario',23472.0,-79.89,43.51).
city('Milverton','ca','Ontario',1803.0,-80.93,43.57).
city('Mississauga Beach','ca','Ontario',4045.0,-79.08,43.25).
city('Mitchell','ca','Ontario',4416.0,-81.18,43.47).
city('Moose Factory','ca','Ontario',2060.0,-80.6,51.25).
city('Morrisburg','ca','Ontario',2728.0,-75.18,44.9).
city('Mount Albert','ca','Ontario',2762.0,-79.32,44.13).
city('Mount Brydges','ca','Ontario',2346.0,-81.48,42.37).
city('Mount Forest','ca','Ontario',4842.0,-80.73,43.97).
city('Nanticoke','ca','Ontario',24732.0,-80.09,42.81).
city('Napanee','ca','Ontario',8197.0,-76.95,44.25).
city('New Hamburg','ca','Ontario',7397.0,-80.72,43.48).
city('Nobleton','ca','Ontario',3667.0,-79.66,43.9).
city('North Bay','ca','Ontario',50171.0,-79.45,46.3).
city('Norwich','ca','Ontario',2651.0,-80.6,42.98).
city('Norwood','ca','Ontario',1746.0,-77.98,44.38).
city('Omemee','ca','Ontario',1393.0,-78.55,44.3).
city('Onaping-Levack','ca','Ontario',4335.0,-81.38,46.63).
city('Orangeville','ca','Ontario',32641.0,-80.1,43.92).
city('Orillia','ca','Ontario',30179.0,-79.42,44.6).
city('Orono','ca','Ontario',1760.0,-78.62,43.99).
city('Osgoode','ca','Ontario',2716.0,-75.62,45.15).
city('Oshawa','ca','Ontario',247989.0,-78.86,43.89).
city('Ottawa','ca','Ontario',874433.0,-75.71,45.42).
city('Owen Sound','ca','Ontario',22625.0,-80.94,44.57).
city('Paisley','ca','Ontario',1091.0,-81.28,44.3).
city('Palmerston','ca','Ontario',2660.0,-80.85,43.83).
city('Paris','ca','Ontario',10437.0,-80.38,43.2).
city('Parkhill','ca','Ontario',1851.0,-81.68,43.17).
city('Parry Sound','ca','Ontario',6469.0,-80.03,45.33).
city('Pembroke','ca','Ontario',15551.0,-77.12,45.83).
city('Perth','ca','Ontario',6481.0,-76.23,44.88).
city('Petawawa','ca','Ontario',11256.0,-77.28,45.9).
city('Peterborough','ca','Ontario',75879.0,-78.34,44.3).
city('Petrolia','ca','Ontario',5453.0,-82.15,42.88).
city('Picton','ca','Ontario',4820.0,-77.15,44.02).
city('Porcupine','ca','Ontario',7601.0,-81.2,48.47).
city('Port Dover','ca','Ontario',5838.0,-80.2,42.78).
city('Port Elgin','ca','Ontario',7147.0,-81.38,44.43).
city('Port Hope','ca','Ontario',11765.0,-78.3,43.96).
city('Port Perry','ca','Ontario',7652.0,-78.93,44.1).
city('Port Stanley','ca','Ontario',2663.0,-81.22,42.67).
city('Powassan','ca','Ontario',1243.0,-79.35,46.07).
city('Prescott','ca','Ontario',4466.0,-75.52,44.72).
city('Renfrew','ca','Ontario',8018.0,-76.7,45.48).
city('Richmond','ca','Ontario',3472.0,-75.83,45.18).
city('Ridgetown','ca','Ontario',3547.0,-81.88,42.43).
city('Rockland','ca','Ontario',9023.0,-75.28,45.53).
city('Rockwood','ca','Ontario',2946.0,-80.13,43.62).
city('Rodney','ca','Ontario',1164.0,-81.68,42.57).
city('Saint Catharines-Niagara','ca','Ontario',316811.0,-79.24,43.18).
city('Saint George','ca','Ontario',2651.0,-80.25,43.24).
city('Saint Jacobs','ca','Ontario',1296.0,-80.55,43.56).
city('Saint Marys','ca','Ontario',6647.0,-81.13,43.25).
city('Saint Thomas','ca','Ontario',38694.0,-81.19,42.78).
city('Sarnia','ca','Ontario',82998.0,-82.4,42.99).
city('Sault Sainte Marie','ca','Ontario',63967.0,-84.35,46.53).
city('Schomberg','ca','Ontario',1284.0,-79.64,44.03).
city('Seaforth','ca','Ontario',2843.0,-81.38,43.55).
city('Shelburne','ca','Ontario',4390.0,-80.2,44.07).
city('Simcoe','ca','Ontario',13446.0,-80.31,42.84).
city('Sioux Lookout','ca','Ontario',3730.0,-91.92,50.1).
city('Smiths Falls','ca','Ontario',10553.0,-76.02,44.91).
city('Smithvill','ca','Ontario',3504.0,-79.53,43.1).
city('South River','ca','Ontario',1193.0,-79.37,45.85).
city('Southampton','ca','Ontario',3549.0,-81.37,44.5).
city('Stayner','ca','Ontario',4104.0,-80.08,44.42).
city('Stirling','ca','Ontario',2270.0,-77.55,44.3).
city('Stratford','ca','Ontario',30234.0,-80.98,43.37).
city('Strathroy','ca','Ontario',13525.0,-81.62,42.95).
city('Sturgeon Falls','ca','Ontario',6314.0,-79.93,46.37).
city('Sudbury','ca','Ontario',109724.0,-81.01,46.49).
city('Sutton','ca','Ontario',6680.0,-79.37,44.3).
city('Tavistock','ca','Ontario',2654.0,-80.83,43.32).
city('Teeswater','ca','Ontario',1171.0,-81.28,43.98).
city('Terrace Bay','ca','Ontario',2060.0,-87.1,48.78).
city('Thamesford','ca','Ontario',1846.0,-80.99,43.07).
city('Thessalon','ca','Ontario',1464.0,-83.55,46.25).
city('Thornbury','ca','Ontario',1970.0,-80.45,44.55).
city('Thunder Bay','ca','Ontario',99336.0,-89.28,48.42).
city('Tilbury','ca','Ontario',4858.0,-82.43,42.25).
city('Tilsonburg','ca','Ontario',14843.0,-80.73,42.87).
city('Timmins','ca','Ontario',32901.0,-81.35,48.49).
city('Toronto','ca','Ontario',4612187.0,-79.38,43.65).
city('Tottenham','ca','Ontario',5101.0,-79.8,44.02).
city('Tweed','ca','Ontario',1626.0,-77.3,44.47).
city('Uxbridge','ca','Ontario',9020.0,-79.12,44.1).
city('Valley East','ca','Ontario',17375.0,-81.01,46.64).
city('Vankleek Hill','ca','Ontario',2136.0,-74.65,45.52).
city('Vineland','ca','Ontario',2580.0,-79.49,43.16).
city('Walkerton','ca','Ontario',5250.0,-81.15,44.13).
city('Wallaceburg','ca','Ontario',10693.0,-82.39,42.59).
city('Wasaga Beach','ca','Ontario',7567.0,-79.99,44.53).
city('Waterford','ca','Ontario',3033.0,-80.28,42.93).
city('Watford','ca','Ontario',1716.0,-81.88,42.95).
city('Wawa','ca','Ontario',3463.0,-84.78,48.0).
city('Wellesley','ca','Ontario',1760.0,-80.76,43.47).
city('Wellington','ca','Ontario',2052.0,-77.35,43.95).
city('West Lorne','ca','Ontario',1540.0,-81.6,42.6).
city('Wheatley','ca','Ontario',2028.0,-82.45,42.1).
city('Whitchurch-Stouffville','ca','Ontario',11696.0,-79.25,43.97).
city('Wiarton','ca','Ontario',2481.0,-81.13,44.73).
city('Wikwemikong','ca','Ontario',1428.0,-81.71,45.8).
city('Winchester','ca','Ontario',2564.0,-75.35,45.1).
city('Windsor','ca','Ontario',278013.0,-83.03,42.3).
city('Wingham','ca','Ontario',3047.0,-81.3,43.88).
city('Woodstock','ca','Ontario',33893.0,-80.76,43.13).
city('Wyoming','ca','Ontario',2324.0,-82.12,42.95).
city('Alberton','ca','Prince Edward Island',1147.0,-64.07,46.8).
city('Charlottetown','ca','Prince Edward Island',42403.0,-63.14,46.24).
city('Cornwall','ca','Prince Edward Island',2272.0,-63.22,46.23).
city('Kensington','ca','Prince Edward Island',1424.0,-63.65,46.43).
city('Montague','ca','Prince Edward Island',2005.0,-62.65,46.17).
city('Souris','ca','Prince Edward Island',1284.0,-62.25,46.35).
city('Summerside','ca','Prince Edward Island',14808.0,-63.8,46.4).
city('Acton Vale','ca','Quebec',5135.0,-72.57,45.63).
city('Albanel','ca','Quebec',1087.0,-72.42,48.87).
city('Alencon','ca','Quebec',1422.0,-73.13,46.07).
city('Alma','ca','Quebec',29527.0,-71.66,48.55).
city('Amos','ca','Quebec',10435.0,-78.14,48.57).
city('Amqui','ca','Quebec',5117.0,-67.43,48.47).
city('Asbestos','ca','Quebec',7190.0,-71.95,45.78).
city('Bagotville','ca','Quebec',1081.0,-70.88,48.35).
city('Baie-Comeau','ca','Quebec',10435.0,-68.16,49.22).
city('Baie-Saint-Paul','ca','Quebec',4512.0,-70.5,47.43).
city('Barraute','ca','Quebec',1180.0,-77.63,48.43).
city('Beauceville','ca','Quebec',4480.0,-70.77,46.2).
city('Beaupre','ca','Quebec',5287.0,-70.88,47.05).
city('Bedford','ca','Quebec',2711.0,-72.98,45.12).
city('Beloeil','ca','Quebec',43016.0,-73.23,45.55).
city('Bernierville','ca','Quebec',1381.0,-71.54,46.1).
city('Berthierville','ca','Quebec',4411.0,-73.17,46.08).
city('Betsiamites','ca','Quebec',1652.0,-68.65,48.95).
city('Bonaventure','ca','Quebec',1480.0,-65.47,48.05).
city('Bromont','ca','Quebec',1042.0,-72.65,45.28).
city('Brownsburg','ca','Quebec',2597.0,-74.4,45.68).
city('Buckingham','ca','Quebec',21373.0,-75.42,45.58).
city('Cabano','ca','Quebec',2710.0,-68.88,47.68).
city('Cap-Chat','ca','Quebec',1466.0,-66.68,49.08).
city('Cap-aux-Meules','ca','Quebec',1686.0,-61.87,47.38).
city('Carleton','ca','Quebec',1094.0,-66.1,48.1).
city('Causapscal','ca','Quebec',2033.0,-67.22,48.35).
city('Chandler','ca','Quebec',2863.0,-64.67,48.33).
city('Chapais','ca','Quebec',1824.0,-74.87,49.78).
city('Chateau-Richer','ca','Quebec',1954.0,-96.45,49.65).
city('Chibougamou','ca','Quebec',7611.0,-74.35,49.87).
city('Chicoutimi-Jonquiere','ca','Quebec',110191.0,-71.08,48.43).
city('Chisasibi','ca','Quebec',3524.0,-78.94,53.79).
city('Chute-aux-Outardes','ca','Quebec',2000.0,-68.38,49.12).
city('Clermont','ca','Quebec',2912.0,-70.23,47.68).
city('Coaticook','ca','Quebec',7021.0,-71.8,45.13).
city('Coleraine','ca','Quebec',1319.0,-71.38,45.96).
city('Contrecoeur','ca','Quebec',3587.0,-73.21,45.89).
city('Cookshire','ca','Quebec',1568.0,-71.62,45.42).
city('Cowansville','ca','Quebec',10888.0,-72.75,45.21).
city('Crabtree','ca','Quebec',2248.0,-73.47,45.97).
city('Danville','ca','Quebec',1761.0,-72.02,45.78).
city('Daveluyville','ca','Quebec',1318.0,-72.15,46.21).
city('Degelis','ca','Quebec',2263.0,-68.65,47.56).
city('Desbiens','ca','Quebec',1147.0,-71.95,48.42).
city('Disraeli','ca','Quebec',2678.0,-71.35,45.9).
city('Dolbeau','ca','Quebec',12916.0,-72.23,48.87).
city('Donnacona','ca','Quebec',8014.0,-71.73,46.67).
city('Drummondville','ca','Quebec',59489.0,-72.49,45.89).
city('East Angus','ca','Quebec',3634.0,-71.67,45.48).
city('East Broughton','ca','Quebec',2406.0,-71.08,46.22).
city('Farnham','ca','Quebec',6061.0,-72.97,45.28).
city('Ferme-Neuve','ca','Quebec',2115.0,-75.45,46.7).
city('Fermont','ca','Quebec',2966.0,-67.06,52.79).
city('Filion','ca','Quebec',1207.0,-74.1,45.81).
city('Forestville','ca','Quebec',3570.0,-69.07,48.73).
city('Fort-Coulonge','ca','Quebec',2911.0,-76.75,45.85).
city('Gaspe','ca','Quebec',3331.0,-64.51,48.82).
city('Gentilly','ca','Quebec',2113.0,-72.45,46.35).
city('Granby','ca','Quebec',53979.0,-72.73,45.41).
city('Grande-Riviere','ca','Quebec',1508.0,-64.5,48.38).
city('Hauterive','ca','Quebec',12816.0,-68.27,49.18).
city('Havre-Saint-Pierre','ca','Quebec',2966.0,-63.58,50.25).
city('Hebertville','ca','Quebec',1691.0,-71.68,48.4).
city('Huntingdon','ca','Quebec',2865.0,-74.18,45.08).
city('Joliette','ca','Quebec',34772.0,-73.45,46.03).
city('Kingsey Falls','ca','Quebec',1480.0,-72.08,45.85).
city('LAnnonciation','ca','Quebec',2017.0,-74.87,46.4).
city('LAscension-de-Notre-Seigneur','ca','Quebec',1759.0,-71.67,48.68).
city('LEpiphanie','ca','Quebec',4569.0,-73.48,45.85).
city('La Malbaie','ca','Quebec',4447.0,-70.17,47.65).
city('La Pocatiere','ca','Quebec',4220.0,-70.01,47.4).
city('La Sarre','ca','Quebec',7206.0,-79.2,48.8).
city('La Tuque','ca','Quebec',9503.0,-72.78,47.44).
city('Labelle','ca','Quebec',1239.0,-74.73,46.28).
city('Lac-Etchemin','ca','Quebec',2313.0,-70.5,46.4).
city('Lac-Lapierre','ca','Quebec',2261.0,-73.77,45.82).
city('Lac-Megantic','ca','Quebec',4658.0,-70.88,45.58).
city('Lac-au-Saumon','ca','Quebec',1198.0,-67.33,48.42).
city('Lachute','ca','Quebec',9562.0,-74.35,45.65).
city('Lacolle','ca','Quebec',1528.0,-73.37,45.08).
city('Laurentides','ca','Quebec',4922.0,-73.77,45.85).
city('Laurier-Station','ca','Quebec',2415.0,-71.63,46.54).
city('Lavaltrie','ca','Quebec',8762.0,-73.29,45.89).
city('Le Bic','ca','Quebec',1281.0,-68.72,48.37).
city('Lebel-sur-Quevillon','ca','Quebec',3289.0,-76.99,49.07).
city('Les Cedres','ca','Quebec',1434.0,-74.06,45.32).
city('Les Coteaux','ca','Quebec',10622.0,-74.22,45.3).
city('Les Escoumins','ca','Quebec',2042.0,-69.42,48.35).
city('Liniere','ca','Quebec',2167.0,-70.52,46.05).
city('Louiseville','ca','Quebec',5819.0,-72.93,46.25).
city('Luceville','ca','Quebec',1373.0,-68.33,48.52).
city('Macamic','ca','Quebec',1559.0,-79.0,48.77).
city('Magog','ca','Quebec',15550.0,-72.14,45.26).
city('Malartic','ca','Quebec',3710.0,-78.12,48.13).
city('Maniwaki','ca','Quebec',4236.0,-75.97,46.37).
city('Marieville','ca','Quebec',5600.0,-73.17,45.43).
city('Maskinonge','ca','Quebec',1105.0,-73.02,46.22).
city('Matagami','ca','Quebec',1966.0,-77.63,49.75).
city('Matane','ca','Quebec',11826.0,-67.53,48.85).
city('Metabetchouan','ca','Quebec',2329.0,-71.87,48.43).
city('Mistissini','ca','Quebec',1844.0,-72.2,48.9).
city('Mont-Joli','ca','Quebec',6124.0,-68.18,48.58).
city('Mont-Laurier','ca','Quebec',6149.0,-65.75,46.55).
city('Montmagny','ca','Quebec',9645.0,-70.55,46.97).
city('Montreal','ca','Quebec',3268513.0,-73.57,45.52).
city('Murdochville','ca','Quebec',1139.0,-65.52,48.97).
city('Napierville','ca','Quebec',3124.0,-73.4,45.18).
city('New Richmond','ca','Quebec',2213.0,-65.83,48.17).
city('Nicolet','ca','Quebec',5257.0,-72.6,46.22).
city('Normandin','ca','Quebec',2728.0,-72.52,48.83).
city('Notre-Dame-du-Bon-Conseil','ca','Quebec',1477.0,-72.34,46.0).
city('Notre-Dame-du-Lac','ca','Quebec',1545.0,-68.8,47.6).
city('Oka-Kanesatake','ca','Quebec',1160.0,-74.08,45.47).
city('Ormstown','ca','Quebec',1562.0,-74.0,45.13).
city('Papineauville','ca','Quebec',1600.0,-75.02,45.62).
city('Pierreville','ca','Quebec',2172.0,-72.8,46.07).
city('Plessisville','ca','Quebec',7186.0,-71.77,46.22).
city('Pont-Rouge','ca','Quebec',4978.0,-71.7,46.75).
city('Port-Alfred-Bagotville','ca','Quebec',15428.0,-70.88,48.33).
city('Port-Cartier','ca','Quebec',5851.0,-66.86,50.04).
city('Portneuf','ca','Quebec',2694.0,-71.88,46.68).
city('Price','ca','Quebec',1830.0,-68.12,48.6).
city('Princeville','ca','Quebec',4041.0,-71.88,46.17).
city('Quebec','ca','Quebec',645623.0,-71.23,46.82).
city('Rawdon','ca','Quebec',4978.0,-73.7,46.03).
city('Richmond','ca','Quebec',3485.0,-72.15,45.67).
city('Rigaud','ca','Quebec',2525.0,-74.3,45.47).
city('Rimouski','ca','Quebec',38420.0,-68.54,48.44).
city('Riviere-au-Renard','ca','Quebec',2565.0,-64.38,48.98).
city('Riviere-du-Loup','ca','Quebec',15219.0,-69.54,47.84).
city('Roberval','ca','Quebec',9287.0,-72.24,48.52).
city('Rougemont','ca','Quebec',1183.0,-73.05,45.43).
city('Rouyn-Noranda','ca','Quebec',24023.0,-79.03,48.24).
city('Saint-Agapit','ca','Quebec',2048.0,-71.43,46.57).
city('Saint-Alexandre','ca','Quebec',1139.0,-69.63,47.68).
city('Saint-Alexis-des-Monts','ca','Quebec',2015.0,-73.16,46.46).
city('Saint-Ambroise','ca','Quebec',2015.0,-71.32,48.55).
city('Saint-Andre-Avellin','ca','Quebec',1868.0,-75.05,45.72).
city('Saint-Anselme','ca','Quebec',1861.0,-70.97,46.62).
city('Saint-Apollinaire','ca','Quebec',2022.0,-71.5,46.62).
city('Saint-Augustin','ca','Quebec',3961.0,-58.65,51.23).
city('Saint-Basile-Sud','ca','Quebec',1276.0,-71.82,46.75).
city('Saint-Bruno','ca','Quebec',2928.0,-79.43,47.47).
city('Saint-Canut','ca','Quebec',3486.0,-74.07,45.72).
city('Saint-Cesaire','ca','Quebec',3175.0,-73.0,45.4).
city('Saint-Cyrill-de-Wendover','ca','Quebec',1279.0,-72.43,45.93).
city('Saint-Damase','ca','Quebec',1349.0,-73.01,45.53).
city('Saint-Damien-de-Buckland','ca','Quebec',1911.0,-70.67,46.64).
city('Saint-Denis','ca','Quebec',1067.0,-73.15,45.78).
city('Saint-Donat-de-Montcalm','ca','Quebec',1685.0,-74.22,46.32).
city('Saint-Ephrem-de-Tring','ca','Quebec',1427.0,-70.96,46.07).
city('Saint-Fabien','ca','Quebec',1157.0,-68.87,48.28).
city('Saint-Felicien','ca','Quebec',8088.0,-72.45,48.65).
city('Saint-Felix-de-Valois','ca','Quebec',3165.0,-73.42,46.17).
city('Saint-Gabriel','ca','Quebec',2901.0,-73.37,46.28).
city('Saint-Gedeon','ca','Quebec',1859.0,-71.78,48.48).
city('Saint-Georges','ca','Quebec',21416.0,-70.68,46.13).
city('Saint-Germain-de-Grantham','ca','Quebec',2145.0,-72.57,45.83).
city('Saint-Gregoire','ca','Quebec',1237.0,-72.52,46.27).
city('Saint-Henri-de-Levis','ca','Quebec',1380.0,-71.07,46.68).
city('Saint-Honore','ca','Quebec',1742.0,-69.13,47.72).
city('Saint-Hyacinthe','ca','Quebec',50327.0,-72.96,45.63).
city('Saint-Jacques','ca','Quebec',2985.0,-73.58,45.95).
city('Saint-Jean-Port-Joli','ca','Quebec',1929.0,-70.27,47.2).
city('Saint-Jean-de-Dieu','ca','Quebec',1161.0,-69.05,48.02).
city('Saint-Jean-sur-Richelieu','ca','Quebec',71613.0,-73.26,45.31).
city('Saint-Jerome','ca','Quebec',54948.0,-74.0,45.78).
city('Saint-Josephe-de-Beauce','ca','Quebec',3388.0,-70.87,46.3).
city('Saint-Josephe-de-Lanoraie','ca','Quebec',1922.0,-73.23,45.97).
city('Saint-Josephe-de-la-Riviere-Bleue','ca','Quebec',1208.0,-69.05,47.43).
city('Saint-Jovite','ca','Quebec',4020.0,-74.58,46.12).
city('Saint-Liboire','ca','Quebec',1405.0,-72.7,45.72).
city('Saint-Marc-des-Carrieres','ca','Quebec',2358.0,-72.03,46.68).
city('Saint-Martin','ca','Quebec',2110.0,-70.65,45.95).
city('Saint-Michel-des-Saints','ca','Quebec',1835.0,-73.92,46.67).
city('Saint-Pacome','ca','Quebec',1371.0,-69.95,47.42).
city('Saint-Pascal','ca','Quebec',2465.0,-69.82,47.52).
city('Saint-Pie','ca','Quebec',3034.0,-72.9,45.5).
city('Saint-Prosper','ca','Quebec',3095.0,-70.48,46.2).
city('Saint-Raphael','ca','Quebec',1276.0,-70.75,46.78).
city('Saint-Raymond','ca','Quebec',3570.0,-71.83,46.88).
city('Saint-Remi','ca','Quebec',4192.0,-73.6,45.25).
city('Saint-Roch-de-lAchigan','ca','Quebec',1038.0,-73.61,45.87).
city('Saint-Sauveur-des-Monts','ca','Quebec',4869.0,-74.17,45.9).
city('Saint-Tite','ca','Quebec',2456.0,-72.57,46.72).
city('Sainte-Adele','ca','Quebec',5467.0,-74.15,45.95).
city('Sainte-Agathe-des-Monts','ca','Quebec',5706.0,-74.28,46.03).
city('Sainte-Anne-des-Monts','ca','Quebec',5602.0,-66.48,49.12).
city('Sainte-Anne-des-Plaines','ca','Quebec',10680.0,-73.82,45.78).
city('Sainte-Claire','ca','Quebec',2565.0,-70.85,46.6).
city('Sainte-Julienne','ca','Quebec',3211.0,-73.72,45.97).
city('Sainte-Justine','ca','Quebec',1149.0,-70.34,46.41).
city('Sainte-Madeleine','ca','Quebec',2198.0,-73.1,46.6).
city('Sainte-Marie','ca','Quebec',8735.0,-71.02,46.43).
city('Sainte-Martine','ca','Quebec',2535.0,-73.8,45.23).
city('Sainte-Sophie','ca','Quebec',1634.0,-73.87,45.83).
city('Sainte-Thecle','ca','Quebec',1340.0,-72.5,46.8).
city('Salaberry-de-Valleyfield','ca','Quebec',38662.0,-74.14,45.26).
city('Sayabec','ca','Quebec',1702.0,-67.68,48.55).
city('Senneterre','ca','Quebec',3228.0,-77.25,48.4).
city('Sept-Iles','ca','Quebec',22582.0,-66.38,50.22).
city('Shawinigan','ca','Quebec',49161.0,-72.75,46.56).
city('Shawville','ca','Quebec',1608.0,-76.48,45.6).
city('Sherbrooke','ca','Quebec',129447.0,-71.9,45.4).
city('Sorel','ca','Quebec',33591.0,-73.14,46.05).
city('Temiscaming','ca','Quebec',1854.0,-79.08,46.72).
city('Thetford Mines','ca','Quebec',22007.0,-71.31,46.1).
city('Thurso','ca','Quebec',2476.0,-75.23,45.58).
city('Trois-Pistoles','ca','Quebec',3695.0,-69.17,48.12).
city('Trois-Rivieres','ca','Quebec',119693.0,-72.57,46.35).
city('Val-David','ca','Quebec',1211.0,-74.2,46.03).
city('Val-dOr','ca','Quebec',25382.0,-77.79,48.11).
city('Valcourt','ca','Quebec',2451.0,-72.32,45.48).
city('Vallee-Jonction','ca','Quebec',1216.0,-70.92,46.37).
city('Vercheres','ca','Quebec',4030.0,-73.35,45.77).
city('Victoriaville','ca','Quebec',34426.0,-71.96,46.06).
city('Ville-Marie','ca','Quebec',2831.0,-79.43,47.33).
city('Warwick','ca','Quebec',3340.0,-71.98,45.95).
city('Waterloo','ca','Quebec',4064.0,-72.52,45.35).
city('Weedon Centre','ca','Quebec',1205.0,-71.45,45.7).
city('Windsor','ca','Quebec',5408.0,-72.0,45.58).
city('Yamachiche','ca','Quebec',1255.0,-72.83,46.28).
city('Assiniboia','ca','Saskatchewan',2320.0,-105.98,49.62).
city('Biggar','ca','Saskatchewan',2068.0,-107.98,52.05).
city('Canora','ca','Saskatchewan',2055.0,-102.43,51.63).
city('Carlyle','ca','Saskatchewan',1177.0,-102.27,49.63).
city('Carnduff','ca','Saskatchewan',950.0,-101.78,49.17).
city('Caronport','ca','Saskatchewan',972.0,-105.82,50.45).
city('Carrot','ca','Saskatchewan',950.0,-103.58,53.28).
city('Dalmeny','ca','Saskatchewan',1504.0,-106.78,52.33).
city('Davidson','ca','Saskatchewan',967.0,-105.97,51.27).
city('Esterhazy','ca','Saskatchewan',2194.0,-102.08,50.65).
city('Estevan','ca','Saskatchewan',9904.0,-103.01,49.14).
city('Eston','ca','Saskatchewan',979.0,-108.75,51.15).
city('Foam Lake','ca','Saskatchewan',1138.0,-103.53,51.65).
city('Fort QuAppelle','ca','Saskatchewan',2040.0,-103.78,50.77).
city('Gravelbourg','ca','Saskatchewan',1109.0,-106.55,49.88).
city('Grenfell','ca','Saskatchewan',997.0,-102.92,50.42).
city('Gull Lake','ca','Saskatchewan',949.0,-108.48,50.1).
city('Hudson Bay','ca','Saskatchewan',1661.0,-102.38,52.85).
city('Humboldt','ca','Saskatchewan',4822.0,-105.12,52.2).
city('Indian Head','ca','Saskatchewan',1642.0,-103.67,50.53).
city('Kamsack','ca','Saskatchewan',1877.0,-101.9,51.57).
city('Kelvington','ca','Saskatchewan',941.0,-103.52,52.17).
city('Kerrobert','ca','Saskatchewan',1038.0,-109.13,51.92).
city('Kindersley','ca','Saskatchewan',4249.0,-109.13,51.47).
city('Kipling','ca','Saskatchewan',969.0,-102.63,50.1).
city('La Ronge','ca','Saskatchewan',3071.0,-105.3,55.1).
city('Langenburg','ca','Saskatchewan',1034.0,-101.7,50.83).
city('Langham','ca','Saskatchewan',1070.0,-106.97,52.37).
city('Lanigan','ca','Saskatchewan',1204.0,-105.03,51.85).
city('Lumsden','ca','Saskatchewan',1477.0,-104.87,50.65).
city('Macklin','ca','Saskatchewan',1257.0,-109.95,52.33).
city('Maple Creek','ca','Saskatchewan',2121.0,-109.47,49.92).
city('Martensville','ca','Saskatchewan',4078.0,-106.68,52.29).
city('Meadow Lake','ca','Saskatchewan',4281.0,-108.43,54.13).
city('Melfort','ca','Saskatchewan',5410.0,-104.61,52.86).
city('Melville','ca','Saskatchewan',4279.0,-102.81,50.94).
city('Moose Jaw','ca','Saskatchewan',32166.0,-105.54,50.39).
city('Moosomin','ca','Saskatchewan',2206.0,-101.67,50.15).
city('Nipawin','ca','Saskatchewan',3994.0,-104.02,53.37).
city('North Battleford','ca','Saskatchewan',19440.0,-108.29,52.79).
city('Outlook','ca','Saskatchewan',1989.0,-107.05,51.5).
city('Oxbow','ca','Saskatchewan',1058.0,-102.17,49.22).
city('Pilot Butte','ca','Saskatchewan',1728.0,-104.42,50.47).
city('Preeceville','ca','Saskatchewan',1003.0,-102.67,51.95).
city('Prince Albert','ca','Saskatchewan',34608.0,-105.75,53.2).
city('Regina','ca','Saskatchewan',176182.0,-104.61,50.45).
city('Rosetown','ca','Saskatchewan',2309.0,-107.98,51.55).
city('Rosthem','ca','Saskatchewan',1405.0,-106.33,52.65).
city('Saskatoon','ca','Saskatchewan',198957.0,-106.66,52.15).
city('Shaunavon','ca','Saskatchewan',1658.0,-108.42,49.65).
city('Shellbrook','ca','Saskatchewan',1192.0,-106.4,53.22).
city('Swift Current','ca','Saskatchewan',14702.0,-107.8,50.3).
city('Tisdale','ca','Saskatchewan',2862.0,-104.05,52.82).
city('Unity','ca','Saskatchewan',2096.0,-109.17,52.43).
city('Wadena','ca','Saskatchewan',1319.0,-103.8,51.95).
city('Warman','ca','Saskatchewan',3252.0,-106.57,52.32).
city('Watrous','ca','Saskatchewan',1689.0,-105.47,51.67).
city('Weyburn','ca','Saskatchewan',9362.0,-103.86,49.67).
city('White City','ca','Saskatchewan',1813.0,-104.35,50.44).
city('Wilkie','ca','Saskatche',1198.0,-108.7,52.42).
city('Wynyard','ca','Saskatchewan',1793.0,-104.18,51.77).
city('Yorkton','ca','Saskatchewan',15172.0,-102.47,51.21).
city('Haines Junction','ca','Yukon',1148.0,-137.51,60.76).
city('Mayo','ca','Yukon',540.0,-135.89,63.6).
city('Whitehorse','ca','Yukon',19616.0,-135.05,60.73).
city('Sal Rei','cv','Boavista',2089.0,-22.92,16.18).
city('Nova Sintra','cv','Brava',1844.0,-24.72,14.81).
city('Mosteiros','cv','Fogo',470.0,-24.33,15.03).
city('Sao Filipe','cv','Fogo',8063.0,-24.51,14.9).
city('Vila do Maio','cv','Maio',2962.0,-23.22,15.14).
city('Santa Maria','cv','Sal',16967.0,-22.92,16.6).
city('Pombas','cv','Santo Antao',1790.0,-25.03,17.15).
city('Ponta do Sol','cv','Santo Antao',4001.0,-25.1,17.19).
city('Porto Novo','cv','Santo Antao',5494.0,-25.07,17.02).
city('Ribeira Brava','cv','Sao Nicolau',5242.0,-24.31,16.61).
city('Assomada','cv','Sao Tiago',7808.0,-23.69,15.09).
city('Pedra Badejo','cv','Sao Tiago',9345.0,-23.54,15.13).
city('Praia','cv','Sao Tiago',111611.0,-23.54,14.93).
city('Tarrafal','cv','Sao Tiago',6366.0,-23.76,15.28).
city('Mindelo','cv','Sao Vicente',69441.0,-24.99,16.89).
city('Bodden Town','ky','Grand Cayman',6514.0,-81.26,19.28).
city('George Town','ky','Grand Cayman',27340.0,-81.39,19.28).
city('West Bay','ky','Grand Cayman',10768.0,-81.42,19.38).
city('Ndele','cf','Bamingui-Bangoran',11941.0,20.64,8.42).
city('Bangui','cf','Bangui',684190.0,18.56,4.36).
city('Alindao','cf','Basse-Kotto',20125.0,21.21,5.05).
city('Kembe','cf','Basse-Kotto',22348.0,21.89,4.62).
city('Mobaye','cf','Basse-Kotto',24518.0,21.19,4.32).
city('Obo','cf','Haut-Mbomou',14038.0,26.49,5.39).
city('Zemio','cf','Haut-Mbomou',7453.0,25.14,5.03).
city('Bria','cf','Haute-Kotto',47190.0,21.99,6.54).
city('Ouadda','cf','Haute-Kotto',5901.0,22.4,8.07).
city('Dekoa','cf','Kemo',17390.0,19.08,6.32).
city('Sibut','cf','Kemo',32547.0,19.08,5.73).
city('Boda','cf','Lobaye',20621.0,17.47,4.32).
city('Mbaiki','cf','Lobaye',76350.0,18.0,3.87).
city('Mongoumba','cf','Lobaye',11663.0,18.6,3.64).
city('Berberati','cf','Mambere-Kadei',59963.0,15.78,4.25).
city('Carnot','cf','Mambere-Kadei',83761.0,15.87,4.93).
city('Gamboula','cf','Mambere-Kadei',8028.0,15.13,4.12).
city('Bangassou','cf','Mbomou',34720.0,22.82,4.74).
city('Gambo','cf','Mbomou',6210.0,22.25,4.65).
city('Ouango','cf','Mbomou',5453.0,22.55,4.31).
city('Rafai','cf','Mbomou',16814.0,23.92,4.97).
city('Kaga-Bandoro','cf','Nana-Gribizi',82722.0,19.18,6.98).
city('Baboua','cf','Nana-Mambere',9034.0,14.83,5.8).
city('Baoro','cf','Nana-Mambere',8937.0,15.97,5.67).
city('Bouar','cf','Nana-Mambere',55031.0,15.59,5.93).
city('Bimbo','cf','Ombella Mpoko',55849.0,18.54,4.3).
city('Boali','cf','Ombella Mpoko',4696.0,18.11,4.8).
city('Bossembele','cf','Ombella Mpoko',11518.0,17.65,5.27).
city('Damara','cf','Ombella Mpoko',16056.0,18.7,4.96).
city('Yakole','cf','Ombella Mpoko',8498.0,17.09,5.31).
city('Bambari','cf','Ouaka',54783.0,20.67,5.76).
city('Grimari','cf','Ouaka',16486.0,20.05,5.74).
city('Ippy','cf','Ouaka',24274.0,21.19,6.27).
city('Kouango','cf','Ouaka',9694.0,19.99,5.0).
city('Batangafo','cf','Ouham',19810.0,18.29,7.31).
city('Bossangoa','cf','Ouham',39607.0,17.46,6.5).
city('Bouca','cf','Ouham',19383.0,18.28,6.51).
city('Kabo','cf','Ouham',17683.0,18.62,7.65).
city('Bocaranga','cf','Ouham-Pende',14002.0,15.64,6.99).
city('Bozoum','cf','Ouham-Pende',36548.0,16.38,6.32).
city('Paoua','cf','Ouham-Pende',31595.0,16.43,7.25).
city('Nola','cf','Sangha-Mbaere',53270.0,16.04,3.52).
city('Birao','cf','Vakaga',11833.0,22.79,10.28).
city('Ati','td','Batha',24074.0,18.33,13.22).
city('Oum Hadjer','td','Batha',19271.0,19.68,13.31).
city('Biltine','td','Biltine',11000.0,20.92,14.54).
city('Aouzou','td','Bourkou-Ennedi-Tibesti',1880.0,17.45,21.81).
city('Faya','td','Bourkou-Ennedi-Tibesti',13400.0,19.12,17.94).
city('Bokoro','td','Chari-Baguirmi',14723.0,17.06,12.38).
city('Bousso','td','Chari-Baguirmi',13555.0,16.73,10.46).
city('Dourbali','td','Chari-Baguirmi',17682.0,15.86,11.8).
city('Massaguet','td','Chari-Baguirmi',17.0,15.44,12.47).
city('Massakory','td','Chari-Baguirmi',15406.0,15.74,12.99).
city('NDjamena','td','Chari-Baguirmi',721081.0,15.05,12.11).
city('Ngama','td','Chari-Baguirmi',12438.0,17.16,11.78).
city('Bitkine','td','Guera',18495.0,18.21,11.99).
city('Melfi','td','Guera',5784.0,17.94,11.06).
city('Mongo','td','Guera',27763.0,18.69,12.19).
city('Mao','td','Kanem',18031.0,15.31,14.12).
city('Moussoro','td','Kanem',15190.0,16.52,13.62).
city('Bol','td','Lac',10551.0,15.91,7.67).
city('Beinamar','td','Logone Occidental',7445.0,15.39,8.66).
city('Moundou','td','Logone Occidental',135167.0,16.09,8.55).
city('Baibokoum','td','Logone Oriental',6910.0,16.25,8.23).
city('Bebidjia','td','Logone Oriental',12671.0,16.57,8.67).
city('Beboto','td','Logone Oriental',5432.0,16.93,8.27).
city('Doba','td','Logone Oriental',24336.0,16.85,8.66).
city('Bongor','td','Mayo-Kebbi',27770.0,15.37,10.28).
city('Fianga','td','Mayo-Kebbi',13441.0,15.08,9.85).
city('Gounou Gaya','td','Mayo-Kebbi',9521.0,15.52,9.63).
city('Guelengdeng','td','Mayo-Kebbi',11379.0,15.55,10.91).
city('Lere','td','Mayo-Kebbi',17132.0,14.15,9.77).
city('Pala','td','Mayo-Kebbi',35466.0,14.9,9.36).
city('Goundi','td','Moyen-Chari',10052.0,17.37,9.36).
city('Koumra','td','Moyen-Chari',36263.0,17.55,8.91).
city('Kyabe','td','Moyen-Chari',16177.0,18.94,9.45).
city('Moissala','td','Moyen-Chari',11264.0,17.77,8.34).
city('Sarh','td','Moyen-Chari',102528.0,18.39,9.15).
city('Abeche','td','Ouaddai',74188.0,20.83,13.84).
city('Adre','td','Ouaddai',11928.0,22.2,13.47).
city('Am Timan','td','Salamat',28885.0,20.28,11.05).
city('Benoy','td','Tandjile',15717.0,16.32,8.99).
city('Bere','td','Tandjile',14666.0,16.16,9.32).
city('Kelo','td','Tandjile',42533.0,15.81,9.31).
city('Lai','td','Tandjile',19382.0,16.3,9.39).
city('Coihaique','cl','Aisen',45788.0,-72.07,-45.57).
city('Antofagasta','cl','Antofagasta',309835.0,-70.39,-23.65).
city('Calama','cl','Antofagasta',143085.0,-68.92,-22.45).
city('Taltal','cl','Antofagasta',10018.0,-70.47,-25.4).
city('Tocopilla','cl','Antofagasta',24461.0,-70.19,-22.09).
city('Angol','cl','Araucania',44856.0,-72.71,-37.79).
city('Carahue','cl','Araucania',11875.0,-73.17,-38.71).
city('Collipulli','cl','Araucania',16392.0,-72.43,-37.96).
city('Freire','cl','Araucania',7813.0,-72.63,-38.96).
city('Lautaro','cl','Araucania',21579.0,-72.44,-38.53).
city('Loncoche','cl','Araucania',15590.0,-72.63,-39.37).
city('Nueva Imperial','cl','Araucania',18777.0,-72.96,-38.74).
city('Pitrufquen','cl','Araucania',13743.0,-72.65,-38.98).
city('Temuco','cl','Arauca',238131.0,-72.58,-38.73).
city('Traiguen','cl','Araucania',14481.0,-72.68,-38.25).
city('Victoria','cl','Araucania',24555.0,-72.34,-38.24).
city('Vilcun','cl','Araucania',9241.0,-72.23,-38.67).
city('Villarrica','cl','Araucania',31603.0,-72.23,-39.28).
city('Copiapo','cl','Atacama',129281.0,-70.34,-27.36).
city('Diego de Almagro','cl','Atacama',18137.0,-70.05,-26.37).
city('Vallenar','cl','Atacama',44895.0,-70.76,-28.57).
city('Arauco','cl','Bio Bio',24659.0,-73.32,-37.25).
city('Bulnes','cl','Bio Bio',12715.0,-72.3,-36.74).
city('Cabrero','cl','Bio Bio',18327.0,-72.41,-37.04).
city('Canete','cl','Bio Bio',20158.0,-73.4,-37.81).
city('Chiguayante','cl','Bio Bio',82545.0,-73.04,-36.9).
city('Chillan','cl','Bio Bio',150396.0,-72.11,-36.6).
city('Coihueco','cl','Bio Bio',7346.0,-71.83,-36.63).
city('Concepcion','cl','Bio Bio',215414.0,-73.05,-36.83).
city('Coronel','cl','Bio Bio',92941.0,-73.16,-37.03).
city('Curanilahue','cl','Bio Bio',30611.0,-73.34,-37.48).
city('Laja','cl','Bio Bio',16550.0,-72.71,-37.28).
city('Lebu','cl','Bio Bio',22345.0,-73.65,-37.61).
city('Los Angeles','cl','Bio Bio',125431.0,-72.36,-37.46).
city('Lota','cl','Bio Bio',49763.0,-73.16,-37.09).
city('Mulchen','cl','Bio Bio',22170.0,-72.25,-37.72).
city('Nacimiento','cl','Bio Bio',21220.0,-72.68,-37.5).
city('Penco','cl','Bio Bio',46091.0,-73.0,-36.73).
city('San Carlos','cl','Bio Bio',31517.0,-71.96,-36.42).
city('Talcahuano','cl','Bio Bio',252969.0,-73.13,-36.74).
city('Tome','cl','Bio Bio',46698.0,-72.96,-36.61).
city('Yumbel','cl','Bio Bio',11111.0,-72.56,-37.1).
city('Coquimbo','cl','Coquimbo',161319.0,-71.33,-29.96).
city('Illapel','cl','Coquimbo',22816.0,-71.17,-31.63).
city('La Serena','cl','Coquimbo',154523.0,-71.25,-29.9).
city('Monte Patria','cl','Coquimbo',13945.0,-70.96,-30.69).
city('Ovalle','cl','Coquimbo',77139.0,-71.2,-30.59).
city('Salamanca','cl','Coquimbo',13265.0,-70.98,-31.78).
city('Vicuna','cl','Coquimbo',13496.0,-70.74,-30.03).
city('Chimbarongo','cl','Libertador General Bernardo OHiggins',17356.0,-71.05,-34.71).
city('Graneros','cl','Libertador General Bernardo OHiggins',23301.0,-70.72,-34.07).
city('Machali','cl','Libertador General Bernardo OHiggins',27595.0,-70.67,-34.18).
city('Rancagua','cl','Libertador General Bernardo OHiggins',212696.0,-70.74,-34.17).
city('Rengo','cl','Libertador General Bernardo OHiggins',38101.0,-70.87,-34.41).
city('San Fernando','cl','Libertador General Bernardo OHiggins',52551.0,-70.99,-34.58).
city('San Vicente','cl','Libertador General Bernardo OHiggins',22573.0,-71.08,-34.43).
city('Santa Cruz','cl','Libertador General Bernardo OHiggins',33283.0,-71.37,-34.63).
city('Ancud','cl','Los Lagos',28020.0,-73.83,-41.87).
city('Calbuco','cl','Los Lagos',12490.0,-73.14,-41.76).
city('Castro','cl','Los Lagos',29926.0,-73.77,-42.48).
city('La Union','cl','Los Lagos',26299.0,-73.09,-40.29).
city('Osorno','cl','Los Lagos',135774.0,-73.16,-40.57).
city('Panguipulli','cl','Los Lagos',16312.0,-72.34,-39.64).
city('Puerto Montt','cl','Los Lagos',160055.0,-72.94,-41.47).
city('Puerto Varas','cl','Los Lagos',24958.0,-72.99,-41.33).
city('Purranque','cl','Los Lagos',13619.0,-73.17,-40.91).
city('Rio Bueno','cl','Los Lagos',15456.0,-72.96,-40.34).
city('Valdivia','cl','Los Lagos',133420.0,-73.23,-39.82).
city('Punta Arenas','cl','Magellanes',117432.0,-70.93,-53.16).
city('Cauquenes','cl','Maule',31363.0,-72.32,-35.96).
city('Constitucion','cl','Maule',37917.0,-72.42,-35.33).
city('Curico','cl','Maule',102439.0,-71.24,-34.98).
city('Linares','cl','Maule',69536.0,-71.59,-35.84).
city('Longavi','cl','Maule',6325.0,-71.69,-35.97).
city('Molina','cl','Maule',28775.0,-71.28,-35.11).
city('Parral','cl','Maule',26905.0,-71.83,-36.14).
city('San Clemente','cl','Maule',13656.0,-71.49,-35.53).
city('San Javier','cl','Maule',22427.0,-71.74,-35.59).
city('Talca','cl','Maule',197480.0,-71.66,-35.42).
city('Teno','cl','Maule',6858.0,-71.16,-34.86).
city('Buin','cl','Metropolitana',55440.0,-70.75,-33.73).
city('Colina','cl','Metropolitana',65082.0,-70.77,-33.7).
city('El Monte','cl','Metropolitana',23090.0,-71.02,-33.68).
city('Lampa','cl','Metropolitana',29250.0,-70.9,-33.28).
city('Melipilla','cl','Metropolitana',63100.0,-71.22,-33.69).
city('Paine','cl','Metropolitana',32765.0,-70.75,-33.82).
city('Penaflor','cl','Metropolitana',65494.0,-70.92,-33.62).
city('Puento Alto','cl','Metropolitana',510412.0,-70.57,-33.61).
city('San Bernardo','cl','Metropolitana',249856.0,-70.7,-33.6).
city('Santiago','cl','Metropolitana',4837248.0,-70.64,-33.46).
city('Talagante','cl','Metropolitana',51763.0,-70.93,-33.66).
city('Arica','cl','Tarapaca',186000.0,-70.3,-18.49).
city('Iquique','cl','Tarapaca',227501.0,-70.14,-20.23).
city('Cabildo','cl','Valparaiso',12784.0,-71.07,-32.47).
city('Calera','cl','Valparaiso',49107.0,-71.19,-32.79).
city('La Ligua','cl','Valparaiso',24857.0,-71.24,-32.46).
city('Limache','cl','Valparaiso',35876.0,-71.27,-33.02).
city('Llaillay','cl','Valparaiso',16646.0,-70.95,-32.85).
city('Los Andes','cl','Valparaiso',56859.0,-70.6,-32.83).
city('Quillota','cl','Valparaiso',67779.0,-71.26,-32.88).
city('Quilpue','cl','Valparaiso',130264.0,-71.5,-33.04).
city('San Antonio','cl','Valparaiso',85651.0,-71.61,-33.6).
city('San Felipe','cl','Valparaiso',59294.0,-70.72,-32.75).
city('Valparaiso','cl','Valparaiso',282450.0,-71.64,-33.04).
city('Villa Alemana','cl','Valparaiso',97320.0,-71.36,-33.04).
city('Vina del Mar','cl','Valparaiso',294553.0,-71.55,-33.01).
city('Anqing','cn','Anhui',358661.0,117.05,30.5).
city('Bengbu','cn','Anhui',576648.0,117.33,32.95).
city('Bozhou','cn','Anhui',174140.0,115.76,33.87).
city('Chaohu','cn','Anhui',138463.0,117.87,31.6).
city('Chizhou','cn','Anhui',148375.0,117.48,30.65).
city('Chuzhou','cn','Anhui',280582.0,118.3,32.3).
city('Dangtu','cn','Anhui',60335.0,118.49,31.55).
city('Datong','cn','Anhui',61085.0,117.05,32.64).
city('Fuyang','cn','Anhui',170023.0,115.82,32.9).
city('Hefei','cn','Anhui',1388904.0,117.28,31.85).
city('Huaibei','cn','Anhui',903039.0,116.75,33.95).
city('Huainan','cn','Anhui',1027655.0,116.98,32.63).
city('Huaiyuan','cn','Anhui',65530.0,117.19,32.96).
city('Huoqiu','cn','Anhui',61904.0,116.26,32.34).
city('Jieshou','cn','Anhui',141993.0,115.35,33.25).
city('Luan','cn','Anhui',179665.0,116.48,31.75).
city('Lujiang','cn','Anhui',89119.0,117.27,31.24).
city('Maanshan','cn','Anhui',540198.0,118.48,31.73).
city('Mengcheng','cn','Anhui',69916.0,116.55,33.27).
city('Mingguang','cn','Anhui',68351.0,117.98,32.77).
city('Suixi','cn','Anhui',74172.0,116.77,33.92).
city('Suzhou','cn','Anhui',205130.0,117.0,33.64).
city('Tangzhai','cn','Anhui',67936.0,116.6,34.43).
city('Tongling','cn','Anhui',312588.0,117.78,30.95).
city('Tunxi','cn','Anhui',77000.0,118.3,29.71).
city('Woyang','cn','Anhui',79070.0,116.23,31.99).
city('Wucheng','cn','Anhui',60212.0,118.18,29.58).
city('Wuhu','cn','Anhui',507524.0,118.37,31.35).
city('Xuanzhou','cn','Anhui',127758.0,118.74,30.94).
city('Yingshang','cn','Anhui',61771.0,116.25,32.64).
city('Aomen','cn','Aomen',478947.0,113.56,22.27).
city('Beibei','cn','Chongqing',112019.0,106.44,29.83).
city('Chongqing','cn','Chongqing',3967028.0,106.58,29.57).
city('Fuling','cn','Chongqing',166507.0,107.35,29.72).
city('Heyang','cn','Chongqing',97575.0,106.27,30.0).
city('Jijiang','cn','Chongqing',61161.0,106.22,29.27).
city('Longhua','cn','Chongqing',65565.0,107.09,29.17).
city('Wanxian','cn','Chongqing',188980.0,108.4,30.82).
city('Yongchang','cn','Chongqing',94465.0,105.88,29.36).
city('Yudong','cn','Chongqing',81408.0,106.5,29.39).
city('Bantou','cn','Fujian',118557.0,118.68,25.37).
city('Dongshan','cn','Fujian',72350.0,117.5,23.74).
city('Fuzhou','cn','Fujian',1179720.0,119.3,26.08).
city('Gantou','cn','Fujian',80721.0,119.53,26.2).
city('Hanyang','cn','Fujian',71053.0,119.64,27.09).
city('Jiangkou','cn','Fujian',59902.0,119.2,25.48).
city('Jiaocheng','cn','Fujian',65170.0,119.53,26.66).
city('Longyan','cn','Fujian',125778.0,117.03,25.18).
city('Luoyang','cn','Fujian',66188.0,118.7,24.96).
city('Nanping','cn','Fujian',171674.0,118.17,26.63).
city('Nanpu','cn','Fujian',59832.0,118.53,27.92).
city('Putian','cn','Fujian',376558.0,119.02,25.43).
city('Qingyang','cn','Fujian',89623.0,118.57,24.82).
city('Quanzhou','cn','Fujian',184143.0,118.58,24.9).
city('Rongcheng','cn','Fujian',67397.0,119.38,25.72).
city('Sanming','cn','Fujian',209444.0,117.58,26.23).
city('Shaowu','cn','Fujian',112585.0,117.5,27.3).
city('Shima','cn','Fujian',68375.0,117.81,24.45).
city('Tantou','cn','Fujian',69050.0,119.6,26.03).
city('Tongshan','cn','Fujian',63250.0,120.21,27.31).
city('Xiamen','cn','Fujian',578337.0,118.08,24.45).
city('Ximei','cn','Fujian',94326.0,118.38,24.95).
city('Yongan','cn','Fujian',134858.0,117.35,25.98).
city('Zhangzhou','cn','Fujian',589831.0,117.67,24.52).
city('Zhicheng','cn','Fujian',59187.0,118.31,27.05).
city('Baiyin','cn','Gansu',188533.0,104.2,36.53).
city('Baoji','cn','Gansu',86278.0,104.2,36.55).
city('Beidao','cn','Gansu',74767.0,105.89,34.57).
city('Jiayuguan','cn','Gansu',122396.0,98.3,39.82).
city('Jinchang','cn','Gansu',144363.0,102.17,38.47).
city('Jiuquan','cn','Gansu',72732.0,98.51,39.75).
city('Lanzhou','cn','Gansu',1417742.0,103.68,36.05).
city('Linxia','cn','Gansu',202402.0,103.21,35.61).
city('Pingliang','cn','Gansu',108156.0,106.68,35.53).
city('Qincheng','cn','Gansu',175852.0,105.92,34.6).
city('Wuwei','cn','Gansu',109319.0,102.8,37.97).
city('Yumen','cn','Gansu',84769.0,97.73,39.83).
city('Zhangye','cn','Gansu',96228.0,100.45,38.93).
city('Anbu','cn','Guangdong',162964.0,116.68,23.46).
city('Chaozhou','cn','Guangdong',424787.0,116.64,23.67).
city('Chenghai','cn','Guangdong',152453.0,116.77,23.47).
city('Chuncheng','cn','Guangdong',153547.0,111.78,22.18).
city('Daliang','cn','Guangdong',210411.0,113.25,22.84).
city('Danshui','cn','Guangdong',126701.0,114.46,22.8).
city('Dongguan','cn','Guangdong',390219.0,113.73,23.05).
city('Donghai','cn','Guangdong',188602.0,115.63,22.95).
city('Dongli','cn','Guangdong',110107.0,110.37,20.84).
city('Dongzhen','cn','Guangdong',98259.0,110.94,22.36).
city('Ducheng','cn','Guangdong',95525.0,111.52,23.25).
city('Encheng','cn','Guangdong',110921.0,112.3,22.19).
city('Foshan','cn','Guangdong',627348.0,113.12,23.03).
city('Gaozhou','cn','Guangdong',166069.0,110.84,21.93).
city('Guangzhou','cn','Guangdong',3152825.0,113.25,23.12).
city('Guanjiao','cn','Guangdong',93519.0,112.97,22.96).
city('Haicheng','cn','Guangdong',130386.0,115.33,22.98).
city('Haimen','cn','Guangdong',125427.0,116.61,23.2).
city('Hepo','cn','Guangdong',131238.0,115.83,23.44).
city('Huaicheng','cn','Guangdong',89294.0,112.18,23.91).
city('Huanggang','cn','Guangdong',225956.0,117.0,23.68).
city('Huangpu','cn','Guangdong',116307.0,113.42,23.1).
city('Huazhou','cn','Guangdong',91701.0,110.62,21.65).
city('Huicheng','cn','Guangdong',160524.0,114.65,22.78).
city('Huizhou','cn','Guangdong',289201.0,114.4,23.08).
city('Humen','cn','Guangdong',191891.0,113.66,22.86).
city('Jiangmen','cn','Guangdong',532419.0,113.08,22.58).
city('Jiazi','cn','Guangdong',130298.0,116.05,22.88).
city('Jieshi','cn','Guangdong',137444.0,115.82,22.82).
city('Lecheng','cn','Guangdong',124268.0,113.35,25.14).
city('Leicheng','cn','Guangdong',118891.0,113.35,25.13).
city('Liancheng','cn','Guangdong',100341.0,110.28,21.62).
city('Lianzhou','cn','Guangdong',92827.0,112.36,24.79).
city('Licheng','cn','Guangdong',172775.0,113.82,23.3).
city('Liusha','cn','Guangdong',118023.0,116.15,23.3).
city('Lubu','cn','Guangdong',95820.0,112.28,23.18).
city('Luocheng','cn','Guangdong',94071.0,111.56,22.77).
city('Luoyang','cn','Guangdong',123144.0,114.28,23.17).
city('Maba','cn','Guangdong',113609.0,113.58,24.68).
city('Maoming','cn','Guangdong',473251.0,110.87,21.92).
city('Mata','cn','Guangdong',81166.0,111.33,21.5).
city('Meilu','cn','Guangdong',104168.0,110.75,21.46).
city('Meizhou','cn','Guangdong',144212.0,116.12,24.33).
city('Mianchang','cn','Guangdong',320737.0,116.59,23.26).
city('Nanfeng','cn','Guangdong',86129.0,111.79,23.76).
city('Pingshan','cn','Guangdong',113631.0,114.68,22.99).
city('Qingtang','cn','Guangdong',88006.0,113.85,24.21).
city('Qingyuan','cn','Guangdong',151287.0,113.02,23.72).
city('Rongcheng','cn','Guangdong',1001985.0,116.34,23.54).
city('Sanbu','cn','Guangdong',140454.0,112.76,22.46).
city('Shantou','cn','Guangdong',1333973.0,116.67,23.37).
city('Shanwei','cn','Guangdong',165699.0,115.35,22.78).
city('Shaoguan','cn','Guangdong',628749.0,113.58,24.8).
city('Shaping','cn','Guangdong',107589.0,112.96,22.77).
city('Shenzhen','cn','Guangdong',1002592.0,114.13,22.53).
city('Shilong','cn','Guangdong',109733.0,113.83,23.11).
city('Shiqiao','cn','Guangdong',135308.0,113.36,22.94).
city('Shiwan','cn','Guangdong',82031.0,113.07,23.0).
city('Shuizhai','cn','Guangdong',81600.0,115.6,23.98).
city('Suicheng','cn','Guangdong',79141.0,110.24,21.39).
city('Taicheng','cn','Guangdong',145440.0,112.77,22.26).
city('Tangping','cn','Guangdong',81729.0,111.93,22.02).
city('Xiaolan','cn','Guangdong',187865.0,113.28,22.78).
city('Xinan','cn','Guangdong',153714.0,112.89,23.17).
city('Xingcheng','cn','Guangdong',106338.0,115.73,24.15).
city('Xiongzhou','cn','Guangdong',79050.0,114.3,25.12).
city('Xucheng','cn','Guangdong',83267.0,110.16,20.33).
city('Yangjiang','cn','Guangdong',399735.0,111.97,21.85).
city('Yingcheng','cn','Guangdong',115538.0,113.4,24.18).
city('Yuancheng','cn','Guangdong',93718.0,114.68,23.73).
city('Yuncheng','cn','Guangdong',96192.0,112.03,22.94).
city('Zhanjiang','cn','Guangdong',637790.0,110.38,21.2).
city('Zhaoqing','cn','Guangdong',361969.0,112.45,23.05).
city('Zhongshan','cn','Guangdong',342306.0,113.35,22.53).
city('Zhuhai','cn','Guangdong',501199.0,113.57,22.28).
city('Babu','cn','Guangxi',65603.0,111.52,24.41).
city('Baihe','cn','Guangxi',63629.0,107.22,22.15).
city('Beihai','cn','Guangxi',289568.0,109.1,21.48).
city('Binzhou','cn','Guangxi',70013.0,108.8,23.22).
city('Bose','cn','Guangxi',90603.0,106.62,23.91).
city('Guicheng','cn','Guangxi',76430.0,109.59,23.1).
city('Guilin','cn','Guangxi',649352.0,110.28,25.28).
city('Heshan','cn','Guangxi',47684.0,108.89,23.83).
city('Jinchengjiang','cn','Guangxi',104138.0,107.83,24.7).
city('Jinji','cn','Guangxi',56816.0,110.82,23.23).
city('Laibin','cn','Guangxi',59835.0,109.27,23.7).
city('Lianzhou','cn','Guangxi',71423.0,109.19,21.68).
city('Liuzhou','cn','Guangxi',763168.0,109.25,24.28).
city('Luorong','cn','Guangxi',67593.0,109.61,24.41).
city('Matong','cn','Guangxi',71066.0,110.07,23.4).
city('Nandu','cn','Guangxi',61881.0,110.83,22.85).
city('Nanning','cn','Guangxi',803788.0,108.32,22.82).
city('Pingnan','cn','Guangxi',62483.0,110.39,23.55).
city('Pumiao','cn','Guangxi',61690.0,108.49,22.76).
city('Qinzhou','cn','Guangxi',100996.0,108.62,21.95).
city('Songhua','cn','Guangxi',54848.0,110.35,22.72).
city('Wuzhou','cn','Guangxi',265846.0,111.32,23.48).
city('Yashan','cn','Guangxi',56629.0,109.93,22.2).
city('Yulin','cn','Guangxi',148485.0,110.14,22.64).
city('Anshun','cn','Guizhou',351936.0,105.93,26.25).
city('Bijie','cn','Guizhou',77645.0,105.28,27.31).
city('Caohai','cn','Guizhou',56744.0,104.28,26.86).
city('Duyun','cn','Guizhou',91136.0,107.52,26.27).
city('Guiyang','cn','Guizhou',1171633.0,106.72,26.58).
city('Kaili','cn','Guizhou',151956.0,107.92,26.58).
city('Liupanshui','cn','Guizhou',167740.0,104.86,26.58).
city('Tongren','cn','Guizhou',90593.0,109.13,27.68).
city('Tongzi','cn','Guizhou',80344.0,106.81,28.14).
city('Xiaoweizhai','cn','Guizhou',58913.0,107.53,26.23).
city('Xingyi','cn','Guizhou',119000.0,104.89,25.09).
city('Zunyi','cn','Guizhou',466292.0,106.92,27.7).
city('Chengmai','cn','Hainan',68720.0,110.01,19.74).
city('Haikou','cn','Hainan',615835.0,110.32,20.05).
city('Lingao','cn','Hainan',64874.0,109.68,19.91).
city('Qiongshan','cn','Hainan',87657.0,110.35,20.0).
city('Sanya','cn','Hainan',144753.0,109.48,18.23).
city('Wanning','cn','Hainan',64954.0,110.39,18.8).
city('Baoding','cn','Hebei',995652.0,115.48,38.87).
city('Botou','cn','Hebei',63045.0,116.55,38.07).
city('Cangzhou','cn','Hebei',527681.0,116.87,38.32).
city('Changli','cn','Hebei',64476.0,119.16,39.71).
city('Chengde','cn','Hebei',449325.0,117.93,40.96).
city('Dingzhou','cn','Hebei',152934.0,114.98,38.51).
city('Fengrun','cn','Hebei',65150.0,118.12,39.83).
city('Guye','cn','Hebei',41484.0,118.43,39.73).
city('Handan','cn','Hebei',1358318.0,114.48,36.58).
city('Hecun','cn','Hebei',83009.0,114.1,36.52).
city('Hengshui','cn','Hebei',456356.0,115.7,37.72).
city('Jingxingkuang','cn','Hebei',61292.0,114.0,38.0).
city('Langfang','cn','Hebei',720119.0,116.68,39.52).
city('Lianzhou','cn','Hebei',57992.0,114.83,38.03).
city('Linshui','cn','Hebei',109955.0,114.2,36.45).
city('Linxi','cn','Hebei',100316.0,118.43,39.7).
city('Luancheng','cn','Hebei',597130.0,114.65,37.88).
city('Nangong','cn','Hebei',82386.0,115.36,37.37).
city('Pengcheng','cn','Hebei',68442.0,114.19,36.42).
city('Qinhuangdao','cn','Hebei',759718.0,119.62,39.93).
city('Renqiu','cn','Hebei',98569.0,116.07,38.7).
city('Shahe','cn','Hebei',125132.0,114.55,36.92).
city('Shijiazhuang','cn','Hebei',1992474.0,114.48,38.05).
city('Tangjiazhuang','cn','Hebei',79489.0,118.45,39.74).
city('Tangshan','cn','Hebei',2054526.0,114.73,37.33).
city('Wuan','cn','Hebei',66523.0,114.19,36.7).
city('Xingtai','cn','Hebei',611739.0,114.49,37.07).
city('Xinji','cn','Hebei',145911.0,115.19,37.91).
city('Xuanhua','cn','Hebei',373422.0,115.03,40.6).
city('Zhangjiakou','cn','Hebei',692602.0,114.93,40.83).
city('Zhaogezhuang','cn','Hebei',86555.0,118.39,39.73).
city('Zhuozhou','cn','Hebei',116310.0,115.79,39.53).
city('Acheng','cn','Heilongjiang',144665.0,126.96,45.54).
city('Anda','cn','Heilongjiang',181271.0,125.32,46.4).
city('Angangxi','cn','Heilongjiang',59211.0,123.8,47.16).
city('Baiquan','cn','Heilongjiang',70472.0,126.08,47.6).
city('Bamiantong','cn','Heilongjiang',66170.0,130.54,44.92).
city('Baoqing','cn','Heilongjiang',62991.0,132.19,46.33).
city('Baoshan','cn','Heilongjiang',123791.0,131.39,46.57).
city('Bayan','cn','Heilongjiang',55186.0,127.4,46.08).
city('Beian','cn','Heilongjiang',145670.0,126.6,48.27).
city('Binzhou','cn','Heilongjiang',62017.0,127.49,45.76).
city('Boli','cn','Heilongjiang',95260.0,130.57,45.75).
city('Chaihe','cn','Heilongjiang',67963.0,129.68,44.77).
city('Chengzihe','cn','Heilongjiang',98188.0,131.06,45.33).
city('Cuiluan','cn','Heilongjiang',54804.0,128.66,47.73).
city('Didao','cn','Heilongjiang',109561.0,130.87,45.33).
city('Dongning','cn','Heilongjiang',61440.0,131.12,44.06).
city('Fujin','cn','Heilongjiang',89442.0,132.02,47.27).
city('Fuli','cn','Heilongjiang',59160.0,131.12,46.72).
city('Fulitun','cn','Heilongjiang',76465.0,131.24,46.81).
city('Fuyu','cn','Heilongjiang',75147.0,124.44,47.8).
city('Gannan','cn','Heilongjiang',59239.0,123.51,47.92).
city('Hailin','cn','Heilongjiang',85578.0,129.37,44.57).
city('Hailun','cn','Heilongjiang',109881.0,126.93,47.45).
city('Harbin','cn','Heilongjiang',3229883.0,126.65,45.75).
city('Hegang','cn','Heilongjiang',743307.0,130.37,47.4).
city('Heihe','cn','Heilongjiang',109427.0,127.47,50.27).
city('Hengshan','cn','Heilongjiang',164844.0,130.89,45.2).
city('Honggang','cn','Heilongjiang',147977.0,124.87,46.47).
city('Huanan','cn','Heilongjiang',66087.0,130.53,46.22).
city('Hulan','cn','Heilongjiang',109104.0,126.6,45.99).
city('Hulan Ergi','cn','Heilongjiang',265344.0,123.61,47.21).
city('Jiamusi','cn','Heilongjiang',549549.0,130.35,46.83).
city('Jidong','cn','Heilongjiang',58520.0,131.08,45.22).
city('Jixi','cn','Heilongjiang',403759.0,130.97,45.3).
city('Keshan','cn','Heilongjiang',84292.0,125.86,48.03).
city('Langxiang','cn','Heilongjiang',57318.0,128.86,46.95).
city('Lanxi','cn','Heilongjiang',72528.0,126.28,46.26).
city('Lingdong','cn','Heilongjiang',83636.0,131.14,46.57).
city('Linkou','cn','Heilongjiang',77754.0,130.25,45.28).
city('Lishu','cn','Heilongjiang',94573.0,130.69,45.09).
city('Longfeng','cn','Heilongjiang',152074.0,125.11,46.55).
city('Longjiang','cn','Heilongjiang',106384.0,123.18,47.34).
city('Mingshui','cn','Heilongjiang',59369.0,125.9,47.18).
city('Mishan','cn','Heilongjiang',87257.0,131.88,45.55).
city('Mudanjiang','cn','Heilongjiang',665915.0,129.6,44.58).
city('Nancha','cn','Heilongjiang',121367.0,129.27,47.13).
city('Nehe','cn','Heilongjiang',108253.0,124.88,48.49).
city('Nenjiang','cn','Heilongjiang',87236.0,125.23,49.18).
city('Nianzishan','cn','Heilongjiang',62131.0,122.88,47.51).
city('Ningan','cn','Heilongjiang',66549.0,129.46,44.34).
city('Qingan','cn','Heilongjiang',60408.0,127.51,46.87).
city('Qinggang','cn','Heilongjiang',64182.0,126.1,46.69).
city('Qiqihar','cn','Heilongjiang',882364.0,124.0,47.35).
city('Qitaihe','cn','Heilongjiang',345033.0,130.85,45.8).
city('Ranghulu','cn','Heilongjiang',226298.0,124.86,46.65).
city('Saertu','cn','Heilongjiang',203488.0,125.02,46.59).
city('Shangzhi','cn','Heilongjiang',82419.0,127.97,45.22).
city('Shanhetun','cn','Heilongjiang',57550.0,127.21,44.71).
city('Shuangcheng','cn','Heilongjiang',130710.0,126.28,45.35).
city('Shuangyashan','cn','Heilongjiang',209521.0,131.35,46.67).
city('Suifenhe','cn','Heilongjiang',15183.0,131.14,44.4).
city('Suihua','cn','Heilongjiang',252245.0,126.98,46.63).
city('Suileng','cn','Heilongjiang',57124.0,127.1,47.25).
city('Tahe','cn','Heilongjiang',60874.0,124.71,52.34).
city('Taikang','cn','Heilongjiang',55316.0,124.43,46.87).
city('Tailai','cn','Heilongjiang',66623.0,123.41,46.39).
city('Tieli','cn','Heilongjiang',109636.0,128.05,46.95).
city('Wangkui','cn','Heilongjiang',69915.0,126.48,46.84).
city('Weihe','cn','Heilongjiang',71344.0,128.25,44.97).
city('Wuchang','cn','Heilongjiang',94786.0,127.15,44.92).
city('Xinglongzhen','cn','Heilongjiang',72038.0,127.08,46.44).
city('Xinqing','cn','Heilongjiang',55415.0,129.5,48.24).
city('Yian','cn','Heilongjiang',73299.0,125.3,47.88).
city('Yichun','cn','Heilongjiang',155762.0,128.9,47.7).
city('Yilan','cn','Heilongjiang',71180.0,129.55,46.31).
city('Youhao','cn','Heilongjiang',78402.0,128.83,47.87).
city('Zhaodong','cn','Heilongjiang',154406.0,125.98,46.07).
city('Zhaoyuan','cn','Heilongjiang',59370.0,125.07,45.51).
city('Zhaozhou','cn','Heilongjiang',62373.0,125.26,45.71).
city('Anyang','cn','Henan',781129.0,114.35,36.08).
city('Changying','cn','Henan',66392.0,114.85,34.06).
city('Dancheng','cn','Henan',65411.0,115.19,33.64).
city('Daokou','cn','Henan',56637.0,114.5,35.58).
city('Dengfeng','cn','Henan',62375.0,113.01,34.46).
city('Dengzhou','cn','Henan',59338.0,112.07,32.68).
city('Gushi','cn','Henan',80666.0,115.67,32.18).
city('Hebi','cn','Henan',244662.0,114.22,35.95).
city('Huaidian','cn','Henan',89978.0,115.03,33.41).
city('Huangchuan','cn','Henan',72663.0,115.03,32.13).
city('Huangzhai','cn','Henan',60037.0,114.63,33.62).
city('Jiaozuo','cn','Henan',517540.0,113.22,35.25).
city('Jishui','cn','Henan',77540.0,115.4,33.74).
city('Kaifeng','cn','Henan',576915.0,114.35,34.85).
city('Liupen','cn','Henan',60202.0,114.34,33.0).
city('Luohe','cn','Henan',417356.0,114.03,33.57).
city('Luoyang','cn','Henan',1390581.0,112.47,34.68).
city('Luyang','cn','Henan',55489.0,112.89,33.74).
city('Minggang','cn','Henan',67945.0,114.04,32.45).
city('Nandun','cn','Henan',65833.0,113.47,33.85).
city('Nanyang','cn','Henan',251532.0,112.53,33.0).
city('Pingdingshan','cn','Henan',889675.0,113.3,33.73).
city('Puyang','cn','Henan',666322.0,114.98,35.7).
city('Sanmenxia','cn','Henan',357767.0,111.08,34.83).
city('Shangqiu','cn','Henan',181218.0,115.64,34.44).
city('Tanghe','cn','Henan',68514.0,112.82,32.69).
city('Xiaoyi','cn','Henan',56033.0,112.95,34.77).
city('Xihua','cn','Henan',66848.0,114.52,33.79).
city('Xinxiang','cn','Henan',743601.0,113.87,35.32).
city('Xinyang','cn','Henan',1590668.0,114.07,32.13).
city('Xinye','cn','Henan',61633.0,112.35,32.52).
city('Xixiang','cn','Henan',60745.0,112.87,35.17).
city('Xuanwu','cn','Henan',56195.0,115.47,33.86).
city('Xuchang','cn','Henan',449258.0,113.82,34.02).
city('Yigou','cn','Henan',59073.0,114.32,35.82).
city('Yima','cn','Henan',82509.0,111.87,34.72).
city('Yinzhuang','cn','Henan',62346.0,112.38,35.45).
city('Yunyang','cn','Henan',73922.0,112.72,33.45).
city('Yuzhou','cn','Henan',87961.0,113.45,34.16).
city('Zhengzhou','cn','Henan',2014125.0,113.67,34.75).
city('Zhoukou','cn','Henan',377061.0,114.63,33.64).
city('Zhumadian','cn','Henan',253536.0,114.05,32.97).
city('Daipo','cn','Hong Kong',332721.0,114.16,22.45).
city('Jiulong','cn','Hong Kong',1985493.0,114.17,22.32).
city('Quanwan','cn','Hong Kong',271238.0,114.11,22.37).
city('Shatian','cn','Hong Kong',653423.0,114.19,22.38).
city('Shiongshui','cn','Hong Kong',398201.0,114.12,22.52).
city('Xianggangdao','cn','Hong Kong',1320413.0,114.14,22.27).
city('Xigong','cn','Hong Kong',455895.0,114.25,22.33).
city('Yuanlong','cn','Hong Kong',542373.0,114.02,22.44).
city('Zhunmen','cn','Hong Kong',503192.0,113.98,22.41).
city('Anlu','cn','Hubei',71198.0,113.67,31.27).
city('Baisha','cn','Hubei',57417.0,115.22,29.83).
city('Buhe','cn','Hubei',106347.0,112.24,30.28).
city('Caidian','cn','Hubei',71891.0,114.07,30.56).
city('Caohe','cn','Hubei',67370.0,115.43,30.24).
city('Danjiangkou','cn','Hubei',92008.0,111.5,32.55).
city('Daye','cn','Hubei',61847.0,114.95,30.09).
city('Duobao','cn','Hubei',90257.0,112.63,30.65).
city('Enshi','cn','Hubei',95227.0,109.47,30.28).
city('Ezhou','cn','Hubei',193652.0,114.83,30.4).
city('Fengkou','cn','Hubei',67139.0,113.26,30.08).
city('Guangshui','cn','Hubei',154771.0,114.0,31.62).
city('Gucheng','cn','Hubei',74038.0,111.64,32.26).
city('Hanchuan','cn','Hubei',87737.0,113.83,30.64).
city('Hongan','cn','Hubei',64831.0,114.61,31.28).
city('Honghu','cn','Hubei',175761.0,113.47,29.82).
city('Huangmei','cn','Hubei',77633.0,115.93,30.08).
city('Huangpi','cn','Hubei',57554.0,114.36,30.87).
city('Huangshi','cn','Hubei',688090.0,115.1,30.22).
city('Huangzhou','cn','Hubei',122563.0,114.86,30.45).
city('Jingmen','cn','Hubei',167750.0,112.19,31.03).
city('Jingzhou','cn','Hubei',177878.0,112.18,30.35).
city('Laohekou','cn','Hubei',253112.0,111.66,32.39).
city('Lichuan','cn','Hubei',72653.0,108.92,30.3).
city('Macheng','cn','Hubei',126366.0,115.03,31.18).
city('Nanhai','cn','Hubei',80290.0,111.76,30.18).
city('Nanzhang','cn','Hubei',83604.0,111.83,31.77).
city('Puqi','cn','Hubei',132891.0,113.88,29.72).
city('Qianjiang','cn','Hubei',179079.0,112.89,30.43).
city('Qingquan','cn','Hubei',76154.0,115.24,30.46).
city('Qixingtai','cn','Hubei',60169.0,111.77,30.42).
city('Rongcheng','cn','Hubei',108908.0,112.88,29.82).
city('Shashi','cn','Hubei',498780.0,112.23,30.32).
city('Shishou','cn','Hubei',122411.0,112.4,29.73).
city('Shiyan','cn','Hubei',408055.0,110.78,32.57).
city('Suizhou','cn','Hubei',323945.0,113.36,31.71).
city('Tianmen','cn','Hubei',224871.0,113.16,30.66).
city('Wuhan','cn','Hubei',4184206.0,114.27,30.58).
city('Wuxue','cn','Hubei',220661.0,115.55,29.85).
city('Xiangfan','cn','Hubei',462956.0,112.13,32.02).
city('Xianning','cn','Hubei',179494.0,114.22,29.88).
city('Xiantao','cn','Hubei',239406.0,113.45,30.38).
city('Xiaogan','cn','Hubei',160437.0,113.9,30.92).
city('Xiaxindian','cn','Hubei',64390.0,113.73,31.02).
city('Xihe','cn','Hubei',90422.0,113.47,31.69).
city('Xinpu','cn','Hubei',60429.0,113.9,30.93).
city('Xinshi','cn','Hubei',98422.0,113.1,31.02).
city('Xinzhou','cn','Hubei',78767.0,114.78,30.84).
city('Yichang','cn','Hubei',476725.0,111.28,30.7).
city('Yicheng','cn','Hubei',61027.0,112.25,31.71).
city('Yingcheng','cn','Hubei',265886.0,113.57,30.94).
city('Yingzhong','cn','Hubei',108883.0,112.58,31.17).
city('Zaoyang','cn','Hubei',184509.0,112.75,32.13).
city('Zhicheng','cn','Hubei',159383.0,111.49,30.3).
city('Zhifang','cn','Hubei',76682.0,114.3,30.54).
city('Anjiang','cn','Hunan',55421.0,110.12,27.32).
city('Anxiang','cn','Hunan',57769.0,112.15,29.41).
city('Changde','cn','Hunan',517780.0,111.68,29.03).
city('Changsha','cn','Hunan',2073938.0,112.97,28.2).
city('Chenzhou','cn','Hunan',179038.0,113.03,25.8).
city('Dayong','cn','Hunan',86083.0,110.47,29.13).
city('Hengyang','cn','Hunan',759602.0,112.35,26.97).
city('Hongjiang','cn','Hunan',59199.0,109.99,27.12).
city('Huaihua','cn','Hunan',127322.0,109.94,27.56).
city('Jinshi','cn','Hunan',82906.0,111.85,29.63).
city('Jishou','cn','Hunan',102332.0,109.72,28.32).
city('Leiyang','cn','Hunan',129116.0,112.84,26.42).
city('Lengshuijiang','cn','Hunan',115399.0,111.42,27.68).
city('Lengshuitan','cn','Hunan',88935.0,111.58,26.45).
city('Lianyuan','cn','Hunan',66501.0,111.66,27.66).
city('Liling','cn','Hunan',98162.0,113.49,27.67).
city('Loudi','cn','Hunan',150684.0,111.98,27.75).
city('Matian','cn','Hunan',57621.0,113.11,26.15).
city('Nanzhou','cn','Hunan',54449.0,112.4,29.37).
city('Ningxiang','cn','Hunan',55312.0,112.54,28.25).
city('Qidong','cn','Hunan',58287.0,112.12,26.78).
city('Qiyang','cn','Hunan',66442.0,111.85,26.59).
city('Shaoyang','cn','Hunan',649452.0,111.2,27.0).
city('Xiangtan','cn','Hunan',674189.0,112.9,27.85).
city('Xiangxiang','cn','Hunan',87592.0,112.52,27.74).
city('Xiangyin','cn','Hunan',57117.0,112.88,28.68).
city('Xinhua','cn','Hunan',75233.0,111.29,27.75).
city('Yiyang','cn','Hunan',202608.0,112.33,28.6).
city('Yongfeng','cn','Hunan',70783.0,112.18,27.46).
city('Yongzhou','cn','Hunan',86095.0,111.6,26.23).
city('Yuanjiang','cn','Hunan',66145.0,112.38,28.83).
city('Yueyang','cn','Hunan',528140.0,113.1,29.38).
city('Zhuzhou','cn','Hunan',709358.0,113.15,27.83).
city('Baoying','cn','Jiangsu',80292.0,119.3,33.23).
city('Changzhou','cn','Jiangsu',949018.0,119.97,31.78).
city('Dafeng','cn','Jiangsu',84323.0,120.43,33.2).
city('Dingshu','cn','Jiangsu',95530.0,119.83,31.37).
city('Dongkan','cn','Jiangsu',72789.0,119.83,34.0).
city('Dongtai','cn','Jiangsu',110988.0,120.3,32.85).
city('Fengxian','cn','Jiangsu',57153.0,116.59,34.7).
city('Gaogou','cn','Jiangsu',56214.0,119.19,34.02).
city('Gaoyou','cn','Jiangsu',90911.0,119.43,32.78).
city('Guiren','cn','Jiangsu',57446.0,118.19,33.67).
city('Haian','cn','Jiangsu',72654.0,120.44,32.55).
city('Haizhou','cn','Jiangsu',59098.0,119.09,34.56).
city('Hede','cn','Jiangsu',89107.0,120.25,33.78).
city('Huaicheng','cn','Jiangsu',94296.0,119.14,33.51).
city('Huaiyin','cn','Jiangsu',555230.0,119.03,33.58).
city('Huilong','cn','Jiangsu',74818.0,121.65,31.81).
city('Hutang','cn','Jiangsu',56370.0,119.48,31.54).
city('Jiangdu','cn','Jiangsu',83936.0,119.57,32.43).
city('Jiangyan','cn','Jiangsu',70375.0,120.14,32.51).
city('Jiangyin','cn','Jiangsu',107918.0,120.26,31.9).
city('Jianhu','cn','Jiangsu',72474.0,119.71,33.52).
city('Jingcheng','cn','Jiangsu',61772.0,120.26,32.02).
city('Jinsha','cn','Jiangsu',95647.0,121.06,32.09).
city('Juegang','cn','Jiangsu',73317.0,121.17,32.32).
city('Liucheng','cn','Jiangsu',72514.0,118.84,32.34).
city('Liyang','cn','Jiangsu',72276.0,119.48,31.43).
city('Mudu','cn','Jiangsu',61902.0,120.51,31.24).
city('Nanjing','cn','Jiangsu',3087010.0,118.78,32.05).
city('Nantong','cn','Jiangsu',666251.0,120.82,32.02).
city('Pecheng','cn','Jiangsu',82974.0,116.93,34.73).
city('Qinnan','cn','Jiangsu',55975.0,119.92,33.27).
city('Rucheng','cn','Jiangsu',77947.0,120.55,32.4).
city('Songling','cn','Jiangsu',77566.0,120.66,31.13).
city('Sucheng','cn','Jiangsu',330465.0,118.29,33.95).
city('Suicheng','cn','Jiangsu',61430.0,117.95,33.89).
city('Suzhou','cn','Jiangsu',1343091.0,120.62,31.3).
city('Taixing','cn','Jiangsu',79655.0,120.0,32.17).
city('Taizhou','cn','Jiangsu',612356.0,119.9,32.49).
city('Wuxi','cn','Jiangsu',1108647.0,120.3,31.58).
city('Xiaolingwei','cn','Jiangsu',66031.0,118.85,32.02).
city('Xinan','cn','Jiangsu',61816.0,118.35,34.38).
city('Xinpu','cn','Jiangsu',392444.0,119.17,34.6).
city('Xuzhou','cn','Jiangsu',1199193.0,117.18,34.27).
city('Yancheng','cn','Jiangsu',628441.0,120.12,33.39).
city('Yangshe','cn','Jiangsu',66039.0,120.53,31.86).
city('Yangzhou','cn','Jiangsu',539715.0,119.43,32.4).
city('Yizheng','cn','Jiangsu',176006.0,119.2,32.27).
city('Yunhe','cn','Jiangsu',82641.0,117.95,34.31).
city('Yunyang','cn','Jiangsu',100076.0,119.56,32.0).
city('Yushan','cn','Jiangsu',124013.0,120.84,31.51).
city('Zhaoyang','cn','Jiangsu',105918.0,119.82,32.94).
city('Zhenjiang','cn','Jiangsu',632552.0,119.43,32.22).
city('Zhongxing','cn','Jiangsu',57338.0,118.66,33.7).
city('Fenyi','cn','Jiangxi',58478.0,114.67,27.81).
city('Ganzhou','cn','Jiangxi',249071.0,114.93,25.95).
city('Jian','cn','Jiangxi',171718.0,115.0,27.13).
city('Jiangguang','cn','Jiangxi',61469.0,115.78,28.19).
city('Jingdezhen','cn','Jiangxi',310565.0,117.18,29.27).
city('Jiujiang','cn','Jiangxi',258807.0,115.98,29.73).
city('Linchuan','cn','Jiangxi',125847.0,116.37,27.99).
city('Nanchang','cn','Jiangxi',1871351.0,115.88,28.68).
city('Pingxiang','cn','Jiangxi',372123.0,113.85,27.62).
city('Poyang','cn','Jiangxi',70787.0,116.66,29.01).
city('Shangrao','cn','Jiangxi',318769.0,117.97,28.47).
city('Xiangdong','cn','Jiangxi',103815.0,113.74,27.64).
city('Xinjian','cn','Jiangxi',56429.0,115.82,28.69).
city('Xinyu','cn','Jiangxi',97480.0,114.93,27.8).
city('Xiongshi','cn','Jiangxi',73732.0,117.19,28.3).
city('Yichun','cn','Jiangxi',152169.0,114.4,27.83).
city('Yingtai','cn','Jiangxi',109422.0,117.03,28.25).
city('Zhangshui','cn','Jiangxi',84026.0,115.53,28.07).
city('Badaojiang','cn','Jilin',183880.0,126.44,41.94).
city('Baicheng','cn','Jilin',316970.0,122.82,45.62).
city('Baishishan','cn','Jilin',56992.0,127.56,43.59).
city('Changchun','cn','Jilin',2537421.0,125.35,43.87).
city('Changling','cn','Jilin',55841.0,123.99,44.27).
city('Chaoyang','cn','Jilin',75347.0,126.05,42.68).
city('Daan','cn','Jilin',93297.0,124.3,45.5).
city('Dashitou','cn','Jilin',65683.0,128.5,43.3).
city('Dehui','cn','Jilin',108818.0,125.7,44.53).
city('Dongchang','cn','Jilin',364934.0,125.93,41.73).
city('Dongfeng','cn','Jilin',67820.0,125.52,42.67).
city('Dunhua','cn','Jilin',148844.0,128.22,43.35).
city('Erdaojiang','cn','Jilin',60831.0,126.03,41.79).
city('Fuyu','cn','Jilin',138704.0,124.82,45.18).
city('Gongzhuling','cn','Jilin',140909.0,124.81,43.51).
city('Helong','cn','Jilin',85756.0,129.0,42.54).
city('Huadian','cn','Jilin',139047.0,126.74,42.97).
city('Huangnihe','cn','Jilin',54959.0,128.01,43.55).
city('Huinan','cn','Jilin',66315.0,126.25,42.62).
city('Hunchun','cn','Jilin',77028.0,130.35,42.87).
city('Jiaohe','cn','Jilin',123018.0,127.34,43.72).
city('Jilin','cn','Jilin',1881977.0,126.55,43.85).
city('Jishu','cn','Jilin',103988.0,126.79,44.29).
city('Jiutai','cn','Jilin',175115.0,125.84,44.15).
city('Kaitong','cn','Jilin',62537.0,123.08,44.81).
city('Kouqian','cn','Jilin',55957.0,126.34,43.7).
city('Liaoyuan','cn','Jilin',465249.0,125.13,42.9).
city('Linjiang','cn','Jilin',69149.0,126.91,41.82).
city('Lishu','cn','Jilin',61584.0,124.32,43.31).
city('Liuhe','cn','Jilin',66975.0,125.72,42.27).
city('Longjing','cn','Jilin',117185.0,129.42,42.77).
city('Meihekou','cn','Jilin',99419.0,125.67,42.53).
city('Mingyue','cn','Jilin',58872.0,128.9,43.11).
city('Nongan','cn','Jilin',98087.0,125.17,44.43).
city('Panshi','cn','Jilin',80200.0,126.05,42.94).
city('Qianan','cn','Jilin',62337.0,124.02,44.99).
city('Qianguo','cn','Jilin',113611.0,124.81,45.11).
city('Sanchazi','cn','Jilin',66576.0,126.6,42.08).
city('Shuangyang','cn','Jilin',62137.0,125.67,43.52).
city('Shulan','cn','Jilin',77420.0,126.94,44.41).
city('Siping','cn','Jilin',555609.0,124.33,43.17).
city('Songjianghe','cn','Jilin',67672.0,127.49,42.17).
city('Taonan','cn','Jilin',112819.0,122.78,45.33).
city('Tumen','cn','Jilin',78719.0,129.82,42.97).
city('Wangou','cn','Jilin',65298.0,126.92,42.06).
city('Wangqing','cn','Jilin',88732.0,129.73,43.32).
city('Xinglongshan','cn','Jilin',58432.0,125.48,43.95).
city('Yanji','cn','Jilin',326957.0,129.52,42.88).
city('Yantongshan','cn','Jilin',57515.0,126.01,43.29).
city('Yushu','cn','Jilin',124736.0,126.56,44.83).
city('Zhengjiatun','cn','Jilin',93666.0,123.5,43.51).
city('Zhenlai','cn','Jilin',67760.0,123.19,45.85).
city('Anshan','cn','Liaoning',1199275.0,122.95,41.12).
city('Beipiao','cn','Liaoning',154999.0,120.76,41.81).
city('Benxi','cn','Liaoning',987717.0,123.75,41.33).
city('Changtu','cn','Liaoning',71284.0,124.13,42.78).
city('Chaoyang','cn','Liaoning',410005.0,120.42,41.55).
city('Dalian','cn','Liaoning',2035307.0,121.65,38.92).
city('Dalianwan','cn','Liaoning',55841.0,121.68,39.02).
city('Dalinghe','cn','Liaoning',56176.0,121.36,41.18).
city('Dandong','cn','Liaoning',631973.0,124.4,40.13).
city('Dashiqiao','cn','Liaoning',80223.0,122.5,40.64).
city('Dongling','cn','Liaoning',171454.0,123.56,41.82).
city('Fengcheng','cn','Liaoning',120514.0,124.06,40.46).
city('Fushun','cn','Liaoning',1400646.0,123.88,41.87).
city('Fuxin','cn','Liaoning',373203.0,121.7,42.04).
city('Haicheng','cn','Liaoning',191651.0,122.74,40.86).
city('Heishan','cn','Liaoning',68603.0,122.11,41.69).
city('Huanren','cn','Liaoning',66147.0,125.35,41.25).
city('Hushitai','cn','Liaoning',61979.0,123.51,41.95).
city('Jinxi','cn','Liaoning',313247.0,120.83,40.75).
city('Jinzhou','cn','Liaoning',409828.0,121.41,40.11).
city('Jiupu','cn','Liaoning',123843.0,122.95,41.07).
city('Kaiyuan','cn','Liaoning',112462.0,103.23,23.7).
city('Kuandian','cn','Liaoning',70867.0,124.78,40.73).
city('Langtou','cn','Liaoning',59046.0,124.33,40.04).
city('Liaoyang','cn','Liaoning',687890.0,123.18,41.28).
city('Liaozhong','cn','Liaoning',54691.0,122.73,41.51).
city('Lingyuan','cn','Liaoning',91418.0,119.39,41.25).
city('Liuerbao','cn','Liaoning',70761.0,123.45,41.13).
city('Lushunkou','cn','Liaoning',82345.0,121.25,38.81).
city('Nanpiao','cn','Liaoning',157044.0,120.72,41.13).
city('Nantai','cn','Liaoning',56478.0,122.78,40.92).
city('Panjin','cn','Liaoning',625040.0,122.05,41.18).
city('Pulandian','cn','Liaoning',104277.0,121.96,39.4).
city('Shenyang','cn','Liaoning',3512192.0,123.45,41.8).
city('Sujiatun','cn','Liaoning',148113.0,123.34,41.66).
city('Tieling','cn','Liaoning',333907.0,123.82,42.3).
city('Wafangdian','cn','Liaoning',250591.0,122.0,39.62).
city('Xiaoshi','cn','Liaoning',68994.0,124.12,41.28).
city('Xifeng','cn','Liaoning',61087.0,124.71,42.74).
city('Xinchengxi','cn','Liaoning',72546.0,123.51,42.05).
city('Xingcheng','cn','Liaoning',98968.0,120.7,40.62).
city('Xinmin','cn','Liaoning',74139.0,122.82,42.0).
city('Xiongyue','cn','Liaoning',89887.0,122.36,40.4).
city('Xiuyan','cn','Liaoning',71614.0,123.28,40.28).
city('Yebaishou','cn','Liaoning',65536.0,119.63,41.4).
city('Yingkou','cn','Liaoning',591159.0,122.28,40.67).
city('Yuhong','cn','Liaoning',155645.0,123.5,41.82).
city('Zhuanghe','cn','Liaoning',80384.0,122.97,39.69).
city('Alihe','cn','Neimenggu',61582.0,123.71,50.6).
city('Baotou','cn','Neimenggu',1279437.0,110.05,40.6).
city('Chifeng','cn','Neimenggu',346654.0,118.95,42.27).
city('Dayan','cn','Neimenggu',61181.0,120.05,49.75).
city('Dongsheng','cn','Neimenggu',99809.0,109.99,39.81).
city('Erenhot','cn','Neimenggu',16427.0,111.96,43.66).
city('Fengzhen','cn','Neimenggu',72444.0,113.14,40.45).
city('Genhe','cn','Neimenggu',73631.0,121.53,50.77).
city('Haibowan','cn','Neimenggu',218427.0,106.8,39.66).
city('Hailar','cn','Neimenggu',211066.0,119.71,49.23).
city('Hainan','cn','Neimenggu',108063.0,106.83,39.3).
city('Hohhot','cn','Neimenggu',774477.0,111.64,40.82).
city('Jiagedagi','cn','Neimenggu',135760.0,124.11,50.43).
city('Jining','cn','Neimen',258757.0,113.09,41.04).
city('Linhe','cn','Neimenggu',168946.0,107.5,40.83).
city('Manzhouli','cn','Neimenggu',54808.0,117.43,49.6).
city('Mujiayingzi','cn','Neimenggu',60627.0,118.78,42.12).
city('Pingzhuang','cn','Neimenggu',67273.0,119.28,42.03).
city('Saliqi','cn','Neimenggu',64704.0,110.51,40.55).
city('Shiguaikuang','cn','Neimenggu',70357.0,110.33,40.7).
city('Tongliao','cn','Neimenggu',261110.0,122.27,43.62).
city('Wuda','cn','Neimenggu',129922.0,106.7,39.5).
city('Wulanhaote','cn','Neimenggu',165846.0,122.08,46.08).
city('Xilinhaote','cn','Neimenggu',120965.0,116.05,43.94).
city('Yakeshi','cn','Neimenggu',116284.0,120.73,49.28).
city('Zalantun','cn','Neimenggu',132224.0,122.72,48.0).
city('Zhalainuoer','cn','Neimenggu',107828.0,117.71,49.47).
city('Dawukou','cn','Ningxia',131880.0,106.36,39.02).
city('Shitanjing','cn','Ningxia',78765.0,106.33,39.24).
city('Shizuishan','cn','Ningxia',136570.0,106.76,39.23).
city('Yinchuan','cn','Ningxia',475101.0,106.32,38.47).
city('Changping','cn','Peking',93174.0,116.2,40.22).
city('Fangshan','cn','Peking',97026.0,115.96,39.69).
city('Huangcun','cn','Peking',104904.0,116.32,39.74).
city('Liangxiang','cn','Peking',76744.0,116.13,39.73).
city('Mentougou','cn','Peking',197772.0,116.07,39.94).
city('Peking','cn','Peking',7480601.0,116.4,39.93).
city('Shunyi','cn','Peking',117623.0,116.64,40.13).
city('Tongzhou','cn','Peking',163326.0,116.64,39.9).
city('Qiatou','cn','Qinghai',86568.0,101.69,36.94).
city('Xining','cn','Qinghai',767531.0,101.77,36.62).
city('Ankang','cn','Shaanxi',132654.0,109.02,32.68).
city('Baoji','cn','Shaanxi',438295.0,107.15,34.38).
city('Guozhen','cn','Shaanxi',85415.0,107.38,34.35).
city('Hancheng','cn','Shaanxi',58049.0,110.43,35.47).
city('Hanzhong','cn','Shaanxi',145986.0,107.03,33.13).
city('Lishan','cn','Shaanxi',75882.0,109.19,34.37).
city('Qili','cn','Shaanxi',57880.0,108.48,34.3).
city('Tongchuan','cn','Shaanxi',223603.0,109.03,35.08).
city('Weinan','cn','Shaanxi',172321.0,109.5,34.5).
city('Xian','cn','Shaanxi',3953191.0,108.9,34.27).
city('Xianyang','cn','Shaanxi',1034081.0,108.7,34.37).
city('Yanan','cn','Shaanxi',107960.0,109.47,36.6).
city('Yanliang','cn','Shaanxi',60891.0,109.22,34.66).
city('Yulin','cn','Shaanxi',90870.0,109.74,38.29).
city('Yuxia','cn','Shaanxi',60206.0,108.63,34.07).
city('Anqiu','cn','Shandong',105665.0,119.19,36.43).
city('Bianzhuang','cn','Shandong',65381.0,118.04,34.84).
city('Binzhou','cn','Shandong',115893.0,118.01,37.37).
city('Boshan','cn','Shandong',153596.0,117.85,36.48).
city('Caocheng','cn','Shandong',83886.0,115.53,34.82).
city('Changqing','cn','Shandong',82598.0,116.73,36.55).
city('Dengzhou','cn','Shandong',85279.0,120.74,37.82).
city('Dezhou','cn','Shandong',379555.0,116.3,37.45).
city('Dingtao','cn','Shandong',58206.0,115.56,35.07).
city('Dongcun','cn','Shandong',92282.0,121.16,36.78).
city('Dongdu','cn','Shandong',72957.0,117.7,35.85).
city('Dongying','cn','Shandong',306450.0,118.52,37.5).
city('Feicheng','cn','Shandong',80929.0,117.95,35.27).
city('Fushan','cn','Shandong',65622.0,121.25,37.5).
city('Gaomi','cn','Shandong',150793.0,119.75,36.39).
city('Hanting','cn','Shandong',90637.0,119.21,36.77).
city('Hekou','cn','Shandong',115800.0,118.53,37.55).
city('Heze','cn','Shandong',254602.0,115.45,35.23).
city('Jiaonan','cn','Shandong',75656.0,119.96,35.88).
city('Jiaozhou','cn','Shandong',165026.0,120.0,36.29).
city('Jiehu','cn','Shandong',69245.0,118.45,35.55).
city('Jimo','cn','Shandong',70733.0,120.46,36.38).
city('Jinan','cn','Shandong',2069266.0,117.0,36.67).
city('Jining','cn','Shandong',450327.0,116.55,35.4).
city('Juxian','cn','Shandong',66588.0,118.82,35.58).
city('Juye','cn','Shandong',58107.0,116.09,35.39).
city('Laiwu','cn','Shandong',124108.0,117.66,36.2).
city('Laiyang','cn','Shandong',169594.0,120.7,36.97).
city('Laizhou','cn','Shandong',90070.0,119.94,37.17).
city('Liaocheng','cn','Shandong',226930.0,115.97,36.43).
city('Licung','cn','Shandong',89083.0,120.41,36.17).
city('Linqing','cn','Shandong',110046.0,115.68,36.85).
city('Linqu','cn','Shandong',77472.0,118.52,36.51).
city('Linshu','cn','Shandong',63285.0,118.65,34.91).
city('Linyi','cn','Shandong',270669.0,118.33,35.08).
city('Longkou','cn','Shandong',60444.0,120.33,37.65).
city('Mengyin','cn','Shandong',65889.0,117.92,35.71).
city('Mingshui','cn','Shandong',114858.0,117.52,36.72).
city('Nanding','cn','Shandong',85495.0,118.03,36.75).
city('Nanma','cn','Shandong',74406.0,118.16,36.18).
city('Ninghai','cn','Shandong',56937.0,121.59,37.38).
city('Ningyang','cn','Shandong',82994.0,116.78,35.76).
city('Pingdu','cn','Shandong',91077.0,119.94,36.79).
city('Pingyi','cn','Shandong',78254.0,117.62,35.51).
city('Pingyin','cn','Shandong',62050.0,116.43,36.28).
city('Qingdao','cn','Shandong',1642245.0,120.32,36.07).
city('Qixia','cn','Shandong',79106.0,120.84,37.3).
city('Qufu','cn','Shandong',85144.0,116.97,35.6).
city('Rizhao','cn','Shandong',246387.0,119.45,35.43).
city('Shancheng','cn','Shandong',74459.0,116.08,34.79).
city('Shanting','cn','Shandong',80843.0,117.45,35.09).
city('Shenxian','cn','Shandong',79196.0,115.66,36.24).
city('Shizilu','cn','Shandong',86749.0,118.83,35.17).
city('Shouguang','cn','Shandong',79212.0,118.7,36.89).
city('Shuiji','cn','Shandong',75849.0,120.53,36.86).
city('Sishui','cn','Shandong',90175.0,117.26,35.66).
city('Suozhen','cn','Shandong',58766.0,118.1,36.95).
city('Taian','cn','Shandong',750340.0,117.12,36.2).
city('Tancheng','cn','Shandong',83467.0,118.14,34.58).
city('Taozhuang','cn','Shandong',60137.0,117.33,34.85).
city('Tengzhou','cn','Shandong',105456.0,117.15,35.09).
city('Weifang','cn','Shandong',394732.0,119.1,36.72).
city('Weihai','cn','Shandong',152595.0,122.1,37.5).
city('Wencheng','cn','Shandong',115370.0,122.04,37.19).
city('Wenshang','cn','Shandong',59455.0,116.48,35.73).
city('Xiazhen','cn','Shandong',125667.0,117.1,34.82).
city('Xincheng','cn','Shandong',77606.0,116.76,36.24).
city('Xindian','cn','Shandong',82555.0,118.28,36.84).
city('Xintai','cn','Shandong',222459.0,117.76,35.9).
city('Yanggu','cn','Shandong',74725.0,115.77,36.11).
city('Yangshan','cn','Shandong',57240.0,116.3,35.07).
city('Yantai','cn','Shandong',719332.0,121.4,37.53).
city('Yanzhou','cn','Shandong',77276.0,116.82,35.55).
city('Yatou','cn','Shandong',91517.0,122.4,37.17).
city('Yidu','cn','Shandong',117056.0,118.47,36.68).
city('Yishui','cn','Shandong',94115.0,118.62,35.79).
city('Yucheng','cn','Shandong',62365.0,116.46,34.93).
city('Yuncheng','cn','Shandong',64511.0,115.76,35.65).
city('Zaozhuang','cn','Shandong',183665.0,117.57,34.88).
city('Zhangdian','cn','Shandong',669770.0,118.06,36.8).
city('Zhaocheng','cn','Shandong',100774.0,120.41,37.36).
city('Zhoucheng','cn','Shandong',72070.0,116.3,35.91).
city('Zhoucun','cn','Shandong',122402.0,117.84,36.8).
city('Zhucheng','cn','Shandong',109968.0,119.38,35.99).
city('Zhuwang','cn','Shandong',56435.0,121.51,36.91).
city('Zouxian','cn','Shandong',190537.0,116.94,35.41).
city('Shanghai','cn','Shanghai',1.4608512E7,121.47,31.23).
city('Changzhi','cn','Shanxi',699514.0,111.75,35.22).
city('Datong','cn','Shanxi',1052678.0,113.3,40.08).
city('Houma','cn','Shanxi',100630.0,111.21,35.62).
city('Jiexiu','cn','Shanxi',77178.0,111.9,37.04).
city('Jincheng','cn','Shanxi',332650.0,112.83,35.5).
city('Linfen','cn','Shanxi',232566.0,111.52,36.08).
city('Taiyuan','cn','Shanxi',2722475.0,112.55,37.87).
city('Xinzhi','cn','Shanxi',72303.0,111.7,36.49).
city('Xinzhou','cn','Shanxi',154003.0,112.72,38.41).
city('Yangquan','cn','Shanxi',413394.0,113.57,37.87).
city('Yuanping','cn','Shanxi',82883.0,112.72,38.73).
city('Yuci','cn','Shanxi',235929.0,112.73,37.68).
city('Yuncheng','cn','Shanxi',201950.0,110.98,35.02).
city('Anju','cn','Sichuan',54098.0,105.44,30.34).
city('Baoning','cn','Sichuan',60542.0,105.96,31.58).
city('Chengdu','cn','Sichuan',3950437.0,104.07,30.67).
city('Daan','cn','Sichuan',120340.0,106.02,29.4).
city('Dawan','cn','Sichuan',54392.0,104.21,30.91).
city('Daxian','cn','Sichuan',130749.0,107.52,31.27).
city('Deyang','cn','Sichuan',152194.0,104.4,31.13).
city('Guangkou','cn','Sichuan',65379.0,103.62,31.0).
city('Guangyuan','cn','Sichuan',213365.0,105.87,32.43).
city('Guihu','cn','Sichuan',63615.0,104.15,30.84).
city('Huayang','cn','Sichuan',90365.0,103.92,30.58).
city('Jiancheng','cn','Sichuan',82563.0,104.51,30.43).
city('Jiangyou','cn','Sichuan',127225.0,104.76,31.77).
city('Leshan','cn','Sichuan',154477.0,103.74,29.57).
city('Linqiong','cn','Sichuan',55587.0,103.46,30.42).
city('Luocheng','cn','Sichuan',73581.0,104.03,29.39).
city('Luzhou','cn','Sichuan',295056.0,105.38,28.88).
city('Mianyang','cn','Sichuan',264136.0,104.77,31.47).
city('Nanchong','cn','Sichuan',204368.0,106.13,30.78).
city('Nanlong','cn','Sichuan',63405.0,106.05,31.35).
city('Neijiang','cn','Sichuan',546854.0,105.05,29.58).
city('Panzhihua','cn','Sichuan',461513.0,101.68,26.58).
city('Suining','cn','Sichuan',124924.0,105.53,30.53).
city('Taihe','cn','Sichuan',83018.0,105.38,30.86).
city('Tianpeng','cn','Sichuan',60797.0,103.94,30.99).
city('Tongchuan','cn','Sichuan',58346.0,105.08,31.1).
city('Xichang','cn','Sichuan',126.0,102.3,27.88).
city('Xunchang','cn','Sichuan',64580.0,104.73,28.47).
city('Yaan','cn','Sichuan',108758.0,103.08,29.98).
city('Yibin','cn','Sichuan',242111.0,104.57,28.77).
city('Zhonglong','cn','Sichuan',58441.0,104.84,29.78).
city('Zigong','cn','Sichuan',689961.0,104.78,29.4).
city('Ziyang','cn','Sichuan',87400.0,104.64,30.14).
city('Gangdong','cn','Tianjin',139225.0,117.61,38.88).
city('Hangu','cn','Tianjin',208369.0,117.78,39.23).
city('Tanggu','cn','Tianjin',535298.0,117.67,39.0).
city('Tianjin','cn','Tianjin',3766207.0,117.2,39.13).
city('Xianshuigu','cn','Tianjin',74028.0,117.38,38.99).
city('Yangcun','cn','Tianjin',63756.0,117.05,39.38).
city('Yangliuqing','cn','Tianjin',76387.0,116.99,39.13).
city('Aksu','cn','Xinjiang',340020.0,80.25,41.15).
city('Altay','cn','Xinjiang',139341.0,88.13,47.84).
city('Baijiantan','cn','Xinjiang',93697.0,85.18,45.64).
city('Changji','cn','Xinjiang',198776.0,87.32,44.02).
city('Hami','cn','Xinjiang',137072.0,93.45,42.8).
city('Hetian','cn','Xinjiang',111829.0,79.92,37.12).
city('Karamay','cn','Xinjiang',174828.0,84.86,45.6).
city('Kashi','cn','Xinjiang',274717.0,75.97,39.48).
city('Korla','cn','Xinjiang',179465.0,86.15,41.73).
city('Kuche','cn','Xinjiang',68105.0,82.92,41.72).
city('Kuytun','cn','Xinjiang',187242.0,84.89,44.44).
city('Shache','cn','Xinjiang',82509.0,77.25,38.42).
city('Shihezi','cn','Xinjiang',572772.0,86.03,44.3).
city('Toutunhe','cn','Xinjiang',93472.0,87.54,43.9).
city('Urumqi','cn','Xinjiang',1508225.0,87.58,43.8).
city('Yining','cn','Xinjiang',257671.0,81.35,43.9).
city('Lasa','cn','Xizang',118721.0,91.1,29.65).
city('Dali','cn','Yunnan',134040.0,100.15,25.7).
city('Gejiu','cn','Yunnan',136135.0,103.15,23.38).
city('Haikou','cn','Yunnan',112644.0,102.6,24.84).
city('Jinma','cn','Yunnan',133084.0,102.75,25.06).
city('Kaihua','cn','Yunnan',64404.0,104.26,23.37).
city('Kaiyuan','cn','Yunnan',198423.0,103.24,23.72).
city('Kunming','cn','Yunnan',1023674.0,102.7,25.05).
city('Lianran','cn','Yunna',106795.0,102.49,24.91).
city('Longquan','cn','Yunnan',91534.0,102.15,24.68).
city('Lucheng','cn','Yunnan',97911.0,101.55,25.03).
city('Mabai','cn','Yunnan',63569.0,104.39,23.02).
city('Majie','cn','Yunnan',131696.0,102.65,25.05).
city('Miyang','cn','Yunnan',72485.0,103.44,24.41).
city('Qujing','cn','Yunnan',146015.0,103.78,25.48).
city('Rongcheng','cn','Yunnan',102157.0,104.11,26.22).
city('Simao','cn','Yunnan',71094.0,100.98,22.78).
city('Wufeng','cn','Yunnan',101728.0,104.85,27.0).
city('Yunjinghong','cn','Yunnan',62105.0,100.81,21.97).
city('Zhaotong','cn','Yunnan',109400.0,103.72,27.32).
city('Zhenhai','cn','Yunnan',73953.0,103.3,26.42).
city('Zhongshu','cn','Yunnan',91750.0,103.76,24.53).
city('Zhoucheng','cn','Yunnan',103829.0,102.55,24.36).
city('Zhuocheng','cn','Yunnan',66290.0,102.54,24.36).
city('Aojiang','cn','Zhejiang',74636.0,120.55,27.62).
city('Choucheng','cn','Zhejiang',89629.0,120.06,29.31).
city('Daqiao','cn','Zhejiang',76653.0,121.4,29.66).
city('Deqing','cn','Zhejiang',87576.0,120.08,30.55).
city('Dinghai','cn','Zhejiang',84380.0,122.1,30.02).
city('Fuyang','cn','Zhejiang',70183.0,119.94,30.06).
city('Hangzhou','cn','Zhejiang',1878129.0,120.17,30.25).
city('Huangyan','cn','Zhejiang',150448.0,121.25,28.65).
city('Hushan','cn','Zhejiang',59865.0,118.83,28.72).
city('Huzhou','cn','Zhejiang',158320.0,120.1,30.87).
city('Jiaojiang','cn','Zhejiang',470804.0,121.45,28.68).
city('Jiaxing','cn','Zhejiang',466101.0,120.75,30.77).
city('Jinhua','cn','Zhejiang',142206.0,119.65,29.12).
city('Jinxiang','cn','Zhejiang',84231.0,120.63,27.44).
city('Kunyang','cn','Zhejiang',65009.0,120.56,27.68).
city('Lanxi','cn','Zhejiang',73706.0,119.46,29.22).
city('Linhai','cn','Zhejiang',152937.0,121.11,28.84).
city('Linping','cn','Zhejiang',78180.0,120.3,30.42).
city('Lishui','cn','Zhejiang',98946.0,119.91,28.46).
city('Luqiao','cn','Zhejiang',427890.0,121.38,28.58).
city('Ningbo','cn','Zhejiang',719867.0,121.55,29.88).
city('Ninghai','cn','Zhejiang',68330.0,121.42,29.29).
city('Quzhou','cn','Zhejiang',82216.0,118.87,28.97).
city('Ruian','cn','Zhejiang',125208.0,120.59,27.85).
city('Shaoxing','cn','Zhejiang',421283.0,120.57,30.0).
city('Shenjiamen','cn','Zhejiang',95433.0,122.28,29.97).
city('Wenling','cn','Zhejiang',67433.0,121.35,28.37).
city('Wenzhou','cn','Zhejiang',865672.0,120.65,28.02).
city('Wuning','cn','Zhejiang',130387.0,120.22,29.27).
city('Xianju','cn','Zhejiang',61532.0,120.73,28.85).
city('Xiaoshan','cn','Zhejiang',95234.0,120.25,30.16).
city('Xiashi','cn','Zhejiang',70171.0,120.69,30.54).
city('Xushan','cn','Zhejiang',80299.0,121.25,30.23).
city('Yuyao','cn','Zhejiang',114177.0,121.15,30.05).
city('Zhenhai','cn','Zhejiang',61979.0,121.73,29.95).
city('Zhicheng','cn','Zhejiang',63753.0,119.9,31.0).
city('Zhuji','cn','Zhejiang',110721.0,120.24,29.71).
city('Leticia','co','Amazonas',29666.0,-69.94,-4.22).
city('Puerto Narino','co','Amazonas',2113.0,-70.38,-3.77).
city('Abejorral','co','Antioquia',7360.0,-75.43,5.8).
city('Abriaqui','co','Antioquia',1281.0,-76.06,6.63).
city('Alejandria','co','Antioquia',2725.0,-75.08,6.37).
city('Amaga','co','Antioquia',12170.0,-75.71,6.04).
city('Amalfi','co','Antioquia',9733.0,-75.08,6.91).
city('Andes','co','Antioquia',16420.0,-75.88,5.65).
city('Angelopolis','co','Antioquia',1917.0,-75.71,6.11).
city('Angostura','co','Antioquia',3640.0,-75.34,6.89).
city('Anori','co','Antioquia',4762.0,-75.07,7.18).
city('Antioquia','co','Antioquia',11829.0,-75.83,6.56).
city('Anza','co','Antioquia',1682.0,-75.0,6.31).
city('Apartado','co','Antioquia',86439.0,-76.64,7.89).
city('Arboletes','co','Antioquia',8381.0,-76.43,8.85).
city('Argelia','co','Antioquia',3474.0,-75.15,5.73).
city('Armenia','co','Antioquia',2035.0,-75.79,6.16).
city('Barbosa','co','Antioquia',16707.0,-75.33,6.44).
city('Bello','co','Antioquia',392945.0,-75.57,6.33).
city('Belmira','co','Antioquia',1388.0,-75.67,6.61).
city('Betania','co','Antioquia',3800.0,-75.98,5.75).
city('Betulia','co','Antioquia',5216.0,-76.0,6.12).
city('Bolivar','co','Antioquia',16225.0,-76.01,5.84).
city('Briceno','co','Antioquia',2214.0,-75.55,7.11).
city('Buritica','co','Antioquia',2388.0,-75.91,6.72).
city('Caceres','co','Antioquia',4987.0,-75.35,7.58).
city('Caicedo','co','Antioquia',1617.0,-75.99,6.41).
city('Caldas','co','Antioquia',65566.0,-75.65,6.11).
city('Campamento','co','Antioquia',1870.0,-75.3,6.98).
city('Canasgordas','co','Antioquia',6026.0,-76.02,6.75).
city('Caracoli','co','Antioquia',3120.0,-74.77,6.4).
city('Caramanta','co','Antioquia',3044.0,-75.65,5.54).
city('Carepa','co','Antioquia',20627.0,-76.66,7.77).
city('Carmen de Viboral','co','Antioquia',21152.0,-75.34,6.09).
city('Carolina','co','Antioquia',3160.0,-75.28,6.73).
city('Caucasia','co','Antioquia',58035.0,-75.21,7.99).
city('Chigorodo','co','Antioquia',48444.0,-76.69,7.68).
city('Cisneros','co','Antioquia',8204.0,-75.09,6.55).
city('Cocorna','co','Antioquia',5257.0,-75.19,6.06).
city('Concepcion','co','Antioquia',1513.0,-75.26,6.4).
city('Concordia','co','Antioquia',9324.0,-75.92,6.05).
city('Copacabana','co','Ant',49170.0,-75.51,6.35).
city('Dabeiba','co','Antioquia',11548.0,-76.26,7.0).
city('Don Matias','co','Antioquia',10011.0,-75.4,6.49).
city('Ebejico','co','Antioquia',2583.0,-75.77,6.33).
city('El Bagre','co','Antioquia',40799.0,-74.81,7.59).
city('Entrerrios','co','Antioquia',3462.0,-75.52,6.57).
city('Envigado','co','Antioquia',163010.0,-75.56,6.16).
city('Fredonia','co','Antioquia',8951.0,-75.67,5.92).
city('Frontino','co','Antioquia',8603.0,-76.13,6.78).
city('Giraldo','co','Antioquia',1464.0,-75.99,6.68).
city('Girardota','co','Antioquia',23816.0,-75.45,6.39).
city('Gomez Plata','co','Antioquia',4097.0,-75.22,6.68).
city('Granada','co','Antioquia',5661.0,-75.19,6.15).
city('Guadalupe','co','Antioquia',1734.0,-75.24,6.82).
city('Guarne','co','Antioquia',14270.0,-75.44,6.29).
city('Guatape','co','Antioquia',5389.0,-75.16,6.24).
city('Heliconia','co','Antioquia',2403.0,-75.73,6.21).
city('Hispania','co','Antioquia',2468.0,-75.91,5.8).
city('Itaguei','co','Antioquia',281858.0,-75.62,6.17).
city('Ituang','co','Antioquia',10770.0,-75.74,7.19).
city('Jardin','co','Antioquia',7747.0,-75.82,5.58).
city('Jerico','co','Antioquia',7750.0,-75.78,5.78).
city('La Ceja','co','Antioquia',36585.0,-75.44,6.04).
city('La Estrella','co','Antioquia',49387.0,-75.65,6.17).
city('La Pintada','co','Antioquia',5342.0,-75.6,5.75).
city('La Union','co','Antioquia',8361.0,-75.37,5.99).
city('Liborina','co','Antioquia',2373.0,-75.82,6.68).
city('Maceo','co','Antioquia',3109.0,-74.79,6.55).
city('Marinilla','co','Antioquia',24172.0,-75.34,6.18).
city('Medellin','co','Antioquia',2000001.0,-75.54,6.29).
city('Montebello','co','Antioquia',2007.0,-75.52,5.95).
city('Murindo','co','Antioquia',2372.0,-76.76,6.99).
city('Mutata','co','Antioquia',4811.0,-76.44,7.25).
city('Narino','co','Antioquia',3186.0,-75.18,5.61).
city('Nechi','co','Antioquia',6694.0,-74.77,8.11).
city('Necocli','co','Antioquia',10835.0,-76.79,8.43).
city('Olaya','co','Antioquia',710.0,-75.82,6.63).
city('Penol','co','Antioquia',7698.0,-75.22,6.23).
city('Peque','co','Antioquia',1793.0,-75.91,7.02).
city('Pueblorrico','co','Antioquia',5327.0,-75.84,5.79).
city('Puerto Berrio','co','Antioquia',33983.0,-74.42,6.48).
city('Puerto Nare','co','Antioquia',4414.0,-75.23,6.3).
city('Puerto Triunfo','co','Antioquia',4056.0,-74.65,5.87).
city('Remedios','co','Antioquia',6415.0,-74.53,7.03).
city('Retiro','co','Antioquia',7941.0,-75.51,6.06).
city('Rionegro','co','Antioquia',62292.0,-75.39,6.16).
city('Sabanalarga','co','Antioquia',2517.0,-75.82,6.85).
city('Sabaneta','co','Antioquia',34173.0,-75.6,6.15).
city('Salgar','co','Antioquia',6429.0,-75.99,5.97).
city('San Andres','co','Antioquia',3154.0,-75.68,6.9).
city('San Carlos','co','Antioquia',7742.0,-74.99,6.19).
city('San Francisco','co','Antioquia',2779.0,-75.98,6.12).
city('San Jeronimo','co','Antioquia',3356.0,-75.73,6.45).
city('San Jose de la Montana','co','Antioquia',2819.0,-75.68,6.85).
city('San Juan de Uraba','co','Antioquia',10825.0,-76.53,8.77).
city('San Luis','co','Antioquia',6448.0,-74.99,6.04).
city('San Pedro','co','Antioquia',8801.0,-75.56,6.46).
city('San Pedro de Uraba','co','Antioquia',11095.0,-76.37,8.27).
city('San Rafael','co','Antioquia',7245.0,-75.02,6.31).
city('San Roque','co','Antioquia',5576.0,-75.02,6.48).
city('San Vicente','co','Antioquia',5021.0,-75.34,6.23).
city('Santa Barbara','co','Antioquia',12743.0,-75.57,5.88).
city('Santa Rosa de Osos','co','Antioquia',10191.0,-75.47,6.66).
city('Santo Domingo','co','Antioquia',2873.0,-75.17,6.47).
city('Santuario','co','Antioquia',17722.0,-75.27,6.14).
city('Segovia','co','Antioquia',39938.0,-74.7,7.07).
city('Sonson','co','Antioquia',17232.0,-75.32,5.72).
city('Sopetran','co','Antioquia',4902.0,-75.75,6.5).
city('Tamesis','co','Antioquia',6407.0,-75.72,5.67).
city('Taraza','co','Antioquia',13639.0,-75.35,7.59).
city('Tarso','co','Antioquia',2700.0,-75.83,5.87).
city('Titiribi','co','Antioquia',3787.0,-75.8,6.07).
city('Toledo','co','Antioquia',4480.0,-75.86,6.98).
city('Turbo','co','Antioquia',50509.0,-76.74,8.1).
city('Uramita','co','Antioquia',2292.0,-76.17,6.9).
city('Urrao','co','Antioquia',18846.0,-76.14,6.32).
city('Valdivia','co','Antioquia',3398.0,-75.4,7.29).
city('Valparaiso','co','Antioquia',3626.0,-75.63,5.62).
city('Vegachi','co','Antioquia',9618.0,-74.8,6.77).
city('Venecia','co','Antioquia',5462.0,-75.72,5.97).
city('Vigia del Fuerte','co','Antioquia',4638.0,-76.9,6.59).
city('Yali','co','Antioquia',3908.0,-74.85,6.68).
city('Yarumal','co','Antioquia',22368.0,-75.43,6.97).
city('Yolombo','co','Antioquia',6033.0,-75.01,6.6).
city('Yondo','co','Antioquia',7516.0,-73.92,7.02).
city('Zaragoza','co','Antioquia',18795.0,-74.86,7.49).
city('Arauca','co','Arauca',69266.0,-70.76,7.08).
city('Arauquita','co','Arauca',9951.0,-71.44,7.02).
city('Cravo Norte','co','Arauca',4787.0,-70.21,6.3).
city('Fortul','co','Arauca',4607.0,-71.78,6.79).
city('Puerto Rondon','co','Arauca',3724.0,-71.1,6.28).
city('Saravena','co','Arauca',33817.0,-71.92,6.99).
city('Tame','co','Arauca',29100.0,-71.74,6.46).
city('Baranoa','co','Atlantico',44079.0,-74.92,10.8).
city('Barranquilla','co','Atlantico',1380437.0,-74.8,10.96).
city('Campo de la Cruz','co','Atlantico',22804.0,-74.89,10.39).
city('Candelaria','co','Atlantico',11427.0,-74.88,10.46).
city('Galapa','co','Atlantico',19733.0,-74.89,10.91).
city('Juan de Acosta','co','Atlantico',8655.0,-75.03,10.83).
city('Luruaco','co','Atlantico',13237.0,-75.15,10.62).
city('Malambo','co','Atlantico',101536.0,-74.77,10.86).
city('Manati','co','Atlantico',14141.0,-74.96,10.46).
city('Palmar de Varela','co','Atlantico',28085.0,-74.76,10.75).
city('Piojo','co','Atlantico',3388.0,-75.11,10.75).
city('Polo Nuevo','co','Atlantico',11727.0,-74.87,10.78).
city('Ponedera','co','Atlantico',11222.0,-74.75,10.64).
city('Puerto Colombia','co','Atlantico',26228.0,-74.95,10.99).
city('Repelon','co','Atlantico',18686.0,-75.13,10.5).
city('Sabanagrande','co','Atlantico',21167.0,-74.75,10.72).
city('Sabanalarga','co','Atlantico',68536.0,-74.92,10.64).
city('Santa Lucia','co','Atlantico',15760.0,-74.97,10.33).
city('Santo Tomas','co','Atlantico',25847.0,-74.75,10.76).
city('Soledad','co','Atlantico',342562.0,-74.77,10.92).
city('Suan','co','Atlantico',10382.0,-74.88,10.34).
city('Tubara','co','Atlantico',8181.0,-74.98,10.87).
city('Usiacuri','co','Atlantico',9147.0,-74.98,10.75).
city('Bogota','co','Bogota',7102602.0,-74.09,4.63).
city('Achi','co','Bolivar',8434.0,-74.56,8.57).
city('Altos del Rosario','co','Bolivar',5220.0,-74.17,8.79).
city('Arenal','co','Bolivar',5346.0,-73.95,8.47).
city('Arjona','co','Bolivar',50406.0,-75.35,10.26).
city('Arroyohondo','co','Bolivar',3622.0,-75.02,10.0).
city('Barranco de Loba','co','Bolivar',5933.0,-74.11,8.95).
city('Calamar','co','Bolivar',9180.0,-74.9,10.25).
city('Cantagallo','co','Bolivar',4672.0,-73.92,7.38).
city('Cartagena','co','Bolivar',952036.0,-75.5,10.4).
city('Cicuco','co','Bolivar',7662.0,-74.66,9.26).
city('Clemencia','co','Bolivar',8775.0,-75.33,10.59).
city('Cordoba','co','Bolivar',6597.0,-74.83,9.59).
city('El Carmen de Bolivar','co','Bolivar',47958.0,-75.13,9.72).
city('El Guamo','co','Bolivar',4732.0,-75.0,10.04).
city('El Penon','co','Bolivar',4204.0,-73.95,8.98).
city('Hatillo de Loba','co','Bolivar',3639.0,-74.08,8.96).
city('Magangue','co','Bolivar',100315.0,-74.74,9.23).
city('Mahates','co','Bolivar',9224.0,-75.19,10.24).
city('Margarita','co','Bolivar',1939.0,-74.29,9.15).
city('Maria la Baja','co','Bolivar',23401.0,-75.32,9.99).
city('Mompos','co','Bolivar',30862.0,-74.43,9.24).
city('Montecristo','co','Bolivar',5608.0,-74.48,8.3).
city('Morales','co','Bolivar',4773.0,-73.87,8.31).
city('Pinillos','co','Bolivar',6218.0,-74.47,8.92).
city('Regidor','co','Bolivar',3386.0,-73.83,8.67).
city('Rio Viejo','co','Bolivar',6963.0,-73.84,8.59).
city('San Cristobal','co','Bolivar',4738.0,-75.25,9.88).
city('San Estanislao','co','Bolivar',12596.0,-75.15,10.4).
city('San Fernando','co','Bolivar',1615.0,-74.53,9.28).
city('San Jacinto','co','Bolivar',20265.0,-75.14,9.83).
city('San Jacinto del Cauca','co','Bolivar',3364.0,-74.72,8.25).
city('San Juan Nepomuceno','co','Bolivar',29619.0,-75.09,9.96).
city('San Martin de Loba','co','Bolivar',8864.0,-74.04,8.94).
city('San Pablo','co','Bolivar',13984.0,-75.27,10.05).
city('Santa Catalina','co','Bolivar',6084.0,-75.29,10.61).
city('Santa Rosa','co','Bolivar',10604.0,-75.37,10.45).
city('Santa Rosa del Sur','co','Bolivar',8905.0,-74.05,7.96).
city('Simiti','co','Bolivar',6670.0,-73.95,7.97).
city('Soplaviento','co','Bolivar',8067.0,-75.14,10.39).
city('Talaigua','co','Bolivar',6217.0,-74.57,9.31).
city('Tiquisio','co','Bolivar',4255.0,-74.27,8.56).
city('Turbaco','co','Bolivar',56173.0,-75.42,10.34).
city('Turbana','co','Bolivar',10236.0,-75.44,10.28).
city('Villanueva','co','Bolivar',12792.0,-75.29,10.45).
city('Zambrano','co','Bolivar',9565.0,-74.82,9.75).
city('Almeida','co','Boyaca',754.0,-73.38,4.97).
city('Aquitania','co','Boyaca',5718.0,-72.89,5.52).
city('Arcabuco','co','Boyaca',1564.0,-73.43,5.75).
city('Belen','co','Boyaca',5411.0,-72.92,5.99).
city('Berbeo','co','Boyaca',266.0,-73.13,5.22).
city('Beteitiva','co','Boyaca',374.0,-72.82,5.92).
city('Boavita','co','Boyaca',3749.0,-72.59,6.33).
city('Boyaca','co','Boyaca',731.0,-73.35,5.45).
city('Briceno','co','Boyaca',632.0,-73.93,5.7).
city('Busbanza','co','Boyaca',164.0,-72.87,5.82).
city('Caldas','co','Boyaca',475.0,-73.87,5.56).
city('Campohermoso','co','Boyaca',695.0,-73.11,5.03).
city('Cerinza','co','Boyaca',1499.0,-72.95,5.95).
city('Chinavita','co','Boyaca',1113.0,-73.37,5.17).
city('Chiquinquira','co','Boyaca',45295.0,-73.82,5.62).
city('Chiquiza','co','Boyaca',730.0,-73.49,5.61).
city('Chiscas','co','Boyaca',1356.0,-72.5,6.54).
city('Chita','co','Boyaca',2914.0,-72.48,6.19).
city('Chitaraque','co','Boyaca',1124.0,-73.37,6.08).
city('Chivata','co','Boyaca',664.0,-73.27,5.53).
city('Chivor','co','Boyaca',1622.0,-73.37,4.89).
city('Cienega','co','Boyaca',1172.0,-73.3,5.4).
city('Combita','co','Boyaca',1034.0,-73.33,5.63).
city('Coper','co','Boyaca',814.0,-74.05,5.48).
city('Corrales','co','Boyaca',1561.0,-72.85,5.83).
city('Covarachia','co','Boyaca',590.0,-72.74,6.5).
city('Cubara','co','Boyaca',1466.0,-72.07,7.04).
city('Cucaita','co','Boyaca',1417.0,-73.47,5.53).
city('Cuitiva','co','Boyaca',233.0,-72.97,5.58).
city('Duitama','co','Boyaca',92041.0,-73.02,5.83).
city('El Cocuy','co','Boyaca',2706.0,-72.45,6.41).
city('El Espino','co','Boyaca',1313.0,-72.43,6.49).
city('Firavitoba','co','Boyaca',2136.0,-73.0,5.65).
city('Floresta','co','Boyaca',1127.0,-72.92,5.86).
city('Gachantiva','co','Boyaca',534.0,-73.55,5.77).
city('Gameza','co','Bo',1690.0,-72.81,5.81).
city('Garagoa','co','Boyaca',11102.0,-73.37,5.08).
city('Guacamayas','co','Boyaca',772.0,-72.5,6.4).
city('Guateque','co','Boyaca',7069.0,-73.52,5.01).
city('Guayata','co','Boyaca',2857.0,-73.49,4.96).
city('Gueican','co','Boyaca',2101.0,-72.42,6.47).
city('Iza','co','Boyaca',748.0,-72.98,5.6).
city('Jenesano','co','Boyaca',1200.0,-73.37,5.39).
city('Jerico','co','Boyaca',865.0,-72.56,6.15).
city('La Capilla','co','Boyaca',1375.0,-73.48,5.7).
city('La Uvita','co','Boyaca',1708.0,-72.56,6.32).
city('La Victoria','co','Boyaca',314.0,-74.23,5.52).
city('Labranzagrande','co','Boyaca',902.0,-72.56,5.57).
city('Leiva','co','Boyaca',5103.0,-73.57,5.63).
city('Macanal','co','Boyaca',734.0,-73.32,4.98).
city('Maripi','co','Boyaca',1143.0,-74.01,5.55).
city('Miraflores','co','Boyaca',2766.0,-73.15,5.2).
city('Mongua','co','Boyaca',2322.0,-72.8,5.76).
city('Mongui','co','Boyaca',2299.0,-72.83,5.72).
city('Moniquira','co','Boyaca',9785.0,-73.59,5.89).
city('Motavita','co','Boyaca',392.0,-73.37,5.58).
city('Muzo','co','Boyaca',7977.0,-74.11,5.53).
city('Nobsa','co','Boyaca',3360.0,-72.95,5.77).
city('Nuevo Colon','co','Boyaca',863.0,-73.47,5.35).
city('Oicata','co','Boyaca',327.0,-73.32,5.6).
city('Otanche','co','Boyaca',3589.0,-74.19,5.66).
city('Pachavita','co','Boyaca',959.0,-73.4,5.13).
city('Paez','co','Boyaca',1220.0,-73.06,5.1).
city('Paipa','co','Boyaca',13554.0,-73.11,5.78).
city('Pa','co','Boyaca',1258.0,-72.71,5.29).
city('Panqueba','co','Boyaca',668.0,-72.47,6.43).
city('Pauna','co','Boyaca',2663.0,-73.98,5.66).
city('Paya','co','Boyaca',336.0,-72.43,5.63).
city('Paz del Rio','co','Boyaca',3427.0,-72.75,6.08).
city('Pesca','co','Boyaca',5113.0,-73.05,5.55).
city('Pisba','co','Boyaca',307.0,-72.48,5.72).
city('Puerto Boyaca','co','Boyaca',27311.0,-74.59,5.98).
city('Quipama','co','Boyaca',3571.0,-74.18,5.52).
city('Ramiriqui','co','Boyaca',5039.0,-73.34,5.4).
city('Raquira','co','Boyaca',2120.0,-73.64,5.54).
city('Rondon','co','Boyaca',504.0,-73.21,5.36).
city('Saboya','co','Boyaca',1375.0,-73.77,5.7).
city('Sachica','co','Boyaca',1774.0,-73.55,5.58).
city('Samaca','co','Boyaca',3689.0,-73.49,5.49).
city('San Eduardo','co','Boyaca',524.0,-73.05,5.2).
city('San Jose de Pare','co','Boyaca',941.0,-73.54,6.02).
city('San Luis de Gaceno','co','Boyaca',2579.0,-73.17,4.82).
city('San Mateo','co','Boyaca',1634.0,-72.56,6.41).
city('San Miguel','co','Boyaca',647.0,-73.73,5.52).
city('San Pablo de Borbur','co','Boyaca',1519.0,-74.06,5.66).
city('Santa Maria','co','Boyaca',2238.0,-73.26,4.86).
city('Santa Rosa de Viterbo','co','Boyaca',6924.0,-72.97,5.89).
city('Santa Sofia','co','Boyaca',1058.0,-73.6,5.72).
city('Santana','co','Boyaca',2091.0,-73.48,6.06).
city('Sativanorte','co','Boyaca',792.0,-72.71,6.13).
city('Sativasur','co','Boyaca',579.0,-72.73,6.08).
city('Siachoque','co','Boyaca',1375.0,-73.23,5.5).
city('Soata','co','Boyaca',10945.0,-72.7,6.33).
city('Socha','co','Boyaca',3353.0,-72.72,5.98).
city('Socota','co','Boyaca',2194.0,-72.64,6.04).
city('Sogamoso','co','Boyaca',126553.0,-72.94,5.72).
city('Somondoco','co','Boyaca',1029.0,-73.44,4.99).
city('Sora','co','Boyaca',508.0,-73.43,5.57).
city('Soraca','co','Boyaca',827.0,-73.32,5.5).
city('Sotaquira','co','Boyaca',1352.0,-73.25,5.77).
city('Susacon','co','Boyaca',1207.0,-72.69,6.23).
city('Sutamarchan','co','Boyaca',1432.0,-73.63,5.6).
city('Sutatenza','co','Boyaca',827.0,-73.45,5.02).
city('Tasco','co','Boyaca',1811.0,-72.78,5.92).
city('Tenza','co','Boyaca',1312.0,-73.42,5.08).
city('Tibana','co','Boyaca',1802.0,-73.4,5.32).
city('Tibasosa','co','Boyaca',3535.0,-73.0,5.75).
city('Tinjaca','co','Boyaca',400.0,-73.65,5.57).
city('Tipacoque','co','Boyaca',1036.0,-72.7,6.42).
city('Toca','co','Boyaca',3946.0,-73.2,5.57).
city('Toguei','co','Boyaca',829.0,-73.52,5.39).
city('Topaga','co','Boyaca',1014.0,-72.84,5.77).
city('Tota','co','Boyaca',774.0,-72.99,5.56).
city('Tunja','co','Boyaca',117480.0,-73.37,5.55).
city('Tunungua','co','Boyaca',178.0,-73.93,5.73).
city('Turmeque','co','Boyaca',2901.0,-73.5,5.32).
city('Tuta','co','Boyaca',1639.0,-73.23,5.69).
city('Tutasa','co','Boyaca',292.0,-72.87,6.05).
city('Umbita','co','Boyaca',1295.0,-73.45,5.23).
city('Ventaquemada','co','Boyaca',1680.0,-73.53,5.37).
city('Viracacha','co','Boyaca',541.0,-73.3,5.43).
city('Zetaquira','co','Boyaca',1047.0,-73.17,5.29).
city('Aguadas','co','Caldas',19727.0,-75.45,5.6).
city('Anserma','co','Caldas',25242.0,-75.8,5.33).
city('Aranzazu','co','Caldas',9327.0,-75.49,5.27).
city('Belalcazar','co','Caldas',6367.0,-75.82,5.01).
city('Chinchina','co','Caldas',68513.0,-75.6,4.98).
city('Filadelfia','co','Caldas',5064.0,-75.56,5.31).
city('La Dorada','co','Caldas',81951.0,-74.67,5.47).
city('La Merced','co','Caldas',3851.0,-75.88,5.4).
city('Manizales','co','Caldas',357819.0,-75.5,5.06).
city('Manzanares','co','Caldas',16278.0,-75.16,5.32).
city('Marmato','co','Caldas',1456.0,-75.6,5.48).
city('Marquetalia','co','Caldas',6224.0,-75.06,5.3).
city('Marulanda','co','Caldas',1256.0,-75.26,5.29).
city('Neira','co','Caldas',11755.0,-75.53,5.16).
city('Norcasia','co','Caldas',5976.0,-74.88,5.57).
city('Pacora','co','Caldas',8218.0,-75.46,5.53).
city('Palestina','co','Caldas',7865.0,-75.64,5.02).
city('Pensilvania','co','Caldas',8173.0,-75.17,5.39).
city('Riosucio','co','Caldas',18950.0,-75.72,5.42).
city('Risaralda','co','Caldas',5421.0,-75.77,5.17).
city('Salamina','co','Caldas',18076.0,-75.48,5.41).
city('Samana','co','Caldas',7781.0,-74.92,5.58).
city('San Jose','co','Caldas',1724.0,-75.79,5.09).
city('Supia','co','Caldas',12784.0,-75.66,5.46).
city('Victoria','co','Caldas',4723.0,-74.92,5.32).
city('Villamaria','co','Caldas',35303.0,-75.52,5.04).
city('Viterbo','co','Caldas',15216.0,-75.88,5.07).
city('Albania','co','Caqueta',4160.0,-75.0,1.33).
city('Belen Andaquies','co','Caqueta',3937.0,-75.87,1.42).
city('Cartagena del Chaira','co','Caqueta',7586.0,-74.85,1.34).
city('Curillo','co','Caqueta',9540.0,-75.92,1.04).
city('El Doncello','co','Caqueta',13082.0,-75.28,1.68).
city('El Paujil','co','Caqueta',7619.0,-75.33,1.58).
city('Florencia','co','Caqueta',130339.0,-75.62,1.61).
city('La Montanita','co','Caqueta',3305.0,-75.44,1.48).
city('Milan','co','Caqueta',2618.0,-75.51,1.35).
city('Morelia','co','Caqueta',2257.0,-75.73,1.49).
city('Puerto Rico','co','Caqueta',12306.0,-75.16,1.91).
city('San Jose de Fragua','co','Caqueta',3632.0,-75.99,1.36).
city('San Vicente del Caguan','co','Caqueta',15073.0,-74.64,2.07).
city('Solano','co','Caqueta',2973.0,-75.25,0.71).
city('Valparaiso','co','Caqueta',3767.0,-75.71,1.2).
city('Aguazul','co','Casanare',15670.0,-72.56,5.18).
city('Chameza','co','Casanare',948.0,-72.88,5.22).
city('Hato Corozal','co','Casanare',2640.0,-71.77,6.16).
city('La Salina','co','Casanare',360.0,-72.34,6.13).
city('Mani','co','Casanare',7031.0,-72.29,4.82).
city('Monterrey','co','Casanare',7759.0,-72.9,4.88).
city('Nunchia','co','Casanare',1282.0,-72.2,5.64).
city('Orocue','co','Casanare',2835.0,-71.34,4.79).
city('Paz de Ariporo','co','Casanare',16666.0,-71.9,5.88).
city('Pore','co','Casanare',4134.0,-72.0,5.73).
city('Recetor','co','Casanare',205.0,-72.76,5.23).
city('Sabanalarga','co','Casanare',1419.0,-73.04,4.85).
city('Sacama','co','Casanare',744.0,-72.25,6.1).
city('San Luis de Palenque','co','Casanare',2032.0,-71.74,5.43).
city('Tamara','co','Casanare',2007.0,-72.17,5.83).
city('Tauramena','co','Casanare',4805.0,-72.76,5.02).
city('Trinidad','co','Casanare',4752.0,-71.63,5.43).
city('Villanueva','co','Casanare',20033.0,-71.97,5.28).
city('Yopal','co','Casanare',61031.0,-72.41,5.35).
city('Almaguer','co','Cauca',3120.0,-76.86,1.92).
city('Argelia','co','Cauca',4262.0,-77.28,2.24).
city('Balboa','co','Cauca',6272.0,-77.22,2.04).
city('Bolivar','co','Cauca',15493.0,-76.97,1.84).
city('Buenos Aires','co','Cauca',2144.0,-76.64,3.02).
city('Cajibio','co','Cauca',3365.0,-76.63,2.63).
city('Caldono','co','Cauca',3518.0,-76.54,2.8).
city('Caloto','co','Cauca',6479.0,-76.41,3.04).
city('Corinto','co','Cauca',16579.0,-76.26,3.18).
city('El Bordo','co','Cauca',12072.0,-76.99,2.12).
city('El Tambo','co','Cauca',6355.0,-76.82,2.45).
city('Florencia','co','Cauca',1467.0,-77.08,1.69).
city('Guapi','co','Cauca',13854.0,-77.86,2.56).
city('Inza','co','Cauca',2972.0,-76.07,2.56).
city('Jambalo','co','Cauca',1972.0,-76.33,2.79).
city('La Sierra','co','Cauca',2129.0,-76.76,2.18).
city('La Vega','co','Cauca',3469.0,-76.78,2.0).
city('Lopez','co','Cauca',3700.0,-76.8,2.43).
city('Mercaderes','co','Cauca',4684.0,-77.17,1.8).
city('Miranda','co','Cauca',13223.0,-76.24,3.25).
city('Morales','co','Cauca',4074.0,-76.63,2.76).
city('Padilla','co','Cauca',4472.0,-76.32,3.23).
city('Paez','co','Cauca',5179.0,-75.99,2.65).
city('Piendamo','co','Cauca',15061.0,-76.52,2.64).
city('Popayan','co','Cauca',217965.0,-76.61,2.42).
city('Puerto Tejada','co','Cauca',53675.0,-76.42,3.24).
city('Purace','co','Cauca',4837.0,-76.5,2.35).
city('Rosas','co','Cauca',1830.0,-76.74,2.26).
city('San Sebastian','co','Cauca',931.0,-76.77,1.84).
city('Santa Rosa','co','Cauca',2385.0,-76.5,1.5).
city('Santander de Quilichao','co','Cauca',40799.0,-76.49,3.01).
city('Silvia','co','Cauca',7474.0,-76.38,2.61).
city('Sotara','co','Cauca',1390.0,-76.62,2.26).
city('Suarez','co','Cauca',9986.0,-76.7,2.95).
city('Sucre','co','Cauca',2552.0,-76.92,2.03).
city('Timbio','co','Cauca',9606.0,-76.69,2.37).
city('Timbiqui','co','Cauca',6267.0,-77.63,2.76).
city('Toribio','co','Cauca',3912.0,-76.27,2.96).
city('Totoro','co','Cauca',1888.0,-76.4,2.49).
city('Villa Rica','co','Cauca',9070.0,-76.85,2.51).
city('Aguachica','co','Cesar',73361.0,-73.62,8.31).
city('Agustin Codazzi','co','Cesar',51479.0,-73.25,10.05).
city('Astrea','co','Cesar',8996.0,-73.98,9.5).
city('Becerril','co','Cesar',9002.0,-73.29,9.7).
city('Bosconia','co','Cesar',24508.0,-73.85,9.9).
city('Chimichagua','co','Cesar',16746.0,-73.82,9.26).
city('Chiriguana','co','Cesar',15181.0,-73.61,9.37).
city('Curumani','co','Cesar',22085.0,-73.54,9.2).
city('El Copey','co','Cesar',18137.0,-73.97,10.15).
city('El Paso','co','Cesar',6367.0,-73.75,9.66).
city('Gamarra','co','Cesar',7327.0,-73.74,8.33).
city('Gonzalez','co','Cesar',5634.0,-73.38,8.39).
city('La Gloria','co','Cesar',6810.0,-73.81,8.62).
city('La Jagua Ibirico','co','Cesar',18555.0,-73.34,9.58).
city('Manaure','co','Cesar',7953.0,-73.03,10.39).
city('Pailitas','co','Cesar',10481.0,-73.62,8.96).
city('Pelaya','co','Cesar',11306.0,-73.67,8.68).
city('Pueblo Bello','co','Cesar',6295.0,-73.63,10.37).
city('Rio de Oro','co','Cesar',6122.0,-73.39,8.29).
city('Robles la Paz','co','Cesar',13249.0,-73.17,10.38).
city('San Alberto','co','Cesar',10628.0,-73.39,7.75).
city('San Diego','co','Cesar',8014.0,-73.19,10.33).
city('San Martin','co','Cesar',7029.0,-73.52,8.0).
city('Tamalameque','co','Cesar',4972.0,-73.82,8.86).
city('Valledupar','co','Cesar',308242.0,-73.25,10.48).
city('Acandi','co','Choco',4840.0,-77.23,8.53).
city('Alto Baudo','co','Choco',3242.0,-77.0,5.53).
city('Bagado','co','Choco',4561.0,-76.42,5.41).
city('Bajo Baudo','co','Choco',6168.0,-77.38,4.94).
city('Bojaya','co','Choco',1396.0,-76.97,6.52).
city('Canton de San Pablo','co','Choco',3271.0,-76.73,5.34).
city('Certegui','co','Choco',2855.0,-76.6,5.4).
city('Condoto','co','Choco',9898.0,-76.65,5.1).
city('El Carmen','co','Choco',2258.0,-75.16,5.89).
city('Istmina','co','Choco',13788.0,-76.69,5.16).
city('Jurado','co','Choco',2351.0,-77.77,7.11).
city('Litoral del San Juan','co','Choco',1448.0,-77.37,4.26).
city('Lloro','co','Choco',2651.0,-76.53,5.5).
city('Mutis','co','Choco',3079.0,-77.41,6.22).
city('Novita','co','Choco',1898.0,-76.62,4.96).
city('Nuqui','co','Choco',2741.0,-77.27,5.71).
city('Quibdo','co','Choco',75105.0,-76.66,5.69).
city('Riosucio','co','Choco',7163.0,-77.11,7.44).
city('San Jose del Palmar','co','Choco',2392.0,-76.23,4.97).
city('Sipi','co','Choco',332.0,-76.48,4.66).
city('Tado','co','Choco',10095.0,-76.57,5.27).
city('Unguia','co','Choco',4179.0,-77.1,8.04).
city('Ayapel','co','Cordoba',22602.0,-75.15,8.33).
city('Buenavista','co','Cordoba',5062.0,-76.0,9.05).
city('Canalete','co','Cordoba',2620.0,-76.2,8.68).
city('Cerete','co','Cordoba',55514.0,-75.79,8.89).
city('Chima','co','Cordoba',2785.0,-75.63,9.15).
city('Chinu','co','Cordoba',19596.0,-75.4,9.11).
city('Cienaga de Oro','co','Cordoba',17623.0,-75.62,8.88).
city('Cotorra','co','Cordoba',4880.0,-75.8,9.05).
city('La Apartada','co','Cordoba',10285.0,-75.38,8.1).
city('Lorica','co','Cordoba',40606.0,-75.81,9.24).
city('Los Cordobas','co','Cordoba',2007.0,-76.36,8.9).
city('Momil','co','Cordoba',6441.0,-75.68,9.24).
city('Monitos','co','Cordoba',5385.0,-76.05,8.25).
city('Montelibano','co','Cordoba',34162.0,-74.1,9.58).
city('Monteria','co','Cordoba',272424.0,-75.89,8.76).
city('Planeta Rica','co','Cordoba',37298.0,-75.58,8.42).
city('Pueblo Nuevo','co','Cordoba',9076.0,-74.96,8.23).
city('Puerto Escondido','co','Cordoba',3020.0,-76.25,9.02).
city('Purisima','co','Cordoba',7043.0,-75.74,9.24).
city('Sahagun','co','Cordoba',59189.0,-75.44,8.95).
city('San Andres Sotavento','co','Cordoba',6646.0,-75.51,9.15).
city('San Antero','co','Cordoba',11610.0,-75.76,9.39).
city('San Bernardo Viento','co','Cordoba',8968.0,-75.96,9.36).
city('San Carlos','co','Cordoba',3447.0,-75.71,8.74).
city('San Pelayo','co','Cordoba',5637.0,-75.84,8.96).
city('Tierralta','co','Cordoba',26242.0,-76.07,8.18).
city('Valencia','co','Cordoba',10653.0,-76.15,8.27).
city('Agua de Dios','co','Cundinamarca',10876.0,-74.67,4.38).
city('Alban','co','Cundinamarca',1684.0,-74.45,4.87).
city('Anapoima','co','Cundinamarca',4953.0,-74.54,4.52).
city('Anolaima','co','Cundinamarca',5585.0,-74.47,4.76).
city('Arbelaez','co','Cundinamarca',5252.0,-74.42,4.27).
city('Beltran','co','Cundinamarca',296.0,-74.75,4.81).
city('Bituima','co','Cundinamarca',473.0,-74.54,4.87).
city('Bojaca','co','Cundinamarca',4399.0,-74.35,4.73).
city('Cabrera','co','Cundinamarca',1397.0,-74.49,3.98).
city('Cachipay','co','Cundinamarca',4260.0,-74.57,5.27).
city('Cajica','co','Cundinamarca',25000.0,-74.03,4.92).
city('Caparrapi','co','Cundinamarca',4477.0,-74.5,5.35).
city('Caqueza','co','Cundinamarca',7958.0,-73.95,4.42).
city('Carmen de Carupa','co','Cundinamarca',1928.0,-73.91,5.35).
city('Chaguani','co','Cundinamarca',1108.0,-74.6,4.95).
city('Chia','co','Cundinamarca',64570.0,-74.07,4.87).
city('Chipaque','co','Cundinamarca',2707.0,-74.04,4.44).
city('Choachi','co','Cundinamarca',4281.0,-73.93,4.53).
city('Choconta','co','Cundinamarca',7592.0,-73.68,5.15).
city('Cogua','co','Cundinamarca',4755.0,-73.98,5.07).
city('Cota','co','Cundinamarca',7615.0,-74.1,4.82).
city('Cucunuba','co','Cundinamarca',1699.0,-73.77,5.25).
city('El Colegio','co','Cundinamarca',10615.0,-74.45,4.59).
city('El Penon','co','Cundinamarca',728.0,-74.29,5.25).
city('El Rosal','co','Cundinamarca',5552.0,-74.27,4.85).
city('Facatativa','co','Cundinamarca',94613.0,-74.37,4.82).
city('Fomeque','co','Cundinamarca',5390.0,-73.9,4.49).
city('Fosca','co','Cundinamarca',1451.0,-73.94,4.34).
city('Funza','co','Cundinamarca',54422.0,-74.21,4.71).
city('Fuquene','co','Cundinamarca',563.0,-73.8,5.41).
city('Fusagasuga','co','Cundinamarca',88822.0,-74.37,4.34).
city('Gachala','co','Cundinamarca',1661.0,-73.52,4.7).
city('Gacha','co','Cundinamarca',3119.0,-73.88,5.0).
city('Gacheta','co','Cundinamarca',4088.0,-73.64,4.82).
city('Gama','co','Cundinamarca',584.0,-73.61,4.77).
city('Girardot','co','Cundinamarca',130292.0,-74.81,4.31).
city('Granada','co','Cundinamarca',1100.0,-74.57,5.07).
city('Guacheta','co','Cundinamarca',4246.0,-73.69,5.39).
city('Guaduas','co','Cundinamarca',14392.0,-74.6,5.06).
city('Guasca','co','Cundinamarca',3540.0,-73.88,4.87).
city('Guataqui','co','Cundinamarca',1139.0,-74.8,4.53).
city('Guatavita','co','Cundinamarca',1920.0,-73.83,4.94).
city('Guayabal de Siquima','co','Cundinamarca',1051.0,-74.47,4.88).
city('Guayabetal','co','Cundinamarca',2017.0,-73.81,4.22).
city('Gutierrez','co','Cundinamarca',772.0,-74.0,4.25).
city('Jerusalen','co','Cundinamarca',697.0,-74.7,4.57).
city('Junin','co','Cundinamarca',1499.0,-73.64,4.8).
city('La Calera','co','Cundinamarca',10175.0,-73.97,4.72).
city('La Mesa','co','Cundinamarca',14072.0,-74.47,4.63).
city('La Palma','co','Cundinamarca',8093.0,-74.38,5.34).
city('La Pena','co','Cundinamarca',1667.0,-74.4,5.2).
city('La Vega','co','Cundinamarca',5706.0,-74.34,5.0).
city('Lenguazaque','co','Cundinamarca',2555.0,-73.72,5.3).
city('Macheta','co','Cundinamarca',1742.0,-73.62,5.08).
city('Madrid','co','Cundinamarca',50438.0,-74.27,4.74).
city('Manta','co','Cundinamarca',1410.0,-73.55,5.02).
city('Medina','co','Cundinamarca',3098.0,-73.35,4.51).
city('Mosquera','co','Cundinamarca',27006.0,-74.23,4.72).
city('Narino','co','Cundinamarca',1213.0,-74.84,4.4).
city('Nemocon','co','Cundinamarca',5467.0,-73.88,5.05).
city('Nilo','co','Cundinamarca',1117.0,-74.61,4.31).
city('Nimaima','co','Cundinamarca',604.0,-74.39,5.13).
city('Nocaima','co','Cundinamarca',2475.0,-74.38,5.07).
city('Ospina Perez','co','Cundinamarca',1307.0,-74.48,4.09).
city('Pacho','co','Cundinamarca',16698.0,-74.17,5.14).
city('Paime','co','Cundinamarca',799.0,-74.15,5.37).
city('Pandi','co','Cundinamarca',1336.0,-74.49,4.19).
city('Paratebueno','co','Cundinamarca',2027.0,-73.22,4.37).
city('Pasca','co','Cundinamarca',3169.0,-74.3,4.31).
city('Puerto Salgar','co','Cundinamarca',9864.0,-74.66,5.47).
city('Puli','co','Cundinamarca',596.0,-74.72,4.69).
city('Quebradanegra','co','Cundinamarca',753.0,-74.48,5.12).
city('Quetame','co','Cundinamarca',1374.0,-73.87,4.33).
city('Quipile','co','Cundinamarca',1896.0,-74.56,4.75).
city('Rafael Reyes','co','Cundinamarca',4084.0,-74.6,4.52).
city('Ricaurte','co','Cundinamarca',2682.0,-74.78,4.28).
city('San Antonio del Tequendama','co','Cundinamarca',1577.0,-74.35,4.62).
city('San Bernardo','co','Cundinamarca',7625.0,-74.42,4.17).
city('San Cayetano','co','Cundinamarca',699.0,-74.07,5.3).
city('San Francisco','co','Cundinamarca',2785.0,-74.29,4.98).
city('San Juan de Rioseco','co','Cundinamarca',3349.0,-74.67,4.92).
city('Sasaima','co','Cundinamarca',2948.0,-74.44,4.9).
city('Sesquile','co','Cundinamarca',1876.0,-73.8,5.05).
city('Sibate','co','Cundinamarca',23208.0,-74.26,4.49).
city('Silvania','co','Cundinamarca',8237.0,-74.39,4.42).
city('Simijaca','co','Cundinamarca',4767.0,-73.86,5.51).
city('Soacha','co','Cundinamarca',313950.0,-74.22,4.58).
city('Sopo','co','Cundinamarca',8396.0,-73.92,4.92).
city('Subachoque','co','Cundinamarca',4088.0,-74.18,4.93).
city('Suesca','co','Cundinamarca',4877.0,-73.8,5.1).
city('Supata','co','Cundinamarca',1907.0,-74.25,5.05).
city('Susa','co','Cundinamarca',1609.0,-73.82,5.45).
city('Sutatausa','co','Cundinamarca',1332.0,-73.86,5.25).
city('Tabio','co','Cundinamarca',4180.0,-74.1,4.92).
city('Tausa','co','Cundinamarca',895.0,-73.89,5.2).
city('Tena','co','Cundinamarca',696.0,-74.37,4.66).
city('Tenjo','co','Cundinamarca',3858.0,-74.15,4.87).
city('Tibacuy','co','Cundinamarca',1028.0,-72.46,4.35).
city('Tibirita','co','Cundinamarca',920.0,-73.51,5.05).
city('Tocaima','co','Cundinamarca',10235.0,-74.64,4.47).
city('Tocancipa','co','Cundinamarca',6027.0,-73.91,4.97).
city('Topaipi','co','Cundinamarca',1099.0,-74.31,5.34).
city('Ubala','co','Cundinamarca',1886.0,-72.54,4.75).
city('Ubaque','co','Cundinamarca',1009.0,-73.93,4.48).
city('Ubate','co','Cundinamarca',20486.0,-73.82,5.32).
city('Une','co','Cundinamarca',3208.0,-74.03,4.4).
city('Utica','co','Cundi',2945.0,-74.48,5.18).
city('Vergara','co','Cundinamarca',2267.0,-74.35,5.12).
city('Viani','co','Cundinamarca',1586.0,-74.57,4.88).
city('Villagomez','co','Cundinamarca',779.0,-74.2,5.28).
city('Villapinzon','co','Cundinamarca',5874.0,-73.6,5.22).
city('Villeta','co','Cundinamarca',20689.0,-74.49,5.02).
city('Viota','co','Cundinamarca',5840.0,-74.53,4.44).
city('Yacopi','co','Cundinamarca',3202.0,-74.34,5.47).
city('Zipacon','co','Cundinamarca',1480.0,-74.38,4.75).
city('Zipaquira','co','Cundinamarca',91237.0,-74.01,5.03).
city('Inirida','co','Guainia',7299.0,-67.92,3.87).
city('Calamar','co','Guaviare',3745.0,-72.65,1.96).
city('El Retorno','co','Guaviare',3362.0,-72.63,2.33).
city('Miraflores','co','Guaviare',4864.0,-71.95,1.34).
city('San Jose del Guaviare','co','Guaviare',22136.0,-72.64,2.57).
city('Acevedo','co','Huila',4451.0,-75.9,1.82).
city('Agrado','co','Huila',4531.0,-75.77,2.26).
city('Aipe','co','Huila',7964.0,-75.24,3.23).
city('Algeciras','co','Huila',10792.0,-75.32,2.53).
city('Alta','co','Huila',2123.0,-75.79,2.06).
city('Baraya','co','Huila',4402.0,-75.06,3.16).
city('Campoalegre','co','Huila',22569.0,-75.33,2.69).
city('Colombia','co','Huila',2388.0,-74.81,3.38).
city('Elias','co','Huila',1117.0,-75.94,2.02).
city('Garzon','co','Huila',29452.0,-75.65,2.21).
city('Gigante','co','Huila',9829.0,-75.56,2.39).
city('Guadalupe','co','Huila',4761.0,-75.76,2.03).
city('Hobo','co','Huila',4445.0,-75.45,2.58).
city('Iquira','co','Huila',3942.0,-75.0,2.65).
city('Isnos','co','Huila',5185.0,-76.24,1.94).
city('La Argentina','co','Huila',3082.0,-75.98,2.2).
city('La Plata','co','Huila',19276.0,-75.89,2.39).
city('Nataga','co','Huila',2232.0,-75.83,2.55).
city('Neiva','co','Huila',352859.0,-75.27,2.94).
city('Oporapa','co','Huila',2310.0,-75.97,2.04).
city('Paicol','co','Huila',1681.0,-75.77,2.45).
city('Palermo','co','Huila',9896.0,-75.44,2.89).
city('Palestina','co','Huila',2028.0,-76.07,1.75).
city('Pital','co','Huila',3957.0,-75.8,2.27).
city('Pitalito','co','Huila',53686.0,-76.06,1.86).
city('Rivera','co','Huila',8044.0,-75.26,2.78).
city('Saladoblanco','co','Huila',1662.0,-76.05,2.01).
city('San Agustin','co','Huila',9481.0,-76.27,1.88).
city('Santa Maria','co','Huila',2761.0,-75.65,2.95).
city('Suaza','co','Huila',2481.0,-75.82,1.98).
city('Tarqui','co','Huila',4144.0,-75.82,2.11).
city('Tello','co','Huila',4868.0,-75.14,3.07).
city('Teruel','co','Huila',3921.0,-75.57,2.74).
city('Tesalia','co','Huila',3981.0,-75.73,2.49).
city('Timana','co','Huila',8203.0,-75.94,1.98).
city('Villavieja','co','Huila',2730.0,-75.22,3.22).
city('Yaguara','co','Huila',5724.0,-75.52,2.67).
city('Albania','co','La Guajira',6365.0,-72.59,11.16).
city('Barrancas','co','La Guajira',17350.0,-72.79,10.96).
city('Dibulla','co','La Guajira',4402.0,-73.31,11.27).
city('Distraccion','co','La Guajira',4742.0,-72.89,10.9).
city('El Molino','co','La Guajira',5265.0,-72.92,10.65).
city('Fonseca','co','La Guajira',23510.0,-72.85,10.89).
city('Hatonuevo','co','La Guajira',6993.0,-72.77,11.07).
city('La Jagua del Pilar','co','La Guajira',894.0,-73.08,10.52).
city('Maicao','co','La Guajira',130351.0,-72.24,11.39).
city('Manaure','co','La Guajira',9703.0,-72.45,11.78).
city('Riohacha','co','La Guajira',92433.0,-72.91,11.54).
city('San Juan del Cesar','co','La Guajira',26849.0,-73.01,10.77).
city('Uribia','co','La Guajira',7519.0,-72.27,11.72).
city('Urumita','co','La Guajira',8509.0,-73.02,10.57).
city('Villanueva','co','La Guajira',18700.0,-72.98,10.62).
city('Algarrobo','co','Magdalena',10042.0,-74.57,10.18).
city('Aracataca','co','Magdalena',27704.0,-74.19,10.6).
city('Ariguani','co','Magdalena',26246.0,-74.0,10.25).
city('Cerro San Antonio','co','Magdalena',7058.0,-74.87,10.33).
city('Chivolo','co','Magdalena',11457.0,-74.64,10.02).
city('Cienaga','co','Magdalena',88313.0,-74.25,11.01).
city('Concordia','co','Magdalena',6625.0,-74.44,9.84).
city('El Banco','co','Magdalena',54524.0,-73.98,9.0).
city('El Pinon','co','Magdalena',7481.0,-74.83,10.41).
city('El Reten','co','Magdalena',15901.0,-74.27,10.62).
city('Fundacion','co','Magdalena',59177.0,-74.19,10.53).
city('Guamal','co','Magdalena',9016.0,-74.22,9.16).
city('Nueva Granada','co','Magdalena',2714.0,-74.39,9.8).
city('Pedraza','co','Magdalena',3677.0,-74.92,10.19).
city('Pijino','co','Magdalena',5390.0,-74.45,9.33).
city('Pivijay','co','Magdalena',33493.0,-74.62,10.47).
city('Plato','co','Magdalena',48607.0,-74.79,9.79).
city('Puebloviejo','co','Magdalena',13524.0,-74.29,11.0).
city('Remolino','co','Magdalena',8308.0,-74.72,10.7).
city('Salamina','co','Magdalena',6166.0,-74.78,10.49).
city('San Sebastian','co','Magdalena',6520.0,-74.5,9.25).
city('San Zenon','co','Magdalena',4340.0,-74.31,9.21).
city('Santa Ana','co','Magdalena',13951.0,-74.57,9.34).
city('Santa Barbara de Pinto','co','Magdalena',4363.0,-74.27,10.2).
city('Santa Marta','co','Magdalena',431788.0,-74.19,11.26).
city('Sitionuevo','co','Magdalena',11817.0,-74.68,10.78).
city('Tenerife','co','Magdalena',8476.0,-74.7,9.93).
city('Acacias','co','Meta',40628.0,-73.76,3.98).
city('Barranca de Upia','co','Meta',1178.0,-72.96,4.58).
city('Cabuyaro','co','Meta',1140.0,-72.79,4.29).
city('Castilla la Nueva','co','Meta',1543.0,-73.68,3.83).
city('Cubarral','co','Meta',2280.0,-73.84,3.77).
city('Cumaral','co','Meta',11264.0,-73.49,4.27).
city('El Calvario','co','Meta',557.0,-73.71,4.35).
city('El Castillo','co','Meta',2581.0,-73.78,3.57).
city('El Dorado','co','Meta',1011.0,-72.87,2.78).
city('Fuente de Oro','co','Meta',3610.0,-73.61,3.46).
city('Granada','co','Meta',32366.0,-73.71,3.52).
city('Guamal','co','Meta',5026.0,-73.75,3.89).
city('La Macarena','co','Meta',3466.0,-73.8,2.19).
city('La Uribe','co','Meta',2103.0,-74.4,3.22).
city('Lejanias','co','Meta',5157.0,-74.05,3.51).
city('Mapiripan','co','Meta',1993.0,-72.13,2.89).
city('Mesetas','co','Meta',4163.0,-74.04,3.38).
city('Puerto Concordia','co','Meta',4313.0,-72.76,2.68).
city('Puerto Gaitan','co','Meta',5928.0,-72.08,4.31).
city('Puerto Lleras','co','Meta',5076.0,-73.37,3.27).
city('Puerto Lopez','co','Meta',16678.0,-72.96,4.09).
city('Puerto Rico','co','Meta',5029.0,-73.21,2.94).
city('Restrepo','co','Meta',7511.0,-73.57,4.25).
city('San Carlos Guaroa','co','Meta',1604.0,-73.24,3.71).
city('San Juan de Arama','co','Meta',2636.0,-73.89,3.35).
city('San Juanito','co','Meta',396.0,-72.97,4.51).
city('San Martin','co','Meta',16274.0,-73.69,3.69).
city('Villavicencio','co','Meta',321721.0,-73.64,4.15).
city('Vista Hermosa','co','Meta',4282.0,-73.75,3.09).
city('Aldana','co','Narino',1956.0,-77.7,0.89).
city('Ancuya','co','Narino',5852.0,-77.53,1.27).
city('Arboleda','co','Narino',1736.0,-77.09,1.5).
city('Barbacoas','co','Narino',7634.0,-78.17,1.66).
city('Belen','co','Narino',3131.0,-77.02,1.6).
city('Buesaco','co','Narino',4177.0,-77.16,1.39).
city('Chachaguei','co','Narino',4899.0,-77.29,1.21).
city('Colon','co','Narino',1348.0,-77.02,1.65).
city('Consaca','co','Narino',2239.0,-77.47,1.21).
city('Contadero','co','Narino',1604.0,-77.55,0.91).
city('Cordoba','co','Narino',3784.0,-77.52,0.86).
city('Cuaspud','co','Narino',2010.0,-77.73,0.87).
city('Cumbal','co','Narino',7529.0,-77.79,0.9).
city('Cumbitara','co','Narino',1091.0,-77.58,1.65).
city('El Charco','co','Narino',6187.0,-78.02,2.49).
city('El Penol','co','Narino',2294.0,-77.43,1.43).
city('El Rosario','co','Narino',2607.0,-77.34,1.75).
city('El Tablon','co','Narino',2373.0,-77.1,1.43).
city('El Tambo','co','Narino',7279.0,-77.39,1.42).
city('Funes','co','Narino',2508.0,-77.45,1.0).
city('Guachucal','co','Narino',4014.0,-77.73,0.96).
city('Guaitarilla','co','Narino',6280.0,-77.56,1.13).
city('Gualmatan','co','Narino',2510.0,-77.57,0.92).
city('Iles','co','Narino',1879.0,-77.52,0.97).
city('Imues','co','Narino',1736.0,-77.5,1.06).
city('Ipiales','co','Narino',77730.0,-77.65,0.83).
city('La Cruz','co','Narino',8752.0,-76.97,1.6).
city('La Florida','co','Narino',2882.0,-77.41,1.3).
city('La Llanada','co','Narino',2747.0,-77.58,1.48).
city('La Tola','co','Narino',3769.0,-78.24,2.41).
city('La Union','co','Narino',15061.0,-77.13,1.61).
city('Leiva','co','Narino',3668.0,-77.31,1.94).
city('Linares','co','Narino',3512.0,-77.53,1.35).
city('Los Andes','co','Narino',4839.0,-77.5,1.52).
city('Maguei','co','Narino',2892.0,-78.22,1.94).
city('Mallama','co','Narino',1788.0,-77.85,1.14).
city('Mosquera','co','Narino',3471.0,-78.5,2.49).
city('Narino','co','Narino',2933.0,-77.37,1.27).
city('Olaya Herrera','co','Narino',9821.0,-77.49,1.27).
city('Ospina','co','Narino',2747.0,-77.57,1.06).
city('Pasto','co','Narino',382242.0,-77.28,1.21).
city('Pizarro','co','Narino',6105.0,-78.72,2.1).
city('Policarpa','co','Narino',2377.0,-77.46,1.63).
city('Potosi','co','Narino',3980.0,-77.58,0.81).
city('Providencia','co','Narino',3326.0,-77.47,1.57).
city('Puerres','co','Narino',3812.0,-77.25,1.18).
city('Pupiales','co','Narino',6760.0,-77.64,0.87).
city('Ricaurte','co','Narino',2617.0,-78.43,1.11).
city('Roberto Payan','co','Narino',1772.0,-78.27,1.69).
city('Samaniego','co','Narino',13515.0,-77.6,1.35).
city('San Bernardo','co','Narino',2988.0,-77.05,1.52).
city('San Jose','co','Narino',5455.0,-78.33,1.92).
city('San Lorenzo','co','Narino',2394.0,-77.22,1.5).
city('San Pablo','co','Narino',6522.0,-77.01,1.67).
city('San Pedro de Cartago','co','Narino',1524.0,-77.12,1.56).
city('Sandona','co','Narino',10402.0,-77.47,1.29).
city('Santa Barbara','co','Narino',4875.0,-77.97,2.44).
city('Santacruz','co','Narino',2469.0,-77.25,1.52).
city('Sapuyes','co','Narino',2628.0,-77.62,1.04).
city('Taminango','co','Narino',2919.0,-77.28,1.57).
city('Tangua','co','Narino',3348.0,-77.4,1.1).
city('Tumaco','co','Narino',86714.0,-78.81,1.81).
city('Tuquerres','co','Narino',20185.0,-77.62,1.09).
city('Yacuanquer','co','Narino',2643.0,-77.41,1.12).
city('Abrego','co','Norte de Santander',10823.0,-73.22,8.08).
city('Arboledas','co','Norte de Santander',2702.0,-72.8,7.65).
city('Bochalema','co','Norte de Santander',2511.0,-72.65,7.61).
city('Bucarasica','co','Norte de Santander',783.0,-72.87,8.04).
city('Cachira','co','Norte de Santander',2097.0,-73.05,7.75).
city('Cacota','co','Norte de Santander',1415.0,-72.65,7.27).
city('Chinacota','co','Norte de Santander',9667.0,-72.62,7.6).
city('Chitaga','co','Norte de Santander',3871.0,-72.67,7.14).
city('Convencion','co','Norte de Santander',9915.0,-73.34,8.47).
city('Cucuta','co','Norte de Santander',721406.0,-72.51,7.88).
city('Cucutilla','co','Norte de Santander',1950.0,-72.78,7.54).
city('Durania','co','Norte de Santander',3471.0,-72.66,7.72).
city('El Carmen','co','Norte de Santander',5286.0,-73.45,8.51).
city('El Tarra','co','Norte de Santander',3336.0,-73.09,8.58).
city('El Zulia','co','Norte de Santander',13521.0,-72.61,7.94).
city('Gramalote','co','Norte de Santander',3577.0,-72.8,7.89).
city('Hacari','co','Norte de Santander',1502.0,-73.15,8.32).
city('Herran','co','Norte de Santander',1648.0,-72.49,7.51).
city('La Esperanza','co','Norte de Santander',2718.0,-72.47,8.17).
city('La Playa','co','Norte de Santander',1215.0,-73.24,8.22).
city('Labateca','co','Norte de Santander',1639.0,-72.5,7.3).
city('Los Patios','co','Norte de Santander',58663.0,-72.51,7.84).
city('Lourdes','co','Norte de Santander',1500.0,-72.83,7.95).
city('Mutiscua','co','Norte de Santander',918.0,-72.75,7.3).
city('Ocana','co','Norte de Santander',83513.0,-73.35,8.24).
city('Pamplona','co','Norte de Santander',53588.0,-72.66,7.39).
city('Pamplonita','co','Norte de Santander',941.0,-72.66,7.44).
city('Puerto Santander','co','Norte de Santander',16275.0,-72.41,8.36).
city('Ragonvalia','co','Norte de Santander',3543.0,-72.48,7.58).
city('Salazar','co','Norte de Santander',4186.0,-72.83,7.8).
city('San Calixto','co','Norte de Santander',2080.0,-73.21,8.41).
city('San Cayetano','co','Norte de Santander',1430.0,-72.63,7.88).
city('Santiago','co','Norte de Santander',1032.0,-72.72,7.87).
city('Sardinata','co','Norte de Santander',7872.0,-72.8,8.09).
city('Silos','co','Norte de Santander',1300.0,-72.76,7.21).
city('Teorama','co','Norte de Santander',2215.0,-73.28,8.44).
city('Tibu','co','Norte de Santander',13566.0,-72.74,8.64).
city('Toledo','co','Norte de Santander',5911.0,-72.49,7.32).
city('Villa del Rosario','co','Norte de Santander',64952.0,-72.47,7.84).
city('Villacaro','co','Norte de Santander',1864.0,-72.98,7.92).
city('Colon','co','Putumayo',3269.0,-76.98,1.19).
city('Mocoa','co','Putumayo',22035.0,-76.63,1.15).
city('Orito','co','Putumayo',13708.0,-76.87,0.7).
city('Puerto Asis','co','Putumayo',29783.0,-76.52,0.53).
city('Puerto Guzman','co','Putumayo',4094.0,-76.59,0.97).
city('Puerto Leguizamo','co','Putumayo',9098.0,-74.78,-0.18).
city('San Francisco','co','Putumayo',4350.0,-76.88,1.18).
city('San Miguel','co','Putumayo',7186.0,-76.88,0.34).
city('Santiago','co','Putumayo',2716.0,-77.01,1.15).
city('Sibundoy','co','Putumayo',9458.0,-76.89,1.18).
city('Valle del Guamuez','co','Putumayo',9969.0,-76.92,0.45).
city('Villagarzon','co','Putumayo',7015.0,-76.63,1.04).
city('Armenia','co','Quindio',315332.0,-75.69,4.53).
city('Buenavista','co','Quindio',2084.0,-75.74,4.36).
city('Calarca','co','Quindio',62171.0,-75.64,4.54).
city('Circasia','co','Quindio',20113.0,-75.64,4.63).
city('Cordoba','co','Quindio',4063.0,-75.69,4.39).
city('Filandia','co','Quindio',6851.0,-75.66,4.67).
city('Genova','co','Quindio',7140.0,-75.77,4.32).
city('La Tebaida','co','Quindio',27099.0,-75.79,4.44).
city('Montenegro','co','Quindio',36500.0,-75.77,4.57).
city('Pijao','co','Quindio',5668.0,-75.72,4.38).
city('Quimbaya','co','Quindio',31392.0,-75.76,4.62).
city('Salento','co','Quindio',4136.0,-75.57,4.64).
city('Apia','co','Risaralda',6940.0,-75.95,5.11).
city('Balboa','co','Risaralda',2302.0,-75.96,4.95).
city('Belen de Umbria','co','Risaralda',15698.0,-75.87,5.2).
city('Dos Quebradas','co','Risaralda',179586.0,-75.67,4.83).
city('Guatica','co','Risaralda',4369.0,-75.8,5.32).
city('La Celia','co','Risaralda',4940.0,-76.02,5.04).
city('La Virginia','co','Risaralda',33836.0,-75.89,4.9).
city('Marsella','co','Risaralda',11158.0,-75.75,4.94).
city('Mistrato','co','Risaralda',6263.0,-75.89,5.29).
city('Pereira','co','Risaralda',440123.0,-75.68,4.81).
city('Pueblo Rico','co','Risaralda',4165.0,-76.04,5.24).
city('Quinchia','co','Risaralda',10896.0,-75.73,5.34).
city('Santa Rosa de Cabal','co','Risaralda',57929.0,-75.62,4.88).
city('Santuario','co','Risaralda',6815.0,-75.97,5.07).
city('Providencia','co','San Andres y Providencia',2404.0,-81.35,13.35).
city('San Andres','co','San Andres y Providencia',58258.0,-81.69,12.58).
city('Aguada','co','Santander',470.0,-73.47,6.25).
city('Albania','co','Santander',810.0,-73.92,5.76).
city('Aratoca','co','Santander',2101.0,-73.02,6.7).
city('Barbosa','co','Santander',20373.0,-73.62,5.93).
city('Barichara','co','Santander',4150.0,-73.23,6.64).
city('Barrancabermeja','co','Santander',191406.0,-73.85,7.09).
city('Betulia','co','Santander',1716.0,-73.29,6.9).
city('Bolivar','co','Santander',2230.0,-73.77,5.99).
city('Bucaramanga','co','Santander',571827.0,-73.13,7.13).
city('Cabrera','co','Santander',363.0,-73.25,6.61).
city('California','co','Santander',573.0,-72.97,7.35).
city('Capitanejo','co','Santander',3791.0,-72.7,6.53).
city('Carcasi','co','Santander',862.0,-72.63,6.63).
city('Cepita','co','Santander',377.0,-72.98,6.76).
city('Cerrito','co','Santander',2435.0,-72.7,6.85).
city('Charala','co','Santander',5727.0,-73.29,5.84).
city('Charta','co','Santander',650.0,-72.97,7.28).
city('Chima','co','Santander',786.0,-73.37,6.34).
city('Chipata','co','Santander',868.0,-73.63,6.05).
city('Cimitarra','co','Santander',11267.0,-73.95,6.32).
city('Concepcion','co','Santander',2520.0,-72.7,6.77).
city('Confines','co','Santander',472.0,-73.24,6.36).
city('Contratacion','co','Santander',3505.0,-73.48,6.29).
city('Coromoro','co','Santander',1010.0,-73.0,6.29).
city('Curiti','co','Santander',3417.0,-73.07,6.61).
city('El Carmen','co','Santander',1602.0,-73.51,6.7).
city('El Guacamayo','co','Santander',428.0,-73.5,6.25).
city('El Penon','co','Santander',831.0,-72.84,6.55).
city('El Playon','co','Santander',5334.0,-73.21,7.48).
city('Encino','co','Santander',412.0,-73.1,6.14).
city('Enciso','co','Santander',698.0,-72.7,6.67).
city('Florian','co','Santander',1227.0,-73.97,5.8).
city('Floridablanca','co','Santander',252271.0,-73.09,7.06).
city('Galan','co','Santander',1122.0,-73.29,6.64).
city('Gambita','co','Santander',742.0,-73.35,5.95).
city('Giron','co','Santander',108468.0,-73.17,7.07).
city('Guaca','co','Santander',1637.0,-72.86,6.88).
city('Guadalupe','co','Santander',2181.0,-73.42,6.25).
city('Guapota','co','Santander',564.0,-73.32,6.31).
city('Guavata','co','Santander',943.0,-73.7,5.96).
city('Gueepsa','co','Santander',2471.0,-73.57,6.02).
city('Hato','co','Santander',600.0,-73.31,6.55).
city('Jesus Maria','co','Santander',823.0,-73.79,5.88).
city('Jordan','co','Santander',112.0,-73.1,6.74).
city('La Belleza','co','Santander',1649.0,-73.97,5.86).
city('La Paz','co','Santander',1135.0,-73.58,6.19).
city('Landazuri','co','Santander',3483.0,-73.81,6.22).
city('Lebrija','co','Santander',8950.0,-73.22,7.12).
city('Los Santos','co','Santander',1310.0,-73.09,7.17).
city('Macaravita','co','Santander',538.0,-72.6,6.5).
city('Malaga','co','Santander',18740.0,-72.74,6.72).
city('Matanza','co','Santander',1669.0,-73.02,7.33).
city('Mogotes','co','Santander',3438.0,-72.97,6.48).
city('Molagavita','co','Santander',1205.0,-72.81,6.68).
city('Ocamonte','co','Santander',883.0,-73.12,6.34).
city('Oiba','co','Santander',3959.0,-73.3,6.27).
city('Onzaga','co','Santander',1393.0,-72.82,6.35).
city('Palmar','co','Santander',360.0,-73.3,6.54).
city('Palmas del Socorro','co','Santander',657.0,-73.29,6.41).
city('Paramo','co','Santander',843.0,-73.17,6.42).
city('Piedecuesta','co','Santander',86388.0,-73.05,6.99).
city('Pinchote','co','Sant',674.0,-73.18,6.54).
city('Puente Nacional','co','Santander',5775.0,-73.68,5.88).
city('Puerto Parra','co','Santander',1448.0,-74.06,6.65).
city('Puerto Wilches','co','Santander',13705.0,-73.91,7.35).
city('Rionegro','co','Santander',9515.0,-73.16,7.26).
city('Sabana de Torres','co','Santander',11292.0,-73.49,7.4).
city('San Andres','co','Santander',3032.0,-72.85,6.81).
city('San Benito','co','Santander',426.0,-73.47,6.17).
city('San Gil','co','Santander',33592.0,-73.14,6.56).
city('San Joaquin','co','Santander',844.0,-72.87,6.43).
city('San Jose de Miranda','co','Santander',1096.0,-72.74,6.66).
city('San Miguel','co','Santander',624.0,-72.65,6.58).
city('San Vicente de Chucuri','co','Santander',11265.0,-73.42,6.89).
city('Santa Barbara','co','Santander',291.0,-72.91,6.99).
city('Santa Helena','co','Santander',865.0,-73.58,6.3).
city('Simacota','co','Santander',2157.0,-73.34,6.44).
city('Socorro','co','Santander',17752.0,-73.27,6.46).
city('Suaita','co','Santander',2691.0,-73.44,6.1).
city('Sucre','co','Santander',1095.0,-73.8,5.92).
city('Surata','co','Santander',806.0,-72.99,7.37).
city('Tona','co','Santander',627.0,-72.97,7.21).
city('Valle San Jose','co','Santander',2522.0,-73.14,6.45).
city('Velez','co','Santander',10905.0,-73.68,6.02).
city('Vetas','co','Santander',1210.0,-72.87,7.33).
city('Villanueva','co','Santander',3707.0,-73.18,6.67).
city('Zapatoca','co','Santander',6052.0,-73.27,6.82).
city('Buenavista','co','Sucre',7206.0,-75.25,8.68).
city('Caimito','co','Sucre',2925.0,-75.39,8.79).
city('Chalan','co','Sucre',2897.0,-75.32,9.55).
city('Coloso','co','Sucre',3749.0,-75.36,9.5).
city('Corozal','co','Sucre',39801.0,-75.29,9.33).
city('El Roble','co','Sucre',3324.0,-75.2,9.1).
city('Galeras','co','Sucre',9460.0,-75.05,9.16).
city('Guaranda','co','Sucre',5436.0,-74.55,8.48).
city('La Union','co','Sucre',4427.0,-75.28,8.86).
city('Los Palmitos','co','Sucre',14385.0,-75.27,9.38).
city('Majagual','co','Sucre',11139.0,-74.63,8.54).
city('Morroa','co','Sucre',4949.0,-75.31,9.34).
city('Ovejas','co','Sucre',13284.0,-75.23,9.53).
city('Palmito','co','Sucre',3993.0,-75.55,9.33).
city('Sampues','co','Sucre',21204.0,-75.38,9.19).
city('San Benito Abad','co','Sucre',18181.0,-75.02,8.94).
city('San Juan de Betulia','co','Sucre',9092.0,-75.25,9.28).
city('San Marcos','co','Sucre',36549.0,-75.13,8.66).
city('San Onofre','co','Sucre',32958.0,-75.53,9.74).
city('San Pedro','co','Sucre',11489.0,-75.12,9.4).
city('Since','co','Sucre',30769.0,-75.14,9.25).
city('Sincelejo','co','Sucre',261190.0,-75.38,9.29).
city('Sucre','co','Sucre',23210.0,-74.71,8.82).
city('Tolu','co','Sucre',27390.0,-75.57,9.54).
city('Toluviejo','co','Sucre',8260.0,-75.44,9.45).
city('Alpujarra','co','Tolima',1492.0,-74.94,3.39).
city('Alvarado','co','Tolima',2049.0,-74.96,4.57).
city('Ambalema','co','Tolima',4892.0,-74.77,4.79).
city('Anzoategui','co','Tolima',2229.0,-75.1,4.63).
city('Ataco','co','Tolima',4105.0,-75.39,3.6).
city('Cajamarca','co','Tolima',9310.0,-75.43,4.44).
city('Carmen de Apicala','co','Tolima',5640.0,-74.73,4.15).
city('Casabianca','co','Tolima',1593.0,-75.12,5.08).
city('Chaparral','co','Tolima',19982.0,-75.49,3.73).
city('Coello','co','Tolima',769.0,-74.9,4.29).
city('Coyaima','co','Tolima',3893.0,-75.2,3.8).
city('Cunday','co','Tolima',2082.0,-74.7,4.06).
city('Dolores','co','Tolima',3752.0,-74.9,3.55).
city('Espinal','co','Tolima',56214.0,-74.89,4.16).
city('Falan','co','Tolima',5234.0,-74.95,5.13).
city('Flandes','co','Tolima',20919.0,-74.82,4.29).
city('Fresno','co','Tolima',17669.0,-75.04,5.16).
city('Guamo','co','Tolima',14881.0,-74.97,4.03).
city('Guayabal','co','Tolima',5340.0,-74.89,5.03).
city('Herveo','co','Tolima',3490.0,-75.18,5.08).
city('Honda','co','Tolima',28158.0,-74.75,5.19).
city('Ibague','co','Tolima',421689.0,-75.24,4.45).
city('Icononzo','co','Tolima',3540.0,-74.54,4.18).
city('Lerida','co','Tolima',20069.0,-74.91,4.87).
city('Libano','co','Tolima',28212.0,-75.07,4.93).
city('Mariquita','co','Tolima',23104.0,-74.9,5.2).
city('Melgar','co','Tolima',25980.0,-74.65,4.21).
city('Murillo','co','Tolima',1860.0,-75.17,4.88).
city('Natagaima','co','Tolima',11217.0,-75.1,3.63).
city('Ortega','co','Tolima',6871.0,-75.23,3.94).
city('Palocabildo','co','Tolima',3534.0,-75.03,5.13).
city('Piedras','co','Tolima',1173.0,-74.88,4.54).
city('Planadas','co','Tolima',9710.0,-75.65,3.2).
city('Prado','co','Tolima',3556.0,-74.93,3.75).
city('Purificacion','co','Tolima',10847.0,-74.93,3.86).
city('Rioblanco','co','Tolima',6210.0,-75.68,3.53).
city('Roncesvalles','co','Tolima',3918.0,-75.61,4.01).
city('Rovira','co','Tolima',6950.0,-75.24,4.24).
city('Saldana','co','Tolima',9237.0,-75.02,3.94).
city('San Antonio','co','Tolima',5185.0,-75.49,3.92).
city('San Luis','co','Tolima',4184.0,-75.1,4.14).
city('Santa Isabel','co','Tolima',2035.0,-75.17,4.75).
city('Suarez','co','Tolima',1243.0,-74.84,4.05).
city('Valle de San Juan','co','Tolima',1486.0,-75.12,4.2).
city('Venadillo','co','Tolima',11311.0,-74.94,4.73).
city('Villahermosa','co','Tolima',4156.0,-75.12,5.03).
city('Villarrica','co','Tolima',3081.0,-74.6,3.94).
city('Alcala','co','Valle del Cauca',9135.0,-75.78,4.67).
city('Andalucia','co','Valle del Cauca',17432.0,-76.17,4.17).
city('Ansermanuevo','co','Valle del Cauca',12332.0,-76.0,4.8).
city('Argelia','co','Valle del Cauca',3419.0,-76.12,4.73).
city('Bolivar','co','Valle del Cauca',4165.0,-76.19,4.34).
city('Buenaventura','co','Valle del Cauca',240391.0,-77.04,3.89).
city('Buga','co','Valle del Cauca',118006.0,-76.3,3.91).
city('Bugalagrande','co','Valle del Cauca',12418.0,-76.17,4.21).
city('Caicedonia','co','Valle del Cauca',32417.0,-75.81,4.35).
city('Cali','co','Valle del Cauca',2392897.0,-76.52,3.44).
city('Candelaria','co','Valle del Cauca',23989.0,-76.36,3.41).
city('Cartago','co','Valle del Cauca',134829.0,-75.91,4.75).
city('Dagua','co','Valle del Cauca',12320.0,-76.69,3.66).
city('Darien','co','Valle del Cauca',11724.0,-76.5,3.93).
city('El Aguila','co','Valle del Cauca',2725.0,-76.04,4.91).
city('El Cairo','co','Valle del Cauca',3268.0,-76.23,4.76).
city('El Cerrito','co','Valle del Cauca',38391.0,-76.31,3.69).
city('El Dovio','co','Valle del Cauca',7943.0,-76.24,4.51).
city('Florida','co','Valle del Cauca',47173.0,-76.24,3.33).
city('Ginebra','co','Valle del Cauca',6088.0,-76.27,3.73).
city('Guacari','co','Valle del Cauca',19637.0,-76.34,3.78).
city('Jamundi','co','Valle del Cauca',44834.0,-76.54,3.26).
city('La Cumbre','co','Valle del Cauca',2432.0,-76.02,3.72).
city('La Union','co','Valle del Cauca',23459.0,-76.11,4.54).
city('La Victoria','co','Valle del Cauca',11064.0,-76.04,4.52).
city('Obando','co','Valle del Cauca',7298.0,-75.97,4.58).
city('Palmira','co','Valle del Cauca',247991.0,-76.3,3.54).
city('Pradera','co','Valle del Cauca',44631.0,-76.24,3.43).
city('Restrepo','co','Valle del Cauca',9545.0,-76.54,3.83).
city('Riofrio','co','Valle del Cauca',9236.0,-76.29,4.16).
city('Roldanillo','co','Valle del Cauca',27562.0,-76.16,4.41).
city('San Pedro','co','Valle del Cauca',5473.0,-76.23,4.0).
city('Sevilla','co','Valle del Cauca',41613.0,-75.93,4.28).
city('Toro','co','Valle del Cauca',13764.0,-76.07,4.61).
city('Trujillo','co','Valle del Cauca',5874.0,-76.32,4.21).
city('Tulua','co','Valle del Cauca',165504.0,-76.21,4.09).
city('Ulloa','co','Valle del Cauca',2621.0,-75.74,4.7).
city('Versalles','co','Valle del Cauca',3543.0,-76.22,4.58).
city('Vijes','co','Valle del Cauca',4071.0,-76.43,3.7).
city('Yotoco','co','Valle del Cauca',8362.0,-76.39,3.87).
city('Yumbo','co','Valle del Cauca',71438.0,-76.49,3.59).
city('Zarzal','co','Valle del Cauca',28761.0,-76.07,4.4).
city('Acaricuara','co','Vaupes',430.0,-70.23,0.7).
city('Mitu','co','Vaupes',5917.0,-70.17,1.2).
city('Taraira','co','Vaupes',341.0,-69.67,0.49).
city('Yavarate','co','Vaupes',38.0,-69.21,0.62).
city('Cumaribo','co','Vichada',629.0,-69.8,4.44).
city('La Primavera','co','Vichada',3920.0,-70.45,5.51).
city('Puerto Carreno','co','Vichada',10216.0,-67.49,6.19).
city('Santa Rosalia','co','Vichada',1363.0,-70.88,5.13).
city('Fomboni','km','Mwali',14965.0,43.73,-12.28).
city('Domoni','km','Ndzouani',14508.0,44.53,-12.25).
city('Mutsamudu','km','Ndzouani',23593.0,44.41,-12.15).
city('Mitsamiouli','km','Ngazidja',6104.0,43.28,-11.4).
city('Moroni','km','Ngazidja',42882.0,43.23,-11.74).
city('Amuri','ck','Aitutaki',285.0,-159.77,-18.87).
city('Atiu','ck','Atiu',165.0,-158.12,-20.03).
city('Mangaia','ck','Mangaia',328.0,-157.92,-21.92).
city('Tauhunu','ck','Manihiki',69.0,-161.05,-10.4).
city('Mauke','ck','Mauke',145.0,-157.38,-20.15).
city('Mitiaro','ck','Mitiaro',80.0,-157.72,-19.82).
city('Nassau','ck','Nassau',49.0,-165.42,-11.55).
city('Roto','ck','Pukapuka',74.0,-165.83,-10.88).
city('Rakahanga','ck','Rakahanga',38.0,-161.08,-10.03).
city('Avarua','ck','Rarotonga',13374.0,-159.76,-21.2).
city('Omoka','ck','Tongareva',180.0,-158.07,-9.0).
city('Alajuela','cr','Alajuela',47503.0,-84.23,10.02).
city('Atenas','cr','Alajuela',7014.0,-84.39,9.99).
city('Desemparados','cr','Alajuela',14448.0,-84.5,9.95).
city('Florencia','cr','Alajuela',888.0,-84.49,10.37).
city('Grecia','cr','Alajuela',12677.0,-84.35,10.03).
city('Guacimo','cr','Alajuela',11720.0,-83.12,8.95).
city('Los Chiles','cr','Alajuela',3342.0,-84.72,11.04).
city('Naranjo','cr','Alajuela',11856.0,-84.39,10.1).
city('Orotina','cr','Alajuela',6135.0,-84.53,9.91).
city('Palmares','cr','Alajuela',4645.0,-83.67,9.32).
city('Pital','cr','Alajuela',2046.0,-84.28,10.45).
city('Pocosol','cr','Alajuela',2947.0,-84.62,10.37).
city('Quesada','cr','Alajuela',27316.0,-84.44,10.33).
city('Rio Segundo','cr','Alajuela',9853.0,-84.3,10.23).
city('San Antonio','cr','Alajuela',12965.0,-84.19,9.98).
city('San Jose','cr','Alajuela',31430.0,-85.13,10.97).
city('San Juan','cr','Alajuela',7729.0,-84.32,10.1).
city('San Rafael','cr','Alajuela',10637.0,-84.33,10.0).
city('San Ramon','cr','Alajuela',10774.0,-84.47,10.09).
city('Upala','cr','Alajuela',4185.0,-85.01,10.89).
city('Zarcero','cr','Alajuela',3559.0,-84.4,10.18).
city('Aguacaliente','cr','Cartago',28500.0,-85.23,10.48).
city('Carmen','cr','Cartago',15920.0,-83.48,10.2).
city('Cartago','cr','Cartago',26615.0,-83.93,9.87).
city('Concepcion','cr','Cartago',14000.0,-84.0,9.91).
city('El Tejar','cr','Cartago',22437.0,-84.23,9.75).
city('Guadalupe','cr','Cartago',13754.0,-84.0,9.65).
city('La Suiza','cr','Cartago',2434.0,-83.62,9.85).
city('Pacayas','cr','Cartago',1556.0,-84.05,9.8).
city('Paraiso','cr','Cartago',39709.0,-83.87,9.83).
city('San Diego','cr','Cartago',16991.0,-84.0,9.9).
city('San Rafael','cr','Cartago',9951.0,-83.97,9.67).
city('Tres Rios','cr','Cartago',10432.0,-83.99,9.9).
city('Turrialba','cr','Cartago',28960.0,-83.69,9.91).
city('Bagaces','cr','Guanacaste',4108.0,-85.25,10.52).
city('Canas','cr','Guanacaste',20309.0,-85.1,10.43).
city('Filadeldia','cr','Guanacaste',5861.0,-85.56,10.44).
city('Juntas','cr','Guanacaste',4737.0,-84.95,10.28).
city('La Cruz','cr','Guanacaste',4319.0,-85.63,11.07).
city('Liberia','cr','Guanacaste',45405.0,-85.45,10.64).
city('Nicoya','cr','Guanacaste',15315.0,-85.46,10.14).
city('Santa Cruz','cr','Guanacaste',12283.0,-85.59,10.26).
city('Tilaran','cr','Guanacaste',7301.0,-84.97,10.47).
city('Heredia','cr','Heredia',21968.0,-84.12,10.0).
city('Mercedes','cr','Heredia',26013.0,-84.13,10.02).
city('San Antonio','cr','Heredia',10938.0,-84.18,9.99).
city('San Francisco','cr','Heredia',55933.0,-84.13,9.99).
city('San Isidro','cr','Heredia',3785.0,-84.5,9.62).
city('San Josecito','cr','Heredia',12195.0,-84.1,10.02).
city('San Pablo','cr','Heredia',21666.0,-84.09,10.0).
city('San Rafael','cr','Heredia',8889.0,-84.11,10.01).
city('Santo Domingo','cr','Heredia',5750.0,-84.15,10.07).
city('Batan','cr','Limon',4584.0,-83.33,10.08).
city('Guacimo','cr','Limon',7022.0,-83.69,10.21).
city('Guapiles','cr','Limon',19097.0,-83.79,10.21).
city('Limon','cr','Limon',63094.0,-83.04,9.99).
city('Matina','cr','Limon',2315.0,-83.28,10.08).
city('Roxana','cr','Limon',2351.0,-83.75,10.27).
city('Siquirres','cr','Limon',18235.0,-83.51,10.11).
city('Buenos Aires','cr','Puntarenas',11680.0,-83.34,9.16).
city('Chacarita','cr','Puntarenas',26354.0,-84.78,9.99).
city('Corredor','cr','Puntarenas',7084.0,-82.95,8.63).
city('Esparta','cr','Puntarenas',15575.0,-84.67,9.99).
city('Golfito','cr','Puntarenas',6778.0,-83.17,8.64).
city('Miramar','cr','Puntarenas',6540.0,-84.73,10.1).
city('Palmar','cr','Puntarenas',4657.0,-84.45,9.87).
city('Parrita','cr','Puntarenas',3734.0,-84.32,9.52).
city('Puerto Cortes','cr','Puntarenas',3850.0,-83.53,8.96).
city('Puntarenas','cr','Puntarenas',35655.0,-84.84,9.98).
city('Quepos','cr','Puntarenas',7810.0,-84.15,9.45).
city('San Vito','cr','Puntarenas',3981.0,-82.97,8.84).
city('Alajuelita','cr','San Jose',13848.0,-84.1,9.91).
city('Aserri','cr','San Jose',25874.0,-84.1,9.87).
city('Calle Blancos','cr','San Jose',20714.0,-84.07,9.95).
city('Cinco Esquinas','cr','San Jose',7158.0,-84.17,10.1).
city('Colon','cr','San Jose',9687.0,-84.25,9.92).
city('Concepcion','cr','San Jose',22036.0,-84.0,9.93).
city('Curridabat','cr','San Jose',34592.0,-84.03,9.92).
city('Daniel Flores','cr','San Jose',10028.0,-83.67,9.34).
city('Desamparados','cr','San Jose',39276.0,-84.12,9.9).
city('Escazu','cr','San Jose',12073.0,-84.15,9.92).
city('Guadalupe','cr','San Jose',26026.0,-84.06,9.94).
city('Ipis','cr','San Jose',26674.0,-84.02,9.97).
city('Purral','cr','San Jose',30034.0,-84.04,9.95).
city('Sabanilla','cr','San Jose',13253.0,-84.03,9.95).
city('San Antonio de Desamparados','cr','San Jose',10542.0,-84.05,9.9).
city('San Felipe','cr','San Jose',24985.0,-84.1,9.9).
city('San Ignacio','cr','San Jose',3072.0,-84.17,9.8).
city('San Isidro','cr','San Jose',26250.0,-83.88,9.7).
city('San Jose','cr','San Jose',335056.0,-84.08,9.93).
city('San Juan','cr','San Jose',20760.0,-84.08,9.93).
city('San Marcos de Tarrazu','cr','San Jose',4255.0,-84.02,9.65).
city('San Miguel','cr','San Jose',28827.0,-84.07,9.89).
city('San Pedro','cr','San Jose',27482.0,-84.05,9.93).
city('San Rafael','cr','San Jose',25415.0,-84.13,9.93).
city('San Rafael Abajo','cr','San Jose',27424.0,-84.28,9.83).
city('San Rafael Arriba','cr','San Jose',15054.0,-84.09,9.89).
city('San Vicente','cr','San Jose',34453.0,-84.05,9.97).
city('Santa Ana','cr','San Jose',8031.0,-84.18,9.94).
city('Santiago','cr','San Jose',8292.0,-84.32,9.84).
city('Adzope','ci','Agneby',81150.0,-3.87,6.1).
city('Affery','ci','Agneby',37424.0,-3.95,6.32).
city('Agboville','ci','Agneby',108684.0,-4.28,5.94).
city('Akoupe','ci','Agneby',51387.0,-3.9,6.38).
city('Touba','ci','Bafing',47538.0,-7.69,8.29).
city('San-Pedro','ci','Bas Sassandra',195873.0,-6.64,4.77).
city('Sassandra','ci','Bas Sassandra',30124.0,-6.08,4.95).
city('Soubre','ci','Bas Sassandra',123214.0,-6.61,5.79).
city('Tabou','ci','Bas Sassandra',21511.0,-7.36,4.42).
city('Odienne','ci','Denguele',71188.0,-7.58,9.51).
city('Bangolo','ci','Dix-huit Montagnes',17712.0,-7.48,7.02).
city('Biankouma','ci','Dix-huit Montagnes',42756.0,-7.62,7.74).
city('Danane','ci','Dix-huit Montagnes',68687.0,-8.16,7.26).
city('Man','ci','Dix-huit Montagnes',140217.0,-7.55,7.4).
city('Gagnoa','ci','Fromager',125647.0,-5.88,6.15).
city('Guiberoua','ci','Fromager',16030.0,-6.17,6.24).
city('Hire','ci','Fromager',30232.0,-5.29,6.19).
city('Ndouci','ci','Fromager',25134.0,-4.77,5.87).
city('Oume','ci','Fromager',78872.0,-5.43,6.38).
city('Daloa','ci','Haut-Sassandra',217876.0,-6.45,6.89).
city('Issia','ci','Haut-Sassandra',88251.0,-6.59,6.49).
city('Vavoua','ci','Haut-Sassandra',54249.0,-6.49,7.38).
city('Ndiekro','ci','Lacs',11794.0,-4.77,7.44).
city('Tiebissou','ci','Lacs',24605.0,-5.29,7.16).
city('Toumodi','ci','Lacs',51560.0,-5.03,6.55).
city('Yamoussoukro','ci','Lacs',200659.0,-5.28,6.82).
city('Abidjan','ci','Lagunes',3692570.0,-4.03,5.33).
city('Alepe','ci','Lagunes',11794.0,-3.65,5.5).
city('Anyama','ci','Lagunes',158250.0,-4.05,5.5).
city('Bingerville','ci','Lagunes',83105.0,-3.9,5.36).
city('Dabou','ci','Lagunes',95057.0,-4.39,5.32).
city('Grand-Lahou','ci','Lagunes',13205.0,-5.03,5.13).
city('Jacqueville','ci','Lagunes',14743.0,-4.42,5.2).
city('Tiassale','ci','Lagunes',52186.0,-4.83,5.88).
city('Bouafle','ci','Marahoue',89344.0,-5.75,6.98).
city('Sinfra','ci','Marahoue',85875.0,-5.92,6.62).
city('Zuenoula','ci','Mara',52630.0,-6.05,7.44).
city('Duekoue','ci','Moyen-Cavally',68872.0,-7.35,6.74).
city('Guiglo','ci','Moyen-Cavally',63528.0,-7.49,6.55).
city('Toulepleu','ci','Moyen-Cavally',17965.0,-8.42,6.58).
city('Abengourou','ci','Moyen-Comoe',144074.0,-3.49,6.73).
city('Agnibilekrou','ci','Moyen-Comoe',59780.0,-3.2,7.13).
city('Arrah','ci','Nzi-Comoe',43408.0,-3.97,6.67).
city('Bocanda','ci','Nzi-Comoe',14051.0,-4.5,7.06).
city('Bongouanou','ci','Nzi-Comoe',38756.0,-4.2,6.65).
city('Daoukro','ci','Nzi-Comoe',56310.0,-3.96,7.06).
city('Dimbokro','ci','Nzi-Comoe',73789.0,-4.71,6.65).
city('Mbahiakro','ci','Nzi-Comoe',21815.0,-4.46,7.48).
city('Mbatto','ci','Nzi-Comoe',36031.0,-4.37,6.46).
city('Boundiali','ci','Savanes',61998.0,-6.49,9.53).
city('Ferkessedougou','ci','Savanes',74966.0,-5.2,9.6).
city('Korhogo','ci','Savanes',172114.0,-5.65,9.45).
city('Tingrela','ci','Savanes',67746.0,-6.4,10.49).
city('Divo','ci','Sud-Bandama',184481.0,-5.37,5.85).
city('Lakota','ci','Sud-Bandama',50651.0,-5.69,5.85).
city('Aboisso','ci','Sud-Comoe',48148.0,-3.2,5.47).
city('Adiake','ci','Sud-Comoe',22030.0,-3.3,5.28).
city('Ayame','ci','Sud-Comoe',15442.0,-3.16,5.62).
city('Bonoua','ci','Sud-Comoe',40637.0,-3.61,5.28).
city('Grand Bassam','ci','Sud-Comoe',90817.0,-3.75,5.2).
city('Beoumi','ci','Vallee du Bandama',25940.0,-5.58,7.68).
city('Botro','ci','Vallee du Bandama',15581.0,-5.32,7.85).
city('Bouake','ci','Vallee du Bandama',572149.0,-5.03,7.69).
city('Dabakala','ci','Vallee du Bandama',22834.0,-4.42,8.36).
city('Katiola','ci','Vallee du Bandam',83695.0,-5.11,8.15).
city('Sakassou','ci','Vallee du Bandama',15068.0,-5.3,7.45).
city('Mankono','ci','Worodougou',25351.0,-6.19,8.06).
city('Seguela','ci','Worodougou',79565.0,-6.67,7.95).
city('Bondoukou','ci','Zanzan',79013.0,-2.8,8.03).
city('Bouna','ci','Zanzan',40188.0,-3.0,9.27).
city('Tanda','ci','Zanzan',27098.0,-3.17,7.8).
city('Bjelovar','hr','Bjelovar-Bilogora',28275.0,16.84,45.91).
city('Dubrovnik','hr','Dubrovnik-Neretva',28428.0,18.07,42.66).
city('Korcula','hr','Dubrovnik-Neretva',3141.0,17.13,42.96).
city('Metkovic','hr','Dubrovnik-Neretva',13941.0,17.63,43.05).
city('Sesvete','hr','Grad Zagreb',52412.0,16.11,45.84).
city('Zagreb','hr','Grad Zagreb',698967.0,15.97,45.8).
city('Buje','hr','Istra',3016.0,13.66,45.42).
city('Porec','hr','Istra',10499.0,13.62,45.22).
city('Pula','hr','Istra',59079.0,13.84,44.88).
city('Rovinj','hr','Istra',13533.0,13.64,45.09).
city('Karlovac','hr','Karlovac',48123.0,15.54,45.5).
city('Ogulin','hr','Karlovac',8755.0,15.23,45.27).
city('Koprivnica','hr','Koprivnica-Krizevci',25579.0,16.83,46.16).
city('Krizevci','hr','Koprivnica-Krizevci',11597.0,16.54,46.02).
city('Krapina','hr','Krapina-Zagorje',4725.0,15.87,46.16).
city('Gospic','hr','Lika-Senj',6118.0,15.37,44.54).
city('Senj','hr','Lika-Senj',5518.0,14.91,44.99).
city('Cakovec','hr','Medimurje',15867.0,16.42,46.39).
city('Beli Manastir','hr','Osijek-Baranja',8713.0,18.61,45.77).
city('Dakovo','hr','Osijek-Baranja',21456.0,18.41,45.31).
city('Nasice','hr','Osijek-Baranja',8213.0,18.1,45.5).
city('Osijek','hr','Osijek-Baranja',88141.0,18.68,45.55).
city('Pozega','hr','Pozega-Slavonija',21153.0,17.68,45.34).
city('Krk','hr','Primorje-Gorski Kotar',3380.0,14.58,45.03).
city('Opatija','hr','Primorje-Gorski Kotar',7888.0,14.31,45.34).
city('Rab','hr','Primorje-Gorski Kotar',557.0,14.77,44.76).
city('Rijeka','hr','Primorje-Gorski Kotar',141173.0,14.44,45.33).
city('Knin','hr','Sibenik-Knin',11182.0,16.2,44.04).
city('Sibenik','hr','Sibenik-Knin',37113.0,15.89,43.74).
city('Kutina','hr','Sisak-Moslavina',14886.0,16.78,45.48).
city('Novska','hr','Sisak-Moslavina',730.0,16.97,45.34).
city('Petrinja','hr','Sisak-Moslavina',13868.0,16.28,45.45).
city('Sisak','hr','Sisak-Moslavina',35749.0,16.36,45.48).
city('Nova Gradiska','hr','Slavonski Brod-Posavina',13329.0,17.38,45.26).
city('Slavonski Brod','hr','Slavonski Brod-Posavina',60742.0,18.01,45.16).
city('Makarska','hr','Split-Dalmacija',13446.0,17.02,43.3).
city('Omis','hr','Split-Dalmacija',6597.0,16.7,43.45).
city('Sinj','hr','Split-Dalmacija',11524.0,16.64,43.7).
city('Solin','hr','Split-Dalmacija',15927.0,16.49,43.54).
city('Split','hr','Split-Dalmacija',176315.0,16.45,43.51).
city('Trogir','hr','Split-Dalmacija',10960.0,16.25,43.53).
city('Varazdin','hr','Varazdin',41808.0,16.33,46.31).
city('Slatina','hr','Virovitica-Podravina',10973.0,17.71,45.7).
city('Virovitica','hr','Virovitica-Podravina',15665.0,17.39,45.84).
city('Vinkovci','hr','Vukovar-Srijem',33315.0,18.8,45.29).
city('Vukovar','hr','Vukovar-Srijem',29584.0,18.99,45.35).
city('Zupanja','hr','Vukovar-Srijem',13842.0,18.7,45.07).
city('Biograd na Moru','hr','Zadar',5285.0,15.45,43.94).
city('Gracac','hr','Zadar',2702.0,15.85,44.3).
city('Pag','hr','Zadar',2714.0,15.05,44.44).
city('Zadar','hr','Zadar',71258.0,15.24,44.12).
city('Velika Gorica','hr','Zagreb',35073.0,16.06,45.74).
city('Zapresic','hr','Zagreb',17624.0,15.81,45.88).
city('Camagueey','cu','Camagueey',347572.0,-77.91,21.4).
city('Caney','cu','Camagueey',4597.0,-78.49,21.3).
city('Esmeralda','cu','Camagueey',20274.0,-78.11,21.85).
city('Florida','cu','Camagueey',63009.0,-78.23,21.54).
city('Guaimaro','cu','Camagueey',39360.0,-77.35,21.05).
city('Minas','cu','Camagueey',20863.0,-77.62,21.49).
city('Nuevitas','cu','Camagueey',54024.0,-77.27,21.55).
city('Santa Cruz del Sur','cu','Camagueey',34602.0,-78.0,20.72).
city('Sibanicu','cu','Camagueey',16856.0,-77.53,21.24).
city('Vertientes','cu','Camagueey',29704.0,-78.15,21.26).
city('Baragua','cu','Ciego de Avila',15268.0,-78.63,21.69).
city('Chambas','cu','Ciego de Avila',24113.0,-78.91,22.2).
city('Ciego de Avila','cu','Ciego de Avila',142032.0,-78.76,21.85).
city('Moron','cu','Ciego de Avila',66062.0,-78.63,22.12).
city('Primero de Enero','cu','Ciego',17934.0,-78.43,21.95).
city('Venezuela','cu','Ciego de Avila',16601.0,-78.8,21.73).
city('Cienfuegos','cu','Cienfuegos',186648.0,-80.45,22.16).
city('Cruces','cu','Cienfuegos',24907.0,-80.27,22.34).
city('Cumanayagua','cu','Cienfuegos',38689.0,-80.2,22.15).
city('Palmira','cu','Cienfuegos',23078.0,-80.39,22.24).
city('Rodas','cu','Cienfuegos',19212.0,-80.56,22.35).
city('Havanna','cu','Ciudad de la Habana',2163822.0,-82.39,23.13).
city('Bayamo','cu','Granma',192641.0,-76.65,20.38).
city('Campechuela','cu','Granma',25069.0,-77.28,20.24).
city('Guisa','cu','Granma',18408.0,-76.54,20.26).
city('Jiguani','cu','Granma',41109.0,-76.43,20.37).
city('Manzanillo','cu','Granma',128194.0,-77.12,20.35).
city('Media Luna','cu','Granma',16713.0,-77.44,20.15).
city('Niquero','cu','Granma',18771.0,-77.58,20.04).
city('Rio Cauto','cu','Granma',23737.0,-76.92,20.56).
city('Yara','cu','Granma',28944.0,-76.95,20.28).
city('Baracoa','cu','Guantanamo',48365.0,-74.5,20.35).
city('Guantanamo','cu','Guantanamo',272808.0,-75.22,20.15).
city('Yateras','cu','Guantanamo',25753.0,-75.02,20.37).
city('Antilla','cu','Holguin',14339.0,-75.84,20.83).
city('Baguanos','cu','Holguin',15176.0,-76.03,20.75).
city('Banes','cu','Holguin',53107.0,-75.72,20.96).
city('Cacocum','cu','Holguin',16848.0,-76.57,20.76).
city('Cueto','cu','Holguin',26527.0,-75.94,20.65).
city('Gibara','cu','Holguin',27603.0,-76.14,21.11).
city('Holguin','cu','Holguin',319114.0,-76.25,20.89).
city('Jobabo','cu','Holguin',17804.0,-76.3,20.97).
city('Moa','cu','Holguin',92885.0,-74.92,20.66).
city('Sagua de Tanamo','cu','Holguin',18282.0,-75.25,20.59).
city('Nueva Gerona','cu','Isla de la Juventud',20264.0,-82.8,21.89).
city('Santa Fe','cu','Isla de la Juventud',4595.0,-82.65,21.69).
city('Alquizar','cu','La Habana',15275.0,-82.59,22.8).
city('Artemisa','cu','La Habana',68076.0,-82.76,22.82).
city('Batabano','cu','La Habana',13832.0,-82.3,22.71).
city('Bauta','cu','La Habana',45771.0,-82.55,22.98).
city('Cabanas','cu','La Habana',5894.0,-82.91,22.98).
city('Guanajay','cu','La Habana',25258.0,-82.68,22.94).
city('Gueines','cu','La Habana',68938.0,-82.03,22.84).
city('Gueira de Melena','cu','La Habana',69897.0,-82.5,22.8).
city('Jaruco','cu','La Habana',20207.0,-82.01,23.05).
city('Madruga','cu','La Habana',33798.0,-81.86,22.92).
city('Mariel','cu','La Habana',28987.0,-82.75,22.99).
city('San Antonio de los Banos','cu','La Habana',42726.0,-82.5,22.88).
city('San Jose de las Lajas','cu','La Habana',54850.0,-82.15,22.97).
city('San Nicolas','cu','La Habana',14914.0,-81.91,22.79).
city('Santa Cruz del Norte','cu','La Habana',18403.0,-81.93,23.16).
city('Santiago de las Vegas','cu','La Habana',35241.0,-82.38,22.97).
city('Amancio','cu','Las Tunas',26914.0,-77.68,20.83).
city('Caimito del Guayabal','cu','Las Tunas',4426.0,-77.62,20.7).
city('Colombia','cu','Las Tunas',20096.0,-77.43,20.99).
city('Las Tunas','cu','Las Tunas',203690.0,-76.95,20.97).
city('Manati','cu','Las Tunas',13278.0,-76.94,21.32).
city('Puerto Padre','cu','Las Tunas',76841.0,-76.6,21.2).
city('Abreus','cu','Matanzas',16711.0,-80.57,22.28).
city('Agramonte','cu','Matanzas',5376.0,-81.16,22.71).
city('Aguada de Pasajeros','cu','Matanzas',23606.0,-80.85,22.39).
city('Alacranes','cu','Matanzas',5843.0,-81.57,22.77).
city('Bolondron','cu','Matanzas',6778.0,-81.45,22.77).
city('Calimete','cu','Matanzas',23255.0,-80.91,22.54).
city('Cardenas','cu','Matanzas',98519.0,-81.21,23.05).
city('Colon','cu','Matanzas',63885.0,-80.91,22.73).
city('Corralillo','cu','Matanzas',51900.0,-80.58,22.99).
city('Jagueey Grande','cu','Matanzas',54365.0,-81.13,22.53).
city('Jovellanos','cu','Matanzas',47166.0,-81.2,22.8).
city('Los Arabos','cu','Matanzas',12504.0,-80.73,22.74).
city('Manguito','cu','Matanzas',3155.0,-80.92,22.58).
city('Marti','cu','Matanzas',13439.0,-80.92,22.95).
city('Matanzas','cu','Matanzas',146738.0,-81.58,23.06).
city('Pedro Betancourt','cu','Matanzas',26761.0,-81.29,22.73).
city('Perico','cu','Matanzas',24073.0,-81.02,22.78).
city('Union de Reyes','cu','Matanzas',33647.0,-81.53,22.8).
city('Varadero','cu','Matanzas',17178.0,-81.36,23.12).
city('Bahia Honda','cu','Pinar del Rio',19834.0,-83.16,22.91).
city('Candelaria','cu','Pinar del Rio',12675.0,-82.97,22.74).
city('Consolacion del Sur','cu','Pinar del Rio',69859.0,-83.52,22.5).
city('Guane','cu','Pinar del Rio',16548.0,-84.09,22.21).
city('Los Palacios','cu','Pinar del Rio',25703.0,-83.25,22.59).
city('Mantua','cu','Pinar del Rio',10797.0,-84.29,22.29).
city('Pinar del Rio','cu','Pinar del Rio',186997.0,-83.7,22.41).
city('San Cristobal','cu','Pinar del Rio',59582.0,-83.05,22.72).
city('San Diego de los Banos','cu','Pinar del Rio',1643.0,-83.37,22.65).
city('San Luis','cu','Pinar del Rio',6690.0,-83.77,22.28).
city('Cabaiguan','cu','Sancti Spiritus',44516.0,-79.5,22.08).
city('Condado','cu','Sancti Spiritus',38249.0,-79.85,21.87).
city('Fomento','cu','Sancti Spiritus',19991.0,-79.72,22.1).
city('Jatibonico','cu','Sancti Spiritus',19644.0,-79.17,21.93).
city('Sancti Spiritus','cu','Sancti Spiritus',127073.0,-79.44,21.93).
city('Trinidad','cu','Sancti Spiritus',60208.0,-79.98,21.8).
city('Yaguajay','cu','Sancti Spiritus',42220.0,-79.23,22.32).
city('Zaza del Medio','cu','Sancti Spiritus',8667.0,-79.38,22.0).
city('Contramaestre','cu','Santiago de Cuba',70441.0,-76.24,20.31).
city('El Cobre','cu','Santiago de Cuba',4768.0,-75.95,20.06).
city('Mayari','cu','Santiago de Cuba',83631.0,-75.69,20.66).
city('Palma Soriano','cu','Santiago de Cuba',102830.0,-76.0,20.22).
city('San Luis','cu','Santiago de Cuba',67296.0,-75.85,20.2).
city('Santiago de Cuba','cu','Santiago de Cuba',555878.0,-75.82,20.01).
city('Songo-La Maya','cu','Santiago de Cuba',47725.0,-75.65,20.17).
city('Caibarien','cu','Villa Clara',39142.0,-79.47,22.52).
city('Camajuani','cu','Villa Clara',35517.0,-79.74,22.48).
city('Cifuentes','cu','Villa Clara',40142.0,-80.05,22.65).
city('Encrucijada','cu','Villa Clara',26155.0,-79.87,22.62).
city('Esperanza','cu','Villa Clara',10462.0,-80.09,22.45).
city('Manicaragua','cu','Villa Clara',41532.0,-79.97,22.15).
city('Placetas','cu','Villa Clara',55410.0,-79.66,22.32).
city('Quemado de Gueines','cu','Villa Clara',12736.0,-80.25,22.79).
city('Rancho Veloz','cu','Villa Clara',4549.0,-80.4,22.88).
city('Ranchuelo','cu','Villa Clara',43696.0,-80.15,22.38).
city('Remedios','cu','Villa Clara',34109.0,-79.55,22.5).
city('Sagua la Grande','cu','Villa Clara',62075.0,-80.08,22.81).
city('Santa Clara','cu','Villa Clara',250518.0,-79.97,22.41).
city('Santo Domingo','cu','Villa Clara',45477.0,-80.25,22.58).
city('Zulueta','cu','Villa Clara',6141.0,-79.66,22.36).
city('Aradippou','cy','Government controlled area',13351.0,33.58,34.95).
city('Chlorakas','cy','Government controlled area',3619.0,32.41,34.8).
city('Dromolaxia','cy','Government controlled area',5241.0,33.59,34.88).
city('Empa','cy','Government controlled area',4520.0,32.43,34.81).
city('Geri','cy','Government controlled area',7640.0,33.42,35.1).
city('Larnaca','cy','Government controlled area',48954.0,33.63,34.92).
city('Lemesos','cy','Gove',154018.0,33.05,34.68).
city('Livadia','cy','Government controlled area',5329.0,33.63,34.95).
city('Nicosia','cy','Government controlled area',200475.0,33.38,35.16).
city('Pafos','cy','Government controlled area',35966.0,32.41,34.77).
city('Pano Polemidia','cy','Government controlled area',3781.0,33.0,34.7).
city('Paralimni','cy','Government controlled area',11838.0,33.98,35.05).
city('Polis','cy','Government controlled area',1975.0,32.41,35.03).
city('Ypsonas','cy','Government controlled area',7349.0,32.97,34.69).
city('Degirmenlik','cy','Turkish controlled area',4925.0,34.73,35.51).
city('Dipkarpaz','cy','Turkish controlled area',5215.0,34.39,35.6).
city('Gazimagusa','cy','Turkish controlled area',42532.0,33.94,35.11).
city('Girne','cy','Turkish controlled area',26720.0,33.33,35.33).
city('Guezelyurt','cy','Turkish controlled area',14836.0,32.98,35.2).
city('Iskele','cy','Turkish controlled area',4491.0,33.9,35.28).
city('Lapithos','cy','Turkish controlled area',5215.0,33.16,35.33).
city('Lefka','cy','Turkish controlled area',7836.0,32.85,35.11).
city('Nicosia','cy','Turkish controlled area',42342.0,33.37,35.18).
city('Yenierenkov','cy','Turkish controlled area',4056.0,34.19,35.54).
city('Ziyamet','cy','Turkish controlled area',1593.0,34.14,35.47).
city('Bechyne','cz','Jihocesky',5900.0,14.48,49.31).
city('Blatna','cz','Jihocesky',6609.0,13.88,49.43).
city('Borovany','cz','Jihocesky',3565.0,14.65,48.9).
city('Ceske Budejovice','cz','Jihocesky',97530.0,14.46,48.98).
city('Ceske Velenice','cz','Jihocesky',3504.0,14.97,48.77).
city('Cesky Krumlov','cz','Jihocesky',14404.0,14.32,48.82).
city('Chlum u Trebone','cz','Jihocesky',2253.0,14.92,48.95).
city('Chynov','cz','Jihocesky',2059.0,14.82,49.4).
city('Dacice','cz','Jihocesky',7895.0,15.43,49.08).
city('Dobra Voda u Ceskych Budejovic','cz','Jihocesky',2360.0,14.53,48.97).
city('Hluboka nad Vltavou','cz','Jihocesky',4514.0,14.43,49.05).
city('Horni Plana','cz','Jihocesky',2281.0,14.03,48.77).
city('Jindrichuv Hradec','cz','Jihocesky',22646.0,14.99,49.15).
city('Jistebnice','cz','Jihocesky',2035.0,14.53,49.48).
city('Kaplice','cz','Jihocesky',7087.0,14.48,48.74).
city('Kardasova Recice','cz','Jihocesky',2022.0,14.88,49.2).
city('Kremze','cz','Jihocesky',2475.0,14.3,48.9).
city('Ledenice','cz','Jihocesky',2135.0,14.63,48.93).
city('Lisov','cz','Jihocesky',3897.0,14.6,49.02).
city('Loucovice','cz','Jihocesky',1960.0,14.25,48.63).
city('Milevsko','cz','Jihocesky',9436.0,14.36,49.45).
city('Mlada Vozice','cz','Jihocesky',2721.0,14.82,49.53).
city('Netolice','cz','Jihocesky',2606.0,14.2,49.05).
city('Nova Bystrice','cz','Jihocesky',3389.0,15.1,49.02).
city('Nova Vcelnice','cz','Jihocesky',2463.0,15.07,49.23).
city('Nove Hrady','cz','Jihocesky',2588.0,14.78,48.78).
city('Pisek','cz','Jihocesky',29756.0,14.14,49.31).
city('Plana nad Luznici','cz','Jihocesky',3027.0,14.7,49.35).
city('Prachatice','cz','Jihocesky',11825.0,14.0,49.02).
city('Protivin','cz','Jihocesky',4926.0,14.22,49.2).
city('Rudolfov','cz','Jihocesky',2377.0,14.57,48.98).
city('Sezimovo Usti','cz','Jihocesky',7455.0,14.71,49.39).
city('Slavonice','cz','Jihocesky',2703.0,15.35,48.98).
city('Sobeslav','cz','Jihocesky',7252.0,14.72,49.25).
city('Strakonice','cz','Jihocesky',23863.0,13.91,49.26).
city('Studena','cz','Jihocesky',2482.0,15.28,49.18).
city('Suchdol nad Luznici','cz','Jihocesky',3628.0,14.88,48.9).
city('Tabor','cz','Jihocesky',36546.0,14.66,49.42).
city('Trebon','cz','Jihocesky',8968.0,14.78,49.02).
city('Trhove Sviny','cz','Jihocesky',4596.0,14.63,48.83).
city('Tyn nad Vltavou','cz','Jihocesky',8100.0,14.41,49.23).
city('Velesin','cz','Jihocesky',4006.0,14.47,48.83).
city('Veseli nad Luznici','cz','Jihocesky',6606.0,14.69,49.19).
city('Vetrni','cz','Jihocesky',3756.0,14.28,48.77).
city('Vimperk','cz','Jihocesky',8237.0,13.78,49.05).
city('Vodnany','cz','Jihocesky',6546.0,14.18,49.15).
city('Volary','cz','Jihocesky',4047.0,13.88,48.92).
city('Volyne','cz','Jihocesky',3177.0,13.2,50.45).
city('Vyssi Brod','cz','Jihocesky',2547.0,14.32,48.62).
city('Zliv','cz','Jihocesky',3679.0,14.37,49.07).
city('Adamov','cz','Jihomoravsky',4951.0,16.66,49.32).
city('Bilovice nad Svitavou','cz','Jihomoravsky',2293.0,16.67,49.25).
city('Blansko','cz','Jihomoravsky',20643.0,16.76,49.34).
city('Blatnice pod Svatym Antoninkem','cz','Jihomoravsky',2155.0,13.15,49.72).
city('Blucina','cz','Jihomoravsky',1998.0,16.65,49.07).
city('Boskovice','cz','Jihomoravsky',11356.0,16.66,49.49).
city('Breclav','cz','Jihomoravsky',26905.0,16.89,48.76).
city('Brno','cz','Jihomoravsky',377407.0,16.61,49.2).
city('Bucovice','cz','Jihomoravsky',6297.0,17.0,49.15).
city('Bzenec','cz','Jihomoravsky',4184.0,17.27,48.98).
city('Cejkovice','cz','Jihomoravsky',2554.0,16.28,48.88).
city('Cerna Hora','cz','Jihomoravsky',1906.0,16.58,49.42).
city('Dobsice','cz','Jihomoravsky',2333.0,16.08,48.85).
city('Dolni Bojanovice','cz','Jihomoravsky',2870.0,17.02,48.85).
city('Dolni Kounice','cz','Jihomoravsky',2297.0,16.47,49.07).
city('Drnovice','cz','Jihomoravsky',2178.0,16.95,49.28).
city('Dubnany','cz','Jihomoravsky',6635.0,17.09,48.92).
city('Hodonin','cz','Jihomoravsky',27600.0,17.12,48.86).
city('Hovorany','cz','Jihomoravsky',2212.0,17.0,48.95).
city('Hrusovany nad Jevisovkou','cz','Jihomoravsky',3261.0,16.4,48.83).
city('Hrusovany u Brna','cz','Jihomoravsky',2881.0,16.6,49.05).
city('Hustopece','cz','Jihomoravsky',5858.0,16.72,48.94).
city('Ivancice','cz','Jihomoravsky',9314.0,16.38,49.1).
city('Ivanovice na Hane','cz','Jihomoravsky',2893.0,17.1,49.32).
city('Jedovnice','cz','Jihomoravsky',2477.0,16.77,49.35).
city('Klobouky u Brna','cz','Jihomoravsky',2219.0,16.87,48.98).
city('Kobyli','cz','Jihomoravsky',2084.0,16.9,48.93).
city('Kunstat','cz','Jihomoravsky',2532.0,16.52,49.5).
city('Kurim','cz','Jihomoravsky',8896.0,16.56,49.29).
city('Kyjov','cz','Jihomoravsky',12394.0,18.12,49.01).
city('Lanzhot','cz','Jihomoravsky',3756.0,16.97,48.73).
city('Lednice','cz','Jihomoravsky',2347.0,16.8,48.8).
city('Letovice','cz','Jihomoravsky',6614.0,16.58,49.55).
city('Luzice','cz','Jihomoravsky',2731.0,17.07,48.85).
city('Mikulcice','cz','Jihomoravsky',1899.0,17.05,48.82).
city('Mikulov','cz','Jihomoravsky',7653.0,16.63,48.8).
city('Milotice','cz','Jihomoravsky',1940.0,17.13,48.97).
city('Miroslav','cz','Jihomoravsky',2998.0,16.32,48.95).
city('Modrice','cz','Jihomoravsky',3491.0,16.62,49.13).
city('Mokra-Horakov','cz','Jihomoravsky',2577.0,16.6,49.27).
city('Moravska Nova Ves','cz','Jihomoravsky',2518.0,17.02,48.8).
city('Moravsky Krumlov','cz','Jihomoravsky',6079.0,16.31,49.05).
city('Moravsky Pisek','cz','Jihomoravsky',2140.0,17.33,48.98).
city('Mutenice','cz','Jihomoravsky',3655.0,17.02,48.92).
city('Namest nad Oslavou','cz','Jihomoravsky',5226.0,16.18,49.21).
city('Orechov','cz','Jihomoravsky',2344.0,16.53,49.12).
city('Oslavany','cz','Jihomoravsky',4527.0,16.33,49.13).
city('Podivin','cz','Jihomoravsky',2876.0,16.85,48.83).
city('Pohorelice','cz','Jihomoravsky',4345.0,16.52,48.98).
city('Pozorice','cz','Jihomoravsky',1968.0,16.78,49.2).
city('Prusanky','cz','Jihomoravsky',2087.0,16.98,48.83).
city('Rajec-Jestrebi','cz','Jihomoravsky',3548.0,16.63,49.42).
city('Rajhrad','cz','Jihomoravsky',2703.0,16.6,49.08).
city('Rakvice','cz','Jihomoravsky',2066.0,16.82,48.85).
city('Ratiskovice','cz','Jihomoravsky',4032.0,17.17,48.93).
city('Rohatec','cz','Jihomoravsky',3358.0,17.18,48.92).
city('Rosice','cz','Jihomoravsky',5276.0,16.38,49.18).
city('Rousinov','cz','Jihomoravsky',4903.0,14.82,49.82).
city('Sardice','cz','Jihomoravsky',2189.0,17.03,48.97).
city('Sitborice','cz','Jihomoravsky',1940.0,16.78,49.02).
city('Slapanice','cz','Jihomoravsky',6190.0,16.73,49.17).
city('Slavkov u Brna','cz','Jihomoravsky',5858.0,16.86,49.15).
city('Straznice','cz','Jihomoravsky',5960.0,17.31,48.9).
city('Strelice','cz','Jihomoravsky',2527.0,16.5,49.15).
city('Svatoborice-Mistrin','cz','Jihomoravsky',3470.0,17.1,48.98).
city('Tisnov','cz','Jihomoravsky',8279.0,16.43,49.35).
city('Tvrdonice','cz','Jihomoravsky',2059.0,17.0,48.77).
city('Ujezd u Brna','cz','Jihomoravsky',2754.0,16.75,49.1).
city('Vacenovice','cz','Jihomoravsky',2075.0,17.18,48.95).
city('Valtice','cz','Jihomoravsky',3616.0,16.75,48.75).
city('Velka nad Velickou','cz','Jihomoravsky',3216.0,17.53,48.88).
city('Velke Bilovice','cz','Jihomoravsky',3785.0,16.9,48.85).
city('Velke Opatovice','cz','Jihomoravsky',4176.0,16.67,49.62).
city('Velke Pavlovice','cz','Jihomoravsky',3089.0,16.82,48.9).
city('Veverska Bityska','cz','Jihomoravsky',2779.0,16.43,49.27).
city('Vnorovy','cz','Jihomoravsky',3065.0,17.35,48.93).
city('Vracov','cz','Jihomoravsky',4514.0,17.22,48.98).
city('Vranovice','cz','Jihomoravsky',1918.0,16.6,48.97).
city('Vyskov','cz','Jihomoravsky',22549.0,17.0,49.28).
city('Zastavka','cz','Jihomoravsky',2350.0,16.37,49.2).
city('Zbysov','cz','Jihomoravsky',3925.0,16.82,49.13).
city('Zdanice','cz','Jihomoravsky',2731.0,17.03,49.07).
city('Zidlochovice','cz','Jihomoravsky',3075.0,16.62,49.03).
city('Znojmo','cz','Jihomoravsky',35791.0,16.06,48.86).
city('As','cz','Karlovarsky',12555.0,12.35,50.24).
city('Bochov','cz','Karlovarsky',1940.0,13.05,50.15).
city('Brezova','cz','Karlovarsky',2767.0,12.87,50.2).
city('Cheb','cz','Karlovarsky',32778.0,12.35,50.08).
city('Chodov','cz','Karlovarsky',14661.0,12.75,50.23).
city('Frantiskovy Lazne','cz','Karlovarsky',5234.0,12.35,50.12).
city('Horni Slavkov','cz','Karlovarsky',5942.0,12.8,50.15).
city('Hranice','cz','Karlovarsky',2254.0,12.18,50.28).
city('Jachymov','cz','Karlovarsky',2816.0,12.92,50.37).
city('Karlovy Vary','cz','Karlovarsky',53585.0,12.87,50.24).
city('Kraslice','cz','Karlovarsky',7236.0,12.51,50.34).
city('Kynsperk nad Ohri','cz','Karlovarsky',5134.0,12.53,50.12).
city('Loket','cz','Karlovarsky',3186.0,12.75,50.18).
city('Luby','cz','Karlovarsky',2465.0,12.4,50.25).
city('Marianske Lazne','cz','Karlovarsky',14709.0,12.7,49.97).
city('Nejdek','cz','Karlovarsky',8556.0,12.74,50.33).
city('Nova Role','cz','Karlovarsky',4027.0,12.8,50.27).
city('Nove Sedlo','cz','Karlovarsky',2626.0,12.73,50.22).
city('Olovi','cz','Karlovarsky',1891.0,12.55,50.25).
city('Ostrov','cz','Karlovarsky',17453.0,12.94,50.31).
city('Plesna','cz','Karlovarsky',1972.0,12.35,50.22).
city('Rotava','cz','Karlovarsky',3431.0,12.58,50.3).
city('Sokolov','cz','Karlovarsky',25079.0,12.63,50.19).
city('Tepla','cz','Karlovarsky',3085.0,12.87,49.98).
city('Touzim','cz','Karlovarsky',3779.0,13.0,50.07).
city('Velka Hledsebe','cz','Karlovarsky',2113.0,12.67,49.97).
city('Zlutice','cz','Karlovarsky',2854.0,13.18,50.1).
city('Borohradek','cz','Kralovehradecky',2127.0,16.1,50.1).
city('Broumov','cz','Kralovehradecky',8325.0,16.34,50.58).
city('Cernilov','cz','Kralovehradecky',2160.0,15.94,50.26).
city('Cerveny Kostelec','cz','Kralovehradecky',8431.0,16.1,50.48).
city('Ceska Skalice','cz','Kralovehradecky',5384.0,16.04,50.39).
city('Chlumec nad Cidlinou','cz','Kralovehradecky',5229.0,15.46,50.17).
city('Dobruska','cz','Kralovehradecky',7150.0,16.13,50.29).
city('Doudleby nad Orlici','cz','Kralovehradecky',1927.0,16.27,50.12).
city('Dvur Kralove','cz','Kralovehradecky',16364.0,15.81,50.44).
city('Habartov','cz','Kralovehradecky',5367.0,12.54,50.2).
city('Holice','cz','Kralovehradecky',6192.0,15.98,50.08).
city('Horice','cz','Kralovehradecky',9052.0,15.63,50.37).
city('Hostinne','cz','Kralovehradecky',4865.0,15.73,50.55).
city('Hradec Kralove','cz','Kralovehradecky',97427.0,15.82,50.22).
city('Hronov','cz','Kralovehradecky',6491.0,16.18,50.48).
city('Jaromer','cz','Kralovehradecky',12911.0,15.91,50.35).
city('Jicin','cz','Kralovehradecky',16516.0,15.35,50.44).
city('Kopidlno','cz','Kralovehradecky',2195.0,15.27,50.33).
city('Kostelec nad Orlici','cz','Kralovehradecky',6153.0,16.22,50.12).
city('Lazne Belohrad','cz','Kralovehradecky',3780.0,15.56,50.44).
city('Mezimesti','cz','Kralovehradecky',2840.0,16.25,50.62).
city('Mlade Buky','cz','Kralovehradecky',2199.0,15.85,50.6).
city('Nachod','cz','Kralovehradecky',21196.0,16.17,50.42).
city('Nechanice','cz','Kralovehradecky',2186.0,15.64,50.24).
city('Nova Paka','cz','Kralovehradecky',9259.0,15.51,50.48).
city('Nove Mesto nad Metuji','cz','Kralovehradecky',10074.0,16.14,50.35).
city('Novy Bydzov','cz','Kralovehradecky',7170.0,15.5,50.25).
city('Opocno','cz','Kralovehradecky',3124.0,16.12,50.27).
city('Police nad Metuji','cz','Kralovehradecky',4377.0,16.23,50.53).
city('Rokytnice v Orlickych horach','cz','Kralovehradecky',2502.0,16.47,50.17).
city('Rtyne v Podkrkonosi','cz','Kralovehradecky',3040.0,16.07,50.5).
city('Rudnik','cz','Kralovehradecky',2178.0,15.73,50.61).
city('Rychnov nad Kneznou','cz','Kralovehradecky',11721.0,16.27,50.17).
city('Smirice','cz','Kralovehradecky',3131.0,15.87,50.3).
city('Sobotka','cz','Kralovehradecky',2279.0,15.17,50.47).
city('Solnice','cz','Kralovehradecky',2076.0,16.25,50.2).
city('Stara Paka','cz','Kralovehradecky',2015.0,15.49,50.51).
city('Svoboda nad Upou','cz','Kralovehradecky',2249.0,15.83,50.61).
city('Trebechovice pod Orebem','cz','Kralovehradecky',5406.0,16.0,50.2).
city('Trutnov','cz','Kralovehradecky',32085.0,15.9,50.57).
city('Tyniste nad Orl','cz','Kralovehradecky',6259.0,16.07,50.15).
city('Upice','cz','Kralovehradecky',5906.0,16.01,50.52).
city('Vamberk','cz','Kralovehradecky',4794.0,16.3,50.12).
city('Velke Porici','cz','Kralovehradecky',2272.0,16.18,50.47).
city('Vrchlabi','cz','Kralovehradecky',13155.0,15.61,50.62).
city('Zacler','cz','Kralovehradecky',3617.0,15.91,50.66).
city('Ceska Kamenice','cz','Liberecky',5468.0,14.43,50.79).
city('Ceska Lipa','cz','Liberecky',39398.0,14.53,50.69).
city('Cesky Dub','cz','Liberecky',2835.0,14.98,50.65).
city('Chrastava','cz','Liberecky',5918.0,14.97,50.82).
city('Cvikov','cz','Liberecky',4430.0,14.63,50.78).
city('Desna','cz','Liberecky',3534.0,15.31,50.76).
city('Doksy','cz','Liberecky',5041.0,14.67,50.57).
city('Frydlant','cz','Liberecky',7481.0,15.08,50.92).
city('Hejnice','cz','Liberecky',2692.0,15.2,50.89).
city('Hodkovice nad Mohelkou','cz','Liberecky',2588.0,15.09,50.66).
city('Hradek','cz','Liberecky',7245.0,14.85,50.85).
city('Jablonec','cz','Liberecky',45289.0,15.16,50.73).
city('Jablonec nad Jizerou','cz','Liberecky',1967.0,15.42,50.7).
city('Jablonne v Podjestedi','cz','Liberecky',3674.0,14.78,50.77).
city('Jilemnice','cz','Liberecky',5728.0,15.51,50.61).
city('Kamenicky Senov','cz','Liberecky',4055.0,14.48,50.77).
city('Liberec','cz','Liberecky',99416.0,15.06,50.78).
city('Lomnice nad Popelkou','cz','Liberecky',6108.0,15.36,50.54).
city('Mimon','cz','Liberecky',6708.0,14.73,50.65).
city('Nove Mesto pod Smrkem','cz','Liberecky',4001.0,15.23,50.92).
city('Novy Bor','cz','Liberecky',12325.0,14.55,50.77).
city('Raspenava','cz','Liberecky',2835.0,15.12,50.9).
city('Rokytnice nad Jizerou','cz','Liberecky',3373.0,15.45,50.73).
city('Rychnov u Jablonce nad Nisou','cz','Liberecky',2004.0,15.16,50.69).
city('Semily','cz','Liberecky',9247.0,15.33,50.6).
city('Smrzovka','cz','Liberecky',3415.0,15.24,50.74).
city('Straz pod Ralskem','cz','Liberecky',4010.0,14.8,50.7).
city('Tanvald','cz','Liberecky',6971.0,15.3,50.73).
city('Turnov','cz','Liberecky',14500.0,15.14,50.6).
city('Velke Hamry','cz','Liberecky',2709.0,15.32,50.72).
city('Zakupy','cz','Liberecky',2582.0,14.65,50.68).
city('Zelezny Brod','cz','Liberecky',6516.0,15.25,50.64).
city('Albrechtice','cz','Moravskoslezsky',4055.0,15.04,50.86).
city('Baska','cz','Moravskoslezsky',3145.0,18.37,49.65).
city('Bilovec','cz','Moravskoslezsky',7465.0,18.03,49.77).
city('Bohumin','cz','Moravskoslezsky',23310.0,18.36,49.9).
city('Bolatice','cz','Moravskoslezsky',4118.0,18.08,49.97).
city('Bridlicna','cz','Moravskoslezsky',3796.0,17.37,49.92).
city('Bruntal','cz','Moravskoslezsky',17610.0,17.46,49.99).
city('Brusperk','cz','Moravskoslezsky',3573.0,18.22,49.7).
city('Budisov nad Budisovkou','cz','Moravskoslezsky',3220.0,17.63,49.8).
city('Bystrice','cz','Moravskoslezsky',4972.0,18.72,49.63).
city('Celadna','cz','Moravskoslezsky',2027.0,18.38,49.57).
city('Cesky Tesin','cz','Moravskoslezsky',26478.0,18.62,49.75).
city('Detmarovice','cz','Moravskoslezsky',3768.0,18.47,49.9).
city('Dobra','cz','Moravskoslezsky',2920.0,18.42,49.68).
city('Dolni Benesov','cz','Moravskoslezsky',4353.0,18.12,49.92).
city('Dolni Lutyne','cz','Moravskoslezsky',4752.0,18.43,49.9).
city('Frenstat','cz','Moravskoslezsky',11348.0,18.21,49.54).
city('Frycovice','cz','Moravskoslezsky',2114.0,18.23,49.67).
city('Frydek-Mistek','cz','Moravskoslezsky',61584.0,18.33,49.69).
city('Frydlant nad Ostravici','cz','Moravskoslezsky',9753.0,18.36,49.59).
city('Fulnek','cz','Moravskoslezsky',6030.0,17.91,49.72).
city('Haj ve Slezsku','cz','Moravskoslezsky',3299.0,18.1,49.9).
city('Hat','cz','Moravskoslezsky',2554.0,18.25,49.95).
city('Havirov','cz','Moravskoslezsky',85829.0,18.43,49.79).
city('Hlucin','cz','Moravskoslezsky',14341.0,18.17,49.9).
city('Horni Benesov','cz','Moravskoslezsky',2473.0,17.6,49.97).
city('Horni Sucha','cz','Moravskoslezsky',4353.0,18.5,49.8).
city('Hradec nad Moravici','cz','Moravskoslezsky',5033.0,17.88,49.86).
city('Hukvaldy','cz','Moravskoslezsky',1897.0,18.23,49.63).
city('Jablunkov','cz','Moravskoslezsky',5911.0,18.76,49.59).
city('Karvina','cz','Moravskoslezsky',65441.0,18.54,49.86).
city('Klimkovice','cz','Moravskoslezsky',3755.0,18.13,49.8).
city('Koberice','cz','Moravskoslezsky',3198.0,18.05,49.98).
city('Koprivnice','cz','Moravskoslezsky',23798.0,18.14,49.6).
city('Kozlovice','cz','Moravskoslezsky',2811.0,18.27,49.6).
city('Kravare','cz','Mora',6667.0,18.01,49.93).
city('Krnov','cz','Moravskoslezsky',25769.0,17.68,50.09).
city('Kuncice pod Ondrejnikem','cz','Moravskoslezsky',1954.0,18.27,49.55).
city('Ludgerovice','cz','Moravskoslezsky',4577.0,18.25,49.9).
city('Mesto Albrechtice','cz','Moravskoslezsky',3612.0,17.57,50.17).
city('Moravsky Beroun','cz','Moravskoslezsky',3418.0,17.45,49.8).
city('Morkov','cz','Moravskoslezsky',2365.0,18.07,49.53).
city('Mosty u Jablunkova','cz','Moravskoslezsky',3981.0,18.75,49.53).
city('Navsi','cz','Moravskoslezsky',3750.0,18.77,49.58).
city('Novy Jicin','cz','Moravskoslezsky',27043.0,17.99,49.6).
city('Nydek','cz','Moravskoslezsky',1944.0,18.77,49.67).
city('Odry','cz','Moravskoslezsky',7415.0,17.83,49.67).
city('Opava','cz','Moravskoslezsky',61514.0,17.89,49.94).
city('Orlova','cz','Moravskoslezsky',34938.0,18.4,49.85).
city('Ostrava','cz','Moravskoslezsky',317136.0,18.27,49.83).
city('Ostravice','cz','Moravskoslezsky',2299.0,18.28,49.87).
city('Palkovice','cz','Moravskoslezsky',2590.0,18.32,49.63).
city('Paskov','cz','Moravskoslezsky',3704.0,18.3,49.73).
city('Petrovice u Karvine','cz','Moravskoslezsky',4499.0,18.53,49.9).
city('Petrvald','cz','Moravskoslezsky',6785.0,18.4,49.84).
city('Pist','cz','Moravskoslezsky',2089.0,18.2,49.98).
city('Pribor','cz','Moravskoslezsky',8720.0,18.15,49.65).
city('Rychvald','cz','Moravskoslezsky',6743.0,18.36,49.87).
city('Rymarov','cz','Moravskoslezsky',9131.0,17.08,49.89).
city('Senov','cz','Moravskoslezsky',5385.0,18.37,49.78).
city('Senov u Noveho Jicina','cz','Moravskoslezsky',1949.0,18.0,49.62).
city('Stara Ves nad Ondrejnici','cz','Moravskoslezsky',2439.0,18.18,49.73).
city('Stary Jicin','cz','Moravskoslezsky',2400.0,17.97,49.57).
city('Stepankovice','cz','Moravskoslezsky',3030.0,18.03,49.97).
city('Stramberk','cz','Moravskoslezsky',3395.0,18.1,49.6).
city('Studenka','cz','Moravskoslezsky',10503.0,18.08,49.74).
city('Suchdol nad Odrou','cz','Moravskoslezsky',2483.0,17.93,49.65).
city('Terlicko','cz','Moravskoslezsky',4110.0,18.5,49.75).
city('Trinec','cz','Moravskoslezsky',39054.0,18.66,49.69).
city('Trojanovice','cz','Moravskoslezsky',2054.0,18.25,49.52).
city('Vendryne','cz','Moravskoslezsky',3827.0,18.7,49.67).
city('Verovice','cz','Moravskoslezsky',1934.0,18.12,49.55).
city('Vitkov','cz','Moravskoslezsky',6312.0,17.75,49.78).
city('Vratimov','cz','Moravskoslezsky',6431.0,18.31,49.77).
city('Vrbno pod Pradedem','cz','Moravskoslezsky',6220.0,17.38,50.13).
city('Vresina','cz','Moravskoslezsky',2328.0,18.2,49.95).
city('Bludov','cz','Olomoucky',3177.0,16.93,49.95).
city('Bohunovice','cz','Olomoucky',2354.0,17.28,49.67).
city('Brodek u Prerova','cz','Olomoucky',1908.0,17.33,49.48).
city('Ceska Ves','cz','Olomoucky',2475.0,17.23,50.25).
city('Dolany','cz','Olomoucky',1932.0,17.33,49.65).
city('Hanusovice','cz','Olomoucky',3585.0,16.95,50.08).
city('Hlubocky','cz','Olomoucky',4556.0,17.4,49.63).
city('Horka nad Moravou','cz','Olomoucky',2048.0,17.2,49.65).
city('Hranice','cz','Olomoucky',19666.0,17.75,49.56).
city('Javornik','cz','Olomoucky',2935.0,17.02,50.4).
city('Jesenik','cz','Olomoucky',12693.0,17.2,50.23).
city('Kojetin','cz','Olomoucky',6407.0,17.31,49.35).
city('Konice','cz','Olomoucky',3019.0,16.88,49.58).
city('Kostelec na Hane','cz','Olomoucky',2713.0,17.07,49.52).
city('Libina','cz','Olomoucky',3468.0,17.12,49.87).
city('Lipnik nad Becvou','cz','Olomoucky',8541.0,17.58,49.54).
city('Lipova-lazne','cz','Olomoucky',2532.0,16.87,49.53).
city('Litovel','cz','Olomoucky',10026.0,17.08,49.72).
city('Lostice','cz','Olomoucky',3051.0,16.93,49.75).
city('Loucna nad Desnou','cz','Olomoucky',1925.0,17.1,50.07).
city('Lutin','cz','Olomoucky',3198.0,17.13,49.57).
city('Mikulovice','cz','Olomoucky',2771.0,17.33,50.3).
city('Mohelnice','cz','Olomoucky',9808.0,16.92,49.78).
city('Nemcice nad Hanou','cz','Olomouck',2102.0,17.2,49.35).
city('Novy Malin','cz','Olomoucky',2303.0,17.03,49.95).
city('Olomouc','cz','Olomoucky',102792.0,17.25,49.61).
city('Plumlov','cz','Olomoucky',2259.0,17.02,49.47).
city('Postrelmov','cz','Olomoucky',3222.0,16.92,49.92).
city('Prerov','cz','Olomoucky',48513.0,17.5,49.48).
city('Prostejov','cz','Olomoucky',48258.0,17.12,49.48).
city('Rapotin','cz','Olomoucky',2887.0,17.02,49.98).
city('Ruda nad Moravou','cz','Olomoucky',2464.0,16.88,49.98).
city('Sobotin','cz','Olomoucky',2502.0,17.1,50.02).
city('Stare Mesto','cz','Olomoucky',2137.0,16.95,50.17).
city('Stepanov','cz','Olomoucky',3316.0,16.92,50.17).
city('Sternberk','cz','Olomoucky',14130.0,17.29,49.73).
city('Stity','cz','Olomoucky',2021.0,16.77,49.97).
city('Sumperk','cz','Olomoucky',29604.0,16.97,49.97).
city('Tovacov','cz','Olomoucky',2656.0,17.28,49.43).
city('Troubky','cz','Olomoucky',1980.0,17.35,49.43).
city('Unicov','cz','Olomoucky',12474.0,17.12,49.77).
city('Velka Bystrice','cz','Olomoucky',2857.0,17.35,49.6).
city('Velke','cz','Olomoucky',2878.0,17.05,50.03).
city('Velky Tynec','cz','Olomoucky',2114.0,17.33,49.55).
city('Vikyrovice','cz','Olomoucky',2014.0,17.01,49.99).
city('Zabreh','cz','Olomoucky',14574.0,16.87,49.88).
city('Zlate Hory','cz','Olomoucky',4489.0,17.4,50.27).
city('Cervena Voda','cz','Pardubicky',3214.0,16.75,50.03).
city('Ceska Trebova','cz','Pardubicky',17103.0,16.44,49.91).
city('Chocen','cz','Pardubicky',9002.0,16.23,50.0).
city('Chrast','cz','Pardubicky',3210.0,15.93,49.3).
city('Chrudim','cz','Pardubicky',23909.0,15.79,49.95).
city('Chvaletice','cz','Pardubicky',3308.0,15.42,50.03).
city('Dolni Dobrouc','cz','Pardubicky',2553.0,16.5,49.98).
city('Hermanuv Mestec','cz','Pardubicky',4865.0,15.67,49.96).
city('Hlinsko','cz','Pardubicky',10538.0,15.9,49.77).
city('Jablonne nad Orlici','cz','Pardubicky',3106.0,16.6,50.03).
city('Jevicko','cz','Pardubicky',2817.0,16.73,49.63).
city('Kraliky','cz','Pardubicky',4806.0,16.77,50.08).
city('Lanskroun','cz','Pardubicky',9980.0,16.61,49.91).
city('Lazne Bohdanec','cz','Pardubicky',3083.0,15.68,50.08).
city('Letohrad','cz','Pardubicky',6257.0,16.49,50.03).
city('Litomysl','cz','Pardubicky',10351.0,16.31,49.87).
city('Luze','cz','Pardubicky',2601.0,16.03,49.9).
city('Moravska Trebova','cz','Pardubicky',11564.0,16.67,49.76).
city('Opatovice nad Labem','cz','Pardubicky',2171.0,15.8,50.15).
city('Pardubice','cz','Pardubicky',90853.0,15.77,50.03).
city('Policka','cz','Pardubicky',9149.0,16.27,49.72).
city('Prelouc','cz','Pardubicky',9106.0,15.57,50.04).
city('Prosec','cz','Pardubicky',2089.0,16.12,49.8).
city('Sezemice','cz','Pardubicky',2995.0,15.86,50.07).
city('Skutec','cz','Pardubicky',5322.0,16.0,49.86).
city('Slatinany','cz','Pardubicky',3957.0,15.82,49.92).
city('Svitavy','cz','Pardubicky',17625.0,16.47,49.76).
city('Tremosnice','cz','Pardubicky',3390.0,15.58,49.87).
city('Usti nad Orlici','cz','Pardubicky',15194.0,16.4,49.97).
city('Vysoke Myto','cz','Pardubicky',12173.0,16.16,49.95).
city('Zamberk','cz','Pardubicky',6128.0,16.46,50.1).
city('Blovice','cz','Plzensky',3852.0,13.55,49.58).
city('Bor','cz','Plzensky',3944.0,12.78,49.72).
city('Brasy','cz','Plzensky',2024.0,13.57,49.83).
city('Chlumcany','cz','Plzensky',2371.0,13.32,49.63).
city('Chotesov','cz','Plzensky',2592.0,13.22,49.65).
city('Dobrany','cz','Plzensky',5642.0,13.29,49.66).
city('Domazlice','cz','Plzensky',11036.0,12.93,49.45).
city('Holysov','cz','Plzensky',4562.0,13.1,49.6).
city('Horazdovice','cz','Plzensky',5692.0,13.71,49.32).
city('Horni Briza','cz','Plzensky',4468.0,13.37,49.83).
city('Horsovky Tyn','cz','Plzensky',4917.0,12.95,49.54).
city('Hradek','cz','Plzensky',2888.0,13.5,49.25).
city('Janovice nad Uhlavou','cz','Plzensky',2025.0,13.22,49.35).
city('Kaznejov','cz','Plzensky',2986.0,13.4,49.88).
city('Kdyne','cz','Plzensky',4879.0,13.03,49.4).
city('Klatovy','cz','Plzensky',23059.0,13.29,49.4).
city('Kralovice','cz','Plzensky',3475.0,13.48,49.98).
city('Line','cz','Plzensky',2230.0,13.27,49.7).
city('Mirosov','cz','Plzensky',2228.0,13.67,49.68).
city('Nepomuk','cz','Plzensky',3531.0,13.6,49.48).
city('Nyran','cz','Plzensky',6884.0,13.19,49.72).
city('Nyrsko','cz','Plzensky',5088.0,13.14,49.3).
city('Plana','cz','Plzensky',5377.0,12.74,49.87).
city('Plasy','cz','Plzensky',2610.0,13.4,49.93).
city('Plzen','cz','Plzensky',165531.0,13.37,49.75).
city('Prestice','cz','Plzensky',6426.0,13.33,49.58).
city('Rokycany','cz','Plzensky',14295.0,13.6,49.74).
city('Spalene Porici','cz','Plzensky',2501.0,13.62,49.62).
city('Stahlavy','cz','Plzensky',2156.0,13.5,49.67).
city('Stankov','cz','Plzensky',3053.0,13.07,49.55).
city('Stary Plzenec','cz','Plzensky',4225.0,13.48,49.7).
city('Stod','cz','Plzensky',3429.0,13.17,49.63).
city('Strasice','cz','Plzensky',2456.0,13.77,49.73).
city('Stribro','cz','Plzensky',7748.0,12.99,49.76).
city('Susice','cz','Plzensky',11452.0,13.51,49.24).
city('Tachov','cz','Plzensky',12684.0,12.63,49.8).
city('Tlucna','cz','Plzensky',2307.0,13.23,49.73).
city('Tremosna','cz','Plzensky',4605.0,13.4,49.82).
city('Vejprnice','cz','Plzensky',2509.0,13.28,49.73).
city('Zbiroh','cz','Plzensky',2582.0,13.77,49.85).
city('Zelezna Ruda','cz','Plzensky',2009.0,13.23,49.13).
city('Zruc-Senec','cz','Plzensky',2353.0,13.43,49.8).
city('Prague','cz','Prague',1154508.0,14.43,50.08).
city('Bakov nad Jizerou','cz','Stredocesky',4684.0,14.93,50.48).
city('Bela pod Bezdezem','cz','Stredocesky',4937.0,14.8,50.5).
city('Benatky nad Jizerou','cz','Stredocesky',6853.0,14.83,50.28).
city('Benesov','cz','Stredocesky',16321.0,14.69,49.79).
city('Beroun','cz','Stredocesky',17422.0,14.07,49.97).
city('Brandys nad Labem-Stara Boleslav','cz','Stredocesky',15375.0,14.66,50.19).
city('Breznice','cz','Stredocesky',3772.0,13.97,49.55).
city('Bustehrad','cz','Stredocesky',2343.0,14.18,50.15).
city('Bystrice','cz','Stredocesky',3991.0,14.67,49.73).
city('Caslav','cz','Stredocesky',10209.0,15.39,49.91).
city('Celakovice','cz','Stredocesky',10086.0,14.77,50.17).
city('Cercany','cz','Stredocesky',2689.0,14.72,49.85).
city('Cernosice','cz','Stredocesky',4774.0,14.32,49.97).
city('Cesky Brod','cz','Stredocesky',6875.0,14.87,50.09).
city('Dobrichovice','cz','Stredocesky',2863.0,14.28,49.93).
city('Dobris','cz','Stredocesky',8066.0,14.16,49.79).
city('Dobrovice','cz','Stredocesky',3027.0,14.95,50.37).
city('Dolni Bousov','cz','Stredocesky',2362.0,15.12,50.43).
city('Horomerice','cz','Stredocesky',2105.0,14.33,50.13).
city('Horovice','cz','Stredocesky',6570.0,13.9,49.85).
city('Hostivice','cz','Stredocesky',4727.0,14.27,50.08).
city('Jesenice','cz','Stredocesky',2551.0,14.52,49.97).
city('Jilove u Prahy','cz','Stredocesky',3427.0,14.5,49.9).
city('Jince','cz','Stredocesky',2296.0,13.98,49.78).
city('Kamenice','cz','Stredocesky',2901.0,14.58,49.9).
city('Kladno','cz','Stredocesky',71262.0,14.09,50.15).
city('Klecany','cz','Stredocesky',2018.0,14.42,50.18).
city('Kolin','cz','Stredocesky',30351.0,15.19,50.03).
city('Komarov','cz','Stredocesky',2542.0,13.87,49.8).
city('Kosmonosy','cz','Stredocesky',4005.0,14.93,50.43).
city('Kostelec nad Cernymi Lesy','cz','Stredocesky',3345.0,14.87,49.98).
city('Kostelec nad Labem','cz','Stredocesky',3029.0,14.6,50.23).
city('Kralupy nad Vltavou','cz','Stredocesky',17493.0,14.31,50.25).
city('Kraluv Dvur','cz','Stredocesky',5509.0,14.03,49.92).
city('Kutna Hora','cz','Stredocesky',21474.0,15.27,49.95).
city('Libcice nad Vltavou','cz','Stredocesky',3404.0,14.35,50.2).
city('Libusin','cz','Stredocesky',2539.0,14.05,50.17).
city('Lysa nad Labem','cz','Stredocesky',8461.0,14.83,50.2).
city('Melnik','cz','Stredocesky',19318.0,14.46,50.36).
city('Mestec Kralove','cz','Stredocesky',3010.0,15.3,50.21).
city('Milin','cz','Stredocesky',2107.0,14.05,49.63).
city('Milovice','cz','Stredocesky',4342.0,14.9,50.23).
city('Mlada Boleslav','cz','Stredocesky',44417.0,14.9,50.42).
city('Mnichovice','cz','Stredocesky',2204.0,14.7,49.93).
city('Mnichovo Hradiste','cz','Stredocesky',8652.0,14.98,50.52).
city('Mnisek pod Brdy','cz','Stredocesky',4208.0,14.27,49.87).
city('Neratovice','cz','Stredocesky',16285.0,14.51,50.26).
city('Neveklov','cz','Stredocesky',2432.0,14.53,49.75).
city('Nove Straseci','cz','Stredocesky',5210.0,13.89,50.16).
city('Nymburk','cz','Stredocesky',14498.0,15.03,50.19).
city('Odolena Voda','cz','Stredocesky',4478.0,14.42,50.23).
city('Pecky','cz','Stredocesky',4386.0,15.03,50.09).
city('Podebrady','cz','Stredocesky',13445.0,15.12,50.15).
city('Pribram','cz','Stredocesky',35963.0,13.99,49.69).
city('Pruhonice','cz','Stredocesky',2008.0,14.57,50.0).
city('Rakovnik','cz','Stredocesky',16725.0,13.73,50.11).
city('Revnice','cz','Stredocesky',3047.0,14.25,49.92).
city('Ricany','cz','Stredocesky',10928.0,14.67,49.99).
city('Rozmital pod Tremsinem','cz','Stredocesky',4491.0,13.88,49.6).
city('Roztoky','cz','Stredocesky',5910.0,14.4,50.17).
city('Rudna','cz','Stredocesky',3170.0,14.22,50.03).
city('Sadska','cz','Stredocesky',3153.0,14.98,50.13).
city('Sazava','cz','Stredocesky',3843.0,14.9,49.87).
city('Sedlcany','cz','Stredocesky',8088.0,14.41,49.67).
city('Sedlec-Prcice','cz','Stredocesky',3037.0,14.55,49.58).
city('Slany','cz','Stredocesky',15330.0,14.09,50.23).
city('Stochov','cz','Stredocesky',5563.0,13.95,50.15).
city('Tuchlovice','cz','Stredocesky',2211.0,14.0,50.15).
city('Tynec nad Sazavou','cz','Stredocesky',5374.0,14.6,49.83).
city('Uhlirske Janovice','cz','Stredocesky',3172.0,15.0,49.88).
city('Unhost','cz','Stredocesky',3676.0,14.15,50.08).
city('Uvaly','cz','Stredocesky',4834.0,14.73,50.08).
city('Velim','cz','Stredocesky',2046.0,15.1,50.06).
city('Velky Osek','cz','Stredocesky',2188.0,15.19,50.1).
city('Velvary','cz','Stredocesky',3001.0,14.25,50.28).
city('Vlasim','cz','Stredocesky',12350.0,14.89,49.71).
city('Votice','cz','Stredocesky',4599.0,14.65,49.65).
city('Vrdy','cz','Stredocesky',3049.0,15.48,49.92).
city('Vsetaty','cz','Stredocesky',2001.0,14.6,50.28).
city('Zdic','cz','Stredocesky',3936.0,13.98,49.9).
city('Zlonice','cz','Stredocesky',2261.0,14.1,50.28).
city('Zruc nad Sazavou','cz','Stredocesky',5175.0,15.09,49.74).
city('Becov','cz','Ustecky',2069.0,13.72,50.45).
city('Benesov nad Ploucnici','cz','Ustecky',4042.0,14.32,50.73).
city('Bilina','cz','Ustecky',15866.0,13.76,50.55).
city('Bohusovice nad Ohri','cz','Ustecky',2523.0,14.15,50.5).
city('Chabarovice','cz','Ustecky',2223.0,13.93,50.68).
city('Chlumec','cz','Ustecky',4090.0,13.93,50.7).
city('Chomutov','cz','Ustecky',51054.0,13.39,50.46).
city('Decin','cz','Ustecky',52521.0,14.19,50.78).
city('Dolni Poustevna','cz','Ustecky',1938.0,14.3,50.98).
city('Dubi','cz','Ustecky',7592.0,13.78,50.68).
city('Duchcov','cz','Ustecky',8737.0,13.75,50.6).
city('Horni Jiretin','cz','Ustecky',1908.0,13.57,50.57).
city('Hrob','cz','Ustecky',1979.0,13.72,50.67).
city('Jilove','cz','Ustecky',5233.0,14.11,50.77).
city('Jirikov','cz','Ustecky',3901.0,14.58,50.98).
city('Jirkov','cz','Ustecky',20648.0,13.44,50.5).
city('Kadan','cz','Ustecky',17559.0,13.27,50.38).
city('Klasterec nad Ohri','cz','Ustecky',15724.0,13.17,50.39).
city('Kostany','cz','Ustecky',2614.0,13.77,50.65).
city('Krasna Lipa','cz','Ustecky',3621.0,13.37,50.48).
city('Krupka','cz','Ustecky',13281.0,13.86,50.68).
city('Kryry','cz','Ustecky',2434.0,13.43,50.18).
city('Libochovice','cz','Ustecky',3659.0,14.03,50.4).
city('Litomerice','cz','Ustecky',24930.0,14.12,50.54).
city('Litvinov','cz','Ustecky',27424.0,13.6,50.61).
city('Lom','cz','Ustecky',3603.0,13.67,50.6).
city('Louny','cz','Ustecky',19720.0,13.79,50.35).
city('Lovosice','cz','Ustecky',9266.0,14.05,50.51).
city('Mezibori','cz','Ustecky',4945.0,13.58,50.62).
city('Mikulasovice','cz','Ustecky',2385.0,14.37,50.95).
city('Most','cz','Ustecky',68254.0,13.63,50.51).
city('Novosedlice','cz','Ustecky',2143.0,13.8,50.65).
city('Obrnice','cz','Ustecky',2610.0,13.7,50.52).
city('Osek','cz','Ustecky',5005.0,13.68,50.62).
city('Peruc','cz','Ustecky',2058.0,13.97,50.33).
city('Podborany','cz','Ustecky',6082.0,13.42,50.24).
city('Postoloprty','cz','Ustecky',4812.0,13.72,50.37).
city('Povrly','cz','Ustecky',2099.0,14.17,50.67).
city('Probostov','cz','Ustecky',2229.0,13.83,50.67).
city('Roudnice','cz','Ustecky',13114.0,14.25,50.42).
city('Rumburk','cz','Ustecky',11000.0,14.54,50.96).
city('Sluknov','cz','Ustecky',5630.0,14.45,51.0).
city('Steti','cz','Ustecky',9152.0,14.37,50.44).
city('Teplice','cz','Ustecky',50972.0,13.82,50.65).
city('Terezin','cz','Ustecky',2916.0,14.15,50.52).
city('Trmice','cz','Ustecky',2678.0,14.0,50.65).
city('Ustek','cz','Ustecky',2649.0,14.35,50.58).
city('Usti','cz','Ustecky',95556.0,14.02,50.67).
city('Varnsdorf','cz','Ustecky',16018.0,14.61,50.92).
city('Vejprty','cz','Ustecky',3320.0,13.03,50.5).
city('Velky Senov','cz','Ustecky',2004.0,14.38,50.98).
city('Zatec','cz','Ustecky',19961.0,13.54,50.33).
city('Batelov','cz','Vysocina',2383.0,15.4,49.32).
city('Brtnice','cz','Vysocina',3641.0,15.68,49.32).
city('Bystrice nad Pernstejnem','cz','Vysocina',9030.0,16.28,49.53).
city('Chotebor','cz','Vysocina',9829.0,15.68,49.73).
city('Dobronin','cz','Vysocina',1897.0,15.67,49.48).
city('Golcuv Jenikov','cz','Vysocina',2593.0,15.48,49.82).
city('Havlickuv Brod','cz','Vysocina',24373.0,15.58,49.61).
city('Humpolec','cz','Vysocina',10915.0,15.35,49.54).
city('Jaromerice nad Rokytnou','cz','Vysocina',4089.0,15.9,49.1).
city('Jemnice','cz','Vysocina',4289.0,15.57,49.03).
city('Jihlava','cz','Vysocina',50818.0,15.58,49.4).
city('Kamenice nad Lipou','cz','Vysocina',4202.0,15.08,49.3).
city('Ledec','cz','Vysocina',6101.0,15.28,49.7).
city('Luka nad Jihlavou','cz','Vysocina',2470.0,15.7,49.37).
city('Merin','cz','Vysocina',1901.0,15.88,49.38).
city('Moravske Budejovice','cz','Vysocina',7970.0,15.81,49.06).
city('Nove Mesto na Morave','cz','Vysocina',10459.0,16.07,49.56).
city('Okrisky','cz','Vysocina',2014.0,15.77,49.25).
city('Pacov','cz','Vysocina',5210.0,15.01,49.48).
city('Pelhrimov','cz','Vysocina',16590.0,15.22,49.44).
city('Pocatky','cz','Vysocina',2743.0,15.25,49.27).
city('Polna','cz','Vysocina',4849.0,15.72,49.48).
city('Pribyslav','cz','Vysocina',3965.0,15.73,49.58).
city('Svetla nad Sazavou','cz','Vysocina',7158.0,15.42,49.67).
city('Telc','cz','Vysocina',6028.0,15.45,49.18).
city('Trebic','cz','Vysocina',39038.0,15.87,49.22).
city('Trest','cz','Vysocina',5908.0,15.48,49.3).
city('Velka Bites','cz','Vysocina',4868.0,16.22,49.3).
city('Velke Mezirici','cz','Vysocina',11795.0,16.01,49.35).
city('Zdar','cz','Vysocina',24344.0,15.93,49.56).
city('Zdirec nad Doubravou','cz','Vysocina',2771.0,15.82,49.7).
city('Zirovnice','cz','Vysocina',3043.0,15.2,49.25).
city('Banov','cz','Zlinsky',2072.0,17.72,48.98).
city('Bojkovice','cz','Zlinsky',4747.0,17.82,49.03).
city('Borsice','cz','Zlinsky',2273.0,17.35,49.07).
city('Brumov-Bylnice','cz','Zlinsky',6064.0,18.03,49.1).
city('Buchlovice','cz','Zlinsky',2437.0,17.33,49.08).
city('Bystrice pod Hostynem','cz','Zlinsky',8748.0,17.67,49.4).
city('Chropyne','cz','Zlinsky',5232.0,17.37,49.35).
city('Dolni Nemci','cz','Zlinsky',3002.0,17.58,48.98).
city('Frystak','cz','Zlinsky',3457.0,17.7,49.3).
city('Halenkov','cz','Zlinsky',2349.0,18.15,49.32).
city('Hluk','cz','Zlinsky',4340.0,17.53,48.98).
city('Holesov','cz','Zlinsky',12455.0,17.58,49.34).
city('Horni Becva','cz','Zlinsky',2408.0,18.28,49.43).
city('Hostalkova','cz','Zlinsky',2023.0,17.88,49.35).
city('Hovezi','cz','Zlinsky',2302.0,18.07,49.3).
city('Hulin','cz','Zlinsky',7576.0,17.46,49.32).
city('Huslenky','cz','Zlinsky',2079.0,17.96,49.38).
city('Hutisko-Solanec','cz','Zlinsky',1891.0,18.22,49.43).
city('Jablunka','cz','Zlinsky',1965.0,17.97,49.38).
city('Karolinka','cz','Zlinsky',2881.0,18.23,49.35).
city('Kelc','cz','Zlinsky',2569.0,17.82,49.48).
city('Korycany','cz','Zlinsky',2827.0,17.18,49.12).
city('Kromeriz','cz','Zlinsky',29211.0,17.38,49.3).
city('Kunovice','cz','Zlinsky',5129.0,17.46,49.05).
city('Kvasice','cz','Zlinsky',2275.0,17.47,49.25).
city('Lesna','cz','Zlinsky',1951.0,17.93,49.52).
city('Luhacovice','cz','Zlinsky',5596.0,17.77,49.1).
city('Morkovice-Slizany','cz','Zlinsky',2799.0,17.22,49.25).
city('Napajedla','cz','Zlinsky',7573.0,17.53,49.17).
city('Nivnice','cz','Zlinsky',3221.0,17.63,48.98).
city('Novy Hrozenkov','cz','Zlinsky',2738.0,18.22,49.35).
city('Ostrozska Nova Ves','cz','Zlinsky',3333.0,17.43,49.02).
city('Otrokovice','cz','Zlinsky',19303.0,17.53,49.22).
city('Polesovice','cz','Zlinsky',1980.0,17.33,49.03).
city('Roznov','cz','Zlinsky',17964.0,18.13,49.47).
city('Slavicin','cz','Zlins',7127.0,17.88,49.08).
city('Slusovice','cz','Zlinsky',2972.0,17.8,49.25).
city('Stare Mesto','cz','Zlinsky',6661.0,17.45,49.09).
city('Stitna nad Vlari-Popov','cz','Zlinsky',2333.0,17.98,49.07).
city('Strani','cz','Zlinsky',3831.0,17.73,48.9).
city('Tlumacov','cz','Zlinsky',2393.0,17.5,49.25).
city('Uherske Hradiste','cz','Zlinsky',26954.0,17.44,49.08).
city('Uhersky Brod','cz','Zlinsky',17625.0,17.64,49.03).
city('Uhersky Ostroh','cz','Zlinsky',4499.0,17.38,48.98).
city('Valasska Bystrice','cz','Zlinsky',2172.0,18.1,49.43).
city('Valasske Klobouky','cz','Zlinsky',5168.0,18.0,49.15).
city('Valasske Mezirici','cz','Zlinsky',27562.0,17.97,49.48).
city('Velke Karlovice','cz','Zlinsky',2664.0,18.3,49.37).
city('Veseli nad Moravou','cz','Zlinsky',12245.0,17.38,48.96).
city('Vizovice','cz','Zlinsky',4481.0,17.85,49.22).
city('Vlcnov','cz','Zlinsky',3016.0,17.97,49.58).
city('Vsetin','cz','Zlinsky',29302.0,17.99,49.35).
city('Zasova','cz','Zlinsky',2738.0,18.05,49.48).
city('Zdounky','cz','Zlinsky',2018.0,17.32,49.23).
city('Zlin','cz','Zlinsky',81066.0,17.65,49.23).
city('Zubri','cz','Zlinsky',5341.0,18.8,49.48).
city('Bandundu','cd','Bandundu',118203.0,17.38,-3.31).
city('Bolobo','cd','Bandundu',27860.0,16.24,-2.16).
city('Bulungu','cd','Bandundu',48340.0,18.6,-4.55).
city('Inongo','cd','Bandundu',40110.0,18.28,-1.94).
city('Kasongo-Lunda','cd','Bandundu',20059.0,16.83,-6.48).
city('Kenge','cd','Bandundu',36960.0,16.9,-4.83).
city('Kikwit','cd','Bandundu',186995.0,18.81,-5.03).
city('Mangai','cd','Bandundu',37185.0,19.53,-4.04).
city('Mushie','cd','Bandundu',33060.0,16.92,-3.02).
city('Nioki','cd','Bandundu',40692.0,17.68,-2.72).
city('Boma','cd','Bas-Congo',344522.0,13.05,-5.85).
city('Kasangulu','cd','Bas-Congo',27960.0,15.18,-4.58).
city('Matadi','cd','Bas-Congo',180115.0,13.48,-5.82).
city('Mbanza-Ngungu','cd','Bas-Congo',86351.0,14.86,-5.25).
city('Tshela','cd','Bas-Congo',38843.0,12.93,-4.97).
city('Binga','cd','Equateur',60037.0,20.42,2.4).
city('Boende','cd','Equateur',32089.0,20.86,-0.22).
city('Bongandanga','cd','Equateur',4104.0,21.05,1.51).
city('Bosobolo','cd','Equateur',14552.0,19.88,4.19).
city('Bumba','cd','Equateur',95514.0,22.46,2.19).
city('Businga','cd','Equateur',28917.0,20.87,3.34).
city('Gbadolite','cd','Equateur',50489.0,21.02,4.29).
city('Gemena','cd','Equateur',117631.0,19.77,3.26).
city('Libenge','cd','Equateur',27051.0,18.62,3.66).
city('Lisala','cd','Equateur',70082.0,21.51,2.14).
city('Mbandaka','cd','Equateur',184189.0,18.26,0.04).
city('Aketi','cd','Haut-Congo',35158.0,23.78,2.74).
city('Basoko','cd','Haut-Congo',43706.0,23.59,1.24).
city('Bondo','cd','Haut-Congo',17858.0,23.67,3.81).
city('Bunia','cd','Haut-Congo',96757.0,30.24,1.56).
city('Buta','cd','Haut-Congo',45674.0,24.74,2.82).
city('Isiro','cd','Haut-Congo',127068.0,27.62,2.76).
city('Kisangani','cd','Haut-Congo',539164.0,25.19,0.53).
city('Wamba','cd','Haut-Congo',17371.0,27.99,2.14).
city('Watsa','cd','Haut-Congo',24515.0,29.53,3.04).
city('Yangambi','cd','Haut-Congo',35529.0,24.43,0.77).
city('Demba','cd','Kasai-Occidental',22261.0,22.26,-5.51).
city('Dibaya','cd','Kasai-Occidental',4571.0,22.87,-6.51).
city('Ilebo','cd','Kasai-Occidental',107086.0,20.61,-4.32).
city('Kananga','cd','Kasai-Occidental',463556.0,22.4,-5.89).
city('Luebo','cd','Kasai-Occidental',35181.0,21.41,-5.35).
city('Mweka','cd','Kasai-Occidental',50672.0,21.57,-4.84).
city('Tshikapa','cd','Kasai-Occidental',267508.0,20.77,-6.41).
city('Gandajika','cd','Kasai-Oriental',154414.0,23.96,-6.74).
city('Kabinda','cd','Kasai-Oriental',58999.0,24.48,-6.13).
city('Lodja','cd','Kasai-Oriental',68239.0,23.42,-3.49).
city('Lubao','cd','Kasai-Oriental',43065.0,25.75,-5.39).
city('Lusambo','cd','Kasai-Oriental',41413.0,23.43,-4.97).
city('Mbuji-Mayi','cd','Kasai-Oriental',874974.0,23.59,-6.13).
city('Mwene-Ditu','cd','Kasai-Oriental',189215.0,23.44,-7.0).
city('Bukama','cd','Katanga',38801.0,25.84,-9.21).
city('Kabalo','cd','Katanga',29857.0,26.91,-6.05).
city('Kalemie','cd','Katanga',147065.0,29.17,-5.92).
city('Kambove','cd','Katanga',36731.0,26.6,-10.87).
city('Kamina','cd','Katanga',73616.0,25.01,-8.73).
city('Kaniama','cd','Katanga',29435.0,24.17,-7.57).
city('Kipushi','cd','Katanga',62382.0,27.25,-11.76).
city('Kolwezi','cd','Katanga',910167.0,25.66,-10.7).
city('Kongolo','cd','Katanga',31969.0,26.98,-5.38).
city('Likasi','cd','Katanga',422726.0,26.73,-10.98).
city('Lubumbashi','cd','Katanga',1374808.0,27.48,-11.66).
city('Manono','cd','Katanga',37583.0,27.45,-7.3).
city('Moba','cd','Katanga',29854.0,29.72,-7.06).
city('Kinshasa','cd','Kinshasa',7787832.0,15.32,-4.31).
city('Kalima','cd','Maniema',55012.0,26.43,-2.51).
city('Kasongo','cd','Maniema',55115.0,26.66,-4.45).
city('Kindu','cd','Maniema',135690.0,25.92,-2.95).
city('Beni','cd','Nord-Kivu',89643.0,29.45,0.49).
city('Butembo','cd','Nord-Kivu',154649.0,29.28,0.13).
city('Goma','cd','Nord-Kivu',144151.0,29.22,-1.69).
city('Bukavu','cd','Sud-Kivu',225431.0,28.84,-2.51).
city('Kabare','cd','Sud-Kivu',37031.0,28.81,-2.46).
city('Kampene','cd','Sud-Kivu',37031.0,26.67,-3.6).
city('Uvira','cd','Sud-Kivu',170422.0,29.14,-3.37).
city('Allingabro','dk','Arhus',1842.0,10.33,56.47).
city('Arhus','dk','Arhus',226716.0,10.21,56.16).
city('Assentoft','dk','Arhus',2432.0,10.15,56.43).
city('Auning','dk','Arhus',2509.0,10.38,56.43).
city('Beder','dk','Arhus',4214.0,10.22,56.07).
city('Ebeltoft','dk','Arhus',5888.0,10.68,56.2).
city('Framlev','dk','Arhus',3067.0,10.02,56.15).
city('Galten','dk','Arhus',4895.0,9.91,56.15).
city('Grenaa','dk','Arhus',14317.0,10.88,56.42).
city('Hadsten','dk','Arhus',7020.0,10.05,56.33).
city('Hammel','dk','Arhus',6138.0,9.87,56.25).
city('Hinnerup','dk','Arhus',7055.0,10.07,56.27).
city('Hjortshoj','dk','Arhus',2515.0,10.27,56.25).
city('Horning','dk','Arhus',6085.0,10.04,56.08).
city('Hornslet','dk','Arhus',4906.0,10.33,56.32).
city('Kolt','dk','Arhus',5061.0,10.07,56.1).
city('Langa','dk','Arhus',2710.0,9.9,56.38).
city('Logten','dk','Arhus',5048.0,10.32,56.28).
city('Lystrup','dk','Ar',9107.0,10.24,56.24).
city('Malling','dk','Arhus',3339.0,10.17,56.03).
city('Mariager','dk','Arhus',2433.0,10.0,56.65).
city('Marslet','dk','Arhus',2698.0,10.17,56.07).
city('Odder','dk','Arhus',11009.0,10.17,55.97).
city('Randers','dk','Arhus',55780.0,10.04,56.47).
city('Ronde','dk','Arhus',2213.0,10.48,56.3).
city('Ry','dk','Arhus',4909.0,9.77,56.08).
city('Ryomgard','dk','Arhus',1952.0,10.5,56.38).
city('Sabro','dk','Arhus',1977.0,10.05,56.22).
city('Silkeborg','dk','Arhus',38760.0,9.55,56.16).
city('Skanderborg','dk','Arhus',13543.0,9.91,56.04).
city('Skovby','dk','Arhus',2489.0,9.95,56.15).
city('Soften','dk','Arhus',2030.0,10.1,56.23).
city('Solbjerg','dk','Arhus',2964.0,10.08,56.05).
city('Spentrup','dk','Arhus',2155.0,10.03,56.55).
city('Stavtrup','dk','Arhus',3519.0,10.12,56.13).
city('Stilling','dk','Arhus',3655.0,10.0,56.07).
city('Svejbaek','dk','Arhus',3743.0,9.63,56.13).
city('Tranbjerg','dk','Arhus',7307.0,10.15,56.1).
city('Trige','dk','Arhus',2475.0,10.17,56.25).
city('Virklund','dk','Arhus',3113.0,9.57,56.12).
city('Aakirkeby','dk','Bornholm',2195.0,14.93,55.07).
city('Allinge-Sandvig','dk','Bornholm',1893.0,14.8,55.28).
city('Nexo','dk','Bornholm',3841.0,15.15,55.07).
city('Ronne','dk','Bornholm',13889.0,14.7,55.1).
city('Copenhagen','dk','Frederiksberg Kommune',1089958.0,12.57,55.68).
city('Birkerod','dk','Frederiksborg',18901.0,12.43,55.83).
city('Blovstrod','dk','Frederiksborg',2137.0,12.4,55.87).
city('Espergaerde','dk','Frederiksborg',11358.0,12.57,56.0).
city('Farum','dk','Frederiksborg',11552.0,12.37,55.8).
city('Fredensborg','dk','Frederiksborg',8249.0,12.4,55.97).
city('Frederikssund','dk','Frederiksborg',14564.0,12.07,55.83).
city('Frederiksvaerk','dk','Frederiksborg',12176.0,12.03,55.97).
city('Ganlose','dk','Frederiksborg',2843.0,12.27,55.78).
city('Gilleleje','dk','Frederiksborg',5799.0,12.32,56.12).
city('Graested','dk','Frederiksborg',3310.0,12.28,56.07).
city('Hellebaek','dk','Frederiksborg',5243.0,12.57,56.07).
city('Helsinge','dk','Frederiksborg',7354.0,12.2,56.02).
city('Helsingor','dk','Frederiksborg',35048.0,12.6,56.04).
city('Hillerod','dk','Frederiksborg',28313.0,12.3,55.93).
city('Hornbaek','dk','Frederiksborg',3223.0,12.47,56.08).
city('Horsholm','dk','Frederiksborg',36670.0,12.5,55.88).
city('Humlebaek','dk','Frederiksborg',8965.0,12.55,55.97).
city('Hundested','dk','Frederiksborg',8615.0,11.87,55.97).
city('Jaegerspris','dk','Frederiksborg',3805.0,11.98,55.85).
city('Lillerod','dk','Frederiksborg',15359.0,12.37,55.87).
city('Liseleje','dk','Fre',2906.0,11.98,56.02).
city('Lynge','dk','Frederiksborg',4284.0,12.28,55.85).
city('Niva','dk','Frederiksborg',8035.0,12.52,55.93).
city('Nodebo','dk','Frederiksborg',1875.0,12.35,55.98).
city('Olstykke','dk','Frederiksborg',5348.0,12.18,55.78).
city('Skibby','dk','Frederiksborg',2661.0,11.97,55.75).
city('Slangerup','dk','Frederiksborg',6829.0,12.18,55.85).
city('Stavnsholt','dk','Frederiksborg',5658.0,12.42,55.82).
city('Stenlose','dk','Frederiksborg',13302.0,12.2,55.77).
city('Vekso','dk','Frederiksborg',1921.0,12.25,55.75).
city('Aarup','dk','Fyn',2592.0,10.07,55.38).
city('Arslev','dk','Fyn',3228.0,10.48,55.3).
city('Assens','dk','Fyn',5913.0,9.92,55.27).
city('Bellinge','dk','Fyn',4129.0,10.33,55.33).
city('Bogense','dk','Fyn',3410.0,10.1,55.57).
city('Bullerup','dk','Fyn',2982.0,10.48,55.43).
city('Ejby','dk','Fyn',1996.0,9.94,55.43).
city('Faaborg','dk','Fyn',7239.0,10.25,55.1).
city('Glamsbjerg','dk','Fyn',3099.0,10.12,55.27).
city('Haarby','dk','Fyn',2400.0,10.12,55.22).
city('Hojby','dk','Fyn',4406.0,10.43,55.34).
city('Kerteminde','dk','Fyn',5748.0,10.67,55.45).
city('Langeskov','dk','Fyn',3713.0,10.6,55.37).
city('Marstal','dk','Fyn',2265.0,10.52,54.85).
city('Middelfart','dk','Fyn',13596.0,9.75,55.5).
city('Munkebo','dk','Fyn',5225.0,10.57,55.45).
city('Neder Holluf','dk','Fyn',5612.0,10.45,55.35).
city('Norre Aaby','dk','Fyn',2678.0,9.9,55.45).
city('Nyborg','dk','Fyn',15826.0,10.8,55.32).
city('Odense','dk','Fyn',145931.0,10.38,55.4).
city('Otterup','dk','Fyn',4522.0,10.4,55.52).
city('Ringe','dk','Fyn',4849.0,10.47,55.24).
city('Rudkobing','dk','Fyn',4666.0,10.72,54.93).
city('Seden','dk','Fyn',3350.0,10.45,55.42).
city('Sonderso','dk','Fyn',2850.0,10.27,55.48).
city('Stige','dk','Fyn',2182.0,10.42,55.43).
city('Strib','dk','Fyn',4339.0,9.78,55.53).
city('Svendborg','dk','Fyn',27553.0,10.6,55.07).
city('Thuro','dk','Fyn',3350.0,10.67,55.05).
city('Tommerup','dk','Fyn',2072.0,10.22,55.32).
city('Ullerslev','dk','Fyn',2962.0,10.67,55.37).
city('Vindeby','dk','Fyn',2144.0,10.61,55.04).
city('Vissenbjerg','dk','Fyn',3055.0,10.13,55.38).
city('Dragor','dk','Kobenhavn',11045.0,12.68,55.6).
city('Flong','dk','Kobenhavn',11108.0,12.18,55.67).
city('Ishoj','dk','Kobenhavn',19453.0,12.32,55.62).
city('Malov','dk','Kobenhavn',8513.0,12.33,55.75).
city('Smorumnedre','dk','Kobenhavn',8968.0,12.3,55.73).
city('Taastrup','dk','Kobenhavn',30977.0,12.32,55.65).
city('Trorod','dk','Kobenhavn',8576.0,12.55,55.83).
city('Vaerlose','dk','Kobenhavn',12842.0,12.35,55.78).
city('Aabybro','dk','Nordjylland',4849.0,9.75,57.15).
city('Aalborg','dk','Nordjylland',122219.0,9.93,57.03).
city('Aars','dk','Nordjylland',7247.0,9.53,56.8).
city('Arden','dk','Nordjylland',2516.0,9.88,56.77).
city('Bronderslev','dk','Nordjylland',11671.0,9.97,57.27).
city('Brovst','dk','Nordjylland',2710.0,9.53,57.1).
city('Dronninglund','dk','Nordjylland',3084.0,10.3,57.15).
city('Farso','dk','Nordjylland',3271.0,9.35,56.78).
city('Fjerritslev','dk','Nordjylland',3441.0,9.27,57.08).
city('Frederikshavn','dk','Nordjylland',24103.0,10.53,57.45).
city('Frejlev','dk','Nordjylland',2286.0,9.83,57.0).
city('Gistrup','dk','Nordjylland',3622.0,10.0,57.0).
city('Hadsund','dk','Nordjylland',5066.0,10.12,56.72).
city('Hals','dk','Nordjylland',2388.0,10.32,57.0).
city('Hirtshals','dk','Nordjylland',6653.0,9.96,57.59).
city('Hjallerup','dk','Nordjylland',3320.0,10.15,57.17).
city('Hjorring','dk','Nordjylland',24634.0,9.98,57.46).
city('Hobro','dk','Nordjylland',11064.0,9.8,56.63).
city('Kas','dk','Nordjylland',1990.0,9.67,57.2).
city('Klarup','dk','Nordjylland',3352.0,10.05,57.02).
city('Logstor','dk','Nordjylland',4469.0,9.25,56.97).
city('Nibe','dk','Nordjylland',4376.0,9.63,56.98).
city('Pandrup','dk','Nordjylland',2942.0,9.68,57.23).
city('Saeby','dk','Nordjylland',8435.0,10.53,57.33).
city('Sindal','dk','Nordjylland',2898.0,10.22,57.47).
city('Skagen','dk','Nordjylland',9747.0,10.6,57.73).
city('Skorping','dk','Nordjylland',2722.0,9.88,56.83).
city('Storvorde','dk','Nordjylland',2796.0,10.1,57.0).
city('Stovring','dk','Nordjylland',6239.0,9.85,56.88).
city('Strandby','dk','Nordjylland',2518.0,10.5,57.5).
city('Svenstrup','dk','Nordjylland',4550.0,9.87,56.98).
city('Tars','dk','Nordjylland',1856.0,10.12,57.38).
city('Vadum','dk','Nordjylland',1978.0,9.87,57.12).
city('Vestbjerg','dk','Nordjylland',2251.0,9.98,57.13).
city('Vester Hassing','dk','Nordjylland',2298.0,10.13,57.07).
city('Vodskov','dk','Nordjylland',4406.0,10.03,57.1).
city('Vra','dk','Nordjylland',2273.0,9.95,57.35).
city('Billund','dk','Ribe',6160.0,9.12,55.73).
city('Bramming','dk','Ribe',6726.0,8.7,55.47).
city('Brorup','dk','Ribe',4233.0,9.02,55.48).
city('Esbjerg','dk','Ribe',72206.0,8.45,55.47).
city('Grindsted','dk','Ribe',9414.0,8.93,55.75).
city('Holsted','dk','Ribe',3096.0,8.92,55.5).
city('Nordby','dk','Ribe',2512.0,8.42,55.45).
city('Oksbol','dk','Ribe',2845.0,8.28,55.63).
city('Olgod','dk','Ribe',3891.0,8.62,55.82).
city('Ribe','dk','Ribe',7983.0,8.77,55.34).
city('Tjaereborg','dk','Ribe',2146.0,8.58,55.47).
city('Varde','dk','Ribe',12735.0,8.48,55.63).
city('Vejen','dk','Ribe',8525.0,9.15,55.48).
city('Aulum','dk','Ringkobing',2875.0,8.8,56.27).
city('Bording','dk','Ringkobing',2104.0,9.26,56.16).
city('Brande','dk','Ringkobing',6357.0,9.12,55.95).
city('Gjellerup Kirkeby','dk','Ringkobing',3627.0,9.05,56.15).
city('Hammerum','dk','Ringkobing',3025.0,9.07,56.13).
city('Harboore','dk','Ringkobing',1745.0,8.2,56.62).
city('Herning','dk','Ringkobing',30329.0,8.97,56.13).
city('Holstebro','dk','Ringkobing',32072.0,8.62,56.36).
city('Hvide Sande','dk','Ringkobing',3291.0,8.13,55.98).
city('Ikast','dk','Ringkobing',14692.0,9.16,56.14).
city('Kibaek','dk','Ringkobing',2656.0,8.85,56.03).
city('Lemvig','dk','Ringkobing',7330.0,8.3,5.53).
city('Lind','dk','Ringkobing',3777.0,8.98,56.1).
city('Ringkobing','dk','Ringkobing',9315.0,8.25,56.09).
city('Skjern','dk','Ringkobing',7145.0,8.5,55.95).
city('Snejbjerg','dk','Ringkobing',3513.0,8.92,56.13).
city('Struer','dk','Ringkobing',11317.0,8.62,56.48).
city('Sunds','dk','Ringkobing',3525.0,9.02,56.2).
city('Tarm','dk','Ringkobing',4080.0,8.53,55.92).
city('Thyboron','dk','Ringkobing',2587.0,8.22,56.7).
city('Ulfborg','dk','Ringkobing',1994.0,8.33,56.27).
city('Videbaek','dk','Ringkobing',4052.0,8.63,56.08).
city('Vildbjerg','dk','Ringkobing',3773.0,8.77,56.2).
city('Vinderup','dk','Ringkobing',2991.0,8.78,56.48).
city('Bjaeverskov','dk','Roskilde',2619.0,12.03,55.45).
city('Borup','dk','Roskilde',3120.0,11.98,55.5).
city('Ejby','dk','Roskilde',2340.0,11.96,55.59).
city('Greve Strand','dk','Roskilde',41560.0,12.3,55.58).
city('Gundsomagle','dk','Roskilde',2149.0,12.17,55.73).
city('Harlev','dk','Roskilde',2423.0,12.25,55.35).
city('Havdrup','dk','Roskilde',3828.0,12.13,55.53).
city('Hvalso','dk','Roskilde',3930.0,11.87,55.6).
city('Jyllinge','dk','Roski',9981.0,12.12,55.75).
city('Koge','dk','Roskilde',33885.0,12.18,55.45).
city('Lejre','dk','Roskilde',2036.0,11.98,55.6).
city('Osted','dk','Roskilde',2122.0,11.97,55.57).
city('Roskilde','dk','Roskilde',44285.0,12.09,55.65).
city('Solrod','dk','Roskilde',14634.0,12.18,55.53).
city('Stroby Egede','dk','Roskilde',2700.0,12.25,55.42).
city('Svogerslev','dk','Roskilde',4355.0,12.02,55.63).
city('Tune','dk','Roskilde',5168.0,12.18,55.6).
city('Viby','dk','Roskilde',4505.0,12.03,55.55).
city('Vindinge','dk','Roskilde',2045.0,12.15,55.63).
city('Aabenraa','dk','Sonderjylland',16344.0,9.42,55.05).
city('Augustenborg','dk','Sonderjylland',3132.0,9.88,54.95).
city('Broager','dk','Sonderjylland',3376.0,9.68,54.88).
city('Christiansfeld','dk','Sonderjylland',2709.0,9.48,55.35).
city('Dybbol','dk','Sonderjylland',2303.0,9.75,54.92).
city('Gram','dk','Sonderjylland',2548.0,9.07,55.28).
city('Grasten','dk','Sonderjylland',4022.0,9.6,54.92).
city('Guderup','dk','Sonderjylland',2424.0,9.88,54.98).
city('Haderslev','dk','Sonderjylland',20825.0,9.48,55.26).
city('Horuphav','dk','Sonderjylland',2514.0,9.9,54.92).
city('Krusa','dk','Sonderjylland',1694.0,9.42,54.85).
city('Logumkloster','dk','Sonderjylland',3056.0,8.95,55.05).
city('Lojt Kirkeby','dk','Sonderjylland',1975.0,9.47,55.08).
city('Nordborg','dk','Sonderjylland',7406.0,9.75,55.05).
city('Padborg','dk','Sonderjylland',4684.0,9.37,54.82).
city('Rodding','dk','Sonderjylland',2769.0,9.07,55.37).
city('Rodekro','dk','Sonderjylland',5452.0,9.35,55.07).
city('Skaerbaek','dk','Sonderjyllan',3174.0,8.77,55.15).
city('Sonderborg','dk','Sonderjylland',27033.0,9.8,54.92).
city('Starup','dk','Sonderjylland',2091.0,9.53,55.23).
city('Tinglev','dk','Sonderjylland',2829.0,9.25,54.93).
city('Toftlund','dk','Sonderjylland',3438.0,9.07,55.18).
city('Tonder','dk','Sonderjylland',7841.0,8.9,54.93).
city('Vojens','dk','Sonderjylland',8019.0,9.32,55.25).
city('Fakse','dk','Storstrom',3747.0,12.13,55.25).
city('Fakse Ladeplads','dk','Storstrom',2837.0,12.18,55.22).
city('Fensmark','dk','Storstrom',4203.0,11.82,55.28).
city('Holeby','dk','Storstrom',1844.0,11.47,54.72).
city('Maribo','dk','Storstrom',5349.0,11.52,54.77).
city('Naestved','dk','Storstrom',40660.0,11.76,55.23).
city('Nakskov','dk','Storstrom',14081.0,11.15,54.83).
city('Neder Vindinge','dk','Storstrom',1900.0,11.88,55.03).
city('Norre Alslev','dk','Storstrom',2128.0,11.9,54.9).
city('Nykobing','dk','Storstrom',16807.0,11.87,54.77).
city('Nyrad','dk','Storstrom',2224.0,11.98,55.0).
city('Orslev','dk','Storstrom',1801.0,11.98,55.03).
city('Praesto','dk','Storstrom',3695.0,12.05,55.12).
city('Rodby','dk','Storstrom',2379.0,11.4,54.7).
city('Rodbyhavn','dk','Storstrom',2145.0,11.35,54.65).
city('Ronnede','dk','Storstrom',2395.0,12.0,55.25).
city('Sakskobing','dk','Storstrom',4928.0,11.65,54.8).
city('Stege','dk','Storstrom',3881.0,12.3,54.98).
city('Store Heddinge','dk','Storstrom',3679.0,12.42,55.32).
city('Stubbekobing','dk','Storstrom',2301.0,12.05,54.88).
city('Sundby','dk','Storstrom',2922.0,11.78,54.85).
city('Vordingborg','dk','Storstrom',8960.0,11.91,55.01).
city('Borkop','dk','Vejle',3561.0,9.65,55.65).
city('Braedstrup','dk','Vejle',3130.0,9.62,55.97).
city('Brejning','dk','Vejle',2220.0,9.68,55.67).
city('Egtved','dk','Vejle',2151.0,9.3,55.62).
city('Fredericia','dk','Vejle',36946.0,9.76,55.58).
city('Give','dk','Vejle',4240.0,9.25,55.85).
city('Hedensted','dk','Vejle',10048.0,9.7,55.77).
city('Horsens','dk','Vejle',50074.0,9.84,55.86).
city('Jelling','dk','Vejle',3059.0,9.43,55.75).
city('Juels','dk','Vejle',3667.0,10.02,55.71).
city('Kolding','dk','Vejle',55363.0,9.47,55.49).
city('Lunderskov','dk','Vejle',2687.0,9.3,55.48).
city('Snoghoj','dk','Vejle',2371.0,9.72,55.52).
city('Sonder Bjert','dk','Vejle',1815.0,9.57,55.45).
city('Taulov','dk','Vejle',2898.0,9.62,55.55).
city('Torring','dk','Vejle',2370.0,9.49,55.86).
city('Vamdrup','dk','Vejle',4685.0,9.28,55.42).
city('Vejle','dk','Vejle',51177.0,9.52,55.71).
city('Asnaes','dk','Vestsjaelland',2441.0,11.52,55.82).
city('Dianalund','dk','Vestsjaelland',3605.0,11.5,55.53).
city('Forlev','dk','Vestsjaelland',2058.0,11.28,55.38).
city('Frederiksberg','dk','Vestsjaelland',3142.0,11.57,55.42).
city('Fuglebjerg','dk','Vestsjaelland',1985.0,11.57,55.3).
city('Gorlev','dk','Vestsjaelland',2269.0,11.23,55.53).
city('Haslev','dk','Vestsjaelland',10588.0,11.97,55.33).
city('Holbaek','dk','Vestsjaelland',24544.0,11.71,55.72).
city('Hong','dk','Vestsjaelland',3789.0,11.3,55.52).
city('Horve','dk','Vestsjaelland',2382.0,11.47,55.75).
city('Jyderup','dk','Vestsjaelland',3984.0,11.43,55.67).
city('Kalundborg','dk','Vestsjaelland',15939.0,11.1,55.68).
city('Korsor','dk','Vestsjaelland',15029.0,11.13,55.34).
city('Nykobing','dk','Vestsjaelland',5596.0,11.68,55.92).
city('Ringsted','dk','Vestsjaelland',18794.0,11.79,55.45).
city('Skaelskor','dk','Vestsjaelland',6455.0,11.32,55.25).
city('Slagelse','dk','Vestsjaelland',31896.0,11.34,55.41).
city('Soro','dk','Vestsjaelland',7167.0,11.57,55.43).
city('Stenlille','dk','Vestsjaelland',1905.0,11.55,55.54).
city('Sveboll','dk','Vestsjaelland',2186.0,11.3,55.65).
city('Svinninge','dk','Vestsjaelland',2376.0,11.44,55.72).
city('Tollose','dk','Vestsjaelland',3457.0,11.75,55.62).
city('Vipperod','dk','Vestsjaelland',2345.0,11.75,55.67).
city('Aalestrup','dk','Viborg',2787.0,9.5,56.7).
city('Bjerringbro','dk','Viborg',7390.0,9.67,56.38).
city('Hanstholm','dk','Viborg',2418.0,8.62,57.12).
city('Hojslev','dk','Viborg',1857.0,9.15,56.58).
city('Hurup','dk','Viborg',2770.0,8.42,56.75).
city('Karup','dk','Viborg',2176.0,9.17,56.3).
city('Kjellerup','dk','Viborg',4514.0,9.43,56.28).
city('Nykobing','dk','Viborg',9326.0,8.87,56.8).
city('Skive','dk','Viborg',20815.0,9.02,56.57).
city('Stoholm','dk','Viborg',2202.0,9.17,56.48).
city('Thisted','dk','Viborg',13020.0,8.69,56.96).
city('Ulstrup','dk','Viborg',1963.0,9.8,56.4).
city('Viborg','dk','Viborg',33844.0,9.41,56.46).
city('Ali Sabih','dj','Ali Sabih',40074.0,42.71,11.16).
city('Awbuk','dj','Awbuk',17776.0,43.29,11.97).
city('Dihzil','dj','Dihzil',12043.0,42.37,11.11).
city('Jibuti','dj','Jibuti',623891.0,43.15,11.56).
city('Tajurah','dj','Tajurah',22193.0,42.89,11.79).
city('Atkinson','dm','Saint Andrew',2506.0,-61.28,15.51).
city('Marigot','dm','Saint Andrew',2907.0,-61.29,15.53).
city('Wesley','dm','Saint Andrew',1997.0,-61.32,15.57).
city('Castle Bruce','dm','Saint David',1997.0,-61.27,15.43).
city('Roseau','dm','Saint George',16571.0,-61.39,15.3).
city('Portsmouth','dm','Saint John',3608.0,-61.46,15.57).
city('Barroui','dm','Saint Joseph',1498.0,-61.45,15.43).
city('Pointe Michel','dm','Saint Luke',1202.0,-61.38,15.26).
city('Berekua','dm','Saint Patrick',3195.0,-61.32,15.24).
city('La Plaine','dm','Saint Patrick',2504.0,-61.26,15.32).
city('Mahaut','dm','Saint Paul',2405.0,-61.4,15.35).
city('Pont Casse','dm','Saint Paul',702.0,-61.36,15.37).
city('Coulihaut','dm','Saint Peter',1604.0,-61.46,15.48).
city('Azua','do','Azua',59141.0,-70.74,18.46).
city('Nuevo Sabana Yegua','do','Azua',10624.0,-71.02,18.72).
city('Neiba','do','Baoruco',18675.0,-71.42,18.49).
city('Tamayo','do','Baoruco',6431.0,-71.2,18.4).
city('Barahona','do','Barahona',77161.0,-71.1,18.21).
city('Cabral','do','Barahona',12303.0,-71.22,18.25).
city('El Penon','do','Barahona',4088.0,-71.19,18.3).
city('Dajabon','do','Dajabon',16402.0,-71.71,19.55).
city('Santo Domingo','do','Distrito Nacional',2202016.0,-69.91,18.48).
city('Las Guaranas','do','Duarte',9588.0,-70.22,19.2).
city('Pimentel','do','Duarte',9550.0,-70.11,19.18).
city('San Francisco de Macoris','do','Duarte',124772.0,-70.25,19.3).
city('El Seibo','do','El Seibo',23554.0,-69.04,18.77).
city('Comendador','do','Elias Pina',12072.0,-71.7,18.87).
city('Moca','do','Espaillat',61838.0,-70.53,19.4).
city('Hato Mayor','do','Hato Mayor',36002.0,-69.26,18.77).
city('Sabana de la Mar','do','Hato Mayor',13976.0,-69.39,19.07).
city('Duverge','do','Independencia',13405.0,-71.53,18.38).
city('Jimani','do','Independencia',6567.0,-71.85,18.49).
city('Higueey','do','La Altagracia',123803.0,-68.71,18.62).
city('La Romana','do','La Romana',208439.0,-68.97,18.43).
city('Constanza','do','La Vega',29485.0,-70.75,18.91).
city('Jarabacoa','do','La Vega',29991.0,-70.64,19.12).
city('La Vega','do','La Vega',102431.0,-70.53,19.22).
city('Nagua','do','Maria Trinidad Sanchez',33863.0,-69.85,19.38).
city('Bonao','do','Monsenor Nouel',73273.0,-70.41,18.95).
city('Maimon','do','Monsenor Nouel',15297.0,-70.79,19.8).
city('Monte Cristi','do','Monte Cristi',17001.0,-71.65,19.85).
city('Villa Vazquez','do','Monte Cristi',11645.0,-71.45,19.74).
city('Bayaguana','do','Monte Plata',21059.0,-69.64,18.76).
city('Monte Plata','do','Monte Pla',15533.0,-69.79,18.81).
city('Sabana Grande de Boya','do','Monte Plata',16835.0,-69.8,18.95).
city('Pedernales','do','Pedernales',11071.0,-71.74,18.04).
city('Bani','do','Peravia',66712.0,-70.33,18.29).
city('San Jose de Ocoa','do','Peravia',21149.0,-70.5,18.55).
city('Puerto Plata','do','Puerto Plata',119908.0,-70.7,19.8).
city('Sosua','do','Puerto Plata',9483.0,-70.52,19.75).
city('Salcedo','do','Salcedo',11676.0,-70.39,19.42).
city('Samana','do','Samana',11433.0,-69.33,19.21).
city('Sanchez','do','Samana',11368.0,-69.62,19.23).
city('Bajos de Haina','do','San Cristobal',66810.0,-70.03,18.42).
city('San Cristobal','do','San Cristobal',154045.0,-70.11,18.42).
city('Villa Altagracia','do','San Cristobal',40029.0,-70.17,18.67).
city('Las Matas de Farfan','do','San Juan',21803.0,-71.52,18.87).
city('San Juan de la Maguana','do','San Juan',72952.0,-71.23,18.81).
city('Consuelo','do','San Pedro de Macoris',27601.0,-69.3,18.56).
city('Quisqueya','do','San Pedro de Macoris',17697.0,-69.41,18.56).
city('San Pedro de Macoris','do','San Pedro de Macoris',217901.0,-69.31,18.46).
city('Cotui','do','Sanchez Ramirez',41643.0,-70.15,19.06).
city('Fantino','do','Sanchez Ramirez',10025.0,-70.3,19.12).
city('La Mata','do','Sanchez Ramirez',10295.0,-70.65,19.15).
city('San Ignacio de Sabaneta','do','Santiago Rodriguez',16381.0,-71.34,19.47).
city('Santiago','do','Santiago',555911.0,-70.69,19.48).
city('Tamboril','do','Santiago',23305.0,-70.6,19.48).
city('Villa Bisono','do','Santiago',33141.0,-70.87,19.56).
city('Esperanza','do','Valverde',42173.0,-70.99,19.58).
city('Mao','do','Valverde',48297.0,-71.08,19.56).
city('Aileu','tp','Aileu',1779.0,125.57,-8.72).
city('Ainaro','tp','Ainaro',3056.0,125.51,-9.0).
city('Baucau','tp','Baucau',14841.0,126.46,-8.46).
city('Auba','tp','Bobonaro',6113.0,125.33,-9.04).
city('Lolotoi','tp','Bobonaro',3455.0,125.26,-9.16).
city('Maliana','tp','Bobonaro',12071.0,125.22,-9.0).
city('Suai','tp','Cova Lima',6428.0,125.25,-9.32).
city('Dare','tp','Dili',18748.0,125.58,-8.59).
city('Dili','tp','Dili',159724.0,125.58,-8.57).
city('Metinaro','tp','Dili',4227.0,125.74,-8.54).
city('Ermera','tp','Ermera',12933.0,125.4,-8.76).
city('Lautem','tp','Lautem',3130.0,126.9,-8.38).
city('Los Palos','tp','Lautem',17042.0,127.02,-8.47).
city('Bazartete','tp','Liquica',3323.0,125.4,-8.61).
city('Liquica','tp','Liquica',4746.0,125.32,-8.6).
city('Manatuto','tp','Manatuto',1904.0,126.01,-8.52).
city('Same','tp','Manufahi',2210.0,125.65,-9.0).
city('Oecussi','tp','Oecussi',4621.0,124.36,-9.22).
city('Viqueque','tp','Viqueque',5453.0,126.36,-8.87).
city('Cuenca','ec','Azuay',276964.0,-79.01,-2.9).
city('Gualaceo','ec','Azuay',17122.0,-78.78,-2.9).
city('Guaranda','ec','Bolivar',22199.0,-79.01,-1.61).
city('San Miguel','ec','Bolivar',12575.0,-79.03,-1.7).
city('Azogues','ec','Canar',34877.0,-78.84,-2.74).
city('Canar','ec','Canar',9900.0,-78.94,-2.56).
city('La Troncal','ec','Canar',36353.0,-79.33,-2.4).
city('El Angel','ec','Carchi',3983.0,-77.94,0.62).
city('San Gabriel','ec','Carchi',15112.0,-77.84,0.61).
city('Tulcan','ec','Carchi',47053.0,-77.74,-0.83).
city('Alausi','ec','Chimborazo',14294.0,-78.85,-2.19).
city('Guano','ec','Chimborazo',12659.0,-78.64,-1.58).
city('Riobamba','ec','Chimborazo',124478.0,-78.65,-1.67).
city('La Mana','ec','Cotopaxi',16450.0,-79.22,-0.93).
city('Latacunga','ec','Cotopaxi',51717.0,-78.61,-0.93).
city('Pujili','ec','Cotopaxi',16168.0,-78.69,-0.95).
city('San Miguel','ec','Cotopaxi',10838.0,-78.59,-1.05).
city('Saquisili','ec','Cotopaxi',3778.0,-78.67,-0.83).
city('Arenillas','ec','El Oro',15852.0,-80.07,-3.78).
city('Huaquillas','ec','El Oro',39757.0,-80.24,-3.48).
city('Machala','ec','El Oro',198123.0,-79.96,-3.26).
city('Pasaje','ec','El Oro',44860.0,-79.8,-3.32).
city('Pinas','ec','El Oro',16981.0,-79.65,-3.67).
city('Portovelo','ec','El Oro',9708.0,-79.62,-3.72).
city('Santa Rosa','ec','El Oro',41816.0,-79.96,-3.45).
city('Zaruma','ec','El Oro',12505.0,-79.64,-3.7).
city('Esmeraldas','ec','Esmeraldas',95630.0,-79.67,0.95).
city('Muisne','ec','Esmeraldas',13393.0,-80.02,0.61).
city('Rosa Zarate','ec','Esmeraldas',42121.0,-79.48,0.33).
city('San Lorenzo','ec','Esmeraldas',20209.0,-78.86,1.27).
city('Valdez','ec','Esmeraldas',11441.0,-79.0,1.25).
city('Puerto Ayora','ec','Galapagos',8996.0,-90.33,-0.76).
city('Puerto Baquerizo Moreno','ec','Galapagos',4214.0,-89.61,-0.9).
city('San Cristobal','ec','Galapagos',6164.0,-89.57,-0.92).
city('Alfredo Baquerizo Moreno','ec','Guayas',12617.0,-79.52,-1.91).
city('Balao','ec','Guayas',12205.0,-79.82,-2.89).
city('Balzar','ec','Guayas',40115.0,-39.9,-1.36).
city('Colimes','ec','Guayas',9384.0,-80.01,-1.54).
city('Coronel Mariduena','ec','Guayas',7303.0,-79.42,-2.2).
city('Daule','ec','Guayas',48505.0,-79.98,-1.86).
city('El Triunfo','ec','Guayas',32282.0,-79.97,-1.93).
city('Eloy Alfaro','ec','Guayas',167784.0,-79.83,-2.17).
city('Guayaquil','ec','Guayas',1952029.0,-79.9,-2.21).
city('La Libertad','ec','Guayas',75881.0,-80.9,-2.23).
city('Lomas de Sargentillo','ec','Guayas',7542.0,-80.09,-1.88).
city('Milagro','ec','Guayas',110093.0,-79.6,-2.18).
city('Naranjal','ec','Guayas',32045.0,-79.62,-2.67).
city('Naranjito','ec','Guayas',34206.0,-79.48,-2.22).
city('Palestina','ec','Guayas',9364.0,-79.74,-1.93).
city('Pedro Carbo','ec','Guayas',23372.0,-80.24,-1.81).
city('Playas','ec','Guayas',30564.0,-80.39,-2.63).
city('Salinas','ec','Guayas',43862.0,-80.98,-2.2).
city('Samborondon','ec','Guayas',24118.0,-79.74,-1.95).
city('Santa Elena','ec','Guayas',42214.0,-80.87,-2.2).
city('Santa Lucia','ec','Guayas',12523.0,-80.0,-2.18).
city('Velasco Ibarra','ec','Guayas',48754.0,-79.62,-1.05).
city('Yaguachi','ec','Guayas',27947.0,-79.69,-2.12).
city('Atuntaqui','ec','Imbabura',17456.0,-78.23,0.35).
city('Cotacachi','ec','Imbabura',8238.0,-78.28,0.31).
city('Ibarra','ec','Imbabura',108666.0,-78.13,0.36).
city('Otavalo','ec','Imbabura',32330.0,-78.27,0.24).
city('Pimampiro','ec','Imbabura',7408.0,-77.97,0.4).
city('Alamor','ec','Loja',6391.0,-80.09,-3.87).
city('Cariamanga','ec','Loja',16862.0,-79.56,-4.32).
city('Catacocha','ec','Loja',10872.0,-79.65,-4.05).
city('Catamayo','ec','Loja',18565.0,-79.36,-3.98).
city('Celica','ec','Loja',5499.0,-79.95,-4.1).
city('Loja','ec','Loja',117796.0,-79.21,-3.99).
city('Macara','ec','Loja',13035.0,-79.95,-4.38).
city('Babahoyo','ec','Los Rios',76279.0,-79.54,-1.8).
city('Buena Fe','ec','Los Rios',17120.0,-79.94,-1.59).
city('Catarama','ec','Los Rios',9723.0,-79.47,-1.57).
city('Montalvo','ec','Los Rios',15547.0,-79.34,-1.8).
city('Palenque','ec','Los Rios',9083.0,-79.75,-1.43).
city('Puebloviejo','ec','Los Rios',10335.0,-79.28,-3.73).
city('Quevedo','ec','Los Rios',119436.0,-79.48,-1.0).
city('Ventanas','ec','Los Rios',46708.0,-79.47,-1.45).
city('Vinces','ec','Los Rios',32497.0,-79.76,-1.55).
city('Bahia de Caraquez','ec','Manabi',37056.0,-80.44,-0.6).
city('Calceta','ec','Manabi',17286.0,-80.17,-0.84).
city('Chone','ec','Manabi',44751.0,-80.09,-0.69).
city('El Carmen','ec','Manabi',63371.0,-80.02,-1.32).
city('Jipijapa','ec','Manabi',35901.0,-80.58,-1.35).
city('Junin','ec','Manabi',9128.0,-80.21,-0.92).
city('Manta','ec','Manabi',183166.0,-80.72,-0.96).
city('Montecristi','ec','Manabi',18351.0,-80.66,-1.04).
city('Pajan','ec','Manabi',9183.0,-80.42,-1.57).
city('Pedernales','ec','Manabi',5983.0,-80.05,0.07).
city('Portoviejo','ec','Manabi',170326.0,-80.46,-1.06).
city('Rocafuerte','ec','Manabi',10274.0,-80.46,-0.92).
city('Santa Ana','ec','Manabi',12833.0,-80.37,-1.2).
city('Sucre','ec','Manabi',15286.0,-80.44,-1.26).
city('Tosagua','ec','Manabi',14680.0,-80.26,-0.78).
city('Gualaquiza','ec','Morona Santiago',4611.0,-78.58,-3.38).
city('Macas','ec','Morona Santiago',23687.0,-78.0,-2.31).
city('Palora','ec','Morona Santiago',6472.0,-77.94,-1.7).
city('Sucua','ec','Morona Santiago',7413.0,-78.17,-2.46).
city('Archidona','ec','Napo',7309.0,-77.81,-0.9).
city('Tena','ec','Napo',17172.0,-77.81,-0.98).
city('Orellana','ec','Orellana',20313.0,-77.14,-0.7).
city('Puyo','ec','Pastaza',24881.0,-77.99,-1.48).
city('Cayambe','ec','Pichincha',26582.0,-78.16,0.05).
city('Machachi','ec','Pichincha',25742.0,-78.57,-0.51).
city('Quito','ec','Pichincha',1399814.0,-78.5,-0.19).
city('Sangolqui','ec','Pichincha',5114.0,-78.46,-0.31).
city('Santo Domingo','ec','Pichincha',200421.0,-79.16,-0.25).
city('Nueva Loja','ec','Sucumbios',24211.0,-76.87,0.1).
city('Ambato','ec','Tungurahua',154369.0,-78.62,-1.24).
city('Banos','ec','Tungurahua',9501.0,-78.43,-1.39).
city('Pelileo','ec','Tungurahua',16572.0,-78.54,-1.32).
city('Pillaro','ec','Tungurahua',7462.0,-78.53,-1.17).
city('Yantzaza','ec','Zamora Chinchipe',9970.0,-78.75,-3.85).
city('Zamora','ec','Zamora Chinchipe',15276.0,-78.97,-4.07).
city('Alexandria','eg','Alexandria',3811512.0,29.95,31.22).
city('Aswan','eg','Aswan',241282.0,32.92,24.08).
city('Koom Ombo','eg','Aswan',59787.0,32.95,24.47).
city('an-Nasir','eg','Aswan',35581.0,33.03,24.51).
city('Abnub','eg','Asyut',68756.0,31.15,27.27).
city('Abo Teeg','eg','Asyut',71264.0,31.31,27.05).
city('Asyut','eg','Asyut',420614.0,31.18,27.19).
city('Dayroot','eg','Asyut',67788.0,30.81,27.56).
city('El Badari','eg','Asyut',44132.0,31.41,26.99).
city('El Qoseyia','eg','Asyut',68394.0,30.82,27.43).
city('Manfaloot','eg','Asyut',78752.0,30.97,27.32).
city('Sahil Salim','eg','Asyut',29481.0,31.35,27.05).
city('Abo Homos','eg','Behera',34181.0,30.31,31.1).
city('Abo el Matamer','eg','Behera',41302.0,30.18,30.92).
city('Damanhoor','eg','Behera',227965.0,30.47,31.04).
city('Edko','eg','Behera',105612.0,30.3,31.31).
city('El Delengat','eg','Behera',40386.0,30.53,30.83).
city('El Mahmoodia','eg','Behera',25575.0,30.53,31.18).
city('El Rahmania','eg','Behera',29961.0,30.63,31.1).
city('Etay el Barood','eg','Behera',41797.0,30.66,30.88).
city('Hosh Eisa','eg','Behera',85363.0,30.29,30.9).
city('Kafr el Dauwar','eg','Behera',267394.0,30.12,31.13).
city('Koom Hamada','eg','Behera',36751.0,30.7,30.77).
city('Rosetta','eg','Behera',64489.0,30.39,31.46).
city('Shabrakhit','eg','Behera',28696.0,30.72,31.03).
city('Beba','eg','Beni Suef',59937.0,31.03,28.99).
city('Beni Suef','eg','Beni Suef',189637.0,31.09,29.08).
city('Boosh','eg','Beni Suef',86617.0,31.13,29.15).
city('Ehnasia','eg','Beni Suef',38195.0,30.94,29.09).
city('El Wasta','eg','Beni Suef',37453.0,31.2,29.33).
city('Somesta','eg','Beni Suef',37260.0,30.85,28.92).
city('al-Fasn','eg','Beni Suef',63793.0,30.89,28.83).
city('Cairo','eg','Cairo',7734602.0,31.25,30.06).
city('Damietta','eg','Damietta',76906.0,31.82,31.42).
city('El Zarka','eg','Damietta',40010.0,31.65,31.22).
city('Ezbet el Borg','eg','Damietta',37953.0,31.83,31.5).
city('Faraskoor','eg','Damietta',58284.0,31.72,31.33).
city('Kafr Sad','eg','Damietta',49558.0,31.65,31.32).
city('Ebshow','eg','El Faiyum',51173.0,30.68,29.37).
city('El Faiyum','eg','El Faiyum',306421.0,30.84,29.31).
city('Etsa','eg','El Faiyum',45269.0,30.8,29.25).
city('Sanoores','eg','El Faiyum',81227.0,30.85,29.49).
city('Tamia','eg','El Faiyum',46866.0,30.96,29.48).
city('Basyoon','eg','Gharbia',55523.0,30.81,30.95).
city('El Mahalla el Kubra','eg','Gharbia',431088.0,31.17,30.97).
city('Kafr el Zayat','eg','Gharbia',73733.0,30.82,30.82).
city('Kotoor','eg','Gharbia',23841.0,30.95,30.98).
city('Samanood','eg','Gharbia',54980.0,31.23,30.96).
city('Tanta','eg','Gharbia',404934.0,31.0,30.79).
city('Zefta','eg','Gharbia',92678.0,31.25,30.7).
city('El Ayat','eg','Gizeh',34796.0,31.25,29.62).
city('El Badrashin','eg','Gizeh',60493.0,31.27,29.85).
city('El Saf','eg','Gizeh',38213.0,31.28,29.57).
city('Gizeh','eg','Gizeh',2443490.0,31.21,30.01).
city('Madinat Sittah Uktubar','eg','Gizeh',41930.0,31.05,29.82).
city('Oseem','eg','Gizeh',63862.0,31.13,30.13).
city('al-Hawamidiyah','eg','Gizeh',106870.0,31.25,29.9).
city('al-Wahat-al-Bahriyah','eg','Gizeh',29681.0,29.01,28.65).
city('Faid','eg','Ismailia',19188.0,32.31,30.32).
city('Ismailia','eg','Ismailia',284851.0,32.26,30.59).
city('El Tur','eg','Janub Sina',15008.0,33.62,28.24).
city('Beyla','eg','Kafr el Sheikh',64258.0,31.21,31.18).
city('Desuk','eg','Kafr el Sheikh',102049.0,30.64,31.13).
city('El Brulus','eg','Kafr el Sheikh',39418.0,31.08,31.56).
city('El Hamool','eg','Kafr el Sheikh',45798.0,31.16,31.31).
city('Fowa','eg','Kafr el Sheikh',63310.0,30.59,31.2).
city('Kafr el Sheikh','eg','Kafr el Sheikh',143988.0,30.93,31.11).
city('Mootbas','eg','Kafr el Sheikh',34206.0,30.52,31.34).
city('Qullin','eg','Kafr el Sheikh',28560.0,30.85,31.05).
city('Sedi Salem','eg','Kafr el Sheikh',47998.0,30.79,31.27).
city('Luxor','eg','Luxor',422408.0,32.65,25.7).
city('El Daba','eg','Matruh',27128.0,28.44,31.03).
city('Marsa Matruh','eg','Matruh',62049.0,27.23,31.35).
city('Abo Korkas','eg','Menia',61182.0,30.82,27.93).
city('Beni Mazar','eg','Menia',58158.0,30.81,28.49).
city('Dir Mowas','eg','Menia',40609.0,30.84,27.64).
city('Maghagheh','eg','Menia',71373.0,30.84,28.65).
city('Matay','eg','Menia',45215.0,30.77,28.43).
city('Melawi','eg','Menia',142516.0,30.84,27.73).
city('Menia','eg','Menia',227164.0,30.75,28.09).
city('Samaloot','eg','Menia',90473.0,30.71,28.3).
city('al-Ganayim','eg','Menia',47889.0,31.33,26.87).
city('Ashmoon','eg','Menufia',82518.0,30.97,30.3).
city('Birkat-as-Sab','eg','Menufia',33854.0,31.08,30.64).
city('El Bagoor','eg','Menufia',36633.0,31.03,30.43).
city('El Shoohada','eg','Menufia',48060.0,30.9,30.6).
city('Menoof','eg','Menufia',83663.0,30.92,30.47).
city('Qowesna','eg','Menufia',42708.0,31.16,30.56).
city('Sers el Mayan','eg','Menufia',51814.0,30.98,30.43).
city('Shebin-El-Kom','eg','Menufia',184115.0,31.0,30.56).
city('Tala','eg','Menufia',51498.0,30.93,30.69).
city('El Arish','eg','North Sinai',129082.0,33.8,31.13).
city('Rafah','eg','North Sinai',30682.0,34.23,31.29).
city('Port Said','eg','Port Said',538377.0,32.29,31.26).
city('Armant','eg','Qe',77662.0,32.59,25.72).
city('Deshna','eg','Qena',54197.0,32.47,26.12).
city('Edfo','eg','Qena',166217.0,32.87,24.98).
city('Esna','eg','Qena',69335.0,32.55,25.29).
city('Farshoot','eg','Qena',53851.0,32.16,26.05).
city('Koos','eg','Qena',60181.0,32.76,25.91).
city('Nag Hammadi','eg','Qena',41184.0,32.24,26.05).
city('Qena','eg','Qena',235390.0,32.72,26.15).
city('Abo Kabir','eg','Sharkia',100696.0,31.67,30.73).
city('Abu Hammad','eg','Sharkia',35157.0,31.68,30.53).
city('Belbees','eg','Sharkia',129227.0,31.56,30.43).
city('Diyarb Najm','eg','Sharkia',51841.0,31.44,30.75).
city('El Asher men Ramadan','eg','Sharkia',57008.0,31.74,30.28).
city('El Ebrahemia','eg','Sharkia',34638.0,31.57,30.71).
city('El Hessenia','eg','Sharkia',28782.0,31.91,30.86).
city('El Korin','eg','Sharkia',61730.0,31.73,30.61).
city('El Qiniat','eg','Sharkia',42912.0,31.45,30.62).
city('El Tal el Kebeer','eg','Sharkia',51569.0,31.78,30.55).
city('El Zagazig','eg','Sharkia',285122.0,31.5,30.58).
city('Fakoos','eg','Sharkia',62829.0,31.8,30.74).
city('Hihya','eg','Sharkia',43432.0,31.58,30.67).
city('Kafr Sakr','eg','Sharkia',34967.0,31.62,30.79).
city('Mashtool el Sook','eg','Sharkia',45798.0,31.39,30.35).
city('Meniat el Kamh','eg','Sharkia',66338.0,31.34,30.52).
city('Akhmim','eg','Sohag',99459.0,31.75,26.56).
city('Dar-as-Salam','eg','Sohag',28074.0,32.03,26.24).
city('El Balyana','eg','Sohag',48801.0,32.0,26.24).
city('El Mansha','eg','Sohag',61134.0,31.81,26.47).
city('El Maragheh','eg','Sohag',38403.0,31.6,26.7).
city('Gerga','eg','Sohag',128267.0,31.88,26.33).
city('Gohayna','eg','Sohag',47821.0,31.5,26.67).
city('Sohag','eg','Sohag',209440.0,31.69,26.55).
city('Tahta','eg','Sohag',90604.0,31.5,26.76).
city('Tema','eg','Sohag',70073.0,31.3,26.94).
city('Suez','eg','Suez',488124.0,32.54,29.98).
city('Aja','eg','ad-Daqahliyah',34692.0,31.29,30.94).
city('Belkas','eg','ad-Daqahliyah',103609.0,31.35,31.22).
city('Dekernes','eg','ad-Daqahliyah',137559.0,31.6,31.08).
city('El Gamalia','eg','ad-Daqahliyah',68381.0,31.85,31.19).
city('El Mansura','eg','ad-Daqahliyah',420233.0,31.38,31.04).
city('El Manzala','eg','ad-Daqahliyah',67494.0,31.93,31.16).
city('El Senbelaween','eg','ad-Daqahliyah',85391.0,31.45,30.88).
city('Mataria','eg','ad-Daqahliyah',99370.0,32.02,31.17).
city('Meet Ghamr','eg','ad-Daqahliyah',109617.0,31.27,30.71).
city('Meniat el Nasr','eg','ad-Daqahliyah',56951.0,31.65,31.13).
city('Sherbeen','eg','ad-Daqahliyah',54676.0,31.52,31.19).
city('Talkha','eg','ad-Daqahliyah',157756.0,31.37,31.05).
city('El Qusir','eg','al-Bahr-al-Ahmar',24653.0,34.28,26.11).
city('Hurghada','eg','al-Bahr-al-Ahmar',95689.0,33.83,27.23).
city('Ras Gharib','eg','al-Bahr-al-Ahmar',28236.0,33.07,28.37).
city('Safaga','eg','al-Bahr-al-Ahmar',32944.0,33.93,26.73).
city('Benha','eg','al-Qalyubiyah',167070.0,31.18,30.47).
city('El Kanater el Khira','eg','al-Qalyubiyah',56316.0,31.13,30.2).
city('El Khanka','eg','al-Qalyubiyah',62434.0,31.36,30.21).
city('Qalyub','eg','al-Qalyubiyah',100521.0,31.2,30.18).
city('Shebin el Kanater','eg','al-Qalyubiyah',56872.0,31.31,30.32).
city('Shubra-El-Khema','eg','al-Qalyubiyah',991944.0,31.25,30.11).
city('Tookh','eg','al-Qalyubiyah',67599.0,31.21,30.35).
city('El Harga','eg','al-Wadi al-Jadid',59185.0,30.55,25.44).
city('Ahuachapan','sv','Ahuachapan',34104.0,-89.86,13.93).
city('Atiquizaya','sv','Ahuachapan',9477.0,-89.76,13.98).
city('Concepcion de Ataco','sv','Ahuachapan',7797.0,-89.85,13.87).
city('Guaymango','sv','Ahuachapan',1517.0,-89.85,13.75).
city('Jujutla','sv','Ahuachapan',2022.0,-89.86,13.79).
city('San Francisco Menendez','sv','Ahuachapan',1264.0,-90.02,13.85).
city('Tacuba','sv','Ahuachapan',5055.0,-89.93,13.9).
city('Ilobasco','sv','Cabanas',22874.0,-88.54,13.84).
city('Sensuntepeque','sv','Cabanas',20387.0,-88.63,13.88).
city('Victoria','sv','Cabanas',2023.0,-88.64,13.95).
city('Chalatenango','sv','Chalatenango',19366.0,-88.95,14.04).
city('Nueva Concepcion','sv','Chalatenango',9990.0,-89.3,14.13).
city('San Francisco Morazan','sv','Chalatenango',506.0,-89.05,14.18).
city('Cojutepeque','sv','Cuscatlan',48414.0,-88.94,13.73).
city('San Pedro Perulapan','sv','Cuscatlan',3287.0,-88.9,13.68).
city('Suchitoto','sv','Cuscatlan',5735.0,-89.03,13.94).
city('Tecoluca','sv','Cuscatlan',2781.0,-89.0,13.79).
city('Tenancingo','sv','Cuscatlan',1011.0,-88.98,13.83).
city('Antiguo Cuscatlan','sv','La Libertad',33767.0,-89.23,13.68).
city('Ciudad Arce','sv','La Libertad',10095.0,-89.46,13.86).
city('Colon','sv','La Libertad',1895.0,-88.57,13.55).
city('La Libertad','sv','La Libertad',16855.0,-89.33,13.48).
city('Nueva San Salvador','sv','La Libertad',124702.0,-89.29,13.68).
city('Nuevo Cuscatlan','sv','La Libertad',6469.0,-89.27,13.65).
city('Opico','sv','La Libertad',7127.0,-89.37,13.88).
city('Quezaltepeque','sv','La Libertad',28886.0,-89.28,13.84).
city('San Pablo Tacachico','sv','La Libertad',3033.0,-89.34,13.98).
city('Zaragoza','sv','La Libertad',11749.0,-89.29,13.58).
city('El Rosario','sv','La Paz',5620.0,-89.03,13.5).
city('Olocuilta','sv','La Paz',6324.0,-89.12,13.57).
city('San Luis la Herradura','sv','La Paz',6634.0,-88.95,13.35).
city('San Pedro Masahuat','sv','La Paz',2654.0,-89.05,13.55).
city('Santiago Nonualco','sv','La Paz',9490.0,-88.94,13.51).
city('Zacatecoluca','sv','La Paz',39616.0,-88.88,13.51).
city('Anamoros','sv','La Union',2655.0,-87.87,13.75).
city('Conchagua','sv','La Union',3034.0,-87.87,13.3).
city('Intipuca','sv','La Union',3540.0,-88.05,13.2).
city('La Union','sv','La Union',26809.0,-87.85,13.34).
city('Nueva Esparta','sv','La Union',2528.0,-87.83,13.78).
city('Pasaquina','sv','La Union',2149.0,-87.84,13.58).
city('San Alejo','sv','La Union',5149.0,-87.97,13.43).
city('Santa Rosa de Lima','sv','La Union',13249.0,-87.9,13.62).
city('Cacaopera','sv','Morazan',2528.0,-88.08,13.77).
city('Corint','sv','Morazan',3160.0,-87.97,13.81).
city('Gotera','sv','Morazan',16154.0,-88.1,13.7).
city('Guatajiagua','sv','Morazan',5273.0,-88.2,13.67).
city('Jocoro','sv','Morazan',4298.0,-88.03,13.61).
city('Sociedad','sv','Morazan',1770.0,-88.02,13.7).
city('Chapeltique','sv','San Miguel',3159.0,-88.26,13.64).
city('Chinameca','sv','San Miguel',8646.0,-88.35,13.51).
city('Chirilagua','sv','San Miguel',6393.0,-88.14,13.22).
city('Ciudad Barrios','sv','San Miguel',8491.0,-88.27,13.77).
city('El Transito','sv','San Miguel',9486.0,-88.36,13.35).
city('Lolotique','sv','San Miguel',2654.0,-88.35,13.55).
city('Moncagua','sv','San Miguel',2148.0,-88.25,13.53).
city('Nueva Guadalupe','sv','San Miguel',5798.0,-88.35,13.53).
city('San Miguel','sv','San Miguel',161889.0,-88.18,13.47).
city('San Rafael','sv','San Miguel',19095.0,-88.36,13.38).
city('Sesori','sv','San Miguel',1390.0,-88.37,13.72).
city('Aguilares','sv','San Salvador',21445.0,-89.19,13.96).
city('Apopa','sv','San Salvador',112157.0,-89.18,13.8).
city('Ayutuxtepeque','sv','San Salvador',25426.0,-89.2,13.74).
city('Cuscatancingo','sv','San Salvador',44368.0,-89.19,13.74).
city('Delgado','sv','San Salvador',71593.0,-89.17,13.72).
city('El Paisnal','sv','San Salvador',1641.0,-89.22,13.97).
city('Guazapa','sv','San Salvador',10106.0,-89.16,13.89).
city('Ilopango','sv','San Salvador',38889.0,-89.12,13.7).
city('Mejicanos','sv','San Salvador',160319.0,-89.2,13.73).
city('Nejapa','sv','San Salvador',5390.0,-89.28,13.89).
city('Panchimalco','sv','San Salvador',6764.0,-89.18,13.62).
city('Rosario de Mora','sv','San Salvador',5178.0,-89.0,13.57).
city('San Marcos','sv','San Salvador',54614.0,-89.19,13.66).
city('San Martin','sv','San Salvador',39360.0,-88.92,13.79).
city('San Salvador','sv','San Salvador',526013.0,-89.19,13.69).
city('Santo Tomas','sv','San Salvador',14581.0,-89.14,13.65).
city('Soyapango','sv','San Salvador',329704.0,-89.16,13.7).
city('Tonacatepeque','sv','San Salvador',6245.0,-89.12,13.79).
city('Apastepeque','sv','San Vicente',5785.0,-88.78,13.67).
city('San Sebastian','sv','San Vicente',7333.0,-88.82,13.72).
city('San Vicente','sv','San Vicente',37328.0,-88.79,13.64).
city('Candelaria de la Frontera','sv','Santa Ana',6301.0,-89.65,14.12).
city('Chalchuapa','sv','Santa Ana',32282.0,-89.7,13.99).
city('Coatepeque','sv','Santa Ana',5773.0,-89.5,13.93).
city('El Congo','sv','Santa Ana',8906.0,-89.5,13.91).
city('Metapan','sv','Santa Ana',19143.0,-89.45,14.33).
city('Santa Ana','sv','Santa Ana',176671.0,-89.54,14.0).
city('Texistepeque','sv','Santa Ana',2401.0,-89.49,14.13).
city('Acajutla','sv','Sonsonate',22764.0,-89.83,13.59).
city('Armenia','sv','Sonsonate',14997.0,-89.5,13.74).
city('Izalco','sv','Sonsonate',19198.0,-89.68,13.74).
city('Juayua','sv','Sonsonate',9936.0,-89.75,13.85).
city('Nahuizalco','sv','Sonsonate',7358.0,-89.74,13.78).
city('San Antonio del Monte','sv','Sonsonate',9136.0,-89.75,13.72).
city('Sonsonate','sv','Sonsonate',59473.0,-89.73,13.72).
city('Sonzacate','sv','Sonsonate',15446.0,-89.72,13.74).
city('Berlin','sv','Usulutan',11313.0,-88.53,13.5).
city('Concepcion Batres','sv','Usulutan',3286.0,-88.37,13.35).
city('Jiquilisco','sv','Usulutan',9129.0,-88.57,13.33).
city('Jucuapa','sv','Usulutan',10601.0,-88.38,13.51).
city('Jucuaran','sv','Usulutan',1643.0,-88.25,13.25).
city('Ozatlan','sv','Usulutan',4171.0,-88.5,13.39).
city('Puerto El Triunfo','sv','Usulutan',19074.0,-88.55,13.28).
city('San Agustin','sv','Usulutan',2149.0,-88.6,13.43).
city('Santa Elena','sv','Usulutan',5887.0,-88.42,13.38).
city('Santiago de Maria','sv','Usulutan',15033.0,-88.47,13.48).
city('Usulutan','sv','Usulutan',51914.0,-88.44,13.34).
city('Palea','gq','Annobon',4436.0,5.61,-1.41).
city('Malabo','gq','Bioko Norte',156039.0,8.79,3.74).
city('Luba','gq','Bioko Sur',8668.0,8.55,3.46).
city('Riaba','gq','Bioko Sur',972.0,8.76,3.4).
city('Acurenam','gq','Centro Sur',2738.0,10.66,1.03).
city('Evinayong','gq','Centro Sur',8468.0,10.57,1.45).
city('Niefang','gq','Centro Sur',4861.0,10.05,1.48).
city('Ebebiyin','gq','Kie-Ntem',24857.0,11.33,2.15).
city('Micomeseng','gq','Kie-Ntem',5818.0,10.62,2.14).
city('Bata','gq','Litoral',173036.0,9.76,1.87).
city('Mbini','gq','Litoral',4061.0,9.61,1.58).
city('Ac','gq','Wele-Nzas',11199.0,10.93,1.3).
city('Anisoc','gq','Wele-Nzas',10197.0,10.77,1.85).
city('Mongomo','gq','Wele-Nzas',6397.0,11.31,1.63).
city('Keren','er','Anseba',58080.0,38.45,15.68).
city('Addi Kwala','er','Debub',6756.0,38.83,14.64).
city('Addi Ugri','er','Debub',17784.0,38.82,14.89).
city('Asseb','er','Debub-Keih-Bahri',78018.0,42.74,13.01).
city('Edd','er','Debub-Keih-Bahri',11259.0,41.69,13.93).
city('Akordat','er','Gash-Barka',8857.0,37.88,15.56).
city('Barentu','er','Gash-Barka',15891.0,37.59,15.12).
city('Teseney','er','Gash-Barka',3753.0,36.65,15.12).
city('Asmara','er','Maekel',563948.0,38.94,15.33).
city('Ginda','er','Maekel',11560.0,39.09,15.45).
city('Addi Keyih','er','Semien-Keih-Bahri',13061.0,39.37,14.85).
city('Dekemhare','er','Semien-Keih-Bahri',10959.0,39.04,15.07).
city('Mitsiwa','er','Semien-Keih-Bahri',39098.0,39.44,15.61).
city('Senafe','er','Semien-Keih-Bahri',6005.0,39.42,14.69).
city('Aeaesmaee','ee','Harju',638.0,24.51,59.24).
city('Aegviidu','ee','Harju',910.0,25.61,59.29).
city('Aemari','ee','Harju',579.0,24.58,59.37).
city('Alavere','ee','Harju',427.0,25.32,59.24).
city('Alliku','ee','Harju',220.0,24.55,59.35).
city('Ardu','ee','Harju',559.0,25.37,59.1).
city('Arukuela','ee','Harju',1829.0,25.08,59.36).
city('Assaku','ee','Harju',402.0,24.84,59.38).
city('Haabneeme','ee','Harju',2077.0,24.81,59.51).
city('Habaja','ee','Harju',345.0,25.18,59.1).
city('Haiba','ee','Harju',395.0,24.47,59.13).
city('Harju-Risti','ee','Harju',387.0,24.02,59.23).
city('Harku','ee','Harju',781.0,24.37,59.13).
city('Harkujaerve','ee','Harju',453.0,24.59,59.42).
city('Hueueru','ee','Harju',349.0,24.53,59.38).
city('Jueri','ee','Harju',2581.0,24.9,59.36).
city('Karjakuela','ee','Harju',362.0,24.39,59.34).
city('Kehra','ee','Harju',3183.0,25.32,59.34).
city('Keila','ee','Harju',9411.0,24.41,59.31).
city('Keila-Joa','ee','Harju',378.0,24.3,59.4).
city('Kiili','ee','Harju',942.0,24.84,59.31).
city('Kiisa','ee','Harju',551.0,24.69,59.24).
city('Kiiu','ee','Harju',833.0,25.38,59.45).
city('Klooga','ee','Harju',983.0,24.21,59.32).
city('Kolga','ee','Harju',520.0,25.72,59.52).
city('Kose','ee','Harju',2232.0,24.88,59.46).
city('Kose-Uuemoisa','ee','Harju',980.0,25.11,59.2).
city('Kostivere','ee','Harju',790.0,25.1,59.43).
city('Kumna','ee','Harju',315.0,24.44,59.33).
city('Kurtna','ee','Harju',331.0,24.72,59.23).
city('Kuusalu','ee','Harju',1238.0,25.44,59.44).
city('Laagri','ee','Harju',4135.0,24.6,59.35).
city('Lagedi','ee','Harju',939.0,24.94,59.41).
city('Lehola','ee','Harju',530.0,24.31,59.29).
city('Lehtmetsa','ee','Harju',789.0,25.36,59.32).
city('Loksa','ee','Harju',3463.0,25.72,59.58).
city('Loo','ee','Harju',2175.0,24.95,59.44).
city('Luige','ee','Harju',562.0,24.76,59.34).
city('Maardu','ee','Harju',16630.0,25.01,59.49).
city('Miiduranna','ee','Harju',399.0,24.82,59.5).
city('Muraste','ee','Harju',337.0,24.43,59.46).
city('Oru','ee','Harju',394.0,24.98,59.19).
city('Padise','ee','Harju',392.0,24.14,59.23).
city('Paldiski','ee','Harju',4202.0,24.09,59.34).
city('Peetri','ee','Harju',824.0,24.81,59.39).
city('Pringi','ee','Harju',603.0,24.79,59.54).
city('Pueuensi','ee','Harju',729.0,24.79,59.55).
city('Raasiku','ee','Harju',1317.0,25.18,59.37).
city('Randvere','ee','Harju',513.0,24.9,59.51).
city('Ravila','ee','Harju',377.0,25.22,59.18).
city('Riisipere','ee','Harju',1058.0,24.32,59.12).
city('Rohuneeme','ee','Harju',316.0,24.8,59.56).
city('Rummu','ee','Harju',3488.0,24.8,59.54).
city('Saku','ee','Harju',4548.0,24.66,59.3).
city('Saue','ee','Harju',5022.0,24.55,59.32).
city('Tabasalu','ee','Harju',2166.0,24.53,59.43).
city('Tallinn','ee','Harju',394023.0,24.74,59.44).
city('Turba','ee','Harju',1096.0,24.23,59.08).
city('Vaida','ee','Harju',1016.0,24.97,59.29).
city('Valkla','ee','Harju',663.0,25.32,59.47).
city('Vanamoisa','ee','Harju',353.0,24.53,59.32).
city('Vasalemma','ee','Harju',856.0,24.29,59.24).
city('Vaskjala','ee','Harju',325.0,24.94,59.36).
city('Viimsi','ee','Harju',1740.0,24.84,59.5).
city('Kaeina','ee','Hiiu',854.0,22.79,58.83).
city('Kaerdla','ee','Hiiu',3763.0,22.75,59.0).
city('Korgessaare','ee','Hiiu',509.0,25.47,58.8).
city('Suuremoisa','ee','Hiiu',316.0,22.95,58.87).
city('Aseri','ee','Ida-Viru',1831.0,26.87,59.45).
city('Avinurme','ee','Ida-Viru',779.0,26.87,58.98).
city('Iisaku','ee','Ida-Viru',916.0,27.31,59.1).
city('Jaerve','ee','Ida-Viru',682.0,27.31,59.41).
city('Johvi','ee','Ida-Viru',11469.0,27.42,59.36).
city('Kivioli','ee','Ida-Viru',6953.0,26.98,59.36).
city('Kohtla-Jaerve','ee','Ida-Viru',46060.0,27.25,59.4).
city('Kohtla-Nomme','ee','Ida-Viru',1075.0,27.18,59.35).
city('Kuremaee','ee','Ida-Viru',369.0,27.54,59.2).
city('Lohusuu','ee','Ida-Viru',394.0,27.05,58.94).
city('Lueganuse','ee','Ida-Viru',454.0,27.03,59.3).
city('Maeetaguse','ee','Ida-Viru',542.0,27.27,59.23).
city('Narva','ee','Ida-Viru',66980.0,28.19,59.38).
city('Narva-Joesuu','ee','Ida-Viru',2802.0,28.04,59.46).
city('Olgina','ee','Ida-Viru',504.0,28.13,59.4).
city('Puessi','ee','Ida-Viru',1840.0,27.05,59.36).
city('Purtse','ee','Ida-Viru',298.0,27.02,59.42).
city('Sillamaee','ee','Ida-Viru',16672.0,27.75,59.41).
city('Sinimaee','ee','Ida-Viru',352.0,27.87,59.37).
city('Sonda','ee','Ida-Viru',594.0,26.84,59.34).
city('Tammiku','ee','Ida-Viru',376.0,27.38,59.33).
city('Toila','ee','Ida-Viru',750.0,27.5,59.42).
city('Tudulinna','ee','Ida-Viru',295.0,27.09,59.04).
city('Voka','ee','Ida-Viru',1046.0,27.58,59.4).
city('Ahula','ee','Jaerva',329.0,25.74,59.11).
city('Albu','ee','Jaerva',349.0,25.67,59.15).
city('Ambla','ee','Jaerva',352.0,25.85,59.19).
city('Aravete','ee','Jaerva',955.0,25.76,59.14).
city('Imavere','ee','Jaerva',486.0,25.77,58.73).
city('Jaeneda','ee','Jaerva',448.0,25.7,59.25).
city('Jaerva-Jaani','ee','Jaerva',1051.0,25.89,59.04).
city('Kabala','ee','Jaerva',366.0,25.63,58.69).
city('Kaeravete','ee','Jaerva',295.0,25.75,59.19).
city('Koeru','ee','Jaerva',1300.0,26.03,58.96).
city('Koigi','ee','Jaerva',448.0,25.97,59.17).
city('Lehtse','ee','Jaerva',493.0,25.82,59.25).
city('Oisu','ee','Jaerva',418.0,25.57,58.75).
city('Paide','ee','Jaerva',9735.0,25.55,58.9).
city('Peetri','ee','Jaerva',307.0,25.83,58.95).
city('Roosna-Alliku','ee','Jaerva',488.0,25.71,59.03).
city('Saerevere','ee','Jaerva',1035.0,25.43,58.79).
city('Tarbja','ee','Jaerva',355.0,25.59,58.93).
city('Tueri','ee','Jaerva',6138.0,25.43,58.82).
city('Tueri-Alliku','ee','Jaerva',507.0,25.45,58.82).
city('Vaeaetsa','ee','Jaerva',679.0,25.45,58.89).
city('Adavere','ee','Jogeva',646.0,25.9,58.71).
city('Esku','ee','Jogeva',413.0,25.88,58.65).
city('Jogeva','ee','Jogeva',3473.0,26.4,58.75).
city('Kaarepere','ee','Jogeva',334.0,26.53,58.66).
city('Kuremaa','ee','Jogeva',594.0,26.52,58.74).
city('Laiuse','ee','Jogeva',461.0,26.48,58.78).
city('Lustivere','ee','Jogeva',477.0,26.08,58.67).
city('Luua','ee','Jogeva',432.0,26.6,58.65).
city('Mustvee','ee','Jogeva',1662.0,26.94,58.86).
city('Palamuse','ee','Jogeva',541.0,26.58,58.69).
city('Pisisaare','ee','Jogeva',300.0,25.97,58.72).
city('Poltsamaa','ee','Jogeva',4764.0,25.98,58.66).
city('Puurmani','ee','Jogeva',646.0,26.28,58.58).
city('Raja','ee','Jogeva',469.0,26.95,58.8).
city('Sadala','ee','Jogeva',306.0,26.6,58.87).
city('Siimusti','ee','Jogeva',797.0,26.34,58.73).
city('Tabivere','ee','Jogeva',1062.0,26.58,58.55).
city('Torma','ee','Jogeva',533.0,26.74,58.81).
city('Vaeike-Kamari','ee','Jogeva',489.0,25.98,58.62).
city('Vaimastvere','ee','Jogeva',346.0,26.29,58.81).
city('Voisiku','ee','Jogeva',516.0,25.92,58.63).
city('Voore','ee','Jogeva',321.0,26.75,58.72).
city('Haapsalu','ee','Laeaene',11805.0,23.54,58.95).
city('Koluvere','ee','Laeaene',494.0,24.11,58.91).
city('Kullamaa','ee','Laeaene',332.0,24.08,58.88).
city('Lihula','ee','Laeaene',1457.0,23.85,58.68).
city('Linnamaee','ee','Laeaene',460.0,23.71,59.0).
city('Palivere','ee','Laeaene',968.0,23.9,58.97).
city('Panga','ee','Laeaene',290.0,23.55,58.82).
city('Risti','ee','Laeaene',597.0,23.84,58.56).
city('Taebla','ee','Laeaene',990.0,23.75,58.95).
city('Uuemoisa','ee','Laeaene',1068.0,23.59,58.94).
city('Virtsu','ee','Laeaene',731.0,23.52,58.5).
city('Aaspere','ee','Laeaene-Viru',315.0,26.12,59.42).
city('Essu','ee','Laeaene-Viru',302.0,26.37,59.43).
city('Haljala','ee','Laeaene-Viru',1233.0,26.2,59.43).
city('Hulja','ee','Laeaene-Viru',569.0,26.21,59.35).
city('Kadrina','ee','Laeaene-Viru',2406.0,26.15,59.33).
city('Kunda','ee','Laeaene-Viru',3764.0,26.54,59.5).
city('Laekvere','ee','Laeaene-Viru',472.0,26.57,59.07).
city('Lepna','ee','Laeaene-Viru',501.0,26.03,59.33).
city('Naepi','ee','Laeaene-Viru',404.0,26.4,59.36).
city('Pajusti','ee','Laeaene-Viru',756.0,26.42,59.27).
city('Piira','ee','Laeaene-Viru',371.0,26.39,59.31).
city('Rakke','ee','Laeaene-Viru',1045.0,26.25,58.98).
city('Rakvere','ee','Laeaene-Viru',16736.0,26.36,59.36).
city('Roela','ee','Laeaene-Viru',596.0,26.6,59.17).
city('Saeaese','ee','Laeaene-Viru',495.0,26.15,59.16).
city('Simuna','ee','Laeaene-Viru',474.0,26.4,59.04).
city('Someru','ee','Laeaene-Viru',1350.0,26.44,59.36).
city('Tamsalu','ee','Laeaene-Viru',2594.0,26.12,59.16).
city('Tapa','ee','Laeaene-Viru',6551.0,25.96,59.27).
city('Triigi','ee','Laeaene-Viru',291.0,26.34,59.11).
city('Tudu','ee','Laeaene-Viru',441.0,26.86,59.18).
city('Ubja','ee','Laeaene-Viru',311.0,26.43,59.41).
city('Uhtna','ee','Laeaene-Viru',355.0,26.56,59.39).
city('Ulvi','ee','Laeaene-Viru',290.0,26.64,59.32).
city('Vaeike-Maarja','ee','Laeaene-Viru',2155.0,26.25,59.13).
city('Vajangu','ee','Laeaene-Viru',401.0,26.03,59.1).
city('Vao','ee','Laeaene-Viru',431.0,26.19,59.11).
city('Veltsi','ee','Laeaene-Viru',293.0,26.27,59.4).
city('Vinni','ee','Laeaene-Viru',1032.0,26.43,59.3).
city('Viru-Jaagupi','ee','Laeaene-Viru',376.0,26.48,59.24).
city('Viru-Nigula','ee','Laeaene-Viru',364.0,26.69,59.44).
city('Vosu','ee','Laeaene-Viru',481.0,25.98,59.57).
city('Are','ee','Paernu',408.0,24.58,58.57).
city('Audru','ee','Paernu',1430.0,24.37,58.41).
city('Haeaedemeeste','ee','Paernu',851.0,24.51,58.08).
city('Joesuu','ee','Paernu',393.0,24.91,58.49).
city('Joopre','ee','Paernu',448.0,24.32,58.47).
city('Kabli','ee','Paernu',365.0,24.74,58.34).
city('Kilingi-Nomme','ee','Paernu',2175.0,24.96,58.15).
city('Koonga','ee','Paernu',303.0,24.15,58.58).
city('Lavassaare','ee','Paernu',548.0,24.39,58.51).
city('Libatse','ee','Paernu',488.0,24.48,58.66).
city('Paernu','ee','Paernu',44193.0,24.51,58.38).
city('Paernu-Jaagupi','ee','Paernu',1341.0,24.52,58.61).
city('Paikuse','ee','Paernu',1996.0,24.63,58.38).
city('Papsaare','ee','Paernu',497.0,24.41,58.4).
city('Reiu','ee','Paernu',376.0,24.59,58.29).
city('Sa','ee','Paernu',370.0,24.4,58.48).
city('Sauga','ee','Paernu',1062.0,24.5,58.42).
city('Selja','ee','Paernu',405.0,24.81,58.51).
city('Seljametsa','ee','Paernu',318.0,24.67,58.36).
city('Sindi','ee','Paernu',4036.0,24.66,58.41).
city('Suigu','ee','Paernu',295.0,24.7,58.53).
city('Surju','ee','Paernu',320.0,24.72,58.24).
city('Tali','ee','Paernu',345.0,24.79,58.06).
city('Tammiste','ee','Paernu',354.0,24.58,58.39).
city('Tihemetsa','ee','Paernu',894.0,25.04,58.15).
city('Tootsi','ee','Paernu',1010.0,24.79,58.58).
city('Tori','ee','Paernu',526.0,24.82,58.48).
city('Tostamaa','ee','Paernu',639.0,24.0,58.33).
city('Uulu','ee','Paernu',524.0,24.59,58.28).
city('Vaendra','ee','Paernu',2544.0,25.04,58.65).
city('Vihtra','ee','Paernu',309.0,25.02,58.59).
city('Voiste','ee','Paernu',520.0,24.48,58.47).
city('Ahja','ee','Polva',616.0,27.07,58.2).
city('Erastvere','ee','Polva',311.0,26.79,57.97).
city('Himmaste','ee','Polva',545.0,27.07,58.08).
city('Kanepi','ee','Polva',638.0,26.76,57.98).
city('Kauksi','ee','Polva',317.0,27.22,58.09).
city('Krootuse','ee','Polva',417.0,26.84,58.07).
city('Linte','ee','Polva',286.0,27.46,58.16).
city('Mammaste','ee','Polva',616.0,27.05,58.07).
city('Mikitamaee','ee','Polva',345.0,27.55,58.0).
city('Mooste','ee','Polva',450.0,27.19,58.16).
city('Orava','ee','Polva',300.0,27.46,57.9).
city('Polgaste','ee','Polva',372.0,26.88,57.98).
city('Polva','ee','Polva',6504.0,27.06,58.05).
city('Raepina','ee','Polva',2901.0,27.46,58.1).
city('Rosma','ee','Polva',377.0,27.07,58.04).
city('Saverna','ee','Polva',398.0,26.72,58.07).
city('Tilsi','ee','Polva',430.0,27.01,57.98).
city('Vaerska','ee','Polva',563.0,27.64,57.96).
city('Vastse-Kuuste','ee','Polva',510.0,26.93,58.17).
city('Veriora','ee','Polva',549.0,27.35,58.0).
city('Eidapere','ee','Rapla',325.0,24.94,58.75).
city('Hagudi','ee','Rapla',327.0,24.2,59.07).
city('Jaervakandi','ee','Rapla',1471.0,24.83,58.78).
city('Juuru','ee','Rapla',571.0,24.95,59.06).
city('Kaerepere','ee','Rapla',544.0,24.84,58.97).
city('Kaeru','ee','Rapla',460.0,25.15,58.83).
city('Kaiu','ee','Rapla',595.0,25.06,59.01).
city('Keava','ee','Rapla',294.0,24.9,58.95).
city('Kehtna','ee','Rapla',1579.0,24.88,58.93).
city('Kivi-Vigala','ee','Rapla',293.0,24.38,58.72).
city('Kodila','ee','Rapla',336.0,24.67,59.04).
city('Kohila','ee','Rapla',3355.0,24.76,59.17).
city('Kuimetsa','ee','Rapla',385.0,25.13,59.04).
city('Lelle','ee','Rapla',431.0,25.0,58.86).
city('Maerjamaa','ee','Rapla',3063.0,24.43,58.9).
city('Orgita','ee','Rapla',540.0,24.43,58.93).
city('Prillimaee','ee','Rapla',406.0,24.81,59.19).
city('Raikkuela','ee','Rapla',301.0,24.76,58.94).
city('Rapla','ee','Rapla',5684.0,24.8,59.01).
city('Sipa','ee','Rapla',338.0,24.32,58.92).
city('Tamme','ee','Rapla',349.0,24.64,58.93).
city('Vana-Vigala','ee','Rapla',572.0,24.27,58.77).
city('Varbola','ee','Rapla',323.0,24.45,59.04).
city('Aste','ee','Saare',546.0,22.46,58.34).
city('Kaerla','ee','Saare',988.0,22.26,58.34).
city('Kihelkonna','ee','Saare',476.0,22.05,58.35).
city('Kudjape','ee','Saare',450.0,22.55,58.26).
city('Kuressaare','ee','Saare',14922.0,22.48,58.26).
city('Leisi','ee','Saare',329.0,22.7,58.57).
city('Mustjala','ee','Saare',295.0,22.24,58.46).
city('Nasva','ee','Saare',330.0,22.0,58.23).
city('Orissaare','ee','Saare',1065.0,23.09,58.56).
city('Salme','ee','Saare',576.0,22.26,58.16).
city('Valjala','ee','Saare',503.0,22.8,58.41).
city('Aeksi','ee','Tartu',453.0,26.64,58.53).
city('Alatskivi','ee','Tartu',430.0,27.13,58.6).
city('Annikoru','ee','Tartu',329.0,26.3,58.27).
city('Aravu','ee','Tartu',144.0,27.39,58.23).
city('Elva','ee','Tartu',5820.0,26.4,58.23).
city('Haage','ee','Tartu',370.0,26.63,58.37).
city('Ignase','ee','Tartu',106.0,26.85,58.26).
city('Ilmatsalu','ee','Tartu',512.0,26.55,58.39).
city('Kaeaerdi','ee','Tartu',573.0,26.41,58.2).
city('Kallaste','ee','Tartu',1171.0,27.14,58.68).
city('Kambja','ee','Tartu',722.0,26.7,58.23).
city('Kolkja','ee','Tartu',397.0,27.22,58.55).
city('Koosa','ee','Tartu',548.0,27.07,58.52).
city('Korvekuela','ee','Tartu',571.0,26.78,58.42).
city('Kuelitse','ee','Tartu',361.0,26.61,58.32).
city('Laehte','ee','Tartu',487.0,26.67,58.49).
city('Laeva','ee','Tartu',468.0,26.36,58.49).
city('Lohkva','ee','Tartu',776.0,26.8,58.37).
city('Luke','ee','Tartu',335.0,26.54,58.24).
city('Luunja','ee','Tartu',579.0,26.88,58.36).
city('Melliste','ee','Tartu',484.0,26.98,58.33).
city('Noo','ee','Tartu',1476.0,26.54,58.28).
city('Puhja','ee','Tartu',1072.0,26.31,58.34).
city('Raeni','ee','Tartu',498.0,26.65,58.36).
city('Rahinge','ee','Tartu',346.0,26.61,58.38).
city('Rannu','ee','Tartu',439.0,26.22,58.24).
city('Roiu','ee','Tartu',485.0,26.87,58.3).
city('Rongu','ee','Tartu',738.0,26.25,58.15).
city('Soinaste','ee','Tartu',336.0,26.69,58.34).
city('Tartu','ee','Tartu',101092.0,26.71,58.38).
city('Toravere','ee','Tartu',311.0,26.46,58.27).
city('Torvandi','ee','Tartu',1592.0,26.07,58.32).
city('Uelenurme','ee','Tartu',1047.0,26.72,58.32).
city('Uhti','ee','Tartu',327.0,26.73,58.28).
city('Ulila','ee','Tartu',349.0,26.43,58.36).
city('Vara','ee','Tartu',406.0,26.88,58.52).
city('Vonnu','ee','Tartu',630.0,27.05,58.28).
city('Aakre','ee','Valga',295.0,26.19,58.1).
city('Helme','ee','Valga',407.0,25.9,58.01).
city('Hummuli','ee','Valga',404.0,26.06,57.9).
city('Kaagjaerve','ee','Valga',317.0,26.18,57.77).
city('Keeni','ee','Valga',351.0,26.28,57.95).
city('Linna','ee','Valga',456.0,25.85,58.03).
city('Luellemaee','ee','Valga',290.0,26.38,57.75).
city('Otepaeae','ee','Valga',1248.0,26.51,58.07).
city('Puka','ee','Valga',748.0,26.23,58.05).
city('Sihva','ee','Valga',362.0,26.43,58.02).
city('Sooru','ee','Valga',294.0,26.12,57.85).
city('Torva','ee','Valga',3112.0,25.93,58.01).
city('Tsirguliina','ee','Valga',515.0,26.2,57.86).
city('Valga','ee','Valga',13946.0,26.05,57.78).
city('Abja-Paluoja','ee','Viljandi',1372.0,25.35,58.13).
city('Halliste','ee','Viljandi',362.0,25.1,58.34).
city('Jaemejala','ee','Viljandi',294.0,25.57,58.39).
city('Kaerstna','ee','Viljandi',300.0,25.81,58.15).
city('Karksi','ee','Viljandi',528.0,25.59,58.12).
city('Karksi-Nuia','ee','Viljandi',1986.0,25.56,58.1).
city('Kolga-Jaani','ee','Viljandi',420.0,25.95,58.53).
city('Koo','ee','Viljandi',318.0,25.72,58.63).
city('Kopu','ee','Viljandi',363.0,25.31,58.33).
city('Leie','ee','Viljandi',284.0,26.03,58.42).
city('Moisakuela','ee','Viljandi',1090.0,25.17,58.1).
city('Mustla','ee','Viljandi',928.0,25.11,58.14).
city('Oisu','ee','Viljandi',351.0,25.55,58.2).
city('Olustvere','ee','Viljandi',647.0,25.56,58.55).
city('Paeri','ee','Viljandi',475.0,25.5,58.35).
city('Paistu','ee','Viljandi',346.0,25.62,58.27).
city('Puiatu','ee','Viljandi',291.0,25.42,58.36).
city('Ramsi','ee','Viljandi',732.0,25.54,58.31).
city('Saarepeedi','ee','Viljandi',330.0,25.69,58.43).
city('Soe','ee','Viljandi',307.0,25.93,58.21).
city('Suergavere','ee','Viljandi',423.0,25.48,58.49).
city('Suislepa','ee','Viljandi',305.0,25.96,58.15).
city('Suure-Jaani','ee','Viljandi',1254.0,25.46,58.55).
city('Uusna','ee','Viljandi',368.0,25.73,58.39).
city('Vana-Voidu','ee','Viljandi',517.0,25.65,58.39).
city('Vastemoisa','ee','Viljandi',450.0,25.43,58.44).
city('Viiratsi','ee','Viljandi',1338.0,25.64,58.36).
city('Viljandi','ee','Viljandi',20310.0,25.6,58.37).
city('Vohma','ee','Viljandi',1551.0,25.55,58.62).
city('Antsla','ee','Voru',1468.0,26.53,57.84).
city('Kaeaepa','ee','Voru',306.0,27.11,57.87).
city('Kobela','ee','Voru',468.0,26.46,57.84).
city('Kollino','ee','Voru',301.0,26.56,57.82).
city('Kose','ee','Voru',549.0,27.04,57.81).
city('Lasva','ee','Voru',309.0,27.18,57.86).
city('Misso','ee','Voru',324.0,27.24,57.6).
city('Osula','ee','Voru',335.0,26.82,57.89).
city('Parksepa','ee','Voru',737.0,26.98,57.91).
city('Puiga','ee','Voru',332.0,27.04,57.8).
city('Rouge','ee','Voru',442.0,26.91,57.73).
city('Saru','ee','Voru',299.0,26.54,57.6).
city('Somerpalu','ee','Voru',413.0,26.83,57.85).
city('Tsooru','ee','Voru',313.0,26.66,57.74).
city('Vaeimela','ee','Voru',799.0,27.02,57.89).
city('Vana-Antsla','ee','Voru',313.0,26.53,57.87).
city('Varstu','ee','Voru',437.0,26.66,57.64).
city('Vastseliina','ee','Voru',773.0,27.29,57.73).
city('Voru','ee','Voru',14630.0,27.01,57.85).
city('Addis Abeba','et','Addis Abeba',2757807.0,38.74,9.03).
city('Amibara','et','Afar',25420.0,40.18,9.35).
city('Asayita','et','Afar',20342.0,41.44,11.56).
city('Awash','et','Afar',11415.0,40.17,8.98).
city('Dubti','et','Afar',26375.0,41.08,11.74).
city('Gewane','et','Afar',11279.0,40.65,10.17).
city('Addi Arkay','et','Amhara',4886.0,38.06,13.45).
city('Addis Alem','et','Amhara',9859.0,38.39,9.04).
city('Addis Zemen','et','Amhara',22526.0,37.78,12.12).
city('Adet','et','Amhara',22950.0,37.48,11.27).
city('Bahir Dar','et','Amhara',168929.0,37.37,11.56).
city('Bati','et','Amhara',19263.0,40.02,11.18).
city('Bichena','et','Amhara',16411.0,38.2,10.45).
city('Bure','et','Amhara',22042.0,37.07,10.71).
city('Chagni','et','Amhara',38020.0,36.5,10.95).
city('Dabat','et','Amhara',11544.0,37.76,12.99).
city('Dangla','et','Amhara',22278.0,36.6,11.25).
city('Debark','et','Amhara',24704.0,37.9,13.16).
city('Debre Birhan','et','Amhara',57797.0,39.53,9.68).
city('Debre Markos','et','Amhara',59931.0,37.72,10.34).
city('Debre Sina','et','Amhara',9409.0,39.76,9.85).
city('Debre Tabor','et','Amhara',32665.0,38.01,11.86).
city('Debre Werk','et','Amhara',10579.0,38.17,10.67).
city('Dejen','et','Amhara',11739.0,38.13,10.17).
city('Dese','et','Amhara',136080.0,39.63,11.13).
city('Finote Selam','et','Amhara',23467.0,37.26,10.69).
city('Gondar','et','Amhara',153942.0,37.46,12.61).
city('Kembolcha','et','Amhara',93709.0,39.74,11.08).
city('Kemise','et','Amhara',23888.0,39.87,10.72).
city('Kobo','et','Amhara',31726.0,39.63,12.16).
city('Lalibela','et','Amhara',11152.0,39.04,12.04).
city('Motta','et','Amhara',25217.0,37.87,11.08).
city('Nefas Mewcha','et','Amhara',17813.0,38.47,11.73).
city('Sekota','et','Amhara',10414.0,39.03,12.64).
city('Shewa Robit','et','Amhara',20683.0,39.63,12.02).
city('Weldiya','et','Amhara',38179.0,39.59,11.83).
city('Were Ilu','et','Amhara',7636.0,39.43,10.6).
city('Werota','et','Amhara',26818.0,37.7,11.92).
city('Asosa','et','Benishangul',30544.0,34.53,10.07).
city('Dire Dawa','et','Diredawa',252347.0,41.86,9.59).
city('Gambela','et','Gambella',42474.0,34.59,8.25).
city('Harer','et','Harar',90226.0,42.13,9.31).
city('Abomsa','et','Oromia',15261.0,39.98,9.99).
city('Agaro','et','Oromia',28273.0,36.65,7.85).
city('Alem Maya','et','Oromia',11252.0,42.01,9.4).
city('Asasa','et','Oromia',23794.0,39.19,7.11).
city('Asbe Teferi','et','Oromia',30777.0,40.86,9.09).
city('Assela','et','Oromia',60191.0,39.14,7.95).
city('Bedele','et','Oromia',20297.0,36.35,8.45).
city('Bedesa','et','Oromia',17529.0,40.77,8.9).
city('Burayu','et','Oromia',13181.0,38.53,9.08).
city('Debre Zeyit','et','Oromia',104234.0,38.99,8.75).
city('Deder','et','Oromia',8884.0,41.44,9.31).
city('Dembi Dolo','et','Oromia',26753.0,34.79,8.53).
city('Dodola','et','Oromia',23120.0,39.18,6.97).
city('Fiche','et','Oromia',25763.0,38.73,9.8).
city('Gebre Guracha','et','Oromia',16586.0,38.41,9.8).
city('Gedo','et','Oromia',7499.0,37.45,9.02).
city('Gelemso','et','Oromia',16067.0,40.52,8.82).
city('Gimbi','et','Oromia',31815.0,35.83,9.18).
city('Ginchi','et','Oromia',17258.0,38.15,9.04).
city('Ginir','et','Oromia',16760.0,40.71,7.14).
city('Giyon','et','Oromia',38401.0,37.97,8.53).
city('Goba','et','Oromia',34375.0,39.97,7.01).
city('Gore','et','Oromia',9352.0,35.54,8.15).
city('Guder','et','Oromia',12569.0,37.77,8.97).
city('Hagere Hiywet','et','Oromia',43928.0,37.85,8.98).
city('Hagere Maryam','et','Oromia',22109.0,38.23,5.63).
city('Hirna','et','Oromia',12295.0,41.1,9.21).
city('Holeta Genet','et','Oromia',23758.0,38.5,9.07).
city('Huruta','et','Oromia',12442.0,39.35,8.15).
city('Jimma','et','Oromia',128330.0,36.83,7.68).
city('Kibre Mengist','et','Oromia',27859.0,38.98,5.88).
city('Kofele','et','Oromia',9643.0,38.78,7.08).
city('Mega','et','Oromia',6884.0,38.31,4.06).
city('Meki','et','Oromia',37658.0,38.82,8.15).
city('Mendi','et','Oromia',25267.0,35.1,9.8).
city('Metehara','et','Oromia',23408.0,39.92,8.9).
city('Metu','et','Oromia',29654.0,35.58,8.3).
city('Mojo','et','Oromia',34553.0,39.12,8.6).
city('Moyale','et','Oromia',25993.0,39.05,3.53).
city('Nazret','et','Oromia',214034.0,39.27,8.55).
city('Nedjo','et','Oromia',20170.0,35.5,9.5).
city('Negele','et','Oromia',45416.0,39.12,6.35).
city('Nekemte','et','Oromia',77327.0,36.53,9.09).
city('Robe','et','Oromia',41280.0,39.63,7.86).
city('Sebeta','et','Oromia',19537.0,38.62,8.92).
city('Sendafa','et','Oromia',7326.0,39.02,9.15).
city('Shakiso','et','Oromia',34116.0,38.91,5.75).
city('Shambu','et','Oromia',15357.0,37.1,9.57).
city('Shashemenne','et','Oromia',85886.0,38.59,7.2).
city('Sire','et','Oromia',10089.0,39.48,8.32).
city('Tulu Bolo','et','Oromia',10531.0,38.21,8.66).
city('Welenchiti','et','Oromia',18478.0,39.43,8.67).
city('Welkite','et','Oromia',30168.0,37.77,8.28).
city('Wonji','et','Oromia',17190.0,39.28,8.45).
city('Yabelo','et','Oromia',17822.0,38.08,4.89).
city('Ziway','et','Oromia',49522.0,38.71,7.93).
city('Jijiga','et','Somali',57146.0,42.79,9.35).
city('Alaba Kulito','et','Southern',25619.0,38.08,7.32).
city('Arba Minch','et','Southern',69634.0,37.55,6.04).
city('Areka','et','Southern',33187.0,37.7,7.08).
city('Awassa','et','Southern',133120.0,38.47,7.06).
city('Bako','et','Southern',17875.0,36.55,5.79).
city('Boditi','et','Southern',33068.0,37.86,6.96).
city('Bonga','et','Southern',18976.0,36.24,7.28).
city('Butajira','et','Southern',30507.0,38.37,8.12).
city('Chencha','et','Southern',7607.0,37.57,6.25).
city('Dilla','et','Southern',47029.0,38.31,6.41).
city('Gidole','et','Southern',10736.0,37.37,5.65).
city('Hossaina','et','Southern',67060.0,37.85,7.55).
city('Jinka','et','Southern',32151.0,36.65,5.65).
city('Leku','et','Southern',11398.0,38.44,6.88).
city('Mizan Teferi','et','Southern',14002.0,35.58,7.0).
city('Sawla','et','Southern',33435.0,36.88,6.3).
city('Soddo','et','Southern',53108.0,37.75,6.9).
city('Teppi','et','Southern',24196.0,35.41,7.21).
city('Wendo','et','Southern',12948.0,38.42,6.61).
city('Yirga Alem','et','Southern',36298.0,38.41,6.75).
city('Yirga Chefe','et','Southern',15988.0,38.19,6.16).
city('Abiy Adi','et','Tigray',10385.0,39.08,13.44).
city('Addigrat','et','Tigray',82546.0,39.47,14.28).
city('Adwa','et','Tigray',43582.0,38.88,14.19).
city('Aksum','et','Tigray',41256.0,38.72,14.13).
city('Alamata','et','Tigray',49082.0,39.56,12.42).
city('Endasilasie','et','Tigray',50087.0,38.28,14.1).
city('Hagere Selam','et','Tigray',5169.0,38.51,6.49).
city('Himora','et','Tigray',19708.0,36.6,14.28).
city('Korem','et','Tigray',30638.0,39.53,12.5).
city('Maychew','et','Tigray',27191.0,39.54,12.78).
city('Mekele','et','Tigray',151752.0,39.47,13.5).
city('Wikro','et','Tigray',20312.0,39.59,13.79).
city('Goose Green','fk','Falkland Islands',83.0,-58.98,-51.83).
city('Port Howard','fk','Falkland Islands',41.0,-59.52,-51.62).
city('Port Stanley','fk','Falkland Islands',2213.0,-57.82,-51.7).
city('Grytviken','fk','South Georgia',21.0,-36.51,-54.24).
city('Anirnar','fo','Klaksvik',18.0,-6.57,62.25).
city('Arnafjoreur','fo','Klaksvik',59.0,-6.52,62.25).
city('Depil','fo','Klaksvik',2.0,-6.52,62.28).
city('Hvannasund','fo','Klaksvik',271.0,-6.5,62.3).
city('Klaksvik','fo','Klaksvik',4664.0,-6.61,62.24).
city('Muli','fo','Klaksvik',4.0,-6.57,62.35).
city('Noredepil','fo','Klaksvik',170.0,-6.52,62.3).
city('Noreoyri','fo','Klaksvik',72.0,-6.53,62.22).
city('Noretoftir','fo','Klaksvik',8.0,-6.5,62.27).
city('Eiei','fo','Noreara Eysturoy',672.0,-7.08,62.31).
city('Elduvik','fo','Noreara Eysturoy',23.0,-6.9,62.28).
city('Funninfsfjare','fo','Noreara Eysturoy',68.0,-6.92,62.23).
city('Funningur','fo','Noreara Eysturoy',66.0,-6.95,62.28).
city('Gjanoyri','fo','Noreara Eysturoy',55.0,-7.03,62.24).
city('Gjov','fo','Noreara Eysturoy',53.0,-6.93,62.32).
city('Ljosa','fo','Noreara Eysturoy',33.0,-7.05,62.27).
city('Noreskali','fo','Noreara Eysturoy',238.0,-7.0,62.22).
city('Oyndarfjoreur','fo','Noreara Eysturoy',206.0,-6.83,62.28).
city('Oyrarbakki','fo','Noreara Eysturoy',104.0,-6.98,62.2).
city('Oyri','fo','Noreara Eysturoy',140.0,-6.97,62.18).
city('Svinair','fo','Noreara Eysturoy',23.0,-7.02,62.23).
city('Fugloy','fo','Noreoy',42.0,-6.28,62.33).
city('Haraldssund','fo','Noreoy',77.0,-6.6,62.27).
city('Hattarvik','fo','Noreoy',19.0,-6.25,62.33).
city('Husar','fo','Noreoy',60.0,-6.68,62.27).
city('Kirkja','fo','Noreoy',31.0,-6.3,62.32).
city('Kunoy','fo','Noreoy',70.0,-6.67,62.28).
city('Mikladalur','fo','Noreoy',60.0,-6.75,62.33).
city('Svinoy','fo','Noreoy',95.0,-6.33,62.28).
city('Syeradalur','fo','Noreoy',14.0,-6.65,62.25).
city('Trollanes','fo','Noreoy',26.0,-6.78,62.37).
city('Vieareieis','fo','Noreoy',388.0,-6.53,62.37).
city('Dalur','fo','Sandoy',45.0,-6.67,61.78).
city('Dimun','fo','Sandoy',5.0,-6.75,61.7).
city('Husavik','fo','Sandoy',82.0,-6.67,61.81).
city('Skalavik','fo','Sandoy',171.0,-6.65,61.83).
city('Skarvanes','fo','Sandoy',4.0,-6.73,61.8).
city('Skopun','fo','Sandoy',464.0,-6.87,61.9).
city('Skuvoy','fo','Sandoy',53.0,-6.8,61.77).
city('Haldarsvik','fo','Streymoy',175.0,-7.08,62.28).
city('Hestur','fo','Streymoy',44.0,-6.87,61.95).
city('Hosvik','fo','Streymoy',344.0,-6.93,62.15).
city('Hvalvik','fo','Streymoy',183.0,-7.02,62.18).
city('Kirkjubour','fo','Streymoy',81.0,-6.78,61.95).
city('Kollafjare','fo','Streymoy',1053.0,-6.88,62.13).
city('Koltur','fo','Streymoy',2.0,-6.95,61.98).
city('Kvivik','fo','Streymoy',372.0,-7.07,62.12).
city('Langasand','fo','Streymoy',33.0,-7.03,62.23).
city('Leynar','fo','Streymoy',114.0,-7.03,62.12).
city('Nesvik','fo','Streymoy',2.0,-7.02,62.22).
city('Nolsoy','fo','Streymoy',283.0,-6.67,62.02).
city('Saksun','fo','Streymoy',37.0,-7.17,62.25).
city('Skaelingur','fo','Streymoy',11.0,-7.0,62.1).
city('Streymnes','fo','Streymoy',189.0,-7.02,62.2).
city('Stykkie','fo','Streymoy',42.0,-7.03,62.11).
city('Tjornuvik','fo','Streymoy',66.0,-7.13,62.28).
city('Valur-Nesie','fo','Streymoy',49.0,-7.13,62.13).
city('Velbastaeur','fo','Streymoy',148.0,-6.83,61.98).
city('Vestmanna','fo','Streymoy',1284.0,-7.16,62.11).
city('Akrar','fo','Sueuroy',13.0,-6.75,61.45).
city('Famjin','fo','Sueuroy',111.0,-6.87,61.52).
city('Froeba','fo','Sueuroy',158.0,-6.77,61.55).
city('Hove','fo','Sueuroy',149.0,-6.73,61.52).
city('Hvalba','fo','Sueuroy',673.0,-6.95,61.6).
city('Lopra','fo','Sueuroy',124.0,-6.77,61.43).
city('Oravik','fo','Sueuroy',36.0,-6.8,61.53).
city('Porkeri','fo','Sueuroy',396.0,-6.73,61.48).
city('Sandvik','fo','Sueuroy',116.0,-6.92,61.63).
city('Sumba','fo','Sueuroy',289.0,-6.7,61.4).
city('Trongisvagsbotnur','fo','Sueuroy',427.0,-6.88,61.55).
city('Tvoroyri','fo','Sueuroy',1230.0,-6.81,61.55).
city('Vagur','fo','Sueuroy',1569.0,-6.83,61.47).
city('Vikarbyrgi','fo','Sueuroy',2.0,-6.72,61.43).
city('Fuglafjare','fo','Syera Eysturoy',1635.0,-6.8,62.25).
city('Glyvrar','fo','Syera Eysturoy',425.0,-6.72,62.13).
city('Gotueiei','fo','Syera Eysturoy',41.0,-6.77,62.18).
city('Gotugjogv','fo','Syera Eysturoy',46.0,-6.76,62.18).
city('Hellur','fo','Syera Eysturoy',30.0,-6.83,62.27).
city('Innan Glyvursnes','fo','Syera Eysturoy',86.0,-6.75,62.13).
city('Kolbanargjov','fo','Syera Eysturoy',35.0,-6.78,62.1).
city('Lambareiei','fo','Syera Eysturoy',7.0,-6.71,62.13).
city('Lambi','fo','Syera Eysturoy',148.0,-6.68,62.13).
city('Leirvik','fo','Syera Eysturoy',960.0,-6.68,62.22).
city('Morskranes','fo','Syera Eysturoy',45.0,-6.83,62.13).
city('Nes','fo','Syera Eysturoy',233.0,-6.72,62.09).
city('Noreragota','fo','Syera Eysturoy',573.0,-6.73,62.2).
city('Rituvik','fo','Syera Eysturoy',268.0,-6.67,62.1).
city('Runavik','fo','Syera Eysturoy',503.0,-6.72,62.12).
city('Saltangara','fo','Syera Eysturoy',799.0,-6.72,62.11).
city('Saltnes','fo','Syera Eysturoy',163.0,-6.73,62.1).
city('Selatrae','fo','Syera Eysturoy',71.0,-6.85,62.15).
city('Skalabotnur','fo','Syera Eysturoy',105.0,-6.85,62.2).
city('Skali','fo','Syera Eysturoy',621.0,-6.77,62.15).
city('Skipanes','fo','Syera Eysturoy',61.0,-6.75,62.17).
city('Soldarfjoreur','fo','Syera Eysturoy',360.0,-6.73,62.15).
city('Strendur','fo','Syera Ey',854.0,-6.77,62.13).
city('Syerugota','fo','Syera Eysturoy',421.0,-6.73,62.18).
city('Toftir','fo','Syera Eysturoy',854.0,-6.94,61.6).
city('Argir','fo','Torshavn',1871.0,-6.75,61.98).
city('Hoyvik','fo','Torshavn',2777.0,-6.75,62.03).
city('Hvitanes','fo','Torshavn',104.0,-6.77,62.05).
city('Kaldbak','fo','Torshavn',229.0,-6.82,62.05).
city('Kollafjoreur','fo','Torshavn',1049.0,-6.9,62.12).
city('Mjorkadalur','fo','Torshavn',1.0,-6.92,62.07).
city('Noreradalur','fo','Torshavn',19.0,-6.92,62.03).
city('Sund','fo','Torshavn',3.0,-6.83,62.05).
city('Syeradalur','fo','Torshavn',7.0,-6.9,62.2).
city('Torshavn','fo','Torshavn',13200.0,-6.8,62.03).
city('Bour','fo','Vaga',67.0,-7.35,62.08).
city('Gasadalur','fo','Vaga',17.0,-7.43,62.12).
city('Mievagur','fo','Vaga',1040.0,-7.21,62.04).
city('Mykines','fo','Vaga',25.0,-7.63,62.1).
city('Sandavagur','fo','Vaga',779.0,-7.13,62.05).
city('Sandur','fo','Vaga',608.0,-6.8,61.83).
city('Sorvag','fo','Vaga',1066.0,-7.3,62.07).
city('Vatnsoyrar','fo','Vaga',41.0,-7.23,62.07).
city('Deuba','fj','Central',1846.0,177.9,-18.25).
city('Korovou','fj','Central',309.0,178.54,-17.81).
city('Lami','fj','Central',21667.0,178.41,-18.11).
city('Namosi','fj','Central',350.0,178.13,-18.03).
city('Nausori','fj','Central',32787.0,178.53,-18.02).
city('Navua','fj','Central',5929.0,178.18,-18.22).
city('Suva','fj','Central',199457.0,178.43,-18.13).
city('Levuka','fj','Eastern',4670.0,178.82,-17.68).
city('Malhaha','fj','Eastern',235.0,177.09,-12.52).
city('Tubou','fj','Eastern',578.0,-178.8,-18.23).
city('Vunisea','fj','Eastern',253.0,178.92,-16.62).
city('Labasa','fj','Northern',33398.0,179.38,-16.47).
city('Navouvalu','fj','Northern',648.0,178.7,-16.99).
city('Savusavu','fj','Northern',7923.0,179.34,-16.78).
city('Seaqaqa','fj','Northern',432.0,179.14,-16.54).
city('Ba','fj','Western',20071.0,177.69,-17.55).
city('Lautoka','fj','Western',49332.0,177.45,-17.61).
city('Nadi','fj','Western',53784.0,177.42,-17.8).
city('Rakiraki','fj','Western',6489.0,178.25,-17.38).
city('Sigatoka','fj','Western',12191.0,177.51,-18.14).
city('Tavua','fj','Western',2650.0,177.87,-17.44).
city('Vatukoula','fj','Western',10152.0,177.85,-17.5).
city('Maarianhamina','fi','Ahvenanmaa',10682.0,19.94,60.1).
city('Aeaenekoski','fi','Central Finland',13406.0,25.69,62.61).
city('Jaemsae','fi','Central Finland',15261.0,25.18,61.86).
city('Jyvaeskylae','fi','Central Finland',85026.0,25.75,62.26).
city('Keuruu','fi','Central Finland',10942.0,24.69,62.27).
city('Laukaa','fi','Central Finland',17093.0,25.94,62.42).
city('Kokkola','fi','Central Ostrobothnia',35586.0,23.12,63.84).
city('Loviisa','fi','Eastern Uusimaa',7264.0,26.22,60.46).
city('Porvoo','fi','Eastern Uusimaa',47192.0,25.66,60.39).
city('Kajaani','fi','Kainuu',35375.0,27.73,64.23).
city('Forssa','fi','Kanta-Haeme',17852.0,23.63,60.82).
city('Haemeenlinna','fi','Kanta-Haeme',47261.0,24.45,61.0).
city('Janakkala','fi','Kanta-Haeme',15698.0,24.59,60.9).
city('Riihimaeki','fi','Kanta-Haeme',26451.0,24.79,60.74).
city('Anjalankoski','fi','Kymenlaakso',16780.0,26.8,60.69).
city('Hamina','fi','Kymenlaakso',21712.0,27.21,60.57).
city('Kotka','fi','Kymenlaakso',54616.0,26.93,60.47).
city('Kouvola','fi','Kymenlaakso',31133.0,26.7,60.88).
city('Kuusankoski','fi','Kymenlaakso',19986.0,26.61,60.92).
city('Valkeala','fi','Kymenlaakso',11059.0,26.8,60.95).
city('Kemi','fi','Lapland',22629.0,24.55,65.76).
city('Kemijaervi','fi','Lapland',9341.0,27.39,66.73).
city('Rovaniemi','fi','Lapland',34781.0,25.7,66.49).
city('Tornio','fi','Lapland',21236.0,24.17,65.86).
city('Joensuu','fi','North Karelia',53389.0,29.78,62.61).
city('Lieksa','fi','North Karelia',13704.0,30.04,63.32).
city('Haukipudas','fi','North Ostrobothnia',17298.0,25.35,65.19).
city('Kempele','fi','North Ostrobothnia',14293.0,25.5,64.92).
city('Kuusamo','fi','North Ostrobothnia',17401.0,29.18,65.96).
city('Muhos','fi','North Ostrobothnia',8232.0,25.99,64.8).
city('Nivala','fi','North Ostrobothnia',10610.0,24.96,63.92).
city('Oulainen','fi','North Ostrobothnia',8300.0,24.83,64.26).
city('Oulu','fi','North O',128618.0,25.47,65.02).
city('Raahe','fi','North Ostrobothnia',22217.0,24.48,64.69).
city('Ylivieska','fi','North Ostrobothnia',13159.0,24.53,64.08).
city('Iisalmi','fi','North Savo',22588.0,27.18,63.57).
city('Kuopio','fi','North Savo',89104.0,27.7,62.9).
city('Siilinjaervi','fi','North Savo',20210.0,27.66,63.08).
city('Varkaus','fi','North Savo',22365.0,27.91,62.32).
city('Kristiinankaupunki','fi','Ostrobothnia',7712.0,21.36,62.27).
city('Mustasaari','fi','Ostrobothnia',17176.0,21.71,63.09).
city('Pietarsaari','fi','Ostrobothnia',19238.0,22.7,63.68).
city('Uusikarlepyy','fi','Ostrobothnia',7338.0,22.53,63.52).
city('Vaasa','fi','Ostrobothnia',57014.0,21.61,63.1).
city('Heinola','fi','Paeijaet-Haeme',20849.0,26.03,61.21).
city('Hollola','fi','Paeijaet-Haeme',20405.0,25.43,61.05).
city('Lahti','fi','Paeijaet-Haeme',98826.0,25.66,60.99).
city('Nastola','fi','Paeijaet-Haeme',14911.0,25.93,60.95).
city('Orimattila','fi','Paeijaet-Haeme',14603.0,25.74,60.8).
city('Kangasala','fi','Region of Tampere',24291.0,24.08,61.47).
city('Lempaeaelae','fi','Region of Tampere',18096.0,23.74,61.32).
city('Nokia','fi','Region of Tampere',28676.0,23.48,61.49).
city('Pirkkala','fi','Region of Tampere',14914.0,23.61,61.5).
city('Tampere','fi','Region of Tampere',202688.0,23.76,61.52).
city('Valkeakoski','fi','Region of Tampere',20376.0,24.03,61.27).
city('Vammala','fi','Region of Tampere',14982.0,22.91,61.34).
city('Yloejaervi','fi','Region of Tampere',22140.0,23.6,61.55).
city('Eura','fi','Satakunta',9338.0,22.12,61.14).
city('Eurajoki','fi','Satakunta',5656.0,21.71,61.22).
city('Harjavalta','fi','Satakunta',7572.0,22.13,61.32).
city('Huittinen','fi','Satakunta',8952.0,22.7,61.19).
city('Kankaanpaeae','fi','Satakunta',12381.0,22.41,61.81).
city('Kokemaeki','fi','Satakunta',8390.0,22.33,61.26).
city('Nakkila','fi','Satakunta',5792.0,21.97,61.37).
city('Noormarkku','fi','Satakunta',6076.0,21.83,61.59).
city('Pori','fi','Satakunta',76773.0,21.77,61.49).
city('Rauma','fi','Satakunta',36550.0,21.52,61.13).
city('Saekylae','fi','Satakunta',4870.0,22.37,61.05).
city('Ulvila','fi','Satakunta',12314.0,21.87,61.44).
city('Imatra','fi','South Karelia',29615.0,28.76,61.18).
city('Joutseno','fi','South Karelia',10603.0,28.5,61.1).
city('Lappeenranta','fi','South Karelia',59276.0,28.18,61.06).
city('Ilmajoki','fi','South Ostrobothnia',11694.0,22.57,62.74).
city('Kauhajoki','fi','South Ostrobothnia',14526.0,22.18,62.44).
city('Kurikka','fi','South Ostrobothnia',10628.0,22.38,62.63).
city('Lapua','fi','South Ostrobothnia',14091.0,22.97,62.99).
city('Seinaejoki','fi','South Ostrobothnia',32149.0,22.84,62.79).
city('Mikkeli','fi','South Savo',46550.0,27.26,61.7).
city('Savonlinna','fi','South Savo',27353.0,28.91,61.87).
city('Kaarina','fi','Southwest Finland',21684.0,22.42,60.42).
city('Lieto','fi','Southwest Finland',15258.0,22.44,60.5).
city('Naantali','fi','Southwest Finland',13607.0,22.02,60.47).
city('Parainen','fi','Southwest Finland',11962.0,22.28,60.31).
city('Raisio','fi','Southwest Finland',23598.0,22.18,60.49).
city('Salo','fi','Southwest Finland',24900.0,23.13,60.39).
city('Turku','fi','Southwest Finland',175944.0,22.25,60.45).
city('Uusikaupunki','fi','Southwest Finland',16226.0,21.41,60.8).
city('Espoo','fi','Uusimaa',229528.0,24.66,60.21).
city('Hanko','fi','Uusimaa',9962.0,22.95,59.83).
city('Helsinki','fi','Uusimaa',558457.0,24.94,60.17).
city('Hyvinkaeae','fi','Uusimaa',43515.0,24.87,60.64).
city('Jaervenpaeae','fi','Uusimaa',38148.0,25.1,60.48).
city('Kerava','fi','Uusimaa',31347.0,25.11,60.41).
city('Kirkkonummi','fi','Uusimaa',32921.0,24.43,60.12).
city('Lohja','fi','Uusimaa',35960.0,24.08,60.25).
city('Maentsaelae','fi','Uusimaa',18074.0,25.3,60.65).
city('Nurmijaervi','fi','Uusimaa',37074.0,24.79,60.47).
city('Sipoo','fi','Uusimaa',19430.0,25.26,60.37).
city('Tammisaari','fi','Uusimaa',14377.0,23.44,59.98).
city('Tuusula','fi','Uusimaa',34725.0,25.03,60.4).
city('Vantaa','fi','Uusimaa',188362.0,25.04,60.29).
city('Vihti','fi','Uusimaa',26280.0,24.33,60.42).
city('Amberieu-en-Bugey','fr','Ain',12289.0,5.33,45.97).
city('Bellegarde-sur-Valserine','fr','Ain',10815.0,5.82,46.12).
city('Bourg-en-Bresse','fr','Ain',40856.0,5.21,46.21).
city('Oyonnax','fr','Ain',24712.0,5.64,46.27).
city('Chateau-Thierry','fr','Aisne',14873.0,3.4,49.05).
city('Chauny','fr','Aisne',12374.0,3.22,49.62).
city('Hirson','fr','Aisne',10529.0,4.08,49.93).
city('Laon','fr','Aisne',26340.0,3.63,49.58).
city('Saint-Quentin','fr','Aisne',58399.0,3.28,49.85).
city('Soissons','fr','Aisne',29480.0,3.32,49.39).
city('Tergnier','fr','Aisne',15296.0,3.27,49.66).
city('Cusset','fr','Allier',13359.0,3.45,46.14).
city('Montlucon','fr','Allier',39664.0,2.58,46.34).
city('Moulins','fr','Allier',21425.0,3.33,46.57).
city('Vichy','fr','Allier',25900.0,3.43,46.14).
city('Yzeure','fr','Allier',12306.0,3.35,46.57).
city('Antibes','fr','Alpes-Maritimes',75311.0,7.12,43.6).
city('Beausoleil','fr','Alpes-Maritimes',13268.0,7.41,43.75).
city('Cagnes-sur-Mer','fr','Alpes-Maritimes',46624.0,7.13,43.68).
city('Cannes','fr','Alpes-Maritimes',66687.0,7.02,43.56).
city('Carros','fr','Alpes-Maritimes',10849.0,7.18,43.8).
city('Grasse','fr','Alpes-Maritimes',46221.0,6.92,43.67).
city('La Trinite','fr','Alpes-Maritimes',10101.0,7.32,43.75).
city('Le Cannet','fr','Alpes-Maritimes',42659.0,7.01,43.59).
city('Mandelieu-la-Napoule','fr','Alpes-Maritimes',19090.0,6.93,43.56).
city('Menton','fr','Alpes-Maritimes',29199.0,7.48,43.79).
city('Mougins','fr','Alpes-Maritimes',18615.0,6.98,43.61).
city('Nice','fr','Alpes-Maritimes',341621.0,7.27,43.7).
city('Roquebrune-Cap-Martin','fr','Alpes-Maritimes',11416.0,7.47,43.77).
city('Saint-Laurent-du-Var','fr','Alpes-Maritimes',29461.0,7.21,43.68).
city('Valbonne','fr','Alpes-Maritimes',11782.0,6.99,43.64).
city('Vallauris','fr','Alpes-Maritimes',27144.0,7.04,43.58).
city('Vence','fr','Alpes-Maritimes',18399.0,7.09,43.73).
city('Villeneuve-Loubet','fr','Alpes-Maritimes',14120.0,7.1,43.66).
city('Digne-les-Bains','fr','Alpes-de-Haute-Provence',16245.0,6.23,44.1).
city('Manosque','fr','Alpes-de-Haute-Provence',20170.0,5.77,43.84).
city('Annonay','fr','Ardeche',17082.0,4.66,45.24).
city('Aubenas','fr','Ardeche',11076.0,4.36,44.63).
city('Guilherand-Granges','fr','Ardeche',10958.0,4.85,44.94).
city('Privas','fr','Ardeche',8722.0,4.58,44.73).
city('Tournon-sur-Rhone','fr','Ardeche',10314.0,4.84,45.07).
city('Charlevi','fr','Ardennes',54946.0,4.73,49.75).
city('Revin','fr','Ardennes',8770.0,4.64,49.94).
city('Sedan','fr','Ardennes',19997.0,4.92,49.7).
city('Foix','fr','Ariege',8661.0,1.6,42.97).
city('Pamier','fr','Ariege',13716.0,1.62,43.12).
city('Romilly-sur-Seine','fr','Aube',14158.0,3.72,48.52).
city('Saint-Andre-les-Vergers','fr','Aube',11085.0,4.06,48.29).
city('Sainte-Savine','fr','Aube',10631.0,4.04,48.31).
city('Troyes','fr','Aube',61903.0,4.08,48.3).
city('Carcassonne','fr','Aude',4469.0,2.34,43.22).
city('Castelnaudary','fr','Aude',10730.0,1.95,43.32).
city('Limoux','fr','Aude',9353.0,2.21,43.06).
city('Narbonne','fr','Aude',47433.0,2.9,43.19).
city('Millau','fr','Aveyron',21215.0,3.07,44.11).
city('Onet-le-Chataeu','fr','Aveyron',10137.0,2.54,44.39).
city('Rodez','fr','Aveyron',23268.0,2.57,44.36).
city('Villefranche-de-Rouergue','fr','Aveyron',11775.0,2.02,44.36).
city('Bischheim','fr','Bas-Rhin',17164.0,7.75,48.61).
city('Bischwiller','fr','Bas-Rhin',12109.0,7.85,48.77).
city('Haguenau','fr','Bas-Rhin',35807.0,7.78,48.82).
city('Hoenheim','fr','Bas-Rhin',10834.0,7.75,48.63).
city('Illkirch-Graffenstaden','fr','Bas-Rhin',25023.0,7.7,48.53).
city('Lingolsheim','fr','Bas-Rhin',17242.0,7.68,48.56).
city('Obernai','fr','Bas-Rhin',11146.0,7.49,48.47).
city('Ostwald','fr','Bas-Rhin',11224.0,7.72,48.55).
city('Saverne','fr','Bas-Rhin',11925.0,7.36,48.75).
city('Schiltigheim','fr','Bas-Rhin',32138.0,7.74,48.6).
city('Selestat','fr','Bas-Rhin',18457.0,7.44,48.26).
city('Strasbourg','fr','Bas-Rhin',273506.0,7.76,48.58).
city('Aix-en-Provence','fr','Bouches-du-Rhone',142133.0,5.44,43.53).
city('Allauch','fr','Bouches-du-Rhone',21156.0,5.48,43.34).
city('Arles','fr','Bouches-du-Rhone',49925.0,4.63,43.69).
city('Aubagne','fr','Bouches-du-Rhone',43979.0,5.56,43.29).
city('Berre-lEtang','fr','Bouches-du-Rhone',14042.0,5.17,43.49).
city('Bouc-Bel-Air','fr','Bouches-du-Rhone',12946.0,5.42,43.45).
city('Chateauneuf-les-Martigues','fr','Bouches-du-Rhone',11225.0,5.15,43.39).
city('Chateaurenard','fr','Bouches-du-Rhone',14088.0,4.84,43.88).
city('Fos-sur-Mer','fr','Bouches-du-Rhone',15783.0,4.95,43.44).
city('Gardanne','fr','Bouches-du-Rhone',20541.0,5.45,43.45).
city('Istres','fr','Bouches-du-Rhone',42036.0,4.98,43.51).
city('La Ciotat','fr','Bouches-du-Rhone',32596.0,5.59,43.18).
city('Les Pennes-Mirabeau','fr','Bouches-du-Rhone',19515.0,5.31,43.41).
city('Marignane','fr','Bouches-du-Rhone',35453.0,5.22,43.42).
city('Marseille','fr','Bouches-du-Rhone',792823.0,5.37,43.31).
city('Martigues','fr','Bouches-du-Rhone',44437.0,5.04,43.41).
city('Miramas','fr','Bouches-du-Rhone',23354.0,4.99,43.59).
city('Plan-de-Cuques','fr','Bouches-du-Rhone',10995.0,5.48,43.35).
city('Port-de-Bouc','fr','Bouches-du-Rhone',15621.0,4.97,43.42).
city('Rognac','fr','Bouches-du-Rhone',12096.0,5.23,43.49).
city('Saint-Martin-de-Crau','fr','Bouches-du-Rhone',11117.0,4.8,43.65).
city('Saint-Remy-de-Provence','fr','Bouches-du-Rhone',10211.0,4.82,43.8).
city('Salon-de-Provence','fr','Bouches-du-Rhone',39598.0,5.08,43.66).
city('Septemes-les-Vallons','fr','Bouches-du-Rhone',10165.0,5.37,43.41).
city('Tarascon','fr','Bouches-du-Rhone',14080.0,4.65,43.82).
city('Vitrolles','fr','Bouches-du-Rhone',38052.0,5.24,43.47).
city('Bayeux','fr','Calvados',15286.0,-0.7,49.28).
city('Caen','fr','Calvados',115358.0,-0.36,49.19).
city('Herouville-Saint-Clair','fr','Calvados',23792.0,-0.34,49.21).
city('Lisieux','fr','Calvados',23100.0,0.26,49.15).
city('Mondeville','fr','Calvados',11193.0,-0.29,49.17).
city('Vire','fr','Calvados',12898.0,-0.89,48.86).
city('Aurillac','fr','Cantal',30652.0,2.43,44.92).
city('Angouleme','fr','Charente',43509.0,0.15,45.66).
city('Cognac','fr','Charente',19585.0,-0.33,45.69).
city('Soyaux','fr','Charente',10156.0,0.19,45.65).
city('La Rochelle','fr','Charente-Maritime',80406.0,-1.18,46.17).
city('Rochefort','fr','Charente-Maritime',26150.0,-0.96,45.95).
city('Royan','fr','Charente-Maritime',17408.0,-0.99,45.63).
city('Saintes','fr','Charente-Maritime',25616.0,-0.62,45.75).
city('Bourges','fr','Cher',71500.0,2.39,47.08).
city('Saint-Amand-Montrond','fr','Cher',11259.0,2.49,46.72).
city('Saint-Doulchard','fr','Cher',9058.0,2.35,47.11).
city('Vierzon','fr','Cher',28503.0,2.06,47.22).
city('Brive-la-Gaillarde','fr','Correze',49092.0,1.51,45.16).
city('Tulle','fr','Correze',14728.0,1.76,45.26).
city('Ussel','fr','Correze',10420.0,2.3,45.55).
city('Ajaccio','fr','Corse-du-Sud',51058.0,8.73,41.93).
city('Porto-Vecchio','fr','Corse-du-Sud',11065.0,9.27,41.6).
city('Beaune','fr','Cote-dOr',22573.0,4.83,47.03).
city('Chenove','fr','Cote-dOr',15551.0,5.0,47.29).
city('Dijon','fr','Cote-dOr',153692.0,5.03,47.33).
city('Quetigny','fr','Cote-dOr',9628.0,5.11,47.31).
city('Talant','fr','Cote-dOr',11877.0,5.01,47.33).
city('Dinan','fr','Cotes-dArmor',10257.0,-2.06,48.47).
city('Lamballe','fr','Cotes-dArmor',11085.0,-2.52,48.47).
city('Lannion','fr','Cotes-dArmor',19495.0,-3.47,48.75).
city('Loudeac','fr','Cotes-dArmor',9177.0,-2.77,48.19).
city('Plerin','fr','Cotes-dArmor',12890.0,-2.77,48.55).
city('Ploufragan','fr','Cotes-dArmor',10651.0,-2.79,48.49).
city('Saint-Brieuc','fr','Cotes-dArmor',43522.0,-2.77,48.52).
city('Gueret','fr','Creuse',13834.0,1.87,46.17).
city('Bressuire','fr','Deux-Sevres',17952.0,-0.5,46.85).
city('Niort','fr','Deux-Sevres',56715.0,-0.47,46.32).
city('Parthenay','fr','Deux-Sevres',10352.0,-0.26,46.65).
city('Thouars','fr','Deux-Sevres',10601.0,-0.22,46.99).
city('Bergerac','fr','Dordogne',25766.0,0.48,44.86).
city('Perigueux','fr','Dordogne',30198.0,0.71,45.18).
city('Sarlat-la-Caneda','fr','Dordogne',9670.0,1.2,44.9).
city('Audincourt','fr','Doubs',15114.0,6.83,47.49).
city('Besancon','fr','Doubs',120139.0,6.02,47.24).
city('Montbeliard','fr','Doubs',26895.0,6.82,47.52).
city('Pontarlier','fr','Doubs',18665.0,6.35,46.91).
city('Valentigney','fr','Doubs',12221.0,6.83,47.46).
city('Bourg-les-Valence','fr','Drome',18645.0,4.88,44.96).
city('Montelimar','fr','Drome',32631.0,4.74,44.57).
city('Pierrelatte','fr','Drome',12201.0,4.68,44.38).
city('Romans-sur-Isere','fr','Drome',32933.0,5.04,45.06).
city('Valence','fr','Drome',63754.0,4.89,44.94).
city('Athis-Mons','fr','Essonne',30025.0,2.38,48.71).
city('Bretigny-sur-Orge','fr','Essonne',23336.0,2.3,48.62).
city('Brunoy','fr','Essonne',23418.0,2.49,48.71).
city('Bures-sur-Yvette','fr','Essonne',10115.0,2.17,48.7).
city('Chilly-Mazarin','fr','Essonne',18523.0,2.31,48.71).
city('Corbeil-Essonnes','fr','Essonne',38760.0,2.47,48.61).
city('Courcouronnes','fr','Essonne',14617.0,2.42,48.62).
city('Dourdan','fr','Essonne',10036.0,2.01,48.54).
city('Draveil','fr','Essonne',28638.0,2.41,48.68).
city('Epinay-sous-Senart','fr','Essonne',12620.0,2.51,48.68).
city('Epinay-sur-Orge','fr','Essonne',9351.0,2.33,48.67).
city('Etampes','fr','Essonne',22399.0,2.16,48.44).
city('Evry','fr','Essonne',51978.0,2.44,48.64).
city('Fleury-Merogis','fr','Essonne',8834.0,2.37,48.64).
city('Gif-sur-Yvette','fr','Essonne',22774.0,2.13,48.68).
city('Grigny','fr','Essonne',24600.0,2.39,48.65).
city('Igny','fr','Essonne',9484.0,2.21,48.74).
city('Juvisy-sur-Orge','fr','Essonne',12185.0,2.38,48.68).
city('Les Ulis','fr','Essonne',25297.0,2.17,48.67).
city('Longjumeau','fr','Essonne',20301.0,2.29,48.71).
city('Massy','fr','Essonne',37529.0,2.27,48.72).
city('Mennecy','fr','Essonne',14216.0,2.41,48.56).
city('Mo','fr','Essonne',22319.0,2.44,48.7).
city('Morangis','fr','Essonne',11145.0,2.33,48.7).
city('Morsang-sur-Orge','fr','Essonne',19567.0,2.34,48.67).
city('Orsay','fr','Essonne',17418.0,2.18,48.7).
city('Palaiseau','fr','Essonne',29749.0,2.25,48.73).
city('Ris-Orangis','fr','Essonne',24628.0,2.41,48.66).
city('Saint-Michel-sur-Orge','fr','Essonne',20413.0,2.3,48.64).
city('Sainte-Genevieve-des-Bois','fr','Essonne',33133.0,2.32,48.64).
city('Savigny-sur-Orge','fr','Essonne',38818.0,2.35,48.69).
city('Verrieres-le-Buisson','fr','Essonne',16288.0,2.26,48.75).
city('Vigneux-sur-Seine','fr','Essonne',26310.0,2.41,48.7).
city('Villebon-sur-Yvette','fr','Essonne',9700.0,2.25,48.7).
city('Viry-Chatillon','fr','Essonne',30479.0,2.37,48.67).
city('Yerres','fr','Essonne',28052.0,2.49,48.72).
city('Bernay','fr','Eure',11491.0,0.6,49.1).
city('Evreux','fr','Eure',53040.0,1.14,49.03).
city('Gisors','fr','Eure',12062.0,1.77,49.28).
city('Louviers','fr','Eure',18401.0,1.17,49.22).
city('Pont-Audemer','fr','Eure',9125.0,0.5,49.35).
city('Val-de-Reuil','fr','Eure',14817.0,1.2,49.28).
city('Vernon','fr','Eure',24688.0,1.47,49.1).
city('Chartres','fr','Eure-et-Loir',41229.0,1.48,48.46).
city('Chateaudun','fr','Eure-et-Loir',14786.0,1.34,48.08).
city('Dreux','fr','Eure-et-Loir',30303.0,1.37,48.74).
city('Luce','fr','Eure-et-Loir',17295.0,1.45,48.44).
city('Mainvillier','fr','Eure-et-Loir',10211.0,1.45,48.45).
city('Nogent-le-Rotrou','fr','Eure-et-Loir',11657.0,0.82,48.33).
city('Vernouillet','fr','Eure-et-Loir',11554.0,1.98,48.98).
city('Brest','fr','Finistere',150554.0,-4.5,48.39).
city('Concarneau','fr','Finistere',20178.0,-3.93,47.87).
city('Douarnenez','fr','Finistere',15580.0,4.35,48.1).
city('Guipavas','fr','Finistere',13109.0,-4.4,48.43).
city('Landerneau','fr','Finistere',14419.0,-4.26,48.46).
city('Le Relecq-Kerhoun','fr','Finistere',11160.0,-4.41,48.41).
city('Morlaix','fr','Finistere',15696.0,-3.84,48.58).
city('Plougastel-Daoulas','fr','Finistere',13128.0,-4.38,48.38).
city('Plouzane','fr','Finistere',12588.0,-4.62,48.39).
city('Quimper','fr','Finiste',66251.0,-4.11,47.99).
city('Quimperle','fr','Finistere',11015.0,-3.55,47.87).
city('Ales','fr','Gard',38661.0,4.08,44.13).
city('Bagnols-sur-Ceze','fr','Gard',18497.0,4.62,44.17).
city('Beaucaire','fr','Gard',14162.0,4.64,43.82).
city('Nimes','fr','Gard',137532.0,4.35,43.84).
city('Pont-Saint-Esprit','fr','Gard',9382.0,4.63,44.26).
city('Saint-Gilles','fr','Gard',11995.0,4.42,43.69).
city('Vauvert','fr','Gard',10377.0,4.26,43.7).
city('Villeneuve-les-Avignon','fr','Gard',12688.0,4.79,43.98).
city('Auch','fr','Gers',21221.0,0.58,43.65).
city('Ambares-et-Lagrave','fr','Gironde',12041.0,-0.49,44.92).
city('Arcachon','fr','Gironde',11391.0,-1.18,44.66).
city('Begles','fr','Gironde',22658.0,-0.54,44.8).
city('Blanquefort','fr','Gironde',14791.0,-0.63,44.94).
city('Bordeaux','fr','Gironde',219311.0,-0.58,44.84).
city('Bruges','fr','Gironde',12117.0,-0.62,44.89).
city('Cenon','fr','Gironde',21483.0,-0.53,44.85).
city('Cestas','fr','Gironde',17230.0,-0.69,44.75).
city('Eysines','fr','Gironde',19925.0,-0.66,44.88).
city('Floirac','fr','Gironde',15928.0,-0.54,44.84).
city('Gradignan','fr','Gironde',22760.0,-0.62,44.76).
city('Gujan-Mestras','fr','Gironde',17953.0,-1.07,44.64).
city('La Teste-de-Buch','fr','Gironde',25116.0,-1.16,44.63).
city('Le Bouscat','fr','Gironde',23331.0,-0.62,44.87).
city('Libourne','fr','Gironde',22514.0,-0.25,44.92).
city('Lormont','fr','Gironde',21437.0,-0.53,44.87).
city('Merignac','fr','Gironde',65847.0,-0.65,44.87).
city('Pessac','fr','Gironde',59818.0,-0.66,44.8).
city('Saint-Medard-en-Jalles','fr','Gironde',28405.0,-0.72,44.9).
city('Talence','fr','Gironde',39514.0,-0.57,44.82).
city('Villenave-dOrnon','fr','Gironde',29114.0,-0.56,44.76).
city('Cernay','fr','Haut-Rhin',10614.0,7.17,47.81).
city('Colmar','fr','Haut-Rhin',66637.0,7.36,48.08).
city('Guebwiller','fr','Haut-Rhin',12005.0,7.21,47.92).
city('Illzach','fr','Haut-Rhin',14729.0,7.33,47.79).
city('Kingersheim','fr','Haut-Rhin',12528.0,7.32,47.8).
city('Mulhouse','fr','Haut-Rhin',111972.0,7.34,47.76).
city('Riediesheim','fr','Haut-Rhin',12348.0,7.35,47.75).
city('Rixheim','fr','Haut-Rhin',13348.0,7.4,47.77).
city('Saint-Louis','fr','Haut-Rhin',20387.0,7.55,47.6).
city('Wittelsheim','fr','Haut-Rhin',10164.0,7.21,47.85).
city('Wittenheim','fr','Haut-Rhin',15612.0,7.32,47.82).
city('Bastia','fr','Haute-Corse',37668.0,9.46,42.71).
city('Balma','fr','Haute-Garonne',13955.0,1.5,43.61).
city('Blagnac','fr','Haute-Garonne',23313.0,1.39,43.63).
city('Colomiers','fr','Haute-Garonne',29888.0,1.33,43.62).
city('Cugnaux','fr','Haute-',14348.0,1.35,43.54).
city('LUnion','fr','Haute-Garonne',12527.0,1.48,43.66).
city('Muret','fr','Haute-Garonne',22819.0,1.31,43.47).
city('Plaisance-du-Touch','fr','Haute-Garonne',17770.0,1.3,43.57).
city('Ramonville-Saint-Agne','fr','Haute-Garonne',11732.0,1.47,43.55).
city('Saint-Gaudens','fr','Haute-Garonne',10698.0,0.7,43.12).
city('Saint-Orens-de-Gameville','fr','Haute-Garonne',12024.0,1.53,43.56).
city('Toulouse','fr','Haute-Garonne',411145.0,1.45,43.62).
city('Tournefeuille','fr','Haute-Garonne',28022.0,1.34,43.59).
city('Le Puy-en-Velay','fr','Haute-L',19791.0,3.88,45.05).
city('Chaumont','fr','Haute-Marne',25562.0,5.14,48.11).
city('Langres','fr','Haute-Marne',9416.0,5.33,47.86).
city('Saint-Dizier','fr','Haute-Marne',29573.0,4.95,48.65).
city('Hericourt','fr','Haute-Saone',10488.0,6.74,47.58).
city('Lure','fr','Haute-Saone',8736.0,6.49,47.69).
city('Luxeuil-les-Bains','fr','Haute-Saone',8261.0,6.37,47.82).
city('Vesoul','fr','Haute-Saone',17050.0,6.15,47.63).
city('Annecy','fr','Haute-Savoie',51119.0,6.12,45.91).
city('Annecy-le-Vieux','fr','Haute-Savoie',20103.0,6.15,45.92).
city('Annemasse','fr','Haute-Savoie',27386.0,6.22,46.2).
city('Bonneville','fr','Haute-Savoie',10931.0,6.4,46.09).
city('Chamonix-Mont-Blanc','fr','Haute-Savoie',10061.0,6.85,45.93).
city('Cluses','fr','Haute-Savoie',18907.0,6.6,46.06).
city('Cran-Gevrier','fr','Haute-Savoie',17317.0,6.1,45.9).
city('Passy','fr','Haute-Savoie',10859.0,6.68,45.93).
city('Rumilly','fr','Haute-Savoie',12278.0,5.94,45.87).
city('Sallanches','fr','Haute-Savoie',15747.0,6.62,45.94).
city('Seynod','fr','Haute-Savoie',17733.0,6.07,45.88).
city('Thonon-les-Bains','fr','Haute-Savoie',29698.0,6.46,46.38).
city('Gaillard','fr','Haute-Vienne',10253.0,6.21,46.19).
city('Limoges','fr','Haute-Vienne',134549.0,1.25,45.83).
city('Saint-Junien','fr','Haute-Vienne',10779.0,0.89,45.89).
city('Briancon','fr','Hautes-Alpes',10627.0,6.62,44.91).
city('Gap','fr','Hautes-Alpes',38617.0,6.08,44.57).
city('Lourdes','fr','Hautes-Pyrenees',14671.0,-0.05,43.1).
city('Tarbes','fr','Hautes-Pyrenees',45628.0,0.08,43.24).
city('Antony','fr','Hauts-de-Seine',61595.0,2.3,48.76).
city('Asnieres-','fr','Hauts-de-Seine',78675.0,2.29,48.91).
city('Bagneux','fr','Hauts-de-Seine',38003.0,2.3,48.79).
city('Bois-Colombes','fr','Hauts-de-Seine',23663.0,2.27,48.92).
city('Boulogne-Billancourt','fr','Hauts-de-Seine',109765.0,2.24,48.83).
city('Bourg-la-Reine','fr','Hauts-de-Seine',18179.0,2.3,48.78).
city('Chatenay-Malabry','fr','Hauts-de-Seine',31708.0,2.27,48.78).
city('Chatillon','fr','Hauts-de-Seine',30261.0,2.29,48.81).
city('Chaville','fr','Hauts-de-Seine',18166.0,2.17,48.81).
city('Clamart','fr','Hauts-de-Seine',49508.0,2.26,48.8).
city('Clichy','fr','Hauts-de-Seine',50908.0,2.3,48.91).
city('Colombes','fr','Hauts-de-Seine',76209.0,2.25,48.93).
city('Courbevoie','fr','Hauts-de-Seine',70896.0,2.25,48.9).
city('Fontenay-aux-Roses','fr','Hauts-de-Seine',23784.0,2.28,48.78).
city('Garches','fr','Hauts-de-Seine',18170.0,2.17,48.84).
city('Gennevillers','fr','Hauts-de-Seine',41553.0,2.29,48.94).
city('Issy-les-Moulineaux','fr','Hauts-de-Seine',57127.0,2.26,48.83).
city('La Garenne-Colombes','fr','Hauts-de-Seine',25781.0,2.24,48.91).
city('Le Plessis-Robinson','fr','Hauts-de-Seine',21931.0,2.25,48.78).
city('Levallois','fr','Hauts-de-Seine',59434.0,2.29,48.9).
city('Malakoff','fr','Hauts-de-Seine',28583.0,2.3,48.82).
city('Meudon','fr','Hauts-de-Seine',42802.0,2.24,48.82).
city('Montrouge','fr','Hauts-de-Seine',37670.0,2.32,48.81).
city('Nanterre','fr','Hauts-de-Seine',84448.0,2.2,48.9).
city('Neuilly-sur-Seine','fr','Hauts-de-Seine',57141.0,2.27,48.89).
city('Puteaux','fr','Hauts-de-Seine',39752.0,2.23,48.88).
city('Rueil-Malmaison','fr','Hauts-de-Seine',78645.0,2.17,48.89).
city('Saint-Cloud','fr','Hauts-de-Seine',28009.0,2.19,48.84).
city('Sceaux','fr','Hauts-de-Seine',20564.0,2.29,48.78).
city('Sevres','fr','Hauts-de-Seine',22993.0,2.21,48.82).
city('Suresnes','fr','Hauts-de-Seine',42243.0,2.22,48.87).
city('Vanves','fr','Hauts-de-Seine',25184.0,2.27,48.83).
city('Ville-dAvray','fr','Hauts-de-Seine',11341.0,2.17,48.82).
city('Villeneuve-la-Garenne','fr','Hauts-de-Seine',21557.0,2.3,48.93).
city('Agde','fr','Herault',21950.0,3.46,43.33).
city('Beziers','fr','Herault',68264.0,3.21,43.35).
city('Castelnau-le-Lez','fr','Herault',16890.0,3.89,43.64).
city('Frontignan','fr','Herault',21511.0,3.74,43.46).
city('Lattes','fr','Herault',16857.0,3.9,43.57).
city('Lunel','fr','Herault',25598.0,4.13,43.69).
city('Mauguio','fr','Herault',17688.0,4.01,43.62).
city('Montpellier','fr','Herault',238887.0,3.87,43.61).
city('Sete','fr','Herault',38788.0,3.68,43.41).
city('Cesson-Sevigne','fr','Ille-et-Vilaine',15651.0,-1.62,48.12).
city('Dinard','fr','Ille-et-Vilaine',10880.0,-2.07,48.64).
city('Fougeres','fr','Ille-et-Vilaine',21710.0,-1.22,48.36).
city('Rennes','fr','Ille-et-Vilaine',213334.0,-1.68,48.11).
city('Saint-Malo','fr','Ille-et-Vilaine',52909.0,-2.01,48.66).
city('Vitre','fr','Ille-et-Vilaine',16026.0,-1.23,48.13).
city('Chateauroux','fr','Indre',49170.0,1.7,46.81).
city('Issoudun','fr','Indre',13676.0,2.0,46.95).
city('Amboise','fr','Indre-et-Loire',11896.0,0.98,47.41).
city('Joue-les-Tours','fr','Indre-et-Loire',36725.0,0.65,47.36).
city('Saint-Avertin','fr','Indre-et-Loire',15619.0,0.73,47.36).
city('Saint-Cyr-sur-Loire','fr','Indre-et-Loire',16907.0,0.65,47.4).
city('Saint-Pierre-des-Corps','fr','Indre-et-Loire',14679.0,0.72,47.39).
city('Tours','fr','Indre-et-Loire',135143.0,0.69,47.38).
city('Bourgoin-Jallieu','fr','Isere',23568.0,5.27,45.6).
city('Echirolles','fr','Isere',32133.0,5.71,45.15).
city('Fontaine','fr','Isere',23869.0,5.65,45.18).
city('Grenoble','fr','Isere',154853.0,5.72,45.19).
city('Le Pont-de-Claix','fr','Isere',11597.0,5.69,45.12).
city('Meylan','fr','Isere',19569.0,5.75,45.22).
city('Saint-Egreve','fr','Isere',15479.0,5.68,45.23).
city('Saint-Martin-dHeres','fr','Isere',37060.0,5.75,45.17).
city('Seyssinet-Pariset','fr','Isere',13135.0,5.67,45.17).
city('Vienne','fr','Isere',30651.0,4.87,45.53).
city('Villefontaine','fr','Isere',19076.0,5.15,45.61).
city('Voiron','fr','Isere',20795.0,5.57,45.38).
city('Champagnole','fr','Jura',8313.0,5.89,46.75).
city('Dole','fr','Jura',24186.0,5.48,47.1).
city('Lons-le-Saunier','fr','Jura',18245.0,5.53,46.68).
city('Saint-Claude','fr','Jura',12169.0,5.86,46.41).
city('Biscarrosse','fr','Landes',9515.0,-1.17,44.4).
city('Dax','fr','Landes',19827.0,-1.04,43.73).
city('Mont-de-Marsan','fr','Landes',30529.0,-0.51,43.9).
city('Saint-Paul-les-Dax','fr','Landes',10850.0,-1.04,43.75).
city('Tarnos','fr','Landes',10850.0,-1.48,43.55).
city('Blois','fr','Loir-et-Cher',49510.0,1.32,47.59).
city('Romorantin-Lanthenay','fr','Loir-et-Cher',18856.0,1.74,47.36).
city('Vendome','fr','Loir-et-Cher',18006.0,1.07,47.79).
city('Andrezieux-Boutheon','fr','Loire',9079.0,4.26,45.53).
city('Firminy','fr','Loire',17356.0,4.28,45.4).
city('La Ricamarie','fr','Loire',7527.0,4.35,45.41).
city('Le Chambon-Feugerolles','fr','Loire',13080.0,4.31,45.39).
city('Montbrison','fr','Loire',15072.0,4.05,45.61).
city('Riorges','fr','Loire',10303.0,4.04,46.05).
city('Rive-de-Gier','fr','Loire',13733.0,4.67,45.57).
city('Roanne','fr','Loire',37144.0,4.07,46.05).
city('Roche-la-Moliere','fr','Loire',10160.0,4.32,45.44).
city('Saint-Chamond','fr','Loire',36734.0,4.5,45.49).
city('Saint-Etienne','fr','Loire',170416.0,4.39,45.43).
city('Saint-Just-Saint-Rambert','fr','Loire',13923.0,4.25,45.5).
city('Bouguenais','fr','Loire-Atlantique',16135.0,-1.62,47.18).
city('Carquefou','fr','Loire-Atlantique',17387.0,-1.5,47.3).
city('Chateaubriant','fr','Loire-Atlantique',11748.0,6.15,43.14).
city('Coueron','fr','Loire-Atlantique',19016.0,-1.73,47.22).
city('Guerande','fr','Loire-Atlantique',15124.0,-2.43,47.33).
city('La Baule-Escoublac','fr','Loire-Atlantique',16658.0,-2.4,47.29).
city('La Chapelle-sur-Erdre','fr','Loire-Atlantique',17646.0,-1.56,47.31).
city('Nantes','fr','Loire-Atlantique',284677.0,-1.57,47.23).
city('Orvault','fr','Loire-Atlantique',24080.0,-1.62,47.27).
city('Reze','fr','Loire-Atlantique',37338.0,-1.54,47.19).
city('Saint-Herblain','fr','Loire-Atlantique',44790.0,-1.65,47.21).
city('Saint-Nazaire','fr','Loire-Atlantique',66937.0,-2.22,47.28).
city('Saint-Sebastien-sur-Loire','fr','Loire-Atlantique',27631.0,-1.51,47.22).
city('Sainte-Luce-sur-Loire','fr','Loire-Atlantique',12550.0,-1.5,47.25).
city('Vertou','fr','Loire-Atlantique',21897.0,-1.48,47.17).
city('Amilly','fr','Loiret',11965.0,2.78,47.97).
city('Chalette-sur-Loing','fr','Loiret',13771.0,2.73,48.02).
city('Fleury-les-Aubrais','fr','Loiret',20981.0,1.93,47.93).
city('Gien','fr','Loiret',14842.0,2.63,47.69).
city('Montargis','fr','Loiret',15048.0,2.73,48.01).
city('Olivet','fr','Loiret',20579.0,1.9,47.86).
city('Orleans','fr','Loiret',118190.0,1.9,47.9).
city('Pithiviers','fr','Loiret',9313.0,2.25,48.18).
city('Saint-Jean-de-Braye','fr','Loiret',18949.0,1.95,47.91).
city('Saint-Jean-de-la-Ruelle','fr','Loiret',16931.0,1.89,47.91).
city('Saran','fr','Loiret',15983.0,1.88,47.95).
city('Cahors','fr','Lot',20336.0,1.44,44.46).
city('Figeac','fr','Lot',9720.0,2.01,44.61).
city('Agen','fr','Lot-et-Garonne',30236.0,0.62,44.2).
city('Le Passage','fr','Lot-et-Garonne',8887.0,5.5,45.52).
city('Marmande','fr','Lot-et-Garonne',17143.0,0.15,44.5).
city('Tonneins','fr','Lot-et-Garonne',8951.0,0.31,44.39).
city('Villeneuve-sur-Lot','fr','Lot-et-Garonne',22933.0,0.7,44.42).
city('Mende','fr','Lozere',12214.0,3.48,44.52).
city('Angers','fr','Maine-et-Loire',158585.0,-0.54,47.48).
city('Avrille','fr','Maine-et-Loire',13219.0,-0.58,47.51).
city('Cholet','fr','Maine-et-Loire',54292.0,-0.88,47.07).
city('Les Ponts-de-Ce','fr','Maine-et-Loire',11757.0,-0.52,47.42).
city('Saint-Barthelemy-dAnjou','fr','Maine-et-Loire',10259.0,-0.51,47.47).
city('Saumur','fr','Maine-et-Loire',30036.0,-0.08,47.27).
city('Trelaze','fr','Maine-et-Loire',11481.0,-0.47,47.46).
city('Cherbourg','fr','Manche',24435.0,-1.63,49.64).
city('Coutances','fr','Manche',9503.0,-1.45,49.06).
city('Equeurdreville-Hainneville','fr','Manche',18316.0,-1.65,49.66).
city('Granville','fr','Manche',13003.0,-1.59,48.85).
city('Octeville','fr','Manche',16417.0,-1.65,49.61).
city('Saint-Lo','fr','Manche',19411.0,-1.11,49.13).
city('Tourlaville','fr','Manche',17763.0,-1.57,49.63).
city('Chalons-en-Champagne','fr','Marne',46981.0,4.36,48.97).
city('Epernay','fr','Marne',25573.0,3.95,49.04).
city('Reims','fr','Marne',192688.0,4.03,49.25).
city('Tinqueux','fr','Marne',10137.0,3.97,49.25).
city('Vitry-le-Francois','fr','Marne',16714.0,4.59,48.73).
city('Chateau-Gontier','fr','Mayenne',11267.0,-0.71,47.83).
city('Laval','fr','Mayenne',51626.0,-0.78,48.07).
city('Mayenne','fr','Mayenne',13969.0,-0.62,48.31).
city('Dombasle-sur-Meurthe','fr','Meurthe-et-Moselle',8896.0,6.35,48.63).
city('Jarville-la-Malgrange','fr','Meurthe-et-Moselle',9658.0,6.22,48.68).
city('Laxou','fr','Meurthe-et-Moselle',15264.0,6.15,48.69).
city('Longwy','fr','Meurthe-et-Moselle',13971.0,5.76,49.53).
city('Luneville','fr','Meurthe-et-Moselle',20017.0,6.49,48.6).
city('Nancy','fr','Meurthe-et-Moselle',106857.0,6.17,48.69).
city('Pont-a-Mousson','fr','Meurthe-et-Moselle',14657.0,6.05,48.91).
city('Saint-Max','fr','Meurthe-et-Moselle',10926.0,6.2,48.71).
city('Toul','fr','Meurthe-et-Moselle',16848.0,5.88,48.68).
city('Vandoeuvre-les-Nancy','fr','Meurthe-et-Moselle',31012.0,6.17,48.65).
city('Villers-les-Nancy','fr','Meurthe-et-Moselle',15296.0,6.14,48.67).
city('Villerupt','fr','Meurthe-et-Moselle',9514.0,5.93,49.48).
city('Bar-le-Duc','fr','Meuse',16686.0,5.17,48.78).
city('Verdun','fr','Meuse',19048.0,5.39,49.17).
city('Auray','fr','Morbihan',11425.0,-3.01,47.68).
city('Hennebont','fr','Morbihan',13423.0,-3.26,47.82).
city('Lanester','fr','Morbihan',22065.0,-3.35,47.77).
city('Lorient','fr','Morbihan',59242.0,-3.0,47.74).
city('Ploemeur','fr','Morbihan',18944.0,-3.43,47.73).
city('Pontivy','fr','Morbihan',13789.0,-2.98,48.06).
city('Vannes','fr','Morbihan',56649.0,-2.76,47.66).
city('Amneville','fr','Moselle',9640.0,6.14,49.26).
city('Behren-les-Forbach','fr','Moselle',10010.0,6.95,49.17).
city('Creutzwald','fr','Moselle',13970.0,6.7,49.2).
city('Fameck','fr','Moselle',11966.0,6.12,49.3).
city('Florange','fr','Moselle',10533.0,6.12,49.33).
city('Forbach','fr','Moselle',20938.0,6.9,49.19).
city('Freyming-Merleb','fr','Moselle',14173.0,6.79,49.15).
city('Hagondange','fr','Moselle',8935.0,6.17,49.25).
city('Hayange','fr','Moselle',14729.0,6.06,49.33).
city('Hombourg-Haut','fr','Moselle',9522.0,6.78,49.12).
city('Maizieres-les-Metz','fr','Moselle',9708.0,6.15,49.21).
city('Marly','fr','Moselle',10637.0,6.15,49.07).
city('Metz','fr','Moselle',128021.0,6.18,49.12).
city('Montigny-les-Metz','fr','Moselle',24655.0,6.15,49.1).
city('Moyeuvre-Grande','fr','Moselle',8826.0,6.06,49.26).
city('Rombas','fr','Moselle',10764.0,6.1,49.25).
city('Saint-Avold','fr','Moselle',17340.0,6.71,49.11).
city('Sarrebourg','fr','Moselle',13458.0,7.05,48.74).
city('Sarreguemines','fr','Moselle',23427.0,7.06,49.12).
city('Stiring-Wendel','fr','Moselle',12872.0,6.92,49.2).
city('Thionville','fr','Moselle',41802.0,6.15,49.36).
city('Uckange','fr','Moselle',7264.0,6.15,49.3).
city('Woippy','fr','Moselle',13508.0,6.15,49.16).
city('Yutz','fr','Moselle',15289.0,6.2,49.35).
city('Cosne-Cours-sur-Loire','fr','Nievre',11038.0,2.93,47.41).
city('Nevers','fr','Nievre',40520.0,3.15,47.0).
city('Varennes-Vauzelles','fr','Nievre',10039.0,3.14,46.99).
city('Aniche','fr','Nord',9905.0,3.25,50.33).
city('Annoeullin','fr','Nord',10442.0,2.94,50.53).
city('Anzin','fr','Nord',14153.0,3.49,50.37).
city('Armentieres','fr','Nord',25468.0,2.88,50.69).
city('Aulnoye-Aymeries','fr','Nord',8864.0,3.84,50.21).
city('Bailleul','fr','Nord',14450.0,2.74,50.74).
city('Bondues','fr','Nord',11026.0,3.1,50.71).
city('Bruay-sur-lEscaut','fr','Nord',11956.0,3.53,50.39).
city('Cambrai','fr','Nord',34140.0,3.23,50.17).
city('Cappelle-la-Grande','fr','Nord',8495.0,2.35,51.0).
city('Caudry','fr','Nord',13503.0,3.4,50.13).
city('Comines','fr','Nord',12467.0,3.01,50.77).
city('Conde-sur-lEscaut','fr','Nord',10147.0,3.58,50.46).
city('Coudekerque-Branche','fr','Nord',24669.0,2.4,51.04).
city('Croix','fr','Nord',21062.0,3.14,50.67).
city('Denain','fr','Nord',20736.0,3.39,50.33).
city('Douai','fr','Nord',43404.0,3.08,50.37).
city('Douchy-les-Mines','fr','Nord',10174.0,3.38,50.3).
city('Dunkirk','fr','Nord',71740.0,2.34,51.04).
city('Escaudain','fr','Nord',9252.0,3.34,50.33).
city('Fache-Thumesnil','fr','Nord',16094.0,3.07,50.59).
city('Fourmies','fr','Nord',13610.0,4.05,50.02).
city('Grande-Synthe','fr','Nord',22738.0,2.28,51.01).
city('Graveline','fr','Nord',12586.0,2.12,50.99).
city('Halluin','fr','Nord',20075.0,3.13,50.79).
city('Haubourdin','fr','Nord',15508.0,2.98,50.61).
city('Hautmont','fr','Nord',15289.0,3.91,50.26).
city('Hazebrouck','fr','Nord',22109.0,2.53,50.73).
city('Hem','fr','Nord',19497.0,3.19,50.66).
city('Jeumont','fr','Nord',10687.0,4.1,50.31).
city('La Madeleine','fr','Nord',23098.0,3.07,50.65).
city('Lambersart','fr','Nord',28256.0,3.03,50.66).
city('Leers','fr','Nord',9741.0,3.25,50.69).
city('Lille','fr','Nord',189746.0,3.07,50.64).
city('Lomme','fr','Nord',29084.0,2.98,50.65).
city('Loos','fr','Nord',21167.0,3.01,50.61).
city('Lys-lez-Lann','fr','Nord',13600.0,3.21,50.67).
city('Marcq-en-Baroeul','fr','Nord',37837.0,3.07,50.67).
city('Marly','fr','Nord',11497.0,3.55,50.35).
city('Marquette-lez-Lille','fr','Nord',10785.0,3.07,50.66).
city('Maubeuge','fr','Nord',33017.0,3.95,50.28).
city('Merville','fr','Nord',8894.0,2.64,50.64).
city('Mons-en-Baroeul','fr','Nord',22710.0,3.11,50.63).
city('Mouvaux','fr','Nord',13035.0,3.13,50.7).
city('Neuville-en-Ferrain','fr','Nord',9372.0,3.15,50.75).
city('Onnaing','fr','Nord',8603.0,3.61,50.39).
city('Raismes','fr','Nord',13554.0,3.48,50.38).
city('Ronchin','fr','Nord',18177.0,3.09,50.6).
city('Roncq','fr','Nord',13251.0,3.12,50.76).
city('Roubaix','fr','Nord',96806.0,3.17,50.69).
city('Saint-Amand-les-Eaux','fr','Nord',17568.0,3.43,50.45).
city('Saint-Andre-lez-Lille','fr','Nord',10201.0,3.05,50.67).
city('Saint-Pol-sur-Mer','fr','Nord',23205.0,2.35,51.03).
city('Saint-Saulve','fr','Nord',11061.0,3.55,50.37).
city('Seclin','fr','Nord',12061.0,3.02,50.55).
city('Sin-le-Noble','fr','Nord',17431.0,3.11,50.37).
city('Somain','fr','Nord',12132.0,3.28,50.36).
city('Tourcoing','fr','Nord',93835.0,3.16,50.72).
city('Valenciennes','fr','Nord',42941.0,3.52,50.37).
city('Vieux-Conde','fr','Nord',10586.0,3.56,50.46).
city('Villeneuve-dAscq','fr','Nord',65783.0,3.14,50.62).
city('Wasquehal','fr','Nord',19030.0,3.14,50.66).
city('Wattignies','fr','Nord',14474.0,3.04,50.59).
city('Wattrelos','fr','Nord',42522.0,3.21,50.71).
city('Waziers','fr','Nord',7431.0,3.12,50.39).
city('Beauvais','fr','Oise',56526.0,2.09,49.43).
city('Chantilly','fr','Oise',10772.0,2.46,49.19).
city('Clermont','fr','Oise',10368.0,2.41,49.39).
city('Compiegne','fr','Oise',41508.0,2.82,49.41).
city('Creil','fr','Oise',30250.0,2.46,49.27).
city('Crepy-en-Valois','fr','Oise',15487.0,2.89,49.24).
city('Gouvieux','fr','Oise',9324.0,2.42,49.19).
city('Meru','fr','Oise',13430.0,2.13,49.24).
city('Montataire','fr','Oise',12031.0,2.43,49.26).
city('Nogent-sur-Oise','fr','Oise',19184.0,2.46,49.28).
city('Noyon','fr','Oise',14711.0,3.0,49.58).
city('Pont-Sainte-Maxence','fr','Oise',13709.0,2.6,49.31).
city('Senlis','fr','Oise',17910.0,2.59,49.21).
city('Alencon','fr','Orne',28505.0,0.09,48.44).
city('Argentan','fr','Orne',16845.0,-0.03,48.75).
city('Flers','fr','Orne',16502.0,-0.57,48.76).
city('LAigle','fr','Orne',8739.0,0.63,48.77).
city('Paris','fr','Paris',2110694.0,2.34,48.86).
city('Aire-sur-la-Lys','fr','Pas-de-Calais',9829.0,2.0,50.64).
city('Arras','fr','Pas-de-Calais',41551.0,2.78,50.29).
city('Auchel','fr','Pas-de-Calais',11227.0,2.48,50.5).
city('Avion','fr','Pas-de-Calais',18305.0,2.83,50.4).
city('Berck','fr','Pas-de-Calais',14638.0,1.57,50.41).
city('Bethune','fr','Pas-de-Calais',29961.0,2.64,50.53).
city('Boulogne-sur-Mer','fr','Pas-de-Calais',45715.0,1.6,50.72).
city('Bruay-la-Brussiere','fr','Pas-de-Calais',23656.0,2.53,50.49).
city('Bully-les-Mines','fr','Pas-de-Calais',11819.0,2.72,50.44).
city('Calais','fr','Pas-de-Calais',79010.0,1.86,50.95).
city('Carvin','fr','Pas-de-Calais',18397.0,2.95,50.49).
city('Courrieres','fr','Pas-de-Calais',10202.0,2.93,50.45).
city('Etaples','fr','Pas-de-Calais',11191.0,1.64,50.52).
city('Harnes','fr','Pas-de-Calais',13440.0,2.89,50.45).
city('Henin-Beaumont','fr','Pas-de-Calais',24725.0,2.93,50.41).
city('Le Portel','fr','Pas-de-Calais',10880.0,1.58,50.72).
city('Lens','fr','Pas-de-Calais',36979.0,2.83,50.44).
city('Libercourt','fr','Pas-de-Calais',8393.0,3.0,50.48).
city('Lievin','fr','Pas-de-Calais',33588.0,2.77,50.42).
city('Lillers','fr','Pas-de-Calais',9929.0,2.48,50.56).
city('Longuenesse','fr','Pas-de-Calais',12570.0,2.23,50.74).
city('Marck','fr','Pas-de-Calais',9012.0,1.96,50.95).
city('Mericourt','fr','Pas-de-Calais',11450.0,2.86,50.4).
city('Montigny-en-Gohelle','fr','Pas-de-Calais',10603.0,2.94,50.44).
city('Noeux-les-Mines','fr','Pas-de-Calais',11828.0,2.66,50.48).
city('Oignies','fr','Pas-de-Calais',10539.0,2.99,50.47).
city('Outreau','fr','Pas-de-Calais',15316.0,1.58,50.71).
city('Rouvroy','fr','Pas-de-Calais',9072.0,3.3,49.85).
city('Saint-Martin-Boulogne','fr','Pas-de-Calais',11892.0,1.62,50.74).
city('Saint-Omer','fr','Pas-de-Calais',16785.0,2.25,50.76).
city('Sallaumines','fr','Pas-de-Calais',10544.0,2.86,50.42).
city('Aubiere','fr','Puy-de-Dome',10529.0,3.11,45.76).
city('Beaumont','fr','Puy-de-Dome',11742.0,3.08,45.76).
city('Chamalieres','fr','Puy-de-Dome',18853.0,3.06,45.78).
city('Clermont-Ferrand','fr','Puy-de-Dome',137364.0,3.08,45.78).
city('Cournon-dAuvergne','fr','Puy-de-Dome',18851.0,3.19,45.74).
city('Gerzat','fr','Puy-de-Dome',9050.0,3.15,45.84).
city('Issoire','fr','Puy-de-Dome',14034.0,3.24,45.55).
city('Riom','fr','Puy-de-Dome',18557.0,3.11,45.9).
city('Thiers','fr','Puy-de-Dome',12576.0,3.54,45.86).
city('Anglet','fr','Pyrenees-Atlantiques',36946.0,-1.51,43.49).
city('Bayonne','fr','Pyrenees-Atlantiques',40336.0,-1.48,43.5).
city('Biarritz','fr','Pyrenees-Atlantiques',31231.0,-1.55,43.48).
city('Billere','fr','Pyrenees-Atlantiques',14055.0,-0.41,43.31).
city('Hendaye','fr','Pyrenees-Atlantiques',13423.0,-1.77,43.37).
city('Lons','fr','Pyrenees-Atlantiques',12684.0,-0.41,43.33).
city('Oloron-Sainte-Marie','fr','Pyrenees-Atlantiques',11007.0,-0.62,43.19).
city('Orthez','fr','Pyrenees-Atlantiques',10203.0,-0.78,43.5).
city('Pau','fr','Pyrenees-Atlantiques',77475.0,-0.39,43.3).
city('Saint-Jean-de-Luz','fr','Pyrenees-Atlantiques',13523.0,-1.66,43.4).
city('Perpignan','fr','Pyrenees-Orientales',104783.0,2.89,42.7).
city('Saint-Esteve','fr','Pyrenees-Orientales',9919.0,2.85,42.7).
city('Brignais','fr','Rhone',12121.0,4.75,45.68).
city('Bron','fr','Rhone',36263.0,4.91,45.74).
city('Caluire-et-Cuire','fr','Rhone',41524.0,4.83,45.8).
city('Decines-Charpieu','fr','Rhone',24661.0,4.93,45.77).
city('Ecully','fr','Rhone',17940.0,4.75,45.77).
city('Francheville','fr','Rhone',11724.0,4.77,45.74).
city('Genas','fr','Rhone',12584.0,5.0,45.74).
city('Givors','fr','Rhone',17777.0,4.77,45.6).
city('Lyon','fr','Rhone',463700.0,4.83,45.76).
city('Meyzieu','fr','Rhone',28198.0,4.97,45.78).
city('Mions','fr','Rhone',11171.0,4.95,45.66).
city('Oullins','fr','Rhone',24803.0,4.8,45.72).
city('Pierre-Benite','fr','Rhone',10304.0,4.82,45.7).
city('Rillieux-la-Pape','fr','Rhone',27206.0,4.91,45.82).
city('Saint-Fons','fr','Rhone',15760.0,4.85,45.71).
city('Saint-Genis-Laval','fr','Rhone',19668.0,4.8,45.69).
city('Saint-Priest','fr','Rhone',40824.0,4.93,45.69).
city('Sainte-Foy-les-Lyon','fr','Rhone',21206.0,4.79,45.74).
city('Tarare','fr','Rhone',10319.0,4.42,45.9).
city('Tassin-la-Demi-Lune','fr','Rhone',16450.0,4.81,45.75).
city('Vaulx-en-Velin','fr','Rhone',36564.0,4.91,45.79).
city('Venissieux','fr','Rhone',53678.0,4.86,45.69).
city('Villefranche-sur-Saone','fr','Rhone',31543.0,4.72,45.99).
city('Villeurbanne','fr','Rhone',126230.0,4.88,45.77).
city('Autun','fr','Saone-et-Loire',15684.0,4.29,46.96).
city('Chalon-sur-Saone','fr','Saone-et-Loire',47968.0,4.84,46.79).
city('Digoin','fr','Saone-et-Loire',8368.0,3.98,46.49).
city('Gueugnon','fr','Saone-et-Loire',7962.0,4.06,46.61).
city('Le Creusot','fr','Saone-et-Loire',24836.0,4.42,46.81).
city('Macon','fr','Saone-et-Loire',33004.0,4.81,46.31).
city('Montceau-les-Mines','fr','Saone-et-Loire',19375.0,4.36,46.68).
city('Paray-le-Monial','fr','Saone-et-Loire',8867.0,4.11,46.45).
city('Saint-Vallier','fr','Saone-et-Loire',9332.0,4.35,46.65).
city('Allonnes','fr','Sarthe',11707.0,0.14,47.97).
city('La Ferte-Bernard','fr','Sarthe',9245.0,0.65,48.18).
city('La Fleche','fr','Sarthe',15559.0,-0.08,47.7).
city('Le Mans','fr','Sarthe',147413.0,0.2,48.0).
city('Sable-sur-Sarthe','fr','Sarthe',13182.0,-0.34,47.84).
city('Aix-les-Bains','fr','Savoie',26688.0,5.9,45.7).
city('Albertville','fr','Savoie',17485.0,6.38,45.68).
city('Chambery','fr','Savoie',57591.0,5.91,45.58).
city('La Motte-Servolex','fr','Savoie',12172.0,5.88,45.6).
city('Saint-Jean-de-Maurienne','fr','Savoie',8671.0,6.33,45.28).
city('Barentin','fr','Seine-Maritime',13031.0,0.95,49.55).
city('Bihorel','fr','Seine-Maritime',8954.0,1.1,49.46).
city('Bois-Guillaume','fr','Seine-Maritime',13395.0,1.12,49.47).
city('Bolbec','fr','Seine-Maritime',12847.0,0.48,49.57).
city('Canteleu','fr','Seine-Maritime',15157.0,1.03,49.45).
city('Caudebec-les-Elbeuf','fr','Seine-Maritime',9998.0,1.04,49.28).
city('Darnetal','fr','Seine-Maritime',8993.0,1.15,49.45).
city('Deville-les-Rouen','fr','Seine-Maritime',10483.0,1.03,49.46).
city('Dieppe','fr','Seine-Maritime',34788.0,1.08,49.93).
city('Elbeuf','fr','Seine-Maritime',16613.0,1.01,49.29).
city('Fecamp','fr','Seine-Maritime',21300.0,0.38,49.76).
city('Gonfreville-lOrcher','fr','Seine-Maritime',9840.0,0.22,49.5).
city('Grand-Couronne','fr','Seine-Maritime',9311.0,1.0,49.35).
city('Harfleur','fr','Seine-Maritime',8175.0,0.2,49.5).
city('Le Grand-Quevilly','fr','Seine-Maritime',26342.0,1.03,49.41).
city('Le Havre','fr','Seine-Maritime',188605.0,0.12,49.5).
city('Le Petit-Quevilly','fr','Seine-Maritime',22373.0,1.03,49.43).
city('Lillebonne','fr','Seine-Maritime',10099.0,0.53,49.53).
city('Maromme','fr','Seine-Maritime',12302.0,1.02,49.48).
city('Mont-Saint-Aignan','fr','Seine-Maritime',22380.0,1.08,49.46).
city('Montivilliers','fr','Seine-Maritime',16390.0,0.19,49.55).
city('Notre-Dame-de-Gravenchon','fr','Seine-Maritime',8511.0,0.58,49.48).
city('Oissel','fr','Seine-Maritime',11100.0,1.1,49.35).
city('Rouen','fr','Seine-Maritime',108101.0,1.08,49.44).
city('Saint-Etienne-du-Rouvray','fr','Seine-Maritime',28344.0,1.1,49.4).
city('Sotteville-les-Rouen','fr','Seine-Maritime',29848.0,1.09,49.42).
city('Yvetot','fr','Seine-Maritime',10857.0,0.75,49.63).
city('Aubervillers','fr','Seine-Saint-Denis',61067.0,2.38,48.92).
city('Aulnay-sous-Bois','fr','Seine-Saint-Denis',79622.0,2.49,48.96).
city('Bagnolet','fr','Seine-Saint-Denis',32781.0,2.41,48.86).
city('Bobigny','fr','Seine-Saint-Denis',44153.0,2.44,48.91).
city('Bondy','fr','Seine-Saint-Denis',47242.0,2.47,48.91).
city('Clichy-sous-Bois','fr','Seine-Saint-Denis',28642.0,2.55,48.92).
city('Drancy','fr','Seine-Saint-Denis',63535.0,2.46,48.94).
city('Epinay-sur-Seine','fr','Seine-Saint-Denis',45614.0,2.3,48.97).
city('Gagny','fr','Seine-Saint-Denis',37511.0,2.53,48.89).
city('La Courneuve','fr','Seine-Saint-Denis',35862.0,2.38,48.93).
city('Le Blanc-Mesnil','fr','Seine-Saint-Denis',47234.0,2.47,48.96).
city('Le Bourget','fr','Seine-Saint-Denis',12503.0,2.42,48.94).
city('Le Pre-Saint-Gervais','fr','Seine-Saint-Denis',17220.0,2.39,48.89).
city('Le Raincy','fr','Seine-Saint-Denis',12770.0,2.5,48.9).
city('Les Lilas','fr','Seine-Saint-Denis',20499.0,2.4,48.89).
city('Les Pavillons-sous-Bois','fr','Seine-Saint-Denis',19309.0,2.48,48.91).
city('Livry-Gargan','fr','Seine-Saint-Denis',38935.0,2.54,48.92).
city('Montfermeil','fr','Seine-Saint-Denis',23484.0,2.55,48.9).
city('Montreuil','fr','Seine-Saint-Denis',89125.0,2.43,48.86).
city('Neuilly-Plaisance','fr','Seine-Saint-Denis',18446.0,2.51,48.86).
city('Neuilly-sur-Marne','fr','Seine-Saint-Denis',33940.0,2.52,48.85).
city('Noisy-le-Grand','fr','Seine-Saint-Denis',61650.0,2.55,48.85).
city('Noisy-le-Sec','fr','Seine-Saint-Denis',38153.0,2.46,48.89).
city('Pantin','fr','Seine-Saint-Denis',52147.0,2.41,48.9).
city('Pierrefitte-sur-Seine','fr','Seine-Saint-Denis',27441.0,2.36,48.96).
city('Romainville','fr','Seine-Saint-Denis',24158.0,2.44,48.89).
city('Rosny-sous-Bois','fr','Seine-Saint-Denis',40571.0,2.48,48.88).
city('Saint-Denis','fr','Seine-Saint-Denis',84027.0,2.36,48.94).
city('Saint-Ouen','fr','Seine-Saint-Denis',38590.0,2.34,48.91).
city('Sevran','fr','Seine-Saint-Denis',46648.0,2.52,48.93).
city('Stains','fr','Seine-Saint-Denis',31921.0,2.35,48.95).
city('Tremblay-en-France','fr','Seine-Saint-Denis',35932.0,2.55,48.99).
city('Villemomble','fr','Seine-Saint-Denis',27351.0,2.5,48.89).
city('Villepinte','fr','Seine-Saint-Denis',36557.0,2.53,48.97).
city('Villetaneuse','fr','Seine-Saint-Denis',11620.0,2.33,48.96).
city('Avon','fr','Seine-et-Marne',14436.0,2.72,48.41).
city('Brie-Comte-Robert','fr','Seine-et-Marne',15080.0,2.6,48.7).
city('Champs-sur-Marne','fr','Seine-et-Marne',27202.0,2.59,48.86).
city('Chelles','fr','Seine-et-Marne',46390.0,2.6,48.89).
city('Claye-Souilly','fr','Seine-et-Marne',10648.0,2.69,48.95).
city('Combs-la-Ville','fr','Seine-et-Marne',22067.0,2.56,48.67).
city('Coulommiers','fr','Seine-et-Marne',14672.0,3.08,48.82).
city('Dammarie-les-Lys','fr','Seine-et-Marne',20792.0,2.64,48.51).
city('Fontainebleau','fr','Seine-et-Marne',16217.0,2.7,48.42).
city('Lagny-sur-Marne','fr','Seine-et-Marne',20272.0,2.7,48.88).
city('Le Mee-sur-Seine','fr','Seine-et-Marne',21861.0,2.63,48.53).
city('Lognes','fr','Seine-et-Marne',15391.0,2.61,48.84).
city('Meaux','fr','Seine-et-Marne',50910.0,2.88,48.96).
city('Melun','fr','Seine-et-Marne',36223.0,2.65,48.54).
city('Mitry-Mory','fr','Seine-et-Marne',18409.0,2.61,48.98).
city('Moissy-Cramayel','fr','Seine-et-Marne',16104.0,2.59,48.62).
city('Montereau-Fault-Yonne','fr','Seine-et-Marne',17364.0,2.95,48.39).
city('Nemours','fr','Seine-et-Marne',13743.0,2.68,48.27).
city('Noisiel','fr','Seine-et-Marne',15205.0,2.63,48.85).
city('Ozoir-la-Ferriere','fr','Seine-et-Marne',22320.0,2.67,48.77).
city('Pontault-Combault','fr','Seine-et-Marne',38250.0,2.61,48.79).
city('Provins','fr','Seine-et-Marne',11958.0,3.3,48.56).
city('Roissy-en-Brie','fr','Seine-et-Marne',20799.0,2.65,48.8).
city('Saint-Fargeau-Ponthierry','fr','Seine-et-Marne',11920.0,2.55,48.54).
city('Savigny-le-Temple','fr','Seine-et-Marne',25707.0,2.58,48.57).
city('Torcy','fr','Seine-et-Marne',24189.0,2.66,48.83).
city('Vaires-sur-Marne','fr','Seine-et-Marne',12418.0,2.63,48.88).
city('Villeparisis','fr','Seine-et-Marne',23557.0,2.6,48.95).
city('Abbeville','fr','Somme',25274.0,1.83,50.12).
city('Albert','fr','Somme',10180.0,2.65,50.0).
city('Amiens','fr','Somme',138816.0,2.3,49.9).
city('Albi','fr','Tarn',46510.0,2.15,43.93).
city('Carmaux','fr','Tarn',9876.0,2.16,44.05).
city('Castres','fr','Tarn',43013.0,2.23,43.61).
city('Gaillac','fr','Tarn',11635.0,1.9,43.91).
city('Graulhet','fr','Tar',12246.0,1.99,43.77).
city('Mazamet','fr','Tarn',10071.0,2.36,43.49).
city('Castelsarassin','fr','Tarn-et-Garonne',11499.0,1.1,44.04).
city('Moissac','fr','Tarn-et-Garonne',12686.0,1.08,44.11).
city('Montauban','fr','Tarn-et-Garonne',52818.0,1.35,44.02).
city('Belfort','fr','Territoire de Belfort',50809.0,6.85,47.65).
city('Argenteuil','fr','Val-dOise',95075.0,2.24,48.94).
city('Arnouville-les-Gonesse','fr','Val-dOise',12543.0,2.41,48.99).
city('Beauchamps','fr','Val-dOise',9173.0,-1.37,48.84).
city('Bezons','fr','Val-dOise',27094.0,2.2,48.93).
city('Cergy','fr','Val-dOise',60288.0,2.07,49.04).
city('Cormeilles-en-Parisis','fr','Val-dOise',21487.0,2.19,48.97).
city('Deuil-la-Barre','fr','Val-dOise',21233.0,2.31,48.97).
city('Domont','fr','Val-dOise',16314.0,2.33,49.03).
city('Eaubonne','fr','Val-dOise',23739.0,2.27,49.0).
city('Enghien-les-Bains','fr','Val-dOise',10675.0,2.31,48.96).
city('Eragny','fr','Val-dOise',15040.0,2.1,49.02).
city('Ermont','fr','Val-dOise',27575.0,2.25,49.0).
city('Ezanville','fr','Val-dOise',8770.0,2.36,49.03).
city('Fosses','fr','Val-dOise',10421.0,2.48,49.1).
city('Franconville','fr','Val-dOise',33870.0,2.22,48.98).
city('Garges-les-Gonesse','fr','Val-dOise',39285.0,2.41,48.97).
city('Gonesse','fr','Val-dOise',26212.0,2.45,48.99).
city('Goussainville','fr','Val-dOise',29494.0,2.47,49.02).
city('Herblay','fr','Val-dOise',24116.0,2.16,49.0).
city('Jouy-le-Moutier','fr','Val-dOise',18705.0,2.03,49.02).
city('LIsle-Adam','fr','Val-dOise',12192.0,2.22,49.11).
city('Montigny-les-Cormeilles','fr','Val-dOise',17587.0,2.2,48.99).
city('Montmagny','fr','Val-dOise',14305.0,2.35,48.96).
city('Montmorency','fr','Val-dOise',20723.0,2.31,48.98).
city('Osny','fr','Val-dOise',16027.0,2.06,49.07).
city('Persan','fr','Val-dOise',9138.0,2.27,49.15).
city('Pontoise','fr','Val-dOise',28186.0,2.09,49.05).
city('Saint-Brice-sous-Foret','fr','Val-dOise',13356.0,2.35,49.0).
city('Saint-Gratien','fr','Val-dOise',19521.0,2.27,48.97).
city('Saint-Leu-la-Foret','fr','Val-dOise',15812.0,2.24,49.01).
city('Saint-Ouen-lAumone','fr','Val-dOise',20636.0,2.1,49.05).
city('Sannois','fr','Val-',25858.0,2.24,48.98).
city('Sarcelles','fr','Val-dOise',59372.0,2.38,49.0).
city('Soisy-sous-Montmorency','fr','Val-dOise',17214.0,2.29,48.98).
city('Taverny','fr','Val-dOise',26828.0,2.19,49.02).
city('Vaureal','fr','Val-dOise',20250.0,2.03,49.03).
city('Villiers-le-Bel','fr','Val-dOise',26611.0,2.38,49.01).
city('Alfortville','fr','Val-de-Marne',36566.0,2.42,48.81).
city('Arcueil','fr','Val-de-Marne',16869.0,2.32,48.8).
city('Boissy-Saint-Leger','fr','Val-de-Marne',15451.0,2.51,48.75).
city('Bonneuil','fr','Val-de-Marne',17644.0,2.43,48.97).
city('Bry-sur-Marne','fr','Val-de-Marne',15911.0,2.5,48.84).
city('Cachan','fr','Val-de-Marne',25391.0,2.32,48.78).
city('Champigny-sur-Marne','fr','Val-de-Marne',71985.0,2.51,48.82).
city('Charenton-le-Pont','fr','Val-de-Marne',30298.0,2.41,48.82).
city('Chennevieres-sur-Marne','fr','Val-de-Marne',17953.0,2.11,49.01).
city('Chevilly-Larue','fr','Val-de-Marne',19630.0,2.35,48.76).
city('Choisy-le-Roi','fr','Val-de-Marne',34757.0,2.4,48.76).
city('Creteil','fr','Val-de-Marne',84133.0,2.45,48.79).
city('Fontenay-sous-Bois','fr','Val-de-Marne',51077.0,2.5,48.85).
city('Fresnes','fr','Val-de-Marne',24335.0,2.32,48.75).
city('Gentilly','fr','Val-de-Marne',15639.0,2.33,48.82).
city('Ivry-sur-Seine','fr','Val-de-Marne',49463.0,2.38,48.82).
city('Joinville-le-Pont','fr','Val-de-Marne',17542.0,2.46,48.82).
city('LHay-les-Roses','fr','Val-de-Marne',29819.0,2.33,48.78).
city('La Queue-en-Brie','fr','Val-de-Marne',11589.0,2.58,48.79).
city('Le Kremlin-Bicetre','fr','Val-de-Marne',27194.0,2.33,48.81).
city('Le Perreux-sur-Marne','fr','Val-de-Marne',31370.0,2.48,48.84).
city('Le Plessis-Trevise','fr','Val-de-Marne',18254.0,2.57,48.81).
city('Limeil-Brevannes','fr','Val-de-Marne',18658.0,2.48,48.74).
city('Maisons-Alfort','fr','Val-de-Marne',50249.0,2.44,48.81).
city('Nogent-sur-Marne','fr','Val-de-Marne',30453.0,2.47,48.84).
city('Orly','fr','Val-de-Marne',19830.0,2.39,48.74).
city('Ormesson-sur-Marne','fr','Val-de-Marne',9710.0,2.54,48.79).
city('Saint-Mande','fr','Val-de-Marne',20516.0,2.4,48.84).
city('Saint-Maur-des-Fosses','fr','Val-de-Marne',71267.0,2.49,48.8).
city('Saint-Maurice','fr','Val-de-Marne',13975.0,2.41,48.83).
city('Sucy-en-Brie','fr','Val-de-Marne',24354.0,2.52,48.76).
city('Thiais','fr','Val-de-Marne',28905.0,2.38,48.76).
city('Valenton','fr','Val-de-Marne',11716.0,2.45,48.75).
city('Villejuif','fr','Val-de-Marne',46913.0,2.39,48.8).
city('Villeneuve-Saint-Georges','fr','Val-de-Marne',29506.0,2.45,48.74).
city('Villeneuve-le-Roi','fr','Val-de-Marne',17229.0,2.4,48.74).
city('Villiers-sur-Marne','fr','Val-de-Marne',29652.0,2.55,48.84).
city('Vincennes','fr','Val-de-Marne',44781.0,2.44,48.85).
city('Vitry-sur-Seine','fr','Val-de-Marne',77035.0,2.39,48.79).
city('Brignoles','fr','Var',13579.0,6.06,43.42).
city('Draguignan','fr','Var',35217.0,6.46,43.55).
city('Frejus','fr','Var',51514.0,6.73,43.45).
city('Hyeres','fr','Var',54588.0,6.12,43.13).
city('La Crau','fr','Var',17335.0,6.07,43.15).
city('La Garde','fr','Var',28016.0,6.03,43.14).
city('La Seyne-sur-Mer','fr','Var',61417.0,5.87,43.11).
city('La Valette-du-Var','fr','Var',22816.0,5.99,43.14).
city('Le Pradet','fr','Var',12070.0,6.01,43.11).
city('Ollioules','fr','Var',13730.0,5.85,43.14).
city('Roquebrune-sur-Argens','fr','Var',12209.0,6.63,43.44).
city('Saint-Maximin-la-Sainte-Baume','fr','Var',14807.0,5.85,43.47).
city('Saint-Raphael','fr','Var',33115.0,6.76,43.44).
city('Sainte-Maxime','fr','Var',13291.0,6.62,43.32).
city('Sanary-sur-Mer','fr','Var',18928.0,5.8,43.13).
city('Six-Fours-les-Plages','fr','Var',35980.0,5.83,43.1).
city('Sollies-Pont','fr','Var',11933.0,6.03,43.19).
city('Toulon','fr','Var',154465.0,5.92,43.13).
city('Apt','fr','Vaucluse',11115.0,5.39,43.88).
city('Avignon','fr','Vaucluse',85848.0,4.81,43.96).
city('Bollene','fr','Vaucluse',14470.0,4.74,44.29).
city('Carpentras','fr','Vaucluse',27734.0,5.04,44.07).
city('Cavaillon','fr','Vaucluse',25890.0,5.03,43.85).
city('LIsle-sur-la-Sorgue','fr','Vaucluse',18177.0,5.04,43.94).
city('Le Pontet','fr','Vaucluse',15747.0,4.84,43.96).
city('Orange','fr','Vaucluse',29053.0,4.81,44.15).
city('Pertuis','fr','Vaucluse',19530.0,5.49,43.7).
city('Sorgues','fr','Vaucluse',17978.0,4.87,44.05).
city('Valreas','fr','Vaucluse',9792.0,4.98,44.39).
city('Challans','fr','Vendee',17688.0,-1.88,46.85).
city('Chateau-dOlonne','fr','Vendee',14469.0,-1.74,46.51).
city('Fontenay-le-Comte','fr','Vendee',13535.0,-0.8,46.47).
city('La Roche-sur-Yon','fr','Vendee',52595.0,-1.44,46.67).
city('Les Herbiers','fr','Vendee',14433.0,-1.02,46.88).
city('Les Sables-dOlonne','fr','Vendee',15517.0,-1.78,46.51).
city('Longeville-sur-Mer','fr','Vendee',1973.0,-1.51,46.42).
city('Chatellerault','fr','Vienne',34022.0,0.54,46.81).
city('Poitiers','fr','Vienne',86639.0,0.34,46.58).
city('Epinal','fr','Vosges',35423.0,6.44,48.18).
city('Gerardmer','fr','Vosges',8839.0,6.88,48.08).
city('Remiremont','fr','Vosges',8274.0,6.59,48.01).
city('Saint-Die','fr','Vosges',22682.0,6.95,48.29).
city('Auxerre','fr','Yonne',37515.0,3.56,47.81).
city('Avallon','fr','Yonne',8053.0,3.89,47.5).
city('Joigny','fr','Yonne',10355.0,3.4,48.0).
city('Sens','fr','Yonne',27060.0,3.27,48.2).
city('Acheres','fr','Yvelines',22282.0,2.06,48.97).
city('Andresy','fr','Yvelines',12646.0,2.07,48.99).
city('Aubergenville','fr','Yvelines',11785.0,1.85,48.97).
city('Bois-dArcy','fr','Yvelines',11869.0,2.02,48.81).
city('Carrieres-sous-Poissy','fr','Yvelines',15261.0,2.03,48.95).
city('Carrieres-sur-Seine','fr','Yvelines',12635.0,2.19,48.92).
city('Chanteloup-les-Vignes','fr','Yvelines',9311.0,2.03,48.99).
city('Chatou','fr','Yvelines',29450.0,2.14,48.89).
city('Conflans-Sainte-Honorine','fr','Yvelines',35122.0,2.1,49.01).
city('Croissy-sur-Seine','fr','Yvelines',10501.0,2.14,48.88).
city('Elancourt','fr','Yvelines',30088.0,1.95,48.78).
city('Fontenay-le-Fleury','fr','Yvelines',12403.0,2.05,48.82).
city('Guyancourt','fr','Yvelines',31107.0,2.06,48.77).
city('Houilles','fr','Yvelines',30101.0,2.18,48.92).
city('La Celle-Saint-Cloud','fr','Yvelines',21069.0,2.15,48.85).
city('Le Chesnay','fr','Yvelines',28353.0,2.12,48.84).
city('Le Pecq','fr','Yvelines',16151.0,2.11,48.9).
city('Le Vesinet','fr','Yvelines',16162.0,2.13,48.9).
city('Les Clayes-sous-Bois','fr','Yvelines',17491.0,1.98,48.83).
city('Les Mureaux','fr','Yvelines',31406.0,1.9,49.0).
city('Limay','fr','Yvelines',18306.0,1.74,49.0).
city('Maisons-Laffitte','fr','Yvelines',22006.0,2.14,48.95).
city('Mantes-la-Jolie','fr','Yvelines',43439.0,1.7,48.99).
city('Mantes-la-Ville','fr','Yvelines',19639.0,1.7,48.96).
city('Marly-le-Roi','fr','Yvelines',17041.0,2.07,48.87).
city('Maurepas','fr','Yvelines',19817.0,1.9,48.76).
city('Montesson','fr','Yvelines',14947.0,2.14,48.91).
city('Montigny-le-Bretonneux','fr','Yvelines',38264.0,2.03,48.76).
city('Plaisir','fr','Yvelines',35407.0,1.95,48.81).
city('Poissy','fr','Yvelines',35663.0,2.04,48.93).
city('Rambouillet','fr','Yvelines',25429.0,1.82,48.65).
city('Saint-Cyr-lEcole','fr','Yvelines',14634.0,2.07,48.81).
city('Saint-Germain-en-Laye','fr','Yvelines',38098.0,2.1,48.9).
city('Sartrouville','fr','Yvelines',50954.0,2.18,48.94).
city('Trappes','fr','Yvelines',28013.0,2.0,48.79).
city('Triel-sur-Seine','fr','Yvelines',12351.0,2.0,48.99).
city('Velizy-Villacoublay','fr','Yvelines',20426.0,2.18,48.79).
city('Verneuil-sur-Seine','fr','Yvelines',16261.0,1.97,48.99).
city('Versailles','fr','Yvelines',85134.0,2.14,48.81).
city('Viroflay','fr','Yvelines',15803.0,2.19,48.81).
city('Voisins-le-Bretonneux','fr','Yvelines',12987.0,2.04,48.76).
city('Camopi','gf','Cayenne',1295.0,-52.34,3.17).
city('Cayenne','gf','Cayenne',61642.0,-52.34,4.92).
city('Iracoubo','gf','Cayenne',1539.0,-53.22,5.48).
city('Kourou','gf','Cayenne',24035.0,-52.65,5.16).
city('Macouria','gf','Cayenne',8786.0,-52.37,4.92).
city('Matoury','gf','Cayenne',26357.0,-52.34,4.85).
city('Remire-Montjoly','gf','Cayenne',19035.0,-52.28,4.92).
city('Roura','gf','Cayenne',2230.0,-52.33,4.73).
city('Saint-Georges','gf','Cayenne',2743.0,-51.81,3.91).
city('Sinnamary','gf','Cayenne',3190.0,-52.96,5.38).
city('Apatou','gf','Saint-Laurent-du-Maroni',4753.0,-54.34,5.16).
city('Grand-Santi','gf','Saint-Laurent-du-Maroni',3942.0,-54.38,4.25).
city('Mana','gf','Saint-Laurent-du-Maroni',5887.0,-53.79,5.67).
city('Maripasoula','gf','Saint-Laurent-du-Maroni',5982.0,-56.04,3.64).
city('Saint-Laurent-du-Maroni','gf','Saint-Laurent-du-Maroni',24290.0,-54.04,5.5).
city('Afaahiti','pf','Iles du Vent',5186.0,-149.27,-17.74).
city('Afareaitu','pf','Iles du Vent',3213.0,-149.77,-17.54).
city('Arue','pf','Iles du Vent',9492.0,-149.49,-17.51).
city('Faaa','pf','Iles du Vent',29389.0,-149.59,-17.54).
city('Faaone','pf','Iles du Vent',1747.0,-149.29,-17.66).
city('Haapiti','pf','Iles du Vent',3959.0,-149.86,-17.56).
city('Hitiaa','pf','Iles du Vent',1826.0,-149.29,-17.59).
city('Mahaena','pf','Iles du Vent',960.0,-149.31,-17.56).
city('Mahina','pf','Iles du Vent',14225.0,-149.45,-17.5).
city('Maiao','pf','Iles du Vent',346.0,-150.63,-17.65).
city('Mataiea','pf','Iles du Vent',4609.0,-149.41,-17.76).
city('Mataiva','pf','Iles du Vent',242.0,-149.19,-17.76).
city('Paea','pf','Iles du Vent',13359.0,-149.57,-17.67).
city('Paopao','pf','Iles du Vent',4221.0,-149.81,-17.49).
city('Papara','pf','Iles du Vent',10361.0,-149.54,-17.74).
city('Papeari','pf','Iles du Vent',4131.0,-149.34,-17.74).
city('Papeete','pf','Iles du Vent',26358.0,-149.56,-17.52).
city('Papenoo','pf','Iles du Vent',3440.0,-149.42,-17.5).
city('Papetoai','pf','Iles du Vent',1964.0,-149.86,-17.47).
city('Pirae','pf','Iles du Vent',14729.0,-149.52,-17.51).
city('Pueu','pf','Iles du Vent',1968.0,-149.21,-17.72).
city('Punaauia','pf','Iles du Vent',25751.0,-149.59,-17.62).
city('Tautira','pf','Iles du Vent',2293.0,-149.14,-17.72).
city('Teahupoo','pf','Iles du Vent',1423.0,-149.27,-17.85).
city('Teavaro','pf','Iles du Vent',2289.0,-149.76,-17.49).
city('Tiarei','pf','Iles du Vent',2795.0,-149.32,-17.52).
city('Toahotu','pf','Iles du Vent',2842.0,-149.31,-17.74).
city('Vairao','pf','Iles du Vent',2423.0,-149.28,-17.77).
city('Anau','pf','Iles sous le Vent',1413.0,-151.72,-16.51).
city('Avera','pf','Iles sous le Vent',3083.0,-151.42,-16.79).
city('Faaaha','pf','Iles sous le Vent',445.0,-151.46,-16.6).
city('Faanui','pf','Iles sous le Vent',2061.0,-151.74,-16.47).
city('Faie','pf','Iles sous le Vent',319.0,-151.0,-16.7).
city('Fare','pf','Iles sous le Vent',1540.0,-151.01,-16.69).
city('Fetuna','pf','Iles sous le Vent',380.0,-151.45,-16.85).
city('Fitii','pf','Iles sous le Vent',1154.0,-151.02,-16.72).
city('Haamene','pf','Iles sous le Vent',908.0,-151.49,-16.62).
city('Haapu','pf','Iles sous le Vent',579.0,-150.99,-16.76).
city('Hipu','pf','Iles sous le Vent',467.0,-151.47,-16.58).
city('Iripau','pf','Iles sous le Vent',1254.0,-151.51,-16.57).
city('Maeva','pf','Iles sous le Vent',1047.0,-151.0,-16.68).
city('Maroe','pf','Iles sous le Vent',498.0,-150.97,-16.74).
city('Maupiti','pf','Iles sous le Vent',1218.0,-152.26,-16.45).
city('Niua','pf','Iles sous le Vent',486.0,-151.51,-16.63).
city('Opoa','pf','Iles sous le Vent',1180.0,-151.37,-16.86).
city('Parea','pf','Iles sous le Vent',454.0,-150.97,-16.78).
city('Puohine','pf','Iles sous le Vent',161.0,-151.41,-16.88).
city('Ruutia','pf','Iles sous le Vent',463.0,-151.54,-16.6).
city('Tapuamu','pf','Iles sous le Vent',582.0,-151.53,-16.59).
city('Tefarerii','pf','Iles sous le Vent',373.0,-152.25,-16.45).
city('Tehurui','pf','Iles sous le Vent',469.0,-151.48,-16.86).
city('Tevaitoa','pf','Iles sous le Vent',1851.0,-151.49,-16.77).
city('Uturoa','pf','Iles sous le Vent',3668.0,-151.42,-16.72).
city('Vaiaau','pf','Iles sous le Vent',909.0,-151.48,-16.89).
city('Vaitape','pf','Iles sous le Vent',4680.0,-151.75,-16.52).
city('Vaitoare','pf','Iles sous le Vent',436.0,-151.45,-16.65).
city('Atuona','pf','Marquises',1762.0,-139.02,-9.79).
city('Fatu-Hiva','pf','Marquises',559.0,-138.63,-10.47).
city('Hakahao','pf','Marquises',1677.0,-140.07,-9.36).
city('Hakamaii','pf','Marquises',608.0,-140.12,-9.4).
city('Hatiheu','pf','Marquises',334.0,-140.05,-8.85).
city('Tahuata','pf','Marquises',693.0,-139.08,-9.95).
city('Taiohae','pf','Marquises',2155.0,-140.07,-8.92).
city('Taipivai','pf','Marquises',380.0,-140.05,-8.88).
city('Ua-Huka','pf','Marquises',587.0,-139.55,-8.9).
city('Ahe','pf','Tuamotu-Gambier',476.0,-146.3,-14.5).
city('Amanu','pf','Tuamotu-Gambier',152.0,-140.77,-17.8).
city('Anaa','pf','Tuamotu-Gambier',451.0,-145.5,-17.42).
city('Apataki','pf','Tuamotu-Gambier',456.0,-146.33,-15.43).
city('Arutua','pf','Tuamotu-Gambier',731.0,-146.73,-15.3).
city('Faaite','pf','Tuamotu-Gambier',352.0,-145.23,-16.75).
city('Fakahima','pf','Tuamotu-Gambier',162.0,-140.13,-15.98).
city('Fakarava','pf','Tuamotu-Gambier',829.0,-145.62,-16.33).
city('Fangatau','pf','Tuamotu-Gambier',128.0,-138.75,-22.23).
city('Hao','pf','Tuamotu-Gambier',1232.0,-140.9,-18.25).
city('Hereheretue','pf','Tuamotu-Gambier',69.0,-144.97,-19.9).
city('Hikueru','pf','Tuamotu-Gambier',159.0,-142.62,-17.6).
city('Katiu','pf','Tuamotu-Gambier',462.0,-144.37,-16.43).
city('Kauehi','pf','Tuamotu-Gambier',657.0,-145.15,-15.85).
city('Kaukura','pf','Tuamotu-Gambier',342.0,-146.7,-15.75).
city('Makatea','pf','Tuamotu-Gambier',98.0,-148.27,-15.82).
city('Makemo','pf','Tuamotu-Gambier',835.0,-143.67,-16.58).
city('Manihi','pf','Tuamotu-Gambier',800.0,-145.93,-14.4).
city('Marokau','pf','Tuamotu-Gambi',52.0,-142.28,-18.03).
city('Napuka','pf','Tuamotu-Gambier',233.0,-141.25,-14.2).
city('Niau','pf','Tuamotu-Gambier',141.0,-146.35,-16.15).
city('Nukutavake','pf','Tuamotu-Gambier',129.0,-138.83,-19.28).
city('Puamau','pf','Tuamotu-Gambier',335.0,-134.92,-23.01).
city('Pukapuka','pf','Tuamotu-Gambier',209.0,-138.8,-14.82).
city('Pukarua','pf','Tuamotu-Gambier',213.0,-137.03,-18.33).
city('Rangiroa','pf','Tuamotu-Gambier',2567.0,-147.58,-15.17).
city('Raroia','pf','Tuamotu-Gambier',238.0,-142.45,-16.02).
city('Reao','pf','Tuamotu-Gambier',359.0,-136.38,-18.52).
city('Rikitea','pf','Tuamotu-Gambier',1103.0,-134.96,-23.11).
city('Taenga','pf','Tuamotu-Gambier',134.0,-143.13,-16.35).
city('Takapoto','pf','Tuamotu-Gambier',494.0,-145.2,-14.63).
city('Takaroa','pf','Tuamotu-Gambier',1228.0,-144.97,-14.47).
city('Tatakoto','pf','Tuamotu-Gambier',259.0,-138.38,-17.33).
city('Tepoto','pf','Tuamotu-Gambier',51.0,-144.28,-16.82).
city('Tikehau','pf','Tuamotu-Gambier',411.0,-148.17,-15.0).
city('Tureia','pf','Tuamotu-Gambier',286.0,-138.53,-20.83).
city('Vahitahi','pf','Tuamotu-Gambier',123.0,-138.87,-18.73).
city('Vairaatea','pf','Tuamotu-Gambier',35.0,-139.33,-19.32).
city('Amaru','pf','Tubuai',238.0,-152.82,-22.62).
city('Anapoto','pf','Tubuai',233.0,-152.86,-22.62).
city('Anatonu','pf','Tubuai',247.0,-147.62,-23.87).
city('Avera','pf','Tubuai',711.0,-151.34,-22.44).
city('Hauti','pf','Tubuai',388.0,-151.32,-22.46).
city('Mahu','pf','Tubuai',462.0,-149.44,-23.39).
city('Mataura','pf','Tubuai',913.0,-149.46,-23.36).
city('Moerai','pf','Tubuai',1044.0,-151.32,-22.42).
city('Mutuaura','pf','Tubuai',291.0,-152.85,-22.65).
city('Rairua','pf','Tubuai',486.0,-147.67,-23.86).
city('Rapa','pf','Tubuai',485.0,-144.33,-27.6).
city('Taahuaia','pf','Tubuai',574.0,-149.46,-23.38).
city('Vaiuru','pf','Tubuai',235.0,-147.64,-23.86).
city('Cocobeach','ga','Estuaire',1653.0,9.6,0.99).
city('Kango','ga','Estuaire',1516.0,10.13,-0.15).
city('Libreville','ga','Estuaire',578156.0,9.45,0.39).
city('Nkan','ga','Estuaire',8526.0,9.75,0.39).
city('Ntoum','ga','Estuaire',8569.0,9.78,0.38).
city('Lekoni','ga','Haut-Ogooue',3583.0,14.23,-1.58).
city('Masuku','ga','Haut-Ogooue',42967.0,13.6,-1.63).
city('Moanda','ga','Haut-Ogooue',30151.0,13.22,-1.56).
city('Mounana','ga','Haut-Ogooue',8780.0,13.17,-1.43).
city('Okandja','ga','Haut-Ogooue',7155.0,13.79,-0.7).
city('Lambarene','ga','Moyen-Ogooue',20714.0,10.21,-0.7).
city('Ndjole','ga','Moyen-Ogooue',5098.0,10.76,-0.18).
city('Fougamou','ga','Ngounie',5649.0,10.6,-1.22).
city('Mbigou','ga','Ngounie',4134.0,11.93,-1.88).
city('Mimongo','ga','Ngounie',3307.0,11.65,-1.63).
city('Mouila','ga','Ngounie',22469.0,11.0,-1.88).
city('Ndende','ga','Ngounie',6200.0,11.38,-2.38).
city('Mayumba','ga','Nyanga',3996.0,10.66,-3.42).
city('Tchibanga','ga','Nyanga',19365.0,11.03,-2.86).
city('Tsogni','ga','Nyanga',9957.0,10.11,-2.79).
city('Booue','ga','Ogooue-Ivindo',5787.0,11.95,-0.09).
city('Makokou','ga','Ogooue-Ivindo',13571.0,12.85,0.56).
city('Mekambo','ga','Ogooue-Ivindo',3858.0,13.93,-1.02).
city('Koulamoutou','ga','Ogooue-Lolo',16222.0,12.5,-1.12).
city('Lastoursville','ga','Ogooue-Lolo',8340.0,12.71,-0.81).
city('Gamba','ga','Ogooue-Maritime',9928.0,10.0,-2.65).
city('Omboue','ga','Ogooue-Maritime',1667.0,9.25,-1.57).
city('Port-Gentil','ga','Ogooue-Maritime',109163.0,8.78,-0.72).
city('Bitam','ga','Woleu-Ntem',10297.0,11.48,2.08).
city('Medouneu','ga','Woleu-Ntem',1929.0,10.78,-0.95).
city('Minvoul','ga','Woleu-Ntem',2894.0,12.13,-2.15).
city('Mitzic','ga','Woleu-Ntem',3886.0,11.55,0.79).
city('Oyem','ga','Woleu-Ntem',30870.0,11.57,1.6).
city('Banjul','gm','Banjul',34598.0,-16.6,13.46).
city('Basse','gm','Basse',16190.0,-14.23,13.31).
city('Gambissara','gm','Basse',6755.0,-14.32,13.24).
city('Sabi','gm','Basse',7738.0,-14.18,13.24).
city('Salikeni','gm','Basse',4122.0,-14.02,13.35).
city('Brikama','gm','Brikama',101805.0,-16.66,13.28).
city('Brufut','gm','Brikama',9332.0,-16.78,13.41).
city('Gunjur','gm','Brikama',12530.0,-16.74,13.2).
city('Sukuta','gm','Brikama',15131.0,-16.71,13.4).
city('Bansang','gm','Janjanbureh',7152.0,-14.65,13.43).
city('Janjanbureh','gm','Janjanbureh',4929.0,-14.77,13.55).
city('Bakau','gm','Kanifing',47654.0,-16.69,13.49).
city('Serekunda','gm','Kanifing',218790.0,-16.68,13.45).
city('Barra','gm','Kerewan',5323.0,-16.57,13.49).
city('Essau','gm','Kerewan',4997.0,-16.54,13.47).
city('Farafenni','gm','Kerewan',36831.0,-15.61,13.57).
city('Kerewan','gm','Kerewan',3017.0,-16.1,13.49).
city('Lamin','gm','Kerewan',16525.0,-16.44,13.37).
city('Kuntaur','gm','Kuntaur',11399.0,-14.87,13.65).
city('Mansakonko','gm','Mansakonko',2187.0,-15.55,13.47).
city('Akhali Atoni','ge','Abkhasia',3062.0,40.8,43.1).
city('Gagra','ge','Abkhasia',8266.0,40.24,43.34).
city('Gali','ge','Abkhasia',11861.0,41.73,42.63).
city('Gudauta','ge','Abkhasia',11673.0,40.62,43.1).
city('Gulripshi','ge','Abkhasia',8927.0,41.1,42.93).
city('Ochamchira','ge','Abkhasia',15517.0,41.46,42.72).
city('Pitsunda','ge','Abkhasia',8402.0,40.35,43.15).
city('Sukhumi','ge','Abkhasia',81546.0,41.0,43.01).
city('Tkvarcheli','ge','Abkhasia',17847.0,41.67,42.84).
city('Batumi','ge','Ajaria',118297.0,41.65,41.65).
city('Chakvi','ge','Ajaria',5580.0,41.73,41.73).
city('Dioknisi','ge','Ajaria',7727.0,42.39,41.65).
city('Keda','ge','Ajaria',1362.0,41.94,41.6).
city('Khelvachauri','ge','Ajaria',3774.0,41.68,41.58).
city('Khulo','ge','Ajaria',768.0,42.31,41.65).
city('Kobuleti','ge','Ajaria',18159.0,41.78,41.82).
city('Makhinjauri','ge','Ajaria',2736.0,41.71,41.67).
city('Ochkhamuri','ge','Ajaria',2061.0,41.84,41.86).
city('Shuakhevi','ge','Ajaria',380.0,42.19,41.63).
city('Chokhatauri','ge','Guria',3456.0,42.26,42.02).
city('Kveda Nasakirali','ge','Guria',2453.0,42.24,42.01).
city('Laituri','ge','Guria',4954.0,41.91,41.91).
city('Lanchkhuti','ge','Guria',7639.0,42.03,42.08).
city('Naruja','ge','Guria',3065.0,41.93,41.91).
city('Ozurgeti','ge','Guria',17745.0,41.99,41.93).
city('Ureki','ge','Guria',1625.0,41.76,41.99).
city('Bagdati','ge','Imereti',4564.0,46.03,41.82).
city('Chiatura','ge','Imereti',12223.0,43.27,42.29).
city('Kharagauli','ge','Imereti',5096.0,43.21,42.02).
city('Khoni','ge','Imereti',10796.0,42.42,42.32).
city('Kulashi','ge','Imereti',2691.0,42.36,42.2).
city('Kutaisi','ge','Imereti',178350.0,42.72,42.26).
city('Sachkhere','ge','Imereti',6449.0,43.33,42.32).
city('Samtredia','ge','Imereti',28751.0,42.35,42.17).
city('Shorapani','ge','Imereti',1699.0,43.12,42.1).
city('Terjola','ge','Imereti',5312.0,42.98,42.3).
city('Tkibuli','ge','Imereti',13203.0,42.96,42.35).
city('Tskaltubo','ge','Imereti',16737.0,42.6,42.33).
city('Vani','ge','Imereti',4266.0,42.51,42.1).
city('Zestaphoni','ge','Imereti',23945.0,43.01,42.11).
city('Akhmeta','ge','Kakheti',8569.0,45.2,42.04).
city('Dedoplis Tskaro','ge','Kakheti',7302.0,44.45,42.04).
city('Gurjaani','ge','Kakheti',9467.0,45.8,41.75).
city('Kvareli','ge','Kakheti',8613.0,45.8,41.95).
city('Lagodekhi','ge','Kakheti',6551.0,46.27,41.83).
city('Sagarejo','ge','Kakheti',12174.0,45.34,41.74).
city('Signag','ge','Kakheti',1923.0,45.9,41.62).
city('Telavi','ge','Kakheti',20586.0,45.47,41.92).
city('Tsnori','ge','Kakheti',6613.0,45.96,41.62).
city('Bediani','ge','Kvemo Kartli',227.0,44.24,41.54).
city('Bolnisi','ge','Kvemo Kartli',9030.0,44.59,41.45).
city('Didi Lilo','ge','Kvemo Kartli',3349.0,44.97,41.74).
city('Dmanisi','ge','Kvemo Kartli',3040.0,44.35,41.52).
city('Gardabani','ge','Kvemo Kartli',10973.0,45.08,41.47).
city('Kazreti','ge','Kvemo Kartli',7114.0,44.41,41.38).
city('Kojori','ge','Kvemo Kartli',678.0,44.69,41.66).
city('Manglisi','ge','Kvemo Kartli',4817.0,44.38,41.69).
city('Marneuli','ge','Kvemo Kartli',18757.0,44.8,41.47).
city('Rustavi','ge','Kvemo Kartli',109872.0,45.03,41.55).
city('Samgori','ge','Kvemo Kartli',3011.0,44.93,41.7).
city('Shaumiani','ge','Kvemo Kartli',5237.0,44.76,41.35).
city('Tamarisi','ge','Kvemo Kartli',660.0,44.71,41.47).
city('Tetri Tskaro','ge','Kvemo Kartli',3627.0,44.46,41.55).
city('Trialeti','ge','Kvemo Kartli',899.0,44.11,41.54).
city('Tsalka','ge','Kvemo Kartli',1572.0,44.08,41.6).
city('Akhalgori','ge','Mtskheta-Mtianeti',1420.0,44.48,42.12).
city('Dusheti','ge','Mtskheta-Mtianeti',7026.0,44.7,42.09).
city('Jinvali','ge','Mtskheta-Mtianeti',3446.0,44.76,42.14).
city('Kazbegi','ge','Mtskheta-Mtianeti',2628.0,44.64,42.66).
city('Mtskheta','ge','Mtskheta-Mtianeti',7423.0,44.7,41.84).
city('Pasanauri','ge','Mtskheta-Mtianeti',2904.0,44.69,42.35).
city('Sioni','ge','Mtskheta-Mtianeti',777.0,44.58,42.6).
city('Tianeti','ge','Mtskheta-Mtianeti',4852.0,44.96,42.11).
city('Zahesi','ge','Mtskheta-Mtianeti',1933.0,44.76,41.82).
city('Ambrolauri','ge','Raga-Lechkumi and Kverno Svaneti',2408.0,43.15,42.52).
city('Kharistvala','ge','Raga-Lechkumi and Kverno Svaneti',114.0,43.04,42.41).
city('Lajanurhesi','ge','Raga-Lechkumi and Kverno Svaneti',95.0,42.84,42.62).
city('Lentekhi','ge','Raga-Lechkumi and Kverno Svaneti',10442.0,42.73,42.79).
city('Oni','ge','Raga-Lechkumi and Kverno Svaneti',3014.0,43.44,42.58).
city('Tsageri','ge','Raga-Lechkumi and Kverno Svaneti',2163.0,42.76,42.65).
city('Abasha','ge','Samagrelo and Zemo Svaneti',6222.0,42.21,42.21).
city('Chkhototsku','ge','Samagrelo and Zemo Svaneti',4357.0,42.1,42.5).
city('Jvari','ge','Samagrelo and Zem',4756.0,42.05,42.72).
city('Khobi','ge','Samagrelo and Zemo Svaneti',5376.0,41.9,42.33).
city('Martvili','ge','Samagrelo and Zemo Svaneti',5484.0,42.37,42.4).
city('Mestia','ge','Samagrelo and Zemo Svaneti',3187.0,42.73,43.05).
city('Poti','ge','Samagrelo and Zemo Svaneti',46112.0,41.66,42.15).
city('Senaki','ge','Samagrelo and Zemo Svaneti',27755.0,42.06,42.27).
city('Tsalenjikha','ge','Samagrelo and Zemo Svaneti',8881.0,42.05,42.57).
city('Zugdidi','ge','Samagrelo and Zemo Svaneti',73014.0,41.86,42.5).
city('Abastumani','ge','Samtskhe-Javakheti',1285.0,42.85,41.7).
city('Adigeni','ge','Samtskhe-Javakheti',1313.0,42.71,41.69).
city('Akhaldaba','ge','Samtskhe-Javakheti',3640.0,42.16,41.65).
city('Akhalkalaki','ge','Samtskhe-Javakheti',8892.0,43.48,41.4).
city('Akhaltsikhe','ge','Samtskhe-Javakheti',17300.0,42.98,41.64).
city('Aspindza','ge','Samtskhe-Javakheti',3940.0,43.26,41.57).
city('Bakuriani','ge','Samtskhe-Javakheti',2392.0,43.53,41.75).
city('Bakurianis Andeziti','ge','Samtskhe-Javakheti',1085.0,43.47,41.73).
city('Borjomi','ge','Samtskhe-Javakheti',13826.0,43.37,41.85).
city('Ninotsminda','ge','Samtskhe-Javakheti',6142.0,43.58,41.27).
city('Tsagve','ge','Samtskhe-Javakheti',2745.0,43.48,41.8).
city('Vale','ge','Samtskhe-Javakheti',4734.0,42.88,41.62).
city('Agara','ge','Shida Kartli',5811.0,43.81,42.04).
city('Gori','ge','Shida Kartli',46680.0,44.11,41.98).
city('Java','ge','Shida Kartli',426.0,43.94,42.4).
city('Kareli','ge','Shida Kartli',6944.0,43.89,42.02).
city('Kaspi','ge','Shida Kartli',14735.0,44.41,41.93).
city('Khashuri','ge','Shida Kartli',27814.0,43.6,41.99).
city('Kornisi','ge','Shida Kartli',208.0,43.82,42.27).
city('Kvaisi','ge','Shida Kartli',237.0,43.65,42.52).
city('Surami','ge','Shida Kartli',10091.0,43.56,42.02).
city('Tbilisi','ge','Tbilisi',1049516.0,44.79,41.72).
city('Tskneti','ge','Tbilisi',4172.0,44.7,41.69).
city('Aalen','de','Baden-Wuerttemberg',67593.0,10.09,48.85).
city('Achern','de','Baden-Wuerttemberg',24272.0,8.08,48.63).
city('Aichtal','de','Baden-Wuerttemberg',9885.0,9.23,48.63).
city('Albstadt','de','Baden-Wuerttemberg',47064.0,9.01,48.22).
city('Altensteig','de','Baden-Wuerttemberg',11122.0,8.61,48.58).
city('Ammerbuch','de','Baden-Wuerttemberg',11538.0,8.96,48.55).
city('Appenweier','de','Baden-Wuerttemberg',9649.0,7.8,48.55).
city('Asperg','de','Baden-Wuerttemberg',12627.0,9.14,48.92).
city('Backnang','de','Baden-Wuerttemberg',36477.0,9.43,48.95).
city('Bad Duerrheim','de','Baden-Wuerttemberg',12668.0,8.52,48.03).
city('Bad Friedrichshall','de','Baden-Wuerttemberg',18412.0,9.22,49.22).
city('Bad Krozingen','de','Baden-Wuerttemberg',16051.0,7.7,47.92).
city('Bad Liebenzell','de','Baden-Wuerttemberg',9665.0,8.73,48.77).
city('Bad Mergentheim','de','Baden-Wuerttemberg',22072.0,9.77,49.49).
city('Bad Rappenau','de','Baden-Wuerttemberg',20868.0,9.11,49.24).
city('Bad Saeckingen','de','Baden-Wuerttemberg',16483.0,7.94,47.56).
city('Bad Saulgau','de','Baden-Wuerttemberg',17771.0,9.49,48.02).
city('Bad Schoenborn','de','Baden-Wuerttemberg',12140.0,8.65,49.22).
city('Bad Urach','de','Baden-Wuerttemberg',13007.0,9.4,48.5).
city('Bad Waldsee','de','Baden-Wuerttemberg',19749.0,9.75,47.92).
city('Bad Wildbad','de','Baden-Wuerttemberg',11411.0,8.55,48.76).
city('Bad Wurzach','de','Baden-Wuerttemberg',14288.0,9.9,47.91).
city('Baden-Baden','de','Baden-Wuerttemberg',54802.0,8.23,48.76).
city('Baiersbronn','de','Baden-Wuerttemberg',16156.0,8.38,48.51).
city('Balingen','de','Baden-Wuerttemberg',34680.0,8.85,48.28).
city('Besigheim','de','Baden-Wuerttemberg',11667.0,9.14,49.01).
city('Biberach','de','Baden-Wuerttemberg',32501.0,9.78,48.1).
city('Bietigheim-Bissingen','de','Baden-Wuerttemberg',41979.0,9.13,48.96).
city('Birkenfeld','de','Baden-Wuerttemberg',10444.0,8.63,48.87).
city('Blaubeuren','de','Baden-Wuerttemberg',11900.0,9.78,48.41).
city('Blaustein','de','Baden-Wuerttemberg',14918.0,9.92,48.42).
city('Blumberg','de','Baden-Wuerttemberg',10666.0,8.53,47.84).
city('Boeblingen','de','Baden-Wuerttemberg',46830.0,9.02,48.7).
city('Bopfingen','de','Baden-Wuerttemberg',12669.0,10.35,48.87).
city('Brackenheim','de','Baden-Wuerttemberg',15031.0,9.07,49.08).
city('Breisach','de','Baden-Wuerttemberg',14083.0,7.58,48.04).
city('Bretten','de','Baden-Wuerttemberg',28774.0,8.7,49.05).
city('Bretzfeld','de','Baden-Wuerttemberg',12223.0,9.44,49.18).
city('Bruchsal','de','Baden-Wuerttemberg',43615.0,8.59,49.14).
city('Bruehl','de','Baden-Wuerttemberg',14344.0,8.53,49.41).
city('Buchen','de','Baden-Wuerttemberg',19276.0,9.33,49.52).
city('Buehl','de','Baden-Wuerttemberg',29434.0,8.13,48.71).
city('Burladingen','de','Baden-Wuerttemberg',13249.0,9.11,48.29).
city('Calw','de','Baden-Wuerttemberg',24220.0,8.74,48.72).
city('Crailsheim','de','Baden-Wuerttemberg',32666.0,10.06,49.14).
city('Denkendorf','de','Baden-Wuerttemberg',10096.0,9.32,48.69).
city('Denzlingen','de','Baden-Wuerttemberg',13388.0,7.88,48.07).
city('Dettingen','de','Baden-Wuerttemberg',9282.0,9.35,48.54).
city('Ditzingen','de','Baden-Wuerttemberg',24255.0,9.06,48.83).
city('Donaueschingen','de','Baden-Wuerttemberg',21699.0,8.49,47.96).
city('Donzdorf','de','Baden-Wuerttemberg',11038.0,9.8,48.69).
city('Dornstadt','de','Baden-Wuerttemberg',8374.0,9.94,48.46).
city('Dossenheim','de','Baden-Wuerttemberg',11794.0,8.68,49.45).
city('Durmersheim','de','Baden-Wuerttemberg',11742.0,8.27,48.94).
city('Eberbach','de','Baden-Wuerttemberg',15526.0,8.99,49.48).
city('Ebersbach','de','Baden-Wuerttemberg',16143.0,9.53,48.73).
city('Edingen-Neckarhausen','de','Baden-Wuerttemberg',13935.0,8.62,49.45).
city('Eggenstein-Leopoldshafen','de','Baden-Wuerttemberg',15222.0,8.38,49.09).
city('Ehingen','de','Baden-Wuerttemberg',26154.0,9.72,48.29).
city('Eislinge','de','Baden-Wuerttemberg',20343.0,9.7,48.71).
city('Ellwangen','de','Baden-Wuerttemberg',25396.0,10.13,48.97).
city('Emmendingen','de','Baden-Wuerttemberg',26820.0,7.85,48.13).
city('Engen','de','Baden-Wuerttemberg',10195.0,8.76,47.85).
city('Eningen','de','Baden-Wuerttemberg',10715.0,9.25,48.49).
city('Eppelheim','de','Baden-Wuerttemberg',14647.0,8.63,49.41).
city('Eppingen','de','Baden-Wuerttemberg',21457.0,8.91,49.14).
city('Erbach','de','Baden-Wuerttemberg',13238.0,9.87,48.34).
city('Esslingen','de','Baden-Wuerttemberg',92710.0,9.32,48.74).
city('Ettenheim','de','Baden-Wuerttemberg',11956.0,7.82,48.26).
city('Ettlingen','de','Baden-Wuerttemberg',39635.0,8.4,48.95).
city('Fellbach','de','Baden-Wuerttemberg',44142.0,9.27,48.82).
city('Filderstadt','de','Baden-Wuerttemberg',43580.0,9.23,48.67).
city('Freiberg','de','Baden-Wuerttemberg',15517.0,9.2,48.94).
city('Freiburg','de','Baden-Wuerttemberg',213920.0,7.85,47.99).
city('Freudenstadt','de','Baden-Wuerttemberg',24384.0,8.41,48.47).
city('Frickenhausen','de','Baden-Wuerttemberg',8917.0,9.36,48.59).
city('Friedrichshafen','de','Baden-Wuerttemberg',58005.0,9.48,47.66).
city('Friesenheim','de','Baden-Wuerttemberg',12616.0,8.41,49.5).
city('Furtwangen','de','Baden-Wuerttemberg',9763.0,8.2,48.05).
city('Gaertringen','de','Baden-Wuerttemberg',11438.0,8.9,48.65).
city('Gaggenau','de','Baden-Wuerttemberg',29800.0,8.33,48.81).
city('Gaildorf','de','Baden-Wuerttemberg',12683.0,9.77,49.0).
city('Geislingen','de','Baden-Wuerttemberg',28311.0,9.83,48.63).
city('Gengenbach','de','Baden-Wuerttemberg',11035.0,8.01,48.41).
city('Gerlingen','de','Baden-Wuerttemberg',18977.0,9.06,48.8).
city('Gernsbach','de','Baden-Wuerttemberg',14548.0,8.34,48.77).
city('Gerstetten','de','Baden-Wuerttemberg',12407.0,10.03,48.64).
city('Giengen','de','Baden-Wuerttemberg',20211.0,10.24,48.63).
city('Goeppingen','de','Baden-Wuerttemberg',58021.0,9.66,48.71).
city('Gottmadingen','de','Baden-Wuerttemberg',10242.0,8.78,47.74).
city('Graben-Neudorf','de','Baden-Wuerttemberg',11683.0,8.49,49.16).
city('Grenzach-Wyhlen','de','Baden-Wuerttemberg',13994.0,7.66,47.56).
city('Gundelfingen','de','Baden-Wuerttemberg',11475.0,7.86,48.05).
city('Haigerloch','de','Baden-Wuerttemberg',11066.0,8.79,48.37).
city('Hechingen','de','Baden-Wuerttemberg',19671.0,8.96,48.36).
city('Heddesheim','de','Baden-Wuerttemberg',11673.0,8.61,49.52).
city('Heidelberg','de','Baden-Wuerttemberg',144703.0,8.69,49.42).
city('Heidenheim','de','Baden-Wuerttemberg',50684.0,10.14,48.68).
city('Heilbronn','de','Baden-Wuerttemberg',121822.0,9.22,49.14).
city('Hemsbach','de','Baden-Wuerttemberg',12442.0,8.64,49.6).
city('Herbrechtingen','de','Baden-Wuerttemberg',13244.0,10.17,48.63).
city('Herrenberg','de','Baden-Wuerttemberg',31401.0,8.86,48.6).
city('Heubach','de','Baden-Wuerttemberg',10164.0,9.93,48.79).
city('Hirschberg','de','Baden-Wuerttemberg',9398.0,8.66,49.51).
city('Hockenheim','de','Baden-Wuerttemberg',20814.0,8.55,49.33).
city('Holzgerlingen','de','Baden-Wuerttemberg',11567.0,9.01,48.64).
city('Horb','de','Baden-Wuerttemberg',26287.0,8.68,48.44).
city('Isny','de','Baden-Wuerttemberg',14461.0,10.03,47.7).
city('Karlsbad','de','Baden-Wuerttemberg',16253.0,8.56,48.91).
city('Karlsruhe','de','Baden-Wuerttemberg',284786.0,8.4,49.0).
city('Kehl','de','Baden-Wuerttemberg',34493.0,7.81,48.59).
city('Kernen','de','Baden-Wuerttemberg',15127.0,9.32,48.79).
city('Ketsch','de','Baden-Wuerttemberg',12960.0,8.52,49.37).
city('Kirchheim','de','Baden-Wuerttemberg',40144.0,9.44,48.65).
city('Kirchzarten','de','Baden-Wuerttemberg',9575.0,7.94,47.97).
city('Koengen','de','Baden-Wuerttemberg',9879.0,9.36,48.68).
city('Konstanz','de','Baden-Wuerttemberg',81951.0,9.17,47.68).
city('Korb','de','Baden-Wuerttemberg',10305.0,9.36,48.84).
city('Korntal-Muenchingen','de','Baden-Wuerttemberg',18358.0,9.12,48.84).
city('Kornwestheim','de','Baden-Wuerttemberg',30756.0,9.19,48.87).
city('Kraichtal','de','Baden-Wuerttemberg',15092.0,8.73,49.15).
city('Kuenzelsau','de','Baden-Wuerttemberg',15128.0,9.69,49.29).
city('Ladenburg','de','Baden-Wuerttemberg',11621.0,8.6,49.47).
city('Lahr','de','Baden-Wuerttemberg',43676.0,7.86,48.34).
city('Laichingen','de','Baden-Wuerttemberg',11063.0,9.68,48.5).
city('Langenau','de','Baden-Wuerttemberg',14411.0,10.12,48.5).
city('Lauda-Koenigshofen','de','Baden-Wuerttemberg',15138.0,9.7,49.57).
city('Lauffen','de','Baden-Wuerttemberg',11191.0,9.15,49.08).
city('Laupheim','de','Baden-Wuerttemberg',19111.0,9.88,48.24).
city('Leimen','de','Baden-Wuerttemberg',27323.0,8.69,49.35).
city('Leinfelden-Echterdingen','de','Baden-Wuerttemberg',37210.0,9.13,48.71).
city('Lenningen','de','Baden-Wuerttemberg',8753.0,9.45,48.57).
city('Leonberg','de','Baden-Wuerttemberg',46276.0,9.02,48.8).
city('Leutenbach','de','Baden-Wuerttemberg',10718.0,9.39,48.9).
city('Leutkirch','de','Baden-Wuerttemberg',22645.0,10.02,47.83).
city('Lichtenstein','de','Baden-Wuerttemberg',9201.0,9.26,48.43).
city('Linkenheim-Hochstetten','de','Baden-Wuerttemberg',11783.0,8.41,49.12).
city('Loerrach','de','Baden-Wuerttemberg',47666.0,7.66,47.63).
city('Lorch','de','Baden-Wuerttemberg',11503.0,9.68,48.8).
city('Ludwigsburg','de','Baden-Wuerttemberg',87855.0,9.19,48.9).
city('Malsch','de','Baden-Wuerttemberg',14364.0,8.34,48.89).
city('Mannheim','de','Baden-Wuerttemberg',309626.0,8.47,49.5).
city('Marbach','de','Baden-Wuerttemberg',15353.0,9.26,48.94).
city('Markdorf','de','Baden-Wuerttemberg',12701.0,9.4,47.72).
city('Markgroeningen','de','Baden-Wuerttemberg',14766.0,9.08,48.9).
city('Meckenbeuren','de','Baden-Wuerttemberg',13121.0,9.56,47.7).
city('Mengen','de','Baden-Wuerttemberg',10155.0,9.33,48.05).
city('Messstetten','de','Baden-Wuerttemberg',10955.0,8.96,48.19).
city('Metzingen','de','Baden-Wuerttemberg',22034.0,9.29,48.54).
city('Moeglingen','de','Baden-Wuerttemberg',10460.0,9.13,48.89).
city('Moessingen','de','Baden-Wuerttemberg',20197.0,9.06,48.42).
city('Mosbach','de','Baden-Wuerttemberg',25474.0,9.15,49.36).
city('Muehlacker','de','Baden-Wuerttemberg',26674.0,8.84,48.96).
city('Muellheim','de','Baden-Wuerttemberg',18518.0,7.62,47.81).
city('Muensingen','de','Baden-Wuerttemberg',14466.0,9.5,48.42).
city('Murrhardt','de','Baden-Wuerttemberg',14381.0,9.57,48.99).
city('Nagold','de','Baden-Wuerttemberg',23486.0,8.73,48.55).
city('Neckargemuend','de','Baden-Wuerttemberg',14111.0,8.79,49.38).
city('Neckarsulm','de','Baden-Wuerttemberg',27530.0,9.22,49.19).
city('Neuenburg','de','Baden-Wuerttemberg',11538.0,7.56,47.82).
city('Neuhausen','de','Baden-Wuerttemberg',11566.0,9.27,48.69).
city('Niefern-Oeschelbronn','de','Baden-Wuerttemberg',12299.0,8.78,48.92).
city('Nuertingen','de','Baden-Wuerttemberg',41002.0,9.34,48.63).
city('Nussloch','de','Baden-Wuerttemberg',10861.0,8.7,49.34).
city('Oberhausen-Rheinhausen','de','Baden-Wuerttemberg',9580.0,8.5,49.27).
city('Oberkirch','de','Baden-Wuerttemberg',20264.0,8.08,48.54).
city('Oberndorf','de','Baden-Wuerttemberg',14890.0,8.56,48.29).
city('Obersulm','de','Baden-Wuerttemberg',13971.0,9.4,49.14).
city('Oehringen','de','Baden-Wuerttemberg',23068.0,9.5,49.21).
city('Oestringen','de','Baden-Wuerttemberg',12887.0,8.71,49.22).
city('Offenburg','de','Baden-Wuerttemberg',59109.0,7.95,48.48).
city('Oftersheim','de','Baden-Wuerttemberg',10228.0,8.59,49.37).
city('Ostfildern','de','Baden-Wuerttemberg',34162.0,9.26,48.72).
city('Pfinztal','de','Baden-Wuerttemberg',18101.0,8.55,48.98).
city('Pforzheim','de','Baden-Wuerttemberg',120366.0,8.69,48.89).
city('Pfullendorf','de','Baden-Wuerttemberg',13278.0,9.25,47.93).
city('Pfullingen','de','Baden-Wuerttemberg',18426.0,9.22,48.47).
city('Philippsburg','de','Baden-Wuerttemberg',12403.0,8.45,49.24).
city('Plankstadt','de','Baden-Wuerttemberg',9300.0,8.59,49.4).
city('Plochingen','de','Baden-Wuerttemberg',14627.0,9.42,48.72).
city('Pluederhausen','de','Baden-Wuerttemberg',9697.0,9.6,48.8).
city('Radolfzell','de','Baden-Wuerttemberg',30385.0,8.98,47.74).
city('Rastatt','de','Baden-Wuerttemberg',48452.0,8.2,48.86).
city('Ravensburg','de','Baden-Wuerttemberg',48441.0,9.6,47.79).
city('Remchingen','de','Baden-Wuerttemberg',11635.0,8.58,48.94).
city('Remseck','de','Baden-Wuerttemberg',22836.0,9.28,48.88).
city('Remshalden','de','Baden-Wuerttemberg',13601.0,9.41,48.82).
city('Renningen','de','Baden-Wuerttemberg',17725.0,8.93,48.77).
city('Reutlingen','de','Baden-Wuerttemberg',113625.0,9.21,48.49).
city('Rheinau','de','Baden-Wuerttemberg',10885.0,8.2,48.87).
city('Rheinfelden','de','Baden-Wuerttemberg',32538.0,7.79,47.57).
city('Rheinstetten','de','Baden-Wuerttemberg',20871.0,8.31,48.96).
city('Riedlingen','de','Baden-Wuerttemberg',10466.0,9.48,48.15).
city('Rielasingen-Worblingen','de','Baden-Wuerttembe',12006.0,8.84,47.73).
city('Rottenburg','de','Baden-Wuerttemberg',43117.0,8.93,48.49).
city('Rottweil','de','Baden-Wuerttemberg',25783.0,8.62,48.17).
city('Rudersberg','de','Baden-Wuerttemberg',11651.0,9.52,48.89).
city('Rutesheim','de','Baden-Wuerttemberg',10175.0,8.95,48.81).
city('Sachsenheim','de','Baden-Wuerttemberg',16940.0,9.06,48.96).
city('Salem','de','Baden-Wuerttemberg',11253.0,9.28,47.78).
city('Sandhausen','de','Baden-Wuerttemberg',14329.0,8.65,49.35).
city('Sankt Georgen','de','Baden-Wuerttemberg',13825.0,8.32,48.14).
city('Sankt Leon-Rot','de','Bad',12143.0,8.6,49.27).
city('Schoenaich','de','Baden-Wuerttemberg',10145.0,9.06,48.66).
city('Schopfheim','de','Baden-Wuerttemberg',19919.0,7.81,47.66).
city('Schorndorf','de','Baden-Wuerttemberg',39919.0,9.52,48.81).
city('Schramberg','de','Baden-Wuerttemberg',18637.0,8.38,48.24).
city('Schriesheim','de','Baden-Wuerttemberg',14448.0,8.66,49.49).
city('Schwaebisch Gmuend','de','Baden-Wuerttemberg',61379.0,9.79,48.81).
city('Schwaebisch Hall','de','Baden-Wuerttemberg',36590.0,9.73,49.12).
city('Schwaigern','de','Baden-Wuerttemberg',11032.0,9.06,49.16).
city('Schwetzingen','de','Baden-Wuerttemberg',23270.0,8.58,49.39).
city('Schwieberdingen','de','Baden-Wuerttemberg',10308.0,9.07,48.88).
city('Sigmaringen','de','Baden-Wuerttemberg',17023.0,9.21,48.09).
city('Sindelfingen','de','Baden-Wuerttemberg',61686.0,9.01,48.71).
city('Singen','de','Baden-Wuerttemberg',46386.0,8.84,47.77).
city('Sinsheim','de','Baden-Wuerttemberg',35740.0,8.87,49.26).
city('Sinzheim','de','Baden-Wuerttemberg',11131.0,8.17,48.77).
city('Spaichingen','de','Baden-Wuerttemberg',12258.0,8.73,48.08).
city('Steinen','de','Baden-Wuerttemberg',10038.0,7.75,47.65).
city('Steinheim','de','Baden-Wuerttemberg',11493.0,9.28,48.97).
city('Stockach','de','Baden-Wuerttemberg',16800.0,9.01,47.86).
city('Straubenhardt','de','Baden-Wuerttemberg',10721.0,8.56,48.84).
city('Stutensee','de','Baden-Wuerttemberg',22603.0,8.49,49.1).
city('Stuttgart','de','Baden-Wuerttemberg',591688.0,9.19,48.79).
city('Suessen','de','Baden-Wuerttemberg',10427.0,9.75,48.69).
city('Sulz','de','Baden-Wuerttemberg',12834.0,8.63,48.37).
city('Tamm','de','Baden-Wuerttemberg',12327.0,9.11,48.92).
city('Tauberbischofsheim','de','Baden-Wuerttemberg',13276.0,9.65,49.63).
city('Teningen','de','Baden-Wuerttemberg',11939.0,7.81,48.14).
city('Tettnang','de','Baden-Wuerttemberg',18365.0,9.59,47.67).
city('Titisee-Neustadt','de','Baden-Wuerttemberg',12092.0,8.17,47.9).
city('Trossingen','de','Baden-Wuerttemberg',15123.0,8.63,48.08).
city('Tuebingen','de','Baden-Wuerttemberg',83815.0,9.06,48.53).
city('Tuttlingen','de','Baden-Wuerttemberg',35133.0,8.8,47.99).
city('Ubstadt-Weiher','de','Baden-Wuerttemberg',12939.0,8.63,49.16).
city('Ueberlingen','de','Baden-Wuerttemberg',21613.0,9.16,47.77).
city('Uhingen','de','Baden-Wuerttemberg',14220.0,9.58,48.72).
city('Ulm','de','Baden-Wuerttemberg',120745.0,9.97,48.4).
city('Vaihingen','de','Baden-Wuerttemberg',29284.0,8.95,48.94).
city('Villingen-Schwenningen','de','Baden-Wuerttemberg',82286.0,8.45,48.07).
city('Waghaeusel','de','Baden-Wuerttemberg',19373.0,8.5,49.25).
city('Waiblingen','de','Baden-Wuerttemberg',53515.0,9.31,48.83).
city('Waldbronn','de','Baden-Wuerttemberg',12269.0,8.48,48.92).
city('Waldkirch','de','Baden-Wuerttemberg',20193.0,7.96,48.1).
city('Waldshut-Tiengen','de','Baden-Wuerttemberg',22648.0,8.2,47.64).
city('Walldorf','de','Baden-Wuerttemberg',14488.0,8.64,49.31).
city('Wallduern','de','Baden-Wuerttemberg',11960.0,9.36,49.59).
city('Wangen','de','Baden-Wuerttemberg',27054.0,9.83,47.69).
city('Wehr','de','Baden-Wuerttemberg',13042.0,7.91,47.63).
city('Weil','de','Baden-Wuerttemberg',29546.0,7.6,47.59).
city('Weil der Stadt','de','Baden-Wuerttemberg',19310.0,8.87,48.75).
city('Weil im Schoenbuch','de','Baden-Wuerttemberg',10245.0,9.06,48.63).
city('Weilheim','de','Baden-Wuerttemberg',9534.0,9.53,48.62).
city('Weingarten','de','Baden-Wuerttemberg',23928.0,9.63,47.81).
city('Weinheim','de','Baden-Wuerttemberg',43217.0,8.66,49.56).
city('Weinsberg','de','Baden-Wuerttemberg',11910.0,9.28,49.15).
city('Weinstadt','de','Baden-Wuerttemberg',26627.0,9.38,48.82).
city('Welzheim','de','Baden-Wuerttemberg',11286.0,9.63,48.88).
city('Wendlingen','de','Baden-Wuerttemberg',16199.0,9.37,48.67).
city('Wernau','de','Baden-Wuerttemberg',12668.0,9.42,48.7).
city('Wertheim','de','Baden-Wuerttemberg',24920.0,9.51,49.76).
city('Wiesloch','de','Baden-Wuerttemberg',26642.0,8.69,49.3).
city('Wildberg','de','Baden-Wuerttemberg',10186.0,8.75,48.64).
city('Winnenden','de','Baden-Wuerttemberg',28230.0,9.4,48.88).
city('Abensberg','de','Bavaria',12543.0,11.85,48.82).
city('Aichach','de','Bavaria',20935.0,11.13,48.47).
city('Ainring','de','Bavaria',9852.0,12.95,47.82).
city('Altdorf','de','Bavaria',13508.0,11.76,48.77).
city('Altoetting','de','Bavaria',12998.0,12.68,48.23).
city('Altusried','de','Bavaria',10084.0,10.21,47.81).
city('Alzenau','de','Bavaria',19083.0,9.06,50.09).
city('Amberg','de','Bavaria',44873.0,11.85,49.45).
city('Ansbach','de','Bavaria',40822.0,10.57,49.3).
city('Aschaffenburg','de','Bavaria',69248.0,9.15,49.99).
city('Augsburg','de','Bavaria',261842.0,10.89,48.36).
city('Bad Aibling','de','Bavaria',17926.0,12.0,47.87).
city('Bad Kissingen','de','Bavaria',21527.0,10.08,50.21).
city('Bad Neustadt','de','Bavaria',16268.0,10.21,50.33).
city('Bad Reichenhall','de','Bavaria',16823.0,12.88,47.73).
city('Bad Staffelstein','de','Bavaria',10632.0,10.98,50.11).
city('Bad Toelz','de','Bavaria',17378.0,11.56,47.76).
city('Bad Windsheim','de','Bavaria',12033.0,10.42,49.51).
city('Bad Woerishofen','de','Bavaria',13922.0,10.6,48.01).
city('Bamberg','de','Bavaria',70471.0,10.9,49.9).
city('Bayreuth','de','Bavaria',74840.0,11.58,49.95).
city('Bobingen','de','Bavaria',16595.0,10.82,48.27).
city('Bogen','de','Bavaria',10458.0,12.69,48.9).
city('Bruckmuehl','de','Bavaria',16178.0,11.92,47.89).
city('Buchloe','de','Bavaria',11997.0,10.72,48.05).
city('Burghausen','de','Bavaria',18376.0,12.83,48.17).
city('Burgkirchen','de','Bavaria',10795.0,12.73,48.17).
city('Burglengenfeld','de','Bavaria',12098.0,12.04,49.21).
city('Burgthann','de','Bavaria',11615.0,11.3,49.35).
city('Cadolzburg','de','Bavaria',10188.0,10.86,49.46).
city('Cham','de','Bavaria',17393.0,12.65,49.23).
city('Coburg','de','Bavaria',42413.0,10.95,50.27).
city('Dachau','de','Bavaria',39815.0,11.43,48.26).
city('Deggendorf','de','Bavaria',31146.0,12.96,48.85).
city('Diedorf','de','Bavaria',10348.0,10.77,48.35).
city('Diessen','de','Bavaria',10025.0,11.1,47.95).
city('Dillingen','de','Bavaria',19013.0,10.5,48.58).
city('Dingolfing','de','Bavaria',18733.0,12.5,48.64).
city('Dinkelsbuehl','de','Bavaria',11581.0,10.32,49.08).
city('Donauwoerth','de','Bavaria',18550.0,10.78,48.73).
city('Dorfen','de','Bavaria',13425.0,12.15,48.28).
city('Ebersberg','de','Bavaria',11082.0,11.97,48.08).
city('Eching','de','Bavaria',13247.0,11.59,48.29).
city('Eckental','de','Bavaria',14346.0,11.21,49.58).
city('Eggenfelden','de','Bavaria',12988.0,12.76,48.41).
city('Eichenau','de','Bavaria',11614.0,11.32,48.18).
city('Eichstaett','de','Bavaria',13166.0,11.2,48.89).
city('Elchingen','de','Bavaria',9315.0,10.1,48.46).
city('Erding','de','Bavaria',32377.0,11.89,48.31).
city('Ergolding','de','Bavaria',11513.0,12.17,48.58).
city('Erlangen','de','Bavaria',102781.0,11.01,49.6).
city('Erlenbach','de','Bavaria',10095.0,9.15,49.81).
city('Essenbach','de','Bavaria',11013.0,12.21,48.62).
city('Feldkirchen-Westerham','de','Bavaria',10177.0,11.85,47.9).
city('Feucht','de','Bavaria',13585.0,11.21,49.38).
city('Feuchtwangen','de','Bavaria',12207.0,10.33,49.17).
city('Forchheim','de','Bavaria',30838.0,11.06,49.73).
city('Freilassing','de','Bavaria',16033.0,12.99,47.84).
city('Freising','de','Bavaria',42322.0,11.73,48.41).
city('Friedberg','de','Bavaria',29581.0,10.98,48.36).
city('Fuerstenfeldbruck','de','Bavaria',34194.0,11.25,48.19).
city('Fuerth','de','Bavaria',112959.0,10.98,49.48).
city('Fuessen','de','Bavaria',14002.0,10.7,47.58).
city('Furth im Wald','de','Bavaria',9400.0,12.84,49.31).
city('Gaimersheim','de','Bavaria',10998.0,11.37,48.82).
city('Garching','de','Bavaria',15380.0,11.65,48.24).
city('Garmisch-Partenkirchen','de','Bavaria',26346.0,11.08,47.5).
city('Gauting','de','Bavaria',19381.0,11.38,48.08).
city('Gemuenden','de','Bavaria',11560.0,9.7,50.05).
city('Geretsried','de','Bavaria',23377.0,11.46,47.87).
city('Germering','de','Bavaria',36905.0,11.36,48.13).
city('Gersthofen','de','Bavaria',20322.0,10.88,48.43).
city('Gilching','de','Bavaria',17204.0,11.29,48.12).
city('Goldbach','de','Bavaria',10038.0,9.18,50.0).
city('Graefelfing','de','Bavaria',12992.0,11.44,48.12).
city('Grafenau','de','Bavaria',9180.0,13.39,48.86).
city('Grafing','de','Bavaria',12469.0,11.96,48.05).
city('Groebenzell','de','Bavaria',19181.0,11.36,48.2).
city('Grossostheim','de','Bavaria',16473.0,9.08,49.92).
city('Gruenwald','de','Bavaria',11173.0,11.54,48.05).
city('Guenzburg','de','Bavaria',19507.0,10.28,48.46).
city('Gunzenhausen','de','Bavaria',16666.0,10.76,49.12).
city('Haar','de','Bavaria',17810.0,11.73,48.11).
city('Hammelburg','de','Bavaria',11798.0,9.88,50.13).
city('Hassfurt','de','Bavaria',13599.0,10.5,50.05).
city('Hauzenberg','de','Bavaria',12471.0,13.62,48.65).
city('Helmbrechts','de','Bavaria',9539.0,11.69,50.24).
city('Hersbruck','de','Bavaria',12506.0,11.43,49.52).
city('Herzogenaurach','de','Bavaria',23229.0,10.88,49.57).
city('Hilpoltstein','de','Bavaria',12968.0,11.18,49.19).
city('Hirschaid','de','Bavaria',11514.0,10.98,49.82).
city('Hoechstadt','de','Bavaria',13470.0,10.79,49.7).
city('Hoesbach','de','Bavaria',13258.0,9.19,50.0).
city('Hof','de','Bavaria',49353.0,11.9,50.32).
city('Holzkirchen','de','Bavaria',15459.0,11.69,47.88).
city('Illertissen','de','Bavaria',16623.0,10.1,48.23).
city('Immenstadt','de','Bavaria',14282.0,10.21,47.57).
city('Ingolstadt','de','Bavaria',120598.0,11.43,48.77).
city('Ismaning','de','Bavaria',14722.0,11.68,48.22).
city('Karlsfeld','de','Bavaria',17958.0,11.46,48.22).
city('Karlstadt','de','Bavaria',15247.0,9.77,49.97).
city('Kaufbeuren','de','Bavaria',43454.0,10.61,47.89).
city('Kelheim','de','Bavaria',16227.0,11.86,48.93).
city('Kempten','de','Bavaria',61800.0,10.3,47.73).
city('Kirchheim','de','Bavaria',11982.0,11.76,48.18).
city('Kissing','de','Bavaria',11072.0,10.98,48.3).
city('Kitzingen','de','Bavaria',21705.0,10.15,49.74).
city('Koenigsbrunn','de','Bavaria',27786.0,10.89,48.28).
city('Kolbermoor','de','Bavaria',18488.0,12.06,47.85).
city('Kronach','de','Bavaria',18349.0,11.32,50.24).
city('Krumbach','de','Bavaria',12518.0,10.36,48.25).
city('Kuemmersbruck','de','Bavaria',10458.0,11.87,49.42).
city('Kulmbach','de','Bavaria',27346.0,11.44,50.12).
city('Landau','de','Bavaria',13026.0,12.69,48.68).
city('Landsberg','de','Bavaria',26624.0,10.87,48.06).
city('Landshut','de','Bavaria',61131.0,12.14,48.54).
city('Langenzenn','de','Bavaria',10767.0,10.79,49.5).
city('Lappersdorf','de','Bavaria',12817.0,12.1,49.05).
city('Lauf','de','Bavaria',26181.0,11.28,49.52).
city('Lauingen','de','Bavaria',10991.0,10.43,48.57).
city('Lenggries','de','Bavaria',9409.0,11.58,47.68).
city('Lichtenfels','de','Bavaria',21586.0,11.06,50.16).
city('Lindau','de','Bavaria',24161.0,9.7,47.56).
city('Lindenberg','de','Bavaria',11614.0,9.85,47.59).
city('Lohr','de','Bavaria',16297.0,9.58,49.98).
city('Mainburg','de','Bavaria',13944.0,11.78,48.65).
city('Maisach','de','Bavaria',12623.0,11.26,48.22).
city('Manching','de','Bavaria',11297.0,11.5,48.72).
city('Markt Schwaben','de','Bavaria',11251.0,11.88,48.2).
city('Marktheidenfeld','de','Bavaria',11023.0,9.6,49.85).
city('Marktoberdorf','de','Bavaria',18701.0,10.62,47.78).
city('Marktredwitz','de','Bavaria',18359.0,12.08,50.0).
city('Maxhuette-Haidhof','de','Bavaria',10610.0,12.09,49.21).
city('Meitingen','de','Bavaria',11245.0,10.85,48.55).
city('Memmingen','de','Bavaria',41210.0,10.18,47.99).
city('Mering','de','Bavaria',12437.0,10.99,48.27).
city('Miesbach','de','Bavaria',11394.0,11.83,47.79).
city('Miltenberg','de','Bavaria',9706.0,9.26,49.71).
city('Mindelheim','de','Bavaria',14221.0,10.49,48.05).
city('Moembris','de','Bavaria',12393.0,9.16,50.07).
city('Moosburg','de','Bavaria',17394.0,11.93,48.48).
city('Muehldorf','de','Bavaria',17940.0,12.52,48.26).
city('Muenchberg','de','Bavaria',11646.0,11.78,50.2).
city('Munich','de','Bavaria',1246133.0,11.58,48.14).
city('Murnau','de','Bavaria',12223.0,11.2,47.69).
city('Naila','de','Bavaria',8349.0,11.7,50.32).
city('Neu-Ulm','de','Bavaria',51654.0,10.01,48.4).
city('Neubiberg','de','Bavaria',13057.0,11.67,48.09).
city('Neuburg','de','Bavaria',28654.0,11.18,48.74).
city('Neufahrn','de','Bavaria',18487.0,11.67,48.32).
city('Neumarkt','de','Bavaria',39834.0,11.46,49.28).
city('Neusaess','de','Bavaria',21923.0,9.35,49.62).
city('Neustadt','de','Bavaria',13982.0,11.17,49.57).
city('Neutraubling','de','Bavaria',12645.0,12.2,48.99).
city('Noerdlingen','de','Bavaria',19646.0,10.49,48.86).
city('Nuremberg','de','Bavaria',497593.0,11.05,49.45).
city('Oberasbach','de','Bavaria',17343.0,10.95,49.44).
city('Oberhaching','de','Bavaria',12416.0,11.59,48.03).
city('Oberschleissheim','de','Bavaria',11517.0,11.55,48.26).
city('Oberstdorf','de','Bavaria',9895.0,10.28,47.41).
city('Ochsenfurt','de','Bavaria',11531.0,10.06,49.67).
city('Olching','de','Bavaria',24526.0,11.33,48.21).
city('Osterhofen','de','Bavaria',12010.0,13.02,48.71).
city('Ottobrunn','de','Bavaria',19254.0,11.67,48.07).
city('Passau','de','Bavaria',51091.0,13.44,48.58).
city('Pegnitz','de','Bavaria',14337.0,11.54,49.76).
city('Peissenberg','de','Bavaria',12852.0,11.07,47.81).
city('Peiting','de','Bavaria',12048.0,10.92,47.8).
city('Penzberg','de','Bavaria',16243.0,11.38,47.76).
city('Pfaffenhofen','de','Bavaria',23443.0,11.5,48.53).
city('Pfarrkirchen','de','Bavaria',12029.0,12.93,48.44).
city('Planegg','de','Bavaria',10669.0,11.43,48.11).
city('Plattling','de','Bavaria',12590.0,12.86,48.79).
city('Pocking','de','Bavaria',14816.0,13.31,48.41).
city('Poing','de','Bavaria',11498.0,11.81,48.17).
city('Prien','de','Bavaria',10264.0,12.34,47.87).
city('Puchheim','de','Bavaria',19278.0,11.35,48.15).
city('Ratisbon','de','Bavaria',129643.0,12.11,49.02).
city('Raubling','de','Bavaria',11403.0,12.1,47.79).
city('Regen','de','Bavaria',12591.0,13.12,48.98).
city('Regenstauf','de','Bavaria',15078.0,12.12,49.13).
city('Rehau','de','Bavaria',10279.0,12.04,50.25).
city('Roding','de','Bavaria',11428.0,12.5,49.2).
city('Roedental','de','Bavaria',13973.0,11.04,50.3).
city('Roethenbach','de','Bavaria',12084.0,11.24,49.49).
city('Rosenheim','de','Bavaria',60768.0,12.15,47.86).
city('Roth','de','Bavaria',24959.0,11.09,49.25).
city('Rothenburg','de','Bavaria',11422.0,10.18,49.3).
city('Schongau','de','Bavaria',12634.0,10.89,47.82).
city('Schrobenhausen','de','Bavaria',16177.0,11.26,48.57).
city('Schwabach','de','Bavaria',38921.0,11.03,49.33).
city('Schwabmuenchen','de','Bavaria',13209.0,10.76,48.19).
city('Schwandorf','de','Bavaria',28124.0,12.11,49.33).
city('Schwarzenbach','de','Bavaria',5074.0,11.93,50.23).
city('Schweinfurt','de','Bavaria',54801.0,10.22,50.06).
city('Selb','de','Bavaria',17172.0,12.13,50.18).
city('Senden','de','Bavaria',22199.0,10.06,48.32).
city('Simbach','de','Bavaria',10015.0,13.02,48.28).
city('Sonthofen','de','Bavaria',21512.0,10.29,47.52).
city('Stadtbergen','de','Bavaria',14837.0,10.85,48.37).
city('Starnberg','de','Bavaria',22827.0,11.34,48.01).
city('Stein','de','Bavaria',13885.0,11.02,49.42).
city('Stephanskirchen','de','Bavaria',9812.0,12.18,47.86).
city('Straubing','de','Bavaria',44504.0,12.57,48.89).
city('Sulzbach-Rosenberg','de','Bavaria',20511.0,11.74,49.51).
city('Taufkirchen','de','Bavaria',17922.0,11.61,48.05).
city('Tirschenreuth','de','Bavaria',9379.0,12.33,49.89).
city('Toeging','de','Bavaria',9830.0,12.57,48.25).
city('Traunreut','de','Bavaria',21535.0,12.6,47.97).
city('Traunstein','de','Bavaria',18275.0,12.64,47.87).
city('Treuchtlingen','de','Bavaria',13208.0,10.91,48.96).
city('Trostberg','de','Bavaria',11640.0,12.55,48.03).
city('Tutzing','de','Bavaria',9411.0,11.27,47.92).
city('Unterhaching','de','Bavaria',20751.0,11.6,48.08).
city('Unterschleissheim','de','Bavaria',26418.0,11.58,48.28).
city('Vaterstetten','de','Bavaria',20962.0,11.77,48.11).
city('Vilsbiburg','de','Bavaria',11538.0,12.35,48.46).
city('Vilshofen','de','Bavaria',16800.0,13.18,48.64).
city('Voehringen','de','Bavaria',13092.0,10.08,48.28).
city('Volkach','de','Bavaria',9424.0,10.23,49.87).
city('Waldkirchen','de','Bavaria',10716.0,13.59,48.73).
city('Waldkraiburg','de','Bavaria',24939.0,12.39,48.21).
city('Wasserburg','de','Bavaria',12539.0,12.2,48.06).
city('Weiden','de','Bavaria',42387.0,12.16,49.68).
city('Weilheim','de','Bavaria',21635.0,11.15,47.84).
city('Weissenburg','de','Bavaria',17740.0,10.97,49.04).
city('Weissenhorn','de','Bavaria',13367.0,10.17,48.3).
city('Wendelstein','de','Bavaria',16108.0,11.15,49.35).
city('Werneck','de','Bavaria',10764.0,10.1,49.99).
city('Wolfratshausen','de','Bavaria',17190.0,11.43,47.91).
city('Wolnzach','de','Bavaria',11071.0,11.62,48.61).
city('Wuerzburg','de','Bavaria',134499.0,9.94,49.8).
city('Wunsiedel','de','Bavaria',10319.0,12.01,50.04).
city('Zirndorf','de','Bavaria',25237.0,10.96,49.46).
city('Zwiesel','de','Bavaria',10484.0,13.23,49.02).
city('Berlin','de','Berlin',3398362.0,13.38,52.52).
city('Angermuende','de','Brandenburg',18200.0,13.99,53.03).
city('Bad Freienwalde','de','Brandenburg',15108.0,14.03,52.79).
city('Bad Liebenwerda','de','Brandenburg',10880.0,13.4,51.52).
city('Beeskow','de','Brandenburg',8547.0,14.24,52.18).
city('Bernau','de','Brandenburg',33481.0,13.58,52.68).
city('Blankenfelde-Mahlow','de','Brandenburg',24185.0,13.39,52.34).
city('Brandenburg','de','Brandenburg',75507.0,12.53,52.42).
city('Cottbus','de','Brandenburg',115246.0,14.33,51.77).
city('Eberswalde','de','Brandenburg',41384.0,13.8,52.84).
city('Eisenhuettenstadt','de','Brandenburg',35839.0,14.62,52.16).
city('Elsterwerda','de','Brandenburg',9714.0,13.51,51.47).
city('Erkner','de','Brandenburg',11866.0,13.74,52.42).
city('Falkensee','de','Brandenburg',37916.0,13.06,52.55).
city('Finsterwalde','de','Brandenburg',18733.0,13.7,51.63).
city('Forst','de','Brandenburg',22521.0,14.63,51.74).
city('Frankfurt','de','Brandenburg',64399.0,14.53,52.34).
city('Fredersdorf-Vogelsdorf','de','Brandenburg',12531.0,13.75,52.53).
city('Fuerstenwalde','de','Brandenburg',33199.0,14.06,52.37).
city('Grossraeschen','de','Brandenburg',11976.0,14.0,51.59).
city('Guben','de','Brandenburg',21602.0,14.7,51.95).
city('Hennigsdorf','de','Brandenburg',26498.0,13.21,52.64).
city('Herzberg','de','Brandenburg',12188.0,13.22,51.69).
city('Hohen Neuendorf','de','Brandenburg',22687.0,13.27,52.67).
city('Jueterbog','de','Brandenburg',13483.0,13.06,52.0).
city('Kleinmachnow','de','Brandenburg',18306.0,13.21,52.42).
city('Koenigs Wusterhausen','de','Brandenburg',33872.0,13.62,52.3).
city('Kolkwi','de','Brandenburg',10336.0,14.25,51.75).
city('Kyritz','de','Brandenburg',11321.0,12.39,52.95).
city('Lauchhammer','de','Brandenburg',18948.0,13.77,51.5).
city('Luckenwalde','de','Brandenburg',21217.0,13.17,52.1).
city('Ludwigsfelde','de','Brandenburg',24823.0,13.25,52.31).
city('Luebben','de','Brandenburg',14985.0,13.88,51.94).
city('Luebbenau','de','Brandenburg',21356.0,13.96,51.87).
city('Nauen','de','Brandenburg',19203.0,12.88,52.61).
city('Neuenhagen','de','Brandenburg',16111.0,13.69,52.53).
city('Neuruppin','de','Brandenburg',32173.0,12.81,52.94).
city('Oranienburg','de','Brandenburg',43275.0,13.23,52.75).
city('Perleberg','de','Brandenburg',13394.0,11.86,53.08).
city('Petershagen-Eggersdorf','de','Brandenburg',12972.0,13.78,52.51).
city('Potsdam','de','Brandenburg',145291.0,13.07,52.4).
city('Premnitz','de','Brandenburg',11176.0,12.35,52.54).
city('Prenzlau','de','Brandenburg',20922.0,13.87,53.33).
city('Pritzwalk','de','Brandenburg',15286.0,12.17,53.15).
city('Rathenow','de','Brandenburg',27058.0,12.33,52.6).
city('Ruedersdorf','de','Brandenburg',17943.0,13.78,52.48).
city('Schoeneiche','de','Brandenburg',11812.0,13.7,52.48).
city('Schwedt','de','Brandenburg',40005.0,14.26,53.07).
city('Senftenberg','de','Brandenburg',28812.0,13.99,51.53).
city('Spremberg','de','Brandenburg',28444.0,14.38,51.57).
city('Strausberg','de','Brandenburg',26835.0,13.88,52.58).
city('Teltow','de','Brandenburg',19624.0,13.3,52.41).
city('Templin','de','Brandenburg',19764.0,13.49,53.13).
city('Velten','de','Brandenburg',11697.0,13.18,52.69).
city('Werder','de','Brandenburg',25913.0,12.93,52.39).
city('Wittenberge','de','Brandenburg',20322.0,11.75,53.01).
city('Wittstock','de','Brandenburg',19811.0,12.48,53.17).
city('Zehdenick','de','Brandenburg',16310.0,13.34,52.99).
city('Bremen','de','Bremen',546429.0,8.81,53.08).
city('Bremerhaven','de','Bremen',119688.0,8.58,53.55).
city('Hamburg','de','Hamburg',1733846.0,10.0,53.55).
city('Alsfeld','de','Hassia',17968.0,9.26,50.76).
city('Altenstadt','de','Hassia',12388.0,8.94,50.29).
city('Asslar','de','Hassia',14041.0,8.46,50.61).
city('Babenhausen','de','Hassia',16551.0,8.95,49.97).
city('Bad Arolsen','de','Hassia',16901.0,9.01,51.39).
city('Bad Camberg','de','Hassia',13920.0,8.26,50.31).
city('Bad Hersfeld','de','Hassia',30630.0,9.7,50.88).
city('Bad Homburg','de','Hassia',51923.0,8.62,50.23).
city('Bad Nauheim','de','Hassia',30369.0,8.73,50.37).
city('Bad Orb','de','Hassia',10051.0,9.35,50.22).
city('Bad Schwalbach','de','Hassia',11259.0,8.06,50.14).
city('Bad Soden','de','Hassia',21418.0,8.5,50.14).
city('Bad Soden-Salmuenster','de','Hassia',13960.0,9.36,50.29).
city('Bad Sooden-Allendorf','de','Hassia',8955.0,9.97,51.28).
city('Bad Vilbel','de','Hassia',30933.0,8.74,50.19).
city('Bad Wildungen','de','Hassia',18078.0,9.12,51.13).
city('Baunatal','de','Hassia',28338.0,9.41,51.25).
city('Bebra','de','Hassia',14798.0,9.8,50.97).
city('Bensheim','de','Hassia',39450.0,8.62,49.68).
city('Biblis','de','Hassia',8824.0,8.44,49.69).
city('Biebertal','de','Hassia',10489.0,8.58,50.63).
city('Biedenkopf','de','Hassia',13736.0,8.52,50.92).
city('Birkenau','de','Hassia',10406.0,8.7,49.57).
city('Bischofsheim','de','Hassia',12114.0,8.35,49.99).
city('Borken','de','Hassia',13656.0,9.28,51.06).
city('Braunfels','de','Hassia',11398.0,8.4,50.52).
city('Bruchkoebel','de','Hassia',20820.0,8.91,50.19).
city('Buedingen','de','Hassia',22157.0,9.11,50.3).
city('Buerstadt','de','Hassia',15365.0,8.46,49.65).
city('Buettelborn','de','Hassia',13326.0,8.51,49.91).
city('Buseck','de','Hassia',13243.0,8.74,50.62).
city('Butzbach','de','Hassia',25804.0,8.66,50.44).
city('Darmstadt','de','Hassia',139757.0,8.64,49.87).
city('Dautphetal','de','Hassia',12168.0,8.54,50.86).
city('Dieburg','de','Hassia',15452.0,8.84,49.91).
city('Dietzenbach','de','Hassia',32975.0,8.78,50.02).
city('Dillenburg','de','Hassia',24772.0,8.29,50.75).
city('Dreieich','de','Hassia',41054.0,8.7,50.03).
city('Egelsbach','de','Hassia',9703.0,8.66,49.97).
city('Eichenzell','de','Hassia',10708.0,9.69,50.49).
city('Eltville','de','Hassia',16858.0,8.11,50.04).
city('Eppstein','de','Hassia',13512.0,8.39,50.14).
city('Erbach','de','Hassia',13501.0,8.98,49.66).
city('Erlensee','de','Hassia',12407.0,9.0,50.17).
city('Eschborn','de','Hassia',20438.0,8.54,50.14).
city('Eschenburg','de','Hassia',10641.0,8.29,50.81).
city('Eschwege','de','Hassia',21546.0,10.05,51.2).
city('Felsberg','de','Hassia',11244.0,9.41,51.14).
city('Floersheim','de','Hassia',19936.0,8.43,50.02).
city('Frankenberg','de','Hassia',19366.0,8.79,51.07).
city('Frankfurt','de','Hassia',648034.0,8.68,50.12).
city('Freigericht','de','Hassia',14940.0,9.12,50.14).
city('Friedberg','de','Hassia',28164.0,8.75,50.34).
city('Friedrichsdorf','de','Hassia',24897.0,8.65,50.27).
city('Fritzlar','de','Hassia',14798.0,9.27,51.14).
city('Fulda','de','Hassia',63851.0,9.69,50.55).
city('Fuldabrueck','de','Hassia',9098.0,9.59,51.24).
city('Fuldatal','de','Hassia',12102.0,9.57,51.39).
city('Geisenheim','de','Hassia',11959.0,7.96,49.99).
city('Gelnhausen','de','Hassia',21417.0,9.18,50.0).
city('Gernsheim','de','Hassia',9435.0,8.48,49.75).
city('Giessen','de','Hassia',74132.0,8.68,50.58).
city('Ginsheim-Gustavsburg','de','Hassia',16283.0,8.35,49.97).
city('Gladenbach','de','Hassia',12613.0,8.56,50.77).
city('Griesheim','de','Hassia',25432.0,8.56,49.87).
city('Gross-Gerau','de','Hassia',23996.0,8.48,49.93).
city('Gross-Umstadt','de','Hassia',21748.0,8.93,49.88).
city('Gross-Zimmern','de','Hassia',14032.0,8.83,49.88).
city('Gruenberg','de','Hassia',14360.0,8.95,50.6).
city('Gruendau','de','Hassia',14997.0,9.15,50.25).
city('Hadamar','de','Hassia',12328.0,8.4,50.46).
city('Haiger','de','Hassia',20134.0,8.21,50.76).
city('Hainburg','de','Hassia',15374.0,8.94,50.08).
city('Hanau','de','Hassia',89938.0,8.91,50.14).
city('Hattersheim','de','Hassia',25544.0,8.48,50.08).
city('Heppenheim','de','Hassia',25580.0,8.63,49.65).
city('Herborn','de','Hassia',21404.0,8.31,50.69).
city('Hessisch Lichtenau','de','Hassia',13394.0,9.71,51.2).
city('Heusenstamm','de','Hassia',19257.0,8.79,50.07).
city('Hochheim','de','Hassia',17203.0,8.35,50.02).
city('Hoechst','de','Hassia',10143.0,8.99,49.81).
city('Hofgeismar','de','Hassia',16199.0,9.38,51.5).
city('Hofheim','de','Hassia',38482.0,8.43,50.09).
city('Homberg','de','Hassia',14893.0,9.4,51.04).
city('Huenfeld','de','Hassia',16454.0,9.76,50.68).
city('Huenfelden','de','Hassia',10380.0,8.16,50.3).
city('Huettenberg','de','Hassia',10457.0,8.61,50.5).
city('Hungen','de','Hassia',12844.0,8.89,50.47).
city('Idstein','de','Hassia',23432.0,8.26,50.24).
city('Karben','de','Hassia',21718.0,8.74,50.24).
city('Kassel','de','Hassia',193117.0,9.48,51.32).
city('Kaufungen','de','Hassia',12804.0,9.62,51.28).
city('Kelkheim','de','Hassia',26823.0,8.44,50.14).
city('Kelsterbach','de','Hassia',14146.0,8.53,50.07).
city('Kirchhain','de','Hassia',16432.0,8.96,50.82).
city('Koenigstein','de','Hassia',15767.0,8.46,50.18).
city('Korbach','de','Hassia',24657.0,8.87,51.29).
city('Kriftel','de','Hassia',10590.0,8.47,50.09).
city('Kronberg','de','Hassia',17649.0,8.49,50.19).
city('Kuenzell','de','Hassia',16356.0,9.71,50.55).
city('Lampertheim','de','Hassia',31873.0,8.46,49.6).
city('Langen','de','Hassia',35755.0,8.67,50.0).
city('Langenselbold','de','Hassia',12652.0,9.03,50.19).
city('Langgoens','de','Hassia',12251.0,8.67,50.49).
city('Laubach','de','Hassia',10262.0,8.98,50.55).
city('Lauterbach','de','Hassia',14665.0,9.39,50.64).
city('Lich','de','Hassia',13410.0,8.82,50.53).
city('Limburg','de','Hassia',33955.0,8.05,50.39).
city('Linden','de','Hassia',12469.0,8.64,50.52).
city('Lohfelden','de','Hassia',13910.0,9.54,51.28).
city('Lollar','de','Hassia',10206.0,8.7,50.65).
city('Lorsch','de','Hassia',12829.0,8.56,49.65).
city('Maintal','de','Hassia',38656.0,8.9,50.16).
city('Marburg','de','Hassia',79300.0,8.77,50.8).
city('Melsungen','de','Hassia',14122.0,9.55,51.14).
city('Michelstadt','de','Hassia',17363.0,9.01,49.68).
city('Moerfelden-Walldorf','de','Hassia',34194.0,8.56,49.98).
city('Moerlenbach','de','Hassia',10566.0,8.73,49.6).
city('Muecke','de','Hassia',10279.0,9.03,50.62).
city('Muehlheim','de','Hassia',26753.0,8.84,50.13).
city('Muehltal','de','Hassia',13812.0,8.7,49.83).
city('Muenster','de','Hassia',13957.0,8.86,49.93).
city('Nauheim','de','Hassia',10367.0,8.74,50.37).
city('Neu-Anspach','de','Hassia',15609.0,8.5,50.32).
city('Neu-Isenburg','de','Hassia',35314.0,8.69,50.06).
city('Neuhof','de','Hassia',11437.0,9.61,50.44).
city('Neustadt','de','Hassia',9155.0,9.11,50.86).
city('Nidda','de','Hassia',18335.0,9.0,50.42).
city('Niddatal','de','Hassia',8986.0,8.79,50.31).
city('Nidderau','de','Hassia',20274.0,8.86,50.25).
city('Niedernhausen','de','Hassia',14703.0,8.32,50.17).
city('Niestetal','de','Hassia',10629.0,9.59,51.32).
city('Ober-Ramstadt','de','Hassia',15695.0,8.74,49.83).
city('Obertshausen','de','Hassia',24280.0,8.85,50.09).
city('Oberursel','de','Hassia',42880.0,8.58,50.21).
city('Oestrich-Winkel','de','Hassia',11925.0,7.36,51.27).
city('Offenbach','de','Hassia',120641.0,8.77,50.1).
city('Petersberg','de','Hassia',14350.0,9.71,50.57).
city('Pfungstadt','de','Hassia',25151.0,8.6,49.81).
city('Pohlheim','de','Hassia',17720.0,8.74,50.54).
city('Raunheim','de','Hassia',13993.0,8.46,50.01).
city('Reinheim','de','Hassia',17839.0,8.83,49.83).
city('Reiskirchen','de','Hassia',10771.0,8.83,50.6).
city('Riedstadt','de','Hassia',21352.0,8.5,49.84).
city('Rodenbach','de','Hassia',11455.0,9.02,50.14).
city('Rodgau','de','Hassia',43760.0,8.87,50.03).
city('Roedermark','de','Hassia',26603.0,8.83,49.98).
city('Rosbach','de','Hassia',11674.0,7.61,50.81).
city('Rossdorf','de','Hassia',12106.0,8.74,49.87).
city('Rotenburg','de','Hassia',14346.0,9.73,51.01).
city('Ruedesheim','de','Hassia',9811.0,7.91,49.99).
city('Ruesselsheim','de','Hassia',59911.0,8.41,50.0).
city('Runkel','de','Hassia',9794.0,8.16,50.41).
city('Schauenburg','de','Hassia',10509.0,9.3,51.28).
city('Schlitz','de','Hassia',10248.0,9.56,50.67).
city('Schluechtern','de','Hassia',17362.0,9.53,50.36).
city('Schoeneck','de','Hassia',11288.0,8.85,50.2).
city('Schotten','de','Hassia',11570.0,9.13,50.51).
city('Schwalbach','de','Hassia',14074.0,8.53,50.16).
city('Schwalmstadt','de','Hassia',20002.0,9.21,50.94).
city('Seeheim-Jugenheim','de','Hassia',16776.0,8.63,49.77).
city('Seligenstadt','de','Hassia',19711.0,8.98,50.06).
city('Sinntal','de','Hassia',9675.0,9.64,50.29).
city('Solms','de','Hassia',13982.0,9.6,50.77).
city('Son','de','Hassia',8618.0,9.93,51.07).
city('Stadtallendorf','de','Hassia',21789.0,9.01,50.84).
city('Steinau','de','Hassia',11199.0,9.45,50.32).
city('Steinbach','de','Hassia',10223.0,8.56,50.17).
city('Taunusstein','de','Hassia',29461.0,8.14,50.14).
city('Trebur','de','Hassia',13016.0,8.39,49.92).
city('Usingen','de','Hassia',13469.0,8.53,50.34).
city('Vellmar','de','Hassia',18464.0,9.47,51.36).
city('Viernheim','de','Hassia',32921.0,8.57,49.55).
city('Waechtersbach','de','Hassia',12497.0,9.3,50.27).
city('Wald-Michelbach','de','Hassia',11447.0,8.83,49.56).
city('Weilburg','de','Hassia',13833.0,8.27,50.49).
city('Weilmuenster','de','Hassia',9637.0,8.36,50.44).
city('Weiterstadt','de','Hassia',24499.0,8.6,49.91).
city('Wettenberg','de','Hassia',12458.0,8.58,50.66).
city('Wetter','de','Hassia',9430.0,8.71,50.9).
city('Wetzlar','de','Hassia',52869.0,8.5,50.56).
city('Wiesbaden','de','Hassia',272337.0,8.23,50.08).
city('Witzenhausen','de','Hassia',16001.0,9.86,51.34).
city('Wolfhagen','de','Hassia',13265.0,9.18,51.34).
city('Achim','de','Lower Saxony',30117.0,9.01,53.04).
city('Adendorf','de','Lower Saxony',9917.0,10.45,53.29).
city('Aerzen','de','Lower Saxony',12114.0,9.26,52.04).
city('Alfeld','de','Lower Saxony',21258.0,9.83,52.0).
city('Apen','de','Lower Saxony',11093.0,7.8,53.22).
city('Aurich','de','Lower Saxony',40987.0,7.48,53.49).
city('Bad Bentheim','de','Lower Saxony',15436.0,7.16,52.32).
city('Bad Bevensen','de','Lower Saxony',8808.0,10.57,53.09).
city('Bad Essen','de','Lower Saxony',15858.0,8.32,52.32).
city('Bad Gandersheim','de','Lower Saxony',11100.0,10.03,51.87).
city('Bad Harzburg','de','Lower Saxony',22670.0,10.56,51.89).
city('Bad Iburg','de','Lower Saxony',11790.0,8.05,52.15).
city('Bad Laer','de','Lower Saxony',9514.0,8.08,52.1).
city('Bad Lauterberg','de','Lower Saxony',11813.0,10.48,51.65).
city('Bad Muender','de','Lower Saxony',18692.0,9.46,52.2).
city('Bad Nenndorf','de','Lower Saxony',10323.0,9.37,52.34).
city('Bad Pyrmont','de','Lower Saxony',21741.0,9.26,51.99).
city('Bad Sachsa','de','Lower Saxony',8245.0,10.54,51.6).
city('Bad Salzdetfurth','de','Lower Saxony',14590.0,10.0,52.05).
city('Bad Zwischenahn','de','Lower Saxony',26641.0,8.0,53.19).
city('Barsinghausen','de','Lower Saxony',34322.0,9.47,52.31).
city('Barssel','de','Lower Saxony',12845.0,7.74,53.17).
city('Bassum','de','Lower Saxony',16204.0,8.73,52.85).
city('Belm','de','Lower Saxony',14073.0,8.13,52.3).
city('Bergen','de','Lower Saxony',13586.0,9.96,52.82).
city('Bissendorf','de','Lower Saxony',14431.0,8.16,52.24).
city('Bockenem','de','Lower Saxony',11328.0,10.13,52.02).
city('Bohmte','de','Lower Saxony',13432.0,8.31,52.37).
city('Bovenden','de','Lower Saxony',13376.0,9.93,51.59).
city('Brake','de','Lower Saxony',16199.0,8.55,53.34).
city('Bramsche','de','Lower Saxony',28773.0,7.99,52.41).
city('Bremervoerde','de','Lower Saxony',18983.0,9.13,53.49).
city('Brunswick','de','Lower Saxony',245259.0,10.51,52.27).
city('Buchholz','de','Lower Saxony',37246.0,9.86,53.34).
city('Bueckeburg','de','Lower Saxony',21077.0,9.05,52.27).
city('Burgdorf','de','Lower Saxony',30288.0,10.01,52.46).
city('Burgwedel','de','Lower Saxony',20624.0,9.85,52.5).
city('Buxtehude','de','Lower Saxony',38236.0,9.68,53.48).
city('Celle','de','Lower Saxony',71106.0,10.06,52.62).
city('Clausthal-Zellerfeld','de','Lower Saxony',15082.0,10.33,51.81).
city('Cloppenburg','de','Lower Saxony',31030.0,8.04,52.85).
city('Cremlingen','de','Lower Saxony',12811.0,10.64,52.25).
city('Cuxhaven','de','Lower Saxony',52873.0,8.69,53.87).
city('Damme','de','Lower Saxony',16236.0,8.2,52.52).
city('Dannenberg','de','Lower Saxony',8612.0,11.09,53.1).
city('Dassel','de','Lower Saxony',11319.0,9.68,51.8).
city('Delmenhorst','de','Lower Saxony',75740.0,8.64,53.06).
city('Diepholz','de','Lower Saxony',16874.0,8.37,52.61).
city('Dinklage','de','Lower Saxony',12802.0,8.11,52.65).
city('Doerverden','de','Lower Saxony',9805.0,9.23,52.85).
city('Drochtersen','de','Lower Saxony',12404.0,9.38,53.7).
city('Duderstadt','de','Lower Saxony',22842.0,10.27,51.52).
city('Edemissen','de','Lower Saxony',12838.0,10.26,52.39).
city('Edewecht','de','Lower Saxony',20519.0,7.99,53.12).
city('Einbeck','de','Lower Saxony',28179.0,9.87,51.83).
city('Elsfleth','de','Lower Saxony',9286.0,8.46,53.24).
city('Elze','de','Lower Saxony',9686.0,9.73,52.13).
city('Emden','de','Lower Saxony',51639.0,7.21,53.37).
city('Emmerthal','de','Lower Saxony',11278.0,9.38,52.05).
city('Fallingbostel','de','Lower Saxony',13639.0,9.7,52.87).
city('Friedeburg','de','Lower Saxony',10822.0,7.83,53.45).
city('Friedland','de','Lower Saxony',10472.0,9.93,51.42).
city('Friesoythe','de','Lower Saxony',20178.0,7.85,53.02).
city('Ganderkesee','de','Lower Saxony',3126.0,8.54,53.04).
city('Garbsen','de','Lower Saxony',63354.0,9.59,52.42).
city('Garrel','de','Lower Saxony',12515.0,8.01,52.95).
city('Geeste','de','Lower Saxony',11456.0,7.26,52.6).
city('Gehrden','de','Lower Saxony',15139.0,9.59,52.32).
city('Georgsmarienhuette','de','Lower Saxony',32945.0,8.05,52.2).
city('Gifhorn','de','Lower Saxony',42699.0,10.53,52.49).
city('Gleichen','de','Lower Saxony',9663.0,10.05,51.47).
city('Goettingen','de','Lower Saxony',123570.0,9.92,51.53).
city('Goslar','de','Lower Saxony',43461.0,10.43,51.92).
city('Grossefehn','de','Lower Saxony',13222.0,7.55,53.4).
city('Grossenkneten','de','Lower Saxony',13925.0,8.27,52.95).
city('Hagen','de','Lower Saxony',14349.0,7.97,52.21).
city('Hameln','de','Lower Saxony',59349.0,9.35,52.11).
city('Hannoversch Muenden','de','Lower Saxony',25612.0,9.68,51.42).
city('Hanover','de','Lower Saxony',519144.0,9.73,52.4).
city('Haren','de','Lower Saxony',23038.0,7.23,52.79).
city('Harsum','de','Lower Saxony',12401.0,9.96,52.22).
city('Hasbergen','de','Lower Saxony',10863.0,7.92,52.24).
city('Haseluenne','de','Lower Saxony',12748.0,7.47,52.67).
city('Hatten','de','Lower Saxony',13342.0,8.38,53.05).
city('Helmstedt','de','Lower Saxony',25686.0,11.0,52.23).
city('Hemmingen','de','Lower Saxony',18956.0,9.74,52.32).
city('Herzberg','de','Lower Saxony',14832.0,10.33,51.66).
city('Hessisch Oldendorf','de','Lower Saxony',19871.0,9.24,52.18).
city('Hildesheim','de','Lower Saxony',102958.0,9.95,52.16).
city('Hilter','de','Lower Saxony',10312.0,8.14,52.15).
city('Holzminden','de','Lower Saxony',21028.0,9.45,51.83).
city('Hude','de','Lower Saxony',15858.0,8.46,53.12).
city('Ihlow','de','Lower Saxony',12757.0,13.33,51.89).
city('Ilsede','de','Lower Saxony',12326.0,10.22,52.26).
city('Isernhagen','de','Lower Saxony',22470.0,9.82,52.47).
city('Jever','de','Lower Saxony',14079.0,7.89,53.59).
city('Jork','de','Lower Saxony',11878.0,9.67,53.54).
city('Kirchlinteln','de','Lower Saxony',10644.0,9.31,52.95).
city('Koenigslutter','de','Lower Saxony',16614.0,10.81,52.25).
city('Krummhoern','de','Lower Saxony',13392.0,7.07,53.42).
city('Laatzen','de','Lower Saxony',40245.0,9.79,52.32).
city('Lahstedt','de','Lower Saxony',10882.0,10.25,52.25).
city('Langelsheim','de','Lower Saxony',13234.0,10.33,51.94).
city('Langen','de','Lower Saxony',18685.0,8.6,53.62).
city('Langenhagen','de','Lower Saxony',49958.0,9.74,52.45).
city('Langwedel','de','Lower Saxony',15200.0,9.21,52.97).
city('Leer','de','Lower Saxony',34081.0,7.46,53.24).
city('Lehre','de','Lower Saxony',11664.0,10.66,52.34).
city('Lehrte','de','Lower Saxony',44495.0,9.97,52.38).
city('Lengede','de','Lower Saxony',13196.0,10.3,52.2).
city('Liebenburg','de','Lower Saxony',9649.0,10.44,52.02).
city('Lilienthal','de','Lower Saxony',17851.0,8.91,53.14).
city('Lingen','de','Lower Saxony',51577.0,7.31,52.54).
city('Loeningen','de','Lower Saxony',13315.0,7.75,52.74).
city('Lohne','de','Lower Saxony',25332.0,8.25,52.66).
city('Loxstedt','de','Lower Saxony',16783.0,8.65,53.47).
city('Luechow','de','Lower Saxony',9763.0,11.15,52.97).
city('Lueneburg','de','Lower Saxony',73252.0,10.4,53.25).
city('Melle','de','Lower Saxony',46745.0,8.35,52.2).
city('Meppen','de','Lower Saxony',34205.0,7.3,52.7).
city('Moormerland','de','Lower Saxony',22672.0,7.45,53.33).
city('Munster','de','Lower Saxony',18090.0,10.08,53.0).
city('Neu Wulmstorf','de','Lower Saxony',20988.0,9.8,53.47).
city('Neustadt','de','Lower Saxony',45661.0,9.46,52.51).
city('Nienburg','de','Lower Saxony',32512.0,9.22,52.64).
city('Norden','de','Lower Saxony',24686.0,7.2,53.61).
city('Nordenham','de','Lower Saxony',27783.0,8.49,53.52).
city('Nordhorn','de','Lower Saxony',52906.0,7.06,52.44).
city('Nordstemmen','de','Lower Saxony',13436.0,9.78,52.17).
city('Northeim','de','Lower Saxony',30751.0,9.99,51.71).
city('Obernkirchen','de','Lower Saxony',10155.0,9.13,52.27).
city('Oldenburg','de','Lower Saxony',160347.0,8.21,53.15).
city('Osnabrueck','de','Lower Saxony',165372.0,8.05,52.28).
city('Ostercappeln','de','Lower Saxony',9677.0,8.23,52.36).
city('Osterholz-Scharmbeck','de','Lower Saxony',31469.0,8.79,53.23).
city('Osterode','de','Lower Saxony',24799.0,10.26,51.73).
city('Ottersberg','de','Lower Saxony',12392.0,9.15,53.1).
city('Oyten','de','Lower Saxony',15694.0,9.01,53.05).
city('Papenburg','de','Lower Saxony',34715.0,7.4,53.09).
city('Pattensen','de','Lower Saxony',13496.0,9.76,52.27).
city('Peine','de','Lower Saxony',49776.0,10.23,52.33).
city('Quakenbrueck','de','Lower Saxony',13170.0,7.95,52.68).
city('Rastede','de','Lower Saxony',20358.0,8.19,53.25).
city('Rehburg-Loccum','de','Lower Saxony',11180.0,9.22,52.47).
city('Rhauderfehn','de','Lower Saxony',17156.0,7.62,53.14).
city('Rinteln','de','Lower Saxony',28048.0,9.08,52.21).
city('Ritterhude','de','Lower Saxony',14143.0,8.74,53.19).
city('Ronnenberg','de','Lower Saxony',23604.0,9.64,52.32).
city('Rosdorf','de','Lower Saxony',11844.0,9.89,51.51).
city('Rosengarten','de','Lower Saxony',13697.0,9.88,53.35).
city('Rotenburg','de','Lower Saxony',22108.0,9.4,53.12).
city('Salzgitter','de','Lower Saxony',111622.0,10.33,52.17).
city('Salzhemmendorf','de','Lower Saxony',10709.0,9.61,52.07).
city('Sarstedt','de','Lower Saxony',18555.0,9.84,52.24).
city('Saterland','de','Lower Saxony',13276.0,7.66,53.14).
city('Scheessel','de','Lower Saxony',13064.0,9.47,53.17).
city('Schiffdorf','de','Lower Saxony',14424.0,8.65,53.54).
city('Schneverdingen','de','Lower Saxony',19537.0,9.79,53.13).
city('Schoeningen','de','Lower Saxony',13313.0,10.95,52.14).
city('Schortens','de','Lower Saxony',21251.0,7.95,53.54).
city('Schuettorf','de','Lower Saxony',11762.0,7.23,52.32).
city('Schwanewede','de','Lower Saxony',19985.0,8.6,53.24).
city('Seelze','de','Lower Saxony',33224.0,9.6,52.41).
city('Seesen','de','Lower Saxony',21976.0,10.18,51.9).
city('Seevetal','de','Lower Saxony',41557.0,10.03,53.39).
city('Sehnde','de','Lower Saxony',22400.0,9.95,52.32).
city('Soltau','de','Lower Saxony',22108.0,9.83,52.99).
city('Springe','de','Lower Saxony',30284.0,9.55,52.22).
city('Stade','de','Lower Saxony',45419.0,9.46,53.61).
city('Stadthagen','de','Lower Saxony',23474.0,9.19,52.33).
city('Stelle','de','Lower Saxony',11396.0,10.11,53.39).
city('Stuhr','de','Lower Saxony',33110.0,8.74,53.02).
city('Suedbrookmerland','de','Lower Saxony',18971.0,7.33,53.47).
city('Sulingen','de','Lower Saxony',12905.0,8.79,52.69).
city('Syke','de','Lower Saxony',24084.0,8.81,52.92).
city('Tostedt','de','Lower Saxony',13695.0,9.71,53.29).
city('Twistringen','de','Lower Saxony',12675.0,8.64,52.8).
city('Uelzen','de','Lower Saxony',35096.0,10.56,52.97).
city('Uetze','de','Lower Saxony',20477.0,10.19,52.47).
city('Uplengen','de','Lower Saxony',11442.0,7.75,53.28).
city('Uslar','de','Lower Saxony',15982.0,9.65,51.67).
city('Varel','de','Lower Saxony',25303.0,8.14,53.4).
city('Vechelde','de','Lower Saxony',16165.0,10.36,52.27).
city('Vechta','de','Lower Saxony',30178.0,8.29,52.73).
city('Verden','de','Lower Saxony',26364.0,9.24,52.93).
city('Vienenburg','de','Lower Saxony',11518.0,10.56,51.95).
city('Visselhoevede','de','Lower Saxony',10757.0,9.59,52.99).
city('Wallenhorst','de','Lower Saxony',24279.0,8.01,52.35).
city('Walsrode','de','Lower Saxony',24439.0,9.6,52.87).
city('Wangerland','de','Lower Saxony',10246.0,7.94,53.65).
city('Wardenburg','de','Lower Saxony',16019.0,8.2,53.07).
city('Wedemark','de','Lower Saxony',29279.0,9.7,52.55).
city('Weener','de','Lower Saxony',15794.0,7.35,53.16).
city('Wennigsen','de','Lower Saxony',14122.0,9.57,52.28).
city('Westerstede','de','Lower Saxony',22209.0,7.92,53.27).
city('Westoverledingen','de','Lower Saxony',19904.0,7.43,53.14).
city('Weyhe','de','Lower Saxony',30349.0,8.84,52.98).
city('Wiefelstede','de','Lower Saxony',14816.0,8.11,53.26).
city('Wiesmoor','de','Lower Saxony',13180.0,7.73,53.42).
city('Wildeshausen','de','Lower Saxony',18276.0,8.43,52.9).
city('Wilhelmshaven','de','Lower Saxony',84209.0,8.11,53.54).
city('Winsen an der Aller','de','Lower Saxony',12791.0,9.91,52.68).
city('Winsen an der Luhe','de','Lower Saxony',32715.0,10.21,53.37).
city('Wittingen','de','Lower Saxony',12401.0,10.73,52.73).
city('Wittmund','de','Lower Saxony',21417.0,7.78,53.57).
city('Wolfenbuettel','de','Lower Saxony',54911.0,10.55,52.17).
city('Wolfsburg','de','Lower Saxony',123184.0,10.78,52.43).
city('Worpswede','de','Lower Saxony',9580.0,8.93,53.22).
city('Wunstorf','de','Lower Saxony',42145.0,9.43,52.43).
city('Zetel','de','Lower Saxony',12037.0,7.98,53.42).
city('Zeven','de','Lower Saxony',12577.0,9.28,53.3).
city('Anklam','de','Mecklenburg-West Pommerania',14533.0,13.69,53.85).
city('Bad Doberan','de','Mecklenburg-West Pommerania',11373.0,11.9,54.11).
city('Barth','de','Mecklenburg-West Pommerania',9344.0,12.73,54.37).
city('Bergen','de','Mecklenburg-West Pommerania',14621.0,13.43,54.42).
city('Boizenburg','de','Mecklenburg-West Pommerania',10634.0,10.73,53.38).
city('Buetzow','de','Mecklenburg-West Pommerania',8163.0,11.97,53.85).
city('Demmin','de','Mecklenburg-West Pommerania',12263.0,13.04,53.91).
city('Greifswald','de','Mecklenburg-West Pommerania',51935.0,13.39,54.09).
city('Grevesmuehlen','de','Mecklenburg-West Pommerania',10993.0,11.18,53.87).
city('Grimmen','de','Mecklenburg-West Pommerania',10764.0,13.03,54.11).
city('Guestrow','de','Mecklenburg-West Pommerania',30869.0,12.18,53.8).
city('Hagenow','de','Mecklenburg-West Pommerania',12253.0,11.19,53.44).
city('Ludwigslust','de','Mecklenburg-West Pommerania',12209.0,11.48,53.33).
city('Malchin','de','Mecklenburg-West Pommerania',8413.0,12.76,53.74).
city('Neubrandenburg','de','Mecklenburg-West Pommerania',67393.0,13.27,53.57).
city('Neustrelitz','de','Mecklenburg-West Pommerania',22312.0,13.06,53.37).
city('Parchim','de','Mecklenburg-West Pommerania',19146.0,11.84,53.43).
city('Pasewalk','de','Mecklenburg-West Pommer',12059.0,13.99,53.51).
city('Ribnitz-Damgarten','de','Mecklenburg-West Pommerania',17176.0,12.43,54.24).
city('Rostock','de','Mecklenburg-West Pommerania',196833.0,12.1,54.09).
city('Sassnitz','de','Mecklenburg-West Pommerania',10758.0,13.61,54.52).
city('Schwerin','de','Mecklenburg-West Pommerania',96329.0,11.4,53.63).
city('Stralsund','de','Mecklenburg-West Pommerania',57959.0,13.09,54.32).
city('Teterow','de','Mecklenburg-West Pommerania',9683.0,12.57,53.77).
city('Torgelow','de','Mecklenburg-West Pommerania',10551.0,14.0,53.64).
city('Ueckermuende','de','Mecklenburg-West Pommerania',10951.0,14.02,53.74).
city('Waren','de','Mecklenburg-West Pommerania',21504.0,12.68,53.52).
city('Wismar','de','Mecklenburg-West Pommerania',45432.0,11.46,53.9).
city('Wolgast','de','Mecklenburg-West Pommerania',12539.0,13.76,54.05).
city('Aachen','de','North Rhine-Westphalia',251104.0,6.09,50.77).
city('Ahaus','de','North Rhine-Westphalia',38932.0,7.01,52.09).
city('Ahlen','de','North Rhine-Westphalia',55112.0,7.88,51.77).
city('Aldenhoven','de','North Rhine-Westphalia',14335.0,6.27,50.91).
city('Alfter','de','North Rhine-Westphalia',22028.0,7.01,50.74).
city('Alpen','de','North Rhine-Westphalia',12970.0,6.51,51.59).
city('Alsdorf','de','North Rhine-Westphalia',46558.0,6.15,50.88).
city('Altena','de','North Rhine-Westphalia',20641.0,7.66,51.31).
city('Anroechte','de','North Rhine-Westphalia',10981.0,8.33,51.57).
city('Arnsberg','de','North Rhine-Westphalia',77415.0,8.06,51.41).
city('Ascheberg','de','North Rhine-Westphalia',15327.0,7.61,51.79).
city('Attendorn','de','North Rhine-Westphalia',25014.0,7.9,51.14).
city('Augustdorf','de','North Rhine-Westphalia',10275.0,8.73,51.91).
city('Bad Berleburg','de','North Rhine-Westphalia',20830.0,8.39,51.05).
city('Bad Driburg','de','North Rhine-Westphalia',19743.0,9.01,51.74).
city('Bad Honnef','de','North Rhine-Westphalia',25342.0,7.22,50.65).
city('Bad Laasphe','de','North Rhine-Westphalia',15268.0,8.4,50.93).
city('Bad Lippspringe','de','North Rhine-Westphalia',15054.0,8.81,51.79).
city('Bad Muenstereifel','de','North Rhine-Westphalia',19166.0,6.76,50.55).
city('Bad Oeynhausen','de','North Rhine-Westphalia',49698.0,8.81,52.21).
city('Bad Salzuflen','de','North Rhine-Westphalia',55348.0,8.75,52.09).
city('Bad Sassendorf','de','North Rhine-Westphalia',11552.0,8.16,51.59).
city('Bad Wuennenberg','de','North Rhine-Westphalia',12484.0,8.7,51.52).
city('Baesweiler','de','North Rhine-',27865.0,6.18,50.9).
city('Balve','de','North Rhine-Westphalia',12288.0,7.86,51.34).
city('Barntrup','de','North Rhine-Westphalia',9666.0,9.11,51.99).
city('Beckum','de','North Rhine-Westphalia',37914.0,8.03,51.76).
city('Bedburg','de','North Rhine-Westphalia',25224.0,6.57,51.0).
city('Bedburg-Hau','de','North Rhine-Westphalia',12524.0,6.18,51.77).
city('Bergheim','de','North Rhine-Westphalia',64082.0,6.64,50.96).
city('Bergisch Gladbach','de','North Rhine-Westphalia',106611.0,7.15,50.98).
city('Bergkamen','de','North Rhine-Westphalia',52670.0,7.63,51.62).
city('Bergneustadt','de','North Rhine-Westphalia',20865.0,7.65,51.04).
city('Bestwig','de','North Rhine-Westphalia',11819.0,8.4,51.37).
city('Beverungen','de','North Rhine-Westphalia',15230.0,9.37,51.67).
city('Bielefeld','de','North Rhine-Westphalia',327198.0,8.53,52.03).
city('Billerbeck','de','North Rhine-Westphalia',11578.0,7.29,51.97).
city('Blomberg','de','North Rhine-Westphalia',17295.0,9.09,51.95).
city('Bocholt','de','North Rhine-Westphalia',73872.0,6.61,51.84).
city('Bochum','de','North Rhine-Westphalia',387061.0,7.2,51.48).
city('Boenen','de','North Rhine-Westphalia',18950.0,7.76,51.6).
city('Bonn','de','North Rhine-Westphalia',314081.0,7.1,50.73).
city('Borchen','de','North Rhine-Westphalia',13456.0,8.74,51.67).
city('Borgentreich','de','North Rhine-Westphalia',9813.0,9.24,51.57).
city('Borken','de','North Rhine-Westphalia',41179.0,6.87,51.85).
city('Bornheim','de','North Rhine-Westphalia',49126.0,6.98,50.77).
city('Bottrop','de','North Rhine-Westphalia',120829.0,6.93,51.53).
city('Brakel','de','North Rhine-Westphalia',17782.0,9.18,51.73).
city('Brilon','de','North Rhine-Westphalia',27186.0,8.57,51.4).
city('Brueggen','de','North Rhine-Westphalia',16224.0,6.19,51.24).
city('Bruehl','de','North Rhine-Westphalia',44588.0,6.9,50.85).
city('Buende','de','North Rhine-Westphalia',45389.0,8.61,52.2).
city('Bueren','de','North Rhine-Westphalia',22703.0,8.56,51.56).
city('Burbach','de','North Rhine-Westphalia',14984.0,8.08,50.75).
city('Burscheid','de','North Rhine-Westphalia',19579.0,7.11,51.1).
city('Castrop-Rauxel','de','North Rhine-Westphalia',78587.0,7.31,51.55).
city('Cleves','de','North Rhine-Westphalia',49448.0,6.12,51.79).
city('Coesfeld','de','North Rhine-Westphalia',36929.0,7.16,51.95).
city('Cologne','de','North Rhine-Westphalia',968823.0,6.97,50.95).
city('Datteln','de','North Rhine-Westphalia',37130.0,7.38,51.67).
city('Delbrueck','de','North Rhine-Westphalia',30699.0,8.56,51.77).
city('Detmold','de','North Rhine-Westphalia',74853.0,8.88,51.95).
city('Dinslaken','de','North Rhine-Westphalia',71632.0,6.73,51.58).
city('Dormagen','de','North Rhine-Westphalia',64129.0,6.84,51.08).
city('Dorsten','de','North Rhine-Westphalia',80180.0,6.97,51.67).
city('Dortmund','de','North Rhine-Westphalia',594255.0,7.48,51.51).
city('Drensteinfurt','de','North Rhine-Westphalia',15234.0,7.75,51.8).
city('Drolshagen','de','North Rhine-Westphalia',12438.0,7.7,51.02).
city('Duelmen','de','North Rhine-Westphalia',47899.0,7.3,51.84).
city('Dueren','de','North Rhine-Westphalia',92956.0,6.49,50.81).
city('Duesseldorf','de','North Rhine-Westphalia',577139.0,6.79,51.24).
city('Duisburg','de','North Rhine-Westphalia',505271.0,6.75,51.43).
city('Eitorf','de','North Rhine-Westphalia',19867.0,7.45,50.78).
city('Elsdorf','de','North Rhine-Westphalia',21901.0,6.56,50.94).
city('Emmerich','de','North Rhine-Westphalia',29753.0,6.24,51.85).
city('Emsdetten','de','North Rhine-Westphalia',35383.0,7.53,52.18).
city('Engelskirchen','de','North Rhine-Westphalia',2088.0,7.39,50.99).
city('Enger','de','North Rhine-Westphalia',20417.0,8.55,52.15).
city('Ennepetal','de','North Rhine-Westphalia',32426.0,7.34,51.3).
city('Ennigerloh','de','North Rhine-Westphalia',20678.0,8.01,51.84).
city('Ense','de','North Rhine-Westphalia',13141.0,7.99,51.49).
city('Erftstadt','de','North Rhine-Westphalia',51606.0,6.76,50.81).
city('Erkelenz','de','North Rhine-Westphalia',44479.0,6.32,51.08).
city('Erkrath','de','North Rhine-Westphalia',47908.0,6.89,51.22).
city('Erwitte','de','North Rhine-Westphalia',16097.0,8.34,51.62).
city('Eschweiler','de','North Rhine-Westphalia',55888.0,6.27,50.83).
city('Espelkamp','de','North Rhine-Westphalia',26684.0,8.62,52.39).
city('Essen','de','North Rhine-Westphalia',576914.0,7.0,51.47).
city('Euskirchen','de','North Rhine-Westphalia',54855.0,6.79,50.66).
city('Extertal','de','North Rhine-Westphalia',13011.0,9.09,52.09).
city('Finnentrop','de','North Rhine-Westphalia',18466.0,7.96,51.17).
city('Frechen','de','North Rhine-Westphalia',48198.0,6.81,50.91).
city('Freudenberg','de','North Rhine-Westphalia',18440.0,7.86,50.9).
city('Froendenberg','de','North Rhine-Westphalia',23499.0,7.76,51.47).
city('Gangelt','de','North Rhine-Westphalia',11647.0,6.0,51.0).
city('Geilenkirchen','de','North Rhine-Westphalia',28587.0,6.11,50.97).
city('Geldern','de','North Rhine-Westphalia',34291.0,6.33,51.52).
city('Gelsenkirchen','de','North Rhine-Westphalia',271647.0,7.11,51.51).
city('Gescher','de','North Rhine-Westphalia',16937.0,7.01,51.95).
city('Geseke','de','North Rhine-Westphalia',20790.0,8.51,51.64).
city('Gevelsberg','de','North Rhine-Westphalia',32978.0,7.33,51.32).
city('Gladbeck','de','North Rhine-Westphalia',77264.0,6.98,51.58).
city('Goch','de','North Rhine-Westphalia',34045.0,6.16,51.68).
city('Grefrath','de','North Rhine-Westphalia',16167.0,6.31,51.3).
city('Greven','de','North Rhine-Westphalia',35732.0,7.62,52.1).
city('Grevenbroich','de','North Rhine-Westphalia',64851.0,6.57,51.1).
city('Gronau','de','North Rhine-Westphalia',46061.0,7.03,52.2).
city('Guetersloh','de','North Rhine-Westphalia',96332.0,8.37,51.91).
city('Gummersbach','de','North Rhine-Westphalia',53244.0,7.57,51.04).
city('Haan','de','North Rhine-Westphalia',29369.0,7.0,51.2).
city('Hagen','de','North Rhine-Westphalia',199497.0,7.46,51.37).
city('Halle','de','North Rhine-Westphalia',20921.0,8.35,52.07).
city('Haltern','de','North Rhine-Westphalia',38212.0,7.17,51.75).
city('Halver','de','North Rhine-Westphalia',17660.0,7.47,51.21).
city('Hamm','de','North Rhine-Westphalia',186289.0,7.8,51.67).
city('Hamminkeln','de','North Rhine-Westphalia',27755.0,6.57,51.74).
city('Harsewinkel','de','North Rhine-Westphalia',23910.0,8.23,51.97).
city('Hattingen','de','North Rhine-Westphalia',58076.0,7.18,51.41).
city('Havixbeck','de','North Rhine-Westphalia',12249.0,7.41,51.99).
city('Heiligenhaus','de','North Rhine-Westphalia',28312.0,6.96,51.32).
city('Heinsberg','de','North Rhine-Westphalia',42409.0,6.09,51.07).
city('Hemer','de','North Rhine-Westphalia',39288.0,7.76,51.39).
city('Hennef','de','North Rhine-Westphalia',45829.0,7.28,50.78).
city('Herdecke','de','North Rhine-Westphalia',25954.0,7.43,51.4).
city('Herford','de','North Rhine-Westphalia',65834.0,8.67,52.12).
city('Herne','de','North Rhine-Westphalia',173121.0,7.21,51.54).
city('Herten','de','North Rhine-Westphalia',65367.0,7.21,51.59).
city('Herzebrock-Clarholz','de','North Rhine-Westphalia',16035.0,8.24,51.89).
city('Herzogenrath','de','North Rhine-Westphalia',47425.0,6.09,50.87).
city('Hiddenhausen','de','North Rhine-Westphalia',20742.0,8.61,52.17).
city('Hilchenbach','de','North Rhine-Westphalia',16784.0,8.09,50.99).
city('Hilden','de','North Rhine-Westphalia',57036.0,6.93,51.18).
city('Hille','de','North Rhine-Westphalia',16620.0,8.74,52.34).
city('Hoerstel','de','North Rhine-Westphalia',19979.0,7.57,52.32).
city('Hoevelhof','de','North Rhine-Westphalia',16349.0,8.64,51.82).
city('Hoexter','de','North Rhine-Westphalia',32962.0,9.37,51.78).
city('Holzwickede','de','North Rhine-Westphalia',17867.0,7.63,51.5).
city('Horn-Bad Meinberg','de','North Rhine-Westphalia',18674.0,8.94,51.87).
city('Hueckelhoven','de','North Rhine-Westphalia',39765.0,6.22,51.06).
city('Hueckeswagen','de','North Rhine-Westphalia',16499.0,7.34,51.15).
city('Huellhorst','de','North Rhine-Westphalia',13913.0,8.67,52.28).
city('Huenxe','de','North Rhine-Westphalia',13707.0,6.77,51.65).
city('Huerth','de','North Rhine-Westphalia',55217.0,6.89,50.89).
city('Ibbenbueren','de','North Rhine-Westphalia',51305.0,7.71,52.29).
city('Iserlohn','de','North Rhine-Westphalia',98190.0,7.68,51.39).
city('Isselburg','de','North Rhine-Westphalia',11274.0,6.46,51.84).
city('Issum','de','North Rhine-Westphalia',12257.0,6.42,51.54).
city('Juechen','de','North Rh',22333.0,6.49,51.11).
city('Juelich','de','North Rhine-Westphalia',34888.0,6.36,50.93).
city('Kaarst','de','North Rhine-Westphalia',42876.0,6.61,51.24).
city('Kalkar','de','North Rhine-Westphalia',14405.0,6.29,51.74).
city('Kall','de','North Rhine-Westphalia',12074.0,6.56,50.54).
city('Kalletal','de','North Rhine-Westphalia',15693.0,8.95,52.11).
city('Kamen','de','North Rhine-Westphalia',46076.0,7.66,51.6).
city('Kamp-Lintfort','de','North Rhine-Westphalia',39949.0,6.52,51.5).
city('Kempen','de','North Rhine-Westphalia',36506.0,6.41,51.37).
city('Kerken','de','North Rhine-Westphalia',12769.0,6.4,51.44).
city('Kerpen','de','North Rhine-Westphalia',64729.0,6.69,50.88).
city('Kevelaer','de','North Rhine-Westphalia',28148.0,6.24,51.59).
city('Kierspe','de','North Rhine-Westphalia',18281.0,7.57,51.14).
city('Kirchhundem','de','North Rhine-Westphalia',13059.0,8.09,51.09).
city('Kirchlengern','de','North Rhine-Westphalia',16557.0,8.62,52.2).
city('Koenigswinter','de','North Rhine-Westphalia',41248.0,7.18,50.71).
city('Korschenbroich','de','North Rhine-Westphalia',33588.0,6.51,51.19).
city('Krefeld','de','North Rhine-Westphalia',239908.0,6.55,51.33).
city('Kreuza','de','North Rhine-Westphalia',18670.0,6.47,50.75).
city('Kreuztal','de','North Rhine-Westphalia',31720.0,7.98,50.97).
city('Kuerten','de','North Rhine-Westphalia',20588.0,7.26,51.05).
city('Lage','de','North Rhine-Westphalia',36709.0,8.79,52.0).
city('Langenfeld','de','North Rhine-Westphalia',58803.0,6.95,51.11).
city('Langerwehe','de','North Rhine-Westphalia',14222.0,6.35,50.82).
city('Leichlingen','de','North Rhine-Westphalia',27532.0,6.99,51.1).
city('Lemgo','de','North Rhine-Westphalia',42036.0,8.91,52.04).
city('Lengerich','de','North Rhine-Westphalia',22642.0,7.86,52.19).
city('Lennestadt','de','North Rhine-Westphalia',28142.0,8.06,51.12).
city('Leopoldshoehe','de','North Rhine-Westphalia',16324.0,8.7,52.02).
city('Leverkusen','de','North Rhine-Westphalia',159088.0,6.99,51.04).
city('Lichtenau','de','North Rhine-Westphalia',11350.0,8.9,51.62).
city('Lindlar','de','North Rhine-Westphalia',22752.0,7.37,51.02).
city('Linnich','de','North Rhine-Westphalia',13983.0,6.26,50.99).
city('Lippetal','de','North Rhine-Westphalia',12755.0,8.14,51.66).
city('Lippstadt','de','North Rhine-Westphalia',67638.0,8.34,51.67).
city('Loehne','de','North Rhine-Westphalia',41805.0,8.72,52.2).
city('Lohmar','de','North Rhine-Westphalia',31802.0,7.22,50.83).
city('Lotte','de','North Rhine-Westphalia',13564.0,7.91,52.29).
city('Luebbecke','de','North Rhine-Westphalia',27131.0,8.61,52.3).
city('Luedenscheid','de','North Rhine-Westphalia',80045.0,7.6,51.23).
city('Luedinghausen','de','North Rhine-Westphalia',24218.0,7.44,51.78).
city('Luegde','de','North Rhine-Westphalia',11448.0,9.25,51.95).
city('Luenen','de','North Rhine-Westphalia',91912.0,7.52,51.62).
city('Marienheide','de','North Rhine-Westphalia',13645.0,7.53,51.09).
city('Marl','de','North Rhine-Westphalia',91262.0,7.12,51.68).
city('Marsberg','de','North Rhine-Westphalia',22361.0,8.86,51.46).
city('Mechernich','de','North Rhine-Westphalia',27551.0,6.65,50.6).
city('Meckenheim','de','North Rhine-Westphalia',25491.0,7.01,50.64).
city('Meerbusch','de','North Rhine-Westphalia',55053.0,6.73,51.24).
city('Meinerzhagen','de','North Rhine-Westphalia',21907.0,7.65,51.12).
city('Menden','de','North Rhine-Westphalia',58939.0,7.79,51.44).
city('Meschede','de','North Rhine-Westphalia',32593.0,8.29,51.35).
city('Mettingen','de','North Rhine-Westphalia',12869.0,7.78,52.32).
city('Mettmann','de','North Rhine-Westphalia',39371.0,6.96,51.25).
city('Minden','de','North Rhine-Westphalia',83402.0,8.9,52.29).
city('Moehnesee','de','North Rhine-Westphalia',11612.0,8.09,51.5).
city('Moenchengladbach','de','North Rhine-Westphalia',264969.0,6.42,51.2).
city('Moers','de','North Rhine-Westphalia',109167.0,6.65,51.45).
city('Monheim','de','North Rhine-Westphalia',43905.0,6.88,51.09).
city('Monschau','de','North Rhine-Westphalia',13167.0,6.24,50.56).
city('Morsbach','de','North Rhine-Westphalia',11743.0,7.75,50.87).
city('Much','de','North Rhine-Westphalia',15327.0,7.4,50.92).
city('Muelheim','de','North Rhine-',172779.0,6.86,51.43).
city('Muenster','de','North Rhine-Westphalia',272452.0,7.62,51.96).
city('Netphen','de','North Rhine-Westphalia',25187.0,8.1,50.92).
city('Nettetal','de','North Rhine-Westphalia',42959.0,6.28,51.32).
city('Neuenkirchen','de','North Rhine-Westphalia',14068.0,7.37,52.26).
city('Neuenrade','de','North Rhine-Westphalia',12505.0,7.78,51.29).
city('Neukirchen-Vluyn','de','North Rhine-Westphalia',29345.0,6.58,51.45).
city('Neunkirchen','de','North Rhine-Westphalia',14295.0,8.01,50.79).
city('Neunkirchen-Seelscheid','de','North Rhine-Westphalia',21374.0,7.31,50.89).
city('Neuss','de','North Rhine-Westphalia',152975.0,6.69,51.2).
city('Nideggen','de','North Rhine-Westphalia',11075.0,6.48,50.71).
city('Niederkassel','de','North Rhine-Westphalia',36426.0,7.03,50.82).
city('Niederkruechten','de','North Rhine-Westphalia',15697.0,6.21,51.21).
city('Niederzier','de','North Rhine-Westphalia',14648.0,6.46,50.88).
city('Noervenich','de','North Rhine-Westphalia',11778.0,6.65,50.81).
city('Nottuln','de','North Rhine-Westphalia',20256.0,7.35,51.94).
city('Nuembrecht','de','North Rhine-Westphalia',17492.0,7.55,50.91).
city('Oberhausen','de','North Rhine-Westphalia',220916.0,6.86,51.47).
city('Ochtrup','de','North Rhine-Westphalia',19543.0,7.19,52.22).
city('Odenthal','de','North Rhine-Westphalia',15537.0,7.11,51.04).
city('Oelde','de','North Rhine-Westphalia',29608.0,8.14,51.84).
city('Oer-Erkenschwick','de','North Rhine-Westphalia',30474.0,7.25,51.64).
city('Oerlinghausen','de','North Rhine-Westphalia',17555.0,8.66,51.97).
city('Olfen','de','North Rhine-Westphalia',12450.0,7.4,51.71).
city('Olpe','de','North Rhine-Westphalia',25939.0,7.85,51.04).
city('Olsberg','de','North Rhine-Westphalia',15923.0,8.49,51.36).
city('Overath','de','North Rhine-Westphalia',27073.0,7.3,50.95).
city('Paderborn','de','North Rhine-Westphalia',143096.0,8.74,51.72).
city('Petershagen','de','North Rhine-Westphalia',27148.0,8.96,52.39).
city('Plettenberg','de','North Rhine-Westphalia',28247.0,7.88,51.22).
city('Porta Westfalica','de','North Rhine-Westphalia',36419.0,8.93,52.22).
city('Preussisch Oldendorf','de','North Rhine-Westphalia',13817.0,8.5,52.3).
city('Pulheim','de','North Rhine-Westphalia',54209.0,6.8,51.0).
city('Radevormwald','de','North Rhine-Westphalia',24298.0,7.35,51.2).
city('Raesfeld','de','North Rhine-Westphalia',11430.0,6.85,51.77).
city('Rahden','de','North Rhine-Westphalia',16218.0,8.61,52.43).
city('Ratingen','de','North Rhine-Westphalia',92306.0,6.85,51.3).
city('Recke','de','North Rhine-Westphalia',11867.0,7.71,52.38).
city('Recklinghausen','de','North Rhine-Westphalia',122727.0,7.19,51.61).
city('Rees','de','North Rhine-Westphalia',22654.0,6.4,51.77).
city('Reichshof','de','North Rhine-Westphalia',20185.0,7.73,50.97).
city('Reken','de','North Rhine-Westphalia',14542.0,7.03,51.78).
city('Remscheid','de','North Rhine-Westphalia',118230.0,7.19,51.18).
city('Rheda-Wiedenbrueck','de','North Rhine-Westphalia',46378.0,8.28,51.85).
city('Rhede','de','North',18774.0,6.7,51.83).
city('Rheinbach','de','North Rhine-Westphalia',26195.0,6.95,50.63).
city('Rheinberg','de','North Rhine-Westphalia',32178.0,6.6,51.55).
city('Rheine','de','North Rhine-Westphalia',76474.0,7.44,52.29).
city('Rietberg','de','North Rhine-Westphalia',28683.0,8.43,51.78).
city('Roesrath','de','North Rhine-Westphalia',27353.0,7.19,50.91).
city('Rommerskirchen','de','North Rhine-Westphalia',12554.0,6.68,51.04).
city('Rosendahl','de','North Rhine-Westphalia',11132.0,7.95,51.77).
city('Ruethen','de','North Rhine-Westphalia',11453.0,8.44,51.49).
city('Salzkotten','de','North Rhine-Westphalia',24369.0,8.59,51.67).
city('Sankt Augustin','de','North Rhine-Westphalia',56258.0,7.18,50.78).
city('Sassenberg','de','North Rhine-Westphalia',14507.0,8.04,52.01).
city('Schalksmuehle','de','North Rhine-Westphalia',11859.0,7.52,51.24).
city('Schermbeck','de','North Rhine-Westphalia',13758.0,6.86,51.69).
city('Schieder-Schwalenberg','de','North Rhine-Westphalia',9382.0,9.15,51.92).
city('Schleiden','de','North Rhine-Westphalia',13972.0,6.48,50.54).
city('Schloss Holte-Stukenbrock','de','North Rhine-Westphalia',26215.0,8.66,51.92).
city('Schmallenberg','de','North Rhine-Westphalia',26218.0,8.3,51.16).
city('Schwalmtal','de','North Rhine-Westphalia',19510.0,6.27,51.22).
city('Schwelm','de','North Rhine-Westphalia',30470.0,7.28,51.29).
city('Schwerte','de','North Rhine-Westphalia',50757.0,7.56,51.45).
city('Selm','de','North Rhine-Westphalia',27596.0,7.46,51.7).
city('Senden','de','North Rhine-Westphalia',19880.0,7.5,51.86).
city('Sendenhorst','de','North Rhine-Westphalia',13469.0,7.83,51.84).
city('Siegburg','de','North Rhine-Westphalia',38818.0,7.21,50.81).
city('Siegen','de','North Rhine-Westphalia',108228.0,8.01,50.87).
city('Simmerath','de','North Rhine-Westphalia',15981.0,6.3,50.61).
city('Soest','de','North Rhine-Westphalia',48720.0,8.11,51.57).
city('Solingen','de','North Rhine-Westphalia',165192.0,7.06,51.18).
city('Spenge','de','North Rhine-Westphalia',15569.0,8.49,52.15).
city('Sprockhoevel','de','North Rhine-Westphalia',26125.0,7.24,51.36).
city('Stadtlohn','de','North Rhine-Westphalia',20726.0,6.93,51.99).
city('Steinfurt','de','North Rhine-Westphalia',34478.0,7.33,52.16).
city('Steinhagen','de','North Rhine-Westphalia',20143.0,8.4,52.01).
city('Steinheim','de','North Rhine-Westphalia',14059.0,9.1,51.86).
city('Stemwede','de','North Rhine-Westphalia',14594.0,8.43,52.42).
city('Stolberg','de','North Rhine-Westphalia',58900.0,6.23,50.79).
city('Straelen','de','North Rhine-Westphalia',15531.0,6.26,51.46).
city('Sundern','de','North Rhine-Westphalia',29648.0,7.99,51.34).
city('Swisttal','de','North Rhine-Westphalia',18211.0,6.91,50.7).
city('Tecklenburg','de','North Rhine-Westphalia',9510.0,7.82,52.22).
city('Telgte','de','North Rhine-Westphalia',19739.0,7.77,51.99).
city('Toenisvorst','de','North Rhine-Westphalia',30579.0,6.44,51.32).
city('Troisdorf','de','North Rhine-Westphalia',75641.0,7.16,50.82).
city('Uebach-Palenberg','de','North Rhine-Westphalia',25957.0,6.11,50.94).
city('Unna','de','North Rhine-Westphalia',69138.0,7.68,51.54).
city('Velbert','de','North Rhine-Westphalia',88876.0,7.04,51.35).
city('Velen','de','North Rhine-Westphalia',13236.0,6.98,51.9).
city('Verl','de','North Rhine-Westphalia',24532.0,8.51,51.89).
city('Versmold','de','North Rhine-Westphalia',21227.0,8.15,52.05).
city('Viersen','de','North Rhine-Westphalia',76771.0,6.4,51.26).
city('Vlotho','de','North Rhine-Westphalia',20219.0,8.85,52.17).
city('Voerde','de','North Rhine-Westphalia',39052.0,6.68,51.6).
city('Vreden','de','North Rhine-Westphalia',22250.0,6.83,52.04).
city('Wachtberg','de','North Rhine-Westphalia',20004.0,7.11,50.63).
city('Wadersloh','de','North Rhine-Westphalia',13212.0,8.24,51.74).
city('Waldbroel','de','North Rhine-Westphalia',19660.0,7.62,50.89).
city('Waltrop','de','North Rhine-Westphalia',30150.0,7.4,51.64).
city('Warburg','de','North Rhine-Westphalia',24399.0,9.15,51.49).
city('Warendorf','de','North Rhine-Westphalia',39281.0,7.98,51.96).
city('Warstein','de','North Rhine-Westphalia',29029.0,8.36,51.45).
city('Wassenberg','de','North Rhine-Westphalia',16603.0,6.15,51.1).
city('Weeze','de','North Rhine-Westphalia',10371.0,6.2,51.64).
city('Wegberg','de','North Rhine-Westphalia',29931.0,6.26,51.15).
city('Weilerswist','de','North Rhine-Westphalia',16515.0,6.83,50.77).
city('Welver','de','North Rhine-Westphalia',13142.0,7.96,51.62).
city('Wenden','de','North Rhine-Westphalia',19977.0,7.87,50.97).
city('Werdohl','de','North Rhine-Westphalia',20481.0,7.76,51.27).
city('Werl','de','North Rhine-Westphalia',32304.0,7.91,51.55).
city('Wermelskirchen','de','North Rhine-Westphalia',36952.0,7.21,51.15).
city('Werne','de','North Rhine-Westphalia',31093.0,7.63,51.67).
city('Werther','de','North Rhine-Westphalia',11910.0,8.41,52.07).
city('Wesel','de','North Rhine-Westphalia',61768.0,6.62,51.67).
city('Wesseling','de','North Rhine-Westphalia',36296.0,6.98,50.84).
city('Westerkappeln','de','North Rhine-Westphalia',11443.0,7.88,52.32).
city('Wetter','de','North Rhine-Westphalia',29328.0,7.4,51.39).
city('Wickede','de','North Rhine-Westphalia',12681.0,7.86,51.5).
city('Wiehl','de','North Rhine-Westphalia',26784.0,7.48,50.99).
city('Willich','de','North Rhine-Westphalia',52100.0,6.55,51.27).
city('Wilnsdorf','de','North Rhine-Westphalia',21498.0,8.1,50.82).
city('Windeck','de','North Rhine-Westphalia',21202.0,7.56,50.82).
city('Winterberg','de','North Rhine-Westphalia',14603.0,8.53,51.2).
city('Wipperfuerth','de','North Rhine-Westphalia',23507.0,7.39,51.13).
city('Witten','de','North Rhine-Westphalia',101122.0,7.34,51.44).
city('Wuelfrath','de','North Rhine-Westphalia',22549.0,7.05,51.29).
city('Wuerselen','de','North Rhine-Westphalia',37594.0,6.13,50.82).
city('Wuppertal','de','North Rhine-Westphalia',363240.0,7.18,51.26).
city('Xanten','de','North Rhine-Westphalia',21294.0,6.45,51.67).
city('Zuelpich','de','North Rhine-Westphalia',20010.0,6.65,50.7).
city('Alzey','de','Rhineland-Palatinate',17945.0,8.11,49.76).
city('Andernach','de','Rhineland-Palatinate',29089.0,7.4,50.44).
city('Bad Duerkheim','de','Rhineland-Palatinate',18751.0,8.16,49.47).
city('Bad Ems','de','Rhineland-Palatinate',9468.0,7.7,50.34).
city('Bad Kreuznach','de','Rhineland-Palatinate',43317.0,7.86,49.85).
city('Bad Neuenahr-Ahrweiler','de','Rhineland-Palatinate',27972.0,7.13,50.55).
city('Bendorf','de','Rhineland-Palatinate',17224.0,7.57,50.43).
city('Betzdorf','de','Rhineland-Palatinate',10615.0,7.86,50.8).
city('Bingen','de','Rhineland-Palatinate',24844.0,7.88,49.97).
city('Bitburg','de','Rhineland-Palatinate',13154.0,6.52,49.98).
city('Bobenheim-Roxheim','de','Rhineland-Palatinate',10129.0,8.34,49.59).
city('Boehl-Iggelheim','de','Rhineland-Palatinate',10694.0,8.3,49.39).
city('Boppard','de','Rhineland-Palatinate',16606.0,7.6,50.24).
city('Diez','de','Rhineland-Palatinate',11065.0,8.01,50.37).
city('Eisenberg','de','Rhineland-Palatinate',9970.0,8.06,49.56).
city('Frankenthal','de','Rhineland-Palatinate',47523.0,8.35,49.55).
city('Germersheim','de','Rhineland-Palatinate',20706.0,8.37,49.22).
city('Gruenstadt','de','Rhineland-Palatinate',13219.0,8.16,49.57).
city('Hassloch','de','Rhineland-Palatinate',20806.0,8.26,49.37).
city('Herxheim','de','Rhineland-Palatinate',10443.0,8.18,49.52).
city('Hoehr-Grenzhausen','de','Rhineland-Palatinate',9906.0,7.66,50.44).
city('Idar-Oberstein','de','Rhineland-Palatinate',32876.0,7.32,49.71).
city('Ingelheim','de','Rhineland-Palatinate',25296.0,8.06,49.98).
city('Kaiserslautern','de','Rhineland-Palatinate',98947.0,7.75,49.45).
city('Kirchen','de','Rhineland-Palatinate',9354.0,7.87,50.8).
city('Kirn','de','Rhineland-Palatinate',8879.0,7.45,49.8).
city('Koblenz','de','Rhineland-Palat',108146.0,7.6,50.35).
city('Lahnstein','de','Rhineland-Palatinate',18572.0,7.62,50.31).
city('Landau','de','Rhineland-Palatinate',42031.0,8.11,49.2).
city('Limburgerhof','de','Rhineland-Palatinate',10750.0,8.38,49.43).
city('Ludwigshafen','de','Rhineland-Palatinate',162514.0,8.44,49.48).
city('Mainz','de','Rhineland-Palatinate',187940.0,8.26,50.0).
city('Mayen','de','Rhineland-Palatinate',19372.0,7.22,50.33).
city('Montabaur','de','Rhineland-Palatinate',12518.0,7.83,50.44).
city('Morbach','de','Rhineland-Palatinate',11184.0,7.12,49.81).
city('Muelheim-Kaerlich','de','Rhineland-Palatinate',10414.0,7.5,50.39).
city('Mutterstadt','de','Rhineland-Palatinate',12565.0,8.35,49.46).
city('Neustadt','de','Rhineland-Palatinate',54080.0,8.13,49.36).
city('Neuwied','de','Rhineland-Palatinate',66901.0,7.46,50.43).
city('Pirmasens','de','Rhineland-Palatinate',43539.0,7.6,49.2).
city('Remagen','de','Rhineland-Palatinate',16360.0,7.23,50.57).
city('Schifferstadt','de','Rhineland-Palatinate',18933.0,8.37,49.39).
city('Sinzig','de','Rhineland-Palatinate',17708.0,7.25,50.56).
city('Spires','de','Rhineland-Palatinate',50608.0,8.43,49.33).
city('Trier','de','Rhineland-Palatinate',100649.0,6.63,49.75).
city('Vallendar','de','Rhineland-Palatinate',9055.0,7.61,50.4).
city('Wittlich','de','Rhineland-Palatinate',17902.0,6.89,49.99).
city('Woerth','de','Rhineland-Palatinate',17507.0,8.26,49.05).
city('Worms','de','Rhineland-Palatinate',82104.0,8.35,49.64).
city('Zweibruecken','de','Rhineland-Palatinate',35970.0,7.37,49.25).
city('Beckingen','de','Saarland',15959.0,6.7,49.4).
city('Bexbach','de','Saarland',19372.0,7.25,49.35).
city('Blieskastel','de','Saarland',22938.0,7.25,49.25).
city('Dillingen','de','Saarland',21451.0,6.73,49.36).
city('Eppelborn','de','Saarland',18400.0,6.96,49.41).
city('Friedrichsthal','de','Saarland',11425.0,7.1,49.33).
city('Grossrosseln','de','Saarland',9310.0,6.85,49.2).
city('Heusweiler','de','Saarland',20094.0,6.93,49.35).
city('Homburg','de','Saarland',45010.0,7.33,49.33).
city('Illingen','de','Saarland',18312.0,7.04,49.37).
city('Kirkel','de','Saarland',10509.0,7.21,49.28).
city('Kleinblittersdorf','de','Saarland',12940.0,7.04,49.15).
city('Lebach','de','Saarland',21665.0,6.91,49.41).
city('Losheim','de','Saarland',16418.0,6.75,49.52).
city('Mandelbachtal','de','Saarland',11896.0,7.15,49.2).
city('Marpingen','de','Saarland',11439.0,7.05,49.45).
city('Merchweiler','de','Saarland',10795.0,7.05,49.36).
city('Merzig','de','Saarland',31141.0,6.63,49.45).
city('Mettlach','de','Saarland',12705.0,6.6,49.49).
city('Nalbach','de','Saarland',9616.0,6.78,49.38).
city('Neunkirchen','de','Saarland',50432.0,7.18,49.36).
city('Nohfelden','de','Saarland',10666.0,7.15,49.59).
city('Ottweiler','de','Saarland',15692.0,7.16,49.41).
city('Puettlingen','de','Saarland',21142.0,6.88,49.29).
city('Quierschied','de','Saarland',14626.0,7.05,49.32).
city('Rehlingen-Siersburg','de','Saarland',16121.0,6.68,49.38).
city('Riegelsberg','de','Saarland',15476.0,6.93,49.3).
city('Saarbruecken','de','Saarland',181779.0,6.97,49.25).
city('Saarlouis','de','Saarland',37663.0,6.75,49.33).
city('Saarwellingen','de','Saarland',13882.0,6.8,49.36).
city('Sankt Ingbert','de','Saarland',38654.0,7.11,49.28).
city('Sankt Wendel','de','Saarland',27162.0,7.16,49.48).
city('Schiffweiler','de','Saarland',17356.0,7.13,49.37).
city('Schmelz','de','Saarland',17494.0,6.85,49.45).
city('Schwalbach','de','Saarland',18801.0,6.81,49.31).
city('Spiesen-Elversberg','de','Saarland',14633.0,7.15,49.32).
city('Sulzbach','de','Saarland',18802.0,7.06,49.31).
city('Tholey','de','Saarland',13266.0,7.06,49.49).
city('Ueberherrn','de','Saarland',12145.0,6.69,49.25).
city('Voelklingen','de','Saarland',41799.0,6.86,49.26).
city('Wadern','de','Saarland',17236.0,6.88,49.54).
city('Wadgassen','de','Saarland',18787.0,6.79,49.27).
city('Wallerfangen','de','Saarland',9880.0,6.72,49.33).
city('Aken','de','Sachsen-Anhalt',9350.0,12.04,51.86).
city('Aschersleben','de','Sachsen-Anhalt',24569.0,11.47,51.76).
city('Bad Duerrenberg','de','Sachsen-Anhalt',11587.0,12.06,51.3).
city('Bernburg','de','Sachsen-Anhalt',32859.0,11.73,51.8).
city('Bitterfeld','de','Sachsen-Anhalt',15486.0,12.31,51.62).
city('Blankenburg','de','Sachsen-Anhalt',15887.0,10.95,51.8).
city('Burg','de','Sachsen-Anhalt',28602.0,11.85,52.28).
city('Calbe','de','Sachsen-Anhalt',11666.0,11.76,51.91).
city('Coswig','de','Sachsen-Anhalt',8729.0,12.43,51.89).
city('Dessau','de','Sachsen-Anhalt',76628.0,12.22,51.83).
city('Eisleben','de','Sachsen-Anhalt',20119.0,11.55,51.53).
city('Gardelegen','de','Sachsen-Anhalt',11771.0,11.39,52.53).
city('Genthin','de','Sachsen-Anhalt',14573.0,12.16,52.4).
city('Graefenhainichen','de','Sachsen-Anhalt',8026.0,12.45,51.74).
city('Halberstadt','de','Sachsen-Anhalt',39391.0,11.04,51.9).
city('Haldensleben','de','Sachsen-Anhalt',20131.0,11.4,52.31).
city('Halle','de','Sachsen-Anhalt',232452.0,11.96,51.48).
city('Hettstedt','de','Sachsen-Anhalt',15876.0,11.5,51.65).
city('Koethen','de','Sachsen-Anhalt',28700.0,11.97,51.76).
city('Leuna','de','Sachsen-Anhalt',7100.0,12.02,51.31).
city('Magdeburg','de','Sachsen-Anhalt',224428.0,11.62,52.13).
city('Merseburg','de','Sachsen-Anhalt',34440.0,11.99,51.36).
city('Naumburg','de','Sachsen-Anhalt',30040.0,11.8,51.16).
city('Oschersleben','de','Sachsen-Anhalt',19929.0,11.23,52.04).
city('Osterburg','de','Sachsen-Anhalt',7255.0,11.75,52.8).
city('Que','de','Sachsen-Anhalt',23057.0,11.15,51.79).
city('Querfurt','de','Sachsen-Anhalt',9436.0,11.6,51.38).
city('Rosslau','de','Sachsen-Anhalt',14247.0,12.24,51.9).
city('Salzwedel','de','Sachsen-Anhalt',24144.0,11.14,52.86).
city('Sangerhausen','de','Sachsen-Anhalt',23301.0,11.29,51.48).
city('Schoenebeck','de','Sachsen-Anhalt',34358.0,11.74,52.03).
city('Stassfurt','de','Sachsen-Anhalt',26705.0,11.58,51.86).
city('Stendal','de','Sachsen-Anhalt',37402.0,11.84,52.61).
city('Tangermuende','de','Sachsen-Anhalt',9686.0,11.95,52.55).
city('Thale','de','Sachsen-Anhalt',13544.0,11.04,51.75).
city('Weissenfels','de','Sachsen-Anhalt',30002.0,11.97,51.21).
city('Wernigerode','de','Sachsen-Anhalt',34674.0,10.79,51.84).
city('Wittenberg','de','Sachsen-Anhalt',45754.0,12.64,51.88).
city('Wolfen','de','Sachsen-Anhalt',25144.0,12.3,51.63).
city('Wolmirstedt','de','Sachsen-Anhalt',10589.0,11.63,52.25).
city('Zeitz','de','Sachsen-Anhalt',29582.0,12.13,51.06).
city('Zerbst','de','Sachsen-Anhalt',16054.0,12.08,51.97).
city('Annaberg-Buchholz','de','Saxony',22849.0,13.01,50.58).
city('Aue','de','Saxony',18630.0,12.7,50.59).
city('Auerbach','de','Saxony',25430.0,12.4,50.52).
city('Bautzen','de','Saxony',41606.0,14.43,51.18).
city('Bischofswerda','de','Saxony',13577.0,14.18,51.14).
city('Borna','de','Saxony',18504.0,12.49,51.13).
city('Brand-Erbisdorf','de','Saxony',12098.0,13.32,50.88).
city('Burgstaedt','de','Saxony',12506.0,12.81,50.92).
city('Chemnitz','de','Saxony',246654.0,12.92,50.83).
city('Coswig','de','Saxony',21965.0,13.56,51.14).
city('Crimmitschau','de','Saxony',22410.0,12.38,50.82).
city('Delitzsch','de','Saxony',25160.0,12.33,51.53).
city('Doebeln','de','Saxony',21318.0,13.11,51.13).
city('Dresden','de','Saxony',480801.0,13.74,51.05).
city('Ebersbach','de','Saxony',9056.0,14.57,51.01).
city('Eilenburg','de','Saxony',17120.0,12.62,51.46).
city('Falkenstein','de','Saxony',9859.0,12.37,50.48).
city('Floeha','de','Saxony',11427.0,13.07,50.87).
city('Frankenberg','de','Saxony',16819.0,13.04,50.92).
city('Freiberg','de','Saxony',43160.0,13.34,50.92).
city('Freital','de','Saxony',38815.0,13.66,51.02).
city('Glauchau','de','Saxony',26260.0,12.54,50.82).
city('Goerlitz','de','Saxony',57097.0,14.98,51.16).
city('Grimma','de','Saxony',17780.0,12.71,51.24).
city('Groeditz','de','Saxony',8086.0,13.44,51.42).
city('Grossenhain','de','Saxony',16588.0,13.53,51.29).
city('Hainichen','de','Saxony',9628.0,13.11,50.97).
city('Heidenau','de','Saxony',16719.0,13.86,50.99).
city('Hohenstein-Ernstthal','de','Saxony',16416.0,12.71,50.81).
city('Hoyerswerda','de','Saxony',43267.0,14.24,51.44).
city('Kamenz','de','Saxony',18122.0,14.09,51.28).
city('Klingenthal','de','Saxony',8984.0,12.46,50.37).
city('Leipzig','de','Saxony',492637.0,12.4,51.35).
city('Lichtenstein','de','Saxony',13583.0,12.63,50.76).
city('Limbach-Oberfrohna','de','Saxony',26721.0,12.74,50.87).
city('Loebau','de','Saxony',21398.0,14.67,51.1).
city('Loessnitz','de','Saxony',10643.0,12.71,50.62).
city('Lugau','de','Saxony',7779.0,12.75,50.74).
city('Marienberg','de','Saxony',15600.0,13.16,50.65).
city('Markkleeberg','de','Saxony',23220.0,12.37,51.29).
city('Meerane','de','Saxony',17646.0,12.46,50.85).
city('Meissen','de','Saxony',28360.0,13.47,51.17).
city('Mittweida','de','Saxony',16494.0,12.98,50.99).
city('Neustadt','de','Saxony',10649.0,14.22,51.04).
city('Niesky','de','Saxony',11260.0,14.81,51.31).
city('Oelsnitz im Erzgebirge','de','Saxony',13214.0,12.16,50.42).
city('Oelsnitz im Vogtland','de','Saxony',12326.0,12.71,50.74).
city('Olbernhau','de','Saxony',11206.0,13.33,50.67).
city('Oschatz','de','Saxony',16348.0,13.1,51.31).
city('Pirna','de','Saxony',39701.0,13.93,50.96).
city('Plauen','de','Saxony',69378.0,12.14,50.5).
city('Radeberg','de','Saxony',18529.0,13.91,51.12).
city('Radebeul','de','Saxony',32698.0,13.63,51.11).
city('Reichenbach','de','Saxony',22569.0,12.3,50.62).
city('Riesa','de','Saxony',36788.0,13.28,51.31).
city('Schkeuditz','de','Saxony',19337.0,12.21,51.41).
city('Schneeberg','de','Saxony',16833.0,12.64,50.61).
city('Schwarzenberg','de','Saxony',18406.0,12.79,50.56).
city('Sebnitz','de','Saxony',9359.0,14.27,50.99).
city('Stollberg','de','Saxony',13304.0,12.77,50.72).
city('Taucha','de','Saxony',14669.0,12.48,51.38).
city('Thalheim','de','Saxony',7622.0,12.86,50.7).
city('Torgau','de','Saxony',18883.0,12.99,51.56).
city('Waldheim','de','Saxony',9150.0,13.02,51.08).
city('Weisswasser','de','Saxony',22124.0,14.64,51.51).
city('Werdau','de','Saxony',24299.0,12.38,50.74).
city('Wilkau-Hasslau','de','Saxony',12452.0,12.51,50.67).
city('Wurzen','de','Saxony',15066.0,12.73,51.37).
city('Zittau','de','Saxony',25527.0,14.81,50.9).
city('Zschopau','de','Saxony',12016.0,13.07,50.75).
city('Zwickau','de','Saxony',99343.0,12.5,50.72).
city('Zwoenitz','de','Saxony',12424.0,12.8,50.64).
city('Ahrensburg','de','Schleswig-Holstein',30797.0,10.23,53.68).
city('Altenholz','de','Schleswig-Holstein',9721.0,10.12,54.41).
city('Bad Bramstedt','de','Schleswig-Holstein',13303.0,9.87,53.92).
city('Bad Oldesloe','de','Schleswig-Holstein',23982.0,10.37,53.81).
city('Bad Schwartau','de','Schleswig-Holstein',20052.0,10.7,53.92).
city('Bad Segeberg','de','Schleswig-Holstein',16097.0,10.3,53.94).
city('Bargteheide','de','Schleswig-Holstein',14123.0,10.26,53.74).
city('Barmstedt','de','Schleswig-Holstein',9558.0,9.76,53.79).
city('Barsbuettel','de','Schleswig-Holstein',12395.0,10.17,53.57).
city('Brunsbuettel','de','Schleswig-Holstein',13840.0,9.13,53.9).
city('Buedelsdorf','de','Schleswig-Holstein',10060.0,9.66,54.29).
city('Eckernfoerde','de','Schleswig-Holstein',23184.0,9.83,54.47).
city('Elmshorn','de','Schleswig-Holstein',48744.0,9.65,53.75).
city('Eutin','de','Schleswig-Holste',17258.0,10.6,54.14).
city('Flensburg','de','Schleswig-Holstein',85158.0,9.42,54.79).
city('Geesthacht','de','Schleswig-Holstein',29853.0,10.37,53.45).
city('Glinde','de','Schleswig-Holstein',16106.0,10.21,53.56).
city('Glueckstadt','de','Schleswig-Holstein',11976.0,9.41,53.79).
city('Halstenbek','de','Schleswig-Holstein',16074.0,9.84,53.64).
city('Harrislee','de','Schleswig-Holstein',11600.0,9.37,54.8).
city('Heide','de','Schleswig-Holstein',20309.0,9.08,54.2).
city('Heiligenhafen','de','Schleswig-Holstein',9328.0,10.97,54.38).
city('Henstedt-Ulzburg','de','Schl',26062.0,9.99,53.78).
city('Husum','de','Schleswig-Holstein',20753.0,9.05,54.49).
city('Itzehoe','de','Schleswig-Holstein',33415.0,9.49,53.94).
city('Kaltenkirchen','de','Schleswig-Holstein',19161.0,9.96,53.84).
city('Kappeln','de','Schleswig-Holstein',9801.0,9.92,54.67).
city('Kiel','de','Schleswig-Holstein',235264.0,10.12,54.32).
city('Kronshagen','de','Schleswig-Holstein',11826.0,10.08,54.34).
city('Lauenburg','de','Schleswig-Holstein',11796.0,10.56,53.38).
city('Luebeck','de','Schleswig-Holstein',213171.0,10.66,53.87).
city('Malente','de','Schlesw',10731.0,10.56,54.18).
city('Moelln','de','Schleswig-Holstein',18396.0,10.69,53.63).
city('Neumuenster','de','Schleswig-Holstein',79429.0,9.98,54.07).
city('Neustadt','de','Schleswig-Holstein',16680.0,10.81,54.11).
city('Norderstedt','de','Schleswig-Holstein',72011.0,10.02,53.66).
city('Oldenburg','de','Schleswig-Holstein',9843.0,10.88,54.3).
city('Pinneberg','de','Schleswig-Holstein',40679.0,9.8,53.66).
city('Ploen','de','Schleswig-Holstein',12876.0,10.42,54.17).
city('Preetz','de','Schleswig-Holstein',15540.0,10.28,54.24).
city('Quickborn','de','Schles',20281.0,9.89,53.73).
city('Ratekau','de','Schleswig-Holstein',16031.0,10.73,53.95).
city('Ratzeburg','de','Schleswig-Holstein',13719.0,10.78,53.69).
city('Reinbek','de','Schleswig-Holstein',25357.0,10.25,53.52).
city('Rellingen','de','Schleswig-Holstein',13856.0,9.81,53.65).
city('Rendsburg','de','Schleswig-Holstein',28814.0,9.66,54.31).
city('Scharbeutz','de','Schleswig-Holstein',11973.0,10.74,54.04).
city('Schenefeld','de','Schleswig-Holstein',17887.0,9.81,53.61).
city('Schleswig','de','Schleswig-Holstein',24061.0,9.55,54.54).
city('Schwarzenbek','de','Schleswig-Holstein',15310.0,10.48,53.51).
city('Stockelsdorf','de','Schleswig-Holstein',16449.0,10.65,53.91).
city('Timmendorfer Strand','de','Schleswig-Holstein',9090.0,10.76,54.0).
city('Tornesch','de','Schleswig-Holstein',13045.0,9.71,53.7).
city('Uetersen','de','Schleswig-Holstein',18155.0,9.67,53.69).
city('Wahlstedt','de','Schleswig-Holstein',9462.0,10.21,53.95).
city('Wedel','de','Schleswig-Holstein',32619.0,9.72,53.58).
city('Westerland','de','Schleswig-Holstein',8927.0,8.31,54.92).
city('Altenburg','de','Thuringia',38338.0,12.44,51.01).
city('Apolda','de','Thuringia',24380.0,11.51,51.03).
city('Arnstadt','de','Thuringia',25995.0,10.95,50.85).
city('Bad Frankenhausen','de','Thuringia',9102.0,11.1,51.36).
city('Bad Langensalza','de','Thuringia',20144.0,10.64,51.11).
city('Bad Salzungen','de','Thuringia',16610.0,10.21,50.81).
city('Eisenach','de','Thuringia',44399.0,10.31,50.98).
city('Eisenberg','de','Thuringia',11616.0,11.89,50.97).
city('Erfurt','de','Thuringia',196719.0,11.03,50.99).
city('Gera','de','Thuringia',104463.0,12.08,50.88).
city('Gotha','de','Thuringia',47214.0,10.7,50.95).
city('Greiz','de','Thuringia',23931.0,12.2,50.66).
city('Heilbad Heiligenstadt','de','Thuringia',17056.0,10.13,51.38).
city('Hermsdorf','de','Thuringia',8728.0,11.85,50.89).
city('Hildburghausen','de','Thuringia',12422.0,10.73,50.43).
city('Ilmenau','de','Thuringia',27471.0,10.91,50.69).
city('Jena','de','Thuringia',99269.0,11.58,50.93).
city('Leinefelde','de','Thuringia',13794.0,10.32,51.39).
city('Meiningen','de','Thuringia',21570.0,10.41,50.57).
city('Meuselwitz','de','Thuringia',9953.0,12.3,51.0).
city('Muehlhausen','de','Thuringia',36287.0,10.45,51.22).
city('Neustadt','de','Thuringia',9142.0,11.74,50.75).
city('Nordhausen','de','Thuringia',43709.0,10.79,51.51).
city('Poessneck','de','Thuringia',13614.0,11.6,50.7).
city('Rudolstadt','de','Thuringia',25773.0,11.33,50.72).
city('Saalfeld','de','Thuringia',28152.0,11.35,50.65).
city('Schmalkalden','de','Thuringia',17963.0,10.45,50.73).
city('Schmoelln','de','Thuringia',13118.0,12.36,50.91).
city('Soemmerda','de','Thuringia',20872.0,11.12,51.17).
city('Sondershausen','de','Thuringia',21954.0,10.86,51.37).
city('Sonneberg','de','Thuringia',24351.0,11.18,50.36).
city('Suhl','de','Thuringia',43269.0,10.68,50.61).
city('Waltershausen','de','Thuringia',11345.0,10.56,50.9).
city('Weida','de','Thuringia',8355.0,12.06,50.78).
city('Weimar','de','Thuringia',65113.0,11.32,50.99).
city('Zella-Mehlis','de','Thuringia',12664.0,10.68,50.65).
city('Zeulenroda','de','Thuringia',13760.0,11.98,50.65).
city('Agogo','gh','Ashanti',37123.0,-1.08,6.8).
city('Bekwai','gh','Ashanti',4260.0,-1.58,6.45).
city('Ejura','gh','Ashanti',43403.0,-1.37,7.38).
city('Konongo','gh','Ashanti',26909.0,-1.21,6.62).
city('Kumasi','gh','Ashanti',1468797.0,-1.63,6.69).
city('Mampong','gh','Ashanti',39732.0,-1.41,7.06).
city('Obuasi','gh','Ashanti',119063.0,-1.66,6.19).
city('Tafo','gh','Ashanti',50456.0,-1.62,6.73).
city('Bechem','gh','Brong-Ahafo',14391.0,-2.03,7.09).
city('Berekum','gh','Brong-Ahafo',36409.0,-2.59,7.45).
city('Duayaw Nkwanta','gh','Brong-Ahafo',14227.0,-2.1,7.17).
city('Kintampo','gh','Brong-Ahafo',22731.0,-1.73,8.05).
city('Sunyani','gh','Brong-Ahafo',63180.0,-2.35,7.34).
city('Techiman','gh','Brong-Ahafo',41315.0,-1.94,7.58).
city('Wenchi','gh','Brong-Ahafo',30389.0,-2.11,7.74).
city('Apam','gh','Central',20148.0,-0.73,5.29).
city('Cape Coast','gh','Central',143044.0,-1.25,5.11).
city('Dunkwa','gh','Central',25410.0,-1.79,5.96).
city('Elmina','gh','Central',25560.0,-1.35,5.09).
city('Foso','gh','Central',15637.0,-1.29,5.7).
city('Mumford','gh','Central',13983.0,-0.75,5.27).
city('Nyakrom','gh','Central',17441.0,-0.88,5.63).
city('Saltpond','gh','Central',18794.0,-1.06,5.2).
city('Swedru','gh','Central',46950.0,-0.71,5.54).
city('Winneba','gh','Central',40754.0,-0.63,5.35).
city('Aburi','gh','Eastern',15053.0,-0.18,5.85).
city('Akim Swedru','gh','Eastern',8355.0,-1.02,5.9).
city('Akropong','gh','Eastern',11096.0,-0.09,5.97).
city('Akwatia','gh','Eastern',20451.0,-0.8,6.05).
city('Asamankese','gh','Eastern',36589.0,-0.67,5.86).
city('Begoro','gh','Eastern',23759.0,-0.39,6.38).
city('Kade','gh','Eastern',13315.0,-0.84,6.09).
city('Kibi','gh','Eastern',9399.0,-0.56,6.16).
city('Koforidua','gh','Eastern',76669.0,-0.26,6.09).
city('Mpraeso','gh','Eastern',9007.0,-0.73,6.58).
city('Nkawkaw','gh','Eastern',41493.0,-0.78,6.55).
city('Nsawam','gh','Eastern',26682.0,-0.36,5.81).
city('Oda','gh','Eastern',32151.0,-1.0,5.91).
city('Somanya','gh','Eastern',16579.0,-0.11,6.11).
city('Suhum','gh','Eastern',25192.0,-0.45,6.04).
city('Accra','gh','Greater Accra',1963460.0,-0.2,5.56).
city('Ashiaman','gh','Greater Accra',123133.0,-0.33,5.7).
city('Madina','gh','Greater Accra',68591.0,-0.17,5.68).
city('Nungua','gh','Greater Accra',70482.0,-0.07,5.6).
city('Tema','gh','Greater Accra',351556.0,0.01,5.64).
city('Tema New Town','gh','Greater Accra',76093.0,0.07,5.68).
city('Teshie','gh','Greater Accra',144012.0,-0.1,5.59).
city('Kpandae','gh','Northern',8652.0,-0.02,8.47).
city('Salaga','gh','Northern',19609.0,-0.52,8.54).
city('Savelugu','gh','Northern',29310.0,-0.83,9.62).
city('Tamale','gh','Northern',360644.0,-0.84,9.4).
city('Yendi','gh','Northern',54411.0,-0.01,9.44).
city('Bawku','gh','Upper East',41808.0,-0.24,11.06).
city('Bolgatanga','gh','Upper East',39870.0,-0.85,10.79).
city('Navrongo','gh','Upper East',25470.0,-1.09,10.89).
city('Wa','gh','Upper West',50268.0,-2.5,10.06).
city('Aflao','gh','Volta',29991.0,1.12,6.11).
city('Anloga','gh','Volta',29748.0,0.9,5.79).
city('Ho','gh','Volta',54199.0,0.47,6.6).
city('Hohoe','gh','Volta',30120.0,0.47,7.15).
city('Keta','gh','Volta',18077.0,0.99,5.91).
city('Kete-Krachi','gh','Volta',9182.0,-0.02,7.8).
city('Kpandu','gh','Volta',22525.0,0.3,7.0).
city('Aboso','gh','Western',8790.0,-1.93,5.37).
city('Anomabu','gh','Western',12717.0,-2.1,5.43).
city('Axim','gh','Western',24500.0,-2.24,4.87).
city('Bibiani','gh','Western',19076.0,-2.33,6.46).
city('Prestea','gh','Western',31607.0,-2.15,5.44).
city('Sekondi','gh','Western',104194.0,-1.72,4.94).
city('Shama','gh','Western',20946.0,-1.65,5.0).
city('Takoradi','gh','Western',114989.0,-1.76,4.89).
city('Tarkwa','gh','Western',41345.0,-2.0,5.3).
city('Aiyion','gr','Ahaia',20665.0,22.08,38.25).
city('Aiyira','gr','Ahaia',1666.0,22.35,38.15).
city('Akrata','gr','Ahaia',1833.0,22.33,38.16).
city('Aktaio','gr','Ahaia',1062.0,21.78,38.29).
city('Ano Kastritsion','gr','Ahaia',1003.0,21.83,38.27).
city('Apideon','gr','Ahaia',748.0,21.43,38.07).
city('Ayios Vasilios','gr','Ahaia',2303.0,21.78,38.28).
city('Dafni','gr','Ahaia',1111.0,22.02,37.8).
city('Demenika','gr','Ahaia',2600.0,21.74,38.21).
city('Diakopton','gr','Ahaia',2363.0,22.2,38.19).
city('Kalavrita','gr','Ahaia',1629.0,22.11,38.03).
city('Kamarai','gr','Ahaia',1200.0,22.0,38.3).
city('Kaminia','gr','Ahaia',850.0,21.62,38.15).
city('Kato Akhaia','gr','Ahaia',5752.0,21.55,38.15).
city('Kato Mazarakion','gr','Ahaia',1005.0,21.65,38.07).
city('Khalandritsa','gr','Ahaia',949.0,21.78,38.12).
city('Lapas','gr','Ahaia',1377.0,21.42,38.1).
city('Mintiloglion','gr','Ahaia',1836.0,21.7,38.18).
city('Ovria','gr','Ahaia',5838.0,21.72,38.18).
city('Paralia','gr','Ahaia',7299.0,21.7,38.2).
city('Patrai','gr','Ahaia',163361.0,21.73,38.24).
city('Rion','gr','Ahaia',6084.0,21.78,38.3).
city('Rododafni','gr','Ahaia',2437.0,22.05,38.28).
city('Royitika','gr','Ahaia',1206.0,21.68,38.18).
city('Sagaiika','gr','Ahaia',954.0,21.47,38.11).
city('Selianitika','gr','Ahaia',1210.0,22.03,38.28).
city('Silivainiotika','gr','Ahaia',1595.0,22.33,38.17).
city('Temeni','gr','Ahaia',1125.0,22.12,38.23).
city('Vrakhnaiika','gr','Ahaia',2780.0,21.67,38.17).
city('Agrinion','gr','Aitolia kai Akarnania',43526.0,21.41,38.62).
city('Aitolikon','gr','Aitolia kai Akarnania',4323.0,21.35,38.43).
city('Amfilokhia','gr','Aitolia kai Akarnania',4023.0,21.17,38.86).
city('Angelokastron','gr','Aitolia kai Akarnania',1614.0,21.3,38.57).
city('Antirrion','gr','Aitolia kai Akarnania',1261.0,21.77,38.33).
city('Arkhontokhorion','gr','Aitolia kai Akarnania',834.0,21.03,38.7).
city('Astakos','gr','Aitolia kai Akarnania',2569.0,21.08,38.53).
city('Ayios Konstantinos','gr','Aitolia kai Akarnania',5703.0,21.4,38.64).
city('Ayios Nikolaos','gr','Aitolia kai Akarnania',982.0,21.11,38.73).
city('Dokimion','gr','Aitolia kai Akarnania',1649.0,21.35,38.62).
city('Euinokhorion','gr','Aitolia kai Akarnania',1585.0,21.53,38.37).
city('Fitiai','gr','Aitolia kai Akarnania',1516.0,21.18,38.7).
city('Galatas','gr','Aitolia kai Akarnania',1057.0,21.57,38.35).
city('Gavalou','gr','Aitolia kai Akarnania',1419.0,21.53,38.53).
city('Gouria','gr','Aitolia kai Akarnania',1096.0,21.27,38.47).
city('Grammatikou','gr','Aitolia kai Akarnania',1061.0,21.5,38.53).
city('Kainouryion','gr','Aitolia kai Akarnania',2946.0,21.5,38.6).
city('Kalivia','gr','Aitolia kai Akarnania',990.0,21.3,38.62).
city('Kandila','gr','Aitolia kai Akarnania',1245.0,20.93,38.7).
city('Katokhi','gr','Aitolia kai Akarnania',2850.0,21.25,38.42).
city('Katouna','gr','Aitolia kai Akarnania',2235.0,21.12,38.78).
city('Krikellos','gr','Aitolia kai Akarnania',1312.0,21.18,38.95).
city('Lepenou','gr','Aitolia kai Akarnania',2170.0,21.28,38.7).
city('Liyias','gr','Aitolia kai Akarnania',1350.0,21.85,38.42).
city('Mataranka','gr','Aitolia kai Akarnania',1831.0,21.47,38.52).
city('Megali Khora','gr','Aitolia kai Akarnania',1191.0,21.37,38.63).
city('Menidion','gr','Aitolia kai Akarnania',1110.0,21.12,39.04).
city('Mesolongion','gr','Aitolia kai Akarnania',12702.0,21.43,38.37).
city('Mitikas','gr','Aitolia kai Akarnania',934.0,20.93,38.67).
city('Monastirakion','gr','Aitolia kai Akarnania',1299.0,20.95,38.85).
city('Naupaktos','gr','Aitolia kai Akarnania',13793.0,21.83,38.39).
city('Neapoli','gr','Aitolia kai Akarnania',1345.0,21.37,38.67).
city('Neokhorion','gr','Aitolia kai Akarnania',3116.0,21.28,38.42).
city('Palaiomanina','gr','Aitolia kai Akarnania',855.0,21.23,38.55).
city('Palairos','gr','Aitolia kai Akarnania',2589.0,20.88,38.78).
city('Paliambela','gr','Aitolia kai Akarnania',996.0,20.95,38.92).
city('Panaitolion','gr','Aitolia kai Akarnania',2915.0,21.45,38.58).
city('Pappadatai','gr','Aitolia kai Akarnania',1313.0,20.79,39.31).
city('Paravola','gr','Aitolia kai Akarnania',1215.0,21.52,38.62).
city('Pentalofon','gr','Aitolia kai Akarnania',912.0,21.25,38.48).
city('Playia','gr','Aitolia kai Akarnania',939.0,20.77,38.8).
city('Sardinia','gr','Aitolia kai Akarnania',1064.0,21.2,38.88).
city('Spolaita','gr','Aitolia kai Akarnania',632.0,21.35,38.7).
city('Stamna','gr','Aitolia kai Akarnania',921.0,21.28,38.52).
city('Stanos','gr','Aitolia kai Akarnania',1132.0,21.17,38.8).
city('Stratos','gr','Aitolia kai Akarnania',1110.0,21.32,38.67).
city('Thermon','gr','Aitolia kai Akarnania',1958.0,21.67,38.58).
city('Thirion','gr','Aitolia kai Akarnania',753.0,20.98,38.87).
city('Triantaiika','gr','Aitolia kai Akarnania',1488.0,21.38,38.65).
city('Trifos','gr','Aitolia kai Aka',708.0,21.07,38.83).
city('Vonitsa','gr','Aitolia kai Akarnania',3770.0,20.89,38.92).
city('Anifion','gr','Argolis',922.0,22.78,37.67).
city('Arakhnaion','gr','Argolis',803.0,22.97,37.68).
city('Argos','gr','Argolis',25091.0,22.73,37.63).
city('Aria','gr','Argolis',2080.0,22.83,37.57).
city('Arkhaia Epidauros','gr','Argolis',1844.0,23.07,37.64).
city('Asini','gr','Argolis',1081.0,22.87,37.55).
city('Ayia Triada','gr','Argolis',1310.0,22.77,37.67).
city('Ayios Adrianos','gr','Argolis',1043.0,22.83,37.6).
city('Didima','gr','Argolis',1271.0,23.17,37.47).
city('Drepanon','gr','Argolis',1348.0,22.88,37.55).
city('Ermioni','gr','Argolis',2856.0,23.25,37.38).
city('Kiverion','gr','Argolis',979.0,22.73,37.52).
city('Koilas','gr','Argolis',1126.0,23.13,37.42).
city('Koutsopodion','gr','Argolis',1848.0,22.72,37.68).
city('Kranidion','gr','Argolis',4442.0,23.16,37.38).
city('Ligourion','gr','Argolis',2817.0,23.03,37.62).
city('Limnai','gr','Argolis',862.0,22.88,37.72).
city('Miloi','gr','Argolis',833.0,22.72,37.55).
city('Nauplion','gr','Argolis',14582.0,22.81,37.56).
city('Nea Epidauros','gr','Argolis',1129.0,23.13,37.67).
city('Nea Kios','gr','Argolis',4214.0,22.75,37.58).
city('Nea Tirins','gr','Argolis',1305.0,22.82,37.6).
city('Portokhelion','gr','Argolis',2219.0,23.15,37.32).
city('Tolon','gr','Argolis',2322.0,22.85,37.52).
city('Astros','gr','Arkadia',2222.0,22.72,37.4).
city('Ayios Andreas','gr','Arkadia',1033.0,22.76,37.35).
city('Ayios Konstantinos','gr','Arkadia',1197.0,22.38,37.52).
city('Ayios Petros','gr','Arkadia',857.0,22.55,37.34).
city('Leonidion','gr','Arkadia',3020.0,22.86,37.17).
city('Levidion','gr','Arkadia',1245.0,22.3,37.68).
city('Megalopoli','gr','Arkadia',5283.0,22.14,37.4).
city('Paralion Astros','gr','Arkadia',827.0,22.77,37.42).
city('Tripoli','gr','Arkadia',26562.0,22.38,37.51).
city('Vitina','gr','Arkadia',906.0,22.18,37.67).
city('Vlakhokerasea','gr','Arkadia',773.0,22.38,37.37).
city('Aneza','gr','Arta',1197.0,20.92,39.09).
city('Ar','gr','Arta',19541.0,20.99,39.16).
city('Ayios Dimitrios','gr','Arta',1034.0,21.08,39.4).
city('Ayios Spiridon','gr','Arta',1281.0,20.86,39.14).
city('Eleousa','gr','Arta',963.0,20.99,39.15).
city('Grammenitsa','gr','Arta',1193.0,20.98,39.18).
city('Kalamia','gr','Arta',1197.0,20.93,39.17).
city('Kambi','gr','Arta',1027.0,20.9,39.22).
city('Khalkiades','gr','Arta',1247.0,20.93,39.16).
city('Kombotion','gr','Arta',2150.0,21.09,39.1).
city('Kostakioi','gr','Arta',1417.0,20.96,39.14).
city('Melissourgoi','gr','Arta',593.0,21.15,39.51).
city('Neokhorion','gr','Arta',2103.0,21.02,39.07).
city('Peta','gr','Arta',1952.0,21.03,39.17).
city('Theodoriana','gr','Arta',999.0,21.21,39.43).
city('Afidnai','gr','Attiki',2070.0,23.83,38.22).
city('Aiantion','gr','Attiki',3936.0,23.47,37.92).
city('Aigaleo','gr','Attiki',72320.0,23.68,37.98).
city('Aiyina','gr','Attiki',7823.0,23.43,37.75).
city('Akharnai','gr','Attiki',82376.0,23.73,38.08).
city('Amarousion','gr','Attiki',72310.0,23.8,38.05).
city('Ambelakia','gr','Attiki',4671.0,23.53,37.95).
city('Anavissos','gr','Attiki',8459.0,23.95,37.73).
city('Ano Liosia','gr','Attiki',28529.0,23.7,38.08).
city('Anoixis','gr','Attiki',6482.0,23.85,38.13).
city('Anthousa','gr','Attiki',3019.0,23.88,37.99).
city('Artemi','gr','Attiki',20725.0,23.67,38.31).
city('Aryiroupoli','gr','Attiki',33715.0,23.75,37.9).
city('Aspropirgos','gr','Attiki',32712.0,23.58,38.07).
city('Athens','gr','Attiki',729139.0,23.73,37.98).
city('Aulon','gr','Attiki',4635.0,23.69,38.25).
city('Ayia Marina','gr','Attiki',2731.0,23.53,37.75).
city('Ayia Paraskevi','gr','Attiki',60662.0,23.83,38.01).
city('Ayia Varvara','gr','Attiki',31218.0,23.65,37.99).
city('Ayioi Anaryiroi','gr','Attiki',33753.0,23.72,38.02).
city('Ayioi Apostoloi','gr','Attiki',4338.0,23.99,38.3).
city('Ayios Dimitrios','gr','Attiki',35066.0,23.81,37.92).
city('Ayios Ioannis Rentis','gr','Attiki',15354.0,23.67,37.98).
city('Ayios Konstantinos','gr','Attiki',1086.0,23.79,38.31).
city('Ayios Panteleimon','gr','Attiki',1386.0,23.98,38.15).
city('Ayios Stefanos','gr','Attiki',10940.0,23.85,38.15).
city('Dafni','gr','Attiki',23447.0,23.63,38.01).
city('Dionisos','gr','Attiki',5940.0,23.88,38.1).
city('Drapetsona','gr','Attiki',12861.0,23.61,37.95).
city('Drosia','gr','Attiki',7098.0,23.85,38.12).
city('Ekali','gr','Attiki',5666.0,23.83,38.12).
city('Eleusis','gr','Attiki',27055.0,23.53,38.03).
city('Ellinikon','gr','Attiki',18094.0,23.73,37.88).
city('Erithrai','gr','Attiki',3250.0,23.32,38.22).
city('Fili','gr','Attiki',2875.0,23.67,38.1).
city('Filothi','gr','Attiki',6926.0,23.78,38.03).
city('Galatas','gr','Attiki',2759.0,23.45,37.5).
city('Galatsion','gr','Attiki',58625.0,23.75,38.02).
city('Glifada','gr','Attiki',88496.0,23.75,37.87).
city('Glika Nera','gr','Attiki',6939.0,23.86,38.0).
city('Grammatikon','gr','Attiki',1334.0,23.97,38.2).
city('Idra','gr','Attiki',2619.0,23.46,37.35).
city('Ilion','gr','Attiki',81647.0,23.71,38.03).
city('Ilioupoli','gr','Attiki',76360.0,23.76,37.93).
city('Imittos','gr','Attiki',10923.0,23.78,37.93).
city('Iraklion','gr','Attiki',47007.0,23.77,38.07).
city('Kaisariani','gr','Attiki',26126.0,23.8,37.97).
city('Kalamakion','gr','Attiki',40490.0,23.72,37.92).
city('Kalamos','gr','Attiki',2158.0,23.87,38.28).
city('Kalivia Thorikou','gr','Attiki',14712.0,23.92,37.83).
city('Kallithea','gr','Attiki',107767.0,23.7,37.95).
city('Kamateron','gr','Attiki',24310.0,23.7,38.07).
city('Kapandrition','gr','Attiki',2672.0,23.88,38.22).
city('Karellas','gr','Attiki',1930.0,23.91,37.88).
city('Kato Soulion','gr','Attiki',1493.0,24.0,38.17).
city('Keratea','gr','Attiki',7701.0,23.98,37.8).
city('Keratsinion','gr','Attiki',77222.0,23.62,37.96).
city('Khaidarion','gr','Attiki',45277.0,23.67,38.02).
city('Khalandrion','gr','Attiki',74211.0,23.8,38.03).
city('Khalkoutsion','gr','Attiki',2293.0,23.73,38.33).
city('Kholargos','gr','Attiki',31545.0,23.8,38.0).
city('Kifisia','gr','Attiki',45755.0,23.82,38.07).
city('Kineta','gr','Attiki',2004.0,23.2,37.97).
city('Kipseli','gr','Attiki',2096.0,23.73,38.0).
city('Kitsi','gr','Attiki',3944.0,23.88,37.92).
city('Koridallos','gr','Attiki',68894.0,23.66,37.98).
city('Koropion','gr','Attiki',17151.0,23.88,37.9).
city('Kouvaras','gr','Attiki',1381.0,23.97,37.83).
city('Krionerion','gr','Attiki',3393.0,23.83,38.15).
city('Laurion','gr','Attiki',8435.0,24.05,37.72).
city('Leontarion','gr','Attiki',4707.0,23.87,37.98).
city('Likovrisi','gr','Attiki',9087.0,23.78,38.07).
city('Limin Markopoulou','gr','Attiki',8899.0,23.95,37.9).
city('Magoula','gr','Attiki',4219.0,23.52,38.08).
city('Mandra','gr','Attiki',11294.0,23.5,38.07).
city('Marathon','gr','Attiki',4051.0,23.97,38.15).
city('Markopoulon','gr','Attiki',6088.0,23.88,38.08).
city('Megara','gr','Attiki',24047.0,23.35,38.0).
city('Melissia','gr','Attiki',22385.0,23.83,38.05).
city('Metamorfosi','gr','Attiki',28740.0,23.75,38.05).
city('Methana','gr','Attiki',1183.0,23.38,37.58).
city('Milesion','gr','Attiki',1121.0,23.8,38.28).
city('Moskhaton','gr','Attiki',23533.0,23.67,37.95).
city('Nea Erithraia','gr','Attiki',16432.0,23.82,38.1).
city('Nea Filadelfia','gr','Attiki',23645.0,23.74,38.03).
city('Nea Ionia','gr','Attiki',67835.0,23.75,38.03).
city('Nea Khalkidon','gr','Attiki',10150.0,23.73,38.03).
city('Nea Makri','gr','Attiki',14723.0,23.98,38.08).
city('Nea Palatia','gr','Attiki',2400.0,23.8,38.32).
city('Nea Penteli','gr','Attiki',7005.0,23.86,38.06).
city('Nea Peramos','gr','Attiki',7705.0,23.43,38.0).
city('Nea Smirni','gr','Attiki',75421.0,23.72,37.95).
city('Neon Psikhikon','gr','Attiki',10416.0,23.79,38.01).
city('Nikaia','gr','Attiki',94608.0,23.65,37.97).
city('Ntrafi','gr','Attiki',1788.0,23.94,38.0).
city('Oinoi','gr','Attiki',898.0,23.42,38.17).
city('Paiania','gr','Attiki',14246.0,23.85,37.95).
city('Palaia Fokaia','gr','Attiki',2824.0,23.95,37.72).
city('Palaion Faliron','gr','Attiki',66292.0,23.7,37.93).
city('Pallini','gr','Attiki',14808.0,23.88,38.0).
city('Papagos','gr','Attiki',12903.0,23.82,37.98).
city('Penteli','gr','Attiki',5538.0,23.87,38.05).
city('Perama','gr','Attiki',26288.0,23.57,37.97).
city('Peristerion','gr','Attiki',137660.0,23.7,38.02).
city('Petroupoli','gr','Attiki',52610.0,23.68,38.05).
city('Peuki','gr','Attiki',20603.0,23.79,38.06).
city('Pikermion','gr','Attiki',1385.0,23.95,38.0).
city('Piraieus','gr','Attiki',172429.0,23.64,37.96).
city('Polidendrion','gr','Attiki',1296.0,23.87,38.22).
city('Poros','gr','Attiki',4454.0,23.46,37.5).
city('Psikhikon','gr','Attiki',10995.0,23.77,38.02).
city('Rafina','gr','Attiki',12745.0,24.0,38.02).
city('Rodopolis','gr','Attiki',2450.0,23.88,38.12).
city('Salamis','gr','Attiki',26964.0,23.48,37.97).
city('Saronis','gr','Attiki',2338.0,23.91,37.75).
city('Selinia','gr','Attiki',2331.0,23.53,37.93).
city('Skala Oropou','gr','Attiki',1284.0,23.78,38.33).
city('Skaramankas','gr','Attiki',1008.0,23.6,38.01).
city('Sparta','gr','Attiki',801.0,23.17,38.03).
city('Spata','gr','Attiki',8137.0,23.92,37.97).
city('Spetsai','gr','Attiki',3972.0,23.15,37.27).
city('Stamata','gr','Attiki',2904.0,23.88,38.13).
city('Tauros','gr','Attiki',14751.0,23.7,37.97).
city('Thrakomakedones','gr','Attiki',5585.0,23.72,38.07).
city('Vari','gr','Attiki',12090.0,23.8,37.83).
city('Varnavas','gr','Attiki',1516.0,23.92,38.22).
city('Vathi','gr','Attiki',1615.0,23.48,37.77).
city('Vilia','gr','Attiki',1967.0,23.33,38.17).
city('Viron','gr','Attiki',61888.0,23.75,37.97).
city('Voula','gr','Attiki',29033.0,23.77,37.85).
city('Vouliagmeni','gr','Attiki',7717.0,23.78,37.82).
city('Vranas','gr','Attiki',670.0,23.95,38.12).
city('Vrilissia','gr','Attiki',30024.0,23.83,38.03).
city('Yerakas','gr','Attiki',16696.0,23.85,38.01).
city('Zefirion','gr','Attiki',8795.0,23.72,38.05).
city('Zografos','gr','Attiki',74390.0,23.77,37.98).
city('Kariai','gr','Ayion Oros',237.0,24.25,40.25).
city('Afantou','gr','Dodekanisos',5562.0,28.15,36.3).
city('Antimakhia','gr','Dodekanisos',2251.0,27.1,36.81).
city('Apollona','gr','Dodekanisos',982.0,27.97,36.25).
city('Arkhangelos','gr','Dodekanisos',5398.0,28.13,36.19).
city('Astipalaia','gr','Dodekanisos',1129.0,26.38,36.58).
city('Ayia Marina','gr','Dodekanisos',2743.0,26.85,37.15).
city('Embonas','gr','Dodekanisos',1211.0,27.86,36.21).
city('Falirakion','gr','Dodekanisos',1885.0,28.21,36.36).
city('Fanai','gr','Dodekanisos',868.0,27.98,36.35).
city('Ialisos','gr','Dodekanisos',11473.0,28.17,36.4).
city('Kalimnos','gr','Dodekanisos',10002.0,26.98,36.95).
city('Kalithiai','gr','Dodekanisos',5356.0,28.23,36.39).
city('Kardamaina','gr','Dodekanisos',1926.0,27.14,36.78).
city('Karpathos','gr','Dodekanisos',2243.0,27.23,35.5).
city('Kefalos','gr','Dodekanisos',2528.0,26.96,36.75).
city('Khorion','gr','Dodekanisos',3331.0,26.97,36.97).
city('Kos','gr','Dodekanisos',19244.0,27.29,36.89).
city('Koskinou','gr','Dodekanisos',2956.0,28.22,36.4).
city('Kremasti','gr','Dodekanisos',4700.0,28.12,36.41).
city('Lakkion','gr','Dodekan',1956.0,26.85,37.13).
city('Lardos','gr','Dodekanisos',1348.0,28.02,36.1).
city('Malon','gr','Dodekanisos',982.0,28.06,36.18).
city('Maritsa','gr','Dodekanisos',1808.0,28.12,36.36).
city('Masari','gr','Dodekanisos',980.0,28.07,36.18).
city('Panormos','gr','Dodekanisos',1752.0,26.96,36.96).
city('Paradision','gr','Dodekanisos',2633.0,28.08,36.4).
city('Pastida','gr','Dodekanisos',1886.0,28.16,36.89).
city('Pilion','gr','Dodekanisos',2430.0,27.16,36.85).
city('Psinthos','gr','Dodekanisos',1264.0,28.09,36.31).
city('Rodos','gr','Dodekanisos',56128.0,28.22,36.44).
city('Sgourou','gr','Dodekanisos',1297.0,28.21,36.42).
city('Simi','gr','Dodekanisos',2508.0,27.84,36.61).
city('Skala','gr','Dodekanisos',1849.0,26.53,37.32).
city('Soroni','gr','Dodekanisos',1238.0,28.02,36.36).
city('Xirokambos','gr','Dodekanisos',879.0,26.87,37.1).
city('Ziparion','gr','Dodekanisos',2706.0,27.2,36.88).
city('Adriani','gr','Drama',1375.0,24.27,41.13).
city('Ayios Athanasios','gr','Drama',3419.0,24.25,41.07).
city('Doxaton','gr','Drama',3780.0,24.23,41.1).
city('Drama','gr','Drama',44225.0,24.14,41.15).
city('Fotolivos','gr','Drama',1844.0,24.07,41.07).
city('Ftelia','gr','Drama',1006.0,24.18,41.08).
city('Kalambakion','gr','Drama',3514.0,24.18,41.05).
city('Kali Vrisi','gr','Drama',1163.0,23.9,41.15).
city('Kallifitos','gr','Drama',1098.0,24.22,41.17).
city('Kalos Agros','gr','Drama',1275.0,24.08,41.1).
city('Kato Neurokopion','gr','Drama',2033.0,23.87,41.35).
city('Khoristi','gr','Drama',2719.0,24.22,41.13).
city('Kiria','gr','Drama',1611.0,24.28,41.1).
city('Koudounia','gr','Drama',919.0,24.12,41.1).
city('Mikropolis','gr','Drama',1094.0,23.82,41.2).
city('Petroussa','gr','Drama',1985.0,24.02,41.2).
city('Prosotsani','gr','Drama',4021.0,23.97,41.18).
city('Sitagroi','gr','Drama',1105.0,24.03,41.12).
city('Volax','gr','Drama',1225.0,24.0,41.32).
city('Xiropotamos','gr','Drama',2670.0,24.1,41.2).
city('Agrafa','gr','Evritania',820.0,21.65,39.14).
city('Domnista','gr','Evritania',695.0,21.85,38.75).
city('Epiniana','gr','Evritania',682.0,21.61,39.14).
city('Karpenision','gr','Evritania',6888.0,21.78,38.92).
city('Alexandroupoli','gr','Evros',52978.0,25.87,40.85).
city('Anthia','gr','Evros',914.0,25.98,40.87).
city('Didimotikhon','gr','Evros',8924.0,26.5,41.35).
city('Dikaia','gr','Evros',737.0,26.29,41.7).
city('Ferai','gr','Evros',5403.0,26.17,40.9).
city('Kamariotissa','gr','Evros',1022.0,25.47,40.48).
city('Karoti','gr','Evros',663.0,26.42,41.4).
city('Kastaneai','gr','Evros',1213.0,26.47,41.65).
city('Kavili','gr','Evros',1531.0,26.52,41.57).
city('Kiprinos','gr','Evros',1095.0,26.23,41.58).
city('Koufovounon','gr','Evros',883.0,26.43,41.35).
city('Lagos','gr','Evros',1535.0,26.47,41.45).
city('Lavara','gr','Evros',1447.0,26.38,41.27).
city('Loutros','gr','Evros',984.0,26.04,40.88).
city('Metaxades','gr','Evros',818.0,26.23,41.42).
city('Nea Vissa','gr','Evros',2673.0,26.53,41.58).
city('Neokhorion','gr','Evros',1160.0,26.45,41.52).
city('Neos Pirgos','gr','Evros',932.0,26.5,41.5).
city('Orestias','gr','Evros',16221.0,26.53,41.5).
city('Ormenion','gr','Evros',750.0,26.21,41.72).
city('Peplos','gr','Evros',1037.0,26.27,40.96).
city('Provaton','gr','Evros',766.0,26.26,41.02).
city('Rizia','gr','Evros',1645.0,26.43,41.62).
city('Sofikon','gr','Evros',863.0,26.55,41.43).
city('Souflion','gr','Evros',4149.0,26.3,41.19).
city('Sterna','gr','Evros',815.0,26.45,41.57).
city('Tikheron','gr','Evros',2029.0,26.28,41.03).
city('Afration','gr','Evvoia',1365.0,23.68,38.45).
city('Aidipsos','gr','Evvoia',1317.0,23.05,38.88).
city('Aliverion','gr','Evvoia',5184.0,24.05,38.38).
city('Amarinthos','gr','Evvoia',4360.0,23.88,38.4).
city('Ayia Anna','gr','Evvoia',823.0,23.4,38.86).
city('Ayios Ioannis','gr','Evvoia',983.0,24.0,38.45).
city('Ayios Loukas','gr','Evvoia',955.0,24.03,38.43).
city('Ayios Nikolaos','gr','Evvoia',2880.0,23.65,38.42).
city('Drosia','gr','Evvoia',4312.0,24.13,38.42).
city('Eretria','gr','Evvoia',3217.0,23.8,38.4).
city('Faros','gr','Evvoia',1195.0,23.62,38.4).
city('Filla','gr','Evvoia',1276.0,23.68,38.43).
city('Istiaia','gr','Evvoia',4199.0,23.15,38.96).
city('Karistos','gr','Evvoia',5091.0,24.42,38.01).
city('Kastella','gr','Evvoia',1370.0,23.63,38.57).
city('Khalkis','gr','Evvoia',54559.0,23.6,38.46).
city('Kimi','gr','Evvoia',2979.0,24.1,38.63).
city('Limni','gr','Evvoia',2072.0,23.32,38.77).
city('Loukisia','gr','Evvoia',1038.0,23.45,38.48).
city('Loutra Aidipsou','gr','Evvoia',2873.0,23.05,38.85).
city('Magoula','gr','Evvoia',1552.0,23.83,38.42).
city('Makrikapa','gr','Evvoia',878.0,23.75,38.62).
city('Malakonta','gr','Evvoia',1641.0,23.77,38.4).
city('Mantoudion','gr','Evvoia',1794.0,23.48,38.8).
city('Marmarion','gr','Evvoia',1013.0,24.32,38.05).
city('Mitikas','gr','Evvoia',1632.0,23.65,38.43).
city('Nea Artaki','gr','Evvoia',9193.0,23.63,38.52).
city('Nea Lambsakos','gr','Evvoia',2025.0,23.63,38.43).
city('Nea Stira','gr','Evvoia',1061.0,24.2,38.18).
city('Neos Pirgos','gr','Evvoia',890.0,23.07,38.93).
city('Oreoi','gr','Evvoia',1293.0,23.1,38.95).
city('Oxilithos','gr','Evvoia',1062.0,24.12,38.58).
city('Paralia','gr','Evvoia',804.0,23.64,38.38).
city('Paralia Aulidos','gr','Evvoia',2625.0,23.63,38.38).
city('Politika','gr','Evvoia',1499.0,23.55,38.6).
city('Prokopion','gr','Evvoia',1108.0,23.48,38.73).
city('Psakhna','gr','Evvoia',5828.0,23.63,38.58).
city('Roviai','gr','Evvoia',1206.0,23.23,38.82).
city('Skiros','gr','Evvoia',1732.0,24.56,38.9).
city('Triada','gr','Evvoia',1075.0,23.72,38.58).
city('Vasilikon','gr','Evvoia',7039.0,23.67,38.43).
city('Vathi','gr','Evvoia',2575.0,23.6,38.4).
city('Yimnon','gr','Evvoia',2041.0,23.88,38.43).
city('Zarakes','gr','Evvoia',936.0,24.2,38.3).
city('Amintaion','gr','Florina',3908.0,21.7,40.7).
city('Ammokhorion','gr','Florina',1192.0,21.48,40.78).
city('Armenokhorion','gr','Florina',1079.0,21.48,40.8).
city('Ayios Panteleimon','gr','Florina',1150.0,21.75,40.73).
city('Filotas','gr','Florina',1774.0,21.7,40.63).
city('Florina','gr','Florina',14910.0,21.42,40.75).
city('Kella','gr','Florina',746.0,21.68,40.78).
city('Kristallopiyi','gr','Florina',699.0,21.09,40.64).
city('Lekhovon','gr','Florina',1188.0,21.48,40.58).
city('Levaia','gr','Florina',761.0,21.7,40.65).
city('Meliti','gr','Florina',1521.0,21.58,40.83).
city('Pappayiannis','gr','Florina',1055.0,21.5,40.83).
city('Xinon Neron','gr','Florina',1176.0,21.62,40.68).
city('Amfissa','gr','Fokis',6854.0,22.37,38.53).
city('Delfoi','gr','Fokis',2797.0,22.5,38.48).
city('Desfina','gr','Fokis',1992.0,22.53,38.41).
city('Galaxidion','gr','Fokis',1859.0,22.38,38.38).
city('Itea','gr','Fokis',4782.0,22.42,38.43).
city('Kastrakion','gr','Fokis',912.0,21.9,38.42).
city('Khrisso','gr','Fokis',1044.0,22.44,38.47).
city('Kirra','gr','Fokis',1348.0,22.45,38.43).
city('Lidorikion','gr','Fokis',840.0,22.2,38.52).
city('Maurolitharion','gr','Fokis',704.0,22.23,38.73).
city('Polidrosos','gr','Fokis',1502.0,22.53,38.63).
city('Akhinos','gr','Fthiotis',898.0,22.7,38.88).
city('Amfiklia','gr','Fthiotis',3674.0,22.58,38.63).
city('Anthili','gr','Fthiotis',1381.0,22.47,38.85).
city('Atalanti','gr','Fthiotis',5859.0,23.0,38.65).
city('Ayia Paraskevi','gr','Fthiotis',998.0,22.74,38.58).
city('Ayios Konstantinos','gr','Fthiotis',2657.0,22.85,38.76).
city('Ayios Serafim','gr','Fthiotis',1071.0,22.7,38.8).
city('Domokos','gr','Fthiotis',1433.0,22.3,39.13).
city('Elatia','gr','Fthiotis',2449.0,22.77,38.63).
city('Exarkhos','gr','Fthiotis',965.0,22.95,38.58).
city('Fteri','gr','Fthiotis',773.0,22.05,38.9).
city('Kainouryion','gr','Fthiotis',1214.0,22.72,38.8).
city('Kamena Vourla','gr','Fthiotis',2881.0,22.78,38.78).
city('Kato Tithorea','gr','Fthiotis',2753.0,22.72,38.6).
city('Kostalexis','gr','Fthiotis',951.0,22.37,38.85).
city('Lamia','gr','Fthiotis',47246.0,22.43,38.9).
city('Larimna','gr','Fthiotis',1196.0,23.28,38.57).
city('Leukas','gr','Fthiotis',1014.0,22.0,38.92).
city('Lianokladion','gr','Fthiotis',1384.0,22.3,38.92).
city('Livanatai','gr','Fthiotis',3142.0,23.05,38.72).
city('Loutra Ipatis','gr','Fthiotis',579.0,22.28,38.9).
city('Makrakomi','gr','Fthiotis',2065.0,22.12,38.93).
city('Malesina','gr','Fthiotis',4281.0,23.23,38.62).
city('Martinon','gr','Fthiotis',3038.0,23.22,38.57).
city('Megali Vrisi','gr','Fthiotis',963.0,22.48,38.88).
city('Molos','gr','Fthiotis',3280.0,22.65,38.82).
city('Moskhokhorion','gr','Fthiotis',763.0,22.45,38.83).
city('Neon Monastirion','gr','Fthiotis',1497.0,22.25,39.23).
city('Omvriaki','gr','Fthiotis',1213.0,22.27,39.1).
city('Pelasyia','gr','Fthiotis',1586.0,22.83,38.95).
city('Renkinion','gr','Fthiotis',762.0,22.7,38.72).
city('Roditsa','gr','Fthiotis',2610.0,22.46,38.87).
city('Sperkhias','gr','Fthiotis',2844.0,22.12,38.9).
city('Stauros','gr','Fthiotis',2128.0,22.37,38.9).
city('Stilis','gr','Fthiotis',5132.0,22.62,38.92).
city('Tithorea','gr','Fthiotis',865.0,22.67,38.58).
city('Tragana','gr','Fthiotis',1320.0,23.12,38.62).
city('Zelion','gr','Fthiotis',868.0,22.88,38.67).
city('Deskati','gr','Grevena',3856.0,21.8,39.92).
city('Grevena','gr','Grevena',10563.0,21.42,40.08).
city('Samarina','gr','Grevena',839.0,21.02,40.1).
city('Afitos','gr','Halkidiki',1428.0,23.43,40.1).
city('Arnaia','gr','Halkidiki',2271.0,23.59,40.48).
city('Ayios Mamas','gr','Halkidiki',1044.0,23.33,40.27).
city('Ayios Nikolaos','gr','Halkidiki',1913.0,23.7,40.25).
city('Floyita','gr','Halkidiki',1589.0,23.22,40.27).
city('Galatista','gr','Halkidiki',2710.0,23.28,40.47).
city('Ierissos','gr','Halkidiki',3135.0,23.88,40.4).
city('Kalivai Poliyirou','gr','Halkidiki',1147.0,23.4,40.28).
city('Kallithea','gr','Halkidiki',976.0,23.45,40.08).
city('Kassandria','gr','Halkidiki',3023.0,23.42,40.05).
city('Khaniotis','gr','Halkidiki',1177.0,23.58,40.0).
city('Lakkoma','gr','Halkidiki',1280.0,23.05,40.38).
city('Megali Panayia','gr','Halkidiki',2782.0,23.68,40.45).
city('Metamorfosis','gr','Halkidiki',873.0,23.6,40.23).
city('Nea Fokaia','gr','Halkidiki',1941.0,23.4,40.13).
city('Nea Kallikratia','gr','Halkidiki',7078.0,23.07,40.32).
city('Nea Moudania','gr','Halkidiki',7506.0,23.28,40.25).
city('Nea Playia','gr','Halkidiki',1332.0,23.2,40.27).
city('Nea Potidaia','gr','Halkidiki',1834.0,23.33,40.2).
city('Nea Roda','gr','Halkidiki',1156.0,23.92,40.38).
city('Nea Triglia','gr','Halkidiki',3028.0,23.2,40.3).
city('Neos Marmaras','gr','Halkidiki',3013.0,23.78,40.1).
city('Nikiti','gr','Halkidiki',2968.0,23.67,40.23).
city('Olinthos','gr','Halkidiki',1155.0,23.35,40.28).
city('Ormilia','gr','Halkidiki',3436.0,23.55,40.3).
city('Ouranopolis','gr','Halkidiki',1047.0,23.98,40.33).
city('Palaiokhora','gr','Halkidiki',923.0,23.45,40.5).
city('Palaiokhorion','gr','Halkidiki',1474.0,23.64,40.46).
city('Peukokhorion','gr','Halkidiki',1906.0,23.61,39.98).
city('Polikhronon','gr','Halkidiki',1174.0,23.53,40.02).
city('Poliyiros','gr','Halkidiki',5258.0,23.44,40.37).
city('Portaria','gr','Halkidiki',1468.0,23.3,40.28).
city('Sarti','gr','Halkidiki',1258.0,23.98,40.1).
city('Sikea','gr','Halkidiki',2336.0,23.93,40.03).
city('Simantra','gr','Halkidiki',2745.0,23.34,40.35).
city('Skala Fourkas','gr','Halkidiki',853.0,23.38,40.0).
city('Sozopolis','gr','Halkidiki',925.0,23.15,40.28).
city('Stratonion','gr','Halkidiki',1150.0,23.83,40.52).
city('Taxiarkhis','gr','Halkidiki',1055.0,23.52,40.43).
city('Ayia Marina','gr','Hania',1671.0,23.93,35.52).
city('Daratsos','gr','Hania',3747.0,23.98,35.5).
city('Galatas','gr','Hania',2377.0,23.97,35.5).
city('Kalivai','gr','Hania',1288.0,24.17,35.45).
city('Khania','gr','Hania',54565.0,24.02,35.51).
city('Kissamos','gr','Hania',4205.0,23.66,35.49).
city('Kolimvari','gr','Hania',1032.0,23.78,35.55).
city('Kounoupidiana','gr','Hania',4771.0,24.08,35.53).
city('Mournies','gr','Hania',6879.0,24.01,35.48).
city('Mouzouras','gr','Hania',1462.0,24.15,35.53).
city('Nerokouros','gr','Hania',4388.0,24.03,35.48).
city('Palaiokhora','gr','Hania',2372.0,23.68,35.23).
city('Perivolia','gr','Hania',3320.0,23.98,35.48).
city('Pitharion','gr','Hania',1302.0,24.08,35.52).
city('Platanos','gr','Hania',1077.0,23.6,35.47).
city('Souda','gr','Hania',6729.0,24.08,35.49).
city('Sternai','gr','Hania',836.0,24.15,35.52).
city('Tsikalaria','gr','Hania',1204.0,24.07,35.48).
city('Vamvakopoulon','gr','Hania',1750.0,24.0,35.5).
city('Vrises','gr','Hania',982.0,24.2,35.38).
city('Yerani','gr','Hania',804.0,24.4,35.35).
city('Yialos','gr','Hania',873.0,23.65,35.24).
city('Kallimasia','gr','Hios',895.0,26.1,38.29).
city('Khios','gr','Hios',23953.0,26.14,38.37).
city('Lankada','gr','Hios',867.0,26.12,38.48).
city('Marmaron','gr','Hios',953.0,26.11,38.54).
city('Nenita','gr','Hios',1032.0,26.09,38.24).
city('Oinoussai','gr','Hios',1182.0,26.22,38.51).
city('Piryion','gr','Hios',1002.0,26.0,38.23).
city('Thimiana','gr','Hios',1483.0,26.13,38.32).
city('Vrontados','gr','Hios',4600.0,26.13,38.41).
city('Alfiousa','gr','Ilia',1067.0,21.53,37.65).
city('Amalias','gr','Ilia',19580.0,21.35,37.8).
city('Andravida','gr','Ilia',3626.0,21.27,37.9).
city('Arkhaia Olimbia','gr','Ilia',1208.0,21.63,37.65).
city('Ayios Nikolaos','gr','Ilia',1305.0,21.12,37.85).
city('Epitalion','gr','Ilia',1953.0,21.5,37.63).
city('Gastouni','gr','Ilia',8114.0,21.25,37.85).
city('Goumeron','gr','Ilia',1072.0,21.62,37.77).
city('Kallikomon','gr','Ilia',1305.0,21.58,37.6).
city('Kallithea','gr','Ilia',949.0,21.82,37.55).
city('Karatoulas','gr','Ilia',1004.0,21.53,37.73).
city('Kardamas','gr','Ilia',1138.0,21.33,37.77).
city('Kavasilas','gr','Ilia',1623.0,21.27,37.87).
city('Khavarion','gr','Ilia',1467.0,21.38,37.85).
city('Killini','gr','Ilia',1133.0,21.15,37.93).
city('Krestena','gr','Ilia',4733.0,21.63,37.62).
city('Lalas','gr','Ilia',1168.0,21.72,37.72).
city('Lekhaina','gr','Ilia',3714.0,21.27,37.93).
city('Makrisia','gr','Ilia',1902.0,21.6,37.62).
city('Manolas','gr','Ilia',1650.0,21.35,38.05).
city('Mirsini','gr','Ilia',1213.0,21.23,37.92).
city('Nea Figalia','gr','Ilia',1264.0,21.78,37.44).
city('Nea Manolas','gr','Ilia',2219.0,21.38,38.05).
city('Neokhorion','gr','Ilia',1105.0,21.2,37.92).
city('Pelopion','gr','Ilia',1073.0,21.58,37.68).
city('Pirgos','gr','Ilia',22402.0,21.45,37.68).
city('Platanos','gr','Ilia',1764.0,21.62,37.67).
city('Savalia','gr','Ilia',1339.0,21.28,37.82).
city('Traganon','gr','Ilia',2414.0,21.32,37.88).
city('Varda','gr','Ilia',3307.0,21.37,38.03).
city('Vartholomio','gr','Ilia',3068.0,21.2,37.87).
city('Varvasaina','gr','Ilia',1280.0,21.5,37.68).
city('Vrina','gr','Ilia',860.0,21.63,37.57).
city('Zakharo','gr','Ilia',5894.0,21.65,37.48).
city('Alexandria','gr','Imathia',13665.0,22.44,40.63).
city('Angelokhorion','gr','Imathia',1526.0,22.2,40.68).
city('Ankathia','gr','Imathia',1311.0,22.47,40.56).
city('Ayia Marina','gr','Imathia',732.0,22.22,40.6).
city('Ay','gr','Imathia',1767.0,22.2,40.6).
city('Diavatos','gr','Imathia',1294.0,22.27,40.55).
city('Episkopi','gr','Imathia',1990.0,22.14,40.69).
city('Khariessa','gr','Imathia',926.0,22.17,40.65).
city('Klidion','gr','Imathia',1323.0,22.59,40.57).
city('Kopanos','gr','Imathia',2202.0,22.13,40.63).
city('Korifi','gr','Imathia',1552.0,22.5,40.6).
city('Kouloura','gr','Imathia',1156.0,22.32,40.55).
city('Leukadia','gr','Imathia',987.0,22.12,40.65).
city('Lianoveryion','gr','Imathia',1712.0,22.5,40.64).
city('Loutros','gr','Imathia',1296.0,22.4,40.59).
city('Makrokhorion','gr','Imathia',4965.0,22.25,40.55).
city('Marina','gr','Imathia',1091.0,22.1,40.7).
city('Meliki','gr','Imathia',3033.0,22.4,40.52).
city('Monospita','gr','Imathia',897.0,22.18,40.62).
city('Naousa','gr','Imathia',19887.0,22.07,40.63).
city('Nision','gr','Imathia',1473.0,22.39,40.64).
city('Patris','gr','Imathia',1330.0,22.19,40.56).
city('Platanos','gr','Imathia',745.0,22.55,40.56).
city('Pla','gr','Imathia',2228.0,22.53,40.64).
city('Poliplatanos','gr','Imathia',892.0,22.19,40.68).
city('Rizomata','gr','Imathia',1157.0,22.2,40.35).
city('Stauros','gr','Imathia',1486.0,22.3,40.58).
city('Trikala','gr','Imathia',1704.0,22.56,40.6).
city('Veroia','gr','Imathia',44465.0,22.2,40.52).
city('Veryina','gr','Imathia',1242.0,22.31,40.48).
city('Anatoli','gr','Ioannina',6422.0,20.87,39.64).
city('Doliana','gr','Ioannina',616.0,20.58,39.9).
city('Eleousa','gr','Ioannina',3064.0,20.79,39.71).
city('Exokhi','gr','Ioannina',1739.0,20.73,40.1).
city('Ioannina','gr','Ioannina',64012.0,20.85,39.67).
city('Kardamitsia','gr','Ioannina',1375.0,20.82,39.66).
city('Katsikas','gr','Ioannina',2993.0,20.89,39.62).
city('Kefalovrison','gr','Ioannina',1011.0,20.56,40.01).
city('Konitsa','gr','Ioannina',2875.0,20.76,40.05).
city('Koutselion','gr','Ioannina',1177.0,20.91,39.59).
city('Metsovon','gr','Ioannina',3305.0,21.18,39.77).
city('Neokaisaria','gr','Ioannina',805.0,20.88,39.59).
city('Neokhoropoulon','gr','Ioannina',1088.0,20.83,39.63).
city('Pedini','gr','Ioannina',2128.0,20.84,39.6).
city('Perama','gr','Ioannina',3066.0,20.85,39.7).
city('Pramanta','gr','Ioannina',1570.0,21.1,39.52).
city('Rodotopion','gr','Ioannina',1130.0,20.73,39.71).
city('Staurakion','gr','Ioannina',1426.0,20.73,39.65).
city('Tsiflikopoulon','gr','Ioannina',1916.0,20.81,39.67).
city('Zitsa','gr','Ioannina',914.0,20.65,39.75).
city('Analipsis','gr','Iraklion',1259.0,25.57,35.32).
city('Anissaras','gr','Iraklion',298.0,25.37,35.33).
city('Arkalokhorion','gr','Iraklion',3537.0,25.27,35.15).
city('Asimion','gr','Iraklion',1259.0,25.1,35.05).
city('Auyeniki','gr','Iraklion',866.0,25.03,35.18).
city('Ayia Eirini','gr','Iraklion',755.0,25.1,35.33).
city('Ayia Varvara','gr','Iraklion',2167.0,25.0,35.13).
city('Ayios Dimitrios','gr','Iraklion',627.0,25.05,35.32).
city('Dafnes','gr','Iraklion',1037.0,25.05,35.22).
city('Epano Arkhanai','gr','Iraklion',3913.0,25.17,35.23).
city('Episkopi','gr','Iraklion',967.0,25.23,35.25).
city('Galia','gr','Iraklion',852.0,24.87,35.08).
city('Gazion','gr','Iraklion',9721.0,25.07,35.33).
city('Gournai','gr','Iraklion',1539.0,25.28,35.32).
city('Iraklion','gr','Iraklion',137155.0,25.13,35.33).
city('Kastellion','gr','Iraklion',1828.0,25.33,35.2).
city('Kato Asitai','gr','Iraklion',1264.0,25.0,35.2).
city('Kato Gouvai','gr','Iraklion',1501.0,25.35,35.32).
city('Khanion tou Kokkini','gr','Iraklion',1385.0,25.25,35.33).
city('Khersonisos','gr','Iraklion',938.0,25.37,35.3).
city('Koutouloufarion','gr','Iraklion',751.0,25.38,35.3).
city('Krouson','gr','Iraklion',2811.0,24.98,35.23).
city('Limin Khersonisou','gr','Iraklion',3103.0,25.38,35.32).
city('Malia','gr','Iraklion',4343.0,25.47,35.28).
city('Moirai','gr','Iraklion',6450.0,24.87,35.05).
city('Mokhos','gr','Iraklion',1132.0,25.42,35.27).
city('Nea Alikarnassos','gr','Iraklion',11886.0,25.17,35.33).
city('Pirgos','gr','Iraklion',1134.0,25.15,35.0).
city('Pombia','gr','Iraklion',953.0,24.87,35.02).
city('Profitis Ilias','gr','Iraklion',1482.0,25.1,35.2).
city('Skalanion','gr','Iraklion',1012.0,25.18,35.28).
city('Stalis','gr','Iraklion',1182.0,25.43,35.3).
city('Thrapsanon','gr','Iraklion',1499.0,25.28,35.18).
city('Tilisos','gr','Iraklion',1026.0,25.02,35.3).
city('Timbakion','gr','Iraklion',4923.0,24.77,35.07).
city('Vasiliai','gr','Iraklion',984.0,25.13,35.27).
city('Veneraton','gr','Iraklion',938.0,25.03,35.2).
city('Yeryeri','gr','Iraklion',1444.0,24.95,35.14).
city('Zaros','gr','Iraklion',2205.0,24.9,35.13).
city('Agnanteron','gr','Karditsa',1859.0,21.85,39.49).
city('Anavra','gr','Karditsa',1145.0,22.08,39.2).
city('Artesianon','gr','Karditsa',1412.0,21.89,39.4).
city('Ayia Trias','gr','Karditsa',754.0,21.73,39.29).
city('Itea','gr','Karditsa',1301.0,22.17,39.47).
city('Kallifonion','gr','Karditsa',1208.0,21.96,39.27).
city('Kallithiron','gr','Karditsa',1098.0,21.91,39.28).
city('Karditsa','gr','Karditsa',32789.0,21.92,39.37).
city('Karditsomagoula','gr','Karditsa',2200.0,21.92,39.39).
city('Karpokhorion','gr','Karditsa',1059.0,22.02,39.33).
city('Kedros','gr','Karditsa',854.0,22.05,39.22).
city('Leontarion','gr','Karditsa',1095.0,22.13,39.18).
city('Magoula','gr','Karditsa',1036.0,21.8,39.46).
city('Makrikhorion','gr','Karditsa',1188.0,21.97,39.44).
city('Mataranka','gr','Karditsa',1695.0,22.07,39.4).
city('Maurommation','gr','Karditsa',1863.0,21.7,39.42).
city('Mirina','gr','Karditsa',814.0,21.95,39.39).
city('Mitropoli','gr','Karditsa',1572.0,21.84,39.34).
city('Morfovounion','gr','Karditsa',1271.0,21.75,39.35).
city('Mouzakion','gr','Karditsa',2127.0,21.66,39.43).
city('Neokhorion','gr','Karditsa',1121.0,21.73,39.28).
city('Palamas','gr','Karditsa',5719.0,22.08,39.47).
city('Proastion','gr','Karditsa',1766.0,21.9,39.49).
city('Prodromos','gr','Karditsa',994.0,21.98,39.38).
city('Rentina','gr','Karditsa',828.0,21.98,39.06).
city('Sofades','gr','Karditsa',6284.0,22.1,39.33).
city('Stauros','gr','Karditsa',889.0,21.97,39.37).
city('Argos Orestikon','gr','Kastoria',7894.0,21.27,40.47).
city('Dispilion','gr','Kastoria',1254.0,21.28,40.48).
city('Kastoria','gr','Kastoria',14665.0,21.27,40.52).
city('Khloi','gr','Kastoria',961.0,21.25,40.51).
city('Korisos','gr','Kastoria',1389.0,21.38,40.5).
city('Kostarazion','gr','Kastoria',935.0,21.33,40.43).
city('Maniakoi','gr','Kastoria',2771.0,21.25,40.5).
city('Maurokhori','gr','Kastoria',1412.0,21.32,40.52).
city('Mesopotamia','gr','Kastoria',1812.0,21.17,40.5).
city('Nestorion','gr','Kastoria',884.0,21.06,40.41).
city('Vogatsiko','gr','Kastoria',735.0,21.38,40.42).
city('Amigdaleon','gr','Kavala',1738.0,24.37,40.97).
city('Amisiana','gr','Kavala',1293.0,24.35,40.93).
city('Antifilippoi','gr','Kavala',1185.0,24.22,40.95).
city('Ayiasma','gr','Kavala',1185.0,24.66,40.91).
city('Elaiokhorion','gr','Kavala',1109.0,24.55,41.05).
city('Eleutherai','gr','Kavala',1303.0,24.25,40.85).
city('Eleutheroupoli','gr','Kavala',4846.0,24.25,40.92).
city('Eratinon','gr','Kavala',920.0,24.63,40.95).
city('Kavala','gr','Kavala',59240.0,24.4,40.94).
city('Keram','gr','Kavala',1338.0,24.71,40.86).
city('Khrisokastron','gr','Kavala',767.0,24.18,40.88).
city('Khrisokhorion','gr','Kavala',1866.0,24.72,40.93).
city('Khrisoupoli','gr','Kavala',8285.0,24.69,40.99).
city('Kipia','gr','Kavala',737.0,24.2,40.88).
city('Kokkinokhoma','gr','Kavala',1934.0,24.3,40.93).
city('Krinides','gr','Kavala',3395.0,24.38,40.95).
city('Limenaria','gr','Kavala',2503.0,24.58,40.63).
city('Moustheni','gr','Kavala',1159.0,24.12,40.87).
city('Nea Iraklitsa','gr','Kavala',1147.0,24.32,40.86).
city('Nea Karia','gr','Kavala',1820.0,24.71,40.91).
city('Nea Karvali','gr','Kavala',2380.0,24.51,40.96).
city('Nea Peramos','gr','Kavala',2642.0,24.3,40.84).
city('Nikisiani','gr','Kavala',2454.0,24.15,40.95).
city('Palaiokhorion','gr','Kavala',1607.0,24.18,40.95).
city('Palaion Tsiflikion','gr','Kavala',2204.0,24.35,40.9).
city('Perni','gr','Kavala',913.0,24.63,41.0).
city('Pigai','gr','Kavala',1037.0,24.67,40.9).
city('Potamia','gr','Kavala',1260.0,24.73,40.72).
city('Prinos','gr','Kavala',1174.0,24.62,40.73).
city('Thasos','gr','Kavala',3339.0,24.72,40.77).
city('Theologos','gr','Kavala',655.0,24.7,40.67).
city('Yeoryiani','gr','Kavala',642.0,24.14,40.95).
city('Zigos','gr','Kavala',1504.0,24.38,41.02).
city('Argostolion','gr','Kefallinia',9820.0,20.48,38.17).
city('Ithaki','gr','Kefallinia',1842.0,20.72,38.36).
city('Lixourion','gr','Kefallinia',3758.0,20.43,38.2).
city('Poros','gr','Kefallinia',1059.0,20.78,38.15).
city('Sami','gr','Kefallinia',1347.0,20.65,38.25).
city('Valsamata','gr','Kefallinia',1008.0,20.6,38.17).
city('Afra','gr','Kerkira',879.0,19.86,39.62).
city('Alepou','gr','Kerkira',1640.0,19.89,39.61).
city('Ano Korakiana','gr','Kerkira',837.0,19.79,39.71).
city('Aryirades','gr','Kerkira',1078.0,19.98,39.44).
city('Auliotai','gr','Kerkira',970.0,19.66,39.77).
city('Ayios Matthaios','gr','Kerkira',1640.0,19.87,39.5).
city('Erikoussa','gr','Kerkira',863.0,19.59,39.88).
city('Gastouri','gr','Kerkira',1129.0,19.9,39.56).
city('Gouvia','gr','Kerkira',874.0,19.84,39.65).
city('Ipsos','gr','Kerkira',769.0,19.84,39.69).
city('Kanalion','gr','Kerkira',3953.0,19.89,39.6).
city('Karousades','gr','Kerkira',993.0,19.74,39.78).
city('Kassiopi','gr','Kerkira',1165.0,19.92,39.79).
city('Kato Korakiana','gr','Kerkira',1055.0,19.83,39.69).
city('Kavos','gr','Kerkira',923.0,20.11,39.38).
city('Kerkira','gr','Kerkira',27004.0,19.92,39.62).
city('Kinopiastai','gr','Kerkira',1463.0,19.88,39.57).
city('Kokkinion','gr','Kerkira',891.0,19.81,39.61).
city('Kontokalion','gr','Kerkira',1798.0,19.85,39.65).
city('Leukimmi','gr','Kerkira',3539.0,20.07,39.42).
city('Liapades','gr','Kerkira',928.0,19.74,39.67).
city('Mpenitsai','gr','Kerkira',722.0,19.91,39.54).
city('Othonoi','gr','Kerkira',761.0,19.41,39.84).
city('Perama','gr','Kerkira',995.0,19.9,39.58).
city('Perivolion','gr','Kerkira',1432.0,20.01,39.42).
city('Potamos','gr','Kerkira',2556.0,19.88,39.63).
city('Sinarades','gr','Kerkira',1150.0,19.85,39.56).
city('Viros','gr','Kerkira',1057.0,19.88,39.58).
city('Adamas','gr','Kiklades',1478.0,24.43,36.73).
city('Andros','gr','Kiklades',1556.0,24.93,37.83).
city('Ano Mera','gr','Kiklades',1611.0,25.4,37.45).
city('Ano Siros','gr','Kiklades',1138.0,24.94,37.45).
city('Antiparos','gr','Kiklades',1063.0,25.05,37.0).
city('Apollonia','gr','Kiklades',1054.0,24.72,36.97).
city('Emborion','gr','Kiklades',1946.0,25.45,36.35).
city('Ermoupolis','gr','Kiklades',11351.0,24.93,37.45).
city('Filotion','gr','Kiklades',1744.0,25.5,37.05).
city('Gaurio','gr','Kiklades',1086.0,24.73,37.88).
city('Ios','gr','Kiklades',1803.0,25.28,36.73).
city('Kamarion','gr','Kiklades',1599.0,25.82,36.8).
city('Karterados','gr','Kiklades',1288.0,25.45,36.42).
city('Mesaria','gr','Kiklades',1233.0,25.45,36.4).
city('Mikonos','gr','Kiklades',7739.0,25.33,37.45).
city('Milos','gr','Kiklades',844.0,24.43,36.75).
city('Mpatsi','gr','Kiklades',1003.0,24.79,37.86).
city('Naousa','gr','Kiklades',2596.0,25.23,37.12).
city('Naxos','gr','Kiklades',7574.0,25.38,37.11).
city('Oia','gr','Kiklades',934.0,25.37,36.47).
city('Ormos Korthiou','gr','Kiklades',903.0,24.95,37.77).
city('Paros','gr','Kiklades',5289.0,25.15,37.08).
city('Thira','gr','Kiklades',2376.0,25.43,36.42).
city('Tinos','gr','Kiklades',4573.0,25.17,37.53).
city('Vari','gr','Kiklades',1266.0,24.95,37.4).
city('Aspros','gr','Kilkis',891.0,22.62,40.9).
city('Axioupoli','gr','Kilkis',3368.0,22.54,40.98).
city('Ayios Petros','gr','Kilkis',1763.0,22.58,40.86).
city('Drosaton','gr','Kilkis',1148.0,22.8,41.17).
city('Europos','gr','Kilkis',2450.0,22.55,40.89).
city('Gallikos','gr','Kilkis',1239.0,22.88,40.86).
city('Gorgopi','gr','Kilkis',913.0,22.51,40.96).
city('Goumenissa','gr','Kilkis',4010.0,22.44,40.94).
city('Kambanis','gr','Kilkis',1523.0,22.91,40.89).
city('Kherso','gr','Kilkis',1327.0,22.78,41.09).
city('Khoriyion','gr','Kilkis',928.0,22.72,40.99).
city('Kilkis','gr','Kilkis',19734.0,22.87,40.99).
city('Koromilea','gr','Kilkis',774.0,22.85,41.07).
city('Kristoni','gr','Kilkis',1195.0,22.86,40.96).
city('Mikrokambos','gr','Kilkis',1207.0,22.77,40.84).
city('Mouriai','gr','Kilkis',988.0,22.79,41.25).
city('Nea Santa','gr','Kilkis',1420.0,22.91,40.84).
city('Neon Ayionerion','gr','Kilkis',1649.0,22.7,40.81).
city('Palaion Ayionerion','gr','Kilkis',997.0,22.72,40.81).
city('Pedinon','gr','Kilkis',1133.0,22.87,40.91).
city('Playia','gr','Kilkis',904.0,22.49,41.08).
city('Polikastron','gr','Kilkis',6961.0,22.57,40.99).
city('Stathmos Mourion','gr','Kilkis',1575.0,22.82,41.28).
city('Toumba','gr','Kilkis',993.0,22.54,40.93).
city('Arkhaia Korinthos','gr','Korinthia',1701.0,22.88,37.92).
city('Arkhaiai Kleonai','gr','Korinthia',905.0,22.7,37.81).
city('Arkhaio Limani','gr','Korinthia',805.0,22.9,37.9).
city('Assos','gr','Korinthia',2730.0,22.83,37.93).
city('Athikia','gr','Korinthia',2058.0,22.93,37.82).
city('Ayioi Theodoroi','gr','Korinthia',6349.0,23.08,37.92).
city('Ayios Vasilios','gr','Korinthia',1462.0,22.8,37.8).
city('Derveni','gr','Korinthia',1379.0,22.42,38.13).
city('Examilia','gr','Korinthia',1631.0,22.93,37.9).
city('Isthmia','gr','Korinthia',1043.0,23.0,37.92).
city('Kamarion','gr','Korinthia',1166.0,22.58,38.1).
city('Kato Assos','gr','Korinthia',1617.0,22.83,37.95).
city('Kato Diminion','gr','Korinthia',1072.0,22.73,38.03).
city('Khiliomodion','gr','Korinthia',1769.0,22.87,37.82).
city('Kiato','gr','Korinthia',10032.0,22.75,38.02).
city('Kiras Vrisi','gr','Korinthia',1151.0,22.98,37.92).
city('Kokko','gr','Korinthia',1221.0,22.78,37.97).
city('Korinthos','gr','Korinthia',30900.0,22.93,37.94).
city('Krionerion','gr','Korinthia',968.0,22.63,37.97).
city('Lekhaion','gr','Korinthia',4837.0,22.85,37.93).
city('Likoporia','gr','Korinthia',801.0,22.52,38.13).
city('Loutra Oraias Elenis','gr','Korinthia',1168.0,22.98,37.87).
city('Loutrakion','gr','Korinthia',12276.0,22.98,37.98).
city('Melission','gr','Korinthia',864.0,22.68,38.05).
city('Moulkion','gr','Korinthia',1316.0,22.73,38.0).
city('Nemea','gr','Korinthia',4344.0,22.67,37.82).
city('Pasion','gr','Korinthia',1150.0,22.73,38.02).
city('Perakhora','gr','Korinthia',1246.0,22.95,38.03).
city('Periyialion','gr','Korinthia',2042.0,22.84,37.95).
city('Sikion','gr','Korinthia',1131.0,22.73,37.98).
city('Sofikon','gr','Korinthia',1799.0,23.05,37.8).
city('Stimanka','gr','Korinthia',1100.0,22.7,37.92).
city('Velon','gr','Korinthia',3018.0,22.77,37.97).
city('Vokhaikon','gr','Korinthia',961.0,22.8,37.95).
city('Vrakhation','gr','Korinthia',3252.0,22.82,37.97).
city('Xilokastron','gr','Korinthia',5256.0,22.63,38.08).
city('Zeugolation','gr','Korinthia',4454.0,22.8,37.93).
city('Aiani','gr','Kozani',2119.0,21.82,40.17).
city('Akrini','gr','Kozani',1113.0,21.9,40.43).
city('Anarrakhi','gr','Kozani',1147.0,21.57,40.48).
city('Anatolikon','gr','Kozani',959.0,21.75,40.55).
city('Ano Komi','gr','Kozani',1547.0,21.83,40.23).
city('Ardassa','gr','Kozani',934.0,21.63,40.48).
city('Ayios Dimitrios','gr','Kozani',1091.0,21.92,40.42).
city('Drepanon','gr','Kozani',1448.0,21.83,40.35).
city('Emborion','gr','Kozani',1033.0,21.55,40.48).
city('Eratira','gr','Kozani',1383.0,21.52,40.35).
city('Galatini','gr','Kozani',2085.0,21.55,40.32).
city('Kariditsa','gr','Kozani',952.0,21.8,40.25).
city('Klitos','gr','Kozani',1382.0,21.87,40.43).
city('Koila','gr','Kozani',1493.0,21.78,40.33).
city('Komnina','gr','Kozani',1126.0,21.78,40.6).
city('Kozani','gr','Kozani',36481.0,21.79,40.3).
city('Krokos','gr','Kozani',3004.0,21.82,40.0).
city('Leukopiyi','gr','Kozani',1269.0,21.75,40.23).
city('Leukovrisi','gr','Kozani',1165.0,21.78,40.27).
city('Livaderon','gr','Kozani',1663.0,21.93,40.03).
city('Maurodendrion','gr','Kozani',1286.0,22.24,40.54).
city('Nea Kharauyi','gr','Kozani',1251.0,21.68,40.31).
city('Nea Lava','gr','Kozani',1435.0,21.97,40.17).
city('Neapoli','gr','Kozani',2471.0,21.38,40.32).
city('Perdikkas','gr','Kozani',1845.0,21.7,40.57).
city('Platanorreuma','gr','Kozani',1040.0,22.02,40.2).
city('Pontokomi','gr','Kozani',1334.0,21.77,40.42).
city('Ptolemais','gr','Kozani',30045.0,21.68,40.51).
city('Servia','gr','Kozani',3390.0,21.99,40.18).
city('Siatista','gr','Kozani',5612.0,21.54,40.26).
city('Tsotilion','gr','Kozani',1695.0,21.32,40.27).
city('Velventos','gr','Kozani',3378.0,22.06,40.25).
city('Asopos','gr','Lakonia',1279.0,22.87,36.73).
city('Dafnion','gr','Lakonia',952.0,22.53,36.93).
city('Elos','gr','Lakonia',957.0,22.7,36.83).
city('Kariai','gr','Lakonia',1048.0,22.5,37.3).
city('Kato Glikovrisi','gr','Lakonia',1753.0,22.78,36.83).
city('Krokeai','gr','Lakonia',1329.0,22.55,36.88).
city('Magoula','gr','Lakonia',1545.0,22.42,37.08).
city('Molaoi','gr','Lakonia',3018.0,22.86,36.8).
city('Neapoli Voion','gr','Lakonia',2824.0,23.07,36.52).
city('Papadianika','gr','Lakonia',1894.0,22.87,36.72).
city('Sikea','gr','Lakonia',1031.0,22.93,36.77).
city('Skala','gr','Lakonia',2817.0,22.67,36.85).
city('Sparti','gr','Lakonia',15497.0,22.43,37.07).
city('Vlakhiotis','gr','Lakonia',2404.0,22.7,36.87).
city('Xirokambion','gr','Lakonia',995.0,22.45,36.97).
city('Yefira','gr','Lakonia',1465.0,23.03,36.68).
city('Yerakion','gr','Lakonia',1323.0,22.7,37.0).
city('Yithion','gr','Lakonia',4576.0,22.56,36.76).
city('Ambelon','gr','Larisa',5961.0,22.34,39.74).
city('Armenion','gr','Larisa',727.0,22.7,39.48).
city('Aryiropoulion','gr','Larisa',1782.0,22.3,39.83).
city('Ayia','gr','Larisa',2827.0,22.76,39.72).
city('Damasion','gr','Larisa',1355.0,22.18,39.0).
city('Dasokhorion','gr','Larisa',859.0,22.41,39.7).
city('Deleria','gr','Larisa',820.0,22.33,39.8).
city('Elasson','gr','Larisa',7060.0,22.19,39.89).
city('Falanna','gr','Larisa',3557.0,22.4,39.72).
city('Farsala','gr','Larisa',10380.0,22.38,39.29).
city('Gonnoi','gr','Larisa',2113.0,22.47,39.87).
city('Khalki','gr','Larisa',1837.0,22.53,39.57).
city('Kranea Elassonos','gr','Larisa',2936.0,21.97,39.95).
city('Kritiri','gr','Larisa',1157.0,22.3,39.72).
city('Larisa','gr','Larisa',128760.0,22.42,39.64).
city('Livadi','gr','Larisa',2655.0,22.15,40.13).
city('Makrikhorion','gr','Larisa',1835.0,22.48,39.8).
city('Melivoia','gr','Larisa',1249.0,22.8,39.75).
city('Nikaia','gr','Larisa',3274.0,22.47,39.57).
city('Piryetos','gr','Larisa',1681.0,22.59,39.92).
city('Platikambos','gr','Larisa',1889.0,22.53,39.62).
city('Rapsani','gr','Larisa',909.0,22.55,39.9).
city('Rodia','gr','Larisa',950.0,22.38,39.68).
city('Sikourion','gr','Larisa',2318.0,22.58,39.76).
city('Terpsithea','gr','Larisa',1308.0,22.37,39.62).
city('Tirnavos','gr','Larisa',10797.0,22.29,39.74).
city('Tsaritsani','gr','Larisa',2514.0,22.23,39.88).
city('Vamvakou','gr','Larisa',1104.0,22.42,39.33).
city('Verdikoussa','gr','Larisa',1603.0,21.97,39.78).
city('Vlakhoyiannion','gr','Larisa',855.0,22.08,39.75).
city('Yiannouli','gr','Larisa',7031.0,22.38,39.67).
city('Ayios Nikolaos','gr','Lasithi',10799.0,25.73,35.15).
city('Gra Liyia','gr','Lasithi',1282.0,25.68,35.02).
city('Ierapetra','gr','Lasithi',12536.0,25.74,35.01).
city('Kato Khorion','gr','Lasithi',1110.0,25.78,35.05).
city('Kentrion','gr','Lasithi',888.0,25.75,35.03).
city('Koutsouras','gr','Lasithi',869.0,25.95,35.03).
city('Kritsa','gr','Lasithi',1560.0,25.65,35.17).
city('Nea Anatoli','gr','Lasithi',1248.0,25.65,35.04).
city('Neapolis','gr','Lasithi',2809.0,25.61,35.25).
city('Palaikastron','gr','Lasithi',1094.0,26.25,35.2).
city('Sision','gr','Lasithi',875.0,25.52,35.3).
city('Sitia','gr','Lasithi',8707.0,26.1,35.2).
city('Skhisma','gr','Lasithi',1968.0,25.72,35.27).
city('Tzermiadon','gr','Lasithi',682.0,25.48,35.2).
city('Agra','gr','Lesvos',983.0,26.07,39.17).
city('Antissa','gr','Lesvos',841.0,25.98,39.23).
city('Atsiki','gr','Lesvos',886.0,25.22,39.95).
city('Ayia Paraskevi','gr','Lesvos',2193.0,26.27,39.25).
city('Ayiasos','gr','Lesvos',2357.0,26.37,39.09).
city('Eresos','gr','Lesvos',1042.0,25.93,39.17).
city('Kalloni','gr','Lesvos',1776.0,26.21,39.23).
city('Loutra','gr','Lesvos',1115.0,26.55,39.06).
city('Mantamados','gr','Lesvos',1120.0,26.33,39.31).
city('Mirina','gr','Lesvos',5406.0,25.07,39.88).
city('Mithimna','gr','Lesvos',1558.0,26.17,39.37).
city('Mitilini','gr','Lesvos',28322.0,26.55,39.11).
city('Moria','gr','Lesvos',1176.0,26.52,39.13).
city('Moudros','gr','Lesvos',1036.0,25.27,39.87).
city('Palaiokipos','gr','Lesvos',1184.0,26.45,39.06).
city('Pamfila','gr','Lesvos',1251.0,26.52,39.16).
city('Pappados','gr','Lesvos',1534.0,26.45,39.04).
city('Parakoila','gr','Lesvos',881.0,26.13,39.17).
city('Petra','gr','Lesvos',1299.0,26.18,39.33).
city('Plomarion','gr','Lesvos',3338.0,26.37,38.98).
city('Polikhnitos','gr','Lesvos',2667.0,26.18,39.08).
city('Skopelos','gr','Lesvos',1728.0,26.45,39.03).
city('Skoutaros','gr','Lesvos',952.0,26.13,39.3).
city('Stipsi','gr','Lesvos',1020.0,26.22,39.31).
city('Varia','gr','Lesvos',1518.0,26.57,39.08).
city('Karia','gr','Levkas',994.0,20.65,38.77).
city('Leukas','gr','Levkas',7075.0,20.7,38.83).
city('Nidrion','gr','Levkas',938.0,20.72,38.7).
city('Agria','gr','Magnisia',5519.0,23.02,39.33).
city('Alli Meria','gr','Magnisia',1189.0,22.98,39.37).
city('Almiros','gr','Magnisia',7253.0,22.76,39.18).
city('Amaliapolis','gr','Magnisia',879.0,22.88,39.17).
city('Anakasia','gr','Magnisia',969.0,22.95,39.39).
city('Anavra','gr','Magnisia',1024.0,22.55,39.07).
city('Ano Lekhonia','gr','Magnisia',1214.0,23.05,39.33).
city('Argalasti','gr','Magnisia',1285.0,23.22,39.23).
city('Ayios Yeoryios Feron','gr','Magnisia',890.0,22.77,39.37).
city('Diminion','gr','Magnisia',2173.0,22.9,39.35).
city('Euxinoupolis','gr','Magnisia',2586.0,22.73,39.2).
city('Glossa','gr','Magnisia',987.0,23.62,39.17).
city('Goritsa','gr','Magnisia',156.0,22.97,39.35).
city('Kala Nera','gr','Magnisia',841.0,23.12,39.3).
city('Kanalia','gr','Magnisia',1144.0,22.88,39.5).
city('Kato Lekhonia','gr','Magnisia',1751.0,23.03,39.33).
city('Makrinitsa','gr','Magnisia',1014.0,22.98,39.4).
city('Mileai','gr','Magnisia',577.0,23.15,39.33).
city('Nea Ankhialos','gr','Magnisia',5908.0,22.81,39.28).
city('Nea Ionia','gr','Magnisia',32005.0,22.92,39.37).
city('Patitirion','gr','Magnisia',1647.0,23.87,39.15).
city('Portaria','gr','Magnisia',1429.0,23.0,39.38).
city('Pteleos','gr','Magnisia',1349.0,22.95,39.05).
city('Rizomilos','gr','Magnisia',1594.0,22.75,39.43).
city('Skiathos','gr','Magnisia',5187.0,23.48,39.17).
city('Skopelos','gr','Magnisia',2886.0,23.72,39.12).
city('Sourpi','gr','Magnisia',2137.0,22.9,39.1).
city('Stefanovikion','gr','Magnisia',2016.0,22.73,39.47).
city('Trikerion','gr','Magnisia',1182.0,23.08,39.1).
city('Velestinon','gr','Magnisia',3211.0,22.75,39.38).
city('Volos','gr','Magnisia',84427.0,22.95,39.37).
city('Zagora','gr','Magnisia',2385.0,23.1,39.45).
city('Arfara','gr','Messinia',1285.0,22.03,37.15).
city('Aris','gr','Messinia',1036.0,22.0,37.1).
city('Dorion','gr','Messinia',1062.0,21.85,37.28).
city('Filiatra','gr','Messinia',6970.0,21.58,37.15).
city('Gargalianoi','gr','Messinia',6282.0,21.63,37.07).
city('Kalamata','gr','Messinia',51108.0,22.11,37.04).
city('Khora','gr','Messinia',3591.0,21.72,37.05).
city('Kiparissia','gr','Messinia',5033.0,21.67,37.25).
city('Kopanaki','gr','Messinia',1500.0,21.82,37.28).
city('Koroni','gr','Messinia',1620.0,21.95,36.8).
city('Longa','gr','Messinia',983.0,21.9,36.87).
city('Marathopolis','gr','Messinia',877.0,21.58,37.07).
city('Meligalas','gr','Messinia',1431.0,21.97,37.22).
city('Messini','gr','Messinia',6773.0,22.01,37.05).
city('Methoni','gr','Messinia',1166.0,21.7,36.82).
city('Mikromani','gr','Messinia',997.0,22.03,37.08).
city('Paralia Vergas','gr','Messinia',2496.0,22.11,37.06).
city('Petalidion','gr','Messinia',1209.0,21.93,36.95).
city('Pilos','gr','Messinia',2135.0,21.7,36.91).
city('Sperkhoyia','gr','Messinia',1004.0,22.07,37.07).
city('Thouria','gr','Messinia',1302.0,22.05,37.08).
city('Valira','gr','Messinia',991.0,21.98,37.17).
city('Vlakhopoulon','gr','Messinia',1446.0,21.78,37.03).
city('Agras','gr','Pella',855.0,22.0,40.81).
city('Akrolimni','gr','Pella',1398.0,22.26,40.68).
city('Ambeliai','gr','Pella',1070.0,22.38,40.83).
city('Apsalos','gr','Pella',1149.0,22.05,40.89).
city('Aravissos','gr','Pella',1513.0,22.27,40.82).
city('Aridaia','gr','Pella',6091.0,22.06,40.97).
city('Arnissa','gr','Pella',1556.0,21.83,40.8).
city('Arsenion','gr','Pella',1389.0,22.16,40.71).
city('Athira','gr','Pella',1722.0,22.58,40.83).
city('Axos','gr','Pella',1336.0,22.0,40.8).
city('Ayios Loukas','gr','Pella',1666.0,22.3,40.72).
city('Edessa','gr','Pella',18669.0,22.05,40.8).
city('Esovalta','gr','Pella',988.0,22.26,40.71).
city('Exaplatanos','gr','Pella',1665.0,22.13,40.98).
city('Galatades','gr','Pella',2459.0,22.27,40.75).
city('Kali','gr','Pella',1773.0,22.18,40.82).
city('Kalivia','gr','Pella',1130.0,22.21,40.76).
city('Kariotissa','gr','Pella',1965.0,22.31,40.77).
city('Kria Vrisi','gr','Pella',6839.0,22.3,40.68).
city('Lipokhorio','gr','Pella',1016.0,22.18,40.76).
city('Loutrakion','gr','Pella',1175.0,21.95,40.97).
city('Mandalon','gr','Pella',1204.0,22.21,40.86).
city('Maurovounion','gr','Pella',1003.0,22.15,40.78).
city('Melission','gr','Pella',1024.0,22.34,40.77).
city('Mesimerion','gr','Pella',899.0,22.02,40.79).
city('Nea Pella','gr','Pella',1595.0,22.49,40.77).
city('Neos Milotopos','gr','Pella',2835.0,22.35,40.82).
city('Palaifiton','gr','Pella',1475.0,22.27,40.78).
city('Pella','gr','Pella',2476.0,22.52,40.76).
city('Pentaplatanon','gr','Pella',1015.0,22.41,40.82).
city('Petraia','gr','Pella',939.0,22.14,40.72).
city('Polikarpion','gr','Pella',1045.0,22.01,40.93).
city('Profitis Ilias','gr','Pella',1225.0,22.16,40.81).
city('Promakhoi','gr','Pella',1809.0,22.0,41.03).
city('Rizarion','gr','Pella',1098.0,22.08,40.79).
city('Rizon','gr','Pella',1106.0,22.14,40.73).
city('Sevastiana','gr','Pella',1561.0,22.12,40.77).
city('Skidra','gr','Pella',5283.0,22.15,40.77).
city('Sosandra','gr','Pella',1217.0,22.03,41.0).
city('Tsakoi','gr','Pella',1004.0,22.04,40.96).
city('Yiannitsa','gr','Pella',27818.0,22.41,40.79).
city('Aiyinion','gr','Pieria',4275.0,22.54,40.5).
city('Alonia','gr','Pieria',653.0,22.54,40.39).
city('Andromakhi','gr','Pieria',1015.0,22.48,40.27).
city('Ayios Dimitrios','gr','Pieria',883.0,22.23,40.15).
city('Ayios Spiridon','gr','Pieria',1649.0,22.44,40.21).
city('Dion','gr','Pieria',1413.0,22.49,40.17).
city('Kallithea','gr','Pieria',3100.0,22.58,40.28).
city('Karitsa','gr','Pieria',2225.0,22.48,40.19).
city('Katerini','gr','Pieria',53294.0,22.5,40.27).
city('Kato Milea','gr','Pieria',1286.0,22.34,40.25).
city('Kitros','gr','Pieria',1412.0,22.58,40.38).
city('Kolindros','gr','Pieria',3590.0,22.48,40.48).
city('Kontariotissa','gr','Pieria',2088.0,22.46,40.23).
city('Korinos','gr','Pieria',4191.0,22.59,40.32).
city('Leptokaria','gr','Pieria',4598.0,22.56,40.06).
city('Litokhoron','gr','Pieria',6709.0,22.5,40.1).
city('Lofos','gr','Pieria',1772.0,22.38,40.24).
city('Makriyialos','gr','Pieria',2009.0,22.6,40.42).
city('Methoni','gr','Pieria',973.0,22.59,40.45).
city('Milea','gr','Pieria',426.0,22.3,40.25).
city('Nea Efesos','gr','Pieria',2006.0,22.5,40.23).
city('Paralia','gr','Pieria',1801.0,22.6,40.27).
city('Peristasis','gr','Pieria',2454.0,22.54,40.27).
city('Platamon','gr','Pieria',2481.0,22.62,39.99).
city('Ritini','gr','Pieria',1711.0,22.28,40.29).
city('Sevasti','gr','Pieria',842.0,22.54,40.36).
city('Sfendamio','gr','Pieria',1151.0,22.55,40.41).
city('Skotina','gr','Pieria',953.0,22.55,40.01).
city('Svoronos','gr','Pieria',2066.0,22.46,40.26).
city('Vrontou','gr','Pieria',2196.0,22.43,40.19).
city('Filippias','gr','Preveza',4256.0,20.88,39.2).
city('Kanalion','gr','Preveza',964.0,20.7,39.07).
city('Kanallakion','gr','Preveza',2446.0,20.6,39.23).
city('Louros','gr','Preveza',2034.0,20.75,39.16).
city('Neos Oropos','gr','Preveza',1375.0,20.74,39.15).
city('Parga','gr','Preveza',2379.0,20.4,39.28).
city('Preveza','gr','Preveza',17283.0,20.75,38.95).
city('Thesprotikon','gr','Preveza',1718.0,20.78,39.25).
city('Anoyia','gr','Rethimni',2545.0,24.88,35.28).
city('Atsipopoulon','gr','Rethimni',1826.0,24.43,35.35).
city('Ayia Galini','gr','Rethimni',1369.0,24.68,35.1).
city('Livadia','gr','Rethimni',1450.0,24.8,35.3).
city('Panormos','gr','Rethimni',1157.0,24.7,35.42).
city('Perama','gr','Rethimni',1655.0,24.7,35.37).
city('Rethimnon','gr','Rethimni',29907.0,24.47,35.36).
city('Zoniana','gr','Rethimni',1703.0,24.83,35.3).
city('Aiyiros','gr','Rodopi',1114.0,25.35,41.11).
city('Amaxades','gr','Rodopi',1016.0,25.07,41.12).
city('Aratos','gr','Rodopi',1152.0,25.55,41.08).
city('Arisvi','gr','Rodopi',1068.0,25.58,41.07).
city('Arriana','gr','Rodopi',1158.0,25.7,41.08).
city('Dokos','gr','Rodopi',1029.0,25.6,41.13).
city('Fillira','gr','Rodopi',1041.0,25.63,41.12).
city('Iasmos','gr','Rodopi',2787.0,25.18,41.13).
city('Ifaistos','gr','Rodopi',1604.0,25.37,41.12).
city('Komotini','gr','Rodopi',45630.0,25.4,41.12).
city('Likion','gr','Rodopi',1081.0,25.68,41.05).
city('Mega Piston','gr','Rodopi',966.0,25.3,41.15).
city('Pagouria','gr','Rodopi',843.0,25.32,41.03).
city('Sapai','gr','Rodopi',4506.0,25.69,41.03).
city('Xilagani','gr','Rodopi',1445.0,25.42,40.98).
city('Ayios Kirikos','gr','Samos',1908.0,26.29,37.61).
city('Fournoi','gr','Samos',1033.0,26.75,37.78).
city('Khora','gr','Samos',1498.0,26.91,37.7).
city('Kokkarion','gr','Samos',1003.0,26.89,37.78).
city('Marathokambos','gr','Samos',1268.0,26.69,37.73).
city('Mitilinioi','gr','Samos',2255.0,26.91,37.73).
city('Neon Karlovasion','gr','Samos',5925.0,26.7,37.79).
city('Pagondas','gr','Samos',695.0,26.83,37.67).
city('Pithagorio','gr','Samos',1297.0,26.95,37.69).
city('Samos','gr','Samos',6389.0,26.98,37.76).
city('Vathi','gr','Samos',1885.0,26.98,37.75).
city('Alistrati','gr','Serrai',2965.0,23.95,41.07).
city('Ambeloi','gr','Serrai',1118.0,23.37,41.0).
city('Ammoudia','gr','Serrai',1110.0,23.33,41.15).
city('Anayennisis','gr','Serrai',990.0,23.33,41.12).
city('Ano Poroia','gr','Serrai',1558.0,23.03,41.28).
city('Ayia Paraskevi','gr','Serrai',978.0,23.47,40.95).
city('Ayion Pneuma','gr','Serrai',2104.0,23.68,41.1).
city('Dafnoudion','gr','Serrai',1193.0,23.75,41.07).
city('Dasokhorion','gr','Serrai',949.0,23.28,41.17).
city('Dimitritsion','gr','Serrai',1529.0,23.42,40.98).
city('Draviskos','gr','Serrai',1706.0,23.87,40.92).
city('Emmanouil Pappas','gr','Serrai',1129.0,23.72,41.08).
city('Flambouron','gr','Serrai',762.0,23.57,40.93).
city('Gazoros','gr','Serrai',1677.0,23.77,41.02).
city('Iraklia','gr','Serrai',3424.0,23.27,41.17).
city('Kala Dendra','gr','Serrai',1317.0,23.42,41.1).
city('Karperi','gr','Serrai',1035.0,23.3,41.12).
city('Kato Kamila','gr','Serrai',1398.0,23.48,41.02).
city('Kato Mitrousion','gr','Serrai',662.0,23.45,41.07).
city('Kerkini','gr','Serrai',1573.0,23.08,41.22).
city('Kharopon','gr','Serrai',1523.0,23.38,41.27).
city('Khimarros','gr','Serrai',950.0,23.25,41.12).
city('Khrisokhorafa','gr','Serrai',1302.0,23.23,41.18).
city('Khrison','gr','Serrai',2079.0,23.65,41.07).
city('Koimisis','gr','Serrai',1490.0,23.3,41.22).
city('Kormista','gr','Serrai',1008.0,24.05,40.98).
city('Leukon','gr','Serrai',2293.0,23.5,41.1).
city('Livadia','gr','Serrai',1085.0,23.08,41.25).
city('Maurothalassa','gr','Serrai',1670.0,23.75,40.9).
city('Megalokhorion','gr','Serrai',741.0,23.22,41.25).
city('Mitrousion','gr','Serrai',1510.0,23.47,41.08).
city('Nea Mpafra','gr','Serrai',1003.0,24.03,40.99).
city('Nea Zikhni','gr','Serrai',2400.0,23.83,41.03).
city('Neokhorion','gr','Serrai',1189.0,23.25,41.18).
city('Neon Petritsion','gr','Serrai',2322.0,23.3,41.28).
city('Neon Soulion','gr','Serrai',2725.0,23.65,41.1).
city('Neos Skopos','gr','Serrai',2560.0,23.62,41.02).
city('Nigrita','gr','Serrai',5320.0,23.5,40.91).
city('Nikoklia','gr','Serrai',1502.0,23.43,40.93).
city('Palaiokomi','gr','Serrai',1862.0,23.9,40.87).
city('Pentapolis','gr','Serrai',1607.0,23.68,41.05).
city('Pontismenon','gr','Serrai',1580.0,23.28,41.2).
city('Proti','gr','Serrai',1783.0,24.0,40.95).
city('Provatas','gr','Serrai',1275.0,23.38,41.07).
city('Psikhikon','gr','Serrai',1142.0,23.63,41.0).
city('Rodolivos','gr','Serrai',2395.0,23.98,40.92).
city('Rodopolis','gr','Serrai',1250.0,23.0,41.26).
city('Serrai','gr','Serrai',55886.0,23.55,41.09).
city('Sidirokastron','gr','Serrai',5825.0,23.39,41.23).
city('Sisamia','gr','Serrai',1168.0,23.42,40.95).
city('Skotoussa','gr','Serrai',1371.0,23.38,41.13).
city('Skoutari','gr','Serrai',2690.0,23.52,41.02).
city('Strimonikon','gr','Serrai',1869.0,23.32,41.05).
city('Terpni','gr','Serrai',2132.0,23.48,40.92).
city('Tholos','gr','Serrai',854.0,23.78,41.0).
city('Toumba','gr','Serrai',947.0,23.7,41.02).
city('Triantafillia','gr','Serrai',944.0,23.35,40.99).
city('Valteron','gr','Serrai',1285.0,23.32,41.18).
city('Valtotopion','gr','Serrai',1106.0,23.6,41.0).
city('Vamvakofiton','gr','Serrai',1161.0,23.4,41.18).
city('Veryi','gr','Serrai',1382.0,23.4,40.95).
city('Vironia','gr','Serrai',858.0,23.23,41.28).
city('Filiates','gr','Thesprotia',2129.0,20.31,39.6).
city('Graikokhorion','gr','Thesprotia',1264.0,20.3,39.48).
city('Igoumenitsa','gr','Thesprotia',9496.0,20.27,39.5).
city('Nea Seleukia','gr','Thesprotia',1578.0,20.26,39.53).
city('Paramithia','gr','Thesprotia',2569.0,20.51,39.47).
city('Parapotamos','gr','Thesprotia',1126.0,20.32,39.55).
city('Perdika','gr','Thesprotia',1875.0,20.3,39.37).
city('Plataria','gr','Thesprotia',1044.0,20.28,39.45).
city('Sayiada','gr','Thesprotia',910.0,20.19,39.63).
city('Sivota','gr','Thesprotia',973.0,20.25,39.41).
city('Adendron','gr','Thessaloniki',2312.0,22.6,40.67).
city('Ambelokipoi','gr','Thessaloniki',41206.0,22.92,40.66).
city('Anatolikon','gr','Thessaloniki',2583.0,22.71,40.66).
city('Angelokhorion','gr','Thessaloniki',991.0,22.83,40.5).
city('Annkhialos','gr','Thessaloniki',1152.0,22.87,40.72).
city('Ano Stauros','gr','Thessaloniki',1539.0,23.7,40.65).
city('Arethousa','gr','Thessaloniki',905.0,23.58,40.75).
city('Askos','gr','Thessaloniki',1406.0,23.38,40.75).
city('Asprovalta','gr','Thessaloniki',3333.0,23.7,40.72).
city('Assiros','gr','Thessaloniki',2409.0,23.03,40.82).
city('Asvestokhorion','gr','Thessaloniki',5345.0,23.03,40.65).
city('Ayia Paraskevi','gr','Thessaloniki',1501.0,23.05,40.48).
city('Ayia Trias','gr','Thessaloniki',3580.0,22.88,40.5).
city('Ayios Athanasios','gr','Thessaloniki',4648.0,22.73,40.72).
city('Ayios Paulos','gr','Thessaloniki',8271.0,22.96,40.64).
city('Ayios Vasilios','gr','Thessaloniki',1328.0,23.14,40.67).
city('Diavata','gr','Thessaloniki',10216.0,22.86,40.69).
city('Drimos','gr','Thessaloniki',2665.0,22.95,40.78).
city('Eleutherio-Kordelio','gr','Thessaloniki',23875.0,22.9,40.65).
city('Epanomi','gr','Thessaloniki',8121.0,22.93,40.43).
city('Eukarpia','gr','Thessaloniki',8013.0,22.95,40.69).
city('Euosmon','gr','Thessaloniki',63111.0,22.91,40.67).
city('Exokhi','gr','Thessaloniki',1580.0,23.07,40.63).
city('Filiron','gr','Thessaloniki',4362.0,23.0,40.68).
city('Iraklion','gr','Thessaloniki',876.0,23.03,40.77).
city('Kalamaria','gr','Thessaloniki',91617.0,22.95,40.58).
city('Kalamoton','gr','Thessaloniki',871.0,23.37,40.57).
city('Kalokhorion','gr','Thessaloniki',4162.0,22.86,40.64).
city('Kardia','gr','Thessaloniki',1751.0,22.99,40.47).
city('Kato Skholarion','gr','Thessaloniki',1904.0,23.03,40.43).
city('Kavallarion','gr','Thessaloniki',2025.0,23.05,40.72).
city('Khalastra','gr','Thessaloniki',7360.0,22.73,40.63).
city('Khalkidon','gr','Thessaloniki',3999.0,22.6,40.73).
city('Khortiatis','gr','Thessaloniki',3466.0,23.1,40.6).
city('Khrisauyi','gr','Thessaloniki',1074.0,23.08,40.77).
city('Kimina','gr','Thessaloniki',3775.0,22.69,40.61).
city('Kolkhikon','gr','Thessaloniki',2010.0,23.13,40.75).
city('Koufalia','gr','Thessaloniki',8305.0,22.57,40.78).
city('Krionerion','gr','Thessaloniki',928.0,23.28,40.82).
city('Krithia','gr','Thessaloniki',1374.0,22.98,40.84).
city('Lankadas','gr','Thessaloniki',7667.0,23.24,40.63).
city('Layina','gr','Thessaloniki',2649.0,23.0,40.72).
city('Liti','gr','Thessaloniki',3226.0,22.98,40.75).
city('Loudias','gr','Thessaloniki',981.0,22.54,40.68).
city('Melissokhorion','gr','Thessaloniki',2002.0,22.93,40.77).
city('Menemeni','gr','Thessaloniki',15706.0,22.9,40.66).
city('Mesimerion','gr','Thessaloniki',1491.0,23.0,40.42).
city('Mikron Monastirion','gr','Thessaloniki',1518.0,22.54,40.71).
city('Nea Apollonia','gr','Thessaloniki',1953.0,23.45,40.63).
city('Nea Filadelfia','gr','Thessaloniki',870.0,22.83,40.8).
city('Nea Kerasia','gr','Thessaloniki',1300.0,23.23,40.37).
city('Nea Maditos','gr','Thessaloniki',2054.0,23.57,40.62).
city('Nea Magnisia','gr','Thessaloniki',4144.0,22.85,40.69).
city('Nea Malgara','gr','Thessaloniki',2476.0,22.68,40.61).
city('Nea Mesimvria','gr','Thessaloniki',2349.0,22.76,40.75).
city('Nea Mikhaniona','gr','Thessaloniki',7908.0,22.86,40.46).
city('Nea Raidestos','gr','Thessaloniki',2322.0,23.05,40.53).
city('Nea Vrasna','gr','Thessaloniki',3011.0,23.65,40.7).
city('Neapolis','gr','Thessaloniki',30106.0,22.99,40.62).
city('Neoi Epivatai','gr','Thessaloniki',5077.0,22.91,40.5).
city('Neokhorouda','gr','Thessaloniki',2232.0,22.88,40.74).
city('Neon Rision','gr','Thessaloniki',3012.0,22.99,40.5).
city('Oraiokastron','gr','Thessaloniki',15006.0,22.92,40.73).
city('Panorama','gr','Thessaloniki',16551.0,23.03,40.58).
city('Pentalofos','gr','Thessaloniki',2107.0,22.85,40.74).
city('Pente Vrisai','gr','Thessaloniki',958.0,23.15,40.82).
city('Peraia','gr','Thessaloniki',16067.0,22.93,40.5).
city('Peristera','gr','Thessaloniki',1137.0,23.17,40.55).
city('Peuka','gr','Thessaloniki',8151.0,22.96,40.7).
city('Pilaia','gr','Thessaloniki',23494.0,22.99,40.6).
city('Playiarion','gr','Thessaloniki',4561.0,22.95,40.47).
city('Polikhni','gr','Thessaloniki',39765.0,22.95,40.66).
city('Profitis','gr','Thessaloniki',963.0,23.28,40.68).
city('Prokhoma','gr','Thessaloniki',1422.0,22.66,40.8).
city('Sikeai','gr','Thessaloniki',44955.0,22.95,40.65).
city('Sindos','gr','Thessaloniki',8228.0,22.8,40.67).
city('Sokhos','gr','Thessaloniki',2748.0,23.35,40.82).
city('Souroti','gr','Thessaloniki',1048.0,23.08,40.47).
city('Stauros','gr','Thessaloniki',3560.0,23.7,40.66).
city('Stauroupolis','gr','Thessaloniki',43224.0,22.93,40.67).
city('Tagarades','gr','Thessaloniki',996.0,23.02,40.48).
city('Thermi','gr','Thessaloniki',14373.0,23.02,40.55).
city('Thessaloniki','gr','Thessaloniki',354291.0,22.94,40.64).
city('Triandria','gr','Thessaloniki',11082.0,22.97,40.62).
city('Trilofon','gr','Thessaloniki',4362.0,22.97,40.47).
city('Vasilika','gr','Thessaloniki',4519.0,23.13,40.47).
city('Vathilakkos','gr','Thessaloniki',2218.0,22.7,40.77).
city('Xilopolis','gr','Thessaloniki',1442.0,23.18,40.93).
city('Yefira','gr','Thessaloniki',3451.0,22.69,40.73).
city('Yerakarou','gr','Thessaloniki',1308.0,23.22,40.63).
city('Zankliverion','gr','Thessaloniki',2312.0,23.29,40.57).
city('Elati','gr','Trikala',886.0,21.53,39.5).
city('Farkadon','gr','Trikala',2416.0,22.07,39.6).
city('Fiki','gr','Trikala',1098.0,21.66,39.52).
city('Gomfoi','gr','Trikala',1064.0,21.69,39.46).
city('Grizanon','gr','Trikala',1528.0,22.05,39.63).
city('Kalambaka','gr','Trikala',8138.0,21.63,39.7).
city('Kast','gr','Trikala',1172.0,21.62,39.72).
city('Kefalovrison','gr','Trikala',959.0,21.69,39.58).
city('Krini','gr','Trikala',845.0,22.02,39.62).
city('Megala Kalivia','gr','Trikala',2092.0,21.79,39.5).
city('Megalokhorion','gr','Trikala',1564.0,21.84,39.56).
city('Oikhalia','gr','Trikala',2819.0,21.98,39.61).
city('Palaiomonastiron','gr','Trikala',1182.0,21.66,39.46).
city('Palaiopirgos','gr','Trikala',1035.0,21.82,39.61).
city('Petroton','gr','Trikala',842.0,21.96,39.59).
city('Pili','gr','Trikala',1791.0,21.62,39.46).
city('Piyi','gr','Trikala',1158.0,21.7,39.52).
city('Rizarion','gr','Trikala',821.0,21.8,39.54).
city('Rizoma','gr','Trikala',1410.0,21.74,39.67).
city('Stournaraiika','gr','Trikala',537.0,21.49,39.45).
city('Taxiarkhai','gr','Trikala',935.0,21.87,39.56).
city('Trikala','gr','Trikala',49810.0,21.77,39.56).
city('Vasiliki','gr','Trikala',1388.0,21.7,39.64).
city('Zarkos','gr','Trikala',1407.0,22.13,39.62).
city('Akraifnion','gr','Voiotia',1195.0,23.22,38.45).
city('Aliartos','gr','Voiotia',4275.0,23.1,38.37).
city('Antikira','gr','Voiotia',3067.0,22.63,38.39).
city('Arakhova','gr','Voiotia',3992.0,22.58,38.48).
city('Arma','gr','Voiotia',1078.0,23.48,38.35).
city('Askri','gr','Voiotia',932.0,23.15,38.29).
city('Asopia','gr','Voiotia',1375.0,23.5,38.3).
city('Ayia Trias','gr','Voiotia',1098.0,22.92,38.35).
city('Ayios Dimitrios','gr','Voiotia',948.0,23.0,38.45).
city('Ayios Thomas','gr','Voiotia',1433.0,23.58,38.28).
city('Ayios Yeoryios','gr','Voiotia',2046.0,22.93,38.4).
city('Daulia','gr','Voiotia',1639.0,22.73,38.52).
city('Dilesi','gr','Voiotia',3134.0,23.67,38.35).
city('Distomon','gr','Voiotia',2023.0,22.67,38.43).
city('Domvraina','gr','Voiotia',1138.0,22.98,38.25).
city('Eleon','gr','Voiotia',656.0,23.47,38.37).
city('Kaparellion','gr','Voiotia',1478.0,23.22,38.23).
city('Kastron','gr','Voiotia',818.0,23.17,38.5).
city('Kiriakion','gr','Voiotia',2227.0,22.78,38.35).
city('Kokkinon','gr','Voiotia',744.0,23.23,38.48).
city('Leontarion','gr','Voiotia',966.0,23.17,38.3).
city('Leuktra','gr','Voiotia',913.0,23.18,38.25).
city('Levadia','gr','Voiotia',20679.0,22.87,38.44).
city('Maurommation','gr','Voiotia',1952.0,23.13,38.32).
city('Oinofita','gr','Voiotia',2971.0,23.63,38.32).
city('Orkhomenos','gr','Voiotia',5920.0,22.98,38.5).
city('Paralia Distomou','gr','Voiotia',1139.0,22.65,38.4).
city('Paulos','gr','Voiotia',1871.0,23.1,38.53).
city('Plaka Dilesi','gr','Voiotia',3084.0,23.61,38.33).
city('Plataiai','gr','Voioti',919.0,23.27,38.22).
city('Prodromos','gr','Voiotia',755.0,22.92,38.27).
city('Skhimatarion','gr','Voiotia',5007.0,23.58,38.35).
city('Skourta','gr','Voiotia',982.0,23.55,38.22).
city('Stirion','gr','Voiotia',1056.0,22.72,38.4).
city('Thespiai','gr','Voiotia',1437.0,23.15,38.3).
city('Thivai','gr','Voiotia',22028.0,23.32,38.33).
city('Vayia','gr','Voiotia',4535.0,23.18,38.32).
city('Avaton','gr','Xanthi',1357.0,24.8,40.97).
city('Avdira','gr','Xanthi',1254.0,24.97,40.93).
city('Ekhinos','gr','Xanthi',2162.0,24.97,41.28).
city('Eulalon','gr','Xanthi',923.0,24.8,40.98).
city('Eumoiron','gr','Xanthi',1190.0,24.87,41.12).
city('Glauki','gr','Xanthi',1180.0,24.93,41.27).
city('Iliokentima','gr','Xanthi',1100.0,24.78,41.0).
city('Kallithea','gr','Xanthi',1131.0,24.73,41.25).
city('Kentauros','gr','Xanthi',2408.0,24.95,41.23).
city('Kimmeria','gr','Xanthi',3423.0,24.93,41.15).
city('Miki','gr','Xanthi',1130.0,24.92,41.25).
city('Neon Erasmion','gr','Xanthi',1009.0,24.82,40.94).
city('Pakhni','gr','Xanthi',1110.0,24.9,41.3).
city('Petinos','gr','Xanthi',1014.0,24.9,41.1).
city('Petrokhorion','gr','Xanthi',1052.0,24.83,41.12).
city('Seleron','gr','Xanthi',1811.0,25.0,41.13).
city('Xanthi','gr','Xanthi',48221.0,24.88,41.14).
city('Yenisea','gr','Xanthi',1935.0,24.97,41.07).
city('Ambelokipoi','gr','Zakinthos',1218.0,20.87,37.77).
city('Gaitanion','gr','Zakinthos',1584.0,20.87,37.78).
city('Kalamakion','gr','Zakinthos',820.0,20.92,37.73).
city('Katastarion','gr','Zakinthos',1321.0,20.77,37.83).
city('Lithakia','gr','Zakinthos',1300.0,20.83,37.72).
city('Makhairadon','gr','Zakinthos',975.0,20.82,37.77).
city('Mouzakion','gr','Zakinthos',1545.0,20.82,37.73).
city('Mpokhali','gr','Zakinthos',836.0,20.87,37.8).
city('Pantokrator','gr','Zakinthos',964.0,20.83,37.73).
city('Planos','gr','Zakinthos',1033.0,20.85,37.82).
city('Vanaton','gr','Zakinthos',944.0,20.85,37.8).
city('Zakinthos','gr','Zakinthos',11540.0,20.9,37.79).
city('Aasiaat','gl','Aasiaat',3115.0,-52.85,68.71).
city('Akunnaaq','gl','Aasiaat',107.0,-52.32,68.75).
city('Kitsissuarsuit','gl','Aasiaat',120.0,-53.11,68.85).
city('Isortoq','gl','Ammassalik',113.0,-38.97,65.53).
city('Kulusuk','gl','Ammassalik',312.0,-37.17,65.57).
city('Kuumiut','gl','Ammassalik',406.0,-37.03,65.87).
city('Qernertuarssuit','gl','Ammassalik',1.0,-37.29,65.72).
city('Sermiligaaq','gl','Ammassalik',223.0,-36.36,65.9).
city('Tasiilaq','gl','Ammassalik',1829.0,-37.69,65.61).
city('Tiniteqilaaq','gl','Ammassalik',169.0,-37.77,65.88).
city('Illoqqortoormiut','gl','Illoqqortoormiut',531.0,-21.97,70.48).
city('Itterajivit','gl','Illoqqortoormiut',15.0,-22.37,70.45).
city('Uunartoq','gl','Illoqqortoormiut',0.0,-21.96,70.4).
city('Ilimanaq','gl','Ilulissat',84.0,-51.11,69.08).
city('Ilulissat','gl','Ilulissat',4413.0,-51.11,69.21).
city('Oqaatsut','gl','Ilulissat',55.0,-51.01,69.35).
city('Qeqertaq','gl','Ilulissat',154.0,-51.31,70.0).
city('Saqqaq','gl','Ilulissat',169.0,-51.94,70.02).
city('Ivittuut','gl','Ivittuut',11.0,-48.16,61.2).
city('Kangilinnguit','gl','Ivittuut',164.0,-48.09,61.23).
city('Attu','gl','Kangaatsiaq',281.0,-53.62,67.95).
city('Iginniarfik','gl','Kangaatsiaq',103.0,-53.16,68.15).
city('Ikerasaarsuk','gl','Kangaatsiaq',116.0,-53.52,68.13).
city('Kangaatsiaq','gl','Kangaatsiaq',680.0,-53.48,68.3).
city('Niaqornaarsuk','gl','Kangaatsiaq',336.0,-52.86,68.23).
city('Atammik','gl','Maniitsoq',250.0,-52.21,64.8).
city('Kangaamiut','gl','Maniitsoq',396.0,-53.35,65.84).
city('Maniitsoq','gl','Maniitsoq',2866.0,-52.93,65.43).
city('Napasoq','gl','Maniitsoq',99.0,-52.39,65.05).
city('Aappilattoq','gl','Nanortalik',180.0,-44.49,60.17).
city('Akuliaruseq','gl','Nanortalik',7.0,-45.47,60.47).
city('Alluitsoq','gl','Nanortalik',6.0,-45.46,60.55).
city('Alluitsup Paa','gl','Nanortalik',364.0,-45.58,60.47).
city('Ammassivik','gl','Nanortalik',83.0,-45.37,60.53).
city('Ikerasassuaq','gl','Nanortalik',4.0,-43.16,60.05).
city('Nanortalik','gl','Nanortalik',1509.0,-45.27,60.15).
city('Narsaq Kujalleq','gl','Nanortalik',110.0,-44.65,60.0).
city('Qallimiut','gl','Nanortalik',12.0,-45.32,60.7).
city('Tasiusaq','gl','Nanortalik',90.0,-44.77,60.18).
city('Igaliku','gl','Narsaq',49.0,-45.41,60.98).
city('Iterlak','gl','Narsaq',2.0,-45.29,60.92).
city('Narsaq','gl','Narsaq',1709.0,-68.88,77.3).
city('Narsarsuaq','gl','Narsaq',154.0,-45.43,61.17).
city('Qassiarsuk','gl','Narsaq',40.0,-45.51,61.15).
city('Tasiusaq','gl','Narsaq',7.0,-56.01,73.42).
city('Timerliit','gl','Narsaq',7.0,-53.24,65.83).
city('Kangerluarsoruseq','gl','Nuuk',6.0,-51.54,63.7).
city('Kapisillit','gl','Nuuk',89.0,-50.26,64.43).
city('Neriunaq','gl','Nuuk',7.0,-50.31,64.47).
city('Nuuk','gl','Nuuk',14799.0,-51.73,64.18).
city('Qeqertarsuatsiaat','gl','Nuuk',261.0,-50.66,63.08).
city('Qooqqut','gl','Nuuk',1.0,-50.89,64.27).
city('Qoornoq','gl','Nuuk',2.0,-51.09,64.53).
city('Pituffik','gl','Outside municipalities',289.0,-68.75,76.53).
city('Arsuk','gl','Paamiut',145.0,-48.44,61.17).
city('Avigaat','gl','Paamiut',0.0,-49.82,62.23).
city('Narsalik','gl','Paamiut',0.0,-49.34,61.62).
city('Paamiut','gl','Paamiut',1862.0,-49.67,61.99).
city('Moriusaq','gl','Qaanaaq',21.0,-69.88,76.76).
city('Qaanaaq','gl','Qaanaaq',616.0,-69.36,77.48).
city('Qeqertarsuaq','gl','Qaanaaq',2.0,-70.18,77.43).
city('Qeqertat','gl','Qaanaaq',18.0,-66.64,77.51).
city('Savissivik','gl','Qaanaaq',82.0,-65.07,76.02).
city('Siorapaluk','gl','Qaanaaq',75.0,-70.75,77.8).
city('Eqalugaarsuit','gl','Qaqortoq',135.0,-26.88,70.76).
city('Qaqortoq','gl','Qaqortoq',3224.0,-46.04,60.72).
city('Qassimiut','gl','Qaqortoq',49.0,-47.16,60.78).
city('Saarloq','gl','Qaqortoq',48.0,-46.02,60.53).
city('Saqqamiut','gl','Qaqortoq',5.0,-47.41,60.82).
city('Upernaviarsuk','gl','Qaqortoq',13.0,-45.87,60.75).
city('Ikamiut','gl','Qasigiannguit',92.0,-51.82,68.63).
city('Qasigiannguit','gl','Qasigiannguit',1341.0,-51.21,68.83).
city('Qeqertarsuaq','gl','Qeqertarsuaq',986.0,-49.78,62.12).
city('Qullissat','gl','Qeqertarsuaq',0.0,-53.01,70.08).
city('Itilleq','gl','Sisimiut',121.0,-53.49,66.58).
city('Kangerlussuaq','gl','Sisimiut',471.0,-50.69,67.0).
city('Sarfannguit','gl','Sisimiut',110.0,-52.86,66.9).
city('Sisimiut','gl','Sisimiut',5227.0,-53.68,66.93).
city('Aappilattoq','gl','Upernavik',208.0,-55.59,72.88).
city('Kangersuatsiaq','gl','Upernavik',244.0,-55.52,72.38).
city('Kullorsuaq','gl','Upernavik',408.0,-57.19,74.58).
city('Naajaat','gl','Upernavik',57.0,-55.81,73.15).
city('Nuusuaq','gl','Upernavik',210.0,-57.06,74.12).
city('Tasiusaq','gl','Upernavik',247.0,-56.04,73.37).
city('Tussaaq','gl','Upernavik',1.0,-65.17,73.05).
city('Upernavik','gl','Upernavik',1129.0,-56.15,72.79).
city('Upernavik Kujalleq','gl','Upernavik',205.0,-55.52,72.15).
city('Ikerasak','gl','Uummannaq',286.0,-51.29,70.5).
city('Illorsuit','gl','Uummannaq',97.0,-53.56,71.23).
city('Maarmorilik','gl','Uummannaq',50.0,-51.27,71.13).
city('Niaqornat','gl','Uummannaq',60.0,-53.64,70.8).
city('Nuugaatsiaq','gl','Uummannaq',99.0,-53.21,71.55).
city('Qaarsut','gl','Uummannaq',204.0,-52.64,70.73).
city('Saattut','gl','Uummannaq',211.0,-51.62,70.82).
city('Ukkusissat','gl','Uummannaq',195.0,-51.87,71.05).
city('Uummannaq','gl','Uummannaq',1275.0,-52.17,70.69).
city('Hillsborough','gd','Carriacou-Petite Martinique',770.0,-61.46,12.48).
city('Grenville','gd','Saint Andrew',2476.0,-61.62,12.13).
city('Saint Davids','gd','Saint Davids',1321.0,-61.67,12.03).
city('Saint Georges','gd','Saint George',4330.0,-61.74,12.06).
city('Gouyave','gd','Saint John',3378.0,-61.73,12.17).
city('Sauteurs','gd','Saint Mark',1320.0,-61.64,12.22).
city('Victoria','gd','Saint Patrick',2256.0,-61.7,12.19).
city('Ba','gp','Basse-Terre',30553.0,-61.59,16.26).
city('Baillif','gp','Basse-Terre',5705.0,-61.74,16.02).
city('Basse-Terre','gp','Basse-Terre',11472.0,-61.72,16.0).
city('Bouillante','gp','Basse-Terre',7541.0,-61.77,16.14).
city('Capesterre-Belle-Eau','gp','Basse-Terre',19823.0,-61.57,16.05).
city('Gourbeyre','gp','Basse-Terre',8572.0,-61.69,15.99).
city('Lamentin','gp','Basse-Terre',14892.0,-61.62,16.27).
city('Petit-Bourg','gp','Basse-Terre',24996.0,-61.59,16.19).
city('Pointe-Noire','gp','Basse-Terre',7750.0,-61.79,16.24).
city('Saint-Claude','gp','Basse-Terre',10135.0,-61.7,16.03).
city('Sainte-Rose','gp','Basse-Terre',20194.0,-61.69,16.34).
city('Trois-Rivieres','gp','Basse-Terre',8812.0,-61.64,15.97).
city('Vieux-Habitants','gp','Basse-Terre',7729.0,-61.75,16.05).
city('Anse-Bertrand','gp','Grande-Terre',5146.0,-61.5,16.47).
city('Le Gosier','gp','Grande-Terre',28700.0,-61.49,16.22).
city('Le Moule','gp','Grande-Terre',22694.0,-61.34,16.33).
city('Les Abymes','gp','Grande-Terre',63061.0,-61.49,16.29).
city('Morne-a-lEau','gp','Grande-Terre',17813.0,-61.45,16.34).
city('Petit-Canal','gp','Grande-Terre',8554.0,-61.49,16.39).
city('Point-a-Pitre','gp','Grande-Terre',18266.0,-61.54,16.25).
city('Port-Louis','gp','Grande-Terre',5515.0,-61.53,16.43).
city('Saint-Francois','gp','Grande-Terre',12733.0,-61.27,16.26).
city('Sainte-Anne','gp','Grande-Terre',22861.0,-61.39,16.24).
city('Terre-de-Bas','gp','Iles des Saintes',1315.0,-61.64,15.85).
city('La Desirade','gp','La Desirade',1717.0,-61.07,16.31).
city('Grand-Bourg','gp','Marie-Galante',5869.0,-61.3,15.89).
city('Saint-Barthelemy','gp','Saint Barthelemy',5988.0,-62.85,17.9).
city('Marigot','gp','Saint Martin',3368.0,-63.05,18.1).
city('Agana Heights','gu','Agana Heights',3816.0,144.74,13.47).
city('Agat','gu','Agat',4376.0,144.65,13.38).
city('Barrigada','gu','Barrigada',4679.0,144.8,13.47).
city('Barrigada Heights','gu','Barrigada',1101.0,144.82,13.49).
city('Chalan Pago','gu','Chalan-Pago-Ordot',2855.0,144.77,13.44).
city('Ordot','gu','Chalan-Pago-Ordot',4089.0,144.76,13.45).
city('Dededo','gu','Dededo',3379.0,144.84,13.52).
city('Finegayan Station','gu','Dededo',1854.0,144.84,13.57).
city('Agana','gu','Hagatna',1050.0,144.75,13.47).
city('Agana Station','gu','Hagatna',1050.0,144.79,13.48).
city('Inarajan','gu','Inarajan',742.0,144.74,13.28).
city('Mangilao','gu','Mangilao',8897.0,144.8,13.44).
city('Merizo','gu','Merizo',1733.0,144.67,13.26).
city('Mongmong','gu','Mongmong-Toto-Maite',3753.0,144.76,13.47).
city('Toto','gu','Mongmong-Toto-Maite',1948.0,144.78,13.47).
city('Apra Harbor','gu','Santa Rita',2743.0,144.67,13.43).
city('Santa Rita','gu','Santa Rita',1265.0,144.67,13.39).
city('Sinajana','gu','Sinajana',2094.0,144.75,13.46).
city('Talofofo','gu','Talofofo',2745.0,144.75,13.35).
city('Tamuning','gu','Tamuning',11255.0,144.78,13.48).
city('Anderson Air Force Base','gu','Yigo',4078.0,144.93,13.56).
city('Yigo','gu','Yigo',8373.0,144.88,13.54).
city('Yona','gu','Yona',2314.0,144.77,13.41).
city('Cahabon','gt','Alta Verapaz',4575.0,-89.82,15.57).
city('Chahal','gt','Alta Verapaz',5100.0,-89.57,15.75).
city('Chisec','gt','Alta Verapaz',12038.0,-90.28,15.82).
city('Coban','gt','Alta Verapaz',46726.0,-90.38,15.47).
city('Fray Bartolome de las','gt','Alta Verapaz',6565.0,-89.94,15.79).
city('Lanquin','gt','Alta Verapaz',1949.0,-89.97,15.57).
city('Panzos','gt','Alta Verapaz',18302.0,-89.67,15.4).
city('San Cristobal Verapaz','gt','Alta Verapaz',18748.0,-90.4,15.38).
city('San Juan Chamelco','gt','Alta Verapaz',11389.0,-90.33,15.43).
city('San Pedro Carcha','gt','Alta Verapaz',12941.0,-90.27,15.48).
city('Santa Catalina la Tinta','gt','Alta Verapaz',9500.0,-89.88,15.31).
city('Santa Cruz Verapaz','gt','Alta Verapaz',5656.0,-90.43,15.37).
city('Senahu','gt','Alta Verapaz',5378.0,-89.83,15.4).
city('Tactic','gt','Alta Verapaz',8723.0,-90.3,15.33).
city('Tamahu','gt','Alta Verapaz',1078.0,-90.17,15.33).
city('Tucuru','gt','Alta Verapaz',3961.0,-90.07,15.3).
city('Cubulco','gt','Baja Verapaz',10073.0,-90.58,15.13).
city('El Chol','gt','Baja Verapaz',2480.0,-90.48,14.96).
city('Granados','gt','Baja Verapaz',1120.0,-90.52,14.91).
city('Purulha','gt','Baja Verapaz',5606.0,-90.2,15.27).
city('Rabinal','gt','Baja Verapaz',12641.0,-90.45,15.1).
city('Salama','gt','Baja Verapaz',22247.0,-90.33,15.1).
city('San Jeronimo','gt','Baja Verapaz',8317.0,-90.2,15.05).
city('San Miguel Chicaj','gt','Baja Verapaz',12708.0,-90.4,15.1).
city('Acatenango','gt','Chimaltenango',6905.0,-90.94,14.55).
city('Chimaltenango','gt','Chimaltenango',80680.0,-90.83,14.67).
city('Comalapa','gt','Chimaltenango',20311.0,-90.88,14.73).
city('El Tejar','gt','Chimaltenango',15445.0,-90.79,14.65).
city('Parramos','gt','Chimaltenango',9415.0,-90.8,14.61).
city('Patzicia','gt','Chimaltenango',16155.0,-90.93,14.63).
city('Patzun','gt','Chimaltenango',18319.0,-91.02,14.68).
city('Pochuta','gt','Chimaltenango',3799.0,-91.08,14.55).
city('San Andres Itzapa','gt','Chimaltenango',18263.0,-90.85,14.62).
city('San Jose Poaquil','gt','Chimaltenango',5864.0,-90.91,14.82).
city('San Martin Jilotepeque','gt','Chimaltenango',9643.0,-90.79,14.79).
city('Santa Apolonia','gt','Chimaltenango',2346.0,-90.97,14.79).
city('Santa Cruz Balanya','gt','Chimaltenango',7664.0,-90.92,14.69).
city('Tecpan Guatemala','gt','Chimaltenango',21526.0,-90.99,14.77).
city('Yepocapa','gt','Chimaltenango',8777.0,-90.96,14.5).
city('Zaragoza','gt','Chimaltenango',9168.0,-90.89,14.65).
city('Camotan','gt','Chiquimula',1565.0,-89.37,14.82).
city('Chiquimula','gt','Chiquimula',40669.0,-89.55,14.8).
city('Concepcion las Minas','gt','Chiquimula',1268.0,-89.45,14.52).
city('Esquipulas','gt','Chiquimula',20249.0,-89.35,14.57).
city('Ipala','gt','Chiquimula',5174.0,-89.62,14.62).
city('Jocotan','gt','Chiquimula',4829.0,-89.38,14.82).
city('Olopa','gt','Chiquimula',1655.0,-89.35,14.68).
city('Quezaltepeque','gt','Chiquimula',4041.0,-89.45,14.63).
city('San Jacinto','gt','Chiquimula',1488.0,-89.5,14.67).
city('San Jose la Arada','gt','Chiquimula',2313.0,-89.58,14.72).
city('San Juan Ermita','gt','Chiquimula',1590.0,-89.43,14.77).
city('El Jicaro','gt','El Progreso',4155.0,-89.9,14.92).
city('Guastatoya','gt','El Progreso',13190.0,-90.07,14.85).
city('Morazan','gt','El Progreso',2502.0,-90.14,14.93).
city('San Agustin Acasaguastlan','gt','El Progreso',10123.0,-89.97,14.95).
city('San Antonio la Paz','gt','El Progreso',7607.0,-90.29,14.75).
city('San Cristobal Acasaguastlan','gt','El Progreso',2127.0,-89.88,14.92).
city('Sanarate','gt','El Progreso',15517.0,-90.19,14.8).
city('Sansare','gt','El Progreso',3714.0,-90.12,14.74).
city('Escuintla','gt','Escuintla',101047.0,-90.78,14.3).
city('Guanagazapa','gt','Escuintla',2784.0,-90.64,14.23).
city('Iztapa','gt','Escuintla',3937.0,-90.71,13.93).
city('La Democracia','gt','Escuintla',5366.0,-90.95,14.23).
city('La Gomera','gt','Escuintla',23460.0,-91.05,14.08).
city('Masagua','gt','Escuintla',9818.0,-90.85,14.2).
city('Nueva Concepcion','gt','Escuintla',10892.0,-91.3,14.2).
city('Palin','gt','Escuintla',30684.0,-90.7,14.4).
city('San Jose','gt','Escuintla',18270.0,-90.82,13.92).
city('San Vicente Pacaya','gt','Escuintla',7014.0,-90.64,14.42).
city('Santa Lucia Cotzumalguapa','gt','Escuintla',60821.0,-91.01,14.33).
city('Siquinala','gt','Escuintla',12881.0,-90.67,14.31).
city('Tiquisate','gt','Escuintla',17814.0,-91.37,14.28).
city('Amatitlan','gt','Guatemala',70357.0,-90.63,14.48).
city('Chinautla','gt','Guatemala',94508.0,-90.5,14.7).
city('Chuarrancho','gt','Guatemala',7001.0,-90.51,14.82).
city('Fraijanes','gt','Guatemala',27852.0,-90.44,14.47).
city('Guatemala','gt','Guatemala',973208.0,-90.55,14.63).
city('Mixco','gt','Guatemala',460576.0,-90.6,14.64).
city('Palencia','gt','Guatemala',18192.0,-90.36,14.66).
city('Petapa','gt','Guatemala',137839.0,-90.57,14.5).
city('San Jose Pinula','gt','Guatemala',46188.0,-90.41,14.55).
city('San Jose del Golfo','gt','Guatemala',4807.0,-90.38,14.76).
city('San Juan Sacatepequez','gt','Guatemala',133613.0,-90.64,14.72).
city('San Pedro Ayampuc','gt','Guatemala',45755.0,-90.45,14.79).
city('San Pedro Sacatepequez','gt','Guatemala',14020.0,-90.64,14.68).
city('San Raymundo','gt','Guatemala',8510.0,-90.6,14.76).
city('Santa Catarina Pinula','gt','Guatemala',66351.0,-90.5,14.57).
city('Villa Canales','gt','Guatemala',119084.0,-90.53,14.48).
city('Villa Nueva','gt','Guatemala',397158.0,-90.59,14.53).
city('Aguacatan','gt','Huehuetenango',5457.0,-91.31,15.34).
city('Barillas','gt','Huehuetenango',13810.0,-91.32,15.8).
city('Chiantla','gt','Huehuetenango',8290.0,-91.46,15.35).
city('Colotenango','gt','Huehuetenango',1656.0,-91.72,15.42).
city('Concepcion','gt','Huehuetenango',8741.0,-91.68,15.62).
city('Cuilco','gt','Huehuetenango',1677.0,-91.97,15.4).
city('Huehuetenango','gt','Huehuetenango',77797.0,-91.47,15.32).
city('Ixtahuacan','gt','Huehuetenango',3631.0,-91.77,15.42).
city('Jacaltenango','gt','Huehuetenango',33384.0,-91.73,15.67).
city('La Democracia','gt','Huehuetenango',21038.0,-91.87,15.63).
city('La Libertad','gt','Huehuetenango',6307.0,-91.83,15.5).
city('Malacatancito','gt','Huehuetenango',2078.0,-91.52,15.22).
city('Nenton','gt','Huehuetenango',2478.0,-91.75,15.8).
city('San Antonio Huista','gt','Huehuetenango',5553.0,-91.77,15.65).
city('San Gaspar Ixchil','gt','Huehuetenango',540.0,-91.72,15.38).
city('San Juan Atitan','gt','Huehuetenango',1870.0,-91.63,15.43).
city('San Juan Ixcoy','gt','Huehuetenango',2483.0,-91.45,15.6).
city('San Mateo Ixtatan','gt','Huehuetenango',12942.0,-91.48,15.83).
city('San Miguel Acatan','gt','Huehuetenango',2716.0,-91.62,15.7).
city('San Pedro Necta','gt','Huehuetenango',3481.0,-91.77,15.5).
city('San Rafael Petzal','gt','Huehuetenango',1494.0,-91.67,15.42).
city('San Rafael la Independencia','gt','Huehuetenango',1038.0,-91.53,15.72).
city('San Sebastian Coatan','gt','Huehuetenango',784.0,-91.57,15.73).
city('San Sebastian Huehuetenango','gt','Huehuetenango',1284.0,-91.58,15.38).
city('Santa Ana Huista','gt','Huehuetenango',1963.0,-91.82,15.68).
city('Santa Barbara','gt','Huehuetenango',868.0,-91.62,15.32).
city('Santa Eulalia','gt','Huehuetenango',4820.0,-91.46,15.73).
city('Santiago Chimaltenango','gt','Huehuetenango',2958.0,-91.72,15.47).
city('Soloma','gt','Huehuetenango',10692.0,-91.45,15.72).
city('Tectitan','gt','Huehuetenango',728.0,-92.03,15.33).
city('Todos Santos Cuchumatan','gt','Huehuetenango',3221.0,-91.62,15.52).
city('El Estor','gt','Izabal',15516.0,-89.35,15.53).
city('Livingston','gt','Izabal',14056.0,-88.75,15.83).
city('Los Amates','gt','Izabal',3347.0,-89.1,15.27).
city('Morales','gt','Izabal',18571.0,-88.82,15.48).
city('Puerto Barrios','gt','Izabal',55445.0,-88.6,15.73).
city('Jalapa','gt','Jalapa',44896.0,-90.0,14.63).
city('Mataquescuintla','gt','Jalapa',7384.0,-90.18,14.53).
city('Monjas','gt','Jalapa',10138.0,-89.87,14.5).
city('San Carlos Alzatate','gt','Jalapa',6220.0,-90.06,14.98).
city('San Luis Jilotepeque','gt','Jalapa',10094.0,-89.73,14.65).
city('San Manuel Chaparron','gt','Jalapa',2570.0,-89.77,14.52).
city('San Pedro Pinula','gt','Jalapa',3235.0,-89.85,14.67).
city('Agua Blanca','gt','Jutiapa',2719.0,-89.65,14.5).
city('Asuncion Mita','gt','Jutiapa',15287.0,-89.72,14.33).
city('Atescatempa','gt','Jutiapa',11306.0,-89.74,14.17).
city('Comapa','gt','Jutiapa',1462.0,-89.92,14.12).
city('Conguaco','gt','Jutiapa',3345.0,-90.03,14.04).
city('El Adelanto','gt','Jutiapa',1923.0,-89.83,14.17).
city('El Progreso','gt','Jutiapa',7199.0,-89.85,14.35).
city('Jalpatagua','gt','Jutiapa',10254.0,-90.01,14.14).
city('Jerez','gt','Jutiapa',4330.0,-89.75,14.1).
city('Jutiapa','gt','Jutiapa',33626.0,-89.9,14.29).
city('Moyuta','gt','Jutiapa',7978.0,-90.08,14.03).
city('Pasaco','gt','Jutiapa',1834.0,-90.21,13.98).
city('Quezada','gt','Jutiapa',2203.0,-90.04,14.27).
city('San Jose Acatempa','gt','Jutiapa',6236.0,-90.13,14.27).
city('Santa Catarina Mita','gt','Jutiapa',10595.0,-89.75,14.45).
city('Yupiltepeque','gt','Jutiapa',2966.0,-89.78,14.2).
city('Zapotitlan','gt','Jutiapa',1583.0,-89.83,14.13).
city('Dolores','gt','Peten',10385.0,-89.42,16.51).
city('Flores','gt','Peten',20002.0,-89.89,16.93).
city('La Libertad','gt','Peten',8467.0,-90.12,16.78).
city('Melchor de Mencos','gt','Peten',11220.0,-89.15,17.07).
city('Poptun','gt','Peten',16963.0,-89.42,16.33).
city('San Andres','gt','Peten',7086.0,-89.92,16.97).
city('San Benito','gt','Peten',30131.0,-89.9,16.92).
city('San Francisco','gt','Peten',3873.0,-89.93,16.8).
city('San Jose','gt','Peten',1176.0,-89.9,16.98).
city('San Luis','gt','Peten',6636.0,-89.44,16.2).
city('Santa Ana','gt','Peten',9309.0,-89.83,16.8).
city('Sayaxche','gt','Peten',8913.0,-90.17,16.52).
city('Almolonga','gt','Quezaltenango',11668.0,-91.5,14.82).
city('Cabrican','gt','Quezaltenango',11663.0,-91.62,15.13).
city('Cajola','gt','Quezaltenango',2867.0,-91.62,14.92).
city('Cantel','gt','Quezaltenango',25485.0,-91.45,14.82).
city('Coatepeque','gt','Quezaltenango',44717.0,-92.87,14.7).
city('Colomba','gt','Quezaltenango',18722.0,-91.73,14.72).
city('Concepcion Chiquirichapa','gt','Quezaltenango',7914.0,-91.62,14.85).
city('El Palmar','gt','Quezaltenango',14828.0,-91.58,14.65).
city('Flores Costa Cuca','gt','Quezaltenango',11716.0,-91.82,14.65).
city('Genova','gt','Quezaltenango',3667.0,-91.83,14.62).
city('Huitan','gt','Quezaltenango',9737.0,-91.62,15.1).
city('La Esperanza','gt','Quezaltenango',16095.0,-91.57,14.87).
city('Olintepeque','gt','Quezaltenango',28239.0,-91.52,14.83).
city('Ostuncalco','gt','Quezaltenango',28301.0,-91.62,14.87).
city('Palestina de los Altos','gt','Quezaltenango',1657.0,-91.7,14.93).
city('Quetzaltenango','gt','Quezaltenango',132231.0,-91.53,14.84).
city('Salcaja','gt','Quezaltenango',11720.0,-91.45,14.88).
city('San Carlos Sija','gt','Quezaltenango',6691.0,-91.55,14.98).
city('San Francisco la Union','gt','Quezaltenango',1146.0,-91.53,14.92).
city('San Martin Sacatepequez','gt','Quezaltenango',3582.0,-91.65,14.82).
city('San Mateo','gt','Quezaltenango',5421.0,-91.58,14.87).
city('San Miguel Sigueila','gt','Quezaltenango',7384.0,-91.62,14.9).
city('Sibilia','gt','Quezaltenango',1155.0,-91.62,15.0).
city('Zunil','gt','Quezaltenango',9780.0,-91.48,14.78).
city('Canilla','gt','Quiche',1663.0,-90.85,15.17).
city('Chajul','gt','Quiche',11416.0,-91.03,15.48).
city('Chicaman','gt','Quiche',2046.0,-90.77,15.4).
city('Chiche','gt','Quiche',2357.0,-91.07,15.01).
city('Chichicastenango','gt','Quiche',77861.0,-91.12,14.93).
city('Chinique','gt','Quiche',2637.0,-91.03,15.04).
city('Cunen','gt','Quiche',8227.0,-91.03,15.34).
city('Ixcan','gt','Quiche',7668.0,-91.07,15.82).
city('Joyabaj','gt','Quiche',12893.0,-90.81,14.99).
city('Nebaj','gt','Quiche',22821.0,-91.15,15.41).
city('Pachalum','gt','Quiche',2295.0,-90.66,14.92).
city('Patzite','gt','Quiche',983.0,-91.22,14.97).
city('Sacapulas','gt','Quiche',11839.0,-91.09,15.29).
city('San Andres Sajcabaja','gt','Quiche',1947.0,-90.92,15.22).
city('San Antonio Ilotenango','gt','Quiche',1979.0,-91.23,15.05).
city('San Bartolome Jocotenango','gt','Quiche',1586.0,-91.08,15.19).
city('San Juan Cotzal','gt','Quiche',10818.0,-91.03,15.43).
city('San Pedro Jocopilas','gt','Quiche',1019.0,-91.15,15.09).
city('Santa Cruz del Quiche','gt','Quiche',23131.0,-91.15,15.03).
city('Uspantan','gt','Quiche',4617.0,-90.83,15.38).
city('Zacualpa','gt','Quiche',9050.0,-90.83,15.08).
city('Champerico','gt','Retalhuleu',7602.0,-91.92,14.3).
city('El Asintal','gt','Retalhuleu',6018.0,-91.73,14.6).
city('Nuevo San Carlos','gt','Retalhuleu',18681.0,-91.7,14.6).
city('Retalhuleu','gt','Retalhuleu',35903.0,-91.69,14.54).
city('San Andres Villa Seca','gt','Retalhuleu',4988.0,-91.58,14.57).
city('San Felipe','gt','Retalhuleu',8737.0,-91.6,14.62).
city('San Martin Zapotitlan','gt','Retalhuleu',4328.0,-91.6,14.6).
city('San Sebastian','gt','Retalhuleu',14519.0,-91.65,14.57).
city('Santa Cruz Mulua','gt','Retalhuleu',2650.0,-91.62,14.58).
city('Alotenango','gt','Sacatepequez',17052.0,-90.81,14.48).
city('Antigua Guatemala','gt','Sacatepequez',38560.0,-90.74,14.56).
city('Ciudad Vieja','gt','Sacatepequez',29584.0,-90.77,14.52).
city('Jocotenango','gt','Sacatepequez',17550.0,-90.73,14.58).
city('Magdalena Milpas Altas','gt','Sacatepequez',5467.0,-90.68,14.55).
city('Pastores','gt','Sacatepequez',10180.0,-90.75,14.6).
city('San Antonio Aguas Calientes','gt','Sacatepequez',7650.0,-90.77,14.54).
city('San Bartolome Milpas Altas','gt','Sacatepequez',6132.0,-90.68,14.61).
city('San Lucas Saca','gt','Sacatepequez',17590.0,-90.66,14.61).
city('San Miguel Duenas','gt','Sacatepequez',8251.0,-90.8,14.52).
city('Santa Catarina Barahona','gt','Sacatepequez',3148.0,-90.79,14.55).
city('Santa Lucia Milpas Altas','gt','Sacatepequez',12711.0,-90.68,14.58).
city('Santa Maria de Jesus','gt','Sacatepequez',15210.0,-90.72,14.5).
city('Santiago Sacatepequez','gt','Sacatepequez',23713.0,-90.68,14.64).
city('Santo Domingo Xenacoj','gt','Sacatepequez',8610.0,-90.7,14.68).
city('Sumpango','gt','Sacatepequez',20454.0,-90.73,14.65).
city('Ayutla','gt','San Marcos',11197.0,-92.15,14.67).
city('Catarina','gt','San Marcos',2977.0,-92.08,14.85).
city('Comitancillo','gt','San Marcos',19203.0,-91.72,15.08).
city('Concepcion Tutuapa','gt','San Marcos',1147.0,-91.78,15.28).
city('El Quetzal','gt','San Marcos',11853.0,-91.82,14.77).
city('El Rodeo','gt','San Marcos',1849.0,-91.97,14.92).
city('El Tumbador','gt','San Marcos',7406.0,-91.93,14.87).
city('Esquipulas Palo Gordo','gt','San Marcos',1502.0,-91.82,14.93).
city('Ixchiguan','gt','San Marcos',2217.0,-91.88,15.2).
city('La Reforma','gt','San Marcos',4804.0,-91.82,14.8).
city('Malaca','gt','San Marcos',14616.0,-92.05,14.9).
city('Nuevo Progreso','gt','San Marcos',7947.0,-91.92,14.8).
city('Ocos','gt','San Marcos',9252.0,-92.19,14.51).
city('Pajapita','gt','San Marcos',7996.0,-92.03,14.72).
city('Rio Blanco','gt','San Marcos',812.0,-91.68,15.03).
city('San Antonio Sacatepequez','gt','San Marcos',1623.0,-91.73,14.97).
city('San Cristobal Cucho','gt','San Marcos',8948.0,-91.78,14.9).
city('San Jose Ojetenan','gt','San Marcos',1243.0,-91.97,15.22).
city('San Lorenzo','gt','San Marcos',925.0,-91.73,15.03).
city('San Marcos','gt','San Marcos',24573.0,-91.8,14.96).
city('San Miguel Ixtahuacan','gt','San Marcos',3587.0,-91.75,15.25).
city('San Pablo','gt','San Marcos',13340.0,-92.0,14.93).
city('San Pedro Sacatepequez','gt','San Marcos',39200.0,-91.77,14.97).
city('San Rafael Pie de la Cuesta','gt','San Marcos',4231.0,-91.92,14.93).
city('Sibinal','gt','San Marcos',1623.0,-92.05,15.13).
city('Sipacapa','gt','San Marcos',647.0,-91.67,15.2).
city('Tacana','gt','San Marcos',6305.0,-92.08,15.23).
city('Tajumulco','gt','San Marcos',4226.0,-91.88,15.08).
city('Tejutla','gt','San Marcos',2599.0,-91.8,15.12).
city('Barberena','gt','Santa Rosa',29861.0,-90.37,14.3).
city('Casillas','gt','Santa Rosa',8786.0,-90.24,14.42).
city('Chiquimulilla','gt','Santa Rosa',12578.0,-90.38,14.09).
city('Cuilapa','gt','Santa Rosa',16484.0,-90.31,14.28).
city('Guazacapan','gt','Santa Rosa',6935.0,-90.42,14.07).
city('Nueva Santa Rosa','gt','Santa Rosa',9922.0,-90.28,14.38).
city('Oratorio','gt','Santa Rosa',9946.0,-90.17,14.23).
city('Pueblo Nuevo Vinas','gt','Santa Rosa',4125.0,-90.47,14.23).
city('San Juan Tecuaco','gt','Santa Rosa',2164.0,-90.26,14.08).
city('San Rafael las Flores','gt','Santa Rosa',2519.0,-90.17,14.48).
city('Santa Cruz Naranjo','gt','Santa Rosa',6126.0,-90.37,14.39).
city('Santa Maria Ixhuatan','gt','Santa Rosa',3559.0,-90.27,14.19).
city('Santa Rosa de Lima','gt','Santa Rosa',5861.0,-90.3,14.39).
city('Taxisco','gt','Santa Rosa',6384.0,-90.46,14.07).
city('Concepcion','gt','Solola',3224.0,-91.15,14.78).
city('Nahuala','gt','Solola',27076.0,-91.32,14.85).
city('Panajachel','gt','Solola',12599.0,-91.15,14.73).
city('San Andres Semetabaj','gt','Solola',2552.0,-91.13,14.75).
city('San Antonio Palopo','gt','Solola',3514.0,-91.12,14.7).
city('San Jose Chacaya','gt','Solola',820.0,-91.22,14.77).
city('San Juan la Laguna','gt','Solola',4513.0,-91.28,14.7).
city('San Lucas Toliman','gt','Solola',14246.0,-91.13,14.63).
city('San Marcos la Laguna','gt','Solola',2626.0,-91.26,14.73).
city('San Pablo la Laguna','gt','Solola',6058.0,-91.27,14.72).
city('San Pedro la Laguna','gt','Solola',9482.0,-91.27,14.68).
city('Santa Catarina Ixtahuacan','gt','Solola',14405.0,-91.37,14.8).
city('Santa Catarina Palopo','gt','Solola',2887.0,-91.13,14.72).
city('Santa Clara la Laguna','gt','Solola',5197.0,-91.3,14.72).
city('Santa Cruz la Laguna','gt','Solola',1393.0,-91.22,14.75).
city('Santa Lucia Utatlan','gt','Solola',1278.0,-91.27,14.77).
city('Santa Maria Visitacion','gt','Solola',1456.0,-91.32,14.72).
city('Santiago Atitlan','gt','Solola',32625.0,-91.23,14.63).
city('Solola','gt','Solola',44443.0,-91.19,14.77).
city('Chicacao','gt','Suchitepequez',20006.0,-91.32,14.53).
city('Cuyotenango','gt','Suchitepequez',10602.0,-91.57,14.53).
city('Mazatenango','gt','Suchitepequez',43225.0,-91.51,14.53).
city('Patulul','gt','Suchitepequez',13905.0,-91.17,14.42).
city('Pueblo Nuevo','gt','Suchitepequez',3051.0,-91.53,14.65).
city('Rio Bravo','gt','Suchitepequez',7412.0,-91.32,14.4).
city('Samayac','gt','Suchitepequez',8809.0,-91.47,14.58).
city('San Antonio Suchitepequez','gt','Suchitepequez',10726.0,-91.42,14.53).
city('San Bernardino','gt','Suchitepequez',5388.0,-91.45,14.53).
city('San Francisco Zapotitlan','gt','Suchitepequez',13544.0,-91.52,14.58).
city('San Gabriel','gt','Suchitepequez',4033.0,-91.52,14.52).
city('San Jose El Idolo','gt','Suchitepequez',2362.0,-91.42,14.45).
city('San Juan Bautista','gt','Suchitepequez',2625.0,-91.18,14.42).
city('San Lorenzo','gt','Suchitepequez',2121.0,-91.52,14.48).
city('San Miguel Panan','gt','Suchitepequez',1983.0,-91.37,14.53).
city('San Pablo Jocopilas','gt','Suchitepequez',19774.0,-91.45,14.58).
city('Santa Barbara','gt','Suchitepequez',12618.0,-91.23,14.43).
city('Santo Domingo Suchitepequez','gt','Suchitepequez',6141.0,-91.48,14.47).
city('Santo Tomas la Union','gt','Suchitepequez',6935.0,-91.38,14.63).
city('Zunilito','gt','Suchitepequez',2688.0,-91.52,14.62).
city('Momostenango','gt','Totonicapan',31088.0,-91.41,15.04).
city('San Andres Xecul','gt','Totonicapan',11884.0,-91.48,14.9).
city('San Bartolo','gt','Totonicapan',1264.0,-91.46,15.08).
city('San Cristobal Totonicapan','gt','Totonicapan',4104.0,-91.43,14.92).
city('San Francisco El Alto','gt','Totonicapan',53226.0,-91.45,14.95).
city('Santa Lucia la Reforma','gt','Totonicapan',1377.0,-91.24,15.13).
city('Santa Maria Chiquimula','gt','Totonicapan',6837.0,-91.33,15.03).
city('Totonicapan','gt','Totonicapan',68213.0,-91.36,14.92).
city('Cabanas','gt','Zacapa',4582.0,-89.8,14.93).
city('Estanzuela','gt','Za',8753.0,-89.57,15.0).
city('Gualan','gt','Zacapa',18957.0,-89.37,15.13).
city('Huite','gt','Zacapa',2656.0,-89.72,14.93).
city('La Union','gt','Zacapa',3606.0,-89.28,14.97).
city('Rio Hondo','gt','Zacapa',5874.0,-89.58,15.07).
city('San Diego','gt','Zacapa',546.0,-89.78,14.78).
city('Teculutan','gt','Zacapa',6275.0,-89.72,14.98).
city('Usumatlan','gt','Zacapa',4884.0,-89.78,14.95).
city('Zacapa','gt','Zacapa',35349.0,-89.53,14.98).
city('Saint Peter Port','gg','Saint Peter Port',16661.0,-2.55,49.47).
city('Bafata','gw','Bafata',22521.0,-14.69,12.17).
city('Quinhamel','gw','Biombo',3128.0,15.86,11.89).
city('Bissau','gw','Bissau',388094.0,-15.6,11.87).
city('Bolama','gw','Bolama',10769.0,-15.49,11.59).
city('Bubaque','gw','Bolama',9941.0,-15.84,11.29).
city('Cacheu','gw','Cacheu',10490.0,-16.17,12.27).
city('Canchungo','gw','Cacheu',6853.0,-16.04,12.06).
city('Gabu','gw','Gabu',14430.0,-14.24,12.28).
city('Bissora','gw','Oio',12688.0,-15.46,12.23).
city('Farim','gw','Oio',6792.0,-15.23,12.5).
city('Mansoa','gw','Oio',7821.0,-15.32,12.07).
city('Buba','gw','Quinara',7779.0,-15.0,11.58).
city('Fulacunda','gw','Quinara',1327.0,-15.21,11.76).
city('Quebo','gw','Quinara',7072.0,-14.94,11.33).
city('Catio','gw','Tombali',9898.0,-15.25,11.29).
city('Beyla','gn','Beyla',14053.0,-8.67,8.7).
city('Boffa','gn','Boffa',2332.0,-14.05,10.18).
city('Boke','gn','Boke',15462.0,-14.3,10.94).
city('Conakry','gn','Conakry',1871185.0,-13.67,9.55).
city('Coyah','gn','Coyah',1632.0,-13.39,9.71).
city('Dabola','gn','Dabola',13056.0,-11.11,10.75).
city('Dalaba','gn','Dalaba',12823.0,-12.28,10.66).
city('Dinguiraye','gn','Dinguiraye',6062.0,-10.73,11.3).
city('Faranah','gn','Faranah',9349.0,-10.75,10.04).
city('Forecariah','gn','Forecariah',12357.0,-13.1,9.43).
city('Fria','gn','Fria',9326.0,-13.55,10.38).
city('Gaoual','gn','Gaoual',7461.0,-13.21,11.76).
city('Guekedou','gn','Gueckedou',5534.0,-10.15,8.56).
city('Kankan','gn','Kankan',114103.0,-9.31,10.39).
city('Kerouane','gn','Kerouane',7228.0,-9.02,9.27).
city('Kindia','gn','Kindia',117095.0,-12.87,10.06).
city('Kissidougou','gn','Kissidougou',47097.0,-10.12,9.19).
city('Koubia','gn','Koubia',9909.0,-11.9,11.58).
city('Koundara','gn','Koundara',13989.0,-13.3,12.48).
city('Kouroussa','gn','Kouroussa',14222.0,-9.89,10.66).
city('Labe','gn','Labe',46510.0,-12.3,11.32).
city('Lola','gn','Lola',1982.0,-8.53,7.79).
city('Macenta','gn','Macenta',43107.0,-9.48,8.55).
city('Mali','gn','Mali',5479.0,-12.3,12.08).
city('Mamou','gn','Mamou',41618.0,-12.1,10.38).
city('Mandiana','gn','Mandiana',10608.0,-8.69,10.63).
city('Nzerekore','gn','Nzerekore',132842.0,-8.83,7.76).
city('Pita','gn','Pita',20051.0,-12.41,11.08).
city('Siguiri','gn','Siguiri',43599.0,-9.18,11.42).
city('Telimele','gn','Telimele',30310.0,-13.05,10.91).
city('Tougue','gn','Tougue',25530.0,-11.67,11.44).
city('Yomou','gn','Yomou',3614.0,-9.27,7.57).
city('Mabaruma','gy','Barima-Waini',717.0,-59.78,8.2).
city('Bartica','gy','Cuyuni-Mazaruni',11159.0,-58.63,6.41).
city('Georgetown','gy','Demerara-Mahaica',235017.0,-58.16,6.79).
city('Mahaica','gy','Demerara-Mahaica',4867.0,-57.92,6.69).
city('Paradise','gy','Demerara-Mahaica',3785.0,-57.99,6.76).
city('Corriverton','gy','East Berbice-Corentyne',12679.0,-57.17,5.9).
city('Kumaka','gy','East Berbice-Corentyne',2170.0,-58.38,3.9).
city('New Amsterdam','gy','East Berbice-Corentyne',35039.0,-57.53,6.25).
city('Skeldon','gy','East Berbice-Corentyne',5859.0,-57.15,5.88).
city('Vreed en Hoop','gy','Essequibo Islands-We',3073.0,-58.18,6.81).
city('Fort Wellington','gy','Mahaica-Berbice',2253.0,-57.61,6.4).
city('Mahaicony','gy','Mahaica-Berbice',2130.0,-57.8,6.55).
city('Rosignol','gy','Mahaica-Berbice',5782.0,-57.54,6.28).
city('Anna Regina','gy','Pomeroon-Supenaam',1331.0,-58.5,7.27).
city('Ituni','gy','Upper Demerara-Berbice',4567.0,-58.25,5.43).
city('Linden','gy','Upper Demerara-Berbice',44690.0,-58.27,5.99).
city('Lethem','gy','Upper Takutu-Upper Essequibo',716.0,-59.8,3.39).
city('Desdunes','ht','Artibonite',12990.0,-72.6,19.29).
city('Dessalines','ht','Artibonit',12313.0,-72.52,19.26).
city('Gonaives','ht','Artibonite',84966.0,-72.69,19.45).
city('Gros-Morne','ht','Artibonite',7234.0,-72.68,19.68).
city('LArtibonite','ht','Artibonite',25765.0,-72.48,19.12).
city('Saint-Marc','ht','Artibonite',66230.0,-72.7,19.11).
city('Saint-Michel-de-lAtalaye','ht','Artibonite',11736.0,-72.33,19.37).
city('Saint-Raphael','ht','Artibonite',6002.0,-72.2,19.43).
city('Verrettes','ht','Artibonite',48811.0,-72.46,19.06).
city('Hinche','ht','Centre',18580.0,-72.01,19.15).
city('Mirebalais','ht','Centre',9088.0,-72.1,18.83).
city('Anse-dHainault','ht','GrandAnse',7266.0,-74.45,18.49).
city('Dame Marie','ht','GrandAnse',6009.0,-74.42,18.57).
city('Jeremie','ht','GrandAnse',30920.0,-74.12,18.65).
city('Miragoane','ht','GrandAnse',6009.0,-73.09,18.44).
city('Cap-Haitien','ht','Nord',134823.0,-72.2,19.76).
city('Croix-des-Bouquets','ht','Nord',6472.0,-72.24,18.59).
city('Grande Riviere du Nord','ht','Nord',8826.0,-72.18,19.58).
city('Limbe','ht','Nord',32652.0,-72.41,19.71).
city('Pignon','ht','Nord',6766.0,-72.12,19.34).
city('Derac','ht','Nord-Est',1808.0,-71.82,19.65).
city('Fort-Liberte','ht','Nord-Est',11473.0,-71.83,19.67).
city('Ouanaminthe','ht','Nord-Est',10152.0,-71.73,19.55).
city('Trou-du-Nord','ht','Nord-Est',10569.0,-72.02,19.62).
city('Port-de-Paix','ht','Nord-Ouest',34659.0,-72.84,19.94).
city('Saint-Louis-du-Nord','ht','Nord-Ouest',11844.0,-72.73,19.92).
city('Anse-a-Galets','ht','Ouest',7166.0,-72.87,18.84).
city('Carrefour','ht','Ouest',439590.0,-72.42,18.53).
city('Delmas','ht','Ouest',377194.0,-72.28,18.55).
city('Kenscoff','ht','Ouest',5176.0,-72.29,18.45).
city('Lascahobas','ht','Ouest',7564.0,-71.94,18.83).
city('Leogane','ht','Ouest',11545.0,-72.63,18.51).
city('Petionville','ht','Ouest',108235.0,-72.29,18.52).
city('Petit Goave','ht','Ouest',14531.0,-72.86,18.43).
city('Port-au-Prince','ht','Ouest',1234750.0,-72.34,18.54).
city('Aquin','ht','Sud',5219.0,-73.4,18.28).
city('Les Cayes','ht','Sud',59323.0,-73.75,18.2).
city('Jacmel','ht','Sud-Est',33569.0,-72.54,18.24).
city('Arizona','hn','Atlantida',4444.0,-87.32,15.63).
city('Atenas de San Cristobal','hn','Atlantida',1783.0,-87.32,15.68).
city('Corozal','hn','Atlantida',2261.0,-86.72,15.78).
city('El Pino','hn','Atlantida',3004.0,-86.93,15.7).
city('El Porvenir','hn','Atlantida',2269.0,-86.93,15.75).
city('El Triunfo de La Cruz','hn','Atlantida',2190.0,-87.43,15.77).
city('Esparta','hn','Atlantida',1115.0,-87.25,15.73).
city('Hicaque','hn','Atlantida',903.0,-87.37,15.72).
city('Jutiapa','hn','Atlantida',2815.0,-86.52,15.77).
city('La Ceiba','hn','Atlantida',130230.0,-86.79,15.78).
city('La Masica','hn','Atlantida',4022.0,-87.12,15.62).
city('La Union','hn','Atlantida',2382.0,-86.98,15.71).
city('Mezapa','hn','Atlantida',3621.0,-87.52,15.58).
city('Mezapita','hn','Atlantida',1846.0,-87.41,15.54).
city('Nueva Armenia','hn','Atlantida',1392.0,-86.51,15.8).
city('Paujiles','hn','Atlantida',1244.0,-87.35,15.1).
city('Piedras Amarillas','hn','Atlantida',999.0,-86.57,15.68).
city('Sambo Creek','hn','Atlantida',2532.0,-86.68,15.82).
city('San Antonio','hn','Atlantida',1151.0,-87.15,15.6).
city('San Francisco','hn','Atlantida',2806.0,-87.05,15.65).
city('San Juan','hn','Atlantida',1512.0,-87.54,15.79).
city('San Juan Pueblo','hn','Atlantida',5735.0,-87.23,15.58).
city('Santa Ana','hn','Atlantida',3579.0,-87.07,15.65).
city('Siempre Viva','hn','Atlantida',1119.0,-87.25,15.58).
city('Suyapa de Lean','hn','Atlantida',941.0,-87.4,15.52).
city('Tela','hn','Atlantida',29329.0,-87.46,15.78).
city('Toloa Adentro','hn','Atlantida',981.0,-87.7,15.67).
city('Tornabe','hn','Atlantida',1452.0,-87.55,15.75).
city('Agua Caliente de Linaca','hn','Choluteca',973.0,-87.23,13.43).
city('Apacilagua','hn','Choluteca',1251.0,-87.07,13.43).
city('Cedeno','hn','Choluteca',1503.0,-87.45,13.22).
city('Choluteca','hn','Choluteca',75880.0,-87.2,13.3).
city('Concepcion de Maria','hn','Choluteca',923.0,-87.0,13.22).
city('Duyure','hn','Choluteca',1164.0,-86.82,13.63).
city('El Corpus','hn','Choluteca',1199.0,-87.04,13.28).
city('El Obraje','hn','Choluteca',1172.0,-87.13,13.17).
city('El Perico','hn','Choluteca',957.0,-87.04,13.13).
city('El Puente','hn','Choluteca',1325.0,-87.12,13.28).
city('El Triunfo','hn','Choluteca',7183.0,-87.0,13.12).
city('La Tajeada','hn','Choluteca',882.0,-87.08,13.32).
city('Los Llanitos','hn','Choluteca',1040.0,-87.34,13.28).
city('Marcovia','hn','Choluteca',1928.0,-87.32,13.28).
city('Monjaras','hn','Choluteca',6772.0,-87.37,13.2).
city('Morolica','hn','Choluteca',973.0,-86.9,13.57).
city('Namasiguee','hn','Choluteca',1804.0,-87.13,13.2).
city('Orocuina','hn','Choluteca',1655.0,-87.1,13.48).
city('Pespire','hn','Choluteca',3172.0,-87.37,13.58).
city('Rio Arriba','hn','Choluteca',995.0,-87.09,13.18).
city('San Agustin','hn','Choluteca',938.0,-87.12,13.2).
city('San Francisco','hn','Choluteca',883.0,-86.9,13.38).
city('San Jeronimo','hn','Choluteca',2381.0,-87.14,13.18).
city('San Marcos de Colon','hn','Choluteca',8821.0,-86.8,13.43).
city('Santa Ana de Yusguare','hn','Choluteca',1823.0,-87.12,13.3).
city('Santa Cruz','hn','Choluteca',1174.0,-87.35,13.24).
city('Bonito Oriental','hn','Colon',3732.0,-85.73,15.73).
city('Carbonales','hn','Colon',3486.0,-85.73,15.76).
city('Corocito','hn','Colon',2855.0,-85.78,15.75).
city('Cuaca Vieja','hn','Colon',914.0,-86.12,15.53).
city('Cusuna','hn','Colon',1441.0,-85.23,15.85).
city('El Guapinol','hn','Colon',1817.0,-87.47,13.77).
city('Elixir','hn','Colon',3079.0,-86.3,15.48).
city('Francia','hn','Colon',1331.0,-85.58,15.85).
city('Jerico','hn','Colon',2364.0,-85.97,15.95).
city('La Brea','hn','Colon',1055.0,-85.97,15.8).
city('La Esperanza','hn','Colon',2014.0,-85.77,15.63).
city('Limon','hn','Colon',2434.0,-85.47,15.86).
city('Prieta','hn','Colon',1103.0,-86.18,15.58).
city('Puerto Castilla','hn','Colon',1220.0,-85.97,16.02).
city('Punta de Piedra','hn','Colon',1188.0,-85.28,15.9).
city('Quebrada de Arena','hn','Colon',2723.0,-85.92,15.77).
city('Rio Esteban','hn','Colon',1208.0,-86.3,15.83).
city('Saba','hn','Colon',9666.0,-86.25,15.47).
city('Salama','hn','Colon',1737.0,-85.97,15.75).
city('Santa Rosa de Aguan','hn','Colon',1304.0,-85.72,15.95).
city('Sonaguera','hn','Colon',11444.0,-86.28,15.62).
city('Taujica','hn','Colon',1271.0,-85.92,15.7).
city('Tocoa','hn','Colon',30789.0,-86.01,15.65).
city('Trujillo','hn','Colon',9647.0,-85.96,15.91).
city('Zamora','hn','Colon',2999.0,-86.07,15.63).
city('Agua Dulcita','hn','Comayagua',1017.0,-87.75,14.7).
city('Aguas del Padre','hn','Comayagua',1104.0,-87.88,14.57).
city('Ajuterique','hn','Comayagua',5354.0,-87.7,14.38).
city('Cerro Blanco','hn','Comayagua',1169.0,-87.78,14.67).
city('Comayagua','hn','Comayagua',58791.0,-87.65,14.46).
city('Concepcion de Guasistagua','hn','Comayagua',1470.0,-87.65,14.6).
city('El Buen Pastor','hn','Comayagua',942.0,-87.78,14.87).
city('El Porvenir','hn','Comayagua',1337.0,-87.88,14.59).
city('El Rincon','hn','Comayagua',1522.0,-87.93,14.58).
city('El Rosario','hn','Comayagua',2575.0,-87.77,14.8).
city('El Sauce','hn','Comayagua',1389.0,-87.67,14.53).
city('El Socorro','hn','Comayagua',1092.0,-87.92,14.64).
city('Esquias','hn','Comayagua',1339.0,-87.37,14.73).
city('Flores','hn','Comayagua',3018.0,-87.57,14.28).
city('Jamalteca','hn','Comayagua',1107.0,-87.58,14.7).
city('Jardines','hn','Comayagua',953.0,-87.98,14.7).
city('La Libertad','hn','Comayagua',4673.0,-87.62,14.75).
city('La Trinidad','hn','Comayagua',880.0,-87.67,14.72).
city('Lamani','hn','Comayagua',1791.0,-87.62,14.2).
city('Las Conchas','hn','Comayagua',1084.0,-87.4,13.32).
city('Las Lajas','hn','Comayagua',3011.0,-87.75,14.78).
city('Las Mercedes','hn','Comayagua',1000.0,-87.57,14.29).
city('Lejamani','hn','Comayagua',3835.0,-87.7,14.37).
city('Meambar','hn','Comayagua',902.0,-87.77,14.78).
city('Minas de Oro','hn','Comayagua',3554.0,-87.35,14.8).
city('Ojos de Agua','hn','Comayagua',1146.0,-87.94,14.6).
city('Palo Pintado','hn','Comayagua',909.0,-87.68,14.52).
city('Potrerillos','hn','Comayagua',1334.0,-87.87,14.55).
city('Rancho Grande','hn','Comayagua',1484.0,-87.5,14.68).
city('Rio Bonito','hn','Comayagua',1054.0,-87.88,14.77).
city('San Antonio de La Cuesta','hn','Comayagua',1033.0,-87.58,14.63).
city('San Jeronimo','hn','Comayagua',1789.0,-87.6,14.63).
city('San Jose de Comayagua','hn','Comayagua',1066.0,-88.03,14.73).
city('San Jose de Pane','hn','Comayagua',958.0,-87.83,14.48).
city('San Jose del Potrero','hn','Comayagua',1091.0,-87.29,14.83).
city('San Luis','hn','Comayagua',1967.0,-87.42,14.75).
city('San Nicolas','hn','Comayagua',976.0,-87.35,14.72).
city('San Sebastian','hn','Comayagua',1471.0,-87.63,14.25).
city('Siguatepeque','hn','Comayagua',43146.0,-87.84,14.6).
city('Taulabe','hn','Comayagua',4660.0,-87.97,14.7).
city('Valle de Angeles','hn','Comayagua',1101.0,-87.63,14.5).
city('Villa de San Antonio','hn','Comayagua',5390.0,-87.62,14.32).
city('Agua Caliente','hn','Copan',1075.0,-88.82,14.88).
city('Bodega de Los Tangos','hn','Copan',953.0,-87.22,13.93).
city('Buenos Aires','hn','Copan',1131.0,-88.97,15.03).
city('Chalmeca','hn','Copan',2008.0,-88.68,15.1).
city('Concepcion de La Barranca','hn','Copan',1014.0,-88.72,15.17).
city('Copan','hn','Copan',6337.0,-89.15,14.82).
city('Corquin','hn','Copan',4753.0,-88.87,14.57).
city('Cucuyagua','hn','Copan',2939.0,-88.87,14.65).
city('Dolores','hn','Copan',1107.0,-88.84,14.87).
city('Dulce Nombre','hn','Copan',3590.0,-88.84,14.85).
city('El Corpus','hn','Copan',1193.0,-88.92,14.7).
city('El Derrumbo','hn','Copan',929.0,-88.78,14.75).
city('El Ocoton','hn','Copan',1038.0,-88.88,15.03).
city('El Paraiso','hn','Copan',4126.0,-88.78,14.48).
city('Florida','hn','Copan',5340.0,-88.83,15.03).
city('La Entrada','hn','Copan',14705.0,-88.73,15.05).
city('La Esperanza','hn','Copan',919.0,-89.1,15.05).
city('La Jigua','hn','Copan',971.0,-88.8,15.04).
city('La Playona','hn','Copan',1285.0,-88.98,15.12).
city('La Zumbadora','hn','Copan',1086.0,-88.9,15.02).
city('Los Arroyos','hn','Copan',916.0,-88.89,14.65).
city('Los Tangos','hn','Copan',1424.0,-88.68,15.15).
city('Nueva Armenia','hn','Copan',875.0,-89.11,15.04).
city('Ojos de Agua','hn','Copan',1340.0,-88.82,14.7).
city('Ostuman','hn','Copan',862.0,-89.17,14.83).
city('Pueblo Nuevo','hn','Copan',1053.0,-88.75,15.0).
city('Quezailica','hn','Copan',1115.0,-88.73,14.88).
city('Rio Amarillo','hn','Copan',1000.0,-89.14,14.97).
city('San Agustin','hn','Copan',1777.0,-88.94,14.82).
city('San Antonio','hn','Copan',1638.0,-88.59,14.43).
city('San Jeronimo','hn','Copan',1046.0,-88.87,14.97).
city('San Joaquin','hn','Copan',1130.0,-88.9,15.05).
city('San Jose','hn','Copan',1789.0,-88.72,14.9).
city('San Juan de Opoa','hn','Copan',1636.0,-88.7,14.78).
city('San Juan de Planes','hn','Copan',1048.0,-88.78,14.93).
city('San Nicolas','hn','Copan',2231.0,-88.73,15.0).
city('Santa Cruz','hn','Copan',863.0,-88.99,14.75).
city('Santa Rita','hn','Copan',2704.0,-89.1,14.0).
city('Santa Rosa de Copan','hn','Copan',27756.0,-88.78,14.77).
city('Trinidad de Copan','hn','Copan',2232.0,-88.75,14.95).
city('Veracruz','hn','Copan',1045.0,-88.78,14.92).
city('Vivistorio','hn','Copan',949.0,-88.74,14.9).
city('Achiotal','hn','Cortes',1210.0,-88.75,14.08).
city('Agua Azul Rancho','hn','Cortes',1043.0,-87.95,14.9).
city('Agua Azul Sierra','hn','Cortes',1079.0,-87.97,14.92).
city('Armenta','hn','Cortes',2989.0,-88.05,15.5).
city('Bajamar','hn','Cortes',1064.0,-87.85,15.88).
city('Baracoa','hn','Cortes',9202.0,-87.85,15.77).
city('Bejuco','hn','Cortes',1276.0,-87.93,15.13).
city('Brisas del Calan','hn','Cortes',2217.0,-87.93,14.92).
city('Buenos Aires','hn','Cortes',979.0,-88.18,15.49).
city('Canaveral','hn','Cortes',2137.0,-88.02,14.98).
city('Casa Quemada','hn','Cortes',3036.0,-88.09,15.12).
city('Chivana','hn','Cortes',1018.0,-87.98,15.75).
city('Choloma','hn','Cortes',139117.0,-87.96,15.61).
city('Chotepe','hn','Cortes',1564.0,-87.98,15.42).
city('Cofradia','hn','Cortes',20353.0,-88.15,15.4).
city('Corinto','hn','Cortes',954.0,-88.37,15.58).
city('Cuyamel','hn','Cortes',5022.0,-88.2,15.66).
city('El Eden','hn','Cortes',954.0,-88.02,14.95).
city('El Higuero','hn','Cortes',1052.0,-87.72,14.57).
city('El Llano','hn','Cortes',1923.0,-87.88,15.15).
city('El Maranon','hn','Cortes',1836.0,-88.05,15.4).
city('El Milagro','hn','Cortes',1916.0,-87.97,15.4).
city('El Ocotillo','hn','Cortes',4735.0,-87.93,14.95).
city('El Olivar','hn','Cortes',1279.0,-87.88,15.08).
city('El Perico','hn','Cortes',1141.0,-88.09,15.09).
city('El Plan','hn','Cortes',2176.0,-87.97,15.28).
city('El Porvenir','hn','Cortes',2940.0,-87.93,15.83).
city('El Rancho','hn','Cortes',1101.0,-87.95,15.67).
city('El Tigre','hn','Cortes',1435.0,-87.99,14.94).
city('El Zapote','hn','Cortes',970.0,-87.85,15.02).
city('Kilometro Setenta y Uno','hn','Cortes',1549.0,-88.02,15.38).
city('La Bueso','hn','Cortes',1139.0,-87.88,15.58).
city('La Campana','hn','Cortes',2268.0,-87.4,13.88).
city('La Esperanza','hn','Cortes',985.0,-88.18,15.41).
city('La Guama','hn','Cortes',1242.0,-87.94,14.88).
city('La Jutosa','hn','Cortes',4183.0,-88.0,15.63).
city('La Lima','hn','Cortes',45962.0,-87.93,15.43).
city('La Sabana','hn','Cortes',1524.0,-87.93,15.37).
city('Los Caminos','hn','Cortes',1146.0,-87.97,14.95).
city('Los Naranjos','hn','Cortes',1684.0,-88.04,14.93).
city('Monterrey','hn','Cortes',2234.0,-87.89,15.58).
city('Naco','hn','Cortes',3966.0,-88.18,15.38).
city('Nueva Granada','hn','Cortes',939.0,-88.1,15.12).
city('Nuevo Chamelecon','hn','Cortes',2098.0,-88.01,15.38).
city('Omoa','hn','Cortes',4763.0,-88.03,15.77).
city('Oropendolas','hn','Cortes',1333.0,-87.94,15.02).
city('Pena Blanca','hn','Cortes',3552.0,-88.05,15.54).
city('Pimienta','hn','Cortes',8761.0,-87.97,15.24).
city('Potrerillos','hn','Cortes',8405.0,-88.13,15.43).
city('Pueblo Nuevo','hn','Cortes',3556.0,-88.02,15.28).
city('Puente Alto','hn','Cortes',1385.0,-87.87,15.7).
city('Puerto Cortes','hn','Cortes',48020.0,-87.94,15.85).
city('Quebrada Seca','hn','Cortes',2248.0,-87.94,15.67).
city('Rio Blanquito','hn','Cortes',2458.0,-87.9,15.73).
city('Rio Chiquito','hn','Cortes',1405.0,-88.25,15.63).
city('Rio Lindo','hn','Cortes',3479.0,-87.98,15.03).
city('San Antonio de Cortes','hn','Cortes',4955.0,-88.03,15.12).
city('San Buenaventura','hn','Cortes',1452.0,-88.0,15.02).
city('San Francisco de Yojoa','hn','Cortes',1946.0,-87.97,15.02).
city('San Jose de Cortes','hn','Cortes',1601.0,-87.9,14.92).
city('San Jose del Boqueron','hn','Cortes',1432.0,-87.87,15.48).
city('San Manuel','hn','Cortes',6389.0,-87.92,15.33).
city('San Pedro Sula','hn','Cortes',489506.0,-88.03,15.47).
city('Santa Cruz de Yojoa','hn','Cortes',10230.0,-87.9,14.98).
city('Santa Elena','hn','Cortes',1361.0,-88.14,15.38).
city('Sapadril Abajo','hn','Cortes',1001.0,-87.88,15.77).
city('Tegucigalpita','hn','Cortes',2737.0,-88.24,15.63).
city('Travesia','hn','Cortes',1283.0,-87.89,15.86).
city('Villanueva','hn','Cortes',31570.0,-87.99,15.31).
city('Yojoa','hn','Cortes',3095.0,-87.94,14.9).
city('Zapotal del Norte','hn','Cortes',2507.0,-88.05,15.52).
city('Tegucigalpa','hn','Distrito Central',850961.0,-87.22,14.09).
city('Arauli','hn','El Paraiso',1160.0,-86.55,13.95).
city('Chirinos','hn','El Paraiso',921.0,-86.58,15.4).
city('Cuyali','hn','El Paraiso',1572.0,-86.55,13.88).
city('Danli','hn','El Paraiso',44805.0,-86.58,14.04).
city('El Benque','hn','El Paraiso',1101.0,-86.47,14.03).
city('El Chichicaste','hn','El Paraiso',1671.0,-86.3,14.07).
city('El Obraje','hn','El Paraiso',1703.0,-86.43,14.0).
city('El Paraiso','hn','El Paraiso',18782.0,-86.56,13.86).
city('El Pescadero','hn','El Paraiso',909.0,-86.55,13.93).
city('El Rodeo','hn','El Paraiso',893.0,-86.6,14.28).
city('Gueinope','hn','El Paraiso',2716.0,-86.93,13.88).
city('Jacaleapa','hn','El Paraiso',2578.0,-86.67,14.02).
city('Jutiapa','hn','El Paraiso',1153.0,-86.4,13.98).
city('Las Animas','hn','El Paraiso',1117.0,-86.57,14.25).
city('Liure','hn','El Paraiso',1022.0,-87.08,13.53).
city('Mandasta','hn','El Paraiso',940.0,-86.92,13.73).
city('Moroceli','hn','El Paraiso',2984.0,-86.87,14.12).
city('Ojo de Agua','hn','El Paraiso',2330.0,-86.35,14.02).
city('Oropoli','hn','El Paraiso',1412.0,-86.82,13.82).
city('Quebrada Larga','hn','El Paraiso',1217.0,-86.37,14.1).
city('San Diego','hn','El Paraiso',1306.0,-86.47,14.05).
city('San Lucas','hn','El Paraiso',1307.0,-86.95,13.74).
city('San Matias','hn','El Paraiso',1251.0,-86.64,13.98).
city('Santa Cruz','hn','El Paraiso',1430.0,-86.63,13.86).
city('Teupasenti','hn','El Paraiso',4208.0,-86.7,14.22).
city('Texiguat','hn','El Paraiso',1012.0,-87.02,13.65).
city('Trojes','hn','El Paraiso',6253.0,-85.99,14.06).
city('Yuscaran','hn','El Paraiso',2371.0,-86.85,13.94).
city('Agalteca','hn','Francisco Morazan',1029.0,-87.27,14.45).
city('Alubaren','hn','Francisco Morazan',983.0,-87.47,13.8).
city('Cedros','hn','Francisco Morazan',1041.0,-87.12,14.6).
city('Cerro Grande','hn','Francisco Morazan',1093.0,-87.25,13.82).
city('Cofradia','hn','Francisco Morazan',1301.0,-87.19,14.22).
city('El Chimbo','hn','Francisco Morazan',1145.0,-87.12,14.13).
city('El Durazno','hn','Francisco Morazan',923.0,-87.27,14.13).
city('El Escanito','hn','Francisco Morazan',1184.0,-87.1,14.67).
city('El Escano de Tepale','hn','Francisco Morazan',1026.0,-87.07,14.75).
city('El Guante','hn','Francisco Morazan',1082.0,-87.1,14.55).
city('El Guantillo','hn','Francisco Morazan',1223.0,-87.3,14.6).
city('El Jicarito','hn','Francisco Morazan',3527.0,-87.09,14.25).
city('El Lolo','hn','Francisco Morazan',1438.0,-87.27,14.12).
city('El Pedernal','hn','Francisco Morazan',1648.0,-87.12,14.7).
city('El Porvenir','hn','Francisco Morazan',3153.0,-87.35,13.75).
city('El Suyatal','hn','Francisco Morazan',2027.0,-87.22,14.52).
city('El Tablon','hn','Francisco Morazan',1121.0,-87.17,14.03).
city('El Terrero','hn','Francisco Morazan',1087.0,-87.07,14.07).
city('El Tizatillo','hn','Francisco Morazan',798.0,-87.23,14.0).
city('Germania','hn','Francisco Morazan',1157.0,-87.98,14.57).
city('Guaimaca','hn','Francisco Morazan',12901.0,-86.82,14.53).
city('Guatemalita','hn','Francisco Morazan',950.0,-88.62,14.12).
city('La Cuesta Dos','hn','Francisco Morazan',1740.0,-87.25,14.12).
city('La Ermita','hn','Francisco Morazan',2495.0,-87.07,14.47).
city('Las Tapias','hn','Francisco Morazan',814.0,-87.28,14.07).
city('Lepaterique','hn','Francisco',2090.0,-87.46,14.06).
city('Marale','hn','Francisco Morazan',1523.0,-87.15,14.88).
city('Mata de Platano','hn','Francisco Morazan',1151.0,-87.28,14.6).
city('Mateo','hn','Francisco Morazan',1021.0,-87.32,14.08).
city('Ojojona','hn','Francisco Morazan',2790.0,-87.3,13.94).
city('Orica','hn','Francisco Morazan',2342.0,-86.95,14.7).
city('Pueblo Nuevo','hn','Francisco Morazan',958.0,-87.29,14.39).
city('Reitoca','hn','Francisco Morazan',1094.0,-87.47,13.82).
city('Rio Abajo','hn','Francisco Morazan',2055.0,-87.22,14.17).
city('Sabanagrande','hn','Francisco Mo',2056.0,-87.27,13.8).
city('San Francisco','hn','Francisco Morazan',1030.0,-86.95,14.18).
city('San Ignacio','hn','Francisco Morazan',2330.0,-87.03,14.65).
city('San Juan de Flores','hn','Francisco Morazan',3633.0,-87.03,14.27).
city('San Juancito','hn','Francisco Morazan',895.0,-87.07,14.23).
city('Santa Ana','hn','Francisco Morazan',1052.0,-87.27,13.93).
city('Santa Lucia','hn','Francisco Morazan',2288.0,-87.12,14.11).
city('Talanga','hn','Francisco Morazan',13492.0,-87.09,14.4).
city('Tamara','hn','Francisco Morazan',2683.0,-87.34,14.15).
city('Trinidad de Quebradas','hn','Francisco Morazan',1405.0,-87.35,14.5).
city('Urrutia','hn','Francisco Morazan',799.0,-87.04,14.75).
city('Valle de Angeles','hn','Francisco Morazan',4649.0,-87.03,14.15).
city('Vallecillo','hn','Francisco Morazan',1986.0,-87.4,14.51).
city('Villa Nueva','hn','Francisco Morazan',2295.0,-87.14,14.02).
city('Villa de San Francisco','hn','Francisco Morazan',5914.0,-86.97,14.17).
city('Yaguacire','hn','Francisco Morazan',1449.0,-87.22,14.02).
city('Zambrano','hn','Francisco Morazan',3873.0,-87.4,14.27).
city('Ahuas','hn','Gracias a Dios',1505.0,-84.33,15.48).
city('Auka','hn','Gracias a Dios',1254.0,-83.83,14.93).
city('Barra Patuca','hn','Gracias a Dios',2759.0,-84.28,15.8).
city('Brus Laguna','hn','Gracias a Dios',4067.0,-84.48,15.75).
city('Iralaya','hn','Gracias a Dios',1520.0,-83.23,15.0).
city('Palkaka','hn','Gracias a Dios',909.0,-83.87,15.32).
city('Paptalaya','hn','Gracias a Dios',1227.0,-84.32,15.5).
city('Puerto Lempira','hn','Gracias a Dios',4857.0,-83.79,15.26).
city('Tikiuraya','hn','Gracias a Dios',925.0,-83.63,15.02).
city('Waksma','hn','Gracias a Dios',969.0,-84.4,15.43).
city('Wampusirpi','hn','Gra',1462.0,-84.61,15.2).
city('Wawina','hn','Gracias a Dios',1481.0,-84.43,15.42).
city('Azacualpa','hn','Intibuca',966.0,-88.38,14.27).
city('Camasca','hn','Intibuca',1150.0,-88.38,14.0).
city('Intibuca','hn','Intibuca',13743.0,-88.17,14.32).
city('Jesus de Otoro','hn','Intibuca',6988.0,-87.98,14.48).
city('Jiquinlaca','hn','Intibuca',1248.0,-88.35,14.0).
city('La Esperanza','hn','Intibuca',5319.0,-88.18,14.31).
city('Magdalena','hn','Intibuca',966.0,-88.32,13.89).
city('Yamaranguila','hn','Intibuca',1187.0,-88.25,14.28).
city('French Harbor','hn','Islas de la Bahia',2698.0,-86.43,16.37).
city('Guanaja','hn','Islas de la Bahia',1942.0,-85.88,16.43).
city('Jose Santos Guardiola','hn','Islas de la Bahia',2768.0,-86.37,16.4).
city('Monte Placentero','hn','Islas de la Bahia',3928.0,-86.47,16.36).
city('Roatan','hn','Islas de la Bahia',7515.0,-86.52,16.33).
city('Sandy Bay','hn','Islas de la Bahia',1072.0,-86.58,16.34).
city('Savannah Bight','hn','Islas de la Bahia',1031.0,-85.88,16.48).
city('Utila','hn','Islas de la Bahia',1834.0,-86.35,15.65).
city('Cane','hn','La Paz',2190.0,-87.67,14.28).
city('La Florida','hn','La Paz',899.0,-87.99,14.07).
city('La Paz','hn','La Paz',17557.0,-87.69,14.32).
city('Los Planes','hn','La Paz',1320.0,-88.02,14.05).
city('Marcala','hn','La Paz',10055.0,-88.04,14.15).
city('San Antonio del Norte','hn','La Paz',1002.0,-87.7,13.89).
city('San Jose','hn','La Paz',1463.0,-87.96,14.24).
city('San Pedro de Tutule','hn','La Paz',1876.0,-87.85,14.25).
city('Santiago de Puringla','hn','La Paz',2433.0,-87.9,14.35).
city('Tepanguare','hn','La Paz',1040.0,-87.75,14.33).
city('Yarumela','hn','La Paz',3059.0,-87.63,14.33).
city('Cololaca','hn','Lempira',1014.0,-88.88,14.3).
city('Erandique','hn','Lempira',1882.0,-88.47,14.23).
city('Gracias','hn','Lempira',7910.0,-88.58,14.59).
city('La Laguna del Pedernal','hn','Lempira',888.0,-88.57,14.82).
city('La Libertad','hn','Lempira',1444.0,-88.58,14.8).
city('La Union','hn','Lempira',3054.0,-88.41,14.82).
city('La Virtud','hn','Lempira',1315.0,-88.7,14.05).
city('Lagunas','hn','Lempira',986.0,-88.49,14.62).
city('Las Tejeras','hn','Lempira',1140.0,-88.6,14.8).
city('Lepaera','hn','Lempira',3137.0,-88.58,14.78).
city('Taragual','hn','Lempira',1043.0,-88.48,14.75).
city('Antigua Ocotepeque','hn','Ocotepeque',1862.0,-89.2,14.4).
city('Belen Gualcho','hn','Ocotepeque',2359.0,-88.8,14.48).
city('El Granzal','hn','Ocotepeque',876.0,-88.87,14.4).
city('El Transito','hn','Ocotepeque',1025.0,-88.92,14.38).
city('La Encarnacion','hn','Ocotepeque',1484.0,-89.09,14.67).
city('La Labor','hn','Ocotepeque',1416.0,-89.0,14.48).
city('Llano Largo','hn','Ocotepeque',910.0,-89.02,14.47).
city('Lucerna','hn','Ocotepeque',1452.0,-88.93,14.55).
city('Mercedes','hn','Ocotepeque',984.0,-89.15,14.43).
city('Ocotepeque','hn','Ocotepeque',8781.0,-89.18,14.44).
city('San Antonio','hn','Ocotepeque',962.0,-88.97,14.52).
city('San Fernando','hn','Ocotepeque',1026.0,-89.12,14.69).
city('San Francisco de Cones','hn','Ocotepeque',1066.0,-88.9,14.52).
city('San Francisco del Valle','hn','Ocotepeque',1878.0,-88.95,14.43).
city('San Marcos','hn','Ocotepeque',5346.0,-88.95,14.4).
city('Santa Fe','hn','Ocotepeque',915.0,-89.24,14.52).
city('Santa Lucia','hn','Ocotepeque',1224.0,-89.2,14.41).
city('Santa Teresa','hn','Ocotepeque',914.0,-89.0,14.38).
city('Sensenti','hn','Ocotepeque',1551.0,-88.94,14.48).
city('Sinuapa','hn','Ocotepeque',2389.0,-89.18,14.45).
city('Yaruchel','hn','Ocotepeque',1105.0,-88.82,14.53).
city('Arimis','hn','Olancho',1817.0,-86.0,14.78).
city('Campamento','hn','Olancho',6560.0,-86.65,14.55).
city('Catacamas','hn','Olancho',33052.0,-85.89,14.85).
city('Concordia','hn','Olancho',1272.0,-86.65,14.62).
city('Dulce Nombre de Culmi','hn','Olancho',2091.0,-85.53,15.1).
city('El Guayabito','hn','Olancho',1404.0,-86.03,14.83).
city('El Rosario','hn','Olancho',962.0,-86.68,14.9).
city('El Rusio','hn','Olancho',1016.0,-86.37,14.47).
city('Froylan Turcios','hn','Olancho',2907.0,-86.04,14.44).
city('Gualaco','hn','Olancho',3601.0,-86.05,15.05).
city('Guarizama','hn','Olancho',1300.0,-86.33,14.92).
city('Guata','hn','Olancho',1217.0,-86.38,15.08).
city('Guayape','hn','Olancho',1703.0,-86.83,14.72).
city('Juticalpa','hn','Olancho',33690.0,-86.23,14.67).
city('Jutiquile','hn','Olancho',3585.0,-86.08,14.72).
city('La Concepcion','hn','Olancho',1985.0,-86.24,14.7).
city('La Empalizada','hn','Olancho',933.0,-86.13,14.65).
city('La Estancia','hn','Olancho',1508.0,-86.35,15.05).
city('Laguna Seca','hn','Olancho',1131.0,-86.1,14.7).
city('Mangulile','hn','Olancho',1263.0,-86.8,15.07).
city('Manto','hn','Olancho',1098.0,-86.38,14.92).
city('Punuare','hn','Olancho',1905.0,-85.97,14.73).
city('Sabana Abajo','hn','Olancho',884.0,-86.59,14.6).
city('Salama','hn','Olancho',2820.0,-86.58,14.83).
city('San Esteban','hn','Olancho',3439.0,-85.75,15.2).
city('San Francisco de Becerra','hn','Olancho',2411.0,-86.1,14.63).
city('San Francisco de La Paz','hn','Olancho',5411.0,-86.2,14.9).
city('San Jose de Rio Tinto','hn','Olancho',1071.0,-85.7,14.93).
city('San Nicolas','hn','Olancho',1313.0,-86.25,14.55).
city('Santa Cruz de Guayape','hn','Olancho',2743.0,-86.89,14.76).
city('Santa Maria del Real','hn','Olancho',4587.0,-85.95,14.77).
city('Silca','hn','Olancho',1112.0,-86.53,14.83).
city('Zopilotepe','hn','Olancho',1300.0,-86.27,14.6).
city('Agualote','hn','Santa Barbara',1759.0,-88.55,15.33).
city('Arada','hn','Santa Barbara',2913.0,-88.3,14.85).
city('Atima','hn','Santa Barbara',1703.0,-88.48,14.93).
city('Azacualpa','hn','Santa Barbara',3604.0,-88.31,15.03).
city('Berlin','hn','Santa Barbara',1050.0,-88.5,14.83).
city('Callejones','hn','Santa Barbara',1033.0,-88.65,15.17).
city('Camalote','hn','Santa Barbara',1319.0,-88.33,15.33).
city('Casa Quemada','hn','Santa Barbara',1030.0,-88.55,15.27).
city('Ceguaca','hn','Santa Barbara',1239.0,-88.2,14.8).
city('Chiquila','hn','Santa Barbara',983.0,-88.58,15.23).
city('Concepcion del Norte','hn','Santa Barbara',946.0,-88.13,15.17).
city('Concepcion del Sur','hn','Santa Barbara',1049.0,-88.17,14.8).
city('Correderos','hn','Santa Barbara',1162.0,-88.45,15.42).
city('El Ciruelo','hn','Santa Barbara',2980.0,-88.5,15.3).
city('El Corozal','hn','Santa Barbara',1039.0,-88.62,15.07).
city('El Ermitano','hn','Santa Barbara',947.0,-88.68,15.25).
city('El Mochito','hn','Santa Barbara',1950.0,-88.08,14.87).
city('El Nisp','hn','Santa Barbara',2474.0,-88.34,14.77).
city('Guacamaya','hn','Santa Barbara',1250.0,-88.15,15.02).
city('Gualjoco','hn','Santa Barbara',1432.0,-88.23,14.95).
city('Ilama','hn','Santa Barbara',1811.0,-88.22,15.07).
city('Joconal','hn','Santa Barbara',1206.0,-88.63,15.35).
city('La Flecha','hn','Santa Barbara',2136.0,-88.48,15.28).
city('La Reina','hn','Santa Barbara',954.0,-88.63,15.12).
city('La Union','hn','Santa Barbara',827.0,-88.56,15.11).
city('Laguna Verde','hn','Santa Barbara',1460.0,-88.17,15.2).
city('Las Vegas','hn','Santa Barbara',7487.0,-88.07,14.87).
city('Loma Alta','hn','Santa Barbara',1067.0,-88.57,15.4).
city('Macholoa','hn','Santa Barbara',989.0,-88.3,14.92).
city('Macuelizo','hn','Santa Barbara',2867.0,-88.56,15.34).
city('Naranjito','hn','Santa Barbara',3814.0,-88.69,14.95).
city('Nuevo Celilac','hn','Santa Barbara',950.0,-88.33,14.98).
city('Nuevo Jalapa','hn','Santa Barbara',1094.0,-88.33,14.92).
city('Petoa','hn','Santa Barbara',1067.0,-88.28,15.27).
city('Pinalejo','hn','Santa Barbara',3767.0,-88.4,15.39).
city('Potrerillos','hn','Santa Barbara',900.0,-88.43,15.27).
city('Proteccion','hn','Santa Barbara',2101.0,-88.65,15.03).
city('Quimistan','hn','Santa Barbara',3517.0,-88.4,15.35).
city('San Francisco de Ojuera','hn','Santa Barbara',853.0,-88.18,14.75).
city('San Jose de Colinas','hn','Santa Barbara',3985.0,-88.3,15.03).
city('San Jose de Oriente','hn','Santa Barbara',888.0,-88.12,15.03).
city('San Jose de Tarros','hn','Santa Barbara',1634.0,-88.7,15.3).
city('San Luis','hn','Santa Barbara',5733.0,-88.38,15.08).
city('San Luis de Planes','hn','Santa Barbara',1111.0,-88.13,14.98).
city('San Marcos','hn','Santa Barbara',3924.0,-88.42,15.3).
city('San Nicolas','hn','Santa Barbara',3523.0,-88.32,14.93).
city('San Pedro Zacapa','hn','Santa Barbara',1065.0,-88.12,14.75).
city('San Vicente Centenario','hn','Santa Barbara',2430.0,-88.28,14.88).
city('Santa Barbara','hn','Santa Barbara',15121.0,-88.24,14.92).
city('Santa Cruz','hn','Santa Barbara',834.0,-88.3,15.34).
city('Santa Rita','hn','Santa Barbara',1687.0,-88.22,14.92).
city('Sula','hn','Santa Barbara',2502.0,-88.57,15.25).
city('Trascerros','hn','Santa Barbara',4174.0,-88.67,15.3).
city('Trinidad','hn','Santa Barbar',4276.0,-88.24,15.13).
city('Agua Fria','hn','Valle',3196.0,-87.55,13.45).
city('Amapala','hn','Valle',2137.0,-87.65,13.27).
city('Aramecina','hn','Valle',1071.0,-87.72,13.75).
city('Cubulero','hn','Valle',1286.0,-87.68,13.48).
city('El Caimito','hn','Valle',832.0,-87.38,13.45).
city('El Guayabo','hn','Valle',889.0,-87.43,13.48).
city('El Tular','hn','Valle',1927.0,-87.52,13.45).
city('Goascoran','hn','Valle',1350.0,-87.62,13.58).
city('Jicaro Galan','hn','Valle',1370.0,-87.44,13.5).
city('La Criba','hn','Valle',1001.0,-87.42,13.45).
city('Langue','hn','Valle',3680.0,-87.65,13.62).
city('Nacaome','hn','Valle',13931.0,-87.49,13.53).
city('San Francisco de Coray','hn','Valle',1330.0,-87.53,13.65).
city('San Lorenzo','hn','Valle',22291.0,-87.45,13.42).
city('Agua Blanca Sur','hn','Yoro',7592.0,-87.88,15.25).
city('Arenal','hn','Yoro',1722.0,-86.83,15.35).
city('Armenia','hn','Yoro',1488.0,-86.37,15.47).
city('Ayapa','hn','Yoro',1559.0,-87.15,15.1).
city('Balsamo Oriental','hn','Yoro',1465.0,-86.33,15.48).
city('Buenos Aires','hn','Yoro',980.0,-86.4,15.47).
city('Carbajales','hn','Yoro',1102.0,-86.35,15.52).
city('Coyoles','hn','Yoro',949.0,-86.68,15.47).
city('Coyoles Central','hn','Yoro',1144.0,-86.67,15.4).
city('El Balsamo','hn','Yoro',1741.0,-87.47,15.07).
city('El Carril','hn','Yoro',2944.0,-86.67,15.47).
city('El Jocomico','hn','Yoro',1033.0,-87.77,15.28).
city('El Juncal','hn','Yoro',1286.0,-86.43,15.45).
city('El Negrito','hn','Yoro',9304.0,-87.71,15.31).
city('El Ocote','hn','Yoro',1908.0,-86.57,15.42).
city('El Progreso','hn','Yoro',100821.0,-87.82,15.4).
city('Guaymitas','hn','Yoro',2321.0,-87.72,15.5).
city('Jocon','hn','Yoro',1731.0,-86.97,15.28).
city('La Colorada','hn','Yoro',979.0,-86.82,15.62).
city('La Curva','hn','Yoro',981.0,-85.77,15.8).
city('La Estancia','hn','Yoro',1668.0,-87.55,15.29).
city('La Guacamaya','hn','Yoro',2525.0,-87.8,15.25).
city('La Mina','hn','Yoro',2690.0,-87.83,15.32).
city('La Rosa','hn','Yoro',1552.0,-87.07,15.35).
city('La Sarrosa','hn','Yoro',2188.0,-87.83,15.23).
city('La Trinidad','hn','Yoro',1314.0,-87.2,15.1).
city('Las Delicias','hn','Yoro',1326.0,-87.62,14.72).
city('Las Vegas','hn','Yoro',1308.0,-87.45,15.02).
city('Lomitas','hn','Yoro',1552.0,-87.22,15.1).
city('Mojiman','hn','Yoro',1498.0,-87.6,15.27).
city('Morazan','hn','Yoro',11077.0,-87.61,15.32).
city('Nombre de Jesus','hn','Yoro',1250.0,-86.68,15.35).
city('Nueva Esperanza','hn','Yoro',2121.0,-87.59,15.27).
city('Nueva Florida','hn','Yoro',904.0,-87.5,15.47).
city('Ocote Paulino','hn','Yoro',1697.0,-87.6,15.42).
city('Olanchito','hn','Yoro',25972.0,-86.58,15.48).
city('Portillo de Gonzalez','hn','Yoro',958.0,-87.6,15.28).
city('Punta Ocote','hn','Yoro',1399.0,-87.28,15.2).
city('Quebrada de Yoro','hn','Yoro',896.0,-87.78,15.43).
city('San Antonio','hn','Yoro',1711.0,-87.15,15.33).
city('San Jose','hn','Yoro',1897.0,-87.15,15.32).
city('Santa Rita','hn','Yoro',12871.0,-87.28,15.17).
city('Subirana','hn','Yoro',1362.0,-87.45,15.2).
city('Sulaco','hn','Yoro',2760.0,-87.27,14.92).
city('Teguajinal','hn','Yoro',1117.0,-86.6,15.37).
city('Tepusteca','hn','Yoro',1638.0,-86.32,15.42).
city('Toyos','hn','Yoro',2530.0,-87.66,15.53).
city('Trojas','hn','Yoro',1068.0,-86.7,15.35).
city('Urraco','hn','Yoro',5711.0,-87.77,15.5).
city('Victoria','hn','Yoro',2884.0,-87.82,15.49).
city('Yorito','hn','Yoro',2169.0,-87.28,15.07).
city('Yoro','hn','Yoro',15776.0,-87.13,15.13).
city('Agasegyhaza','hu','Bacs-Kiskun',1898.0,19.45,46.84).
city('Akaszto','hu','Bacs-Kiskun',3480.0,19.2,46.69).
city('Bacsalmas','hu','Bacs-Kiskun',7608.0,19.33,46.13).
city('Bacsbokod','hu','Bacs-Kiskun',3077.0,19.16,46.12).
city('Baja','hu','Bacs-Kiskun',37714.0,18.95,46.18).
city('Balloszoeg','hu','Bacs-Kiskun',2753.0,19.59,46.86).
city('Batya','hu','Bacs-Kiskun',2190.0,18.96,46.48).
city('Bugac','hu','Bacs-Kiskun',3066.0,19.69,46.69).
city('Csaszartoeltes','hu','Bacs-Kiskun',2649.0,19.19,46.44).
city('Csavoly','hu','Bacs-Kiskun',2080.0,19.15,46.2).
city('Csengod','hu','Bacs-Kiskun',2291.0,19.26,46.71).
city('Davod','hu','Bacs-Kiskun',2240.0,18.91,46.0).
city('Dunapataj','hu','Bacs-Kiskun',3693.0,18.99,46.64).
city('Dunavecse','hu','Bacs-Kiskun',4201.0,18.98,46.92).
city('Dusnok','hu','Bacs-Kiskun',3284.0,18.97,46.38).
city('Ersekcsanad','hu','Bacs-Kiskun',2863.0,18.98,46.25).
city('Felsoszentivan','hu','Bacs-Kiskun',1998.0,19.2,46.19).
city('Fueloepszallas','hu','Bacs-Kiskun',2503.0,19.23,46.83).
city('Gara','hu','Bacs-Kiskun',2656.0,19.04,46.03).
city('Hajos','hu','Bacs-Kiskun',3520.0,19.11,46.4).
city('Harta','hu','Bacs-Kiskun',3716.0,19.03,46.7).
city('Helvecia','hu','Bacs-Kiskun',3918.0,19.63,46.83).
city('Hercegszanto','hu','Bacs-Kiskun',2308.0,18.94,45.94).
city('Izsak','hu','Bacs-Kiskun',6117.0,19.36,46.8).
city('Jakabszallas','hu','Bacs-Kiskun',2604.0,19.73,46.73).
city('Janoshalma','hu','Bacs-Kiskun',9755.0,19.32,46.3).
city('Jaszszentlaszlo','hu','Bacs-Kiskun',2602.0,19.76,46.56).
city('Kalocsa','hu','Bacs-Kiskun',18242.0,18.99,46.52).
city('Katymar','hu','Bacs-Kiskun',2374.0,19.21,46.03).
city('Kecel','hu','Bacs-Kiskun',9155.0,19.24,46.53).
city('Kecskemet','hu','Bacs-Kiskun',106062.0,19.69,46.91).
city('Kelebia','hu','Bacs-Kiskun',2985.0,19.62,46.2).
city('Kerekegyhaza','hu','Bacs-Kiskun',5983.0,19.48,46.94).
city('Kiskoroes','hu','Bacs-Kiskun',15091.0,19.28,46.63).
city('Kiskunfelegyhaza','hu','Bacs-Kiskun',31721.0,19.84,46.71).
city('Kiskunhalas','hu','Bacs-Kiskun',29354.0,19.48,46.43).
city('Kiskunmajsa','hu','Bacs-Kiskun',11955.0,19.74,46.5).
city('Kisszallas','hu','Bacs-Kiskun',2846.0,19.5,46.27).
city('Kunfeherto','hu','Bacs-Kiskun',2281.0,19.42,46.35).
city('Kunszentmiklos','hu','Bacs-Kiskun',8976.0,19.13,47.03).
city('Lajosmizse','hu','Bacs-Kiskun',11034.0,19.55,47.03).
city('Lakitelek','hu','Bacs-Kiskun',4435.0,20.0,46.88).
city('Madaras','hu','Bacs-Kiskun',3246.0,19.26,46.06).
city('Melykut','hu','Bacs-Kiskun',5766.0,19.38,46.22).
city('Nagybaracska','hu','Bacs-Kiskun',2445.0,18.9,46.05).
city('Nemesnadudvar','hu','Bacs-Kiskun',2041.0,19.06,46.34).
city('Nyarlorinc','hu','Bacs-Kiskun',2384.0,19.88,46.87).
city('Orgovany','hu','Bacs-Kiskun',3472.0,19.48,46.75).
city('Palmonostora','hu','Bacs-Kiskun',2052.0,19.95,46.63).
city('Solt','hu','Bacs-Kiskun',6984.0,19.01,46.8).
city('Soltvadkert','hu','Bacs-Kiskun',7695.0,19.4,46.58).
city('Suekoesd','hu','Bacs-Kiskun',3987.0,19.0,46.29).
city('Szabadszallas','hu','Bacs-Kiskun',6605.0,19.23,46.88).
city('Szalkszentmarton','hu','Bacs-Kiskun',2982.0,19.02,46.97).
city('Szank','hu','Bacs-Kiskun',2506.0,19.67,46.55).
city('Szentkiraly','hu','Bacs-Kiskun',1965.0,19.93,46.92).
city('Tass','hu','Bacs-Kiskun',2963.0,19.03,47.02).
city('Tazlar','hu','Bacs-Kiskun',1984.0,19.51,46.55).
city('Tiszaalpar','hu','Bacs-Kiskun',5070.0,19.99,46.81).
city('Tiszakecske','hu','Bacs-Kiskun',11745.0,20.09,46.94).
city('Tompa','hu','Bacs-Kiskun',4844.0,19.55,46.2).
city('Varosfoeld','hu','Bacs-Kiskun',2248.0,19.75,46.81).
city('Vaskut','hu','Bacs-Kiskun',3613.0,18.99,46.11).
city('Beremend','hu','Baranya',2775.0,18.43,45.78).
city('Boly','hu','Baranya',3642.0,18.52,45.97).
city('Dunaszekcso','hu','Baranya',2151.0,18.76,46.08).
city('Goedre','hu','Baranya',957.0,17.96,46.29).
city('Harkany','hu','Baranya',3450.0,18.23,45.85).
city('Hidas','hu','Baranya',2274.0,18.51,46.26).
city('Hosszuheteny','hu','Baranya',3299.0,18.35,46.15).
city('Komlo','hu','Baranya',26924.0,18.26,46.19).
city('Kozarmisleny','hu','Baranya',4093.0,18.29,46.03).
city('Lanycsok','hu','Baranya',2707.0,18.61,45.99).
city('Magocs','hu','Baranya',2652.0,18.23,46.35).
city('Mohacs','hu','Baranya',18711.0,18.68,46.0).
city('Pecs','hu','Baranya',156661.0,18.22,46.08).
city('Pecsvarad','hu','Baranya',4024.0,18.42,46.15).
city('Pellerd','hu','Baranya',1881.0,18.16,46.03).
city('Sasd','hu','Baranya',3500.0,18.11,46.25).
city('Sellye','hu','Baranya',3184.0,17.85,45.87).
city('Siklos','hu','Baranya',10180.0,18.29,45.85).
city('Szaszvar','hu','Baranya',2684.0,18.38,46.27).
city('Szentlorinc','hu','Baranya',7123.0,17.98,46.05).
city('Szigetvar','hu','Baranya',11267.0,17.81,46.05).
city('Vajszlo','hu','Baranya',1888.0,17.98,45.85).
city('Villany','hu','Baranya',2738.0,18.45,45.87).
city('Battonya','hu','Bekes',6604.0,21.02,46.29).
city('Bekes','hu','Bekes',21198.0,21.13,46.77).
city('Bekescsaba','hu','Bekes',65956.0,21.08,46.68).
city('Bekessamson','hu','Bekes',2581.0,20.62,46.42).
city('Bekesszentandras','hu','Bekes',4103.0,20.48,46.87).
city('Bucsa','hu','Bekes',2479.0,21.0,47.21).
city('Csabacsud','hu','Bekes',2085.0,20.65,46.82).
city('Csanadapaca','hu','Bekes',2811.0,20.89,46.54).
city('Csorvas','hu','Bekes',5643.0,20.83,46.63).
city('Devavanya','hu','Bekes',8796.0,20.96,47.04).
city('Doboz','hu','Bekes',4466.0,21.25,46.74).
city('Dombegyhaz','hu','Bekes',2380.0,21.14,46.34).
city('Elek','hu','Bekes',5465.0,21.24,46.54).
city('Fuezesgyarmat','hu','Bekes',6426.0,21.22,47.11).
city('Gadoros','hu','Bekes',4008.0,20.61,46.67).
city('Gyomaendrod','hu','Bekes',15194.0,20.83,46.94).
city('Gyula','hu','Bekes',32269.0,21.29,46.0).
city('Kaszaper','hu','Bekes',2063.0,20.82,46.46).
city('Ketegyhaza','hu','Bekes',4331.0,21.18,46.54).
city('Kevermes','hu','Bekes',2401.0,21.19,46.41).
city('Koeroesladany','hu','Bekes',5006.0,21.08,46.97).
city('Koeroestarcsa','hu','Bekes',2786.0,21.02,46.89).
city('Kondoros','hu','Bekes',5793.0,20.81,46.76).
city('Kunagota','hu','Bekes',2951.0,21.05,46.43).
city('Lokoeshaza','hu','Bekes',2017.0,21.23,46.43).
city('Magyarbanhegyes','hu','Bekes',2634.0,20.96,46.46).
city('Medgyesegyhaza','hu','Bekes',4037.0,21.03,46.5).
city('Mehkerek','hu','Bekes',2274.0,21.44,46.77).
city('Mezobereny','hu','Bekes',11306.0,21.02,46.83).
city('Mezohegyes','hu','Bekes',6220.0,20.82,46.32).
city('Mezokovacshaza','hu','Bekes',6877.0,20.9,46.41).
city('Nagyszenas','hu','Bekes',5617.0,20.67,46.66).
city('Okany','hu','Bekes',2930.0,21.34,46.9).
city('Oroshaza','hu','Bekes',31373.0,20.67,46.57).
city('Pusztafoeldvar','hu','Bekes',1887.0,20.8,46.52).
city('Sarkad','hu','Bekes',10698.0,21.39,46.74).
city('Szabadkigyos','hu','Bekes',2591.0,21.09,46.61).
city('Szarvas','hu','Bekes',18170.0,20.56,46.87).
city('Szeghalom','hu','Bekes',9985.0,21.17,47.03).
city('Totkomlos','hu','Bekes',6497.0,20.76,46.42).
city('Ujkigyos','hu','Bekes',5602.0,21.03,46.58).
city('Veszto','hu','Bekes',7494.0,21.26,46.93).
city('Abaujszanto','hu','Borsod-Abauj-Zemplen',3366.0,21.18,48.28).
city('Alsozsolca','hu','Borsod-Abauj-Zemplen',6107.0,20.88,48.08).
city('Arlo','hu','Borsod-Abauj-Zemplen',4129.0,20.27,48.18).
city('Arnot','hu','Borsod-Abauj-Zemplen',2493.0,20.87,48.13).
city('Aszalo','hu','Borsod-Abauj-Zemplen',2008.0,20.97,48.22).
city('Bekecs','hu','Borsod-Abauj-Zemplen',2446.0,21.17,48.17).
city('Bocs','hu','Borsod-Abauj-Zemplen',2677.0,20.97,48.05).
city('Bogacs','hu','Borsod-Abauj-Zemplen',2112.0,20.53,47.9).
city('Boldva','hu','Borsod-Abauj-Zemplen',2456.0,20.78,48.22).
city('Borsodnadasd','hu','Borsod-Abauj-Zemplen',3546.0,20.23,48.12).
city('Cigand','hu','Borsod-Abauj-Zemplen',3245.0,21.9,48.25).
city('Edeleny','hu','Borsod-Abauj-Zemplen',11037.0,20.74,48.3).
city('Emod','hu','Borsod-Abauj-Zemplen',5382.0,20.81,47.94).
city('Encs','hu','Borsod-Abauj-Zemplen',6886.0,21.13,48.33).
city('Farkaslyuk','hu','Borsod-Abauj-Zemplen',1922.0,20.31,48.2).
city('Felsozsolca','hu','Borsod-Abauj-Zemplen',7040.0,20.85,48.11).
city('Gesztely','hu','Borsod-Abauj-Zemplen',2839.0,20.97,48.1).
city('Goenc','hu','Borsod-Abauj-Zemplen',2217.0,21.28,48.47).
city('Halmaj','hu','Borsod-Abauj-Zemplen',1869.0,21.0,48.25).
city('Harsany','hu','Borsod-Abauj-Zemplen',2059.0,20.75,47.97).
city('Hejobaba','hu','Borsod-Abauj-Zemplen',1949.0,20.95,47.9).
city('Hernadnemeti','hu','Borsod-Abauj-Zemplen',3629.0,20.98,48.08).
city('Izsofalva','hu','Borsod-Abauj-Zemplen',1871.0,20.65,48.31).
city('Jardanhaza','hu','Borsod-Abauj-Zemplen',1938.0,20.25,48.15).
city('Karcsa','hu','Borsod-Abauj-Zemplen',1984.0,21.8,48.32).
city('Kazincbarcika','hu','Borsod-Abauj-Zemplen',32396.0,20.65,48.26).
city('Mad','hu','Borsod-Abauj-Zemplen',2589.0,21.28,48.2).
city('Malyi','hu','Borsod-Abauj-Zemplen',4128.0,20.83,48.02).
city('Megyaszo','hu','Borsod-Abauj-Zemplen',3072.0,21.05,48.18).
city('Mezokeresztes','hu','Borsod-Abauj-Zemplen',4116.0,20.69,47.83).
city('Mezokoevesd','hu','Borsod-Abauj-Zemplen',17701.0,20.58,47.81).
city('Mezozombor','hu','Borsod-Abauj-Zemplen',2549.0,21.26,48.16).
city('Miskolc','hu','Borsod-Abauj-Zemplen',179430.0,20.79,48.1).
city('Monok','hu','Borsod-Abauj-Zemplen',1786.0,21.15,48.21).
city('Mucsony','hu','Borsod-Abauj-Zemplen',3486.0,20.68,48.27).
city('Nyekladhaza','hu','Borsod-Abauj-Zemplen',4939.0,20.83,47.98).
city('Olaszliszka','hu','Borsod-Abauj-Zemplen',1799.0,21.43,48.25).
city('Onga','hu','Borsod-Abauj-Zemplen',4697.0,20.91,48.13).
city('Onod','hu','Borsod-Abauj-Zemplen',2461.0,20.92,48.0).
city('Ozd','hu','Borsod-Abauj-Zemplen',38475.0,20.3,48.23).
city('Pruegy','hu','Borsod-Abauj-Zemplen',2568.0,21.25,48.09).
city('Putnok','hu','Borsod-Abauj-Zemplen',7501.0,20.42,48.31).
city('Ricse','hu','Borsod-Abauj-Zemplen',1907.0,21.98,48.34).
city('Rudabanya','hu','Borsod-Abauj-Zemplen',2941.0,20.63,48.39).
city('Sajobabony','hu','Borsod-Abauj-Zemplen',3113.0,20.74,48.17).
city('Sajokaza','hu','Borsod-Abauj-Zemplen',3494.0,20.58,48.29).
city('Sajolad','hu','Borsod-Abauj-Zemplen',3001.0,20.9,48.05).
city('Sajoszentpeter','hu','Borsod-Abauj-Zemplen',13125.0,20.72,48.22).
city('Sajoszoeged','hu','Borsod-Abauj-Zemplen',2289.0,21.0,47.95).
city('Sajovamos','hu','Borsod-Abauj-Zemplen',2206.0,20.85,48.19).
city('Saly','hu','Borsod-Abauj-Zemplen',2174.0,20.67,47.95).
city('Sarospatak','hu','Borsod-Abauj-Zemplen',14478.0,21.57,48.33).
city('Satoraljaujhely','hu','Borsod-Abauj-Zemplen',18052.0,21.66,48.4).
city('Szendro','hu','Borsod-Abauj-Zemplen',4284.0,20.73,48.4).
city('Szentistvan','hu','Borsod-Abauj-Zemplen',2629.0,20.67,47.77).
city('Szerencs','hu','Borsod-Abauj-Zemplen',10046.0,21.2,48.17).
city('Szihalom','hu','Borsod-Abauj-Zemplen',2120.0,20.48,47.0).
city('Szikszo','hu','Borsod-Abauj-Zemplen',5963.0,20.93,48.2).
city('Szirmabesenyo','hu','Borsod-Abauj-Zemplen',4697.0,20.79,48.16).
city('Taktaharkany','hu','Borsod-Abauj-Zemplen',4076.0,21.13,48.09).
city('Taktaszada','hu','Borsod-Abauj-Zemplen',2067.0,21.18,48.12).
city('Tallya','hu','Borsod-Abauj-Zemplen',2169.0,21.23,48.23).
city('Tarcal','hu','Borsod-Abauj-Zemplen',3283.0,21.35,48.13).
city('Tiszakarad','hu','Borsod-Abauj-Zemplen',2522.0,21.74,48.23).
city('Tiszakeszi','hu','Borsod-Abauj-Zemplen',2692.0,20.99,47.8).
city('Tiszaluc','hu','Borsod-Abauj-Zemplen',5551.0,21.08,48.03).
city('Tiszaujvaros','hu','Borsod-Abauj-Zemplen',17294.0,21.07,47.94).
city('Tokaj','hu','Borsod-Abauj-Zemplen',5071.0,21.4,48.1).
city('Tolcsva','hu','Borsod-Abauj-Zemplen',1860.0,21.45,48.28).
city('Budapest','hu','Budapest',1708088.0,19.08,47.51).
city('Algyo','hu','Csongrad',5235.0,20.25,46.32).
city('Apatfalva','hu','Csongrad',3268.0,20.58,46.17).
city('Asotthalom','hu','Csongrad',4134.0,19.78,46.2).
city('Baks','hu','Csongrad',2292.0,20.09,46.54).
city('Balastya','hu','Csongrad',3564.0,20.01,46.41).
city('Bordany','hu','Csongrad',3097.0,19.92,46.32).
city('Csanadpalota','hu','Csongrad',3224.0,20.73,46.25).
city('Csanytelek','hu','Csongrad',2937.0,20.1,46.6).
city('Csengele','hu','Csongrad',2004.0,19.86,46.54).
city('Csongrad','hu','Csongrad',18580.0,20.14,46.72).
city('Deszk','hu','Csongrad',3245.0,20.24,46.22).
city('Domaszek','hu','Csongrad',4242.0,19.96,46.25).
city('Fabiansebestyen','hu','Csongrad',2276.0,20.47,46.68).
city('Foeldeak','hu','Csongrad',3255.0,20.5,46.32).
city('Forraskut','hu','Csongrad',2287.0,19.92,46.37).
city('Hodmezovasarhely','hu','Csongrad',47699.0,20.32,46.42).
city('Kistelek','hu','Csongrad',7430.0,19.98,46.47).
city('Kiszombor','hu','Csongrad',4131.0,20.43,46.19).
city('Mako','hu','Csongrad',25135.0,20.47,46.22).
city('Maroslele','hu','Csongrad',2157.0,20.34,46.27).
city('Mindszent','hu','Csongrad',7243.0,20.2,46.52).
city('Morahalom','hu','Csongrad',5445.0,19.88,46.22).
city('Opusztaszer','hu','Csongrad',2260.0,20.08,46.48).
city('Pusztaszer','hu','Csongrad',1642.0,19.98,46.55).
city('Roeszke','hu','Csongrad',3241.0,20.05,46.19).
city('Ruzsa','hu','Csongrad',2764.0,19.75,46.29).
city('Sandorfalva','hu','Csongrad',7738.0,20.11,46.36).
city('Szatymaz','hu','Csongrad',4187.0,20.05,46.35).
city('Szeged','hu','Csongrad',160609.0,20.16,46.26).
city('Szegvar','hu','Csongrad',4897.0,20.23,46.59).
city('Szekkutas','hu','Csongrad',2586.0,20.53,46.5).
city('Szentes','hu','Csongrad',30495.0,20.26,46.66).
city('Toemoerkeny','hu','Csongrad',1944.0,20.04,46.62).
city('Uelles','hu','Csongrad',3145.0,19.84,46.34).
city('Zakanyszek','hu','Csongrad',2747.0,19.9,46.27).
city('Zsombo','hu','Csongrad',3268.0,19.98,46.32).
city('Aba','hu','Fejer',4479.0,18.53,47.03).
city('Adony','hu','Fejer',3812.0,18.87,47.13).
city('Alap','hu','Fejer',2149.0,18.69,46.8).
city('Apostag','hu','Fejer',2099.0,18.95,46.88).
city('Bakonycsernye','hu','Fejer',3177.0,18.08,47.32).
city('Baracs','hu','Fejer',3294.0,18.91,46.9).
city('Baracska','hu','Fejer',2701.0,18.78,47.3).
city('Bicske','hu','Fejer',11072.0,18.63,47.48).
city('Bodajk','hu','Fejer',4069.0,18.23,47.32).
city('Cece','hu','Fejer',2843.0,18.65,46.77).
city('Csakvar','hu','Fejer',5259.0,18.44,47.41).
city('Deg','hu','Fejer',2354.0,18.45,46.87).
city('Dunaujvaros','hu','Fejer',53396.0,18.93,46.98).
city('Eloszallas','hu','Fejer',2556.0,18.82,46.83).
city('Enying','hu','Fejer',7171.0,18.25,46.93).
city('Ercsi','hu','Fejer',8383.0,18.9,47.25).
city('Etyek','hu','Fejer',3626.0,18.75,47.45).
city('Fehervarcsurgo','hu','Fejer',1886.0,18.27,47.3).
city('Gardony','hu','Fejer',8105.0,18.65,47.2).
city('Ivancsa','hu','Fejer',2807.0,18.84,47.16).
city('Kaloz','hu','Fejer',2527.0,18.49,46.96).
city('Kapolnasnyek','hu','Fejer',3224.0,18.68,47.25).
city('Kislang','hu','Fejer',2641.0,18.39,46.96).
city('Lajoskomarom','hu','Fejer',2365.0,18.34,46.84).
city('Lepseny','hu','Fejer',3224.0,18.25,47.0).
city('Lovasbereny','hu','Fejer',2674.0,18.55,47.31).
city('Many','hu','Fejer',2294.0,18.67,47.55).
city('Martonvasar','hu','Fejer',5166.0,18.78,47.32).
city('Mezofalva','hu','Fejer',4910.0,18.77,46.93).
city('Mezoszilas','hu','Fejer',2309.0,18.48,46.82).
city('Mor','hu','Fejer',14690.0,18.22,47.37).
city('Nagyvenyim','hu','Fejer',3949.0,18.84,46.96).
city('Pakozd','hu','Fejer',2721.0,18.55,47.23).
city('Pazmand','hu','Fejer',1985.0,18.67,47.28).
city('Perkata','hu','Fejer',4166.0,18.79,47.05).
city('Polgardi','hu','Fejer',6564.0,18.31,47.07).
city('Pusztaszabolcs','hu','Fejer',6355.0,18.77,47.13).
city('Pusztavam','hu','Fejer',2521.0,18.23,47.43).
city('Rackeresztur','hu','Fejer',3117.0,18.83,47.27).
city('Sarbogard','hu','Fejer',13424.0,18.63,46.89).
city('Sarkeresztur','hu','Fejer',2443.0,18.56,47.02).
city('Sarosd','hu','Fejer',3474.0,18.66,47.05).
city('Sarszentmihaly','hu','Fejer',2824.0,18.33,47.16).
city('Seregelyes','hu','Fejer',4539.0,18.58,47.1).
city('Soponya','hu','Fejer',1996.0,18.45,47.02).
city('Szabadbattyan','hu','Fejer',4492.0,18.38,47.12).
city('Szekesfehervar','hu','Fejer',103772.0,18.41,47.2).
city('Val','hu','Fejer',2348.0,18.68,47.37).
city('Velence','hu','Fejer',4832.0,18.66,47.25).
city('Zamoly','hu','Fejer',2194.0,18.42,47.33).
city('Abda','hu','Gyor-Moson-Sopron',2997.0,17.55,47.7).
city('Agfalva','hu','Gyor-Moson-Sopron',1971.0,16.49,47.69).
city('Asvanyraro','hu','Gyor-Moson-Sopron',1985.0,17.5,47.84).
city('Bakonyszentlaszlo','hu','Gyor-Moson-Sopron',1913.0,17.8,47.41).
city('Beled','hu','Gyor-Moson-Sopron',2933.0,17.1,47.47).
city('Bony','hu','Gyor-Moson-Sopron',2225.0,17.87,47.65).
city('Bosarkany','hu','Gyor-Moson-Sopron',2208.0,17.25,47.68).
city('Csorna','hu','Gyor-Moson-Sopron',10825.0,17.25,47.61).
city('Farad','hu','Gyor-Moson-Sopron',1936.0,17.23,47.59).
city('Fertod','hu','Gyor-Moson-Sopron',3396.0,16.87,47.62).
city('Fertorakos','hu','Gyor-Moson-Sopron',2179.0,16.65,47.72).
city('Fertoszentmiklos','hu','Gyor-Moson-Sopron',3877.0,16.88,47.58).
city('Goenyu','hu','Gyor-Moson-Sopron',3021.0,17.84,47.73).
city('Gyoerujbarat','hu','Gyo',4603.0,17.65,47.61).
city('Gyor','hu','Gyor-Moson-Sopron',129009.0,17.64,47.69).
city('Gyorszemere','hu','Gyor-Moson-Sopron',2964.0,17.55,47.55).
city('Halaszi','hu','Gyor-Moson-Sopron',2850.0,17.36,47.88).
city('Janossomorja','hu','Gyor-Moson-Sopron',5985.0,17.17,47.78).
city('Kapuvar','hu','Gyor-Moson-Sopron',10661.0,17.04,47.6).
city('Kimle','hu','Gyor-Moson-Sopron',2312.0,17.37,47.83).
city('Kony','hu','Gyor-Moson-Sopron',2609.0,17.4,47.62).
city('Lebeny','hu','Gyor-Moson-Sopron',3161.0,17.38,47.73).
city('Mihalyi','hu','Gyor-Moson-Sopron',1137.0,17.1,47.52).
city('Mosonmagyarovar','hu','Gyor-Moson-Sopron',30359.0,17.27,47.86).
city('Mosonszentmiklos','hu','Gyor-Moson-Sopron',2517.0,17.43,47.73).
city('Nyul','hu','Gyor-Moson-Sopron',3816.0,17.68,47.58).
city('Oetteveny','hu','Gyor-Moson-Sopron',2725.0,17.52,47.72).
city('Pannonhalma','hu','Gyor-Moson-Sopron',4089.0,17.75,47.55).
city('Per','hu','Gyor-Moson-Sopron',2372.0,17.81,47.61).
city('Rabapatona','hu','Gyor-Moson-Sopron',2497.0,17.5,47.62).
city('Rajka','hu','Gyor-Moson-Sopron',2601.0,17.2,48.0).
city('Sopron','hu','Gyor-Moson-Sopron',55623.0,16.58,47.68).
city('Szany','hu','Gyor-Moson-Sopron',2300.0,17.3,47.47).
city('Tet','hu','Gyor-Moson-Sopron',4104.0,17.52,47.52).
city('Toeltestava','hu','Gyor-Moson-Sopron',1902.0,17.73,47.62).
city('Bagamer','hu','Hajdu-Bihar',2433.0,21.99,47.47).
city('Balmazujvaros','hu','Hajdu-Bihar',18012.0,21.35,47.61).
city('Barand','hu','Hajdu-Bihar',2728.0,21.22,47.3).
city('Berettyoujfalu','hu','Hajdu-Bihar',16090.0,21.54,47.23).
city('Biharkeresztes','hu','Hajdu-Bihar',4237.0,21.74,47.13).
city('Biharnagybajom','hu','Hajdu-Bihar',2936.0,21.23,47.22).
city('Bocskaikert','hu','Hajdu-Bihar',2474.0,21.67,47.66).
city('Csoekmo','hu','Hajdu-Bihar',2170.0,21.29,47.04).
city('Debrecen','hu','Hajdu-Bihar',204825.0,21.63,47.54).
city('Derecske','hu','Hajdu-Bihar',9207.0,21.57,47.36).
city('Ebes','hu','Hajdu-Bihar',4468.0,21.5,47.48).
city('Egyek','hu','Hajdu-Bihar',5573.0,20.89,47.62).
city('Foeldes','hu','Hajdu-Bihar',4345.0,21.37,47.29).
city('Goerbehaza','hu','Hajdu-Bihar',2626.0,21.24,47.83).
city('Hajdubagos','hu','Hajdu-Bihar',1959.0,21.68,47.4).
city('Hajduboeszoermeny','hu','Hajdu-Bihar',31957.0,21.51,47.68).
city('Hajdudorog','hu','Hajdu-Bihar',9514.0,21.5,47.82).
city('Hajduhadhaz','hu','Hajdu-Bihar',12892.0,21.67,47.69).
city('Hajdunanas','hu','Hajdu-Bihar',18032.0,21.43,47.85).
city('Hajdusamson','hu','Hajdu-Bihar',10854.0,21.76,47.6).
city('Hajduszoboszlo','hu','Hajdu-Bihar',23496.0,21.4,47.45).
city('Hajduszovat','hu','Hajdu-Bihar',3167.0,21.48,47.39).
city('Hortobagy','hu','Hajdu-Bihar',1745.0,21.17,47.58).
city('Hosszupalyi','hu','Hajdu-Bihar',5478.0,21.74,47.4).
city('Ka','hu','Hajdu-Bihar',6392.0,21.29,47.35).
city('Komadi','hu','Hajdu-Bihar',6091.0,21.5,47.01).
city('Konyar','hu','Hajdu-Bihar',2257.0,21.67,47.33).
city('Letavertes','hu','Hajdu-Bihar',7157.0,21.9,47.38).
city('Mikepercs','hu','Hajdu-Bihar',3430.0,21.63,47.45).
city('Monostorpalyi','hu','Hajdu-Bihar',2221.0,21.78,47.4).
city('Nadudvar','hu','Hajdu-Bihar',9135.0,21.17,47.42).
city('Nagyhegyes','hu','Hajdu-Bihar',2683.0,21.37,47.55).
city('Nagyrabe','hu','Hajdu-Bihar',2380.0,21.33,47.21).
city('Nyirabrany','hu','Hajdu-Bih',3940.0,22.03,47.55).
city('Nyiracsad','hu','Hajdu-Bihar',4047.0,21.98,47.61).
city('Nyiradony','hu','Hajdu-Bihar',7827.0,21.92,47.7).
city('Nyirmartonfalva','hu','Hajdu-Bihar',2130.0,21.91,47.6).
city('Pocsaj','hu','Hajdu-Bihar',2709.0,21.81,47.3).
city('Polgar','hu','Hajdu-Bihar',8347.0,21.12,47.87).
city('Puespoekladany','hu','Hajdu-Bihar',15990.0,21.13,47.32).
city('Sarand','hu','Hajdu-Bihar',2322.0,21.64,47.42).
city('Sarretudvari','hu','Hajdu-Bihar',3023.0,21.2,47.23).
city('Teglas','hu','Hajdu-Bihar',6285.0,21.69,47.73).
city('Tiszacsege','hu','Hajdu-Bihar',4961.0,21.0,47.7).
city('Ujfeherto','hu','Hajdu-Bihar',13542.0,21.68,47.8).
city('Vamospercs','hu','Hajdu-Bihar',5451.0,21.89,47.54).
city('Abasar','hu','Heves',3189.0,20.0,47.8).
city('Adacs','hu','Heves',2890.0,19.96,47.71).
city('Andornaktalya','hu','Heves',2636.0,20.41,47.85).
city('Apc','hu','Heves',2754.0,19.7,47.81).
city('Belapatfalva','hu','Heves',3401.0,20.37,48.05).
city('Besenyotelek','hu','Heves',2847.0,20.45,47.71).
city('Boldog','hu','Heves',3131.0,19.71,47.62).
city('Csany','hu','Heves',2279.0,19.83,47.66).
city('Domoszlo','hu','Heves',2105.0,20.12,47.83).
city('Ecsed','hu','Heves',3457.0,19.78,47.75).
city('Eger','hu','Heves',56302.0,20.38,47.9).
city('Egerszalok','hu','Heves',1952.0,20.33,47.87).
city('Erdotelek','hu','Heves',3443.0,20.32,47.68).
city('Felsotarkany','hu','Heves',3223.0,20.42,47.97).
city('Fuezesabony','hu','Heves',8182.0,20.41,47.75).
city('Gyoengyoes','hu','Heves',32938.0,19.92,47.78).
city('Gyoengyoeshalasz','hu','Heves',2585.0,19.92,47.76).
city('Gyoengyoespata','hu','Heves',2724.0,19.8,47.82).
city('Gyoengyoessolymos','hu','Heves',3160.0,19.93,47.82).
city('Gyoengyoestarjan','hu','Heves',2463.0,19.87,47.8).
city('Hatvan','hu','Heves',22710.0,19.68,47.67).
city('Hered','hu','Heves',2039.0,19.63,47.7).
city('Heves','hu','Heves',11311.0,20.29,47.6).
city('Hort','hu','Heves',3797.0,19.78,47.7).
city('Kal','hu','Heves',3683.0,20.26,47.73).
city('Karacsond','hu','Heves',3132.0,20.03,47.74).
city('Kerecsend','hu','Heves',2217.0,20.35,47.8).
city('Kiskoere','hu','Heves',3038.0,20.5,47.51).
city('Kompolt','hu','Heves',2166.0,20.25,47.73).
city('Lorinci','hu','Heves',6089.0,19.68,47.73).
city('Maklar','hu','Heves',2340.0,20.41,47.81).
city('Matraderecske','hu','Heves',2232.0,20.08,47.95).
city('Nagyrede','hu','Heves',3308.0,19.85,47.78).
city('Ostoros','hu','Heves',2362.0,20.43,47.87).
city('Parad','hu','Heves',2111.0,20.03,47.92).
city('Petervasara','hu','Heves',2568.0,20.1,48.02).
city('Petofibanya','hu','Heves',3061.0,19.72,47.77).
city('Poroszlo','hu','Heves',3030.0,20.65,47.65).
city('Recsk','hu','Heves',2992.0,20.12,47.93).
city('Rozsaszentmarton','hu','Heves',2028.0,19.75,47.8).
city('Sirok','hu','Heves',2068.0,20.2,47.93).
city('Szilvasvarad','hu','Heves',1885.0,20.4,48.11).
city('Tarnalelesz','hu','Heves',1805.0,20.18,48.05).
city('Tiszanana','hu','Heves',2607.0,20.52,47.56).
city('Vamosgyoerk','hu','Heves',2020.0,19.92,47.69).
city('Verpelet','hu','Heves',4016.0,20.23,47.85).
city('Zagyvaszanto','hu','Heves',2067.0,19.68,47.78).
city('Abadszalok','hu','Jasz-Nagykun-Szolnok',4654.0,20.6,47.47).
city('Alattyan','hu','Jasz-Nagykun-Szolnok',2004.0,20.05,47.43).
city('Besenyszoeg','hu','Jasz-Nagykun-Szolnok',3460.0,20.27,47.3).
city('Cibakhaza','hu','Jasz-Nagykun-Szolnok',4565.0,20.2,46.97).
city('Cserkeszolo','hu','Jasz-Nagykun-Szolnok',2182.0,20.18,46.87).
city('Fegyvernek','hu','Jasz-Nagykun-Szolnok',6972.0,20.54,47.25).
city('Hegyeshalom','hu','Jasz-Nagykun-Szolnok',3507.0,20.03,47.52).
city('Janoshida','hu','Jasz-Nagykun-Szolnok',2709.0,20.05,47.39).
city('Jaszalsoszentgyoergy','hu','Jasz-Nagykun-Szolnok',3777.0,20.1,47.37).
city('Jaszapati','hu','Jasz-Nagykun-Szolnok',9806.0,20.14,47.51).
city('Jaszarokszallas','hu','Jasz-Nagykun-Szolnok',8107.0,19.97,47.64).
city('Jaszbereny','hu','Jasz-Nagykun-Szolnok',27835.0,19.91,47.5).
city('Jaszdozsa','hu','Jasz-Nagykun-Szolnok',2225.0,20.02,47.58).
city('Jaszfenyzaru','hu','Jasz-Nagykun-Szolnok',5746.0,19.73,47.57).
city('Jaszjakohalma','hu','Jasz-Nagykun-Szolnok',3088.0,20.0,47.52).
city('Jaszkiser','hu','Jasz-Nagykun-Szolnok',5741.0,20.21,47.46).
city('Jaszladany','hu','Jasz-Nagykun-Szolnok',6215.0,20.18,47.37).
city('Jaszszentandras','hu','Jasz-Nagykun-Szolnok',2640.0,20.18,47.58).
city('Karcag','hu','Jasz-Nagykun-Szolnok',22370.0,20.92,47.32).
city('Kenderes','hu','Jasz-Nagykun-Szolnok',5243.0,20.68,47.25).
city('Kengyel','hu','Jasz-Nagykun-Szolnok',4299.0,20.34,47.09).
city('Kisujszallas','hu','Jasz-Nagykun-Szolnok',12661.0,20.76,47.22).
city('Kunhegyes','hu','Jasz-Nagykun-Szolnok',8462.0,20.64,47.37).
city('Kunmadaras','hu','Jasz-Nagykun-Szolnok',5826.0,20.8,47.43).
city('Kunszentmarton','hu','Jasz-Nagykun-Szolnok',9606.0,20.29,46.84).
city('Martfu','hu','Jasz-Nagykun-Szolnok',7247.0,20.28,47.02).
city('Mezotur','hu','Jasz-Nagykun-Szolnok',19168.0,20.61,47.0).
city('Oecsoed','hu','Jasz-Nagykun-Szolnok',3730.0,20.4,46.9).
city('Rakoczifalva','hu','Jasz-Nagykun-Szolnok',5481.0,20.23,47.09).
city('Rakocziujfalu','hu','Jasz-Nagykun-Szolnok',2012.0,20.27,47.07).
city('Szajol','hu','Jasz-Nagykun-Szolnok',3991.0,20.3,47.18).
city('Szolnok','hu','Jasz-Nagykun-Szolnok',75998.0,20.18,47.18).
city('Tiszabo','hu','Jasz-Nagykun-Szolnok',2000.0,20.49,47.31).
city('Tiszabura','hu','Jasz-Nagykun-Szolnok',2730.0,20.47,47.45).
city('Tiszafoeldvar','hu','Jasz-Nagykun-Szolnok',11873.0,20.26,46.98).
city('Tiszafuered','hu','Jasz-Nagykun-Szolnok',12000.0,20.75,47.61).
city('Tiszapuespoeki','hu','Jasz-Nagykun-Szolnok',2096.0,20.32,47.22).
city('Tiszaroff','hu','Jasz-Nagykun-Szolnok',1874.0,20.45,47.4).
city('Tiszasuely','hu','Jasz-Nagykun-Szolnok',1737.0,20.4,47.38).
city('Tiszaszentimre','hu','Jasz-Nagykun-Szolnok',2340.0,20.73,47.51).
city('Toeroekszentmiklos','hu','Jasz-Nagykun-Szolnok',22770.0,20.41,47.18).
city('Toszeg','hu','Jasz-Nagykun-Szolnok',4621.0,20.16,47.1).
city('Turkeve','hu','Jasz-Nagykun-Szolnok',10016.0,20.74,47.1).
city('Ujszasz','hu','Jasz-Nagykun-Szolnok',6855.0,20.07,47.29).
city('Zagyvarekas','hu','Jasz-Nagykun-Szolnok',3700.0,20.14,47.27).
city('Acs','hu','Komarom-Esztergom',7180.0,18.02,47.7).
city('Almasfuezito','hu','Komarom-Esztergom',2348.0,18.27,47.72).
city('Babolna','hu','Komarom-Esztergom',3885.0,17.98,47.64).
city('Baj','hu','Komarom-Esztergom',2664.0,18.37,47.65).
city('Bajna','hu','Komarom-Esztergom',2024.0,18.6,47.65).
city('Bokod','hu','Komarom-Esztergom',2229.0,18.25,47.5).
city('Csaszar','hu','Komarom-Esztergom',1922.0,18.15,47.51).
city('Csolnok','hu','Komarom-Esztergom',3381.0,18.73,47.7).
city('Dorog','hu','Komarom-Esztergom',12658.0,18.72,47.72).
city('Esztergom','hu','Komarom-Esztergom',28785.0,18.74,47.79).
city('Kecsked','hu','Komarom-Esztergom',1908.0,18.32,47.52).
city('Kesztoelc','hu','Komarom-Esztergom',2559.0,18.8,47.72).
city('Kisber','hu','Komarom-Esztergom',5850.0,18.01,47.5).
city('Kocs','hu','Komarom-Esztergom',2655.0,18.22,47.61).
city('Koernye','hu','Komarom-Esztergom',4359.0,18.33,47.55).
city('Komarom','hu','Komarom-Esztergom',19646.0,18.12,47.74).
city('Labatlan','hu','Komarom-Esztergom',5357.0,18.5,47.75).
city('Mocsa','hu','Komarom-Esztergom',2265.0,18.18,47.67).
city('Nagyigmand','hu','Komarom-Esztergom',3132.0,18.08,47.64).
city('Naszaly','hu','Komarom-Esztergom',2239.0,18.27,47.7).
city('Nyergesujfalu','hu','Komarom-Esztergom',7667.0,18.55,47.76).
city('Oroszlany','hu','Komarom-Esztergom',20271.0,18.31,47.48).
city('Piliscsev','hu','Komarom-Esztergom',2310.0,18.81,47.69).
city('Pilismarot','hu','Komarom-Esztergom',1952.0,18.88,47.78).
city('Sarisap','hu','Komarom-Esztergom',2911.0,18.68,47.68).
city('Suetto','hu','Komarom-Esztergom',1998.0,18.45,47.75).
city('Szarliget','hu','Komarom-Esztergom',2148.0,18.49,47.53).
city('Szomod','hu','Komarom-Esztergom',2020.0,18.35,47.68).
city('Tarjan','hu','Komarom-Esztergom',2825.0,18.52,47.62).
city('Tat','hu','Komarom-Esztergom',5575.0,18.65,47.75).
city('Tata','hu','Komarom-Esztergom',23868.0,18.31,47.64).
city('Tatabanya','hu','Komarom-Esztergom',71527.0,18.44,47.55).
city('Tokod','hu','Komarom-Esztergom',4271.0,18.66,47.72).
city('Tokodaltaro','hu','Komarom-Esztergom',3106.0,18.65,47.74).
city('Vertesszoeloes','hu','Komarom-Esztergom',2747.0,18.38,47.62).
city('Balassagyarmat','hu','Nograd',17541.0,19.31,48.07).
city('Batonyterenye','hu','Nograd',14214.0,19.83,47.97).
city('Bercel','hu','Nograd',1991.0,19.4,47.87).
city('Bujak','hu','Nograd',2343.0,19.55,47.88).
city('Diosjeno','hu','Nograd',2746.0,19.05,47.95).
city('Ersekvadkert','hu','Nograd',3762.0,19.21,48.01).
city('Jobbagyi','hu','Nograd',2329.0,19.68,47.84).
city('Karancskeszi','hu','Nograd',1924.0,19.7,48.17).
city('Karancslapujto','hu','Nograd',2845.0,19.73,48.16).
city('Kazar','hu','Nograd',2080.0,19.84,48.06).
city('Matranovak','hu','Nograd',1972.0,19.98,48.04).
city('Matraterenye','hu','Nograd',1995.0,19.93,48.05).
city('Matraverebely','hu','Nograd',2197.0,19.77,47.99).
city('Nagyoroszi','hu','Nograd',2250.0,19.1,48.0).
city('Paszto','hu','Nograd',10119.0,19.7,47.92).
city('Retsag','hu','Nograd',3004.0,19.13,47.94).
city('Rimoc','hu','Nograd',1874.0,19.53,48.03).
city('Romhany','hu','Nograd',2421.0,19.27,47.93).
city('Salgotarjan','hu','Nograd',44289.0,19.82,48.11).
city('Szecseny','hu','Nograd',6446.0,19.53,48.09).
city('Szurdokpuespoeki','hu','Nograd',1947.0,19.7,47.86).
city('Tar','hu','Nograd',1972.0,19.75,47.95).
city('Abony','hu','Pest',16342.0,20.01,47.19).
city('Albertirsa','hu','Pest',11864.0,19.62,47.24).
city('Alsonemedi','hu','Pest',4974.0,19.18,47.33).
city('Aszod','hu','Pest',6184.0,19.49,47.66).
city('Bag','hu','Pest',4071.0,19.49,47.65).
city('Biatorbagy','hu','Pest',8632.0,18.81,47.47).
city('Budakalasz','hu','Pest',9696.0,19.05,47.62).
city('Budakeszi','hu','Pest',13248.0,18.93,47.52).
city('Budaoers','hu','Pest',25089.0,18.96,47.46).
city('Bugyi','hu','Pest',5412.0,19.15,47.22).
city('Cegled','hu','Pest',39287.0,19.78,47.18).
city('Cegledbercel','hu','Pest',4710.0,19.68,47.23).
city('Csemo','hu','Pest',4411.0,19.71,47.12).
city('Csobanka','hu','Pest',2881.0,18.96,47.63).
city('Csoemoer','hu','Pest',7544.0,19.23,47.56).
city('Dabas','hu','Pest',16590.0,19.32,47.18).
city('Danszentmiklos','hu','Pest',2838.0,19.55,47.22).
city('Dany','hu','Pest',4378.0,19.54,47.53).
city('Delegyhaza','hu','Pest',2506.0,19.06,47.25).
city('Diosd','hu','Pest',6168.0,18.93,47.4).
city('Doemsoed','hu','Pest',5942.0,19.01,47.1).
city('Domony','hu','Pest',2031.0,19.43,47.65).
city('Dunabogdany','hu','Pest',3059.0,19.03,47.78).
city('Dunaharaszti','hu','Pest',16973.0,19.09,47.35).
city('Dunakeszi','hu','Pest',30246.0,19.12,47.63).
city('Dunavarsany','hu','Pest',6016.0,19.09,47.29).
city('Ecser','hu','Pest',3333.0,19.33,47.45).
city('Erd','hu','Pest',59242.0,18.91,47.38).
city('Erdokertes','hu','Pest',5996.0,19.32,47.67).
city('Farmos','hu','Pest',3793.0,19.86,47.37).
city('Felsopakony','hu','Pest',3040.0,19.25,47.35).
city('Forro','hu','Pest',2473.0,19.67,47.45).
city('Fot','hu','Pest',16770.0,19.2,47.62).
city('Galgahe','hu','Pest',2641.0,19.57,47.62).
city('Galgamacsa','hu','Pest',2061.0,19.39,47.7).
city('Goed','hu','Pest',15874.0,19.13,47.7).
city('Goedoello','hu','Pest',32374.0,19.35,47.6).
city('Gomba','hu','Pest',2861.0,19.54,47.38).
city('Gyal','hu','Pest',21937.0,19.21,47.38).
city('Gyoemro','hu','Pest',14155.0,19.4,47.42).
city('Halasztelek','hu','Pest',7245.0,19.0,47.37).
city('Hernad','hu','Pest',3689.0,19.44,47.17).
city('Hevizgyoerk','hu','Pest',3101.0,19.52,47.63).
city('Iklad','hu','Pest',2194.0,19.45,47.67).
city('Inarcs','hu','Pest',4262.0,19.33,47.27).
city('Isaszeg','hu','Pest',10754.0,19.4,47.53).
city('Jaszkarajeno','hu','Pest',3125.0,20.06,47.05).
city('Kakucs','hu','Pest',2707.0,19.38,47.25).
city('Kartal','hu','Pest',6017.0,19.54,47.68).
city('Kerepes','hu','Pest',8755.0,19.22,47.59).
city('Kiskunlachaza','hu','Pest',8980.0,19.01,47.2).
city('Kistarcsa','hu','Pest',9637.0,19.18,47.58).
city('Kocser','hu','Pest',2096.0,19.92,47.0).
city('Koka','hu','Pest',4376.0,19.58,47.49).
city('Kosd','hu','Pest',2371.0,19.18,47.8).
city('Leanyfalu','hu','Pest',2534.0,19.08,47.72).
city('Maglod','hu','Pest',10144.0,19.37,47.45).
city('Mende','hu','Pest',4250.0,19.45,47.42).
city('Mogyorod','hu','Pest',4949.0,19.25,47.6).
city('Monor','hu','Pest',21720.0,19.45,47.35).
city('Nagykata','hu','Pest',13322.0,19.74,47.41).
city('Nagykoroes','hu','Pest',26711.0,19.78,47.03).
city('Nagykovacsi','hu','Pest',4861.0,19.02,47.65).
city('Nagymaros','hu','Pest',4629.0,18.97,47.78).
city('Nagytarcsa','hu','Pest',2846.0,19.28,47.54).
city('Nyaregyhaza','hu','Pest',3770.0,19.5,47.25).
city('Ocsa','hu','Pest',9097.0,19.23,47.3).
city('Oerkeny','hu','Pest',5119.0,19.43,47.13).
city('Orbottyan','hu','Pest',5495.0,19.27,47.68).
city('Pand','hu','Pest',2041.0,19.64,47.35).
city('Paty','hu','Pest',5475.0,18.83,47.52).
city('Pecel','hu','Pest',13193.0,19.35,47.49).
city('Perbal','hu','Pest',2167.0,18.77,47.6).
city('Peteri','hu','Pest',1970.0,19.42,47.38).
city('Pilis','hu','Pest',11102.0,19.55,47.28).
city('Pilisborosjeno','hu','Pest',3180.0,19.0,47.62).
city('Piliscsaba','hu','Pest',6468.0,18.83,47.62).
city('Pilisszanto','hu','Pest',2245.0,18.89,47.67).
city('Pilisszentivan','hu','Pest',4218.0,18.9,47.62).
city('Pilisszentkereszt','hu','Pest',2224.0,18.9,47.7).
city('Pilisvoeroesvar','hu','Pest',13150.0,18.91,47.62).
city('Pomaz','hu','Pest',14917.0,19.02,47.66).
city('Racalmas','hu','Pest',4148.0,18.95,47.02).
city('Rackeve','hu','Pest',9229.0,18.93,47.17).
city('Solymar','hu','Pest',9242.0,18.93,47.59).
city('Soskut','hu','Pest',2998.0,18.83,47.4).
city('Suelysap','hu','Pest',7976.0,19.27,47.62).
city('Szada','hu','Pest',3370.0,19.32,47.63).
city('Szazhalombatta','hu','Pest',17566.0,18.94,47.34).
city('Szentendre','hu','Pest',23606.0,19.05,47.7).
city('Szentlorinckata','hu','Pest',2005.0,19.76,47.53).
city('Szentmartonkata','hu','Pest',4868.0,19.7,47.45).
city('Szigetcsep','hu','Pest',2455.0,18.98,47.27).
city('Szigethalom','hu','Pest',13092.0,19.03,47.35).
city('Szigetszentmiklos','hu','Pest',24874.0,19.05,47.35).
city('Szigetujfalu','hu','Pest',2158.0,18.93,47.23).
city('Szob','hu','Pest',3065.0,18.87,47.82).
city('Szod','hu','Pest',3059.0,19.21,47.73).
city('Szodliget','hu','Pest',4350.0,19.15,47.75).
city('Taborfalva','hu','Pest',3509.0,19.49,47.1).
city('Tahitofalu','hu','Pest',4677.0,19.1,47.75).
city('Taksony','hu','Pest',6129.0,19.07,47.34).
city('Tapiobicske','hu','Pest',3514.0,19.67,47.37).
city('Tapiogyoergye','hu','Pest',3817.0,19.96,47.34).
city('Tapiosag','hu','Pest',2760.0,19.63,47.4).
city('Tapioszecso','hu','Pest',6628.0,19.62,47.45).
city('Tapioszele','hu','Pest',6214.0,19.87,47.33).
city('Tapioszentmarton','hu','Pest',5596.0,19.75,47.33).
city('Tapioszolos','hu','Pest',3155.0,19.85,47.3).
city('Tarnok','hu','Pest',7990.0,18.86,47.38).
city('Telki','hu','Pest',2071.0,18.83,47.55).
city('Toalmas','hu','Pest',3434.0,19.67,47.52).
city('Toekoel','hu','Pest',9112.0,18.98,47.33).
city('Toeroekbalint','hu','Pest',11658.0,18.92,47.43).
city('Toertel','hu','Pest',4733.0,19.93,47.12).
city('Tura','hu','Pest',8294.0,19.6,47.6).
city('Uello','hu','Pest',10232.0,19.35,47.38).
city('Ueroem','hu','Pest',4753.0,19.01,47.6).
city('Ujhartyan','hu','Pest',2852.0,19.39,47.23).
city('Ujszilvas','hu','Pes',2722.0,19.92,47.27).
city('Uri','hu','Pest',2718.0,19.53,47.42).
city('Vac','hu','Pest',35108.0,19.13,47.79).
city('Vacszentlaszlo','hu','Pest',2085.0,19.53,47.58).
city('Valko','hu','Pest',2461.0,19.51,47.58).
city('Vecses','hu','Pest',19327.0,19.28,47.4).
city('Veresegyhaz','hu','Pest',11087.0,19.28,47.65).
city('Veroce','hu','Pest',3087.0,19.03,47.83).
city('Visegrad','hu','Pest',1713.0,18.98,47.79).
city('Zsambek','hu','Pest',4791.0,18.72,47.55).
city('Zsambok','hu','Pest',2474.0,19.62,47.55).
city('Adand','hu','Somogy',2306.0,18.17,46.85).
city('Babocsa','hu','Somogy',1877.0,17.34,46.04).
city('Balatonboglar','hu','Somogy',5964.0,17.67,46.77).
city('Balatonfenyves','hu','Somogy',1885.0,17.5,46.71).
city('Balatonfoeldvar','hu','Somogy',2069.0,17.88,46.85).
city('Balatonlelle','hu','Somogy',4910.0,17.68,46.78).
city('Balatonszabadi','hu','Somogy',2838.0,18.13,46.88).
city('Balatonszarszo','hu','Somogy',1992.0,17.83,46.83).
city('Barcs','hu','Somogy',12116.0,17.46,45.96).
city('Berzence','hu','Somogy',2694.0,17.15,46.2).
city('Boehoenye','hu','Somogy',2437.0,17.38,46.4).
city('Csurgo','hu','Somogy',5682.0,17.09,46.26).
city('Fonyod','hu','Somogy',5199.0,17.55,46.73).
city('Kadarkut','hu','Somogy',2740.0,17.61,46.23).
city('Kaposmero','hu','Somogy',2506.0,17.71,46.35).
city('Kaposvar','hu','Somogy',66947.0,17.79,46.36).
city('Karad','hu','Somogy',1733.0,17.85,46.68).
city('Kethely','hu','Somogy',2408.0,17.4,46.65).
city('Labod','hu','Somogy',2244.0,17.46,46.2).
city('Lengyeltoti','hu','Somogy',3380.0,17.65,46.67).
city('Marcali','hu','Somogy',12344.0,17.42,46.58).
city('Nagyatad','hu','Somogy',11843.0,17.36,46.23).
city('Nagybajom','hu','Somogy',3532.0,17.51,46.38).
city('Segesd','hu','Somogy',2674.0,17.35,46.33).
city('Siofok','hu','Somogy',23028.0,18.06,46.9).
city('Somogyvar','hu','Somogy',2023.0,17.67,46.58).
city('Tab','hu','Somogy',4824.0,18.02,46.73).
city('Taszar','hu','Somogy',2013.0,17.91,46.37).
city('Zamardi','hu','Somogy',2211.0,17.95,46.88).
city('Ajak','hu','Szabolcs-Szatmar-Bereg',3983.0,22.06,48.2).
city('Anarcs','hu','Szabolcs-Szatmar-Bereg',2021.0,22.11,48.18).
city('Apagy','hu','Szabolcs-Szatmar-Bereg',2348.0,21.96,47.98).
city('Aranyosapati','hu','Szabolcs-Szatmar-Bereg',2142.0,22.27,48.2).
city('Baktaloranthaza','hu','Szabolcs-Szatmar-Bereg',4265.0,22.08,48.0).
city('Balkany','hu','Szabolcs-Szatmar-Bereg',6798.0,21.87,47.77).
city('Boekoeny','hu','Szabolcs-Szatmar-Bereg',3310.0,21.77,47.75).
city('Buj','hu','Szabolcs-Szatmar-Bereg',2496.0,21.65,48.1).
city('Csenger','hu','Szabolcs-Szatmar-Bereg',5225.0,22.68,47.84).
city('Demecser','hu','Szabolcs-Szatmar-Bereg',4558.0,21.92,48.12).
city('Doege','hu','Szabolcs-Szatmar-Bereg',2181.0,22.08,48.27).
city('Dombrad','hu','Szabolcs-Szatmar-Bereg',4276.0,21.92,48.23).
city('Encsencs','hu','Szabolcs-Szatmar-Bereg',2087.0,22.12,47.76).
city('Fabianhaza','hu','Szabolcs-Szatmar-Bereg',1919.0,22.38,47.88).
city('Fehergyarmat','hu','Szabolcs-Szatmar-Bereg',9031.0,22.52,47.99).
city('Fenyeslitke','hu','Szabolcs-Szatmar-Bereg',2425.0,22.11,48.29).
city('Gegeny','hu','Szabolcs-Szatmar-Ber',2093.0,21.96,48.16).
city('Gyulahaza','hu','Szabolcs-Szatmar-Bereg',2059.0,22.12,48.15).
city('Hodasz','hu','Szabolcs-Szatmar-Bereg',3489.0,22.21,47.94).
city('Ibrany','hu','Szabolcs-Szatmar-Bereg',6880.0,21.71,48.14).
city('Kallosemjen','hu','Szabolcs-Szatmar-Bereg',3968.0,21.93,47.87).
city('Kalmanhaza','hu','Szabolcs-Szatmar-Bereg',2086.0,21.61,47.88).
city('Kantorjanosi','hu','Szabolcs-Szatmar-Bereg',2244.0,22.16,47.96).
city('Kek','hu','Szabolcs-Szatmar-Bereg',2044.0,21.89,48.13).
city('Kemecse','hu','Szabolcs-Szatmar-Bereg',5029.0,21.8,48.07).
city('Kisleta','hu','Szabolcs-Szatmar-Bereg',1944.0,22.02,47.85).
city('Kisvarda','hu','Szabolcs-Szatmar-Bereg',18190.0,22.08,48.22).
city('Kocsord','hu','Szabolcs-Szatmar-Bereg',3054.0,22.39,47.96).
city('Kotaj','hu','Szabolcs-Szatmar-Bereg',4553.0,21.72,48.05).
city('Levelek','hu','Szabolcs-Szatmar-Bereg',2948.0,21.99,47.98).
city('Mandok','hu','Szabolcs-Szatmar-Bereg',4566.0,22.2,48.32).
city('Mariapocs','hu','Szabolcs-Szatmar-Bereg',2182.0,22.03,47.88).
city('Mateszalka','hu','Szabolcs-Szatmar-Bereg',18718.0,22.33,47.96).
city('Merk','hu','Szabolcs-Szatmar-Bereg',2335.0,22.39,47.8).
city('Nagycserkesz','hu','Szabolcs-Szatmar-Bereg',1907.0,21.57,47.98).
city('Nagydobos','hu','Szabolcs-Szatmar-Bereg',2282.0,22.32,48.07).
city('Nagyecsed','hu','Szabolcs-Szatmar-Bereg',6919.0,22.39,47.86).
city('Nagyhalasz','hu','Szabolcs-Szatmar-Bereg',5924.0,21.76,48.14).
city('Nagykallo','hu','Szabolcs-Szatmar-Bereg',10796.0,21.84,47.88).
city('Napkor','hu','Szabolcs-Szatmar-Bereg',3786.0,21.89,47.96).
city('Nyirbator','hu','Szabolcs-Szatmar-Bereg',13434.0,22.14,47.84).
city('Nyirbeltek','hu','Szabolcs-Szatmar-Bereg',3021.0,22.14,47.7).
city('Nyirbogat','hu','Szabolcs-Szatmar-Bereg',3336.0,22.07,47.82).
city('Nyirbogdany','hu','Szabolcs-Szatmar-Bereg',3039.0,21.89,48.07).
city('Nyircsaholy','hu','Szabolcs-Szatmar-Bereg',2251.0,22.36,47.93).
city('Nyiregyhaza','hu','Szabolcs-Szatmar-Bereg',116809.0,21.72,47.96).
city('Nyirgyulaj','hu','Szabolcs-Szatmar-Bereg',2130.0,22.09,47.9).
city('Nyirkarasz','hu','Szabolcs-Szatmar-Bereg',2395.0,22.1,48.12).
city('Nyirlugos','hu','Szabolcs-Szatmar-Bereg',3004.0,22.05,47.71).
city('Nyirmada','hu','Szabolcs-Szatmar-Bereg',4743.0,22.2,48.07).
city('Nyirmeggyes','hu','Szabolcs-Szatmar-Bereg',2757.0,22.28,47.93).
city('Nyirmihalydi','hu','Szabolcs-Szatmar-Bereg',1997.0,21.98,47.73).
city('Nyirpazony','hu','Szabolcs-Szatmar-Bereg',3162.0,21.8,47.98).
city('Nyirtass','hu','Szabolcs-Szatmar-Bereg',2194.0,22.03,48.13).
city('Nyirtelek','hu','Szabolcs-Szatmar-Bereg',7138.0,21.63,48.02).
city('Nyirvasvari','hu','Szabolcs-Szatmar-Bereg',1971.0,22.19,47.84).
city('Oekoeritofuelpoes','hu','Szabolcs-Szatmar-Bereg',2034.0,22.53,47.94).
city('Ofeherto','hu','Szabolcs-Szatmar-Bereg',2727.0,22.05,47.93).
city('Opalyi','hu','Szabolcs-Szatmar-Bereg',3035.0,22.34,48.02).
city('Patroha','hu','Szabolcs-Szatmar-Bereg',2976.0,22.0,48.19).
city('Petnehaza','hu','Szabolcs-Szatmar-Bereg',1993.0,22.09,48.08).
city('Porcsalma','hu','Szabolcs-Szatmar-Bereg',2770.0,22.57,47.88).
city('Rakamaz','hu','Szabolcs-Szatmar-Bereg',5197.0,21.46,48.14).
city('Szakoly','hu','Szabolcs-Szatmar-Bereg',2925.0,21.93,47.78).
city('Szamosszeg','hu','Szabolcs-Szatmar-Bereg',2084.0,22.37,48.06).
city('Tarpa','hu','Szabolcs-Szatmar-Bereg',2331.0,22.53,48.1).
city('Tiszabercel','hu','Szabolcs-Szatmar-Bereg',2047.0,21.65,48.15).
city('Tiszabezded','hu','Szabolcs-Szatmar-Bereg',2054.0,22.15,48.37).
city('Tiszadada','hu','Szabolcs-Szatmar-Bereg',2505.0,21.25,48.04).
city('Tiszadob','hu','Szabolcs-Szatmar-Bereg',3311.0,21.17,48.01).
city('Tiszaeszlar','hu','Szabolcs-Szatmar-Bereg',2857.0,21.47,48.05).
city('Tiszaloek','hu','Szabolcs-Szatmar-Bereg',6122.0,21.38,48.02).
city('Tiszanagyfalu','hu','Szabolcs-Szatmar-Bereg',2010.0,21.48,48.1).
city('Tiszavasvari','hu','Szabolcs-Szatmar-Bereg',13631.0,21.36,47.97).
city('Tornyospalca','hu','Szabolcs-Szatmar-Bereg',2725.0,22.19,48.29).
city('Tunyogmatolcs','hu','Szabolcs-Szatmar-Bereg',2629.0,22.48,47.99).
city('Tuzser','hu','Szabolcs-Szatmar-Bereg',3332.0,22.13,48.35).
city('Tyukod','hu','Szabolcs-Szatmar-Bereg',2188.0,22.59,47.88).
city('Vaja','hu','Szabolcs-Szatmar-Bereg',3774.0,22.17,48.0).
city('Vasarosnameny','hu','Szabolcs-Szatmar-Bereg',9310.0,22.31,48.13).
city('Zahony','hu','Szabolcs-Szatmar-Bereg',4807.0,22.19,48.41).
city('Bata','hu','Tolna',1891.0,18.79,46.13).
city('Bataszek','hu','Tolna',6820.0,18.73,46.19).
city('Boelcske','hu','Tolna',2946.0,18.97,46.74).
city('Bogyiszlo','hu','Tolna',2348.0,18.83,46.38).
city('Bonyhad','hu','Tolna',14184.0,18.53,46.3).
city('Decs','hu','Tolna',4210.0,18.77,46.28).
city('Doebroekoez','hu','Tolna',2120.0,18.24,46.43).
city('Dombovar','hu','Tolna',20748.0,18.13,46.38).
city('Dunafoeldvar','hu','Tolna',9073.0,18.91,46.8).
city('Dunaszentgyoergy','hu','Tolna',2624.0,18.83,46.52).
city('Fadd','hu','Tolna',4442.0,18.83,46.47).
city('Gyoenk','hu','Tolna',2148.0,18.48,46.55).
city('Hogyesz','hu','Tolna',3029.0,18.42,46.48).
city('Iregszemcse','hu','Tolna',2772.0,18.18,46.7).
city('Madocsa','hu','Tolna',1935.0,18.97,46.68).
city('Nagydorog','hu','Tolna',2787.0,18.66,46.63).
city('Nagymagocs','hu','Tolna',3424.0,18.47,46.28).
city('Nagymanyok','hu','Tolna',2504.0,18.46,46.29).
city('Nemetker','hu','Tolna',1901.0,18.78,46.71).
city('Ocseny','hu','Tolna',2536.0,18.77,46.3).
city('Ozora','hu','Tolna',1742.0,18.4,46.75).
city('Paks','hu','Tolna',20638.0,18.86,46.62).
city('Pincehely','hu','Tolna',2548.0,18.45,46.68).
city('Simontornya','hu','Tolna',4536.0,18.55,46.76).
city('Szedres','hu','Tolna',2478.0,18.68,46.47).
city('Szekszard','hu','Tolna',35327.0,18.71,46.35).
city('Szentgal','hu','Tolna',2815.0,18.62,46.37).
city('Tamasi','hu','Tolna',9682.0,18.28,46.63).
city('Tengelic','hu','Tolna',2445.0,18.72,46.53).
city('Tolna','hu','Tolna',12011.0,18.78,46.43).
city('Zomba','hu','Tolna',2286.0,18.57,46.4).
city('Buek','hu','Vas',3174.0,16.75,47.39).
city('Celldoemoelk','hu','Vas',11421.0,17.15,47.25).
city('Csepreg','hu','Vas',3568.0,16.72,47.4).
city('Gencsapati','hu','Vas',2580.0,16.6,47.28).
city('Jak','hu','Vas',2310.0,16.58,47.13).
city('Janoshaza','hu','Vas',2754.0,17.16,47.12).
city('Koermend','hu','Vas',12368.0,16.6,47.01).
city('Koszeg','hu','Vas',11500.0,16.55,47.39).
city('Repcelak','hu','Vas',2644.0,17.01,47.42).
city('Sarvar','hu','Vas',15343.0,16.93,47.26).
city('Szentgotthard','hu','Vas',8911.0,16.28,46.95).
city('Szombathely','hu','Vas',80210.0,16.63,47.23).
city('Taplanszentkereszt','hu','Vas',2342.0,16.66,47.2).
city('Vasvar','hu','Vas',4613.0,16.8,47.05).
city('Vep','hu','Vas',3460.0,16.73,47.23).
city('Ajka','hu','Veszprem',31407.0,17.56,47.1).
city('Badacsonytomaj','hu','Veszprem',2271.0,17.51,46.8).
city('Balatonalmadi','hu','Veszprem',8364.0,18.02,47.03).
city('Balatonfuered','hu','Veszprem',13054.0,17.88,46.95).
city('Balatonfuzfo','hu','Veszprem',4260.0,18.05,47.07).
city('Balatonkenese','hu','Veszprem',3326.0,18.12,47.03).
city('Band','hu','Veszprem',641.0,17.8,47.12).
city('Berhida','hu','Veszprem',5822.0,18.13,47.12).
city('Csabrendek','hu','Veszpr',2948.0,17.3,47.02).
city('Cseteny','hu','Veszprem',2039.0,18.0,47.32).
city('Devecser','hu','Veszprem',5140.0,17.42,47.11).
city('Hajmasker','hu','Veszprem',2793.0,18.02,47.15).
city('Herend','hu','Veszprem',3385.0,17.75,47.13).
city('Liter','hu','Veszprem',2010.0,18.02,47.1).
city('Nemesvamos','hu','Veszprem',2508.0,17.88,47.05).
city('Oesku','hu','Veszprem',2272.0,18.09,47.18).
city('Osi','hu','Veszprem',2146.0,18.2,47.18).
city('Papa','hu','Veszprem',32990.0,17.47,47.33).
city('Petfuerdo','hu','Veszprem',4877.0,18.13,47.17).
city('Suemeg','hu','Veszprem',6726.0,17.28,46.99).
city('Szentkiralyszabadja','hu','Veszprem',2042.0,17.97,47.05).
city('Tapolca','hu','Veszprem',17598.0,17.44,46.89).
city('Urkut','hu','Veszprem',2178.0,17.63,47.08).
city('Varpalota','hu','Veszprem',21299.0,18.14,47.2).
city('Veszprem','hu','Veszprem',60387.0,17.91,47.1).
city('Zirc','hu','Veszprem',7314.0,17.87,47.26).
city('Becsehely','hu','Zala',2255.0,16.8,46.45).
city('Cserszegtomaj','hu','Zala',1941.0,17.22,46.8).
city('Gyenesdias','hu','Zala',2796.0,17.28,46.77).
city('Heviz','hu','Zala',4439.0,17.18,46.79).
city('Keszthely','hu','Zala',21534.0,17.24,46.77).
city('Lenti','hu','Zala',8399.0,16.55,46.62).
city('Letenye','hu','Zala',4527.0,16.73,46.44).
city('Murakeresztur','hu','Zala',1969.0,16.87,46.37).
city('Nagykanizsa','hu','Zala',51383.0,16.99,46.46).
city('Pacsa','hu','Zala',1878.0,17.01,46.72).
city('Sarmellek','hu','Zala',1836.0,17.17,46.72).
city('Tuerje','hu','Zala',1868.0,17.1,46.98).
city('Vonyarcvashegy','hu','Zala',1902.0,17.31,46.77).
city('Zalaegerszeg','hu','Zala',60919.0,16.83,46.85).
city('Zalakomar','hu','Zala',3103.0,17.18,46.55).
city('Zalaloevo','hu','Zala',3195.0,16.58,46.86).
city('Zalaszentgrot','hu','Zala',7796.0,17.09,46.93).
city('Bakkafjoereur','is','Austurland',97.0,-14.87,66.02).
city('Borgarfjoereur','is','Austurland',99.0,-23.25,65.77).
city('Breiedalsvik','is','Austurland',169.0,-14.0,64.8).
city('Djupivogur','is','Austurland',389.0,-14.28,64.65).
city('Egilsstaeir','is','Austurland',1884.0,-14.4,65.26).
city('Eiear','is','Austurland',48.0,-14.38,65.37).
city('Eskifjoereur','is','Austurland',984.0,-14.0,65.07).
city('Faskruesfjoereur','is','Austurland',630.0,-14.02,64.93).
city('Fellabaer','is','Austurland',396.0,-14.7,65.25).
city('Hallormsstaeur','is','Austurland',57.0,-14.75,65.1).
city('Hoefn','is','Austurland',1695.0,-15.21,64.26).
city('Neskaupstaeur','is','Austurland',1410.0,-13.7,65.15).
city('Reyearfjoereur','is','Austurland',766.0,-14.22,65.03).
city('Seyeisfjoereur','is','Austurland',699.0,-14.02,65.25).
city('Stoeevarfjoereur','is','Austurland',243.0,-13.88,64.84).
city('Vopnafjoereur','is','Austurland',537.0,-14.83,65.75).
city('Alftanes','is','Hoefueborgarsvaeei',2104.0,-22.03,64.11).
city('Gareabaer','is','Hoefueborgarsvaeei',9265.0,-21.99,64.09).
city('Grundarhverfi','is','Hoefueborgarsvaeei',637.0,-21.85,64.25).
city('Hafnarfjoereur','is','Hoefueborgarsvaeei',22289.0,-21.95,64.06).
city('Kopavogur','is','Hoefueborgarsvaeei',26157.0,-21.92,64.12).
city('Mosfellsbaer','is','Hoefueborgarsvaeei',6917.0,-21.65,64.15).
city('Reykjavik','is','Hoefueborgarsvaeei',113907.0,-21.92,64.14).
city('Seltjarnarnes','is','Hoefueborgarsvaeei',4493.0,-21.93,64.13).
city('Akureyri','is','Noreurland eystra',16563.0,-18.12,65.69).
city('Dalvik','is','Noreurland eystra',1403.0,-18.58,65.98).
city('Grenivik','is','Noreurland eystra',300.0,-18.18,65.95).
city('Grimsey','is','Noreurland eystra',101.0,-21.4,66.53).
city('Hauganes','is','Noreurland eystra',166.0,-18.3,65.92).
city('Hjalteyri','is','Noreurland eystra',41.0,-18.2,65.86).
city('Hrafnagil','is','Noreurland eystra',163.0,-18.37,65.87).
city('Hrisey','is','Noreurland eystra',170.0,-18.38,66.0).
city('Husavik','is','Noreurland eystra',2338.0,-17.35,66.05).
city('Kopasker','is','Noreurland eystra',144.0,-16.45,66.3).
city('Kristnes','is','Noreurland eystra',47.0,-18.08,65.58).
city('Laugar','is','Noreurland eystra',87.0,-17.3,65.73).
city('Litli-Arskogssandur','is','Noreurland eystra',130.0,-18.37,65.95).
city('Olafsfjoereur','is','Noreurland eystra',914.0,-18.65,66.07).
city('Raufarhoefn','is','Noreurland eystra',226.0,-15.95,66.45).
city('Reykjahlie','is','Noreurland eystra',204.0,-16.92,65.65).
city('Svalbareseyri','is','Noreurland eystra',197.0,-18.1,65.75).
city('Thorshoefn','is','Noreurland eystra',351.0,-15.33,66.2).
city('Bloenduos','is','Noreurland vestra',936.0,-20.31,65.66).
city('Hofsos','is','Noreurland vestra',172.0,-19.43,65.9).
city('Holar','is','Noreurland vestra',108.0,-19.13,65.73).
city('Hvammstangi','is','Noreurland vestra',573.0,-20.95,65.4).
city('Laugarbakki','is','Noreurland vestra',71.0,-20.98,63.97).
city('Sauearkrokur','is','Noreurland vestra',2682.0,-19.66,65.74).
city('Siglufjoereur','is','Noreurland vestra',1391.0,-18.93,66.16).
city('Skagastroend','is','Noreurland vestra',550.0,-20.32,65.83).
city('Varmahlie','is','Noreurland vestra',127.0,-19.47,65.55).
city('Eyrarbakki','is','Sueurland',594.0,-21.15,63.87).
city('Flueir','is','Sueurland',292.0,-20.13,64.25).
city('Hella','is','Sueurland',694.0,-20.4,63.83).
city('Hveragerei','is','Sueurland',1934.0,-21.21,64.01).
city('Hvolsvoellur','is','Sueurland',753.0,-20.23,63.75).
city('Kirkjubaejarklaustur','is','Sueurland',139.0,-18.07,63.78).
city('Laugaras','is','Sueurland',107.0,-20.5,64.12).
city('Laugarvatn','is','Sueurland',212.0,-20.73,64.22).
city('Rauealaekur','is','Sueurland',33.0,-18.38,65.68).
city('Selfoss','is','Sueurland',5396.0,-21.01,63.94).
city('Solheimar','is','Sueurland',60.0,-20.65,64.07).
city('Stokkseyri','is','Sueurland',459.0,-21.07,63.83).
city('Thorlakshoefn','is','Sueurland',1262.0,-21.4,63.86).
city('Vestmannaeyjar','is','Sueurland',4203.0,-20.27,63.44).
city('Vik i Myrdal','is','Sueurland',298.0,-19.02,63.42).
city('Gareur','is','Sueurnes',1401.0,-22.65,64.07).
city('Grindavik','is','Sueurnes',2539.0,-22.45,63.85).
city('Hafnir','is','Sueurnes',118.0,-22.68,63.93).
city('Keflavik','is','Sueurnes',7930.0,-22.56,64.01).
city('Njarevik','is','Sueurnes',2844.0,-22.55,63.97).
city('Sandgerei','is','Sueurnes',1371.0,-22.71,64.05).
city('Vogar','is','Sueurnes',982.0,-22.37,63.97).
city('Bildudalur','is','Vestfireir',204.0,-23.62,65.67).
city('Bolungarvik','is','Vestfireir',918.0,-23.27,66.15).
city('Boreeyri','is','Vestfireir',27.0,-21.13,65.2).
city('Drangsnes','is','Vestfireir',77.0,-21.45,65.68).
city('Flateyri','is','Vestfireir',299.0,-23.52,66.05).
city('Hnifsdalur','is','Vestfireir',409.0,-23.15,66.11).
city('Holmavik','is','Vestfireir',424.0,-21.68,65.72).
city('Isafjoereur','is','Vestfireir',2534.0,-23.14,66.08).
city('Krossholt','is','Vestfireir',12.0,-22.3,64.72).
city('Patreksfjoereur','is','Vestfireir',674.0,-24.0,65.58).
city('Reykholar','is','Vestfireir',117.0,-22.2,65.45).
city('Sueavik','is','Vestfireir',195.0,-23.0,66.03).
city('Sueureyri','is','Vestfireir',353.0,-23.53,66.12).
city('Talknafjoereur','is','Vestfireir',331.0,-23.88,65.62).
city('Thingeyri','is','Vestfireir',299.0,-23.5,65.87).
city('Akranes','is','Vesturland',5606.0,-22.09,64.33).
city('Bifroest','is','Vesturland',208.0,-21.5,64.75).
city('Borgarnes','is','Vesturland',1783.0,-21.95,64.54).
city('Bueardalur','is','Vesturland',233.0,-21.77,65.12).
city('Grundarfjoereur','is','Vesturland',795.0,-23.27,64.92).
city('Hellissandur','is','Vesturland',408.0,-23.9,64.92).
city('Hvanneyri','is','Vesturland',231.0,-21.77,64.57).
city('Kleppjarnsreykir','is','Vesturland',42.0,-21.4,64.65).
city('Olafsvik','is','Vesturland',992.0,-23.74,64.89).
city('Reykholt','is','Vesturland',31.0,-21.3,64.67).
city('Rif','is','Vesturland',134.0,-23.82,64.93).
city('Stykkisholmur','is','Vesturland',1059.0,-22.74,65.07).
city('Port Blair','in','Andaman and Nicobar Islands',112062.0,92.76,11.67).
city('Addanki','in','Andhra Pradesh',28547.0,79.98,15.82).
city('Adilabad','in','Andhra Pradesh',118539.0,78.53,19.68).
city('Adoni','in','Andhra Pradesh',163649.0,77.27,15.63).
city('Akividu','in','Andhra Pradesh',40421.0,81.38,16.6).
city('Alampur','in','Andhra Pradesh',14060.0,78.15,15.88).
city('Alwal','in','Andhra Pradesh',126564.0,78.54,17.5).
city('Amalapuram','in','Andhra Pradesh',52696.0,82.02,16.58).
city('Amudalavalasa','in','Andhra Pradesh',39129.0,83.9,18.42).
city('Amur','in','Andhra Pradesh',40811.0,78.28,18.79).
city('Anakapalle','in','Andhra Pradesh',84367.0,83.0,17.69).
city('Anantapur','in','Andhra Pradesh',240469.0,77.59,14.7).
city('Andole','in','Andhra Pradesh',24645.0,78.07,17.85).
city('Asifabad','in','Andhra Pradesh',21216.0,79.28,19.37).
city('Atmakur','in','Andhra Pradesh',35137.0,78.58,15.88).
city('Avanigadda','in','Andhra Pradesh',25761.0,80.92,16.02).
city('Badepalli','in','Andhra Pradesh',31664.0,78.16,16.75).
city('Badvel','in','Andhra Pradesh',16238.0,79.05,14.75).
city('Banganapalle','in','Andhra Pradesh',25325.0,78.23,15.32).
city('Banswada','in','Andhra Pradesh',22665.0,77.88,18.38).
city('Bapatla','in','Andhra Pradesh',70125.0,80.47,15.91).
city('Belampalli','in','Andhra Pradesh',66443.0,79.49,19.06).
city('Betamcherla','in','Andhra Pradesh',35421.0,78.17,15.47).
city('Bhadrachalam','in','Andhra Pradesh',45661.0,80.88,17.67).
city('Bhainsa','in','Andhra Pradesh',46125.0,77.97,19.1).
city('Bhattiprolu','in','Andhra Pradesh',18001.0,80.78,16.1).
city('Bhimavaram','in','Andhra Pradesh',142979.0,81.53,16.55).
city('Bhimunipatnam','in','Andhra Pradesh',44848.0,83.43,17.88).
city('Bhongir','in','Andhra Pradesh',50100.0,78.88,17.52).
city('Bobbili','in','Andhra Pradesh',52849.0,83.37,18.57).
city('Bodhan','in','Andhra Pradesh',73946.0,77.88,18.66).
city('Challapalle','in','Andhra Prade',16841.0,80.93,16.12).
city('Chatakonda','in','Andhra Pradesh',2816.0,80.65,17.55).
city('Chilakalurupet','in','Andhra Pradesh',94021.0,80.16,16.1).
city('Chipurupalle','in','Andhra Pradesh',25904.0,83.57,18.3).
city('Chirala','in','Andhra Pradesh',87011.0,80.35,15.84).
city('Chittur','in','Andhra Pradesh',160542.0,79.1,13.22).
city('Chodavaram','in','Andhra Pradesh',27037.0,82.37,17.63).
city('Cuddapah','in','Andhra Pradesh',127024.0,78.81,14.48).
city('Cumbum','in','Andhra Pradesh',15212.0,79.12,15.57).
city('Darnakal','in','Andhra Pradesh',15353.0,80.14,17.43).
city('Dauleshwaram','in','Andhra Pradesh',37847.0,81.8,16.95).
city('Devarkonda','in','Andhra Pradesh',29730.0,78.93,16.69).
city('Dharmavaram','in','Andhra Pradesh',114062.0,77.71,14.42).
city('Dhone','in','Andhra Pradesh',39689.0,77.88,15.42).
city('Eluru','in','Andhra Pradesh',183401.0,81.11,16.72).
city('Farrukhnagar','in','Andhra Pradesh',39771.0,78.22,17.08).
city('Gaddiannaram','in','Andhra Pradesh',62603.0,78.52,17.36).
city('Gadwal','in','Andhra Pradesh',55958.0,77.8,16.23).
city('Gannavaram','in','Andhra Pradesh',19410.0,80.8,16.53).
city('Giddalur','in','Andhra Pradesh',28142.0,78.92,15.35).
city('Gopalapatnam','in','Andhra Pradesh',50969.0,83.22,17.82).
city('Gopalur','in','Andhra Pradesh',3324.0,77.8,16.62).
city('Gudivada','in','Andhra Pradesh',116174.0,81.0,16.44).
city('Gudur','in','Andhra Pradesh',40254.0,79.33,15.82).
city('Guntakal','in','Andhra Pradesh',120978.0,77.37,15.18).
city('Guntur','in','Andhra Pradesh',530636.0,80.44,16.31).
city('Guti','in','Andhra Pradesh',45555.0,77.63,15.12).
city('Hindupur','in','Andhra Pradesh',133313.0,77.48,13.83).
city('Hyderabad','in','Andhra Pradesh',3598199.0,78.48,17.4).
city('Ichchapuram','in','Andhra Pradesh',33757.0,84.7,19.12).
city('Jaggayyapeta','in','Andhra Pradesh',41185.0,80.1,16.9).
city('Jagtial','in','Andhra Pradesh',99046.0,78.91,18.8).
city('Jammalamadugu','in','Andhra Pradesh',43875.0,78.4,14.83).
city('Jangaon','in','Andhra Pradesh',47563.0,79.18,17.72).
city('Kadiri','in','Andhra Pradesh',81507.0,78.16,14.12).
city('Kagaznagar','in','Andhra Pradesh',60163.0,79.48,19.34).
city('Kaikalur','in','Andhra Pradesh',20763.0,81.2,16.57).
city('Kakinada','in','Andhra Pradesh',292956.0,82.24,16.96).
city('Kallur','in','Andhra Pradesh',59349.0,77.77,15.69).
city('Kalyandurg','in','Andhra Pradesh',31893.0,77.1,14.55).
city('Kamalapuram','in','Andhra Pradesh',14677.0,78.65,14.58).
city('Kamareddi','in','Andhra Pradesh',71049.0,78.35,18.32).
city('Kanigiri','in','Andhra Pradesh',25045.0,79.52,15.4).
city('Kankipadu','in','Andhra Pradesh',14249.0,80.78,16.45).
city('Kapra','in','Andhra Pradesh',198349.0,78.48,17.37).
city('Karimnagar','in','Andhra Pradesh',228770.0,79.13,18.45).
city('Karnul','in','Andhra Pradesh',279571.0,78.03,15.83).
city('Kavali','in','Andhra Pradesh',83361.0,79.99,14.92).
city('Khammam','in','Andhra Pradesh',170522.0,80.15,17.25).
city('Kodar','in','Andhra Pradesh',59182.0,79.97,16.98).
city('Kondapalle','in','Andhra Pradesh',38722.0,80.53,16.62).
city('Kondukur','in','Andhra Pradesh',53668.0,79.91,15.22).
city('Koratla','in','Andhra Pradesh',60238.0,78.72,18.82).
city('Kosgi','in','Andhra Pradesh',15455.0,77.27,15.85).
city('Kothapet','in','Andhra Pradesh',4266.0,79.48,19.33).
city('Kottagud','in','Andhra Pradesh',79255.0,80.64,17.56).
city('Kottapalli','in','Andhra Pradesh',9901.0,79.1,18.48).
city('Kovur','in','Andhra Pradesh',35607.0,79.98,14.48).
city('Kovvur','in','Andhra Pradesh',40383.0,81.73,17.02).
city('Kukatpalle','in','Andhra Pradesh',341746.0,78.41,17.49).
city('Kuppam','in','Andhra Pradesh',19856.0,78.37,12.75).
city('Lakshettipet','in','Andhra Pradesh',11164.0,79.22,18.87).
city('Lalbahadur Nagar','in','Andhra Pradesh',317529.0,78.5,17.43).
city('Macherla','in','Andhra Pradesh',51044.0,79.43,16.48).
city('Machilipatnam','in','Andhra Pradesh',192848.0,81.14,16.19).
city('Madanapalle','in','Andhra Pradesh',108605.0,78.5,13.55).
city('Mahbubabad','in','Andhra Pradesh',37957.0,80.02,17.62).
city('Mahbubnagar','in','Andhra Pradesh',136150.0,77.98,16.74).
city('Malkajgiri','in','Andhra Pradesh',196652.0,78.59,17.55).
city('Mancheral','in','Andhra Pradesh',78006.0,79.45,18.88).
city('Mandamarri','in','Andhra Pradesh',66017.0,79.47,18.97).
city('Mandapeta','in','Andhra Pradesh',48858.0,81.93,16.87).
city('Mandasa','in','Andhra Pradesh',9289.0,84.47,18.87).
city('Mangalagiri','in','Andhra Pradesh',59398.0,80.56,16.44).
city('Manthani','in','Andhra Pradesh',15665.0,79.67,18.65).
city('Manuguru','in','Andhra Pradesh',33423.0,80.72,17.98).
city('Markapur','in','Andhra Pradesh',63990.0,79.28,15.73).
city('Medak','in','Andhra Pradesh',44356.0,78.28,18.07).
city('Metpalli','in','Andhra Pradesh',59195.0,78.62,18.83).
city('Miryalaguda','in','Andhra Pradesh',101245.0,79.57,16.87).
city('Nagar Karnul','in','Andhra Pradesh',29442.0,78.33,16.48).
city('Nagari','in','Andhra Pradesh',25936.0,79.58,13.33).
city('Nagireddipalle','in','Andhra Pradesh',10394.0,79.1,14.27).
city('Nalgonda','in','Andhra Pradesh',121839.0,79.26,17.06).
city('Nandigama','in','Andhra Pradesh',38227.0,80.3,16.78).
city('Nandikotkur','in','Andhra Pradesh',45352.0,78.27,15.87).
city('Nandyal','in','Andhra Pradesh',165355.0,78.48,15.49).
city('Narasannapeta','in','Andhra Pradesh',24273.0,84.05,18.42).
city('Narasapur','in','Andhra Pradesh',59310.0,81.7,16.45).
city('Narasaraopet','in','Andhra Pradesh',97205.0,80.04,16.24).
city('Narayanavanam','in','Andhra Pradesh',11432.0,79.58,13.42).
city('Narayanpet','in','Andh',39045.0,77.5,16.73).
city('Narsingi','in','Andhra Pradesh',6445.0,78.43,18.03).
city('Narsipatnam','in','Andhra Pradesh',33759.0,82.62,17.67).
city('Naspur','in','Andhra Pradesh',15374.0,79.45,18.83).
city('Nayudupeta','in','Andhra Pradesh',45778.0,79.9,13.9).
city('Nelimaria','in','Andhra Pradesh',19810.0,83.42,18.2).
city('Nellur','in','Andhra Pradesh',404202.0,79.98,14.46).
city('Nidadavole','in','Andhra Pradesh',44176.0,81.67,16.92).
city('Nirmal','in','Andhra Pradesh',80991.0,78.35,19.12).
city('Nizamabad','in','Andhra Pradesh',305472.0,78.1,18.68).
city('Nuzvid','in','Andhra Pradesh',53397.0,80.85,16.78).
city('Ongole','in','Andhra Pradesh',172891.0,80.05,15.5).
city('Pakala','in','Andhra Pradesh',24680.0,79.12,13.47).
city('Palakollu','in','Andhra Pradesh',57346.0,81.75,16.52).
city('Palasa','in','Andhra Pradesh',65892.0,84.42,18.77).
city('Palkonda','in','Andhra Pradesh',29378.0,83.75,18.6).
city('Palmaner','in','Andhra Pradesh',42178.0,78.75,13.2).
city('Palwancha','in','Andhra Pradesh',75232.0,80.68,17.6).
city('Parvatipuram','in','Andhra Pradesh',52090.0,83.43,18.78).
city('Patancheru','in','Andhra Pradesh',46827.0,78.27,17.53).
city('Pedana','in','Andhra Pradesh',30256.0,81.17,16.27).
city('Peddapalli','in','Andhra Pradesh',33581.0,79.37,18.62).
city('Peddapuram','in','Andhra Pradesh',45972.0,82.13,17.08).
city('Penugonda','in','Andhra Pradesh',23659.0,81.73,16.67).
city('Penukonda','in','Andhra Pradesh',20220.0,77.58,14.08).
city('Phirangipuram','in','Andhra Pradesh',17335.0,80.27,16.3).
city('Pithapuram','in','Andhra Pradesh',52715.0,82.27,17.12).
city('Ponnur','in','Andhra Pradesh',57177.0,80.56,16.07).
city('Proddatur','in','Andhra Pradesh',177816.0,78.55,14.75).
city('Pulivendla','in','Andhra Pradesh',33615.0,78.23,14.42).
city('Punganuru','in','Andhra Pradesh',48870.0,78.58,13.37).
city('Puttur','in','Andhra Pradesh',30990.0,79.55,13.45).
city('Qutubullapur','in','Andhra Pradesh',284675.0,78.47,17.43).
city('Rajamahendri','in','Andhra Pradesh',304838.0,81.79,17.02).
city('Rajampet','in','Andhra Pradesh',31079.0,79.17,14.18).
city('Rajendranagar','in','Andhra Pradesh',173892.0,78.39,17.29).
city('Ramachandrapuram','in','Andhra Pradesh',49031.0,80.03,17.2).
city('Ramagundam','in','Andhra Pradesh',243331.0,79.45,18.8).
city('Ramapuram','in','Andhra Pradesh',5961.0,77.87,15.28).
city('Rayachoti','in','Andhra Pradesh',81442.0,78.75,14.05).
city('Rayadrug','in','Andhra Pradesh',59975.0,76.87,14.7).
city('Razam','in','Andhra Pradesh',27835.0,83.67,18.47).
city('Razole','in','Andhra Pradesh',14203.0,81.83,16.48).
city('Renigunta','in','Andhra Pradesh',25898.0,79.52,13.65).
city('Repalle','in','Andhra Pradesh',42972.0,80.85,16.02).
city('Sadasivpet','in','Andhra Pradesh',37249.0,77.95,17.62).
city('Salur','in','Andhra Pradesh',50212.0,83.22,18.53).
city('Samalkot','in','Andhra Pradesh',55104.0,82.18,17.06).
city('Sangareddi','in','Andhra Pradesh',59205.0,78.08,17.63).
city('Sattenapalle','in','Andhra Pradesh',53609.0,80.18,16.4).
city('Serilungampalle','in','Andhra Pradesh',188853.0,78.33,17.48).
city('Siddipet','in','Andhra Pradesh',64569.0,78.84,18.11).
city('Sikandarabad','in','Andhra Pradesh',217528.0,78.52,17.47).
city('Singarayakonda','in','Andhra Pradesh',17798.0,80.03,15.25).
city('Sirpur','in','Andhra Pradesh',10116.0,79.6,19.48).
city('Sirsilla','in','Andhra Pradesh',71506.0,78.81,18.4).
city('Sompeta','in','Andhra Pradesh',17984.0,84.6,18.93).
city('Srikakulam','in','Andhra Pradesh',118312.0,83.9,18.3).
city('Srikalahasti','in','Andhra Pradesh',74504.0,79.7,13.76).
city('Srisailam','in','Andhra Pradesh',24145.0,78.87,16.08).
city('Sulurpeta','in','Andhra Pradesh',38065.0,80.02,13.7).
city('Suriapet','in','Andhra Pradesh',111741.0,79.62,17.15).
city('Tadepalle','in','Andhra Pradesh',34357.0,80.6,16.48).
city('Tadepallegudem','in','Andhra Pradesh',108176.0,81.52,16.82).
city('Tadpatri','in','Andhra Pradesh',93055.0,78.0,14.91).
city('Tandur','in','Andhra Pradesh',63246.0,77.58,17.23).
city('Tanuku','in','Andhra Pradesh',68296.0,81.69,16.75).
city('Tekkali','in','Andhra Pradesh',24682.0,84.23,18.62).
city('Tenali','in','Andhra Pradesh',151793.0,80.65,16.24).
city('Tirumala','in','Andhra Pradesh',18015.0,79.35,13.68).
city('Tirupati','in','Andhra Pradesh',250849.0,79.41,13.63).
city('Tirupati Cantonment','in','Andhra Pradesh',31671.0,79.42,13.65).
city('Tirvuru','in','Andhra Pradesh',29469.0,80.62,17.12).
city('Tuni','in','Andhra Pradesh',52664.0,82.55,17.35).
city('Uppal Kalan','in','Andhra Pradesh',139379.0,78.55,17.38).
city('Uravakonda','in','Andhra Pradesh',33499.0,77.27,14.95).
city('Vadlapudi','in','Andhra Pradesh',17881.0,79.8,14.32).
city('Vemalwada','in','Andhra Pradesh',22920.0,78.88,18.47).
city('Venkatagiri','in','Andhra Pradesh',32765.0,79.58,13.97).
city('Vetapalem','in','Andhra Pradesh',38011.0,80.32,15.78).
city('Vijayawada','in','Andhra Pradesh',874684.0,80.63,16.52).
city('Vikarabad','in','Andhra Pradesh',43342.0,77.9,17.33).
city('Vinukonda','in','Andhra Pradesh',61332.0,79.75,16.05).
city('Visakhapatnam','in','Andhra Pradesh',1063293.0,83.3,17.73).
city('Vizianagaram','in','Andhra Pradesh',179379.0,83.4,18.12).
city('Vuyyuru','in','Andhra Pradesh',36755.0,80.85,16.37).
city('Wanparti','in','Andhra Pradesh',55188.0,78.07,16.37).
city('Warangal','in','Andhra Pradesh',557864.0,79.58,18.01).
city('Yarada','in','Andhra Pradesh',3406.0,83.27,17.65).
city('Yellamanchili','in','Andhra Pradesh',26181.0,82.86,17.54).
city('Yellandu','in','Andhra Pradesh',43792.0,80.33,17.6).
city('Yemmiganur','in','Andhra Pradesh',80942.0,77.48,15.73).
city('Yerraguntla','in','Andhra Pradesh',27874.0,78.53,14.63).
city('Zahirabad','in','Andhra Pradesh',46509.0,77.62,17.68).
city('Along','in','Arunachal Pradesh',18427.0,94.77,28.17).
city('Basar','in','Arunachal Pradesh',4157.0,94.67,27.98).
city('Itanagar','in','Arunachal Pradesh',44995.0,93.61,27.14).
city('Khonsa','in','Arunachal Pradesh',10188.0,95.57,27.02).
city('Pasighat','in','Arunachal Pradesh',25584.0,95.33,28.07).
city('Tawang','in','Arunachal Pradesh',4831.0,91.87,27.58).
city('Tezu','in','Arunachal Pradesh',14928.0,96.17,27.92).
city('Ziro','in','Arunachal Pradesh',13895.0,93.83,27.63).
city('Abhayapuri','in','Assam',15803.0,90.66,26.34).
city('Amguri','in','Assam',8496.0,94.53,26.8).
city('Badarpur','in','Assam',11033.0,92.6,24.9).
city('Barpathar','in','Assam',7445.0,93.87,26.3).
city('Barpeta','in','Assam',48826.0,91.0,26.32).
city('Barpeta Road','in','Assam',37157.0,90.9,26.46).
city('Basugaon','in','Assam',12833.0,90.4,26.47).
city('Bihpuria','in','Assam',11781.0,93.9,27.04).
city('Bijni','in','Assam',12991.0,90.66,26.52).
city('Bilasipara','in','Assam',37741.0,90.24,26.24).
city('Bokajan','in','Assam',16561.0,93.78,26.02).
city('Bokokhat','in','Assam',9554.0,93.6,26.64).
city('Bongaigaon','in','Assam',64905.0,90.54,26.48).
city('Chabua','in','Assam',7623.0,95.18,27.48).
city('Chapar','in','Assam',19302.0,90.44,26.28).
city('Dergaon','in','Assam',13366.0,93.97,26.71).
city('Dhekiajuli','in','Assam',21272.0,92.5,26.7).
city('Dhemaji','in','Assam',13059.0,94.58,27.49).
city('Dhing','in','Assam',20827.0,92.49,26.45).
city('Dhuburi','in','Assam',62528.0,89.97,26.03).
city('Dibrugarh','in','Assam',122160.0,94.91,27.49).
city('Digboi','in','Assam',20685.0,95.61,27.4).
city('Diphu','in','Assam',57099.0,93.43,25.84).
city('Dispur','in','Assam',8282.0,91.83,26.11).
city('Duliagaon','in','Assam',23530.0,95.32,27.37).
city('Dum Duma','in','Assam',21707.0,95.56,27.57).
city('Gauripur','in','Assam',24695.0,89.96,26.09).
city('Goalpara','in','Assam',50761.0,90.62,26.18).
city('Gohpur','in','Assam',9896.0,93.63,26.88).
city('Golaghat','in','Assam',34374.0,93.97,26.51).
city('Golakganj','in','Assam',8125.0,89.83,26.1).
city('Gossaigaon','in','Assam',13933.0,89.97,26.45).
city('Guwahati','in','Assam',899132.0,91.75,26.19).
city('Haflong','in','Assam',39983.0,93.03,25.19).
city('Hailakandi','in','Assam',31032.0,92.57,24.67).
city('Hauli','in','Assam',17355.0,90.96,26.44).
city('Hojai','in','Assam',36871.0,92.86,26.02).
city('Jogighopa','in','Assam',2415.0,90.58,26.23).
city('Jorhat','in','Assam',69036.0,94.2,26.76).
city('Karimganj','in','Assam',55293.0,92.36,24.85).
city('Kharupetia','in','Assam',18599.0,92.13,26.52).
city('Kokrajhar','in','Assam',31972.0,90.26,26.41).
city('Lakhimpur','in','Assam',59844.0,94.1,27.24).
city('Lakhipur','in','Assam',13460.0,91.66,25.41).
city('Lala','in','Assam',10942.0,92.6,24.55).
city('Lanka','in','Assam',42428.0,92.95,25.93).
city('Lumding','in','Assam',25777.0,93.17,25.75).
city('Lumding Railway Colony','in','Assam',25878.0,90.2,26.26).
city('Mahur','in','Assam',7178.0,93.12,25.17).
city('Maibong','in','Assam',8365.0,93.17,25.3).
city('Makum','in','Assam',16226.0,95.45,27.5).
city('Mangaldai','in','Assam',24872.0,92.03,26.43).
city('Mankachar','in','Assam',31092.0,89.86,25.54).
city('Margherita','in','Assam',24430.0,95.68,27.29).
city('Mariani','in','Assam',23641.0,94.33,26.67).
city('Nagaon','in','Assam',112113.0,92.68,26.35).
city('Naharkatia','in','Assam',15549.0,95.33,27.29).
city('Nalbari','in','Assam',24618.0,91.43,26.45).
city('Nazira','in','Assam',14303.0,94.73,26.92).
city('Niz-Hajo','in','Assam',15977.0,91.53,26.25).
city('North Guwahati','in','Assam',17517.0,91.73,26.21).
city('Numaligarh','in','Assam',7386.0,93.75,26.63).
city('Palasbari','in','Assam',4714.0,91.5,26.13).
city('Raha','in','Assam',4724.0,92.52,26.23).
city('Rangapara','in','Assam',18740.0,92.65,26.82).
city('Rangia','in','Assam',26389.0,91.63,26.47).
city('Sapatgram','in','Assam',11714.0,90.13,26.34).
city('Sibsagar','in','Assam',62107.0,94.63,26.99).
city('Silchar','in','Assam',152399.0,92.77,24.83).
city('Sonari','in','Assam',19673.0,95.03,27.07).
city('Sorbhog','in','Assam',7614.0,90.86,26.5).
city('Sualkuchi','in','Assam',13918.0,91.57,26.17).
city('Tangla','in','Assam',17725.0,91.91,26.66).
city('Tezpur','in','Assam',58854.0,92.79,26.63).
city('Tinsukia','in','Assam',89377.0,95.3,27.5).
city('Udalguri','in','Assam',15936.0,92.12,26.77).
city('Adra','in','Bangla',22183.0,86.67,23.5).
city('Ahmadpur','in','Bangla',8855.0,87.7,23.83).
city('Alipur Duar','in','Bangla',75936.0,89.53,26.5).
city('Amlagora','in','Bangla',19038.0,87.33,22.83).
city('Amta','in','Bangla',16753.0,88.01,22.58).
city('Amtala','in','Bangla',8267.0,88.29,22.37).
city('Arambagh','in','Bangla',60644.0,87.78,22.88).
city('Asansol','in','Bangla',504320.0,86.98,23.69).
city('Ashoknagar Kalyangarh','in','Bangla',117132.0,89.6,22.76).
city('Aurangabad','in','Bangla',31641.0,87.98,24.64).
city('Baduria','in','Bangla',49552.0,88.79,22.74).
city('Baghdogra','in','Bangla',17373.0,88.32,26.7).
city('Bagnan','in','Bangla',8501.0,88.14,22.92).
city('Bagra','in','Bangla',11364.0,86.32,23.73).
city('Bagula','in','Bangla',20999.0,88.65,23.32).
city('Baharampur','in','Bangla',180564.0,88.24,24.1).
city('Baidyabati','in','Bangla',115515.0,88.33,22.79).
city('Baj Baj','in','Bangla',76166.0,88.17,22.48).
city('Bakreswar','in','Bangla',1739.0,87.37,23.88).
city('Balarampur','in','Bangla',13908.0,87.26,22.73).
city('Bali Chak','in','Bangla',12958.0,87.55,22.37).
city('Bally','in','Bangla',297001.0,88.35,22.65).
city('Bally Cantonment','in','Bangla',101148.0,88.36,22.65).
city('Balurghat','in','Bangla',141418.0,88.77,25.23).
city('Bangaon','in','Bangla',111704.0,88.83,23.05).
city('Bankra','in','Bangla',56278.0,88.31,22.58).
city('Bankura','in','Bangla',133979.0,87.07,23.24).
city('Bansbaria','in','Bangla',108485.0,88.4,22.95).
city('Barakpur','in','Bangla',148188.0,88.38,22.76).
city('Baranagar','in','Bangla',260097.0,88.37,22.64).
city('Barasat','in','Bangla',298270.0,88.48,22.72).
city('Barddhaman','in','Bangla',301754.0,87.86,23.24).
city('Barjora','in','Bangla',12296.0,87.28,23.43).
city('Baruipur','in','Bangla',47878.0,88.45,22.35).
city('Basirhat','in','Bangla',117431.0,88.86,22.66).
city('Begampur','in','Bangla',9832.0,88.24,22.74).
city('Beldanga','in','Bangla',27.0,88.25,23.93).
city('Beliator','in','Bangla',6014.0,87.22,23.33).
city('Bhadreswar','in','Bangla',121674.0,88.35,22.84).
city('Bhandardaha','in','Bangla',5079.0,88.21,22.62).
city('Bhatpara','in','Bangla',483175.0,88.42,22.89).
city('Bidhannagar','in','Bangla',202953.0,88.42,22.57).
city('Bishnupur','in','Bangla',34238.0,87.8,22.73).
city('Bolpur','in','Bangla',71005.0,87.7,23.67).
city('Calcutta','in','Bangla',4631819.0,88.36,22.57).
city('Canning','in','Bangla',42132.0,88.67,22.32).
city('Chakdaha','in','Bangla',91700.0,88.35,22.48).
city('Champahati','in','Bangla',8922.0,88.48,22.4).
city('Champdani','in','Bangla',103699.0,88.34,22.81).
city('Chandannagar','in','Bangla',180640.0,88.37,22.89).
city('Chandrakona','in','Bangla',21858.0,87.52,22.73).
city('Chittaranjan','in','Bangla',45309.0,86.9,23.86).
city('Contai','in','Bangla',88710.0,87.75,21.79).
city('Dalkola','in','Bangla',15287.0,87.85,25.85).
city('Darjiling','in','Bangla',123808.0,88.26,27.05).
city('Dhulagari','in','Bangla',21080.0,88.17,22.59).
city('Dhulian','in','Bangla',77078.0,87.97,24.68).
city('Dhupgari','in','Bangla',41172.0,89.02,26.6).
city('Diamond Harbour','in','Bangla',40099.0,88.18,22.19).
city('Digha','in','Bangla',3667.0,87.55,21.68).
city('Dinhata','in','Bangla',42401.0,89.47,26.13).
city('Dubrajpur','in','Bangla',35090.0,87.38,23.8).
city('Dum Dum','in','Bangla',122731.0,88.42,22.63).
city('Dumjor','in','Bangla',17973.0,88.22,22.64).
city('Durgapur','in','Bangla',518922.0,87.31,23.5).
city('Egra','in','Bangla',32866.0,87.53,21.9).
city('Falakata','in','Bangla',20120.0,89.2,26.53).
city('Farakka','in','Bangla',21836.0,87.9,24.82).
city('Fort Gloster','in','Bangla',18349.0,88.18,22.5).
city('Gangarampur','in','Bangla',65323.0,88.52,25.4).
city('Garbeta Amlagora','in','Bangla',33350.0,87.37,22.84).
city('Garui','in','Bangla',16499.0,88.4,22.63).
city('Garulia','in','Bangla',74404.0,88.37,22.83).
city('Gayespur','in','Bangla',55949.0,88.51,22.98).
city('Ghatal','in','Ban',54663.0,87.72,22.67).
city('Gobardanga','in','Bangla',43812.0,88.76,22.87).
city('Gobindapur','in','Bangla',11781.0,88.09,22.59).
city('Gopalpur','in','Bangla',6900.0,88.75,22.61).
city('Gopinathpur','in','Bangla',5255.0,86.07,22.65).
city('Gurdaha','in','Bangla',13103.0,88.76,22.73).
city('Guskhara','in','Bangla',33783.0,87.75,23.5).
city('Habra','in','Bangla',139310.0,88.62,22.84).
city('Haldia','in','Bangla',207466.0,88.09,22.08).
city('Haldibari','in','Bangla',14101.0,88.77,26.33).
city('Halisahar','in','Bangla',128184.0,88.42,22.95).
city('Haora','in','Bangla',1027771.0,88.33,22.58).
city('Harindanga','in','Bangla',6254.0,88.32,22.04).
city('Haringhata','in','Bangla',9705.0,88.57,22.95).
city('Haripur','in','Bangla',7327.0,88.23,22.94).
city('Hugli-Chunchura','in','Bangla',177022.0,88.4,22.91).
city('Ingraj Bazar','in','Bangla',170056.0,88.14,25.01).
city('Islampur','in','Bangla',55696.0,88.2,26.27).
city('Jafarpur','in','Bangla',14798.0,88.23,22.32).
city('Jalpaiguri','in','Bangla',107843.0,88.71,26.53).
city('Jamuria','in','Bangla',160257.0,87.08,23.7).
city('Jangipur','in','Bangla',82555.0,88.07,24.47).
city('Jaynagar-Majilpur','in','Bangla',24512.0,88.42,22.18).
city('Jhalida','in','Bangla',18059.0,85.97,23.37).
city('Jhargram','in','Bangla',57802.0,86.98,22.45).
city('Jiaganj-Azimganj','in','Bangla',49169.0,88.27,24.23).
city('Kalaikunda','in','Bangla',3232.0,87.25,22.35).
city('Kalimpong','in','Bangla',44488.0,88.48,27.07).
city('Kaliyaganj','in','Bangla',51753.0,88.32,25.63).
city('Kalna','in','Bangla',53969.0,88.37,23.22).
city('Kalyani','in','Bangla',93193.0,88.48,22.98).
city('Kamarhati','in','Bangla',332997.0,88.37,22.67).
city('Kanchrapara','in','Bangla',136967.0,88.45,22.95).
city('Kandi','in','Bangla',54853.0,88.03,23.95).
city('Kankuria','in','Bangla',28445.0,88.25,24.42).
city('Karimpur','in','Bangla',9565.0,88.62,23.97).
city('Karsiyang','in','Bangla',46431.0,88.28,26.88).
city('Kasimbazar','in','Bangla',10727.0,88.28,24.12).
city('Katwa','in','Bangla',78416.0,88.13,23.65).
city('Kenda','in','Bangla',15132.0,86.53,23.2).
city('Kesabpur','in','Bangla',10921.0,88.26,22.97).
city('Kharagpur','in','Bangla',219686.0,87.31,22.34).
city('Kharagpur Railway Settlement','in','Bangla',89610.0,87.26,22.34).
city('Kharar','in','Bangla',12051.0,87.68,22.7).
city('Khardaha','in','Bangla',128358.0,88.38,22.73).
city('Khatra','in','Bangla',16484.0,86.85,22.98).
city('Koch Bihar','in','Bangla',78744.0,89.46,26.33).
city('Konnagar','in','Bangla',76090.0,88.36,22.7).
city('Krishnanagar','in','Bangla',145941.0,88.51,23.41).
city('Krishnapur','in','Bangla',7336.0,88.27,22.67).
city('Kulti','in','Bangla',305434.0,86.89,23.72).
city('Madanpur','in','Bangla',12960.0,88.48,23.02).
city('Madhyamgram','in','Bangla',161142.0,88.45,22.7).
city('Maheshtala','in','Bangla',440936.0,88.23,22.51).
city('Mahiari','in','Bangla',17053.0,88.24,22.59).
city('Mahikpur','in','Bangla',19759.0,88.21,22.53).
city('Mahishadal','in','Bangla',17988.0,87.98,22.18).
city('Mainaguri','in','Bangla',29462.0,88.82,26.57).
city('Mal','in','Bangla',24278.0,88.74,26.85).
city('Masila','in','Bangla',11461.0,88.23,22.58).
city('Mathabhanga','in','Bangla',22644.0,89.2,26.35).
city('Memari','in','Bangla',44452.0,88.12,23.2).
city('Midnapur','in','Bangla',164704.0,87.15,22.33).
city('Mirik','in','Bangla',10110.0,88.17,26.9).
city('Monoharpur','in','Bangla',23364.0,88.08,22.11).
city('Muragachha','in','Bangla',10324.0,88.4,23.53).
city('Murshidabad','in','Bangla',39561.0,88.27,24.18).
city('Nabagram','in','Bangla',34731.0,88.51,22.29).
city('Naihati','in','Bangla',253245.0,88.43,22.91).
city('Nalhati','in','Bangla',25878.0,87.82,24.3).
city('Navadwip','in','Bangla',111134.0,88.37,23.42).
city('Ni Barakpur','in','Bangla',91537.0,88.36,22.77).
city('Noapara','in','Bangla',12208.0,88.98,22.53).
city('North Barakpur','in','Bangla',132907.0,88.37,22.78).
city('North Dum Dum','in','Bangla',235629.0,88.41,22.64).
city('Odlabari','in','Bangla',12311.0,88.62,26.83).
city('Ondal','in','Bangla',20791.0,87.24,23.57).
city('Panchla','in','Bangla',23528.0,88.14,22.54).
city('Pandua','in','Bangla',28208.0,88.28,23.08).
city('Panihati','in','Bangla',378741.0,88.37,22.69).
city('Patrasaer','in','Bangla',11520.0,87.52,23.22).
city('Patuli','in','Bangla',4694.0,88.25,23.55).
city('Phulia','in','Bangla',54845.0,88.5,23.24).
city('Pujali','in','Bangla',45415.0,88.15,22.47).
city('Puruliya','in','Bangla',122544.0,86.36,23.34).
city('Raghudebbati','in','Bangla',12834.0,88.2,22.53).
city('Raghunathpur','in','Bangla',22804.0,86.67,23.55).
city('Raiganj','in','Bangla',170268.0,88.12,25.62).
city('Rajarhat Gopalpur','in','Bangla',330164.0,88.27,22.52).
city('Rajpur','in','Bangla',444549.0,88.44,22.44).
city('Ramchandrapur','in','Bangla',9665.0,88.48,22.9).
city('Ramjibanpur','in','Bangla',18319.0,87.62,22.83).
city('Ramnagar','in','Bangla',5195.0,88.25,22.78).
city('Rampur Hat','in','Bangla',53473.0,87.78,24.17).
city('Ranaghat','in','Bangla',70991.0,88.58,23.19).
city('Raniganj','in','Bangla',131274.0,87.11,23.62).
city('Raypur','in','Bangla',6907.0,88.51,22.41).
city('Rishra','in','Bangla',117026.0,88.36,22.71).
city('Sahapur','in','Bangla',7883.0,88.17,22.52).
city('Sainthia','in','Bangla',43225.0,87.67,23.95).
city('Sankarpur','in','Bangla',6244.0,88.46,22.85).
city('Sankrail','in','Bangla',27526.0,88.22,22.55).
city('Santoshpur','in','Bangla',7636.0,88.27,22.53).
city('Sarenga','in','Bangla',21740.0,88.22,22.52).
city('Shantipur','in','Bangla',149998.0,88.44,23.26).
city('Shiliguri','in','Bangla',515623.0,88.42,26.73).
city('Shrirampur','in','Bangla',226338.0,88.35,22.74).
city('Singur','in','Bangla',19404.0,88.23,22.81).
city('Siuri','in','Bangla',64665.0,87.53,23.91).
city('Sodpur','in','Bangla',7038.0,88.39,22.71).
city('Sonamukhi','in','Bangla',28337.0,87.42,23.3).
city('South Dum Dum','in','Bangla',447586.0,88.41,22.61).
city('Srirampur','in','Bangla',18682.0,88.02,22.95).
city('Taki','in','Bangla',40117.0,88.92,22.59).
city('Tamluk','in','Bangla',48651.0,87.92,22.3).
city('Tarakeswar','in','Bangla',30478.0,88.02,22.89).
city('Titagarh','in','Bangla',127763.0,88.38,22.74).
city('Tufanganj','in','Bangla',20422.0,89.67,26.32).
city('Ula','in','Bangla',6324.0,88.56,22.72).
city('Ulubaria','in','Bangla',222293.0,88.11,22.47).
city('Uttarpara-Kotrung','in','Bangla',173444.0,88.35,22.66).
city('Amarpur','in','Bihar',22796.0,86.9,25.03).
city('Ara','in','Bihar',223700.0,84.66,25.56).
city('Araria','in','Bihar',67482.0,87.52,26.15).
city('Asarganj','in','Bihar',6020.0,86.68,25.15).
city('Aurangabad','in','Bihar',95939.0,84.37,24.75).
city('Bagaha','in','Bihar',103866.0,84.09,27.1).
city('Bahadurganj','in','Bihar',31408.0,87.82,26.27).
city('Bairgania','in','Bihar',37469.0,85.28,26.75).
city('Bakhtiyarpur','in','Bihar',34537.0,85.52,25.47).
city('Banka','in','Bihar',38943.0,86.92,24.88).
city('Banmankhi','in','Bihar',26809.0,87.18,25.88).
city('Bar Bigha','in','Bihar',41763.0,85.73,25.22).
city('Barauli','in','Bihar',37306.0,84.6,26.4).
city('Barh','in','Bihar',49562.0,85.72,25.48).
city('Barhiya','in','Bihar',43049.0,86.03,25.28).
city('Baruni','in','Bihar',84889.0,85.98,25.48).
city('Begusarai','in','Bihar',103071.0,86.12,25.42).
city('Behea','in','Bihar',22371.0,84.6,25.57).
city('Belsand','in','Bihar',19398.0,85.4,26.45).
city('Bettiah','in','Bihar',127022.0,84.5,26.81).
city('Bhabua','in','Bihar',48646.0,83.62,25.05).
city('Bhagalpur','in','Bihar',361587.0,86.98,25.26).
city('Bihar','in','Bihar',244256.0,85.52,25.21).
city('Bihariganj','in','Bihar',32806.0,86.98,25.73).
city('Bikramganj','in','Bihar',42631.0,84.25,25.2).
city('Birpur','in','Bihar',18970.0,87.02,26.52).
city('Bodh Gaya','in','Bihar',35192.0,84.98,24.71).
city('Buxar','in','Bihar',96130.0,83.98,25.58).
city('Chakia','in','Bihar',17833.0,85.05,26.42).
city('Chhapra','in','Bihar',197350.0,84.72,25.78).
city('Chhatapur','in','Bihar',23425.0,87.02,26.0).
city('Colgong','in','Bihar',24081.0,87.22,25.27).
city('Dalsingh Sarai','in','Bihar',21613.0,85.83,25.67).
city('Darbhanga','in','Bihar',287180.0,85.88,26.16).
city('Daudnagar','in','Bihar',41240.0,84.4,25.03).
city('Dehri','in','Bihar',129952.0,84.18,24.91).
city('Dhaka','in','Bihar',36115.0,85.17,26.68).
city('Dighwara','in','Bihar',29273.0,84.98,25.75).
city('Dinapur','in','Bihar',152956.0,85.04,25.64).
city('Dinapur Cantonment','in','Bihar',30077.0,85.01,25.64).
city('Dumra','in','Bihar',15780.0,85.52,26.57).
city('Dumraon','in','Bihar',50529.0,84.15,25.55).
city('Fatwa','in','Bihar',41652.0,85.32,25.52).
city('Forbesganj','in','Bihar',45103.0,87.25,26.3).
city('Gaya','in','Bihar',423737.0,85.0,24.81).
city('Gogri Jamalpur','in','Bihar',33883.0,86.67,25.42).
city('Gopalganj','in','Bihar',63731.0,84.43,26.47).
city('Hajipur','in','Bihar',133621.0,85.2,25.68).
city('Hilsa','in','Bihar',41115.0,85.28,25.32).
city('Hisua','in','Bihar',27946.0,85.42,24.83).
city('Islampur','in','Bihar',31879.0,85.2,25.15).
city('Jagdispur','in','Bihar',31032.0,84.42,25.48).
city('Jahanabad','in','Bihar',96397.0,84.98,25.22).
city('Jamalpur','in','Bihar',100791.0,86.48,25.32).
city('Jamui','in','Bihar',78189.0,86.22,24.92).
city('Janakpur Road','in','Bihar',15071.0,85.72,26.48).
city('Jaynagar','in','Bihar',20498.0,86.15,26.58).
city('Jha Jha','in','Bihar',38628.0,86.37,24.77).
city('Jhanjharpur','in','Bihar',31323.0,86.28,26.27).
city('Jogbani','in','Bihar',33303.0,87.25,26.42).
city('Kanti','in','Bihar',23001.0,85.3,26.22).
city('Kasba','in','Bihar',26940.0,87.55,25.85).
city('Katihar','in','Bihar',192575.0,87.57,25.55).
city('Khagaria','in','Bihar',49988.0,86.48,25.5).
city('Khagaul','in','Bihar',51583.0,85.05,25.58).
city('Kharagpur','in','Bihar',27495.0,86.55,25.12).
city('Kishanganj','in','Bihar',94817.0,87.95,26.11).
city('Koath','in','Bihar',16727.0,84.27,25.32).
city('Lakhisarai','in','Bihar',89509.0,86.09,25.18).
city('Lalganj','in','Bihar',31882.0,85.18,25.87).
city('Madhipura','in','Bihar',50575.0,86.78,25.92).
city('Madhubani','in','Bihar',71590.0,86.06,26.37).
city('Maharajganj','in','Bihar',22433.0,84.48,26.12).
city('Mahnar Bazar','in','Bihar',40120.0,85.43,25.62).
city('Mairwa','in','Bihar',20165.0,84.15,26.23).
city('Maner','in','Bihar',27904.0,84.88,25.65).
city('Manihari','in','Bihar',23734.0,87.63,25.35).
city('Marhaura','in','Bihar',26140.0,84.87,25.97).
city('Masaurhi','in','Bihar',53446.0,85.03,25.35).
city('Mohiuddinagar','in','Bihar',14940.0,85.67,25.58).
city('Mokama','in','Bihar',55209.0,85.92,25.4).
city('Motihari','in','Bihar',112156.0,84.91,26.66).
city('Munger','in','Bihar',203185.0,86.47,25.39).
city('Murliganj','in','Bihar',23846.0,86.98,25.9).
city('Muzaffarpur','in','Bihar',333235.0,85.38,26.13).
city('Nabinagar','in','Bihar',20851.0,84.12,24.62).
city('Narkatiaganj','in','Bihar',45206.0,84.46,27.11).
city('Nasriganj','in','Bihar',23287.0,84.33,25.05).
city('Naugachhia','in','Bihar',41251.0,87.1,25.4).
city('Nawada','in','Bihar',96740.0,85.54,24.88).
city('Nirmali','in','Bihar',17104.0,86.58,26.32).
city('Patna','in','Bihar',1600085.0,85.13,25.62).
city('Phulwari','in','Bihar',61928.0,85.13,25.6).
city('Piro','in','Bihar',28970.0,84.42,25.33).
city('Purnia','in','Bihar',198474.0,87.47,25.78).
city('Rafiganj','in','Bihar',26231.0,84.65,24.82).
city('Raghunathpur','in','Bihar',6100.0,87.9,25.63).
city('Rajgir','in','Bihar',38352.0,85.42,25.03).
city('Ramnagar','in','Bihar',43502.0,84.32,27.17).
city('Raxaul','in','Bihar',47970.0,84.85,26.98).
city('Revelganj','in','Bihar',37035.0,84.67,25.78).
city('Rusera','in','Bihar',28784.0,86.03,25.75).
city('Sagauli','in','Bihar',34626.0,84.73,26.78).
city('Saharsa','in','Bihar',145779.0,86.59,25.88).
city('Samastipur','in','Bihar',57602.0,85.78,25.85).
city('Sasaram','in','Bihar',145798.0,84.01,24.96).
city('Shahpur','in','Bihar',15852.0,84.45,25.58).
city('Shaikhpura','in','Bihar',46723.0,85.85,25.15).
city('Sherghati','in','Bihar',35283.0,84.78,24.57).
city('Shivhar','in','Bihar',24981.0,85.28,26.52).
city('Silao','in','Bihar',21830.0,85.42,25.08).
city('Sitamarhi','in','Bihar',57101.0,85.48,26.61).
city('Siwan','in','Bihar',119194.0,84.35,26.23).
city('Sonepur','in','Bihar',36036.0,85.18,25.7).
city('Sultanganj','in','Bihar',45029.0,86.73,25.24).
city('Supaul','in','Bihar',60027.0,86.6,26.12).
city('Teghra','in','Bihar',46161.0,85.95,25.48).
city('Tekari','in','Bihar',19065.0,84.83,24.93).
city('Thakurganj','in','Bihar',15955.0,88.13,26.45).
city('Waris Aliganj','in','Bihar',35247.0,85.63,25.02).
city('Chandigarh','in','Chandigarh',914374.0,76.78,30.75).
city('Akaltara','in','Chhattisgarh',21335.0,82.43,22.02).
city('Ambagarh Chauki','in','Chhattisgarh',9266.0,80.72,20.78).
city('Ambikapur','in','Chhattisgarh',72829.0,83.2,23.13).
city('Arang','in','Chhattisgarh',17505.0,81.97,21.2).
city('Baikunthpur','in','Chhattisgarh',10791.0,82.55,23.25).
city('Balod','in','Chhattisgarh',22277.0,81.2,20.73).
city('Baloda','in','Chhattisgarh',12039.0,82.48,22.15).
city('Baloda Bazar','in','Chhattisgarh',25238.0,82.17,21.67).
city('Basna','in','Chhattisgarh',9305.0,82.82,21.28).
city('Bemetra','in','Chhattisgarh',24912.0,81.54,21.74).
city('Bhanpuri','in','Chhattisgarh',17270.0,80.92,21.1).
city('Bhatapara','in','Chhattisgarh',51756.0,81.93,21.73).
city('Bhatgaon','in','Chhattisgarh',8045.0,81.7,21.15).
city('Bhilai','in','Chhattisgarh',625203.0,81.38,21.21).
city('Bilaspur','in','Chhattisgarh',282736.0,82.15,22.09).
city('Bodri','in','Chhattisgarh',14493.0,81.43,23.17).
city('Champa','in','Chhattisgarh',41257.0,82.65,22.05).
city('Charoda','in','Chhattisgarh',108737.0,81.5,21.23).
city('Chhuikhadan','in','Chhattisgarh',6485.0,80.98,21.53).
city('Chirmiri','in','Chhattisgarh',120919.0,82.41,23.21).
city('Deori','in','Chhattisgarh',12286.0,82.62,21.45).
city('Dhamtari','in','Chhattisgarh',87161.0,81.55,20.71).
city('Dongargaon','in','Chhattisgarh',12507.0,80.85,20.97).
city('Dongragarh','in','Chhattisgarh',35512.0,80.73,21.2).
city('Durg','in','Chhattisgarh',255310.0,81.28,21.2).
city('Gandai','in','Chhattisgarh',12477.0,81.1,21.67).
city('Gariaband','in','Chhattisgarh',10416.0,82.06,20.64).
city('Gaurela','in','Chhattisgarh',14593.0,81.9,22.75).
city('Gharghoda','in','Chhattisgarh',8513.0,83.35,22.17).
city('Gidam','in','Chhattisgarh',6228.0,81.4,18.98).
city('Gobra Nawapara','in','Chhattisgarh',27483.0,81.88,20.97).
city('Jagdalpur','in','Chhattisgarh',76473.0,82.03,19.09).
city('Jamui','in','Chhattisgarh',24186.0,81.4,21.25).
city('Jashpurnagar','in','Chhattisgarh',22609.0,84.15,22.9).
city('Kanker','in','Chhattisgarh',25987.0,81.49,20.27).
city('Katghora','in','Chhattisgarh',20115.0,82.55,22.5).
city('Kawardha','in','Chhattisgarh',35241.0,81.25,22.02).
city('Khairagarh','in','Chhattisgarh',15736.0,80.97,21.42).
city('Kharod','in','Chhattisgarh',8927.0,82.57,21.75).
city('Kharsia','in','Chhattisgarh',18258.0,83.12,21.97).
city('Kohka','in','Chhattisgarh',42949.0,81.76,21.22).
city('Kondagaon','in','Chhattisgarh',27630.0,81.67,19.6).
city('Korba','in','Chhattisgarh',419326.0,82.69,22.35).
city('Kota','in','Chhattisgarh',15584.0,82.03,22.3).
city('Kumhari','in','Chhattisgarh',38351.0,81.52,21.27).
city('Kurud','in','Chhattisgarh',11296.0,81.72,20.83).
city('Lormi','in','Chhattisgarh',12858.0,81.73,22.28).
city('Mahasamund','in','Chhattisgarh',50447.0,82.1,21.1).
city('Mahendragarh','in','Chhattisgarh',32491.0,82.2,23.22).
city('Mungeli','in','Chhattisgarh',27701.0,81.68,22.07).
city('Nailajanjgir','in','Chhattisgarh',35858.0,82.57,22.02).
city('New Chirimiri Ponry Hills Colliery','in','Chhattisgarh',20200.0,81.81,23.16).
city('Patan','in','Chhattisgarh',9333.0,81.53,21.03).
city('Pathalgaon','in','Chhattisgarh',15396.0,83.47,22.57).
city('Pendra','in','Chhattisgarh',12638.0,81.95,22.77).
city('Pithora','in','Chhattisgarh',7593.0,82.52,21.27).
city('Raigarh','in','Chhattisgarh',121291.0,83.39,21.9).
city('Raipur','in','Chhattisgarh',680066.0,81.63,21.24).
city('Rajhara','in','Chhattisgarh',48588.0,80.72,20.68).
city('Rajnandgaon','in','Chhattisgarh',150772.0,81.04,21.1).
city('Ramanuj Ganj','in','Chhattisgarh',10702.0,83.7,23.8).
city('Ratanpur','in','Chhattisgarh',21395.0,82.17,22.3).
city('Sakti','in','Chhattisgarh',21563.0,82.97,22.03).
city('Saraipali','in','Chhattisgarh',18396.0,83.0,21.33).
city('Sarangarh','in','Chhattisgarh',14617.0,83.08,21.6).
city('Simga','in','Chhattisgarh',12945.0,81.7,21.63).
city('Takhatpur','in','Chhattisgarh',17861.0,81.87,22.15).
city('Amli','in','Dadra and Nagar Haveli',33368.0,73.02,20.28).
city('Silvassa','in','Dadra and Nagar Haveli',27359.0,73.01,20.27).
city('Daman','in','Daman and D',39741.0,72.83,20.42).
city('Diu','in','Daman and Diu',23790.0,70.99,20.72).
city('Alipur','in','Delhi',20738.0,77.15,28.8).
city('Babarpur','in','Delhi',45998.0,77.27,28.69).
city('Bawana','in','Delhi',24908.0,77.03,28.8).
city('Bhalswa Jahangirpur','in','Delhi',180616.0,77.17,28.74).
city('Delhi','in','Delhi',1.092827E7,77.21,28.67).
city('Deoli','in','Delhi',175730.0,77.22,28.49).
city('Dilli Cantonment','in','Delhi',138336.0,77.16,28.57).
city('Gharonda','in','Delhi',40133.0,77.28,28.61).
city('Gokalpur','in','Delhi',114024.0,77.28,28.71).
city('Nangloi Jat','in','Delhi',194381.0,77.07,28.68).
city('Ni Dilli','in','Delhi',317949.0,77.22,28.6).
city('Sultanpur Majra','in','Delhi',189390.0,77.06,28.76).
city('Tigri','in','Delhi',49709.0,78.15,28.82).
city('Aldona','in','Goa',6606.0,73.87,15.58).
city('Bambolim','in','Goa',5441.0,73.85,15.45).
city('Bandora','in','Goa',12819.0,73.97,15.4).
city('Benaulim','in','Goa',10225.0,73.92,15.25).
city('Bicholim','in','Goa',15317.0,73.95,15.6).
city('Candolim','in','Goa',9198.0,73.75,15.52).
city('Carapur','in','Goa',5576.0,73.97,15.55).
city('Chicalim','in','Goa',7787.0,73.83,15.4).
city('Chinchinim','in','Goa',7356.0,73.97,15.2).
city('Colvale','in','Goa',5723.0,73.83,15.62).
city('Cortalim','in','Goa',7564.0,73.88,15.38).
city('Cuncolim','in','Goa',16124.0,73.98,15.17).
city('Curchorem','in','Goa',22512.0,74.1,15.25).
city('Curti','in','Goa',13662.0,74.02,15.42).
city('Davorlim','in','Goa',11418.0,73.98,15.25).
city('Goa Velha','in','Goa',5656.0,73.87,15.43).
city('Guirim','in','Goa',7058.0,73.8,15.58).
city('Jua','in','Goa',5470.0,73.93,15.53).
city('Kalangat','in','Goa',17447.0,73.75,15.53).
city('Kankon','in','Goa',12446.0,74.02,15.02).
city('Madgaon','in','Goa',86827.0,73.94,15.28).
city('Mapusa','in','Goa',43658.0,73.82,15.6).
city('Mormugao','in','Goa',102355.0,73.78,15.42).
city('Navelim','in','Goa',12470.0,73.98,15.53).
city('Pale','in','Goa',5428.0,74.08,15.47).
city('Panaji','in','Goa',65593.0,73.81,15.5).
city('Pernem','in','Goa',5555.0,73.8,15.72).
city('Ponda','in','Goa',18900.0,74.02,15.4).
city('Quepem','in','Goa',13042.0,74.07,15.22).
city('Queula','in','Goa',5699.0,73.97,15.38).
city('Raia','in','Goa',9421.0,73.97,15.3).
city('Saligao','in','Goa',5804.0,73.77,15.55).
city('Sancoale','in','Goa',16312.0,73.9,15.37).
city('Sanguem','in','Goa',6120.0,74.17,15.23).
city('Sanquelim','in','Goa',11698.0,74.0,15.58).
city('Sanvordem','in','Goa',5051.0,74.12,15.27).
city('Serula','in','Goa',10632.0,73.83,15.53).
city('Siolim','in','Goa',10481.0,73.77,15.62).
city('Taleigao','in','Goa',17148.0,73.8,15.47).
city('Valpoi','in','Goa',8331.0,74.13,15.53).
city('Varca','in','Goa',5079.0,73.92,15.22).
city('Adalaj','in','Gujarat',10423.0,72.58,23.17).
city('Ahmadabad','in','Gujarat',3719933.0,72.58,23.03).
city('Ahwa','in','Gujarat',14321.0,73.68,20.75).
city('Amod','in','Gujarat',18742.0,72.9,21.98).
city('Amreli','in','Gujarat',99748.0,71.22,21.61).
city('Amroli','in','Gujarat',17082.0,72.85,21.3).
city('Anand','in','Gujarat',138018.0,72.95,22.56).
city('Anjar','in','Gujarat',66887.0,70.02,23.12).
city('Anklesvar','in','Gujarat',74747.0,72.98,21.63).
city('Babra','in','Gujarat',18993.0,71.3,21.85).
city('Bagasara','in','Gujarat',32946.0,70.95,21.48).
city('Balasinor','in','Gujarat',35151.0,73.33,22.95).
city('Bansda','in','Gujarat',12702.0,73.37,20.75).
city('Bantva','in','Gujarat',15052.0,70.08,21.48).
city('Bardoli','in','Gujarat',57814.0,73.12,21.12).
city('Bavla','in','Gujarat',32964.0,72.37,22.83).
city('Bedi','in','Gujarat',21328.0,70.05,22.5).
city('Bhachau','in','Gujarat',24044.0,70.35,23.28).
city('Bhanvad','in','Gujarat',20824.0,69.78,21.93).
city('Bharuch','in','Gujarat',153538.0,72.97,21.71).
city('Bhavnagar','in','Gujarat',555014.0,72.13,21.79).
city('Bhayavadar','in','Gujarat',19458.0,70.25,21.85).
city('Bhuj','in','Gujarat',133458.0,69.66,23.26).
city('Bilimora','in','Gujarat',54582.0,72.95,20.78).
city('Bilkha','in','Gujarat',14421.0,70.6,21.43).
city('Borsad','in','Gujarat',60275.0,72.9,22.42).
city('Botad','in','Gujarat',117060.0,71.66,22.18).
city('Chaklasi','in','Gujarat',38434.0,72.93,22.65).
city('Chalala','in','Gujarat',17082.0,71.17,21.42).
city('Chanasma','in','Gujarat',15573.0,72.12,23.72).
city('Chandkheda','in','Gujarat',65080.0,72.61,23.15).
city('Chandlodiya','in','Gujarat',66775.0,72.56,23.1).
city('Chaya','in','Gujarat',44314.0,69.63,21.61).
city('Chhota Udaipur','in','Gujarat',24519.0,74.01,22.32).
city('Chikhli','in','Gujarat',7487.0,73.07,20.75).
city('Chotila','in','Gujarat',15197.0,71.18,22.42).
city('Dabhoi','in','Gujarat',56257.0,73.41,22.13).
city('Dahegam','in','Gujarat',40674.0,72.82,23.17).
city('Dahod','in','Gujarat',83972.0,74.25,22.84).
city('Dakor','in','Gujarat',25020.0,73.15,22.75).
city('Damnagar','in','Gujarat',17767.0,71.52,21.7).
city('Delvada','in','Gujarat',11912.0,71.03,20.77).
city('Devgadh Baria','in','Gujarat',19704.0,73.9,22.71).
city('Dhandhuka','in','Gujarat',30051.0,71.98,22.37).
city('Dhanera','in','Gujarat',23656.0,72.02,24.52).
city('Dharampur','in','Gujarat',21209.0,73.18,20.53).
city('Dhari','in','Gujarat',29346.0,71.02,21.33).
city('Dhola','in','Gujarat',8206.0,71.78,21.88).
city('Dholka','in','Gujarat',54981.0,72.44,22.74).
city('Dhoraji','in','Gujarat',81450.0,70.44,21.74).
city('Dhrangadhra','in','Gujarat',75582.0,71.46,23.0).
city('Dhrol','in','Gujarat',26497.0,70.42,22.57).
city('Dhuwaran','in','Gujarat',11473.0,72.8,22.23).
city('Disa','in','Gujarat',92230.0,72.18,24.26).
city('Dungarpur','in','Gujarat',6105.0,71.73,21.28).
city('Dungra','in','Gujarat',26150.0,72.91,20.48).
city('Dwarka','in','Gujarat',35839.0,68.97,22.23).
city('Gadhda','in','Gujarat',28613.0,71.55,21.97).
city('Gandevi','in','Gujarat',16241.0,72.98,20.82).
city('Gandhidham','in','Gujarat',136605.0,70.13,23.07).
city('Gandhinagar','in','Gujarat',231314.0,72.63,23.3).
city('Gariadhar','in','Gujarat',35695.0,71.58,21.53).
city('Ghatlodiya','in','Gujarat',128917.0,72.55,23.05).
city('Ghogha','in','Gujarat',11362.0,72.28,21.68).
city('Godhra','in','Gujarat',131921.0,73.6,22.77).
city('Gondal','in','Gujarat',101808.0,70.8,21.97).
city('Halol','in','Gujarat',45744.0,73.47,22.5).
city('Halvad','in','Gujarat',26207.0,71.18,23.02).
city('Hansot','in','Gujarat',12525.0,72.8,21.58).
city('Harij','in','Gujarat',18965.0,71.9,23.7).
city('Himatnagar','in','Gujarat',60638.0,72.96,23.6).
city('Idar','in','Gujarat',31316.0,73.0,23.83).
city('Jalalpore','in','Gujarat',17325.0,72.9,20.97).
city('Jambusar','in','Gujarat',41596.0,72.8,22.05).
city('Jamnagar','in','Gujarat',492087.0,70.07,22.47).
city('Jasdan','in','Gujarat',43864.0,71.2,22.03).
city('Jetalsar','in','Gujarat',14771.0,70.58,21.7).
city('Jetpur','in','Gujarat',63261.0,72.22,22.05).
city('Jodiya','in','Gujarat',15788.0,70.28,22.72).
city('Junagadh','in','Gujarat',184459.0,70.45,21.52).
city('Kadi','in','Gujarat',58070.0,72.33,23.31).
city('Kalavad','in','Gujarat',26289.0,70.38,22.22).
city('Kali','in','Gujarat',35736.0,72.61,23.1).
city('Kalol','in','Gujarat',66445.0,72.97,22.93).
city('Kandla','in','Gujarat',25845.0,70.22,23.03).
city('Kanodar','in','Gujarat',11954.0,72.38,24.1).
city('Kapadwanj','in','Gujarat',44767.0,73.07,23.02).
city('Karamsad','in','Gujarat',32382.0,72.9,22.55).
city('Kathor','in','Gujarat',15311.0,72.93,21.3).
city('Kavant','in','Gujarat',8618.0,74.05,22.1).
city('Keshod','in','Gujarat',68523.0,70.23,21.31).
city('Khambhaliya','in','Gujarat',38123.0,69.65,22.2).
city('Khambhat','in','Gujarat',81334.0,72.61,22.32).
city('Khed Brahma','in','Gujarat',29404.0,73.05,24.03).
city('Kheda','in','Gujarat',24768.0,72.68,22.75).
city('Kheralu','in','Gujarat',20757.0,72.62,23.88).
city('Kodinar','in','Gujarat',34933.0,70.7,20.78).
city('Kosamba','in','Gujarat',33221.0,72.95,21.48).
city('Kundla','in','Gujarat',76814.0,71.3,21.35).
city('Kutiyana','in','Gujarat',16879.0,69.98,21.63).
city('Lakhtar','in','Gujarat',14534.0,71.78,22.85).
city('Lalpur','in','Gujarat',15076.0,69.97,22.2).
city('Lathi','in','Gujarat',22747.0,71.38,21.72).
city('Limbdi','in','Gujarat',41743.0,71.8,22.57).
city('Lunavada','in','Gujarat',35433.0,73.62,23.13).
city('Mahemdavad','in','Gujarat',32506.0,72.77,22.83).
city('Mahesana','in','Gujarat',102675.0,72.38,23.6).
city('Mahudha','in','Gujarat',16828.0,72.93,22.82).
city('Mahuva','in','Gujarat',74625.0,71.75,21.1).
city('Malia','in','Gujarat',14423.0,70.77,23.08).
city('Malpur','in','Gujarat',6972.0,73.45,23.35).
city('Manavadar','in','Gujarat',29107.0,70.13,21.5).
city('Mandal','in','Gujarat',13345.0,71.92,23.3).
city('Mandvi','in','Gujarat',33261.0,71.34,22.04).
city('Mangrol','in','Gujarat',58993.0,70.12,21.12).
city('Mansa','in','Gujarat',29553.0,72.67,23.43).
city('Meghraj','in','Gujarat',10498.0,73.5,23.5).
city('Memnagar','in','Gujarat',44011.0,72.54,23.04).
city('Modasa','in','Gujarat',58974.0,73.3,23.47).
city('Morvi','in','Gujarat',118021.0,70.83,22.82).
city('Mundra','in','Gujarat',15219.0,69.73,22.85).
city('Nadiad','in','Gujarat',202080.0,72.85,22.7).
city('Naliya','in','Gujarat',10586.0,68.83,23.27).
city('Naroda','in','Gujarat',5366.0,72.67,23.08).
city('Navsari','in','Gujarat',136204.0,72.92,20.96).
city('Okha','in','Gujarat',21049.0,69.08,22.47).
city('Olpad','in','Gujarat',14091.0,72.75,21.33).
city('Paddhari','in','Gujarat',9702.0,70.6,22.43).
city('Padra','in','Gujarat',36501.0,73.08,22.23).
city('Palanpur','in','Gujarat',123301.0,72.43,24.17).
city('Palitana','in','Gujarat',55916.0,71.83,21.52).
city('Paliyad','in','Gujarat',10862.0,71.57,22.25).
city('Pardi','in','Gujarat',27425.0,72.95,20.52).
city('Parnera','in','Gujarat',11435.0,72.95,20.55).
city('Patan','in','Gujarat',74128.0,71.27,22.37).
city('Petlad','in','Gujarat',51823.0,72.79,22.48).
city('Porbandar','in','Gujarat',138881.0,69.6,21.65).
city('Prantij','in','Gujarat',22780.0,72.86,23.44).
city('Radhanpur','in','Gujarat',35459.0,71.6,23.83).
city('Rajkot','in','Gujarat',1177434.0,70.79,22.31).
city('Rajpipla','in','Gujarat',35394.0,73.5,21.87).
city('Rajula','in','Gujarat',34655.0,71.43,21.05).
city('Ranavav','in','Gujarat',26012.0,69.75,21.68).
city('Ranip','in','Gujarat',99871.0,72.54,23.03).
city('Rapar','in','Gujarat',21507.0,70.63,23.57).
city('Sachin','in','Gujarat',12661.0,72.88,21.08).
city('Salaya','in','Gujarat',30230.0,69.6,22.32).
city('Sanand','in','Gujarat',35035.0,72.38,22.98).
city('Sankheda','in','Gujarat',12077.0,73.58,22.17).
city('Sarkhej','in','Gujarat',30350.0,72.5,22.98).
city('Sayla','in','Gujarat',15376.0,71.47,22.55).
city('Shahpur','in','Gujarat',12867.0,70.77,22.15).
city('Shivrajpur','in','Gujarat',6705.0,73.65,22.42).
city('Siddhapur','in','Gujarat',54317.0,72.37,23.92).
city('Sihor','in','Gujarat',52606.0,71.97,21.7).
city('Sika','in','Gujarat',19406.0,69.83,22.43).
city('Sinor','in','Gujarat',11267.0,73.33,21.92).
city('Sojitra','in','Gujarat',19403.0,72.72,22.55).
city('Songadh','in','Gujarat',25270.0,73.57,21.17).
city('Surat','in','Gujarat',2894675.0,72.82,21.2).
city('Surendranagar','in','Gujarat',179640.0,71.67,22.71).
city('Talaja','in','Gujarat',29950.0,72.05,21.35).
city('Tankara','in','Gujarat',10175.0,70.73,22.67).
city('Thangad','in','Gujarat',42511.0,71.18,22.57).
city('Tharad','in','Gujarat',24698.0,71.63,24.4).
city('Thasra','in','Gujarat',18337.0,73.22,22.8).
city('Umrala','in','Gujarat',11874.0,71.82,21.83).
city('Umreth','in','Gujarat',32804.0,73.12,22.7).
city('Una','in','Gujarat',56549.0,71.03,20.82).
city('Unjha','in','Gujarat',54623.0,72.38,23.81).
city('Upleta','in','Gujarat',56357.0,70.27,21.75).
city('Utran','in','Gujarat',14856.0,72.87,21.23).
city('Vadnagar','in','Gujarat',24833.0,72.63,23.78).
city('Vadodara','in','Gujarat',1409565.0,73.18,22.31).
city('Vaghodia','in','Gujarat',14606.0,73.38,22.3).
city('Valbhipur','in','Gujarat',18662.0,71.86,21.88).
city('Valsad','in','Gujarat',72934.0,72.92,20.62).
city('Vapi','in','Gujarat',92225.0,72.9,20.37).
city('Vapi INA','in','Gujarat',28546.0,72.9,20.4).
city('Vartej','in','Gujarat',10272.0,72.07,21.73).
city('Vejalpur','in','Gujarat',121618.0,73.56,22.68).
city('Veraval','in','Gujarat',163336.0,70.34,20.92).
city('Vidyanagar','in','Gujarat',32583.0,72.9,22.53).
city('Vijapur','in','Gujarat',24299.0,72.75,23.57).
city('Viramgam','in','Gujarat',53670.0,72.03,23.13).
city('Virpur','in','Gujarat',8866.0,73.48,23.18).
city('Visavadar','in','Gujarat',18383.0,70.68,21.38).
city('Visnagar','in','Gujarat',68623.0,72.54,23.71).
city('Vyara','in','Gujarat',38171.0,73.4,21.12).
city('Wadhwan','in','Gujarat',66469.0,71.72,22.73).
city('Waghai','in','Gujarat',6462.0,73.48,20.77).
city('Wankaner','in','Gujarat',47813.0,70.93,22.62).
city('Ambala','in','Haryana',146797.0,76.77,30.38).
city('Ambala Cantonment','in','Haryana',66820.0,76.86,30.39).
city('Ambala Sadar','in','Haryana',112312.0,76.84,30.35).
city('Asandh','in','Haryana',25325.0,76.6,29.52).
city('Ateli','in','Haryana',6177.0,76.28,28.1).
city('Bahadurgarh','in','Haryana',153666.0,76.92,28.69).
city('Barwala','in','Haryana',36696.0,75.92,29.38).
city('Bawal','in','Haryana',13319.0,76.58,28.08).
city('Beri','in','Haryana',16729.0,76.58,28.7).
city('Bhiwani','in','Haryana',190868.0,76.12,28.81).
city('Bilaspur','in','Haryana',10710.0,77.32,30.32).
city('Charkhi Dadri','in','Haryana',50562.0,76.27,28.6).
city('Chhachhrauli','in','Haryana',10751.0,77.37,30.25).
city('Chita','in','Haryana',37425.0,76.37,30.05).
city('Dabwali','in','Haryana',62118.0,74.73,29.95).
city('Dharughera','in','Haryana',23134.0,76.77,28.22).
city('Ellenabad','in','Haryana',37683.0,74.65,29.45).
city('Faridabad','in','Haryana',1280909.0,77.3,28.38).
city('Farrukhnagar','in','Haryana',10092.0,76.82,28.45).
city('Fatehabad','in','Haryana',66017.0,75.45,29.52).
city('Firozpur Jhirka','in','Haryana',20196.0,76.95,27.8).
city('Gannaur','in','Haryana',32602.0,77.02,29.04).
city('Ghraunda','in','Haryana',34310.0,76.97,29.55).
city('Gohana','in','Haryana',56097.0,76.7,29.13).
city('Gurgaon','in','Haryana',197353.0,77.01,28.47).
city('Hansi','in','Haryana',82412.0,75.95,29.11).
city('Hasanpur','in','Haryana',9906.0,77.5,27.97).
city('Hisar','in','Haryana',296456.0,75.72,29.16).
city('Hodal','in','Haryana',44304.0,77.37,27.9).
city('Indri','in','Haryana',15955.0,77.07,29.88).
city('Jagadhri','in','Haryana',112590.0,77.29,30.18).
city('Jakhal Mandi','in','Haryana',7411.0,75.83,29.8).
city('Jhajjar','in','Haryana',44125.0,76.65,28.62).
city('Jind','in','Haryana',161271.0,76.3,29.31).
city('Julana','in','Haryana',14509.0,76.42,29.13).
city('Kaithal','in','Haryana',140614.0,76.4,29.81).
city('Kalanwali','in','Haryana',27357.0,74.95,29.85).
city('Kalka','in','Haryana',32207.0,76.93,30.83).
city('Kanina','in','Haryana',10816.0,76.32,28.33).
city('Karnal','in','Haryana',225064.0,76.97,29.69).
city('Ladwa','in','Haryana',23567.0,77.05,29.98).
city('Loharu','in','Haryana',12411.0,75.82,28.45).
city('Maham','in','Haryana',19385.0,76.3,28.98).
city('Mahendragarh','in','Haryana',25730.0,76.15,28.28).
city('Mustafabad','in','Haryana',8975.0,77.15,30.2).
city('Narayangarh','in','Haryana',20087.0,77.13,30.48).
city('Narnaul','in','Haryana',66053.0,76.1,28.04).
city('Narnaund','in','Haryana',16300.0,76.15,29.22).
city('Narwana','in','Haryana',55854.0,76.12,29.62).
city('Nilokheri','in','Haryana',17361.0,76.92,29.83).
city('Nuh','in','Haryana',12699.0,77.02,28.12).
city('Palwal','in','Haryana',121974.0,77.32,28.15).
city('Panchkula','in','Haryana',181910.0,76.88,30.7).
city('Panipat','in','Haryana',292828.0,76.96,29.39).
city('Pehowa','in','Haryana',39104.0,76.58,29.98).
city('Pinjaur','in','Haryana',32164.0,76.92,30.8).
city('Punahana','in','Haryana',15.0,77.2,27.87).
city('Pundri','in','Haryana',17534.0,76.55,29.75).
city('Radaur','in','Haryana',12329.0,77.15,30.03).
city('Rania','in','Haryana',22741.0,74.83,29.53).
city('Ratiya','in','Haryana',26526.0,75.56,29.7).
city('Rewari','in','Haryana',112087.0,76.6,28.19).
city('Rohtak','in','Haryana',317266.0,76.58,28.9).
city('Safidon','in','Haryana',30865.0,76.67,29.42).
city('Samalkha','in','Haryana',35622.0,77.02,29.23).
city('Shahabad','in','Haryana',39325.0,76.88,30.17).
city('Sirsa','in','Haryana',181652.0,75.03,29.53).
city('Siwani','in','Haryana',18016.0,75.62,28.92).
city('Sohna','in','Haryana',33363.0,77.07,28.25).
city('Sonipat','in','Haryana',250538.0,77.01,28.99).
city('Taoru','in','Haryana',19312.0,76.95,28.22).
city('Thanesar','in','Haryana',138288.0,76.82,29.98).
city('Tohana','in','Haryana',59753.0,75.9,29.7).
city('Tosham','in','Haryana',12529.0,75.92,28.88).
city('Uchana','in','Haryana',15831.0,76.17,29.47).
city('Uklana Mandi','in','Haryana',1190.0,75.87,29.52).
city('Yamunanagar','in','Haryana',208945.0,77.28,30.14).
city('Arki','in','Himachal Pradesh',3293.0,76.97,31.15).
city('Bakloh','in','Himachal Pradesh',1737.0,75.92,32.47).
city('Banjar','in','Himachal Pradesh',1351.0,77.35,31.63).
city('Bilaspur','in','Himachal Pradesh',14038.0,76.75,31.33).
city('Chamba','in','Himachal Pradesh',21504.0,76.13,32.57).
city('Chaupal','in','Himachal Pradesh',1701.0,77.58,30.95).
city('Chuari Khas','in','Himachal Pradesh',3431.0,76.02,32.43).
city('Dagshai','in','Himachal Pradesh',2994.0,77.0,30.88).
city('Dalhousie','in','Himachal Pradesh',7602.0,75.98,32.53).
city('Daulatpur','in','Himachal Pradesh',3592.0,76.25,32.06).
city('Dera Gopipur','in','Himachal Pradesh',4735.0,76.22,31.9).
city('Dharamshala','in','Himachal Pradesh',19542.0,76.28,32.24).
city('Gagret','in','Himachal Pradesh',3026.0,76.07,31.67).
city('Ghamarwin','in','Himachal Pradesh',6691.0,76.72,31.45).
city('Hamirpur','in','Himachal Pradesh',19281.0,76.52,31.68).
city('Jawala Mukhi','in','Himachal Pradesh',5281.0,76.32,31.88).
city('Jogindarnagar','in','Himachal Pradesh',5234.0,76.77,31.98).
city('Jubbal','in','Himachal Pradesh',1327.0,77.67,31.12).
city('Jutogh','in','Himachal Pradesh',2470.0,77.12,31.1).
city('Kangra','in','Himachal Pradesh',9159.0,76.27,32.1).
city('Kasauli','in','Himachal Pradesh',5215.0,76.95,30.92).
city('Kot Khai','in','Himachal Pradesh',1253.0,77.53,31.12).
city('Kulu','in','Himachal Pradesh',19832.0,77.1,31.97).
city('Manali','in','Himachal Pradesh',8344.0,77.17,32.27).
city('Mandi','in','Himachal Pradesh',28219.0,76.92,31.72).
city('Nadaun','in','Himachal Pradesh',4838.0,76.35,31.78).
city('Nahan','in','Himachal Pradesh',27547.0,77.3,30.55).
city('Nalagarh','in','Himachal Pradesh',10250.0,76.72,31.05).
city('Narkanda','in','Himachal Pradesh',718.0,77.45,31.27).
city('Nurpur','in','Himachal Pradesh',9438.0,76.48,31.17).
city('Palampur','in','Himachal Pradesh',4131.0,76.53,32.12).
city('Pandoh','in','Himachal Pradesh',4351.0,77.05,31.68).
city('Paonta Sahib','in','Himachal Pradesh',21788.0,77.62,30.45).
city('Rajgarh','in','Himachal Pradesh',2866.0,77.3,30.85).
city('Rampur','in','Himachal Pradesh',6206.0,77.63,31.45).
city('Rohru','in','Himachal Pradesh',8164.0,77.75,31.22).
city('Sabathu','in','Himachal Pradesh',6692.0,76.98,30.98).
city('Santokhgarh','in','Himachal Pradesh',8878.0,76.32,31.37).
city('Sarahan','in','Himachal Pradesh',1495.0,77.8,31.52).
city('Sarka Ghat','in','Himachal Pradesh',3944.0,76.73,31.7).
city('Seoni','in','Himachal Pradesh',1630.0,77.12,31.25).
city('Shimla','in','Himachal Pradesh',173517.0,77.16,31.11).
city('Solon','in','Himachal Pradesh',40286.0,77.12,30.92).
city('Sundarnagar','in','Himachal Pradesh',25340.0,76.88,31.53).
city('Theog','in','Himachal Pradesh',4191.0,77.35,31.12).
city('Tira Sujanpur','in','Himachal Pradesh',7748.0,76.5,31.83).
city('Una','in','Himachal Pradesh',17570.0,76.28,31.48).
city('Yol','in','Himachal Pradesh',11315.0,76.2,32.17).
city('Akhnur','in','Jammu and Kashmir',12803.0,74.73,32.87).
city('Anantnag','in','Jammu and Kashmir',79827.0,75.15,33.73).
city('Arnia','in','Jammu and Kashmir',9662.0,74.8,32.52).
city('Badgam','in','Jammu and Kashmir',20948.0,74.72,34.02).
city('Bandipur','in','Jammu and Kashmir',31980.0,74.65,34.42).
city('Banihal','in','Jammu and Kashmir',3278.0,75.2,33.42).
city('Baramula','in','Jammu and Kashmir',77282.0,74.35,34.2).
city('Batote','in','Jammu and Kashmir',4209.0,75.32,33.1).
city('Bhaderwah','in','Jammu and Kashmir',13430.0,75.72,32.98).
city('Bijbiara','in','Jammu and Kashmir',24592.0,75.09,33.8).
city('Bishna','in','Jammu and Kashmir',11646.0,74.87,32.62).
city('Doda','in','Jammu and Kashmir',17755.0,75.57,33.13).
city('Gulmarg','in','Jammu and Kashmir',730.0,74.38,34.05).
city('Hajan','in','Jammu and Kashmir',10800.0,74.62,34.3).
city('Handwara','in','Jammu and Kashmi',12639.0,74.28,34.4).
city('Hiranagar','in','Jammu and Kashmir',9447.0,75.27,32.45).
city('Jammu','in','Jammu and Kashmir',465600.0,74.85,32.71).
city('Kargil','in','Jammu and Kashmir',13843.0,76.1,34.57).
city('Kathua','in','Jammu and Kashmir',48555.0,75.52,32.37).
city('Katra','in','Jammu and Kashmir',9107.0,74.95,32.98).
city('Khour','in','Jammu and Kashmir',6690.0,74.8,32.6).
city('Kishtwar','in','Jammu and Kashmir',20561.0,75.77,33.32).
city('Kud','in','Jammu and Kashmir',1242.0,75.28,33.08).
city('Kulgam','in','Jammu and Kashmir',16247.0,75.02,33.65).
city('Leh','in','Jammu and Kashmir',37498.0,77.58,34.17).
city('Magam','in','Jammu and Kashmir',4690.0,74.58,34.08).
city('Naushehra','in','Jammu and Kashmir',5187.0,74.23,33.16).
city('Pahalgam','in','Jammu and Kashmir',7753.0,75.33,34.03).
city('Parole','in','Jammu and Kashmir',7801.0,75.43,32.35).
city('Pattan','in','Jammu and Kashmir',14971.0,74.57,34.17).
city('Pulwama','in','Jammu and Kashmir',20073.0,74.92,33.88).
city('Qazigund','in','Jammu and Kashmir',5578.0,75.15,33.63).
city('Rajauri','in','Jammu and Kashmir',27803.0,74.3,33.38).
city('Ramban','in','Jammu and Kashmir',7320.0,75.25,33.25).
city('Ramgarh','in','Jammu and Kashmir',4945.0,74.2,33.4).
city('Ramnagar','in','Jammu and Kashmir',8167.0,75.32,32.82).
city('Samba','in','Jammu and Kashmir',26903.0,75.12,32.57).
city('Shupiyan','in','Jammu and Kashmir',13566.0,74.83,33.72).
city('Sopur','in','Jammu and Kashmir',63039.0,74.47,34.3).
city('Srinagar','in','Jammu and Kashmir',975926.0,74.79,34.09).
city('Sumbal','in','Jammu and Kashmir',11694.0,74.63,34.23).
city('Tral','in','Jammu and Kashmir',13257.0,75.1,33.93).
city('Udhampur','in','Jammu and Kashmir',80478.0,75.13,32.93).
city('Uri','in','Jammu and Kashmir',6757.0,74.03,34.08).
city('Adityapur','in','Jharkhand',139531.0,86.04,22.8).
city('Bagbahra','in','Jharkhand',71149.0,86.2,22.82).
city('Barhi','in','Jharkhand',10655.0,85.42,24.3).
city('Barka Kana','in','Jharkhand',18184.0,85.48,23.62).
city('Barki Saraiya','in','Jharkhand',24134.0,85.87,24.19).
city('Barwadih','in','Jharkhand',7402.0,84.12,23.83).
city('Bermo','in','Jharkhand',16861.0,85.89,23.77).
city('Bhagatdih','in','Jharkhand',34425.0,86.4,23.76).
city('Bhaurah','in','Jharkhand',43735.0,86.39,23.72).
city('Bhojudih','in','Jharkhand',9110.0,86.45,23.63).
city('Bhuli','in','Jharkhand',106001.0,86.38,23.79).
city('Bokaro','in','Jharkhand',418578.0,85.96,23.78).
city('Bokaro Civil Township','in','Jharkhand',39898.0,86.0,23.75).
city('Bundu','in','Jharkhand',19469.0,85.58,23.18).
city('Chaibasa','in','Jharkhand',66259.0,85.8,22.56).
city('Chakradharpur','in','Jharkhand',40604.0,85.61,22.68).
city('Chakulia','in','Jh',14953.0,86.72,22.48).
city('Chandil','in','Jharkhand',4657.0,86.05,22.97).
city('Chas','in','Jharkhand',112153.0,86.17,23.65).
city('Chatra','in','Jharkhand',46849.0,84.87,24.22).
city('Chiria','in','Jharkhand',3947.0,85.27,22.3).
city('Chirkunda','in','Jharkhand',41353.0,86.42,23.82).
city('Daltenganj','in','Jharkhand',77712.0,84.06,24.05).
city('Devghar','in','Jharkhand',107897.0,86.69,24.49).
city('Dhanbad','in','Jharkhand',219660.0,86.42,23.8).
city('Dhanwar','in','Jharkhand',8512.0,85.98,24.42).
city('Dugda','in','Jharkhand',20402.0,86.17,23.75).
city('Dumka','in','Jharkhand',47668.0,87.25,24.27).
city('Garwa','in','Jharkhand',40666.0,83.82,24.18).
city('Ghatsila','in','Jharkhand',40022.0,86.48,22.6).
city('Gobindpur','in','Jharkhand',18289.0,86.29,23.23).
city('Godda','in','Jharkhand',43663.0,87.22,24.83).
city('Gomoh','in','Jharkhand',31398.0,86.17,23.87).
city('Gua','in','Jharkhand',11390.0,85.38,22.2).
city('Gumia','in','Jharkhand',47127.0,85.82,23.78).
city('Gumla','in','Jharkhand',44956.0,84.55,23.05).
city('Hazaribag','in','Jharkhand',140079.0,85.36,24.01).
city('Hesla','in','Jharkhand',6286.0,85.88,24.07).
city('Husainabad','in','Jharkhand',26187.0,84.02,24.53).
city('Jagannathpur','in','Jharkhand',7020.0,85.65,22.23).
city('Jamadoba','in','Jharkhand',34778.0,86.4,23.72).
city('Jamshedpur','in','Jharkhand',616404.0,86.2,22.79).
city('Jamtara','in','Jharkhand',24391.0,86.8,23.95).
city('Jarangdih','in','Jharkhand',32279.0,86.1,23.66).
city('Jaridih','in','Jharkhand',107299.0,86.3,24.19).
city('Jasidih','in','Jharkhand',16339.0,86.65,24.52).
city('Jharia','in','Jharkhand',86947.0,86.42,23.76).
city('Jhumri Tilaiya','in','Jharkhand',76350.0,85.52,24.43).
city('Jorapokhar','in','Jharkhand',90138.0,86.36,23.79).
city('Jugsalai','in','Jharkhand',49411.0,86.18,22.77).
city('Kalikapur','in','Jharkhand',4061.0,86.28,22.62).
city('Kandra','in','Jharkhand',6902.0,86.05,22.85).
city('Kanke','in','Jharkhand',16714.0,85.32,23.43).
city('Katras','in','Jharkhand',57355.0,86.28,23.8).
city('Kenduadih','in','Jharkhand',9033.0,86.38,23.78).
city('Kharsawan','in','Jharkhand',7217.0,85.83,22.8).
city('Khunti','in','Jharkhand',31370.0,85.28,23.08).
city('Kiri Buru','in','Jharkhand',9720.0,85.35,22.08).
city('Kodarma','in','Jharkhand',19182.0,85.6,24.47).
city('Kuju','in','Jharkhand',19392.0,85.5,23.72).
city('Latehar','in','Jharkhand',20771.0,84.5,23.75).
city('Lohardaga','in','Jharkhand',53037.0,84.68,23.43).
city('Loyabad','in','Jharkhand',33165.0,86.67,23.67).
city('Madhupur','in','Jharkhand',50677.0,86.65,24.25).
city('Malkera','in','Jharkhand',12593.0,86.3,23.78).
city('Mango','in','Jharkhand',194568.0,86.21,22.85).
city('Manoharpur','in','Jharkhand',13190.0,85.2,22.38).
city('Mihijam','in','Jharkhand',37259.0,86.87,23.87).
city('Mugma','in','Jharkhand',3195.0,86.73,23.77).
city('Muri','in','Jharkhand',12658.0,85.87,23.37).
city('Mushabani','in','Jharkhand',32765.0,86.45,22.52).
city('Netarhat','in','Jharkhand',4424.0,84.27,23.48).
city('Nirsa','in','Jharkhand',14126.0,86.0,23.78).
city('Noamundi','in','Jharkhand',16560.0,85.53,22.15).
city('Pakaur','in','Jharkhand',40450.0,87.85,24.63).
city('Pathardih','in','Jharkhand',45281.0,86.43,23.67).
city('Patratu','in','Jharkhand',31703.0,85.38,23.66).
city('Phusro','in','Jharkhand',88689.0,85.86,23.68).
city('Rajmahal','in','Jharkhand',19713.0,87.83,25.05).
city('Ramgarh','in','Jharkhand',83842.0,85.51,23.63).
city('Ranchi','in','Jharkhand',945079.0,85.33,23.36).
city('Ray','in','Jharkhand',5949.0,85.05,23.68).
city('Sahibgan','in','Jharkhand',95900.0,87.62,25.25).
city('Saraikela','in','Jharkhand',12665.0,85.95,22.72).
city('Saunda','in','Jharkhand',88199.0,85.37,23.64).
city('Sijua','in','Jharkhand',31540.0,86.32,23.78).
city('Simdega','in','Jharkhand',38736.0,84.52,22.62).
city('Sindari','in','Jharkhand',78414.0,86.49,23.68).
city('Sini','in','Jharkhand',6376.0,85.97,22.8).
city('Tenudam','in','Jharkhand',21671.0,85.85,23.73).
city('Tisra','in','Jharkhand',52666.0,86.42,23.73).
city('Topchanchi','in','Jharkhand',5789.0,86.2,23.9).
city('Afzalpur','in','Karnataka',20094.0,76.35,17.2).
city('Ajjampur','in','Karnataka',10795.0,76.0,13.73).
city('Aland','in','Karnataka',39067.0,76.57,17.57).
city('Alnavar','in','Karnataka',16928.0,74.73,15.43).
city('Alur','in','Karnataka',6605.0,75.98,12.98).
city('Anekal','in','Karnataka',36696.0,77.7,12.7).
city('Ankola','in','Karnataka',14541.0,74.3,14.67).
city('Annigeri','in','Karnataka',25755.0,75.43,15.43).
city('Arkalgud','in','Karnataka',15803.0,76.05,12.77).
city('Arsikere','in','Karnataka',44272.0,76.25,13.33).
city('Athni','in','Karnataka',42051.0,75.07,16.73).
city('Aurad','in','Karnataka',17019.0,77.43,18.25).
city('Badami','in','Karnataka',28316.0,75.68,15.92).
city('Bagalkot','in','Karnataka',97277.0,75.69,16.19).
city('Bagepalli','in','Karnataka',24033.0,77.78,13.78).
city('Bail Hongal','in','Karnataka',47067.0,74.87,15.82).
city('Baindur','in','Karnataka',20322.0,74.63,13.87).
city('Banavar','in','Karnataka',7827.0,76.17,13.42).
city('Bangalore','in','Karnataka',4931603.0,77.56,12.97).
city('Bangarapet','in','Karnataka',42793.0,78.2,12.97).
city('Bannur','in','Karnataka',25457.0,76.87,12.33).
city('Bantwal','in','Karnataka',37622.0,75.03,12.9).
city('Basavakalyan','in','Karnataka',65810.0,76.95,17.87).
city('Basavana Bagevadi','in','Karnataka',30829.0,75.97,16.58).
city('Belgaum','in','Karnataka',428756.0,74.5,15.86).
city('Bellary','in','Karnataka',336710.0,76.91,15.14).
city('Belluru','in','Karnataka',7626.0,76.72,12.98).
city('Beltangadi','in','Karnataka',7676.0,75.3,13.98).
city('Belur','in','Karnataka',21553.0,75.87,13.17).
city('Bhadravati','in','Karnataka',163917.0,75.69,13.84).
city('Bhalki','in','Karnataka',38586.0,77.22,18.03).
city('Bhatkal','in','Karnataka',31738.0,74.57,13.97).
city('Bidar','in','Karnataka',204088.0,77.52,17.92).
city('Bijapur','in','Karnataka',271087.0,75.71,16.83).
city('Bilgi','in','Karnataka',16257.0,75.62,16.35).
city('Birur','in','Karnataka',23495.0,75.97,13.62).
city('Bommanahalli','in','Karnataka',221908.0,77.63,13.01).
city('Byadgi','in','Karnataka',27722.0,75.48,14.68).
city('Challakere','in','Karnataka',53510.0,76.65,14.32).
city('Chamrajnagar','in','Karnataka',67998.0,76.95,11.92).
city('Channagiri','in','Karnataka',20378.0,75.93,14.03).
city('Channapatna','in','Karnataka',66652.0,77.19,12.66).
city('Channarayapatna','in','Karnataka',37684.0,76.4,12.9).
city('Chik Ballapur','in','Karnataka',57836.0,77.73,13.47).
city('Chikmagalur','in','Karnataka',121494.0,75.76,13.32).
city('Chiknayakanhalli','in','Karnataka',24294.0,76.62,13.43).
city('Chikodi','in','Karnataka',34987.0,74.6,16.43).
city('Chincholi','in','Karnataka',20449.0,77.43,17.47).
city('Chintamani','in','Karnataka',71804.0,78.05,13.4).
city('Chitaguppa','in','Karnataka',26890.0,77.45,17.69).
city('Chitapur','in','Karnataka',30141.0,77.08,17.12).
city('Chitradurga','in','Karnataka',138599.0,76.39,14.23).
city('Dandeli','in','Karnataka',52300.0,74.63,15.25).
city('Dasarahalli','in','Karnataka',348798.0,77.49,13.01).
city('Davanagere','in','Karnataka',406752.0,75.92,14.46).
city('Devanhalli','in','Karnataka',25230.0,77.7,13.23).
city('Dod Ballapur','in','Karnataka',78682.0,77.52,13.3).
city('Gadag','in','Karnataka',162583.0,75.63,15.44).
city('Gajendragarh','in','Karnataka',29752.0,75.98,15.73).
city('Gangawati','in','Karnataka',106259.0,76.52,15.44).
city('Gauribidanur','in','Karnataka',32450.0,77.53,13.62).
city('Gokak','in','Karnataka',73484.0,74.81,16.18).
city('Gorur','in','Karnataka',6192.0,76.05,12.83).
city('Gubbi','in','Karnataka',17985.0,76.93,13.32).
city('Gudibanda','in','Karnataka',9256.0,77.7,13.67).
city('Gulbarga','in','Karnataka',483655.0,76.82,17.34).
city('Guledgudda','in','Karnataka',33854.0,75.8,16.05).
city('Gundlupet','in','Karnataka',27200.0,76.68,11.8).
city('Gurmatkal','in','Karnataka',18238.0,77.4,16.87).
city('Haliyal','in','Karnataka',21627.0,74.77,15.33).
city('Hangal','in','Karnataka',26607.0,75.13,14.77).
city('Harihar','in','Karnataka',78041.0,75.8,14.52).
city('Harpanahalli','in','Karnataka',44981.0,75.98,14.8).
city('Hassan','in','Karnataka',128542.0,76.08,13.01).
city('Haveri','in','Karnataka',60161.0,75.4,14.8).
city('Hirekerur','in','Karnataka',16688.0,75.38,14.47).
city('Hiriyur','in','Karnataka',53524.0,76.6,13.97).
city('Holalkere','in','Karnataka',15481.0,76.18,14.03).
city('Hole Narsipur','in','Karnataka',28288.0,76.25,12.78).
city('Homnabad','in','Karnataka',41489.0,77.13,17.77).
city('Honavar','in','Karnataka',18393.0,74.45,14.28).
city('Honnali','in','Karnataka',16755.0,75.67,14.25).
city('Hosakote','in','Karnataka',11692.0,77.18,14.28).
city('Hosanagara','in','Karnataka',5188.0,75.07,13.92).
city('Hosangadi','in','Karnataka',2609.0,74.95,13.7).
city('Hosdurga','in','Karnataka',24687.0,76.27,13.79).
city('Hoskote','in','Karnataka',41240.0,77.8,13.07).
city('Hospet','in','Karnataka',197862.0,76.37,15.28).
city('Hubli','in','Karnataka',840285.0,75.13,15.36).
city('Hukeri','in','Karnataka',20826.0,74.6,16.23).
city('Hungund','in','Karnataka',19037.0,76.05,16.07).
city('Hunsur','in','Karnataka',47648.0,76.28,12.3).
city('Huvina Hadagalli','in','Karnataka',25314.0,75.92,15.0).
city('Ilkal','in','Karnataka',56941.0,76.13,15.97).
city('Indi','in','Karnataka',34078.0,75.97,17.17).
city('Jagalur','in','Karnataka',15789.0,76.35,14.53).
city('Jamkhandi','in','Karnataka',61696.0,75.28,16.51).
city('Jevargi','in','Karnataka',20157.0,76.77,17.02).
city('Kadur','in','Karnataka',32938.0,76.02,13.57).
city('Kalghatgi','in','Karnataka',15428.0,74.97,15.18).
city('Kamalapuram','in','Karnataka',22228.0,76.43,15.27).
city('Kampli','in','Karnataka',36644.0,76.62,15.4).
city('Kanakapura','in','Karnataka',50757.0,77.42,12.54).
city('Kannur','in','Karnataka',7625.0,75.37,11.85).
city('Karkal','in','Karnataka',25376.0,74.98,13.2).
city('Karwar','in','Karnataka',64462.0,74.12,14.82).
city('Kengeri','in','Karnataka',43149.0,77.47,12.03).
city('Kerur','in','Karnataka',17930.0,75.57,16.02).
city('Khanapur','in','Karnataka',17217.0,74.52,15.63).
city('Kodigenahalli','in','Karnataka',5727.0,77.38,13.72).
city('Kodlipet','in','Karnataka',2686.0,75.88,12.8).
city('Kolar','in','Karnataka',126452.0,78.13,13.14).
city('Kollegal','in','Karnataka',56502.0,77.12,12.15).
city('Konanur','in','Karnataka',9555.0,76.05,12.63).
city('Konnur','in','Karnataka',19168.0,74.75,16.2).
city('Koppa','in','Karnataka',5124.0,75.35,13.55).
city('Koppal','in','Karnataka',60873.0,76.15,15.35).
city('Koratagere','in','Karnataka',14446.0,77.23,13.53).
city('Kotturu','in','Karnataka',24006.0,76.22,14.82).
city('Krishnarajanagar','in','Karnataka',32319.0,76.39,12.46).
city('Krishnarajapura','in','Karnataka',201665.0,77.74,12.97).
city('Krishnarajasagara','in','Karnataka',8713.0,76.57,12.4).
city('Krishnarajpet','in','Karnataka',24291.0,76.5,12.67).
city('Kudchi','in','Karnataka',19274.0,74.85,16.63).
city('Kudligi','in','Karnataka',22975.0,76.38,14.9).
city('Kumsi','in','Karnataka',6468.0,75.4,14.07).
city('Kumta','in','Karnataka',28002.0,74.4,14.42).
city('Kundapura','in','Karnataka',28493.0,74.7,13.63).
city('Kundgol','in','Karnataka',17618.0,75.25,15.25).
city('Kunigal','in','Karnataka',33276.0,77.02,13.02).
city('Kurgunta','in','Karnataka',8682.0,77.35,17.2).
city('Kushalnagar','in','Karnataka',14962.0,75.97,12.47).
city('Kushtagi','in','Karnataka',24182.0,76.2,15.77).
city('Kyathanahalli','in','Karnataka',36818.0,76.67,12.54).
city('Lakshmeshwar','in','Karnataka',35143.0,75.47,15.13).
city('Lingsugur','in','Karnataka',29785.0,76.52,16.17).
city('Londa','in','Karnataka',6132.0,74.52,15.47).
city('Maddur','in','Karnataka',28143.0,77.07,12.6).
city('Madhugiri','in','Karnataka',28127.0,77.2,13.67).
city('Madikeri','in','Karnataka',33543.0,75.73,12.42).
city('Magadi','in','Karnataka',27215.0,77.23,12.97).
city('Mahalingpur','in','Karnataka',32702.0,75.12,16.38).
city('Maisuru','in','Karnataka',868385.0,76.65,12.31).
city('Malavalli','in','Karnataka',38132.0,77.08,12.38).
city('Malpe','in','Karnataka',23496.0,74.72,13.35).
city('Malur','in','Karnataka',30680.0,77.92,13.0).
city('Mandya','in','Karnataka',134857.0,76.89,12.54).
city('Mangaluru','in','Karnataka',417423.0,74.84,12.88).
city('Manvi','in','Karnataka',41650.0,77.05,15.98).
city('Mayakonda','in','Karnataka',6445.0,76.08,14.28).
city('Melukote','in','Karnataka',4011.0,76.65,12.67).
city('Mudalgi','in','Karnataka',31078.0,74.97,16.33).
city('Mudbidri','in','Karnataka',30635.0,74.98,13.08).
city('Muddebihal','in','Karnataka',31898.0,76.13,16.33).
city('Mudgal','in','Karnataka',21007.0,76.43,16.02).
city('Mudhol','in','Karnataka',47431.0,75.28,16.35).
city('Mudigere','in','Karnataka',9323.0,75.63,13.13).
city('Mulbagal','in','Karnataka',47466.0,78.4,13.17).
city('Mulgund','in','Karnataka',18930.0,75.53,15.25).
city('Mulki','in','Karnataka',17260.0,74.8,13.1).
city('Mundargi','in','Karnataka',21828.0,75.9,15.22).
city('Mundgod','in','Karnataka',17000.0,75.03,14.97).
city('Munirabad','in','Karnataka',8246.0,76.33,15.33).
city('Nagamangala','in','Karnataka',16761.0,76.77,12.82).
city('Nanjangud','in','Karnataka',50247.0,76.7,12.1).
city('Naragund','in','Karnataka',33406.0,75.38,15.72).
city('Narasimharajapura','in','Karnataka',7776.0,75.52,13.62).
city('Naregal','in','Karnataka',17405.0,75.82,15.58).
city('Navalgund','in','Karnataka',23210.0,75.37,15.57).
city('Nelmangala','in','Karnataka',28699.0,77.37,13.11).
city('Nipani','in','Karnataka',60356.0,74.38,16.41).
city('Nyamati','in','Karnataka',10337.0,75.58,14.15).
city('Pandavapura','in','Karnataka',19052.0,76.67,12.5).
city('Pavagada','in','Karnataka',32065.0,77.27,14.1).
city('Piriyapatna','in','Karnataka',16101.0,76.1,12.33).
city('Ponnampet','in','Karnataka',6117.0,75.93,12.15).
city('Puttur','in','Karnataka',53336.0,75.22,12.77).
city('Rabkavi','in','Karnataka',73841.0,75.11,16.47).
city('Raichur','in','Karnataka',225981.0,77.35,16.21).
city('Ramanagaram','in','Karnataka',93535.0,77.27,12.72).
city('Ramdurg','in','Karnataka',32506.0,75.3,15.95).
city('Ranibennur','in','Karnataka',99113.0,75.61,14.62).
city('Raybag','in','Karnataka',17390.0,74.78,16.48).
city('Robertsonpet','in','Karnataka',135229.0,78.28,12.97).
city('Ron','in','Karnataka',22595.0,75.73,15.67).
city('Sadalgi','in','Karnataka',22137.0,74.55,16.57).
city('Sagar','in','Karnataka',53155.0,75.03,14.17).
city('Sakleshpur','in','Karnataka',24934.0,75.78,12.97).
city('Sandur','in','Karnataka',29016.0,76.55,15.1).
city('Sanivarsante','in','Karnataka',4432.0,75.9,12.73).
city('Sankeshwar','in','Karnataka',34552.0,74.48,16.27).
city('Sargur','in','Karnataka',10983.0,76.42,11.98).
city('Saundatti Yellamma','in','Karnataka',40095.0,75.12,15.78).
city('Savanur','in','Karnataka',37823.0,75.35,14.97).
city('Sedam','in','Karnataka',35137.0,77.28,17.18).
city('Shahabad','in','Karnataka',52957.0,76.93,17.13).
city('Shahpur','in','Karnataka',31425.0,76.83,16.7).
city('Shiggaon','in','Karnataka',26120.0,75.23,15.0).
city('Shikarpur','in','Karnataka',33276.0,75.35,14.27).
city('Shimoga','in','Karnataka',319577.0,75.57,13.93).
city('Shirhatti','in','Karnataka',16605.0,75.58,15.23).
city('Shorapur','in','Karnataka',49505.0,76.75,16.52).
city('Shrirangapattana','in','Karnataka',23929.0,76.7,12.45).
city('Siddapur','in','Karnataka',14769.0,74.88,14.33).
city('Sidlaghatta','in','Karnataka',49118.0,77.87,13.38).
city('Sindgi','in','Karnataka',33773.0,76.23,16.92).
city('Sindhnur','in','Karnataka',68799.0,76.77,15.78).
city('Sira','in','Karnataka',57933.0,76.9,13.75).
city('Sirsi','in','Karnataka',61612.0,74.85,14.62).
city('Siruguppa','in','Karnataka',47921.0,76.9,15.63).
city('Someshwar','in','Karnataka',22139.0,75.07,13.5).
city('Somvarpet','in','Karnataka',7228.0,75.87,12.6).
city('Sorab','in','Karnataka',7088.0,75.1,14.38).
city('Sringeri','in','Karnataka',4272.0,75.25,13.42).
city('Srinivaspur','in','Karnataka',25762.0,78.22,13.33).
city('Sulya','in','Karnataka',18950.0,75.38,12.57).
city('Talikota','in','Karnataka',27905.0,76.32,16.48).
city('Tarikera','in','Karnataka',37851.0,75.82,13.72).
city('Tekkalakota','in','Karnataka',25532.0,76.88,15.53).
city('Terdal','in','Karnataka',26413.0,75.05,16.5).
city('Tiptur','in','Karnataka',60962.0,76.48,13.27).
city('Tirthahalli','in','Karnataka',15423.0,75.23,13.7).
city('Tirumakudal Narsipur','in','Karnataka',9891.0,76.92,12.2).
city('Tumkur','in','Karnataka',307384.0,77.1,13.34).
city('Turuvekere','in','Karnataka',14116.0,76.67,13.17).
city('Udupi','in','Karnataka',129124.0,74.75,13.35).
city('Ullal','in','Karnataka',59121.0,74.85,12.8).
city('Virarajendrapet','in','Karnataka',15978.0,75.8,12.2).
city('Wadi','in','Karnataka',30605.0,76.98,17.07).
city('Yadgir','in','Karnataka',65381.0,77.13,16.77).
city('Yelahanka','in','Karnataka',116457.0,77.6,13.1).
city('Yelandur','in','Karnataka',8902.0,77.03,12.07).
city('Yelbarga','in','Karnataka',12023.0,76.02,15.63).
city('Yellapur','in','Karnataka',19345.0,74.72,14.97).
city('Adur','in','Kerala',29655.0,76.73,9.17).
city('Alangad','in','Kerala',39935.0,76.27,10.24).
city('Alappuzha','in','Kerala',176799.0,76.33,9.5).
city('Alwaye','in','Kerala',23705.0,76.36,10.11).
city('Angamali','in','Kerala',34402.0,76.4,10.2).
city('Arukutti','in','Kerala',17945.0,76.35,9.87).
city('Arur','in','Kerala',36501.0,76.34,9.59).
city('Attingal','in','Kerala',36599.0,76.83,8.68).
city('Azhikode North','in','Kerala',22961.0,75.36,11.95).
city('Azhikode South','in','Kerala',24120.0,75.36,11.91).
city('Beypur','in','Kerala',70758.0,75.82,11.18).
city('Chalakudi','in','Kerala',49335.0,76.35,10.3).
city('Changanacheri','in','Kerala',51435.0,76.54,9.45).
city('Chavakkad','in','Kerala',38014.0,76.04,10.52).
city('Chendamangalam','in','Kerala',28447.0,76.21,10.18).
city('Chengannur','in','Kerala',25046.0,76.63,9.33).
city('Cheruvannur','in','Kerala',59374.0,75.84,11.21).
city('Chirakkal','in','Kerala',44357.0,75.37,11.89).
city('Chittur','in','Kerala',31611.0,76.75,10.7).
city('Dharmadam','in','Kerala',29946.0,75.43,11.78).
city('Edathala','in','Kerala',71178.0,76.32,10.03).
city('Elayavur','in','Kerala',32236.0,75.41,11.86).
city('Elur','in','Kerala',30832.0,76.28,10.07).
city('Eranholi','in','Kerala',24838.0,75.47,11.77).
city('Erattupetta','in','Kerala',33411.0,76.78,9.7).
city('Feroke','in','Kerala',30229.0,75.85,11.18).
city('Guruvayur','in','Kerala',21418.0,76.05,10.6).
city('Idukki','in','Kerala',11249.0,76.97,9.85).
city('Irinjalakuda','in','Kerala',29211.0,76.23,10.33).
city('Kadalundi','in','Kerala',39429.0,75.81,11.15).
city('Kalamassery','in','Kerala',66388.0,76.27,10.05).
city('Kalliasseri','in','Kerala',29108.0,75.29,12.0).
city('Kanjirappalli','in','Kerala',41498.0,76.8,9.57).
city('Kannangad','in','Kerala',68456.0,75.09,12.34).
city('Kannur','in','Kerala',62842.0,75.35,11.86).
city('Kasaragod','in','Kerala',53313.0,74.98,12.5).
city('Kayankulam','in','Kerala',64189.0,76.49,9.17).
city('Kochi','in','Kerala',604751.0,76.22,10.02).
city('Kodungallur','in','Kerala',34213.0,76.22,10.22).
city('Kollam','in','Kerala',394198.0,76.58,8.89).
city('Komalapuram','in','Kerala',45471.0,76.33,9.52).
city('Kothamangalam','in','Kerala',37547.0,76.62,10.08).
city('Kottayam','in','Kerala',59442.0,76.52,9.6).
city('Koyilandi','in','Kerala',70666.0,75.7,11.43).
city('Kozhikkod','in','Kerala',439962.0,75.78,11.26).
city('Kunnamangalam','in','Kerala',38372.0,75.88,11.32).
city('Kunnamkulam','in','Kerala',63950.0,76.08,10.65).
city('Kuthuparamba','in','Kerala',29570.0,75.57,11.82).
city('Kuttakulam','in','Kerala',18865.0,76.59,9.88).
city('Malappuram','in','Kerala',61749.0,76.06,11.07).
city('Manjeri','in','Kerala',89209.0,76.11,11.12).
city('Manjeshwar','in','Kerala',8928.0,74.88,12.7).
city('Mannarakkat','in','Kerala',50921.0,76.47,10.98).
city('Maradu','in','Kerala',43199.0,76.38,9.89).
city('Mattannur','in','Kerala',45526.0,75.58,11.92).
city('Mavelikara','in','Kerala',28303.0,76.55,9.27).
city('Mavur','in','Kerala',28316.0,75.92,11.27).
city('Methala','in','Kerala',42444.0,76.22,10.25).
city('Muvattupula','in','Kerala',29666.0,76.58,9.97).
city('Muzhappilangad','in','Kerala',23033.0,75.45,11.8).
city('Nadapuram','in','Kerala',39512.0,75.67,11.7).
city('Nedumangad','in','Kerala',58284.0,77.0,8.61).
city('Neyyattinkara','in','Kerala',88143.0,77.08,8.4).
city('Nileshwar','in','Kerala',25404.0,75.1,12.25).
city('Olavanna','in','Kerala',31722.0,75.87,11.27).
city('Ottappalam','in','Kerala',50917.0,76.38,10.77).
city('Palai','in','Kerala',22773.0,76.71,9.68).
city('Palakkad','in','Kerala',132740.0,76.65,10.78).
city('Pantalam','in','Kerala',42301.0,76.73,9.32).
city('Pappinisseri','in','Kerala',34028.0,75.35,11.95).
city('Paravur','in','Kerala',34822.0,76.46,9.47).
city('Pathanamthitta','in','Kerala',38288.0,76.78,9.27).
city('Payyannur','in','Kerala',70075.0,75.19,12.1).
city('Perintalamanna','in','Kerala',46587.0,76.23,10.98).
city('Perumpavur','in','Kerala',27108.0,76.48,10.13).
city('Piravam','in','Kerala',28254.0,76.5,9.87).
city('Ponnani','in','Kerala',105521.0,75.92,10.78).
city('Punalur','in','Kerala',47267.0,76.93,9.0).
city('Puzhathi','in','Kerala',34373.0,75.42,11.91).
city('Shertallai','in','Kerala',45479.0,76.33,9.69).
city('Shoranur','in','Kerala',42698.0,76.28,10.77).
city('Talipparamba','in','Kerala',69884.0,75.36,12.03).
city('Thalassery','in','Kerala',97210.0,75.49,11.75).
city('Thannirmukkam','in','Kerala',32206.0,76.36,9.64).
city('Thiruva','in','Kerala',784223.0,76.95,8.51).
city('Thodupuzha','in','Kerala',48174.0,76.72,9.9).
city('Thrippunithura','in','Kerala',63123.0,76.35,9.94).
city('Thrissur','in','Kerala',325140.0,76.21,10.52).
city('Tirur','in','Kerala',54939.0,75.92,10.91).
city('Tiruvalla','in','Kerala',57228.0,76.57,9.39).
city('Vadakara','in','Kerala',76500.0,75.58,11.61).
city('Vaikam','in','Kerala',22810.0,76.4,9.77).
city('Varkkallai','in','Kerala',43280.0,76.72,8.73).
city('Vayalar','in','Kerala',25094.0,76.33,9.7).
city('Amini','in','Lakshadweep',7692.0,72.73,11.11).
city('Kavaratti','in','Lakshadweep',10689.0,72.64,10.57).
city('Minicoy','in','Lakshadweep',9957.0,73.06,8.27).
city('Agar','in','Madhya Pradesh',34536.0,76.02,23.7).
city('Ajaigarh','in','Madhya Pradesh',14642.0,80.27,24.9).
city('Akodia','in','Madhya Pradesh',11280.0,76.6,23.38).
city('Alampur','in','Madhya Pradesh',10020.0,78.82,26.03).
city('Alirajpur','in','Madhya Pradesh',26446.0,74.35,22.3).
city('Alot','in','Madhya Pradesh',23136.0,75.55,23.77).
city('Amanganj','in','Madhya Pradesh',13169.0,80.03,24.43).
city('Amarkantak','in','Madhya Pradesh',7613.0,81.75,22.67).
city('Amarpatan','in','Madhya Pradesh',16860.0,80.98,24.32).
city('Amarwara','in','Madhya Pradesh',13259.0,79.17,22.3).
city('Ambah','in','Madhya Pradesh',40528.0,78.23,26.72).
city('Amla','in','Madhya Pradesh',29998.0,78.12,21.93).
city('Amlai','in','Madhya Pradesh',32091.0,81.7,23.11).
city('Anjad','in','Madhya Pradesh',24289.0,75.05,22.03).
city('Antri','in','Madhya Pradesh',9788.0,78.22,26.05).
city('Anuppur','in','Madhya Pradesh',18124.0,81.68,23.1).
city('Aron','in','Madhya Pradesh',24277.0,77.42,24.38).
city('Ashoknagar','in','Madhya Pradesh',64729.0,77.72,24.57).
city('Ashta','in','Madhya Pradesh',45370.0,76.72,23.02).
city('Babai','in','Madhya Pradesh',16177.0,77.93,22.7).
city('Badarwas','in','Madhya Pradesh',11135.0,77.57,24.97).
city('Badnagar','in','Madhya Pradesh',31787.0,75.37,23.04).
city('Badnawar','in','Madhya Pradesh',18792.0,75.22,23.02).
city('Bagh','in','Madhya Pradesh',7764.0,74.77,22.37).
city('Bagli','in','Madhya Pradesh',10765.0,76.35,22.65).
city('Baihar','in','Madhya Pradesh',16170.0,80.55,22.1).
city('Baikunthpur','in','Madhya Pradesh',10180.0,81.42,24.72).
city('Balaghat','in','Madhya Pradesh',80368.0,80.18,21.8).
city('Baldeogarh','in','Madhya Pradesh',8283.0,79.07,24.75).
city('Bamora','in','Madhya Pradesh',7981.0,78.08,24.08).
city('Banda','in','Madhya Pradesh',28981.0,78.95,24.05).
city('Barela','in','Madhya Pradesh',11649.0,80.05,23.1).
city('Barghat','in','Madhya Pradesh',11221.0,79.72,22.03).
city('Bargi','in','Madhya Pradesh',17589.0,79.87,22.98).
city('Barhi','in','Madhya Pradesh',12138.0,80.8,23.9).
city('Barwaha','in','Madhya Pradesh',24423.0,76.05,22.27).
city('Barwani','in','Madhya Pradesh',47348.0,74.89,22.04).
city('Basoda','in','Madhya Pradesh',69285.0,77.93,23.85).
city('Begamganj','in','Madhya Pradesh',33470.0,78.33,23.6).
city('Beohari','in','Madhya Pradesh',22110.0,81.38,24.05).
city('Berasia','in','Madhya Pradesh',27093.0,77.43,23.63).
city('Betma','in','Madhya Pradesh',13818.0,75.62,22.68).
city('Betul','in','Madhya Pradesh',91963.0,77.9,21.92).
city('Betul Bazar','in','Madhya Pradesh',9641.0,77.93,21.86).
city('Bhainsdehi','in','Madhya Pradesh',16402.0,77.63,21.65).
city('Bhander','in','Madhya Pradesh',22484.0,78.75,25.73).
city('Bhanpura','in','Madhya Pradesh',17084.0,75.73,24.52).
city('Bhavra','in','Madhya Pradesh',9966.0,74.33,22.53).
city('Bhikangaon','in','Madhya Pradesh',15323.0,75.95,21.87).
city('Bhind','in','Madhya Pradesh',174053.0,78.77,26.57).
city('Bhitarwar','in','Madhya Pradesh',17681.0,78.12,25.8).
city('Bhopal','in','Madhya Pradesh',1600080.0,77.4,23.24).
city('Biaora','in','Madhya Pradesh',41993.0,76.92,23.87).
city('Bijawar','in','Madhya Pradesh',19470.0,79.5,24.63).
city('Bilaua','in','Madhya Pradesh',11996.0,78.28,26.05).
city('Bina-Etawa','in','Madhya Pradesh',55191.0,78.2,24.2).
city('Burhanpur','in','Madhya Pradesh',202717.0,76.22,21.33).
city('Burhar','in','Madhya Pradesh',18193.0,81.53,23.22).
city('Chanderi','in','Madhya Pradesh',32552.0,78.13,24.72).
city('Chandia','in','Madhya Pradesh',13100.0,80.7,23.65).
city('Chandla','in','Madhya Pradesh',11196.0,80.2,25.08).
city('Chhatarpur','in','Madhya Pradesh',111606.0,79.58,24.92).
city('Chhindwara','in','Madhya Pradesh',134862.0,78.94,22.07).
city('Chichli','in','Madhya Pradesh',10226.0,78.82,22.83).
city('Chitrakut','in','Madhya Pradesh',23994.0,81.72,19.19).
city('Churhat','in','Madhya Pradesh',14101.0,81.68,24.43).
city('Daboh','in','Madhya Pradesh',18299.0,78.88,26.02).
city('Dabra','in','Madhya Pradesh',60842.0,78.33,25.9).
city('Damoh','in','Madhya Pradesh',118789.0,79.44,23.85).
city('Datia','in','Madhya Pradesh',90638.0,78.45,25.67).
city('Deori Khas','in','Madhya Pradesh',24937.0,79.02,23.4).
city('Depalpur','in','Madhya Pradesh',16938.0,75.55,22.85).
city('Dewas','in','Madhya Pradesh',261245.0,76.05,22.97).
city('Dhamnod','in','Madhya Pradesh',29684.0,75.47,22.22).
city('Dhana','in','Madhya Pradesh',10642.0,78.85,23.75).
city('Dhanpuri','in','Madhya Pradesh',45428.0,81.51,23.22).
city('Dhar','in','Madhya Pradesh',82447.0,75.29,22.6).
city('Dharampuri','in','Madhya Pradesh',14179.0,75.35,22.17).
city('Dindori','in','Madhya Pradesh',19265.0,81.08,22.95).
city('Gadarwara','in','Madhya Pradesh',41424.0,78.78,22.92).
city('Gairatganj','in','Madhya Pradesh',8779.0,78.22,23.4).
city('Garhakota','in','Madhya Pradesh',28117.0,79.15,23.77).
city('Ghansor','in','Madhya Pradesh',6597.0,79.95,22.65).
city('Gogapur','in','Madhya Pradesh',6857.0,75.52,23.55).
city('Gohad','in','Madhya Pradesh',51640.0,78.45,26.43).
city('Gormi','in','Madhya Pradesh',16889.0,78.52,26.6).
city('Govindgarh','in','Madhya Pradesh',10194.0,81.3,24.38).
city('Guna','in','Madhya Pradesh',153705.0,77.3,24.65).
city('Gurh','in','Madhya Pradesh',13104.0,81.52,24.52).
city('Gwalior','in','Madhya Pradesh',882551.0,78.17,26.23).
city('Harda','in','Madhya Pradesh',67394.0,77.11,22.33).
city('Harpalpur','in','Madhya Pradesh',17733.0,79.33,25.28).
city('Harrai','in','Madhya Pradesh',10251.0,79.22,22.62).
city('Harsud','in','Madhya Pradesh',16738.0,76.73,22.1).
city('Hatod','in','Madhya Pradesh',9350.0,75.73,22.8).
city('Hatta','in','Madhya Pradesh',30858.0,79.6,24.12).
city('Hindoria','in','Madhya Pradesh',15144.0,79.57,23.9).
city('Hirapur','in','Madhya Pradesh',6069.0,79.7,21.53).
city('Hoshangabad','in','Madhya Pradesh',109370.0,77.71,22.75).
city('Ichhawar','in','Madhya Pradesh',13657.0,77.02,23.02).
city('Indergarh','in','Madhya Pradesh',17368.0,79.68,26.93).
city('Indore','in','Madhya Pradesh',1837230.0,75.86,22.72).
city('Isagarh','in','Madhya Pradesh',10370.0,77.88,24.83).
city('Itarsi','in','Madhya Pradesh',100585.0,77.76,22.62).
city('Jabalpur','in','Madhya Pradesh',1030276.0,79.94,23.17).
city('Jabalpur Cantonment','in','Madhya Pradesh',70682.0,79.95,23.16).
city('Jaisinghnagar','in','Madhya Pradesh',7601.0,81.38,23.7).
city('Jamai','in','Madhya Pradesh',22590.0,78.58,22.2).
city('Jaora','in','Madhya Pradesh',67210.0,75.11,23.64).
city('Jatara','in','Madhya Pradesh',17003.0,79.05,25.02).
city('Jawad','in','Madhya Pradesh',16889.0,74.85,24.6).
city('Jawar','in','Madhya Pradesh',7753.0,76.5,23.0).
city('Jhabua','in','Madhya Pradesh',34138.0,74.6,22.77).
city('Jiran','in','Madhya Pradesh',10983.0,74.88,24.32).
city('Jobat','in','Madhya Pradesh',10786.0,74.57,22.42).
city('Joura','in','Madhya Pradesh',26341.0,77.82,26.33).
city('Kailaras','in','Madhya Pradesh',24542.0,77.62,26.32).
city('Kaimur','in','Madhya Pradesh',20156.0,79.75,23.38).
city('Kannod','in','Madhya Pradesh',15872.0,76.73,22.67).
city('Kareli','in','Madhya Pradesh',27811.0,79.07,22.92).
city('Karera','in','Madhya Pradesh',26215.0,78.15,25.47).
city('Karrapur','in','Madhya Pradesh',9993.0,78.85,23.95).
city('Kasrawad','in','Madhya Pradesh',21486.0,75.6,22.13).
city('Katangi','in','Madhya Pradesh',16571.0,79.78,22.62).
city('Khachrod','in','Madhya Pradesh',31829.0,75.28,23.42).
city('Khajuraho','in','Madhya Pradesh',25681.0,79.93,24.85).
city('Khamaria','in','Madhya Pradesh',15034.0,79.88,23.22).
city('Khandwa','in','Madhya Pradesh',182860.0,76.35,21.83).
city('Khargapur','in','Madhya Pradesh',13508.0,79.15,24.82).
city('Khargone','in','Madhya Pradesh',94995.0,75.6,21.83).
city('Khategaon','in','Madhya Pradesh',23407.0,76.92,22.6).
city('Khetia','in','Madhya Pradesh',15022.0,74.58,21.67).
city('Khilchipur','in','Madhya Pradesh',16412.0,76.57,24.03).
city('Khirkiya','in','Madhya Pradesh',18500.0,76.85,22.17).
city('Khujner','in','Madhya P',9951.0,76.6,23.78).
city('Khurai','in','Madhya Pradesh',31617.0,78.32,24.05).
city('Kolaras','in','Madhya Pradesh',17176.0,77.6,25.23).
city('Kotar','in','Madhya Pradesh',6959.0,80.98,24.72).
city('Kothi','in','Madhya Pradesh',7796.0,80.78,24.75).
city('Kotma','in','Madhya Pradesh',31759.0,81.97,23.2).
city('Kukshi','in','Madhya Pradesh',26185.0,74.75,22.2).
city('Kumbhraj','in','Madhya Pradesh',16393.0,77.05,24.37).
city('Lahar','in','Madhya Pradesh',32889.0,78.95,26.2).
city('Lakhnadon','in','Madhya Pradesh',15591.0,79.6,22.6).
city('Lodhikheda','in','Madhya Pradesh',9995.0,78.83,21.58).
city('Machalpur','in','Madhya Pradesh',8557.0,76.3,24.13).
city('Madhogarh','in','Madhya Pradesh',5052.0,80.9,24.57).
city('Maharajpur','in','Madhya Pradesh',22545.0,79.73,25.02).
city('Maheshwar','in','Madhya Pradesh',21502.0,75.58,22.18).
city('Mahidpur','in','Madhya Pradesh',30423.0,75.66,23.48).
city('Maihar','in','Madhya Pradesh',37917.0,80.75,24.27).
city('Majholi','in','Madhya Pradesh',11554.0,79.92,23.5).
city('Maksi','in','Madhya Pradesh',20096.0,76.15,23.27).
city('Malhargarh','in','Madhya Pradesh',7621.0,74.98,24.28).
city('Manasa','in','Madhya Pradesh',24081.0,75.15,24.48).
city('Manawar','in','Madhya Pradesh',27640.0,75.08,22.23).
city('Mandla','in','Madhya Pradesh',45189.0,80.38,22.6).
city('Mandleshwar','in','Madhya Pradesh',12051.0,75.67,22.18).
city('Mandsaur','in','Madhya Pradesh',125002.0,75.07,24.07).
city('Mangawan','in','Madhya Pradesh',12504.0,81.55,24.68).
city('Manpur','in','Madhya Pradesh',6639.0,75.62,22.43).
city('Mau','in','Madhya Pradesh',54115.0,77.22,24.42).
city('Mauganj','in','Madhya Pradesh',25540.0,81.88,24.68).
city('Mihona','in','Madhya Pradesh',15832.0,78.97,26.28).
city('Mohgaon','in','Madhya Pradesh',10447.0,78.72,21.65).
city('Morar','in','Madhya Pradesh',44456.0,78.23,26.23).
city('Morena','in','Madhya Pradesh',152020.0,77.99,26.51).
city('Morwa','in','Madhya Pradesh',20169.0,73.83,22.9).
city('Multai','in','Madhya Pradesh',22031.0,78.25,21.77).
city('Mundi','in','Madhya Pradesh',11410.0,76.5,22.07).
city('Mungaoli','in','Madhya Pradesh',20083.0,78.1,24.42).
city('Murwara','in','Madhya Pradesh',195877.0,80.39,23.85).
city('Nagda','in','Madhya Pradesh',103513.0,75.42,23.46).
city('Nagod','in','Madhya Pradesh',21734.0,80.6,24.57).
city('Naigarhi','in','Madhya Pradesh',9392.0,81.78,24.78).
city('Nainpur','in','Madhya Pradesh',22338.0,80.12,22.43).
city('Namli','in','Madhya Pradesh',9236.0,75.05,23.43).
city('Narayangarh','in','Madhya Pradesh',10234.0,75.05,24.28).
city('Narsimhapur','in','Madhya Pradesh',47516.0,79.2,22.95).
city('Narsingarh','in','Madhya Pradesh',29985.0,77.1,23.7).
city('Narwar','in','Mad',16949.0,77.9,25.65).
city('Nasrullaganj','in','Madhya Pradesh',18267.0,77.27,22.68).
city('Naugaon','in','Madhya Pradesh',38675.0,79.43,25.05).
city('Nepa Nagar','in','Madhya Pradesh',32614.0,76.4,21.47).
city('Nimach','in','Madhya Pradesh',116381.0,74.87,24.47).
city('Pachmarhi','in','Madhya Pradesh',3228.0,78.43,22.47).
city('Palera','in','Madhya Pradesh',16555.0,79.23,25.02).
city('Pali','in','Madhya Pradesh',21290.0,81.05,23.35).
city('Panagar','in','Madhya Pradesh',26622.0,79.98,23.3).
city('Panara','in','Madhya Pradesh',4097.0,78.55,22.07).
city('Pandaria','in','Madhya Pradesh',13875.0,81.42,22.23).
city('Pandhana','in','Madhya Pradesh',11627.0,76.22,21.7).
city('Pandhurna','in','Madhya Pradesh',43635.0,78.52,21.6).
city('Panna','in','Madhya Pradesh',46796.0,80.2,24.72).
city('Pansemal','in','Madhya Pradesh',11184.0,74.7,21.65).
city('Parasia','in','Madhya Pradesh',39444.0,78.77,22.2).
city('Pasan','in','Madhya Pradesh',30932.0,82.2,22.85).
city('Patan','in','Madhya Pradesh',14123.0,79.7,23.3).
city('Patharia','in','Madhya Pradesh',18360.0,79.0,23.9).
city('Pawai','in','Madhya Pradesh',13085.0,80.17,24.27).
city('Petlawad','in','Madhya Pradesh',13262.0,74.8,23.0).
city('Pipariya','in','Madhya Pradesh',44069.0,78.35,22.75).
city('Piploda','in','Madhya Pradesh',7720.0,75.43,23.35).
city('Porsa','in','Madhya Pradesh',37827.0,78.38,26.68).
city('Prithvipur','in','Madhya Pradesh',24986.0,78.76,25.22).
city('Raghogarh','in','Madhya Pradesh',63880.0,77.2,24.45).
city('Rahatgarh','in','Madhya Pradesh',27465.0,78.37,23.78).
city('Raisen','in','Madhya Pradesh',40982.0,77.8,23.33).
city('Rajgarh','in','Madhya Pradesh',21641.0,75.84,23.34).
city('Rajnagar','in','Madhya Pradesh',13391.0,79.92,24.88).
city('Rajpur','in','Madhya Pradesh',19398.0,75.13,21.93).
city('Rampura','in','Madhya Pradesh',18497.0,75.43,24.47).
city('Ranapur','in','Madhya Pradesh',10677.0,74.53,22.65).
city('Ratangarh','in','Madhya Pradesh',7495.0,75.12,24.82).
city('Ratlam','in','Madhya Pradesh',236868.0,75.03,23.35).
city('Rehli','in','Madhya Pradesh',27708.0,79.08,23.63).
city('Rehti','in','Madhya Pradesh',10718.0,77.43,22.73).
city('Rewa','in','Madhya Pradesh',208483.0,81.29,24.53).
city('Sabalgarh','in','Madhya Pradesh',31035.0,77.4,26.25).
city('Sagar','in','Madhya Pradesh',247359.0,78.75,23.85).
city('Sagar Cantonment','in','Madhya Pradesh',35344.0,78.74,23.84).
city('Sailana','in','Madhya Pradesh',10811.0,74.92,23.47).
city('Sanawad','in','Madhya Pradesh',36459.0,76.07,22.18).
city('Sanchi','in','Madhya Pradesh',7302.0,77.73,23.48).
city('Sanwer','in','Madhya Pradesh',14216.0,75.83,22.98).
city('Sarangpur','in','Madhya Pradesh',35831.0,76.47,23.57).
city('Sardarpur','in','Madhya Pradesh',6710.0,74.98,22.67).
city('Sarni','in','Madhya Pradesh',99125.0,78.27,22.04).
city('Satna','in','Madhya Pradesh',257805.0,80.83,24.58).
city('Satwas','in','Madhya Pradesh',12117.0,76.68,22.53).
city('Sausar','in','Madhya Pradesh',26707.0,78.78,21.65).
city('Sehore','in','Madhya Pradesh',99294.0,77.08,23.2).
city('Semaria','in','Madhya Pradesh',14046.0,81.15,24.8).
city('Sendhwa','in','Madhya Pradesh',54535.0,75.1,21.68).
city('Seondha','in','Madhya Pradesh',21328.0,78.8,26.15).
city('Seoni','in','Madhya Pradesh',101389.0,79.55,22.1).
city('Seoni Malwa','in','Madhya Pradesh',28337.0,77.47,22.45).
city('Shahdol','in','Madhya Pradesh',89298.0,81.36,23.3).
city('Shahgarh','in','Madhya Pradesh',14837.0,79.13,24.32).
city('Shahpur','in','Madhya Pradesh',11534.0,78.54,22.58).
city('Shahpura','in','Madhya Pradesh',12814.0,79.67,23.13).
city('Shajapur','in','Madhya Pradesh',53352.0,76.27,23.43).
city('Shamgarh','in','Madhya Pradesh',23078.0,75.63,24.18).
city('Sheopur','in','Madhya Pradesh',62422.0,76.7,25.67).
city('Shivapuri','in','Madhya Pradesh',164233.0,77.65,25.43).
city('Shujalpur','in','Madhya Pradesh',47063.0,76.72,23.4).
city('Sidhi','in','Madhya Pradesh',54248.0,81.88,24.42).
city('Sihora','in','Madhya Pradesh',41196.0,80.12,23.48).
city('Singrauli','in','Madhya Pradesh',249255.0,82.27,23.84).
city('Sirmaur','in','Madhya Pradesh',11813.0,81.38,24.85).
city('Sironj','in','Madhya Pradesh',45459.0,77.7,24.1).
city('Sitamau','in','Madhya Pradesh',13442.0,75.35,24.02).
city('Sohagpur','in','Madhya Pradesh',23852.0,78.2,22.7).
city('Sultanpur','in','Madhya Pradesh',9420.0,77.93,23.15).
city('Susner','in','Madhya Pradesh',14603.0,76.08,23.95).
city('Tal','in','Madhya Pradesh',14245.0,75.38,23.72).
city('Talen','in','Madhya Pradesh',9819.0,76.72,23.57).
city('Tarana','in','Madhya Pradesh',22775.0,76.03,23.33).
city('Tekanpur','in','Madhya Pradesh',13683.0,78.27,25.98).
city('Tendukheda','in','Madhya Pradesh',12700.0,79.55,23.4).
city('Teonthar','in','Madhya Pradesh',16579.0,81.65,24.98).
city('Tikamgarh','in','Madhya Pradesh',74732.0,78.83,24.74).
city('Tirodi','in','Madhya Pradesh',8871.0,79.7,21.68).
city('Udaipura','in','Madhya Pradesh',15474.0,78.5,23.08).
city('Ujjain','in','Madhya Pradesh',457395.0,75.78,23.19).
city('Ukwa','in','Madhya Pradesh',7370.0,80.47,21.97).
city('Umaria','in','Madhya Pradesh',29743.0,80.83,23.53).
city('Unhel','in','Madhya Pradesh',15838.0,75.57,23.33).
city('Vidisha','in','Madhya Pradesh',140059.0,77.8,23.53).
city('Waraseoni','in','Madhya Pradesh',23803.0,80.03,21.75).
city('Achalpur','in','Maharashtra',111287.0,77.5,21.26).
city('Ahmadnagar','in','Maharashtra',367168.0,74.74,19.1).
city('Ahmadnagar Cantonment','in','Maharashtra',39478.0,74.76,19.04).
city('Ahmadpur','in','Maharashtra',40221.0,76.93,18.7).
city('Ajra','in','Maharashtra',15864.0,74.2,16.12).
city('Akalkot','in','Maharashtra',39229.0,76.22,17.53).
city('Akola','in','Maharashtra',428892.0,77.0,20.71).
city('Akot','in','Maharashtra',86924.0,77.05,21.1).
city('Alandi','in','Maharashtra',21385.0,73.9,18.67).
city('Alibag','in','Maharashtra',20754.0,72.88,18.64).
city('Allapalli','in','Maharashtra',10772.0,80.07,19.42).
city('Amalner','in','Maharashtra',97.0,75.06,21.05).
city('Ambad','in','Maharashtra',29849.0,75.8,19.62).
city('Ambajogai','in','Maharashtra',74120.0,76.38,18.73).
city('Ambarnath','in','Maharashtra',217778.0,73.17,19.2).
city('Amravati','in','Maharashtra',603885.0,77.76,20.95).
city('Anjangaon','in','Maharashtra',55003.0,77.31,21.16).
city('Arvi','in','Maharashtra',41840.0,78.23,20.98).
city('Ashta','in','Maharashtra',35500.0,74.4,16.95).
city('Ashti','in','Maharashtra',13083.0,76.23,19.38).
city('Aurangabad','in','Maharashtra',1016520.0,75.32,19.89).
city('Ausa','in','Maharashtra',34164.0,76.5,18.25).
city('Badlapur','in','Maharashtra',104636.0,73.27,19.15).
city('Balapur','in','Maharashtra',42404.0,76.77,20.67).
city('Ballarpur','in','Maharashtra',92154.0,79.35,19.85).
city('Baramati','in','Maharashtra',53923.0,74.58,18.15).
city('Barsi','in','Maharashtra',110992.0,75.69,18.24).
city('Basmat','in','Maharashtra',63977.0,77.17,19.32).
city('Bhadravati','in','Maharashtra',74925.0,79.12,20.11).
city('Bhandara','in','Maharashtra',90190.0,79.65,21.18).
city('Bhigva','in','Maharashtra',8753.0,74.77,18.32).
city('Bhiwandi','in','Maharashtra',707090.0,73.05,19.3).
city('Bhor','in','Maharashtra',18984.0,73.85,18.17).
city('Bhum','in','Maharashtra',18545.0,75.67,18.47).
city('Bhusawal','in','Maharashtra',183016.0,75.78,21.05).
city('Bid','in','Maharashtra',148477.0,75.76,18.99).
city('Biloli','in','Maharashtra',14717.0,77.73,18.77).
city('Boisar','in','Maharashtra',15692.0,72.75,19.8).
city('Bombay','in','Maharashtra',1.2692717E7,72.82,18.96).
city('Brahmapuri','in','Maharashtra',32961.0,79.86,20.63).
city('Budhgaon','in','Maharashtra',15737.0,74.6,16.9).
city('Buldana','in','Maharashtra',66996.0,76.18,20.54).
city('Chakan','in','Maharashtra',23161.0,73.85,18.75).
city('Chalisgaon','in','Maharashtra',96389.0,74.99,20.46).
city('Chandrapur','in','Maharashtra',328377.0,79.3,19.96).
city('Chandur','in','Maharashtra',21145.0,78.58,20.27).
city('Chandur Bazar','in','Maharashtra',18781.0,77.75,21.24).
city('Chandvad','in','Maharashtra',19592.0,74.25,20.33).
city('Chicholi','in','Maharashtra',18866.0,79.68,21.47).
city('Chikhli','in','Maharashtra',52845.0,76.25,20.35).
city('Chinchani','in','Maharashtra',14357.0,72.7,19.87).
city('Chiplun','in','Maharashtra',51441.0,73.52,17.53).
city('Chopda','in','Maharashtra',65603.0,75.28,21.25).
city('Dabhol','in','Maharashtra',9142.0,73.17,17.6).
city('Dahanu','in','Maharashtra',49052.0,72.73,19.97).
city('Darwa','in','Maharashtra',23064.0,77.77,20.32).
city('Daryapur','in','Maharashtra',35784.0,77.33,20.93).
city('Dattapur','in','Maharashtra',21765.0,78.17,20.77).
city('Daund','in','Maharashtra',45444.0,74.6,18.47).
city('Dehu','in','Maharashtra',5604.0,73.77,18.72).
city('Dehu Road','in','Maharashtra',49307.0,73.72,18.16).
city('Deolali','in','Maharashtra',52962.0,73.84,19.95).
city('Deolali Pravara','in','Maharashtra',32314.0,75.01,19.62).
city('Deoli','in','Maharashtra',16687.0,78.48,20.67).
city('Deulgaon Raja','in','Maharashtra',26690.0,76.03,20.02).
city('Dharangaon','in','Maharashtra',33721.0,75.27,21.02).
city('Dharmabad','in','Maharashtra',32354.0,77.85,18.9).
city('Dharur','in','Maharashtra',19062.0,76.12,18.82).
city('Dhule','in','Maharashtra',367010.0,74.77,20.9).
city('Diglur','in','Maharashtra',52600.0,77.6,18.55).
city('Digras','in','Maharashtra',41557.0,77.72,20.12).
city('Dondaicha','in','Maharashtra',46021.0,74.57,21.33).
city('Dudhani','in','Maharashtra',12736.0,76.37,17.37).
city('Durgapur','in','Maharashtra',18561.0,79.3,20.0).
city('Edandol','in','Maharashtra',30934.0,75.33,20.92).
city('Faizpur','in','Maharashtra',24536.0,75.85,21.17).
city('Gadchiroli','in','Maharashtra',48408.0,80.0,20.17).
city('Gadhinghaj','in','Maharashtra',26451.0,74.35,16.23).
city('Gangakher','in','Maharashtra',46369.0,76.75,18.95).
city('Gangapur','in','Maharashtra',24120.0,75.02,19.68).
city('Gevrai','in','Maharashtra',30408.0,75.75,19.27).
city('Ghatanji','in','Maharashtra',20786.0,78.32,20.13).
city('Ghoti','in','Maharashtra',22097.0,73.63,19.72).
city('Ghugus','in','Maharashtra',31861.0,79.13,19.93).
city('Gondiya','in','Maharashtra',124907.0,80.2,21.47).
city('Goregaon','in','Maharashtra',6946.0,73.3,18.1).
city('Guhagar','in','Maharashtra',3425.0,73.2,17.47).
city('Hadgaon','in','Maharashtra',26453.0,77.67,19.5).
city('Hinganghat','in','Maharashtra',97576.0,78.83,20.56).
city('Hingoli','in','Maharashtra',75884.0,77.14,19.72).
city('Ichalkaranji','in','Maharashtra',274405.0,74.46,16.69).
city('Igatpuri','in','Maharashtra',35463.0,73.55,19.7).
city('Indapur','in','Maharashtra',26754.0,73.25,18.3).
city('Jalgaon','in','Maharashtra',154317.0,75.09,19.94).
city('Jalna','in','Maharashtra',262055.0,75.88,19.85).
city('Jamkhed','in','Maharashtra',29591.0,75.18,18.67).
city('Jawhar','in','Maharashtra',12083.0,73.23,19.92).
city('Jaysingpur','in','Maharashtra',46946.0,74.57,16.8).
city('Jejuri','in','Maharashtra',14064.0,74.17,18.28).
city('Jintur','in','Maharashtra',42423.0,76.7,19.62).
city('Junnar','in','Maharashtra',25999.0,73.88,19.2).
city('Kabnur','in','Maharashtra',31368.0,74.35,16.73).
city('Kagal','in','Maharashtra',25481.0,74.32,16.58).
city('Kalamb','in','Maharashtra',25752.0,74.98,18.81).
city('Kalamnuri','in','Maharashtra',22709.0,77.33,19.67).
city('Kalas','in','Maharashtra',14858.0,74.8,18.17).
city('Kalmeshwar','in','Maharashtra',19387.0,78.9,21.23).
city('Kalyan','in','Maharashtra',1262355.0,73.16,19.25).
city('Kamthi','in','Maharashtra',86220.0,79.2,21.23).
city('Kandri','in','Maharashtra',8323.0,79.27,21.42).
city('Kankavli','in','Maharashtra',15735.0,73.7,16.27).
city('Kannad','in','Maharashtra',42059.0,75.13,20.27).
city('Karad','in','Maharashtra',55667.0,74.18,17.29).
city('Karanja','in','Maharashtra',64740.0,77.48,20.48).
city('Karjat','in','Maharashtra',34577.0,73.33,18.92).
city('Karmala','in','Maharashtra',22811.0,75.2,18.42).
city('Katol','in','Maharashtra',41896.0,78.58,21.27).
city('Khadki','in','Maharashtra',75660.0,73.83,18.57).
city('Khamgaon','in','Maharashtra',94612.0,76.56,20.7).
city('Khapa','in','Maharashtra',15176.0,78.97,21.43).
city('Kharakvasla','in','Maharashtra',23677.0,73.77,18.43).
city('Khed','in','Maharashtra',11100.0,73.6,18.02).
city('Khopoli','in','Maharashtra',64465.0,73.33,18.78).
city('Khuldabad','in','Maharashtra',14415.0,75.18,20.05).
city('Kinwat','in','Maharashtra',25958.0,78.2,19.63).
city('Kodoli','in','Maharashtra',17537.0,74.2,16.88).
city('Kolhapur','in','Maharashtra',516184.0,74.22,16.7).
city('Kopargaon','in','Maharashtra',65121.0,74.48,19.88).
city('Koregaon','in','Maharashtra',25846.0,74.08,18.65).
city('Kudal','in','Maharashtra',14433.0,73.68,16.03).
city('Kurandvad','in','Maharashtra',21389.0,74.58,16.68).
city('Kurduvadi','in','Maharashtra',23132.0,75.43,18.08).
city('Lanja','in','Maharashtra',13120.0,73.55,16.85).
city('Lasalgaon','in','Maharashtra',13666.0,74.23,20.15).
city('Latur','in','Maharashtra',348994.0,76.58,18.41).
city('Lonar','in','Maharashtra',21767.0,76.53,19.98).
city('Lonavale','in','Maharashtra',58567.0,73.42,18.75).
city('Mahabaleshwar','in','Maharashtra',13599.0,73.67,17.92).
city('Mahad','in','Maharashtra',26667.0,73.42,18.08).
city('Maindargi','in','Maharashtra',11445.0,76.3,17.47).
city('Majalgaon','in','Maharashtra',47848.0,76.23,19.15).
city('Malegaon','in','Maharashtra',435397.0,74.5,20.56).
city('Malkapur','in','Maharashtra',27914.0,75.44,19.57).
city('Malwan','in','Maharashtra',18860.0,73.47,16.07).
city('Manchar','in','Maharashtra',14739.0,73.93,19.0).
city('Mangalvedhe','in','Maharashtra',22412.0,75.44,17.51).
city('Mangrul Pir','in','Maharashtra',29200.0,77.35,20.32).
city('Manmad','in','Maharashtra',76729.0,74.43,20.26).
city('Manor','in','Maharashtra',8918.0,72.92,19.75).
city('Mansar','in','Maharashtra',6901.0,79.25,21.4).
city('Manwath','in','Maharashtra',30626.0,76.5,19.3).
city('Matheran','in','Maharashtra',5288.0,73.27,18.98).
city('Mehkar','in','Maharashtra',41140.0,76.57,20.15).
city('Mhasla','in','Maharashtra',9332.0,73.12,18.13).
city('Mhaswad','in','Maharashtra',21406.0,74.77,17.64).
city('Mira Bhayandar','in','Maharashtra',687778.0,72.85,19.29).
city('Mohpa','in','Maharashtra',7141.0,78.82,21.32).
city('Moram','in','Maharashtra',17697.0,76.47,17.8).
city('Morshi','in','Maharashtra',35557.0,78.01,21.34).
city('Mudkhed','in','Maharashtra',20777.0,77.52,19.17).
city('Mukhed','in','Maha',28649.0,77.36,18.72).
city('Mul','in','Maharashtra',23986.0,79.67,20.07).
city('Murbad','in','Maharashtra',17495.0,73.4,19.25).
city('Murgud','in','Maharashtra',9396.0,74.2,16.4).
city('Murtijapur','in','Maharashtra',40226.0,77.38,20.73).
city('Murud','in','Maharashtra',12666.0,72.97,18.33).
city('Nagothana','in','Maharashtra',10866.0,73.13,18.53).
city('Nagpur','in','Maharashtra',2228191.0,79.08,21.16).
city('Nalasopara','in','Maharashtra',240250.0,72.78,19.43).
city('Naldurg','in','Maharashtra',17262.0,76.3,17.82).
city('Nanded','in','Maharashtra',485150.0,77.29,19.17).
city('Nandgaon','in','Maharashtra',24211.0,74.65,20.32).
city('Nandura','in','Maharashtra',39653.0,76.45,20.83).
city('Nandurbar','in','Maharashtra',100711.0,74.23,21.38).
city('Narkhed','in','Maharashtra',22288.0,78.54,21.48).
city('Nashik','in','Maharashtra',1289596.0,73.78,20.01).
city('Navapur','in','Maharashtra',32323.0,73.78,21.17).
city('Navghar','in','Maharashtra',157884.0,72.9,19.34).
city('Navi Mumbai','in','Maharashtra',915102.0,73.06,19.11).
city('Neral','in','Maharashtra',16061.0,73.32,19.03).
city('Nilanga','in','Maharashtra',34494.0,76.77,18.1).
city('Ojhar','in','Maharashtra',44939.0,73.93,20.1).
city('Osmanabad','in','Maharashtra',85528.0,76.03,18.17).
city('Pachora','in','Maharashtra',46827.0,75.35,20.67).
city('Paithan','in','Maharashtra',37363.0,75.38,19.48).
city('Palghar','in','Maharashtra',72383.0,72.75,19.68).
city('Panchgani','in','Maharashtra',14401.0,73.82,17.92).
city('Pandhakarwada','in','Maharashtra',28003.0,78.53,20.02).
city('Pandharpur','in','Maharashtra',95673.0,75.31,17.68).
city('Panhala','in','Maharashtra',3634.0,74.12,16.82).
city('Panvel','in','Maharashtra',128056.0,73.1,19.0).
city('Parbhani','in','Maharashtra',289652.0,76.76,19.27).
city('Parli','in','Maharashtra',94871.0,76.54,18.84).
city('Parola','in','Maharashtra',37004.0,75.12,20.88).
city('Partur','in','Maharashtra',30993.0,76.22,19.6).
city('Patan','in','Maharashtra',12156.0,73.9,17.37).
city('Pathardi','in','Maharashtra',24093.0,75.18,19.17).
city('Pathri','in','Maharashtra',37651.0,76.45,19.25).
city('Patur','in','Maharashtra',21748.0,76.93,20.45).
city('Pawni','in','Maharashtra',23452.0,79.63,20.78).
city('Pen','in','Maharashtra',34094.0,73.08,18.75).
city('Phaltan','in','Maharashtra',53206.0,74.43,17.98).
city('Pimpri','in','Maharashtra',1284702.0,73.8,18.62).
city('Poladpur','in','Maharashtra',5660.0,83.47,17.98).
city('Pulgaon','in','Maharashtra',35241.0,78.33,20.73).
city('Pune','in','Maharashtra',2935968.0,73.84,18.53).
city('Pune Cantonment','in','Maharashtra',79143.0,73.88,18.5).
city('Purna','in','Maharashtra',34891.0,77.05,19.18).
city('Pusad','in','Maharashtra',71593.0,77.57,19.91).
city('Rahimatpur','in','Maharashtra',17261.0,74.2,17.6).
city('Rahuri','in','Maharashtra',36888.0,74.65,19.38).
city('Rajapur','in','Maharashtra',10718.0,73.52,16.67).
city('Rajgurunagar','in','Maharashtra',18846.0,73.9,18.87).
city('Rajur','in','Maharashtra',11935.0,78.92,20.12).
city('Rajura','in','Maharashtra',28883.0,79.37,19.78).
city('Ramtek','in','Maharashtra',23405.0,79.33,21.4).
city('Ratnagiri','in','Maharashtra',75993.0,73.29,17.0).
city('Raver','in','Maharashtra',26637.0,76.03,21.25).
city('Revadanda','in','Maharashtra',10415.0,72.93,18.55).
city('Risod','in','Maharashtra',30134.0,76.78,19.97).
city('Sangamner','in','Maharashtra',67315.0,74.2,19.57).
city('Sangli-Miraj','in','Maharashtra',491293.0,74.57,16.86).
city('Sangole','in','Maharashtra',31281.0,75.2,17.43).
city('Sasvad','in','Maharashtra',29861.0,74.03,18.33).
city('Satana','in','Maharashtra',34443.0,74.2,20.58).
city('Satara','in','Maharashtra',112802.0,74.0,17.7).
city('Savantvadi','in','Maharashtra',23386.0,73.82,15.9).
city('Savda','in','Maharashtra',19905.0,75.88,21.15).
city('Savner','in','Maharashtra',29641.0,78.92,21.39).
city('Selu','in','Maharashtra',42882.0,76.47,19.47).
city('Shahada','in','Maharashtra',58407.0,74.47,21.55).
city('Shahapur','in','Maharashtra',10966.0,73.33,19.45).
city('Shegaon','in','Maharashtra',56453.0,76.68,20.78).
city('Shendurjana','in','Maharashtra',21705.0,77.9,21.11).
city('Shirdi','in','Maharashtra',31980.0,74.48,19.77).
city('Shirgaon','in','Maharashtra',5844.0,72.7,19.7).
city('Shirpur','in','Maharashtra',69545.0,74.88,21.35).
city('Shirwal','in','Maharashtra',12703.0,73.98,18.13).
city('Sholapur','in','Maharashtra',997358.0,75.89,17.67).
city('Shrigonda','in','Maharashtra',28210.0,74.68,18.62).
city('Shrirampur','in','Maharashtra',84950.0,74.64,19.63).
city('Sillod','in','Maharashtra',51046.0,75.65,20.3).
city('Sindi','in','Maharashtra',13637.0,78.87,20.8).
city('Sinnar','in','Maharashtra',34098.0,74.0,19.85).
city('Sirur','in','Maharashtra',31020.0,74.38,18.83).
city('Sonegaon','in','Maharashtra',12614.0,78.68,20.65).
city('Srivardhan','in','Maharashtra',15280.0,73.02,18.03).
city('Surgana','in','Maharashtra',6566.0,73.62,20.57).
city('Talegaon Dabhade','in','Maharashtra',47657.0,73.68,18.72).
city('Taloda','in','Maharashtra',26295.0,74.22,21.57).
city('Tarapur','in','Maharashtra',7493.0,72.7,19.85).
city('Tasgaon','in','Maharashtra',34935.0,74.6,17.03).
city('Telhara','in','Maharashtra',21148.0,76.84,21.03).
city('Thana','in','Maharashtra',1486453.0,72.97,19.2).
city('Trimbak','in','Maharashtra',10591.0,73.55,19.93).
city('Tuljapur','in','Maharashtra',35599.0,76.08,18.0).
city('Tumsar','in','Maharashtra',43222.0,79.73,21.38).
city('Udgir','in','Maharashtra',101072.0,77.11,18.4).
city('Ulhasnagar','in','Maharashtra',516625.0,73.15,19.23).
city('Umarga','in','Maharashtra',32184.0,76.62,17.83).
city('Umarkhed','in','Maharashtra',35268.0,77.7,19.6).
city('Umred','in','Maharashtra',51798.0,79.33,20.85).
city('Uran','in','Maharashtra',25600.0,72.94,18.88).
city('Uran Islampur','in','Maharashtra',65398.0,74.27,17.05).
city('Vada','in','Maharashtra',15475.0,73.13,19.65).
city('Vadgaon','in','Maharashtra',12374.0,73.65,18.74).
city('Vaijapur','in','Maharashtra',40046.0,74.73,19.92).
city('Varangaon','in','Maharashtra',44066.0,75.9,21.02).
city('Vasai','in','Maharashtra',53255.0,72.8,19.36).
city('Vengurla','in','Maharashtra',12499.0,73.63,15.87).
city('Virar','in','Maharashtra',150419.0,72.79,19.47).
city('Vite','in','Maharashtra',45976.0,74.55,17.28).
city('Wai','in','Maharashtra',32960.0,73.9,17.93).
city('Wani','in','Maharashtra',57293.0,78.95,20.07).
city('Wardha','in','Maharashtra',113768.0,78.6,20.75).
city('Warora','in','Maharashtra',41526.0,79.0,20.23).
city('Warud','in','Maharashtra',47821.0,78.27,21.47).
city('Washim','in','Maharashtra',68628.0,77.13,20.1).
city('Yaval','in','Maharashtra',32883.0,75.7,21.17).
city('Yavatmal','in','Maharashtra',128185.0,78.13,20.41).
city('Yeola','in','Maharashtra',46766.0,74.48,20.03).
city('Churachandpur','in','Manipur',47774.0,93.67,24.33).
city('Imphal','in','Manipur',223537.0,93.94,24.79).
city('Kakching','in','Manipur',30420.0,93.98,24.48).
city('Mayang Imphal','in','Manipur',22160.0,93.88,24.62).
city('Moirang','in','Manipur',17104.0,93.77,24.5).
city('Thoubal','in','Manipur',44497.0,94.02,24.63).
city('Wangjing','in','Manipur',7529.0,94.03,24.6).
city('Yairipok','in','Manipur',8798.0,94.07,24.67).
city('Baghmara','in','Meghalaya',9950.0,88.87,22.25).
city('Cherrapunji','in','Meghalaya',11090.0,91.7,25.3).
city('Jawai','in','Meghalaya',26849.0,92.2,25.45).
city('Mairang','in','Meghalaya',12586.0,91.63,25.57).
city('Mawlai','in','Meghalaya',41285.0,91.85,25.58).
city('Nongpoh','in','Meghalaya',14387.0,91.88,25.9).
city('Nongstoin','in','Meghalaya',25760.0,91.27,25.52).
city('Nongthymmai','in','Meghalaya',37319.0,92.25,25.31).
city('Shillong','in','Meghalaya',132853.0,91.87,25.57).
city('Tura','in','Meghalaya',63650.0,90.22,25.52).
city('Aizawl','in','Mizoram',265353.0,92.71,23.71).
city('Champhai','in','Mizoram',28934.0,93.38,23.48).
city('Darlawn','in','Mizoram',3962.0,92.9,24.02).
city('Khawhai','in','Mizoram',2537.0,93.12,23.37).
city('Lunglei','in','Mizoram',52734.0,92.73,22.88).
city('Mamit','in','Mizoram',6104.0,92.48,23.93).
city('North Vanlaiphai','in','Mizoram',3476.0,93.07,23.13).
city('Saiha','in','Mizoram',22657.0,92.97,22.48).
city('Sairang','in','Mizoram',5760.0,92.67,23.8).
city('Saitul','in','Mizoram',11045.0,92.58,23.97).
city('Serchhip','in','Mizoram',20246.0,92.83,23.3).
city('Thenzawl','in','Mizoram',5964.0,92.75,23.32).
city('Dimapur','in','Nagaland',135866.0,93.73,25.92).
city('Kohima','in','Nagaland',92117.0,94.11,25.67).
city('Mokokchung','in','Nagaland',34023.0,94.51,26.33).
city('Mon','in','Nagaland',18743.0,95.1,26.75).
city('Phek','in','Nagaland',15119.0,94.5,25.67).
city('Tuensang','in','Nagaland',33750.0,94.83,26.29).
city('Wokha','in','Nagaland',54012.0,94.27,26.1).
city('Zunheboto','in','Nagaland',29500.0,94.52,25.97).
city('Anandapur','in','Orissa',36814.0,86.11,21.23).
city('Angul','in','Orissa',44390.0,85.1,20.85).
city('Aska','in','Orissa',21136.0,84.65,19.6).
city('Athgarh','in','Orissa',16667.0,85.62,20.53).
city('Athmallik','in','Orissa',11918.0,84.53,20.72).
city('Balangir','in','Orissa',91249.0,83.5,20.71).
city('Baleshwar','in','Orissa',114331.0,86.95,21.49).
city('Balugaon','in','Orissa',17240.0,85.1,20.17).
city('Banapur','in','Orissa',17501.0,85.18,19.78).
city('Banki','in','Orissa',16557.0,85.53,20.38).
city('Banposh','in','Orissa',10431.0,84.8,22.25).
city('Barbil','in','Orissa',56875.0,85.4,22.12).
city('Bargarh','in','Orissa',68676.0,83.61,21.34).
city('Baripada','in','Orissa',116227.0,86.73,21.95).
city('Barpali','in','Orissa',20204.0,83.58,21.2).
city('Basudebpur','in','Orissa',31830.0,86.73,21.13).
city('Baudh','in','Orissa',18947.0,84.32,20.83).
city('Belaguntha','in','Orissa',10361.0,84.65,19.88).
city('Belpahar','in','Orissa',36336.0,84.02,21.91).
city('Bhadrak','in','Orissa',98657.0,86.52,21.06).
city('Bhanjanagar','in','Orissa',20649.0,84.58,19.93).
city('Bhawanipatna','in','Orissa',64474.0,83.17,19.91).
city('Bhuban','in','Orissa',20480.0,85.83,20.88).
city('Bhubaneswar','in','Orissa',762307.0,85.84,20.27).
city('Binika','in','Orissa',15096.0,83.8,21.03).
city('Birmitrapur','in','Orissa',27882.0,84.77,22.4).
city('Brahmapur','in','Orissa',324753.0,84.8,19.32).
city('Brajrajnagar','in','Orissa',79428.0,83.91,21.82).
city('Buguda','in','Orissa',14298.0,84.8,19.82).
city('Burla','in','Orissa',40820.0,83.87,21.5).
city('Byasanagar','in','Orissa',42161.0,86.33,20.85).
city('Champua','in','Orissa',9488.0,85.67,22.08).
city('Chandbali','in','Orissa',9918.0,86.77,20.78).
city('Chatrapur','in','Orissa',21125.0,84.98,19.35).
city('Chikitigarh','in','Orissa',11056.0,84.62,19.2).
city('Chitrakonda','in','Orissa',7260.0,82.08,18.12).
city('Choudwar','in','Orissa',44717.0,85.82,20.52).
city('Daitari','in','Orissa',4147.0,85.75,21.1).
city('Deogarh','in','Orissa',21136.0,84.73,21.53).
city('Dhenkanal','in','Orissa',62235.0,85.6,20.67).
city('Digapahandi','in','Orissa',11167.0,84.58,19.37).
city('Ganjam','in','Orissa',11430.0,85.07,19.38).
city('Gopalpur','in','Orissa',7163.0,84.92,19.27).
city('Gudari','in','Orissa',6895.0,83.78,19.35).
city('Gunupur','in','Orissa',22266.0,83.82,19.08).
city('Hinjilikatu','in','Orissa',22781.0,84.75,19.48).
city('Hirakud','in','Orissa',27279.0,83.87,21.52).
city('Jagatsinghapur','in','Orissa',32948.0,86.17,20.27).
city('Jajpur Road','in','Orissa',34648.0,86.14,20.95).
city('Jaleswar','in','Orissa',23282.0,87.22,21.82).
city('Jatni','in','Orissa',56008.0,85.7,20.17).
city('Jaypur','in','Orissa',80844.0,82.56,18.86).
city('Jharsuguda','in','Orissa',79499.0,84.01,21.87).
city('Joda','in','Orissa',41745.0,85.32,22.06).
city('Junagarh','in','Orissa',16857.0,82.93,19.87).
city('Kamakhyanagar','in','Orissa',15820.0,85.55,20.93).
city('Kantabanji','in','Orissa',21026.0,82.92,20.48).
city('Kantilo','in','Orissa',8862.0,85.18,20.35).
city('Kataka','in','Orissa',591515.0,85.88,20.47).
city('Kendrapara','in','Orissa',43847.0,86.42,20.5).
city('Kendujhar','in','Orissa',55801.0,85.58,21.63).
city('Kesinga','in','Orissa',17995.0,83.23,20.2).
city('Kharhial','in','Orissa',14008.0,82.77,20.28).
city('Khurda','in','Orissa',42530.0,85.62,20.18).
city('Kochinda','in','Orissa',14083.0,84.35,21.73).
city('Kodala','in','Orissa',13188.0,84.95,19.63).
city('Koraput','in','Orissa',41174.0,82.72,18.82).
city('Kotaparh','in','Orissa',15480.0,82.35,19.15).
city('Malkangiri','in','Orissa',25056.0,81.9,18.35).
city('Naurangapur','in','Orissa',29694.0,82.55,19.23).
city('Nayagarh','in','Orissa',16002.0,85.1,20.13).
city('Nilagiri','in','Orissa',15463.0,86.77,21.47).
city('Nimaparha','in','Orissa',18224.0,86.02,20.07).
city('Padampur','in','Orissa',16389.0,83.07,20.98).
city('Paradip','in','Orissa',3608.0,86.7,20.28).
city('Paradwip','in','Orissa',85875.0,86.62,20.32).
city('Parlakimidi','in','Orissa',45383.0,84.08,18.77).
city('Patamundai','in','Orissa',34403.0,86.57,20.57).
city('Patnagarh','in','Orissa',19583.0,83.15,20.72).
city('Phulabani','in','Orissa',36616.0,84.23,20.47).
city('Pipili','in','Orissa',15302.0,85.83,20.12).
city('Polasara','in','Orissa',20578.0,84.82,19.7).
city('Puri','in','Orissa',170856.0,85.83,19.81).
city('Purushottampur','in','Orissa',14709.0,84.88,19.53).
city('Rairangpur','in','Orissa',23074.0,86.17,22.27).
city('Raj Gangpur','in','Or',45422.0,84.64,22.22).
city('Rambha','in','Orissa',11277.0,85.1,19.52).
city('Raurkela','in','Orissa',226886.0,84.81,22.24).
city('Raurkela Civil Township','in','Orissa',236096.0,84.86,22.25).
city('Rayagada','in','Orissa',61410.0,83.41,19.18).
city('Redhakhol','in','Orissa',14367.0,84.35,21.07).
city('Remuna','in','Orissa',30319.0,86.88,21.55).
city('Rengali','in','Orissa',7704.0,84.05,21.63).
city('Sambalpur','in','Orissa',162901.0,83.97,21.47).
city('Sonepur','in','Orissa',18770.0,83.92,20.83).
city('Sorada','in','Orissa',15118.0,84.43,19.75).
city('Soro','in','Orissa',29800.0,86.68,21.28).
city('Sunabeda','in','Orissa',60798.0,82.86,18.69).
city('Sundargarh','in','Orissa',41709.0,84.03,22.12).
city('Talcher','in','Orissa',38439.0,85.22,20.95).
city('Tarabha','in','Orissa',8156.0,83.65,20.73).
city('Titlagarh','in','Orissa',28407.0,83.15,20.3).
city('Udala','in','Orissa',11812.0,86.57,21.58).
city('Udayagiri','in','Orissa',10866.0,84.38,20.13).
city('Umarkot','in','Orissa',27547.0,82.22,19.67).
city('Karaikal','in','Pondicherry',79662.0,79.83,10.93).
city('Mahe','in','Pondicherry',38188.0,75.53,11.7).
city('Ozhukarai','in','Pondicherry',245290.0,79.77,11.94).
city('Pondicherry','in','Pondicherry',227434.0,79.83,11.94).
city('Yanam','in','Pondicherry',36900.0,82.22,16.73).
city('Abohar','in','Punjab',130613.0,74.2,30.14).
city('Ajnala','in','Punjab',19691.0,74.8,31.85).
city('Akalgarh','in','Punjab',6993.0,75.88,29.82).
city('Alawalpur','in','Punjab',7411.0,75.65,31.43).
city('Amloh','in','Punjab',13860.0,76.23,30.62).
city('Amritsar','in','Punjab',1092528.0,74.87,31.64).
city('Anandpur Sahib','in','Punjab',15230.0,76.5,31.25).
city('Badhni Kalan','in','Punjab',6072.0,75.28,30.68).
city('Bagh Purana','in','Punjab',23362.0,75.1,30.69).
city('Banga','in','Punjab',19236.0,75.98,31.18).
city('Barnala','in','Punjab',105024.0,75.54,30.39).
city('Bassi Pathana','in','Punjab',18593.0,76.4,30.69).
city('Batala','in','Punjab',145479.0,75.21,31.82).
city('Bathinda','in','Punjab',242818.0,74.97,30.17).
city('Begowal','in','Punjab',10175.0,75.52,31.62).
city('Bhawanigarh','in','Punjab',19377.0,76.03,30.27).
city('Bhikhi','in','Punjab',15960.0,75.53,30.07).
city('Budhlada','in','Punjab',25433.0,75.57,29.93).
city('Dasuya','in','Punjab',20699.0,75.63,31.82).
city('Daulatpur','in','Punjab',4810.0,75.98,31.78).
city('Dera Baba Nanak','in','Punjab',7492.0,75.02,32.03).
city('Dhanaula','in','Punjab',19283.0,75.58,30.28).
city('Dhariwal','in','Punjab',20605.0,75.3,31.95).
city('Dhilwan','in','Punjab',8447.0,75.35,31.52).
city('Dhuri','in','Punjab',54306.0,75.87,30.37).
city('Dinanagar','in','Punjab',23341.0,75.47,32.15).
city('Dirba','in','Punjab',13838.0,75.98,30.07).
city('Doraha','in','Punjab',23553.0,76.02,30.82).
city('Faridkot','in','Punjab',77455.0,74.74,30.68).
city('Fatehgarh Churian','in','Punjab',18053.0,74.97,31.87).
city('Fazilka','in','Punjab',70893.0,74.02,30.41).
city('Firozpur','in','Punjab',102138.0,74.61,30.92).
city('Fir','in','Punjab',58775.0,74.6,30.95).
city('Gardhiwala','in','Punjab',6694.0,75.75,31.73).
city('Garhshankar','in','Punjab',16471.0,76.13,31.22).
city('Ghanaur','in','Punjab',6091.0,76.62,30.33).
city('Giddarbaha','in','Punjab',39246.0,74.67,30.2).
city('Gobindgarh','in','Punjab',61067.0,76.31,30.66).
city('Gurdaspur','in','Punjab',72503.0,75.4,32.04).
city('Guru Har Sahai','in','Punjab',16029.0,74.42,30.72).
city('Hajipur','in','Punjab',5680.0,75.75,31.98).
city('Hariana','in','Punjab',8333.0,75.85,31.63).
city('Hoshiarpur','in','Punjab',158154.0,75.91,31.53).
city('Jagraon','in','Punjab',65310.0,75.48,30.78).
city('Jaitu','in','Punjab',34349.0,74.88,30.47).
city('Jalalabad','in','Punjab',29826.0,74.25,30.62).
city('Jalandhar','in','Punjab',785234.0,75.57,31.33).
city('Jalandhar Cantonment','in','Punjab',44246.0,75.63,31.31).
city('Jandiala','in','Punjab',16894.0,75.34,31.39).
city('Kalanaur','in','Punjab',13671.0,75.15,32.02).
city('Kapurthala','in','Punjab',92674.0,75.38,31.38).
city('Kartarpur','in','Punjab',26703.0,75.5,31.45).
city('Khamanon','in','Punjab',9395.0,76.35,30.82).
city('Khanna','in','Punjab',117146.0,76.21,30.71).
city('Kharar','in','Punjab',45694.0,76.65,30.75).
city('Khem Karan','in','Punjab',12637.0,74.57,31.15).
city('Kot Isa Khan','in','Punjab',9639.0,75.13,30.95).
city('Kot Kapura','in','Punjab',88360.0,74.8,30.59).
city('Kurali','in','Punjab',25332.0,76.58,30.83).
city('Longowal','in','Punjab',21882.0,75.68,30.22).
city('Ludhiana','in','Punjab',1545476.0,75.84,30.91).
city('Machhiwara','in','Punjab',20448.0,76.2,30.92).
city('Majitha','in','Punjab',13901.0,74.95,31.77).
city('Makhu','in','Punjab',12885.0,74.98,31.1).
city('Malaut','in','Punjab',76621.0,74.48,30.23).
city('Maler Kotla','in','Punjab',113848.0,75.87,30.54).
city('Mansa','in','Punjab',80024.0,75.39,29.98).
city('Maur','in','Punjab',28298.0,75.25,30.08).
city('Moga','in','Punjab',130559.0,75.17,30.82).
city('Mohali','in','Punjab',145096.0,76.69,30.78).
city('Mukerian','in','Punjab',22753.0,75.62,31.95).
city('Muktsar','in','Punjab',89840.0,74.52,30.47).
city('Munak','in','Punjab',15802.0,76.85,29.52).
city('Nabha','in','Punjab',64645.0,76.14,30.38).
city('Nakodar','in','Punjab',32407.0,75.48,31.12).
city('Nangal','in','Punjab',44179.0,76.38,31.37).
city('Nawashahr','in','Punjab',31123.0,76.13,31.12).
city('Nurmahal','in','Punjab',13155.0,75.6,31.1).
city('Pathankot','in','Punjab',174319.0,75.64,32.27).
city('Patiala','in','Punjab',329248.0,76.39,30.32).
city('Patti','in','Punjab',37090.0,74.85,31.28).
city('Phagwara','in','Punjab',100154.0,75.76,31.22).
city('Phillaur','in','Punjab',22590.0,75.78,31.02).
city('Qadian','in','Punjab',21016.0,75.38,31.82).
city('Rahon','in','Punjab',12486.0,76.12,31.05).
city('Raikot','in','Punjab',26116.0,75.6,30.65).
city('Raja Sansi','in','Punjab',12958.0,74.8,31.72).
city('Rajpura','in','Punjab',86827.0,76.59,30.48).
city('Ram Das','in','Punjab',6191.0,74.9,31.97).
city('Raman','in','Punjab',20353.0,74.96,29.94).
city('Rampura','in','Punjab',45642.0,75.23,30.25).
city('Rupnagar','in','Punjab',52317.0,76.52,30.98).
city('Samana','in','Punjab',50536.0,76.2,30.15).
city('Samrala','in','Punjab',18624.0,76.18,30.85).
city('Sanaur','in','Punjab',18402.0,76.45,30.3).
city('Sangrur','in','Punjab',88622.0,75.84,30.25).
city('Sardulgarh','in','Punjab',17270.0,75.25,29.7).
city('Shahkot','in','Punjab',13578.0,75.33,31.12).
city('Sham Churasi','in','Punjab',4403.0,75.75,31.5).
city('Sirhind','in','Punjab',60852.0,76.38,30.65).
city('Sunam','in','Punjab',53651.0,75.8,30.13).
city('Talwandi Bhai','in','Punjab',16392.0,74.93,30.85).
city('Talwara','in','Punjab',24754.0,75.9,31.93).
city('Tarn Taran','in','Punjab',58590.0,74.92,31.45).
city('Zira','in','Punjab',34587.0,74.99,30.97).
city('Abu Road','in','Rajasthan',50266.0,72.78,24.48).
city('Ajmer','in','Rajasthan',517947.0,74.64,26.45).
city('Aklera','in','Rajasthan',19684.0,76.57,24.42).
city('Alwar','in','Rajasthan',283248.0,76.6,27.56).
city('Amet','in','Rajasthan',17435.0,73.93,25.3).
city('Antah','in','Rajasthan',30600.0,76.29,25.15).
city('Anupgarh','in','Rajasthan',33311.0,73.21,29.19).
city('Asind','in','Rajasthan',15390.0,74.33,25.73).
city('Bagar','in','Rajasthan',15671.0,75.5,28.18).
city('Bagru','in','Rajasthan',25102.0,75.55,26.82).
city('Bahror','in','Rajasthan',25817.0,76.26,27.87).
city('Bakani','in','Rajasthan',8621.0,76.23,24.28).
city('Bali','in','Rajasthan',19260.0,73.28,25.18).
city('Balotra','in','Rajasthan',68125.0,72.23,25.83).
city('Bandikui','in','Rajasthan',16166.0,76.57,27.05).
city('Banswara','in','Rajasthan',93654.0,74.44,23.54).
city('Baran','in','Rajasthan',87484.0,76.51,25.1).
city('Bari','in','Rajasthan',56140.0,77.6,26.65).
city('Bari Sadri','in','Rajasthan',15617.0,74.47,24.42).
city('Barmer','in','Rajasthan',89493.0,71.39,25.75).
city('Basi','in','Rajasthan',21096.0,76.03,26.83).
city('Baswa','in','Rajasthan',22515.0,76.58,27.15).
city('Bayana','in','Rajasthan',36402.0,77.28,26.9).
city('Beawar','in','Rajasthan',130786.0,74.3,26.1).
city('Begun','in','Rajasthan',20837.0,75.0,24.98).
city('Bhadasar','in','Rajasthan',33009.0,74.32,28.28).
city('Bhadra','in','Rajasthan',37632.0,75.17,29.12).
city('Bharatpur','in','Rajasthan',229400.0,77.49,27.23).
city('Bhasawar','in','Rajasthan',18997.0,77.03,27.03).
city('Bhawani Mandi','in','Rajasthan',38033.0,75.83,24.42).
city('Bhilwara','in','Rajasthan',326454.0,74.63,25.35).
city('Bhindar','in','Rajasthan',16946.0,74.18,24.5).
city('Bhinmal','in','Rajasthan',42866.0,72.25,25.0).
city('Bikaner','in','Rajasthan',576056.0,73.32,28.03).
city('Bilara','in','Rajasthan',41713.0,73.7,26.17).
city('Bissau','in','Rajasthan',22622.0,75.08,28.25).
city('Bundi','in','Rajasthan',98576.0,75.63,25.45).
city('Chatsu','in','Rajasthan',33100.0,75.95,26.6).
city('Chechat','in','Rajasthan',11138.0,75.88,24.77).
city('Chhabra','in','Rajasthan',25678.0,76.83,24.67).
city('Chhapar','in','Rajasthan',18729.0,74.4,27.82).
city('Chhoti Sadri','in','Rajasthan',17336.0,74.7,24.38).
city('Chirawa','in','Rajasthan',41322.0,75.63,28.25).
city('Chittaurgarh','in','Rajasthan',106718.0,74.63,24.89).
city('Chomun','in','Rajasthan',55965.0,75.72,27.17).
city('Churu','in','Rajasthan',103541.0,74.96,28.31).
city('Daosa','in','Rajasthan',73039.0,76.33,26.88).
city('Dariba','in','Rajasthan',3076.0,74.13,24.95).
city('Deshnok','in','Rajasthan',16721.0,73.35,27.8).
city('Devgarh','in','Rajasthan',17502.0,73.9,25.53).
city('Devli','in','Rajasthan',21299.0,75.38,25.75).
city('Dhaulpur','in','Rajasthan',102469.0,77.87,26.7).
city('Didwana','in','Rajasthan',49856.0,74.57,27.39).
city('Dig','in','Rajasthan',43489.0,77.33,27.47).
city('Dungargarh','in','Rajasthan',48040.0,74.02,28.08).
city('Dungarpur','in','Rajasthan',45198.0,73.72,23.83).
city('Fatehpur','in','Rajasthan',83176.0,74.95,27.99).
city('Galiakot','in','Rajasthan',6907.0,74.0,23.52).
city('Ganganagar','in','Rajasthan',231855.0,73.86,29.93).
city('Gangapur','in','Rajasth',68893.0,75.5,25.85).
city('Gothra','in','Rajasthan',22420.0,75.38,27.82).
city('Govindgarh','in','Rajasthan',10956.0,76.98,27.5).
city('Gulabpura','in','Rajasthan',26469.0,74.67,25.9).
city('Hanumangarh','in','Rajasthan',155698.0,74.29,29.62).
city('Hindaun','in','Rajasthan',95600.0,77.02,26.74).
city('Jahazpur','in','Rajasthan',20351.0,75.28,25.62).
city('Jaipur','in','Rajasthan',2711937.0,75.8,26.92).
city('Jaisalmer','in','Rajasthan',67609.0,70.9,26.92).
city('Jaitaran','in','Rajasthan',21405.0,73.93,26.2).
city('Jalor','in','Rajasthan',49686.0,72.62,25.35).
city('Jhalawar','in','Rajasthan',51888.0,76.15,24.6).
city('Jhalrapatan','in','Rajasthan',33123.0,76.17,24.55).
city('Jhunjhunun','in','Rajasthan',113201.0,75.39,28.13).
city('Jobner','in','Rajasthan',10829.0,75.38,26.97).
city('Jodhpur','in','Rajasthan',921540.0,73.02,26.29).
city('Kaithun','in','Rajasthan',22166.0,75.98,25.14).
city('Kaman','in','Rajasthan',33527.0,77.27,27.65).
city('Kanor','in','Rajasthan',13090.0,74.27,24.43).
city('Kapasan','in','Rajasthan',19732.0,74.33,24.9).
city('Karanpura','in','Rajasthan',21606.0,73.45,29.84).
city('Karauli','in','Rajasthan',73722.0,77.02,26.5).
city('Kekri','in','Rajasthan',37853.0,75.15,25.97).
city('Keshorai Patan','in','Rajasthan',23466.0,75.93,25.3).
city('Khairthal','in','Rajasthan',36213.0,76.64,27.8).
city('Khandela','in','Rajasthan',23165.0,75.5,27.6).
city('Khanpur','in','Rajasthan',14854.0,76.38,24.72).
city('Khetri','in','Rajasthan',17178.0,75.8,27.98).
city('Kishangarh','in','Rajasthan',71024.0,75.79,27.2).
city('Kishangarh Ranwal','in','Rajasthan',30062.0,75.35,27.17).
city('Kot Putli','in','Rajasthan',43654.0,76.2,27.72).
city('Kota','in','Rajasthan',763141.0,75.83,25.18).
city('Kuchaman','in','Rajasthan',56729.0,74.85,27.15).
city('Kuchera','in','Rajasthan',21798.0,73.97,26.98).
city('Kumher','in','Rajasthan',21904.0,77.37,27.32).
city('Kushalgarh','in','Rajasthan',10350.0,74.45,23.17).
city('Lachhmangarh','in','Rajasthan',48145.0,75.03,27.82).
city('Ladnun','in','Rajasthan',60494.0,74.38,27.64).
city('Lakheri','in','Rajasthan',28466.0,76.17,25.67).
city('Lalsot','in','Rajasthan',31482.0,76.33,26.57).
city('Losal','in','Rajasthan',27966.0,74.92,27.4).
city('Mahwa','in','Rajasthan',22626.0,76.93,27.05).
city('Makrana','in','Rajasthan',93911.0,74.72,27.05).
city('Malpura','in','Rajasthan',28602.0,75.38,26.28).
city('Mandal','in','Rajasthan',23478.0,74.57,25.45).
city('Mandalgarh','in','Rajasthan',21570.0,75.1,25.2).
city('Mandawar','in','Rajasthan',10979.0,76.55,27.87).
city('Mandwa','in','Rajasthan',22465.0,75.16,28.04).
city('Mangrol','in','Rajasthan',23897.0,76.52,25.33).
city('Manohar Thana','in','Rajasthan',10100.0,76.8,24.23).
city('Manoharpur','in','Rajasthan',28928.0,75.95,27.3).
city('Merta','in','Rajasthan',43761.0,74.03,26.65).
city('Mount Abu','in','Rajasthan',24982.0,72.7,24.6).
city('Mundwa','in','Rajasthan',17466.0,73.82,27.07).
city('Nadbai','in','Rajasthan',23522.0,77.2,27.23).
city('Naenwa','in','Rajasthan',16416.0,75.85,25.77).
city('Nagar','in','Rajasthan',23548.0,77.1,27.43).
city('Nagaur','in','Rajasthan',96853.0,73.73,27.21).
city('Napasar','in','Rajasthan',21749.0,73.55,27.97).
city('Naraina','in','Rajasthan',17048.0,75.2,26.78).
city('Nasirabad','in','Rajasthan',51751.0,74.73,26.3).
city('Nathdwara','in','Rajasthan',39429.0,73.82,24.93).
city('Nawa','in','Rajasthan',20046.0,75.0,27.02).
city('Nawalgarh','in','Rajasthan',58350.0,75.27,27.85).
city('Nim ka Thana','in','Rajasthan',32692.0,75.8,27.73).
city('Nimaj','in','Rajasthan',20424.0,74.0,26.17).
city('Nimbahera','in','Rajasthan',58089.0,74.68,24.62).
city('Niwai','in','Rajasthan',35117.0,75.92,26.35).
city('Nohar','in','Rajasthan',46363.0,74.77,29.18).
city('Nokha','in','Rajasthan',55915.0,73.42,27.6).
city('Padampur','in','Rajasthan',18455.0,73.62,29.68).
city('Pali','in','Rajasthan',210117.0,73.32,25.79).
city('Partapur','in','Rajasthan',10081.0,74.17,23.6).
city('Parvatsar','in','Rajasthan',15406.0,74.77,26.88).
city('Phalodi','in','Rajasthan',46792.0,72.37,27.13).
city('Phulera','in','Rajasthan',22574.0,75.23,26.87).
city('Pilani','in','Rajasthan',28151.0,75.6,28.37).
city('Pilibanga','in','Rajasthan',36757.0,74.08,29.45).
city('Pindwara','in','Rajasthan',23230.0,73.07,24.8).
city('Pipar','in','Rajasthan',34633.0,73.53,26.38).
city('Pirawa','in','Rajasthan',11791.0,76.03,24.17).
city('Pokaran','in','Rajasthan',21015.0,71.92,26.92).
city('Pratapgarh','in','Rajasthan',37782.0,74.78,24.03).
city('Pushkar','in','Rajasthan',16174.0,74.55,26.5).
city('Raipur','in','Rajasthan',17537.0,74.02,26.0).
city('Raisinghnagar','in','Rajasthan',29628.0,73.45,29.54).
city('Rajakhera','in','Rajasthan',30630.0,78.18,26.92).
city('Rajaldesar','in','Rajasthan',24105.0,74.47,28.03).
city('Rajgarh','in','Rajasthan',38271.0,76.01,27.93).
city('Rajsamand','in','Rajasthan',63419.0,73.88,25.07).
city('Ramganj Mandi','in','Rajasthan',35757.0,75.93,24.65).
city('Ramgarh','in','Rajasthan',29836.0,75.18,27.25).
city('Rani','in','Rajasthan',13573.0,73.3,25.37).
city('Ratangarh','in','Rajasthan',66630.0,74.6,28.09).
city('Rawatbhata','in','Rajasthan',36874.0,75.58,24.94).
city('Rawatsar','in','Rajasthan',31018.0,74.38,29.28).
city('Ringas','in','Rajasthan',25173.0,75.57,27.35).
city('Sadri','in','Rajasthan',25634.0,73.43,25.18).
city('Sagwara','in','Rajasthan',34931.0,74.8,23.68).
city('Salumbar','in','Rajasthan',16558.0,74.05,24.13).
city('Sambhar','in','Rajasthan',22830.0,75.2,26.92).
city('Samdari','in','Rajasthan',17915.0,72.58,25.82).
city('Sanchor','in','Rajasthan',29024.0,71.77,24.76).
city('Sangariya','in','Rajasthan',38641.0,74.45,29.8).
city('Sangod','in','Rajasthan',19844.0,76.28,24.92).
city('Sardarshahr','in','Rajasthan',86678.0,74.48,28.45).
city('Sarwar','in','Rajasthan',17861.0,75.0,26.07).
city('Sawai Madhopur','in','Rajasthan',108620.0,76.34,26.03).
city('Shahpura','in','Rajasthan',31268.0,75.45,26.51).
city('Sheoganj','in','Rajasthan',26806.0,73.07,25.15).
city('Sikar','in','Rajasthan',199946.0,75.13,27.61).
city('Sirohi','in','Rajasthan',38613.0,72.87,24.88).
city('Siwana','in','Rajasthan',22067.0,72.42,25.63).
city('Sojat','in','Rajasthan',42559.0,73.67,25.92).
city('Sri Madhopur','in','Rajasthan',30283.0,75.6,27.47).
city('Sujangarh','in','Rajasthan',88861.0,74.46,27.7).
city('Suket','in','Rajasthan',19852.0,76.03,24.65).
city('Sunel','in','Rajasthan',15840.0,75.97,24.37).
city('Surajgarh','in','Rajasthan',19723.0,75.73,28.32).
city('Suratgarh','in','Rajasthan',63158.0,73.9,29.32).
city('Takhatgarh','in','Rajasthan',17287.0,73.0,25.33).
city('Taranagar','in','Rajasthan',29394.0,75.03,28.68).
city('Tijara','in','Rajasthan',21835.0,76.85,27.93).
city('Toda Bhim','in','Rajasthan',22531.0,76.82,26.92).
city('Toda Raisingh','in','Rajasthan',22615.0,75.48,26.02).
city('Tonk','in','Rajasthan',151341.0,75.78,26.17).
city('Udaipur','in','Rajasthan',226540.0,74.59,26.15).
city('Udpura','in','Rajasthan',10015.0,75.97,24.72).
city('Uniara','in','Rajasthan',11442.0,75.22,26.15).
city('Vijainagar','in','Rajasthan',30789.0,74.64,26.11).
city('Wer','in','Rajasthan',18269.0,77.17,27.0).
city('Gangtok','in','Sikkim',30702.0,88.6,27.34).
city('Gezing','in','Sikkim',869.0,88.27,27.28).
city('Mangan','in','Sikkim',1464.0,88.53,27.52).
city('Namchi','in','Sikkim',1147.0,88.35,27.17).
city('Naya Bazar','in','Sikkim',1035.0,88.27,27.13).
city('Rangpo','in','Sikkim',4026.0,88.53,27.18).
city('Singtam','in','Sikkim',6133.0,88.5,27.23).
city('Abiramam','in','Tamil Nadu',6837.0,78.45,9.47).
city('Adiramapattinam','in','Tamil Nadu',27911.0,79.4,10.35).
city('Aduturai','in','Tamil Nadu',11434.0,79.48,11.03).
city('Alandur','in','Tamil Nadu',153789.0,80.23,13.03).
city('Alanganallur','in','Tamil Nadu',11400.0,78.05,10.07).
city('Alangayam','in','Tamil Nadu',17357.0,78.75,12.6).
city('Alangudi','in','Tamil Nadu',10618.0,78.98,10.37).
city('Alangulam','in','Tamil Nadu',28585.0,77.5,8.87).
city('Alwar Tirunagari','in','Tamil Nadu',8888.0,77.95,8.6).
city('Ambasamudram','in','Tamil Nadu',32022.0,77.44,8.71).
city('Ambattur','in','Tamil Nadu',341078.0,80.17,13.11).
city('Ambur','in','Tamil Nadu',109883.0,78.72,12.8).
city('Ammapettai','in','Tamil Nadu',11544.0,78.54,11.22).
city('Anaimalai','in','Tamil Nadu',16132.0,76.93,10.58).
city('Anakaputhur','in','Tamil Nadu',34801.0,80.26,13.0).
city('Andippatti','in','Tamil Nadu',24450.0,77.63,9.98).
city('Annamalainagar','in','Tamil Nadu',8828.0,79.73,11.4).
city('Annavasal','in','Tamil Nadu',7861.0,78.7,10.47).
city('Annur','in','Tamil Nadu',19964.0,77.13,11.23).
city('Anthiyur','in','Tamil Nadu',20438.0,77.6,11.58).
city('Arakonam','in','Tamil Nadu',79087.0,79.67,13.08).
city('Arani','in','Tamil Nadu',62863.0,79.28,12.68).
city('Arani Road','in','Tamil Nadu',12950.0,79.28,12.67).
city('Arantangi','in','Tamil Nadu',35624.0,78.98,10.17).
city('Aravankadu','in','Tamil Nadu',5176.0,76.77,11.37).
city('Arcot','in','Tamil Nadu',51948.0,79.33,12.91).
city('Arimalam','in','Tamil Nadu',8048.0,78.9,10.27).
city('Ariyalur','in','Tamil Nadu',29146.0,79.08,11.13).
city('Arumbavur','in','Tamil Nadu',11419.0,78.73,11.38).
city('Arumuganeri','in','Tamil Nadu',25154.0,78.12,8.57).
city('Aruppukkottai','in','Tamil Nadu',85377.0,78.09,9.51).
city('Attayyampatti','in','Tamil Nadu',13628.0,78.07,11.53).
city('Attur','in','Tamil Nadu',58707.0,78.6,11.6).
city('Avadi','in','Tamil Nadu',250066.0,80.11,13.12).
city('Avanashi','in','Tamil Nadu',24329.0,77.28,11.2).
city('Avaniapuram','in','Tamil Nadu',58731.0,78.12,9.86).
city('Ayakudi','in','Tamil Nadu',24120.0,77.55,10.45).
city('Ayyampettai','in','Tamil Nadu',14704.0,79.18,10.9).
city('Bargur','in','Tamil Nadu',12959.0,78.37,12.55).
city('Belur','in','Tamil Nadu',9281.0,78.42,11.7).
city('Bhavani','in','Tamil Nadu',39748.0,77.68,11.45).
city('Bhuvanagiri','in','Tamil Nadu',20658.0,79.63,11.47).
city('Bodinayakkanur','in','Tamil Nadu',75687.0,77.35,10.01).
city('Chengalpattu','in','Tamil Nadu',65695.0,79.97,12.7).
city('Chengam','in','Tamil Nadu',23904.0,78.8,12.3).
city('Chennamalai','in','Tamil Nadu',16270.0,77.61,11.17).
city('Chetpet','in','Tamil Nadu',18326.0,80.23,13.07).
city('Chettipalaiyam','in','Tamil Nadu',24091.0,77.07,10.9).
city('Cheyur','in','Tamil Nadu',11060.0,80.0,12.35).
city('Chidambaram','in','Tamil Nadu',58655.0,79.68,11.4).
city('Chinalapatti','in','Tamil Nadu',23379.0,77.94,10.3).
city('Chinna Salem','in','Tamil Nadu',20111.0,78.9,11.65).
city('Chinnammanur','in','Tamil Nadu',39217.0,77.38,9.83).
city('Courtalam','in','Tamil Nadu',2440.0,77.28,8.92).
city('Denkanikottai','in','Tamil Nadu',19360.0,77.78,12.52).
city('Desur','in','Tamil Nadu',5312.0,79.48,12.43).
city('Devadanapatti','in','Tamil Nadu',14190.0,77.65,10.15).
city('Devakkottai','in','Tamil Nadu',41572.0,78.82,9.95).
city('Dhali','in','Tamil Nadu',6494.0,77.17,10.5).
city('Dharapuram','in','Tamil Nadu',72297.0,77.52,10.74).
city('Dharmapuri','in','Tamil Nadu',66022.0,78.16,12.13).
city('Dindigul','in','Tamil Nadu',200814.0,77.97,10.36).
city('Dusi','in','Tamil Nadu',5257.0,79.68,12.77).
city('Elayirampannai','in','Tamil Nadu',6473.0,77.83,9.27).
city('Elumalai','in','Tamil Nadu',14456.0,77.7,9.87).
city('Eral','in','Tamil Nadu',9188.0,78.02,8.63).
city('Eraniel','in','Tamil Nadu',9844.0,77.3,8.2).
city('Erode','in','Tamil Nadu',147283.0,77.73,11.35).
city('Ettaiyapuram','in','Tamil Nadu',12957.0,77.98,9.15).
city('Gangavalli','in','Tamil Nadu',10905.0,78.65,11.48).
city('Gingi','in','Tamil Nadu',21530.0,79.41,12.25).
city('Gopichettipalaiyam','in','Tamil Nadu',57532.0,77.43,11.46).
city('Gudalur','in','Tamil Nadu',81067.0,77.83,10.99).
city('Gudiyattam','in','Tamil Nadu',93981.0,78.86,12.95).
city('Gummidipundi','in','Tamil Nadu',16605.0,80.15,13.4).
city('Harur','in','Tamil Nadu',20407.0,78.5,12.07).
city('Hosur','in','Tamil Nadu',103769.0,77.82,12.72).
city('Idappadi','in','Tamil Nadu',51647.0,77.85,11.58).
city('Ilampillai','in','Tamil Nadu',11309.0,78.0,11.6).
city('Iluppur','in','Tamil Nadu',12472.0,78.63,10.52).
city('Inam Karur','in','Tamil Nadu',46960.0,78.01,10.96).
city('Irugur','in','Tamil Nadu',19166.0,77.07,11.02).
city('Jalakandapuram','in','Tamil Nadu',14530.0,77.88,11.7).
city('Jayankondam','in','Tamil Nadu',32217.0,79.36,11.21).
city('Jolarpet','in','Tamil Nadu',40962.0,78.58,12.56).
city('Kadambur','in','Tamil Nadu',4512.0,77.87,8.98).
city('Kadayanallur','in','Tamil Nadu',77779.0,77.35,9.08).
city('Kalapatti','in','Tamil Nadu',22759.0,77.07,11.09).
city('Kalavai','in','Tamil Nadu',10057.0,79.42,12.77).
city('Kallakkurichi','in','Tamil Nadu',40453.0,78.97,11.73).
city('Kallidaikurichchi','in','Tamil Nadu',25515.0,77.48,8.67).
city('Kallupatti','in','Tamil Nadu',9725.0,77.87,9.72).
city('Kalugumalai','in','Tamil Nadu',15425.0,77.72,9.15).
city('Kambam','in','Tamil Nadu',60834.0,77.28,9.74).
city('Kanadukathan','in','Tamil Nadu',4814.0,78.78,10.17).
city('Kanchipuram','in','Tamil Nadu',155043.0,79.7,12.84).
city('Kangayam','in','Tamil Nadu',31367.0,77.57,11.0).
city('Kanniyakumari','in','Tamil Nadu',20542.0,77.57,8.08).
city('Karaikkudi','in','Tamil Nadu',91916.0,78.77,10.07).
city('Karamadai','in','Tamil Nadu',31190.0,76.97,11.27).
city('Karambakkudi','in','Tamil Nadu',12371.0,79.13,10.47).
city('Kariapatti','in','Tamil Nadu',14398.0,78.1,9.7).
city('Karumbakkam','in','Tamil Nadu',11992.0,80.1,12.7).
city('Karur','in','Tamil Nadu',76922.0,78.07,10.96).
city('Kasipalaiyam','in','Tamil Nadu',57036.0,77.29,11.45).
city('Katpadi','in','Tamil Nadu',16408.0,79.13,12.98).
city('Kattivakkam','in','Tamil Nadu',34598.0,80.32,13.22).
city('Kaveripattinam','in','Tamil Nadu',14209.0,78.23,12.42).
city('Kavundampalaiyam','in','Tamil Nadu',25210.0,76.92,11.05).
city('Kavundampalayam','in','Tamil Nadu',48409.0,76.91,11.07).
city('Kayalpattinam','in','Tamil Nadu',36178.0,78.13,8.56).
city('Kayattar','in','Tamil Nadu',10008.0,77.8,8.95).
city('Kelamangalam','in','Tamil Nadu',11328.0,77.85,12.6).
city('Kilakarai','in','Tamil Nadu',30471.0,78.78,9.23).
city('Kilvelur','in','Tamil Nadu',7629.0,79.73,10.77).
city('Kiranur','in','Tamil Nadu',8311.0,78.15,10.59).
city('Kodaikanal','in','Tamil Nadu',35024.0,77.48,10.23).
city('Kodumudi','in','Tamil Nadu',13053.0,77.88,11.08).
city('Kolachal','in','Tamil Nadu',23097.0,77.25,8.17).
city('Kombai','in','Tamil Nadu',13209.0,77.32,9.83).
city('Konganapuram','in','Tamil Nadu',8331.0,77.92,11.58).
city('Koradacheri','in','Tamil Nadu',6151.0,79.48,10.77).
city('Korampallam','in','Tamil Nadu',3228.0,78.1,8.77).
city('Kotagiri','in','Tamil Nadu',28850.0,76.88,11.43).
city('Kottaiyur','in','Tamil Nadu',11520.0,78.82,10.12).
city('Kovilpatti','in','Tamil Nadu',90304.0,77.86,9.19).
city('Koyampattur','in','Tamil Nadu',959906.0,76.96,11.01).
city('Krishnagiri','in','Tamil Nadu',66425.0,78.21,12.54).
city('Kulithalai','in','Tamil Nadu',26824.0,78.42,10.92).
city('Kumarapalaiyam','in','Tamil Nadu',67041.0,77.73,11.44).
city('Kumbakonam','in','Tamil Nadu',139276.0,79.38,10.97).
city('Kuniyamuthur','in','Tamil Nadu',65854.0,76.95,10.98).
city('Kunur','in','Tamil Nadu',50534.0,76.78,11.36).
city('Kurichi','in','Tamil Nadu',81275.0,76.96,10.92).
city('Kurinjippadi','in','Tamil Nadu',23019.0,79.6,11.57).
city('Kuttanallur','in','Tamil Nadu',23260.0,79.53,10.7).
city('Kuzhithurai','in','Tamil Nadu',20613.0,77.18,8.32).
city('Lalgudi','in','Tamil Nadu',20918.0,78.83,10.87).
city('Madhavaram','in','Tamil Nadu',90052.0,80.26,13.02).
city('Madras','in','Tamil Nadu',4328416.0,80.27,13.09).
city('Madukkarai','in','Tamil Nadu',29147.0,76.97,10.9).
city('Madukkur','in','Tamil Nadu',15631.0,79.4,10.48).
city('Ma','in','Tamil Nadu',909988.0,78.12,9.92).
city('Maduranthakam','in','Tamil Nadu',29746.0,79.9,12.52).
city('Mallapuram','in','Tamil Nadu',11837.0,78.25,11.97).
city('Mallasamudram','in','Tamil Nadu',18822.0,78.03,11.48).
city('Mallur','in','Tamil Nadu',10525.0,78.13,11.55).
city('Mamallapuram','in','Tamil Nadu',12415.0,80.2,12.62).
city('Manali','in','Tamil Nadu',32366.0,80.27,13.17).
city('Manalurpet','in','Tamil Nadu',7626.0,79.1,12.02).
city('Manamadurai','in','Tamil Nadu',27496.0,78.48,9.7).
city('Manapparai','in','Tamil Nadu',36930.0,78.42,10.6).
city('Manavalakurichi','in','Tamil Nadu',10720.0,77.3,8.13).
city('Mandapam','in','Tamil Nadu',15080.0,79.12,9.28).
city('Mangalam','in','Tamil Nadu',11379.0,78.67,9.77).
city('Mannargudi','in','Tamil Nadu',63154.0,79.45,10.67).
city('Marakkanam','in','Tamil Nadu',19734.0,79.95,12.2).
city('Marandahalli','in','Tamil Nadu',10480.0,78.0,12.4).
city('Masinigudi','in','Tamil Nadu',9642.0,76.67,11.57).
city('Mayiladuthurai','in','Tamil Nadu',86668.0,79.65,11.11).
city('Melur','in','Tamil Nadu',33842.0,78.33,10.05).
city('Melvisharam','in','Tamil Nadu',41067.0,79.24,12.94).
city('Mettupalayam','in','Tamil Nadu',38268.0,77.69,11.24).
city('Mettur','in','Tamil Nadu',56748.0,77.8,11.8).
city('Minjur','in','Tamil Nadu',24674.0,80.27,13.27).
city('Mohanur','in','Tamil Nadu',12846.0,78.17,11.08).
city('Mulanur','in','Tamil Nadu',12264.0,77.72,10.77).
city('Musiri','in','Tamil Nadu',30211.0,78.45,10.93).
city('Muttayyapuram','in','Tamil Nadu',31885.0,78.13,8.83).
city('Muttupet','in','Tamil Nadu',21568.0,79.48,10.4).
city('Naduvattam','in','Tamil Nadu',11675.0,76.57,11.48).
city('Nagapattinam','in','Tamil Nadu',94247.0,79.84,10.8).
city('Nagercoil','in','Tamil Nadu',213877.0,77.43,8.18).
city('Namagiripettai','in','Tamil Nadu',22098.0,78.27,11.47).
city('Namakkal','in','Tamil Nadu',56002.0,78.17,11.23).
city('Nambiyur','in','Tamil Nadu',16126.0,77.33,11.37).
city('Nambutalai','in','Tamil Nadu',7914.0,79.0,9.72).
city('Nandivaram','in','Tamil Nadu',30975.0,80.06,12.84).
city('Nangavalli','in','Tamil Nadu',9902.0,77.88,11.75).
city('Nanguneri','in','Tamil Nadu',6969.0,77.67,8.48).
city('Nannilam','in','Tamil Nadu',10180.0,79.62,10.88).
city('Narasingapuram','in','Tamil Nadu',10875.0,79.33,13.62).
city('Naravarikuppam','in','Tamil Nadu',18556.0,80.18,13.18).
city('Nattam','in','Tamil Nadu',21888.0,78.23,10.23).
city('Nattarasankottai','in','Tamil Nadu',5921.0,78.57,9.87).
city('Nellikkuppam','in','Tamil Nadu',44427.0,79.68,11.77).
city('Nelliyalam','in','Tamil Nadu',43966.0,76.33,11.51).
city('Nerkunram','in','Tamil Nadu',47530.0,80.26,13.04).
city('Neyveli','in','Tamil Nadu',131213.0,79.48,11.62).
city('Nidamangalam','in','Tamil Nadu',9126.0,79.42,10.77).
city('Nilakkottai','in','Tamil Nadu',21685.0,77.87,10.17).
city('Odugathur','in','Tamil Nadu',8282.0,78.9,12.77).
city('Omalur','in','Tamil Nadu',12702.0,78.07,11.73).
city('Padmanabhapuram','in','Tamil Nadu',20214.0,77.33,8.23).
city('Palaimpatti','in','Tamil Nadu',26494.0,78.42,11.93).
city('Palakkodu','in','Tamil Nadu',19632.0,78.08,12.3).
city('Palamedu','in','Tamil Nadu',8435.0,78.12,10.12).
city('Palani','in','Tamil Nadu',66091.0,77.51,10.46).
city('Palladam','in','Tamil Nadu',31938.0,77.3,10.98).
city('Pallapatti','in','Tamil Nadu',20283.0,77.88,10.7).
city('Pallattur','in','Tamil Nadu',8187.0,78.8,10.15).
city('Pallavaram','in','Tamil Nadu',157158.0,80.16,12.99).
city('Pallikonda','in','Tamil Nadu',21337.0,78.93,12.92).
city('Pallipalaiyam','in','Tamil Nadu',34456.0,77.77,11.37).
city('Pallipattu','in','Tamil Nadu',8912.0,79.45,13.33).
city('Pammal','in','Tamil Nadu',55466.0,80.11,12.97).
city('Panapakkam','in','Tamil Nadu',10611.0,79.22,13.5).
city('Pannuratti','in','Tamil Nadu',56591.0,79.55,11.78).
city('Papanasam','in','Tamil Nadu',16839.0,79.28,10.93).
city('Papparapatti','in','Tamil Nadu',11617.0,78.07,12.22).
city('Paramakkudi','in','Tamil Nadu',85702.0,78.59,9.54).
city('Parangippettai','in','Tamil Nadu',19856.0,79.76,11.49).
city('Pattukkottai','in','Tamil Nadu',67988.0,79.31,10.43).
city('Pennadam','in','Tamil Nadu',17662.0,79.23,11.4).
city('Pennagaram','in','Tamil Nadu',15758.0,77.9,12.13).
city('Pennathur','in','Tamil Nadu',8257.0,79.23,12.25).
city('Peraiyur','in','Tamil Nadu',9245.0,77.8,9.72).
city('Perambalur','in','Tamil Nadu',30802.0,78.88,11.23).
city('Peranamallur','in','Tamil Nadu',5722.0,79.43,12.57).
city('Peravurani','in','Tamil Nadu',21663.0,79.18,10.3).
city('Periyakulam','in','Tamil Nadu',40134.0,77.53,10.12).
city('Periyanayakkanpalaiyam','in','Tamil Nadu',24896.0,76.93,11.15).
city('Periyanegamam','in','Tamil Nadu',7913.0,77.1,10.73).
city('Periyapatti','in','Tamil Nadu',10646.0,77.27,10.75).
city('Pernampattu','in','Tamil Nadu',43127.0,78.73,12.94).
city('Perundurai','in','Tamil Nadu',17488.0,77.58,11.27).
city('Perur','in','Tamil Nadu',8342.0,76.9,10.97).
city('Pollachi','in','Tamil Nadu',88221.0,77.0,10.67).
city('Polur','in','Tamil Nadu',26293.0,79.13,12.5).
city('Ponneri','in','Tamil Nadu',24758.0,80.2,13.32).
city('Pudukkottai','in','Tamil Nadu',112128.0,78.82,10.39).
city('Pudur','in','Tamil Nadu',9857.0,78.65,11.16).
city('Puliyankudi','in','Tamil Nadu',62499.0,77.4,9.18).
city('Puliyur','in','Tamil Nadu',11174.0,78.83,10.63).
city('Pullampadi','in','Tamil Nadu',102.0,78.92,10.97).
city('Punamalli','in','Tamil Nadu',48842.0,80.11,13.05).
city('Punjai Puliyampatti','in','Tamil Nadu',15068.0,77.2,11.35).
city('Rajapalaiyam','in','Tamil Nadu',124179.0,77.55,9.46).
city('Ramanathapuram','in','Tamil Nadu',65320.0,78.83,9.37).
city('Ramapuram','in','Tamil Nadu',31169.0,79.2,13.12).
city('Rameswaram','in','Tamil Nadu',39964.0,79.3,9.28).
city('Ranipettai','in','Tamil Nadu',48771.0,79.33,12.93).
city('Rasipuram','in','Tamil Nadu',48954.0,78.17,11.47).
city('Saint Thomas Mount','in','Tamil Nadu',43227.0,80.0,13.0).
city('Sankarankoil','in','Tamil Nadu',55137.0,77.54,9.17).
city('Sathyamangalam','in','Tamil Nadu',34014.0,77.25,11.52).
city('Sattankulam','in','Tamil Nadu',14085.0,77.93,8.45).
city('Sattur','in','Tamil Nadu',31859.0,77.93,9.37).
city('Sayalgudi','in','Tamil Nadu',12415.0,78.45,9.18).
city('Selam','in','Tamil Nadu',778462.0,78.16,11.67).
city('Shenkottai','in','Tamil Nadu',27012.0,77.27,8.97).
city('Sholavandan','in','Tamil Nadu',22318.0,77.97,10.02).
city('Sholingur','in','Tamil Nadu',28648.0,79.42,13.12).
city('Singanallur','in','Tamil Nadu',31239.0,77.0,11.02).
city('Singaperumalkoil','in','Tamil Nadu',8301.0,80.02,12.77).
city('Sirkali','in','Tamil Nadu',33102.0,79.73,11.23).
city('Sirumugai','in','Tamil Nadu',20066.0,77.02,11.33).
city('Sivaganga','in','Tamil Nadu',42789.0,78.48,9.87).
city('Sivagiri','in','Tamil Nadu',18776.0,77.62,10.23).
city('Sivakasi','in','Tamil Nadu',74289.0,77.79,9.46).
city('Srimushnam','in','Tamil Nadu',12364.0,79.42,11.4).
city('Sriperumbudur','in','Tamil Nadu',17255.0,79.97,12.97).
city('Srivaikuntam','in','Tamil Nadu',15666.0,77.93,8.62).
city('Srivilliputtur','in','Tamil Nadu',74377.0,77.63,9.52).
city('Suchindram','in','Tamil Nadu',12316.0,77.48,8.15).
city('Sulur','in','Tamil Nadu',26185.0,77.13,11.03).
city('Surampatti','in','Tamil Nadu',34880.0,77.66,11.23).
city('Surandai','in','Tamil Nadu',28989.0,77.4,8.97).
city('Swamimalai','in','Tamil Nadu',7197.0,79.33,10.95).
city('Tambaram','in','Tamil Nadu',150056.0,80.12,12.93).
city('Taramangalam','in','Tamil Nadu',23790.0,77.98,11.7).
city('Tattayyangarpettai','in','Tamil Nadu',12605.0,78.45,11.13).
city('Tenkasi','in','Tamil Nadu',65501.0,77.31,8.96).
city('Thanjavur','in','Tamil Nadu',219591.0,79.13,10.79).
city('Tharangambadi','in','Tamil Nadu',21479.0,79.85,11.03).
city('Theni Allinagaram','in','Tamil Nadu',96796.0,77.48,10.02).
city('Thirumangalam','in','Tamil Nadu',46873.0,77.98,9.83).
city('Thiruparankundram','in','Tamil Nadu',42700.0,78.07,9.87).
city('Thiruthangal','in','Tamil Nadu',54504.0,77.83,9.48).
city('Thiruthuraipundi','in','Tamil Nadu',22391.0,79.65,10.53).
city('Thiruvarur','in','Tamil Nadu',58782.0,79.64,10.78).
city('Thisayanvilai','in','Tamil Nadu',20397.0,77.88,8.33).
city('Thuthukkudi','in','Tamil Nadu',218548.0,78.14,8.81).
city('Tindivanam','in','Tamil Nadu',69845.0,79.65,12.24).
city('Tinnanur','in','Tamil Nadu',22125.0,80.03,13.12).
city('Tiruchchendur','in','Tamil Nadu',29874.0,78.12,8.49).
city('Tiruchchirappalli','in','Tamil Nadu',775551.0,78.69,10.81).
city('Tiruchengode','in','Tamil Nadu',87131.0,77.9,11.38).
city('Tirukkalukkundram','in','Tamil Nadu',23646.0,80.06,12.6).
city('Tirukkattuppalli','in','Tamil Nadu',12466.0,78.97,10.85).
city('Tirukkoyilur','in','Tamil Nadu',28340.0,79.2,11.95).
city('Tirumullaivasal','in','Tamil Nadu',13233.0,79.83,11.23).
city('Tirunelveli','in','Tamil Nadu',435882.0,77.69,8.73).
city('Tirupathur','in','Tamil Nadu',42849.0,78.6,11.32).
city('Tiruppur','in','Tamil Nadu',397554.0,77.35,11.09).
city('Tiruppuvanam','in','Tamil Nadu',22519.0,78.27,9.83).
city('Tiruttani','in','Tamil Nadu',39902.0,79.63,13.18).
city('Tiruvallur','in','Tamil Nadu',48099.0,79.92,13.15).
city('Tiruvannamalai','in','Tamil Nadu',138255.0,79.07,12.24).
city('Tiruverkadu','in','Tamil Nadu',34408.0,80.17,13.07).
city('Tiruvethipuram','in','Tamil Nadu',36530.0,79.55,12.67).
city('Tiruvidaimarudur','in','Tamil Nadu',14184.0,79.47,10.98).
city('Tiruvottiyur','in','Tamil Nadu',229019.0,80.29,13.16).
city('Tondi','in','Tamil Nadu',16469.0,79.02,9.73).
city('Turaiyur','in','Tamil Nadu',32137.0,78.62,11.17).
city('Udagamandalam','in','Tamil Nadu',98247.0,76.69,11.42).
city('Udagamandalam Valley','in','Tamil Nadu',25455.0,76.4,11.64).
city('Udankudi','in','Tamil Nadu',19010.0,78.02,8.43).
city('Udumalaipettai','in','Tamil Nadu',58576.0,77.24,10.58).
city('Ulundurpettai','in','Tamil Nadu',19835.0,79.28,11.7).
city('Uppiliapuram','in','Tamil Nadu',6900.0,78.52,11.27).
city('Usilampatti','in','Tamil Nadu',30677.0,77.8,9.97).
city('Uttamapalaiyam','in','Tamil Nadu',22780.0,77.33,9.8).
city('Uttiramerur','in','Tamil Nadu',24318.0,79.77,12.6).
city('Uttukkuli','in','Tamil Nadu',7514.0,77.43,11.17).
city('Vadakku Valliyur','in','Tamil Nadu',24749.0,77.65,8.38).
city('Vadamadurai','in','Tamil Nadu',15886.0,78.08,10.47).
city('Valasaravakkam','in','Tamil Nadu',33894.0,79.93,13.11).
city('Valavanur','in','Tamil Nadu',14463.0,79.58,11.92).
city('Vallam','in','Tamil Nadu',14935.0,79.08,10.72).
city('Valparai','in','Tamil Nadu',90361.0,76.99,10.38).
city('Vandalur','in','Tamil Nadu',13715.0,80.08,12.9).
city('Vandavasi','in','Tamil Nadu',31533.0,79.62,12.5).
city('Vaniyambadi','in','Tamil Nadu',90295.0,78.6,12.69).
city('Vasudevanallur','in','Tamil Nadu',19021.0,77.42,9.23).
city('Vattalkundu','in','Tamil Nadu',22640.0,77.77,10.17).
city('Vedaranniyam','in','Tami',32248.0,79.85,10.37).
city('Vedasandur','in','Tamil Nadu',12494.0,77.95,10.53).
city('Velluru','in','Tamil Nadu',177096.0,79.13,12.92).
city('Velur','in','Tamil Nadu',18951.0,78.02,11.1).
city('Vettavalam','in','Tamil Nadu',13808.0,79.25,12.1).
city('Vijayapuri','in','Tamil Nadu',6651.0,77.5,11.23).
city('Vikramasingapuram','in','Tamil Nadu',47150.0,77.38,8.72).
city('Vikravandi','in','Tamil Nadu',10449.0,79.55,12.03).
city('Viluppuram','in','Tamil Nadu',97388.0,79.49,11.95).
city('Viraganur','in','Tamil Nadu',10854.0,78.73,11.48).
city('Virapandi','in','Tamil Nadu',20939.0,77.45,9.96).
city('Virappanchatram','in','Tamil Nadu',76663.0,77.7,11.4).
city('Viravanallur','in','Tamil Nadu',19691.0,77.53,8.7).
city('Virudhachalam','in','Tamil Nadu',61503.0,79.32,11.51).
city('Virudunagar','in','Tamil Nadu',73280.0,77.95,9.59).
city('Walajabad','in','Tamil Nadu',10544.0,79.78,12.77).
city('Walajapet','in','Tamil Nadu',30259.0,79.38,12.93).
city('Wellington','in','Tamil Nadu',20256.0,76.8,11.37).
city('Agartala','in','Tripura',203292.0,91.27,23.0).
city('Amarpur','in','Tripura',11908.0,91.65,23.52).
city('Belonia','in','Tripura',16737.0,91.45,23.25).
city('Dharmanagar','in','Tripura',32917.0,92.17,24.38).
city('Indranagar','in','Tripura',18001.0,91.37,23.62).
city('Kailasahar','in','Tripura',22124.0,92.02,24.33).
city('Kamalpur','in','Tripura',5509.0,91.83,24.2).
city('Khowai','in','Tripura',20049.0,91.63,24.1).
city('Ranir Bazar','in','Tripura',11811.0,91.37,23.83).
city('Sabrum','in','Tripura',6206.0,91.73,23.0).
city('Sonamura','in','Tripura',10823.0,91.28,23.48).
city('Teliamura','in','Tripura',18583.0,91.61,23.85).
city('Udaipur','in','Tripura',23293.0,91.48,23.53).
city('Achhnera','in','Uttar Pradesh',20534.0,77.77,27.18).
city('Afzalgarh','in','Uttar Pradesh',27756.0,78.68,29.4).
city('Agra','in','Uttar Pradesh',1430194.0,78.01,27.19).
city('Agra Cantonment','in','Uttar Pradesh',58679.0,78.01,27.17).
city('Ahraura','in','Uttar Pradesh',25078.0,83.02,25.02).
city('Akbarpur','in','Uttar Pradesh',27853.0,81.25,26.4).
city('Alapur','in','Uttar Pradesh',22622.0,79.22,27.95).
city('Aliganj','in','Uttar Pradesh',26655.0,79.18,27.5).
city('Aligarh','in','Uttar Pradesh',753280.0,78.06,27.89).
city('Allahabad','in','Uttar Pradesh',1073544.0,81.84,25.45).
city('Allahabad Cantonment','in','Uttar Pradesh',25223.0,81.81,25.45).
city('Allahganj','in','Uttar Pradesh',13825.0,79.68,27.55).
city('Amanpur','in','Uttar Pradesh',10363.0,78.75,27.72).
city('Ambahta','in','Uttar Pradesh',14304.0,77.33,29.85).
city('Amethi','in','Uttar Pradesh',12946.0,81.44,27.08).
city('Amroha','in','Uttar Pradesh',176271.0,78.46,28.91).
city('Anandnagar','in','Uttar Pradesh',11221.0,83.28,27.1).
city('Antu','in','Uttar Pradesh',8317.0,81.92,26.05).
city('Anupshahr','in','Uttar Pradesh',25308.0,78.27,28.37).
city('Aonla','in','Uttar Pradesh',50016.0,79.15,28.28).
city('Atarra','in','Uttar Pradesh',46173.0,80.57,25.28).
city('Atrauli','in','Uttar Pradesh',47516.0,78.28,28.03).
city('Atraulia','in','Uttar Pradesh',11849.0,82.95,26.33).
city('Auraiya','in','Uttar Pradesh',70515.0,79.5,26.47).
city('Aurangabad','in','Uttar Pradesh',22108.0,77.33,28.03).
city('Auras','in','Uttar Pradesh',6592.0,80.52,26.92).
city('Ayodhya','in','Uttar Pradesh',53298.0,82.2,26.8).
city('Azamgarh','in','Uttar Pradesh',116655.0,83.18,26.07).
city('Babarpur Ajitmal','in','Uttar Pradesh',27317.0,79.23,26.8).
city('Baberu','in','Uttar Pradesh',15608.0,80.72,25.55).
city('Babina','in','Uttar Pradesh',35542.0,78.47,25.25).
city('Babrala','in','Uttar Pradesh',16671.0,78.4,28.27).
city('Babugarh','in','Uttar Pradesh',7156.0,77.85,28.72).
city('Bachhraon','in','Uttar Pradesh',29235.0,78.22,28.93).
city('Baghpat','in','Uttar Pradesh',41770.0,77.22,28.95).
city('Bah','in','Uttar Pradesh',15360.0,78.6,26.88).
city('Baheri','in','Uttar Pradesh',63959.0,79.5,28.78).
city('Bahjoi','in','Uttar Pradesh',33756.0,78.62,28.4).
city('Bahraich','in','Uttar Pradesh',182236.0,81.59,27.58).
city('Bahsuma','in','Uttar Pradesh',11158.0,77.97,29.22).
city('Bahua','in','Uttar Pradesh',10244.0,80.63,25.85).
city('Bajna','in','Uttar Pradesh',7674.0,77.68,27.9).
city('Bakewar','in','Uttar Pradesh',14219.0,79.18,26.67).
city('Baldeo','in','Uttar Pradesh',10537.0,77.82,27.42).
city('Ballia','in','Uttar Pradesh',109722.0,84.15,25.76).
city('Balrampur','in','Uttar Pradesh',77404.0,82.18,27.43).
city('Banat','in','Uttar Pradesh',21582.0,77.35,29.47).
city('Banda','in','Uttar Pradesh',152233.0,80.33,25.47).
city('Bangarmau','in','Uttar Pradesh',37429.0,80.22,26.9).
city('Bansdih','in','Uttar Pradesh',21459.0,84.22,25.88).
city('Bansgaon','in','Uttar Pradesh',14284.0,83.35,26.55).
city('Bansi','in','Uttar Pradesh',39930.0,82.93,27.18).
city('Barabanki','in','Uttar Pradesh',19831.0,81.2,26.92).
city('Baragaon','in','Uttar Pradesh',10009.0,80.77,25.46).
city('Baraut','in','Uttar Pradesh',93553.0,77.26,29.1).
city('Bareli','in','Uttar Pradesh',745509.0,79.41,28.36).
city('Bareli Cantonment','in','Uttar Pradesh',28377.0,79.4,28.33).
city('Barhani','in','Uttar Pradesh',13339.0,82.78,27.48).
city('Barhapur','in','Uttar Pradesh',22004.0,78.53,29.53).
city('Barkhera','in','Uttar Pradesh',11210.0,79.8,28.45).
city('Barsana','in','Uttar Pradesh',9816.0,77.38,27.65).
city('Barva Sagar','in','Uttar Pradesh',23394.0,78.71,25.38).
city('Basti','in','Uttar Pradesh',115126.0,82.74,26.8).
city('Behat','in','Uttar Pradesh',18225.0,77.62,30.17).
city('Bela','in','Uttar Pradesh',74000.0,81.99,25.92).
city('Beniganj','in','Uttar Pradesh',10419.0,80.45,27.28).
city('Beswan','in','Uttar Pradesh',5897.0,77.88,27.65).
city('Bewar','in','Uttar Pradesh',23283.0,79.3,27.22).
city('Bhadohi','in','Uttar Pradesh',78576.0,82.56,25.4).
city('Bhagwantnagar','in','Uttar Pradesh',6597.0,80.75,26.23).
city('Bharthana','in','Uttar Pradesh',41059.0,79.23,26.75).
city('Bharwari','in','Uttar Pradesh',16413.0,81.5,25.55).
city('Bhinga','in','Uttar Pradesh',22018.0,81.93,27.72).
city('Bhongaon','in','Uttar Pradesh',29914.0,79.18,27.25).
city('Bidhuna','in','Uttar Pradesh',27161.0,79.52,26.82).
city('Bighapur','in','Uttar Pradesh',6409.0,80.68,26.35).
city('Bijnor','in','Uttar Pradesh',84601.0,78.13,29.38).
city('Bikapur','in','Uttar Pradesh',13179.0,82.13,26.6).
city('Bilari','in','Uttar Pradesh',29669.0,78.8,28.63).
city('Bilaspur','in','Uttar Pradesh',23957.0,78.44,28.64).
city('Bilgram','in','Uttar Pradesh',27176.0,80.03,27.18).
city('Bilhaur','in','Uttar Pradesh',19335.0,80.08,26.85).
city('Bilsanda','in','Uttar Pradesh',15540.0,79.95,28.25).
city('Bilsi','in','Uttar Pradesh',26323.0,78.92,28.13).
city('Bindki','in','Uttar Pradesh',36062.0,80.6,26.03).
city('Bisalpur','in','Uttar Pradesh',68362.0,79.8,28.3).
city('Bisauli','in','Uttar Pradesh',32158.0,78.93,28.32).
city('Biswan','in','Uttar Pradesh',52522.0,81.0,27.5).
city('Bithur','in','Uttar Pradesh',10603.0,80.28,26.63).
city('Budaun','in','Uttar Pradesh',16157.0,79.12,28.04).
city('Bulandshahr','in','Uttar Pradesh',198631.0,77.85,28.41).
city('Burhana','in','Uttar Pradesh',35445.0,77.47,29.28).
city('Chail','in','Uttar Pradesh',8408.0,81.63,25.43).
city('Chakia','in','Uttar Pradesh',15000.0,83.22,25.05).
city('Chandauli','in','Uttar Pradesh',25038.0,83.27,25.27).
city('Chandausi','in','Uttar Pradesh',112646.0,78.78,28.46).
city('Chandpur','in','Uttar Pradesh',73562.0,78.27,29.14).
city('Charkhari','in','Uttar Pradesh',24883.0,79.75,25.4).
city('Charthawal','in','Uttar Pradesh',19944.0,77.58,29.55).
city('Chhaprauli','in','Uttar Pradesh',19224.0,77.18,29.22).
city('Chhara Rafatpur','in','Uttar Pradesh',24538.0,78.41,27.94).
city('Chharprauli','in','Uttar Pradesh',21755.0,77.19,29.23).
city('Chhata','in','Uttar Pradesh',21262.0,77.5,27.72).
city('Chhibramau','in','Uttar Pradesh',57076.0,79.52,27.15).
city('Chirgaon','in','Uttar Pradesh',14149.0,78.82,25.58).
city('Chit Baragaon','in','Uttar Pradesh',21659.0,84.02,25.75).
city('Chitrakut Dham','in','Uttar Pradesh',53750.0,80.84,25.2).
city('Chopan','in','Uttar Pradesh',13587.0,83.03,24.52).
city('Chunar','in','Uttar Pradesh',36462.0,82.9,25.13).
city('Colonelganj','in','Uttar Pradesh',25506.0,81.7,27.13).
city('Dadri','in','Uttar Pradesh',70616.0,77.55,28.57).
city('Dalmau','in','Uttar Pradesh',11433.0,81.03,26.07).
city('Dankaur','in','Uttar Pradesh',13021.0,77.55,28.35).
city('Dasna','in','Uttar Pradesh',27928.0,77.53,28.68).
city('Dataganj','in','Uttar Pradesh',24564.0,79.4,28.03).
city('Daurala','in','Uttar Pradesh',10917.0,77.68,29.12).
city('Dayal Bagh','in','Uttar Pradesh',3369.0,78.02,27.22).
city('Deoband','in','Uttar Pradesh',88180.0,77.67,29.7).
city('Deoranian','in','Uttar Pradesh',19790.0,79.48,28.63).
city('Deoria','in','Uttar Pradesh',113638.0,83.78,26.51).
city('Dewa','in','Uttar Pradesh',14377.0,81.17,27.03).
city('Dhampur','in','Uttar Pradesh',49978.0,78.52,29.32).
city('Dhanaura','in','Uttar Pradesh',28288.0,78.25,28.97).
city('Dhaurhra','in','Uttar Pradesh',20100.0,81.07,28.0).
city('Dibai','in','Uttar Pradesh',37877.0,78.25,28.22).
city('Dibiyapur','in','Uttar Pradesh',23947.0,79.69,26.59).
city('Dohrighat','in','Uttar Pradesh',11182.0,83.52,26.27).
city('Dostpur','in','Uttar Pradesh',12689.0,82.47,26.28).
city('Dudhinagar','in','Uttar Pradesh',12743.0,83.25,24.22).
city('Dundwaraganj','in','Uttar Pradesh',46319.0,78.95,27.73).
city('Etah','in','Uttar Pradesh',120020.0,78.64,27.57).
city('Etawah','in','Uttar Pradesh',257472.0,79.01,26.78).
city('Faizabad','in','Uttar Pradesh',153062.0,82.14,26.78).
city('Farah','in','Uttar Pradesh',9236.0,77.77,27.33).
city('Faridnagar','in','Uttar Pradesh',11372.0,77.62,28.77).
city('Faridpur','in','Uttar Pradesh',71790.0,79.53,28.22).
city('Fariha','in','Uttar Pradesh',6380.0,78.48,27.32).
city('Farrukhabad','in','Uttar Pradesh',241176.0,79.57,27.4).
city('Fatehabad','in','Uttar Pradesh',21959.0,78.32,27.02).
city('Fatehganj Pashchimi','in','Uttar Pradesh',23812.0,79.3,28.47).
city('Fatehgarh','in','Uttar Pradesh',14849.0,79.63,27.37).
city('Fatehpur','in','Uttar Pradesh',100255.0,81.02,26.55).
city('Fatehpur Chaurasi','in','Uttar Pradesh',5932.0,80.27,26.78).
city('Fatehpur Sikri','in','Uttar Pradesh',30029.0,77.67,27.1).
city('Firozabad','in','Uttar Pradesh',306439.0,78.39,27.15).
city('Gajraula','in','Uttar Pradesh',50385.0,78.23,28.85).
city('Ganga Ghat','in','Uttar Pradesh',80308.0,80.45,26.52).
city('Gangoh','in','Uttar Pradesh',59525.0,77.25,29.77).
city('Ganj Muradabad','in','Uttar Pradesh',9971.0,80.18,26.97).
city('Garautha','in','Uttar Pradesh',9490.0,79.3,25.57).
city('Garhmukteshwar','in','Uttar Pradesh',37047.0,78.1,28.8).
city('Gaura Barahaj','in','Uttar Pradesh',37492.0,83.72,26.28).
city('Gawan','in','Uttar Pradesh',8745.0,78.35,28.43).
city('Ghatampur','in','Uttar Pradesh',40439.0,80.17,26.17).
city('Ghaziabad','in','Uttar Pradesh',1199306.0,77.41,28.66).
city('Ghazipur','in','Uttar Pradesh',103105.0,83.59,25.59).
city('Ghiror','in','Uttar Pradesh',14012.0,78.8,27.18).
city('Ghorawal','in','Uttar Pradesh',7493.0,82.78,24.77).
city('Ghosi','in','Uttar Pradesh',39142.0,83.55,26.12).
city('Gohand','in','Uttar Pradesh',7287.0,79.55,25.7).
city('Gokul','in','Uttar Pradesh',4351.0,77.72,27.45).
city('Gola Bazar','in','Uttar Pradesh',10937.0,83.37,26.35).
city('Gola Gokarannath','in','Uttar Pradesh',58992.0,80.47,28.08).
city('Gonda','in','Uttar Pradesh',133596.0,81.95,27.14).
city('Gopamau','in','Uttar Pradesh',13582.0,80.28,27.55).
city('Gorakhpur','in','Uttar Pradesh',674312.0,83.36,26.76).
city('Gosainganj','in','Uttar Pradesh',11358.0,81.75,26.67).
city('Govardhan','in','Uttar Pradesh',20046.0,77.47,27.5).
city('Gulaothi','in','Uttar Pradesh',46652.0,77.78,28.6).
city('Gunnaur','in','Uttar Pradesh',20982.0,78.43,28.25).
city('Gursahaiganj','in','Uttar Pradesh',40217.0,79.72,27.12).
city('Gursarai','in','Uttar Pradesh',25193.0,79.18,25.62).
city('Gyanpur','in','Uttar Pradesh',13468.0,82.47,25.35).
city('Haldaur','in','Uttar Pradesh',18688.0,78.28,29.3).
city('Hamirpur','in','Uttar Pradesh',34148.0,80.15,25.95).
city('Handia','in','Uttar Pradesh',17862.0,82.18,25.38).
city('Hapur','in','Uttar Pradesh',242944.0,77.77,28.73).
city('Hardoi','in','Uttar Pradesh',122647.0,80.12,27.42).
city('Harduaganj','in','Uttar Pradesh',12329.0,78.17,27.95).
city('Hasanpur','in','Uttar Pradesh',57487.0,78.28,28.72).
city('Hastinapur','in','Uttar Pradesh',24095.0,78.02,29.17).
city('Hata','in','Uttar Pradesh',12051.0,83.75,26.75).
city('Hathras','in','Uttar Pradesh',126895.0,78.04,27.6).
city('Iglas','in','Uttar Pradesh',13748.0,77.93,27.72).
city('Ikauna','in','Uttar Pradesh',14218.0,81.97,27.55).
city('Islamnagar','in','Uttar Pradesh',29147.0,78.72,28.33).
city('Itaunja','in','Uttar Pradesh',6727.0,80.92,27.08).
city('Itimadpur','in','Uttar Pradesh',22700.0,78.2,27.24).
city('Jahanabad','in','Uttar Pradesh',13619.0,79.72,28.63).
city('Jahangirabad','in','Uttar Pradesh',57369.0,78.1,28.42).
city('Jahangirpur','in','Utt',10043.0,77.72,28.18).
city('Jais','in','Uttar Pradesh',25729.0,81.53,26.25).
city('Jalalabad','in','Uttar Pradesh',30180.0,78.55,28.67).
city('Jalali','in','Uttar Pradesh',18179.0,78.27,27.87).
city('Jalalpur','in','Uttar Pradesh',31391.0,82.73,26.32).
city('Jalaun','in','Uttar Pradesh',55304.0,79.35,26.15).
city('Jalesar','in','Uttar Pradesh',38618.0,78.32,27.48).
city('Jansath','in','Uttar Pradesh',19469.0,77.85,29.33).
city('Jarwal','in','Uttar Pradesh',17577.0,81.55,27.17).
city('Jasrana','in','Uttar Pradesh',9884.0,78.68,27.25).
city('Jaswantnagar','in','Uttar Pradesh',27780.0,78.92,26.88).
city('Jaunpur','in','Uttar Pradesh',169589.0,82.69,25.76).
city('Jewar','in','Uttar Pradesh',29319.0,77.55,28.13).
city('Jhalu','in','Uttar Pradesh',20358.0,78.25,29.35).
city('Jhansi','in','Uttar Pradesh',412968.0,78.56,25.45).
city('Jhinjhak','in','Uttar Pradesh',23501.0,79.73,26.57).
city('Jhinjhana','in','Uttar Pradesh',19713.0,77.22,29.52).
city('Jhusi','in','Uttar Pradesh',16644.0,81.93,25.43).
city('Kabrai','in','Uttar Pradesh',24774.0,80.02,25.42).
city('Kachhwa','in','Uttar Pradesh',15383.0,82.72,25.22).
city('Kadaura','in','Uttar Pradesh',13785.0,79.85,25.98).
city('Kadipur','in','Uttar Pradesh',7473.0,82.38,26.17).
city('Kaimganj','in','Uttar Pradesh',32861.0,79.35,27.57).
city('Kairana','in','Uttar Pradesh',80440.0,77.2,29.4).
city('Kakori','in','Uttar Pradesh',18334.0,80.8,26.88).
city('Kakrala','in','Uttar Pradesh',35694.0,79.2,27.9).
city('Kalinagar','in','Uttar Pradesh',10729.0,80.1,28.62).
city('Kalpi','in','Uttar Pradesh',44343.0,79.73,26.12).
city('Kamalganj','in','Uttar Pradesh',16223.0,79.65,27.27).
city('Kampil','in','Uttar Pradesh',9201.0,79.28,27.62).
city('Kandhla','in','Uttar Pradesh',43391.0,77.27,29.32).
city('Kannauj','in','Uttar Pradesh',76721.0,79.91,27.06).
city('Kanpur','in','Uttar Pradesh',2823523.0,80.33,26.47).
city('Kanpur Cantonment','in','Uttar Pradesh',94480.0,80.28,26.5).
city('Kant','in','Uttar Pradesh',24432.0,79.8,27.8).
city('Kanth','in','Uttar Pradesh',24886.0,78.63,29.07).
city('Kaptanganj','in','Uttar Pradesh',12300.0,83.72,26.92).
city('Karari','in','Uttar Pradesh',14404.0,81.43,25.45).
city('Karhal','in','Uttar Pradesh',26696.0,78.95,27.02).
city('Kasganj','in','Uttar Pradesh',99472.0,78.63,27.81).
city('Katra','in','Uttar Pradesh',18241.0,80.84,27.78).
city('Kemri','in','Uttar Pradesh',26729.0,79.22,28.82).
city('Khaga','in','Uttar Pradesh',13339.0,81.12,25.78).
city('Khailar','in','Uttar Pradesh',13334.0,78.53,25.35).
city('Khair','in','Uttar Pradesh',30176.0,77.83,27.95).
city('Khairabad','in','Uttar Pradesh',42129.0,80.75,27.53).
city('Khairagarh','in','Uttar Pradesh',20097.0,77.82,26.95).
city('Khalilabad','in','Uttar Pradesh',45325.0,83.08,26.78).
city('Khanpur','in','Uttar Pradesh',14689.0,78.05,28.53).
city('Kharela','in','Uttar Pradesh',13800.0,79.82,25.55).
city('Khargupur','in','Uttar Pradesh',9577.0,81.98,27.38).
city('Khatauli','in','Uttar Pradesh',64737.0,77.72,29.28).
city('Khekra','in','Uttar Pradesh',42412.0,77.28,28.87).
city('Kheri','in','Uttar Pradesh',26330.0,80.8,27.9).
city('Khudaganj','in','Uttar Pradesh',12638.0,79.72,28.15).
city('Khurja','in','Uttar Pradesh',105920.0,77.85,28.26).
city('Khutar','in','Uttar Pradesh',15620.0,80.28,28.2).
city('Kiraoli','in','Uttar Pradesh',21026.0,77.78,27.15).
city('Kiratpur','in','Uttar Pradesh',60229.0,78.2,29.52).
city('Kishanpur','in','Uttar Pradesh',6105.0,81.02,25.65).
city('Kishni','in','Uttar Pradesh',9853.0,79.27,27.02).
city('Konch','in','Uttar Pradesh',52778.0,79.15,25.98).
city('Kopaganj','in','Uttar Pradesh',33543.0,83.57,26.02).
city('Kosi Kalan','in','Uttar Pradesh',52498.0,77.44,27.8).
city('Kota','in','Uttar Pradesh',14632.0,83.13,24.45).
city('Kotra','in','Uttar Pradesh',8535.0,79.32,25.82).
city('Kulpahar','in','Uttar Pradesh',18978.0,79.65,25.32).
city('Kunda','in','Uttar Pradesh',24951.0,81.52,25.72).
city('Kundarki','in','Uttar Pradesh',27200.0,78.78,28.7).
city('Kurara','in','Uttar Pradesh',12731.0,79.98,25.98).
city('Kurawali','in','Uttar Pradesh',22603.0,78.97,27.39).
city('Laharpur','in','Uttar Pradesh',55917.0,80.9,27.72).
city('Lakhimpur','in','Uttar Pradesh',140237.0,80.78,27.95).
city('Lakhna','in','Uttar Pradesh',11390.0,79.15,26.65).
city('Lakhnau','in','Uttar Pradesh',2472250.0,80.92,26.85).
city('Lakhnau Cantonment','in','Uttar Pradesh',63443.0,80.97,26.81).
city('Lalganj','in','Uttar Pradesh',23730.0,81.7,25.93).
city('Lalitpur','in','Uttar Pradesh',126487.0,78.41,24.7).
city('Lar','in','Uttar Pradesh',26691.0,83.97,26.22).
city('Lawar','in','Uttar Pradesh',19558.0,77.77,29.12).
city('Loni','in','Uttar Pradesh',164927.0,77.28,28.75).
city('Machhlishahr','in','Uttar Pradesh',25250.0,82.42,25.68).
city('Madhoganj','in','Uttar Pradesh',10300.0,80.15,27.12).
city('Madhogarh','in','Uttar Pradesh',10531.0,79.18,26.28).
city('Maghar','in','Uttar Pradesh',17013.0,83.13,26.75).
city('Mahaban','in','Uttar Pradesh',9515.0,77.75,27.43).
city('Maharajganj','in','Uttar Pradesh',14831.0,82.66,26.59).
city('Mahmudabad','in','Uttar Pradesh',45925.0,81.12,27.3).
city('Mahoba','in','Uttar Pradesh',89179.0,79.87,25.3).
city('Maholi','in','Uttar Pradesh',19345.0,80.47,27.67).
city('Mahroni','in','Uttar Pradesh',8899.0,78.72,24.58).
city('Mailani','in','Uttar Pradesh',14213.0,80.35,28.28).
city('Mainpuri','in','Uttar Pradesh',94629.0,79.02,27.24).
city('Malihabad','in','Uttar Pradesh',16651.0,80.72,26.92).
city('Mallanwam','in','Uttar Pradesh',33731.0,80.15,27.05).
city('Mandawar','in','Uttar Pradesh',21341.0,78.13,29.5).
city('Manikpur','in','Uttar Pradesh',14417.0,81.12,25.07).
city('Manikpur Sarhat','in','Uttar Pradesh',16304.0,81.09,25.06).
city('Maniyar','in','Uttar Pradesh',20464.0,84.17,25.98).
city('Manjhanpur','in','Uttar Pradesh',16940.0,81.38,25.53).
city('Mankapur','in','Uttar Pradesh',9747.0,82.23,27.03).
city('Mariahu','in','Uttar Pradesh',22251.0,82.62,25.62).
city('Mataundh','in','Uttar Pradesh',8592.0,80.15,25.45).
city('Mathura','in','Uttar Pradesh',330543.0,77.68,27.5).
city('Mau','in','Uttar Pradesh',246074.0,83.56,25.96).
city('Mau Aima','in','Uttar Pradesh',20125.0,81.92,25.7).
city('Maudaha','in','Uttar Pradesh',37848.0,80.12,25.68).
city('Mauranipur','in','Uttar Pradesh',53734.0,79.13,25.24).
city('Maurawan','in','Uttar Pradesh',14918.0,80.88,26.43).
city('Mawana','in','Uttar Pradesh',76981.0,77.91,29.11).
city('Mehnagar','in','Uttar Pradesh',14898.0,83.12,25.0).
city('Mehndawal','in','Uttar Pradesh',25498.0,83.12,26.98).
city('Milak','in','Uttar Pradesh',28508.0,79.18,28.62).
city('Miranpur','in','Uttar Pradesh',27392.0,77.93,29.3).
city('Mirat','in','Uttar Pradesh',1223303.0,77.7,28.99).
city('Mirat Cantonment','in','Uttar Pradesh',91925.0,77.67,29.02).
city('Mirganj','in','Uttar Pradesh',15336.0,79.2,28.55).
city('Mirzapur','in','Uttar Pradesh',220051.0,82.56,25.16).
city('Misrikh','in','Uttar Pradesh',15014.0,80.52,27.45).
city('Modinagar','in','Uttar Pradesh',117169.0,77.62,28.92).
city('Mohan','in','Uttar Pradesh',14710.0,80.68,26.78).
city('Moradabad','in','Uttar Pradesh',721210.0,78.76,28.84).
city('Moth','in','Uttar Pradesh',14078.0,78.95,25.72).
city('Mubarakpur','in','Uttar Pradesh',53268.0,83.28,26.09).
city('Mughal Sarai','in','Uttar Pradesh',98053.0,83.12,25.3).
city('Mughal Sarai Railway Settlement','in','Uttar Pradesh',28955.0,83.17,25.3).
city('Muhammadabad','in','Uttar Pradesh',26496.0,82.19,26.33).
city('Muhammadi','in','Uttar Pradesh',43911.0,80.22,27.95).
city('Muradnagar','in','Uttar Pradesh',89491.0,77.5,28.78).
city('Mur','in','Uttar Pradesh',12311.0,77.93,27.58).
city('Musafirkhana','in','Uttar Pradesh',8082.0,81.8,26.37).
city('Muzaffarnagar','in','Uttar Pradesh',349741.0,77.69,29.48).
city('Nadigaon','in','Uttar Pradesh',7598.0,79.03,26.12).
city('Nagina','in','Uttar Pradesh',76601.0,78.43,29.45).
city('Nagram','in','Uttar Pradesh',9859.0,81.13,26.62).
city('Najibabad','in','Uttar Pradesh',84014.0,78.33,29.62).
city('Nakur','in','Uttar Pradesh',23086.0,77.3,29.92).
city('Nandgaon','in','Uttar Pradesh',10450.0,77.38,27.72).
city('Nanpara','in','Uttar Pradesh',46285.0,81.5,27.87).
city('Naraini','in','Uttar Pradesh',15078.0,80.48,25.18).
city('Narauli','in','Uttar Pradesh',17947.0,78.72,28.5).
city('Naraura','in','Uttar Pradesh',22434.0,78.38,28.2).
city('Nautanwa','in','Uttar Pradesh',32590.0,83.42,27.43).
city('Nawabganj','in','Uttar Pradesh',35291.0,81.04,27.32).
city('Nichlaul','in','Uttar Pradesh',17569.0,83.73,27.32).
city('Nihtaur','in','Uttar Pradesh',48394.0,78.38,29.33).
city('Niwari','in','Uttar Pradesh',10331.0,77.53,28.88).
city('Nizamabad','in','Uttar Pradesh',13897.0,83.05,26.05).
city('Noida','in','Uttar Pradesh',380346.0,77.33,28.58).
city('Nurpur','in','Uttar Pradesh',39081.0,78.42,29.15).
city('Nyoria Husenpur','in','Uttar Pradesh',21144.0,79.89,28.74).
city('Obra','in','Uttar Pradesh',56116.0,82.98,24.42).
city('Orai','in','Uttar Pradesh',158280.0,79.45,25.99).
city('Oran','in','Uttar Pradesh',6496.0,80.75,25.38).
city('Pachperwa','in','Uttar Pradesh',15057.0,82.65,27.52).
city('Padrauna','in','Uttar Pradesh',47186.0,83.98,26.92).
city('Pahasu','in','Uttar Pradesh',18856.0,78.0,28.18).
city('Pali','in','Uttar Pradesh',9099.0,78.42,24.48).
city('Palia Kalan','in','Uttar Pradesh',38551.0,80.58,28.45).
city('Parichha','in','Uttar Pradesh',7399.0,78.75,25.52).
city('Parichhatgarh','in','Uttar Pradesh',18992.0,77.93,28.98).
city('Patti','in','Uttar Pradesh',9686.0,82.2,25.92).
city('Pawayan','in','Uttar Pradesh',25710.0,80.1,28.07).
city('Phalauda','in','Uttar Pradesh',18547.0,77.82,29.18).
city('Phaphund','in','Uttar Pradesh',16677.0,79.47,26.6).
city('Phulpur','in','Uttar Pradesh',15891.0,82.49,25.82).
city('Pihani','in','Uttar Pradesh',30372.0,80.2,27.63).
city('Pilibhit','in','Uttar Pradesh',131021.0,79.81,28.64).
city('Pilkhuwa','in','Uttar Pradesh',74219.0,77.65,28.72).
city('Pinahat','in','Uttar Pradesh',19513.0,78.38,26.88).
city('Pipraich','in','Uttar Pradesh',15858.0,83.53,26.85).
city('Pipri','in','Uttar Pradesh',13584.0,82.83,24.2).
city('Pratapgarh','in','Uttar Pradesh',13673.0,81.95,25.9).
city('Pukhrayan','in','Uttar Pradesh',22557.0,79.85,26.23).
city('Puranpur','in','Uttar Pradesh',39992.0,80.15,28.52).
city('Purwa','in','Uttar Pradesh',22223.0,80.78,26.47).
city('Rabupura','in','Uttar Pradesh',13950.0,77.6,28.25).
city('Radha Kund','in','Uttar Pradesh',6421.0,77.48,27.53).
city('Rae Bareli','in','Uttar Pradesh',186451.0,81.23,26.23).
city('Rajapur','in','Uttar Pradesh',13963.0,81.15,25.38).
city('Ramkola','in','Uttar Pradesh',13950.0,83.85,26.92).
city('Ramnagar','in','Uttar Pradesh',28886.0,82.23,26.18).
city('Rampur','in','Uttar Pradesh',296447.0,79.02,28.82).
city('Rampur Maniharan','in','Uttar Pradesh',26260.0,77.45,29.82).
city('Rampura','in','Uttar Pradesh',11348.0,79.18,26.35).
city('Ranipur','in','Uttar Pradesh',18822.0,79.07,25.25).
city('Rasra','in','Uttar Pradesh',31879.0,83.85,25.85).
city('Rasulabad','in','Uttar Pradesh',7801.0,80.48,26.75).
city('Rath','in','Uttar Pradesh',61734.0,79.57,25.58).
city('Raya','in','Uttar Pradesh',20010.0,77.78,27.57).
city('Renukut','in','Uttar Pradesh',62419.0,83.03,24.2).
city('Reoti','in','Uttar Pradesh',23821.0,84.38,25.85).
city('Richha','in','Uttar Pradesh',19461.0,79.52,28.7).
city('Rithora','in','Uttar Pradesh',16068.0,79.52,28.47).
city('Robertsganj','in','Uttar Pradesh',37858.0,83.07,24.7).
city('Rudarpur','in','Uttar Pradesh',30876.0,83.62,26.45).
city('Rudauli','in','Uttar Pradesh',39491.0,82.8,27.03).
city('Rura','in','Uttar Pradesh',15909.0,79.9,26.48).
city('Sadabad','in','Uttar Pradesh',36097.0,78.05,27.45).
city('Sadat','in','Uttar Pradesh',11212.0,83.28,25.68).
city('Safipur','in','Uttar Pradesh',24804.0,80.35,26.73).
city('Saharanpur','in','Uttar Pradesh',484921.0,77.54,29.97).
city('Sahaspur','in','Uttar Pradesh',24454.0,78.62,29.13).
city('Sahaswan','in','Uttar Pradesh',60959.0,78.74,28.08).
city('Sahawar','in','Uttar Pradesh',22203.0,78.85,27.8).
city('Saidpur','in','Uttar Pradesh',18702.0,80.55,27.09).
city('Sainthal','in','Uttar Pradesh',14246.0,79.58,28.53).
city('Sakit','in','Uttar Pradesh',7811.0,78.82,27.45).
city('Salimpur','in','Uttar Pradesh',18766.0,84.62,26.43).
city('Salon','in','Uttar Pradesh',14313.0,81.45,26.03).
city('Sambhal','in','Uttar Pradesh',196129.0,78.56,28.59).
city('Samthar','in','Uttar Pradesh',21584.0,78.92,25.85).
city('Sandi','in','Uttar Pradesh',25010.0,79.95,27.3).
city('Sandila','in','Uttar Pradesh',53188.0,80.52,27.08).
city('Sarai Mir','in','Uttar Pradesh',17851.0,82.92,26.02).
city('Sarai akil','in','Uttar Pradesh',17444.0,81.52,25.38).
city('Sarauli','in','Uttar Pradesh',20925.0,79.1,28.5).
city('Sardhana','in','Uttar Pradesh',49862.0,77.62,29.15).
city('Sarila','in','Uttar Pradesh',8013.0,79.68,25.77).
city('Sasni','in','Uttar Pradesh',13499.0,78.08,27.72).
city('Satrikh','in','Uttar Pradesh',11024.0,81.2,26.87).
city('Saurikh','in','Uttar Pradesh',12056.0,79.48,27.03).
city('Seohara','in','Uttar Pradesh',46551.0,78.58,29.22).
city('Shahabad','in','Uttar Pradesh',54290.0,79.49,28.11).
city('Shahganj','in','Uttar Pradesh',26513.0,82.68,26.05).
city('Shahi','in','Uttar Pradesh',16066.0,79.32,28.55).
city('Shahjahanpur','in','Uttar Pradesh',320466.0,79.9,27.88).
city('Shahpur','in','Uttar Pradesh',18876.0,77.55,29.35).
city('Shamli','in','Uttar Pradesh',97976.0,77.31,29.46).
city('Shamsabad','in','Uttar Pradesh',28140.0,78.78,27.28).
city('Shankargarh','in','Uttar Pradesh',14139.0,81.62,25.18).
city('Shergarh','in','Uttar Pradesh',14078.0,79.35,28.65).
city('Sherkot','in','Uttar Pradesh',57367.0,78.58,29.35).
city('Shikarpur','in','Uttar Pradesh',34652.0,78.02,28.28).
city('Shikohabad','in','Uttar Pradesh',99688.0,78.58,27.12).
city('Shisgarh','in','Uttar Pradesh',23473.0,79.31,28.72).
city('Sidhauli','in','Uttar Pradesh',22195.0,80.83,27.28).
city('Sidhpura','in','Uttar Pradesh',14816.0,78.88,27.63).
city('Sikandarabad','in','Uttar Pradesh',73386.0,77.69,28.44).
city('Sikandarpur','in','Uttar Pradesh',2417.0,84.05,26.05).
city('Sikandra','in','Uttar Pradesh',12290.0,79.65,26.37).
city('Sikandra Rao','in','Uttar Pradesh',42233.0,78.4,27.7).
city('Sirathu','in','Uttar Pradesh',13599.0,81.32,25.65).
city('Sirsa','in','Uttar Pradesh',12609.0,82.08,25.28).
city('Sirsaganj','in','Uttar Pradesh',29037.0,78.7,27.05).
city('Sirsi','in','Uttar Pradesh',22551.0,78.65,28.65).
city('Sisauli','in','Uttar Pradesh',15839.0,77.47,29.42).
city('Siswa Bazar','in','Uttar Pradesh',19941.0,83.77,27.15).
city('Sitapur','in','Uttar Pradesh',164451.0,80.69,27.57).
city('Siyana','in','Uttar Pradesh',43026.0,77.95,28.63).
city('Soron','in','Uttar Pradesh',28686.0,78.75,27.88).
city('Suar','in','Uttar Pradesh',28944.0,79.05,29.03).
city('Sultanpur','in','Uttar Pradesh',110379.0,82.06,26.26).
city('Tajpur','in','Uttar Pradesh',17529.0,78.48,29.17).
city('Talbahat','in','Uttar Pradesh',13791.0,78.43,25.05).
city('Talgram','in','Uttar Pradesh',10631.0,79.65,27.05).
city('Tanda','in','Uttar Pradesh',66454.0,80.79,27.77).
city('Thakurdwara','in','Uttar Pradesh',39864.0,78.85,29.2).
city('Thana Bhawan','in','Uttar Pradesh',33502.0,77.42,29.58).
city('Tikaitnagar','in','Uttar Pradesh',8807.0,81.58,26.95).
city('Tikri','in','Uttar Pradesh',13648.0,77.35,29.23).
city('Tilhar','in','Uttar Pradesh',57048.0,79.73,27.98).
city('Tindwari','in','Uttar Pradesh',10407.0,80.53,25.62).
city('Titron','in','Uttar Pradesh',11570.0,77.33,29.68).
city('Tori Fatehpur','in','Uttar Pradesh',10211.0,79.13,25.45).
city('Tulsipur','in','Uttar Pradesh',22488.0,82.42,27.55).
city('Tundla','in','Uttar Pradesh',50944.0,78.28,27.2).
city('Ugu','in','Uttar Pradesh',6519.0,80.33,26.78).
city('Ujhani','in','Uttar Pradesh',56314.0,79.02,28.02).
city('Umri','in','Uttar Pradesh',9365.0,78.95,26.52).
city('Un','in','Uttar Pradesh',15008.0,77.25,29.58).
city('Unnao','in','Uttar Pradesh',161687.0,80.49,26.55).
city('Utraula','in','Uttar Pradesh',28440.0,82.42,27.32).
city('Varanasi','in','Uttar Pradesh',1164520.0,83.01,25.32).
city('Vrindavan','in','Uttar Pradesh',60201.0,77.7,27.58).
city('Wazirganj','in','Uttar Pradesh',19374.0,79.05,28.22).
city('Zafarabad','in','Uttar Prades',9107.0,82.73,25.7).
city('Zaidpur','in','Uttar Pradesh',33400.0,81.33,26.83).
city('Zamania','in','Uttar Pradesh',32011.0,83.57,25.43).
city('Almora','in','Uttaranchal',32446.0,79.67,29.62).
city('Bageshwar','in','Uttaranchal',8708.0,79.77,29.85).
city('Barkot','in','Uttaranchal',7726.0,78.2,30.82).
city('Bazpur','in','Uttaranchal',23902.0,79.12,29.15).
city('Bhim Tal','in','Uttaranchal',6626.0,79.57,29.35).
city('Bhowali','in','Uttaranchal',5686.0,79.52,29.38).
city('Chakrata','in','Uttaranchal',3349.0,77.8,30.7).
city('Chamoli and Gopeshwar','in','Uttaranchal',21781.0,79.34,30.41).
city('Champawat','in','Uttaranchal',4669.0,80.1,29.33).
city('Clement Town','in','Uttaranchal',20807.0,78.07,30.27).
city('Dehra Dun','in','Uttaranchal',522135.0,78.05,30.34).
city('Dehra Dun Cantonment','in','Uttaranchal',30008.0,77.97,30.34).
city('Devaprayag','in','Uttaranchal',2131.0,78.62,30.15).
city('Dharchula','in','Uttaranchal',7332.0,80.53,29.85).
city('Doiwala','in','Uttaranchal',8248.0,78.12,30.18).
city('Dwarahat','in','Uttaranchal',2443.0,79.43,29.0).
city('Gangotri','in','Uttaranchal',811.0,78.93,30.98).
city('Haldwani','in','Uttaranchal',139512.0,79.52,29.23).
city('Haridwar','in','Uttaranchal',186099.0,78.16,29.98).
city('Herbertpur','in','Uttaranchal',9479.0,77.73,30.45).
city('Jaspur','in','Uttaranchal',42529.0,78.82,29.28).
city('Joshimath','in','Uttaranchal',13866.0,79.57,30.57).
city('Kalagarh','in','Uttaranchal',13298.0,78.75,29.5).
city('Kashipur','in','Uttaranchal',103149.0,78.96,29.22).
city('Kedarnath','in','Uttaranchal',508.0,79.07,30.73).
city('Khatima','in','Uttaranchal',15716.0,79.97,28.92).
city('Kichha','in','Uttaranchal',34908.0,79.5,28.92).
city('Kotdwara','in','Uttaranchal',27012.0,78.53,29.75).
city('Laksar','in','Uttaranchal',19272.0,78.05,29.77).
city('Manglaur','in','Uttaranchal',46400.0,77.88,29.79).
city('Masuri','in','Uttaranchal',25756.0,78.08,30.45).
city('Naini Tal','in','Uttaranchal',42314.0,79.45,29.38).
city('Narendranagar','in','Uttaranchal',4734.0,78.3,30.17).
city('Pauri','in','Uttaranchal',26517.0,78.78,30.15).
city('Pithoragarh','in','Uttaranchal',47576.0,80.22,29.58).
city('Raipur','in','Uttaranchal',27705.0,78.1,30.32).
city('Raiwala','in','Uttaranchal',5198.0,78.22,30.02).
city('Ramnagar','in','Uttaranchal',51249.0,79.12,29.4).
city('Ranikhet','in','Uttaranchal',19875.0,79.42,29.65).
city('Ranipur','in','Uttaranchal',45097.0,78.21,29.96).
city('Rishikesh','in','Uttaranchal',66397.0,78.29,30.12).
city('Rudraprayag','in','Uttaranchal',2571.0,78.98,30.28).
city('Rudrapur','in','Uttaranchal',101571.0,79.48,29.5).
city('Rurki','in','Uttaranchal',103905.0,77.89,29.87).
city('Sitarganj','in','Uttaranchal',24228.0,79.7,28.93).
city('Srinagar','in','Uttaranchal',20219.0,78.78,30.22).
city('Sultanpur','in','Uttaranchal',8519.0,78.12,29.75).
city('Tanakpur','in','Uttaranchal',16907.0,80.12,29.08).
city('Tehri','in','Uttaranchal',27614.0,78.48,30.38).
city('Uttarkashi','in','Uttaranchal',17125.0,78.45,30.73).
city('Virbhadra','in','Uttaranchal',13064.0,78.28,30.07).
city('Banda Aceh','id','Aceh',250796.0,95.32,5.55).
city('Bireun','id','Aceh',25794.0,96.69,5.21).
city('Dewantara','id','Aceh',40394.0,96.28,5.22).
city('Kuala Simpang','id','Aceh',20797.0,98.07,4.28).
city('Langsa','id','Aceh',54466.0,97.96,4.47).
city('Lhokseumawe','id','Aceh',88976.0,97.14,5.19).
city('Meulaboh','id','Aceh',35063.0,96.12,4.14).
city('Sabang','id','Aceh',24519.0,95.33,5.89).
city('Sigli','id','Aceh',17505.0,95.94,5.38).
city('Denpasar','id','Bali',405959.0,115.22,-8.65).
city('Karangasem','id','Bali',31869.0,115.62,-8.44).
city('Klungkung','id','Bali',27837.0,115.4,-8.53).
city('Kuta','id','Bali',30015.0,115.17,-8.72).
city('Negara','id','Bali',33192.0,114.61,-8.37).
city('Singaraja','id','Bali',133796.0,115.09,-8.12).
city('Tabanan','id','Bali',33668.0,115.12,-8.54).
city('Ubud','id','Bali',28373.0,115.26,-8.52).
city('Manggar','id','Bangka-Belitung',34522.0,108.27,-2.89).
city('Mentok','id','Bangka-Belitung',26708.0,105.16,-2.06).
city('Pangkal Pinang','id','Bangka-Belitung',125939.0,106.1,-2.12).
city('Sungai Liat','id','Bangka-Belitung',74716.0,106.1,-1.86).
city('Tanjung Pandan','id','Bangka-Belitung',62371.0,107.63,-2.74).
city('Toboali-Rias','id','Bangka-Belitung',33856.0,106.5,-3.0).
city('Balaraja','id','Banten',130159.0,105.95,-6.21).
city('Cikupa','id','Banten',174184.0,106.52,-6.23).
city('Cilegon','id','Banten',299790.0,106.0,-5.94).
city('Ciputat','id','Banten',207848.0,106.68,-6.23).
city('Curug','id','Banten',191617.0,106.55,-6.25).
city('Kresek','id','Banten',110304.0,106.37,-6.13).
city('Labuhan','id','Banten',33574.0,105.83,-6.37).
city('Pandegelang','id','Banten',92361.0,106.1,-6.31).
city('Pasarkemis','id','Banten',154227.0,106.51,-6.16).
city('Pondok Aren','id','Banten',190216.0,106.68,-6.25).
city('Rangkasbitung','id','Banten',126904.0,106.24,-6.36).
city('Sepatan','id','Banten',118434.0,106.58,-6.12).
city('Serang','id','Banten',164777.0,106.15,-6.11).
city('Serpong','id','Banten',80189.0,106.66,-6.32).
city('Tangerang','id','Banten',1372185.0,106.63,-6.18).
city('Teluknaga','id','Banten',128336.0,106.61,-6.08).
city('Bengkulu','id','Bengkulu',309759.0,102.25,-3.8).
city('Curup','id','Bengkulu',46246.0,102.52,-3.46).
city('Gorontalo','id','Gorontalo',144202.0,123.06,0.56).
city('Jakarta','id','Jakarta',8540306.0,106.83,-6.18).
city('Jambi','id','Jambi',420391.0,103.61,-1.59).
city('Kualatungka','id','Jambi',33684.0,103.47,-0.82).
city('Mendahara','id','Jambi',56269.0,103.59,-1.03).
city('Simpang','id','Jambi',36653.0,104.1,-1.26).
city('Sungaipenuh','id','Jambi',95990.0,101.39,-2.06).
city('Arjawinangun','id','Jawa Barat',105852.0,108.4,-6.65).
city('Astanajapura','id','Jawa Barat',148055.0,108.6,-6.8).
city('Babakan','id','Jawa Barat',124801.0,108.72,-6.83).
city('Bandung','id','Jawa Barat',1699822.0,107.6,-6.91).
city('Banjar','id','Jawa Barat',37282.0,107.42,-7.2).
city('Banjaran','id','Jawa Barat',165136.0,107.58,-7.05).
city('Batu Jajar','id','Jawa Barat',29416.0,107.48,-6.88).
city('Bekasi','id','Jawa Barat',1520204.0,106.97,-6.22).
city('Bogor','id','Jawa Barat',769328.0,106.79,-6.58).
city('Bojong Gede','id','Jawa Barat',171242.0,107.78,-6.48).
city('Caringan','id','Jawa Barat',91841.0,106.82,-6.7).
city('Ciamis','id','Jawa Barat',123631.0,108.35,-7.32).
city('Ciampea','id','Jawa Barat',207445.0,106.69,-6.55).
city('Cianjur','id','Jawa Barat',146883.0,107.14,-6.82).
city('Ciawi','id','Jawa Barat',67902.0,106.83,-6.67).
city('Cibadak','id','Jawa Barat',229745.0,106.78,-6.89).
city('Cibeureum','id','Jawa Barat',52774.0,108.25,-7.35).
city('Cibinong','id','Jawa Barat',188674.0,106.84,-6.44).
city('Cibitung','id','Jawa Barat',198119.0,107.08,-6.27).
city('Cicalengka','id','Jawa Barat',158.0,107.83,-6.99).
city('Cicuruk','id','Jawa Barat',88961.0,106.78,-6.78).
city('Cidahu','id','Jawa Barat',50240.0,106.72,-6.76).
city('Cikampek','id','Jawa Barat',145613.0,107.46,-6.4).
city('Cikarang','id','Jawa Barat',106486.0,107.12,-6.27).
city('Cikeruh','id','Jawa Barat',85328.0,107.76,-6.95).
city('Ciledug','id','Jawa Barat',98524.0,108.72,-6.86).
city('Cileungsi','id','Jawa Barat',202360.0,106.95,-6.4).
city('Cileunyi','id','Jawa Barat',111570.0,107.73,-6.93).
city('Cimahi','id','Jawa Barat',378027.0,107.48,-6.83).
city('Ciomas','id','Jawa Barat',152335.0,106.75,-6.6).
city('Ciparay','id','Jawa Barat',114226.0,107.64,-7.0).
city('Ciranjang','id','Jawa Barat',77755.0,107.22,-6.8).
city('Cirebon','id','Jawa Barat',254314.0,108.56,-6.71).
city('Cirebon Barat','id','Jawa Barat',77785.0,108.53,-6.71).
city('Cirebon Utara','id','Jawa Barat',96788.0,108.54,-6.69).
city('Cisaat','id','Jawa Barat',141005.0,106.88,-6.9).
city('Cisarua','id','Jawa Barat',103933.0,106.98,-6.67).
city('Citeureup','id','Jawa Barat',110162.0,106.86,-6.48).
city('Dayeuh Kolot','id','Jawa Barat',81512.0,107.62,-6.98).
city('Depok','id','Jawa Barat',1198195.0,106.83,-6.39).
city('Garut','id','Jawa Barat',122421.0,107.9,-7.21).
city('Gunung Putri','id','Jawa Barat',147561.0,106.87,-6.45).
city('Indramayu','id','Jawa Barat',123271.0,108.32,-6.33).
city('Jatibarang','id','Jawa Barat',73006.0,108.3,-6.47).
city('Jatiwangi','id','Jawa Barat',57970.0,108.25,-6.73).
city('Kadipaten','id','Jawa Barat',26970.0,108.17,-6.76).
city('Kadungora','id','Jawa Barat',77255.0,107.9,-7.08).
city('Karang Tengah','id','Jawa Barat',138471.0,107.12,-6.83).
city('Karangampel','id','Jawa Barat',31232.0,108.45,-6.47).
city('Karangsembung','id','Jawa Barat',75852.0,108.65,-6.83).
city('Karawang','id','Jawa Barat',198894.0,107.28,-6.3).
city('Kawalu','id','Jawa Barat',50538.0,108.2,-7.38).
city('Kelari','id','Jawa Barat',26337.0,107.22,-6.12).
city('Kemang','id','Jawa Barat',111027.0,107.25,-6.98).
city('Klangenan','id','Jawa Barat',88373.0,108.47,-6.69).
city('Kuningan','id','Jawa Barat',72090.0,108.48,-6.98).
city('Lemahabang','id','Jawa Barat',36019.0,106.62,-6.83).
city('Lembang','id','Jawa Barat',183283.0,107.61,-6.81).
city('Leuwiliang','id','Jawa Barat',191992.0,106.62,-6.57).
city('Majalaya','id','Jawa Barat',226720.0,107.76,-7.05).
city('Majalengka','id','Jawa Barat',87775.0,108.24,-6.84).
city('Margahayu','id','Jawa Barat',83124.0,107.55,-6.96).
city('Mundu','id','Jawa Barat',50426.0,108.39,-6.45).
city('Pacet','id','Jawa Barat',328324.0,107.05,-6.75).
city('Padalarang','id','Jawa Barat',124953.0,107.48,-6.84).
city('Palabuhanratu','id','Jawa Barat',42999.0,106.55,-6.98).
city('Palimanan','id','Jawa Barat',92606.0,108.44,-6.71).
city('Pamanukan','id','Jawa Barat',114386.0,107.82,-6.28).
city('Pameungpeuk','id','Jawa Barat',48297.0,107.6,-7.02).
city('Pamulang','id','Jawa Barat',174549.0,106.73,-6.31).
city('Parung','id','Jawa Barat',193991.0,106.73,-6.42).
city('Paseh','id','Jawa Barat',126287.0,107.75,-7.1).
city('Plered','id','Jawa Barat',25122.0,107.38,-6.63).
city('Plumbon','id','Jawa Barat',167187.0,108.49,-6.7).
city('Purwakarta','id','Jawa Barat',215816.0,107.43,-6.55).
city('Rajapolah','id','Jawa Barat',39838.0,108.19,-7.21).
city('Rancaekek','id','Jawa Barat',152108.0,107.75,-6.95).
city('Rengasdengklok','id','Jawa Barat',201687.0,107.28,-6.15).
city('Sawangan','id','Jawa Barat',114063.0,106.77,-6.4).
city('Sindang','id','Jawa Barat',27957.0,108.3,-6.38).
city('Singaparna','id','Jawa Barat',48880.0,108.11,-7.35).
city('Soreang','id','Jawa Barat',151135.0,107.51,-7.02).
city('Subang','id','Jawa Barat',129009.0,107.75,-6.57).
city('Sukabumi','id','Jawa Barat',276431.0,106.92,-6.92).
city('Sukaraja','id','Jawa Barat',138577.0,106.86,-6.73).
city('Sumber','id','Jawa Barat',93466.0,108.48,-6.75).
city('Sumedang','id','Jawa Barat',206919.0,107.92,-6.84).
city('Tambun','id','Jawa Barat',314271.0,107.05,-6.27).
city('Tarogong','id','Jawa Barat',77165.0,107.87,-7.2).
city('Tasikmalaya','id','Jawa Barat',271160.0,108.21,-7.32).
city('Wanaraja','id','Jawa Barat',26239.0,107.97,-7.17).
city('Weru','id','Jawa Barat',139013.0,108.5,-6.7).
city('Adiwerna','id','Jawa Tengah',134202.0,109.12,-6.93).
city('Ambarawa','id','Jawa Tengah',84380.0,110.4,-7.26).
city('Bae','id','Jawa Tengah',57927.0,110.86,-6.77).
city('Baki','id','Jawa Tengah',58916.0,110.76,-7.62).
city('Balapulang','id','Jawa Tengah',28484.0,109.1,-7.05).
city('Banyumas','id','Jawa Tengah',48379.0,109.28,-7.52).
city('Batang','id','Jawa Tengah',115549.0,109.77,-6.94).
city('Baturaden','id','Jawa Tengah',42395.0,109.21,-7.29).
city('Blora','id','Jawa Tengah',51812.0,111.41,-6.96).
city('Boyolali','id','Jawa Tengah',59852.0,110.59,-7.52).
city('Brebes','id','Jawa Tengah',186936.0,109.03,-6.86).
city('Buaran','id','Jawa Tengah',38774.0,109.55,-7.05).
city('Bulakamba','id','Jawa Tengah',27367.0,108.92,-6.87).
city('Bumiayu','id','Jawa Tengah',54044.0,109.0,-7.25).
city('Ceper','id','Jawa Tengah',28647.0,110.66,-7.68).
city('Cepu','id','Jawa Tengah',55056.0,111.58,-7.15).
city('Cilacap','id','Jawa Tengah',214288.0,109.0,-7.34).
city('Colomandu','id','Jawa Tengah',26275.0,110.75,-7.53).
city('Comal','id','Jawa Tengah',51092.0,109.52,-6.92).
city('Delanggu','id','Jawa Tengah',24440.0,110.68,-7.62).
city('Demak','id','Jawa Tengah',27251.0,110.64,-6.89).
city('Dukuhturi','id','Jawa Tengah',98084.0,109.08,-6.9).
city('Gatak','id','Jawa Tengah',48964.0,110.72,-7.58).
city('Gebog','id','Jawa Tengah',43757.0,110.83,-6.73).
city('Gombong','id','Jawa Tengah',31965.0,109.5,-7.6).
city('Grogol','id','Jawa Tengah',100624.0,110.8,-7.59).
city('Jaten','id','Jawa Tengah',32379.0,110.9,-7.58).
city('Jati','id','Jawa Tengah',85816.0,110.81,-6.84).
city('Jatibarang','id','Jawa Tengah',28817.0,109.05,-6.96).
city('Jeluko','id','Jawa Tengah',37522.0,110.92,-6.8).
city('Jepara','id','Jawa Tengah',54324.0,110.68,-6.62).
city('Jogonalan','id','Jawa Tengah',28114.0,110.53,-7.72).
city('Juwana','id','Jawa Tengah',40178.0,111.15,-6.7).
city('Kaliwungu','id','Jawa Tengah',48916.0,110.23,-6.95).
city('Karanganom','id','Jawa Tengah',50671.0,110.64,-7.66).
city('Karanganyar','id','Jawa Tengah',34923.0,109.58,-7.62).
city('Kartosura','id','Jawa Tengah',88936.0,110.74,-7.55).
city('Kebonarum','id','Jawa Tengah',21745.0,110.57,-7.7).
city('Kebumen','id','Jawa Tengah',144457.0,109.65,-7.67).
city('Kedungwuni','id','Jawa Tengah',117262.0,109.64,-6.97).
city('Kembaran','id','Jawa Tengah',77977.0,109.28,-7.42).
city('Kendal','id','Jawa Tengah',50637.0,110.42,-6.91).
city('Ketanggungan','id','Jawa Tengah',44288.0,108.88,-6.93).
city('Klaten','id','Jawa Tengah',126845.0,110.59,-7.71).
city('Kramat','id','Jawa Tengah',48074.0,109.2,-6.88).
city('Kroya','id','Jawa Tengah',23255.0,109.23,-7.63).
city('Kudus','id','Jawa Tengah',92166.0,110.84,-6.81).
city('Kutoarjo','id','Jawa Tengah',31353.0,109.9,-7.72).
city('Lasem','id','Jawa Tengah',28948.0,111.45,-6.7).
city('Lebaksiu','id','Jawa Tengah',33607.0,109.15,-7.05).
city('Magelang','id','Jawa Tengah',111470.0,110.21,-7.48).
city('Majenang','id','Jawa Tengah',38898.0,108.76,-7.3).
city('Margasari','id','Jawa Tengah',27814.0,109.02,-7.1).
city('Mayong','id','Jawa Tengah',24176.0,110.75,-6.75).
city('Mertoyudan','id','Jawa Tengah',69872.0,110.2,-7.52).
city('Mlonggo','id','Jawa Tengah',33543.0,110.7,-6.53).
city('Mojolaban','id','Jawa Tengah',66754.0,110.87,-7.57).
city('Mranggen','id','Jawa Tengah',28026.0,110.51,-7.02).
city('Muntilan','id','Jawa Tengah',44859.0,110.27,-7.58).
city('Ngawen','id','Jawa Tengah',44401.0,110.69,-7.82).
city('Ngemplak','id','Jawa Tengah',23751.0,110.7,-7.53).
city('Pangkah','id','Jawa Tengah',113387.0,109.17,-6.97).
city('Parakan','id','Jawa Tengah',23795.0,110.11,-7.28).
city('Pati','id','Jawa Tengah',122798.0,111.04,-6.75).
city('Pecangakan','id','Jawa Tengah',61047.0,110.7,-6.68).
city('Pedan','id','Jawa Tengah',28738.0,110.68,-7.75).
city('Pekalongan','id','Jawa Tengah',257973.0,109.66,-6.88).
city('Pemalang','id','Jawa Tengah',184169.0,109.38,-6.88).
city('Peterukan','id','Jawa Tengah',74189.0,109.43,-6.88).
city('Ponorogo','id','Jawa Tengah',79034.0,111.47,-7.87).
city('Prambanan','id','Jawa Tengah',44926.0,110.5,-7.75).
city('Purbalingga','id','Jawa Tengah',56909.0,109.39,-7.37).
city('Purwodadi','id','Jawa Tengah',96372.0,110.46,-7.44).
city('Purwokerto','id','Jawa Tengah',217245.0,109.24,-7.43).
city('Purworejo','id','Jawa Tengah',105077.0,112.74,-7.77).
city('Randudongkal','id','Jawa Tengah',28532.0,109.32,-7.1).
city('Rembang','id','Jawa Tengah',44030.0,111.34,-6.71).
city('Salatiga','id','Jawa Tengah',172664.0,110.47,-7.3).
city('Selogiri','id','Jawa Tengah',30180.0,110.87,-7.78).
city('Semarang','id','Jawa Tengah',1288221.0,110.42,-6.97).
city('Sidareja','id','Jawa Tengah',30314.0,108.78,-7.48).
city('Slawi','id','Jawa Tengah',61213.0,109.14,-6.98).
city('Sragen','id','Jawa Tengah',71530.0,111.02,-7.43).
city('Sukaraja','id','Jawa Tengah',66489.0,109.29,-7.46).
city('Surakarta','id','Jawa Tengah',555368.0,110.82,-7.57).
city('Talang','id','Jawa Tengah',98971.0,109.13,-6.9).
city('Taman','id','Jawa Tengah',181626.0,109.38,-6.9).
city('Tarub','id','Jawa Tengah',75740.0,109.18,-6.91).
city('Tayu','id','Jawa Tengah',26414.0,111.04,-6.5).
city('Tegal','id','Jawa Tengah',237110.0,109.13,-6.86).
city('Temanggung','id','Jawa Tengah',42081.0,110.17,-7.32).
city('Trucuk','id','Jawa Tengah',23584.0,110.65,-7.72).
city('Ungaran','id','Jawa Tengah',127873.0,110.4,-7.12).
city('Wanasari','id','Jawa Tengah',25892.0,109.26,-6.91).
city('Wedi','id','Jawa Tengah',55300.0,110.61,-7.75).
city('Welahan','id','Jawa Tengah',26163.0,110.72,-6.8).
city('Weleri','id','Jawa Tengah',58454.0,110.06,-6.97).
city('Wengon','id','Jawa Tengah',35531.0,109.05,-7.51).
city('Wonogiri','id','Jawa Tengah',38623.0,110.92,-7.81).
city('Wonopringgo','id','Jawa Tengah',38430.0,109.64,-6.98).
city('Wonosari','id','Jawa Tengah',62961.0,110.75,-7.61).
city('Wonosobo','id','Jawa Tengah',93000.0,109.9,-7.36).
city('Wuradesa','id','Jawa Tengah',39407.0,109.6,-6.88).
city('Ambulu','id','Jawa Timur',27503.0,113.65,-8.35).
city('Babat','id','Jawa Timur',27039.0,112.17,-7.1).
city('Balung','id','Jawa Timur',47631.0,113.91,-7.73).
city('Bangil','id','Jawa Timur',62513.0,112.78,-7.6).
city('Bangkalan','id','Jawa Timur',62185.0,112.74,-7.03).
city('Banyuwangi','id','Jawa Timur',108178.0,114.37,-8.2).
city('Batu','id','Jawa Timur',75640.0,112.52,-7.87).
city('Besuki','id','Jawa Timur',55466.0,113.68,-7.73).
city('Blitar','id','Jawa Timur',132431.0,112.16,-8.07).
city('Bojonegoro','id','Jawa Timur',86578.0,111.87,-7.15).
city('Bondowoso','id','Jawa Timur',69791.0,113.82,-7.91).
city('Boyolangu','id','Jawa Timur',32287.0,111.89,-8.12).
city('Buduran','id','Jawa Timur',48152.0,112.71,-7.42).
city('Dampit','id','Jawa Timur',23094.0,112.75,-8.22).
city('Diwek','id','Jawa Timur',41719.0,112.23,-7.58).
city('Driyorejo','id','Jawa Timur',26827.0,112.62,-7.35).
city('Gambiran','id','Jawa Timur',22525.0,114.14,-8.39).
city('Gampengrejo','id','Jawa Timur',49119.0,112.02,-7.77).
city('Gedangan','id','Jawa Timur',79239.0,112.71,-7.38).
city('Gedek','id','Jawa Timur',29323.0,112.38,-7.45).
city('Gempol','id','Jawa Timur',31151.0,112.68,-7.55).
city('Genteng','id','Jawa Timur',79653.0,114.14,-8.36).
city('Gondang','id','Jawa Timur',24616.0,111.83,-8.07).
city('Gondanglegi','id','Jawa Timur',22468.0,112.63,-8.18).
city('Gresik','id','Jawa Timur',73638.0,112.66,-7.16).
city('Jatiroto','id','Jawa Timur',50065.0,111.11,-7.89).
city('Jember','id','Jawa Timur',298620.0,113.69,-8.17).
city('Jombang','id','Jawa Timur',126479.0,112.26,-7.56).
city('Kaliang','id','Jawa Timur',23897.0,113.93,-7.05).
city('Kamal','id','Jawa Timur',22515.0,112.73,-7.17).
city('Kanigoro','id','Jawa Timur',36467.0,112.22,-8.12).
city('Kebomas','id','Jawa Timur',75990.0,112.63,-7.17).
city('Kediri','id','Jawa Timur',235171.0,112.01,-7.81).
city('Kedungwaru','id','Jawa Timur',80267.0,111.92,-8.07).
city('Kencong','id','Jawa Timur',43047.0,113.38,-8.28).
city('Kepanjen','id','Jawa Timur',51920.0,112.58,-8.13).
city('Kertosono','id','Jawa Timur',60789.0,112.11,-7.6).
city('Kraksaan','id','Jawa Timu',28249.0,113.42,-7.76).
city('Krian','id','Jawa Timur',38604.0,112.58,-7.4).
city('Lamongan','id','Jawa Timur',59224.0,112.41,-7.12).
city('Lawang','id','Jawa Timur',159517.0,112.7,-7.83).
city('Lumajang','id','Jawa Timur',123640.0,113.22,-8.14).
city('Madiun','id','Jawa Timur',186116.0,111.51,-7.63).
city('Magetan','id','Jawa Timur',79716.0,111.33,-7.65).
city('Malang','id','Jawa Timur',746780.0,112.62,-7.98).
city('Mojoagung','id','Jawa Timur',23534.0,112.35,-7.57).
city('Mojokerto','id','Jawa Timur',112570.0,112.43,-7.47).
city('Mojosari','id','Jawa Timur',36298.0,112.55,-7.52).
city('Muncar','id','Jawa Timur',64538.0,114.33,-8.43).
city('Nganjuk','id','Jawa Timur',69019.0,111.9,-7.59).
city('Ngawi','id','Jawa Timur',22412.0,111.43,-7.41).
city('Ngoro','id','Jawa Timur',22871.0,112.26,-7.68).
city('Ngunut','id','Jawa Timur',26297.0,112.02,-8.1).
city('Paciran','id','Jawa Timur',27072.0,112.33,-6.87).
city('Pakisaji','id','Jawa Timur',30214.0,112.58,-8.06).
city('Pamekasan','id','Jawa Timur',92457.0,113.47,-7.17).
city('Panarukan','id','Jawa Timur',30749.0,113.93,-7.7).
city('Pandaan','id','Jawa Timur',34184.0,112.68,-7.65).
city('Panji','id','Jawa Timur',42789.0,114.02,-7.68).
city('Pare','id','Jawa Timur',56700.0,112.19,-7.76).
city('Pasuruan','id','Jawa Timur',158618.0,112.9,-7.64).
city('Peterongan','id','Jawa Timur',22726.0,112.27,-7.53).
city('Porong','id','Jawa Timur',54698.0,112.69,-7.56).
city('Prigen','id','Jawa Timur',24164.0,112.63,-7.69).
city('Probolinggo','id','Jawa Timur',181678.0,113.2,-7.76).
city('Sampang','id','Jawa Timur',53270.0,113.26,-7.21).
city('Sidoarjo','id','Jawa Timur',139205.0,112.71,-7.45).
city('Singojuruh','id','Jawa Timur',29418.0,114.23,-8.32).
city('Singosari','id','Jawa Timur',57794.0,112.67,-7.89).
city('Situbondo','id','Jawa Timur',51058.0,113.93,-7.73).
city('Sooko','id','Jawa Timur',25494.0,112.42,-7.48).
city('Srono','id','Jawa Timur',36260.0,114.27,-8.4).
city('Sumber Pucung','id','Jawa Timur',35285.0,112.47,-8.17).
city('Sumenep','id','Jawa Timur',84665.0,113.85,-7.01).
city('Surabaya','id','Jawa Timur',2374920.0,112.74,-7.24).
city('Taman','id','Jawa Timur',126875.0,112.64,-7.37).
city('Tanggul','id','Jawa Timur',35909.0,113.45,-8.17).
city('Tanggulangin','id','Jawa Timur',32867.0,112.7,-7.5).
city('Tempeh','id','Jawa Timur',26637.0,113.16,-8.2).
city('Trenggalek','id','Jawa Timur',29083.0,111.7,-8.05).
city('Tuban','id','Jawa Timur',76251.0,112.03,-6.87).
city('Tulangan','id','Jawa Timur',63890.0,112.64,-7.46).
city('Tulungagung','id','Jawa Timur',65270.0,111.9,-8.05).
city('Waru','id','Jawa Timur',147506.0,112.65,-7.38).
city('Wates','id','Jawa Timur',22916.0,112.13,-7.91).
city('Wlingi','id','Jawa Timur',29582.0,112.32,-8.13).
city('Manis Mata','id','Kalimantan Barat',18889.0,111.04,-2.45).
city('Pemangkat','id','Kalimantan Barat',34030.0,108.97,1.18).
city('Pontianak','id','Kalimantan Barat',455226.0,109.34,-0.02).
city('Singkawang','id','Kalimantan Barat',101851.0,108.98,0.91).
city('Sungairaya','id','Kalimantan Barat',47736.0,108.9,0.7).
city('Amuntai','id','Kalimantan Selatan',55596.0,115.24,-2.42).
city('Banjarmasin','id','Kalimantan Selatan',572910.0,114.59,-3.3).
city('Barabai','id','Kalimantan Selatan',60231.0,115.38,-2.58).
city('Kota Baru','id','Kalimantan Selatan',55135.0,116.24,-3.25).
city('Martapura','id','Kalimantan Selatan',131452.0,114.84,-3.41).
city('Kualakapuas','id','Kalimantan Tengah',35632.0,114.35,-3.1).
city('Palangka Raya','id','Kalimantan Tengah',179593.0,113.92,-2.21).
city('Pangkalanbuun','id','Kalimantan Tengah',38058.0,111.62,-2.69).
city('Sampit','id','Kalimantan Tengah',66054.0,112.95,-2.53).
city('Balikpapan','id','Kalimantan Timur',433939.0,116.83,-1.26).
city('Bontang','id','Kalimantan Timur',101693.0,117.49,0.14).
city('Loa Janan','id','Kalimantan Timur',212820.0,117.1,-0.59).
city('Samarinda','id','Kalimantan Timur',355223.0,117.15,-0.5).
city('Sembakung','id','Kalimantan Timur',8098.0,117.25,3.81).
city('Tanjung Redeb','id','Kalimantan Timur',49402.0,117.49,2.16).
city('Tarakan','id','Kalimantan Timur',97496.0,117.62,3.28).
city('Bandar Lampung','id','Lampung',800446.0,105.27,-5.44).
city('Kota Bumi','id','Lampung',42366.0,104.88,-4.82).
city('Metro','id','Lampung',149552.0,105.33,-5.1).
city('Pringsewu','id','Lampung',124791.0,105.08,-5.36).
city('Terbanggi Besar','id','Lampung',52567.0,105.21,-4.88).
city('Ternate','id','Maluku Utara',101736.0,127.36,0.79).
city('Tidore','id','Maluku Utara',46146.0,127.43,0.7).
city('Amahai','id','Maluku',47651.0,128.92,-3.34).
city('Ambon','id','Maluku',355607.0,128.16,-3.7).
city('Tual','id','Maluku',39501.0,132.74,-5.63).
city('Bima','id','Nusa Tenggara Barat',66972.0,118.72,-8.46).
city('Mataram','id','Nusa Tenggara Barat',318712.0,116.13,-8.58).
city('Praya','id','Nusa Tenggara Barat',35184.0,116.29,-8.72).
city('Sumbawa','id','Nusa Tenggara Barat',52655.0,117.42,-8.5).
city('Atambua','id','Nusa Tenggara Timur',35794.0,124.89,-9.09).
city('Ende','id','Nusa Tenggara Timur',77212.0,121.65,-8.86).
city('Kefamenanu','id','Nusa Tenggara Timur',29491.0,124.47,-9.41).
city('Kupang','id','Nusa Tenggara Timur',282421.0,123.57,-10.17).
city('Maumere','id','Nusa Tenggara Timur',47599.0,122.21,-8.62).
city('Ruteng','id','Nusa Tenggara Timur',34570.0,120.47,-8.61).
city('Soe','id','Nusa Tenggara Timur',27718.0,124.28,-9.84).
city('Waingapu','id','Nusa Tenggara Timur',48829.0,120.26,-9.66).
city('Aberpura','id','Papua',62255.0,140.58,-2.63).
city('Biak','id','Papua',40907.0,136.05,-1.17).
city('Jaya Pura','id','Papua',134912.0,140.72,-2.54).
city('Manokwari','id','Papua',53191.0,134.08,-0.86).
city('Merauke','id','Papua',49079.0,140.4,-8.5).
city('Nabire','id','Papua',43899.0,135.5,-3.34).
city('Sorong','id','Papua',125538.0,131.29,-0.86).
city('Batam','id','Riau Kepulauan',277301.0,103.92,1.03).
city('Kijang','id','Riau Kepulauan',41343.0,104.63,0.9).
city('Tanjung Pinang','id','Riau Kepulauan',1254.0,104.45,0.91).
city('Balaipungut','id','Riau',56453.0,101.28,1.05).
city('Bengkalis','id','Riau',41705.0,102.08,1.49).
city('Dumai','id','Riau',143775.0,101.45,1.68).
city('Duri','id','Riau',60767.0,101.21,1.26).
city('Pekan Baru','id','Riau',650953.0,101.43,0.56).
city('Selatpanjang','id','Riau',87821.0,102.7,-0.99).
city('Tanjung Balai-Meral','id','Riau',108127.0,103.43,1.0).
city('Tembilahan','id','Riau',92211.0,103.05,-0.4).
city('Banggae','id','Sulawesi Selatan',59510.0,119.71,-3.87).
city('Bone','id','Sulawesi Selatan',81631.0,120.32,-4.54).
city('Bontonompo','id','Sulawesi Selatan',61736.0,119.41,-5.36).
city('Galesong','id','Sulawesi Selatan',83052.0,119.36,-5.31).
city('Majene','id','Sulawesi Selatan',37716.0,118.97,-3.54).
city('Makasar','id','Sulawesi Selatan',1321832.0,119.41,-5.14).
city('Palopo','id','Sulawesi Selatan',93151.0,120.24,-3.1).
city('Pare Pare','id','Sulawesi Selatan',113626.0,119.62,-3.87).
city('Polewali','id','Sulawesi Selatan',58191.0,119.35,-3.42).
city('Rantepao','id','Sulawesi Selatan',40439.0,119.9,-2.98).
city('Singkang','id','Sulawesi Selatan',59524.0,120.03,-4.14).
city('Sinjai','id','Sulawesi Selatan',40798.0,120.26,-5.13).
city('Sombaopu','id','Sulawesi Selatan',86239.0,119.38,-5.21).
city('Tanete','id','Sulawesi Selatan',105109.0,120.13,-5.33).
city('Ujung Bulu','id','Sulawesi Selatan',43707.0,120.26,-5.53).
city('Baolan','id','Sulawesi Tengah',44089.0,120.9,0.47).
city('Luwuk','id','Sulawesi Tengah',47779.0,122.79,-0.94).
city('Palu','id','Sulawesi Tengah',282461.0,119.84,-0.9).
city('Poso','id','Sulawesi Tengah',47115.0,120.76,-1.39).
city('Bau Bau','id','Sulawesi Tenggara',82806.0,122.6,-5.47).
city('Katobu','id','Sulawesi Tenggara',42751.0,122.51,-4.93).
city('Kendari','id','Sulawesi Tenggara',235329.0,122.59,-3.97).
city('Bitung','id','Sulawesi Utara',137361.0,125.19,1.46).
city('Manado','id','Sulawesi Utara',451910.0,124.84,1.5).
city('Mobagu','id','Sulawesi Utara',82175.0,123.98,0.39).
city('Tomohon','id','Sulawesi Utara',27623.0,124.81,1.32).
city('Tondano','id','Sulawesi Utara',33315.0,124.9,1.32).
city('Bukit Tinggi','id','Sumatera Barat',98760.0,100.37,-0.31).
city('Padang','id','Sumatera Barat',840458.0,100.35,-0.95).
city('Padang Panjang','id','Sumatera Barat',43322.0,100.42,-0.45).
city('Padang Pariaman','id','Sumatera Barat',92243.0,100.13,-0.63).
city('Payakumbuh','id','Sumatera Barat',121652.0,100.63,-0.22).
city('Sijunjung','id','Sumatera Barat',27787.0,100.97,-0.7).
city('Solok','id','Sumatera Barat',48373.0,100.66,-0.79).
city('Baturaja','id','Sumatera Selatan',134824.0,104.17,-4.13).
city('Lahat','id','Sumatera Selatan',65903.0,103.54,-3.79).
city('Lubuk Linggau','id','Sumatera Selatan',148314.0,102.85,-3.29).
city('Pagar Alam','id','Sumatera Selatan',70383.0,103.28,-4.02).
city('Palembang','id','Sumatera Selatan',1241334.0,104.75,-2.99).
city('Prabumulih','id','Sumatera Selatan',103476.0,104.23,-3.44).
city('Tanjung Agung','id','Sumatera Selatan',53114.0,103.8,-3.93).
city('Bandar','id','Sumatera Utara',31443.0,99.75,2.05).
city('Belawan','id','Sumatera Utara',102709.0,98.69,3.79).
city('Binjai','id','Sumatera Utara',228794.0,98.48,3.6).
city('Deli Tua','id','Sumatera Utara',27944.0,98.68,3.5).
city('Gunung Stoli','id','Sumatera Utara',24788.0,97.61,1.28).
city('Hamparan Perak','id','Sumatera Utara',149586.0,98.62,3.72).
city('Kabanjahe','id','Sumatera Utara',57160.0,98.48,3.1).
city('Kisaran','id','Sumatera Utara',129928.0,99.62,2.99).
city('Kota Pinang','id','Sumatera Utara',76142.0,100.08,1.9).
city('Labuhan Deli','id','Sumatera Utara',49675.0,98.68,3.75).
city('Lubuk Pakam','id','Sumatera Utara',87457.0,98.87,3.56).
city('Medan','id','Sumatera Utara',1751190.0,98.67,3.59).
city('Padang Sidempuan','id','Sumatera Utara',100575.0,99.27,1.39).
city('Pangkalanbrandan','id','Sumatera Utara',25543.0,98.28,4.02).
city('Pematang Siantar','id','Sumate',209636.0,99.06,2.96).
city('Perbaungan','id','Sumatera Utara',157378.0,98.95,3.57).
city('Percut Sei Tuan','id','Sumatera Utara',311105.0,98.75,3.68).
city('Rantauprapat','id','Sumatera Utara',103011.0,99.82,2.1).
city('Sibolga','id','Sumatera Utara',79725.0,98.78,1.74).
city('Stabat','id','Sumatera Utara',26863.0,98.47,3.75).
city('Sunggal','id','Sumatera Utara',157936.0,98.61,3.55).
city('Tanjung Balai','id','Sumatera Utara',142526.0,99.8,2.97).
city('Tanjung Morawa','id','Sumatera Utara',157908.0,98.82,3.52).
city('Tanjung Tiram','id','Sumatera Utara',25118.0,98.38,4.05).
city('Tebingtinggi','id','Sumatera Utara',117547.0,99.14,3.33).
city('Teluk Nibung','id','Sumatera Utara',25146.0,99.81,3.02).
city('Bambanglipuro','id','Yogyakarta',44717.0,110.28,-7.95).
city('Bantul','id','Yogyakarta',58658.0,110.33,-7.88).
city('Depok','id','Yogyakarta',104537.0,110.41,-7.75).
city('Gamping','id','Yogyakarta',66116.0,110.31,-7.78).
city('Godean','id','Yogyakarta',63170.0,110.3,-7.77).
city('Jetis','id','Yogyakarta',49292.0,110.22,-7.68).
city('Kasihan','id','Yogyakarta',86242.0,110.32,-7.82).
city('Mlati','id','Yogyakarta',67092.0,110.36,-7.73).
city('Ngaglik','id','Yogyakarta',34328.0,110.38,-7.7).
city('Pandak','id','Yogyakarta',56048.0,110.29,-7.91).
city('Pundong','id','Yogyakarta',24082.0,110.35,-7.95).
city('Sewon','id','Yogyakarta',73592.0,110.35,-7.88).
city('Seyegan','id','Yogyakarta',23427.0,110.3,-7.71).
city('Sleman','id','Yogyakarta',56216.0,110.33,-7.71).
city('Srandakan','id','Yogyakarta',29532.0,110.25,-7.93).
city('Wonosari','id','Yogyakarta',27458.0,110.6,-7.96).
city('Yogyakarta','id','Yogyakarta',636711.0,110.37,-7.78).
city('Ardabil','ir','Ardabil',410773.0,48.3,38.25).
city('Garmi','ir','Ardabil',39985.0,48.05,39.02).
city('Khalkhal','ir','Ardabil',51028.0,48.52,37.63).
city('Meshkinshahr','ir','Ardabil',72334.0,47.68,38.38).
city('Parsabad','ir','Ardabil',101715.0,47.93,39.65).
city('Bukan','ir','Azarbayejan-e Gharbi',213349.0,46.2,36.53).
city('Khoy','ir','Azarbayejan-e Gharbi',175386.0,44.97,38.53).
city('Mahabad','ir','Azarbayejan-e Gharbi',162448.0,45.72,36.77).
city('Maku','ir','Azarbayejan-e Gharbi',41517.0,44.5,39.3).
city('Miandoab','ir','Azarbayejan-e Gharbi',132830.0,46.1,36.97).
city('Naqadeh','ir','Azarbayejan-e Gharbi',73535.0,45.37,36.95).
city('Orumiyeh','ir','Azarbayejan-e Gharbi',602443.0,45.0,37.53).
city('Oshnaviyeh','ir','Azarbayejan-e Gharbi',50692.0,45.1,37.05).
city('Piranshahr','ir','Azarbayejan-e Gharbi',61420.0,45.13,36.7).
city('Qarahziyaeddin','ir','Azarbayejan-e Gharbi',31950.0,45.03,38.88).
city('Salmas','ir','Azarbayejan-e Gharbi',81614.0,44.75,38.18).
city('Sardasht','ir','Azarbayejan-e Gharbi',47641.0,45.53,36.15).
city('Shahindezh','ir','Azarbayejan-e Gharbi',41446.0,46.55,36.67).
city('Takab','ir','Azarbayejan-e Gharbi',51546.0,47.1,36.41).
city('Ahar','ir','Azarbayejan-e Sharqi',94355.0,47.06,38.47).
city('Ajabshir','ir','Azarbayejan-e Sharqi',29677.0,45.91,37.48).
city('Azar Shahr','ir','Azarbayejan-e Sharqi',37349.0,45.97,37.76).
city('Bonab','ir','Azarbayejan-e Sharqi',80365.0,46.05,37.33).
city('Hadishahr','ir','Azarbayejan-e Sharqi',26226.0,45.63,38.87).
city('Hashtrud','ir','Azarbayejan-e Sharqi',16888.0,47.06,37.47).
city('Malekan','ir','Azarbayejan-e Sharqi',24412.0,46.53,38.07).
city('Maragheh','ir','Azarbayejan-e Sharqi',168290.0,46.22,37.42).
city('Marand','ir','Azarbayejan-e Sharqi',124201.0,45.77,38.43).
city('Mianeh','ir','Azarbayejan-e Sharqi',91039.0,47.7,37.33).
city('Sarab','ir','Azarbayejan-e Sharqi',37771.0,47.57,37.95).
city('Tabriz','ir','Azarbayejan-e Sharqi',1424701.0,46.3,38.08).
city('Bandar-e Gonaveh','ir','Bushehr',52755.0,50.52,29.57).
city('Borazjan','ir','Bushehr',86067.0,51.2,29.27).
city('Bushehr','ir','Bushehr',157778.0,50.83,28.92).
city('Dashti','ir','Bushehr',22701.0,51.37,28.65).
city('Dir','ir','Bushehr',15778.0,51.85,27.83).
city('Khormuj','ir','Bushehr',29886.0,51.37,28.66).
city('Kongan','ir','Bushehr',16261.0,52.07,27.83).
city('Tangestan','ir','Bushehr',12558.0,51.27,28.88).
city('Borujan','ir','Chahar Mahal-e Bakhtiari',52660.0,51.29,31.97).
city('Farrokhshahr','ir','Chahar Mahal-e Bakhtiari',32396.0,50.98,32.27).
city('Farsan','ir','Chahar Mahal-e Bakhtiari',25074.0,50.57,32.27).
city('Shahr-e Kord','ir','Chahar Mahal-e Bakhtiari',129167.0,50.85,32.32).
city('Ardistan','ir','Esfahan',16058.0,52.37,33.38).
city('Dorchehpiyaz','ir','Esfahan',37466.0,51.55,32.62).
city('Dowlatabad','ir','Esfahan',33610.0,51.7,32.8).
city('Esfahan','ir','Esfahan',1547241.0,51.68,32.68).
city('Falavarjan','ir','Esfahan',49847.0,51.49,32.57).
city('Faridan','ir','Esfahan',15737.0,50.37,32.95).
city('Fereydunshahr','ir','Esfahan',11562.0,50.12,32.93).
city('Fuladshahr','ir','Esfahan',44440.0,51.38,32.43).
city('Golara','ir','Esfahan',65869.0,51.44,32.63).
city('Golpayegan','ir','Esfahan',44920.0,50.28,33.45).
city('Kashan','ir','Esfahan',301107.0,51.5,33.98).
city('Kelishad','ir','Esfahan',33633.0,51.55,32.54).
city('Khomeynishahr','ir','Esfahan',277355.0,51.47,32.7).
city('Khonsar','ir','Esfahan',21148.0,50.31,33.22).
city('Khuresgan','ir','Esfahan',71732.0,51.75,32.65).
city('Mobarakeh','ir','Esfahan',64904.0,51.66,32.49).
city('Nain','ir','Esfahan',25739.0,53.08,32.87).
city('Najafabad','ir','Esfahan',223468.0,51.35,32.67).
city('Natnaz','ir','Esfahan',10920.0,51.9,33.52).
city('Qahdarijan','ir','Esfahan',29394.0,51.45,32.57).
city('Rehnan','ir','Esfahan',49147.0,51.6,32.69).
city('Semirom','ir','Esfahan',27222.0,51.57,31.42).
city('Shahinshahr','ir','Esfahan',141055.0,51.54,32.81).
city('Shahreza','ir','Esfahan',100806.0,51.87,32.02).
city('Zarinshahr','ir','Esfahan',57186.0,51.59,32.45).
city('Abadeh','ir','Fars',56993.0,52.67,31.18).
city('Akbarabad','ir','Fars',98342.0,52.77,29.24).
city('Darab','ir','Fars',63324.0,54.54,28.75).
city('Eqlid','ir','Fars',42089.0,52.71,31.01).
city('Estehban','ir','Fars',32801.0,54.04,29.12).
city('Fasa','ir','Fars',98068.0,53.68,28.97).
city('Firuzabad','ir','Fars',66563.0,52.6,28.87).
city('Gerash','ir','Fars',25318.0,54.1,27.67).
city('Jahrom','ir','Fars',107910.0,53.57,28.55).
city('Kazerun','ir','Fars',94518.0,51.67,29.6).
city('Lar','ir','Fars',71744.0,54.28,27.68).
city('Marv Dasht','ir','Fars',129483.0,52.83,29.8).
city('Neyriz','ir','Fars',45509.0,54.33,29.2).
city('Nurabad','ir','Fars',64046.0,51.53,30.11).
city('Sepidan','ir','Fars',14211.0,52.02,30.27).
city('Shiraz','ir','Fars',1249972.0,52.57,29.63).
city('Astaneh-ye Ashrafiyeh','ir','Gilan',42787.0,49.98,37.27).
city('Astara','ir','Gilan',39067.0,48.85,38.43).
city('Bandar-e Anzali','ir','Gilan',110834.0,49.45,37.47).
city('Fawman','ir','Gilan',37991.0,49.29,37.23).
city('Lahijan','ir','Gilan',64959.0,50.0,37.2).
city('Langarud','ir','Gilan',68153.0,50.15,37.18).
city('Rasht','ir','Gilan',594619.0,49.63,37.3).
city('Rudbar','ir','Gilan',17085.0,49.42,36.85).
city('Rudsar','ir','Gilan',47506.0,50.3,37.13).
city('Sawmaeh Sara','ir','Gilan',40535.0,49.32,37.28).
city('Talesh','ir','Gilan',45309.0,48.92,37.8).
city('Aq Qaleh','ir','Golestan',28288.0,54.45,37.02).
city('Azad Shahr','ir','Golestan',47594.0,55.16,37.09).
city('Bandar-e Torkaman','ir','Golestan',48658.0,54.07,36.88).
city('Gonbad-e Qabus','ir','Golestan',131427.0,55.17,37.25).
city('Gorgan','ir','Golestan',244955.0,54.48,36.83).
city('Kalaleh','ir','Golestan',33703.0,55.5,37.39).
city('Kordkuy','ir','Golestan',31346.0,54.12,36.8).
city('Minudasht','ir','Golestan',27988.0,55.37,37.22).
city('Asadabad','ir','Hamadan',59622.0,48.11,34.79).
city('Bahar','ir','Hamadan',28647.0,48.43,34.9).
city('Hamadan','ir','Hamadan',514134.0,48.58,34.77).
city('Nahavand','ir','Hamadan',76258.0,48.37,34.2).
city('Tuysarkan','ir','Hamadan',48165.0,48.44,34.55).
city('Bandar-e Abbas','ir','Hormozgan',317971.0,56.25,27.25).
city('Bandar-e Lengeh','ir','Hormozgan',22771.0,54.9,26.55).
city('Jask','ir','Hormozgan',16468.0,57.52,25.75).
city('Minab','ir','Hormozgan',70796.0,57.07,27.15).
city('Qeshm','ir','Hormozgan',16691.0,56.2,26.95).
city('Abdanan','ir','Ilam',19362.0,47.47,32.94).
city('Darrehshahr','ir','Ilam',11577.0,47.4,33.15).
city('Dehloran','ir','Ilam',46109.0,47.26,32.69).
city('Ilam','ir','Ilam',140951.0,46.43,33.63).
city('Mehran','ir','Ilam',11831.0,46.17,33.12).
city('Baft','ir','Kerman',43081.0,56.6,29.28).
city('Bam','ir','Kerman',99276.0,58.35,29.08).
city('Bardsir','ir','Kerman',37195.0,56.56,29.93).
city('Jiroft','ir','Kerman',111560.0,57.73,28.67).
city('Kahnuj','ir','Kerman',42856.0,57.7,27.87).
city('Kerman','ir','Kerman',577547.0,57.08,30.3).
city('Rafsanjan','ir','Kerman',147691.0,56.02,30.42).
city('Ravar','ir','Kerman',40170.0,56.81,31.27).
city('Shahr-e Babak','ir','Kerman',52413.0,55.15,30.13).
city('Sirjan','ir','Kerman',207661.0,55.73,29.47).
city('Zarand','ir','Kerman',58987.0,56.58,30.8).
city('Eslamabad','ir','Kermanshah',81513.0,47.12,34.32).
city('Gilan-e Garb','ir','Kermanshah',11979.0,45.92,34.13).
city('Harsin','ir','Kermanshah',57652.0,47.6,34.26).
city('Javanrud','ir','Kermanshah',38660.0,46.52,34.8).
city('Kangavar','ir','Kermanshah',53418.0,47.95,34.5).
city('Kermanshah','ir','Kermanshah',766742.0,47.06,34.38).
city('Paveh','ir','Kermanshah',17779.0,46.37,35.05).
city('Sahneh','ir','Kermanshah',32980.0,47.69,34.48).
city('Sar-e-Pol-e-Zohab','ir','Kermanshah',51816.0,45.85,34.47).
city('Sonqor','ir','Kermanshah',43177.0,47.6,34.78).
city('Birjand','ir','Khorasan',197004.0,59.22,32.88).
city('Bojnurd','ir','Khorasan',192062.0,57.32,37.47).
city('Chenaran','ir','Khorasan',46945.0,59.1,36.65).
city('Dargaz','ir','Khorasan',39988.0,59.1,37.45).
city('Esfarayen','ir','Khorasan',59685.0,57.5,37.1).
city('Fariman','ir','Khorasan',32874.0,59.88,35.72).
city('Ferdus','ir','Khorasan',29787.0,58.17,34.02).
city('Gonabad','ir','Khorasan',43470.0,58.68,34.35).
city('Kashmar','ir','Khorasan',96162.0,58.45,35.18).
city('Mashhad','ir','Khorasa',2307254.0,59.57,36.27).
city('Neyshabur','ir','Khorasan',220954.0,58.82,36.22).
city('Qaen','ir','Khorasan',40161.0,59.18,33.73).
city('Qanat','ir','Khorasan',18768.0,59.2,33.72).
city('Quchan','ir','Khorasan',111765.0,58.5,37.12).
city('Sabzevar','ir','Khorasan',226208.0,57.63,36.22).
city('Sarakhs','ir','Khorasan',46505.0,61.17,36.54).
city('Shirvan','ir','Khorasan',98688.0,57.92,37.45).
city('Tabas','ir','Khorasan',49999.0,56.92,33.6).
city('Taybad','ir','Khorasan',37517.0,60.77,34.74).
city('Torbat-e Heydariyeh','ir','Khorasan',125648.0,59.22,35.28).
city('Torbat-e Jam','ir','Khorasan',58935.0,60.62,35.22).
city('Abadan','ir','Khuzestan',370220.0,48.28,30.33).
city('Agha Jari','ir','Khuzestan',22019.0,49.83,30.7).
city('Ahvaz','ir','Khuzestan',854980.0,48.72,31.28).
city('Andimeshk','ir','Khuzestan',167228.0,48.35,33.45).
city('Bandar-e Emam Khomeyni','ir','Khuzestan',48066.0,49.08,30.43).
city('Bandar-e Mahshahr','ir','Khuzestan',96393.0,49.22,30.65).
city('Behbahan','ir','Khuzestan',79335.0,50.27,30.58).
city('Dezful','ir','Khuzestan',212367.0,48.47,32.38).
city('Ezeh','ir','Khuzestan',107547.0,49.9,31.8).
city('Hendijan','ir','Khuzestan',20703.0,49.72,30.24).
city('Khorramshahr','ir','Khuzestan',331254.0,48.18,30.43).
city('Masjed-e Soleyman','ir','Khuzestan',111522.0,49.3,31.98).
city('Omidiyeh','ir','Khuzestan',47048.0,49.71,30.75).
city('Ramhormoz','ir','Khuzestan',38825.0,49.62,31.27).
city('Ramshir','ir','Khuzestan',19456.0,49.41,30.9).
city('Shadegan','ir','Khuzestan',37224.0,48.67,30.65).
city('Shush','ir','Khuzestan',52290.0,48.24,32.19).
city('Shushtar','ir','Khuzestan',77515.0,48.83,32.05).
city('Susangerd','ir','Khuzestan',41447.0,48.17,31.55).
city('Deh Dasht','ir','Kohgiluyeh-e Boyerahmad',69732.0,50.55,30.79).
city('Do Gonbadan','ir','Kohgiluyeh-e Boyerahmad',94646.0,50.78,30.36).
city('Kehgiluyeh','ir','Kohgiluyeh-e Boyerahmad',29347.0,50.5,30.87).
city('Yasuj','ir','Kohgiluyeh-e Boyerahmad',135220.0,51.68,30.82).
city('Baneh','ir','Kordestan',104939.0,45.92,35.98).
city('Bijar','ir','Kordestan',53875.0,47.6,35.87).
city('Kamyaran','ir','Kordestan',61647.0,46.94,34.8).
city('Marivan','ir','Kordestan',111495.0,46.2,35.45).
city('Qorveh','ir','Kordestan',87960.0,47.8,35.17).
city('Sanandaj','ir','Kordestan',349200.0,47.02,35.3).
city('Saqqez','ir','Kordestan',151249.0,46.28,36.23).
city('Alashtar','ir','Lorestan',27703.0,48.25,33.87).
city('Aligudarz','ir','Lorestan',91048.0,49.72,33.37).
city('Azna','ir','Lorestan',47485.0,48.96,33.6).
city('Borujerd','ir','Lorestan',251976.0,48.8,33.92).
city('Do Rud','ir','Lorestan',114404.0,49.05,33.49).
city('Khorramabad','ir','Lorestan',329847.0,48.35,33.48).
city('Kuhdasht','ir','Lorestan',100216.0,47.6,33.53).
city('Nurabad','ir','Lorestan',73534.0,47.97,34.08).
city('Arak','ir','Markazi',503673.0,49.7,34.08).
city('Ashtian','ir','Markazi',11020.0,50.0,34.55).
city('Delijan','ir','Markazi',33510.0,50.68,33.98).
city('Khomeyn','ir','Markazi',77431.0,50.05,33.63).
city('Mahallat','ir','Markazi',35704.0,50.5,33.88).
city('Sarband','ir','Markazi',14458.0,49.42,33.93).
city('Saveh','ir','Markazi',175545.0,50.33,35.02).
city('Tafresh','ir','Markazi',14399.0,50.02,34.68).
city('Aliabad','ir','Mazandaran',50888.0,54.87,36.9).
city('Amir Kala','ir','Mazandaran',22896.0,52.71,36.62).
city('Amol','ir','Mazandaran',199398.0,52.4,36.43).
city('Babol','ir','Mazandaran',202812.0,52.7,36.53).
city('Babol Sar','ir','Mazandaran',48056.0,52.64,36.71).
city('Behshahr','ir','Mazandaran',93508.0,53.55,36.72).
city('Chalus','ir','Mazandaran',69644.0,51.41,36.66).
city('Fereydun Kenar','ir','Mazandaran',34100.0,52.53,36.68).
city('Juybar','ir','Mazandaran',28406.0,52.9,36.64).
city('Mahmudabad','ir','Mazandaran',32184.0,52.25,36.63).
city('Neka','ir','Mazandaran',48851.0,53.29,36.66).
city('Nur','ir','Mazandaran',13529.0,52.03,36.63).
city('Nushahr','ir','Mazandaran',39923.0,51.55,36.65).
city('Qaemshahr','ir','Mazandaran',181631.0,52.87,36.47).
city('Ramsar','ir','Mazandaran',31976.0,50.67,36.9).
city('Sari','ir','Mazandaran',255416.0,53.1,36.55).
city('Savadkuh','ir','Mazandaran',6692.0,53.05,36.12).
city('Tonekabon','ir','Mazandaran',37504.0,50.88,36.82).
city('Abhar','ir','Qazvin',69894.0,49.22,36.15).
city('Abyek','ir','Qazvin',55132.0,50.53,36.05).
city('Qazvin','ir','Qazvin',333652.0,50.0,36.27).
city('Takestan','ir','Qazvin',71504.0,49.7,36.07).
city('Qom','ir','Qom',1011103.0,50.95,34.65).
city('Damghan','ir','Semnan',67698.0,54.35,36.17).
city('Garmsar','ir','Semnan',49494.0,52.33,35.22).
city('Semnan','ir','Semnan',124831.0,53.38,35.55).
city('Shahrud','ir','Semnan',131895.0,54.97,36.42).
city('Chabahar','ir','Sistan-e Baluchestan',47291.0,60.63,25.3).
city('Iranshahr','ir','Sistan-e Baluchestan',131242.0,60.7,27.2).
city('Khash','ir','Sistan-e Baluchestan',69608.0,61.23,28.22).
city('Saravan','ir','Sistan-e Baluchestan',62158.0,62.58,27.4).
city('Zabol','ir','Sistan-e Baluchestan',121999.0,61.48,31.02).
city('Zahedan','ir','Sistan-e Baluchestan',552015.0,60.83,29.5).
city('Damavand','ir','Tehran',29147.0,52.07,35.72).
city('Eqbaliyeh','ir','Tehran',36709.0,51.54,35.3).
city('Eslamshahr','ir','Tehran',318855.0,51.2,35.54).
city('Hashtgerd','ir','Tehran',57128.0,50.66,35.97).
city('Karaj','ir','Tehran',1448996.0,50.97,35.8).
city('Mahdasht','ir','Tehran',37076.0,50.82,35.72).
city('Malard','ir','Tehran',56790.0,50.99,35.67).
city('Mohammadiyeh','ir','Tehran',32610.0,51.55,35.29).
city('Nazarabad','ir','Tehran',213706.0,50.6,35.95).
city('Pakdasht','ir','Tehran',57416.0,51.7,35.47).
city('Pishva','ir','Tehran',53861.0,51.73,35.3).
city('Qarchak','ir','Tehran',251857.0,51.58,35.42).
city('Qods','ir','Tehran',272852.0,51.18,35.73).
city('Robat Karim','ir','Tehran',62759.0,51.08,35.48).
city('Shahriyar','ir','Tehran',58855.0,51.06,35.66).
city('Tehran','ir','Tehran',7157993.0,51.43,35.67).
city('Varamin','ir','Tehran',179620.0,51.65,35.32).
city('Ardakan','ir','Yazd',58840.0,54.01,32.32).
city('Bafq','ir','Yazd',31218.0,55.4,31.58).
city('Mehriz','ir','Yazd',36723.0,54.45,31.58).
city('Meybod','ir','Yazd',51879.0,54.01,32.23).
city('Taft','ir','Yazd',19394.0,54.22,31.73).
city('Yazd','ir','Yazd',477926.0,54.37,31.92).
city('Alvand','ir','Zanjan',74899.0,49.16,36.32).
city('Khorramdarreh','ir','Zanjan',50531.0,49.18,36.2).
city('Zanjan','ir','Zanjan',357489.0,48.5,36.67).
city('Jurf-as-Sahzr','iq','Babil',16287.0,44.22,32.87).
city('Saddat-al-Hindiyah','iq','Babil',30717.0,44.26,32.7).
city('al-Hillah','iq','Babil',289714.0,44.46,32.48).
city('al-Madhatiyah','iq','Babil',20378.0,44.67,32.4).
city('al-Musayyib','iq','Babil',43034.0,44.3,32.78).
city('al-Qasim','iq','Babil',37107.0,44.68,32.3).
city('Baghdad','iq','Baghdad',5672516.0,44.44,33.33).
city('Dahuk','iq','Dahuk',129127.0,43.02,36.85).
city('Zahzu','iq','Dahuk',95336.0,42.7,37.14).
city('Qalat Sukkar','iq','Di Qar',25217.0,46.07,31.86).
city('Suq-as-Suyuhz','iq','Di Qar',69696.0,46.47,30.88).
city('an-Nasiriyah','iq','Di Qar',400254.0,46.26,31.04).
city('ar-Rifai','iq','Di Qar',25236.0,46.11,31.73).
city('as-Satrah','iq','Di Qar',83006.0,46.17,31.41).
city('Baqubah','iq','Diyala',152552.0,44.64,33.75).
city('Hanaqin','iq','Diyala',70271.0,45.38,34.35).
city('Jalula','iq','Diyala',44629.0,45.16,34.27).
city('Kifri','iq','Diyala',30241.0,44.97,34.7).
city('Mandali','iq','Diyala',29882.0,45.55,33.75).
city('al-Fuhud','iq','Diyala',21622.0,46.71,30.97).
city('al-Hzalis','iq','Diyala',70265.0,44.52,33.86).
city('al-Miqdadiyah','iq','Diyala',50860.0,44.92,33.97).
city('Irbil','iq','Irbil',932854.0,44.02,36.19).
city('Rawanduz','iq','Irbil',23030.0,44.5,36.62).
city('Saqlawah','iq','Irbil',50410.0,45.43,35.47).
city('Karbala','iq','Karbala',434457.0,44.08,32.61).
city('al-Hindiyah','iq','Karbala',57673.0,44.22,32.55).
city('Ali al Garbi','iq','Maysan',19779.0,46.68,32.46).
city('al-Amarah','iq','Maysan',323308.0,47.17,31.85).
city('al-Majarr-al-Kabir','iq','Maysan',35635.0,47.17,31.57).
city('Sinjar','iq','Ninawa',38437.0,41.86,36.32).
city('Tall Afar','iq','Ninawa',179160.0,42.45,36.38).
city('Tall Kayf','iq','Ninawa',23613.0,43.13,36.48).
city('al-Hamdaniyah','iq','Ninawa',28554.0,43.38,36.27).
city('al-Mawsil','iq','Ninawa',2066370.0,43.14,36.34).
city('as-Sayhzan','iq','Ninawa',74635.0,43.45,36.77).
city('Balad','iq','Salah-ad-Din',42227.0,44.15,34.02).
city('Bayji','iq','Salah-ad-Din',36574.0,43.48,34.94).
city('Daluiyah','iq','Salah-ad-Din',20306.0,44.12,34.1).
city('Samarra','iq','Salah-ad-Din',158968.0,43.87,34.2).
city('Tikrit','iq','Salah-ad-Din',42616.0,43.68,34.61).
city('Tuz Khurmatu','iq','Salah-ad-Din',60080.0,44.64,34.89).
city('ad-Dujayl','iq','Salah-ad-Din',26450.0,44.23,33.85).
city('al-Aziziyah','iq','Wasit',44911.0,45.07,32.91).
city('al-Hayy','iq','Wasit',78541.0,64.03,32.17).
city('al-Kut','iq','Wasit',315167.0,45.82,32.5).
city('an-Numaniyah','iq','Wasit',46560.0,45.41,32.54).
city('as-Suwayrah','iq','Wasit',42505.0,44.78,32.92).
city('Anah','iq','al-Anbar',19786.0,41.93,34.47).
city('Hit','iq','al-Anbar',32008.0,42.83,33.65).
city('Rawah','iq','al-Anbar',20649.0,41.91,34.46).
city('al-Fallujah','iq','al-Anbar',190705.0,43.77,33.36).
city('al-Habba','iq','al-Anbar',66759.0,43.57,33.39).
city('al-Haditzah','iq','al-Anbar',31029.0,42.37,34.14).
city('ar-Ramadi','iq','al-Anbar',274543.0,43.31,33.43).
city('ar-Rutbah','iq','al-Anbar',22446.0,40.3,33.04).
city('Abu al-Hzasib','iq','al-Basrah',85895.0,47.98,30.45).
city('al-Basrah','iq','al-Basrah',2016217.0,47.83,30.5).
city('al-Faw','iq','al-Basrah',105080.0,48.46,29.99).
city('al-Haritzah','iq','al-Basrah',92848.0,47.73,30.73).
city('az-Zubayr','iq','al-Basrah',122789.0,47.71,30.39).
city('ar-Rumaytzah','iq','al-M',47408.0,45.22,31.53).
city('as-Samawah','iq','al-Mutzanna',153298.0,45.28,31.32).
city('Afak','iq','al-Qadisiyah',21965.0,45.26,32.07).
city('ad-Diwaniyah','iq','al-Qadisiyah',318806.0,44.93,32.0).
city('al-Gammas','iq','al-Qadisiyah',31018.0,44.62,31.75).
city('al-Hamzah','iq','al-Qadisiyah',43167.0,44.98,31.73).
city('as-Samiyah','iq','al-Qadisiyah',57858.0,44.59,31.96).
city('as-Sinafiyah','iq','al-Qadisiyah',22724.0,44.63,31.58).
city('al-Kufah','iq','an-Najaf',127876.0,44.34,32.09).
city('al-Mishzab','iq','an-Najaf',23270.0,44.5,31.8).
city('an-Najaf','iq','an-Najaf',482583.0,44.33,31.99).
city('Camcamal','iq','as-Sulaymaniyah',75913.0,44.84,35.54).
city('Halubcah','iq','as-Sulaymaniyah',57548.0,45.98,35.18).
city('Kusanjaq','iq','as-Sulaymaniyah',45158.0,44.64,36.09).
city('Panjwin','iq','as-Sulaymaniyah',27219.0,45.97,35.61).
city('Qalat Dizah','iq','as-Sulaymaniyah',24847.0,45.12,36.18).
city('as-Sulaymaniyah','iq','as-Sulaymaniyah',723246.0,45.45,35.55).
city('Aqrah','iq','at-Tamim',34895.0,43.91,36.76).
city('Kirkuk','iq','at-Tamim',601442.0,44.41,35.47).
city('Bagenalstown','ie','Carlow',3033.0,-6.96,52.7).
city('Carlow','ie','Carlow',20055.0,-6.92,52.84).
city('Muinebeag','ie','Carlow',2820.0,-6.95,52.7).
city('Tullow','ie','Carlow',2424.0,-6.74,52.8).
city('Bailieborough','ie','Cavan',1703.0,-6.98,53.92).
city('Belturbet','ie','Cavan',1277.0,-7.45,54.1).
city('Cavan','ie','Cavan',6388.0,-7.37,54.0).
city('Cootehill','ie','Cavan',1713.0,-7.09,54.07).
city('Ennis','ie','Clare',24427.0,-8.99,52.86).
city('Kilrush','ie','Clare',2712.0,-9.49,52.63).
city('Newmarket-on-Fergus','ie','Clare',1754.0,-8.9,52.76).
city('Shannon','ie','Clare',8781.0,-8.92,52.7).
city('Bandon','ie','Cork',5493.0,-8.74,51.75).
city('Bantry','ie','Cork',3234.0,-9.5,51.66).
city('Blarney','ie','Cork',2215.0,-8.57,51.94).
city('Carrigaline','ie','Cork',12902.0,-8.39,51.81).
city('Charleville','ie','Cork',2674.0,-8.68,52.35).
city('Clonakilty','ie','Cork',4065.0,-8.89,51.62).
city('Cobh','ie','Cork',10501.0,-8.3,51.0).
city('Cork','ie','Cork',188908.0,-8.47,51.9).
city('Dunmanway','ie','Cork',1566.0,-9.12,51.72).
city('Fermoy','ie','Cork',4933.0,-8.28,52.13).
city('Kanturk','ie','Cork',1628.0,-8.9,52.17).
city('Kinsale','ie','Cork',3843.0,-8.53,51.7).
city('Macroom','ie','Cork',3169.0,-8.95,51.9).
city('Mallow','ie','Cork',9495.0,-8.66,52.14).
city('Midleton','ie','Cork',8891.0,-8.17,51.92).
city('Mitchelstown','ie','Cork',3357.0,-8.27,52.27).
city('Passage West','ie','Cork',4907.0,-8.34,51.87).
city('Skibbereen','ie','Cork',2098.0,-9.28,51.56).
city('Tower','ie','Cork',3099.0,-8.6,51.92).
city('Youghal','ie','Cork',6868.0,-7.85,51.95).
city('Ballybofey','ie','Donegal',3848.0,-7.79,54.8).
city('Ballyshannon','ie','Donegal',2683.0,-8.21,54.51).
city('Buncrana','ie','Donegal',5546.0,-7.45,55.14).
city('Bundoran','ie','Donegal',1865.0,-8.29,54.48).
city('Carndonagh','ie','Donegal',1581.0,-7.27,55.25).
city('Donegal','ie','Donegal',2513.0,-8.12,54.66).
city('Killybegs','ie','Donegal',1725.0,-8.47,54.64).
city('Letterkenny','ie','Donegal',16903.0,-7.74,54.94).
city('Lifford','ie','Donegal',1617.0,-7.49,54.84).
city('Moville','ie','Donegal',1402.0,-7.06,55.19).
city('Balbriggan','ie','Dublin',11293.0,-6.19,53.61).
city('Donabate','ie','Dublin',3936.0,-6.15,53.48).
city('Dublin','ie','Dublin',1024027.0,-6.25,53.33).
city('Kinsealy-Drinan','ie','Dublin',2155.0,-6.19,53.42).
city('Leixlip','ie','Dublin',15729.0,-6.49,53.37).
city('Lusk','ie','Dublin',2508.0,-6.17,53.52).
city('Malahide','ie','Dublin',14057.0,-6.16,53.45).
city('Portmarnock','ie','Dublin',8037.0,-6.14,53.42).
city('Portrane','ie','Dublin',1763.0,-6.11,53.49).
city('Rathcoole','ie','Dublin',2443.0,-6.47,53.27).
city('Rush','ie','Dublin',7294.0,-6.11,53.52).
city('Skerries','ie','Dublin',10014.0,-6.11,53.58).
city('Swords','ie','Dublin',29816.0,-6.22,53.45).
city('Athenry','ie','Galway',2419.0,-8.76,53.3).
city('Ballinasloe','ie','Galway',6388.0,-8.24,53.33).
city('Galway','ie','Galway',70686.0,-9.06,53.28).
city('Gort','ie','Galway',2098.0,-8.82,53.07).
city('Loughrea','ie','Galway',4296.0,-8.57,53.2).
city('Oranmore','ie','Galway',1758.0,-8.93,53.27).
city('Tuam','ie','Galway',6130.0,-8.86,53.52).
city('Ballybunion','ie','Kerry',1626.0,-9.68,52.52).
city('Cahirciveen','ie','Kerry',1409.0,-10.22,51.97).
city('Castleisland','ie','Kerry',2122.0,-9.47,52.24).
city('Dingle','ie','Kerry',1971.0,-10.25,52.13).
city('Kenmare','ie','Kerry',2023.0,-9.59,51.88).
city('Killarney','ie','Kerry',13814.0,-9.52,53.06).
city('Killorglin','ie','Kerry',1409.0,-9.79,52.1).
city('Listowel','ie','Kerry',4143.0,-9.49,52.45).
city('Tralee','ie','Kerry',22941.0,-9.72,52.28).
city('Athy','ie','Kildare',6382.0,-6.99,52.99).
city('Celbridge','ie','Kildare',18167.0,-6.55,53.33).
city('Clane','ie','Kildare',5155.0,-6.69,53.29).
city('Kilcock','ie','Kildare',3293.0,-6.67,53.4).
city('Kilcullen','ie','Kildare',2110.0,-6.74,53.12).
city('Kildare','ie','Kildare',6380.0,-6.99,53.16).
city('Maynooth','ie','Kildare',11318.0,-6.6,53.38).
city('Monasterevan','ie','Kildare',2704.0,-7.06,53.14).
city('Naas','ie','Kildare',20554.0,-6.68,53.22).
city('Newbridge','ie','Kildare',18860.0,-6.8,53.18).
city('Prosperous','ie','Kildare',1649.0,-6.75,53.29).
city('Rathangan','ie','Kildare',1961.0,-6.99,53.22).
city('Sallins','ie','Kildare',3164.0,-6.67,53.25).
city('Castlecomer','ie','Kilkenny',1686.0,-7.22,52.8).
city('Kilkenny','ie','Kilkenny',21589.0,-7.26,52.66).
city('Thomastown','ie','Kilkenny',1603.0,-7.14,52.52).
city('Abbeyleix','ie','Laois',1711.0,-7.35,52.9).
city('Mountmellick','ie','Laois',3547.0,-7.33,53.12).
city('Mountrath','ie','Laois',1597.0,-7.47,53.01).
city('Portarlington','ie','Laois',4293.0,-7.19,53.16).
city('Portlaoighise','ie','Laois',13622.0,-7.3,53.04).
city('Carrick-on-Shannon','ie','Leitrim',2389.0,-8.1,53.95).
city('Abbeyfeale','ie','Limerick',1734.0,-9.3,52.39).
city('Kilmallock','ie','Limerick',1523.0,-8.59,52.4).
city('Limerick','ie','Limerick',90054.0,-8.63,52.67).
city('Newcastle','ie','Limerick',4184.0,-9.06,52.45).
city('Rathkeale','ie','Limerick',1470.0,-8.94,52.52).
city('Granard','ie','Longford',1292.0,-7.5,53.77).
city('Longford','ie','Longford',7787.0,-7.81,53.73).
city('Moate','ie','Longford',1504.0,-7.72,53.56).
city('Ardee','ie','Louth',4008.0,-6.55,53.86).
city('Drogheda','ie','Louth',33441.0,-6.36,53.72).
city('Dundalk','ie','Louth',33428.0,-6.42,54.02).
city('Ballina','ie','Mayo',10087.0,-9.16,54.12).
city('Ballinrobe','ie','Mayo',1707.0,-9.23,53.63).
city('Ballyhaunis','ie','Mayo',1344.0,-8.77,53.76).
city('Castlebar','ie','Mayo',12874.0,-9.3,53.86).
city('Claremorris','ie','Mayo',2168.0,-9.01,53.73).
city('Swinford','ie','Mayo',1241.0,-8.96,53.95).
city('Westport','ie','Mayo',6200.0,-9.52,53.81).
city('Ashbourne','ie','Meath',7001.0,-6.4,53.51).
city('Athboy','ie','Meath',1656.0,-6.92,53.62).
city('Duleek','ie','Meath',2376.0,-6.42,53.65).
city('Dunboyne','ie','Meath',6718.0,-6.47,53.4).
city('Dunshaughlin','ie','Meath',3567.0,-6.54,53.51).
city('Kells','ie','Meath',4820.0,-6.89,53.73).
city('Laytown','ie','Meath',6342.0,-6.24,53.67).
city('Navan','ie','Meath',24545.0,-6.69,53.66).
city('Ratoath','ie','Meath',4084.0,-6.45,53.5).
city('Trim','ie','Meath',6781.0,-6.8,53.55).
city('Carrickmacross','ie','Monaghan',3995.0,-6.74,53.98).
city('Castleblayney','ie','Monaghan',3006.0,-6.75,54.12).
city('Clones','ie','Monaghan',1834.0,-7.24,54.19).
city('Monaghan','ie','Monaghan',5937.0,-6.97,54.25).
city('Banagher','ie','Offaly',1586.0,-7.99,53.19).
city('Birr','ie','Offaly',4549.0,-7.92,53.1).
city('Clara','ie','Offaly',2783.0,-7.62,53.33).
city('Edenderry','ie','Offaly',4890.0,-7.05,53.34).
city('Kilcormac','ie','Offaly',1200.0,-7.73,53.17).
city('Tullamore','ie','Offaly',11575.0,-7.49,53.28).
city('Ballaghaderreen','ie','Roscommon',1389.0,-8.59,53.91).
city('Boyle','ie','Roscommon',2199.0,-8.32,53.98).
city('Castlerea','ie','Roscommon',1770.0,-8.51,53.77).
city('Roscommon','ie','Roscommon',4860.0,-8.2,53.64).
city('Sligo','ie','Sligo',20228.0,-8.48,54.28).
city('Nenagh','ie','Tipperary North Riding',6672.0,-8.2,52.87).
city('Roscrea','ie','Tipperary North Riding',4721.0,-7.81,52.96).
city('Templemore','ie','Tipperary North Riding',2264.0,-7.84,52.79).
city('Thurles','ie','Tipperary North Riding',7588.0,-7.83,52.69).
city('Cahir','ie','Tipperary South Riding',3057.0,-7.92,52.37).
city('Carrick-on-Suir','ie','Tipperary South Riding',5710.0,-7.42,52.35).
city('Cashel','ie','Tipperary South Riding',2798.0,-7.89,52.52).
city('Clonmel','ie','Tipperary South Riding',17394.0,-7.71,52.36).
city('Tipperary','ie','Tipperary South Riding',4976.0,-8.17,52.49).
city('Dungarvan','ie','Waterford',7551.0,-7.63,52.09).
city('Dunmore East','ie','Waterford',1795.0,-7.0,52.15).
city('Kill','ie','Waterford',2304.0,-7.34,52.18).
city('Tramore','ie','Waterford',9164.0,-7.16,52.16).
city('Waterford','ie','Waterford',47904.0,-7.13,52.26).
city('Athlone','ie','Westmeath',15951.0,-7.95,53.42).
city('Mullingar','ie','Westmeath',17262.0,-7.34,53.53).
city('Enniscorthy','ie','Wexford',9709.0,-6.57,52.5).
city('Gorey','ie','Wexford',6040.0,-6.3,52.67).
city('New Ross','ie','Wexford',6695.0,-6.95,52.4).
city('Wexford','ie','Wexford',17708.0,-6.48,52.34).
city('Arklow','ie','Wicklow',10622.0,-6.15,52.8).
city('Blessington','ie','Wicklow',2874.0,-6.53,53.18).
city('Bray','ie','Wicklow',32317.0,-6.11,53.21).
city('Enniskerry','ie','Wicklow',1990.0,-6.17,53.19).
city('Greystones','ie','Wicklow',12260.0,-6.07,53.14).
city('Kilcoole','ie','Wicklow',2869.0,-6.07,53.1).
city('Newtownmountkennedy','ie','Wicklow',2498.0,-6.11,53.09).
city('Rathdrum','ie','Wicklow',1649.0,-6.23,52.93).
city('Wicklow','ie','Wicklow',10461.0,-6.05,52.99).
city('Castletown','im','Castletown',2680.0,-4.65,54.09).
city('Douglas','im','Douglas',25422.0,-4.48,54.15).
city('Laxey','im','Laxey',1524.0,-4.4,54.23).
city('Onchan','im','Onchan',8871.0,-4.45,54.19).
city('Peel','im','Peel',3765.0,-4.71,54.22).
city('Port E','im','Port Erin',3473.0,-4.78,54.08).
city('Port Saint Mary','im','Port Saint Mary',2051.0,-4.76,54.07).
city('Ramsey','im','Ramsey',7526.0,-4.4,54.34).
city('Arad','il','Hadarom',24222.0,35.22,31.26).
city('Ashdod','il','Hadarom',202681.0,34.64,31.8).
city('Ashqelon','il','Hadarom',108342.0,34.56,31.67).
city('Beer Sheva','il','Hadarom',187457.0,34.8,31.25).
city('Bene Ayish','il','Hadarom',8193.0,34.75,31.78).
city('Dimona','il','Hadarom',33354.0,35.03,31.07).
city('Elat','il','Hadarom',46707.0,34.95,29.56).
city('Gan Yavne','il','Hadarom',14830.0,34.71,31.79).
city('Kuseife','il','Hadarom',9770.0,35.07,31.25).
city('Merkaz Shappira','il','Hadarom',2785.0,35.19,30.61).
city('Mizpe Ramon','il','Hadarom',4769.0,34.8,30.61).
city('Netivot','il','Hadarom',24933.0,34.6,31.43).
city('Ofaqim','il','Hadarom',24633.0,34.61,31.32).
city('Omer','il','Hadarom',5995.0,34.85,31.29).
city('Qiryat Gat','il','Hadarom',48946.0,34.76,31.61).
city('Qiryat Malakhi','il','Hadarom',18725.0,34.74,31.74).
city('Sederot','il','Hadarom',20865.0,34.58,31.53).
city('Yeroham','il','Hadarom',9148.0,34.91,31.0).
city('Arara','il','Haifa',15438.0,35.1,32.49).
city('Atlit','il','Haifa',4622.0,34.93,32.68).
city('Baqa-Jatt','il','Haifa',30908.0,35.05,32.43).
city('Binyamina-Givat Ada','il','Haifa',10372.0,43.95,32.53).
city('Daliyat Al Karmel-Isifya','il','Haifa',23817.0,35.08,32.72).
city('Haifa','il','Haifa',269961.0,34.99,32.82).
city('Hzadera','il','Haifa',77287.0,34.92,32.45).
city('Ibtin','il','Haifa',2020.0,35.1,32.76).
city('Jisr Az-Zarqa','il','Haifa',10850.0,34.91,32.54).
city('Nesher','il','Haifa',21811.0,35.06,32.75).
city('Or Aqiva','il','Haifa',16157.0,34.91,32.52).
city('Pardes Hzanna-Karkur','il','Haifa',29943.0,34.98,32.48).
city('Qesarya','il','Haifa',4300.0,34.88,32.48).
city('Qiryat Atta','il','Haifa',49548.0,35.12,32.81).
city('Qiryat Bialik','il','Haifa',37385.0,35.08,32.83).
city('Qiryat Motzkin','il','Haifa',40694.0,35.06,32.82).
city('Qiryat Yam','il','Haifa',38122.0,35.06,32.84).
city('Rekhasim','il','Haifa',8521.0,35.1,32.75).
city('Tirat Karmel','il','Haifa',19234.0,34.99,32.75).
city('Umm Al-Fahm','il','Haifa',40829.0,35.16,32.53).
city('Zikhron Yaaqov','il','Haifa',16512.0,34.95,32.58).
city('Beer Yaaqov','il','Hamerkaz',9356.0,34.83,31.93).
city('Bene Beraq','il','Hamerkaz',140849.0,34.85,32.09).
city('Bet Dagan','il','Hamerkaz',5990.0,34.83,32.0).
city('Bet Yizhaq','il','Hamerkaz',1674.0,34.88,32.32).
city('Elyakhin','il','Hamerkaz',2728.0,34.92,32.4).
city('Even Yehuda','il','Hamerkaz',9091.0,34.88,32.29).
city('Fureidis','il','Hamerkaz',9805.0,34.95,32.6).
city('Gedera','il','Hamerkaz',14267.0,34.78,31.82).
city('Hod HaSharon','il','Hamerkaz',42996.0,34.89,32.15).
city('Jaljulye','il','Hamerkaz',7580.0,34.95,32.15).
city('Kafar Qasem','il','Hamerkaz',17189.0,34.98,32.12).
city('Kefar Habad','il','Hamerkaz',4771.0,34.85,31.99).
city('Kefar Sava','il','Hamerkaz',80922.0,34.91,32.19).
city('Kefar Yona','il','Hamerkaz',12771.0,34.93,32.32).
city('Lod','il','Hamerkaz',68095.0,34.9,31.96).
city('Mazkeret Batya','il','Hamerkaz',8283.0,34.83,31.85).
city('Modiin-Makkabim-Reut','il','Hamerkaz',56573.0,35.01,31.9).
city('Nehalim','il','Hamerkaz',2061.0,34.91,32.06).
city('Nes Zziyyona','il','Hamerkaz',27765.0,34.8,31.93).
city('Netanya','il','Hamerkaz',172405.0,34.86,32.33).
city('Nordiyya','il','Hamerkaz',2264.0,34.9,32.32).
city('Pardesiyya','il','Hamerkaz',6348.0,34.92,32.3).
city('Petahz Tiqwa','il','Hamerkaz',177372.0,34.88,32.09).
city('Qalansawe','il','Hamerkaz',16714.0,34.98,32.0).
city('Qiryat Eqron','il','Hamerkaz',10019.0,34.82,31.85).
city('Raanana','il','Hamerkaz',71681.0,34.88,32.19).
city('Ramat Efal','il','Hamerkaz',2836.0,34.83,32.05).
city('Ramla','il','Hamerkaz',63837.0,34.86,31.93).
city('Rehzovot','il','Hamerkaz',103022.0,34.8,31.89).
city('Rishon LeZziyyon','il','Hamerkaz',222301.0,34.8,31.96).
city('Rosh HaAyin','il','Hamerkaz',37339.0,34.94,32.1).
city('Savyon','il','Hamerkaz',3434.0,34.88,32.05).
city('Shoham','il','Hamerkaz',18942.0,34.96,32.0).
city('Tayibe','il','Hamerkaz',32736.0,34.99,32.27).
city('Tel Mond','il','Hamerkaz',8939.0,34.93,32.25).
city('Tire','il','Hamerkaz',20736.0,34.96,32.25).
city('Yavne','il','Hamerkaz',32394.0,34.74,31.87).
city('Yehud-Newe Efrayim','il','Hamerkaz',25469.0,34.89,32.04).
city('Zzoran-Qadima','il','Hamerkaz',16374.0,34.91,32.29).
city('Afula','il','Hazzafon',39798.0,35.29,32.62).
city('Akko','il','Hazzafon',45548.0,35.08,32.94).
city('Arrabe','il','Hazzafon',19700.0,35.33,32.85).
city('Basmat Tabun','il','Hazzafon',6278.0,35.15,32.74).
city('Beit Jann','il','Hazzafon',10001.0,35.38,32.97).
city('Bet Shean','il','Hazzafon',16452.0,35.51,32.51).
city('Bir El-Maksur','il','Hazzafon',6942.0,35.23,32.75).
city('Bueine-Nujeidat','il','Hazzafon',7737.0,35.37,32.8).
city('Dabburiyya','il','Hazzafon',8329.0,35.4,32.7).
city('Deir Hanna','il','Hazzafon',8658.0,35.36,32.87).
city('Eilabun','il','Hazzafon',4227.0,35.4,32.83).
city('Ein Mahel','il','Hazzafon',10642.0,35.35,32.72).
city('Fassuta','il','Hazzafon',2985.0,35.31,33.05).
city('Hazzor HaGelilit','il','Hazzafon',8549.0,35.55,33.0).
city('Hurfeish','il','Hazzafon',5252.0,35.35,33.02).
city('Ibillin','il','Hazzafon',10619.0,35.18,32.82).
city('Iksal','il','Hazzafon',11213.0,35.32,32.68).
city('Ilut','il','Hazzafon',6561.0,35.25,32.72).
city('Ir Hahamisha','il','Hazzafon',33854.0,35.16,32.95).
city('Jish','il','Hazzafon',2684.0,35.44,33.02).
city('Judeide-Maker','il','Hazzafon',17820.0,35.15,32.92).
city('Kabul','il','Hazzafon',9301.0,35.22,32.87).
city('Kafar Kama','il','Hazzafon',2990.0,35.44,32.72).
city('Kafar Kanna','il','Hazzafon',17338.0,35.35,32.75).
city('Kafar Manda','il','Hazzafon',14771.0,35.25,32.82).
city('Kafar Yasif','il','Hazzafon',8615.0,35.18,32.98).
city('Karmiel','il','Hazzafon',44036.0,35.3,32.93).
city('Kefar Tavor','il','Hazzafon',2323.0,35.42,32.69).
city('Kefar Weradim','il','Hazzafon',5559.0,35.28,32.99).
city('Kisra-Sumei','il','Hazzafon',6471.0,35.3,32.97).
city('Maalot-Tarshihza','il','Hazzafon',21878.0,35.31,33.03).
city('Mazraa','il','Hazzafon',3447.0,35.1,32.99).
city('Mielya','il','Hazzafon',2705.0,35.26,33.03).
city('Migdal HaEmeq','il','Hazzafon',25425.0,35.24,32.68).
city('Mugar','il','Hazzafon',19104.0,35.41,32.89).
city('Muqeible','il','Hazzafon',3090.0,35.29,32.52).
city('Nahariyya','il','Hazzafon',50881.0,35.1,33.03).
city('Nahef','il','Hazzafon',10077.0,35.33,32.94).
city('Naura','il','Hazzafon',1651.0,35.39,32.61).
city('Nazerat','il','Hazzafon',64240.0,35.3,32.71).
city('Nazerat Illit','il','Hazzafon',44632.0,35.33,32.72).
city('Nein','il','Hazzafon',1588.0,35.35,32.63).
city('Peqiin','il','Hazzafon',5195.0,35.34,32.98).
city('Qiryat Shemona','il','Hazzafon',22738.0,35.57,33.21).
city('Qiryat Tivon','il','Hazzafon',13581.0,35.13,32.73).
city('Ramat Yishay','il','Hazzafon',5722.0,35.18,32.7).
city('Rame','il','Hazzafon',7360.0,35.41,32.94).
city('Reine','il','Hazzafon',16157.0,35.3,32.72).
city('Rosh Pinna','il','Hazzafon',2492.0,35.53,32.97).
city('Rumat Heib','il','Hazzafon',1588.0,35.31,32.78).
city('Sajur','il','Hazzafon',3547.0,35.34,32.95).
city('Sakhnin','il','Hazzafon',24401.0,35.29,32.87).
city('Sallama','il','Hazzafon',1800.0,35.37,32.9).
city('Segev-Shalom','il','Hazzafon',5991.0,35.26,32.86).
city('Shaab','il','Hazzafon',5923.0,35.24,32.89).
city('Shagor','il','Hazzafon',28536.0,35.27,32.92).
city('Shefaram','il','Hazzafon',32473.0,35.17,32.82).
city('Sheikh Dannun','il','Hazzafon',2305.0,35.15,32.99).
city('Shelomi','il','Hazzafon',5784.0,35.1,33.07).
city('Sulam','il','Hazzafon',2426.0,35.33,32.61).
city('Tamra','il','Hazzafon',25839.0,35.2,32.85).
city('Tiberias','il','Hazzafon',41029.0,35.53,32.8).
city('Timrat','il','Hazzafon',1789.0,35.23,32.7).
city('Tuba-Zangariyye','il','Hazzafon',5131.0,35.6,32.97).
city('Turan','il','Hazzafon',11195.0,35.37,32.77).
city('Uzeir','il','Hazzafon',2591.0,35.33,32.79).
city('Yavneel','il','Hazzafon',2957.0,35.5,32.71).
city('Yoqneam Illit','il','Hazzafon',18821.0,35.13,32.67).
city('Zzefat','il','Hazzafon',27690.0,35.51,32.97).
city('Abu Ghosh','il','Jerusalem',5570.0,35.1,31.8).
city('Bet Shemesh','il','Jerusalem',64838.0,34.98,31.75).
city('Jerusalem','il','Jerusalem',714685.0,35.22,31.78).
city('Mevasserat Ziyyon','il','Jerusalem',22663.0,35.15,31.8).
city('Qiryat Yearim','il','Jerusalem',3066.0,35.1,31.82).
city('Zzur Hadassa','il','Jerusalem',3711.0,35.1,31.72).
city('Alfe Menashe','il','Judea and Samaria',5560.0,35.0,32.17).
city('Allon Shevut','il','Judea and Samaria',3269.0,35.12,31.67).
city('Ariel','il','Judea and Samaria',17135.0,35.17,32.1).
city('Bet Arye','il','Judea and Samaria',2616.0,35.05,32.03).
city('Bet El','il','Judea and Samaria',5039.0,35.22,31.93).
city('Betar Illit','il','Judea and Samaria',28593.0,35.12,31.7).
city('Efrata','il','Judea and Samaria',7578.0,35.13,31.65).
city('Ein Qiniyye','il','Judea and Samaria',1996.0,35.15,31.93).
city('Eli','il','Judea and Samaria',2098.0,35.27,32.07).
city('Elqana','il','Judea and Samaria',3269.0,35.03,32.1).
city('Givat Zeev','il','Judea and Samaria',11598.0,35.17,31.87).
city('Har Adar','il','Judea and Samaria',1996.0,35.13,31.82).
city('Immanuel','il','Judea and Samaria',2522.0,35.13,32.15).
city('Kefar Adummim','il','Judea and Samaria',2066.0,35.33,31.82).
city('Kokhav Yaaqov','il','Judea and Samaria',5170.0,35.22,31.88).
city('Maale Adummim','il','Judea and Samaria',28530.0,35.35,31.82).
city('Newe Deqalim','il','Judea and Samaria',2635.0,34.27,31.35).
city('Ofra','il','Judea and Samaria',2525.0,35.23,31.92).
city('Oranit','il','Judea and Samaria',5706.0,34.98,32.13).
city('Qarne Shomeron','il','Judea and Samaria',5518.0,35.08,32.17).
city('Qedummim','il','Judea and Samaria',3133.0,35.15,32.2).
city('Qiryat Arba','il','Judea and Samaria',7027.0,35.1,31.53).
city('Shaare Tiqwa','il','Judea and Samaria',3911.0,35.02,32.12).
city('Shilo','il','Judea and Samaria',1973.0,35.28,32.05).
city('Talmon','il','Judea and Samaria',1743.0,35.12,31.93).
city('Azur','il','Tel Aviv',10338.0,34.8,32.02).
city('Bat Yam','il','Tel Aviv',130973.0,34.75,32.02).
city('Ganne Tiqwa','il','Tel Aviv',12408.0,34.87,32.05).
city('Givat Shemuel','il','Tel Aviv',18799.0,34.85,32.07).
city('Givatayim','il','Tel Aviv',47003.0,34.8,32.06).
city('Herzeliyya','il','Tel Aviv',84595.0,34.84,32.17).
city('Hzolon','il','Tel Aviv',167072.0,34.76,32.02).
city('Kefar Shemaryahu','il','Tel Aviv',1774.0,34.82,32.19).
city('Or Yehuda','il','Tel Aviv',30977.0,34.85,32.04).
city('Qiryat Ono','il','Tel Aviv',24907.0,34.86,32.07).
city('Ramat Gan','il','Tel Aviv',126864.0,34.8,32.08).
city('Ramat HaSharon','il','Tel Aviv',35556.0,34.84,32.15).
city('Tel Aviv-Yafo','il','Tel Aviv',370480.0,34.77,32.07).
city('Alba Adriatica','it','Abruzzes',11344.0,13.93,42.82).
city('Atessa','it','Abruzzes',11081.0,14.44,42.07).
city('Atri','it','Abruzzes',11904.0,13.96,42.59).
city('Avezzano','it','Abruzzes',38957.0,13.42,42.04).
city('Celano','it','Abruzzes',11701.0,13.54,42.09).
city('Chieti','it','Abruzzes',51194.0,14.16,42.35).
city('Citta SantAngelo','it','Abruzzes',13023.0,14.04,42.53).
city('Francavilla al Mare','it','Abruzzes',26335.0,14.24,42.44).
city('Giulianova','it','Abruzzes',22299.0,13.95,42.76).
city('Guardiagrele','it','Abruzzes',10451.0,14.21,42.2).
city('LAquila','it','Abruzzes',65858.0,13.39,42.35).
city('Lanciano','it','Abruzzes',38351.0,14.37,42.23).
city('Martinsicuro','it','Abruzzes',15030.0,13.91,42.89).
city('Montesilvano','it','Abruzzes',43237.0,14.13,42.49).
city('Montorio al Vomano','it','Abruzzes',8223.0,13.63,42.59).
city('Ortona','it','Abruzzes',22874.0,14.39,42.36).
city('Penne','it','Abruzzes',13394.0,13.92,42.47).
city('Pescara','it','Abruzzes',118136.0,14.21,42.46).
city('Pineto','it','Abruzzes',14469.0,14.06,42.61).
city('Roseto degli Abruzzi','it','Abruzzes',22868.0,14.02,42.66).
city('San Salvo','it','Abruzzes',19249.0,14.73,42.05).
city('Silvi','it','Abruzzes',16070.0,14.08,42.57).
city('Spoltore','it','Abruzzes',17633.0,14.13,42.45).
city('Sulmona','it','Abruzzes',26796.0,13.93,42.06).
city('Teramo','it','Abruzzes',49605.0,13.7,42.67).
city('Vasto','it','Abruzzes',37841.0,14.7,42.12).
city('Acquaviva delle Fonti','it','Apulia',22030.0,16.84,40.89).
city('Adelfia','it','Apulia',17132.0,16.86,41.0).
city('Alberobello','it','Apulia',11112.0,17.26,40.79).
city('Altamura','it','Apulia',66119.0,16.55,40.84).
city('Andria','it','Apulia',93819.0,16.29,41.23).
city('Apricena','it','Apulia',13753.0,15.44,41.79).
city('Aradeo','it','Apulia',9108.0,18.13,40.14).
city('Bari','it','Apulia',303049.0,16.87,41.12).
city('Barletta','it','Apulia',92650.0,16.27,41.32).
city('Bisceglie','it','Apulia',52878.0,16.5,41.25).
city('Bitetto','it','Apulia',10662.0,16.75,41.03).
city('Bitonto','it','Apulia',58242.0,16.69,41.12).
city('Bitritto','it','Apulia',10384.0,16.83,41.05).
city('Brindisi','it','Apulia',92457.0,17.93,40.64).
city('Campi Salentina','it','Apulia',11120.0,18.01,40.41).
city('Canosa di Puglia','it','Apulia',30426.0,16.05,41.23).
city('Capurso','it','Apulia',14808.0,16.91,41.06).
city('Carmiano','it','Apulia',12291.0,18.04,40.36).
city('Carovigno','it','Apulia',15611.0,17.64,40.71).
city('Casamassima','it','Apulia',17519.0,16.91,40.95).
city('Casarano','it','Apulia',20722.0,18.15,40.01).
city('Cassano delle Murge','it','Apulia',12545.0,16.76,40.89).
city('Castellana Grotte','it','Apulia',18437.0,17.16,40.0).
city('Castellaneta','it','Apulia',18022.0,16.92,40.64).
city('Cavallino','it','Apulia',11878.0,18.19,40.3).
city('Ceglie Messapica','it','Apulia',20695.0,17.51,40.65).
city('Cerignola','it','Apulia',58888.0,15.88,41.27).
city('Cisternino','it','Apulia',12265.0,17.41,40.74).
city('Conversano','it','Apulia',24802.0,17.1,40.97).
city('Copertino','it','Apulia',22105.0,18.03,40.27).
city('Corato','it','Apulia',45276.0,16.4,41.15).
city('Crispiano','it','Apulia',12663.0,17.23,40.6).
city('Cutrofiano','it','Apulia',9105.0,18.19,40.12).
city('Erchie','it','Apulia',8828.0,17.73,40.44).
city('Fasano','it','Apulia',38871.0,17.35,40.84).
city('Foggia','it','Apulia',143826.0,15.55,41.47).
city('Francavilla Fontana','it','Apulia',37411.0,17.58,40.53).
city('Galatina','it','Apulia',27985.0,18.16,40.18).
city('Galatone','it','Apulia',15802.0,18.06,40.16).
city('Gallipoli','it','Apulia',20588.0,17.98,40.06).
city('Ginosa','it','Apulia',22451.0,16.76,40.58).
city('Gioia del Colle','it','Apulia',26205.0,16.92,40.8).
city('Giovinazzo','it','Apulia',19962.0,16.66,41.19).
city('Gravina in Puglia','it','Apulia',43640.0,16.41,40.81).
city('Grottaglie','it','Apulia',31543.0,17.43,40.54).
city('Grumo Appula','it','Apulia',12677.0,16.69,41.06).
city('Laterza','it','Apulia',15268.0,16.79,40.63).
city('Latiano','it','Apulia',15321.0,17.71,40.55).
city('Lecce','it','Apulia',79259.0,18.16,40.36).
city('Leverano','it','Apulia',13795.0,17.99,40.29).
city('Lizzanello','it','Apulia',10737.0,18.21,40.3).
city('Lizzano','it','Apulia',10376.0,17.44,40.39).
city('Locorotondo','it','Apulia',14294.0,17.32,40.75).
city('Lucera','it','Apulia',35396.0,15.33,41.52).
city('Maglie','it','Apulia',15295.0,18.29,40.12).
city('Manduria','it','Apulia',30534.0,17.62,40.4).
city('Manfredonia','it','Apulia',57015.0,15.9,41.63).
city('Margherita di Savoia','it','Apulia',12589.0,16.12,41.38).
city('Martano','it','Apulia',9644.0,18.3,40.21).
city('Martina Franca','it','Apulia',48233.0,17.33,40.71).
city('Massafra','it','Apulia',31436.0,17.08,40.61).
city('Matino','it','Apulia',11410.0,18.13,40.04).
city('Melendugno','it','Apulia',9554.0,18.33,40.27).
city('Mesagne','it','Apulia',26981.0,17.8,40.57).
city('Minervino Murge','it','Apulia',9955.0,16.08,41.09).
city('Modugno','it','Apulia',36208.0,16.76,41.09).
city('Mola di Bari','it','Apulia',23918.0,17.08,41.05).
city('Molfetta','it','Apulia',61308.0,16.59,41.21).
city('Monopoli','it','Apulia',50064.0,17.28,40.95).
city('Monte SantAngelo','it','Apulia',13394.0,15.95,41.71).
city('Monteroni di Lecce','it','Apulia',13908.0,18.1,40.32).
city('Mottola','it','Apulia',16686.0,17.03,40.64).
city('Nardo','it','Apulia',31294.0,18.02,40.18).
city('Noci','it','Apulia',19993.0,17.11,40.8).
city('Noicattaro','it','Apulia',25022.0,16.98,41.04).
city('Oria','it','Apulia',15505.0,17.63,40.51).
city('Orta Nova','it','Apulia',17873.0,15.76,41.29).
city('Ostuni','it','Apulia',32604.0,17.56,40.73).
city('Palagiano','it','Apulia',16426.0,17.03,40.59).
city('Palo del Colle','it','Apulia',22505.0,16.7,41.06).
city('Parabita','it','Apulia',9804.0,18.13,40.06).
city('Polignano a Mare','it','Apulia',16462.0,17.21,41.0).
city('Pulsano','it','Apulia',10191.0,17.35,40.39).
city('Putignano','it','Apulia',27994.0,17.11,40.86).
city('Racale','it','Apulia',10502.0,18.1,39.96).
city('Ruffano','it','Apulia',9186.0,18.25,39.99).
city('Rutigliano','it','Apulia',18115.0,16.98,41.03).
city('Ruvo di Puglia','it','Apulia',26385.0,16.48,41.12).
city('Salice Salentino','it','Apulia',8932.0,17.96,40.39).
city('San Ferdinando di Puglia','it','Apulia',14792.0,16.06,41.3).
city('San Giorgio Ionico','it','Apulia',15682.0,17.38,40.45).
city('San Giovanni Rotondo','it','Apulia',27228.0,15.72,41.71).
city('San Marco in Lamis','it','Apulia',16109.0,15.62,41.72).
city('San Nicandro Garganico','it','Apulia',17043.0,15.56,41.84).
city('San Pancrazio Salentino','it','Apulia',10546.0,17.83,40.42).
city('San Pietro Vernotico','it','Apulia',14779.0,17.99,40.49).
city('San Severo','it','Apulia',56708.0,15.38,41.69).
city('San Vito dei Normanni','it','Apulia',20057.0,17.7,40.66).
city('Sannicandro di Bari','it','Apulia',9761.0,16.8,41.0).
city('Santeramo in Colle','it','Apulia',27024.0,16.75,40.8).
city('Sava','it','Apulia',15819.0,17.53,40.41).
city('Squinzano','it','Apulia',15156.0,18.04,40.44).
city('Surbo','it','Apulia',13711.0,18.13,40.4).
city('Taranto','it','Apulia',191364.0,17.24,40.48).
city('Taurisano','it','Apulia',12340.0,18.2,39.96).
city('Taviano','it','Apulia',12797.0,18.08,39.99).
city('Terlizzi','it','Apulia',27076.0,16.53,41.14).
city('Torre Santa Susanna','it','Apulia',10575.0,17.72,40.47).
city('Torremaggiore','it','Apulia',16997.0,15.28,41.69).
city('Trani','it','Apulia',53902.0,16.41,41.28).
city('Trepuzzi','it','Apulia',14198.0,18.1,40.39).
city('Tricase','it','Apulia',17836.0,18.35,39.94).
city('Triggiano','it','Apulia',26708.0,16.91,41.07).
city('Trinitapoli','it','Apulia',14629.0,16.07,41.36).
city('Turi','it','Apulia',11680.0,17.01,40.92).
city('Ugento','it','Apulia',9893.0,18.15,39.94).
city('Valenzano','it','Apulia',17960.0,16.87,41.04).
city('Veglie','it','Apulia',14227.0,17.96,40.34).
city('Vieste','it','Apulia',13440.0,16.17,41.89).
city('Avigliano','it','Basilicata',11881.0,15.71,40.74).
city('Bernalda','it','Basilicata',11532.0,16.69,40.41).
city('Ferrandina','it','Basilicata',9092.0,16.44,40.49).
city('Lauria','it','Basilicata',13507.0,15.83,40.04).
city('Lavello','it','Basilicata',12774.0,15.78,41.05).
city('Matera','it','Basilicata',57250.0,16.6,40.67).
city('Melfi','it','Basilicata',15897.0,15.66,41.01).
city('Montescaglioso','it','Basilicata',10005.0,16.66,40.55).
city('Pisticci','it','Basilicata',17393.0,16.55,40.39).
city('Policoro','it','Basilicata',15083.0,16.68,40.22).
city('Potenza','it','Basilicata',68823.0,15.79,40.66).
city('Rionero in Vulture','it','Basilicata',13399.0,15.67,40.93).
city('Venosa','it','Basilicata',11982.0,15.81,40.96).
city('Acri','it','Calabria',21495.0,16.38,39.49).
city('Amantea','it','Calabria',13733.0,16.07,39.14).
city('Bagnara Calabra','it','Calabria',11165.0,15.83,38.31).
city('Belvedere Marittimo','it','Calabria',8880.0,15.86,39.62).
city('Bisignano','it','Calabria',11136.0,16.28,39.52).
city('Cariati','it','Calabria',8058.0,16.94,39.5).
city('Cassano allo Ionio','it','Calabria',17566.0,16.31,39.79).
city('Castrolibero','it','Calabria',10495.0,16.18,39.3).
city('Castrovillari','it','Calabria',21094.0,16.2,39.81).
city('Catanzaro','it','Calabria',91584.0,16.6,38.9).
city('Cetraro','it','Calabria',10296.0,15.94,39.51).
city('Ciro Marina','it','Calabria',13929.0,17.12,39.37).
city('Cittanova','it','Calabria',102.0,16.07,38.36).
city('Corigliano Calabro','it','Calabria',36531.0,16.5,39.6).
city('Cosenza','it','Calabria',67380.0,16.26,39.29).
city('Crotone','it','Calabria',48825.0,17.12,39.09).
city('Cutro','it','Calabria',10102.0,16.96,39.03).
city('Gioia Tauro','it','Calabria',18772.0,15.89,38.41).
city('Isola di Capo Rizzuto','it','Calabria',13128.0,17.09,38.95).
city('Lamezia Terme','it','Calabria',71927.0,16.29,38.95).
city('Locri','it','Calabria',12994.0,16.26,38.24).
city('Luzzi','it','Calabria',10338.0,16.28,39.45).
city('Melito di Porto Salvo','it','Calabria',10602.0,15.78,37.93).
city('Montalto Uffugo','it','Calabria',19140.0,16.15,39.4).
city('Palmi','it','Calabria',19317.0,15.85,38.36).
city('Paola','it','Calabria',16896.0,16.03,39.39).
city('Petilia Policastro','it','Calabria',9159.0,16.78,39.12).
city('Polistena','it','Calabria',11637.0,16.09,38.42).
city('Reggio di Calabria','it','Calabria',181990.0,15.65,38.11).
city('Rende','it','Calabria',36400.0,16.18,39.34).
city('Rosarno','it','Calabria',15558.0,15.97,38.49).
city('Rossan','it','Calabria',35073.0,16.62,39.59).
city('San Giovanni in Fiore','it','Calabria',17202.0,16.69,39.26).
city('Scalea','it','Calabria',10765.0,15.8,39.81).
city('Siderno','it','Calabria',17194.0,16.29,38.27).
city('Soverato','it','Calabria',9884.0,16.53,38.69).
city('Taurianova','it','Calabria',15488.0,16.01,38.36).
city('Trebisacce','it','Calabria',9028.0,16.53,39.87).
city('Vibo Valentia','it','Calabria',36055.0,16.11,38.69).
city('Villa San Giovanni','it','Calabria',13187.0,15.64,38.23).
city('Acerra','it','Campania',46729.0,14.39,41.0).
city('Afragola','it','Campania',59416.0,14.3,40.93).
city('Agropoli','it','Campania',21243.0,14.98,40.36).
city('Angri','it','Campania',29745.0,14.56,40.75).
city('Ariano Irpino','it','Campania',23034.0,15.08,41.16).
city('Arzano','it','Campania',38397.0,14.26,40.92).
city('Atripalda','it','Campania',11361.0,14.82,40.93).
city('Avellino','it','Campania',52466.0,14.79,40.92).
city('Aversa','it','Campania',56626.0,14.19,40.98).
city('Bacoli','it','Campania',26579.0,14.08,40.8).
city('Baronissi','it','Campania',16375.0,14.75,40.74).
city('Battipaglia','it','Campania',52818.0,14.97,40.62).
city('Bellizzi','it','Campania',12956.0,14.8,40.89).
city('Benevento','it','Campania',61728.0,14.77,41.13).
city('Boscoreale','it','Campania',26944.0,14.46,40.79).
city('Boscotrecase','it','Campania',10393.0,14.46,40.77).
city('Brusciano','it','Campania',16051.0,14.42,40.82).
city('Caivano','it','Campania',36860.0,14.29,40.96).
city('Calvizzano','it','Campania',13333.0,14.2,40.9).
city('Campagna','it','Campania',16760.0,15.11,40.67).
city('Capaccio','it','Campania',21122.0,15.08,40.43).
city('Capua','it','Campania',19209.0,14.2,41.13).
city('Cardito','it','Campania',20232.0,14.3,40.95).
city('Casagiove','it','Campania',14552.0,14.31,41.07).
city('Casal di Principe','it','Campania',19983.0,14.13,41.01).
city('Casalnuovo di Napoli','it','Campania',52709.0,14.33,40.92).
city('Casaluce','it','Campania',10243.0,14.2,41.0).
city('Casandrino','it','Campania',13963.0,14.25,40.94).
city('Casavatore','it','Campania',19287.0,14.27,40.9).
city('Caserta','it','Campania',78598.0,14.32,41.07).
city('Casoria','it','Campania',78629.0,14.28,40.9).
city('Castel San Giorgio','it','Campania',13460.0,14.69,40.78).
city('Castel Volturno','it','Campania',19652.0,13.93,41.04).
city('Castellammare di Stabia','it','Campania',66944.0,14.48,40.7).
city('Cava de Tirreni','it','Campania',53467.0,14.69,40.71).
city('Cercola','it','Campania',19764.0,14.35,40.85).
city('Cervinara','it','Campania',9936.0,14.61,41.02).
city('Cicciano','it','Campania',12266.0,14.53,40.97).
city('Crispano','it','Campania',13238.0,14.29,40.95).
city('Eboli','it','Campania',37120.0,15.01,40.63).
city('Ercolano','it','Campania',53341.0,14.34,40.8).
city('Fisciano','it','Campania',12790.0,14.79,40.77).
city('Forio','it','Campania',15939.0,13.85,40.74).
city('Frattamaggiore','it','Campania',31251.0,14.27,40.94).
city('Frattaminore','it','Campania',15664.0,14.26,40.95).
city('Giffoni Valle Piana','it','Campania',11523.0,14.93,40.74).
city('Giugliano in Campania','it','Campania',107680.0,14.19,40.93).
city('Gragnano','it','Campania',29227.0,14.51,40.69).
city('Grumo Nevano','it','Campania',18623.0,14.26,40.94).
city('Ischia','it','Campania',18621.0,13.95,40.75).
city('Lusciano','it','Campania',13609.0,14.19,40.96).
city('Maddaloni','it','Campania',38099.0,14.38,41.06).
city('Marano di Napoli','it','Campania',50885.0,14.18,40.9).
city('Marcianise','it','Campania',41726.0,14.28,41.04).
city('Marigliano','it','Campania',31772.0,14.44,40.94).
city('Massa Lubrense','it','Campania',13523.0,14.33,40.6).
city('Melito di Napoli','it','Campania',41291.0,14.23,40.92).
city('Mercato San Severino','it','Campania',20954.0,14.76,40.79).
city('Mercogliano','it','Campania',13046.0,14.73,40.92).
city('Mondragone','it','Campania',24810.0,13.9,41.12).
city('Monte di Procida','it','Campania',12757.0,14.05,40.8).
city('Montecorvino Rovella','it','Campania',12208.0,15.0,40.71).
city('Montesarchio','it','Campania',13110.0,14.63,41.07).
city('Mugnano di Napoli','it','Campania',32847.0,14.2,40.92).
city('Naples','it','Campania',981284.0,14.27,40.85).
city('Nocera Inferiore','it','Campania',48798.0,14.63,40.75).
city('Nocera Superiore','it','Campania',22898.0,14.66,40.74).
city('Nola','it','Campania',32872.0,14.53,40.92).
city('Orta di Atella','it','Campania',14088.0,14.27,40.96).
city('Ottaviano','it','Campania',23161.0,14.46,40.86).
city('Pagani','it','Campania',32580.0,14.61,40.76).
city('Palma Campania','it','Campania',14741.0,14.55,40.87).
city('Pellezzano','it','Campania',10969.0,14.75,40.72).
city('Piano di Sorrento','it','Campania',13111.0,14.4,40.64).
city('Piedimonte Matese','it','Campania',11491.0,14.37,41.35).
city('Poggiomarino','it','Campania',21214.0,14.53,40.81).
city('Pollena Trocchia','it','Campania',14255.0,14.37,40.85).
city('Pomigliano dArco','it','Campania',39555.0,14.38,40.9).
city('Pompei','it','Campania',26251.0,14.48,40.75).
city('Pontecagnano','it','Campania',22997.0,14.88,40.65).
city('Portici','it','Campania',55775.0,14.34,40.81).
city('Pozzuoli','it','Campania',81237.0,14.12,40.83).
city('Procida','it','Campania',10835.0,14.02,40.77).
city('Qualiano','it','Campania',27149.0,14.15,40.92).
city('Quarto','it','Campania',38706.0,14.14,40.88).
city('Roccapiemonte','it','Campania',9368.0,14.69,40.76).
city('Sala Consilina','it','Campania',12903.0,15.58,40.4).
city('Salerno','it','Campania',144147.0,14.77,40.68).
city('San Cipriano dAversa','it','Campania',12187.0,14.13,41.0).
city('San Felice a Cancello','it','Campania',17021.0,14.49,41.02).
city('San Gennaro Vesuviano','it','Campania',10955.0,14.53,40.88).
city('San Giorgio a Cremano','it','Campania',50887.0,14.33,40.83).
city('San Giorgio del Sannio','it','Campania',9929.0,14.85,41.06).
city('San Giuseppe Vesuviano','it','Campania',22551.0,14.5,40.84).
city('San Marcellino','it','Campania',12071.0,14.18,40.98).
city('San Marzano sul Sarno','it','Campania',9501.0,14.58,40.77).
city('San Nicola','it','Campania',19627.0,15.8,38.27).
city('San Prisco','it','Campania',10730.0,14.28,41.09).
city('San Sebastiano al Vesuvio','it','Campania',9931.0,14.37,40.84).
city('SantAgata de Goti','it','Campania',11935.0,14.5,41.09).
city('SantAnastasia','it','Campania',27612.0,14.4,40.87).
city('SantAntimo','it','Campania',32044.0,14.24,40.94).
city('SantAntoni','it','Campania',18954.0,14.53,40.72).
city('SantArpino','it','Campania',14291.0,14.25,40.97).
city('Santa Maria Capua Vetere','it','Campania',29780.0,14.26,41.09).
city('Santa Maria a Vico','it','Campania',14211.0,14.48,41.04).
city('Santa Maria la Carita','it','Campania',11264.0,14.52,40.71).
city('Sarno','it','Campania',31278.0,14.61,40.82).
city('Saviano','it','Campania',15792.0,14.51,40.91).
city('Scafati','it','Campania',48113.0,14.51,40.75).
city('Sessa Aurunca','it','Campania',22821.0,13.93,41.24).
city('Siano','it','Campania',10613.0,14.69,40.8).
city('Solofra','it','Campania',12419.0,14.85,40.84).
city('Somma Vesuviana','it','Campania',35196.0,14.44,40.88).
city('Sorrento','it','Campania',15308.0,14.37,40.63).
city('Teano','it','Campania',12806.0,14.06,41.25).
city('Terzigno','it','Campania',17155.0,14.5,40.81).
city('Torre Annunziata','it','Campania',47211.0,14.45,40.76).
city('Torre del Greco','it','Campania',88006.0,14.36,40.79).
city('Trecase','it','Campania',8975.0,14.44,40.77).
city('Trentola-Ducenta','it','Campania',15215.0,14.17,40.97).
city('Vico Equense','it','Campania',20756.0,14.42,40.67).
city('Vietri sul Mare','it','Campania',8105.0,14.71,40.68).
city('Villa Literno','it','Campania',10562.0,14.07,41.01).
city('Villaricca','it','Campania',28190.0,14.2,40.91).
city('Volla','it','Campania',22814.0,14.34,40.88).
city('Alfonsine','it','Emilia-Romagna',11963.0,12.04,44.51).
city('Anzola dellEmilia','it','Emilia-Romagna',10918.0,11.18,44.55).
city('Argenta','it','Emilia-Romagna',22005.0,11.82,44.63).
city('Bagnacavallo','it','Emilia-Romagna',16423.0,12.0,44.42).
city('Bellaria-Igea Marina','it','Emilia-Romagna',16743.0,12.45,44.15).
city('Bertinoro','it','Emilia-Romagna',9941.0,12.14,44.15).
city('Bologna','it','Emilia-Romagna',367168.0,11.34,44.5).
city('Bondeno','it','Emilia-Romagna',15698.0,11.4,44.89).
city('Budrio','it','Emilia-Romagna',16322.0,11.53,44.54).
city('Calderara di Reno','it','Emilia-Romagna',12521.0,11.28,44.57).
city('Carpi','it','Emilia-Romagna',63336.0,10.87,44.79).
city('Casalecchio di Reno','it','Emilia-Romagna',33288.0,11.24,44.47).
city('Casalgrande','it','Emilia-Romagna',15082.0,10.74,44.59).
city('Castel Maggiore','it','Emilia-Romagna',17023.0,11.36,44.57).
city('Castel San Giovanni','it','Emilia-Romagna',12316.0,9.43,45.07).
city('Castel San Pietro Terme','it','Emilia-Romagna',20368.0,11.57,44.4).
city('Castelfranco Emilia','it','Emilia-Romagna',27398.0,11.04,44.6).
city('Castellarano','it','Emilia-Romagna',13323.0,10.73,44.51).
city('Castelnovo ne Monti','it','Emilia-Romagna',10532.0,10.39,44.44).
city('Castelnuovo Rangone','it','Emilia-Romagna',13498.0,10.95,44.55).
city('Castelvetro di Modena','it','Emilia-Romagna',10604.0,10.95,44.51).
city('Castenaso','it','Emilia-Romagna',14193.0,11.47,44.51).
city('Cattolica','it','Emilia-Romagna',16157.0,12.81,43.95).
city('Cento','it','Emilia-Romagna',30001.0,11.27,44.74).
city('Cervia','it','Emilia-Romagna',26914.0,12.35,44.28).
city('Cesena','it','Emilia-Romagna',92280.0,12.24,44.15).
city('Cesenatico','it','Emilia-Romagna',22479.0,12.39,44.2).
city('Codigoro','it','Emilia-Romagna',13147.0,12.09,44.83).
city('Collecchio','it','Emilia-Romagna',12647.0,10.21,44.75).
city('Comacchio','it','Emilia-Romagna',20054.0,12.18,44.7).
city('Conselice','it','Emilia-Romagna',9011.0,11.82,44.52).
city('Copparo','it','Emilia-Romagna',18110.0,11.81,44.9).
city('Correggio','it','Emilia-Romagna',21540.0,10.77,44.78).
city('Crevalcore','it','Emilia-Romagna',12413.0,11.13,44.73).
city('Faenza','it','Emilia-Romagna',54919.0,11.87,44.29).
city('Ferrara','it','Emilia-Romagna',131252.0,11.61,44.84).
city('Fidenza','it','Emilia-Romagna',24218.0,10.06,44.88).
city('Finale Emilia','it','Emilia-Romagna',15665.0,11.28,44.84).
city('Fiorano Modenese','it','Emilia-Romagna',16817.0,10.81,44.53).
city('Fiorenzuola dArda','it','Emilia-Romagna',13804.0,9.9,44.94).
city('Forli','it','Emilia-Romagna',111574.0,12.03,44.22).
city('Forlimpopoli','it','Emilia-Romagna',11622.0,12.11,44.19).
city('Formigine','it','Emilia-Romagna',32419.0,10.85,44.58).
city('Gambettola','it','Emilia-Romagna',9889.0,12.34,44.12).
city('Guastalla','it','Emilia-Romagna',14572.0,10.65,44.93).
city('Imola','it','Emilia-Romagna',66903.0,11.7,44.36).
city('Lugo','it','Emilia-Romagna',32235.0,11.9,44.42).
city('Maranello','it','Emilia-Romagna',16988.0,10.87,44.53).
city('Medicina','it','Emilia-Romagna',14065.0,11.63,44.0).
city('Meldola','it','Emilia-Romagna',9851.0,11.06,44.85).
city('Mirandola','it','Emilia-Romagna',22173.0,11.06,44.89).
city('Modena','it','Emilia-Romagna',180641.0,10.92,44.65).
city('Molinella','it','Emilia-Romagna',14943.0,11.67,44.63).
city('Monte San Pietro','it','Emilia-Romagna',12106.0,11.13,44.43).
city('Noceto','it','Emilia-Romagna',11258.0,10.18,44.8).
city('Nonantola','it','Emilia-Romagna',13544.0,11.03,44.68).
city('Novellara','it','Emilia-Romagna',12598.0,10.73,44.86).
city('Novi di Modena','it','Emilia-Romagna',10896.0,10.9,44.91).
city('Parma','it','Emilia-Romagna',155693.0,10.32,44.81).
city('Pavullo nel Frignano','it','Emilia-Romagna',16114.0,10.83,44.35).
city('Piacenza','it','Emilia-Romagna',95453.0,9.68,45.06).
city('Pianoro','it','Emilia-Romagna',17497.0,11.34,44.37).
city('Portomaggiore','it','Emilia-Romagna',11910.0,11.8,44.71).
city('Quattro Castella','it','Emilia-Romagna',12369.0,10.46,44.64).
city('Ravenna','it','Emilia-Romagna',143396.0,12.21,44.42).
city('Reggio nellEmilia','it','Emilia-Romagna',149707.0,10.63,44.71).
city('Riccione','it','Emilia-Romagna',34228.0,12.65,44.01).
city('Rimini','it','Emilia-Romagna',132031.0,12.57,44.06).
city('Rubiera','it','Emilia-Romagna',12617.0,10.78,44.65).
city('Russi','it','Emilia-Romagna',10712.0,12.03,44.37).
city('Salsomaggiore Terme','it','Emilia-Romagna',18565.0,9.97,44.82).
city('San Felice sul Panaro','it','Emilia-Romagna',10589.0,11.13,44.84).
city('San Giovanni in Persiceto','it','Emilia-Romagna',25344.0,11.18,44.64).
city('San Lazzaro di Savena','it','Emilia-Romagna',29962.0,11.41,44.47).
city('San Pietro in Casale','it','Emilia-Romagna',10667.0,11.4,44.7).
city('SantIlario dEnza','it','Emilia-Romagna',10221.0,10.45,44.76).
city('Santarcangelo di Romagna','it','Emilia-Romagna',20287.0,12.45,44.07).
city('Sasso Marconi','it','Emilia-Romagna',14487.0,11.24,44.41).
city('Sassuolo','it','Emilia-Romagna',37446.0,10.77,44.55).
city('Savignano sul Rubicone','it','Emilia-Romagna',16276.0,12.4,44.1).
city('Scandiano','it','Emilia-Romagna',23918.0,10.71,44.6).
city('Soliera','it','Emilia-Romagna',14530.0,10.92,44.74).
city('Spilamberto','it','Emilia-Romagna',11472.0,11.01,44.54).
city('Vignola','it','Emilia-Romagna',22092.0,10.99,44.47).
city('Zola Predosa','it','Emilia-Romagna',15362.0,11.2,44.49).
city('Azzano Decimo','it','Friuli-Venezia Giulia',13421.0,12.72,45.89).
city('Cervignano del Friuli','it','Friuli-Venezia Giulia',12674.0,13.39,45.82).
city('Cividale del Friuli','it','Friuli-Venezia Giulia',11590.0,13.41,46.1).
city('Codroipo','it','Friuli-Venezia Giulia',14660.0,12.84,45.96).
city('Cordenons','it','Friuli-Venezia Giulia',17824.0,12.71,45.99).
city('Fiume Veneto','it','Friuli-Venezia Giulia',10556.0,12.73,45.93).
city('Fontanafredda','it','Friuli-Venezia Giulia',9796.0,12.56,45.97).
city('Gemona','it','Friuli-Venezia Giulia',11061.0,13.14,46.29).
city('Gorizia','it','Friuli-Venezia Giulia',34602.0,13.62,45.94).
city('Grado','it','Friuli-Venezia Giulia',8658.0,13.38,45.68).
city('Latisana','it','Friuli-Venezia Giulia',12432.0,12.99,45.78).
city('Maniago','it','Friuli-Venezia Giulia',12299.0,12.69,46.18).
city('Monfalcone','it','Friuli-Venezia Giulia',26331.0,13.53,45.82).
city('Muggia','it','Friuli-Venezia Giulia',13470.0,13.76,45.62).
city('Porcia','it','Friuli-Venezia Giulia',13981.0,12.6,45.95).
city('Pordenone','it','Friuli-Venezia Giulia',48581.0,12.65,45.97).
city('Ronchi dei Legionari','it','Friuli-Venezia Giulia',11746.0,13.5,45.84).
city('Sacile','it','Friuli',18935.0,12.5,45.95).
city('San Vito al Tagliamento','it','Friuli-Venezia Giulia',13834.0,12.86,45.9).
city('Spilimbergo','it','Friuli-Venezia Giulia',11193.0,12.9,46.12).
city('Tavagnacco','it','Friuli-Venezia Giulia',12877.0,13.22,46.13).
city('Tolmezzo','it','Friuli-Venezia Giulia',10777.0,13.01,46.4).
city('Trieste','it','Friuli-Venezia Giulia',204379.0,13.77,45.65).
city('Udine','it','Friuli-Venezia Giulia',94597.0,13.24,46.07).
city('Alatri','it','Lazio',30322.0,13.34,41.73).
city('Albano Laziale','it','Lazio',37869.0,12.66,41.72).
city('Anagni','it','Lazio',21519.0,13.14,41.75).
city('Anguillara Sabazia','it','Lazio',17734.0,12.26,42.09).
city('Anzio','it','Lazio',41629.0,12.62,41.46).
city('Aprilia','it','Lazio',67935.0,12.65,41.6).
city('Ardea','it','Lazio',32934.0,12.55,41.6).
city('Ariccia','it','Lazio',19033.0,12.67,41.72).
city('Artena','it','Lazio',11564.0,12.91,41.75).
city('Bracciano','it','Lazio',15003.0,12.16,42.1).
city('Cassino','it','Lazio',35683.0,13.82,41.5).
city('Cave','it','Lazio',11014.0,12.93,41.82).
city('Ceccano','it','Lazio',24918.0,13.32,41.58).
city('Cerveteri','it','Lazio',33069.0,12.1,42.0).
city('Ciampino','it','Lazio',40686.0,12.6,41.8).
city('Cisterna','it','Lazio',35945.0,12.8,41.61).
city('Civita Castellana','it','Lazio',16785.0,12.4,42.29).
city('Civitavecchia','it','Lazio',51480.0,11.78,42.09).
city('Colleferro','it','Lazio',22123.0,12.98,41.74).
city('Cori','it','Lazio',11826.0,12.91,41.65).
city('Fara in Sabina','it','Lazio',12825.0,12.73,42.21).
city('Ferentino','it','Lazio',22555.0,13.24,41.7).
city('Fiumicino','it','Lazio',56970.0,12.23,41.77).
city('Fondi','it','Lazio',35157.0,13.42,41.36).
city('Formello','it','Lazio',11097.0,12.4,42.08).
city('Formia','it','Lazio',40726.0,13.59,41.26).
city('Frascati','it','Lazio',21305.0,12.68,41.82).
city('Frosinone','it','Lazio',49775.0,13.35,41.65).
city('Gaeta','it','Lazio',22566.0,13.56,41.22).
city('Genzano di Roma','it','Lazio',24626.0,12.67,41.71).
city('Grottaferrata','it','Lazio',19485.0,12.66,41.8).
city('Guidonia','it','Lazio',81837.0,12.68,42.02).
city('Isola del Liri','it','Lazio',12893.0,13.57,41.69).
city('Ladispoli','it','Lazio',34995.0,12.09,41.95).
city('Lanuvio','it','Lazio',11458.0,12.7,41.67).
city('Lariano','it','Lazio',12092.0,12.83,41.73).
city('Latina','it','Lazio',124330.0,12.89,41.47).
city('Marino','it','Lazio',32905.0,12.65,41.77).
city('Mentana','it','Lazio',14925.0,12.68,42.03).
city('Minturno','it','Lazio',19520.0,13.74,41.28).
city('Monte San Giovanni Campano','it','Lazio',13538.0,13.51,41.64).
city('Montefiascone','it','Lazio',13326.0,12.02,42.54).
city('Monterotondo','it','Lazio',40249.0,12.62,42.05).
city('Nettuno','it','Lazio',40642.0,12.68,41.47).
city('Palestrina','it','Lazio',18697.0,12.77,41.85).
city('Palombara Sabina','it','Lazio',12787.0,12.76,42.07).
city('Pomezia','it','Lazio',48859.0,12.51,41.68).
city('Pontecorvo','it','Lazio',14863.0,13.68,41.46).
city('Pontinia','it','Lazio',14621.0,13.03,41.41).
city('Priverno','it','Lazio',14494.0,13.17,41.48).
city('Rieti','it','Lazio',45355.0,12.86,42.41).
city('Rocca Priora','it','Lazio',11117.0,12.75,41.8).
city('Rocca di Papa','it','Lazio',15026.0,12.7,41.77).
city('Rome','it','Lazio',2643736.0,12.5,41.89).
city('Sabaudia','it','Lazio',18951.0,13.02,41.3).
city('San Cesareo','it','Lazio',11312.0,12.8,41.82).
city('Santa Marinella','it','Lazio',17577.0,11.84,42.04).
city('Sezze','it','Lazio',24214.0,13.16,41.52).
city('Sora','it','Lazio',25977.0,13.6,41.73).
city('Subiaco','it','Lazio',9932.0,13.09,41.93).
city('Tarquinia','it','Lazio',16898.0,11.75,42.26).
city('Terracina','it','Lazio',37984.0,13.24,41.3).
city('Tivoli','it','Lazio',49303.0,12.79,41.96).
city('Valmontone','it','Lazio',14448.0,12.91,41.78).
city('Velletri','it','Lazio',56758.0,12.76,41.69).
city('Veroli','it','Lazio',22352.0,13.41,41.69).
city('Vetralla','it','Lazio',13250.0,12.04,42.33).
city('Viterbo','it','Lazio',63299.0,12.09,42.42).
city('Zagarolo','it','Lazio',14410.0,12.8,41.84).
city('Alassio','it','Liguria',10384.0,8.17,44.02).
city('Albenga','it','Liguria',22761.0,8.21,44.05).
city('Albisola Superiore','it','Liguria',10751.0,8.49,44.31).
city('Arcola','it','Liguria',10170.0,9.91,44.12).
city('Arenzano','it','Liguria',11572.0,8.72,44.43).
city('Bordighera','it','Liguria',9965.0,7.67,43.8).
city('Cairo Montenotte','it','Liguria',13547.0,8.26,44.41).
city('Chiavari','it','Liguria',27277.0,9.34,44.32).
city('Cogoleto','it','Liguria',9148.0,8.71,44.42).
city('Finale Ligu','it','Liguria',11543.0,8.34,44.18).
city('Genoa','it','Liguria',585815.0,8.93,44.42).
city('Imperia','it','Liguria',39987.0,8.03,43.9).
city('La Spezia','it','Liguria',89012.0,9.83,44.13).
city('Lavagna','it','Liguria',13002.0,9.35,44.31).
city('Lerici','it','Liguria',10684.0,9.91,44.09).
city('Loano','it','Liguria',10375.0,8.25,44.14).
city('Pietra Ligure','it','Liguria',8301.0,8.29,44.16).
city('Rapallo','it','Liguria',29379.0,9.23,44.36).
city('Recco','it','Liguria',10341.0,9.15,44.38).
city('San Remo','it','Liguria',49053.0,7.77,43.83).
city('Santa Margherita Ligure','it','Liguria',10310.0,9.2,44.34).
city('Sarzana','it','Liguria',20596.0,9.95,44.12).
city('Savona','it','Liguria',58302.0,8.46,44.32).
city('Sestri Levante','it','Liguria',18906.0,9.39,44.28).
city('Taggia','it','Liguria',12367.0,7.85,43.87).
city('Varazze','it','Liguria',13464.0,8.67,44.41).
city('Ventimiglia','it','Liguria',24734.0,7.6,43.8).
city('Abbiategrasso','it','Lombardy',30308.0,8.91,45.41).
city('Agrate Brianza','it','Lombardy',14002.0,9.34,45.57).
city('Albino','it','Lombardy',17387.0,9.78,45.77).
city('Alzano Lombardo','it','Lombardy',12767.0,9.72,45.73).
city('Arcisate','it','Lombardy',9833.0,8.86,45.86).
city('Arcore','it','Lombardy',17361.0,9.31,45.62).
city('Arese','it','Lombardy',19649.0,9.08,45.54).
city('Arluno','it','Lombardy',10662.0,8.93,45.5).
city('Asola','it','Lombardy',10112.0,10.4,45.22).
city('Bagnolo Mella','it','Lombardy',12165.0,10.15,45.44).
city('Bareggio','it','Lombardy',17271.0,8.98,45.47).
city('Bergamo','it','Lombardy',113603.0,9.67,45.7).
city('Besana in Brianza','it','Lombardy',15703.0,9.29,45.7).
city('Biassono','it','Lombardy',12090.0,9.27,45.62).
city('Bollate','it','Lombardy',49620.0,9.12,45.56).
city('Botticino','it','Lombardy',10222.0,10.3,45.54).
city('Bovisio-Masciago','it','Lombardy',14364.0,9.13,45.62).
city('Brescia','it','Lombardy',193713.0,10.22,45.55).
city('Bresso','it','Lombardy',26815.0,9.18,45.54).
city('Broni','it','Lombardy',9514.0,9.3,45.09).
city('Brugherio','it','Lombardy',32439.0,9.3,45.55).
city('Buccinasco','it','Lombardy',29180.0,9.11,45.42).
city('Busto Arsizio','it','Lombardy',79229.0,8.84,45.62).
city('Busto Garolfo','it','Lombardy',13520.0,8.87,45.55).
city('Calcinato','it','Lombardy',11817.0,10.4,45.45).
city('Calolziocorte','it','Lombardy',14168.0,9.43,45.8).
city('Canegrate','it','Lombardy',12649.0,8.93,45.57).
city('Cantu','it','Lombardy',36513.0,9.12,45.74).
city('Carate Brianza','it','Lombardy',17114.0,9.23,45.69).
city('Caravaggio','it','Lombardy',14976.0,9.63,45.5).
city('Cardano al Campo','it','Lombardy',12946.0,8.77,45.64).
city('Caronno Pertusella','it','Lombardy',12775.0,9.05,45.6).
city('Carpenedolo','it','Lombardy',11306.0,10.43,45.37).
city('Carugate','it','Lombardy',14033.0,9.33,45.55).
city('Casalmaggiore','it','Lombardy',14802.0,10.42,44.99).
city('Casalpusterlengo','it','Lombardy',14586.0,9.64,45.19).
city('Casatenovo','it','Lombardy',13014.0,9.31,45.7).
city('Cassano dAdda','it','Lombardy',17711.0,9.51,45.54).
city('Cassina de Pecchi','it','Lombardy',12692.0,9.37,45.52).
city('Castano Primo','it','Lombardy',10792.0,8.77,45.56).
city('Castel Goffredo','it','Lombardy',10916.0,10.48,45.3).
city('Castellanza','it','Lombardy',14926.0,8.89,45.62).
city('Castiglione delle Stiviere','it','Lombardy',20166.0,10.48,45.39).
city('Cazzago San Martino','it','Lombardy',10732.0,10.02,45.58).
city('Cernusco sul Naviglio','it','Lombardy',27540.0,9.33,45.53).
city('Cerro Maggiore','it','Lombardy',14181.0,8.95,45.59).
city('Cesano Boscone','it','Lombardy',24190.0,9.12,45.64).
city('Cesano Maderno','it','Lombardy',34758.0,9.13,45.63).
city('Cesate','it','Lombardy',13619.0,9.08,45.6).
city('Chiari','it','Lombardy',18414.0,9.92,45.54).
city('Cinisello Balsamo','it','Lombardy',74123.0,9.17,45.56).
city('Codogno','it','Lombardy',14558.0,9.69,45.17).
city('Cologno Monzese','it','Lombardy',47871.0,9.27,45.54).
city('Cologno al Serio','it','Lombardy',10175.0,9.71,45.58).
city('Como','it','Lombardy',78582.0,9.08,45.81).
city('Concesio','it','Lombardy',13732.0,10.22,45.6).
city('Concorezzo','it','Lombardy',14646.0,9.33,45.59).
city('Corbetta','it','Lombardy',14474.0,89.92,45.46).
city('Cormano','it','Lombardy',18545.0,9.16,45.54).
city('Cornaredo','it','Lombardy',21091.0,9.02,45.5).
city('Cornate dAdda','it','Lombardy',10089.0,9.47,45.65).
city('Corsico','it','Lombardy',32168.0,9.11,45.44).
city('Crema','it','Lombardy',34359.0,9.69,45.37).
city('Cremona','it','Lombardy',70748.0,10.01,45.15).
city('Curtatone','it','Lombardy',13826.0,7.65,45.39).
city('Cusano Milanino','it','Lombardy',19368.0,9.18,45.55).
city('Dalmine','it','Lombardy',23928.0,9.59,45.65).
city('Darfo','it','Lombardy',14391.0,10.17,45.87).
city('Desenzano del Garda','it','Lombardy',25974.0,10.52,45.47).
city('Desio','it','Lombardy',36708.0,9.2,45.63).
city('Erba','it','Lombardy',17258.0,9.22,45.82).
city('Fagnano Olona','it','Lombardy',10957.0,8.86,45.67).
city('Gallarate','it','Lombardy',48529.0,8.78,45.68).
city('Garbagnate Milanese','it','Lombardy',29295.0,9.06,45.57).
city('Gardone Val Trompia','it','Lombardy',11478.0,10.18,45.7).
city('Garlasco','it','Lombardy',9429.0,8.91,45.21).
city('Gavardo','it','Lombardy',10948.0,10.43,45.59).
city('Gavirate','it','Lombardy',9910.0,8.72,45.84).
city('Ghedi','it','Lombardy',16690.0,10.24,45.42).
city('Giussano','it','Lombardy',23745.0,9.21,45.71).
city('Goito','it','Lombardy',10185.0,10.67,45.25).
city('Gorgonzola','it','Lombardy',19167.0,9.4,45.54).
city('Gussago','it','Lombardy',15585.0,10.15,45.6).
city('Induno Olona','it','Lombardy',10325.0,8.84,45.85).
city('Lainate','it','Lombardy',25446.0,9.03,45.57).
city('Lecco','it','Lombardy',47113.0,9.41,45.86).
city('Legnano','it','Lombardy',57996.0,8.91,45.61).
city('Leno','it','Lombardy',13604.0,10.2,45.37).
city('Lentate sul Seveso','it','Lombardy',15205.0,9.11,45.69).
city('Limbiate','it','Lombardy',31736.0,9.11,45.6).
city('Lissone','it','Lombardy',37137.0,9.23,45.62).
city('Lodi','it','Lombardy',41043.0,9.5,45.32).
city('Lonate Pozzolo','it','Lombardy',12316.0,8.74,45.6).
city('Lonato','it','Lombardy',13196.0,10.47,45.45).
city('Luino','it','Lombardy',14450.0,8.73,46.0).
city('Lumezzane','it','Lombardy',24338.0,10.27,45.65).
city('Lurate Caccivio','it','Lombardy',10369.0,9.0,45.77).
city('Magenta','it','Lombardy',23621.0,8.87,45.47).
city('Malnate','it','Lombardy',16282.0,8.87,45.8).
city('Mandello del Lario','it','Lombardy',10196.0,9.31,45.92).
city('Manerbio','it','Lombardy',13349.0,10.13,45.36).
city('Mantova','it','Lombardy',45959.0,10.79,45.16).
city('Mariano Comense','it','Lombardy',21877.0,9.17,45.7).
city('Meda','it','Lombardy',22048.0,9.15,45.67).
city('Melegnano','it','Lombardy',16155.0,9.32,45.37).
city('Melzo','it','Lombardy',19453.0,9.42,45.51).
city('Merate','it','Lombardy',14801.0,9.41,45.72).
city('Milan','it','Lombardy',1156903.0,9.19,45.48).
city('Montichiari','it','Lombardy',21041.0,10.4,45.41).
city('Monza','it','Lombardy',120857.0,9.27,45.58).
city('Morbegno','it','Lombardy',11775.0,9.57,46.14).
city('Mortara','it','Lombardy',14300.0,8.73,45.27).
city('Muggio','it','Lombardy',21561.0,9.23,45.59).
city('Nave','it','Lombardy',11001.0,10.28,45.59).
city('Nembro','it','Lombardy',11635.0,9.76,45.75).
city('Nerviano','it','Lombardy',18000.0,8.96,45.55).
city('Nova Milanese','it','Lombardy',23655.0,9.2,45.59).
city('Novate Milanese','it','Lombardy',20576.0,9.13,45.54).
city('Olgiate Comasco','it','Lombardy',11261.0,8.97,45.78).
city('Olgiate Olona','it','Lombardy',11628.0,8.88,45.64).
city('Opera','it','Lombardy',13986.0,9.21,45.38).
city('Orzinuovi','it','Lombardy',12022.0,9.92,45.41).
city('Osio Sotto','it','Lombardy',11415.0,9.6,45.61).
city('Ospitaletto','it','Lombardy',12368.0,10.59,45.14).
city('Paderno Dugnano','it','Lombardy',47733.0,9.16,45.55).
city('Palazzolo sullOglio','it','Lombardy',18409.0,9.88,45.61).
city('Parabiago','it','Lombardy',25186.0,8.94,45.56).
city('Paullo','it','Lombardy',10758.0,9.4,45.42).
city('Pavia','it','Lombardy',71520.0,9.15,45.2).
city('Pero','it','Lombardy',10759.0,9.08,45.51).
city('Peschiera Borromeo','it','Lombardy',21791.0,9.33,45.43).
city('Pieve Emanuele','it','Lombardy',17668.0,10.74,45.77).
city('Pioltello','it','Lombardy',32312.0,9.33,45.5).
city('Ponte San Pietro','it','Lombardy',9873.0,9.58,45.71).
city('Porto Mantovano','it','Lombardy',14496.0,10.79,45.19).
city('Rescaldina','it','Lombardy',14194.0,8.95,45.61).
city('Rezzato','it','Lombardy',13190.0,10.31,45.52).
city('Rho','it','Lombardy',53558.0,9.04,45.54).
city('Romano di Lombardia','it','Lombardy',16358.0,9.75,45.52).
city('Rovato','it','Lombardy',15569.0,10.0,45.57).
city('Rozzano','it','Lombardy',36179.0,9.15,45.37).
city('Salo','it','Lombardy',10525.0,10.51,45.62).
city('Samarate','it','Lombardy',16128.0,8.78,45.64).
city('San Donato Milanese','it','Lombardy',33116.0,9.26,45.42).
city('San Giuliano Milanese','it','Lombardy',32437.0,9.28,45.41).
city('SantAngelo Lodigiano','it','Lombardy',12996.0,9.41,45.24).
city('Sarezzo','it','Lombardy',12423.0,10.19,45.66).
city('Saronno','it','Lombardy',38080.0,9.02,45.64).
city('Sedriano','it','Lombardy',11231.0,8.97,45.48).
city('Segrate','it','Lombardy',33249.0,9.28,45.49).
city('Senago','it','Lombardy',20198.0,9.11,45.59).
city('Seregno','it','Lombardy',40237.0,9.19,45.66).
city('Seriate','it','Lombardy',21795.0,9.71,45.7).
city('Sesto Calende','it','Lombardy',10402.0,8.62,45.74).
city('Sesto San Giovanni','it','Lombardy',74668.0,9.23,45.55).
city('Settimo Milanese','it','Lombardy',19208.0,9.05,45.48).
city('Seveso','it','Lombardy',20142.0,9.14,45.65).
city('Solaro','it','Lombardy',13435.0,9.16,44.89).
city('Somma Lombardo','it','Lombardy',16935.0,8.7,45.7).
city('Sondrio','it','Lombardy',22064.0,9.86,46.18).
city('Soresina','it','Lombardy',8947.0,9.85,45.29).
city('Stezzano','it','Lombardy',11844.0,9.65,45.65).
city('Stradella','it','Lombardy',11050.0,9.26,45.08).
city('Suzzara','it','Lombardy',18304.0,10.75,45.01).
city('Tirano','it','Lombardy',9546.0,10.17,46.22).
city('Tradate','it','Lombardy',16621.0,8.9,45.72).
city('Travagliato','it','Lombardy',12234.0,10.07,45.53).
city('Treviglio','it','Lombardy',27200.0,9.59,45.53).
city('Trezzano sul Naviglio','it','Lombardy',18220.0,9.07,45.42).
city('Trez','it','Lombardy',12360.0,9.51,45.62).
city('Uboldo','it','Lombardy',10376.0,9.0,45.62).
city('Valmadrera','it','Lombardy',11574.0,9.35,45.85).
city('Varedo','it','Lombardy',13151.0,9.14,45.61).
city('Varese','it','Lombardy',84371.0,8.83,45.83).
city('Viadana','it','Lombardy',18158.0,10.51,44.94).
city('Vigevano','it','Lombardy',55078.0,8.85,45.33).
city('Villa Carcina','it','Lombardy',10481.0,10.19,45.63).
city('Villasanta','it','Lombardy',14218.0,9.29,45.62).
city('Vimercate','it','Lombardy',26053.0,9.36,45.63).
city('Vimodrone','it','Lombardy',14040.0,9.26,45.5).
city('Virgilio','it','Lombardy',10891.0,10.79,45.12).
city('Voghera','it','Lombardy',38848.0,9.0,45.0).
city('Zogno','it','Lombardy',9607.0,9.66,45.8).
city('Ancona','it','Marche',100982.0,13.5,43.6).
city('Ascoli Piceno','it','Marche',50092.0,13.58,42.86).
city('Cagli','it','Marche',9068.0,12.64,43.56).
city('Castelfidardo','it','Marche',17870.0,13.54,43.47).
city('Chiaravalle','it','Marche',14334.0,13.31,43.6).
city('Cingoli','it','Marche',10261.0,13.21,43.37).
city('Civitanova Marche','it','Marche',39288.0,13.72,43.31).
city('Corridonia','it','Marche',14425.0,13.5,43.26).
city('Fabriano','it','Marche',31087.0,12.89,43.34).
city('Falconara Marittima','it','Marche',27917.0,13.39,43.63).
city('Fano','it','Marche',59864.0,13.01,43.85).
city('Fermo','it','Marche',36060.0,13.7,43.17).
city('Filottrano','it','Marche',9550.0,13.34,43.44).
city('Fossombrone','it','Marche',9621.0,12.79,43.69).
city('Grottammare','it','Marche',15057.0,13.86,42.99).
city('Jesi','it','Marche',39463.0,13.24,43.52).
city('Loreto','it','Marche',11701.0,13.59,43.43).
city('Macerata','it','Marche',40893.0,13.44,43.3).
city('Matelica','it','Marche',10294.0,13.01,43.27).
city('Mondolfo','it','Marche',11477.0,13.11,43.76).
city('Montegranaro','it','Marche',13039.0,13.63,43.24).
city('Montemarciano','it','Marche',10012.0,13.3,43.64).
city('Monteprandone','it','Marche',11113.0,13.83,42.92).
city('Morrovalle','it','Marche',9723.0,13.57,43.32).
city('Osimo','it','Marche',30463.0,13.47,43.49).
city('Pesaro','it','Marche',91817.0,12.91,43.92).
city('Porto Recanati','it','Marche',10233.0,13.67,43.43).
city('Porto San Giorgio','it','Marche',16010.0,13.88,43.19).
city('Porto SantElpidio','it','Marche',22433.0,13.76,43.26).
city('Potenza Picena','it','Marche',15044.0,13.62,43.37).
city('Recanati','it','Marche',20540.0,13.54,43.41).
city('San Benedetto del Tronto','it','Marche',43767.0,13.87,42.96).
city('San Severino Marche','it','Marche',12896.0,13.24,43.27).
city('SantElpidio a Mare','it','Marche',15560.0,13.69,43.23).
city('Senigallia','it','Marche',42180.0,13.21,43.72).
city('Tolentino','it','Marche',19055.0,13.27,43.21).
city('Treia','it','Marche',9673.0,13.32,43.32).
city('Urbino','it','Marche',15284.0,12.63,43.74).
city('Campobasso','it','Molise',47569.0,14.65,41.57).
city('Isernia','it','Molise',21409.0,14.31,41.59).
city('Termoli','it','Molise',32917.0,15.02,41.98).
city('Venafro','it','Molise',12050.0,14.03,41.5).
city('Acqui Terme','it','Piemonte',19410.0,8.46,44.68).
city('Alba','it','Piemonte',30860.0,8.03,44.71).
city('Alexandria','it','Piemonte',81921.0,8.61,44.92).
city('Alpignano','it','Piemonte',17390.0,7.51,45.11).
city('Arona','it','Piemonte',14423.0,8.52,45.8).
city('Asti','it','Piemonte',72194.0,8.21,44.92).
city('Avigliana','it','Piemonte',12080.0,7.38,45.1).
city('Beinasco','it','Piemonte',17416.0,7.58,45.02).
city('Biella','it','Piemonte',45636.0,8.06,45.58).
city('Borgaro Torinese','it','Piemonte',14353.0,7.66,45.15).
city('Borgo San Dalmazzo','it','Piemonte',11857.0,7.49,44.34).
city('Borgomanero','it','Piemonte',20133.0,8.46,45.71).
city('Borgosesia','it','Piemonte',14144.0,8.26,45.72).
city('Boves','it','Piemonte',9782.0,7.55,44.32).
city('Bra','it','Piemonte',29454.0,7.83,44.7).
city('Busca','it','Piemonte',10168.0,7.48,44.52).
city('Cameri','it','Piemonte',10236.0,8.66,45.5).
city('Canelli','it','Piemonte',10595.0,8.28,44.72).
city('Carmagnola','it','Piemonte',25658.0,7.71,44.86).
city('Casale Monferrato','it','Piemonte',35337.0,8.45,45.14).
city('Caselle Torinese','it','Piemonte',16826.0,7.64,45.17).
city('Castellamonte','it','Piemonte',9437.0,7.69,45.39).
city('Castelletto sopra Ticino','it','Piemonte',9416.0,8.63,45.72).
city('Chieri','it','Piemonte',33804.0,7.82,45.03).
city('Chivasso','it','Piemonte',23591.0,7.88,45.21).
city('Cirie','it','Piemonte',18882.0,7.53,45.26).
city('Collegno','it','Piemonte',17767.0,7.6,45.09).
city('Cossato','it','Piemonte',15921.0,8.16,45.57).
city('Cuneo','it','Piemonte',52500.0,7.54,44.39).
city('Cuorgne','it','Piemonte',10371.0,7.65,45.38).
city('Domodossola','it','Piemonte',18887.0,8.29,46.12).
city('Fossano','it','Piemonte',25133.0,7.72,44.56).
city('Galliate','it','Piemonte',14035.0,8.7,45.49).
city('Giaveno','it','Piemonte',15884.0,7.35,45.04).
city('Grugliasco','it','Piemonte',37599.0,7.58,45.08).
city('Ivrea','it','Piemonte',23680.0,7.87,45.48).
city('Leini','it','Piemonte',12343.0,7.71,45.18).
city('Moncalieri','it','Piemonte',52820.0,7.69,45.02).
city('Mondo','it','Piemonte',22457.0,7.83,44.4).
city('Nichelino','it','Piemonte',49474.0,7.63,44.99).
city('Nizza Monferrato','it','Piemonte',10391.0,8.36,44.77).
city('Novara','it','Piemonte',105903.0,8.62,45.45).
city('Novi Ligure','it','Piemonte',27115.0,8.79,44.78).
city('Oleggio','it','Piemonte',13097.0,8.63,45.61).
city('Omegna','it','Piemonte',15940.0,8.39,45.89).
city('Orbassano','it','Piemonte',22805.0,7.53,45.02).
city('Ovada','it','Piemonte',11898.0,8.62,44.64).
city('Pianezza','it','Piemonte',11672.0,7.55,45.1).
city('Pinerolo','it','Piemonte',33807.0,7.33,44.9).
city('Piossasco','it','Piemonte',17036.0,7.46,45.0).
city('Poirino','it','Piemonte',9404.0,7.84,44.93).
city('Racconigi','it','Piemonte',10128.0,7.67,44.78).
city('Rivalta di Torino','it','Piemonte',19069.0,7.52,45.04).
city('Rivarolo Canavese','it','Piemonte',12497.0,7.68,45.35).
city('Rivoli','it','Piemonte',49959.0,7.51,45.09).
city('Saluzzo','it','Piemonte',16080.0,7.48,44.65).
city('San Mauro Torinese','it','Piemonte',18799.0,7.77,45.11).
city('Santena','it','Piemonte',10348.0,7.77,44.95).
city('Santhia','it','Piemonte',9614.0,8.16,45.37).
city('Savigliano','it','Piemonte',21161.0,7.66,44.66).
city('Settimo Torinese','it','Piemonte',47463.0,7.77,45.15).
city('Tortona','it','Piemonte',25129.0,8.85,44.91).
city('Trecate','it','Piemonte',18578.0,8.73,45.44).
city('Trofarello','it','Piemonte',11377.0,7.73,44.99).
city('Turin','it','Piemonte',846489.0,7.68,45.08).
city('Valenza','it','Piemonte',20625.0,8.63,45.02).
city('Venaria Reale','it','Piemonte',37806.0,7.63,45.14).
city('Verbania','it','Piemonte',31209.0,8.55,45.94).
city('Vercelli','it','Piemonte',45114.0,8.41,45.34).
city('Vinovo','it','Piemonte',14004.0,7.63,44.95).
city('Volpiano','it','Piemonte',13842.0,7.76,45.21).
city('Alghero','it','Sardegna',42034.0,8.31,40.57).
city('Arzachena','it','Sardegna',11716.0,9.38,41.09).
city('Assemini','it','Sardegna',26309.0,9.0,39.29).
city('Cabras','it','Sardegna',9249.0,8.51,39.94).
city('Cagliari','it','Sardegna',157343.0,9.1,39.22).
city('Capoterra','it','Sardegna',25572.0,8.96,39.19).
city('Carbonia','it','Sardegna',31508.0,8.52,39.18).
city('Guspini','it','Sardegna',13229.0,8.62,39.55).
city('Iglesias','it','Sardegna',30851.0,8.52,39.32).
city('Ittiri','it','Sardegna',9593.0,8.56,40.61).
city('La Maddalena','it','Sardegna',11885.0,9.4,41.22).
city('Macomer','it','Sardegna',11796.0,8.77,40.27).
city('Monserrato','it','Sardegna',23415.0,9.13,39.26).
city('Nuoro','it','Sardegna',38543.0,9.33,40.34).
city('Olbia','it','Sardegna',44903.0,9.5,40.93).
city('Oristano','it','Sardegna',30069.0,8.58,39.91).
city('Ozieri','it','Sardegna',11924.0,8.98,40.6).
city('Porto Torres','it','Sardegna',22302.0,8.4,40.85).
city('Quartu SantElena','it','Sardegna',75134.0,9.15,39.27).
city('Quartucciu','it','Sardegna',12145.0,9.16,39.25).
city('San Gavino Monreale','it','Sardegna',9814.0,8.78,39.55).
city('SantAntioco','it','Sardegna',12278.0,8.44,39.08).
city('Sassari','it','Sardegna',119187.0,8.56,40.73).
city('Selargius','it','Sardegna',30232.0,9.16,39.27).
city('Serramanna','it','Sardegna',9766.0,8.91,39.42).
city('Sestu','it','Sardegna',17618.0,9.08,39.3).
city('Siniscola','it','Sardegna',10187.0,9.68,40.58).
city('Sinnai','it','Sardegna',17218.0,9.18,39.3).
city('Sorso','it','Sardegna',13555.0,8.56,40.81).
city('Tempio Pausania','it','Sardegna',13947.0,9.09,40.91).
city('Terralba','it','Sardegna',9530.0,8.65,39.72).
city('Tortoli','it','Sardegna',11127.0,9.64,39.94).
city('Villacidro','it','Sardegna',15513.0,8.73,39.47).
city('Aci Castello','it','Sicily',18554.0,15.13,37.56).
city('Aci Catena','it','Sicily',31216.0,15.14,37.6).
city('Aci SantAntonio','it','Sicily',18411.0,15.11,37.6).
city('Acireale','it','Sicily',51967.0,15.17,37.62).
city('Adrano','it','Sicily',36184.0,14.83,37.67).
city('Agira','it','Sicily',8585.0,14.51,37.65).
city('Agrigento','it','Sicily',55402.0,13.58,37.31).
city('Alcamo','it','Sicily',44278.0,12.96,37.98).
city('Aragona','it','Sicily',10490.0,13.61,37.41).
city('Augusta','it','Sicily',33635.0,15.22,37.23).
city('Avola','it','Sicily',32767.0,15.13,36.92).
city('Bagheria','it','Sicily',55388.0,13.51,38.09).
city('Barcellona','it','Sicily',44788.0,15.21,38.16).
city('Barrafranca','it','Sicily',12737.0,14.19,37.37).
city('Belmonte Mezzagno','it','Sicily',11279.0,13.38,38.04).
city('Belpasso','it','Sicily',22316.0,14.97,37.59).
city('Biancavilla','it','Sicily',22829.0,14.87,37.64).
city('Bronte','it','Sicily',19134.0,14.86,37.83).
city('Caltagirone','it','Sicily',38753.0,14.51,37.24).
city('Caltanissetta','it','Sicily',64189.0,14.05,37.5).
city('Campobello di Licata','it','Sicily',11557.0,13.91,37.26).
city('Campobello di Mazara','it','Sicily',11225.0,12.74,37.64).
city('Canicatti','it','Sicily',32514.0,13.84,37.36).
city('Capaci','it','Sicily',10559.0,13.23,38.17).
city('Capo dOrlando','it','Sicily',13699.0,14.75,38.17).
city('Carini','it','Sicily',29785.0,13.2,38.15).
city('Carlentini','it','Sicily',17572.0,15.01,37.27).
city('Castelbuono','it','Sicily',10129.0,14.08,37.94).
city('Casteldaccia','it','Sicily',9671.0,13.53,38.05).
city('Castellammare del Golfo','it','Sicily',15504.0,12.87,38.03).
city('Casteltermini','it','Sicily',8384.0,13.64,37.55).
city('Castelvetrano','it','Sicily',27286.0,12.78,37.68).
city('Catania','it','Sicily',307331.0,15.08,37.5).
city('Cefalu','it','Sicily',14334.0,14.01,38.04).
city('Cinisi','it','Sicily',11305.0,13.1,38.15).
city('Comiso','it','Sicily',29575.0,14.6,36.95).
city('Corleone','it','Sicily',11982.0,13.3,37.81).
city('Enna','it','Sicily',30785.0,14.28,37.6).
city('Erice','it','Sicily',25160.0,12.58,38.04).
city('Favara','it','Sicily',31846.0,13.63,37.32).
city('Ficarazzi','it','Sicily',10829.0,13.47,38.08).
city('Fiumefreddo di Sicilia','it','Sicily',10302.0,14.2,37.79).
city('Floridia','it','Sicily',22616.0,15.16,37.1).
city('Francofonte','it','Sicily',13398.0,14.88,37.23).
city('Gela','it','Sicily',74959.0,14.21,37.08).
city('Giardini-Naxos','it','Sicily',9158.0,15.28,37.84).
city('Giarre','it','Sicily',27688.0,15.18,37.73).
city('Grammichele','it','Sicily',12797.0,14.63,37.22).
city('Gravina di Catania','it','Sicily',28007.0,15.06,37.56).
city('Ispica','it','Sicily',15238.0,14.91,36.79).
city('Lentini','it','Sicily',23235.0,14.99,37.29).
city('Leonforte','it','Sicily',14576.0,14.38,37.63).
city('Licata','it','Sicily',35018.0,13.93,37.11).
city('Lipari','it','Sicily',10649.0,14.94,38.47).
city('Marsala','it','Sicily',80755.0,12.43,37.81).
city('Mascali','it','Sicily',12525.0,15.2,37.75).
city('Mascalucia','it','Sicily',27703.0,15.05,37.57).
city('Mazara del Vallo','it','Sicily',50979.0,12.59,37.67).
city('Mazzarino','it','Sicily',12483.0,14.21,37.31).
city('Melilli','it','Sicily',13211.0,15.12,37.19).
city('Menfi','it','Sicily',13231.0,12.97,37.6).
city('Messina','it','Sicily',237956.0,15.55,38.19).
city('Milazzo','it','Sicily',30778.0,15.23,38.22).
city('Militello in Val di Catania','it','Sicily',8035.0,14.8,37.27).
city('Misilmeri','it','Sicily',25692.0,13.44,38.06).
city('Misterbianco','it','Sicily',46600.0,15.01,37.52).
city('Modica','it','Sicily',56282.0,14.76,36.87).
city('Monreale','it','Sicily',34544.0,13.31,38.11).
city('Motta SantAnastasia','it','Sicily',11667.0,14.97,37.52).
city('Mussomeli','it','Sicily',11846.0,13.73,37.59).
city('Naro','it','Sicily',8747.0,13.73,37.29).
city('Nicosia','it','Sicily',15416.0,14.39,37.75).
city('Niscemi','it','Sicily',29459.0,14.38,37.16).
city('Noto','it','Sicily',24049.0,15.07,36.89).
city('Paceco','it','Sicily',11418.0,12.54,37.99).
city('Pachino','it','Sicily',22301.0,15.08,36.72).
city('Palagonia','it','Sicily',17745.0,14.74,37.33).
city('Palazzolo Acreide','it','Sicily',9548.0,14.89,37.07).
city('Palermo','it','Sicily',669582.0,13.36,38.12).
city('Palma di Montechiaro','it','Sicily',21567.0,13.76,37.2).
city('Partanna','it','Sicily',11852.0,12.89,37.73).
city('Partinico','it','Sicily',32870.0,13.1,38.06).
city('Paterno','it','Sicily',47042.0,14.9,37.57).
city('Patti','it','Sicily',13703.0,14.96,38.14).
city('Pedara','it','Sicily',11579.0,15.07,37.64).
city('Piazza Armerina','it','Sicily',21864.0,14.36,37.38).
city('Porto Empedocle','it','Sicily',16110.0,13.53,37.29).
city('Pozzallo','it','Sicily',19030.0,14.83,36.73).
city('Priolo Gargallo','it','Sicily',12498.0,15.18,37.15).
city('Racalmuto','it','Sicily',10076.0,13.73,37.41).
city('Raffadali','it','Sicily',14023.0,13.53,37.41).
city('Ragusa','it','Sicily',72631.0,14.73,36.93).
city('Ramacca','it','Sicily',11219.0,14.7,37.39).
city('Randazzo','it','Sicily',11731.0,14.95,37.88).
city('Ravanusa','it','Sicily',13492.0,13.93,37.26).
city('Ribera','it','Sicily',21086.0,13.26,37.51).
city('Riesi','it','Sicily',11322.0,14.07,37.3).
city('Riposto','it','Sicily',14054.0,15.2,37.73).
city('Rosolini','it','Sicily',20671.0,14.95,36.82).
city('Salemi','it','Sicily',11937.0,12.8,37.82).
city('San Cataldo','it','Sicily',24487.0,14.0,37.5).
city('San Giovanni la Punta','it','Sicily',22970.0,15.11,37.59).
city('San Giuseppe Jato','it','Sicily',8380.0,13.18,37.98).
city('San Gregorio di Catania','it','Sicily',11616.0,15.1,37.57).
city('SantAgata di Militello','it','Sicily',13673.0,14.66,38.08).
city('SantAgata li Battiati','it','Sicily',10900.0,15.08,37.55).
city('Santa Flavia','it','Sicily',10630.0,13.53,38.09).
city('Sciacca','it','Sicily',42902.0,13.07,37.51).
city('Scicli','it','Sicily',27198.0,14.69,36.79).
city('Scordia','it','Sicily',17742.0,14.85,37.32).
city('Sortino','it','Sicily',9617.0,15.03,37.15).
city('Syracuse','it','Sicily',127666.0,15.29,37.07).
city('Taormina','it','Sicily',10160.0,15.28,37.86).
city('Termini Imerese','it','Sicily',27632.0,13.7,37.99).
city('Terrasini','it','Sicily',11269.0,13.08,38.16).
city('Trapani','it','Sicily',70031.0,12.52,38.03).
city('Tremestieri Etneo','it','Sicily',22917.0,15.07,37.58).
city('Troina','it','Sicily',10450.0,14.6,37.79).
city('Valderice','it','Sicily',12223.0,12.62,38.04).
city('Valguarnera Caropepe','it','Sicily',8991.0,14.38,37.5).
city('Villabate','it','Sicily',20927.0,13.43,38.07).
city('Vittoria','it','Sicily',56765.0,14.53,36.96).
city('Agliana','it','Toscana',15721.0,11.0,43.9).
city('Altopascio','it','Toscana',12150.0,10.66,43.82).
city('Arezzo','it','Toscana',95233.0,11.87,43.47).
city('Aulla','it','Toscana',10492.0,9.97,44.22).
city('Bagno a Ripoli','it','Toscana',25431.0,11.31,43.75).
city('Barberino di Mugello','it','Toscana',10271.0,11.24,44.0).
city('Barga','it','Toscana',10292.0,10.48,44.07).
city('Bibbiena','it','Toscana',12123.0,11.81,43.71).
city('Borgo San Lorenzo','it','Toscana',16628.0,11.38,43.95).
city('Bucine','it','Toscana',9940.0,11.62,43.47).
city('Calenzano','it','Toscana',15349.0,11.17,43.87).
city('Camaiore','it','Toscana',30860.0,10.3,43.95).
city('Campi Bisenzio','it','Toscana',39555.0,11.13,43.82).
city('Campiglia Marittima','it','Toscana',13014.0,10.61,43.06).
city('Capannori','it','Toscana',41274.0,10.55,43.84).
city('Carmignano','it','Toscana',13366.0,11.64,45.15).
city('Carrara','it','Toscana',67228.0,10.07,44.07).
city('Cascina','it','Toscana',40663.0,10.52,43.68).
city('Castelfiorentino','it','Toscana',17602.0,10.95,43.61).
city('Castelfranco di Sotto','it','Toscana',12130.0,10.75,43.7).
city('Castiglion Fiorentino','it','Toscana',12795.0,11.92,43.35).
city('Cecina','it','Toscana',27969.0,10.51,43.32).
city('Cerreto Guidi','it','Toscana',10208.0,10.89,43.76).
city('Certaldo','it','Toscana',16096.0,11.03,43.56).
city('Chiusi','it','Toscana',8100.0,11.94,43.02).
city('Colle di Val dElsa','it','Toscana',21350.0,11.12,43.43).
city('Collesalvetti','it','Toscana',16930.0,10.47,43.59).
city('Cortona','it','Toscana',22705.0,11.97,43.28).
city('Empoli','it','Toscana',45971.0,10.93,43.73).
city('Fiesole','it','Toscana',14295.0,11.25,43.81).
city('Figline Valdarno','it','Toscana',17130.0,11.46,43.62).
city('Fivizzano','it','Toscana',8971.0,10.11,44.24).
city('Florence','it','Toscana',347194.0,11.24,43.78).
city('Follonica','it','Toscana',21460.0,10.75,42.93).
city('Forte dei Marmi','it','Toscana',8177.0,10.17,43.97).
city('Fucecchio','it','Toscana',22187.0,10.8,43.74).
city('Greve in Chianti','it','Toscana',13820.0,11.32,43.59).
city('Grosseto','it','Toscana',72328.0,11.1,42.77).
city('Impruneta','it','Toscana',14949.0,11.25,43.69).
city('Lastra a Signa','it','Toscana',18870.0,11.09,43.77).
city('Leghorn','it','Toscana',146762.0,10.3,43.55).
city('Lucca','it','Toscana',80617.0,10.5,43.85).
city('Massa','it','Toscana',68318.0,10.15,44.06).
city('Massa Marittima','it','Toscana',8924.0,10.89,43.04).
city('Massarosa','it','Toscana',21262.0,10.33,43.87).
city('Monsummano Terme','it','Toscana',21415.0,10.81,43.87).
city('Montale','it','Toscana',10704.0,11.02,43.94).
city('Monte Argentario','it','Toscana',12256.0,11.16,42.41).
city('Montecatini-Terme','it','Toscana',20359.0,10.79,43.89).
city('Montelupo Fiorentino','it','Toscana',12146.0,11.01,43.74).
city('Montemurlo','it','Toscana',18352.0,11.05,43.92).
city('Montepulciano','it','Toscana',14389.0,11.77,43.1).
city('Montespertoli','it','Toscana',12723.0,11.08,43.64).
city('Montevarchi','it','Toscana',22987.0,11.56,43.53).
city('Montignoso','it','Toscana',10804.0,10.18,44.02).
city('Montopoli in Val dArno','it','Toscana',10326.0,10.76,43.0).
city('Orbetello','it','Toscana',14805.0,11.21,42.45).
city('Pescia','it','Toscana',17868.0,10.69,43.9).
city('Pietrasanta','it','Toscana',24625.0,10.24,43.97).
city('Piombino','it','Toscana',34114.0,10.53,42.94).
city('Pisa','it','Toscana',83803.0,10.4,43.72).
city('Pistoia','it','Toscana',85267.0,10.91,43.94).
city('Poggibonsi','it','Toscana',28619.0,11.13,43.49).
city('Ponsacco','it','Toscana',13257.0,10.62,43.62).
city('Pontassieve','it','Toscana',21423.0,11.43,43.78).
city('Pontedera','it','Toscana',26713.0,10.63,43.66).
city('Portoferraio','it','Toscana',10102.0,10.3,42.82).
city('Prato','it','Toscana',178915.0,11.09,43.89).
city('Quarrata','it','Toscana',24341.0,11.81,43.5).
city('Reggello','it','Toscana',15388.0,11.53,43.69).
city('Roccastrada','it','Toscana',9470.0,11.16,43.0).
city('Rosignano Marittimo','it','Toscana',31871.0,10.47,43.41).
city('San Casciano','it','Toscana',16845.0,11.18,43.66).
city('San Giovanni Valdarno','it','Toscana',17245.0,11.53,43.56).
city('San Giuliano Terme','it','Toscana',32516.0,10.43,43.77).
city('San Miniato','it','Toscana',27806.0,10.83,43.69).
city('Sansepolcro','it','Toscana',16302.0,12.12,43.59).
city('Santa Croce sullArno','it','Toscana',12993.0,10.78,43.71).
city('Santa Maria a Monte','it','Toscana',11384.0,10.7,43.7).
city('Scandicci','it','Toscana',50491.0,11.18,43.75).
city('Seravezza','it','Toscana',12985.0,10.21,43.99).
city('Serravalle Pistoiese','it','Toscana',11171.0,10.84,43.9).
city('Sesto Fiorentino','it','Toscana',47074.0,11.19,43.84).
city('Siena','it','Toscana',47922.0,11.32,43.33).
city('Signa','it','Toscana',16237.0,11.07,43.79).
city('Sinalunga','it','Toscana',12348.0,11.73,43.2).
city('Terranuova Bracciolini','it','Toscana',12026.0,11.59,43.55).
city('Vaiano','it','Toscana',9514.0,11.13,43.97).
city('Vecchiano','it','Toscana',12339.0,10.38,43.79).
city('Viareggio','it','Toscana',59866.0,10.24,43.89).
city('Vinci','it','Toscana',14284.0,10.91,43.79).
city('Volterra','it','Toscana',11130.0,10.85,43.41).
city('Appiano','it','Trentino-Alto Adige',13521.0,11.24,46.47).
city('Arco','it','Trentino-Alto Adige',15373.0,10.87,45.92).
city('Bolzano','it','Trentino-Alto Adige',91209.0,11.35,46.5).
city('Bressanone','it','Trentino-Alto Adige',18599.0,11.65,46.71).
city('Brunico','it','Trentino-Alto Adige',13982.0,11.92,46.8).
city('Laives','it','Trentino-Alto Adige',15989.0,11.33,46.44).
city('Lana','it','Trentino-Alto Adige',10341.0,11.15,46.61).
city('Merano','it','Trentino-Alto Adige',33514.0,11.15,46.67).
city('Pergine Valsugana','it','Trentino-Alto Adige',17883.0,11.23,46.07).
city('Riva','it','Trentino-Alto Adige',15389.0,10.84,45.9).
city('Rovereto','it','Trentino-Alto Adige',33510.0,11.03,45.9).
city('Trento','it','Trentino-Alto Adige',106703.0,11.12,46.08).
city('Amelia','it','Umbria',11282.0,12.41,42.56).
city('Assisi','it','Umbria',25749.0,12.62,43.07).
city('Bastia Umbra','it','Umbria',20137.0,12.57,43.06).
city('Castiglione del Lago','it','Umbria',15309.0,12.04,43.12).
city('Citta di Castello','it','Umbria',39959.0,12.23,43.46).
city('Corciano','it','Umbria',16983.0,12.28,43.14).
city('Foligno','it','Umbria',50616.0,12.7,42.96).
city('Gualdo Tadino','it','Umbria',16216.0,12.78,43.24).
city('Gubbio','it','Umbria',31742.0,12.57,43.35).
city('Magione','it','Umbria',13326.0,12.2,43.14).
city('Marsciano','it','Umbria',17262.0,12.33,42.92).
city('Narni','it','Umbria',20567.0,12.51,42.53).
city('Orvieto','it','Umbria',21573.0,12.1,42.74).
city('Perugia','it','Umbria',157077.0,12.39,43.11).
city('San Giustino','it','Umbria',11138.0,12.17,43.55).
city('Spoleto','it','Umbria',36489.0,12.75,42.74).
city('Terni','it','Umbria',108006.0,12.65,42.57).
city('Todi','it','Umbria',17321.0,12.39,42.79).
city('Umbertide','it','Umbria',16451.0,12.31,43.31).
city('Aosta','it','Valle dAosta',33503.0,7.31,45.75).
city('Abano Terme','it','Veneto',19112.0,11.78,45.35).
city('Adria','it','Veneto',21182.0,12.05,45.06).
city('Albignasego','it','Veneto',19835.0,11.86,45.35).
city('Altavilla Vicentina','it','Veneto',10643.0,11.47,45.51).
city('Arzignano','it','Veneto',24565.0,11.33,45.52).
city('Badia Polesine','it','Veneto',10947.0,11.47,45.11).
city('Bassano del Grappa','it','Veneto',42457.0,11.74,45.77).
city('Belluno','it','Veneto',35895.0,12.21,46.15).
city('Bovolone','it','Veneto',14128.0,11.11,45.26).
city('Bussolengo','it','Veneto',18755.0,10.84,45.47).
city('Cadoneghe','it','Veneto',15600.0,11.91,45.44).
city('Caldogno','it','Veneto',10854.0,11.49,45.6).
city('Campodarsego','it','Veneto',12327.0,11.9,45.5).
city('Campolongo Maggiore','it','Veneto',9607.0,12.03,45.32).
city('Camponogara','it','Veneto',11841.0,12.07,45.39).
city('Camposampiero','it','Veneto',11651.0,11.93,45.57).
city('Caorle','it','Veneto',11647.0,12.87,45.61).
city('Carbonera','it','Veneto',10501.0,12.28,45.68).
city('Cassola','it','Veneto',13479.0,11.8,45.73).
city('Castel dAzzano','it','Veneto',11016.0,10.95,45.36).
city('Castelfranco Veneto','it','Veneto',33449.0,11.93,45.68).
city('Cavarzere','it','Veneto',15543.0,12.08,45.14).
city('Cerea','it','Veneto',16046.0,11.21,45.2).
city('Chiampo','it','Veneto',12865.0,11.28,45.55).
city('Chioggia','it','Veneto',53074.0,12.27,45.22).
city('Cittadella','it','Veneto',19681.0,11.77,45.65).
city('Concordia Sagittaria','it','Veneto',10859.0,12.84,45.75).
city('Conegliano','it','Veneto',36037.0,12.29,45.89).
city('Cornedo Vicentino','it','Veneto',11378.0,11.34,45.62).
city('Creazzo','it','Veneto',10529.0,11.46,45.54).
city('Dolo','it','Veneto',15173.0,12.08,45.43).
city('Dueville','it','Veneto',13841.0,11.55,45.64).
city('Eraclea','it','Veneto',13132.0,12.66,45.58).
city('Este','it','Veneto',16790.0,11.63,45.24).
city('Feltre','it','Veneto',19580.0,11.91,46.03).
city('Grezzana','it','Veneto',10706.0,11.01,45.52).
city('Iesolo','it','Veneto',22976.0,12.59,45.55).
city('Isola della Scala','it','Veneto',10879.0,10.99,45.28).
city('Legnago','it','Veneto',24319.0,11.3,45.2).
city('Lendinara','it','Veneto',12477.0,11.59,45.09).
city('Lonigo','it','Veneto',15001.0,11.38,45.4).
city('Malo','it','Veneto',13107.0,11.39,45.65).
city('Marcon','it','Veneto',13368.0,12.3,45.57).
city('Marostica','it','Veneto',13401.0,11.65,45.76).
city('Martellago','it','Veneto',20335.0,12.15,45.55).
city('Mira','it','Veneto',36219.0,12.12,45.45).
city('Mirano','it','Veneto',27152.0,12.11,45.5).
city('Mogliano Veneto','it','Veneto',27612.0,12.23,45.56).
city('Monselice','it','Veneto',16815.0,11.73,45.26).
city('Montagnana','it','Veneto',9607.0,11.46,45.24).
city('Montebelluna','it','Veneto',28562.0,12.05,45.79).
city('Montecchio Maggiore','it','Veneto',21875.0,11.42,45.51).
city('Montegrotto Terme','it','Veneto',10865.0,11.76,45.32).
city('Motta di Livenza','it','Veneto',10501.0,12.61,45.78).
city('Musile di Piave','it','Veneto',10779.0,12.55,45.62).
city('Negrar','it','Veneto',18134.0,10.93,45.53).
city('Noale','it','Veneto',15512.0,12.07,45.54).
city('Occhiobello','it','Veneto',10500.0,11.58,44.92).
city('Oderzo','it','Veneto',18158.0,12.49,45.79).
city('Padova','it','Veneto',205247.0,11.87,45.41).
city('Paese','it','Veneto',20224.0,12.15,45.68).
city('Pescantina','it','Veneto',14175.0,10.85,45.49).
city('Piazzola sul Brenta','it','Veneto',11204.0,11.79,45.54).
city('Pieve di Soligo','it','Veneto',11642.0,12.16,45.89).
city('Piove di Sacco','it','Veneto',18196.0,12.04,45.3).
city('Ponte San Nicolo','it','Veneto',13148.0,11.93,45.37).
city('Porto Tolle','it','Veneto',10894.0,12.37,44.94).
city('Portogruaro','it','Veneto',23843.0,12.83,45.79).
city('Preganziol','it','Veneto',15877.0,12.24,45.6).
city('Quinto di Treviso','it','Veneto',9726.0,12.17,45.65).
city('Riese','it','Veneto',10568.0,11.92,45.73).
city('Romano dEzzelino','it','Veneto',15087.0,11.76,45.8).
city('Roncade','it','Veneto',12540.0,12.38,45.63).
city('Rosa','it','Veneto',13186.0,12.88,45.92).
city('Rovigo','it','Veneto',48634.0,11.78,45.08).
city('Rubano','it','Veneto',14458.0,11.78,45.44).
city('Salzano','it','Veneto',12306.0,12.11,45.53).
city('San Biagio di Callalta','it','Veneto',12160.0,11.87,44.58).
city('San Bonifacio','it','Veneto',18684.0,11.27,45.4).
city('San Dona di Piave','it','Veneto',37452.0,12.56,45.64).
city('San Giovanni Lupatoto','it','Veneto',22034.0,11.04,45.39).
city('San Martino Buon Albergo','it','Veneto',13471.0,11.1,45.42).
city('San Martino di Lupari','it','Veneto',12023.0,11.85,45.65).
city('San Michele al Tagliamento','it','Veneto',11602.0,12.98,45.77).
city('San Pietro in Cariano','it','Veneto',13774.0,10.89,45.52).
city('SantAmbrogio','it','Veneto',10188.0,12.06,45.6).
city('Santa Maria di Sala','it','Veneto',15322.0,12.03,45.51).
city('Santo Stino di Livenza','it','Veneto',12294.0,12.68,45.74).
city('Schio','it','Veneto',39001.0,11.35,45.72).
city('Scorze','it','Veneto',18546.0,12.11,45.58).
city('Selvazzano Dentro','it','Veneto',20047.0,11.78,45.39).
city('Silea','it','Veneto',9447.0,12.29,45.65).
city('Sommacampagna','it','Veneto',14414.0,10.83,45.4).
city('Sona','it','Veneto',15528.0,10.83,45.43).
city('Spinea','it','Veneto',25198.0,12.18,45.49).
city('Spresiano','it','Veneto',9868.0,12.26,45.78).
city('Susegana','it','Veneto',11594.0,12.25,45.85).
city('Tezze sul Brenta','it','Veneto',11215.0,11.7,45.68).
city('Thiene','it','Veneto',20474.0,11.47,45.71).
city('Torri di Quartesolo','it','Veneto',11900.0,11.62,45.52).
city('Trebaseleghe','it','Veneto',12137.0,12.05,45.58).
city('Treviso','it','Veneto',81323.0,12.24,45.67).
city('Valdagno','it','Veneto',26435.0,11.3,45.65).
city('Valdobbiadene','it','Veneto',10854.0,11.99,45.91).
city('Valeggio sul Mincio','it','Veneto',12015.0,10.73,45.36).
city('Vedelago','it','Veneto',14702.0,12.01,45.69).
city('Venice','it','Veneto',259126.0,12.33,45.43).
city('Verona','it','Veneto',247082.0,10.99,45.44).
city('Vicenza','it','Veneto',108636.0,11.54,45.55).
city('Vigodarzere','it','Veneto',13309.0,11.88,45.45).
city('Vigonza','it','Veneto',21541.0,11.98,45.45).
city('Villafranca di Verona','it','Veneto',30271.0,10.84,45.36).
city('Villorba','it','Veneto',18144.0,12.23,45.73).
city('Vittorio Veneto','it','Veneto',30193.0,12.29,45.99).
city('Volpago del Montello','it','Veneto',9593.0,12.12,45.78).
city('Zevio','it','Veneto',13318.0,11.13,45.37).
city('May Pen','jm','Clarendon',44757.0,-77.24,17.97).
city('Lucea','jm','Hanover',6290.0,-78.18,18.44).
city('Kingston','jm','Kingston',583999.0,-76.8,17.99).
city('Mandeville','jm','Manchester',47116.0,-77.48,18.05).
city('Port Antonio','jm','Portland',14235.0,-76.38,18.16).
city('Half Way Tree','jm','Saint Andrew',18552.0,-76.79,18.0).
city('Bamboo','jm','Saint Ann',4264.0,-77.26,18.38).
city('Browns Town','jm','Saint Ann',7837.0,-77.36,18.4).
city('Discovery Bay','jm','Saint Ann',2536.0,-77.39,18.47).
city('Ocho Rios','jm','Saint Ann',9451.0,-77.11,18.42).
city('Saint Anns Bay','jm','Saint Ann',12686.0,-77.22,18.44).
city('Portmore','jm','Saint Catherine',102865.0,-76.88,17.95).
city('Spanish Town','jm','Saint Catherine',145024.0,-76.95,18.0).
city('Black River','jm','Saint Elizabeth',4229.0,-77.86,18.03).
city('Bull Savanna','jm','Saint Elizabeth',6962.0,-77.59,17.88).
city('Anchovy','jm','Saint James',4161.0,-77.92,18.4).
city('Cambridge','jm','Saint James',3930.0,-77.89,18.32).
city('Maroon Town','jm','Saint James',3643.0,-77.79,18.35).
city('Montego Bay','jm','Saint James',82868.0,-77.92,18.47).
city('Anotto Bay','jm','Saint Mary',5672.0,-76.76,18.27).
city('Port Maria','jm','Saint Mary',7906.0,-76.89,18.37).
city('Morant Bay','jm','Saint Thomas',9369.0,-76.39,17.87).
city('Albert Town','jm','Trelawney',3449.0,-77.54,18.28).
city('Falmouth','jm','Trelawney',7780.0,-77.66,18.49).
city('Savanna la Mar','jm','Westmoreland',18618.0,-77.95,18.16).
city('Agui','jp','Aichi',24198.0,136.91,34.95).
city('Anjo','jp','Aichi',168664.0,137.1,34.96).
city('Atsumi','jp','Aichi',21712.0,137.11,34.63).
city('Bisai','jp','Aichi',58903.0,136.74,35.31).
city('Chiryu','jp','Aichi',67062.0,137.03,35.01).
city('Chita','jp','Aichi',83276.0,136.86,35.0).
city('Fujioka','jp','Aichi',21076.0,137.2,35.19).
city('Fuso','jp','Aichi',33247.0,136.92,35.31).
city('Gamagori','jp','Aichi',80786.0,137.23,34.84).
city('Handa','jp','Aichi',116120.0,136.94,34.9).
city('Hekinan','jp','Aichi',68873.0,136.98,34.89).
city('Higashiura','jp','Aichi',48002.0,136.96,34.97).
city('Ichinomiya','jp','Aichi',280333.0,136.8,35.3).
city('Inazawa','jp','Aichi',102131.0,136.77,35.25).
city('Inuyama','jp','Aichi',73996.0,136.93,35.38).
city('Isshiki','jp','Aichi',23966.0,137.03,34.82).
city('Iwakura','jp','Aichi',48007.0,136.86,35.28).
city('Jimokuji','jp','Aichi',38908.0,136.82,35.2).
city('Kanie','jp','Aichi',36592.0,136.8,35.12).
city('Kariya','jp','Aichi',139160.0,137.0,34.99).
city('Kasugai','jp','Aichi',298591.0,136.98,35.24).
city('Kira','jp','Aichi',21585.0,137.07,34.8).
city('Kisogawa','jp','Aichi',32586.0,136.78,35.35).
city('Komaki','jp','Aichi',151026.0,136.91,35.3).
city('Konan','jp','Aichi',100390.0,136.86,35.34).
city('Kota','jp','Aichi',34415.0,137.17,34.87).
city('Kozakai','jp','Aichi',22064.0,137.36,34.8).
city('Mihama','jp','Aichi',26402.0,136.9,34.77).
city('Minamichita','jp','Aichi',21917.0,136.94,34.71).
city('Miwa','jp','Aichi',24593.0,136.77,35.2).
city('Miyoshi','jp','Aichi',56958.0,137.07,35.08).
city('Nagakute','jp','Aichi',49145.0,137.04,35.18).
city('Nagoya','jp','Aichi',2191291.0,136.91,35.15).
city('Nishiharu','jp','Aichi',33545.0,136.85,35.24).
city('Nishio','jp','Aichi',103338.0,137.06,34.87).
city('Nisshin','jp','Aichi',81866.0,137.04,35.14).
city('Obu','jp','Aichi',77865.0,136.96,35.01).
city('Oharu','jp','Aichi',29623.0,136.81,35.17).
city('Okazaki','jp','Aichi',352364.0,137.16,34.96).
city('Owariashi','jp','Aichi',80633.0,137.03,35.22).
city('Saori','jp','Aichi',22695.0,136.74,35.2).
city('Saya','jp','Aichi',31007.0,136.72,35.16).
city('Seto','jp','Aichi',134247.0,137.08,35.22).
city('Shikatsu','jp','Aichi',44131.0,136.88,35.25).
city('Shinshiro','jp','Aichi',36070.0,137.5,34.9).
city('Shippo','jp','Aichi',22588.0,136.79,35.17).
city('Sobue','jp','Aichi',23372.0,136.71,35.25).
city('Tahara','jp','Aichi',38177.0,137.26,34.67).
city('Takahama','jp','Aichi',40502.0,136.98,34.92).
city('Taketoyo','jp','Aichi',41679.0,136.92,34.85).
city('Togo','jp','Aichi',41638.0,137.04,35.1).
city('Tokai','jp','Aichi',100680.0,136.89,35.03).
city('Tokoname','jp','Aichi',49554.0,136.84,34.9).
city('Toyoake','jp','Aichi',68558.0,137.01,35.06).
city('Toyohashi','jp','Aichi',378377.0,137.39,34.76).
city('Toyokawa','jp','Aichi',120538.0,137.39,34.82).
city('Toyota','jp','Aichi',362386.0,137.16,35.09).
city('Tsushima','jp','Aichi',67658.0,136.73,35.18).
city('Yatomi','jp','Aichi',37826.0,136.73,35.11).
city('Akita','jp','Akita',320071.0,140.11,39.71).
city('Honjo','jp','Akita',46730.0,140.09,39.44).
city('Kazuno','jp','Akita',36925.0,140.78,40.18).
city('Noshiro','jp','Akita',51079.0,140.03,40.2).
city('Odate','jp','Akita',64543.0,140.56,40.27).
city('Oga','jp','Akita',28304.0,139.82,39.91).
city('Omagari','jp','Akita',38805.0,140.46,39.46).
city('Takanosu','jp','Akita',20542.0,140.37,40.23).
city('Tenno','jp','Akita',22740.0,139.97,39.9).
city('Ugo','jp','Akita',18545.0,140.41,39.2).
city('Yokote','jp','Akita',39178.0,140.56,39.31).
city('Yuzawa','jp','Akita',33537.0,140.48,39.17).
city('Aomori','jp','Aomori',298396.0,140.74,40.83).
city('Goshogawara','jp','Aomori',49111.0,140.44,40.81).
city('Hachinohe','jp','Aomori',239047.0,141.53,40.52).
city('Hiraka','jp','Aomori',22290.0,140.55,40.59).
city('Hirosaki','jp','Aomori',174973.0,140.47,40.6).
city('Kizukuri','jp','Aomori',18907.0,140.37,40.79).
city('Kuroishi','jp','Aomori',38615.0,140.59,40.64).
city('Misawa','jp','Aomori',42805.0,141.34,40.68).
city('Mutsu','jp','Aomori',49221.0,141.21,41.29).
city('Namioka','jp','Aomori',20681.0,140.59,40.71).
city('Towada','jp','Aomori',63672.0,141.21,40.62).
city('Abiko','jp','Chiba',131774.0,140.03,35.88).
city('Asahi','jp','Chiba',41721.0,140.65,35.72).
city('Chiba','jp','Chiba',919746.0,140.11,35.61).
city('Choshi','jp','Chiba',75651.0,140.81,35.75).
city('Funabashi','jp','Chiba',560754.0,139.99,35.7).
city('Fussa','jp','Chiba',62297.0,139.33,35.74).
city('Futtsu','jp','Chiba',51651.0,139.83,35.31).
city('Ichihara','jp','Chiba',283537.0,140.09,35.53).
city('Ichikawa','jp','Chiba',458249.0,139.93,35.72).
city('Inzai','jp','Chiba',67406.0,140.15,35.84).
city('Kamagaya','jp','Chiba',106288.0,140.01,35.77).
city('Kamogawa','jp','Chiba',29120.0,140.12,35.11).
city('Kashiwa','jp','Chiba',340228.0,139.97,35.87).
city('Katsuura','jp','Chiba',22308.0,140.32,35.15).
city('Kimitsu','jp','Chiba',92128.0,139.91,35.33).
city('Kisarazu','jp','Chiba',122527.0,139.93,35.38).
city('Kujukuri','jp','Chiba',20488.0,140.45,35.53).
city('Matsudo','jp','Chiba',470287.0,139.9,35.78).
city('Mobara','jp','Chiba',97317.0,140.29,35.43).
city('Nagareyama','jp','Chiba',156003.0,139.91,35.86).
city('Narashino','jp','Chiba',156085.0,140.04,35.69).
city('Narita','jp','Chiba',100644.0,140.32,35.79).
city('Naruto','jp','Chiba',25697.0,140.4,35.61).
city('Noda','jp','Chiba',121414.0,139.87,35.95).
city('Oamishirasato','jp','Chiba',53240.0,140.31,35.52).
city('Ohara','jp','Chiba',20226.0,140.39,35.24).
city('Omigawa','jp','Chiba',25763.0,140.61,35.85).
city('Sakae','jp','Chiba',26391.0,140.24,35.85).
city('Sakura','jp','Chiba',182553.0,140.23,35.72).
city('Sambu','jp','Chiba',21481.0,140.36,35.64).
city('Sawara','jp','Chiba',47200.0,140.5,35.9).
city('Sekiyado','jp','Chiba',30923.0,139.82,36.03).
city('Shiroi','jp','Chiba',55316.0,140.05,35.8).
city('Shisui','jp','Chiba',19904.0,140.27,35.74).
city('Shonan','jp','Chiba',47072.0,140.0,35.84).
city('Sodegaura','jp','Chiba',60594.0,139.94,35.42).
city('Tateyama','jp','Chiba',50065.0,139.89,35.0).
city('Togane','jp','Chiba',66334.0,140.36,35.57).
city('Tomisato','jp','Chiba',53017.0,140.36,35.73).
city('Urayasu','jp','Chiba',143761.0,139.9,35.67).
city('Yachimata','jp','Chiba',83324.0,140.31,35.66).
city('Yachiyo','jp','Chiba',182894.0,140.1,35.74).
city('Yokaichiba','jp','Chiba',32651.0,140.55,35.71).
city('Yotsukaido','jp','Chiba',86703.0,140.17,35.68).
city('Hojo','jp','Ehime',27992.0,132.77,33.97).
city('Imabari','jp','Ehime',115356.0,133.0,34.06).
city('Iyo','jp','Ehime',30760.0,132.69,33.76).
city('Iyomishima','jp','Ehime',36030.0,133.55,33.99).
city('Kawanoe','jp','Ehime',37641.0,133.57,34.01).
city('Masaki','jp','Ehime',30471.0,132.69,33.79).
city('Matsuyama','jp','Ehime',485435.0,132.77,33.84).
city('Niihama','jp','Ehime',123061.0,133.27,33.96).
city('Ozu','jp','Ehime',38834.0,132.55,33.51).
city('Saijo','jp','Ehime',58824.0,133.17,33.92).
city('Shigenobu','jp','Ehime',24693.0,132.88,33.8).
city('Tobe','jp','Ehime',21382.0,132.79,33.74).
city('Toyo','jp','Ehime',32475.0,133.05,33.97).
city('Uwajima','jp','Ehime',58972.0,132.56,33.22).
city('Yawatahama','jp','Ehime',30835.0,132.42,33.46).
city('Fukui','jp','Fukui',248709.0,136.22,36.08).
city('Harue','jp','Fukui',24332.0,136.21,36.14).
city('Katsuyama','jp','Fukui',27088.0,136.49,36.06).
city('Maruoka','jp','Fukui',33564.0,136.26,36.15).
city('Mikuni','jp','Fukui',23480.0,136.14,36.22).
city('Obama','jp','Fukui',32896.0,135.74,35.5).
city('Ono','jp','Fukui',37470.0,136.49,35.99).
city('Sabae','jp','Fukui',66292.0,136.19,35.95).
city('Takefu','jp','Fukui',75753.0,136.16,35.91).
city('Tsuruga','jp','Fukui',68483.0,136.07,35.65).
city('Amagi','jp','Fukuoka',42312.0,130.66,33.42).
city('Buzen','jp','Fukuoka',28310.0,131.11,33.62).
city('Chikugo','jp','Fukuoka',49069.0,130.5,33.2).
city('Chikushino','jp','Fukuoka',105421.0,130.52,33.48).
city('Dazaifu','jp','Fukuoka',67325.0,130.52,33.51).
city('Fukuma','jp','Fukuoka',43154.0,130.49,33.77).
city('Fukuoka','jp','Fukuoka',1392299.0,130.41,33.59).
city('Hirokawa','jp','Fukuoka',20052.0,130.55,33.24).
city('Honami','jp','Fukuoka',26119.0,130.68,33.61).
city('Iizuka','jp','Fukuoka',78206.0,130.69,33.64).
city('Inatsuki','jp','Fukuoka',19140.0,130.71,33.59).
city('Kanda','jp','Fukuoka',36122.0,130.98,33.78).
city('Kasuga','jp','Fukuoka',112300.0,130.47,33.54).
city('Kasuya','jp','Fukuoka',37870.0,130.49,33.61).
city('Kawasaki','jp','Fukuoka',19141.0,130.83,33.58).
city('Kitakyushu','jp','Fukuoka',997545.0,130.86,33.88).
city('Koga','jp','Fukuoka',60046.0,130.47,33.73).
city('Kurate','jp','Fukuoka',18405.0,130.67,33.79).
city('Kurume','jp','Fukuoka',238199.0,130.51,33.31).
city('Maebaru','jp','Fukuoka',70339.0,130.2,33.56).
city('Miyata','jp','Fukuoka',20421.0,130.67,33.72).
city('Mizumaki','jp','Fukuoka',31956.0,130.69,33.85).
city('Munakata','jp','Fukuoka',86980.0,130.55,33.81).
city('Nakagawa','jp','Fukuoka',49421.0,130.42,33.5).
city('Nakama','jp','Fukuoka',46746.0,130.72,33.82).
city('Nogata','jp','Fukuoka',56822.0,130.73,33.74).
city('Ogori','jp','Fukuoka',58258.0,130.56,33.39).
city('Okagaki','jp','Fukuoka',31758.0,130.62,33.86).
city('Okawa','jp','Fukuoka',39224.0,130.37,33.2).
city('Omuta','jp','Fukuoka',131975.0,130.44,33.02).
city('Onojo','jp','Fukuoka',96167.0,130.48,33.54).
city('Sasaguri','jp','Fukuoka',32588.0,130.53,33.62).
city('Setaka','jp','Fukuoka',23985.0,130.46,33.15).
city('Shime','jp','Fukuoka',39217.0,130.47,33.6).
city('Shingu','jp','Fukuoka',25992.0,130.46,33.73).
city('Sue','jp','Fukuoka',26173.0,130.5,33.58).
city('Tagawa','jp','Fukuoka',51608.0,130.81,33.64).
city('Tanushimaru','jp','Fukuoka',21156.0,130.68,33.35).
city('Umi','jp','Fukuoka',39773.0,130.5,33.57).
city('Yamada','jp','Fukuoka',10779.0,130.76,33.56).
city('Yame','jp','Fukuoka',39228.0,130.56,33.21).
city('Yanagawa','jp','Fukuoka',40386.0,130.41,33.17).
city('Yukuhashi','jp','Fukuoka',71278.0,130.97,33.73).
city('Aizubange','jp','Fukushima',18702.0,139.82,37.56).
city('Aizuwakamatsu','jp','Fukushima',115938.0,139.93,37.49).
city('Fukushima','jp','Fukushima',294240.0,140.47,37.75).
city('Funehiki','jp','Fukushima',23524.0,140.58,37.44).
city('Haramachi','jp','Fukushima',47433.0,140.96,37.64).
city('Hobara','jp','Fukushima',24516.0,140.55,37.82).
city('Inawashiro','jp','Fukushima',17413.0,140.1,37.56).
city('Ishikawa','jp','Fukushima',18817.0,140.45,37.14).
city('Iwaki','jp','Fukushima',357313.0,140.88,37.05).
city('Kawamata','jp','Fukushima',16477.0,140.6,37.66).
city('Kitakata','jp','Fukushima',37140.0,139.0,37.66).
city('Koriyama','jp','Fukushima',340563.0,140.38,37.41).
city('Miharu','jp','Fukushima',19709.0,140.48,37.43).
city('Motomiya','jp','Fukushima',22705.0,140.4,37.52).
city('Namie','jp','Fukushima',21866.0,141.0,37.5).
city('Nihommatsu','jp','Fukushima',36287.0,140.43,37.6).
city('Shirakawa','jp','Fukushima',48340.0,140.21,37.13).
city('Soma','jp','Fukushima',38042.0,140.92,37.8).
city('Sukagawa','jp','Fukushima',68791.0,140.37,37.29).
city('Yanagawa','jp','Fukushima',20808.0,140.6,37.86).
city('Ena','jp','Gifu',35689.0,137.42,35.45).
city('Gifu','jp','Gifu',397718.0,136.76,35.42).
city('Ginan','jp','Gifu',22962.0,136.77,35.38).
city('Godo','jp','Gifu',20758.0,136.6,35.42).
city('Hashima','jp','Gifu',65613.0,136.7,35.32).
city('Hozumi','jp','Gifu',37230.0,136.7,35.4).
city('Ibigawa','jp','Gifu',18562.0,136.58,35.49).
city('Ikeda','jp','Gifu',24515.0,136.57,35.44).
city('Kakamigahara','jp','Gifu',132243.0,136.89,35.41).
city('Kani','jp','Gifu',97471.0,137.07,35.43).
city('Kasamatsu','jp','Gifu',22671.0,136.77,35.37).
city('Mino','jp','Gifu',23567.0,136.91,35.54).
city('Minokamo','jp','Gifu',53968.0,137.01,35.44).
city('Mitake','jp','Gifu',19340.0,137.13,35.43).
city('Mizunami','jp','Gifu',42618.0,137.25,35.37).
city('Nakatsugawa','jp','Gifu',55012.0,137.5,35.49).
city('Ogaki','jp','Gifu',150572.0,136.61,35.37).
city('Ono','jp','Gifu',24036.0,136.68,35.48).
city('Seki','jp','Gifu',77085.0,136.39,34.86).
city('Tajimi','jp','Gifu',107819.0,137.13,35.33).
city('Takayama','jp','Gifu',66637.0,137.24,36.15).
city('Tarui','jp','Gifu',29070.0,136.53,35.37).
city('Toki','jp','Gifu',61395.0,137.18,35.35).
city('Yoro','jp','Gifu',32921.0,136.56,35.31).
city('Annaka','jp','Gumma',48236.0,138.89,36.33).
city('Azuma','jp','Gumma',22884.0,139.24,36.34).
city('Fujimi','jp','Gumma',23282.0,139.07,36.45).
city('Fujioka','jp','Gumma',63359.0,139.09,36.25).
city('Gumma','jp','Gumma',37108.0,138.99,36.39).
city('Haruna','jp','Gumma',22376.0,138.86,36.38).
city('Isesaki','jp','Gumma',130694.0,139.2,36.32).
city('Kasakake','jp','Gumma',27641.0,139.28,36.39).
city('Kiryu','jp','Gumma',110221.0,139.33,36.43).
city('Maebashi','jp','Gumma',282714.0,139.06,36.39).
city('Nakanojo','jp','Gumma',17742.0,138.85,36.59).
city('Nitta','jp','Gumma',30394.0,139.31,36.3).
city('Numata','jp','Gumma',45526.0,139.05,36.65).
city('Oizumi','jp','Gumma',41926.0,139.39,36.24).
city('Omama','jp','Gumma',21286.0,139.28,36.44).
city('Ora','jp','Gumma',27735.0,139.44,36.26).
city('Ota','jp','Gumma',152106.0,139.38,36.3).
city('Sakai','jp','Gumma',31268.0,139.27,36.26).
city('Shibukawa','jp','Gumma',48323.0,139.01,36.5).
city('Takasaki','jp','Gumma',240860.0,139.02,36.33).
city('Tamamura','jp','Gumma',42567.0,139.09,36.3).
city('Tatebayashi','jp','Gumma',81275.0,139.53,36.25).
city('Tomioka','jp','Gumma',49282.0,138.9,36.26).
city('Yoshii','jp','Gumma',25656.0,138.98,36.25).
city('Fuchu','jp','Hiroshima',44899.0,132.87,34.49).
city('Fukuyama','jp','Hiroshima',383302.0,133.37,34.5).
city('Hatsukaichi','jp','Hiroshima',77342.0,132.33,34.36).
city('Higashihiroshima','jp','Hiroshima',135640.0,132.72,34.44).
city('Hiroshima','jp','Hiroshima',1143850.0,132.44,34.39).
city('Innoshima','jp','Hiroshima',26141.0,133.18,34.29).
city('Kaita','jp','Hiroshima',29902.0,132.53,34.37).
city('Kannabe','jp','Hiroshima',40767.0,133.38,34.54).
city('Kumano','jp','Hiroshima',25664.0,132.58,34.34).
city('Kure','jp','Hiroshima',196626.0,132.56,34.25).
city('Kurose','jp','Hiroshima',27158.0,132.67,34.32).
city('Mihara','jp','Hiroshima',80388.0,133.08,34.4).
city('Miyoshi','jp','Hiroshima',39257.0,132.83,34.81).
city('Ono','jp','Hiroshima',26191.0,132.28,34.28).
city('Onomichi','jp','Hiroshima',90937.0,133.19,34.41).
city('Otake','jp','Hiroshima',30151.0,132.22,34.21).
city('Shinichi','jp','Hiroshima',21030.0,133.27,34.56).
city('Shobara','jp','Hiroshima',20527.0,133.02,34.86).
city('Takehara','jp','Hiroshima',30506.0,132.91,34.35).
city('Abashiri','jp','Hokkaido',42498.0,144.27,44.02).
city('Akabira','jp','Hokkaido',14214.0,142.06,43.55).
city('Asahikawa','jp','Hokkaido',356615.0,142.36,43.77).
city('Ashibetsu','jp','Hokkaido',19108.0,142.19,43.52).
city('Bibai','jp','Hokkaido',29029.0,141.86,43.33).
city('Bihoro','jp','Hokkaido',22972.0,144.1,43.83).
city('Chitose','jp','Hokkaido',92943.0,141.64,42.83).
city('Date','jp','Hokkaido',35301.0,140.86,42.47).
city('Ebetsu','jp','Hokkaido',133955.0,141.55,43.12).
city('Eniwa','jp','Hokkaido',68771.0,141.57,42.89).
city('Fukagawa','jp','Hokkaido',26152.0,142.04,43.72).
city('Furano','jp','Hokkaido',25873.0,142.38,43.35).
city('Hakodate','jp','Hokkaido',275733.0,140.74,41.8).
city('Ishikari','jp','Hokkaido',57302.0,141.36,43.25).
city('Iwamizawa','jp','Hokkaido',85108.0,141.76,43.2).
city('Iwanai','jp','Hokkaido',15584.0,140.51,42.98).
city('Kamiiso','jp','Hokkaido',38098.0,140.67,41.83).
city('Kitahiroshima','jp','Hokkaido',62371.0,141.56,42.99).
city('Kitami','jp','Hokkaido',113138.0,143.89,43.81).
city('Kushiro','jp','Hokkaido',103239.0,144.43,42.99).
city('Makubetsu','jp','Hokkaido',25935.0,141.81,45.37).
city('Mikasa','jp','Hokkaido',12102.0,141.89,43.24).
city('Mombetsu','jp','Hokkaido',26895.0,143.35,44.35).
city('Muroran','jp','Hokkaido',96198.0,141.01,42.34).
city('Nakashibetsu','jp','Hokkaido',23818.0,144.97,43.55).
city('Nanae','jp','Hokkaido',30008.0,140.68,41.9).
city('Nayoro','jp','Hokkaido',26457.0,142.46,44.35).
city('Nemuro','jp','Hokkaido',31224.0,145.57,43.33).
city('Noboribetsu','jp','Hokkaido',52881.0,141.1,42.41).
city('Obihiro','jp','Hokkaido',173892.0,143.19,42.92).
city('Otaru','jp','Hokkaido',143794.0,141.0,43.2).
city('Otofuke','jp','Hokkaido',40945.0,143.2,43.0).
city('Rumoi','jp','Hokkaido',26454.0,141.65,43.94).
city('Sapporo','jp','Hokkaido',1883040.0,141.34,43.06).
city('Shibetsu','jp','Hokkaido',21744.0,145.12,43.65).
city('Shiraoi','jp','Hokkaido',20805.0,141.35,42.55).
city('Shizunai','jp','Hokkaido',22436.0,142.37,42.33).
city('Sunagawa','jp','Hokkaido',20102.0,141.91,43.49).
city('Takikawa','jp','Hokkaido',45132.0,141.9,43.57).
city('Tobetsu','jp','Hokkaido',21818.0,141.52,43.21).
city('Tomakomai','jp','Hokkaido',174808.0,141.59,42.63).
city('Utashinai','jp','Hokkaido',5163.0,142.06,43.52).
city('Wakkanai','jp','Hokkaido',41556.0,141.67,45.41).
city('Yoichi','jp','Hokkaido',22788.0,140.79,43.19).
city('Yubari','jp','Hokkaido',12872.0,141.98,43.07).
city('Aioi','jp','Hyogo',32394.0,134.45,34.8).
city('Akashi','jp','Hyogo',297281.0,134.98,34.66).
city('Ako','jp','Hyogo',52016.0,134.39,34.75).
city('Amagasaki','jp','Hyogo',442176.0,135.41,34.71).
city('Ashiya','jp','Hyogo',88574.0,135.31,34.73).
city('Fukusaki','jp','Hyogo',19033.0,134.76,34.95).
city('Harima','jp','Hyogo',34018.0,134.85,34.73).
city('Himeji','jp','Hyogo',481496.0,134.69,34.83).
city('Inagawa','jp','Hyogo',31999.0,135.37,34.89).
city('Inami','jp','Hyogo',32409.0,134.93,34.74).
city('Itami','jp','Hyogo',193526.0,135.42,34.78).
city('Kakogawa','jp','Hyogo',271636.0,134.84,34.77).
city('Kasai','jp','Hyogo',50046.0,134.84,34.95).
city('Kawanishi','jp','Hyogo',160522.0,135.42,34.82).
city('Kobe','jp','Hyogo',1528487.0,135.17,34.68).
city('Kodera','jp','Hyogo',19271.0,134.73,34.91).
city('Miki','jp','Hyogo',74702.0,134.98,34.81).
city('Nandan','jp','Hyogo',18721.0,134.71,34.26).
city('Nishinomiya','jp','Hyogo',468929.0,135.34,34.73).
city('Nishiwaki','jp','Hyogo',36953.0,134.97,34.98).
city('Ono','jp','Hyogo',50231.0,134.93,34.84).
city('Sanda','jp','Hyogo',132864.0,135.22,34.89).
city('Sasayama','jp','Hyogo',47205.0,135.22,35.07).
city('Sumoto','jp','Hyogo',39546.0,134.89,34.34).
city('Taishi','jp','Hyogo',32079.0,134.58,34.83).
city('Takarazuka','jp','Hyogo',219790.0,135.35,34.8).
city('Takasago','jp','Hyogo',94423.0,134.65,34.8).
city('Tatsuno','jp','Hyogo',40011.0,134.55,34.87).
city('Toyooka','jp','Hyogo',46500.0,134.82,35.54).
city('Yamasaki','jp','Hyogo',25115.0,134.53,35.02).
city('Yashiro','jp','Hyogo',21554.0,134.96,34.92).
city('Yumesaki','jp','Hyogo',21917.0,134.72,34.92).
city('Ami','jp','Ibaraki',48257.0,140.24,36.04).
city('Chiyoda','jp','Ibaraki',26981.0,140.23,36.15).
city('Daigo','jp','Ibaraki',22311.0,140.35,36.77).
city('Edosaki','jp','Ibaraki',20801.0,140.32,35.95).
city('Fujishiro','jp','Ibaraki',33149.0,140.12,35.92).
city('Hasaki','jp','Ibaraki',39209.0,140.81,35.77).
city('Hitachi','jp','Ibaraki',186311.0,140.66,36.59).
city('Hitachinaka','jp','Ibaraki',155972.0,140.52,36.4).
city('Hitachiota','jp','Ibaraki',39724.0,140.52,36.54).
city('Hokota','jp','Ibaraki',27691.0,140.55,36.19).
city('Ibaraki','jp','Ibaraki',34627.0,140.42,36.28).
city('Ina','jp','Ibaraki',24780.0,140.02,35.96).
city('Ishige','jp','Ibaraki',24948.0,139.97,36.12).
city('Ishioka','jp','Ibaraki',52305.0,140.28,36.19).
city('Itako','jp','Ibaraki',25791.0,140.55,35.93).
city('Iwai','jp','Ibaraki',42498.0,139.89,36.04).
city('Iwase','jp','Ibaraki',21981.0,140.1,36.36).
city('Kamisu','jp','Ibaraki',52554.0,140.68,35.88).
city('Kasama','jp','Ibaraki',29478.0,140.25,36.38).
city('Kashima','jp','Ibaraki',65936.0,140.63,35.97).
city('Kasumigaura','jp','Ibaraki',18018.0,140.32,36.08).
city('Kitaibaraki','jp','Ibaraki',50844.0,140.73,36.79).
city('Koga','jp','Ibaraki',58005.0,139.71,36.2).
city('Kukizaki','jp','Ibaraki',25495.0,140.11,35.99).
city('Makabe','jp','Ibaraki',19294.0,140.09,36.27).
city('Minori','jp','Ibaraki',26187.0,140.34,36.24).
city('Mito','jp','Ibaraki',246542.0,140.47,36.38).
city('Mitsukaido','jp','Ibaraki',41147.0,139.99,36.02).
city('Moriya','jp','Ibaraki',56567.0,139.98,35.97).
city('Naka','jp','Ibaraki',46761.0,140.17,36.05).
city('Oarai','jp','Ibaraki',19326.0,140.57,36.32).
city('Ryugasaki','jp','Ibaraki',85763.0,140.19,35.91).
city('Sakai','jp','Ibaraki',26919.0,139.79,36.12).
city('Sanwa','jp','Ibaraki',40022.0,139.82,36.2).
city('Shimodate','jp','Ibaraki',63667.0,139.98,36.31).
city('Shimotsuma','jp','Ibaraki',37787.0,139.96,36.2).
city('Sowa','jp','Ibaraki',48801.0,139.75,36.17).
city('Takahagi','jp','Ibaraki',33576.0,140.71,36.71).
city('Tokai','jp','Ibaraki',35319.0,140.59,36.47).
city('Tomobe','jp','Ibaraki',37147.0,140.3,36.35).
city('Tone','jp','Ibaraki',17954.0,140.16,35.86).
city('Toride','jp','Ibaraki',80717.0,140.07,35.9).
city('Tsuchiura','jp','Ibaraki',136386.0,140.19,36.09).
city('Tsukuba','jp','Ibaraki',175593.0,140.09,36.21).
city('Ushiku','jp','Ibaraki',80021.0,140.14,36.0).
city('Yachiyo','jp','Ibar',23708.0,139.89,36.2).
city('Yasato','jp','Ibaraki',30340.0,140.19,36.25).
city('Yuki','jp','Ibaraki',51575.0,139.88,36.3).
city('Hakui','jp','Ishikawa',24529.0,136.77,36.9).
city('Kaga','jp','Ishikawa',67370.0,136.31,36.31).
city('Kanazawa','jp','Ishikawa',458941.0,136.64,36.56).
city('Komatsu','jp','Ishikawa',109047.0,136.44,36.41).
city('Matto','jp','Ishikawa',68160.0,136.57,36.52).
city('Nanao','jp','Ishikawa',45309.0,136.96,37.05).
city('Nonoichi','jp','Ishikawa',48355.0,136.61,36.54).
city('Suzu','jp','Ishikawa',18205.0,137.26,37.44).
city('Tsubata','jp','Ishikawa',38645.0,136.73,36.67).
city('Tsurugi','jp','Ishikawa',22042.0,136.63,36.45).
city('Uchinada','jp','Ishikawa',26956.0,136.64,36.65).
city('Wajima','jp','Ishikawa',24605.0,136.78,37.37).
city('Daito','jp','Iwate',16746.0,141.4,39.01).
city('Esashi','jp','Iwate',32844.0,141.18,39.2).
city('Hanamaki','jp','Iwate',73116.0,141.12,39.39).
city('Ichinohe','jp','Iwate',15825.0,141.3,40.2).
city('Ichinoseki','jp','Iwate',62971.0,141.13,38.92).
city('Iwate','jp','Iwate',16328.0,141.23,39.98).
city('Kamaishi','jp','Iwate',43108.0,141.89,39.27).
city('Kitakami','jp','Iwate',93855.0,141.12,39.29).
city('Kuji','jp','Iwate',35568.0,140.61,36.5).
city('Miyako','jp','Iwate',51721.0,141.95,39.65).
city('Mizusawa','jp','Iwate',61281.0,141.14,39.14).
city('Morioka','jp','Iwate',295174.0,141.15,39.7).
city('Ninohe','jp','Iwate',26873.0,141.31,40.28).
city('Ofunato','jp','Iwate',35418.0,141.71,39.08).
city('Otsuchi','jp','Iwate',16497.0,141.91,39.36).
city('Rikuzentakata','jp','Iwate',24793.0,141.63,39.02).
city('Shiwa','jp','Iwate',34315.0,141.17,39.56).
city('Shizukuishi','jp','Iwate',19866.0,140.98,39.69).
city('Takizawa','jp','Iwate',58415.0,141.07,39.75).
city('Tono','jp','Iwate',26781.0,141.53,39.34).
city('Yahaba','jp','Iwate',28653.0,141.15,39.61).
city('Yamada','jp','Iwate',20144.0,141.94,39.47).
city('Kagawa','jp','Kagawa',24958.0,134.03,34.23).
city('Kanonji','jp','Kagawa',44364.0,133.65,34.13).
city('Kokubunji','jp','Kagawa',24868.0,133.97,34.28).
city('Marugame','jp','Kagawa',82091.0,133.79,34.29).
city('Miki','jp','Kagawa',29728.0,134.14,34.27).
city('Ryonan','jp','Kagawa',20246.0,133.92,34.24).
city('Sakaide','jp','Kagawa',57090.0,133.85,34.31).
city('Shido','jp','Kagawa',22859.0,134.17,34.32).
city('Tadotsu','jp','Kagawa',23515.0,133.75,34.26).
city('Takamatsu','jp','Kagawa',334226.0,134.04,34.34).
city('Tonosho','jp','Kagawa',16514.0,134.18,34.48).
city('Zentsuji','jp','Kagawa',35474.0,133.79,34.23).
city('Aira','jp','Kagoshima',45353.0,130.62,31.73).
city('Akune','jp','Kagoshima',25089.0,130.2,32.01).
city('Hayato','jp','Kagoshima',39475.0,130.74,31.76).
city('Ibusuki','jp','Kagoshima',29710.0,130.62,31.26).
city('Ijuin','jp','Kagoshima',25217.0,130.38,31.61).
city('Izumi','jp','Kagoshima',39217.0,130.35,32.08).
city('Kagoshima','jp','Kagoshima',555357.0,130.56,31.59).
city('Kajiki','jp','Kagoshima',22997.0,130.66,31.74).
city('Kanoya','jp','Kagoshima',82336.0,130.85,31.38).
city('Kaseda','jp','Kagoshima',23711.0,130.3,31.41).
city('Kokubu','jp','Kagoshima',57897.0,130.77,31.73).
city('Kushikino','jp','Kagoshima',25744.0,130.26,31.7).
city('Makurazaki','jp','Kagoshima',24971.0,130.28,31.26).
city('Naze','jp','Kagoshima',41366.0,129.5,28.37).
city('Nishinoomote','jp','Kagoshima',17832.0,131.0,30.73).
city('Okuchi','jp','Kagoshima',22426.0,130.62,32.05).
city('Sendai','jp','Kagoshima',73133.0,130.29,31.82).
city('Shibushi','jp','Kagoshima',183.0,131.1,31.47).
city('Sueyoshi','jp','Kagoshima',19986.0,131.02,31.64).
city('Tarumizu','jp','Kagoshima',19147.0,130.7,31.49).
city('Aikawa','jp','Kanagawa',43457.0,139.29,35.55).
city('Atsugi','jp','Kanagawa',229203.0,139.36,35.45).
city('Ayase','jp','Kanagawa',82613.0,139.43,35.44).
city('Chigasaki','jp','Kanagawa',231660.0,139.41,35.33).
city('Ebina','jp','Kanagawa',123667.0,139.42,35.47).
city('Fujisawa','jp','Kanagawa',394630.0,139.47,35.33).
city('Hadano','jp','Kanagawa',174284.0,139.23,35.37).
city('Hakone','jp','Kanagawa',13939.0,139.11,35.25).
city('Hayama','jp','Kanagawa',31136.0,139.59,35.26).
city('Hiratsuka','jp','Kanagawa',259056.0,139.35,35.33).
city('Isehara','jp','Kanagawa',103402.0,139.32,35.41).
city('Kamakura','jp','Kanagawa',166019.0,139.55,35.32).
city('Kawasaki','jp','Kanagawa',1306804.0,139.7,35.53).
city('Minamiashigara','jp','Kanagawa',45129.0,139.1,35.32).
city('Miura','jp','Kanagawa',51484.0,139.63,35.15).
city('Ninomiya','jp','Kanagawa',31412.0,139.23,35.29).
city('Odawara','jp','Kanagawa',203038.0,139.16,35.25).
city('Oiso','jp','Kanagawa',32595.0,139.32,35.3).
city('Sagamihara','jp','Kanagawa',648811.0,139.38,35.58).
city('Samukawa','jp','Kanagawa',46496.0,139.39,35.38).
city('Shiroyama','jp','Kanagawa',23749.0,139.31,35.6).
city('Tsukui','jp','Kanagawa',31032.0,139.26,35.59).
city('Yamato','jp','Kanagawa',224019.0,139.47,35.52).
city('Yokohama','jp','Kanagawa',3574478.0,139.62,35.47).
city('Yokosuka','jp','Kanagawa',428999.0,139.67,35.27).
city('Yugawara','jp','Kanagawa',27567.0,139.07,35.15).
city('Zama','jp','Kanagawa',134674.0,139.4,35.5).
city('Zushi','jp','Kanagawa',60056.0,139.58,35.3).
city('Aki','jp','Kochi',20118.0,133.91,33.5).
city('Ino','jp','Kochi',24123.0,133.43,33.55).
city('Kochi','jp','Kochi',335572.0,133.54,33.56).
city('Muroto','jp','Kochi',17601.0,134.15,33.3).
city('Nakamura','jp','Kochi',34559.0,132.94,32.99).
city('Nankoku','jp','Kochi',51128.0,133.64,33.58).
city('Sukumo','jp','Kochi',25784.0,132.72,32.93).
city('Susaki','jp','Kochi',26195.0,133.28,33.39).
city('Tosa','jp','Kochi',29636.0,133.44,33.5).
city('Tosashimizu','jp','Kochi',17286.0,132.95,32.79).
city('Tosayamada','jp','Kochi',22496.0,133.69,33.61).
city('Arao','jp','Kumamoto',55851.0,130.46,32.96).
city('Ashikita','jp','Kumamoto',16082.0,130.49,32.28).
city('Aso','jp','Kumamoto',18119.0,131.04,32.97).
city('Hitoyoshi','jp','Kumamoto',38007.0,130.77,32.21).
city('Hondo','jp','Kumamoto',40787.0,130.19,32.46).
city('Jonan','jp','Kumamoto',20536.0,130.72,32.7).
city('Kikuchi','jp','Kumamoto',26678.0,130.81,32.98).
city('Kikuyo','jp','Kumamoto',30461.0,130.81,32.87).
city('Koshi','jp','Kumamoto',22514.0,130.78,32.88).
city('Kumamoto','jp','Kumamoto',680429.0,130.71,32.8).
city('Mashiki','jp','Kumamoto',33634.0,130.8,32.79).
city('Matsubase','jp','Kumamoto',26163.0,130.68,32.65).
city('Minamata','jp','Kumamoto',29429.0,130.41,32.21).
city('Nishigoshi','jp','Kumamoto',29485.0,130.73,32.88).
city('Ozu','jp','Kumamoto',29820.0,130.87,32.88).
city('Tamana','jp','Kumamoto',45661.0,130.56,32.92).
city('Ueki','jp','Kumamoto',31688.0,130.68,32.9).
city('Ushibuka','jp','Kumamoto',16668.0,130.02,32.2).
city('Uto','jp','Kumamoto',39234.0,130.66,32.68).
city('Yamaga','jp','Kumamoto',32298.0,130.69,33.01).
city('Yatsushiro','jp','Kumamoto',104343.0,130.6,32.51).
city('Ayabe','jp','Kyoto',37613.0,135.25,35.3).
city('Fukuchiyama','jp','Kyoto',68736.0,135.12,35.3).
city('Joyo','jp','Kyoto',83111.0,135.77,34.86).
city('Kameoka','jp','Kyoto',97182.0,135.57,35.02).
city('Kizu','jp','Kyoto',41761.0,135.81,34.73).
city('Kumiyama','jp','Kyoto',16005.0,135.74,34.88).
city('Kyotanabe','jp','Kyoto',65904.0,135.77,34.82).
city('Kyoto','jp','Kyoto',1459647.0,135.75,35.01).
city('Maizuru','jp','Kyoto',92466.0,135.32,35.45).
city('Miyazu','jp','Kyoto',21632.0,135.19,35.53).
city('Muko','jp','Kyoto',53222.0,135.72,34.96).
city('Nagaokakyo','jp','Kyoto',76895.0,135.7,34.93).
city('Seika','jp','Kyoto',30311.0,135.78,34.77).
city('Uji','jp','Kyoto',192926.0,135.8,34.9).
city('Yawata','jp','Kyoto',71657.0,135.71,34.87).
city('Ago','jp','Mie',23723.0,136.82,34.33).
city('Hisai','jp','Mie',41643.0,136.47,34.67).
city('Ise','jp','Mie',97315.0,136.71,34.49).
city('Kameyama','jp','Mie',39900.0,136.45,34.86).
city('Komono','jp','Mie',40740.0,136.53,35.02).
city('Kumano','jp','Mie',19517.0,136.14,33.93).
city('Kuwana','jp','Mie',113108.0,136.7,35.08).
city('Matsusaka','jp','Mie',124614.0,136.53,34.58).
city('Meiwa','jp','Mie',22610.0,136.61,34.54).
city('Nabari','jp','Mie',88129.0,136.09,34.63).
city('Owase','jp','Mie',22038.0,136.21,34.08).
city('Suzuka','jp','Mie',191479.0,136.58,34.88).
city('Toba','jp','Mie',23303.0,136.84,34.49).
city('Toin','jp','Mie',26630.0,136.58,35.1).
city('Tsu','jp','Mie',163462.0,136.51,34.72).
city('Ueno','jp','Mie',61599.0,136.13,34.77).
city('Yokkaichi','jp','Mie',295843.0,136.64,34.97).
city('Furukawa','jp','Miyagi',76313.0,140.96,38.57).
city('Hasama','jp','Miyagi',22740.0,141.2,38.68).
city('Ishinomaki','jp','Miyagi',117235.0,141.29,38.43).
city('Iwanuma','jp','Miyagi',42411.0,140.87,38.11).
city('Kakuda','jp','Miyagi',33221.0,140.78,37.97).
city('Kesennuma','jp','Miyagi',59117.0,141.57,38.81).
city('Kogota','jp','Miyagi',19761.0,141.05,38.55).
city('Marumori','jp','Miyagi',16752.0,140.77,37.92).
city('Natori','jp','Miyagi',75563.0,140.88,38.16).
city('Ogawara','jp','Miyagi',23340.0,140.72,38.05).
city('Rifu','jp','Miyagi',35038.0,140.97,38.33).
city('Sendai','jp','Miyagi',1037569.0,140.89,38.26).
city('Shibata','jp','Miyagi',39935.0,140.75,38.05).
city('Shichigahama','jp','Miyagi',21433.0,141.05,38.3).
city('Shiogama','jp','Miyagi',59526.0,141.01,38.31).
city('Shiroishi','jp','Miyagi',39482.0,140.61,38.01).
city('Tagajo','jp','Miyagi',61937.0,140.95,38.29).
city('Taiwa','jp','Miyagi',25838.0,140.89,38.44).
city('Tomiya','jp','Miyagi',42501.0,140.88,38.4).
city('Wakuya','jp','Miyagi',18334.0,141.14,38.54).
city('Watari','jp','Miyagi',36322.0,140.85,38.04).
city('Yamoto','jp','Miyagi',32029.0,141.22,38.42).
city('Ebino','jp','Miyazaki',23880.0,130.84,32.05).
city('Hyuga','jp','Miyazaki',58906.0,131.65,32.44).
city('Kiyotake','jp','Miyazaki',31200.0,131.38,31.85).
city('Kobayashi','jp','Miyazaki',39748.0,130.96,31.99).
city('Kunitomi','jp','Miyazaki',22584.0,131.31,31.98).
city('Kushima','jp','Miyazaki',22102.0,131.23,31.45).
city('Mimata','jp','Miyazaki',25305.0,131.0,31.74).
city('Miyakonojo','jp','Miyazaki',130995.0,131.06,31.72).
city('Miyazaki','jp','Miyazaki',311206.0,131.42,31.91).
city('Nichinan','jp','Miyazaki',44243.0,131.39,31.58).
city('Nobeoka','jp','Miyazaki',121951.0,131.68,32.58).
city('Sadowara','jp','Miyazaki',33112.0,131.29,32.04).
city('Saito','jp','Miyazaki',34318.0,131.41,32.11).
city('Shintomi','jp','Miyazaki',20051.0,131.48,32.06).
city('Takanabe','jp','Miyazaki',22513.0,131.52,32.12).
city('Chino','jp','Nagano',56567.0,138.15,36.0).
city('Ho','jp','Nagano',33195.0,137.87,36.35).
city('Iida','jp','Nagano',107112.0,137.83,35.52).
city('Iiyama','jp','Nagano',25281.0,138.36,36.85).
city('Ina','jp','Nagano',62105.0,137.96,35.84).
city('Komagane','jp','Nagano',34757.0,137.94,35.74).
city('Komoro','jp','Nagano',46272.0,138.43,36.33).
city('Koshoku','jp','Nagano',40154.0,138.13,36.54).
city('Maruko','jp','Nagano',25403.0,138.26,36.32).
city('Matsumoto','jp','Nagano',210669.0,137.97,36.24).
city('Minowa','jp','Nagano',27070.0,137.98,35.91).
city('Nagano','jp','Nagano',360179.0,138.18,36.65).
city('Nakano','jp','Nagano',42708.0,138.37,36.75).
city('Okaya','jp','Nagano',54286.0,138.06,36.06).
city('Omachi','jp','Nagano',30599.0,137.84,36.51).
city('Saku','jp','Nagano',68886.0,138.47,36.23).
city('Shimosuwa','jp','Nagano',23068.0,138.08,36.07).
city('Shiojiri','jp','Nagano',67160.0,137.96,36.12).
city('Suwa','jp','Nagano',54736.0,138.12,36.05).
city('Suzaka','jp','Nagano',54023.0,138.32,36.65).
city('Tatsuno','jp','Nagano',21499.0,138.0,35.99).
city('Tobu','jp','Nagano',26008.0,138.32,36.37).
city('Toyoshina','jp','Nagano',27835.0,137.89,36.3).
city('Ueda','jp','Nagano',126607.0,138.25,36.4).
city('Fukue','jp','Nagasaki',26637.0,128.85,32.69).
city('Hirado','jp','Nagasaki',22516.0,129.56,33.36).
city('Isahaya','jp','Nagasaki',97372.0,130.05,32.84).
city('Matsuura','jp','Nagasaki',20785.0,129.61,33.31).
city('Nagasaki','jp','Nagasaki',410207.0,129.88,32.75).
city('Nagayo','jp','Nagasaki',45293.0,129.88,32.82).
city('Omura','jp','Nagasaki',89919.0,129.95,32.91).
city('Sasebo','jp','Nagasaki',237446.0,129.72,33.16).
city('Shimabara','jp','Nagasaki',38114.0,130.37,32.79).
city('Togitsu','jp','Nagasaki',29365.0,129.85,32.84).
city('Gojo','jp','Nara',34343.0,135.7,34.36).
city('Gose','jp','Nara',32871.0,135.75,34.46).
city('Haibara','jp','Nara',18472.0,135.95,34.53).
city('Heguri','jp','Nara',20304.0,135.69,34.63).
city('Ikagura','jp','Nara',28330.0,135.73,34.62).
city('Ikoma','jp','Nara',117604.0,135.72,34.7).
city('Kammaki','jp','Nara',24225.0,135.7,34.56).
city('Kashiba','jp','Nara',69391.0,135.7,34.55).
city('Kashihara','jp','Nara',126224.0,135.8,34.5).
city('Kawai','jp','Nara',20106.0,135.73,34.57).
city('Koryo','jp','Nara',33642.0,135.75,34.55).
city('Nara','jp','Nara',367360.0,135.83,34.69).
city('Oji','jp','Nara',23015.0,135.71,34.59).
city('Oyodo','jp','Nara',20490.0,135.8,34.4).
city('Sakurai','jp','Nara',62966.0,135.85,34.51).
city('Sango','jp','Nara',23607.0,135.69,34.6).
city('Tawaramoto','jp','Nara',32660.0,135.8,34.56).
city('Tenri','jp','Nara',71054.0,135.84,34.6).
city('Yamatokoriyama','jp','Nara',92139.0,135.79,34.64).
city('Yamatotakada','jp','Nara',73173.0,135.75,34.51).
city('Arai','jp','Niigata',27481.0,138.25,37.04).
city('Gosen','jp','Niigata',37361.0,139.18,37.7).
city('Itoigawa','jp','Niigata',30866.0,137.85,37.04).
city('Joetsu','jp','Niigata',136235.0,138.25,37.12).
city('Kameda','jp','Niigata',32765.0,139.11,37.87).
city('Kamo','jp','Niigata',32129.0,139.05,37.65).
city('Kashiwazaki','jp','Niigata',86184.0,138.57,37.38).
city('Kurosaki','jp','Niigata',27848.0,139.01,37.85).
city('Maki','jp','Niigata',29042.0,138.88,37.76).
city('Mitsuke','jp','Niigata',43180.0,138.93,37.52).
city('Muika','jp','Niigata',29123.0,138.88,37.08).
city('Murakami','jp','Niigata',31334.0,139.47,38.23).
city('Muramatsu','jp','Niigata',19712.0,139.16,37.66).
city('Nagaoka','jp','Niigata',195320.0,138.85,37.46).
city('Nakajo','jp','Niigata',26671.0,139.38,38.01).
city('Niigata','jp','Niigata',505276.0,139.04,37.92).
city('Niitsu','jp','Niigata',65911.0,139.12,37.8).
city('Ojiya','jp','Niigata',40549.0,138.79,37.31).
city('Ryotsu','jp','Niigata',16359.0,138.43,38.08).
city('Sanjo','jp','Niigata',82894.0,138.96,37.62).
city('Shibata','jp','Niigata',80794.0,139.32,37.94).
city('Shiozawa','jp','Niigata',20178.0,138.85,37.03).
city('Shirone','jp','Niigata',41406.0,139.0,37.76).
city('Suibara','jp','Niigata',20392.0,139.22,37.84).
city('Tochio','jp','Niigata',23045.0,139.0,37.48).
city('Tokamachi','jp','Niigata',41136.0,138.75,37.14).
city('Toyosaka','jp','Niigata',49824.0,139.19,37.93).
city('Tsubame','jp','Niigata',44284.0,138.93,37.65).
city('Yoshida','jp','Niigata',25500.0,138.88,37.68).
city('Beppu','jp','Oita',125067.0,131.5,33.28).
city('Bungotakada','jp','Oita',17931.0,131.45,33.56).
city('Hiji','jp','Oita',27864.0,131.53,33.36).
city('Hita','jp','Oita',61482.0,130.94,33.31).
city('Kitsuki','jp','Oita',23353.0,131.62,33.41).
city('Kusu','jp','Oita',18371.0,131.15,33.27).
city('Nakatsu','jp','Oita',67373.0,131.19,33.6).
city('Oita','jp','Oita',448910.0,131.6,33.24).
city('Saiki','jp','Oita',49066.0,131.91,32.96).
city('Taketa','jp','Oita',16361.0,131.39,32.95).
city('Tsukumi','jp','Oita',21659.0,131.86,33.07).
city('Usa','jp','Oita',48724.0,131.36,33.53).
city('Usuki','jp','Oita',35001.0,131.81,33.12).
city('Bizen','jp','Okayama',27251.0,134.26,34.74).
city('Ibara','jp','Okayama',34425.0,133.47,34.6).
city('Kamogata','jp','Okayama',18413.0,133.58,34.52).
city('Kasaoka','jp','Okayama',58461.0,133.52,34.52).
city('Kurashiki','jp','Okayama',437585.0,133.77,34.61).
city('Mabi','jp','Okayama',22771.0,133.7,34.62).
city('Niimi','jp','Okayama',23787.0,133.46,34.99).
city('Okayama','jp','Okayama',639657.0,133.92,34.67).
city('Sanyo','jp','Okayama',25468.0,134.02,34.75).
city('Soja','jp','Okayama',57469.0,133.74,34.68).
city('Takahashi','jp','Okayama',24819.0,133.62,34.8).
city('Tamano','jp','Okayama',67786.0,133.94,34.51).
city('Tsuyama','jp','Okayama',89718.0,134.01,35.07).
city('Chatan','jp','Okinawa',27844.0,127.76,26.3).
city('Ginowan','jp','Okinawa',91801.0,127.79,26.3).
city('Gushikawa','jp','Okinawa',65252.0,127.87,26.36).
city('Haebaru','jp','Okinawa',34240.0,127.88,26.34).
city('Hirara','jp','Okinawa',34354.0,125.29,24.79).
city('Ishigaki','jp','Okinawa',44803.0,124.16,24.34).
city('Ishikawa','jp','Okinawa',22412.0,127.83,26.42).
city('Itoman','jp','Okinawa',57185.0,127.68,26.13).
city('Nago','jp','Okinawa',59588.0,127.99,26.59).
city('Naha','jp','Okinawa',300799.0,127.7,26.21).
city('Nishihara','jp','Okinawa',37583.0,127.76,26.23).
city('Okinawa','jp','Okinawa',125485.0,127.79,26.34).
city('Tomigusuku','jp','Okinawa',55715.0,127.68,26.18).
city('Urasoe','jp','Okinawa',110284.0,127.73,26.26).
city('Yomitan','jp','Okinawa',39538.0,127.73,26.39).
city('Daito','jp','Osaka',129523.0,135.62,34.71).
city('Fujiidera','jp','Osaka',66856.0,135.6,34.57).
city('Habikino','jp','Osaka',121052.0,135.61,34.56).
city('Hannan','jp','Osaka',60796.0,135.25,34.36).
city('Higashiosaka','jp','Osaka',513130.0,135.59,34.67).
city('Hirakata','jp','Osaka',406335.0,135.66,34.81).
city('Ibaraki','jp','Osaka',263408.0,135.57,34.81).
city('Ikeda','jp','Osaka',99477.0,135.43,34.82).
city('Izumi','jp','Osaka',189087.0,135.42,34.48).
city('Izumiotsu','jp','Osaka',80773.0,135.41,34.5).
city('Izum','jp','Osaka',99429.0,135.32,34.42).
city('Kadoma','jp','Osaka',131729.0,135.59,34.73).
city('Kaizuka','jp','Osaka',92633.0,135.36,34.45).
city('Kashiwara','jp','Osaka',79059.0,135.64,34.59).
city('Katano','jp','Osaka',82027.0,135.68,34.78).
city('Kawachinagano','jp','Osaka',126500.0,135.57,34.48).
city('Kishiwada','jp','Osaka',205563.0,135.39,34.47).
city('Kumatori','jp','Osaka',45234.0,135.37,34.41).
city('Matsubara','jp','Osaka',130857.0,135.55,34.57).
city('Mihara','jp','Osaka',37952.0,135.58,34.54).
city('Mino','jp','Osaka',123949.0,135.47,34.83).
city('Misaki','jp','Osaka',18887.0,135.13,34.31).
city('Moriguchi','jp','Osaka',148352.0,135.57,34.73).
city('Neyagawa','jp','Osaka',245112.0,135.64,34.79).
city('Osaka','jp','Osaka',2592433.0,135.5,34.68).
city('Osakasayama','jp','Osaka',57170.0,135.56,34.5).
city('Sakai','jp','Osaka',782347.0,135.48,34.57).
city('Sennan','jp','Osaka',66460.0,135.28,34.37).
city('Settsu','jp','Osaka',83337.0,135.55,34.78).
city('Shijonawate','jp','Osaka',56851.0,135.64,34.75).
city('Shimamoto','jp','Osaka',30031.0,135.65,34.86).
city('Suita','jp','Osaka',351634.0,135.52,34.75).
city('Takaishi','jp','Osaka',60512.0,135.44,34.53).
city('Takatsuki','jp','Osaka',354472.0,135.62,34.85).
city('Tondabayashi','jp','Osaka',132875.0,135.6,34.52).
city('Toyonaka','jp','Osaka',384463.0,135.48,34.78).
city('Toyono','jp','Osaka',25867.0,135.46,34.91).
city('Yao','jp','Osaka',273216.0,135.58,34.63).
city('Imari','jp','Saga',57940.0,129.88,33.27).
city('Kanzaki','jp','Saga',20173.0,130.37,33.3).
city('Karatsu','jp','Saga',78331.0,129.97,33.44).
city('Kashima','jp','Saga',32410.0,130.09,33.11).
city('Kawasoe','jp','Saga',18399.0,130.32,33.19).
city('Saga','jp','Saga',165237.0,130.3,33.25).
city('Takeo','jp','Saga',34230.0,130.02,33.19).
city('Taku','jp','Saga',23341.0,130.08,33.31).
city('Tosu','jp','Saga',63596.0,130.51,33.36).
city('Ureshino','jp','Saga',18953.0,129.98,33.09).
city('Yamato','jp','Saga',22547.0,130.26,33.32).
city('Ageo','jp','Saitama',219405.0,139.61,35.95).
city('Asaka','jp','Saitama',128061.0,139.58,35.83).
city('Chichibu','jp','Saitama',58508.0,139.09,36.0).
city('Fujimi','jp','Saitama',108462.0,139.54,35.87).
city('Fukaya','jp','Saitama',106597.0,139.28,36.21).
city('Fukiage','jp','Saitama',28334.0,139.45,36.1).
city('Gyoda','jp','Saitama',86344.0,139.47,36.14).
city('Hanno','jp','Saitama',86264.0,139.32,35.86).
city('Hanyu','jp','Saitama',58687.0,139.54,36.18).
city('Hasuda','jp','Saitama',65162.0,139.67,35.99).
city('Hatogaya','jp','Saitama',53063.0,139.73,35.84).
city('Hatoyama','jp','Saitama',16103.0,139.33,35.98).
city('Hidaka','jp','Saitama',52912.0,139.35,35.9).
city('Higashimatsuyama','jp','Saitama',93933.0,139.4,36.05).
city('Honjo','jp','Saitama',61869.0,139.18,36.24).
city('Ina','jp','Saitama',34674.0,139.65,35.98).
city('Iruma','jp','Saitama',151548.0,139.38,35.83).
city('Iwatsuki','jp','Saitama',108835.0,139.7,35.96).
city('Kamifukuoka','jp','Saitama',52324.0,139.51,35.88).
city('Kamisato','jp','Saitama',32056.0,139.14,36.25).
city('Kasukabe','jp','Saitama',206919.0,139.77,35.98).
city('Kawagoe','jp','Saitama',337937.0,139.49,35.92).
city('Kawaguchi','jp','Saitama',468574.0,139.73,35.81).
city('Kawajima','jp','Saitama',23564.0,139.48,36.01).
city('Kazo','jp','Saitama',71292.0,139.6,36.13).
city('Kisai','jp','Saitama',20851.0,139.58,36.1).
city('Kitamoto','jp','Saitama',69840.0,139.54,36.03).
city('Kodama','jp','Saitama',21545.0,139.14,36.2).
city('Konosu','jp','Saitama',88494.0,139.53,36.05).
city('Koshigaya','jp','Saitama',317443.0,139.79,35.89).
city('Kuki','jp','Saitama',73375.0,139.67,36.07).
city('Kumagaya','jp','Saitama',155816.0,139.39,36.15).
city('Kurihashi','jp','Saitama',27813.0,139.69,36.15).
city('Matsubushi','jp','Saitama',30646.0,139.82,35.93).
city('Menuma','jp','Saitama',27685.0,139.37,36.22).
city('Misato','jp','Saitama',129695.0,139.88,35.83).
city('Miyashiro','jp','Saitama',34895.0,139.72,36.02).
city('Miyoshi','jp','Saitama',35816.0,139.52,35.84).
city('Moroyama','jp','Saitama',39693.0,139.33,35.94).
city('Niiza','jp','Saitama',153591.0,139.55,35.81).
city('Ogawa','jp','Saitama',37444.0,139.27,36.06).
city('Oi','jp','Saitama',50594.0,139.51,35.85).
city('Okegawa','jp','Saitama',75063.0,139.56,36.0).
city('Saitama','jp','Saitama',1077730.0,139.64,35.87).
city('Sakado','jp','Saitama',96658.0,139.41,35.95).
city('Satte','jp','Saitama',55287.0,139.76,36.08).
city('Sayama','jp','Saita',160846.0,139.4,35.87).
city('Shiki','jp','Saitama',65413.0,139.55,35.85).
city('Shiraoka','jp','Saitama',50975.0,139.67,36.01).
city('Shobu','jp','Saitama',22156.0,139.6,36.07).
city('Showa','jp','Saitama',36755.0,139.8,35.99).
city('Soka','jp','Saitama',231449.0,139.79,35.82).
city('Sugito','jp','Saitama',49818.0,139.73,36.03).
city('Toda','jp','Saitama',118733.0,139.68,35.82).
city('Tokorozawa','jp','Saitama',339441.0,139.47,35.8).
city('Tsurugashima','jp','Saitama',69431.0,139.39,35.95).
city('Wako','jp','Saitama',77437.0,139.61,35.78).
city('Warabi','jp','Saitama',69648.0,139.68,35.85).
city('Washimiya','jp','Saitama',34365.0,139.72,36.08).
city('Yashio','jp','Saitama',74700.0,139.84,35.83).
city('Yorii','jp','Saitama',38718.0,139.2,36.12).
city('Yoshikawa','jp','Saitama',60511.0,139.85,35.89).
city('Yoshimi','jp','Saitama',23120.0,139.45,36.04).
city('Hikone','jp','Shiga',110927.0,136.24,35.27).
city('Hino','jp','Shiga',22768.0,136.25,35.01).
city('Konan','jp','Shiga',20589.0,136.17,34.93).
city('Kosei','jp','Shiga',43336.0,136.07,35.01).
city('Kusatsu','jp','Shiga',127681.0,135.95,35.02).
city('Minakuchi','jp','Shiga',38986.0,136.17,34.97).
city('Moriyama','jp','Shiga',68585.0,136.02,35.07).
city('Nagahama','jp','Shiga',62090.0,136.27,35.38).
city('Notogawa','jp','Shiga',22551.0,136.16,35.18).
city('Omihachiman','jp','Shiga',68697.0,136.08,35.14).
city('Otsu','jp','Shiga',298167.0,135.87,35.01).
city('Ritto','jp','Shiga',60363.0,135.96,34.99).
city('Shiga','jp','Shiga',23836.0,135.92,35.19).
city('Yasu','jp','Shiga',37587.0,136.05,35.08).
city('Yokaichi','jp','Shiga',45339.0,136.2,35.11).
city('Gotsu','jp','Shimane',24597.0,132.22,35.02).
city('Hamada','jp','Shimane',45751.0,132.07,34.9).
city('Hikawa','jp','Shimane',27635.0,132.84,35.4).
city('Hirata','jp','Shimane',28154.0,132.82,35.44).
city('Izumo','jp','Shimane',89287.0,132.75,35.36).
city('Masuda','jp','Shimane',48577.0,131.86,34.68).
city('Matsue','jp','Shimane',156813.0,133.04,35.48).
city('Oda','jp','Shimane',31868.0,132.51,35.19).
city('Yasugi','jp','Shimane',29368.0,133.25,35.43).
city('Asaba','jp','Shizuoka',20195.0,137.93,34.7).
city('Atami','jp','Shizuoka',40688.0,139.07,35.1).
city('Daito','jp','Shizuoka',22665.0,138.05,34.67).
city('Fuji','jp','Shizuoka',240017.0,138.69,35.17).
city('Fujieda','jp','Shizuoka',132860.0,138.26,34.88).
city('Fujinomiya','jp','Shizuoka',121517.0,138.61,35.22).
city('Fukuroi','jp','Shizuoka',63046.0,137.93,34.75).
city('Gotemba','jp','Shizuoka',83795.0,138.93,35.31).
city('Haibara','jp','Shizuoka',25670.0,138.23,34.74).
city('Hamakita','jp','Shizuoka',86503.0,137.78,34.8).
city('Hamamatsu','jp','Shizuoka',605105.0,137.73,34.72).
city('Hamaoka','jp','Shizuoka',25447.0,138.12,34.65).
city('Hosoe','jp','Shizuoka',22346.0,137.65,34.8).
city('Ito','jp','Shizuoka',71579.0,139.1,34.97).
city('Iwata','jp','Shizuoka',88510.0,137.85,34.72).
city('Kakegawa','jp','Shizuoka',84005.0,138.03,34.77).
city('Kanaya','jp','Shizuoka',20286.0,138.14,34.82).
city('Kannami','jp','Shizuoka',40199.0,138.94,35.1).
city('Kikugawa','jp','Shizuoka',32500.0,138.08,34.75).
city('Kosai','jp','Shizuoka',43914.0,137.55,34.72).
city('Mishima','jp','Shizuoka',113480.0,138.92,35.12).
city('Mori','jp','Shizuoka',20280.0,137.93,34.83).
city('Nagaizumi','jp','Shizuoka',38092.0,138.9,35.14).
city('Numazu','jp','Shizuoka',204320.0,138.86,35.1).
city('Oigawa','jp','Shizuoka',23475.0,138.27,34.8).
city('Oyama','jp','Shizuoka',21745.0,138.22,34.6).
city('Ryuyo','jp','Shizuoka',20263.0,137.81,34.67).
city('Sagara','jp','Shizuoka',25922.0,138.2,34.68).
city('Shimada','jp','Shizuoka',75782.0,138.13,34.83).
city('Shimizu','jp','Shizuoka',133342.0,138.69,35.06).
city('Shimoda','jp','Shizuoka',26705.0,138.93,34.68).
city('Shizuoka','jp','Shizuoka',467327.0,138.39,34.98).
city('Susono','jp','Shizuoka',55545.0,138.91,35.16).
city('Tenryu','jp','Shizuoka',23419.0,137.83,34.88).
city('Toyoda','jp','Shizuoka',30435.0,137.82,34.72).
city('Yaizu','jp','Shizuoka',121059.0,138.32,34.87).
city('Yoshida','jp','Shizuoka',28687.0,138.26,34.79).
city('Ashikaga','jp','Tochigi',159673.0,139.45,36.35).
city('Fujioka','jp','Tochigi',18335.0,139.09,36.24).
city('Imaichi','jp','Tochigi',64324.0,139.69,36.73).
city('Iwafune','jp','Tochigi',19249.0,139.67,36.31).
city('Kaminokawa','jp','Tochigi',30828.0,139.92,36.44).
city('Kanuma','jp','Tochigi',94904.0,139.75,36.57).
city('Karasuyama','jp','Tochigi',18488.0,140.15,36.65).
city('Kawachi','jp','Tochi',36108.0,139.95,36.63).
city('Kuroiso','jp','Tochigi',61231.0,140.05,36.98).
city('Mashiko','jp','Tochigi',26045.0,140.1,36.47).
city('Mibu','jp','Tochigi',39729.0,139.81,36.42).
city('Minamikawachi','jp','Tochigi',22617.0,139.87,36.38).
city('Moka','jp','Tochigi',65718.0,140.01,36.44).
city('Motegi','jp','Tochigi',19575.0,140.19,36.53).
city('Nasu','jp','Tochigi',27077.0,140.13,37.02).
city('Nikko','jp','Tochigi',16042.0,139.61,36.75).
city('Nishinasuno','jp','Tochigi',46866.0,139.98,36.89).
city('Nogi','jp','Tochigi',27334.0,139.73,36.24).
city('Ohira','jp','Tochigi',28472.0,139.72,36.34).
city('Otawara','jp','Tochigi',58889.0,140.03,36.87).
city('Oyama','jp','Tochigi',159938.0,139.8,36.32).
city('Sano','jp','Tochigi',82536.0,139.58,36.32).
city('Takanezawa','jp','Tochigi',31642.0,139.99,36.62).
city('Tanuma','jp','Tochigi',28724.0,139.57,36.37).
city('Tochigi','jp','Tochigi',82134.0,139.73,36.38).
city('Ujiie','jp','Tochigi',30366.0,139.96,36.68).
city('Utsunomiya','jp','Tochigi',449869.0,139.89,36.56).
city('Yaita','jp','Tochigi',36275.0,139.93,36.8).
city('Aizumi','jp','Tokushima',32486.0,134.48,34.12).
city('Anan','jp','Tokushima',55422.0,134.66,33.92).
city('Ikeda','jp','Tokushima',15895.0,133.79,34.01).
city('Ishii','jp','Tokushima',26394.0,134.43,34.07).
city('Kamojima','jp','Tokushima',24374.0,134.35,34.07).
city('Kitajima','jp','Tokushima',20053.0,134.54,34.12).
city('Komatsushima','jp','Tokushima',42599.0,134.59,34.01).
city('Naruto','jp','Tokushima',64083.0,134.6,34.19).
city('Tokushima','jp','Tokushima',267347.0,134.55,34.07).
city('Waki','jp','Tokushima',17659.0,134.15,34.08).
city('Akiruno','jp','Tokyo',82022.0,139.29,35.72).
city('Akishima','jp','Tokyo',107926.0,139.36,35.7).
city('Chofu','jp','Tokyo',212978.0,139.55,35.65).
city('Fuchu','jp','Tokyo',240082.0,139.48,35.67).
city('Hachioji','jp','Tokyo',579402.0,139.33,35.66).
city('Hamura','jp','Tokyo',58201.0,139.32,35.76).
city('Higashikurume','jp','Tokyo',116323.0,139.53,35.76).
city('Higa','jp','Tokyo',150869.0,139.47,35.75).
city('Higashiyamato','jp','Tokyo',79333.0,139.41,35.74).
city('Hino','jp','Tokyo',171778.0,139.4,35.68).
city('Hoya','jp','Tokyo',107073.0,139.58,35.74).
city('Inagi','jp','Tokyo',77024.0,139.49,35.63).
city('Itsukaichi','jp','Tokyo',24956.0,139.23,35.74).
city('Kiyose','jp','Tokyo',69529.0,139.53,35.78).
city('Kodaira','jp','Tokyo',187369.0,139.49,35.74).
city('Koganei','jp','Tokyo',115968.0,139.52,35.72).
city('Kokubunji','jp','Tokyo',118682.0,139.48,35.7).
city('Komae','jp','Tokyo',77643.0,139.58,35.63).
city('Kunitachi','jp','Tokyo',78062.0,139.43,35.69).
city('Machida','jp','Tokyo',399971.0,139.43,35.56).
city('Mitaka','jp','Tokyo',178739.0,139.57,35.68).
city('Mizuho','jp','Tokyo',33922.0,139.36,35.77).
city('Musashimurayama','jp','Tokyo',66554.0,139.4,35.76).
city('Musashino','jp','Tokyo',137480.0,139.58,35.71).
city('Ome','jp','Tokyo',149324.0,139.26,35.79).
city('Tachikawa','jp','Tokyo',173696.0,139.41,35.7).
city('Tama','jp','Tokyo',147477.0,139.46,35.61).
city('Tanashi','jp','Tokyo',82112.0,139.55,35.74).
city('Tokyo','jp','Tokyo',8336611.0,139.77,35.67).
city('Kurayoshi','jp','Tottori',48347.0,133.82,35.44).
city('Sakaiminato','jp','Tottori',36324.0,133.24,35.53).
city('Tottori','jp','Tottori',154099.0,134.23,35.5).
city('Yonago','jp','Tottori',141369.0,133.34,35.44).
city('Fukumitsu','jp','Toyama',19535.0,136.87,36.55).
city('Himi','jp','Toyama',54511.0,136.99,36.86).
city('Kamiichi','jp','Toyama',23004.0,137.37,36.7).
city('Kosugi','jp','Toyama',33200.0,137.09,36.71).
city('Kurobe','jp','Toyama',36479.0,137.45,36.88).
city('Namerikawa','jp','Toyama',34638.0,137.34,36.77).
city('Nyuzen','jp','Toyama',27585.0,137.5,36.94).
city('Osawano','jp','Toyama',23420.0,137.21,36.58).
city('Oyabe','jp','Toyama',33495.0,136.88,36.67).
city('Shimminato','jp','Toyama',35994.0,137.09,36.78).
city('Takaoka','jp','Toyama',170079.0,137.02,36.75).
city('Tateyama','jp','Toyama',28326.0,137.32,36.67).
city('Tonami','jp','Toyama',42692.0,136.96,36.64).
city('Toyama','jp','Toyama',325535.0,137.22,36.7).
city('Uozu','jp','Toyama',45849.0,137.39,36.82).
city('Yatsuo','jp','Toyama',22205.0,137.14,36.57).
city('Arida','jp','Wakayama',32651.0,135.12,34.09).
city('Gobo','jp','Wakayama',27169.0,135.14,33.9).
city('Hashimoto','jp','Wakayama',57115.0,135.62,34.31).
city('Iwade','jp','Wakayama',55634.0,135.32,34.25).
city('Kainan','jp','Wakayama',43369.0,135.21,34.15).
city('Katsuragi','jp','Wakayama',19138.0,135.5,34.3).
city('Kishigawa','jp','Wakayama',21927.0,135.31,34.2).
city('Nachikatsuura','jp','Wakayama',18712.0,135.94,33.62).
city('Shingu','jp','Wakayama',31619.0,136.0,33.72).
city('Tanabe','jp','Wakayama',69564.0,135.39,33.73).
city('Wakayama','jp','Wakayama',375341.0,135.17,34.22).
city('Higashine','jp','Yamagata',45779.0,140.38,38.44).
city('Kahoku','jp','Yamagata',20868.0,140.28,38.42).
city('Kaminoyama','jp','Yamagata',35594.0,140.27,38.16).
city('Kawanishi','jp','Yamagata',18565.0,140.05,38.0).
city('Murayama','jp','Yamagata',28427.0,140.39,38.48).
city('Nagai','jp','Yamagata',31026.0,140.04,38.1).
city('Nanyo','jp','Yamagata',35334.0,140.15,38.05).
city('Obanazawa','jp','Yamagata',20822.0,140.4,38.6).
city('Sagae','jp','Yamagata',43544.0,140.27,38.37).
city('Sakata','jp','Yamagata',100446.0,139.83,38.91).
city('Shinjo','jp','Yamagata',41141.0,140.3,38.77).
city('Takahata','jp','Yamagata',26347.0,140.21,38.0).
city('Tendo','jp','Yamagata',65394.0,140.38,38.35).
city('Tsuruoka','jp','Yamagata',99821.0,139.82,38.73).
city('Yamagata','jp','Yamagata',254540.0,140.33,38.25).
city('Yonezawa','jp','Yamagata',94487.0,140.1,37.91).
city('Yuza','jp','Yamagata',17083.0,139.91,39.02).
city('Hagi','jp','Yamaguchi',43826.0,131.39,34.42).
city('Hikari','jp','Yamaguchi',45886.0,131.93,33.96).
city('Hofu','jp','Yamaguchi',116926.0,131.57,34.05).
city('Iwakuni','jp','Yamaguchi',104006.0,132.23,34.17).
city('Kudamatsu','jp','Yamaguchi',52773.0,131.86,34.0).
city('Mine','jp','Yamaguchi',18248.0,131.2,34.17).
city('Nagato','jp','Yamaguchi',23101.0,131.18,34.37).
city('Ogori','jp','Yamaguchi',23516.0,131.4,34.09).
city('Onoda','jp','Yamaguchi',44296.0,131.18,33.98).
city('Sanyo','jp','Yamaguchi',21913.0,131.17,34.05).
city('Shimonoseki','jp','Yamaguchi',245789.0,130.94,33.96).
city('Shinnanyo','jp','Yamaguchi',31851.0,131.73,34.08).
city('Tokuyama','jp','Yamaguchi',101134.0,131.8,34.05).
city('Toyoura','jp','Yamaguchi',19802.0,130.91,34.13).
city('Ube','jp','Yamaguchi',173735.0,131.24,33.94).
city('Yamaguchi','jp','Yamaguchi',145517.0,131.48,34.18).
city('Yanai','jp','Yamaguchi',32229.0,132.11,33.97).
city('Enzan','jp','Yamanashi',25143.0,138.73,35.72).
city('Fujiyoshida','jp','Yamanashi',52983.0,138.8,35.5).
city('Isawa','jp','Yamanashi',29616.0,138.63,35.65).
city('Kofu','jp','Yamanashi',190001.0,138.57,35.66).
city('Nirasaki','jp','Yamanashi',33264.0,138.47,35.71).
city('Otsuki','jp','Yamanashi',31226.0,138.93,35.62).
city('Ryuo','jp','Yamanashi',43181.0,138.51,35.67).
city('Tsuru','jp','Yamanashi',35454.0,138.91,35.57).
city('Uenohara','jp','Yamanashi',27840.0,139.11,35.62).
city('Yamanashi','jp','Yamanashi',32792.0,138.65,35.68).
city('Saint Helier','je','Saint Helier',28789.0,-2.11,49.19).
city('Ajlun','jo','Ajlun',8941.0,35.74,32.34).
city('Anjarah','jo','Ajlun',18627.0,35.75,32.31).
city('Ayn Janna','jo','Ajlun',10126.0,35.77,32.33).
city('Halawah','jo','Ajlun',5678.0,35.66,32.39).
city('Hzirbat al-Wahadinah','jo','Ajlun',5130.0,35.65,32.33).
city('Irjan','jo','Ajlun',5344.0,35.73,32.4).
city('Kufranjah','jo','Ajlun',22822.0,35.7,32.3).
city('Sahzrah','jo','Ajlun',11214.0,35.85,32.37).
city('al-Hasimiyah','jo','Ajlun',6959.0,35.71,31.01).
city('Abu Alanda','jo','Amman',33806.0,35.97,31.9).
city('Amman','jo','Amman',1218130.0,35.93,31.95).
city('Askan Abu Nusayr','jo','Amman',26364.0,35.87,32.09).
city('Hzalda wa Tila-al-Ali','jo','Amman',50208.0,35.85,32.01).
city('Hzuraybat As-Suq','jo','Amman',29034.0,35.93,31.87).
city('Jawa','jo','Amman',11859.0,35.93,31.85).
city('Naur','jo','Amman',17233.0,35.83,31.88).
city('Sahab','jo','Amman',44901.0,36.0,31.88).
city('Suwaylih','jo','Amman',74363.0,35.84,32.03).
city('Umm As-Summaq','jo','Amman',20390.0,35.85,31.88).
city('Umm Nuwarah','jo','Amman',11677.0,35.8,31.93).
city('Umm Qusayr wal Muqabalin','jo','Amman',27004.0,35.9,31.9).
city('Wadi as-Sir','jo','Amman',193973.0,35.82,31.95).
city('al-Bunayyat','jo','Amman',6226.0,35.88,31.88).
city('al-Jizah','jo','Amman',4906.0,35.95,31.7).
city('al-Jubayhah','jo','Amman',52258.0,35.86,32.02).
city('al-Juwaydah','jo','Amman',23433.0,35.93,31.89).
city('al-Quwaysimah','jo','Amman',36148.0,35.95,31.92).
city('al-Yadudah','jo','Amman',15268.0,35.92,31.85).
city('Alal','jo','Irbid',4851.0,35.9,32.63).
city('Arhaba','jo','Irbid',7834.0,35.78,32.44).
city('Aydun','jo','Irbid',20041.0,35.86,32.51).
city('Bayt Idis','jo','Irbid',5151.0,35.7,32.44).
city('Bayt Ras','jo','Irbid',15686.0,35.85,32.6).
city('Bayt Yafa','jo','Irbid',8494.0,35.78,32.52).
city('Bus','jo','Irbid',11673.0,35.9,32.55).
city('Dayr Abi Said','jo','Irbid',11350.0,35.68,32.5).
city('Dayr Yusuf','jo','Irbid',6787.0,35.8,32.49).
city('Dayr as-Sinah','jo','Irbid',5700.0,35.75,32.52).
city('Duwaqarah','jo','Irbid',4929.0,35.73,32.6).
city('Hakama','jo','Irbid',7717.0,35.89,32.6).
city('Hartza','jo','Irbid',5317.0,35.85,32.69).
city('Hatim','jo','Irbid',6045.0,35.78,32.65).
city('Hawwarah','jo','Irbid',13337.0,35.91,32.53).
city('Hzarja','jo','Irbid',5997.0,35.88,32.67).
city('Inbah','jo','Irbid',7294.0,35.76,32.48).
city('Irbid','jo','Irbid',296050.0,35.85,32.55).
city('Judayta','jo','Irbid',13163.0,35.7,32.4).
city('Kafr Abil','jo','Irbid',6907.0,35.67,32.42).
city('Kafr Asad','jo','Irbid',8947.0,35.72,32.6).
city('Kafr Awan','jo','Irbid',7855.0,35.68,32.43).
city('Kafr Rakib','jo','Irbid',4832.0,35.68,32.45).
city('Kafr Sawm','jo','Irbid',7800.0,35.8,32.68).
city('Kafr Yuba','jo','Irbid',11730.0,35.8,32.54).
city('Kafr al-Ma','jo','Irbid',10245.0,35.7,32.48).
city('Kitim','jo','Irbid',5771.0,35.9,32.44).
city('Kuraymah','jo','Irbid',19453.0,35.6,32.28).
city('Malka','jo','Irbid',7477.0,35.75,32.67).
city('Qumaym','jo','Irbid',5574.0,35.73,32.57).
city('Saham','jo','Irbid',6765.0,35.78,32.7).
city('Sal','jo','Irbid',7521.0,35.91,32.57).
city('Samma','jo','Irbid',9736.0,35.69,32.57).
city('Sammu','jo','Irbid',6683.0,35.74,32.52).
city('Sum','jo','Irbid',5188.0,35.8,32.59).
city('Tibnah','jo','Irbid',5703.0,35.73,32.48).
city('Umm Qays','jo','Irbid',4683.0,35.68,32.66).
city('Waqqas','jo','Irbid',6192.0,35.6,32.55).
city('Zahar','jo','Irbid',4526.0,35.78,32.57).
city('al-Asrafiyah','jo','Irbid',8687.0,35.8,32.1).
city('al-Balawinah','jo','Irbid',6090.0,35.6,32.25).
city('al-Buwaydah','jo','Irbid',5374.0,35.82,32.42).
city('al-Husun','jo','Irbid',22284.0,35.89,32.48).
city('al-Mansiyah','jo','Irbid',7491.0,35.58,32.58).
city('al-Mazar as-Samaliyah','jo','Ir',14319.0,35.79,32.47).
city('al-Mugayyir','jo','Irbid',9587.0,35.62,32.62).
city('an-Nuayyimah','jo','Irbid',13660.0,35.91,32.42).
city('ar-Ramtza','jo','Irbid',71571.0,36.01,32.57).
city('as-Sajarah','jo','Irbid',12262.0,35.93,32.65).
city('as-Sarih','jo','Irbid',21813.0,35.9,32.5).
city('as-Sunah as-Samaliyah','jo','Irbid',17311.0,35.61,32.61).
city('at-Tayyibah','jo','Irbid',13758.0,35.72,32.54).
city('at-Turrah','jo','Irbid',15944.0,35.99,32.64).
city('Balila','jo','Jaras',5639.0,35.93,32.38).
city('Burma','jo','Jaras',5128.0,35.78,32.22).
city('Jaras','jo','Jaras',29292.0,35.89,32.27).
city('Kafr Hzall','jo','Jaras',6396.0,35.88,32.36).
city('Muhzayyam Suf','jo','Jaras',13070.0,35.83,32.32).
city('Qafqafa','jo','Jaras',4767.0,35.94,32.35).
city('Raymun','jo','Jaras',6587.0,35.83,32.28).
city('Sakib','jo','Jaras',11339.0,35.81,32.29).
city('Suf','jo','Jaras',14017.0,35.84,32.32).
city('al-Kittah','jo','Jaras',6093.0,35.84,32.28).
city('Bayir','jo','Maan',5314.0,36.68,30.76).
city('Maan','jo','Maan',32647.0,35.73,30.19).
city('Wadi Musa','jo','Maan',15618.0,35.48,30.32).
city('al-Hussayniyah','jo','Maan',6156.0,35.78,32.25).
city('al-Jafr','jo','Maan',4289.0,36.21,30.29).
city('at-Tayyibah','jo','Maan',5142.0,35.47,30.25).
city('Diban','jo','Madaba',6854.0,35.78,31.5).
city('Madaba','jo','Madaba',82471.0,35.79,31.72).
city('Main','jo','Madaba',5320.0,35.73,31.68).
city('Mulayh','jo','Madaba',5414.0,35.82,31.58).
city('al-Aqabah','jo','al-Aqabah',101790.0,35.0,29.53).
city('al-Quwayrah','jo','al-Aqabah',8361.0,35.32,29.8).
city('Ayn al-Basa','jo','al-Balqa',29231.0,35.83,32.07).
city('Dirar','jo','al-Balqa',6529.0,35.63,32.22).
city('Juwafat al-Kafrayn','jo','al-Balqa',6897.0,35.64,31.86).
city('Maaddi','jo','al-Balqa',4475.0,35.62,32.17).
city('Mahas','jo','al-Balqa',10955.0,35.77,31.98).
city('Safut','jo','al-Balqa',6645.0,35.83,32.03).
city('Suknat as-Sunah','jo','al-Balqa',5328.0,35.58,31.89).
city('Yarqa','jo','al-',5146.0,35.69,31.98).
city('al-Baqah','jo','al-Balqa',80231.0,35.84,32.07).
city('al-Fuhays','jo','al-Balqa',13827.0,35.77,32.01).
city('al-Karamah','jo','al-Balqa',10089.0,35.58,31.95).
city('as-Salt','jo','al-Balqa',76583.0,35.72,32.05).
city('as-Subayhi','jo','al-Balqa',4322.0,35.7,32.15).
city('at-Tiwal al-Janubi','jo','al-Balqa',8143.0,35.6,32.17).
city('Adar','jo','al-Karak',4957.0,35.77,31.2).
city('Ayy','jo','al-Karak',8194.0,35.64,31.13).
city('Faqqu','jo','al-Karak',5620.0,35.7,31.37).
city('Gawr al-Mazraah','jo','al-Karak',8157.0,35.52,31.27).
city('Gawr as-Safi','jo','al-Karak',18413.0,35.47,31.04).
city('Mawtah','jo','al-Karak',11195.0,35.69,31.09).
city('Sirfa','jo','al-Karak',4454.0,35.66,31.33).
city('al-Hussayniyah','jo','al-Karak',4191.0,35.72,31.03).
city('al-Karak','jo','al-Karak',25404.0,35.7,31.18).
city('al-Mazar','jo','al-Karak',10475.0,35.7,31.07).
city('al-Qasr','jo','al-Karak',4287.0,35.75,31.31).
city('al-Qitranah','jo','al-Karak',4936.0,36.04,31.26).
city('ar-Rabbah','jo','al-Karak',4721.0,35.74,31.27).
city('at-Tayyibah','jo','al-Karak',5839.0,35.6,31.06).
city('Balama','jo','al-Mafraq',8549.0,36.08,32.23).
city('Mugayyir as-Sirhan','jo','al-Mafraq',6913.0,36.2,32.47).
city('Sabha','jo','al-Mafraq',5854.0,36.5,32.33).
city('Sama as-Sarhan','jo','al-Mafraq',4631.0,36.23,32.47).
city('Umm al-Qittayn','jo','al-Mafraq',4654.0,36.63,32.32).
city('al-Hamra','jo','al-Mafraq',6841.0,36.15,32.45).
city('al-Mafraq','jo','al-Mafraq',60161.0,36.22,32.36).
city('ar-Ruwaysid','jo','al-Mafraq',5857.0,38.2,32.5).
city('az-Zatari','jo','al-Mafraq',4968.0,36.3,32.3).
city('Busayra','jo','at-Tafilah',8238.0,35.6,30.73).
city('al-Ayn al-Bayda','jo','at-Tafilah',9011.0,36.9,31.88).
city('al-Hasa','jo','at-Tafilah',11762.0,35.98,30.82).
city('at-Tafilah','jo','at-Tafilah',29280.0,35.6,30.84).
city('Musayrfat Ras al-Ayn','jo','az-Zarqa',59608.0,35.92,31.95).
city('ad-Dulayl','jo','az-Zarqa',21974.0,36.05,32.15).
city('al-Azraq as-Samali','jo','az-Zarqa',7067.0,36.82,31.83).
city('al-Hasimiyah','jo','az-Zarqa',18851.0,36.12,32.13).
city('ar-Russayfah','jo','az-Zarqa',261903.0,36.02,32.02).
city('as-Suhznah','jo','az-Zarqa',13678.0,36.07,32.13).
city('az-Zarqa','jo','az-Zarqa',473254.0,36.1,32.07).
city('Akmechet','kz','Akmechet',166226.0,65.47,44.8).
city('Aralsk','kz','Akmechet',33016.0,61.66,46.81).
city('Ayteke','kz','Akmechet',35883.0,62.15,45.86).
city('Dzhusaly','kz','Akmechet',20065.0,64.09,45.5).
city('Kazalinsk','kz','Akmechet',6582.0,62.12,45.77).
city('Shieli','kz','Akmechet',29832.0,66.73,44.17).
city('Ta','kz','Akmechet',16455.0,65.54,44.78).
city('Zhanakorgan','kz','Akmechet',21339.0,67.24,43.91).
city('Almaty','kz','Almaty',1204820.0,76.92,43.32).
city('Boralday','kz','Almaty',20996.0,76.83,43.33).
city('Energeticheskiy','kz','Almaty',17463.0,77.0,43.5).
city('Esik','kz','Almaty',26447.0,77.45,43.37).
city('Fabrichniy','kz','Almaty',16656.0,76.39,43.17).
city('Kapsagay','kz','Almaty',42171.0,77.07,43.88).
city('Karabulak','kz','Almaty',16252.0,78.48,44.92).
city('Karasay','kz','Almaty',30.0,76.62,43.2).
city('Kirovskiy','kz','Almaty',11810.0,78.22,44.9).
city('Sarkand','kz','Almaty',76919.0,79.91,45.42).
city('Saryozek','kz','Almaty',13930.0,77.96,44.37).
city('Taldikorgan','kz','Almaty',107743.0,78.4,45.0).
city('Talgar','kz','Almaty',42194.0,77.24,43.31).
city('Tekeli','kz','Almaty',22470.0,78.85,44.81).
city('Ushtobe','kz','Almaty',20491.0,77.97,45.26).
city('Uzynagash','kz','Almaty',22712.0,76.31,43.23).
city('Zharkent','kz','Almaty',34422.0,79.98,44.17).
city('Aksu','kz','Aqmola',8543.0,71.96,52.45).
city('Alekseyevka','kz','Aqmola',2605.0,70.94,52.01).
city('Astana','kz','Aqmola',345621.0,71.47,51.17).
city('Atbasar','kz','Aqmola',34796.0,68.35,51.82).
city('Bestobe','kz','Aqmola',7188.0,73.09,52.5).
city('Derzhavinsk','kz','Aqmola',13856.0,66.31,51.1).
city('Ereymentau','kz','Aqmola',14169.0,73.11,51.63).
city('Koeksetau','kz','Aqmola',124452.0,69.42,53.3).
city('Makinsk','kz','Aqmola',17711.0,70.41,52.64).
city('Stepnogorsk','kz','Aqmola',46741.0,71.89,52.35).
city('Stepnyak','kz','Aqmola',4929.0,70.77,52.84).
city('Zholymbet','kz','Aqmola',6876.0,71.71,51.75).
city('Alga','kz','Aqtoebe',14229.0,58.32,49.91).
city('Aqtobe','kz','Aqtoebe',262471.0,57.17,50.28).
city('Batamshinskiy','kz','Aqtoebe',5668.0,58.27,50.57).
city('Emba','kz','Aqtoebe',18762.0,58.15,48.84).
city('Khromtau','kz','Aqtoebe',23717.0,58.45,50.27).
city('Oktyabrsk','kz','Aqtoebe',28199.0,57.42,49.48).
city('Shalkar','kz','Aqtoebe',29669.0,59.62,47.83).
city('Shubarkuduk','kz','Aqtoebe',11733.0,56.48,49.14).
city('Shubarshi','kz','Aqtoebe',8651.0,57.18,48.59).
city('Temir','kz','Aqtoebe',2560.0,57.13,49.14).
city('Atyrau','kz','Atyrau',146440.0,51.88,47.12).
city('Balykshi','kz','Atyrau',19260.0,51.87,47.07).
city('Dossor','kz','Atyrau',9526.0,52.98,47.53).
city('Inderborskiy','kz','Atyrau',13254.0,51.73,48.55).
city('Karaton','kz','Atyrau',8905.0,53.5,46.45).
city('Kulsary','kz','Atyrau',41108.0,54.01,46.97).
city('Makat','kz','Atyrau',14082.0,53.33,47.65).
city('Aksay','kz','Batis Kazakstan',34802.0,53.0,51.18).
city('Chapaevsk','kz','Batis Kazakstan',7724.0,51.14,50.19).
city('Chingirlau','kz','Batis Kazakstan',6218.0,54.11,51.12).
city('Fyodorovka','kz','Batis Kazakstan',5338.0,51.98,51.21).
city('Oral','kz','Batis Kazakstan',230205.0,51.0,51.0).
city('Zachagansk','kz','Batis Kazakstan',13345.0,51.28,51.15).
city('Aktau','kz','Mankistau',165512.0,73.05,50.27).
city('Beyneu','kz','Mankistau',14245.0,55.19,45.33).
city('Fort-Shevchenko','kz','Mankistau',5213.0,50.0,44.51).
city('Kuryk','kz','Mankistau',11836.0,51.67,43.19).
city('Mangystau','kz','Mankistau',17178.0,51.2,43.65).
city('Shetpe','kz','Mankistau',11836.0,52.14,44.15).
city('Zhanaozen','kz','Mankistau',54889.0,52.82,43.37).
city('Zhetybay','kz','Mankistau',11731.0,52.08,43.6).
city('Achisay','kz','Ontuestik Kazakstan',5635.0,68.9,43.54).
city('Aksu','kz','Ontuestik Kazakstan',26114.0,69.84,42.44).
city('Arys','kz','Ontuestik Kazakstan',36289.0,68.8,42.44).
city('Chardara','kz','Ontuestik Kazakstan',25356.0,67.96,41.26).
city('Ilyich','kz','Ontuestik Kazakstan',12895.0,68.51,40.85).
city('Kentau','kz','Ontuestik Kazakstan',57412.0,68.52,43.52).
city('Lenger','kz','Ontuestik Kazakstan',21238.0,69.88,42.19).
city('Saryagash','kz','Ontuestik Kazakstan',25139.0,69.15,41.46).
city('Shymkent','kz','Ontuestik Kazakstan',414059.0,69.59,42.32).
city('Tuerkistan','kz','Ontuestik Kazakstan',97368.0,68.26,43.3).
city('Zhetysay','kz','Ontuestik Kazakstan',29257.0,68.35,40.8).
city('Aksu','kz','Pavlodar',44812.0,76.93,52.05).
city('Ekibastuz','kz','Pavlodar',144133.0,75.32,51.73).
city('Irtyshyk','kz','Pavlodar',9216.0,75.45,53.34).
city('Kachiry','kz','Pavlodar',8931.0,76.09,53.08).
city('Maykain','kz','Pavlodar',7695.0,75.79,51.47).
city('Pavlodar','kz','Pavlodar',329014.0,76.95,52.3).
city('Sherbakty','kz','Pavlodar',8931.0,78.15,52.5).
city('Abay','kz','Qaragandy',35454.0,72.86,49.65).
city('Agadyr','kz','Qaragandy',9710.0,72.86,48.28).
city('Aktas','kz','Qaragandy',9888.0,72.98,49.79).
city('Aktau','kz','Qaragandy',9977.0,73.06,50.22).
city('Atasu','kz','Qaragandy',13184.0,71.65,48.69).
city('Balkhash','kz','Qaragandy',81369.0,74.95,46.85).
city('Gulshat','kz','Qaragandy',891.0,74.35,46.63).
city('Karacal','kz','Qaragandy',10703.0,70.8,48.02).
city('Karkaralinsk','kz','Qaragandy',8195.0,75.46,49.42).
city('Karsakbay','kz','Qaragandy',2761.0,66.72,47.84).
city('Konyrat','kz','Qaragandy',5167.0,74.99,46.96).
city('Nikolskiy','kz','Qaragandy',66902.0,67.53,47.89).
city('Novodolinskiy','kz','Qaragandy',5167.0,72.72,49.72).
city('Osakarovka','kz','Qaragandy',7305.0,72.57,50.58).
city('Qaragandy','kz','Qaragandy',413556.0,73.16,49.88).
city('Saran','kz','Qaragandy',46605.0,72.91,49.78).
city('Saryshagan','kz','Qaragandy',4365.0,73.6,46.12).
city('Shakhtinsk','kz','Qaragandy',52638.0,72.69,49.69).
city('Temirtau','kz','Qaragandy',172809.0,72.96,50.07).
city('Tokaryovka','kz','Qaragandy',4098.0,73.17,50.11).
city('Zhayrem','kz','Qaragandy',11670.0,70.58,48.24).
city('Zhezkazgan','kz','Qaragandy',104365.0,67.77,47.78).
city('Arkalik','kz','Qostanay',53843.0,66.9,50.25).
city('Borovskoy','kz','Qostanay',9659.0,64.15,53.8).
city('Esil','kz','Qostanay',13504.0,66.38,51.96).
city('Fyodorovka','kz','Qostanay',8317.0,62.69,53.64).
city('Komsomolets','kz','Qostanay',9838.0,62.05,53.75).
city('Komsomolskiy','kz','Qostanay',9569.0,65.53,53.32).
city('Kushmurun','kz','Qostanay',8049.0,64.6,52.46).
city('Lisakovsk','kz','Qostanay',33460.0,62.61,52.61).
city('Qostanay','kz','Qostanay',230282.0,63.63,53.22).
city('Rudni','kz','Qostanay',117946.0,63.12,52.95).
city('Tobol','kz','Qostanay',7155.0,62.58,52.7).
city('Zatobolsk','kz','Qostanay',16992.0,63.69,53.2).
city('Zhitikara','kz','Qostanay',43107.0,61.24,52.19).
city('Ayagoz','kz','Sigis Kazakstan',33479.0,80.43,47.97).
city('Belousovka','kz','Sigis Kazakstan',9948.0,82.52,50.14).
city('Glubokoe','kz','Sigis Kazakstan',11192.0,82.29,50.16).
city('Kurchatov','kz','Sigis Kazakstan',13152.0,80.18,50.38).
city('Kurchum','kz','Sigis Kazakstan',8800.0,83.65,48.58).
city('Oeskemen','kz','Sigis Kazakstan',319082.0,82.61,49.97).
city('Riddir','kz','Sigis Kazakstan',52667.0,83.52,50.36).
city('Semey','kz','Sigis Kazakstan',292795.0,80.27,50.43).
city('Serebryansk','kz','Sigis Kazakstan',11478.0,83.42,49.7).
city('Shar','kz','Sigis Kazakstan',9087.0,81.05,49.6).
city('Shemonaikha','kz','Sigis Kazakstan',20087.0,81.91,50.64).
city('Ulba','kz','Sigis Kazakstan',5165.0,83.37,50.27).
city('Urdzhar','kz','Sigis Kazakstan',14826.0,81.61,47.1).
city('Zaysan','kz','Sigis Kazakstan',17600.0,84.86,47.48).
city('Zyryanovsk','kz','Sigis Kazakstan',44939.0,84.26,49.75).
city('Bulaevo','kz','Soltuestik Kazakstan',9886.0,70.44,54.0).
city('Kishkenekol','kz','Soltuestik Kazakstan',6780.0,72.33,53.64).
city('Krasnoarmeysk','kz','Soltuestik Kazakstan',13148.0,69.75,53.85).
city('Leninogorsk','kz','Soltuestik Kazakstan',57203.0,63.29,45.64).
city('Mamlyutka','kz','Soltuestik Kazakstan',9328.0,68.52,54.94).
city('Petropavl','kz','Soltuestik Kazakstan',200891.0,69.22,54.88).
city('Saumalkol','kz','Soltuestik Kazakstan',2074.0,68.09,53.3).
city('Sergeyevka','kz','Soltuestik Kazakstan',8845.0,67.4,53.89).
city('Shuchinsk','kz','Soltuestik Kazakstan',47291.0,70.18,52.94).
city('Georgiyevka','kz','Taraz',9821.0,74.71,43.05).
city('Karatau','kz','Taraz',37881.0,70.46,43.18).
city('Korday','kz','Taraz',22047.0,81.56,49.34).
city('Merke','kz','Taraz',15934.0,73.18,42.87).
city('Mikhaylovka','kz','Taraz',15132.0,71.49,43.0).
city('Oytal','kz','Taraz',9821.0,73.26,42.91).
city('Shu','kz','Taraz',39785.0,73.74,43.6).
city('Taraz','kz','Taraz',358167.0,71.37,42.9).
city('Zhanatas','kz','Taraz',33495.0,69.73,43.56).
city('Gilgil','ke','Central',25264.0,36.31,-0.48).
city('Kandara','ke','Centra',914.0,37.0,-0.88).
city('Kangema','ke','Central',4319.0,36.96,-0.68).
city('Karatina','ke','Central',7452.0,37.1,-0.49).
city('Karuri','ke','Central',21476.0,37.18,-0.7).
city('Kerugoya','ke','Central',15287.0,37.28,-0.5).
city('Kiambu','ke','Central',21267.0,36.82,-1.18).
city('Kijabe','ke','Central',4679.0,36.57,-0.92).
city('Kikuyu','ke','Central',3960.0,36.67,-1.23).
city('Limuru','ke','Central',6323.0,36.65,-1.1).
city('Makuyu','ke','Central',191.0,37.18,-0.9).
city('Maragua','ke','Central',4662.0,37.13,-0.78).
city('Muranga','ke','Central',11987.0,37.15,-0.71).
city('Nyeri','ke','Central',51084.0,36.95,-0.41).
city('Ol Kalou','ke','Central',16516.0,36.38,-0.27).
city('Othaya','ke','Central',4468.0,36.95,-0.57).
city('Ruiru','ke','Central',114636.0,36.96,-1.14).
city('Sagana','ke','Central',3297.0,37.2,-0.67).
city('Thika','ke','Central',99335.0,37.09,-1.04).
city('Vanga','ke','Central',4049.0,39.17,-4.63).
city('Gazi','ke','Coast',5222.0,39.51,-4.43).
city('Kilifi','ke','Coast',46124.0,39.85,-3.61).
city('Kinango','ke','Coast',8070.0,39.32,-4.13).
city('Kipini','ke','Coast',4114.0,40.53,-2.52).
city('Kwale','ke','Coast',4883.0,39.45,-4.18).
city('Lamu','ke','Coast',24529.0,40.9,-2.28).
city('Malindi','ke','Coast',68311.0,40.1,-3.21).
city('Mariakani','ke','Coast',12786.0,39.47,-3.87).
city('Mombasa','ke','Coast',799727.0,39.66,-4.04).
city('Sawasawa','ke','Coast',12975.0,39.48,-4.47).
city('Shimoni','ke','Coast',2374.0,39.39,-4.64).
city('Takaungu','ke','Coast',10760.0,39.85,-3.68).
city('Tana River','ke','Coast',17915.0,39.5,-1.5).
city('Taveta','ke','Coast',13377.0,37.68,-3.4).
city('Voi','ke','Coast',19624.0,38.57,-3.37).
city('Witu','ke','Coast',5380.0,40.43,-2.38).
city('Wundanyi','ke','Coast',12501.0,38.37,-3.4).
city('Chogoria','ke','Eastern',2767.0,37.65,-0.23).
city('Chuka','ke','Eastern',9348.0,37.65,-0.33).
city('Embu','ke','Eastern',34927.0,37.45,-0.52).
city('Isiolo','ke','Eastern',33212.0,37.57,0.37).
city('Kangundo','ke','Eastern',10094.0,37.34,-1.3).
city('Kitui','ke','Eastern',15957.0,38.01,-1.36).
city('Machakos','ke','Eastern',31971.0,37.26,-1.51).
city('Makueni','ke','Eastern',20681.0,37.61,-1.8).
city('Marsabit','ke','Eastern',15364.0,37.98,2.33).
city('Matuu','ke','Eastern',5888.0,37.47,-1.2).
city('Maua','ke','Eastern',10804.0,37.93,0.23).
city('Mavoko','ke','Eastern',24530.0,37.0,-1.45).
city('Meru','ke','Eas',47226.0,37.64,0.06).
city('Mitoto-Andei','ke','Eastern',4763.0,38.17,-2.68).
city('Moyale','ke','Eastern',16246.0,39.05,3.52).
city('Mwingi','ke','Eastern',11219.0,38.07,-0.93).
city('Runjenjes','ke','Eastern',1733.0,37.57,-0.42).
city('Wote','ke','Eastern',6133.0,37.63,-1.78).
city('Nairobi','ke','Nairobi',2750561.0,36.82,-1.29).
city('Garissa','ke','North Eastern',67843.0,39.67,-0.44).
city('Mandera','ke','North Eastern',36066.0,41.86,3.94).
city('Wajir','ke','North Eastern',45679.0,40.05,1.75).
city('Ahero','ke','Nyanza',8788.0,34.92,-0.18).
city('Awendo','ke','Nyanza',15324.0,34.48,-1.0).
city('Bondo','ke','Nyanza',8683.0,34.27,0.24).
city('Homa Bay','ke','Nyanza',40324.0,34.45,-0.52).
city('Kehancha','ke','Nyanza',13162.0,34.62,-1.2).
city('Kendu Bay','ke','Nyanza',434.0,34.64,-0.36).
city('Keroka','ke','Nyanza',4143.0,34.95,-0.79).
city('Kisii','ke','Nyanza',28547.0,34.76,-0.67).
city('Kisumu','ke','Nyanza',216479.0,34.75,-0.09).
city('Masimba','ke','Nyanza',1855.0,34.93,-0.87).
city('Mbita Point','ke','Nyanza',6797.0,34.2,-0.42).
city('Migori','ke','Nyanza',35240.0,34.47,-1.07).
city('Muhoroni','ke','Nyanza',15217.0,35.2,-0.15).
city('Nyamache','ke','Nyanza',2456.0,34.78,-0.85).
city('Nyamarambe','ke','Nyanza',236.0,34.62,-0.81).
city('Nyamira','ke','Nyanza',11104.0,34.9,-0.55).
city('Nyansiongo','ke','Nyanza',4112.0,35.02,-0.75).
city('Ogembo','ke','Nyanza',1842.0,34.72,-0.8).
city('Oyugis','ke','Nyanza',10116.0,34.72,-0.5).
city('Rongo','ke','Nyanza',6877.0,34.6,-0.77).
city('Siaya','ke','Nyanza',15354.0,34.29,0.06).
city('Suneka','ke','Nyanza',4696.0,34.74,-0.66).
city('Tabaka','ke','Nyanza',5643.0,34.67,-0.75).
city('Ugunja','ke','Nyanza',3996.0,34.3,0.18).
city('Ukwala','ke','Nyanza',747.0,34.19,-0.19).
city('Yala','ke','Nyanza',2715.0,34.53,0.1).
city('Baringo','ke','Rift Valley',7656.0,35.97,0.47).
city('Bomet','ke','Rift Valley',5270.0,35.35,-0.79).
city('Burnt Forest','ke','Rift Valley',3786.0,35.42,0.23).
city('Chepareria','ke','Rift Valley',1073.0,35.2,1.32).
city('Eldama Ravine','ke','Rift Valley',12523.0,35.72,0.05).
city('Eldoret','ke','Rift Valley',218472.0,35.27,0.52).
city('Itentambach','ke','Rift Valley',4725.0,35.52,0.6).
city('Kabarnet','ke','Rift Valley',10134.0,35.73,0.5).
city('Kajiado','ke','Rift Valley',11199.0,36.79,-1.84).
city('Kapenguria','ke','Rift Valley',15436.0,35.08,1.26).
city('Kapsabet','ke','Rift Valley',23990.0,35.09,0.21).
city('Kericho','ke','Rift Valley',35747.0,35.28,-0.36).
city('Kipkelion','ke','Rift Valley',2952.0,35.47,-0.2).
city('Kitale','ke','Rift Valley',75136.0,34.99,1.03).
city('Konza','ke','Rift Valley',2004.0,37.12,-1.75).
city('Laikipia','ke','Rift Valley',4298.0,36.75,0.42).
city('Litein','ke','Rift Valley',3129.0,35.18,-0.58).
city('Lodwar','ke','Rift Valley',20219.0,35.57,3.13).
city('Londiani','ke','Rift Valley',4758.0,35.58,-0.15).
city('Magadi','ke','Rift Valley',14529.0,36.3,-1.89).
city('Maralal','ke','Rift Valley',20843.0,36.68,1.11).
city('Molo','ke','Rift Valley',27901.0,35.73,-0.24).
city('Naivasha','ke','Rift Valley',38366.0,36.43,-0.71).
city('Nakuru','ke','Rift Valley',259934.0,36.07,-0.28).
city('Namanga','ke','Rift Valley',13193.0,36.8,-2.54).
city('Nandi','ke','Rift Valley',3758.0,35.1,0.2).
city('Nandi Hills','ke','Rift Valley',4257.0,35.18,0.12).
city('Nanyuki','ke','Rift Valley',36147.0,37.06,0.02).
city('Naro Moru','ke','Rift Valley',9018.0,37.02,-0.17).
city('Narok','ke','Rift Valley',36067.0,35.85,-1.07).
city('Ngong','ke','Rift Valley',9519.0,36.65,-1.36).
city('Nyahururu','ke','Rift Valley',31982.0,36.36,0.04).
city('Rongai','ke','Rift Valley',30471.0,35.85,-0.17).
city('Rumuruti','ke','Rift Valley',4502.0,36.52,0.27).
city('Sotik','ke','Rift Valley',2600.0,35.12,-0.68).
city('Bungoma','ke','Western',55968.0,34.56,0.57).
city('Busia','ke','Western',40920.0,34.31,0.39).
city('Butere','ke','Western',11206.0,34.48,0.22).
city('Funyula','ke','Western',1426.0,34.12,-0.28).
city('Kakamega','ke','Western',63433.0,34.73,0.29).
city('Kimilili','ke','Western',11780.0,34.72,-0.79).
city('Luanda','ke','Western',10053.0,34.05,0.3).
city('Lugari','ke','Western',5828.0,34.85,0.65).
city('Malaba','ke','Western',8383.0,34.27,0.63).
city('Malakisi','ke','Western',4319.0,34.42,0.68).
city('Malava','ke','Western',1956.0,34.85,-0.45).
city('Mount Elgon','ke','Western',6096.0,34.76,1.09).
city('Mumias','ke','Western',45492.0,34.49,0.33).
city('Nambale','ke','Western',1154.0,34.25,0.44).
city('Port Victoria','ke','Western',6793.0,33.0,0.1).
city('Sirisia','ke','Western',944.0,34.0,0.12).
city('Vihiga','ke','Western',21889.0,34.93,0.3).
city('Webuye','ke','Western',22508.0,34.77,0.62).
city('Taburao','ki','Abaiang',3823.0,173.04,1.81).
city('Binoinano','ki','Abemana',369.0,173.92,0.42).
city('Takaeang','ki','Aranuka',772.0,173.62,0.16).
city('Roreti','ki','Arorae',1174.0,176.83,2.65).
city('Ooma','ki','Banaba',112.0,169.55,-0.88).
city('Tabukiniberu','ki','Beru',1993.0,175.98,-1.34).
city('Butaritari','ki','Butaritari',2582.0,172.79,3.08).
city('London','ki','Kiritimati',687.0,157.78,1.99).
city('Tabontebike','ki','Kuria',749.0,173.4,0.21).
city('Tabiauea','ki','Maiana',1476.0,173.03,0.91).
city('Makin','ki','Makin',1258.0,172.99,3.38).
city('Rawannawi','ki','Marakei',1916.0,173.27,2.05).
city('Rungata','ki','Nikunau',1414.0,176.44,-1.35).
city('Temaraia','ki','Nonouti',2631.0,174.45,-0.69).
city('Ijaki','ki','Onotoa',825.0,175.58,-1.91).
city('Pyramid Point','ki','Phoenix Islands',53.0,-171.62,-2.87).
city('Utiroa','ki','Tabiteuea North',2230.0,174.76,-1.23).
city('Buariki','ki','Tabiteuea South',692.0,175.06,-1.48).
city('Nabari','ki','Tabuaeran',228.0,-159.73,3.91).
city('Abaokoro','ki','Tamana',783.0,175.97,-2.5).
city('Buariki','ki','Tarawa North',2715.0,172.95,1.61).
city('Bairiki','ki','Tarawa South',44428.0,172.99,1.33).
city('Bonriki','ki','Tarawa South',3711.0,173.15,1.37).
city('Washington','ki','Teraina',1201.0,-160.76,4.71).
city('Bayan','kw','Hawalli',30656.0,48.03,29.3).
city('Hawalli','kw','Hawalli',93312.0,47.98,29.35).
city('Musrif','kw','Hawalli',18704.0,48.07,29.27).
city('Salwa','kw','Hawalli',40972.0,48.08,29.28).
city('al-Jabiriyah','kw','Hawalli',34464.0,48.02,29.31).
city('ar-Rumaytziyah','kw','Hawalli',32103.0,48.07,29.32).
city('as-Saab','kw','Hawalli',8863.0,48.02,29.36).
city('as-Salimiyah','kw','Hawalli',158860.0,48.06,29.33).
city('Sabhan','kw','Mubarak al-Kabir',3394.0,48.0,29.25).
city('Subbah-as-Salim','kw','Mubarak al-Kabir',139150.0,48.06,29.26).
city('al-Funaytis','kw','Mubarak al-Kab',1878.0,48.1,29.24).
city('al-Funaytis-al-Garbiyah','kw','Mubarak al-Kabir',5080.0,48.06,29.23).
city('al-Massilah','kw','Mubarak al-Kabir',2358.0,48.09,29.25).
city('al-Qurayn','kw','Mubarak al-Kabir',128760.0,48.07,29.2).
city('Abu Hulayfah','kw','al-Ahmadi',28967.0,48.12,29.14).
city('Hadiyah','kw','al-Ahmadi',9437.0,48.08,29.14).
city('Jabbar-al-Ali','kw','al-Ahmadi',38023.0,48.08,29.17).
city('al-Ahmadi','kw','al-Ahmadi',38253.0,48.08,29.07).
city('al-Aqaylah','kw','al-Ahmadi',930.0,48.1,29.17).
city('al-Fintas','kw','al-Ahmadi',23067.0,48.12,29.18).
city('al-Fuhayhil','kw','al-Ahmadi',68278.0,48.13,29.08).
city('al-Mahbulah','kw','al-Ahmadi',18175.0,48.12,29.15).
city('al-Manqaf','kw','al-Ahmadi',39018.0,48.13,29.1).
city('al-Wafrah','kw','al-Ahmadi',10015.0,47.93,28.62).
city('ar-Riqqah','kw','al-Ahmadi',52058.0,48.11,29.15).
city('as-Sabahiyah','kw','al-Ahmadi',187655.0,48.11,29.12).
city('as-Suaybah','kw','al-Ahmadi',2864.0,48.13,29.05).
city('az-Zahar','kw','al-Ahmadi',41392.0,48.07,29.17).
city('az-Zawr','kw','al-Ahmadi',5749.0,48.28,29.44).
city('Abdullah-as-Salam','kw','al-Asamah',20601.0,47.98,29.36).
city('Banayd-al-Qar','kw','al-Asamah',26018.0,48.01,29.36).
city('Doha','kw','al-Asamah',37804.0,47.82,29.32).
city('Garnatah','kw','al-Asamah',2799.0,47.88,29.32).
city('Kayfan','kw','al-Asamah',27202.0,48.05,29.32).
city('Qartabah','kw','al-Asamah',14258.0,47.99,29.31).
city('ad-Daiyah','kw','al-Asamah',15594.0,47.98,29.33).
city('ad-Dasmah','kw','al-Asamah',17582.0,48.0,29.37).
city('al-Fayha','kw','al-Asamah',19800.0,47.98,29.34).
city('al-Hzalidiya','kw','al-Asamah',15846.0,47.95,29.33).
city('al-Kuwayt','kw','al-Asamah',60053.0,47.99,29.38).
city('al-Mansuriyah','kw','al-Asamah',8898.0,48.0,29.36).
city('al-Mintaqah as-Sahiyah','kw','al-Asamah',5485.0,47.9,29.32).
city('al-Qadisiyah','kw','al-Asamah',20528.0,48.0,29.35).
city('al-Udayliyah','kw','al-Asamah',17461.0,47.96,29.3).
city('al-Yarmawk','kw','al-Asamah',15586.0,47.93,29.29).
city('an-Nuzha','kw','al-Asamah',13819.0,47.99,29.35).
city('ar-Rawdah','kw','al-Asamah',30049.0,48.0,29.32).
city('as-Samiyah','kw','al-A',13759.0,47.97,29.35).
city('as-Sulaybihzat','kw','al-Asamah',32498.0,47.87,29.32).
city('as-Suwayhz as-Sakaniyah','kw','al-Asamah',4711.0,47.93,29.33).
city('as-Suwayhz as-Sanaiyah','kw','al-Asamah',10694.0,47.94,29.34).
city('Abraq Hzitan','kw','al-Farwaniyah',47577.0,47.98,29.29).
city('Hzitan-al-Janubiyah','kw','al-Farwaniyah',203647.0,47.95,29.26).
city('Jalib as-Suyuhz','kw','al-Farwaniyah',166467.0,47.94,29.27).
city('Janub-as-Surrah','kw','al-Farwaniyah',18493.0,48.02,29.29).
city('Sabah-an-Nasr','kw','al-Farwaniyah',14765.0,47.89,29.26).
city('Umayriyah','kw','al-Farwaniyah',20096.0,47.91,29.29).
city('al-Andalus','kw','al-Farwaniyah',31808.0,47.88,29.31).
city('al-Ardiyah','kw','al-Farwaniyah',55063.0,47.88,29.29).
city('al-Fardaws','kw','al-Farwaniyah',65746.0,47.87,29.29).
city('al-Farwaniyah','kw','al-Farwaniyah',86510.0,47.91,29.27).
city('ar-Rabiyah','kw','al-Farwaniyah',36440.0,47.9,29.29).
city('ar-Ray','kw','al-Farwaniyah',6336.0,47.93,29.31).
city('ar-Riqay','kw','al-Farwaniyah',19206.0,47.91,29.31).
city('Amgarah','kw','al-Jahra',12150.0,47.74,29.29).
city('Tayma','kw','al-Jahra',69483.0,47.7,29.32).
city('al-Jahra','kw','al-Jahra',22125.0,47.69,29.35).
city('al-Qasr','kw','al-Jahra',58979.0,47.71,29.34).
city('al-Uyawn','kw','al-Jahra',32421.0,47.67,29.32).
city('al-Wahah','kw','al-Jahra',39111.0,47.67,29.34).
city('an-Nasim','kw','al-Jahra',16349.0,47.72,29.33).
city('as-Sulaybiyah','kw','al-Jahra',80887.0,47.83,29.29).
city('Batken','kg','Batken',10155.0,70.83,40.07).
city('Haydarkan','kg','Batken',11857.0,71.33,39.94).
city('Isfana','kg','Batken',16952.0,69.53,39.84).
city('Biskek','kg','Biskek',896258.0,74.57,42.87).
city('Bazarkurgon','kg','Celalabad',27704.0,72.74,41.07).
city('Celalabad','kg','Celalabad',77929.0,73.0,40.94).
city('Kochkor-Ata','kg','Celalabad',16076.0,72.35,41.08).
city('Koekyangak','kg','Celalabad',11006.0,73.2,41.03).
city('Maylisuu','kg','Celalabad',20228.0,72.45,41.26).
city('Taskoemuer','kg','Celalabad',23596.0,72.22,41.35).
city('Ak-Suu','kg','Cuy',9344.0,74.38,42.81).
city('Kant','kg','Cuy',20182.0,74.84,42.89).
city('Karabalta','kg','Cuy',62841.0,73.89,42.83).
city('Kayingdi','kg','Cuy',10616.0,73.68,42.83).
city('Kemin','kg','Cuy',10295.0,75.68,42.8).
city('Krasnooktyabrskiy','kg','Cuy',9857.0,74.31,42.84).
city('Tokmak','kg','Cuy',63047.0,75.29,42.83).
city('Balikci','kg','Issik-Goel',45102.0,76.19,42.46).
city('Colponata','kg','Issik-Goel',18598.0,77.08,42.65).
city('Karakol','kg','Issik-Goel',70172.0,78.38,42.49).
city('Tyup','kg','Issik-Goel',13438.0,78.36,42.73).
city('At-Bashi','kg','Narin',15227.0,75.8,41.17).
city('Narin','kg','Narin',41717.0,75.99,41.43).
city('Kara-Suu','kg','Os',18098.0,72.89,40.71).
city('Kizilkiya','kg','Os',30997.0,72.12,40.26).
city('Oezgoen','kg','Os',40364.0,73.29,40.78).
city('Os','kg','Os',230409.0,72.79,40.54).
city('Sueluektue','kg','Os',15019.0,69.56,39.94).
city('Karakol','kg','Talas',19432.0,72.67,41.63).
city('Talas','kg','Talas',35172.0,72.24,42.52).
city('Toktogul','kg','Talas',19336.0,72.94,41.88).
city('Samakhixai','la','Attopu',4296.0,106.84,14.81).
city('Huayxay','la','Bokeo',16649.0,104.3,20.8).
city('Pakxan','la','Bolikhamsay',21958.0,103.64,18.4).
city('Champasak','la','Champasak',12994.0,105.86,14.9).
city('Pakxe','la','Champasak',88463.0,105.8,15.12).
city('Xam Nua','la','Houaphanh',38976.0,104.04,20.42).
city('Thakek','la','Khammouane',26189.0,104.81,17.4).
city('Nam Tha','la','Luang Nam Tha',3227.0,101.4,20.96).
city('Luang Prabang','la','Luang Prabang',47510.0,102.14,19.89).
city('Ban Nahin','la','Oudomxay',3465.0,104.22,18.23).
city('Phongsaly','la','Phongsaly',14311.0,102.19,21.75).
city('Saravan','la','Saravan',5519.0,106.41,15.72).
city('Savannakhet','la','Savannakhet',66552.0,104.75,16.57).
city('Sekong','la','Sekong',4462.0,106.7,15.41).
city('Vientiane','la','Viangchan Prefecture',196644.0,102.61,17.97).
city('Phonhong','la','Viangchan Province',10122.0,102.42,18.48).
city('Xaignabury','la','Xaignabury',31160.0,101.48,19.2).
city('Pek','la','Xiang Khuang',5229.0,103.37,19.34).
city('Aizkraukle','lv','Aizkraukles',8840.0,25.2,56.59).
city('Jaunjelgava','lv','Aizkraukles',1938.0,25.09,56.63).
city('Plavinas','lv','Aizkraukles',3848.0,25.72,56.62).
city('Aluksne','lv','Aluksnes',2264.0,27.04,57.43).
city('Ape','lv','Aluksnes',1521.0,26.69,57.55).
city('Balvi','lv','Balvu',8409.0,27.26,57.13).
city('Vilaka','lv','Balvu',1797.0,27.67,57.19).
city('Bauska','lv','Bauskas',10532.0,24.18,56.41).
city('Cesis','lv','Cesu',18198.0,25.27,57.32).
city('Ligatne','lv','Cesu',1433.0,25.05,57.19).
city('Daugavpils','lv','Daugavpils pilseta',111564.0,26.51,55.88).
city('Ilukste','lv','Daugavpils',2898.0,26.3,55.98).
city('Subate','lv','Daugavpils',908.0,25.91,56.02).
city('Auce','lv','Dobeles',3125.0,22.9,56.47).
city('Dobele','lv','Dobeles',11225.0,23.27,56.63).
city('Gulbene','lv','Gulbenes',9355.0,26.75,57.18).
city('Akniste','lv','Jekabspils',1314.0,25.75,56.17).
city('Jekabspils','lv','Jekabspils',27078.0,25.86,56.51).
city('Viesite','lv','Jekabspils',2162.0,25.56,56.36).
city('Jelgava','lv','Jelgava',61793.0,23.71,56.65).
city('Kalnciems','lv','Jelgavas',2103.0,23.58,56.85).
city('Jurmala','lv','Jurmala pilseta',54088.0,23.76,56.98).
city('Dagda','lv','Kraslavas',2740.0,27.54,56.1).
city('Kraslava','lv','Kraslavas',11088.0,27.17,55.9).
city('Kuldiga','lv','Kuldigas',13289.0,21.95,56.98).
city('Skrunda','lv','Kuldigas',2659.0,22.02,56.67).
city('Liepaja','lv','Liepaja',85263.0,21.01,56.51).
city('Aizpute','lv','Liepajas',5634.0,21.61,56.72).
city('Durbe','lv','Liepajas',454.0,21.35,56.59).
city('Grobina','lv','Lie',4203.0,21.16,56.55).
city('Pavilosta','lv','Liepajas',1171.0,21.17,56.89).
city('Priekule','lv','Liepajas',2550.0,21.58,56.46).
city('Ainazi','lv','Limbazu',1278.0,24.35,57.87).
city('Aloja','lv','Limbazu',1509.0,24.87,57.78).
city('Limbazi','lv','Limbazu',8974.0,24.71,57.52).
city('Salacgriva','lv','Limbazu',3427.0,24.36,57.77).
city('Staicele','lv','Limbazu',1175.0,24.75,57.84).
city('Karsava','lv','Ludzas',2645.0,27.68,56.79).
city('Ludza','lv','Ludzas',10514.0,27.73,56.55).
city('Zilupe','lv','Ludzas',1897.0,28.11,56.4).
city('Cesvaine','lv','Madonas',1811.0,26.31,56.97).
city('Lubana','lv','Madonas',1918.0,26.73,56.9).
city('Madona','lv','Madonas',9280.0,26.22,56.86).
city('Varaklani','lv','Madonas',2344.0,26.75,56.62).
city('Kegums','lv','Ogres',2372.0,24.72,56.74).
city('Lielvarde','lv','Ogres',5114.0,24.8,56.72).
city('Ogre','lv','Ogres',25818.0,24.61,56.81).
city('Livani','lv','Preilu',10073.0,26.18,56.36).
city('Preili','lv','Preilu',8656.0,26.71,56.3).
city('Rezekne','lv','Rezekne',38340.0,27.32,56.51).
city('Vilani','lv','Rezeknes',3934.0,26.93,56.57).
city('Riga','lv','Riga',742570.0,24.13,56.97).
city('Baldone','lv','Rigas',2025.0,24.39,56.75).
city('Balozi','lv','Rigas',3854.0,24.12,56.87).
city('Olaine','lv','Rigas',12584.0,23.92,56.81).
city('Salaspils','lv','Rigas',17606.0,24.35,56.86).
city('Saulkrasti','lv','Rigas',3184.0,24.41,57.29).
city('Sigulda','lv','Rigas',10422.0,24.86,57.16).
city('Vangazi','lv','Rigas',4020.0,24.53,57.11).
city('Broceni','lv','Saldus',3486.0,22.53,56.7).
city('Saldus','lv','Saldus',12223.0,22.48,56.67).
city('Sabile','lv','Talsu',1580.0,22.57,57.05).
city('Stende','lv','Talsu',1955.0,22.53,57.15).
city('Talsi','lv','Talsu',12022.0,22.59,57.25).
city('Valdemarpils','lv','Talsu',1447.0,22.59,57.38).
city('Kandava','lv','Tukuma',3592.0,22.76,57.05).
city('Tukums','lv','Tukuma',18348.0,23.16,56.97).
city('Seda','lv','Valkas',1778.0,25.74,57.65).
city('Smiltene','lv','Valkas',6108.0,25.9,57.43).
city('Strenci','lv','Valkas',1593.0,25.67,57.64).
city('Valka','lv','Valkas',6589.0,26.0,57.78).
city('Mazsalaca','lv','Valmieras',1701.0,25.04,57.87).
city('Rujiena','lv','Valmieras',3638.0,25.34,57.9).
city('Valmiera','lv','Valmieras',26963.0,25.42,57.55).
city('Ventspils','lv','Ventspils pilseta',42643.0,21.56,57.4).
city('Piltene','lv','Ventspils',1103.0,21.66,57.22).
city('Bayrut','lb','Bayrut',1252010.0,35.5,33.88).
city('Alay','lb','Jabal Lubnan',27233.0,35.61,33.81).
city('Babda','lb','Jabal Lubnan',77190.0,35.57,33.88).
city('Jubayl','lb','Jabal Lubnan',20786.0,35.66,34.13).
city('Juniyah','lb','Jabal Lubnan',96322.0,35.63,33.97).
city('Balabakk','lb','al-Biqaa',30925.0,36.21,34.01).
city('Jubb Jannin','lb','al-Biqaa',7088.0,35.68,33.62).
city('Rasayya','lb','al-Biqaa',11288.0,35.86,33.51).
city('Riyaq','lb','al-Biqaa',18878.0,36.01,33.86).
city('Zahlah','lb','al-Biqaa',78145.0,35.92,33.84).
city('al-Hirmil','lb','al-Biqaa',11071.0,36.39,34.4).
city('Jazzin','lb','al-Janub',13477.0,35.61,33.59).
city('Juwayya','lb','al-Janub',6931.0,35.35,33.24).
city('Sayda','lb','al-Janub',163574.0,35.39,33.57).
city('Sur','lb','al-Janub',135211.0,35.21,33.28).
city('Marjuyun','lb','an-Nabatiyah',16173.0,35.59,33.34).
city('an-Nabatiyat-at-Tahta','lb','an-Nabatiyah',98441.0,35.48,33.41).
city('Tarabulus as-Sam','lb','as-Samal',229418.0,35.87,34.43).
city('al-Batrun','lb','as-Samal',10852.0,35.65,34.27).
city('Teyateyaneng','ls','Berea',25149.0,27.74,-29.15).
city('Butha Buthe','ls','Butha-Buthe',11373.0,28.23,-28.78).
city('Hlotse','ls','Leribe',46416.0,28.06,-28.85).
city('Maputsoa','ls','Leribe',31690.0,27.9,-28.88).
city('Mafeteng','ls','Mafeteng',40591.0,27.25,-29.83).
city('Maseru','ls','Maseru',194387.0,27.49,-29.31).
city('Mohales Hoek','ls','Mohales Hoek',22153.0,27.48,-30.16).
city('Mokhotlong','ls','Mokhotlong',5484.0,29.07,-29.29).
city('Qachas Nek','ls','Qachas Nek',17810.0,28.69,-30.12).
city('Quthing','ls','Quthing',17073.0,27.72,-30.39).
city('Thaba-Tseka','ls','Thaba-Tseka',4843.0,28.6,-29.54).
city('Tubmanburg','lr','Bomi',3168.0,-10.82,6.87).
city('Gbarnga','lr','Bong',45947.0,-9.49,7.01).
city('Buchanan','lr','Grand Bassa',25864.0,-10.05,5.88).
city('Robertsport','lr','Grand Cape Mount',12015.0,-11.36,6.75).
city('Zwedru','lr','Grand Gedeh',25772.0,-8.13,6.07).
city('Harper','lr','Maryland and Grand Kru',32931.0,-7.72,4.39).
city('Bensonville','lr','Montserrado',32970.0,-10.6,6.45).
city('Monrovia','lr','Montserrado',935427.0,-10.8,6.31).
city('Ganta','lr','Nimba',13828.0,-8.53,7.3).
city('Yekepa','lr','Nimba',24746.0,-8.53,7.58).
city('Ajdabiya','ly','Ajdabiya',134357.0,20.22,30.77).
city('Marsa al-Burayqah','ly','Ajdabiya',13780.0,19.61,30.39).
city('az-Zuwaytinah','ly','Ajdabiya',21014.0,20.12,30.95).
city('Benghazi','ly','Bangazi',650629.0,20.07,32.12).
city('Bani Walid','ly','Bani Walid',46350.0,13.99,31.77).
city('Darnah','ly','Darnah',78782.0,22.64,32.77).
city('Gadamis','ly','Gadamis',16752.0,9.5,30.15).
city('Garyan','ly','Garyan',85219.0,13.02,32.17).
city('Gat','ly','Gat',24347.0,10.17,24.97).
city('Marzuq','ly','Marzuq',43732.0,13.91,25.93).
city('Misratah','ly','Misratah',386120.0,15.09,32.38).
city('Mizdah','ly','Mizdah',26107.0,12.98,31.43).
city('Nalut','ly','Nalut',66228.0,10.97,31.88).
city('Sabha','ly','Sabha',126387.0,14.42,27.07).
city('Sabratah','ly','Sabratah wa Surman',102037.0,12.48,32.79).
city('Surman','ly','Sabratah wa Surman',25235.0,12.58,32.77).
city('Surt','ly','Surt',128123.0,16.59,31.21).
city('Masallatah','ly','Tarhunah wa Masallatah',23702.0,14.0,32.62).
city('Tarhunah','ly','Tarhunah wa Masallatah',210698.0,13.63,32.43).
city('Tripoli','ly','Tripoli',1150990.0,13.18,32.87).
city('Awbari','ly','Wadi al-Hayat',42975.0,12.77,26.58).
city('al-Biraq','ly','Wadi as-Sati',39444.0,14.28,27.53).
city('Jadu','ly','Yafran wa Jadu',6013.0,12.02,31.95).
city('Yafran','ly','Yafran wa Jadu',67638.0,12.53,32.06).
city('Bardiyah','ly','al-Butnan',9149.0,25.09,31.77).
city('Tubruq','ly','al-Butnan',121052.0,23.96,32.08).
city('Suluq','ly','al-Hizam al-Ahzdar',15543.0,20.25,31.67).
city('Tukrah','ly','al-Hizam al-Ahzdar',23164.0,20.57,32.53).
city('al-Abyar','ly','al-Hizam al-Ahzdar',31248.0,20.6,32.18).
city('Sahhat','ly','al-Jabal al-Ahdar',43376.0,21.86,32.83).
city('al-Bayda','ly','al-Jabal al-Ahdar',118753.0,21.62,32.76).
city('al-Aziziyah','ly','al-Jifarah',287406.0,13.02,32.53).
city('Hun','ly','al-Jufrah',18878.0,15.94,29.12).
city('Waddan','ly','al-Jufrah',27590.0,16.13,29.17).
city('al-Kufrah','ly','al-Kufrah',46050.0,23.29,24.2).
city('al-Marj','ly','al-Marj',85315.0,20.83,32.5).
city('Zlitan','ly','al-Marqab',99289.0,14.56,32.48).
city('al-Hzums','ly','al-Marqab',201943.0,14.26,32.66).
city('al-Qubbah','ly','al-Qubbah',53064.0,22.25,32.77).
city('Awjilah','ly','al-Wahat',6610.0,21.29,29.11).
city('Jalu','ly','al-Wahat',3334.0,21.53,29.03).
city('Zaltan','ly','an-Nuqat al-Hums',16291.0,11.87,32.95).
city('Zuwarah','ly','an-Nuqat al-Hums',180310.0,12.09,32.95).
city('az-Zawiyah','ly','az-Zawiyah',186125.0,12.72,32.76).
city('Balzers','li','Balzers',4447.0,9.51,47.08).
city('Eschen','li','Eschen',4008.0,9.52,47.21).
city('Gamprin','li','Gamprin',1268.0,9.5,47.22).
city('Mauren','li','Mauren',3626.0,9.53,47.22).
city('Planken','li','Planken',377.0,9.53,47.18).
city('Ruggell','li','Ruggell',1862.0,9.52,47.24).
city('Schaan','li','Schaan',5748.0,9.51,47.17).
city('Schellenberg','li','Schellenberg',1004.0,9.54,47.23).
city('Triesen','li','Triesen',4701.0,9.53,47.11).
city('Triesenberg','li','Triesenberg',2689.0,9.53,47.12).
city('Vaduz','li','Vaduz',5197.0,9.53,47.14).
city('Alytus','lt','Alytaus',70750.0,24.05,54.39).
city('Daugai','lt','Alytaus',1279.0,24.33,54.37).
city('Druskininkai','lt','Alytaus',17793.0,23.98,54.02).
city('Lazdijai','lt','Alytaus',4975.0,23.51,54.24).
city('Simnas','lt','Alytaus',1864.0,23.65,54.4).
city('Varena','lt','Alytaus',10305.0,24.55,54.23).
city('Veisiejai','lt','Alytaus',1654.0,23.65,54.08).
city('Ariogala','lt','Kauno',3653.0,23.49,55.26).
city('Birstonas','lt','Kauno',3181.0,24.01,54.61).
city('Dotnuva','lt','Kauno',783.0,23.89,55.37).
city('Ezerelis','lt','Kauno',2051.0,23.6,54.89).
city('Garliava','lt','Kauno',13811.0,23.87,54.82).
city('Jieznas','lt','Kauno',1390.0,24.17,54.61).
city('Jonava','lt','Kauno',34996.0,24.27,55.08).
city('Kacergine','lt','Kauno',897.0,23.7,54.93).
city('Kaisiadorys','lt','Kauno',9868.0,24.46,54.87).
city('Kaunas','lt','Kauno',374655.0,23.91,54.9).
city('Kedainiai','lt','Kauno',31983.0,23.97,55.3).
city('Kulautuva','lt','Kauno',1401.0,23.65,54.94).
city('Prienai','lt','Kauno',11353.0,23.94,54.64).
city('Raseiniai','lt','Kauno',12525.0,23.12,55.38).
city('Vilkija','lt','Kauno',2289.0,23.59,55.05).
city('Ziezmariai','lt','Kauno',4061.0,24.44,54.8).
city('Gargzdai','lt','Klaipedos',15951.0,21.39,55.71).
city('Klaipeda','lt','Klaipedos',192314.0,21.13,55.71).
city('Kretinga','lt','Klaipedos',22238.0,21.23,55.89).
city('Neringa','lt','Klaipedos',2380.0,21.05,55.38).
city('Pagegiai','lt','Klaipedos',2363.0,21.91,55.14).
city('Palanga','lt','Klaipedos',17798.0,21.06,55.92).
city('Panemune','lt','Klaipedos',313.0,21.91,55.09).
city('Priekule','lt','Klaipedos',1711.0,21.32,55.56).
city('Rusne','lt','Klaipedos',2484.0,21.38,55.3).
city('Salantai','lt','Klaipedos',1829.0,21.57,56.07).
city('Silute','lt','Klaipedos',21762.0,21.47,55.35).
city('Skuodas','lt','Klaipedos',7726.0,21.51,56.27).
city('Zemaiciu Naumiestis','lt','Klaipedos',1285.0,21.69,55.37).
city('Gelgaudiskis','lt','Marijampoles',1839.0,22.98,55.08).
city('Kalvarija','lt','Marijampo',4876.0,23.22,54.42).
city('Kazlu Ruda','lt','Marijampoles',7248.0,23.48,54.78).
city('Kudirkos Naumiestis','lt','Marijampoles',1962.0,22.88,54.77).
city('Kybartai','lt','Marijampoles',6355.0,22.76,54.64).
city('Marijampole','lt','Marijampoles',47617.0,23.34,54.56).
city('Sakiai','lt','Marijampoles',6614.0,23.05,54.96).
city('Vilkaviskis','lt','Marijampoles',13012.0,23.03,54.65).
city('Virbalis','lt','Marijampoles',1281.0,22.82,54.63).
city('Birzai','lt','Panevezio',14912.0,24.75,56.2).
city('Joniskelis','lt','Panevezio',1430.0,24.17,56.02).
city('Juodupe','lt','Panevezio',1989.0,25.61,56.09).
city('Kupiskis','lt','Panevezio',8264.0,24.97,55.84).
city('Naujamiestis','lt','Panevezio',770.0,24.16,55.69).
city('Obeliai','lt','Panevezio',1247.0,25.14,55.97).
city('Pabirze','lt','Panevezio',490.0,24.64,56.18).
city('Pandelys','lt','Panevezio',974.0,25.24,56.02).
city('Panevezys','lt','Panevezio',117400.0,24.37,55.74).
city('Pasvalys','lt','Panevezio',8511.0,24.39,56.07).
city('Ramygala','lt','Panevezio',1637.0,24.3,55.51).
city('Rokiskis','lt','Panevezio',16257.0,25.59,55.96).
city('Subacius','lt','Panevezio',1116.0,24.81,55.77).
city('Vabalninkas','lt','Panevezio',1177.0,24.74,55.99).
city('Akmene','lt','Siauliu',3026.0,22.73,56.25).
city('Joniskis','lt','Siauliu',11114.0,23.61,56.24).
city('Kelme','lt','Siauliu',10627.0,22.93,55.63).
city('Kursenai','lt','Siauliu',13915.0,22.94,55.99).
city('Linkuva','lt','Siauliu',1720.0,23.96,56.09).
city('Naujoji Akmene','lt','Siauliu',11923.0,22.88,56.33).
city('Pakruojis','lt','Si',5964.0,23.87,55.99).
city('Radviliskis','lt','Siauliu',19916.0,23.54,55.81).
city('Seduva','lt','Siauliu',3321.0,23.76,55.75).
city('Siauliai','lt','Siauliu',130594.0,23.32,55.93).
city('Tyruliai','lt','Siauliu',373.0,23.24,55.75).
city('Tytuvenai','lt','Siauliu',2770.0,23.28,55.61).
city('Uzventis','lt','Siauliu',827.0,22.66,55.79).
city('Venta','lt','Siauliu',3270.0,22.71,56.19).
city('Vieksniai','lt','Siauliu',2212.0,22.51,56.23).
city('Zagare','lt','Siauliu',2201.0,23.24,56.35).
city('Jurbarkas','lt','Taurages',13103.0,22.76,55.09).
city('Silale','lt','Taurages',6026.0,22.2,55.47).
city('Skaudvile','lt','Taurages',1976.0,22.58,55.41).
city('Smalininkai','lt','Taurages',599.0,22.57,55.08).
city('Taurage','lt','Taurages',27665.0,22.28,55.25).
city('Mazeikiai','lt','Telsiu',41314.0,22.34,56.33).
city('Plunge','lt','Telsiu',23383.0,21.85,55.91).
city('Rietavas','lt','Telsiu',3737.0,21.92,55.73).
city('Seda','lt','Telsiu',1224.0,22.08,56.18).
city('Telsiai','lt','Telsiu',30101.0,22.23,55.99).
city('Varniai','lt','Telsiu',1227.0,22.37,55.75).
city('Anyksciai','lt','Utenos',11570.0,25.1,55.53).
city('Dukstas','lt','Utenos',1021.0,26.33,55.54).
city('Dusetos','lt','Utenos',833.0,25.83,55.73).
city('Ignalina','lt','Utenos',6422.0,26.16,55.34).
city('Kavarskas','lt','Utenos',755.0,24.94,55.44).
city('Moletai','lt','Utenos',7243.0,25.41,55.24).
city('Troskunai','lt','Utenos',480.0,24.87,55.59).
city('Turmantas','lt','Utenos',282.0,26.46,55.0).
city('Utena','lt','Utenos',33243.0,25.6,55.5).
city('Visaginas','lt','Utenos',28350.0,26.44,55.61).
city('Zarasai','lt','Utenos',8096.0,26.25,55.73).
city('Baltoji Voke','lt','Vilniaus',1071.0,25.2,54.6).
city('Eisiskes','lt','Vilniaus',3810.0,24.99,54.17).
city('Elektrenai','lt','Vilniaus',13722.0,24.63,54.77).
city('Grigiskes','lt','Vilniaus',11556.0,25.08,54.69).
city('Lentvaris','lt','Vilniaus',11589.0,25.05,54.65).
city('Nemencine','lt','Vilniaus',6063.0,25.48,54.85).
city('Pabrade','lt','Vilniaus',6376.0,25.76,54.99).
city('Rudiskes','lt','Vilniaus',2616.0,24.83,54.53).
city('Salcininkai','lt','Vilniaus',6892.0,25.37,54.31).
city('Sirvintos','lt','Vilniaus',7322.0,24.97,55.04).
city('Svencioneliai','lt','Vilniaus',6791.0,26.0,55.16).
city('Svencionys','lt','Vilniaus',5539.0,26.16,55.16).
city('Trakai','lt','Vilniaus',5531.0,24.93,54.64).
city('Ukmerge','lt','Vilniaus',28662.0,24.76,55.26).
city('Vievis','lt','Vilniaus',5269.0,24.81,54.77).
city('Vilnius','lt','Vilniaus',542381.0,25.2,54.7).
city('Bascharage','lu','Capellen',4645.0,5.91,49.57).
city('Bettange-sur-Mess','lu','Capellen',992.0,5.98,49.57).
city('Bridel','lu','Capellen',2404.0,6.08,49.65).
city('Capellen','lu','Capellen',1330.0,5.99,49.65).
city('Clemency','lu','Capellen',1821.0,5.87,49.59).
city('Dahlem','lu','Capellen',389.0,5.94,49.6).
city('Dippach','lu','Capellen',808.0,5.98,49.58).
city('Dondelange','lu','Capellen',146.0,6.02,49.69).
city('Eischen','lu','Capellen',1559.0,5.87,49.68).
city('Fingig','lu','Capellen',329.0,5.9,49.6).
city('Garnich','lu','Capellen',824.0,5.95,49.61).
city('Goeblange','lu','Capellen',434.0,5.96,49.66).
city('Goetzingen','lu','Capellen',341.0,5.98,49.66).
city('Grass','lu','Capellen',71.0,5.89,49.63).
city('Greisch','lu','Capellen',210.0,5.98,49.7).
city('Hagen','lu','Capellen',978.0,5.93,49.64).
city('Hautcharage','lu','Capellen',1495.0,5.91,49.58).
city('Hivange','lu','Capellen',119.0,5.93,49.6).
city('Hobscheid','lu','Capellen',1051.0,5.91,49.68).
city('Holzem','lu','Capellen',541.0,5.99,49.61).
city('Kahler','lu','Capellen',192.0,5.91,49.63).
city('Kehlen','lu','Capellen',1658.0,6.03,49.66).
city('Keispelt','lu','Capellen',567.0,6.06,49.69).
city('Kleinbettingen','lu','Capellen',872.0,5.91,49.64).
city('Koerich','lu','Capellen',1066.0,5.95,49.67).
city('Kopstal','lu','Capellen',657.0,6.07,49.66).
city('Linger','lu','Capellen',591.0,5.88,49.56).
city('Mamer','lu','Capellen',5017.0,6.02,49.63).
city('Meispelt','lu','Capellen',290.0,6.05,49.69).
city('Nospelt','lu','Capellen',766.0,6.0,49.67).
city('Olm','lu','Capellen',1459.0,6.0,49.65).
city('Roodt','lu','Capellen',215.0,6.0,49.69).
city('Schouweiler','lu','Capellen',1090.0,5.95,49.58).
city('Septfontaines','lu','Capellen',363.0,5.96,49.7).
city('Sprinkange','lu','Capellen',357.0,5.96,49.58).
city('Steinfort','lu','Capellen',2225.0,5.91,49.66).
city('Allerborn','lu','Clervaux',59.0,5.87,50.03).
city('Asselborn','lu','Clervaux',413.0,5.97,50.09).
city('Basbellain','lu','Clervaux',164.0,5.98,50.14).
city('Beiler','lu','Clervaux',87.0,6.08,50.16).
city('Binsfeld','lu','Clervaux',235.0,6.03,50.11).
city('Biwisch','lu','Clervaux',103.0,5.97,50.11).
city('Bockholtz','lu','Clervaux',47.0,6.05,50.01).
city('Boevange','lu','Clervaux',125.0,5.93,50.04).
city('Boxhorn','lu','Clervaux',259.0,5.99,50.08).
city('Brachtenbach','lu','Clervaux',159.0,5.91,50.02).
city('Breidfeld','lu','Clervaux',49.0,6.06,50.12).
city('Cinqfontaines','lu','Clervaux',13.0,6.0,50.1).
city('Clervaux','lu','Clervaux',1103.0,6.03,50.05).
city('Consthum','lu','Clervaux',207.0,6.05,49.97).
city('Crendal','lu','Clervaux',10.0,5.89,50.05).
city('Deiffelt-Lentzweiler','lu','Clervaux',138.0,5.96,50.06).
city('Derenbach','lu','Clervaux',287.0,5.88,50.01).
city('Doennange','lu','Clervaux',146.0,5.95,50.06).
city('Dorscheid','lu','Clervaux',90.0,6.07,50.03).
city('Drauffelt','lu','Clervaux',143.0,6.0,50.01).
city('Drinklange','lu','Clervaux',124.0,6.01,50.13).
city('Eisenbach','lu','Clervaux',231.0,6.14,50.01).
city('Eselborn','lu','Clervaux',337.0,6.0,50.06).
city('Fischbach','lu','Clervaux',114.0,6.06,50.07).
city('Goedange','lu','Clervaux',45.0,6.01,50.14).
city('Grindhausen','lu','Clervaux',25.0,6.06,50.08).
city('Hachiville','lu','Clervaux',194.0,5.92,50.1).
city('Hamiville','lu','Clervaux',171.0,5.9,50.04).
city('Hautbellain','lu','Clervaux',151.0,5.97,50.15).
city('Heinerscheid','lu','Clervaux',429.0,6.08,50.09).
city('Hoffelt','lu','Clervaux',270.0,5.92,50.09).
city('Holler','lu','Clervaux',87.0,6.04,50.12).
city('Holzthum','lu','Clervaux',143.0,6.07,49.98).
city('Hosingen','lu','Clervaux',811.0,6.09,50.01).
city('Huldange','lu','Clervaux',376.0,6.01,50.16).
city('Hupperdange','lu','Clervaux',210.0,6.05,50.09).
city('Kalborn','lu','Clervaux',58.0,6.11,50.1).
city('Leithum','lu','Clervaux',78.0,6.1,50.16).
city('Lieler','lu','Clervaux',179.0,6.11,50.12).
city('Lullange','lu','Clervaux',132.0,5.94,50.06).
city('Marnach','lu','Clervaux',454.0,6.06,50.05).
city('Maulusmuehle','lu','Clervaux',11.0,6.02,50.09).
city('Munshausen','lu','Clervaux',147.0,6.03,50.03).
city('Neidhausen','lu','Clervaux',53.0,6.06,50.02).
city('Niederwampach-Schimpach','lu','Clervaux',206.0,5.84,50.01).
city('Oberwampach','lu','Clervaux',183.0,5.86,50.01).
city('Reuler','lu','Clervaux',193.0,6.04,50.06).
city('Roder','lu','Clervaux',66.0,6.08,50.05).
city('Rodershausen','lu','Clervaux',96.0,6.13,50.03).
city('Rumlange-Lentzweiler','lu','Clervaux',123.0,5.97,50.08).
city('Sassel','lu','Clervaux',45.0,5.99,50.09).
city('Siebenaler','lu','Clervaux',58.0,6.02,50.01).
city('Stockem','lu','Clervaux',119.0,5.95,50.07).
city('Troine-Hinterhasselt','lu','Clervaux',225.0,5.88,50.06).
city('Troine-Route','lu','Clervaux',67.0,6.0,50.09).
city('Troisvierges','lu','Clervaux',1457.0,6.01,50.12).
city('Urspelt','lu','Clervaux',54.0,6.04,50.07).
city('Wahlhausen','lu','Clervaux',246.0,6.12,49.98).
city('Weicherdange','lu','Clervaux',220.0,5.98,50.03).
city('Weiler','lu','Clervaux',44.0,5.94,50.1).
city('Weiswampach','lu','Clervaux',691.0,6.07,50.13).
city('Wilwerdange','lu','Clervaux',268.0,6.02,50.14).
city('Wincrange','lu','Clervaux',210.0,5.91,50.05).
city('Bastendorf','lu','Diekirch',377.0,6.16,49.89).
city('Bettendorf','lu','Diekirch',1072.0,6.21,49.87).
city('Bigelbach','lu','Diekirch',79.0,6.28,49.86).
city('Bourscheid','lu','Diekirch',275.0,6.06,49.91).
city('Brandenbourg','lu','Diekirch',193.0,6.14,49.91).
city('Buerden','lu','Diekirch',450.0,6.09,49.88).
city('Diekirch','lu','Diekirch',6243.0,6.16,49.87).
city('Eppeldorf','lu','Diekirch',181.0,6.24,49.84).
city('Ermsdorf','lu','Diekirch',228.0,6.22,49.82).
city('Erpeldange','lu','Diekirch',845.0,6.11,49.86).
city('Ettelbruck','lu','Diekirch',6364.0,6.11,49.85).
city('Folkendange','lu','Diekirch',21.0,6.2,49.84).
city('Gilsdorf','lu','Diekirch',887.0,6.18,49.86).
city('Hoesdorf','lu','Diekirch',105.0,6.25,49.88).
city('Hoscheid','lu','Diekirch',319.0,6.08,49.94).
city('Hoscheid-Dickt','lu','Diekirch',110.0,6.09,49.97).
city('Ingeldorf','lu','Diekirch',833.0,6.13,49.85).
city('Kehmen-Scheidel','lu','Diekirch',105.0,6.03,49.9).
city('Landscheid','lu','Diekirch',76.0,6.13,49.92).
city('Lipperscheid','lu','Diekirch',186.0,6.08,49.91).
city('Medernach','lu','Diekirch',907.0,6.21,49.8).
city('Mertzig','lu','Diekirch',1482.0,6.0,49.83).
city('Michelau','lu','Diekirch',281.0,6.09,49.9).
city('Moestroff','lu','Diekirch',418.0,6.23,49.86).
city('Niederfeulen','lu','Diekirch',1125.0,6.04,49.85).
city('Oberfeulen','lu','Diekirch',283.0,6.03,49.84).
city('Reisdorf','lu','Diekirch',493.0,6.26,49.86).
city('Savelborn-Fermes','lu','Diekirch',87.0,6.25,49.8).
city('Schieren','lu','Diekirch',1397.0,6.09,49.83).
city('Schlindermanderscheid','lu','Diekirch',170.0,6.06,49.93).
city('Stegen','lu','Diekirch',406.0,6.17,49.83).
city('Tandel','lu','Diekirch',89.0,6.18,49.89).
city('Wallendorf','lu','Diekirch',85.0,6.27,49.88).
city('Warken','lu','Diekirch',1188.0,6.09,49.85).
city('Welscheid','lu','Diekirch',149.0,6.06,49.88).
city('Altrier','lu','Echternach',190.0,6.32,49.74).
city('Beaufort','lu','Echternach',1418.0,6.29,49.83).
city('Bech','lu','Echternach',380.0,6.36,49.74).
city('Berdorf','lu','Echternach',900.0,6.35,49.81).
city('Bollendorf-Pont','lu','Echternach',172.0,6.36,49.85).
city('Born','lu','Echternach',336.0,6.51,49.75).
city('Boursdorf','lu','Echternach',22.0,6.47,49.75).
city('Breidweiler','lu','Echternach',99.0,6.3,49.77).
city('Christnach','lu','Echternach',394.0,6.27,49.78).
city('Consdorf','lu','Echternach',1241.0,6.33,49.77).
city('Dickweiler','lu','Echternach',111.0,6.47,49.77).
city('Dillingen','lu','Echternach',159.0,6.31,49.85).
city('Echternach','lu','Echternach',4787.0,6.41,49.81).
city('Girst','lu','Echternach',113.0,6.49,49.76).
city('Girsterklaus','lu','Echternach',12.0,6.49,49.77).
city('Givenich','lu','Echternach',84.0,6.48,49.74).
city('Grundhof','lu','Echternach',27.0,6.33,49.83).
city('Haller','lu','Echternach',223.0,6.28,49.81).
city('Hemstal','lu','Echternach',79.0,6.33,49.73).
city('Herborn','lu','Echternach',150.0,6.42,49.74).
city('Hinkel','lu','Echternach',82.0,6.51,49.77).
city('Moersdorf','lu','Echternach',301.0,6.5,49.73).
city('Mompach','lu','Echternach',100.0,6.46,49.74).
city('Muellerthal','lu','Echternach',152.0,6.31,49.78).
city('Osweiler','lu','Echternach',381.0,6.44,49.77).
city('Rippig','lu','Echternach',113.0,6.31,49.73).
city('Rosport','lu','Echternach',681.0,6.5,49.79).
city('Scheidgen','lu','Echternach',461.0,6.36,49.77).
city('Steinheim','lu','Echternach',550.0,6.47,49.81).
city('Waldbillig','lu','Echternach',408.0,6.28,49.78).
city('Weilerbach','lu','Echternach',274.0,6.38,49.83).
city('Zittig','lu','Echternach',38.0,6.34,49.73).
city('Abweiler','lu','Esch-sur-Alzette',75.0,6.08,49.53).
city('Aspelt','lu','Esch-sur-Alzette',1013.0,6.22,49.52).
city('Belvaux','lu','Esch-sur-Alzette',5313.0,5.93,49.51).
city('Berchem','lu','Esch-sur-Alzette',863.0,6.12,49.54).
city('Bergem','lu','Esch-sur-Alzette',1535.0,6.04,49.52).
city('Bettembourg','lu','Esch-sur-Alzette',7437.0,6.1,49.52).
city('Bivange','lu','Esch-sur-Alzette',617.0,6.13,49.54).
city('Crauthem','lu','Esch-sur-Alzette',1278.0,6.14,49.53).
city('Differdange','lu','Esch-sur-Alzette',5295.0,5.89,49.53).
city('Dudelange','lu','Esch-sur-Alzette',18013.0,6.08,49.48).
city('Ehlange','lu','Esch-sur-Alzette',429.0,6.01,49.54).
city('Ehlerange','lu','Esch-sur-Alzette',756.0,5.96,49.52).
city('Esch-Alzette','lu','Esch-sur-Alzette',28228.0,5.98,49.5).
city('Fennange','lu','Esch-sur-Alzette',293.0,6.07,49.51).
city('Foetz','lu','Esch-sur-Alzette',483.0,6.01,49.52).
city('Fousbann','lu','Esch-sur-Alzette',5371.0,5.92,49.52).
city('Frisange','lu','Esch-sur-Alzette',1355.0,6.19,49.51).
city('Hellange','lu','Esch-sur-Alzette',629.0,6.15,49.5).
city('Huncherange','lu','Esch-sur-Alzette',615.0,6.06,49.51).
city('Kayl','lu','Esch-sur-Alzette',4396.0,6.03,49.49).
city('Kockelscheuer','lu','Esch-sur-Alzette',270.0,6.11,49.56).
city('Lamadelaine','lu','Esch-sur-Alzette',2428.0,5.85,49.54).
city('Lasauvage','lu','Esch-sur-Alzette',402.0,5.83,49.52).
city('Leudelange','lu','Esch-sur-Alzette',1924.0,6.06,49.56).
city('Limpach','lu','Esch-sur-Alzette',254.0,5.98,49.55).
city('Livange','lu','Esch-sur-Alzette',306.0,6.12,49.53).
city('Mondercange','lu','Esch-sur-Alzette',3306.0,5.98,49.53).
city('Niedercorn','lu','Esch-sur-Alzette',3164.0,5.89,49.54).
city('Noertzange','lu','Esch-sur-Alzette',999.0,6.05,49.5).
city('Obercorn','lu','Esch-sur-Alzette',4666.0,5.9,49.51).
city('Peppange','lu','Esch-sur-Alzette',593.0,6.12,49.52).
city('Petange','lu','Esch-sur-Alzette',7187.0,5.86,49.56).
city('Pissange','lu','Esch-sur-Alzette',66.0,6.0,49.54).
city('Pontpierre','lu','Esch-sur-Alzette',1009.0,6.02,49.53).
city('Reckange-sur-Mess','lu','Esch-sur-Alzette',571.0,6.0,49.56).
city('Rodange','lu','Esch-sur-Alzette',4683.0,5.84,49.54).
city('Roedgen','lu','Esch-sur-Alzette',337.0,6.03,49.57).
city('Roeser','lu','Esch-sur-Alzette',708.0,6.15,49.54).
city('Rumelange','lu','Esch-sur-Alzette',4474.0,5.89,49.51).
city('Sanem','lu','Esch-sur-Alzette',2489.0,5.92,49.55).
city('Schifflange','lu','Esch-sur-Alzette',8155.0,6.01,49.51).
city('Soleuvre','lu','Esch-sur-Alzette',4988.0,5.95,49.53).
city('Tetange','lu','Esch-sur-Alzette',2929.0,6.04,49.47).
city('Wickrange','lu','Esch-sur-Alzette',111.0,6.02,49.54).
city('Ahn-Dreiborn','lu','Grevenmacher',253.0,6.42,49.62).
city('Altlinster','lu','Grevenmacher',115.0,6.21,49.71).
city('Beidweiler','lu','Grevenmacher',227.0,6.3,49.72).
city('Berbourg','lu','Grevenmacher',664.0,6.39,49.72).
city('Berg','lu','Grevenmacher',93.0,6.35,49.67).
city('Betzdorf','lu','Grevenmacher',248.0,6.35,49.68).
city('Beyren','lu','Grevenmacher',312.0,6.33,49.62).
city('Biwer','lu','Grevenmacher',653.0,6.37,49.7).
city('Biwerbach','lu','Grevenmacher',16.0,6.33,49.69).
city('Boudler','lu','Grevenmacher',69.0,6.36,49.72).
city('Boudlerbach','lu','Grevenmacher',35.0,6.35,49.71).
city('Bourglinster','lu','Grevenmacher',680.0,6.21,49.69).
city('Breinert','lu','Grevenmacher',50.0,6.34,49.7).
city('Brouch','lu','Grevenmacher',52.0,6.34,49.72).
city('Ehnen','lu','Grevenmacher',531.0,6.38,49.59).
city('Eisenborn','lu','Grevenmacher',170.0,6.18,49.68).
city('Eschweiler','lu','Grevenmacher',118.0,6.31,49.71).
city('Flaxweiler','lu','Grevenmacher',358.0,6.34,49.66).
city('Godbrange','lu','Grevenmacher',463.0,6.23,49.72).
city('Gonderange','lu','Grevenmacher',1469.0,6.24,49.68).
city('Gostingen','lu','Grevenmacher',342.0,6.35,49.61).
city('Graulinster-Blumenthal','lu','Grevenmacher',101.0,6.28,49.73).
city('Grevenmacher','lu','Grevenmacher',3958.0,6.44,49.67).
city('Hagelsdorf','lu','Grevenmacher',19.0,6.36,49.68).
city('Imbringen','lu','Grevenmach',292.0,6.19,49.69).
city('Junglinster','lu','Grevenmacher',2358.0,6.25,49.7).
city('Lellig','lu','Grevenmacher',142.0,6.43,49.71).
city('Machtum','lu','Grevenmacher',304.0,6.43,49.65).
city('Manternach','lu','Grevenmacher',443.0,6.42,49.7).
city('Mensdorf','lu','Grevenmacher',813.0,6.3,49.65).
city('Mertert','lu','Grevenmacher',1163.0,6.47,49.7).
city('Muenschecker','lu','Grevenmacher',152.0,6.44,49.69).
city('Niederdonven','lu','Grevenmacher',324.0,6.4,49.63).
city('Oberdonven','lu','Grevenmacher',164.0,6.4,49.64).
city('Olingen','lu','Grevenmacher',403.0,6.31,49.67).
city('Rodenbourg','lu','Grevenmacher',109.0,6.28,49.68).
city('Roodt-sur-Syr','lu','Grevenmacher',960.0,6.3,49.66).
city('Wasserbillig','lu','Grevenmacher',2327.0,6.5,49.72).
city('Wecker','lu','Grevenmacher',667.0,6.38,49.69).
city('Weydig','lu','Grevenmacher',27.0,6.33,49.71).
city('Wormeldange','lu','Grevenmacher',786.0,6.4,49.6).
city('Wormeldange-Haut','lu','Grevenmacher',541.0,6.4,49.62).
city('Alzingen','lu','Luxembourg',1376.0,6.16,49.56).
city('Bereldange','lu','Luxembourg',3627.0,6.12,49.65).
city('Bertrange','lu','Luxembourg',5615.0,6.05,49.61).
city('Contern','lu','Luxembourg',1083.0,6.22,49.58).
city('Ernster','lu','Luxembourg',350.0,6.24,49.67).
city('Fentange','lu','Luxembourg',1302.0,6.15,49.56).
city('Findel','lu','Luxembourg',105.0,6.2,49.62).
city('Hassel','lu','Luxembourg',436.0,6.21,49.55).
city('Heisdorf','lu','Luxembourg',1586.0,6.14,49.66).
city('Helmsange','lu','Luxembourg',2193.0,6.14,49.65).
city('Hesperange','lu','Luxembourg',1937.0,6.15,49.57).
city('Hostert','lu','Luxembourg',364.0,6.24,49.65).
city('Howald','lu','Luxembourg',4140.0,6.14,49.57).
city('Itzig','lu','Luxembourg',1836.0,6.17,49.58).
city('Luxemburg','lu','Luxembourg',76684.0,6.12,49.62).
city('Medingen','lu','Luxembourg',102.0,6.24,49.57).
city('Moutfort','lu','Luxembourg',1171.0,6.25,49.58).
city('Muellendorf','lu','Luxembourg',1024.0,6.13,49.68).
city('Muensbach','lu','Luxembourg',585.0,6.27,49.63).
city('Neuhaeusgen','lu','Luxembourg',239.0,6.24,49.61).
city('Niederanven','lu','Luxembourg',1508.0,6.26,49.64).
city('Oberanven','lu','Luxembourg',682.0,6.25,49.65).
city('Oetrange','lu','Luxembourg',781.0,6.26,49.59).
city('Rameldange','lu','Luxembourg',682.0,6.23,49.65).
city('Sandweiler','lu','Luxembourg',2522.0,6.21,49.61).
city('Schrassig','lu','Luxembourg',1051.0,6.25,49.6).
city('Schuttrange','lu','Luxembourg',841.0,6.26,49.62).
city('Senningen','lu','Luxembourg',378.0,6.23,49.64).
city('Senningerberg','lu','Luxembourg',1564.0,6.2,49.64).
city('Steinsel','lu','Luxembourg',1879.0,6.12,49.67).
city('Strassen','lu','Luxembourg',6006.0,6.06,49.62).
city('Syren','lu','Luxembourg',423.0,6.22,49.56).
city('Uebersyren','lu','Luxembourg',616.0,6.27,49.62).
city('Waldhof','lu','Luxembourg',10.0,6.19,49.65).
city('Walferdange','lu','Luxembourg',740.0,6.13,49.65).
city('Weiler-la-Tour','lu','Luxembourg',484.0,6.2,49.54).
city('Angelsberg','lu','Mersch',292.0,6.16,49.75).
city('Ansembourg','lu','Mersch',42.0,6.04,49.7).
city('Beringen','lu','Mersch',956.0,6.12,49.76).
city('Bissen','lu','Mersch',2547.0,6.06,49.78).
city('Blaschette','lu','Mersch',465.0,6.17,49.69).
city('Boevange','lu','Mersch',576.0,6.01,49.77).
city('Bofferdange','lu','Mersch',802.0,6.14,49.68).
city('Bour','lu','Mersch',67.0,6.01,49.7).
city('Brouch','lu','Mersch',676.0,6.02,49.73).
city('Buschdorf','lu','Mersch',387.0,6.0,49.75).
city('Colmar-Berg','lu','Mersch',1776.0,6.1,49.81).
city('Cruchten','lu','Mersch',404.0,6.13,49.79).
city('Ernzen','lu','Mersch',398.0,6.22,49.76).
city('Essingen','lu','Mersch',18.0,6.11,49.77).
city('Fischbach','lu','Mersch',184.0,6.18,49.73).
city('Glabach','lu','Mersch',31.0,6.15,49.77).
city('Gosseldange','lu','Mersch',458.0,6.11,49.72).
city('Grevenknapp-Bill-Finsterthal','lu','Mersch',192.0,6.03,49.76).
city('Heffingen','lu','Mersch',623.0,6.24,49.76).
city('Helmdange','lu','Mersch',638.0,6.14,49.69).
city('Hollenfels','lu','Mersch',247.0,6.05,49.71).
city('Huensdorf','lu','Mersch',413.0,6.13,49.69).
city('Larochette','lu','Mersch',1410.0,6.22,49.77).
city('Lintgen','lu','Mersch',1752.0,6.13,49.71).
city('Lorentzweiler','lu','Mersch',772.0,6.15,49.69).
city('Marienthal','lu','Mersch',108.0,6.06,49.71).
city('Mersch','lu','Mersch',3464.0,6.11,49.75).
city('Moesdorf','lu','Mersch',353.0,6.11,49.76).
city('Nommern','lu','Mersch',272.0,6.17,49.78).
city('Pettingen','lu','Mersch',206.0,6.1,49.77).
city('Prettange','lu','Mersch',101.0,6.12,49.71).
city('Reckange','lu','Mersch',611.0,6.08,49.74).
city('Reuland','lu','Mersch',196.0,6.26,49.74).
city('Rollingen','lu','Mersch',1448.0,6.11,49.74).
city('Scherbach','lu','Mersch',21.0,6.22,49.78).
city('Scherfenhof','lu','Mersch',19.0,6.23,49.77).
city('Schiltzberg','lu','Mersch',17.0,6.23,49.73).
city('Schoenfels','lu','Mersch',216.0,6.09,49.71).
city('Schoos','lu','Mersch',164.0,6.17,49.74).
city('Schrondweiler','lu','Mersch',285.0,6.15,49.79).
city('Tuntange','lu','Mersch',605.0,6.01,49.71).
city('Arsdorf','lu','Redange',241.0,5.84,49.86).
city('Beckerich','lu','Redange',672.0,5.88,49.73).
city('Bettborn','lu','Redange',231.0,5.94,49.79).
city('Bigonville','lu','Redange',475.0,5.79,49.85).
city('Bilsdorf','lu','Redange',121.0,5.82,49.85).
city('Brattert-Rindschleiden','lu','Redange',25.0,5.9,49.85).
city('Buschrodt','lu','Redange',118.0,5.93,49.82).
city('Calmus','lu','Redange',76.0,5.96,49.72).
city('Colpach-Bas','lu','Redange',110.0,5.82,49.75).
city('Colpach-Haut','lu','Redange',152.0,5.82,49.76).
city('Dellen-Lehrhof-Grevels','lu','Redange',114.0,5.96,49.85).
city('Ehner','lu','Redange',13.0,5.95,49.71).
city('Ell','lu','Redange',359.0,5.85,49.76).
city('Eltz','lu','Redange',34.0,5.89,49.77).
city('Elvange','lu','Redange',96.0,5.91,49.72).
city('Eschette','lu','Redange',34.0,5.88,49.82).
city('Everlange','lu','Redange',370.0,5.95,49.77).
city('Folschette','lu','Redange',289.0,5.87,49.81).
city('Grevels','lu','Redange',207.0,5.91,49.85).
city('Grosbous','lu','Redange',656.0,5.96,49.82).
city('Haut-Martelange','lu','Redange',32.0,5.75,49.82).
city('Heispelt','lu','Redange',81.0,5.88,49.85).
city('Holtz','lu','Redange',196.0,5.79,49.8).
city('Hostert','lu','Redange',360.0,5.86,49.81).
city('Hovelange','lu','Redange',285.0,5.9,49.72).
city('Huttange','lu','Redange',37.0,5.89,49.73).
city('Kapweiler','lu','Redange',30.0,5.97,49.73).
city('Koetschette','lu','Redange',125.0,5.84,49.84).
city('Kuborn','lu','Redange',75.0,5.9,49.87).
city('Lannen','lu','Redange',113.0,5.83,49.78).
city('Levelange','lu','Redange',43.0,5.85,49.73).
city('Michelbouch','lu','Redange',116.0,6.02,49.81).
city('Nagem','lu','Redange',216.0,5.85,49.78).
city('Niederpallen','lu','Redange',374.0,5.91,49.75).
city('Noerdange','lu','Redange',466.0,5.92,49.74).
city('Oberpallen','lu','Redange',397.0,5.84,49.73).
city('Ospern','lu','Redange',276.0,5.9,49.78).
city('Perle','lu','Redange',649.0,5.76,49.81).
city('Petit-Nobressart','lu','Redange',89.0,5.8,49.77).
city('Platen','lu','Redange',541.0,5.93,49.79).
city('Pratz','lu','Redange',367.0,5.93,49.8).
city('Rambrouch','lu','Redange',401.0,5.84,49.83).
city('Redange','lu','Redange',1164.0,5.88,49.77).
city('Reichlange','lu','Redange',132.0,5.92,49.77).
city('Reimberg','lu','Redange',182.0,5.95,49.79).
city('Rippweiler','lu','Redange',153.0,5.95,49.75).
city('Rombach','lu','Redange',244.0,5.74,49.83).
city('Roodt','lu','Redange',159.0,5.82,49.79).
city('Saeul','lu','Redange',316.0,5.98,49.72).
city('Schandel','lu','Redange',194.0,5.97,49.79).
city('Schwebach','lu','Redange',55.0,5.97,49.74).
city('Schweich','lu','Redange',194.0,5.92,49.72).
city('Useldange','lu','Redange',657.0,5.98,49.76).
city('Vichten','lu','Redange',764.0,6.0,49.8).
city('Wahl','lu','Redange',235.0,5.9,49.83).
city('Wolwelange','lu','Redange',358.0,5.76,49.82).
city('Altwies','lu','Remich',617.0,6.25,49.51).
city('Assel','lu','Remich',174.0,6.31,49.55).
city('Bech-Kleinmacher','lu','Remich',593.0,6.35,49.53).
city('Bous','lu','Remich',560.0,6.32,49.55).
city('Burmerange','lu','Remich',191.0,6.32,49.48).
city('Canach','lu','Remich',955.0,6.32,49.6).
city('Dalheim','lu','Remich',1364.0,6.25,49.54).
city('Ellange','lu','Remich',299.0,6.29,49.52).
city('Elvange','lu','Remich',713.0,6.31,49.5).
city('Emerange','lu','Remich',99.0,6.29,49.48).
city('Erpeldange','lu','Remich',359.0,6.32,49.54).
city('Filsdorf','lu','Remich',371.0,6.24,49.53).
city('Greiveldange','lu','Remich',630.0,6.35,49.58).
city('Lenningen','lu','Remich',338.0,6.36,49.59).
city('Mondorf-les-Bains','lu','Remich',3113.0,6.28,49.5).
city('Remerschen','lu','Remich',704.0,6.35,49.48).
city('Remich','lu','Remich',3187.0,6.36,49.55).
city('Rolling','lu','Remich',117.0,6.31,49.54).
city('Schengen','lu','Remich',470.0,6.36,49.47).
city('Schwebsingen','lu','Remich',307.0,6.35,49.51).
city('Stadtbredimus','lu','Remich',749.0,6.36,49.56).
city('Trintange','lu','Remich',289.0,6.28,49.57).
city('Trintange-Ersange-Roedt','lu','Remich',231.0,6.27,49.57).
city('Waldbredimus','lu','Remich',416.0,6.28,49.55).
city('Welfrange','lu','Remich',154.0,6.28,49.53).
city('Wellenstein','lu','Remich',499.0,6.34,49.52).
city('Wintrange','lu','Remich',384.0,6.35,49.5).
city('Bettel','lu','Vianden',223.0,6.22,49.91).
city('Bivels','lu','Vianden',80.0,6.19,49.96).
city('Fouhren','lu','Vianden',380.0,6.19,49.91).
city('Gralingen','lu','Vianden',142.0,6.1,49.93).
city('Longsdorf','lu','Vianden',80.0,6.2,49.89).
city('Merscheid','lu','Vianden',103.0,6.1,49.95).
city('Nachtmanderscheid','lu','Vianden',70.0,6.12,49.94).
city('Putscheid','lu','Vianden',38.0,6.14,49.96).
city('Stolzembourg','lu','Vianden',183.0,6.16,49.96).
city('Vianden','lu','Vianden',1626.0,6.21,49.93).
city('Walsdorf','lu','Vianden',68.0,6.17,49.92).
city('Weiler','lu','Vianden',153.0,6.12,49.96).
city('Alscheid','lu','Wiltz',50.0,6.0,49.97).
city('Baschleiden','lu','Wiltz',185.0,5.82,49.89).
city('Bavigne','lu','Wiltz',132.0,5.84,49.92).
city('Berle','lu','Wiltz',110.0,5.85,49.95).
city('Bockholtz','lu','Wiltz',60.0,5.99,49.92).
city('Boulaide','lu','Wiltz',396.0,5.81,49.88).
city('Buederscheid','lu','Wiltz',126.0,5.94,49.93).
city('Dahl','lu','Wiltz',246.0,5.97,49.93).
city('Doncols','lu','Wiltz',232.0,5.83,49.97).
city('Enscherange','lu','Wiltz',174.0,5.99,49.0).
city('Erpeldange','lu','Wiltz',202.0,5.94,49.97).
city('Esch-sur-Sure','lu','Wiltz',333.0,5.93,49.91).
city('Eschdorf','lu','Wiltz',433.0,5.93,49.88).
city('Eschweiler','lu','Wiltz',205.0,5.94,49.99).
city('Goesdorf','lu','Wiltz',251.0,5.96,49.92).
city('Gruemelscheid','lu','Wiltz',64.0,5.87,49.98).
city('Harlange','lu','Wiltz',378.0,5.79,49.93).
city('Heiderscheid','lu','Wiltz',424.0,5.97,49.88).
city('Heiderscheid-Fond','lu','Wiltz',55.0,5.96,49.9).
city('Hierheck','lu','Wiltz',36.0,5.93,49.87).
city('Insenborn','lu','Wiltz',165.0,5.88,49.9).
city('Kaundorf','lu','Wiltz',192.0,5.9,49.92).
city('Kautenbach','lu','Wiltz',126.0,6.02,49.95).
city('Knaphoscheid','lu','Wiltz',180.0,5.96,50.01).
city('Lellingen','lu','Wiltz',93.0,6.01,49.98).
city('Liefrange','lu','Wiltz',85.0,5.87,49.91).
city('Lultzhausen','lu','Wiltz',32.0,5.89,49.9).
city('Masseler','lu','Wiltz',36.0,6.03,49.93).
city('Mecher','lu','Wiltz',63.0,5.87,49.92).
city('Merckholtz','lu','Wiltz',94.0,5.98,49.96).
city('Merscheid','lu','Wiltz',143.0,5.97,49.87).
city('Neunhausen','lu','Wiltz',65.0,5.88,49.87).
city('Nocher','lu','Wiltz',233.0,5.97,49.94).
city('Nocher-Route','lu','Wiltz',129.0,6.02,49.94).
city('Noertrange','lu','Wiltz',274.0,5.91,49.97).
city('Nothum','lu','Wiltz',161.0,5.88,49.94).
city('Pintsch','lu','Wiltz',126.0,6.01,49.99).
city('Pommerloch','lu','Wiltz',51.0,5.86,49.96).
city('Schleif','lu','Wiltz',8.0,5.8,49.99).
city('Selscheid','lu','Wiltz',59.0,5.94,50.01).
city('Sonlez','lu','Wiltz',41.0,5.82,49.96).
city('Surre','lu','Wiltz',190.0,5.78,49.9).
city('Tadler-Ringel-Dirbach','lu','Wiltz',133.0,5.99,49.91).
city('Tarchamps','lu','Wiltz',294.0,5.79,49.95).
city('Watrange','lu','Wiltz',92.0,5.78,49.94).
city('Wiltz','lu','Wiltz',4816.0,5.93,49.97).
city('Wilwerwiltz','lu','Wiltz',249.0,5.99,49.98).
city('Winseler','lu','Wiltz',126.0,5.89,49.96).
city('Berovo','mk','Berovo',13847.0,22.86,41.72).
city('Pehcevo','mk','Berovo',5466.0,22.88,41.26).
city('Bac','mk','Bitola',692.0,21.56,40.95).
city('Bistrica','mk','Bitola',4798.0,21.37,40.98).
city('Bitola','mk','Bitola',86528.0,21.34,41.04).
city('Capari','mk','Bitola',1311.0,21.16,41.05).
city('Dobrusevo','mk','Bitola',2103.0,21.48,41.15).
city('Kukurecani','mk','Bitola',2395.0,21.3,41.09).
city('Mogila','mk','Bitola',4392.0,21.39,41.11).
city('Novaci','mk','Bitola',2357.0,21.45,41.04).
city('Staravina','mk','Bitola',285.0,21.71,41.08).
city('Brod','mk','Brod',5607.0,21.23,41.52).
city('Plasnica','mk','Brod',4574.0,21.13,41.47).
city('Samokov','mk','Brod',1429.0,21.14,41.69).
city('Debar','mk','Debar',18075.0,20.53,41.52).
city('Zupa','mk','Debar',6333.0,20.58,41.48).
city('Delcevo','mk','Delcevo',17415.0,22.76,41.97).
city('Kamenica','mk','Delcevo',8114.0,22.58,42.01).
city('Demir Hisar','mk','Demir Hisar',7011.0,21.18,41.2).
city('Sopotnica','mk','Demir Hisar',2110.0,21.15,41.3).
city('Bogdanci','mk','Gevgelija',8635.0,22.56,41.23).
city('Gevgelija','mk','Gevgelija',20664.0,22.51,41.15).
city('Miravci','mk','Gevgelija',2573.0,22.43,41.31).
city('Star Dojran','mk','Gevgelija',3348.0,22.73,41.18).
city('Cegrane','mk','Gostivar',12523.0,20.96,41.84).
city('Dolna Banjica','mk','Gostivar',10147.0,20.9,41.8).
city('Gostivar','mk','Gostivar',50974.0,20.92,41.8).
city('Mavrovi Anovi','mk','Gostivar',914.0,20.73,41.7).
city('Negotino-Polosko','mk','Gostivar',17518.0,20.88,41.89).
city('Rostusa','mk','Gostivar',9147.0,20.59,41.61).
city('Srbinovo','mk','Gostivar',3629.0,20.95,41.72).
city('Vrapciste','mk','Gostivar',8652.0,20.86,41.83).
city('Vrutok','mk','Gostivar',6207.0,21.83,41.78).
city('Kavadarci','mk','Kavadarci',38800.0,22.01,41.44).
city('Konopiste','mk','Kavadarci',327.0,22.08,41.25).
city('Rosoman','mk','Kavadarci',4106.0,21.95,41.52).
city('Drugovo','mk','Kicevo',3149.0,20.91,41.48).
city('Kicevo','mk','Kicevo',31124.0,20.97,41.51).
city('Oslomej','mk','Kicevo',10919.0,20.98,41.55).
city('Vranestica','mk','Kicevo',1265.0,21.02,41.46).
city('Zajas','mk','Kicevo',12219.0,20.94,41.59).
city('Cesinovo','mk','Kocani',2377.0,22.29,41.88).
city('Kocani','mk','Kocani',34259.0,22.4,41.93).
city('Oblesevo','mk','Kocani',4972.0,22.33,41.9).
city('Zletovo','mk','Kocani',3340.0,22.24,41.99).
city('Kratovo','mk','Kratovo',10288.0,22.16,42.08).
city('Kriva Palanka','mk','Kriva Palanka',20820.0,22.33,42.22).
city('Rankovce','mk','Kriva Palanka',4071.0,22.12,42.19).
city('Krusevo','mk','Krusevo',9630.0,21.26,41.14).
city('Zitose','mk','Krusevo',2131.0,21.29,41.42).
city('Izvor','mk','Kumanovo',1014.0,21.57,42.19).
city('Klecevce','mk','Kumanovo',1505.0,21.86,42.14).
city('Kumanovo','mk','Kumanovo',108471.0,21.71,42.14).
city('Lipkovo','mk','Kumanovo',28103.0,21.57,42.16).
city('Orasac','mk','Kumanovo',1180.0,21.81,42.05).
city('Staro Nagoricane','mk','Kumanovo',4112.0,21.83,42.2).
city('Demir Kapija','mk','Negotino',4451.0,22.26,41.43).
city('Negotino','mk','Negotino',19516.0,22.1,41.5).
city('Belcista','mk','Ohrid',2804.0,20.82,41.3).
city('Kosel','mk','Ohrid',1281.0,20.83,41.16).
city('Meseista','mk','Ohrid',2452.0,20.76,41.23).
city('Ohrid','mk','Ohrid',54908.0,20.82,41.12).
city('Dolneni','mk','Prilep',11534.0,21.45,41.45).
city('Krivogastani','mk','Prilep',5899.0,21.34,41.35).
city('Prilep','mk','Prilep',73815.0,21.56,41.36).
city('Topolcani','mk','Prilep',2773.0,21.42,41.24).
city('Vitoliste','mk','Prilep',456.0,21.83,41.19).
city('Probistip','mk','Probistip',12702.0,22.15,42.01).
city('Konce','mk','Radovis',3475.0,22.41,41.49).
city('Podares','mk','Radovis',3774.0,22.53,41.63).
city('Radovis','mk','Radovis',24983.0,22.47,41.65).
city('Resen','mk','Resen',16539.0,21.01,41.09).
city('Aracinovo','mk','Skopje',12800.0,21.57,42.04).
city('Cucer','mk','Skopje',8646.0,21.38,42.11).
city('Ilinden','mk','Skopje',16406.0,21.58,41.99).
city('Kondovo','mk','Skopje',11656.0,12.33,42.03).
city('Petrovec','mk','Skopje',8298.0,21.6,41.94).
city('Saraj','mk','Skopje',25379.0,21.34,42.01).
city('Skopje','mk','Skopje',474887.0,21.47,42.0).
city('Sopiste','mk','Skopje',9460.0,21.41,41.96).
city('Studenicani','mk','Skopje',18219.0,21.52,41.93).
city('Zelenikovo','mk','Skopje',4020.0,21.58,41.9).
city('Karbinci','mk','Stip',3900.0,22.24,41.81).
city('Stip','mk','Stip',48279.0,22.2,41.75).
city('Delogozdi','mk','Struga',8413.0,20.73,41.25).
city('Labunista','mk','Struga',8805.0,20.58,41.29).
city('Lukovo','mk','Struga',1424.0,20.58,41.35).
city('Struga','mk','Struga',37388.0,20.68,41.18).
city('Velesta','mk','Struga',8646.0,20.66,41.25).
city('Vevcani','mk','Struga',2429.0,20.57,41.24).
city('Bosilovo','mk','Strumica',12447.0,22.75,41.43).
city('Kuklis','mk','Strumica',4368.0,22.67,41.4).
city('Murtino','mk','Strumica',6658.0,22.76,41.4).
city('Novo Selo','mk','Strumica',11818.0,22.87,41.42).
city('Strumica','mk','Strumica',45509.0,22.66,41.43).
city('Vasilevo','mk','Strumica',12382.0,22.65,41.49).
city('Lozovo','mk','Sveti Nikole',2836.0,21.9,41.8).
city('Sveti Nikole','mk','Sveti Nikole',18475.0,21.94,41.91).
city('Bogovinje','mk','Tetovo',15166.0,20.92,41.95).
city('Brvenica','mk','Tetovo',16267.0,20.98,41.98).
city('Dzepciste','mk','Tetovo',8166.0,21.0,42.04).
city('Jegunovce','mk','Tetovo',7313.0,21.12,42.07).
city('Kamenjane','mk','Tetovo',15376.0,20.94,41.96).
city('Sipkovica','mk','Tetovo',8228.0,20.89,42.05).
city('Tearce','mk','Tetovo',23096.0,21.05,42.07).
city('Tetovo','mk','Tetovo',72945.0,20.97,42.01).
city('Vratnica','mk','Tetovo',3678.0,21.11,42.13).
city('Zelino','mk','Tetovo',25422.0,21.07,41.99).
city('Valandovo','mk','Valandovo',11825.0,22.55,41.35).
city('Bogomila','mk','Veles',1223.0,21.46,41.58).
city('Caska','mk','Veles',2878.0,21.67,41.64).
city('Gradsko','mk','Veles',3737.0,21.94,41.56).
city('Veles','mk','Veles',57873.0,21.78,41.73).
city('Blatec','mk','Vinica',2031.0,22.6,41.78).
city('Orizari','mk','Vinica',4292.0,22.45,41.94).
city('Vinica','mk','Vinica',18218.0,22.5,41.9).
city('Zrnovci','mk','Vinica',3236.0,22.45,41.85).
city('Ambatolampy','mg','Antananarivo',28461.0,47.43,-19.38).
city('Anjozorobe','mg','Antananarivo',19027.0,47.87,-18.4).
city('Ankazobe','mg','Antananarivo',15722.0,47.11,-18.31).
city('Antananarivo','mg','Antananarivo',1391506.0,47.51,-18.89).
city('Antanifotsy','mg','Antananarivo',70625.0,47.32,-19.67).
city('Antsirabe','mg','Antananarivo',182804.0,47.03,-19.87).
city('Arivonimamo','mg','Antananarivo',21982.0,47.18,-19.01).
city('Betafo','mg','Antananarivo',29785.0,46.85,-19.83).
city('Faratsiho','mg','Antananarivo',37563.0,46.94,-19.41).
city('Fenoarivo','mg','Antananarivo',19605.0,46.56,-18.45).
city('Manjakandriana','mg','Antananarivo',31840.0,47.81,-18.92).
city('Soavinandriana','mg','Antananarivo',40453.0,46.73,-19.17).
city('Tsiroanomandidy','mg','Antananarivo',27060.0,46.04,-18.77).
city('Ambanja','mg','Antsiranana',30621.0,48.45,-13.68).
city('Ambilobe','mg','Antsiranana',14635.0,49.05,-13.19).
city('Andapa','mg','Antsiranana',20798.0,49.65,-14.66).
city('Antalaha','mg','Antsiranana',34112.0,50.27,-14.9).
city('Antsirambazaha','mg','Antsiranana',22680.0,48.27,-13.4).
city('Antsiranana','mg','Antsiranana',82944.0,49.28,-12.28).
city('Sambava','mg','Antsiranana',31522.0,50.15,-14.25).
city('Ambalavao','mg','Fianarantsoa',28027.0,46.93,-21.83).
city('Ambatofinandrahana','mg','Fianarantsoa',25997.0,46.8,-20.55).
city('Ambositra','mg','Fianarantsoa',30353.0,47.24,-20.53).
city('Fandriana','mg','Fianarantsoa',31437.0,47.37,-20.24).
city('Farafangana','mg','Fianarantsoa',24764.0,47.82,-22.82).
city('Fianarantsoa','mg','Fianarantsoa',167240.0,47.07,-21.45).
city('Ifanadiana','mg','Fianarantsoa',17543.0,47.63,-21.3).
city('Ihosy','mg','Fianarantsoa',16990.0,46.12,-22.4).
city('Ikalamavony','mg','Fianarantsoa',15601.0,46.58,-21.15).
city('Ikongo','mg','Fianarantsoa',32374.0,47.44,-21.88).
city('Manakara','mg','Fianarantsoa',35499.0,48.01,-22.14).
city('Mananjary','mg','Fianarantsoa',27686.0,48.35,-21.23).
city('Nosy Varika','mg','Fianarantsoa',37152.0,48.53,-20.59).
city('Vangaindrano','mg','Fianarantsoa',23523.0,47.6,-23.35).
city('Vondrozo','mg','Fianarantsoa',19949.0,47.31,-22.82).
city('Ambato Boina','mg','Mahajanga',22529.0,46.71,-16.47).
city('Antsohihy','mg','Mahajanga',21290.0,47.99,-14.88).
city('Bealanana','mg','Mahajanga',16948.0,48.73,-14.55).
city('Mahajanga','mg','Mahajanga',154670.0,46.31,-15.72).
city('Marovoay','mg','Mahajanga',31253.0,46.64,-16.11).
city('Tsaratanana','mg','Mahajanga',16761.0,47.65,-16.79).
city('Ambatondrazaka','mg','Toamasina',43134.0,48.43,-17.83).
city('Ambodifototra','mg','Toamasina',11830.0,49.85,-16.99).
city('Amparafaravola','mg','Toamasina',51520.0,48.21,-17.59).
city('Andevoranto','mg','Toamasina',10429.0,49.1,-18.95).
city('Andilamena','mg','Toamasina',19750.0,48.56,-17.02).
city('Anosibe Anala','mg','Toamasina',26365.0,48.2,-19.43).
city('Fenoarivo Atsinanana','mg','Toamasina',21036.0,49.41,-17.38).
city('Mahanoro','mg','Toamasina',39879.0,48.8,-19.9).
city('Mananara','mg','Toamasina',41209.0,49.75,-16.16).
city('Maroantsetra','mg','Toamasina',23859.0,49.74,-15.43).
city('Marolambo','mg','Toamasina',26160.0,48.12,-20.05).
city('Moramanga','mg','Toamasina',29212.0,48.22,-18.94).
city('Soanierana Ivongo','mg','Toamasina',39271.0,49.57,-16.92).
city('Toamasina','mg','Toamasina',206390.0,49.4,-18.15).
city('Vavatenina','mg','Toamasina',36916.0,49.19,-17.47).
city('Vohibinany','mg','Toamasina',25311.0,49.03,-17.35).
city('Amboasary','mg','Toliary',36082.0,46.38,-25.04).
city('Ambovombe','mg','Toliary',66818.0,46.08,-25.18).
city('Ampanihy','mg','Toliary',25686.0,44.74,-24.7).
city('Ankazoabo','mg','Toliary',25961.0,44.51,-22.29).
city('Beloha','mg','Toliary',23021.0,45.05,-25.18).
city('Beloni Tsiribihina','mg','Toliary',23900.0,44.54,-19.69).
city('Beroroha','mg','Toliary',18632.0,45.16,-21.68).
city('Betioky','mg','Toliary',31102.0,44.37,-23.72).
city('Miandrivazo','mg','Toliary',20631.0,45.45,-19.53).
city('Morondava','mg','Toliary',36803.0,44.27,-20.29).
city('Sakaraha','mg','Toliary',21826.0,44.52,-22.92).
city('Taolanaro','mg','Toliary',45141.0,46.99,-25.03).
city('Toliary','mg','Toliary',115328.0,43.66,-23.36).
city('Tsihombe','mg','Toliary',29825.0,45.48,-25.32).
city('Balaka','mw','Balaka',18907.0,34.96,-14.98).
city('Blantyre','mw','Blantyre City',584870.0,34.99,-15.79).
city('Chikwawa','mw','Chikwawa',8966.0,34.79,-16.02).
city('Chiradzulu','mw','Chiradzulu',1580.0,35.18,-15.69).
city('Chitipa','mw','Chitipa',8825.0,33.27,-9.69).
city('Chipoka','mw','Dedza',4346.0,34.5,-13.99).
city('Dedza','mw','Dedza',15611.0,34.33,-14.36).
city('Dowa','mw','Dowa',5568.0,33.93,-13.65).
city('Mponela','mw','Dowa',11222.0,33.72,-13.51).
city('Karonga','mw','Karonga',34211.0,33.95,-9.94).
city('Livingstonia','mw','Karonga',5552.0,34.12,-10.59).
city('Kasungu','mw','Kasungu',42565.0,33.48,-13.02).
city('Lilongwe','mw','Lilongwe City',646738.0,33.8,-13.97).
city('Liwonde','mw','Machinga',22476.0,35.22,-15.05).
city('Machinga','mw','Machinga',1418.0,35.52,-14.96).
city('Mangochi','mw','Mangochi',40295.0,35.27,-14.46).
city('Monkey Bay','mw','Mangochi',11623.0,34.92,-14.07).
city('Mchinji','mw','Mchinji',18328.0,32.88,-13.8).
city('Mulanje','mw','Mulanje',1651.0,35.5,-16.02).
city('Mwanza','mw','Mwanza',11384.0,34.52,-15.6).
city('Mzimba','mw','Mzimba',19310.0,33.6,-11.89).
city('Mzuzu','mw','Mzuzu City',128456.0,34.02,-11.46).
city('Nkhata Bay','mw','Nkhata Bay',11722.0,34.3,-11.59).
city('Nkhotakota','mw','Nkhotakota',24869.0,34.3,-12.91).
city('Nsanje','mw','Nsanje',21782.0,35.27,-16.91).
city('Ntcheu','mw','Ntcheu',10464.0,34.63,-14.81).
city('Ntchisi','mw','Ntchisi',7326.0,34.08,-13.33).
city('Phalombe','mw','Phalombe',2663.0,35.65,-15.79).
city('Rumphi','mw','Rumphi',20731.0,33.87,-11.01).
city('Salima','mw','Salima',30056.0,34.43,-13.77).
city('Luchenza','mw','Thyolo',11958.0,35.3,-16.01).
city('Thyolo','mw','Thyolo',5776.0,35.13,-16.06).
city('Zomba','mw','Zomba Municipality',80932.0,35.31,-15.39).
city('Bandar Maharani','my','Johor',127905.0,102.56,2.05).
city('Bandar Penggaram','my','Johor',156245.0,102.93,1.85).
city('Bukit Bakri','my','Johor',30282.0,102.67,2.05).
city('Buloh Kasap','my','Johor',13088.0,102.77,2.55).
city('Chaah','my','Johor',11844.0,103.03,2.23).
city('Johor Bahru','my','Johor',802525.0,103.75,1.48).
city('Kelapa Sawit','my','Johor',13239.0,103.53,1.67).
city('Kluang','my','Johor',169838.0,103.32,2.04).
city('Kota Tinggi','my','Johor',52746.0,103.9,1.73).
city('Kulai','my','Johor',63765.0,103.6,1.67).
city('Labis','my','Johor',21907.0,103.03,2.38).
city('Mersing','my','Johor',22009.0,103.83,2.43).
city('Parit Raja','my','Johor',17440.0,103.12,1.87).
city('Pasir Gudang','my','Johor',145739.0,103.89,1.45).
city('Pekan Nenas','my','Johor',23293.0,103.52,1.52).
city('Pontian Kecil','my','Johor',50839.0,103.38,1.52).
city('Segamat','my','Johor',69821.0,102.81,2.52).
city('Sekudai','my','Johor',159864.0,103.67,1.53).
city('Senai','my','Johor',73201.0,103.65,1.6).
city('Simpang Rengam','my','Johor',17528.0,103.32,1.83).
city('Tangkak','my','Johor',35111.0,102.55,2.27).
city('Ulu Tiram','my','Johor',75396.0,103.82,1.6).
city('Yong Peng','my','Johor',27139.0,103.06,2.01).
city('Alor Setar','my','Kedah',217378.0,100.37,6.11).
city('Bedong','my','Kedah',47598.0,100.52,5.73).
city('Gurun','my','Kedah',15965.0,100.48,5.82).
city('Jitra','my','Kedah',63492.0,100.42,6.27).
city('Kuah','my','Kedah',30227.0,99.85,6.32).
city('Kuala Kedah','my','Kedah',19232.0,100.3,6.1).
city('Kulim','my','Kedah',170931.0,100.55,5.36).
city('Sungai Petani','my','Kedah',228898.0,100.48,5.65).
city('Gua Musang','my','Kelantan',19734.0,101.97,4.88).
city('Kadok','my','Kelantan',19236.0,102.25,6.0).
city('Kota Bahru','my','Kelantan',279343.0,102.24,6.12).
city('Kuala Krai','my','Kelantan',20874.0,102.2,5.33).
city('Pangkal Kalong','my','Kelantan',39908.0,102.22,5.92).
city('Pasir Mas','my','Kelantan',19020.0,102.13,6.03).
city('Peringat','my','Kelantan',23291.0,102.28,6.03).
city('Tanah Merah','my','Kelantan',29120.0,102.15,5.8).
city('Tumpat','my','Kelantan',12281.0,102.17,6.2).
city('Wakaf Baru','my','Kelantan',21198.0,102.2,6.12).
city('Kuala Lumpur','my','Kuala Lumpur',1453978.0,101.71,3.16).
city('Labuan','my','Labuan',73664.0,115.24,5.29).
city('Alor Gajah','my','Melaka',20163.0,102.22,2.38).
city('Ayer Keroh','my','Melaka',37717.0,102.28,2.27).
city('Ayer Molek','my','Melaka',15497.0,102.32,2.2).
city('Batu Berendam','my','Melaka',25028.0,102.25,2.25).
city('Bemban','my','Melaka',14329.0,102.38,2.27).
city('Bukit Baru','my','Melaka',55658.0,102.27,2.22).
city('Bukit Rambai','my','Melaka',17391.0,102.18,2.25).
city('Klebang','my','Melaka',38650.0,102.2,2.22).
city('Kuala Sungai Baru','my','Melaka',12269.0,102.03,2.35).
city('Masjid Tanah','my','Melaka',29185.0,102.12,2.35).
city('Melaka','my','Melaka',180675.0,102.25,2.21).
city('Pulau Sebang','my','Melaka',11879.0,102.23,2.45).
city('Sungai Udang','my','Melaka',26044.0,102.15,2.27).
city('Bahau','my','Negeri Sembilan',31275.0,-102.4,2.81).
city('Kuala Pilah','my','Negeri Sembilan',19511.0,102.25,2.73).
city('Nilai','my','Negeri Sembilan',36720.0,101.8,2.82).
city('Port Dickson','my','Negeri Sembilan',89203.0,101.8,2.53).
city('Seremban','my','Negeri Sembilan',372931.0,101.95,2.71).
city('Tampin','my','Negeri Sembilan',28240.0,102.22,2.47).
city('Bentong','my','Pahang',49218.0,101.92,3.51).
city('Bukit Tinggi','my','Pahang',12346.0,101.82,3.35).
city('Jerantut','my','Pahang',33608.0,102.37,3.93).
city('Kuala Lipis','my','Pahang',15450.0,102.05,4.18).
city('Kuantan','my','Pahang',366253.0,103.34,3.82).
city('Mentakab','my','Pahang',42174.0,102.35,3.48).
city('Pekan','my','Pahang',31826.0,103.42,3.5).
city('Raub','my','Pahang',40027.0,101.85,3.79).
city('Temerloh','my','Pahang',59942.0,102.42,3.45).
city('Ayer Tawar','my','Perak',20185.0,100.74,4.22).
city('Bagan Serai','my','Perak',20477.0,-100.53,5.01).
city('Batu Gajah','my','Perak',46197.0,101.04,4.48).
city('Bidor','my','Perak',30018.0,101.28,4.12).
city('Ipoh','my','Perak',673346.0,101.07,4.6).
city('Kampar','my','Perak',19058.0,101.15,4.31).
city('Kampong Koh','my','Perak',35217.0,100.7,4.19).
city('Kuala Kangsar','my','Perak',39333.0,100.93,4.77).
city('Lawan Kuda Baharu','my','Perak',20238.0,101.16,4.44).
city('Lumut','my','Perak',39627.0,100.63,4.23).
city('Pantai Remis','my','Perak',16318.0,100.63,4.45).
city('Parit Buntar','my','Perak',27322.0,100.5,5.12).
city('Simpang Empat','my','Perak',58037.0,100.63,4.95).
city('Sungai Siput Utara','my','Perak',37202.0,101.07,4.82).
city('Taiping','my','Perak',217658.0,100.72,4.86).
city('Tanjong Malim','my','Perak',18184.0,101.52,3.68).
city('Tapah','my','Perak',27864.0,101.2,4.17).
city('Teluk Intan','my','Perak',63357.0,101.03,4.02).
city('Kangar','my','Perlis',63894.0,100.19,6.44).
city('Kuala Perlis','my','Perlis',13917.0,100.13,6.4).
city('Ayer Itam','my','Pulau Pinang',115276.0,100.45,5.47).
city('Bukit Mertajam','my','Pulau Pinang',212387.0,100.46,5.37).
city('Butterworth','my','Pulau Pinang',107597.0,100.37,5.4).
city('Gelugor','my','Pulau Pinang',135858.0,100.5,5.48).
city('Georgetown','my','Pulau Pinang',178358.0,100.31,5.37).
city('Juru','my','Pulau Pinang',12265.0,100.45,5.32).
city('Kepala Batas','my','Pulau Pinang',17131.0,100.43,5.52).
city('Nibong Tebal','my','Pulau Pinang',40085.0,100.48,5.17).
city('Perai','my','Pulau Pinang',65322.0,100.38,5.38).
city('Permatang Kuching','my','Pulau Pinang',27193.0,100.4,5.48).
city('Sungai Ara','my','Pulau Pinang',141019.0,100.27,5.33).
city('Tanjong Bunga','my','Pulau Pinang',16550.0,100.27,5.47).
city('Tanjong Tokong','my','Pulau Pinang',24073.0,100.3,5.47).
city('Val dOr','my','Pulau Pinang',70125.0,100.5,5.25).
city('Beaufort','my','Sabah',15855.0,115.75,5.33).
city('Donggongon','my','Sabah',71585.0,116.08,5.92).
city('Keningau','my','Sabah',77703.0,116.15,5.35).
city('Kinarut','my','Sabah',15716.0,116.05,5.82).
city('Kota Belud','my','Sabah',12825.0,116.43,6.35).
city('Kota Kinabalu','my','Sabah',457375.0,116.07,5.97).
city('Kudat','my','Sabah',32397.0,116.84,6.9).
city('Kunak','my','Sabah',22072.0,118.25,3.68).
city('Lahad Datu','my','Sabah',105635.0,118.34,5.03).
city('Papar','my','Sabah',19277.0,115.93,5.73).
city('Putatan','my','Sabah',78340.0,116.05,5.88).
city('Ranau','my','Sabah',19296.0,116.68,5.97).
city('Sandakan','my','Sabah',392332.0,118.11,5.85).
city('Semporna','my','Sabah',62686.0,118.6,4.47).
city('Tawau','my','Sabah',306497.0,117.88,4.26).
city('Bintulu','my','Sarawak',151718.0,113.03,3.17).
city('Kapit','my','Sarawak',15771.0,112.93,2.02).
city('Kuching','my','Sarawak',570579.0,110.34,1.55).
city('Limbang','my','Sarawak',26201.0,115.0,4.75).
city('Miri','my','Sarawak',228227.0,113.97,4.4).
city('Sarikel','my','Sarawak',29283.0,111.52,2.12).
city('Sibu','my','Sarawak',198252.0,111.83,2.3).
city('Sri Aman','my','Sarawak',27218.0,111.45,1.25).
city('Ampang Jaya','my','Selangor',644157.0,101.77,3.15).
city('Balakong','my','Selangor',69301.0,101.75,3.03).
city('Bandar Baru Salak Tinggi','my','Selangor',17878.0,101.75,2.8).
city('Banting','my','Selangor',75467.0,101.5,2.82).
city('Batang Berjuntai','my','Selangor',20001.0,101.42,3.38).
city('Batu Arang','my','Selangor',22579.0,101.47,3.32).
city('Beranang','my','Selangor',14369.0,101.87,2.88).
city('Dungun','my','Selangor',58675.0,101.32,3.22).
city('Gombak Setia','my','Selangor',67039.0,101.7,3.3).
city('Jenjarom','my','Selangor',24858.0,101.5,2.88).
city('Kajang-Sungai Chua','my','Selangor',325953.0,101.77,2.98).
city('Klang','my','Selangor',879887.0,101.45,3.04).
city('Kuala Kubu Baru','my','Selangor',22471.0,101.65,3.57).
city('Kuala Selangor','my','Selangor',55896.0,101.25,3.35).
city('Kuang','my','Selangor',21184.0,101.55,3.25).
city('Pengkalan Kundang','my','Selangor',23307.0,101.52,3.28).
city('Petaling Jaya','my','Selangor',520712.0,101.62,3.1).
city('Rawang','my','Selangor',120484.0,101.58,3.32).
city('Sabak','my','Selangor',17251.0,100.98,3.77).
city('Sekinchan','my','Selangor',17511.0,101.1,3.5).
city('Selayang Baru','my','Selangor',232973.0,101.65,3.27).
city('Semenyih','my','Selangor',80576.0,101.85,2.95).
city('Serendah','my','Selangor',28483.0,101.62,3.37).
city('Shah Alam','my','Selangor',481670.0,101.56,3.07).
city('Subang Jaya','my','Selangor',833912.0,101.53,3.15).
city('Sungai Besar','my','Selangor',26939.0,100.98,3.67).
city('Sungai Pelek','my','Selangor',13829.0,101.72,2.65).
city('Tanjong Karang','my','Selangor',16393.0,101.18,3.42).
city('Tanjong Sepat','my','Selangor',22339.0,101.57,2.67).
city('Cukai','my','Terengganu',82434.0,103.45,4.23).
city('Jertih','my','Terengganu',13526.0,102.5,5.75).
city('Kerteh','my','Terengganu',24430.0,103.45,4.52).
city('Kuala Terengganu','my','Terengganu',285091.0,103.14,5.33).
city('Marang','my','Terengganu',21413.0,103.22,5.2).
city('Paka','my','Terengganu',21044.0,103.43,4.65).
city('Bodufolhudhoo','mv','Alif Alif',496.0,72.77,4.18).
city('Feridhoo','mv','Alif Alif',511.0,72.72,4.05).
city('Himandhoo','mv','Alif Alif',523.0,72.72,3.93).
city('Maalhos','mv','Alif Alif',376.0,72.7,3.98).
city('Mathiveri','mv','Alif Alif',533.0,72.72,4.2).
city('Rasdhoo','mv','Alif Alif',1092.0,72.98,4.27).
city('Thoddoo','mv','Alif Alif',1161.0,72.95,4.42).
city('Ukulhas','mv','Alif Alif',519.0,72.85,4.22).
city('Dhagethi','mv','Alif Dhaal',705.0,72.96,3.6).
city('Dhidhdhoo','mv','Alif Dhaal',144.0,72.87,3.52).
city('Dhigurah','mv','Alif Dhaal',440.0,72.92,3.55).
city('Fenfushi','mv','Alif Dhaal',668.0,72.78,3.49).
city('Hangnameedhoo','mv','Alif Dhaal',524.0,72.96,3.85).
city('Kuburudhoo','mv','Alif Dhaal',476.0,72.98,3.77).
city('Maamigili','mv','Alif Dhaal',1918.0,72.83,3.5).
city('Mahibadhoo','mv','Alif Dhaal',2155.0,72.97,3.78).
city('Mandhoo','mv','Alif Dhaal',322.0,72.7,3.72).
city('Omadhoo','mv','Alif Dhaal',747.0,72.97,3.79).
city('Dharavandhoo','mv','Baa',847.0,73.13,5.16).
city('Dhonfanu','mv','Baa',313.0,73.1,5.2).
city('Eydhafushi','mv','Baa',2808.0,73.03,5.12).
city('Fehendhoo','mv','Baa',141.0,72.93,4.9).
city('Fulhadhoo','mv','Baa',265.0,72.95,4.89).
city('Goidhoo','mv','Baa',447.0,72.9,4.88).
city('Hithaadhoo','mv','Baa',881.0,72.9,5.03).
city('Kamadhoo','mv','Baa',234.0,73.14,5.28).
city('Kendhoo','mv','Baa',746.0,72.98,5.28).
city('Kihaadhoo','mv','Baa',319.0,72.97,5.28).
city('Kudarikilu','mv','Baa',406.0,73.05,5.3).
city('Maalhos','mv','Baa',328.0,73.11,5.14).
city('Thulhaadhoo','mv','Baa',2006.0,72.84,5.02).
city('Badidhoo','mv','Dhaal',616.0,73.0,2.95).
city('Gemendhoo','mv','Dhaal',355.0,73.03,2.8).
city('Hulhudheli','mv','Dhaal',510.0,72.87,2.87).
city('Kudahuvadhoo','mv','Dhaal',1320.0,72.9,2.67).
city('Maaeboodhoo','mv','Dhaal',581.0,72.97,2.7).
city('Meedhoo','mv','Dhaal',961.0,73.01,3.0).
city('Ribudhoo','mv','Dhaal',368.0,72.9,2.93).
city('Vaanee','mv','Dhaal',370.0,73.0,2.73).
city('Biledhdhoo','mv','Faaf',885.0,72.98,3.13).
city('Dharaboodhoo','mv','Faaf',248.0,72.93,3.06).
city('Feeali','mv','Faaf',914.0,73.0,3.27).
city('Magoodhoo','mv','Faaf',453.0,72.97,3.1).
city('Nilandhoo','mv','Faaf',2048.0,72.9,3.07).
city('Dhaandhoo','mv','Gaaf Alif',1158.0,73.42,0.63).
city('Dhevvadhoo','mv','Gaaf Alif',495.0,73.18,0.55).
city('Dhiyadhoo','mv','Gaaf Alif',117.0,73.5,0.48).
city('Gemanafushi','mv','Gaaf Alif',936.0,73.57,0.45).
city('Kanduhulhudhoo','mv','Gaaf Alif',316.0,73.54,0.35).
city('Kodey','mv','Gaaf Alif',249.0,73.55,0.5).
city('Kolamaafushi','mv','Gaaf Alif',1235.0,73.19,0.84).
city('Maamendhoo','mv','Gaaf Alif',1066.0,73.44,0.72).
city('Nilandhoo','mv','Gaaf Alif',391.0,73.38,0.65).
city('Viligili','mv','Gaaf Alif',2305.0,73.44,0.76).
city('Fares','mv','Gaaf Dhaal',429.0,73.19,0.2).
city('Fiyoari','mv','Gaaf Dhaal',858.0,73.07,0.22).
city('Gadhdhoo','mv','Gaaf Dhaal',1681.0,73.4,0.3).
city('Hoadedhdhoo','mv','Gaaf Dhaal',427.0,72.97,0.37).
city('Maathodaa','mv','Gaaf Dhaal',485.0,73.1,0.22).
city('Madeveli','mv','Gaaf Dhaal',824.0,73.0,0.46).
city('Nadallaa','mv','Gaaf Dhaal',605.0,72.98,0.3).
city('Rathafandhoo','mv','Gaaf Dhaal',517.0,73.09,0.25).
city('Thinadhoo','mv','Gaaf Dhaal',5361.0,72.93,0.53).
city('Vaadhoo','mv','Gaaf Dhaal',650.0,73.28,0.25).
city('Fuvammulah','mv','Ghaviyani',7960.0,73.43,-0.3).
city('Baarah','mv','Haa Alif',1372.0,73.2,6.82).
city('Berinmadhoo','mv','Haa Alif',108.0,72.97,7.07).
city('Dhidhdhoo','mv','Haa Alif',3039.0,73.1,6.88).
city('Filladhoo','mv','Haa Alif',637.0,73.22,6.9).
city('Hathifushi','mv','Haa Alif',125.0,72.82,7.03).
city('Hoarafushi','mv','Haa Alif',2327.0,72.9,6.98).
city('Ihavandhoo','mv','Haa Alif',2259.0,72.92,6.95).
city('Kelaa','mv','Haa Alif',1158.0,73.2,6.95).
city('Maarandhoo','mv','Haa Alif',484.0,72.97,6.87).
city('Mulhadhoo','mv','Haa Alif',236.0,72.98,7.02).
city('Muraidhoo','mv','Haa Alif',431.0,73.15,6.85).
city('Thakandhoo','mv','Haa Alif',467.0,72.99,6.85).
city('Thuraakunu','mv','Haa Alif',375.0,72.88,7.12).
city('Uligamu','mv','Haa Alif',288.0,72.92,7.08).
city('Utheemu','mv','Haa Alif',586.0,73.1,6.85).
city('Vashafaru','mv','Haa Alif',736.0,73.16,6.9).
city('Faridhoo','mv','Haa Dhaal',154.0,73.05,6.79).
city('Finey','mv','Haa Dhaal',317.0,73.05,6.75).
city('Hanimaadhoo','mv','Haa Dhaal',1286.0,73.15,6.75).
city('Hirimaradhoo','mv','Haa Dhaal',653.0,73.02,6.73).
city('Hondaidhoo','mv','Haa Dhaal',85.0,73.08,6.77).
city('Kuburudhoo','mv','Haa Dhaal',224.0,73.03,6.66).
city('Kulhudhuffushi','mv','Haa Dhaal',7775.0,73.05,6.62).
city('Kumundhoo','mv','Haa Dhaal',997.0,73.03,6.05).
city('Kuribi','mv','Haa Dhaal',475.0,72.98,6.67).
city('Maavaidhoo','mv','Haa Dhaal',294.0,73.03,6.52).
city('Makunudhoo','mv','Haa Dhaal',1158.0,72.68,6.4).
city('Naivaadhoo','mv','Haa Dhaal',436.0,72.9,6.73).
city('Nellaidhoo','mv','Haa Dhaal',731.0,72.93,6.72).
city('Neykurendhoo','mv','Haa Dhaal',966.0,72.96,6.55).
city('Nolhivaramu','mv','Haa Dhaal',1677.0,73.08,6.66).
city('Nolhivaranfaru','mv','Haa Dhaal',448.0,73.1,6.72).
city('Vaikaradhoo','mv','Haa Dhaal',1315.0,72.95,6.55).
city('Dhiffushi','mv','Kaaf',901.0,73.71,4.44).
city('Gaafaru','mv','Kaaf',851.0,73.43,4.75).
city('Gulhi','mv','Kaaf',603.0,73.51,3.99).
city('Guraidhoo','mv','Kaaf',1208.0,73.47,3.9).
city('Himmafushi','mv','Kaaf',1072.0,73.57,4.31).
city('Huraa','mv','Kaaf',838.0,73.58,4.32).
city('Kaashidhoo','mv','Kaaf',1826.0,73.47,4.97).
city('Maafushi','mv','Kaaf',2932.0,73.47,3.93).
city('Thulusdhoo','mv','Kaaf',868.0,73.63,4.37).
city('Dhabidhoo','mv','Laam',619.0,73.57,2.08).
city('Fonadhoo','mv','Laam',2074.0,73.5,1.83).
city('Gaadhoo','mv','Laam',255.0,73.47,1.82).
city('Gamu','mv','Laam',2957.0,73.54,1.92).
city('Hithadhoo','mv','Laam',683.0,73.38,1.78).
city('Isdhoo','mv','Laam',1505.0,73.58,2.1).
city('Kalhaidhoo','mv','Laam',402.0,73.54,1.99).
city('Kunahandhoo','mv','Laam',538.0,73.37,1.78).
city('Maabaidhoo','mv','Laam',894.0,73.55,2.03).
city('Maamendhoo','mv','Laam',989.0,73.4,1.82).
city('Maavah','mv','Laam',1413.0,73.24,1.89).
city('Mundhoo','mv','Laam',540.0,73.53,2.01).
city('Hinnavaru','mv','Lhaviyani',3349.0,73.42,5.49).
city('Kurendhoo','mv','Lhaviyani',1311.0,73.45,5.55).
city('Maafilaafushi','mv','Lhaviyani',181.0,73.42,5.37).
city('Naifaru','mv','Lhaviyani',3836.0,73.33,5.43).
city('Olhuvelifushi','mv','Lhaviyani',435.0,73.58,5.28).
city('Male','mv','Male',84971.0,73.5,4.17).
city('Dhiggaru','mv','Miim',810.0,73.55,3.12).
city('Kolhufushi','mv','Miim',988.0,73.4,2.77).
city('Madifushi','mv','Miim',111.0,73.64,3.08).
city('Maduvvari','mv','Miim',405.0,73.55,3.1).
city('Mulah','mv','Miim',1370.0,73.57,2.95).
city('Muli','mv','Miim',1008.0,73.57,2.92).
city('Naalaafushi','mv','Miim',264.0,73.58,2.9).
city('Raimandhoo','mv','Miim',149.0,73.62,3.08).
city('Veyvah','mv','Miim',204.0,73.6,2.96).
city('Fodhdhoo','mv','Nuun',249.0,73.21,5.74).
city('Hebadhoo','mv','Nuun',425.0,73.08,5.15).
city('Holhudhoo','mv','Nuun',1506.0,73.23,5.75).
city('Kedhikolhudhoo','mv','Nuun',1219.0,73.42,5.95).
city('Kudafari','mv','Nuun',365.0,73.08,5.98).
city('Landhoo','mv','Nuun',649.0,73.45,5.88).
city('Lhohi','mv','Nuun',502.0,72.87,5.47).
city('Maafaru','mv','Nuun',818.0,73.21,5.83).
city('Maalhendhoo','mv','Nuun',631.0,73.43,5.9).
city('Magoodhoo','mv','Nuun',246.0,73.33,5.78).
city('Manadhoo','mv','Nuun',1418.0,73.38,5.77).
city('Miladhoo','mv','Nuun',738.0,73.33,5.8).
city('Velidhoo','mv','Nuun',2036.0,73.24,5.66).
city('Agolhitheemu','mv','Raa',366.0,72.98,5.78).
city('Alifushi','mv','Raa',1861.0,72.93,5.97).
city('Fainu','mv','Raa',244.0,73.02,5.47).
city('Hulhudhuffaaru','mv','Raa',1021.0,73.01,5.76).
city('Iguraidhoo','mv','Raa',1431.0,73.01,5.47).
city('Innamaadhoo','mv','Raa',525.0,73.03,5.55).
city('Kadholhudhoo','mv','Raa',3056.0,72.86,5.62).
city('Kinolhas','mv','Raa',384.0,73.03,5.45).
city('Maakurathu','mv','Raa',884.0,73.03,5.62).
city('Maduvvari','mv','Raa',1691.0,72.9,5.48).
city('Meedhoo','mv','Raa',1539.0,72.96,5.46).
city('Rasgetheemu','mv','Raa',611.0,72.98,5.8).
city('Rasmaadhoo','mv','Raa',557.0,73.03,5.57).
city('Ugoofaaru','mv','Raa',1264.0,73.0,5.67).
city('Vaadhoo','mv','Raa',352.0,72.99,5.86).
city('Bilehffahi','mv','Shaviyani',464.0,72.95,6.33).
city('Feevah','mv','Shaviyani',707.0,73.18,6.35).
city('Feydhoo','mv','Shaviyani',618.0,73.03,6.35).
city('Firubaidhoo','mv','Shaviyani',412.0,73.23,6.12).
city('Foakaidhoo','mv','Shaviyani',1183.0,73.15,6.33).
city('Funadhoo','mv','Shaviyani',1221.0,73.27,6.15).
city('Goidhoo','mv','Shaviyani',469.0,72.92,6.42).
city('Kaditheemu','mv','Shaviyani',1259.0,72.92,6.44).
city('Komandoo','mv','Shaviyani',1569.0,73.35,5.97).
city('Lhaimagu','mv','Shaviyani',513.0,73.25,6.16).
city('Maakandoodhoo','mv','Shaviyani',1891.0,73.25,6.23).
city('Maaugoodhoo','mv','Shaviyani',708.0,73.25,6.03).
city('Maroshi','mv','Shaviyani',600.0,73.06,6.21).
city('Narudhoo','mv','Shaviyani',459.0,73.18,6.27).
city('Noomaraa','mv','Shaviyani',502.0,73.05,6.42).
city('Feydhoo','mv','Siin',2657.0,73.13,-0.68).
city('Hithadhoo','mv','Siin',9927.0,73.08,-0.59).
city('Hulhudhoo','mv','Siin',1350.0,73.23,-0.59).
city('Maradhoo','mv','Siin',2204.0,73.12,-0.67).
city('Maradhoo-Feydhoo','mv','Siin',1119.0,73.13,-0.67).
city('Meedhoo','mv','Siin',1726.0,73.23,-0.58).
city('Buruni','mv','Thaa',244.0,73.1,2.55).
city('Dhiyamigili','mv','Thaa',444.0,73.33,2.33).
city('Gaadhiffushi','mv','Thaa',257.0,73.22,2.25).
city('Guraidhoo','mv','Thaa',1509.0,73.32,2.33).
city('Hirilandhoo','mv','Thaa',840.0,72.93,2.27).
city('Kadoodhoo','mv','Thaa',372.0,72.92,2.32).
city('Kibidhoo','mv','Thaa',920.0,73.08,2.17).
city('Madifushi','mv','Thaa',596.0,73.35,2.36).
city('Omadhoo','mv','Thaa',341.0,73.02,2.16).
city('Thimarafushi','mv','Thaa',1504.0,73.15,2.2).
city('Vandhoo','mv','Thaa',228.0,72.94,2.29).
city('Veymandhoo','mv','Thaa',845.0,73.38,2.18).
city('Vilufushi','mv','Thaa',1146.0,73.3,2.51).
city('Felidhoo','mv','Vaav',541.0,73.53,3.48).
city('Fulidhoo','mv','Vaav',338.0,73.4,3.68).
city('Keyodhoo','mv','Vaav',490.0,73.55,3.46).
city('Rakeedhoo','mv','Vaav',200.0,73.45,3.32).
city('Thinadhoo','mv','Vaav',96.0,73.52,3.5).
city('Bamako','ml','Bamako',1297390.0,-7.99,12.65).
city('Gao','ml','Gao',38186.0,-0.05,16.27).
city('Bafoulabe','ml','Kayes',26866.0,-10.82,13.8).
city('Kayes','ml','Kayes',97475.0,-11.44,14.45).
city('Kita','ml','Kayes',5769.0,-9.49,13.04).
city('Nioro','ml','Kayes',72080.0,-9.59,15.23).
city('Kidal','ml','Kidal',11642.0,1.41,18.45).
city('Tessalit','ml','Kidal',2787.0,0.98,20.28).
city('Banamba','ml','Koulikoro',30603.0,-7.45,13.55).
city('Kangaba','ml','Koulikoro',17232.0,-8.44,11.94).
city('Kati','ml','Koulikoro',42927.0,-8.08,12.75).
city('Kolokani','ml','Koulikoro',48792.0,-8.05,13.58).
city('Koulikoro','ml','Koulikoro',23922.0,-7.58,12.87).
city('Nara','ml','Koulikoro',27797.0,-7.28,15.18).
city('Bandiagara','ml','Mopti',6856.0,-3.61,14.35).
city('Djenne','ml','Mopti',22391.0,-4.56,13.92).
city('Douentza','ml','Mopti',8057.0,-2.96,15.0).
city('Mopti','ml','Mopti',108790.0,-4.18,14.49).
city('Tenenkou','ml','Mopti',7471.0,-4.92,14.45).
city('Ke-Massina','ml','Segou',9848.0,-5.36,13.97).
city('Kimparana','ml','Segou',6014.0,-4.93,12.84).
city('Markala','ml','Segou',53746.0,-6.07,13.67).
city('Niono','ml','Segou',32621.0,-5.99,14.23).
city('San','ml','Segou',24813.0,-4.9,13.3).
city('Segou','ml','Segou',92562.0,-6.26,13.44).
city('Sokolo','ml','Segou',4374.0,-6.13,14.74).
city('Bougouni','ml','Sikasso',35567.0,-7.49,11.42).
city('Kolondieba','ml','Sikasso',10041.0,-6.89,11.08).
city('Koutiala','ml','Sikasso',99662.0,-5.47,12.39).
city('Sikasso','ml','Sikasso',144801.0,-5.68,11.32).
city('Yorosso','ml','Sikasso',17447.0,-4.79,12.37).
city('Araouane','ml','Tombouctou',4026.0,-3.53,18.9).
city('Dire','ml','Tombouctou',10947.0,-10.96,12.28).
city('Goundam','ml','Tombouctou',8459.0,-3.68,16.43).
city('Niafunke','ml','Tombouctou',6901.0,-3.99,15.93).
city('Taoudenni','ml','Tombouctou',3019.0,-3.98,22.67).
city('Tombouctou','ml','Tombouctou',32463.0,-3.01,16.78).
city('Ghajnsielem and Comino','mt','Gozo and Comino',2373.0,14.28,36.03).
city('Gharb','mt','Gozo and Comino',971.0,14.21,36.06).
city('Ghasri','mt','Gozo and Comino',364.0,14.23,36.06).
city('Kercem','mt','Gozo and Comino',1627.0,14.23,36.04).
city('Munxar','mt','Gozo and Comino',840.0,14.23,36.03).
city('Nadur','mt','Gozo and Comino',3933.0,14.29,36.04).
city('Qala','mt','Gozo and Comino',1534.0,14.31,36.04).
city('Rabat','mt','Gozo and Comino',6596.0,14.24,36.05).
city('San Lawrenz','mt','Gozo and Comino',530.0,14.2,36.06).
city('Sannat','mt','Gozo and Comino',1681.0,14.24,36.02).
city('Xaghra','mt','Gozo and Comino',3680.0,14.26,36.05).
city('Xewkija','mt','Gozo and Comino',3303.0,14.26,36.03).
city('Zebbug','mt','Gozo and Comino',1575.0,14.24,36.07).
city('Birgu','mt','Inner Harbour',2936.0,14.52,35.89).
city('Bormla','mt','Inner Harbour',6096.0,14.53,35.89).
city('Floriana','mt','Inner Harbour',2516.0,14.51,35.9).
city('Gzira','mt','Inner Harbour',7513.0,14.5,35.9).
city('Hamrun','mt','Inner Harbour',10680.0,14.48,35.89).
city('Isla','mt','Inner Harbour',3543.0,14.51,35.89).
city('Kalkara','mt','Inner Harbour',2982.0,14.54,35.89).
city('Marsa','mt','Inner Harbour',5116.0,14.49,35.88).
city('Msida','mt','Inner Harbour',6920.0,14.48,35.9).
city('Paola','mt','Inner Harbour',9257.0,14.54,35.85).
city('Pieta','mt','Inner Harbour',4128.0,14.5,35.89).
city('Santa Lucia','mt','Inner Harbour',3760.0,14.51,35.86).
city('Sliema','mt','Inner Harbour',11318.0,14.5,35.92).
city('Ta Xbiex','mt','Inner Harbour',1642.0,14.49,35.9).
city('Valletta','mt','Inner Harbour',6794.0,14.52,35.91).
city('Gharghur','mt','Northern',2025.0,14.46,35.92).
city('Mellieha','mt','Northern',5976.0,14.36,35.96).
city('Mgarr','mt','Northern',2868.0,14.3,36.03).
city('Mosta','mt','Northern',17789.0,14.43,35.91).
city('Naxxar','mt','Northern',10378.0,14.45,35.92).
city('San Pawl il-Bahar','mt','Northern',7396.0,14.4,35.95).
city('Birkirkara','mt','Outer Harbour',21676.0,14.46,35.9).
city('Fgura','mt','Outer Harbour',11819.0,14.52,35.87).
city('Luqa','mt','Outer Harbour',5053.0,14.48,35.87).
city('Pembroke','mt','Outer Harbour',2838.0,14.48,35.94).
city('Qormi','mt','Outer Harbour',18230.0,14.47,35.88).
city('San Giljan','mt','Outer Harbour',6799.0,14.49,35.92).
city('San Gwann','mt','Outer Harbour',12346.0,14.49,35.93).
city('Santa Venera','mt','Outer Harbour',6264.0,14.46,35.89).
city('Swieqi','mt','Outer Harbour',5973.0,14.48,35.93).
city('Tarxien','mt','Outer Harbour',7761.0,14.51,35.87).
city('Xghajra','mt','Outer Harbour',837.0,14.55,35.89).
city('Zabbar','mt','Outer Harbour',15030.0,14.54,35.88).
city('Birzebugia','mt','South Eastern',7739.0,14.53,35.84).
city('Ghaxaq','mt','South Eastern',4375.0,14.52,35.85).
city('Gudja','mt','South Eastern',3023.0,14.5,35.85).
city('Kirkop','mt','South Eastern',2137.0,14.49,35.84).
city('Marsascala','mt','South Eastern',5530.0,14.56,35.87).
city('Marsaxlokk','mt','South Eastern',3026.0,14.54,35.84).
city('Mqabba','mt','South Eastern',2891.0,14.47,35.85).
city('Qrendi','mt','South Eastern',2493.0,14.46,35.83).
city('Safi','mt','South Eastern',1863.0,14.48,35.83).
city('Zejtun','mt','South Eastern',11549.0,14.53,35.85).
city('Zurrieq','mt','South Eastern',9149.0,14.47,35.84).
city('Attard','mt','Western',9510.0,14.45,35.89).
city('Balzan','mt','Western',3240.0,14.46,35.19).
city('Dingli','mt','Western',3009.0,14.38,35.86).
city('Iklin','mt','Western',3360.0,14.45,35.91).
city('Lija','mt','Western',2471.0,14.45,35.9).
city('Mdina','mt','Western',360.0,14.4,35.89).
city('Rabat','mt','Western',12914.0,14.4,35.87).
city('Siggiewi','mt','Western',7676.0,14.43,35.85).
city('Zebbug','mt','Western',11063.0,14.43,35.87).
city('Jaluit','mh','Jaluit',314.0,169.61,5.79).
city('Ebeye','mh','Kwajalein',9825.0,167.73,8.77).
city('Rita','mh','Majuro',21020.0,171.06,7.12).
city('Fort-de-France','mq','Fort-de-France',89997.0,-61.08,14.6).
city('Le Lamentin','mq','Fort-de-France',39230.0,-61.0,14.6).
city('Saint-Joseph','mq','Fort-de-France',16974.0,-61.04,14.67).
city('Schoelcher','mq','Fort-de-France',21487.0,-61.12,14.63).
city('Basse-Pointe','mq','La Trinite',4037.0,-61.12,14.86).
city('Gros-Morne','mq','La Trinite',11026.0,-61.0,14.7).
city('La Trinite','mq','La Trinite',15041.0,-60.97,14.74).
city('Le Lorrain','mq','La Trinite',8342.0,-61.07,14.83).
city('Le Robert','mq','La Trinite',23815.0,-60.94,14.67).
city('Riviere-Salee','mq','La Trinite',15153.0,-60.99,14.75).
city('Sainte-Marie','mq','La Trinite',20381.0,-61.0,14.78).
city('Ducos','mq','Le Marin',17395.0,-60.98,14.57).
city('Le Francois','mq','Le Marin',19683.0,-60.9,14.6).
city('Le Marin','mq','Le Marin',7944.0,-60.87,14.47).
city('Le Vauclin','mq','Le Marin',7813.0,-60.85,14.53).
city('Les Trois-Ilets','mq','Le Marin',5658.0,-61.04,14.53).
city('Riviere-Pilote','mq','Le Marin',13360.0,-60.9,14.49).
city('Saint-Esprit','mq','Le Marin',8508.0,-60.94,14.55).
city('Sainte-Luce','mq','Le Marin',9197.0,-60.92,14.47).
city('Le Morne-Rouge','mq','Saint-Pierre',5469.0,-61.14,14.77).
city('Saint-Pierre','mq','Saint-Pierre',4125.0,-61.18,14.74).
city('Atar','mr','Adrar',30501.0,-13.05,20.51).
city('Singati','mr','Adrar',4620.0,-12.37,20.47).
city('Guerou','mr','Assaba',22249.0,-11.83,16.8).
city('Kifah','mr','Assaba',67712.0,-11.4,16.62).
city('Alak','mr','Brakna',21293.0,-13.91,17.06).
city('Bababe','mr','Brakna',11507.0,-13.94,16.34).
city('Buqah','mr','Brakna',24565.0,-14.27,16.59).
city('Chagar','mr','Brakna',10437.0,-5.78,25.38).
city('Magta Lahjar','mr','Brakna',22521.0,-13.5,17.0).
city('Nouadhibou','mr','Dakhlet Nouadhibou',80181.0,-17.04,20.96).
city('Silibabi','mr','Guidimagha',26462.0,-12.18,15.17).
city('Djowol','mr','Gurgul',7772.0,-13.38,16.07).
city('Kayhaydi','mr','Gurgul',51410.0,-13.5,16.15).
city('Maghama','mr','Gurgul',5100.0,-12.85,15.51).
city('Mbout','mr','Gurgul',6925.0,-12.58,16.02).
city('Adel Bagrou','mr','Hodh ech Chargui',13670.0,-7.12,15.57).
city('Tinbadgah','mr','Hodh ech Chargui',23762.0,-8.15,16.26).
city('Walatah','mr','Hodh ech Chargui',12777.0,-7.04,17.3).
city('an-Namah','mr','Hodh ech Chargui',35820.0,-7.26,16.62).
city('Ayun','mr','Hodh el Gharbi',21768.0,-9.62,16.66).
city('Kubanni','mr','Hodh el Gharbi',4780.0,-9.46,15.78).
city('Tintane','mr','Hodh el Gharbi',16067.0,-8.22,17.03).
city('Aqjawajat','mr','Inshiri',11235.0,-14.4,19.75).
city('Nouakchott','mr','Nouakchott',709835.0,-15.98,18.09).
city('Tijiqjah','mr','Takant',17180.0,-11.44,18.56).
city('Fdayrik','mr','Tiris Zemmour',5128.0,-12.71,22.69).
city('Zuwarat','mr','Tiris Zemmour',44319.0,-12.49,22.73).
city('Bu Tilimit','mr','Trarza',32797.0,-14.7,17.55).
city('Rusu','mr','Trarza',61822.0,-15.8,16.52).
city('Albion','mu','Black River',3254.0,57.4,-20.19).
city('Bambous','mu','Black River',13047.0,57.4,-20.25).
city('Cascavelle','mu','Black River',2613.0,57.4,-20.27).
city('Case Noyale','mu','Black River',1525.0,57.37,-20.39).
city('Chamarel','mu','Black River',723.0,57.38,-20.41).
city('Flic en Flac','mu','Black River',2010.0,57.37,-20.27).
city('Grande Riviere Noire','mu','Black River',2361.0,57.37,-20.34).
city('Gros Cailloux','mu','Black River',3361.0,57.43,-20.2).
city('La Gaulette','mu','Black River',2216.0,57.65,-20.36).
city('Le Morne','mu','Black River',1321.0,57.34,-20.45).
city('Petite Riviere','mu','Black River',5331.0,57.43,-20.18).
city('Port Louis','mu','Black River',155226.0,57.51,-20.17).
city('Richelieu','mu','Black River',5196.0,57.45,-20.19).
city('Tamarin','mu','Black River',3764.0,57.38,-20.31).
city('Bel Air','mu','Flacq',17671.0,57.75,-20.25).
city('Bon Accueil','mu','Flacq',6553.0,57.67,-20.17).
city('Brisee Verdiere','mu','Flacq',7374.0,57.67,-20.18).
city('Camp Ithier','mu','Flacq',4401.0,57.74,-20.22).
city('Camp de Masque','mu','Flacq',2721.0,57.66,-20.24).
city('Camp de Masque Pave','mu','Flacq',4520.0,57.67,-20.25).
city('Central Flacq','mu','Flacq',17710.0,57.71,-20.2).
city('Clemencia','mu','Flacq',1835.0,57.7,-20.26).
city('Ecroignard','mu','Flacq',5952.0,57.74,-20.23).
city('Grand River South East','mu','Flacq',2472.0,57.77,-20.27).
city('Lalmatie','mu','Flacq',10404.0,57.67,-20.2).
city('Laventure','mu','Flacq',6171.0,57.68,-20.15).
city('Mare La Chaux','mu','Flacq',2058.0,57.76,-20.2).
city('Medine-Camp de Masque','mu','Flacq',7244.0,57.39,-20.25).
city('Olivia','mu','Flacq',3980.0,57.73,-20.29).
city('Poste de Flacq','mu','Flacq',7133.0,57.71,-20.17).
city('Quatre Cocos','mu','Flacq',5724.0,57.79,-20.23).
city('Quatre Soeurs','mu','Flacq',3515.0,57.77,-20.29).
city('Queen Victoria','mu','Flacq',3025.0,57.7,-20.21).
city('Saint Julien','mu','Flacq',3188.0,57.63,-20.22).
city('Saint Julien dHotman','mu','Flacq',3335.0,57.63,-20.23).
city('Sebastopol','mu','Flacq',5745.0,57.68,-20.28).
city('Trou dEau Douce','mu','Flacq',5665.0,57.78,-20.23).
city('Bambous Virieux','mu','Grand Port',1541.0,57.76,-20.33).
city('Bananes','mu','Grand Port',652.0,57.56,-20.35).
city('Beau Vallon','mu','Grand Port',7016.0,57.7,-20.42).
city('Bois des Amourettes','mu','Grand Port',1986.0,57.73,-20.36).
city('Cluny','mu','Grand Port',1629.0,57.6,-20.37).
city('Grand Bel Air','mu','Grand Port',1452.0,57.57,-20.5).
city('Grand Sable','mu','Grand Port',2208.0,57.77,-20.31).
city('LEscalier','mu','Grand Port',8408.0,57.6,-20.47).
city('Mahebourg','mu','Grand Port',17042.0,57.7,-20.41).
city('New Grove','mu','Grand Port',9935.0,57.6,-20.42).
city('Nouvelle France','mu','Grand Port',7238.0,57.55,-20.37).
city('Plaine Magnien','mu','Grand Port',10778.0,57.65,-20.43).
city('Rose Belle','mu','Grand Port',12619.0,57.6,-20.4).
city('Saint Hubert','mu','Grand Port',4170.0,57.63,-20.37).
city('Camp Thorel','mu','Moka',2299.0,57.62,-20.21).
city('Dagotiere','mu','Moka',6915.0,57.55,-20.23).
city('Dubreuil','mu','Moka',2726.0,57.59,-20.3).
city('Esperance','mu','Moka',1878.0,57.63,-20.06).
city('LAvenir','mu','Moka',2533.0,57.55,-20.21).
city('La Laura-Malenga','mu','Moka',1313.0,57.55,-20.2).
city('Melrose','mu','Moka',2002.0,57.63,-20.26).
city('Moka','mu','Moka',8842.0,57.5,-20.21).
city('Montagne Blanche','mu','Moka',8661.0,57.65,-20.29).
city('Pailles','mu','Moka',10622.0,57.46,-20.18).
city('Providence','mu','Moka',3126.0,57.62,-20.24).
city('Quartier Militaire','mu','Moka',6424.0,57.58,-20.25).
city('Ripailles','mu','Moka',3050.0,57.77,-20.17).
city('Saint Pierre','mu','Moka',16414.0,57.52,-20.22).
city('Verdun','mu','Moka',2208.0,57.55,-20.22).
city('Arsenal','mu','Pamplemousses',2599.0,57.53,-20.09).
city('Baie du Tombeau','mu','Pamplemousses',13153.0,57.51,-20.11).
city('Calebasses','mu','Pamplemousses',4648.0,57.55,-20.11).
city('Congomah','mu','Pamplemousses',1956.0,57.58,-20.14).
city('Creve Coeur','mu','Pamplemousses',3097.0,57.55,-20.17).
city('DEpinay','mu','Pamplemousses',5228.0,57.59,-20.13).
city('Fond du Sac','mu','Pamplemousses',5796.0,57.57,-20.05).
city('Le Hochet','mu','Pamplemousses',15197.0,57.53,-20.14).
city('Long Mountain','mu','Pamplemousses',7775.0,57.57,-20.13).
city('Morcellement Saint Andre','mu','Pamplemousses',6150.0,57.55,-20.08).
city('Notre Dame','mu','Pamplemousses',3959.0,57.57,-20.15).
city('Pamplemousse','mu','Pamplemousses',8836.0,57.57,-20.1).
city('Plaines des Papayes','mu','Pamplemousses',7617.0,57.57,-20.07).
city('Pointe aux Piments','mu','Pamplemousses',7556.0,57.51,-20.08).
city('Terre Rouge','mu','Pamplemousses',9566.0,57.52,-20.12).
city('Triolet','mu','Pamplemousses',23270.0,57.53,-20.05).
city('Villebague','mu','Pamplemousses',2577.0,57.62,-20.12).
city('Beau Bassin-Rose Hill','mu','Plaines Wilhelm',110821.0,57.46,-20.23).
city('Curepipe','mu','Plaines Wilhelm',84200.0,57.51,-20.31).
city('Midlands','mu','Plaines Wilhelm',4546.0,57.57,-20.32).
city('Quatre Bornes','mu','Plaines Wilhelm',80961.0,57.47,-20.26).
city('Vascoas-Phoenix','mu','Plaines Wilhelm',106760.0,57.48,-20.3).
city('Amaury','mu','Riviere du Rempart',2912.0,57.68,-20.14).
city('Amitie-Gokhoola','mu','Riviere du Rempart',2112.0,57.67,-20.12).
city('Belle Vue Maurel','mu','Riviere du Rempart',5088.0,57.58,-20.07).
city('Cap Malheureux','mu','Riviere du Rempart',4803.0,57.62,-19.97).
city('Cottage','mu','Riviere du Rempart',3646.0,57.62,-20.05).
city('Esperance Trebuchet','mu','Riviere du Rempart',2323.0,57.64,-20.07).
city('Goodlands','mu','Riviere du Rempart',20910.0,57.63,-20.03).
city('Grand Baie','mu','Riviere du Rempart',11512.0,57.58,-20.02).
city('Grand Gaube','mu','Riviere du Rempart',7156.0,57.65,-20.02).
city('Mapou','mu','Riviere du Rempart',1288.0,57.61,-20.08).
city('Petit Raffray','mu','Riviere du Rempart',9117.0,57.58,-20.0).
city('Piton','mu','Riviere du Rempart',5909.0,57.62,-20.09).
city('Plaine des Roches','mu','Riviere du Rempart',4218.0,57.7,-20.12).
city('Poudre dOr','mu','Riviere du Rempart',4933.0,57.67,-20.06).
city('Poudre dOr Hamlet','mu','Riviere du Rempart',2281.0,57.67,-20.05).
city('Riviere du Rempart','mu','Riviere du Rempart',11675.0,57.68,-20.1).
city('Roche Terre','mu','Riviere du Rempart',3199.0,57.62,-20.01).
city('Roches Noires','mu','Riviere du Rempart',5733.0,57.72,-20.11).
city('The Vale','mu','Riviere du Rempart',3707.0,57.58,-20.01).
city('Camp Diable','mu','Savanne',5082.0,57.58,-20.47).
city('Chamouny','mu','Savanne',4913.0,57.45,-20.48).
city('Chemin Grenier','mu','Savanne',12457.0,57.46,-20.49).
city('Grand Bois','mu','Savanne',7804.0,57.55,-20.42).
city('Riviere des Anguilles','mu','Savanne',9927.0,57.55,-20.48).
city('Saint Aubin','mu','Savanne',1659.0,57.53,-20.49).
city('Souillac','mu','Savanne',4392.0,57.51,-20.51).
city('Surinam','mu','Savanne',10621.0,57.48,-20.5).
city('Acoua','yt','Mayotte',5350.0,45.06,-12.72).
city('Bandraboua','yt','Mayotte',7882.0,45.12,-12.7).
city('Bandrele','yt','Mayotte',6352.0,45.19,-12.91).
city('Boueni','yt','Mayotte',5335.0,45.08,-12.9).
city('Chiconi','yt','Mayotte',7205.0,45.11,-12.83).
city('Chirongui','yt','Mayotte',6174.0,45.15,-12.93).
city('Dembeni','yt','Mayotte',8638.0,45.19,-12.84).
city('Kanikeli','yt','Mayotte',4855.0,45.1,-12.95).
city('Koungou','yt','Mayotte',18121.0,45.2,-12.72).
city('Mamoudzou','yt','Mayotte',54837.0,45.2,-12.78).
city('Mtsamboro','yt','Mayotte',7725.0,45.07,-12.7).
city('Mtsangamouji','yt','Mayotte',6108.0,45.08,-12.76).
city('Ouangani','yt','Mayotte',7273.0,45.14,-12.85).
city('Sada','yt','Mayotte',9834.0,45.12,-12.85).
city('Tsingoni','yt','Mayotte',7603.0,45.1,-12.79).
city('Dzaoudzi','yt','Pamanzi',14144.0,45.25,-12.77).
city('Pamanzi','yt','Pamanzi',9074.0,45.27,-12.79).
city('Aguascalientes','mx','Aguascalientes',658193.0,-102.3,21.88).
city('Asientos','mx','Aguascalientes',4039.0,-102.1,22.23).
city('Calvillo','mx','Aguascalientes',19663.0,-102.72,21.85).
city('Cosio','mx','Aguascalientes',4591.0,-102.3,22.37).
city('Margaritas','mx','Aguascalientes',8579.0,-102.3,22.0).
city('Ojocaliente','mx','Aguascalientes',6677.0,-102.67,21.87).
city('Pabellon de Arteaga','mx','Aguascalientes',26460.0,-102.4,22.17).
city('Pabellon de Hidalgo','mx','Aguascalientes',4246.0,-102.35,22.17).
city('Palo Alto','mx','Aguascalientes',4610.0,-101.97,21.92).
city('Rincon de Romos','mx','Aguascalientes',24683.0,-102.33,22.24).
city('San Francisco de los Romo','mx','Aguascalientes',11589.0,-102.28,22.07).
city('San Jose de Gracia','mx','Aguascalientes',4226.0,-102.42,22.15).
city('Tepezala','mx','Aguascalientes',3868.0,-102.17,22.22).
city('Villa Juarez','mx','Aguascalientes',4330.0,-102.07,22.12).
city('Cabo San Lucas','mx','Baja California Sur',42601.0,-109.9,22.88).
city('Constitucion','mx','Baja California Sur',39915.0,-111.66,25.04).
city('Guerrero Negro','mx','Baja California Sur',11479.0,-114.17,27.99).
city('Insurgentes','mx','Baja California Sur',8584.0,-111.78,25.26).
city('La Paz','mx','Baja California Sur',171490.0,-110.32,24.14).
city('Loreto','mx','Baja California Sur',11227.0,-111.35,26.02).
city('Los Cabos','mx','Baja California Sur',34883.0,-109.73,23.16).
city('Mulege','mx','Baja California Sur',3851.0,-111.96,26.9).
city('Santa Rosalia','mx','Baja California Sur',11899.0,-112.28,27.32).
city('Todos Santos','mx','Baja California Sur',4419.0,-110.22,23.45).
city('Algodones','mx','Baja California',4874.0,-114.73,32.71).
city('Camalu','mx','Baja California',7425.0,-116.07,30.85).
city('Cuervos','mx','Baja California',8481.0,-114.87,32.63).
city('Delta','mx','Baja California',5698.0,-115.19,32.36).
city('Ejido Hermosillo','mx','Baja California',6399.0,-114.92,32.51).
city('El Sauzal','mx','Baja California',9085.0,-116.68,31.9).
city('Ensenada','mx','Baja California',256577.0,-116.62,31.87).
city('Estacion Coahuila','mx','Baja California',7596.0,-115.0,32.19).
city('Guadalupe Victoria','mx','Baja California',18244.0,-115.11,32.29).
city('La Joya','mx','Baja California',19024.0,-117.01,32.44).
city('Lazaro Cardenas','mx','Baja California',14226.0,-115.74,31.41).
city('Maneadero','mx','Baja California',17861.0,-116.57,31.72).
city('Mexicali','mx','Baja California',597124.0,-115.47,32.65).
city('Primo Tapia','mx','Baja California',5039.0,-116.92,32.22).
city('Progreso','mx','Baja California',5231.0,-115.58,32.58).
city('Puebla','mx','Baja California',8700.0,-115.35,32.56).
city('Reacomodo','mx','Baja California',8064.0,-115.17,32.23).
city('Rosarito','mx','Baja California',66023.0,-117.03,32.33).
city('San Felipe','mx','Baja California',15386.0,-114.85,31.02).
city('San Luis','mx','Baja California',7872.0,-113.75,28.43).
city('San Quintin','mx','Baja California',5433.0,-115.95,30.48).
city('Santa Isabel','mx','Baja California',21152.0,-113.35,28.38).
city('Tecate','mx','Baja California',58303.0,-116.63,32.57).
city('Tecolotes','mx','Baja California',5259.0,-114.98,32.58).
city('Tijuana','mx','Baja California',1376494.0,-117.02,32.53).
city('Vicente Guerrero','mx','Baja California',12829.0,-116.01,30.77).
city('Becal','mx','Campeche',6894.0,-90.03,20.45).
city('Bolonchen','mx','Campeche',3913.0,-90.17,19.45).
city('Calkini','mx','Campeche',14195.0,-90.05,20.37).
city('Campeche','mx','Campeche',205221.0,-90.53,19.85).
city('Candelaria','mx','Campeche',8652.0,-91.05,18.17).
city('Carmen','mx','Campeche',141315.0,-91.83,18.63).
city('Champoton','mx','Campeche',24809.0,-90.72,19.35).
city('China','mx','Campeche',4583.0,-90.5,19.77).
city('Dzitbalche','mx','Campeche',10902.0,-90.05,20.32).
city('Escarcega','mx','Campeche',28165.0,-90.74,18.62).
city('Hecelchakan','mx','Campeche',10153.0,-90.13,20.17).
city('Hopelchen','mx','Campeche',7021.0,-89.85,19.77).
city('Isla Aguada','mx','Campeche',4440.0,-91.47,18.78).
city('Nunkini','mx','Campeche',5556.0,-90.18,20.33).
city('Palizada','mx','Campeche',3169.0,-92.08,18.25).
city('Pomuch','mx','Campeche',7838.0,-90.18,20.13).
city('Sabancuy','mx','Campeche',6290.0,-91.18,18.97).
city('Seybaplaya','mx','Campeche',8884.0,-90.67,19.65).
city('Tenabo','mx','Campeche',6814.0,-90.23,20.05).
city('Acacoyagua','mx','Chiapas',6202.0,-92.65,15.35).
city('Acala','mx','Chiapas',12954.0,-92.8,16.57).
city('Acapetahua','mx','Chiapas',6115.0,-92.7,15.28).
city('Altamirano','mx','Chiapas',6672.0,-92.15,16.88).
city('Alvaro Obregon','mx','Chiapas',4979.0,-92.42,14.93).
city('Amatan','mx','Chiapas',3742.0,-92.75,17.35).
city('Amatenango del Valle','mx','Chiapas',3632.0,-92.43,16.51).
city('Arriaga','mx','Chiapas',22820.0,-93.9,16.23).
city('Benemerito de las Americas','mx','Chiapas',6676.0,-90.65,16.52).
city('Berriozabal','mx','Chiapas',20952.0,-93.27,16.8).
city('Bochil','mx','Chiapas',10383.0,-92.92,16.98).
city('Cacahoatan','mx','Chiapas',14404.0,-92.17,14.98).
city('Cancuc','mx','Chiapas',4970.0,-92.48,16.92).
city('Catazaja','mx','Chiapas',3223.0,-92.02,17.75).
city('Chalchihiutan','mx','Chiapas',1138.0,-92.67,17.0).
city('Chanal','mx','Chiapas',5592.0,-92.4,16.72).
city('Chiapa','mx','Chiapas',32183.0,-93.02,16.71).
city('Chiapilla','mx','Chiapas',4141.0,-92.73,16.52).
city('Chicomuselo','mx','Chiapas',4956.0,-92.3,15.74).
city('Chilon','mx','Chiapas',5228.0,-92.42,17.23).
city('Cintalapa','mx','Chiapas',33465.0,-93.72,16.73).
city('Comaltitlan','mx','Chiapas',7944.0,-92.58,15.22).
city('Comitan','mx','Chiapas',79947.0,-92.13,16.25).
city('Copainala','mx','Chiapas',6365.0,-93.2,17.08).
city('Copoya','mx','Chiapas',5287.0,-93.08,16.72).
city('Cristobal Obregon','mx','Chiapas',4242.0,-93.53,16.35).
city('El Bosque','mx','Chiapas',4158.0,-92.73,17.07).
city('Escuintla','mx','Chiapas',8989.0,-92.63,15.33).
city('Frontera Comalapa','mx','Chiapas',14917.0,-92.14,15.66).
city('Frontera Corozal','mx','Chiapas',4499.0,-94.07,16.32).
city('Frontera Hidalgo','mx','Chiapas',3364.0,-92.17,14.78).
city('Huehuetan','mx','Chiapas',7265.0,-92.39,15.04).
city('Huehuetan Estacion','mx','Chiapas',5991.0,-92.38,15.03).
city('Huixtla','mx','Chiapas',29257.0,-92.47,15.15).
city('Ixhuatan','mx','Chiapas',3392.0,-93.03,17.28).
city('Ixtacomitan','mx','Chiapas',4478.0,-93.1,17.42).
city('Ixtapa','mx','Chiapas',4559.0,-92.92,16.8).
city('Jaltenango','mx','Chiapas',8880.0,-92.72,15.92).
city('Jesus Maria Garza','mx','Chiapas',6189.0,-93.36,17.54).
city('Jiquipilas','mx','Chiapas',8951.0,-93.64,16.66).
city('Jitotol','mx','Chiapas',3278.0,-92.87,17.03).
city('Juarez','mx','Chiapas',6839.0,-93.17,17.65).
city('La Concordia','mx','Chiapas',7423.0,-92.74,16.17).
city('La Libertad','mx','Chiapas',4393.0,-92.19,14.59).
city('La Trinitaria','mx','Chiapas',6655.0,-92.05,16.12).
city('Las Margaritas','mx','Chiapas',16201.0,-91.98,16.32).
city('Las Rosas','mx','Chiapas',16752.0,-92.37,16.37).
city('Mapastepec','mx','Chiapas',16082.0,-92.9,15.43).
city('Mazatan','mx','Chiapas',5938.0,-92.45,14.87).
city('Motozintla','mx','Chiapas',19092.0,-92.23,15.37).
city('Nicolas Ruiz','mx','Chiapas',3268.0,-92.53,16.4).
city('Ocosingo','mx','Chiapas',28721.0,-92.25,17.07).
city('Ocotepec','mx','Chiapas',4251.0,-93.15,17.22).
city('Ocozocoautla','mx','Chiapas',31597.0,-93.37,16.77).
city('Ostuacan','mx','Chiapas',3183.0,-93.3,17.42).
city('Oxchuc','mx','Chiapas',3421.0,-92.42,16.85).
city('Palenque','mx','Chiapas',36670.0,-91.97,17.52).
city('Palestina','mx','Chiapas',8069.0,-92.75,15.8).
city('Pantelho','mx','Chiapas',6124.0,-92.55,16.93).
city('Paredon','mx','Chiapas',6337.0,-93.87,16.03).
city('Petalcingo','mx','Chiapas',6274.0,-92.45,17.28).
city('Pichucalco','mx','Chiapas',14220.0,-93.07,17.52).
city('Pijijiapan','mx','Chiapas',15101.0,-93.22,15.69).
city('Pueblo Nuevo Solistahuacan','mx','Chiapas',7769.0,-92.88,17.1).
city('Puerto Madero','mx','Chiapas',9652.0,-92.42,14.73).
city('Pujiltic','mx','Chiapas',7088.0,-92.77,16.11).
city('Raudales Malpaso','mx','Chiapas',6995.0,-92.24,14.99).
city('Rayon','mx','Chiapas',4643.0,-93.0,17.2).
city('Reforma','mx','Chiapas',24884.0,-91.02,18.1).
city('Rincon Chamula','mx','Chiapas',4303.0,-93.44,16.42).
city('Salto de Agua','mx','Chiapas',4864.0,-92.37,17.62).
city('San Cristobal de las Casas','mx','Chiapas',129001.0,-92.63,16.75).
city('San Fernando','mx','Chiapas',9024.0,-93.22,16.87).
city('San Lucas','mx','Chiapas',4494.0,-92.72,16.6).
city('San Pedro Buenavista','mx','Chiapas',8390.0,-93.12,16.08).
city('Simojovel','mx','Chiapas',8510.0,-92.63,17.2).
city('Socoltenango','mx','Chiapas',4843.0,-92.25,16.22).
city('Soyalo','mx','Chiapas',3442.0,-92.92,16.9).
city('Suchiapa','mx','Chiapas',13282.0,-93.08,16.62).
city('Suchiate','mx','Chiapas',13743.0,-92.22,14.55).
city('Tapachula','mx','Chiapas',197968.0,-92.27,14.91).
city('Tapilula','mx','Chiapas',6432.0,-93.03,17.23).
city('Tecpatan','mx','Chiapas',4569.0,-93.3,17.13).
city('Tenango','mx','Chiapas',4633.0,-92.42,16.97).
city('Teopisca','mx','Chiapas',12096.0,-92.48,16.52).
city('Tila','mx','Chiapas',6089.0,-92.47,17.39).
city('Tonala','mx','Chiapas',32856.0,-93.77,16.08).
city('Totolapa','mx','Chiapas',4267.0,-92.68,16.6).
city('Tres Picos','mx','Chiapas',4881.0,-93.53,15.87).
city('Tuxtla Chico','mx','Chiapas',7287.0,-92.17,14.95).
city('Tuxtla Gutierrez','mx','Chiapas',481143.0,-93.12,16.75).
city('Tzimol','mx','Chiapas',4178.0,-92.27,16.27).
city('Veinte de Noviembre','mx','Chiapas',4309.0,-92.25,14.99).
city('Venustiano Carranza','mx','Chiapas',15074.0,-92.55,16.35).
city('Villa Corzo','mx','Chiapas',9123.0,-93.27,16.17).
city('Villaflores','mx','Chiapas',34210.0,-93.23,16.23).
city('Yajalon','mx','Chiapas',14763.0,-92.33,17.23).
city('Zinacantan','mx','Chiapas',3742.0,-92.72,16.76).
city('Adolfo Lopez Mateos','mx','Chihuahua',8770.0,-107.3,28.47).
city('Ahumada','mx','Chihuahua',9326.0,-106.51,30.61).
city('Anahuac','mx','Chihuahua',10696.0,-106.75,28.5).
city('Ascension','mx','Chihuahua',11781.0,-107.98,31.1).
city('Benito Juarez','mx','Chihuahua',6138.0,-107.93,29.75).
city('Camargo','mx','Chihuahua',37745.0,-105.17,27.69).
city('Carichi','mx','Chihuahua',1339.0,-107.0,28.07).
city('Casas Grandes','mx','Chihuahua',4124.0,-107.95,30.37).
city('Chihuahua','mx','Chihuahua',708292.0,-106.08,28.63).
city('Creel','mx','Chihuahua',5011.0,-107.63,27.75).
city('Cuauhtemoc','mx','Chihuahua',90839.0,-106.87,28.42).
city('Delicias','mx','Chihuahua',102974.0,-105.47,28.19).
city('El Largo','mx','Chihuahua',4964.0,-108.27,29.68).
city('Guachochi','mx','Chihuahua',10449.0,-107.09,26.82).
city('Guadalupe','mx','Chihuahua',5169.0,-92.17,15.7).
city('Guadalupe y Calvo','mx','Chihuahua',3230.0,-106.97,26.09).
city('Hidalgo','mx','Chihuahua',101772.0,-105.67,26.93).
city('Ignacio Zaragoza','mx','Chihuahua',3455.0,-107.22,28.38).
city('Jimenez','mx','Chihuahua',31055.0,-105.4,28.33).
city('Juarez','mx','Chihuahua',1403025.0,-106.49,31.74).
city('Lazaro Cardenas','mx','Chihuahua',8161.0,-105.62,28.38).
city('Madera','mx','Chihuahua',16087.0,-108.14,29.19).
city('Majimachi','mx','Chihuahua',10165.0,-107.32,30.41).
city('Meoqui','mx','Chihuahua',21179.0,-105.48,28.27).
city('Naica','mx','Chihuahua',5494.0,-105.48,27.85).
city('Nuevo Casas Grandes','mx','Chihuahua',51358.0,-107.92,30.42).
city('Ojinaga','mx','Chihuahua',22128.0,-104.41,29.56).
city('Praxedis Guerrero','mx','Chihuahua',3787.0,-106.02,31.37).
city('Puerto Palomas','mx','Chihuahua',5659.0,-107.62,31.77).
city('San Buenaventura','mx','Chihuahua',6168.0,-107.48,29.85).
city('San Francisco el Oro','mx','Chihuahua',5621.0,-105.84,26.88).
city('Santa Barbara','mx','Chihuahua',10800.0,-105.82,26.8).
city('Santa Cruz de Rosales','mx','Chihuahua',5217.0,-105.55,28.2).
city('Saucillo','mx','Chihuahua',10595.0,-105.28,28.02).
city('Valentin Gomez Farias','mx','Chihuahua',5404.0,-106.58,28.22).
city('Va','mx','Chihuahua',4198.0,-105.42,26.91).
city('Vicente Guerrero','mx','Chihuahua',6876.0,-92.2,14.85).
city('Acuna','mx','Coahuila',144703.0,-100.94,29.32).
city('Allende','mx','Coahuila',19636.0,-100.85,28.33).
city('Arteaga','mx','Coahuila',6352.0,-100.85,25.47).
city('Castanos','mx','Coahuila',20809.0,-101.43,26.78).
city('Concordia','mx','Coahuila',6964.0,-103.12,25.78).
city('Cuatrocienagas','mx','Coahuila',9364.0,-102.07,26.99).
city('El Coyote','mx','Coahuila',8856.0,-103.28,25.7).
city('Frontera','mx','Coahuila',64979.0,-101.45,26.93).
city('General Cepeda','mx','Coahuila',3916.0,-101.45,25.38).
city('Hercules','mx','Coahuila',3711.0,-103.8,28.02).
city('Matamoros','mx','Coahuila',46284.0,-103.23,25.54).
city('Minas de Barroteran','mx','Coahuila',8482.0,-101.28,27.63).
city('Monclova','mx','Coahuila',195772.0,-101.42,26.91).
city('Muzquiz','mx','Coahuila',32804.0,-101.52,27.88).
city('Nadadores','mx','Coahuila',4501.0,-101.6,27.02).
city('Nava','mx','Coahuila',18639.0,-100.77,28.42).
city('Nueva Rosita','mx','Coahuila',36644.0,-101.22,27.95).
city('Ocampo','mx','Coahuila',2951.0,-102.4,27.32).
city('Palau','mx','Coahuila',16904.0,-101.42,27.92).
city('Parras','mx','Coahuila',32255.0,-102.18,25.42).
city('Piedras Negras','mx','Coahuila',139624.0,-100.53,28.71).
city('Ramos Arizpe','mx','Coahuila',38260.0,-100.96,25.53).
city('Sabinas','mx','Coahuila',49201.0,-101.12,27.86).
city('Saltillo','mx','Coahuila',621270.0,-101.0,25.42).
city('San Buenaventura','mx','Coahuila',18822.0,-101.53,27.08).
city('San Pedro','mx','Coahuila',41167.0,-103.22,25.43).
city('Torreon','mx','Coahuila',524084.0,-103.43,25.55).
city('Venustiano Carranza','mx','Coahuila',4288.0,-102.95,25.35).
city('Viesca','mx','Coahuila',3673.0,-102.8,25.35).
city('Villa Madero','mx','Coahuila',26296.0,-103.27,25.77).
city('Villa Union','mx','Coahuila',5147.0,-100.72,28.22).
city('Zaragoza','mx','Coahuila',10577.0,-100.92,28.48).
city('Armeria','mx','Colima',16953.0,-103.97,18.93).
city('Cofradia','mx','Colima',6495.0,-103.55,19.43).
city('Colima','mx','Colima',127239.0,-103.73,19.24).
city('Comala','mx','Colima',9117.0,-103.75,19.32).
city('Coquimatlan','mx','Colima',13061.0,-103.8,19.2).
city('Cuauhtemoc','mx','Colima',8986.0,-103.62,19.32).
city('El Colomo','mx','Colima',10908.0,-104.25,19.05).
city('Madrid','mx','Colima',4411.0,-103.87,19.08).
city('Manzanillo','mx','Colima',110738.0,-104.32,19.05).
city('Minatitlan','mx','Colima',4691.0,-104.07,19.37).
city('Queseria','mx','Colima',8959.0,-103.58,19.37).
city('Suchitlan','mx','Colima',4190.0,-103.72,19.37).
city('Tecoman','mx','Colima',79582.0,-103.88,18.92).
city('Villa de Alvarez','mx','Colima',95066.0,-103.75,19.27).
city('Mexico City','mx','Distrito Federal',8657045.0,-99.14,19.43).
city('Bermejillo','mx','Durango',7692.0,-103.62,25.88).
city('Canatlan','mx','Durango',10342.0,-104.78,24.52).
city('Cuencame','mx','Durango',8876.0,-103.7,24.87).
city('Durango','mx','Durango',457154.0,-104.67,24.03).
city('Gomez Palacio','mx','Durango',228585.0,-103.5,25.57).
city('Guadalupe Victoria','mx','Durango',14269.0,-104.12,24.45).
city('Juarez','mx','Durango',6210.0,-104.03,24.82).
city('Lerdo','mx','Durango',63533.0,-103.53,25.53).
city('Mapimi','mx','Durango',4548.0,-103.85,25.82).
city('Nazareno','mx','Durango',6332.0,-103.42,25.38).
city('Nazas','mx','Durango',3346.0,-104.13,25.23).
city('Nombre de Dios','mx','Durango',4556.0,-104.23,23.85).
city('Nuevo Ideal','mx','Durango',8623.0,-105.07,24.89).
city('Ocampo','mx','Durango',1280.0,-105.52,26.45).
city('Panuco','mx','Durango',4727.0,-104.33,24.53).
city('Papasquiaro','mx','Durango',22751.0,-105.34,24.83).
city('Penon Blanco','mx','Durango',5014.0,-104.04,24.79).
city('Poanas','mx','Durango',10249.0,-103.62,25.77).
city('Pueblo Nuevo','mx','Durango',19363.0,-105.38,23.38).
city('Rodeo','mx','Durango',3846.0,-104.57,25.18).
city('Santa Catarina de Tepehuanes','mx','Durango',4800.0,-105.73,25.35).
city('Santa Clara','mx','Durango',3953.0,-103.36,24.48).
city('Santa Maria del Oro','mx','Durango',5710.0,-105.37,25.93).
city('Suchil','mx','Durango',4095.0,-103.83,23.62).
city('Tayoltita','mx','Durango',3742.0,-105.93,24.08).
city('Tlahualilo','mx','Durango',8588.0,-103.45,26.12).
city('Vicente Guerrero','mx','Durango',14559.0,-103.98,23.75).
city('Abasolo','mx','Guanajuato',25821.0,-101.52,20.45).
city('Acambaro','mx','Guanajuato',56265.0,-100.73,20.03).
city('Aldama','mx','Guanajuato',4044.0,-101.32,20.82).
city('Allende','mx','Guanajuato',66314.0,-100.76,20.92).
city('Apaseo el Alto','mx','Guanajuato',25577.0,-100.62,20.45).
city('Apaseo el Grande','mx','Guanajuato',22636.0,-100.7,20.57).
city('Celaya','mx','Guanajuato',305913.0,-100.82,20.52).
city('Cerano','mx','Guanajuato',7860.0,-101.38,20.12).
city('Cerro Gordo','mx','Guanajuato',4714.0,-101.13,20.58).
city('Colonias Nuevo Mexico','mx','Guanajuato',4425.0,-101.48,20.99).
city('Comonfort','mx','Guanajuato',22300.0,-100.77,20.72).
city('Coroneo','mx','Guanajuato',3177.0,-100.33,20.13).
city('Cortazar','mx','Guanajuato',56363.0,-100.97,20.49).
city('Cueramaro','mx','Guanajuato',13937.0,-101.72,20.62).
city('Doctor Mora','mx','Guanajuato',4431.0,-100.29,21.15).
city('Dolores Hidalgo','mx','Guanajuato',55140.0,-100.93,21.17).
city('Duarte','mx','Guanajuato',59.0,-101.52,21.08).
city('Escobedo','mx','Guanajuato',12968.0,-100.73,20.68).
city('Guanajuato','mx','Guanajuato',78368.0,-101.28,21.02).
city('Huanimaro','mx','Guanajuato',4965.0,-101.5,20.37).
city('Iramuco','mx','Guanajuato',6559.0,-100.92,19.95).
city('Irapuato','mx','Guanajuato',339568.0,-101.36,20.68).
city('Jaral del Progreso','mx','Guanajuato',17748.0,-101.07,20.37).
city('Jerecuaro','mx','Guanajuato',7050.0,-100.52,20.15).
city('Juventino Rosas','mx','Guanajuato',38199.0,-101.0,20.65).
city('La Aldea','mx','Guanajuato',5171.0,-101.0,20.9).
city('La Calera','mx','Guanajuato',5570.0,-101.32,20.78).
city('La Ermita','mx','Guanajuato',5054.0,-101.98,20.4).
city('La Moncada','mx','Guanajuato',4730.0,-100.8,20.27).
city('Leon','mx','Guanajuato',1114662.0,-101.69,21.12).
city('Manuel Doblado','mx','Guanajuato',13218.0,-101.93,20.73).
city('Maravatio','mx','Guanajuato',3955.0,-100.97,20.2).
city('Marfil','mx','Guanajuato',15241.0,-101.28,21.0).
city('Medina','mx','Guanajuato',6997.0,-101.62,21.15).
city('Moroleon','mx','Guanajuato',40064.0,-101.2,20.13).
city('Ocampo','mx','Guanajuato',6534.0,-101.5,21.65).
city('Octopan','mx','Guanajuato',12054.0,-100.73,20.57).
city('Pacueco','mx','Guanajuato',10856.0,-102.0,20.37).
city('Paracuaro','mx','Guanajuato',5389.0,-100.77,20.15).
city('Penjamo','mx','Guanajuato',33510.0,-101.73,20.43).
city('Plan de Ayala','mx','Guanajuato',4782.0,-101.1,21.43).
city('Pueblo Nuevo','mx','Guanajuato',3814.0,-101.37,20.52).
city('Purisima de Bustos','mx','Guanajuato',26602.0,-101.05,20.63).
city('Rincon de Tamayo','mx','Guanajuato',10015.0,-100.75,20.42).
city('Romita','mx','Guanajuato',19351.0,-101.52,20.87).
city('Salamanca','mx','Guanajuato',138620.0,-101.2,20.57).
city('Salvatierra','mx','Guanajuato',32973.0,-100.88,20.22).
city('San Bartolo de Berrios','mx','Guanajuato',4454.0,-101.07,21.62).
city('San Cristobal','mx','Guanajuato',3989.0,-101.47,20.65).
city('San Diego de la Union','mx','Guanajuato',6072.0,-100.87,21.47).
city('San Felipe','mx','Guanajuato',26073.0,-101.22,21.48).
city('San Francisco del Rincon','mx','Guanajuato',66951.0,-101.86,21.02).
city('San Jose Iturbide','mx','Guanajuato',16702.0,-100.38,21.0).
city('San Jos','mx','Guanajuato',4827.0,-101.27,20.68).
city('San Juan de la Vega','mx','Guanajuato',14209.0,-100.77,20.63).
city('San Luis de la Paz','mx','Guanajuato',47323.0,-100.52,21.3).
city('San Nicolas de los Agustinos','mx','Guanajuato',6726.0,-101.04,20.27).
city('San Pedro de los Naranjos','mx','Guanajuato',4126.0,-100.99,20.25).
city('San Roque','mx','Guanajuato',4875.0,-101.85,20.97).
city('Santa Teresa','mx','Guanajuato',4813.0,-101.32,20.95).
city('Santiago de Cuenda','mx','Guanajuato',5012.0,-100.98,20.6).
city('Sarabia','mx','Guanajuato',5091.0,-101.07,20.52).
city('Silao','mx','Guanajuato',65198.0,-101.43,20.93).
city('Tarandacuao','mx','Guanajuato',7256.0,-100.53,20.0).
city('Tarimoro','mx','Guanajuato',12677.0,-100.75,20.28).
city('Teneria del Santuario','mx','Guanajuato',4145.0,-100.77,20.58).
city('Uriangato','mx','Guanajuato',49747.0,-101.18,20.15).
city('Valle de Santiago','mx','Guanajuato',60531.0,-101.2,20.38).
city('Valtierrilla','mx','Guanajuato',11970.0,-101.13,20.53).
city('Victoria','mx','Guanajuato',4053.0,-100.22,21.21).
city('Villagran','mx','Guanajuato',24155.0,-100.98,20.52).
city('Yerbabuena','mx','Guanajuato',4378.0,-101.27,20.97).
city('Yuriria','mx','Guanajuato',21776.0,-101.13,20.21).
city('Acamixtla','mx','Guerrero',4866.0,-99.58,18.57).
city('Acapulco','mx','Guerrero',652160.0,-99.92,16.85).
city('Acatlan','mx','Guerrero',7249.0,-98.73,16.81).
city('Ajuchitlan','mx','Guerrero',6329.0,-100.48,18.15).
city('Alpoyeca','mx','Guerrero',3284.0,-98.52,17.67).
city('Altamirano','mx','Guerrero',24533.0,-100.65,18.32).
city('Apango','mx','Guerrero',3863.0,-99.33,17.73).
city('Apaxtla','mx','Guerrero',7413.0,-99.87,18.15).
city('Arcelia','mx','Guerrero',16940.0,-100.27,18.28).
city('Atliaca','mx','Guerrero',6766.0,-99.37,17.65).
city('Atoyac','mx','Guerrero',20515.0,-100.43,17.2).
city('Ayutla','mx','Guerrero',9897.0,-99.22,16.9).
city('Azoyu','mx','Guerrero',4462.0,-98.73,16.72).
city('Bajos de Ejido','mx','Guerrero',5637.0,-99.97,16.95).
city('Buenavista','mx','Guerrero',7170.0,-99.42,18.45).
city('Chichihualco','mx','Guerrero',10391.0,-99.65,17.68).
city('Chilapa','mx','Guerrero',23665.0,-99.17,17.6).
city('Chilpancingo','mx','Guerrero',165257.0,-99.5,17.55).
city('Coacoyul','mx','Guerrero',5658.0,-101.43,17.62).
city('Cocula','mx','Guerrero',4546.0,-99.67,18.23).
city('Copala','mx','Guerrero',6875.0,-98.98,16.65).
city('Copalillo','mx','Guerrero',5993.0,-99.12,18.03).
city('Coyuca','mx','Guerrero',9740.0,-100.35,17.68).
city('Cruz Grande','mx','Guerrero',9876.0,-99.13,16.73).
city('Cuajinicuilapa','mx','Guerrero',9390.0,-98.42,16.47).
city('Cuautepec','mx','Guerrero',3483.0,-99.0,16.7).
city('Cutzamala','mx','Guerrero',5057.0,-100.57,18.47).
city('El Ocotito','mx','Guerrero',5983.0,-99.57,17.25).
city('El Paraiso','mx','Guerrero',4752.0,-100.85,18.18).
city('Huamuxtitlan','mx','Guerrero',5921.0,-98.57,17.82).
city('Huitziltepec','mx','Guerrero',4419.0,-99.47,17.82).
city('Huitzuco','mx','Guerrero',16238.0,-99.35,18.3).
city('Iguala','mx','Guerrero',112111.0,-99.54,18.37).
city('Ixtapa','mx','Guerrero',5207.0,-101.65,17.67).
city('La Loma','mx','Guerrero',5248.0,-100.91,17.27).
city('La Union','mx','Guerrero',3189.0,-101.82,17.97).
city('Las Petaquillas','mx','Guerrero',6033.0,-99.47,17.48).
city('Marquelia','mx','Guerrero',6874.0,-98.81,16.58).
city('Mazatlan','mx','Guerrero',4948.0,-99.48,17.45).
city('Mochitlan','mx','Guerrero',4387.0,-99.4,17.47).
city('Olinala','mx','Guerrero',5452.0,-98.85,17.83).
city('Ometepec','mx','Guerrero',17801.0,-98.42,16.68).
city('Petatlan','mx','Guerrero',21038.0,-101.27,17.52).
city('Pilcaya','mx','Guerrero',4718.0,-99.67,18.73).
city('Quechultenango','mx','Guerrero',5112.0,-99.22,17.42).
city('San Jeronimito','mx','Guerrero',6385.0,-101.33,17.55).
city('San Jeronimo','mx','Guerrero',7326.0,-100.47,17.13).
city('San Jose Ixtapa','mx','Guerrero',5868.0,-99.58,18.52).
city('San Marcos','mx','Guerrero',12278.0,-99.35,16.8).
city('Taxco','mx','Guerrero',53219.0,-99.62,18.57).
city('Tecoanapa','mx','Guerrero',3675.0,-98.75,16.52).
city('Tecpan','mx','Guerrero',14638.0,-100.68,17.25).
city('Teloloapan','mx','Guerrero',21244.0,-99.85,18.35).
city('Tepecoacuilco','mx','Guerrero',5922.0,-99.48,18.3).
city('Tierra Colorada','mx','Guerrero',10202.0,-99.58,17.17).
city('Tixtla','mx','Guerrero',21130.0,-99.43,17.58).
city('Tlacoachistlahuaca','mx','Guerrero',3828.0,-98.3,16.82).
city('Tlacotepec','mx','Guerrero',6513.0,-99.98,17.77).
city('Tlalchapa','mx','Guerrero',4183.0,-100.47,18.4).
city('Tlamacazapa','mx','Guerrero',5168.0,-99.5,18.51).
city('Tlapa','mx','Guerrero',36875.0,-98.59,17.55).
city('Tlapehuala','mx','Guerrero',8651.0,-100.52,18.22).
city('Totolapan','mx','Guerrero',4064.0,-100.4,18.13).
city('Tres Palos','mx','Guerrero',4764.0,-101.62,18.18).
city('Xalpatlahuac','mx','Guerrero',4054.0,-98.62,17.47).
city('Xaltianguis','mx','Guerrero',6933.0,-99.83,17.07).
city('Xochihuehuetlan','mx','Guerrero',5158.0,-98.43,17.92).
city('Xochistlahuaca','mx','Guerrero',3566.0,-98.25,16.78).
city('Zacualpan','mx','Guerrero',4100.0,-100.33,17.08).
city('Zihuatanejo','mx','Guerrero',61310.0,-101.57,17.63).
city('Zirandaro','mx','Guerrero',3663.0,-100.98,18.45).
city('Zitlala','mx','Guerrero',4974.0,-99.08,17.63).
city('Zumpango','mx','Guerrero',21143.0,-99.5,17.65).
city('Acaxochitlan','mx','Hidalgo',3746.0,-98.2,20.17).
city('Acayuca','mx','Hidalgo',7276.0,-98.83,20.03).
city('Actopan','mx','Hidalgo',26706.0,-98.93,20.27).
city('Ajacuba','mx','Hidalgo',6590.0,-99.11,20.09).
city('Almoloya','mx','Hidalgo',4217.0,-98.4,19.7).
city('Apan','mx','Hidalgo',26386.0,-98.42,19.72).
city('Atengo','mx','Hidalgo',7806.0,-99.33,20.17).
city('Atitalaquia','mx','Hidalgo',5806.0,-99.22,20.07).
city('Atotonilco de Tula','mx','Hidalgo',7330.0,-99.2,20.01).
city('Atotonilco el Grande','mx','Hidalgo',6871.0,-98.67,20.28).
city('Calnali','mx','Hidalgo',3600.0,-98.58,20.92).
city('Cardonal','mx','Hidalgo',6398.0,-99.12,20.62).
city('Chapulhuacan','mx','Hidalgo',3501.0,-98.9,21.17).
city('Cuautepec','mx','Hidalgo',16543.0,-98.3,20.03).
city('Doxey','mx','Hidalgo',6339.0,-99.23,20.08).
city('El Arenal','mx','Hidalgo',3318.0,-98.9,20.23).
city('El Llano','mx','Hidalgo',11794.0,-99.3,20.05).
city('Emiliano Zapata','mx','Hidalgo',8555.0,-98.53,19.67).
city('Huautla','mx','Hidalgo',3407.0,-98.28,21.03).
city('Huejutla','mx','Hidalgo',38491.0,-98.42,21.13).
city('Hueytlalpan','mx','Hidalgo',5715.0,-98.3,20.18).
city('Huichapan','mx','Hidalgo',8035.0,-99.65,20.38).
city('Ixmiquilpan','mx','Hidalgo',32475.0,-99.23,20.48).
city('Jacala','mx','Hidalgo',3908.0,-99.18,21.02).
city('Jaltocan','mx','Hidalgo',5641.0,-98.53,21.15).
city('Los Reyes','mx','Hidalgo',3681.0,-98.17,20.15).
city('Mineral del Monte','mx','Hidalgo',10790.0,-98.67,20.13).
city('Mixquiahuala','mx','Hidalgo',22610.0,-99.22,20.23).
city('Molango','mx','Hidalgo',3929.0,-98.72,20.78).
city('Orizatlan','mx','Hidalgo',6488.0,-98.62,21.18).
city('Pachuca','mx','Hidalgo',319593.0,-98.76,20.12).
city('Pachuquilla','mx','Hidalgo',3338.0,-98.7,20.07).
city('Progreso','mx','Hidalgo',16548.0,-99.2,20.25).
city('Sahagun','mx','Hidalgo',28648.0,-98.58,19.77).
city('San Juan Tepa','mx','Hidalgo',5139.0,-99.07,20.22).
city('San Marcos','mx','Hidalgo',10961.0,-99.33,20.07).
city('Singuilucan','mx','Hidalgo',3627.0,-98.52,19.97).
city('Tasquillo','mx','Hidalgo',3583.0,-99.3,20.55).
city('Tecozautla','mx','Hidalgo',5251.0,-99.63,20.53).
city('Tepatepec','mx','Hidalgo',10032.0,-99.08,20.23).
city('Tepeapulco','mx','Hidalgo',14935.0,-98.55,19.78).
city('Tepeji','mx','Hidalgo',33198.0,-99.34,19.91).
city('Tepepa','mx','Hidalgo',4512.0,-98.18,20.13).
city('Tetepango','mx','Hidalgo',7289.0,-99.17,20.1).
city('Tezontepec','mx','Hidalgo',15441.0,-98.83,19.89).
city('Tizayuca','mx','Hidalgo',39325.0,-98.98,19.83).
city('Tlahuelilpan','mx','Hidalg',8137.0,-99.23,20.13).
city('Tlanalapa','mx','Hidalgo',7511.0,-98.6,19.83).
city('Tlanchinol','mx','Hidalgo',4180.0,-98.65,20.98).
city('Tlaxcoapan','mx','Hidalgo',12772.0,-99.22,20.08).
city('Tlaxiaca','mx','Hidalgo',8788.0,-98.88,20.12).
city('Tolcayuca','mx','Hidalgo',5964.0,-98.92,19.95).
city('Tula de Allende','mx','Hidalgo',27678.0,-99.35,20.06).
city('Tulancingo','mx','Hidalgo',102388.0,-98.39,20.09).
city('Tulantepec','mx','Hidalgo',15625.0,-98.38,20.05).
city('Vindho','mx','Hidalgo',11054.0,-99.32,20.0).
city('Zacualtipan','mx','Hidalgo',17090.0,-98.6,20.65).
city('Zapotlan','mx','Hidalgo',8344.0,-98.85,19.97).
city('Zempoala','mx','Hidalgo',5814.0,-98.67,19.92).
city('Zimapan','mx','Hidalgo',12455.0,-99.35,20.75).
city('Acatic','mx','Jalisco',11582.0,-102.88,20.78).
city('Acatlan','mx','Jalisco',9375.0,-103.63,20.43).
city('Ahualulco','mx','Jalisco',14778.0,-103.98,20.7).
city('Ajijic','mx','Jalisco',13714.0,-103.28,20.3).
city('Alejandria','mx','Jalisco',4998.0,-101.98,20.98).
city('Amatitan','mx','Jalisco',9791.0,-103.72,20.83).
city('Ameca','mx','Jalisco',35869.0,-104.03,20.55).
city('Antonio Escobedo','mx','Jalisco',5269.0,-104.02,20.8).
city('Arandas','mx','Jalisco',43344.0,-102.35,20.7).
city('Atemajac','mx','Jalisco',4855.0,-103.86,20.1).
city('Atequiza','mx','Jalisco',5579.0,-103.13,20.42).
city('Atotonilco el Alto','mx','Jalisco',27012.0,-102.52,20.55).
city('Atotonilquillo','mx','Jalisco',7130.0,-103.13,20.4).
city('Atoyac','mx','Jalisco',5359.0,-103.53,20.02).
city('Autlan','mx','Jalisco',42157.0,-104.37,19.77).
city('Ayotlan','mx','Jalisco',10662.0,-102.35,20.53).
city('Ayutla','mx','Jalisco',7835.0,-104.33,20.12).
city('Bellavista','mx','Jalisco',6884.0,-103.65,20.43).
city('Cajititlan','mx','Jalisco',4855.0,-103.32,20.43).
city('Capilla de Guadalupe','mx','Jalisco',12445.0,-102.58,20.83).
city('Casimiro Castillo','mx','Jalisco',11215.0,-104.43,19.6).
city('Chapala','mx','Jalisco',20323.0,-103.2,20.3).
city('Chiquilistlan','mx','Jalisco',3683.0,-103.82,20.2).
city('Cihuatlan','mx','Jalisco',16520.0,-104.57,19.25).
city('Cocula','mx','Jalisco',14434.0,-103.83,20.38).
city('Colotlan','mx','Jalisco',12927.0,-103.27,22.1).
city('Concepcion de Buenos Aires','mx','Jalisco',4767.0,-103.27,19.97).
city('Cosala','mx','Jalisco',6319.0,-103.37,20.3).
city('Coyula','mx','Jalisco',5408.0,-103.22,20.65).
city('Cuitzeo','mx','Jalisco',5172.0,-102.78,20.33).
city('Cuqio','mx','Jalisco',4316.0,-103.04,20.93).
city('Cuyutlan','mx','Jalisco',5644.0,-103.4,20.42).
city('Degollado','mx','Jalisco',10753.0,-102.15,20.47).
city('El Arenal','mx','Jalisco',10309.0,-103.7,20.78).
city('El Grullo','mx','Jalisco',21031.0,-104.2,19.77).
city('El Limon','mx','Jalisco',3312.0,-104.18,19.82).
city('El Quince','mx','Jalisco',11878.0,-103.28,20.53).
city('El Refugio','mx','Jalisco',5694.0,-103.73,20.67).
city('El Salto','mx','Jalisco',22553.0,-104.51,20.34).
city('El Verde','mx','Jalisco',7556.0,-103.27,20.55).
city('Encarnacion','mx','Jalisco',21861.0,-102.22,21.52).
city('Etzatlan','mx','Jalisco',13183.0,-104.08,20.77).
city('Guadalajara','mx','Jalisco',1640649.0,-103.35,20.67).
city('Guzman','mx','Jalisco',88803.0,-103.46,19.71).
city('Hidalgo','mx','Jalisco',12157.0,-102.6,21.67).
city('Hostotipaquillo','mx','Jalisco',3189.0,-104.07,21.07).
city('Huejucar','mx','Jalisco',3551.0,-103.22,22.35).
city('Huejuquilla el Alto','mx','Jalisco',4640.0,-103.87,22.6).
city('Itzican','mx','Jalisco',4713.0,-102.95,20.33).
city('Ixtapa','mx','Jalisco',18717.0,-105.2,20.7).
city('Ixtlahuacan de los Membrillos','mx','Jalisco',5539.0,-103.18,20.35).
city('Ixtlahuacan del Rio','mx','Jalisco',6000.0,-103.25,20.87).
city('Ixtlan','mx','Jalisco',4848.0,-103.47,19.82).
city('Jalostotitlan','mx','Jalisco',22407.0,-102.47,21.2).
city('Jamay','mx','Jalisco',16310.0,-102.72,20.3).
city('Jesus Maria','mx','Jalisco',8264.0,-104.27,20.67).
city('Jocotepec','mx','Jalisco',16459.0,-103.43,20.3).
city('Juanacatlan','mx','Jalisco',8542.0,-103.17,20.52).
city('Juchitlan','mx','Jalisco',3717.0,-104.12,20.08).
city('La Barca','mx','Jalisco',34450.0,-102.56,20.28).
city('La Huerta','mx','Jalisco',7601.0,-104.65,19.47).
city('La Tijera','mx','Jalisco',5691.0,-104.4,19.9).
city('La Venta del Astillero','mx','Jalisco',4491.0,-103.54,20.72).
city('Lagos de Moreno','mx','Jalisco',84681.0,-101.93,21.37).
city('Las Juntas','mx','Jalisco',6259.0,-104.7,19.42).
city('Las Pintas','mx','Jalisco',16503.0,-103.32,20.57).
city('Lo Arado','mx','Jalisco',4005.0,-104.58,19.62).
city('Magdalena','mx','Jalisco',14177.0,-103.98,20.92).
city('Mascota','mx','Jalisco',8322.0,-104.78,20.52).
city('Mazamitla','mx','Jalisco',6615.0,-103.03,19.92).
city('Mexticacan','mx','Jalisco',3792.0,-102.72,21.22).
city('Mezcala','mx','Jalisco',4100.0,-102.75,20.93).
city('Nuevo Mexico','mx','Jalisco',28135.0,-103.43,20.75).
city('Ocotlan','mx','Jalisco',81531.0,-102.77,20.37).
city('Ojuelos de Jalisco','mx','Jalisco',9827.0,-101.58,21.87).
city('Pihuamo','mx','Jalisco',7613.0,-103.38,19.25).
city('Poncitlan','mx','Jalisco',13069.0,-102.93,20.38).
city('Puente Grande','mx','Jalisco',5636.0,-103.15,20.57).
city('Puerto Vallarta','mx','Jalisco',187143.0,-105.23,20.62).
city('Purificacion','mx','Jalisco',4740.0,-104.6,19.72).
city('San Agustin','mx','Jalisco',15107.0,-103.47,20.53).
city('San Gabriel','mx','Jalisco',4358.0,-103.03,21.02).
city('San Jose de Gracia','mx','Jalisco',5397.0,-102.58,20.67).
city('San Jose del Castillo','mx','Jalisco',10280.0,-103.23,20.53).
city('San Juan de los Lagos','mx','Jalisco',45673.0,-102.33,21.24).
city('San Julian','mx','Jalisco',12752.0,-102.17,21.02).
city('San Marcos','mx','Jalisco',3253.0,-104.18,20.78).
city('San Martin de Hidalgo','mx','Jalisco',7855.0,-103.95,20.45).
city('San Miguel el Alto','mx','Jalisco',22204.0,-102.35,21.02).
city('San Patricio','mx','Jalisco',6713.0,-104.7,19.22).
city('San Sebastian el Grande','mx','Jalisco',15465.0,-103.42,20.52).
city('Santa Anita','mx','Jalisco',13515.0,-103.47,20.55).
city('Santa Cruz de las Flores','mx','Jalisco',8504.0,-103.5,20.48).
city('Santa Cruz del Valle','mx','Jalisco',14637.0,-103.43,20.53).
city('Sayula','mx','Jalisco',25312.0,-103.62,19.87).
city('Tala','mx','Jalisco',30943.0,-103.72,20.67).
city('Talpa','mx','Jalisco',7665.0,-104.82,20.38).
city('Tamazula','mx','Jalisco',18397.0,-103.25,19.63).
city('Tapalpa','mx','Jalisco',5858.0,-103.77,19.95).
city('Tecalitlan','mx','Jalisco',13500.0,-103.3,19.47).
city('Tecolotlan','mx','Jalisco',8602.0,-104.05,20.22).
city('Tenamaxtlan','mx','Jalisco',4825.0,-104.17,20.22).
city('Teocaltiche','mx','Jalisco',22646.0,-102.58,21.43).
city('Teocuitatlan de Corona','mx','Jalisco',4304.0,-103.4,20.12).
city('Tepatitlan','mx','Jalisco',83698.0,-102.73,20.82).
city('Tequila','mx','Jalisco',25283.0,-103.82,20.88).
city('Tesistan','mx','Jalisco',29253.0,-103.48,20.78).
city('Teuchitlan','mx','Jalisco',3756.0,-103.87,20.68).
city('Tizapan el Alto','mx','Jalisco',14385.0,-103.07,20.17).
city('Tlajomulco','mx','Jalisco',17025.0,-103.43,20.47).
city('Tlaquepaque','mx','Jalisco',493667.0,-103.32,20.64).
city('Tomatlan','mx','Jalisco',8360.0,-105.25,19.93).
city('Tonala','mx','Jalisco',401616.0,-103.23,20.62).
city('Tonaya','mx','Jalisco',3475.0,-103.97,19.78).
city('Tonila','mx','Jalisco',3345.0,-103.52,19.43).
city('Tototlan','mx','Jalisco',11016.0,-102.8,20.55).
city('Tuxpan','mx','Jalisco',25664.0,-103.38,19.55).
city('Union de San Antonio','mx','Jalisco',6648.0,-101.97,21.1).
city('Union de Tula','mx','Jalisco',9119.0,-104.27,19.97).
city('Usmajac','mx','Jalisco',6627.0,-103.57,19.87).
city('Valle de Guadalupe','mx','Jalisco',4397.0,-102.62,21.0).
city('Valle de Juarez','mx','Jalisco',4014.0,-102.93,19.93).
city('Villa Corona','mx','Jalisco',6803.0,-103.68,20.42).
city('Villa Guerrero','mx','Jalisco',3892.0,-103.6,21.98).
city('Yahualica','mx','Jalisco',14971.0,-102.85,21.13).
city('Zacoalco','mx','Jalisco',16468.0,-103.58,20.23).
city('Zapopan','mx','Jalisco',987555.0,-103.4,20.72).
city('Zapote','mx','Jalisco',4401.0,-102.8,21.07).
city('Zapotiltic','mx','Jalisco',22200.0,-103.43,19.62).
city('Zapotlanejo','mx','Jalisco',29055.0,-103.07,20.63).
city('Acahualco','mx','Mexico',13968.0,-99.78,19.28).
city('Acambay','mx','Mexico',5807.0,-99.84,19.96).
city('Acazulco','mx','Mexico',5131.0,-99.42,19.27).
city('Acolman','mx','Mexico',4998.0,-98.92,19.63).
city('Acuautla','mx','Mexico',21905.0,-98.85,19.33).
city('Acutzilapan','mx','Mexico',5232.0,-99.68,19.78).
city('Ajoloapan','mx','Mexico',15905.0,-99.05,19.98).
city('Almaya','mx','Mexico',4810.0,-99.42,19.23).
city('Almoloya','mx','Mexico',3843.0,-100.12,18.95).
city('Almoloya del Rio','mx','Mexico',8995.0,-99.49,19.16).
city('Amanalco','mx','Mexico',5990.0,-100.02,19.32).
city('Amecameca','mx','Mexico',31719.0,-98.77,19.12).
city('Ameyalco','mx','Mexico',5022.0,-99.46,19.31).
city('Apaxco','mx','Mexico',14138.0,-99.17,19.97).
city('Atarasquillo','mx','Mexico',9608.0,-99.46,19.33).
city('Atenco','mx','Mexico',42382.0,-99.22,19.39).
city('Atizapan','mx','Mexico',7243.0,-99.55,19.25).
city('Atlacomulco','mx','Mexico',22247.0,-99.87,19.8).
city('Atlatlahuca','mx','Mexico',5380.0,-99.61,19.07).
city('Atlatongo','mx','Mexico',4983.0,-98.9,19.67).
city('Atlautla','mx','Mexico',10635.0,-98.78,19.02).
city('Atlazalpan','mx','Mexico',10062.0,-98.9,19.22).
city('Autopan','mx','Mexico',30417.0,-99.66,19.36).
city('Axapusco','mx','Mexico',3343.0,-98.75,19.73).
city('Ayotuzco','mx','Mexico',4483.0,-99.82,18.75).
city('Ayotzingo','mx','Mexico',9174.0,-98.93,19.2).
city('Azcatepec','mx','Mexico',47694.0,-98.84,19.71).
city('Balderas','mx','Mexico',4621.0,-99.65,19.11).
city('Bocanegra','mx','Mexico',5681.0,-99.12,19.84).
city('Buenavista','mx','Mexico',235612.0,-99.05,19.55).
city('Cacalomacan','mx','Mexico',10723.0,-99.7,19.25).
city('Cahuacan','mx','Mexico',4729.0,-99.42,19.64).
city('Calimaya','mx','Mexico',10407.0,-99.62,19.16).
city('Calixtlahuaca','mx','Mexico',8865.0,-99.69,19.33).
city('Capulhuac','mx','Mexico',20517.0,-99.47,19.19).
city('Carbon','mx','Mexico',8434.0,-99.53,19.82).
city('Chalco','mx','Mexico',164003.0,-98.9,19.26).
city('Chapultepec','mx','Mexico',5828.0,-99.57,19.2).
city('Chiautla','mx','Mexico',7775.0,-98.88,19.53).
city('Chicoloapan','mx','Mexico',84444.0,-98.92,19.41).
city('Chiconautla','mx','Mexico',7844.0,-99.01,19.62).
city('Chiconcuac','mx','Mexico',19047.0,-98.9,19.55).
city('Chimalhuacan','mx','Mexico',590165.0,-98.96,19.44).
city('Chimalpa','mx','Mexico',7182.0,-99.35,19.43).
city('Cholula','mx','Mexico',8798.0,-99.48,19.27).
city('Citendeje','mx','Mexico',5414.0,-99.93,19.78).
city('Coacalco','mx','Mexico',313419.0,-99.11,19.63).
city('Coatepec','mx','Mexico',5576.0,-99.38,19.23).
city('Coatepec Harinas','mx','Mexico',7243.0,-99.72,18.9).
city('Coatlinchan','mx','Mexico',21498.0,-98.87,19.45).
city('Cocotitlan','mx','Mexico',9599.0,-98.87,19.23).
city('Colorines','mx','Mexico',7246.0,-100.17,19.2).
city('Coyotepec','mx','Mexico',35795.0,-99.21,19.78).
city('Cuauhtenco','mx','Mexico',6674.0,-99.73,19.25).
city('Cuautitlan','mx','Mexico',84741.0,-99.18,19.67).
city('Cuautitlan Izcalli','mx','Mexico',475199.0,-99.25,19.65).
city('Cuautlalpan','mx','Mexico',9141.0,-99.14,19.75).
city('Ecatepec','mx','Mexico',1806297.0,-99.05,19.6).
city('Ecatzingo','mx','Mexico',6373.0,-98.75,18.93).
city('El Oro','mx','Mexico',6805.0,-100.13,19.8).
city('Enchisi','mx','Mexico',4499.0,-99.82,19.76).
city('Enthavi','mx','Mexico',4810.0,-99.58,19.49).
city('Huehuetoca','mx','Mexico',6951.0,-99.2,19.85).
city('Hueypoxtla','mx','Mexico',3566.0,-99.08,19.91).
city('Huilango','mx','Mexico',15551.0,-99.25,19.69).
city('Huixquilucan','mx','Mexico',124852.0,-99.35,19.36).
city('Huixquilucan de Degollado','mx','Mexico',8862.0,-92.48,15.14).
city('Ixlahuaca','mx','Mexico',7574.0,-99.22,20.48).
city('Ixtacalco','mx','Mexico',4645.0,-99.19,19.69).
city('Ixtapaluca','mx','Mexico',351015.0,-98.88,19.32).
city('Ixtapan','mx','Mexico',17648.0,-99.68,18.83).
city('Jajalpa','mx','Mexico',6012.0,-99.54,19.11).
city('Jaltenco','mx','Mexico',9603.0,-99.1,19.75).
city('Jaltepec','mx','Mexico',5275.0,-98.63,19.73).
city('Jesus del Monte','mx','Mexico',9649.0,-99.99,19.11).
city('Jilotepec','mx','Mexico',11641.0,-99.53,19.95).
city('Jilotzingo','mx','Mexico',6474.0,-99.23,19.7).
city('Jocotitlan','mx','Mexico',7610.0,-99.79,19.71).
city('Joquicingo','mx','Mexico',4206.0,-99.47,19.05).
city('Juchitepec','mx','Mexico',14870.0,-98.88,19.1).
city('La Concepcion los Banos','mx','Mexico',6503.0,-99.86,19.68).
city('La Magdalema','mx','Mexico',4656.0,-100.07,19.77).
city('Lerma','mx','Mexico',18145.0,-99.52,19.29).
city('Lopez Mateos','mx','Mexico',521056.0,-99.26,19.57).
city('Los Reyes','mx','Mexico',251179.0,-98.98,19.36).
city('Los Reyes Acozac','mx','Mexico',22133.0,-98.98,19.77).
city('Luvianos','mx','Mexico',9247.0,-100.4,18.92).
city('Malinalco','mx','Mexico',7220.0,-99.5,18.95).
city('Melchor Ocampo','mx','Mexico',34491.0,-99.15,19.7).
city('Metepec','mx','Mexico',172990.0,-99.62,19.27).
city('Mexicaltzingo','mx','Mexico',8287.0,-99.59,19.21).
city('Mextepec','mx','Mexico',5142.0,-99.93,19.63).
city('Montecillo','mx','Mexico',5138.0,-98.9,19.45).
city('Nativitas','mx','Mexico',5634.0,-99.61,19.58).
city('Naucalpan','mx','Mexico',846222.0,-99.23,19.48).
city('Nextlalpan','mx','Mexico',12598.0,-99.07,19.74).
city('Nezahualcoyotl','mx','Mexico',1232565.0,-99.03,19.41).
city('Nicolas Romero','mx','Mexico',245394.0,-99.31,19.62).
city('Nopaltepec','mx','Mexico',3572.0,-98.7,19.8).
city('Ocotitlan','mx','Mexico',4799.0,-99.62,19.23).
city('Ocotlan','mx','Mexico',5226.0,-99.59,19.19).
city('Ocoyoacac','mx','Mexico',24647.0,-99.46,19.27).
city('Ojo de Agua','mx','Mexico',84255.0,-98.97,19.72).
city('Otumba','mx','Mexico',9718.0,-98.75,19.7).
city('Otzacatipan','mx','Mexico',18823.0,-99.61,19.33).
city('Oyamel','mx','Mexico',5110.0,-99.58,19.43).
city('Oztolotepec','mx','Mexico',18303.0,-99.56,19.42).
city('Ozumba','mx','Mexico',19929.0,-98.8,19.05).
city('Papalotla','mx','Mexico',3546.0,-98.85,19.57).
city('Progreso Industrial','mx','Mexico',10332.0,-99.36,19.63).
city('Pueblo Nuevo','mx','Mexico',5170.0,-99.62,19.67).
city('Rayon','mx','Mexico',7445.0,-99.58,19.14).
city('Rio Frio','mx','Mexico',5707.0,-98.67,19.35).
city('Salitrillo','mx','Mexico',4829.0,-99.85,19.43).
city('San Antonio Buenavista','mx','Mexico',6365.0,-99.71,19.26).
city('San Antonio La Isla','mx','Mexico',11123.0,-99.57,19.16).
city('San Bartolo','mx','Mexico',5837.0,-99.53,19.49).
city('San Bartolo del Llano','mx','Mexico',10937.0,-99.74,19.59).
city('San Bernardino','mx','Mexico',5204.0,-98.88,19.5).
city('San Buenaventura','mx','Mexico',9991.0,-99.7,19.27).
city('San Felipe del Progreso','mx','Mexico',3909.0,-99.95,19.71).
city('San Jose el Vidrio','mx','Mexico',4606.0,-99.38,19.65).
city('San Juan Tilapa','mx','Mexico',8019.0,-99.66,19.22).
city('San Juan de las Huertas','mx','Mexico',11929.0,-99.76,19.25).
city('San Lorenzo Cuauhtenco','mx','Mexico',4569.0,-99.6,19.2).
city('San Martin de las Piramides','mx','Mexico',13017.0,-98.83,19.7).
city('San Nicolas Guadalupe','mx','Mexico',5228.0,-100.09,19.56).
city('San Nicolas Tolentino','mx','Mexico',5260.0,-100.22,19.18).
city('San Pablo de las Salinas','mx','Mexico',173565.0,-99.1,19.67).
city('San Pedro Abajo','mx','Mexico',5581.0,-99.57,19.48).
city('San Pedro Arriba','mx','Mexico',6154.0,-99.57,19.45).
city('San Pedro el Alto','mx','Mexico',4708.0,-99.91,19.61).
city('San Pedro los Banos','mx','Mexico',11886.0,-99.83,19.67).
city('San Simon de la Laguna','mx','Mexico',4441.0,-100.08,19.3).
city('Santa Catarina del Monte','mx','Mexico',5178.0,-98.77,19.5).
city('Santa Gertrudis','mx','Mexico',5185.0,-99.37,19.73).
city('Santa Maria del Monte','mx','Mexico',5299.0,-99.82,19.29).
city('Santo Domingo de Guzman','mx','Mexico',7378.0,-99.77,19.59).
city('Soyaniquilpan','mx','Mexico',3898.0,-99.5,19.98).
city('Sultepec','mx','Mexico',3979.0,-99.95,18.87).
city('Tecalco','mx','Mexico',4810.0,-98.95,19.67).
city('Tecamac','mx','Mexico',15244.0,-98.97,19.73).
city('Techuchulco','mx','Mexico',4405.0,-99.53,19.11).
city('Tejupilco','mx','Mexico',25036.0,-100.15,18.9).
city('Temamatla','mx','Mexico',5150.0,-98.88,19.2).
city('Temascalapa','mx','Mexico',5735.0,-98.9,19.83).
city('Temascalcingo','mx','Mexico',12909.0,-100.0,19.92).
city('Temoaya','mx','Mexico',3382.0,-99.59,19.47).
city('Tenancingo','mx','Mexico',34274.0,-99.61,18.97).
city('Tenango de Arista','mx','Mexico',20969.0,-99.59,19.1).
city('Tenango del Aire','mx','Mexico',5237.0,-98.85,19.17).
city('Tenochtitlan','mx','Mexico',5603.0,-99.93,19.75).
city('Teoloyucan','mx','Mexico',61379.0,-99.18,19.75).
city('Teotihuacan','mx','Mexico',22540.0,-98.85,19.68).
city('Tepetitlan','mx','Mexico',4590.0,-99.92,19.63).
city('Tepetlaoxtoc','mx','Mexico',5860.0,-98.82,19.58).
city('Tepetlixpa','mx','Mexico',13322.0,-98.82,19.03).
city('Tepexpan','mx','Mexico',23905.0,-99.31,19.6).
city('Tepotzotlan','mx','Mexico',44519.0,-99.22,19.71).
city('Tequixquiac','mx','Mexico',20975.0,-99.15,19.91).
city('Texcalyacac','mx','Mexico',4038.0,-99.47,19.17).
city('Texcoco','mx','Mexico',115384.0,-98.88,19.52).
city('Teyahualco','mx','Mexico',41756.0,-99.13,19.66).
city('Tez','mx','Mexico',10057.0,-98.81,19.22).
city('Tezoyuca','mx','Mexico',13504.0,-98.9,19.6).
city('Tianguistenco','mx','Mexico',20104.0,-99.47,19.18).
city('Tilapa','mx','Mexico',9676.0,-99.42,19.19).
city('Tlacotepec','mx','Mexico',10869.0,-99.78,19.52).
city('Tlalcilalcalpan','mx','Mexico',11059.0,-99.78,19.29).
city('Tlalmanalco','mx','Mexico',14952.0,-98.8,19.22).
city('Tlalnepantla','mx','Mexico',715798.0,-99.19,19.54).
city('Tlaltelulco','mx','Mexico',7354.0,-99.63,19.23).
city('Tlaltizapan','mx','Mexico',9620.0,-99.5,19.19).
city('Tlanisco','mx','Mexico',5411.0,-99.67,19.03).
city('Toluca','mx','Mexico',505903.0,-99.67,19.29).
city('Tonanitla','mx','Mexico',5859.0,-99.06,19.69).
city('Tonatico','mx','Mexico',8224.0,-99.68,18.78).
city('Totocuitlapilco','mx','Mexico',7966.0,-99.58,19.23).
city('Totoltepec','mx','Mexico',18779.0,-99.58,19.31).
city('Tultepec','mx','Mexico',33788.0,-99.31,19.48).
city('Tultitlan','mx','Mexico',24387.0,-99.17,19.65).
city('Valle de Bravo','mx','Mexico',28280.0,-100.13,19.18).
city('Victoria','mx','Mexico',3661.0,-100.0,19.44).
city('Villa Guerrero','mx','Mexico',9267.0,-99.65,18.87).
city('Vista Hermosa','mx','Mexico',6344.0,-99.22,19.52).
city('Xalatlaco','mx','Mexico',13663.0,-99.42,19.18).
city('Xalpa','mx','Mexico',10444.0,-99.18,19.82).
city('Xico','mx','Mexico',365793.0,-98.94,19.27).
city('Xochimanca','mx','Mexico',4705.0,-98.82,19.48).
city('Xoloc','mx','Mexico',6885.0,-99.25,19.7).
city('Xometla','mx','Mexico',4454.0,-98.88,19.65).
city('Xonacatlan','mx','Mexico',19687.0,-99.53,19.4).
city('Yachihuacaltepec','mx','Mexico',4597.0,-99.68,19.32).
city('Zacacalco','mx','Mexico',7224.0,-98.98,19.93).
city('Zacamulpa','mx','Mexico',5985.0,-99.33,19.36).
city('Zacualpan','mx','Mexico',3360.0,-99.78,18.72).
city('Zaragoza','mx','Mexico',6896.0,-99.65,19.15).
city('Zictepec','mx','Mexico',5559.0,-99.58,19.03).
city('Zinacantepec','mx','Mexico',54222.0,-99.74,19.28).
city('Zolotepec','mx','Mexico',9857.0,-99.49,19.42).
city('Zumpahuacan','mx','Mexico',4450.0,-99.55,18.9).
city('Zumpango','mx','Mexico',47517.0,-99.11,19.81).
city('Acuitzio','mx','Michoacan',5918.0,-101.33,19.48).
city('Aguililla','mx','Michoacan',9422.0,-102.73,18.73).
city('Alvaro Obregon','mx','Michoacan',8120.0,-101.08,19.83).
city('Angahuan','mx','Michoacan',4864.0,-102.18,19.55).
city('Angamacutiro','mx','Michoacan',5021.0,-101.68,20.17).
city('Angangueo','mx','Michoacan',4943.0,-100.28,19.6).
city('Antunez','mx','Michoacan',8591.0,-102.2,19.02).
city('Apatzingan','mx','Michoacan',98426.0,-102.35,19.08).
city('Ario','mx','Michoacan',11499.0,-102.03,19.62).
city('Arteaga','mx','Michoacan',9550.0,-102.42,18.47).
city('Benito Juarez','mx','Michoacan',3074.0,-100.47,19.23).
city('Brisenas','mx','Michoacan',4030.0,-102.57,20.27).
city('Buenavista','mx','Michoacan',9121.0,-102.6,19.2).
city('Buenos Aires','mx','Michoacan',10707.0,-102.17,19.07).
city('Caltzontzin','mx','Michoacan',4109.0,-101.93,19.42).
city('Capacuaro','mx','Michoacan',7283.0,-102.05,19.55).
city('Capula','mx','Michoacan',4678.0,-101.8,19.7).
city('Caracuaro','mx','Michoacan',3218.0,-101.13,19.01).
city('Charapan','mx','Michoacan',3615.0,-102.23,19.67).
city('Charo','mx','Michoacan',4689.0,-101.05,19.78).
city('Chavinda','mx','Michoacan',6841.0,-102.45,20.02).
city('Cheran','mx','Michoacan',12949.0,-101.95,19.68).
city('Chilchota','mx','Michoacan',7103.0,-102.13,19.85).
city('Churintzio','mx','Michoacan',3026.0,-102.07,20.15).
city('Churumuco','mx','Michoacan',4265.0,-101.63,18.62).
city('Coahuayana','mx','Michoacan',6848.0,-103.68,18.73).
city('Coalcoman','mx','Michoacan',10715.0,-103.15,18.78).
city('Coeneo','mx','Michoacan',4185.0,-101.58,19.82).
city('Cojumatlan','mx','Michoacan',6653.0,-102.83,20.12).
city('Comachuen','mx','Michoacan',4412.0,-101.9,19.62).
city('Contepec','mx','Michoacan',3623.0,-100.12,20.02).
city('Copandaro','mx','Michoacan',3498.0,-101.22,19.88).
city('Cotija','mx','Michoacan',13939.0,-102.68,19.82).
city('Cuanajo','mx','Michoacan',5110.0,-101.52,19.48).
city('Cuitareo','mx','Michoacan',4300.0,-100.6,19.62).
city('Cuitzeo','mx','Michoacan',9057.0,-101.15,19.98).
city('Ecuandureo','mx','Michoacan',5098.0,-102.18,20.17).
city('Hidalgo','mx','Michoacan',54996.0,-100.57,19.68).
city('Huandacareo','mx','Michoacan',6877.0,-101.28,19.98).
city('Huetamo','mx','Michoacan',21899.0,-100.88,18.58).
city('Indaparapeo','mx','Michoacan',6907.0,-100.97,19.78).
city('Irimbo','mx','Michoacan',2927.0,-100.47,19.72).
city('Ixtlan','mx','Michoacan',5017.0,-102.4,20.18).
city('Jacona','mx','Michoacan',48984.0,-102.33,19.96).
city('Jiquilpan','mx','Michoacan',25621.0,-102.72,19.98).
city('Jungapeo','mx','Michoacan',5189.0,-100.48,19.45).
city('La Huacana','mx','Michoacan',9351.0,-101.82,18.97).
city('La Mira','mx','Michoacan',14536.0,-102.28,18.68).
city('La Orilla','mx','Michoacan',16178.0,-102.23,17.98).
city('La Piedad','mx','Michoacan',70241.0,-102.03,20.33).
city('La Ruana','mx','Michoacan',9256.0,-102.7,19.15).
city('Las Guacamayas','mx','Michoacan',39448.0,-102.22,18.02).
city('Lazaro Cardenas','mx','Michoacan',84005.0,-102.18,17.95).
city('Lombardia','mx','Michoacan',11417.0,-102.03,19.15).
city('Los Reyes','mx','Michoacan',37441.0,-100.27,19.73).
city('Madero','mx','Michoacan',5588.0,-101.27,19.4).
city('Maravatio','mx','Michoacan',30413.0,-100.43,19.9).
city('Maya','mx','Michoacan',7016.0,-101.02,20.0).
city('Morelia','mx','Michoacan',592820.0,-101.18,19.72).
city('Morelos','mx','Michoacan',11680.0,-101.47,19.98).
city('Nahuatzen','mx','Michoacan',8164.0,-101.83,19.7).
city('Nocupetaro','mx','Michoacan',3054.0,-101.15,19.05).
city('Nueva Italia de Ruiz','mx','Michoacan',31426.0,-102.1,19.02).
city('Nuevo San Juan Parangaricutiro','mx','Michoacan',12300.0,-102.13,19.4).
city('Numaran','mx','Michoacan',4524.0,-101.93,20.25).
city('Ocampo','mx','Michoacan',3217.0,-100.33,19.58).
city('Opopeo','mx','Michoacan',8601.0,-101.6,19.4).
city('Pajacuaran','mx','Michoacan',9611.0,-102.57,20.12).
city('Panindicuaro','mx','Michoacan',5982.0,-101.77,19.97).
city('Paracho','mx','Michoacan',15965.0,-102.07,19.65).
city('Paracuaro','mx','Michoacan',3819.0,-102.22,19.13).
city('Pastor Ortiz','mx','Michoacan',6853.0,-102.45,19.52).
city('Patzcuaro','mx','Michoacan',49018.0,-101.62,19.52).
city('Pedernales','mx','Michoacan',6240.0,-101.47,19.13).
city('Penjamillo','mx','Michoacan',3584.0,-101.9,20.1).
city('Periban','mx','Michoacan',11877.0,-102.42,19.52).
city('Pichataro','mx','Michoacan',4749.0,-101.8,19.57).
city('Purepero','mx','Michoacan',14267.0,-102.02,19.92).
city('Puruandiro','mx','Michoacan',28351.0,-101.5,20.08).
city('Puruaran','mx','Michoacan',7403.0,-101.53,19.1).
city('Querendaro','mx','Michoacan',8770.0,-100.9,19.88).
city('Quiroga','mx','Michoacan',13511.0,-101.53,19.67).
city('Rincon de Nicolas Romero','mx','Michoacan',5059.0,-102.55,20.02).
city('Sahuayo','mx','Michoacan',58516.0,-102.72,20.07).
city('San Jose de Gracia','mx','Michoacan',8146.0,-102.23,19.8).
city('San Lucas','mx','Michoacan',3249.0,-100.78,18.57).
city('Santa Clara de Valladares','mx','Michoacan',6471.0,-102.51,19.64).
city('Santa Clara del Cobre','mx','Michoacan',12275.0,-101.65,19.41).
city('Santa Fe de la Laguna','mx','Michoacan',4359.0,-101.55,19.67).
city('Tacambaro','mx','Michoacan',21059.0,-101.47,19.23).
city('Tancitaro','mx','Michoacan',5298.0,-102.37,19.33).
city('Tangamandapio','mx','Michoacan',9967.0,-102.43,19.95).
city('Tangancicuaro','mx','Michoacan',15182.0,-102.13,19.9).
city('Tanhuato','mx','Michoacan',8454.0,-102.33,20.28).
city('Tarecuato','mx','Michoacan',8149.0,-102.53,19.87).
city('Taretan','mx','Michoacan',6449.0,-101.92,19.33).
city('Tarimbaro','mx','Michoacan',5138.0,-101.13,19.78).
city('Tepalcatepec','mx','Michoacan',15281.0,-102.83,19.17).
city('Tingambato','mx','Michoacan',6329.0,-101.87,19.5).
city('Tingueindin','mx','Michoacan',6303.0,-102.48,19.75).
city('Tiqui','mx','Michoacan',3446.0,-100.73,18.88).
city('Tlalpujahua','mx','Michoacan',3420.0,-100.17,19.8).
city('Tlazazalca','mx','Michoacan',3635.0,-102.07,19.97).
city('Tungareo','mx','Michoacan',4133.0,-100.38,19.88).
city('Tuxpan','mx','Michoacan',9324.0,-100.47,19.57).
city('Tzintzuntzan','mx','Michoacan',3233.0,-101.58,19.62).
city('Uruapan','mx','Michoacan',237319.0,-102.07,19.42).
city('Venustiano Carranza','mx','Michoacan',11627.0,-102.62,20.15).
city('Villa Jimenez','mx','Michoacan',4516.0,-101.75,19.9).
city('Villachuato','mx','Michoacan',4310.0,-101.58,20.17).
city('Villamar','mx','Michoacan',3028.0,-102.6,20.02).
city('Vista Hermosa','mx','Michoacan',9581.0,-102.48,20.27).
city('Yurecuaro','mx','Michoacan',20833.0,-102.3,20.33).
city('Zacapu','mx','Michoacan',50115.0,-101.78,19.82).
city('Zamora','mx','Michoacan',124922.0,-102.27,19.98).
city('Zinapecuaro','mx','Michoacan',14931.0,-100.82,19.87).
city('Zitacuaro','mx','Michoacan',78954.0,-100.36,19.44).
city('Alpuyeca','mx','Morelos',7811.0,-99.27,18.73).
city('Amacuzac','mx','Morelos',5510.0,-99.38,18.59).
city('Amayuca','mx','Morelos',4984.0,-98.77,18.7).
city('Anenecuilco','mx','Morelos',10295.0,-98.98,18.77).
city('Apatlaco','mx','Morelos',12530.0,-98.95,18.78).
city('Atlatlahucan','mx','Morelos',7554.0,-98.9,18.93).
city('Axochiapan','mx','Morelos',17568.0,-98.73,18.5).
city('Ayala','mx','Morelos',6869.0,-98.98,18.75).
city('Coatetelco','mx','Morelos',9503.0,-99.33,18.72).
city('Cocoyoc','mx','Morelos',9752.0,-98.98,18.87).
city('Cuautla','mx','Morelos',146186.0,-98.96,18.82).
city('Cuernavaca','mx','Morelos',343785.0,-99.25,18.92).
city('Emiliano Zapata','mx','Morelos',37726.0,-99.18,18.83).
city('Higueron','mx','Morelos',4603.0,-99.17,18.58).
city('Hueyapan','mx','Morelos',6353.0,-98.67,18.87).
city('Huiztilac','mx','Morelos',4328.0,-99.27,19.04).
city('Jantetelco','mx','Morelos',4514.0,-98.78,18.73).
city('Jiutepec','mx','Morelos',166340.0,-99.18,18.87).
city('Jojutla','mx','Morelos',20540.0,-99.18,18.62).
city('Jonacatepec','mx','Morelos',8252.0,-98.8,18.68).
city('La Joya','mx','Morelos',13158.0,-99.47,18.67).
city('Mazatepec','mx','Morelos',4975.0,-99.35,18.72).
city('Miacatlan','mx','Morelos',8253.0,-99.37,18.77).
city('Oaxtepec','mx','Morelos',6993.0,-98.97,18.9).
city('Ocuituco','mx','Morelos',4728.0,-98.77,18.87).
city('Puente de Ixtla','mx','Morelos',20673.0,-99.32,18.64).
city('San Jose Vista Hermosa','mx','Morelos',4327.0,-99.05,18.86).
city('Santa Catarina','mx','Morelos',4477.0,-99.13,18.97).
city('Santa Rosa Treinta','mx','Morelos',16953.0,-99.02,18.55).
city('Tehuixtla','mx','Morelos',7075.0,-99.27,18.55).
city('Telixtac','mx','Morelos',4294.0,-98.77,18.57).
city('Temixco','mx','Morelos',91064.0,-99.23,18.85).
city('Temoac','mx','Morelos',5302.0,-98.78,18.77).
city('Tenextepango','mx','Morelos',9133.0,-98.95,18.72).
city('Tepalcingo','mx','Morelos',11846.0,-98.85,18.6).
city('Tepoztlan','mx','Morelos',15963.0,-99.1,18.98).
city('Tetecala','mx','Morelos',5111.0,-99.4,18.72).
city('Tetela del Volcan','mx','Morelos',9127.0,-98.72,18.87).
city('Tilzapotla','mx','Morelos',5256.0,-99.27,18.48).
city('Tlacotepec','mx','Morelos',4914.0,-98.75,18.82).
city('Tlalnepantla','mx','Morelos',3742.0,-98.98,19.0).
city('Tlaltizapan','mx','Morelos',10465.0,-99.12,18.68).
city('Tlaquiltenango','mx','Morelos',19056.0,-99.17,18.63).
city('Tlatenchi','mx','Morelos',4730.0,-99.2,18.58).
city('Tlayacapan','mx','Morelos',7785.0,-98.98,18.93).
city('Totolapan','mx','Morelos',5584.0,-98.92,18.97).
city('Tres Marias','mx','Morelos',5713.0,-99.24,19.05).
city('Xochitepec','mx','Morelos',16768.0,-99.23,18.78).
city('Xoxocotla','mx','Morelos',19790.0,-99.25,18.68).
city('Yautepec','mx','Morelos',41388.0,-99.07,18.88).
city('Yecapixtla','mx','Morelos',14431.0,-98.87,18.88).
city('Zacatepec','mx','Morelos',21534.0,-99.19,18.67).
city('Acaponeta','mx','Nayarit',18564.0,-105.36,22.5).
city('Ahuacatlan','mx','Nayarit',6450.0,-104.48,21.05).
city('Amatlan','mx','Nayarit',3332.0,-104.4,20.8).
city('Aztatan','mx','Nayarit',5185.0,-105.42,22.38).
city('Bucerias','mx','Nayarit',9037.0,-105.33,20.75).
city('Compostela','mx','Nayarit',16162.0,-104.9,21.23).
city('Hidalgo','mx','Nayarit',11076.0,-105.23,21.73).
city('Ixcuintla','mx','Nayarit',18365.0,-105.22,21.82).
city('Ixtlan del Rio','mx','Nayarit',21646.0,-104.37,21.03).
city('Jala','mx','Nayarit',9179.0,-104.43,21.08).
city('Jalcocotan','mx','Nayarit',4370.0,-105.12,21.47).
city('La Penita de Jaltemba','mx','Nayarit',7535.0,-105.25,21.03).
city('La Presa','mx','Nayarit',4003.0,-105.39,22.34).
city('Lagunillas','mx','Nayarit',3793.0,-104.77,21.22).
city('Las Jarretaderas','mx','Nayarit',4463.0,-105.03,21.9).
city('Las Varas','mx','Nayarit',12837.0,-105.17,21.17).
city('Puga','mx','Nayarit',6361.0,-104.82,21.58).
city('Rosamorada','mx','Nayarit',3634.0,-105.21,22.12).
city('Ruiz','mx','Nayarit',12745.0,-105.15,21.95).
city('San Blas','mx','Nayarit',9016.0,-105.27,21.52).
city('San Juan de Abajo','mx','Nayarit',9015.0,-105.21,20.82).
city('San Vicente','mx','Nayarit',4675.0,-105.3,21.95).
city('Santa Maria del Oro','mx','Nayarit',3596.0,-104.58,21.33).
city('Tecuala','mx','Nayarit',14921.0,-105.46,22.4).
city('Tepic','mx','Nayarit',280602.0,-104.89,21.5).
city('Tuxpan','mx','Nayarit',22762.0,-105.27,21.93).
city('Valle de Banderas','mx','Nayarit',5656.0,-105.23,20.8).
city('Xalisco','mx','Nayarit',24264.0,-104.9,21.45).
city('Yago','mx','Nayarit',4063.0,-105.07,21.83).
city('Zacualpan','mx','Nayarit',5236.0,-105.17,21.25).
city('Allende','mx','Nuevo Leon',22609.0,-100.02,25.28).
city('Anahuac','mx','Nuevo Leon',17181.0,-100.15,27.23).
city('Apodaca','mx','Nuevo Leon',352246.0,-100.18,25.77).
city('Bustamante','mx','Nuevo Leon',3543.0,-100.5,26.55).
city('Cadereyta','mx','Nuevo Leon',67997.0,-100.0,25.6).
city('China','mx','Nuevo Leon',9591.0,-99.23,25.7).
city('Cienaga de Flores','mx','Nuevo Leon',11035.0,-100.18,25.95).
city('Doctor Arroyo','mx','Nuevo Leon',8435.0,-100.18,23.67).
city('Galeana','mx','Nuevo Leon',6292.0,-100.07,24.83).
city('Garcia','mx','Nuevo Leon',26950.0,-100.58,25.82).
city('Garza Garcia','mx','Nuevo Leon',130652.0,-100.38,25.66).
city('General Bravo','mx','Nuevo Leon',4073.0,-99.17,25.8).
city('General Escobedo','mx','Nuevo Leon',308284.0,-100.33,25.82).
city('General Teran','mx','Nuevo Leon',7487.0,-99.67,25.25).
city('General Zuazua','mx','Nuevo Leon',5663.0,-100.12,25.9).
city('Guadalupe','mx','Nuevo Leon',724949.0,-100.26,25.68).
city('Hidalgo','mx','Nuevo Leon',15227.0,-99.62,25.85).
city('Hualahuises','mx','Nuevo Leon',5439.0,-99.67,24.88).
city('Juarez','mx','Nuevo Leon',14228.0,-100.08,25.65).
city('La Reforma','mx','Nuevo Leon',6145.0,-99.54,24.7).
city('Lampazos de Naranjo','mx','Nuevo Leon',5104.0,-100.52,27.02).
city('Linares','mx','Nuevo Leon',57731.0,-99.57,24.86).
city('Marin','mx','Nuevo Leon',3299.0,-100.05,25.87).
city('Mina','mx','Nuevo Leon',3803.0,-100.53,26.02).
city('Montemorelos','mx','Nuevo Leon',37695.0,-99.84,25.19).
city('Monterrey','mx','Nuevo Leon',1122912.0,-100.32,25.67).
city('Pesqueria','mx','Nuevo Leon',5689.0,-100.05,25.78).
city('Sabinas Hidalgo','mx','Nuevo Leon',32048.0,-100.18,26.51).
city('Salinas Victoria','mx','Nuevo Leon',6561.0,-100.31,25.83).
city('San Nicolas de los Garza','mx','Nuevo Leon',507837.0,-100.3,25.75).
city('Santa Catarina','mx','Nuevo Leon',254483.0,-100.47,25.67).
city('Santiago','mx','Nuevo Leon',35970.0,-100.14,25.41).
city('Acatlan','mx','Oaxaca',5933.0,-96.62,18.53).
city('Amatlan','mx','Oaxaca',3539.0,-96.4,16.32).
city('Amilpas','mx','Oaxaca',7361.0,-94.6,16.37).
city('Amuzgos','mx','Oaxaca',4003.0,-98.1,16.65).
city('Asuncion Ixtaltepec','mx','Oaxaca',7556.0,-95.05,16.5).
city('Asuncion Nochixtlan','mx','Oaxaca',10012.0,-97.23,17.47).
city('Asuncion Ocotlan','mx','Oaxaca',3848.0,-96.72,16.77).
city('Atzompa','mx','Oaxaca',14162.0,-96.79,17.1).
city('Ayautla','mx','Oaxaca',2896.0,-96.67,18.03).
city('Ayoquezco','mx','Oaxaca',5302.0,-96.83,16.68).
city('Ayotzintepec','mx','Oaxaca',3680.0,-96.13,17.67).
city('Cacahuatepec','mx','Oaxaca',3636.0,-98.15,16.62).
city('Cacaotepec','mx','Oaxaca',5774.0,-96.8,17.13).
city('Chahuites','mx','Oaxaca',9837.0,-94.18,16.28).
city('Chichicapam','mx','Oaxaca',3029.0,-96.48,16.75).
city('Chiltepec','mx','Oaxaca',3294.0,-96.18,17.95).
city('Cienaga de Zimatlan','mx','Oaxaca',3093.0,-96.76,16.9).
city('Coatlan','mx','Oaxaca',4052.0,-96.83,16.38).
city('Comitancillo','mx','Oaxaca',3824.0,-95.15,16.48).
city('Cosolapa','mx','Oaxaca',7996.0,-96.65,18.58).
city('Coyotepec','mx','Oaxaca',3114.0,-96.7,16.97).
city('Cuicatlan','mx','Oaxaca',3877.0,-96.97,17.78).
city('Cuilapam','mx','Oaxaca',10782.0,-96.77,17.0).
city('Ejutla de Crespo','mx','Oaxaca',8117.0,-96.73,16.57).
city('El Espinal','mx','Oaxaca',7616.0,-94.07,16.33).
city('Etla','mx','Oaxaca',5293.0,-96.78,17.2).
city('Guelavia','mx','Oaxaca',3014.0,-96.55,16.95).
city('Guichicovi','mx','Oaxaca',4371.0,-95.1,16.97).
city('Huajuapan','mx','Oaxaca',47846.0,-97.79,17.81).
city('Huatulco','mx','Oaxaca',5472.0,-96.32,15.85).
city('Huautla','mx','Oaxaca',9972.0,-96.85,18.13).
city('Huaxpaltepec','mx','Oaxaca',4212.0,-97.93,16.32).
city('Huayapam','mx','Oaxaca',3630.0,-96.67,17.1).
city('Huazolotitlan','mx','Oaxaca',4506.0,-97.93,16.28).
city('Huitzo','mx','Oaxaca',4743.0,-96.87,17.25).
city('Huixtepec','mx','Oaxaca',8785.0,-96.77,16.83).
city('Ixcatlan','mx','Oaxaca',3273.0,-96.5,18.15).
city('Ixhuatan','mx','Oaxaca',5654.0,-94.48,16.37).
city('Ixtepec','mx','Oaxaca',23151.0,-95.12,16.58).
city('Jalapa','mx','Oaxaca',7110.0,-95.99,17.29).
city('Jamiltepec','mx','Oaxaca',9928.0,-97.82,16.28).
city('Jicayan','mx','Oaxaca',4405.0,-97.98,16.42).
city('Juchitan','mx','Oaxaca',67640.0,-95.02,16.43).
city('Juquila','mx','Oaxaca',5318.0,-97.3,16.23).
city('Juxtlahuaca','mx','Oaxaca',8309.0,-98.02,17.33).
city('Loma Bonita','mx','Oaxaca',30357.0,-95.88,18.12).
city('Magdalena Teitipac','mx','Oaxaca',3777.0,-96.6,16.92).
city('Magdalena Tequisistlan','mx','Oaxaca',3890.0,-95.25,16.37).
city('Matatlan','mx','Oaxaca',3064.0,-96.38,16.87).
city('Matias Romero','mx','Oaxaca',21064.0,-95.03,16.88).
city('Mechoacan','mx','Oaxaca',4407.0,-97.83,16.33).
city('Miahuatlan','mx','Oaxaca',17632.0,-96.6,16.33).
city('Mitla','mx','Oaxaca',7547.0,-96.4,16.92).
city('Mixtepec','mx','Oaxaca',3411.0,-96.68,16.18).
city('Mixtequilla','mx','Oaxaca',3526.0,-95.65,16.38).
city('Nazareno Etla','mx','Oaxaca',3463.0,-96.82,17.17).
city('Niltepec','mx','Oaxaca',3289.0,-94.62,16.57).
city('Oaxaca','mx','Oaxaca',262574.0,-96.72,17.07).
city('Ocotepec','mx','Oaxaca',5251.0,-96.4,16.8).
city('Ocotlan','mx','Oaxaca',13266.0,-96.72,16.8).
city('Ojitlan','mx','Oaxaca',6043.0,-96.38,18.07).
city('Palomares','mx','Oaxaca',4465.0,-95.05,17.13).
city('Panixtlahuaca','mx','Oaxaca',5682.0,-97.38,16.25).
city('Petapa','mx','Oaxaca',4560.0,-95.12,16.83).
city('Pinotepa Nacional','mx','Oaxaca',25669.0,-98.02,16.32).
city('Pinotepa de Don Luis','mx','Oaxaca',5527.0,-97.92,16.42).
city('Pochutla','mx','Oaxaca',13078.0,-96.47,15.73).
city('Puerto Escondido','mx','Oaxaca',19488.0,-97.07,15.85).
city('Putla','mx','Oaxaca',9486.0,-97.93,17.03).
city('Quetzaltepec','mx','Oaxaca',3610.0,-95.82,16.97).
city('Rincon Viejo','mx','Oaxaca',8540.0,-95.05,16.9).
city('Salina Cruz','mx','Oaxaca',73651.0,-95.2,16.17).
city('San Agustin de las Juntas','mx','Oaxaca',4921.0,-96.71,17.0).
city('San Antonio de la Cal','mx','Oaxaca',15673.0,-96.7,17.0).
city('San Dionisio del Mar','mx','Oaxaca',3281.0,-94.75,16.33).
city('San Francisco del Mar','mx','Oaxaca',4033.0,-94.65,16.23).
city('San Mateo del Mar','mx','Oaxaca',5441.0,-95.0,16.2).
city('Santa Lucia del Camino','mx','Oaxaca',49322.0,-96.72,17.05).
city('Santa Maria del Tule','mx','Oaxaca',7195.0,-96.62,17.03).
city('Santos Reyes Nopala','mx','Oaxaca',4830.0,-97.17,16.1).
city('Soyaltepec','mx','Oaxaca',8116.0,-96.48,18.2).
city('Suchilquitongo','mx','Oaxaca',6314.0,-96.88,17.25).
city('Tamazulapam','mx','Oaxaca',5028.0,-97.57,17.68).
city('Tapanatepec','mx','Oaxaca',7208.0,-94.2,16.35).
city('Tehuantepec','mx','Oaxaca',37391.0,-95.23,16.33).
city('Teitipac','mx','Oaxaca',2970.0,-96.6,16.93).
city('Telixtlahuaca','mx','Oaxaca',9000.0,-96.9,17.28).
city('Teotitlan','mx','Oaxaca',6570.0,-97.08,18.13).
city('Teotitlan den Valle','mx','Oaxaca',4812.0,-96.5,17.03).
city('Tilquiapam','mx','Oaxaca',3281.0,-96.59,16.78).
city('Tlacolula','mx','Oaxaca',11689.0,-96.48,16.95).
city('Tlalixtac','mx','Oaxaca',6581.0,-96.65,17.07).
city('Tlaxiaco','mx','Oaxaca',14608.0,-97.68,17.27).
city('Tutla','mx','Oaxaca',3318.0,-97.6,17.75).
city('Tuxtepec','mx','Oaxaca',92124.0,-96.12,18.09).
city('Union Hidalgo','mx','Oaxaca',12736.0,-94.83,16.47).
city('Usila','mx','Oaxaca',5063.0,-96.55,17.88).
city('Valle Nacional','mx','Oaxaca',6701.0,-96.32,17.78).
city('Xadani','mx','Oaxaca',5895.0,-96.07,15.93).
city('Xitla','mx','Oaxaca',3515.0,-96.67,16.32).
city('Xoxocotlan','mx','Oaxaca',61848.0,-96.73,17.02).
city('Yaitepec','mx','Oaxaca',3247.0,-97.23,16.23).
city('Zaachila','mx','Oaxaca',12240.0,-96.77,16.92).
city('Zacatepec','mx','Oaxaca',4444.0,-97.98,16.77).
city('Zanatepec','mx','Oaxaca',7025.0,-94.35,16.48).
city('Zimatlan','mx','Oaxaca',10014.0,-96.78,16.87).
city('Acajete','mx','Puebla',18068.0,-97.95,19.1).
city('Acateno','mx','Puebla',3295.0,-97.2,20.13).
city('Acatlan','mx','Puebla',11402.0,-97.98,18.59).
city('Acatzingo','mx','Puebla',22386.0,-97.78,18.98).
city('Actipan','mx','Puebla',6037.0,-97.78,18.97).
city('Acuexcomac','mx','Puebla',4236.0,-98.38,19.03).
city('Ahuatempan','mx','Puebla',4246.0,-98.02,18.42).
city('Ajalpan','mx','Puebla',24218.0,-97.25,18.37).
city('Aljojuca','mx','Puebla',4358.0,-97.52,19.1).
city('Almecatla','mx','Puebla',7366.0,-98.23,19.13).
city('Alseseca','mx','Puebla',6490.0,-97.68,18.83).
city('Altepexi','mx','Puebla',16587.0,-97.32,18.35).
city('Amecac','mx','Puebla',4242.0,-98.65,18.82).
city('Amozoc','mx','Puebla',57364.0,-98.05,19.03).
city('Aparicio','mx','Puebla',4601.0,-98.15,19.1).
city('Atempan','mx','Puebla',5284.0,-97.43,19.85).
city('Atencingo','mx','Puebla',12910.0,-98.6,18.52).
city('Atlixco','mx','Puebla',85894.0,-98.45,18.9).
city('Atoyatempan','mx','Puebla',6109.0,-97.92,18.82).
city('Atzitzintla','mx','Puebla',3424.0,-97.32,18.9).
city('Atzompa','mx','Puebla',4176.0,-98.33,19.03).
city('Ayutla','mx','Puebla',6749.0,-98.5,18.55).
city('Benito Juarez','mx','Puebla',4822.0,-97.75,19.83).
city('Buenos Aires','mx','Puebla',3684.0,-97.57,19.17).
city('Cacaloxuchitl','mx','Puebla',3669.0,-98.49,18.78).
city('Calipan','mx','Puebla',4454.0,-97.17,18.3).
city('Calmeca','mx','Puebla',4918.0,-98.63,18.63).
city('Calpan','mx','Puebla',10402.0,-98.45,19.1).
city('Caltenco','mx','Puebla',4761.0,-97.8,18.9).
city('Canada','mx','Puebla',4255.0,-97.42,18.73).
city('Canoa','mx','Puebla',14030.0,-98.08,19.15).
city('Caxhuacan','mx','Puebla',3816.0,-97.6,20.07).
city('Chapulco','mx','Puebla',4394.0,-97.4,18.62).
city('Chautla','mx','Puebla',5174.0,-98.15,18.95).
city('Chiapa','mx','Puebla',4405.0,-97.77,19.25).
city('Chiautla','mx','Puebla',11511.0,-98.6,18.28).
city('Chiautzingo','mx','Puebla',7176.0,-98.47,19.2).
city('Chietla','mx','Puebla',6902.0,-98.58,18.53).
city('Chignahuapan','mx','Puebla',16138.0,-98.03,19.83).
city('Chignautla','mx','Puebla',9259.0,-97.38,19.83).
city('Chilac','mx','Puebla',12099.0,-97.35,18.32).
city('Chilchotla','mx','Puebla',4348.0,-97.17,19.25).
city('Cholula','mx','Puebla',55808.0,-98.3,19.06).
city('Cit','mx','Puebla',4395.0,-97.27,18.97).
city('Coatepec','mx','Puebla',5631.0,-97.58,19.1).
city('Coronango','mx','Puebla',13563.0,-98.3,19.12).
city('Coxcatlan','mx','Puebla',5830.0,-97.15,18.27).
city('Cuacnopalan','mx','Puebla',7888.0,-97.5,18.82).
city('Cuanala','mx','Puebla',5230.0,-98.32,19.1).
city('Cuapiaxtla','mx','Puebla',5781.0,-97.82,18.92).
city('Cuautlancingo','mx','Puebla',17729.0,-98.27,19.08).
city('Cuayucatepec','mx','Puebla',8699.0,-97.48,18.5).
city('Cuetzalan','mx','Puebla',5785.0,-97.52,20.03).
city('Domingo Arenas','mx','Puebla',5812.0,-98.43,19.15).
city('Esperanza','mx','Puebla',8190.0,-97.4,18.87).
city('Guadalupe Victoria','mx','Puebla',9272.0,-97.35,19.28).
city('Huaquechula','mx','Puebla',3380.0,-98.55,18.77).
city('Huauchinango','mx','Puebla',49853.0,-98.07,20.19).
city('Huehuetlan','mx','Puebla',5268.0,-98.68,18.37).
city('Huejotzingo','mx','Puebla',21763.0,-98.4,19.15).
city('Hueyapan','mx','Puebla',5405.0,-98.67,18.86).
city('Hueyotlipan','mx','Puebla',4921.0,-97.85,18.9).
city('Hueytamalco','mx','Puebla',4255.0,-97.27,19.95).
city('Huixcolotla','mx','Puebla',10954.0,-99.37,19.36).
city('Ixcaquixtla','mx','Puebla',4716.0,-97.82,18.45).
city('Ixtiyucan','mx','Puebla',6513.0,-97.82,19.18).
city('Izucar','mx','Puebla',42937.0,-98.47,18.61).
city('Jolalpan','mx','Puebla',7301.0,-98.83,18.32).
city('La Ceiba','mx','Puebla',10190.0,-97.77,20.77).
city('Libres','mx','Puebla',13326.0,-97.68,19.47).
city('Los Ranchos','mx','Puebla',8203.0,-98.48,19.07).
city('Los Reyes de Juarez','mx','Puebla',17142.0,-97.82,18.93).
city('Malacatepec','mx','Puebla',4234.0,-98.3,18.93).
city('Metlaltoyuca','mx','Puebla',3989.0,-97.85,20.73).
city('Miahuatlan','mx','Puebla',10134.0,-97.35,18.43).
city('Momoxpan','mx','Puebla',16675.0,-98.23,19.07).
city('Moyotzingo','mx','Puebla',24555.0,-98.4,19.25).
city('Nealtican','mx','Puebla',11339.0,-98.42,19.05).
city('Necaxa','mx','Puebla',8375.0,-98.0,20.23).
city('Nopalucan','mx','Puebla',5641.0,-97.82,19.22).
city('Ocotitlan','mx','Puebla',4749.0,-97.95,19.03).
city('Ocotlan','mx','Puebla',9894.0,-98.27,19.15).
city('Ocoyucan','mx','Puebla',4747.0,-98.28,18.97).
city('Oriental','mx','Puebla',9770.0,-97.62,19.37).
city('Pahuatlan','mx','Puebla',3490.0,-98.15,20.28).
city('Palmar de Bravo','mx','Puebla',4504.0,-97.57,18.83).
city('Puebla','mx','Puebla',1392137.0,-98.22,19.05).
city('Quecholac','mx','Puebla',8711.0,-97.67,18.95).
city('Raboso','mx','Puebla',4374.0,-98.43,18.57).
city('Rafael Lara Grajales','mx','Puebla',11441.0,-97.78,19.25).
city('San Gabriel Casa Blanca','mx','Puebla',14940.0,-97.13,18.16).
city('San Salvador el Seco','mx','Puebla',15271.0,-97.65,19.13).
city('San Sebastian Villanueva','mx','Puebla',6293.0,-97.72,19.05).
city('Sanctorum','mx','Puebla',22936.0,-98.25,19.1).
city('Santa Maria la Alta','mx','Puebla',6397.0,-97.67,18.6).
city('Serdan','mx','Puebla',22128.0,-97.45,18.98).
city('Soltepec','mx','Puebla',6508.0,-97.7,19.12).
city('Tecali','mx','Puebla',4508.0,-97.97,18.9).
city('Tecamachalco','mx','Puebla',26227.0,-97.73,18.88).
city('Tehuacan','mx','Puebla',241437.0,-97.38,18.45).
city('Tehuitzingo','mx','Puebla',6117.0,-98.28,18.35).
city('Tenango','mx','Puebla',4798.0,-98.18,18.65).
city('Tenextatiloyan','mx','Puebla',4352.0,-97.58,19.72).
city('Teontepec','mx','Puebla',5475.0,-97.52,18.5).
city('Teopantlan','mx','Puebla',3792.0,-98.27,18.72).
city('Teotlalcingo','mx','Puebla',6138.0,-98.48,19.23).
city('Tepango','mx','Puebla',3376.0,-97.82,20.0).
city('Tepatlaxco','mx','Puebla',15084.0,-97.97,19.07).
city('Tepeaca','mx','Puebla',24956.0,-97.9,18.97).
city('Tepeojuma','mx','Puebla',5131.0,-98.45,18.72).
city('Tepexi','mx','Puebla',4617.0,-97.93,18.58).
city('Tepulco','mx','Puebla',6214.0,-97.98,19.12).
city('Tetela Morelos','mx','Puebla',8461.0,-98.17,18.91).
city('Tetela de Ocampo','mx','Puebla',4234.0,-97.8,19.82).
city('Teteles','mx','Puebla',4750.0,-97.43,19.87).
city('Tetzoyocan','mx','Puebla',5593.0,-97.7,18.75).
city('Texmelucan','mx','Puebla',75906.0,-98.43,19.28).
city('Teziutlan','mx','Puebla',70822.0,-97.36,19.82).
city('Tianguismanalco','mx','Puebla',5310.0,-98.43,18.95).
city('Tlachichuca','mx','Puebla',7096.0,-97.42,19.1).
city('Tlacotepec','mx','Puebla',8716.0,-97.87,20.07).
city('Tlacoyalco','mx','Puebla',9399.0,-97.58,18.65).
city('Tlahuapan','mx','Puebla',7639.0,-98.57,19.33).
city('Tlaixpan','mx','Puebla',9031.0,-97.73,18.9).
city('Tlalancaleca','mx','Puebla',10406.0,-98.5,19.32).
city('Tlaltenango','mx','Puebla',5809.0,-98.33,19.17).
city('Tlanalapan','mx','Puebla',11792.0,-97.27,19.25).
city('Tlancualpican','mx','Puebla',4293.0,-98.7,18.43).
city('Tlanepantla','mx','Puebla',4476.0,-97.9,18.85).
city('Tlapanala','mx','Puebla',3471.0,-98.53,18.68).
city('Tlatlauquitepec','mx','Puebla',9720.0,-97.48,19.85).
city('Tlaxcalancingo','mx','Puebla',20363.0,-98.27,19.03).
city('Tlaxco','mx','Puebla',5228.0,-98.02,20.43).
city('Tochapan','mx','Puebla',15690.0,-97.62,18.9).
city('Tochimilco','mx','Puebla',3688.0,-98.57,18.9).
city('Tochtepec','mx','Puebla',6050.0,-97.82,18.83).
city('Tulcingo','mx','Puebla',5607.0,-98.43,18.05).
city('Xalmimilulco','mx','Puebla',14144.0,-98.38,19.22).
city('Xaltepec','mx','Puebla',7353.0,-97.6,18.87).
city('Xicotepec','mx','Puebla',37426.0,-97.97,20.3).
city('Xiutetelco','mx','Puebla',6971.0,-97.33,19.8).
city('Xochiltenango','mx','Puebla',8337.0,-97.85,18.93).
city('Xochitlan','mx','Puebla',4659.0,-97.78,18.7).
city('Xonatepec','mx','Puebla',11041.0,-98.1,19.08).
city('Xoxtla','mx','Puebla',10089.0,-98.32,19.17).
city('Yaonahuac','mx','Puebla',4191.0,-97.45,19.87).
city('Yehualtepec','mx','Puebla',6329.0,-97.65,18.78).
city('Zacapoaxtla','mx','Puebla',8771.0,-97.58,19.88).
city('Zacatepec','mx','Puebla',10204.0,-97.53,19.27).
city('Zacatlan','mx','Puebla',31708.0,-97.97,19.93).
city('Zaragoza','mx','Puebla',10575.0,-97.55,19.77).
city('Zinacatepec','mx','Puebla',14826.0,-97.25,18.33).
city('Zongozotla','mx','Puebla',4467.0,-97.73,19.98).
city('Zozutla','mx','Puebla',5933.0,-97.65,18.75).
city('Ajuchitlan','mx','Queretaro',4876.0,-100.02,20.72).
city('Amazcala','mx','Queretaro',4780.0,-100.27,20.7).
city('Amealco','mx','Queretaro',7827.0,-100.15,20.18).
city('Cadereyta','mx','Queretaro',11524.0,-99.82,20.7).
city('Colon','mx','Queretaro',7088.0,-100.05,20.8).
city('El Colorado','mx','Queretaro',4572.0,-100.25,20.57).
city('El Pueblito','mx','Queretaro',47203.0,-100.45,20.53).
city('El Sauz','mx','Queretaro',6569.0,-100.1,20.47).
city('Ezequiel Montes','mx','Queretaro',12443.0,-99.88,20.67).
city('Huimilpan','mx','Queretaro',3434.0,-100.28,20.37).
city('Jalpan','mx','Queretaro',9291.0,-99.48,21.23).
city('Jauregui','mx','Queretaro',17091.0,-100.45,20.73).
city('La Canada','mx','Queretaro',10089.0,-100.32,20.62).
city('La Estancia','mx','Queretaro',5579.0,-100.07,20.42).
city('La Lira','mx','Queretaro',5328.0,-100.15,20.47).
city('La Llave','mx','Queretaro',5644.0,-99.98,20.47).
city('Pedro Escobedo','mx','Queretaro',8920.0,-100.13,20.5).
city('Queretaro','mx','Queretaro',611803.0,-100.4,20.59).
city('San Jose el Alto','mx','Queretaro',5957.0,-100.37,20.65).
city('San Juan del Rio','mx','Queretaro',118178.0,-100.0,20.38).
city('San Nicolas','mx','Queretaro',4632.0,-99.92,20.48).
city('San Pedro Martir','mx','Queretaro',5299.0,-100.35,20.3).
city('Tequisquiapan','mx','Queretaro',28963.0,-99.87,20.52).
city('Tlacote el Bajo','mx','Queretaro',5419.0,-100.5,20.65).
city('Bacalar','mx','Quintana Roo',11513.0,-88.38,18.67).
city('Bonfil','mx','Quintana Roo',10153.0,-86.87,21.06).
city('Calderitas','mx','Quintana Roo',5599.0,-88.25,18.55).
city('Cancun','mx','Quintana Roo',542156.0,-86.83,21.17).
city('Chetumal','mx','Quintana Roo',134464.0,-88.29,18.5).
city('Chunhuhub','mx','Quintana Roo',5231.0,-88.68,19.55).
city('Cozumel','mx','Quintana Roo',73938.0,-86.95,20.51).
city('Felipe Carrillo Puerto','mx','Quintana Roo',23109.0,-88.05,19.58).
city('Isla Mujeres','mx','Quintana Roo',12491.0,-86.72,21.2).
city('Kantunilkin','mx','Quintana Roo',7205.0,-87.49,21.1).
city('Leona Vicario','mx','Quintana Roo',5731.0,-87.19,21.0).
city('Nicolas Bravo','mx','Quintana Roo',4571.0,-88.92,18.45).
city('Playa del Carmen','mx','Quintana Roo',54346.0,-87.07,20.62).
city('Tulum','mx','Quintana Roo',8390.0,-87.47,20.22).
city('Ahualulco','mx','San Luis Potosi',3844.0,-101.17,22.4).
city('Axtla','mx','San Luis Potosi',6522.0,-98.85,21.47).
city('Cardenas','mx','San Luis Potosi',15331.0,-99.67,22.0).
city('Cedral','mx','San Luis Potosi',9475.0,-100.75,23.83).
city('Cerritos','mx','San Luis Potosi',13453.0,-100.28,22.43).
city('Charcas','mx','San Luis Potosi',11365.0,-101.12,23.13).
city('Ciudad Valles','mx','San Luis Potosi',109508.0,-99.02,21.98).
city('Ciudad del Maiz','mx','San Luis Potosi',8456.0,-99.6,22.4).
city('Dulce Grande','mx','San Luis Potosi',5426.0,-102.17,23.0).
city('Ebano','mx','San Luis Potosi',21258.0,-98.37,22.22).
city('El Naranjo','mx','San Luis Potosi',9458.0,-98.6,21.47).
city('Escalerillas','mx','San Luis Potosi',4124.0,-101.07,22.13).
city('Fernandez','mx','San Luis Potosi',29672.0,-100.0,21.95).
city('Juarez','mx','San Luis Potosi',3850.0,-100.27,22.33).
city('La Pila','mx','San Luis Potosi',5149.0,-100.87,22.05).
city('Los Zacatones','mx','San Luis Potosi',5913.0,-102.05,22.95).
city('Matehuala','mx','San Luis Potosi',67720.0,-100.65,23.66).
city('Matlapa','mx','San Luis Potosi',3445.0,-98.82,21.34).
city('Moctezuma','mx','San Luis Potosi',4000.0,-101.02,22.78).
city('Rayon','mx','San Luis Potosi',5298.0,-99.67,21.85).
city('Rioverde','mx','San Luis Potosi',48857.0,-99.98,21.93).
city('Salinas','mx','San Luis Potosi',13973.0,-101.72,22.63).
city('Salitral','mx','San Luis Potosi',4152.0,-102.08,22.85).
city('San Ciro de Acosta','mx','San Luis Potosi',6771.0,-99.82,21.63).
city('San Luis Potosi','mx','San Luis Potosi',677726.0,-100.98,22.16).
city('Santa Maria del Rio','mx','San Luis Potosi',12097.0,-100.75,21.8).
city('Soledad','mx','San Luis Potosi',194014.0,-100.96,22.18).
city('Tamasopo','mx','San Luis Potosi',3914.0,-99.48,21.93).
city('Tamazunchale','mx','San Luis Potosi',21532.0,-98.78,21.27).
city('Tamuin','mx','San Luis Potosi',14748.0,-98.75,21.98).
city('Tancanhuitz','mx','San Luis Potosi',3039.0,-98.97,21.6).
city('Tancuayalab','mx','San Luis Potosi',5913.0,-98.57,21.73).
city('Tanquian','mx','San Luis Potosi',9201.0,-98.63,21.62).
city('Tierranueva','mx','San Luis Potosi',5362.0,-100.57,21.68).
city('Venado','mx','San Luis Potosi',4945.0,-101.02,22.93).
city('Villa de Arriaga','mx','San Luis Potosi',4651.0,-101.37,21.92).
city('Villa de Reyes','mx','San Luis Potosi',8787.0,-100.93,21.8).
city('Xilitla','mx','San Luis Potosi',5906.0,-98.97,21.33).
city('Zaragoza','mx','San Luis Potosi',8296.0,-100.73,22.03).
city('Adolfo Ruiz Cortines','mx','Sinaloa',12947.0,-108.75,25.75).
city('Agua Verde','mx','Sinaloa',4192.0,-106.05,22.9).
city('Ahome','mx','Sinaloa',10806.0,-109.17,25.91).
city('Angostura','mx','Sinaloa',4587.0,-108.18,25.37).
city('Badiraguato','mx','Sinaloa',3634.0,-107.55,25.37).
city('Bagojo','mx','Sinaloa',4395.0,-109.12,25.87).
city('Campo Gobierno','mx','Sinaloa',20985.0,-107.54,24.65).
city('Choix','mx','Sinaloa',7623.0,-108.33,26.72).
city('Compuertas','mx','Sinaloa',4163.0,-108.35,25.45).
city('Concordia','mx','Sinaloa',7560.0,-106.07,23.28).
city('Constancia','mx','Sinaloa',5836.0,-107.19,24.22).
city('Cosala','mx','Sinaloa',5910.0,-106.69,24.41).
city('Costa Rica','mx','Sinaloa',21665.0,-107.39,24.59).
city('Culiacan','mx','Sinaloa',582489.0,-107.39,24.8).
city('Culiacancito','mx','Sinaloa',4201.0,-107.53,24.82).
city('El Burrion','mx','Sinaloa',4169.0,-108.4,25.53).
city('El Carrizo','mx','Sinaloa',4931.0,-106.88,24.03).
city('El Fuerte','mx','Sinaloa',11171.0,-108.62,26.42).
city('El Rosario','mx','Sinaloa',14577.0,-107.18,24.26).
city('Eldorado','mx','Sinaloa',14136.0,-107.37,24.33).
city('Escuinapa','mx','Sinaloa',28249.0,-105.8,22.85).
city('Gabriel Leyva Solano','mx','Sinaloa',27537.0,-108.64,25.67).
city('Guamuchil','mx','Sinaloa',59279.0,-108.09,25.47).
city('Guasave','mx','Sinaloa',68452.0,-108.47,25.57).
city('Higuera','mx','Sinaloa',9037.0,-109.28,25.95).
city('Isla del Bosque','mx','Sinaloa',5156.0,-105.85,22.73).
city('Jahuara Segundo','mx','Sinaloa',5318.0,-108.93,25.98).
city('Juan Jose Rios','mx','Sinaloa',26382.0,-108.83,25.75).
city('La Cruz','mx','Sinaloa',11900.0,-106.9,23.92).
city('La Palma','mx','Sinaloa',8022.0,-107.44,24.8).
city('La Reforma','mx','Sinaloa',6943.0,-108.05,25.08).
city('La Trinidad','mx','Sinaloa',4385.0,-108.48,25.73).
city('Los Mochis','mx','Sinaloa',214610.0,-109.0,25.79).
city('Mazatlan','mx','Sinaloa',354730.0,-106.42,23.22).
city('Mochicahui','mx','Sinaloa',4999.0,-108.93,25.93).
city('Mocorito','mx','Sinaloa',5304.0,-107.92,25.48).
city('Navolato','mx','Sinaloa',28462.0,-107.69,24.77).
city('Pericos','mx','Sinaloa',6638.0,-107.7,25.08).
city('Quila','mx','Sinaloa',5603.0,-107.22,24.42).
city('San Blas','mx','Sinaloa',6353.0,-108.77,26.08).
city('San Ignacio','mx','Sinaloa',4293.0,-106.42,23.92).
city('Sinaloa','mx','Sinaloa',4297.0,-108.23,25.83).
city('Teacapan','mx','Sinaloa',4421.0,-105.75,22.55).
city('Topolobampo','mx','Sinaloa',7580.0,-109.05,25.6).
city('Villa Union','mx','Sinaloa',13683.0,-106.23,23.2).
city('Zapotitlan','mx','Sinaloa',6152.0,-109.05,25.93).
city('Agua Prieta','mx','Sonora',68449.0,-109.56,31.33).
city('Alamos','mx','Sonora',8521.0,-108.93,27.02).
city('Altar','mx','Sonora',6193.0,-111.82,30.7).
city('Bacobampo','mx','Sonora',8747.0,-109.66,26.98).
city('Bacum','mx','Sonora',3830.0,-110.08,27.55).
city('Bahia de Kino','mx','Sonora',5201.0,-111.93,28.83).
city('Benjamin Hill','mx','Sonora',5735.0,-111.1,30.17).
city('Caborca','mx','Sonora',52899.0,-112.16,30.72).
city('Campo Sesenta','mx','Sonora',6012.0,-110.12,27.47).
city('Cananea','mx','Sonora',33435.0,-110.3,30.99).
city('Carbo','mx','Sonora',4443.0,-110.97,29.68).
city('Cocorit','mx','Sonora',8695.0,-109.97,27.58).
city('Cumpas','mx','Sonora',2979.0,-109.78,29.98).
city('Empalme','mx','Sonora',38601.0,-110.82,27.97).
city('Esperanza','mx','Sonora',34381.0,-109.93,27.58).
city('Esqueda','mx','Sonora',6119.0,-109.57,30.72).
city('Etchojoa','mx','Sonora',8571.0,-109.63,26.92).
city('Etchoropo','mx','Sonora',4360.0,-109.69,26.76).
city('Guaymas','mx','Sonora',103454.0,-110.91,27.92).
city('Hermosillo','mx','Sonora',595833.0,-110.97,29.07).
city('Huatabampo','mx','Sonora',30428.0,-109.63,26.83).
city('Imuris','mx','Sonora',6117.0,-110.87,30.78).
city('Juarez','mx','Sonora',14680.0,-109.83,27.12).
city('Kino','mx','Sonora',23359.0,-110.95,30.63).
city('La Doce','mx','Sonora',23870.0,-111.48,28.85).
city('La Union','mx','Sonora',5006.0,-109.6,26.8).
city('Moctezuma','mx','Sonora',4028.0,-109.67,29.82).
city('Naco','mx','Sonora',5193.0,-109.94,31.33).
city('Nacozari','mx','Sonora',11872.0,-109.65,30.42).
city('Navajoa','mx','Sonora',102175.0,-109.45,27.08).
city('Nogales','mx','Sonora',185890.0,-110.95,31.31).
city('Obregon','mx','Sonora',258174.0,-109.93,27.48).
city('Pitiquito','mx','Sonora',5157.0,-112.08,30.7).
city('Potam','mx','Sonora',5859.0,-110.38,27.6).
city('Providencia','mx','Sonora',4916.0,-111.58,28.72).
city('Puerto Penasco','mx','Sonora',33877.0,-113.53,31.32).
city('Rio Muerto','mx','Sonora',7358.0,-110.23,27.42).
city('Sahuaripa','mx','Sonora',4038.0,-109.23,29.05).
city('San Luis Rio Colorado','mx','Sonora',139261.0,-114.78,32.46).
city('Santa Ana','mx','Sonora',10277.0,-111.13,30.53).
city('Sonoita','mx','Sonora',9783.0,-112.83,31.85).
city('Tobarito','mx','Sonora',9065.0,-109.89,27.36).
city('Ures','mx','Sonora',4199.0,-110.4,29.43).
city('Vicam','mx','Sonora',8837.0,-110.28,27.63).
city('Yaqui','mx','Sonora',14802.0,-110.03,27.35).
city('Yavaros','mx','Sonora',4058.0,-109.52,26.7).
city('Aquiles Serdan','mx','Tabasco',4277.0,-92.28,17.78).
city('Ayapa','mx','Tabasco',4761.0,-93.17,18.18).
city('Balancan','mx','Tabasco',11895.0,-91.53,17.8).
city('Belen','mx','Tabasco',5680.0,-92.62,17.8).
city('Buenavista','mx','Tabasco',4468.0,-92.53,17.92).
city('Cardenas','mx','Tabasco',85354.0,-93.37,18.01).
city('Chontalpa','mx','Tabasco',6145.0,-93.52,17.7).
city('Comalcalco','mx','Tabasco',40992.0,-93.22,18.27).
city('Cunduacan','mx','Tabasco',17904.0,-93.17,18.07).
city('El Triunfo','mx','Tabasco',5965.0,-91.17,17.92).
city('Emiliano Zapata','mx','Tabasco',18608.0,-91.77,17.75).
city('Frontera','mx','Tabasco',22621.0,-92.65,18.58).
city('Huimanguillo','mx','Tabasco',26602.0,-93.38,17.85).
city('Jalapa','mx','Tabasco',5025.0,-92.82,17.72).
city('Jalpa','mx','Tabasco',15320.0,-93.08,18.13).
city('Jonuta','mx','Tabasco',6483.0,-92.13,18.08).
city('La Venta','mx','Tabasco',9511.0,-94.03,18.1).
city('Luis Gil Perez','mx','Tabasco',5489.0,-93.05,17.87).
city('Macultepec','mx','Tabasco',6430.0,-92.83,18.17).
city('Macuspana','mx','Tabasco',30410.0,-92.6,17.77).
city('Magana','mx','Tabasco',4898.0,-91.53,17.47).
city('Miguel Hidalgo','mx','Tabasco',4845.0,-91.15,17.27).
city('Nacajuca','mx','Tabasco',9471.0,-93.02,18.13).
city('Ocuiltzapotlan','mx','Tabasco',17074.0,-92.85,18.13).
city('Paraiso','mx','Tabasco',23830.0,-93.23,18.4).
city('Pemex','mx','Tabasco',6357.0,-92.5,17.9).
city('San Carlos','mx','Tabasco',13054.0,-91.15,17.55).
city('Santa Rosalia','mx','Tabasco',5533.0,-93.38,18.07).
city('Tacotalpa','mx','Tabasco',7460.0,-92.82,17.6).
city('Tamulte','mx','Tabasco',8295.0,-92.78,18.22).
city('Teapa','mx','Tabasco',26331.0,-92.95,17.55).
city('Tecolutilla','mx','Tabasco',9779.0,-93.32,18.28).
city('Tenosique','mx','Tabasco',32415.0,-91.43,17.48).
city('Villahermosa','mx','Tabasco',362416.0,-92.92,17.98).
city('Abasolo','mx','Tamaulipas',6740.0,-98.37,24.07).
city('Aldama','mx','Tamaulipas',12292.0,-98.07,22.92).
city('Altamira','mx','Tamaulipas',54956.0,-97.92,22.4).
city('Antiguo Morelos','mx','Tamaulipas',3219.0,-99.08,22.55).
city('Camargo','mx','Tamaulipas',10085.0,-98.83,26.27).
city('Cuauhtemoc','mx','Tamaulipas',5924.0,-98.15,22.53).
city('El Mante','mx','Tamaulipas',79985.0,-98.97,22.73).
city('Estacion Manuel','mx','Tamaulipas',12165.0,-98.32,22.73).
city('Gonzalez','mx','Tamaulipas',11098.0,-98.42,22.83).
city('Graciano Sanchez','mx','Tamaulipas',4411.0,-99.28,23.92).
city('Guerrero','mx','Tamaulipas',4384.0,-99.23,26.55).
city('Gustavo Diaz Ordaz','mx','Tamaulipas',12698.0,-98.58,26.23).
city('Hidalgo','mx','Tamaulipas',4810.0,-98.2,26.05).
city('Jaumave','mx','Tamaulipas',4421.0,-99.38,23.42).
city('Llerca','mx','Tamaulipas',4005.0,-99.0,23.32).
city('Los Guerra','mx','Tamaulipas',4984.0,-99.07,26.38).
city('Madero','mx','Tamaulipas',192743.0,-97.83,22.27).
city('Matamoros','mx','Tamaulipas',435159.0,-97.5,25.88).
city('Mier','mx','Tamaulipas',7259.0,-99.15,26.42).
city('Miguel Aleman','mx','Tamaulipas',19857.0,-99.1,26.35).
city('Miramar','mx','Tamaulipas',67692.0,-97.87,22.33).
city('Nuevo Laredo','mx','Tamaulipas',349562.0,-99.51,27.48).
city('Nuevo Progreso','mx','Tamaulipas',9125.0,-97.95,23.17).
city('Ocampo','mx','Tamaulipas',5150.0,-99.33,22.83).
city('Padilla','mx','Tamaulipas',5624.0,-98.78,24.02).
city('Reynosa','mx','Tamaulipas',498670.0,-98.28,26.08).
city('Rio Bravo','mx','Tamaulipas',85485.0,-98.09,25.98).
city('San Fernando','mx','Tamaulipas',29173.0,-98.16,24.85).
city('Santa Engracia','mx','Tamaulipas',6961.0,-99.2,24.02).
city('Santander Jimenez','mx','Tamaulipas',5562.0,-98.47,24.22).
city('Soto la Marina','mx','Tamaulipas',9712.0,-98.22,23.77).
city('Tampico','mx','Tamaulipas',309015.0,-97.85,22.22).
city('Tula','mx','Tamaulipas',9054.0,-99.72,23.0).
city('Valle Hermoso','mx','Tamaulipas',47838.0,-97.83,25.67).
city('Victoria','mx','Tamaulipas',269933.0,-99.13,23.73).
city('Xicotencatl','mx','Tamaulipas',9346.0,-98.88,23.02).
city('Altzayanca','mx','Tlaxcala',3353.0,-97.78,19.43).
city('Amaxac','mx','Tlaxcala',7710.0,-98.18,19.37).
city('Apetatitlan','mx','Tlaxcala',7026.0,-98.18,19.33).
city('Apizaco','mx','Tlaxcala',46461.0,-98.15,19.42).
city('Atexcatzingo','mx','Tlaxcala',4504.0,-98.13,19.47).
city('Ayometla','mx','Tlaxcala',7591.0,-98.2,19.2).
city('Benito Juarez','mx','Tlaxcala',5123.0,-97.92,19.37).
city('Calpulalpan','mx','Tlaxcala',29321.0,-98.58,19.58).
city('Chiautempan','mx','Tlaxcala',48324.0,-98.18,19.32).
city('Contla','mx','Tlaxcala',24569.0,-98.17,19.33).
city('Cuapiaxtla','mx','Tlaxcala',7147.0,-97.77,19.3).
city('Huamantla','mx','Tlaxcala',45905.0,-97.93,19.32).
city('Hueyotlipan','mx','Tlaxcala',4798.0,-98.35,19.48).
city('Huiloac','mx','Tlaxcala',5247.0,-98.15,19.4).
city('Ixtacuixtla','mx','Tlaxcala',6160.0,-98.37,19.33).
city('Ixtenco','mx','Tlaxcala',6304.0,-97.9,19.25).
city('Mazatecochco','mx','Tlaxcala',8960.0,-98.17,19.18).
city('Nanacamilpa','mx','Tlaxcala',11682.0,-98.55,19.48).
city('Nativitas','mx','Tlaxcala',7012.0,-98.32,19.23).
city('Panotla','mx','Tlaxcala',10644.0,-98.27,19.32).
city('Papalotla','mx','Tlaxcala',20759.0,-98.2,19.17).
city('Sanctorum','mx','Tlaxcala',4488.0,-98.47,19.5).
city('Teacalco','mx','Tlaxcala',3941.0,-98.3,19.25).
city('Tenancingo','mx','Tlaxcala',10960.0,-98.18,19.15).
city('Teolocholco','mx','Tlaxcala',15690.0,-98.18,19.25).
city('Tepetitla','mx','Tlaxcala',8034.0,-98.38,19.28).
city('Tepeyanco','mx','Tlaxcala',3370.0,-98.25,19.25).
city('Tequixquitla','mx','Tlaxcala',12548.0,-97.65,19.33).
city('Terrenate','mx','Tlaxcala',4348.0,-97.92,19.48).
city('Tetla','mx','Tlaxcala',12465.0,-98.1,19.43).
city('Tetlanohcan','mx','Tlaxcala',9832.0,-98.15,19.25).
city('Texcalac','mx','Tlaxcala',5733.0,-98.08,19.42).
city('Tlaltelulco','mx','Tlaxcala',14860.0,-98.18,19.27).
city('Tlaxcala','mx','Tlaxcala',84674.0,-98.24,19.31).
city('Tlaxco','mx','Tlaxcala',12553.0,-98.12,19.62).
city('Tocatlan','mx','Tlaxcala',5123.0,-98.02,19.38).
city('Totolac','mx','Tlaxcala',5774.0,-98.25,19.32).
city('Vicente Guerrero','mx','Tlaxcala',52594.0,-98.17,19.13).
city('Xaloztoc','mx','Tlaxcala',17465.0,-98.05,19.4).
city('Xaltocan','mx','Tlaxcala',4512.0,-98.2,19.42).
city('Xicohtzinco','mx','Tlaxcala',11094.0,-98.22,19.18).
city('Xiloxoxtla','mx','Tlaxcala',3454.0,-98.2,19.27).
city('Yauhquemecan','mx','Tlaxcala',4266.0,-98.17,19.42).
city('Zacatelco','mx','Tlaxcala',32573.0,-98.23,19.22).
city('Zitlaltepec','mx','Tlaxcala',6800.0,-97.9,19.2).
city('Acayucan','mx','Veracruz',46992.0,-94.92,17.95).
city('Actopan','mx','Veracruz',3990.0,-96.62,19.5).
city('Acultzingo','mx','Veracruz',5801.0,-97.32,18.72).
city('Agua Dulce','mx','Veracruz',21082.0,-95.7,19.25).
city('Alamo','mx','Veracruz',22741.0,-97.67,20.93).
city('Allende','mx','Veracruz',21398.0,-94.4,18.15).
city('Altamirano','mx','Veracruz',4714.0,-96.33,19.1).
city('Alto Lucero','mx','Veracruz',4564.0,-96.72,19.62).
city('Altotonga','mx','Veracruz',15800.0,-97.23,19.77).
city('Alvarado','mx','Veracruz',21519.0,-95.77,18.77).
city('Amatlan','mx','Veracruz',7634.0,-96.92,18.83).
city('Anahuac','mx','Veracruz',13074.0,-97.87,22.2).
city('Anton Lizardo','mx','Veracruz',6535.0,-95.98,19.05).
city('Atzacan','mx','Veracruz',7888.0,-97.08,18.9).
city('Azueta','mx','Veracruz',6783.0,-95.67,18.13).
city('Banderilla','mx','Veracruz',15757.0,-96.93,19.58).
city('Benito Juarez','mx','Veracruz',13001.0,-98.2,20.9).
city('Boca del Monte','mx','Veracruz',4434.0,-96.82,19.15).
city('Boca del Rio','mx','Veracruz',11099.0,-96.12,19.12).
city('Cabada','mx','Veracruz',11065.0,-95.44,18.58).
city('Carrillo','mx','Veracruz',17990.0,-95.75,18.37).
city('Castillo de Teayo','mx','Veracruz',4267.0,-97.62,20.75).
city('Catemaco','mx','Veracruz',24258.0,-95.12,18.42).
city('Cazones','mx','Veracruz',4001.0,-97.32,20.72).
city('Cerro Azul','mx','Veracruz',19633.0,-97.73,21.2).
city('Chacaltianguis','mx','Veracruz',4084.0,-95.83,18.33).
city('Chicontepec','mx','Veracruz',4480.0,-98.17,20.97).
city('Chinameca','mx','Veracruz',7094.0,-94.67,18.02).
city('Chinampa','mx','Veracruz',4871.0,-97.73,21.37).
city('Chocaman','mx','Veracruz',9277.0,-97.02,19.02).
city('Clara','mx','Veracruz',12332.0,-95.4,18.0).
city('Coacoatzintla','mx','Veracruz',4978.0,-96.93,19.63).
city('Coacotla','mx','Veracruz',6428.0,-94.67,17.94).
city('Coatepec','mx','Veracruz',48455.0,-96.97,19.45).
city('Coatzacoalcos','mx','Veracruz',230727.0,-94.42,18.14).
city('Coatzintla','mx','Veracruz',30608.0,-97.45,20.48).
city('Comoapan','mx','Veracruz',4846.0,-95.17,18.42).
city('Cordoba','mx','Veracruz',134409.0,-96.92,18.89).
city('Corral Nuevo','mx','Veracruz',4547.0,-95.15,18.13).
city('Cosamaloapan','mx','Veracruz',28773.0,-95.8,18.37).
city('Cosautlan','mx','Veracruz',4575.0,-96.98,19.33).
city('Coscomatepec','mx','Veracruz',12920.0,-97.03,19.07).
city('Cosoleacaque','mx','Veracruz',20372.0,-94.65,18.01).
city('Coxquihui','mx','Veracruz',3716.0,-97.58,20.18).
city('Coyutla','mx','Veracruz',7939.0,-97.65,20.25).
city('Cuauhtemoc','mx','Veracruz',9426.0,-97.83,22.18).
city('Cuautlapan','mx','Veracruz',6928.0,-97.03,18.87).
city('Cuichapa','mx','Veracruz',8268.0,-96.87,18.77).
city('Cuitlahuac','mx','Veracruz',12331.0,-96.72,18.82).
city('El Castillo','mx','Veracruz',4107.0,-96.85,19.53).
city('El Higo','mx','Veracruz',8175.0,-98.47,21.77).
city('El Tejar','mx','Veracruz',10511.0,-96.17,19.07).
city('Emilio Carranza','mx','Veracruz',5887.0,-96.6,19.97).
city('Filomeno Mata','mx','Veracruz',8973.0,-97.7,20.2).
city('Fortin','mx','Veracruz',20668.0,-97.0,18.9).
city('Gutierrez Zamora','mx','Veracruz',14735.0,-97.08,20.45).
city('Hidalgo','mx','Veracruz',5802.0,-96.87,19.97).
city('Hidalgotitlan','mx','Veracruz',3770.0,-94.63,17.78).
city('Huatusco','mx','Veracruz',29389.0,-96.95,19.16).
city('Huayacoctla','mx','Veracruz',4258.0,-98.49,20.58).
city('Hueyapan','mx','Veracruz',3541.0,-95.15,18.12).
city('Huiloapan','mx','Veracruz',3780.0,-97.32,18.75).
city('Ignacio de la Llave','mx','Veracruz',4888.0,-95.98,18.72).
city('Isla','mx','Veracruz',24558.0,-96.15,18.6).
city('Ixcatepec','mx','Veracruz',3655.0,-97.95,21.2).
city('Ixhuatlan del Cafe','mx','Veracruz',6566.0,-96.98,19.05).
city('Ixhuatlancillo','mx','Veracruz',4680.0,-97.15,18.9).
city('Ixtaczoquitlan','mx','Veracruz',23522.0,-97.07,18.85).
city('Jalacingo','mx','Veracruz',10216.0,-97.3,19.8).
city('Jalapilla','mx','Veracruz',5561.0,-97.08,18.83).
city('Jaltipan','mx','Veracruz',28525.0,-94.74,17.94).
city('Jamapa','mx','Veracruz',3815.0,-96.23,19.03).
city('Jesus Carranza','mx','Veracruz',3615.0,-95.03,17.43).
city('Jilotepec','mx','Veracruz',3219.0,-96.97,19.62).
city('La Antigua','mx','Veracruz',18070.0,-96.37,19.37).
city('La Estanzuela','mx','Veracruz',4066.0,-96.27,18.5).
city('La Pena','mx','Veracruz',8331.0,-97.4,20.95).
city('La Perla','mx','Veracruz',3249.0,-97.13,18.93).
city('La Poza','mx','Veracruz',16286.0,-96.97,20.12).
city('Las Amapolas','mx','Veracruz',4865.0,-95.62,18.4).
city('Las Choapas','mx','Veracruz',40306.0,-94.08,17.93).
city('Las Vigas','mx','Veracruz',8037.0,-97.08,19.63).
city('Lerdo','mx','Veracruz',18941.0,-95.52,18.62).
city('Los Altos','mx','Veracruz',4771.0,-97.77,21.52).
city('Los Mangos','mx','Veracruz',4996.0,-97.82,22.22).
city('Maltrata','mx','Veracruz',10496.0,-97.27,18.8).
city('Mariano Escobedo','mx','Veracruz',3052.0,-97.12,18.92).
city('Martinez','mx','Veracruz',55669.0,-97.05,20.06).
city('Mecatlan','mx','Ver',4509.0,-97.68,20.22).
city('Mecayapan','mx','Veracruz',5005.0,-94.83,18.22).
city('Mendoza','mx','Veracruz',35547.0,-97.17,18.82).
city('Minatitlan','mx','Veracruz',150902.0,-94.52,17.98).
city('Misantla','mx','Veracruz',23242.0,-96.83,19.93).
city('Monte Blanco','mx','Veracruz',7652.0,-97.02,18.97).
city('Moralillo','mx','Veracruz',9126.0,-97.9,22.22).
city('Motzorongo','mx','Veracruz',4014.0,-96.73,18.63).
city('Mundo Nuevo','mx','Veracruz',9288.0,-95.5,18.7).
city('Nanchital','mx','Veracruz',25983.0,-94.4,18.07).
city('Naolinco','mx','Veracruz',8246.0,-96.85,19.65).
city('Naranjos','mx','Veracruz',19689.0,-97.7,21.36).
city('Nautla','mx','Veracruz',2890.0,-96.78,20.22).
city('Nogales','mx','Veracruz',19904.0,-97.13,18.84).
city('Oluta','mx','Veracruz',11489.0,-94.9,17.92).
city('Omealca','mx','Veracruz',3818.0,-96.77,18.75).
city('Orizaba','mx','Veracruz',121353.0,-97.1,18.83).
city('Otatitlan','mx','Veracruz',4653.0,-96.03,18.2).
city('Oteapan','mx','Veracruz',12378.0,-94.65,18.0).
city('Ozuluama','mx','Veracruz',3733.0,-97.85,21.67).
city('Pajapan','mx','Veracruz',7461.0,-94.7,18.25).
city('Panuco','mx','Veracruz',35318.0,-98.19,22.06).
city('Papantla','mx','Veracruz',47961.0,-97.33,20.46).
city('Paraje Nuevo','mx','Veracruz',4190.0,-96.87,18.87).
city('Paso de Ovejas','mx','Veracruz',6951.0,-96.43,19.28).
city('Paso del Macho','mx','Veracruz',12043.0,-96.72,18.97).
city('Paso del Toro','mx','Veracruz',4139.0,-96.12,19.03).
city('Perote','mx','Veracruz',32560.0,-97.23,19.57).
city('Piedras Negras','mx','Veracruz',8454.0,-96.17,18.77).
city('Platon Sanchez','mx','Veracruz',10169.0,-98.37,21.28).
city('Playa Vicente','mx','Veracruz',7701.0,-95.82,17.83).
city('Potrero Nuevo','mx','Veracruz',14181.0,-96.1,18.17).
city('Potrero del Llano','mx','Veracruz',4513.0,-97.68,21.05).
city('Poza Rica','mx','Veracruz',174526.0,-97.47,20.55).
city('Puntilla Aldama','mx','Veracruz',4774.0,-96.92,20.18).
city('Rafael Delgado','mx','Veracruz',7823.0,-97.07,18.8).
city('Rafael Lucio','mx','Veracruz',3116.0,-96.97,19.58).
city('Rinconada','mx','Veracruz',6687.0,-96.52,19.35).
city('Saltabarranca','mx','Veracruz',2959.0,-95.53,18.6).
city('San Juan Evangelista','mx','Veracruz',4069.0,-95.13,17.9).
city('San Marcos','mx','Veracruz',6261.0,-96.95,20.2).
city('San Rafael','mx','Veracruz',6441.0,-96.85,20.2).
city('San Roman','mx','Veracruz',9549.0,-95.75,17.87).
city('Santiago Tuxtla','mx','Veracruz',15681.0,-95.3,18.47).
city('Sayula','mx','Veracruz',11059.0,-94.95,17.87).
city('Soconusco','mx','Veracruz',5082.0,-94.87,17.97).
city('Soledad','mx','Veracruz',12278.0,-96.42,19.05).
city('Soteapan','mx','Veracruz',4140.0,-94.87,18.23).
city('Tamalin','mx','Veracruz',4674.0,-97.8,21.35).
city('Tamiahua','mx','Veracruz',5265.0,-97.45,21.27).
city('Tantoyuca','mx','Veracruz',26930.0,-98.23,21.35).
city('Tatahuicapan','mx','Veracruz',6869.0,-94.75,18.23).
city('Tecolutla','mx','Veracruz',3879.0,-97.02,20.48).
city('Tempoal','mx','Veracruz',12558.0,-98.38,21.52).
city('Tenango de Rio Blanco','mx','Veracruz',39545.0,-97.11,18.85).
city('Teocelo','mx','Veracruz',9259.0,-96.97,19.38).
city('Tepetzint','mx','Veracruz',4930.0,-97.83,21.17).
city('Tequila','mx','Veracruz',3248.0,-97.07,18.73).
city('Tetelzingo','mx','Veracruz',4193.0,-97.15,19.07).
city('Texistepec','mx','Veracruz',8758.0,-94.78,17.88).
city('Tezonapa','mx','Veracruz',5100.0,-96.68,18.6).
city('Tierra Blanca','mx','Veracruz',45359.0,-96.34,18.45).
city('Tihuatlan','mx','Veracruz',12047.0,-97.53,20.72).
city('Tlacojalpan','mx','Veracruz',4090.0,-95.95,18.23).
city('Tlacotalpan','mx','Veracruz',8704.0,-95.67,18.62).
city('Tlapacoyan','mx','Veracruz',33669.0,-97.22,19.97).
city('Tocuila','mx','Veracruz',4248.0,-97.02,18.95).
city('Tomatlan','mx','Veracruz',3883.0,-97.0,19.03).
city('Totolapa','mx','Veracruz',6477.0,-96.18,18.52).
city('Totula','mx','Veracruz',3464.0,-96.94,19.21).
city('Tres Valles','mx','Veracruz',17939.0,-96.13,18.25).
city('Tuxpam','mx','Veracruz',74493.0,-97.41,20.96).
city('Tuxtla','mx','Veracruz',55699.0,-95.22,18.45).
city('Tuzamapan','mx','Veracruz',6563.0,-96.85,19.4).
city('Union y Progreso','mx','Veracruz',5502.0,-96.85,20.07).
city('Ursulo Galvan','mx','Veracruz',5200.0,-96.35,19.4).
city('Vega de Alatorre','mx','Veracruz',6710.0,-96.63,20.03).
city('Veracruz','mx','Veracruz',568336.0,-96.14,19.19).
city('Xalapa','mx','Veracruz',425166.0,-96.92,19.53).
city('Xico','mx','Veracruz',15292.0,-97.0,19.42).
city('Xocotla','mx','Veracruz',4736.0,-97.1,19.03).
city('Yanga','mx','Veracruz',5300.0,-96.8,18.83).
city('Yecuatla','mx','Veracruz',3198.0,-96.75,19.87).
city('Zaragoza','mx','Veracruz',8260.0,-97.72,21.28).
city('Zempoala','mx','Veracruz',9436.0,-96.42,19.45).
city('Zongolica','mx','Veracruz',6411.0,-96.98,18.67).
city('Zozocolco','mx','Veracruz',3370.0,-97.58,20.15).
city('Acanceh','mx','Yucatan',9892.0,-89.45,20.82).
city('Akil','mx','Yucatan',9858.0,-89.35,20.25).
city('Baca','mx','Yucatan',4356.0,-89.42,21.1).
city('Buctzotz','mx','Yucatan',7162.0,-88.78,21.2).
city('Cacalchen','mx','Yucatan',6671.0,-89.23,20.98).
city('Cansahcab','mx','Yucatan',4582.0,-89.1,21.17).
city('Caucel','mx','Yucatan',6396.0,-89.72,21.02).
city('Celestun','mx','Yucatan',6401.0,-90.4,20.87).
city('Cenotillo','mx','Yucatan',3176.0,-88.62,20.97).
city('Chemax','mx','Yucatan',10596.0,-87.93,20.65).
city('Chichimila','mx','Yucatan',4693.0,-88.22,20.62).
city('Chicxulub','mx','Yucatan',3613.0,-89.51,21.14).
city('Chochola','mx','Yucatan',4244.0,-89.83,20.75).
city('Cholul','mx','Yucatan',4716.0,-89.28,21.02).
city('Chumayel','mx','Yucatan',2982.0,-89.32,20.43).
city('Conkal','mx','Yucatan',6395.0,-89.53,21.07).
city('Cuzama','mx','Yucatan',3459.0,-89.32,20.73).
city('Dzan','mx','Yucatan',4532.0,-89.47,20.38).
city('Dzemul','mx','Yucatan',3072.0,-89.3,21.2).
city('Dzidzantun','mx','Yucatan',8301.0,-89.05,21.25).
city('Dzilam Gonzalez','mx','Yucatan',5941.0,-88.93,21.28).
city('Dzitas','mx','Yucatan',2909.0,-88.53,20.83).
city('Espita','mx','Yucatan',9960.0,-88.32,21.02).
city('Halacho','mx','Yucatan',9165.0,-90.08,20.48).
city('Hocaba','mx','Yucatan',3866.0,-89.25,20.82).
city('Hoctun','mx','Yucatan',491.0,-89.2,20.87).
city('Homun','mx','Yucatan',5423.0,-89.28,20.73).
city('Huhi','mx','Yucatan',4367.0,-89.17,20.72).
city('Hunucma','mx','Yucatan',22288.0,-89.87,21.02).
city('Itzincab','mx','Yucatan',5013.0,-89.7,20.92).
city('Ixil','mx','Yucatan',3375.0,-89.48,21.15).
city('Izamal','mx','Yucatan',14954.0,-89.02,20.93).
city('Kanasin','mx','Yucatan',40027.0,-89.57,20.93).
city('Kantunil','mx','Yucatan',3414.0,-89.03,20.8).
city('Kinchil','mx','Yucatan',5634.0,-89.95,20.92).
city('Mama','mx','Yucatan',2823.0,-89.37,20.48).
city('Mani','mx','Yucatan',3978.0,-89.4,20.38).
city('Maxcanu','mx','Yucatan',11930.0,-89.98,20.58).
city('Merida','mx','Yucatan',717196.0,-89.62,20.97).
city('Motul','mx','Yucatan',21109.0,-89.28,21.1).
city('Muna','mx','Yucatan',11363.0,-89.72,20.48).
city('Opichen','mx','Yucatan',4265.0,-89.85,20.55).
city('Oxkutzcab','mx','Yucatan',21508.0,-89.42,20.3).
city('Panaba','mx','Yucatan',5723.0,-88.27,21.28).
city('Peto','mx','Yucatan',17607.0,-88.92,20.13).
city('Piste','mx','Yucatan',4674.0,-88.58,20.7).
city('Progreso','mx','Yucatan',47124.0,-89.67,21.28).
city('Sacalum','mx','Yucatan',3214.0,-89.58,20.48).
city('Santa Elena','mx','Yucatan',3335.0,-89.65,20.33).
city('Seye','mx','Yucatan',7834.0,-89.37,20.83).
city('Sotuta','mx','Yucatan',5291.0,-89.02,20.6).
city('Sucila','mx','Yucatan',3910.0,-88.32,21.15).
city('Tahmek','mx','Yucatan',3596.0,-89.27,20.88).
city('Teabo','mx','Yucatan',5040.0,-89.28,20.4).
city('Tecoh','mx','Yucatan',8700.0,-89.47,20.75).
city('Tekanto','mx','Yucatan',3425.0,-89.1,21.02).
city('Tekax','mx','Yucatan',22807.0,-89.28,20.2).
city('Tekit','mx','Yucatan',8852.0,-89.33,20.53).
city('Telchac','mx','Yucatan',3464.0,-89.28,21.2).
city('Temax','mx','Yucatan',6125.0,-88.93,21.15).
city('Temozon','mx','Yucatan',5441.0,-88.22,20.8).
city('Tetiz','mx','Yucatan',3774.0,-89.93,20.97).
city('Ticul','mx','Yucatan',30282.0,-89.53,20.4).
city('Timucuy','mx','Yucatan',3532.0,-89.52,20.82).
city('Tixkokob','mx','Yucatan',10228.0,-89.4,21.0).
city('Tixpehual','mx','Yucatan',3334.0,-89.52,20.98).
city('Tizimin','mx','Yucatan',41993.0,-88.15,21.13).
city('Tunkas','mx','Yucatan',3070.0,-88.75,20.88).
city('Tzucacab','mx','Yucatan',9819.0,-89.05,20.07).
city('Uman','mx','Yucatan',28473.0,-89.74,20.89).
city('Valladolid','mx','Yucatan',39663.0,-88.2,20.67).
city('X-Can','mx','Yucatan',4148.0,-87.65,20.88).
city('Apozol','mx','Zacatecas',2933.0,-103.1,21.48).
city('Banon','mx','Zacatecas',4137.0,-102.48,23.18).
city('Canitas','mx','Zacatecas',5965.0,-102.72,23.6).
city('Chalchihuites','mx','Zacatecas',4028.0,-103.88,23.48).
city('Concepcion del Oro','mx','Zacatecas',6523.0,-101.42,24.63).
city('Cos','mx','Zacatecas',4297.0,-102.35,23.28).
city('Estrada','mx','Zacatecas',3461.0,-102.74,23.0).
city('Fresnillo','mx','Zacatecas',105492.0,-102.86,23.17).
city('Garcia','mx','Zacatecas',5489.0,-101.95,22.17).
city('Gonzalez Ortega','mx','Zacatecas',5287.0,-101.92,22.5).
city('Guadalupe','mx','Zacatecas',94110.0,-102.52,22.75).
city('Hidalgo','mx','Zacatecas',3856.0,-101.7,22.35).
city('Jalpa','mx','Zacatecas',13686.0,-102.97,21.63).
city('Jerez','mx','Zacatecas',37835.0,-103.0,22.65).
city('Juan Aldama','mx','Zacatecas',14162.0,-103.39,24.29).
city('Juchipila','mx','Zacatecas',6700.0,-103.12,21.42).
city('Loreto','mx','Zacatecas',19779.0,-101.97,22.27).
city('Luis Moya','mx','Zacatecas',5856.0,-102.25,22.42).
city('Miguel Auza','mx','Zacatecas',12685.0,-103.45,24.29).
city('Monte Escobedo','mx','Zacatecas',3776.0,-103.58,22.3).
city('Morelos','mx','Zacatecas',5650.0,-102.62,22.88).
city('Natera','mx','Zacatecas',4176.0,-102.12,22.67).
city('Nieves','mx','Zacatecas',5296.0,-103.02,24.0).
city('Nochistlan','mx','Zacatecas',15613.0,-102.85,21.37).
city('Ojo Caliente','mx','Zacatecas',18284.0,-102.25,22.57).
city('Piedra Gorda','mx','Zacatecas',7135.0,-102.35,22.45).
city('Pinos','mx','Zacatecas',4631.0,-101.57,22.3).
city('Plateros','mx','Zacatecas',4158.0,-102.85,23.22).
city('Pozo de Gamboa','mx','Zacatecas',4178.0,-102.57,22.95).
city('Rio Grande','mx','Zacatecas',29842.0,-103.03,23.83).
city('Sain Alto','mx','Zacatecas',4653.0,-103.25,23.58).
city('Sombrerete','mx','Zacatecas',18805.0,-103.65,23.63).
city('Tabasco','mx','Zacatecas',6626.0,-102.92,21.87).
city('Tacoaleche','mx','Zacatecas',6821.0,-102.42,22.82).
city('Tepechitlan','mx','Zacatecas',4419.0,-103.33,21.67).
city('Teul','mx','Zacatecas',3168.0,-103.48,21.47).
city('Tlaltenango','mx','Zacatecas',14240.0,-103.32,21.78).
city('Toribio','mx','Zacatecas',3825.0,-102.68,23.06).
city('Trancoso','mx','Zacatecas',10459.0,-102.37,22.73).
city('Valparaiso','mx','Zacatecas',10545.0,-103.57,22.77).
city('Victor Rosales','mx','Zacatecas',25898.0,-102.7,22.95).
city('Villa Gonzalez Ortega','mx','Zacatecas',4059.0,-103.46,23.94).
city('Villanueva','mx','Zacatecas',11138.0,-102.88,22.35).
city('Zacatecas','mx','Zacatecas',118566.0,-102.58,22.78).
city('Tol','fm','Chuuk',4909.0,151.62,7.53).
city('Weno','fm','Chuuk',17628.0,151.84,7.46).
city('Lelu','fm','Kusaie',4648.0,162.99,5.31).
city('Kolonia','fm','Pohn',4544.0,158.21,6.95).
city('Palikir','fm','Pohnpei',4645.0,158.16,6.92).
city('Colonia','fm','Yap',2097.0,138.1,9.52).
city('Balti','md','Balti',150472.0,27.91,47.76).
city('Falesti','md','Balti',17967.0,27.72,47.58).
city('Glodeni','md','Balti',12353.0,27.52,47.7).
city('Rascani','md','Balti',25055.0,27.57,47.96).
city('Cahul','md','Cahul',43778.0,28.19,45.91).
city('Chisinau','md','Chisinau Oras',713805.0,28.83,47.03).
city('Straseni','md','Chisinau',19652.0,28.61,47.15).
city('Briceni','md','Edinet',10762.0,27.67,48.37).
city('Donduseni','md','Edinet',9077.0,27.59,48.24).
city('Edinet','md','Edinet',18342.0,27.32,48.17).
city('Ocnita','md','Edinet',10762.0,27.47,48.43).
city('Ciadar Lunga','md','Gagauzia',24252.0,28.83,46.06).
city('Comrat','md','Gagauzia',28284.0,28.66,46.31).
city('Vulcanesti','md','Gagauzia',17032.0,28.41,45.68).
city('Basarabeasca','md','Lapusna',13569.0,28.97,46.34).
city('Cimislia','md','Lapusna',15441.0,28.78,46.53).
city('Hancesti','md','Lapusna',18005.0,28.87,47.7).
city('Leova','md','Lapusna',11417.0,28.24,46.5).
city('Orhei','md','Orhei',49629.0,28.82,47.39).
city('Rezina','md','Orhei',14835.0,28.96,47.75).
city('Telenesti','md','Orhei',8954.0,28.37,47.5).
city('Drochia','md','Soroca',19933.0,27.82,48.03).
city('Floresti','md','Soroca',17032.0,28.31,47.89).
city('Soroca','md','Soroca',38232.0,28.3,48.16).
city('Taraclia','md','Taraclia',14094.0,28.67,45.9).
city('Causani','md','Tighina',21863.0,29.41,46.0).
city('Camenca','md','Transnistria',12820.0,28.72,48.01).
city('Dnestrovsc','md','Transnistria',12072.0,29.88,46.66).
city('Dubasari','md','Transnistria',16180.0,29.16,47.27).
city('Griguriopol','md','Transnistria',10949.0,29.31,47.15).
city('Rabnita','md','Transnistria',60951.0,29.0,47.77).
city('Slobozia','md','Transnistria',17780.0,29.71,46.75).
city('Tighina','md','Transnistria',128403.0,29.48,46.83).
city('Tiraspol','md','Transnistria',196540.0,29.63,46.85).
city('Calarasi','md','Ungheni',17125.0,28.33,47.26).
city('Nispore','md','Ungheni',14692.0,28.18,47.09).
city('Ungheni','md','Ungheni',39709.0,27.81,47.21).
city('Fontvieille','mc','Fontvieille',4307.0,7.41,43.73).
city('La Condamine','mc','La Condamine',11985.0,7.41,43.74).
city('Monaco-Ville','mc','Monaco-Ville',967.0,7.42,43.74).
city('Monte Carlo','mc','Monte Carlo',15825.0,7.42,43.75).
city('Cecerleg','mn','Arhangaj',19189.0,101.46,47.46).
city('Oelgij','mn','Bajan-Oelgij',30087.0,89.96,48.97).
city('Bajanhongor','mn','Bajanhongor',23239.0,100.12,46.69).
city('Bulgan','mn','Bulgan',17351.0,103.56,48.82).
city('Darhan','mn','Darhan-Uul',72386.0,109.4,46.63).
city('Cojbalsan','mn','Dornod',44367.0,114.5,48.06).
city('Sajnsand','mn','Dornogovd',28651.0,110.11,44.89).
city('Mandalgovd','mn','Dundgovd',15433.0,106.26,45.77).
city('Altaj','mn','Govd-Altaj',18772.0,96.26,46.38).
city('Cojr','mn','Govdsumber',9894.0,108.36,46.36).
city('Oendoerhaan','mn','Hentij',14724.0,110.65,47.34).
city('Moeroen','mn','Hoevsgoel',27694.0,100.15,49.64).
city('Hovd','mn','Hovd',27929.0,102.17,44.67).
city('Dalanzadgad','mn','Oemnoegovd',15095.0,104.43,43.58).
city('Arvajheer','mn','Oevoerhangaj',20629.0,102.77,46.27).
city('Erdenet','mn','Orhon',79649.0,104.08,49.03).
city('Suehbaatar','mn','Selenge',24238.0,106.19,50.23).
city('Zuunharaa','mn','Selenge',18831.0,106.45,48.85).
city('Baruun-Urt','mn','Suehbaatar',15808.0,113.28,46.68).
city('Nalajh','mn','Toev',16945.0,107.26,47.77).
city('Zuunmod','mn','Toev',17742.0,106.95,47.71).
city('Ulaanbaatar','mn','Ulaanbaatar',844786.0,106.91,47.93).
city('Ulaangom','mn','Uvs',28091.0,92.06,49.99).
city('Tosoncengel','mn','Zavhan',9526.0,98.26,48.77).
city('Uliastaj','mn','Zavhan',26130.0,96.84,47.74).
city('Casablanca','ma','Casablanca',3609698.0,-7.62,33.6).
city('Bal-Jaad','ma','Chaouia-Ouardigha',37721.0,-6.4,32.79).
city('Bin Sulayman','ma','Chaouia-Ouardigha',41859.0,-7.12,33.63).
city('Birrasid','ma','Chaouia-Ouardigha',89056.0,-7.59,33.28).
city('Buzniqah','ma','Chaouia-Ouardigha',24143.0,-7.16,33.79).
city('Hzuribkah','ma','Chaouia-Ouardigha',173793.0,-6.91,32.89).
city('Sattat','ma','Chaouia-Ouardigha',131771.0,-7.62,33.01).
city('Wad Zam','ma','Chaouia-Ouardigha',88396.0,-6.58,32.87).
city('Asfi','ma','Doukkala-Abda',328883.0,-9.24,32.32).
city('Azimur','ma','Doukkala-Abda',37969.0,-8.35,33.3).
city('Sidi Binnur','ma','Doukkala-Abda',39692.0,-8.44,32.66).
city('Sidi Ismail','ma','Doukkala-Abda',22872.0,-8.52,32.84).
city('al-Jadidah','ma','Doukkala-Abda',162208.0,-8.51,33.26).
city('al-Yussufiyah','ma','Doukkala-Abda',70108.0,-8.53,32.26).
city('Fez','ma','Fes-Boulemane',1160239.0,-5.0,34.05).
city('Safru','ma','Fes-Boulemane',71666.0,-4.86,33.85).
city('Kenitra','ma','Gharb-Chrarda-Beni Hssen',420534.0,-6.58,34.27).
city('Masra bal-Qsiri','ma','Gharb-Chrarda-Beni Hssen',29289.0,-5.96,34.59).
city('Sidi Qasim','ma','Gharb-Chrarda-Beni Hssen',78723.0,-5.71,34.24).
city('Sidi Sulayman','ma','Gharb-Chrarda-Beni Hssen',90859.0,-5.93,34.27).
city('Sidi Yahya al-Garb','ma','Gharb-Chrarda-Beni Hssen',36758.0,-6.31,34.31).
city('Suq-al-Arba','ma','Gharb-Chrarda-Beni Hssen',45649.0,-6.0,34.7).
city('Wazzan','ma','Gharb-Chrarda-Beni Hssen',64118.0,-5.57,34.81).
city('Gulimim','ma','Guelmim',119717.0,-10.07,28.98).
city('Tantan','ma','Guelmim',48936.0,-11.1,28.43).
city('Bin Jarir','ma','Marrakech-Tensift-Al Haouz',88091.0,-7.96,32.25).
city('Marrakesh','ma','Marrakech-Tensift-Al Haouz',942631.0,-8.0,31.63).
city('al-Qalat-as-Saragnah','ma','Marrakech-Tensift-Al Haouz',73479.0,-7.42,32.06).
city('as-Sawirah','ma','Marrakech-Tensift-Al Haouz',70718.0,-9.77,31.52).
city('Azru','ma','Meknes-Tafilalet',50957.0,-5.23,33.45).
city('Hzanifrah','ma','Meknes-Tafilalet',116824.0,-5.67,32.95).
city('Midalt','ma','Meknes-Tafilalet',54847.0,-4.74,32.7).
city('Miknas','ma','Meknes-Tafilalet',583195.0,-5.56,33.9).
city('Mrirt','ma','Meknes-Tafilalet',36496.0,-5.57,33.17).
city('al-Hajab','ma','Meknes-Tafilalet',32876.0,-5.37,33.7).
city('ar-Rasidiyah','ma','Meknes-Tafilalet',128613.0,-4.45,31.94).
city('Ahfir','ma','Oriental',19861.0,-2.11,34.97).
city('Birkan','ma','Oriental',91264.0,-2.33,34.93).
city('Fikik','ma','Oriental',13795.0,-1.23,32.13).
city('Jaradah','ma','Oriental',75410.0,-2.17,34.32).
city('Nador','ma','Oriental',157665.0,-2.95,35.17).
city('Tawrirt','ma','Oriental',91175.0,-2.89,34.42).
city('Ujdah','ma','Oriental',433835.0,-1.91,34.69).
city('Zayu','ma','Oriental',25102.0,-2.74,34.95).
city('al-Ayun Sidi Malluk','ma','Oriental',29817.0,-2.51,34.59).
city('Rabat','ma','Rabat-Sale-Zammour-Zaer',1894386.0,-6.84,34.02).
city('Tiflat','ma','Rabat-Sale-Zammour-Zaer',64939.0,-6.31,33.9).
city('al-Hzamissat','ma','Rabat-Sale-Zammour-Zaer',125738.0,-6.07,33.84).
city('as-Sahzirat','ma','Rabat-Sale-Zammour-Zaer',38506.0,-7.04,33.85).
city('Agadir','ma','Souss Massa-Draa',656110.0,-9.61,30.42).
city('Awlad Taymah','ma','Souss Massa-Draa',58944.0,-9.22,30.4).
city('Tarudant','ma','Souss',84609.0,-8.88,30.48).
city('Tingir','ma','Souss Massa-Draa',38112.0,-5.53,31.52).
city('Tiznit','ma','Souss Massa-Draa',73334.0,-9.74,29.71).
city('Warzazat','ma','Souss Massa-Draa',49034.0,-6.9,30.92).
city('Zakurah','ma','Souss Massa-Draa',32738.0,-5.86,30.33).
city('Bani Mallal','ma','Tadla-Azilal',192482.0,-6.37,32.35).
city('Qasbat Tadlah','ma','Tadla-Azilal',42857.0,-6.28,32.61).
city('al-Faqih Bin Salah','ma','Tadla-Azilal',108373.0,-6.7,32.51).
city('Asilah','ma','Tangier-Tetouan',31666.0,-6.03,35.47).
city('Martil','ma','Tangier-Tetouan',29805.0,-5.29,35.63).
city('Midiq','ma','Tangier-Tetouan',27165.0,-5.32,35.69).
city('Sifsawn','ma','Tangier-Tetouan',40452.0,-5.27,35.17).
city('Tangier','ma','Tangier-Tetouan',825316.0,-5.81,35.79).
city('Tetouan','ma','Tangier-Tetouan',365355.0,-5.37,35.58).
city('al-Arais','ma','Tangier-Tetouan',120994.0,-6.16,35.2).
city('al-Finidiq','ma','Tangier-Tetouan',44414.0,-5.35,35.85).
city('al-Qasr-al-Kabir','ma','Tangier-Tetouan',146872.0,-5.91,35.02).
city('Imzuran','ma','Taza-Al Hoceima-Taounate',28556.0,-3.87,35.16).
city('Jarsif','ma','Taza-Al Hoceima-Taounate',46943.0,-3.36,34.24).
city('Tahlah','ma','Taza-Al Hoceima-Taounate',22520.0,-4.42,34.05).
city('Tawnat','ma','Taza-Al Hoceima-Taounate',27249.0,-4.64,34.55).
city('Tazah','ma','Taza-Al Hoceima-Taounate',106190.0,-4.02,34.22).
city('Tazah-al-Uliya','ma','Taza-Al Hoceima-Taounate',31596.0,-4.2,34.03).
city('al-Husaymah','ma','Taza-Al Hoceima-Taounate',68925.0,-3.94,35.26).
city('Montepuez','mz','Cabo Delgado',72279.0,39.0,-13.12).
city('Pemba','mz','Cabo Delgado',108737.0,40.48,-12.96).
city('Chibuto','mz','Gaza',59165.0,33.53,-24.68).
city('Chokwe','mz','Gaza',63695.0,32.98,-24.53).
city('Macia','mz','Gaza',23156.0,33.09,-25.02).
city('Manjacaze','mz','Gaza',25541.0,33.88,-24.7).
city('Xai-Xai','mz','Gaza',127366.0,33.64,-25.04).
city('Inhambane','mz','Inhambane',73903.0,35.38,-23.87).
city('Maxixe','mz','Inhambane',119868.0,35.34,-23.87).
city('Chimoio','mz','Manica',256992.0,33.47,-19.12).
city('Manica','mz','Manica',25488.0,32.88,-18.97).
city('Matola','mz','Maputo Provincia',543907.0,32.46,-25.97).
city('Maputo','mz','Maputo',1191613.0,32.57,-25.95).
city('Angoche','mz','Nampula',74624.0,39.91,-16.23).
city('Mocambique','mz','Nampula',54315.0,40.73,-15.04).
city('Nacala','mz','Nampula',224853.0,40.68,-14.56).
city('Nampula','mz','Nampula',388526.0,39.24,-15.13).
city('Cuamba','mz','Niassa',73268.0,36.54,-14.79).
city('Lichinga','mz','Niassa',109839.0,35.24,-13.3).
city('Beira','mz','Sofala',530706.0,34.84,-19.83).
city('Dondo','mz','Sofala',78648.0,34.73,-19.62).
city('Tete','mz','Tete',129316.0,33.58,-16.17).
city('Garue','mz','Zambezia',125042.0,36.98,-15.46).
city('Mocuba','mz','Zambezia',68984.0,38.26,-16.85).
city('Quelimane','mz','Zambezia',188964.0,36.89,-17.88).
city('Katima Mulilo','na','Caprivi',25034.0,24.26,-17.5).
city('Henties Bay','na','Erongo',3837.0,14.28,-22.12).
city('Karibib','na','Erongo',6900.0,15.85,-21.94).
city('Okombahe','na','Erongo',2555.0,21.07,-15.39).
city('Omaruru','na','Erongo',11546.0,15.95,-21.43).
city('Otjimbingwe','na','Erongo',7717.0,16.12,-22.36).
city('Swakopmund','na','Erongo',25047.0,14.52,-22.67).
city('Usakos','na','Erongo',9194.0,15.58,-22.0).
city('Walvis Bay','na','Erongo',52064.0,14.5,-22.95).
city('Aranos','na','Hardap',3431.0,19.1,-24.15).
city('Maltahoehe','na','Hardap',2329.0,16.94,-24.84).
city('Mariental','na','Hardap',13381.0,17.96,-24.62).
city('Rehoboth','na','Hardap',21378.0,17.08,-23.32).
city('Bethanien','na','Karas',10400.0,17.15,-26.5).
city('Karasburg','na','Karas',6055.0,18.74,-28.02).
city('Keetmanshoop','na','Karas',15609.0,18.13,-26.58).
city('Luederitz','na','Karas',15138.0,15.15,-26.64).
city('Oranjemund','na','Karas',8496.0,16.43,-28.55).
city('Warmbad','na','Karas',6700.0,18.73,-28.44).
city('Rundu','na','Kavango',58177.0,19.75,-17.92).
city('Windhoek','na','Khomas',268129.0,17.09,-22.56).
city('Arandis','na','Kunene',4507.0,14.99,-22.43).
city('Khorixas','na','Kunene',12022.0,14.96,-20.37).
city('Opuwo','na','Kunene',4857.0,13.82,-18.06).
city('Outjo','na','Kunene',6558.0,16.14,-20.11).
city('Eenhana','na','Ohangwena',3405.0,16.32,-17.42).
city('Oshikango','na','Ohangwena',2658.0,15.88,-17.4).
city('Gobabis','na','Omaheke',16323.0,18.96,-22.45).
city('Ongandjera','na','Omusati',2719.0,15.06,-17.88).
city('Outapi','na','Omusati',2758.0,15.0,-17.5).
city('Ongwediva','na','Oshana',9654.0,15.77,-17.78).
city('Oshakati','na','Oshana',33636.0,15.69,-17.78).
city('Ondangwa','na','Oshikoto',9125.0,15.97,-17.91).
city('Otavi','na','Oshikoto',4562.0,17.34,-19.64).
city('Tsumeb','na','Oshikoto',12191.0,17.71,-19.24).
city('Gro','na','Otjozondjupa',24105.0,18.09,-19.56).
city('Okahandja','na','Otjozondjupa',20881.0,16.91,-21.98).
city('Okakarara','na','Otjozondjupa',5255.0,17.45,-20.59).
city('Otjiwarongo','na','Otjozondjupa',21226.0,16.64,-20.46).
city('Yaren','nr','Aiwo',4560.0,166.91,-0.55).
city('Baglung','np','Baglung',23297.0,83.6,28.27).
city('Nepalganj','np','Banke',61477.0,81.62,28.07).
city('Kalaiya','np','Bara',39367.0,85.0,27.03).
city('Gulariya','np','Bardiya',53110.0,81.33,28.24).
city('Bhaktapur','np','Bhaktapur',76890.0,85.43,27.67).
city('Bharatpur','np','Chitwan',107162.0,84.44,27.67).
city('Amargadhi','np','Dadeldhura',19015.0,80.58,29.3).
city('Narayan','np','Dailekh',20910.0,81.73,28.83).
city('Tribuvannagar','np','Dang Deokhuri',49426.0,85.37,27.72).
city('Tulsipur','np','Dang Deokhuri',39061.0,82.29,28.13).
city('Dashrathchand','np','Darchula',18318.0,80.55,29.85).
city('Dhankuta','np','Dhankuta',22085.0,87.34,26.95).
city('Janakpur','np','Dhanusa',93796.0,85.92,26.73).
city('Bhimeshwar','np','Dolakha',22851.0,86.03,27.67).
city('Dipayal','np','Doti',27088.0,80.69,29.12).
city('Ilam','np','Ilam',17492.0,87.92,26.91).
city('Bhadrapur','np','Jhapa',19524.0,88.08,26.54).
city('Damak','np','Jhapa',33766.0,87.73,26.66).
city('Mechinagar','np','Jhapa',54073.0,87.92,27.17).
city('Jumla','np','Jumla',9073.0,82.16,29.27).
city('Dhangadhi','np','Kailali',92326.0,80.59,28.69).
city('Tikapur','np','Kailali',44762.0,81.13,28.5).
city('Mahendranagar','np','Kanchanpur',88386.0,80.3,28.96).
city('Pokhara','np','Kaski',186410.0,83.99,28.22).
city('Kathmandu','np','Kathmandu',790612.0,85.31,27.71).
city('Kirtipur','np','Kathmandu',44635.0,85.28,27.67).
city('Banepa','np','Kavrepalanchok',17154.0,85.52,27.63).
city('Dhulikhet','np','Kavrepalanchok',10170.0,85.55,27.62).
city('Panauti','np','Kavrepalanchok',27604.0,85.52,27.59).
city('Lalitpur','np','Lalitpur',183316.0,85.32,27.68).
city('Jaleswor','np','Mahottari',23574.0,85.79,26.65).
city('Hetauda','np','Makwanpur',84800.0,85.02,27.41).
city('Biratnagar','np','Morang',182.0,87.28,26.46).
city('Bidur','np','Nuwakot',22063.0,85.16,27.89).
city('Tansen','np','Palpa',23190.0,83.55,27.87).
city('Birganj','np','Parsa',133244.0,84.87,27.02).
city('Gaur','np','Rautahat',27327.0,85.27,26.77).
city('Butwal','np','Rupandehi',91737.0,83.45,27.71).
city('Siddharthanagar','np','Rupandehi',63372.0,83.45,27.5).
city('Khandbari','np','Sankhuwasabha',22904.0,87.22,27.37).
city('Rajbiraj','np','Saptari',33063.0,86.74,26.54).
city('Malangwa','np','Sarlahi',20285.0,85.55,26.86).
city('Kamalamai','np','Sindhuli',36440.0,85.92,27.22).
city('Lahan','np','Siraha',31497.0,86.48,26.72).
city('Siraha','np','Siraha',24659.0,86.21,26.66).
city('Dharan','np','Sunsari',108605.0,87.26,26.81).
city('Inaruwa','np','Sunsari',25031.0,87.1,26.61).
city('Itahari','np','Sunsari',47987.0,87.28,26.67).
city('Birendranagar','np','Surkhet',34986.0,81.65,28.56).
city('Waling','np','Syangja',21869.0,83.77,27.99).
city('Triyuga','np','Udayapur',63340.0,86.96,26.69).
city('Antriol','an','Bonaire',2980.0,-68.27,12.17).
city('Kralendijk','an','Bonaire',3081.0,-68.28,12.15).
city('Nort Salinja','an','Bonaire',1632.0,-68.27,12.18).
city('Rincon','an','Bonaire',1496.0,-68.33,12.23).
city('Tera Kora','an','Bonaire',1186.0,-68.27,12.13).
city('Barber','an','Curacao',2424.0,-69.07,12.28).
city('Flip','an','Curacao',587.0,-69.12,12.3).
city('Groot Piscadera','an','Curacao',2576.0,-68.97,12.15).
city('Hato','an','Curacao',13.0,-68.28,12.18).
city('Labadera','an','Curacao',2356.0,-68.82,12.15).
city('Lagun','an','Curacao',289.0,-69.17,12.32).
city('Lelienberg','an','Curacao',681.0,-69.08,12.3).
city('Meiberg','an','Curacao',23.0,-69.02,12.17).
city('Montana Abou','an','Curacao',4237.0,-68.85,12.1).
city('Montana Rey','an','Curacao',3571.0,-68.87,12.1).
city('Nieuwpoort','an','Curacao',1937.0,-68.82,12.05).
city('Oostpunt','an','Curacao',1147.0,-68.77,12.07).
city('Pannekoek','an','Curacao',321.0,-69.1,12.25).
city('Ronde Klip','an','Curacao',867.0,-68.85,12.15).
city('Seru Grandi','an','Curacao',1341.0,-69.0,12.18).
city('Sint Michiel','an','Curacao',5138.0,-68.98,12.13).
city('Sint Willibrordus','an','Curacao',465.0,-69.05,12.22).
city('Soto','an','Curacao',1987.0,-69.1,12.27).
city('Souax','an','Curacao',3493.0,-68.97,12.18).
city('Tera Cora','an','Curacao',3665.0,-69.0,12.22).
city('Wacao','an','Curacao',427.0,-69.05,12.32).
city('Westpunt','an','Curacao',783.0,-69.17,12.37).
city('Willemstad','an','Curacao',97590.0,-68.93,12.1).
city('Saint Johns','an','Saba',197.0,-63.23,17.62).
city('The Bottom','an','Saba',488.0,-63.25,17.64).
city('Windward Side','an','Saba',442.0,-63.23,17.63).
city('Zions Hill','an','Saba',299.0,-63.22,17.62).
city('Cherry Tree','an','Sint Eustatius',244.0,-62.97,17.48).
city('Golden Rock','an','Sint Eustatius',823.0,-62.98,17.48).
city('Mountain','an','Sint Eustatius',51.0,-62.95,17.48).
city('Oranjestad','an','Sint Eustatius',1097.0,-62.98,17.49).
city('Princess Garden','an','Sint Eustatius',167.0,-62.97,17.47).
city('Cole Bay','an','Sint Maarten',6496.0,-63.08,18.02).
city('Cul De Sac','an','Sint Maarten',8467.0,-63.07,18.03).
city('Little Bay','an','Sint Maarten',2338.0,-63.05,18.02).
city('Low Lands','an','Sint Maarten',249.0,-63.12,18.03).
city('Phillipsburg','an','Sint Maarten',1318.0,-63.03,18.02).
city('Princess Quarter','an','Sint Maarten',13048.0,-63.03,18.03).
city('Simpson Bay','an','Sint Maarten',791.0,-63.1,18.03).
city('Aa en Hunze','nl','Drenthe',26224.0,6.7,53.05).
city('Assen','nl','Drenthe',64940.0,6.56,53.01).
city('Borger-Odoorn','nl','Drenthe',26927.0,6.79,52.93).
city('Coe','nl','Drenthe',35113.0,6.75,52.67).
city('De Wolden','nl','Drenthe',24550.0,6.6,53.27).
city('Emmen','nl','Drenthe',112333.0,6.9,52.79).
city('Hoogeveen','nl','Drenthe',53740.0,6.49,52.73).
city('Menterwolde','nl','Drenthe',12893.0,6.6,53.14).
city('Meppel','nl','Drenthe',31049.0,6.19,52.7).
city('Noordenveld','nl','Drenthe',32719.0,6.42,53.14).
city('Stadskanaal','nl','Drenthe',34316.0,6.91,53.0).
city('Tynaarlo','nl','Drenthe',32389.0,6.67,53.1).
city('Westerveld','nl','Drenthe',19575.0,6.36,52.84).
city('Almere','nl','Flevoland',186457.0,5.17,52.36).
city('Dronten','nl','Flevoland',39509.0,5.71,52.54).
city('Lelystad','nl','Flevoland',73426.0,5.45,52.52).
city('Noordoostpolder','nl','Flevoland',46826.0,5.76,52.72).
city('Urk','nl','Flevoland',17887.0,5.6,52.67).
city('Zeewolde','nl','Flevoland',22932.0,5.54,52.37).
city('Dantumadeel','nl','Friesland',19619.0,6.01,53.3).
city('Franekeradeel','nl','Friesland',21482.0,5.53,53.21).
city('Harlingen','nl','Friesland',15615.0,5.44,53.18).
city('Heerenveen','nl','Friesland',43715.0,5.92,52.96).
city('Kollumerland','nl','Friesland',13781.0,6.19,53.31).
city('Leeuwarden','nl','Friesland',92494.0,5.79,53.21).
city('Menaldumadeel','nl','Friesland',14567.0,5.66,53.22).
city('Smallingerland','nl','Friesland',55787.0,6.09,53.11).
city('Sneek','nl','Friesland',34562.0,5.65,53.04).
city('Tytsjerksteradiel','nl','Friesland',31892.0,5.91,53.21).
city('Aalten','nl','Gelderland',18856.0,6.57,51.94).
city('Apeldoorn','nl','Gelderland',157763.0,5.96,52.22).
city('Arnhem','nl','Gelderland',144959.0,5.91,51.99).
city('Barneveld','nl','Gelderland',51158.0,5.57,52.14).
city('Bemmel','nl','Gelderland',42751.0,5.9,51.9).
city('Beuningen','nl','Gelderland',26178.0,5.78,51.87).
city('Borculo','nl','Gelderland',10551.0,6.51,52.12).
city('Brummen','nl','Gelderland',21675.0,6.15,52.09).
city('Culemborg','nl','Gelderland',27869.0,5.23,51.96).
city('Didam','nl','Gelderland',16927.0,6.12,51.94).
city('Doesburg','nl','Gelderland',11692.0,6.12,52.02).
city('Doetinchem','nl','Gelderland',519.0,6.28,51.97).
city('Druten','nl','Gelderland',18544.0,5.61,51.89).
city('Duiven','nl','Gelderland',27463.0,6.01,51.96).
city('Ede','nl','Gelderland',106506.0,5.65,52.04).
city('Eibergen','nl','Gelderland',16888.0,6.64,52.11).
city('Elburg','nl','Gelderland',21737.0,5.83,52.45).
city('Epe','nl','Gelderland',33242.0,5.98,52.36).
city('Ermelo','nl','Gelderland',26695.0,5.61,52.31).
city('Geldermalsen','nl','Gelderland',26526.0,5.3,51.89).
city('Gendringen','nl','Gelderland',21247.0,6.38,51.87).
city('Gorssel','nl','Gelderland',12824.0,6.21,52.2).
city('Groesbeek','nl','Gelderland',18757.0,5.93,51.79).
city('Harderwijk','nl','Gelderland',41916.0,5.63,52.35).
city('Hattem','nl','Gelderland',11676.0,6.07,52.48).
city('Heerde','nl','Gelderland',18163.0,6.05,52.39).
city('Kesteren','nl','Gelderland',22527.0,5.57,51.94).
city('Leerdam','nl','Gelderland',21286.0,5.09,51.89).
city('Lichtenvoorde','nl','Gelderland',19949.0,6.56,51.99).
city('Lochem','nl','Gelderland',19863.0,6.41,52.17).
city('Loppersum','nl','Gelderland',11175.0,6.01,52.5).
city('Neede','nl','Gelderland',11082.0,6.62,52.14).
city('Neerijnen','nl','Gelderland',11782.0,5.28,51.83).
city('Nijkerk','nl','Gelderland',37845.0,5.48,52.24).
city('Nijmegen','nl','Gelderland',158707.0,5.85,51.84).
city('Nunspeet','nl','Gelderland',26785.0,5.79,52.39).
city('Oldebroek','nl','Gelderland',23333.0,5.9,52.45).
city('Putten','nl','Gelderland',23832.0,5.61,52.27).
city('Renkum','nl','Gelderland',32323.0,5.74,51.98).
city('Rheden','nl','Gelderland',45374.0,6.01,52.01).
city('Tiel','nl','Gelderland',43643.0,5.43,51.91).
city('Voorst','nl','Gelderland',24046.0,6.14,52.18).
city('Wageningen','nl','Gelderland',35080.0,5.67,51.98).
city('Westervoort','nl','Gelderland',16208.0,5.96,51.97).
city('Wijchen','nl','Gelderland',40392.0,5.73,51.82).
city('Winterswijk','nl','Gelderland',29098.0,6.72,51.98).
city('Wisch','nl','Gelderland',19389.0,6.31,51.93).
city('Zaltbommel','nl','Gelderland',26178.0,5.24,51.8).
city('Zelhem','nl','Gelderland',11039.0,6.34,52.0).
city('Zevenaar','nl','Gelderland',25576.0,6.07,51.94).
city('Zutphen','nl','Gelderland',38399.0,6.2,52.14).
city('Appingedam','nl','Groningen',12621.0,6.86,53.32).
city('Bedum','nl','Groningen',11123.0,6.59,53.3).
city('De Marne','nl','Groningen',11378.0,6.34,53.36).
city('Delfzijl','nl','Groningen',28473.0,6.91,53.34).
city('Eemsmond','nl','Groningen',17745.0,6.61,53.4).
city('Groningen','nl','Groningen',179995.0,6.57,53.23).
city('Grootegast','nl','Groningen',12862.0,6.28,53.21).
city('Haren','nl','Groningen',18775.0,6.6,53.17).
city('Hoogezand-Sappemeer','nl','Groningen',34033.0,6.76,53.17).
city('Leek','nl','Groningen',19931.0,6.37,53.17).
city('Pekela','nl','Groningen',14142.0,7.01,53.11).
city('Scheemda','nl','Groningen',14363.0,6.99,53.2).
city('Slochteren','nl','Groningen',15317.0,6.8,53.22).
city('Veendam','nl','Groningen',28099.0,6.86,53.1).
city('Vlagtwedde','nl','Groningen',17047.0,7.11,53.03).
city('Winschoten','nl','Groningen',18703.0,7.03,53.15).
city('Winsum','nl','Groningen',14355.0,6.51,53.0).
city('Zuidhorn','nl','Groningen',18338.0,6.46,53.25).
city('Ambt Montfort','nl','Limburg',10907.0,6.04,51.12).
city('Arcen en Velden','nl','Limburg',8838.0,6.18,51.48).
city('Beek','nl','Limburg',16989.0,5.79,50.94).
city('Beesel','nl','Limburg',13656.0,6.04,51.27).
city('Bergen','nl','Limburg',13647.0,6.03,51.6).
city('Brunssum','nl','Limburg',29914.0,5.96,50.96).
city('Echt','nl','Limburg',19260.0,5.89,51.1).
city('Eijsden','nl','Limburg',12079.0,5.71,50.78).
city('Gennep','nl','Limburg',17002.0,5.96,51.7).
city('Haelen','nl','Limburg',10283.0,5.95,51.24).
city('Heerlen','nl','Limburg',93518.0,6.03,50.91).
city('Helden','nl','Limburg',19787.0,6.0,51.33).
city('Heythuysen','nl','Limburg',12088.0,5.86,51.2).
city('Horst','nl','Limburg',28657.0,6.04,51.46).
city('Kerkrade','nl','Limburg',49327.0,6.06,50.87).
city('Maasbracht','nl','Limburg',13764.0,5.85,51.13).
city('Maasbree','nl','Limburg',12887.0,6.04,51.35).
city('Maastricht','nl','Limburg',122383.0,5.69,50.8).
city('Margraten','nl','Limburg',13512.0,5.82,50.83).
city('Meerssen','nl','Limburg',19932.0,5.75,50.89).
city('Nederweert','nl','Limburg',16284.0,5.75,51.29).
city('Nuth','nl','Limburg',16257.0,5.88,50.92).
city('Roerdalen','nl','Limburg',10555.0,6.01,51.16).
city('Roermond','nl','Limburg',46558.0,5.99,51.2).
city('Schinnen','nl','Limburg',13365.0,5.89,50.95).
city('Simpelveld','nl','Limburg',11276.0,5.97,50.84).
city('Sittard-Geleen','nl','Limburg',98159.0,5.86,51.01).
city('Stein','nl','Limburg',26602.0,5.76,50.97).
city('Susteren','nl','Limburg',13006.0,5.86,51.07).
city('Vaals','nl','Limburg',10679.0,6.01,50.77).
city('Valkenburg','nl','Limburg',17778.0,5.83,50.87).
city('Venlo','nl','Limburg',91783.0,6.17,51.38).
city('Venray','nl','Limburg',40518.0,5.97,51.53).
city('Voerendaal','nl','Limburg',13132.0,5.93,50.88).
city('Weert','nl','Limburg',49614.0,5.7,51.26).
city('Aalburg','nl','Noord-Brabant',12472.0,5.13,51.75).
city('Asten','nl','Noord-Brabant',16199.0,5.75,51.41).
city('Bergeijk','nl','Noord-Brabant',18255.0,5.36,51.32).
city('Bergen op Zoom','nl','Noord-Brabant',67641.0,4.29,51.5).
city('Bernheze','nl','Noord-Brabant',29064.0,5.52,51.73).
city('Bernisse','nl','Noord-Brabant',12908.0,5.5,51.67).
city('Best','nl','Noord-Brabant',30292.0,5.4,51.5).
city('Bladel','nl','Noord-Brabant',19199.0,5.21,51.37).
city('Boxmeer','nl','Noord-Brabant',29918.0,5.94,51.66).
city('Boxtel','nl','Noord-Brabant',29572.0,5.31,51.59).
city('Breda','nl','Noord-Brabant',168934.0,4.77,51.58).
city('Cranendonck','nl','Noord-Brabant',20427.0,5.59,51.32).
city('Cuijk','nl','Noord-Brabant',25012.0,5.92,51.73).
city('Deurne','nl','Noord-Brabant',32182.0,5.79,51.46).
city('Dongen','nl','Noord-Brabant',25855.0,4.94,51.63).
city('Drimmelen','nl','Noord-Brabant',26911.0,4.79,51.68).
city('Eersel','nl','Noord-Brabant',18551.0,5.31,51.37).
city('Eindhoven','nl','Noord-Brabant',210498.0,5.47,51.44).
city('Etten-Leur','nl','Noord-Brabant',41418.0,4.62,51.58).
city('Geertruidenberg','nl','Noord-Brabant',20912.0,4.91,51.69).
city('Geldrop','nl','Noord-Brabant',28877.0,5.56,51.44).
city('Gemert-Bakel','nl','Noord-Brabant',28128.0,5.7,51.56).
city('Gilze en Rijen','nl','Noord-Brabant',25511.0,4.94,51.55).
city('Goirle','nl','Noord-Brabant',22899.0,5.06,51.52).
city('Grave','nl','Noord-Brabant',12976.0,5.73,51.77).
city('Haaren','nl','Noord-Brabant',14138.0,5.23,51.64).
city('Halderberge','nl','Noord-Brabant',30111.0,4.53,51.59).
city('Heeze-Leende','nl','Noord-Brabant',15399.0,5.56,51.35).
city('Helmond','nl','Noord-Brabant',88371.0,5.65,51.48).
city('Heusden','nl','Noord-Brabant',44200.0,5.16,51.69).
city('Hilvarenbeek','nl','Noord-Brabant',15147.0,5.12,51.49).
city('Laarbeek','nl','Noord-Brabant',21652.0,5.64,51.5).
city('Landerd','nl','Noord-Brabant',14845.0,5.68,51.7).
city('Loon op Zand','nl','Noord-Brabant',23408.0,5.07,51.63).
city('Maasdonk','nl','Noord-Brabant',11473.0,5.46,51.75).
city('Mierlo','nl','Noord-Brabant',10309.0,5.61,51.45).
city('Mill en Sint Hubert','nl','Noord-Brabant',11142.0,5.78,51.68).
city('Moerdijk','nl','Noord-Brabant',36518.0,4.59,51.65).
city('Nuenen','nl','Noord-Brabant',23755.0,5.54,51.47).
city('Oirschot','nl','Noord-Brabant',18057.0,5.31,51.52).
city('Oisterwijk','nl','Noord-Brabant',25544.0,5.19,51.59).
city('Oosterhout','nl','Noord-Brabant',54110.0,4.86,51.65).
city('Oss','nl','Noord-Brabant',69965.0,5.52,51.76).
city('Reusel-De Mierden','nl','Noord-Brabant',12297.0,5.16,51.37).
city('Roosendaal','nl','Noord-Brabant',81228.0,4.46,51.54).
city('Rucphen','nl','Noord-Brabant',22872.0,4.56,51.53).
city('Schijndel','nl','Noord-Brabant',24324.0,5.44,51.62).
city('Sint Anthonis','nl','Noord-Brabant',12007.0,5.87,51.61).
city('Sint-Michielsgestel','nl','Noord-Brabant',28528.0,5.34,51.64).
city('Sint-Oedenrode','nl','Noord-Brabant',17119.0,5.46,51.57).
city('Someren','nl','Noord-Brabant',18786.0,5.71,51.39).
city('Son en Breugel','nl','Noord-Brabant',15366.0,5.49,51.52).
city('Steenbergen','nl','Noord-Brabant',23793.0,4.31,51.59).
city('Tilburg','nl','Noord-Brabant',206858.0,5.07,51.57).
city('Uden','nl','Noord-Brabant',41221.0,5.61,51.67).
city('Valkenswaard','nl','Noord-Brabant',31158.0,5.45,51.36).
city('Veghel','nl','Noord-Brabant',37273.0,5.55,51.62).
city('Veldhoven','nl','Noord-Brabant',43615.0,5.38,51.39).
city('Vught','nl','Noord-Brabant',26082.0,5.29,51.66).
city('Waalre','nl','Noord-Brabant',16596.0,5.44,51.39).
city('Waalwijk','nl','Noord-Brabant',46197.0,5.07,51.7).
city('Werkendam','nl','Noord-Brabant',26986.0,4.9,51.82).
city('Woensdrecht','nl','Noord-Brabant',22318.0,4.3,51.43).
city('Woudrichem','nl','Noord-Brabant',14762.0,5.02,51.8).
city('Zundert','nl','Noord-Brabant',20656.0,4.66,51.47).
city('s-Hertogenbosch','nl','Noord-Brabant',135917.0,5.31,51.7).
city('Aalsmeer','nl','Noord-Holland',22969.0,4.76,52.27).
city('Alkmaar','nl','Noord-Holland',93287.0,4.75,52.64).
city('Amstelveen','nl','Noord-Holland',77343.0,4.86,52.32).
city('Amsterdam','nl','Noord-Holland',745811.0,4.89,52.37).
city('Anna Paulowna','nl','Noord-Holland',14379.0,4.85,52.79).
city('Bergen','nl','Noord-Holland',32300.0,4.71,52.67).
city('Beverwijk','nl','Noord-Holland',36466.0,4.65,52.49).
city('Blaricum','nl','Noord-Holland',8997.0,5.24,52.29).
city('Bloemendaal','nl','Noord-Holland',17544.0,4.61,52.4).
city('Bussum','nl','Noord-Holland',31430.0,5.17,52.28).
city('Castricum','nl','Noord-Holland',35750.0,4.67,52.56).
city('Den Helder','nl','Noord-Holland',59607.0,4.75,52.96).
city('Diemen','nl','Noord-Holland',24146.0,4.97,52.34).
city('Edam-Volendam','nl','Noord-Holland',28798.0,4.99,52.51).
city('Enkhuizen','nl','Noord-Holland',17943.0,5.29,52.71).
city('Haarlem','nl','Noord-Holland',147736.0,4.62,52.39).
city('Haarlemmermeer','nl','Noord-Holland',131698.0,4.7,52.3).
city('Harenkarspel','nl','Noord-Holland',16422.0,4.75,52.77).
city('Heemskerk','nl','Noord-Ho',37598.0,4.63,52.5).
city('Heemstede','nl','Noord-Holland',25770.0,4.61,52.35).
city('Heerhugowaard','nl','Noord-Holland',51004.0,4.85,52.67).
city('Heiloo','nl','Noord-Holland',22526.0,4.7,52.6).
city('Hillegom','nl','Noord-Holland',20955.0,4.57,52.3).
city('Hilversum','nl','Noord-Holland',83864.0,5.18,52.23).
city('Hoorn','nl','Noord-Holland',70379.0,5.05,52.65).
city('Huizen','nl','Noord-Holland',42669.0,5.23,52.3).
city('Katwijk','nl','Noord-Holland',42231.0,4.4,52.21).
city('Landsmeer','nl','Noord-Holland',10338.0,4.94,52.47).
city('Langedijk','nl','Noord-Holland',26276.0,4.78,52.66).
city('Laren','nl','Noord-Holland',11978.0,5.22,52.25).
city('Naarden','nl','Noord-Holland',17047.0,5.14,52.3).
city('Niedorp','nl','Noord-Holland',11670.0,4.89,52.74).
city('Opmeer','nl','Noord-Holland',11755.0,4.94,52.71).
city('Purmerend','nl','Noord-Holland',80807.0,4.94,52.52).
city('Rozenburg','nl','Noord-Holland',12960.0,4.73,52.28).
city('Schagen','nl','Noord-Holland',17416.0,4.79,52.79).
city('Texel','nl','Noord-Holland',14153.0,4.79,53.09).
city('Uitgeest','nl','Noord-Holland',12293.0,4.71,52.53).
city('Uithoorn','nl','Noord-Holland',27154.0,4.83,52.23).
city('Velsen','nl','Noord-Holland',68513.0,4.63,52.47).
city('Waterland','nl','Noord-Holland',16840.0,5.03,52.47).
city('Weesp','nl','Noord-Holland',17833.0,5.02,52.32).
city('Wieringermeer','nl','Noord-Holland',13176.0,5.03,52.85).
city('Zaanstad','nl','Noord-Holland',141800.0,4.82,52.45).
city('Zandvoort','nl','Noord-Holland',17893.0,4.53,52.38).
city('Almelo','nl','Overijssel',76332.0,6.65,52.36).
city('Borne','nl','Overijssel',19806.0,6.72,52.32).
city('Dalfsen','nl','Overijssel',26503.0,6.26,52.51).
city('Denekamp','nl','Overijssel',26461.0,6.99,52.39).
city('Deventer','nl','Overijssel',87726.0,6.16,52.27).
city('Enschede','nl','Overijssel',154183.0,6.89,52.22).
city('Haaksbergen','nl','Overijssel',24493.0,6.73,52.16).
city('Hardenberg','nl','Overijssel',58361.0,6.61,52.57).
city('Hellendoorn','nl','Overijssel',36565.0,6.44,52.39).
city('Hengelo','nl','Overijssel',82928.0,6.78,52.27).
city('Kampen','nl','Overijssel',49303.0,5.91,52.56).
city('Losser','nl','Overijssel',22618.0,7.01,52.27).
city('Oldenzaal','nl','Overijssel',31843.0,6.94,52.32).
city('Ommen','nl','Overijssel',17301.0,6.51,52.46).
city('Ootmarsum','nl','Overijssel',4748.0,6.9,52.42).
city('Raalte','nl','Overijssel',37298.0,6.27,52.39).
city('Rijssen','nl','Overijssel',36244.0,6.51,52.32).
city('Staphorst','nl','Overijssel',15821.0,6.2,52.65).
city('Steenwijk','nl','Overijssel',42799.0,6.1,52.79).
city('Tubbergen','nl','Overijssel',20542.0,6.77,52.42).
city('Vriezenveen','nl','Overijssel',33809.0,6.61,52.43).
city('Wierden','nl','Overijssel',23783.0,6.59,52.37).
city('Zwolle','nl','Overijssel',114924.0,6.09,52.52).
city('Amersfoort','nl','Utrecht',139208.0,5.38,52.16).
city('Baarn','nl','Utrecht',24301.0,5.27,52.22).
city('Breukelen','nl','Utrecht',14540.0,4.99,52.19).
city('Bunnik','nl','Utrecht',14061.0,5.19,52.07).
city('Bunschoten','nl','Utrecht',19494.0,5.38,52.24).
city('De Bilt','nl','Utrecht',43179.0,5.17,52.12).
city('De Ronde Venen','nl','Utrecht',34965.0,4.86,52.2).
city('Doorn','nl','Utrecht',10402.0,5.34,52.04).
city('Driebergen-Rijsenburg','nl','Utrecht',18381.0,5.26,52.05).
city('Houten','nl','Utrecht',40766.0,5.16,52.04).
city('IJsselstein','nl','Utrecht',33489.0,5.04,52.02).
city('Leusden','nl','Utrecht',29843.0,5.46,52.13).
city('Lopik','nl','Utrecht',13904.0,4.95,51.98).
city('Maarsen','nl','Utrecht',39269.0,5.04,52.15).
city('Montfoort','nl','Utrecht',13385.0,4.95,52.05).
city('Nieuwegein','nl','Utrecht',62806.0,5.08,52.03).
city('Oudewater','nl','Utrecht',9755.0,4.87,52.04).
city('Rhenen','nl','Utrecht',17957.0,5.56,51.97).
city('Soest','nl','Utrecht',45752.0,5.29,52.18).
city('Utrecht','nl','Utrecht',267044.0,5.11,52.1).
city('Veenendaal','nl','Utrecht',63119.0,5.55,52.02).
city('Vianen','nl','Utrecht',20029.0,5.1,52.01).
city('Wijk','nl','Utrecht',23557.0,5.35,51.99).
city('Woerden','nl','Utrecht',48653.0,4.91,52.09).
city('Woudenberg','nl','Utrecht',11182.0,5.41,52.09).
city('Zeist','nl','Utrecht',60233.0,5.23,52.1).
city('Axel','nl','Zeeland',12421.0,3.91,51.27).
city('Borsele','nl','Zeeland',22723.0,3.73,51.43).
city('Goes','nl','Zeeland',37275.0,3.89,51.51).
city('Hulst','nl','Zeeland',20158.0,4.05,51.29).
city('Kapelle','nl','Zeeland',12114.0,3.96,51.48).
city('Middelburg','nl','Zeeland',47307.0,3.61,51.5).
city('Oostburg','nl','Zeeland',18437.0,3.5,51.34).
city('Schouwen-Duiveland','nl','Zeeland',35592.0,3.92,51.66).
city('Terneuzen','nl','Zeeland',34771.0,3.84,51.33).
city('Tholen','nl','Zeeland',24399.0,4.21,51.54).
city('Veere','nl','Zeeland',21939.0,3.66,51.55).
city('Vlissingen','nl','Zeeland',45816.0,3.57,51.46).
city('Zijpe','nl','Zeeland',11334.0,4.1,51.65).
city('Alblasserdam','nl','Zuid-Holland',18888.0,4.66,51.87).
city('Alphen','nl','Zuid-Holland',72570.0,4.66,52.14).
city('Barendrecht','nl','Zuid-Holland',43123.0,4.54,51.86).
city('Bergschenhoek','nl','Zuid-Holland',15080.0,4.5,51.99).
city('Berkel en Rodenrijs','nl','Zuid-Holland',17801.0,4.47,51.98).
city('Bleiswijk','nl','Zuid-Holland',10792.0,4.53,52.02).
city('Bodegraven','nl','Zuid-Holland',19920.0,4.74,52.09).
city('Boskoop','nl','Zuid-Holland',15469.0,4.66,52.07).
city('Brielle','nl','Zuid-Holland',16070.0,4.16,51.91).
city('Capelle','nl','Zuid-Holland',66878.0,4.58,51.94).
city('De Lier','nl','Zuid-Holland',11589.0,4.26,51.97).
city('Delft','nl','Zuid-Holland',98482.0,4.36,52.01).
city('Dordrecht','nl','Zuid-Holland',121595.0,4.67,51.8).
city('Giessenlanden','nl','Zuid-Holland',14419.0,4.86,51.85).
city('Goedereede','nl','Zuid-Holland',11661.0,3.98,51.82).
city('Gorinchem','nl','Zuid-Holland',35730.0,4.96,51.84).
city('Gouda','nl','Zuid-Holland',71684.0,4.7,52.02).
city('Hardinxveld-Giessendam','nl','Zuid-Holland',17888.0,4.83,51.84).
city('Hellevoetsluis','nl','Zuid-Holland',40803.0,4.13,51.84).
city('Hendrik-Ido-Ambacht','nl','Zuid-Holland',22478.0,4.63,51.85).
city('Jacobswoude','nl','Zuid-Holland',10514.0,4.67,52.22).
city('Krimpen','nl','Zuid-Holland',29799.0,4.59,51.92).
city('Leiden','nl','Zuid-Holland',116928.0,4.49,52.17).
city('Leiderdorp','nl','Zuid-Holland',28563.0,4.52,52.16).
city('Leidschendam-Voorburg','nl','Zuid-Holland',74666.0,4.39,52.09).
city('Liesveld','nl','Zuid-Holland',9842.0,4.83,51.94).
city('Lisse','nl','Zuid-Holland',22059.0,4.56,52.26).
city('Maassluis','nl','Zuid-Holland',32989.0,4.26,51.92).
city('Middelharnis','nl','Zuid-Holland',17971.0,4.15,51.76).
city('Monster','nl','Zuid-Holland',20629.0,4.18,52.04).
city('Naaldwijk','nl','Zuid-Holland',28916.0,4.19,52.0).
city('Nieuwekerk aan den IJssel','nl','Zuid-Holland',24067.0,4.63,51.98).
city('Nieuwkoop','nl','Zuid-Holland',11010.0,4.78,52.15).
city('Noordwijk','nl','Zuid-Holland',23908.0,4.43,52.25).
city('Noordwijkerhout','nl','Zuid-Holland',14963.0,4.49,52.27).
city('Oegestgeest','nl','Zuid-Holland',22018.0,4.47,52.18).
city('Oostflakkee','nl','Zuid-Holland',10201.0,4.26,51.7).
city('Oud-Beijerland','nl','Zuid-Holland',23787.0,4.42,51.83).
city('Papendrecht','nl','Zuid-Holland',31379.0,4.67,51.84).
city('Pijnacker-Nootdorp','nl','Zuid-Holland',35907.0,4.42,52.02).
city('Reeuwijk','nl','Zuid-Holland',12970.0,4.71,52.05).
city('Ridderkerk','nl','Zuid-Holland',45568.0,4.59,51.87).
city('Rijnsburg','nl','Zuid-Holland',15297.0,4.44,52.19).
city('Rijnwoude','nl','Zuid-Holland',18912.0,4.54,52.09).
city('Rijswijk','nl','Zuid-Holland',48413.0,4.36,52.05).
city('Rotterdam','nl','Zuid-Holland',603851.0,4.48,51.93).
city('Sassenheim','nl','Zuid-Holland',15097.0,4.52,52.22).
city('Schiedam','nl','Zuid-Holland',76874.0,4.37,51.94).
city('Schipluiden','nl','Zuid-Holland',1112.0,4.31,51.98).
city('Schoonhoven','nl','Zuid-Holland',12471.0,4.84,51.95).
city('Sliedrecht','nl','Zuid-Holland',23758.0,4.75,51.83).
city('Spijkenisse','nl','Zuid-Holland',78642.0,4.32,51.85).
city('Strijen','nl','Zuid-Holland',9190.0,4.55,51.75).
city('The Hague','nl','Zuid-Holland',476587.0,4.28,52.08).
city('Vlaardingen','nl','Zuid-Holland',74210.0,4.33,51.92).
city('Vlist','nl','Zuid-Holland',9874.0,4.82,51.98).
city('Voorhout','nl','Zuid-Holland',16650.0,4.48,52.22).
city('Voorschoten','nl','Zuid-Holland',22271.0,4.45,52.14).
city('Waddinxveen','nl','Zuid-Holland',27087.0,4.65,52.6).
city('Wassenaar','nl','Zuid-Holland',25317.0,4.39,52.16).
city('Wateringen','nl','Zuid-Holland',17050.0,4.28,52.04).
city('West Maas en Waal','nl','Zuid-Holland',18551.0,4.47,51.79).
city('Zevenhuizen-Moerkapelle','nl','Zuid-Holland',10169.0,4.58,52.02).
city('Zoetermeer','nl','Zuid-Holland',114144.0,4.49,52.07).
city('Zwijndrecht','nl','Zuid-Holland',41148.0,4.64,51.82).
city('s-Gravenzande','nl','Zuid-Holland',20029.0,4.15,52.01).
city('Fayaoue','nc','Iles',4239.0,166.53,-20.65).
city('Tadine','nc','Iles',8261.0,167.88,-21.55).
city('Vao','nc','Iles',1807.0,167.48,-22.67).
city('Waala','nc','Iles',1043.0,163.67,-19.73).
city('We','nc','Iles',11176.0,167.24,-20.91).
city('Canala','nc','Nord',2857.0,165.95,-21.52).
city('Hienghene','nc','Nord',2219.0,164.93,-20.68).
city('Houailu','nc','Nord',4795.0,165.62,-21.29).
city('Kaala Gomen','nc','Nord',1939.0,164.4,-20.67).
city('Kone','nc','Nord',4775.0,164.85,-21.06).
city('Koumac','nc','Nord',3153.0,164.26,-20.56).
city('Ouegoa','nc','Nord',2092.0,164.43,-20.35).
city('Poindimie','nc','Nord',5157.0,165.0,-20.95).
city('Ponerihouen','nc','Nord',2934.0,165.4,-21.08).
city('Pouebo','nc','Nord',2281.0,164.57,-20.4).
city('Pouembout','nc','Nord',1592.0,164.9,-21.13).
city('Poum','nc','Nord',1568.0,164.02,-20.23).
city('Poya','nc','Nord',3394.0,165.15,-21.35).
city('Touho','nc','Nord',2424.0,165.23,-20.78).
city('Voh','nc','Nord',2168.0,164.7,-20.97).
city('Bouloupari','nc','Sud',1619.0,166.05,-21.87).
city('Bourail','nc','Sud',4595.0,165.48,-21.57).
city('Dumbea','nc','Sud',21031.0,166.44,-22.17).
city('Farino','nc','Sud',260.0,165.77,-21.67).
city('La Foa','nc','Sud',2778.0,165.82,-21.72).
city('Moindou','nc','Sud',630.0,165.68,-21.7).
city('Mont-Dore','nc','Sud',26237.0,166.58,-22.28).
city('Noumea','nc','Sud',93331.0,166.44,-22.27).
city('Paita','nc','Sud',10436.0,166.34,-22.13).
city('Sarramea','nc','Sud',586.0,165.85,-21.65).
city('Thio','nc','Sud',2732.0,166.19,-21.61).
city('Yate','nc','Sud',1674.0,166.9,-22.15).
city('Waitangi','nz','Area Outside Region',644.0,176.52,-43.94).
city('Algies Bay-Mahurangi','nz','Auckland',938.0,174.74,-36.44).
city('Auckland','nz','Auckland',417910.0,174.76,-36.85).
city('Helensville','nz','Auckland',2580.0,174.47,-36.68).
city('Leigh','nz','Auckland',499.0,174.82,-36.28).
city('Manukau','nz','Auckland',383256.0,174.88,-37.0).
city('North Shore','nz','Auckland',207865.0,174.75,-36.8).
city('Orewa','nz','Auckland',6588.0,175.45,-36.79).
city('Parakai','nz','Auckland',1390.0,174.43,-36.65).
city('Snells Beach','nz','Auckland',3727.0,174.44,-36.24).
city('Waiheke','nz','Auckland',8719.0,175.1,-36.8).
city('Waitakere','nz','Auckland',166237.0,174.54,-36.85).
city('Warkworth','nz','Auckland',3441.0,174.67,-36.4).
city('Wellsford','nz','Auckland',1986.0,174.52,-36.28).
city('Athenree','nz','Bay of Plenty',563.0,175.92,-37.47).
city('Edgecumbe','nz','Bay of Plenty',1642.0,176.83,-37.98).
city('Katikati','nz','Bay of Plenty',3232.0,175.92,-37.55).
city('Kawerau','nz','Bay of Plenty',6702.0,176.7,-38.09).
city('Maketu','nz','Bay of Plenty',1083.0,176.45,-37.77).
city('Mamaku','nz','Bay of Plenty',751.0,176.08,-38.1).
city('Matata','nz','Bay of Plenty',722.0,176.75,-37.88).
city('Murupara','nz','Bay of Plenty',1876.0,176.7,-38.47).
city('Opotiki','nz','Bay of Plenty',4044.0,177.28,-38.07).
city('Paengaroa','nz','Bay of Plenty',901.0,176.42,-37.82).
city('Rotorua','nz','Bay of Plenty',54063.0,176.24,-38.14).
city('Taneatua','nz','Bay of Plenty',813.0,177.02,-38.07).
city('Tauranga','nz','Bay of Plenty',110338.0,176.15,-37.7).
city('Te Kaha','nz','Bay of Plenty',403.0,177.68,-37.73).
city('Te Puke','nz','Bay of Plenty',7200.0,176.32,-37.78).
city('Waimana','nz','Bay of Plenty',709.0,177.08,-38.15).
city('Whakatane','nz','Bay of Plenty',18602.0,176.99,-37.97).
city('Akaroa','nz','Canterbury',628.0,172.97,-43.8).
city('Amberley','nz','Canterbury',1105.0,172.73,-43.16).
city('Ashburton','nz','Canterbury',16783.0,171.75,-43.91).
city('Burnham','nz','Canterbury',1239.0,172.32,-43.62).
city('Cheviot','nz','Canterbury',425.0,173.27,-42.82).
city('Christchurch','nz','Canterbury',363925.0,172.64,-43.0).
city('Culverden','nz','Canterbury',432.0,172.85,-42.77).
city('Cust','nz','Canterbury',435.0,167.05,-43.32).
city('Darfield','nz','Canterbury',1593.0,172.12,-43.48).
city('Dunsandel','nz','Canterbury',438.0,172.18,-43.67).
city('Fairlie','nz','Canterbury',788.0,170.83,-44.09).
city('Geraldine','nz','Canterbury',2335.0,171.25,-44.1).
city('Hampden','nz','Canterbury',333.0,170.82,-45.33).
city('Hanmer Springs','nz','Canterbury',784.0,172.82,-42.52).
city('Kaikoura','nz','Canterbury',2180.0,174.41,-39.73).
city('Kurow','nz','Canterbury',422.0,170.47,-44.73).
city('Lake Tekapo','nz','Canterbury',330.0,170.5,-44.02).
city('Leeston','nz','Canterbury',1272.0,172.3,-43.76).
city('Lincoln','nz','Canterbury',2235.0,172.48,-43.65).
city('Lyttelton','nz','Canterbury',3220.0,172.72,-43.6).
city('Methven','nz','Canterbury',1236.0,171.65,-43.63).
city('Mount Cook','nz','Canterbury',255.0,170.1,-43.73).
city('Oamaru','nz','Canterbury',13020.0,170.98,-45.07).
city('Omarama','nz','Canterbury',304.0,169.97,-44.48).
city('Otematata','nz','Canterbury',265.0,170.27,-44.62).
city('Oxford','nz','Canterbury',1776.0,172.18,-43.3).
city('Pareora','nz','Canterbury',503.0,171.2,-44.5).
city('Pleasant Point','nz','Canterbury',1187.0,171.13,-44.27).
city('Rakaia','nz','Canterbury',1043.0,172.02,-43.75).
city('Rangiora','nz','Canterbury',12459.0,172.57,-43.31).
city('Rolleston','nz','Canterbury',3124.0,172.38,-43.58).
city('Sefton','nz','Canterbury',546.0,172.67,-43.25).
city('Southbridge','nz','Canterbury',785.0,172.25,-43.82).
city('Taitapu','nz','Canterbury',454.0,172.55,-43.67).
city('Te Puru-Thornton Bay','nz','Canterbury',1040.0,172.75,-43.63).
city('Temuka','nz','Canterbury',4254.0,171.27,-44.25).
city('Timaru','nz','Canterbury',28007.0,171.22,-44.38).
city('Twizel','nz','Canterbury',986.0,170.18,-44.33).
city('Waikuku','nz','Canterbury',804.0,172.68,-43.3).
city('Waimate','nz','Canterbury',2799.0,173.88,-35.31).
city('Woodend','nz','Canterbury',3059.0,172.67,-43.32).
city('Gisborne','nz','Gisborne',34274.0,178.02,-38.66).
city('Manutuke','nz','Gisborne',685.0,177.92,-38.68).
city('Muriwai Beach','nz','Gisborne',2183.0,174.45,-36.82).
city('Patutahi','nz','Gisborne',386.0,177.9,-38.62).
city('Ruatoria','nz','Gisborne',897.0,178.33,-37.88).
city('Te Karaka','nz','Gisborne',592.0,177.87,-38.47).
city('Tokomaru Bay','nz','Gisborne',495.0,178.3,-38.13).
city('Tolaga Bay','nz','Gisborne',932.0,178.3,-38.37).
city('Frasertown','nz','Hawkes Bay',302.0,177.4,-38.97).
city('Hastings','nz','Hawkes Bay',61696.0,176.84,-39.64).
city('Napier','nz','Hawkes Bay',56787.0,176.9,-39.49).
city('Nuhaka','nz','Hawkes Bay',342.0,177.75,-39.05).
city('Otane','nz','Hawkes Bay',566.0,176.63,-39.88).
city('Tuai','nz','Hawkes Bay',280.0,177.17,-38.82).
city('Waipawa','nz','Hawkes Bay',1899.0,175.52,-41.4).
city('Waipukurau','nz','Hawkes Bay',3984.0,176.67,-40.17).
city('Wairoa','nz','Hawkes Bay',4260.0,177.37,-39.02).
city('Bulls','nz','Manawatu-Wanganui',1781.0,175.38,-40.17).
city('Dannevirke','nz','Manawatu-Wanganui',5478.0,176.09,-40.21).
city('Eketahuna','nz','Manawatu-Wanganui',594.0,175.7,-40.65).
city('Feilding','nz','Manawatu-Wanganui',14153.0,175.55,-40.22).
city('Foxton','nz','Manawatu-Wanganui',4780.0,175.3,-40.47).
city('Halcombe','nz','Manawatu-Wanganui',446.0,175.5,-40.15).
city('Himatangi','nz','Manawatu-Wanganui',538.0,175.32,-40.4).
city('Hunterville','nz','Manawatu-Wanganui',520.0,175.57,-39.93).
city('Levin','nz','Manawatu-Wanganui',19790.0,175.28,-40.62).
city('Marton','nz','Manawatu-Wanganui',4610.0,175.38,-40.08).
city('Ohakune','nz','Manawatu-Wanganui',1303.0,175.42,-39.42).
city('Ohura','nz','Manawatu-Wanganui',225.0,174.98,-38.83).
city('Pahiatua','nz','Manawatu-Wanganui',2649.0,175.83,-40.45).
city('Palmerston North','nz','Manawatu-Wanganui',75997.0,175.61,-40.35).
city('Picton','nz','Manawatu-Wanganui',4300.0,174.02,-41.3).
city('Raetihi','nz','Manawatu-Wanganui',1053.0,175.28,-39.43).
city('Ratana','nz','Manawatu-Wanganui',437.0,175.18,-40.05).
city('Rongotea','nz','Manawatu-Wanganui',631.0,175.42,-40.3).
city('Sanson','nz','Manawatu-Wanganui',508.0,175.42,-40.22).
city('Shannon','nz','Manawatu-Wanganui',1441.0,175.42,-40.55).
city('Taihape','nz','Manawatu-Wanganui',1752.0,175.8,-39.68).
city('Takapau','nz','Manawatu-Wanganui',597.0,176.35,-40.03).
city('Taumarunui','nz','Manawatu-Wanganui',4922.0,175.26,-38.89).
city('Tokomaru','nz','Manawatu-Wanganui',563.0,175.5,-40.47).
city('Waiouru','nz','Manawatu-Wanganui',1347.0,175.67,-39.48).
city('Wanganui','nz','Manawatu-Wanganui',40269.0,175.03,-39.93).
city('Woodville','nz','Manawatu-Wanganui',1486.0,175.87,-40.33).
city('Blenheim','nz','Marlborough',28467.0,173.96,-41.53).
city('Havelock','nz','Marlborough',504.0,173.77,-41.28).
city('Seddon','nz','Marlborough',511.0,174.08,-41.67).
city('Nelson','nz','Nelson',60481.0,173.24,-41.29).
city('Ahipara','nz','Northland',1093.0,173.17,-35.17).
city('Awanui','nz','Northland',388.0,173.25,-35.05).
city('Dargaville','nz','Northland',4672.0,173.88,-35.92).
city('East Opua','nz','Northland',360.0,174.12,-35.32).
city('Haruru Falls','nz','Northland',632.0,174.05,-35.27).
city('Kaeo','nz','Northland',508.0,173.78,-35.1).
city('Kaikohe','nz','Northland',4080.0,173.8,-35.4).
city('Kaingaroa Forest','nz','Northland',578.0,173.33,-35.03).
city('Kaitaia','nz','Northland',5237.0,173.27,-35.12).
city('Kaiwaka','nz','Northland',565.0,174.45,-36.17).
city('Kawakawa','nz','Northland',1399.0,174.07,-35.38).
city('Kerikeri','nz','Northland',5654.0,173.97,-35.22).
city('Mangawhai Heads','nz','Northland',692.0,174.57,-36.12).
city('Maungatapere','nz','Northland',1007.0,174.2,-35.75).
city('Maungaturoto','nz','Northland',790.0,174.37,-36.1).
city('Moerewa','nz','Northland',1662.0,174.03,-35.38).
city('Ngunguru','nz','Northland',1358.0,174.5,-35.62).
city('Ohaeawai','nz','Northland',764.0,173.88,-35.35).
city('Okaihau','nz','Northland',726.0,173.78,-35.32).
city('Omapere and Opononi','nz','Northland',628.0,173.38,-35.53).
city('Paihia','nz','Northland',1944.0,174.08,-35.28).
city('Rawene','nz','Northland',486.0,173.5,-35.4).
city('Ruawai','nz','Northland',477.0,174.03,-36.13).
city('Russell','nz','Northland',839.0,174.12,-35.27).
city('Taipa Bay-Mangonui','nz','Northland',1731.0,173.47,-34.98).
city('Te Kopuru','nz','Northland',505.0,175.07,-39.67).
city('Whangarei','nz','Northland',49711.0,174.31,-35.72).
city('Alexandra','nz','Otago',4650.0,169.37,-45.25).
city('Arrowtown','nz','Otago',2126.0,168.83,-44.93).
city('Balclutha','nz','Otago',4441.0,169.75,-46.22).
city('Clinton','nz','Otago',343.0,169.37,-46.2).
city('Clyde','nz','Otago',890.0,169.32,-45.18).
city('Cromwell','nz','Otago',2934.0,169.23,-45.05).
city('Dunedin','nz','Otago',114346.0,170.48,-45.88).
city('Kaitangata','nz','Otago',851.0,169.85,-46.25).
city('Kakanui','nz','Otago',443.0,170.9,-45.18).
city('Karitane','nz','Otago',427.0,170.67,-45.65).
city('Lawrence','nz','Otago',511.0,169.7,-45.92).
city('Milton','nz','Otago',2009.0,169.97,-46.12).
city('Outram','nz','Otago',657.0,170.23,-45.87).
city('Owaka','nz','Otago',395.0,169.67,-46.45).
city('Palmerston','nz','Otago',870.0,170.72,-45.48).
city('Queenstown','nz','Otago',10500.0,168.64,-45.04).
city('Ranfurly','nz','Otago',793.0,170.1,-45.13).
city('Roxburgh','nz','Otago',670.0,169.32,-45.55).
city('Stirling','nz','Otago',320.0,169.78,-46.25).
city('Tapanui','nz','Otago',913.0,169.27,-45.93).
city('Waikouaiti','nz','Otago',1181.0,170.68,-45.6).
city('Waitati','nz','Otago',534.0,170.57,-45.75).
city('Wanaka','nz','Otago',4428.0,169.15,-44.7).
city('Warrington','nz','Otago',427.0,170.58,-45.72).
city('Bluff','nz','Southland',1938.0,168.33,-46.6).
city('Edendale','nz','Southland',583.0,168.78,-46.32).
city('Gore','nz','Southland',10127.0,168.92,-46.09).
city('Invercargill','nz','Southland',47287.0,168.37,-46.41).
city('Lumsden','nz','Southland',463.0,168.45,-45.73).
city('Manapouri','nz','Southland',248.0,167.6,-45.57).
city('Night Caps','nz','Southland',350.0,168.03,-45.97).
city('Ohai','nz','Southland',408.0,167.95,-45.92).
city('Otautau','nz','Southland',745.0,168.0,-46.15).
city('Riversdale','nz','Southland',371.0,168.75,-45.9).
city('Riverton','nz','Southland',1651.0,168.02,-46.35).
city('Te Anau','nz','Southland',2074.0,167.72,-45.42).
city('Tuatapere','nz','Southland',696.0,167.68,-46.13).
city('Wallacetown','nz','Southland',638.0,168.27,-46.33).
city('Winton','nz','Southland',2193.0,168.33,-46.15).
city('Woodlands','nz','Southland',285.0,168.55,-46.37).
city('Wyndham','nz','Southland',586.0,168.85,-46.33).
city('Egmont Village','nz','Taranaki',479.0,174.15,-39.15).
city('Eltham','nz','Taranaki',2235.0,174.3,-39.43).
city('Hawera','nz','Taranaki',11069.0,174.28,-39.58).
city('Inglewood','nz','Taranaki',2879.0,174.25,-39.16).
city('Kaponga','nz','Taranaki',357.0,174.15,-39.43).
city('Manaia','nz','Taranaki',902.0,174.13,-39.55).
city('New Plymouth','nz','Taranaki',49169.0,174.08,-39.06).
city('Okato','nz','Taranaki',528.0,173.88,-39.2).
city('Opunake','nz','Taranaki',1495.0,173.86,-39.46).
city('Patea','nz','Taranaki',1286.0,174.48,-39.76).
city('Rahotu','nz','Taranaki',302.0,173.8,-39.33).
city('Stratford','nz','Taranaki',5266.0,174.26,-39.34).
city('Urenui','nz','Taranaki',421.0,174.38,-39.0).
city('Waitara','nz','Taranaki',6319.0,174.25,-38.93).
city('Waverley','nz','Taranaki',919.0,174.63,-39.77).
city('Brightwater','nz','Tasman',1677.0,173.12,-41.38).
city('Karamea','nz','Tasman',500.0,172.12,-41.25).
city('Mapua','nz','Tasman',1819.0,173.1,-41.25).
city('Motueka','nz','Tasman',7485.0,173.0,-41.12).
city('Murchison','nz','Tasman',624.0,172.33,-41.8).
city('Riwaka','nz','Tasman',986.0,173.0,-41.08).
city('Takaka','nz','Tasman',1223.0,172.8,-40.85).
city('Tapawera','nz','Tasman',432.0,172.82,-41.4).
city('Wakefield','nz','Tasman',1663.0,173.05,-41.4).
city('Bombay','nz','Waikato',740.0,174.98,-37.17).
city('Cambridge','nz','Waikato',15.0,175.44,-37.88).
city('Coromandel','nz','Waikato',1502.0,175.5,-36.77).
city('Hamilton','nz','Waikato',152642.0,175.28,-37.78).
city('Huntly','nz','Waikato',6988.0,175.17,-37.55).
city('Kawhia','nz','Waikato',543.0,174.82,-38.07).
city('Kerepehi','nz','Waikato',537.0,175.53,-37.3).
city('Mangakino','nz','Waikato',1202.0,175.77,-38.4).
city('Matamata','nz','Waikato',6575.0,175.77,-37.82).
city('Meremere','nz','Waikato',379.0,174.38,-39.58).
city('Morrinsville','nz','Waikato',6695.0,175.53,-37.65).
city('Ngaruawahia','nz','Waikato',5112.0,175.12,-37.67).
city('Ngatea','nz','Waikato',1151.0,175.5,-37.28).
city('Otorohanga','nz','Waikato',2673.0,175.2,-38.17).
city('Paeroa','nz','Waikato',3994.0,175.67,-37.36).
city('Pauanui Beach','nz','Waikato',749.0,175.87,-37.02).
city('Piopio','nz','Waikato',502.0,175.02,-38.47).
city('Pukekohe','nz','Waikato',21438.0,174.95,-37.19).
city('Putaruru','nz','Waikato',3782.0,175.78,-38.05).
city('Raglan','nz','Waikato',2863.0,174.88,-37.8).
city('Reporoa','nz','Waikato',595.0,176.35,-38.43).
city('Tairua','nz','Waikato',1588.0,175.85,-37.02).
city('Taupo','nz','Waikato',22469.0,176.08,-38.69).
city('Te Aroha','nz','Waikato',3781.0,175.71,-37.53).
city('Te Awamutu','nz','Waikato',14007.0,175.33,-38.01).
city('Te Kauwhata','nz','Waikato',1174.0,175.15,-37.4).
city('Te Kuiti','nz','Waikato',4464.0,175.17,-38.32).
city('Te Teko','nz','Waikato',672.0,175.82,-38.22).
city('Thames','nz','Waikato',7136.0,175.53,-37.12).
city('Tirau','nz','Waikato',778.0,175.75,-37.98).
city('Tokoroa','nz','Waikato',14277.0,175.87,-38.22).
city('Turangi','nz','Waikato',3401.0,175.93,-39.0).
city('Waharoa','nz','Waikato',569.0,175.77,-37.77).
city('Waihi','nz','Waikato',4619.0,175.83,-37.38).
city('Waihi Beach','nz','Waikato',2014.0,175.93,-37.4).
city('Waitoa','nz','Waikato',386.0,175.63,-37.62).
city('Waiuku','nz','Waikato',7555.0,174.75,-37.25).
city('Whangamata','nz','Waikato',4253.0,175.87,-37.2).
city('Whitianga','nz','Waikato',3367.0,175.7,-36.83).
city('Carterton','nz','Wellington',4322.0,175.53,-41.02).
city('Featherston','nz','Wellington',2393.0,175.32,-41.12).
city('Greytown','nz','Wellington',2166.0,175.45,-41.08).
city('Kapiti','nz','Wellington',39078.0,175.02,-40.91).
city('Lower Hutt','nz','Wellington',101194.0,174.93,-41.2).
city('Makara-Ohariu','nz','Wellington',920.0,174.77,-41.2).
city('Martinborough','nz','Wellington',1370.0,175.47,-41.22).
city('Masterton','nz','Wellington',20698.0,175.65,-40.95).
city('Otaki','nz','Wellington',6086.0,175.15,-40.76).
city('Porirua','nz','Wellin',50914.0,174.85,-41.14).
city('Te Horo','nz','Wellington',698.0,175.1,-40.8).
city('Upper Hutt','nz','Wellington',36304.0,175.03,-41.14).
city('Wellington','nz','Wellington',179240.0,174.78,-41.28).
city('Blackball','nz','West Coast',321.0,171.42,-42.37).
city('Dobson','nz','West Coast',738.0,171.3,-42.45).
city('Fox Glacier','nz','West Coast',253.0,170.08,-43.5).
city('Franz Josef','nz','West Coast',315.0,170.18,-43.4).
city('Greymouth','nz','West Coast',9418.0,171.2,-42.46).
city('Harihari','nz','West Coast',345.0,170.55,-43.15).
city('Hector-Ngakawau','nz','West Coast',297.0,171.88,-41.6).
city('Hokitika','nz','West Coast',3401.0,170.97,-42.71).
city('Reefton','nz','West Coast',980.0,171.87,-42.12).
city('Ross','nz','West Coast',312.0,170.82,-42.9).
city('Westport','nz','West Coast',3629.0,171.57,-41.74).
city('Bonanza','ni','Atlantico Norte',6129.0,-84.59,14.03).
city('Puerto Cabezas','ni','Atlantico Norte',31050.0,-83.39,14.03).
city('Rosita','ni','Atlantico Norte',8151.0,-84.41,13.93).
city('Siuna','ni','Atlantico Norte',11725.0,-84.77,13.73).
city('Waslala','ni','Atlantico Norte',5611.0,-85.39,13.23).
city('Waspan','ni','Atlantico Norte',7287.0,-83.97,14.74).
city('Bluefields','ni','Atlantico Sur',50178.0,-83.77,12.01).
city('Bocana de Paiwas','ni','Atlantico Sur',4975.0,-85.14,12.8).
city('Corn Island','ni','Atlantico Sur',7934.0,-83.04,12.17).
city('El Rama','ni','Atlantico Sur',25484.0,-84.22,12.15).
city('Laguna de Perlas','ni','Atlantico Sur',4944.0,-83.68,12.35).
city('Nueva Guinea','ni','Atlantico Sur',46630.0,-84.46,11.69).
city('Boaco','ni','Boaco',22481.0,-85.66,12.47).
city('Camoapa','ni','Boaco',14401.0,-85.51,12.38).
city('San Lorenzo','ni','Boaco',6885.0,-85.67,12.38).
city('Diriamba','ni','Carazo',38018.0,-86.25,11.86).
city('Dolores','ni','Carazo',6143.0,-86.22,11.85).
city('Jinotepe','ni','Carazo',31267.0,-86.2,11.85).
city('Masatepe','ni','Carazo',17323.0,-86.16,11.91).
city('San Marcos','ni','Carazo',19957.0,-86.2,11.92).
city('Santa Teresa','ni','Carazo',5372.0,-86.22,11.73).
city('Chichigalpa','ni','Chinandega',38066.0,-87.03,12.57).
city('Chinandega','ni','Chinandega',128616.0,-87.13,12.63).
city('Corinto','ni','Chinandega',22354.0,-87.18,12.48).
city('El Viejo','ni','Chinandega',44384.0,-87.18,12.67).
city('Puerto Morazan','ni','Chinandega',5769.0,-87.18,12.85).
city('Somotillo','ni','Chinandega',13063.0,-86.91,13.04).
city('Acoyapa','ni','Chontales',10011.0,-85.17,11.97).
city('Juigalpa','ni','Chontales',48899.0,-85.38,12.11).
city('Santo Domingo','ni','Chontales',6212.0,-85.09,12.27).
city('Santo Tomas','ni','Chontales',13437.0,-85.08,12.07).
city('Villa Sandino','ni','Chontales',8234.0,-84.99,12.05).
city('Condega','ni','Esteli',10067.0,-86.4,13.35).
city('Esteli','ni','Esteli',91687.0,-86.36,13.09).
city('La Trinidad','ni','Esteli',9312.0,-86.18,12.57).
city('Diriomo','ni','Granada',9134.0,-86.05,11.87).
city('Granada','ni','Granada',92630.0,-85.96,11.94).
city('Nandaime','ni','Granada',18832.0,-86.06,11.76).
city('Jinotega','ni','Jinotega',36824.0,-86.0,13.1).
city('Wiwili','ni','Jinotega',6508.0,-85.82,13.61).
city('El Sauce','ni','Leon',8559.0,-86.54,12.88).
city('La Paz Centro','ni','Leon',20995.0,-86.68,12.33).
city('Larreynaga','ni','Leon',6645.0,-86.57,12.67).
city('Leon','ni','Leon',150327.0,-86.89,12.43).
city('Nagarote','ni','Leon',35438.0,-86.57,12.26).
city('Telica','ni','Leon',7550.0,-86.87,12.52).
city('Somoto','ni','Madriz',18581.0,-86.59,13.48).
city('Managua','ni','Managua',1140499.0,-86.27,12.15).
city('Mateare','ni','Managua',15067.0,-86.32,12.23).
city('San Rafael del Sur','ni','Managua',25184.0,-86.44,11.85).
city('Ticuantepe','ni','Mana',10226.0,-86.2,12.02).
city('Tipitapa','ni','Managua',89642.0,-86.1,12.2).
city('La Concepcion','ni','Masaya',12471.0,-86.18,11.93).
city('Masaya','ni','Masaya',123474.0,-86.1,11.98).
city('Nandasmo','ni','Masaya',6417.0,-86.12,11.93).
city('Nindiri','ni','Masaya',10496.0,-86.13,12.01).
city('Niquinohomo','ni','Masaya',7262.0,-86.1,11.9).
city('Ciudad Dario','ni','Matagalpa',12981.0,-86.12,12.72).
city('Matagalpa','ni','Matagalpa',79122.0,-85.93,12.93).
city('Matiguas','ni','Matagalpa',9769.0,-85.46,12.83).
city('Rio Blanco','ni','Matagalpa',12311.0,-85.23,12.93).
city('San Isidro','ni','Matagalpa',6366.0,-85.48,12.55).
city('Sebaco','ni','Matagalpa',21449.0,-86.05,12.83).
city('El Jicaro','ni','Nueva Segovia',9522.0,-86.1,11.58).
city('Jalapa','ni','Nueva Segovia',33620.0,-86.14,13.92).
city('Ocotal','ni','Nueva Segovia',39199.0,-86.48,13.64).
city('Quilali','ni','Nueva Segovia',12211.0,-86.04,13.57).
city('San Carlos','ni','Rio San Juan',12931.0,-84.78,11.13).
city('San Miguelito','ni','Rio San Juan',4447.0,-84.9,11.4).
city('Belen','ni','Rivas',4968.0,-85.89,11.5).
city('Rivas','ni','Rivas',26046.0,-85.82,11.44).
city('San Jorge','ni','Rivas',7001.0,-85.8,11.45).
city('San Juan del Sur','ni','Rivas',6787.0,-85.86,11.25).
city('Agadez','ne','Agadez',88569.0,7.98,17.0).
city('Arlit','ne','Agadez',83400.0,7.33,18.82).
city('Bilma','ne','Agadez',2292.0,12.94,18.69).
city('Tchirozerine','ne','Agadez',10367.0,7.83,17.11).
city('Diffa','ne','Diffa',27951.0,12.62,13.32).
city('Maine-Soroa','ne','Diffa',10700.0,12.03,13.21).
city('NGuigmi','ne','Diffa',17899.0,13.12,14.25).
city('Birni NGaoure','ne','Dosso',23909.0,2.91,13.08).
city('Boboye','ne','Dosso',12166.0,2.87,13.0).
city('Dogondoutchi','ne','Dosso',31770.0,4.03,13.64).
city('Dosso','ne','Dosso',49755.0,3.2,13.05).
city('Gaya','ne','Dosso',33054.0,3.49,11.89).
city('Aguie','ne','Maradi',13153.0,7.78,13.5).
city('Dakoro','ne','Maradi',19799.0,6.77,14.51).
city('Guidan Roumdji','ne','Maradi',11650.0,6.7,13.67).
city('Madarounfa','ne','Maradi',9792.0,7.15,13.3).
city('Maradi','ne','Maradi',163501.0,7.1,13.49).
city('Mayahi','ne','Maradi',22185.0,7.67,13.97).
city('Tessaoua','ne','Maradi',35778.0,7.99,13.75).
city('Tibiri','ne','Maradi',20019.0,7.06,13.58).
city('Niamey','ne','Niamey',774245.0,2.12,13.52).
city('Abalak','ne','Tahoua',13555.0,6.29,15.45).
city('Birni NKonni','ne','Tahoua',48108.0,5.26,13.79).
city('Bouza','ne','Tahoua',7142.0,6.05,14.42).
city('Illela','ne','Tahoua',16679.0,5.24,14.46).
city('Keita','ne','Tahoua',8961.0,5.78,14.76).
city('Madaoua','ne','Tahoua',24806.0,5.96,14.07).
city('Tahoua','ne','Tahoua',80432.0,5.26,14.9).
city('Tchintabaraden','ne','Tahoua',8852.0,5.8,15.9).
city('Ayorou','ne','Tillabery',26290.0,0.93,14.74).
city('Filingue','ne','Tillabery',11678.0,3.33,14.35).
city('Kollo','ne','Tillabery',10377.0,2.33,13.32).
city('Ouallam','ne','Tillabery',7501.0,2.09,14.32).
city('Say','ne','Tillabery',10388.0,2.36,13.11).
city('Tera','ne','Tillabery',21097.0,0.76,14.01).
city('Tillabery','ne','Tillabery',19263.0,1.45,14.21).
city('Goure','ne','Zinder',14640.0,10.27,13.98).
city('Magaria','ne','Zinder',19421.0,8.91,12.99).
city('Matameye','ne','Zinder',16846.0,8.48,13.42).
city('Mirriah','ne','Zinder',20726.0,9.16,13.71).
city('Tanout','ne','Zinder',15205.0,8.89,14.97).
city('Zinder','ne','Zinder',191440.0,8.99,13.8).
city('Aba','ng','Abia',897613.0,7.35,5.1).
city('Amaigbo','ng','Abia',127309.0,7.83,5.78).
city('Bende','ng','Abia',79624.0,7.63,5.57).
city('Ohafia','ng','Abia',73361.0,7.8,5.62).
city('Okwe','ng','Abia',80126.0,7.26,5.02).
city('Umuahia','ng','Abia',264680.0,7.48,5.54).
city('Abuja','ng','Abuja Federal Capital Territory',174152.0,7.17,9.18).
city('Jimeta','ng','Adamawa',248166.0,12.46,9.28).
city('Mubi','ng','Adamawa',225721.0,13.27,10.27).
city('Numan','ng','Adamawa',77622.0,12.03,9.47).
city('Yola','ng','Adamawa',96013.0,12.46,9.23).
city('Ikot Ekpene','ng','Akwa Ibom',254821.0,7.71,5.19).
city('Oron','ng','Akwa Ibom',112040.0,8.25,4.81).
city('Uyo','ng','Akwa Ibom',124690.0,7.85,5.01).
city('Agulu','ng','Anambra',79027.0,7.05,6.11).
city('Awka','ng','Anambra',167751.0,7.07,6.22).
city('Enugu Ukwu','ng','Anambra',68791.0,7.0,6.17).
city('Igbo Ukwu','ng','Anambra',75230.0,7.01,6.02).
city('Ihiala','ng','Anambra',83272.0,6.85,5.86).
city('Nkpor','ng','Anambra',103741.0,6.83,6.16).
city('Nnewi','ng','Anambra',194002.0,6.92,6.03).
city('Obosi','ng','Anambra',136753.0,6.87,6.11).
city('Okpoko','ng','Anambra',168462.0,6.17,6.53).
city('Onitsha','ng','Anambra',561106.0,6.78,6.16).
city('Ozubulu','ng','Anambra',73818.0,6.85,5.95).
city('Uga','ng','Anambra',64184.0,7.08,5.93).
city('Azare','ng','Bauchi',105695.0,10.19,11.68).
city('Bauchi','ng','Bauchi',316173.0,9.84,10.31).
city('Yenagoa','ng','Bayelsa',24335.0,6.25,4.93).
city('Gboko','ng','Benue',195710.0,8.9,7.33).
city('Makurdi','ng','Benue',292664.0,8.53,7.73).
city('Otukpo','ng','Benue',160830.0,8.67,6.82).
city('Bama','ng','Borno',118129.0,13.68,11.52).
city('Biu','ng','Borno',95012.0,12.2,10.6).
city('Gamboru','ng','Borno',84678.0,14.22,12.37).
city('Maiduguri','ng','Borno',1112511.0,13.16,11.85).
city('Calabar','ng','Cross River',461832.0,8.31,4.96).
city('Ikom','ng','Cross River',79110.0,8.71,5.97).
city('Ugep','ng','Cross River',200293.0,8.08,5.81).
city('Agbor','ng','Delta',67616.0,6.19,6.26).
city('Asaba','ng','Delta',73381.0,6.74,6.2).
city('Sapele','ng','Delta',161692.0,5.67,5.9).
city('Ughelli','ng','Delta',79993.0,5.98,5.5).
city('Warri','ng','Delta',536068.0,5.75,5.51).
city('Abakaliki','ng','Ebonyi',134113.0,8.11,6.33).
city('Afikpo','ng','Ebonyi',71872.0,7.93,5.9).
city('Effium','ng','Ebonyi',86952.0,8.07,6.63).
city('Ezza','ng','Ebonyi',67419.0,8.08,6.45).
city('Ishieke','ng','Ebonyi',89997.0,8.03,6.4).
city('Auchi','ng','Edo',62912.0,6.26,7.08).
city('Benin','ng','Edo',1125126.0,5.62,6.34).
city('Ekpoma','ng','Edo',59624.0,6.13,6.75).
city('Uromi','ng','Edo',108617.0,6.32,6.72).
city('Ado','ng','Ekiti',274328.0,5.27,7.67).
city('Aramoko','ng','Ekiti',74492.0,5.05,7.72).
city('Efon Alaye','ng','Ekiti',279339.0,4.88,7.67).
city('Emure','ng','Ekiti',90646.0,5.47,7.45).
city('Igbara Odo','ng','Ekiti',74121.0,5.06,7.51).
city('Igede','ng','Ekiti',87282.0,5.12,7.65).
city('Ijero','ng','Ekiti',167644.0,5.07,7.81).
city('Ikere','ng','Ekiti',103062.0,5.23,7.5).
city('Ikole','ng','Ekiti',110874.0,5.47,7.79).
city('Ilawe','ng','Ekiti',182896.0,5.06,7.4).
city('Ipoti','ng','Ekiti',82114.0,5.07,7.87).
city('Ise','ng','Ekiti',190077.0,5.42,7.46).
city('Ode','ng','Ekiti',75464.0,5.71,7.79).
city('Aku','ng','Enugu',73748.0,7.33,6.7).
city('Eha Amufu','ng','Enugu',70785.0,7.75,6.66).
city('Enugu','ng','Enugu',653436.0,7.5,6.33).
city('Nsukka','ng','Enugu',111026.0,7.39,6.86).
city('Duku','ng','Gombe',87671.0,10.77,10.82).
city('Gombe','ng','Gombe',250278.0,11.17,10.29).
city('Kumo','ng','Gombe',35715.0,11.21,10.04).
city('Pindiga','ng','Gombe',106323.0,10.9,9.98).
city('Etiti','ng','Imo',73752.0,7.35,5.62).
city('Nkwerre','ng','Imo',62997.0,7.12,5.75).
city('Okigwe','ng','Imo',115507.0,7.35,5.85).
city('Owerri','ng','Imo',215053.0,7.02,5.5).
city('Dutse','ng','Jigawa',17129.0,9.33,11.8).
city('Hadejia','ng','Jigawa',110761.0,10.04,12.46).
city('Kaduna','ng','Kaduna',1582211.0,7.44,10.52).
city('Kafanchan','ng','Kaduna',79529.0,8.28,9.59).
city('Kagoro','ng','Kaduna',77015.0,8.38,9.61).
city('Lere','ng','Kaduna',93289.0,8.58,10.39).
city('Zaria','ng','Kaduna',975228.0,7.71,11.08).
city('Kano','ng','Kano',3626204.0,8.52,12.0).
city('Daura','ng','Katsina',78283.0,11.45,11.53).
city('Funtua','ng','Katsina',136821.0,7.31,11.53).
city('Katsina','ng','Katsina',432179.0,7.6,13.0).
city('Malumfashi','ng','Katsina',70715.0,7.62,11.78).
city('Birnin Kebbi','ng','Kebbi',108172.0,4.19,12.46).
city('Jega','ng','Kebbi',73495.0,4.38,12.21).
city('Ankpa','ng','Kogi',61691.0,7.62,7.38).
city('Idah','ng','Kogi',68709.0,6.73,7.12).
city('Kuroro','ng','Kogi',70341.0,6.23,7.58).
city('Lokoja','ng','Kogi',60585.0,6.74,7.81).
city('Ogaminana','ng','Kogi',84380.0,6.23,7.6).
city('Okene','ng','Kogi',479217.0,6.23,7.56).
city('Ilorin','ng','Kwara',814246.0,4.53,8.5).
city('Lafiagi','ng','Kwara',102780.0,5.42,8.85).
city('Offa','ng','Kwara',113841.0,4.72,8.14).
city('Epe','ng','Lagos',84719.0,3.98,6.59).
city('Ikorodu','ng','Lagos',313468.0,3.51,6.61).
city('Lagos','ng','Lagos',8789133.0,3.47,6.45).
city('Keffi','ng','Nassarawa',85919.0,7.87,8.84).
city('Lafia','ng','Nassarawa',127246.0,8.52,8.49).
city('Bida','ng','Niger',171672.0,6.01,9.08).
city('Kontagora','ng','Niger',98763.0,5.47,10.4).
city('Minna','ng','Niger',291930.0,6.55,9.6).
city('Suleja','ng','Niger',162150.0,7.17,9.17).
city('Abeokuta','ng','Ogun',593140.0,3.35,7.16).
city('Ifo','ng','Ogun',88278.0,3.2,6.82).
city('Ijebu Igbo','ng','Ogun',109269.0,4.0,6.97).
city('Ijebu Ode','ng','Ogun',209191.0,3.92,6.81).
city('Sango Ota','ng','Ogun',173894.0,3.23,6.7).
city('Shagamu','ng','Ogun',214574.0,3.64,6.85).
city('Akure','ng','Ondo',420623.0,5.2,7.25).
city('Idanre','ng','Ondo',86468.0,5.11,7.11).
city('Ikare','ng','Ondo',182779.0,5.6,7.45).
city('Oka','ng','Ondo',78016.0,5.72,7.37).
city('Okitipupa','ng','Ondo',74062.0,4.69,6.51).
city('Ondo','ng','Ondo',257023.0,4.84,7.09).
city('Owo','ng','Ondo',276593.0,5.59,7.19).
city('Apomu','ng','Osun',71657.0,4.18,7.33).
city('Ede','ng','Osun',283728.0,4.52,7.73).
city('Ejigbo','ng','Osun',138367.0,4.32,7.9).
city('Erin-Oshogbo','ng','Osun',86647.0,4.48,7.81).
city('Gbongan','ng','Osun',139494.0,4.35,7.47).
city('Ife','ng','Osun',372191.0,4.57,7.55).
city('Ifon Osun','ng','Osun',125313.0,4.48,7.87).
city('Ikire','ng','Osun',222174.0,4.18,7.34).
city('Ikirun','ng','Osun',134246.0,4.66,7.92).
city('Ila','ng','Osun',179204.0,4.9,8.02).
city('Ilesha','ng','Osun',277922.0,3.42,8.92).
city('Ilobu','ng','Osun',118097.0,4.48,7.84).
city('Inisa','ng','Osun',164172.0,4.33,7.84).
city('Iwo','ng','Osun',250459.0,4.18,7.63).
city('Modakeke','ng','Osun',119537.0,4.27,7.38).
city('Oke-Mesi','ng','Osun',79564.0,4.92,7.83).
city('Olupona','ng','Osun',95002.0,4.18,7.6).
city('Oshogbo','ng','Osun',499444.0,4.58,7.83).
city('Oyan','ng','Osun',73623.0,4.77,8.05).
city('Eruwa','ng','Oyo',71027.0,3.45,7.55).
city('Fiditi','ng','Oyo',71460.0,3.91,7.7).
city('Ibadan','ng','Oyo',3565810.0,3.93,7.38).
city('Igbo Ora','ng','Oyo',92725.0,3.29,7.43).
city('Igboho','ng','Oyo',136772.0,3.75,8.83).
city('Iseyin','ng','Oyo',340707.0,3.67,7.98).
city('Kishi','ng','Oyo',155520.0,3.85,9.09).
city('Lalupon','ng','Oyo',81130.0,4.06,7.47).
city('Ogbomosho','ng','Oyo',861303.0,4.18,8.08).
city('Oyo','ng','Oyo',736113.0,3.92,7.83).
city('Shaki','ng','Oyo',178688.0,3.4,8.66).
city('Jos','ng','Plateau',816876.0,8.89,9.93).
city('Abonnema','ng','Rivers',68591.0,6.79,4.69).
city('Bugama','ng','Rivers',135417.0,6.87,4.73).
city('Okrika','ng','Rivers',133284.0,7.08,4.74).
city('Opobo','ng','Rivers',125398.0,7.56,4.64).
city('Port Harcourt','ng','Rivers',1148753.0,7.0,4.78).
city('Sokoto','ng','Sokoto',563899.0,5.24,13.07).
city('Jalingo','ng','Taraba',117766.0,11.37,8.89).
city('Wukari','ng','Taraba',92940.0,9.77,7.88).
city('Damaturu','ng','Yobe',255913.0,11.96,11.75).
city('Gashua','ng','Yobe',125827.0,11.04,12.88).
city('Nguru','ng','Yobe',111022.0,10.45,12.88).
city('Potiskum','ng','Yobe',86003.0,11.07,11.71).
city('Gusau','ng','Zamfara',226873.0,6.66,12.17).
city('Kaura Namoda','ng','Zamfara',69731.0,6.58,12.59).
city('Kanggye','kp','Chagangdo',264489.0,126.59,40.97).
city('Chongjin','kp','Hamgyongbukto',689583.0,129.78,41.78).
city('Kimchaek','kp','Hamgyongbukto',237587.0,129.2,40.68).
city('Najin','kp','Hamgyongbukto',66365.0,130.3,42.25).
city('Hamhung','kp','Hamgyongnamdo',840231.0,127.54,39.92).
city('Sariwon','kp','Hwanghaebukto',300877.0,125.76,38.51).
city('Songnim','kp','Hwanghaebukto',166182.0,125.63,38.74).
city('Haeju','kp','Hwanghaenamdo',271311.0,125.71,38.04).
city('Kaesong','kp','Kaesong',202977.0,126.56,37.97).
city('Wonsan','kp','Kangwon',355337.0,127.43,39.16).
city('Nampo','kp','Nampo',670327.0,125.44,38.76).
city('Sinuiju','kp','Pyonganbukto',385956.0,124.41,40.1).
city('Phyongsong','kp','Pyongannamdo',323119.0,125.86,39.24).
city('Pyongyang','kp','Pyongyang',2787902.0,125.75,39.02).
city('Hyesan','kp','Yanggang',210753.0,128.16,41.4).
city('Settlement','mp','Northern Islands',8.0,145.19,20.02).
city('Songsong','mp','Rota',13.0,145.14,14.14).
city('Capital Hill','mp','Saipan',1543.0,145.75,15.2).
city('Chalan Kanoa','mp','Saipan',3210.0,145.7,15.15).
city('Dandan','mp','Saipan',4256.0,145.74,15.13).
city('Garapan','mp','Saipan',4218.0,145.73,15.21).
city('Gualo Rai','mp','Saipan',2551.0,145.72,15.19).
city('Koblerville','mp','Saipan',3716.0,145.71,15.12).
city('San Antonio','mp','Saipan',5633.0,145.69,15.13).
city('San Jose','mp','Saipan',938.0,145.71,15.17).
city('San Roque','mp','Saipan',1091.0,145.77,15.25).
city('San Vicente','mp','Saipan',4647.0,145.73,15.15).
city('Susupe','mp','Saipan',2373.0,145.7,15.14).
city('Tanapag','mp','Saipan',4392.0,145.75,15.21).
city('San Jose','mp','Tinian',1893.0,145.62,14.97).
city('Algarheim','no','Akershus',370.0,11.28,60.15).
city('Aneby','no','Akershus',1354.0,10.87,60.08).
city('Arnes','no','Akershus',3113.0,11.47,60.13).
city('As','no','Akershus',7891.0,10.78,59.67).
city('Asgrenda','no','Akershus',619.0,11.0,60.1).
city('Ask','no','Akershus',1084.0,11.05,60.06).
city('Aursmoen','no','Akershus',2258.0,11.43,59.92).
city('Bjorkelangen','no','Akershus',2360.0,11.57,59.88).
city('Borgen','no','Akershus',583.0,11.22,60.08).
city('Drobak','no','Akershus',11261.0,10.65,59.67).
city('Eidsvoll','no','Akershus',3432.0,11.27,60.34).
city('Fagerstrand','no','Akershus',2018.0,10.59,59.73).
city('Fetsund','no','Akershus',6480.0,11.17,59.93).
city('Fjellfoten','no','Akershus',1059.0,11.46,60.08).
city('Fjellsrud','no','Akershus',427.0,11.22,59.88).
city('Fjellstrand','no','Akershus',825.0,10.61,59.8).
city('Flateby','no','Akershus',3186.0,11.17,59.83).
city('Fosser','no','Akershus',569.0,11.48,59.82).
city('Frogner','no','Akershus',1142.0,11.1,60.02).
city('Gronlund','no','Akershus',2156.0,11.1,60.08).
city('Gronvoll','no','Akershus',1518.0,10.94,60.12).
city('Hemnes','no','Akershus',611.0,11.47,59.72).
city('Holen','no','Akershus',388.0,10.74,59.54).
city('Jessheim','no','Akershus',12245.0,11.18,60.15).
city('Klofta','no','Akershus',6036.0,11.15,60.07).
city('Langset','no','Akershus',325.0,11.25,60.4).
city('Lindeberg','no','Akershus',550.0,11.13,60.03).
city('Loken','no','Akershus',941.0,11.48,59.8).
city('Lorenfallet','no','Akershus',944.0,11.22,60.02).
city('Lostad','no','Akershus',1554.0,10.93,60.11).
city('Maura','no','Akershus',2460.0,11.04,60.26).
city('Minnesund','no','Akershus',485.0,11.23,60.38).
city('Neskollen','no','Akershus',1102.0,10.97,59.9).
city('Nesoddtangen','no','Akershus',10940.0,10.67,59.86).
city('Nordkisa','no','Akershus',900.0,11.27,60.18).
city('Oslo','no','Akershus',808690.0,10.75,59.91).
city('Rotnes','no','Akershus',4766.0,10.88,60.05).
city('Sessvollmoen','no','Akershus',656.0,11.17,60.25).
city('Siggerud','no','Akershus',1349.0,10.88,59.81).
city('Smestad','no','Akershus',582.0,10.43,59.93).
city('Son-Store Brevik','no','Akershus',4776.0,10.7,59.52).
city('Sorumsand','no','Akershus',3698.0,11.26,59.99).
city('Teigebyen','no','Akershus',2229.0,11.0,60.23).
city('Togrenda','no','Akershus',2604.0,10.75,59.74).
city('Torvik','no','Akershus',353.0,12.55,66.2).
city('Vestby','no','Akershus',5443.0,10.74,59.6).
city('Vormsund','no','Akershus',485.0,11.43,60.15).
city('Ytre Enebakk','no','Akershus',2732.0,11.06,59.73).
city('Amli','no','Aust-Agder',561.0,8.5,58.78).
city('Birkeland','no','Aust-Agder',2209.0,8.23,58.33).
city('Blakstad','no','Aust-Agder',1944.0,10.47,59.82).
city('Byglandsfjord','no','Aust-Agder',328.0,7.8,58.68).
city('Bykle','no','Aust-Agder',226.0,7.33,59.35).
city('Eikeland','no','Aust-Agder',406.0,9.1,58.8).
city('Fevik','no','Aust-Agder',5070.0,8.7,58.38).
city('Gjerstad','no','Aust-Agder',353.0,9.0,58.87).
city('Grimstad','no','Aust-Agder',9581.0,8.6,58.35).
city('Hovden','no','Aust-Agder',293.0,7.35,59.53).
city('Jortveit','no','Aust-Agder',651.0,8.52,58.27).
city('Lillesand','no','Aust-Agder',5992.0,8.39,58.25).
city('Myra','no','Aust-Agder',549.0,8.87,58.75).
city('Risor','no','Aust-Agder',4450.0,9.22,58.73).
city('Tvedestrand','no','Aust-Agder',1975.0,8.93,58.62).
city('Al','no','Buskerud',2291.0,8.56,60.64).
city('Amot-Geithus','no','Buskerud',5798.0,9.9,59.9).
city('Aros','no','Buskerud',1123.0,10.49,59.72).
city('Drammen','no','Buskerud',90692.0,10.2,59.75).
city('Geilo','no','Buskerud',2289.0,8.2,60.52).
city('Gol','no','Buskerud',2521.0,8.95,60.7).
city('Hallingby','no','Buskerud',740.0,10.2,60.27).
city('Hemsedal','no','Buskerud',659.0,8.57,60.87).
city('Hillestad','no','Buskerud',344.0,9.67,59.58).
city('Holmsbu','no','Buskerud',345.0,10.43,59.56).
city('Honefoss','no','Buskerud',13826.0,10.23,60.19).
city('Hvittingfoss','no','Buskerud',1026.0,10.02,59.48).
city('Hyggen','no','Buskerud',394.0,10.36,59.72).
city('Kjenner','no','Buskerud',1345.0,10.27,59.79).
city('Kongsberg','no','Buskerud',17849.0,9.63,59.67).
city('Kroderen','no','Buskerud',532.0,9.82,60.15).
city('Lierbyen','no','Buskerud',4217.0,10.25,59.83).
city('Nakkerud','no','Buskerud',353.0,10.05,60.05).
city('Nesbyen','no','Buskerud',2067.0,9.11,60.58).
city('Noresund','no','Buskerud',367.0,9.62,60.17).
city('Ormasen','no','Buskerud',808.0,9.81,59.75).
city('Prestfoss','no','Buskerud',486.0,9.63,60.03).
city('Royken','no','Buskerud',2902.0,10.38,59.75).
city('Saetre','no','Buskerud',3037.0,10.52,59.68).
city('Sokna','no','Buskerud',543.0,9.9,60.23).
city('Steinsasen','no','Buskerud',1287.0,10.27,60.09).
city('Sundvollen','no','Buskerud',734.0,10.33,60.07).
city('Svene','no','Buskerud',317.0,9.58,59.8).
city('Sylling','no','Buskerud',537.0,10.28,59.9).
city('Tofte','no','Buskerud',3191.0,10.61,59.57).
city('Torpo','no','Buskerud',389.0,8.72,60.67).
city('Tranby','no','Buskerud',5501.0,10.28,59.79).
city('Tyristrand','no','Buskerud',794.0,10.1,60.1).
city('Vang','no','Buskerud',1804.0,10.33,60.21).
city('Veggli','no','Buskerud',307.0,9.15,60.05).
city('Vestfossen','no','Buskerud',2707.0,9.87,58.75).
city('Vikersund','no','Buskerud',2496.0,10.01,59.99).
city('Alta','no','Finnmark',12101.0,23.27,69.98).
city('Batsfjord','no','Finnmark',2216.0,29.73,70.63).
city('Berlevag','no','Finnmark',1087.0,29.1,70.85).
city('Bjornevatn','no','Finnmark',2343.0,29.98,69.67).
city('Hammerfest','no','Finnmark',6730.0,23.71,70.68).
city('Hasvik','no','Finnmark',392.0,22.15,70.48).
city('Havoysund','no','Finnmark',1149.0,24.7,71.0).
city('Hesseng','no','Finnmark',1537.0,29.99,69.68).
city('Honningsvag','no','Finnmark',2561.0,25.98,70.98).
city('Kautokeino','no','Finnmark',1349.0,23.13,68.98).
city('Kiberg','no','Finnmark',262.0,31.0,70.28).
city('Kirkenes','no','Finnmark',3314.0,30.03,69.73).
city('Kjollefjord','no','Finnmark',1014.0,27.35,70.93).
city('Lakselv','no','Finnmark',2167.0,24.93,70.05).
city('Mehamn','no','Finnmark',733.0,27.85,71.03).
city('Nordvagen','no','Finnmark',445.0,26.03,70.98).
city('Oksfjord','no','Finnmark',527.0,22.37,70.24).
city('Rafsbotn','no','Finnmark',364.0,23.53,70.02).
city('Rypefjord','no','Finnmark',1741.0,23.67,70.63).
city('Sorvaer','no','Finnmark',198.0,21.98,70.63).
city('Vadso','no','Finnmark',5190.0,29.74,70.09).
city('Vardo','no','Finnmark',2023.0,31.06,70.39).
city('Adalsbruk','no','Hedmark',541.0,11.3,60.78).
city('Alvdal','no','Hedmark',697.0,10.65,62.12).
city('Braskereidfoss','no','Hedmark',267.0,11.78,60.72).
city('Brumunddal','no','Hedmark',8385.0,10.93,60.89).
city('Disena','no','Hedmark',280.0,11.65,60.2).
city('Elverum','no','Hedmark',12585.0,11.54,60.89).
city('Flisa','no','Hedmark',1543.0,12.0,60.62).
city('Folldal','no','Hedmark',564.0,10.05,62.13).
city('Grinder','no','Hedmark',231.0,12.05,60.38).
city('Heradsbygd','no','Hedmark',466.0,11.63,60.82).
city('Innbygda','no','Hedmark',2275.0,12.27,61.32).
city('Kirkenaer','no','Hedmark',1220.0,12.05,60.47).
city('Kjellmyra','no','Hedmark',414.0,12.03,60.65).
city('Kongsvinger','no','Hedmark',11147.0,11.99,60.2).
city('Koppang','no','Hedmark',1166.0,11.07,61.57).
city('Kylstad','no','Hedmark',294.0,11.05,60.87).
city('Loiten Braenderi','no','Hedmark',678.0,11.32,60.82).
city('Loten','no','Hedmark',2480.0,11.33,60.81).
city('Magnor','no','Hedmark',1006.0,12.22,59.96).
city('Mo','no','Hedmark',409.0,12.03,60.42).
city('Moelv','no','Hedmark',4113.0,10.7,60.93).
city('Nybergsund','no','Hedmark',329.0,12.32,61.25).
city('Os','no','Hedmark',662.0,11.2,62.5).
city('Otnes','no','Hedmark',311.0,5.48,62.03).
city('Rena','no','Hedmark',2051.0,11.33,61.15).
city('Roverud','no','Hedmark',882.0,12.05,60.25).
city('Sand','no','Hedmark',977.0,11.55,60.38).
city('Sander','no','Hedmark',319.0,11.82,60.22).
city('Skarnes','no','Hedmark',2129.0,11.7,60.25).
city('Skotterud','no','Hedmark',1357.0,12.13,59.98).
city('Stange','no','Hedmark',2494.0,11.22,60.73).
city('Tangen','no','Hedmark',475.0,11.27,60.62).
city('Tolga','no','Hedmark',651.0,11.0,62.42).
city('Tynset','no','Hedmark',2368.0,10.77,62.28).
city('Valer','no','Hedmark',1167.0,11.83,60.67).
city('Agotnes','no','Hordaland',1431.0,5.02,60.41).
city('Alvik','no','Hordaland',584.0,6.43,60.43).
city('Aras','no','Hordaland',602.0,4.93,60.78).
city('Askoy','no','Hordaland',17352.0,5.18,60.4).
city('Austmarka','no','Hordaland',387.0,5.15,60.62).
city('Bekkjarvik','no','Hordaland',371.0,5.2,60.0).
city('Bergen','no','Hordaland',214154.0,5.34,60.38).
city('Dale','no','Hordaland',1242.0,5.82,60.6).
city('Dimmelsvik','no','Hordaland',223.0,5.98,59.95).
city('Eidfjord','no','Hordaland',575.0,7.08,60.47).
city('Eikelandsosen','no','Hordaland',422.0,5.75,60.24).
city('Espeland','no','Hordaland',1782.0,5.47,60.38).
city('Etne','no','Hordaland',973.0,5.93,59.67).
city('Fanahammeren','no','Hordaland',3584.0,5.34,60.26).
city('Fedje','no','Hordaland',480.0,4.71,60.78).
city('Fitjar','no','Hordaland',1321.0,5.32,59.92).
city('Flesland','no','Hordaland',303.0,5.22,60.29).
city('Foldroy','no','Hordaland',369.0,5.3,59.8).
city('Forde','no','Hordaland',375.0,5.47,59.61).
city('Fotlandsvag','no','Hordaland',248.0,5.5,60.6).
city('Frekhaug','no','Hordaland',1633.0,5.25,60.52).
city('Granvin','no','Hordaland',469.0,6.72,60.55).
city('Haga','no','Hordaland',910.0,5.77,60.39).
city('Hagavik','no','Hordaland',1375.0,5.43,60.18).
city('Hammarsland','no','Hordaland',409.0,5.26,60.31).
city('Haugland','no','Hordaland',438.0,5.73,60.48).
city('Heroysund','no','Hordaland',391.0,5.79,59.92).
city('Holme','no','Hordaland',643.0,5.16,59.65).
city('Husnes','no','Hordaland',2173.0,5.77,59.87).
city('Hylkje','no','Hordaland',1801.0,5.35,60.51).
city('Indre Arna','no','Hordaland',6202.0,5.48,60.42).
city('Karasjok','no','Hordaland',1928.0,25.5,69.45).
city('Klokkarvik','no','Hordaland',658.0,5.16,60.22).
city('Knappskog','no','Hordaland',1091.0,5.06,60.38).
city('Knarrevik-Straume','no','Hordaland',9160.0,5.16,60.37).
city('Knarvik','no','Hordaland',4288.0,5.29,60.54).
city('Krokeidet','no','Hordaland',415.0,5.3,60.23).
city('Langevag','no','Hordaland',726.0,5.22,59.6).
city('Leirvik','no','Hordaland',10991.0,5.49,59.8).
city('Li','no','Hordaland',342.0,5.13,60.31).
city('Lindas','no','Hordaland',1070.0,5.17,60.73).
city('Lofthus','no','Hordaland',564.0,6.67,60.33).
city('Lonevag','no','Hordaland',523.0,5.5,60.53).
city('Manger','no','Hordaland',820.0,5.04,60.64).
city('Misje','no','Hordaland',227.0,4.97,60.45).
city('Mosterhamn','no','Hordaland',1156.0,5.38,59.7).
city('Nordvik','no','Hordaland',364.0,5.73,60.42).
city('Norheimsund','no','Hordaland',2121.0,6.14,60.37).
city('Odda','no','Hordaland',5515.0,6.54,60.07).
city('Osoyro','no','Hordaland',8014.0,5.45,60.19).
city('Oystese','no','Hordaland',1636.0,6.21,60.4).
city('Rosendal','no','Hordaland',965.0,6.02,59.98).
city('Rubbestadneset','no','Hordaland',1132.0,5.29,59.8).
city('Saebovik','no','Hordaland',832.0,5.71,59.8).
city('Sagvag','no','Hordaland',3308.0,5.38,59.78).
city('Skanevik','no','Hordaland',615.0,5.98,59.73).
city('Skulestadmoen','no','Hordaland',1529.0,6.45,60.69).
city('Softeland','no','Hordaland',1197.0,5.43,60.25).
city('Solsvik','no','Hordaland',531.0,4.97,60.44).
city('Sovik','no','Hordaland',728.0,5.39,60.22).
city('Stanghelle','no','Hordaland',772.0,5.73,60.55).
city('Storebo','no','Hordaland',1090.0,5.23,60.1).
city('Sunde-Valen','no','Hordaland',1817.0,5.71,59.85).
city('Sveio','no','Hordaland',957.0,5.33,59.55).
city('Svortland','no','Hordaland',2046.0,5.12,59.77).
city('Taelavag','no','Hordaland',493.0,4.99,60.26).
city('Tyssedal','no','Hordaland',715.0,6.57,60.12).
city('Ulvik','no','Hordaland',693.0,6.9,60.57).
city('Uskedal','no','Hordaland',698.0,5.86,59.93).
city('Vage','no','Hordaland',515.0,5.52,60.05).
city('Vaksdal','no','Hordaland',870.0,5.75,60.48).
city('Valestrandfossen','no','Hordaland',944.0,5.43,60.5).
city('Valvatna','no','Hordaland',607.0,5.42,59.77).
city('Vossevangen','no','Hordaland',5551.0,6.43,60.64).
city('Ytre Arna','no','Hordaland',2526.0,5.43,60.47).
city('Alnes','no','More og Romsdal',203.0,5.97,62.48).
city('Andalsnes','no','More og Romsdal',2024.0,7.72,52.57).
city('Arset','no','More og Romsdal',467.0,7.58,62.7).
city('Aukra','no','More og Romsdal',712.0,6.9,62.78).
city('Aure','no','More og Romsdal',619.0,8.53,63.27).
city('Austnes','no','More og Romsdal',397.0,6.27,62.63).
city('Batnfjordsora','no','More og Romsdal',339.0,7.7,62.88).
city('Brandal','no','More og Romsdal',308.0,6.0,62.4).
city('Brattvag','no','More og Romsdal',2192.0,6.45,62.6).
city('Bremsnes','no','More og Romsdal',417.0,7.67,63.1).
city('Bud','no','More og Romsdal',779.0,6.92,62.92).
city('Eide','no','More og Romsdal',1134.0,7.44,69.92).
city('Eidsvag','no','More og Romsdal',886.0,8.07,62.78).
city('Elnesvagen','no','More og Romsdal',2107.0,7.15,62.86).
city('Giske','no','More og Romsdal',572.0,6.87,62.48).
city('Groa','no','More og Romsdal',500.0,8.72,62.65).
city('Haddal','no','More og Romsdal',314.0,5.88,62.28).
city('Hareid','no','More og Romsdal',3617.0,6.03,62.37).
city('Hjelset','no','More og Romsdal',1008.0,7.48,62.78).
city('Ikornnes','no','More og Romsdal',817.0,6.57,62.38).
city('Isfjorden','no','More og Romsdal',1243.0,7.79,62.58).
city('Kleive','no','More og Romsdal',516.0,7.67,62.82).
city('Kristiansund','no','More og Romsdal',16904.0,7.76,63.12).
city('Kvalsvik','no','More og Romsdal',261.0,5.57,62.37).
city('Kvalvag','no','More og Romsdal',258.0,7.88,63.07).
city('Larsnes','no','More og Romsdal',519.0,5.6,62.22).
city('Midsund','no','More og Romsdal',438.0,6.68,62.68).
city('Molde','no','More og Romsdal',18603.0,7.18,62.74).
city('Myklebost','no','More og Romsdal',371.0,6.38,62.61).
city('Nerland','no','More og Romsdal',219.0,8.0,62.7).
city('Nesjestranda','no','More og Romsdal',331.0,7.45,62.7).
city('Nordstrand','no','More og Romsdal',3091.0,6.05,62.51).
city('Orsta','no','More og Romsdal',6425.0,6.14,62.21).
city('Rausand','no','More og Romsdal',305.0,8.12,62.83).
city('Rensvik','no','More og Romsdal',2139.0,7.82,63.1).
city('Rindal','no','More og Romsdal',658.0,9.22,63.05).
city('Roald','no','More og Romsdal',678.0,6.13,62.58).
city('Sjoholt','no','More og Romsdal',1123.0,6.81,62.49).
city('Skei-Surnadalsora','no','More og Romsdal',2377.0,8.65,62.97).
city('Skodje','no','More og Romsdal',1599.0,6.67,62.51).
city('Sovik','no','More og Romsdal',599.0,6.3,62.55).
city('Steinshamn','no','More og Romsdal',473.0,6.48,62.78).
city('Stranda','no','More og Romsdal',2537.0,6.93,62.32).
city('Sunndalsora','no','More og Romsdal',4223.0,8.58,62.68).
city('Sykkylven','no','More og Romsdal',3972.0,6.59,62.4).
city('Sylte','no','More og Romsdal',355.0,6.43,62.45).
city('Tingvollvagen','no','More og Romsdal',1004.0,8.22,62.92).
city('Tjorvag','no','More',361.0,5.72,62.28).
city('Tomra','no','More og Romsdal',1152.0,6.95,62.59).
city('Tornes','no','More og Romsdal',431.0,7.03,62.85).
city('Ulsteinvik','no','More og Romsdal',5150.0,5.87,62.34).
city('Vatne','no','More og Romsdal',1585.0,6.62,62.56).
city('Vestnes','no','More og Romsdal',2102.0,7.08,62.62).
city('Volda','no','More og Romsdal',5438.0,6.07,62.15).
city('Voll','no','More og Romsdal',461.0,6.85,62.47).
city('Asen','no','Nord-Trondelag',447.0,11.05,63.6).
city('Bangsund','no','Nord-Trondelag',885.0,11.4,64.4).
city('Follafoss','no','Nord-Trondelag',484.0,11.1,63.98).
city('Grong','no','Nord-Trondelag',1073.0,12.33,64.45).
city('Hegra','no','Nord-Trondelag',637.0,11.12,63.47).
city('Hell','no','Nord-Trondelag',1003.0,10.9,63.43).
city('Hylla','no','Nord-Trondelag',353.0,11.38,63.83).
city('Kolvereid','no','Nord-Trondelag',1499.0,11.6,64.85).
city('Koppera','no','Nord-Trondelag',210.0,11.85,63.4).
city('Kvithammer','no','Nord-Trondelag',235.0,10.88,63.48).
city('Lauvsnes','no','Nord-Trondelag',441.0,10.92,64.5).
city('Leksvik','no','Nord-Trondelag',1102.0,10.5,63.67).
city('Levanger','no','Nord-Trondelag',8304.0,11.32,63.75).
city('Malm','no','Nord-Trondelag',1234.0,11.21,64.08).
city('Midtbygda','no','Nord-Trondelag',948.0,11.75,63.43).
city('Namsos','no','Nord-Trondelag',8946.0,11.52,64.48).
city('Ranemsletta','no','Nord-Trondelag',299.0,11.95,64.5).
city('Rora','no','Nord-Trondelag',493.0,11.4,63.87).
city('Rorvik','no','Nord-Trondelag',2621.0,11.24,64.87).
city('Royrvik','no','Nord-Trondelag',247.0,13.55,64.88).
city('Skage','no','Nord-Trondelag',635.0,11.75,64.47).
city('Skogn','no','Nord-Trondelag',1916.0,11.23,63.71).
city('Smaland','no','Nord-Trondelag',349.0,10.72,63.6).
city('Snasa','no','Nord-Trondelag',748.0,12.37,64.25).
city('Sparbu','no','Nord-Trondelag',619.0,11.43,63.92).
city('Steinkjer','no','Nord-Trondelag',11198.0,11.48,64.02).
city('Stjordalshalsen','no','Nord-Trondelag',9848.0,10.94,63.48).
city('Straumen','no','Nord-Trondelag',1173.0,11.29,63.88).
city('Trones','no','Nord-Trondelag',415.0,12.83,64.73).
city('Velde','no','Nord-Trondelag',441.0,11.4,64.12).
city('Verdalsora','no','Nord-Trondelag',7225.0,11.49,63.8).
city('Alsvag','no','Nordland',335.0,15.28,68.9).
city('Andenes','no','Nordland',2789.0,16.11,69.32).
city('Ballangen','no','Nordland',1001.0,16.82,68.34).
city('Ballstad','no','Nordland',763.0,13.55,68.07).
city('Beisfjord','no','Nordland',626.0,17.59,68.37).
city('Berg','no','Nordland',469.0,12.2,65.37).
city('Bjerka','no','Nordland',449.0,13.88,66.15).
city('Bjerkvik','no','Nordland',1207.0,17.52,68.56).
city('Bleik','no','Nordland',481.0,16.0,69.28).
city('Bo','no','Nordland',718.0,16.9,68.37).
city('Bodo','no','Nordland',33811.0,14.37,67.29).
city('Bogen','no','Nordland',388.0,17.0,68.53).
city('Bronnoysund','no','Nordland',4352.0,12.22,65.47).
city('Evje','no','Nordland',2154.0,13.73,68.27).
city('Fauske','no','Nordland',5974.0,15.4,67.25).
city('Fjelldal','no','Nordland',327.0,16.55,68.55).
city('Fosnavag-Leinstrand','no','Nordland',3482.0,5.65,62.35).
city('Gladstad','no','Nordland',302.0,11.97,65.68).
city('Glomfjord','no','Nordland',1196.0,13.97,66.82).
city('Gravdal','no','Nordland',1628.0,13.5,68.12).
city('Hakvik','no','Nordland',545.0,17.32,68.4).
city('Hauknes','no','Nordland',1860.0,14.07,66.28).
city('Hemnesberget','no','Nordland',1240.0,13.63,66.23).
city('Henningsvaer','no','Nordland',407.0,14.22,68.15).
city('Husoy','no','Nordland',340.0,15.47,67.99).
city('Inndyr','no','Nordland',662.0,14.03,67.03).
city('Kabelvag','no','Nordland',1654.0,14.48,68.21).
city('Kjopsvik','no','Nordland',964.0,16.35,68.1).
city('Korgen','no','Nordland',877.0,13.83,66.08).
city('Leknes','no','Nordland',2665.0,13.6,68.16).
city('Leland','no','Nordland',563.0,12.95,66.07).
city('Liland','no','Nordland',304.0,16.88,68.48).
city('Loding','no','Nordland',2880.0,14.75,67.3).
city('Lodingen','no','Nordland',1845.0,15.96,68.42).
city('Lopsmarka','no','Nordland',2302.0,14.45,67.32).
city('Lovund','no','Nordland',356.0,12.38,66.37).
city('Melbu','no','Nordland',2143.0,14.8,68.51).
city('Misvaer','no','Nordland',242.0,15.0,67.12).
city('Mo i Rana','no','Nordland',17926.0,14.17,66.33).
city('Mosjoen','no','Nordland',9620.0,13.22,65.84).
city('Myre','no','Nordland',2004.0,15.96,69.11).
city('Narvik','no','Nordland',14178.0,17.42,68.45).
city('Nesna','no','Nordland',1194.0,13.03,66.21).
city('Ornes','no','Nordland',1549.0,13.7,66.87).
city('Ramsund','no','Nordland',306.0,16.53,68.48).
city('Reine','no','Nordland',356.0,13.1,67.93).
city('Reipa','no','Nordland',307.0,13.65,66.9).
city('Risoyhamn','no','Nordland',208.0,15.63,68.97).
city('Rognan','no','Nordland',2492.0,15.39,67.1).
city('Rokland','no','Nordland',498.0,15.32,66.98).
city('Rosvik','no','Nordland',216.0,15.47,67.48).
city('Sandnes','no','Nordland',383.0,14.88,68.58).
city('Sandnessjoen','no','Nordland',5708.0,12.63,66.02).
city('Sigerfjord','no','Nordland',771.0,15.54,68.65).
city('Sorarnoy','no','Nordland',204.0,13.97,67.13).
city('Sorland','no','Nordland',589.0,12.7,67.67).
city('Sortland','no','Nordland',4609.0,15.38,68.71).
city('Sorvagen','no','Nordland',477.0,13.03,67.88).
city('Stamsund','no','Nordland',1010.0,13.85,68.14).
city('Stokmarknes','no','Nordland',3135.0,14.91,68.56).
city('Storforshei','no','Nordland',687.0,14.52,66.4).
city('Strand','no','Nordland',562.0,15.45,68.7).
city('Straume','no','Nordland',282.0,14.47,68.68).
city('Straumen','no','Nordland',815.0,15.6,67.35).
city('Stromsnes','no','Nordland',497.0,15.93,67.97).
city('Sulitjelma','no','Nordland',488.0,16.05,67.15).
city('Svolvaer','no','Nordland',4188.0,14.55,68.26).
city('Terrak','no','Nordland',611.0,12.42,65.08).
city('Tjotta','no','Nordland',232.0,12.4,65.83).
city('Trofors','no','Nordland',797.0,13.42,65.57).
city('Vik','no','Nordland',381.0,12.15,65.3).
city('Aurdal','no','Oppland',703.0,9.4,60.93).
city('Bagn','no','Oppland',606.0,9.57,60.82).
city('Biri','no','Oppland',1275.0,10.5,60.97).
city('Bismo','no','Oppland',584.0,8.27,61.88).
city('Brandbu-Jaren','no','Oppland',4379.0,10.47,60.43).
city('Dale','no','Oppland',784.0,9.5,61.78).
city('Dokka','no','Oppland',2868.0,10.08,60.83).
city('Dombas','no','Oppland',1195.0,9.13,62.08).
city('Dovre','no','Oppland',459.0,9.25,61.98).
city('Eina','no','Oppland',652.0,10.6,60.63).
city('Fagernes','no','Oppland',1813.0,9.25,60.99).
city('Follebu','no','Oppland',926.0,10.28,61.23).
city('Forset','no','Oppland',653.0,10.15,61.2).
city('Fo','no','Oppland',816.0,8.57,61.83).
city('Gjovik','no','Oppland',17733.0,10.65,60.79).
city('Gran-Ringstad','no','Oppland',1388.0,10.57,60.37).
city('Granrudmoen','no','Oppland',1698.0,10.44,61.28).
city('Grua','no','Oppland',1491.0,10.67,60.27).
city('Harestua','no','Oppland',1814.0,10.72,60.1).
city('Harpefoss','no','Oppland',453.0,9.85,61.58).
city('Hov','no','Oppland',2150.0,10.36,60.71).
city('Hundorp','no','Oppland',601.0,9.9,61.55).
city('Jevnaker','no','Oppland',4347.0,10.4,60.26).
city('Jorstadmoen-Faberg','no','Oppland',1341.0,10.42,61.17).
city('Kapp','no','Oppland',1896.0,10.86,60.71).
city('Kvam','no','Oppland',863.0,9.7,61.67).
city('Lalm','no','Oppland',294.0,9.27,61.82).
city('Leira','no','Oppland',792.0,9.3,60.97).
city('Lena','no','Oppland',1122.0,10.8,60.67).
city('Lia','no','Oppland',258.0,9.65,61.65).
city('Lillehammer','no','Oppland',19223.0,10.47,61.12).
city('Otta','no','Oppland',1623.0,9.52,61.78).
city('Raufoss','no','Oppland',6071.0,10.63,60.73).
city('Reinsvoll','no','Oppland',1157.0,10.62,60.68).
city('Ringebu','no','Oppland',1332.0,10.11,61.55).
city('Roa-Lunner','no','Oppland',1619.0,10.62,60.3).
city('Segalstad','no','Oppland',899.0,10.23,61.23).
city('Skreia','no','Oppland',1304.0,10.94,60.65).
city('Tretten','no','Oppland',872.0,10.32,61.32).
city('Vagamo','no','Oppland',1483.0,9.11,61.88).
city('Vinstra','no','Oppland',2467.0,9.75,61.6).
city('Alshus','no','Ostfold',1051.0,10.96,59.13).
city('Askim','no','Ostfold',12488.0,11.16,59.58).
city('Fosby','no','Ostfold',324.0,11.7,59.22).
city('Fuglevik','no','Ostfold',470.0,10.66,59.39).
city('Halden','no','Ostfold',22029.0,11.37,59.13).
city('Hamnas','no','Ostfold',207.0,11.42,59.62).
city('Hauge','no','Ostfold',322.0,10.88,59.1).
city('Heias','no','Ostfold',661.0,11.3,59.7).
city('Ise','no','Ostfold',717.0,11.23,59.3).
city('Karlshus','no','Ostfold',1780.0,10.87,59.35).
city('Larkollen','no','Ostfold',1380.0,10.67,59.33).
city('Lervik','no','Ostfold',2284.0,10.76,59.27).
city('Mysen','no','Ostfold',5502.0,11.33,59.56).
city('Orje','no','Ostfold',1744.0,11.67,59.48).
city('Rakkestad','no','Ostfold',3813.0,11.36,59.42).
city('Rod','no','Ostfold',345.0,10.95,59.07).
city('Skiptvet','no','Ostfold',1473.0,11.18,59.46).
city('Skjaerhollen','no','Ostfold',631.0,11.03,59.03).
city('Skjeberg','no','Ostfold',1876.0,11.2,59.22).
city('Skjonhaug','no','Ostfold',1817.0,11.31,59.64).
city('Slevik','no','Ostfold',983.0,10.83,59.2).
city('Sponvika','no','Ostfold',421.0,11.23,59.1).
city('Spydeberg','no','Ostfold',3161.0,11.09,59.62).
city('Tomter','no','Ostfold',1305.0,11.01,59.67).
city('Utgard','no','Ostfold',315.0,10.87,59.08).
city('Vak','no','Ostfold',1011.0,10.85,59.47).
city('Akrehamn-Vedavagen','no','Rogaland',9358.0,5.2,59.26).
city('Aksdal','no','Rogaland',1052.0,5.5,59.33).
city('Brusand','no','Rogaland',399.0,5.77,58.53).
city('Egersund','no','Rogal',9547.0,6.01,58.46).
city('Fordesfjorden','no','Rogaland',2994.0,5.4,59.42).
city('Gilja','no','Rogaland',254.0,6.27,58.8).
city('Hauge','no','Rogaland',2146.0,6.28,58.35).
city('Hellvik','no','Rogaland',649.0,5.9,58.48).
city('Hole','no','Rogaland',301.0,6.0,58.88).
city('Hommersak','no','Rogaland',5796.0,5.85,58.93).
city('Jorpeland','no','Rogaland',5539.0,6.05,59.02).
city('Judaberg','no','Rogaland',555.0,5.85,59.18).
city('Kleppe-Verdalen','no','Rogaland',6363.0,5.64,58.78).
city('Kopervik','no','Rogaland',6465.0,5.31,59.29).
city('Kvernaland','no','Rogaland',5503.0,5.73,58.79).
city('Lyefjell','no','Rogaland',2175.0,5.75,58.75).
city('Moi','no','Rogaland',1705.0,6.54,58.46).
city('Naerbo','no','Rogaland',4952.0,5.65,58.67).
city('Nedstrand','no','Rogaland',233.0,5.85,59.35).
city('Ogna','no','Rogaland',324.0,5.8,58.52).
city('Olen','no','Rogaland',905.0,5.81,59.6).
city('Oltedal','no','Rogaland',719.0,6.03,58.83).
city('Osthusvik','no','Rogaland',298.0,5.78,59.1).
city('Pollestad','no','Rogaland',467.0,5.58,58.72).
city('Sand','no','Rogaland',1132.0,6.27,59.48).
city('Sandeid','no','Rogaland',570.0,5.83,59.55).
city('Sandve','no','Rogaland',323.0,5.2,59.18).
city('Sauda','no','Rogaland',4313.0,6.34,59.65).
city('Sirevag','no','Rogaland',398.0,5.78,58.5).
city('Skjold','no','Rogaland',612.0,5.58,59.52).
city('Skudeneshamn','no','Rogaland',3191.0,5.25,59.16).
city('Stavanger','no','Rogaland',173535.0,5.71,58.97).
city('Sviland','no','Rogaland',340.0,5.83,58.83).
city('Tananger','no','Rogaland',5823.0,5.6,58.94).
city('Tau','no','Rogaland',2507.0,5.92,59.08).
city('Undheim','no','Rogaland',454.0,5.78,58.68).
city('Varhaug','no','Rogaland',2419.0,5.65,58.63).
city('Vigrestad','no','Rogaland',1768.0,5.68,58.58).
city('Vikedal','no','Rogaland',407.0,5.92,59.5).
city('Vikesa','no','Rogaland',713.0,6.1,58.63).
city('Vikevag','no','Rogaland',531.0,5.7,59.1).
city('Visnes','no','Rogaland',609.0,5.22,59.36).
city('Ardalstangen','no','Sogn og Fjordane',1495.0,7.7,61.24).
city('Askvoll','no','Sogn og Fjordane',616.0,5.08,61.35).
city('Aurlandsvangen','no','Sogn og Fjordane',599.0,7.18,60.91).
city('Austreim','no','Sogn og Fjordane',380.0,5.95,61.17).
city('Balestrand','no','Sogn og Fjordane',799.0,6.53,61.2).
city('Brandsoy','no','Sogn og Fjordane',474.0,5.13,61.62).
city('Bryggja','no','Sogn og Fjordane',386.0,5.38,61.93).
city('Byrkjelo','no','Sogn og Fjordane',314.0,6.5,61.73).
city('Byrknes','no','Sogn og Fjordane',291.0,4.83,60.9).
city('Dale','no','Sogn og Fjordane',961.0,5.41,61.36).
city('Floro','no','Sogn og Fjordane',8169.0,5.03,61.6).
city('Forde','no','Sogn og Fjordane',8517.0,5.87,61.46).
city('Gaupne','no','Sogn og Fjordane',1017.0,7.27,61.4).
city('Grodas','no','Sogn og Fjordane',386.0,6.53,61.97).
city('Hardbakke','no','Sogn og Fjordane',234.0,4.85,61.08).
city('Hermansverk-Leikanger','no','Sogn og Fjordane',1945.0,6.78,61.19).
city('Holevik','no','Sogn og Fjordane',341.0,5.08,61.93).
city('Hoyanger','no','Sogn og Fjordane',2293.0,6.08,61.22).
city('Innvik','no','Sogn og Fjordane',363.0,6.62,61.85).
city('Kalvag','no','Sogn og Fjordane',369.0,4.88,61.77).
city('Kaupanger','no','Sogn og Fjordane',874.0,7.23,61.18).
city('Kyrkjebo','no','Sogn og Fjordane',254.0,5.92,61.17).
city('Laerdalsoyri','no','Sogn og Fjordane',1117.0,7.48,61.1).
city('Maloy','no','Sogn og Fjordane',3070.0,5.11,61.93).
city('Naustdal','no','Sogn og Fjordane',1055.0,5.72,61.52).
city('Nordfjordeid','no','Sogn og Fjordane',2535.0,6.0,61.9).
city('Olden','no','Sogn og Fjordane',545.0,9.93,63.87).
city('Ovre Ardal','no','Sogn og Fjordane',3439.0,7.81,61.32).
city('Raudeberg','no','Sogn og Fjordane',707.0,5.13,61.98).
city('Sandane','no','Sogn og Fjordane',2137.0,6.22,61.78).
city('Sande','no','Sogn og Fjordane',533.0,5.8,61.33).
city('Seimsdalen','no','Sogn og Fjordane',448.0,7.67,61.25).
city('Selje','no','Sogn og Fjordane',714.0,5.35,62.05).
city('Sogndalsfjora','no','Sogn og Fjordane',2978.0,5.44,60.25).
city('Stryn','no','Sogn og Fjordane',2119.0,6.78,61.92).
city('Svelgen','no','Sogn og Fjordane',1204.0,5.31,61.77).
city('Vagsvag','no','Sogn og Fjordane',223.0,5.05,61.94).
city('Vassenden','no','Sogn og Fjordane',246.0,6.12,61.5).
city('Viksoyri','no','Sogn og Fjordane',1101.0,6.58,61.09).
city('A','no','Sor-Trondelag',1145.0,10.21,63.97).
city('Arnset','no','Sor-Trondelag',1024.0,10.11,63.75).
city('Askjem','no','Sor-Trondelag',270.0,10.01,63.51).
city('Berkak','no','Sor-Trondelag',905.0,10.0,62.83).
city('Bjornli','no','Sor-Trondelag',288.0,9.68,63.13).
city('Botngard','no','Sor-Trondelag',1146.0,9.82,63.77).
city('Brekstad','no','Sor-Trondelag',1879.0,9.68,63.68).
city('Buvika-Ilhaugen','no','Sor-Trondelag',1678.0,10.07,63.25).
city('Eggkleiva','no','Sor-Trondelag',235.0,10.05,63.28).
city('Fillan','no','Sor-Trondelag',532.0,8.98,63.6).
city('Gjolme','no','Sor-Trondelag',473.0,9.82,63.32).
city('Hestvika','no','Sor-Trondelag',235.0,9.18,63.57).
city('Hommelvik','no','Sor-Trondelag',4013.0,10.8,63.42).
city('Hovin','no','Sor-Trondelag',592.0,10.25,63.12).
city('Klaebu','no','Sor-Trondelag',2992.0,11.73,64.08).
city('Korsvegen','no','Sor-Trondelag',495.0,10.1,63.17).
city('Kval','no','Sor-Trondelag',463.0,10.3,63.23).
city('Kyrksaeterora','no','Sor-Trondelag',2497.0,9.1,63.28).
city('Ler','no','Sor-Trondelag',459.0,10.33,63.2).
city('Lokken Verk','no','Sor-Trondelag',916.0,9.71,63.13).
city('Lundamo','no','Sor-Trondelag',1102.0,10.3,63.16).
city('Lysoysund','no','Sor-Trondelag',310.0,9.87,63.88).
city('Melhus','no','Sor-Trondelag',4602.0,10.29,63.3).
city('Muruvik','no','Sor-Trondelag',341.0,10.85,63.43).
city('Oppdal','no','Sor-Trondelag',3786.0,9.66,62.6).
city('Opphaug','no','Sor-Trondelag',358.0,9.7,63.73).
city('Orkanger-Fannrem','no','Sor-Trondelag',6484.0,9.86,63.3).
city('Ottersbo','no','Sor-Trondelag',339.0,9.75,63.7).
city('Rakvagen','no','Sor-Trondelag',277.0,10.08,63.77).
city('Roros','no','Sor-Trondelag',3499.0,11.38,62.58).
city('Selbekken','no','Sor-Trondelag',361.0,9.83,63.5).
city('Sistranda','no','Sor-Trondelag',678.0,8.83,63.72).
city('Soknedal','no','Sor-Trondelag',282.0,10.18,62.95).
city('Storas','no','Sor-Trondelag',323.0,9.6,63.1).
city('Storen','no','Sor-Trondelag',1788.0,10.26,63.04).
city('Tanem','no','Sor-Trondelag',970.0,10.45,63.32).
city('Trolla','no','Sor-Trondelag',461.0,10.32,63.45).
city('Trondheim','no','Sor-Trondelag',146930.0,10.4,63.44).
city('Uthaug','no','Sor-Trondelag',415.0,9.6,63.72).
city('Amot','no','Telemark',603.0,8.37,59.63).
city('Bjervamoen','no','Telemark',1416.0,9.13,59.32).
city('Bo','no','Telemark',2478.0,9.06,59.42).
city('Dalen','no','Telemark',810.0,8.0,59.45).
city('Folkestad','no','Telemark',430.0,9.07,59.43).
city('Fyresdal','no','Telemark',354.0,8.1,59.18).
city('Gvarv','no','Telemark',891.0,9.15,59.38).
city('Herre','no','Telemark',1347.0,9.57,59.1).
city('Hjukse','no','Telemark',376.0,9.32,59.52).
city('Kil','no','Telemark',936.0,9.32,58.87).
city('Kragero','no','Telemark',5266.0,9.4,58.87).
city('Kviteseid','no','Telemark',644.0,8.5,59.4).
city('Langangen','no','Telemark',507.0,9.8,59.1).
city('Miland','no','Telemark',400.0,8.75,59.92).
city('Notodden','no','Telemark',8306.0,9.26,59.57).
city('Preststranda','no','Telemark',1236.0,9.06,59.1).
city('Rjukan','no','Telemark',3576.0,8.56,59.88).
city('Seljord','no','Telemark',1187.0,8.63,59.48).
city('Siljan','no','Telemark',966.0,9.7,59.3).
city('Tveitsund','no','Telemark',347.0,8.53,59.02).
city('Ulefoss','no','Telemark',2746.0,9.26,59.28).
city('Vadfoss-Helle','no','Telemark',1544.0,9.36,58.9).
city('Yli','no','Telemark',316.0,9.18,59.57).
city('Andselv','no','Troms',700.0,18.57,69.07).
city('Andslimoen','no','Troms',569.0,18.59,69.09).
city('Borkenes','no','Troms',1458.0,16.18,68.78).
city('Ersfjordbotn','no','Troms',301.0,18.62,69.69).
city('Evenskjaer','no','Troms',641.0,16.57,68.58).
city('Finnsnes','no','Troms',3942.0,17.98,69.23).
city('Furuflaten','no','Troms',227.0,20.15,69.45).
city('Gibostad','no','Troms',384.0,18.07,69.35).
city('Grov','no','Troms',282.0,17.13,68.68).
city('Gryllefjord','no','Troms',459.0,17.02,69.37).
city('Hansnes','no','Troms',330.0,19.6,69.97).
city('Harstad','no','Troms',19574.0,16.52,68.81).
city('Ibestad','no','Troms',464.0,17.13,68.8).
city('Kasfjord','no','Troms',281.0,16.36,68.83).
city('Lyngseidet','no','Troms',840.0,20.22,69.58).
city('Moen','no','Troms',857.0,18.62,69.13).
city('Movik','no','Troms',363.0,19.1,69.72).
city('Nordkjosbotn','no','Troms',391.0,19.57,69.22).
city('Olderdalen','no','Troms',317.0,20.53,69.62).
city('Setermoen','no','Troms',2358.0,18.33,68.89).
city('Silsand','no','Troms',1261.0,17.93,69.23).
city('Sjovegan','no','Troms',716.0,17.86,68.87).
city('Skibotn','no','Troms',500.0,20.27,69.4).
city('Skjervoy','no','Troms',2376.0,21.0,70.05).
city('Skjold','no','Troms',222.0,19.28,69.03).
city('Sommaroy','no','Troms',276.0,18.01,69.63).
city('Sorkjosen','no','Troms',865.0,20.95,69.77).
city('Sorreisa','no','Troms',1397.0,18.12,69.15).
city('Storslett','no','Troms',1444.0,21.07,69.77).
city('Storsteinnes','no','Troms',914.0,19.23,69.25).
city('Tennevoll','no','Troms',254.0,17.8,68.75).
city('Torsken','no','Troms',196.0,17.1,69.33).
city('Tovik','no','Troms',208.0,16.89,68.67).
city('Tromso','no','Troms',52747.0,18.94,69.66).
city('Farsund','no','Vest-Agder',3088.0,6.78,58.09).
city('Feda','no','Vest-Agder',407.0,6.83,58.27).
city('Flekkefjord','no','Vest-Agder',5707.0,6.68,58.31).
city('Gjusvik','no','Vest-Agder',1635.0,8.03,58.2).
city('Hollen','no','Vest-Agder',462.0,7.82,58.08).
city('Kristiansand','no','Vest-Agder',63784.0,7.99,58.15).
city('Liknes','no','Vest-Agder',2171.0,58.32,58.32).
city('Lyngdal','no','Vest-Agder',3719.0,7.1,58.15).
city('Mandal','no','Vest-Agder',10233.0,7.44,58.03).
city('Nodeland','no','Vest-Agder',1815.0,7.84,58.16).
city('Nodelandsheia','no','Vest-Agder',1121.0,7.85,58.15).
city('Oyslebo','no','Vest-Agder',380.0,7.55,58.17).
city('Sira','no','Vest-Agder',600.0,6.63,58.42).
city('Skalevik','no','Vest-Agder',2618.0,8.01,58.08).
city('Sogne','no','Vest-Agder',7728.0,7.78,58.1).
city('Strai','no','Vest-Agder',1389.0,7.9,58.2).
city('Svenevik','no','Vest-Agder',203.0,7.2,58.05).
city('Tonstad','no','Vest-Agder',756.0,6.72,58.67).
city('Tveit','no','Vest-Agder',1392.0,8.13,58.26).
city('Vanse','no','Vest-Agder',1941.0,6.69,58.1).
city('Vestbygda','no','Vest-Agder',1111.0,6.61,58.11).
city('Vigeland','no','Vest-Agder',1255.0,7.32,58.09).
city('Andebu','no','Vestfold',1432.0,10.08,59.33).
city('Aroysund','no','Vestfold',2102.0,10.46,59.18).
city('Asgardstrand','no','Vestfold',2932.0,10.46,59.35).
city('Barkaker','no','Vestfold',1218.0,10.38,59.32).
city('Berger','no','Vestfold',1134.0,10.39,59.56).
city('Gullhaug','no','Vestfold',1948.0,10.25,59.5).
city('Helgeroa-Nevlunghamn','no','Vestfold',1602.0,9.85,59.0).
city('Hof','no','Vestfold',818.0,12.02,60.55).
city('Holmestrand','no','Vestfold',6076.0,10.31,59.5).
city('Horten','no','Vestfold',17876.0,10.47,59.42).
city('Hoyfjord','no','Vestfold',368.0,10.12,59.37).
city('Kirkevoll-Brekkeasen','no','Vestfold',1021.0,10.32,59.4).
city('Kvelde','no','Vestfold',864.0,9.98,59.18).
city('Larvik','no','Vestfold',23222.0,9.99,59.07).
city('Lauve-Viksjord','no','Vestfold',1406.0,10.15,59.07).
city('Melsomvik','no','Vestfold',1549.0,10.34,59.23).
city('Nesbygda','no','Vestfold',991.0,10.38,59.66).
city('Nykirke','no','Vestfold',663.0,10.38,59.42).
city('Revetal-Bergsasen','no','Vestfold',1926.0,10.28,59.36).
city('Sande','no','Vestfold',1335.0,10.21,59.59).
city('Selvik','no','Vestfold',1866.0,10.27,59.57).
city('Sem','no','Vestfold',1852.0,10.3,59.29).
city('Skoppum','no','Vestfold',1567.0,10.42,59.38).
city('Stavern','no','Vestfold',5577.0,10.03,59.0).
city('Stokke','no','Vestfold',2625.0,10.31,59.23).
city('Svarstad','no','Vestfold',575.0,11.22,61.7).
city('Svelvik','no','Vestfold',3972.0,10.41,59.62).
city('Tjome','no','Vestfold',2376.0,10.39,59.13).
city('Hzasab','om','Musandam',17085.0,56.25,26.2).
city('Bawsar','om','Muscat',126415.0,58.39,23.53).
city('Matruh','om','Muscat',57604.0,58.49,23.41).
city('Muscat','om','Muscat',67445.0,58.54,23.61).
city('Qabus','om','Muscat',37739.0,58.54,23.63).
city('Qurayyat','om','Muscat',29615.0,58.9,23.25).
city('Ruwi','om','Muscat',85601.0,58.53,23.59).
city('al-Qurm','om','Muscat',23597.0,58.52,23.6).
city('as-Sib','om','Muscat',182260.0,58.19,23.67).
city('Salalah','om','Zufar',178469.0,54.09,17.02).
city('Bahla','om','ad-Dahziliyah',44024.0,57.3,22.97).
city('Nizwa','om','ad-Dahziliyah',86619.0,57.53,22.92).
city('Sumail','om','ad-Dahziliyah',36088.0,57.98,23.3).
city('Barka','om','al-Batinah',57535.0,57.88,23.71).
city('Saham','om','al-Batinah',76022.0,56.88,24.18).
city('Sinas','om','al-Batinah',43312.0,56.46,24.73).
city('Suhar','om','al-Batinah',138838.0,56.7,24.34).
city('al-Hzaburah','om','al-Batinah',36563.0,57.1,23.99).
city('al-Masnaah','om','al-Batinah',36142.0,57.63,23.78).
city('ar-Rustaq','om','al-Batinah',60196.0,57.43,23.4).
city('as-Suwayq','om','al-Batinah',86268.0,57.43,23.85).
city('Ibra','om','as-Sarqiyah',21389.0,58.53,22.72).
city('Sur','om','as-Sarqiyah',77419.0,59.55,22.57).
city('al-Mudaybi','om','as-Sarqiyah',45170.0,58.12,22.57).
city('Ibri','om','az-Zahirah',88600.0,56.5,23.25).
city('al-Buraymi','om','az-Zahirah',62328.0,55.8,24.25).
city('Muzaffarabad','pk','Azad Kashmir',19748.0,73.48,34.35).
city('Barkhan','pk','Baluchistan',8761.0,69.51,29.91).
city('Bela','pk','Baluchistan',20121.0,66.3,26.23).
city('Bhag','pk','Baluchistan',14556.0,67.82,29.04).
city('Chaman','pk','Baluchistan',88606.0,66.44,30.92).
city('Dalbandin','pk','Baluchistan',14623.0,64.44,28.88).
city('Dera Bugti','pk','Baluchistan',18122.0,69.15,29.03).
city('Dhadar','pk','Baluchistan',15091.0,67.64,29.48).
city('Duki','pk','Baluchistan',6385.0,68.56,30.15).
city('Gaddani','pk','Baluchistan',13428.0,66.73,25.12).
city('Gwadar','pk','Baluchistan',51907.0,62.33,25.14).
city('Harnai','pk','Baluchistan',11067.0,67.93,30.1).
city('Jiwani','pk','Baluchistan',16324.0,61.76,25.07).
city('Kalat','pk','Baluchistan',26704.0,66.58,29.03).
city('Kharan','pk','Baluchistan',30845.0,65.42,28.57).
city('Khuzdar','pk','Baluchistan',141286.0,66.6,27.8).
city('Kohlu','pk','Baluchistan',11090.0,69.23,29.9).
city('Loralai','pk','Baluchistan',37791.0,68.6,30.36).
city('Mach','pk','Baluchistan',16932.0,67.33,29.87).
city('Mastung','pk','Baluchistan',29086.0,66.85,29.8).
city('Nushki','pk','Baluchistan',27683.0,66.01,29.56).
city('Ormara','pk','Baluchistan',13027.0,64.63,25.22).
city('Pasni','pk','Baluchistan',33114.0,63.45,25.27).
city('Pishin','pk','Baluchistan',24242.0,66.98,30.59).
city('Quetta','pk','Baluchistan',733970.0,67.02,30.21).
city('Sibi','pk','Baluchistan',64096.0,67.87,29.55).
city('Sohbatpur','pk','Baluchistan',8941.0,68.55,28.52).
city('Surab','pk','Baluchistan',13105.0,66.26,28.49).
city('Turbat','pk','Baluchistan',75727.0,63.07,25.99).
city('Usta Muhammad','pk','Baluchistan',43988.0,68.05,28.18).
city('Uthal','pk','Baluchistan',16485.0,66.62,25.81).
city('Zhob','pk','Baluchistan',50559.0,69.44,31.35).
city('Ziarat','pk','Baluchistan',733.0,67.73,30.39).
city('Islamabad','pk','Federal Capital Area',756105.0,73.06,33.72).
city('Alizai','pk','Federally administered Tribal Areas',3334.0,70.35,33.54).
city('Kotal','pk','Federally administered Tribal Areas',2223.0,71.15,34.1).
city('Miram Shah','pk','Federally administered Tribal Areas',3334.0,70.06,33.0).
city('Shinpokh','pk','Federally administered Tribal Areas',1111.0,71.18,34.33).
city('Wana','pk','Federally administered Tribal Areas',2223.0,69.57,32.3).
city('Abottabad','pk','North-West Frontier',127950.0,73.2,34.15).
city('Akora','pk','North-West Frontier',23289.0,72.13,34.0).
city('Amangarh','pk','North-West Frontie',25725.0,71.92,34.0).
city('Baffa','pk','North-West Frontier',14048.0,73.22,34.43).
city('Bannu','pk','North-West Frontier',49028.0,70.6,32.99).
city('Bat Khela','pk','North-West Frontier',46082.0,71.97,34.62).
city('Charsadda','pk','North-West Frontier',95358.0,71.73,34.16).
city('Cherat','pk','North-West Frontier',2986.0,71.88,33.82).
city('Chitral','pk','North-West Frontier',36097.0,71.75,36.02).
city('Dera Ismail Khan','pk','North-West Frontier',101658.0,70.9,31.83).
city('Dir','pk','North-West Frontier',29871.0,71.88,35.2).
city('Doaba','pk','North-West Frontie',8894.0,70.73,33.42).
city('Hangu','pk','North-West Frontier',36152.0,71.05,33.54).
city('Haripur','pk','North-West Frontier',56981.0,72.92,34.02).
city('Havelian','pk','North-West Frontier',40497.0,73.17,34.05).
city('Jahangira','pk','North-West Frontier',37554.0,73.13,34.02).
city('Karak','pk','North-West Frontier',32587.0,66.88,30.33).
city('Khalabat','pk','North-West Frontier',39164.0,72.88,34.04).
city('Kohat','pk','North-West Frontier',151488.0,71.44,33.6).
city('Kulachi','pk','North-West Frontier',22378.0,70.46,31.93).
city('Lachi','pk','North-West Frontier',18538.0,71.33,33.38).
city('Lakki Marwat','pk','North-West Frontier',36394.0,70.91,32.6).
city('Mansehra','pk','North-West Frontier',66513.0,73.2,34.34).
city('Mardan','pk','North-West Frontier',300545.0,72.04,34.2).
city('Mingaora','pk','North-West Frontier',227423.0,72.36,34.78).
city('Nowshera','pk','North-West Frontier',96806.0,71.99,34.01).
city('Pabbi','pk','North-West Frontier',37310.0,71.78,34.02).
city('Paharpur','pk','North-West Frontier',17295.0,70.97,32.11).
city('Peshawar','pk','North-West Frontier',1219248.0,71.54,34.01).
city('Risalpur','pk','North-',37099.0,71.99,34.07).
city('Sarai Naurang','pk','North-West Frontier',19695.0,70.77,32.82).
city('Shabqadar','pk','North-West Frontier',66568.0,71.57,34.22).
city('Shorkot','pk','North-West Frontier',67467.0,70.86,31.9).
city('Swabi','pk','North-West Frontier',97402.0,72.47,34.13).
city('Takhat Bhai','pk','North-West Frontier',59372.0,71.93,34.28).
city('Tall','pk','North-West Frontier',29333.0,72.23,35.49).
city('Tangi','pk','North-West Frontier',29447.0,71.65,34.3).
city('Tank','pk','North-West Frontier',38504.0,70.38,32.21).
city('Topi','pk','North',36343.0,72.62,34.07).
city('Tordher','pk','North-West Frontier',33244.0,71.83,34.32).
city('Utmanzai','pk','North-West Frontier',29425.0,71.77,34.18).
city('Zaida','pk','North-West Frontier',26789.0,72.47,34.07).
city('Gilgit','pk','Northern Areas',9891.0,74.29,35.92).
city('Hunza','pk','Northern Areas',15606.0,74.64,36.3).
city('Abdul Hakim','pk','Punjab',46508.0,72.11,30.55).
city('Ahmadpur East','pk','Punjab',116613.0,71.26,29.15).
city('Ahmadpur Lumma','pk','Punjab',16351.0,70.05,28.32).
city('Ahmadpur Sial','pk','Punjab',24888.0,71.76,30.68).
city('Alipur','pk','Punjab',33599.0,70.9,29.38).
city('Alipur Chatha','pk','Punjab',49144.0,73.81,32.27).
city('Arifwala','pk','Punjab',87386.0,73.07,30.3).
city('Attock','pk','Punjab',85504.0,72.36,33.78).
city('Baddomalhi','pk','Punjab',18434.0,74.67,31.98).
city('Bahawalnagar','pk','Punjab',126654.0,73.25,30.0).
city('Bahawalpur','pk','Punjab',552765.0,71.67,29.39).
city('Bai Pheru','pk','Punjab',68289.0,73.95,31.2).
city('Basirpur','pk','Punjab',41630.0,73.83,30.58).
city('Begowala','pk','Punjab',9258.0,74.27,32.43).
city('Bhakkar','pk','Punjab',81974.0,71.06,31.63).
city('Bhalwal','pk','Punjab',74765.0,72.9,32.27).
city('Bhawana','pk','Punjab',16217.0,72.65,31.57).
city('Bhera','pk','Punjab',31790.0,72.92,32.48).
city('Bhopalwala','pk','Punjab',17340.0,74.37,32.43).
city('Burewala','pk','Punjab',183969.0,72.67,30.16).
city('Chak Azam Sahu','pk','Punjab',38214.0,73.03,30.75).
city('Chak Jhumra','pk','Punjab',37212.0,73.18,31.57).
city('Chakwal','pk','Punjab',101230.0,72.85,32.93).
city('Chawinda','pk','Punjab',23598.0,74.7,32.35).
city('Chichawatni','pk','Punjab',82787.0,72.68,30.53).
city('Chiniot','pk','Punjab',201840.0,72.98,31.72).
city('Chishtian Mandi','pk','Punjab',122235.0,72.84,29.79).
city('Choa Saidan Shah','pk','Punjab',15343.0,72.98,32.72).
city('Chuhar Kana','pk','Punjab',69341.0,73.82,31.75).
city('Chunian','pk','Punjab',57329.0,73.97,30.97).
city('Dajal','pk','Punjab',17629.0,70.38,29.55).
city('Darya Khan','pk','Punjab',15047.0,71.1,31.79).
city('Daska','pk','Punjab',126961.0,74.36,32.33).
city('Daud Khel','pk','Punjab',26394.0,71.56,32.88).
city('Daultala','pk','Punjab',11813.0,73.15,33.2).
city('Dera Din Panah','pk','Punjab',14877.0,70.93,30.57).
city('Dera Ghazi Khan','pk','Punjab',236162.0,70.64,30.06).
city('Dhanote','pk','Punjab',18728.0,71.77,29.57).
city('Dhonkal','pk','Punjab',12116.0,74.13,32.4).
city('Dijkot','pk','Punjab',27468.0,72.98,31.22).
city('Dina','pk','Punjab',46305.0,68.65,28.24).
city('Dinga','pk','Punjab',39796.0,73.72,32.64).
city('Dipalpur','pk','Punjab',74662.0,73.66,30.67).
city('Dullewala','pk','Punjab',48680.0,71.43,31.84).
city('Dunga Bunga','pk','Punjab',25891.0,73.25,29.75).
city('Dunyapur','pk','Punjab',34043.0,71.73,29.8).
city('Eminabad','pk','Punjab',22677.0,74.25,32.05).
city('Faisalabad','pk','Punjab',2507302.0,73.11,31.41).
city('Faqirwali','pk','Punjab',25185.0,73.03,29.47).
city('Faruka','pk','Punjab',21746.0,72.42,31.88).
city('Fateh Jang','pk','Punjab',29442.0,72.65,33.57).
city('Fatehpur','pk','Punjab',18125.0,71.22,31.17).
city('Fazalpur','pk','Punjab',28212.0,75.07,32.19).
city('Ferozwala','pk','Punjab',63927.0,71.88,29.02).
city('Fort Abbas','pk','Punjab',40624.0,72.85,29.19).
city('Garh Maharaja','pk','Punjab',29151.0,71.91,30.83).
city('Ghakar','pk','Punjab',54629.0,74.14,32.3).
city('Ghurgushti','pk','Punjab',17370.0,72.55,33.93).
city('Gojra','pk','Punjab',139767.0,72.69,31.15).
city('Gujar Khan','pk','Punjab',69394.0,73.3,33.26).
city('Gujr','pk','Punjab',1384869.0,74.18,32.16).
city('Gujrat','pk','Punjab',301595.0,74.07,32.58).
city('Hadali','pk','Punjab',49677.0,74.57,32.64).
city('Hafizabad','pk','Punjab',153701.0,73.68,32.07).
city('Harnoli','pk','Punjab',15669.0,71.55,32.28).
city('Harunabad','pk','Punjab',72453.0,73.14,29.61).
city('Hasan Abdal','pk','Punjab',45678.0,72.7,30.43).
city('Hasilpur','pk','Punjab',88056.0,72.55,29.71).
city('Haveli','pk','Punjab',65308.0,73.7,30.46).
city('Hazro','pk','Punjab',26308.0,72.49,33.91).
city('Hujra Shah Muqim','pk','Punjab',61564.0,73.82,30.75).
city('Isa Khel','pk','Punjab',17588.0,71.28,32.67).
city('Jahanian','pk','Punjab',29093.0,72.27,31.8).
city('Jalalpur Jattan','pk','Punjab',93910.0,74.2,32.64).
city('Jalalpur Pirwala','pk','Punjab',37391.0,71.22,29.5).
city('Jamke Chima','pk','Punjab',23737.0,74.36,32.39).
city('Jampur','pk','Punjab',63810.0,70.59,29.64).
city('Jand','pk','Punjab',18169.0,72.02,33.43).
city('Jandiala Sherkhan','pk','Punjab',10984.0,73.92,31.82).
city('Jaranwala','pk','Punjab',119820.0,73.41,31.34).
city('Jatoi','pk','Punjab',47158.0,70.84,29.51).
city('Jauharabad','pk','Punjab',46542.0,72.27,32.3).
city('Jhang','pk','Punjab',341311.0,72.32,31.28).
city('Jhawarian','pk','Punjab',27892.0,72.62,32.37).
city('Jhelum','pk','Punjab',164128.0,73.72,32.94).
city('Kabirwala','pk','Punjab',60799.0,71.87,30.4).
city('Kahna Nau','pk','Punjab',45885.0,74.38,31.37).
city('Kahror Pakka','pk','Punjab',69763.0,71.91,29.62).
city('Kahuta','pk','Punjab',22550.0,73.38,33.59).
city('Kalabagh','pk','Punjab',15975.0,71.55,32.97).
city('Kalaswala','pk','Punjab',12575.0,74.65,32.2).
city('Kaleke','pk','Punjab',16361.0,73.6,31.97).
city('Kalur Kot','pk','Punjab',25573.0,71.26,32.16).
city('Kamalia','pk','Punjab',112459.0,72.64,30.73).
city('Kamar Mashani','pk','Punjab',15867.0,71.37,32.85).
city('Kamir','pk','Punjab',24052.0,73.05,30.43).
city('Kamoke','pk','Punjab',199589.0,74.21,31.98).
city('Kamra','pk','Punjab',43776.0,73.52,33.75).
city('Kanganpur','pk','Punjab',21787.0,74.13,30.77).
city('Karor Lal Esan','pk','Punjab',25633.0,70.95,31.23).
city('Kasur','pk','Punjab',290728.0,74.45,31.12).
city('Khairpur Tamewali','pk','Punjab',30966.0,72.23,29.58).
city('Khanewal','pk','Punjab',154407.0,71.82,30.31).
city('Khangah Dogran','pk','Punjab',30312.0,73.63,31.84).
city('Khangarh','pk','Punjab',19697.0,71.16,29.91).
city('Khanpur','pk','Punjab',142468.0,70.65,28.65).
city('Kharian','pk','Punjab',81459.0,73.89,32.81).
city('Khewra','pk','Punjab',32619.0,73.01,32.64).
city('Khundian','pk','Punjab',30525.0,71.47,32.46).
city('Khurianwala','pk','Punjab',35290.0,73.27,31.5).
city('Khushab','pk','Punjab',102823.0,72.34,32.3).
city('Kot Abdul Malik','pk','Punjab',69355.0,66.98,30.2).
city('Kot Addu','pk','Punjab',104247.0,70.97,30.46).
city('Kot Moman','pk','Punjab',38366.0,73.03,32.19).
city('Kot Radha Kishan','pk','Punjab',45951.0,74.1,31.17).
city('Kot Samaba','pk','Punjab',22952.0,70.47,28.55).
city('Kotli Loharan','pk','Punjab',21462.0,74.48,32.58).
city('Kundian','pk','Punjab',35417.0,71.47,32.45).
city('Kunjah','pk','Punjab',28102.0,73.98,32.54).
city('Lahore','pk','Punjab',6312576.0,74.35,31.56).
city('Lalamusa','pk','Punjab',65216.0,73.96,32.7).
city('Lalian','pk','Punjab',31364.0,72.78,31.83).
city('Liaqatabad','pk','Punjab',26374.0,71.37,32.29).
city('Liaqatpur','pk','Punjab',37134.0,70.94,28.94).
city('Lieah','pk','Punjab',78977.0,70.93,30.97).
city('Liliani','pk','Punjab',12211.0,72.95,32.2).
city('Lodhran','pk','Punjab',97276.0,71.63,29.54).
city('Ludhewala Waraich','pk','Punjab',39755.0,74.11,32.15).
city('Mailsi','pk','Punjab',64564.0,72.18,29.8).
city('Malakwal','pk','Punjab',34599.0,73.21,32.56).
city('Mamu Kanjan','pk','Punjab',31912.0,72.8,30.84).
city('Mananwala Jodh Singh','pk','Punjab',28431.0,73.69,31.59).
city('Mandi Bahauddin','pk','Punjab',129770.0,73.48,32.59).
city('Mandi Sadiq Ganj','pk','Punjab',13067.0,73.73,30.17).
city('Mangla','pk','Punjab',16263.0,72.38,31.9).
city('Mankera','pk','Punjab',10818.0,71.44,31.38).
city('Mian Channun','pk','Punjab',76248.0,72.34,30.44).
city('Mianwali','pk','Punjab',89596.0,71.54,32.59).
city('Minchinabad','pk','Punjab',29251.0,73.57,30.17).
city('Mitha Tiwana','pk','Punjab',26430.0,72.11,32.25).
city('Multan','pk','Punjab',1437644.0,71.45,30.2).
city('Muridke','pk','Punjab',164292.0,74.25,31.81).
city('Murree','pk','Punjab',25245.0,73.39,33.91).
city('Mustafabad','pk','Punjab',45809.0,73.5,30.9).
city('Muzaffargarh','pk','Punjab',165240.0,71.18,30.07).
city('Nankana Sahib','pk','Punjab',56383.0,73.69,31.45).
city('Narang','pk','Punjab',34776.0,74.52,31.9).
city('Narowal','pk','Punjab',68311.0,74.87,32.11).
city('Nowshera','pk','Punjab',10060.0,75.18,32.14).
city('Nowshera Virkan','pk','Punjab',40865.0,73.98,31.97).
city('Okara','pk','Punjab',223714.0,73.45,30.81).
city('Pakpattan','pk','Punjab',126743.0,73.38,30.35).
city('Pasrur','pk','Punjab',53379.0,74.65,32.27).
city('Pattoki','pk','Punjab',70457.0,73.85,31.03).
city('Phalia','pk','Punjab',24788.0,73.58,32.43).
city('Pind Dadan Khan','pk','Punjab',22000.0,73.04,32.59).
city('Pindi Bhattian','pk','Punjab',35086.0,73.27,31.9).
city('Pindi Gheb','pk','Punjab',34311.0,72.26,33.24).
city('Pirmahal','pk','Punjab',35341.0,72.43,30.77).
city('Qadirpur Ran','pk','Punjab',20406.0,71.67,30.29).
city('Qila Disar Singh','pk','Punjab',48896.0,73.92,32.11).
city('Rabwah','pk','Punjab',50207.0,72.82,31.83).
city('Rahim Yar Khan','pk','Punjab',299850.0,70.3,28.42).
city('Raiwind','pk','Punjab',31590.0,74.21,31.25).
city('Raja Jang','pk','Punjab',24406.0,74.27,31.22).
city('Rajanpur','pk','Punjab',50679.0,70.32,29.1).
city('Rasulnagar','pk','Punjab',14392.0,73.78,32.32).
city('Rawalpindi','pk','Punjab',1743599.0,73.04,33.6).
city('Renala Khurd','pk','Punjab',37109.0,73.6,30.88).
city('Rojhan','pk','Punjab',13030.0,69.95,28.69).
city('Sadiqabad','pk','Punjab',189931.0,70.13,28.3).
city('Sahiwal','pk','Punjab',136481.0,72.72,31.33).
city('Samasatta','pk','Punjab',24362.0,71.54,29.34).
city('Sa','pk','Punjab',62892.0,74.34,32.48).
city('Sammundri','pk','Punjab',66671.0,72.8,31.11).
city('Sangala Hill','pk','Punjab',57019.0,73.37,31.72).
city('Sanjwal','pk','Punjab',10657.0,72.43,33.77).
city('Sarai Alamgir','pk','Punjab',44133.0,73.75,32.9).
city('Sarai Sidhu','pk','Punjab',15631.0,71.97,30.6).
city('Sargodha','pk','Punjab',542761.0,72.67,32.08).
city('Shahkot','pk','Punjab',47943.0,73.48,31.57).
city('Shahpur City','pk','Punjab',14152.0,72.47,32.28).
city('Shakargarh','pk','Punjab',64323.0,75.15,32.26).
city('Sharqpur','pk','Punjab',31853.0,74.1,31.46).
city('Shehr Sultan','pk','Punjab',16165.0,71.02,29.57).
city('Shekhupura','pk','Punjab',361408.0,73.98,31.72).
city('Shujaabad','pk','Punjab',65972.0,71.29,29.88).
city('Sialkot','pk','Punjab',477537.0,74.55,32.52).
city('Sillanwali','pk','Punjab',27022.0,72.54,31.82).
city('Sodhra','pk','Punjab',15976.0,74.18,32.47).
city('Sukheke','pk','Punjab',32834.0,73.5,31.87).
city('Talagang','pk','Punjab',44974.0,72.41,32.92).
city('Tandlianwala','pk','Punjab',38296.0,73.13,31.04).
city('Taunsa','pk','Punjab',44867.0,70.64,30.7).
city('Taxila','pk','Punjab',90546.0,72.81,33.75).
city('Toba Tek Singh','pk','Punjab',69084.0,72.47,30.97).
city('Tulamba','pk','Punjab',28149.0,72.23,30.54).
city('Uch','pk','Punjab',23992.0,71.05,29.24).
city('Vihari','pk','Punjab',112873.0,72.34,30.05).
city('Wah','pk','Punjab',237584.0,72.75,33.77).
city('Warburton','pk','Punjab',24294.0,73.83,31.55).
city('Wazirabad','pk','Punjab',102474.0,74.1,32.45).
city('Yazman','pk','Punjab',24579.0,71.75,29.14).
city('Zafarwal','pk','Punjab',23077.0,74.9,32.35).
city('Zahir Pir','pk','Punjab',34119.0,70.51,28.82).
city('Adilpur','pk','Sind',8248.0,69.31,27.94).
city('Badah','pk','Sind',38856.0,68.02,27.33).
city('Badin','pk','Sind',73572.0,68.84,24.66).
city('Bagarji','pk','Sind',8005.0,68.75,27.75).
city('Bakshshapur','pk','Sind',8737.0,69.37,28.39).
city('Bandhi','pk','Sind',8609.0,68.3,26.6).
city('Berani','pk','Sind',9976.0,68.8,25.79).
city('Bhan','pk','Sind',16962.0,67.71,26.56).
city('Bhiria City','pk','Sind',12186.0,68.2,26.92).
city('Bhit Shah','pk','Sind',19326.0,68.5,25.8).
city('Bozdar','pk','Sind',9175.0,68.63,27.19).
city('Bulri','pk','Sind',4997.0,68.33,24.87).
city('Chak','pk','Sind',14276.0,68.83,27.87).
city('Chambar','pk','Sind',12747.0,68.82,25.3).
city('Chohar Jamali','pk','Sind',15782.0,67.98,24.4).
city('Chor','pk','Sind',16302.0,69.77,25.52).
city('Dadu','pk','Sind',139836.0,67.77,26.73).
city('Daharki','pk','Sind',40085.0,69.7,28.05).
city('Daro','pk','Sind',10870.0,68.18,24.78).
city('Darya Khan Mari','pk','Sind',8974.0,68.28,26.68).
city('Daulatpur','pk','Sind',14575.0,67.96,26.51).
city('Daur','pk','Sind',17578.0,68.32,26.45).
city('Dhoronaro','pk','Sind',19908.0,69.57,25.5).
city('Digri','pk','Sind',31844.0,69.1,25.15).
city('Diplo','pk','Sind',11576.0,69.58,24.47).
city('Dokri','pk','Sind',14800.0,68.1,27.38).
city('Gambat','pk','Sind',34007.0,68.51,27.35).
city('Garello','pk','Sind',6853.0,68.08,27.44).
city('Garhi Khairo','pk','Sind',13666.0,67.97,28.06).
city('Garhi Yasin','pk','Sind',14811.0,68.5,27.91).
city('Gharo','pk','Sind',19525.0,67.58,24.74).
city('Ghauspur','pk','Sind',29769.0,69.07,28.14).
city('Ghotki','pk','Sind',64319.0,69.32,28.01).
city('Hala','pk','Sind',47918.0,68.42,25.81).
city('Hingorja','pk','Sind',22264.0,68.41,27.21).
city('Hyderabad','pk','Sind',1386840.0,68.37,25.38).
city('Islamkot','pk','Sind',12426.0,70.17,24.7).
city('Jacobabad','pk','Sind',170653.0,68.43,28.28).
city('Jam Sahib','pk','Sind',6870.0,68.62,26.3).
city('Jati','pk','Sind',9152.0,68.26,24.35).
city('Jhol','pk','Sind',16068.0,68.88,25.96).
city('Jhudo','pk','Sind',25909.0,69.31,24.95).
city('Johi','pk','Sind',16311.0,67.6,26.7).
city('Kadhan','pk','Sind',6854.0,68.98,24.49).
city('Kambar','pk','Sind',77510.0,67.99,27.59).
city('Kandiari','pk','Sind',6861.0,68.52,26.92).
city('Kandiaro','pk','Sind',26808.0,68.2,27.06).
city('Karachi','pk','Sind',1.1627378E7,67.01,24.86).
city('Kario Ghanwar','pk','Sind',5685.0,68.6,24.82).
city('Karoondi','pk','Sind',8604.0,68.45,26.89).
city('Kashmor','pk','Sind',33734.0,69.57,28.43).
city('Keti Bandar','pk','Sind',2934.0,67.45,24.13).
city('Khadro','pk','Sind',9997.0,68.72,26.15).
city('Khairpur','pk','Sind',124650.0,68.74,27.53).
city('Khairp','pk','Sind',30287.0,67.73,27.1).
city('Khandh Kot','pk','Sind',88501.0,69.18,28.24).
city('Khanpur','pk','Sind',22274.0,69.41,27.85).
city('Khipro','pk','Sind',28731.0,69.37,25.82).
city('Kot Diji','pk','Sind',25617.0,68.69,27.34).
city('Kot Ghulam Mohammad','pk','Sind',20898.0,74.55,32.33).
city('Kotri','pk','Sind',72700.0,68.3,25.36).
city('Kunri','pk','Sind',26774.0,69.57,25.18).
city('Lakhi','pk','Sind',13600.0,68.7,27.85).
city('Larkana','pk','Sind',364168.0,68.21,27.56).
city('Madeji','pk','Sind',14803.0,68.45,27.75).
city('Matiari','pk','Sind',18930.0,68.44,25.6).
city('Matli','pk','Sind',50401.0,68.65,25.05).
city('Mehar','pk','Sind',30430.0,67.81,27.18).
city('Mehrabpur','pk','Sind',35264.0,68.02,28.1).
city('Miro Khan','pk','Sind',10590.0,68.1,27.77).
city('Mirpur Bathoro','pk','Sind',8867.0,68.25,24.73).
city('Mirpur Khas','pk','Sind',215739.0,69.01,25.53).
city('Mirpur Mathelo','pk','Sind',49313.0,69.54,28.03).
city('Mirpur Sakro','pk','Sind',8371.0,67.63,24.55).
city('Mirwah','pk','Sind',12140.0,69.05,25.32).
city('Mithi','pk','Sind',23432.0,69.8,24.74).
city('Moro','pk','Sind',76794.0,67.99,26.67).
city('Nabisar','pk','Sind',6256.0,69.65,25.07).
city('Nasirabad','pk','Sind',27810.0,67.91,27.38).
city('Naudero','pk','Sind',33457.0,68.37,27.67).
city('Naukot','pk','Sind',22082.0,69.45,24.85).
city('Naushahro Firoz','pk','Sind',17632.0,68.12,26.84).
city('Nawabshah','pk','Sind',229590.0,68.4,26.24).
city('Padidan','pk','Sind',20920.0,68.3,26.78).
city('Pano Aqil','pk','Sind',72885.0,69.1,27.86).
city('Phulji','pk','Sind',7878.0,67.68,26.89).
city('Pirjo Goth','pk','Sind',35539.0,68.62,27.6).
city('Pithoro','pk','Sind',6440.0,69.38,25.52).
city('Radhan','pk','Sind',16787.0,67.95,27.18).
city('Rajo Khanani','pk','Sind',7683.0,68.85,24.98).
city('Ranipur','pk','Sind',22496.0,68.5,27.28).
city('Ratodero','pk','Sind',47822.0,68.29,27.81).
city('Rohri','pk','Sind',50668.0,68.89,27.68).
city('Rustam','pk','Sind',9048.0,68.8,27.97).
city('Saeedabad','pk','Sind',16183.0,68.37,25.97).
city('Sakrand','pk','Sind',31631.0,68.26,26.13).
city('Samaro','pk','Sind',8784.0,69.4,25.28).
city('Sanghar','pk','Sind',62057.0,68.93,26.05).
city('Sann','pk','Sind',8834.0,68.13,26.03).
city('Sarhari','pk','Sind',11434.0,68.48,26.1).
city('Sehwan','pk','Sind',41152.0,67.85,26.43).
city('Setharja','pk','Sind',32653.0,68.48,27.2).
city('Shah Dipalli','pk','Sind',5216.0,69.23,25.52).
city('Shahdadkot','pk','Sind',75439.0,67.9,27.85).
city('Shahdadpur','pk','Sind',67275.0,68.61,25.92).
city('Shahpur Chakar','pk','Sind',21447.0,68.63,26.15).
city('Shikarpur','pk','Sind',156961.0,68.64,27.96).
city('Sinjhoro','pk','Sind',15971.0,68.8,26.03).
city('Sita Road','pk','Sind',27588.0,67.85,27.03).
city('Sobhodero','pk','Sind',14624.0,68.4,27.3).
city('Sujawal','pk','Sind',27599.0,68.08,24.61).
city('Sukkur','pk','Sind',417923.0,68.85,27.7).
city('Talhar','pk','Sind',21155.0,68.81,24.89).
city('Tando Adam','pk','Sind',125646.0,68.66,25.76).
city('Tando Allah Yar','pk','Sind',127249.0,68.72,25.46).
city('Tando Bagho','pk','Sind',14096.0,68.97,24.8).
city('Tando Ghulam Ali','pk','Sind',16299.0,68.88,25.12).
city('Tando Jam','pk','Sind',31613.0,68.53,25.43).
city('Tando Jan Mohammad','pk','Sind',16128.0,69.22,25.07).
city('Tando Mitha Khan','pk','Sind',2723.0,69.2,25.99).
city('Tando Muhammad Khan','pk','Sind',72687.0,68.53,25.12).
city('Tangwani','pk','Sind',9256.0,69.0,28.29).
city('Thano Bula Khan','pk','Sind',14739.0,67.83,25.37).
city('Tharushah','pk','Sind',17699.0,68.11,26.95).
city('Thatta','pk','Sind',44304.0,67.92,24.75).
city('Thul','pk','Sind',34473.0,68.77,28.27).
city('Ubauro','pk','Sind',23463.0,69.73,28.16).
city('Umarkot','pk','Sind',42077.0,69.73,25.37).
city('Warah','pk','Sind',18725.0,67.8,27.45).
city('Ulimang','pw','Aimeliik',130.0,134.64,7.62).
city('Airai','pw','Airai',960.0,134.55,7.36).
city('Ngaramash','pw','Angaur',135.0,134.13,6.9).
city('Hatohobei','pw','Hatobohei',11.0,131.18,3.01).
city('Kayangel','pw','Kayangel',126.0,134.71,8.07).
city('Koror','pw','Koror',11357.0,134.51,7.35).
city('Meyungs','pw','Koror',1275.0,134.47,7.35).
city('Melekeok','pw','Melekeok',217.0,134.6,7.48).
city('Ngermechau','pw','Ngaraard',287.0,134.63,7.56).
city('Chol','pw','Ngardmau',223.0,134.32,7.67).
city('Ollei','pw','Ngaremlengui',109.0,134.61,7.72).
city('Oikul','pw','Ngatpang',102.0,134.58,7.37).
city('Ngerkeai','pw','Ngchesar',113.0,134.58,7.45).
city('Imeong','pw','Ngerchelong',132.0,134.53,7.53).
city('Ngetkip','pw','Ngiwal',62.0,134.51,7.36).
city('Kloulklubed','pw','Peleliu',531.0,134.26,7.04).
city('Dongosaru','pw','Sonsorol',24.0,132.22,5.32).
city('Almirante','pa','Bocas del Toro',8114.0,-82.4,9.3).
city('Barranco','pa','Bocas del Toro',1398.0,-82.7,9.52).
city('Bocas del Toro','pa','Bocas del Toro',3501.0,-82.56,9.34).
city('Changuinola','pa','Bocas del Toro',22902.0,-82.52,9.43).
city('Chiriqui Grande','pa','Bocas del Toro',1429.0,-82.12,8.95).
city('El Silencio','pa','Bocas del Toro',987.0,-82.53,9.38).
city('Finca Cincuenta y Uno','pa','Bocas del Toro',1000.0,-82.69,9.48).
city('Guabito','pa','Bocas del Toro',5988.0,-82.62,9.5).
city('Punta Pena','pa','Bocas del Toro',993.0,-82.18,8.92).
city('Valle del Risco','pa','Bocas del Toro',918.0,-82.43,9.23).
city('Alanje','pa','Chiriqui',1361.0,-82.54,8.4).
city('Aserrio de Gariche','pa','Chiriqui',1658.0,-82.8,8.48).
city('Bagala','pa','Chiriqui',910.0,-82.53,8.47).
city('Berba','pa','Chiriqui',942.0,-82.75,8.35).
city('Boqueron','pa','Chiriqui',1345.0,-82.56,8.5).
city('Boquete','pa','Chiriqui',6123.0,-82.44,8.78).
city('Bugaba','pa','Chiriqui',2582.0,-82.62,8.48).
city('Burica','pa','Chiriqui',1360.0,-82.87,8.03).
city('Caimito','pa','Chiriqui',906.0,-82.43,8.55).
city('Canoa','pa','Chiriqui',3061.0,-81.78,8.43).
city('Celmira','pa','Chiriqui',950.0,-82.8,8.53).
city('Cerro Punta','pa','Chiriqui',2957.0,-82.57,8.85).
city('Chiriqui','pa','Chiriqui',2431.0,-82.33,8.4).
city('David','pa','Chiriqui',82863.0,-82.43,8.44).
city('Divala','pa','Chiriqui',2493.0,-82.72,8.42).
city('Dolega','pa','Chiriqui',1653.0,-82.42,8.56).
city('Finca Blanco','pa','Chiriqui',1618.0,-82.87,8.38).
city('Finca Corredor','pa','Chiriqui',1372.0,-82.85,8.35).
city('Gariche','pa','Chiriqui',900.0,-82.78,8.48).
city('Gomez','pa','Chiriqui',1186.0,-82.73,8.57).
city('Gualaca','pa','Chiriqui',2754.0,-82.29,8.53).
city('Guarumal','pa','Chiriqui',1526.0,-82.53,8.35).
city('Horconcitos','pa','Chiriqui',877.0,-82.16,8.32).
city('La Concepcion','pa','Chiriqui',16912.0,-82.62,8.53).
city('La Esperanza','pa','Chiriqui',1952.0,-82.8,8.4).
city('La Estrella','pa','Chiriqui',945.0,-82.67,8.52).
city('La Victoria','pa','Chiriqui',1163.0,-82.25,8.45).
city('Las Lomas','pa','Chiriqui',11727.0,-82.4,8.43).
city('Los Algarrobos','pa','Chiriqui',2028.0,-82.43,8.5).
city('Los Anastacios','pa','Chiriqui',1123.0,-82.42,8.53).
city('Mata del Nance','pa','Chiriqui',1051.0,-82.4,8.45).
city('Monte Lirio','pa','Chiriqui',2823.0,-82.83,8.78).
city('Palmira','pa','Chiriqui',1144.0,-82.45,8.72).
city('Pedregal','pa','Chiriqui',16287.0,-82.43,8.37).
city('Plaza de Caisan','pa','Chiriqui',1121.0,-82.82,8.73).
city('Potrerillos Abajo','pa','Chiriqui',1182.0,-82.48,8.65).
city('Potrerillos Arriba','pa','Chiriqui',1045.0,-82.5,8.68).
city('Progreso','pa','Chiriqui',2107.0,-82.83,8.45).
city('Pueblo Nuevo','pa','Chiriqui',1169.0,-82.42,8.57).
city('Pueblo Viejo','pa','Chiriqui',1042.0,-81.67,8.25).
city('Puerto Armuelles','pa','Chiriqui',18796.0,-82.87,8.28).
city('Quiteno','pa','Chiriqui',1146.0,-82.4,8.47).
city('Remedios','pa','Chiriqui',976.0,-81.84,8.23).
city('Rio Sereno','pa','Chiriqui',1908.0,-82.86,8.82).
city('San Andres','pa','Chiriqui',1242.0,-82.73,8.6).
city('San Felix','pa','Chiriqui',1049.0,-81.87,8.28).
city('Santa Marta','pa','Chiriqui',1952.0,-82.7,8.52).
city('Santo Domingo','pa','Chiriqui',1172.0,-82.72,8.5).
city('Siogui Abajo','pa','Chiriqui',2675.0,-82.67,8.5).
city('Siogui Arriba','pa','Chiriqui',1102.0,-82.68,8.53).
city('Sortova','pa','Chiriqui',1678.0,-82.65,8.55).
city('Tijeras','pa','Chiriqui',1148.0,-82.55,8.47).
city('Tole','pa','Chiriqui',1253.0,-81.66,8.25).
city('Volcan','pa','Chiriqui',11246.0,-82.63,8.77).
city('Aguadulce','pa','Cocle',17238.0,-80.54,8.24).
city('Alto de la Estancia','pa','Cocle',1081.0,-80.17,8.6).
city('Anton','pa','Cocle',13852.0,-80.26,8.41).
city('Caimito','pa','Cocle',911.0,-80.23,8.62).
city('Canaveral','pa','Cocle',874.0,-80.43,8.52).
city('Capellania','pa','Cocle',2252.0,-80.55,8.3).
city('Chigore','pa','Cocle',2212.0,-80.35,8.53).
city('Chiguiri Arriba','pa','Cocle',987.0,-80.18,8.67).
city('Churuquita Chiquita','pa','Cocle',1142.0,-80.28,8.57).
city('Churuquita Grande','pa','Cocle',1685.0,-80.27,8.6).
city('Cocle','pa','Cocle',1226.0,-80.43,8.45).
city('El Cano','pa','Cocle',1247.0,-80.52,8.4).
city('El Coco','pa','Cocle',1078.0,-80.35,8.4).
city('El Cope','pa','Cocle',1179.0,-80.6,8.62).
city('El Corte','pa','Cocle',1103.0,-80.6,8.35).
city('El Cristo','pa','Cocle',1096.0,-80.62,8.25).
city('El Roble','pa','Cocle',1610.0,-80.65,8.17).
city('Entradero','pa','Cocle',1006.0,-80.22,8.57).
city('Juan Diaz','pa','Cocle',1348.0,-80.28,8.47).
city('La Candelaria','pa','Cocle',934.0,-80.32,8.63).
city('La Loma','pa','Cocle',1654.0,-80.63,8.17).
city('La Pintada','pa','Cocle',1938.0,-80.44,8.6).
city('Las Guias Oriente','pa','Cocle',1143.0,-80.07,8.43).
city('Las Lomas','pa','Cocle',1062.0,-80.38,8.5).
city('Llano Marin','pa','Cocle',1264.0,-80.33,8.5).
city('Los Pollos','pa','Cocle',1260.0,-80.18,8.38).
city('Nata','pa','Cocle',5619.0,-80.52,8.33).
city('Ola','pa','Cocle',583.0,-80.64,8.42).
city('Penonome','pa','Cocle',12394.0,-80.36,8.51).
city('Pocri','pa','Cocle',11447.0,-80.55,8.27).
city('Rio Grande','pa','Cocle',1127.0,-80.48,8.42).
city('Rio Hato','pa','Cocle',4752.0,-80.17,8.38).
city('Vista Hermosa','pa','Cocle',2725.0,-80.37,8.53).
city('Buena Vista','pa','Colon',3060.0,-79.7,9.27).
city('Cativa','pa','Colon',29609.0,-79.84,9.36).
city('Colon','pa','Colon',76646.0,-79.9,9.36).
city('El Giral','pa','Colon',1310.0,-79.69,9.25).
city('El Valle de la Union','pa','Colon',888.0,-79.66,9.24).
city('Escobal','pa','Colon',1790.0,-79.96,9.15).
city('Gatun','pa','Colon',1553.0,-79.77,9.29).
city('Margarita','pa','Colon',3303.0,-79.89,9.33).
city('Maria Chiquita','pa','Colon',1146.0,-79.76,9.44).
city('Nuevo San Juan','pa','Colon',1232.0,-79.66,9.22).
city('Nuevo Vigia','pa','Colon',2163.0,-79.61,9.24).
city('Palmas Bellas','pa','Colon',1274.0,-80.09,9.23).
city('Portobelo','pa','Colon',1274.0,-79.65,9.55).
city('Puerto Escondido','pa','Colon',12371.0,-80.09,9.19).
city('Puerto Pilon','pa','Colon',5688.0,-79.79,9.36).
city('Quebrada Bonita Adentro','pa','Colon',1807.0,-79.7,9.3).
city('Rio Alejandro','pa','Colon',3632.0,-79.79,9.38).
city('Rio Duque','pa','Colon',1166.0,-79.68,9.27).
city('Rio Rita','pa','Colon',1216.0,-79.79,9.3).
city('Sabanitas','pa','Colon',12872.0,-79.8,9.34).
city('Salamanca','pa','Colon',981.0,-79.6,9.34).
city('Santa Rita Arriba','pa','Colon',1960.0,-79.78,9.34).
city('El Real de Santa Maria','pa','Darien',804.0,-77.71,8.13).
city('Garachine','pa','Darien',1350.0,-78.36,8.06).
city('Jaque','pa','Darien',1357.0,-78.17,7.52).
city('La Palma','pa','Darien',1845.0,-78.15,8.41).
city('Meteti','pa','Darien',1347.0,-77.97,8.5).
city('Santa Fe','pa','Darien',1234.0,-78.15,8.65).
city('Yaviza','pa','Darien',1611.0,-77.68,8.18).
city('Capeti','pa','Embera',859.0,-77.58,8.08).
city('Puerto Indio','pa','Embera',473.0,-78.17,8.02).
city('Boca de Parita','pa','Herrera',1047.0,-80.45,8.02).
city('Chitre','pa','Herrera',43967.0,-80.42,7.97).
city('El Rincon','pa','Herrera',1364.0,-80.62,8.12).
city('Las Minas','pa','Herrera',1076.0,-8.74,7.8).
city('Los Pozos','pa','Herrera',846.0,-80.62,7.78).
city('Ocu','pa','Herrera',2987.0,-80.78,7.94).
city('Parita','pa','Herrera',2875.0,-80.51,8.0).
city('Pese','pa','Herrera',3141.0,-80.61,7.9).
city('Santa Maria','pa','Herrera',1739.0,-80.66,8.12).
city('Achutupo','pa','Kuna Yala',1753.0,-77.98,9.2).
city('Ailigandi','pa','Kuna Yala',1652.0,-78.02,9.23).
city('Carti Sugtupu','pa','Kuna Yala',1050.0,-78.97,9.47).
city('Coetupo','pa','Kuna Yala',930.0,-77.7,8.9).
city('El Porvenir','pa','Kuna Yala',10.0,-78.98,9.56).
city('Kanir-Dup','pa','Kuna Yala',1429.0,-78.15,9.28).
city('Mamitipo','pa','Kuna Yala',1271.0,-77.98,9.18).
city('Mulatupo','pa','Kuna Yala',1303.0,-77.75,8.95).
city('Nargana','pa','Kuna Yala',1090.0,-78.58,9.44).
city('Sasardi','pa','Kuna Yala',1047.0,-77.75,8.97).
city('Tigre','pa','Kuna Yala',817.0,-78.53,9.43).
city('Tubuala','pa','Kuna Yala',1061.0,-79.03,9.52).
city('Ukupseni','pa','Kuna Yala',2042.0,-78.23,9.3).
city('Ustupo','pa','Kuna Yala',2514.0,-77.93,9.13).
city('Icanti','pa','Kuna de Madungandi',644.0,-78.68,9.21).
city('Ipeti','pa','Kuna de Madungandi',652.0,-78.51,8.97).
city('Morti','pa','Kuna de Wargandi',528.0,-77.92,8.85).
city('Wala','pa','Kuna de Wargandi',532.0,-78.06,8.98).
city('Agua Buena','pa','Los Santos',1069.0,-80.4,7.82).
city('Bella Vista','pa','Los Santos',1104.0,-80.24,7.75).
city('El Ejido','pa','Los Santos',1120.0,-80.38,7.92).
city('Guarare','pa','Los Santos',2104.0,-80.27,7.82).
city('La Espigadilla','pa','Los Santos',1317.0,-80.4,7.88).
city('La Palma','pa','Los Santos',1283.0,-80.38,7.72).
city('La Tiza','pa','Los Santos',1091.0,-80.28,7.75).
city('Las Tablas','pa','Los Santos',8570.0,-80.28,7.76).
city('Llano Largo','pa','Los Santos',1077.0,-80.43,7.9).
city('Llano de Piedra','pa','Los Santos',1105.0,-80.57,7.67).
city('Los Santos','pa','Los Santos',5971.0,-80.42,7.93).
city('Macaracas','pa','Los Santos',2192.0,-80.54,7.73).
city('Pedasi','pa','Los Santos',1558.0,-80.02,7.53).
city('Pocri','pa','Los Santos',705.0,-80.15,7.73).
city('Santa Ana Arriba','pa','Los Santos',984.0,-80.37,7.93).
city('Santo Domingo','pa','Los Santos',1876.0,-80.25,7.75).
city('Tonosi','pa','Los Santos',1643.0,-8.44,7.4).
city('Bisira','pa','Ngoeb',914.0,-81.86,8.9).
city('Cerro Sombrero','pa','Ngoebe Bugle',884.0,-81.62,8.05).
city('Chichica','pa','Ngoebe Bugle',787.0,-81.66,8.36).
city('Kankintu','pa','Ngoebe Bugle',706.0,-81.82,8.85).
city('Kusapin','pa','Ngoebe Bugle',1288.0,-81.89,9.18).
city('Alcalde Diaz','pa','Panama',19783.0,-79.55,9.12).
city('Alto del Espino','pa','Panama',3672.0,-79.85,8.83).
city('Ancon','pa','Panama',9170.0,-79.55,8.97).
city('Arraijan','pa','Panama',76829.0,-79.65,8.95).
city('Balboa','pa','Panama',807.0,-79.56,8.94).
city('Bejuco','pa','Panama',3420.0,-79.88,8.6).
city('Cabra','pa','Panama',1415.0,-79.32,9.12).
city('Caimitillo','pa','Panama',1101.0,-79.53,9.15).
city('Calzada Larga','pa','Panama',1427.0,-79.57,9.17).
city('Canita','pa','Panama',1258.0,-78.88,9.21).
city('Capira','pa','Panama',3376.0,-79.87,8.75).
city('Cermeno','pa','Panama',928.0,-79.85,8.73).
city('Cerro Azul','pa','Panama',1287.0,-79.42,9.17).
city('Cerro Cama','pa','Panama',1274.0,-79.91,9.03).
city('Chame','pa','Panama',2313.0,-79.87,8.58).
city('Chepo','pa','Panama',15338.0,-79.1,9.17).
city('Chilibre','pa','Panama',33536.0,-79.62,9.15).
city('Chiman','pa','Panama',786.0,-78.62,8.72).
city('Coloncito','pa','Panama',918.0,-79.9,8.57).
city('El Coco','pa','Panama',12125.0,-79.82,8.87).
city('El Espave','pa','Panama',1026.0,-79.84,8.93).
city('El Espino','pa','Panama',1717.0,-79.85,8.84).
city('El Progreso','pa','Panama',4292.0,-79.12,9.27).
city('Guadalupe','pa','Panama',8409.0,-79.81,8.86).
city('La Cabima','pa','Panama',17545.0,-79.53,9.13).
city('La Chorrera','pa','Panama',61235.0,-79.78,8.88).
city('La Herradura','pa','Panama',3347.0,-79.81,8.85).
city('La Mesa','pa','Panama',1127.0,-79.27,9.18).
city('La Mitra','pa','Panama',4778.0,-79.79,8.84).
city('Las Colinas','pa','Panama',1447.0,-80.08,8.55).
city('Las Cumbres','pa','Panama',69130.0,-79.53,9.08).
city('Lidice','pa','Panama',4059.0,-79.9,8.75).
city('Los Lotes','pa','Panama',1319.0,-79.3,9.13).
city('Nueva Gorgona','pa','Panama',1517.0,-79.87,8.55).
city('Nuevo Arraijan','pa','Panama',23594.0,-79.72,8.92).
city('Nuevo Emperador','pa','Panama',1723.0,-79.73,9.0).
city('Nuevo Guarare','pa','Panama',856.0,-79.72,8.93).
city('Pacora','pa','Panama',55530.0,-79.28,9.08).
city('Panama','pa','Panama',408188.0,-79.53,8.97).
city('Paraiso','pa','Panama',1177.0,-79.63,9.03).
city('Paso Blanco','pa','Panama',2735.0,-79.23,9.13).
city('Potrero Grande','pa','Panama',4044.0,-79.83,8.88).
city('Puerto Caimito','pa','Panama',1674.0,-79.72,8.87).
city('Sajalices','pa','Panama',945.0,-79.87,8.68).
city('San Carlos','pa','Panama',810.0,-79.94,8.48).
city('San Miguel','pa','Panama',751.0,-78.93,8.46).
city('San Miguelito','pa','Panama',321516.0,-79.5,9.03).
city('San Vicente de Bique','pa','Panama',1784.0,-79.68,8.92).
city('Santa Clara','pa','Panama',1410.0,-79.75,9.04).
city('Santa Rita','pa','Panama',987.0,-79.88,8.86).
city('Taboga','pa','Panama',983.0,-79.54,8.8).
city('Tocumen','pa','Panama',88543.0,-79.38,9.08).
city('Veracruz','pa','Panama',16172.0,-79.63,8.88).
city('Villa Carmen','pa','Panama',1256.0,-79.87,8.8).
city('Villa Rosario','pa','Panama',2947.0,-79.87,8.78).
city('Vista Alegre','pa','Panama',41786.0,-79.7,8.93).
city('Atalaya','pa','Veraguas',2857.0,-80.92,8.05).
city('Calobre','pa','Veraguas',937.0,-80.84,8.32).
city('Canazas','pa','Veraguas',1950.0,-80.95,8.23).
city('El Espino de Santa Rosa','pa','Veraguas',1048.0,-80.82,8.1).
city('El Uvito','pa','Veraguas',858.0,-80.98,8.12).
city('La Colorada','pa','Veraguas',1246.0,-80.98,8.02).
city('La Mata','pa','Veraguas',959.0,-80.88,8.08).
city('La Mesa','pa','Veraguas',2228.0,-81.17,8.15).
city('La Pena','pa','Veraguas',2274.0,-81.03,8.13).
city('La Raya de Santa Maria','pa','Veraguas',933.0,-80.82,8.17).
city('Las Palmas','pa','Veraguas',1489.0,-81.44,8.13).
city('Los Algarrobos','pa','Veraguas',1611.0,-81.02,8.12).
city('Los Boquerones','pa','Veraguas',1038.0,-80.85,8.08).
city('Montijo','pa','Veraguas',1873.0,-81.04,7.99).
city('Rio de Jesus','pa','Veraguas',1180.0,-81.15,7.98).
city('San Antonio','pa','Veraguas',1232.0,-80.93,8.05).
city('San Francisco','pa','Veraguas',1898.0,-81.36,8.07).
city('Santa Fe','pa','Veraguas',950.0,-81.07,8.52).
city('Santiago','pa','Veraguas',45358.0,-80.97,8.1).
city('Sona','pa','Veraguas',7401.0,-81.32,8.01).
city('Kokopo','pg','East New Britain',26334.0,152.27,-4.34).
city('Rabaul','pg','East New Britain',8085.0,152.16,-4.2).
city('Aitape','pg','East Sepik',5547.0,142.35,-3.12).
city('Ambunti','pg','East Sepik',2073.0,142.83,-4.22).
city('Angoram','pg','East Sepik',1603.0,144.07,-4.06).
city('Wewak','pg','East Sepik',18230.0,143.62,-3.56).
city('Goroka','pg','Eastern Highlands',18502.0,145.38,-6.09).
city('Kainantu','pg','Eastern Highlands',8509.0,145.87,-6.27).
city('Laiagam','pg','Enga',921.0,143.77,-5.27).
city('Porgera','pg','Enga',1578.0,143.2,-5.46).
city('Wabag','pg','Enga',3959.0,143.71,-5.49).
city('Balimo','pg','Fly River',3601.0,142.91,-8.01).
city('Daru','pg','Fly River',15215.0,143.21,-9.07).
city('Kiunga','pg','Fly River',11540.0,141.3,-6.12).
city('Morehead','pg','Fly River',2246.0,141.65,-8.55).
city('Kerema','pg','Gulf',5645.0,145.77,-7.96).
city('Finschhafen','pg','Madang',1054.0,147.85,-6.59).
city('Madang','pg','Madang',27420.0,145.79,-5.23).
city('Lorengau','pg','Manus',5807.0,147.28,-2.03).
city('Alotau','pg','Milne Bay',12095.0,150.45,-10.3).
city('Samarai','pg','Milne Bay',1638.0,150.67,-10.61).
city('Bulolo','pg','Morobe',16042.0,146.65,-7.19).
city('Lae','pg','Morobe',76254.0,146.99,-6.7).
city('Wau','pg','Morobe',14628.0,146.72,-7.32).
city('Port Moresby','pg','National Capital District',283733.0,147.18,-9.48).
city('Kavieng','pg','New Ireland',14491.0,150.79,-2.58).
city('Namatanai','pg','New Ireland',1376.0,152.44,-3.66).
city('Arawa','pg','North Solomons',40266.0,155.56,-6.23).
city('Buin','pg','North Solomons',750.0,155.73,-6.82).
city('Kieta','pg','North Solomons',3611.0,155.62,-6.21).
city('Panguna','pg','North Solomons',2916.0,155.5,-6.24).
city('Kokoda','pg','Oro',6199.0,147.74,-8.87).
city('Popondetta','pg','Oro',28199.0,148.24,-8.77).
city('Vanimo','pg','Sandaun',11204.0,141.3,-2.69).
city('Kundiawa','pg','Simbu',9383.0,144.96,-6.02).
city('Ialibu','pg','Southern Highlands',6915.0,143.98,-6.28).
city('Mendi','pg','Southern Highlands',26251.0,143.65,-6.14).
city('Tari','pg','Southern Highlands',10333.0,142.93,-5.84).
city('Kandrian','pg','West New Britain',1014.0,149.55,-6.21).
city('Kimbe','pg','West New Britain',18849.0,150.14,-5.55).
city('Mount Hagen','pg','Western Highlands',33622.0,144.22,-5.86).
city('Fuerte Olimpo','py','Alto Paraguay',2478.0,-57.9,-21.07).
city('La Victoria','py','Alto Paraguay',5002.0,-57.94,-22.29).
city('Mayor Pablo Lagerenza','py','Alto Paraguay',1205.0,-60.79,-19.92).
city('Ciudad del Este','py','Alto Parana',260594.0,-54.63,-25.42).
city('Doctor Juan Leon Mallorquin','py','Alto Parana',7489.0,-55.26,-25.43).
city('Domingo Martinez de Irala','py','Alto Parana',989.0,-54.72,-25.9).
city('Hernandariaz','py','Alto Parana',55677.0,-54.65,-25.4).
city('Iruna','py','Alto Parana',802.0,-55.05,-26.14).
city('Itaquyry','py','Alto Parana',3038.0,-55.22,-24.93).
city('Juan Emilio OLeary','py','Alto Parana',3042.0,-55.39,-25.42).
city('Los Cedrales','py','Alto Parana',2755.0,-54.7,-25.65).
city('Mbaracayu','py','Alto Parana',509.0,-54.8,-25.02).
city('Minga Guazu','py','Alto Parana',17926.0,-54.73,-25.5).
city('Minga Pora','py','Alto Parana',1770.0,-54.9,-24.87).
city('Nacunday','py','Alto Parana',912.0,-54.77,-26.02).
city('Naranjal','py','Alto Parana',2155.0,-55.18,-25.97).
city('Presidente Franco','py','Alto Parana',54303.0,-54.61,-25.57).
city('San Alberto','py','Alto Parana',4990.0,-54.9,-24.97).
city('San Cristobal','py','Alto Parana',478.0,-55.44,-25.91).
city('Santa Rita','py','Alto Parana',11850.0,-55.07,-25.78).
city('Santa Rosa del Monday','py','Alto Parana',1711.0,-54.89,-25.8).
city('Yguazu','py','Alto Parana',3364.0,-55.0,-25.45).
city('Bella Vista','py','Amambay',5654.0,-56.52,-22.13).
city('Capitan Bado','py','Amambay',9115.0,-55.54,-23.26).
city('Pedro Juan Caballero','py','Amambay',67432.0,-55.75,-22.53).
city('Asuncion','py','Asuncion',508797.0,-57.63,-25.3).
city('Doctor Pedro P. Pena','py','Boqueron',5043.0,-62.3,-22.48).
city('Filadelfia','py','Boqueron',8049.0,-60.03,-22.34).
city('Marechal Estigarribia','py','Boqueron',7018.0,-60.62,-22.03).
city('Menno','py','Boqueron',5615.0,-59.82,-22.37).
city('Neuland','py','Boqueron',2816.0,-60.13,-22.65).
city('Caaguazu','py','Caaguazu',54814.0,-56.02,-25.46).
city('Carayao','py','Caaguazu',2473.0,-56.4,-25.2).
city('Coronel Oviedo','py','Caaguazu',51291.0,-56.44,-25.45).
city('Doctor Cecilio Baez','py','Caaguazu',1978.0,-56.32,-25.05).
city('Doctor Eulogio Estigarribia','py','Caaguazu',11559.0,-55.7,-25.37).
city('Doctor Juan Manuel Frutos','py','Caaguazu',4798.0,-55.8,-25.36).
city('Jose Ocampos','py','Caaguazu',1681.0,-55.44,-25.4).
city('La Pastoria','py','Caaguazu',336.0,-56.54,-25.23).
city('Marechal Francisco Solano Lopez','py','Caaguazu',689.0,-55.37,-24.67).
city('Mbutuy','py','Caaguazu',1466.0,-56.3,-24.96).
city('Nueva Londres','py','Caaguazu',813.0,-56.53,-25.42).
city('Raul Arsenio Oviedo','py','Caaguazu',1424.0,-55.43,-25.13).
city('Repatriacion','py','Caaguazu',7091.0,-55.95,-25.53).
city('San Joaquin','py','Caaguazu',1745.0,-56.12,-24.95).
city('San Jose de los Arroyos','py','Caaguazu',5118.0,-56.73,-25.54).
city('Simon Bolivar','py','Caaguazu',767.0,-56.32,-25.02).
city('Tres Corrales','py','Caaguazu',252.0,-56.13,-25.03).
city('Tres de Febrero','py','Caaguazu',1063.0,-55.76,-25.3).
city('Vaqueria','py','Caaguazu',2871.0,-55.83,-25.02).
city('Yhu','py','Caaguazu',2092.0,-55.93,-25.06).
city('Abai','py','Caazapa',3024.0,-55.94,-26.03).
city('Buena Vista','py','Caazapa',1580.0,-56.08,-26.18).
city('Caazapa','py','Caazapa',6790.0,-56.38,-26.2).
city('Doctor Moises Bertoni','py','Caazapa',380.0,-56.44,-26.37).
city('General Higinio Morinigo','py','Caazapa',1399.0,-55.92,-25.95).
city('Maciel','py','Caazapa',503.0,-56.48,-26.19).
city('San Juan Nepomuceno','py','Caazapa',7894.0,-55.94,-26.12).
city('Tavai','py','Caazapa',722.0,-56.35,-26.48).
city('Yegros','py','Caazapa',1140.0,-56.41,-26.46).
city('Yuty','py','Caazapa',4774.0,-56.25,-26.62).
city('Corpus Christi','py','Canendiyu',1387.0,-54.83,-24.03).
city('Curuguaty','py','Canendiyu',11096.0,-55.71,-24.48).
city('General Francisco Alvarez','py','Canendiyu',2839.0,-54.53,-24.07).
city('Itanara','py','Canendiyu',316.0,-55.78,-23.82).
city('Katuete','py','Canendiyu',4070.0,-54.62,-24.13).
city('La Paloma','py','Canendiyu',4383.0,-54.52,-24.08).
city('Nueva Esperanza','py','Canendiyu',3333.0,-54.87,-24.52).
city('Salto del Guaira','py','Canendiyu',7387.0,-54.34,-24.02).
city('Ygatimi','py','Canendiyu',2810.0,-55.5,-24.08).
city('Ypehu','py','Canendiyu',1986.0,-55.46,-23.91).
city('Aregua','py','Central',11224.0,-57.42,-25.3).
city('Capiata','py','Central',198801.0,-57.42,-25.35).
city('Fernando de la Mora','py','Central',120180.0,-57.59,-25.32).
city('Guarambare','py','Central',9066.0,-57.46,-25.49).
city('Ita','py','Central',18461.0,-57.36,-25.51).
city('Itaugua','py','Central',65035.0,-57.34,-25.38).
city('Juan Augusto Saldivar','py','Central',4761.0,-57.4,-25.45).
city('Lambare','py','Central',126391.0,-57.64,-25.33).
city('Limpio','py','Central',96238.0,-57.53,-25.18).
city('Luque','py','Central',209836.0,-57.49,-25.27).
city('Nemby','py','Central',94767.0,-57.6,-25.36).
city('Nueva Italia','py','Central',2841.0,-57.5,-25.62).
city('San Antonio','py','Central',55759.0,-57.61,-25.38).
city('San Lorenzo','py','Central',227898.0,-57.52,-25.34).
city('Villa Elisa','py','Central',64138.0,-57.62,-25.37).
city('Villeta','py','Central',11031.0,-57.56,-25.51).
city('Ypacarai','py','Central',9656.0,-57.28,-25.41).
city('Ypane','py','Central',6659.0,-57.53,-25.45).
city('Belen','py','Concepcion',1621.0,-57.24,-23.47).
city('Concepcion','py','Concepcion',48127.0,-57.43,-23.4).
city('Horqueta','py','Concepcion',10533.0,-57.05,-23.0).
city('Loreto','py','Concepcion',3476.0,-57.18,-23.27).
city('San Carlos','py','Concepcion',706.0,-57.3,-22.27).
city('San Lazaro','py','Concepcion',708.0,-57.92,-22.17).
city('Altos','py','Cordillera',4763.0,-57.25,-25.23).
city('Arroyos y Esteros','py','Cordillera',2455.0,-57.09,-25.05).
city('Atyra','py','Cordillera',4769.0,-57.17,-25.25).
city('Caacupe','py','Cordillera',21697.0,-57.14,-25.39).
city('Caraguatay','py','Cordillera',1637.0,-56.84,-25.24).
city('Emboscada','py','Cordillera',5911.0,-57.35,-25.15).
city('Eusebio','py','Cordillera',8253.0,-56.97,-25.39).
city('Isla Pucu','py','Cordillera',1529.0,-56.9,-25.3).
city('Itacurubi de la Cordillera','py','Cordillera',3576.0,-56.85,-25.45).
city('Juan de Mena','py','Cordillera',480.0,-56.73,-24.92).
city('Loma Grande','py','Cordillera',364.0,-57.22,-25.17).
city('Mbocayty del Yhaguy','py','Cordillera',611.0,-56.72,-25.33).
city('Nueva Colombia','py','Cordillera',683.0,-57.35,-25.18).
city('Piribebuy','py','Cordillera',10337.0,-57.05,-25.48).
city('Primero de Marzo','py','Cordillera',837.0,-56.92,-25.15).
city('San Bernardino','py','Cordillera',4651.0,-57.32,-25.27).
city('San Jose Obrero','py','Cordillera',459.0,-56.87,-25.25).
city('Santa Elena','py','Cordillera',1138.0,-56.8,-25.4).
city('Tobati','py','Cordillera',9953.0,-57.07,-25.25).
city('Valenzuela','py','Cordillera',587.0,-56.87,-25.58).
city('Borja','py','Guaira',325.0,-56.48,-25.95).
city('Capitan Mauricio Jose Troche','py','Guaira',2369.0,-56.28,-25.57).
city('Coronel Martinez','py','Guaira',1359.0,-56.62,-25.76).
city('Doctor Botrell','py','Guaira',246.0,-56.32,-25.58).
city('Felix Perez Cardozo','py','Guaira',536.0,-56.53,-25.75).
city('General Eugenio Alejandrino Garay','py','Guaira',955.0,-62.21,-20.52).
city('Independencia','py','Guaira',1575.0,-56.25,-25.72).
city('Itape','py','Guaira',1641.0,-56.62,-25.85).
city('Iturbe','py','Guaira',4476.0,-56.5,-26.05).
city('Jose Fasardi','py','Guaira',409.0,-56.13,-25.98).
city('Mbocayaty','py','Guaira',2296.0,-56.42,-25.72).
city('Natalicio Talavera','py','Guaira',1809.0,-56.3,-25.64).
city('Numi','py','Guaira',864.0,-56.32,-25.95).
city('Paso Yobai','py','Guaira',17.0,-55.93,-25.68).
city('San Salvador','py','Guaira',723.0,-56.47,-25.95).
city('Villarrica','py','Guaira',41160.0,-56.46,-25.78).
city('Yataity','py','Guaira',1874.0,-56.07,-26.37).
city('Alto Vera','py','Itapua',642.0,-55.63,-26.58).
city('Bella Vista','py','Itapua',2334.0,-55.55,-27.05).
city('Cambyreta','py','Itapua',822.0,-55.78,-27.35).
city('Capitan Meza','py','Itapua',963.0,-55.57,-27.02).
city('Capitan Miranda','py','Itapua',2498.0,-55.8,-27.2).
city('Carlos Antonio Lopez','py','Itapua',1497.0,-54.77,-26.4).
city('Carmen del Parana','py','Itapua',4196.0,-56.22,-27.23).
city('Coronel Bogado','py','Itapua',9831.0,-56.25,-27.17).
city('Edelira','py','Itapua',1699.0,-55.27,-26.75).
city('Encarnacion','py','Itapua',74991.0,-55.88,-27.33).
city('Fram','py','Itapua',3916.0,-55.88,-26.98).
city('General Artigas','py','Itapua',4073.0,-56.22,-26.94).
city('General Delgado','py','Itapua',1544.0,-56.52,-27.17).
city('Hohenau','py','Itapua',5307.0,-55.75,-27.08).
city('Itapua Poty','py','Itapua',646.0,-55.57,-26.58).
city('Jesus','py','Itapua',2530.0,-55.79,-27.05).
city('La Paz','py','Itapua',340.0,-55.85,-27.02).
city('Leandro Oviedo','py','Itapua',309.0,-56.23,-26.72).
city('Mayor Otano','py','Itapua',4702.0,-54.71,-26.4).
city('Natalio','py','Itapua',2253.0,-55.08,-26.72).
city('Nueva Alborada','py','Itapua',290.0,-55.62,-27.25).
city('Obligado','py','Itapua',6350.0,-55.63,-27.03).
city('Pirapo','py','Itapua',1757.0,-55.54,-26.85).
city('San Cosme y Damian','py','Itapua',2224.0,-56.35,-27.32).
city('San Juan del Parana','py','Itapua',1494.0,-55.97,-27.3).
city('San Pedro del Parana','py','Itapua',5723.0,-56.22,-26.84).
city('San Rafael del Parana','py','Itapua',460.0,-54.93,-26.65).
city('Tomas Romero Pereira','py','Itapua',5534.0,-55.25,-26.48).
city('Trinidad','py','Itapua',2837.0,-55.78,-27.12).
city('Yatytay','py','Itapua',2553.0,-55.08,-26.69).
city('Ayolas','py','Misiones',12064.0,-56.9,-27.4).
city('San Ignacio','py','Misiones',14404.0,-57.03,-26.89).
city('San Juan Bautista','py','Misiones',10935.0,-57.15,-26.68).
city('San Miguel','py','Misiones',1210.0,-57.04,-26.53).
city('San Patricio','py','Misiones',1525.0,-56.84,-26.98).
city('Santa Maria','py','Misiones',2095.0,-56.93,-26.78).
city('Santa Rosa','py','Misiones',7257.0,-56.85,-26.89).
city('Santiago','py','Misiones',2144.0,-56.76,-27.15).
city('Villa Florida','py','Misiones',2305.0,-57.13,-26.4).
city('Yabebyry','py','Misiones',217.0,-57.14,-27.4).
city('Alberdi','py','Neembucu',6518.0,-58.13,-26.19).
city('Cerrito','py','Neembucu',1036.0,-57.67,-27.32).
city('Desmochados','py','Neembucu',240.0,-58.1,-27.12).
city('General Jose Eduvigis Diaz','py','Neembucu',1345.0,-58.42,-27.17).
city('Guazu Cua','py','Neembucu',373.0,-58.05,-26.88).
city('Humaita','py','Neembucu',1519.0,-58.5,-27.07).
city('Isla Umbu','py','Neembucu',340.0,-58.3,-27.0).
city('Laureles','py','Neembucu',708.0,-57.49,-27.24).
city('Mayor Jose Dejesus Martinez','py','Neembucu',920.0,-58.22,-27.15).
city('Paso de Patria','py','Neembucu',853.0,-58.55,-27.25).
city('Pilar','py','Neembucu',25542.0,-58.3,-26.87).
city('San Juan Bautista de Neembucu','py','Neembucu',330.0,-57.93,-26.65).
city('Tacuaras','py','Neembucu',280.0,-58.1,-26.82).
city('Villa Franca','py','Neembucu',459.0,-58.14,-26.28).
city('Villa Oliva','py','Neembucu',772.0,-57.87,-26.02).
city('Villalbin','py','Neembucu',375.0,-57.92,-27.15).
city('Acahay','py','Paraguari',3205.0,-57.11,-25.91).
city('Caapucu','py','Paraguari',2284.0,-57.18,-26.23).
city('Carapegua','py','Paraguari',5784.0,-57.25,-25.77).
city('Escobar','py','Paraguari',234.0,-57.02,-25.65).
city('General Bernardino Caballero','py','Paraguari',1152.0,-56.86,-25.68).
city('La Colmena','py','Paraguari',2551.0,-56.85,-25.88).
city('Mbuyapey','py','Paraguari',2201.0,-56.76,-26.22).
city('Paraguari','py','Paraguari',10079.0,-57.16,-25.62).
city('Pirayu','py','Paraguari',4000.0,-57.23,-25.48).
city('Quiindy','py','Paraguari',5137.0,-57.23,-25.98).
city('Quyquyho','py','Paraguari',757.0,-56.99,-26.23).
city('Sapucai','py','Paraguari',1932.0,-56.95,-25.68).
city('Tebicuarymi','py','Paraguari',403.0,-56.65,-25.92).
city('Yaguaron','py','Paraguari',7182.0,-57.28,-25.57).
city('Ybycui','py','Paraguari',4629.0,-57.02,-26.01).
city('Ybytimi','py','Paraguari',526.0,-56.79,-25.77).
city('Benjamin Aceval','py','Presidente Hayes',7751.0,-57.57,-24.97).
city('Jose Falcon','py','Presidente Hayes',310.0,-57.71,-25.21).
city('Mariano Roque Alonso','py','Presidente Hayes',72023.0,-57.55,-25.17).
city('Nanawa','py','Presidente Hayes',5588.0,-67.67,-25.27).
city('Pozo Colorado','py','Presidente Hayes',1850.0,-58.86,-23.43).
city('Puerto Pinasco','py','Presidente Hayes',892.0,-57.79,-22.64).
city('Villa Hayes','py','Presidente Hayes',16726.0,-57.53,-25.09).
city('Antequera','py','San Pedro',2701.0,-57.08,-24.13).
city('Capiibary','py','San Pedro',3537.0,-56.04,-24.8).
city('Chore','py','San Pedro',2193.0,-56.57,-24.2).
city('General Elizardo Aquino','py','San Pedro',2983.0,-56.7,-24.44).
city('General Isidro Resquin','py','San Pedro',2349.0,-56.49,-24.07).
city('Guayaibi','py','San Pedro',2248.0,-56.43,-24.53).
city('Itacurubi del Rosario','py','San Pedro',3888.0,-56.68,-24.5).
city('Lima','py','San Pedro',2358.0,-56.5,-23.89).
city('Nueva Germania','py','San Pedro',1206.0,-56.57,-23.9).
city('San Estanislao','py','San Pedro',14751.0,-56.5,-24.67).
city('San Pablo','py','San Pedro',659.0,-57.07,-24.15).
city('San Pedro de Ycuamandiyu','py','San Pedro',9361.0,-57.08,-24.09).
city('Tacuati','py','San Pedro',2406.0,-56.59,-23.45).
city('Union','py','San Pedro',1653.0,-56.55,-24.8).
city('Veinticinco de Diciembre','py','San Pedro',766.0,-56.55,-24.7).
city('Villa del Rosario','py','San Pedro',5124.0,-57.1,-24.42).
city('Yataity del Norte','py','San Pedro',1392.0,-56.35,-24.83).
city('Bagua Grande','pe','Amazonas',20474.0,-78.44,-5.78).
city('Cajaruro','pe','Amazonas',7313.0,-78.43,-5.74).
city('Chachapoyas','pe','Amazonas',20348.0,-77.87,-6.23).
city('La Peca','pe','Amazonas',27167.0,-78.44,-5.61).
city('Caraz','pe','Ancash',10976.0,-77.82,-9.05).
city('Carhuaz','pe','Ancash',5067.0,-77.65,-9.29).
city('Casma','pe','Ancash',21263.0,-78.21,-9.44).
city('Chimbote','pe','Ancash',320119.0,-78.6,-9.07).
city('Choishco','pe','Ancash',15151.0,-78.63,-9.02).
city('Huallanca','pe','Ancash',5665.0,-76.96,-9.88).
city('Huaraz','pe','Ancash',87233.0,-77.53,-9.53).
city('Huar','pe','Ancash',4235.0,-77.24,-9.37).
city('Huarmey','pe','Ancash',16245.0,-78.16,-10.07).
city('Pomabamba','pe','Ancash',4473.0,-77.47,-8.83).
city('Santa','pe','Ancash',14130.0,-78.63,-8.98).
city('Yungay','pe','Ancash',5292.0,-77.75,-9.15).
city('Abancay','pe','Apurimac',55299.0,-72.89,-13.64).
city('Andahuaylas','pe','Apurimac',17522.0,-73.4,-13.65).
city('San Jeronimo','pe','Apurimac',5635.0,-73.37,-13.65).
city('Talavera','pe','Apurimac',7414.0,-73.43,-13.65).
city('Acari','pe','Arequipa',4465.0,-74.63,-15.43).
city('Arequipa','pe','Arequipa',844000.0,-71.53,-16.39).
city('Camana','pe','Arequipa',16509.0,-72.72,-16.62).
city('Chivay','pe','Arequipa',4563.0,-71.61,-15.64).
city('Cocachacra','pe','Arequipa',8838.0,-71.77,-17.09).
city('Lluta','pe','Arequipa',6025.0,-72.02,-16.02).
city('Mollendo','pe','Arequipa',29084.0,-72.02,-17.02).
city('Nicolas de Pierola','pe','Arequipa',5826.0,-76.7,-11.95).
city('Orcopampa','pe','Arequipa',5668.0,-72.36,-15.27).
city('Punta de Bombon','pe','Arequipa',6364.0,-71.81,-17.18).
city('Rio Grande','pe','Arequipa',4710.0,-75.21,-14.51).
city('Yura','pe','Arequipa',5712.0,-71.7,-16.25).
city('Ayacucho','pe','Ayacucho',140510.0,-74.22,-13.17).
city('Ayna','pe','Ayacucho',4609.0,-73.93,-12.67).
city('Coracora','pe','Ayacucho',7453.0,-73.79,-15.02).
city('Huanta','pe','Ayacucho',18711.0,-74.25,-12.95).
city('Puquio','pe','Ayacucho',10538.0,-74.13,-14.7).
city('San Miguel','pe','Ayacucho',6332.0,-73.98,-13.01).
city('Tambo','pe','Ayacucho',5054.0,-73.92,-14.8).
city('Bambamarc','pe','Cajamarca',13411.0,-78.53,-6.68).
city('Bellavista','pe','Cajamarca',6349.0,-78.69,-5.67).
city('Cajabamba','pe','Cajamarca',13546.0,-78.04,-7.62).
city('Cajamarca','pe','Cajamarca',132622.0,-78.52,-7.16).
city('Celendin','pe','Cajamarca',14726.0,-78.15,-6.86).
city('Chota','pe','Cajamarca',14304.0,-78.65,-6.55).
city('Cutervo','pe','Cajamarca',14565.0,-78.82,-6.37).
city('Jaen','pe','Cajamarca',52730.0,-78.81,-5.71).
city('Pucara','pe','Cajamarca',3970.0,-77.85,-7.52).
city('San Ignacio','pe','Cajamarca',7947.0,-79.0,-5.14).
city('Anta','pe','Cusco',5886.0,-72.12,-13.48).
city('Calca','pe','Cusco',9220.0,-71.97,-13.32).
city('Cusco','pe','Cusco',313210.0,-71.99,-13.52).
city('Oropesa','pe','Cusco',4040.0,-71.78,-13.59).
city('Santa Ana','pe','Cusco',25259.0,-72.72,-12.87).
city('Santo Tomas','pe','Cusco',4152.0,-72.08,-14.46).
city('Sicuani','pe','Cusco',33726.0,-71.23,-14.29).
city('Urcos','pe','Cusco',5504.0,-71.64,-13.7).
city('Urubamba','pe','Cusco',7574.0,-72.12,-13.31).
city('Huancavelica','pe','Huancavelica',41719.0,-74.99,-12.79).
city('Lircay','pe','Huancavelica',5260.0,-74.72,-12.93).
city('Pampas','pe','Huancavelica',5545.0,-74.9,-12.4).
city('Ambo','pe','Huanuco',6896.0,-76.17,-10.12).
city('Huanuco','pe','Huanuco',148466.0,-76.24,-9.92).
city('La Union','pe','Huanuco',4809.0,-76.79,-9.77).
city('Llata','pe','Huanuco',4606.0,-76.79,-9.41).
city('San Miguel de Cauri','pe','Huanuco',5350.0,-76.61,-10.11).
city('Tingo Maria','pe','Huanuco',53416.0,-75.99,-9.29).
city('Chincha Alta','pe','Ica',154561.0,-76.14,-13.42).
city('Ica','pe','Ica',247687.0,-75.75,-14.06).
city('Los Aquijes','pe','Ica',7883.0,-75.67,-14.1).
city('Marcona','pe','Ica',15548.0,-75.07,-15.2).
city('Nazca','pe','Ica',23662.0,-74.94,-14.83).
city('Palpa','pe','Ica',5909.0,-75.19,-14.54).
city('Pisco','pe','Ica',62148.0,-76.22,-13.71).
city('Salas','pe','Ica',10734.0,-79.61,-6.27).
city('San Clemente','pe','Ica',15886.0,-76.15,-13.67).
city('San Juan Bautista','pe','Ica',6902.0,-75.75,-14.03).
city('Santiago','pe','Ica',10496.0,-75.74,-14.19).
city('Subtanjalla','pe','Ica',9137.0,-75.74,-14.03).
city('Tupac Amaru Inca','pe','Ica',11209.0,-76.15,-13.7).
city('Vista Alegre','pe','Ica',10267.0,-75.72,-14.05).
city('Acobamba','pe','Junin',7193.0,-74.57,-12.88).
city('Acolla','pe','Junin',6836.0,-75.57,-11.73).
city('Carhuamayo','pe','Junin',9163.0,-76.05,-10.91).
city('Chupaca','pe','Junin',9921.0,-75.29,-12.06).
city('Concepcion','pe','Junin',11381.0,-75.32,-11.91).
city('Huancayo','pe','Junin',380098.0,-75.21,-12.07).
city('Huasahuasi','pe','Junin',5169.0,-75.62,-11.32).
city('Huayucachi','pe','Junin',5854.0,-75.24,-12.13).
city('Jauja','pe','Junin',21152.0,-75.5,-11.8).
city('Junin','pe','Junin',15389.0,-76.01,-11.15).
city('La Oroya','pe','Junin',33495.0,-75.94,-11.52).
city('Mazamari','pe','Junin',6856.0,-74.57,-11.35).
city('Morococha','pe','Junin',7926.0,-76.14,-11.6).
city('Orcotuna','pe','Junin',4218.0,-75.34,-11.96).
city('Pangoa','pe','Junin',6667.0,-73.0,-12.11).
city('Perene','pe','Junin',6875.0,-75.22,-10.97).
city('Pilcomayo','pe','Junin',8206.0,-75.27,-12.05).
city('San Agustin','pe','Junin',6025.0,-75.25,-11.97).
city('San Jeronimo de Tunan','pe','Junin',8812.0,-75.25,-11.95).
city('San Pedro de Cajas','pe','Junin',5784.0,-75.87,-11.25).
city('San Ramon','pe','Junin',14774.0,-75.34,-11.13).
city('Santa Rosa de Saco','pe','Junin',13797.0,-75.3,-11.88).
city('Satipo','pe','Junin',15602.0,-74.69,-11.26).
city('Sicaya','pe','Junin',6872.0,-75.29,-12.03).
city('Tarma','pe','Junin',51581.0,-75.73,-11.41).
city('Yauya','pe','Junin',9133.0,-77.3,-8.98).
city('Ascope','pe','La Libertad',14078.0,-79.12,-7.72).
city('Cascas','pe','La Libertad',4318.0,-78.82,-7.48).
city('Chepen','pe','La Libertad',42181.0,-79.42,-7.22).
city('Chicama','pe','La Libertad',14982.0,-79.15,-7.85).
city('Chocope','pe','La Libertad',32515.0,-79.23,-7.78).
city('Guadalupe','pe','La Libertad',25491.0,-79.49,-7.26).
city('Huamachuco','pe','La Libertad',21866.0,-78.05,-7.81).
city('Huanchanco','pe','La Li',17845.0,-79.12,-8.08).
city('Laredo','pe','La Libertad',24802.0,-78.95,-8.1).
city('Moche','pe','La Libertad',22683.0,-79.04,-8.18).
city('Otuzco','pe','La Libertad',10180.0,-78.57,-7.9).
city('Pacanga','pe','La Libertad',8789.0,-79.5,-7.17).
city('Pacasmayo','pe','La Libertad',29296.0,-79.57,-7.4).
city('Paijan','pe','La Libertad',21223.0,-79.31,-7.73).
city('Pueblo Nuevo','pe','La Libertad',5792.0,-79.49,-7.18).
city('Quiruvilca','pe','La Libertad',9268.0,-78.2,-7.97).
city('Salaverry','pe','La Libertad',10112.0,-78.99,-8.22).
city('San Pedro de Lloc','pe','La Libertad',16323.0,-79.52,-7.42).
city('Santiago de Cao','pe','La Libertad',22081.0,-79.25,-7.96).
city('Santiago de Chuco','pe','La Libertad',6790.0,-78.18,-8.15).
city('Trujillo','pe','La Libertad',750004.0,-79.03,-8.11).
city('Viru','pe','La Libertad',20867.0,-78.76,-8.42).
city('Chiclayo','pe','Lambayeque',582597.0,-79.84,-6.76).
city('Chongoyape','pe','Lambayeque',16133.0,-79.39,-6.63).
city('Eten','pe','Lambayeque',13755.0,-79.87,-6.9).
city('Ferrenafe','pe','Lambayeque',34512.0,-79.8,-6.63).
city('Illimo','pe','Lambayeque',5709.0,-79.83,-6.42).
city('Jayanca','pe','Lambayeque',6153.0,-79.83,-6.4).
city('Lambayeque','pe','Lambayeque',43907.0,-79.91,-6.69).
city('Mochumi','pe','Lambayeque',7494.0,-79.87,-6.54).
city('Monsefu','pe','Lambayeque',25822.0,-79.86,-6.87).
city('Morrope','pe','Lambayeque',6692.0,-80.01,-6.53).
city('Motupe','pe','Lambayeque',13743.0,-79.71,-6.15).
city('Olmos','pe','Lambayeque',9845.0,-79.75,-5.98).
city('Oyotun','pe','Lambayeque',6359.0,-79.31,-6.85).
city('Picsi','pe','Lambayeque',43806.0,-79.79,-6.72).
city('Pimentel','pe','Lambayeque',15622.0,-79.93,-6.83).
city('Pueblo Nuevo','pe','Lambayeque',12527.0,-79.89,-5.72).
city('Reque','pe','Lambayeque',9852.0,-79.82,-6.86).
city('San Jose','pe','Lambayeque',7468.0,-79.84,-6.73).
city('Sana','pe','Lambayeque',39377.0,-79.58,-6.91).
city('Santa Rosa','pe','Lambayeque',10673.0,-79.84,-6.77).
city('Tucume','pe','Lambayeque',7074.0,-79.85,-6.52).
city('Barranca','pe','Lima y Callao',51078.0,-77.77,-10.74).
city('Caleta de Carquin','pe','Lima y Cal',6085.0,-77.61,-11.1).
city('Chancay','pe','Lima y Callao',29746.0,-77.27,-11.56).
city('Chicla','pe','Lima y Callao',7354.0,-76.3,-11.75).
city('Chilca','pe','Lima y Callao',14216.0,-76.74,-12.52).
city('Chosica','pe','Lima y Callao',110536.0,-76.71,-11.93).
city('Huacho','pe','Lima y Callao',53852.0,-77.62,-11.11).
city('Hualmay','pe','Lima y Callao',29416.0,-77.63,-11.09).
city('Huaral','pe','Lima y Callao',68606.0,-77.21,-11.5).
city('Huaura','pe','Lima y Callao',22867.0,-77.6,-11.06).
city('Imperial','pe','Lima y Callao',35689.0,-76.36,-13.07).
city('Lima','pe','Lima y Callao',7646786.0,-77.05,-12.07).
city('Mala','pe','Lima y Callao',19045.0,-76.64,-12.66).
city('Matucana','pe','Lima y Callao',4985.0,-76.4,-11.85).
city('Nuevo Imperial','pe','Lima y Callao',35689.0,-76.33,-13.08).
city('Oyon','pe','Lima y Callao',6925.0,-76.78,-10.66).
city('Paramonga','pe','Lima y Callao',30490.0,-77.84,-10.67).
city('Pativilca','pe','Lima y Callao',14988.0,-77.8,-10.7).
city('Quilmana','pe','Lima y Callao',7109.0,-76.4,-12.95).
city('Ricardo Palma','pe','Lima y Callao',5343.0,-76.67,-11.92).
city('San Luis','pe','Lima y Callao',9778.0,-77.0,-12.08).
city('San Vicente de Canete','pe','Lima y Callao',28157.0,-76.4,-13.09).
city('Santa Eulalia','pe','Lima y Callao',7068.0,-76.69,-11.85).
city('Santa Maria','pe','Lima y Callao',16390.0,-76.9,-12.0).
city('Sayan','pe','Lima y Callao',6837.0,-77.19,-11.14).
city('Supe','pe','Lima y Callao',15138.0,-77.73,-10.8).
city('Supe Puerto','pe','Lima y Callao',12634.0,-77.75,-10.81).
city('Vegueta','pe','Lima y Callao',6862.0,-77.65,-11.02).
city('Barranca','pe','Loreto',5805.0,-76.7,-4.83).
city('Contamana','pe','Loreto',13947.0,-75.02,-7.34).
city('Iquitos','pe','Loreto',439114.0,-73.2,-3.75).
city('Lagunas','pe','Loreto',9238.0,-75.64,-5.23).
city('Nauta','pe','Loreto',11757.0,-73.78,-4.57).
city('Ramon Castilla','pe','Loreto',5520.0,-69.96,-4.23).
city('Requena','pe','Loreto',20494.0,-73.91,-5.07).
city('Saquena','pe','Loreto',4381.0,-73.52,-4.67).
city('Vargas Guerra','pe','Loreto',7114.0,-77.72,-2.97).
city('Yurimaguas','pe','Loreto',42016.0,-76.1,-5.91).
city('Iberia','pe','Madre de Dios',4406.0,-69.59,-11.36).
city('Puerto Maldonado','pe','Madre de Dios',37742.0,-69.2,-12.6).
city('Tambopata','pe','Madre de Dios',39142.0,-69.18,-12.73).
city('Ilo','pe','Moquegua',53717.0,-71.34,-17.64).
city('Moquegua','pe','Moquegua',54703.0,-70.94,-17.19).
city('Pacocha','pe','Moquegua',7622.0,-71.34,-17.58).
city('Torata','pe','Moquegua',7086.0,-70.85,-17.06).
city('Cerro de Pasco','pe','Pasco',79183.0,-76.27,-10.69).
city('Chaupimarca','pe','Pasco',28795.0,-76.54,-10.43).
city('Oxapampa','pe','Pasco',7777.0,-75.4,-10.57).
city('Paucartambo','pe','Pasco',5423.0,-71.6,-13.32).
city('Tinyahuarco','pe','Pasco',5089.0,-76.3,-10.75).
city('Villa Rica','pe','Pasco',7482.0,-75.29,-10.72).
city('Yanacancha','pe','Pasco',23280.0,-76.54,-10.47).
city('Yanahuanca','pe','Pasco',6019.0,-76.52,-10.48).
city('Ayabaca','pe','Piura',5294.0,-79.72,-4.66).
city('Bernal','pe','Piura',5943.0,-80.75,-5.45).
city('Buenos Aires','pe','Piura',7967.0,-79.97,-5.25).
city('Catacaos','pe','Piura',57903.0,-80.68,-5.27).
city('Chulucanas','pe','Piura',69145.0,-80.17,-5.09).
city('Colan','pe','Piura',14274.0,-81.06,-5.04).
city('El Alto','pe','Piura',9345.0,-81.22,-4.27).
city('Huancabamba','pe','Piura',8591.0,-79.45,-5.24).
city('La Arena','pe','Piura',32914.0,-80.68,-5.33).
city('La Brea','pe','Piura',17773.0,-80.9,-4.25).
city('La Huaca','pe','Piura',8506.0,-80.97,-4.91).
city('La Union','pe','Piura',34991.0,-80.74,-5.4).
city('Las Lomas','pe','Piura',9493.0,-80.25,-4.65).
city('Mancora','pe','Piura',9142.0,-81.02,-4.1).
city('Marcavelica','pe','Piura',25760.0,-80.72,-4.88).
city('Morropon','pe','Piura',12362.0,-79.97,-5.18).
city('Paita','pe','Piura',56404.0,-81.12,-5.09).
city('Piura','pe','Piura',326592.0,-80.63,-5.19).
city('Querecotillo','pe','Piura',25511.0,-80.66,-4.87).
city('Salitral','pe','Piura',5409.0,-80.7,-4.85).
city('Sechura','pe','Piura',23124.0,-80.82,-5.56).
city('Sullana','pe','Piura',162493.0,-80.68,-4.89).
city('Talara','pe','Piura',100105.0,-81.28,-4.58).
city('Tamarindo','pe','Piura',4836.0,-81.03,-4.88).
city('Tambo Grande','pe','Piura',30169.0,-80.35,-4.93).
city('Vice','pe','Piura',12973.0,-80.78,-5.41).
city('Vichayal','pe','Piura',5687.0,-81.14,-4.85).
city('Ayaviri','pe','Puno',19397.0,-70.6,-14.88).
city('Azangaro','pe','Puno',13350.0,-70.22,-14.91).
city('Desaguadero','pe','Puno',5353.0,-69.05,-16.57).
city('Huancane','pe','Puno',7867.0,-70.89,-15.82).
city('Ilave','pe','Puno',16105.0,-69.67,-16.08).
city('Juli','pe','Puno',7342.0,-69.45,-16.22).
city('Juliaca','pe','Puno',247949.0,-70.14,-15.5).
city('Lampa','pe','Puno',4801.0,-70.37,-15.37).
city('Macusani','pe','Puno',6071.0,-70.44,-14.07).
city('Nunoa','pe','Puno',4290.0,-70.65,-14.47).
city('Puno','pe','Puno',116951.0,-70.05,-15.84).
city('Putina','pe','Puno',8155.0,-69.43,-15.47).
city('Santa Lucia','pe','Puno',4339.0,-70.62,-15.71).
city('Yunguyo','pe','Puno',10210.0,-70.87,-17.17).
city('Bellavista','pe','San Martin',15300.0,-76.53,-7.07).
city('Chazuta','pe','San Martin',8065.0,-76.13,-6.57).
city('Huicungo','pe','San Martin',6788.0,-76.8,-7.28).
city('Jepelacio','pe','San Martin',7182.0,-76.95,-6.12).
city('Juanjui','pe','San Martin',37885.0,-76.74,-7.17).
city('Lamas','pe','San Martin',13755.0,-76.52,-6.43).
city('Moyobamba','pe','San Martin',44428.0,-76.97,-6.03).
city('Picota','pe','San Martin',6727.0,-76.34,-6.92).
city('Rioja','pe','San Martin',25170.0,-77.18,-6.06).
city('San Jose de Sisa','pe','San Martin',9520.0,-76.65,-6.62).
city('Saposoa','pe','San Martin',14961.0,-76.8,-6.93).
city('Sauce','pe','San Martin',7113.0,-76.17,-6.73).
city('Soritor','pe','San Martin',10907.0,-77.07,-6.1).
city('Tabalosos','pe','San Martin',14811.0,-76.68,-6.35).
city('Tarapoto','pe','San Martin',124638.0,-76.48,-6.51).
city('Tocache','pe','San Martin',29160.0,-76.52,-8.18).
city('Uchiza','pe','San Martin',17822.0,-76.41,-8.42).
city('Ilabaya','pe','Tacna',9534.0,-70.52,-17.42).
city('Tacna','pe','Tacna',280996.0,-70.25,-18.02).
city('Tarata','pe','Tacna',4936.0,-70.03,-17.65).
city('Aguas Verdes','pe','Tumbes',9147.0,-80.27,-3.48).
city('Corrales','pe','Tumbes',19856.0,-72.65,-15.93).
city('Papayal','pe','Tumbes',5509.0,-80.73,-4.07).
city('Tumbes','pe','Tumbes',109599.0,-80.46,-3.57).
city('Zarumilla','pe','Tumbes',16983.0,-80.29,-3.5).
city('Zorritos','pe','Tumbes',12317.0,-80.66,-3.67).
city('Campoverde','pe','Ucayali',8985.0,-74.81,-8.47).
city('Pucallpa','pe','Ucayali',311793.0,-74.53,-8.39).
city('Abucay','ph','Bicol',2863.0,123.66,12.98).
city('Abuyog','ph','Bicol',3377.0,124.06,12.95).
city('Aguada','ph','Bicol',2552.0,123.83,12.82).
city('Alayao','ph','Bicol',2406.0,122.54,14.28).
city('Anislag','ph','Bicol',4061.0,123.7,13.08).
city('Anoling','ph','Bicol',2670.0,123.67,13.21).
city('Antipolo','ph','Bicol',3638.0,123.35,13.47).
city('Apad','ph','Bicol',2755.0,122.76,13.81).
city('Apud','ph','Bicol',2071.0,123.29,13.14).
city('Armenia','ph','Bicol',3658.0,123.74,12.26).
city('Ayugan','ph','Bicol',2613.0,123.32,13.55).
city('Baao','ph','Bicol',19613.0,123.36,13.46).
city('Bacolod','ph','Bicol',2773.0,123.51,12.23).
city('Bacon','ph','Bicol',5010.0,124.04,13.04).
city('Badian','ph','Bicol',2706.0,123.31,13.03).
city('Bagacay','ph','Bicol',3075.0,123.73,13.39).
city('Bagahanglad','ph','Bicol',2649.0,123.67,12.59).
city('Bagumbayan','ph','Bicol',2543.0,123.54,13.46).
city('Bahay','ph','Bicol',2501.0,123.03,13.54).
city('Balading','ph','Bicol',2755.0,123.71,13.39).
city('Balaogan','ph','Bicol',2841.0,123.28,13.43).
city('Balatan','ph','Bicol',4451.0,123.23,13.32).
city('Baleno','ph','Bicol',3741.0,123.48,12.47).
city('Balete','ph','Bicol',8588.0,124.03,13.02).
city('Baligang','ph','Bicol',5781.0,123.64,13.15).
city('Balinad','ph','Bicol',3032.0,123.54,13.29).
city('Baliuag','ph','Bicol',4601.0,123.2,13.52).
city('Balocawe','ph','Bicol',2142.0,123.85,12.2).
city('Balogo','ph','Bicol',3549.0,123.31,13.4).
city('Balud','ph','Bicol',2295.0,123.19,12.04).
city('Bangad','ph','Bicol',3321.0,123.4,12.16).
city('Banocboc','ph','Bicol',3963.0,122.58,14.3).
city('Banquerohan','ph','Bicol',9040.0,123.75,13.06).
city('Bara','ph','Bicol',2084.0,123.64,12.07).
city('Barayong','ph','Bicol',2433.0,123.72,13.1).
city('Barcelona','ph','Bicol',3258.0,124.14,12.87).
city('Bariw','ph','Bicol',2070.0,123.73,13.13).
city('Bascaran','ph','Bicol',3261.0,123.7,13.1).
city('Basiad','ph','Bicol',2849.0,122.34,14.16).
city('Basicao','ph','Bicol',2662.0,123.4,13.05).
city('Basud','ph','Bicol',3705.0,123.46,13.53).
city('Batang','ph','Bicol',3017.0,123.56,13.25).
city('Bato','ph','Bicol',9528.0,123.83,13.49).
city('Batobalani','ph','Bicol',5025.0,122.75,14.23).
city('Batuan','ph','Bicol',2516.0,123.78,12.42).
city('Baybay','ph','Bicol',2212.0,123.71,13.41).
city('Beberon','ph','Bicol',2250.0,123.14,13.54).
city('Bigaa','ph','Bicol',14510.0,123.76,13.2).
city('Binanwanaan','ph','Bicol',3034.0,123.3,13.7).
city('Binitayan','ph','Bicol',4802.0,123.76,13.29).
city('Binodegahan','ph','Bicol',2471.0,123.46,13.06).
city('Bolo','ph','Bicol',2627.0,123.26,13.08).
city('Bombon','ph','Bicol',4913.0,123.2,13.68).
city('Bonga','ph','Bicol',4547.0,123.66,13.25).
city('Boton','ph','Bicol',2336.0,124.04,12.93).
city('Bual','ph','Bicol',6795.0,124.03,13.03).
city('Buang','ph','Bicol',2402.0,123.64,13.31).
city('Buenavista','ph','Bicol',2609.0,123.55,13.02).
city('Buga','ph','Bicol',3666.0,123.36,13.3).
city('Buhatan','ph','Bicol',2556.0,124.05,12.97).
city('Buluang','ph','Bicol',5758.0,123.35,13.31).
city('Bulusan','ph','Bicol',6648.0,124.14,12.76).
city('Burabod','ph','Bicol',2286.0,123.42,13.27).
city('Buracan','ph','Bicol',2309.0,123.5,13.6).
city('Busing','ph','Bicol',2062.0,122.97,13.15).
city('Butag','ph','Bicol',2833.0,123.93,12.63).
city('Buyo','ph','Bicol',3229.0,123.68,13.4).
city('Cabcab','ph','Bicol',2613.0,124.05,13.63).
city('Ca','ph','Bicol',2270.0,123.73,12.91).
city('Cabitan','ph','Bicol',3468.0,123.34,12.3).
city('Cabugao','ph','Bicol',2642.0,124.28,13.6).
city('Cabusao','ph','Bicol',2269.0,123.11,13.72).
city('Caditaan','ph','Bicol',3126.0,123.85,12.81).
city('Cagliliog','ph','Bicol',2738.0,123.29,13.9).
city('Cagmanaba','ph','Bicol',2773.0,123.3,13.06).
city('Calabaca','ph','Bicol',2749.0,122.44,14.3).
city('Calasgasan','ph','Bicol',2447.0,122.93,14.08).
city('Calasuche','ph','Bicol',2278.0,123.53,12.22).
city('Calatagan','ph','Bicol',7132.0,124.21,13.59).
city('Calolbon','ph','Bicol',5005.0,124.1,13.6).
city('Camaligan','ph','Bicol',5950.0,123.16,13.63).
city('Canaman','ph','Bicol',3010.0,123.17,13.65).
city('Capalonga','ph','Bicol',3900.0,122.49,14.33).
city('Capuy','ph','Bicol',2328.0,123.93,12.98).
city('Caramoan','ph','Bicol',3471.0,123.86,13.77).
city('Caramoran','ph','Bicol',4791.0,124.13,13.99).
city('Caranan','ph','Bicol',7265.0,123.02,13.52).
city('Caraycayon','ph','Bicol',3016.0,123.48,13.62).
city('Carriedo','ph','Bicol',2091.0,124.1,12.93).
city('Casiguran','ph','Bicol',8605.0,124.01,12.87).
city('Castilla','ph','Bicol',2771.0,123.88,12.95).
city('Castillo','ph','Bicol',4203.0,123.12,13.73).
city('Catabangan','ph','Bicol',3665.0,122.64,13.88).
city('Cataingan','ph','Bicol',7809.0,123.98,12.0).
city('Causip','ph','Bicol',2033.0,123.28,13.5).
city('Claveria','ph','Bicol',6185.0,123.25,12.9).
city('Colacling','ph','Bicol',2965.0,12.0,13.79).
city('Cotmon','ph','Bicol',2770.0,123.66,13.12).
city('Cumadcad','ph','Bicol',5203.0,123.79,12.98).
city('Curry','ph','Bicol',2358.0,123.3,13.6).
city('Daet','ph','Bicol',78812.0,122.96,14.12).
city('Daguit','ph','Bicol',3391.0,122.72,14.19).
city('Dalupaon','ph','Bicol',3901.0,122.94,13.55).
city('Dancalan','ph','Bicol',2167.0,123.59,12.92).
city('Dapdap','ph','Bicol',2127.0,123.77,12.22).
city('Del Gallego','ph','Bicol',4070.0,122.6,13.92).
city('Del Rosario','ph','Bicol',2589.0,123.32,13.4).
city('Dimasalang','ph','Bicol',3018.0,123.86,12.19).
city('Dogongan','ph','Bicol',2144.0,122.89,14.1).
city('Donsol','ph','Bicol',6198.0,123.6,12.91).
city('Estancia','ph','Bicol',3708.0,123.68,13.36).
city('Fabrica','ph','Bicol',3641.0,123.3,13.49).
city('Gabao','ph','Bicol',3600.0,123.96,12.73).
city('Gainza','ph','Bicol',2173.0,123.14,13.61).
city('Garchitorena','ph','Bicol',4909.0,123.7,13.88).
city('Gatbo','ph','Bicol',2367.0,123.7,13.29).
city('Gibgos','ph','Bicol',2477.0,123.77,13.86).
city('Gigmoto','ph','Bicol',3259.0,124.39,13.78).
city('Goa','ph','Bicol',20936.0,123.49,13.7).
city('Guijalo','ph','Bicol',2604.0,123.87,13.74).
city('Guinacutan','ph','Bicol',2861.0,122.87,14.16).
city('Gumaus','ph','Bicol',2346.0,122.72,14.31).
city('Guruyan','ph','Bicol',2675.0,123.94,12.74).
city('Hacienda','ph','Bicol',4756.0,123.81,13.37).
city('Herrera','ph','Bicol',2198.0,123.58,13.27).
city('Himaao','ph','Bicol',3865.0,123.3,13.55).
city('Hobo','ph','Bicol',3373.0,123.18,13.51).
city('Imelda','ph','Bicol',3466.0,122.88,14.03).
city('Inapatan','ph','Bicol',2698.0,123.31,13.38).
city('Iraya','ph','Bicol',2727.0,123.52,13.25).
city('Iriga','ph','Bicol',94846.0,123.42,13.43).
city('Irosin','ph','Bicol',20716.0,124.04,12.7).
city('Jamorawon','ph','Bicol',3089.0,123.55,12.23).
city('Joroan','ph','Bicol',2596.0,123.62,13.49).
city('Jovellar','ph','Bicol',3936.0,123.6,13.07).
city('Juban','ph','Bicol',4075.0,123.99,12.85).
city('Kinalansan','ph','Bicol',2137.0,123.55,13.71).
city('La Purisima','ph','Bicol',4928.0,123.29,13.45).
city('Labnig','ph','Bicol',2983.0,123.68,13.38).
city('Lacag','ph','Bicol',2207.0,123.68,13.15).
city('Lagonoy','ph','Bicol',7324.0,123.52,13.74).
city('Lajong','ph','Bicol',2253.0,123.97,12.83).
city('Lanigay','ph','Bicol',2789.0,123.5,13.32).
city('Larap','ph','Bicol',4329.0,122.65,14.3).
city('Legaspi','ph','Bicol',142871.0,123.75,13.17).
city('Libog','ph','Bicol',11690.0,123.78,13.24).
city('Liboro','ph','Bicol',6028.0,122.73,13.83).
city('Limbuhan','ph','Bicol',3190.0,124.03,11.9).
city('Lourdes','ph','Bicol',3791.0,123.38,13.38).
city('Lubigan','ph','Bicol',2444.0,122.93,13.74).
city('Lugui','ph','Bicol',2308.0,122.8,14.13).
city('Luklukan','ph','Bicol',4335.0,122.72,14.33).
city('Luna','ph','Bicol',2209.0,123.73,12.55).
city('Lupi','ph','Bicol',2353.0,123.04,13.66).
city('Mabalodbalod','ph','Bicol',2494.0,123.46,13.59).
city('Mabiton','ph','Bicol',2202.0,123.26,12.84).
city('Macabugos','ph','Bicol',2561.0,123.31,13.23).
city('Macalaya','ph','Bicol',3673.0,123.77,12.89).
city('Magallanes','ph','Bicol',2740.0,123.84,12.83).
city('Magarao','ph','Bicol',15205.0,123.18,13.66).
city('Magsalangi','ph','Bicol',2399.0,123.57,12.18).
city('Mahaba','ph','Bicol',3125.0,123.55,13.27).
city('Malabog','ph','Bicol',3957.0,123.68,13.17).
city('Malasugui','ph','Bicol',2978.0,122.85,14.14).
city('Malatap','ph','Bicol',2157.0,122.51,14.19).
city('Malawag','ph','Bicol',3155.0,123.28,13.38).
city('Malbug','ph','Bicol',2292.0,123.65,12.06).
city('Malidong','ph','Bicol',2301.0,123.46,13.01).
city('Malilipot','ph','Bicol',19450.0,123.74,13.32).
city('Malinta','ph','Bicol',3374.0,123.56,12.3).
city('Mambulo','ph','Bicol',6319.0,123.05,13.72).
city('Mampurog','ph','Bicol',2310.0,122.9,14.05).
city('Manambrag','ph','Bicol',2920.0,124.11,13.74).
city('Mandaon','ph','Bicol',3539.0,123.28,12.23).
city('Manga','ph','Bicol',2433.0,123.46,13.27).
city('Manguiring','ph','Bicol',3767.0,123.27,13.74).
city('Manito','ph','Bicol',3008.0,123.87,13.12).
city('Maonon','ph','Bicol',2942.0,123.37,13.04).
city('Marintoc','ph','Bicol',2111.0,123.71,12.29).
city('Mariroc','ph','Bicol',4324.0,123.69,13.34).
city('Masarawag','ph','Bicol',3725.0,123.62,13.22).
city('Maslog','ph','Bicol',3641.0,123.77,13.1).
city('Masoli','ph','Bicol',2601.0,123.39,13.36).
city('Matacon','ph','Bicol',3976.0,123.42,13.33).
city('Matnog','ph','Bicol',4771.0,123.51,13.33).
city('Mauraro','ph','Bicol',3753.0,123.6,13.15).
city('Mercedes','ph','Bicol',16991.0,123.01,14.11).
city('Miaga','ph','Bicol',2149.0,123.82,12.24).
city('Milagros','ph','Bicol',6009.0,123.49,12.22).
city('Milaor','ph','Bicol',8809.0,123.18,13.6).
city('Minalabac','ph','Bicol',4724.0,123.19,13.57).
city('Mobo','ph','Bicol',3750.0,123.66,12.34).
city('Monbon','ph','Bicol',3408.0,124.01,12.73).
city('Monreal','ph','Bicol',4759.0,123.67,12.64).
city('Muladbucad','ph','Bicol',3988.0,123.6,13.23).
city('Naga','ph','Bicol',147115.0,123.2,13.6).
city('Nagas','ph','Bicol',2785.0,123.67,13.44).
city('Naro','ph','Bicol',2977.0,123.67,11.9).
city('Nato','ph','Bicol',5583.0,123.54,13.61).
city('Ocampo','ph','Bicol',2841.0,123.38,13.56).
city('Odicon','ph','Bicol',2439.0,123.07,13.53).
city('Ogod','ph','Bicol',2948.0,123.62,12.9).
city('Osiao','ph','Bicol',2737.0,123.98,13.09).
city('Osmena','ph','Bicol',2915.0,123.33,12.73).
city('Otavi','ph','Bicol',2833.0,123.93,12.65).
city('Padang','ph','Bicol',2187.0,123.77,13.22).
city('Palanas','ph','Bicol',2690.0,123.92,12.15).
city('Palsong','ph','Bicol',4566.0,123.27,13.45).
city('Pambuhan','ph','Bicol',2526.0,123.08,13.98).
city('Pamplona','ph','Bicol',4884.0,123.08,13.59).
city('Pandan','ph','Bicol',3712.0,123.62,13.9).
city('Panguiranan','ph','Bicol',274.0,123.32,12.07).
city('Panique','ph','Bicol',4375.0,123.39,12.45).
city('Pantao','ph','Bicol',6864.0,123.33,13.2).
city('Paolbo','ph','Bicol',3447.0,123.25,13.71).
city('Paracale','ph','Bicol',8290.0,122.78,14.28).
city('Parubcan','ph','Bicol',4491.0,123.74,13.71).
city('Pasacao','ph','Bicol',10531.0,123.04,13.51).
city('Paulba','ph','Bicol',2468.0,123.46,13.19).
city('Pawa','ph','Bicol',2123.0,123.89,13.13).
city('Pawican','ph','Bicol',3159.0,123.95,12.08).
city('Pawili','ph','Bicol',2247.0,123.28,13.52).
city('Payo','ph','Bicol',3839.0,124.3,13.91).
city('Pena','ph','Bicol',2537.0,123.93,12.08).
city('Pili','ph','Bicol',23178.0,123.28,13.56).
city('Pinit','ph','Bicol',3281.0,123.27,13.55).
city('Pio Duran','ph','Bicol',13249.0,123.45,13.03).
city('Placer','ph','Bicol',5969.0,123.92,11.87).
city('Ponso','ph','Bicol',4574.0,123.52,13.29).
city('Potot','ph','Bicol',2529.0,123.43,12.2).
city('Puro','ph','Bicol',5442.0,123.39,12.49).
city('Putiao','ph','Bicol',2303.0,123.72,13.02).
city('Quezon','ph','Bicol',2198.0,123.95,12.6).
city('Quitang','ph','Bicol',2055.0,123.05,13.55).
city('Ragay','ph','Bicol',9000.0,122.79,13.82).
city('Rapu-Rapu','ph','Bicol',4647.0,124.13,13.19).
city('Rawis','ph','Bicol',4551.0,123.38,13.32).
city('Recodo','ph','Bicol',2160.0,123.72,11.96).
city('Rizal','ph','Bicol',5171.0,124.03,12.94).
city('Sabang','ph','Bicol',2542.0,123.25,13.97).
city('Sagpon','ph','Bicol',6849.0,123.73,13.15).
city('Sagurong','ph','Bicol',2530.0,123.37,13.59).
city('Salingogon','ph','Bicol',2338.0,123.19,13.44).
city('Salogon','ph','Bicol',2239.0,123.52,13.65).
city('Salvacion','ph','Bicol',2573.0,123.49,13.38).
city('San Agustin','ph','Bicol',2236.0,123.27,13.57).
city('San Andres','ph','Bicol',2249.0,123.78,13.26).
city('San Antonio','ph','Bicol',4374.0,123.43,13.36).
city('San Felipe','ph','Bicol',3090.0,122.93,14.02).
city('San Fernando','ph','Bicol',6278.0,123.46,13.03).
city('San Francisco','ph','Bicol',2533.0,123.82,13.03).
city('San Gabriel','ph','Bicol',5065.0,123.1,13.57).
city('San Isidro','ph','Bicol',2994.0,123.47,13.34).
city('San Jacinto','ph','Bicol',7637.0,123.73,12.57).
city('San Jose','ph','Bicol',6255.0,123.37,13.48).
city('San Juan','ph','Bicol',2250.0,123.36,13.4).
city('San Lucas','ph','Bicol',2268.0,123.19,13.71).
city('San Miguel','ph','Bicol',3149.0,123.4,13.42).
city('San Pascual','ph','Bicol',5939.0,122.98,13.13).
city('San Pedro','ph','Bicol',2318.0,124.0,12.02).
city('San Rafael','ph','Bicol',3201.0,123.42,13.06).
city('San Ramon','ph','Bicol',2766.0,123.29,13.67).
city('San Roque','ph','Bicol',4362.0,123.53,13.37).
city('San Sebastian','ph','Bicol',2101.0,123.59,13.73).
city('San Vicente','ph','Bicol',3168.0,123.31,13.5).
city('Santa Cruz','ph','Bicol',2070.0,124.03,12.9).
city('Santa Elena','ph','Bicol',14641.0,122.38,14.17).
city('Santa Justina','ph','Bicol',5712.0,123.49,13.4).
city('Santa Magdalena','ph','Bicol',3913.0,124.11,12.65).
city('Santa Rosa Sur','ph','Bicol',2295.0,122.72,14.26).
city('Santa Teresita','ph','Bicol',2281.0,123.44,13.49).
city('Santo Domingo','ph','Bicol',3726.0,123.16,13.75).
city('Santo Nino','ph','Bicol',2040.0,123.97,13.1).
city('Sapa','ph','Bicol',2246.0,123.64,12.88).
city('Sinuknipan','ph','Bicol',2533.0,122.63,13.89).
city('Sogod','ph','Bicol',2960.0,123.32,13.83).
city('Sorsogon','ph','Bicol',81419.0,124.01,12.98).
city('Sugcad','ph','Bicol',3000.0,123.7,13.37).
city('Sugod','ph','Bicol',2080.0,124.08,12.99).
city('Tagas','ph','Bicol',15292.0,123.72,13.17).
city('Tagoytoy','ph','Bicol',2106.0,123.68,13.42).
city('Talaongan','ph','Bicol',2951.0,124.13,12.68).
city('Talisay','ph','Bicol',7544.0,122.92,14.14).
city('Talobatib','ph','Bicol',3459.0,122.79,14.18).
city('Tambo','ph','Bicol',3122.0,123.27,13.51).
city('Tara','ph','Bicol',2077.0,122.98,13.82).
city('Tigaon','ph','Bicol',12509.0,123.49,13.64).
city('Tigbao','ph','Bicol',2707.0,123.0,12.36).
city('Tigbinan','ph','Bicol',2805.0,122.47,14.18).
city('Tinago','ph','Bicol',4491.0,123.65,13.18).
city('Tinalmud','ph','Bicol',2217.0,122.88,13.58).
city('Tinampo','ph','Bicol',2590.0,123.51,13.23).
city('Tinawagan','ph','Bicol',2632.0,123.48,13.65).
city('Tiwi','ph','Bicol',16826.0,123.68,13.46).
city('Tubli','ph','Bicol',2452.0,124.15,13.93).
city('Tuburan','ph','Bicol',3954.0,123.56,13.24).
city('Tugos','ph','Bicol',3818.0,122.75,14.27).
city('Tulay Na Lupa','ph','Bicol',5693.0,122.79,14.09).
city('Tumalaytay','ph','Bicol',2340.0,123.23,12.28).
city('Umabay','ph','Bicol',3480.0,123.7,12.31).
city('Usab','ph','Bicol',2404.0,123.58,12.33).
city('Uson','ph','Bicol',4395.0,123.78,12.23).
city('Viga','ph','Bicol',4089.0,124.31,13.87).
city('Villahermosa','ph','Bicol',2428.0,123.71,13.05).
city('Vinzons','ph','Bicol',13617.0,122.91,14.18).
city('Abulug','ph','Cagayan Valley',2412.0,121.45,18.45).
city('Abut','ph','Cagayan Valley',2387.0,121.61,17.36).
city('Accusilian','ph','Cagayan Valley',2377.0,121.46,17.76).
city('Afusing','ph','Cagayan Valley',3541.0,121.72,17.87).
city('Aggugaddan','ph','Cagayan Valley',2364.0,121.81,17.7).
city('Alannay','ph','Cagayan Valley',2128.0,121.57,18.05).
city('Alcala','ph','Cagayan Valley',4668.0,121.65,17.91).
city('Alibagu','ph','Cagayan Valley',4446.0,121.87,17.12).
city('Allacapan','ph','Cagayan Valley',3645.0,121.58,18.25).
city('Allinguigan','ph','Cagayan Valley',6297.0,121.93,17.13).
city('Almaguer','ph','Cagayan Valley',3368.0,121.08,16.0).
city('Amulung','ph','Cagayan Valley',2354.0,121.73,17.84).
city('Angadanan','ph','Cagayan Valley',4487.0,121.75,16.76).
city('Antagan','ph','Cagayan Valley',4065.0,121.91,17.28).
city('Aritao','ph','Cagayan Valley',7972.0,121.04,16.3).
city('Atulayan','ph','Cagayan Valley',6374.0,121.68,17.65).
city('Aurora','ph','Cagayan Valley',4500.0,121.64,16.99).
city('Awallan','ph','Cagayan Valley',2144.0,121.94,17.96).
city('Bacnor','ph','Cagayan Valley',2216.0,121.63,16.98).
city('Bagabag','ph','Cagayan Valley',24967.0,121.18,16.5).
city('Bagong Tanza','ph','Cagayan Valley',2404.0,121.61,16.99).
city('Bagu','ph','Cagayan Valley',2120.0,121.36,18.42).
city('Bagumbayan','ph','Cagayan Valley',3113.0,121.56,17.95).
city('Ballesteros','ph','Cagayan Valley',5591.0,121.52,18.41).
city('Bambang','ph','Cagayan Valley',22831.0,121.11,16.38).
city('Bangad','ph','Cagayan Valley',2216.0,121.78,17.49).
city('Banganan','ph','Cagayan Valley',2595.0,121.05,16.32).
city('Banquero','ph','Cagayan Valley',2173.0,121.78,17.02).
city('Basco','ph','Cagayan Valley',7297.0,121.97,20.45).
city('Batal','ph','Cagayan Valley',7274.0,121.6,16.69).
city('Battung','ph','Cagayan Valley',2350.0,121.47,17.68).
city('Bauan','ph','Cagayan Valley',8165.0,121.69,17.72).
city('Belance','ph','Cagayan Valley',2233.0,121.25,16.18).
city('Benito Soliven','ph','Cagayan Valley',4926.0,121.95,16.98).
city('Bidduang','ph','Cagayan Valley',2133.0,121.34,18.47).
city('Binalan','ph','Cagayan Valley',2276.0,121.54,18.32).
city('Binguang','ph','Cagayan Valley',2082.0,121.78,17.46).
city('Bintawan','ph','Cagayan Valley',4971.0,121.19,16.58).
city('Bitag','ph','Cagayan Valley',4006.0,121.85,17.9).
city('Bone','ph','Cagayan Valley',6573.0,121.01,16.26).
city('Buguey','ph','Cagayan Valley',3111.0,121.83,18.29).
city('Buliwao','ph','Cagayan Valley',2380.0,121.23,16.48).
city('Burgos','ph','Cagayan Valley',4360.0,121.72,16.95).
city('Busilac','ph','Cagayan Valley',2814.0,121.12,16.48).
city('Cabagan','ph','Cagayan Valley',25304.0,121.76,17.43).
city('Cabannungan','ph','Cagayan Valley',2147.0,121.85,17.13).
city('Cabaritan','ph','Cagayan Valley',9348.0,121.49,18.42).
city('Cabarroguis','ph','Cagayan Valley',6974.0,121.5,16.58).
city('Cabiraoan','ph','Cagayan Valley',2932.0,122.09,18.34).
city('Cabulay','ph','Cagayan Valley',2829.0,121.51,16.73).
city('Calamagui','ph','Cagayan Valley',2671.0,121.77,17.49).
city('Calantac','ph','Cagayan Valley',2541.0,121.72,17.9).
city('Calaoagan','ph','Cagayan Valley',2471.0,121.71,18.04).
city('Calinaoan','ph','Cagayan Valley',2083.0,121.74,17.36).
city('Calog','ph','Cagayan Valley',2959.0,121.38,18.36).
city('Canapi','ph','Cagayan Valley',2815.0,121.86,17.2).
city('Capissayan','ph','Cagayan Valley',2882.0,121.82,18.05).
city('Carig','ph','Cagayan Valley',2924.0,121.75,17.66).
city('Casambalangan','ph','Cagayan Valley',3281.0,122.12,18.38).
city('Catayauan','ph','Cagayan Valley',3843.0,121.66,18.16).
city('Claveria','ph','Cagayan Valley',10618.0,121.09,18.61).
city('Cordon','ph','Cagayan Valley',4514.0,121.45,16.67).
city('Cullalabo','ph','Cagayan Valley',4907.0,121.7,17.1).
city('Dagupan','ph','Cagayan Valley',2305.0,121.51,17.71).
city('Dalaoig','ph','Cagayan Valley',2485.0,121.72,17.93).
city('Daragutan','ph','Cagayan Valley',2336.0,122.03,17.0).
city('Dassun','ph','Cagayan Valley',6030.0,121.72,17.7).
city('Diadi','ph','Cagayan Valley',2157.0,121.37,16.66).
city('Diamantina','ph','Cagayan Valley',2367.0,121.63,16.92).
city('Dibuluan','ph','Cagayan Valley',2384.0,121.77,16.52).
city('Dicabisagan','ph','Cagayan Valley',3503.0,122.42,17.08).
city('Dicamay','ph','Cagayan Valley',2370.0,122.02,16.7).
city('Diffun','ph','Cagayan Valley',9414.0,121.5,16.6).
city('Divisoria','ph','Cagayan Valley',2068.0,121.77,17.52).
city('Dodan','ph','Cagayan Valley',3002.0,121.8,17.64).
city('Dumabato','ph','Cagayan Valley',2590.0,121.7,16.32).
city('Eden','ph','Cagayan Valley',2136.0,121.6,17.04).
city('Enrile','ph','Cagayan Valley',9650.0,121.7,17.56).
city('Esperanza','ph','Cagayan Valley',2180.0,121.68,17.01).
city('Estefania','ph','Cagayan Valley',2165.0,121.73,17.8).
city('Faire','ph','Cagayan Valley',4916.0,121.57,17.89).
city('Furao','ph','Cagayan Valley',2344.0,121.81,17.04).
city('Gadu','ph','Cagayan Valley',2902.0,121.62,17.64).
city('Gammad','ph','Cagayan Valley',2639.0,121.75,17.71).
city('Gamu','ph','Cagayan Valley',5545.0,121.83,17.05).
city('Gappal','ph','Cagayan Valley',2495.0,121.82,16.84).
city('Gattaran','ph','Cagayan Valley',3613.0,121.64,18.06).
city('Gonzaga','ph','Cagayan Valley',7228.0,122.0,18.27).
city('Ibung','ph','Cagayan Valley',4462.0,121.19,16.61).
city('Imurong','ph','Cagayan Valley',3274.0,121.74,17.75).
city('Ineangan','ph','Cagayan Valley',3670.0,121.09,16.32).
city('Iraga','ph','Cagayan Valley',3937.0,121.65,17.7).
city('Jones','ph','Cagayan Valley',5227.0,121.71,16.56).
city('La Paz','ph','Cagayan Valley',4017.0,121.67,16.91).
city('Lallayug','ph','Cagayan Valley',2102.0,121.44,17.7).
city('Lanna','ph','Cagayan Valley',3439.0,121.7,17.7).
city('Lapi','ph','Cagayan Valley',2849.0,121.9,17.72).
city('Larion','ph','Cagayan Valley',3010.0,121.77,17.63).
city('Lasam','ph','Cagayan Valley',6352.0,121.6,18.07).
city('Lublub','ph','Cagayan Valley',2771.0,121.31,15.8).
city('Luna','ph','Cagayan Valley',2616.0,121.73,16.97).
city('Mabasa','ph','Cagayan Valley',2242.0,121.13,16.32).
city('Mabini','ph','Cagayan Valley',4458.0,121.74,17.1).
city('Mabuttal','ph','Cagayan Valley',2342.0,121.51,18.38).
city('Maddarulug','ph','Cagayan Valley',2186.0,121.68,17.6).
city('Maddela','ph','Cagayan Valley',9751.0,121.69,16.35).
city('Magalalag','ph','Cagayan Valley',2625.0,121.74,17.58).
city('Magapit','ph','Cagayan Valley',2624.0,121.67,18.11).
city('Magdalena','ph','Cagayan Valley',2146.0,121.77,16.93).
city('Maguilling','ph','Cagayan Valley',2892.0,121.5,17.75).
city('Malasin','ph','Cagayan Valley',2888.0,121.44,16.56).
city('Mallig','ph','Cagayan Valley',3767.0,121.68,17.14).
city('Maluno','ph','Cagayan Valley',2493.0,121.95,17.0).
city('Manaring','ph','Cagayan Valley',2114.0,121.92,17.18).
city('Manga','ph','Cagayan Valley',2211.0,121.86,17.7).
city('Masaya','ph','Cagayan Valley',5524.0,121.75,16.52).
city('Masipi','ph','Cagayan Valley',3086.0,121.85,17.37).
city('Maxingal','ph','Cagayan Valley',2323.0,121.67,18.21).
city('Minallo','ph','Cagayan Valley',2490.0,121.85,16.99).
city('Minanga','ph','Cagayan Valley',2151.0,121.74,17.6).
city('Minante','ph','Cagayan Valley',6697.0,121.76,16.9).
city('Minuri','ph','Cagayan Valley',2546.0,121.86,16.54).
city('Mozzozzin','ph','Cagayan Valley',2559.0,121.75,17.45).
city('Mungo','ph','Cagayan Valley',4591.0,121.48,17.71).
city('Munoz','ph','Cagayan Valley',5198.0,121.62,17.16).
city('Nabannagan','ph','Cagayan Valley',3596.0,121.54,18.07).
city('Nagtipunan','ph','Cagayan Valley',5682.0,121.6,16.22).
city('Naguilian','ph','Cagayan Valley',8560.0,121.84,17.03).
city('Namuac','ph','Cagayan Valley',3037.0,121.17,18.61).
city('Natappian','ph','Cagayan Valley',11867.0,121.71,17.68).
city('Paddaya','ph','Cagayan Valley',3228.0,121.76,18.32).
city('Palagao','ph','Cagayan Valley',2953.0,121.7,18.04).
city('Pangal','ph','Cagayan Valley',2710.0,121.66,16.62).
city('Pata','ph','Cagayan Valley',2224.0,121.52,17.72).
city('Pattao','ph','Cagayan Valley',3222.0,121.81,18.25).
city('Penablanca','ph','Cagayan Valley',2983.0,121.79,17.63).
city('Piat','ph','Cagayan Valley',5958.0,121.48,17.79).
city('Pilig','ph','Cagayan Valley',2336.0,121.77,17.34).
city('Pinoma','ph','Cagayan Valley',3305.0,121.72,16.88).
city('Punta','ph','Cagayan Valley',4435.0,121.74,18.33).
city('Quezon','ph','Cagayan Valley',7283.0,121.44,16.91).
city('Quibal','ph','Cagayan Valley',2376.0,121.82,17.73).
city('Ragan','ph','Cagayan Valley',4217.0,121.78,17.31).
city('Ramon','ph','Cagayan Valley',36307.0,121.53,16.78).
city('Ramos','ph','Cagayan Valley',3042.0,121.61,16.7).
city('Reina Mercedes','ph','Cagayan Valley',6228.0,121.83,16.99).
city('Rizal','ph','Cagayan Valley',2815.0,121.56,16.72).
city('Saguday','ph','Cagayan Valley',7464.0,121.61,16.52).
city('Salinas','ph','Cagayan Valley',2506.0,121.02,16.37).
city('Salinungan','ph','Cagayan Valley',8110.0,121.62,16.87).
city('San Antonio','ph','Cagayan Valley',2649.0,121.45,16.81).
city('San Bernardo','ph','Cagayan Valley',2366.0,121.75,17.4).
city('San Fernando','ph','Cagayan Valley',2084.0,121.13,16.39).
city('San Guillermo','ph','Cagayan Valley',3927.0,121.8,16.77).
city('San Jose','ph','Cagayan Valley',5219.0,121.74,17.52).
city('San Juan','ph','Cagayan Valley',2517.0,121.74,17.41).
city('San Luis','ph','Cagayan Valley',2176.0,121.83,16.97).
city('San Manuel','ph','Cagayan Valley',9865.0,121.64,17.02).
city('San Mariano','ph','Cagayan Valley',12441.0,122.02,16.98).
city('San Mateo','ph','Cagayan Valley',2090.0,121.75,17.14).
city('San Pedro','ph','Cagayan Valley',3027.0,121.88,17.2).
city('San Vicente','ph','Cagayan Valley',3269.0,122.15,18.51).
city('Sanchez-Mira','ph','Cagayan Valley',5046.0,121.22,8.52).
city('Sandiat','ph','Cagayan Valley',4910.0,121.67,17.07).
city('Santa Ana','ph','Cagayan Valley',6315.0,122.14,18.47).
city('Santa Cruz','ph','Cagayan Valley',2295.0,121.32,18.52).
city('Santa Maria','ph','Cagayan Valley',3180.0,121.71,17.81).
city('Santa Teresita','ph','Cagayan Valley',2576.0,121.88,18.25).
city('Santiago','ph','Cagayan Valley',108427.0,121.54,16.69).
city('Santo Domingo','ph','Cagayan Valley',2640.0,121.75,17.16).
city('Santo Tomas','ph','Cagayan Valley',2772.0,121.77,17.4).
city('Siempre Viva','ph','Cagayan Valley',3904.0,121.64,17.23).
city('Silawit','ph','Cagayan Valley',3084.0,121.76,16.88).
city('Simanu','ph','Cagayan Valley',2617.0,121.84,17.49).
city('Simimbaan','ph','Cagayan Valley',2854.0,121.58,17.12).
city('Sinamar','ph','Cagayan Valley',6012.0,121.57,16.9).
city('Sindon','ph','Cagayan Valley',2418.0,122.02,17.06).
city('Solano','ph','Cagayan Valley',36208.0,121.18,16.53).
city('Soyung','ph','Cagayan Valley',5418.0,121.67,16.7).
city('Taguing','ph','Cagayan Valley',2081.0,121.76,17.94).
city('Tapel','ph','Cagayan Valley',2548.0,122.02,18.3).
city('Tuao','ph','Cagayan Valley',2200.0,121.45,17.73).
city('Tuguegarao','ph','Cagayan Valley',116665.0,121.72,17.62).
city('Tumauini','ph','Cagayan Valley',3573.0,121.81,17.27).
city('Tupang','ph','Cagayan Valley',2213.0,121.65,17.92).
city('Uddiawan','ph','Cagayan Valley',3112.0,121.15,16.56).
city('Ugac','ph','Cagayan Valley',2208.0,121.72,17.61).
city('Ugad','ph','Cagayan Valley',2166.0,121.8,17.29).
city('Upi','ph','Cagayan Valley',5647.0,121.84,17.08).
city('Yeban','ph','Cagayan Valley',3557.0,121.94,17.02).
city('Adlay','ph','Caraga',2548.0,125.9,9.41).
city('Agay','ph','Caraga',3977.0,125.59,9.05).
city('Albor','ph','Caraga',3571.0,125.57,10.2).
city('Alegria','ph','Caraga',5235.0,125.8,8.99).
city('Alubijid','ph','Caraga',2700.0,125.43,8.96).
city('Amaga','ph','Caraga',2230.0,126.07,8.53).
city('Anticala','ph','Caraga',3246.0,125.65,9.0).
city('Aras-Asan','ph','Caraga',5099.0,126.3,8.89).
city('Aurora','ph','Caraga',2681.0,125.84,8.59).
city('Bacolod','ph','Caraga',2171.0,126.29,8.93).
city('Bacuag','ph','Caraga',5420.0,125.64,9.61).
city('Bahbah','ph','Caraga',28643.0,125.91,8.61).
city('Balangbalang','ph','Caraga',2135.0,125.62,9.06).
city('Bancasi','ph','Caraga',3607.0,125.47,8.97).
city('Bangonay','ph','Caraga',2643.0,125.55,9.31).
city('Barcelona','ph','Caraga',3541.0,126.43,8.16).
city('Barobo','ph','Caraga',9893.0,126.12,8.54).
city('Basa','ph','Caraga',2323.0,126.06,8.07).
city('Basag','ph','Caraga',2799.0,125.62,8.92).
city('Bayugan','ph','Caraga',40561.0,125.77,8.76).
city('Bigaan','ph','Caraga',2744.0,126.28,8.32).
city('Binucayan','ph','Caraga',2875.0,125.72,8.25).
city('Bislig','ph','Caraga',68892.0,126.32,8.22).
city('Borbon','ph','Caraga',21.0,125.89,8.48).
city('Brasilisa','ph','Caraga',2727.0,125.48,9.78).
city('Buenavista','ph','Caraga',2564.0,126.16,9.12).
city('Bunawan','ph','Caraga',15471.0,125.99,8.17).
city('Burgos','ph','Caraga',3513.0,126.19,9.27).
city('Butuan','ph','Caraga',250200.0,125.52,8.93).
city('Cadanglasan','ph','Caraga',5737.0,126.37,7.92).
city('Cagdianao','ph','Caraga',2676.0,125.67,9.92).
city('Calamba','ph','Caraga',2713.0,125.59,9.1).
city('Caloc-an','ph','Caraga',3390.0,125.53,9.05).
city('Cantapoy','ph','Caraga',2259.0,125.44,9.49).
city('Cantilan','ph','Caraga',9408.0,125.98,9.33).
city('Capalayan','ph','Caraga',2151.0,125.54,9.74).
city('Carmen','ph','Caraga',3826.0,125.66,9.11).
city('Carrascal','ph','Caraga',4385.0,125.95,9.37).
city('Causwagan','ph','Caraga',2225.0,125.84,8.45).
city('Claver','ph','Caraga',5906.0,125.73,9.57).
city('Comagascas','ph','Caraga',2914.0,125.56,9.14).
city('Cortes','ph','Caraga',3026.0,126.19,9.28).
city('Cuevas','ph','Caraga',2243.0,126.09,8.02).
city('Culit','ph','Caraga',2881.0,125.36,8.95).
city('Dapa','ph','Caraga',8822.0,126.05,9.76).
city('Del Carmen','ph','Caraga',4276.0,125.97,9.87).
city('Del Pilar','ph','Caraga',2511.0,125.58,9.15).
city('Dinagat','ph','Caraga',2600.0,125.59,9.96).
city('Esperanza','ph','Caraga',6193.0,125.65,8.68).
city('Gamut','ph','Caraga',2863.0,126.21,8.77).
city('Gigaquit','ph','Caraga',3064.0,125.7,9.59).
city('Guadalupe','ph','Caraga',3381.0,125.71,8.58).
city('Guinabs','ph','Caraga',4358.0,125.42,8.9).
city('Hinatuan','ph','Caraga',10055.0,126.33,8.37).
city('Ipil','ph','Caraga',3333.0,125.44,9.79).
city('Jabonga','ph','Caraga',3245.0,125.52,9.34).
city('Jagupit','ph','Caraga',2157.0,125.56,9.24).
city('Javier','ph','Caraga',2276.0,126.09,8.49).
city('Kauswagan','ph','Caraga',2939.0,125.75,8.52).
city('Kinabjangan','ph','Caraga',2626.0,125.36,8.97).
city('Kitcharao','ph','Caraga',7213.0,125.57,9.46).
city('La Paz','ph','Caraga',2966.0,126.03,8.63).
city('La Union','ph','Caraga',4758.0,125.54,9.09).
city('Lanuza','ph','Caraga',2033.0,126.06,9.23).
city('Lapinigan','ph','Caraga',4328.0,125.98,8.42).
city('Lianga','ph','Caraga',13623.0,126.09,8.63).
city('Libas','ph','Caraga',3373.0,125.98,9.88).
city('Libertad','ph','Caraga',5800.0,126.03,8.11).
city('Lingig','ph','Caraga',6400.0,126.41,8.04).
city('Loreto','ph','Caraga',5564.0,125.71,9.27).
city('Los Angeles','ph','Caraga',4054.0,125.61,9.01).
city('Los Arcos','ph','Caraga',2234.0,125.99,8.63).
city('Loyola','ph','Caraga',2673.0,126.33,8.34).
city('Luna','ph','Caraga',7799.0,125.5,9.73).
city('Mabahin','ph','Caraga',2327.0,126.17,9.19).
city('Mabua','ph','Caraga',2075.0,125.44,9.81).
city('Madrid','ph','Caraga',3119.0,125.96,9.26).
city('Magallanes','ph','Caraga',6637.0,125.52,9.02).
city('Mainit','ph','Caraga',5520.0,125.52,9.54).
city('Manapa','ph','Caraga',3919.0,125.44,8.98).
city('Manila de Bugabus','ph','Caraga',5351.0,125.57,8.81).
city('Marihatag','ph','Caraga',3829.0,126.3,8.79).
city('Mat-i','ph','Caraga',3795.0,125.47,9.73).
city('Matabao','ph','Caraga',3570.0,125.4,8.96).
city('Maygatasan','ph','Caraga',4014.0,125.72,8.71).
city('Nasipit','ph','Caraga',9407.0,125.29,8.97).
city('Panikian','ph','Caraga',2103.0,125.94,9.33).
city('Parang','ph','Caraga',3491.0,125.94,9.28).
city('Patin-ay','ph','Caraga',7263.0,125.94,8.55).
city('Pilar','ph','Caraga',2392.0,126.1,9.87).
city('Placer','ph','Caraga',10443.0,125.6,9.65).
city('Punta','ph','Caraga',3909.0,125.34,8.99).
city('Purok','ph','Caraga',4278.0,126.16,9.78).
city('Rizal','ph','Caraga',2836.0,125.4,8.93).
city('Rosario','ph','Caraga',8180.0,126.02,8.35).
city('Salvacion','ph','Caraga',3496.0,125.96,8.7).
city('San Benito','ph','Caraga',2334.0,126.01,9.96).
city('San Francisco','ph','Caraga',2279.0,125.49,9.53).
city('San Isidro','ph','Caraga',2896.0,125.83,9.03).
city('San Jose','ph','Caraga',6622.0,125.98,8.95).
city('San Luis','ph','Caraga',7109.0,125.73,8.49).
city('San Miguel','ph','Caraga',2983.0,125.95,8.97).
city('San Roque','ph','Caraga',2094.0,125.56,9.42).
city('San Vicente','ph','Caraga',2126.0,126.09,8.54).
city('Sanghan','ph','Caraga',2508.0,125.57,9.09).
city('Santa Ana','ph','Caraga',2452.0,125.56,9.19).
city('Santa Josefa','ph','Caraga',4164.0,126.03,7.99).
city('Santa Maria','ph','Caraga',2454.0,126.31,8.01).
city('Santiago','ph','Caraga',9302.0,125.65,8.28).
city('Santo Tomas','ph','Caraga',3055.0,125.8,8.19).
city('Sapao','ph','Caraga',2284.0,126.04,10.02).
city('Sibagat','ph','Caraga',4865.0,125.7,8.82).
city('Sinobong','ph','Caraga',3335.0,125.93,8.07).
city('Sison','ph','Caraga',3171.0,125.53,9.66).
city('Socorro','ph','Caraga',9742.0,125.97,9.62).
city('Surigao','ph','Caraga',88581.0,125.47,9.8).
city('Tagana-an','ph','Caraga',4386.0,125.59,9.7).
city('Tagbina','ph','Caraga',10673.0,126.17,8.45).
city('Tagcatong','ph','Caraga',2907.0,125.26,9.0).
city('Tago','ph','Caraga',6300.0,126.23,9.02).
city('Talacogon','ph','Caraga',15581.0,125.78,8.46).
city('Taligaman','ph','Caraga',7430.0,125.66,8.9).
city('Talisay','ph','Caraga',2200.0,125.62,9.82).
city('Tandag','ph','Caraga',29010.0,126.2,9.08).
city('Tidman','ph','Caraga',3154.0,126.34,8.3).
city('Tigao','ph','Caraga',2077.0,126.18,9.21).
city('Trento','ph','Caraga',15916.0,126.06,8.05).
city('Tubajon','ph','Caraga',2906.0,125.56,10.33).
city('Tubay','ph','Caraga',7946.0,125.52,9.17).
city('Tungao','ph','Caraga',8910.0,125.57,8.78).
city('Unidad','ph','Caraga',3344.0,126.23,8.54).
city('Union','ph','Caraga',2368.0,126.11,9.76).
city('Veruela','ph','Caraga',18114.0,125.95,8.07).
city('Abucay','ph','Central Luzon',35508.0,120.54,14.72).
city('Acli','ph','Central Luzon',2555.0,120.64,15.13).
city('Agbannawag','ph','Central Luzon',3782.0,121.08,15.68).
city('Akle','ph','Central Luzon',3381.0,121.07,15.05).
city('Alas-asin','ph','Central Luzon',6595.0,120.56,14.43).
city('Aliaga','ph','Central Luzon',34020.0,120.83,15.5).
city('Almendras','ph','Central Luzon',2626.0,120.7,15.28).
city('Alua','ph','Central Luzon',4943.0,120.88,15.32).
city('Amacalan','ph','Central Luzon',2693.0,120.62,15.58).
city('Amucao','ph','Central Luzon',2478.0,120.69,15.47).
city('Amungan','ph','Central Luzon',12357.0,119.96,15.37).
city('Anao','ph','Central Luzon',4669.0,120.69,15.14).
city('Angat','ph','Central Luzon',41235.0,121.03,14.93).
city('Angeles','ph','Central Luzon',298948.0,120.55,15.15).
city('Antipolo','ph','Central Luzon',3486.0,121.19,15.62).
city('Apalit','ph','Central Luzon',77418.0,120.77,14.95).
city('Arenas','ph','Central Luzon',4108.0,120.68,15.17).
city('Armenia','ph','Central Luzon',3468.0,120.57,15.43).
city('Bacabac','ph','Central Luzon',2190.0,120.42,15.73).
city('Bacsay','ph','Central Luzon',2615.0,120.33,15.65).
city('Baculong','ph','Central Luzon',3655.0,120.64,15.53).
city('Bagac','ph','Central Luzon',3969.0,120.39,14.6).
city('Bagong Barrio','ph','Central Luzon',4205.0,120.95,14.9).
city('Bagong Sikat','ph','Central Luzon',2665.0,121.31,15.48).
city('Bagting','ph','Central Luzon',19206.0,121.18,15.58).
city('Bahay Pare','ph','Central Luzon',9726.0,120.88,15.03).
city('Balagtas','ph','Central Luzon',59826.0,120.87,14.82).
city('Balaoang','ph','Central Luzon',3724.0,120.51,15.66).
city('Balas','ph','Central Luzon',2517.0,120.61,15.03).
city('Balasing','ph','Central Luzon',4768.0,121.01,14.85).
city('Balayang','ph','Central Luzon',2923.0,120.69,15.55).
city('Balete','ph','Central Luzon',4360.0,120.64,15.65).
city('Balingcanaway','ph','Central Luzon',5870.0,120.69,15.48).
city('Balite','ph','Central Luzon',2564.0,120.78,14.9).
city('Baliuag','ph','Central Luzon',135627.0,120.89,14.96).
city('Baloc','ph','Central Luzon',10566.0,120.89,15.64).
city('Baloy','ph','Central Luzon',2308.0,120.78,15.81).
city('Balsic','ph','Central Luzon',5661.0,120.48,14.86).
city('Balucuc','ph','Central Luzon',9214.0,120.84,14.96).
city('Balut','ph','Central Luzon',2348.0,120.55,14.68).
city('Balutu','ph','Central Luzon',3539.0,120.7,15.3).
city('Bamban','ph','Central Luzon',2511.0,120.33,15.67).
city('Banawang','ph','Central Luzon',2306.0,120.39,14.61).
city('Bangad','ph','Central Luzon',4498.0,121.03,15.5).
city('Bani','ph','Central Luzon',3066.0,119.92,15.57).
city('Baquero','ph','Central Luzon',5145.0,120.55,15.72).
city('Batasan','ph','Central Luzon',4966.0,120.93,15.15).
city('Batitang','ph','Central Luzon',3306.0,120.8,15.42).
city('Beddeng','ph','Central Luzon',2565.0,120.09,14.98).
city('Biay','ph','Central Luzon',2257.0,119.91,15.74).
city('Bibiclat','ph','Central Luzon',7039.0,120.87,15.53).
city('Bicos','ph','Central Luzon',3962.0,121.04,15.66).
city('Bilad','ph','Central Luzon',2778.0,120.44,15.73).
city('Bobon','ph','Central Luzon',4150.0,120.39,15.67).
city('Bocaue','ph','Central Luzon',98649.0,120.92,14.82).
city('Bolitoc','ph','Central Luzon',3131.0,119.88,15.74).
city('Bongabon','ph','Central Luzon',36168.0,121.14,15.63).
city('Botolan','ph','Central Luzon',22994.0,120.02,15.29).
city('Buenlag','ph','Central Luzon',2545.0,120.57,15.63).
city('Buensuceso','ph','Central Luzon',3729.0,120.67,15.2).
city('Bulaon','ph','Central Luzon',131818.0,120.67,15.09).
city('Bularit','ph','Central Luzon',2512.0,120.62,15.57).
city('Bulawen','ph','Central Luzon',3612.0,119.95,15.42).
city('Bulihan','ph','Central Luzon',4869.0,120.9,14.88).
city('Buliran','ph','Central Luzon',3115.0,120.91,15.42).
city('Bulualto','ph','Central Luzon',2671.0,120.95,15.22).
city('Bunol','ph','Central Luzon',3021.0,120.84,15.67).
city('Burgos','ph','Central Luzon',11494.0,120.68,15.76).
city('Bustos','ph','Central Luzon',42139.0,120.92,14.96).
city('Cabanatuan','ph','Central Luzon',220095.0,120.97,15.5).
city('Cabangan','ph','Central Luzon',3092.0,120.06,15.16).
city('Cabayaoasan','ph','Central Luzon',2798.0,120.55,15.67).
city('Cabcaben','ph','Central Luzon',5948.0,120.59,14.45).
city('Cafe','ph','Central Luzon',2339.0,120.72,15.34).
city('Calaba','ph','Central Luzon',4229.0,120.87,15.3).
city('Calancuasan','ph','Central Luzon',2453.0,120.65,15.82).
city('Calantas','ph','Central Luzon',4519.0,120.52,15.02).
city('Calayaan','ph','Central Luzon',2285.0,120.5,15.57).
city('Calibutbut','ph','Central Luzon',5282.0,120.62,15.1).
city('Calingcuan','ph','Central Luzon',3208.0,120.58,15.33).
city('Caluluan','ph','Central Luzon',4121.0,120.72,15.38).
city('Calumpang','ph','Central Luzon',4433.0,121.12,15.12).
city('Calumpit','ph','Central Luzon',91865.0,120.77,14.91).
city('Cama Juan','ph','Central Luzon',2357.0,120.77,15.38).
city('Camachile','ph','Central Luzon',2766.0,120.58,14.64).
city('Camias','ph','Central Luzon',7412.0,120.96,15.18).
city('Candating','ph','Central Luzon',4307.0,120.81,15.15).
city('Cardona','ph','Central Luzon',2594.0,120.58,15.58).
city('Carmen','ph','Central Luzon',2835.0,120.83,15.45).
city('Carranglan','ph','Central Luzon',11017.0,121.06,15.96).
city('Castillejos','ph','Central Luzon',27301.0,120.2,14.93).
city('Cavite','ph','Central Luzon',2402.0,120.78,15.68).
city('Cawayan Bugtong','ph','Central Luzon',3605.0,120.8,15.64).
city('Comillas','ph','Central Luzon',4809.0,120.72,15.4).
city('Concepcion','ph','Central Luzon',23910.0,120.75,15.33).
city('Conversion','ph','Central Luzon',2853.0,121.13,15.9).
city('Culianin','ph','Central Luzon',7565.0,120.9,14.91).
city('Culubasa','ph','Central Luzon',2268.0,120.65,15.14).
city('Cutcut','ph','Central Luzon',7143.0,120.67,15.47).
city('Dampol','ph','Central Luzon',2796.0,120.81,14.88).
city('Del Carmen','ph','Central Luzon',4053.0,120.53,14.98).
city('Del Pilar','ph','Central Luzon',37329.0,120.7,15.03).
city('Diliman','ph','Central Luzon',3792.0,120.95,15.03).
city('Dolores','ph','Central Luzon',4522.0,120.53,15.1).
city('Dumarais','ph','Central Luzon',3587.0,120.69,15.44).
city('Entablado','ph','Central Luzon',5202.0,120.86,15.29).
city('Estacion','ph','Central Luzon',4478.0,120.61,15.7).
city('Estipona','ph','Central Luzon',4351.0,120.64,15.59).
city('Estrella','ph','Central Luzon',4463.0,121.03,15.75).
city('Fort Magsaysay','ph','Central Luzon',5990.0,121.08,15.43).
city('Gabaldon','ph','Central Luzon',7259.0,121.34,15.45).
city('Gapan','ph','Central Luzon',79278.0,120.94,15.31).
city('General Luna','ph','Central Luzon',2774.0,121.0,15.62).
city('General Mamerto Natividad','ph','Central Luzon',18393.0,121.05,15.6).
city('Guagua','ph','Central Luzon',9519.0,120.63,14.97).
city('Gu','ph','Central Luzon',76613.0,120.88,14.83).
city('Guisguis','ph','Central Luzon',3128.0,119.98,15.79).
city('Gutad','ph','Central Luzon',2623.0,120.48,14.94).
city('Hagonoy','ph','Central Luzon',123789.0,120.69,14.83).
city('Hermosa','ph','Central Luzon',33714.0,120.51,14.83).
city('Iba','ph','Central Luzon',15755.0,120.2,15.39).
city('Joson','ph','Central Luzon',3462.0,120.98,15.95).
city('Kalawakan','ph','Central Luzon',3463.0,121.08,15.0).
city('Lambakin','ph','Central Luzon',6094.0,120.87,15.06).
city('Lanat','ph','Central Luzon',2178.0,120.6,15.8).
city('Laug','ph','Central Luzon',3157.0,120.75,15.05).
city('Lawang Kupang','ph','Central Luzon',2616.0,120.86,15.35).
city('Lennec','ph','Central Luzon',3142.0,120.73,15.69).
city('Licab','ph','Central Luzon',6783.0,120.76,15.55).
city('Liciada','ph','Central Luzon',3982.0,120.93,14.9).
city('Ligaya','ph','Central Luzon',5300.0,121.29,15.51).
city('Limay','ph','Central Luzon',52823.0,120.6,14.56).
city('Liozon','ph','Central Luzon',3245.0,119.93,15.4).
city('Lipay','ph','Central Luzon',2717.0,119.91,15.46).
city('Llanera','ph','Central Luzon',5121.0,121.02,15.67).
city('Loma de Gato','ph','Central Luzon',21990.0,121.0,14.78).
city('Lomboy','ph','Central Luzon',3282.0,120.72,15.49).
city('Lourdes','ph','Central Luzon',2370.0,120.85,15.02).
city('Lucapon','ph','Central Luzon',5767.0,119.93,15.7).
city('Lupao','ph','Central Luzon',11000.0,120.9,15.88).
city('Maasim','ph','Central Luzon',3577.0,121.03,14.99).
city('Mababanaba','ph','Central Luzon',3733.0,120.45,15.5).
city('Mabalacat','ph','Central Luzon',188057.0,120.57,15.22).
city('Mabayo','ph','Central Luzon',2843.0,120.28,14.73).
city('Mabilang','ph','Central Luzon',2229.0,120.48,15.67).
city('Mabilog','ph','Central Luzon',2581.0,120.67,15.4).
city('Mabini','ph','Central Luzon',7810.0,120.98,15.6).
city('Macapsing','ph','Central Luzon',2282.0,121.13,15.68).
city('Macarse','ph','Central Luzon',2311.0,120.77,15.42).
city('Macatbong','ph','Central Luzon',2727.0,121.08,15.51).
city('Magliman','ph','Central Luzon',2505.0,120.66,15.03).
city('Magtanggol','ph','Central Luzon',2204.0,120.93,15.77).
city('Maguinao','ph','Central Luzon',2978.0,120.93,15.03).
city('Malabon','ph','Central Luzon',2640.0,119.98,15.63).
city('Malacampa','ph','Central Luzon',4537.0,120.41,15.65).
city('Maligaya','ph','Central Luzon',4275.0,120.89,15.67).
city('Malolos','ph','Central Luzon',198763.0,120.81,14.85).
city('Maloma','ph','Central Luzon',4430.0,120.06,15.11).
city('Maluid','ph','Central Luzon',2726.0,120.65,15.57).
city('Malusac','ph','Central Luzon',2162.0,120.62,14.85).
city('Mambog','ph','Central Luzon',3726.0,120.02,15.32).
city('Mamonit','ph','Central Luzon',2178.0,120.4,15.59).
city('Manacsac','ph','Central Luzon',2313.0,120.78,15.58).
city('Manatal','ph','Central Luzon',2290.0,120.9,14.82).
city('Mandili','ph','Central Luzon',4532.0,120.9,15.17).
city('Mangga','ph','Central Luzon',2247.0,120.91,15.25).
city('Manibaug','ph','Central Luzon',24618.0,120.56,15.11).
city('Mapalacsiao','ph','Central Luzon',5419.0,120.65,15.43).
city('Mapalad','ph','Central Luzon',3353.0,121.1,15.43).
city('Mapaniqui','ph','Central Luzon',4200.0,120.92,15.1).
city('Maquiapo','ph','Central L',2307.0,120.55,14.98).
city('Marawa','ph','Central Luzon',3812.0,120.83,15.4).
city('Mariveles','ph','Central Luzon',84569.0,120.49,14.44).
city('Masalipit','ph','Central Luzon',2532.0,121.04,15.15).
city('Masinloc','ph','Central Luzon',28041.0,119.95,15.54).
city('Matayumtayum','ph','Central Luzon',2730.0,120.71,15.52).
city('Maturanoc','ph','Central Luzon',4912.0,120.8,15.67).
city('Mayantoc','ph','Central Luzon',6250.0,120.38,15.62).
city('Meycauayan','ph','Central Luzon',184838.0,120.91,14.73).
city('Minalin','ph','Central Luzon',13528.0,120.69,14.97).
city('Moriones','ph','Central Luzon',2916.0,120.47,15.45).
city('Morong','ph','Central Luzon',16117.0,120.27,14.68).
city('Motrico','ph','Central Luzon',2947.0,120.68,15.41).
city('Murcia','ph','Central Luzon',5138.0,120.6,15.4).
city('Nagpandayan','ph','Central Luzon',3140.0,120.77,15.6).
city('Nambalan','ph','Central Luzon',2265.0,120.46,15.6).
city('Nampicuan','ph','Central Luzon',6058.0,120.64,15.74).
city('Nancamarinan','ph','Central Luzon',3565.0,120.54,15.68).
city('Nieves','ph','Central Luzon',8617.0,120.95,15.33).
city('Niugan','ph','Central Luzon',4014.0,120.97,14.95).
city('ODonnell','ph','Central Luzon',12218.0,120.46,15.35).
city('Obando','ph','Central Luzon',59924.0,120.94,14.71).
city('Olongapo','ph','Central Luzon',219999.0,120.28,14.82).
city('Orion','ph','Central Luzon',46991.0,120.58,14.62).
city('Paco Roman','ph','Central Luzon',2770.0,121.09,15.66).
city('Padapada','ph','Central Luzon',3016.0,120.55,15.57).
city('Pag-asa','ph','Central Luzon',3590.0,120.55,14.7).
city('Paitan','ph','Central Luzon',2586.0,120.73,15.83).
city('Palauig','ph','Central Luzon',2944.0,119.91,15.43).
city('Palayan','ph','Central Luzon',23742.0,121.09,15.54).
city('Palusapis','ph','Central Luzon',2443.0,120.86,15.68).
city('Pamatawan','ph','Central Luzon',2849.0,120.22,14.93).
city('Panan','ph','Central Luzon',2294.0,120.03,15.21).
city('Pance','ph','Central Luzon',4070.0,120.62,15.69).
city('Pandacaqui','ph','Central Luzon',28603.0,120.65,15.18).
city('Pandi','ph','Central Luzon',34928.0,120.96,14.87).
city('Pando','ph','Central Luzon',2560.0,120.68,15.4).
city('Panlinlang','ph','Central Luzon',2539.0,120.7,15.17).
city('Pantabangan','ph','Central Luzon',5956.0,121.14,15.81).
city('Pantubig','ph','Central Luzon',39285.0,120.96,14.95).
city('Paombong','ph','Central Luzon',41384.0,120.79,14.83).
city('Papaya','ph','Central Luzon',32874.0,121.05,15.35).
city('Parang','ph','Central Luzon',2728.0,120.42,14.63).
city('Parista','ph','Central Luzon',3515.0,120.93,15.85).
city('Pau','ph','Central Luzon',2428.0,120.72,15.03).
city('Penaranda','ph','Central Luzon',27465.0,121.0,15.35).
city('Pias','ph','Central Luzon',3321.0,120.82,15.18).
city('Pilar','ph','Central Luzon',17831.0,120.57,14.66).
city('Pinahan','ph','Central Luzon',3005.0,121.05,15.63).
city('Pinambaran','ph','Central Luzon',3378.0,120.98,15.2).
city('Pio','ph','Central Luzon',24345.0,120.52,15.05).
city('Plaridel','ph','Central Luzon',2842.0,121.0,15.65).
city('Porac','ph','Central Luzon',2305.0,120.02,15.25).
city('Porais','ph','Central Luzon',3075.0,121.04,15.75).
city('Prado','ph','Central Luzon',3590.0,120.52,14.88).
city('Pulilan','ph','Central Luzon',77187.0,120.85,14.91).
city('Pulo','ph','Central Luzon',3152.0,121.01,14.96).
city('Pulong Gubat','ph','Central Luzon',4697.0,120.9,14.87).
city('Pulong Sampalok','ph','Central Luzon',2335.0,121.06,14.96).
city('Pulong Santol','ph','Central Luzon',5591.0,120.56,15.04).
city('Pulungmasle','ph','Central Luzon',9278.0,120.54,15.01).
city('Puncan','ph','Central Luzon',4047.0,121.0,15.91).
city('Pura','ph','Central Luzon',6929.0,120.65,15.62).
city('Putlod','ph','Central Luzon',3481.0,120.9,15.37).
city('Quezon','ph','Central Luzon',18451.0,120.82,15.55).
city('Rajal','ph','Central Luzon',10281.0,120.88,15.44).
city('Ramos','ph','Central Luzon',15066.0,120.64,15.66).
city('Rizal','ph','Central Luzon',26200.0,121.1,15.71).
city('Sabang','ph','Central Luzon',5144.0,120.25,14.7).
city('Sagana','ph','Central Luzon',2496.0,121.15,15.57).
city('Salapungan','ph','Central Luzon',5928.0,120.93,15.13).
city('Salaza','ph','Central Luzon',4599.0,119.95,15.45).
city('Salcedo','ph','Central Luzon',2182.0,120.6,15.86).
city('Salvacion','ph','Central Luzon',3721.0,120.92,15.84).
city('Samal','ph','Central Luzon',29729.0,120.54,14.77).
city('San Agustin','ph','Central Luzon',3601.0,120.39,14.99).
city('San Alejandro','ph','Central Luzon',3064.0,120.87,15.55).
city('San Andres','ph','Central Luzon',3329.0,120.78,15.72).
city('San Anton','ph','Central Luzon',4911.0,120.92,15.34).
city('San Antonio','ph','Central Luzon',7497.0,120.71,15.29).
city('San Basilio','ph','Central Luzon',8125.0,120.58,15.03).
city('San Benito','ph','Central Luzon',2549.0,120.43,14.85).
city('San Carlos','ph','Central Luzon',2580.0,120.82,15.3).
city('San Casimiro','ph','Central Luzon',2833.0,120.78,15.55).
city('San Clemente','ph','Central Luzon',3019.0,120.36,15.71).
city('San Cristobal','ph','Central Luzon',3201.0,120.77,15.57).
city('San Fabian','ph','Central Luzon',2335.0,120.9,15.6).
city('San Felipe','ph','Central Luzon',7086.0,120.53,15.46).
city('San Fernando','ph','Central Luzon',251157.0,120.69,15.03).
city('San Francisco','ph','Central Luzon',8570.0,120.61,15.32).
city('San Ildefonso','ph','Central Luzon',6436.0,120.67,15.15).
city('San Isidro','ph','Central Luzon',7113.0,120.82,15.37).
city('San Jacinto','ph','Central Luzon',2771.0,120.67,15.55).
city('San Jose','ph','Central Luzon',53066.0,120.89,15.41).
city('San Jose Malino','ph','Central Luzon',4979.0,120.67,15.13).
city('San Juan','ph','Central Luzon',4274.0,120.37,15.16).
city('San Juan de Mata','ph','Central Luzon',3131.0,120.53,15.54).
city('San Lorenzo','ph','Central Luzon',2498.0,119.96,15.48).
city('San Luis','ph','Central Luzon',33467.0,120.79,15.04).
city('San Manuel','ph','Central Luzon',5995.0,120.67,15.49).
city('San Marcelino','ph','Central Luzon',18721.0,120.16,14.97).
city('San Mateo','ph','Central Luzon',4984.0,120.8,15.2).
city('San Miguel','ph','Central Luzon',42122.0,120.79,15.29).
city('San Narciso','ph','Central Luzon',15635.0,120.08,15.02).
city('San Nicolas','ph','Central Luzon',6424.0,120.56,15.14).
city('San Pablo','ph','Central Luzon',2169.0,120.62,14.97).
city('San Pascual','ph','Central Luzon',2467.0,120.67,15.51).
city('San Patricio','ph','Central Luzon',3647.0,120.73,15.1).
city('San Rafael','ph','Central Luzon',2777.0,120.7,14.9).
city('San Ricardo','ph','Central Luzon',2501.0,120.97,15.6).
city('San Roque','ph','Central Luzon',4388.0,120.82,15.18).
city('San Roque Dau','ph','Central Luzon',9621.0,120.58,14.98).
city('San Simon','ph','Central Luzon',29049.0,120.78,14.99).
city('San Vicente','ph','Central Luzon',9800.0,120.74,15.16).
city('Santa Ana','ph','Central Luzon',47158.0,120.77,15.09).
city('Santa Barbara','ph','Central Luzon',6525.0,120.8,15.4).
city('Santa Cruz','ph','Central Luzon',15077.0,120.44,15.33).
city('Santa Fe','ph','Central Luzon',2231.0,120.21,15.01).
city('Santa Ignacia','ph','Central Luzon',11477.0,120.44,15.62).
city('Santa Ines','ph','Central Luzon',5821.0,120.47,15.57).
city('Santa Juliana','ph','Central Luzon',2962.0,120.43,15.33).
city('Santa Lucia','ph','Central Luzon',5160.0,120.77,15.35).
city('Santa Maria','ph','Central Luzon',3396.0,120.66,15.31).
city('Santa Monica','ph','Central Luzon',5475.0,120.72,15.36).
city('Santa Rita','ph','Central Luzon',9021.0,120.74,15.16).
city('Santa Rosa','ph','Central Luzon',11683.0,120.94,15.42).
city('Santa Teresa','ph','Central Luzon',4881.0,120.55,14.93).
city('Santiago','ph','Central Luzon',5971.0,120.52,14.9).
city('Santo Cristo','ph','Central Luzon',7922.0,120.8,15.3).
city('Santo Domingo','ph','Central Luzon',3380.0,120.68,15.01).
city('Santo Nino','ph','Central Luzon',2678.0,120.67,15.29).
city('Santo Rosario','ph','Central Luzon',6120.0,120.87,15.55).
city('Santo Tomas','ph','Central Luzon',14563.0,120.85,15.37).
city('Sapa','ph','Central Luzon',3504.0,120.69,14.99).
city('Sapang','ph','Central Luzon',11372.0,120.52,15.72).
city('Sapang Buho','ph','Central Luzon',3339.0,121.12,15.59).
city('Sasmuan','ph','Central Luzon',21124.0,120.62,14.94).
city('Saysain','ph','Central Luzon',2683.0,120.39,14.56).
city('Sibul','ph','Central Luzon',5297.0,121.03,15.49).
city('Siclong','ph','Central Luzon',2700.0,121.22,15.58).
city('Sinait','ph','Central Luzon',2268.0,120.58,15.54).
city('Sinilian','ph','Central Luzon',5040.0,120.46,15.7).
city('Soledad','ph','Central Luzon',4728.0,120.97,15.42).
city('Sula','ph','Central Luzon',3431.0,120.4,15.46).
city('Sulucan','ph','Central Luzon',5703.0,120.93,14.8).
city('Tabacao','ph','Central Luzon',3465.0,120.93,15.63).
city('Tabon','ph','Central Luzon',2537.0,120.92,15.27).
city('Tabuating','ph','Central Luzon',4120.0,120.94,15.4).
city('Talaga','ph','Central Luzon',4655.0,120.59,15.39).
city('Talang','ph','Central Luzon',2497.0,120.87,15.02).
city('Taltal','ph','Central Luzon',5370.0,119.95,15.59).
city('Talugtug','ph','Central Luzon',6306.0,120.81,15.78).
city('Tariji','ph','Central Luzon',2332.0,120.61,15.55).
city('Tarlac','ph','Central Luzon',182413.0,120.58,15.48).
city('Tartaro','ph','Central Luzon',5231.0,121.04,15.17).
city('Tayabo','ph','Central Luzon',4406.0,121.03,15.83).
city('Telabastagan','ph','Central Luzon',25935.0,120.62,15.12).
city('Tinang','ph','Central Luzon',4217.0,120.65,15.38).
city('Tondod','ph','Central Luzon',3182.0,120.97,15.72).
city('Uacon','ph','Central Luzon',3377.0,119.94,15.68).
city('Upig','ph','Central Luzon',2262.0,120.99,15.03).
city('Vargas','ph','Central Luzon',2777.0,120.48,15.58).
city('Villa Aglipay','ph','Central Luzon',4800.0,120.45,15.47).
city('Villa Isla','ph','Central Luzon',2256.0,120.87,15.77).
city('Vizal San Pablo','ph','Central Luzon',2322.0,120.92,15.05).
city('Vizal Santo Nino','ph','Central Luzon',2529.0,120.92,15.07).
city('Alamada','ph','Central Mindanao',4987.0,124.57,7.33).
city('Amas','ph','Central Mindanao',6219.0,124.98,7.06).
city('Bacolod','ph','Central Mindanao',5294.0,123.92,8.12).
city('Bagontapay','ph','Central Mindanao',6747.0,124.91,6.86).
city('Baguer','ph','Central Mindanao',3228.0,124.5,7.26).
city('Bai Sarifinang','ph','Central Mindanao',6288.0,124.63,6.44).
city('Balili','ph','Central Mindanao',2485.0,123.73,7.89).
city('Balogo','ph','Central Mindanao',3063.0,124.47,7.28).
city('Baloi','ph','Central Mindanao',7700.0,124.23,8.12).
city('Banisilan','ph','Central Mindanao',5748.0,124.72,7.49).
city('Bannawag','ph','Central Mindanao',3060.0,124.87,7.16).
city('Bantogon','ph','Central Mindanao',5379.0,124.03,6.53).
city('Bao','ph','Central Mindanao',6672.0,124.65,7.41).
city('Barongis','ph','Central Mindanao',2987.0,124.56,7.26).
city('Baroy','ph','Central Mindanao',3195.0,123.78,8.03).
city('Basak','ph','Central Mindanao',3781.0,124.15,6.73).
city('Batasan','ph','Central Mindanao',2231.0,125.05,7.03).
city('Bayasong','ph','Central Mindanao',2990.0,124.87,6.65).
city('Bialong','ph','Central Mindanao',8639.0,124.89,6.98).
city('Biwang','ph','Central Mindanao',2334.0,124.56,6.6).
city('Blingkong','ph','Central Mindanao',4954.0,124.88,6.57).
city('Bual','ph','Central Mindanao',3800.0,124.71,6.99).
city('Bulatukan','ph','Central Mindanao',4305.0,125.16,6.9).
city('Bunawan','ph','Central Mindanao',2120.0,124.3,8.32).
city('Buru-un','ph','Central Mindanao',15490.0,124.18,8.19).
city('Busok','ph','Central Mindanao',3463.0,124.6,6.51).
city('Carmen','ph','Central Mindanao',8759.0,124.79,7.2).
city('Columbio','ph','Central Mindanao',5516.0,124.94,6.7).
city('Cotabato','ph','Central Mindanao',179445.0,124.25,7.23).
city('Daguma','ph','Central Mindanao',3785.0,124.55,6.59).
city('Dalipuga','ph','Central Mindanao',14242.0,124.25,8.32).
city('Dansuli','ph','Central Mindanao',4561.0,124.58,6.64).
city('Digkilaan','ph','Central Mindanao',4349.0,124.32,8.25).
city('Dimayon','ph','Central Mindanao',2571.0,124.15,8.07).
city('Dualing','ph','Central Mindanao',2323.0,124.57,7.15).
city('Dukay','ph','Central Mindanao',2484.0,124.56,6.67).
city('Esperanza','ph','Central Mindanao',4075.0,124.27,7.45).
city('Gansing','ph','Central Mindanao',5031.0,124.66,6.74).
city('Glad','ph','Central Mindanao',5746.0,124.52,7.15).
city('Gokoton','ph','Central Mindanao',2914.0,124.69,7.16).
city('Iligan','ph','Central Mindanao',267854.0,124.22,8.17).
city('Kabacan','ph','Central Mindanao',31768.0,124.82,7.11).
city('Kalaisan','ph','Central Mindanao',2494.0,125.04,7.01).
city('Kalamansig','ph','Central Mindanao',12820.0,124.05,6.56).
city('Kalandagan','ph','Central Mindanao',2137.0,124.72,6.68).
city('Kalanganan','ph','Central Mindanao',2331.0,124.25,8.08).
city('Kapatagan','ph','Central Mindanao',9664.0,123.77,7.9).
city('Kapaya','ph','Central Mindanao',4201.0,124.56,6.57).
city('Kapingkong','ph','Central Mindanao',3129.0,124.63,6.67).
city('Karomatan','ph','Central Mindanao',5329.0,123.72,7.79).
city('Kauswagan','ph','Central Mindanao',6851.0,124.09,8.19).
city('Kawit','ph','Central Mindanao',2257.0,124.07,8.19).
city('Kenram','ph','Central Mindanao',4363.0,124.62,6.67).
city('Kisante','ph','Central Mindanao',4815.0,125.16,6.92).
city('Kolambugan','ph','Central Mindanao',2427.0,123.9,8.11).
city('Kulaman','ph','Central Mindanao',3380.0,124.09,6.46).
city('Labu-o','ph','Central Mindanao',3267.0,125.04,7.12).
city('Laguilayan','ph','Central Mindanao',17764.0,124.52,6.65).
city('Lanipao','ph','Central Mindanao',4114.0,123.78,7.96).
city('Lapinig','ph','Central Mindanao',3473.0,123.69,7.92).
city('Libertad','ph','Central Mindanao',5210.0,124.23,8.25).
city('Libungan','ph','Central Mindanao',5606.0,124.52,7.24).
city('Liliongan','ph','Central Mindanao',3049.0,124.79,7.37).
city('Limulan','ph','Central Mindanao',3933.0,124.06,6.58).
city('Linamon','ph','Central Mindanao',6849.0,124.17,8.18).
city('Linao','ph','Central Mindanao',4489.0,124.97,7.17).
city('Lutayan','ph','Central Mindanao',13080.0,124.87,6.6).
city('Magpet','ph','Central Mindanao',5414.0,125.11,7.11).
city('Maigo','ph','Central Mindanao',7235.0,123.96,8.16).
city('Maindang','ph','Central Mindanao',3201.0,124.85,6.6).
city('Malamote','ph','Central Mindanao',3098.0,124.94,7.07).
city('Malapag','ph','Central Mindanao',3306.0,124.82,7.13).
city('Malasila','ph','Central Mindanao',5864.0,125.13,6.94).
city('Malinao','ph','Central Mindanao',4264.0,124.69,7.59).
city('Malisbong','ph','Central Mindanao',4452.0,124.35,6.12).
city('Malitubog','ph','Central Mindanao',2241.0,124.64,7.32).
city('Mamali','ph','Central Mindanao',2394.0,124.65,6.78).
city('Manaulanan','ph','Central Mindanao',2231.0,124.62,7.05).
city('Manuangan','ph','Central Mindanao',4422.0,124.4,7.28).
city('Maranding','ph','Central Mindanao',13694.0,123.77,7.92).
city('Marawi','ph','Central Mindanao',143546.0,124.29,8.0).
city('Marbel','ph','Central Mindanao',3399.0,124.92,7.12).
city('Maria-Cristina','ph','Central Mindanao',5540.0,124.19,8.16).
city('Matiompong','ph','Central Mindanao',2317.0,124.58,6.68).
city('Midsayap','ph','Central Mindanao',32932.0,124.53,7.19).
city('Minapan','ph','Central Mindanao',3055.0,124.86,6.82).
city('Munai','ph','Central Mindanao',2113.0,124.06,7.98).
city('New Cebu','ph','Central Mindanao',2895.0,125.03,7.1).
city('New Lagao','ph','Central Mindanao',2223.0,124.64,6.7).
city('New Panay','ph','Central Mindanao',3151.0,124.59,6.76).
city('Nuling','ph','Central Mindanao',2989.0,124.1,6.66).
city('Nunguan','ph','Central Mindanao',2584.0,124.69,7.11).
city('Osias','ph','Central Mindanao',3225.0,124.82,7.6).
city('Paatan','ph','Central Mindanao',4526.0,124.93,7.12).
city('Pagangan','ph','Central Mindanao',2560.0,124.6,7.11).
city('Palimbang','ph','Central Mindanao',4858.0,124.19,6.21).
city('Pamantingan','ph','Central Mindanao',2776.0,124.46,6.7).
city('Pantao Ragat','ph','Central Mindanao',2418.0,124.16,8.06).
city('Patindeguen','ph','Central Mindanao',2112.0,124.5,7.22).
city('Pedtad','ph','Central Mindanao',2278.0,124.81,7.16).
city('Pimbalayan','ph','Central Mindanao',2143.0,124.67,6.87).
city('Poloy-poloy','ph','Central Mindanao',5130.0,124.1,6.64).
city('President Roxas','ph','Central Mindanao',10879.0,125.05,7.16).
city('Pualas','ph','Central Mindanao',2100.0,123.85,8.02).
city('Punol','ph','Central Mindanao',2468.0,124.58,7.05).
city('Purikay','ph','Central Mindanao',2537.0,124.07,6.69).
city('Ragandang','ph','Central Mindanao',2216.0,124.12,6.66).
city('Rebe','ph','Central Mindanao',4413.0,123.82,7.91).
city('Rogongon','ph','Central',5530.0,124.33,8.23).
city('Sadsalan','ph','Central Mindanao',2276.0,124.62,6.82).
city('Saguing','ph','Central Mindanao',5073.0,125.08,6.98).
city('Salunayan','ph','Central Mindanao',2758.0,124.5,7.15).
city('Salvador','ph','Central Mindanao',4285.0,123.84,7.9).
city('Sambulawan','ph','Central Mindanao',4585.0,124.74,6.7).
city('Sampao','ph','Central Mindanao',5259.0,124.6,6.88).
city('San Mateo','ph','Central Mindanao',3791.0,124.58,7.18).
city('San Roque','ph','Central Mindanao',2549.0,124.27,6.16).
city('Sapad','ph','Central Mindanao',4471.0,123.83,7.85).
city('Tacub','ph','Central Mindanao',3137.0,124.12,8.19).
city('Taguisa','ph','Central Mindanao',3147.0,124.04,6.7).
city('Tambak','ph','Central Mindanao',2258.0,124.63,6.73).
city('Tamnag','ph','Central Mindanao',6302.0,124.85,6.57).
city('Telafas','ph','Central Mindanao',2306.0,124.98,6.64).
city('Tomado','ph','Central Mindanao',2610.0,124.61,7.19).
city('Tran','ph','Central Mindanao',2167.0,124.06,6.72).
city('Tubod','ph','Central Mindanao',10975.0,123.79,8.05).
city('Tuka','ph','Central Mindanao',4003.0,124.59,6.52).
city('Tulunan','ph','Central Mindanao',9584.0,124.88,6.83).
city('Villamor','ph','Central Mindanao',2409.0,124.52,6.7).
city('Abaca','ph','Central Visayas',2480.0,124.5,9.92).
city('Abis','ph','Central Visayas',2603.0,122.93,9.72).
city('Abucayan','ph','Central Visayas',2204.0,123.9,9.93).
city('Aguining','ph','Central Visayas',2488.0,124.59,10.09).
city('Alangilan','ph','Central Visayas',4613.0,122.88,9.28).
city('Alangilanan','ph','Central Visayas',2365.0,123.11,9.64).
city('Albuquerque','ph','Central Visayas',2730.0,123.96,9.61).
city('Alcantara','ph','Central Visayas',4447.0,123.41,9.98).
city('Alcoy','ph','Central Visayas',3016.0,123.51,9.71).
city('Alegria','ph','Central Visayas',2539.0,123.34,9.73).
city('Alfaco','ph','Central Visayas',2599.0,123.67,10.25).
city('Alicia','ph','Central Visayas',4415.0,124.44,9.9).
city('Aloguinsan','ph','Central Visayas',2721.0,123.55,10.22).
city('Amdus','ph','Central Visayas',2247.0,123.1,9.88).
city('Amio','ph','Central Visayas',2349.0,122.94,9.36).
city('Anonang','ph','Central Visayas',5660.0,124.03,11.0).
city('Antipolo','ph','Central Visayas',4530.0,123.95,11.17).
city('Apoloy','ph','Central Visayas',2127.0,123.02,9.17).
city('Asturias','ph','Central Visayas',7779.0,123.72,10.57).
city('Atop-atop','ph','Central Visayas',2844.0,123.76,11.23).
city('Azagra','ph','Central Visayas',4688.0,123.15,9.48).
city('Bacong','ph','Central Visayas',3689.0,123.93,9.5).
city('Badian','ph','Central Visayas',3613.0,123.4,9.86).
city('Bagacay','ph','Central Visayas',3090.0,124.25,10.17).
city('Bagay','ph','Central Visayas',4977.0,124.04,11.2).
city('Bagtic','ph','Central Visayas',3835.0,123.01,9.7).
city('Bais','ph','Central Visayas',65594.0,123.12,9.6).
city('Bakhawan','ph','Central Visayas',2661.0,123.96,11.21).
city('Bal-os','ph','Central Visayas',3206.0,122.63,9.44).
city('Balayong','ph','Central Visayas',2469.0,123.06,9.47).
city('Balilihan','ph','Central Visayas',2931.0,123.97,9.76).
city('Balogo','ph','Central Visayas',3308.0,123.17,10.12).
city('Balud','ph','Central Visayas',3586.0,123.68,10.15).
city('Banhigan','ph','Central Visayas',2359.0,123.39,9.85).
city('Baod','ph','Central',3059.0,123.7,11.21).
city('Basak','ph','Central Visayas',3705.0,123.31,10.23).
city('Basay','ph','Central Visayas',4307.0,122.64,9.41).
city('Basdiot','ph','Central Visayas',4015.0,123.38,9.94).
city('Bateria','ph','Central Visayas',3629.0,124.03,11.14).
city('Batuan','ph','Central Visayas',4052.0,124.15,9.78).
city('Becerril','ph','Central Visayas',2416.0,123.44,9.65).
city('Biabas','ph','Central Visayas',2381.0,124.47,9.8).
city('Biasong','ph','Central Visayas',2163.0,123.74,10.53).
city('Bien Unido','ph','Central Visayas',530.0,124.38,10.14).
city('Biking','ph','Central Visayas',2907.0,123.85,9.59).
city('Bindoy','ph','Central Visayas',3600.0,123.14,9.76).
city('Binlod','ph','Central Visayas',2941.0,123.61,9.91).
city('Bitoon','ph','Central Visayas',3334.0,123.73,10.66).
city('Bogo','ph','Central Visayas',23562.0,124.01,11.05).
city('Bolisong','ph','Central Visayas',2802.0,123.15,9.69).
city('Boljoon','ph','Central Visayas',3313.0,123.48,9.63).
city('Bonawon','ph','Central Visayas',9189.0,122.92,9.14).
city('Bonbon','ph','Central Visayas',6122.0,123.57,10.23).
city('Bood','ph','Central Visayas',2320.0,123.83,9.74).
city('Borbon','ph','Central Visayas',4703.0,124.03,10.84).
city('Botigues','ph','Central Visayas',2973.0,123.67,11.1).
city('Buanoy','ph','Central Visayas',10955.0,123.7,10.47).
city('Buenavista','ph','Central Visayas',3082.0,123.69,10.05).
city('Bugas','ph','Central Visayas',2261.0,123.44,9.89).
city('Bugsoc','ph','Central Visayas',2871.0,124.27,9.78).
city('Bulasa','ph','Central Visayas',3419.0,123.61,9.93).
city('Bulod','ph','Central Visayas',2140.0,123.15,9.68).
city('Cabalawan','ph','Central Visayas',2859.0,123.95,10.74).
city('Cabangahan','ph','Central Visayas',3861.0,122.95,9.08).
city('Cabul-an','ph','Central Visayas',3850.0,124.05,10.15).
city('Cabungahan','ph','Central Visayas',2307.0,123.98,10.52).
city('Cahumayan','ph','Central Visayas',3017.0,123.96,10.57).
city('Calamba','ph','Central Visayas',2719.0,123.28,10.18).
city('Calape','ph','Central Visayas',3100.0,123.96,10.53).
city('Calituban','ph','Central Visayas',3950.0,124.3,10.25).
city('Calumboyan','ph','Central Visayas',2339.0,124.03,10.79).
city('Camambugan','ph','Central Visayas',2265.0,124.44,10.06).
city('Cambanay','ph','Central Visayas',2658.0,123.99,10.54).
city('Campuyo','ph','Central Visayas',2794.0,123.15,9.66).
city('Can-asujan','ph','Central Visayas',6994.0,123.66,10.13).
city('Canaway','ph','Central Visayas',3712.0,123.07,9.07).
city('Candabong','ph','Central Visayas',2386.0,123.81,9.71).
city('Candijay','ph','Central Visayas',4125.0,124.5,9.82).
city('Canhaway','ph','Central Visayas',3157.0,124.47,9.75).
city('Canjulao','ph','Central Visayas',2693.0,124.36,9.67).
city('Canlaon','ph','Central Visayas',44850.0,123.2,10.37).
city('Canmaya','ph','Central Visayas',2610.0,124.07,9.94).
city('Cansuje','ph','Central Visayas',2436.0,123.55,9.92).
city('Cantao-an','ph','Central Visayas',4177.0,123.71,10.26).
city('Carmelo','ph','Central Visayas',2175.0,123.79,10.71).
city('Carmen','ph','Central Visayas',15056.0,124.11,10.21).
city('Casala-an','ph','Central Visayas',2875.0,123.05,9.12).
city('Casay','ph','Central Visayas',3631.0,123.55,9.82).
city('Catarman','ph','Central Visayas',3688.0,123.86,9.6).
city('Caticugan','ph','Central Visayas',2558.0,123.0,9.1).
city('Catmon','ph','Central Visayas',7811.0,124.0,10.72).
city('Catmondaan','ph','Central Visayas',2861.0,124.01,10.69).
city('Catungawan','ph','Central Visayas',3342.0,124.47,9.78).
city('Cawayan','ph','Central Visayas',2705.0,123.53,9.8).
city('Cayang','ph','Central Visayas',6353.0,123.98,11.07).
city('Cebu','ph','Central Visayas',758597.0,123.9,10.32).
city('Clarin','ph','Central Visayas',3200.0,124.02,9.96).
city('Cogon','ph','Central Visayas',2723.0,123.68,10.34).
city('Cogtong','ph','Central Visayas',3074.0,124.53,9.84).
city('Colonia','ph','Central Visayas',2259.0,123.79,10.66).
city('Compostela','ph','Central Visayas',18727.0,124.0,10.45).
city('Consuelo','ph','Central Visayas',4888.0,124.3,10.63).
city('Cordoba','ph','Central Visayas',29288.0,123.95,10.25).
city('Cotcot','ph','Central Visayas',4067.0,124.0,10.43).
city('Cuanos','ph','Central Visayas',2205.0,123.78,10.28).
city('Dagohoy','ph','Central Visayas',2741.0,124.27,9.9).
city('Damolog','ph','Central Visayas',2946.0,124.0,10.77).
city('Danao','ph','Central Visayas',25523.0,124.09,10.23).
city('Datagon','ph','Central Visayas',2584.0,123.1,9.44).
city('Dauin','ph','Central Visayas',3305.0,123.27,9.19).
city('Dauis','ph','Central Visayas',2553.0,123.87,9.63).
city('De la Paz','ph','Central Visayas',3144.0,123.87,9.7).
city('Doljo','ph','Central Visayas',2760.0,123.73,9.59).
city('Doong','ph','Central Visayas',2554.0,123.64,11.07).
city('Dumaguete','ph','Central Visayas',113588.0,123.31,9.32).
city('Dumanjug','ph','Central Visayas',3613.0,123.43,10.06).
city('El Pardo','ph','Central Visayas',2768.0,123.49,9.66).
city('Esperanza','ph','Central Visayas',4254.0,124.37,10.7).
city('Estaca','ph','Central Visayas',2661.0,124.26,9.68).
city('Garcia Hernandez','ph','Central Visayas',2643.0,124.3,9.62).
city('Giliga-on','ph','Central Visayas',5250.0,122.94,9.1).
city('Ginatilan','ph','Central Visayas',2699.0,123.32,9.56).
city('Guadalupe','ph','Central Visayas',6056.0,123.68,10.28).
city('Guba','ph','Central Visayas',2195.0,123.27,10.31).
city('Guibuangan','ph','Central Visayas',2209.0,123.48,10.11).
city('Guindulman','ph','Central Visayas',4686.0,124.48,9.76).
city('Guio-ang','ph','Central Visayas',2652.0,124.51,9.79).
city('Hagdan','ph','Central Visayas',3120.0,123.9,11.33).
city('Hagnaya','ph','Central Visayas',3391.0,123.97,11.1).
city('Hibaiyo','ph','Central Visayas',5209.0,123.32,10.27).
city('Hilantagaan','ph','Central Visayas',3396.0,123.82,11.2).
city('Hilotongan','ph','Central Visayas',2919.0,123.64,11.15).
city('Himensulan','ph','Central Visayas',2343.0,124.29,10.6).
city('Hinlayagan','ph','Central Visayas',2788.0,124.34,10.03).
city('Ilihan','ph','Central Visayas',3246.0,123.97,10.91).
city('Inamlang','ph','Central Visayas',2865.0,123.33,9.68).
city('Inayagan','ph','Central Visayas',6610.0,123.78,10.23).
city('Jaclupan','ph','Central Visayas',9652.0,123.82,10.3).
city('Jampang','ph','Central Visayas',2189.0,123.58,9.9).
city('Jandayan','ph','Central Visayas',2815.0,124.18,10.17).
city('Jantianon','ph','Central Visayas',2322.0,123.15,9.45).
city('Japitan','ph','Central Visayas',3222.0,123.5,10.13).
city('Jetafe','ph','Central Visayas',4489.0,124.15,10.15).
city('Jimalalud','ph','Central Visayas',3212.0,123.19,9.98).
city('Jugno','ph','Central Visayas',3778.0,123.2,9.47).
city('Kabac','ph','Central Visayas',4149.0,123.7,11.24).
city('Kaongkod','ph','Central Visayas',2329.0,123.76,11.25).
city('Kawit','ph','Central Visayas',5771.0,123.95,11.19).
city('La Hacienda','ph','Central Visayas',3726.0,124.39,9.88).
city('La Libertad','ph','Central Visayas',5632.0,123.23,10.03).
city('La Paz','ph','Central Visayas',3091.0,123.98,11.03).
city('Lamacan','ph','Central Visayas',11993.0,123.62,10.02).
city('Lanao','ph','Central Visayas',2875.0,124.04,11.26).
city('Lanas','ph','Central Visayas',2325.0,123.73,10.27).
city('Langtad','ph','Central Visayas',4017.0,123.67,10.04).
city('Langub','ph','Central Visayas',2861.0,123.74,10.58).
city('Lapu-Lapu','ph','Central Visayas',241391.0,123.96,10.33).
city('Lazi','ph','Central Visayas',3429.0,123.64,9.13).
city('Lepanto','ph','Central Visayas',2472.0,123.4,9.7).
city('Libertad','ph','Central Visayas',3798.0,124.02,11.03).
city('Logon','ph','Central Visayas',3644.0,124.12,11.33).
city('Lombog','ph','Central Visayas',2276.0,124.42,9.78).
city('Loon','ph','Central Visayas',9485.0,123.79,9.8).
city('Lugo','ph','Central Visayas',2372.0,123.99,10.82).
city('Lunas','ph','Central Visayas',5789.0,123.75,10.65).
city('Lut-od','ph','Central Visayas',2418.0,123.63,10.26).
city('Maayongtubig','ph','Central Visayas',4922.0,123.25,9.17).
city('Mabini','ph','Central Visayas',5999.0,124.52,9.86).
city('Macaas','ph','Central Visayas',2703.0,124.01,10.7).
city('Madridejos','ph','Central Visayas',5193.0,123.54,10.54).
city('Magay','ph','Central Visayas',2281.0,124.01,10.47).
city('Mahayag','ph','Central Visayas',2353.0,124.32,9.94).
city('Mainit','ph','Central Visayas',2323.0,123.36,9.44).
city('Malabugas','ph','Central Visayas',4646.0,122.77,9.37).
city('Malabuyoc','ph','Central Visayas',2812.0,123.33,9.66).
city('Malaiba','ph','Central Visayas',6888.0,123.32,10.33).
city('Malbago','ph','Central Visayas',2614.0,123.33,9.75).
city('Malhiao','ph','Central Visayas',2678.0,123.42,9.88).
city('Malingin','ph','Central Visayas',2650.0,123.98,11.05).
city('Maloh','ph','Central Visayas',5105.0,122.98,9.06).
city('Maluay','ph','Central Visayas',2878.0,123.22,9.13).
city('Malusay','ph','Central Visayas',2473.0,123.28,10.14).
city('Manalongon','ph','Central Visayas',9321.0,122.9,9.19).
city('Mandaue','ph','Central Visayas',288898.0,123.93,10.33).
city('Maninihon','ph','Central Visayas',6150.0,122.84,9.37).
city('Mantalongon','ph','Central Visayas',4172.0,123.52,9.95).
city('Mantiquil','ph','Central Visayas',2281.0,123.05,9.17).
city('Maravilla','ph','Central Visayas',2253.0,123.89,10.9).
city('Maribojoc','ph','Central Visayas',2476.0,123.84,9.75).
city('Maricaban','ph','Central Visayas',2779.0,123.77,11.15).
city('Masaba','ph','Central Visayas',2456.0,123.97,10.53).
city('Maya','ph','Central Visayas',7572.0,124.06,11.27).
city('Mayabon','ph','Central Visayas',6521.0,123.17,9.09).
city('Mayana','ph','Central Visayas',2305.0,124.35,9.76).
city('Mayaposi','ph','Central Visayas',2538.0,123.02,9.62).
city('Mckinley','ph','Central Visayas',2213.0,123.26,10.09).
city('Medellin','ph','Central Visayas',11741.0,123.96,11.13).
city('Mercedes','ph','Central Visayas',2463.0,124.4,10.67).
city('Minglanilla','ph','Central Visayas',62058.0,123.78,10.25).
city('Minolos','ph','Central Visayas',2355.0,123.47,10.1).
city('Moalboal','ph','Central Visayas',6831.0,123.4,9.94).
city('Mohon','ph','Central Visayas',6813.0,123.63,11.05).
city('Nagbalaye','ph','Central Visayas',5108.0,122.87,9.25).
city('Nahawan','ph','Central Visayas',2226.0,124.05,9.97).
city('Nailon','ph','Central Visayas',5379.0,124.04,11.05).
city('Nalundan','ph','Central Visayas',9674.0,123.07,9.75).
city('Nangka','ph','Central Visayas',6879.0,123.5,10.16).
city('Novallas','ph','Central Visayas',5525.0,123.12,9.51).
city('Nueva Fuerza','ph','Central Visayas',2191.0,124.15,9.87).
city('Nueva Vida','ph','Central Visayas',3058.0,124.17,9.8).
city('Nug-as','ph','Central Visayas',2844.0,123.44,9.71).
city('Obong','ph','Central Visayas',5576.0,123.51,9.74).
city('Ocana','ph','Central Visayas',13898.0,123.62,10.06).
city('Okiot','ph','Central Visayas',3370.0,123.17,9.57).
city('Okoy','ph','Central Visayas',3099.0,123.8,11.17).
city('Oslob','ph','Central Visayas',3724.0,123.43,9.52).
city('Owak','ph','Central Visayas',3202.0,123.7,10.55).
city('Padre Zamora','ph','Central V',2271.0,123.25,10.07).
city('Pajo','ph','Central Visayas',3051.0,124.02,11.23).
city('Pamplona','ph','Central Visayas',11772.0,123.12,9.47).
city('Panalipan','ph','Central Visayas',2679.0,124.02,10.65).
city('Panaytayon','ph','Central Visayas',2574.0,123.98,9.95).
city('Pangdan','ph','Central Visayas',4063.0,123.73,10.23).
city('Panglao','ph','Central Visayas',6853.0,123.75,9.58).
city('Panugnawan','ph','Central Visayas',2154.0,123.98,11.16).
city('Patao','ph','Central Visayas',5997.0,123.69,11.22).
city('Paypay','ph','Central Visayas',2758.0,123.98,11.22).
city('Perrelos','ph','Central Visayas',10971.0,123.68,10.12).
city('Pilar','ph','Central Visayas',2812.0,124.33,9.83).
city('Pinamungahan','ph','Central Visayas',23068.0,123.59,10.27).
city('Pinayagan','ph','Central Visayas',4498.0,123.95,9.93).
city('Pinocawan','ph','Central Visayas',4489.0,123.3,10.34).
city('Pitogo','ph','Central Visayas',2403.0,124.55,10.12).
city('Polo','ph','Central Visayas',4046.0,123.18,9.48).
city('Pooc','ph','Central Visayas',2220.0,123.74,11.15).
city('Poro','ph','Central Visayas',2621.0,124.41,10.63).
city('Putat','ph','Central Visayas',3874.0,123.85,10.78).
city('Saavedra','ph','Central Visayas',2190.0,123.38,9.97).
city('Sagbayan','ph','Central Visayas',4934.0,124.09,9.91).
city('Samboan','ph','Central Visayas',3646.0,123.31,9.53).
city('San Agustin','ph','Central Visayas',3982.0,123.78,9.63).
city('San Antonio','ph','Central Visayas',2489.0,123.24,9.34).
city('San Fernando','ph','Central Visayas',23706.0,123.71,10.16).
city('San Francisco','ph','Central Visayas',7018.0,124.34,10.41).
city('San Isidro','ph','Central Visayas',2714.0,124.0,10.22).
city('San Jose','ph','Central Visayas',4847.0,124.3,10.14).
city('San Miguel','ph','Central Visayas',2519.0,123.98,9.7).
city('San Pascual','ph','Central Visayas',3351.0,124.43,9.95).
city('San Remigio','ph','Central Visayas',3806.0,123.94,11.08).
city('San Roque','ph','Central Visayas',2367.0,124.03,10.35).
city('Sandayong','ph','Central Visayas',3389.0,124.0,10.5).
city('Sandulot','ph','Central Visayas',3641.0,123.02,9.1).
city('Sangat','ph','Central Visayas',4608.0,123.69,10.13).
city('Santa Catalina','ph','Central Visayas',26457.0,122.86,9.35).
city('Santa Cruz','ph','Central Visayas',3420.0,123.88,10.33).
city('Santa Cruz Nuevo','ph','Central Visayas',4731.0,123.1,9.54).
city('Santa Fe','ph','Central Visayas',2405.0,123.81,11.15).
city('Santa Filomena','ph','Central Visayas',2932.0,123.34,9.74).
city('Santander','ph','Central Visayas',2541.0,123.34,9.42).
city('Santiago','ph','Central Visayas',2337.0,124.31,10.59).
city('Santo Nino','ph','Central Visayas',2339.0,123.79,10.69).
city('Sibulan','ph','Central Visayas',28079.0,123.29,9.36).
city('Sierra Bullones','ph','Central Visayas',2978.0,124.29,9.81).
city('Silab','ph','Central Visayas',3296.0,123.17,9.44).
city('Sillon','ph','Central Visayas',4042.0,123.75,11.2).
city('Simala','ph','Central Visayas',2569.0,123.62,9.97).
city('Siquijor','ph','Central Visayas',10259.0,123.51,9.22).
city('Sogod','ph','Central Visayas',2968.0,123.99,10.75).
city('Songculan','ph','Central Visayas',3335.0,123.82,9.63).
city('Sulangan','ph','Central Visayas',4582.0,123.73,11.14).
city('Tabalong','ph','Central Visayas',2294.0,123.84,9.62).
city('Tabon','ph','Central Visayas',3074.0,123.39,10.04).
city('Tabuan','ph','Central Visayas',5390.0,122.85,9.52).
city('Tabuelan','ph','Central Visayas',3985.0,123.87,10.82).
city('Tabunok','ph','Central Visayas',2954.0,123.95,10.82).
city('Tagbilaran','ph','Central Visayas',86421.0,123.86,9.66).
city('Tagum','ph','Central Visayas',2559.0,124.37,10.1).
city('Tajao','ph','Central Visayas',5394.0,123.59,10.32).
city('Talangnan','ph','Central Visayas',3276.0,123.34,9.63).
city('Talibon','ph','Central Visayas',11209.0,124.33,10.15).
city('Talisay','ph','Central Visayas',68653.0,123.95,10.76).
city('Tambo','ph','Central Visayas',3196.0,123.09,9.89).
city('Tambongon','ph','Central Visayas',2643.0,123.93,10.97).
city('Tambulan','ph','Central Visayas',2162.0,123.09,9.91).
city('Tamisu','ph','Central Visayas',2904.0,123.1,9.63).
city('Tampocon','ph','Central Visayas',3768.0,123.13,9.85).
city('Tandayag','ph','Central Visayas',3532.0,123.23,9.45).
city('Tangke','ph','Central Visayas',9858.0,123.97,10.8).
city('Tangnan','ph','Central Visayas',2870.0,123.78,9.61).
city('Tapilon','ph','Central Visayas',7786.0,124.03,11.28).
city('Tapon','ph','Central Visayas',5245.0,123.45,10.06).
city('Tawala','ph','Central Visayas',2695.0,123.78,9.56).
city('Taytayan','ph','Central Visayas',3654.0,123.98,10.87).
city('Tayud','ph','Central Visayas',7788.0,123.97,10.37).
city('Tiguib','ph','Central Visayas',2573.0,123.13,9.8).
city('Tinaan','ph','Central Visayas',5959.0,123.75,11.27).
city('Tinaogan','ph','Central Visayas',2360.0,123.15,9.78).
city('Tindog','ph','Central Visayas',3306.0,124.01,11.12).
city('Tinubdan','ph','Central Visayas',2146.0,124.01,11.19).
city('Tipolo','ph','Central Visayas',2361.0,124.52,10.02).
city('Toledo','ph','Central Visayas',156915.0,123.64,10.38).
city('Tominjao','ph','Central Visayas',3644.0,124.04,11.23).
city('Totolan','ph','Central Visayas',4030.0,123.85,9.63).
city('Trinidad','ph','Central Visayas',3225.0,124.34,10.08).
city('Tubigagmanok','ph','Central Visayas',3866.0,123.75,10.62).
city('Tubigon','ph','Central Visayas',11262.0,123.96,9.95).
city('Tubod','ph','Central Visayas',2726.0,123.54,10.01).
city('Tulay','ph','Central Visayas',7808.0,123.58,10.25).
city('Ubay','ph','Central Visayas',3799.0,124.47,10.06).
city('Union','ph','Central Visayas',3425.0,124.43,10.36).
city('Valencia','ph','Central Visayas',3642.0,123.75,9.83).
city('Vallehermoso','ph','Central Visayas',6148.0,123.78,10.06).
city('Zamboanguita','ph','Central Visayas',6164.0,123.2,9.11).
city('Agbannawag','ph','Cordillera',3186.0,121.53,17.38).
city('Ambuclao','ph','Cordillera',2822.0,120.75,16.48).
city('Amlimay','ph','Cordillera',2405.0,120.83,16.7).
city('Angad','ph','Cordillera',2223.0,120.63,17.58).
city('Atok','ph','Cordillera',2092.0,120.7,16.58).
city('Baculongan','ph','Cordillera',11742.0,120.83,16.8).
city('Baguinge','ph','Cordillera',2078.0,121.11,16.78).
city('Baguio','ph','Cordillera',272732.0,120.57,16.43).
city('Balbalan','ph','Cordillera',2195.0,121.2,17.44).
city('Banaue','ph','Cordillera',2497.0,121.06,16.92).
city('Bangao','ph','Cordillera',3902.0,120.84,16.82).
city('Bangued','ph','Cordillera',14017.0,120.6,17.6).
city('Bayabas','ph','Cordillera',2165.0,120.52,16.45).
city('Besao','ph','Cordillera',2241.0,120.86,17.1).
city('Betwagan','ph','Cordillera',2132.0,120.97,17.08).
city('Bocos','ph','Cordillera',2428.0,121.02,16.93).
city('Bontoc','ph','Cordillera',10440.0,120.98,17.09).
city('Buguias','ph','Cordillera',6192.0,120.83,16.72).
city('Bulalacao','ph','Cordillera',3112.0,120.81,16.84).
city('Calaba','ph','Cordillera',2482.0,120.62,17.62).
city('Conner','ph','Cordillera',2401.0,121.33,17.8).
city('Dalipey','ph','Cordillera',2125.0,120.72,16.8).
city('Dalupirip','ph','Cordillera',2580.0,120.73,16.33).
city('Dolores','ph','Cordillera',23.0,120.71,17.65).
city('Flora','ph','Cordillera',4213.0,121.42,18.23).
city('Gambang','ph','Cordillera',3370.0,120.78,16.75).
city('Hapao','ph','Cordillera',2188.0,121.02,16.88).
city('Kabugao','ph','Cordillera',2337.0,121.18,18.02).
city('Kibungan','ph','Cordillera',7912.0,120.65,16.72).
city('La Paz','ph','Cordillera',3405.0,120.69,17.67).
city('Lagawe','ph','Cordillera',6820.0,121.1,16.82).
city('Lamut','ph','Cordillera',4089.0,121.23,16.65).
city('Laya','ph','Cordillera',3787.0,121.47,17.47).
city('Liwan','ph','Cordillera',5286.0,121.63,17.52).
city('Loacan','ph','Cordillera',6371.0,120.67,16.55).
city('Lubuagan','ph','Cordillera',2893.0,121.18,17.36).
city('Mankayan','ph','Cordillera',15886.0,120.78,16.86).
city('Monamon','ph','Cordillera',5371.0,120.88,16.88).
city('Nangalisan','ph','Cordillera',2297.0,120.55,16.4).
city('Natubleng','ph','Cordillera',2145.0,120.78,16.7).
city('Paracelis','ph','Cordillera',4232.0,121.47,17.27).
city('Pasil','ph','Cordillera',10109.0,121.13,17.38).
city('Pidigan','ph','Cordillera',2734.0,120.59,17.57).
city('Sablan','ph','Cordillera',2456.0,120.5,16.49).
city('Sadsadan','ph','Cordillera',2842.0,120.87,16.93).
city('Sagada','ph','Cordillera',2830.0,120.91,17.09).
city('San Ramon','ph','Cordillera',4054.0,120.71,17.41).
city('Tabaan','ph','Cordillera',2653.0,120.52,16.3).
city('Tabio','ph','Cordillera',3543.0,120.8,16.85).
city('Tabuk','ph','Cordillera',27048.0,121.43,17.41).
city('Tacadang','ph','Cordillera',2402.0,120.65,16.7).
city('Tadian','ph','Cordillera',2803.0,120.82,16.99).
city('Taga','ph','Cordillera',4898.0,121.36,17.57).
city('Taloy','ph','Cordillera',3485.0,120.5,16.33).
city('Tayum','ph','Cordillera',2530.0,120.65,17.62).
city('Topdac','ph','Cordillera',2289.0,120.7,16.55).
city('Tuba','ph','Cordillera',24482.0,120.55,16.32).
city('Tublay','ph','Cordillera',3706.0,120.62,16.52).
city('Tuding','ph','Cordillera',7491.0,120.64,16.41).
city('Abuyog','ph','Eastern Visayas',15632.0,125.01,10.75).
city('Alangalang','ph','Eastern Visayas',8095.0,124.85,11.21).
city('Albuera','ph','Eastern Visayas',4968.0,124.7,10.92).
city('Alegria','ph','Eastern Visayas',5811.0,124.33,12.39).
city('Allen','ph','Eastern Visayas',7502.0,124.29,12.5).
city('Almeria','ph','Eastern Visayas',2960.0,124.38,11.62).
city('Alugan','ph','Eastern Visayas',2131.0,125.48,12.22).
city('Anahawan','ph','Eastern Visayas',2640.0,124.87,10.35).
city('Anito','ph','Eastern Visayas',2070.0,125.29,12.45).
city('Arteche','ph','Eastern Visayas',5025.0,125.37,12.27).
city('Babatingon','ph','Eastern Visayas',6237.0,124.85,11.42).
city('Balagtas','ph','Eastern Visayas',2293.0,124.52,11.13).
city('Balangiga','ph','Eastern Visayas',5592.0,125.39,11.11).
city('Balangkayan','ph','Eastern Visayas',3159.0,125.51,11.47).
city('Balaquid','ph','Eastern Visayas',2502.0,124.51,11.47).
city('Balinsasayao','ph','Eastern Visayas',2404.0,124.96,10.68).
city('Balocawehay','ph','Eastern Visayas',3528.0,124.97,10.72).
city('Balugo','ph','Eastern Visayas',6704.0,124.71,10.89).
city('Bantayan','ph','Eastern Visayas',3976.0,124.84,12.52).
city('Bantigue','ph','Eastern Visayas',2026.0,124.41,10.93).
city('Baras','ph','Eastern Visayas',2764.0,125.02,11.18).
city('Barugo','ph','Eastern Visayas',6655.0,124.74,11.32).
city('Basey','ph','Eastern Visayas',7844.0,125.07,11.28).
city('Basud','ph','Eastern Visayas',2980.0,124.36,11.37).
city('Bato','ph','Eastern Visayas',9952.0,124.79,10.33).
city('Biliran','ph','Eastern Visayas',4699.0,124.48,11.47).
city('Bilwang','ph','Eastern Visayas',2808.0,124.47,10.88).
city('Biri','ph','Eastern Visayas',2597.0,124.36,12.68).
city('Bislig','ph','Eastern Visayas',2704.0,125.03,11.07).
city('Bitanhuan','ph','Eastern Visayas',2841.0,124.77,10.6).
city('Bobon','ph','Eastern Visayas',4775.0,124.56,12.53).
city('Bugko','ph','Eastern Visayas',3120.0,124.79,12.54).
city('Bunga','ph','Eastern Visayas',2900.0,124.69,11.13).
city('Butason','ph','Eastern Visayas',3232.0,124.46,11.31).
city('Cabadiangan','ph','Eastern Visayas',3002.0,125.04,12.67).
city('Cabatuan','ph','Eastern Visayas',2381.0,125.22,12.52).
city('Cabay','ph','Eastern Visayas',2297.0,125.49,11.45).
city('Cabucgayan','ph','Eastern Visayas',2700.0,124.58,11.47).
city('Cabuynan','ph','Eastern Visayas',2569.0,125.02,11.08).
city('Cagamutan','ph','Eastern Visayas',2688.0,125.28,12.36).
city('Caibiran','ph','Eastern Visayas',6461.0,124.58,11.57).
city('Calapi','ph','Eastern Visayas',2587.0,125.02,11.94).
city('Calbayog','ph','Eastern Visayas',67921.0,124.63,12.07).
city('Calbiga','ph','Eastern Visayas',2920.0,125.02,11.62).
city('Campokpok','ph','Eastern Visayas',5688.0,124.4,11.29).
city('Can-avid','ph','Eastern Visayas',5928.0,125.45,12.0).
city('Canhandugan','ph','Eastern Visayas',2104.0,124.78,11.14).
city('Capoocan','ph','Eastern Visayas',8474.0,124.64,11.29).
city('Capul','ph','Eastern Visayas',4756.0,124.18,12.42).
city('Caraycaray','ph','Eastern Visayas',3174.0,124.42,11.56).
city('Caridad','ph','Eastern Visayas',3688.0,124.75,10.83).
city('Carigara','ph','Eastern Visayas',17495.0,124.68,11.3).
city('Catbalogan','ph','Eastern Visayas',67958.0,124.89,11.77).
city('Catubig','ph','Eastern Visayas',4728.0,125.05,12.41).
city('Cervantes','ph','Eastern Visayas',2344.0,124.66,12.37).
city('Concepcion','ph','Eastern Visayas',2180.0,124.78,10.41).
city('Consuegra','ph','Eastern Visayas',3337.0,124.51,11.3).
city('Culaba','ph','Eastern Visayas',6232.0,124.54,11.66).
city('Culasian','ph','Eastern Visayas',2475.0,124.61,11.31).
city('Dagami','ph','Eastern Visayas',4387.0,124.9,11.06).
city('Dao','ph','Eastern Visayas',2361.0,125.44,12.1).
city('Dapdap','ph','Eastern Visayas',2223.0,125.49,12.06).
city('Daram','ph','Eastern Visayas',3069.0,124.8,11.64).
city('Dolores','ph','Eastern Visayas',5770.0,125.05,11.55).
city('Doos','ph','Eastern Visayas',2744.0,124.73,10.47).
city('Dulag','ph','Eastern Visayas',10151.0,125.03,10.95).
city('Erenas','ph','Eastern Visayas',2243.0,124.33,12.43).
city('Gabas','ph','Eastern Visayas',2255.0,124.8,10.73).
city('Gamay','ph','Eastern Visayas',9125.0,125.3,12.39).
city('Gandara','ph','Eastern Visayas',3982.0,124.81,12.01).
city('General MacArthur','ph','Eastern Visayas',4491.0,125.54,11.25).
city('Giporlos','ph','Eastern Visayas',5257.0,125.45,11.12).
city('Guindapunan','ph','Eastern Visayas',2279.0,124.71,11.3).
city('Guirang','ph','Eastern Visayas',2504.0,125.12,11.35).
city('Guiuan','ph','Eastern Visayas',11041.0,125.72,11.03).
city('Hebobollao','ph','Eastern Visayas',2487.0,125.09,12.37).
city('Hernani','ph','Eastern Visayas',2159.0,125.62,11.33).
city('Hinabuyan','ph','Eastern Visayas',2391.0,124.41,11.24).
city('Hindang','ph','Eastern Visayas',4106.0,124.73,10.43).
city('Hingatungan','ph','Eastern Visayas',2019.0,125.19,10.59).
city('Hinundayan','ph','Eastern Visayas',2693.0,125.25,10.36).
city('Ibarra','ph','Eastern Visayas',3065.0,124.88,10.12).
city('Ichon','ph','Eastern Visayas',3821.0,124.9,10.11).
city('Inangatan','ph','Eastern Visayas',3215.0,124.4,11.25).
city('Ipil','ph','Eastern Visayas',3854.0,124.64,10.97).
city('Isabel','ph','Eastern Visayas',8596.0,124.44,10.93).
city('Jaro','ph','Eastern Visayas',7934.0,124.78,11.19).
city('Javier','ph','Eastern Visayas',2949.0,124.94,10.8).
city('Jiabong','ph','Eastern Visayas',4076.0,124.95,11.76).
city('Jipapad','ph','Eastern Visayas',3797.0,125.24,12.29).
city('Jubasan','ph','Eastern Visayas',2328.0,124.29,12.48).
city('Julita','ph','Eastern Visayas',2997.0,124.96,10.97).
city('Kananga','ph','Eastern Visayas',7647.0,124.56,11.19).
city('Kilim','ph','Eas',3262.0,124.8,10.71).
city('La Paz','ph','Eastern Visayas',4146.0,124.96,10.89).
city('Lalawigan','ph','Eastern Visayas',2025.0,125.47,11.59).
city('Lamak','ph','Eastern Visayas',2201.0,124.74,10.4).
city('Lao','ph','Eastern Visayas',2154.0,124.56,11.02).
city('Lapinig','ph','Eastern Visayas',3684.0,125.3,12.32).
city('Las Navas','ph','Eastern Visayas',3415.0,125.03,12.34).
city('Lavezares','ph','Eastern Visayas',4082.0,124.33,12.53).
city('Lawaan','ph','Eastern Visayas',5018.0,125.3,11.14).
city('Lemon','ph','Eastern Visayas',2102.0,124.57,11.29).
city('Leyte','ph','Eastern Visayas',7223.0,124.49,11.37).
city('Libas','ph','Eastern Visayas',2056.0,124.54,10.94).
city('Libertad','ph','Eastern Visayas',3435.0,124.51,10.98).
city('Liberty','ph','Eastern Visayas',2323.0,125.0,10.87).
city('Liloan','ph','Eastern Visayas',3535.0,124.84,10.6).
city('Llorente','ph','Eastern Visayas',7908.0,125.55,11.41).
city('Looc','ph','Eastern Visayas',2209.0,124.56,11.48).
city('Lope de Vega','ph','Eastern Visayas',2532.0,124.62,12.3).
city('Mabini','ph','Eastern Visayas',2130.0,125.17,11.42).
city('MacArthur','ph','Eastern Visayas',2668.0,125.0,10.83).
city('MacKinley','ph','Eastern Visayas',2041.0,124.67,12.45).
city('Macrohon','ph','Eastern Visayas',2826.0,124.94,10.08).
city('Mahaplag','ph','Eastern Visayas',3866.0,124.97,10.59).
city('Makiwalo','ph','Eastern Visayas',4614.0,124.73,12.51).
city('Malaga','ph','Eastern Visayas',2156.0,124.38,12.24).
city('Malajog','ph','Eastern Visayas',2196.0,124.48,12.11).
city('Malitbog','ph','Eastern Visayas',2800.0,125.0,10.16).
city('Manlilinao','ph','Eastern Visayas',2397.0,124.5,11.11).
city('Mantang','ph','Eastern Visayas',2081.0,125.43,11.87).
city('Mapanas','ph','Eastern Visayas',3575.0,125.25,12.47).
city('Margen','ph','Eastern Visayas',2813.0,124.53,11.02).
city('Masarayao','ph','Eastern Visayas',2085.0,124.62,11.09).
city('Matag-ob','ph','Eastern Visayas',2831.0,124.47,11.12).
city('Matalom','ph','Eastern Visayas',4335.0,124.79,10.28).
city('Matlang','ph','Eastern Visayas',5840.0,124.46,10.89).
city('Maydolong','ph','Eastern Visayas',5492.0,125.5,11.5).
city('Mayorga','ph','Eastern Visayas',2721.0,125.0,10.9).
city('Maypangdan','ph','Eastern Visayas',2342.0,125.45,11.65).
city('Merida','ph','Eastern Visayas',3570.0,124.54,10.91).
city('Mondragon','ph','Eastern Visayas',5198.0,124.76,12.51).
city('Motiong','ph','Eastern Visayas',2507.0,125.0,11.78).
city('Naghalin','ph','Eastern Visayas',2977.0,124.57,11.15).
city('Napuro','ph','Eastern Visayas',2507.0,124.71,12.03).
city('Naval','ph','Eastern Visayas',12217.0,124.4,11.56).
city('Nena','ph','Eastern Visayas',2276.0,125.42,11.77).
city('Nenita','ph','Eastern Visayas',2551.0,124.8,12.49).
city('Omag','ph','Eastern Visayas',2032.0,124.37,11.33).
city('Oras','ph','Eastern Visayas',9022.0,125.44,12.13).
city('Ormoc','ph','Eastern Visayas',92345.0,124.61,11.01).
city('Palanit','ph','Eastern Visayas',3358.0,124.35,12.32).
city('Palapag','ph','Eastern Visayas',8342.0,125.12,12.55).
city('Palarao','ph','Eastern Visayas',2409.0,124.48,11.4).
city('Palhi','ph','Eastern Visayas',2185.0,124.8,10.65).
city('Palo','ph','Eastern Visayas',17534.0,124.99,11.16).
city('Palompon','ph','Eastern Visayas',12087.0,124.39,11.05).
city('Pambujan','ph','Eastern Visayas',10812.0,124.93,12.56).
city('Pangdan','ph','Eastern Visayas',2597.0,124.92,11.74).
city('Pangpang','ph','Eastern Visayas',2021.0,125.08,12.57).
city('Paranas','ph','Eastern Visayas',4703.0,125.02,11.77).
city('Pastrana','ph','Eastern Visayas',2730.0,124.89,11.14).
city('Pawing','ph','Eastern Visayas',3316.0,125.0,11.18).
city('Pena','ph','Eastern Visayas',3137.0,124.4,12.19).
city('Pinamopoan','ph','Eastern Visayas',2770.0,124.57,11.31).
city('Plaridel','ph','Eastern Visayas',3904.0,124.77,10.57).
city('Polahongon','ph','Eastern Visa',2730.0,124.97,10.53).
city('Polangi','ph','Eastern Visayas',2647.0,124.63,12.4).
city('Potong','ph','Eastern Visayas',2498.0,125.28,12.34).
city('Puerto Bello','ph','Eastern Visayas',2887.0,124.53,10.97).
city('Quinapondan','ph','Eastern Visayas',3471.0,125.52,11.16).
city('Rizal','ph','Eastern Visayas',3835.0,124.58,11.18).
city('Sabang','ph','Eastern Visayas',3522.0,124.54,12.08).
city('Salcedo','ph','Eastern Visayas',3603.0,125.67,11.15).
city('Salvacion','ph','Eastern Visayas',2519.0,125.04,12.62).
city('San Antonio','ph','Eastern Visayas',2509.0,124.65,11.85).
city('San Eduardo','ph','Eastern Visayas',2164.0,125.45,12.17).
city('San Francisco','ph','Eastern Visayas',2676.0,125.16,10.06).
city('San Isidro','ph','Eastern Visayas',3800.0,124.39,11.19).
city('San Joaquin','ph','Eastern Visayas',4497.0,124.43,12.17).
city('San Jose','ph','Eastern Visayas',3779.0,124.77,11.76).
city('San Jose de Buan','ph','Eastern Visayas',2811.0,125.03,12.05).
city('San Juan','ph','Eastern Visayas',2915.0,124.69,11.21).
city('San Julian','ph','Eastern Visayas',3069.0,125.46,11.75).
city('San Miguel','ph','Eastern Visayas',3401.0,124.83,11.27).
city('San Pedro','ph','Eastern Visayas',3603.0,124.82,10.96).
city('San Policarpio','ph','Eastern Visayas',5616.0,124.56,12.07).
city('San Policarpo','ph','Eastern Visayas',3581.0,125.51,12.18).
city('San Roque','ph','Eastern Visayas',5724.0,124.95,11.79).
city('San Sebastian','ph','Eastern Visayas',2018.0,125.02,11.71).
city('San Vicente','ph','Eastern Visayas',2280.0,124.33,11.7).
city('Santa Fe','ph','Eastern Visayas',2607.0,124.85,10.72).
city('Santa Margarita','ph','Eastern Visayas',4825.0,124.66,12.04).
city('Santa Paz','ph','Eastern Visayas',2046.0,124.78,10.27).
city('Santa Rita','ph','Eastern Visayas',4338.0,124.94,11.45).
city('Santo Nino','ph','Eastern Visayas',2438.0,124.51,11.5).
city('Seguinon','ph','Eastern Visayas',2211.0,124.69,10.94).
city('Silago','ph','Eastern Visayas',2276.0,125.17,10.53).
city('Silanga','ph','Eastern Visayas',2350.0,124.84,11.82).
city('Silvino Lobos','ph','Eastern Visayas',2720.0,124.83,12.3).
city('Sogod','ph','Eastern Visayas',8303.0,124.98,10.39).
city('Sulangan','ph','Eastern Visayas',3034.0,125.83,10.94).
city('Sulat','ph','Eastern Visayas',4684.0,125.45,11.81).
city('Tabango','ph','Eastern Visayas',5806.0,124.37,11.31).
city('Tabing','ph','Eastern Visayas',2345.0,124.35,11.4).
city('Tabontabon','ph','Eastern Visayas',2557.0,124.96,11.04).
city('Tabunok','ph','Eastern Visayas',2670.0,124.8,10.35).
city('Tacloban','ph','Eastern Visayas',189087.0,125.02,11.29).
city('Taft','ph','Eastern Visayas',4421.0,125.42,11.9).
city('Tagbubunga','ph','Eastern Visayas',2489.0,124.41,11.12).
city('Talalora','ph','Eastern Visayas',2186.0,124.84,11.53).
city('Talisayan','ph','Eastern Visayas',2332.0,124.7,10.95).
city('Tanauan','ph','Eastern Visayas',16567.0,125.02,11.11).
city('Tarangnan','ph','Eastern Visayas',2762.0,124.75,11.9).
city('Tinambacan','ph','Eastern Visayas',4555.0,124.5,12.09).
city('Tomas Oppus','ph','Eastern Visayas',2446.0,124.98,10.25).
city('Tucdao','ph','Eastern Visayas',2424.0,124.47,11.7).
city('Tugbong','ph','Eastern Visayas',2636.0,124.6,11.02).
city('Tunga','ph','Eastern Visayas',2932.0,124.75,11.25).
city('Tutubigan','ph','Eastern Visayas',2030.0,125.06,11.84).
city('Utod','ph','Eastern Visayas',2364.0,124.77,10.55).
city('Valencia','ph','Eastern Visayas',3771.0,124.57,11.11).
city('Victoria','ph','Eastern Visayas',2718.0,124.31,12.45).
city('Vigo','ph','Eastern Visayas',2024.0,125.05,12.52).
city('Villaba','ph','Eastern Visayas',3266.0,124.39,11.21).
city('Villareal','ph','Eastern Visayas',3765.0,124.93,11.56).
city('Acao','ph','Ilocos',4307.0,120.38,16.53).
city('Agno','ph','Ilocos',2638.0,119.8,16.12).
city('Agoo','ph','Ilocos',28971.0,120.1,16.08).
city('Aguilar','ph','Ilocos',9801.0,120.24,15.89).
city('Alac','ph','Ilocos',3430.0,120.81,15.99).
city('Alaminos','ph','Ilocos',10488.0,119.98,16.16).
city('Alcala','ph','Ilocos',8883.0,120.52,15.85).
city('Allangigan','ph','Ilocos',2219.0,120.5,17.17).
city('Aloleng','ph','Ilocos',2389.0,119.77,16.12).
city('Amagbagan','ph','Ilocos',2443.0,120.53,16.1).
city('Anda','ph','Ilocos',3160.0,119.95,16.29).
city('Angatel','ph','Ilocos',2359.0,120.33,15.8).
city('Anonang','ph','Ilocos',7036.0,120.43,16.12).
city('Anulid','ph','Ilocos',2177.0,120.48,15.83).
city('Aringay','ph','Ilocos',29825.0,120.36,16.4).
city('Asin','ph','Ilocos',3550.0,120.45,15.83).
city('Baay','ph','Ilocos',3045.0,120.58,18.12).
city('Bacag','ph','Ilocos',5509.0,120.58,15.93).
city('Bacarra','ph','Ilocos',9636.0,120.61,18.25).
city('Bacnar','ph','Ilocos',4606.0,120.33,15.88).
city('Bacnotan','ph','Ilocos',3142.0,120.35,16.72).
city('Bactad','ph','Ilocos',3610.0,120.62,15.98).
city('Badoc','ph','Ilocos',4319.0,120.47,17.93).
city('Bail','ph','Ilocos',2120.0,120.35,16.27).
city('Balaoan','ph','Ilocos',2928.0,120.4,16.82).
city('Balingasay','ph','Ilocos',3720.0,119.86,16.36).
city('Balingueo','ph','Ilocos',2906.0,120.4,15.95).
city('Balogo','ph','Ilocos',2298.0,120.28,15.98).
city('Baluyot','ph','Ilocos',3176.0,120.45,15.8).
city('Bamban','ph','Ilocos',2783.0,119.95,15.84).
city('Banaoang','ph','Ilocos',3784.0,120.36,16.04).
city('Bangan-Oda','ph','Ilocos',3456.0,119.83,16.11).
city('Bangar','ph','Ilocos',11068.0,120.42,16.9).
city('Bangui','ph','Ilocos',2458.0,120.76,18.54).
city('Bani','ph','Ilocos',6944.0,120.15,16.01).
city('Banna','ph','Ilocos',3566.0,120.65,17.98).
city('Banog','ph','Ilocos',3700.0,119.91,16.17).
city('Bantay','ph','Ilocos',10091.0,120.39,17.58).
city('Bantog','ph','Ilocos',4111.0,120.69,16.01).
city('Barangobong','ph','Ilocos',3644.0,120.55,15.88).
city('Baraoas','ph','Ilocos',3556.0,120.4,16.63).
city('Baro','ph','Ilocos',2906.0,120.67,15.98).
city('Barong','ph','Ilocos',2392.0,120.73,18.06).
city('Basing','ph','Ilocos',2367.0,120.27,15.98).
city('Basista','ph','Ilocos',2781.0,120.4,15.86).
city('Batakil','ph','Ilocos',2504.0,120.53,16.16).
city('Bautista','ph','Ilocos',3097.0,120.48,15.81).
city('Baybay','ph','Ilocos',2748.0,120.16,16.01).
city('Bical','ph','Ilocos',3550.0,120.43,15.82).
city('Bil-loca','ph','Ilocos',2219.0,120.57,18.1).
city('Binabalian','ph','Ilocos',3298.0,119.93,16.42).
city('Binalonan','ph','Ilocos',8145.0,120.6,16.05).
city('Binday','ph','Ilocos',2236.0,120.45,16.13).
city('Bobonan','ph','Ilocos',2454.0,120.52,16.15).
city('Bogtong','ph','Ilocos',3999.0,120.32,15.75).
city('Bolaoit','ph','Ilocos',2386.0,120.43,15.93).
city('Bolo','ph','Ilocos',2784.0,120.17,15.98).
city('Bongalon','ph','Ilocos',2181.0,120.15,16.01).
city('Botao','ph','Ilocos',2719.0,120.42,15.92).
city('Bued','ph','Ilocos',2432.0,120.33,16.0).
city('Buenlag','ph','Ilocos',6703.0,120.46,15.9).
city('Buer','ph','Ilocos',3088.0,120.27,15.83).
city('Bugayong','ph','Ilocos',2910.0,120.58,16.09).
city('Burgos','ph','Ilocos',3236.0,119.87,16.06).
city('Butubut','ph','Ilocos',3193.0,120.45,16.81).
city('Caba','ph','Ilocos',4806.0,120.35,16.43).
city('Cabalaoangan','ph','Ilocos',2674.0,120.78,15.98).
city('Cabalitian','ph','Ilocos',2253.0,120.78,16.08).
city('Cabilocaan','ph','Ilocos',2488.0,119.93,16.08).
city('Cabittaogan','ph','Ilocos',2455.0,120.37,17.58).
city('Cabugao','ph','Ilocos',6874.0,120.46,17.0).
city('Cabungan','ph','Ilocos',3059.0,120.0,16.33).
city('Callaguip','ph','Ilocos',2105.0,120.49,18.07).
city('Calomboyan','ph','Ilocos',2809.0,120.3,15.95).
city('Calongbuyan','ph','Ilocos',2324.0,120.47,17.18).
city('Calsib','ph','Ilocos',2157.0,120.28,15.85).
city('Camaley','ph','Ilocos',2297.0,120.3,16.0).
city('Cambaly','ph','Ilocos',2083.0,120.44,16.61).
city('Canan','ph','Ilocos',2780.0,120.48,15.9).
city('Cantoria','ph','Ilocos',2552.0,120.4,16.85).
city('Caoayan','ph','Ilocos',2739.0,120.24,16.82).
city('Capandanan','ph','Ilocos',2462.0,120.68,15.95).
city('Capulaan','ph','Ilocos',2949.0,120.54,15.9).
city('Caramutan','ph','Ilocos',6525.0,120.62,15.92).
city('Carmen','ph','Ilocos',10250.0,120.6,15.88).
city('Carosucan','ph','Ilocos',7083.0,120.64,15.97).
city('Carot','ph','Ilocos',2939.0,119.98,16.35).
city('Carriedo','ph','Ilocos',2524.0,120.77,16.03).
city('Catablan','ph','Ilocos',5090.0,120.46,15.98).
city('Caterman','ph','Ilocos',2195.0,120.42,17.2).
city('Cato','ph','Ilocos',4530.0,119.92,15.84).
city('Catuday','ph','Ilocos',2149.0,119.81,16.29).
city('Cayungnan','ph','Ilocos',2082.0,119.83,16.13).
city('Cervantes','ph','Ilocos',3099.0,120.73,16.99).
city('Comillas','ph','Ilocos',3148.0,120.75,16.96).
city('Concepcion','ph','Ilocos',2347.0,120.47,16.22).
city('Corrooy','ph','Ilocos',2233.0,120.42,16.8).
city('Dagup','ph','Ilocos',2090.0,120.45,16.64).
city('Dagupan','ph','Ilocos',135933.0,120.52,16.1).
city('Damortis','ph','Ilocos',2272.0,120.41,16.24).
city('Darapidap','ph','Ilocos',2684.0,120.41,17.21).
city('Dasol','ph','Ilocos',3892.0,119.88,15.98).
city('Davila','ph','Ilocos',3465.0,120.58,18.47).
city('Dewey','ph','Ilocos',2199.0,119.96,16.41).
city('Diaz','ph','Ilocos',4017.0,120.83,15.88).
city('Dilan','ph','Ilocos',4031.0,120.52,16.08).
city('Dinalaoan','ph','Ilocos',3492.0,120.33,16.0).
city('Dingras','ph','Ilocos',6866.0,120.69,18.11).
city('Domalandan','ph','Ilocos',15108.0,120.18,16.02).
city('Domanpot','ph','Ilocos',5340.0,120.65,16.0).
city('Don Pedro','ph','Ilocos',2854.0,120.43,15.88).
city('Dorongan','ph','Ilocos',5336.0,120.32,15.82).
city('Doyong','ph','Ilocos',3398.0,120.37,15.97).
city('Dulig','ph','Ilocos',2572.0,120.19,16.0).
city('Dumpay','ph','Ilocos',5414.0,120.39,15.88).
city('Eguia','ph','Ilocos',3033.0,119.89,15.91).
city('Esmeralda','ph','Ilocos',2674.0,120.72,15.87).
city('Fuerte','ph','Ilocos',2558.0,120.36,17.54).
city('Gayaman','ph','Ilocos',3765.0,120.31,16.01).
city('Guiling','ph','Ilocos',2873.0,120.61,15.85).
city('Guiset','ph','Ilocos',21995.0,120.68,16.07).
city('Hacienda','ph','Ilocos',2540.0,120.18,15.93).
city('Halog','ph','Ilocos',2496.0,120.43,16.37).
city('Ili','ph','Ilocos',4908.0,120.34,16.67).
city('Ilio-ilio','ph','Ilocos',2123.0,119.77,15.96).
city('Inabaan','ph','Ilocos',2830.0,120.48,16.26).
city('Infanta','ph','Ilocos',3161.0,119.91,15.83).
city('Isla','ph','Ilocos',2447.0,120.3,15.89).
city('La Paz','ph','Ilocos',2080.0,120.75,15.9).
city('Labayug','ph','Ilocos',2874.0,120.57,16.15).
city('Labney','ph','Ilocos',2150.0,120.47,16.1).
city('Labrador','ph','Ilocos',2108.0,120.14,16.03).
city('Lagasit','ph','Ilocos',3147.0,120.79,16.0).
city('Laguit','ph','Ilocos',4533.0,120.2,15.95).
city('Laoag','ph','Ilocos',102109.0,120.59,18.2).
city('Lapog','ph','Ilocos',3148.0,120.46,17.74).
city('Legaspi','ph','Ilocos',3281.0,120.82,16.03).
city('Leones','ph','Ilocos',2713.0,120.4,16.37).
city('Lepa','ph','Ilocos',8877.0,120.45,15.89).
city('Libas','ph','Ilocos',3311.0,120.3,15.87).
city('Linmansangan','ph','Ilocos',3872.0,120.28,15.8).
city('Lipay','ph','Ilocos',2078.0,120.41,16.71).
city('Lloren','ph','Ilocos',5800.0,120.42,16.34).
city('Lobong','ph','Ilocos',3641.0,120.47,16.08).
city('Longos','ph','Ilocos',2638.0,120.4,16.11).
city('Loqueb','ph','Ilocos',6141.0,120.43,15.95).
city('Lucap','ph','Ilocos',4935.0,120.0,16.18).
city('Lucero','ph','Ilocos',2990.0,119.92,16.42).
city('Luna','ph','Ilocos',2321.0,119.9,16.35).
city('Lunec','ph','Ilocos',2317.0,120.48,15.95).
city('Lungog','ph','Ilocos',2097.0,120.48,17.46).
city('Luzong','ph','Ilocos',2207.0,120.44,16.87).
city('Mabilao','ph','Ilocos',2397.0,120.42,16.15).
city('Mabilbila','ph','Ilocos',2408.0,120.44,17.51).
city('Mabini','ph','Ilocos',2859.0,119.94,16.07).
city('Mabusag','ph','Ilocos',2249.0,120.51,17.93).
city('Macaboboni','ph','Ilocos',2461.0,119.79,16.2).
city('Macalong','ph','Ilocos',5802.0,120.65,16.02).
city('Macalva','ph','Ilocos',2874.0,120.39,16.35).
city('Macayug','ph','Ilocos',2432.0,120.42,16.08).
city('Magallanes','ph','Ilocos',2487.0,120.74,15.99).
city('Magsingal','ph','Ilocos',4571.0,120.42,17.69).
city('Magtaking','ph','Ilocos',5946.0,120.18,15.98).
city('Malabago','ph','Ilocos',3618.0,120.35,15.99).
city('Malawa','ph','Ilocos',2102.0,120.27,15.97).
city('Malibong','ph','Ilocos',2313.0,120.32,15.83).
city('Manaoag','ph','Ilocos',59115.0,120.49,16.04).
city('Mangaldan','ph','Ilocos',88828.0,120.39,16.08).
city('Mapandan','ph','Ilocos',11166.0,120.45,16.02).
city('Mapolopolo','ph','Ilocos',2219.0,120.38,15.88).
city('Maticmatic','ph','Ilocos',3552.0,120.43,16.0).
city('Minien','ph','Ilocos',6111.0,120.49,15.98).
city('Nagbacalan','ph','Ilocos',2778.0,120.52,18.11).
city('Nagsabaran','ph','Ilocos',2533.0,120.33,16.67).
city('Nagsaing','ph','Ilocos',7482.0,120.33,15.98).
city('Naguelguel','ph','Ilocos',3124.0,120.27,16.01).
city('Naguilayan','ph','Ilocos',3777.0,120.28,16.0).
city('Naguilian','ph','Ilocos',9691.0,120.4,16.53).
city('Nalsian','ph','Ilocos',3157.0,120.45,15.85).
city('Nalvo','ph','Ilocos',2324.0,120.35,16.85).
city('Nama','ph','Ilocos',2355.0,120.55,16.12).
city('Namboongan','ph','Ilocos',2329.0,120.38,16.3).
city('Nancalabasaan','ph','Ilocos',2139.0,120.86,15.94).
city('Narvacan','ph','Ilocos',3019.0,120.48,17.42).
city('Natividad','ph','Ilocos',5828.0,120.8,16.04).
city('Navatat','ph','Ilocos',2493.0,120.4,15.87).
city('Nibaliw','ph','Ilocos',13630.0,120.39,16.12).
city('Nilombot','ph','Ilocos',7605.0,120.43,16.03).
city('Oaqui','ph','Ilocos',2304.0,120.42,16.86).
city('Olea','ph','Ilocos',2434.0,120.5,15.87).
city('Olo','ph','Ilocos',3468.0,120.32,15.77).
city('Padong','ph','Ilocos',3361.0,120.76,18.05).
city('Pagudpud','ph','Ilocos',4945.0,120.78,18.56).
city('Paitan','ph','Ilocos',2826.0,120.03,16.08).
city('Palacpalac','ph','Ilocos',2956.0,120.54,16.13).
city('Paldit','ph','Ilocos',3664.0,120.53,16.17).
city('Palguyod','ph','Ilocos',3230.0,120.52,16.12).
city('Panganiban','ph','Ilocos',2698.0,120.77,16.02).
city('Pangapisan','ph','Ilocos',2602.0,119.98,16.2).
city('Pangascasan','ph','Ilocos',2644.0,120.08,16.12).
city('Pangpang','ph','Ilocos',2592.0,120.31,15.94).
city('Paoay','ph','Ilocos',3284.0,120.52,18.06).
city('Paringao','ph','Ilocos',6570.0,120.32,16.57).
city('Parioc','ph','Ilocos',2718.0,120.47,17.17).
city('Pasibi','ph','Ilocos',3201.0,120.37,15.85).
city('Pasuquin','ph','Ilocos',5768.0,120.62,18.33).
city('Patac','ph','Ilocos',2553.0,120.38,16.28).
city('Patayac','ph','Ilocos',2497.0,120.43,15.96).
city('Patpata','ph','Ilocos',2567.0,120.43,17.18).
city('Payas','ph','Ilocos',3108.0,120.42,15.98).
city('Payocpoc','ph','Ilocos',13107.0,120.33,16.5).
city('Piddig','ph','Ilocos',3508.0,120.73,18.16).
city('Pindangan','ph','Ilocos',4101.0,120.55,15.86).
city('Pinili','ph','Ilocos',2310.0,120.53,17.95).
city('Pogonsili','ph','Ilocos',2214.0,120.25,15.86).
city('Polo','ph','Ilocos',2343.0,119.95,16.2).
city('Polong','ph','Ilocos',2949.0,120.32,15.94).
city('Pudoc','ph','Ilocos',2635.0,120.4,17.27).
city('Puelay','ph','Ilocos',6854.0,120.57,15.89).
city('Pugo','ph','Ilocos',2354.0,120.47,16.32).
city('Puro','ph','Ilocos',4035.0,120.36,17.68).
city('Quiling','ph','Ilocos',3570.0,120.54,18.07).
city('Quinarayan','ph','Ilocos',2558.0,120.47,17.45).
city('Quintong','ph','Ilocos',3162.0,120.27,16.0).
city('Ranao','ph','Ilocos',2112.0,119.81,16.21).
city('Real','ph','Ilocos',2256.0,120.35,15.81).
city('Rimos','ph','Ilocos',6670.0,120.39,16.87).
city('Rissing','ph','Ilocos',2117.0,120.38,16.85).
city('Rosario','ph','Ilocos',7763.0,120.53,16.17).
city('Sablig','ph','Ilocos',2482.0,119.98,16.27).
city('Sagunto','ph','Ilocos',2082.0,120.52,16.2).
city('Salomague','ph','Ilocos',4238.0,120.22,15.92).
city('Samon','ph','Ilocos',2112.0,120.66,15.94).
city('San Antonio','ph','Ilocos',3655.0,120.77,16.08).
city('San Carlos','ph','Ilocos',91673.0,120.37,15.98).
city('San Eugenio','ph','Ilocos',3719.0,120.36,16.36).
city('San Felipe','ph','Ilocos',3801.0,120.63,16.06).
city('San Fernando','ph','Ilocos',83961.0,120.32,16.61).
city('San Gabriel','ph','Ilocos',3854.0,120.44,16.22).
city('San Jacinto','ph','Ilocos',10529.0,120.44,16.07).
city('San Jose','ph','Ilocos',2258.0,120.39,16.43).
city('San Juan','ph','Ilocos',2558.0,120.67,16.04).
city('San Lorenzo','ph','Ilocos',2177.0,120.63,18.13).
city('San Miguel','ph','Ilocos',6061.0,120.35,16.03).
city('San Nicolas','ph','Ilocos',11706.0,120.69,17.12).
city('San Pedro','ph','Ilocos',3445.0,120.65,15.88).
city('San Pedro Apartado','ph','Ilocos',3331.0,120.57,15.84).
city('San Rafael','ph','Ilocos',2574.0,120.73,16.07).
city('San Roque','ph','Ilocos',4605.0,120.75,16.05).
city('San Sebastian','ph','Ilocos',2795.0,120.36,17.63).
city('San Vicente','ph','Ilocos',3491.0,120.39,16.0).
city('Sanlibo','ph','Ilocos',2609.0,120.55,15.92).
city('Santa','ph','Ilocos',2283.0,120.44,17.49).
city('Santa Catalina','ph','Ilocos',2727.0,120.61,16.08).
city('Santa Cruz','ph','Ilocos',2826.0,120.45,17.09).
city('Santa Lucia','ph','Ilocos',2651.0,120.45,17.12).
city('Santa Maria','ph','Ilocos',3477.0,120.61,16.37).
city('Santa Maria Norte','ph','Ilocos',2458.0,120.59,16.08).
city('Santo Domingo','ph','Ilocos',7029.0,120.64,16.06).
city('Santo Tomas','ph','Ilocos',2490.0,120.73,16.09).
city('Sapang','ph','Ilocos',2078.0,120.4,15.98).
city('Sarrat','ph','Ilocos',5822.0,120.65,18.16).
city('Sinait','ph','Ilocos',3123.0,120.46,17.87).
city('Sison','ph','Ilocos',9256.0,120.52,16.17).
city('Solsona','ph','Ilocos',3725.0,120.77,18.09).
city('Sonquil','ph','Ilocos',2347.0,120.38,16.0).
city('Sual','ph','Ilocos',5290.0,120.09,16.07).
city('Subusub','ph','Ilocos',6887.0,120.5,16.22).
city('Sumabnit','ph','Ilocos',4296.0,120.58,16.03).
city('Suso','ph','Ilocos',2280.0,120.46,17.36).
city('Suyo','ph','Ilocos',3493.0,120.53,16.98).
city('Tablac','ph','Ilocos',2903.0,120.48,17.22).
city('Taboc','ph','Ilocos',2546.0,120.34,16.69).
city('Tabug','ph','Ilocos',3281.0,120.55,18.03).
city('Tagudin','ph','Ilocos',3468.0,120.2,16.51).
city('Talospatang','ph','Ilocos',3057.0,120.45,15.92).
city('Taloy','ph','Ilocos',2352.0,120.47,15.95).
city('Tamayo','ph','Ilocos',5767.0,120.28,15.88).
city('Tamorong','ph','Ilocos',2442.0,120.43,17.33).
city('Tandoc','ph','Ilocos',3191.0,120.33,15.97).
city('Tanolong','ph','Ilocos',2779.0,120.4,15.82).
city('Tayug','ph','Ilocos',11611.0,120.75,16.03).
city('Tebag','ph','Ilocos',2779.0,120.47,15.98).
city('Telbang','ph','Ilocos',2795.0,120.06,16.17).
city('Tiep','ph','Ilocos',2178.0,119.86,16.24).
city('Toboy','ph','Ilocos',3082.0,120.64,16.03).
city('Tobuan','ph','Ilocos',2772.0,120.11,16.06).
city('Tococ','ph','Ilocos',2266.0,120.42,15.83).
city('Tocok','ph','Ilocos',3067.0,120.3,15.75).
city('Tombod','ph','Ilocos',206.0,120.55,15.95).
city('Tondol','ph','Ilocos',2680.0,120.01,16.31).
city('Toritori','ph','Ilocos',2076.0,119.98,16.23).
city('Torres','ph','Ilocos',2489.0,120.48,16.01).
city('Umanday','ph','Ilocos',4701.0,120.22,15.94).
city('Unzad','ph','Ilocos',3570.0,120.54,15.92).
city('Urbiztondo','ph','Ilocos',12734.0,120.33,15.82).
city('Urdaneta','ph','Ilocos',102827.0,120.57,15.98).
city('Uyong','ph','Ilocos',2728.0,120.13,16.05).
city('Vigan','ph','Ilocos',37521.0,120.37,17.56).
city('Villanueva','ph','Ilocos',2592.0,120.55,15.78).
city('Vintar','ph','Ilocos',5263.0,120.64,18.23).
city('Zaragoza','ph','Ilocos',7391.0,119.94,16.39).
city('Ampatuan','ph','Muslim Mindanao',3962.0,124.47,6.87).
city('Andalan','ph','Muslim Mindanao',2644.0,121.39,5.96).
city('Anuling','ph','Muslim Mindanao',10039.0,121.01,6.04).
city('Awang','ph','Muslim Mindanao',8417.0,124.22,7.15).
city('Bacayawan','ph','Muslim Mindanao',3234.0,124.23,7.77).
city('Badak','ph','Muslim Mindanao',6653.0,124.72,6.85).
city('Bagan','ph','Muslim Mindanao',2230.0,124.42,6.93).
city('Baka','ph','Muslim Mindanao',2404.0,124.26,7.28).
city('Bakong','ph','Muslim Mindanao',3185.0,119.79,4.89).
city('Balabagan','ph','Muslim Mindanao',2422.0,124.11,7.53).
city('Balatungkayo','ph','Muslim Mindanao',2219.0,124.73,7.1).
city('Bangkal','ph','Muslim Mindanao',2288.0,121.07,6.07).
city('Barira','ph','Muslim Mindanao',3717.0,124.3,7.49).
city('Barurao','ph','Muslim Mindanao',2990.0,124.6,6.9).
city('Bato-bato','ph','Muslim Mindanao',3735.0,120.95,6.03).
city('Batu-batu','ph','Muslim Mindanao',8881.0,119.89,5.07).
city('Bawisan','ph','Muslim Mindanao',3461.0,120.88,5.94).
city('Bayang','ph','Muslim Mindanao',6176.0,124.19,7.79).
city('Bayanga','ph','Muslim Mindanao',5087.0,124.25,7.52).
city('Binidayan','ph','Muslim Mindanao',3848.0,124.17,7.81).
city('Binuang','ph','Muslim Mindanao',3159.0,121.06,5.96).
city('Blensong','ph','Muslim Mindanao',4151.0,124.18,7.02).
city('Bongued','ph','Muslim Mindanao',2684.0,124.4,7.12).
city('Bualan','ph','Muslim Mindanao',3007.0,124.27,7.45).
city('Buan','ph','Muslim Mindanao',2788.0,120.46,5.36).
city('Buanza','ph','Muslim Mindanao',3196.0,120.97,6.02).
city('Bugasan','ph','Muslim Mindanao',7754.0,124.26,7.44).
city('Buliok','ph','Muslim Mindanao',3713.0,124.7,7.02).
city('Bulit','ph','Muslim Mindanao',2219.0,124.79,7.12).
city('Buluan','ph','Muslim Mindanao',28025.0,124.8,6.72).
city('Butig','ph','Muslim Mindanao',6016.0,124.3,7.72).
city('Cagayan de Tawi-Tawi','ph','Muslim Mindanao',3847.0,118.51,6.98).
city('Capual Island','ph','Muslim Mindanao',6250.0,121.41,6.04).
city('Dados','ph','Muslim Mindanao',2325.0,124.32,7.06).
city('Dalumangcob','ph','Muslim Mindanao',9424.0,124.3,7.22).
city('Damabalas','ph','Muslim Mindanao',3230.0,124.51,7.02).
city('Datu Paglas','ph','Muslim Mindanao',3851.0,124.85,6.77).
city('Digal','ph','Muslim Mindanao',6810.0,124.8,6.75).
city('Dinganen','ph','Muslim Mindanao',4623.0,124.38,7.33).
city('Edcor','ph','Muslim Mindanao',2483.0,124.4,7.44).
city('Gadung','ph','Muslim Mindanao',2456.0,124.02,6.8).
city('Ganassi','ph','Muslim Mindanao',2412.0,124.1,7.83).
city('Gang','ph','Muslim Mindanao',3317.0,124.27,7.25).
city('Idtig','ph','Muslim Mindanao',3969.0,124.77,6.8).
city('Kagay','ph','Muslim Mindanao',2318.0,120.91,6.01).
city('Kajatian','ph','Muslim Mindanao',5436.0,120.99,6.03).
city('Kalang','ph','Muslim Mindanao',2323.0,121.36,5.92).
city('Kalbugan','ph','Muslim Mindanao',3227.0,124.66,6.96).
city('Kambing','ph','Muslim Mindanao',2373.0,121.26,5.9).
city('Kanlagay','ph','Muslim Mindanao',2211.0,121.29,5.88).
city('Karungdong','ph','Muslim Mindanao',7269.0,121.26,5.88).
city('Katidtuan','ph','Muslim Mindanao',4710.0,124.32,7.19).
city('Katuli','ph','Muslim Mindanao',4732.0,124.22,7.43).
city('Kauran','ph','Muslim Mindanao',5120.0,124.47,6.79).
city('Kitango','ph','Muslim Mindanao',2608.0,124.44,6.95).
city('Kitapok','ph','Muslim Mindanao',2924.0,124.43,6.95).
city('Kulasi','ph','Muslim Mindanao',7148.0,120.99,5.92).
city('Kulay-kulay','ph','Muslim Mindanao',2783.0,121.23,5.95).
city('Kungtad','ph','Muslim Mindanao',2464.0,120.85,5.56).
city('Laminusa','ph','Muslim Mindanao',8113.0,120.91,5.55).
city('Langpas','ph','Muslim Mindanao',2378.0,120.95,5.98).
city('Languyan','ph','Muslim Mindanao',8900.0,120.08,5.27).
city('Larap','ph','Muslim Mindanao',4113.0,119.41,4.76).
city('Latung','ph','Muslim Mindanao',2964.0,120.88,5.5).
city('Layog','ph','Muslim Mindanao',2588.0,124.73,7.08).
city('Ligayan','ph','Muslim Mindanao',2319.0,119.47,4.65).
city('Limbo','ph','Muslim Mindanao',4841.0,124.24,7.25).
city('Litayen','ph','Muslim Mindanao',5294.0,124.03,7.31).
city('Lookan','ph','Muslim Mindanao',2758.0,120.1,5.04).
city('Lugus','ph','Muslim Mindanao',7167.0,120.81,5.7).
city('Lumbac','ph','Muslim Mindanao',2448.0,124.25,7.73).
city('Luuk','ph','Muslim Mindanao',9558.0,121.31,5.97).
city('Luuk Datan','ph','Muslim Mindanao',2567.0,119.85,4.81).
city('Mahala','ph','Muslim Mindanao',2427.0,121.13,5.92).
city('Maimbung','ph','Muslim Mindanao',3779.0,121.03,5.93).
city('Makir','ph','Muslim Mindanao',2371.0,124.3,7.03).
city('Malabang','ph','Muslim Mindanao',4354.0,124.07,7.59).
city('Manubul','ph','Muslim Mindanao',4736.0,120.8,5.47).
city('Manuk Mangkaw','ph','Muslim Mindanao',4981.0,119.85,4.8).
city('Marantao','ph','Muslim Mindanao',3572.0,124.23,7.95).
city('Marogong','ph','Muslim Mindanao',3785.0,124.15,7.67).
city('Marsada','ph','Muslim Mindanao',2571.0,121.11,5.93).
city('Mataya','ph','Muslim Mindanao',3136.0,124.37,7.47).
city('Mauboh','ph','Muslim Mindanao',2561.0,121.09,5.99).
city('Mileb','ph','Muslim Mindanao',2758.0,124.58,6.9).
city('Nunangan','ph','Muslim Mindanao',2978.0,124.37,6.98).
city('Nuyo','ph','Muslim Mindanao',2224.0,124.41,7.42).
city('Pagatin','ph','Muslim Mindanao',3079.0,124.48,6.97).
city('Panabuan','ph','Muslim Mindanao',2528.0,120.96,5.96).
city('Panadtaban','ph','Muslim Mindanao',2324.0,124.64,6.9).
city('Pandakan','ph','Muslim Mindanao',3161.0,121.17,5.99).
city('Pandan Niog','ph','Muslim Mindanao',3192.0,120.56,6.25).
city('Pang','ph','Muslim Mindanao',2563.0,121.29,5.95).
city('Panglima Alari','ph','Muslim Mindanao',7102.0,119.97,5.08).
city('Parang','ph','Muslim Mindanao',27306.0,122.59,6.64).
city('Parangan','ph','Muslim Mindanao',2432.0,119.94,5.08).
city('Parian Dakula','ph','Muslim Mindanao',4005.0,120.77,5.56).
city('Pawak','ph','Muslim Mindanao',2555.0,124.26,8.02).
city('Payuhan','ph','Muslim Mindanao',4519.0,120.9,5.94).
city('Pidsandawan','ph','Muslim Mindanao',2481.0,124.59,6.93).
city('Pigkelegan','ph','Muslim Mindanao',6083.0,124.32,7.23).
city('Pinaring','ph','Muslim Mindanao',2247.0,124.31,7.23).
city('Pitogo','ph','Muslim Mindanao',3493.0,121.31,5.89).
city('Polloc','ph','Muslim Mindanao',3140.0,124.22,7.36).
city('Punay','ph','Muslim Mindanao',6099.0,121.2,5.96).
city('Romangaob','ph','Muslim Mindanao',12538.0,124.15,6.83).
city('Rominimbang','ph','Muslim Mindanao',2485.0,124.3,7.5).
city('Sambulawan','ph','Muslim Mindanao',2679.0,124.7,6.88).
city('Sanga-sanga','ph','Muslim Mindanao',5295.0,119.79,5.07).
city('Sapa','ph','Muslim Mindanao',2572.0,120.33,5.15).
city('Sapad','ph','Muslim Mindanao',4376.0,124.25,7.48).
city('Satan','ph','Muslim Mindanao',4068.0,124.41,6.86).
city('Seit','ph','Muslim Mindanao',14552.0,121.22,5.98).
city('Simbahan','ph','Muslim Mindanao',4712.0,120.59,6.3).
city('Simuay','ph','Muslim Mindanao',4666.0,124.31,7.28).
city('Sionogan','ph','Muslim Mindanao',2730.0,120.95,6.01).
city('Sitangkai','ph','Muslim M',17200.0,119.39,4.66).
city('Tabialan','ph','Muslim Mindanao',2312.0,121.89,6.03).
city('Taganak','ph','Muslim Mindanao',2638.0,118.3,6.08).
city('Talitay','ph','Muslim Mindanao',3983.0,124.7,7.03).
city('Tampakan','ph','Muslim Mindanao',8306.0,119.79,4.92).
city('Tamparan','ph','Muslim Mindanao',2396.0,124.33,7.88).
city('Tapayan','ph','Muslim Mindanao',3240.0,124.27,7.29).
city('Tapikan','ph','Muslim Mindanao',2232.0,124.34,6.84).
city('Taviran','ph','Muslim Mindanao',2851.0,124.32,7.12).
city('Timbangan','ph','Muslim Mindanao',2230.0,121.0,6.0).
city('Tonggusong Banaran','ph','Muslim Mindanao',6267.0,120.13,5.02).
city('Tubig Indangan','ph','Muslim Mindanao',4671.0,119.85,4.9).
city('Tugaya','ph','Muslim Mindanao',2501.0,124.17,7.88).
city('Tumbagaan','ph','Muslim Mindanao',2261.0,120.31,5.37).
city('Tunggol','ph','Muslim Mindanao',3495.0,122.95,6.46).
city('Ungus-ungus','ph','Muslim Mindanao',2344.0,119.84,5.05).
city('Uyaan','ph','Muslim Mindanao',2601.0,124.04,7.86).
city('Wao','ph','Muslim Mindanao',17845.0,124.67,7.68).
city('Manila','ph','National Capital Region',1.0443877E7,120.97,14.62).
city('Adtuyon','ph','Northern Mindanao',3380.0,124.85,7.81).
city('Aglayan','ph','Northern Mindanao',5761.0,125.14,8.05).
city('Alae','ph','Northern Mindanao',5121.0,124.81,8.42).
city('Alanib','ph','Northern Mindanao',4207.0,124.99,8.02).
city('Alubijid','ph','Northern Mindanao',3320.0,124.47,8.57).
city('Anakan','ph','Northern Mindanao',3825.0,125.15,8.85).
city('Ani-e','ph','Northern Mindanao',3324.0,124.87,8.61).
city('Aplaya','ph','Northern Mindanao',3730.0,124.77,8.61).
city('Bagakay','ph','Northern Mindanao',3136.0,123.8,8.14).
city('Baikingon','ph','Northern Mindanao',2164.0,124.55,8.47).
city('Balila','ph','Northern Mindanao',2511.0,125.01,8.0).
city('Baliwagan','ph','Northern Mindanao',2838.0,124.79,8.72).
city('Bangahan','ph','Northern Mindanao',2728.0,124.73,7.8).
city('Bantuanon','ph','Northern Mindanao',4673.0,125.07,8.01).
city('Barra','ph','Northern Mindanao',12442.0,124.67,8.5).
city('Basak','ph','Northern Mindanao',2457.0,124.86,8.04).
city('Batangan','ph','Northern Mindanao',6937.0,125.38,7.93).
city('Bato','ph','Northern Mindanao',2789.0,123.64,8.6).
city('Biga','ph','Northern Mindanao',2830.0,124.26,8.36).
city('Binitinan','ph','Northern Mindanao',3101.0,124.78,8.71).
city('Binuangan','ph','Northern Mindanao',5754.0,124.79,8.92).
city('Bolobolo','ph','Northern Mindanao',2975.0,124.54,8.55).
city('Bonbon','ph','Northern Mindanao',2215.0,124.73,9.11).
city('Bugcaon','ph','Northern Mindanao',4218.0,125.11,8.04).
city('Bugo','ph','Northern Mindanao',45787.0,124.76,8.51).
city('Busdi','ph','Northern Mindanao',2168.0,125.25,8.28).
city('Cabalantian','ph','Northern Mindanao',3242.0,124.35,8.37).
city('Cabangahan','ph','Northern Mindanao',2709.0,125.14,8.02).
city('Cabanglasan','ph','Northern Mindanao',5423.0,125.33,8.12).
city('Cabulohan','ph','Northern Mindanao',2637.0,125.28,8.04).
city('Cagayan de Oro','ph','Northern Mindanao',445212.0,124.67,8.45).
city('Calamba','ph','Northern Mindanao',6738.0,123.64,8.56).
city('Canayan','ph','Northern Mindanao',4639.0,125.15,8.2).
city('Candiis','ph','Northern Mindanao',2323.0,125.18,8.97).
city('Casisang','ph','Northern Mindanao',13721.0,125.13,8.14).
city('Catarman','ph','Northern Mindanao',2521.0,124.68,9.13).
city('Clarin','ph','Northern Mindanao',7125.0,123.86,8.2).
city('Claveria','ph','Northern Mindanao',7784.0,124.89,8.61).
city('Consuelo','ph','Northern Mindanao',3128.0,125.19,8.9).
city('Cosina','ph','Northern Mindanao',3117.0,124.62,8.11).
city('Dagumba-an','ph','Northern Mindanao',6635.0,124.6,8.15).
city('Dalirig','ph','Northern Mindanao',3660.0,124.9,8.38).
city('Dalwangan','ph','Northern Mindanao',4906.0,125.04,8.2).
city('Damilag','ph','Northern Mindanao',11000.0,124.82,8.35).
city('Damulog','ph','Northern Mindanao',8789.0,124.94,7.49).
city('Dangcagan','ph','Northern Mindanao',4864.0,125.01,7.6).
city('Dansolihon','ph','Northern Mindanao',3595.0,124.59,8.31).
city('Dimaluna','ph','Northern Mindanao',3187.0,123.8,8.12).
city('Dologon','ph','Northern Mindanao',15128.0,125.03,7.83).
city('Dumalaguing','ph','Northern Mindanao',2417.0,125.06,8.35).
city('Gimangpang','ph','Northern Mindanao',2472.0,124.31,8.47).
city('Gingoog','ph','Northern Mindanao',70943.0,125.13,8.83).
city('Guinoyuran','ph','Northern Mindanao',6944.0,125.03,7.91).
city('Guinsiliban','ph','Northern Mindanao',2074.0,124.78,9.1).
city('Halapitan','ph','Northern Mindanao',10870.0,125.33,7.92).
city('Hinaplanan','ph','Northern Mindanao',2695.0,124.87,8.64).
city('Igpit','ph','Northern Mindanao',5753.0,124.59,8.51).
city('Imbatug','ph','Northern Mindanao',2480.0,125.28,8.06).
city('Impalutao','ph','Northern Mindanao',2431.0,125.03,8.25).
city('Impasug-ong','ph','Northern Mindanao',7007.0,125.09,8.31).
city('Indulang','ph','Northern Mindanao',3387.0,124.59,8.09).
city('Initao','ph','Northern Mindanao',9922.0,124.31,8.5).
city('Inobulan','ph','Northern Mindanao',2561.0,124.79,8.89).
city('Jasaan','ph','Northern Mindanao',16435.0,124.76,8.65).
city('Jimenez','ph','Northern Mindanao',6662.0,123.84,8.33).
city('Kadingilan','ph','Northern Mindanao',7020.0,124.91,7.6).
city('Kalabugao','ph','Northern Mindanao',5982.0,125.16,8.45).
city('Kalilangan','ph','Northern Mindanao',14456.0,124.73,7.82).
city('Kalugmanan','ph','Northern Mindanao',2675.0,124.86,8.28).
city('Kauswagan','ph','Northern Mindanao',2268.0,124.78,8.79).
city('Kibangay','ph','Northern Mindanao',6539.0,124.9,8.05).
city('Kibawe','ph','Northern Mindanao',5081.0,124.99,7.57).
city('Kimanait','ph','Northern Mindanao',3589.0,124.73,7.76).
city('Kimaya','ph','Northern Mindanao',3944.0,124.84,8.56).
city('Kisolon','ph','Northern Mindanao',8105.0,124.98,8.33).
city('Kitaotao','ph','Northern Mindanao',3893.0,125.01,7.65).
city('La Fortuna','ph','Northern Mindanao',2496.0,125.02,8.28).
city('La Roxas','ph','Northern Mindanao',2456.0,124.89,7.86).
city('Lagonglong','ph','Northern Mindanao',9043.0,124.79,8.81).
city('Laguindingan','ph','Northern Mindanao',3120.0,124.47,8.58).
city('Laguitas','ph','Northern Mindanao',2181.0,125.13,8.09).
city('Langcangan','ph','Northern Mindanao',8706.0,123.76,8.48).
city('Lantapan','ph','Northern Mindanao',5021.0,125.05,8.0).
city('Lapasan','ph','Northern Mindanao',2573.0,123.86,8.19).
city('Libertad','ph','Northern Mindanao',3433.0,124.1,8.41).
city('Libona','ph','Northern Mindanao',5713.0,124.73,8.34).
city('Liboran','ph','Northern Mindanao',2772.0,124.65,8.35).
city('Linabo','ph','Northern Mindanao',5849.0,125.16,8.05).
city('Lingating','ph','Northern Mindanao',3774.0,124.63,8.33).
city('Lingion','ph','Northern Mindanao',4321.0,124.6,8.18).
city('Little Baguio','ph','Northern Mindanao',4926.0,125.28,7.9).
city('Looc','ph','Northern Mindanao',2292.0,124.79,8.84).
city('Lopez Jaena','ph','Northern Mindanao',3575.0,123.77,8.55).
city('Lourdes','ph','Northern Mindanao',3198.0,124.43,8.53).
city('Lugait','ph','Northern Mindanao',7370.0,124.26,8.34).
city('Lumbayao','ph','Northern Mindanao',3693.0,125.17,8.02).
city('Lumbia','ph','Northern Mindanao',7863.0,124.59,8.4).
city('Lumintao','ph','Northern Mindanao',3327.0,125.12,7.87).
city('Lunao','ph','Northern Mindanao',8995.0,125.06,8.85).
city('Lurogan','ph','Northern',7336.0,124.97,8.02).
city('Maanas','ph','Northern Mindanao',3477.0,125.03,8.89).
city('Mahinog','ph','Northern Mindanao',2780.0,124.79,9.16).
city('Mailag','ph','Northern Mindanao',5388.0,125.14,7.97).
city('Malinao','ph','Northern Mindanao',3196.0,125.19,8.83).
city('Malitbog','ph','Northern Mindanao',3151.0,124.88,8.53).
city('Maluko','ph','Northern Mindanao',3278.0,124.96,8.37).
city('Mambajao','ph','Northern Mindanao',10057.0,124.72,9.25).
city('Mambatangan','ph','Northern Mindanao',2922.0,124.83,8.43).
city('Mambayaan','ph','Northern Mindanao',2781.0,124.78,8.78).
city('Managok','ph','Northern Mindanao',6477.0,125.19,8.03).
city('Mananum','ph','Northern Mindanao',2185.0,124.95,8.83).
city('Mandangoa','ph','Northern Mindanao',2740.0,124.79,8.77).
city('Manticao','ph','Northern Mindanao',7956.0,124.29,8.4).
city('Maputi','ph','Northern Mindanao',2304.0,124.29,8.45).
city('Maramag','ph','Northern Mindanao',33844.0,125.01,7.76).
city('Mat-I','ph','Northern Mindanao',3401.0,124.35,8.4).
city('Matangad','ph','Northern Mindanao',2825.0,124.37,8.58).
city('Mauswagon','ph','Northern Mindanao',3126.0,124.41,8.6).
city('Medina','ph','Northern Mindanao',9201.0,125.02,8.91).
city('Miaray','ph','Northern Mindanao',3190.0,125.03,7.57).
city('Miglamin','ph','Northern Mindanao',2633.0,125.27,8.05).
city('Molugan','ph','Northern Mindanao',8042.0,124.57,8.54).
city('Moog','ph','Northern Mindanao',5197.0,124.46,8.6).
city('Naawan','ph','Northern Mindanao',3643.0,124.29,8.43).
city('Napaliran','ph','Northern Mindanao',2284.0,124.8,8.78).
city('Natulongan','ph','Northern Mindanao',3165.0,125.02,7.53).
city('Odiongan','ph','Northern Mindanao',4151.0,125.17,8.85).
city('Opol','ph','Northern Mindanao',3468.0,124.57,8.52).
city('Oroquieta','ph','Northern Mindanao',39279.0,123.81,8.49).
city('Ozamiz','ph','Northern Mindanao',93083.0,123.84,8.15).
city('Pan-ay','ph','Northern Mindanao',2160.0,123.84,8.22).
city('Pandan','ph','Northern Mindanao',2332.0,124.73,9.24).
city('Pangabuan','ph','Northern Mindanao',2098.0,123.7,8.06).
city('Pangantucan','ph','Northern Mindanao',7598.0,124.81,7.85).
city('Pines','ph','Northern Mindanao',3019.0,123.81,8.45).
city('Plaridel','ph','Northern Mindanao',2972.0,123.69,8.61).
city('Pongol','ph','Northern Mindanao',3421.0,124.75,8.28).
city('Punta Silum','ph','Northern Mindanao',3613.0,124.27,8.38).
city('Puntian','ph','Northern Mindanao',2312.0,124.9,8.28).
city('Sagay','ph','Northern Mindanao',3256.0,124.72,9.11).
city('Salawagan','ph','Northern Mindanao',6508.0,125.14,7.69).
city('Salay','ph','Northern Mindanao',6427.0,124.79,8.86).
city('Salimbalan','ph','Northern Mindanao',2746.0,124.71,8.27).
city('Sampagar','ph','Northern Mindanao',2207.0,124.95,7.52).
city('San Antonio','ph','Northern Mindanao',7250.0,124.7,8.69).
city('San Carlos','ph','Northern Mindanao',3186.0,125.07,7.97).
city('San Isidro','ph','Northern Mindanao',4270.0,124.59,8.25).
city('San Jose','ph','Northern Mindanao',4542.0,125.06,8.3).
city('San Juan','ph','Northern Mindanao',2096.0,124.87,8.71).
city('San Luis','ph','Northern Mindanao',5296.0,125.02,8.68).
city('San Martin','ph','Northern Mindanao',3434.0,124.77,8.56).
city('San Miguel','ph','Northern Mindanao',5054.0,124.75,8.03).
city('Sankanan','ph','Northern Mindanao',3055.0,124.86,8.32).
city('Santa Ana','ph','Northern Mindanao',5770.0,124.78,8.52).
city('Santa Cruz','ph','Northern Mindanao',9347.0,124.91,8.6).
city('Santa Fe','ph','Northern Mindanao',3380.0,124.78,8.35).
city('Sapang Dalaga','ph','Northern Mindanao',2742.0,123.57,8.54).
city('Silae','ph','Northern Mindanao',2214.0,125.28,8.16).
city('Sinacaban','ph','Northern Mindanao',2372.0,123.84,8.29).
city('Sinonoc','ph','Northern Mindanao',2648.0,123.85,8.32).
city('Solana','ph','Northern Mindanao',2984.0,124.77,8.62).
city('Sugbongcogon','ph','Northern Mindanao',2494.0,124.79,8.96).
city('Sumilao','ph','Northern Mindanao',5339.0,124.95,8.29).
city('Sumpong','ph','Northern Mindanao',7399.0,125.12,8.16).
city('Sungay','ph','Northern Mindanao',2094.0,124.41,8.45).
city('Tabid','ph','Northern Mindanao',3152.0,123.78,8.11).
city('Tabo-o','ph','Northern Mindanao',2965.0,123.86,8.33).
city('Taboc','ph','Northern Mindanao',2107.0,124.8,8.88).
city('Tagoloan','ph','Northern Mindanao',30390.0,124.76,8.54).
city('Tagpangi','ph','Northern Mindanao',2980.0,124.56,8.37).
city('Talakag','ph','Northern Mindanao',7861.0,124.6,8.23).
city('Talisayan','ph','Northern Mindanao',4616.0,124.88,9.0).
city('Tangub','ph','Northern Mindanao',29721.0,123.74,8.07).
city('Taytay','ph','Northern Mindanao',2821.0,124.54,8.54).
city('Tignapoloan','ph','Northern Mindanao',4098.0,124.57,8.26).
city('Tikalaan','ph','Northern Mindanao',3389.0,124.63,8.03).
city('Tubigan','ph','Northern Mindanao',2629.0,124.31,8.53).
city('Tudela','ph','Northern Mindanao',3137.0,123.85,8.25).
city('Tupsan','ph','Northern Mindanao',2370.0,124.78,9.2).
city('Unidos','ph','Northern Mindanao',2111.0,123.67,8.59).
city('Villanueva','ph','Northern Mindanao',7415.0,124.78,8.59).
city('Yumbing','ph','Northern Mindanao',4930.0,124.66,9.24).
city('Alabel','ph','Southern Mindanao',43312.0,125.26,6.1).
city('Alejal','ph','Southern Mindanao',8075.0,125.66,7.38).
city('Andap','ph','Southern Mindanao',9096.0,125.75,7.86).
city('Andili','ph','Southern Mindanao',4400.0,125.97,7.45).
city('Anibongan','ph','Southern Mindanao',2468.0,125.72,7.39).
city('Astorga','ph','Southern Mindanao',10712.0,125.46,6.91).
city('Aumbay','ph','Southern Mindanao',3397.0,125.78,7.1).
city('Babag','ph','Southern Mindanao',3215.0,126.07,7.73).
city('Baculi','ph','Southern Mindanao',2971.0,126.58,7.45).
city('Badtasan','ph','Southern Mindanao',2174.0,124.61,6.01).
city('Baganga','ph','Southern Mindanao',10106.0,126.56,7.57).
city('Balagunan','ph','Southern Mindanao',4528.0,125.52,7.49).
city('Balet','ph','Southern Mindanao',2658.0,125.77,7.17).
city('Baliton','ph','Southern Mindanao',5809.0,125.24,5.75).
city('Balutakay','ph','Southern Mindanao',2817.0,125.35,6.72).
city('Banaybanay','ph','Southern Mindanao',14180.0,126.07,7.1).
city('Bangkas Heights','ph','Southern Mindanao',11619.0,125.44,7.09).
city('Bantacan','ph','Southern Mindanao',3299.0,126.13,7.6).
city('Baon','ph','Southern Mindanao',3601.0,126.09,6.8).
city('Baracatan','ph','Southern Mindanao',7298.0,125.42,6.97).
city('Basag','ph','Southern Mindanao',7325.0,124.98,6.27).
city('Basiawan','ph','Southern Mindanao',6351.0,125.49,6.53).
city('Batiano','ph','Southern Mindanao',2410.0,126.49,7.55).
city('Bato','ph','Southern Mindanao',5008.0,125.47,7.04).
city('Batobato','ph','Southern Mindanao',9714.0,126.08,6.82).
city('Baylo','ph','Southern Mindanao',3552.0,126.06,7.85).
city('Biao','ph','Southern Mindanao',12043.0,125.52,7.16).
city('Bincungan','ph','Southern Mindanao',3810.0,125.75,7.37).
city('Bitaogan','ph','Southern Mindanao',2145.0,126.08,6.77).
city('Bobon','ph','Southern Mindanao',4515.0,126.33,6.87).
city('Bolila','ph','Southern Mindanao',2125.0,125.57,6.37).
city('Bongabong','ph','Southern Mindanao',3888.0,125.88,7.22).
city('Boston','ph','Southern Mindanao',2891.0,126.36,7.87).
city('Buayan','ph','Southern Mindanao',14607.0,125.24,6.11).
city('Buclad','ph','Southern Mindanao',2620.0,125.75,7.52).
city('Buhangin','ph','Sout',4391.0,125.52,6.49).
city('Bukay Pait','ph','Southern Mindanao',3356.0,124.77,6.56).
city('Bukid','ph','Southern Mindanao',2232.0,125.41,5.57).
city('Bulacan','ph','Southern Mindanao',4518.0,125.41,6.56).
city('Burias','ph','Southern Mindanao',4066.0,125.26,5.72).
city('Butulan','ph','Southern Mindanao',2436.0,125.43,5.61).
city('Cabayangan','ph','Southern Mindanao',16539.0,125.73,7.41).
city('Cabinuangan','ph','Southern Mindanao',10777.0,126.03,7.68).
city('Calian','ph','Southern Mindanao',3488.0,125.7,6.12).
city('Camudmud','ph','Southern Mindanao',2189.0,125.69,7.18).
city('Canocotan','ph','Southern Mindanao',9025.0,125.77,7.4).
city('Caraga','ph','Southern Mindanao',4410.0,126.57,7.33).
city('Carpenter Hill','ph','Southern Mindanao',5344.0,124.87,6.45).
city('Cateel','ph','Southern Mindanao',6624.0,126.45,7.79).
city('Cebuano','ph','Southern Mindanao',5430.0,124.97,6.39).
city('Cogon','ph','Southern Mindanao',2238.0,125.72,7.15).
city('Conel','ph','Southern Mindanao',8519.0,125.19,6.2).
city('Coronon','ph','Southern Mindanao',6854.0,125.45,6.88).
city('Cuambog','ph','Southern Mindanao',6383.0,125.85,7.31).
city('Culaman','ph','Southern Mindanao',3523.0,125.66,5.96).
city('Dacudao','ph','Southern Mindanao',3670.0,125.47,7.22).
city('Dadiangas','ph','Southern Mindanao',432571.0,125.25,6.1).
city('Dahican','ph','Southern Mindanao',6937.0,126.28,6.93).
city('Dajay','ph','Southern Mindanao',7567.0,124.72,6.4).
city('Daliao','ph','Southern Mindanao',2335.0,124.95,5.86).
city('Davao','ph','Southern Mindanao',1212285.0,125.63,7.11).
city('Dawan','ph','Southern Mindanao',4048.0,126.15,6.92).
city('Del Pilar','ph','Southern Mindanao',4062.0,125.83,7.56).
city('Digos','ph','Southern Mindanao',117536.0,125.35,6.76).
city('Dolo','ph','Southern Mindanao',3973.0,125.19,6.81).
city('Don Marcelino','ph','Southern Mindanao',7983.0,125.67,6.26).
city('Dumaguil','ph','Southern Mindanao',2238.0,124.65,6.62).
city('Dumlan','ph','Southern Mindanao',2661.0,125.88,7.43).
city('Esperanza','ph','Southern Mindanao',2561.0,125.2,7.0).
city('Florida','ph','Southern Mindanao',4141.0,125.67,7.65).
city('Gabi','ph','Southern Mindanao',3939.0,126.09,7.62).
city('Gabuyan','ph','Southern Mindanao',4402.0,125.68,7.62).
city('Glamang','ph','Southern Mindanao',4467.0,125.06,6.16).
city('Glan Padidu','ph','Southern Mindanao',3716.0,125.22,5.85).
city('Goma','ph','Southern Mindanao',4275.0,125.32,6.79).
city('Governador Generoso','ph','Southern Mindanao',7981.0,126.07,6.65).
city('Guihing','ph','Southern Mindanao',12465.0,125.35,6.68).
city('Guinsang-an','ph','Southern Mindanao',3847.0,124.68,6.48).
city('Gumalang','ph','Southern Mindanao',4313.0,125.4,7.21).
city('Gupitan','ph','Southern Mindanao',8235.0,125.65,7.78).
city('Hagonoy','ph','Southern Mindanao',7409.0,125.33,6.68).
city('Hijo','ph','Southern Mindanao',3014.0,125.83,7.35).
city('Igpit','ph','Southern Mindanao',3238.0,125.29,6.7).
city('Ilaya','ph','Southern Mindanao',3200.0,125.23,5.81).
city('Inawayan','ph','Southern Mindanao',5345.0,125.47,6.96).
city('Jovellar','ph','Southern Mindanao',2357.0,126.46,7.06).
city('Kablon','ph','Southern Mindanao',4852.0,125.01,6.32).
city('Kalbay','ph','Southern Mindanao',4339.0,125.5,5.72).
city('Kaligutan','ph','Southern Mindanao',2789.0,125.81,7.7).
city('Kapatan','ph','Southern Mindanao',2902.0,125.24,5.9).
city('Katangawan','ph','Southern Mindanao',8476.0,125.22,6.17).
city('Katubao','ph','Southern Mindanao',4177.0,124.83,5.89).
city('Kiamba','ph','Southern Mindanao',10979.0,124.63,5.99).
city('Kiblawan','ph','Southern Mindanao',4464.0,125.24,6.61).
city('Kinablangan','ph','Southern Mindanao',5423.0,126.55,7.69).
city('Kinamayan','ph','Southern Mindanao',4300.0,125.67,7.5).
city('Kinangan','ph','Southern Mindanao',4561.0,125.59,6.3).
city('Kipalbig','ph','Southern Mindanao',5070.0,124.92,6.41).
city('Klinan','ph','Southern Mindanao',3017.0,125.13,6.19).
city('Koronadal','ph','Southern Mindanao',123765.0,124.85,6.5).
city('Koronadal Proper','ph','Southern Mindanao',4352.0,124.99,6.26).
city('La Libertad','ph','Southern Mindanao',5324.0,125.65,7.48).
city('La Paz','ph','Southern Mindanao',2782.0,125.73,7.32).
city('La Union','ph','Southern Mindanao',5220.0,126.09,6.7).
city('Lacaron','ph','Southern Mindanao',2751.0,125.58,6.45).
city('Lacson','ph','Southern Mindanao',3970.0,125.44,7.21).
city('Lais','ph','Southern Mindanao',2298.0,125.65,6.33).
city('Lamba','ph','Southern Mindanao',6408.0,124.81,6.36).
city('Lambontong','ph','Southern Mindanao',4338.0,124.81,6.31).
city('Lamian','ph','Southern Mindanao',3936.0,124.84,6.31).
city('Lamidan','ph','Southern Mindanao',3241.0,125.7,6.08).
city('Lampari','ph','Southern Mindanao',2383.0,124.88,6.32).
city('Lampitak','ph','Southern Mindanao',2266.0,125.05,6.43).
city('Lapuan','ph','Southern Mindanao',3825.0,125.7,6.15).
city('Lapuz','ph','Southern Mindanao',2601.0,124.63,6.52).
city('Lasang','ph','Southern Mindanao',8318.0,125.67,7.27).
city('Libas','ph','Southern Mindanao',2153.0,124.78,6.54).
city('Liberty','ph','Southern Mindanao',2417.0,124.81,6.5).
city('Liboganon','ph','Southern Mindanao',2338.0,125.78,7.35).
city('Limao','ph','Southern Mindanao',2123.0,125.67,7.08).
city('Limba-an','ph','Southern Mindanao',4855.0,125.83,7.63).
city('Limot','ph','Southern Mindanao',2221.0,126.27,7.04).
city('Linan','ph','Southern Mindanao',3160.0,124.97,6.43).
city('Linao','ph','Southern Mindanao',2571.0,126.0,7.02).
city('Linoan','ph','Southern Mindanao',2952.0,125.97,7.63).
city('Lopez Jaena','ph','Southern Mindanao',5352.0,124.68,6.51).
city('Lucatan','ph','Southern Mindanao',2557.0,126.42,7.01).
city('Lumakil','ph','Southern Mindanao',2591.0,125.02,6.22).
city('Lumasal','ph','Southern Mindanao',3876.0,124.85,5.89).
city('Lumatil','ph','Southern Mindanao',2172.0,124.89,5.88).
city('Lun','ph','Southern Mindanao',11541.0,125.29,6.04).
city('Luna','ph','Southern Mindanao',4550.0,125.67,7.58).
city('Lunen','ph','Southern Mindanao',2416.0,124.9,6.36).
city('Lungaog','ph','Southern Mindanao',3203.0,125.68,7.53).
city('Luzon','ph','Southern Mindanao',3211.0,126.09,6.52).
city('Maan','ph','Southern Mindanao',3450.0,124.74,5.93).
city('Maasim','ph','Southern Mindanao',5847.0,125.0,5.85).
city('Mabantao','ph','Southern Mindanao',3251.0,125.7,7.62).
city('Mabay','ph','Southern Mindanao',3212.0,124.47,6.05).
city('Mabini','ph','Southern Mindanao',2757.0,124.9,6.54).
city('Maduao','ph','Southern Mindanao',2143.0,125.63,7.29).
city('Magatos','ph','Southern Mindanao',5770.0,125.73,7.55).
city('Magdug','ph','Southern Mindanao',2343.0,126.09,6.55).
city('Magnaga','ph','Southern Mindanao',7644.0,125.89,7.17).
city('Magsaysay','ph','Southern Mindanao',10297.0,125.41,7.09).
city('Maguling','ph','Southern Mindanao',2361.0,124.4,6.1).
city('Mahanub','ph','Southern Mindanao',3872.0,126.5,7.58).
city('Mahayag','ph','Southern Mindanao',2814.0,125.62,7.22).
city('Mainit','ph','Southern Mindanao',6148.0,126.01,7.53).
city('Maitum','ph','Southern Mindanao',8478.0,124.5,6.04).
city('Malagos','ph','Southern Mindanao',4975.0,125.42,7.19).
city('Malalag','ph','Southern Mindanao',6180.0,125.4,6.6).
city('Malandag','ph','Southern Mindanao',12867.0,125.25,6.31).
city('Malbang','ph','Southern Mindanao',2448.0,125.04,5.86).
city('Malinao','ph','Southern Mindanao',2308.0,125.29,6.66).
city('Maltana','ph','Southern Mindanao',3361.0,124.93,6.42).
city('Mambago','ph','Southern Mindanao',2913.0,125.69,7.11).
city('Managa','ph','Southern Mindanao',3460.0,125.27,6.75).
city('Manat','ph','Southern Mindanao',2679.0,126.02,7.56).
city('Manay','ph','Southern Mindanao',12473.0,126.06,7.28).
city('Mangalcal','ph','Southern Mindanao',3446.0,125.66,7.37).
city('Mangile','ph','Southern Mindanao',3020.0,125.68,6.0).
city('Manikling','ph','Southern Mindanao',2444.0,126.06,6.88).
city('Manuel Roxas','ph','Southern Mindanao',4482.0,124.67,6.45).
city('Maragusan','ph','Southern Mindanao',18669.0,126.0,7.5).
city('Mati','ph','Southern Mindanao',71832.0,126.22,6.96).
city('Matiao','ph','Southern Mindanao',2814.0,125.93,7.08).
city('Matti','ph','Southern Mindanao',4796.0,125.31,6.77).
city('Mawab','ph','Southern Mindanao',14446.0,125.92,7.51).
city('Mayo','ph','Southern Mindanao',2829.0,126.33,7.0).
city('Mindupok','ph','Southern Mindanao',3437.0,124.42,6.09).
city('Montevista','ph','Southern Mindanao',10146.0,125.99,7.69).
city('Nalus','ph','Southern Mindanao',3920.0,124.59,6.01).
city('Nangan','ph','Southern Mindanao',3362.0,126.12,6.47).
city('Nanyo','ph','Southern Mindanao',3236.0,125.64,7.33).
city('New Baclayon','ph','Southern Mindanao',3804.0,125.37,6.58).
city('New Bohol','ph','Southern Mindanao',3749.0,125.83,7.53).
city('New Corella','ph','Southern Mindanao',20574.0,125.83,7.59).
city('New Iloilo','ph','Southern Mindanao',3707.0,124.79,6.55).
city('New Leyte','ph','Southern Mindanao',2788.0,125.75,7.5).
city('New Sibonga','ph','Southern Mindanao',2310.0,125.93,7.56).
city('New Visayas','ph','Southern Mindanao',14758.0,125.62,7.53).
city('Norala','ph','Southern Mindanao',12750.0,124.66,6.52).
city('Nuing','ph','Southern Mindanao',2610.0,125.44,5.63).
city('Padada','ph','Southern Mindanao',11439.0,125.35,6.64).
city('Pag-asa','ph','Southern Mindanao',3507.0,125.68,7.57).
city('Pagalungan','ph','Southern Mindanao',2936.0,125.01,6.27).
city('Pagsabangan','ph','Southern Mindanao',4284.0,125.75,7.48).
city('Palian','ph','Southern Mindanao',2861.0,124.91,6.38).
city('Palkan','ph','Southern Mindanao',3591.0,125.03,6.3).
city('Palma Gil','ph','Southern Mindanao',4894.0,125.62,7.65).
city('Panay','ph','Southern Mindanao',4134.0,124.64,6.5).
city('Pangian','ph','Southern Mindanao',4001.0,125.55,6.46).
city('Pangyan','ph','Southern Mindanao',5261.0,125.28,5.7).
city('Panikian','ph','Southern Mindanao',2878.0,126.03,7.01).
city('Paraiso','ph','Southern Mindanao',4152.0,124.81,6.47).
city('Pasian','ph','Southern Mindanao',4291.0,126.07,7.93).
city('Pindasan','ph','Southern Mindanao',5254.0,125.85,7.29).
city('Polo','ph','Southern Mindanao',2631.0,125.11,6.26).
city('Polomolok','ph','Southern Mindanao',64849.0,125.06,6.22).
city('Polonuling','ph','Southern Mindanao',6550.0,124.97,6.29).
city('Pongpong','ph','Southern Mindanao',2927.0,125.47,6.5).
city('Pundaguitan','ph','Southern Mindanao',2143.0,126.18,6.36).
city('Salvacion','ph','Southern Mindanao',6090.0,126.13,7.98).
city('Samal','ph','Southern Mindanao',43525.0,125.71,7.07).
city('Sampao','ph','Southern Mindanao',8648.0,125.65,7.6).
city('San Alfonso','ph','Southern Mindanao',3386.0,126.42,7.78).
city('San Antonio','ph','Southern Mindanao',2355.0,125.74,7.12).
city('San Ignacio','ph','Southern Mindanao',6300.0,126.49,7.12).
city('San Isidro','ph','Southern Mindanao',3095.0,125.37,6.71).
city('San Jose','ph','Southern Mindanao',4069.0,125.14,6.28).
city('San Luis','ph','Southern Mindanao',2181.0,126.55,7.44).
city('San Miguel','ph','Southern Mindanao',3610.0,125.19,6.99).
city('San Pedro','ph','Southern Mindanao',4079.0,126.52,7.34).
city('San Rafael','ph','Southern Mindanao',2126.0,126.46,7.76).
city('San Remigio','ph','Southern Mindanao',2147.0,125.78,6.92).
city('San Vicente','ph','Southern Mindanao',3247.0,124.79,6.45).
city('Santa Maria','ph','Southern Mindanao',16759.0,125.47,6.55).
city('Santiago','ph','Southern Mindanao',2631.0,126.57,7.29).
city('Santo Nino','ph','Southern Mindanao',7687.0,125.35,7.13).
city('Sapu','ph','Southern Mindanao',9788.0,125.27,5.92).
city('Sarangani','ph','Southern Mindanao',7506.0,125.47,5.4).
city('Saug','ph','Southern Mindanao',11693.0,125.77,7.53).
city('Sebu','ph','Southern Mindanao',21767.0,124.69,6.22).
city('Sibulan','ph','Southern Mindanao',9021.0,125.46,6.93).
city('Silway','ph','Southern Mindanao',7893.0,125.11,6.18).
city('Sinawilan','ph','Southern Mindanao',4017.0,125.25,6.75).
city('Sinayawan','ph','Southern Mindanao',4930.0,125.31,6.71).
city('Sinolon','ph','Southern Mindanao',2838.0,124.81,6.26).
city('Sirib','ph','Southern Mindanao',5008.0,125.41,7.13).
city('Sua-on','ph','Southern Mindanao',2936.0,125.64,7.66).
city('Sugal','ph','Southern Mindanao',2759.0,125.46,5.66).
city('Sulit','ph','Southern Mindanao',5019.0,125.02,6.24).
city('Sulop','ph','Southern Mindanao',6582.0,125.34,6.6).
city('Surop','ph','Southern Mindanao',2119.0,126.17,6.4).
city('Suyan','ph','Southern Mindanao',7229.0,125.39,6.06).
city('Tacub','ph','Southern Mindanao',2391.0,125.42,6.86).
city('Tagakpan','ph','Southern Mindanao',4019.0,125.43,7.11).
city('Tagdangua','ph','Southern Mindanao',4116.0,125.87,7.22).
city('Tagnanan','ph','Southern Mindanao',4171.0,125.86,7.27).
city('Tagum','ph','Southern Mindanao',171656.0,125.81,7.38).
city('Talicod','ph','Southern Mindanao',10293.0,125.69,6.96).
city('Talisay','ph','Southern Mindanao',2583.0,126.1,6.72).
city('Talomo','ph','Southern Mindanao',3857.0,125.72,7.53).
city('Taluya','ph','Southern Mindanao',4903.0,125.17,5.81).
city('Tamayong','ph','Southern Mindanao',5717.0,125.38,7.13).
city('Tambilil','ph','Southern Mindanao',4740.0,124.67,5.96).
city('Tambo','ph','Southern Mindanao',2378.0,125.7,7.16).
city('Tambongon','ph','Southern Mindanao',3243.0,125.95,7.07).
city('Tamisan','ph','Southern Mindanao',2866.0,126.3,6.85).
city('Tampakan','ph','Southern Mindanao',9048.0,124.93,6.45).
city('Tamugan','ph','Southern Mindanao',8291.0,125.38,7.23).
city('Tanglad','ph','Southern Mindanao',2184.0,125.45,6.6).
city('Tantangan','ph','Souther',10337.0,124.75,6.62).
city('Tapia','ph','Southern Mindanao',2720.0,126.01,7.75).
city('Tarragona','ph','Southern Mindanao',3777.0,126.45,7.04).
city('Taytayan','ph','Southern Mindanao',6894.0,126.5,7.73).
city('Teresita','ph','Southern Mindanao',2609.0,124.71,6.41).
city('Tibagon','ph','Southern Mindanao',3905.0,125.87,7.23).
city('Tibal-og','ph','Southern Mindanao',621.0,120.73,14.99).
city('Tibanban','ph','Southern Mindanao',7838.0,126.1,6.63).
city('Tiblawan','ph','Southern Mindanao',2843.0,126.1,6.48).
city('Tinagacan','ph','Southern Mindanao',4808.0,125.23,6.2).
city('Tinoto','ph','Southern Mindanao',3725.0,125.07,5.89).
city('Tokawal','ph','Southern Mindanao',3435.0,125.25,6.22).
city('Tubalan','ph','Southern Mindanao',4164.0,125.56,6.5).
city('Tuban','ph','Southern Mindanao',5194.0,125.39,6.82).
city('Tubod','ph','Southern Mindanao',7871.0,125.64,7.37).
city('Tuganay','ph','Southern Mindanao',4054.0,125.72,7.37).
city('Tuli','ph','Southern Mindanao',3643.0,125.42,7.23).
city('Tuyan','ph','Southern Mindanao',4239.0,125.28,6.0).
city('Ula','ph','Southern Mindanao',2689.0,125.49,7.13).
city('Upper Klinan','ph','Southern Mindanao',3768.0,125.12,6.23).
city('Wangan','ph','Southern Mindanao',7621.0,125.45,7.16).
city('Wines','ph','Southern Mindanao',2907.0,125.39,7.19).
city('Aborlan','ph','Southern Tagalog',4790.0,118.56,9.43).
city('Abra de Ilog','ph','Southern Tagalog',2971.0,120.73,13.45).
city('Abuyon','ph','Southern Tagalog',4342.0,122.52,13.62).
city('Adela','ph','Southern Tagalog',3926.0,120.97,12.44).
city('Aga','ph','Southern Tagalog',5218.0,120.81,14.1).
city('Agdangan','ph','Southern Tagalog',3918.0,121.92,13.87).
city('Agutaya','ph','Southern Tagalog',4989.0,120.94,11.15).
city('Alabat','ph','Southern Tagalog',7910.0,122.02,14.1).
city('Alad','ph','Southern Tagalog',2543.0,122.24,12.62).
city('Alaminos','ph','Southern Tagalog',31427.0,121.25,14.06).
city('Alcantara','ph','Southern Tagalog',2251.0,122.05,12.27).
city('Alfonso','ph','Southern Tagalog',9446.0,120.85,14.14).
city('Algeciras','ph','Southern Tagalog',4007.0,120.81,11.42).
city('Aliang','ph','Southern Tagalog',2642.0,120.88,14.28).
city('Alibog','ph','Southern Tagalog',2576.0,121.23,12.23).
city('Alimanguan','ph','Southern Tagalog',3324.0,119.33,10.61).
city('Alitagtag','ph','Southern Tagalog',3960.0,121.01,13.87).
city('Alupay','ph','Southern Tagalog',3981.0,121.3,13.84).
city('Amadeo','ph','Southern Tagalog',16618.0,120.92,14.17).
city('Ambulong','ph','Southern Tagalog',9074.0,121.06,14.09).
city('Angono','ph','Southern Tagalog',87199.0,121.15,14.53).
city('Anilao','ph','Southern Tagalog',2677.0,121.51,12.72).
city('Antipolo','ph','Southern Tagalog',276015.0,121.18,14.59).
city('Anuling','ph','Southern Tagalog',3905.0,120.88,14.12).
city('Apitong','ph','Southern Tagalog',2402.0,121.18,13.24).
city('Aplaya','ph','Southern Tagalog',6592.0,121.08,14.05).
city('Aporawan','ph','Southern Tagalog',2943.0,118.35,9.6).
city('Araceli','ph','Southern Tagalog',3111.0,119.99,10.56).
city('Aramaywan','ph','Southern Tagalog',3537.0,118.16,9.25).
city('Aurora','ph','Southern Tagalog',9829.0,121.82,13.29).
city('Aya','ph','Southern Tagalog',2924.0,121.12,13.9).
city('Ayusan','ph','Southern Tagalog',3715.0,121.4,14.02).
city('Baco','ph','Southern Tagalog',2903.0,121.1,13.36).
city('Bacoor','ph','Southern Tagalog',356987.0,120.94,14.46).
city('Bacuit','ph','Southern Tagalog',7801.0,119.4,11.19).
city('Bacungan','ph','Southern Tagalog',3975.0,118.7,9.91).
city('Bagong Pook','ph','Southern Tagalog',5062.0,121.19,13.84).
city('Bagong Sikat','ph','Southern Tagalog',5468.0,121.06,12.37).
city('Bagumbong','ph','Southern Tagalog',2984.0,121.38,14.34).
city('Bagupaye','ph','Southern Tagalog',2578.0,122.39,13.57).
city('Bahile','ph','Southern Tagalog',2255.0,118.78,9.99).
city('Balabac','ph','Southern Tagalog',9880.0,117.06,7.98).
city('Balagtasin','ph','Southern Tagalog',4050.0,121.09,13.9).
city('Balanacan','ph','Southern Tagalog',3547.0,121.87,13.53).
city('Balatero','ph','Southern Tagalog',3746.0,120.93,13.51).
city('Balaytigui','ph','Southern Tagalog',2341.0,120.6,14.13).
city('Balele','ph','Southern Tagalog',6496.0,121.09,14.06).
city('Balete','ph','Southern Tagalog',5941.0,121.15,13.95).
city('Balibago','ph','Southern Tagalog',3275.0,120.97,13.77).
city('Balite','ph','Southern Tagalog',4999.0,121.22,13.56).
city('Balitoc','ph','Southern Tagalog',3121.0,120.63,13.87).
city('Balugo','ph','Southern Tagalog',2666.0,121.44,12.58).
city('Banaba','ph','Southern Tagalog',3583.0,121.03,14.06).
city('Banalo','ph','Southern Tagalog',2310.0,121.18,13.65).
city('Banaybanay','ph','Southern Tagalog',23878.0,121.16,13.89).
city('Bancalaan','ph','Southern Tagalog',7510.0,117.1,8.23).
city('Banilad','ph','Southern Tagalog',4031.0,120.74,14.07).
city('Bansud','ph','Southern Tagalog',13758.0,121.46,12.87).
city('Bantilan','ph','Southern Tagalog',5406.0,121.67,14.75).
city('Banugao','ph','Southern Tagalog',2795.0,121.63,14.73).
city('Barahan','ph','Southern Tagalog',6414.0,120.76,13.01).
city('Baras','ph','Southern Tagalog',20250.0,121.27,14.52).
city('Batangas','ph','Southern Tagalog',238907.0,121.02,13.78).
city('Bataraza','ph','Southern Tagalog',6169.0,117.62,8.66).
city('Batas','ph','Southern Tagalog',2591.0,120.82,14.2).
city('Batasan','ph','Southern Tagalog',4752.0,120.78,12.77).
city('Bato','ph','Southern Tagalog',2615.0,119.47,10.83).
city('Bautista','ph','Southern Tagalog',2458.0,121.28,13.99).
city('Bay','ph','Southern Tagalog',33547.0,121.28,14.18).
city('Bayanan','ph','Southern Tagalog',3579.0,121.18,13.36).
city('Baybayin','ph','Southern Tagalog',2451.0,121.27,13.82).
city('Bayuin','ph','Southern Tagalog',3069.0,121.38,13.04).
city('Biga','ph','Southern Tagalog',3231.0,120.93,13.82).
city('Bilaran','ph','Southern Tagalog',4577.0,120.71,14.04).
city('Bilog-bilog','ph','Southern Tagalog',11342.0,121.09,14.11).
city('Binahaan','ph','Southern Tagalog',4843.0,121.76,13.99).
city('Binan','ph','Southern Tagalog',2094.0,121.08,14.34).
city('Binangonan','ph','Southern Tagalog',219203.0,121.19,14.48).
city('Binay','ph','Southern T',2828.0,122.6,13.5).
city('Bintakay','ph','Southern Tagalog',2593.0,121.88,13.5).
city('Binubusan','ph','Southern Tagalog',6714.0,120.64,13.96).
city('Binulasan','ph','Southern Tagalog',2292.0,121.7,14.73).
city('Bitangan','ph','Southern Tagalog',3284.0,120.88,14.25).
city('Bitin','ph','Southern Tagalog',5758.0,121.21,14.09).
city('Bolboc','ph','Southern Tagalog',2437.0,120.75,14.02).
city('Bolo','ph','Southern Tagalog',8310.0,120.98,13.79).
city('Boot','ph','Southern Tagalog',4884.0,121.08,14.05).
city('Brookes Point','ph','Southern Tagalog',27072.0,117.84,8.77).
city('Bubog','ph','Southern Tagalog',4880.0,121.03,12.38).
city('Bucal','ph','Southern Tagalog',3254.0,121.54,13.91).
city('Buenavista','ph','Southern Tagalog',2743.0,121.94,13.25).
city('Bugaan','ph','Southern Tagalog',3907.0,120.93,14.03).
city('Bukal','ph','Southern Tagalog',2919.0,121.39,13.94).
city('Bulacnin','ph','Southern Tagalog',7985.0,121.14,13.99).
city('Bulalacao','ph','Southern Tagalog',7207.0,120.76,12.04).
city('Bulihan','ph','Southern Tagalog',6616.0,120.96,14.08).
city('Buluang','ph','Southern Tagalog',2566.0,119.88,12.23).
city('Bungahan','ph','Southern Tagalog',3340.0,120.66,13.94).
city('Bungoy','ph','Southern Tagalog',3591.0,121.37,13.99).
city('Bunog','ph','Southern Tagalog',2228.0,117.78,9.14).
city('Burdeos','ph','Southern Tagalog',4548.0,121.97,14.84).
city('Burgos','ph','Southern Tagalog',3080.0,121.81,13.92).
city('Burirao','ph','Southern Tagalog',2626.0,118.1,9.2).
city('Buyabod','ph','Southern Tagalog',2991.0,122.06,13.47).
city('Buyayao','ph','Southern Tagalog',5138.0,121.45,12.37).
city('Cabacao','ph','Southern Tagalog',4486.0,120.65,13.33).
city('Cabanbanan','ph','Southern Tagalog',4469.0,121.43,14.24).
city('Cabatang','ph','Southern Tagalog',4211.0,121.38,13.97).
city('Cabay','ph','Southern Tagalog',3277.0,121.38,13.88).
city('Cabog','ph','Southern Tagalog',2967.0,121.37,15.32).
city('Cabra','ph','Southern Tagalog',3261.0,120.05,13.89).
city('Cagsiay','ph','Southern Tagalog',10173.0,121.75,14.22).
city('Cahil','ph','Southern Tagalog',3241.0,120.9,13.92).
city('Cainta','ph','Southern Tagalog',283177.0,121.12,14.58).
city('Cajimos','ph','Southern Tagalog',2739.0,122.28,12.6).
city('Calamba','ph','Southern Tagalog',316633.0,121.15,14.21).
city('Calansayan','ph','Southern Tagalog',3252.0,121.08,13.85).
city('Calantas','ph','Southern Tagalog',2564.0,120.78,13.96).
city('Calatagan','ph','Southern Tagalog',16111.0,120.64,13.83).
city('Calategas','ph','Southern Tagalog',4542.0,118.22,9.17).
city('Calatrava','ph','Southern Tagalog',2225.0,122.07,12.62).
city('Calauan','ph','Southern Tagalog',36580.0,121.32,14.15).
city('Calawag','ph','Southern Tagalog',4379.0,119.57,10.67).
city('Calintaan','ph','Southern Tagalog',11476.0,120.94,12.58).
city('Caloocan','ph','Southern Tagalog',4245.0,120.97,14.63).
city('Calubcub','ph','Southern Tagalog',5019.0,121.44,13.74).
city('Calumpang','ph','Southern Tagalog',2774.0,121.31,14.01).
city('Cambuga','ph','Southern Tagalog',6432.0,122.45,13.62).
city('Camflora','ph','Southern Tagalog',6146.0,122.66,13.35).
city('Caminawit','ph','Southern Tagalog',11161.0,121.08,12.33).
city('Camohaguin','ph','Southern Tagalog',4363.0,122.17,13.91).
city('Candawaga','ph','Southern Tagalog',5164.0,117.49,8.86).
city('Cantil','ph','Southern Tagalog',2648.0,121.52,12.0).
city('Canubing','ph','Southern Tagalog',9569.0,121.13,13.37).
city('Capuluan','ph','Southern Tagalog',2234.0,122.52,13.81).
city('Caramay','ph','Southern Tagalog',2524.0,119.23,10.18).
city('Cardona','ph','Southern Tagalog',30221.0,121.23,14.49).
city('Carlagan','ph','Southern Tagalog',2562.0,122.05,14.98).
city('Carmen','ph','Southern Tagalog',2677.0,122.12,12.62).
city('Carmona','ph','Southern Tagalog',55886.0,121.06,14.32).
city('Caruray','ph','Southern Tagalog',4115.0,119.01,10.31).
city('Casay','ph','Southern Tagalog',3596.0,122.52,13.26).
city('Casian','ph','Southern Tagalog',2677.0,119.71,11.03).
city('Castanas','ph','Southern Tagalog',9040.0,121.55,13.88).
city('Cavinti','ph','Southern Tagalog',9758.0,121.51,14.24).
city('Cavite','ph','Southern Tagalog',115920.0,120.9,14.47).
city('Cawayan','ph','Southern Tagalog',4221.0,122.03,13.02).
city('Cigaras','ph','Southern Tagalog',2775.0,121.43,14.23).
city('Comunal','ph','Southern Tagalog',2773.0,121.14,13.25).
city('Concepcion','ph','Southern Tagalog',15157.0,121.79,13.17).
city('Coron','ph','Southern Tagalog',8723.0,120.21,12.0).
city('Cuenca','ph','Southern Tagalog',21558.0,121.05,13.9).
city('Cuyo','ph','Southern Tagalog',7549.0,121.01,10.85).
city('Dagatan','ph','Southern Tagalog',2784.0,121.29,13.87).
city('Daine','ph','Southern Tagalog',3899.0,120.84,14.19).
city('Dapawan','ph','Southern Tagalog',2929.0,122.03,12.41).
city('Daraitan','ph','Southern Tagalog',3742.0,121.4,14.62).
city('Dasmarinas','ph','Southern Tagalog',441878.0,120.93,14.33).
city('Dayap','ph','Southern Tagalog',5092.0,121.34,14.18).
city('Dayapan','ph','Southern Tagalog',2396.0,120.9,13.94).
city('Dinahican','ph','Southern Tagalog',7062.0,121.72,14.69).
city('Dingalan','ph','Southern Tagalog',7316.0,121.39,15.39).
city('Dolores','ph','Southern Tagalog',7633.0,121.4,14.01).
city('Dubduban','ph','Southern Tagalog',2271.0,122.1,12.58).
city('Dulangan','ph','Southern Tagalog',3329.0,121.05,13.39).
city('Espana','ph','Southern Tagalog',2624.0,122.5,12.39).
city('Estrella','ph','Southern Tagalog',2615.0,121.31,13.33).
city('Evangelista','ph','Southern Tagalog',2585.0,121.08,13.34).
city('Famy','ph','Southern Tagalog',3758.0,121.45,14.44).
city('Gabawan','ph','Southern Tagalog',2382.0,122.01,12.42).
city('Gasan','ph','Southern Tagalog',2228.0,121.85,13.32).
city('General Emilio Aguinaldo','ph','Southern Tagalog',12243.0,120.8,14.18).
city('General Luna','ph','Southern Tagalog',9177.0,122.17,13.69).
city('General Nakar','ph','Southern Tagalog',3532.0,121.64,14.76).
city('Gloria','ph','Southern Tagalog',6137.0,121.47,12.98).
city('Guinayangan','ph','Southern Tagalog',2732.0,122.45,13.9).
city('Guisguis','ph','Southern Tagalog',5741.0,121.52,13.87).
city('Gulod','ph','Southern Tagalog',2705.0,120.62,13.87).
city('Gulod Malaya','ph','Southern Tagalog',5764.0,121.22,14.35).
city('Gumian','ph','Southern Tagalog',3695.0,121.62,14.71).
city('Guyam','ph','Southern Tagalog',3050.0,120.86,14.15).
city('Halayhay','ph','Southern Tagalog',10630.0,120.81,14.37).
city('Halayhayin','ph','Southern Tagalog',3834.0,121.42,14.2).
city('Haligue','ph','Southern Tagalog',2607.0,121.12,13.67).
city('Harrison','ph','Southern Tagalog',2349.0,120.43,13.45).
city('Hondagua','ph','Southern Tagalog',4587.0,122.24,13.95).
city('Hukay','ph','Southern Tagalog',2230.0,120.71,13.84).
city('Ibaan','ph','Southern Tagalog',9430.0,121.14,13.82).
city('Ibona','ph','Southern Tagalog',3325.0,121.38,15.32).
city('Ilasan','ph','Southern Tagalog',3054.0,121.63,14.06).
city('Ilihan','ph','Southern Tagalog',3544.0,121.08,13.63).
city('Indang','ph','Southern Tagalog',41158.0,120.88,14.2).
city('Infanta','ph','Southern Tagalog',5321.0,121.65,14.74).
city('Inicbulan','ph','Southern Tagalog',2570.0,120.97,13.82).
city('Ipil','ph','Southern Tagalog',2468.0,121.99,13.51).
city('Ipilan','ph','Southern Tagalog',5076.0,117.9,8.84).
city('Iraan','ph','Southern Tagalog',5262.0,117.7,9.06).
city('Iraray','ph','Southern Tagalog',2790.0,118.05,8.99).
city('Irawan','ph','Southern Tagalog',4141.0,118.7,9.8).
city('Iriron','ph','Southern Tagalog',3926.0,120.93,12.62).
city('Isabang','ph','Southern Tagalog',3497.0,121.57,13.96).
city('Isugod','ph','Southern Tagalog',3665.0,118.11,9.33).
city('Jala-Jala','ph','Southern Tagalog',16400.0,121.32,14.35).
city('Janagdong','ph','Southern Tagalog',5174.0,121.51,13.9).
city('Janopol','ph','Southern Tagalog',5297.0,121.1,14.08).
city('Javalera','ph','Southern Tagalog',34.0,120.92,14.26).
city('Jomalig','ph','Southern Tagalog',2270.0,122.37,14.71).
city('Kabulusan','ph','Southern Tagalog',3811.0,121.4,14.37).
city('Kalayaan','ph','Southern Tagalog',7306.0,121.57,14.35).
city('Kanluran','ph','Southern Tagalog',2312.0,120.85,14.42).
city('Kapatalan','ph','Southern Tagalog',2719.0,121.45,14.43).
city('Kawit','ph','Southern Tagalog',73204.0,120.9,14.45).
city('Kaytitinga','ph','Southern Tagalog',4610.0,120.83,14.11).
city('Kinalaglagan','ph','Southern Tagalog',2397.0,121.1,14.0).
city('Kinatakutan','ph','Southern Tagalog',2703.0,122.48,13.95).
city('La Curva','ph','Southern Tagalog',3359.0,121.05,12.4).
city('Labasan','ph','Southern Tagalog',4217.0,121.47,12.78).
city('Labog','ph','Southern Tagalog',3466.0,118.05,9.06).
city('Lacdayan','ph','Southern Tagalog',2642.0,122.53,13.6).
city('Laguile','ph','Southern Tagalog',2486.0,120.92,13.92).
city('Laiya','ph','Southern Tagalog',7504.0,121.39,13.68).
city('Lalig','ph','Southern Tagalog',14729.0,121.33,13.98).
city('Lanas','ph','Southern Tagalog',2499.0,121.91,12.06).
city('Lapolapo','ph','Southern Tagalog',3621.0,121.13,13.83).
city('Laurel','ph','Southern Tagalog',9720.0,120.94,14.05).
city('Laylay','ph','Southern Tagalog',2718.0,121.82,13.44).
city('Leuteboro','ph','Southern Tagalog',3802.0,121.38,13.06).
city('Lian','ph','Southern Tagalog',7496.0,120.65,14.04).
city('Libas','ph','Southern Tagalog',2256.0,121.96,13.24).
city('Libato','ph','Southern Tagalog',3830.0,121.35,13.8).
city('Libertad','ph','Southern Tagalog',2231.0,122.01,12.46).
city('Ligaya','ph','Southern Tagalog',8431.0,120.89,12.66).
city('Liliw','ph','Southern Tagalog',15246.0,121.44,14.13).
city('Liminangcong','ph','Southern Tagalog',4790.0,119.36,10.99).
city('Limon','ph','Southern Tagalog',2495.0,122.02,12.3).
city('Linapacan','ph','Southern Tagalog',2972.0,119.87,11.49).
city('Lipa','ph','Southern Tagalog',213525.0,121.17,13.95).
city('Lobo','ph','Southern Tagalog',3052.0,121.21,13.65).
city('Longos','ph','Southern Tagalog',15546.0,121.52,14.33).
city('Looc','ph','Southern Tagalog',3036.0,120.97,13.38).
city('Los Banos','ph','Southern Tagalog',95752.0,121.18,14.18).
city('Lubang','ph','Southern Tagalog',5750.0,120.12,13.86).
city('Lucban','ph','Southern Tagalog',30991.0,121.56,14.11).
city('Lucena','ph','Southern Tagalog',228738.0,121.6,13.95).
city('Lucsuhin','ph','Southern Tagalog',4240.0,120.64,13.88).
city('Luisiana','ph','Southern Tagalog',4554.0,121.51,14.18).
city('Luksuhin','ph','Southern Tagalog',4614.0,120.88,14.1).
city('Lumang Bayan','ph','Southern Tagalog',4359.0,121.13,13.42).
city('Lumangbayan','ph','Southern Tagalog',2390.0,121.24,13.24).
city('Lumban','ph','Southern Tagalog',30269.0,121.46,14.3).
city('Lumbangan','ph','Southern Tagalog',7071.0,120.7,14.06).
city('Lumil','ph','Southern Tagalog',2512.0,121.01,14.18).
city('Luntal','ph','Southern Tagalog',2765.0,120.72,14.03).
city('Lusacan','ph','Southern Tagalog',14870.0,121.35,13.95).
city('Mabini','ph','Southern Tagalog',2767.0,120.94,13.75).
city('Mabitac','ph','Southern Tagalog',12398.0,121.43,14.43).
city('Macalamcam','ph','Southern Tagalog',2931.0,121.32,13.85).
city('Macalelon','ph','Southern Tagalog',6042.0,122.14,13.75).
city('Madulao','ph','Southern Tagalog',3378.0,122.34,13.56).
city('Magallanes','ph','Southern Tagalog',3396.0,120.76,14.19).
city('Magbay','ph','Southern Tagalog',3248.0,121.09,12.41).
city('Magdalena','ph','Southern Tagalog',3168.0,121.43,14.2).
city('Magdiwang','ph','Southern Tagalog',2716.0,122.51,12.49).
city('Magsaysay','ph','Southern Tagalog',9407.0,121.15,12.33).
city('Maguyam','ph','Southern Tagalog',5437.0,121.03,14.28).
city('Mahabang Parang','ph','Southern Tagalog',2791.0,121.08,13.98).
city('Mainit','ph','Southern Tagalog',2373.0,119.9,11.51).
city('Majayjay','ph','Southern Tagalog',11412.0,121.47,14.15).
city('Malabag','ph','Southern Tagalog',7021.0,120.97,14.15).
city('Malab','ph','Southern Tagalog',3731.0,121.13,14.0).
city('Malabanban','ph','Southern Tagalog',19470.0,121.47,13.93).
city('Malainen Luma','ph','Southern Tagalog',2813.0,120.79,14.27).
city('Malaking Pulo','ph','Southern Tagalog',6182.0,121.08,14.13).
city('Malamig','ph','Southern Tagalog',2824.0,121.37,12.95).
city('Malanday','ph','Southern Tagalog',21901.0,121.09,14.65).
city('Malaruhatan','ph','Southern Tagalog',3169.0,120.67,14.03).
city('Malatgao','ph','Southern Tagalog',2270.0,118.45,9.3).
city('Malaya','ph','Southern Tagalog',11442.0,121.34,14.4).
city('Malibago','ph','Southern Tagalog',3087.0,122.01,13.28).
city('Malicboy','ph','Southern Tagalog',6224.0,121.79,13.98).
city('Maliig','ph','Southern Tagalog',2837.0,120.15,13.85).
city('Malinao','ph','Southern Tagalog',7528.0,121.83,14.0).
city('Malitbog','ph','Southern Tagalog',3125.0,121.47,12.76).
city('Maluanluan','ph','Southern Tagalog',3116.0,121.43,13.09).
city('Malvar','ph','Southern Tagalog',29880.0,121.16,14.04).
city('Mamala','ph','Southern Tagalog',7418.0,121.52,14.02).
city('Mamatid','ph','Southern Tagalog',40271.0,121.16,14.23).
city('Mamburao','ph','Southern Tagalog',23892.0,120.59,13.23).
city('Managpi','ph','Southern Tagalog',2683.0,121.2,13.31).
city('Manaul','ph','Southern Tagalog',3011.0,121.41,12.45).
city('Mangarin','ph','Southern Tagalog',3246.0,121.12,12.35).
city('Mangas','ph','Southern Tagalog',4911.0,120.87,14.12).
city('Manggahan','ph','Southern Tagalog',13825.0,120.91,14.29).
city('Manggalang','ph','Southern Tagalog',22401.0,121.48,13.87).
city('Mansalay','ph','Southern Tagalog',23044.0,121.44,12.52).
city('Mapulo','ph','Southern Tagalog',2828.0,121.18,13.73).
city('Mapulot','ph','Southern Tagalog',2668.0,122.54,14.03).
city('Maragondon','ph','Southern Tagalog',22973.0,120.74,14.27).
city('Marao','ph','Southern Tagalog',2245.0,121.84,13.91).
city('Maria Aurora','ph','Southern Tagalog',6807.0,121.48,15.8).
city('Masaguisi','ph','Southern Tagalog',2481.0,121.45,12.75).
city('Masalukot','ph','Southern Tagalog',10667.0,121.42,13.98).
city('Masapang','ph','Southern Tagalog',4579.0,121.34,14.2).
city('Masaya','ph','Southern Tagalog',7587.0,121.27,14.14).
city('Masiga','ph','Southern Tagalog',2668.0,121.83,13.36).
city('Mataas na Kahoy','ph','Southern Tagalog',17612.0,121.12,13.96).
city('Matabungkay','ph','Southern Tagalog',3718.0,120.62,13.95).
city('Matagbak','ph','Southern Tagalog',2893.0,120.83,14.13).
city('Matala','ph','Southern Tagalog',2597.0,121.16,13.83).
city('Mataywanac','ph','Southern Tagalog',2375.0,120.73,14.03).
city('Matingain','ph','Southern Tagalog',4130.0,120.88,13.92).
city('Maugat','ph','Southern Tagalog',2613.0,121.3,13.85).
city('Maujao','ph','Southern Tagalog',2310.0,121.3,12.29).
city('Maulawin','ph','Southern Tagalog',6822.0,121.43,14.27).
city('Mendez','ph','Southern Tagalog',22081.0,120.91,14.13).
city('Mogpog','ph','Southern Tagalog',3192.0,121.86,13.47).
city('Montalban','ph','Southern Tagalog',134436.0,121.12,14.74).
city('Montecillo','ph','Southern Tagalog',3289.0,121.48,13.89).
city('Morong','ph','Southern Tagalog',49589.0,121.24,14.51).
city('Mulanay','ph','Southern Tagalog',7643.0,122.4,13.52).
city('Muzon','ph','Southern Tagalog',4301.0,120.99,13.85).
city('Nag-Iba','ph','Southern Tagalog',2370.0,121.28,13.33).
city('Nagcarlan','ph','Southern Tagalog',24560.0,121.42,14.14).
city('Navotas','ph','Souther',3220.0,121.23,14.42).
city('New Agutaya','ph','Southern Tagalog',2464.0,119.31,10.56).
city('New Guinlo','ph','Southern Tagalog',3676.0,119.44,10.8).
city('Noveleta','ph','Southern Tagalog',37299.0,120.88,14.43).
city('Odiong','ph','Southern Tagalog',3346.0,121.47,12.59).
city('Odiongan','ph','Southern Tagalog',6077.0,121.99,12.4).
city('Osmena','ph','Southern Tagalog',4866.0,119.93,10.52).
city('Paagahan','ph','Southern Tagalog',3621.0,121.4,14.44).
city('Paclolo','ph','Southern Tagalog',2346.0,121.17,12.38).
city('Padre Garcia','ph','Southern Tagalog',4304.0,121.22,13.88).
city('Paete','ph','Southern Tagalog',26855.0,121.48,14.36).
city('Pag-Asa','ph','Southern Tagalog',15040.0,120.78,13.09).
city('Pagsangahan','ph','Southern Tagalog',13572.0,122.54,13.22).
city('Pagsanjan','ph','Southern Tagalog',4279.0,121.45,14.27).
city('Paiisa','ph','Southern Tagalog',4275.0,121.36,13.93).
city('Pakil','ph','Southern Tagalog',10693.0,121.48,14.38).
city('Palahanan','ph','Southern Tagalog',3404.0,121.37,13.83).
city('Palangue','ph','Southern Tagalog',9567.0,120.81,14.28).
city('Paluan','ph','Southern Tagalog',4549.0,120.47,13.42).
city('Pambisan','ph','Southern Tagalog',2844.0,121.41,13.01).
city('Panacan','ph','Southern Tagalog',10526.0,118.41,9.25).
city('Panalingaan','ph','Southern Tagalog',2973.0,117.42,8.78).
city('Pancol','ph','Southern Tagalog',2261.0,119.42,10.87).
city('Pangao','ph','Southern Tagalog',2314.0,121.13,13.92).
city('Panggulayan','ph','Southern Tagalog',2737.0,121.43,13.05).
city('Pangil','ph','Southern Tagalog',19726.0,121.47,14.4).
city('Pangobilian','ph','Southern Tagalog',7178.0,117.86,8.8).
city('Panikihan','ph','Southern Tagalog',24.0,122.13,13.9).
city('Panique','ph','Southern Tagalog',2690.0,122.02,12.48).
city('Panitian','ph','Southern Tagalog',7258.0,118.09,9.1).
city('Panlaitan','ph','Southern Tagalog',2596.0,119.85,12.12).
city('Pansol','ph','Southern Tagalog',6380.0,121.24,13.89).
city('Pansoy','ph','Southern Tagalog',5728.0,122.6,13.18).
city('Pantay','ph','Southern Tagalog',5791.0,121.12,14.12).
city('Pantihan','ph','Southern Tagalog',5182.0,120.79,14.25).
city('Panukulan','ph','Southern Tagalog',2836.0,121.81,14.93).
city('Paradahan','ph','Southern Tagalog',8977.0,120.86,14.32).
city('Pasong Buaya','ph','Southern Tagalog',12047.0,120.92,14.21).
city('Pasong Kawayan','ph','Southern Tagalog',7031.0,120.88,14.34).
city('Patabog','ph','Southern Tagalog',3149.0,122.46,13.45).
city('Patnanungan','ph','Southern Tagalog',6901.0,122.18,14.78).
city('Pato-o','ph','Southern Tagalog',2949.0,122.06,12.43).
city('Perez','ph','Southern Tagalog',4788.0,121.92,14.2).
city('Pila','ph','Southern Tagalog',34383.0,121.36,14.23).
city('Pili','ph','Southern Tagalog',3421.0,121.52,13.07).
city('Pililla','ph','Southern Tagalog',30408.0,121.0,14.48).
city('Pinagsibaan','ph','Southern Tagalog',2671.0,121.32,13.84).
city('Pinugay','ph','Southern Tagalog',5666.0,121.26,14.6).
city('Pitogo','ph','Southern Tagalog',5230.0,121.59,13.15).
city('Plaridel','ph','Southern Tagalog',3503.0,120.28,11.66).
city('Poctol','ph','Southern Tagalog',2237.0,121.43,13.82).
city('Polillo','ph','Southern Tagalog',5502.0,121.94,14.71).
city('Port Barton','ph','Southern Tagalog',4832.0,119.25,10.48).
city('Prenza','ph','Southern Tagalog',3731.0,120.66,14.0).
city('Prinza','ph','Southern Tagalog',2907.0,121.13,14.2).
city('Progreso','ph','Southern Tagalog',3097.0,122.09,13.9).
city('Puerto Galera','ph','Southern Tagalog',3274.0,120.95,13.5).
city('Puerto Princesa','ph','Southern Tagalog',154816.0,118.74,9.74).
city('Pulangbato','ph','Southern Tagalog',2320.0,121.4,13.75).
city('Pulo','ph','Southern Tagalog',2267.0,121.63,14.72).
city('Pulot','ph','Southern Tagalog',12569.0,118.02,8.93).
city('Punang','ph','Southern Tagalog',2533.0,118.06,9.02).
city('Punta','ph','Southern Tagalog',2756.0,121.68,13.27).
city('Punta Baja','ph','Southern Tagalog',8480.0,117.65,9.07).
city('Puting Kahoy','ph','Southern Tagalog',4046.0,121.03,14.22).
city('Putingkahoy','ph','Southern Tagalog',2577.0,121.31,13.82).
city('Putol','ph','Southern Tagalog',5387.0,120.73,13.99).
city('Quezon','ph','Southern Tagalog',7333.0,120.11,11.63).
city('Quilo-quilo','ph','Southern Tagalog',5742.0,121.06,13.93).
city('Quinabigan','ph','Southern Tagalog',2575.0,121.48,12.99).
city('Quipot','ph','Southern Tagalog',3190.0,121.36,13.86).
city('Quisao','ph','Southern Tagalog',10989.0,121.34,14.43).
city('Ransang','ph','Southern Tagalog',3548.0,117.58,8.96).
city('Real','ph','Southern Tagalog',9163.0,121.6,14.66).
city('Rio Tuba','ph','Southern Tagalog',8943.0,117.44,8.52).
city('Rizal','ph','Southern Tagalog',3878.0,121.28,14.0).
city('Romblon','ph','Southern Tagalog',15316.0,122.27,12.58).
city('Rosario','ph','Southern Tagalog',5563.0,122.28,13.85).
city('Roxas','ph','Southern Tagalog',14335.0,121.52,12.59).
city('Sabang','ph','Southern Tagalog',3540.0,121.61,13.65).
city('Sagana','ph','Southern Tagalog',2298.0,121.49,12.72).
city('Salcedo','ph','Southern Tagalog',4618.0,121.47,12.81).
city('Salvacion','ph','Southern Tagalog',2361.0,119.93,12.13).
city('Sampalac','ph','Southern Tagalog',6743.0,121.64,14.16).
city('Sampaloc','ph','Southern Tagalog',11590.0,121.16,14.33).
city('Sampiro','ph','Southern Tagalog',2465.0,121.38,13.78).
city('San Agustin','ph','Southern Tagalog',4054.0,121.47,12.76).
city('San Andres','ph','Southern Tagalog',4528.0,121.68,13.79).
city('San Antonio','ph','Southern Tagalog',2595.0,121.39,14.05).
city('San Aquilino','ph','Southern Tagalog',3151.0,121.49,12.6).
city('San Carlos','ph','Southern Tagalog',4644.0,121.24,13.84).
city('San Celestino','ph','Southern Tagalog',2222.0,121.24,13.93).
city('San Diego','ph','Southern Tagalog',2970.0,121.06,14.11).
city('San Felix','ph','Southern Tagalog',8068.0,121.32,14.05).
city('San Francisco','ph','Southern Tagalog',2776.0,121.78,13.84).
city('San Gregorio','ph','Southern Tagalog',3068.0,121.27,14.03).
city('San Isidro','ph','Southern Tagalog',2950.0,121.31,13.83).
city('San Joaquin','ph','Southern Tagalog',3498.0,121.2,14.06).
city('San Jose','ph','Southern Tagalog',14969.0,120.53,12.35).
city('San Juan','ph','Southern Tagalog',7090.0,121.74,13.8).
city('San Mariano','ph','Southern Tagalog',4781.0,121.44,12.64).
city('San Mateo','ph','Southern Tagalog',134515.0,121.13,14.71).
city('San Miguel','ph','Southern Tagalog',2798.0,121.29,14.04).
city('San Narciso','ph','Southern Tagalog',11118.0,122.57,13.57).
city('San Nicolas','ph','Southern Tagalog',2340.0,120.95,13.93).
city('San Pablo','ph','Southern Tagalog',207572.0,121.33,14.07).
city('San Pascual','ph','Southern Tagalog',39395.0,121.03,13.8).
city('San Pedro','ph','Southern Tagalog',92310.0,121.07,13.62).
city('San Rafael','ph','Southern Tagalog',3792.0,121.42,14.12).
city('San Teodoro','ph','Southern Tagalog',4827.0,121.02,13.44).
city('San Vicente','ph','Southern Tagalog',3484.0,120.88,12.62).
city('Santa Brigida','ph','Southern Tagalog',2541.0,121.49,12.57).
city('Santa Catalina','ph','Southern Tagalog',2278.0,121.34,14.12).
city('Santa Catalina Norte','ph','Southern Tagalog',5448.0,121.36,13.87).
city('Santa Catalina Sur','ph','Southern Tagalog',6195.0,121.43,13.87).
city('Santa Cecilia','ph','Southern Tagalog',4229.0,122.25,14.1).
city('Santa Clara','ph','Southern Tagalog',4430.0,121.06,13.75).
city('Santa Cruz','ph','Southern Tagalog',26559.0,121.32,13.77).
city('Santa Fe','ph','Southern Tagalog',2358.0,122.0,12.16).
city('Santa Lucia','ph','Southern Tagalog',4224.0,121.43,14.03).
city('Santa Maria','ph','Southern Tagalog',4776.0,121.45,13.53).
city('Santa Rosa','ph','Southern Tagalog',74348.0,121.46,14.1).
city('Santa Teresa','ph','Southern Tagalog',3177.0,121.11,12.25).
city('Santa Teresita','ph','Southern Tagalog',2849.0,120.98,13.87).
city('Santiago','ph','Southern Tagalog',4939.0,121.28,14.02).
city('Santisimo Rosario','ph','Southern Tagalog',4190.0,121.31,14.0).
city('Santo Nino','ph','Southern Tagalog',2651.0,121.12,13.77).
city('Santo Tomas','ph','Southern Tagalog',2446.0,121.5,14.18).
city('Santor','ph','Southern Tagalog',3448.0,121.11,14.09).
city('Sapul','ph','Southern Tagalog',2840.0,121.19,13.37).
city('Saraza','ph','Southern Tagalog',2533.0,117.78,8.74).
city('Sibulan','ph','Southern Tagalog',3633.0,121.93,14.75).
city('Sico','ph','Southern Tagalog',3919.0,121.38,13.83).
city('Sinala','ph','Southern Tagalog',2802.0,120.97,13.8).
city('Sinisian','ph','Southern Tagalog',3703.0,120.84,13.91).
city('Socorro','ph','Southern Tagalog',5543.0,121.41,13.06).
city('Solo','ph','Southern Tagalog',3065.0,120.9,13.75).
city('Suba','ph','Southern Tagalog',2965.0,121.01,10.84).
city('Subaan','ph','Southern Tagalog',2527.0,121.37,13.13).
city('Subic','ph','Southern Tagalog',8882.0,120.94,13.95).
city('Suclayin','ph','Southern Tagalog',5734.0,121.55,15.76).
city('Sugod','ph','Southern Tagalog',2221.0,122.68,12.38).
city('Sumagui','ph','Southern Tagalog',3495.0,121.47,12.8).
city('Taal','ph','Southern Tagalog',39761.0,120.92,13.88).
city('Tabinay','ph','Southern Tagalog',2522.0,120.93,13.48).
city('Tabon','ph','Southern Tagalog',3801.0,117.99,9.24).
city('Taburi','ph','Southern Tagalog',2501.0,117.34,8.68).
city('Tacligan','ph','Southern Tagalog',2593.0,121.06,13.4).
city('Taclobo','ph','Southern Tagalog',4782.0,122.59,12.31).
city('Tagabas','ph','Southern Tagalog',2228.0,122.27,13.62).
city('Tagaytay','ph','Southern Tagalog',52883.0,120.96,14.11).
city('Tagbac','ph','Southern Tagalog',4143.0,120.09,13.84).
city('Tagbacan','ph','Southern Tagalog',4840.0,122.36,13.63).
city('Tagburos','ph','Southern Tagalog',4149.0,118.73,9.83).
city('Tagkawayan','ph','Southern Tagalog',7684.0,122.53,13.97).
city('Tagusao','ph','Southern Tagalog',2961.0,117.81,9.19).
city('Tala','ph','Southern Tagalog',4270.0,122.58,13.28).
city('Talaga','ph','Southern Tagalog',3231.0,120.93,13.73).
city('Talahib','ph','Southern Tagalog',3117.0,121.13,13.64).
city('Talahiban','ph','Southern Tagalog',3385.0,121.39,13.81).
city('Talaibon','ph','Southern Tagalog',2820.0,121.14,13.84).
city('Talipan','ph','Southern Tagalog',4473.0,121.68,13.93).
city('Talisay','ph','Southern Tagalog',10822.0,121.42,13.73).
city('Talumpok','ph','Southern Tagalog',4722.0,121.16,13.73).
city('Tambong','ph','Southern Tagalog',2510.0,121.49,12.96).
city('Tampayan','ph','Southern Tagalog',2839.0,122.52,12.48).
city('Tanay','ph','Southern Tagalog',59898.0,121.29,14.5).
city('Tanza','ph','Southern Tagalog',105537.0,120.93,14.69).
city('Tarusan','ph','Southern Tagalog',3107.0,117.52,8.65).
city('Taysan','ph','Southern Tagalog',5296.0,121.07,13.87).
city('Taytay','ph','Southern Tagalog',80621.0,120.69,13.17).
city('Tayuman','ph','Southern Tagalog',5276.0,122.52,13.42).
city('Taywanak','ph','Southern Tagalog',3093.0,120.85,14.16).
city('Teneguiban','ph','Southern Tagalog',3267.0,119.5,11.36).
city('Teresa','ph','Southern Tagalog',34715.0,121.21,14.56).
city('Ternate','ph','Southern Tagalog',20050.0,120.72,14.29).
city('Tiaong','ph','Southern Tagalog',5044.0,121.32,13.95).
city('Tignoan','ph','Southern Tagalog',4164.0,121.62,14.56).
city('Tiguion','ph','Southern Tagalog',3018.0,121.86,13.33).
city('Tiguisan','ph','Southern Tagalog',2486.0,121.46,12.84).
city('Tigwi','ph','Southern Tagalog',2543.0,122.04,13.27).
city('Tilik','ph','Southern Tagalog',2350.0,120.2,13.82).
city('Tinamnan','ph','Southern Tagalog',2582.0,121.58,14.1).
city('Tingloy','ph','Southern Tagalog',2646.0,120.87,13.66).
city('Toong','ph','Southern Tagalog',2684.0,120.76,14.04).
city('Torrijos','ph','Southern Tagalog',3002.0,122.09,13.32).
city('Tranca','ph','Southern Tagalog',2445.0,121.07,14.13).
city('Trece Martires City','ph','Southern Tagalog',42687.0,120.85,14.28).
city('Tuban','ph','Southern Tagalog',2402.0,120.83,12.81).
city('Tugdan','ph','Southern Tagalog',2373.0,122.08,12.31).
city('Tuhian','ph','Southern Tagalog',2646.0,122.22,13.65).
city('Tulay','ph','Southern Tagalog',3294.0,120.77,14.27).
city('Tumalim','ph','Southern Tagalog',3692.0,120.72,14.08).
city('Tumarbong','ph','Southern Tagalog',3261.0,119.46,10.38).
city('Tuy','ph','Southern Tagalog',8603.0,120.73,14.01).
city('Udalo','ph','Southern Tagalog',3047.0,120.83,13.48).
city('Umiray','ph','Southern Tagalog',5096.0,121.42,15.22).
city('Unisan','ph','Southern Tagalog',4764.0,121.98,13.84).
city('Victoria','ph','Southern Tagalog',17272.0,121.31,13.71).
city('Vigo','ph','Southern Tagalog',2482.0,120.18,13.83).
city('Wawa','ph','Southern Tagalog',4057.0,121.08,13.84).
city('Yook','ph','Southern Tagalog',2820.0,121.97,13.23).
city('Yuni','ph','Southern Tagalog',5714.0,122.48,13.42).
city('Alicia','ph','Western Mindanao',3306.0,122.93,7.51).
city('Aurora','ph','Western Mindanao',9157.0,123.58,7.95).
city('Bacungan','ph','Western Mindanao',3771.0,122.93,8.15).
city('Balagon','ph','Western Mindanao',2691.0,123.23,8.01).
city('Balas','ph','Western Mindanao',2295.0,122.14,6.69).
city('Barcelona','ph','Western Mindanao',2255.0,123.5,8.54).
city('Batu','ph','Western Mindanao',2966.0,122.83,7.75).
city('Bayog','ph','Western Mindanao',4284.0,123.07,7.87).
city('Begang','ph','Western Mindanao',2384.0,122.02,6.69).
city('Bolong','ph','Western Mindanao',5189.0,122.24,7.1).
city('Buenavista','ph','Western Mindanao',6132.0,122.26,7.24).
city('Bunguiao','ph','Western Mindanao',6728.0,122.2,7.1).
city('Buug','ph','Western Mindanao',8559.0,123.06,7.73).
city('Cabaluay','ph','Western Mindanao',3586.0,122.17,7.0).
city('Calabasa','ph','Western Mindanao',2419.0,122.23,7.25).
city('Colonia','ph','Western Mindanao',2587.0,122.16,6.64).
city('Culianan','ph','Western Mindanao',5915.0,122.15,6.98).
city('Curuan','ph','Western Mindanao',6776.0,122.23,7.21).
city('Danlugan','ph','Western Mindanao',2666.0,123.37,7.89).
city('Dapitan','ph','Western Mindanao',50517.0,123.43,8.66).
city('Dawa-dawa','ph','Western Mindanao',2299.0,122.84,7.47).
city('Del Monte','ph','Western Mindanao',2213.0,123.01,7.73).
city('Dicoyong','ph','Western Mindanao',2075.0,123.03,8.22).
city('Dimataling','ph','Western Mindanao',4273.0,123.37,7.53).
city('Dipla','ph','Western Mindanao',3338.0,123.02,7.72).
city('Dipolo','ph','Western Mindanao',2679.0,123.12,7.78).
city('Dipolog','ph','Western Mindanao',94139.0,123.35,8.59).
city('Diwan','ph','Western Mindanao',3847.0,123.42,8.61).
city('Dulian','ph','Western Mindanao',2722.0,122.18,7.12).
city('Dumalinao','ph','Western Mindanao',3966.0,123.37,7.82).
city('Dumingag','ph','Western Mindanao',6534.0,123.35,8.17).
city('East Migpulao','ph','Western Mindanao',2689.0,123.36,7.63).
city('Gandiangan','ph','Western Mindanao',2169.0,122.91,7.68).
city('Guiong','ph','Western Mindanao',2477.0,122.03,6.42).
city('Guipos','ph','Western Mindanao',4050.0,123.32,7.73).
city('Ilaya','ph','Western Mindanao',3123.0,123.43,8.54).
city('Imelda','ph','Western Mindanao',5640.0,123.95,7.65).
city('Ipil','ph','Western Mindanao',19196.0,122.59,7.78).
city('Irasan','ph','Western Mindanao',2170.0,123.21,8.53).
city('Isabela','ph','Western Mindanao',67341.0,121.97,6.7).
city('Jolo','ph','Western Mindanao',102222.0,120.99,6.05).
city('Josefina','ph','Western Mindanao',3152.0,123.53,8.2).
city('Kagawasan','ph','Western Mindanao',2224.0,123.4,7.87).
city('Kalawit','ph','Western Mindanao',8499.0,122.52,8.07).
city('Kalian','ph','Western Mindanao',2815.0,123.24,7.59).
city('Katipunan','ph','Western Mindanao',7405.0,123.06,8.05).
city('Kawayan','ph','Western Mindanao',2154.0,122.87,7.54).
city('Kipit','ph','Western Mindanao',2325.0,122.53,8.05).
city('Kumalarang','ph','Western Mindanao',6870.0,123.15,7.75).
city('La Dicha','ph','Western Mindanao',2725.0,123.0,7.67).
city('Labangan','ph','Western Mindanao',10781.0,123.51,7.86).
city('Labuan','ph','Western Mindanao',12949.0,121.9,7.1).
city('Lakewood','ph','Western Mindanao',6540.0,123.16,7.85).
city('Lamisahan','ph','Western Mindanao',2989.0,122.16,7.07).
city('Landang','ph','Western Mindanao',3542.0,122.25,6.96).
city('Langatian','ph','Western Mindanao',3518.0,123.23,8.52).
city('Lantawan','ph','Western Mindanao',2766.0,121.84,6.64).
city('Laparay','ph','Western Mindanao',2140.0,122.82,7.4).
city('Lapuyan','ph','Western Mindanao',5274.0,123.2,7.64).
city('Legarda','ph','Western Mindanao',4016.0,123.31,7.63).
city('Liargo','ph','Western Mindanao',4892.0,123.51,8.0).
city('Licomo','ph','Western Mindanao',5456.0,122.34,7.47).
city('Liloy','ph','Western Mindanao',4784.0,122.66,8.11).
city('Limaong','ph','Western Mindanao',3321.0,122.37,7.36).
city('Limpapa','ph','Western Mindanao',3751.0,121.91,7.12).
city('Linay','ph','Western Mindanao',2657.0,123.13,8.52).
city('Lingasad','ph','Western Mindanao',2421.0,123.37,8.49).
city('Lintangan','ph','Western Mindanao',3211.0,121.95,7.22).
city('Lumbayao','ph','Western Mindanao',2557.0,122.14,6.95).
city('Lumbog','ph','Western Mindanao',2128.0,123.2,7.56).
city('Mabuhay','ph','Western Mindanao',2848.0,122.84,7.42).
city('Mahayag','ph','Western Mindanao',17146.0,123.45,8.11).
city('Malangas','ph','Western Mindanao',8473.0,123.03,7.63).
city('Malayal','ph','Western Mindanao',2811.0,121.94,7.21).
city('Malim','ph','Western Mindanao',2356.0,123.43,7.45).
city('Maluso','ph','Western Mindanao',31375.0,121.88,6.54).
city('Mandih','ph','Western Mindanao',3420.0,123.02,8.21).
city('Mangusu','ph','Western Mindanao',3710.0,122.28,7.33).
city('Manicahan','ph','Western Mindanao',8338.0,122.2,7.02).
city('Manukan','ph','Western Mindanao',11524.0,123.1,8.53).
city('Margosatubig','ph','Western Mindanao',14606.0,123.17,7.58).
city('Mercedes','ph','Western Mindanao',8730.0,122.15,6.96).
city('Midsalip','ph','Western Mindanao',4069.0,123.27,8.0).
city('Molave','ph','Western Mindanao',21089.0,123.49,8.09).
city('Monching','ph','Western Mindanao',4393.0,122.87,7.72).
city('Muti','ph','Western Mindanao',2308.0,122.28,7.28).
city('Naga','ph','Western Mindanao',8461.0,122.75,7.77).
city('Olingan','ph','Western Mindanao',7806.0,123.32,8.53).
city('Olutanga','ph','Western Mindanao',7133.0,122.85,7.31).
city('Pagadian','ph','Western Mindanao',132578.0,123.5,7.84).
city('Panubigan','ph','Western Mindanao',2110.0,123.33,7.43).
city('Patawag','ph','Western Mindanao',2279.0,122.62,8.11).
city('Payao','ph','Western Mindanao',4674.0,122.8,7.59).
city('Pinan','ph','Western Mindanao',4512.0,123.43,8.4).
city('Pitogo','ph','Western Mindanao',5973.0,123.31,7.45).
city('Polanco','ph','Western Mindanao',3817.0,123.36,8.53).
city('Ponot','ph','Western Mindanao',6624.0,123.03,8.46).
city('Quiniput','ph','Western Mindanao',3509.0,122.22,7.18).
city('Rebokon','ph','Western Mindanao',2494.0,123.42,7.75).
city('Recodo','ph','Western Mindanao',42790.0,121.96,6.95).
city('Sagacad','ph','Western Mindanao',2073.0,123.34,7.69).
city('Salug','ph','Western Mindanao',6775.0,122.78,8.11).
city('San Isidro','ph','Western Mindanao',3006.0,123.48,8.11).
city('San Jose','ph','Western Mindanao',2085.0,123.05,7.69).
city('San Miguel','ph','Western Mindanao',2657.0,123.27,7.65).
city('San Pablo','ph','Western Mindanao',3346.0,123.46,7.66).
city('Sangali','ph','Western Mindanao',14728.0,122.2,7.07).
city('Santa Clara','ph','Western Mindanao',4306.0,122.06,6.68).
city('Semut','ph','Western Mindanao',3423.0,122.22,6.66).
city('Seres','ph','Western Mindanao',2128.0,123.35,8.38).
city('Sergio Osmena Sr','ph','Western Mindanao',4954.0,123.5,8.17).
city('Siare','ph','Western Mindanao',3531.0,122.99,8.33).
city('Siay','ph','Western Mindanao',2351.0,122.86,7.7).
city('Siayan','ph','Western Mindanao',4906.0,123.1,8.27).
city('Sibuco','ph','Western Mindanao',3327.0,122.07,7.29).
city('Sibulao','ph','Western Mindanao',2939.0,122.24,7.32).
city('Sibutad','ph','Western Mindanao',3395.0,123.48,8.58).
city('Sinubung','ph','Western Mindanao',2173.0,121.93,7.03).
city('Siocon','ph','Western Mindanao',5071.0,122.14,7.71).
city('Sirawai','ph','Western Mindanao',4126.0,122.14,7.59).
city('Sumalig','ph','Western Mindanao',3118.0,123.66,8.0).
city('Sumisip','ph','Western Mindanao',3735.0,121.97,6.42).
city('Tabina','ph','Western Mindanao',5074.0,123.41,7.47).
city('Tablas','ph','Western Mindanao',2336.0,122.17,6.63).
city('Tagasilay','ph','Western Mindanao',3192.0,122.26,7.3).
city('Talabaan','ph','Western Mindanao',3553.0,122.17,6.94).
city('Talisayan','ph','Western Mindanao',5445.0,121.93,6.99).
city('Taluksangay','ph','Western Mindanao',7343.0,122.18,6.95).
city('Talusan','ph','Western Mindanao',5783.0,122.81,7.43).
city('Tambulig','ph','Western Mindanao',7488.0,123.54,8.07).
city('Tampilisan','ph','Western Mindanao',3578.0,122.68,8.02).
city('Tawagan','ph','Western Mindanao',2810.0,123.48,7.85).
city('Tictapul','ph','Western Mindanao',2297.0,122.33,7.42).
city('Tigbao','ph','Western Mindanao',2207.0,122.33,7.43).
city('Tigpalay','ph','Western Mindanao',5480.0,122.34,7.49).
city('Tigtabon','ph','Western Mindanao',3546.0,122.17,6.9).
city('Tiguha','ph','Western Mindanao',2142.0,123.21,7.7).
city('Tiparak','ph','Western Mindanao',2898.0,123.52,8.04).
city('Titay','ph','Western Mindanao',11469.0,122.53,7.81).
city('Tolosa','ph','Western Mindanao',2686.0,122.16,7.03).
city('Tuburan','ph','Western Mindanao',8205.0,122.27,6.64).
city('Tukuran','ph','Western Mindanao',13149.0,123.58,7.85).
city('Tungawan','ph','Western Mindanao',3603.0,122.37,7.51).
city('Vitali','ph','Western Mindanao',9653.0,122.29,7.37).
city('Zamboanga','ph','Western Mindanao',460879.0,122.08,6.92).
city('Abaca','ph','Western Visayas',2139.0,122.71,11.14).
city('Abangay','ph','Western Visayas',2207.0,122.65,10.97).
city('Abiera','ph','Western Visayas',2394.0,122.09,11.57).
city('Abilay','ph','Western Visayas',2195.0,122.5,10.73).
city('Agambulong','ph','Western Visayas',2300.0,122.47,11.37).
city('Aganan','ph','Western Visayas',2522.0,122.53,10.78).
city('Aglalana','ph','Western Visayas',2868.0,122.66,11.18).
city('Agpangi','ph','Western Visayas',2150.0,123.42,10.57).
city('Aguisan','ph','Western Visayas',11798.0,122.86,10.17).
city('Ajuy','ph','Western Visayas',8695.0,123.02,11.17).
city('Alacaygan','ph','Western Visayas',2598.0,123.06,10.84).
city('Alegria','ph','Western Visayas',2780.0,123.08,10.65).
city('Alibunan','ph','Western Visayas',2798.0,122.48,11.15).
city('Alicante','ph','Western Visayas',8606.0,123.02,10.89).
city('Alijis','ph','Western Visayas',2132.0,122.87,10.44).
city('Alim','ph','Western Visayas',3732.0,122.49,9.57).
city('Alimo','ph','Western Visayas',7302.0,122.43,10.82).
city('Alimono','ph','Western Visayas',2708.0,122.71,11.19).
city('Altavas','ph','Western Visayas',2736.0,122.49,11.54).
city('Andres Bonifacio','ph','Western Visayas',6493.0,123.25,10.92).
city('Anoring','ph','Western Visayas',2860.0,123.03,11.25).
city('Antipolo','ph','Western Visayas',7398.0,122.97,10.36).
city('Aquino','ph','Western Visayas',2607.0,122.11,11.83).
city('Ara-al','ph','Western Visayas',2630.0,123.05,10.42).
city('Aranas','ph','Western Visayas',4479.0,122.4,11.57).
city('Aranda','ph','Western Visayas',3100.0,122.95,10.24).
city('Arcangel','ph','Western Visayas',3470.0,122.35,11.54).
city('Asia','ph','Western Visayas',23547.0,122.52,9.55).
city('Astorga','ph','Western Visayas',2702.0,122.8,11.26).
city('Atabayan','ph','Western Visayas',2362.0,122.42,10.68).
city('Atipuluan','ph','Western Visayas',3940.0,122.95,10.51).
city('Aureliana','ph','Western Visayas',2172.0,121.98,10.89).
city('Avila','ph','Western Visayas',2349.0,122.71,10.69).
city('Bacalan','ph','Western Visayas',2060.0,122.09,11.55).
city('Bacolod','ph','Wes',453954.0,122.97,10.63).
city('Bacuyangan','ph','Western Visayas',7506.0,122.47,9.64).
city('Badlan','ph','Western Visayas',2041.0,122.52,11.14).
city('Bago','ph','Western Visayas',76721.0,122.86,10.55).
city('Bagroy','ph','Western Visayas',2361.0,122.94,10.2).
city('Bagtic','ph','Western Visayas',5799.0,123.06,10.77).
city('Bagumbayan','ph','Western Visayas',2577.0,122.85,10.46).
city('Bailan','ph','Western Visayas',2885.0,122.83,11.46).
city('Balabag','ph','Western Visayas',3860.0,122.21,11.37).
city('Balasan','ph','Western Visayas',4051.0,123.09,11.47).
city('Balibagan','ph','Western Visayas',2263.0,122.52,10.8).
city('Baliwagan','ph','Western Visayas',2883.0,122.88,10.4).
city('Bancal','ph','Western Visayas',4295.0,123.16,11.56).
city('Banga','ph','Western Visayas',2097.0,122.59,11.08).
city('Barotac Nuevo','ph','Western Visayas',11641.0,122.7,10.89).
city('Barotac Viejo','ph','Western Visayas',8611.0,122.85,11.04).
city('Basiao','ph','Western Visayas',2475.0,122.64,11.55).
city('Batan','ph','Western Visayas',4495.0,122.5,11.59).
city('Batbatan Island','ph','Western Visayas',2271.0,121.91,11.47).
city('Bato','ph','Western Visayas',5665.0,123.37,10.81).
city('Bay-ang','ph','Western Visayas',2477.0,122.94,11.03).
city('Bayas','ph','Western Visayas',2275.0,123.19,11.43).
city('Belison','ph','Western Visayas',4711.0,121.96,10.84).
city('Bi-ao','ph','Western Visayas',6559.0,122.99,10.12).
city('Bilao','ph','Western Visayas',5805.0,122.56,11.49).
city('Binalbagan','ph','Western Visayas',38567.0,122.87,10.2).
city('Bingawan','ph','Western Visayas',3657.0,122.57,11.23).
city('Binon-an','ph','Western Visayas',3442.0,123.14,11.4).
city('Binuntucan','ph','Western Visayas',4213.0,122.85,11.4).
city('Bitadton','ph','Western Visayas',3017.0,122.09,11.49).
city('Bocana','ph','Western Visayas',4464.0,122.72,10.01).
city('Bolilao','ph','Western Visayas',2651.0,122.73,10.88).
city('Bolo','ph','Western Visayas',4705.0,122.76,11.54).
city('Bolong','ph','Western Visayas',2899.0,122.52,10.82).
city('Buenavista','ph','Western Visayas',3218.0,123.18,10.67).
city('Bug-ang','ph','Western Visayas',6000.0,123.37,10.74).
city('Bugasong','ph','Western Visayas',2828.0,122.07,11.0).
city('Bula','ph','Western Visayas',3060.0,122.51,11.45).
city('Bulad','ph','Western Visayas',2013.0,123.0,10.26).
city('Bulanon','ph','Western Visayas',8127.0,123.47,10.92).
city('Bulata','ph','Western Visayas',5151.0,122.4,9.86).
city('Buluangan','ph','Western Visayas',12249.0,123.34,10.39).
city('Bulwang','ph','Western Visayas',3462.0,122.36,11.72).
city('Bungsuan','ph','Western Visayas',4089.0,122.7,11.23).
city('Buray','ph','Western Visayas',3863.0,122.46,10.72).
city('Burias','ph','Western Visayas',4281.0,122.57,11.45).
city('Busay','ph','Western Visayas',5503.0,122.88,10.54).
city('Buyu-an','ph','Western Visayas',3056.0,122.35,10.67).
city('Cabacungan','ph','Western Visayas',7200.0,123.13,10.32).
city('Cabadiangan','ph','Western Visayas',3279.0,122.7,9.95).
city('Cabanbanan','ph','Western Visayas',2061.0,122.96,10.09).
city('Cabano','ph','Western Visayas',5812.0,122.71,10.59).
city('Cabatuan','ph','Western Visayas',6106.0,122.49,10.88).
city('Cabilao','ph','Western Visayas',2668.0,123.14,11.54).
city('Cabilauan','ph','Western Visayas',2321.0,122.62,10.88).
city('Cabugao','ph','Western Visayas',4267.0,122.54,10.81).
city('Cadagmayan','ph','Western Visayas',2212.0,122.5,10.82).
city('Cadiz','ph','Western Visayas',131106.0,123.3,10.93).
city('Cagbang','ph','Western Visayas',3856.0,122.5,10.7).
city('Caidquid','ph','Western Visayas',2162.0,122.51,11.41).
city('Calampisawan','ph','Western Visayas',2382.0,123.47,10.61).
city('Calapi','ph','Western Visayas',2954.0,122.97,10.29).
city('Calaya','ph','Western Visayas',2713.0,122.63,10.49).
city('Caliling','ph','Western Visayas',4840.0,122.48,9.98).
city('Calizo','ph','Western Visayas',3527.0,122.39,11.58).
city('Camalobalo','ph','Western Visayas',2539.0,122.95,10.27).
city('Camanci','ph','Western Visayas',2986.0,122.35,11.73).
city('Camandag','ph','Western Visayas',4058.0,123.07,10.33).
city('Camangcamang','ph','Western Visayas',4131.0,122.98,10.18).
city('Camindangan','ph','Western Visayas',5100.0,122.61,9.92).
city('Camingawan','ph','Western Visayas',7820.0,122.84,9.9).
city('Candelaria','ph','Western Visayas',2178.0,122.53,11.28).
city('Candoni','ph','Western Visayas',6191.0,122.6,9.82).
city('Caningay','ph','Western',3296.0,122.63,9.83).
city('Canroma','ph','Western Visayas',2170.0,122.88,10.36).
city('Cansilayan','ph','Western Visayas',3809.0,123.02,10.56).
city('Canturay','ph','Western Visayas',5135.0,122.46,9.8).
city('Capagao','ph','Western Visayas',2801.0,122.75,11.43).
city('Carabalan','ph','Western Visayas',7557.0,122.95,10.11).
city('Caridad','ph','Western Visayas',3267.0,122.89,10.49).
city('Carmelo','ph','Western Visayas',2678.0,122.82,11.02).
city('Carmen','ph','Western Visayas',4945.0,122.92,10.38).
city('Carol-an','ph','Western Visayas',6321.0,122.96,9.96).
city('Cartagena','ph','Western Visayas',3396.0,122.4,9.82).
city('Casanayan','ph','Western Visayas',3453.0,123.05,11.52).
city('Caticlan','ph','Western Visayas',4223.0,121.96,11.93).
city('Catungan','ph','Western Visayas',2318.0,122.02,10.77).
city('Cawayan','ph','Western Visayas',3122.0,122.46,11.63).
city('Cayangwan','ph','Western Visayas',2070.0,122.28,11.7).
city('Cayhagan','ph','Western Visayas',3363.0,122.43,9.67).
city('Cervantes','ph','Western Visayas',2520.0,123.52,10.88).
city('Chambery','ph','Western Visayas',3108.0,123.18,10.97).
city('Codcod','ph','Western Visayas',13026.0,123.22,10.46).
city('Cogon','ph','Western Visayas',3811.0,122.8,11.47).
city('Concepcion','ph','Western Visayas',7836.0,123.09,10.95).
city('Concordia','ph','Western Visayas',3091.0,122.55,10.5).
city('Consolacion','ph','Western Visayas',2092.0,122.63,11.33).
city('Constancia','ph','Western Visayas',2713.0,122.64,10.6).
city('Consuelo','ph','Western Visayas',4543.0,122.75,10.0).
city('Cordova','ph','Western Visayas',2588.0,122.4,10.73).
city('Cortes','ph','Western Visayas',2390.0,122.4,11.54).
city('Cuartero','ph','Western Visayas',3520.0,122.67,11.34).
city('Culasi','ph','Western Visayas',4254.0,122.52,11.25).
city('Culipapa','ph','Western Visayas',7680.0,122.56,9.47).
city('Da-an','ph','Western Visayas',2085.0,122.42,11.2).
city('Daan Banua','ph','Western Visayas',4036.0,123.06,10.9).
city('Damayan','ph','Western Visayas',2308.0,122.52,11.48).
city('Dancalan','ph','Western Visayas',9862.0,122.72,9.98).
city('Dao','ph','Western Visayas',6818.0,122.32,10.95).
city('Dapdapan','ph','Western Visayas',3040.0,122.63,11.0).
city('De La Paz','ph','Western Visayas',2117.0,122.78,11.06).
city('Delicioso','ph','Western Visayas',2301.0,122.78,9.98).
city('Dian-ay','ph','Western Visayas',3195.0,123.55,10.83).
city('Dingle','ph','Western Visayas',6171.0,122.67,11.01).
city('Dongon','ph','Western Visayas',3181.0,122.32,11.72).
city('Dos Hermanas','ph','Western Visayas',9270.0,123.04,10.74).
city('Duenas','ph','Western Visayas',3705.0,122.62,11.07).
city('Dulangan','ph','Western Visayas',5339.0,122.96,11.46).
city('Dulao','ph','Western Visayas',7403.0,122.94,10.54).
city('Dumalag','ph','Western Visayas',3039.0,122.62,11.3).
city('Dumarao','ph','Western Visayas',3187.0,122.69,11.26).
city('Duran','ph','Western Visayas',3097.0,122.59,11.26).
city('East Valencia','ph','Western Visayas',2444.0,122.72,10.67).
city('Egana','ph','Western Visayas',2723.0,122.0,10.75).
city('Elizalde','ph','Western Visayas',7241.0,122.93,11.43).
city('Ermita','ph','Western Visayas',2304.0,122.72,10.9).
city('Estancia','ph','Western Visayas',11050.0,123.15,11.45).
city('Eustaquio Lopez','ph','Western Visayas',14408.0,123.04,10.82).
city('Felic','ph','Western Visayas',2484.0,122.36,11.58).
city('Gabi','ph','Western Visayas',2189.0,123.33,11.6).
city('General Luna','ph','Western Visayas',3132.0,123.57,10.83).
city('Getulio','ph','Western Visayas',2063.0,122.66,10.74).
city('Gibato','ph','Western Visayas',2360.0,122.82,11.23).
city('Gibon','ph','Western Visayas',6919.0,122.05,11.85).
city('Gines','ph','Western Visayas',2476.0,122.48,10.93).
city('Granada','ph','Western Visayas',2269.0,123.35,11.63).
city('Guadalupe','ph','Western Visayas',11053.0,123.37,10.46).
city('Guiljungan','ph','Western Visayas',14876.0,122.68,9.97).
city('Guimbal','ph','Western Visayas',7232.0,122.32,10.66).
city('Guimbala-on','ph','Western Visayas',10109.0,123.09,10.76).
city('Guinbaliwan','ph','Western Visayas',2503.0,122.39,11.66).
city('Guinticgan','ph','Western Visayas',7452.0,123.12,11.55).
city('Guintubhan','ph','Western Visayas',2330.0,122.95,10.21).
city('Guisijan','ph','Western Visayas',2196.0,122.05,11.09).
city('Haguimit','ph','Western Visayas',4008.0,123.02,10.4).
city('Hamtic','ph','Western Visayas',4816.0,121.97,10.7).
city('Harigue','ph','Western Visayas',2105.0,121.44,11.86).
city('Himaya','ph','Western Visayas',3296.0,122.83,10.45).
city('Hipona','ph','Western Visayas',2380.0,122.89,11.41).
city('Ibajay','ph','Western Visayas',2654.0,122.16,11.82).
city('Idio','ph','Western Visayas',2102.0,122.1,11.63).
city('Igang','ph','Western Visayas',3468.0,122.63,10.92).
city('Igbaras','ph','Western Visayas',5974.0,122.27,10.72).
city('Igbon','ph','Western Visayas',2367.0,123.17,11.22).
city('Igcocolo','ph','Western Visayas',2297.0,122.32,10.69).
city('Igmaya-an','ph','Western Visayas',3164.0,123.24,10.55).
city('Ilog','ph','Western Visayas',6741.0,122.77,10.03).
city('Iloilo','ph','Western Visayas',387748.0,122.55,10.69).
city('Inayawan','ph','Western Visayas',9963.0,122.44,9.9).
city('Intampilan','ph','Western Visayas',2226.0,122.75,11.48).
city('Isabela','ph','Western Visayas',15898.0,122.99,10.21).
city('Ivisan','ph','Western Visayas',5036.0,122.69,11.52).
city('Jaena','ph','Western Visayas',4272.0,122.4,11.42).
city('Jaguimitan','ph','Western Visayas',2461.0,122.72,11.16).
city('Jalaud','ph','Western Visayas',2527.0,122.7,10.87).
city('Jamabalud','ph','Western Visayas',2742.0,122.62,10.88).
city('Japitan','ph','Western Visayas',2736.0,123.54,10.76).
city('Jibao-an','ph','Western Visayas',2677.0,122.5,10.78).
city('Jordan','ph','Western Visayas',8255.0,122.59,10.66).
city('Jugas','ph','Western Visayas',2072.0,122.38,11.61).
city('Kabankalan','ph','Western Visayas',138314.0,122.82,10.0).
city('Kapitan Ramon','ph','Western Visayas',4640.0,123.13,10.77).
city('Kumaliskis','ph','Western Visayas',2837.0,123.2,10.51).
city('La Carlota','ph','Western Visayas',41313.0,122.0,10.43).
city('La Granja','ph','Western Visayas',5277.0,122.98,10.4).
city('La Paz','ph','Western Visayas',2024.0,122.52,10.43).
city('Lacaron','ph','Western Visayas',2301.0,122.73,11.42).
city('Lalab','ph','Western Visayas',2542.0,122.42,11.57).
city('Lalagsan','ph','Western Visayas',2941.0,123.01,10.28).
city('Langub','ph','Western Visayas',3039.0,123.54,10.8).
city('Lanot','ph','Western Visayas',6928.0,122.76,11.52).
city('Lantangan','ph','Western Visayas',2252.0,122.89,11.39).
city('Lawigan','ph','Western Visayas',2571.0,122.05,10.0).
city('Leganes','ph','Western Visayas',2463.0,122.59,10.79).
city('Lemery','ph','Western Visayas',3240.0,122.93,11.23).
city('Leon','ph','Western Visayas',5172.0,122.39,10.78).
city('Libacao','ph','Western Visayas',3847.0,122.61,10.83).
city('Libertad','ph','Western Visayas',2281.0,122.35,11.41).
city('Linabuan','ph','Western Visayas',3430.0,122.33,11.63).
city('Linabuan Sur','ph','Western Visayas',2789.0,122.35,11.65).
city('Linaon','ph','Western Visayas',3669.0,122.45,9.95).
city('Lonoy','ph','Western Visayas',2586.0,122.64,11.51).
city('Lopez Jaena','ph','Western Visayas',5573.0,123.43,10.85).
city('Lucero','ph','Western Visayas',2155.0,122.46,11.46).
city('Lucmayan','ph','Western Visayas',2024.0,122.53,10.48).
city('Luna','ph','Western Visayas',11311.0,123.23,10.97).
city('Lupo','ph','Western Visayas',2291.0,122.47,11.5).
city('Ma-ao','ph','Western Visayas',25837.0,122.98,10.48).
city('Ma-ayon','ph','Western Visayas',4999.0,122.78,11.39).
city('Maasin','ph','Western Visayas',3514.0,122.43,10.89).
city('Mabilo','ph','Western Visayas',2440.0,122.41,11.68).
city('Mabini','ph','Western Visayas',7270.0,123.49,10.8).
city('Madalag','ph','Western Visayas',2133.0,122.98,10.9).
city('Magallon','ph','Western Visayas',14619.0,123.08,10.27).
city('Magallon Cadre','ph','Western Visayas',3622.0,123.12,10.29).
city('Magdalena','ph','Western Visayas',2419.0,121.98,10.42).
city('Makato','ph','Western Visayas',3035.0,122.28,11.72).
city('Makiling','ph','Western Visayas',4441.0,123.39,10.78).
city('Malabor','ph','Western Visayas',2690.0,122.05,11.27).
city('Malayu-an','ph','Western Visayas',2868.0,123.01,11.1).
city('Malocloc','ph','Western Visayas',3664.0,122.68,11.51).
city('Maloco','ph','Western Visayas',2511.0,122.15,11.78).
city('Man-up','ph','Western Visayas',2433.0,122.5,11.53).
city('Manalad','ph','Western Visayas',3151.0,122.76,10.01).
city('Manapla','ph','Western Visayas',34312.0,123.13,10.96).
city('Mangoso','ph','Western Visayas',2466.0,122.63,11.42).
city('Manhoy','ph','Western Visayas',2172.0,122.67,11.35).
city('Manika','ph','Western Visayas',3074.0,122.29,11.39).
city('Manoc-Manoc','ph','Western Visayas',5990.0,121.94,11.94).
city('Mapili','ph','Western Visayas',2104.0,122.73,11.12).
city('Maribong','ph','Western Visayas',3308.0,122.53,11.1).
city('Masaling','ph','Western Visayas',3829.0,122.54,9.97).
city('Mianay','ph','Western Visayas',3042.0,122.7,11.47).
city('Mina','ph','Western Visayas',2665.0,122.58,10.93).
city('Minapasuk','ph','Western Visayas',6885.0,123.37,10.7).
city('Minoyan','ph','Western Visayas',7771.0,123.11,10.52).
city('Miranda','ph','Western Visayas',6182.0,122.89,10.33).
city('Monpon','ph','Western Visayas',2189.0,122.64,10.91).
city('Montilla','ph','Western Visayas',3558.0,122.92,10.2).
city('Morales','ph','Western Visayas',2600.0,122.38,11.54).
city('Morobuan','ph','Western Visayas',2442.0,122.55,10.63).
city('Nabulao','ph','Western Visayas',7059.0,122.46,9.66).
city('Naile','ph','Western Visayas',2221.0,122.18,11.76).
city('Naisud','ph','Western Visayas',2499.0,122.19,11.81).
city('Nambusao','ph','Western Visayas',5871.0,122.6,11.43).
city('Nanca','ph','Western Visayas',2666.0,123.04,10.86).
city('Napnapan','ph','Western Visayas',3258.0,122.4,10.71).
city('Napoles','ph','Western Visayas',5440.0,122.9,10.5).
city('Narauis','ph','Western Visayas',2233.0,122.88,10.25).
city('Nasunogan','ph','Western Visayas',2564.0,122.67,11.37).
city('Nato','ph','Western Visayas',3548.0,122.86,10.16).
city('New Lucena','ph','Western Visayas',3059.0,122.6,10.88).
city('New Washington','ph','Western Visayas',5731.0,122.43,11.65).
city('Nueva Valencia','ph','Western Visayas',2681.0,122.53,10.52).
city('Ochando','ph','Western Visayas',2615.0,122.48,11.62).
city('Odiong','ph','Western Visayas',3771.0,122.76,10.92).
city('Ondoy','ph','Western Visayas',2041.0,122.13,11.82).
city('Oracon','ph','Western Visayas',2045.0,122.6,10.48).
city('Orong','ph','Western Visayas',6772.0,122.83,9.94).
city('Pacol','ph','Western Visayas',19839.0,122.83,10.47).
city('Pakiad','ph','Western Visayas',2689.0,122.52,10.71).
city('Palampas','ph','Western Visayas',9036.0,123.4,10.53).
city('Panay','ph','Western Visayas',3048.0,122.79,11.56).
city('Panayakan','ph','Western Visayas',2298.0,122.22,11.76).
city('Pandanon','ph','Western Visayas',2201.0,123.18,10.57).
city('Panitan','ph','Western Visayas',5156.0,122.77,11.47).
city('Paraiso','ph','Western Visayas',30494.0,123.37,10.88).
city('Parian','ph','Western Visayas',2889.0,122.7,11.48).
city('Paticui','ph','Western Visayas',2742.0,122.9,10.24).
city('Patnongon','ph','Western Visayas',5810.0,121.98,10.92).
city('Patria','ph','Western Visayas',2463.0,122.02,11.74).
city('Patun-an','ph','Western Visayas',2509.0,123.47,10.57).
city('Pavia','ph','Western Visayas',5928.0,122.55,10.78).
city('Pawa','ph','Western Visayas',2138.0,122.85,11.57).
city('Payao','ph','Western Visayas',9137.0,122.95,10.18).
city('Piape','ph','Western Visayas',2543.0,121.98,10.73).
city('Pilar','ph','Western Visayas',9957.0,123.0,11.48).
city('Pili','ph','Western Visayas',2695.0,123.02,11.11).
city('Pina','ph','Western Visayas',2054.0,122.64,10.64).
city('Plaridel','ph','Western Visayas',5110.0,123.49,10.9).
city('Polo','ph','Western Visayas',2121.0,122.31,11.59).
city('Ponong','ph','Western Visayas',2513.0,122.62,11.08).
city('Pontevedra','ph','Western Visayas',5493.0,122.85,10.93).
city('Prosperidad','ph','Western Visayas',4470.0,123.31,10.52).
city('Pulupandan','ph','Western Visayas',27361.0,122.81,10.53).
city('Punao','ph','Western Visayas',5997.0,123.4,10.57).
city('Quezon','ph','Western Visayas',11681.0,123.28,10.43).
city('Quinagaringan','ph','Western Visayas',2153.0,122.59,11.12).
city('Quipot','ph','Western Visayas',2883.0,123.0,11.28).
city('Refugio','ph','Western Visayas',2289.0,123.45,10.52).
city('Rizal','ph','Western Visayas',2810.0,122.97,11.0).
city('Rosario','ph','Western Visayas',2318.0,122.3,11.58).
city('Roxas','ph','Western Visayas',102688.0,122.75,11.6).
city('Sag-Ang','ph','Western Visayas',8136.0,123.06,10.38).
city('Sagasa','ph','Western Visayas',3952.0,122.9,10.47).
city('Sagay','ph','Western Visayas',71589.0,123.42,10.93).
city('Salamanca','ph','Western Visayas',4994.0,123.53,10.75).
city('Salvacion','ph','Western Visayas',4060.0,122.58,10.56).
city('San Antonio','ph','Western Visayas',2646.0,122.45,10.8).
city('San Carlos','ph','Western Visayas',59673.0,123.38,10.55).
city('San Dionisio','ph','Western Visayas',3134.0,123.09,11.27).
city('San Enrique','ph','Western Visayas',6219.0,122.76,10.75).
city('San Fernando','ph','Western Visayas',2651.0,123.16,11.09).
city('San Francisco','ph','Western Visayas',2901.0,122.05,11.32).
city('San Isidro','ph','Western Visayas',3404.0,123.47,10.55).
city('San Joaquin','ph','Western Visayas',4893.0,122.14,10.59).
city('San Jose','ph','Western Visayas',10079.0,122.65,10.76).
city('San Juan','ph','Western Visayas',2851.0,123.15,10.42).
city('San Miguel','ph','Western Visayas',4189.0,122.74,10.71).
city('San Nicolas','ph','Western Visayas',2380.0,122.51,11.0).
city('San Pablo','ph','Western Visayas',8046.0,123.16,10.9).
city('San Pedro','ph','Western Visayas',5026.0,121.95,10.81).
city('San Rafael','ph','Western Visayas',3492.0,122.83,11.17).
city('San Salvador','ph','Western Visayas',2807.0,122.84,11.0).
city('Santa Barbara','ph','Western Visayas',8629.0,122.53,10.82).
city('Santa Cruz','ph','Western Visayas',2919.0,123.08,10.63).
city('Santa Monica','ph','Western Visayas',2581.0,122.45,10.74).
city('Santa Rosa','ph','Western Visayas',3794.0,123.08,10.59).
city('Santa Teresa','ph','Western Visayas',4000.0,122.56,10.59).
city('Santiago','ph','Western Visayas',2022.0,122.91,11.06).
city('Santo Angel','ph','Western Visayas',2344.0,122.65,11.31).
city('Santol','ph','Western Visayas',6435.0,122.97,10.17).
city('Sapi-an','ph','Western Visayas',4920.0,122.6,11.49).
city('Sara','ph','Western Visayas',4062.0,123.02,11.26).
city('Sebaste','ph','Western Visayas',2909.0,122.38,11.05).
city('Semirara','ph','Western Visayas',5470.0,121.4,12.07).
city('Sibaguan','ph','Western Visayas',2174.0,122.71,11.56).
city('Sibucao','ph','Western Visayas',2829.0,122.89,10.41).
city('Sigma','ph','Western Visayas',3222.0,122.67,11.42).
city('Silay','ph','Western Visayas',84131.0,122.98,10.75).
city('Su-ay','ph','Western Visayas',19672.0,122.86,10.06).
city('Sulangan','ph','Western Visayas',2262.0,122.69,10.83).
city('Tabu','ph','Western Visayas',6143.0,122.71,9.89).
city('Tabuc','ph','Western Visayas',5275.0,122.82,11.48).
city('Tagubong','ph','Western Visayas',2077.0,122.75,11.2).
city('Talaban','ph','Western Visayas',6003.0,122.87,10.13).
city('Talisay','ph','Western Visayas',66356.0,122.97,10.74).
city('Taloc','ph','Western Visayas',20409.0,122.9,10.57).
city('Talon','ph','Western Visayas',2311.0,122.68,11.56).
city('Tambak','ph','Western Visayas',2690.0,122.42,11.67).
city('Tambaliza','ph','Western Visayas',2950.0,123.17,11.27).
city('Tamlang','ph','Western Visayas',2275.0,123.46,10.83).
city('Tanza','ph','Western Visayas',3214.0,122.9,11.21).
city('Tapaz','ph','Western Visayas',2340.0,122.53,11.27).
city('Tarong','ph','Western Visayas',2376.0,123.12,11.53).
city('Tibiao','ph','Western Visayas',3723.0,122.04,11.29).
city('Tiglawigan','ph','Western Visayas',6848.0,123.36,10.95).
city('Tigum','ph','Western Visayas',2168.0,122.57,10.78).
city('Tiling','ph','Western Visayas',3332.0,122.65,9.97).
city('Timpas','ph','Western Visayas',3551.0,122.73,11.49).
city('Tinogboc','ph','Western Visayas',2208.0,121.41,12.01).
city('Tinongan','ph','Western Visayas',4440.0,123.04,10.22).
city('Tiring','ph','Western Visayas',2232.0,122.52,10.85).
city('Tiwi','ph','Western Visayas',2269.0,122.73,10.93).
city('Toboso','ph','Western Visayas',13006.0,123.52,10.72).
city('Tortosa','ph','Western Visayas',7048.0,123.09,10.93).
city('Trapiche','ph','Western Visayas',11539.0,122.43,10.68).
city('Tumcon','ph','Western Visayas',5067.0,122.67,10.92).
city('Tuyom','ph','Western Visayas',11117.0,122.59,9.98).
city('Udtongan','ph','Western Visayas',2201.0,123.53,10.78).
city('Ungka','ph','Western Visayas',5598.0,122.55,10.75).
city('Unidos','ph','Western Visayas',2103.0,122.01,11.9).
city('Union','ph','Western Visayas',2284.0,121.91,11.77).
city('Valderrama','ph','Western Visayas',4276.0,122.08,11.41).
city('Victorias','ph','Western Visayas',86507.0,123.06,10.89).
city('Vista Alegre','ph','Western Visayas',2709.0,122.75,9.99).
city('Vito','ph','Western Visayas',6141.0,123.51,10.9).
city('Yubo','ph','Western Visayas',2374.0,123.05,10.4).
city('Zarraga','ph','Western Visayas',3253.0,122.61,10.82).
city('Bielawa','pl','Dolnoslaskie',30824.0,16.61,50.69).
city('Bogatynia','pl','Dolnoslaskie',19221.0,14.96,50.92).
city('Boguszow-Gorce','pl','Dolnoslaskie',16726.0,16.19,50.76).
city('Boleslawiec','pl','Dolnoslaskie',40682.0,15.56,51.26).
city('Brzeg Dolny','pl','Dolnoslaskie',12707.0,16.74,51.27).
city('Bystrzyca Klodzka','pl','Dolnoslaskie',10589.0,16.64,50.3).
city('Chojnow','pl','Dolnoslaskie',14209.0,15.93,51.28).
city('Dzierzoniow','pl','Dolnoslaskie',34888.0,16.65,50.73).
city('Glogow','pl','Dolnoslaskie',68530.0,16.08,51.67).
city('Gora','pl','Dolnoslaskie',12668.0,16.52,51.67).
city('Jawor','pl','Dolnoslaskie',24269.0,16.2,51.06).
city('Jelcz-Laskowice','pl','Dolnoslaskie',15308.0,17.3,51.03).
city('Jelenia Gora','pl','Dolnoslaskie',87310.0,15.73,50.91).
city('Kamienna Gora','pl','Dolnoslaskie',21743.0,16.03,50.79).
city('Klodzko','pl','Dolnoslaskie',28627.0,16.66,50.44).
city('Kowary','pl','Dolnoslaskie',11834.0,15.83,50.8).
city('Kudowa-Zdroj','pl','Dolnoslaskie',10176.0,16.23,50.43).
city('Legnica','pl','Dolnoslaskie',106033.0,16.16,51.21).
city('Luban','pl','Dolnoslaskie',22245.0,15.28,51.12).
city('Lubin','pl','Dolnoslaskie',77532.0,16.2,51.4).
city('Lwowek Slaski','pl','Dolnoslaskie',9657.0,15.6,51.11).
city('Milicz','pl','Dolnoslaskie',12169.0,17.27,51.53).
city('Nowa Ruda','pl','Dolnoslaskie',24753.0,16.5,50.59).
city('Olawa','pl','Dolnoslaskie',31036.0,17.3,50.94).
city('Olesnica','pl','Dolnoslaskie',36956.0,17.38,51.21).
city('Pieszyce','pl','Dolnoslaskie',9406.0,16.59,50.72).
city('Polkowice','pl','Dolnoslaskie',21565.0,16.05,51.5).
city('Strzegom','pl','Dolnoslaskie',17004.0,16.35,50.96).
city('Strzelin','pl','Dolnoslaskie',12394.0,17.07,50.78).
city('Swidnica','pl','Dolnoslaskie',60351.0,16.49,50.85).
city('Swiebodzice','pl','Dolnoslaskie',23228.0,16.33,50.86).
city('Sycow','pl','Dolnoslaskie',10809.0,17.71,51.3).
city('Trzebnica','pl','Dolnoslaskie',12212.0,17.06,51.31).
city('Walbrzych','pl','Dolnoslaskie',127431.0,16.28,50.78).
city('Wolo','pl','Dolnoslaskie',12276.0,16.63,51.33).
city('Wroclaw','pl','Dolnoslaskie',634893.0,17.03,51.11).
city('Zabkowice Slaskie','pl','Dolnoslaskie',16321.0,16.82,50.59).
city('Zgorzelec','pl','Dolnoslaskie',33247.0,15.01,51.15).
city('Ziebice','pl','Dolnoslaskie',9328.0,17.05,50.6).
city('Zlotoryja','pl','Dolnoslaskie',16612.0,15.91,51.12).
city('Aleksandrow Kujawski','pl','Kujawsko-Pomorskie',12285.0,18.7,52.88).
city('Brodnica','pl','Kujawsko-Pomorskie',27341.0,19.4,53.26).
city('Bydgoszcz','pl','Kujawsko-Pomorskie',366452.0,18.01,53.12).
city('Chelmno','pl','Kujawsko-Pomorskie',20576.0,18.43,53.35).
city('Chelmza','pl','Kujawsko-Pomorskie',15403.0,18.61,53.18).
city('Ciechocinek','pl','Kujawsko-Pomorskie',10832.0,18.79,52.88).
city('Golub-Dobrzyn','pl','Kujawsko-Pomorskie',12937.0,19.04,53.11).
city('Grudziadz','pl','Kujawsko-Pomorskie',99486.0,18.75,53.49).
city('Inowroclaw','pl','Kujawsko-Pomorskie',77597.0,18.25,52.78).
city('Janikowo','pl','Kujawsko-Pomorskie',8942.0,17.03,52.43).
city('Koronowo','pl','Kujawsko-Pomorskie',10965.0,17.93,53.31).
city('Kruszwica','pl','Kujawsko-Pomorskie',9494.0,18.3,52.68).
city('Lipno','pl','Kujawsko-Pomorskie',14821.0,19.17,52.84).
city('Mogilno','pl','Kujawsko-Pomorskie',12465.0,17.96,52.65).
city('Naklo nad Notecia','pl','Kujawsko-Pomorskie',19565.0,17.6,53.14).
city('Rypin','pl','Kujawsko-Pomorskie',16589.0,19.41,53.07).
city('Sepolno Krajenskie','pl','Kujawsko-Pomorskie',9223.0,17.53,53.45).
city('Solec Kujawski','pl','Kujawsko-Pomorskie',15125.0,18.23,53.07).
city('Swiecie','pl','Kujawsko-Pomorskie',25843.0,18.44,53.4).
city('Szubin','pl','Kujawsko-Pomorskie',9206.0,17.72,53.01).
city('Torun','pl','Kujawsko-Pomorskie',208717.0,18.61,53.02).
city('Tuchola','pl','Kujawsko-Pomorskie',13686.0,17.85,53.59).
city('Wabrzezno','pl','Kujawsko-Pomorskie',13911.0,18.94,53.28).
city('Wloclawek','pl','Kujawsko-Pomorskie',120339.0,19.06,52.66).
city('Znin','pl','Kujawsko-Pomorskie',14008.0,17.71,52.85).
city('Aleksandrow Lodzki','pl','Lodzkie',20292.0,19.3,51.82).
city('Belchatow','pl','Lodzkie',62896.0,19.36,51.37).
city('Brzeziny','pl','Lodzkie',12319.0,19.75,51.81).
city('Glowno','pl','Lodzkie',15103.0,19.7,51.98).
city('Koluszki','pl','Lodzkie',13343.0,19.82,51.75).
city('Konstantynow Lodzki','pl','Lodzkie',17415.0,19.32,51.75).
city('Kutno','pl','Lodzkie',48323.0,19.36,52.24).
city('Lask','pl','Lodzkie',18577.0,19.14,51.6).
city('Leczyca','pl','Lodzkie',15528.0,19.2,52.07).
city('Lodz','pl','Lodzkie',768755.0,19.46,51.77).
city('Lowicz','pl','Lodzkie',30397.0,19.93,52.11).
city('Opoczno','pl','Lodzkie',22592.0,20.28,51.38).
city('Ozorkow','pl','Lodzkie',20608.0,19.29,51.97).
city('Pabianice','pl','Lodzkie',70542.0,19.35,51.67).
city('Piotrkow Trybunalski','pl','Lodzkie',80128.0,19.7,51.41).
city('Radomsko','pl','Lodzkie',49175.0,19.44,51.07).
city('Rawa Mazowiecka','pl','Lodzkie',17770.0,20.26,51.77).
city('Sieradz','pl','Lodzkie',44436.0,18.74,51.6).
city('Skierniewice','pl','Lodzkie',49042.0,20.14,51.96).
city('Tomaszow Mazowiecki','pl','Lodzkie',67197.0,20.03,51.54).
city('Wielun','pl','Lodzkie',24384.0,18.57,51.22).
city('Zdunska Wola','pl','Lodzkie',44515.0,18.94,51.61).
city('Zgierz','pl','Lodzkie',58036.0,19.41,51.87).
city('Zychlin','pl','Lodzkie',8844.0,19.62,52.25).
city('Biala Podlaska','pl','Lubelskie',57541.0,23.11,52.04).
city('Bilgoraj','pl','Lubelskie',26987.0,22.73,50.54).
city('Deblin','pl','Lubelskie',19561.0,21.83,51.57).
city('Hrubieszow','pl','Lubelskie',18605.0,23.89,50.81).
city('Janow Lubelski','pl','Lubelskie',11811.0,22.41,50.71).
city('Kholm','pl','Lubelskie',68043.0,23.49,51.14).
city('Krasnik','pl','Lubelskie',35834.0,22.22,50.93).
city('Krasnystaw','pl','Lubelskie',19532.0,23.18,50.99).
city('Leczna','pl','Lubelskie',21719.0,22.87,51.31).
city('Lubartow','pl','Lubelskie',22839.0,22.61,51.46).
city('Lublin','pl','Lubelskie',360044.0,22.57,51.24).
city('Lukow','pl','Lubelskie',30551.0,22.39,51.94).
city('Miedzyrzec Podlaski','pl','Lubelskie',17158.0,22.78,51.99).
city('Opole Lubelskie','pl','Lubelskie',8780.0,21.97,51.15).
city('Parczew','pl','Lubelskie',10249.0,22.9,51.64).
city('Poniatowa','pl','Lubelskie',10056.0,22.12,51.18).
city('Pulawy','pl','Lubelskie',49759.0,21.98,51.43).
city('Radzyn Podlaski','pl','Lubelskie',16071.0,22.62,51.79).
city('Ryki','pl','Lubelskie',9619.0,21.93,51.64).
city('Swidnik','pl','Lubelskie',40061.0,22.79,51.22).
city('Tomaszow Lubelski','pl','Lubelskie',20006.0,23.42,50.46).
city('Wlodawa','pl','Lubelskie',13142.0,23.56,51.55).
city('Zamosc','pl','Lubelskie',66034.0,23.26,50.73).
city('Drezdenko','pl','Lubuskie',10541.0,15.83,52.83).
city('Gorzow Wielkopolski','pl','Lubuskie',124430.0,15.23,52.74).
city('Gubin','pl','Lubuskie',16629.0,14.72,51.96).
city('Kostrzyn','pl','Lubuskie',18099.0,14.65,52.59).
city('Kozuchow','pl','Lubuskie',9679.0,15.6,51.75).
city('Krosno Odrzanskie','pl','Lubuskie',12178.0,15.1,52.06).
city('Lubsko','pl','Lubuskie',14994.0,14.96,51.79).
city('Miedzyrzecz','pl','Lubuskie',18669.0,15.57,52.45).
city('Nowa Sol','pl','Lubuskie',40354.0,15.71,51.81).
city('Skwierzyna','pl','Lubuskie',10051.0,15.49,52.59).
city('Slubice','pl','Lubuskie',17567.0,14.57,52.36).
city('Strzelce Krajenskie','pl','Lubuskie',9978.0,15.53,52.87).
city('Sulechow','pl','Lubuskie',18055.0,15.62,52.09).
city('Sulecin','pl','Lubuskie',10090.0,15.11,52.45).
city('Swiebodzin','pl','Lubuskie',21779.0,15.53,52.26).
city('Szprotawa','pl','Lubuskie',12786.0,15.52,51.57).
city('Wschowa','pl','Lubuskie',14458.0,16.32,51.8).
city('Zagan','pl','Lubuskie',26251.0,15.3,51.62).
city('Zary','pl','Lubuskie',38779.0,15.13,51.65).
city('Zielona Gora','pl','Lubuskie',118433.0,15.49,51.94).
city('Andrychow','pl','Malopolskie',21954.0,19.34,49.86).
city('Bochnia','pl','Malopolskie',29184.0,20.43,49.98).
city('Brzesko','pl','Malopolskie',16866.0,20.6,49.97).
city('Brzeszcze','pl','Malopolskie',11787.0,19.15,49.99).
city('Bukowno','pl','Malopolskie',10874.0,19.44,50.29).
city('Chelmek','pl','Malopolskie',9059.0,19.25,50.11).
city('Chrzanow','pl','Malopolskie',39973.0,19.4,50.14).
city('Cracow','pl','Malopolskie',755050.0,19.96,50.06).
city('Dabrowa Tarnowska','pl','Malopolskie',11291.0,21.0,50.18).
city('Gorlice','pl','Malopolskie',28609.0,21.16,49.67).
city('Kety','pl','Malopolskie',19249.0,19.22,49.87).
city('Krynica-Zdroj','pl','Malopolskie',12270.0,20.96,49.42).
city('Krzeszowice','pl','Malopolskie',9978.0,19.63,50.13).
city('Libiaz','pl','Malopolskie',17834.0,19.29,50.1).
city('Limanowa','pl','Malopolskie',14714.0,20.42,49.71).
city('Miechow','pl','Malopolskie',11735.0,20.02,50.36).
city('Myslenice','pl','Malopolskie',17686.0,19.94,49.84).
city('Nowy Sacz','pl','Malopolskie',84376.0,20.7,49.63).
city('Nowy Targ','pl','Malopolskie',33763.0,20.03,49.49).
city('Olkusz','pl','Malopolskie',37744.0,19.55,50.28).
city('Oswiecim','pl','Malopolskie',41143.0,19.26,50.04).
city('Rabka-Zdroj','pl','Malopolskie',13076.0,19.94,49.62).
city('Skawina','pl','Malopolskie',23647.0,19.83,49.98).
city('Stary Sacz','pl','Malopolskie',8959.0,20.64,49.57).
city('Sucha Beskidzka','pl','Malopolskie',9801.0,19.59,49.75).
city('Tarnow','pl','Malopolskie',117799.0,20.99,50.01).
city('Trzebinia','pl','Malopolskie',18828.0,19.45,50.16).
city('Wadowice','pl','Malopolskie',19238.0,19.49,49.88).
city('Wieliczka','pl','Malopolskie',18677.0,20.09,49.99).
city('Wolbrom','pl','Malopolskie',9146.0,19.77,50.39).
city('Zakopane','pl','Malopolskie',27581.0,19.96,49.29).
city('Blonie','pl','Mazowieckie',12195.0,20.62,52.2).
city('Brwinow','pl','Mazowieckie',11669.0,20.8,52.18).
city('Ciechanow','pl','Mazowieckie',46438.0,20.62,52.88).
city('Garwolin','pl','Mazowieckie',15912.0,21.62,51.91).
city('Gora Kalwaria','pl','Mazowieckie',10777.0,21.21,51.99).
city('Gostynin','pl','Mazowieckie',19398.0,19.43,53.43).
city('Grodzisk Mazowiecki','pl','Mazowieckie',26684.0,20.62,52.11).
city('Grojec','pl','Mazowieckie',14880.0,20.86,51.88).
city('Jozefow','pl','Mazowieckie',17910.0,21.26,52.15).
city('Karczew','pl','Mazowieckie',10319.0,21.25,52.08).
city('Kobylka','pl','Mazowieckie',17659.0,21.2,52.34).
city('Konstancin-Jeziorna','pl','Mazowieckie',16548.0,21.11,52.1).
city('Kozienice','pl','Mazowieckie',18677.0,21.55,51.59).
city('Legionowo','pl','Mazowieckie',50786.0,20.92,52.41).
city('Lomianki','pl','Mazowieckie',15315.0,20.89,52.35).
city('Makow Mazowiecki','pl','Mazowieckie',9978.0,21.1,52.86).
city('Marki','pl','Mazowieckie',23177.0,21.11,52.33).
city('Milanowek','pl','Mazowieckie',15451.0,20.66,52.13).
city('Minsk Mazowiecki','pl','Mazowieckie',37027.0,21.56,52.18).
city('Mlawa','pl','Mazowieckie',29398.0,20.36,53.12).
city('Nowy Dwor Mazowiecki','pl','Mazowieckie',27633.0,20.71,52.43).
city('Ostroleka','pl','Mazowieckie',53740.0,21.57,53.09).
city('Ostrow Mazowiecka','pl','Mazowieckie',22653.0,21.9,52.8).
city('Otwock','pl','Mazowieckie',42776.0,21.28,52.11).
city('Piaseczno','pl','Mazowieckie',36279.0,21.02,52.07).
city('Piastow','pl','Mazowieckie',23250.0,20.92,52.21).
city('Pionki','pl','Mazowieckie',19966.0,21.46,51.49).
city('Plock','pl','Mazowieckie',127474.0,19.7,52.55).
city('Plonsk','pl','Mazowieckie',22217.0,20.38,52.63).
city('Pruszkow','pl','Mazowieckie',54851.0,20.82,52.22).
city('Przasnysz','pl','Mazowieckie',16718.0,20.88,53.01).
city('Pultusk','pl','Mazowieckie',19039.0,21.09,52.71).
city('Radom','pl','Mazowieckie',226794.0,21.16,51.4).
city('Siedlce','pl','Mazowieckie',76772.0,22.28,52.17).
city('Sierpc','pl','Mazowieckie',18866.0,19.65,52.86).
city('Sochaczew','pl','Mazowieckie',38267.0,20.23,52.23).
city('Sokolow Podlaski','pl','Mazowieckie',18241.0,22.24,52.41).
city('Sulejowek','pl','Mazowieckie',18630.0,21.27,52.25).
city('Szydlowiec','pl','Mazowieckie',12128.0,20.86,51.23).
city('Warka','pl','Mazowieckie',11048.0,21.19,51.8).
city('Warsaw','pl','Mazowieckie',1651676.0,21.02,52.26).
city('Wegrow','pl','Mazowieckie',12512.0,22.01,52.4).
city('Wolomin','pl','Mazowieckie',36592.0,21.23,52.34).
city('Wyszkow','pl','Mazowieckie',26628.0,21.45,52.6).
city('Zabki','pl','Mazowieckie',23473.0,21.11,52.29).
city('Zielonka','pl','Mazowieckie',17518.0,21.17,52.3).
city('Zyrardow','pl','Mazowieckie',41179.0,20.45,52.06).
city('Brzeg','pl','Opolskie',38259.0,17.47,50.85).
city('Glubczyce','pl','Opolskie',13697.0,17.83,50.19).
city('Glucholazy','pl','Opolskie',15120.0,17.37,50.32).
city('Grodkow','pl','Opolskie',8654.0,17.37,50.7).
city('Kedzierzyn-Kozle','pl','Opolskie',65636.0,18.21,50.34).
city('Kluczbork','pl','Opolskie',25978.0,18.21,50.98).
city('Krapkowice','pl','Opolskie',18275.0,17.96,50.48).
city('Namyslow','pl','Opolskie',16376.0,17.72,51.08).
city('Nysa','pl','Opolskie',47954.0,17.34,50.48).
city('Olesno','pl','Opolskie',10236.0,18.41,50.89).
city('Opole','pl','Opolskie',127676.0,17.94,50.68).
city('Ozimek','pl','Opolskie',9963.0,18.22,50.69).
city('Prudnik','pl','Opolskie',23343.0,17.58,50.32).
city('Strzelce Opolskie','pl','Opolskie',20241.0,18.3,50.52).
city('Zawadzkie','pl','Opolskie',8439.0,18.46,50.62).
city('Zdzieszowice','pl','Opolskie',13401.0,18.12,50.42).
city('Debica','pl','Podkarpackie',47366.0,21.42,50.06).
city('Jaroslaw','pl','Podkarpackie',40134.0,22.68,50.02).
city('Jaslo','pl','Podkarpackie',37851.0,21.47,49.74).
city('Krosno','pl','Podkarpackie',47784.0,21.76,49.7).
city('Lancut','pl','Podkarpackie',18266.0,22.23,50.07).
city('Lezajsk','pl','Podkarpackie',13958.0,22.42,50.26).
city('Lubaczow','pl','Podkarpackie',12595.0,23.12,50.16).
city('Mielec','pl','Podkarpackie',60993.0,21.43,50.29).
city('Nisko','pl','Podkarpackie',15573.0,22.14,50.53).
city('Nowa Deba','pl','Podkarpackie',11489.0,21.76,50.44).
city('Peremyshl','pl','Podkarpackie',67013.0,22.78,49.79).
city('Przeworsk','pl','Podkarpackie',15805.0,22.5,50.07).
city('Ropczyce','pl','Podkarpackie',15254.0,21.75,50.07).
city('Rzeszow','pl','Podkarpackie',158382.0,22.0,50.05).
city('Sanok','pl','Podkarpackie',39684.0,22.21,49.57).
city('Stalowa Wola','pl','Podkarpackie',66495.0,22.05,50.57).
city('Tarnobrzeg','pl','Podkarpackie',50459.0,21.68,50.59).
city('Ustrzyki Dolne','pl','Podkarpackie',9610.0,22.61,49.43).
city('Augustow','pl','Podlaskie',29752.0,23.0,53.84).
city('Bialystok','pl','Podlaskie',291855.0,23.16,53.14).
city('Bielsk Podlaski','pl','Podlaskie',26745.0,23.29,52.78).
city('Czarna Bialostocka','pl','Podlaskie',9753.0,22.58,53.59).
city('Grajewo','pl','Podlaskie',22803.0,22.44,53.65).
city('Hajnowka','pl','Podlaskie',22157.0,23.58,52.73).
city('Kolno','pl','Podlaskie',10659.0,21.93,53.42).
city('Lapy','pl','Podlaskie',16434.0,22.89,52.99).
city('Lomza','pl','Podlaskie',63723.0,22.07,53.18).
city('Monki','pl','Podlaskie',10577.0,22.78,53.4).
city('Siemiatycze','pl','Podlaskie',15421.0,22.87,52.42).
city('Sokolka','pl','Podlaskie',19080.0,23.5,53.4).
city('Suwalki','pl','Podlaskie',69222.0,22.94,54.11).
city('Wysokie Mazowieckie','pl','Podlaskie',9203.0,22.51,52.91).
city('Zambrow','pl','Podlaskie',22857.0,22.24,52.98).
city('Bytow','pl','Pomorskie',16724.0,17.47,54.18).
city('Chojnice','pl','Pomorskie',39407.0,17.57,53.7).
city('Czersk','pl','Pomorskie',9390.0,17.97,53.8).
city('Czluchow','pl','Pomorskie',14759.0,17.35,53.67).
city('Gdansk','pl','Pomorskie',461865.0,18.64,54.36).
city('Gdynia','pl','Pomorskie',253730.0,18.53,54.52).
city('Kartuzy','pl','Pom',15002.0,18.2,54.33).
city('Koscierzyna','pl','Pomorskie',23361.0,17.97,54.13).
city('Kwidzyn','pl','Pomorskie',37601.0,18.93,53.74).
city('Lebork','pl','Pomorskie',35161.0,17.75,54.55).
city('Malbork','pl','Pomorskie',38655.0,19.04,54.04).
city('Miastko','pl','Pomorskie',10954.0,16.97,54.0).
city('Nowy Dwor Gdanski','pl','Pomorskie',9822.0,19.12,54.22).
city('Pruszcz Gdanski','pl','Pomorskie',23618.0,17.57,50.33).
city('Puck','pl','Pomorskie',11415.0,18.4,54.71).
city('Reda','pl','Pomorskie',18116.0,18.34,54.62).
city('Rumia','pl','Pomorskie',44791.0,18.37,54.59).
city('Slupsk','pl','Pomorskie',98608.0,17.02,54.47).
city('Sopot','pl','Pomorskie',40142.0,18.56,54.44).
city('Starogard Gdanski','pl','Pomorskie',48202.0,18.52,53.97).
city('Sztum','pl','Pomorskie',10081.0,18.96,53.85).
city('Tczew','pl','Pomorskie',60133.0,18.78,54.1).
city('Ustka','pl','Pomorskie',16250.0,16.85,54.58).
city('Wejherowo','pl','Pomorskie',44083.0,18.23,54.6).
city('Wladyslawowo','pl','Pomorskie',14889.0,18.4,54.79).
city('Bedz','pl','Slaskie',58236.0,19.13,50.34).
city('Bielsko-Biala','pl','Slaskie',176515.0,19.05,49.82).
city('Bierun','pl','Slaskie',19659.0,19.1,50.1).
city('Blachowania','pl','Slaskie',9905.0,18.96,50.79).
city('Bytom','pl','Slaskie',189186.0,18.91,50.35).
city('Chorzow','pl','Slaskie',113430.0,19.03,50.3).
city('Cieszyn','pl','Slaskie',35586.0,18.63,49.75).
city('Czechowice-Dziedzice','pl','Slaskie',34703.0,19.02,49.91).
city('Czeladz','pl','Slaskie',34308.0,19.13,50.32).
city('Czerwionka-Leszczyny','pl','Slaskie',28740.0,18.68,50.17).
city('Czestochowa','pl','Slaskie',248125.0,19.13,50.81).
city('Dabrowa Gornicza','pl','Slaskie',130601.0,19.18,50.33).
city('Gliwice','pl','Slaskie',198835.0,18.67,50.31).
city('Jastrzebie-Zdroj','pl','Slaskie',95813.0,18.59,49.99).
city('Jaworzno','pl','Slaskie',96541.0,19.27,50.21).
city('Kalety','pl','Slaskie',8670.0,18.9,50.57).
city('Katowice','pl','Slaskie',317316.0,19.02,50.26).
city('Klobuck','pl','Slaskie',13190.0,18.94,50.91).
city('Knurow','pl','Slaskie',39744.0,18.67,50.22).
city('Laziska Gorne','pl','Slaskie',21972.0,18.78,50.17).
city('Ledziny','pl','Slaskie',15928.0,19.06,50.13).
city('Lubliniec','pl','Slaskie',24133.0,18.69,50.67).
city('Mikolow','pl','Slaskie',38650.0,18.97,50.23).
city('Myslowice','pl','Slaskie',75281.0,19.14,50.24).
city('Myszkow','pl','Slaskie',33273.0,19.32,50.58).
city('Orzesze','pl','Slaskie',18438.0,18.78,50.16).
city('Piekary Slaskie','pl','Slaskie',59757.0,18.96,50.4).
city('Poreba','pl','Slaskie',8718.0,19.34,50.49).
city('Pszczyna','pl','Slaskie',25288.0,18.95,49.98).
city('Pszow','pl','Slaskie',14028.0,18.4,50.04).
city('Pyskowice','pl','Slaskie',19018.0,18.62,50.41).
city('Raciborz','pl','Slaskie',58464.0,18.22,50.09).
city('Radlin','pl','Slaskie',17479.0,18.46,50.04).
city('Radzionkow','pl','Slaskie',17167.0,18.89,50.39).
city('Ruda Slaska','pl','Slaskie',146189.0,18.88,50.3).
city('Rybnik','pl','Slaskie',142510.0,18.55,50.1).
city('Rydultowy','pl','Slaskie',21887.0,18.43,50.07).
city('Siemianowice Slaskie','pl','Slaskie',73121.0,19.05,50.33).
city('Skoczow','pl','Slaskie',14810.0,18.8,49.8).
city('Sosnowiec','pl','Slaskie',227295.0,19.12,50.28).
city('Swietochlowice','pl','Slaskie',55600.0,18.94,50.29).
city('Tarnowskie Gory','pl','Slaskie',60938.0,18.86,50.46).
city('Tychy','pl','Slaskie',131696.0,19.0,50.16).
city('Ustron','pl','Slaskie',15637.0,18.8,49.72).
city('Wisla','pl','Slaskie',11379.0,18.87,49.66).
city('Wodzislaw Slaski','pl','Slaskie',49521.0,18.47,50.0).
city('Wojkowice','pl','Slaskie',9602.0,19.01,50.36).
city('Zabrze','pl','Slaskie',192177.0,18.78,50.3).
city('Zawiercie','pl','Slaskie',53159.0,19.42,50.49).
city('Zory','pl','Slaskie',63174.0,18.69,50.07).
city('Zywiec','pl','Slaskie',31939.0,19.18,49.87).
city('Busko-Zdroj','pl','Swietokrzyskie',17095.0,20.72,50.48).
city('Jedrzejow','pl','Swietokrzyskie',16792.0,20.3,50.65).
city('Kielce','pl','Swietokrzyskie',208598.0,20.65,50.89).
city('Konskie','pl','Swietokrzyskie',20756.0,20.4,51.2).
city('Ostrowiec Swietokrzyski','pl','Swietokrzyskie',73989.0,21.39,50.95).
city('Pinczow','pl','Swietokrzyskie',11806.0,20.53,50.54).
city('Polaniec','pl','Swietokrzyskie',8158.0,21.28,50.43).
city('Sandomierz','pl','Swietokrzyskie',25087.0,21.74,50.69).
city('Skarzysko-Kamienna','pl','Swietokrzyskie',49410.0,20.88,51.12).
city('Starachowice','pl','Swietokrzyskie',53738.0,21.07,51.06).
city('Staszow','pl','Swietokrzyskie',15553.0,21.18,50.56).
city('Suchedniow','pl','Swietokrzyskie',9184.0,20.83,51.07).
city('Wloszczowa','pl','Swietokrzyskie',10661.0,19.97,50.86).
city('Bartoszyce','pl','Warminsko-Mazurskie',25660.0,20.81,54.25).
city('Biskupiec','pl','Warminsko-Mazurskie',10340.0,20.95,53.87).
city('Braniewo','pl','Warminsko-Mazurskie',18356.0,19.82,54.39).
city('Dobre Miasto','pl','Warminsko-Mazurskie',10514.0,20.39,53.99).
city('Dzialdowo','pl','Warminsko-Mazurskie',21127.0,20.18,53.23).
city('Elblag','pl','Warminsko-Mazurskie',127558.0,19.4,54.18).
city('Elk','pl','Warminsko-Mazurskie',55769.0,22.36,53.83).
city('Gizycko','pl','Warminsko-Mazurskie',29972.0,21.76,54.04).
city('Goldap','pl','Warminsko-Mazurskie',13769.0,22.31,54.31).
city('Ilawa','pl','Warminsko-Mazurskie',32557.0,19.56,53.59).
city('Ketrzyn','pl','Warminsko-Mazurskie',28172.0,21.37,54.08).
city('Lidzbark Warminski','pl','Warminsko-Mazurskie',16540.0,20.59,54.14).
city('Lubawa','pl','Warminsko-Mazurskie',9302.0,19.75,53.5).
city('Morag','pl','Warminsko-Mazurskie',14745.0,19.93,53.92).
city('Mragowo','pl','Warminsko-Mazurskie',21965.0,21.3,53.88).
city('Nidzica','pl','Warminsko-Mazurskie',14720.0,20.43,53.37).
city('Nowe Miasto Lubawskie','pl','Warminsko-Mazurskie',10997.0,19.59,53.43).
city('Olecko','pl','Warminsko-Mazurskie',15923.0,22.51,54.04).
city('Olsztyn','pl','Warminsko-Mazurskie',171803.0,20.49,53.78).
city('Orneta','pl','Warminsko-Mazurskie',9412.0,20.13,54.12).
city('Ostroda','pl','Warminsko-Mazurskie',33524.0,19.96,53.71).
city('Paslek','pl','Warminsko-Mazurskie',12267.0,19.66,54.07).
city('Pisz','pl','Warminsko-Mazurskie',19232.0,21.8,53.63).
city('Szczytno','pl','Warminsko-Mazurskie',26044.0,20.99,53.56).
city('Wegorzewo','pl','Warminsko-Mazurskie',11864.0,21.75,54.22).
city('Chodziez','pl','Wielkopolskie',19776.0,16.91,52.99).
city('Czarnkow','pl','Wielkopolskie',11562.0,16.55,52.91).
city('Gniezno','pl','Wielkopolskie',70269.0,17.61,52.53).
city('Gostyn','pl','Wielkopolskie',20771.0,17.0,51.88).
city('Grodzisk Wielkopolski','pl','Wielkopolskie',13826.0,16.36,52.23).
city('Jarocin','pl','Wielkopolskie',25665.0,17.5,51.98).
city('Kalisz','pl','Wielkopolskie',108759.0,18.1,51.77).
city('Kepno','pl','Wielkopolskie',14813.0,18.0,51.28).
city('Kolo','pl','Wielkopolskie',23493.0,18.64,52.2).
city('Konin','pl','Wielkopolskie',81258.0,18.25,52.21).
city('Koscian','pl','Wielkopolskie',24096.0,16.64,52.09).
city('Krotoszyn','pl','Wielkopolskie',29231.0,17.43,51.7).
city('Leszno','pl','Wi',63565.0,16.57,51.85).
city('Lubon','pl','Wielkopolskie',26431.0,16.87,52.34).
city('Miedzychod','pl','Wielkopolskie',10994.0,15.9,52.61).
city('Mosina','pl','Wielkopolskie',12097.0,16.84,52.26).
city('Murowana Goslina','pl','Wielkopolskie',9989.0,17.01,52.58).
city('Nowy Tomysl','pl','Wielkopolskie',15179.0,16.12,52.31).
city('Oborniki','pl','Wielkopolskie',17915.0,16.81,52.65).
city('Opalenica','pl','Wielkopolskie',8991.0,16.4,52.31).
city('Ostrow Wielkopolski','pl','Wielkopolskie',72898.0,17.8,51.66).
city('Ostrzeszow','pl','Wielkopolskie',14447.0,17.95,51.42).
city('Pila','pl','Wielkopolskie',75532.0,16.74,53.15).
city('Pleszew','pl','Wielkopolskie',17640.0,17.78,51.91).
city('Poznan','pl','Wielkopolskie',570352.0,16.9,52.4).
city('Rawicz','pl','Wielkopolskie',21380.0,16.86,51.61).
city('Rogozno','pl','Wielkopolskie',10859.0,16.98,52.75).
city('Slupca','pl','Wielkopolskie',14476.0,17.88,52.29).
city('Srem','pl','Wielkopolskie',30404.0,17.01,52.09).
city('Sroda Wielkopolska','pl','Wielkopolskie',21757.0,17.27,52.22).
city('Swarzedz','pl','Wielkopolskie',29010.0,17.07,52.41).
city('Szamotuly','pl','Wielkopolskie',18588.0,16.58,52.61).
city('Trzcianka','pl','Wielkopolskie',16914.0,16.46,53.04).
city('Turek','pl','Wielkopolskie',29533.0,18.48,52.02).
city('Wagrowiec','pl','Wielkopolskie',24428.0,17.2,52.81).
city('Wolsztyn','pl','Wielkopolskie',13689.0,16.11,52.11).
city('Wronki','pl','Wielkopolskie',11611.0,16.36,52.7).
city('Wrzesnia','pl','Wielkopolskie',28703.0,17.58,52.32).
city('Zlotow','pl','Wielkopolskie',18395.0,17.03,53.36).
city('Barlinek','pl','Zachodnio-Pomorskie',14385.0,15.2,53.0).
city('Bialogard','pl','Zachodnio-Pomorskie',24265.0,15.98,54.01).
city('Choszczno','pl','Zachodnio-Pomorskie',15733.0,15.4,53.18).
city('Darlowo','pl','Zachodnio-Pomorskie',14398.0,16.41,54.42).
city('Debno','pl','Zachodnio-Pomorskie',13804.0,14.7,52.74).
city('Drawsko Pomorskie','pl','Zachodnio-Pomorskie',11275.0,15.8,53.53).
city('Goleniow','pl','Zachodnio-Pomorskie',22505.0,14.82,53.57).
city('Gryfice','pl','Zachodnio-Pomorskie',16720.0,15.19,53.92).
city('Gryfino','pl','Zachodnio-Pomorskie',21270.0,14.48,53.23).
city('Kamien Pomorski','pl','Zachodnio-Pomorskie',9036.0,14.78,53.97).
city('Kolobrzeg','pl','Zachodnio-Pomorskie',44377.0,15.57,54.19).
city('Koszalin','pl','Zachodnio-Pomorskie',107450.0,16.18,54.19).
city('Lobez','pl','Zachodnio-Pomorskie',10609.0,15.62,53.64).
city('Mysliborz','pl','Zachodnio-Pomorskie',12092.0,14.87,52.93).
city('Nowogard','pl','Zachodnio-Pomorskie',16703.0,15.11,53.66).
city('Polczyn-Zdroj','pl','Zachodnio-Pomorskie',8682.0,16.1,53.77).
city('Police','pl','Zachodnio-Pomorskie',34350.0,14.56,53.55).
city('Pyrzyce','pl','Zachodnio-Pomorskie',12893.0,14.88,53.14).
city('Slawno','pl','Zachodnio-Pomorskie',13415.0,16.67,54.35).
city('Stargard Szczecinski','pl','Zachodnio-Pomorskie',71224.0,15.02,53.34).
city('Swidwin','pl','Zachodnio-Pomorskie',16076.0,15.78,53.77).
city('Swinoujscie','pl','Zachodnio-Pomorskie',40919.0,14.25,53.91).
city('Szczecin','pl','Zachodnio-Pomorskie',413658.0,14.53,53.43).
city('Szczecinek','pl','Zachodnio-Pomorskie',38496.0,16.69,53.71).
city('Trzebiatow','pl','Zachodnio-Pomorskie',10322.0,15.26,54.07).
city('Walcz','pl','Zachodnio-Pomorskie',25971.0,16.47,53.27).
city('Zlocieniec','pl','Zachodnio-Pomorskie',13337.0,16.0,53.53).
city('Angra','pt','Acores',12045.0,-27.22,38.66).
city('Arrifes','pt','Acores',6981.0,-25.69,37.77).
city('Faja de Baixo','pt','Acores',4915.0,-25.65,37.75).
city('Horta','pt','Acores',6572.0,-28.63,38.54).
city('Lagoa','pt','Acores',9239.0,-27.97,39.05).
city('Ponta Delgada','pt','Acores',20056.0,-25.67,37.75).
city('Praia da Vitoria','pt','Acores',6061.0,-27.06,38.73).
city('Rabo de Peixe','pt','Acores',7681.0,-25.57,37.8).
city('Ribeira Grande','pt','Acores',5198.0,-28.69,38.52).
city('Rosto do Cao','pt','Acores',7880.0,-25.64,37.75).
city('Vila Franca do Campo','pt','Acores',5035.0,-25.42,37.72).
city('Alcacer do Sal','pt','Alentejo',9198.0,-8.49,38.37).
city('Aljustrel','pt','Alentejo',5334.0,-8.16,37.87).
city('Beja','pt','Alentejo',23906.0,-7.86,38.02).
city('Borba','pt','Alentejo',4586.0,-7.44,38.8).
city('Caia e Sao Pedro','pt','Alentejo',3568.0,-7.09,38.97).
city('Campo Maior','pt','Alentejo',8235.0,-7.06,39.02).
city('Castro Verde','pt','Alentejo',4857.0,-8.07,37.7).
city('Cercal','pt','Alentejo',3772.0,-8.66,37.8).
city('Elvas','pt','Alentejo',9904.0,-7.15,38.88).
city('Estremoz','pt','Alentejo',9349.0,-7.57,38.85).
city('Evora','pt','Alentejo',45851.0,-7.91,38.57).
city('Ferreira do Alentejo','pt','Alentejo',4689.0,-8.02,38.05).
city('Grandola','pt','Alentejo',10737.0,-8.56,38.17).
city('Montemor-o-Novo','pt','Alentejo',12854.0,-8.21,38.65).
city('Moura','pt','Alentejo',9360.0,-7.44,38.13).
city('Odemira','pt','Alentejo',5830.0,-8.62,37.6).
city('Ponte de Sor','pt','Alentejo',11062.0,-8.01,39.25).
city('Portalegre','pt','Alentejo',15581.0,-7.43,39.29).
city('Redondo','pt','Alentejo',5845.0,-7.54,38.65).
city('Reguengos de Monsaraz','pt','Alentejo',7217.0,-7.52,38.42).
city('Santiago do Cacem','pt','Alentejo',7797.0,-8.69,38.02).
city('Santo Andre','pt','Alentejo',10601.0,-8.74,38.05).
city('Sao Teotonio','pt','Alentejo',4936.0,-8.69,37.5).
city('Serpa','pt','Alentejo',6586.0,-7.59,37.93).
city('Sines','pt','Alentejo',12791.0,-8.86,37.95).
city('Vendas Novas','pt','Alentejo',11248.0,-8.44,38.68).
city('Vila Nova de Milfontes','pt','Alentejo',4393.0,-8.77,37.72).
city('Vila Vicosa','pt','Alentejo',5484.0,-7.41,38.78).
city('Albufeira','pt','Algarve',15851.0,-8.26,37.09).
city('Aljezur','pt','Algarve',4122.0,-8.79,37.32).
city('Almancil','pt','Algarve',9898.0,-8.02,37.08).
city('Alvor','pt','Algarve',5272.0,-8.56,37.13).
city('Armacao de Pera','pt','Algarve',4030.0,-8.34,37.1).
city('Boliqueime','pt','Algarve',4470.0,-8.14,37.13).
city('Castro Marim','pt','Algarve',5089.0,-7.42,37.22).
city('Estombar','pt','Algarve',8590.0,-8.47,37.15).
city('Faro','pt','Algarve',41355.0,-7.94,37.03).
city('Ferreiras','pt','Algarve',5157.0,-8.22,37.13).
city('Guia','pt','Algarve',4173.0,-8.29,37.12).
city('Lagoa','pt','Algarve',6301.0,-8.44,37.13).
city('Lagos','pt','Algarve',18831.0,-8.68,37.1).
city('Loule','pt','Algarve',23109.0,-8.02,37.13).
city('Luz','pt','Algarve',3627.0,-7.69,37.08).
city('Moncarapacho','pt','Algarve',8545.0,-7.77,37.08).
city('Monchique','pt','Algarve',5421.0,-8.54,37.32).
city('Monte Gordo','pt','Algarve',4282.0,-7.44,37.18).
city('Montenegro','pt','Algarve',5609.0,-7.96,37.03).
city('Olhao','pt','Algarve',29238.0,-7.85,37.03).
city('Portimao','pt','Algarve',38486.0,-8.54,37.13).
city('Quarteira','pt','Algarve',18782.0,-8.09,37.07).
city('Santa Barbara de Nexe','pt','Algarve',4087.0,-7.96,37.1).
city('Sao Bartolomeu de Messines','pt','Algarve',8381.0,-8.27,37.25).
city('Sao Bras de Alportel','pt','Algarve',11153.0,-7.87,37.15).
city('Silves','pt','Algarve',10917.0,-8.42,37.18).
city('Tavira','pt','Algarve',13871.0,-7.64,37.12).
city('Vila Real de Santo Antonio','pt','Algarve',11560.0,-7.41,37.2).
city('Abraveses','pt','Centro',9319.0,-7.91,40.67).
city('Aguada de Cima','pt','Centro',4388.0,-8.42,40.52).
city('Agueda','pt','Centro',11940.0,-8.44,40.57).
city('Albergaria-A-Velha','pt','Centro',7974.0,-8.47,40.7).
city('Alcains','pt','Centro',5029.0,-7.44,39.92).
city('Alhadas','pt','Centro',3767.0,-8.77,40.18).
city('Amor','pt','Centro',4870.0,-8.86,39.8).
city('Aradas','pt','Centro',7294.0,-8.64,40.62).
city('Arazede','pt','Centro',5906.0,-8.64,40.28).
city('Arcos','pt','Centro',6725.0,-8.42,40.45).
city('Arganil','pt','Centro',4330.0,-8.04,40.22).
city('Avanca','pt','Centro',6539.0,-8.56,40.8).
city('Aveiro','pt','Centro',54161.0,-8.66,40.65).
city('Batalha','pt','Centro',7910.0,-8.82,39.65).
city('Beduido','pt','Centro',8201.0,-8.56,40.77).
city('Branca','pt','Centro',5632.0,-8.47,40.77).
city('Buarcos','pt','Centro',7865.0,-8.87,40.17).
city('Campo','pt','Centro',4551.0,-7.91,40.7).
city('Cantanhede','pt','Centro',7347.0,-8.59,40.35).
city('Caranguejeira','pt','Centro',5247.0,-8.71,39.73).
city('Castanheira de Pera','pt','Centro',3331.0,-8.21,40.0).
city('Castelo Branco','pt','Centro',33479.0,-7.49,39.82).
city('Castro Daire','pt','Centro',4744.0,-7.92,40.9).
city('Coimbra','pt','Centro',106580.0,-8.43,40.22).
city('Condeixa-A-Nova','pt','Centro',4613.0,-8.49,40.12).
city('Cortegaca','pt','Centro',4139.0,-8.61,40.93).
city('Covilha','pt','Centro',17610.0,-7.51,40.29).
city('Eixo','pt','Centro',5978.0,-8.56,40.62).
city('Esmoriz','pt','Centro',11393.0,-8.61,40.95).
city('Figueira da Foz','pt','Centro',12050.0,-8.87,40.15).
city('Fundao','pt','Centro',9725.0,-7.49,40.13).
city('Gafanha da Encarnacao','pt','Centro',4914.0,-8.72,40.62).
city('Gafanha da Nazare','pt','Centro',14840.0,-8.71,40.63).
city('Guarda','pt','Centro',28502.0,-7.26,40.56).
city('Ilhavo','pt','Centro',17236.0,-8.66,40.6).
city('Lavos','pt','Centro',4164.0,-8.81,40.1).
city('Leiria','pt','Centro',45111.0,-8.8,39.75).
city('Lorvao','pt','Centro',4158.0,-8.31,40.25).
city('Lourical','pt','Centro',5085.0,-8.72,40.0).
city('Lousa','pt','Centro',11444.0,-8.24,40.12).
city('Maceira','pt','Centro',9831.0,-8.87,39.68).
city('Mangualde','pt','Centro',8894.0,-7.76,40.6).
city('Marinha Grande','pt','Centro',28915.0,-8.93,39.75).
city('Mealhada','pt','Centro',4443.0,-8.44,40.37).
city('Mira','pt','Centro',7682.0,-8.72,40.43).
city('Mira de Aire','pt','Centro',3922.0,-8.71,39.53).
city('Miranda do Corvo','pt','Centro',7857.0,-8.32,40.1).
city('Monte Redondo','pt','Centro',4463.0,-8.82,39.9).
city('Nelas','pt','Centro',4190.0,-7.84,40.53).
city('Oia','pt','Centro',7118.0,-8.52,40.55).
city('Oliveira do Bairro','pt','Centro',6239.0,-8.49,40.52).
city('Oliveira do Hospital','pt','Centro',4704.0,-7.86,40.35).
city('Oliveirinha','pt','Centro',4971.0,-8.57,40.6).
city('Ovar','pt','Centro',18452.0,-8.62,40.87).
city('Pampilhosa','pt','Centro',4512.0,-8.41,40.33).
city('Pardilho','pt','Centro',4169.0,-8.61,40.8).
city('Poiares','pt','Centro',5514.0,-8.26,40.22).
city('Pombal','pt','Centro',17355.0,-8.62,39.92).
city('Porto de Mos','pt','Centro',6032.0,-8.81,39.6).
city('Proenca-A-Nova','pt','Centro',4590.0,-7.91,39.75).
city('Rio de Loba','pt','Centro',9529.0,-7.87,40.67).
city('Salreu','pt','Centro',4140.0,-8.54,40.73).
city('Sangalhos','pt','Centro',4516.0,-8.46,40.5).
city('Santa Catarina da Serra','pt','Centro',4405.0,-8.67,39.67).
city('Sao Joao','pt','Centro',6762.0,-8.59,40.87).
city('Sao Pedro do S','pt','Centro',4080.0,-8.06,40.75).
city('Satao','pt','Centro',4034.0,-7.72,40.73).
city('Seia','pt','Centro',7082.0,-7.69,40.42).
city('Serta','pt','Centro',5636.0,-8.09,39.8).
city('Soure','pt','Centro',8416.0,-8.62,40.05).
city('Souto da Carpalhosa','pt','Centro',4130.0,-8.81,39.85).
city('Tavarede','pt','Centro',8586.0,-8.84,40.17).
city('Teixoso','pt','Centro',4703.0,-7.46,40.32).
city('Tondela','pt','Centro',4393.0,-8.07,40.52).
city('Tortosendo','pt','Centro',5701.0,-7.51,40.23).
city('Vagos','pt','Centro',4529.0,-8.67,40.55).
city('Valega','pt','Centro',7005.0,-8.57,40.83).
city('Valongo do Vouga','pt','Centro',5084.0,-8.44,40.62).
city('Vieira de Leiria','pt','Centro',5807.0,-8.92,39.87).
city('Viseu','pt','Centro',26364.0,-7.92,40.67).
city('A dos Cunhados','pt','Lisboa e Vale do Tejo',6594.0,-9.29,39.15).
city('Abrantes','pt','Lisboa e Vale do Tejo',13646.0,-8.19,39.47).
city('Agualva-Cacem','pt','Lisboa e Vale do Tejo',93981.0,-9.3,38.77).
city('Alcabideche','pt','Lisboa e Vale do Tejo',33315.0,-9.41,38.73).
city('Alcanede','pt','Lisboa e Vale do Tejo',5020.0,-8.81,39.42).
city('Alcanena','pt','Lisboa e Vale do Tejo',4408.0,-8.66,39.45).
city('Alcobaca','pt','Lisboa e Vale do Tejo',5051.0,-8.97,39.55).
city('Alcochete','pt','Lisboa e Vale do Tejo',9705.0,-8.96,38.75).
city('Alcoentre','pt','Lisboa e Vale do Tejo',3923.0,-8.94,39.2).
city('Aldeia de Paio Pires','pt','Lisboa e Vale do Tejo',12179.0,-9.07,38.62).
city('Alenquer','pt','Lisboa e Vale do Tejo',9626.0,-8.99,39.05).
city('Alferrarede','pt','Lisboa e Vale do Tejo',3654.0,-8.16,39.48).
city('Alges','pt','Lisboa e Vale do Tejo',19326.0,-9.23,38.7).
city('Algueirao-Mem Martins','pt','Lisboa e Vale do Tejo',74776.0,-9.34,38.8).
city('Alhandra','pt','Lisboa e Vale do Tejo',7226.0,-8.99,38.92).
city('Alhos Vedros','pt','Lisboa e Vale do Tejo',13384.0,-9.02,38.65).
city('Aljubarrota','pt','Lisboa e Vale do Tejo',6146.0,-8.92,39.57).
city('Almada','pt','Lisboa e Vale do Tejo',34007.0,-9.16,38.68).
city('Almargem do Bispo','pt','Lisboa e Vale do Tejo',8271.0,-9.26,38.83).
city('Almeirim','pt','Lisboa e Vale do Tejo',11556.0,-8.62,39.2).
city('Alpiarca','pt','Lisboa e Vale do Tejo',7946.0,-8.57,39.25).
city('Alverca do Ribatejo','pt','Lisboa e Vale do Tejo',31144.0,-9.04,38.89).
city('Amadora','pt','Lisboa e Vale do Tejo',178856.0,-9.24,38.75).
city('Amora','pt','Lisboa e Vale do Tejo',52577.0,-9.11,38.62).
city('Apelacao','pt','Lisboa e Vale do Tejo',7181.0,-9.12,38.82).
city('Arrentela','pt','Lisboa e Vale do Tejo',30156.0,-9.09,38.62).
city('Arruda dos Vinhos','pt','Lisboa e Vale do Tejo',6170.0,-9.07,38.98).
city('Atouguia da Baleia','pt','Lisboa e Vale do Tejo',8313.0,-9.32,39.33).
city('Aveiras de Cima','pt','Lisboa e Vale do Tejo',4615.0,-8.89,39.13).
city('Azambuja','pt','Lisboa e Vale do Tejo',7179.0,-8.86,39.07).
city('Baixa da Banheira','pt','Lisboa e Vale do Tejo',23900.0,-9.05,38.66).
city('Barcarena','pt','Lisboa e Vale do Tejo',11968.0,-9.27,38.73).
city('Barreiro','pt','Lisboa e Vale do Tejo',51279.0,-9.08,38.66).
city('Belas','pt','Lisboa e Vale do Tejo',21018.0,-9.26,38.77).
city('Benavente','pt','Lisboa e Vale do Tejo',8932.0,-8.79,38.98).
city('Benedita','pt','Lisboa e Vale do Tejo',8556.0,-8.97,39.42).
city('Bobadela','pt','Lisboa e Vale do Tejo',8399.0,-9.09,38.82).
city('Bombarral','pt','Lisboa e Vale do Tejo',5852.0,-9.14,39.27).
city('Bucelas','pt','Lisboa e Vale do Tejo',4614.0,-9.11,38.9).
city('Cacilhas','pt','Lisboa e Vale do Tejo',6494.0,-9.14,38.68).
city('Caldas da Rainha','pt','Lisboa e Vale do Tejo',26647.0,-9.13,39.4).
city('Camarate','pt','Lisboa e Vale do Tejo',20176.0,-9.13,38.8).
city('Canecas','pt','Lisboa e Vale do Tejo',10977.0,-9.22,38.8).
city('Caparica','pt','Lisboa e Vale do Tejo',21167.0,-9.19,38.67).
city('Carcavelos','pt','Lisboa e Vale do Tejo',20366.0,-9.33,38.68).
city('Carnaxide','pt','Lisboa e Vale do Tejo',23697.0,-9.25,38.72).
city('Carregado','pt','Lisboa e Vale do Tejo',10473.0,-8.97,39.02).
city('Cartaxo','pt','Lisboa e Vale do Tejo',10502.0,-8.77,39.15).
city('Cascais','pt','Lisboa e Vale do Tejo',36436.0,-9.43,38.7).
city('Castanheira do Ribatejo','pt','Lisboa e Vale do Tejo',7651.0,-8.96,38.98).
city('Charneca de Caparica','pt','Lisboa e Vale do Tejo',23712.0,-9.17,38.62).
city('Colares','pt','Lisboa e Vale do Tejo',7905.0,-9.44,38.8).
city('Corroios','pt','Lisboa e Vale do Tejo',52517.0,-9.15,38.63).
city('Coruche','pt','Lisboa e Vale do Tejo',8775.0,-8.51,38.95).
city('Costa da Caparica','pt','Lisboa e Vale do Tejo',14231.0,-9.22,38.63).
city('Cova da Piedade','pt','Lisboa e Vale do Tejo',19472.0,-9.15,38.67).
city('Cruz Quebrada-Dafundo','pt','Lisboa e Vale d',6637.0,-9.24,38.7).
city('Entroncamento','pt','Lisboa e Vale do Tejo',19887.0,-8.48,39.45).
city('Ericeira','pt','Lisboa e Vale do Tejo',7538.0,-9.41,38.98).
city('Estoril','pt','Lisboa e Vale do Tejo',23375.0,-9.4,38.71).
city('Evora de Alcobaca','pt','Lisboa e Vale do Tejo',4708.0,-8.96,39.52).
city('Famoes','pt','Lisboa e Vale do Tejo',9435.0,-9.2,38.78).
city('Fatima','pt','Lisboa e Vale do Tejo',11798.0,-8.64,39.62).
city('Fazendas de Almeirim','pt','Lisboa e Vale do Tejo',6634.0,-8.57,39.18).
city('Fernao Ferro','pt','Lisboa e Vale do Tejo',10721.0,-9.12,38.58).
city('Foros de Salvaterra','pt','Lisboa e Vale do Tejo',4114.0,-8.76,39.0).
city('Forte da Casa','pt','Lisboa e Vale do Tejo',10840.0,-8.99,38.93).
city('Golega','pt','Lisboa e Vale do Tejo',3830.0,-8.47,39.4).
city('Laranjeiro','pt','Lisboa e Vale do Tejo',20472.0,-7.8,37.07).
city('Linda-a-Velha','pt','Lisboa e Vale do Tejo',20895.0,-9.25,38.71).
city('Lisbon','pt','Lisboa e Vale do Tejo',517798.0,-9.14,38.72).
city('Loures','pt','Lisboa e Vale do Tejo',66230.0,-9.16,38.83).
city('Lourinha','pt','Lisboa e Vale do Tejo',9196.0,-9.31,39.23).
city('Mafra','pt','Lisboa e Vale do Tejo',12259.0,-9.32,38.93).
city('Malveira','pt','Lisboa e Vale do Tejo',4747.0,-9.24,38.93).
city('Marinhais','pt','Lisboa e Vale do Tejo',5788.0,-8.69,39.05).
city('Milharado','pt','Lisboa e Vale do Tejo',5935.0,-9.19,38.95).
city('Moita','pt','Lisboa e Vale do Tejo',17795.0,-8.97,38.65).
city('Montijo','pt','Lisboa e Vale do Tejo',30010.0,-8.96,38.7).
city('Moscavide','pt','Lisboa e Vale do Tejo',11488.0,-9.1,38.77).
city('Nazare','pt','Lisboa e Vale do Tejo',8993.0,-9.06,39.6).
city('Odivelas','pt','Lisboa e Vale do Tejo',54623.0,-9.19,38.78).
city('Oeiras e Sao Juliao da Barra','pt','Lisboa e Vale do Tejo',34758.0,-9.32,38.68).
city('Olival Basto','pt','Lisboa e Vale do Tejo',5959.0,-9.16,38.78).
city('Ourem','pt','Lisboa e Vale do Tejo',12729.0,-8.57,39.63).
city('Paco de Arcos','pt','Lisboa e Vale do Tejo',25974.0,-9.29,38.7).
city('Palmela','pt','Lisboa e Vale do Tejo',16934.0,-8.89,38.57).
city('Parede','pt','Lisboa e Vale do Tejo',17212.0,-9.35,38.69).
city('Pataias','pt','Lisboa e Vale do Tejo',5510.0,-8.99,39.67).
city('Peniche','pt','Lisboa e Vale do Tejo',15661.0,-9.37,39.36).
city('Pero Pinheiro','pt','Lisboa e Vale do Tejo',4792.0,-9.32,38.85).
city('Pinhal Novo','pt','Lisboa e Vale do Tejo',23508.0,-8.91,38.63).
city('Poceirao','pt','Lisboa e Vale do Tejo',4225.0,-8.77,38.83).
city('Pontevel','pt','Lisboa e Vale do Tejo',4435.0,-8.82,39.15).
city('Pontinha','pt','Lisboa e Vale do Tejo',23249.0,-9.19,38.77).
city('Porto Salvo','pt','Lisboa e Vale do Tejo',13867.0,-9.29,38.72).
city('Povoa de Santa Iria','pt','Lisboa e Vale do Tejo',28900.0,-9.06,38.85).
city('Povoa de Santo Adriao','pt','Lisboa e Vale do Tejo',14897.0,-9.17,38.8).
city('Pragal','pt','Lisboa e Vale do Tejo',7701.0,-9.16,38.67).
city('Queijas','pt','Lisboa e Vale do Tejo',8828.0,-9.26,38.72).
city('Queluz','pt','Lisboa e Vale do Tejo',103398.0,-9.25,38.75).
city('Quinta do Anjo','pt','Lisboa e Vale do Tejo',9124.0,-8.92,38.57).
city('Ramada','pt','Lisboa e Vale do Tejo',17535.0,-9.18,38.8).
city('Riachos','pt','Lisboa e Vale do Tejo',5463.0,-8.51,39.43).
city('Rio Maior','pt','Lisboa e Vale do Tejo',12064.0,-8.92,39.33).
city('Rio de Mouro','pt','Lisboa e Vale do Tejo',54695.0,-9.32,38.77).
city('Sacavem','pt','Lisboa e Vale do Tejo',17718.0,-9.1,38.78).
city('Salvaterra de Magos','pt','Lisboa e Vale do Tejo',5165.0,-8.79,39.02).
city('Samora Correia','pt','Lisboa e Vale do Tejo',14154.0,-8.86,38.93).
city('Santa Iria de Azoia','pt','Lisboa e Vale do Tejo',18573.0,-9.07,38.85).
city('Santarem','pt','Lisboa e Vale do Tejo',29385.0,-8.69,39.24).
city('Santo Andre','pt','Lisboa e Vale do Tejo',11213.0,-8.25,39.05).
city('Santo Antao do Tojal','pt','Lisboa e Vale do Tejo',4156.0,-9.12,38.85).
city('Santo Antonio da Charneca','pt','Lisboa e Vale do Tejo',11143.0,-9.02,38.62).
city('Sao Domingos de Rana','pt','Lisboa e Vale do Tejo',46717.0,-9.32,38.7).
city('Sao Joao Das Lampas','pt','Lisboa e Vale do Tejo',10484.0,-9.39,38.87).
city('Sao Joao da Talha','pt','Lisboa e Vale do Tejo',18924.0,-9.07,38.82).
city('Sao Joao dos Montes','pt','Lisboa e Vale do Tejo',4772.0,-9.0,38.93).
city('Sao Miguel do Rio Torto','pt','Lisboa e Vale do Tejo',3147.0,-8.21,39.43).
city('Sao Pedro da Cadeira','pt','Lisboa e Vale do Tejo',4452.0,-9.36,39.07).
city('Sesimbra','pt','Lisboa e Vale do Tejo',41133.0,-9.09,38.43).
city('Setubal','pt','Lisboa e Vale do Tejo',117109.0,-8.89,38.53).
city('Silveira','pt','Lisboa e Vale do Tejo',6942.0,-9.36,39.12).
city('Sintra','pt','Lisboa e Vale do Tejo',26193.0,-9.37,38.8).
city('Sobralinho','pt','Lisboa e Vale do Tejo',4453.0,-9.01,38.92).
city('Sobreda','pt','Lisboa e Vale do Tejo',11145.0,-9.17,38.65).
city('Terrugem','pt','Lisboa e Vale do Tejo',4693.0,-9.27,38.7).
city('Tomar','pt','Lisboa e Vale do Tejo',19168.0,-8.41,39.6).
city('Torres Novas','pt','Lisboa e Vale do Tejo',14526.0,-8.52,39.48).
city('Torres Vedras','pt','Lisboa e Vale do Tejo',24443.0,-9.26,39.1).
city('Trafaria','pt','Lisboa e Vale do Tejo',5603.0,-9.22,38.67).
city('Tramagal','pt','Lisboa e Vale do Tejo',3821.0,-8.24,39.45).
city('Turquel','pt','Lisboa e Vale do Tejo',4434.0,-8.97,39.47).
city('Unhos','pt','Lisboa e Vale do Tejo',10711.0,-9.11,38.82).
city('Vale da Amoreira','pt','Lisboa e Vale do Tejo',10828.0,-7.69,39.07).
city('Venda do Pinheiro','pt','Lisboa e Vale do Tejo',4950.0,-9.22,38.92).
city('Ventosa','pt','Lisboa e Vale do Tejo',5215.0,-9.07,39.13).
city('Vialonga','pt','Lisboa e Vale do Tejo',16087.0,-9.07,38.87).
city('Vila Franca de Xira','pt','Lisboa e Vale do Tejo',18354.0,-8.99,38.96).
city('Camacha','pt','Madeira',8635.0,-16.32,33.08).
city('Camara de Lobos','pt','Madeira',32209.0,-16.96,32.63).
city('Campanario','pt','Madeira',3987.0,-17.02,32.65).
city('Canico','pt','Madeira',11996.0,-16.84,32.63).
city('Funchal','pt','Madeira',98041.0,-16.9,32.65).
city('Machico','pt','Madeira',12567.0,-16.76,32.7).
city('Ponta do Sol','pt','Madeira',4236.0,-17.09,32.67).
city('Porto Santo','pt','Madeira',4348.0,-16.32,33.05).
city('Ribeira Brava','pt','Madeira',5933.0,-17.06,32.65).
city('Santa Cruz','pt','Madeira',6010.0,-16.79,32.68).
city('A Ver-o-Mar','pt','Norte',10500.0,-8.76,41.4).
city('Adaufe','pt','Norte',3850.0,-8.39,41.58).
city('Aguas Santas','pt','Norte',27686.0,-8.58,41.21).
city('Agucadoura','pt','Norte',4520.0,-8.77,41.43).
city('Alfena','pt','Norte',14455.0,-8.52,41.23).
city('Alpendurada e Matos','pt','Norte',5103.0,-8.22,41.08).
city('Amarante','pt','Norte',6782.0,-8.07,41.27).
city('Anta','pt','Norte',10951.0,-8.62,41.27).
city('Antas','pt','Norte',5569.0,-8.29,41.73).
city('Apulia','pt','Norte',4394.0,-8.76,41.48).
city('Arcozelo','pt','Norte',13495.0,-8.63,41.07).
city('Areosa','pt','Norte',4626.0,-8.84,41.72).
city('Argoncilhe','pt','Norte',8743.0,-8.52,41.02).
city('Aroes','pt','Norte',4855.0,-8.21,41.45).
city('Arrifana','pt','No',6927.0,-8.49,40.92).
city('Arvore','pt','Norte',4553.0,-8.71,41.33).
city('Aves','pt','Norte',8506.0,-8.39,41.37).
city('Avintes','pt','Norte',11577.0,-8.54,41.12).
city('Baguim do Monte','pt','Norte',15850.0,-8.52,41.18).
city('Baltar','pt','Norte',4929.0,-8.37,41.18).
city('Barcelos','pt','Norte',19084.0,-8.62,41.53).
city('Barrosas','pt','Norte',5573.0,-8.27,41.34).
city('Bougado','pt','Norte',21680.0,-8.54,41.33).
city('Braga','pt','Norte',121393.0,-8.43,41.55).
city('Braganca','pt','Norte',21468.0,-6.76,41.81).
city('Brito','pt','Norte',5051.0,-8.36,41.45).
city('Caldas de Vizela','pt','Norte',10239.0,-8.31,41.38).
city('Caldelas','pt','Norte',5724.0,-8.37,41.67).
city('Calendario','pt','Norte',11357.0,-8.52,41.4).
city('Campo','pt','Norte',8916.0,-8.46,41.18).
city('Candoso','pt','Norte',3893.0,-8.32,41.42).
city('Canedo','pt','Norte',6159.0,-8.61,40.75).
city('Canelas','pt','Norte',14247.0,-8.59,41.08).
city('Canidelo','pt','Norte',26430.0,-8.64,41.12).
city('Carvalhosa','pt','Norte',4502.0,-8.36,41.3).
city('Casteloes de Cepeda','pt','Norte',8322.0,-8.32,41.2).
city('Chaves','pt','Norte',13066.0,-7.47,41.74).
city('Coronado','pt','Norte',8697.0,-8.56,41.28).
city('Couto','pt','Norte',5415.0,-8.46,41.33).
city('Custoias','pt','Norte',19406.0,-7.31,41.1).
city('Darque','pt','Norte',8092.0,-8.76,41.68).
city('Ermesinde','pt','Norte',39420.0,-8.54,41.22).
city('Espinho','pt','Norte',9566.0,-8.64,41.01).
city('Fafe','pt','Norte',16868.0,-8.16,41.45).
city('Fanzeres','pt','Norte',23916.0,-8.52,41.17).
city('Feira','pt','Norte',16376.0,-8.54,40.92).
city('Ferreira','pt','Norte',4205.0,-8.34,41.27).
city('Ferreiros','pt','Norte',7870.0,-8.55,41.35).
city('Fiaes','pt','Norte',8708.0,-8.51,40.98).
city('Figueiro','pt','Norte',4579.0,-8.16,41.3).
city('Foz do Sousa','pt','Norte',6315.0,-8.49,41.1).
city('Frazao','pt','Norte',4314.0,-8.4,41.27).
city('Freamunde','pt','Norte',7982.0,-8.34,41.28).
city('Galegos','pt','Norte',5403.0,-8.56,41.57).
city('Gandra','pt','Norte',6034.0,-8.42,41.2).
city('Gemunde','pt','Norte',5284.0,-8.64,41.27).
city('Godim','pt','Norte',4919.0,-7.79,41.17).
city('Gondomar','pt','Norte',27690.0,-8.52,41.15).
city('Grijo','pt','Norte',10907.0,-8.57,41.03).
city('Gueifaes','pt','Norte',12260.0,-8.61,41.07).
city('Guifoes','pt','Norte',9231.0,-8.66,41.2).
city('Guimaraes','pt','Norte',40603.0,-8.3,41.44).
city('Gulpilhares','pt','Norte',10660.0,-8.64,41.08).
city('Joane','pt','Norte',7869.0,-8.41,41.43).
city('Jovim','pt','Norte',7067.0,-8.51,41.1).
city('Lamego','pt','Norte',10928.0,-7.81,41.1).
city('Lavra','pt','Norte',9633.0,-8.71,41.25).
city('Leca da Palmeira','pt','Norte',17995.0,-8.7,41.2).
city('Leca do Bailio','pt','Norte',16103.0,-8.61,41.2).
city('Lobao','pt','Norte',6049.0,-8.47,40.98).
city('Lordelo','pt','Norte',7297.0,-8.38,41.3).
city('Lourosa','pt','Norte',9619.0,-8.54,40.98).
city('Lustosa','pt','Norte',4686.0,-8.31,41.33).
city('Macedo de Cavaleiros','pt','Norte',6566.0,-6.96,41.53).
city('Macieira de Cambra','pt','Norte',4909.0,-8.37,40.85).
city('Madalena','pt','Norte',9617.0,-8.32,41.22).
city('Maia','pt','Norte',36425.0,-8.62,41.24).
city('Margaride','pt','Norte',10652.0,-8.19,41.37).
city('Marinhas','pt','Norte',6052.0,-8.77,41.55).
city('Matosinhos','pt','Norte',28069.0,-8.7,41.18).
city('Meadela','pt','Norte',9981.0,-8.79,41.7).
city('Meinedo','pt','Norte',4416.0,-8.24,41.25).
city('Milheiros','pt','Norte',4342.0,-8.57,41.22).
city('Milheiros de Poiares','pt','Norte',4339.0,-8.46,40.92).
city('Mirandela','pt','Norte',12504.0,-7.17,41.48).
city('Mogadouro','pt','Norte',3935.0,-6.71,41.33).
city('Moreira','pt','Norte',11336.0,-8.37,41.05).
city('Moreira de Conegos','pt','Norte',5607.0,-8.34,41.38).
city('Mozelos','pt','Norte',7229.0,-8.39,41.87).
city('Negrelos','pt','Norte',6664.0,-8.39,41.35).
city('Nogueira','pt','Norte',4855.0,-8.0,41.23).
city('Nogueira da Regedoura','pt','Norte',5328.0,-8.57,41.0).
city('Olival','pt','Norte',5715.0,-8.54,41.05).
city('Oliveira','pt','Norte',6222.0,-8.46,41.48).
city('Oliveira de Azemeis','pt','Norte',11771.0,-8.47,40.83).
city('Oliveira do Douro','pt','Norte',24406.0,-8.59,41.12).
city('Pacos de Brandao','pt','Norte',4637.0,-8.57,40.97).
city('Pacos de Ferreira','pt','Norte',6782.0,-8.39,41.27).
city('Pedroso','pt','Norte',18962.0,-8.74,41.42).
city('Pedroucos','pt','Norte',12553.0,-8.57,41.18).
city('Penafiel','pt','Norte',8065.0,-8.27,41.2).
city('Perafita','pt','Norte',12538.0,-8.24,41.18).
city('Perozinho','pt','Norte',6259.0,-8.57,41.07).
city('Peso da Regua','pt','Norte',5048.0,-7.77,41.17).
city('Ponte','pt','Norte',7040.0,-8.32,41.47).
city('Porto','pt','Norte',249630.0,-8.62,41.15).
city('Povoa de Lanhoso','pt','Norte',5008.0,-8.26,41.58).
city('Povoa de Varzim','pt','Norte',29044.0,-8.77,41.38).
city('Real','pt','Norte',5827.0,-8.16,41.63).
city('Rebordosa','pt','Norte',114.0,-8.39,41.22).
city('Recarei','pt','Norte',4856.0,-8.41,41.15).
city('Refojos de Basto','pt','Norte',5037.0,-7.99,41.52).
city('Ribeirao','pt','Norte',8735.0,-8.54,41.35).
city('Rio Meao','pt','Norte',4802.0,-8.57,40.95).
city('Rio Tinto','pt','Norte',49966.0,-8.56,41.18).
city('Ronfe','pt','Norte',4888.0,-8.37,41.43).
city('Sande','pt','Norte',7789.0,-8.39,41.7).
city('Sandim','pt','Norte',6449.0,-8.51,41.03).
city('Santa Cruz do Bispo','pt','Norte',6230.0,-8.66,41.22).
city('Santa Maria de Lamas','pt','Norte',5628.0,-8.56,40.98).
city('Santiago da Riba-Ul','pt','Norte',4341.0,-8.47,40.85).
city('Santo Tirso','pt','Norte',14021.0,-8.46,41.35).
city('Sao Felix da Marinha','pt','Norte',11685.0,-8.61,41.03).
city('Sao Joao da Madeira','pt','Norte',22079.0,-8.49,40.9).
city('Sao Joao de Ver','pt','Norte',9568.0,-8.54,40.95).
city('Sao Mamede de Infesta','pt','Norte',25939.0,-8.61,41.19).
city('Sao Pedro da Cova','pt','Norte',17011.0,-8.51,41.15).
city('Sao Pedro de Casteloes','pt','Norte',7649.0,-8.39,40.85).
city('Sao Roque','pt','Norte',5575.0,-8.46,40.88).
city('Selho','pt','Norte',10223.0,-8.34,41.42).
city('Senhora da Hora','pt','Norte',28929.0,-8.64,41.18).
city('Seroa','pt','Norte',4040.0,-8.42,41.27).
city('Serzedelo','pt','Norte',4019.0,-8.36,41.4).
city('Serzedo','pt','Norte',8000.0,-8.22,41.4).
city('Silvalde','pt','Norte',7188.0,-8.62,40.98).
city('Sobrado','pt','Norte',6703.0,-8.46,41.2).
city('Sobreira','pt','Norte',4219.0,-7.79,41.52).
city('Souto','pt','Norte',4922.0,-8.61,40.98).
city('Teloes','pt','Norte',4675.0,-8.09,41.32).
city('Urgezes','pt','Norte',5456.0,-8.29,41.42).
city('Valadares','pt','Norte',9255.0,-7.97,41.15).
city('Valbom','pt','Norte',14443.0,-8.57,41.13).
city('Vale','pt','Norte',5058.0,-8.47,41.43).
city('Valongo','pt','Norte',21327.0,-8.49,41.18).
city('Valpacos','pt','Norte',4572.0,-7.31,41.6).
city('Viana do Castelo','pt','Norte',15555.0,-8.83,41.71).
city('Vila Cha','pt','Norte',4295.0,-8.46,40.87).
city('Vila Frescainha','pt','Norte',4018.0,-8.63,41.52).
city('Vila Nova da Telha','pt','Norte',5848.0,-8.62,41.07).
city('Vila Nova de Famalicao','pt','Norte',9496.0,-8.52,41.42).
city('Vila Nova de Gaia','pt','Norte',70810.0,-8.63,41.14).
city('Vila Praia de Ancora','pt','Norte',4987.0,-8.84,41.82).
city('Vila Real','pt','Norte',17001.0,-7.75,41.31).
city('Vila Verde','pt','Norte',4389.0,-8.42,41.65).
city('Vila de Cucujaes','pt','Norte',11087.0,-8.49,40.87).
city('Vila de Prado','pt','Norte',4518.0,-8.46,41.6).
city('Vila do Conde','pt','Norte',27642.0,-8.75,41.35).
city('Vilar de Andorinho','pt','Norte',18944.0,-8.56,41.1).
city('Vilar do Paraiso','pt','Norte',14727.0,-8.61,41.08).
city('Vilarinho','pt','Norte',4177.0,-8.32,41.35).
city('Vilela','pt','Norte',5540.0,-7.59,41.23).
city('Vizela','pt','Norte',4066.0,-8.26,41.38).
city('Arecibo','pr','Arecibo',49189.0,-66.73,18.44).
city('Barceloneta','pr','Arecibo',4494.0,-66.54,18.45).
city('Camuy','pr','Arecibo',4240.0,-66.85,18.49).
city('Ciales','pr','Arecibo',3256.0,-66.47,18.34).
city('Dorado','pr','Arecibo',13117.0,-66.27,18.47).
city('Florida','pr','Arecibo',5972.0,-66.58,18.39).
city('Hatillo','pr','Arecibo',5622.0,-66.82,18.49).
city('Isabela','pr','Arecibo',12505.0,-67.02,18.51).
city('Manati','pr','Arecibo',16093.0,-66.48,18.43).
city('Morovis','pr','Arecibo',2414.0,-66.41,18.33).
city('Quebradillas','pr','Arecibo',5620.0,-66.94,18.48).
city('Vega Alta','pr','Arecibo',12036.0,-66.32,18.42).
city('Vega Baja','pr','Arecibo',29326.0,-66.4,18.44).
city('Bayamon','pr','Bayamon',203598.0,-66.17,18.35).
city('Catano','pr','Bayamon',28094.0,-66.14,18.45).
city('Guaynabo','pr','Bayamon',81363.0,-66.11,18.39).
city('Levittown','pr','Bayamon',29786.0,-66.18,18.45).
city('Toa Alta','pr','Bayamon',4483.0,-66.25,18.39).
city('Toa Baja','pr','Bayamon',1889.0,-66.25,18.44).
city('Canovanas','pr','Carolina',8437.0,-65.91,18.38).
city('Carolina','pr','Carolina',170408.0,-65.95,18.34).
city('Loiza','pr','Carolina',4311.0,-65.88,18.43).
city('Trujillo Alto','pr','Carolina',54191.0,-66.02,18.36).
city('Aibonito','pr','Guayama',8947.0,-66.27,18.14).
city('Arroyo','pr','Guayama',7520.0,-66.06,17.97).
city('Barranquitas','pr','Guayama',3021.0,-66.31,18.19).
city('Cayey','pr','Guayama',18495.0,-66.16,18.12).
city('Cidra','pr','Guayama',5067.0,-66.16,18.18).
city('Coamo','pr','Guayama',11941.0,-66.36,18.08).
city('Comerio','pr','Guayama',4649.0,-66.23,18.22).
city('Corozal','pr','Guayama',11297.0,-66.31,18.34).
city('Guayama','pr','Guayama',21576.0,-66.11,17.98).
city('Juana Diaz','pr','Guayama',9427.0,-66.5,18.05).
city('Maunabo','pr','Guayama',2154.0,-65.9,18.01).
city('Naranjito','pr','Guayama',2005.0,-66.25,18.31).
city('Orocovis','pr','Guayama',944.0,-66.39,18.22).
city('Patillas','pr','Guayama',4247.0,-66.01,18.01).
city('Salinas','pr','Guayama',6375.0,-66.3,17.98).
city('Santa Isabel','pr','Guayama',7260.0,-66.41,17.97).
city('Villalba','pr','Guayama',4555.0,-66.48,18.13).
city('Aguas Buenas','pr','Humacao',4576.0,-66.11,18.26).
city('Caguas','pr','Humacao',86807.0,-66.07,18.23).
city('Ceiba','pr','Humacao',6576.0,-66.35,18.44).
city('Culebra','pr','Humacao',1486.0,-65.31,18.31).
city('Fajardo','pr','Humacao',34070.0,-65.66,18.34).
city('Gurabo','pr','Humacao',8974.0,-65.98,18.26).
city('Humacao','pr','Humacao',20388.0,-65.82,18.15).
city('Juncos','pr','Humacao',8905.0,-65.92,18.23).
city('Las Piedras','pr','Humacao',6655.0,-65.87,18.18).
city('Luquillo','pr','Humacao',8326.0,-65.72,18.38).
city('Naguabo','pr','Humacao',4643.0,-65.74,18.21).
city('Rio Grande','pr','Humacao',41218.0,-65.84,18.38).
city('San Lorenzo','pr','Humacao',9373.0,-65.97,18.19).
city('Vieques','pr','Humacao',4531.0,-65.48,18.08).
city('Yabucoa','pr','Humacao',6952.0,-65.88,18.05).
city('Aguada','pr','Mayagueez-Aguadilla',4040.0,-67.19,18.38).
city('Aguadilla','pr','Mayagueez-Aguadilla',16074.0,-67.13,18.45).
city('Anasco','pr','Mayagueez-Aguadilla',6136.0,-67.14,18.29).
city('Cabo Rojo','pr','Mayagueez-Aguadilla',10840.0,-67.15,18.09).
city('Hormigueros','pr','Mayagueez-Aguadilla',11935.0,-67.12,18.14).
city('Lajas','pr','Mayagueez-Aguadilla',5255.0,-67.06,18.05).
city('Las Marias','pr','Mayagueez-Aguadilla',1031.0,-66.99,18.26).
city('Maricao','pr','Mayagueez-Aguadilla',1172.0,-66.98,18.19).
city('Mayagueez','pr','Mayagueez-Aguadilla',76503.0,-67.15,18.22).
city('Moca','pr','Mayagueez-Aguadilla',4964.0,-67.11,18.4).
city('Rincon','pr','Mayagueez-Aguadilla',1499.0,-67.25,18.34).
city('San German','pr','Mayagueez-Aguadilla',12055.0,-67.05,18.08).
city('San Sebastian','pr','Mayagueez-Aguadilla',11591.0,-67.0,18.34).
city('Adjuntas','pr','Ponce',5080.0,-66.72,18.17).
city('Guanica','pr','Ponce',9224.0,-66.93,17.97).
city('Guayanilla','pr','Ponce',5213.0,-66.79,18.02).
city('Jayuya','pr','Ponce',3587.0,-66.6,18.22).
city('Lares','pr','Ponce',7184.0,-66.88,18.3).
city('Penuelas','pr','Ponce',6847.0,-66.72,18.06).
city('Ponce','pr','Ponce',152639.0,-66.6,18.02).
city('Sabana Grande','pr','Ponce',8961.0,-66.97,18.08).
city('Utuado','pr','Ponce',9844.0,-66.71,18.27).
city('Yauco','pr','Ponce',20296.0,-66.86,18.04).
city('San Juan','pr','San Juan',418140.0,-66.13,18.44).
city('Doha','qa','Doha',344939.0,51.51,25.3).
city('Abu Samrah','qa','Jariyan al-Batnah',938.0,50.84,24.75).
city('Hzawr al-Udayd','qa','Jariyan al-Batnah',125.0,51.32,24.62).
city('Rawdat Rasid','qa','Jariyan al-Batnah',3620.0,51.2,25.23).
city('Sawda Natzil','qa','Jariyan al-Batnah',229.0,51.09,24.55).
city('Khor','qa','Khor',18923.0,51.51,25.69).
city('Musayid','qa','Musayid',10106.0,51.55,24.98).
city('Umm Salal','qa','Umm Salal',29391.0,51.4,25.42).
city('al-Guwayriyah','qa','al-Guwayriyah',2332.0,51.25,25.84).
city('Duhzan','qa','al-Jumayliyah',7250.0,50.79,25.43).
city('Umm Bab','qa','al-Jumayliyah',2500.0,50.8,25.21).
city('al-Aturiyah','qa','al-Jumayliyah',1251.0,51.23,25.53).
city('al-Jumayliyah','qa','al-Jumayliyah',1788.0,51.09,25.62).
city('an-Nasraniyah','qa','al-Jumayliyah',670.0,51.07,25.4).
city('al-Wakrah','qa','al-Wakrah',26437.0,51.61,25.18).
city('al-Wukayr','qa','al-Wakrah',5146.0,51.53,25.13).
city('ar-Rayyan','qa','ar-Rayyan',272466.0,51.37,25.32).
city('as-Sahhaniyah','qa','ar-Rayyan',11553.0,51.24,25.4).
city('ar-','qa','as-Samal',3334.0,51.22,26.14).
city('Madingou','cg','Bouenza',22760.0,13.55,-4.15).
city('Nkayi','cg','Bouenza',70945.0,13.28,-4.18).
city('Brazzaville','cg','Brazzaville',1115773.0,15.26,-4.25).
city('Ewo','cg','Cuvette',4923.0,14.82,-0.88).
city('Owando','cg','Cuvette',16590.0,15.92,-0.48).
city('Loandjili','cg','Kouilou',26387.0,11.86,-4.75).
city('Ngamaba-Mfilou','cg','Kouilou',16254.0,11.99,-4.25).
city('Pointe Noire','cg','Kouilou',628924.0,11.87,-4.77).
city('Sibiti','cg','Lekoumou',19089.0,13.35,-3.69).
city('Impfondo','cg','Likouala',20859.0,18.04,1.64).
city('Loubomo','cg','Niari',70734.0,12.67,-4.18).
city('Matsanga','cg','Niari',3582.0,12.68,-1.88).
city('Mossendjo','cg','Niari',21555.0,12.72,-2.94).
city('Djambala','cg','Plateaux',9650.0,14.75,-2.54).
city('Gamboma','cg','Plateaux',20877.0,15.85,-1.88).
city('Kinkala','cg','Pool',13882.0,14.76,-4.35).
city('Ouesso','cg','Sangha',16691.0,16.05,1.61).
city('Sembe','cg','Sangha',2514.0,14.58,1.64).
city('Bras-Panon','re','Saint-Benoit',10445.0,55.7,-20.99).
city('Saint-Andre','re','Saint-Benoit',48675.0,55.65,-20.95).
city('Saint-Benoit','re','Saint-Benoit',35312.0,55.72,-21.03).
city('Sainte-Rose','re','Saint-Benoit',7036.0,55.8,-21.11).
city('Salazie','re','Saint-Benoit',7696.0,55.55,-21.02).
city('La Possession','re','Saint-Denis',26867.0,55.34,-20.92).
city('Le Port','re','Saint-Denis',40774.0,55.3,-20.93).
city('Saint-Denis','re','Saint-Denis',137198.0,55.46,-20.87).
city('Sainte-Marie','re','Saint-Denis',31638.0,55.55,-20.88).
city('Sainte-Suz','re','Saint-Denis',20531.0,55.61,-20.9).
city('LEtang-Sale','re','Saint-Paul',14005.0,55.38,-21.25).
city('Les Aviron','re','Saint-Paul',8007.0,55.34,-21.22).
city('Les Trois-Bassins','re','Saint-Paul',7114.0,55.3,-21.09).
city('Saint-Leu','re','Saint-Paul',28280.0,55.29,-21.16).
city('Saint-Paul','re','Saint-Paul',99309.0,55.27,-21.0).
city('Cilaos','re','Saint-Pierre',6225.0,55.47,-21.12).
city('Entre-Deux','re','Saint-Pierre',5788.0,55.48,-21.23).
city('Le Tampon','re','Saint-Pierre',69989.0,55.53,-21.27).
city('Petite-Ile','re','Saint-Pierre',10962.0,55.57,-21.34).
city('Saint-Joseph','re','Saint-Pierre',33696.0,55.62,-21.36).
city('Saint-Louis','re','Saint-Pierre',47884.0,55.41,-21.27).
city('Saint-Philippe','re','Saint-Pierre',5441.0,55.77,-21.34).
city('Saint-Pierre','re','Saint-Pierre',76657.0,55.47,-21.32).
city('Abrud','ro','Alba',6122.0,23.06,46.28).
city('Aiud','ro','Alba',28341.0,23.73,46.32).
city('Alba Iulia','ro','Alba',66085.0,23.57,46.08).
city('Albac','ro','Alba',2168.0,22.97,46.45).
city('Almasu Mare','ro','Alba',1649.0,23.13,46.1).
city('Arieseni','ro','Alba',1876.0,22.77,46.48).
city('Avram Iancu','ro','Alba',1806.0,22.78,46.38).
city('Baia de Aries','ro','Alba',4566.0,23.28,46.38).
city('Berghin','ro','Alba',2125.0,23.73,46.07).
city('Bistra','ro','Alba',4942.0,23.1,46.38).
city('Blaj','ro','Alba',20371.0,23.91,46.18).
city('Blandiana','ro','Alba',1157.0,23.38,45.97).
city('Bucium','ro','Alba',1747.0,23.22,46.23).
city('Calnic','ro','Alba',2959.0,23.67,45.88).
city('Campeni','ro','Alba',7932.0,23.04,46.37).
city('Cenade','ro','Alba',994.0,24.02,46.05).
city('Cergau','ro','Alba',1722.0,23.92,46.1).
city('Ceru-Bacainti','ro','Alba',367.0,23.25,45.98).
city('Cetatea de Balta','ro','Alba',3161.0,24.17,46.25).
city('Ciugud','ro','Alba',2613.0,23.62,46.05).
city('Ciuruleasa','ro','Alba',1333.0,23.03,46.25).
city('Craciunelu de Jos','ro','Alba',4297.0,23.83,46.18).
city('Cricau','ro','Alba',2052.0,23.57,46.18).
city('Cugir','ro','Alba',24734.0,23.37,45.85).
city('Daia Romana','ro','Alba',3057.0,23.67,46.02).
city('Dostat','ro','Alba',1049.0,23.85,45.97).
city('Farau','ro','Alba',1866.0,24.02,46.33).
city('Galda de Jos','ro','Alba',4772.0,23.62,46.18).
city('Garbova','ro','Alba',2022.0,23.73,45.87).
city('Garda de Sus','ro','Alba',1822.0,22.82,46.45).
city('Hoparta','ro','Alba',1355.0,23.87,46.32).
city('Horea','ro','Alba',2320.0,22.94,46.5).
city('Ighiu','ro','Alba',6294.0,23.52,46.15).
city('Intregalde','ro','Alba',860.0,23.42,46.25).
city('Jidvei','ro','Alba',5146.0,24.1,46.22).
city('Livezile','ro','Alba',1491.0,23.63,46.35).
city('Lopadea Noua','ro','Alba',2931.0,23.82,46.28).
city('Lunca Muresului','ro','Alba',2617.0,23.9,46.43).
city('Lupsa','ro','Alba',3765.0,23.2,46.37).
city('Metes','ro','Alba',3114.0,23.42,46.1).
city('Mihalt','ro','Alba',3601.0,23.73,46.15).
city('Miraslau','ro','Alba',2298.0,23.72,46.37).
city('Mogos','ro','Alba',1087.0,23.28,46.27).
city('Noslac','ro','Alba',1992.0,23.93,46.4).
city('Ocna Mures','ro','Alba',15316.0,23.86,46.39).
city('Ocolis','ro','Alba',832.0,23.47,46.48).
city('Ohaba','ro','Alba',916.0,23.78,46.07).
city('Pianu','ro','Alba',3308.0,23.48,45.92).
city('Poiana Vadului','ro','Alba',1276.0,22.88,46.4).
city('Ponor','ro','Alba',702.0,23.42,46.33).
city('Posaga','ro','Alba',1366.0,23.4,46.45).
city('Radesti','ro','Alba',1379.0,23.72,46.27).
city('Ramet','ro','Alba',734.0,23.53,46.3).
city('Rimetea','ro','Alba',1191.0,23.57,46.45).
city('Rosia Montana','ro','Alba',3776.0,23.13,46.3).
city('Rosia de Secas','ro','Alba',1660.0,23.88,46.05).
city('Salciua','ro','Alba',1747.0,23.43,46.4).
city('Salistea','ro','Alba',2328.0,23.4,45.9).
city('Sancel','ro','Alba',2735.0,23.95,46.2).
city('Santimbru','ro','Alba',2679.0,23.65,46.13).
city('Sasciori','ro','Alba',5822.0,23.58,45.87).
city('Scarisoara','ro','Alba',1808.0,22.85,46.47).
city('Sebes','ro','Alba',27246.0,23.57,45.96).
city('Sibot','ro','Alba',2427.0,23.33,45.95).
city('Sohodol','ro','Alba',2038.0,23.03,46.35).
city('Sona','ro','Alba',4425.0,24.02,46.22).
city('Spring','ro','Alba',2492.0,23.78,45.97).
city('Stremt','ro','Alba',2761.0,23.63,46.22).
city('Sugag','ro','Alba',3175.0,23.63,45.77).
city('Teius','ro','Alba',7112.0,23.68,46.2).
city('Unirea','ro','Alba',5377.0,22.88,45.62).
city('Vadu Motilor','ro','Alba',1523.0,22.97,46.4).
city('Valea Lunga','ro','Alba',3199.0,22.78,46.08).
city('Vidra','ro','Alba',1924.0,22.92,46.47).
city('Vintu de Jos','ro','Alba',5215.0,23.47,46.0).
city('Zlatna','ro','Alba',8393.0,23.23,46.13).
city('Almas','ro','Arad',2957.0,22.23,46.28).
city('Apateu','ro','Arad',3622.0,21.78,46.62).
city('Arad','ro','Arad',169067.0,21.32,46.19).
city('Archis','ro','Arad',1667.0,22.05,46.48).
city('Barsa','ro','Arad',1901.0,22.07,46.38).
city('Barzava','ro','Arad',2975.0,21.98,46.12).
city('Bata','ro','Arad',1206.0,22.03,46.02).
city('Beliu','ro','Arad',3274.0,21.98,46.48).
city('Birchis','ro','Arad',2009.0,22.17,45.97).
city('Bocsig','ro','Arad',3493.0,21.95,46.42).
city('Brazii','ro','Arad',1397.0,22.33,46.23).
city('Buteni','ro','Arad',3424.0,22.12,46.32).
city('Carand','ro','Arad',1299.0,22.08,46.45).
city('Cermei','ro','Arad',2811.0,21.85,46.55).
city('Chisindia','ro','Arad',1550.0,22.1,46.28).
city('Chisineu Cris','ro','Arad',8171.0,21.52,46.53).
city('Conop','ro','Arad',2296.0,21.88,46.1).
city('Covasint','ro','Arad',2613.0,21.6,46.2).
city('Craiva','ro','Arad',3064.0,21.96,46.58).
city('Curtici','ro','Arad',9615.0,21.31,46.35).
city('Dezna','ro','Arad',1485.0,22.25,46.4).
city('Dieci','ro','Arad',1725.0,22.25,46.32).
city('Dorgos','ro','Arad',1368.0,21.83,46.05).
city('Fantanele','ro','Arad',5597.0,21.4,46.12).
city('Felnac','ro','Arad',5097.0,21.15,46.12).
city('Ghioroc','ro','Arad',3998.0,21.58,46.15).
city('Graniceri','ro','Arad',2547.0,21.3,46.52).
city('Gurahont','ro','Arad',4427.0,22.35,46.27).
city('Halmagel','ro','Arad',1629.0,22.62,46.27).
city('Halmagiu','ro','Arad',3507.0,22.58,46.27).
city('Hasmas','ro','Arad',1436.0,22.08,46.5).
city('Ignesti','ro','Arad',809.0,22.17,46.4).
city('Ineu','ro','Arad',10051.0,21.85,46.43).
city('Iratosu','ro','Arad',2325.0,21.2,46.32).
city('Lipova','ro','Arad',11041.0,21.0,46.1).
city('Livada','ro','Arad',2840.0,21.38,46.22).
city('Macea','ro','Arad',6056.0,21.3,46.38).
city('Masca','ro','Arad',3498.0,21.68,46.3).
city('Moneasa','ro','Arad',1035.0,22.25,46.45).
city('Nadlac','ro','Arad',8067.0,20.74,46.17).
city('Olari','ro','Arad',1905.0,21.55,46.38).
city('Pancota','ro','Arad',7133.0,21.7,46.34).
city('Paulis','ro','Arad',4036.0,21.58,46.12).
city('Pecica','ro','Arad',12804.0,21.07,46.17).
city('Peregu Mare','ro','Arad',1770.0,20.9,46.23).
city('Petris','ro','Arad',1842.0,22.38,46.05).
city('Pilu','ro','Arad',1943.0,21.35,46.57).
city('Plescuta','ro','Arad',1471.0,22.43,46.3).
city('Sagu','ro','Arad',3797.0,21.28,46.05).
city('Santana','ro','Arad',12706.0,21.5,46.35).
city('Savarsin','ro','Arad',3239.0,22.23,46.02).
city('Sebis','ro','Arad',6168.0,22.11,46.37).
city('Secusigiu','ro','Arad',5748.0,20.98,46.08).
city('Seitin','ro','Arad',2943.0,20.85,46.1).
city('Se','ro','Arad',3140.0,21.72,46.38).
city('Semlac','ro','Arad',3727.0,20.93,46.12).
city('Sepreus','ro','Arad',2423.0,21.73,46.72).
city('Sicula','ro','Arad',4503.0,21.75,46.43).
city('Silindia','ro','Arad',943.0,21.92,46.35).
city('Simand','ro','Arad',4064.0,21.45,46.43).
city('Sintea Mare','ro','Arad',3609.0,21.6,46.52).
city('Siria','ro','Arad',8004.0,21.63,46.27).
city('Sistarovat','ro','Arad',374.0,21.73,46.02).
city('Socodor','ro','Arad',2248.0,21.43,46.52).
city('Sofronea','ro','Arad',2527.0,21.3,46.27).
city('Tarnova','ro','Arad',6146.0,21.8,46.32).
city('Taut','ro','Arad',2139.0,21.92,46.28).
city('Varadia de Mures','ro','Arad',2082.0,22.15,46.02).
city('Varfurile','ro','Arad',3247.0,22.52,46.32).
city('Vinga','ro','Arad',6283.0,21.2,46.02).
city('Vladimirescu','ro','Arad',10451.0,21.4,46.15).
city('Zabrani','ro','Arad',4392.0,21.55,46.07).
city('Zarand','ro','Arad',2629.0,21.65,46.4).
city('Zerind','ro','Arad',1442.0,21.52,46.62).
city('Zimandu Nou','ro','Arad',4412.0,21.4,46.28).
city('Albesti','ro','Arges',4503.0,25.0,45.32).
city('Albestii-Pamanteni','ro','Arges',5815.0,24.67,45.22).
city('Albota','ro','Arges',3866.0,24.85,44.77).
city('Aninoasa','ro','Arges',3334.0,24.93,45.18).
city('Arefu','ro','Arges',2750.0,24.6,45.33).
city('Babana','ro','Arges',2809.0,24.7,44.9).
city('Baiculesti','ro','Arges',6207.0,24.7,45.07).
city('Balilesti','ro','Arges',4362.0,24.93,45.07).
city('Barla','ro','Arges',5795.0,24.77,44.43).
city('Bascov','ro','Arges',8759.0,24.82,44.9).
city('Beleti-Negresti','ro','Arges',1974.0,25.08,44.9).
city('Berevoesti','ro','Arges',3385.0,24.93,45.23).
city('Bogati','ro','Arges',4936.0,25.13,44.87).
city('Boteni','ro','Arges',2733.0,25.12,45.18).
city('Botesti','ro','Arges',1330.0,25.13,45.02).
city('Bradu','ro','Arges',5091.0,24.9,44.78).
city('Bradulet','ro','Arges',2130.0,24.77,45.28).
city('Budeasa','ro','Arges',3789.0,24.85,44.93).
city('Bughea de Jos','ro','Arges',2988.0,25.0,45.27).
city('Buzoesti','ro','Arges',6281.0,24.92,44.58).
city('Caldararu','ro','Arges',2975.0,24.95,44.45).
city('Calinesti','ro','Arges',10419.0,25.05,44.82).
city('Campulung','ro','Arges',37280.0,25.04,45.27).
city('Cateasca','ro','Arges',3713.0,25.08,44.77).
city('Cepari','ro','Arges',2452.0,24.57,45.22).
city('Cetateni','ro','Arges',3032.0,25.18,45.2).
city('Cicanesti','ro','Arges',2265.0,24.63,45.25).
city('Ciofrangeni','ro','Arges',2643.0,24.53,45.08).
city('Ciomagesti','ro','Arges',1362.0,24.45,44.83).
city('Cocu','ro','Arges',2662.0,24.65,44.87).
city('Corbeni','ro','Arges',5613.0,24.65,45.3).
city('Corbi','ro','Arges',4381.0,24.8,45.28).
city('Cosesti','ro','Arges',5416.0,24.87,45.07).
city('Costesti','ro','Arges',10654.0,24.88,44.67).
city('Cotmeana','ro','Arges',2230.0,24.62,44.97).
city('Cuca','ro','Arges',2315.0,24.52,44.95).
city('Curtea de Arges','ro','Arges',32179.0,24.68,45.14).
city('Dambovicioara','ro','Arges',1043.0,25.23,45.45).
city('Darmanesti','ro','Arges',3676.0,24.9,45.02).
city('Davidesti','ro','Arges',2816.0,25.03,45.02).
city('Dobresti','ro','Arges',1820.0,25.13,44.97).
city('Domnesti','ro','Arges',3182.0,24.83,45.2).
city('Draganu','ro','Arges',1962.0,24.72,44.93).
city('Dragoslavele','ro','Arges',2528.0,25.17,45.35).
city('Godeni','ro','Arges',3333.0,24.98,45.23).
city('Harsesti','ro','Arges',2841.0,24.78,44.53).
city('Ha','ro','Arges',4913.0,25.1,45.12).
city('Izvoru','ro','Arges',2641.0,24.65,44.8).
city('Leordeni','ro','Arges',6019.0,25.12,44.78).
city('Leresti','ro','Arges',4960.0,25.07,45.33).
city('Lunca Corbului','ro','Arges',3350.0,24.75,44.7).
city('Malureni','ro','Arges',4762.0,24.8,45.1).
city('Maracineni','ro','Arges',4468.0,24.9,44.9).
city('Merisani','ro','Arges',4390.0,24.73,44.97).
city('Micesti','ro','Arges',4061.0,24.87,44.95).
city('Mihaesti','ro','Arges',5825.0,25.0,45.12).
city('Mioarele','ro','Arges',1790.0,25.07,45.25).
city('Mioveni','ro','Arges',36339.0,24.95,44.95).
city('Mirosi','ro','Arges',2789.0,24.93,44.42).
city('Moraresti','ro','Arges',2201.0,24.57,45.02).
city('Mosoaia','ro','Arges',4267.0,24.77,44.82).
city('Mozaceni','ro','Arges',2684.0,25.17,44.57).
city('Musatesti','ro','Arges',4176.0,24.78,45.22).
city('Negrasi','ro','Arges',2811.0,25.12,44.6).
city('Nucsoara','ro','Arges',1687.0,24.78,45.33).
city('Oarja','ro','Arges',2851.0,24.97,44.77).
city('Pietrosani','ro','Arges',5871.0,24.85,45.18).
city('Pitesti','ro','Arges',167671.0,24.87,44.86).
city('Poenari','ro','Arges',2375.0,24.86,45.28).
city('Poiana Lacului','ro','Arges',6705.0,24.73,44.82).
city('Popesti','ro','Arges',4104.0,25.07,44.77).
city('Priboieni','ro','Arges',3583.0,25.08,44.88).
city('Ratesti','ro','Arges',3368.0,25.13,44.73).
city('Recea','ro','Arges',3229.0,25.03,44.52).
city('Rociu','ro','Arges',2980.0,25.03,44.67).
city('Rucar','ro','Arges',6142.0,25.17,45.4).
city('Salatrucu','ro','Arges',2251.0,24.52,45.32).
city('Sapata','ro','Arges',2103.0,24.73,44.77).
city('Schitu-Golesti','ro','Arges',4945.0,25.0,45.2).
city('Slobozia','ro','Arges',5045.0,25.23,44.52).
city('Stalpeni','ro','Arges',5088.0,24.97,45.05).
city('Stefan cel Mare','ro','Arges',2632.0,25.25,44.5).
city('Stefanesti','ro','Arges',12837.0,24.93,44.87).
city('Stoenesti','ro','Arges',4534.0,25.17,45.25).
city('Stolnici','ro','Arges',3784.0,24.78,44.57).
city('Suici','ro','Arges',2897.0,24.53,45.25).
city('Suseni','ro','Arges',3492.0,24.95,44.72).
city('Teiu','ro','Arges',1853.0,25.12,44.67).
city('Tigveni','ro','Arges',3634.0,24.58,45.13).
city('Titesti','ro','Arges',4581.0,25.0,45.02).
city('Topoloveni','ro','Arges',11039.0,25.08,44.82).
city('Uda','ro','Arges',2567.0,24.57,44.92).
city('Ungheni','ro','Arges',3678.0,24.97,44.5).
city('Valea Danului','ro','Arges',3089.0,24.65,45.18).
city('Valea Iasului','ro','Arges',2778.0,24.72,45.18).
city('Valea Mare-Pravat','ro','Arges',4210.0,25.08,45.28).
city('Vedea','ro','Arges',4243.0,24.62,44.78).
city('Vladesti','ro','Arges',3131.0,24.92,45.17).
city('Agas','ro','Bacau',6619.0,26.22,46.48).
city('Ardeoani','ro','Bacau',2532.0,26.6,46.53).
city('Asau','ro','Bacau',7438.0,26.4,46.43).
city('Bacau','ro','Bacau',171397.0,26.92,46.58).
city('Balcani','ro','Bacau',7958.0,26.55,46.63).
city('Barsanesti','ro','Bacau',5038.0,26.7,46.33).
city('Beresti-Bistrita','ro','Bacau',3377.0,26.83,46.72).
city('Beresti-Tazlau','ro','Bacau',5661.0,26.67,46.47).
city('Berzunti','ro','Bacau',5285.0,26.63,46.4).
city('Blagesti','ro','Bacau',7165.0,26.65,46.68).
city('Bogdanesti','ro','Bacau',2740.0,26.68,46.22).
city('Brusturoasa','ro','Bacau',3479.0,26.2,46.52).
city('Buhoci','ro','Bacau',4736.0,27.02,46.57).
city('Buhusi','ro','Bacau',18395.0,26.72,46.71).
city('Caiuti','ro','Bacau',5357.0,26.93,46.18).
city('Casin','ro','Bacau',3713.0,26.75,46.2).
city('Cleja','ro','Bacau',6816.0,26.9,46.42).
city('Colonesti','ro','Bacau',2162.0,27.3,46.57).
city('Comanesti','ro','Bacau',23730.0,26.45,46.43).
city('Corbasca','ro','Bacau',5328.0,27.17,46.28).
city('Cotofanesti','ro','Bacau',3279.0,26.98,46.15).
city('Damienesti','ro','Bacau',1896.0,26.98,46.73).
city('Darmanesti','ro','Bacau',14290.0,26.48,46.37).
city('Dealu Morii','ro','Bacau',2970.0,27.23,46.32).
city('Dofteana','ro','Bacau',107.0,26.52,46.32).
city('Faraoani','ro','Bacau',5141.0,26.9,46.43).
city('Filipeni','ro','Bacau',2441.0,27.18,46.53).
city('Filipesti','ro','Bacau',4678.0,26.89,46.75).
city('Gaiceana','ro','Bacau',3063.0,27.22,46.33).
city('Garleni','ro','Bacau',6263.0,26.8,46.67).
city('Ghimes-Faget','ro','Bacau',5248.0,26.05,46.58).
city('Glavanesti','ro','Bacau',3760.0,27.38,46.25).
city('Gura Vaii','ro','Bacau',6075.0,26.73,46.33).
city('Helegiu','ro','Bacau',7195.0,26.75,46.35).
city('Hemeius','ro','Bacau',3761.0,26.85,46.62).
city('Horgesti','ro','Bacau',4665.0,27.07,46.43).
city('Huruesti','ro','Bacau',2821.0,27.25,46.27).
city('Izvoru Berheciului','ro','Bacau',1697.0,27.22,46.58).
city('Letea Veche','ro','Bacau',4893.0,26.95,46.55).
city('Lipova','ro','Bacau',2916.0,27.23,46.72).
city('Livezi','ro','Bacau',5255.0,26.73,46.4).
city('Luizi-Calugara','ro','Bacau',4596.0,26.83,46.53).
city('Magiresti','ro','Bacau',4477.0,26.55,46.52).
city('Magura','ro','Bacau',3936.0,26.85,46.57).
city('Manastirea Casin','ro','Bacau',5505.0,26.68,46.15).
city('Margineni','ro','Bacau',8033.0,26.9,46.6).
city('Moinesti','ro','Bacau',23981.0,26.51,46.48).
city('Motoseni','ro','Bacau',4007.0,27.43,46.33).
city('Negri','ro','Bacau',3101.0,26.97,46.7).
city('Nicolae Balcescu','ro','Bacau',10140.0,26.92,46.47).
city('Oituz','ro','Bacau',9596.0,26.62,46.2).
city('Oncesti','ro','Bacau',1686.0,27.25,46.47).
city('Onesti','ro','Bacau',50489.0,26.76,46.26).
city('Or','ro','Bacau',4140.0,27.02,46.28).
city('Palanca','ro','Bacau',3733.0,26.12,46.53).
city('Pancesti','ro','Bacau',4272.0,27.08,46.33).
city('Parava','ro','Bacau',3367.0,27.0,46.3).
city('Pargaresti','ro','Bacau',4798.0,26.65,46.25).
city('Parincea','ro','Bacau',3836.0,27.1,46.48).
city('Parjol','ro','Bacau',6688.0,26.6,46.58).
city('Plopana','ro','Bacau',3291.0,27.22,46.68).
city('Podu Turcului','ro','Bacau',5081.0,27.38,46.2).
city('Poduri','ro','Bacau',7937.0,26.5,46.47).
city('Racaciuni','ro','Bacau',7839.0,26.98,46.33).
city('Rachitoasa','ro','Bacau',5009.0,27.37,46.43).
city('Racova','ro','Bacau',3488.0,26.75,46.7).
city('Rosiori','ro','Bacau',2137.0,27.08,46.72).
city('Sanduleni','ro','Bacau',4287.0,26.73,46.45).
city('Sascut','ro','Bacau',10031.0,27.1,46.2).
city('Saucesti','ro','Bacau',4042.0,26.93,46.67).
city('Scorteni','ro','Bacau',3159.0,26.65,46.55).
city('Secuieni','ro','Bacau',4375.0,27.1,46.65).
city('Slanic-Moldova','ro','Bacau',4955.0,26.43,46.2).
city('Solont','ro','Bacau',3866.0,26.52,46.55).
city('Stanisesti','ro','Bacau',4684.0,27.3,46.43).
city('Stefan cel Mare','ro','Bacau',7051.0,26.72,46.22).
city('Strugari','ro','Bacau',2629.0,26.72,46.53).
city('Tamasi','ro','Bacau',6330.0,26.98,46.48).
city('Targu Ocna','ro','Bacau',13127.0,26.62,46.28).
city('Targu-Trotus','ro','Bacau',5305.0,26.67,46.27).
city('Tatarasti','ro','Bacau',2630.0,27.2,46.22).
city('Traian','ro','Bacau',4662.0,27.03,46.63).
city('Ungureni','ro','Bacau',3728.0,26.95,46.52).
city('Urechesti','ro','Bacau',3999.0,27.08,46.13).
city('Valea Seaca','ro','Bacau',3516.0,26.87,46.47).
city('Vultureni','ro','Bacau',2171.0,27.28,46.37).
city('Zemes','ro','Bacau',5171.0,26.42,46.58).
city('Abram','ro','Bihor',3291.0,22.38,47.32).
city('Abramut','ro','Bihor',2962.0,22.25,47.32).
city('Alesd','ro','Bihor',10264.0,22.4,47.06).
city('Astileu','ro','Bihor',3728.0,22.38,47.03).
city('Auseu','ro','Bihor',2978.0,22.5,47.03).
city('Avram Iancu','ro','Bihor',3252.0,22.38,47.31).
city('Balc','ro','Bihor',3512.0,22.53,47.28).
city('Batar','ro','Bihor',5143.0,21.82,46.7).
city('Beius','ro','Bihor',10721.0,22.36,46.66).
city('Biharia','ro','Bihor',5769.0,21.92,47.15).
city('Boianu Mare','ro','Bihor',1403.0,22.53,47.38).
city('Borod','ro','Bihor',4076.0,22.63,46.98).
city('Bors','ro','Bihor',3346.0,21.82,47.12).
city('Bratca','ro','Bihor',5462.0,22.63,46.95).
city('Brusturi','ro','Bihor',4295.0,22.25,47.15).
city('Budureasa','ro','Bihor',2622.0,22.5,46.67).
city('Buduslau','ro','Bihor',1926.0,22.27,47.4).
city('Bulz','ro','Bihor',2352.0,22.68,46.92).
city('Buntesti','ro','Bihor',4676.0,22.47,46.62).
city('Cabesti','ro','Bihor',2043.0,22.37,46.77).
city('Campani','ro','Bihor',2608.0,22.32,46.8).
city('Capalna','ro','Bihor',1975.0,22.1,46.73).
city('Carpinet','ro','Bihor',2203.0,22.48,46.45).
city('Cefa','ro','Bihor',6206.0,21.73,46.92).
city('Ceica','ro','Bihor',4028.0,22.18,46.85).
city('Cetariu','ro','Bihor',3819.0,22.02,47.13).
city('Cherechiu','ro','Bihor',2437.0,22.13,47.38).
city('Chislaz','ro','Bihor',3386.0,22.23,47.28).
city('Ciuhoiu','ro','Bihor',2249.0,22.12,47.23).
city('Ciumeghiu','ro','Bihor',4419.0,21.58,46.73).
city('Cociuba Mare','ro','Bihor',3173.0,22.0,46.73).
city('Copacel','ro','Bihor',2427.0,22.17,46.98).
city('Cristioru de Jos','ro','Bihor',1610.0,22.53,46.43).
city('Curatele','ro','Bihor',2670.0,22.42,46.7).
city('Curtuiseni','ro','Bihor',3720.0,22.2,47.55).
city('Derna','ro','Bihor',2963.0,22.3,47.2).
city('Diosig','ro','Bihor',9455.0,22.0,47.3).
city('Dobresti','ro','Bihor',5573.0,22.3,46.85).
city('Draganesti','ro','Bihor',2872.0,22.38,46.62).
city('Dragesti','ro','Bihor',2521.0,22.13,46.88).
city('Finis','ro','Bihor',3624.0,22.32,46.63).
city('Girisu de Cris','ro','Bihor',5170.0,21.78,47.07).
city('Hidiselu de Sus','ro','Bihor',3262.0,22.05,46.95).
city('Holod','ro','Bihor',3493.0,22.13,46.78).
city('Husasau de Tinca','ro','Bihor',2324.0,21.92,46.82).
city('Ineu','ro','Bihor',4007.0,22.12,47.08).
city('Lazareni','ro','Bihor',2982.0,22.07,46.87).
city('Lazuri de Beius','ro','Bihor',1840.0,22.4,46.58).
city('Lugasu de Jos','ro','Bihor',3252.0,22.35,47.07).
city('Lunca','ro','Bihor',3081.0,22.47,46.52).
city('Madaras','ro','Bihor',2964.0,21.68,46.83).
city('Magesti','ro','Bihor',2824.0,22.45,47.02).
city('Marghita','ro','Bihor',18935.0,22.34,47.36).
city('Nojorid','ro','Bihor',4484.0,21.88,46.98).
city('Nucet','ro','Bihor',2362.0,22.58,46.47).
city('Olcea','ro','Bihor',2909.0,21.98,46.68).
city('Oradea','ro','Bihor',203841.0,21.92,47.07).
city('Osorheiu','ro','Bihor',5764.0,22.05,47.03).
city('Pietroasa','ro','Bihor',3386.0,22.55,46.58).
city('Pocola','ro','Bihor',1646.0,22.28,46.68).
city('Pomezeu','ro','Bihor',3310.0,22.28,46.78).
city('Popesti','ro','Bihor',8386.0,22.42,47.0).
city('Rabagani','ro','Bihor',2269.0,22.23,46.75).
city('Remetea','ro','Bihor',3084.0,22.35,46.73).
city('Rieni','ro','Bihor',3125.0,22.48,46.57).
city('Rosia','ro','Bihor',2594.0,22.4,46.8).
city('Sacadat','ro','Bihor',1882.0,22.15,47.03).
city('Sacueni','ro','Bihor',11443.0,22.1,47.35).
city('Salacea','ro','Bihor',3138.0,22.32,47.47).
city('Salard','ro','Bihor',4109.0,22.05,47.22).
city('Salonta','ro','Bihor',17562.0,21.65,46.8).
city('Sambata','ro','Bihor',1641.0,22.2,46.8).
city('Sanmartin','ro','Bihor',7738.0,21.96,47.01).
city('Santandrei','ro','Bihor',3902.0,21.87,47.07).
city('Sarbi','ro','Bihor',2943.0,22.13,47.18).
city('Simian','ro','Bihor',3977.0,22.1,47.48).
city('Sinteu','ro','Bihor',1267.0,22.48,47.15).
city('Soimi','ro','Bihor',2951.0,22.12,46.68).
city('Spinus','ro','Bihor',1245.0,22.2,47.2).
city('Stei','ro','Bihor',8320.0,22.47,46.54).
city('Suncuius','ro','Bihor',3444.0,22.53,46.93).
city('Suplacu de','ro','Bihor',4517.0,22.53,47.25).
city('Tarcaia','ro','Bihor',2104.0,22.37,46.63).
city('Tarcea','ro','Bihor',2652.0,22.18,47.45).
city('Tauteu','ro','Bihor',4377.0,22.33,47.27).
city('Tetchea','ro','Bihor',3105.0,22.32,47.05).
city('Tileagd','ro','Bihor',6994.0,22.2,47.07).
city('Tinca','ro','Bihor',7335.0,21.95,46.77).
city('Tulca','ro','Bihor',2849.0,21.78,46.78).
city('Uileacu de Beius','ro','Bihor',2436.0,22.23,46.68).
city('Vadu Crisului','ro','Bihor',4311.0,22.52,46.98).
city('Valea lui Mihai','ro','Bihor',10240.0,22.13,47.52).
city('Varciorog','ro','Bihor',2314.0,22.3,46.97).
city('Vascau','ro','Bihor',2722.0,22.48,46.48).
city('Viisoara','ro','Bihor',1344.0,22.45,47.38).
city('Beclean','ro','Bistrita-Nasaud',10909.0,24.18,47.18).
city('Bistrita','ro','Bistrita-Nasaud',81319.0,24.5,47.14).
city('Bistrita Bargaului','ro','Bistrita-Nasaud',4332.0,24.77,47.22).
city('Branistea','ro','Bistrita-Nasaud',3347.0,24.07,47.17).
city('Budacu de Jos','ro','Bistrita-Nasaud',2866.0,24.52,47.08).
city('Budesti','ro','Bistrita-Nasaud',2050.0,24.25,46.88).
city('Caianu Mic','ro','Bistrita-Nasaud',5340.0,24.15,47.23).
city('Cetate','ro','Bistrita-Nasaud',5115.0,24.62,47.13).
city('Chiochis','ro','Bistrita-Nasaud',3520.0,24.18,46.98).
city('Chiuza','ro','Bistrita-Nasaud',2210.0,24.25,47.23).
city('Ciceu-Giurgesti','ro','Bistrita-Nasaud',4285.0,24.02,47.25).
city('Cosbuc','ro','Bistrita-Nasaud',2972.0,24.4,47.37).
city('Dumitra','ro','Bistrita-Nasaud',4482.0,24.48,47.22).
city('Feldru','ro','Bistrita-Nasaud',6967.0,24.6,47.28).
city('Galatii Bistritei','ro','Bistrita-Nasaud',2458.0,24.4,46.98).
city('Ilva Mare','ro','Bistrita-Nasaud',2574.0,24.9,47.37).
city('Ilva Mica','ro','Bistrita-Nasaud',3431.0,24.67,47.32).
city('Josenii Bargaului','ro','Bistrita-Nasaud',5006.0,24.68,47.22).
city('Lechinta','ro','Bistrita-Nasaud',5939.0,24.35,47.02).
city('Lesu','ro','Bistrita-Nasaud',2961.0,24.75,47.32).
city('Livezile','ro','Bistrita-Nasaud',4248.0,24.57,47.18).
city('Lunca Ilvei','ro','Bistrita-Nasaud',3275.0,24.98,47.37).
city('Magura Ilvei','ro','Bistrita-Nasaud',3767.0,24.8,47.38).
city('Mai','ro','Bistrita-Nasaud',7259.0,24.75,47.4).
city('Mariselu','ro','Bistrita-Nasaud',2534.0,24.52,47.02).
city('Matei','ro','Bistrita-Nasaud',2949.0,24.27,46.98).
city('Micestii de Campie','ro','Bistrita-Nasaud',1270.0,24.32,46.87).
city('Milas','ro','Bistrita-Nasaud',1546.0,24.43,46.82).
city('Monor','ro','Bistrita-Nasaud',1581.0,24.7,46.97).
city('Nasaud','ro','Bistrita-Nasaud',10380.0,24.41,47.3).
city('Nimigea','ro','Bistrita-Nasaud',5457.0,24.3,47.27).
city('Nuseni','ro','Bistrita-Nasaud',3221.0,24.2,47.1).
city('Parva','ro','Bistrita-Nasaud',2611.0,24.55,47.4).
city('Prundu Bargaului','ro','Bistrita-Nasaud',6317.0,24.73,47.22).
city('Rebra','ro','Bistrita-Nasaud',3028.0,24.5,47.32).
city('Rebrisoara','ro','Bistrita-Nasaud',4638.0,24.45,47.28).
city('Rodna','ro','Bistrita-Nasaud',6218.0,24.82,47.42).
city('Romuli','ro','Bistrita-Nasaud',1737.0,24.43,47.53).
city('Salva','ro','Bistrita-Nasaud',4368.0,24.35,47.3).
city('Sangeorz-Bai','ro','Bistrita-Nasaud',10254.0,24.68,47.37).
city('Sanmihaiu de Campie','ro','Bistrita-Nasaud',1614.0,24.33,46.9).
city('Sant','ro','Bistrita-Nasau',3312.0,24.9,47.45).
city('Sieu','ro','Bistrita-Nasaud',3103.0,24.6,47.02).
city('Sieu-Magherus','ro','Bistrita-Nasaud',3830.0,24.38,47.08).
city('Sieu-Odorhei','ro','Bistrita-Nasaud',2526.0,24.32,47.15).
city('Sieut','ro','Bistrita-Nasaud',2754.0,24.65,46.98).
city('Silvasu de Campie','ro','Bistrita-Nasaud',1209.0,24.3,46.78).
city('Sintereag','ro','Bistrita-Nasaud',3806.0,24.3,47.18).
city('Spermezeu','ro','Bistrita-Nasaud',2573.0,24.15,47.3).
city('Tarlisua','ro','Bistrita-Nasaud',3693.0,24.18,47.38).
city('Teaca','ro','Bistrita-Nasaud',5954.0,24.52,46.92).
city('Telciu','ro','Bistrita-Nasaud',5314.0,24.4,47.43).
city('Tiha Bargaului','ro','Bistrita-Nasaud',6206.0,24.77,47.23).
city('Uriu','ro','Bistrita-Nasaud',3572.0,24.05,47.2).
city('Urmenis','ro','Bistrita-Nasaud',2253.0,24.37,46.77).
city('Zagra','ro','Bistrita-Nasaud',3725.0,24.28,47.33).
city('Albesti','ro','Botosani',6578.0,27.07,47.7).
city('Avrameni','ro','Botosani',5490.0,26.95,48.02).
city('Baluseni','ro','Botosani',5017.0,26.8,47.67).
city('Botosani','ro','Botosani',114784.0,26.67,47.75).
city('Braesti','ro','Botosani',2222.0,26.45,47.87).
city('Broscauti','ro','Botosani',3430.0,26.45,47.95).
city('Bucecea','ro','Botosani',5143.0,26.43,47.77).
city('Calarasi','ro','Botosani',3962.0,27.27,47.62).
city('Concesti','ro','Botosani',2049.0,26.55,48.17).
city('Copalau','ro','Botosani',7086.0,26.83,47.62).
city('Cordareni','ro','Botosani',2172.0,26.58,47.98).
city('Corlateni','ro','Botosani',4127.0,26.55,47.93).
city('Corni','ro','Botosani',6521.0,26.58,47.65).
city('Cotusca','ro','Botosani',5333.0,26.85,48.13).
city('Cristesti','ro','Botosani',4745.0,26.73,47.63).
city('Cristinesti','ro','Botosani',3866.0,26.38,48.1).
city('Curtesti','ro','Botosani',4331.0,26.65,47.72).
city('Dangeni','ro','Botosani',3094.0,26.97,47.85).
city('Darabani','ro','Botosani',11890.0,26.58,48.18).
city('Dersca','ro','Botosani',5105.0,26.2,47.98).
city('Dobarceni','ro','Botosani',2897.0,27.07,47.82).
city('Dorohoi','ro','Botosani',30776.0,26.4,47.96).
city('Draguseni','ro','Botosani',2762.0,26.82,48.02).
city('Durnesti','ro','Botosani',4144.0,27.1,47.77).
city('Flamanzi','ro','Botosani',11806.0,26.87,47.55).
city('Frumusica','ro','Botosani',6069.0,26.9,47.53).
city('George Enescu','ro','Botosani',3667.0,26.48,48.03).
city('Gorbanesti','ro','Botosani',3587.0,26.85,47.78).
city('Hanesti','ro','Botosani',2339.0,26.98,47.92).
city('Havarna','ro','Botosani',5088.0,26.65,48.07).
city('Hiliseu-Horia','ro','Botosani',3684.0,26.25,48.03).
city('Hlipiceni','ro','Botosani',3756.0,27.15,47.6).
city('Hudesti','ro','Botosani',6360.0,26.5,48.15).
city('Ibanesti','ro','Botosani',4196.0,26.37,48.07).
city('Leorda','ro','Botosani',2734.0,26.45,47.82).
city('Lunca','ro','Botosani',4921.0,26.98,47.62).
city('Manoleasa','ro','Botosani',3705.0,27.08,48.0).
city('Mihail Eminescu','ro','Botosani',6451.0,26.92,47.78).
city('Mihaileni','ro','Botosani',5037.0,26.15,47.97).
city('Mihalaseni','ro','Botosani',2438.0,27.07,47.88).
city('Mileanca','ro','Botosani',2985.0,26.7,48.08).
city('Mitoc','ro','Botosani',2023.0,27.03,48.1).
city('Nicseni','ro','Botosani',2878.0,26.63,47.87).
city('Paltinis','ro','Botosani',3302.0,26.65,48.22).
city('Pomarla','ro','Botosani',2964.0,26.32,48.07).
city('Prajeni','ro','Botosani',3265.0,27.02,47.52).
city('Rachiti','ro','Botosani',4333.0,26.68,47.77).
city('Radauti-Prut','ro','Botosani',3945.0,26.8,48.23).
city('Rauseni','ro','Botosani',2987.0,27.2,47.57).
city('Ripiceni','ro','Botosani',2259.0,27.15,47.95).
city('Roma','ro','Botosani',3218.0,26.6,47.83).
city('Romanesti','ro','Botosani',2198.0,27.28,47.75).
city('Santa-Maria','ro','Botosani',3062.0,27.35,47.62).
city('Saveni','ro','Botosani',8126.0,26.87,47.95).
city('Sendriceni','ro','Botosani',4200.0,26.32,47.95).
city('Stauceni','ro','Botosani',3279.0,26.75,47.72).
city('Stefanesti','ro','Botosani',5607.0,27.18,47.78).
city('Stiubieni','ro','Botosani',2853.0,26.78,47.97).
city('Suharau','ro','Botosani',5356.0,26.42,48.13).
city('Sulita','ro','Botosani',5521.0,26.93,47.65).
city('Todireni','ro','Boto',3579.0,27.12,47.62).
city('Trusesti','ro','Botosani',5748.0,27.02,47.77).
city('Tudora','ro','Botosani',5139.0,26.63,47.52).
city('Ungureni','ro','Botosani',6948.0,26.78,47.88).
city('Unteni','ro','Botosani',3022.0,26.78,47.8).
city('Vaculesti','ro','Botosani',2247.0,26.42,47.88).
city('Varfu Campului','ro','Botosani',3885.0,26.33,47.85).
city('Viisoara','ro','Botosani',2298.0,26.73,48.17).
city('Vladeni','ro','Botosani',4963.0,26.52,47.72).
city('Vlasinesti','ro','Botosani',3380.0,26.88,47.93).
city('Vorniceni','ro','Botosani',4490.0,26.67,47.98).
city('Vorona','ro','Botosani',7992.0,26.62,47.55).
city('Baraganul','ro','Braila',3561.0,27.52,44.8).
city('Bertestii de Jos','ro','Braila',3256.0,27.75,44.83).
city('Bordei Verde','ro','Braila',3016.0,27.57,45.08).
city('Braila','ro','Braila',213570.0,27.97,45.28).
city('Chiscani','ro','Braila',5294.0,27.93,45.18).
city('Ciocile','ro','Braila',3101.0,27.23,44.82).
city('Ciresu','ro','Braila',3523.0,27.35,44.95).
city('Dudesti','ro','Braila',4061.0,27.43,44.9).
city('Faurei','ro','Braila',4043.0,27.27,45.09).
city('Frecatei','ro','Braila',1494.0,28.11,44.89).
city('Galbenu','ro','Braila',3572.0,27.17,45.22).
city('Gemenele','ro','Braila',1899.0,27.62,45.28).
city('Gradistea','ro','Braila',2626.0,27.4,45.27).
city('Gropeni','ro','Braila',3560.0,27.9,45.08).
city('Ianca','ro','Braila',11209.0,27.45,45.13).
city('Insuratei','ro','Braila',7309.0,27.6,44.92).
city('Jirlau','ro','Braila',3397.0,27.17,45.17).
city('Marasu','ro','Braila',3453.0,27.97,44.85).
city('Maxineni','ro','Braila',3758.0,27.63,45.4).
city('Mircea Voda','ro','Braila',3594.0,27.38,45.12).
city('Movila Miresei','ro','Braila',4341.0,27.6,45.22).
city('Racovita','ro','Braila',1395.0,27.45,45.3).
city('Ramnicelu','ro','Braila',2286.0,27.53,45.28).
city('Romanu','ro','Braila',1913.0,27.73,45.28).
city('Rosiori','ro','Braila',3083.0,27.38,44.8).
city('Salcia Tudor','ro','Braila',3017.0,27.52,45.37).
city('Scortaru Nou','ro','Braila',1483.0,27.6,45.32).
city('Silistea','ro','Braila',1855.0,27.85,45.3).
city('Stancuta','ro','Braila',3852.0,27.83,44.9).
city('Surdila-Gaiseanca','ro','Braila',2726.0,27.33,45.07).
city('Surdila-Greci','ro','Braila',1635.0,27.27,45.07).
city('Sutesti','ro','Braila',4740.0,27.43,45.22).
city('Tichilesti','ro','Braila',4270.0,27.9,45.12).
city('Traian','ro','Braila',3684.0,27.73,45.18).
city('Tudor Vladimirescu','ro','Braila',5327.0,27.8,45.22).
city('Tufesti','ro','Braila',5784.0,27.82,45.05).
city('Ulmu','ro','Braila',4397.0,27.32,44.95).
city('Unirea','ro','Braila',2550.0,27.82,45.12).
city('Vadeni','ro','Braila',4173.0,27.93,45.37).
city('Victoria','ro','Braila',3942.0,27.62,44.82).
city('Visani','ro','Braila',2819.0,27.28,45.15).
city('Viziru','ro','Braila',6305.0,27.7,45.02).
city('Zavoaia','ro','Braila',3482.0,27.48,44.95).
city('Apata','ro','Brasov',2929.0,25.52,45.95).
city('Beclean','ro','Brasov',1511.0,24.92,45.83).
city('Bod','ro','Brasov',3839.0,25.65,45.77).
city('Bran','ro','Brasov',5177.0,25.35,45.52).
city('Brasov','ro','Brasov',276089.0,25.61,45.66).
city('Budila','ro','Brasov',3405.0,25.8,45.67).
city('Bunesti','ro','Brasov',2435.0,25.05,46.1).
city('Cata','ro','Brasov',2510.0,25.27,46.08).
city('Cincu','ro','Brasov',1762.0,24.8,45.92).
city('Codlea','ro','Brasov',24188.0,25.44,45.7).
city('Comana','ro','Brasov',2556.0,25.25,45.92).
city('Cristian','ro','Brasov',3849.0,25.47,45.62).
city('Dumbravita','ro','Brasov',4435.0,25.43,45.77).
city('Fagaras','ro','Brasov',34034.0,24.97,45.84).
city('Feldioara','ro','Brasov',6307.0,25.6,45.82).
city('Fundata','ro','Brasov',990.0,25.3,45.45).
city('Ghimbav','ro','Brasov',4967.0,25.5,45.67).
city('Halchiu','ro','Brasov',6051.0,25.55,45.77).
city('Harman','ro','Brasov',4321.0,25.68,45.72).
city('Harseni','ro','Brasov',2199.0,25.02,45.75).
city('Hoghiz','ro','Brasov',4876.0,25.3,45.98).
city('Homorod','ro','Brasov',2344.0,25.27,46.05).
city('Jibert','ro','Brasov',2469.0,25.07,46.0).
city('Lisa','ro','Brasov',1653.0,24.85,45.72).
city('Maierus','ro','Brasov',2472.0,25.53,45.9).
city('Mandra','ro','Brasov',2856.0,25.05,45.82).
city('Moeciu','ro','Brasov',4680.0,25.33,45.48).
city('Ormenis','ro','Brasov',3325.0,25.55,46.02).
city('Parau','ro','Brasov',2092.0,25.18,45.85).
city('Poiana Marului','ro','Brasov',4926.0,25.3,45.6).
city('Predeal','ro','Brasov',5270.0,25.58,45.53).
city('Prejmer','ro','Brasov',8106.0,25.77,45.72).
city('Racos','ro','Brasov',3077.0,25.53,46.08).
city('Rasnov','ro','Brasov',15253.0,25.46,45.6).
city('Recea','ro','Brasov',3213.0,24.93,45.72).
city('Rupea','ro','Brasov',5610.0,25.21,46.05).
city('Sacele','ro','Brasov',29918.0,25.71,45.62).
city('Sanpetru','ro','Brasov',3312.0,25.63,45.72).
city('Sercaia','ro','Brasov',2988.0,25.13,45.83).
city('Sinca','ro','Brasov',3445.0,25.16,45.78).
city('Soars','ro','Brasov',1870.0,24.92,45.93).
city('Tarlungeni','ro','Brasov',7219.0,25.75,45.63).
city('Teliu','ro','Brasov',3610.0,25.85,45.7).
city('Ticusul','ro','Brasov',849.0,25.1,45.93).
city('Ucea','ro','Brasov',2069.0,24.68,45.73).
city('Ungra','ro','Brasov',1983.0,25.27,45.98).
city('Vama Buzaului','ro','Brasov',3289.0,25.98,45.58).
city('Victoria','ro','Brasov',8812.0,24.77,45.73).
city('Vistea','ro','Brasov',3238.0,24.71,45.81).
city('Voila','ro','Brasov',4513.0,24.85,45.82).
city('Vulcan','ro','Brasov',5493.0,25.42,45.63).
city('Zarnesti','ro','Brasov',25126.0,25.35,45.58).
city('Bucharest','ro','Bucharest',1877155.0,26.1,44.44).
city('Amaru','ro','Buzau',2749.0,26.58,44.93).
city('Balaceanu','ro','Buzau',1773.0,27.15,45.27).
city('Balta Alba','ro','Buzau',3080.0,27.28,45.32).
city('Beceni','ro','Buzau',4992.0,26.78,45.38).
city('Berca','ro','Buzau',9479.0,26.68,45.28).
city('Bisoca','ro','Buzau',2915.0,26.7,45.53).
city('Blajani','ro','Buzau',1248.0,26.82,45.32).
city('Boldu','ro','Buzau',2518.0,27.23,45.33).
city('Bozioru','ro','Buzau',1267.0,26.48,45.38).
city('Bradeanu','ro','Buzau',2864.0,26.85,44.93).
city('Braesti','ro','Buzau',2502.0,26.5,45.43).
city('Breaza','ro','Buzau',3127.0,26.53,45.1).
city('Buda','ro','Buzau',3257.0,26.9,45.5).
city('Buzau','ro','Buzau',130955.0,26.82,45.15).
city('Calvini','ro','Buzau',4315.0,26.3,45.25).
city('Canesti','ro','Buzau',1090.0,26.6,45.4).
city('Catina','ro','Buzau',2695.0,26.25,45.3).
city('Cernatesti','ro','Buzau',3982.0,26.77,45.27).
city('Chiliile','ro','Buzau',774.0,26.58,45.45).
city('Chiojdu','ro','Buzau',3791.0,26.2,45.35).
city('Cilibia','ro','Buzau',1909.0,27.07,45.07).
city('Cislau','ro','Buzau',4961.0,26.37,45.25).
city('Cochirleanca','ro','Buzau',5712.0,27.03,45.22).
city('Colti','ro','Buzau',1313.0,26.38,45.38).
city('Constantin Rosetti','ro','Buzau',4205.0,27.17,45.05).
city('Costesti','ro','Buzau',4704.0,26.77,45.05).
city('Cozieni','ro','Buzau',2425.0,26.48,45.33).
city('Galbinasi','ro','Buzau',4013.0,26.92,45.08).
city('Gheraseni','ro','Buzau',3740.0,26.78,45.03).
city('Ghergheasa','ro','Buzau',2726.0,27.2,45.27).
city('Glodeanu-Silistea','ro','Buzau',4585.0,26.8,44.83).
city('Glodeanul Sarat','ro','Buzau',4683.0,26.65,44.87).
city('Grebanu','ro','Buzau',5457.0,26.97,45.38).
city('Gura Teghii','ro','Buzau',3835.0,26.42,45.48).
city('Largu','ro','Buzau',1769.0,27.15,44.97).
city('Lopatari','ro','Buzau',4385.0,26.58,45.48).
city('Luciu','ro','Buzau',2922.0,27.08,44.97).
city('Magura','ro','Buzau',4657.0,26.58,45.27).
city('Manzalesti','ro','Buzau',3005.0,26.65,45.5).
city('Maracineni','ro','Buzau',7096.0,26.8,45.2).
city('Margaritesti','ro','Buzau',866.0,26.83,45.43).
city('Merei','ro','Buzau',7137.0,26.68,45.13).
city('Mihailesti','ro','Buzau',3719.0,26.67,44.92).
city('Movila Banului','ro','Buzau',2760.0,26.68,44.98).
city('Murgesti','ro','Buzau',1140.0,26.88,45.4).
city('Naeni','ro','Buzau',2008.0,26.48,45.1).
city('Nehoiu','ro','Buzau',11350.0,26.3,45.42).
city('Odaile','ro','Buzau',1080.0,26.55,45.38).
city('Padina','ro','Buzau',4774.0,27.12,44.83).
city('Panatau','ro','Buzau',2835.0,26.38,45.32).
city('Pardosi','ro','Buzau',572.0,26.89,45.37).
city('Parscov','ro','Buzau',5968.0,26.55,45.28).
city('Patarlagele','ro','Buzau',8101.0,26.35,45.32).
city('Pietroasele','ro','Buzau',3690.0,26.57,45.1).
city('Podgoria','ro','Buzau',3312.0,27.02,45.42).
city('Pogoanele','ro','Buzau',7778.0,26.98,44.92).
city('Posta Calnau','ro','Buzau',5982.0,26.85,45.23).
city('Puiesti','ro','Buzau',4506.0,27.18,45.4).
city('Racoviteni','ro','Buzau',1462.0,26.9,45.37).
city('Ramnicelu','ro','Buzau',4273.0,27.12,45.36).
city('Ramnicu Sarat','ro','Buzau',38526.0,27.06,45.38).
city('Robeasca','ro','Buzau',1290.0,27.13,45.17).
city('Rusetu','ro','Buzau',4254.0,27.22,44.95).
city('Sageata','ro','Buzau',5427.0,26.98,45.1).
city('Sahateni','ro','Buzau',3333.0,26.52,45.05).
city('Sapoca','ro','Buzau',3156.0,26.75,45.25).
city('Sarulesti','ro','Buzau',1559.0,26.75,45.5).
city('Scortoasa','ro','Buzau',3374.0,26.67,45.37).
city('Scutelnici','ro','Buzau',2615.0,26.92,44.85).
city('Siriu','ro','Buzau',3178.0,26.25,45.5).
city('Smeeni','ro','Buzau',7015.0,26.85,44.98).
city('Stalpu','ro','Buzau',3175.0,26.72,45.08).
city('Tintesti','ro','Buzau',4475.0,26.87,45.07).
city('Tisau','ro','Buzau',5114.0,26.52,45.17).
city('Topliceni','ro','Buzau',4374.0,27.02,45.4).
city('Ulmeni','ro','Buzau',3283.0,26.65,45.07).
city('Vadu Pasii','ro','Buzau',9034.0,26.9,45.17).
city('Valcelele','ro','Buzau',1811.0,26.63,45.08).
city('Valea Ramnicului','ro','Buzau',5702.0,26.67,45.57).
city('Valea Salciei','ro','Buzau',862.0,26.82,45.5).
city('Vernesti','ro','Buzau',8603.0,26.73,45.22).
city('Vintila Voda','ro','Buzau',3367.0,26.72,45.47).
city('Viperesti','ro','Buzau',3600.0,26.47,45.23).
city('Zarnesti','ro','Buzau',5459.0,26.87,45.3).
city('Ziduri','ro','Buzau',4736.0,27.08,45.3).
city('Alexandru Odobescu','ro','Calarasi',3062.0,27.08,44.27).
city('Belciugatele','ro','Calarasi',2322.0,26.43,44.48).
city('Borcea','ro','Calarasi',9546.0,27.75,44.33).
city('Budesti','ro','Calarasi',9598.0,26.45,44.23).
city('Calarasi','ro','Calarasi',69167.0,27.33,44.2).
city('Cascioarele','ro','Calarasi',2132.0,26.47,44.13).
city('Chirnogi','ro','Calarasi',8022.0,26.57,44.12).
city('Chiselet','ro','Calarasi',3535.0,26.85,44.18).
city('Ciocanesti','ro','Calarasi',4931.0,27.07,44.2).
city('Curcani','ro','Calarasi',5167.0,26.58,44.2).
city('Cuza Voda','ro','Calarasi',4296.0,27.27,44.27).
city('Dichiseni','ro','Calarasi',1836.0,27.53,44.23).
city('Dor Marunt','ro','Calarasi',6806.0,26.92,44.45).
city('Dorobantu','ro','Calarasi',3433.0,26.95,44.22).
city('Dragalina','ro','Calarasi',8642.0,27.32,44.43).
city('Dragos Voda','ro','Calarasi',2997.0,27.15,44.43).
city('Frasinet','ro','Calarasi',2023.0,26.8,44.32).
city('Frum','ro','Calarasi',5111.0,26.32,44.3).
city('Fundeni','ro','Calarasi',5443.0,26.35,44.38).
city('Fundulea','ro','Calarasi',6668.0,26.52,44.46).
city('Gradistea','ro','Calarasi',5232.0,27.22,44.23).
city('Gurbanesti','ro','Calarasi',1640.0,26.7,44.38).
city('Ileana','ro','Calarasi',3805.0,26.67,44.52).
city('Independenta','ro','Calarasi',3863.0,27.15,44.28).
city('Jegalia','ro','Calarasi',4751.0,27.63,44.3).
city('Lehliu','ro','Calarasi',2953.0,26.82,44.47).
city('Lehliu-Gara','ro','Calarasi',6538.0,26.85,44.44).
city('Luica','ro','Calarasi',2269.0,26.58,44.23).
city('Lupsanu','ro','Calarasi',3797.0,26.9,44.38).
city('Manastirea','ro','Calarasi',6123.0,26.9,44.22).
city('Mitreni','ro','Calarasi',4831.0,26.6,44.17).
city('Modelu','ro','Calarasi',9672.0,27.38,44.2).
city('Nana','ro','Calarasi',2606.0,26.58,44.27).
city('Nicolae Balcescu','ro','Calarasi',1692.0,26.77,44.45).
city('Oltenita','ro','Calarasi',26356.0,26.63,44.08).
city('Perisoru','ro','Calarasi',5535.0,27.55,44.45).
city('Plataresti','ro','Calarasi',4260.0,26.37,44.35).
city('Radovanu','ro','Calarasi',5065.0,26.52,44.2).
city('Roseti','ro','Calarasi',5843.0,27.43,44.22).
city('Sarulesti','ro','Calarasi',3134.0,26.65,44.42).
city('Sohatu','ro','Calarasi',3511.0,26.5,44.32).
city('Soldanu','ro','Calarasi',3488.0,26.52,44.22).
city('Spantov','ro','Calarasi',4616.0,26.78,44.12).
city('Stefan Voda','ro','Calarasi',2467.0,27.32,44.32).
city('Stefan cel Mare','ro','Calarasi',3217.0,27.4,44.27).
city('Tamadau Mare','ro','Calarasi',2579.0,26.55,44.47).
city('Ulmeni','ro','Calarasi',5285.0,26.72,44.15).
city('Ulmu','ro','Calarasi',1927.0,26.92,44.27).
city('Unirea','ro','Calarasi',2954.0,27.63,44.27).
city('Valcelele','ro','Calarasi',2053.0,27.16,44.38).
city('Valea Argovei','ro','Calarasi',2756.0,26.78,44.35).
city('Vasilati','ro','Calarasi',7840.0,26.43,44.28).
city('Vlad Tepes','ro','Calarasi',2584.0,27.08,44.35).
city('Anina','ro','Caras-Severin',8689.0,21.86,45.08).
city('Armenis','ro','Caras-Severin',2613.0,22.32,45.2).
city('Baile Herculane','ro','Caras-Severin',6022.0,22.43,44.88).
city('Bania','ro','Caras-Severin',1939.0,22.05,44.88).
city('Bautar','ro','Caras-Severin',2731.0,22.55,45.52).
city('Berliste','ro','Caras-Severin',1326.0,21.46,44.99).
city('Berzasca','ro','Caras-Severin',3014.0,21.95,44.65).
city('Berzovia','ro','Caras-Severin',4031.0,21.63,45.43).
city('Bocsa','ro','Caras-Severin',16349.0,21.72,45.37).
city('Bolvasnita','ro','Caras-Severin',1525.0,22.3,45.35).
city('Bozovici','ro','Caras-Severin',3187.0,22.0,44.93).
city('Brebu','ro','Caras-Severin',1292.0,21.98,45.42).
city('Brebu Nou','ro','Caras-Severin',86.0,22.13,45.23).
city('Buchin','ro','Caras-Severin',2073.0,22.25,45.37).
city('Bucosnita','ro','Caras-Severin',3025.0,22.27,45.3).
city('Caransebes','ro','Caras-Severin',27521.0,22.22,45.41).
city('Carasova','ro','Caras-Severin',3153.0,21.87,45.2).
city('Carbunari','ro','Caras-Severin',1236.0,21.75,44.83).
city('Ciclova Romana','ro','Caras-Severin',1758.0,21.7,45.0).
city('Ciuchici','ro','Caras-Severin',1222.0,21.62,44.95).
city('Ciudanovita','ro','Caras-Severin',752.0,21.78,45.15).
city('Constantin Daicoviciu','ro','Caras-Severin',2854.0,22.15,45.55).
city('Copacele','ro','Caras-Severin',1309.0,22.1,45.5).
city('Cornea','ro','Caras-Severin',2098.0,22.32,45.03).
city('Cornereva','ro','Caras-Severin',3291.0,22.42,45.07).
city('Coronini','ro','Caras-Severin',1810.0,21.68,44.68).
city('Dalboset','ro','Caras-Severin',1857.0,21.95,44.87).
city('Doclin','ro','Caras-Severin',1979.0,21.65,45.3).
city('Dognecea','ro','Caras-Severin',1982.0,21.75,45.27).
city('Domasnea','ro','Caras-S',1446.0,22.32,45.08).
city('Eftimie Murgu','ro','Caras-Severin',1761.0,22.09,44.9).
city('Ezeris','ro','Caras-Severin',1362.0,21.88,45.4).
city('Farliug','ro','Caras-Severin',2186.0,21.85,45.49).
city('Forotic','ro','Caras-Severin',1855.0,21.58,45.23).
city('Garnic','ro','Caras-Severin',1480.0,21.79,44.79).
city('Glimboca','ro','Caras-Severin',1865.0,22.32,45.48).
city('Goruia','ro','Caras-Severin',921.0,21.78,45.19).
city('Gradinari','ro','Caras-Severin',2129.0,21.58,45.12).
city('Iablanita','ro','Caras-Severin',2566.0,22.32,44.95).
city('Lapusnicel','ro','Caras-Severin',1279.0,22.23,44.98).
city('Lapusnicu Mare','ro','Caras-Severin',1929.0,21.95,44.9).
city('Luncavita','ro','Caras-Severin',2842.0,22.27,45.08).
city('Lupac','ro','Caras-Severin',2922.0,21.82,45.28).
city('Marga','ro','Caras-Severin',1263.0,22.52,45.5).
city('Maureni','ro','Caras-Severin',2553.0,21.5,45.4).
city('Mehadia','ro','Caras-Severin',4336.0,22.37,44.9).
city('Mehadica','ro','Caras-Severin',891.0,22.27,45.03).
city('Moldova Noua','ro','Caras-Severin',13264.0,21.66,44.74).
city('Naidas','ro','Caras-Severin',1272.0,21.58,44.88).
city('Obreja','ro','Caras-Severin',3136.0,22.25,45.48).
city('Ocna de Fier','ro','Caras-Severin',766.0,21.78,45.33).
city('Oravita','ro','Caras-Severin',12332.0,21.69,45.05).
city('Otelu Rosu','ro','Caras-Severin',11482.0,22.36,45.54).
city('Paltinis','ro','Caras-Severin',2595.0,22.15,45.43).
city('Pojejena','ro','Caras-Severin',3187.0,21.57,44.77).
city('Prigor','ro','Caras-Severin',2880.0,22.12,44.93).
city('Racasdia','ro','Caras-Severin',2101.0,21.63,44.98).
city('Ramna','ro','Caras-Severin',1721.0,21.7,45.43).
city('Resita','ro','Caras-Severin',81229.0,21.89,45.3).
city('Rusca Montana','ro','Caras-Severin',2023.0,22.45,45.57).
city('Sacu','ro','Caras-Severin',1629.0,22.12,45.57).
city('Sasca Montana','ro','Caras-Severin',1830.0,21.73,44.87).
city('Sichevita','ro','Caras-Severin',2643.0,21.87,44.7).
city('Slatina-Timis','ro','Caras-Severin',3037.0,22.28,45.25).
city('Socol','ro','Caras-Severin',2226.0,21.37,44.87).
city('Sopotu Nou','ro','Caras-Severin',1397.0,21.87,44.82).
city('Tarnova','ro','Caras-Severin',1844.0,22.01,45.34).
city('Teregova','ro','Caras-Severin',4207.0,22.28,45.15).
city('Ticvaniu Mare','ro','Caras-Severin',1894.0,21.63,45.13).
city('Toplet','ro','Caras-Severin',2812.0,22.4,44.8).
city('Turnu Ruieni','ro','Caras-Severin',3541.0,22.33,45.38).
city('Valiug','ro','Caras-Severin',953.0,22.03,45.23).
city('Varadia','ro','Caras-Severin',1483.0,21.53,45.08).
city('Vermes','ro','Caras-Severin',1705.0,21.65,45.52).
city('Vrani','ro','Caras-Severin',1215.0,21.48,45.03).
city('Zavoi','ro','Caras-Severin',4205.0,22.42,45.5).
city('Zorlentu Mare','ro','Caras-Severin',1176.0,21.95,45.45).
city('Aghiresu','ro','Cluj',7071.0,23.25,46.88).
city('Aiton','ro','Cluj',1331.0,23.73,46.68).
city('Alunis','ro','Cluj',1370.0,23.75,47.03).
city('Apahida','ro','Cluj',8658.0,23.75,46.82).
city('Aschileu','ro','Cluj',1831.0,23.47,46.98).
city('Baciu','ro','Cluj',8046.0,23.52,46.8).
city('Baisoara','ro','Cluj',2319.0,23.47,46.58).
city('Belis','ro','Cluj',1377.0,23.03,46.65).
city('Bobalna','ro','Cluj',1867.0,23.65,47.16).
city('Bontida','ro','Cluj',4666.0,23.8,46.92).
city('Borsa','ro','Cluj',1841.0,23.67,46.93).
city('Buza','ro','Cluj',1374.0,24.15,46.9).
city('Caianu','ro','Cluj',2536.0,23.92,46.78).
city('Calarasi','ro','Cluj',2544.0,23.87,46.48).
city('Calatele','ro','Cluj',2689.0,23.02,46.77).
city('Camarasu','ro','Cluj',2768.0,24.13,46.78).
city('Campia Turzii','ro','Cluj',26457.0,23.88,46.55).
city('Capusu Mare','ro','Cluj',3645.0,23.3,46.78).
city('Caseiu','ro','Cluj',4791.0,23.87,47.18).
city('Catcau','ro','Cluj',2451.0,23.78,47.2).
city('Catina','ro','Cluj',2177.0,24.18,46.85).
city('Ceanu Mare','ro','Cluj',4247.0,23.95,46.67).
city('Chinteni','ro','Cluj',2746.0,23.53,46.87).
city('Chiuiesti','ro','Cluj',2720.0,23.88,47.3).
city('Ciucea','ro','Cluj',4393.0,22.82,46.95).
city('Ciurila','ro','Cluj',1506.0,23.55,46.65).
city('Cluj-Napoca','ro','Cluj',316749.0,23.59,46.78).
city('Cojocna','ro','Cluj',4336.0,23.83,46.75).
city('Cornesti','ro','Cluj',1797.0,23.68,47.03).
city('Cuzdrioara','ro','Cluj',2944.0,23.92,47.17).
city('Dabaca','ro','Cluj',1798.0,23.67,46.98).
city('Dej','ro','Cluj',38033.0,23.89,47.15).
city('Feleacu','ro','Cluj',3764.0,23.62,46.72).
city('Fizesu Gherlii','ro','Cluj',2614.0,23.98,47.02).
city('Floresti','ro','Cluj',7397.0,23.48,46.73).
city('Frata','ro','Cluj',4323.0,24.05,46.7).
city('Garbau','ro','Cluj',2609.0,23.35,46.83).
city('Geaca','ro','Cluj',1734.0,24.1,46.87).
city('Gherla','ro','Cluj',23741.0,23.9,47.02).
city('Gilau','ro','Cluj',7745.0,23.38,46.75).
city('Huedin','ro','Cluj',9395.0,23.03,46.87).
city('Iara','ro','Cluj',4660.0,23.52,46.55).
city('Iclod','ro','Cluj',4351.0,23.8,46.98).
city('Izvoru Crisului','ro','Cluj',1638.0,23.1,46.83).
city('Jichisu de Jos','ro','Cluj',1305.0,23.8,47.12).
city('Jucu','ro','Cluj',4061.0,23.78,46.85).
city('Luna','ro','Cluj',4369.0,23.92,46.52).
city('Maguri-Racatau','ro','Cluj',2379.0,23.13,46.63).
city('Manastireni','ro','Cluj',1771.0,23.08,46.77).
city('Margau','ro','Cluj',1844.0,22.97,46.75).
city('Marisel','ro','Cluj',1649.0,23.13,46.65).
city('Mica','ro','Cluj',3799.0,23.93,47.13).
city('Mihai Viteazu','ro','Cluj',5659.0,23.75,46.53).
city('Mintiu Gherlii','ro','Cluj',3806.0,23.95,47.05).
city('Mociu','ro','Cluj',3454.0,24.03,46.8).
city('Moldovenesti','ro','Cluj',3618.0,23.65,46.5).
city('Palatca','ro','Cluj',1368.0,23.98,46.85).
city('Panticeu','ro','Cluj',1985.0,23.57,47.03).
city('Petrestii de Jos','ro','Cluj',1861.0,23.65,46.58).
city('Ploscos','ro','Cluj',787.0,23.79,46.56).
city('Poieni','ro','Cluj',5719.0,22.9,46.92).
city('Rasca','ro','Cluj',1742.0,23.1,46.72).
city('Recea Cristur','ro','Cluj',1680.0,23.53,47.07).
city('Sacuieu','ro','Cluj',1617.0,22.93,46.83).
city('Sancraiu','ro','Cluj',1826.0,22.98,46.83).
city('Sandulesti','ro','Cluj',1856.0,23.72,46.58).
city('Sanmartin','ro','Cluj',1721.0,23.57,46.9).
city('Sanpaul','ro','Cluj',2523.0,23.42,46.88).
city('Savadisla','ro','Cluj',4433.0,23.45,46.68).
city('Sic','ro','Cluj',2725.0,23.88,46.93).
city('Suatu','ro','Cluj',1923.0,23.97,46.77).
city('Taga','ro','Cluj',2124.0,24.05,46.95).
city('Tritenii de Jos','ro','Cluj',5008.0,24.0,46.58).
city('Turda','ro','Cluj',54587.0,23.78,46.57).
city('Tureni','ro','Cluj',2545.0,23.7,46.62).
city('Unguras','ro','Cluj',3031.0,24.05,47.12).
city('Vad','ro','Cluj',2118.0,23.75,47.2).
city('Valea Ierii','ro','Cluj',1010.0,23.35,46.65).
city('Viisoara','ro','Cluj',5786.0,23.92,46.55).
city('Vultureni','ro','Cluj',1551.0,23.57,46.97).
city('Adamclisi','ro','Constanta',2247.0,27.95,44.08).
city('Agigea','ro','Constanta',5405.0,28.62,44.08).
city('Albesti','ro','Constanta',3459.0,28.42,43.8).
city('Aliman','ro','Constanta',3015.0,27.85,44.18).
city('Amzacea','ro','Constanta',2647.0,28.4,43.95).
city('Baneasa','ro','Constanta',5280.0,27.7,44.07).
city('Basarabi','ro','Constanta',10906.0,28.42,44.18).
city('Castelu','ro','Constanta',7816.0,28.33,44.25).
city('Cerchezu','ro','Constanta',1548.0,28.1,43.82).
city('Cernavoda','ro','Constanta',18502.0,28.04,44.35).
city('Chirnogeni','ro','Constanta',3533.0,28.23,43.9).
city('Ciobanu','ro','Constanta',3477.0,27.97,44.73).
city('Ciocarlia','ro','Constanta',2998.0,28.28,44.1).
city('Cobadin','ro','Constanta',8979.0,28.22,44.08).
city('Cogealac','ro','Constanta',7046.0,28.57,44.55).
city('Comana','ro','Constanta',1850.0,28.32,43.9).
city('Constanta','ro','Constanta',303401.0,28.63,44.18).
city('Corbu','ro','Constanta',5180.0,28.65,44.4).
city('Costinesti','ro','Constanta',2500.0,28.63,43.95).
city('Crucea','ro','Constanta',3413.0,28.23,44.53).
city('Cumpana','ro','Constanta',9731.0,28.57,44.12).
city('Deleni','ro','Constanta',2492.0,28.02,44.1).
city('Dobromir','ro','Constanta',2597.0,27.78,44.02).
city('Douazeci si Trei August','ro','Constanta',5214.0,28.58,43.92).
city('Dumbraveni','ro','Constanta',605.0,27.98,43.93).
city('Eforie','ro','Constanta',9499.0,28.63,44.07).
city('Garliciu','ro','Constanta',1821.0,28.08,44.77).
city('Ghindaresti','ro','Constanta',2669.0,28.03,44.65).
city('Harsova','ro','Constanta',10055.0,27.95,44.69).
city('Horia','ro','Constanta',1249.0,28.12,44.63).
city('Independenta','ro','Constanta',3145.0,28.08,43.97).
city('Ion Corvin','ro','Constanta',2137.0,27.8,44.12).
city('Istria','ro','Constanta',2591.0,28.72,44.57).
city('Limanu','ro','Constanta',4661.0,28.53,43.8).
city('Lipnita','ro','Constanta',3716.0,27.6,44.1).
city('Lumina','ro','Constanta',7168.0,28.57,44.28).
city('Mangalia','ro','Constanta',39620.0,28.58,43.83).
city('Medgidia','ro','Constanta',43315.0,28.28,44.25).
city('Mereni','ro','Constanta',4155.0,28.37,44.05).
city('Mihai Viteazu','ro','Constanta',3291.0,28.68,44.65).
city('Mihail Kogalniceanu','ro','Constanta',9970.0,28.45,44.37).
city('Mircea Voda','ro','Constanta',6983.0,28.17,44.28).
city('Navodari','ro','Constanta',33107.0,28.61,44.33).
city('Negru Voda','ro','Constanta',5585.0,28.22,43.82).
city('Nicolae Balcescu','ro','Constanta',4813.0,28.38,44.38).
city('Oltina','ro','Constanta',3030.0,27.67,44.17).
city('Ostrov','ro','Constanta',5516.0,27.37,44.12).
city('Ovidiu','ro','Constanta',13258.0,28.56,44.27).
city('Pantelimon','ro','Constanta',1870.0,28.37,44.57).
city('Pecineaga','ro','Constanta',3040.0,28.5,43.9).
city('Pestera','ro','Constanta',3496.0,28.13,44.18).
city('Poarta Alba','ro','Constanta',4739.0,28.4,44.22).
city('Rasova','ro','Constanta',3909.0,27.93,44.25).
city('Sacele','ro','Constanta',2196.0,28.65,44.48).
city('Saraiu','ro','Constanta',1464.0,28.15,44.72).
city('Seimeni','ro','Constanta',2239.0,28.07,44.37).
city('Silistea','ro','Constanta',1442.0,28.17,44.4).
city('Targusor','ro','Constanta',2937.0,28.42,44.45).
city('Techirghiol','ro','Constanta',7083.0,28.6,44.07).
city('Topalu','ro','Constanta',1891.0,28.05,44.55).
city('Topraisar','ro','Constanta',5329.0,28.45,44.02).
city('Tortoman','ro','Constanta',1819.0,28.22,44.35).
city('Tuzla','ro','Constanta',6292.0,28.63,44.0).
city('Valu lui Traian','ro','Constanta',8733.0,28.47,44.17).
city('Vulturu','ro','Constanta',741.0,28.27,44.65).
city('Aita Mare','ro','Covasna',1750.0,25.55,45.97).
city('Baraolt','ro','Covasna',9429.0,25.6,46.09).
city('Barcani','ro','Covasna',3792.0,26.08,45.7).
city('Batani','ro','Covasna',4454.0,25.68,46.08).
city('Belin','ro','Covasna',2612.0,25.57,45.93).
city('Bodoc','ro','Covasna',2466.0,25.85,45.95).
city('Borosneu Mare','ro','Covasna',3063.0,26.0,45.82).
city('Bradut','ro','Covasna',4616.0,25.62,46.13).
city('Brates','ro','Covasna',1525.0,26.07,45.83).
city('Bretcu','ro','Covasna',3866.0,26.3,46.05).
city('Catalina','ro','Covasna',3497.0,26.15,45.97).
city('Cernat','ro','Covasna',3963.0,26.03,45.95).
city('Chichis','ro','Covasna',1676.0,25.8,45.78).
city('Comandau','ro','Covasna',1034.0,26.27,45.77).
city('Covasna','ro','Covasna',10979.0,26.18,45.86).
city('Dobarlau','ro','Covasna',2301.0,25.88,45.73).
city('Ghelinta','ro','Covasna',4702.0,26.23,45.95).
city('Ghidfalau','ro','Covasna',2568.0,25.85,45.9).
city('Haghig','ro','Covasna',2175.0,25.58,45.83).
city('Ilieni','ro','Covasna',1826.0,25.77,45.8).
city('Intorsura Buzaului','ro','Covasna',9026.0,26.03,45.69).
city('Lemnia','ro','Covasna',3416.0,26.27,46.05).
city('Malnas','ro','Covasna',4804.0,25.83,46.02).
city('Moacsa','ro','Covasna',2274.0,25.97,45.87).
city('Ojdula','ro','Covasna',3465.0,26.25,45.98).
city('Ozun','ro','Covasna',4493.0,25.85,45.8).
city('Poian','ro','Covasna',2886.0,26.15,46.07).
city('Reci','ro','Covasna',2204.0,25.93,45.85).
city('Sanzieni','ro','Covasna',4634.0,26.13,46.05).
city('Sfantu Gheorghe','ro','Covasna',60678.0,25.79,45.87).
city('Sita Buzaului','ro','Covasna',4788.0,26.07,45.65).
city('Targu Secuiesc','ro','Covasna',20067.0,26.14,46.0).
city('Turia','ro','Covasna',3846.0,26.05,46.03).
city('Valcele','ro','Covasna',3646.0,25.68,45.85).
city('Valea Crisului','ro','Covasna',3405.0,25.77,45.92).
city('Valea Mare','ro','Covasna',1156.0,26.0,45.77).
city('Varghis','ro','Covasna',1876.0,25.53,46.13).
city('Zabala','ro','Covasna',4729.0,26.18,45.9).
city('Zagon','ro','Covasna',5416.0,26.12,45.77).
city('Aninoasa','ro','Dambovita',5907.0,25.43,44.97).
city('Baleni','ro','Dambovita',8231.0,25.67,44.82).
city('Barbuletu','ro','Dambovita',6777.0,25.3,45.13).
city('Bezdead','ro','Dambovita',5067.0,25.52,45.15).
city('Bilciuresti','ro','Dambovita',1824.0,25.8,44.73).
city('Branesti','ro','Dambovita',9094.0,25.42,45.03).
city('Branistea','ro','Dambovita',4430.0,25.58,44.68).
city('Brezoaiele','ro','Dambovita',4100.0,25.73,44.58).
city('Buciumeni','ro','Dambovita',4604.0,25.45,45.15).
city('Bucsani','ro','Dambovita',6797.0,25.65,44.87).
city('Butimanu','ro','Dambovita',2335.0,25.9,44.68).
city('Candesti','ro','Dambovita',3137.0,25.22,45.08).
city('Ciocanesti','ro','Dambovita',5354.0,25.85,44.6).
city('Cobia','ro','Dambovita',3430.0,25.3,44.73).
city('Cojasca','ro','Dambovita',7205.0,25.85,44.72).
city('Comisani','ro','Dambovita',5401.0,25.58,44.88).
city('Contesti','ro','Dambovita',5495.0,25.63,44.67).
city('Corbii Mari','ro','Dambovita',8257.0,25.5,44.55).
city('Cornatelu','ro','Dambovita',1751.0,25.67,44.75).
city('Cornesti','ro','Dambovita',7616.0,25.87,44.78).
city('Costestii din Vale','ro','Dambovita',3417.0,25.48,44.65).
city('Crangurile de Sus','ro','Dambovita',3428.0,25.23,44.77).
city('Crevedia','ro','Dambovita',6674.0,25.93,44.6).
city('Darmanesti','ro','Dambovita',7919.0,25.78,44.92).
city('Dobra','ro','Dambovita',3806.0,25.72,44.78).
city('Doicesti','ro','Dambovita',4727.0,25.4,44.98).
city('Dragodana','ro','Dambovita',6918.0,25.35,44.73).
city('Dragomiresti','ro','Dambovita',8194.0,25.33,44.92).
city('Edera de Jos','ro','Dambovita',3925.0,25.63,45.03).
city('Fieni','ro','Dambovita',7567.0,25.42,45.14).
city('Finta','ro','Dambovita',4613.0,25.83,44.8).
city('Gaesti','ro','Dambovita',15037.0,25.32,44.73).
city('Glodeni','ro','Dambovita',4367.0,25.47,45.02).
city('Gura Foii','ro','Dambovita',2319.0,25.28,44.75).
city('Gura Ocnitei','ro','Dambovita',7856.0,25.58,44.93).
city('Gura Sutii','ro','Dambovita',5355.0,25.52,44.75).
city('Hulubesti','ro','Dambovita',3428.0,25.23,44.83).
city('Ion luca Caragiale','ro','Dambovita',8982.0,25.7,44.92).
city('Lucieni','ro','Dambovita',6286.0,25.43,44.85).
city('Ludesti','ro','Dambovita',5011.0,25.23,44.87).
city('Lunguletu','ro','Dambovita',5718.0,25.65,44.62).
city('Malu cu Flori','ro','Dambovita',2698.0,25.2,45.15).
city('Manesti','ro','Dambovita',4612.0,25.28,44.97).
city('Matasaru','ro','Dambovita',5722.0,25.42,44.72).
city('Mogosani','ro','Dambovita',4549.0,25.4,44.68).
city('Moreni','ro','Dambovita',20596.0,25.64,45.0).
city('Moroeni','ro','Dambovita',5042.0,25.43,45.22).
city('Morteni','ro','Dambovita',3088.0,25.23,44.67).
city('Motaeni','ro','Dambovita',2210.0,25.42,45.1).
city('Niculesti','ro','Dambovita',4501.0,25.37,45.11).
city('Nucet','ro','Dambovita',4348.0,25.55,44.78).
city('Ocnita','ro','Dambovita',4348.0,25.55,44.98).
city('Odobesti','ro','Dambovita',5211.0,25.57,44.62).
city('Petresti','ro','Dambovita',6020.0,25.33,44.65).
city('Pietrosita','ro','Dambovita',3298.0,25.43,45.18).
city('Poiana','ro','Dambovita',3930.0,25.68,44.57).
city('Potlogi','ro','Dambovita',8299.0,25.58,44.55).
city('Produlesti','ro','Dambovita',3546.0,25.5,44.7).
city('Pucheni','ro','Dambovita',2201.0,25.28,45.18).
city('Pucioasa','ro','Dambovita',14971.0,25.44,45.09).
city('Racari','ro','Dambovita',6828.0,25.73,44.63).
city('Razvad','ro','Dambovita',8305.0,25.53,44.93).
city('Runcu','ro','Dambovita',4435.0,25.38,45.18).
city('Salcioara','ro','Dambovita',4125.0,25.58,44.72).
city('Selaru','ro','Dambovita',3924.0,25.3,44.47).
city('Slobozia Moara','ro','Dambovita',2340.0,25.72,44.6).
city('Sotanga','ro','Dambovita',6939.0,25.37,44.98).
city('Targoviste','ro','Dambovita',88436.0,25.45,44.95).
city('Tartasesti','ro','Dambovita',5066.0,25.82,44.57).
city('Tatarani','ro','Dambovita',5422.0,25.27,45.0).
city('Titu','ro','Dambovita',10081.0,25.55,44.66).
city('Uliesti','ro','Dambovita',4494.0,25.42,44.58).
city('Ulmi','ro','Dambovita',3899.0,25.5,44.9).
city('Vacaresti','ro','Dambovita',7812.0,25.48,44.85).
city('Valea Lunga','ro','Dambovita',5097.0,25.56,45.06).
city('Valea Mare','ro','Dambovita',2533.0,25.23,44.78).
city('Valeni-Dambovita','ro','Dambovita',2934.0,25.18,45.17).
city('Varfuri','ro','Dambovita',2086.0,25.52,45.1).
city('Visina','ro','Dambovita',6604.0,25.33,44.58).
city('Visinesti','ro','Dambovita',2372.0,25.55,45.1).
city('Voinesti','ro','Dambovita',6159.0,25.25,45.07).
city('Vulcana Bai','ro','Dambovita',2972.0,25.38,45.08).
city('Afumati','ro','Dolj',3247.0,23.47,44.0).
city('Almajiu','ro','Dolj',4108.0,23.72,44.45).
city('Amarastii de Jos','ro','Dolj',5870.0,24.17,43.95).
city('Amarastii de Sus','ro','Dolj',3879.0,24.15,43.98).
city('Apele Vii','ro','Dolj',2462.0,24.07,44.07).
city('Argetoaia','ro','Dolj',4862.0,23.37,44.52).
city('Bailesti','ro','Dolj',19599.0,23.35,44.03).
city('Barca','ro','Dolj',4403.0,23.62,43.97).
city('Bechet','ro','Dolj',3824.0,23.95,43.77).
city('Bistret','ro','Dolj',4570.0,23.5,43.9).
city('Botosesti-Paia','ro','Dolj',994.0,23.27,44.4).
city('Brabova','ro','Dolj',1791.0,23.43,44.37).
city('Bradesti','ro','Dolj',4625.0,23.63,44.48).
city('Bralostita','ro','Dolj',3840.0,23.52,44.5).
city('Bratovoesti','ro','Dolj',6055.0,23.9,44.13).
city('Breasta','ro','Dolj',3867.0,23.68,44.33).
city('Bucovat','ro','Dolj',4175.0,23.75,44.3).
city('Bulzesti','ro','Dolj',1944.0,23.88,44.53).
city('Calafat','ro','Dolj',18643.0,22.95,44.0).
city('Calarasi','ro','Dolj',6632.0,24.05,43.8).
city('Calopar','ro','Dolj',3917.0,23.77,44.17).
city('Caraula','ro','Dolj',2628.0,23.25,44.18).
city('Carpen','ro','Dolj',2978.0,23.25,44.33).
city('Castra-Nova','ro','Dolj',3601.0,24.02,44.12).
city('Celaru','ro','Dolj',5326.0,24.13,44.05).
city('Ceratu','ro','Dolj',3851.0,23.67,44.07).
city('Cernatesti','ro','Dolj',2203.0,23.43,44.45).
city('Cetate','ro','Dolj',5908.0,23.05,44.1).
city('Cioroiasiu','ro','Dolj',1977.0,23.45,44.08).
city('Ciupercenii Noi','ro','Dolj',5949.0,22.95,43.9).
city('Cosoveni','ro','Dolj',5024.0,23.92,44.23).
city('Cotofenii din Dos','ro','Dolj',2594.0,23.62,44.43).
city('Craiova','ro','Dolj',304144.0,23.82,44.33).
city('Dabuleni','ro','Dolj',13641.0,24.08,43.8).
city('Daneti','ro','Dolj',7110.0,24.05,43.98).
city('Desa','ro','Dolj',4981.0,23.03,43.87).
city('Diosti','ro','Dolj',3366.0,24.18,44.12).
city('Dobresti','ro','Dolj',2799.0,23.95,43.97).
city('Dragotesti','ro','Dolj',2530.0,24.1,44.25).
city('Dranic','ro','Dolj',3032.0,23.85,44.05).
city('Farcasu','ro','Dolj',3620.0,23.75,44.6).
city('Filiasi','ro','Dolj',18995.0,23.52,44.55).
city('Galicea Mare','ro','Dolj',4812.0,23.3,44.1).
city('Gangiova','ro','Dolj',2966.0,23.85,43.9).
city('Ghercesti','ro','Dolj',1611.0,23.9,44.35).
city('Gighera','ro','Dolj',3609.0,23.8,43.85).
city('Giubega','ro','Dolj',4166.0,23.42,44.12).
city('Giurgita','ro','Dolj',3195.0,23.63,44.02).
city('Gogosu','ro','Dolj',1017.0,23.37,44.42).
city('Goicea','ro','Dolj',4676.0,23.62,43.93).
city('Goiesti','ro','Dolj',3357.0,23.75,44.48).
city('Grecesti','ro','Dolj',2014.0,23.28,44.45).
city('Isalnita','ro','Dolj',3955.0,23.73,44.4).
city('Izvoare','ro','Dolj',2121.0,23.28,44.15).
city('Leu','ro','Dolj',5404.0,24.0,44.18).
city('Lipovu','ro','Dolj',3152.0,23.63,44.1).
city('Macesu de Jos','ro','Dolj',1650.0,23.72,43.88).
city('Macesu de Sus','ro','Dolj',1692.0,23.7,43.92).
city('Maglavit','ro','Dolj',5753.0,23.1,44.03).
city('Malu Mare','ro','Dolj',4995.0,23.87,44.23).
city('Marsani','ro','Dolj',5238.0,24.02,44.02).
city('Melinesti','ro','Dolj',4429.0,23.72,44.57).
city('Mischii','ro','Dolj',1841.0,23.85,44.38).
city('Motatei','ro','Dolj',7898.0,23.2,44.08).
city('Murgasi','ro','Dolj',2750.0,23.87,44.5).
city('Negoi','ro','Dolj',4322.0,23.35,43.9).
city('Orodel','ro','Dolj',3269.0,23.23,44.23).
city('Ostroveni','ro','Dolj',5731.0,23.9,43.8).
city('Perisor','ro','Dolj',1896.0,23.5,44.13).
city('Pielesti','ro','Dolj',3647.0,23.95,44.33).
city('Piscu Vechi','ro','Dolj',5445.0,23.17,43.9).
city('Plenita','ro','Dolj',5260.0,23.18,44.22).
city('Podari','ro','Dolj',6302.0,23.78,44.25).
city('Poiana Mare','ro','Dolj',12633.0,23.07,43.92).
city('Predesti','ro','Dolj',3433.0,23.6,44.35).
city('Radovan','ro','Dolj',3259.0,23.62,44.17).
city('Rastu','ro','Dolj',3757.0,23.28,43.88).
city('Robanesti','ro','Dolj',2759.0,24.02,44.32).
city('Sadova','ro','Dolj',8277.0,23.95,43.9).
city('Salcuta','ro','Dolj',2509.0,23.43,44.25).
city('Scaesti','ro','Dolj',2294.0,23.58,44.47).
city('Seaca de Camp','ro','Dolj',2238.0,23.22,43.93).
city('Seaca de Padure','ro','Dolj',1370.0,23.3,44.37).
city('Secu','ro','Dolj',1319.0,23.3,44.47).
city('Segarcea','ro','Dolj',7944.0,23.74,44.1).
city('Silistea Crucii','ro','Dolj',1826.0,23.48,44.03).
city('Simnicu de Sus','ro','Dolj',4380.0,23.8,44.38).
city('Sopot','ro','Dolj',1985.0,23.5,44.42).
city('Teasc','ro','Dolj',3388.0,23.86,44.16).
city('Terpezita','ro','Dolj',1952.0,23.52,44.28).
city('Teslui','ro','Dolj',2764.0,24.17,44.21).
city('Tuglui','ro','Dolj',2969.0,23.82,44.18).
city('Unirea','ro','Dolj',4225.0,23.18,44.15).
city('Urzicuta','ro','Dolj',3118.0,23.0,44.02).
city('Valea Stanciului','ro','Dolj',6264.0,23.87,43.98).
city('Vartop','ro','Dolj',1818.0,23.35,44.2).
city('Varvoru','ro','Dolj',3344.0,23.63,44.23).
city('Vela','ro','Dolj',2211.0,23.42,44.28).
city('Verbita','ro','Dolj',1583.0,23.17,44.3).
city('Balabanesti','ro','Galati',3976.0,27.72,46.1).
city('Balasesti','ro','Galati',2534.0,27.67,46.1).
city('Baleni','ro','Galati',2696.0,27.83,45.82).
city('Baneasa','ro','Galati',2184.0,27.93,45.93).
city('Barcea','ro','Galati',5985.0,27.47,45.75).
city('Beresti','ro','Galati',3518.0,27.88,46.11).
city('Beresti-Sat','ro','Galati',4352.0,27.88,46.1).
city('Brahasesti','ro','Galati',8214.0,27.37,46.03).
city('Branistea','ro','Galati',4052.0,27.85,45.45).
city('Buciumeni','ro','Galati',2658.0,27.3,46.0).
city('Cavadinesti','ro','Galati',3547.0,28.02,46.07).
city('Certesti','ro','Galati',2506.0,27.62,46.02).
city('Corni','ro','Galati',2481.0,27.77,45.85).
city('Corod','ro','Galati',7855.0,27.62,45.9).
city('Cosmesti','ro','Galati',6526.0,27.3,45.88).
city('Costache Negri','ro','Galati',2582.0,27.72,45.7).
city('Cuca','ro','Galati',2580.0,27.88,45.73).
city('Cudalbi','ro','Galati',8055.0,27.7,45.78).
city('Draganesti','ro','Galati',5874.0,27.47,45.78).
city('Draguseni','ro','Galati',5297.0,27.75,45.97).
city('Fartanesti','ro','Galati',5325.0,27.98,45.82).
city('Foltesti','ro','Galati',3294.0,28.05,45.75).
city('Frumusita','ro','Galati',5206.0,28.07,45.67).
city('Fundeni','ro','Galati',3954.0,27.53,45.53).
city('Galati','ro','Galati',294088.0,28.04,45.44).
city('Ghidigeni','ro','Galati',6294.0,27.5,46.05).
city('Gohor','ro','Galati',3886.0,27.4,46.07).
city('Grivita','ro','Galati',3694.0,27.65,45.72).
city('Independenta','ro','Galati',4728.0,27.75,45.48).
city('Ivesti','ro','Galati',9671.0,27.52,45.68).
city('Jorasti','ro','Galati',1944.0,27.87,45.98).
city('Liesti','ro','Galati',10956.0,27.52,45.62).
city('Mastacani','ro','Galati',5185.0,28.03,45.0).
city('Matca','ro','Galati',11642.0,27.53,45.85).
city('Movileni','ro','Galati',3200.0,27.37,45.75).
city('Munteni','ro','Galati',9760.0,27.43,45.93).
city('Namoloasa','ro','Galati',2373.0,27.55,45.53).
city('Nicoresti','ro','Galati',6147.0,27.28,45.93).
city('Oancea','ro','Galati',1559.0,28.1,45.92).
city('Pechea','ro','Galati',11287.0,27.8,45.63).
city('Piscu','ro','Galati',5002.0,27.73,45.5).
city('Priponesti','ro','Galati',2574.0,27.43,46.07).
city('Rediu','ro','Galati',3855.0,27.83,45.72).
city('Scanteiesti','ro','Galati',2707.0,27.98,45.68).
city('Schela','ro','Galati',3548.0,27.82,45.5).
city('Sendreni','ro','Galati',3126.0,27.92,45.4).
city('Slobozia-Conachi','ro','Galati',7234.0,27.78,45.58).
city('Smardan','ro','Galati',3961.0,27.93,45.48).
city('Smulti','ro','Galati',1611.0,27.75,45.93).
city('Suceveni','ro','Galati',2160.0,28.02,45.98).
city('Targu Bujor','ro','Galati',7532.0,27.9,45.87).
city('Tecuci','ro','Galati',41154.0,27.43,45.86).
city('Tepu','ro','Galati',2538.0,27.37,45.97).
city('Tudor Vladimirescu','ro','Galati',5498.0,27.65,45.57).
city('Tulucesti','ro','Galati',7503.0,28.03,45.57).
city('Umbraresti','ro','Galati',7116.0,27.47,45.72).
city('Valea Marului','ro','Galati',3717.0,27.68,45.83).
city('Vanatori','ro','Galati',4126.0,28.02,45.53).
city('Varlezi','ro','Galati',2185.0,27.85,45.9).
city('Vladesti','ro','Galati',2228.0,28.08,45.85).
city('Adunatii-Copaceni','ro','Giurgiu',6584.0,26.07,44.27).
city('Baneasa','ro','Gi',5582.0,26.05,44.05).
city('Bolintin Deal','ro','Giurgiu',6139.0,25.82,44.47).
city('Bolintinu-din-Vale','ro','Giurgiu',11700.0,25.75,44.45).
city('Bucsani','ro','Giurgiu',3959.0,25.65,44.37).
city('Bulbucata','ro','Giurgiu',1682.0,25.8,44.28).
city('Buturugeni','ro','Giurgiu',4078.0,25.83,44.37).
city('Calugareni','ro','Giurgiu',6444.0,25.98,44.18).
city('Clejani','ro','Giurgiu',3414.0,25.75,44.32).
city('Colibasi','ro','Giurgiu',3823.0,26.18,44.22).
city('Comana','ro','Giurgiu',7717.0,26.13,44.17).
city('Crevedia Mare','ro','Giurgiu',4927.0,25.62,44.43).
city('Daia','ro','Giurgiu',3090.0,25.98,44.0).
city('Floresti-Stoenesti','ro','Giurgiu',8713.0,25.7,44.5).
city('Fratesti','ro','Giurgiu',5527.0,25.97,43.95).
city('Gaiseni','ro','Giurgiu',5455.0,25.65,44.52).
city('Gaujani','ro','Giurgiu',2763.0,25.7,43.73).
city('Ghimpati','ro','Giurgiu',6040.0,25.82,44.23).
city('Giurgiu','ro','Giurgiu',69068.0,25.97,43.9).
city('Gogosari','ro','Giurgiu',2244.0,25.7,43.87).
city('Gostinari','ro','Giurgiu',2720.0,26.23,44.18).
city('Gostinu','ro','Giurgiu',2388.0,26.12,44.0).
city('Gradinari','ro','Giurgiu',3738.0,25.82,44.38).
city('Greaca','ro','Giurgiu',2796.0,26.33,44.12).
city('Hotarele','ro','Giurgiu',8790.0,26.37,44.18).
city('Iepuresti','ro','Giurgiu',2334.0,25.88,44.26).
city('Izvoarele','ro','Giurgiu',4753.0,25.78,44.03).
city('Joita','ro','Giurgiu',8616.0,25.85,44.5).
city('Letca Noua','ro','Giurgiu',3849.0,25.68,44.27).
city('Marsa','ro','Giurgiu',2745.0,25.56,44.37).
city('Mihai Bravu','ro','Giurgiu',2718.0,26.05,44.13).
city('Mihailesti','ro','Giurgiu',7506.0,25.9,44.33).
city('Ogrezeni','ro','Giurgiu',4893.0,25.77,44.42).
city('Oinacu','ro','Giurgiu',3892.0,26.02,43.95).
city('Prundu','ro','Giurgiu',4708.0,26.23,44.1).
city('Putineiu','ro','Giurgiu',2854.0,25.73,43.9).
city('Rasuceni','ro','Giurgiu',3090.0,25.68,44.08).
city('Roata de Jos','ro','Giurgiu',8350.0,25.54,44.41).
city('Schitu','ro','Giurgiu',2227.0,25.84,44.14).
city('Singureni','ro','Giurgiu',3477.0,25.93,44.23).
city('Slobozia','ro','Giurgiu',2626.0,25.9,43.85).
city('Stanesti','ro','Giurgiu',3228.0,25.83,43.92).
city('Stoenesti','ro','Giurgiu',2540.0,25.9,44.15).
city('Toporu','ro','Giurgiu',2536.0,25.65,44.02).
city('Ulmi','ro','Giurgiu',7606.0,25.79,44.47).
city('Valea Dragului','ro','Giurgiu',3214.0,26.3,44.22).
city('Vanatorii Mici','ro','Giurgiu',4965.0,25.56,44.49).
city('Varasti','ro','Giurgiu',6412.0,26.25,44.23).
city('Vedea','ro','Giurgiu',5785.0,25.78,43.78).
city('Albeni','ro','Gorj',2820.0,23.6,45.03).
city('Alimpesti','ro','Gorj',2232.0,23.8,45.08).
city('Aninoasa','ro','Gorj',4288.0,23.48,44.75).
city('Arcani','ro','Gorj',1424.0,23.13,45.08).
city('Baia de Fier','ro','Gorj',4328.0,23.77,45.17).
city('Balanesti','ro','Gorj',2434.0,23.4,45.07).
city('Balesti','ro','Gorj',7333.0,23.22,45.02).
city('Balteni','ro','Gorj',7895.0,23.28,44.87).
city('Barbatesti','ro','Gorj',1886.0,23.5,44.87).
city('Bengesti','ro','Gorj',3504.0,23.6,45.07).
city('Berlesti','ro','Gorj',2367.0,23.67,44.92).
city('Bolbosi','ro','Gorj',3286.0,23.22,44.75).
city('Borascu','ro','Gorj',3641.0,23.28,44.7).
city('Branesti','ro','Gorj',2516.0,23.48,44.67).
city('Bumbesti-Jiu','ro','Gorj',10445.0,23.4,45.17).
city('Bumbesti-Piticu','ro','Gorj',2528.0,23.67,45.12).
city('Bustuchin','ro','Gorj',3660.0,23.73,44.97).
city('Calnic','ro','Gorj',2410.0,23.08,44.95).
city('Capreni','ro','Gorj',2435.0,23.62,44.75).
city('Catunele','ro','Gorj',2604.0,22.93,44.82).
city('Ciuperceni','ro','Gorj',1735.0,23.02,44.93).
city('Crasna','ro','Gorj',5466.0,23.5,45.15).
city('Crusetu','ro','Gorj',3895.0,23.67,44.63).
city('Danciulesti','ro','Gorj',2756.0,23.75,44.73).
city('Danesti','ro','Gorj',3879.0,23.33,44.97).
city('Dragotesti','ro','Gorj',2685.0,23.17,44.8).
city('Dragutesti','ro','Gorj',5126.0,23.23,44.97).
city('Farcasesti','ro','Gorj',3857.0,23.2,44.87).
city('Glogova','ro','Gorj',1980.0,22.91,44.93).
city('Godinesti','ro','Gorj',2426.0,22.97,45.0).
city('Hurezani','ro','Gorj',1826.0,23.65,44.8).
city('Ionesti','ro','Gorj',2505.0,23.43,44.62).
city('Jupanesti','ro','Gorj',2388.0,23.53,44.9).
city('Lelesti','ro','Gorj',1951.0,23.2,45.1).
city('Licuriciu','ro','Gorj',2590.0,23.62,44.92).
city('Logresti','ro','Gorj',3001.0,23.7,44.9).
city('Matasari','ro','Gorj',5411.0,23.08,44.85).
city('Motru','ro','Gorj',22319.0,22.98,44.8).
city('Musetesti','ro','Gorj',2270.0,23.47,45.15).
city('Negomiru','ro','Gorj',3810.0,23.17,44.83).
city('Novaci','ro','Gorj',6033.0,23.67,45.18).
city('Pades','ro','Gorj',5071.0,22.85,45.02).
city('Pestisani','ro','Gorj',4187.0,23.03,45.07).
city('Plopsoru','ro','Gorj',6576.0,23.35,44.78).
city('Polovragi','ro','Gorj',2911.0,23.8,45.18).
city('Prigoria','ro','Gorj',3481.0,23.68,45.07).
city('Rosia de Amaradia','ro','Gorj',3463.0,23.75,45.05).
city('Rovinari','ro','Gorj',12259.0,23.18,44.92).
city('Runcu','ro','Gorj',5760.0,23.13,45.12).
city('Sacelu','ro','Gorj',1834.0,23.53,45.1).
city('Samarinesti','ro','Gorj',1949.0,23.05,44.75).
city('Saulesti','ro','Gorj',2452.0,23.48,44.8).
city('Schela','ro','Gorj',1993.0,23.3,45.17).
city('Scoarta','ro','Gorj',4973.0,23.45,45.02).
city('Slivilesti','ro','Gorj',3778.0,23.13,44.78).
city('Stanesti','ro','Gorj',2647.0,23.25,45.12).
city('Stejari','ro','Gorj',3046.0,23.68,44.77).
city('Stoina','ro','Gorj',2791.0,23.63,44.68).
city('Tantareni','ro','Gorj',5762.0,23.48,44.6).
city('Targu Carbunesti','ro','Gorj',8646.0,23.52,44.97).
city('Targu Jiu','ro','Gorj',97178.0,23.26,45.05).
city('Telesti','ro','Gorj',2779.0,23.08,45.0).
city('Ticleni','ro','Gorj',5250.0,23.4,44.88).
city('Tismana','ro','Gorj',7751.0,22.97,45.05).
city('Turburea','ro','Gorj',4652.0,23.52,44.72).
city('Turceni','ro','Gorj',8458.0,23.38,44.67).
city('Turcinesti','ro','Gorj',2373.0,23.33,45.1).
city('Urdari','ro','Gorj',3162.0,23.28,44.8).
city('Vagiulesti','ro','Gorj',3113.0,23.08,44.72).
city('Vladimir','ro','Gorj',3435.0,23.57,44.83).
city('Atid','ro','Harghita',2797.0,25.05,46.45).
city('Avramesti','ro','Harghita',2481.0,25.02,46.33).
city('Baile Tusnad','ro','Harghita',1675.0,25.86,46.15).
city('Balan','ro','Harghita',7275.0,25.81,46.65).
city('Bilbor','ro','Harghita',2820.0,25.52,47.05).
city('Borsec','ro','Harghita',2815.0,25.57,46.95).
city('Bradesti','ro','Harghita',3510.0,25.35,46.35).
city('Capalnita','ro','Harghita',1954.0,25.52,46.37).
city('Carta','ro','Harghita',5407.0,25.75,46.53).
city('Ciucsangeorgiu','ro','Harghita',4821.0,25.95,46.32).
city('Ciumani','ro','Harghita',4428.0,25.52,46.68).
city('Corbu','ro','Harghita',1579.0,25.7,46.98).
city('Corund','ro','Harghita',6091.0,25.18,46.47).
city('Cristuru Secuiesc','ro','Harghita',9554.0,25.02,46.3).
city('Danesti','ro','Harghita',4455.0,25.74,46.51).
city('Darjiu','ro','Harghita',1160.0,25.2,46.2).
city('Dealu','ro','Harghita',3850.0,25.3,46.4).
city('Ditrau','ro','Harghita',5858.0,25.52,46.82).
city('Feliceni','ro','Harghita',2984.0,25.27,46.27).
city('Frumoasa','ro','Harghita',3599.0,25.85,46.45).
city('Galautas','ro','Harghita',2618.0,25.43,46.92).
city('Gheorgheni','ro','Harghita',19777.0,25.59,46.72).
city('Joseni','ro','Harghita',5635.0,25.5,46.7).
city('Lazarea','ro','Harghita',3555.0,25.53,46.75).
city('Lueta','ro','Harghita',3473.0,25.48,46.27).
city('Lunca de Jos','ro','Harghita',5152.0,25.98,46.57).
city('Lunca de Sus','ro','Harghita',3375.0,25.97,46.53).
city('Lupeni','ro','Harghita',4370.0,25.22,46.38).
city('Martinis','ro','Harghita',2968.0,25.38,46.23).
city('Meresti','ro','Harghita',1395.0,25.45,46.23).
city('Miercurea-Ciuc','ro','Harghita',41282.0,25.81,46.37).
city('Mihaileni','ro','Harghita',2605.0,25.82,46.47).
city('Mugeni','ro','Harghita',5784.0,25.22,46.25).
city('Ocland','ro','Harghita',1383.0,25.42,46.17).
city('Odorheiu Secuiesc','ro','Harghita',36531.0,25.3,46.32).
city('Pauleni-Ciuc','ro','Harghita',1711.0,25.83,46.4).
city('Plaiesii-de-Jos','ro','Harghita',2936.0,26.1,46.22).
city('Praid','ro','Harghita',6738.0,25.13,46.55).
city('Remetea','ro','Harghita',6225.0,25.45,46.78).
city('Sacel','ro','Harghita',1303.0,24.93,46.3).
city('Sancraieni','ro','Harghita',6105.0,25.85,46.3).
city('Sandominic','ro','Harghita',6306.0,25.78,46.58).
city('Sanmartin','ro','Harghita',4272.0,25.93,46.27).
city('Sansimion','ro','Harghita',3397.0,25.88,46.25).
city('Sarmas','ro','Harghita',4074.0,25.47,46.88).
city('Secuieni','ro','Harghita',2622.0,24.98,46.25).
city('Siculeni','ro','Harghita',6806.0,25.75,46.42).
city('Simonesti','ro','Harghita',3685.0,25.1,46.33).
city('Subcetate','ro','Harghita',2075.0,25.45,46.85).
city('Suseni','ro','Harghita',5079.0,25.55,46.67).
city('Toplita','ro','Harghita',15663.0,25.37,46.94).
city('Tulghes','ro','Harghita',3543.0,25.77,46.95).
city('Tusnad','ro','Harghita',2084.0,25.9,46.22).
city('Ulies','ro','Harghita',12.0,25.24,46.21).
city('Varsag','ro','Harghita',1493.0,25.35,46.52).
city('Vlahita','ro','Harghita',6922.0,25.53,46.35).
city('Voslobeni','ro','Harghita',2026.0,25.63,46.65).
city('Zetea','ro','Harghita',5670.0,25.37,46.38).
city('Aninoasa','ro','Hunedoara',4999.0,23.33,45.4).
city('Bacia','ro','Hunedoara',1772.0,23.02,45.8).
city('Baia de Cris','ro','Hunedoara',2987.0,22.72,46.17).
city('Baita','ro','Hunedoara',4183.0,22.9,46.03).
city('Balsa','ro','Hunedoara',1200.0,23.12,46.03).
city('Banita','ro','Hunedoara',1352.0,23.27,45.45).
city('Baru','ro','Hunedoara',3014.0,23.13,45.48).
city('Batrana','ro','Hunedoara',172.0,22.58,45.78).
city('Beriu','ro','Hunedoara',3309.0,23.18,45.78).
city('Berthelot','ro','Hunedoara',1006.0,22.87,45.62).
city('Blajeni','ro','Hunedoara',1516.0,22.9,46.23).
city('Bosorod','ro','Hunedoara',2224.0,23.08,45.68).
city('Brad','ro','Hunedoara',15988.0,22.79,46.13).
city('Branisca','ro','Hunedoara',1808.0,22.78,45.92).
city('Bretea Romana','ro','Hunedoara',3096.0,23.02,45.65).
city('Buces','ro','Hunedoara',2355.0,22.93,46.18).
city('Bucuresci','ro','Hunedoara',1906.0,22.9,46.13).
city('Bulzesti','ro','Hunedoara',400.0,22.73,46.27).
city('Bunila','ro','Hunedoara',455.0,22.67,45.7).
city('Burjuc','ro','Hunedoara',997.0,22.48,45.95).
city('Calan','ro','Hunedoara',12782.0,23.0,45.74).
city('Carjiti','ro','Hunedoara',787.0,22.83,45.85).
city('Cerbal','ro','Hunedoara',655.0,22.72,45.78).
city('Certeju de Sus','ro','Hunedoara',3422.0,22.97,45.97).
city('Criscior','ro','Hunedoara',4232.0,22.87,46.12).
city('Densus','ro','Hunedoara',1756.0,22.8,45.58).
city('Deva','ro','Hunedoara',67802.0,22.91,45.89).
city('Dobra','ro','Hunedoara',3459.0,22.57,45.92).
city('Geoagiu','ro','Hunedoara',5918.0,23.2,45.92).
city('Ghelari','ro','Hunedoara',2304.0,22.78,45.72).
city('Gurasada','ro','Hunedoara',1735.0,22.58,45.95).
city('Harau','ro','Hunedoara',2098.0,22.95,45.9).
city('Hateg','ro','Hunedoara',10865.0,22.95,45.62).
city('Hunedoara','ro','Hunedoara',69136.0,22.92,45.77).
city('Ilia','ro','Hunedoara',3967.0,22.65,45.93).
city('Lapugiu de Jos','ro','Hunedoara',1725.0,22.48,45.88).
city('Lelese','ro','Hunedoara',505.0,22.7,45.73).
city('Lunca Cernii de Jos','ro','Hunedoara',1099.0,22.62,45.63).
city('Luncoiu de Jos','ro','Hunedoara',1997.0,22.77,46.1).
city('Lupeni','ro','Hunedoara',30488.0,23.24,45.36).
city('Martinesti','ro','Hunedoara',1035.0,23.13,45.82).
city('Orastie','ro','Hunedoara',20763.0,23.2,45.85).
city('Orastioara de Sus','ro','Hunedoara',2428.0,23.17,45.73).
city('Pestisu Mic','ro','Hunedoara',1272.0,22.88,45.8).
city('Petrila','ro','Hunedoara',25234.0,23.42,45.45).
city('Petrosani','ro','Hunedoara',44187.0,23.38,45.41).
city('Pui','ro','Hunedoara',4680.0,23.1,45.52).
city('Rachitova','ro','Hunedoara',1467.0,22.75,45.6).
city('Rapoltu Mare','ro','Hunedoara',2040.0,23.07,45.87).
city('Rau de Mori','ro','Hunedoara',3510.0,22.85,45.48).
city('Ribita','ro','Hunedoara',1579.0,22.77,46.18).
city('Romos','ro','Hunedoara',2824.0,23.28,45.83).
city('Salasu de Sus','ro','Hunedoara',2748.0,22.95,45.52).
city('Santamaria Orlea','ro','Hunedoara',3485.0,22.97,45.58).
city('Sarmizegetusa','ro','Hunedoara',1369.0,22.78,45.52).
city('Simeria','ro','Hunedoara',13827.0,23.01,45.85).
city('Soimus','ro','Hunedoara',3502.0,22.88,45.93).
city('Teliucu Inferior','ro','Hunedoara',2527.0,22.88,45.72).
city('Tomesti','ro','Hunedoara',1279.0,22.65,46.22).
city('Toplita','ro','Hunedoara',870.0,22.78,45.68).
city('Totesti','ro','Hunedoara',1990.0,22.88,45.57).
city('Turdas','ro','Hunedoara',1931.0,23.12,45.85).
city('Uricani','ro','Hunedoara',9924.0,23.15,45.33).
city('Valisoara','ro','Hunedoara',1369.0,22.85,46.05).
city('Vata de Jos','ro','Hunedoara',4239.0,22.6,46.18).
city('Vetel','ro','Hunedoara',2722.0,22.8,45.9).
city('Vorta','ro','Hunedoara',1071.0,22.68,46.02).
city('Vulcan','ro','Hunedoara',28869.0,23.29,45.38).
city('Zam','ro','Hunedoara',2121.0,22.45,46.0).
city('Adancata','ro','Ialomita',3083.0,26.43,44.77).
city('Albesti','ro','Ialomita',2702.0,27.13,44.53).
city('Alexeni','ro','Ialomita',2478.0,26.7,44.68).
city('Amara','ro','Ialomita',7557.0,27.32,44.62).
city('Andrasesti','ro','Ialomita',2272.0,27.13,44.57).
city('Armasesti','ro','Ialomita',7243.0,26.58,44.75).
city('Axintele','ro','Ialomita',2912.0,26.78,44.6).
city('Balaciu','ro','Ialomita',3371.0,26.88,44.62).
city('Barcanesti','ro','Ialomita',3936.0,26.65,44.63).
city('Bordusani','ro','Ialomita',5285.0,27.9,44.48).
city('Brazii','ro','Ialomita',3473.0,26.35,44.77).
city('Bucu','ro','Ialomita',5232.0,27.5,44.6).
city('Cazanesti','ro','Ialomita',3604.0,27.02,44.62).
city('Ciocarlia','ro','Ialomita',881.0,26.67,44.8).
city('Ciochina','ro','Ialomita',3573.0,27.07,44.58).
city('Ciulnita','ro','Ialomita',2529.0,27.35,44.53).
city('Cocora','ro','Ialomita',3726.0,27.05,44.73).
city('Cosambesti','ro','Ialomita',3482.0,27.43,44.57).
city('Cosereni','ro','Ialomita',6957.0,26.57,44.68).
city('Dragoesti','ro','Ialomita',1141.0,26.53,44.57).
city('Dridu','ro','Ialomita',5111.0,26.45,44.7).
city('Facaeni','ro','Ialomita',5893.0,27.9,44.57).
city('Fetesti','ro','Ialomita',32867.0,27.84,44.38).
city('Fierbinti-Targ','ro','Ialomita',5198.0,26.35,44.7).
city('Garbovi','ro','Ialomita',4408.0,26.77,44.78).
city('Gheorghe Doja','ro','Ialomita',2822.0,27.27,44.66).
city('Gheorghe Lazar','ro','Ialomita',2476.0,27.45,44.63).
city('Giurgeni','ro','Ialomita',1629.0,27.88,44.77).
city('Grindu','ro','Ialomita',2412.0,26.92,44.77).
city('Grivita','ro','Ialomita',7032.0,27.28,44.73).
city('Io','ro','Ialomita',3689.0,26.77,44.67).
city('Jilavele','ro','Ialomita',3747.0,26.53,44.77).
city('Manasia','ro','Ialomita',4617.0,26.67,44.7).
city('Mihail Kogalniceanu','ro','Ialomita',6181.0,27.73,44.68).
city('Milosesti','ro','Ialomita',3056.0,27.23,44.73).
city('Movila','ro','Ialomita',2195.0,27.7,44.55).
city('Movilita','ro','Ialomita',4766.0,26.48,44.65).
city('Munteni Buzau','ro','Ialomita',3824.0,26.98,44.63).
city('Perieti','ro','Ialomita',3638.0,27.22,44.55).
city('Reviga','ro','Ialomita',3337.0,27.1,44.72).
city('Salcioara','ro','Ialomita',2595.0,26.88,44.53).
city('Saveni','ro','Ialomita',5579.0,27.65,44.6).
city('Scanteia','ro','Ialomita',4312.0,27.47,44.74).
city('Sfantu Gheorghe','ro','Ialomita',2154.0,26.83,44.65).
city('Sinesti','ro','Ialomita',2575.0,26.38,44.57).
city('Slobozia','ro','Ialomita',52693.0,27.38,44.57).
city('Stelnica','ro','Ialomita',1834.0,27.88,44.42).
city('Suditi','ro','Ialomita',2281.0,27.6,44.58).
city('Tandarei','ro','Ialomita',12231.0,27.67,44.65).
city('Urziceni','ro','Ialomita',16771.0,26.65,44.72).
city('Valea Ciorii','ro','Ialomita',1996.0,27.57,44.72).
city('Valea Macrisului','ro','Ialomita',2090.0,26.83,44.75).
city('Vladeni','ro','Ialomita',2230.0,27.88,44.62).
city('Alexandru Ioan Cuza','ro','Iasi',2951.0,26.85,47.13).
city('Andrieseni','ro','Iasi',4501.0,27.28,47.53).
city('Aroneanu','ro','Iasi',2916.0,27.6,47.2).
city('Baltati','ro','Iasi',5061.0,27.15,47.22).
city('Barnova','ro','Iasi',3925.0,27.62,47.07).
city('Belcesti','ro','Iasi',11335.0,27.08,47.3).
city('Bivolari','ro','Iasi',4530.0,27.43,47.53).
city('Braesti','ro','Iasi',3289.0,27.1,47.15).
city('Butea','ro','Iasi',3893.0,26.92,47.07).
city('Ceplenita','ro','Iasi',4533.0,27.02,47.38).
city('Ciortesti','ro','Iasi',4378.0,27.83,46.9).
city('Ciurea','ro','Iasi',10110.0,27.57,47.05).
city('Coarnele Caprei','ro','Iasi',3156.0,27.1,47.38).
city('Comarna','ro','Iasi',4551.0,27.78,47.05).
city('Costuleni','ro','Iasi',4911.0,27.85,47.03).
city('Cotnari','ro','Iasi',7985.0,26.98,47.35).
city('Cozmesti','ro','Iasi',3192.0,27.98,46.88).
city('Cristesti','ro','Iasi',4273.0,26.57,47.27).
city('Cucuteni','ro','Iasi',1454.0,26.93,47.28).
city('Dagata','ro','Iasi',4861.0,27.18,46.93).
city('Deleni','ro','Iasi',10484.0,26.88,47.47).
city('Dobrovat','ro','Iasi',2644.0,27.7,46.95).
city('Dolhesti','ro','Iasi',2821.0,27.9,46.87).
city('Dumesti','ro','Iasi',4732.0,27.35,47.18).
city('Erbiceni','ro','Iasi',5655.0,27.23,47.27).
city('Focuri','ro','Iasi',6030.0,27.22,47.35).
city('Golaesti','ro','Iasi',3797.0,27.7,47.23).
city('Gorban','ro','Iasi',2991.0,28.07,46.88).
city('Grajduri','ro','Iasi',3264.0,27.52,46.97).
city('Gropnita','ro','Iasi',3414.0,27.25,47.35).
city('Grozesti','ro','Iasi',1866.0,28.05,47.0).
city('Halaucesti','ro','Iasi',5819.0,26.8,47.1).
city('Harlau','ro','Iasi',11295.0,26.91,47.44).
city('Helesteni Harmaneasa','ro','Iasi',2652.0,26.87,47.2).
city('Holboca','ro','Iasi',11708.0,27.7,47.15).
city('Horlesti','ro','Iasi',3112.0,27.37,47.12).
city('Iasi','ro','Iasi',318014.0,27.57,47.17).
city('Ipatele','ro','Iasi',2095.0,27.42,46.92).
city('Lespezi','ro','Iasi',6138.0,26.7,47.37).
city('Letcani','ro','Iasi',6642.0,27.42,47.18).
city('Lungani','ro','Iasi',5065.0,27.15,47.18).
city('Madarjac','ro','Iasi',1566.0,27.25,47.05).
city('Mircesti','ro','Iasi',6797.0,26.83,47.08).
city('Mironeasa','ro','Iasi',4324.0,27.42,46.97).
city('Miroslava','ro','Iasi',8127.0,27.52,47.15).
city('Miroslovesti','ro','Iasi',7072.0,26.65,47.15).
city('Mogosesti','ro','Iasi',4946.0,27.53,47.03).
city('Mogosesti-Siret','ro','Iasi',4044.0,26.78,47.13).
city('Mosna','ro','Iasi',1939.0,27.95,46.92).
city('Motca','ro','Iasi',5095.0,26.62,47.25).
city('Movileni','ro','Iasi',3129.0,27.35,47.32).
city('Oteleni','ro','Iasi',3841.0,27.03,47.08).
city('Pascani','ro','Iasi',42203.0,26.72,47.25).
city('Plugari','ro','Iasi',3694.0,27.1,47.48).
city('Podu Iloaiei','ro','Iasi',9752.0,27.27,47.22).
city('Popesti','ro','Iasi',4143.0,27.23,47.15).
city('Popricani','ro','Iasi',6752.0,27.52,47.3).
city('Prisacani','ro','Iasi',3578.0,27.88,47.08).
city('Probota','ro','Iasi',3685.0,27.5,47.38).
city('Raducaneni','ro','Iasi',7706.0,27.93,46.95).
city('Rediu','ro','Iasi',6548.0,27.5,47.22).
city('Romanesti','ro','Iasi',2026.0,27.32,47.28).
city('Ruginoasa','ro','Iasi',6220.0,26.85,47.25).
city('Scanteia','ro','Iasi',4245.0,27.57,46.92).
city('Scheia','ro','Iasi',4742.0,27.52,46.93).
city('Schitu-Duca','ro','Iasi',4347.0,27.77,47.03).
city('Scobinti','ro','Iasi',7618.0,26.93,47.38).
city('Sinesti','ro','Iasi',4264.0,27.18,47.12).
city('Sipote','ro','Iasi',5800.0,27.22,47.47).
city('Siretel','ro','Iasi',4046.0,26.73,47.4).
city('Stolniceni-Prajescu','ro','Iasi',5625.0,26.73,47.2).
city('Strunga','ro','Iasi',4508.0,26.98,47.17).
city('Tansa','ro','Iasi',3081.0,27.23,46.92).
city('Targu Gangiulesti','ro','Iasi',12104.0,27.01,47.21).
city('Tatarusi','ro','Iasi',5651.0,26.6,47.35).
city('Tibana','ro','Iasi',7098.0,27.33,46.98).
city('Tibanesti','ro','Iasi',7662.0,27.33,46.92).
city('Tiganasi','ro','Iasi',4283.0,27.47,47.33).
city('Todiresti','ro','Iasi',6970.0,26.83,47.32).
city('Tomesti','ro','Iasi',11828.0,27.68,47.12).
city('Trifesti','ro','Iasi',5232.0,27.52,47.45).
city('Tutora','ro','Iasi',2126.0,27.78,47.13).
city('Ungheni','ro','Iasi',3983.0,27.78,47.2).
city('Valea Seaca','ro','Iasi',5865.0,26.67,47.28).
city('Vanatori','ro','Iasi',4782.0,27.53,47.23).
city('Victoria','ro','Iasi',4305.0,27.58,47.28).
city('Vladeni','ro','Iasi',4498.0,27.33,47.42).
city('Voinesti','ro','Iasi',6161.0,27.42,47.07).
city('Afumati','ro','Ilfov',6696.0,26.27,44.52).
city('Balotesti','ro','Ilfov',6795.0,26.12,44.62).
city('Berceni','ro','Ilfov',4154.0,26.18,44.32).
city('Bragadiru','ro','Ilfov',8274.0,25.98,44.37).
city('Branesti','ro','Ilfov',8645.0,26.33,44.45).
city('Buftea','ro','Ilfov',20691.0,25.95,44.57).
city('Cernica','ro','Ilfov',9530.0,26.28,44.42).
city('Chiajna','ro','Ilfov',8105.0,25.97,44.47).
city('Chitila','ro','Ilfov',12788.0,25.98,44.52).
city('Ciolpani','ro','Ilfov',4523.0,26.08,44.73).
city('Ciorogarla','ro','Ilfov',4968.0,25.88,44.44).
city('Clinceni','ro','Ilfov',4995.0,25.95,44.37).
city('Corbeanca','ro','Ilfov',3786.0,26.05,44.6).
city('Cornetu','ro','Ilfov',5063.0,25.93,44.35).
city('Darasti-Ilfov','ro','Ilfov',2972.0,26.02,44.32).
city('Dascalu','ro','Ilfov',2594.0,26.23,44.6).
city('Dobroesti','ro','Ilfov',6599.0,26.18,44.45).
city('Domnesti','ro','Ilfov',6393.0,25.92,44.4).
city('Dragomiresti-Vale','ro','Ilfov',4330.0,25.94,44.48).
city('Ganeasa','ro','Ilfov',4240.0,26.28,44.48).
city('Glina','ro','Ilfov',7227.0,26.25,44.38).
city('Gradistea','ro','Ilfov',2924.0,26.28,44.67).
city('Gruiu','ro','Ilfov',7183.0,26.23,44.73).
city('Jilava','ro','Ilfov',12023.0,26.08,44.33).
city('Magurele','ro','Ilfov',9375.0,26.03,44.35).
city('Moara Vlasiei','ro','Ilfov',5912.0,26.22,44.63).
city('Mogosoaia','ro','Ilfov',5304.0,26.0,44.53).
city('Nuci','ro','Ilfov',3174.0,26.3,44.72).
city('Otopeni','ro','Ilfov',10332.0,26.07,44.55).
city('Pantelimon','ro','Ilfov',16206.0,26.2,44.45).
city('Peris','ro','Ilfov',7235.0,26.01,44.68).
city('Petrachioaia','ro','Ilfov',2866.0,26.3,44.58).
city('Popesti-Leordeni','ro','Ilfov',15279.0,26.17,44.38).
city('Prim Decembrie','ro','Ilfov',9537.0,26.06,44.29).
city('Snagov','ro','Ilfov',6126.0,26.18,44.7).
city('Stefanestii de Jos','ro','Ilfov',4183.0,26.2,44.53).
city('Tunari','ro','Ilfov',3859.0,26.15,44.55).
city('Vidra','ro','Ilfov',8322.0,26.15,44.27).
city('Voluntari','ro','Ilfov',30323.0,26.13,44.47).
city('Ardusat','ro','Maramures',2513.0,23.37,47.65).
city('Arinis','ro','Maramures',1192.0,23.23,47.5).
city('Asuaju de Sus','ro','Maramures',1585.0,23.18,47.0).
city('Baia Mare','ro','Maramures',136554.0,23.58,47.66).
city('Baia-Sprie','ro','Maramures',16746.0,23.68,47.67).
city('Baita de sub Codru','ro','Maramures',1910.0,23.15,47.53).
city('Baiut','ro','Maramures',2652.0,24.0,47.62).
city('Barsana','ro','Maramures',6266.0,24.07,47.82).
city('Basesti','ro','Maramures',1586.0,23.15,47.48).
city('Bicaz','ro','Maramures',1272.0,23.03,47.47).
city('Bistra','ro','Maramures',4330.0,24.2,47.87).
city('Bocicoiu Mare','ro','Maramures',4400.0,24.0,47.97).
city('Bogdan Voda','ro','Maramures',3377.0,24.27,47.7).
city('Boiu Mare','ro','Maramures',1254.0,23.58,47.4).
city('Borsa','ro','Maramures',26966.0,24.67,47.65).
city('Botiza','ro','Maramures',2949.0,24.15,47.67).
city('Budesti','ro','Maramures',3437.0,23.95,47.73).
city('Calinesti','ro','Maramures',3354.0,23.98,47.78).
city('Campulung la Tisa','ro','Maramures',2443.0,23.77,47.98).
city('Cavnic','ro','Maramures',5072.0,23.88,47.66).
city('Cernesti','ro','Maramures',3760.0,23.75,47.52).
city('Cicarlau','ro','Maramures',3951.0,23.4,47.7).
city('Copalnic Manastur','ro','Maramures',5747.0,23.68,47.5).
city('Coroieni','ro','Maramures',2308.0,23.77,47.37).
city('Cupseni','ro','Maramures',3727.0,23.93,47.55).
city('Desesti','ro','Maramures',2580.0,23.85,47.77).
city('Dragomiresti','ro','Maramures',3116.0,24.3,47.68).
city('Dumbravita','ro','Maramures',4420.0,23.65,47.6).
city('Farcasa','ro','Maramures',3716.0,23.33,47.58).
city('Giulesti','ro','Maramures',3328.0,23.93,47.82).
city('Grosi','ro','Maramures',2493.0,23.62,47.62).
city('Ieud','ro','Maramures',4139.0,24.23,47.68).
city('Lapus','ro','Maramures',3769.0,24.02,47.5).
city('Leordina','ro','Maramures',2537.0,24.25,47.78).
city('Miresu Mare','ro','Maramures',5054.0,23.33,47.5).
city('Moisei','ro','Maramures',8877.0,24.55,47.65).
city('Oarta de Jos','ro','Maramures',1387.0,23.13,47.45).
city('Ocna Sugatag','ro','Maramures',4147.0,23.93,47.78).
city('Petrova','ro','Maramures',2664.0,24.23,47.83).
city('Poienile Izei','ro','Maramures',1016.0,24.12,47.7).
city('Poienile de sub Munte','ro','Maramures',9865.0,24.43,47.82).
city('Recea','ro','Maramures',5360.0,23.52,47.63).
city('Remetea Chioarului','ro','Maramures',2965.0,23.55,47.53).
city('Remeti','ro','Maramures',3001.0,23.63,47.98).
city('Repedea','ro','Maramures',4688.0,24.4,47.83).
city('Rona de Jos','ro','Maramures',2089.0,24.02,47.92).
city('Rona de Sus','ro','Maramures',4630.0,24.05,47.9).
city('Rozavlea','ro','Maramures',6076.0,24.22,47.73).
city('Ruscova','ro','Maramures',4760.0,24.28,47.8).
city('Sacalaseni','ro','Maramures',5733.0,23.57,47.58).
city('Sacel','ro','Maramures',3723.0,24.43,47.63).
city('Salistea de Sus','ro','Maramures',5119.0,24.35,47.65).
city('Salsig','ro','Maramures',3097.0,23.3,47.53).
city('Sapanta','ro','Maramures',3234.0,23.7,47.97).
city('Sarasau','ro','Maramures',2379.0,23.82,47.95).
city('Satulung','ro','Maramures',5334.0,23.43,47.57).
city('Seini','ro','Maramures',10382.0,23.28,47.76).
city('Sighetu Marmatiei','ro','Maramures',40654.0,23.91,47.93).
city('Sisesti','ro','Maramures',5403.0,23.7,47.63).
city('Somcuta Mare','ro','Maramures',7584.0,23.47,47.52).
city('Stramtura','ro','Maramures',4156.0,24.13,47.78).
city('Suciu de Sus','ro','Maramures',6125.0,24.03,47.43).
city('Targu-Lapus','ro','Maramures',13145.0,23.86,47.46).
city('Tautii Margheraus','ro','Maramures',6597.0,23.48,47.65).
city('Ulmeni','ro','Maramures',7047.0,23.3,47.47).
city('Vadu Izei','ro','Maramures',2794.0,23.88,47.93).
city('Valea Chioarului','ro','Maramures',2252.0,23.48,47.43).
city('Vima Mica','ro','Maramures',1621.0,23.72,47.4).
city('Viseu de Jos','ro','Maramures',5201.0,24.37,47.73).
city('Viseu de Sus','ro','Maramures',16321.0,24.42,47.72).
city('Baclesu','ro','Mehedinti',2730.0,23.13,44.48).
city('Baia de Arama','ro','Mehedinti',5624.0,22.83,45.0).
city('Bala','ro','Mehedinti',4580.0,22.83,44.88).
city('Balacita','ro','Mehedinti',3471.0,23.13,44.38).
city('Balta','ro','Mehedinti',1391.0,22.63,44.9).
city('Balvanesti','ro','Mehedinti',1131.0,22.68,44.8).
city('Breznita Ocol','ro','Mehedinti',4002.0,22.62,44.67).
city('Breznita-Motru','ro','Mehedinti',1760.0,23.22,44.57).
city('Brosteni','ro','Mehedinti',3017.0,23.0,44.75).
city('Burila Mare','ro','Mehedinti',2656.0,22.57,44.45).
city('Butoiesti','ro','Mehedinti',3438.0,23.37,44.58).
city('Cazanesti','ro','Mehedinti',2726.0,22.9,44.72).
city('Ciresu','ro','Mehedinti',813.0,22.55,44.82).
city('Corcova','ro','Mehedinti',5946.0,23.05,44.7).
city('Corlatel','ro','Mehedinti',1552.0,22.93,44.4).
city('Cujmir','ro','Mehedinti',3733.0,22.93,44.22).
city('Darvari','ro','Mehedinti',2990.0,23.05,44.2).
city('Devesel','ro','Mehedinti',3529.0,22.67,44.47).
city('Drobeta-Turnu Severin','ro','Mehedinti',102347.0,22.66,44.64).
city('Dubova','ro','Mehedinti',1073.0,22.27,44.62).
city('Dumbrava','ro','Mehedinti',1861.0,23.12,44.52).
city('Eselnita','ro','Mehedinti',2994.0,22.36,44.7).
city('Floresti','ro','Mehedinti',2832.0,22.95,44.77).
city('Garla Mare','ro','Mehedinti',5258.0,22.77,44.22).
city('Godeanu','ro','Mehedinti',766.0,22.62,44.8).
city('Gogosu','ro','Mehedinti',5309.0,22.58,44.38).
city('Greci','ro','Meh',1508.0,23.12,44.55).
city('Grozesti','ro','Mehedinti',2219.0,23.32,44.65).
city('Gruia','ro','Mehedinti',3126.0,22.7,44.27).
city('Hinova','ro','Mehedinti',2808.0,22.77,44.53).
city('Husnicioara','ro','Mehedinti',1699.0,22.85,44.68).
city('Ilovat','ro','Mehedinti',1547.0,22.77,44.82).
city('Ilovita','ro','Mehedinti',1397.0,22.47,44.76).
city('Isverna','ro','Mehedinti',2476.0,22.63,44.98).
city('Izvoru Barzii','ro','Mehedinti',3059.0,22.67,44.71).
city('Jiana','ro','Mehedinti',4966.0,22.69,44.41).
city('Livezile','ro','Mehedinti',1985.0,22.87,44.52).
city('Malovat','ro','Mehedinti',2943.0,22.73,44.7).
city('Obarsia Noua','ro','Mehedinti',2147.0,22.98,44.17).
city('Obarsia-Closani','ro','Mehedinti',1102.0,22.68,45.02).
city('Oprisor','ro','Mehedinti',3030.0,23.08,44.28).
city('Orsova','ro','Mehedinti',12350.0,22.4,44.72).
city('Padina','ro','Mehedinti',1924.0,23.02,44.43).
city('Patulele','ro','Mehedinti',4395.0,22.78,44.35).
city('Podeni','ro','Mehedinti',1148.0,22.55,44.88).
city('Ponoarele','ro','Mehedinti',2906.0,22.78,44.97).
city('Poroina Mare','ro','Mehedinti',1384.0,22.93,44.48).
city('Pristol','ro','Mehedinti',1774.0,22.72,44.23).
city('Prunisor','ro','Mehedinti',2531.0,22.97,44.63).
city('Punghina','ro','Mehedinti',3322.0,22.93,44.28).
city('Rogova','ro','Mehedinti',1464.0,22.8,44.47).
city('Salcia','ro','Mehedinti',3337.0,22.93,44.15).
city('Simian','ro','Mehedinti',9434.0,22.72,44.62).
city('Sisesti','ro','Mehedinti',3129.0,22.84,44.78).
city('Sovarna','ro','Mehedinti',1416.0,22.8,44.85).
city('Stangaceaua','ro','Mehedinti',1602.0,23.32,44.6).
city('Strehaia','ro','Mehedinti',11607.0,23.2,44.63).
city('Svinita','ro','Mehedinti',1105.0,22.1,44.5).
city('Tamna','ro','Mehedinti',3656.0,23.02,44.57).
city('Vanatori','ro','Mehedinti',4570.0,22.93,44.24).
city('Vanju Mare','ro','Mehedinti',6740.0,22.88,44.44).
city('Vanjulet','ro','Mehedinti',1894.0,22.79,44.44).
city('Vladaia','ro','Mehedinti',2185.0,23.03,44.35).
city('Voloiac','ro','Mehedinti',2038.0,23.1,44.62).
city('Acatari','ro','Mures',4719.0,24.65,46.45).
city('Adamus','ro','Mures',5905.0,24.23,46.3).
city('Albesti','ro','Mures',5382.0,24.85,46.23).
city('Alunis','ro','Mures',3258.0,24.82,46.9).
city('Apold','ro','Mures',2698.0,24.82,46.12).
city('Atintis','ro','Mures',1606.0,24.1,46.43).
city('Bagaciu','ro','Mures',2549.0,24.37,46.27).
city('Bahnea','ro','Mures',3754.0,24.48,46.37).
city('Bala','ro','Mures',889.0,24.5,46.72).
city('Balauseri','ro','Mures',4968.0,24.68,46.4).
city('Band','ro','Mures',7599.0,24.38,46.58).
city('Batos','ro','Mures',4107.0,24.67,46.88).
city('Beica de Jos','ro','Mures',2207.0,24.8,46.73).
city('Bichis','ro','Mures',1023.0,24.1,46.37).
city('Bogata','ro','Mures',1915.0,24.07,46.45).
city('Brancovenesti','ro','Mures',4444.0,24.77,46.87).
city('Breaza','ro','Mures',2492.0,24.63,46.77).
city('Ceuasul-de Campie','ro','Mures',5332.0,24.52,46.63).
city('Chetani','ro','Mures',2844.0,24.03,46.47).
city('Chiheru de Jos','ro','Mures',1720.0,24.88,46.68).
city('Coroisanmartin','ro','Mures',1464.0,24.6,46.4).
city('Cozma','ro','Mures',632.0,24.53,46.82).
city('Craciunesti','ro','Mures',4283.0,24.58,46.48).
city('Craiesti','ro','Mures',1011.0,24.18,46.3).
city('Cristesti','ro','Mures',5507.0,24.48,46.5).
city('Cucerdea','ro','Mures',1680.0,24.27,46.4).
city('Cuci','ro','Mures',2171.0,24.15,46.47).
city('Danes','ro','Mures',4759.0,24.7,46.22).
city('Deda','ro','Mures',4263.0,24.9,46.93).
city('Eremitu','ro','Mures',3818.0,24.93,46.67).
city('Ernei','ro','Mures',5141.0,24.65,46.6).
city('Fantanele','ro','Mures',4981.0,24.75,46.42).
city('Faragau','ro','Mures',1628.0,24.52,46.77).
city('Galesti','ro','Mures',2894.0,24.75,46.52).
city('Ganesti','ro','Mures',3775.0,24.35,46.33).
city('Gheorghe Doja','ro','Mures',2827.0,24.5,46.47).
city('Ghindari','ro','Mures',4997.0,24.92,46.5).
city('Glodeni','ro','Mures',3719.0,24.6,46.65).
city('Gornesti','ro','Mures',5787.0,24.65,46.67).
city('Grebenisu de Campie','ro','Mures',1613.0,24.3,46.6).
city('Gurghiu','ro','Mures',6278.0,24.85,46.77).
city('Hodac','ro','Mures',4892.0,24.92,46.77).
city('Hodosa','ro','Mures',1390.0,24.82,46.63).
city('Ibanesti','ro','Mures',4434.0,24.93,46.77).
city('Iclanzel','ro','Mures',2255.0,24.28,46.53).
city('Ideciu de Jos','ro','Mures',1955.0,24.75,46.8).
city('Iernut','ro','Mures',9343.0,24.24,46.46).
city('Livezeni','ro','Mures',3704.0,24.63,46.55).
city('Ludus','ro','Mures',17165.0,24.09,46.48).
city('Lunca','ro','Mures',2809.0,24.57,46.85).
city('Lunca Bradului','ro','Mures',2123.0,25.1,46.95).
city('Magherani','ro','Mures',2681.0,24.9,46.57).
city('Mica','ro','Mures',4626.0,24.42,46.37).
city('Miercurea Nirajului','ro','Mures',5741.0,24.8,46.53).
city('Mihesu de Campie','ro','Mures',2498.0,24.15,46.68).
city('Nades','ro','Mures',2368.0,24.73,46.32).
city('Neaua','ro','Mures',1521.0,24.83,46.48).
city('Ogra','ro','Mures',2403.0,24.32,46.43).
city('Panet','ro','Mures',5880.0,24.47,46.55).
city('Papiu Ilarian','ro','Mures',997.0,24.2,46.55).
city('Pasareni','ro','Mures',1889.0,24.7,46.48).
city('Petelea','ro','Mures',2735.0,24.72,46.73).
city('Pogaceaua','ro','Mures',1952.0,24.3,46.68).
city('Raciu','ro','Mures',3694.0,24.4,46.68).
city('Rastolita','ro','Mures',2193.0,25.03,46.98).
city('Reghin','ro','Mures',35490.0,24.71,46.78).
city('Rusii Munti','ro','Mures',2216.0,24.85,46.92).
city('Sancraiul-de-Mures','ro','Mures',6161.0,24.5,46.55).
city('Sangeorg-de Mures','ro','Mures',7776.0,24.6,46.57).
city('Sangeorgiu-de-Padure','ro','Mures',5398.0,24.83,46.43).
city('Sanger','ro','Mures',2491.0,24.13,46.55).
city('Sanpaul','ro','Mures',3959.0,24.35,46.45).
city('Sanpetru-de-Campie','ro','Mures',3142.0,24.27,46.72).
city('Santana-de-Mures','ro','Mures',4201.0,24.55,46.57).
city('Sarmasu','ro','Mures',7371.0,24.17,46.75).
city('Saschiz','ro','Mures',2009.0,24.97,46.18).
city('Saulia','ro','Mures',2083.0,24.22,46.63).
city('Sighisoara','ro','Mures',31429.0,24.79,46.22).
city('Sincai','ro','Mures',1614.0,24.38,46.65).
city('Solovastru','ro','Mures',2800.0,24.77,46.77).
city('Sovata','ro','Mures',11465.0,25.08,46.6).
city('Stanceni','ro','Mures',1523.0,25.23,46.98).
city('Suplac','ro','Mures',2332.0,24.52,46.38).
city('Suseni','ro','Mures',2282.0,24.75,46.82).
city('Targu-Mures','ro','Mures',146864.0,24.56,46.55).
city('Tarnaveni','ro','Mures',25721.0,24.27,46.33).
city('Taureni','ro','Mures',1033.0,25.25,46.27).
city('Ungheni','ro','Mures',6449.0,24.47,46.48).
city('Valea Larga','ro','Mures',3326.0,24.07,46.62).
city('Vanatori','ro','Mures',3702.0,24.93,46.23).
city('Vargata','ro','Mures',1976.0,24.8,46.57).
city('Vatava','ro','Mures',2099.0,24.77,46.97).
city('Vetca','ro','Mures',849.0,24.78,46.35).
city('Viisoara','ro','Mures',1635.0,24.6,46.28).
city('Voivodeni','ro','Mures',1930.0,24.63,46.7).
city('Zagar','ro','Mures',1197.0,24.62,46.35).
city('Zau de Campie','ro','Mures',3455.0,24.13,46.6).
city('Agapia','ro','Neamt',4517.0,26.28,47.17).
city('Bahna','ro','Neamt',3713.0,26.78,46.78).
city('Baltatesti','ro','Neamt',6635.0,26.3,47.12).
city('Bara','ro','Neamt',4436.0,27.05,47.03).
city('Bargaoani','ro','Neamt',4203.0,26.63,46.98).
city('Bicaz','ro','Neamt',8340.0,26.09,46.92).
city('Bicaz Chei','ro','Neamt',4618.0,25.88,46.82).
city('Bicazu Ardelean','ro','Neamt',4212.0,25.93,46.85).
city('Bodesti','ro','Neamt',5122.0,26.42,47.04).
city('Borca','ro','Neamt',6556.0,25.77,47.18).
city('Borlesti','ro','Neamt',8965.0,26.48,46.77).
city('Botesti','ro','Neamt',6343.0,26.73,47.05).
city('Bozieni','ro','Neamt',3057.0,27.15,46.83).
city('Brusturi-Draganesti','ro','Neamt',5554.0,26.38,47.28).
city('Candesti','ro','Neamt',4105.0,26.58,46.72).
city('Ceahlau','ro','Neamt',2458.0,25.97,47.05).
city('Cordun','ro','Neamt',7124.0,26.87,46.95).
city('Costisa','ro','Neamt',3540.0,26.65,46.75).
city('Cracaoani','ro','Neamt',4490.0,26.32,47.08).
city('Damuc','ro','Neamt',3084.0,25.9,46.8).
city('Dobreni','ro','Neamt',3641.0,26.42,46.98).
city('Doljesti','ro','Neamt',7359.0,26.98,47.03).
city('Dragomiresti','ro','Neamt',2418.0,26.53,47.02).
city('Dulcesti','ro','Neamt',4856.0,26.77,46.97).
city('Dumbrava Rosie','ro','Neamt',7104.0,26.43,46.88).
city('Farcasa','ro','Neamt',3173.0,25.83,47.17).
city('Faurei','ro','Neamt',2344.0,26.68,46.92).
city('Garcina','ro','Neamt',4330.0,26.3,46.98).
city('Gheraesti','ro','Neamt',6448.0,26.82,47.02).
city('Girov','ro','Neamt',7396.0,26.52,46.95).
city('Grinties','ro','Neamt',2573.0,25.87,47.05).
city('Grumazesti','ro','Neamt',5385.0,26.37,47.13).
city('Hangu','ro','Neamt',4046.0,26.03,47.05).
city('Horia','ro','Neamt',7086.0,26.93,46.9).
city('Icusesti','ro','Neamt',4648.0,26.93,46.8).
city('Ion Creanga','ro','Neamt',5637.0,26.98,46.87).
city('Margineni','ro','Neamt',3995.0,26.63,46.9).
city('Moldoveni','ro','Neamt',2508.0,26.77,46.83).
city('Oniceni','ro','Neamt',3284.0,27.17,46.8).
city('Pangarati','ro','Neamt',5170.0,26.15,46.93).
city('Pastraveni','ro','Neamt',3798.0,26.57,47.17).
city('Petricani','ro','Neamt',5580.0,26.47,47.17).
city('Piatra Neamt','ro','Neamt',102689.0,26.37,46.94).
city('Piatra Soimului','ro','Neamt',7848.0,26.43,46.83).
city('Pipirig','ro','Neamt',8569.0,26.07,47.25).
city('Podoleni','ro','Neamt',5520.0,26.62,46.8).
city('Poiana Teiului','ro','Neamt',5145.0,25.97,47.1).
city('Poienari','ro','Neamt',3273.0,27.12,46.9).
city('Raucesti','ro','Neamt',8204.0,26.42,47.25).
city('Razboieni','ro','Neamt',2381.0,26.53,47.08).
city('Rediu','ro','Neamt',5182.0,26.57,46.75).
city('Roman','ro','Neamt',67820.0,26.93,46.93).
city('Romani','ro','Neamt',4597.0,26.68,46.78).
city('Roznov','ro','Neamt',8688.0,26.52,46.83).
city('Sabaoani','ro','Neamt',10218.0,26.85,47.02).
city('Sagna','ro','Neamt',7443.0,27.02,46.98).
city('Savinesti','ro','Neamt',6012.0,26.47,46.85).
city('Secuieni','ro','Neamt',3607.0,26.47,47.2).
city('Stanita','ro','Neamt',2203.0,27.1,47.02).
city('Stefan cel Mare','ro','Neamt',3386.0,26.52,47.0).
city('Tamaseni','ro','Neamt',8292.0,26.93,46.98).
city('Tarcau','ro','Neamt',3504.0,26.13,46.87).
city('Targu-Neamt','ro','Neamt',20473.0,26.36,47.21).
city('Tasca','ro','Neamt',2682.0,26.02,46.9).
city('Tazlau','ro','Neamt',3002.0,26.47,46.72).
city('Tibucani','ro','Neamt',4403.0,26.57,47.1).
city('Timisesti','ro','Neamt',4004.0,26.55,47.23).
city('Trifesti','ro','Neamt',5018.0,26.82,46.92).
city('Tupilati','ro','Neamt',2388.0,26.63,47.07).
city('Urecheni','ro','Neamt',4007.0,26.52,47.17).
city('Valea Ursului','ro','Neamt',3916.0,27.08,46.82).
city('Vanatori-Neamt','ro','Neamt',8707.0,26.32,47.2).
city('Viisoara','ro','Neamt',5014.0,26.23,46.93).
city('Zanesti','ro','Neamt',6077.0,26.55,46.82).
city('Babiciu','ro','Olt',2337.0,24.57,44.03).
city('Baldovinesti','ro','Olt',3380.0,24.05,44.38).
city('Bals','ro','Olt',20627.0,24.1,44.36).
city('Barasti','ro','Olt',2156.0,24.68,44.62).
city('Barza','ro','Olt',2677.0,24.78,44.33).
city('Bobicesti','ro','Olt',3468.0,24.15,44.38).
city('Brancoveni','ro','Olt',3321.0,24.3,44.32).
city('Brastavatu','ro','Olt',5189.0,24.4,43.92).
city('Brebeni','ro','Olt',2904.0,24.45,44.38).
city('Bucinisu','ro','Olt',2306.0,24.25,43.95).
city('Caracal','ro','Olt',33761.0,24.36,44.13).
city('Carlogani','ro','Olt',2854.0,24.15,44.52).
city('Cezieni','ro','Olt',2187.0,24.27,44.18).
city('Cilieni','ro','Olt',3556.0,24.62,43.9).
city('Colonesti','ro','Olt',2186.0,24.67,44.65).
city('Corabia','ro','Olt',20047.0,24.51,43.79).
city('Corbu','ro','Olt',2586.0,24.72,44.48).
city('Coteana','ro','Olt',2960.0,24.47,44.3).
city('Crampoaia','ro','Olt',3769.0,24.73,44.32).
city('Cungrea','ro','Olt',2542.0,24.38,44.67).
city('Curtisoara','ro','Olt',4583.0,24.33,44.5).
city('Daneasa','ro','Olt',3816.0,24.57,44.15).
city('Deveselu','ro','Olt',3302.0,24.38,44.07).
city('Dobretu','ro','Olt',1502.0,23.95,44.5).
city('Dobrosloveni','ro','Olt',3821.0,24.37,44.18).
city('Dobroteasa','ro','Olt',2121.0,24.38,44.78).
city('Dobrun','ro','Olt',3419.0,24.22,44.27).
city('Draganesti-Olt','ro','Olt',12057.0,24.53,44.17).
city('Draghiceni','ro','Olt',1885.0,24.25,44.13).
city('Fagetelu','ro','Olt',1427.0,24.53,44.78).
city('Falcoiu','ro','Olt',4283.0,24.37,44.23).
city('Farcasele','ro','Olt',5045.0,24.45,44.13).
city('Ganeasa','ro','Olt',4074.0,24.28,44.42).
city('Garcovu','ro','Olt',2684.0,24.63,43.77).
city('Giuvarasti','ro','Olt',2676.0,24.7,43.8).
city('Gostavatu','ro','Olt',3373.0,24.53,44.08).
city('Gradinari','ro','Olt',2489.0,24.28,44.57).
city('Grojdibodu','ro','Olt',3282.0,24.27,43.75).
city('Ianca','ro','Olt',4347.0,24.18,43.78).
city('Iancu Jianu','ro','Olt',4375.0,24.03,44.5).
city('Icoana','ro','Olt',2281.0,24.72,44.42).
city('Izbiceni','ro','Olt',5089.0,24.65,43.83).
city('Izvoarele','ro','Olt',3792.0,24.52,44.27).
city('Leleasca','ro','Olt',1819.0,24.43,44.78).
city('Maruntei','ro','Olt',4397.0,24.47,44.2).
city('Mihaesti','ro','Olt',1957.0,24.8,44.12).
city('Milcov','ro','Olt',3021.0,24.38,44.4).
city('Morunglav','ro','Olt',2958.0,24.12,44.47).
city('Movileni','ro','Olt',3839.0,24.65,44.37).
city('Nicolae Titulescu','ro','Olt',3095.0,24.8,44.3).
city('Obarsia','ro','Olt',3215.0,24.34,43.88).
city('Oboga','ro','Olt',3620.0,24.1,44.42).
city('Oporelu','ro','Olt',1265.0,24.42,44.6).
city('Optasi','ro','Olt',3581.0,24.65,44.58).
city('Orlea','ro','Olt',4591.0,24.38,43.75).
city('Osica de Sus','ro','Olt',5351.0,24.32,44.25).
city('Parscoveni','ro','Olt',4817.0,24.23,44.3).
city('Perieti','ro','Olt',3963.0,24.55,44.42).
city('Piatra Olt','ro','Olt',6313.0,24.3,44.36).
city('Plesoiu','ro','Olt',3365.0,24.27,44.47).
city('Poboru','ro','Olt',2367.0,24.5,44.67).
city('Potcoava','ro','Olt',6022.0,24.63,44.48).
city('Priseaca','ro','Olt',1920.0,24.45,44.52).
city('Radomiresti','ro','Olt',3995.0,24.68,44.12).
city('Redea','ro','Olt',3217.0,24.3,44.05).
city('Rotunda','ro','Olt',3194.0,24.32,43.98).
city('Rusanesti','ro','Olt',4819.0,24.6,43.93).
city('Samburesti','ro','Olt',1458.0,24.42,44.8).
city('Scarisoara','ro','Olt',3221.0,24.57,44.0).
city('Schitu','ro','Olt',3112.0,24.57,44.35).
city('Scornicesti','ro','Olt',12456.0,24.55,44.57).
city('Seaca','ro','Olt',2302.0,24.75,44.17).
city('Serbanesti','ro','Olt',3120.0,24.7,44.35).
city('Slatina','ro','Olt',78989.0,24.36,44.44).
city('Slatioara','ro','Olt',2528.0,24.32,44.4).
city('Spineni','ro','Olt',2359.0,24.57,44.7).
city('Sprancenata','ro','Olt',2983.0,24.63,44.08).
city('Stefan cel Mare','ro','Olt',2093.0,24.22,43.82).
city('Stoenesti','ro','Olt',2391.0,24.5,44.12).
city('Stoicanesti','ro','Olt',3015.0,24.63,44.18).
city('Strejesti','ro','Olt',3404.0,24.27,44.53).
city('Studina','ro','Olt',4723.0,24.42,43.97).
city('Tatulesti','ro','Olt',1324.0,24.63,44.63).
city('Teslui','ro','Olt',2822.0,24.37,44.52).
city('Tia Mare','ro','Olt',4853.0,24.63,43.87).
city('Topana','ro','Olt',1220.0,24.52,44.82).
city('Traian','ro','Olt',3419.0,24.45,44.02).
city('Tufeni','ro','Olt',3286.0,24.78,44.37).
city('Urzica','ro','Olt',2594.0,24.28,43.87).
city('Vadastra','ro','Olt',3631.0,24.37,43.87).
city('Vadastrita','ro','Olt',3715.0,24.33,43.85).
city('Valcele','ro','Olt',2827.0,24.56,44.28).
city('Valea Mare','ro','Olt',3961.0,24.45,44.45).
city('Valeni','ro','Olt',3317.0,24.78,44.23).
city('Verguleasa','ro','Olt',3439.0,24.32,44.65).
city('Visina','ro','Olt',3311.0,24.45,43.87).
city('Vitomiresti','ro','Olt',2678.0,24.37,44.87).
city('Vladila','ro','Olt',2198.0,24.4,44.0).
city('Voineasa','ro','Olt',2310.0,24.15,44.27).
city('Vulpeni','ro','Olt',2669.0,23.92,44.47).
city('Vulturesti','ro','Olt',2790.0,24.32,44.73).
city('Adunati','ro','Prahova',2239.0,25.62,45.13).
city('Albesti-Paleologu','ro','Prahova',5695.0,26.22,44.95).
city('Alunis','ro','Prahova',3677.0,25.87,45.2).
city('Apostolache','ro','Prahova',2311.0,26.27,45.13).
city('Aricestii-Rahtivani','ro','Prahova',8764.0,25.83,44.95).
city('Aricestii-Zeletin','ro','Prahova',1376.0,26.17,45.22).
city('Azuga','ro','Prahova',4961.0,25.55,45.45).
city('Baba Ana','ro','Prahova',4234.0,26.45,44.97).
city('Baicoi','ro','Prahova',19869.0,25.85,45.04).
city('Balta Doamnei','ro','Prahova',2719.0,26.17,44.75).
city('Baltesti','ro','Prahova',3543.0,26.13,45.1).
city('Banesti','ro','Prahova',5636.0,25.77,45.1).
city('Barcanesti','ro','Prahova',9225.0,26.05,44.88).
city('Berceni','ro','Prahova',5976.0,26.12,44.93).
city('Bertea','ro','Prahova',3328.0,25.87,45.23).
city('Blejoi','ro','Prahova',7646.0,26.02,45.0).
city('Boldesti','ro','Prahova',1952.0,26.53,44.87).
city('Boldesti-Scaeni','ro','Prahova',11460.0,26.03,45.03).
city('Brazi','ro','Prahova',8406.0,26.02,44.85).
city('Breaza','ro','Prahova',17949.0,25.65,45.2).
city('Brebu','ro','Prahova',7591.0,25.77,45.18).
city('Bucov','ro','Prahova',10279.0,26.08,44.97).
city('Busteni','ro','Prahova',9907.0,25.55,45.42).
city('Calugareni','ro','Prahova',1425.0,26.38,45.08).
city('Campina','ro','Prahova',38302.0,25.74,45.13).
city('Carbunesti','ro','Prahova',1889.0,26.2,45.23).
city('Ceptura','ro','Prahova',5204.0,26.32,45.02).
city('Cerasu','ro','Prahova',5105.0,26.03,45.32).
city('Chiojdeanca','ro','Prahova',1788.0,26.27,45.17).
city('Ciorani','ro','Prahova',7036.0,26.42,44.82).
city('Cocorastii-Misli','ro','Prahova',3416.0,25.93,45.08).
city('Colceag','ro','Prahova',5473.0,26.35,44.95).
city('Comarnic','ro','Prahova',13255.0,25.64,45.25).
city('Cornu','ro','Prahova',4402.0,25.7,45.15).
city('Cosminele','ro','Prahova',1245.0,25.88,45.15).
city('Doftana','ro','Prahova',6777.0,25.8,45.15).
city('Draganesti','ro','Prahova',5156.0,26.3,44.82).
city('Drajna','ro','Prahova',5660.0,26.05,45.22).
city('Dumbrava','ro','Prahova',4394.0,26.18,44.88).
city('Dumbravesti','ro','Prahova',3664.0,26.0,45.08).
city('Fantanele','ro','Prahova',4053.0,25.87,44.72).
city('Filipestii de Padure','ro','Prahova',10169.0,25.75,45.0).
city('Filipestii de Targ','ro','Prahova',7794.0,25.78,44.98).
city('Floresti','ro','Prahova',7507.0,25.78,45.05).
city('Fulga','ro','Prahova',3819.0,26.43,44.88).
city('Gherghita','ro','Prahova',3968.0,26.27,44.8).
city('Gorgota','ro','Prahova',5459.0,26.08,44.78).
city('Gornet','ro','Prahova',3076.0,26.07,45.12).
city('Gornet-Cricov','ro','Prahova',2651.0,26.27,45.08).
city('Gura Vadului','ro','Prahova',2508.0,26.47,45.05).
city('Gura Vitioarei','ro','Prahova',5947.0,26.02,45.13).
city('Iordacheanu','ro','Prahova',5100.0,26.25,45.05).
city('Izvoarele','ro','Prahova',6836.0,25.27,45.03).
city('Jugureni','ro','Prahova',730.0,26.45,45.1).
city('Lapos','ro','Prahova',1401.0,26.44,45.16).
city('Lipanesti','ro','Prahova',4985.0,26.02,45.05).
city('Magurele','ro','Prahova',4812.0,26.03,45.1).
city('Magureni','ro','Prahova',6515.0,25.73,45.07).
city('Maneciu','ro','Prahova',11033.0,25.98,45.32).
city('Manesti','ro','Prahova',7186.0,25.85,44.87).
city('Mizil','ro','Prahova',15532.0,26.44,45.01).
city('Pacureti','ro','Prahova',2252.0,26.13,45.15).
city('Paulesti','ro','Prahova',5069.0,25.0,45.0).
city('Ploiesti','ro','Prahova',228853.0,26.03,44.94).
city('Plopeni','ro','Prahova',9580.0,25.98,45.07).
city('Plopu','ro','Prahova',2282.0,26.15,45.02).
city('Podenii Noi','ro','Prahova',4644.0,26.17,45.12).
city('Poenarii-Burchi','ro','Prahova',5681.0,26.02,44.75).
city('Poiana Campina','ro','Prahova',5254.0,25.68,45.13).
city('Posesti','ro','Prahova',4218.0,26.12,45.28).
city('Predeal-Sarari','ro','Prahova',2642.0,26.1,45.18).
city('Provita de Jos','ro','Prahova',2513.0,25.65,45.12).
city('Pr','ro','Prahova',2333.0,25.63,45.13).
city('Puchenii Mari','ro','Prahova',8869.0,26.08,44.82).
city('Rafov','ro','Prahova',5472.0,26.13,44.87).
city('Salcia','ro','Prahova',1189.0,26.33,45.18).
city('Salciile','ro','Prahova',2286.0,26.48,44.82).
city('Sangeru','ro','Prahova',5271.0,26.35,45.13).
city('Scorteni','ro','Prahova',5995.0,25.85,45.1).
city('Secaria','ro','Prahova',1341.0,25.68,45.28).
city('Sinaia','ro','Prahova',11918.0,25.54,45.36).
city('Sirna','ro','Prahova',5331.0,25.95,44.8).
city('Slanic','ro','Prahova',6967.0,25.95,45.26).
city('Soimari','ro','Prahova',3127.0,26.2,45.18).
city('Sotrile','ro','Prahova',3530.0,25.72,45.22).
city('Starchiojd','ro','Prahova',6592.0,26.18,45.32).
city('Stefesti','ro','Prahova',2365.0,25.9,45.22).
city('Surani','ro','Prahova',1838.0,26.17,45.2).
city('Talea','ro','Prahova',1184.0,25.55,45.22).
city('Targsorul-Vechi','ro','Prahova',8460.0,25.92,44.87).
city('Tataru','ro','Prahova',1255.0,26.33,45.11).
city('Teisani','ro','Prahova',3968.0,25.98,45.23).
city('Telega','ro','Prahova',6358.0,25.78,45.13).
city('Tinosu','ro','Prahova',2551.0,26.02,44.82).
city('Tomsani','ro','Prahova',4550.0,26.28,44.95).
city('Urlati','ro','Prahova',11798.0,26.23,44.98).
city('Valcanesti','ro','Prahova',3924.0,25.93,45.12).
city('Valea Calugareasca','ro','Prahova',10378.0,26.15,44.97).
city('Valenii de Munte','ro','Prahova',13276.0,26.04,45.2).
city('Varbilau','ro','Prahova',7084.0,25.95,45.18).
city('Agrij','ro','Salaj',1374.0,23.13,47.07).
city('Almasu','ro','Salaj',2801.0,23.13,46.95).
city('Babeni','ro','Salaj',2011.0,23.4,47.3).
city('Balan','ro','Salaj',4050.0,23.33,47.15).
city('Banisor','ro','Salaj',2385.0,22.85,47.12).
city('Benesat','ro','Salaj',1737.0,23.3,47.42).
city('Bobota','ro','Salaj',3950.0,22.77,47.38).
city('Bocsa','ro','Salaj',3394.0,22.92,47.3).
city('Buciumi','ro','Salaj',2776.0,23.07,47.03).
city('Camar','ro','Salaj',1855.0,22.62,47.3).
city('Carastelec','ro','Salaj',1133.0,22.7,47.3).
city('Cehu Silvaniei','ro','Salaj',7832.0,23.28,47.42).
city('Chiesd','ro','Salaj',2577.0,22.88,47.38).
city('Cizer','ro','Salaj',2420.0,22.88,47.07).
city('Coseiu','ro','Salaj',1298.0,22.98,47.32).
city('Crasna','ro','Salaj',6233.0,22.9,47.17).
city('Creaca','ro','Salaj',2987.0,23.25,47.2).
city('Criseni','ro','Salaj',2390.0,23.05,47.23).
city('Cristolt','ro','Salaj',1516.0,23.43,47.2).
city('Cuzaplac','ro','Salaj',1999.0,23.2,46.97).
city('Dobrin','ro','Salaj',1736.0,23.13,47.28).
city('Dragu','ro','Salaj',1545.0,23.4,47.02).
city('Fildu de Jos','ro','Salaj',1542.0,23.07,46.93).
city('Galgau','ro','Salaj',2718.0,23.33,47.2).
city('Garbou','ro','Salaj',2402.0,23.43,47.15).
city('Halmasd','ro','Salaj',2578.0,22.62,47.15).
city('Hereclean','ro','Salaj',3685.0,23.02,47.25).
city('Hida','ro','Salaj',3083.0,23.28,47.07).
city('Horoatu Crasnei','ro','Salaj',2789.0,22.88,47.13).
city('Ileanda','ro','Salaj',2546.0,23.63,47.33).
city('Ip','ro','Salaj',3833.0,22.65,47.23).
city('Jibou','ro','Salaj',11183.0,23.25,47.27).
city('Letca','ro','Salaj',2185.0,23.45,47.33).
city('Lozna','ro','Salaj',1187.0,23.47,47.32).
city('Maeriste','ro','Salaj',3436.0,22.8,47.32).
city('Marca','ro','Salaj',2890.0,22.57,47.22).
city('Mesesenii de Jos','ro','Salaj',3017.0,22.98,47.15).
city('Mirsid','ro','Salaj',2246.0,23.13,47.23).
city('Napradea','ro','Salaj',2961.0,23.32,47.37).
city('Nusfalau','ro','Salaj',5436.0,22.73,47.2).
city('Periceiu','ro','Salaj',3922.0,22.88,47.23).
city('Plopis','ro','Salaj',2731.0,22.68,47.13).
city('Poiana Blenchii','ro','Salaj',1311.0,23.75,47.3).
city('Romanasi','ro','Salaj',2932.0,23.18,47.1).
city('Rus','ro','Salaj',2608.0,23.6,47.28).
city('Sag','ro','Salaj',3391.0,22.82,47.08).
city('Salatig','ro','Salaj',3094.0,23.13,47.37).
city('Samsud','ro','Salaj',1725.0,22.95,47.35).
city('Sanmihaiul-Almasului','ro','Salaj',1758.0,23.3,47.02).
city('Sarmasag','ro','Salaj',6400.0,22.83,47.35).
city('Simleu Silvaniei','ro','Salaj',15721.0,22.8,47.23).
city('Somes-Odorhei','ro','Salaj',2993.0,23.27,47.32).
city('Surduc','ro','Salaj',3934.0,23.35,47.25).
city('Treznea','ro','Salaj',1012.0,23.12,47.1).
city('Valcau de Jos','ro','Salaj',3232.0,22.73,47.12).
city('Varsolt','ro','Salaj',2406.0,22.93,47.2).
city('Zalau','ro','Salaj',63232.0,23.06,47.18).
city('Zalha','ro','Salaj',1152.0,23.53,47.18).
city('Zimbor','ro','Salaj',1262.0,23.27,47.0).
city('Acas','ro','Satu Mare',2819.0,22.78,47.53).
city('Andrid','ro','Satu Mare',2627.0,22.35,47.52).
city('Apa','ro','Satu Mare',2842.0,23.2,47.77).
city('Ardud','ro','Satu Mare',6357.0,22.88,47.63).
city('Barsau','ro','Satu Mare',2452.0,23.21,47.61).
city('Batarci','ro','Satu Mare',3681.0,23.17,48.03).
city('Beltiug','ro','Satu Mare',3233.0,22.85,47.55).
city('Berveni','ro','Satu Mare',3536.0,22.47,47.75).
city('Bixad','ro','Satu Mare',73.0,23.4,47.93).
city('Bogdand','ro','Satu Mare',3179.0,22.93,47.42).
city('Botiz','ro','Satu Mare',4779.0,22.95,47.83).
city('Calinesti-Oas','ro','Satu Mare',4654.0,23.3,47.9).
city('Camarzana','ro','Satu Mare',2591.0,23.32,48.0).
city('Capleni','ro','Satu Mare',4424.0,22.5,47.72).
city('Carei','ro','Satu Mare',22583.0,22.47,47.69).
city('Cauas','ro','Satu Mare',2497.0,22.55,47.57).
city('Cehal','ro','Satu Mare',1976.0,22.6,47.38).
city('Certeze','ro','Satu Mare',5330.0,23.47,47.9).
city('Craidorolt','ro','Satu Mare',2151.0,22.7,47.62).
city('Crucisor','ro','Satu Mare',2471.0,23.25,47.68).
city('Culciu','ro','Satu Mare',3941.0,23.03,47.77).
city('Doba','ro','Satu Mare',2727.0,22.72,47.73).
city('Dorolt','ro','Satu Mare',3426.0,22.82,47.85).
city('Foeni','ro','Satu Mare',1836.0,22.38,47.7).
city('Gherta Mica','ro','Satu Mare',3188.0,23.23,47.93).
city('Halmeu','ro','Satu Mare',7184.0,23.02,47.97).
city('Hodod','ro','Satu Mare',3131.0,23.03,47.4).
city('Homorod-de Jos','ro','Satu Mare',2019.0,23.07,47.63).
city('Lazuri','ro','Satu Mare',5237.0,22.87,47.85).
city('Livada','ro','Satu Mare',6833.0,23.13,47.87).
city('Mediesu Aurit','ro','Satu Mare',7122.0,23.15,47.78).
city('Micula','ro','Satu Mare',3707.0,22.95,47.9).
city('Moftinu Mare','ro','Satu Mare',4242.0,22.67,47.67).
city('Negresti-Oas','ro','Satu Mare',13456.0,23.44,47.87).
city('Odoreu','ro','Satu Mare',4765.0,23.0,47.8).
city('Orasu Nou','ro','Satu Mare',6737.0,23.28,47.83).
city('Paulesti','ro','Satu Mare',4258.0,22.92,47.78).
city('Petresti','ro','Satu Mare',1646.0,22.37,47.6).
city('Pir','ro','Satu Mare',1738.0,22.37,47.47).
city('Piscolt','ro','Satu Mare',3199.0,22.3,47.58).
city('Pomi','ro','Satu Mare',2312.0,23.32,47.7).
city('Sacaseni','ro','Satu Mare',1319.0,22.68,47.48).
city('Sanislau','ro','Satu Mare',5072.0,22.33,47.63).
city('Santau','ro','Satu Mare',2580.0,22.52,47.52).
city('Satu Mare','ro','Satu Mare',112491.0,22.89,47.79).
city('Sauca','ro','Satu Mare',1434.0,22.48,47.47).
city('Socond','ro','Satu Mare',2535.0,22.95,47.57).
city('Supuru de Jos','ro','Satu Mare',4598.0,22.77,47.43).
city('Tarna Mare','ro','Satu Mare',3661.0,23.02,47.83).
city('Tarsolt','ro','Satu Mare',2973.0,23.35,47.95).
city('Tasnad','ro','Satu Mare',9467.0,22.59,47.48).
city('Terebesti','ro','Satu Mare',1551.0,22.72,47.68).
city('Tiream','ro','Satu Mare',2317.0,22.47,47.62).
city('Turt','ro','Satu Mare',6693.0,23.22,47.98).
city('Turulung','ro','Satu Mare',3815.0,23.08,47.93).
city('Urziceni','ro','Satu Mare',1479.0,22.4,47.73).
city('Valea Vinului','ro','Satu Mare',2221.0,23.18,47.72).
city('Vama','ro','Satu Mare',3576.0,23.4,47.83).
city('Vetis','ro','Satu Mare',4365.0,22.77,47.8).
city('Viile Satu Mare','ro','Satu Mare',3178.0,22.95,47.67).
city('Agnita','ro','Sibiu',10505.0,24.61,45.97).
city('Altina','ro','Sibiu',1587.0,24.47,45.93).
city('Apoldu de Jos','ro','Sibiu',1506.0,23.85,45.87).
city('Arpasu de Jos','ro','Sibiu',2733.0,24.62,45.78).
city('Atel','ro','Sibiu',3576.0,24.47,46.15).
city('Avrig','ro','Sibiu',14032.0,24.38,45.74).
city('Axente Sever','ro','Sibiu',3960.0,24.22,46.1).
city('Barghis','ro','Sibiu',2116.0,24.53,45.98).
city('Bazna','ro','Sibiu',3824.0,24.28,46.2).
city('Biertan','ro','Sibiu',2939.0,24.52,46.13).
city('Blajel','ro','Sibiu',2419.0,24.32,46.22).
city('Bradeni','ro','Sibiu',1470.0,24.83,46.08).
city('Brateiu','ro','Sibiu',3126.0,24.42,46.17).
city('Bruiu','ro','Sibiu',782.0,24.7,45.87).
city('Carta','ro','Sibiu',928.0,24.57,45.78).
city('Cartisoara','ro','Sibiu',1133.0,24.58,45.72).
city('Chirpar','ro','Sibiu',1448.0,24.6,45.9).
city('Cisnadie','ro','Sibiu',15042.0,24.15,45.72).
city('Copsa Mica','ro','Sibiu',5350.0,24.25,46.11).
city('Cristian','ro','Sibiu',3437.0,24.03,45.78).
city('Darlos','ro','Sibiu',3212.0,24.4,46.18).
city('Dumbraveni','ro','Sibiu',8167.0,24.58,46.24).
city('Gura Raului','ro','Sibiu',3546.0,23.98,45.73).
city('Hoghilag','ro','Sibiu',2110.0,24.62,46.23).
city('Iacobeni','ro','Sibiu',2637.0,24.72,46.05).
city('Jina','ro','Sibiu',4013.0,23.68,45.78).
city('Laslea','ro','Sibiu',3147.0,24.65,46.22).
city('Loamnes','ro','Sibiu',3231.0,24.1,45.93).
city('Ludos','ro','Sibiu',786.0,23.9,45.92).
city('Marpod','ro','Sibiu',840.0,24.5,45.87).
city('Medias','ro','Sibiu',53041.0,24.36,46.17).
city('Merghindeal','ro','Sibiu',1256.0,24.73,45.97).
city('Micasasa','ro','Sibiu',2384.0,24.12,46.08).
city('Miercurea Sibiului','ro','Sibiu',3981.0,23.8,45.88).
city('Mihaileni','ro','Sibiu',1050.0,24.35,45.98).
city('Mosna','ro','Sibiu',3187.0,24.4,46.08).
city('Nocrich','ro','Sibiu',2612.0,24.45,45.9).
city('Ocna Sibiului','ro','Sibiu',4021.0,24.05,45.89).
city('Orlat','ro','Sibiu',3193.0,23.97,45.75).
city('Pauca','ro','Sibiu',2191.0,23.9,46.02).
city('Poiana Sibiului','ro','Sibiu',2748.0,23.73,45.8).
city('Poplaca','ro','Sibiu',1742.0,24.05,45.72).
city('Porumbacu de Jos','ro','Sibiu',3166.0,24.45,45.75).
city('Racovita','ro','Sibiu',2824.0,24.35,45.68).
city('Rasinari','ro','Sibiu',5403.0,24.07,45.7).
city('Rau Sadului','ro','Sibiu',627.0,24.07,45.62).
city('Rosia','ro','Sibiu',4733.0,24.32,45.82).
city('Sadu','ro','Sibiu',2430.0,24.18,45.67).
city('Saliste','ro','Sibiu',5660.0,23.88,45.78).
city('Seica Mare','ro','Sibiu',4739.0,24.15,46.02).
city('Seica Mica','ro','Sibiu',1709.0,24.13,46.05).
city('Selimbar','ro','Sibiu',4829.0,24.2,45.77).
city('Sibiu','ro','Sibiu',151895.0,24.13,45.79).
city('Slimnic','ro','Sibiu',3592.0,24.17,45.92).
city('Sura Mare','ro','Sibiu',3253.0,24.17,45.85).
city('Sura Mica','ro','Sibiu',2311.0,24.07,45.83).
city('Talmaciu','ro','Sibiu',8660.0,24.27,45.68).
city('Tarnava','ro','Sibiu',2813.0,24.29,46.15).
city('Tilisca','ro','Sibiu',1656.0,23.85,45.8).
city('Turnu Rosu','ro','Sibiu',2578.0,24.3,45.63).
city('Valea Viilor','ro','Sibiu',1991.0,24.28,46.08).
city('Vurpar','ro','Sibiu',2322.0,24.35,45.9).
city('Adancata','ro','Suceava',7779.0,26.3,47.73).
city('Arbore','ro','Suceava',6736.0,25.93,47.73).
city('Baia','ro','Suceava',6762.0,26.22,47.42).
city('Balcauti','ro','Suceava',3384.0,26.08,47.9).
city('Bilca','ro','Suceava',3460.0,25.75,47.92).
city('Bogdanesti','ro','Suceava',3981.0,26.28,47.37).
city('Boroaia','ro','Suceava',4737.0,26.33,47.35).
city('Bosanci','ro','Suceava',6270.0,26.32,47.58).
city('Botosana','ro','Suceava',4881.0,25.95,47.68).
city('Breaza','ro','Suceava',1686.0,25.33,47.62).
city('Brodina','ro','Suceava',3654.0,25.42,47.88).
city('Brosteni','ro','Suceava',6578.0,25.7,47.23).
city('Bunesti','ro','Suceava',2684.0,26.28,47.52).
city('Cacica','ro','Suceava',4438.0,25.9,47.63).
city('Cajvana','ro','Suceava',7236.0,25.97,47.7).
city('Calafindesti','ro','Suceava',5764.0,26.12,47.85).
city('Campulung Moldovenesc','ro','Suceava',19765.0,25.56,47.54).
city('Carlibaba','ro','Suceava',1965.0,25.13,47.58).
city('Ciprian Porumbescu','ro','Suceava',6405.0,26.07,47.57).
city('Cornu Luncii','ro','Suceava',7288.0,26.15,47.47).
city('Crucea','ro','Suceava',2279.0,25.62,47.35).
city('Darmanesti','ro','Suceava',5817.0,26.15,47.73).
city('Dolhasca','ro','Suceava',11025.0,26.6,47.43).
city('Dolhesti','ro','Suceava',4046.0,26.53,47.45).
city('Dorna','ro','Suceava',3089.0,25.43,47.34).
city('Dorna Candrenilor','ro','Suceava',4650.0,25.25,47.35).
city('Dornesti','ro','Suceava',4371.0,26.02,47.87).
city('Dragoesti','ro','Suceava',5288.0,26.08,47.55).
city('Draguseni','ro','Suceava',2665.0,26.48,47.28).
city('Dumbraveni','ro','Suceava',8110.0,26.42,47.65).
city('Falticeni','ro','Suceava',29576.0,26.3,47.46).
city('Fantanele','ro','Suceava',4913.0,26.32,47.52).
city('Forasti','ro','Suceava',4912.0,26.47,47.35).
city('Frasin','ro','Suceava',6519.0,25.8,47.53).
city('Fratautii Noi','ro','Suceava',5512.0,25.85,47.95).
city('Fratautii Vechi','ro','Suceava',4635.0,25.88,47.9).
city('Frumosu','ro','Suceava',3571.0,25.65,47.62).
city('Fundu Moldovei','ro','Suceava',4135.0,25.4,47.53).
city('Galanesti','ro','Suceava',6211.0,25.8,47.92).
city('Gramesti','ro','Suceava',3097.0,26.15,47.92).
city('Granicesti','ro','Suceava',4916.0,26.07,47.82).
city('Gura Humorului','ro','Suceava',15728.0,25.9,47.56).
city('Horodniceni','ro','Suceava',3699.0,26.17,47.53).
city('Horodnicu','ro','Suceava',6899.0,25.85,47.87).
city('Iacobeni','ro','Suceava',3836.0,25.32,47.43).
city('Ipotesti','ro','Suceava',4521.0,26.28,47.62).
city('Izvoarele Sucevei','ro','Suceava',2262.0,25.18,47.75).
city('Liteni','ro','Suceava',9833.0,26.2,47.57).
city('Malini','ro','Suceava',7163.0,26.08,47.47).
city('Manastirea Homorului','ro','Suceava',3573.0,25.87,47.6).
city('Marginea','ro','Suceava',9489.0,25.82,47.82).
city('Milisauti','ro','Suceava',8399.0,26.0,47.78).
city('Mitocu Dragomirnei','ro','Suceava',3976.0,26.25,47.73).
city('Moara','ro','Suceava',4304.0,26.23,47.57).
city('Moldova Sulita','ro','Suceava',2059.0,25.25,47.68).
city('Moldovita','ro','Suceava',4985.0,25.53,47.68).
city('Musenita','ro','Suceava',2232.0,26.0,47.97).
city('Ostra','ro','Suceava',3145.0,25.77,47.4).
city('Paltinoasa','ro','Suceava',5635.0,25.95,47.55).
city('Panaci','ro','Suceava',2308.0,25.38,47.27).
city('Partestii de Jos','ro','Suceava',2998.0,25.97,47.63).
city('Patrauti','ro','Suceava',4283.0,26.2,47.72).
city('Poiana Stampei','ro','Suceava',2315.0,25.13,47.32).
city('Pojorata','ro','Suceava',3107.0,25.45,47.52).
city('Preutesti','ro','Suceava',9048.0,26.42,47.45).
city('Putna','ro','Suceava',3727.0,25.62,47.87).
city('Radaseni','ro','Suceava',4404.0,26.25,47.47).
city('Radauti','ro','Suceava',27241.0,25.92,47.85).
city('Rasca','ro','Suceava',5127.0,26.23,47.37).
city('Sadova','ro','Suceava',2474.0,25.5,47.53).
city('Salcea','ro','Suceava',8655.0,26.37,47.65).
city('Saru Dornei','ro','Suceava',4301.0,25.35,47.28).
city('Satu Mare','ro','Suceava',4091.0,26.02,47.83).
city('Scheia','ro','Suceava',7533.0,26.23,47.65).
city('Siminicea','ro','Suceava',3107.0,26.4,47.7).
city('Siret','ro','Suceava',9247.0,26.06,47.95).
city('Slatina','ro','Suceava',5196.0,26.02,47.45).
city('Solca','ro','Suceava',4391.0,25.85,47.71).
city('Straja','ro','Suceava',5304.0,25.55,47.92).
city('Stroiesti','ro','Suceava',3524.0,26.13,47.62).
city('Stulpicani','ro','Suceava',6234.0,25.77,47.47).
city('Suceava','ro','Suceava',105797.0,26.26,47.64).
city('Sucevita','ro','Suceava',2584.0,25.72,47.78).
city('Todiresti','ro','Suceava',5763.0,26.03,47.7).
city('Udesti','ro','Suceava',7177.0,26.42,47.57).
city('Ulma','ro','Suceava',2285.0,25.3,47.88).
city('Vadu Moldovei','ro','Suceava',7325.0,26.37,47.38).
city('Valea Moldovei','ro','Suceava',5814.0,26.03,47.47).
city('Vama','ro','Suceava',5995.0,25.68,47.57).
city('Vatra Dornei','ro','Suceava',16055.0,25.36,47.36).
city('Vatra Moldovitei','ro','Suceava',4653.0,25.57,47.65).
city('Veresti','ro','Suceava',7089.0,26.43,47.6).
city('Vicovu de Jos','ro','Suceava',5956.0,25.73,47.9).
city('Vicovu de Sus','ro','Suceava',14077.0,25.68,47.93).
city('Volovat','ro','Suceava',6990.0,25.9,47.82).
city('Vulturesti','ro','Suceava',3771.0,26.45,47.52).
city('Zamostea','ro','Suceava',3177.0,26.2,47.87).
city('Zvoristea','ro','Suceava',6275.0,26.28,47.83).
city('Alexandria','ro','Teleorman',49346.0,25.34,43.99).
city('Babaita','ro','Teleorman',6276.0,25.38,44.17).
city('Balaci','ro','Teleorman',2485.0,24.92,44.35).
city('Blejesti','ro','Teleorman',4149.0,25.47,44.3).
city('Bogdana','ro','Teleorman',2970.0,25.09,43.93).
city('Botoroaga','ro','Teleorman',6488.0,25.55,44.15).
city('Bragadiru','ro','Teleorman',4498.0,25.52,43.77).
city('Branceni','ro','Teleorman',3057.0,25.4,43.88).
city('Bujoreni','ro','Teleorman',1230.0,25.43,43.95).
city('Bujoru','ro','Teleorman',2018.0,25.57,43.72).
city('Buzescu','ro','Teleorman',4243.0,25.23,44.02).
city('Calinesti','ro','Teleorman',3964.0,25.23,44.08).
city('Calmatuiu','ro','Teleorman',2675.0,24.85,44.0).
city('Cervenia','ro','Teleorman',3360.0,25.47,43.83).
city('Ciolanesti','ro','Teleorman',3594.0,25.08,44.32).
city('Ciuperceni','ro','Teleorman',1865.0,24.95,43.77).
city('Contesti','ro','Teleorman',3754.0,25.48,43.8).
city('Cosmesti','ro','Teleorman',2735.0,25.38,44.3).
city('Crangeni','ro','Teleorman',3529.0,24.78,44.03).
city('Crangu','ro','Teleorman',3589.0,25.08,43.82).
city('Crevenicu','ro','Teleorman',1693.0,25.58,44.23).
city('Didesti','ro','Teleorman',1396.0,24.88,44.22).
city('Dobrotesti','ro','Teleorman',5096.0,24.88,44.28).
city('Dracsenei','ro','Teleorman',3616.0,24.98,44.22).
city('Draganesti de Vede','ro','Teleorman',2237.0,25.05,44.13).
city('Draganesti-Vlasca','ro','Teleorman',4740.0,25.6,44.1).
city('Frumoasa','ro','Teleorman',2587.0,25.47,43.8).
city('Furculesti','ro','Teleorman',3872.0,25.15,43.87).
city('Galateni','ro','Teleorman',3175.0,25.35,44.22).
city('Gratia','ro','Teleorman',2996.0,25.45,44.43).
city('Islaz','ro','Teleorman',6029.0,24.75,43.73).
city('Izvoarele','ro','Teleorman',2919.0,25.38,43.82).
city('Lisa','ro','Teleorman',2576.0,25.13,43.8).
city('Lita','ro','Teleorman',3166.0,24.82,43.8).
city('Lunca','ro','Teleorman',6485.0,24.77,43.83).
city('Magura','ro','Teleorman',3070.0,25.4,44.03).
city('Maldaeni','ro','Teleorman',4755.0,24.93,44.12).
city('Marzanesti','ro','Teleorman',4326.0,25.47,43.93).
city('Mavrodin','ro','Teleorman',5628.0,25.25,44.03).
city('Mereni','ro','Teleorman',3334.0,25.63,44.23).
city('Mosteni','ro','Teleorman',1681.0,25.13,43.87).
city('Nanov','ro','Teleorman',3545.0,25.3,44.0).
city('Nasturelu','ro','Teleorman',2809.0,25.47,43.67).
city('Necsesti','ro','Teleorman',1562.0,25.15,44.25).
city('Olteni','ro','Teleorman',3352.0,25.28,44.18).
city('Orbeasca','ro','Teleorman',8203.0,25.32,44.13).
city('Peretu','ro','Teleorman',7816.0,25.08,44.05).
city('Piatra','ro','Teleorman',3731.0,25.17,43.82).
city('Pietrosani','ro','Teleorman',3351.0,25.63,43.72).
city('Plopii Slavitesti','ro','Teleorman',4716.0,24.68,43.97).
city('Plosca','ro','Teleorman',6404.0,25.12,44.03).
city('Poeni','ro','Teleorman',3335.0,25.33,44.4).
city('Poroschia','ro','Teleorman',4544.0,25.37,43.93).
city('Putineiu','ro','Teleorman',2822.0,24.97,43.9).
city('Radoiesti','ro','Teleorman',2476.0,25.15,44.15).
city('Rasmiresti','ro','Teleorman',1163.0,25.55,43.98).
city('Rosiori de Vede','ro','Teleorman',30774.0,25.0,44.12).
city('Saceni','ro','Teleorman',1661.0,25.07,44.23).
city('Salcia','ro','Teleorman',3243.0,24.92,43.95).
city('Sarbeni','ro','Teleorman',1740.0,25.38,44.47).
city('Scrioastea','ro','Teleorman',4244.0,24.95,44.15).
city('Scurtu Mare','ro','Teleorman',2066.0,25.27,44.35).
city('Seaca','ro','Teleorman',2797.0,25.07,43.75).
city('Segarcea Vale','ro','Teleorman',3768.0,24.8,43.82).
city('Sfintesti','ro','Teleorman',1437.0,25.1,44.18).
city('Silistea','ro','Teleorman',4391.0,25.35,44.38).
city('Silistea-Gumesti','ro','Teleorman',2909.0,25.0,44.38).
city('Slobozia-Mandra','ro','Teleorman',4159.0,24.7,43.92).
city('Smardioasa','ro','Teleorman',2658.0,25.43,43.85).
city('Stejaru','ro','Teleorman',2249.0,24.9,44.19).
city('Storobaneasa','ro','Teleorman',3645.0,25.45,43.88).
city('Suhaia','ro','Teleorman',4744.0,25.25,43.73).
city('Talpa','ro','Teleorman',2309.0,25.3,44.28).
city('Tatarastii de Jos','ro','Teleorman',4228.0,25.18,44.37).
city('Tatarastii de Sus','ro','Teleorman',3271.0,25.12,44.42).
city('Tiganesti','ro','Teleorman',5397.0,25.37,43.9).
city('Traian','ro','Teleorman',2170.0,25.0,43.77).
city('Trivalea-Mosteni','ro','Teleorman',3359.0,25.23,44.27).
city('Troianul','ro','Teleorman',3502.0,25.0,44.0).
city('Turnu Magurele','ro','Teleorman',28784.0,24.87,43.76).
city('Vartoapele-de-Jos','ro','Teleorman',3201.0,25.2,44.18).
city('Vedea','ro','Teleorman',3108.0,25.07,44.08).
city('Videle','ro','Teleorman',11813.0,25.53,44.29).
city('Viisoara','ro','Teleorman',2242.0,25.17,43.78).
city('Vitanesti','ro','Teleorman',3214.0,25.42,44.0).
city('Zambreasca','ro','Teleorman',1871.0,24.98,44.32).
city('Zimnicea','ro','Teleorman',15228.0,25.36,43.68).
city('Balint','ro','Timis',1736.0,21.85,45.82).
city('Banloc','ro','Timis',4497.0,21.13,45.38).
city('Bara','ro','Timis',374.0,21.88,45.9).
city('Barna','ro','Timis',1531.0,22.05,45.72).
city('Beba','ro','Timis',1586.0,20.32,46.13).
city('Becicherecu Mic','ro','Timis',4765.0,21.1,45.83).
city('Belint','ro','Timis',3023.0,21.77,45.75).
city('Bethausen','ro','Timis',3012.0,21.97,45.83).
city('Biled','ro','Timis',6230.0,20.95,45.88).
city('Bogda','ro','Timis',465.0,21.57,45.98).
city('Boldur','ro','Timis',2542.0,21.78,45.7).
city('Brestovat','ro','Timis',812.0,21.73,45.93).
city('Buzias','ro','Timis',7625.0,21.61,45.65).
city('Carpinis','ro','Timis',7071.0,20.9,45.78).
city('Cenad','ro','Timis',4218.0,20.58,46.13).
city('Cenei','ro','Timis',4754.0,20.9,45.72).
city('Cheveresu Mare','ro','Timis',1938.0,21.48,45.67).
city('Ciacova','ro','Timis',7205.0,21.13,45.52).
city('Comlosu Mare','ro','Timis',4745.0,20.63,45.9).
city('Costeiu','ro','Timis',3805.0,21.85,45.73).
city('Criciova','ro','Timis',1698.0,22.07,45.63).
city('Curtea','ro','Timis',1310.0,22.3,45.82).
city('Darova','ro','Timis',3028.0,21.77,45.63).
city('Denta','ro','Timis',3152.0,21.3,45.38).
city('Deta','ro','Timis',6253.0,21.22,45.4).
city('Dudestii Vechi','ro','Timis',5746.0,20.48,46.05).
city('Dumbrava','ro','Timis',2820.0,22.12,45.82).
city('Dumbravita','ro','Timis',2644.0,21.25,45.8).
city('Faget','ro','Timis',7125.0,22.18,45.85).
city('Fardea','ro','Timis',1900.0,22.17,45.73).
city('Foeni','ro','Timis',1695.0,20.88,45.5).
city('Gataia','ro','Timis',8002.0,21.43,45.43).
city('Gavojdia','ro','Timis',3122.0,22.02,45.62).
city('Ghiroda','ro','Timis',4857.0,21.3,45.77).
city('Ghizela','ro','Timis',1290.0,21.75,45.82).
city('Giarmata','ro','Timis',5357.0,21.32,45.83).
city('Giera','ro','Timis',1310.0,20.98,45.42).
city('Giroc','ro','Timis',4250.0,21.23,45.7).
city('Giulvaz','ro','Timis',2992.0,20.98,45.55).
city('Jamu Mare','ro','Timis',3289.0,21.42,45.25).
city('Jebel','ro','Timis',5298.0,21.23,45.55).
city('Jimbolia','ro','Timis',10860.0,20.71,45.8).
city('Lenauheim','ro','Timis',5605.0,20.8,45.87).
city('Liebling','ro','Timis',3705.0,21.32,45.58).
city('Lovrin','ro','Timis',8851.0,20.78,45.97).
city('Lugoj','ro','Timis',43244.0,21.91,45.69).
city('Manastiur','ro','Timis',1757.0,22.07,45.82).
city('Margina','ro','Timis',2333.0,22.27,45.85).
city('Masloc','ro','Timis',3935.0,21.45,46.0).
city('Moravita','ro','Timis',2368.0,21.27,45.27).
city('Mosnita Noua','ro','Timis',4268.0,21.33,45.72).
city('Nadrag','ro','Timis',2897.0,22.18,45.65).
city('Nitchidorf','ro','Timis',1567.0,21.53,45.58).
city('Ohaba Lunga','ro','Timis',1212.0,21.98,45.9).
city('Ortisoara','ro','Timis',4042.0,21.2,45.97).
city('Peciu Nou','ro','Timis',4937.0,21.07,45.6).
city('Periam','ro','Timis',6563.0,20.87,46.05).
city('Pietroasa','ro','Timis',1162.0,22.4,45.83).
city('Pischia','ro','Timis',2974.0,21.35,45.9).
city('Racovita','ro','Timis',3260.0,21.63,45.7).
city('Recas','ro','Timis',8508.0,21.5,45.8).
city('Remetea Mare','ro','Timis',3473.0,21.37,45.78).
city('Sacalaz','ro','Timis',6176.0,21.12,45.75).
city('Sacosu Turcesc','ro','Timis',3121.0,21.43,45.65).
city('Sag','ro','Timis',4461.0,21.17,45.65).
city('Sanandrei','ro','Timis',5302.0,21.17,45.85).
city('Sanmihaiu Roman','ro','Timis',4343.0,21.09,45.7).
city('Sannicolaul Mare','ro','Timis',12888.0,20.62,46.08).
city('Sanpetrul-Mare','ro','Timis',5782.0,20.67,46.05).
city('Satchinez','ro','Timis',4586.0,21.03,45.93).
city('Secas','ro','Timis',301.0,21.82,45.88).
city('Stiuca','ro','Timis',1821.0,21.98,45.57).
city('Teremia Mare','ro','Timis',4108.0,20.53,45.94).
city('Timisoara','ro','Timis',315055.0,21.23,45.76).
city('Tomesti','ro','Timis',2226.0,22.3,45.78).
city('Topolovatu Mare','ro','Timis',2942.0,21.62,45.77).
city('Tormac','ro','Timis',2706.0,21.48,45.52).
city('Traian Vuia','ro','Timis',2215.0,22.07,45.8).
city('Uivar','ro','Timis',4378.0,20.9,45.65).
city('Varias','ro','Timis',6054.0,20.95,46.02).
city('Victor Vlad Dela','ro','Timis',2879.0,21.89,45.64).
city('Voiteg','ro','Timis',2402.0,21.23,45.47).
city('Babadag','ro','Tulcea',10101.0,28.74,44.9).
city('Baia','ro','Tulcea',4938.0,28.67,44.72).
city('Beidaud','ro','Tulcea',1793.0,28.57,44.72).
city('Carcaliu','ro','Tulcea',3422.0,28.15,45.18).
city('Casimcea','ro','Tulcea',3363.0,28.37,44.73).
city('Ceamurlia de Jos','ro','Tulcea',2596.0,28.72,44.73).
city('Ceatalchioi','ro','Tulcea',744.0,28.78,45.28).
city('Cerna','ro','Tulcea',4279.0,28.32,45.08).
city('Chilia Veche','ro','Tulcea',3599.0,29.28,45.42).
city('Ciucurova','ro','Tulcea',2328.0,28.48,44.93).
city('Constantin Rosetti','ro','Tulcea',1157.0,29.57,45.3).
city('Crisan','ro','Tulcea',1392.0,29.47,44.97).
city('Daeni','ro','Tulcea',2506.0,28.12,44.83).
city('Dorobantu','ro','Tulcea',1769.0,28.27,44.95).
city('Frecatei','ro','Tulcea',3797.0,28.67,45.1).
city('Greci','ro','Tulcea',5384.0,28.23,45.18).
city('Grindu','ro','Tulcea',1561.0,28.22,45.4).
city('Hamcearca','ro','Tulcea',1624.0,28.37,45.12).
city('Horia','ro','Tulcea',1588.0,28.45,45.02).
city('Isaccea','ro','Tulcea',5375.0,28.46,45.27).
city('Izvoarele','ro','Tulcea',3817.0,28.53,45.03).
city('Jijila','ro','Tulcea',5770.0,28.15,45.3).
city('Jurilovca','ro','Tulcea',5133.0,28.87,44.77).
city('Luncavita','ro','Tulcea',7050.0,28.27,45.28).
city('Macin','ro','Tulcea',10295.0,28.13,45.26).
city('Mahmudia','ro','Tulcea',4876.0,29.08,45.08).
city('Malnas','ro','Tulcea',1039.0,29.05,45.19).
city('Mihai Bravu','ro','Tulcea',2640.0,28.65,44.95).
city('Mihail Kogalniceanu','ro','Tulcea',3210.0,28.73,45.03).
city('Murighiol','ro','Tulcea',3761.0,29.17,45.03).
city('Nalbant','ro','Tulcea',2789.0,28.62,45.05).
city('Niculitel','ro','Tulcea',4690.0,28.48,45.18).
city('Nufaru','ro','Tulcea',2388.0,28.92,45.15).
city('Ostrov','ro','Tulcea',2210.0,28.15,44.93).
city('Pardina','ro','Tulcea',702.0,28.97,45.3).
city('Peceneaga','ro','Tulcea',2042.0,28.13,45.02).
city('Sarichioi','ro','Tulcea',7483.0,28.85,44.95).
city('Sfantu Gheorghe','ro','Tulcea',979.0,29.6,44.88).
city('Slava Cercheza','ro','Tulcea',2893.0,28.55,44.9).
city('Smardan','ro','Tulcea',1168.0,28.03,45.28).
city('Somova','ro','Tulcea',4463.0,28.67,45.18).
city('Stejaru','ro','Tulcea',2301.0,28.55,44.77).
city('Sulina','ro','Tulcea',4443.0,29.66,45.16).
city('Topolog','ro','Tulcea',4982.0,28.37,44.88).
city('Tulcea','ro','Tulcea',92475.0,28.8,45.19).
city('Turcoaia','ro','Tulcea',3646.0,28.18,45.12).
city('Valea Nucarilor','ro','Tulcea',3968.0,28.93,45.03).
city('Alunu','ro','Valcea',4495.0,23.82,45.02).
city('Amarasti','ro','Valcea',2109.0,24.15,44.77).
city('Babeni','ro','Valcea',9350.0,24.25,44.98).
city('Baile Govora','ro','Valcea',2862.0,24.18,45.08).
city('Baile Olanesti','ro','Valcea',4562.0,24.23,45.2).
city('Balcesti','ro','Valcea',5683.0,23.95,44.62).
city('Barbatesti','ro','Valcea',3805.0,24.12,45.18).
city('Berbesti','ro','Valcea',5606.0,23.88,44.98).
city('Berislavesti','ro','Valcea',3032.0,24.42,45.25).
city('Boisoara','ro','Valcea',1653.0,24.38,45.43).
city('Brezoi','ro','Valcea',6668.0,24.23,45.35).
city('Budesti','ro','Valcea',5362.0,24.38,45.05).
city('Bujoreni','ro','Valcea',3830.0,24.35,45.13).
city('Bunesti','ro','Valcea',2620.0,24.18,45.12).
city('Caineni','ro','Valcea',2731.0,24.32,45.5).
city('Calimanesti','ro','Valcea',8486.0,24.34,45.25).
city('Cernisoara','ro','Valcea',3948.0,23.98,45.03).
city('Copaceni','ro','Valcea',3013.0,23.98,45.0).
city('Costesti','ro','Valcea',3616.0,24.07,45.15).
city('Creteni','ro','Valcea',2602.0,24.18,44.68).
city('Daesti','ro','Valcea',2787.0,24.13,44.97).
city('Danicei','ro','Valcea',2459.0,24.38,44.9).
city('Dragasani','ro','Valcea',20630.0,24.26,44.67).
city('Dragoesti','ro','Valcea',2362.0,24.3,44.82).
city('Fartatesti','ro','Valcea',4561.0,24.0,44.78).
city('Fauresti','ro','Valcea',3623.0,24.02,44.57).
city('Francesti','ro','Valcea',5490.0,24.1,45.0).
city('Galicea','ro','Valcea',4054.0,24.28,44.92).
city('Ghioroiu','ro','Valcea',2144.0,23.83,44.7).
city('Glavile','ro','Valcea',2532.0,24.15,44.82).
city('Golesti','ro','Valcea',2696.0,24.48,45.15).
city('Gradistea','ro','Valcea',3057.0,23.82,44.87).
city('Gusoeni','ro','Valcea',1870.0,24.12,44.72).
city('Horezu','ro','Valcea',6743.0,24.01,45.15).
city('Ionesti','ro','Valcea',4379.0,24.23,44.85).
city('Ladesti','ro','Valcea',2188.0,24.05,44.88).
city('Lalosu','ro','Valcea',2606.0,24.02,44.55).
city('Lapusata','ro','Valcea',2454.0,24.02,44.92).
city('Livezi','ro','Valcea',2586.0,23.82,44.85).
city('Lungesti','ro','Valcea',3628.0,24.18,44.57).
city('Maciuca','ro','Valcea',2193.0,24.02,44.75).
city('Madulari','ro','Valcea',1718.0,24.0,45.03).
city('Malaia','ro','Valcea',1886.0,24.03,45.35).
city('Maldaresti','ro','Valcea',2033.0,24.02,45.1).
city('Mateesti','ro','Valcea',3232.0,23.85,45.07).
city('Mihaesti','ro','Valcea',6263.0,24.25,45.03).
city('Milcoiu','ro','Valcea',1276.0,24.47,45.05).
city('Muereasca','ro','Valcea',2591.0,24.33,45.18).
city('Nicolae Balcescu','ro','Valcea',3768.0,24.45,45.12).
city('Ocnele Mari','ro','Valcea',3554.0,24.31,45.09).
city('Olanu','ro','Valcea',3340.0,24.32,44.87).
city('Orlesti','ro','Valcea',3372.0,24.23,44.8).
city('Otesani','ro','Valcea',3001.0,24.03,45.07).
city('Pausesti','ro','Valcea',2973.0,24.12,45.07).
city('Pausesti-Maglasi','ro','Valcea',3775.0,24.25,45.13).
city('Perisani','ro','Valcea',3781.0,24.4,45.38).
city('Pesceana','ro','Valcea',2017.0,24.13,44.88).
city('Pietrari','ro','Valcea',3257.0,24.12,45.1).
city('Popesti','ro','Valcea',3164.0,24.1,44.98).
city('Prundeni','ro','Valcea',4596.0,24.27,44.73).
city('Racovita','ro','Valcea',1824.0,24.32,45.42).
city('Ramnicu Valcea','ro','Valcea',107558.0,24.38,45.11).
city('Roesti','ro','Valcea',2280.0,24.08,44.92).
city('Rosiile','ro','Valcea',2985.0,23.93,44.87).
city('Runcu','ro','Valcea',1138.0,24.45,45.17).
city('Salatrucel','ro','Valcea',2206.0,24.38,45.25).
city('Scundu','ro','Valcea',2203.0,24.2,44.83).
city('Sinesti','ro','Valcea',2636.0,23.85,44.95).
city('Sirineasa','ro','Valcea',2571.0,24.2,44.93).
city('Slatioara','ro','Valcea',3575.0,23.92,45.12).
city('Stanesti','ro','Valcea',1527.0,24.05,44.82).
city('Stefanesti','ro','Valcea',3663.0,24.25,44.62).
city('Stoenesti','ro','Valcea',3863.0,24.17,45.12).
city('Stoilesti','ro','Valcea',4316.0,24.37,44.9).
city('Stroesti','ro','Valcea',3076.0,23.9,45.08).
city('Susani','ro','Valcea',3875.0,24.1,44.58).
city('Sutesti','ro','Valcea',3596.0,24.22,44.65).
city('Tetoiu','ro','Valcea',2995.0,23.92,44.75).
city('Tomsani','ro','Valcea',4123.0,24.05,45.12).
city('Vaideeni','ro','Valcea',4198.0,23.93,45.17).
city('Valea Mare','ro','Valcea',3165.0,24.0,44.67).
city('Vladesti','ro','Valcea',2411.0,24.3,45.12).
city('Voicesti','ro','Valcea',1752.0,24.3,44.6).
city('Voineasa','ro','Valcea',1695.0,23.95,45.42).
city('Zatreni','ro','Valcea',4524.0,23.85,44.77).
city('Albesti','ro','Vaslui',3279.0,27.87,46.5).
city('Alexandru Vlahuta','ro','Vaslui',3139.0,27.63,46.42).
city('Arsura','ro','Vaslui',1984.0,28.02,46.82).
city('Bacani','ro','Vaslui',2748.0,27.67,46.33).
city('Bacesti','ro','Vaslui',4017.0,27.23,46.85).
city('Balteni','ro','Vaslui',1612.0,27.63,46.67).
city('Banca','ro','Vaslui',5600.0,27.8,46.3).
city('Barlad','ro','Vaslui',67819.0,27.66,46.23).
city('Berezeni','ro','Vaslui',5590.0,28.15,46.3).
city('Blagesti','ro','Vaslui',1844.0,28.02,46.13).
city('Bogdana','ro','Vaslui',1856.0,27.62,46.53).
city('Bogdanesti','ro','Vaslui',3461.0,27.72,46.45).
city('Bogdanita','ro','Vaslui',1573.0,27.68,46.45).
city('Botesti','ro','Vaslui',2292.0,27.88,46.8).
city('Bunesti','ro','Vaslui',3070.0,27.97,46.83).
city('Codaesti','ro','Vaslui',4785.0,27.75,46.87).
city('Coroiesti','ro','Vaslui',2318.0,27.48,46.25).
city('Costesti','ro','Vaslui',3192.0,27.75,46.5).
city('Cretesti','ro','Vaslui',1944.0,27.95,46.63).
city('Danesti','ro','Vaslui',2420.0,27.66,46.84).
city('Deleni','ro','Vaslui',2627.0,27.75,46.55).
city('Delesti','ro','Vaslui',5122.0,27.55,46.7).
city('Dimitrie Cantemir','ro','Vaslui',3040.0,28.06,46.51).
city('Dragomiresti','ro','Vaslui',4868.0,27.35,46.63).
city('Dranceni Sat','ro','Vaslui',4719.0,28.08,46.82).
city('Duda','ro','Vaslui',5037.0,28.03,46.75).
city('Dumesti','ro','Vaslui',3625.0,27.28,46.85).
city('Epureni','ro','Vaslui',3241.0,27.9,46.25).
city('Falciu','ro','Vaslui',6178.0,28.13,46.3).
city('Gagesti','ro','Vaslui',2252.0,27.97,46.33).
city('Garceni','ro','Vaslui',2561.0,27.28,46.77).
city('Gherghesti','ro','Vaslui',2785.0,27.52,46.5).
city('Grivita','ro','Vaslui',5405.0,27.65,46.15).
city('Hoceni','ro','Vaslui',3192.0,28.0,46.53).
city('Husi','ro','Vaslui',29129.0,28.06,46.68).
city('Iana','ro','Vaslui',3936.0,27.55,46.38).
city('Ivanesti','ro','Vaslui',4906.0,27.45,46.65).
city('Ivesti','ro','Vaslui',4631.0,27.53,46.18).
city('Laza','ro','Vaslui',6694.0,27.58,46.65).
city('Lipovat','ro','Vaslui',4403.0,27.7,46.57).
city('Lunca Banului','ro','Vaslui',3931.0,28.17,46.6).
city('Malusteni','ro','Vaslui',2988.0,27.92,46.18).
city('Miclesti','ro','Vaslui',2961.0,27.83,46.82).
city('Muntenii de Jos','ro','Vaslui',3826.0,27.77,46.62).
city('Murgeni','ro','Vaslui',7665.0,28.02,46.2).
city('Negresti','ro','Vaslui',10043.0,27.43,46.83).
city('Oltenesti','ro','Vaslui',3041.0,27.9,46.58).
city('Osesti','ro','Vaslui',3146.0,27.47,46.77).
city('Padureni','ro','Vaslui',4429.0,27.22,45.93).
city('Perieni','ro','Vaslui',5258.0,27.62,46.3).
city('Pogana','ro','Vaslui',3378.0,27.57,46.32).
city('Poienesti','ro','Vaslui',3141.0,27.52,46.62).
city('Puiesti','ro','Vaslui',5050.0,27.5,46.42).
city('Pungesti','ro','Vaslui',3453.0,27.33,46.7).
city('Rebricea','ro','Vaslui',3605.0,27.55,46.87).
city('Rosiesti','ro','Vaslui',3769.0,27.88,46.43).
city('Solesti','ro','Vaslui',386.0,27.78,46.77).
city('Stanilesti','ro','Vaslui',5874.0,28.17,46.62).
city('Stefan cel Mare','ro','Vaslui',3370.0,27.63,46.72).
city('Suletea','ro','Vaslui',2535.0,27.9,46.28).
city('Tacuta','ro','Vaslui',3410.0,27.68,46.92).
city('Tanacu','ro','Vaslui',5986.0,27.82,46.68).
city('Tatarani','ro','Vaslui',2551.0,27.97,46.7).
city('Todiresti','ro','Vaslui',5388.0,27.37,46.85).
city('Tutova','ro','Vaslui',5619.0,27.55,46.12).
city('Valeni','ro','Vaslui',6723.0,28.06,46.6).
city('Vaslui','ro','Vaslui',69226.0,27.73,46.65).
city('Vetrisoaia','ro','Vaslui',3452.0,28.22,46.43).
city('Viisoara','ro','Vaslui',3894.0,27.88,46.38).
city('Vinderei','ro','Vaslui',4716.0,27.8,46.15).
city('Voinesti','ro','Vaslui',3785.0,27.42,46.57).
city('Vulturesti','ro','Vaslui',2320.0,27.53,46.82).
city('Vutcani','ro','Vaslui',2391.0,27.97,46.47).
city('Zapodeni','ro','Vaslui',4207.0,27.65,46.75).
city('Zorleni','ro','Vaslui',9511.0,27.72,46.27).
city('Adjud','ro','Vrancea',17299.0,27.18,46.1).
city('Andreiasu de Jos','ro','Vrancea',2000.0,26.83,45.75).
city('Balesti','ro','Vrancea',2215.0,27.23,45.43).
city('Barsesti','ro','Vrancea',3263.0,26.73,45.92).
city('Boghesti','ro','Vrancea',1832.0,27.4,46.17).
city('Bolotesti','ro','Vrancea',4578.0,27.07,45.83).
city('Bordesti','ro','Vrancea',1806.0,27.03,45.55).
city('Brosteni','ro','Vrancea',2152.0,27.03,45.75).
city('Campineanca','ro','Vrancea',3158.0,27.13,45.7).
city('Campuri','ro','Vrancea',4007.0,26.77,46.03).
city('Carligele','ro','Vrancea',2949.0,27.1,45.68).
city('Chiojdeni','ro','Vrancea',2449.0,26.87,45.55).
city('Ciorasti','ro','Vrancea',3861.0,27.3,45.43).
city('Corbita','ro','Vrancea',2091.0,27.3,46.15).
city('Cotesti','ro','Vrancea',4780.0,27.05,45.65).
city('Dumbraveni','ro','Vrancea',4156.0,27.12,45.53).
city('Dumitresti','ro','Vrancea',5292.0,26.92,45.57).
city('Fitionesti','ro','Vrancea',2853.0,27.05,45.98).
city('Focsani','ro','Vrancea',105114.0,27.18,45.7).
city('Garoafa','ro','Vrancea',4624.0,27.2,45.78).
city('Golesti','ro','Vrancea',3446.0,27.13,45.67).
city('Gugesti','ro','Vrancea',6478.0,27.13,45.57).
city('Gura Calitei','ro','Vrancea',3111.0,27.02,45.58).
city('Homocea','ro','Vrancea',9869.0,27.23,46.13).
city('Jaristea','ro','Vrancea',4088.0,27.07,45.78).
city('Jitia','ro','Vrancea',1717.0,26.72,45.58).
city('Maicanesti','ro','Vrancea',5312.0,27.5,45.5).
city('Marasesti','ro','Vrancea',11769.0,27.23,45.88).
city('Mera','ro','Vrancea',3938.0,26.95,45.77).
city('Milcovul','ro','Vrancea',8547.0,27.25,45.65).
city('Movilita','ro','Vrancea',3911.0,27.1,45.95).
city('Nanesti','ro','Vrancea',2427.0,27.5,45.55).
city('Naruja','ro','Vrancea',1914.0,26.78,45.83).
city('Nereju','ro','Vrancea',4202.0,26.72,45.72).
city('Nistoresti','ro','Vrancea',2335.0,26.73,45.83).
city('Odobesti','ro','Vrancea',8026.0,27.07,45.77).
city('Paltin','ro','Vrancea',3687.0,26.72,45.78).
city('Panciu','ro','Vrancea',8810.0,27.09,45.91).
city('Paunesti','ro','Vrancea',6778.0,27.1,46.03).
city('Poiana Cristei','ro','Vrancea',2775.0,26.98,45.65).
city('Pufesti','ro','Vrancea',4179.0,27.2,46.0).
city('Racoasa','ro','Vrancea',3463.0,26.88,46.0).
city('Reghiu','ro','Vrancea',2677.0,26.83,45.78).
city('Ruginesti','ro','Vrancea',4438.0,27.12,46.07).
city('Sihlea','ro','Vrancea',5354.0,27.12,45.5).
city('Slobozia Bradului','ro','Vrancea',5060.0,27.05,45.5).
city('Slobozia-Ciorasti','ro','Vrancea',2077.0,27.2,45.62).
city('Soveja','ro','Vrancea',2747.0,26.67,46.0).
city('Straoane','ro','Vrancea',4049.0,27.05,45.93).
city('Suraia','ro','Vrancea',7770.0,27.4,45.68).
city('Tamboesti','ro','Vrancea',4565.0,27.05,45.52).
city('Tanasoaia','ro','Vrancea',2341.0,27.37,46.1).
city('Tataranu','ro','Vrancea',4904.0,27.32,45.52).
city('Tifesti','ro','Vrancea',5202.0,27.1,45.85).
city('Tulnici','ro','Vrancea',5803.0,26.67,45.92).
city('Urechesti','ro','Vrancea',5856.0,27.07,45.6).
city('Valea Sarii','ro','Vrancea',2093.0,26.8,45.88).
city('Vanatori','ro','Vrancea',5521.0,27.25,45.73).
city('Vartescoiu','ro','Vrancea',3425.0,27.08,45.73).
city('Vidra','ro','Vrancea',7424.0,26.9,45.92).
city('Vintileasca','ro','Vrancea',2155.0,26.73,45.6).
city('Vizantea','ro','Vrancea',4201.0,26.78,45.97).
city('Vrancioaia','ro','Vrancea',3018.0,26.73,45.85).
city('Vulturu','ro','Vrancea',8549.0,27.43,45.6).
city('Abadzekhskaya','ru','Adygeya',4010.0,40.22,44.39).
city('Adygeysk','ru','Adygeya',12208.0,39.19,44.88).
city('Beloye','ru','Adygeya',3067.0,39.65,45.05).
city('Blechepsin','ru','Adygeya',3031.0,40.5,44.82).
city('Dondukovskaya','ru','Adygeya',6609.0,40.36,44.88).
city('Enem','ru','Adygeya',17665.0,38.9,44.93).
city('Giaginskaya','ru','Adygeya',15169.0,40.07,44.87).
city('Kamennomostskiy','ru','Adygeya',7585.0,40.19,44.3).
city('Khakurinokhabl','ru','Adygeya',3830.0,40.23,45.01).
city('Khanskaya','ru','Adygeya',11297.0,39.96,44.68).
city('Khatukay','ru','Adygeya',4538.0,39.67,45.19).
city('Khodz','ru','Adygeya',3028.0,40.71,44.51).
city('Koshekhabl','ru','Adygeya',7313.0,40.51,44.9).
city('Krasnogvardeyskoye','ru','Adygeya',9071.0,39.58,45.14).
city('Krasnooktyabrskiy','ru','Adygeya',5491.0,40.08,44.58).
city('Kuzhorskaya','ru','Adygeya',3556.0,40.31,44.68).
city('Maykop','ru','Adygeya',158453.0,40.11,44.61).
city('Natyrbovo','ru','Adygeya',3377.0,40.63,44.73).
city('Ponezhukay','ru','Adygeya',3390.0,39.39,44.89).
city('Severo-Vostochnye Sady','ru','Adygeya',3327.0,40.12,44.67).
city('Takhtamukay','ru','Adygeya',5120.0,38.99,44.92).
city('Tlyustenkhabl','ru','Adygeya',496.0,39.1,44.98).
city('Tulskiy','ru','Adygeya',10508.0,40.18,44.51).
city('Volnoye','ru','Adygeya',3670.0,40.71,44.62).
city('Yablonovskiy','ru','Adygeya',25078.0,38.94,44.99).
city('Aginskoye','ru','Agin-Buryat',11491.0,114.53,51.1).
city('Duldurga','ru','Agin-Buryat',6259.0,113.59,50.68).
city('Mogoytuy','ru','Agin-Buryat',8420.0,114.92,51.28).
city('Orlovskiy','ru','Agin-Buryat',2303.0,114.83,51.03).
city('Aktash','ru','Altai Republic',3374.0,87.73,50.3).
city('Chemal','ru','Altai Republic',3284.0,86.01,51.4).
city('Choya','ru','Altai Republic',1930.0,86.55,52.02).
city('Gorno-Altaysk','ru','Altai Republic',54917.0,85.96,51.96).
city('Kosh-Agach','ru','Altai Republic',5732.0,88.67,50.0).
city('Kyzyl-Ozek','ru','Altai Republic',3217.0,86.0,51.88).
city('Mayma','ru','Altai Republic',15428.0,85.92,52.05).
city('Onguday','ru','Altai Republic',5406.0,86.15,50.75).
city('Shebalino','ru','Altai Republic',4939.0,85.68,51.29).
city('Turochak','ru','Altai Republic',5514.0,87.13,52.27).
city('Ulagan','ru','Altai Republic',2623.0,87.97,50.63).
city('Ust-Kan','ru','Altai Republic',3547.0,84.75,50.95).
city('Ust-Koksa','ru','Altai Republic',4008.0,85.6,50.3).
city('Aleysk','ru','Altaiski Kray',28020.0,82.78,52.49).
city('Altayskoye','ru','Altaiski Kray',13852.0,85.33,51.95).
city('Barnaul','ru','Altaiski Kray',599586.0,83.75,53.36).
city('Bayevo','ru','Altaiski Kray',5134.0,80.77,53.28).
city('Belokurikha','ru','Altaiski Kray',14734.0,84.99,51.99).
city('Beloyarsk','ru','Altaiski Kray',10733.0,83.91,53.45).
city('Berezovka','ru','Altaiski Kray',3885.0,83.95,53.4).
city('Biysk','ru','Altaiski Kray',215433.0,85.17,52.53).
city('Blagoveshchenka','ru','Altaiski Kray',12319.0,79.87,52.83).
city('Borovikha','ru','Altaiski Kray',6712.0,83.84,53.51).
city('Burla','ru','Altaiski Kray',4682.0,78.33,53.33).
city('Bursol','ru','Altaiski Kray',978.0,78.45,53.18).
city('Bystryy Istok','ru','Altaiski Kray',4455.0,84.42,52.38).
city('Charyshskoye','ru','Altaiski Kray',3371.0,83.58,51.4).
city('Cheremnoye','ru','Altaiski Kray',4458.0,83.23,53.17).
city('Galbshtadt','ru','Altaiski Kray',2001.0,78.98,53.23).
city('Gornyak','ru','Altaiski',15669.0,81.47,50.99).
city('Kalmanka','ru','Altaiski Kray',3628.0,83.54,52.9).
city('Kamen-na-Obi','ru','Altaiski Kray',44564.0,81.34,53.79).
city('Khabary','ru','Altaiski Kray',5895.0,79.53,53.64).
city('Klyuchi','ru','Altaiski Kray',9205.0,79.17,52.27).
city('Kosikha','ru','Altaiski Kray',5612.0,84.58,53.36).
city('Krasnogorskoye','ru','Altaiski Kray',6703.0,86.2,52.3).
city('Krasnoshchekovo','ru','Altaiski Kray',5463.0,82.73,51.67).
city('Krutikha','ru','Altaiski Kray',4294.0,81.2,53.96).
city('Kulunda','ru','Altaiski Kray',15345.0,78.95,52.58).
city('Kurya','ru','Altaiski Kray',4258.0,82.32,51.6).
city('Kytmanovo','ru','Altaiski Kray',4183.0,85.47,53.47).
city('Lebyazhye','ru','Altaiski Kray',4559.0,80.84,51.7).
city('Lenki','ru','Altaiski Kray',3859.0,80.43,52.95).
city('Malinovoye Ozero','ru','Altaiski Kray',4101.0,79.75,51.68).
city('Mamontovo','ru','Altaiski Kray',9275.0,81.62,52.72).
city('Mikhaylovskoye','ru','Altaiski Kray',11467.0,79.72,51.82).
city('Nagornyy','ru','Altaiski Kray',6308.0,83.55,52.8).
city('Nalobikha','ru','Altaiski Kray',4451.0,84.6,53.2).
city('Nauchnyy Gorodok','ru','Altaiski Kray',2687.0,83.52,53.42).
city('Novichikha','ru','Altaiski Kray',4460.0,81.4,52.22).
city('Novoaltaysk','ru','Altaiski Kray',61051.0,83.96,53.4).
city('Novosilikatnyy','ru','Altaiski Kray',15241.0,83.64,53.32).
city('Novoyegoryevskoye','ru','Altaiski Kray',6168.0,80.9,51.77).
city('Ozerki','ru','Altaiski Kray',4020.0,83.68,53.67).
city('Pankrushikha','ru','Altaiski Kray',5160.0,80.34,53.83).
city('Pavlovsk','ru','Altaiski Kray',14827.0,82.98,53.33).
city('Pervomayskoye','ru','Altaiski Kray',5171.0,82.86,53.33).
city('Petropavlovskoye','ru','Altaiski Kray',2839.0,84.13,52.07).
city('Pospelikha','ru','Altaiski Kray',13586.0,81.77,51.95).
city('Rebrikha','ru','Altaiski Kray',8858.0,82.33,53.08).
city('Rodino','ru','Altaiski Kray',9537.0,80.25,52.5).
city('Romanovo','ru','Altaiski Kray',6056.0,81.23,52.62).
city('Rubtsovsk','ru','Altaiski Kray',161067.0,81.2,51.53).
city('Shelabolikha','ru','Altaiski Kray',4298.0,82.62,53.42).
city('Shipunovo','ru','Altaiski Kray',11431.0,82.23,52.17).
city('Sibirskiy','ru','Altaiski Kray',11952.0,83.77,53.58).
city('Slavgorod','ru','Altaiski Kray',34141.0,78.67,53.0).
city('Slavgorodskoye','ru','Altaiski Kray',3683.0,78.67,53.05).
city('Smolenskoye','ru','Altaiski Kray',9431.0,85.08,52.33).
city('Sokolovo','ru','Altaiski Kray',3281.0,84.79,52.53).
city('Soloneshnoye','ru','Altaiski Kray',4716.0,84.32,51.66).
city('Solton','ru','Altaiski Kray',3122.0,86.47,52.83).
city('Sorokino','ru','Altaiski Kray',6203.0,84.92,53.75).
city('Sovetskoye','ru','Altaiski Kray',5441.0,85.42,52.3).
city('Srostki','ru','Altaiski Kray',3049.0,85.72,52.43).
city('Staroaleysk','ru','Altaiski Kray',5037.0,82.0,51.01).
city('Tabuny','ru','Altaiski Kray',3950.0,78.75,52.77).
city('Talmenka','ru','Altaiski Kray',19904.0,83.56,53.82).
city('Togul','ru','Altaiski Kray',4937.0,85.92,53.48).
city('Topchikha','ru','Altaiski Kray',9301.0,83.12,52.82).
city('Troitskoye','ru','Altaiski Kray',10887.0,84.66,52.98).
city('Tselinnoye','ru','Altaiski Kray',5836.0,85.67,53.08).
city('Tyumentsevo','ru','Altaiski Kray',5759.0,81.52,53.33).
city('Uglovskoye','ru','Altaiski Kray',4744.0,80.2,51.38).
city('Ust-Charyshskaya Pristan','ru','Altaiski Kray',5647.0,83.65,52.4).
city('Ust-Kalmanka','ru','Altaiski Kray',6659.0,83.32,52.12).
city('Verkh-Suetka','ru','Altaiski Kray',2580.0,80.05,53.3).
city('Verkhne-Katunskoye','ru','Altaiski Kray',3009.0,85.45,52.47).
city('Veseloyarsk','ru','Altaiski Kray',5230.0,81.11,51.28).
city('Vlasikha','ru','Altaiski Kray',4687.0,83.6,53.31).
city('Volchikha','ru','Altaiski Kray',11212.0,80.38,52.03).
city('Yarovoye','ru','Altaiski Kray',21195.0,78.58,52.9).
city('Yeltsovka','ru','Altaiski Kray',3311.0,82.41,51.92).
city('Yuzhnyy','ru','Altai',19515.0,83.69,53.25).
city('Zalesovo','ru','Altaiski Kray',7936.0,84.74,53.99).
city('Zarinsk','ru','Altaiski Kray',52210.0,84.93,53.72).
city('Zaton','ru','Altaiski Kray',3157.0,83.81,53.3).
city('Zavyalovo','ru','Altaiski Kray',7393.0,80.87,52.83).
city('Zmeinogorsk','ru','Altaiski Kray',11514.0,82.2,51.16).
city('Zonalnoye','ru','Altaiski Kray',3500.0,84.95,52.67).
city('Zudilovo','ru','Altaiski Kray',3144.0,83.88,53.5).
city('Arkhara','ru','Amur',10430.0,130.12,49.42).
city('Belogorsk','ru','Amur',66271.0,128.47,50.92).
city('Berezovka','ru','Amur',3455.0,127.87,50.6).
city('Blagoveshchensk','ru','Amur',221298.0,127.53,50.27).
city('Bureya','ru','Amur',5383.0,129.78,49.8).
city('Ekimchan','ru','Amur',1177.0,132.97,53.07).
city('Fevralsk','ru','Amur',4510.0,130.72,52.47).
city('Ivanovka','ru','Amur',6505.0,128.0,50.37).
city('Koboldo','ru','Amur',530.0,132.7,52.97).
city('Konstantinovka','ru','Amur',5702.0,127.98,49.62).
city('Magdagachi','ru','Amur',11739.0,125.8,53.45).
city('Never','ru','Amur',2344.0,124.16,53.97).
city('Novobureyskiy','ru','Amur',8550.0,129.88,49.78).
city('Novokievskiy Uval','ru','Amur',4548.0,128.91,51.66).
city('Novoraychikhinsk','ru','Amur',2835.0,129.58,49.78).
city('Ogodzha','ru','Amur',465.0,132.55,52.75).
city('Ovsyanka','ru','Amur',3588.0,126.88,53.58).
city('Poyarkovo','ru','Amur',7003.0,128.68,49.6).
city('Progress','ru','Amur',12578.0,129.68,49.75).
city('Raychikhinsk','ru','Amur',23746.0,129.42,49.77).
city('Romny','ru','Amur',3413.0,129.33,50.72).
city('Seryshevo','ru','Amur',11718.0,128.21,51.06).
city('Shimanovsk','ru','Amur',21467.0,127.7,52.0).
city('Shirokiy','ru','Amur',1519.0,129.5,49.75).
city('Sivaki','ru','Amur',2479.0,126.75,52.63).
city('Skovorodino','ru','Amur',10007.0,123.92,53.98).
city('Solovyovsk','ru','Amur',2948.0,124.44,54.22).
city('Srednebelaya','ru','Amur',6148.0,128.07,50.68).
city('Stoyba','ru','Amur',895.0,131.7,52.8).
city('Svobodnyy','ru','Amur',61018.0,128.13,51.4).
city('Takhtamygda','ru','Amur',1125.0,123.59,54.12).
city('Talakan','ru','Amur',6294.0,130.37,50.32).
city('Taldan','ru','Amur',3436.0,124.8,53.67).
city('Tambovka','ru','Amur',7834.0,128.07,50.1).
city('Tokur','ru','Amur',1126.0,132.9,53.13).
city('Tygda','ru','Amur',3510.0,126.33,53.12).
city('Tynda','ru','Amur',37336.0,124.72,55.17).
city('Urusha','ru','Amur',4252.0,122.9,54.05).
city('Ushumun','ru','Amur',2808.0,126.53,52.78).
city('Vozzhaevka','ru','Amur',7000.0,128.71,50.74).
city('Yekaterinoslavka','ru','Amur',10178.0,129.11,50.37).
city('Yerofey Pavlovich','ru','Amur',5409.0,121.94,53.97).
city('Zavitinsk','ru','Amur',13198.0,129.45,50.12).
city('Zeya','ru','Amur',26999.0,127.27,53.75).
city('Zlatoustovsk','ru','Amur',823.0,133.6,52.96).
city('Arkhangelsk','ru','Arkhangelsk',344603.0,40.53,64.57).
city('Belushya Guba','ru','Arkhangelsk',2522.0,52.32,71.55).
city('Bereznik','ru','Arkhangelsk',6218.0,42.72,62.87).
city('Cheremushskiy','ru','Arkhangelsk',1093.0,47.26,61.27).
city('Dvins','ru','Arkhangelsk',2845.0,45.17,62.13).
city('Ileza','ru','Arkhangelsk',1430.0,43.91,61.06).
city('Ilinsko-Podomskoye','ru','Arkhangelsk',2860.0,47.98,61.11).
city('Kamenka','ru','Arkhangelsk',3258.0,44.12,65.9).
city('Kargopol','ru','Arkhangelsk',10966.0,38.97,61.5).
city('Karpogory','ru','Arkhangelsk',4441.0,44.45,64.0).
city('Katunino','ru','Arkhangelsk',3255.0,40.62,64.38).
city('Kharitonovo','ru','Arkhangelsk',1402.0,47.5,61.4).
city('Kholmogory','ru','Arkhangelsk',4417.0,41.65,64.23).
city('Kizema','ru','Arkhangel',3644.0,44.82,61.11).
city('Kodino','ru','Arkhangelsk',1970.0,39.67,63.72).
city('Konevo','ru','Arkhangelsk',2951.0,39.33,62.13).
city('Konosha','ru','Arkhangelsk',12383.0,40.26,60.97).
city('Koryazhma','ru','Arkhangelsk',42628.0,47.13,61.31).
city('Kotlas','ru','Arkhangelsk',59181.0,46.66,61.26).
city('Krasnoborsk','ru','Arkhangelsk',4838.0,45.94,61.56).
city('Kuloy','ru','Arkhangelsk',6557.0,42.49,61.03).
city('Leshukonskoye','ru','Arkhangelsk',4813.0,45.77,64.9).
city('Loyga','ru','Arkhangelsk',1618.0,44.0,61.08).
city('Lukovetskiy','ru','Arkhangelsk',2701.0,41.88,64.33).
city('Maloshuyka','ru','Arkhangelsk',3044.0,37.39,63.76).
city('Mezen','ru','Arkhangelsk',3673.0,44.24,65.85).
city('Mirnyy','ru','Arkhangelsk',29341.0,44.54,61.33).
city('Mudyuga','ru','Arkhangelsk',938.0,39.29,63.77).
city('Nyandoma','ru','Arkhangelsk',22179.0,40.2,61.67).
city('Obozyorskiy','ru','Arkhangelsk',3583.0,40.32,63.43).
city('Oksovskiy','ru','Arkhangelsk',2123.0,39.9,62.62).
city('Oktyabrskiy','ru','Arkhangelsk',9697.0,43.25,61.08).
city('Onega','ru','Arkhangelsk',22693.0,38.08,63.92).
city('Pervomayskiy','ru','Arkhangelsk',41998.0,40.83,64.43).
city('Pinega','ru','Arkhangelsk',3620.0,43.38,64.7).
city('Plesetsk','ru','Arkhangelsk',10870.0,40.28,62.72).
city('Podyuga','ru','Arkhangelsk',2977.0,40.86,61.1).
city('Privodino','ru','Arkhangelsk',3140.0,46.5,61.08).
city('Puksoozero','ru','Arkhangelsk',2086.0,40.6,62.57).
city('Rochegda','ru','Arkhangelsk',2362.0,43.25,62.8).
city('Samoded','ru','Arkhangelsk',1928.0,40.52,63.61).
city('Savinskiy','ru','Arkhangelsk',7587.0,40.13,62.94).
city('Severodvinsk','ru','Arkhangelsk',194295.0,39.83,64.57).
city('Shalakusha','ru','Arkhangelsk',2684.0,40.28,62.25).
city('Shenkursk','ru','Arkhangelsk',5893.0,42.92,62.1).
city('Shipitsyno','ru','Arkhangelsk',3780.0,46.52,61.28).
city('Solginskiy','ru','Arkhangelsk',1802.0,41.34,61.05).
city('Solovetskiy','ru','Arkhangelsk',919.0,35.72,65.03).
city('Solvychegodsk','ru','Arkhangelsk',2647.0,46.92,61.33).
city('Udimskiy','ru','Arkhangelsk',2594.0,45.91,61.14).
city('Urdoma','ru','Arkhangelsk',4460.0,48.54,61.75).
city('Ust-Shonosha','ru','Arkhangelsk',2252.0,41.33,61.16).
city('Uyemskiy','ru','Arkhangelsk',3593.0,40.86,64.48).
city('Velsk','ru','Arkhangelsk',26162.0,42.1,61.07).
city('Verkhnyaya Toyma','ru','Arkhangelsk',3790.0,45.05,62.23).
city('Voloshka','ru','Arkhangelsk',1562.0,40.09,61.33).
city('Vychegodskiy','ru','Arkhangelsk',12923.0,46.91,61.24).
city('Yarensk','ru','Arkhangelsk',3929.0,49.09,62.17).
city('Yemtsa','ru','Arkhangelsk',1441.0,40.33,63.07).
city('Yertsevo','ru','Arkhangelsk',3860.0,40.07,60.8).
city('Akhtubinsk','ru','Astrakhan',44552.0,46.17,48.28).
city('Aksarayskiy','ru','Astrakhan',3323.0,48.02,46.79).
city('Astrakhan','ru','Astrakhan',502537.0,48.05,46.35).
city('Chernyy Yar','ru','Astrakhan',8006.0,46.11,48.06).
city('Ikryanoye','ru','Astrakhan',9880.0,47.73,46.09).
city('Ilinka','ru','Astrakhan',4612.0,47.9,46.24).
city('Kamyzyak','ru','Astrakhan',16191.0,48.07,46.11).
city('Kapustin Yar','ru','Astrakhan',6476.0,45.74,48.58).
city('Kapustin Yar-1','ru','Astrakhan',31922.0,45.75,48.58).
city('Kha','ru','Astrakhan',18224.0,47.26,47.41).
city('Kirovskiy','ru','Astrakhan',2249.0,48.12,45.85).
city('Krasnyy Yar','ru','Astrakhan',10876.0,48.34,46.53).
city('Krasnyye Barrikady','ru','Astrakhan',6275.0,47.85,46.21).
city('Liman','ru','Astrakhan',8858.0,47.23,45.79).
city('Marfino','ru','Astrakhan',3312.0,48.72,46.41).
city('Nachalovo','ru','Astrakhan',4808.0,48.19,46.34).
city('Narimanov','ru','Astrakhan',11907.0,47.85,46.69).
city('Nikolskoye','ru','Astrakhan',5281.0,46.4,47.76).
city('Nizhniy Baskunchak','ru','As',3153.0,46.83,48.22).
city('Oranzherei','ru','Astrakhan',4367.0,47.57,45.85).
city('Sasykoli','ru','Astrakhan',4965.0,47.01,47.55).
city('Solyanka','ru','Astrakhan',3173.0,48.0,46.38).
city('Starokucherganovka','ru','Astrakhan',5658.0,47.92,46.32).
city('Tambovka','ru','Astrakhan',3528.0,47.38,47.32).
city('Verkhniy Baskunchak','ru','Astrakhan',8745.0,46.72,48.23).
city('Volgo-Kaspiyskiy','ru','Astrakhan',2662.0,47.92,46.2).
city('Volodarskiy','ru','Astrakhan',9509.0,48.54,46.4).
city('Yaksatovo','ru','Astrakhan',3376.0,48.02,46.24).
city('Yandyki','ru','Astrakhan',3411.0,47.13,45.77).
city('Yenotayevka','ru','Astrakhan',7985.0,47.03,47.25).
city('Zenzeli','ru','Astrakhan',3147.0,47.05,45.92).
city('Agidel','ru','Bashkortostan',19218.0,53.93,55.88).
city('Aksakovo','ru','Bashkortostan',3179.0,54.15,54.03).
city('Aksyonovo','ru','Bashkortostan',1136.0,54.6,53.92).
city('Akyar','ru','Bashkortostan',5560.0,58.22,51.86).
city('Alekseyevka','ru','Bashkortostan',3966.0,55.23,54.85).
city('Amzya','ru','Bashkortostan',4843.0,54.38,56.22).
city('Arkhangelskoye','ru','Bashkortostan',5652.0,56.46,54.37).
city('Askarovo','ru','Bashkortostan',7081.0,58.31,53.31).
city('Askino','ru','Bashkortostan',6866.0,56.58,56.09).
city('Avdon','ru','Bashkortostan',4980.0,55.72,54.67).
city('Bakaly','ru','Bashkortostan',9532.0,53.8,55.18).
city('Baymak','ru','Bashkortostan',17494.0,58.32,52.59).
city('Belebey','ru','Bashkortostan',62583.0,54.12,54.12).
city('Beloretsk','ru','Bashkortostan',70469.0,58.4,53.97).
city('Birsk','ru','Bashkortostan',41015.0,55.54,55.42).
city('Bizhbulyak','ru','Bashkortostan',6385.0,54.27,53.72).
city('Blagoveshchensk','ru','Bashkortostan',34238.0,55.98,55.04).
city('Bolsheustikinskoye','ru','Bashkortostan',7571.0,58.27,55.95).
city('Burayevo','ru','Bashkortostan',8963.0,55.41,55.84).
city('Buribay','ru','Bashkortostan',4461.0,58.17,51.97).
city('Buzdyak','ru','Bashkortostan',9752.0,54.55,54.58).
city('Chekmagush','ru','Bashkortostan',11225.0,54.66,55.13).
city('Davlekanovo','ru','Bashkortostan',23953.0,55.05,54.22).
city('Dmitriyevka','ru','Bashkortostan',3796.0,55.33,54.75).
city('Duvan','ru','Bashkortostan',3710.0,57.89,55.7).
city('Dyurtyuli','ru','Bashkortostan',31088.0,54.88,55.49).
city('Fyodorovka','ru','Bashkortostan',4136.0,55.19,53.18).
city('Iglino','ru','Bashkortostan',13958.0,56.44,54.84).
city('Inzer','ru','Bashkortostan',4388.0,57.55,54.22).
city('Ishimbay','ru','Bashkortostan',70422.0,56.04,53.46).
city('Isyangulovo','ru','Bashkortostan',7455.0,56.58,52.19).
city('Kabakovo','ru','Bashkortostan',3078.0,56.14,54.54).
city('Kaltasy','ru','Bashkortostan',4454.0,54.8,55.97).
city('Kandry','ru','Bashkortostan',12100.0,54.12,54.57).
city('Karaidel','ru','Bashkortostan',5184.0,56.91,55.83).
city('Karaidelskiy','ru','Bashkortostan',201.0,57.08,55.82).
city('Karmaskaly','ru','Bashkortostan',7858.0,56.18,54.37).
city('Kirgiz-Miyaki','ru','Bashkortostan',7673.0,54.78,53.63).
city('Krasnaya Gorka','ru','Bashkortostan',4079.0,56.67,55.19).
city('Krasnokholmskiy','ru','Bashkortostan',8117.0,55.05,55.99).
city('Krasnousolskiy','ru','Bashkortostan',11819.0,56.47,53.89).
city('Krasnyy Klyuch','ru','Bashkortostan',2348.0,56.65,55.39).
city('Kudeyevskiy','ru','Bashkortostan',2872.0,56.76,54.88).
city('Kumertau','ru','Bashkortostan',65322.0,55.78,52.77).
city('Kushnarenkovo','ru','Bashkortostan',10650.0,55.35,55.11).
city('Kuyanovo','ru','Bashkortostan',3895.0,54.49,55.84).
city('Lomovka','ru','Bashkortostan',3178.0,58.37,53.94).
city('Maloyaz','ru','Bashkortostan',4773.0,58.1,55.1).
city('Mayachnyy','ru','Bashkortostan',3506.0,55.73,52.68).
city('Meleuz','ru','Bashkortostan',65363.0,55.92,52.97).
city('Mesyagutovo','ru','Bashkortostan',9780.0,58.24,55.53).
city('Mikhaylovka','ru','Bashkortostan',4344.0,55.9,54.8).
city('Mindyak','ru','Bashkortostan',2955.0,58.79,54.02).
city('Mishkino','ru','Bashkortostan',5808.0,59.1,53.98).
city('Mrakovo','ru','Bashkortostan',8394.0,56.62,52.72).
city('Mursalimkino','ru','Bashkortostan',2527.0,58.56,55.04).
city('Neftekamsk','ru','Bashkortostan',126807.0,54.27,56.08).
city('Nikolo-Beryozovka','ru','Bashkortostan',5992.0,54.15,56.13).
city('Nizhnetroitskiy','ru','Bashkortostan',3784.0,53.68,54.33).
city('Novobelokatay','ru','Bashkortostan',5923.0,58.96,55.71).
city('Novomikhaylovskiy','ru','Bashkortostan',930.0,54.13,53.9).
city('Oktyabrskiy','ru','Bashkortostan',109498.0,53.46,54.47).
city('Pavlovka','ru','Bashkortostan',4277.0,56.56,55.42).
city('Pervomayskiy','ru','Bashkortostan',511.0,55.43,53.65).
city('Pribelskiy','ru','Bashkortostan',4969.0,56.45,54.37).
city('Priyutovo','ru','Bashkortostan',20847.0,53.93,53.9).
city('Rayevskiy','ru','Bashkortostan',20060.0,54.93,54.07).
city('Salavat','ru','Bashkortostan',159896.0,55.92,53.37).
city('Semiletka','ru','Bashkortostan',4163.0,54.62,55.36).
city('Serafimovskiy','ru','Bashkortostan',10360.0,53.82,54.0).
city('Shafranovo','ru','Bashkortostan',2611.0,54.77,53.97).
city('Sharan','ru','Bashkortostan',5555.0,54.0,54.82).
city('Shishma','ru','Bashkortostan',21048.0,55.38,54.58).
city('Sibay','ru','Bashkortostan',61591.0,58.65,52.7).
city('Starobaltachevo','ru','Bashkortostan',5612.0,55.93,55.99).
city('Starosubkhangulovo','ru','Bashkortostan',4351.0,57.43,53.1).
city('Sterlibashevo','ru','Bashkortostan',5786.0,55.25,53.47).
city('Sterlitamak','ru','Bashkortostan',267235.0,55.95,53.63).
city('Subkhankulovo','ru','Bashkortostan',5674.0,53.82,54.57).
city('Temyasovo','ru','Bashkortostan',3524.0,58.1,52.98).
city('Tirlyanskiy','ru','Bashkortostan',5758.0,58.59,54.22).
city('Tolbazy','ru','Bashkortostan',10183.0,55.9,54.01).
city('Tubinskiy','ru','Bashkortostan',1388.0,58.22,52.88).
city('Tukan','ru','Bashkortostan',1808.0,57.45,53.84).
city('Tuymazy','ru','Bashkortostan',68830.0,53.7,54.6).
city('Uchaly','ru','Bashkortostan',21264.0,59.45,54.3).
city('Ufa','ru','Bashkortostan',1033350.0,56.04,54.78).
city('Ulu-Telyak','ru','Bashkortostan',3287.0,56.97,54.91).
city('Ulukulevo','ru','Bashkortostan',4546.0,56.32,54.43).
city('Urman','ru','Bashkortostan',2509.0,56.88,54.88).
city('Verkhneyarkeyevo','ru','Bashkortostan',9357.0,54.32,55.45).
city('Verkhniy Avzyan','ru','Bashkortostan',2581.0,57.54,53.53).
city('Verkhniye Kigi','ru','Bashkortostan',6885.0,58.6,55.41).
city('Verkhniye Tatyshly','ru','Bashkortostan',6341.0,55.84,56.29).
city('Voskresenskoye','ru','Bashkortostan',1992.0,56.17,53.13).
city('Yanaul','ru','Bashkortostan',27963.0,54.93,56.28).
city('Yazykovo','ru','Bashkortostan',5929.0,56.13,55.22).
city('Yermekeyevo','ru','Bashkortostan',4214.0,53.67,54.09).
city('Yermolayevo','ru','Bashkortostan',6354.0,55.81,52.7).
city('Yumaguzino','ru','Bashkortostan',5353.0,56.38,52.9).
city('Zilair','ru','Bashkortostan',5872.0,57.44,52.23).
city('Zirgan','ru','Bashkortostan',4083.0,55.91,53.22).
city('Alekseyevka','ru','Belgorod',39849.0,38.7,50.64).
city('Bekhteyevka','ru','Belgorod',3332.0,37.21,50.79).
city('Belgorod','ru','Belgorod',345293.0,36.59,50.61).
city('Bessonovka','ru','Belgorod',3060.0,36.29,50.52).
city('Borisovka','ru','Belgorod',14253.0,35.99,50.62).
city('Chernyanka','ru','Belgorod',15261.0,37.81,50.94).
city('Golovchino','ru','Belgorod',5356.0,35.8,50.53).
city('Gorodishche','ru','Belgorod',3492.0,38.14,51.15).
city('Grayvoron','ru','Belgorod',6212.0,35.67,50.48).
city('Gubkin','ru','Belgorod',88495.0,37.39,51.28).
city('Ilovka','ru','Belgorod',3308.0,38.64,50.71).
city('Ivnya','ru','Belgorod',7824.0,36.14,51.06).
city('Korocha','ru','Belgorod',6081.0,37.23,50.81).
city('Krasnaya Yaruga','ru','Belgorod',7924.0,35.66,50.8).
city('Krasnogvardeyskoye','ru','Belgorod',8183.0,38.38,50.65).
city('Krasnoye','ru','Belgorod',2352.0,38.69,50.93).
city('Livenka','ru','Belgorod',4154.0,38.26,50.46).
city('Maslova Pristan','ru','Belgorod',5669.0,36.75,50.46).
city('Mayskiy','ru','Belgorod',7537.0,36.59,50.6).
city('Novaya Tavolzhanka','ru','Belgorod',5053.0,36.84,50.36).
city('Novyy Oskol','ru','Belgorod',21035.0,37.87,50.76).
city('Oktyabrskiy','ru','Belgorod',6988.0,36.37,50.43).
city('Prokhorovka','ru','Belgorod',10136.0,36.73,51.04).
city('Proletarskiy','ru','Belgorod',8786.0,35.77,50.79).
city('Pyatnitskoye','ru','Belgorod',4855.0,37.85,50.42).
city('Rakitnoye','ru','Belgorod',10596.0,35.83,50.83).
city('Razumnoye','ru','Belgorod',15529.0,36.7,50.54).
city('Rogovatoye','ru','Belgorod',3062.0,38.37,51.22).
city('Rovenki','ru','Belgorod',9867.0,38.89,49.92).
city('Severnyy','ru','Belgorod',7752.0,36.58,50.6).
city('Shebekino','ru','Belgorod',45194.0,36.9,50.41).
city('Skorodnoye','ru','Belgorod',3677.0,37.24,51.07).
city('Staryy Oskol','ru','Belgorod',226980.0,37.84,51.3).
city('Streletskoye','ru','Belgorod',5727.0,36.57,50.65).
city('Stroitel','ru','Belgorod',18636.0,36.48,50.79).
city('Tomarovka','ru','Belgorod',7916.0,36.22,50.67).
city('Troitskiy','ru','Belgorod',6236.0,37.45,51.37).
city('Urazovo','ru','Belgorod',6966.0,38.05,50.08).
city('Valuyki','ru','Belgorod',35887.0,38.1,50.21).
city('Veydelevka','ru','Belgorod',7280.0,38.45,50.15).
city('Volokonovka','ru','Belgorod',12413.0,37.86,50.48).
city('Yakovlevo','ru','Belgorod',2629.0,36.46,50.0).
city('Zasosna','ru','Belgorod',4287.0,38.4,50.63).
city('Altukhovo','ru','Bryansk',1908.0,34.37,52.67).
city('Ardon','ru','Bryansk',2775.0,32.27,52.74).
city('Belaya Beryozka','ru','Bryansk',7011.0,33.49,52.39).
city('Belyye Berega','ru','Bryansk',10425.0,34.67,53.21).
city('Bolshoye Polpino','ru','Bryansk',4521.0,34.51,53.24).
city('Bryansk','ru','Bryansk',427241.0,34.42,53.26).
city('Bytosh','ru','Bryansk',4425.0,34.1,53.82).
city('Dobrun','ru','Bryansk',4123.0,34.25,53.18).
city('Dubrovka','ru','Bryansk',8427.0,33.51,53.7).
city('Dyatkovo','ru','Bryansk',33339.0,34.34,53.6).
city('Glinishchevo','ru','Bryansk',4156.0,34.07,53.31).
city('Gordeyevka','ru','Bryansk',3005.0,31.97,52.96).
city('Ivot','ru','Bryansk',6294.0,34.19,53.68).
city('Karachev','ru','Bryansk',19758.0,34.99,53.12).
city('Kletnya','ru','Bryansk',13658.0,33.22,53.39).
city('Klimovo','ru','Bryansk',14482.0,32.19,52.38).
city('Klintsy','ru','Bryansk',66337.0,32.23,52.76).
city('Kokino','ru','Bryansk',4616.0,34.78,52.5).
city('Kokorevka','ru','Bryansk',2403.0,34.28,52.59).
city('Komarichi','ru','Bryansk',7090.0,34.79,52.42).
city('Krasnaya Gora','ru','Bryansk',6468.0,31.61,53.01).
city('Lokot','ru','Bryansk',11853.0,34.58,52.57).
city('Lopandino','ru','Bryansk',1938.0,34.81,52.46).
city('Lyubokhna','ru','Bryansk',5188.0,34.39,53.51).
city('Mglin','ru','Bryansk',8369.0,32.84,53.06).
city('Navlya','ru','Bryansk',13735.0,34.5,52.83).
city('Novozybkov','ru','Bryansk',42572.0,31.93,52.54).
city('Pochyop','ru','Bryansk',17033.0,33.46,52.93).
city('Pogar','ru','Bryansk',11242.0,33.26,52.56).
city('Putevka','ru','Bryansk',3656.0,34.28,53.26).
city('Raditsa-Krylovka','ru','Bryansk',3443.0,34.36,53.31).
city('Ramasukha','ru','Bryansk',553.0,33.54,52.74).
city('Rognedino','ru','Bryansk',3287.0,33.56,53.8).
city('Rzhanitsa','ru','Bryansk',5281.0,33.92,53.43).
city('Seltso','ru','Bryansk',18759.0,34.11,53.36).
city('Seshcha','ru','Bryansk',5038.0,33.34,53.73).
city('Sevsk','ru','Bryansk',7594.0,34.5,52.15).
city('Shkotovo-17','ru','Bryansk',15505.0,34.41,53.45).
city('Star','ru','Bryansk',4994.0,34.15,53.62).
city('Starodub','ru','Bryansk',18539.0,32.76,52.58).
city('Suponevo','ru','Bryansk',7845.0,34.3,53.2).
city('Surazh','ru','Bryansk',11962.0,32.39,53.02).
city('Suzyomka','ru','Bryansk',9518.0,34.07,52.32).
city('Sven','ru','Bryansk',3491.0,34.55,53.18).
city('Trubchyovsk','ru','Bryansk',16319.0,33.77,52.58).
city('Unecha','ru','Bryansk',29028.0,32.68,52.85).
city('Vygonichi','ru','Bryansk',5086.0,34.07,53.09).
city('Vyshkov','ru','Bryansk',2881.0,31.69,52.48).
city('Zaymishche','ru','Bryansk',4942.0,32.24,52.72).
city('Zhiryatino','ru','Bryansk',2324.0,33.74,53.22).
city('Zhukovka','ru','Bryansk',19691.0,33.72,53.53).
city('Zlynka','ru','Bryansk',5261.0,31.74,52.43).
city('Babushkin','ru','Buryatia',4578.0,105.86,51.71).
city('Bagdarin','ru','Buryatia',4676.0,113.6,54.43).
city('Barguzin','ru','Buryatia',6052.0,109.62,53.62).
city('Bayangol','ru','Buryatia',1432.0,103.45,50.69).
city('Bichura','ru','Buryatia',9559.0,107.6,50.59).
city('Chikoy','ru','Buryatia',705.0,106.92,50.27).
city('Dzhida','ru','Buryatia',4913.0,106.18,50.68).
city('Gusinoozyorsk','ru','Buryatia',26081.0,106.5,51.28).
city('Gusinoye Ozero','ru','Buryatia',3208.0,106.26,51.11).
city('Iljinka','ru','Buryatia',4340.0,107.28,52.15).
city('Ilka','ru','Buryatia',2199.0,108.53,51.72).
city('Istok','ru','Buryatia',3072.0,106.25,52.1).
city('Ivolginsk','ru','Buryatia',7109.0,107.23,51.75).
city('Kabansk','ru','Buryatia',6257.0,106.65,52.05).
city('Kamensk','ru','Buryatia',7965.0,106.64,51.88).
city('Kholtoson','ru','Buryatia',1040.0,103.3,50.29).
city('Khorinsk','ru','Buryatia',7986.0,109.77,52.17).
city('Kichera','ru','Buryatia',1593.0,110.1,55.94).
city('Kizhinga','ru','Buryatia',6459.0,109.92,51.83).
city('Kurumkan','ru','Buryatia',5848.0,110.3,54.3).
city('Kyakhta','ru','Buryatia',18431.0,106.45,50.35).
city('Kyren','ru','Buryatia',5334.0,102.13,51.68).
city('Mukhor-Shibir','ru','Buryat',5374.0,107.83,51.05).
city('Naushki','ru','Buryatia',3510.0,106.11,50.38).
city('Nizhneangarsk','ru','Buryatia',5493.0,109.55,55.78).
city('Novaya Bryan','ru','Buryatia',4860.0,108.26,51.71).
city('Novoilinsk','ru','Buryatia',5045.0,108.67,51.68).
city('Novokizhinginsk','ru','Buryatia',2214.0,109.62,51.55).
city('Novyy Uoyan','ru','Buryatia',4867.0,111.78,56.24).
city('Onokhoy','ru','Buryatia',10478.0,108.03,51.92).
city('Orlik','ru','Buryatia',2008.0,99.83,52.51).
city('Petropavlovka','ru','Buryatia',7582.0,105.31,50.61).
city('Selenduma','ru','Buryatia',2562.0,106.24,50.91).
city('Selenginsk','ru','Buryatia',16028.0,106.8,52.01).
city('Severobaykalsk','ru','Buryatia',25587.0,109.32,55.65).
city('Severomuysk','ru','Buryatia',3962.0,113.43,56.15).
city('Sokol','ru','Buryatia',5928.0,107.5,51.83).
city('Sosnovo-Ozerskoye','ru','Buryatia',5840.0,111.57,52.52).
city('Sotnikovo','ru','Buryatia',4396.0,107.47,51.87).
city('Taksimo','ru','Buryatia',10359.0,114.88,56.34).
city('Tankhoy','ru','Buryatia',1028.0,105.13,51.55).
city('Tarbagatay','ru','Buryatia',4175.0,107.37,51.5).
city('Tonnelnyy','ru','Buryatia',433.0,113.35,56.28).
city('Turka','ru','Buryatia',1472.0,108.22,52.95).
city('Turuntajevo','ru','Buryatia',6260.0,107.62,52.2).
city('Ulan-Ude','ru','Buryatia',360281.0,107.62,51.83).
city('Ust-Barguzin','ru','Buryatia',7195.0,108.98,53.45).
city('Vydrino','ru','Buryatia',5211.0,104.85,51.49).
city('Yanchukan','ru','Buryatia',529.0,112.81,56.25).
city('Zaigrayevo','ru','Buryatia',5512.0,108.26,51.83).
city('Zakamensk','ru','Buryatia',12250.0,103.27,50.38).
city('Zarechnyy','ru','Buryatia',9806.0,107.53,51.85).
city('Achkhoy-Martan','ru','Chechnya',16779.0,45.29,43.19).
city('Alkhan-Churt','ru','Chechnya',7666.0,44.79,43.35).
city('Alkhan-Kala','ru','Chechnya',10168.0,45.54,43.26).
city('Alkhan-Yurt','ru','Chechnya',8879.0,45.57,43.23).
city('Alkhazurovo','ru','Chechnya',5452.0,45.65,43.06).
city('Alleroy','ru','Chechnya',10247.0,46.28,43.21).
city('Alpatovo','ru','Chechnya',5192.0,45.24,43.7).
city('Assinovskaya','ru','Chechnya',10270.0,45.18,43.24).
city('Avtury','ru','Chechnya',18370.0,46.0,43.16).
city('Bachi-Yurt','ru','Chechnya',14788.0,46.2,43.22).
city('Bamut','ru','Chechnya',5148.0,45.2,43.16).
city('Belgatoy','ru','Chechnya',3254.0,45.83,43.18).
city('Beno-Yurt','ru','Chechnya',5642.0,45.05,43.69).
city('Borzoy','ru','Chechnya',4218.0,45.63,42.84).
city('Bratskoye','ru','Chechnya',5053.0,44.89,43.65).
city('Chechen-Aul','ru','Chechnya',7134.0,45.79,43.2).
city('Chervlyonnaya','ru','Chechnya',7871.0,45.88,43.5).
city('Chiri-Yurt','ru','Chechnya',5136.0,45.74,43.09).
city('Duba-Yurt','ru','Chechnya',5751.0,45.73,43.04).
city('Dyshne-Vedeno','ru','Chechnya',3330.0,46.13,42.96).
city('Dzhalka','ru','Chechnya',6306.0,45.98,43.32).
city('Dzokhar Gala','ru','Chechnya',191315.0,45.7,43.31).
city('Engel-Yurt','ru','Chechnya',5508.0,46.36,43.33).
city('Gekhi','ru','Chechnya',9714.0,45.47,43.17).
city('Geldagan','ru','Chechnya',11901.0,46.04,43.21).
city('Germenchuk','ru','Chechnya',9285.0,45.92,43.19).
city('Gerzel-Aul','ru','Chechnya',3527.0,46.4,43.25).
city('Gikalo','ru','Chechnya',5130.0,45.75,43.29).
city('Goragorskiy','ru','Chechnya',4783.0,45.08,43.5).
city('Goyty','ru','Chechnya',13250.0,45.62,43.16).
city('Grebenskaya','ru','Chechnya',5066.0,46.37,43.53).
city('Gudermes','ru','Chechnya',32769.0,46.11,43.36).
city('Gvardeyskoye','ru','Chechnya',7200.0,44.97,43.68).
city('Ilaskhan-Yurt','ru','Chechnya',4496.0,46.1,43.28).
city('Ishcherskaya','ru','Chechnya',4941.0,45.13,43.72).
city('Ishkhoy-Yurt','ru','Chechnya',3051.0,46.39,43.21).
city('Itum-Kale','ru','Chechnya',2922.0,45.58,42.74).
city('Kalinovskaya','ru','Chechnya',8305.0,45.52,43.58).
city('Kargalinskaya','ru','Chechnya',5371.0,46.48,43.74).
city('Katyr-Yurt','ru','Chechnya',9202.0,45.37,43.17).
city('Khambi-Irze','ru','Chechnya',3130.0,45.45,43.23).
city('Khankala','ru','Chechnya',7925.0,45.75,43.3).
city('Komsomolskoye','ru','Chechnya',5126.0,45.88,43.23).
city('Koshkeldy','ru','Chechnya',5221.0,46.35,43.25).
city('Kulary','ru','Chechnya',4673.0,45.5,43.24).
city('Kurchaloy','ru','Chechnya',20903.0,46.09,43.2).
city('Martan-Chu','ru','Chechnya',5385.0,45.56,43.07).
city('Mayrtup','ru','Chechnya',10778.0,46.13,43.2).
city('Mesker-Yurt','ru','Chechnya',11147.0,45.91,43.25).
city('Nadterechnoye','ru','Chechnya',7877.0,45.34,43.62).
city('Naurskaya','ru','Chechnya',8550.0,45.31,43.65).
city('Novyye Atagi','ru','Chechnya',8760.0,45.78,43.13).
city('Noybera','ru','Chechnya',6821.0,46.28,43.27).
city('Nozhay-Yurt','ru','Chechnya',5073.0,46.38,43.09).
city('Oyskhara','ru','Chechnya',12795.0,46.25,43.26).
city('Pervomayskaya','ru','Chechnya',5026.0,45.53,43.4).
city('Petropavlovskaya','ru','Chechnya',3686.0,45.83,43.38).
city('Prigorodnoye','ru','Chechnya',4863.0,45.76,43.26).
city('Roshni-Chu','ru','Chechnya',4253.0,45.45,43.09).
city('Samashki','ru','Chechnya',10848.0,45.3,43.29).
city('Sernovodskoye','ru','Chechnya',9882.0,45.16,43.31).
city('Serzhen-Yurt','ru','Chechnya',4773.0,45.99,43.12).
city('Shaami-Yurt','ru','Chechnya',3209.0,45.39,43.23).
city('Shalazhi','ru','Chechnya',5319.0,45.36,43.1).
city('Sharoy','ru','Chechnya',203.0,45.81,42.63).
city('Shatoy','ru','Chechnya',1775.0,45.69,42.87).
city('Shela','ru','Chechnya',44037.0,45.9,43.15).
city('Shelkovskaya','ru','Chechnya',9602.0,46.34,43.51).
city('Staraya Sunzha','ru','Chechnya',7860.0,45.74,43.34).
city('Staryye Atagi','ru','Chechnya',10183.0,45.73,43.12).
city('Tolstoy-Yurt','ru','Chechnya',7772.0,45.77,43.44).
city('Tsentoroy','ru','Chechnya',5670.0,46.22,43.01).
city('Tsotsin-Yurt','ru','Chechnya',15970.0,46.0,43.24).
city('Urus-Martan','ru','Chechnya',41480.0,45.54,43.13).
city('Ustargardoyn-Evl','ru','Chechnya',25767.0,45.87,43.3).
city('Valerik','ru','Chechnya',6025.0,45.41,43.18).
city('Vedeno','ru','Chechnya',1472.0,46.1,42.97).
city('Verkhniy Naur','ru','Chechnya',5036.0,45.25,43.61).
city('Yalkhoy-Mokhk','ru','Chechnya',4058.0,46.19,43.1).
city('Zakan-Yurt','ru','Chechnya',4939.0,45.42,43.26).
city('Zandak','ru','Chechnya',3549.0,46.46,43.06).
city('Znamenskoye','ru','Chechnya',9641.0,45.13,43.68).
city('Agapovka','ru','Chelyabins',6362.0,59.14,53.3).
city('Argayash','ru','Chelyabinsk',10096.0,60.88,55.49).
city('Asha','ru','Chelyabinsk',33007.0,57.27,55.0).
city('Bakal','ru','Chelyabinsk',21763.0,58.8,54.94).
city('Bazhovo','ru','Chelyabinsk',11537.0,61.62,55.06).
city('Berdyaush','ru','Chelyabinsk',5631.0,59.14,55.16).
city('Bobrovka','ru','Chelyabinsk',3560.0,61.74,54.05).
city('Bredy','ru','Chelyabinsk',10450.0,60.34,52.42).
city('Brodokalmak','ru','Chelyabinsk',3466.0,62.08,55.57).
city('Chebarkul','ru','Chelyabinsk',46503.0,60.37,54.98).
city('Chelyabinsk','ru','Chelyabinsk',1062931.0,61.43,55.15).
city('Chelyabinsk-40','ru','Chelyabinsk',91096.0,60.7,55.76).
city('Chelyabinsk-70','ru','Chelyabinsk',50086.0,60.73,56.09).
city('Cheremshanka','ru','Chelyabinsk',1161.0,60.31,56.12).
city('Chesma','ru','Chelyabinsk',5789.0,60.67,53.83).
city('Dolgoderevenskoye','ru','Chelyabinsk',6976.0,61.34,55.34).
city('Fershampenuaz','ru','Chelyabinsk',4403.0,59.81,53.52).
city('Fyodorovka','ru','Chelyabinsk',4174.0,61.34,55.09).
city('Gornyak','ru','Chelyabinsk',13946.0,61.69,55.1).
city('Kanashevo','ru','Chelyabinsk',3244.0,62.06,55.21).
city('Karabash','ru','Chelyabinsk',15631.0,60.22,55.48).
city('Kartaly','ru','Chelyabinsk',28504.0,60.67,53.05).
city('Kasli','ru','Chelyabinsk',17911.0,60.76,55.89).
city('Katav-Ivanovsk','ru','Chelyabinsk',19339.0,58.2,54.75).
city('Kizilskoye','ru','Chelyabinsk',6449.0,58.9,52.73).
city('Kopeysk','ru','Chelyabinsk',70786.0,61.65,55.11).
city('Korkino','ru','Chelyabinsk',40047.0,61.4,54.89).
city('Koyelga','ru','Chelyabinsk',4053.0,60.9,54.65).
city('Krasnogorskiy','ru','Chelyabinsk',13603.0,61.22,54.6).
city('Kropachevo','ru','Chelyabinsk',5252.0,57.98,55.02).
city('Kunashak','ru','Chelyabinsk',5950.0,61.55,55.7).
city('Kusa','ru','Chelyabinsk',19819.0,59.44,55.34).
city('Kyshtym','ru','Chelyabinsk',41625.0,60.56,55.7).
city('Leninsk','ru','Chelyabinsk',1701.0,59.87,54.9).
city('Lokomotivnyy','ru','Chelyabinsk',10663.0,60.57,53.0).
city('Magnitka','ru','Chelyabinsk',5784.0,59.7,55.35).
city('Magnitogorsk','ru','Chelyabinsk',413357.0,58.97,53.42).
city('Mezhevoy','ru','Chelyabinsk',5538.0,58.82,55.17).
city('Mezhozyornyy','ru','Chelyabinsk',8222.0,59.37,54.15).
city('Miass','ru','Chelyabinsk',156563.0,60.09,55.0).
city('Miasskoye','ru','Chelyabinsk',9524.0,61.9,55.28).
city('Minyar','ru','Chelyabinsk',10664.0,57.56,55.07).
city('Nizhniy Ufaley','ru','Chelyabinsk',2818.0,59.98,55.92).
city('Novogornyy','ru','Chelyabinsk',8132.0,60.79,55.63).
city('Novosineglazovskiy','ru','Chelyabinsk',14620.0,61.38,55.03).
city('Nyazepetrovsk','ru','Chelyabinsk',12717.0,59.6,56.05).
city('Oktyabrskiy','ru','Chelyabinsk',10198.0,61.8,55.08).
city('Oktyabrskoye','ru','Chelyabinsk',7507.0,62.73,54.4).
city('Pervomayskiy','ru','Chelyabinsk',10681.0,61.17,54.87).
city('Plast','ru','Chelyabinsk',17050.0,60.81,54.37).
city('Poletayevo','ru','Chelyabinsk',6532.0,61.12,55.04).
city('Potanino','ru','Chelyabinsk',8717.0,61.62,55.18).
city('Roshchino','ru','Chelyabinsk',5231.0,61.28,55.31).
city('Roza','ru','Chelyabinsk',14491.0,61.46,54.91).
city('Satka','ru','Chelyabinsk',49384.0,59.04,55.04).
city('Sim','ru','Chelyabinsk',15632.0,57.69,55.0).
city('Starokamyshinsk','ru','Chelyabinsk',11158.0,61.54,55.06).
city('Suleya','ru','Chelyabinsk',2920.0,58.78,55.17).
city('Tayginka','ru','Chelyabinsk',1413.0,60.5,55.62).
city('Timiryazevskiy','ru','Chelyabinsk',3153.0,60.76,54.93).
city('Troitsk','ru','Chelyabinsk',82339.0,61.57,54.1).
city('Tryokhgornyy','ru','Chelyabinsk',34042.0,58.46,54.82).
city('Turgoyak','ru','Chelyabinsk',2275.0,60.12,55.15).
city('Tyubuk','ru','Chelyabinsk',3573.0,60.94,56.05).
city('Ust-Katav','ru','Chelyabinsk',25046.0,58.17,54.94).
city('Uvelskiy','ru','Chelyabinsk',10625.0,61.36,54.44).
city('Uyskoye','ru','Chelyabinsk',7668.0,60.0,54.38).
city('Vakhrushevo','ru','Chelyabinsk',4152.0,61.72,55.23).
city('Varna','ru','Chelyabinsk',9906.0,60.97,53.4).
city('Verkhneuralsk','ru','Chelyabinsk',9844.0,59.21,53.88).
city('Verkhniy Ufaley','ru','Chelyabinsk',33245.0,60.23,56.06).
city('Vishnyovogorsk','ru','Chelyabinsk',5039.0,60.65,55.99).
city('Vyazovaya','ru','Chelyabinsk',2101.0,58.36,54.91).
city('Yemanzhelinka','ru','Chelyabinsk',4117.0,61.26,54.8).
city('Yemanzhelinsk','ru','Chelyabinsk',29849.0,61.3,54.75).
city('Yetkul','ru','Chelyabinsk',6163.0,61.58,54.83).
city('Yuryuzan','ru','Chelyabinsk',13424.0,58.42,54.86).
city('Yuzhnouralsk','ru','Chelyabinsk',38745.0,61.26,54.44).
city('Yuzhnyy','ru','Chelyabinsk',2143.0,60.07,53.55).
city('Zauralskiy','ru','Chelyabinsk',7777.0,61.24,54.79).
city('Zheleznodorozhnyy','ru','Chelyabinsk',7337.0,61.54,55.11).
city('Zlatoust','ru','Chelyabinsk',191369.0,59.65,55.17).
city('Aksha','ru','Chita',3950.0,113.29,50.28).
city('Aksyonovo-Zilovskoye','ru','Chita',4097.0,117.53,53.07).
city('Aleksandrovskiy Zavod','ru','Chita',2516.0,117.95,50.92).
city('Amazar','ru','Chita',2527.0,120.88,53.86).
city('Arbagar','ru','Chita',712.0,116.25,51.93).
city('Atamanovka','ru','Chita',9053.0,113.63,51.93).
city('Bada','ru','Chita',5149.0,109.9,51.38).
city('Baley','ru','Chita',13404.0,116.63,51.6).
city('Balyaga','ru','Chita',3559.0,108.93,51.15).
city('Borzya','ru','Chita',30421.0,116.52,50.38).
city('Bukachacha','ru','Chita',3372.0,116.92,52.98).
city('Chara','ru','Chita',1974.0,118.26,56.91).
city('Chernyshevsk','ru','Chita',12466.0,117.0,52.53).
city('Chita','ru','Chita',308294.0,113.46,52.05).
city('Darasun','ru','Chita',7755.0,113.96,51.66).
city('Dauriya','ru','Chita',4058.0,116.87,49.93).
city('Davenda','ru','Chita',978.0,119.3,53.55).
city('Domna','ru','Chita',6576.0,113.15,51.9).
city('Drovyanaya','ru','Chita',3090.0,113.03,51.58).
city('Gazimurskiy Zavod','ru','Chita',2358.0,118.35,51.55).
city('Itaka','ru','Chita',431.0,118.7,53.88).
city('Kadaya','ru','Chita',1167.0,119.28,50.93).
city('Kalanguy','ru','Chita',2679.0,116.52,51.02).
city('Kalga','ru','Chita',3573.0,118.9,50.92).
city('Karymskoye','ru','Chita',11901.0,114.35,51.62).
city('Khilok','ru','Chita',10627.0,110.45,51.35).
city('Kholbon','ru','Chita',2537.0,116.25,51.88).
city('Klichka','ru','Chita',2514.0,118.0,50.43).
city('Klyuchevskiy','ru','Chita',1621.0,119.43,53.55).
city('Kokuy','ru','Chita',7767.0,117.55,52.21).
city('Krasnokamensk','ru','Chita',54317.0,118.02,50.05).
city('Krasnyy Chikoy','ru','Chita',6824.0,108.75,50.37).
city('Ksenyevka','ru','Chita',3344.0,118.71,53.57).
city('Kurort Darasun','ru','Chita',3275.0,113.7,51.2).
city('Kyra','ru','Chita',4452.0,111.97,49.58).
city('Makkaveyevo','ru','Chita',3922.0,113.97,51.73).
city('Mogocha','ru','Chita',12648.0,119.77,53.73).
city('Mogzon','ru','Chita',4262.0,111.95,51.74).
city('Nerchinsk','ru','Chita',15361.0,116.55,52.0).
city('Nerchinskiy Zavod','ru','Chita',3012.0,119.6,51.32).
city('Nizhniy Tsasuchey','ru','Chita',3278.0,115.13,50.52).
city('Novaya Chara','ru','Chita',4490.0,118.12,56.81).
city('Novokruchininskiy','ru','Chita',9391.0,113.77,51.78).
city('Novopavlovka','ru','Chita',4102.0,109.23,51.22).
city('Oktyabrskiy','ru','Chita',2112.0,118.18,50.08).
city('Olovyannaya','ru','Chita',8247.0,115.57,50.95).
city('Olovyannaya-4','ru','Chita',9324.0,115.55,50.93).
city('Pervomayskiy','ru','Chita',12530.0,115.63,51.67).
city('Petrovsk-Zabaykalskiy','ru','Chita',19843.0,108.83,51.28).
city('Priargunsk','ru','Chita',7902.0,119.1,50.35).
city('Priiskovyy','ru','Chita',1578.0,116.63,51.93).
city('Shelopugino','ru','Chita',3416.0,117.55,51.65).
city('Sherlovaya Gora','ru','Chita',13989.0,116.3,50.53).
city('Shilka','ru','Chita',14133.0,116.03,51.85).
city('Smolenka','ru','Chita',2933.0,113.47,52.15).
city('Sretensk','ru','Chita',7698.0,117.7,52.23).
city('Tarbagatay','ru','Chita',2412.0,109.08,51.18).
city('Tupik','ru','Chita',996.0,119.93,54.43).
city('Ulety','ru','Chita',6075.0,112.48,51.37).
city('Urulga','ru','Chita',3106.0,114.78,51.75).
city('Ust-Karsk','ru','Chita',1947.0,118.8,52.7).
city('Verkh-Usugli','ru','Chita',2573.0,115.19,52.68).
city('Vershino-Darasunskiy','ru','Chita',6451.0,115.52,52.35).
city('Vershino-Shakhtaminskiy','ru','Chita',1633.0,117.9,51.3).
city('Yablonovo','ru','Chita',799.0,112.75,51.83).
city('Zabaykalsk','ru','Chita',9767.0,117.32,49.63).
city('Zhireken','ru','Chita',3766.0,117.33,52.8).
city('Aliskerovo','ru','Chukotka',7.0,16.0,67.77).
city('Anadyr','ru','Chukotka',10318.0,177.48,64.75).
city('Baranikha','ru','Chukotka',31.0,168.25,68.52).
city('Beringovskiy','ru','Chukotka',1861.0,179.32,63.05).
city('Bilibino','ru','Chukotka',5757.0,166.44,68.06).
city('Egvekinot','ru','Chukotka',2248.0,-179.17,66.32).
city('Komsomolskiy','ru','Chukotka',556.0,172.7,69.17).
city('Krasnoarmeyskiy','ru','Chukotka',0.0,172.0,69.58).
city('Lavrentiya','ru','Chukotka',1242.0,-171.0,65.58).
city('Leningradskiy','ru','Chukotka',712.0,178.42,69.38).
city('Mys Shmidta','ru','Chukotka',657.0,-179.5,68.93).
city('Pevek','ru','Chukotka',4832.0,170.38,69.7).
city('Provideniya','ru','Chukotka',2536.0,-173.3,64.38).
city('Shakhtyorskiy','ru','Chukotka',306.0,177.6,64.78).
city('Ugolnye Kopi','ru','Chukotka',3598.0,177.66,64.74).
city('Valkumey','ru','Chukotka',0.0,170.19,69.6).
city('Vstrechnyy','ru','Chukotka',12.0,165.6,67.95).
city('Alikovo','ru','Chuvashia',2886.0,46.75,55.75).
city('Batyrevo','ru','Chuvashia',5648.0,47.61,55.07).
city('Buinsk','ru','Chuvashia',1606.0,47.06,55.2).
city('Cheboksary','ru','Chuvashia',446786.0,47.25,56.13).
city('Ibresi','ru','Chuvashia',9113.0,47.04,55.3).
city('Ishlei','ru','Chuvashia',3160.0,47.05,56.02).
city('Kanash','ru','Chuvashia',49886.0,47.47,55.51).
city('Kirya','ru','Chuvashia',2402.0,46.86,55.08).
city('Komsomolskoye','ru','Chuvashia',4793.0,47.56,55.26).
city('Kozlovka','ru','Chuvashia',13069.0,48.2,55.76).
city('Krasnoarmeyskoye','ru','Chuvashia',4296.0,47.18,55.77).
city('Krasnyye Chetai','ru','Chuvashia',2954.0,46.12,55.68).
city('Kugesi','ru','Chuvashia',11547.0,47.3,56.03).
city('Mariinskiy Posad','ru','Chuvashia',10199.0,47.72,56.11).
city('Morgaushi','ru','Chuvashia',2922.0,46.77,55.97).
city('Novocheboksarsk','ru','Chuvashia',128470.0,47.5,56.12).
city('Novoye Atlashevo','ru','Chuvashia',3515.0,47.56,56.02).
city('Novyye Lapsary','ru','Chuvashia',7582.0,47.22,56.07).
city('Poretskoye','ru','Chuvashia',6420.0,46.33,55.19).
city('Ratorosh','ru','Chuvashia',42340.0,46.6,54.85).
city('Shemursha','ru','Chuvashia',3690.0,47.53,54.88).
city('Shikhazany','ru','Chuvashia',3060.0,47.4,55.56).
city('Shumerlya','ru','Chuvashia',35221.0,46.42,55.49).
city('Sosnovka','ru','Chuvashia',3024.0,47.22,56.18).
city('Tsivilsk','ru','Chuvashia',13636.0,47.47,55.86).
city('Urmary','ru','Chuvashia',6256.0,47.94,55.68).
city('Vurnary','ru','Chuvashia',10825.0,46.96,55.49).
city('Yadrin','ru','Chuvashia',10735.0,46.21,55.94).
city('Yalchiki','ru','Chuvashia',2706.0,48.01,55.16).
city('Yantikovo','ru','Chuvashia',3331.0,47.9,55.82).
city('Achisu','ru','Dag',1737.0,47.68,42.65).
city('Adil-Yangiyurt','ru','Dagestan',4017.0,46.59,43.56).
city('Agvali','ru','Dagestan',2158.0,46.12,42.54).
city('Akhty','ru','Dagestan',14080.0,47.73,41.46).
city('Aknada','ru','Dagestan',4070.0,46.17,42.4).
city('Aksay','ru','Dagestan',8924.0,46.45,43.37).
city('Akusha','ru','Dagestan',4810.0,47.35,42.28).
city('Alburikent','ru','Dagestan',7335.0,47.47,42.97).
city('Andi','ru','Dagestan',5318.0,46.26,42.79).
city('Ansalta','ru','Dagestan',5654.0,46.11,42.69).
city('Babayurt','ru','Dagestan',13857.0,46.78,43.6).
city('Bammatyurt','ru','Dagestan',3863.0,46.61,43.34).
city('Batashyurt','ru','Dagestan',3786.0,46.51,43.31).
city('Batayurt','ru','Dagestan',4093.0,46.69,43.32).
city('Bavtugay','ru','Dagestan',5398.0,46.84,43.17).
city('Belidzhi','ru','Dagestan',8039.0,48.41,41.89).
city('Bezhta','ru','Dagestan',3994.0,46.12,42.13).
city('Botlikh','ru','Dagestan',11131.0,46.22,42.66).
city('Burtunay','ru','Dagestan',4014.0,46.63,42.99).
city('Buynaksk','ru','Dagestan',62690.0,47.12,42.83).
city('Chinar','ru','Dagestan',4665.0,48.14,42.11).
city('Chirkey','ru','Dagestan',7959.0,46.98,42.96).
city('Chontaul','ru','Dagestan',8241.0,46.86,43.3).
city('Dagestanskiye Ogni','ru','Dagestan',27835.0,48.18,42.12).
city('Derbent','ru','Dagestan',105967.0,48.29,42.06).
city('Druzhba','ru','Dagestan',3621.0,48.0,42.24).
city('Dubki','ru','Dagestan',5576.0,46.84,43.02).
city('Durgeli','ru','Dagestan',5185.0,47.3,42.67).
city('Dylym','ru','Dagestan',8069.0,46.64,43.07).
city('Endirey','ru','Dagestan',6927.0,46.65,43.16).
city('Erpeli','ru','Dagestan',3619.0,46.98,42.81).
city('Gagatli','ru','Dagestan',3442.0,46.29,42.8).
city('Gaptsakh','ru','Dagestan',3501.0,47.93,41.45).
city('Gedzhukh','ru','Dagestan',6816.0,48.07,42.12).
city('Gereykhanovskoye','ru','Dagestan',3418.0,48.29,41.7).
city('Gerga','ru','Dagestan',3778.0,47.96,42.35).
city('Gergebil','ru','Dagestan',5107.0,47.07,42.5).
city('Gimry','ru','Dagestan',3599.0,46.84,42.76).
city('Gizilyurt','ru','Dagestan',30114.0,46.87,43.21).
city('Gubden','ru','Dagestan',7997.0,47.57,42.57).
city('Gunib','ru','Dagestan',2576.0,46.96,42.39).
city('Gurbuki','ru','Dagestan',4592.0,47.6,42.61).
city('Izberbash','ru','Dagestan',42122.0,47.86,42.56).
city('Kafyr-Kumukh','ru','Dagestan',4274.0,47.16,42.84).
city('Kakashura','ru','Dagestan',5575.0,47.38,42.65).
city('Kalininaul','ru','Dagestan',4752.0,46.56,43.07).
city('Karabudakhkent','ru','Dagestan',13207.0,47.56,42.71).
city('Karamakhi','ru','Dagestan',3904.0,47.26,42.62).
city('Karata','ru','Dagestan',4838.0,46.34,42.59).
city('Kaspiysk','ru','Dagestan',81753.0,47.64,42.88).
city('Kasumkent','ru','Dagestan',12225.0,48.14,41.68).
city('Kayakent','ru','Dagestan',11805.0,47.9,42.38).
city('Khadzhalmakhi','ru','Dagestan',6088.0,47.18,42.42).
city('Khalimbekaul','ru','Dagestan',4292.0,47.16,42.85).
city('Khamamatyurt','ru','Dagestan',4935.0,46.5,43.61).
city('Khazar','ru','Dagestan',3736.0,48.34,41.99).
city('Khebda','ru','Dagestan',2749.0,46.55,42.44).
city('Khiv','ru','Dagestan',2401.0,47.93,41.75).
city('Khuchni','ru','Dagestan',3637.0,47.95,41.95).
city('Khunzakh','ru','Dagestan',3955.0,46.71,42.54).
city('Kidero','ru','Dagestan',655.0,45.96,42.19).
city('Kishcha','ru','Dagestan',3821.0,47.59,42.18).
city('Kizlyar','ru','Dagestan',50565.0,46.72,43.85).
city('Kochubey','ru','Dagestan',6815.0,46.55,44.39).
city('Kokrek','ru','Dagestan',4181.0,46.73,43.24).
city('Komsomolskiy','ru','Dagestan',2748.0,46.7,43.98).
city('Komsomolskoye','ru','Dagestan',8710.0,46.9,43.2).
city('Korkmaskala','ru','Dagestan',6402.0,47.29,43.02).
city('Kostek','ru','Dagestan',4137.0,46.85,43.34).
city('Kubachi','ru','Dagestan',2977.0,47.6,42.09).
city('Kuli','ru','Dagestan',3893.0,47.25,42.02).
city('Kulzeb','ru','Dagestan',3272.0,47.01,43.17).
city('Kumukh','ru','Dagestan',2658.0,47.12,42.17).
city('Kurakh','ru','Dagestan',3364.0,47.78,41.58).
city('Kurkent','ru','Dagestan',3224.0,48.11,41.71).
city('Kurush','ru','Dagestan',7807.0,47.83,41.28).
city('Kyakhulay','ru','Dagestan',5731.0,47.48,42.97).
city('Leninaul','ru','Dagestan',7503.0,46.57,43.08).
city('Leninkent','ru','Dagestan',13912.0,47.35,42.97).
city('Levashi','ru','Dagestan',7817.0,47.33,42.43).
city('Lutkun','ru','Dagestan',3264.0,47.69,41.48).
city('Madzhalis','ru','Dagestan',6173.0,47.83,42.12).
city('Magaramkent','ru','Dagestan',6708.0,48.35,41.62).
city('Makhachkala','ru','Dagestan',497967.0,47.5,42.98).
city('Mamedkala','ru','Dagestan',8965.0,48.12,42.17).
city('Manaskent','ru','Dagestan',4897.0,47.69,42.73).
city('Mekhelta','ru','Dagestan',2898.0,46.49,42.8).
city('Miatli','ru','Dagestan',4424.0,46.83,43.08).
city('Miskindzha','ru','Dagestan',3611.0,47.84,41.42).
city('Mugi','ru','Dagestan',3377.0,47.42,42.3).
city('Mutsalaul','ru','Dagestan',6219.0,46.73,43.27).
city('Myurego','ru','Dagestan',4548.0,47.69,42.4).
city('Nizhneye Kazanishche','ru','Dagestan',11765.0,47.16,42.76).
city('Nizhniy Dzhengutay','ru','Dagestan',7450.0,47.24,42.7).
city('Novaya Maka','ru','Dagestan',4545.0,48.37,41.78).
city('Novogagatli','ru','Dagestan',4619.0,46.48,43.46).
city('Novokayakent','ru','Dagestan',5991.0,47.99,42.39).
city('Novolakskoye','ru','Dagestan',4463.0,46.48,43.12).
city('Novyy Chirkey','ru','Dagestan',7556.0,47.06,43.16).
city('Novyy Khushet','ru','Dagestan',7912.0,47.56,42.9).
city('Novyy Kostek','ru','Dagestan',4000.0,46.83,43.34).
city('Novyy Sulak','ru','Dagestan',5454.0,46.82,43.21).
city('Nuradilovo','ru','Dagestan',3371.0,46.46,43.29).
city('Paraul','ru','Dagestan',4278.0,47.36,42.74).
city('Pervomayskoye','ru','Dagestan',9073.0,46.71,43.92).
city('Pokrovskoye','ru','Dagestan',3827.0,46.67,43.29).
city('Rutul','ru','Dagestan',4237.0,47.43,41.53).
city('Sabnova','ru','Dagestan',3598.0,48.25,42.06).
city('Samur','ru','Dagestan',3730.0,48.48,41.83).
city('Sergokala','ru','Dagestan',8165.0,47.66,42.45).
city('Shamilkala','ru','Dagestan',7563.0,46.86,42.69).
city('Shamkhal','ru','Dagestan',8375.0,47.33,43.06).
city('Shamkhal-Termen','ru','Dagestan',5774.0,47.31,43.04).
city('Sirtich','ru','Dagestan',4185.0,48.23,41.84).
city('Siukh','ru','Dagestan',3425.0,46.55,42.6).
city('Solnechnoye','ru','Dagestan',4024.0,46.51,43.28).
city('Sovetskoye','ru','Dagestan',4203.0,46.54,42.48).
city('Stalskoye','ru','Dagestan',6535.0,46.97,43.19).
city('Sulak','ru','Dagestan',6800.0,47.51,43.27).
city('Sultan Yangiyurt','ru','Dagestan',11308.0,46.87,43.22).
city('Tarki','ru','Dagestan',10554.0,47.49,42.94).
city('Tarumovka','ru','Dagestan',5245.0,46.54,44.07).
city('Temiraul','ru','Dagestan',3331.0,46.83,43.25).
city('Terekli-Mekteb','ru','Dagestan',7799.0,45.87,44.16).
city('Tlyarota','ru','Dagestan',1898.0,46.36,42.1).
city('Tpig','ru','Dagestan',2823.0,47.59,41.78).
city('Tsurib','ru','Dagestan',1915.0,46.83,42.24).
city('Tyube','ru','Dagestan',6466.0,47.32,43.05).
city('Uchkent','ru','Dagestan',3380.0,47.08,43.11).
city('Ulluaya','ru','Dagestan',5905.0,47.38,42.37).
city('Ullubiyaul','ru','Dagestan',3665.0,47.72,42.59).
city('Untsukul','ru','Dagestan',5913.0,46.79,42.71).
city('Urkarakh','ru','Dagestan',5548.0,47.63,42.16).
city('Urma','ru','Dagestan',3515.0,47.29,42.54).
city('Usisha','ru','Dagestan',4442.0,47.39,42.25).
city('Usukhchay','ru','Dagestan',1966.0,47.91,41.42).
city('Utamysh','ru','Dagestan',3714.0,47.75,42.4).
city('Utsmiyurt','ru','Dagestan',3464.0,46.47,43.53).
city('Vachi','ru','Dagestan',714.0,47.21,42.07).
city('Velikent','ru','Dagestan',4020.0,48.06,42.19).
city('Verkhneye Kazanishche','ru','Dagestan',6444.0,47.14,42.73).
city('Xasun-Yurt','ru','Dagestan',134595.0,46.59,43.25).
city('Yuzhno-Sukhokumsk','ru','Dagestan',9913.0,45.45,44.7).
city('Zubutli-Miatli','ru','Dagestan',4918.0,46.81,43.2).
city('Ali-Yurt','ru','Ingushetia',7593.0,44.85,43.15).
city('Dolakovo','ru','Ingushetia',9994.0,44.6,43.23).
city('Dzheyrakh','ru','Ingushetia',1174.0,44.69,42.81).
city('Ekazhevo','ru','Ingushetia',25549.0,44.82,43.22).
city('Galashki','ru','Ingushetia',6928.0,44.97,43.12).
city('Kantyshevo','ru','Ingushetia',17363.0,44.63,43.22).
city('Karabulak','ru','Ingushetia',34512.0,44.9,43.3).
city('Malgobek','ru','Ingushetia',46340.0,44.58,43.54).
city('Nazran','ru','Ingushetia',164142.0,44.8,43.21).
city('Nesterovskaya','ru','Ingushetia',19186.0,45.03,43.23).
city('Nizhniye Achaluki','ru','Ingushetia',5248.0,44.75,43.4).
city('Novyy Redant','ru','Ingushetia',4990.0,44.88,43.48).
city('Ordzhonikidzevskaya','ru','Ingushetia',71841.0,45.04,43.32).
city('Psedakh','ru','Ingushetia',6964.0,44.57,43.47).
city('Sagopshi','ru','Ingushetia',11848.0,44.58,43.49).
city('Sredniye Achaluki','ru','Ingushetia',5643.0,44.68,43.34).
city('Surkhakhi','ru','Ingushetia',16215.0,44.91,43.19).
city('Troitskaya','ru','Ingushetia',23745.0,45.01,43.3).
city('Verkhniye Achaluki','ru','Ingushetia',9393.0,44.7,43.35).
city('Voznesenskaya','ru','Ingushetia',6972.0,44.74,43.54).
city('Yandyrka','ru','Ingushetia',11730.0,44.92,43.27).
city('Alekseyevsk','ru','Irkutsk',3082.0,108.4,57.85).
city('Alzamay','ru','Irkutsk',7058.0,98.66,55.56).
city('Angarsk','ru','Irkutsk',243161.0,103.91,52.57).
city('Artyomovskiy','ru','Irkutsk',2128.0,114.64,58.21).
city('Atagay','ru','Irkutsk',1805.0,99.39,55.1).
city('Balagansk','ru','Irkutsk',4195.0,103.05,54.01).
city('Balakhninskiy','ru','Irkutsk',1675.0,114.28,58.01).
city('Baykal','ru','Irkutsk',491.0,104.79,51.88).
city('Baykalsk','ru','Irkutsk',15530.0,104.15,51.51).
city('Biryusinsk','ru','Irkutsk',9583.0,97.81,55.96).
city('Bodaybo','ru','Irkutsk',15934.0,114.19,57.85).
city('Bolshaya Rechka','ru','Irkutsk',2368.0,104.73,51.95).
city('Bolshoy Lug','ru','Irkutsk',4391.0,104.1,52.12).
city('Bratsk','ru','Irkutsk',259994.0,10.0,56.3).
city('Cheremkhovo','ru','Irkutsk',57395.0,103.07,53.16).
city('Chunskiy','ru','Irkutsk',16199.0,99.65,56.09).
city('Gorno-Chuyskiy','ru','Irkutsk',605.0,111.73,57.63).
city('Irkutsk','ru','Irkutsk',586702.0,104.24,52.33).
city('Kachug','ru','Irkutsk',7532.0,105.88,53.96).
city('Kazachinskoye','ru','Irkutsk',2581.0,107.58,56.27).
city('Khomutovo','ru','Irkutsk',4918.0,104.4,52.47).
city('Khrebtovaya','ru','Irkutsk',2017.0,104.25,56.71).
city('Khuzhir','ru','Irkutsk',1118.0,107.34,53.19).
city('Kirensk','ru','Irkutsk',13309.0,108.11,57.79).
city('Kitoy','ru','Irkutsk',3953.0,103.9,52.6).
city('Kropotkin','ru','Irkutsk',1765.0,115.32,58.51).
city('Kultuk','ru','Irkutsk',4151.0,103.68,51.72).
city('Kunerma','ru','Irkutsk',157.0,108.48,55.75).
city('Kuytun','ru','Irkutsk',10566.0,101.5,54.34).
city('Kvitok','ru','Irkutsk',3155.0,98.47,56.08).
city('Lesogorsk','ru','Irkutsk',5809.0,99.52,56.04).
city('Listvyanka','ru','Irkutsk',1700.0,104.86,51.86).
city('Lugovskiy','ru','Irkutsk',617.0,112.89,58.06).
city('Magistralnyy','ru','Irkutsk',7429.0,107.45,56.17).
city('Mama','ru','Irkutsk',4239.0,112.9,58.31).
city('Mamakan','ru','Irkutsk',2229.0,114.0,57.82).
city('Markova','ru','Irkutsk',6340.0,107.09,57.32).
city('Meget','ru','Irkutsk',8370.0,104.05,52.42).
city('Mikhaylovka','ru','Irkutsk',7937.0,103.28,52.96).
city('Mishelevka','ru','Irkutsk',7529.0,103.17,52.86).
city('Nizhneudinsk','ru','Irkutsk',38724.0,99.03,54.9).
city('Novaya Igirma','ru','Irkutsk',10681.0,103.91,57.14).
city('Novobiryusinskiy','ru','Irkutsk',4855.0,97.72,56.96).
city('Oktyabrskiy','ru','Irkutsk',5713.0,99.43,56.07).
city('Oyek','ru','Irkutsk',3380.0,104.46,52.59).
city('Pokosnoye','ru','Irkutsk',3110.0,101.05,55.53).
city('Rudnogorsk','ru','Irkutsk',4441.0,103.75,57.27).
city('Sayansk','ru','Irkutsk',45476.0,102.1,53.99).
city('Shelekhov','ru','Irkutsk',47459.0,104.1,52.21).
city('Shestakovo','ru','Irkutsk',1084.0,103.96,56.48).
city('Shitkino','ru','Irkutsk',2363.0,98.34,56.37).
city('Shumskiy','ru','Irkutsk',3095.0,99.13,54.83).
city('Slyudyanka','ru','Irkutsk',18810.0,103.71,51.66).
city('Sogdiondon','ru','Irkutsk',566.0,112.16,57.69).
city('Svirsk','ru','Irkutsk',14717.0,103.33,53.09).
city('Tayshet','ru','Irkutsk',37767.0,97.99,55.93).
city('Tayturka','ru','Irkutsk',5100.0,103.46,52.87).
city('Telma','ru','Irkutsk',4022.0,103.71,52.7).
city('Tulun','ru','Irkutsk',51331.0,100.57,54.56).
city('Tyret Pervaya','ru','Irkutsk',4082.0,102.3,53.66).
city('Uk','ru','Irkutsk',2342.0,98.85,55.08).
city('Ulkan','ru','Irkutsk',5701.0,107.35,57.24).
city('Usolye-Sibirskoye','ru','Irkutsk',86903.0,103.63,52.76).
city('Ust-Ilimsk','ru','Irkutsk',100272.0,102.66,58.0).
city('Ust-Kut','ru','Irkutsk',48203.0,105.65,56.77).
city('Ust-Uda','ru','Irkutsk',5169.0,103.04,54.17).
city('Vidim','ru','Irkutsk',1415.0,103.11,56.41).
city('Vikhorevka','ru','Irkutsk',24918.0,101.25,56.09).
city('Vitimskiy','ru','Irkutsk',885.0,113.27,58.22).
city('Yantal','ru','Irkutsk',2383.0,105.24,56.85).
city('Yelantsy','ru','Irkutsk',3664.0,106.39,57.8).
city('Yerbogachen','ru','Irkutsk',2019.0,108.01,61.28).
city('Yurty','ru','Irkutsk',5902.0,97.63,56.05).
city('Zalari','ru','Irkutsk',9781.0,102.51,53.56).
city('Zheleznodorozhnyy','ru','Irkutsk',7629.0,102.79,57.9).
city('Zheleznogorsk-Ilimskiy','ru','Irkutsk',28456.0,104.12,56.57).
city('Zhigalovo','ru','Irkutsk',5272.0,105.16,54.81).
city('Zima','ru','Irkutsk',33324.0,102.04,53.93).
city('Zvyozdnyy','ru','Irkutsk',1196.0,106.48,56.75).
city('Arkhipovka','ru','Ivanovo',1741.0,41.25,56.66).
city('Bogorodskoye','ru','Ivanovo',2998.0,41.02,57.05).
city('Dolmatovskiy','ru','Ivanovo',423.0,42.33,57.5).
city('Dulyapino','ru','Ivanovo',1456.0,40.81,57.25).
city('Furmanov','ru','Ivanovo',38381.0,41.1,57.25).
city('Gavrilov Posad','ru','Ivanovo',6948.0,40.12,56.56).
city('Ilinskoye-Khovanskoye','ru','Ivanovo',3640.0,39.77,56.97).
city('Ivankovskiy','ru','Ivanovo',451.0,40.08,56.65).
city('Ivanovo','ru','Ivanovo',420843.0,40.99,57.01).
city('Kamenka','ru','Ivanovo',4124.0,41.79,57.39).
city('Kaminskiy','ru','Ivanovo',1645.0,41.47,57.16).
city('Kholuy','ru','Ivanovo',996.0,41.87,56.58).
city('Kineshma','ru','Ivanovo',92984.0,42.13,57.44).
city('Kitovo','ru','Ivanovo',2934.0,41.3,56.87).
city('Kokhma','ru','Ivanovo',28984.0,41.09,56.93).
city('Kolobovo','ru','Ivanovo',2910.0,41.34,56.71).
city('Komsomolsk','ru','Ivanovo',9156.0,40.38,57.03).
city('Lezhnyovo','ru','Ivanovo',8031.0,40.89,56.78).
city('Lukh','ru','Ivanovo',3157.0,42.26,57.01).
city('Markovo','ru','Ivanovo',1253.0,40.5,57.02).
city('Mosta','ru','Ivanovo',622.0,42.16,56.53).
city('Mugreyevskiy','ru','Ivanovo',917.0,42.35,56.6).
city('Navoloki','ru','Ivanovo',10951.0,41.96,57.47).
city('Nerl','ru','Ivanovo',2292.0,40.38,56.66).
city('Novopistsovo','ru','Ivanovo',3064.0,41.84,57.32).
city('Novotalitsy','ru','Ivanovo',8543.0,40.87,57.02).
city('Novoye Leushino','ru','Ivanovo',1565.0,40.53,56.8).
city('Novyye Gorki','ru','Ivanovo',2877.0,41.07,56.74).
city('Oktyabrskiy','ru','Ivanovo',1228.0,40.33,57.13).
city('Ozyornyy','ru','Ivanovo',831.0,40.98,57.17).
city('Palekh','ru','Ivanovo',5616.0,41.86,56.8).
city('Panfilovo','ru','Ivanovo',289.0,41.18,56.68).
city('Pestyaki','ru','Ivanovo',4172.0,42.67,56.71).
city('Petrovskiy','ru','Ivanovo',2943.0,40.32,56.65).
city('Pistsovo','ru','Ivanovo',2775.0,40.53,57.18).
city('Plyos','ru','Ivanovo',2589.0,41.5,57.46).
city('Podozyorskiy','ru','Ivanovo',1120.0,40.33,57.23).
city('Privolzhsk','ru','Ivanovo',17865.0,41.29,57.38).
city('Puchezh','ru','Ivanovo',9881.0,43.17,56.98).
city('Rodniki','ru','Ivanovo',27681.0,41.73,57.1).
city('Savino','ru','Ivanovo',6133.0,41.21,56.6).
city('Shuya','ru','Ivanovo',60705.0,41.36,56.85).
city('Staraya Vichuga','ru','Ivanovo',5599.0,41.88,57.27).
city('Talitsy','ru','Ivanovo',6003.0,42.33,56.53).
city('Teykovo','ru','Ivanovo',36016.0,40.54,56.85).
city('Verkhniy Landekh','ru','Ivanovo',2009.0,42.6,56.84).
city('Vichuga','ru','Ivanovo',39072.0,41.93,57.21).
city('Yuryevets','ru','Ivanovo',11921.0,43.11,57.33).
city('Yuzha','ru','Ivanovo',14678.0,42.01,56.58).
city('Zarechnyy','ru','Ivanovo',1335.0,42.29,57.47).
city('Zavolzhsk','ru','Ivanovo',12847.0,42.14,57.48).
city('Amurzet','ru','Jewish Republic',5213.0,131.1,47.7).
city('Babstovo','ru','Jewish Republic',3685.0,132.48,48.12).
city('Bira','ru','Jewish Republic',4176.0,132.47,49.0).
city('Birakan','ru','Jewish Republic',2463.0,131.7,49.02).
city('Birobidzhan','ru','Jewish Republic',76146.0,132.95,48.8).
city('Imeni Telmana','ru','Jewish Republic',1075.0,134.98,48.55).
city('Izvestkovyy','ru','Jewish Republic',2159.0,131.55,48.98).
city('Khingansk','ru','Jewish Republic',2093.0,131.18,49.12).
city('Kuldur','ru','Jewish Republic',1896.0,131.63,49.22).
city('Leninskoye','ru','Jewish Republic',6827.0,132.62,47.94).
city('Londoko','ru','Jewish Republic',1298.0,131.98,49.03).
city('Nikolayevka','ru','Jewish Republic',7410.0,134.77,48.55).
city('Obluche','ru','Jewish Republic',10777.0,131.08,49.0).
city('Priamurskiy','ru','Jewish Republic',3560.0,134.92,48.52).
city('Smidovich','ru','Jewish Republic',5720.0,133.82,48.6).
city('Teploozyorsk','ru','Jewish Republic',4963.0,131.87,49.01).
city('Volochayevka-Vtoraya','ru','Jewish Republic',1971.0,134.56,48.58).
city('Aleksandrovskaya','ru','Kabardino-Balkaria',4014.0,43.65,43.48).
city('Altud','ru','Kabardino-Balkaria',5578.0,43.87,43.72).
city('Argudan','ru','Kabardino-Balkaria',8250.0,43.92,43.42).
city('Aushiger','ru','Kabardino-Balkaria',4955.0,43.73,43.4).
city('Baksan','ru','Kabardino-Balkaria',37520.0,43.54,43.69).
city('Baksanenok','ru','Kabardino-Balkaria',7058.0,43.65,43.69).
city('Belaya Rechka','ru','Kabardino-Balkaria',3424.0,43.54,43.44).
city('Chegem','ru','Kabardino-Balkaria',18429.0,43.13,43.28).
city('Chegem Vtoroy','ru','Kabardino-Balkaria',10951.0,43.6,43.6).
city('Deyskoye','ru','Kabardino-Balkaria',4736.0,44.16,43.48).
city('Dokshukino','ru','Kabardino-Balkaria',35020.0,43.76,43.59).
city('Dugulubgey','ru','Kabardino-Balkaria',20965.0,43.54,43.66).
city('Elbrus','ru','Kabardino-Balkaria',3476.0,42.65,43.26).
city('Germenchik','ru','Kabardino-Balkaria',4129.0,43.77,43.59).
city('Islamey','ru','Kabardino-Balkaria',10899.0,43.46,43.68).
city('Kakhun','ru','Kabardino-Balkaria',7490.0,43.88,43.54).
city('Kamenka','ru','Kabardino-Balkaria',3525.0,43.52,43.53).
city('Kamennomostskoye','ru','Kabardino-Balkaria',6316.0,43.05,43.74).
city('Karagach','ru','Kabardino-Balkaria',5870.0,43.78,43.81).
city('Kashkhatau','ru','Kabardino-Balkaria',5367.0,43.61,43.32).
city('Kenzhe','ru','Kabardino-Balkaria',10636.0,43.56,43.5).
city('Khasanya','ru','Kabardino-Balkaria',10495.0,43.58,43.43).
city('Kishpek','ru','Kabardino-Balkaria',4327.0,43.64,43.66).
city('Kotlyarevskaya','ru','Kabardino-Balkaria',3887.0,44.06,43.58).
city('Kuba-Taba','ru','Kabardino-Balkaria',3179.0,43.44,43.78).
city('Kyzburun Pervyy','ru','Kabardino-Balkaria',5833.0,43.4,43.65).
city('Lechinkay','ru','Kabardino-Balkaria',4334.0,43.43,43.56).
city('Malka','ru','Kabardino-Balkaria',7220.0,43.32,43.8).
city('Mayskiy','ru','Kabardino-Balkaria',27522.0,44.07,43.68).
city('Nalchik','ru','Kabardino-Balkaria',282916.0,43.62,43.5).
city('Nartan','ru','Kabardino-Balkaria',12694.0,43.7,43.51).
city('Nizhne Bakhsen','ru','Kabardino-Balkaria',19886.0,42.92,43.42).
city('Nizhniy Cherek','ru','Kabardino-Balkaria',3098.0,43.91,43.51).
city('Nizhniy Kurkuzhin','ru','Kabardino-Balkaria',3674.0,43.35,43.75).
city('Planovskoye','ru','Kabardino-Balkaria',3482.0,44.2,43.4).
city('Primalkinskoye','ru','Kabardino-Balkaria',4873.0,44.01,43.75).
city('Psygansu','ru','Kabardino-Balkaria',6885.0,43.79,43.42).
city('Qalechykh','ru','Kabardino-Balkaria',62831.0,44.01,43.76).
city('Sarmakovo','ru','Kabardino-Balkaria',9588.0,43.2,43.75).
city('Shalushka','ru','Kabardino-Balkaria',11577.0,43.57,43.53).
city('Soldatskaya','ru','Kabardino-Balkaria',4651.0,43.82,43.82).
city('Staryy Cherek','ru','Kabardino-Balkaria',6702.0,43.85,43.47).
city('Staryy Urukh','ru','Kabardino-Balkaria',3848.0,44.02,43.34).
city('Terek','ru','Kabardino-Balkaria',21180.0,44.14,43.48).
city('Urukh','ru','Kabardino-Balkaria',4360.0,44.03,43.29).
city('Urvan','ru','Kabardino-Balkaria',5484.0,43.76,43.49).
city('Verkhniy Kurkuzhin','ru','Kabardino-Balkaria',3129.0,43.27,43.7).
city('Verkhnyaya Balkariya','ru','Kabardino-Balkaria',4076.0,43.46,43.13).
city('Yekaterinogradskaya','ru','Kabardino-Balkaria',3841.0,44.22,43.76).
city('Zalukokoazhe','ru','Kabardino-Balkaria',9554.0,43.22,43.9).
city('Zayukovo','ru','Kabardino-Balkaria',10559.0,43.33,43.62).
city('Zhemtala','ru','Kabardino-Balkaria',3266.0,43.66,43.29).
city('Baltiysk','ru','Kaliningrad',34541.0,19.91,54.65).
city('Chernyakhovsk','ru','Kaliningrad',45188.0,21.81,54.63).
city('Donskoye','ru','Kaliningrad',3212.0,19.98,54.95).
city('Guryevsk','ru','Kaliningrad',11653.0,20.61,54.77).
city('Gusev','ru','Kaliningrad',28690.0,22.2,54.59).
city('Gvardeysk','ru','Kaliningrad',15099.0,21.07,54.65).
city('Kaliningrad','ru','Kaliningrad',434959.0,20.5,54.71).
city('Krasnoznamensk','ru','Kaliningrad',3724.0,22.49,54.94).
city('Ladushkin','ru','Kaliningrad',3928.0,20.17,54.57).
city('Mamonovo','ru','Kaliningrad',7271.0,19.94,54.47).
city('Neman','ru','Kaliningrad',12507.0,22.03,55.03).
city('Nesterov','ru','Kaliningrad',5072.0,22.57,54.63).
city('Ozyorsk','ru','Kaliningrad',5706.0,22.01,54.41).
city('Pionerskiy','ru','Kaliningrad',11856.0,20.22,54.95).
city('Polessk','ru','Kaliningrad',7835.0,21.11,54.86).
city('Pravdinsk','ru','Kaliningrad',4515.0,21.02,54.44).
city('Preussisch Eylau','ru','Kaliningrad',7307.0,20.65,54.39).
city('Primore','ru','Kaliningrad',859.0,20.04,54.94).
city('Pri','ru','Kaliningrad',2222.0,20.01,54.74).
city('Rushiai','ru','Kaliningrad',10812.0,20.15,54.94).
city('Rybachiy','ru','Kaliningrad',973.0,20.83,55.17).
city('Slavsk','ru','Kaliningrad',5248.0,21.67,55.04).
city('Sovetsk','ru','Kaliningrad',43310.0,21.88,55.07).
city('Svetlyy','ru','Kaliningrad',22119.0,20.13,54.68).
city('Vasilkovo','ru','Kaliningrad',4292.0,20.63,54.74).
city('Yantarnyy','ru','Kaliningrad',5527.0,19.94,54.87).
city('Yuzhnyy','ru','Kaliningrad',3111.0,20.6,54.55).
city('Zelenogradsk','ru','Kaliningra',12846.0,20.49,54.96).
city('Zheleznodorozhnyy','ru','Kaliningrad',2984.0,21.31,54.36).
city('Znamensk','ru','Kaliningrad',4359.0,21.27,54.61).
city('Arshan','ru','Kalmykia',3542.0,44.22,46.27).
city('Bolshoy Tsaryn','ru','Kalmykia',4936.0,45.42,47.85).
city('Elista','ru','Kalmykia',106972.0,44.21,46.32).
city('Gorodovikovsk','ru','Kalmykia',10706.0,41.97,46.14).
city('Iki-Burul','ru','Kalmykia',3709.0,44.65,45.82).
city('Kaspiyskiy','ru','Kalmykia',14045.0,47.37,45.39).
city('Ketchenery','ru','Kalmykia',3834.0,44.52,47.31).
city('Komsomolskiy','ru','Kalmykia',3878.0,46.04,45.33).
city('Malyye Derbety','ru','Kalmykia',5822.0,44.67,47.95).
city('Priyutnoye','ru','Kalmykia',5632.0,43.51,46.1).
city('Sadovoye','ru','Kalmykia',6333.0,44.51,47.77).
city('Troitskoye','ru','Kalmykia',10025.0,44.26,46.42).
city('Tsagan Aman','ru','Kalmykia',5769.0,46.72,47.57).
city('Yashalta','ru','Kalmykia',4723.0,42.27,46.34).
city('Yashkul','ru','Kalmykia',7203.0,45.34,46.17).
city('Babynino','ru','Kaluga',4009.0,35.74,54.39).
city('Balabanovo','ru','Kaluga',24233.0,36.66,55.18).
city('Baryatino','ru','Kaluga',2645.0,34.52,54.31).
city('Belousovo','ru','Kaluga',8421.0,36.68,55.09).
city('Betlitsa','ru','Kaluga',3825.0,33.96,54.02).
city('Borovsk','ru','Kaluga',11578.0,36.49,55.21).
city('Detchino','ru','Kaluga',4838.0,36.32,54.8).
city('Dugna','ru','Kaluga',783.0,36.85,54.42).
city('Duminichi','ru','Kaluga',7779.0,35.1,53.91).
city('Ferzikovo','ru','Kaluga',4344.0,36.77,54.52).
city('Imeni Lva Tolstogo','ru','Kaluga',3554.0,36.04,54.61).
city('Iznoski','ru','Kaluga',1905.0,35.31,54.99).
city('Kaluga','ru','Kaluga',338982.0,36.27,54.54).
city('Khvastovichi','ru','Kaluga',4545.0,35.1,53.47).
city('Kirov','ru','Kaluga',39319.0,34.31,54.08).
city('Kondrovo','ru','Kaluga',17151.0,35.93,54.81).
city('Kozelsk','ru','Kaluga',19809.0,35.78,54.04).
city('Kremenki','ru','Kaluga',11994.0,37.13,54.89).
city('Kudinovo','ru','Kaluga',3381.0,36.25,54.98).
city('Kurovskoy','ru','Kaluga',3648.0,36.02,54.53).
city('Lyudinovo','ru','Kaluga',41392.0,34.45,53.87).
city('Maloyaroslavets','ru','Kaluga',32669.0,36.47,55.01).
city('Medyn','ru','Kaluga',7791.0,35.86,54.97).
city('Meshchovsk','ru','Kaluga',4386.0,35.28,54.32).
city('Mosalsk','ru','Kaluga',4320.0,34.98,54.49).
city('Myatlevo','ru','Kaluga',1969.0,35.68,54.89).
city('Obninsk','ru','Kaluga',107394.0,36.61,55.1).
city('Peremyshl','ru','Kaluga',3199.0,36.16,54.26).
city('Polotnyanyy Zavod','ru','Kaluga',5679.0,35.97,54.72).
city('Pyatovskiy','ru','Kaluga',2986.0,36.09,54.69).
city('Seredeyskiy','ru','Kaluga',1927.0,35.23,54.05).
city('Sosenskiy','ru','Kaluga',12484.0,35.96,54.06).
city('Spas-Demensk','ru','Kaluga',5114.0,34.02,54.41).
city('Sukhinichi','ru','Kaluga',16100.0,35.34,54.1).
city('Tarusa','ru','Kaluga',10181.0,37.18,54.72).
city('Tovarkovo','ru','Kaluga',14294.0,35.94,54.68).
city('Ulyanovo','ru','Kaluga',3051.0,35.54,53.72).
city('Vorotynsk','ru','Kaluga',10977.0,36.05,54.43).
city('Yermolino','ru','Kaluga',9350.0,36.6,55.0).
city('Yukhnov','ru','Kaluga',7934.0,35.23,54.74).
city('Zhiletovo','ru','Kaluga',2998.0,36.02,54.7).
city('Zhizdra','ru','Kaluga',5737.0,34.74,53.75).
city('Zhukovo','ru','Kaluga',12170.0,36.74,55.03).
city('Esso','ru','Kamchatka',1965.0,158.7,55.93).
city('Klyuchi','ru','Kamchatka',6496.0,160.85,56.3).
city('Kozyryovsk','ru','Kamchatka',1445.0,159.87,56.07).
city('Milkovo','ru','Kamchatka',8726.0,158.62,54.72).
city('Nikolskoye','ru','Kamchatka',763.0,165.99,55.19).
city('Oktyabrskiy','ru','Kamchatka',2201.0,156.24,52.66).
city('Ozernovskiy','ru','Kamchatka',2615.0,156.52,51.5).
city('Petropavlovsk-Kamchatskiy','ru','Kamchatka',187283.0,158.65,53.02).
city('Petropavlovsk-Kamchatskiy-50','ru','Kamchatka',22815.0,158.62,53.07).
city('Sobolevo','ru','Kamchatka',1787.0,155.92,54.27).
city('Ust-Bolsheretsk','ru','Kamchatka',2150.0,156.28,52.82).
city('Ust-Kamchatsk','ru','Kamchatka',4939.0,162.46,56.23).
city('Yelizovo','ru','Kamchatka',40692.0,158.38,53.18).
city('Adyge-Khabl','ru','Karachai-Cherkess Republic',3666.0,41.94,44.33).
city('Ali-Berdukovskiy','ru','Karachai-Cherkess Republic',5093.0,41.75,43.99).
city('Besleney','ru','Karachai-Cherkess Republic',3189.0,41.74,44.24).
city('Cherkessk','ru','Karachai-Cherkess Republic',117157.0,42.06,44.29).
city('Dombay','ru','Karachai-Cherkess Republic',405.0,41.62,43.29).
city('Druzhba','ru','Karachai-Cherkess Republic',3153.0,42.02,44.2).
city('Dzheguta','ru','Karachai-Cherkess Republic',3734.0,42.05,43.95).
city('Elbrusskiy','ru','Karachai-Cherkess Republic',243.0,42.14,43.56).
city('Erken-Shakhar','ru','Karachai-Cherkess Republic',4170.0,41.98,44.32).
city('Ikon-Khalk','ru','Karachai-Cherkess Republic',4220.0,41.92,44.31).
city('Ispravnaya','ru','Karachai-Cherkess Republic',4606.0,41.61,44.07).
city('Kardonikskaya','ru','Karachai-Cherkess Republic',7830.0,41.72,43.86).
city('Kavkazskiy','ru','Karachai-Cherkess Republic',3052.0,42.23,44.27).
city('Khabez','ru','Karachai-Cherkess Republic',5806.0,41.77,44.05).
city('Krasnyy Kurgan','ru','Karachai-Cherkess Republic',3243.0,42.61,43.94).
city('Kumysh','ru','Karachai-Cherkess Republic',4306.0,41.9,43.88).
city('Kurdzhinovo','ru','Karachai-Cherkess Republic',4234.0,40.96,43.99).
city('Kyzyl-Oktyabr','ru','Karachai-Cherkess Republic',3603.0,41.79,43.82).
city('Mednogorskiy','ru','Karachai-Cherkess Republic',4328.0,41.19,43.91).
city('Novyy Karachay','ru','Karachai-Cherkess Republic',2172.0,41.9,43.82).
city('Ordzhonikidzevskiy','ru','Karachai-Cherkess Republic',3246.0,41.9,43.84).
city('Pervomayskoye','ru','Karachai-Cherkess Republic',5345.0,42.48,43.94).
city('Pravokubanskiy','ru','Karachai-Cherkess Republic',2971.0,41.89,43.92).
city('Pregradnaya','ru','Karachai-Cherkess Republic',6595.0,41.2,43.95).
city('Psyzh','ru','Karachai-Cherkess Republic',6840.0,42.02,44.23).
city('Qaracay Sahar','ru','Karachai-Cherkess Republic',22313.0,41.91,43.78).
city('Sary-Tyuz','ru','Karachai-Cherkess Republic',3188.0,41.9,43.9).
city('Storozhevaya','ru','Karachai-Cherkess Republic',7986.0,41.44,43.88).
city('Teberda','ru','Karachai-Cherkess Republic',7705.0,41.75,43.44).
city('Tereze','ru','Karachai-Cherkess Republic',6335.0,42.44,43.93).
city('Uchkeken','ru','Karachai-Cherkess Republic',15118.0,42.51,43.94).
city('Udarnyy','ru','Karachai-Cherkess Republic',1142.0,42.51,44.35).
city('Ust-Dzheguta','ru','Karachai-Cherkess Republic',34001.0,41.97,44.09).
city('Zelenchukskaya','ru','Karachai-Cherkess Republic',21117.0,41.59,43.86).
city('Belomorsk','ru','Karelia',12165.0,34.77,64.53).
city('Chupa','ru','Karelia',3954.0,33.06,66.27).
city('Ilinskiy','ru','Karelia',3119.0,32.66,61.01).
city('Kalevala','ru','Karelia',5431.0,31.17,65.2).
city('Kem','ru','Karelia',13830.0,34.57,64.95).
city('Khelyulya','ru','Karelia',3082.0,30.68,61.73).
city('Kondopoga','ru','Karelia',34360.0,34.28,62.2).
city('Kostomuksha','ru','Karelia',30138.0,30.82,64.68).
city('Lakhdenpokhya','ru','Karelia',8448.0,30.18,61.52).
city('Loukhi','ru','Karelia',5764.0,33.04,66.08).
city('Lyaskelya','ru','Karelia',3571.0,31.02,61.77).
city('Medvezhyegorsk','ru','Karelia',16773.0,34.45,62.92).
city('Muyezerskiy','ru','Karelia',3901.0,31.64,63.94).
city('Nadvoitsy','ru','Karelia',10780.0,34.32,63.87).
city('Olonets','ru','Karelia',10006.0,32.97,60.98).
city('Petrozavodsk','ru','Karelia',265027.0,34.33,61.82).
city('Pindushi','ru','Karelia',5053.0,34.58,62.92).
city('Pitkyaranta','ru','Karelia',13090.0,31.48,61.57).
city('Porosozero','ru','Karelia',3436.0,32.7,62.72).
city('Povenets','ru','Karelia',2539.0,34.85,62.85).
city('Pryazha','ru','Karelia',4156.0,33.62,61.7).
city('Pudozh','ru','Karelia',10605.0,36.53,61.8).
city('Pyaozerskiy','ru','Karelia',2534.0,31.17,65.83).
city('Segezha','ru','Karelia',33354.0,34.33,63.75).
city('Sheltozero','ru','Karelia',1012.0,35.37,61.37).
city('Shuya','ru','Karelia',3261.0,34.25,61.92).
city('Sortavala','ru','Karelia',20760.0,30.68,61.7).
city('Suoyarvi','ru','Karelia',10834.0,32.35,62.08).
city('Vyartsilya','ru','Karelia',3145.0,30.68,62.18).
city('Abagur','ru','Kemerovo',6530.0,87.23,53.72).
city('Anzhero-Sudzhensk','ru','Kemerovo',82527.0,86.04,56.08).
city('Artyshta','ru','Kemerovo',3090.0,86.28,54.13).
city('Bachatskiy','ru','Kemerovo',14618.0,86.1,54.25).
city('Barzas','ru','Kemerovo',2230.0,86.31,55.72).
city('Belogorsk','ru','Kemerovo',3452.0,88.49,55.02).
city('Belovo','ru','Kemerovo',79424.0,86.3,54.42).
city('Berikulskiy','ru','Kemerovo',932.0,88.14,55.53).
city('Beryozovskiy','ru','Kemerovo',47860.0,86.26,55.67).
city('Borovoy','ru','Kemerovo',5942.0,86.08,55.43).
city('Chistogorskiy','ru','Kemerovo',4240.0,87.33,53.98).
city('Chugunash','ru','Kemerovo',657.0,87.77,52.87).
city('Gramoteino','ru','Kemerovo',14010.0,86.37,54.52).
city('Guryevsk','ru','Kemerovo',27160.0,85.94,54.29).
city('Inskoy','ru','Kemerovo',13326.0,86.42,54.43).
city('Itatskiy','ru','Kemerovo',4235.0,89.04,56.07).
city('Izhmorskiy','ru','Kemerovo',5950.0,86.64,56.19).
city('Kaltan','ru','Kemerovo',25904.0,87.28,53.5).
city('Karagaylinskiy','ru','Kemerovo',4326.0,86.55,54.17).
city('Kaz','ru','Kemerovo',4854.0,87.32,52.92).
city('Kedrovka','ru','Kemerovo',17752.0,86.09,55.52).
city('Kemerovo','ru','Kemerovo',477096.0,86.08,55.33).
city('Kiselyovsk','ru','Kemerovo',102254.0,86.65,53.98).
city('Komsomolsk','ru','Kemerovo',2566.0,88.18,55.65).
city('Krapivinskiy','ru','Kemerovo',7909.0,86.81,55.01).
city('Krasnobrodskiy','ru','Kemerovo',11565.0,86.47,54.17).
city('Krasnogorskiy','ru','Kemerovo',2994.0,86.27,54.55).
city('Krasnoye','ru','Kemerovo',3426.0,85.38,54.61).
city('Kuzedeyevo','ru','Kemerovo',3448.0,87.17,53.33).
city('Leninsk-Kuznetskiy','ru','Kemerovo',109025.0,86.16,54.66).
city('Listvyagi','ru','Kemerovo',4627.0,86.98,53.68).
city('Makarakskiy','ru','Kemerovo',442.0,88.03,55.59).
city('Malinovka','ru','Kemerovo',9981.0,87.28,53.4).
city('Mariinsk','ru','Kemerovo',43122.0,87.75,56.21).
city('Mezhdurechensk','ru','Kemerovo',101028.0,88.06,53.69).
city('Mundybash','ru','Kemerovo',5870.0,87.32,53.23).
city('Myski','ru','Kemerovo',44082.0,87.8,53.7).
city('Nikitinskiy','ru','Kemerovo',2419.0,86.1,54.58).
city('Novokuznetsk','ru','Kemerovo',539622.0,87.1,53.75).
city('Osinniki','ru','Kemerovo',48920.0,87.35,53.62).
city('Pioner','ru','Kemerovo',6015.0,85.95,55.32).
city('Plotnikovo','ru','Kemerovo',4983.0,85.95,55.03).
city('Polysayevo','ru','Kemerovo',28028.0,86.24,54.58).
city('Pritomskiy','ru','Kemerovo',4261.0,87.58,53.78).
city('Prokopyevsk','ru','Kemerovo',215272.0,86.71,53.9).
city('Promyshlennaya','ru','Kemerovo',17216.0,85.64,54.92).
city('Promyshlennovskiy','ru','Kemerovo',6152.0,86.2,55.48).
city('Rudnichnyy','ru','Kemerovo',4308.0,86.24,56.08).
city('Salair','ru','Kemerovo',9096.0,85.78,54.22).
city('Sheregesh','ru','Kemerovo',10114.0,88.03,52.95).
city('Spassk','ru','Kemerovo',1556.0,87.75,52.75).
city('Starobachaty','ru','Kemerovo',4608.0,86.2,54.23).
city('Staropesterevo','ru','Kemerovo',3554.0,86.4,54.5).
city('Suslovo','ru','Kemerovo',2974.0,88.12,56.22).
city('Tashtagol','ru','Kemerovo',22779.0,87.88,52.78).
city('Tayga','ru','Kemerovo',24328.0,85.62,56.06).
city('Tayzhina','ru','Kemerovo',5063.0,87.42,53.67).
city('Temirtau','ru','Keme',4723.0,87.47,53.13).
city('Tisul','ru','Kemerovo',9249.0,88.31,55.76).
city('Topki','ru','Kemerovo',30449.0,86.6,56.28).
city('Trudarmeyskiy','ru','Kemerovo',4711.0,86.42,54.13).
city('Tsentralnyy','ru','Kemerovo',773.0,87.65,55.21).
city('Tyazhinskiy','ru','Kemerovo',13716.0,88.51,56.12).
city('Verkh-Chebula','ru','Kemerovo',5224.0,87.62,56.03).
city('Yagunovskiy','ru','Kemerovo',8199.0,85.98,55.29).
city('Yashkino','ru','Kemerovo',15197.0,85.43,55.88).
city('Yaya','ru','Kemerovo',13238.0,86.44,56.2).
city('Yurga','ru','Kemerovo',84222.0,84.89,55.72).
city('Zelenogorskiy','ru','Kemerovo',5249.0,87.0,55.03).
city('Amursk','ru','Khabarovsk Krai',46383.0,136.9,50.22).
city('Ayan','ru','Khabarovsk Krai',1286.0,138.17,56.45).
city('Berezovyy','ru','Khabarovsk Krai',5633.0,135.7,51.67).
city('Bikin','ru','Khabarovsk Krai',19659.0,134.26,46.82).
city('Bogorodskoye','ru','Khabarovsk Krai',4108.0,140.45,52.37).
city('Chegdomyn','ru','Khabarovsk Krai',14855.0,133.02,51.12).
city('Chumikan','ru','Khabarovsk Krai',1305.0,135.32,54.72).
city('De-Kastri','ru','Khabarovsk Krai',3615.0,140.78,51.47).
city('Dormidontovka','ru','Khabarovsk Krai',1623.0,134.9,47.8).
city('Elban','ru','Khabarovsk Krai',12531.0,136.51,50.09).
city('Gorin','ru','Khabarovsk Krai',3695.0,136.67,51.2).
city('Gornyy','ru','Khabarovsk Krai',1625.0,136.4,50.75).
city('Gurskoye','ru','Khabarovsk Krai',822.0,138.12,50.32).
city('Imeni Poliny Osipenko','ru','Khabarovsk Krai',2479.0,136.48,52.42).
city('Khabarovsk','ru','Khabarovsk Krai',578307.0,135.12,48.42).
city('Khor','ru','Khabarovsk Krai',11503.0,134.95,47.88).
city('Khurba','ru','Khabarovsk Krai',5537.0,136.88,50.41).
city('Knyaze-Volkonskoye','ru','Khabarovsk Krai',8936.0,135.47,48.47).
city('Komsomolsk-na-Amure','ru','Khabarovsk Krai',275168.0,137.0,50.56).
city('Korfovskiy','ru','Khabarovsk Krai',5652.0,135.05,48.22).
city('Lazarev','ru','Khabarovsk Krai',1906.0,141.51,52.23).
city('Lermontovka','ru','Khabarovsk Krai',4479.0,134.32,47.15).
city('Litovko','ru','Khabarovsk Krai',2670.0,135.17,49.24).
city('Lososina','ru','Khabarovsk Krai',3151.0,140.35,49.02).
city('Mago','ru','Khabarovsk Krai',2206.0,140.18,53.25).
city('Mayskiy','ru','Khabarovsk Krai',2883.0,140.2,49.02).
city('Mnogovershinnyy','ru','Khabarovsk Krai',2719.0,139.92,53.94).
city('Mukhen','ru','Khabarovsk Krai',4617.0,136.1,48.1).
city('Nekrasovka','ru','Khabarovsk Krai',9159.0,135.23,48.35).
city('Nikolayevsk-na-Amure','ru','Khabarovsk Krai',27152.0,140.72,53.14).
city('Novyy Urgal','ru','Khabarovsk Krai',7061.0,132.56,51.07).
city('Okhotsk','ru','Khabarovsk Krai',5570.0,143.3,59.38).
city('Oktyabrskiy','ru','Khabarovsk Krai',6333.0,140.28,49.05).
city('Pereyaslavka','ru','Khabarovsk Krai',10149.0,134.84,47.96).
city('Selikhino','ru','Khabarovsk Krai',4722.0,137.52,50.36).
city('Sofiysk','ru','Khabarovsk Krai',650.0,133.98,52.25).
city('Solnechnyy','ru','Khabarovsk Krai',13993.0,137.03,50.59).
city('Sovetskaya Gavan','ru','Khabarovsk Krai',29740.0,140.28,48.97).
city('Tayozhnoye','ru','Khabarovsk Krai',3994.0,135.92,48.75).
city('Topolevo','ru','Khabarovsk Krai',4117.0,135.17,48.51).
city('Troitskoye','ru','Khabarovsk Krai',5557.0,136.57,49.45).
city('Tyrma','ru','Khabarovsk Krai',2445.0,132.17,50.08).
city('Vanino','ru','Khabarovsk Krai',18618.0,140.25,49.08).
city('Vostochnyy','ru','Khabarovsk Krai',3635.0,135.1,48.5).
city('Vyazemskiy','ru','Khabarovsk Krai',15248.0,134.75,47.53).
city('Vysokogornyy','ru','Khabarovsk Krai',3926.0,139.15,50.12).
city('Zavety Ilicha','ru','Khabarovsk Krai',9153.0,140.28,49.03).
city('Abakan','ru','Khakasia',167291.0,91.43,53.72).
city('Abaza','ru','Khakasia',18094.0,90.09,52.66).
city('Askiz','ru','Khakasia',5953.0,90.48,53.14).
city('Beltirskiy','ru','Khakasia',5122.0,90.4,53.03).
city('Belyy Yar','ru','Khakasia',8951.0,91.39,53.6).
city('Beya','ru','Khakasia',5338.0,90.91,53.05).
city('Biskamzha','ru','Khakasia',1961.0,89.53,53.45).
city('Bograd','ru','Khakasia',4623.0,90.83,54.23).
city('Chernogorsk','ru','Khakasia',71583.0,91.22,53.83).
city('Cheryomushki','ru','Khakasia',8935.0,91.39,52.84).
city('Kommunar','ru','Khakasia',2730.0,89.29,54.35).
city('Kopyevo','ru','Khakasia',4863.0,89.81,54.99).
city('Mayna','ru','Khakasia',5287.0,91.48,53.01).
city('Podsineye','ru','Khakasia',3249.0,91.54,53.67).
city('Priiskovyy','ru','Khakasia',1174.0,88.7,54.65).
city('Sayanogorsk','ru','Khakasia',49940.0,91.4,53.09).
city('Shira','ru','Khakasia',9358.0,89.96,54.49).
city('Sorsk','ru','Khakasia',13035.0,90.25,54.0).
city('Tashtyp','ru','Khakasia',6379.0,89.9,52.79).
city('Tuim','ru','Khakasia',4669.0,89.93,54.34).
city('Ust-Abakan','ru','Khakasia',14696.0,91.37,53.85).
city('Vershina Teya','ru','Khakasia',4417.0,89.56,53.26).
city('Zhemchuzhnyy','ru','Khakasia',802.0,90.15,54.49).
city('Agirish','ru','Khanty-Mansi',2886.0,63.02,61.92).
city('Andra','ru','Khanty-Mansi',2013.0,65.89,62.51).
city('Barsovo','ru','Khanty-Mansi',5710.0,73.17,61.17).
city('Beloyarskiy','ru','Khanty-Mansi',19042.0,66.37,63.71).
city('Belyy Yar','ru','Khanty-Mansi',14674.0,73.18,62.26).
city('Beryozovo','ru','Khanty-Mansi',7224.0,65.04,63.94).
city('Cheuskiny','ru','Khanty-Mansi',3752.0,72.4,61.12).
city('Gornopravdinsk','ru','Khanty-Mansi',5048.0,69.9,60.05).
city('Igrim','ru','Khanty-Mansi',9545.0,64.42,63.19).
city('Kogalym','ru','Khanty-Mansi',57823.0,74.5,62.03).
city('Kommunisticheskiy','ru','Khanty-Mansi',2690.0,64.48,61.68).
city('Kondinskoye','ru','Khanty-Mansi',4166.0,67.41,59.65).
city('Kuminskiy','ru','Khanty-Mansi',2860.0,66.57,58.67).
city('Langepas','ru','Khanty-Mansi',40044.0,75.39,61.17).
city('Lokosovo','ru','Khanty-Mansi',3915.0,74.82,61.13).
city('Lugovoy','ru','Khanty-Mansi',1994.0,65.89,59.73).
city('Lyantor','ru','Khanty-Mansi',35761.0,72.31,61.58).
city('Malinovskiy','ru','Khanty-Mansi',2672.0,62.84,61.2).
city('Megion','ru','Khanty-Mansi',48691.0,76.1,61.05).
city('Mezhdurechenskiy','ru','Khanty-Mansi',11121.0,65.93,59.6).
city('Mortka','ru','Khanty-Mansi',3698.0,66.02,59.33).
city('Nefteyugansk','ru','Khanty-Mansi',112634.0,72.7,61.08).
city('Nizhnevartovsk','ru','Khanty-Mansi',244940.0,76.57,60.93).
city('Novoagansk','ru','Khanty-Mansi',9907.0,76.63,61.97).
city('Nyagan','ru','Khanty-Mansi',52138.0,65.39,62.14).
city('Oktyabrskoye','ru','Khanty-Mansi',3933.0,66.03,62.46).
city('Ostyako-Vogulsk','ru','Khanty-Mansi',58729.0,69.0,61.0).
city('Pionerskiy','ru','Khanty-Mansi',5348.0,62.87,61.19).
city('Poykovskiy','ru','Khanty-Mansi',28080.0,73.33,61.23).
city('Raduzhnyy','ru','Khanty-Mansi',47626.0,77.23,62.09).
city('Salym','ru','Khanty-Mansi',5605.0,71.48,60.06).
city('Sentyabrskiy','ru','Khanty-Mansi',3071.0,148.5,45.27).
city('Sovetskiy','ru','Khanty-Mansi',23685.0,63.58,61.36).
city('Surgut','ru','Khanty-Mansi',300371.0,73.42,61.25).
city('Tayozhnyy','ru','Khanty-Mansi',2575.0,62.67,61.2).
city('Unyugan','ru','Khanty-Mansi',5166.0,64.97,61.96).
city('Uray','ru','Khanty-Mansi',39879.0,64.76,60.13).
city('Yugorsk','ru','Khanty-Mansi',30878.0,63.33,61.31).
city('Zelenoborsk','ru','Khanty-Mansi',2252.0,64.03,61.47).
city('Afanasyevo','ru','Kirov',3368.0,53.25,58.87).
city('Arbazh','ru','Kirov',3943.0,48.3,57.68).
city('Arkul','ru','Kirov',2537.0,50.04,57.28).
city('Belaya Kholunitsa','ru','Kirov',11658.0,50.84,58.84).
city('Belorechensk','ru','Kirov',1473.0,52.29,58.77).
city('Bogorodskoye','ru','Kirov',3123.0,50.74,57.83).
city('Chalturin','ru','Kirov',8241.0,48.9,58.54).
city('Chernaya Kholunitsa','ru','Kirov',1539.0,51.71,58.85).
city('Darovskoy','ru','Kirov',7261.0,47.96,58.77).
city('Demyanovo','ru','Kirov',6228.0,47.08,60.35).
city('Dubrovka','ru','Kirov',1916.0,51.16,59.23).
city('Falyonki','ru','Kirov',5808.0,51.59,58.36).
city('Khristoforovo','ru','Kirov',817.0,47.26,60.9).
city('Kiknur','ru','Kirov',5246.0,47.2,57.3).
city('Kilmez','ru','Kirov',5880.0,51.07,56.94).
city('Kirov','ru','Kirov',457387.0,49.66,58.6).
city('Kirovo-Chepetsk','ru','Kirov',90253.0,50.04,58.55).
city('Kirs','ru','Kirov',11385.0,52.27,59.33).
city('Kosino','ru','Kirov',2330.0,51.28,58.41).
city('Kostino','ru','Kirov',3466.0,53.27,58.91).
city('Kotelnich','ru','Kirov',26837.0,48.32,58.31).
city('Krasnaya Polyana','ru','Kirov',7828.0,51.14,56.24).
city('Kumeny','ru','Kirov',5090.0,49.91,58.1).
city('Lalsk','ru','Kirov',4413.0,47.59,60.74).
city('Lebyazhye','ru','Kirov',3463.0,49.51,57.41).
city('Leninskoye','ru','Kirov',5323.0,47.09,58.31).
city('Lesnoy','ru','Kirov',6915.0,52.13,59.79).
city('Lesnyye Polyany','ru','Kirov',1731.0,52.42,59.0).
city('Luza','ru','Kirov',11936.0,47.27,60.62).
city('Lyangasovo','ru','Kirov',12626.0,49.45,58.52).
city('Malmyzh','ru','Kirov',8990.0,50.69,56.52).
city('Maromitsa','ru','Kirov',1832.0,48.01,59.87).
city('Medvedok','ru','Kirov',2041.0,50.03,57.39).
city('Mirnyy','ru','Kirov',3508.0,47.68,58.5).
city('Murashi','ru','Kirov',7190.0,48.97,59.4).
city('Murygino','ru','Kirov',7996.0,49.46,58.74).
city('Nagorsk','ru','Kirov',4982.0,50.81,59.32).
city('Nema','ru','Kirov',3797.0,50.5,57.5).
city('Nizhneivkino','ru','Kirov',2234.0,49.52,58.19).
city('Nolinsk','ru','Kirov',10282.0,49.94,57.56).
city('Oktyabrskiy','ru','Kirov',1924.0,48.91,59.44).
city('Omutninsk','ru','Kirov',25364.0,52.18,58.67).
city('Oparino','ru','Kirov',4986.0,48.28,59.85).
city('Orichi','ru','Kirov',7806.0,49.06,58.4).
city('Pervomayskiy','ru','Kirov',3643.0,50.16,58.68).
city('Peskovka','ru','Kirov',6746.0,52.37,59.04).
city('Pinyug','ru','Kirov',2915.0,47.78,60.25).
city('Pizhanka','ru','Kirov',3900.0,48.55,57.46).
city('Podosinovets','ru','Kirov',4106.0,47.08,60.27).
city('Raduzhnyy','ru','Kirov',9514.0,49.65,59.48).
city('Rudnichnyy','ru','Kirov',5555.0,52.47,59.62).
city('Sanchursk','ru','Kirov',5544.0,47.25,56.94).
city('Slobodskoy','ru','Kirov',32362.0,50.19,58.72).
city('Sosnovka','ru','Kirov',12355.0,51.28,56.26).
city('Sovetsk','ru','Kirov',17869.0,48.96,57.58).
city('Sozimskiy','ru','Kirov',1968.0,52.25,59.75).
city('Strizhi','ru','Kirov',3881.0,49.26,58.46).
city('Stulovo','ru','Kirov',3488.0,50.17,58.73).
city('Suna','ru','Kirov',2400.0,50.08,57.84).
city('Svecha','ru','Kirov',4971.0,47.5,58.28).
city('Svetlopolyansk','ru','Kirov',3176.0,52.37,59.42).
city('Torfyanoy','ru','Kirov',1775.0,49.2,58.49).
city('Tuzha','ru','Kirov',5002.0,47.93,57.61).
city('Uni','ru','Kirov',4767.0,51.49,57.75).
city('Urzhum','ru','Kirov',11333.0,49.99,57.11).
city('Vakhrushi','ru','Kirov',10330.0,50.03,58.68).
city('Verkhoshizhemye','ru','Kirov',4382.0,49.12,58.01).
city('Vostochnyy','ru','Kirov',7622.0,52.23,58.78).
city('Vyatskiye Polyany','ru','Kirov',39535.0,51.08,56.22).
city('Yaransk','ru','Kirov',19558.0,47.88,57.3).
city('Yurya','ru','Kirov',5982.0,49.27,59.05).
city('Zarya','ru','Kirov',1194.0,48.08,60.09).
city('Zujevka','ru','Kirov',11953.0,51.13,58.4).
city('Aykino','ru','Komi',3358.0,50.0,62.22).
city('Blagoyevo','ru','Komi',2510.0,47.92,63.37).
city('Borovoy','ru','Komi',1821.0,52.89,63.23).
city('Inta','ru','Komi',38403.0,60.17,66.04).
city('Izhma','ru','Komi',3599.0,53.92,65.02).
city('Izyayu','ru','Komi',1631.0,56.99,65.1).
city('Komsomolskiy','ru','Komi',3846.0,63.78,67.55).
city('Kortkeros','ru','Komi',4429.0,51.59,61.81).
city('Koslan','ru','Komi',2547.0,48.9,63.45).
city('Koygorodok','ru','Komi',2924.0,51.0,60.44).
city('Kozhva','ru','Komi',3374.0,57.05,65.11).
city('Kozhym','ru','Komi',53.0,59.52,65.73).
city('Krasnozatonskiy','ru','Komi',8078.0,50.88,61.66).
city('Letka','ru','Komi',2984.0,49.42,59.61).
city('Mezhdurechensk','ru','Komi',1855.0,48.55,63.25).
city('Mikun','ru','Komi',11503.0,50.06,62.37).
city('Mulda','ru','Komi',174.0,63.85,67.5).
city('Nizhniy Odes','ru','Komi',11165.0,54.86,63.64).
city('Obyachevo','ru','Komi',5547.0,49.61,60.33).
city('Oktyabrskiy','ru','Komi',627.0,64.13,67.57).
city('Parma','ru','Komi',1319.0,57.7,66.0).
city('Pechora','ru','Komi',46113.0,57.21,65.15).
city('Promyshlennyy','ru','Komi',1112.0,63.92,67.58).
city('Puteyets','ru','Komi',1223.0,57.09,65.17).
city('Sedkyrkeshch','ru','Komi',1973.0,50.92,61.75).
city('Severnyy','ru','Komi',11434.0,64.12,67.6).
city('Shchelyayur','ru','Komi',3376.0,53.43,65.33).
city('Shudayag','ru','Komi',3446.0,53.61,63.53).
city('Sindor','ru','Komi',2880.0,51.89,62.86).
city('Sosnogorsk','ru','Komi',29343.0,53.88,63.6).
city('Sovetskiy','ru','Komi',2415.0,64.42,67.48).
city('Sykty','ru','Komi',230142.0,50.81,61.67).
city('Synya','ru','Komi',1011.0,58.02,65.38).
city('Troitsko-Pechorsk','ru','Komi',8414.0,56.2,62.7).
city('Tsementnozavodskiy','ru','Komi',2135.0,64.1,67.62).
city('Ukhta','ru','Komi',102188.0,53.69,63.56).
city('Usinsk','ru','Komi',44875.0,57.41,65.92).
city('Usogorsk','ru','Komi',5308.0,48.71,63.42).
city('Ust-Kulom','ru','Komi',5205.0,53.69,61.69).
city('Ust-Tsilma','ru','Komi',4830.0,52.15,65.44).
city('Verkhnyaya Inta','ru','Komi',1975.0,60.52,66.08).
city('Verkhnyaya Maksakovka','ru','Komi',3827.0,50.97,61.64).
city('Vizinga','ru','Komi',6788.0,50.08,61.08).
city('Vodnyy','ru','Komi',6307.0,53.41,63.5).
city('Vorgashor','ru','Komi',18158.0,63.8,67.59).
city('Vorkuta','ru','Komi',80040.0,64.0,67.5).
city('Voyvozh','ru','Komi',3727.0,54.97,62.9).
city('Vuktyl','ru','Komi',13694.0,57.31,63.86).
city('Vylgort','ru','Komi',9707.0,50.7,61.62).
city('Yarega','ru','Komi',8092.0,53.56,63.43).
city('Yeletskiy','ru','Komi',742.0,64.24,67.05).
city('Zapolyarnyy','ru','Komi',4476.0,63.75,67.48).
city('Zelenets','ru','Komi',3040.0,50.7,61.88).
city('Zheleznodorozhnyy','ru','Komi',16404.0,50.86,62.59).
city('Zheshart','ru','Komi',9534.0,49.56,62.06).
city('Gayny','ru','Komi-Permyak',4331.0,54.33,60.3).
city('Kochevo','ru','Komi-Permyak',3261.0,54.31,59.6).
city('Kosa','ru','Komi-Permyak',2199.0,54.99,59.95).
city('Kudymkar','ru','Komi-Permyak',31597.0,54.66,59.01).
city('Maykor','ru','Komi-Permyak',3236.0,55.87,59.01).
city('Pozhva','ru','Komi-Permyak',3677.0,56.06,59.09).
city('Yurla','ru','Komi-Permyak',4058.0,54.32,59.33).
city('Yusva','ru','Komi-Permyak',4556.0,54.96,58.96).
city('Kamenskoye','ru','Koryak',609.0,166.2,62.47).
city('Ossora','ru','Koryak',2420.0,163.07,59.24).
city('Palana','ru','Koryak',3671.0,159.97,59.12).
city('Tigil','ru','Koryak',1993.0,158.67,57.8).
city('Tilichiki','ru','Koryak',1968.0,166.1,60.47).
city('Antropovo','ru','Kostroma',3736.0,43.01,58.4).
city('Bogov','ru','Kostroma',2327.0,47.02,58.98).
city('Buy','ru','Kostroma',26486.0,41.53,58.48).
city('Chukhloma','ru','Kostroma',5430.0,42.68,58.75).
city('Galich','ru','Kostroma',18595.0,42.35,58.38).
city('Georgiyevskoye','ru','Kostroma',2744.0,44.65,58.72).
city('Kadyy','ru','Kostroma',3783.0,43.19,57.78).
city('Karavayevo','ru','Kostroma',7472.0,41.06,57.75).
city('Kologriv','ru','Kostroma',3605.0,44.31,58.83).
city('Kosmynino','ru','Kostroma',1670.0,40.76,57.58).
city('Kostroma','ru','Kostroma',277658.0,40.93,57.77).
city('Krasnoye-na-Volge','ru','Kostroma',7953.0,41.24,57.51).
city('Makaryev','ru','Kostroma',7588.0,43.8,57.89).
city('Manturovo','ru','Kostroma',18817.0,44.76,58.34).
city('Nerekhta','ru','Kostroma',25353.0,40.57,57.46).
city('Neya','ru','Kostroma',11145.0,43.88,58.28).
city('Nikolskoye','ru','Kostroma',4891.0,40.75,57.83).
city('Ostrovskoye','ru','Kostroma',5138.0,42.24,57.8).
city('Parfenyevo','ru','Kostroma',2861.0,43.41,58.49).
city('Pavino','ru','Kostroma',2947.0,46.13,59.11).
city('Ponazyrevo','ru','Kostroma',4861.0,46.12,58.35).
city('Pyshchug','ru','Kostroma',3226.0,45.72,58.89).
city('Sharya','ru','Kostroma',24395.0,45.51,58.37).
city('Soligalich','ru','Kostroma',6886.0,42.29,59.08).
city('Sudislavl','ru','Kostroma',5236.0,41.7,57.88).
city('Susanino','ru','Kostroma',3961.0,41.59,58.15).
city('Vetluzhskiy','ru','Kostroma',13229.0,45.45,58.39).
city('Vokhma','ru','Kostroma',4663.0,46.75,58.93).
city('Volgorechensk','ru','Kostroma',17700.0,41.16,57.44).
city('Abinsk','ru','Krasnodar',34669.0,38.16,44.87).
city('Abrau-Dyurso','ru','Krasnodar',3021.0,37.64,44.7).
city('Achuevo','ru','Krasnodar',485.0,37.76,45.72).
city('Afipskiy','ru','Krasnodar',18209.0,38.84,44.9).
city('Agronom','ru','Krasnodar',3820.0,39.2,45.15).
city('Akhtanizovskaya','ru','Krasnodar',3342.0,37.1,45.32).
city('Akhtyrskiy','ru','Krasnodar',19468.0,38.3,44.85).
city('Alekseyevskaya','ru','Krasnodar',3303.0,40.16,45.77).
city('Anapskaya','ru','Krasnodar',13965.0,37.38,44.9).
city('Anastasiyevskaya','ru','Krasnodar',11204.0,37.89,45.21).
city('Apsheronsk','ru','Krasnodar',40452.0,39.73,44.46).
city('Arkhangelskaya','ru','Krasnodar',9144.0,40.28,45.68).
city('Arkhipo-Osipovka','ru','Krasnodar',8170.0,38.53,44.37).
city('Armavir','ru','Krasnodar',199551.0,41.12,44.99).
city('Atamanskaya','ru','Krasnodar',3930.0,39.64,46.17).
city('Azovskaya','ru','Krasnodar',3960.0,38.63,44.79).
city('Baturinskaya','ru','Krasnodar',3678.0,39.37,45.79).
city('Belaya Glina','ru','Krasnodar',17997.0,40.87,46.07).
city('Belorechensk','ru','Krasnodar',54527.0,39.0,44.77).
city('Belozernyy','ru','Krasnodar',4315.0,38.69,45.08).
city('Berezanskaya','ru','Krasnodar',6568.0,39.59,45.71).
city('Besskorbnaya','ru','Krasnodar',5837.0,41.31,44.64).
city('Brinkovskaya','ru','Krasnodar',4821.0,38.59,46.03).
city('Bryukhovetskaya','ru','Krasnodar',22309.0,39.0,45.8).
city('Chamlykskaya','ru','Krasnodar',3722.0,40.88,44.72).
city('Chelbasskaya','ru','Krasnodar',7080.0,39.37,45.98).
city('Chernomorskiy','ru','Krasnodar',8454.0,38.49,44.85).
city('Chernoyerkovskaya','ru','Krasnodar',3856.0,37.77,45.43).
city('Dinskaya','ru','Krasnodar',34573.0,39.23,45.22).
city('Divnomorskoye','ru','Krasnodar',5880.0,38.14,44.5).
city('Dmitriyevskaya','ru','Krasnodar',3412.0,40.75,45.65).
city('Dneprovskaya','ru','Krasnodar',3236.0,38.81,45.62).
city('Dolzhanskaya','ru','Krasnodar',7194.0,37.8,46.63).
city('Dvubratskiy','ru','Krasnodar',10272.0,39.8,45.24).
city('Dyadkovskaya','ru','Krasnodar',4514.0,39.19,45.55).
city('Dzhiginka','ru','Krasnodar',4079.0,37.33,45.13).
city('Dzhubga','ru','Krasnodar',5314.0,38.7,44.32).
city('Fastovetskaya','ru','Krasnodar',8806.0,40.16,45.92).
city('Gayduk','ru','Krasnodar',7266.0,37.7,44.79).
city('Gelendzhik','ru','Krasnodar',50715.0,38.07,44.57).
city('Girey','ru','Krasnodar',6712.0,40.66,45.4).
city('Glubokiy','ru','Krasnodar',3513.0,41.02,44.94).
city('Golubitskaya','ru','Krasnodar',4138.0,37.28,45.32).
city('Gornoye Loo','ru','Krasnodar',3156.0,39.61,43.72).
city('Goryachiy Klyuch','ru','Krasnodar',28078.0,39.13,44.63).
city('Gostagaevskaya','ru','Krasnodar',9078.0,37.5,45.02).
city('Grivenskaya','ru','Krasnodar',5208.0,38.16,45.65).
city('Gubskaya','ru','Krasnodar',3178.0,40.64,44.32).
city('Gulkevichi','ru','Krasnodar',35843.0,40.71,45.36).
city('Guyguqey','ru','Krasnodar',53623.0,37.32,44.89).
city('Ilinskaya','ru','Krasnodar',4911.0,40.72,45.73).
city('Ilskiy','ru','Krasnodar',22612.0,38.58,44.84).
city('Industrialnyy','ru','Krasnodar',3923.0,39.11,45.1).
city('Irklievskaya','ru','Krasnodar',3068.0,39.66,45.85).
city('Ivanovskaya','ru','Krasnodar',9415.0,38.66,45.32).
city('Kabardinka','ru','Krasnodar',7395.0,37.94,44.65).
city('Kalinino','ru','Krasnodar',34594.0,39.0,45.14).
city('Kalininskaya','ru','Krasnodar',13363.0,38.66,45.48).
city('Kalnibolotskaya','ru','Krasnodar',6578.0,40.45,46.01).
city('Kamyshevatskaya','ru','Krasnodar',5201.0,37.95,46.41).
city('Kanelovskaya','ru','Krasnodar',4332.0,39.19,46.59).
city('Kanevskaya','ru','Krasnodar',45334.0,38.9,46.1).
city('Kavkazskaya','ru','Krasnodar',11680.0,40.67,45.45).
city('Kazanskaya','ru','Krasnodar',10794.0,40.44,45.41).
city('Khadyzhensk','ru','Krasnodar',21685.0,39.53,44.43).
city('Kholmskaya','ru','Krasnodar',17494.0,38.39,44.85).
city('Kirpilskaya','ru','Krasnodar',5727.0,39.71,45.38).
city('Kislyakovskaya','ru','Krasnodar',5501.0,39.67,46.44).
city('Kiyevskoye','ru','Krasnodar',4727.0,37.88,45.03).
city('Konokovo','ru','Krasnodar',7507.0,41.33,44.86).
city('Konstantinovskaya','ru','Krasnodar',4149.0,40.73,44.84).
city('Kopanskaya','ru','Krasnodar',4008.0,38.48,46.27).
city('Korenovsk','ru','Krasnodar',41666.0,39.45,45.47).
city('Korzhevskiy','ru','Krasnodar',3927.0,37.72,45.2).
city('Kovalevskoye','ru','Krasnodar',3139.0,40.98,45.19).
city('Krasnaya Polyana','ru','Krasnodar',3555.0,40.66,44.37).
city('Krasnodar','ru','Krasnodar',649860.0,38.98,45.03).
city('Krasnoselskiy','ru','Krasnodar',7558.0,40.62,45.38).
city('Krasnoye','ru','Krasnodar',3504.0,39.57,46.73).
city('Kropotkin','ru','Krasnodar',79600.0,40.58,45.44).
city('Krylovskaya','ru','Krasnodar',10718.0,39.64,46.21).
city('Krymsk','ru','Krasnodar',57556.0,37.98,44.92).
city('Kubanskiy','ru','Krasnodar',3200.0,40.57,45.93).
city('Kurchanskaya','ru','Krasnodar',6358.0,37.56,45.2).
city('Kurganinsk','ru','Krasnodar',47682.0,40.6,44.88).
city('Kushchevskaya','ru','Krasnodar',29915.0,39.64,46.56).
city('Labinsk','ru','Krasnodar',61946.0,40.74,44.63).
city('Ladozhskaya','ru','Krasnodar',14904.0,39.94,45.31).
city('Lenina','ru','Krasnodar',5259.0,39.78,46.07).
city('Leningradskaya','ru','Krasnodar',38712.0,39.39,46.31).
city('Lvovskoye','ru','Krasnodar',4771.0,38.61,45.0).
city('Maryanskaya','ru','Krasnodar',10353.0,38.65,45.1).
city('Maykopskoye','ru','Krasnodar',4171.0,40.77,45.0).
city('Medvedovskaya','ru','Krasnodar',16941.0,39.03,45.45).
city('Mikhaylovskaya','ru','Krasnodar',8050.0,40.6,44.99).
city('Mingrelskaya','ru','Krasnodar',5522.0,38.34,45.01).
city('Mirskoy','ru','Krasnodar',3095.0,40.4,45.54).
city('Mostovskoy','ru','Krasnodar',25188.0,40.79,44.41).
city('Myskhako','ru','Krasnodar',5743.0,37.77,44.66).
city('Natukhaevskaya','ru','Krasnodar',6428.0,37.57,44.9).
city('Nebug','ru','Krasnodar',3698.0,39.0,44.17).
city('Neftegorsk','ru','Krasnodar',4785.0,39.71,44.36).
city('Nekrasovskaya','ru','Krasnodar',4814.0,39.75,45.14).
city('Nezamaevskaya','ru','Krasnodar',3122.0,40.27,46.16).
city('Nizhnebakanskaya','ru','Krasnodar',8648.0,37.83,44.87).
city('Nizhneshilovka','ru','Krasnodar',5090.0,40.02,43.47).
city('Novoalekseyevskaya','ru','Krasnodar',3578.0,40.93,44.82).
city('Novobeysugskaya','ru','Krasnodar',3601.0,39.88,45.47).
city('Novoderevyankovskaya','ru','Krasnodar',6712.0,38.75,46.32).
city('Novodmitriyevskaya','ru','Krasnodar',5230.0,38.87,44.82).
city('Novodzherelievskaya','ru','Krasnodar',5365.0,38.68,45.77).
city('Novokorsunskaya','ru','Krasnodar',5133.0,39.15,45.64).
city('Novokubansk','ru','Krasnodar',36402.0,41.05,45.1).
city('Novolabinskaya','ru','Krasnodar',3733.0,39.9,45.11).
city('Novoleushkovskaya','ru','Krasnodar',6853.0,40.0,46.0).
city('Novomalorossiyskaya','ru','Krasnodar',5867.0,39.9,45.63).
city('Novomikhaylovskiy','ru','Krasnodar',10370.0,38.85,44.25).
city('Novominskaya','ru','Krasnodar',12049.0,38.96,46.32).
city('Novomyshastovskaya','ru','Krasnodar',9916.0,38.58,45.2).
city('Novonikolayevskaya','ru','Krasnodar',3753.0,38.75,45.55).
city('Novoplatnirovskaya','ru','Krasnodar',3988.0,39.41,46.1).
city('Novopokrovskaya','ru','Krasnodar',19342.0,40.7,45.95).
city('Novorossiysk','ru','Krasnodar',241860.0,37.77,44.72).
city('Novorozhdestvenskaya','ru','Krasnodar',6780.0,39.95,45.86).
city('Novoshcherbinovskaya','ru','Krasnodar',6415.0,38.63,46.48).
city('Novotitarovskaya','ru','Krasnodar',22630.0,38.98,45.24).
city('Novoukrainskiy','ru','Krasnodar',3572.0,38.05,44.9).
city('Novoukrainskoye','ru','Krasnodar',5928.0,40.53,45.38).
city('Novovelichkovskaya','ru','Krasnodar',8774.0,38.84,45.27).
city('Oktyabrskaya','ru','Krasnodar',11608.0,39.82,46.29).
city('Olginskaya','ru','Krasnodar',4441.0,38.55,45.94).
city('Orel-Izumrud','ru','Krasnodar',4614.0,39.92,43.46).
city('Otradnaya','ru','Krasnodar',22985.0,41.52,44.39).
city('Otrado-Kubanskoye','ru','Krasnodar',3697.0,40.84,45.24).
city('Otrado-Olginskoye','ru','Krasnodar',3365.0,40.95,45.31).
city('Parkovyy','ru','Krasnodar',4524.0,40.15,45.83).
city('Pashkovskiy','ru','Krasnodar',43634.0,39.11,45.02).
city('Pavlovskaya','ru','Krasnodar',31133.0,39.79,46.13).
city('Peredovaya','ru','Krasnodar',4204.0,41.48,44.12).
city('Perepravnaya','ru','Krasnodar',3186.0,40.77,44.33).
city('Pereyaslovskaya','ru','Krasnodar',8542.0,39.03,45.84).
city('Petropavlovskaya','ru','Krasnodar',6632.0,40.47,45.08).
city('Petrovskaya','ru','Krasnodar',13340.0,37.96,45.43).
city('Plastunovskaya','ru','Krasnodar',9604.0,39.27,45.29).
city('Platnirovskaya','ru','Krasnodar',11710.0,39.39,45.39).
city('Poltavskaya','ru','Krasnodar',29009.0,38.21,45.36).
city('Poputnaya','ru','Krasnodar',6279.0,41.44,44.52).
city('Prikubanskiy','ru','Krasnodar',3168.0,41.2,45.0).
city('Primorsko-Akhtarsk','ru','Krasnodar',33103.0,38.18,46.04).
city('Privolnaya','ru','Krasnodar',6566.0,38.69,46.13).
city('Prochnookopskaya','ru','Krasnodar',4916.0,41.12,45.07).
city('Psebay','ru','Krasnodar',11174.0,40.77,44.11).
city('Pshekhskaya','ru','Krasnodar',4979.0,39.8,44.69).
city('Rayevskaya','ru','Krasnodar',8518.0,37.55,44.83).
city('Razdolnaya','ru','Krasnodar',3190.0,39.56,45.38).
city('Rodnikovskaya','ru','Krasnodar',8925.0,40.67,44.76).
city('Rogovskaya','ru','Krasnodar',8435.0,38.74,45.73).
city('Ryazanskaya','ru','Krasnodar',5157.0,39.59,44.96).
city('Saratovskaya','ru','Krasnodar',6117.0,39.2,44.71).
city('Severskaya','ru','Krasnodar',22849.0,38.68,44.85).
city('Shedok','ru','Krasnodar',3142.0,40.85,44.22).
city('Shepsi','ru','Krasnodar',3151.0,39.15,44.04).
city('Shirochanka','ru','Krasnodar',5853.0,38.33,46.66).
city('Shkurinskaya','ru','Krasnodar',5005.0,39.37,46.59).
city('Slavyansk-na-Kubani','ru','Krasnodar',65197.0,38.12,45.25).
city('Smolenskaya','ru','Krasnodar',8130.0,38.81,44.79).
city('Sochi','ru','Krasnodar',327613.0,39.73,43.6).
city('Sokolovskoye','ru','Krasnodar',3138.0,40.68,45.26).
city('Sovetskaya','ru','Krasnodar',10166.0,41.17,44.78).
city('Sovkhoznyy','ru','Krasnodar',3916.0,38.12,45.29).
city('Spokoynaya','ru','Krasnodar',5291.0,41.41,44.25).
city('Staraya Stanitsa','ru','Krasnodar',7145.0,41.15,45.01).
city('Staroderevyankovskaya','ru','Krasnodar',12918.0,38.97,46.12).
city('Starodzhereliyevskaya','ru','Krasnodar',3106.0,38.3,45.47).
city('Starokorsunskaya','ru','Krasnodar',10915.0,39.31,45.06).
city('Staroleushkovskaya','ru','Krasnodar',5733.0,39.76,45.99).
city('Starominskaya','ru','Krasnodar',30461.0,39.05,46.53).
city('Staromyshastovskaya','ru','Krasnodar',10625.0,39.08,45.34).
city('Staronizhestebliyevskaya','ru','Krasnodar',10478.0,38.44,45.37).
city('Staroshcherbinovskaya','ru','Krasnodar',18785.0,38.67,46.63).
city('Starotitarovskaya','ru','Krasnodar',12351.0,37.14,45.21).
city('Starovelichkovskaya','ru','Krasnodar',13111.0,38.73,45.43).
city('Strelka','ru','Krasnodar',5433.0,37.3,45.21).
city('Su-Psekh','ru','Krasnodar',6417.0,37.37,44.86).
city('Taman','ru','Krasnodar',9417.0,36.71,45.21).
city('Tbilisskaya','ru','Krasnodar',24446.0,40.19,45.36).
city('Temirgoyevskaya','ru','Krasnodar',8588.0,40.28,45.11).
city('Temizhbekskaya','ru','Krasnodar',6111.0,40.85,45.45).
city('Temryuk','ru','Krasnodar',36547.0,37.38,45.27).
city('Ternovskaya','ru','Krasnodar',6643.0,40.41,45.85).
city('Tikhoretsk','ru','Krasnodar',64388.0,40.13,45.85).
city('Timashyovsk','ru','Krasnodar',55895.0,38.95,45.62).
city('Troitskaya','ru','Krasnodar',6479.0,38.13,45.13).
city('Trudobelikovskiy','ru','Krasnodar',9013.0,38.16,45.27).
city('Tsibanobalka','ru','Krasnodar',4548.0,37.34,44.98).
city('Tuapse','ru','Krasnodar',64235.0,39.07,44.11).
city('Udobnaya','ru','Krasnodar',5519.0,41.55,44.2).
city('Upornaya','ru','Krasnodar',3350.0,41.02,44.4).
city('Uspenskaya','ru','Krasnodar',4682.0,41.06,45.76).
city('Uspenskoye','ru','Krasnodar',11843.0,41.4,44.83).
city('Ust-Labinsk','ru','Krasnodar',44089.0,39.69,45.21).
city('Varenikovskaya','ru','Krasnodar',14409.0,37.65,45.12).
city('Vasyurinskaya','ru','Krasnodar',12830.0,39.42,45.12).
city('Velikovechnoye','ru','Krasnodar',5762.0,39.76,44.93).
city('Ventsy','ru','Krasnodar',4193.0,40.84,45.38).
city('Verkhnebakanskiy','ru','Krasnodar',6746.0,37.67,44.84).
city('Vinogradnyy','ru','Krasnodar',3250.0,37.32,45.05).
city('Vityazevo','ru','Krasnodar',6104.0,37.27,44.99).
city('Vladimirskaya','ru','Krasnodar',7278.0,40.8,44.55).
city('Volnoye','ru','Krasnodar',3495.0,41.21,44.95).
city('Voronezhskaya','ru','Krasnodar',8026.0,39.57,45.21).
city('Voznesenskaya','ru','Krasnodar',7009.0,41.03,44.56).
city('Vyselki','ru','Krasnodar',18746.0,39.66,45.58).
city('Vyshestebliyevskaya','ru','Krasnodar',4312.0,37.0,45.19).
city('Vysokoye','ru','Krasnodar',3090.0,39.97,43.47).
city('Yaroslavskaya','ru','Krasnodar',5458.0,40.46,44.61).
city('Yasenskaya','ru','Krasnodar',4855.0,38.27,46.36).
city('Yelizavetinskaya','ru','Krasnodar',19306.0,38.8,45.03).
city('Yeysk','ru','Krasnodar',87815.0,38.27,46.7).
city('Yurovka','ru','Krasnodar',3510.0,37.41,45.11).
city('Yuzhnyy','ru','Krasnodar',3912.0,40.17,44.86).
city('Zavetnyy','ru','Krasnodar',4486.0,41.14,44.93).
city('Aban','ru','Krasnoyarsk',9670.0,96.06,56.68).
city('Achinsk','ru','Krasnoyarsk',117635.0,90.5,56.28).
city('Aginskoye','ru','Krasnoyarsk',6077.0,94.91,55.26).
city('Artyomovsk','ru','Krasnoyarsk',2721.0,93.42,54.36).
city('Balakhta','ru','Krasnoyarsk',7721.0,91.6,55.39).
city('Beryozovka','ru','Krasnoyarsk',21014.0,93.14,56.04).
city('Bogotol','ru','Krasnoyarsk',23623.0,89.52,56.21).
city('Boguchany','ru','Krasnoyarsk',11209.0,97.45,58.38).
city('Bolshaya Irba','ru','Krasnoyarsk',4949.0,92.93,54.08).
city('Bolshaya Murta','ru','Krasnoyarsk',8304.0,93.15,56.91).
city('Bolshoy Uluy','ru','Krasnoyarsk',3364.0,90.57,56.65).
city('Borodino','ru','Krasnoyarsk',19603.0,94.89,55.91).
city('Chernenko','ru','Krasnoyarsk',42778.0,89.2,55.54).
city('Chibizhek','ru','Krasnoyarsk',348.0,93.6,54.4).
city('Chunoyar','ru','Krasnoyarsk',3240.0,97.32,57.45).
city('Devyatka','ru','Krasnoyarsk',93838.0,93.53,56.25).
city('Divnogorsk','ru','Krasnoyarsk',30018.0,92.36,55.96).
city('Dubinino','ru','Krasnoyarsk',11841.0,89.1,55.67).
city('Dzerzhinskoye','ru','Krasnoyarsk',7775.0,95.23,56.84).
city('Filimonovo','ru','Krasnoyarsk',3127.0,95.46,56.2).
city('Goryachegorsk','ru','Krasnoyarsk',873.0,88.92,55.4).
city('Idrinskoye','ru','Krasnoyarsk',5498.0,92.14,54.37).
city('Igarka','ru','Krasnoyarsk',7470.0,86.58,67.47).
city('Ilanskiy','ru','Krasnoyarsk',16668.0,96.06,56.24).
city('Irbeyskoye','ru','Krasnoyarsk',4681.0,95.45,55.64).
city('Irsha','ru','Krasnoyarsk',1436.0,94.79,55.93).
city('Kansk','ru','Krasnoyarsk',101503.0,95.71,56.2).
city('Karatuzskoye','ru','Krasnoyarsk',7900.0,92.87,53.61).
city('Kayerkan','ru','Krasnoyarsk',27295.0,87.74,69.38).
city('Kazachinskoye','ru','Krasnoyarsk',3987.0,93.28,57.7).
city('Kodinsk','ru','Krasnoyarsk',15672.0,99.18,58.69).
city('Koshurnikovo','ru','Krasnoyarsk',3743.0,93.3,54.17).
city('Kozulka','ru','Krasnoyarsk',8663.0,91.38,56.16).
city('Krasnokamensk','ru','Krasnoyarsk',4773.0,93.26,54.33).
city('Krasnoturansk','ru','Krasnoyarsk',5845.0,91.56,54.32).
city('Krasnoyarsk','ru','Krasnoyarsk',907460.0,93.06,56.02).
city('Krasnoyarsk-35','ru','Krasnoyarsk',6068.0,92.8,53.88).
city('Krasnoyarsk-45','ru','Krasnoyarsk',71357.0,94.59,56.11).
city('Krasnoyarsk-66','ru','Krasnoyarsk',5142.0,91.82,56.17).
city('Kuragino','ru','Krasnoyarsk',14076.0,92.67,53.9).
city('Lesosibirsk','ru','Krasnoyarsk',65946.0,92.48,58.24).
city('Mazulskiy','ru','Krasnoyarsk',1305.0,90.34,56.2).
city('Minusinsk','ru','Krasnoyarsk',72782.0,91.69,53.71).
city('Motygino','ru','Krasnoyarsk',6625.0,94.76,58.18).
city('Nazarovo','ru','Krasnoyarsk',55253.0,90.38,56.01).
city('Nizhniy Ingash','ru','Krasnoyarsk',8458.0,96.53,56.2).
city('Nizhnyaya Poyma','ru','Krasnoyarsk',9560.0,97.19,56.16).
city('Norilsk','ru','Krasnoyarsk',127504.0,88.22,69.34).
city('Novobirilyussy','ru','Krasnoyarsk',4274.0,90.67,56.95).
city('Novochernorechenskiy','ru','Krasnoyarsk',3722.0,91.08,56.27).
city('Novosyolovo','ru','Krasnoyarsk',6251.0,107.71,56.06).
city('Oktyabrskiy','ru','Krasnoyarsk',6110.0,97.54,57.43).
city('Ovsyanka','ru','Krasnoyarsk',3722.0,92.55,55.96).
city('Pamyati Trinadzati Bortsov','ru','Krasnoyarsk',3036.0,92.33,56.2).
city('Partizanskoye','ru','Krasnoyarsk',3915.0,94.39,55.5).
city('Pirovskoye','ru','Krasnoyarsk',3241.0,92.27,57.63).
city('Podtyosovo','ru','Krasnoyarsk',5570.0,92.1,58.6).
city('Pokanayevka','ru','Krasnoyarsk',723.0,97.62,56.49).
city('Predivinsk','ru','Krasnoyarsk',2028.0,93.44,57.07).
city('Rassvet','ru','Krasnoyarsk',3454.0,91.48,57.01).
city('Razdolinsk','ru','Krasnoyarsk',2762.0,94.67,58.42).
city('Sayanskiy','ru','Krasnoyarsk',3962.0,91.89,54.15).
city('Severo-Yeniseyskiy','ru','Krasnoyarsk',6564.0,93.05,60.37).
city('Shalinskoye','ru','Krasnoyarsk',4198.0,93.76,55.72).
city('Shushenskoye','ru','Krasnoyarsk',18770.0,91.94,53.33).
city('Snezhnogorsk','ru','Krasnoyarsk',1286.0,87.74,68.09).
city('Sosnovoborsk','ru','Krasnoyarsk',31633.0,93.36,56.13).
city('Strelka','ru','Krasnoyarsk',5677.0,93.03,58.07).
city('Sukhobuzimskoye','ru','Krasnoyarsk',4550.0,93.27,56.5).
city('Svetlogorsk','ru','Krasnoyarsk',1398.0,88.35,66.92).
city('Taezhnyy','ru','Krasnoyarsk',3512.0,98.9,58.36).
city('Talnakh','ru','Krasnoyarsk',59052.0,88.45,69.5).
city('Taseyevo','ru','Krasnoyarsk',8479.0,94.9,57.22).
city('Teya','ru','Krasnoyarsk',1649.0,92.63,60.38).
city('Tinskoy','ru','Krasnoyarsk',4147.0,96.92,56.15).
city('Turukhansk','ru','Krasnoyarsk',4774.0,87.98,65.82).
city('Tyukhtet','ru','Krasnoyarsk',5138.0,89.31,56.53).
city('Ural','ru','Krasnoyarsk',2057.0,94.75,55.91).
city('Uyar','ru','Krasnoyarsk',13167.0,94.31,55.81).
city('Uzhur','ru','Krasnoyarsk',15637.0,89.82,55.32).
city('Uzhur-4','ru','Krasnoyarsk',10641.0,92.87,56.1).
city('Yemelyanovo','ru','Krasnoyarsk',11734.0,92.67,56.19).
city('Yeniseysk','ru','Krasno',19920.0,92.16,58.45).
city('Yermakovskoye','ru','Krasnoyarsk',8910.0,92.39,53.28).
city('Yuzhno-Yeniseyskiy','ru','Krasnoyarsk',807.0,94.66,58.78).
city('Zaozyornyy','ru','Krasnoyarsk',11875.0,94.7,55.96).
city('Zelenyy Bor','ru','Krasnoyarsk',2604.0,91.67,53.67).
city('Zykovo','ru','Krasnoyarsk',5365.0,93.15,55.95).
city('Almenevo','ru','Kurgan',4456.0,63.58,54.94).
city('Belozerskoye','ru','Kurgan',4364.0,65.58,55.82).
city('Chastoozerye','ru','Kurgan',2779.0,67.88,55.57).
city('Dalmatovo','ru','Kurgan',14526.0,62.92,56.26).
city('Glyadyanskoye','ru','Kurgan',4237.0,65.09,54.91).
city('Ikovka','ru','Kurgan',5243.0,64.94,55.61).
city('Kargapolye','ru','Kurgan',8547.0,64.4,55.95).
city('Kataysk','ru','Kurgan',15620.0,62.58,56.29).
city('Ketovo','ru','Kurgan',6966.0,65.33,55.36).
city('Krasnyy Oktyabr','ru','Kurgan',4084.0,64.81,55.65).
city('Kurgan','ru','Kurgan',343132.0,65.33,55.45).
city('Kurtamysh','ru','Kurgan',17936.0,64.43,54.91).
city('Lebyazhye','ru','Kurgan',6735.0,66.5,55.28).
city('Lesnikov','ru','Kurgan',5864.0,65.32,55.28).
city('Makushino','ru','Kurgan',9682.0,67.24,55.21).
city('Mishkino','ru','Kurgan',8712.0,63.92,55.34).
city('Mokrousovo','ru','Kurgan',4851.0,66.77,55.81).
city('Petukhovo','ru','Kurgan',12367.0,67.86,55.07).
city('Polovinnoye','ru','Kurgan',5103.0,65.97,54.79).
city('Prosvet','ru','Kurgan',2961.0,65.08,55.58).
city('Safakulevo','ru','Kurgan',4189.0,62.54,54.99).
city('Shadrinsk','ru','Kurgan',79480.0,63.64,56.08).
city('Shatrovo','ru','Kurgan',6295.0,64.63,56.52).
city('Shchuchye','ru','Kurgan',10480.0,62.73,55.21).
city('Shumikha','ru','Kurgan',18500.0,63.3,55.23).
city('Tselinnoye','ru','Kurgan',5711.0,63.67,54.5).
city('Vargashi','ru','Kurgan',9728.0,65.83,55.36).
city('Vvedenskoye','ru','Kurgan',3895.0,65.08,55.47).
city('Yurgamysh','ru','Kurgan',7888.0,64.47,55.37).
city('Zverinogolovskoye','ru','Kurgan',4400.0,64.85,54.46).
city('Belaya','ru','Kursk',2810.0,35.72,51.05).
city('Bolshoye Soldatskoye','ru','Kursk',2647.0,35.51,51.34).
city('Cheremisinovo','ru','Kursk',3983.0,37.26,51.88).
city('Chernitsyno','ru','Kursk',2959.0,36.05,51.51).
city('Dmitriyev-Lgovskiy','ru','Kursk',8445.0,35.09,52.12).
city('Dyakonovo','ru','Kursk',4031.0,35.91,51.64).
city('Fatezh','ru','Kursk',5722.0,35.86,52.09).
city('Glushkovo','ru','Kursk',5618.0,34.63,51.34).
city('Gorshechnoye','ru','Kursk',6758.0,38.04,51.52).
city('Imeni Karla Libknekhta','ru','Kursk',8030.0,35.5,51.62).
city('Ivanino','ru','Kursk',2333.0,35.58,51.63).
city('Kastornoye','ru','Ku',4390.0,38.15,51.82).
city('Khomutovka','ru','Kursk',4936.0,34.56,51.92).
city('Kirovskiy','ru','Kursk',3043.0,36.67,51.42).
city('Konyshevka','ru','Kursk',4038.0,35.28,51.86).
city('Korenyovo','ru','Kursk',6480.0,34.91,51.39).
city('Kshenskiy','ru','Kursk',6504.0,37.71,51.84).
city('Kurchatov','ru','Kursk',47319.0,35.65,51.59).
city('Kursk','ru','Kursk',409435.0,36.19,51.73).
city('Lgov','ru','Kursk',23265.0,35.28,51.69).
city('Manturovo','ru','Kursk',2755.0,37.12,51.45).
city('Medvyonka','ru','Kursk',4491.0,36.11,51.42).
city('Oboyan','ru','Kursk',14434.0,36.45,51.21).
city('Olymskiy','ru','Kursk',3128.0,38.17,51.68).
city('Pervoavgustovskiy','ru','Kursk',1677.0,35.06,52.24).
city('Ponyri','ru','Kursk',4591.0,36.2,52.28).
city('Pristen','ru','Kursk',5463.0,36.71,51.24).
city('Pryamitsyno','ru','Kursk',5120.0,35.95,51.65).
city('Rylsk','ru','Kursk',17211.0,34.68,51.57).
city('Shchigry','ru','Kursk',19198.0,36.91,51.87).
city('Solntsevo','ru','Kursk',4374.0,36.75,51.4).
city('Sudzha','ru','Kursk',6940.0,35.26,51.2).
city('Tim','ru','Kursk',3673.0,37.12,51.62).
city('Tyotkino','ru','Kursk',5106.0,34.29,51.28).
city('Voroshnevo','ru','Kursk',3244.0,36.02,51.65).
city('Zheleznogorsk','ru','Kursk',97902.0,35.41,52.35).
city('Zolotukhino','ru','Kursk',4886.0,36.38,52.08).
city('Agalatovo','ru','Leningrad',5028.0,30.3,60.22).
city('Annino','ru','Leningrad',3315.0,30.05,59.77).
city('Begunitsy','ru','Leningrad',3558.0,29.32,59.58).
city('Boksitogorsk','ru','Leningrad',17366.0,33.85,59.48).
city('Bolshaya Izhora','ru','Leningrad',3812.0,29.57,59.93).
city('Bolshiye Kolpany','ru','Leningrad',4214.0,30.08,59.54).
city('Budogoshch','ru','Leningrad',3865.0,32.44,59.28).
city('Bugry','ru','Leningrad',4715.0,30.4,60.07).
city('Druzhnaya Gorka','ru','Leningrad',3677.0,30.13,59.28).
city('Dubrovka','ru','Leningrad',5405.0,30.7,59.93).
city('Fedorovskoye','ru','Leningrad',3013.0,30.53,59.67).
city('Fornosovo','ru','Leningrad',4841.0,30.58,59.58).
city('Garbolovo','ru','Leningrad',3830.0,30.5,60.35).
city('Gatchina','ru','Leningrad',89763.0,30.13,59.57).
city('Glebychevo','ru','Leningrad',3243.0,28.75,60.45).
city('Gorbunki','ru','Leningrad',7566.0,29.97,59.83).
city('Gostilitsy','ru','Leningrad',3563.0,29.62,59.75).
city('Imeni Morozova','ru','Leningrad',10623.0,31.03,59.98).
city('Imeni Sverdlova','ru','Leningrad',9151.0,30.67,59.78).
city('Ivangorod','ru','Leningrad',11074.0,28.22,59.37).
city('Kamenka','ru','Leningrad',8071.0,28.51,60.5).
city('Kamennogorsk','ru','Leningrad',6208.0,29.12,60.97).
city('Kikerino','ru','Leningrad',1995.0,29.63,59.47).
city('Kingisepp','ru','Leningrad',50567.0,28.6,59.37).
city('Kipen','ru','Leningrad',3098.0,29.85,59.67).
city('Kirishi','ru','Leningrad',56191.0,32.02,59.46).
city('Kirovsk','ru','Leningrad',24678.0,31.0,59.87).
city('Kobrinskoye','ru','Leningrad',1158.0,30.12,59.42).
city('Kommunar','ru','Leningrad',17359.0,30.4,59.62).
city('Krasnyy Bor','ru','Leningrad',4852.0,30.67,59.7).
city('Kuzmolovskiy','ru','Leningrad',9676.0,30.5,60.09).
city('Kuznechnoye','ru','Leningrad',4714.0,29.87,61.15).
city('Lebyazhye','ru','Leningrad',5572.0,29.43,59.95).
city('Leskolovo','ru','Leningrad',4039.0,30.45,60.27).
city('Lesogorskiy','ru','Leningrad',2989.0,28.93,61.03).
city('Lodeynoye Pole','ru','Leningrad',22164.0,33.56,60.73).
city('Luga','ru','Leningrad',40115.0,29.84,58.74).
city('Lyuban','ru','Leningrad',4494.0,31.25,59.35).
city('Maloye Verevo','ru','Leningrad',4088.0,30.18,59.62).
city('Mga','ru','Leningrad',9565.0,31.07,59.75).
city('Murino','ru','Leningrad',4977.0,30.46,60.05).
city('Naziya','ru','Leningrad',5726.0,31.66,59.6).
city('Nikolskiy','ru','Leningrad',2916.0,34.07,60.92).
city('Nikolskoye','ru','Leningrad',17404.0,34.96,59.5).
city('Novaya Ladoga','ru','Leningrad',9680.0,32.31,60.1).
city('Novoye Devyatkino','ru','Leningrad',8802.0,30.47,60.05).
city('Nurma','ru','Leningrad',3256.0,31.02,59.55).
city('Otradnoye','ru','Leningrad',21397.0,30.82,59.78).
city('Pavlovo','ru','Leningrad',3348.0,30.9,59.81).
city('Pervomayskoye','ru','Leningrad',4473.0,29.73,60.37).
city('Pikalyovo','ru','Leningrad',23007.0,34.17,59.52).
city('Podporozhye','ru','Leningrad',19658.0,34.19,60.92).
city('Priladozhskiy','ru','Leningrad',5159.0,31.48,59.85).
city('Primorsk','ru','Leningrad',5107.0,28.6,60.37).
city('Priozyorsk','ru','Leningrad',20440.0,30.12,61.03).
city('Rakhya','ru','Leningrad',3140.0,30.84,60.09).
city('Romanovka','ru','Leningrad',5647.0,30.7,60.05).
city('Roshchino','ru','Leningrad',9346.0,29.61,60.25).
city('Russko-Vysotskoye','ru','Leningrad',4711.0,29.93,59.7).
city('Ryabovo','ru','Leningrad',3292.0,31.13,59.4).
city('Sapernoye','ru','Leningrad',3280.0,29.96,60.71).
city('Schluesselburg','ru','Leningrad',12393.0,31.03,59.95).
city('Sertolovo','ru','Leningrad',43626.0,30.2,60.15).
city('Shcheglovo','ru','Leningrad',3095.0,30.75,60.03).
city('Sinyavino','ru','Leningrad',3593.0,31.07,59.9).
city('Siverskiy','ru','Leningrad',12076.0,30.08,59.35).
city('Slantsy','ru','Leningrad',36209.0,28.07,59.1).
city('Sosnovo','ru','Leningrad',5923.0,30.26,60.56).
city('Sosnovyy B','ru','Leningrad',68564.0,29.12,59.9).
city('Sovetskiy','ru','Leningrad',6574.0,28.68,60.53).
city('Staraya','ru','Leningrad',4444.0,30.63,59.9).
city('Svetogorsk','ru','Leningrad',15734.0,28.85,61.12).
city('Svirstroy','ru','Leningrad',1039.0,33.72,60.81).
city('Syasstroy','ru','Leningrad',13170.0,32.57,60.14).
city('Taytsy','ru','Leningrad',2631.0,30.12,59.67).
city('Tikhvin','ru','Leningrad',62076.0,33.51,59.64).
city('Toksovo','ru','Leningrad',5863.0,30.53,60.15).
city('Tolmachevo','ru','Leningrad',3361.0,29.91,58.86).
city('Tosno','ru','Leningrad',40198.0,30.88,59.55).
city('Ulyanovka','ru','Leningrad',9197.0,30.77,59.63).
city('Vazhiny','ru','Leningrad',2926.0,34.02,60.96).
city('Volkhov','ru','Leningrad',45673.0,32.34,59.93).
city('Volosovo','ru','Leningrad',12096.0,29.5,59.45).
city('Voyskovitsy','ru','Leningrad',3896.0,29.97,59.53).
city('Voznesenye','ru','Leningrad',2803.0,35.47,61.02).
city('Vsevolozhsk','ru','Leningrad',48224.0,30.68,60.02).
city('Vyborg','ru','Leningrad',78634.0,28.75,60.7).
city('Vyritsa','ru','Leningrad',11107.0,30.35,59.42).
city('Vysotsk','ru','Leningrad',1873.0,28.57,60.63).
city('Yanino','ru','Leningrad',4263.0,30.56,59.93).
city('Yefimovskiy','ru','Leningrad',3917.0,34.65,59.63).
city('Yelizavetino','ru','Leningrad',3037.0,29.76,59.48).
city('Borinskoye','ru','Lipetsk',5998.0,39.37,52.46).
city('Chaplygin','ru','Lipetsk',13488.0,39.96,53.24).
city('Dankov','ru','Lipetsk',22914.0,39.15,53.25).
city('Dobrinka','ru','Lipetsk',10063.0,40.47,52.17).
city('Dobroye','ru','Lipetsk',5550.0,39.82,52.86).
city('Dolgorukovo','ru','Lipetsk',5599.0,38.34,52.31).
city('Donskoye','ru','Lipetsk',3860.0,38.97,52.62).
city('Gryazi','ru','Lipetsk',47414.0,39.94,52.49).
city('Izmalkovo','ru','Lipetsk',4072.0,37.96,52.69).
city('Kalikino','ru','Lipetsk',3352.0,39.83,52.95).
city('Kazaki','ru','Lipetsk',3227.0,38.27,52.63).
city('Khlevnoye','ru','Lipetsk',6150.0,39.09,52.2).
city('Krasnoye','ru','Lipetsk',4021.0,38.79,52.86).
city('Krivopolyanye','ru','Lipetsk',5080.0,39.93,53.23).
city('Lebedyan','ru','Lipetsk',22970.0,39.14,53.01).
city('Lev Tolstoy','ru','Lipetsk',8955.0,39.45,53.21).
city('Lipetsk','ru','Lipetsk',515659.0,39.62,52.62).
city('Prigorodka','ru','Lipetsk',3140.0,39.71,52.05).
city('Stanovoye','ru','Lipetsk',5211.0,38.36,52.77).
city('Syrskoye','ru','Lipetsk',3454.0,39.52,52.57).
city('Terbuny','ru','Lipetsk',6936.0,38.28,52.14).
city('Usman','ru','Lipetsk',19910.0,39.72,52.05).
city('Volovo','ru','Lipetsk',4036.0,37.88,52.02).
city('Yelets','ru','Lipetsk',115690.0,38.51,52.6).
city('Zadonsk','ru','Lipetsk',10326.0,38.93,52.38).
city('Arman','ru','Magadan',1411.0,150.17,59.7).
city('Atka','ru','Magadan',560.0,151.8,60.83).
city('Belichan','ru','Magadan',30.0,148.1,62.9).
city('Bolshevik','ru','Magadan',344.0,147.5,62.73).
city('Burkhala','ru','Magadan',530.0,148.97,62.7).
city('Debin','ru','Magadan',854.0,150.2,62.37).
city('Dukat','ru','Magadan',1194.0,155.55,62.55).
city('Evensk','ru','Magadan',2024.0,159.23,61.95).
city('Galimyy','ru','Magadan',174.0,155.98,62.33).
city('Kadykchan','ru','Magadan',812.0,147.01,63.08).
city('Karamken','ru','Magadan',691.0,151.17,60.2).
city('Kholodnyy','ru','Magadan',1247.0,147.95,62.72).
city('Magadan','ru','Magadan',95258.0,150.8,59.57).
city('Myaundzha','ru','Magadan',1977.0,147.19,63.04).
city('Ola','ru','Magadan',6347.0,151.28,59.58).
city('Omsukchan','ru','Magadan',4201.0,155.8,62.53).
city('Orotukan','ru','Magadan',2560.0,151.7,62.27).
city('Palatka','ru','Magadan',4534.0,150.9,60.1).
city('Seymchan','ru','Magadan',3455.0,152.43,62.88).
city('Shirokiy','ru','Magadan',543.0,147.95,63.12).
city('Sinegorye','ru','Magadan',3776.0,150.77,62.35).
city('Sokol','ru','Magadan',4374.0,150.92,59.88).
city('Spornoye','ru','Magadan',854.0,151.05,62.33).
city('Stekolnyy','ru','Magadan',2096.0,150.75,60.05).
city('Susuman','ru','Magadan',7366.0,148.17,62.78).
city('Talaya','ru','Magadan',1054.0,152.75,61.36).
city('Uptar','ru','Magadan',2144.0,150.92,59.75).
city('Ust-Omchug','ru','Magadan',4515.0,149.63,61.15).
city('Verkhniy At-Uryakh','ru','Magadan',57.0,150.12,62.65).
city('Yagodnoye','ru','Magadan',4685.0,149.62,62.53).
city('Kilemary','ru','Mari El',3903.0,46.87,56.78).
city('Kozmodemyansk','ru','Mari El',22536.0,46.57,56.34).
city('Krasnogorskiy','ru','Mari El',7065.0,48.33,56.15).
city('Krasnokokshaisk','ru','Mari El',259542.0,47.87,56.64).
city('Krasnooktyabrskiy','ru','Mari El',4254.0,47.66,56.68).
city('Kuzhener','ru','Mari El',5797.0,48.9,56.8).
city('Mari-Turek','ru','Mari El',5900.0,49.62,56.79).
city('Medvedevo','ru','Mari El',16407.0,47.82,56.63).
city('Mochalishche','ru','Mari El',2225.0,48.35,56.33).
city('Morki','ru','Mari El',9568.0,49.0,56.43).
city('Novyy Toryal','ru','Mari El',7177.0,48.74,57.0).
city('Orshanka','ru','Mari El',6750.0,47.9,56.91).
city('Paranga','ru','Mari El',6634.0,49.4,56.7).
city('Privolzhskiy','ru','Mari El',4110.0,48.41,55.97).
city('Semyonovka','ru','Mari El',6897.0,47.95,56.65).
city('Sernur','ru','Mari El',8921.0,49.15,56.93).
city('Sovetskiy','ru','Mari El',10674.0,48.48,56.76).
city('Surok','ru','Mari El',3126.0,48.12,56.44).
city('Suslonger','ru','Mari El',3597.0,48.25,56.31).
city('Vizimyary','ru','Mari El',2358.0,46.92,56.43).
city('Volzhsk','ru','Mari El',58608.0,48.51,55.85).
city('Yurino','ru','Mari El',4199.0,46.3,56.29).
city('Zvenigovo','ru','Mari El',12484.0,48.02,55.97).
city('Ardatov','ru','Mordovia',9478.0,46.23,54.87).
city('Atemar','ru','Mordovia',4052.0,45.4,54.18).
city('Atyashevo','ru','Mordovia',5935.0,46.09,54.59).
city('Atyuryevo','ru','Mordovia',4628.0,43.33,54.32).
city('Barashevo','ru','Mordovia',3651.0,42.88,54.53).
city('Bolshaya Yelkhovka','ru','Mordovia',4020.0,45.31,54.28).
city('Bolshiye Berezniki','ru','Mordovia',6252.0,45.95,54.18).
city('Bolshoye Ignatovo','ru','Mordovia',2735.0,45.57,55.02).
city('Chaunza','ru','Mordovia',9680.0,45.78,54.4).
city('Dubyonki','ru','Mordovia',3499.0,46.3,54.45).
city('Insar','ru','Mordovia',8838.0,44.37,53.87).
city('Kadoshkino','ru','Mordovia',4763.0,44.42,54.03).
city('Kemlya','ru','Mordovia',4761.0,45.25,54.7).
city('Kochkurovo','ru','Mordovia',3185.0,45.43,54.03).
city('Komsomolskiy','ru','Mordovia',13906.0,45.82,54.45).
city('Kovylkino','ru','Mordovia',21838.0,43.64,54.01).
city('Krasnoslobodsk','ru','Mordovia',10748.0,43.79,54.42).
city('Lepley','ru','Mordovia',3074.0,42.86,54.31).
city('Lukhovka','ru','Mordovia',8892.0,45.23,54.15).
city('Lyambir','ru','Mordovia',8274.0,45.12,54.28).
city('Nikolayevka','ru','Mordovia',5081.0,45.14,54.15).
city('Partsa','ru','Mordovia',3056.0,42.86,54.37).
city('Potma','ru','Mordovia',4296.0,42.9,54.12).
city('Romodanovo','ru','Mordovia',9646.0,45.33,54.43).
city('Ruzajevka','ru','Mordovia',49311.0,44.93,54.07).
city('Saransk','ru','Mordovia',303397.0,45.18,54.18).
city('Shiringushi','ru','Mordovia',2369.0,42.77,53.85).
city('Sosnovka','ru','Mordovia',3616.0,43.29,54.71).
city('Tatarskaya Pishlya','ru','Mordovia',3150.0,44.92,54.07).
city('Temnikov','ru','Mordovia',8252.0,43.21,54.63).
city('Tengushevo','ru','Mordovia',4010.0,42.72,54.77).
city('Torbeyevo','ru','Mordovia',9138.0,43.25,54.07).
city('Turgenevo','ru','Mordovia',5168.0,46.32,54.83).
city('Udarnyy','ru','Mordovia',3581.0,42.86,54.34).
city('Umyot','ru','Mordovia',2937.0,42.7,54.12).
city('Vysha','ru','Mordovia',1061.0,42.36,53.85).
city('Yangawyl','ru','Mordovia',4972.0,45.13,54.13).
city('Yavas','ru','Mordovia',7783.0,42.85,54.42).
city('Yelniki','ru','Mordovia',5549.0,43.87,54.62).
city('Zubova Polyana','ru','Mordovi',10119.0,42.83,54.08).
city('Zykovo','ru','Mordovia',1059.0,45.1,54.07).
city('Moscow','ru','Moscow',1.0381288E7,37.62,55.75).
city('Nekrasovka','ru','Moscow',7994.0,37.92,55.68).
city('Vnukovo','ru','Moscow',20592.0,37.18,55.6).
city('Vostochnyy','ru','Moscow',13011.0,37.87,55.82).
city('Zelenograd','ru','Moscow',228298.0,37.29,55.94).
city('Abramtsevo','ru','Moskovskaya Oblast',236.0,37.83,55.83).
city('Alabino','ru','Moskovskaya Oblast',612.0,37.01,55.53).
city('Alabushevo','ru','Moskovskaya Oblast',2733.0,37.15,56.02).
city('Andreyevka','ru','Moskovskaya Oblast',8395.0,37.13,55.99).
city('Aprelevka','ru','Moskovskaya Oblast',17780.0,37.07,55.54).
city('Arkhangelskoye','ru','Moskovskaya Oblast',3582.0,37.28,55.78).
city('Ashitkovo','ru','Moskovskaya Oblast',3285.0,38.62,55.43).
city('Ashukino','ru','Moskovskaya Oblast',6310.0,37.95,56.17).
city('Ateptsevo','ru','Moskovskaya Oblast',3424.0,36.75,55.33).
city('Avsyunino','ru','Moskovskaya Oblast',5148.0,39.08,55.55).
city('Baksheyevo','ru','Moskovskaya Oblast',2296.0,39.88,55.71).
city('Balashikha','ru','Moskovskaya Oblast',150105.0,37.95,55.8).
city('Barvikha','ru','Moskovskaya Oblast',4193.0,37.28,55.74).
city('Barybino','ru','Moskovskaya Oblast',3994.0,37.9,55.26).
city('Beloomut','ru','Moskovskaya Oblast',6971.0,39.34,54.94).
city('Beloozyorskiy','ru','Moskovskaya Oblast',14375.0,38.49,55.47).
city('Belyye Stolby','ru','Moskovskaya Oblast',5563.0,37.86,55.33).
city('Bogorodskoye','ru','Moskovskaya Oblast',9275.0,37.88,56.55).
city('Bolshevik','ru','Moskovskaya Oblast',5229.0,41.61,51.03).
city('Bolshevo','ru','Moskovskaya Oblast',10133.0,37.85,55.93).
city('Bolshiye Dvory','ru','Moskovskaya Oblast',4801.0,38.65,55.82).
city('Bolshiye Vyazyomy','ru','Moskovskaya Oblast',5620.0,36.98,55.63).
city('Bolshoye Bunkovo','ru','Moskovskaya Oblast',3412.0,38.62,55.85).
city('Bronnitsy','ru','Moskovskaya Oblast',18645.0,38.27,55.43).
city('Bykovo','ru','Moskovskaya Oblast',9159.0,38.05,55.63).
city('Chekhov','ru','Moskovskaya Oblast',75645.0,37.48,55.15).
city('Cherkizovo','ru','Moskovskaya Oblast',3439.0,37.8,55.97).
city('Chernogolovka','ru','Moskovskaya Oblast',20117.0,38.37,56.0).
city('Chernoye','ru','Moskovskaya Oblast',5755.0,38.07,55.75).
city('Cherusti','ru','Moskovskaya Oblast',2867.0,40.02,55.55).
city('Davydovo','ru','Moskovskaya Oblast',10606.0,38.85,55.61).
city('Dedenevo','ru','Moskovskaya Oblast',6455.0,37.52,56.25).
city('Dedovsk','ru','Moskovskaya Oblast',27001.0,37.12,55.87).
city('Demikhovo','ru','Moskovskaya Oblast',5474.0,38.87,55.8).
city('Dmitrov','ru','Moskovskaya Oblast',61608.0,37.52,56.35).
city('Dolgoprudnyy','ru','Moskovskaya Oblast',68260.0,37.51,55.93).
city('Domodedovo','ru','Moskovskaya Oblast',53888.0,37.75,55.43).
city('Dorokhovo','ru','Moskovskaya Oblast',4313.0,36.37,55.54).
city('Drezna','ru','Moskovskaya Oblast',11387.0,38.84,55.75).
city('Druzhba','ru','Moskovskaya Oblast',4058.0,37.75,55.88).
city('Dubki','ru','Moskovskaya Oblast',388.0,37.22,55.67).
city('Dubna','ru','Moskovskaya Oblast',60605.0,37.15,56.75).
city('Dzerzhinskiy','ru','Moskovskaya Oblast',41146.0,37.84,55.63).
city('Elektrogorsk','ru','Moskovskaya Oblast',20724.0,38.79,55.88).
city('Elektrostal','ru','Moskovskaya Oblast',144389.0,38.44,55.79).
city('Elektrougli','ru','Moskovskaya Oblast',16257.0,38.34,55.71).
city('Firsanovka','ru','Moskovskaya Oblast',2824.0,37.24,55.95).
city('Fosforitnyy','ru','Moskovskaya Oblast',4158.0,38.9,55.33).
city('Fryanovo','ru','Moskovskaya Oblast',11088.0,38.45,56.13).
city('Fryazino','ru','Moskovskaya Oblast',52256.0,38.05,55.95).
city('Galchino','ru','Moskovskaya Oblast',2980.0,35.71,55.34).
city('Golitsyno','ru','Moskovskaya Oblast',16056.0,36.98,55.61).
city('Gorki Leninskiye','ru','Moskovskaya Oblast',1715.0,37.77,55.5).
city('Iksha','ru','Moskovskaya Oblast',3707.0,37.52,56.17).
city('Ilyinskiy','ru','Moskovskaya Oblast',7929.0,38.1,55.62).
city('Ilyinskoye','ru','Moskovskaya Oblast',5601.0,37.73,55.35).
city('Imeni Pervoye Maya','ru','Moskov',3049.0,39.2,55.77).
city('Imeni Tsyurupy','ru','Moskovskaya Oblast',3926.0,38.64,55.5).
city('Imeni Vorovskogo','ru','Moskovskaya Oblast',5303.0,38.33,55.72).
city('Istra','ru','Moskovskaya Oblast',33391.0,36.86,55.92).
city('Ivanteyevka','ru','Moskovskaya Oblast',51086.0,37.92,55.97).
city('Kashira','ru','Moskovskaya Oblast',40084.0,38.17,54.84).
city('Kerva','ru','Moskovskaya Oblast',2784.0,39.58,55.62).
city('Khimki','ru','Moskovskaya Oblast',142620.0,37.44,55.89).
city('Khorlovo','ru','Moskovskaya Oblast',3852.0,38.82,55.34).
city('Khotkovo','ru','Moskovskaya Oblast',20464.0,38.0,56.25).
city('Klimovsk','ru','Moskovskaya Oblast',55207.0,37.53,55.36).
city('Klin','ru','Moskovskaya Oblast',80779.0,36.7,56.34).
city('Klyazma','ru','Moskovskaya Oblast',3439.0,37.83,55.96).
city('Kokoshkino','ru','Moskovskaya Oblast',9818.0,37.17,55.6).
city('Kolomna','ru','Moskovskaya Oblast',147692.0,38.78,55.08).
city('Kolyubakino','ru','Moskovskaya Oblast',2724.0,36.53,55.67).
city('Kommunarka','ru','Moskovskaya Oblast',4684.0,37.48,55.57).
city('Konstantinovo','ru','Moskovskaya Oblast',3565.0,38.03,56.56).
city('Korenevo','ru','Moskovskaya Oblast',7319.0,38.0,55.67).
city('Korolyov','ru','Moskovskaya Oblast',139800.0,37.82,55.92).
city('Kotelniki','ru','Moskovskaya Oblast',17601.0,37.86,55.65).
city('Kraskovo','ru','Moskovskaya Oblast',11832.0,37.98,55.65).
city('Krasnaya Poyma','ru','Moskovskaya Oblast',3113.0,39.08,55.01).
city('Krasnoarmeysk','ru','Moskovskaya Oblast',25689.0,38.13,56.1).
city('Krasnogorsk','ru','Moskovskaya Oblast',92934.0,37.33,55.83).
city('Krasnozavodsk','ru','Moskovskaya Oblast',11694.0,38.22,56.45).
city('Krasnyy Tkach','ru','Moskovskaya Oblast',3166.0,39.08,55.47).
city('Kratovo','ru','Moskovskaya Oblast',6799.0,38.18,55.6).
city('Kubinka','ru','Moskovskaya Oblast',25942.0,36.69,55.58).
city('Kupavna','ru','Moskovskaya Oblast',6636.0,38.15,55.78).
city('Kurovskoye','ru','Moskovskaya Oblast',19173.0,38.91,55.58).
city('Lesnoy','ru','Moskovskaya Oblast',8689.0,37.92,56.07).
city('Lesnoy Gorodok','ru','Moskovskaya Oblast',5056.0,37.21,55.64).
city('Lesnyye Polyany','ru','Moskovskaya Oblast',3695.0,37.87,55.97).
city('Likino-Dulyovo','ru','Moskovskaya Oblast',30836.0,38.96,55.7).
city('Lobnya','ru','Moskovskaya Oblast',61772.0,37.48,56.01).
city('Lopatinskiy','ru','Moskovskaya Oblast',14219.0,38.73,55.33).
city('Losino-Petrovskiy','ru','Moskovskaya Oblast',22116.0,38.2,55.87).
city('Lotoshino','ru','Moskovskaya Oblast',5623.0,35.64,56.23).
city('Lugovaya','ru','Moskovskaya Oblast',3086.0,37.48,56.05).
city('Lukhovitsy','ru','Moskovskaya Oblast',32388.0,39.04,54.97).
city('Lvovskiy','ru','Moskovskaya Oblast',11808.0,37.53,55.31).
city('Lytkarino','ru','Moskovskaya Oblast',50620.0,37.9,55.58).
city('Lyubertsy','ru','Moskovskaya Oblast',154653.0,37.89,55.67).
city('Lyubuchany','ru','Moskovskaya Oblast',3537.0,37.55,55.24).
city('Malakhovka','ru','Moskovskaya Oblast',18399.0,38.02,55.65).
city('Malino','ru','Moskovskaya Oblast',4327.0,38.19,55.11).
city('Mamontovka','ru','Moskovskaya Oblast',8817.0,37.82,55.98).
city('Marfino','ru','Moskovskaya Oblast',3687.0,37.38,55.7).
city('Mendeleyevo','ru','Moskovskaya Oblast',7964.0,37.21,56.03).
city('Meshcherino','ru','Moskovskaya Oblast',4207.0,38.36,55.2).
city('Mikhnyovo','ru','Moskovskaya Oblast',10742.0,37.95,55.13).
city('Misheronskiy','ru','Moskovskaya Oblast',3790.0,39.73,55.72).
city('Monino','ru','Moskovskaya Oblast',19852.0,38.19,55.84).
city('Moskovskiy','ru','Moskovskaya Oblast',15435.0,37.36,55.6).
city('Mozhaysk','ru','Moskovskaya Oblast',31557.0,36.03,55.5).
city('Mukhanovo','ru','Moskovskaya Oblast',652.0,38.32,56.5).
city('Mytishchi','ru','Moskovskaya Oblast',160545.0,37.73,55.91).
city('Nakhabino','ru','Moskovskaya Oblast',27985.0,37.26,55.83).
city('Naro-Fominsk','ru','Moskovskaya Oblast',72633.0,36.74,55.39).
city('Nekrasovskiy','ru','Moskovskaya Oblast',9613.0,37.5,56.07).
city('Nemchinovka','ru','Moskovskaya Oblast',3337.0,37.36,55.72).
city('Nikolsko-Arkhangelskiy','ru','Moskovskaya Oblast',18483.0,37.9,55.75).
city('Noginsk','ru','Moskovskaya Oblast',115981.0,38.44,55.85).
city('Novopetrovskoye','ru','Moskovskaya Oblast',5184.0,36.47,55.99).
city('Novopodrezkovo','ru','Moskovskaya Oblast',10271.0,37.34,55.94).
city('Obukhovo','ru','Moskovskaya Oblast',10657.0,38.28,54.83).
city('Odintsovo','ru','Moskovskaya Oblast',137043.0,37.29,55.67).
city('Oktyabrskiy','ru','Moskovskaya Oblast',10051.0,37.97,55.61).
city('Opalikha','ru','Moskovskaya Oblast',5081.0,37.25,55.83).
city('Orekhovo-Zuevo','ru','Moskovskaya Oblast',120001.0,38.98,55.82).
city('Ostrovtsy','ru','Moskovskaya Oblast',3683.0,38.01,55.59).
city('Ozherele','ru','Moskovskaya Oblast',10353.0,38.27,54.79).
city('Ozyory','ru','Moskovskaya Oblast',25162.0,38.54,54.85).
city('Pavlovskaya Sloboda','ru','Moskovskaya Oblast',5937.0,37.08,55.81).
city('Pavlovskiy Posad','ru','Moskovskaya Oblast',60052.0,38.65,55.78).
city('Pervomayskiy','ru','Moskovskaya Oblast',9964.0,37.22,55.52).
city('Peski','ru','Moskovskaya Oblast',3705.0,38.77,55.22).
city('Pirogovskiy','ru','Moskovskaya Oblast',6208.0,37.73,55.98).
city('Podolsk','ru','Moskovskaya Oblast',175326.0,37.54,55.42).
city('Pokrovka','ru','Moskovskaya Oblast',390.0,36.83,56.24).
city('Povarovo','ru','Moskovskaya Oblast',7539.0,37.05,56.07).
city('Pravdinskiy','ru','Moskovskaya Oblast',10372.0,37.85,56.07).
city('Privokzalnyy','ru','Moskovskaya Oblast',3617.0,35.92,56.0).
city('Proletarskiy','ru','Moskovskaya Oblast',4069.0,37.38,55.02).
city('Protvino','ru','Moskovskaya Oblast',37330.0,37.22,54.87).
city('Pushchino','ru','Moskovskaya Oblast',20073.0,37.6,54.83).
city('Pushkino','ru','Moskovskaya Oblast',71653.0,37.83,56.0).
city('Radovitskiy','ru','Moskovskaya Oblast',1887.0,39.8,55.13).
city('Ramenskoye','ru','Moskovskaya Oblast',42417.0,38.27,55.53).
city('Razvilka','ru','Moskovskaya Oblast',8701.0,37.75,55.59).
city('Rechitsy','ru','Moskovskaya Oblast',3436.0,38.48,55.61).
city('Reshetnikovo','ru','Moskovskaya Oblast',3192.0,36.57,56.45).
city('Reutov','ru','Moskovskaya Oblast',78371.0,37.86,55.76).
city('Rodniki','ru','Moskovskaya Oblast',3710.0,38.07,55.65).
city('Rogachyovo','ru','Moskovskaya Oblast',3381.0,37.18,56.43).
city('Roshal','ru','Moskovskaya Oblast',21951.0,39.88,55.67).
city('Rozhdestveno','ru','Moskovskaya Oblast',3062.0,37.05,55.85).
city('Ruza','ru','Moskovskaya Oblast',13480.0,36.2,55.7).
city('Ryazanovskiy','ru','Moskovskaya Oblast',2305.0,39.59,55.15).
city('Rzhavki','ru','Moskovskaya Oblast',4084.0,37.25,56.0).
city('Saltykovka','ru','Moskovskaya Oblast',4573.0,37.91,55.76).
city('Selyatino','ru','Moskovskaya Oblast',12954.0,36.97,55.52).
city('Semkhoz','ru','Moskovskaya Oblast',2838.0,38.07,56.28).
city('Serebryanye Prudy','ru','Moskovskaya Oblast',8895.0,38.72,54.46).
city('Sergiyev Posad','ru','Moskovskaya Oblast',112921.0,38.13,56.32).
city('Serpukhov','ru','Moskovskaya Oblast',128160.0,37.41,54.92).
city('Severnyy','ru','Moskovskaya Oblast',3796.0,37.65,56.73).
city('Shakhovskaya','ru','Moskovskaya Oblast',10353.0,35.51,56.03).
city('Shatura','ru','Moskovskaya Oblast',30069.0,39.54,55.58).
city('Shaturtorf','ru','Moskovskaya Oblast',3312.0,39.42,55.57).
city('Shcherbinka','ru','Moskovskaya Oblast',28066.0,37.56,55.5).
city('Shchyolkovo','ru','Moskovskaya Oblast',113215.0,38.02,55.9).
city('Sheremetyevskiy','ru','Moskovskaya Oblast',6411.0,37.5,55.99).
city('Skhodnya','ru','Moskovskaya Oblast',18898.0,37.3,55.95).
city('Skoropuskovskiy','ru','Moskovskaya Oblast',5434.0,38.17,56.37).
city('Snegiri','ru','Moskovskaya Obla',3465.0,37.03,55.88).
city('Sofrino','ru','Moskovskaya Oblast',15353.0,37.93,56.15).
city('Solnechnogorsk','ru','Moskovskaya Oblast',58892.0,36.98,56.18).
city('Staraya Kupavna','ru','Moskovskaya Oblast',21256.0,38.17,55.8).
city('Starbeyevo','ru','Moskovskaya Oblast',370.0,37.47,55.92).
city('Stolbovaya','ru','Moskovskaya Oblast',5142.0,37.49,55.25).
city('Stupino','ru','Moskovskaya Oblast',61000.0,38.07,54.9).
city('Sverdlovskiy','ru','Moskovskaya Oblast',5636.0,38.15,55.9).
city('Sychyovo','ru','Moskovskaya Oblast',3169.0,36.21,55.97).
city('Taldom','ru','Mosk',13112.0,37.53,56.73).
city('Tekstilshchik','ru','Moskovskaya Oblast',7430.0,37.84,55.94).
city('Tempy','ru','Moskovskaya Oblast',458.0,37.3,56.63).
city('Tomilino','ru','Moskovskaya Oblast',28310.0,37.94,55.66).
city('Troitsk','ru','Moskovskaya Oblast',33785.0,37.31,55.48).
city('Troitskoye','ru','Moskovskaya Oblast',4548.0,38.53,55.3).
city('Tuchkovo','ru','Moskovskaya Oblast',16826.0,36.47,55.6).
city('Tugolesskiy Bor','ru','Moskovskaya Oblast',2217.0,39.81,55.56).
city('Udelnaya','ru','Moskovskaya Oblast',13199.0,38.0,55.62).
city('Uvarovka','ru','Moskovskaya Oblast',3136.0,35.61,55.53).
city('Uzunovo','ru','Moskovskaya Oblast',3371.0,38.64,54.49).
city('Vatutinki','ru','Moskovskaya Oblast',9502.0,37.33,55.5).
city('Verbilki','ru','Moskovskaya Oblast',6708.0,37.6,56.53).
city('Vereya','ru','Moskovskaya Oblast',3445.0,37.64,55.56).
city('Vidnoye','ru','Moskovskaya Oblast',51722.0,37.71,55.55).
city('Vishnyakovskiye Dachi','ru','Moskovskaya Oblast',1773.0,38.13,55.75).
city('Volokolamsk','ru','Moskovskaya Oblast',16277.0,35.97,56.03).
city('Voskresensk','ru','Moskovskaya Oblast',77088.0,38.7,55.31).
city('Vostryakovo','ru','Moskovskaya Oblast',16509.0,37.81,55.39).
city('Vozhd Proletariata','ru','Moskovskaya Oblast',594.0,39.32,55.43).
city('Vysokovsk','ru','Moskovskaya Oblast',10772.0,36.55,56.32).
city('Yakhroma','ru','Moskovskaya Oblast',12667.0,37.48,56.3).
city('Yakovlevskoye','ru','Moskovskaya Oblast',4330.0,37.95,55.44).
city('Yam','ru','Moskovskaya Oblast',3244.0,37.75,55.48).
city('Yegoryyevsk','ru','Moskovskaya Oblast',66961.0,39.03,55.38).
city('Zagoryanskiy','ru','Moskovskaya Oblast',7514.0,37.96,55.93).
city('Zaprudnya','ru','Moskovskaya Oblast',12517.0,37.43,56.57).
city('Zaraysk','ru','Moskovskaya Oblast',24638.0,38.88,54.77).
city('Zavety Ilicha','ru','Moskovskaya Oblast',5758.0,37.85,56.05).
city('Zelenogradskiy','ru','Moskovskaya Oblast',2155.0,37.92,56.1).
city('Zhavoronki','ru','Moskovskaya Oblast',2899.0,37.1,55.65).
city('Zhilyovo','ru','Moskovskaya Oblast',2448.0,38.03,54.99).
city('Zhitnevo','ru','Moskovskaya Oblast',3193.0,37.91,55.35).
city('Zhukovskiy','ru','Moskovskaya Oblast',101253.0,38.25,55.55).
city('Zvenigorod','ru','Moskovskaya Oblast',11628.0,36.85,55.73).
city('Afrikanda','ru','Murmansk',1800.0,32.78,67.44).
city('Alakurtti','ru','Murmansk',6293.0,30.3,66.95).
city('Apatity','ru','Murmansk',61187.0,33.39,67.57).
city('Kandalaksha','ru','Murmansk',38432.0,32.41,67.16).
city('Kildinstroy','ru','Murmansk',2699.0,33.1,68.8).
city('Kirovsk','ru','Murmansk',29606.0,33.67,67.61).
city('Kola','ru','Murmansk',10282.0,33.11,68.92).
city('Kovdor','ru','Murmansk',19519.0,30.47,67.56).
city('Lovozero','ru','Murmansk',2963.0,35.01,68.01).
city('Molochnyy','ru','Murmansk',5308.0,33.0,68.85).
city('Monchegorsk','ru','Murmansk',49869.0,32.82,67.92).
city('Murmansk','ru','Murmansk',319266.0,33.08,68.96).
city('Murmashi','ru','Murmansk',15416.0,32.66,68.83).
city('Nikel','ru','Murmansk',15596.0,30.22,69.41).
city('Olenegorsk','ru','Murmansk',23670.0,33.3,68.15).
city('Ostrovnoy','ru','Murmansk',4747.0,39.51,68.05).
city('Pechenga','ru','Murmansk',2791.0,31.23,69.55).
city('Polyarnyy','ru','Murmansk',17332.0,33.45,69.2).
city('Polyarnyye Zori','ru','Murmansk',15092.0,32.5,67.41).
city('Prirechnyy','ru','Murmansk',103.0,30.35,69.03).
city('Revda','ru','Murmansk',9780.0,34.56,67.94).
city('Roslyakovo','ru','Murmansk',8921.0,33.22,69.05).
city('Safonovo','ru','Murmansk',4578.0,33.3,69.06).
city('Severomorsk','ru','Murmansk',53921.0,33.42,69.07).
city('Shonguy','ru','Murmansk',1122.0,33.13,68.78).
city('Skalistyy','ru','Murmansk',14225.0,33.35,69.26).
city('Snezhnogorsk','ru','Murmansk',12014.0,33.23,69.19).
city('Tumannyy','ru','Murmansk',896.0,35.69,68.88).
city('Umba','ru','Murmansk',6128.0,34.35,66.69).
city('Verkhnetulomskiy','ru','Murmansk',1889.0,31.8,68.61).
city('Vidyayevo','ru','Murmansk',5949.0,33.0,68.89).
city('Zaozyorsk','ru','Murmansk',11967.0,32.44,69.4).
city('Zapolyarnyy','ru','Murmansk',17790.0,30.8,69.41).
city('Zasheyek','ru','Murmansk',983.0,32.5,67.4).
city('Zelenoborskiy','ru','Murmansk',7207.0,32.36,66.85).
city('Amderma','ru','Nenets',609.0,61.67,69.76).
city('Iskateley','ru','Nenets',6545.0,53.02,67.67).
city('Naryan-Mar','ru','Nenets',18041.0,53.05,67.65).
city('Afonino','ru','Nizhni Novgorod',3182.0,44.1,56.27).
city('Ardatov','ru','Nizhni Novgorod',9946.0,43.09,55.24).
city('Arya','ru','Nizhni Novgorod',4931.0,45.96,57.49).
city('Arzamas','ru','Nizhni Novgorod',109480.0,43.82,55.38).
city('Babino','ru','Nizhni Novgorod',2456.0,43.63,56.22).
city('Balakhna','ru','Nizhni Novgorod',63084.0,43.59,56.49).
city('Blizhne-Pesochnoye','ru','Nizhni Novgorod',2634.0,42.07,55.33).
city('Bogorodsk','ru','Nizhni Novgorod',36652.0,43.52,56.1).
city('Bolshoye Kozino','ru','Nizhni Novgorod',5568.0,43.72,56.4).
city('Bolshoye Murashkino','ru','Nizhni Novgorod',6269.0,44.77,55.78).
city('Bolshoye Pikino','ru','Nizhni Novgorod',2622.0,44.19,56.35).
city('Bor','ru','Nizhni Novgorod',60648.0,44.09,56.35).
city('Burevestnik','ru','Nizhni Novgorod',3054.0,43.81,56.13).
city('Buturlino','ru','Nizhni Novgorod',6857.0,44.9,55.57).
city('Chernukha','ru','Nizhni Novgorod',3448.0,43.76,55.59).
city('Chistoye','ru','Nizhni Novgorod',1065.0,43.01,56.54).
city('Chkalovsk','ru','Nizhni Novgorod',13577.0,43.24,56.76).
city('Dalneye Konstantinovo','ru','Nizhni Novgorod',4902.0,44.09,55.81).
city('Diveyevo','ru','Nizhni Novgorod',6390.0,43.25,55.04).
city('Doschatoye','ru','Nizhni Novgorod',5004.0,42.11,55.38).
city('Dzerzhinsk','ru','Nizhni Novgorod',256540.0,43.46,56.24).
city('Frolishchi','ru','Nizhni Novgorod',1659.0,42.65,56.42).
city('Gagino','ru','Nizhni Novgorod',3933.0,45.04,55.23).
city('Gavrilovka','ru','Nizhni Novgorod',700.0,43.71,56.23).
city('Gidrotorf','ru','Nizhni Novgorod',7540.0,43.54,56.47).
city('Gorbatov','ru','Nizhni Novgorod',2495.0,43.06,56.13).
city('Gorbatovka','ru','Nizhni Novgorod',3265.0,43.74,56.26).
city('Gorodets','ru','Nizhni Novgorod',31789.0,43.48,56.65).
city('Gremyachyovo','ru','Nizhni Novgorod',5213.0,43.03,55.4).
city('Ilinogorsk','ru','Nizhni Novgorod',8291.0,42.99,56.23).
city('Imeni Stepana Razina','ru','Nizhni Novgorod',3123.0,44.3,54.9).
city('Katunki','ru','Nizhni Novgorod',815.0,43.22,56.83).
city('Kerzhenets','ru','Nizhni Novgorod',668.0,44.43,56.47).
city('Knyaginino','ru','Nizhni Novgorod',6923.0,45.03,55.82).
city('Kovernino','ru','Nizhni Novgorod',6759.0,43.81,57.13).
city('Krasnaya Gorka','ru','Nizhni Novgorod',1088.0,46.09,55.38).
city('Krasnyye Baki','ru','Nizhni Novgorod',7810.0,45.16,57.13).
city('Kstovo','ru','Nizhni Novgorod',67243.0,44.19,56.14).
city('Kulebaki','ru','Nizhni Novgorod',37623.0,42.53,55.41).
city('Leninskaya Sloboda','ru','Nizhni Novgorod',29.0,44.47,56.08).
city('Lesogorsk','ru','Nizhni Novgorod',1061.0,43.94,55.1).
city('Linda','ru','Nizhni Novgorod',5489.0,44.1,56.61).
city('Lukino','ru','Nizhni Novgorod',3619.0,43.63,56.44).
city('Lukoyanov','ru','Nizhni Novgorod',12913.0,44.49,55.04).
city('Lyskovo','ru','Nizhni Novgorod',23570.0,45.04,56.03).
city('Makaryevo','ru','Nizhni Novgorod',218.0,44.97,56.14).
city('Maloye Kozino','ru','Nizhni Novgorod',823.0,43.68,56.44).
city('Mukhtolovo','ru','Nizhni Novgorod',5615.0,43.2,55.46).
city('Mulino','ru','Nizhni Novgorod',11513.0,42.93,56.28).
city('Navashino','ru','Nizhni Novgorod',17552.0,42.2,55.53).
city('Neklyudovo','ru','Nizhni Novgorod',9052.0,43.98,56.41).
city('Nizhniy Novgorod','ru','Nizhni Novgorod',1284176.0,44.0,56.33).
city('Novosmolinskiy','ru','Nizhni Novgorod',5128.0,43.1,56.27).
city('Oktyabrskiy','ru','Nizhni Novgorod',7230.0,44.19,56.3).
city('Pamyat Parizhskoy Kommuny','ru','Nizhni Novgorod',4003.0,44.5,56.1).
city('Pavlovo','ru','Nizhni Novgorod',63339.0,43.09,55.96).
city('Perevoz','ru','Nizhni Novgorod',9228.0,44.54,55.6).
city('Pervomaysk','ru','Nizhni Novgorod',14810.0,43.81,54.87).
city('Pervomayskiy','ru','Nizhni Novgorod',1086.0,43.35,56.62).
city('Pervoye Maya','ru','Nizhni Novgorod',2173.0,44.71,56.16).
city('Pilna','ru','Nizhni Novgorod',7733.0,45.92,55.55).
city('Pizhma','ru','Nizhni Novgorod',4266.0,47.12,57.86).
city('Pochinki','ru','Nizhni Novgorod',11724.0,44.85,54.7).
city('Prudy','ru','Nizhni Novgorod',3806.0,46.26,57.57).
city('Pyra','ru','Nizhni Novgorod',1991.0,43.36,56.31).
city('Reshetikha','ru','Nizhni Novgorod',7356.0,43.29,56.22).
city('Sarov','ru','Nizhni Novgorod',86172.0,43.83,55.38).
city('Satis','ru','Nizhni Novgorod',2453.0,43.53,54.97).
city('Savasleyka','ru','Nizhni Novgorod',3261.0,42.31,55.45).
city('Sechenovo','ru','Nizhni Novgorod',5151.0,45.89,55.22).
city('Semyonov','ru','Nizhni Novgorod',25004.0,44.49,56.8).
city('Sergach','ru','Nizhni Novgorod',22361.0,45.47,55.53).
city('Shakhunya','ru','Nizhni Novgorod',21529.0,46.62,57.67).
city('Sharanga','ru','Nizhni Novgorod',6273.0,46.54,57.17).
city('Shatki','ru','Nizhni Novgorod',9712.0,44.13,55.19).
city('Shaygino','ru','Nizhni Novgorod',1095.0,46.86,57.77).
city('Shimorskoye','ru','Nizhni Novgorod',3727.0,42.03,55.32).
city('Sitniki','ru','Nizhni Novgorod',1321.0,44.06,56.44).
city('Smolino','ru','Nizhni Novgorod',2862.0,43.03,56.28).
city('Sokolskoye','ru','Nizhni Novgorod',6570.0,43.16,57.14).
city('Sosnovskoye','ru','Nizhni Novgorod',9052.0,43.16,55.8).
city('Spasskoye','ru','Nizhni Novgorod',4023.0,45.69,55.86).
city('Sukhobezvodnoye','ru','Nizhni Novgorod',6634.0,44.89,57.05).
city('Surovatikha','ru','Nizhni Novgorod',4644.0,43.9,55.77).
city('Syava','ru','Nizhni Novgorod',5339.0,46.32,58.02).
city('Taremskoye','ru','Nizhni Novgorod',3059.0,43.05,55.93).
city('Tonkino','ru','Nizhni Novgorod',5406.0,46.46,57.37).
city('Tonshayevo','ru','Nizhni Novgorod',4357.0,47.1,57.74).
city('Tsentralnyy','ru','Nizhni Novgorod',3805.0,42.76,56.35).
city('Tumbotino','ru','Nizhni Novgorod',7546.0,43.03,56.0).
city('Tyosha','ru','Nizhni Novgorod',1285.0,42.81,55.51).
city('Ulyanovo','ru','Nizhni Novgorod',3361.0,44.4,55.05).
city('Urazovka','ru','Nizhni Novgorod',1884.0,45.62,55.4).
city('Uren','ru','Nizhni Novgorod',12311.0,45.78,57.46).
city('Vacha','ru','Nizhni Novgorod',6618.0,42.77,55.8).
city('Vad','ru','Nizhni Novgorod',6645.0,44.21,55.53).
city('Vakhtan','ru','Nizhni Novgorod',6529.0,46.68,57.97).
city('Varnavino','ru','Nizhni Novgorod',3655.0,45.08,57.4).
city('Vasilsursk','ru','Nizhni Novgorod',1307.0,46.01,56.13).
city('Veletma','ru','Nizhni Novgorod',1178.0,42.42,55.33).
city('Vetluga','ru','Nizhni Novgorod',9497.0,45.78,57.86).
city('Vetluzhskiy','ru','Nizhni Novgorod',5578.0,45.12,57.17).
city('Vilya','ru','Nizhni Novgorod',3338.0,42.21,55.25).
city('Volodarsk','ru','Nizhni Novgorod',10862.0,43.19,56.23).
city('Vorotynets','ru','Nizhni Novgorod',6606.0,45.86,56.06).
city('Vorsma','ru','Nizhni Novgorod',12362.0,43.27,55.99).
city('Voskresenskoye','ru','Nizhni Novgorod',6255.0,45.43,56.84).
city('Voznesenskoye','ru','Nizhni Novgorod',7204.0,42.76,54.89).
city('Vyksa','ru','Nizhni Novgorod',61665.0,42.17,55.32).
city('Vyyezdnoye','ru','Nizhni Novgorod',7857.0,43.78,55.39).
city('Yuganets','ru','Nizhni Novgorod',2991.0,43.24,56.25).
city('Zavolzhye','ru','Nizhni Novgorod',43700.0,43.41,56.64).
city('Zelenyy Gorod','ru','Nizhni Novgorod',2396.0,44.07,56.17).
city('Zhelnino','ru','Nizhni Novgorod',684.0,43.36,56.2).
city('Alagir','ru','North Ossetia',21542.0,44.21,42.97).
city('Ardon','ru','North Ossetia',18313.0,44.29,43.18).
city('Arkhonskaya','ru','North Ossetia',7991.0,44.52,43.11).
city('Bersin-Yurt','ru','North Ossetia',36078.0,44.54,43.2).
city('Buron','ru','North Ossetia',496.0,44.01,42.8).
city('Chermen','ru','North Ossetia',8550.0,44.71,43.15).
city('Chikola','ru','North Ossetia',7142.0,43.92,43.19).
city('Dachnoye','ru','North Ossetia',4579.0,44.74,43.08).
city('Digora','ru','North Ossetia',12000.0,44.16,43.16).
city('Elkhotovo','ru','North Ossetia',12425.0,44.2,43.34).
city('Gizel','ru','North Ossetia',7256.0,44.57,43.04).
city('Kambileyevskoye','ru','North Ossetia',7770.0,44.76,43.07).
city('Kardzhin','ru','North Ossetia',3154.0,44.28,43.27).
city('Kholst','ru','North Ossetia',45.0,44.15,42.83).
city('Khumala','ru','North Ossetia',3906.0,44.47,43.24).
city('Kizlyar','ru','North Ossetia',8544.0,44.6,43.7).
city('Lukovskaya','ru','North Ossetia',5299.0,44.6,43.72).
city('Mikhaylovskoye','ru','North Ossetia',10479.0,44.64,43.1).
city('Mizur','ru','North Ossetia',2934.0,44.08,42.86).
city('Mozdok','ru','North Ossetia',43779.0,44.65,43.75).
city('Nogir','ru','North Ossetia',11469.0,44.64,43.08).
city('Oktyabrskoye','ru','North Ossetia',10763.0,44.74,43.07).
city('Olginskoye','ru','North Ossetia',3182.0,44.69,43.16).
city('Pavlodolskaya','ru','North Ossetia',5833.0,44.48,43.72).
city('Sadon','ru','North Ossetia',754.0,44.01,42.85).
city('Sunzha','ru','North Ossetia',11548.0,44.82,43.06).
city('Tarskoye','ru','North Ossetia',4449.0,44.77,42.97).
city('Terskaya','ru','North Ossetia',3069.0,44.73,43.72).
city('Troitskoye','ru','North Ossetia',4007.0,44.66,43.76).
city('Verkhniy Fiagdon','ru','North Ossetia',1102.0,44.3,42.83).
city('Verkhniy Zgid','ru','North Ossetia',208.0,43.96,42.87).
city('Vladikavkaz','ru','North Ossetia',317372.0,44.68,43.04).
city('Zavodskoy','ru','North Ossetia',14833.0,44.71,43.12).
city('Zmeyskaya','ru','North Ossetia',6533.0,44.16,43.34).
city('Batetskiy','ru','Novgorod',2223.0,30.32,58.65).
city('Bolshaya Vishera','ru','Novgorod',1811.0,32.08,58.92).
city('Borovichi','ru','Novgorod',56572.0,33.9,58.4).
city('Chudovo','ru','Novgorod',17377.0,31.66,59.13).
city('Demyansk','ru','Novgorod',5693.0,32.47,57.64).
city('Kholm','ru','Novgorod',4228.0,32.85,59.27).
city('Khvoynaya','ru','Novgorod',6637.0,34.53,58.9).
city('Krasnofarfornyy','ru','Novgorod',1613.0,31.85,59.13).
city('Krechevitsy','ru','Novgorod',3287.0,31.4,58.62).
city('Kresttsy','ru','Novgorod',9737.0,32.52,58.25).
city('Kulotino','ru','Novgorod',3352.0,33.38,58.45).
city('Lyubytino','ru','Novgorod',3225.0,33.4,58.82).
city('Malaya Vishera','ru','Novgorod',13834.0,32.2,58.85).
city('Marevo','ru','Novgorod',2571.0,32.08,57.32).
city('Moshenskoye','ru','Novgorod',2697.0,34.58,58.52).
city('Nebolchi','ru','Novgorod',2198.0,33.35,59.12).
city('Okulovka','ru','Novgorod',13852.0,33.3,58.37).
city('Pankovka','ru','Novgorod',9828.0,31.22,58.5).
city('Parfino','ru','Novgorod',8254.0,31.65,57.97).
city('Pestovo','ru','Novgorod',15910.0,35.8,58.6).
city('Poddorye','ru','Novgorod',1913.0,31.12,57.48).
city('Proletariy','ru','Novgorod',5240.0,31.7,58.43).
city('Shimsk','ru','Novgorod',3755.0,30.72,58.22).
city('Soltsy','ru','Novgorod',11093.0,30.33,58.13).
city('Staraya Russa','ru','Novgorod',34303.0,31.36,57.99).
city('Tyosovo-Netylskiy','ru','Novgorod',2934.0,31.07,58.95).
city('Tyosovskiy','ru','Novgorod',1025.0,30.83,58.83).
city('Uglovka','ru','Novgorod',3472.0,33.52,58.23).
city('Valday','ru','Novgorod',18549.0,33.25,57.97).
city('Velikiy Novgorod','ru','Novgorod',215065.0,31.28,58.52).
city('Volkhovskiy','ru','Novgorod',2975.0,31.32,58.58).
city('Volot','ru','Novgorod',2276.0,30.7,57.93).
city('Zarubino','ru','Novgorod',1612.0,33.47,58.73).
city('Bagan','ru','Novosibirsk',5803.0,77.66,54.1).
city('Barabinsk','ru','Novosibirsk',31509.0,78.35,55.35).
city('Baryshevo','ru','Novosibirsk',5024.0,83.18,54.97).
city('Berdsk','ru','Novosibirsk',90251.0,83.08,54.76).
city('Bolotnoye','ru','Novosibirsk',17704.0,84.39,55.68).
city('Chany','ru','Novosibirsk',8923.0,76.75,55.31).
city('Cherepanovo','ru','Novosibirsk',20125.0,83.37,54.23).
city('Chik','ru','Novosibirsk',4991.0,82.45,55.02).
city('Chistoozyornoye','ru','Novosibirsk',6704.0,76.58,54.71).
city('Chulym','ru','Novosibirsk',11975.0,80.96,55.1).
city('Dorogino','ru','Novosibirsk',3762.0,83.31,54.36).
city('Dovolnoye','ru','Novosibirsk',7220.0,79.66,54.49).
city('Gornyy','ru','Novosibirsk',9807.0,83.87,55.13).
city('Iskitim','ru','Novosibirsk',61828.0,83.29,54.64).
city('Karasuk','ru','Novosibirsk',28589.0,78.03,53.73).
city('Kargat','ru','Novosibirsk',10881.0,80.28,55.2).
city('Kochenevskij','ru','Novosibirsk',16298.0,82.19,55.02).
city('Kochki','ru','Novosibirsk',4101.0,80.48,54.34).
city('Koltsovo','ru','Novosibirsk',9447.0,83.25,54.92).
city('Kolyvan','ru','Novosibirsk',10807.0,82.74,55.31).
city('Krasnoobsk','ru','Novosibirsk',16894.0,82.98,54.92).
city('Krasnozerskoye','ru','Novosibirsk',10339.0,79.24,54.0).
city('Krivodanovka','ru','Novosibirsk',9006.0,82.65,55.09).
city('Kudryashovskiy','ru','Novosibirsk',3935.0,82.78,55.1).
city('Kujbysev','ru','Novosibirsk',48309.0,78.32,55.45).
city('Kupino','ru','Novosibirsk',16333.0,77.28,54.36).
city('Kyshtovka','ru','Novosibirsk',5724.0,76.63,56.55).
city('Linyovo','ru','Novosibirsk',21536.0,83.37,54.43).
city('Listvyanskiy','ru','Novosibirsk',2673.0,83.48,54.45).
city('Masljaninskiy','ru','Novosibirsk',13391.0,84.21,54.34).
city('Mochishche','ru','Novosibirsk',3314.0,83.12,55.15).
city('Moshkovo','ru','Novosibirsk',10541.0,83.61,55.3).
city('Novolugovoye','ru','Novosibirsk',3308.0,83.12,54.97).
city('Novosibirsk','ru','Novosibirsk',1419016.0,82.93,55.04).
city('Ob','ru','Novosibirsk',24239.0,82.71,54.99).
city('Ordynskoye','ru','Novosibirsk',10314.0,81.9,54.37).
city('Polovinnoye','ru','Novosibirsk',3530.0,79.23,53.77).
city('Posevnaya','ru','Novosibirsk',4268.0,83.32,54.1).
city('Prokudskoye','ru','Novosibirsk',6043.0,82.46,55.01).
city('Severnoye','ru','Novosibirsk',5373.0,78.36,56.35).
city('Sokur','ru','Novosibirsk',5753.0,83.31,55.22).
city('Stantsionno-Oyashinskiy','ru','Novosibirsk',4689.0,83.82,55.47).
city('Suzun','ru','Novosibirsk',15365.0,82.31,53.79).
city('Tashara','ru','Novosibirsk',3364.0,83.5,55.52).
city('Tatarsk','ru','Novosibirsk',25151.0,75.97,55.22).
city('Toguchin','ru','Novosibirsk',21886.0,84.39,55.24).
city('Tolmachevo','ru','Novosibirsk',3921.0,82.74,54.98).
city('Ubinskoye','ru','Novosibirsk',5882.0,79.68,55.31).
city('Ust-Tarka','ru','Novosibirsk',4325.0,75.7,55.57).
city('Vengerovo','ru','Novosibirsk',7073.0,76.74,55.68).
city('Verkh-Tula','ru','Novosibirsk',5625.0,82.78,54.89).
city('Verkhniy-Irmen','ru','Novosibirsk',3072.0,82.23,54.58).
city('Yarkovo','ru','Novosibirsk',5149.0,82.58,54.8).
city('Yevsino','ru','Novosibirsk',5036.0,83.42,54.5).
city('Zdvinsk','ru','Novosibirsk',5539.0,78.67,54.7).
city('Azovo','ru','Omsk',5311.0,73.03,54.72).
city('Beregovoy','ru','Omsk',7961.0,73.18,55.15).
city('Bolshegrivskoye','ru','Omsk',3763.0,74.91,53.91).
city('Bolshereche','ru','Omsk',12212.0,74.62,56.09).
city('Bolshiye Uki','ru','Omsk',4331.0,72.62,56.95).
city('Cherlak','ru','Omsk',12122.0,74.8,54.15).
city('Gorkovskoye','ru','Omsk',5644.0,74.35,55.37).
city('Irtyshskiy','ru','Omsk',3284.0,73.58,54.8).
city('Isilkul','ru','Omsk',26429.0,71.27,54.92).
city('Kalachinsk','ru','Omsk',24059.0,74.57,55.05).
city('Klyuchi','ru','Omsk',3965.0,74.83,57.38).
city('Kolosovka','ru','Omsk',5759.0,73.61,56.46).
city('Kormilovka','ru','Omsk',10166.0,74.1,55.0).
city('Krasnoyar','ru','Omsk',4006.0,73.09,55.32).
city('Krasnyy Yar','ru','Omsk',5322.0,72.94,55.24).
city('Krutaya Gorka','ru','Omsk',6779.0,73.25,55.35).
city('Krutinka','ru','Omsk',7752.0,71.51,56.01).
city('Luzino','ru','Omsk',9897.0,73.03,54.95).
city('Lyubinskiy','ru','Omsk',10461.0,72.7,55.15).
city('Maryanovka','ru','Omsk',8302.0,72.65,54.96).
city('Moskalyonki','ru','Omsk',9753.0,71.93,54.95).
city('Muromtsevo','ru','Omsk',11147.0,75.25,56.37).
city('Nazyvajevsk','ru','Omsk',12694.0,71.33,55.57).
city('Nizhnyaya Omka','ru','Omsk',5246.0,74.92,55.43).
city('Novoomskiy','ru','Omsk',4467.0,73.3,54.83).
city('Novovarshavka','ru','Omsk',6487.0,74.7,54.18).
city('Odesskoye','ru','Omsk',6025.0,72.97,54.22).
city('Okoneshnikovo','ru','Omsk',5501.0,75.08,54.83).
city('Omsk','ru','Omsk',1129289.0,73.4,55.0).
city('Pavlogradka','ru','Omsk',6148.0,73.55,54.2).
city('Poltavka','ru','Omsk',7103.0,71.76,54.36).
city('Rostovka','ru','Omsk',5423.0,71.89,55.38).
city('Russkaya Polyana','ru','Omsk',6454.0,73.88,53.78).
city('Sargatskoye','ru','Omsk',8285.0,73.5,55.62).
city('Sedelnikovo','ru','Omsk',4994.0,75.31,56.95).
city('Sherbakul','ru','Omsk',7251.0,72.4,54.63).
city('Sosnovskiy','ru','Omsk',3339.0,73.16,54.6).
city('Tara','ru','Omsk',26986.0,74.37,56.9).
city('Tavricheskoye','ru','Omsk',13063.0,73.63,54.58).
city('Tevriz','ru','Omsk',7270.0,72.4,57.52).
city('Troitskoye','ru','Omsk',3911.0,72.22,55.7).
city('Tyukalinsk','ru','Omsk',11935.0,72.0,55.87).
city('Ust-Ishim','ru','Omsk',4999.0,71.17,57.69).
city('Vkhodnoy','ru','Omsk',7819.0,73.12,54.98).
city('Znamenskoye','ru','Omsk',5391.0,73.9,57.11).
city('Bolkhov','ru','Orel',11904.0,36.02,53.45).
city('Dmitrovsk-Orlovskiy','ru','Orel',6366.0,35.14,52.51).
city('Dolgoye','ru','Orel',4953.0,37.41,52.07).
city('Glazunovka','ru','Orel',6666.0,36.33,52.5).
city('Khomutovo','ru','Orel',4647.0,37.45,52.85).
city('Khotynets','ru','Orel',4182.0,35.4,53.13).
city('Kolpny','ru','Orel',7081.0,37.03,52.22).
city('Korsakovo','ru','Orel',1465.0,37.35,53.27).
city('Krasnaya Zarya','ru','Orel',1802.0,37.7,52.77).
city('Kromy','ru','Orel',7098.0,35.77,52.69).
city('Livny','ru','Orel',52916.0,37.6,52.42).
city('Maloarkhangelsk','ru','Orel',3905.0,36.5,52.4).
city('Mtsensk','ru','Orel',47610.0,36.55,53.27).
city('Naryshkino','ru','Orel',9600.0,35.73,52.97).
city('Novosil','ru','Orel',3989.0,37.04,52.97).
city('Oryol','ru','Orel',331130.0,36.08,52.97).
city('Otradinskiy','ru','Orel',3022.0,36.5,53.23).
city('Pokrovskoye','ru','Orel',4566.0,36.88,52.6).
city('Shablykino','ru','Orel',3848.0,35.19,52.86).
city('Soskovo','ru','Orel',2094.0,35.38,52.75).
city('Trosna','ru','Orel',2627.0,35.8,52.44).
city('Verkhovye','ru','Orel',7964.0,37.24,52.82).
city('Zalegoshch','ru','Orel',5925.0,36.89,52.9).
city('Zmievka','ru','Orel',6288.0,36.37,52.67).
city('Znamenka','ru','Orel',11938.0,36.02,52.92).
city('Znamenskoye','ru','Orel',1950.0,35.7,53.27).
city('Abdulino','ru','Orenburg',21195.0,53.67,53.7).
city('Adamovka','ru','Orenburg',7994.0,59.95,51.52).
city('Akkermanovka','ru','Orenburg',1264.0,58.23,51.24).
city('Aleksandrovka','ru','Orenburg',4129.0,54.41,52.68).
city('Asekeyevo','ru','Orenburg',5267.0,52.8,53.57).
city('Belyayevka','ru','Orenburg',5110.0,56.41,51.39).
city('Buguruslan','ru','Orenburg',53512.0,52.43,53.65).
city('Buzuluk','ru','Orenburg',87715.0,52.26,52.78).
city('Chebenki','ru','Orenburg',3496.0,55.7,51.94).
city('Chkalov','ru','Orenburg',550210.0,55.1,51.78).
city('Dombarovskiy','ru','Orenburg',9556.0,59.54,50.76).
city('Dubenskiy','ru','Orenburg',596.0,56.63,51.45).
city('Energetik','ru','Orenburg',9136.0,58.8,51.75).
city('Gay','ru','Orenburg',41620.0,58.46,51.47).
city('Grachyovka','ru','Orenburg',6485.0,52.88,52.92).
city('Ilek','ru','Orenburg',9898.0,53.38,51.53).
city('Kardailovo','ru','Orenburg',3036.0,53.9,51.54).
city('Kargala','ru','Orenburg',1973.0,55.19,51.98).
city('Koltubanovskiy','ru','Orenburg',3831.0,52.03,52.95).
city('Krasnogvardeyets','ru','Orenburg',3836.0,52.32,52.63).
city('Krasnokholm','ru','Orenburg',6041.0,54.16,51.6).
city('Krasnoyarskiy','ru','Orenburg',3218.0,59.9,51.97).
city('Krasnyy Kommunar','ru','Orenburg',4167.0,55.37,51.96).
city('Kurmanayevka','ru','Orenburg',4552.0,52.1,52.55).
city('Kuvandyk','ru','Orenburg',28707.0,57.35,51.48).
city('Kvarkeno','ru','Orenburg',4161.0,59.73,52.16).
city('Matveyevka','ru','Orenburg',3276.0,56.18,52.15).
city('Mednogorsk','ru','Orenburg',30676.0,57.58,51.42).
city('Nezhinka','ru','Orenburg',5100.0,55.37,51.77).
city('Nizhnyaya Pavlovka','ru','Orenburg',3691.0,54.8,51.71).
city('Novoorsk','ru','Orenburg',11212.0,58.98,51.38).
city('Novorudnyy','ru','Orenburg',1930.0,58.19,51.51).
city('Novosergiyevka','ru','Orenburg',13188.0,53.64,52.09).
city('Novotroitsk','ru','Orenburg',106187.0,58.32,51.21).
city('Oktyabrskoye','ru','Orenburg',7600.0,55.5,52.34).
city('Orsk','ru','Orenburg',246839.0,58.63,51.21).
city('Perevolotskiy','ru','Orenburg',9667.0,54.2,51.88).
city('Pervomayskiy','ru','Orenburg',6821.0,55.04,51.82).
city('Pleshanovo','ru','Orenburg',3746.0,53.48,52.83).
city('Podgorodnyaya Pokrovka','ru','Orenburg',3123.0,54.99,51.82).
city('Ponomaryovka','ru','Orenburg',5375.0,54.12,53.32).
city('Prigorodnyy','ru','Orenburg',3222.0,55.12,51.78).
city('Sakmara','ru','Orenburg',4594.0,55.34,51.98).
city('Saraktash','ru','Orenburg',17413.0,56.36,51.79).
city('Severnoye','ru','Orenburg',4695.0,52.53,54.1).
city('Sharlyk','ru','Orenburg',8072.0,54.75,52.92).
city('So','ru','Orenburg',27420.0,55.0,51.16).
city('Sorochinsk','ru','Orenburg',30731.0,53.17,52.43).
city('Svetlyy','ru','Orenburg',8976.0,60.85,50.82).
city('Tashla','ru','Orenburg',6651.0,52.75,51.77).
city('Tatarskaya Kargala','ru','Orenburg',3478.0,55.18,51.95).
city('Totskoye','ru','Orenburg',7161.0,52.75,52.53).
city('Tyulgan','ru','Orenburg',10105.0,56.16,52.34).
city('Yasnyy','ru','Orenburg',17360.0,59.88,51.03).
city('Bashmakovo','ru','Penza',9654.0,43.04,53.21).
city('Bednodemyanovsk','ru','Penza',7475.0,43.19,53.93).
city('Bekovo','ru','Penza',6800.0,43.71,52.46).
city('Belinskiy','ru','Penza',8800.0,43.41,52.96).
city('Bessonovka','ru','Penza',9880.0,45.04,53.31).
city('Bogoslovka','ru','Penza',4636.0,44.8,53.21).
city('Chaadayevka','ru','Penza',7072.0,45.9,53.14).
city('Chemodanovka','ru','Penza',5002.0,45.24,53.23).
city('Gorodishche','ru','Penza',8334.0,45.7,53.27).
city('Grabovo','ru','Penza',7303.0,45.07,53.38).
city('Inderka','ru','Penza',4031.0,46.26,53.25).
city('Issa','ru','Penza',5532.0,44.86,53.87).
city('Kamenka','ru','Penza',40974.0,44.04,53.19).
city('Kolyshley','ru','Penza',8371.0,44.53,52.7).
city('Kondol','ru','Penza',3612.0,45.05,52.82).
city('Kuznetsk','ru','Penza',90481.0,46.6,53.12).
city('Lopatino','ru','Penza',4318.0,45.8,52.62).
city('Lunino','ru','Penza',8214.0,45.23,53.59).
city('Makhalino','ru','Penza',5210.0,46.22,53.09).
city('Malaya Serdoba','ru','Penza',4922.0,44.93,52.47).
city('Mokshan','ru','Penza',11652.0,44.62,53.44).
city('Narovchat','ru','Penza',4340.0,43.7,53.88).
city('Neverkino','ru','Penza',5105.0,46.73,52.78).
city('Nikolsk','ru','Penza',23542.0,46.08,53.71).
city('Nizhniy Lomov','ru','Penza',23836.0,43.68,53.52).
city('Pachelma','ru','Penza',8620.0,43.35,53.24).
city('Penza','ru','Penza',512607.0,45.0,53.2).
city('Poim','ru','Penza',3138.0,43.18,53.03).
city('Poselki','ru','Penza',3069.0,46.49,53.14).
city('Russkiy Kameshkir','ru','Penza',5305.0,46.1,52.87).
city('Serd','ru','Penza',36652.0,44.22,52.47).
city('Shemysheyka','ru','Penza',6619.0,45.4,52.9).
city('Sosnovoborsk','ru','Penza',7299.0,46.25,53.29).
city('Srednyaya Yelyuzan','ru','Penza',8279.0,45.95,53.03).
city('Sura','ru','Penza',2275.0,45.77,53.89).
city('Sursk','ru','Penza',7623.0,45.7,53.08).
city('Tamala','ru','Penza',7956.0,43.25,52.54).
city('Vadinsk','ru','Penza',4708.0,43.05,53.69).
city('Verkhniy Lomov','ru','Penza',4390.0,43.55,53.47).
city('Verkhozim','ru','Penza',1756.0,45.43,52.72).
city('Yevlashyovo','ru','Penza',4587.0,46.82,53.1).
city('Zarechnyy','ru','Penza',62139.0,46.58,53.13).
city('Zasechnoye','ru','Penza',4733.0,45.08,53.1).
city('Zemetchino','ru','Penza',11928.0,42.62,53.5).
city('Zolotaryovka','ru','Penza',2860.0,45.32,53.08).
city('Aleksandrovsk','ru','Perm',15486.0,57.57,59.16).
city('Barda','ru','Perm',8279.0,55.58,56.93).
city('Berezniki','ru','Perm',167750.0,56.77,59.41).
city('Bershet','ru','Perm',3489.0,56.37,57.73).
city('Beryozovk','ru','Perm',6887.0,57.3,57.61).
city('Biser','ru','Perm',1006.0,58.88,58.42).
city('Bolshaya Sosnova','ru','Perm',4297.0,54.6,57.67).
city('Chastyye','ru','Perm',4907.0,54.96,57.3).
city('Chaykovskaya','ru','Perm',3007.0,55.53,58.13).
city('Chaykovskiy','ru','Perm',86714.0,54.15,56.78).
city('Cherdyn','ru','Perm',5585.0,56.48,60.4).
city('Chermoz','ru','Perm',4079.0,56.16,58.78).
city('Chernushka','ru','Perm',35942.0,56.07,56.51).
city('Chusovoy','ru','Perm',50205.0,57.82,58.29).
city('Dobryanka','ru','Perm',36972.0,56.41,58.46).
city('Ferma','ru','Perm',3402.0,56.3,57.9).
city('Foki','ru','Perm',3792.0,54.35,56.7).
city('Gamovo','ru','Perm',4362.0,56.1,57.87).
city('Gornozavodsk','ru','Perm',12796.0,58.32,58.38).
city('Gremyachinsk','ru','Perm',12094.0,57.84,58.56).
city('Gubakha','ru','Perm',31424.0,57.59,58.87).
city('Ilinskiy','ru','Perm',6342.0,55.69,58.57).
city('Kalino','ru','Perm',2473.0,57.61,58.25).
city('Karagay','ru','Perm',6586.0,54.93,58.26).
city('Kerchevskiy','ru','Perm',2990.0,56.29,59.94).
city('Kizel','ru','Perm',21808.0,57.64,59.06).
city('Komarikhinskiy','ru','Perm',1510.0,57.12,58.09).
city('Komsomolskiy','ru','Perm',3280.0,57.13,57.47).
city('Kondratovo','ru','Perm',5594.0,56.11,57.98).
city('Krasnokamsk','ru','Perm',52690.0,55.75,58.07).
city('Krasnovishersk','ru','Perm',18185.0,57.08,60.4).
city('Kujeda','ru','Perm',9565.0,55.58,56.43).
city('Kukushtan','ru','Perm',4870.0,56.49,57.65).
city('Kultayevo','ru','Perm',4235.0,55.95,57.9).
city('Kungur','ru','Perm',66390.0,56.95,57.43).
city('Kusye-Aleksandrovskiy','ru','Perm',1895.0,58.39,58.29).
city('Lobanovo','ru','Perm',3563.0,56.29,57.86).
city('Lunyovka','ru','Perm',354.0,57.68,59.15).
city('Lyamino','ru','Perm',5000.0,57.72,58.29).
city('Lysva','ru','Perm',69637.0,57.79,58.11).
city('Mayskiy','ru','Perm',5224.0,55.53,58.12).
city('Medvedka','ru','Perm',796.0,59.1,58.74).
city('Mendeleyevo','ru','Perm',3245.0,55.0,58.17).
city('Nagornskiy','ru','Perm',560.0,57.54,58.77).
city('Novoilinskiy','ru','Perm',3660.0,55.48,57.9).
city('Novovilvenskiy','ru','Perm',411.0,58.33,58.38).
city('Novyye Lyady','ru','Perm',9050.0,56.6,58.05).
city('Nyrob','ru','Perm',7314.0,56.71,60.72).
city('Nytva','ru','Perm',20526.0,55.33,57.94).
city('Ocher','ru','Perm',15396.0,54.7,57.88).
city('Okhansk','ru','Perm',7920.0,55.38,57.72).
city('Oktyabrskiy','ru','Perm',9790.0,57.2,56.52).
city('Orda','ru','Perm',5270.0,56.9,57.2).
city('Oryol','ru','Perm',1869.0,56.59,59.34).
city('Osa','ru','Perm',23292.0,55.43,57.28).
city('Overyata','ru','Perm',4507.0,55.86,58.09).
city('Pashiya','ru','Perm',4140.0,58.26,58.43).
city('Pavlovskiy','ru','Perm',3323.0,54.85,57.83).
city('Perm','ru','Perm',982428.0,56.25,58.0).
city('Polazna','ru','Perm',12973.0,56.41,58.29).
city('Promysla','ru','Perm',728.0,59.15,58.57).
city('Rudnichnyy','ru','Perm',875.0,57.65,59.0).
city('Sarany','ru','Perm',1224.0,58.88,58.5).
city('Sars','ru','Perm',5404.0,57.13,56.56).
city('Severnyy-Kospashskiy','ru','Perm',2212.0,57.79,59.09).
city('Shakhta','ru','Perm',2767.0,57.65,59.09).
city('Shirokovskiy','ru','Perm',1823.0,57.76,58.85).
city('Shumikhinskiy','ru','Perm',2192.0,57.68,58.74).
city('Siva','ru','Perm',4744.0,54.38,58.38).
city('Skalnyy','ru','Perm',2069.0,57.97,58.36).
city('Solikamsk','ru','Perm',100814.0,56.75,59.64).
city('Staryy Bis','ru','Perm',690.0,58.88,58.41).
city('Suksun','ru','Perm',8284.0,57.39,57.15).
city('Sylva','ru','Perm',7655.0,56.76,58.03).
city('Tsentralnyy-Kospashskiy','ru','Perm',2806.0,57.77,59.05).
city('Tyoplaya Gora','ru','Perm',3764.0,59.07,58.53).
city('Ugleuralskiy','ru','Perm',10169.0,57.59,58.95).
city('Uinskoye','ru','Perm',4340.0,56.58,56.88).
city('Uralskiy','ru','Perm',8707.0,55.56,57.94).
city('Usolye','ru','Perm',6002.0,56.66,59.43).
city('Ust-Kachka','ru','Perm',3991.0,55.67,58.01).
city('Ust-Kishert','ru','Perm',4413.0,57.25,57.36).
city('Usva','ru','Perm',739.0,57.62,58.69).
city('Vereshchagino','ru','Perm',22451.0,54.65,58.08).
city('Verkhnechusovskiye Gorodki','ru','Perm',2427.0,57.1,58.17).
city('Vsevolodo-Vilva','ru','Perm',3539.0,57.43,59.22).
city('Yayva','ru','Perm',10615.0,57.26,59.34).
city('Yelovo','ru','Perm',5570.0,54.92,57.05).
city('Yubileynyy','ru','Perm',1656.0,57.76,58.78).
city('Yugo-Kamskiy','ru','Perm',7779.0,55.59,57.71).
city('Yuzhny','ru','Perm',2275.0,57.75,58.97).
city('Zvyozdnyy','ru','Perm',9389.0,56.3,57.6).
city('Zyukayka','ru','Perm',4556.0,54.7,58.2).
city('Anuchino','ru','Primorski',4658.0,133.06,43.96).
city('Arsenyev','ru','Primorski',61620.0,133.28,44.16).
city('Artyom','ru','Primorski',62887.0,132.18,43.36).
city('Artyomovskiy','ru','Primorski',9496.0,132.32,43.37).
city('Barabash','ru','Primorski',3603.0,131.48,43.2).
city('Bolshoy Kamen','ru','Primorski',37480.0,132.36,43.12).
city('Chernigovka','ru','Primorski',13969.0,132.59,44.34).
city('Chkalovskoye','ru','Primorski',3606.0,133.06,44.84).
city('Chuguyevka','ru','Primorski',13354.0,133.87,44.16).
city('Dalnegorsk','ru','Primorski',38454.0,135.51,44.54).
city('Dalnerechensk','ru','Primorski',29377.0,133.72,45.93).
city('Fokino','ru','Primorski',25827.0,132.4,42.98).
city('Galyonki','ru','Primorski',5228.0,131.77,44.03).
city('Gornorechenskiy','ru','Primorski',3409.0,135.12,44.26).
city('Gornyy','ru','Primorski',214.0,133.9,44.85).
city('Gornyye Klyuchi','ru','Primorski',5146.0,133.5,45.24).
city('Ivanovka','ru','Primorski',3011.0,132.48,43.97).
city('Kamen-Rybolov','ru','Primorski',11489.0,132.06,44.74).
city('Kamenka','ru','Primorski',1693.0,136.01,44.47).
city('Kavalerovo','ru','Primorski',16945.0,135.05,44.27).
city('Khasan','ru','Primorski',776.0,130.65,42.42).
city('Khorol','ru','Primorski',11245.0,132.1,44.42).
city('Khrustalnyy','ru','Primorski',3577.0,135.1,44.35).
city('Kirovskiy','ru','Primorski',9467.0,133.51,45.09).
city('Knevichi','ru','Primorski',4605.0,132.19,43.41).
city('Kraskino','ru','Primorski',3369.0,130.78,42.71).
city('Krasnorechenskiy','ru','Primorski',3833.0,135.36,44.63).
city('Lazo','ru','Primorski',3396.0,133.78,44.63).
city('Lesozavodsk','ru','Primorski',41779.0,133.42,45.48).
city('Lipovtsy','ru','Primorski',6581.0,131.72,44.2).
city('Livadiya','ru','Primorski',12652.0,132.68,42.87).
city('Luchegorsk','ru','Primorski',21833.0,134.24,46.48).
city('Monastyrishche','ru','Primorski',4192.0,132.48,44.2).
city('Nakhodka','ru','Primorski',146922.0,132.89,42.83).
city('Nikolayevka','ru','Primorski',4051.0,133.21,43.09).
city('Novonikolsk','ru','Primorski',4066.0,131.87,43.85).
city('Novopokrovka','ru','Primorski',3946.0,134.49,45.85).
city('Novoshakhtinskiy','ru','Primorski',8091.0,132.0,43.93).
city('Novosysoyevka','ru','Primorski',4903.0,133.38,44.24).
city('Olga','ru','Primorski',4347.0,135.28,43.74).
city('Partizansk','ru','Primorski',42490.0,133.13,43.13).
city('Plastun','ru','Primorski',6082.0,136.29,44.76).
city('Pogranichnyy','ru','Primorski',11930.0,131.38,44.42).
city('Pokrovka','ru','Primorski',10614.0,131.62,43.95).
city('Popova','ru','Primorski',1285.0,131.73,42.96).
city('Posyet','ru','Primorski',2857.0,130.8,42.65).
city('Preobrazheniye','ru','Primorski',9113.0,133.9,42.91).
city('Primorskiy','ru','Primorski',1708.0,131.58,43.1).
city('Razdolnoye','ru','Primorski',7648.0,131.92,43.55).
city('Rettikhovka','ru','Primorski',2712.0,132.79,44.17).
city('Rudnaya Pristan','ru','Primorski',2332.0,135.82,44.36).
city('Rudnyy','ru','Primorski',2567.0,134.96,44.28).
city('Russkiy','ru','Primorski',5080.0,131.87,43.0).
city('Sergeyevka','ru','Primorski',4421.0,132.51,43.85).
city('Shkotovo','ru','Primorski',5221.0,132.36,43.33).
city('Shkotovo-22','ru','Primorski',8394.0,132.34,42.88).
city('Shkotovo-26','ru','Primorski',1106.0,132.42,42.86).
city('Sibirtsevo','ru','Primorski',9226.0,132.44,44.26).
city('Slavyanka','ru','Primorski',14687.0,131.37,42.87).
city('Smolyaninovo','ru','Primorski',6294.0,132.47,43.3).
city('Spassk-Dalniy','ru','Primorski',50186.0,132.82,44.6).
city('Spasskoye','ru','Primorski',6038.0,132.77,44.6).
city('Svetlaya','ru','Primorski',1109.0,138.33,46.54).
city('Tavrichanka','ru','Primorski',8352.0,131.86,43.34).
city('Terney','ru','Primorski',3876.0,136.61,45.05).
city('Trudovoye','ru','Primorski',18484.0,132.08,43.31).
city('Uglekamensk','ru','Primorski',6461.0,133.23,43.22).
city('Uglovoye','ru','Primorski',12429.0,132.11,43.35).
city('Ussuriysk','ru','Primorski',157071.0,132.01,43.8).
city('Vladimiro-Aleksandrovskoye','ru','Primorski',5444.0,133.08,42.89).
city('Vladivostok','ru','Primorski',587029.0,131.9,43.13).
city('Volchanets','ru','Primorski',4013.0,132.75,42.91).
city('Volno-Nadezhdinskoye','ru','Primorski',6604.0,131.99,43.38).
city('Vostok','ru','Primorski',3452.0,135.88,46.49).
city('Vozdvizhenka','ru','Primorski',7102.0,131.95,43.9).
city('Vrangel','ru','Primorski',14981.0,133.08,42.73).
city('Vysokogorsk','ru','Primorski',463.0,135.4,44.41).
city('Yakovlevka','ru','Primorski',4996.0,133.49,44.42).
city('Yaroslavskiy','ru','Primorski',10010.0,132.23,44.19).
city('Yekaterinovka','ru','Primorski',3555.0,133.05,42.92).
city('Zarubino','ru','Primorski',3438.0,131.09,42.63).
city('Zavodskoy','ru','Primorski',14865.0,132.3,43.47).
city('Bezhanitsy','ru','Pskov',4711.0,29.88,56.97).
city('Dedovichi','ru','Pskov',9606.0,29.93,57.53).
city('Dno','ru','Pskov',9608.0,29.98,57.83).
city('Gdov','ru','Pskov',5521.0,27.81,58.74).
city('Idritsa','ru','Pskov',5623.0,28.88,56.35).
city('Krasnogorodsk','ru','Pskov',4563.0,28.27,56.83).
city('Krasnyy Luch','ru','Pskov',1452.0,30.09,57.07).
city('Kunya','ru','Pskov',3429.0,30.97,56.29).
city('Loknya','ru','Pskov',4762.0,30.15,56.83).
city('Nevel','ru','Pskov',17833.0,29.92,56.03).
city('Novorzhev','ru','Pskov',3988.0,29.33,57.03).
city('Novosokolniki','ru','Pskov',9559.0,30.15,56.34).
city('Opochka','ru','Pskov',13548.0,28.65,56.71).
city('Ostrov','ru','Pskov',24355.0,28.32,57.35).
city('Palkino','ru','Pskov',3112.0,28.0,57.53).
city('Pechory','ru','Pskov',13246.0,27.6,57.82).
city('Plyussa','ru','Pskov',3749.0,29.4,58.42).
city('Porkhov','ru','Pskov',11886.0,29.53,57.77).
city('Pskov','ru','Pskov',201992.0,28.33,57.83).
city('Pushkinskiye Gory','ru','Pskov',5920.0,28.93,57.02).
city('Pustoshka','ru','Pskov',5253.0,29.37,56.33).
city('Pytalovo','ru','Pskov',6767.0,27.9,57.07).
city('Sebezh','ru','Pskov',6688.0,28.48,56.28).
city('Seredka','ru','Pskov',3724.0,28.19,58.16).
city('Strugi Krasnyye','ru','Pskov',8518.0,29.13,58.27).
city('Usvyaty','ru','Pskov',3060.0,30.75,55.75).
city('Velikie Luki','ru','Pskov',103150.0,30.53,56.34).
city('Za','ru','Pskov',1354.0,29.73,58.42).
city('Aksay','ru','Rostov',38871.0,39.87,47.26).
city('Aleksandrovka','ru','Rostov',4731.0,38.99,46.78).
city('Almaznyy','ru','Rostov',3080.0,40.05,48.03).
city('Ayutinskiy','ru','Rostov',10623.0,40.14,47.77).
city('Azov','ru','Rostov',82134.0,39.41,47.11).
city('Bagaevskaya','ru','Rostov',15252.0,40.4,47.32).
city('Bataysk','ru','Rostov',109964.0,39.75,47.14).
city('Belaya Kalitva','ru','Rostov',47521.0,40.79,48.18).
city('Bokovskaya','ru','Rostov',503.0,41.83,49.23).
city('Bolshaya Martynovka','ru','Rostov',6813.0,41.66,47.27).
city('Bolshaya Orlovka','ru','Rostov',4293.0,41.28,47.33).
city('Bolshiye Saly','ru','Rostov',3250.0,39.68,47.4).
city('Bolshoy Log','ru','Rostov',3726.0,39.92,47.3).
city('Bystrogorskiy','ru','Rostov',3859.0,41.18,48.25).
city('Chaltyr','ru','Rostov',14689.0,39.5,47.29).
city('Chertkovo','ru','Rostov',11012.0,40.28,49.39).
city('Donetsk','ru','Rostov',47829.0,40.03,48.35).
city('Donskoy','ru','Rostov',13627.0,40.26,47.4).
city('Dubovskoye','ru','Rostov',8019.0,42.76,47.41).
city('Gigant','ru','Rostov',10034.0,41.34,46.51).
city('Glubokiy','ru','Rostov',11225.0,40.33,48.52).
city('Gornyatskiy','ru','Rostov',9292.0,40.89,48.29).
city('Gornyy','ru','Rostov',2716.0,40.2,47.82).
city('Grushevskaya','ru','Rostov',4044.0,39.95,47.44).
city('Gukovo','ru','Rostov',66080.0,39.94,48.06).
city('Gundorovskiy','ru','Rostov',5210.0,41.9,46.78).
city('Kagalnik','ru','Rostov',7939.0,39.11,47.08).
city('Kagalnitskaya','ru','Rostov',6838.0,40.15,46.88).
city('Kalinin','ru','Rostov',3423.0,39.52,47.23).
city('Kamenolomni','ru','Rostov',12262.0,40.21,47.67).
city('Kamensk-Shakhtinskiy','ru','Rostov',75815.0,40.26,48.32).
city('Kashary','ru','Rostov',6292.0,41.0,49.04).
city('Kazanskaya','ru','Rostov',4946.0,41.15,49.79).
city('Kirovskaya','ru','Rostov',5918.0,40.08,46.98).
city('Koksovyy','ru','Rostov',8458.0,40.6,48.2).
city('Konstantinovsk','ru','Rostov',18876.0,41.09,47.58).
city('Krasnaya Polyana','ru','Rostov',3728.0,41.5,46.12).
city('Krasnoarmeyskiy','ru','Rostov',3716.0,42.21,47.01).
city('Krasnovka','ru','Rostov',3966.0,40.12,48.78).
city('Krasnoyarskaya','ru','Rostov',4544.0,42.12,47.57).
city('Krasnyy Sulin','ru','Rostov',44134.0,40.08,47.89).
city('Krasyukovskaya','ru','Rostov',4316.0,40.1,47.55).
city('Krivyanskaya','ru','Rostov',10203.0,40.17,47.4).
city('Krym','ru','Rostov',4475.0,39.53,47.31).
city('Kuleshovka','ru','Rostov',14668.0,39.56,47.07).
city('Kuybyshevo','ru','Rostov',5790.0,38.91,47.81).
city('Letnik','ru','Rostov',3141.0,41.27,46.01).
city('Likhovskoy','ru','Rostov',13617.0,40.19,48.15).
city('Likhoy','ru','Rostov',3102.0,40.19,48.12).
city('Malchevskaya','ru','Rostov',3922.0,40.38,49.06).
city('Mankovo-Kalitvenskoye','ru','Rostov',4207.0,40.28,49.41).
city('Matveyev Kurgan','ru','Rostov',14342.0,38.87,47.56).
city('Mayskiy','ru','Rostov',12136.0,40.1,47.7).
city('Mechetinskaya','ru','Rostov',6517.0,40.46,46.77).
city('Melekhovskaya','ru','Rostov',3346.0,40.49,47.48).
city('Millerovo','ru','Rostov',385.0,40.39,48.93).
city('Milyutinskaya','ru','Rostov',2743.0,41.67,48.63).
city('Morozovsk','ru','Rostov',29290.0,41.83,48.35).
city('Nikolayevka','ru','Rostov',5220.0,38.84,47.31).
city('Nikolayevskaya','ru','Rostov',3613.0,41.5,47.61).
city('Novobataysk','ru','Rostov',5097.0,39.78,46.9).
city('Novobessergenevka','ru','Rostov',3445.0,38.85,47.19).
city('Novocherkassk','ru','Rostov',166976.0,40.09,47.42).
city('Novoshakhtinsk','ru','Rostov',99480.0,39.94,47.75).
city('Novyy Yegorlyk','ru','Rostov',3739.0,41.85,46.38).
city('Oblivskaya','ru','Rostov',9528.0,42.49,48.54).
city('Olginskaya','ru','Rostov',5255.0,39.95,47.18).
city('Orlovskiy','ru','Rostov',19325.0,42.05,46.87).
city('Persianovskiy','ru','Rostov',15730.0,39.42,47.53).
city('Peschanokopskoye','ru','Rostov',11340.0,41.08,46.2).
city('Peshkovo','ru','Rostov',3596.0,39.39,47.02).
city('Pokrovskoye','ru','Rostov',12576.0,38.9,47.42).
city('Primorka','ru','Rostov',3780.0,39.06,47.28).
city('Proletarsk','ru','Rostov',19494.0,41.72,46.7).
city('Rassvet','ru','Rostov',4765.0,40.75,46.83).
city('Razvilnoye','ru','Rostov',5844.0,41.3,46.24).
city('Remontnoye','ru','Rostov',7374.0,43.66,46.56).
city('Rodionovo-Nesvetayskaya','ru','Rostov',6188.0,39.71,47.61).
city('Romanovskaya','ru','Rostov',6885.0,42.03,47.54).
city('Rostov-na-Donu','ru','Rostov',1074495.0,39.71,47.24).
city('Salsk','ru','Rostov',61703.0,41.54,46.47).
city('Samarskoye','ru','Rostov',10638.0,39.68,46.93).
city('Sambek','ru','Rostov',5278.0,39.8,47.75).
city('Sandata','ru','Rostov',4047.0,41.81,46.27).
city('Semikarakorsk','ru','Rostov',23583.0,40.81,47.52).
city('Shakhty','ru','Rostov',221315.0,40.21,47.71).
city('Sholokhovskiy','ru','Rostov',10062.0,41.13,48.27).
city('Sinegorskiy','ru','Rostov',6660.0,40.85,48.01).
city('Sinyavskoye','ru','Rostov',3715.0,39.28,47.28).
city('Sokolovo-Kundryuchenskiy','ru','Rostov',9585.0,39.94,47.84).
city('Sovetskaya','ru','Rostov',2293.0,42.12,49.01).
city('Staraya Stanitsa','ru','Rostov',8284.0,40.28,48.35).
city('Taganrog','ru','Rostov',279060.0,38.91,47.22).
city('Talovyy','ru','Rostov',5909.0,40.09,47.8).
city('Tarasovskiy','ru','Rostov',8949.0,40.36,48.73).
city('Tatsinskaya','ru','Rostov',11258.0,41.28,48.2).
city('Tselina','ru','Rostov',11075.0,41.03,46.53).
city('Tsimlyansk','ru','Rostov',15341.0,42.1,47.65).
city('Uglegorskiy','ru','Rostov',2485.0,41.28,48.18).
city('Uglerodovskiy','ru','Rostov',2986.0,40.07,48.14).
city('Ust-Donetskiy','ru','Rostov',11357.0,40.87,47.64).
city('Veshenskaya','ru','Rostov',9303.0,41.72,49.63).
city('Vesyolyy','ru','Rostov',8807.0,38.75,47.17).
city('Volgodonsk','ru','Rostov',167734.0,42.15,47.51).
city('Yegorlykskaya','ru','Rostov',17978.0,40.65,46.56).
city('Yolkin','ru','Rostov',3013.0,40.5,47.32).
city('Zavetnoye','ru','Rostov',6711.0,43.89,47.12).
city('Zavodskoy','ru','Rostov',8948.0,40.27,48.41).
city('Zernograd','ru','Rostov',29268.0,40.31,46.85).
city('Zhirnov','ru','Rostov',6069.0,41.11,48.18).
city('Zimovniki','ru','Rostov',17678.0,42.46,47.15).
city('Zverevo','ru','Rostov',24979.0,40.12,48.02).
city('Aleksandro-Nevskiy','ru','Ryazan',4030.0,40.21,53.48).
city('Chuchkovo','ru','Ryazan',4404.0,41.45,54.26).
city('Gus-Zheleznyy','ru','Ryazan',2381.0,41.17,55.05).
city('Izhevskoye','ru','Ryazan',3703.0,40.87,54.56).
city('Kadom','ru','Ryazan',6027.0,42.47,54.56).
city('Kasimov','ru','Ryazan',35355.0,41.39,54.94).
city('Korablino','ru','Ryazan',14469.0,40.01,53.92).
city('Lashma','ru','Ryazan',1736.0,41.15,54.93).
city('Lesnoy','ru','Ryazan',7335.0,40.46,54.2).
city('Mikhaylov','ru','Ryazan',12907.0,39.02,54.23).
city('Miloslavskoye','ru','Ryazan',4693.0,39.44,53.57).
city('Murmino','ru','Ryazan',3506.0,40.05,54.6).
city('Novomichurinsk','ru','Ryazan',20821.0,39.78,54.04).
city('Oktyabrskiy','ru','Ryazan',5682.0,39.19,54.01).
city('Pavelets','ru','Ryazan',2152.0,39.25,53.79).
city('Pitelino','ru','Ryazan',2355.0,41.82,54.58).
city('Polyany','ru','Ryazan',6170.0,39.82,54.71).
city('Poplevinskiy','ru','Ryazan',667.0,39.54,53.69).
city('Pronsk','ru','Ryazan',4222.0,39.0,54.12).
city('Putyatino','ru','Ryazan',3044.0,41.12,54.16).
city('Ryazan','ru','Ryazan',520177.0,39.74,54.62).
city('Ryazhsk','ru','Ryazan',22041.0,40.07,53.71).
city('Rybnoye','ru','Ryazan',19159.0,39.51,54.73).
city('Sapozhok','ru','Ryazan',4283.0,40.68,53.94).
city('Sarai','ru','Ryazan',6439.0,40.99,53.72).
city('Sasovo','ru','Ryazan',29859.0,41.91,54.35).
city('Shatsk','ru','Ryazan',7434.0,41.71,54.02).
city('Shilovo','ru','Ryazan',16159.0,40.88,54.32).
city('Skopin','ru','Ryazan',24357.0,39.58,53.83).
city('Solotcha','ru','Ryazan',2481.0,39.84,54.79).
city('Spas-Klepiki','ru','Ryazan',5942.0,40.17,55.13).
city('Spassk-Ryazanskiy','ru','Ryazan',8655.0,40.38,54.41).
city('Starozhilovo','ru','Ryazan',5147.0,39.91,54.23).
city('Syntul','ru','Ryazan',1842.0,41.3,55.0).
city('Tsentralnyy','ru','Ryazan',1911.0,39.63,53.68).
city('Tuma','ru','Ryazan',6432.0,40.56,55.15).
city('Ukholovo','ru','Ryazan',5558.0,40.49,53.79).
city('Yelatma','ru','Ryazan',3902.0,41.75,54.94).
city('Yermish','ru','Ryazan',4598.0,42.27,54.76).
city('Zakharovo','ru','Ryazan',2882.0,39.28,54.37).
city('Zarechnyy','ru','Ryazan',3069.0,39.57,53.72).
city('Aleksandrovskaya','ru','Saint Petersburg',1159.0,30.33,59.73).
city('Beloostrov','ru','Saint Petersburg',1654.0,30.0,60.15).
city('Kolpino','ru','Saint Petersburg',136078.0,30.6,59.75).
city('Komarovo','ru','Saint Petersburg',1039.0,29.82,60.18).
city('Krasnoye Selo','ru','Saint Petersburg',43134.0,30.09,59.74).
city('Kronshtadt','ru','Saint Petersburg',42987.0,29.77,59.99).
city('Levashovo','ru','Saint Petersburg',4007.0,30.21,60.1).
city('Lisiy Nos','ru','Saint Petersburg',2508.0,30.01,60.01).
city('Lomonosov','ru','Saint Petersburg',36778.0,29.75,59.91).
city('Metallostroy','ru','Saint Petersburg',25123.0,30.58,59.8).
city('Molodyozhnoye','ru','Saint Petersburg',1406.0,29.54,60.2).
city('Pargolovo','ru','Saint Petersburg',11962.0,30.26,60.08).
city('Pavlovsk','ru','Saint Petersburg',13474.0,30.45,59.68).
city('Pesochnyy','ru','Saint Petersburg',6348.0,30.17,60.12).
city('Petro-Slavyanka','ru','Saint Petersburg',1308.0,30.52,59.8).
city('Petrodvorets','ru','Saint Petersburg',61974.0,29.9,59.89).
city('Pontonnyy','ru','Saint Petersburg',9001.0,30.63,59.78).
city('Pushkin','ru','Saint Petersburg',82417.0,30.42,59.72).
city('Repino','ru','Saint Petersburg',1968.0,29.87,60.17).
city('Saint Petersburg','ru','Saint Petersburg',4039751.0,30.32,59.93).
city('Sapernyy','ru','Saint Petersburg',1371.0,30.68,59.77).
city('Serovo','ru','Saint Petersburg',247.0,59.55,60.2).
city('Sestroretsk','ru','Saint Petersburg',41281.0,29.95,60.09).
city('Shushary','ru','Saint Petersburg',15503.0,30.47,59.77).
city('Solnechnoye','ru','Saint Petersburg',1136.0,29.94,60.15).
city('Strelna','ru','Saint Petersburg',12477.0,30.05,59.86).
city('Tyarlevo','ru','Saint Petersburg',1523.0,30.45,59.7).
city('Ushkovo','ru','Saint Petersburg',472.0,29.62,60.2).
city('Ust-Izhora','ru','Saint Petersburg',1127.0,30.6,59.8).
city('Zelenogorsk','ru','Saint Petersburg',11867.0,29.69,60.2).
city('Aleksandrovsk-Sakhalinskiy','ru','Sakhalin',12025.0,142.16,50.9).
city('Aniva','ru','Sakhalin',7963.0,142.53,46.72).
city('Boshnyakovo','ru','Sakhalin',1491.0,142.17,49.63).
city('Bykov','ru','Sakhalin',4672.0,142.55,47.32).
city('Chekhov','ru','Sakhalin',4653.0,141.98,47.44).
city('Dolinsk','ru','Sakhalin',11989.0,142.8,47.35).
city('Due','ru','Sakhalin',195.0,142.1,50.83).
city('Ekhabi','ru','Sakhalin',507.0,142.97,53.5).
city('Gastello','ru','Sakhalin',1042.0,142.97,49.12).
city('Gornozavodsk','ru','Sakhalin',5579.0,141.85,46.56).
city('Ilinskiy','ru','Sakhalin',851.0,142.21,48.0).
city('Katangli','ru','Sakhalin',850.0,143.23,51.7).
city('Kholmsk','ru','Sakhalin',32682.0,142.06,47.05).
city('Kolendo','ru','Sakhalin',36.0,142.79,53.76).
city('Korsakov','ru','Sakhalin',35091.0,142.78,46.64).
city('Krasnogorsk','ru','Sakhalin',3304.0,142.1,48.4).
city('Kurilsk','ru','Sakhalin',2185.0,147.88,45.23).
city('Leonidovo','ru','Sakhalin',1283.0,142.87,49.28).
city('Makarov','ru','Sakhalin',6663.0,142.8,48.63).
city('Mgachi','ru','Sakhalin',1632.0,142.27,51.05).
city('Nevelsk','ru','Sakhalin',17639.0,141.86,46.67).
city('Nogliki','ru','Sakhalin',10098.0,143.11,51.83).
city('Novikovo','ru','Sakhalin',803.0,143.36,46.36).
city('Okha','ru','Sakhalin',26560.0,142.95,53.57).
city('Ozyorskiy','ru','Sakhalin',1680.0,143.13,46.61).
city('Poronaysk','ru','Sakhalin',16677.0,143.12,49.22).
city('Pravda','ru','Sakhalin',2412.0,142.02,46.94).
city('Severo-Kurilsk','ru','Sakhalin',2286.0,156.13,50.68).
city('Shakhtyorsk','ru','Sakhalin',10106.0,142.13,49.17).
city('Shebunino','ru','Sakhalin',1177.0,141.86,46.43).
city('Sinegorsk','ru','Sakhalin',2444.0,142.5,47.17).
city('Smirnykh','ru','Sakhalin',7116.0,142.83,49.75).
city('Sokol','ru','Sakhalin',3228.0,142.75,47.23).
city('Telnovskiy','ru','Sakhalin',207.0,142.1,49.4).
city('Tikhmenevo','ru','Sakhalin',808.0,142.9,49.2).
city('Tomari','ru','Sakhalin',4910.0,142.07,47.76).
city('Toyohara','ru','Sakhalin',176486.0,142.74,46.95).
city('Troitskoye','ru','Sakhalin',3176.0,142.63,46.92).
city('Tungor','ru','Sakhalin',1322.0,142.96,53.38).
city('Tymovskoye','ru','Sakhalin',8030.0,142.66,50.85).
city('Udarnyy','ru','Sakhalin',518.0,142.15,49.12).
city('Uglegorsk','ru','Sakhalin',12669.0,142.03,49.08).
city('Uglezavodsk','ru','Sakhalin',1610.0,142.62,47.32).
city('Vakhrushev','ru','Sakhalin',2884.0,142.97,48.98).
city('Vostochnyy','ru','Sakhalin',936.0,142.62,48.28).
city('Vostok','ru','Sakhalin',2779.0,148.9,48.92).
city('Vzmorye','ru','Sakhalin',758.0,142.51,47.85).
city('Yablochnyy','ru','Sakhalin',2062.0,142.07,47.17).
city('Yuzhno-Kurilsk','ru','Sakhalin',5413.0,145.86,44.03).
city('Alekseyevka','ru','Samara',7109.0,50.86,52.92).
city('Balasheyka','ru','Samara',3080.0,48.09,53.28).
city('Bereza','ru','Samara',5846.0,50.17,53.55).
city('Bezenchuk','ru','Samara',23736.0,49.43,52.98).
city('Bogatoye','ru','Samara',6391.0,51.4,53.07).
city('Bogatyr','ru','Samara',1098.0,50.03,53.42).
city('Bolshaya Chernigovka','ru','Samara',6269.0,50.87,52.1).
city('Bolshaya Glushitsa','ru','Samara',10055.0,50.48,52.38).
city('Borskoye','ru','Samara',9119.0,51.72,53.03).
city('Chapaevsk','ru','Samara',70148.0,49.72,52.98).
city('Chelno-Vershiny','ru','Sa',6015.0,51.1,54.43).
city('Dubovyy Umet','ru','Samara',3105.0,50.3,52.97).
city('Fyodorovka','ru','Samara',3019.0,49.66,53.47).
city('Georgiyevka','ru','Samara',3638.0,50.99,53.28).
city('Isakly','ru','Samara',4417.0,51.53,54.13).
city('Kamyshla','ru','Samara',4789.0,52.14,54.11).
city('Khryashchevka','ru','Samara',3210.0,49.09,53.82).
city('Khvorostyanka','ru','Samara',4899.0,48.97,52.61).
city('Kinel','ru','Samara',34337.0,50.65,53.23).
city('Kinel-Cherkassy','ru','Samara',18393.0,51.5,53.47).
city('Klyavlino','ru','Samara',6318.0,52.02,54.26).
city('Komsomolskiy','ru','Samara',3198.0,50.9,53.22).
city('Koshki','ru','Samara',8086.0,50.47,54.2).
city('Krasnoarmeyskoye','ru','Samara',5403.0,50.03,52.71).
city('Krasnyy Yar','ru','Samara',7664.0,50.38,53.49).
city('Krotovka','ru','Samara',5398.0,51.17,53.3).
city('Kurumoch','ru','Samara',6443.0,50.03,53.5).
city('Mezhdurechensk','ru','Samara',3454.0,49.11,53.27).
city('Mirnyy','ru','Samara',7393.0,50.22,53.55).
city('Neftegorsk','ru','Samara',19542.0,51.2,52.82).
city('Novaya Samara','ru','Samara',112417.0,49.93,53.11).
city('Novosemeykino','ru','Samara',9646.0,50.37,53.38).
city('Novyy Buyan','ru','Samara',3508.0,50.03,53.7).
city('Obsharovka','ru','Samara',5668.0,48.85,53.13).
city('Oktyabrsk','ru','Samara',24726.0,48.64,53.17).
city('Osinki','ru','Samara',3103.0,49.51,52.85).
city('Otradnyy','ru','Samara',50127.0,51.35,53.37).
city('Pervomayskiy','ru','Samara',444.0,51.6,53.35).
city('Pestravka','ru','Samara',6623.0,49.96,52.41).
city('Petra Dubrava','ru','Samara',6078.0,50.37,53.3).
city('Podbelsk','ru','Samara',3391.0,51.77,53.73).
city('Podstepki','ru','Samara',3140.0,49.13,53.52).
city('Pokhvistnevo','ru','Samara',27914.0,52.13,53.63).
city('Povolzhskiy','ru','Samara',8952.0,49.77,53.58).
city('Privolzhye','ru','Samara',7423.0,48.58,52.85).
city('Rozhdestveno','ru','Samara',5004.0,50.07,53.25).
city('Samara','ru','Samara',1134742.0,50.15,53.2).
city('Sergiyevsk','ru','Samara',8218.0,51.15,53.94).
city('Sernovodsk','ru','Samara',3570.0,51.24,53.92).
city('Shentala','ru','Samara',6595.0,51.48,54.45).
city('Shigony','ru','Samara',5268.0,48.68,53.39).
city('Smyshlyayevka','ru','Samara',5908.0,50.4,53.25).
city('Spiridonovka','ru','Samara',4387.0,50.65,53.1).
city('Sukhodol','ru','Samara',14296.0,51.22,53.88).
city('Surgut','ru','Samara',4699.0,51.23,53.93).
city('Syzran','ru','Samara',189341.0,48.47,53.17).
city('Timashyovo','ru','Samara',5596.0,51.15,53.37).
city('Tolyatti','ru','Samara',718.0,49.51,53.48).
city('Usolye','ru','Samara',4769.0,49.05,53.39).
city('Utevka','ru','Samara',4556.0,50.97,52.9).
city('Varlamovo','ru','Samara',3264.0,48.42,53.19).
city('Volzhskiy','ru','Samara',7040.0,50.13,53.43).
city('Yablonyovyy Ovrag','ru','Samara',6413.0,49.4,53.42).
city('Yelkhovka','ru','Samara',3142.0,50.27,53.86).
city('Zhigulyovsk','ru','Samara',49159.0,49.5,53.42).
city('Zolnoye','ru','Samara',1797.0,49.8,53.44).
city('Aleksandrov Gay','ru','Saratov',9919.0,48.57,50.15).
city('Alekseyevka','ru','Saratov',2127.0,48.01,52.31).
city('Arkadak','ru','Saratov',14393.0,43.5,51.94).
city('Atkarsk','ru','Saratov',27554.0,45.0,51.88).
city('Balakovo','ru','Saratov',201923.0,47.78,52.03).
city('Balashov','ru','Saratov',98108.0,43.17,51.55).
city('Baltay','ru','Saratov',3959.0,46.63,52.47).
city('Bazarnyy Karabulak','ru','Saratov',10389.0,46.42,52.27).
city('Cherkasskoye','ru','Saratov',3434.0,47.22,52.43).
city('Dergachi','ru','Saratov',9570.0,48.77,51.23).
city('Dukhovnitskoye','ru','Sar',5943.0,48.2,52.48).
city('Engels','ru','Saratov',196013.0,46.12,51.5).
city('Gornyy','ru','Saratov',7045.0,48.52,51.76).
city('Ivanteyevka','ru','Saratov',6127.0,49.11,52.27).
city('Kalininsk','ru','Saratov',18685.0,44.47,51.5).
city('Kamenskiy','ru','Saratov',3617.0,45.48,50.88).
city('Khvalynsk','ru','Saratov',13438.0,48.1,52.49).
city('Khvatovka','ru','Saratov',2301.0,46.57,52.35).
city('Krasnoarmeysk','ru','Saratov',25841.0,45.7,51.02).
city('Krasnyy Kut','ru','Saratov',14956.0,46.97,50.95).
city('Krasnyy Oktyabr','ru','Saratov',3303.0,45.7,51.55).
city('Krasnyy Tekstilshchik','ru','Saratov',3276.0,45.84,51.36).
city('Krasnyy Yar','ru','Saratov',3095.0,46.41,51.63).
city('Lysyye Gory','ru','Saratov',7501.0,44.82,51.53).
city('Marks','ru','Saratov',33106.0,46.72,51.71).
city('Mokrous','ru','Saratov',6738.0,47.52,51.23).
city('Novouzensk','ru','Saratov',16932.0,48.14,50.46).
city('Novyye Burasy','ru','Saratov',6469.0,46.07,52.13).
city('Ozinki','ru','Saratov',9733.0,49.67,51.17).
city('Perelyub','ru','Saratov',5549.0,50.37,51.87).
city('Petrovsk','ru','Saratov',33622.0,45.38,52.32).
city('Pinerovka','ru','Saratov',3602.0,43.06,51.56).
city('Piterka','ru','Saratov',5437.0,47.45,50.67).
city('Podlesnoye','ru','Saratov',4149.0,47.05,51.8).
city('Privolzhskiy','ru','Saratov',31849.0,46.03,51.4).
city('Pugachyov','ru','Saratov',41347.0,48.8,52.01).
city('Pushkino','ru','Saratov',2728.0,46.98,51.23).
city('Repnoye','ru','Saratov',3131.0,43.18,51.6).
city('Romanovka','ru','Saratov',7746.0,42.76,51.74).
city('Rovnoye','ru','Saratov',5228.0,46.05,50.77).
city('Rtishchevo','ru','Saratov',44014.0,43.79,52.26).
city('Samoylovka','ru','Saratov',8584.0,43.7,51.18).
city('Saratov','ru','Saratov',863734.0,46.03,51.57).
city('Sennoy','ru','Saratov',6979.0,46.95,52.17).
city('Shikhany','ru','Saratov',6688.0,47.22,52.12).
city('Sokolovyy','ru','Saratov',6183.0,45.83,51.57).
city('Sovetskoye','ru','Saratov',3490.0,46.73,51.45).
city('Stepnoye','ru','Saratov',14035.0,46.87,51.4).
city('Storozhovka','ru','Saratov',3355.0,45.8,51.65).
city('Svetlyy','ru','Saratov',12222.0,45.63,51.67).
city('Svobodnyy','ru','Saratov',2275.0,46.37,52.33).
city('Tatishchevo','ru','Saratov',7377.0,45.59,51.67).
city('Turki','ru','Saratov',6821.0,43.27,51.98).
city('Volsk','ru','Saratov',71717.0,47.38,52.03).
city('Voskresenskoye','ru','Saratov',3211.0,46.93,51.82).
city('Vozrozhdeniye','ru','Saratov',2738.0,48.2,52.69).
city('Yekaterinovka','ru','Saratov',6435.0,44.34,52.06).
city('Yershov','ru','Saratov',23682.0,48.25,51.35).
city('Demidov','ru','Smolensk',8516.0,31.51,55.27).
city('Desnogorsk','ru','Smolensk',32454.0,33.28,54.15).
city('Dorogobuzh','ru','Smolensk',12294.0,33.29,54.93).
city('Dukhovshchina','ru','Smolensk',4494.0,32.41,55.19).
city('Glinka','ru','Smolensk',1964.0,32.87,54.65).
city('Golynki','ru','Smolensk',3782.0,31.39,54.87).
city('Gusino','ru','Smolensk',3211.0,31.38,54.4).
city('Gzhatsk','ru','Smolensk',28880.0,35.0,55.55).
city('Izdyoshkovo','ru','Smolensk',1893.0,33.58,55.13).
city('Kardymovo','ru','Smolensk',4951.0,32.43,54.89).
city('Khislavichi','ru','Smolensk',4496.0,32.15,54.18).
city('Kholm-Zhirkovskiy','ru','Smolensk',3726.0,33.47,55.52).
city('Krasnyy','ru','Smolensk',4590.0,31.43,54.57).
city('Monastyrshchina','ru','Smolensk',4501.0,31.84,54.35).
city('Novodugino','ru','Smolensk',3894.0,34.29,55.63).
city('Oster','ru','Smolensk',1894.0,32.8,54.03).
city('Ozyornyy','ru','Smolensk',6213.0,32.45,55.58).
city('Pechyorsk','ru','Smolensk',3652.0,32.06,54.85).
city('Pochinok','ru','Smolensk',9310.0,32.45,54.4).
city('Przhevalskoye','ru','Smolensk',2055.0,31.85,55.51).
city('Roslavl','ru','Smolensk',56972.0,32.86,53.95).
city('Rudnya','ru','Smolensk',9615.0,31.09,54.96).
city('Safonovo','ru','Smolensk',46638.0,33.22,55.15).
city('Shatalovo','ru','Smolensk',4142.0,32.45,54.33).
city('Shumyachi','ru','Smolensk',4607.0,32.42,53.86).
city('Smolensk','ru','Smolensk',320994.0,32.04,54.78).
city('Stodolishche','ru','Smolensk',3198.0,32.65,54.18).
city('Sychevka','ru','Smolensk',8510.0,34.28,55.83).
city('Tyomkino','ru','Smolensk',2388.0,35.01,55.08).
city('Ugra','ru','Smolensk',4721.0,34.33,54.78).
city('Velizh','ru','Smolensk',8147.0,31.19,55.61).
city('Verkhnedneprovskiy','ru','Smolensk',13903.0,33.33,54.98).
city('Vyazma','ru','Smolensk',57192.0,34.29,55.21).
city('Yartsevo','ru','Smolensk',52706.0,32.67,55.07).
city('Yekimovichi','ru','Smolensk',1534.0,33.3,54.12).
city('Yelnya','ru','Smolensk',10947.0,33.19,54.58).
city('Yershichi','ru','Smolensk',3239.0,32.76,53.68).
city('Achikulak','ru','Stavropol',7040.0,44.84,44.55).
city('Aleksandriya','ru','Stavropol',4223.0,43.25,45.09).
city('Aleksandriyskaya','ru','Stavropol',10279.0,43.35,44.23).
city('Aleksandrovskoye','ru','Stavropol',28006.0,43.0,44.71).
city('Andzhiyevskiy','ru','Stavropol',6755.0,43.11,44.23).
city('Arkhangelskoye','ru','Stavropol',5217.0,44.09,44.61).
city('Arzgir','ru','Stavropol',15838.0,44.22,45.37).
city('Balakhonovskoye','ru','Stavropol',4377.0,41.78,44.77).
city('Barsukovskaya','ru','Stavropol',5529.0,41.82,44.76).
city('Bekeshevskaya','ru','Stavropol',3800.0,42.43,44.11).
city('Beshpagir','ru','Stavropol',4183.0,42.38,45.02).
city('Bezopasnoye','ru','Stavropol',7176.0,41.94,45.65).
city('Blagodarnyy','ru','Stavropol',35996.0,43.44,45.1).
city('Blagodatnoye','ru','Stavropol',5230.0,42.59,45.4).
city('Bolshaya Dzhalga','ru','Stavropol',3877.0,42.7,45.98).
city('Borgustanskaya','ru','Stavropol',4250.0,42.53,44.06).
city('Budyonnovsk','ru','Stavropol',67963.0,44.14,44.79).
city('Burlatskoye','ru','Stavropol',3637.0,43.64,45.06).
city('Chernolesskoye','ru','Stavropol',5386.0,43.71,44.72).
city('Divnoye','ru','Stavropol',15700.0,43.35,45.91).
city('Dmitriyevskoye','ru','Stavropol',3442.0,41.87,45.8).
city('Donskoye','ru','Stavropol',15469.0,41.98,45.43).
city('Dyomina','ru','Stavropol',4442.0,43.6,44.57).
city('Edissiya','ru','Stavropol',5775.0,44.54,44.05).
city('Etoka','ru','Stavropol',3152.0,43.05,43.92).
city('Galyugayevskaya','ru','Stavropol',3313.0,44.95,43.7).
city('Georgievsk','ru','Stavropol',72652.0,43.47,44.15).
city('Georgiyevskaya','ru','Stavropol',5610.0,43.48,44.12).
city('Gofitskoye','ru','Stavropol',5493.0,43.05,45.08).
city('Goryachevodskiy','ru','Stavropol',35075.0,43.09,44.02).
city('Grachyovka','ru','Stavropol',6350.0,42.43,45.21).
city('Grazhdanskoye Pervoye','ru','Stavropol',3097.0,42.8,44.24).
city('Grigoropolisskaya','ru','Stavropol',9310.0,41.06,45.3).
city('Ipatovo','ru','Stavropol',29073.0,42.9,45.72).
city('Irgakly','ru','Stavropol',3997.0,44.76,44.36).
city('Ivanovskoye','ru','Stavropol',7003.0,41.87,44.58).
city('Izobilnyy','ru','Stavropol',40122.0,41.71,45.37).
city('Kalinovskoye','ru','Stavropol',3951.0,42.97,44.86).
city('Kangly','ru','Stavropol',3494.0,43.03,44.25).
city('Kara-Tyube','ru','Stavropol',3359.0,45.44,44.63).
city('Kayasula','ru','Stavropol',4982.0,45.0,44.33).
city('Kazminskoye','ru','Stavropol',6078.0,41.68,44.59).
city('Kevsala','ru','Stavropol',3532.0,42.69,45.8).
city('Kislovodsk','ru','Stavropol',132773.0,42.72,43.91).
city('Kochubeyevskoye','ru','Stavropol',28491.0,41.83,44.66).
city('Komsomolets','ru','Stavropol',3143.0,43.57,44.02).
city('Konstantinovskaya','ru','Stavropol',7137.0,43.16,44.05).
city('Konstantinovskoye','ru','Stavropol',5816.0,42.64,45.3).
city('Krasnogvardeyskoye','ru','Stavropol',16169.0,41.52,45.85).
city('Krasnokumskoye','ru','Stavropol',13630.0,43.5,44.18).
city('Kruglolesskoye','ru','Stavropol',3249.0,42.81,44.66).
city('Kugulta','ru','Stavropol',5564.0,42.39,45.36).
city('Kursavka','ru','Stavropol',11043.0,42.51,44.46).
city('Kurskaya','ru','Stavropol',12036.0,44.45,44.05).
city('Ladovskaya Balka','ru','Stavropol',5117.0,41.4,45.63).
city('Lermontov','ru','Stavropol',23369.0,42.97,44.11).
city('Letnyaya Stavka','ru','Stavropol',4969.0,43.45,45.43).
city('Levokumka','ru','Stavropol',5651.0,43.15,44.23).
city('Levokumskoye','ru','Stavropol',11377.0,44.66,44.82).
city('Lysogorskaya','ru','Stavropol',10219.0,43.28,44.11).
city('Marinskaya','ru','Stavropol',9065.0,43.49,43.88).
city('Mikhaylovsk','ru','Stavropol',59198.0,42.0,45.14).
city('Mineralnyye Vody','ru','Stavropol',76281.0,43.13,44.21).
city('Moskovskoye','ru','Stavropol',5482.0,41.91,45.28).
city('Nadezhda','ru','Stavropol',8426.0,44.6,44.1).
city('Nagutskoye','ru','Stavropol',3146.0,42.87,44.44).
city('Neftekumsk','ru','Stavropol',28464.0,44.92,44.67).
city('Nevinnomyssk','ru','Stavropol',134347.0,41.95,44.63).
city('Nezhinskiy','ru','Stavropol',3991.0,42.69,43.93).
city('Nezlobnaya','ru','Stavropol',18412.0,43.4,44.12).
city('Nikolayevka','ru','Stavropol',27597.0,43.09,44.1).
city('Niny','ru','Stavropol',4894.0,43.95,44.49).
city('Novoaleksandrovsk','ru','Stavropol',27610.0,41.22,45.49).
city('Novoblagodarnoye','ru','Stavropol',3146.0,42.88,44.14).
city('Novopavlovsk','ru','Stavropol',24409.0,43.63,43.96).
city('Novoselitskoye','ru','Stavropol',8723.0,43.44,44.75).
city('Novotroitskaya','ru','Stavropol',7910.0,41.53,45.33).
city('Novozavedennoye','ru','Stavropol',5336.0,43.64,44.26).
city('Obilnoye','ru','Stavropol',6739.0,43.56,44.24).
city('Oktyabrskoye','ru','Stavropol',3533.0,42.83,45.62).
city('Orlovka','ru','Stavropol',3236.0,44.17,44.69).
city('Otkaznoye','ru','Stavropol',4090.0,43.86,44.33).
city('Pelagiada','ru','Stavropol',6871.0,42.02,45.21).
city('Podgornaya','ru','Stavropol',5336.0,43.43,44.2).
city('Podkumskiy','ru','Stavropol',3702.0,43.21,44.08).
city('Pokoynoye','ru','Stavropol',9175.0,44.25,44.81).
city('Praskoveya','ru','Stavropol',11420.0,44.2,44.74).
city('Pravokumskoye','ru','Stavropol',5117.0,44.65,44.77).
city('Pregradnoye','ru','Stavropol',3671.0,41.75,45.82).
city('Privolnyy','ru','Stavropol',3554.0,42.01,45.58).
city('Ptichye','ru','Stavropol',4680.0,41.71,45.52).
city('Pyatigorsk','ru','Stavropol',142868.0,43.06,44.05).
city('Pyatigorskiy','ru','Stavropol',4997.0,43.26,43.97).
city('Rasshevatskaya','ru','Stavropol',5686.0,41.04,45.57).
city('Russkoye','ru','Stavropol',4507.0,44.56,43.83).
city('Ryzdvyanyy','ru','Stavropol',7602.0,41.84,45.27).
city('Severnoye','ru','Stavropol',3607.0,42.85,44.83).
city('Soldato-Aleksandrovskoye','ru','Stavropol',11059.0,43.76,44.27).
city('Solnechnodolsk','ru','Stavropol',13161.0,41.34,45.26).
city('Solomenskoye','ru','Stavropol',3096.0,44.35,44.22).
city('Soluno-Dmitriyevskoye','ru','Stavropol',3270.0,42.7,44.42).
city('Sotnikovskoye','ru','Stavropol',5116.0,43.78,45.0).
city('Sovetskaya','ru','Stavropol',7886.0,44.05,44.03).
city('Spitsevka','ru','Stavropol',3374.0,42.51,45.12).
city('Starodubskoye','ru','Stavropol',4104.0,44.02,44.56).
city('Staromaryevka','ru','Stavropol',5869.0,42.25,45.1).
city('Staropavlovskaya','ru','Stavropol',3081.0,43.63,43.85).
city('Stavropol','ru','Stavropol',363069.0,41.97,45.04).
city('Stepnoye','ru','Stavropol',6058.0,44.56,44.27).
city('Sukhaya Buyvola','ru','Stavropol',3525.0,43.0,45.15).
city('Suvorovskaya','ru','Stavropol',17261.0,42.65,44.19).
city('Svetlograd','ru','Stavropol',39727.0,42.85,45.34).
city('Svobody','ru','Stavropol',17661.0,43.05,44.03).
city('Tatarka','ru','Stavropol',6062.0,41.95,44.95).
city('Temizhbekskiy','ru','Stavropol',3811.0,41.04,45.45).
city('Tishchenskoye','ru','Stavropol',3437.0,41.67,45.46).
city('Trunovskoye','ru','Stavropol',6459.0,42.14,45.49).
city('Urozhaynoye','ru','Stavropol',4215.0,44.92,44.79).
city('Velichaevskoye','ru','Stavropol',5843.0,45.13,44.95).
city('Verkhnerusskoye','ru','Stavropol',4378.0,41.95,45.12).
city('Vinsady','ru','Stavropol',8949.0,42.97,44.08).
city('Vysotskoye','ru','Stavropol',3078.0,42.91,45.03).
city('Yasnaya Polyana','ru','Stavropol',5064.0,42.75,44.02).
city('Yelizavetinskoye','ru','Stavropol',3316.0,43.35,45.02).
city('Yessentuki','ru','Stavropol',81016.0,42.85,44.04).
city('Yessentukskaya','ru','Stavropol',19956.0,42.9,44.04).
city('Yutsa','ru','Stavropol',8702.0,43.01,43.96).
city('Zaterechnyy','ru','Stavropol',7835.0,45.21,44.79).
city('Zavetnoye','ru','Stavropol',3932.0,41.6,44.75).
city('Zelenokumsk','ru','Stavropol',41307.0,43.88,44.41).
city('Zheleznovodsk','ru','Stavropol',24632.0,43.02,44.14).
city('Zolskaya','ru','Stavropol',8865.0,43.3,43.91).
city('Achit','ru','Sverdlovsk',5036.0,57.9,56.8).
city('Alapajevsk','ru','Sverdlovsk',42957.0,61.69,57.85).
city('Aramil','ru','Sverdlovsk',15237.0,60.83,56.7).
city('Arti','ru','Sverdlovsk',13564.0,58.53,56.42).
city('Artyomovskiy','ru','Sverdlovsk',33769.0,61.87,57.36).
city('Asbest','ru','Sverdlovsk',74584.0,61.46,57.02).
city('Asbestovskiy','ru','Sverdlovsk',1209.0,61.4,57.75).
city('Atig','ru','Sverdlovsk',3842.0,59.42,56.69).
city('Ayat','ru','Sverdlovsk',861.0,60.23,57.04).
city('Azanka','ru','Sverdlovsk',3210.0,64.8,58.03).
city('Baranchinskiy','ru','Sverdlovsk',10970.0,59.7,58.16).
city('Basyanovskiy','ru','Sverdlovsk',1744.0,60.74,58.31).
city('Baykalovo','ru','Sverdlovsk',6043.0,63.76,57.4).
city('Belorechka','ru','Sverdlovsk',265.0,60.04,57.33).
city('Beloyarskiy','ru','Sverdlovsk',12438.0,61.38,56.76).
city('Beryozovskiy','ru','Sverdlovsk',46405.0,60.8,56.91).
city('Bilimbay','ru','Sverdlovsk',5875.0,59.81,56.96).
city('Bisert','ru','Sverdlovsk',11077.0,59.05,56.86).
city('Bobrovskiy','ru','Sverdlovsk',5198.0,60.98,56.67).
city('Bogdanovich','ru','Sverdlovsk',32270.0,62.05,56.78).
city('Bolshoy Istok','ru','Sverdlovsk',6619.0,60.78,56.72).
city('Bulanash','ru','Sverdlovsk',13056.0,61.99,57.27).
city('Butka','ru','Sverdlovsk',3510.0,63.78,56.72).
city('Cheremukhovo','ru','Sverdlovsk',7270.0,59.99,60.34).
city('Chernoistochinsk','ru','Sverdlovsk',3646.0,59.87,57.74).
city('Degtyarsk','ru','Sverdlovsk',15294.0,60.1,56.7).
city('Druzhinino','ru','Sverdlovsk',2897.0,59.51,56.79).
city('Dvurechensk','ru','Sverdlovsk',5121.0,61.1,56.6).
city('Gari','ru','Sverdlovsk',3134.0,62.35,59.43).
city('Gornouralskiy','ru','Sverdlovsk',4198.0,59.91,58.07).
city('Gornyy Shchit','ru','Sverdlovsk',4648.0,60.52,56.69).
city('Irbit','ru','Sverdlovsk',41647.0,63.06,57.67).
city('Is','ru','Sverdlovsk',4729.0,59.72,58.79).
city('Iset','ru','Sverdlovsk',3191.0,60.37,56.98).
city('Istok','ru','Sverdlovsk',5670.0,60.78,56.79).
city('Ivdel','ru','Sverdlovsk',19380.0,60.42,60.69).
city('Izumrud','ru','Sverdlovsk',1307.0,61.4,57.07).
city('Kachkanar','ru','Sverdlovsk',43984.0,59.49,58.7).
city('Kalinovo','ru','Sverdlovsk',2901.0,60.15,57.13).
city('Kalya','ru','Sverdlovsk',6676.0,59.99,60.24).
city('Kamensk-Uralskiy','ru','Sverdlovsk',181884.0,61.93,56.41).
city('Kamyshlov','ru','Sverdlovsk',28006.0,62.71,56.84).
city('Karpinsk','ru','Sverdlovsk',30071.0,60.01,59.76).
city('Karpuninskiy','ru','Sverdlovsk',588.0,61.8,58.72).
city('Karpushikha','ru','Sverdlovsk',1497.0,59.9,57.5).
city('Kedrovoye','ru','Sverdlovsk',2163.0,60.57,57.16).
city('Kirovgrad','ru','Sverdlovsk',22685.0,60.06,57.44).
city('Klyuchevsk','ru','Sverdlovsk',1955.0,60.94,57.12).
city('Koltsovo','ru','Sverdlovsk',14493.0,60.82,56.76).
city('Kosya','ru','Sverdlovsk',504.0,59.35,58.8).
city('Krasnogvardeyskiy','ru','Sverdlovsk',4746.0,62.32,57.38).
city('Krasnoturinsk','ru','Sverdlovsk',64209.0,60.48,59.79).
city('Krasnoufimsk','ru','Sverdlovsk',43122.0,57.76,56.6).
city('Krasnouralsk','ru','Sverdlovsk',27656.0,60.05,58.35).
city('Kuri','ru','Sverdlovsk',4177.0,62.13,56.92).
city('Kushva','ru','Sverdlovsk',34059.0,59.75,58.29).
city('Kuzino','ru','Sverdlovsk',3213.0,59.43,57.02).
city('Kytlym','ru','Sverdlovsk',872.0,59.2,59.5).
city('Lesnoy','ru','Sverdlovsk',52322.0,59.8,58.65).
city('Levikha','ru','Sverdlovsk',3452.0,59.9,57.58).
city('Lobva','ru','Sverdlovsk',8403.0,60.49,59.19).
city('Losinyy','ru','Sverdlovsk',2189.0,61.07,57.14).
city('Lugovskoy','ru','Sverdlovsk',2969.0,64.52,56.95).
city('Makhnyovo','ru','Sverdlovsk',3688.0,61.71,58.45).
city('Malysheva','ru','Sverdlovsk',9955.0,61.39,57.12).
city('Martyush','ru','Sverdlovsk',4110.0,61.88,56.4).
city('Mikhaylovsk','ru','Sverdlovsk',10209.0,59.11,56.44).
city('Monetnyy','ru','Sverdlovsk',5540.0,60.88,57.05).
city('Natalinsk','ru','Sverdlovsk',2060.0,57.87,56.47).
city('Nevyansk','ru','Sverdlovsk',25822.0,60.21,57.49).
city('Neyvo-Rudyanka','ru','Sverdlovsk',2895.0,60.14,57.34).
city('Neyvo-Shaytanskiy','ru','Sverdlovsk',2602.0,61.25,57.73).
city('Nikolo-Pavlovskoye','ru','Sverdlovsk',4721.0,60.06,57.78).
city('Nizhniy Tagil','ru','Sverdlovsk',381121.0,59.97,57.92).
city('Nizhniy Tagil-39','ru','Sverdlovsk',9508.0,60.37,58.03).
city('Nizhniye Sergi','ru','Sverdlovsk',12077.0,59.29,56.65).
city('Nizhnyaya Salda','ru','Sverdlovsk',17473.0,60.73,58.08).
city('Nizhnyaya Tura','ru','Sverdlovsk',23835.0,59.8,58.63).
city('Novaya Lyalya','ru','Sverdlovsk',14246.0,60.6,59.06).
city('Novoasbest','ru','Sverdlovsk',2394.0,60.29,57.74).
city('Novouralsk','ru','Sverdlovsk',93849.0,60.08,57.25).
city('Novoutkinsk','ru','Sverdlovsk',5507.0,59.55,56.99).
city('Oktyabrskiy','ru','Sverdlovsk',116.0,60.73,57.03).
city('Ous','ru','Sverdlovsk',1639.0,61.52,60.91).
city('Pavda','ru','Sverdlovsk',677.0,59.51,59.26).
city('Pelym','ru','Sverdlovsk',3647.0,62.0,61.0).
city('Pervouralsk','ru','Sverdlovsk',130016.0,59.95,56.91).
city('Petrokamenskoye','ru','Sverdlovsk',3688.0,60.66,57.71).
city('Pionerskiy','ru','Sverdlovsk',3134.0,63.73,57.1).
city('Pokrovsk-Uralskiy','ru','Sverdlovsk',1592.0,59.83,60.15).
city('Pokrovskoye','ru','Sverdlovsk',3573.0,61.61,56.47).
city('Polevskoy','ru','Sverdlovsk',65771.0,60.19,56.44).
city('Polunochnoye','ru','Sverdlovsk',2848.0,60.42,60.87).
city('Privokzalnyy','ru','Sverdlovsk',6116.0,60.73,58.88).
city('Pyshma','ru','Sverdlovsk',10094.0,63.24,56.95).
city('Reftinskiy','ru','Sverdlovsk',17673.0,61.68,57.09).
city('Revda','ru','Sverdlovsk',61786.0,59.93,56.81).
city('Rezh','ru','Sverdlovsk',39217.0,61.4,57.37).
city('Rudnichnyy','ru','Sverdlovsk',4201.0,60.28,59.7).
city('Sadovyy','ru','Sverdlovsk',2968.0,60.58,56.76).
city('Sarana','ru','Sverdlovsk',2640.0,57.72,56.48).
city('Sarapulka','ru','Sverdlovsk',878.0,61.05,56.87).
city('Serov','ru','Sverdlovsk',98440.0,60.58,59.61).
city('Severka','ru','Sverdlovsk',3325.0,60.3,56.87).
city('Severnyy','ru','Sverdlovsk',235.0,60.4,60.98).
city('Severouralsk','ru','Sverdlovsk',34317.0,59.96,60.15).
city('Shabrovskiy','ru','Sverdlovsk',3868.0,60.58,56.64).
city('Shalya','ru','Sverdlovsk',6689.0,58.73,57.25).
city('Shamary','ru','Sverdlovsk',3605.0,58.22,57.34).
city('Shchelkun','ru','Sverdlovsk',3044.0,60.95,56.31).
city('Shirokaya Rechka','ru','Sverdlovsk',1131.0,60.49,56.8).
city('Sinegorskiy','ru','Sverdlovsk',880.0,59.52,57.89).
city('Sosva','ru','Sverdlovsk',10171.0,61.84,59.18).
city('Sovkhoznyy','ru','Sverdlovsk',3546.0,61.43,56.57).
city('Sredneuralsk','ru','Sverdlovsk',19616.0,60.47,56.99).
city('Staropyshminsk','ru','Sverdlovsk',1679.0,60.9,56.93).
city('Staroutkinsk','ru','Sverdlovsk',3188.0,59.34,57.23).
city('Sukhoy Log','ru','Sverdlovsk',36329.0,62.03,56.91).
city('Sysert','ru','Sverdlovsk',21942.0,60.81,56.5).
city('Tabory','ru','Sverdlovsk',2062.0,64.55,58.52).
city('Talitsa','ru','Sverdlovsk',18603.0,63.71,57.02).
city('Tavatuy','ru','Sverdlovsk',559.0,60.21,57.15).
city('Tavda','ru','Sverdlovsk',39480.0,65.26,58.05).
city('Tretiy Severnyy','ru','Sverdlovsk',2128.0,59.96,60.21).
city('Troitskiy','ru','Sverdlovsk',11081.0,63.73,57.06).
city('Tsementnyy','ru','Sverdlovsk',5972.0,60.14,57.47).
city('Tugulym','ru','Sverdlovsk',6139.0,64.64,57.06).
city('Turinsk','ru','Sverdlovsk',18555.0,63.7,58.05).
city('Turinskaya Sloboda','ru','Sverdlovsk',6023.0,64.39,57.61).
city('Ufimskiy','ru','Sverdlovsk',3260.0,58.05,56.71).
city('Uralets','ru','Sverdlovsk',1551.0,59.64,57.66).
city('Uralskiy','ru','Sverdlovsk',2273.0,58.97,56.72).
city('Valerianovsk','ru','Sverdlovsk',2152.0,59.55,58.76).
city('Verkh-Neyvinskiy','ru','Sverdlovsk',5156.0,60.09,57.26).
city('Verkhneye Dubrovo','ru','Sverdlovsk',4596.0,61.04,56.75).
city('Verkhniy Tagil','ru','Sverdlovsk',12359.0,59.96,57.38).
city('Verkhniye Sergi','ru','Sverdlovsk',6520.0,59.55,56.66).
city('Verkhnyaya Pyshma','ru','Sverdlovsk',59062.0,60.58,56.97).
city('Verkhnyaya Salda','ru','Sverdlovsk',48993.0,60.55,58.05).
city('Verkhnyaya Sinyachikha','ru','Sverdlovsk',10964.0,61.66,57.97).
city('Verkhnyaya Sysert','ru','Sverdlovsk',1115.0,60.75,56.44).
city('Verkhnyaya Tura','ru','Sverdlovsk',10608.0,59.82,58.36).
city('Verkhoturye','ru','Sverdlovsk',7566.0,60.81,58.86).
city('Veselovka','ru','Sverdlovsk',294.0,59.98,59.7).
city('Visim','ru','Sverdlovsk',1699.0,59.49,57.65).
city('Visimo-Utkinsk','ru','Sverdlovsk',843.0,59.36,57.68).
city('Volchansk','ru','Sverdlovsk',10403.0,60.07,59.93).
city('Vorontsovka','ru','Sverdlovsk',983.0,60.24,59.66).
city('Vostochnyy','ru','Sverdlovsk',5635.0,61.81,58.8).
city('Yekaterinburg','ru','Sverdlovsk',1287586.0,60.6,56.85).
city('Yelanskiy','ru','Sverdlovsk',8653.0,62.5,56.82).
city('Yertarskiy','ru','Sverdlovsk',1612.0,64.3,56.78).
city('Yolkino','ru','Sverdlovsk',1306.0,59.83,58.7).
city('Yushala','ru','Sverdlovsk',4169.0,64.26,57.08).
city('Zarechnyy','ru','Sverdlovsk',27759.0,61.33,56.81).
city('Zavodouspenskoye','ru','Sverdlovsk',1441.0,65.0,56.85).
city('Zaykovo','ru','Sverdlovsk',4731.0,62.77,57.56).
city('Zyryanovskiy','ru','Sverdlovsk',896.0,61.7,57.73).
city('Zyuzelskiy','ru','Sverdlovsk',1311.0,60.13,56.49).
city('Bokino','ru','Tambov',4016.0,41.47,52.64).
city('Bondari','ru','Tambov',3949.0,42.02,53.04).
city('Dmitriyevka','ru','Tambov',9015.0,40.79,52.88).
city('Donskoye','ru','Tambov',4305.0,41.49,52.78).
city('Gavrilovka Vtoraya','ru','Tambov',2699.0,42.76,52.86).
city('Goreloye','ru','Tambov',3933.0,41.5,52.93).
city('Inzhavino','ru','Tambov',10278.0,42.49,52.32).
city('Kirsanov','ru','Tambov',17975.0,42.71,52.66).
city('Komsomolets','ru','Tambov',3678.0,41.23,52.77).
city('Kotovsk','ru','Tambov',33077.0,41.51,52.59).
city('Krasnenkaya','ru','Tambov',4489.0,41.45,52.75).
city('Michurinsk','ru','Tambov',93500.0,40.5,52.9).
city('Mordovo','ru','Tambov',7112.0,40.78,52.09).
city('Morshansk','ru','Tambov',43312.0,41.81,53.45).
city('Muchkapskiy','ru','Tambov',7814.0,42.48,51.85).
city('Novaya Lyada','ru','Tambov',4851.0,41.64,52.72).
city('Novopokrovka','ru','Tambov',2167.0,40.88,52.15).
city('Pervomayskiy','ru','Tambov',13345.0,40.3,53.23).
city('Petrovskoye','ru','Tambov',5817.0,40.95,52.85).
city('Pichayevo','ru','Tambov',3463.0,42.2,53.23).
city('Platonovka','ru','Tambov',3761.0,41.96,52.71).
city('Pokrovo-Prigorodnoye','ru','Tambov',5012.0,41.32,52.68).
city('Rasskazovo','ru','Tambov',45957.0,41.9,52.67).
city('Rzhaksa','ru','Tambov',5692.0,42.02,52.14).
city('Satinka','ru','Tambov',3599.0,41.67,52.37).
city('Seleznyovskiy','ru','Tambov',4603.0,41.25,52.8).
city('Sosnovka','ru','Tambov',10475.0,41.37,53.23).
city('Staroyurevo','ru','Tambov',6684.0,40.71,53.32).
city('Tambov','ru','Tambov',290936.0,41.43,52.73).
city('Tokaryovka','ru','Tambov',7223.0,41.16,51.99).
city('Umyot','ru','Tambov',4853.0,41.08,52.4).
city('Ustye','ru','Tambov',3609.0,40.47,52.83).
city('Uvarovo','ru','Tambov',28771.0,42.26,51.99).
city('Zavoronezhskoye','ru','Tambov',5645.0,40.55,52.88).
city('Zherdevka','ru','Tambov',16019.0,41.46,51.85).
city('Znamenka','ru','Tambov',8940.0,41.5,52.39).
city('Aksubay','ru','Tatarstan',9537.0,50.78,54.84).
city('Aktanysh','ru','Tatarstan',8163.0,54.09,55.72).
city('Aktyubinskiy','ru','Tatarstan',9964.0,52.78,54.82).
city('Alekseyevskoye','ru','Tatarstan',9738.0,50.11,55.31).
city('Almetyevsk','ru','Tatarstan',142727.0,52.31,54.9).
city('Apastovo','ru','Tatarstan',4575.0,48.5,55.2).
city('Arsk','ru','Tatarstan',17243.0,49.88,56.09).
city('Aysha','ru','Tatarstan',3086.0,48.65,55.87).
city('Aznakay','ru','Tatarstan',36109.0,53.07,54.86).
city('Baltasi','ru','Tatarstan',7009.0,50.21,56.34).
city('Bavly','ru','Tatarstan',22982.0,53.28,54.38).
city('Bazarnyye Mataki','ru','Tatarstan',5339.0,49.91,54.91).
city('Betki','ru','Tatarstan',3756.0,53.55,54.84).
city('Bogatyye Saby','ru','Tatarstan',7209.0,50.45,56.01).
city('Bolgar','ru','Tatarstan',8641.0,49.06,54.94).
city('Bolshaya Atnya','ru','Tatarstan',3658.0,49.45,56.25).
city('Bolshiye Kaybitsy','ru','Tatarstan',1581.0,48.18,55.42).
city('Bugulma','ru','Tatarstan',93507.0,52.8,54.55).
city('Buinsk','ru','Tatarstan',20267.0,48.28,54.95).
city('Cheremshan','ru','Tatarstan',5646.0,51.49,54.66).
city('Chistay','ru','Tatarstan',62261.0,50.64,55.36).
city('Dzhalil','ru','Tatarstan',14797.0,52.74,55.02).
city('Kamskiye Polyany','ru','Tatarstan',15077.0,51.33,55.42).
city('Kamskoye Ustye','ru','Tatarstan',4459.0,49.22,55.21).
city('Karabash','ru','Tatarstan',5149.0,52.58,54.69).
city('Kazan','ru','Tatarstan',1104750.0,49.13,55.75).
city('Kukmor','ru','Tatarstan',16795.0,50.89,56.18).
city('Kuybyshevskiy Zaton','ru','Tatarstan',2919.0,49.16,55.15).
city('Laishevo','ru','Tatarstan',7744.0,49.55,55.4).
city('Leninogorsk','ru','Tatarstan',66264.0,52.45,54.6).
city('Lubyany','ru','Tatarstan',1899.0,51.4,56.04).
city('Mamadish','ru','Tatarstan',13842.0,51.41,55.71).
city('Mendeleyevsk','ru','Tatarstan',22970.0,52.32,55.89).
city('Menzelinsk','ru','Tatarstan',16858.0,53.1,55.72).
city('Muslyumovo','ru','Tatarstan',7406.0,53.2,55.3).
city('Nizhnekamsk','ru','Tatarstan',234301.0,51.82,55.64).
city('Nizhniye Vyazovyye','ru','Tatarstan',8290.0,48.53,55.8).
city('Nizhnyaya Maktama','ru','Tatarstan',10600.0,52.37,54.85).
city('Novosheshminsk','ru','Tatarstan',4585.0,51.24,55.07).
city('Nurlat','ru','Tatarstan',34452.0,50.77,54.43).
city('Ogyrchi','ru','Tatarstan',18300.0,53.0,56.52).
city('Osinovo','ru','Tatarstan',7827.0,48.88,55.88).
city('Pestretsy','ru','Tatarstan',7311.0,49.65,55.75).
city('Russkiy Aktash','ru','Tatarstan',4195.0,52.12,55.03).
city('Rybnaya Sloboda','ru','Tatarstan',7190.0,50.14,55.46).
city('Sarmanovo','ru','Tatarstan',6339.0,52.59,55.25).
city('Shemordan','ru','Tatarstan',5887.0,50.39,56.18).
city('Shugurovo','ru','Tatarstan',2243.0,52.1,54.52).
city('Staroye Drozhzhanoye','ru','Tatarstan',3338.0,47.57,54.73).
city('Stolbishche','ru','Tatarstan',3648.0,49.21,55.65).
city('Taetesh','ru','Tatarstan',12171.0,48.83,54.92).
city('Tyulyachi','ru','Tatarstan',2949.0,50.23,55.88).
city('Urussu','ru','Tatarstan',11279.0,53.45,54.58).
city('Vasilyevo','ru','Tatarstan',16877.0,48.75,55.84).
city('Verkhniy Uslon','ru','Tatarstan',4265.0,48.98,55.77).
city('Vysokaya Gora','ru','Tatarstan',5477.0,49.3,55.92).
city('Yarchally','ru','Tatarstan',518903.0,52.32,55.69).
city('Yelabuga','ru','Tatarstan',72644.0,52.07,55.76).
city('Zainsk','ru','Tatarstan',42045.0,52.06,55.32).
city('Zelenodolsk','ru','Tatarstan',101131.0,48.66,55.84).
city('Zelyonaya Roshcha','ru','Tatarstan',824.0,52.03,54.48).
city('Dikson','ru','Taymir',1113.0,80.55,73.51).
city('Dudinka','ru','Taymir',23619.0,86.18,69.41).
city('Karaul','ru','Taymir',824.0,83.19,70.08).
city('Khatanga','ru','Taymir',3205.0,102.5,71.97).
city('Aleksandrovskoye','ru','Tomsk',7999.0,85.39,56.74).
city('Asino','ru','Tomsk',27070.0,86.15,57.0).
city('Bakchar','ru','Tomsk',7195.0,82.07,57.02).
city('Belyy Yar','ru','Tomsk',8245.0,85.06,58.44).
city('Bogashevo','ru','Tomsk',3773.0,85.14,56.37).
city('Kargasok','ru','Tomsk',8572.0,80.86,59.06).
city('Kedrovyy','ru','Tomsk',3061.0,79.52,57.52).
city('Kolpashevo','ru','Tomsk',27876.0,82.91,58.31).
city('Kozhevnikovo','ru','Tomsk',7970.0,83.96,56.26).
city('Krasnyy Yar','ru','Tomsk',3128.0,84.54,57.13).
city('Krivosheino','ru','Tomsk',6010.0,83.93,57.34).
city('Melnikovo','ru','Tomsk',9745.0,84.08,56.55).
city('Mogochin','ru','Tomsk',3191.0,83.57,57.72).
city('Molchanovo','ru','Tomsk',6109.0,83.77,57.59).
city('Moryakovskiy Zaton','ru','Tomsk',4745.0,84.65,56.7).
city('Parabel','ru','Tomsk',6227.0,81.45,58.71).
city('Pervomayskoye','ru','Tomsk',5817.0,86.24,57.08).
city('Podgornoye','ru','Tomsk',5024.0,82.65,57.79).
city('Samus','ru','Tomsk',5706.0,84.7,56.74).
city('Seversk','ru','Tomsk',109846.0,84.83,56.61).
city('Strezhevoy','ru','Tomsk',44784.0,77.59,60.73).
city('Svetlyy','ru','Tomsk',7536.0,85.97,56.92).
city('Teguldet','ru','Tomsk',4801.0,88.17,57.31).
city('Timiryazevskoye','ru','Tomsk',6229.0,84.9,56.49).
city('Togur','ru','Tomsk',8442.0,82.83,58.36).
city('Tomsk','ru','Tomsk',485523.0,84.97,56.5).
city('Zonalnaya Stantsiya','ru','Tomsk',5050.0,85.01,56.43).
city('Zyryanskoye','ru','Tomsk',6285.0,86.62,56.83).
city('Ageyevo','ru','Tula',5934.0,36.48,54.16).
city('Aleksin','ru','Tula',66886.0,37.09,54.52).
city('Arkhangelskoye','ru','Tula',2690.0,37.71,53.26).
city('Barsuki','ru','Tula',3500.0,37.49,54.27).
city('Begichevskiy','ru','Tula',2616.0,38.26,53.8).
city('Belyov','ru','Tula',15606.0,36.13,53.81).
city('Bogoroditsk','ru','Tula',30216.0,38.12,53.77).
city('Bolokhovo','ru','Tula',10084.0,37.82,54.09).
city('Borodinskiy','ru','Tula',6447.0,37.83,53.98).
city('Brusyanskiy','ru','Tula',3277.0,38.08,53.98).
city('Chekalin','ru','Tula',1105.0,36.24,54.1).
city('Cherepet','ru','Tula',2070.0,36.38,54.12).
city('Chern','ru','Tula',6689.0,36.91,53.46).
city('Donskoy','ru','Tula',31968.0,38.32,53.97).
city('Dubna','ru','Tula',6019.0,36.96,54.16).
city('Dubovka','ru','Tula',8946.0,38.07,53.95).
city('Gorelki','ru','Tula',7655.0,37.62,54.27).
city('Gritsovskiy','ru','Tula',6568.0,38.18,54.13).
city('Kamenetskiy','ru','Tula',2788.0,38.22,54.01).
city('Kazachka','ru','Tula',1042.0,38.07,53.36).
city('Kazanovka','ru','Tula',781.0,38.6,53.77).
city('Kaznacheyevskiy','ru','Tula',465.0,37.55,54.05).
city('Khanino','ru','Tula',1256.0,36.62,54.21).
city('Khrushchyovo','ru','Tula',3425.0,37.53,54.24).
city('Kimovsk','ru','Tula',31947.0,38.53,53.97).
city('Kireyevsk','ru','Tula',25513.0,37.92,53.94).
city('Komsomolskiy','ru','Tula',2899.0,38.29,53.91).
city('Kosaya Gora','ru','Tula',17619.0,37.56,54.17).
city('Kurkino','ru','Tula',5944.0,38.67,53.44).
city('Leninskiy','ru','Tula',9834.0,37.47,54.3).
city('Lipki','ru','Tula',9633.0,37.71,53.94).
city('Lomintsevskiy','ru','Tula',4666.0,37.67,53.98).
city('Mayskiy','ru','Tula',2055.0,38.23,53.97).
city('Mendeleyevskiy','ru','Tula',9350.0,37.58,54.15).
city('Novogurovskiy','ru','Tula',3702.0,37.34,54.47).
city('Novolvovsk','ru','Tula',1973.0,38.79,53.93).
city('Novomoskovsk','ru','Tula',130984.0,38.22,54.09).
city('Novougolnyy','ru','Tula',7072.0,38.29,54.01).
city('Odoyev','ru','Tula',6386.0,36.69,53.94).
city('Ogaryovka','ru','Tula',3815.0,37.53,53.92).
city('Oktyabrskiy','ru','Tula',3263.0,38.13,53.77).
city('Partizan','ru','Tula',2462.0,38.11,53.96).
city('Pervomayskiy','ru','Tula',10946.0,37.53,54.05).
city('Pesochenskiy','ru','Tula',547.0,36.12,54.17).
city('Plavsk','ru','Tula',16763.0,37.29,53.71).
city('Plekhanovo','ru','Tula',8841.0,37.45,54.23).
city('Podlesnyy','ru','Tula',1745.0,38.27,53.95).
city('Priupskiy','ru','Tula',3324.0,37.78,53.89).
city('Revyakino','ru','Tula',3220.0,37.66,54.37).
city('Rudnyov','ru','Tula',2128.0,38.46,53.94).
city('Severo-Zadonsk','ru','Tula',16570.0,38.4,54.03).
city('Shakhtyorskiy','ru','Tula',3850.0,38.3,53.93).
city('Shchyokino','ru','Tula',59808.0,37.51,54.01).
city('Shvartsevskiy','ru','Tula',5083.0,37.99,54.1).
city('Skuratovskiy','ru','Tula',13325.0,37.6,54.11).
city('Sokolniki','ru','Tula',10843.0,38.47,54.05).
city('Sovetsk','ru','Tula',8485.0,37.56,53.92).
city('Suvorov','ru','Tula',21059.0,36.49,54.12).
city('Tovarkovskiy','ru','Tula',7959.0,38.21,53.68).
city('Tula','ru','Tula',468830.0,37.61,54.2).
city('Tyoploye','ru','Tula',5303.0,37.59,53.61).
city('Uzlovaya','ru','Tula',58458.0,38.17,53.98).
city('Venyov','ru','Tula',17090.0,38.27,54.35).
city('Volovo','ru','Tula',4089.0,38.01,53.56).
city('Yasnogorsk','ru','Tula',18023.0,37.7,54.48).
city('Yefremov','ru','Tula',45498.0,38.13,53.15).
city('Yepifan','ru','Tula',2310.0,38.55,53.82).
city('Zadonye','ru','Tula',1410.0,38.38,54.0).
city('Zaokskiy','ru','Tula',6480.0,37.41,54.73).
city('Zhdankovskiy','ru','Tula',3046.0,38.18,53.75).
city('Andreapol','ru','Tver',9209.0,32.27,56.65).
city('Belyy','ru','Tver',4189.0,32.94,55.84).
city('Belyy Gorodok','ru','Tver',2735.0,37.51,56.97).
city('Berezayka','ru','Tver',2432.0,33.9,57.99).
city('Bezhetsk','ru','Tver',28114.0,36.7,57.78).
city('Bologoye','ru','Tver',25142.0,34.05,57.87).
city('Emmauss','ru','Tver',3404.0,36.12,56.78).
city('Firovo','ru','Tver',2746.0,33.7,57.48).
city('Izoplit','ru','Tver',4299.0,36.2,56.63).
city('Kalashnikovo','ru','Tver',5032.0,35.23,57.28).
city('Kalyazin','ru','Tver',14655.0,37.84,57.24).
city('Kashin','ru','Tver',16599.0,37.61,57.36).
city('Kesova Gora','ru','Tver',3946.0,37.29,57.58).
city('Kimry','ru','Tver',52071.0,37.35,56.87).
city('Konakovo','ru','Tver',42240.0,36.77,56.7).
city('Kozlovo','ru','Tver',4248.0,36.29,56.51).
city('Krasnomayskiy','ru','Tver',5611.0,34.42,57.62).
city('Krasnyy Kholm','ru','Tver',6120.0,37.12,58.06).
city('Kuvshinovo','ru','Tver',10960.0,34.18,57.04).
city('Kuzhenkino','ru','Tver',3424.0,33.98,57.74).
city('Lesnoye','ru','Tver',1887.0,35.52,58.29).
city('Likhoslavl','ru','Tver',12290.0,35.46,57.13).
city('Maksatikha','ru','Tver',9441.0,35.88,57.8).
city('Molokovo','ru','Tver',2490.0,36.76,58.17).
city('Nelidovo','ru','Tver',25349.0,32.78,56.22).
city('Novozavidovskiy','ru','Tver',7641.0,36.43,56.55).
city('Olenino','ru','Tver',5079.0,33.5,56.21).
city('Orsha','ru','Tver',2272.0,36.23,56.92).
city('Ostashkov','ru','Tver',19563.0,33.1,57.15).
city('Ozyornyy','ru','Tver',10347.0,33.65,57.9).
city('Peno','ru','Tver',5187.0,32.74,56.92).
city('Radchenko','ru','Tver',2022.0,36.35,56.7).
city('Rameshki','ru','Tver',4110.0,36.05,57.34).
city('Redkino','ru','Tver',11507.0,36.28,56.63).
city('Rzhev','ru','Tver',62247.0,34.33,56.26).
city('Sakharovo','ru','Tver',3790.0,36.05,56.92).
city('Sandovo','ru','Tver',3807.0,36.42,58.47).
city('Selishche','ru','Tver',1328.0,33.26,56.89).
city('Selizharovo','ru','Tver',7096.0,33.46,56.85).
city('Solnechnyy','ru','Tver',2041.0,33.87,57.99).
city('Sonkovo','ru','Tver',4431.0,37.15,57.78).
city('Spirovo','ru','Tver',6640.0,34.98,57.42).
city('Staraya Toropa','ru','Tver',2232.0,31.68,56.28).
city('Staritsa','ru','Tver',9135.0,34.93,56.51).
city('Sukhoverkovo','ru','Tver',706.0,35.56,56.62).
city('Toropets','ru','Tver',14188.0,31.63,56.5).
city('Torzhok','ru','Tver',48547.0,34.97,57.04).
city('Trud','ru','Tver',664.0,33.97,57.61).
city('Tver','ru','Tver',400216.0,35.89,56.86).
city('Udomlya','ru','Tver',32375.0,34.99,57.88).
city('Vasilyevskiy Mokh','ru','Tver',2496.0,36.01,57.03).
city('Velikooktyabrskiy','ru','Tver',2574.0,33.82,57.43).
city('Vesyegonsk','ru','Tver',8467.0,37.27,58.67).
city('Vypolzovo','ru','Tver',1982.0,33.71,57.88).
city('Vyshniy Volochyok','ru','Tver',54374.0,34.56,57.58).
city('Zapadnaya Dvina','ru','Tver',9963.0,32.08,56.26).
city('Zharkovskiy','ru','Tver',4833.0,32.26,55.85).
city('Zubtsov','ru','Tver',7397.0,34.59,56.17).
city('Abatskoye','ru','Tyumen',8195.0,70.46,56.29).
city('Antipino','ru','Tyumen',5147.0,65.73,57.12).
city('Armizonskoye','ru','Tyumen',4711.0,67.67,55.95).
city('Aromashevo','ru','Tyumen',5573.0,68.65,56.87).
city('Berdyuzhye','ru','Tyumen',5223.0,68.31,55.8).
city('Bogandinskiy','ru','Tyumen',9586.0,65.88,56.9).
city('Bolshoye Sorokino','ru','Tyumen',5462.0,69.82,56.63).
city('Borovskiy','ru','Tyumen',15406.0,65.73,57.04).
city('Chervishevo','ru','Tyumen',3113.0,65.42,56.95).
city('Golyshmanovo','ru','Tyumen',13424.0,68.38,56.38).
city('Irtyshskiy','ru','Tyumen',4434.0,68.13,58.33).
city('Isetskoye','ru','Tyumen',7170.0,65.35,56.48).
city('Ishim','ru','Tyumen',67763.0,69.45,56.15).
city('Kazanskoye','ru','Tyumen',5851.0,69.24,55.64).
city('Melioratorov','ru','Tyumen',5306.0,65.61,57.21).
city('Mendeleyevo','ru','Tyumen',4270.0,68.3,58.17).
city('Moskovskiy','ru','Tyumen',3450.0,65.43,57.11).
city('Nizhnyaya Tavda','ru','Tyumen',6711.0,66.17,57.67).
city('Novaya Zaimka','ru','Tyumen',4202.0,66.92,56.49).
city('Novoseleznevo','ru','Tyumen',3377.0,69.2,55.68).
city('Omutinskoye','ru','Tyumen',9595.0,67.67,56.48).
city('Onokhino','ru','Tyumen',3012.0,65.53,56.93).
city('Sladkovo','ru','Tyumen',3455.0,70.33,55.53).
city('Sumkino','ru','Tyumen',4186.0,68.32,58.11).
city('Tobolsk','ru','Tyumen',93651.0,68.27,58.2).
city('Turtas','ru','Tyumen',5050.0,69.13,58.94).
city('Tyumen','ru','Tyumen',519124.0,65.53,57.15).
city('Uporovo','ru','Tyumen',5299.0,66.27,56.31).
city('Uspenka','ru','Tyumen',3217.0,69.23,56.8).
city('Uvat','ru','Tyumen',4581.0,68.9,59.14).
city('Vagay','ru','Tyumen',4951.0,69.01,57.93).
city('Vikulovo','ru','Tyumen',6952.0,70.62,56.82).
city('Vinzili','ru','Tyumen',11219.0,65.77,56.97).
city('Yalutorovsk','ru','Tyumen',35892.0,66.3,56.67).
city('Yarkovo','ru','Tyumen',6925.0,67.08,57.4).
city('Yurginskoye','ru','Tyumen',4606.0,67.39,56.82).
city('Zavodoukovsk','ru','Tyumen',25683.0,66.54,56.51).
city('Ak-Dovurak','ru','Tyva',12593.0,90.6,51.18).
city('Balgazyn','ru','Tyva',3342.0,95.2,51.0).
city('Bay-Khaak','ru','Tyva',3058.0,94.5,51.17).
city('Chaa-Khol','ru','Tyva',3424.0,92.48,51.57).
city('Chadan','ru','Tyva',9247.0,91.58,51.0).
city('Erzin','ru','Tyva',2952.0,95.17,50.25).
city('Kaa-Khem','ru','Tyva',10375.0,94.73,51.68).
city('Khandagayty','ru','Tyva',3146.0,92.05,50.73).
city('Khovu-Aksy','ru','Tyva',3675.0,93.6,51.13).
city('Kungurtug','ru','Tyva',1820.0,97.52,50.6).
city('Kyzyl','ru','Tyva',108241.0,94.38,51.71).
city('Kyzyl-Mazhalyk','ru','Tyva',5004.0,90.6,51.13).
city('Mugur-Aksy','ru','Tyva',4012.0,90.5,50.35).
city('Samagaltay','ru','Tyva',3477.0,95.05,50.6).
city('Saryg-Sep','ru','Tyva',4582.0,95.6,51.5).
city('Shagonar','ru','Tyva',11415.0,92.8,51.53).
city('Sug-Aksy','ru','Tyva',3051.0,91.28,51.4).
city('Sukpak','ru','Tyva',3648.0,94.63,51.67).
city('Teeli','ru','Tyva',3732.0,90.23,51.03).
city('Toora-Khem','ru','Tyva',2214.0,96.11,52.47).
city('Turan','ru','Tyva',5528.0,93.92,52.15).
city('Alnashi','ru','Udmurtia',6205.0,52.48,56.19).
city('Balezino','ru','Udmurtia',16618.0,52.99,57.99).
city('Debyosy','ru','Udmurtia',5763.0,53.81,57.66).
city('Fakel','ru','Udmurtia',2006.0,53.03,57.63).
city('Glazov','ru','Udmurtia',100677.0,52.66,58.14).
city('Grakhovo','ru','Udmurtia',3400.0,51.97,56.04).
city('Igra','ru','Udmurtia',22033.0,53.04,57.56).
city('Izhevsk','ru','Udmurtia',631044.0,53.23,56.85).
city('Kama','ru','Udmurtia',3439.0,54.18,56.3).
city('Kambarka','ru','Udmurtia',12464.0,54.18,56.25).
city('Karakulino','ru','Udmurtia',5052.0,53.7,56.01).
city('Kez','ru','Udmurtia',10792.0,53.72,57.9).
city('Khokhryaki','ru','Udmurtia',3544.0,53.32,56.92).
city('Kilmez','ru','Udmurtia',3106.0,51.33,57.01).
city('Kiyasovo','ru','Udmurtia',3265.0,53.13,56.35).
city('Kizner','ru','Udmurtia',9847.0,51.51,56.28).
city('Krasnogorskoye','ru','Udmurtia',4508.0,52.5,57.7).
city('Malaya Purga','ru','Udmurtia',6803.0,53.0,56.55).
city('Mozhga','ru','Udmurtia',47271.0,52.19,56.45).
city('Pirogovo','ru','Udmurtia',3363.0,53.16,56.78).
city('Pudem','ru','Udmurtia',2278.0,52.17,58.3).
city('Pychas','ru','Udmurtia',3183.0,52.44,56.5).
city('Sarapul','ru','Udmurtia',101346.0,53.8,56.47).
city('Selty','ru','Udmurtia',5523.0,52.14,57.31).
city('Sharkan','ru','Udmurtia',6523.0,53.88,57.3).
city('Sigayevo','ru','Udmurtia',5780.0,53.78,56.42).
city('Syumsi','ru','Udmurtia',5582.0,51.61,57.11).
city('Uva','ru','Udmurtia',19143.0,52.19,56.99).
city('Vavozh','ru','Udmurtia',5569.0,51.92,56.77).
city('Votkinsk','ru','Udmurtia',98635.0,53.99,57.04).
city('Yakshur-Bodya','ru','Udmurtia',6867.0,53.16,57.18).
city('Yar','ru','Udmurtia',7122.0,52.11,58.25).
city('Yukamenskoye','ru','Udmurtia',4278.0,52.25,57.89).
city('Zavyalovo','ru','Udmurtia',7374.0,53.37,56.79).
city('Barysh','ru','Ulyanovsk',18547.0,47.13,53.65).
city('Bazarnyy Syzgan','ru','Ulyanovsk',6039.0,46.76,53.75).
city('Bolshiye Klyuchishchi','ru','Ulyanovsk',3691.0,48.23,54.13).
city('Bolshoye Nagatkino','ru','Ulyanovsk',5189.0,47.97,54.52).
city('Cherdakly','ru','Ulyanovsk',11939.0,48.83,54.33).
city('Chufarovo','ru','Ulyanovsk',2671.0,47.34,54.1).
city('Dimitrovgrad','ru','Ulyanovsk',132228.0,49.55,54.25).
city('Glotovka','ru','Ulyanovsk',3039.0,46.7,53.95).
city('Ignatovka','ru','Ulyanovsk',2853.0,47.65,53.95).
city('Imeni Lenina','ru','Ulyanovsk',2889.0,46.97,53.57).
city('Inza','ru','Ulyanovsk',19737.0,46.36,53.85).
city('Isheyevka','ru','Ulyanovsk',9944.0,48.27,54.42).
city('Izmaylovo','ru','Ulyanovsk',3075.0,47.24,53.72).
city('Kanadey','ru','Ulyanovsk',2076.0,47.53,53.16).
city('Karsun','ru','Ulyanovsk',8128.0,46.98,54.18).
city('Krasnyy Gulyay','ru','Ulyanovsk',3080.0,48.33,54.03).
city('Kuzovatovo','ru','Ulyanovsk',8607.0,47.67,53.54).
city('Mayna','ru','Ulyanovsk',7904.0,47.62,54.12).
city('Mirnyy','ru','Ulyanovsk',3171.0,48.75,54.37).
city('Mullovka','ru','Ulyanovsk',6383.0,49.4,54.2).
city('Nikolayevka','ru','Ulyanovsk',6419.0,47.2,53.12).
city('Nikolskoye-na-Cheremshane','ru','Ulyanovsk',1967.0,49.23,54.05).
city('Novaya Malykla','ru','Ulyanovsk',3292.0,49.95,54.2).
city('Novaya Mayna','ru','Ulyanovsk',6448.0,49.75,54.15).
city('Novocheremshansk','ru','Ulyanovsk',3294.0,50.17,54.35).
city('Novospasskoye','ru','Ulyanovsk',10941.0,47.76,53.15).
city('Novoulyanovsk','ru','Ulyanovsk',17722.0,48.38,54.17).
city('Oktyabrskiy','ru','Ulyanovsk',6679.0,48.73,54.35).
city('Pavlovka','ru','Ulyanovsk',5878.0,46.76,53.6).
city('Radishchevo','ru','Ulyanovsk',4845.0,47.88,52.85).
city('Sengiley','ru','Ulyanovsk',8018.0,48.79,53.96).
city('Silikatnyy','ru','Ulyanovsk',3614.0,48.33,54.02).
city('Staraya Kulatka','ru','Ulyanovsk',6022.0,47.62,52.72).
city('Staraya Mayna','ru','Ulyanovsk',6927.0,48.95,54.6).
city('Starotimoshkino','ru','Ulyanovsk',4061.0,47.53,53.72).
city('Surskoye','ru','Ulyanovsk',7324.0,46.73,54.47).
city('Terenga','ru','Ulyanovsk',5461.0,48.37,53.72).
city('Tsilna','ru','Ulyanovsk',4128.0,48.15,54.6).
city('Ulyanovsk','ru','Ulyanovsk',640685.0,48.4,54.33).
city('Undory','ru','Ulyanovsk',3376.0,48.37,54.62).
city('Veshkayma','ru','Ulyanovsk',7087.0,47.11,54.05).
city('Yazykovo','ru','Ulyanovsk',4918.0,47.37,54.29).
city('Zhadovka','ru','Ulyanovsk',2098.0,46.95,53.57).
city('Bayanday','ru','Ust-Ordyn Buryat',2854.0,105.51,53.07).
city('Bokhan','ru','Ust-Ordyn Buryat',5387.0,103.77,53.16).
city('Kutulik','ru','Ust-Ordyn Buryat',5390.0,102.78,53.35).
city('Novonukutskiy','ru','Ust-Ordyn Buryat',3121.0,102.71,53.7).
city('Osa','ru','Ust-Ordyn Buryat',4454.0,103.88,53.39).
city('Ust-Ordynskiy','ru','Ust-Ordyn Buryat',14538.0,104.75,52.8).
city('Aleksandrov','ru','Vladimir',64089.0,38.72,56.4).
city('Andreyevo','ru','Vladimir',5204.0,41.15,55.95).
city('Anopino','ru','Vladimir',1972.0,40.67,55.7).
city('Balakirevo','ru','Vladimir',8932.0,38.85,56.5).
city('Bavleny','ru','Vladimir',3209.0,39.57,56.4).
city('Belaya Rechka','ru','Vladimir',2603.0,39.36,56.3).
city('Bogolyubovo','ru','Vladimir',4121.0,40.53,56.2).
city('Dobryatino','ru','Vladimir',1934.0,41.32,55.51).
city('Galitsy','ru','Vladimir',1060.0,42.85,56.19).
city('Golovino','ru','Vladimir',2990.0,40.43,55.97).
city('Gorokhovets','ru','Vladimir',14247.0,42.7,56.19).
city('Gus-Khrustalnyy','ru','Vladimir',65268.0,40.67,55.62).
city('Gusevskiy','ru','Vladimir',3473.0,40.57,55.67).
city('Imeni Vorovskogo','ru','Vladi',2110.0,41.1,55.72).
city('Ivanishchi','ru','Vladimir',2149.0,40.43,55.77).
city('Kameshkovo','ru','Vladimir',13935.0,41.0,56.35).
city('Karabanovo','ru','Vladimir',15615.0,38.7,56.32).
city('Kirzhach','ru','Vladimir',22131.0,38.87,56.17).
city('Kolchugino','ru','Vladimir',47080.0,39.38,56.3).
city('Kommunar','ru','Vladimir',3135.0,40.43,56.12).
city('Kosterevo','ru','Vladimir',9350.0,39.62,55.93).
city('Kovrov','ru','Vladimir',154226.0,41.32,56.36).
city('Krasnaya Gorbatka','ru','Vladimir',9225.0,41.76,55.88).
city('Krasnoye Yekho','ru','Vladimir',2242.0,40.7,55.8).
city('Krasnyy Bogatyr','ru','Vladimir',1019.0,41.13,56.02).
city('Krasnyy Mayak','ru','Vladimir',856.0,41.38,56.05).
city('Krasnyy Oktyabr','ru','Vladimir',5594.0,40.13,56.11).
city('Kurlovo','ru','Vladimir',7263.0,40.48,55.43).
city('Lakinsk','ru','Vladimir',16706.0,39.95,56.02).
city('Luknovo','ru','Vladimir',2614.0,42.04,56.2).
city('Melekhovo','ru','Vladimir',6922.0,41.28,56.28).
city('Melenki','ru','Vladimir',15902.0,41.63,55.34).
city('Mezinovskiy','ru','Vladimir',2116.0,40.35,55.5).
city('Mstera','ru','Vladimir',5470.0,41.92,56.38).
city('Murom','ru','Vladimir',126932.0,42.04,55.57).
city('Nikologory','ru','Vladimir',6244.0,42.0,56.14).
city('Novki','ru','Vladimir',1639.0,41.1,56.37).
city('Novovyazniki','ru','Vladimir',5611.0,42.17,56.2).
city('Oktyabrskiy','ru','Vladimir',2052.0,42.03,56.24).
city('Orgtrud','ru','Vladimir',4393.0,40.61,56.18).
city('Petushki','ru','Vladimir',15866.0,39.47,55.93).
city('Pokrov','ru','Vladimir',15867.0,39.18,55.91).
city('Sobinka','ru','Vladimir',20459.0,40.02,55.98).
city('Stavrovo','ru','Vladimir',7822.0,40.0,56.13).
city('Stepantsevo','ru','Vladimir',2744.0,41.7,56.13).
city('Strunino','ru','Vladimir',15484.0,38.57,56.38).
city('Sudogda','ru','Vladimir',13277.0,40.86,55.95).
city('Suzdal','ru','Vladimir',11183.0,40.44,56.43).
city('Urshelskiy','ru','Vladimir',4576.0,40.22,55.68).
city('Velikodvorskiy','ru','Vladimir',2218.0,40.68,55.25).
city('Vladimir','ru','Vladimir',310027.0,40.4,56.14).
city('Volginskiy','ru','Vladimir',6151.0,39.23,55.97).
city('Vyazniki','ru','Vladimir',39244.0,42.17,56.25).
city('Yuryev-Polskiy','ru','Vladimir',19414.0,39.67,56.5).
city('Yuryevets','ru','Vladimir',11352.0,40.27,56.1).
city('Zolotkovo','ru','Vladimir',3655.0,41.1,55.53).
city('Alekseyevskaya','ru','Volgograd',4205.0,42.18,50.28).
city('Antipovka','ru','Volgograd',3021.0,45.33,49.83).
city('Bereslavka','ru','Volgograd',4817.0,44.06,48.63).
city('Bolshiye Chapurniki','ru','Volgograd',3212.0,44.58,48.42).
city('Bykovo','ru','Volgograd',8268.0,45.38,49.77).
city('Chernyshkovskiy','ru','Volgograd',5458.0,42.22,48.42).
city('Danilovka','ru','Volgograd',5956.0,44.1,50.35).
city('Dubovka','ru','Volgograd',15218.0,44.81,49.06).
city('Frolovo','ru','Volgograd',40882.0,43.65,49.77).
city('Gorkovskiy','ru','Volgograd',15315.0,44.4,48.69).
city('Gorodishche','ru','Volgograd',19509.0,44.51,48.81).
city('Gumrak','ru','Volgograd',5227.0,44.37,48.79).
city('Ilovlya','ru','Volgograd',11930.0,43.98,49.3).
city('Kalach-na-Donu','ru','Volgograd',27522.0,43.5,48.71).
city('Kamyshin','ru','Volgograd',128628.0,45.4,50.1).
city('Kletskaya','ru','Volgograd',5362.0,43.06,49.31).
city('Kotelnikovo','ru','Volgograd',19424.0,43.15,47.63).
city('Kotovo','ru','Volgograd',26981.0,44.82,50.3).
city('Krasnooktyabrskiy','ru','Volgograd',11080.0,44.76,48.87).
city('Krasnoslobodsk','ru','Volgograd',14334.0,44.57,48.71).
city('Krasnyy Yar','ru','Volgograd',7727.0,44.72,50.7).
city('Kumylzhenskaya','ru','Volgograd',8061.0,42.59,49.88).
city('Leninsk','ru','Volgograd',15167.0,45.2,48.71).
city('Linyovo','ru','Volgograd',6712.0,44.82,50.88).
city('Log','ru','Volgograd',3695.0,43.86,49.49).
city('Medveditskiy','ru','Volgograd',1475.0,44.72,50.78).
city('Mikhaylovka','ru','Volgograd',59993.0,43.22,50.06).
city('Nekhayevskiy','ru','Volgograd',4714.0,41.74,50.4).
city('Nikolajevsk','ru','Volgograd',16044.0,45.43,50.02).
city('Nizhniy Chir','ru','Volgograd',4765.0,43.09,48.36).
city('Novoanninskiy','ru','Volgograd',19231.0,42.68,50.53).
city('Novonikolayevskiy','ru','Volgograd',10251.0,42.36,50.98).
city('Novyy Rogachik','ru','Volgograd',7575.0,44.05,48.67).
city('Oktyabrskiy','ru','Volgograd',5688.0,44.1,48.8).
city('Olkhovka','ru','Volgograd',5314.0,44.57,49.87).
city('Pallasovka','ru','Volgograd',17139.0,46.88,50.05).
city('Petrov Val','ru','Volgograd',14853.0,45.2,50.15).
city('Preobrazhenskaya','ru','Volgograd',5475.0,43.05,50.73).
city('Primorsk','ru','Volgograd',3235.0,45.0,49.27).
city('Rudnya','ru','Volgograd',8062.0,44.57,50.8).
city('Savinka','ru','Volgograd',3449.0,47.1,50.07).
city('Sebrovo','ru','Volgograd',4496.0,43.3,50.1).
city('Serafimovich','ru','Volgograd',9847.0,42.73,49.58).
city('Srednyaya Akhtuba','ru','Volgograd',13887.0,44.87,48.71).
city('Staraya Poltavka','ru','Volgograd',4068.0,46.47,50.47).
city('Surovikino','ru','Volgograd',20678.0,42.85,48.61).
city('Svetlyy Yar','ru','Volgograd',13131.0,44.79,48.48).
city('Uryupinsk','ru','Volgograd',41645.0,42.0,50.78).
city('Vodstroy','ru','Volgograd',4173.0,44.57,48.85).
city('Volgograd','ru','Volgograd',1010331.0,44.48,48.71).
city('Volzhskiy','ru','Volgograd',323298.0,44.77,48.79).
city('Yelan','ru','Volgograd',15181.0,43.73,50.95).
city('Yorzovka','ru','Volgograd',5634.0,44.63,48.93).
city('Zaplavnoye','ru','Volgograd',3693.0,45.02,48.69).
city('Zhirnovsk','ru','Volgograd',17887.0,44.77,50.98).
city('Babajevo','ru','Vologda',12294.0,35.94,59.39).
city('Belozyorsk','ru','Vologda',10676.0,37.79,60.04).
city('Chagoda','ru','Vologda',7288.0,35.35,59.17).
city('Chebsara','ru','Vologda',1742.0,38.83,59.2).
city('Cherepovets','ru','Vologda',311854.0,37.9,59.13).
city('Gryazovets','ru','Vologda',16133.0,40.25,58.88).
city('Imeni Babushkina','ru','Vologda',4026.0,43.12,59.76).
city('Imeni Zhelyabova','ru','Vologda',1261.0,36.6,58.95).
city('Kadnikov','ru','Vologda',5312.0,40.34,59.5).
city('Kaduy','ru','Vologda',11570.0,37.15,59.2).
city('Kharovsk','ru','Vologda',11115.0,40.19,59.96).
city('Khokhlovo','ru','Vologda',2478.0,37.4,59.15).
city('Kichmengskiy Gorodok','ru','Vologda',6624.0,45.8,59.98).
city('Kirillov','ru','Vologda',8236.0,38.38,59.87).
city('Krasavino','ru','Vologda',7912.0,46.47,60.97).
city('Kuzino','ru','Vologda',1423.0,38.28,59.78).
city('Lipin Bor','ru','Vologda',3771.0,37.95,60.27).
city('Molochnoye','ru','Vologda',8421.0,39.68,59.28).
city('Nikolsk','ru','Vologda',8656.0,45.45,59.5).
city('Nyuksenitsa','ru','Vologda',4322.0,44.24,60.41).
city('Sazonovo','ru','Vologda',3509.0,35.23,59.09).
city('Sheksna','ru','Vologda',21197.0,38.5,59.22).
city('Shuyskoye','ru','Vologda',2389.0,41.02,59.37).
city('Sokol','ru','Vologda',42174.0,40.12,59.46).
city('Suda','ru','Vologda',5582.0,37.55,59.15).
city('Syamzha','ru','Vologda',3856.0,41.07,60.02).
city('Tarnogskiy Gorodok','ru','Vologda',5432.0,43.58,60.5).
city('Totma','ru','Vologda',10502.0,42.76,59.97).
city('Ustye','ru','Vologda',4068.0,39.73,59.63).
city('Ustyuzhna','ru','Vologda',10566.0,36.43,58.85).
city('Velikiy Ustyug','ru','Vologda',32642.0,46.3,60.77).
city('Verkhovazhye','ru','Vologda',5105.0,42.05,60.74).
city('Vokhtoga','ru','Vologda',7107.0,41.05,58.81).
city('Vologda','ru','Vologda',294892.0,39.9,59.22).
city('Vozhega','ru','Vologda',6703.0,40.21,60.47).
city('Vytegra','ru','Vologda',11100.0,36.4,61.0).
city('Abramovka','ru','Voronezh',3396.0,41.02,51.19).
city('Anna','ru','Voronezh',19148.0,40.43,51.49).
city('Bobrov','ru','Voronezh',20587.0,40.03,51.1).
city('Boguchar','ru','Voronezh',15048.0,40.56,49.94).
city('Borisoglebsk','ru','Voronezh',68598.0,42.09,51.37).
city('Buturlinovka','ru','Voronezh',28581.0,40.61,50.82).
city('Davydovka','ru','Voronezh',5841.0,39.43,51.16).
city('Devitsa','ru','Voronezh',4389.0,38.95,51.64).
city('Drakino','ru','Voronezh',3071.0,39.41,51.13).
city('Ertil','ru','Voronezh',12622.0,40.81,51.86).
city('Georgiu-Dezh','ru','Voronezh',55940.0,39.56,50.98).
city('Gremyachye','ru','Voronezh',3383.0,38.8,51.97).
city('Gribanovskiy','ru','Voronezh',17220.0,41.97,51.46).
city('Kalachinsk','ru','Voronezh',20552.0,41.01,50.43).
city('Kamenka','ru','Voronezh',9450.0,42.77,51.32).
city('Kantemirovka','ru','Voronezh',12770.0,39.86,49.7).
city('Kashirskoye','ru','Voronezh',4564.0,39.59,51.41).
city('Khokhol','ru','Voronezh',4876.0,38.71,51.54).
city('Khokholskiy','ru','Voronezh',7776.0,38.77,51.56).
city('Khrenovoye','ru','Voronezh',5476.0,40.29,51.12).
city('Kolodeznyy','ru','Voronezh',5857.0,39.18,51.33).
city('Kozlovka','ru','Voronezh',3343.0,40.44,50.86).
city('Krasnolesnyy','ru','Voronezh',5305.0,39.59,51.88).
city('Latnaya','ru','Voronezh',7232.0,38.9,51.66).
city('Losevo','ru','Voronezh',4476.0,40.05,50.68).
city('Maslovka','ru','Voronezh',7518.0,39.23,51.55).
city('Maslovskiy','ru','Voronezh',3436.0,39.34,51.54).
city('Mitrofanovka','ru','Voronezh',5643.0,39.7,49.97).
city('Nikolskoye','ru','Voronezh',5309.0,39.3,51.58).
city('Nizhnedevitsk','ru','Voronezh',6320.0,38.36,51.54).
city('Nizhniy Kislyay','ru','Voronezh',4394.0,40.17,50.86).
city('Nizhniy Mamon','ru','Voronezh',3914.0,40.5,50.19).
city('Novaya Chigla','ru','Voronezh',2978.0,40.48,51.22).
city('Novaya Usman','ru','Voronezh',22165.0,39.42,51.64).
city('Novokhopyorsk','ru','Voronezh',7515.0,41.63,51.1).
city('Novokhopyorskiy','ru','Voronezh',7666.0,41.57,51.08).
city('Novovoronezh','ru','Voronezh',37392.0,39.22,51.32).
city('Olkhovatka','ru','Voronezh',4363.0,39.29,50.28).
city('Orlovo','ru','Voronezh',4047.0,39.59,51.75).
city('Ostrogozhsk','ru','Voronezh',34403.0,39.08,50.87).
city('Otradnoye','ru','Voronezh',3215.0,145.86,44.07).
city('Panino','ru','Voronezh',7164.0,40.14,51.65).
city('Pavlovsk','ru','Voronezh',26566.0,40.11,50.46).
city('Pereleshino','ru','Voronezh',3795.0,40.13,51.74).
city('Pereleshinskiy','ru','Voronezh',3257.0,40.18,51.7).
city('Pervoye Maya','ru','Voronezh',4512.0,39.59,50.89).
city('Peski','ru','Voronezh',7230.0,42.43,51.23).
city('Petropavlovka','ru','Voronezh',5469.0,40.84,50.04).
city('Podgorenskiy','ru','Voronezh',6652.0,39.64,50.41).
city('Podgornoye','ru','Voronezh',5754.0,39.39,51.08).
city('Podkletnoye','ru','Voronezh',3070.0,39.45,51.59).
city('Povorino','ru','Voronezh',18004.0,42.25,51.2).
city('Pridonskoy','ru','Voronezh',16896.0,39.06,51.68).
city('Ramon','ru','Voronezh',7928.0,39.33,51.92).
city('Repyovka','ru','Voronezh',5823.0,38.65,51.08).
city('Rossosh','ru','Voronezh',64324.0,38.51,51.14).
city('Sadovoye','ru','Voronezh',5011.0,40.5,51.53).
city('Semiluki','ru','Voronezh',26257.0,39.02,51.69).
city('Shilovo','ru','Voronezh',6728.0,39.09,51.55).
city('Sloboda','ru','Voronezh',3519.0,40.31,51.14).
city('Somovo','ru','Voronezh',13729.0,39.36,51.73).
city('Sredniy Ikorets','ru','Voronezh',3273.0,39.76,51.07).
city('Strelitsa','ru','Voronezh',4761.0,38.92,51.6).
city('Talovaya','ru','Voronezh',13367.0,40.73,51.11).
city('Ternovka','ru','Voronezh',4703.0,41.62,51.67).
city('Uglyanets','ru','Voronezh',3647.0,39.59,51.82).
city('Verkhniy Mamon','ru','Voronezh',8278.0,40.41,50.17).
city('Verkhnyaya Khava','ru','Voronezh',7870.0,39.93,51.84).
city('Verkhnyaya Tishanka','ru','Voronezh',3602.0,40.53,51.32).
city('Volya','ru','Voronezh',7869.0,39.52,51.75).
city('Vorobyevka','ru','Voronezh',4420.0,40.95,50.64).
city('Voronezh','ru','Voronezh',840590.0,39.26,51.72).
city('Vorontsovka','ru','Voronezh',5067.0,40.37,50.62).
city('Yelan-Koleno','ru','Voronezh',5270.0,41.22,51.15).
city('Yelan-Kolenovskiy','ru','Voronezh',4112.0,41.23,51.13).
city('Zabolotovka','ru','Voronezh',3308.0,39.32,50.28).
city('Zemlyansk','ru','Voronezh',3111.0,38.74,51.9).
city('Aldan','ru','Yakutia',24426.0,125.39,58.6).
city('Allakh-Yun','ru','Yakutia',296.0,138.05,61.13).
city('Almaznyy','ru','Yakutia',1699.0,114.33,62.45).
city('Amga','ru','Yakutia',6151.0,131.96,60.9).
city('Artyk','ru','Yakutia',612.0,145.1,64.2).
city('Aykhal','ru','Yakutia',15267.0,111.5,66.0).
city('Batagay','ru','Yakutia',4439.0,134.65,67.66).
city('Batagay-Alyta','ru','Yakutia',1666.0,130.41,67.8).
city('Belaya Gora','ru','Yakutia',2383.0,146.42,68.53).
city('Berdigestyakh','ru','Yakutia',5948.0,126.7,62.1).
city('Berkakit','ru','Yakutia',4764.0,124.8,56.55).
city('Bezymyannyy','ru','Yakutia',107.0,126.25,58.76).
city('Bolshoy Nimnyr','ru','Yakutia',463.0,125.48,58.04).
city('Borogontsy','ru','Yakutia',5280.0,131.17,62.67).
city('Brindakit','ru','Yakutia',15.0,137.55,59.98).
city('Chagda','ru','Yakutia',568.0,130.63,58.75).
city('Chernyshevskiy','ru','Yakutia',5137.0,112.47,63.01).
city('Cherskiy','ru','Yakutia',3707.0,161.3,68.75).
city('Chokurdakh','ru','Yakutia',2506.0,147.87,70.62).
city('Chulman','ru','Yakutia',10430.0,124.91,56.85).
city('Churapcha','ru','Yakutia',7280.0,132.43,62.0).
city('Deputatskiy','ru','Yakutia',3484.0,139.9,69.3).
city('Dzhebariki-Khaya','ru','Yakutia',2056.0,135.8,62.22).
city('Eldikan','ru','Yakutia',2050.0,135.18,60.8).
city('Elginskiy','ru','Yakutia',379.0,141.78,64.58).
city('Ese-Khayya','ru','Yakutia',332.0,134.67,67.52).
city('Jakutskaj','ru','Yakutia',215065.0,129.73,62.03).
city('Kangalassy','ru','Yakutia',1721.0,129.96,62.35).
city('Kankunskiy','ru','Yakutia',95.0,126.1,57.63).
city('Khandyga','ru','Yakutia',6796.0,135.6,62.67).
city('Khani','ru','Yakutia',903.0,120.97,57.03).
city('Khatassy','ru','Yakutia',3676.0,129.64,61.9).
city('Khonuu','ru','Yakutia',2413.0,143.22,66.45).
city('Kysyl-Syr','ru','Yakutia',3491.0,122.76,63.88).
city('Lebedinyy','ru','Yakutia',1213.0,125.49,58.5).
city('Leninskiy','ru','Yakutia',2043.0,125.43,58.58).
city('Lensk','ru','Yakutia',23695.0,114.93,60.73).
city('Magan','ru','Yakutia',1686.0,129.53,62.11).
city('Markha','ru','Yakutia',11648.0,129.76,62.1).
city('Mayya','ru','Yakutia',6794.0,130.28,61.73).
city('Mirnyy','ru','Yakutia',40309.0,113.96,62.54).
city('Mokhsogollokh','ru','Yakutia',6947.0,128.92,61.47).
city('Nago','ru','Yakutia',147.0,124.95,55.97).
city('Namtsy','ru','Yakutia',7980.0,129.67,62.72).
city('Nelkan','ru','Yakutia',135.0,142.97,64.25).
city('Neryungri','ru','Yakutia',66325.0,124.71,56.67).
city('Nizhneyansk','ru','Yakutia',678.0,136.07,71.43).
city('Nizhniy Bestyakh','ru','Yakutia',3218.0,129.91,61.95).
city('Nizhniy Kuranakh','ru','Yakutia',6798.0,125.49,58.84).
city('Nyurba','ru','Yakutia',9972.0,118.33,63.28).
city('Olenyok','ru','Yakutia',2155.0,112.45,68.5).
city('Olyokminsk','ru','Yakutia',9648.0,120.2,60.38).
city('Peleduy','ru','Yakutia',4556.0,112.74,59.63).
city('Pokrovsk','ru','Yakutia',9763.0,129.13,61.48).
city('Predporozhnyy','ru','Yakutia',239.0,143.2,65.17).
city('Sangar','ru','Yakutia',4633.0,127.47,63.92).
city('Sarylakh','ru','Yakutia',189.0,142.75,64.42).
city('Saskylakh','ru','Yakutia',1920.0,114.08,71.92).
city('Serebryanyy Bor','ru','Yakutia',4302.0,124.8,56.8).
city('Severnyy','ru','Yakutia',74.0,138.03,66.33).
city('Solnechnyy','ru','Yakutia',1230.0,137.5,60.42).
city('Srednekolymsk','ru','Yakutia',3459.0,153.68,67.45).
city('Suntar','ru','Yakutia',8639.0,117.63,62.16).
city('Tabaga','ru','Yakutia',3624.0,129.6,61.4).
city('Tiksi','ru','Yakutia',5681.0,128.87,71.63).
city('Tommot','ru','Yakutia',9034.0,126.28,58.97).
city('Torgo','ru','Yakutia',94.0,119.53,58.45).
city('Udachnyy','ru','Yakutia',15266.0,112.4,66.42).
city('Ust-Kuyga','ru','Yakutia',1517.0,135.6,70.02).
city('Ust-Maya','ru','Yakutia',3062.0,134.53,60.42).
city('Ust-Nera','ru','Yak',9148.0,143.2,64.57).
city('Verkhnevilyuysk','ru','Yakutia',6341.0,120.32,63.45).
city('Verkhoyansk','ru','Yakutia',1388.0,133.39,67.54).
city('Vilyuysk','ru','Yakutia',9949.0,121.62,63.76).
city('Vitim','ru','Yakutia',3843.0,112.56,59.45).
city('Yllymakh','ru','Yakutia',484.0,126.7,58.58).
city('Ynykchan','ru','Yakutia',379.0,137.72,60.25).
city('Ytyk-Kyuyol','ru','Yakutia',6062.0,133.47,62.33).
city('Yugoryonok','ru','Yakutia',875.0,137.67,59.78).
city('Zhatay','ru','Yakutia',8131.0,129.83,62.16).
city('Zhigansk','ru','Yakutia',3237.0,123.37,66.77).
city('Zolotinka','ru','Yakutia',548.0,124.85,56.21).
city('Zvyozdochka','ru','Yakutia',548.0,137.75,60.5).
city('Zyryanka','ru','Yakutia',3627.0,150.84,65.74).
city('Aksarka','ru','Yamalo-Nenets',2576.0,67.8,66.56).
city('Gubkinskiy','ru','Yamalo-Nenets',20463.0,76.62,64.46).
city('Kharp','ru','Yamalo-Nenets',7298.0,65.81,66.8).
city('Korotchayevo','ru','Yamalo-Nenets',7017.0,78.19,65.97).
city('Krasnoselkup','ru','Yamalo-Nenets',4025.0,82.47,65.7).
city('Labytnangi','ru','Yamalo-Nenets',27067.0,66.42,66.66).
city('Muravlenko','ru','Yamalo-Nenets',39137.0,73.5,63.78).
city('Muzhi','ru','Yamalo-Nenets',3209.0,64.67,65.37).
city('Nadym','ru','Yamalo-Nenets',46339.0,72.52,65.53).
city('Novyy Urengoy','ru','Yamalo-Nenets',94214.0,76.51,66.09).
city('Noyabrsk','ru','Yamalo-Nenets',98278.0,75.62,63.17).
city('Pangody','ru','Yamalo-Nenets',10898.0,74.83,65.92).
city('Purpe','ru','Yamalo-Nenets',9099.0,76.69,64.48).
city('Salekhard','ru','Yamalo-Nenets',38026.0,66.6,66.53).
city('Staryy Nadym','ru','Yamalo-Nenets',2766.0,72.78,65.67).
city('Tarko-Sale','ru','Yamalo-Nenets',18568.0,77.79,64.92).
city('Tazovskiy','ru','Yamalo-Nenets',5981.0,78.7,67.47).
city('Urengoy','ru','Yamalo-Nenets',9355.0,78.42,65.97).
city('Yar-Sale','ru','Yamalo-Nenets',4885.0,70.83,66.83).
city('Bolshoye Selo','ru','Yaroslavl',3643.0,38.94,57.72).
city('Borisoglebskiy','ru','Yaroslavl',5832.0,39.15,57.26).
city('Breytovo','ru','Yaroslavl',3632.0,37.87,58.3).
city('Burmakino','ru','Yaroslavl',3318.0,40.23,57.42).
city('Danilov','ru','Yaroslavl',16808.0,40.18,58.18).
city('Dubki','ru','Yaroslavl',3385.0,40.25,57.3).
city('Gavrilov-Yam','ru','Yaroslavl',18618.0,39.85,57.3).
city('Ishnya','ru','Yaroslavl',3297.0,39.42,57.18).
city('Konstantinovskiy','ru','Yaroslavl',5718.0,39.6,57.82).
city('Krasnyy Profintern','ru','Yaroslavl',1468.0,40.43,57.75).
city('Krasnyye Tkachi','ru','Yaroslavl',4054.0,39.75,57.5).
city('Kuznechikha','ru','Yaroslavl',3227.0,42.31,57.22).
city('Lyubim','ru','Yaroslavl',6057.0,40.69,58.36).
city('Myshkin','ru','Yaroslavl',6061.0,38.45,57.79).
city('Nekrasovskoye','ru','Yaroslavl',6353.0,40.36,57.68).
city('Novyy Nekouz','ru','Yaroslavl',3629.0,38.07,57.91).
city('Pereslavl-Zalesskiy','ru','Yaroslavl',43490.0,38.85,56.73).
city('Pesochnoye','ru','Yaroslavl',3005.0,39.16,58.01).
city('Petrovskoye','ru','Yaroslavl',5324.0,39.27,57.01).
city('Porechye-Rybnoye','ru','Yaroslavl',1836.0,39.38,57.1).
city('Poshekhonye','ru','Yaroslavl',6813.0,39.13,58.5).
city('Prechistoye','ru','Yaroslavl',4985.0,40.34,50.42).
city('Rostov','ru','Yaroslavl',33804.0,39.4,57.19).
city('Rybinsk','ru','Yaroslavl',216726.0,38.83,58.05).
city('Semibratovo','ru','Yaroslavl',7511.0,39.54,57.31).
city('Tunoshna','ru','Yaroslavl',3152.0,40.13,57.55).
city('Tutayev','ru','Yaroslavl',43828.0,39.55,57.89).
city('Uglich','ru','Yaroslavl',37733.0,38.33,57.53).
city('Volga','ru','Yaroslavl',3469.0,38.4,57.95).
city('Yaroslavl','ru','Yaroslavl',606735.0,39.87,57.62).
city('Baykit','ru','Yevenki',3748.0,96.38,61.68).
city('Tura','ru','Yevenki',5444.0,100.25,64.28).
city('Vanavara','ru','Yevenki',3090.0,102.28,60.34).
city('Butare','rw','Butare',89709.0,29.73,-2.59).
city('Nyanza','rw','Butare',56679.0,29.74,-2.35).
city('Byumba','rw','Byumba',70586.0,30.06,-1.58).
city('Cyangugu','rw','Cyangugu',63883.0,28.9,-2.48).
city('Gikongoro','rw','Gikongoro',33832.0,29.58,-2.5).
city('Gisenyi','rw','Gisenyi',83718.0,29.26,-1.69).
city('Gitarama','rw','Gitarama',87613.0,29.76,-2.07).
city('Kibungo','rw','Kibungo',46235.0,30.55,-2.16).
city('Rwamagana','rw','Kibungo',50076.0,30.49,-1.9).
city('Kibuye','rw','Kibuye',48024.0,29.36,-2.06).
city('Ruhengeri','rw','Ruhengeri',86737.0,29.63,-1.5).
city('Kigali','rw','Ville de Kigali',745526.0,30.06,-1.94).
city('Georgetown','sh','Ascension',538.0,-14.44,-7.95).
city('Gough Island','sh','Gough Island',4.0,-9.87,-40.35).
city('Jamestown','sh','Saint Helena',637.0,-5.71,-15.92).
city('Edinburgh','sh','Tristan da Cunha',271.0,-12.32,-37.06).
city('Mansion','kn','Christ Church Nichola Town',690.0,-62.75,17.37).
city('Sandy Point','kn','Saint Anne Sandy Point',780.0,-62.83,17.36).
city('Basseterre','kn','Saint George Basseterre',12920.0,-62.73,17.31).
city('Gingerland','kn','Saint George Gingerland',493.0,-62.55,17.13).
city('Newcastle','kn','Saint James Windward',493.0,-62.58,17.2).
city('Dieppe Bay','kn','Saint John Capesterre',592.0,-62.8,17.41).
city('Sadlers','kn','Saint John Capesterre',986.0,-62.78,17.4).
city('Tabernacle','kn','Saint John Capesterre',789.0,62.77,17.38).
city('Fig Tree','kn','Saint John Figtree',395.0,-62.85,17.37).
city('Cayon','kn','Saint Mary Cayon',788.0,-62.73,17.35).
city('Saint Pauls','kn','Saint Paul Capesterre',1183.0,-62.82,17.4).
city('Charlestown','kn','Saint Paul Charlestown',1538.0,-62.63,17.15).
city('Monkey Hill','kn','Saint Peter Basseterre',592.0,-62.72,17.32).
city('Cotton Ground','kn','Saint Thomas Lowland',381.0,-62.62,17.17).
city('Middle Island','kn','Saint Thomas Middle Island',887.0,-62.88,17.32).
city('Boyds','kn','Trinity Palmetto Point',591.0,-62.77,17.28).
city('Anse-la-Raye','lc','Anse-la-Raye',1248.0,-61.03,13.93).
city('Canaries','lc','Canaries',710.0,-61.07,13.9).
city('Castries','lc','Castries',12981.0,-60.98,14.03).
city('Choc','lc','Castries',52.0,-60.97,14.03).
city('Choiseul','lc','Choiseul',363.0,-61.05,13.77).
city('Dennery','lc','Dennery',2893.0,-60.89,13.89).
city('Cap Estate','lc','Gros Inlet',699.0,-60.95,14.08).
city('Gros Islet','lc','Gros Inlet',2448.0,-60.96,14.08).
city('Laborie','lc','Laborie',1133.0,-60.98,13.75).
city('Micoud','lc','Micoud',3458.0,-60.9,13.82).
city('Soufriere','lc','Soufriere',2878.0,-61.05,13.86).
city('Vieux Fort','lc','Vieux Fort',4629.0,-60.95,13.73).
city('Miquelon','pm','Miquelon-Langlade',1141.0,-56.4,47.1).
city('Saint-Pierre','pm','Saint-Pierre',6200.0,-56.18,46.79).
city('Biabou','vc','Charlotte',1050.0,-61.13,13.2).
city('Byera','vc','Charlotte',1365.0,-61.12,13.26).
city('Georgetown','vc','Charlotte',1708.0,-61.12,13.29).
city('Dovers','vc','Grenadines',525.0,-61.18,12.88).
city('Hamilton','vc','Grenadines',630.0,-61.23,13.0).
city('Port Elizabeth','vc','Grenadines',839.0,-61.23,13.02).
city('Layou','vc','Saint Andrew',1609.0,-61.27,13.2).
city('Chateaubelair','vc','Saint David',735.0,-61.24,13.28).
city('Kingstown','vc','Saint George',17995.0,-61.23,13.16).
city('Barroualie','vc','Saint Patrick',1902.0,-61.27,13.23).
city('Apia','ws','Apia Urban Area',40407.0,-171.76,-13.83).
city('Afega','ws','North West Upolu',1895.0,-171.82,-13.79).
city('Aleisa East','ws','North West Upolu',509.0,-171.88,-13.88).
city('Aleisa West','ws','North West Upolu',820.0,-171.9,-13.88).
city('Fagalii','ws','North West Upolu',1660.0,-171.72,-13.83).
city('Faleasiu','ws','North West Upolu',3475.0,-171.88,-13.8).
city('Faleatiu','ws','North West Upolu',847.0,-171.93,-13.82).
city('Faleolo','ws','North West Upolu',16.0,-171.98,-13.82).
city('Faleula','ws','North West Upolu',2592.0,-171.8,-13.8).
city('Fasitoo Tai','ws','North West Upolu',1545.0,-171.95,-13.83).
city('Fasitoouta','ws','North West Upolu',2098.0,-171.91,-13.82).
city('Laulii','ws','North West Upolu',1938.0,-171.68,-13.85).
city('Leauvaa','ws','North West Upolu',3062.0,-171.85,-13.8).
city('Letogo','ws','North West Upolu',533.0,-171.7,-13.83).
city('Leulumoega','ws','North West Upolu',1458.0,-171.94,-13.82).
city('Levi','ws','North West Upolu',989.0,-172.01,-13.92).
city('Malie','ws','North West Upolu',2189.0,-171.82,-13.8).
city('Malua','ws','North West Upolu',371.0,-171.88,-13.79).
city('Nofoalii','ws','North West Upolu',1828.0,-171.92,-13.82).
city('Nonoa','ws','North West Upolu',513.0,-171.87,-13.8).
city('Nuu','ws','North West Upolu',681.0,-172.43,-13.77).
city('Safune I','ws','North West Upolu',310.0,-171.78,-13.79).
city('Saina','ws','North West Upolu',230.0,-171.77,-13.82).
city('Salepouae','ws','North West Upolu',774.0,-171.85,-13.81).
city('Satapuala','ws','North West Upolu',1412.0,-171.97,-13.83).
city('Satuimalufilufi','ws','North West Upolu',718.0,-172.0,-13.8).
city('Siusega','ws','North West Upolu',2226.0,-171.82,-13.83).
city('Talimatau','ws','North West Upolu',1082.0,-171.79,-13.83).
city('Toamua','ws','North West Upolu',778.0,-171.78,-13.8).
city('Tuanai','ws','North West Upolu',1245.0,-171.83,-13.8).
city('Tufulele','ws','North West Upolu',905.0,-171.86,-13.8).
city('Tulaele','ws','North West Upolu',391.0,-171.77,-13.83).
city('Utualii','ws','North West Upolu',598.0,-171.87,-13.79).
city('Vaigaga','ws','North West Upolu',760.0,-171.8,-13.82).
city('Vailele','ws','North West Upolu',3438.0,-171.72,-13.85).
city('Vailuutai','ws','North West Upolu',717.0,-171.95,-13.82).
city('Vaitele','ws','North West Upolu',5631.0,-171.78,-13.82).
city('Vaiusu','ws','North West Upolu',2043.0,-171.75,-13.82).
city('Amaile','ws','Rest of Upolu',221.0,-171.38,-13.95).
city('Apai','ws','Rest of Upolu',102.0,-172.1,-13.84).
city('Apolima Island','ws','Rest of Upolu',88.0,-172.12,-13.82).
city('Aufaga','ws','Rest of Upolu',459.0,-171.47,-14.02).
city('Eva','ws','Rest of Upolu',266.0,-171.59,-13.87).
city('Faleapuna','ws','Rest of Upolu',584.0,-1.0,-13.87).
city('Falefa','ws','Rest of Upolu',1346.0,-171.55,-13.88).
city('Faleseela','ws','Rest of Upolu',701.0,-171.96,-13.93).
city('Faleu','ws','Rest of Upolu',328.0,-172.07,-13.85).
city('Falevai','ws','Rest of Upolu',202.0,-171.99,-13.92).
city('Falevao','ws','Rest of Upolu',552.0,-171.53,-13.9).
city('Fausaga','ws','Rest of Upolu',303.0,-171.8,-14.01).
city('Fuailoloo','ws','Rest of Upolu',1124.0,-172.01,-13.83).
city('Fusi','ws','Rest of Upolu',606.0,-171.67,-13.92).
city('Iliili','ws','Rest of Upolu',30.0,-171.69,-14.02).
city('Lalomanu','ws','Rest of Upolu',704.0,-171.4,-14.0).
city('Lalomauga','ws','Rest of Upolu',406.0,-171.56,-13.9).
city('Lalovi','ws','Rest of Upolu',322.0,-172.03,-13.85).
city('Lealatele','ws','Rest of Upolu',129.0,-172.27,-13.53).
city('Lepa','ws','Rest of Upolu',172.0,-171.47,-14.0).
city('Leusoalii','ws','Rest of Upolu',371.0,-171.67,-13.85).
city('Levi','ws','Rest of Upolu',125.0,-171.85,-13.79).
city('Lona','ws','Rest of Upolu',218.0,-171.47,-13.92).
city('Lotofaga','ws','Rest of Upolu',874.0,-171.66,-13.99).
city('Luatuanu','ws','Rest of Upolu',977.0,-171.65,-13.85).
city('Lufilufi','ws','Rest of Upolu',1074.0,-171.58,-13.85).
city('Maasina','ws','Rest of Upolu',160.0,-171.49,-13.92).
city('Maninoa','ws','Rest of Upolu',366.0,-171.78,-14.01).
city('Manono Uta','ws','Rest of Upolu',1261.0,-172.04,-13.88).
city('Manunu','ws','Rest of Upolu',284.0,-171.57,-13.9).
city('Matanofo','ws','Rest of Upolu',80.0,-171.97,-13.92).
city('Matatufu','ws','Rest of Upolu',397.0,-171.53,-14.02).
city('Matautu','ws','Rest of Upolu',469.0,-171.76,-13.92).
city('Matavai','ws','Rest of Upolu',1308.0,-171.43,-13.47).
city('Mulivai','ws','Rest of Upolu',449.0,-171.8,-14.02).
city('Musumusu','ws','Rest of Upolu',75.0,-171.5,-13.88).
city('Mutiatele','ws','Rest of Upolu',283.0,-171.36,-13.98).
city('Nefunefu','ws','Rest of Upolu',141.0,-172.0,-13.92).
city('Niusuatia','ws','Rest of Upolu',331.0,-171.8,-13.97).
city('Paepaeala','ws','Rest of Upolu',148.0,-172.15,-13.78).
city('Pata','ws','Rest of Upolu',549.0,-171.98,-13.92).
city('Piu','ws','Rest of Upolu',69.0,-171.56,-14.0).
city('Poutasi','ws','Rest of Upolu',378.0,-171.68,-14.02).
city('Saaga','ws','Rest of Upolu',490.0,-171.77,-14.02).
city('Saanapu Tai','ws','Rest of Upolu',213.0,-171.88,-13.98).
city('Saanapu Uta','ws','Rest of Upolu',1095.0,-171.87,-13.98).
city('Safaatoa','ws','Rest of Upolu',589.0,-171.92,-13.93).
city('Salamumu Tai','ws','Rest of Upolu',59.0,-171.93,-13.97).
city('Salamumu Uta','ws','Rest of Upolu',300.0,-171.92,-13.97).
city('Salani','ws','Rest of Upolu',524.0,-171.57,-14.0).
city('Saleaaumua','ws','Rest of Upolu',544.0,-171.36,-13.97).
city('Saleapaga','ws','Rest of Upolu',505.0,-171.37,-13.97).
city('Saleilua','ws','Rest of Upolu',604.0,-171.7,-14.02).
city('Salelesi','ws','Rest of Upolu',411.0,-171.58,-13.87).
city('Salesatele','ws','Rest of Upolu',330.0,-171.58,-14.0).
city('Saletele','ws','Rest of Upolu',160.0,-171.52,-13.88).
city('Salimu','ws','Rest of Upolu',62.0,-171.5,-13.92).
city('Samai','ws','Rest of Upolu',182.0,-171.96,-13.92).
city('Samamea','ws','Rest of Upolu',89.0,-171.47,-13.9).
city('Samatau','ws','Rest of Upolu',939.0,-172.02,-13.9).
city('Samea','ws','Rest of Upolu',150.0,-172.02,-13.83).
city('Samusu','ws','Rest of Upolu',686.0,-171.38,-13.97).
city('Sapoe','ws','Rest of Upolu',105.0,-171.54,-14.02).
city('Sapunaoa','ws','Rest of Upolu',408.0,-171.57,-13.99).
city('Satalo','ws','Rest of Upolu',356.0,-171.58,-14.02).
city('Sataoa Tai','ws','Rest of Upolu',303.0,-172.84,-13.98).
city('Sataoa Uta','ws','Rest of Upolu',968.0,-171.83,-13.98).
city('Satitoa','ws','Rest of Upolu',522.0,-171.37,-13.98).
city('Satoi','ws','Rest of Upolu',104.0,-171.92,-13.81).
city('Sauano','ws','Rest of Upolu',200.0,-172.52,-13.88).
city('Sauniatu','ws','Rest of Upolu',81.0,-171.57,-13.92).
city('Savaia','ws','Rest of Upolu',395.0,-171.93,-13.93).
city('Siufaga','ws','Rest of Upolu',580.0,-171.39,-13.95).
city('Siumu','ws','Rest of Upolu',1117.0,-171.78,-14.02).
city('Siumu Uta','ws','Rest of Upolu',197.0,-171.77,-14.03).
city('Siuniu','ws','Rest of Upolu',104.0,-171.55,-14.0).
city('Siupapa','ws','Rest of Upolu',53.0,-171.44,-14.02).
city('Solaua','ws','Rest of Upolu',19.0,-171.58,-13.92).
city('Solosolo','ws','Rest of Upolu',1487.0,-171.63,-13.87).
city('Taelefaga','ws','Rest of Upolu',183.0,-171.52,-13.92).
city('Tafagamanu','ws','Rest of Upolu',314.0,-171.92,-13.95).
city('Tafatafa','ws','Rest of Upolu',224.0,-171.65,-14.02).
city('Tafitoala','ws','Rest of Upolu',393.0,-171.79,-14.02).
city('Tiavea','ws','Rest of Upolu',639.0,-171.4,-13.95).
city('Uafato','ws','Rest of Upolu',301.0,-171.43,-13.93).
city('Ulutogia','ws','Rest of Upolu',195.0,-171.39,-14.0).
city('Utufaalalafa','ws','Rest of Upolu',89.0,-171.37,-13.96).
city('Utulaelae','ws','Rest of Upolu',166.0,-171.55,-14.02).
city('Vaiee','ws','Rest of Upolu',497.0,-171.82,-14.0).
city('Vaigalu','ws','Rest of Upolu',97.0,-171.45,-14.02).
city('Vailoa','ws','Rest of Upolu',336.0,-171.38,-14.0).
city('Vaovai','ws','Rest of Upolu',577.0,-171.66,-14.02).
city('Vavau','ws','Rest of Upolu',383.0,-171.48,-14.02).
city('Aopo','ws','Savaii',390.0,-172.5,-13.48).
city('Asaga','ws','Savaii',337.0,-172.13,-13.58).
city('Auala','ws','Savaii',574.0,-172.6,-13.47).
city('Avao','ws','Savaii',276.0,-172.37,-13.45).
city('Avata','ws','Savaii',302.0,-172.78,-13.48).
city('Faala','ws','Savaii',887.0,-172.28,-13.75).
city('Fagaee','ws','Savaii',201.0,-172.19,-13.63).
city('Fagafau','ws','Savaii',273.0,-172.65,-13.58).
city('Fagamalo','ws','Savaii',294.0,-172.35,-13.42).
city('Faiaai','ws','Savaii',421.0,-172.63,-13.63).
city('Falealupo','ws','Savaii',518.0,-172.8,-13.5).
city('Falelima','ws','Savaii',416.0,-172.68,-13.53).
city('Fatuvalu','ws','Savaii',170.0,-172.42,-13.47).
city('Foalalo','ws','Savaii',361.0,-172.57,-13.67).
city('Foaluga','ws','Savaii',563.0,-172.55,-13.67).
city('Fogasavaii','ws','Savaii',380.0,-172.6,-13.63).
city('Fogatuli','ws','Savaii',273.0,-172.62,-13.62).
city('Gataivai','ws','Savaii',1141.0,-172.38,-13.75).
city('Gautavai','ws','Savaii',171.0,-172.37,-13.75).
city('Lalomalava','ws','Savaii',399.0,-172.13,-13.7).
city('Lano','ws','Savaii',706.0,-172.13,-13.6).
city('Leagiagi','ws','Savaii',124.0,-172.39,-13.45).
city('Lelepa','ws','Savaii',213.0,-172.33,-13.45).
city('Letui','ws','Savaii',273.0,-172.47,-13.47).
city('Manase','ws','Savaii',158.0,-172.37,-13.43).
city('Mauga','ws','Savaii',145.0,-172.62,-13.47).
city('Neiafu Tai','ws','Savaii',299.0,-172.73,-13.52).
city('Neiafu Uta','ws','Savaii',545.0,-172.72,-13.52).
city('Paia','ws','Savaii',308.0,-172.4,-13.47).
city('Papa','ws','Savaii',284.0,-172.7,-13.47).
city('Papa Uta','ws','Savaii',480.0,-172.69,-13.47).
city('Patamea','ws','Savaii',597.0,-172.27,-13.48).
city('Puapua','ws','Savaii',523.0,-172.22,-13.58).
city('Puleia','ws','Savaii',262.0,-172.35,-13.75).
city('Saasaai','ws','Savaii',520.0,-172.14,-13.62).
city('Safotu','ws','Savaii',1207.0,-172.4,-13.45).
city('Sagone','ws','Savaii',776.0,-172.58,-13.65).
city('Saipipi','ws','Savaii',705.0,-172.13,-13.62).
city('Salailua','ws','Savaii',582.0,-172.57,-13.68).
city('Saleaula','ws','Savaii',597.0,-172.33,-13.43).
city('Saleia','ws','Savaii',275.0,-172.38,-13.45).
city('Salelavalu Tai','ws','Savaii',331.0,-172.16,-13.72).
city('Salelavalu Uta','ws','Savaii',560.0,-172.15,-13.72).
city('Salimu','ws','Savaii',250.0,-172.12,-13.65).
city('Samalaeulu','ws','Savaii',789.0,-172.27,-13.47).
city('Samata I Tai','ws','Savaii',490.0,-172.64,-13.6).
city('Samata I Uta','ws','Savaii',624.0,-172.63,-13.6).
city('Samauga','ws','Savaii',289.0,-171.56,-13.92).
city('Sapapalii','ws','Savaii',877.0,-172.12,-13.68).
city('Sapulu','ws','Savaii',957.0,-171.88,-13.81).
city('Sasina','ws','Savaii',566.0,-172.43,-13.45).
city('Sataua','ws','Savaii',771.0,-172.67,-13.47).
city('Satoalepai','ws','Savaii',235.0,-172.32,-13.45).
city('Satuiatua','ws','Savaii',304.0,-172.56,-13.68).
city('Sili','ws','Savaii',868.0,-172.35,-13.72).
city('Siufaga','ws','Savaii',484.0,-172.03,-13.9).
city('Siutu','ws','Savaii',648.0,-172.55,-13.68).
city('Tafua','ws','Savaii',403.0,-172.22,-13.78).
city('Taga','ws','Savaii',680.0,-172.47,-13.77).
city('Tapueleele','ws','Savaii',228.0,-172.17,-13.63).
city('Tino I Iva','ws','Savaii',740.0,-172.2,-13.7).
city('Tuasivi','ws','Savaii',365.0,-172.12,-13.67).
city('Tufutafoe','ws','Savaii',330.0,-172.77,-13.48).
city('Utuloa','ws','Savaii',34.0,-172.58,-13.47).
city('Vaiala','ws','Savaii',221.0,-171.72,-13.82).
city('Vailoa','ws','Savaii',769.0,-172.28,-13.73).
city('Vaipouli','ws','Savaii',171.0,-172.35,-13.45).
city('Vaipua','ws','Savaii',417.0,-172.62,-13.63).
city('Vaisala','ws','Savaii',599.0,-172.62,-13.48).
city('Vaotupua','ws','Savaii',183.0,-172.8,-13.51).
city('Acquaviva','sm','Acquaviva',1530.0,12.41,43.95).
city('Borgo Maggiore','sm','Borgo Maggiore',6627.0,12.45,43.93).
city('Chiesanuova','sm','Chiesanuova',952.0,12.41,43.92).
city('Domagnano','sm','Domagnano',2724.0,12.47,43.95).
city('Faetano','sm','Faetano',980.0,12.5,43.94).
city('Fiorentino','sm','Fiorentino',2082.0,12.46,43.9).
city('Montegiardino','sm','Montegiardino',771.0,12.48,43.92).
city('San Marino','sm','San Marino',4598.0,12.43,43.94).
city('Serravalle','sm','Serravalle',9258.0,12.49,43.95).
city('Sao Tome','st','Agua Grande',62186.0,6.73,0.37).
city('Santana','st','Cantagalo',7705.0,6.23,0.26).
city('Neves','st','Lemba',7705.0,6.57,0.38).
city('Santo Amaro','st','Lobata',8239.0,6.69,0.36).
city('Trindade','st','Me-Zochi',7627.0,6.68,0.3).
city('Santo Antonio','st','Pague',1209.0,7.41,1.65).
city('Abha','sa','Asir',142255.0,42.5,18.23).
city('Abu Aris','sa','Asir',44584.0,42.83,16.97).
city('Bisah','sa','Asir',55159.0,42.6,20.01).
city('Hzamis Musayt','sa','Asir',276511.0,42.73,18.31).
city('Hail','sa','Hail',236551.0,41.7,27.53).
city('Jizan','sa','Jizan',79946.0,42.55,16.9).
city('Sabya','sa','Jizan',49398.0,42.62,17.15).
city('Jiddah','sa','Makkah',2545728.0,39.17,21.5).
city('Mecca','sa','Makkah',1199659.0,39.82,21.43).
city('Rabig','sa','Makkah',40260.0,39.02,22.8).
city('al-Hawiyah','sa','Makkah',118259.0,38.57,28.98).
city('at-Taif','sa','Makkah',514071.0,40.38,21.26).
city('Dariyah','sa','Najran',32451.0,42.92,24.74).
city('Najran','sa','Najran',125637.0,44.13,17.5).
city('Sarurah','sa','Najran',51219.0,47.12,17.47).
city('Afif','sa','Riyadh',35739.0,42.93,23.92).
city('Riyadh','sa','Riyadh',3469290.0,46.77,24.65).
city('ad-Dawadimi','sa','Riyadh',48246.0,44.38,24.49).
city('ad-Dilam','sa','Riyadh',37689.0,47.17,24.0).
city('al-Hzarj','sa','Riyadh',189422.0,47.5,24.18).
city('az-Zulfi','sa','Riyadh',53073.0,44.8,26.3).
city('Tabuk','sa','Tabuk',355469.0,36.57,28.39).
city('Umm Lajj','sa','Tabuk',31468.0,37.27,25.02).
city('al-Bahah','sa','al-Bahah',19127.0,41.47,20.02).
city('Araar','sa','al-Hudud-as-Samaliyah',107838.0,41.02,30.99).
city('Rafhah','sa','al-Hudud-as-Samaliyah',30730.0,43.5,29.63).
city('Turayf','sa','al-Hudud-as-Samaliyah',32654.0,38.66,31.67).
city('al-Qurayyah','sa','al-Hudud-as-Samaliyah',74360.0,37.34,31.33).
city('Sakakah','sa','al-Jawf',93282.0,40.2,29.97).
city('al-Jawf','sa','al-Jawf',55085.0,39.87,29.81).
city('Yanbu','sa','al-Madinah',113309.0,38.05,24.09).
city('al-Madinah','sa','al-Madinah',824031.0,39.59,24.48).
city('Buraydah','sa','al-Qasim',341981.0,43.97,26.37).
city('Unayzah','sa','al-Qasim',129770.0,43.99,26.09).
city('ar-Rass','sa','al-Qasim',80999.0,43.5,25.87).
city('Buqayq','sa','as-Sarqiyah',37696.0,49.67,25.93).
city('Hafar-al-Batin','sa','as-Sarqiyah',163109.0,45.96,28.43).
city('Rahimah','sa','as-Sarqiyah',53589.0,50.06,26.7).
city('Safwah','sa','as-Sarqiyah',43946.0,49.96,26.65).
city('Sayhat','sa','as-Sarqiyah',68425.0,50.05,26.47).
city('Tarut','sa','as-Sarqiyah',44849.0,50.07,26.57).
city('ad-Dammam','sa','as-Sarqiyah',568186.0,50.1,26.43).
city('al-Hufuf','sa','as-',266158.0,49.58,25.35).
city('al-Hzafji','sa','as-Sarqiyah',58607.0,48.51,28.42).
city('al-Hzubar','sa','as-Sarqiyah',168506.0,50.2,26.23).
city('al-Jubayl','sa','as-Sarqiyah',92773.0,49.65,27.01).
city('al-Mubarraz','sa','as-Sarqiyah',258211.0,49.57,25.43).
city('al-Qatif','sa','as-Sarqiyah',116579.0,50.02,26.52).
city('atz-Tzuqbah','sa','as-Sarqiyah',148510.0,50.2,26.27).
city('az-Zahran','sa','as-Sarqiyah',86847.0,50.16,26.29).
city('Dakar','sn','Dakar',2702820.0,-17.48,14.72).
city('Bambey','sn','Diourbel',32874.0,-16.46,14.71).
city('Diourbel','sn','Diourbel',126400.0,-16.24,14.66).
city('Mbacke','sn','Diourbel',78635.0,-15.92,14.8).
city('Diofior','sn','Fatick',6407.0,-16.67,14.19).
city('Fatick','sn','Fatick',62987.0,-16.42,14.35).
city('Foundiougne','sn','Fatick',4718.0,-16.48,14.12).
city('Gossas','sn','Fatick',10244.0,-16.08,14.5).
city('Guinguineo','sn','Fatick',15201.0,-15.96,14.28).
city('Kahone','sn','Fatick',2825.0,-16.02,14.15).
city('Passi','sn','Fatick',4521.0,-16.27,13.98).
city('Sokone','sn','Fatick',15460.0,-16.39,13.88).
city('Gandiaye','sn','Kaolack',5984.0,-16.27,14.23).
city('Kaffrine','sn','Kaolack',33572.0,-15.56,14.11).
city('Kaolack','sn','Kaolack',289633.0,-16.1,14.15).
city('Koungheul','sn','Kaolack',14786.0,-14.82,13.98).
city('Ndoffane','sn','Kaolack',8414.0,-15.93,13.92).
city('Nioro','sn','Kaolack',21846.0,-15.79,13.76).
city('Goudomp','sn','Kolda',10098.0,-15.95,12.54).
city('Kolda','sn','Kolda',80632.0,-14.95,12.91).
city('Marsassoum','sn','Kolda',9116.0,-15.98,12.83).
city('Sedhiou','sn','Kolda',20756.0,-15.59,12.72).
city('Velingara','sn','Kolda',27566.0,-14.11,13.15).
city('Dahra','sn','Louga',17656.0,-15.49,15.35).
city('Kebemer','sn','Louga',21409.0,-16.45,15.37).
city('Linguere','sn','Louga',10228.0,-15.12,15.4).
city('Louga','sn','Louga',117333.0,-16.25,15.61).
city('Dagana','sn','Saint-Louis',31310.0,-15.5,16.51).
city('Gollere','sn','Saint-Louis',2684.0,-14.1,16.26).
city('Kanel','sn','Saint-Louis',5138.0,-13.17,15.49).
city('Matam','sn','Saint-Louis',12277.0,-13.25,15.67).
city('Ndioum','sn','Saint-Louis',5304.0,-14.65,16.51).
city('Ourossogui','sn','Saint-Louis',9741.0,-13.32,15.6).
city('Podor','sn','Saint-Louis',6984.0,-14.97,16.66).
city('Richard Toll','sn','Saint-Louis',91500.0,-15.69,16.47).
city('Saint-Louis','sn','Saint-Louis',176048.0,-16.49,16.03).
city('Semme','sn','Saint-Louis',3717.0,-12.95,15.2).
city('Thilogne','sn','Saint-Louis',4968.0,-13.6,15.97).
city('Waounde','sn','Saint-Louis',13688.0,-12.87,15.27).
city('Bakel','sn','Tambacounda',10202.0,-12.46,14.91).
city('Kedougou','sn','Tambacounda',16612.0,-12.18,12.56).
city('Tambacounda','sn','Tambacounda',83467.0,-13.68,13.78).
city('Joal-Fadiouth','sn','Thies',39490.0,-16.85,14.18).
city('Khombole','sn','Thies',14762.0,-16.7,14.76).
city('Mbour','sn','Thies',194682.0,-16.97,14.43).
city('Mekhe','sn','Thies',20207.0,-16.63,15.13).
city('Nguekhokh','sn','Thies',6516.0,-17.01,14.51).
city('Pout','sn','Thies',29387.0,-17.07,14.77).
city('Thiadiaye','sn','Thies',7495.0,-16.7,14.42).
city('Thies','sn','Thies',320721.0,-16.93,14.81).
city('Tivaouane','sn','Thies',56828.0,-16.83,14.97).
city('Bignona','sn','Ziguinchor',45918.0,-16.24,12.83).
city('Oussouye','sn','Ziguinchor',7107.0,-16.55,12.5).
city('Thionck-Essyl','sn','Ziguinchor',7775.0,-16.52,12.78).
city('Ziguinchor','sn','Ziguinchor',255391.0,-16.29,12.59).
city('Aleksandrovac','yu','Central Serbia',6596.0,21.05,43.46).
city('Aleksinac','yu','Central Serbia',16652.0,21.71,43.54).
city('Aleksinacki Rudnik','yu','Central Serbia',1430.0,21.69,43.56).
city('Arandelovac','yu','Central Serbia',24674.0,20.57,44.31).
city('Arilje','yu','Central Serbia',6921.0,20.1,43.75).
city('Azanja','yu','Central Serbia',4603.0,20.88,44.43).
city('Babusnica','yu','Central Serbia',4606.0,22.41,43.06).
city('Backo Petrovo Selo','yu','Central Serbia',7129.0,20.08,45.71).
city('Badovinci','yu','Central Serbia',5402.0,19.37,44.79).
city('Bajina Basta','yu','Central Serbia',9812.0,19.57,43.97).
city('Baljevac','yu','Central Serbia',1625.0,20.64,43.39).
city('Banja Koviljaca','yu','Central Serbia',6540.0,19.16,44.51).
city('Barajevo','yu','Central Serbia',8828.0,20.42,44.58).
city('Baric','yu','Central Serbia',6837.0,20.26,44.65).
city('Batocina','yu','Central Serbia',5622.0,21.08,44.15).
city('Bela Palanka','yu','Central Serbia',8763.0,22.31,43.22).
city('Belgrade','yu','Central Serbia',1115200.0,20.5,44.83).
city('Beli Potok','yu','Central Serbia',3645.0,22.08,43.54).
city('Blace','yu','Central Serbia',5593.0,21.29,43.3).
city('Bogatic','yu','Central Serbia',7370.0,19.48,44.84).
city('Bogovina','yu','Central Serbia',1201.0,21.94,43.9).
city('Bolec','yu','Central Serbia',6050.0,20.6,44.72).
city('Boljevac','yu','Central Serbia',3765.0,21.95,43.83).
city('Bor','yu','Central Serbia',39388.0,22.1,44.13).
city('Borca','yu','Central Serbia',37844.0,20.45,44.87).
city('Bosilegrad','yu','Central Serbia',2713.0,22.47,42.5).
city('Brus','yu','Central Serbia',4651.0,21.03,43.38).
city('Brza Palanka','yu','Central Serbia',1054.0,22.45,44.47).
city('Brzi Brod','yu','Central Serbia',4656.0,21.97,43.31).
city('Bujanovac','yu','Central Serbia',12109.0,21.77,42.46).
city('Cacak','yu','Central Ser',75062.0,20.33,43.9).
city('Cajetina','yu','Central Serbia',3309.0,19.72,43.75).
city('Cicevac','yu','Central Serbia',5031.0,21.45,43.72).
city('Cuprija','yu','Central Serbia',20373.0,21.38,43.93).
city('Despotovac','yu','Central Serbia',4489.0,21.45,44.09).
city('Dimitrovgrad','yu','Central Serbia',6887.0,22.78,43.01).
city('Dobanovci','yu','Central Serbia',8217.0,20.23,44.83).
city('Donja Vrezina','yu','Central Serbia',4676.0,21.95,43.33).
city('Donji Komren','yu','Central Serbia',5969.0,21.88,43.35).
city('Donji Milanovac','yu','Central Serbia',3069.0,22.12,44.48).
city('Gornji Milanovac','yu','Central Serbia',24555.0,20.46,44.03).
city('Grdelica','yu','Central Serbia',2371.0,22.07,42.9).
city('Grocka','yu','Central Serbia',8580.0,20.72,44.67).
city('Guca','yu','Central Serbia',2014.0,20.23,43.78).
city('Ivanjica','yu','Central Serbia',12667.0,20.23,43.58).
city('Jagodina','yu','Central Serbia',35282.0,21.26,43.98).
city('Jakovo','yu','Central Serbia',6077.0,20.26,44.76).
city('Jasa Tomic','yu','Central Serbia',2876.0,20.86,45.45).
city('Josanicka Banja','yu','Central Serbia',1145.0,20.75,43.39).
city('Kaluderica','yu','Central Serbia',23712.0,20.57,44.75).
city('Kladovo','yu','Central Serbia',9061.0,22.61,44.61).
city('Klupci','yu','Central Serbia',7366.0,19.25,44.53).
city('Knjazevac','yu','Central Serbia',19380.0,22.26,43.57).
city('Koceljeva','yu','Central Serbia',4748.0,19.81,44.47).
city('Kosjeric','yu','Central Serbia',4200.0,19.91,44.0).
city('Kostolac','yu','Central Serbia',9248.0,21.17,44.71).
city('Kragujevac','yu','Central Serbia',149275.0,20.92,44.02).
city('Kraljevo','yu','Central Serbia',58140.0,20.67,43.74).
city('Krupanj','yu','Central Serbia',4913.0,19.36,44.37).
city('Krusevac','yu','Central Serbia',57417.0,21.32,43.58).
city('Kucevo','yu','Central Serbia',4552.0,21.67,44.48).
city('Kursumlija','yu','Central Serbia',13979.0,21.27,43.15).
city('Kusadak','yu','Central Serbia',5630.0,20.8,44.4).
city('Lajkovac','yu','Central Serbia',3450.0,20.17,44.37).
city('Lapovo','yu','Central Serbia',7302.0,21.1,44.18).
city('Lazarevac','yu','Central Serbia',24503.0,20.27,44.39).
city('Lebane','yu','Central Serbia',10086.0,21.74,42.92).
city('Leskovac','yu','Central Serbia',63683.0,21.95,43.0).
city('Lesnica','yu','Central Serbia',4715.0,19.31,44.65).
city('Lestane','yu','Central Serbia',9024.0,20.58,44.73).
city('Ljig','yu','Central Serbia',3060.0,20.24,44.22).
city('Ljubovija','yu','Central Serbia',4243.0,19.38,44.19).
city('Loznica','yu','Central Serbia',21287.0,19.22,44.53).
city('Loznicko Polje','yu','Central Serbia',7841.0,19.22,44.56).
city('Lozovik','yu','Central Serbia',5545.0,21.1,44.46).
city('Lucani','yu','Central Serbia',4324.0,20.14,43.86).
city('Majdanpek','yu','Central Serbia',9606.0,21.94,44.42).
city('Majur','yu','Central Serbia',6984.0,19.65,44.77).
city('Mali Zvornik','yu','Central Serbia',4875.0,19.12,44.4).
city('Mataruska Banja','yu','Central Serbia',2887.0,20.61,43.69).
city('Medveda','yu','Central Serbia',2759.0,21.08,43.63).
city('Mionica','yu','Central Serbia',1724.0,20.08,44.25).
city('Mladenovac','yu','Central Serbia',22087.0,20.7,44.43).
city('Negotin','yu','Central Serbia',18000.0,22.53,44.23).
city('Nis','yu','Central Serbia',173775.0,21.9,43.33).
city('Niska Banja','yu','Central Serbia',4524.0,22.02,43.3).
city('Nova Varos','yu','Central Serbia',10166.0,19.81,43.46).
city('Novi Pazar','yu','Central Serbia',56028.0,20.52,43.15).
city('Novo Milosevo','yu','Central Serbia',6664.0,20.3,45.72).
city('Obrenovac','yu','Central Serbia',24257.0,20.21,44.66).
city('Osecina','yu','Central Serbia',3272.0,19.6,44.37).
city('Ostruznica','yu','Central Serbia',4005.0,20.32,44.73).
city('Ovca','yu','Central Serbia',2300.0,20.54,44.89).
city('Padinska Skela','yu','Central Serbia',9353.0,20.43,44.94).
city('Paracin','yu','Central Serbia',25411.0,21.41,43.87).
city('Petrovac','yu','Central Serbia',7920.0,21.41,44.39).
city('Pinosava','yu','Central Serbia',2871.0,20.48,44.7).
city('Pirot','yu','Central Serbia',40928.0,22.6,43.17).
city('Pocerski Pricinovic','yu','Central Serbia',6187.0,19.7,44.73).
city('Pozarevac','yu','Central Serbia',42057.0,21.19,44.63).
city('Pozega','yu','Central Serbia',13403.0,20.04,43.85).
city('Predejane','yu','Central Serbia',1174.0,22.13,42.83).
city('Presevo','yu','Central Serbia',13537.0,21.65,42.31).
city('Priboj','yu','Central Serbia',19139.0,19.54,43.59).
city('Prijepolje','yu','Central Serbia',14811.0,19.65,43.39).
city('Prokuplje','yu','Central Serbia',26937.0,21.59,43.24).
city('Raca','yu','Central Serbia',2757.0,19.29,44.92).
city('Radinac','yu','Central Serbia',4918.0,20.97,44.63).
city('Raska','yu','Central Serbia',6622.0,20.62,43.29).
city('Resavica','yu','Central Serbia',2309.0,21.52,44.07).
city('Ribnica','yu','Central Serbia',2770.0,20.69,43.71).
city('Ripanj','yu','Central Serbia',10827.0,20.52,44.64).
city('Rudovci','yu','Central Serbia',1779.0,20.42,44.37).
city('Rusanj','yu','Central Serbia',4839.0,20.44,44.68).
city('Sabac','yu','Central Serbia',55114.0,19.69,44.76).
city('Sevojno','yu','Central Serbia',7692.0,19.9,43.85).
city('Sjenica','yu','Central Serbia',12888.0,20.0,43.27).
city('Smederevo','yu','Central Serbia',63058.0,20.93,44.67).
city('Smederevska Palanka','yu','Central Serbia',25516.0,20.96,44.37).
city('Sokobanja','yu','Central Serbia',8308.0,21.87,43.64).
city('Sopot','yu','Central Serbia',1775.0,20.57,44.52).
city('Sremcica','yu','Central Serbia',19077.0,20.39,44.68).
city('Surcin','yu','Central Serbia',14867.0,20.28,44.79).
city('Surdulica','yu','Central Serbia',10816.0,22.17,42.69).
city('Svilajnac','yu','Central Serbia',9677.0,21.2,44.23).
city('Svrljig','yu','Central Serbia',7813.0,22.12,43.41).
city('Topola','yu','Central Serbia',5663.0,20.68,44.25).
city('Trstenik','yu','Central Serbia',17309.0,21.01,43.62).
city('Tutin','yu','Central Serbia',9224.0,20.33,42.99).
city('Ub','yu','Central Serbia',6068.0,20.07,44.46).
city('Ugrinovci','yu','Central Serbia',7971.0,20.19,44.88).
city('Umka','yu','Central Serbia',5336.0,20.3,44.68).
city('Uzice','yu','Central Serbia',55670.0,19.84,43.87).
city('Valjevo','yu','Central Serbia',62471.0,19.89,44.28).
city('Velika Plana','yu','Central Serbia',16148.0,21.07,44.33).
city('Veliki Crljeni','yu','Central Serbia',4565.0,20.28,44.47).
city('Veliki Trnovac','yu','Central Serbia',6812.0,21.74,42.48).
city('Veliko Gradiste','yu','Central Serbia',5752.0,21.51,44.76).
city('Vinca','yu','Central Serbia',6027.0,20.62,44.76).
city('Vladicin Han','yu','Central Serbia',8453.0,22.06,42.71).
city('Vlasotince','yu','Central Serbia',16673.0,22.12,42.96).
city('Vranje','yu','Central Serbia',56199.0,21.91,42.57).
city('Vranjska Banja','yu','Central Serbia',6159.0,21.99,42.56).
city('Vrcin','yu','Central Serbia',8949.0,20.59,44.67).
city('Vrnjacka Banja','yu','Central Serbia',9998.0,20.9,43.62).
city('Vucje','yu','Central Serbia',3190.0,21.91,42.87).
city('Zajecar','yu','Central Serbia',39849.0,22.3,43.91).
city('Zlatibor','yu','Central Serbia',2497.0,19.7,43.72).
city('Zvecka','yu','Central Serbia',6180.0,20.16,44.64).
city('Dakovica','yu','Kosovo and Meto',94070.0,20.43,42.39).
city('Gnjilane','yu','Kosovo and Metohija',88287.0,21.48,42.47).
city('Kosovo Polje','yu','Kosovo and Metohija',32098.0,21.12,42.63).
city('Kosovska Mitrovica','yu','Kosovo and Metohija',84736.0,20.87,42.89).
city('Orahovac','yu','Kosovo and Metohija',25889.0,20.66,42.41).
city('Pec','yu','Kosovo and Metohija',93161.0,20.31,42.66).
city('Podujevo','yu','Kosovo and Metohija',46513.0,21.19,42.91).
city('Pristina','yu','Kosovo and Metohija',254023.0,21.17,42.65).
city('Prizren','yu','Kosovo and Metohija',159145.0,20.74,42.23).
city('Urosevac','yu','Kosovo and Metohija',94278.0,21.17,42.38).
city('Niksic','yu','Montenegro',65896.0,18.94,42.78).
city('Pljevlja','yu','Montenegro',26266.0,19.36,43.36).
city('Podgorica','yu','Montenegro',156988.0,19.28,42.47).
city('Ulcinj','yu','Montenegro',10641.0,19.21,41.93).
city('Ada','yu','Vojvodina',10259.0,20.13,45.8).
city('Alibunar','yu','Vojvodina',3353.0,20.97,45.08).
city('Apatin','yu','Vojvodina',19677.0,18.98,45.67).
city('Bac','yu','Vojvodina',6110.0,19.24,45.39).
city('Backa Palanka','yu','Vojvodina',30208.0,19.39,45.25).
city('Backa Topola','yu','Vojvodina',16082.0,19.64,45.82).
city('Backi Jarak','yu','Vojvodina',6250.0,19.88,45.37).
city('Backi Petrovac','yu','Vojvodina',6649.0,19.59,45.36).
city('Backo Gradiste','yu','Vojvodina',5453.0,20.03,45.53).
city('Bajmok','yu','Vojvodina',8599.0,19.42,45.97).
city('Banatski Karlovac','yu','Vojvodina',5799.0,21.02,45.05).
city('Banatsko Novo Selo','yu','Vojvodina',7397.0,20.78,44.99).
city('Bavaniste','yu','Vojvodina',6027.0,20.88,44.82).
city('Becej','yu','Vojvodina',25562.0,20.04,45.63).
city('Bela Crkva','yu','Vojvodina',10586.0,21.42,44.9).
city('Beocin','yu','Vojvodina',8122.0,19.72,45.2).
city('Beska','yu','Vojvodina',6328.0,20.07,45.13).
city('Bezdan','yu','Vojvodina',5270.0,18.93,45.85).
city('Cantavir','yu','Vojvodina',7039.0,19.76,45.92).
city('Celarevo','yu','Vojvodina',5554.0,19.53,45.27).
city('Coka','yu','Vojvodina',4617.0,20.14,45.94).
city('Crepaja','yu','Vojvodina',4794.0,20.64,45.01).
city('Crvenka','yu','Vojvodina',10147.0,19.46,45.66).
city('Curug','yu','Vojvodina',8876.0,20.07,45.47).
city('Dolovo','yu','Vojvodina',6861.0,20.88,44.9).
city('Durdevo','yu','Vojvodina',5295.0,20.06,45.32).
city('Futog','yu','Vojvodina',19340.0,19.71,45.24).
city('Golubinci','yu','Vojvodina',5351.0,20.77,44.99).
city('Horgos','yu','Vojvodina',6123.0,19.97,46.16).
city('Indija','yu','Vojvodina',27228.0,20.09,45.05).
city('Irig','yu','Vojvodina',4988.0,19.86,45.1).
city('Jabuka','yu','Vojvodina',6225.0,19.52,43.35).
city('Kac','yu','Vojvodina',11635.0,19.94,45.3).
city('Kacarevo','yu','Vojvodina',7556.0,20.69,44.97).
city('Kanjiza','yu','Vojvodina',9972.0,20.05,46.07).
city('Karavukovo','yu','Vojvodina',4894.0,19.19,45.5).
city('Kikinda','yu','Vojvodina',41704.0,20.45,45.84).
city('Kisac','yu','Vojvodina',5395.0,19.73,45.35).
city('Kljajicevo','yu','Vojvodina',6115.0,19.28,45.77).
city('Kovacica','yu','Vojvodina',6693.0,20.62,45.11).
city('Kovilj','yu','Vojvodina',5736.0,20.02,45.23).
city('Kovin','yu','Vojvodina',14472.0,20.98,44.75).
city('Kucura','yu','Vojvodina',4653.0,19.59,45.52).
city('Kula','yu','Vojvodina',19395.0,19.52,45.62).
city('Lacarak','yu','Vojvodina',11170.0,19.57,45.0).
city('Macvanska Mitrovica','yu','Vojvodina',3862.0,19.6,44.97).
city('Mali Idos','yu','Vojvodina',5412.0,19.67,45.71).
city('Melenci','yu','Vojvodina',6439.0,20.32,45.51).
city('Mokrin','yu','Vojvodina',5833.0,20.41,45.94).
city('Mol','yu','Vojvodina',6649.0,20.13,45.76).
city('Nova Pazova','yu','Vojvodina',18986.0,20.22,44.94).
city('Novi Banovci','yu','Vojvodina',10378.0,20.28,44.95).
city('Novi Becej','yu','Vojvodina',14243.0,20.14,45.6).
city('Novi Knezevac','yu','Vojvodina',7499.0,20.1,46.05).
city('Novi Sad','yu','Vojvodina',194405.0,19.85,45.25).
city('Odzaci','yu','Vojvodina',9749.0,19.26,45.51).
city('Omoljica','yu','Vojvodina',6490.0,20.73,44.76).
city('Opovo','yu','Vojvodina',4657.0,20.43,45.05).
city('Padina','yu','Vojvodina',5731.0,20.73,45.12).
city('Palic','yu','Vojvodina',7822.0,19.77,46.11).
city('Pancevo','yu','Vojvodina',77201.0,20.66,44.87).
city('Petrovaradin','yu','Vojvodina',14787.0,19.88,45.25).
city('Prigrevica','yu','Vojvodina',4808.0,19.09,45.68).
city('Ruma','yu','Vojvodina',33116.0,19.83,45.0).
city('Rumenka','yu','Vojvodina',6139.0,19.74,45.29).
city('Ruski Krstur','yu','Vojvodina',5122.0,19.42,45.56).
city('Sajkas','yu','Vojvodina',4785.0,20.09,45.27).
city('Senta','yu','Vojvodina',19891.0,20.09,45.94).
city('Sid','yu','Vojvodina',16937.0,19.23,45.13).
city('Sivac','yu','Vojvodina',8899.0,19.38,45.7).
city('Sombor','yu','Vojvodina',51607.0,19.12,45.78).
city('Sonta','yu','Vojvodina',4881.0,19.1,45.59).
city('Srbobran','yu','Vojvodina',13170.0,19.8,45.55).
city('Sremska Kamenica','yu','Vojvodina',12220.0,19.84,45.22).
city('Sremska Mitrovica','yu','Vojvodina',39286.0,19.61,44.98).
city('Sremski Karlovci','yu','Vojvodina',9255.0,19.93,45.2).
city('Stanisic','yu','Vojvodina',4748.0,19.17,45.94).
city('Stara Moravica','yu','Vojvodina',5559.0,19.47,45.87).
city('Stara Pazova','yu','Vojvodina',19183.0,20.16,44.99).
city('Starcevo','yu','Vojvodina',7629.0,20.7,44.81).
city('Stari Banovci','yu','Vojvodina',5916.0,20.29,44.99).
city('Subotica','yu','Vojvodina',99595.0,19.68,46.07).
city('Temerin','yu','Vojvodina',19877.0,19.89,45.41).
city('Titel','yu','Vojvodina',5831.0,20.29,45.21).
city('Veternik','yu','Vojvodina',21018.0,19.76,45.25).
city('Vojka','yu','Vojvodina',5173.0,20.15,44.94).
city('Vrbas','yu','Vojvodina',25991.0,19.65,45.57).
city('Vrsac','yu','Vojvodina',36036.0,21.3,45.13).
city('Zabalj','yu','Vojvodina',9844.0,20.06,45.37).
city('Zitiste','yu','Vojvodina',3297.0,20.55,45.49).
city('Zrenjanin','yu','Vojvodina',79410.0,20.4,45.37).
city('Baoma','sl','Eastern',4836.0,-11.33,8.04).
city('Barma','sl','Eastern',6921.0,-11.33,8.35).
city('Blama','sl','Eastern',7488.0,-11.35,7.87).
city('Boajibu','sl','Eastern',6787.0,-11.33,8.18).
city('Buedu','sl','Eastern',4686.0,-10.37,8.28).
city('Bunumbu','sl','Eastern',6368.0,-10.87,8.17).
city('Daru','sl','Eastern',5159.0,-10.84,7.99).
city('Gorahun','sl','Eastern',3758.0,-11.24,7.47).
city('Hangha','sl','Eastern',4603.0,-11.14,7.94).
city('Jaiama-Nimokoro','sl','Eastern',6786.0,-11.1,8.55).
city('Jaiama-Sewafe','sl','Eastern',7070.0,-11.25,8.53).
city('Jojoima','sl','Eastern',2715.0,-10.79,7.88).
city('Kailahun','sl','Eastern',12195.0,-10.58,8.28).
city('Kayimi','sl','Eastern',2922.0,-11.17,8.88).
city('Kenema','sl','Eastern',70680.0,-11.19,7.88).
city('Koidu','sl','Eastern',111090.0,-10.85,8.44).
city('Koindu','sl','Eastern',11096.0,-10.41,8.38).
city('Mobai','sl','Eastern',2980.0,-10.75,7.99).
city('Motema','sl','Eastern',8502.0,-11.03,8.6).
city('Nyandehun-Mendegelema','sl','Eastern',3753.0,-10.49,8.2).
city('Pandebu-Tokpombu','sl','Eastern',14741.0,-10.83,7.57).
city('Panguma','sl','Eastern',7321.0,-11.13,8.18).
city('Pendembu','sl','Eastern',7602.0,-10.71,8.1).
city('Peyima','sl','Eastern',4201.0,-11.03,8.7).
city('Segbwema','sl','Eastern',11135.0,-10.93,8.02).
city('Seidu','sl','Eastern',3483.0,-10.6,9.02).
city('Simbakoro','sl','Eastern',3905.0,-11.02,8.6).
city('Tombo','sl','Eastern',6220.0,-10.73,8.53).
city('Tomboru','sl','Eastern',5182.0,-10.62,8.13).
city('Wuima','sl','Eastern',3393.0,-11.22,8.3).
city('Yengema','sl','Eastern',17427.0,-11.17,8.72).
city('Alikalia','sl','Northern',3279.0,-11.4,9.17).
city('Bindi','sl','Northern',3331.0,-11.45,9.92).
city('Bumbuna','sl','Northern',3010.0,-11.73,9.05).
city('Gberia Fotombu','sl','Northern',3171.0,-11.17,9.88).
city('Kabala','sl','Northern',18754.0,-11.55,9.58).
city('Kamakwie','sl','Northern',8468.0,-12.23,9.5).
city('Kambia','sl','Northern',10279.0,-12.92,9.12).
city('Kasiri','sl','Northern',4605.0,-13.12,8.94).
city('Konakridie','sl','Northern',2992.0,-13.24,8.7).
city('Kukuna','sl','Northern',6849.0,-12.67,9.4).
city('Lowoma','sl','Northern',3592.0,-12.03,9.75).
city('Lungi','sl','Northern',7165.0,-13.24,8.67).
city('Lunsar','sl','Northern',21650.0,-12.55,8.69).
city('Magburaka','sl','Northern',13937.0,-11.95,8.72).
city('Makali','sl','Northern',3318.0,-11.67,8.63).
city('Makeni','sl','Northern',53930.0,-12.05,8.88).
city('Mambolo','sl','Northern',5911.0,-13.04,8.92).
city('Mange','sl','Northern',2980.0,-12.85,8.92).
city('Masiaka','sl','Northern',3008.0,-11.8,8.67).
city('Masingbi','sl','Northern',5902.0,-11.95,8.78).
city('Masoyila','sl','Northern',3526.0,-13.19,8.61).
city('Mile Ninetyone','sl','Northern',9712.0,-12.31,8.57).
city('Moriba','sl','Northern',2701.0,-11.98,9.22).
city('Moyamba','sl','Northern',8732.0,-12.44,8.17).
city('Pepel','sl','Northern',4301.0,-13.06,8.59).
city('Port Loko','sl','Northern',20539.0,-12.8,8.77).
city('Rokupr','sl','Northern',11157.0,-12.4,8.67).
city('Sawkta','sl','Northern',3327.0,-13.2,8.63).
city('Tintanfore','sl','Northern',5263.0,-13.22,8.63).
city('Yele','sl','Northern',3155.0,-11.84,8.42).
city('Yeliboya','sl','Northern',4087.0,-13.29,8.97).
city('Yonibana','sl','Northern',3354.0,-12.25,8.44).
city('Baiima','sl','Southern',2826.0,-11.85,8.1).
city('Bo','sl','Southern',80506.0,-11.74,7.97).
city('Bomi','sl','Southern',3583.0,-11.53,7.25).
city('Bonthe','sl','Southern',9712.0,-12.51,7.53).
city('Bumpeh','sl','Southern',10178.0,-11.92,7.9).
city('Foindu','sl','Southern',3848.0,-11.55,7.42).
city('Gandorhun','sl','Southern',7003.0,-11.84,7.5).
city('Gbeworbu','sl','Southern',2703.0,-11.61,7.55).
city('Koribondo','sl','Southern',3460.0,-11.69,7.71).
city('Kpetewoma','sl','Southern',3582.0,-12.62,7.95).
city('Largo','sl','Southern',4484.0,-12.15,8.27).
city('Mamboma','sl','Southern',3898.0,-11.68,8.08).
city('Masabendu','sl','Southern',3233.0,-11.98,7.22).
city('Mattru','sl','Southern',7818.0,-12.18,7.6).
city('Mogbemo','sl','Southern',2908.0,-12.31,7.77).
city('Potoru','sl','Southern',3238.0,-11.48,7.51).
city('Pujehun','sl','Southern',5198.0,-11.72,7.35).
city('Rotifunk','sl','Southern',6331.0,-12.68,8.23).
city('Serabu','sl','Southern',3194.0,-12.05,7.8).
city('Sumbuya','sl','Southern',5302.0,-11.96,7.65).
city('Tongola','sl','Southern',3210.0,-11.9,7.45).
city('Yamandu','sl','Southern',5524.0,-11.8,8.18).
city('Zimmi','sl','Southern',3145.0,-11.31,7.32).
city('Freetown','sl','Western',1190761.0,-13.24,8.49).
city('Goderich','sl','Western',14794.0,-13.29,8.43).
city('Hastings','sl','Western',5502.0,-13.14,8.38).
city('Waterloo','sl','Western',21222.0,-13.07,8.34).
city('Banska Bystrica','sk','Banskobystricky',82336.0,19.15,48.74).
city('Banska Stiavnica','sk','Banskobystricky',10874.0,18.89,48.46).
city('Brezno','sk','Banskobystricky',23055.0,19.64,48.81).
city('Detva','sk','Banskobystricky',15122.0,19.33,48.58).
city('Filakovo','sk','Banskobystricky',10198.0,19.82,48.28).
city('Hnusta','sk','Banskobystricky',7557.0,19.95,48.57).
city('Hrinova','sk','Banskobystricky',8289.0,19.53,48.59).
city('Kremnica','sk','Banskobystricky',5822.0,18.91,48.7).
city('Krupina','sk','Banskobystricky',7991.0,19.06,48.35).
city('Lucenec','sk','Banskobystricky',28159.0,19.66,48.34).
city('Nova Bana','sk','Banskobystricky',7505.0,18.64,48.44).
city('Poltar','sk','Banskobystricky',6099.0,19.8,48.44).
city('Revuca','sk','Banskobystricky',13466.0,20.11,48.69).
city('Rimavska Sobota','sk','Banskobystricky',25235.0,20.02,48.39).
city('Sliac','sk','Banskobystricky',4667.0,19.14,48.62).
city('Tisovec','sk','Banskobystricky',4215.0,19.94,48.68).
city('Tornala','sk','Banskobystricky',8169.0,20.33,48.42).
city('Velky Krtis','sk','Banskobystricky',14013.0,19.35,48.2).
city('Zarnovica','sk','Banskobystricky',6596.0,18.73,48.49).
city('Ziar','sk','Banskobystricky',19392.0,18.86,48.59).
city('Zvolen','sk','Banskobystricky',44502.0,19.14,48.58).
city('Bratislava','sk','Bratislavsky',423737.0,17.13,48.16).
city('Malacky','sk','Bratislavsky',17773.0,17.02,48.44).
city('Modra','sk','Bratislavsky',8536.0,17.31,48.34).
city('Pezinok','sk','Bratislavsky',21343.0,17.27,48.29).
city('Senec','sk','Bratislavsky',14673.0,17.4,48.23).
city('Stupava','sk','Bratislavsky',8063.0,17.03,48.29).
city('Svaety Jur','sk','Bratislavsky',4614.0,17.21,48.25).
city('Cierna nad Tisou','sk','Kosicky',4645.0,22.09,48.42).
city('Dobsina','sk','Kosicky',4896.0,20.36,48.82).
city('Gelnica','sk','Kosicky',6404.0,20.93,48.85).
city('Kosice','sk','Kosicky',236563.0,21.26,48.73).
city('Kralovsky Chlmec','sk','Kosicky',8031.0,21.93,48.88).
city('Krompachy','sk','Kosicky',8812.0,20.86,48.92).
city('Medzev','sk','Kosicky',3667.0,20.89,48.7).
city('Michalovce','sk','Kosicky',40360.0,21.91,48.76).
city('Moldava nad Bodvou','sk','Kosicky',9525.0,20.99,48.62).
city('Roznava','sk','Kosicky',19261.0,20.54,48.67).
city('Secovce','sk','Kosicky',7819.0,21.66,48.71).
city('Sobrance','sk','Kosicky',6262.0,22.18,48.76).
city('Strazske','sk','Kosicky',4474.0,21.83,48.87).
city('Trebisov','sk','Kosicky',22947.0,21.73,48.64).
city('Velke Kapusany','sk','Kosicky',9760.0,22.09,48.56).
city('Vranov','sk','Kosicky',23246.0,21.69,48.89).
city('Hurbanovo','sk','Nitriansky',8153.0,18.19,47.89).
city('Kolarovo','sk','Nitriansky',10823.0,17.99,47.92).
city('Komarno','sk','Nitriansky',37365.0,18.13,47.76).
city('Levice','sk','Nitriansky',37574.0,18.6,48.22).
city('Levoca','sk','Nitriansky',14366.0,18.61,48.22).
city('Nitra','sk','Nitriansky',86329.0,18.08,48.31).
city('Nove Zamky','sk','Nitriansky',42044.0,18.16,47.98).
city('Sahy','sk','Nitriansky',8061.0,18.93,48.08).
city('Sala','sk','Nitriansky',24513.0,17.88,48.15).
city('Sturovo','sk','Nitriansky',11708.0,18.72,47.8).
city('Surany','sk','Nitriansky',10491.0,18.19,48.09).
city('Svodin','sk','Nitriansky',2649.0,18.5,47.91).
city('Tlmace','sk','Nitriansky',4305.0,18.53,48.29).
city('Vrable','sk','Nitriansky',9493.0,18.32,48.24).
city('Zlate Moravce','sk','Nitriansky',15618.0,18.4,48.39).
city('Bardejov','sk','Presovsky',34209.0,21.27,49.29).
city('Giraltovce','sk','Presovsky',4189.0,21.51,49.12).
city('Humenne','sk','Presovsky',35367.0,21.91,48.93).
city('Kezmarok','sk','Presovsky',21391.0,20.42,49.14).
city('Lipany','sk','Presovsky',6130.0,20.96,49.16).
city('Medzilaborce','sk','Presovsky',6741.0,21.91,49.27).
city('Podolinec','sk','Presovsky',3173.0,20.54,49.26).
city('Poprad','sk','Presovsky',57431.0,20.3,49.06).
city('Presov','sk','Presovsky',94718.0,21.24,48.99).
city('Sabinov','sk','Presovsky',12290.0,21.1,49.1).
city('Snina','sk','Presovsky',22221.0,22.15,48.99).
city('Spisska Bela','sk','Presovsky',6136.0,20.46,49.19).
city('Spisska Nova Ves','sk','Presovsky',39195.0,20.56,48.95).
city('Spisske Podhradie','sk','Presovsky',3780.0,20.75,49.0).
city('Stara Lubovna','sk','Presovsky',16227.0,20.69,49.3).
city('Stropkov','sk','Presovsky',10874.0,21.65,49.2).
city('Svidnik','sk','Presovsky',12428.0,21.56,49.31).
city('Svit','sk','Presovsky',7445.0,20.19,49.07).
city('Velky Saris','sk','Presovsky',4018.0,21.2,49.05).
city('Banovce','sk','Trenciansky',21328.0,18.25,48.72).
city('Bojnice','sk','Trenciansky',5006.0,18.58,48.79).
city('Dubnica','sk','Trenciansky',26617.0,18.18,48.97).
city('Handlova','sk','Trenciansky',18018.0,18.76,48.73).
city('Ilava','sk','Trenciansky',5411.0,18.23,49.01).
city('Myjava','sk','Trenciansky',13142.0,17.57,48.77).
city('Nemsova','sk','Trenciansky',6136.0,18.11,48.97).
city('Nova Dubnica','sk','Trenciansky',12358.0,18.14,48.95).
city('Novaky','sk','Trenciansky',4402.0,18.55,48.72).
city('Nove Mesto','sk','Trenciansky',21527.0,17.83,48.75).
city('Partizanske','sk','Trenciansky',24370.0,18.4,48.64).
city('Povazska Bystrica','sk','Trenciansky',43936.0,18.44,49.12).
city('Prievidza','sk','Trenciansky',52987.0,18.62,48.78).
city('Puchov','sk','Trenciansky',18833.0,18.32,49.12).
city('Stara Tura','sk','Trenciansky',10291.0,17.7,48.79).
city('Topolcany','sk','Trenciansky',27712.0,18.16,48.57).
city('Trencianske Teplice','sk','Trenciansky',4438.0,18.16,48.92).
city('Trencin','sk','Trenciansky',58278.0,18.05,48.9).
city('Brezova pod Bradlom','sk','Trnavsky',5567.0,17.54,48.67).
city('Dunajska Streda','sk','Trnavsky',23639.0,17.61,48.0).
city('Galanta','sk','Trnavsky',16365.0,17.73,48.2).
city('Gbely','sk','Trnavsky',5223.0,17.13,48.72).
city('Hlohovec','sk','Trnavsky',23930.0,17.8,48.44).
city('Holic','sk','Trnavsky',11416.0,17.16,48.82).
city('Leopoldov','sk','Trnavsky',3999.0,17.77,48.45).
city('Piestany','sk','Trnavsky',29788.0,17.82,48.6).
city('Samorin','sk','Trnavsky',12143.0,17.32,48.03).
city('Senica','sk','Trnavsky',21741.0,17.37,48.68).
city('Sered','sk','Trnavsky',17406.0,17.74,48.3).
city('Skalica','sk','Trnavsky',15013.0,17.23,48.85).
city('Sladkovicovo','sk','Trnavsky',6078.0,17.65,48.21).
city('Trnava','sk','Trnavsky',69785.0,17.58,48.38).
city('Velky Meder','sk','Trnavsky',9113.0,17.77,47.86).
city('Vrbove','sk','Trnavsky',6249.0,17.73,48.64).
city('Bytca','sk','Zilinsky',11550.0,18.56,49.23).
city('Cadca','sk','Zilinsky',27281.0,18.78,49.44).
city('Dolny Kubin','sk','Zilinsky',20401.0,19.3,49.22).
city('Kysucke Nove Mesto','sk','Zilinsky',16558.0,18.78,49.3).
city('Liptovsky Hradok','sk','Zilinsky',8232.0,19.73,49.04).
city('Liptovsky Mikulas','sk','Zilinsky',33509.0,19.61,49.08).
city('Martin','sk','Zilinsky',60817.0,18.91,49.07).
city('Namestovo','sk','Zilinsky',8135.0,19.48,49.42).
city('Rajec','sk','Zilinsky',6400.0,18.63,49.09).
city('Ruzomberok','sk','Zilinsky',30806.0,19.31,49.08).
city('Trstena','sk','Zilinsky',7461.0,19.61,49.37).
city('Turcianske Teplice','sk','Zilinsky',7031.0,18.86,48.87).
city('Turzovka','sk','Zilinsky',7854.0,18.63,49.41).
city('Tvrdosin','sk','Zilinsky',9544.0,19.56,49.34).
city('Vrutky','sk','Zilinsky',7298.0,18.91,49.12).
city('Zilina','sk','Zilinsky',85985.0,18.74,49.22).
city('Bistrica ob Trzicu','si','Gorenjska',3161.0,14.29,46.35).
city('Bled','si','Gorenjska',5205.0,14.11,46.38).
city('Jesenice','si','Gorenjska',12511.0,14.04,46.44).
city('Koroska Bela','si','Gorenjska',2212.0,14.1,46.44).
city('Kranj','si','Gorenjska',34950.0,14.36,46.25).
city('Kranjska','si','Gorenjska',1414.0,13.79,46.48).
city('Lesce','si','Gorenjska',2788.0,14.16,46.36).
city('Radovljica','si','Gorenjska',5978.0,14.17,46.37).
city('Sencur','si','Gorenjska',2745.0,14.42,46.25).
city('Skofja Loka','si','Gorenjska',12013.0,14.29,46.17).
city('Slovenski Javornik','si','Gorenjska',1907.0,14.1,46.43).
city('Trzic','si','Gorenjska',3925.0,14.32,46.37).
city('Zelezniki','si','Gorenjska',3175.0,14.17,46.23).
city('Ziri','si','Gorenjska',3587.0,14.11,46.04).
city('Ajdovscina','si','Goriska',6527.0,13.9,45.89).
city('Idrija','si','Goriska',5784.0,14.02,46.0).
city('Kromberk','si','Goriska',1813.0,13.67,45.96).
city('Nova Gorica','si','Goriska',12748.0,13.65,45.95).
city('Rence','si','Goriska',1836.0,13.67,45.89).
city('Sempeter','si','Goriska',3886.0,13.64,45.93).
city('Solkan','si','Goriska',3252.0,13.65,45.97).
city('Spodnja Idrija','si','Goriska',1853.0,14.03,46.03).
city('Tolmin','si','Goriska',3684.0,13.74,46.19).
city('Vrtojba','si','Goriska',2385.0,13.63,45.91).
city('Crnomelj','si','Jugovzodna Slovenija',5840.0,15.19,45.57).
city('Kocevje','si','Jugovzodna Slovenija',8841.0,14.86,45.65).
city('Metlika','si','Jugovzodna Slovenija',3237.0,15.31,45.65).
city('Novo Mesto','si','Jugovzodna Slovenija',22417.0,15.16,45.8).
city('Ribnica','si','Jugovzodna Slovenija',3482.0,14.73,45.74).
city('Straza','si','Jugovzodna Slovenija',1978.0,15.07,45.78).
city('Trebnje','si','Jugovzodna Slovenija',3162.0,15.02,45.9).
city('Crna na Koroskem','si','Koroska',2346.0,15.85,46.47).
city('Dravograd','si','Koroska',3381.0,15.02,46.59).
city('Mezica','si','Koroska',3445.0,14.85,46.52).
city('Mislinja','si','Koroska',1852.0,15.2,46.44).
city('Muta','si','Koroska',2410.0,15.17,46.61).
city('Prevalje','si','Koroska',4469.0,14.92,46.55).
city('Radlje ob Dravi','si','Koroska',2661.0,15.23,46.61).
city('Ravne','si','Koroska',7671.0,15.0,45.97).
city('Slovenj Gradec','si','Koroska',7933.0,15.08,46.52).
city('Cerknica','si','Notranjsko-kraska',3531.0,14.37,45.8).
city('Ilirska Bistrica','si','Notranjsko-kraska',4846.0,14.24,45.57).
city('Pivka','si','No',2051.0,14.2,45.68).
city('Postojna','si','Notranjsko-kraska',8626.0,14.21,45.78).
city('Rakek','si','Notranjsko-kraska',1966.0,14.31,45.81).
city('Ankaran','si','Obalno-kraska',2895.0,13.75,45.58).
city('Izola','si','Obalno-kraska',10355.0,13.66,45.54).
city('Jagodje','si','Obalno-kraska',2143.0,13.66,45.53).
city('Koper','si','Obalno-kraska',23273.0,13.73,45.55).
city('Lucija','si','Obalno-kraska',6036.0,13.61,45.5).
city('Piran','si','Obalno-kraska',4032.0,13.56,45.53).
city('Portoroz','si','Obalno-kraska',2769.0,13.59,45.52).
city('Sezana','si','Obalno-kraska',4797.0,13.87,45.71).
city('Borovnica','si','Osrednjeslovenska',2115.0,14.36,45.92).
city('Brezovica pri Ljubljani','si','Osrednjeslovenska',2345.0,14.4,46.03).
city('Domzale','si','Osrednjeslovenska',11647.0,14.6,46.14).
city('Grosuplje','si','Osrednjeslovenska',6256.0,14.66,45.96).
city('Ig','si','Osrednjeslovenska',2078.0,14.53,45.96).
city('Kamnik','si','Osrednjeslovenska',12584.0,14.6,46.23).
city('Litija','si','Osrednjeslovenska',6459.0,14.83,46.06).
city('Ljubljana','si','Osrednjeslovenska',255115.0,14.51,46.06).
city('Logatec','si','Osrednjeslovenska',8014.0,14.23,45.92).
city('Medvode','si','Osrednjeslovenska',4954.0,14.43,46.13).
city('Menges','si','Osrednjeslovenska',5742.0,14.58,46.17).
city('Skofljica','si','Osrednjeslovenska',1972.0,14.58,45.98).
city('Trzin','si','Osrednjeslovenska',3420.0,14.57,46.13).
city('Verd','si','Osrednjeslovenska',1846.0,14.31,45.96).
city('Vir','si','Osrednjeslovenska',3102.0,14.82,45.95).
city('Vnanje Gorice','si','Osrednjeslovenska',1837.0,14.42,46.01).
city('Vrhnika','si','Osrednjeslovenska',7623.0,14.29,45.97).
city('Lenart','si','Podravska',2567.0,15.83,46.58).
city('Limbus','si','Podravska',1983.0,15.58,46.55).
city('Lovrenc na Pohorju','si','Podravska',2003.0,15.39,46.54).
city('Maribor','si','Podravska',89056.0,15.64,46.55).
city('Miklavz na Dravskem Polju','si','Podravska',3799.0,15.7,46.51).
city('Ormoz','si','Podravska',2198.0,16.15,46.41).
city('Pesnica pri Mariboru','si','Podravska',813.0,15.68,46.6).
city('Ptuj','si','Podravska',18141.0,15.86,46.42).
city('Race','si','Podravska',2246.0,15.68,46.45).
city('Ruse','si','Podravska',4497.0,15.52,46.54).
city('Slovenska Bistrica','si','Podravska',6561.0,15.56,46.4).
city('Spodnje Hoce','si','Podravska',2107.0,15.65,46.5).
city('Beltinci','si','Pomurska',2258.0,16.24,46.61).
city('Gornja Radgona','si','Pomurska',3194.0,15.99,46.67).
city('Lendava','si','Pomurska',3377.0,16.45,46.56).
city('Ljutomer','si','Pomurska',3387.0,16.2,46.52).
city('Murska Sobota','si','Pomurska',12412.0,16.15,46.66).
city('Radenci','si','Pomurska',2149.0,16.04,46.65).
city('Celje','si','Savin',37115.0,15.27,46.24).
city('Lasko','si','Savinjska',3389.0,15.24,46.15).
city('Mozirje','si','Savinjska',1957.0,14.96,46.34).
city('Polzela','si','Savinjska',2363.0,15.07,46.28).
city('Radece','si','Savinjska',2291.0,15.18,46.07).
city('Rogaska Slatina','si','Savinjska',4724.0,15.64,46.24).
city('Sempeter','si','Savinjska',1901.0,15.12,46.26).
city('Sentjur','si','Savinjska',4710.0,15.4,46.22).
city('Slovenske Konjice','si','Savinjska',4830.0,15.43,46.34).
city('Sostanj','si','Savinjska',2776.0,15.05,46.38).
city('Store','si','Savinjska',1872.0,15.31,46.22).
city('Velenje','si','Savinjska',26426.0,15.11,46.37).
city('Vojnik','si','Savinjska',1964.0,15.3,46.29).
city('Zalec','si','Savinjska',4859.0,15.17,46.25).
city('Zrece','si','Savinjska',2874.0,15.38,46.38).
city('Brezice','si','Spodnjeposavska',6298.0,15.58,45.9).
city('Krsko','si','Spodnjeposavska',6926.0,15.47,45.97).
city('Senovo','si','Spodnjeposavska',2404.0,15.48,46.02).
city('Sevnica','si','Spodnjeposavska',4836.0,15.32,46.01).
city('Hrast','si','Zasavska',5800.0,15.1,46.15).
city('Trbovlje','si','Zasavska',15993.0,15.03,46.15).
city('Zagorje ob Savi','si','Zasavska',6799.0,15.0,46.14).
city('Tulagi','sb','Central',1472.0,160.15,-9.09).
city('Taro Island','sb','Choiseul',507.0,156.43,-6.72).
city('Honiara','sb','Guadalcanal',56312.0,159.91,-9.43).
city('Buala','sb','Isabel',2689.0,159.62,-8.16).
city('Kirakira','sb','Makira and Ulawa',1122.0,161.88,-10.44).
city('Auki','sb','Malaita',4336.0,160.7,-8.76).
city('Tigoa','sb','Rennell and Bellona',213.0,160.03,-11.54).
city('Lata','sb','Temotu',539.0,165.83,-10.71).
city('Gizo','sb','Western',6155.0,156.85,-8.1).
city('Baki','so','Awdal',19472.0,43.12,10.53).
city('Borama','so','Awdal',38075.0,43.19,9.92).
city('Gebilay','so','Awdal',7565.0,43.11,9.7).
city('Sayla','so','Awdal',8351.0,43.5,11.36).
city('Tayeglo','so','Bakol',2119.0,44.51,4.02).
city('Xuddur','so','Bakol',13303.0,43.87,4.1).
city('Yet','so','Bakol',8429.0,43.03,4.53).
city('Mogadishu','so','Banadir',2590180.0,45.33,2.05).
city('Alula','so','Bari',5057.0,50.76,11.97).
city('Bandarbeyla','so','Bari',13753.0,50.81,9.5).
city('Bandarmuayo','so','Bari',6040.0,50.44,11.66).
city('Bargal','so','Bari',6798.0,51.05,11.27).
city('Bereda','so','Bari',11262.0,51.05,11.85).
city('Bosaso','so','Bari',74287.0,49.18,11.28).
city('Iskusuban','so','Bari',5759.0,50.23,10.26).
city('Qandala','so','Bari',15923.0,49.87,11.46).
city('Qardo','so','Bari',39115.0,49.08,9.5).
city('Xafun','so','Bari',10919.0,51.26,10.42).
city('Baydabo','so','Bay',129839.0,43.64,3.12).
city('Bur Hakkaba','so','Bay',27792.0,44.08,2.8).
city('Dinsor','so','Bay',16149.0,42.97,2.48).
city('Dusa Marreb','so','Galgudud',8658.0,46.51,5.75).
city('Elbur','so','Galgudud',9031.0,46.62,4.69).
city('Eldere','so','Galgudud',26562.0,47.18,3.85).
city('Bardere','so','Gedo',42240.0,42.28,2.34).
city('Dolaw','so','Gedo',22126.0,42.08,4.17).
city('Dujuma','so','Gedo',2432.0,42.56,1.26).
city('Garbaharey','so','Gedo',12652.0,42.23,3.33).
city('Luq','so','Gedo',33820.0,42.54,3.79).
city('Sao','so','Gedo',7893.0,42.44,1.63).
city('Wajid','so','Gedo',6666.0,43.24,3.82).
city('Balad','so','Hiran',19914.0,45.3,4.48).
city('Beled Weyne','so','Hiran',55410.0,45.19,4.73).
city('Bulobarde','so','Hiran',16928.0,45.57,3.86).
city('Jalalassi','so','Hiran',9743.0,45.59,3.39).
city('Jilib','so','Jubbada Dexe',43694.0,42.77,0.5).
city('Afmadu','so','Jubbada Hose',11939.0,42.06,0.52).
city('Bur Gabo','so','Jubbada Hose',3096.0,41.83,-1.21).
city('Jamame','so','Jubbada Hose',185270.0,42.75,0.08).
city('Kismayo','so','Jubbada Hose',234884.0,42.53,-0.35).
city('Galkayo','so','Mudug',61144.0,47.42,6.78).
city('Hobyo','so','Mudug',12564.0,48.52,5.35).
city('Xarardere','so','Mudug',2018.0,47.85,4.64).
city('Eyl','so','Nugal',18904.0,49.82,7.98).
city('Garowe','so','Nugal',49913.0,48.48,8.41).
city('Lasanod','so','Nugal',34427.0,47.33,8.4).
city('Adale','so','Sabellaha Dexe',5385.0,46.3,2.75).
city('Awdegle','so','Sabellaha Dexe',18682.0,44.83,1.99).
city('Jawhar','so','Sabellaha Dexe',47086.0,45.51,2.78).
city('Mahadday Weyne','so','Sabellaha Dexe',8273.0,45.53,2.99).
city('Afgoye','so','Sabellaha Hose',65461.0,45.12,2.14).
city('Barawe','so','Sabellaha Hose',27067.0,44.02,1.11).
city('Marka','so','Sabellaha Hose',320800.0,44.76,1.72).
city('Qoryoley','so','Sabellaha Hose',51720.0,44.53,1.79).
city('Wanlaweyn','so','Sabellaha Hose',22022.0,44.0,2.62).
city('Erigabo','so','Sanag',33853.0,47.36,10.63).
city('Lasqoray','so','Sanag',6941.0,48.18,11.15).
city('Buro','so','Togder',99270.0,45.53,9.53).
city('Ek','so','Togder',4325.0,45.36,9.0).
city('Odweyne','so','Togder',5491.0,45.06,9.41).
city('Adadlay','so','Woqoyi Galbed',9018.0,44.65,9.77).
city('Berbera','so','Woqoyi Galbed',242363.0,45.0,10.44).
city('Hargeysa','so','Woqoyi Galbed',478283.0,44.06,9.56).
city('Adelaide','za','Eastern Cape',12212.0,26.29,-32.7).
city('Alice','za','Eastern Cape',9788.0,26.83,-32.79).
city('Aliwal North','za','Eastern Cape',44475.0,26.71,-30.69).
city('Bisho','za','Eastern Cape',137288.0,27.39,-32.87).
city('Burgersdorp','za','Eastern Cape',12548.0,26.33,-30.99).
city('Butterworth','za','Eastern Cape',34353.0,28.1,-32.33).
city('Cradock','za','Eastern Cape',32900.0,25.61,-32.2).
city('East London','za','Eastern Cape',421562.0,27.87,-32.97).
city('Ekuphumleni','za','Eastern Cape',20975.0,26.79,-32.07).
city('Elliot','za','Eastern Cape',11836.0,27.85,-31.32).
city('Ezibeleni','za','Eastern Cape',20009.0,26.98,-31.87).
city('Fort Beaufort','za','Eastern Cape',58469.0,26.63,-32.77).
city('Graaff-Reinet','za','Eastern Cape',62921.0,24.54,-32.3).
city('Grahamstown','za','Eastern Cape',91552.0,26.52,-33.3).
city('Ilinge','za','Eastern Cape',10899.0,27.05,-31.96).
city('Jeffreys Bay','za','Eastern Cape',11698.0,24.92,-34.04).
city('Kirkwood','za','Eastern Cape',10148.0,25.42,-33.4).
city('Kruisfontein','za','Eastern Cape',18991.0,24.73,-34.0).
city('Lady Frere','za','Eastern Cape',25041.0,27.23,-31.69).
city('Middelburg','za','Eastern Cape',18164.0,25.01,-31.5).
city('Molteno','za','Eastern Cape',10078.0,26.37,-31.4).
city('Needscamp','za','Eastern Cape',18673.0,27.65,-33.15).
city('Port Alfred','za','Eastern Cape',17959.0,26.88,-33.6).
city('Port Elizabeth','za','Eastern Cape',967722.0,25.59,-33.96).
city('Queenstown','za','Eastern Cape',105315.0,26.88,-31.9).
city('Somerset East','za','Eastern Cape',16155.0,25.58,-32.72).
city('Stutterheim','za','Eastern Cape',35524.0,27.41,-32.56).
city('Uitenhage','za','Eastern Cape',228924.0,25.39,-33.76).
city('Umtata','za','Eastern Cape',78663.0,28.79,-31.58).
city('Umzimvubu','za','Eastern Cape',5939.0,29.54,-31.63).
city('Whittlesea','za','Eastern Cape',12080.0,26.82,-32.17).
city('Willowmore','za','Eastern Cape',7100.0,23.48,-33.29).
city('Allanridge','za','Free State',31718.0,26.67,-27.74).
city('Bethlehem','za','Free State',83658.0,28.3,-28.22).
city('Bloemfontein','za','Free State',463084.0,26.23,-29.15).
city('Botshabelo','za','Free State',309810.0,26.73,-29.23).
city('Brandfort','za','Free State',12091.0,26.47,-28.7).
city('Bulfontein','za','Free State',32152.0,26.23,-29.14).
city('Clocolan','za','Free State',12318.0,27.57,-28.91).
city('Deneysville','za','Free State',12397.0,28.1,-26.87).
city('Dordrecht','za','Free State',9123.0,27.06,-31.38).
city('Frankfort','za','Free State',38055.0,28.5,-27.27).
city('Harrismith','za','Free State',35108.0,29.13,-28.27).
city('Heilbron','za','Free State',55237.0,27.98,-27.28).
city('Hennenman','za','Free State',22847.0,27.03,-27.97).
city('Hoopstad','za','Free State',12663.0,25.92,-27.82).
city('Kgotsong','za','Free State',71988.0,26.62,-27.39).
city('Koppies','za','Free State',11445.0,27.58,-27.22).
city('Kroonstad','za','Free State',103997.0,27.21,-27.66).
city('Kutlwanong','za','Free State',95080.0,26.75,-27.84).
city('Ladybrand','za','Free State',17228.0,27.46,-29.19).
city('Marquard','za','Free State',10839.0,27.43,-28.66).
city('Parys','za','Free State',71373.0,27.46,-26.91).
city('Phuthaditjhaba','za','Free State',84286.0,28.81,-28.53).
city('Reitz','za','Free State',16637.0,28.43,-27.79).
city('Sasolburg','za','Free State',77016.0,27.84,-26.82).
city('Senekal','za','Free State',39614.0,27.62,-28.32).
city('Thaba Nchu','za','Free State',38616.0,26.83,-29.21).
city('Theunissen','za','Free State',34745.0,26.72,-28.4).
city('Ventersburg','za','Free State',10698.0,27.13,-28.07).
city('Viljoenskroon','za','Free State',55025.0,26.95,-27.21).
city('Villiers','za','Free State',11240.0,28.6,-27.02).
city('Virginia','za','Free State',122542.0,26.87,-28.09).
city('Vrede','za','Free State',14622.0,29.16,-27.43).
city('Vredefort','za','Free State',10649.0,27.38,-27.01).
city('Welkom','za','Fr',432070.0,26.73,-27.97).
city('Wesselsbron','za','Free State',42599.0,26.36,-27.84).
city('Winburg','za','Free State',11072.0,27.02,-28.52).
city('Zastron','za','Free State',12449.0,27.08,-30.29).
city('Alberton','za','Gauteng',202503.0,28.13,-26.33).
city('Benoni','za','Gauteng',605363.0,28.33,-26.15).
city('Boksburg','za','Gauteng',445182.0,28.23,-26.27).
city('Brakpan','za','Gauteng',305702.0,28.37,-26.29).
city('Bronkhorstspruit','za','Gauteng',27343.0,28.74,-25.8).
city('Carltonville','za','Gauteng',182310.0,27.37,-26.34).
city('Cullinan','za','Gauteng',25490.0,28.52,-25.67).
city('Heidelberg','za','Gauteng',64201.0,28.34,-26.53).
city('Johannesburg','za','Gauteng',2026466.0,28.04,-26.19).
city('Krugersdorp','za','Gauteng',378833.0,27.77,-26.09).
city('Midrand','za','Gauteng',173009.0,28.13,-26.0).
city('Nigel','za','Gauteng',140649.0,28.44,-26.4).
city('Pretoria','za','Gauteng',1619485.0,28.22,-25.73).
city('Randfontein','za','Gauteng',133659.0,27.7,-26.15).
city('Randvaal','za','Gauteng',16028.0,28.02,-26.58).
city('Soweto','za','Gauteng',1695094.0,27.84,-26.28).
city('Springs','za','Gauteng',186400.0,28.43,-26.27).
city('Temba','za','Gauteng',47983.0,28.26,-25.4).
city('Tembisa','za','Gauteng',511671.0,28.22,-25.99).
city('Vanderbijlpark','za','Gauteng',246821.0,27.82,-26.69).
city('Vereeniging','za','Gauteng',474680.0,27.96,-26.65).
city('Verwoerdburg','za','Gauteng',233394.0,28.2,-25.83).
city('Westonaria','za','Gauteng',156831.0,27.65,-26.32).
city('Ballitoville','za','KwaZulu Natal',17218.0,31.2,-29.54).
city('Dundee','za','KwaZulu Natal',84430.0,30.23,-28.16).
city('Durban','za','KwaZulu Natal',3120340.0,30.99,-29.87).
city('Ekuvukeni','za','KwaZulu Natal',14331.0,30.16,-28.47).
city('Emnambithi','za','KwaZulu Natal',117698.0,29.78,-28.55).
city('Empangeni','za','KwaZulu Natal',28094.0,31.89,-28.74).
city('Epumalanga','za','KwaZulu Natal',140125.0,30.61,-29.82).
city('Eshowe','za','KwaZulu Natal',14786.0,31.46,-28.88).
city('Esikhawini','za','KwaZulu Natal',49276.0,31.9,-28.88).
city('Glencoe','za','KwaZulu Natal',13547.0,30.15,-28.17).
city('Greytown','za','KwaZulu',13912.0,30.59,-29.06).
city('Howick','za','KwaZulu Natal',28726.0,30.22,-29.49).
city('Kokstad','za','KwaZulu Natal',25373.0,29.42,-30.55).
city('Margate','za','KwaZulu Natal',34407.0,30.37,-30.85).
city('Mondlo','za','KwaZulu Natal',44924.0,30.72,-27.98).
city('Mooi River','za','KwaZulu Natal',10132.0,29.99,-29.22).
city('Mpophomeni','za','KwaZulu Natal',26230.0,30.2,-29.56).
city('Ncotshane','za','KwaZulu Natal',28251.0,31.62,-27.38).
city('Newcastle','za','KwaZulu Natal',404849.0,29.92,-27.75).
city('Pietermaritzburg','za','KwaZulu Natal',750864.0,30.39,-29.61).
city('Port Shepstone','za','KwaZulu Natal',52804.0,30.46,-30.72).
city('Richards Bay','za','KwaZulu Natal',253156.0,32.09,-28.8).
city('Richmond','za','KwaZulu Natal',32445.0,30.29,-29.85).
city('Scottsburgh','za','KwaZulu Natal',23949.0,30.75,-30.28).
city('Stanger','za','KwaZulu Natal',59901.0,31.29,-29.34).
city('Sundumbili','za','KwaZulu Natal',12455.0,31.4,-29.13).
city('Ulundi','za','KwaZulu Natal',20763.0,31.41,-28.33).
city('Umkomaas','za','KwaZulu Natal',20410.0,30.8,-30.19).
city('Utrecht','za','KwaZulu Natal',3575.0,30.32,-27.66).
city('Vryheid','za','KwaZulu Natal',150079.0,30.79,-27.76).
city('Wembezi','za','KwaZulu Natal',25364.0,29.82,-29.03).
city('Duiwelskloof','za','Limpopo',24572.0,30.14,-23.69).
city('Ellisras','za','Limpopo',15360.0,27.75,-23.67).
city('Giyani','za','Limpopo',37047.0,30.72,-23.31).
city('Lebowakgomo','za','Limpopo',33329.0,29.5,-24.2).
city('Louis Trichardt','za','Limpopo',86854.0,29.89,-23.04).
city('Lulekani','za','Limpopo',26698.0,31.26,-23.92).
city('Mankweng','za','Limpopo',12500.0,29.82,-2.0).
city('Messina','za','Limpopo',20191.0,30.03,-22.34).
city('Nkowakowa','za','Limpopo',30157.0,30.28,-23.88).
city('Nylstroom','za','Limpopo',20527.0,28.4,-24.7).
city('Phalaborwa','za','Limpopo',109468.0,31.11,-23.95).
city('Pietersburg','za','Limpopo',123754.0,29.45,-23.89).
city('Potgietersrus','za','Limpopo',101090.0,29.0,-24.16).
city('Thabazimbi','za','Limpopo',10365.0,27.4,-24.59).
city('Thohoyandou','za','Limpopo',44046.0,30.48,-22.95).
city('Thulamahashe','za','Limpopo',11655.0,31.2,-24.72).
city('Tzaneen','za','Limpopo',16954.0,30.17,-23.82).
city('Warmbad','za','Limpopo',90300.0,28.29,-24.88).
city('Balfour','za','Mpumalanga',46039.0,28.59,-26.65).
city('Barberton','za','Mpumalanga',67971.0,31.05,-25.78).
city('Belfast','za','Mpumalanga',11916.0,30.03,-25.68).
city('Bethal','za','Mpumalanga',101986.0,29.45,-26.47).
city('Breyten','za','Mpumalanga',12550.0,29.98,-26.3).
city('Delmas','za','Mpumalanga',92181.0,28.68,-26.14).
city('Ekangala','za','Mpumalanga',37650.0,28.75,-25.68).
city('Embalenhle','za','Mpumalanga',141953.0,29.06,-26.53).
city('Empuluzi','za','Mpumalanga',14177.0,30.04,-26.54).
city('Ermelo','za','Mpumalanga',41201.0,29.98,-26.51).
city('Hendrina','za','Mpumalanga',15871.0,29.72,-26.14).
city('Komatipoort','za','Mpumalanga',20523.0,31.94,-25.41).
city('Kriel','za','Mpumalanga',15055.0,29.23,-26.26).
city('KwaNgema','za','Mpumalanga',28127.0,30.46,-27.0).
city('Lebohang','za','Mpumalanga',36881.0,28.92,-26.36).
city('Lydenburg','za','Mpumalanga',21695.0,30.45,-25.09).
city('Middelburg','za','Mpumalanga',154720.0,29.47,-25.76).
city('Nelspruit','za','Mpumalanga',110170.0,30.98,-25.47).
city('Phola','za','Mpumalanga',41972.0,29.05,-26.05).
city('Piet Retief','za','Mpumalanga',84403.0,30.81,-27.0).
city('Secunda','za','Mpumalanga',20452.0,29.17,-26.55).
city('Siyabuswa','za','Mpumalanga',26239.0,29.05,-25.12).
city('Standerton','za','Mpumalanga',74028.0,29.24,-26.94).
city('Volksrust','za','Mpumalanga',43382.0,29.89,-27.36).
city('Witbank','za','Mpumalanga',262514.0,29.22,-25.86).
city('Witrivier','za','Mpumalanga',15954.0,31.02,-25.31).
city('Bloemhof','za','North West',17122.0,25.59,-27.65).
city('Brits','za','North West',122576.0,27.78,-25.63).
city('Christiana','za','North West',17523.0,25.16,-27.92).
city('Fochville','za','North West',62528.0,27.5,-26.47).
city('GaRankuwa','za','North West',68767.0,27.98,-25.62).
city('Klerksdorp','za','North West',178928.0,26.62,-26.88).
city('Koster','za','North West',12126.0,26.9,-25.86).
city('Letsopa','za','North West',13641.0,25.99,-26.81).
city('Lichtenburg','za','North West',65863.0,26.16,-26.15).
city('Mabopane','za','North West',97417.0,28.08,-25.5).
city('Mmabatho','za','North West',76897.0,25.61,-25.83).
city('Mogwase','za','North West',11601.0,27.26,-25.22).
city('Orkney','za','North West',145843.0,26.64,-26.98).
city('Pampierstad','za','North West',21800.0,24.68,-27.78).
city('Potchefstroom','za','North West',123674.0,27.1,-26.7).
city('Rustenburg','za','North West',124064.0,27.24,-25.65).
city('Schweizer Reneke','za','North West',70290.0,25.33,-27.19).
city('Stilfontein','za','North West',93138.0,26.76,-26.84).
city('Vryburg','za','North West',49590.0,24.73,-26.96).
city('Wolmaranstad','za','North West',49436.0,25.98,-27.2).
city('Zeerust','za','North West',17708.0,26.08,-25.54).
city('Barkly West','za','Northern Cape',11621.0,24.53,-28.53).
city('Calvinia','za','Northern Cape',8146.0,19.77,-31.47).
city('Carnarvon','za','Northern Cape',5785.0,22.13,-30.97).
city('Colesberg','za','Northern Cape',12424.0,25.1,-30.72).
city('Danielskuil','za','Northern Cape',10123.0,23.53,-28.17).
city('De Aar','za','Northern Cape',32322.0,24.0,-30.65).
city('Jan Kempdorp','za','Northern Cape',1348.0,24.85,-27.91).
city('Kathu','za','Northern Cape',9219.0,23.05,-27.7).
city('Kimberley','za','Northern Cape',142105.0,24.77,-28.75).
city('Kuruman','za','Northern Cape',9093.0,23.42,-27.45).
city('Prieska','za','Northern Cape',11236.0,22.73,-29.66).
city('Ritchie','za','Northern Cape',9960.0,24.6,-29.04).
city('Springbok','za','Northern Cape',10438.0,17.88,-29.67).
city('Upington','za','Northern Cape',71381.0,21.23,-28.46).
city('Warrenton','za','Northern Cape',17946.0,24.84,-28.12).
city('Atlantis','za','Western Cape',60269.0,18.48,-33.57).
city('Beaufort-West','za','Western Cape',44739.0,22.57,-32.35).
city('Bredasdorp','za','Western Cape',14936.0,20.03,-34.53).
city('Caledon','za','Western Cape',4687.0,19.42,-34.22).
city('Cape Town','za','Western Cape',3433504.0,18.46,-33.93).
city('Ceres','za','Western Cape',41598.0,19.3,-33.36).
city('George','za','Western Cape',174591.0,22.45,-33.95).
city('Grabouw','za','Western Cape',29897.0,19.02,-34.14).
city('Hermanus','za','Western Cape',25153.0,19.23,-34.41).
city('Knysna','za','Western Cape',63110.0,23.06,-34.03).
city('Malmesbury','za','Western Cape',34993.0,18.72,-33.45).
city('Mooreesburg','za','Western Cape',10436.0,18.65,-33.13).
city('Mosselbay','za','Western Cape',71063.0,22.13,-34.17).
city('Oudtshoorn','za','Western Cape',76713.0,22.19,-33.58).
city('Paarl','za','Western Cape',187875.0,18.96,-33.7).
city('Plettenberg Bay','za','Western Cape',19445.0,23.37,-34.05).
city('Robertson','za','Western Cape',25217.0,19.98,-33.8).
city('Saldanha','za','Western Cape',68288.0,17.93,-33.01).
city('Somerset West','za','Western Cape',183503.0,18.84,-34.07).
city('Stellenbosch','za','Western Cape',94268.0,18.86,-33.92).
city('Swellendam','za','Western Cape',13675.0,20.43,-34.02).
city('Vredendal','za','Western Cape',14806.0,18.5,-31.64).
city('Worcester','za','Western Cape',127604.0,19.44,-33.64).
city('Aewol','kr','Cheju',23717.0,126.32,33.47).
city('Cheju','kr','Cheju',329076.0,126.52,33.51).
city('Sogwipo','kr','Cheju',95042.0,126.57,33.25).
city('Chongup','kr','Chollabuk',78152.0,126.84,35.57).
city('Chonju','kr','Chollabuk',711442.0,127.14,35.83).
city('Iksan','kr','Chollabuk',283510.0,126.95,35.94).
city('Kimje','kr','Chollabuk',44896.0,126.89,35.8).
city('Kochang','kr','Chollabuk',62559.0,126.69,35.43).
city('Kunsan','kr','Chollabuk',243413.0,126.71,35.99).
city('Namwon','kr','Chollabuk',58059.0,127.37,35.4).
city('Puan','kr','Chollabuk',22267.0,126.74,35.72).
city('Songtan','kr','Chollabuk',74098.0,127.54,35.74).
city('Haenam','kr','Chollanam',23929.0,126.6,34.57).
city('Hwasun','kr','Chollanam',59946.0,126.99,35.05).
city('Kwangyang','kr','Chollanam',89287.0,127.6,34.97).
city('Mokpo','kr','Chollanam',268417.0,126.39,34.8).
city('Naju','kr','Chollanam',42462.0,126.72,35.02).
city('Polgyo','kr','Chollanam',19843.0,127.34,34.84).
city('Sunchon','kr','Chollanam',230809.0,127.49,34.95).
city('Yochon','kr','Chollanam',126632.0,127.66,34.76).
city('Yonggwang','kr','Chollanam',19909.0,126.51,35.27).
city('Yosu','kr','Chollanam',342013.0,127.74,34.74).
city('Chechon','kr','Chungchongbuk',121594.0,128.22,37.14).
city('Chinchon','kr','Chungchongbuk',22911.0,127.42,36.86).
city('Chongju','kr','Chungchongbuk',634614.0,127.5,36.64).
city('Chungju','kr','Chungchongbuk',178028.0,127.94,36.98).
city('Okchon','kr','Chungchongbuk',30615.0,127.57,36.3).
city('Yongdong','kr','Chungchongbuk',24154.0,127.78,36.17).
city('Asan','kr','Chungchongnam',97753.0,126.98,36.79).
city('Chochiwon','kr','Chungchongnam',38871.0,127.29,36.61).
city('Chonan','kr','Chungchongnam',365172.0,127.16,36.81).
city('Hongsong','kr','Chungchongnam',37987.0,126.66,36.6).
city('Kongju','kr','Chungchongnam',72437.0,127.12,36.45).
city('Kumsan','kr','Chungchongnam',25243.0,127.49,36.1).
city('Nonsan','kr','Chungchongnam',43847.0,127.09,36.2).
city('Poryong','kr','Chungchongnam',62041.0,126.61,36.34).
city('Puyo','kr','Chungchongnam',32642.0,126.9,36.29).
city('Songhwan','kr','Chungchongnam',29239.0,127.13,36.92).
city('Sosan','kr','Chungchongnam',74210.0,126.44,36.79).
city('Taean','kr','Chungchongnam',66423.0,126.29,36.76).
city('Taesan','kr','Chungchongnam',23149.0,126.42,36.94).
city('Tangjin','kr','Chungchongnam',32780.0,126.63,36.9).
city('Yesan','kr','Chungchongnam',39411.0,126.84,36.69).
city('Yonmu','kr','Chungchongnam',25015.0,127.1,36.12).
city('Inchon','kr','Inchon',2580775.0,126.64,37.48).
city('Kanghwa','kr','Inchon',25535.0,126.48,37.75).
city('Chunchon','kr','Kangwon',209750.0,127.74,37.86).
city('Hongchon','kr','Kangwon',33263.0,127.89,37.69).
city('Kangnung','kr','Kangwon',180614.0,128.89,37.76).
city('Samchok','kr','Kangwon',42146.0,129.16,37.45).
city('Sokcho','kr','Kangwon',97782.0,128.55,38.24).
city('Taebaek','kr','Kangwon',48971.0,128.98,37.17).
city('Tonghae','kr','Kangwon',101130.0,129.12,37.49).
city('Wonju','kr','Kangwon',243391.0,127.94,37.35).
city('Yongwol','kr','Kangwon',25413.0,128.48,37.18).
city('Kwangju','kr','Kwangju',1416937.0,126.91,35.16).
city('Ansan','kr','Kyonggi',650809.0,126.86,37.35).
city('Ansong','kr','Kyonggi',69264.0,127.28,37.01).
city('Anyang','kr','Kyonggi',634413.0,126.92,37.39).
city('Hanam','kr','Kyonggi',134915.0,127.19,37.53).
city('Hwado','kr','Kyonggi',106594.0,127.29,37.65).
city('Ichon','kr','Kyonggi',101204.0,127.45,37.28).
city('Kimpo','kr','Kyonggi',169509.0,126.7,37.64).
city('Koyang','kr','Kyonggi',1195590.0,126.93,37.7).
city('Kunpo','kr','Kyonggi',316011.0,126.95,37.35).
city('Kuri','kr','Kyonggi',195262.0,127.13,37.59).
city('Kwachon','kr','Kyonggi',81282.0,126.99,37.42).
city('Kwangju','kr','Kyonggi',81791.0,127.25,37.41).
city('Kwangmyong','kr','Kyonggi',357763.0,126.84,37.45).
city('Munsan','kr','Kyonggi',43208.0,126.79,37.85).
city('Namyangju','kr','Kyonggi',90853.0,127.28,37.66).
city('Osan','kr','Kyonggi',158998.0,127.07,37.15).
city('Paengsong','kr','Kyonggi',43279.0,127.04,36.96).
city('Pochon','kr','Kyonggi',43181.0,127.2,37.89).
city('Pubal','kr','Kyonggi',63034.0,127.48,37.28).
city('Puchon','kr','Kyonggi',829409.0,126.77,37.48).
city('Pyongtaek','kr','Kyonggi',278387.0,127.1,36.98).
city('Shihung','kr','Kyonggi',621124.0,126.89,37.46).
city('Songnam','kr','Kyonggi',1032060.0,127.15,37.44).
city('Suwon','kr','Kyonggi',1242799.0,127.01,37.26).
city('Taean','kr','Kyonggi',37976.0,127.04,37.2).
city('Tongduchon','kr','Kyonggi',81003.0,127.05,37.92).
city('Uijongbu','kr','Kyonggi',479175.0,127.04,37.74).
city('Uiwang','kr','Kyonggi',136504.0,126.98,37.35).
city('Wabu','kr','Kyonggi',96990.0,127.22,37.58).
city('Yoju','kr','Kyonggi',37495.0,127.64,37.29).
city('Yongin','kr','Kyonggi',113661.0,127.12,37.28).
city('Andong','kr','Kyongsangbuk',129319.0,128.72,36.56).
city('Angang','kr','Kyongsangbuk',35083.0,129.24,35.98).
city('Hayang','kr','Kyongsangbuk',40423.0,128.82,35.91).
city('Hunghae','kr','Kyongsangbuk',36080.0,129.34,36.1).
city('Kimchon','kr','Kyongsangbuk',94091.0,128.13,36.11).
city('Kumi','kr','Kyongsangbuk',291004.0,128.35,36.13).
city('Kyongju','kr','Kyongsangbuk',155237.0,129.22,35.85).
city('Kyongsan','kr','Kyongsangbuk',129902.0,128.73,35.82).
city('Mungyong','kr','Kyongsangbuk',50329.0,128.11,36.74).
city('Ochon','kr','Kyongsangbuk',42448.0,129.41,35.96).
city('Odong','kr','Kyongsangbuk',20492.0,129.32,35.71).
city('Pohang','kr','Kyongsangbuk',305958.0,129.37,36.03).
city('Sangju','kr','Kyongsangbuk',55640.0,128.15,36.42).
city('Sonsan','kr','Kyongsangbuk',20673.0,128.31,36.25).
city('Waegwan','kr','Kyongsangbuk',29691.0,128.4,35.99).
city('Yechon','kr','Kyongsangbuk',21127.0,128.45,36.65).
city('Yongchon','kr','Kyongsangbuk',56006.0,128.93,35.96).
city('Yongju','kr','Kyongsangbuk',84625.0,128.62,36.83).
city('Yonil','kr','Kyongsangbuk',40851.0,129.35,35.99).
city('Changsungpo','kr','Kyongsangnam',56278.0,128.73,34.87).
city('Changwon','kr','Kyongsangnam',526389.0,128.62,35.27).
city('Chinhae','kr','Kyongsangnam',134898.0,128.66,35.15).
city('Chinju','kr','Kyongsangnam',307260.0,128.08,35.19).
city('Chinyong','kr','Kyongsangnam',28565.0,128.72,35.3).
city('Kimhae','kr','Kyongsangnam',356447.0,128.93,35.19).
city('Kochang','kr','Kyongsangnam',43713.0,127.9,35.68).
city('Koje','kr','Kyongsangnam',72132.0,128.58,34.86).
city('Kosong','kr','Kyongsangnam',26704.0,128.32,34.97).
city('Kumsong','kr','Kyongsangnam',78932.0,128.01,34.82).
city('Masan','kr','Kyongsangnam',349738.0,128.58,35.22).
city('Miryang','kr','Kyongsangnam',53107.0,128.76,35.49).
city('Naeso','kr','Kyongsangnam',81086.0,128.5,35.26).
city('Sachon','kr','Kyongsangnam',57927.0,128.07,34.93).
city('Sinhyon','kr','Kyongsangnam',82612.0,128.63,34.88).
city('Tongyong','kr','Kyongsangnam',89375.0,128.42,34.84).
city('Ungsang','kr','Kyongsangnam',83369.0,129.17,35.41).
city('Yangsan','kr','Kyongsangnam',71944.0,129.04,35.34).
city('Kijang','kr','Pusan',43070.0,129.22,35.23).
city('Pusan','kr','Pusan',3678551.0,129.03,35.11).
city('Soul','kr','Soul',1.0349291E7,126.99,37.56).
city('Hwawon','kr','Taegu',64758.0,128.47,35.79).
city('Taegu','kr','Taegu',2566537.0,128.6,35.87).
city('Taejon','kr','Taejon',1475220.0,127.43,36.33).
city('Nongso','kr','Ulsan',57597.0,129.36,35.62).
city('Ulsan','kr','Ulsan',962931.0,129.31,35.55).
city('A Coruna','es','A Coruna',236010.0,-8.42,43.33).
city('A Laracha','es','A Coruna',10696.0,-8.59,43.25).
city('A Pobra do Caraminal','es','A Coruna',10067.0,-8.94,42.61).
city('Ames','es','A Coruna',18960.0,-8.64,42.9).
city('Arteixo','es','A Coruna',23527.0,-8.51,43.3).
city('As Pontes de Garcia Rodriguez','es','A Coruna',12212.0,-7.84,43.45).
city('Betanzos','es','A Coruna',12629.0,-8.21,43.28).
city('Boiro','es','A Coruna',17916.0,-8.88,42.65).
city('Cambre','es','A Coruna',19445.0,-8.34,43.29).
city('Carballo','es','A Coruna',28409.0,-8.69,43.22).
city('Culleredo','es','A Coruna',22560.0,-8.39,43.29).
city('Fene','es','A Coruna',14633.0,-8.17,43.48).
city('Ferrol','es','A Coruna',78689.0,-8.24,43.49).
city('Muros','es','A Coruna',10252.0,-9.06,42.78).
city('Naron','es','A Coruna',32509.0,-8.17,43.52).
city('Noia','es','A Coruna',14352.0,-8.8,42.79).
city('Oleiros','es','A Coruna',27510.0,-8.32,43.34).
city('Ordes','es','A Coruna',12076.0,-8.41,43.08).
city('Ortiguera','es','A Coruna',8249.0,-7.86,43.69).
city('Padron','es','A Coruna',8925.0,-8.67,42.75).
city('Rianxo','es','A Coruna',11793.0,-8.82,42.65).
city('Ribeira','es','A Coruna',26333.0,-8.95,42.8).
city('Sada','es','A Coruna',11573.0,-8.26,43.35).
city('Santa Comba','es','A Coruna',10896.0,-8.83,43.04).
city('Santiago de Compostela','es','A Coruna',91141.0,-8.54,42.88).
city('Teo','es','A Coruna',15623.0,-8.5,42.75).
city('Alacant','es','Alacant',327013.0,-0.48,38.35).
city('Alcoi','es','Alacant',68180.0,-0.48,38.7).
city('Almoradi','es','Alacant',16415.0,-0.77,38.12).
city('Altea','es','Alacant',18588.0,-0.05,38.6).
city('Aspe','es','Alacant',19430.0,-0.79,38.35).
city('Benidorm','es','Alacant',60603.0,-0.14,38.55).
city('Callosa de Segura','es','Alacant',18465.0,-0.87,38.14).
city('Calp','es','Alacant',22059.0,0.05,38.66).
city('Cocentaina','es','Alacant',12404.0,-0.44,38.75).
city('Crevillent','es','Alacant',28957.0,-0.81,38.26).
city('Denia','es','Alacant',38953.0,0.11,38.85).
city('El Campello','es','Alacant',22475.0,-0.41,38.44).
city('Elda','es','Alacant',60276.0,-0.81,38.48).
city('Elx','es','Alacant',227546.0,-0.68,38.27).
city('Ibi','es','Alacant',25467.0,-0.57,38.64).
city('LAlfas del Pi','es','Alacant',12972.0,-0.11,38.59).
city('La Vila Joiosa','es','Alacant',27638.0,-0.24,38.51).
city('Monover','es','Alacant',13743.0,-0.84,38.44).
city('Mutxamel','es','Alacant',18176.0,-0.44,38.42).
city('Novelda','es','Alacant',28974.0,-0.78,38.39).
city('Orihuela','es','Alacant',63147.0,-0.95,38.09).
city('Pego','es','Alacant',11753.0,-0.15,38.84).
city('Petrer','es','Alacant',35210.0,-0.77,38.49).
city('Pilar de la Horadada','es','Alacant',14874.0,-0.79,37.87).
city('Sant Joan dAlacant','es','Alacant',19376.0,-0.44,38.4).
city('Sant Vicent del Raspeig','es','Alacant',46342.0,-0.52,38.4).
city('Santa Pola','es','Alacant',23111.0,-0.56,38.19).
city('Torrevieja','es','Alacant',59528.0,-0.69,37.98).
city('Villena','es','Alacant',38150.0,-0.87,38.64).
city('Xabia','es','Alacant',21909.0,0.16,38.79).
city('Amurrio','es','Alava',9806.0,-3.0,43.07).
city('Llodio','es','Alava',19623.0,-2.97,43.15).
city('Vitoria','es','Alava',224774.0,-2.67,42.85).
city('Albacete','es','Albacete',155083.0,-1.87,39.0).
city('Almansa','es','Albacete',24502.0,-1.11,38.87).
city('Hellin','es','Albacete',28691.0,-1.7,38.51).
city('La Roda','es','Albacete',14535.0,-2.17,39.21).
city('Villarrobledo','es','Albacete',23663.0,-2.61,39.27).
city('Adra','es','Almeria',23988.0,-3.02,36.76).
city('Albox','es','Almeria',10688.0,-2.14,37.39).
city('Almeria','es','Almeria',181497.0,-2.43,36.83).
city('Berja','es','Almeria',14526.0,-2.94,36.85).
city('El Ejido','es','Almeria',63155.0,-2.83,36.79).
city('Huercal-Overa','es','Almeria',16204.0,-1.95,37.39).
city('Ni','es','Almeria',19449.0,-2.22,36.97).
city('Roquetas de Mar','es','Almeria',54665.0,-2.61,36.77).
city('Vicar','es','Almeria',18315.0,-2.64,36.84).
city('Aller','es','Asturias',14428.0,-5.55,43.05).
city('Aviles','es','Asturias',81984.0,-5.91,43.56).
city('Cangas del Narcea','es','Asturias',16273.0,-6.55,43.19).
city('Carreno','es','Asturias',10412.0,-4.87,43.32).
city('Castrillon','es','Asturias',22176.0,-6.8,43.4).
city('Corvera de Asturias','es','Asturias',15656.0,-3.95,43.27).
city('Gijon','es','Asturias',262573.0,-5.67,43.53).
city('Grado','es','Asturias',11289.0,-6.08,43.4).
city('Langreo','es','Asturias',45071.0,-5.69,43.31).
city('Laviana','es','Asturias',14321.0,-5.54,43.25).
city('Lena','es','Asturias',13377.0,-5.83,43.17).
city('Llanera','es','Asturias',12124.0,-5.93,43.47).
city('Llanes','es','Asturias',13084.0,-4.76,43.42).
city('Mieres','es','Asturias',45510.0,-5.78,43.25).
city('Oviedo','es','Asturias',198250.0,-5.83,43.35).
city('Pravia','es','Asturias',9132.0,-6.12,43.39).
city('Siero','es','Asturias',47199.0,-5.66,43.4).
city('Tineo','es','Asturias',12416.0,-6.41,43.33).
city('Valdes','es','Asturias',14576.0,-5.32,43.37).
city('Villaviciosa','es','Asturias',13750.0,-5.44,43.48).
city('Avila','es','Avila',49408.0,-4.7,40.67).
city('Almendralejo','es','Badajoz',27423.0,-6.41,38.68).
city('Azuaga','es','Badajoz',8435.0,-5.69,38.26).
city('Badajoz','es','Badajoz',133042.0,-6.97,38.88).
city('Don Benito','es','Badajoz',31425.0,-5.87,38.96).
city('Jerez de los Caballeros','es','Badajoz',9458.0,6.77,38.33).
city('Merida','es','Badajoz',50333.0,-6.34,38.92).
city('Montijo','es','Badajoz',15199.0,-6.62,38.92).
city('Olivenza','es','Badajoz',10788.0,-7.1,38.69).
city('Villafranca de los Barros','es','Badajoz',12442.0,-6.33,38.56).
city('Villanueva de la Serena','es','Badajoz',24006.0,-5.8,38.98).
city('Zafra','es','Badajoz',15199.0,-6.41,38.42).
city('Alcudia','es','Balears',14436.0,3.12,39.85).
city('Calvia','es','Balears',41549.0,2.51,39.57).
city('Ciutadella de Menorca','es','Balears',26681.0,3.83,40.0).
city('Eivissa','es','Balears',40219.0,1.42,38.91).
city('Felanitx','es','Balears',17187.0,3.13,39.47).
city('Inca','es','Balears',26595.0,2.91,39.72).
city('Llucmajor','es','Balears',28037.0,2.88,39.49).
city('Mahon','es','Balears',26926.0,4.25,39.89).
city('Manacor','es','Balears',36095.0,3.2,39.57).
city('Marratxi','es','Balears',27035.0,2.8,39.65).
city('Palma','es','Balears',378884.0,2.65,39.57).
city('Pollenca','es','Balears',15946.0,3.0,39.88).
city('Sant Josep de sa Tal','es','Balears',16476.0,1.28,38.92).
city('Santa Eulalia del Rio','es','Balears',22876.0,1.51,38.99).
city('Soller','es','Balears',12658.0,2.71,39.77).
city('Arenys de Mar','es','Barcelona',13869.0,2.54,41.59).
city('Badalona','es','Barcelona',222413.0,2.24,41.45).
city('Barbera del Valles','es','Barcelona',28556.0,2.12,41.52).
city('Barcelona','es','Barcelona',1570378.0,2.17,41.4).
city('Berga','es','Barcelona',15860.0,1.84,42.11).
city('Caldes de Montbui','es','Barcelona',14963.0,2.16,41.64).
city('Calella','es','Bar',14797.0,2.66,41.62).
city('Canovelles','es','Barcelona',13952.0,2.27,41.63).
city('Cardedeu','es','Barcelona',13822.0,2.37,41.64).
city('Castellar del Valles','es','Barcelona',19725.0,2.08,41.63).
city('Castelldefels','es','Barcelona',50167.0,1.96,41.29).
city('Cerdanyola','es','Barcelona',57639.0,2.13,41.49).
city('Cornella','es','Barcelona',86420.0,2.06,41.37).
city('El Masnou','es','Barcelona',22343.0,2.35,41.5).
city('El Prat de Llobregat','es','Barcelona',66796.0,2.08,41.34).
city('Esplugues de Llobregat','es','Barcelona',487.0,2.08,41.37).
city('Gava','es','Barcelona',43021.0,2.0,41.31).
city('Granollers','es','Barcelona',57382.0,2.28,41.61).
city('Igualada','es','Barcelona',35711.0,1.61,41.6).
city('LHospitalet de Llobregat','es','Barcelona',258268.0,2.1,41.35).
city('La Garriga','es','Barcelona',13006.0,2.28,41.69).
city('La Llagosta','es','Barcelona',13012.0,2.18,41.52).
city('Malgrat de Mar','es','Barcelona',15524.0,2.74,41.65).
city('Manlleu','es','Barcelona',18944.0,2.28,42.0).
city('Manresa','es','Barcelona',69134.0,1.81,41.7).
city('Martorell','es','Barcelona',24877.0,1.93,41.47).
city('Mataro','es','Barcelona',114923.0,2.44,41.54).
city('Molins de Rei','es','Barcelona',22301.0,2.01,41.42).
city('Mollet del Valles','es','Barcelona',51077.0,2.21,41.55).
city('Montcada i Reixac','es','Barcelona',30574.0,2.18,41.49).
city('Montornes del Valles','es','Barcelona',13904.0,2.26,41.54).
city('Olesa de Montserrat','es','Barcelona',19436.0,-1.9,41.55).
city('Palau-solita i Plegamans','es','Barcelona',12301.0,2.18,41.6).
city('Parets del Valles','es','Barcelona',16190.0,2.23,41.59).
city('Pineda de Mar','es','Barcelona',22771.0,2.69,41.63).
city('Premia de Mar','es','Barcelona',28455.0,2.38,41.5).
city('Ripollet','es','Barcelona',32670.0,2.16,41.5).
city('Rubi','es','Barcelona',66084.0,2.03,41.5).
city('Sabadell','es','Barcelona',198589.0,2.1,41.55).
city('Sant Adria de Besos','es','Barcelona',34511.0,2.21,41.43).
city('Sant Andreu de la Barca','es','Barcelona',23699.0,1.97,41.45).
city('Sant Boi de Llobregat','es','Barcelona',83726.0,2.03,41.36).
city('Sant Celoni','es','Barcelona',13723.0,2.48,41.69).
city('Sant Cugat','es','Barcelona',65118.0,2.08,41.47).
city('Sant Feliu de Llobregat','es','Barcelona',43267.0,2.05,41.38).
city('Sant Joan Despi','es','Barcelona',31089.0,2.07,41.37).
city('Sant Just Desvern','es','Barcelona',14987.0,2.08,41.38).
city('Sant Pere de Ribes','es','Barcelona',24997.0,1.77,41.27).
city('Sant Quirze del Valles','es','Barcelona',14832.0,2.09,41.53).
city('Sant Vicenc dels Horts','es','Barcelona',26683.0,2.01,41.4).
city('Santa Coloma de Gramenet','es','Barcelona',122092.0,2.22,41.47).
city('Santa Perpetua de Mogoda','es','Barcelona',22128.0,2.18,41.54).
city('Sitges','es','Barcelona',21495.0,1.81,41.24).
city('Terrassa','es','Barcelona',187770.0,2.0,41.57).
city('Torello','es','Barcelona',13275.0,2.26,42.05).
city('Vic','es','Barcelona',35337.0,2.24,41.94).
city('Viladecans','es','Barcelona',61419.0,2.02,41.32).
city('Vilafranca del Penedes','es','Barcelona',33765.0,-1.68,41.35).
city('Vilanova del Cami','es','Barcelona',11015.0,1.63,41.57).
city('Vilanova i la Geltru','es','Barcelona',58597.0,1.72,41.23).
city('Aranda de Duero','es','Burgos',30326.0,-3.7,41.68).
city('Burgos','es','Burgos',168319.0,-3.69,42.35).
city('Miranda de Ebro','es','Burgos',36386.0,-2.95,42.69).
city('Caceres','es','Caceres',90938.0,-6.38,39.47).
city('Coria','es','Caceres',13287.0,-6.54,39.99).
city('Miajadas','es','Caceres',10733.0,-5.91,39.15).
city('Navalmoral de la Mata','es','Caceres',16752.0,-5.54,39.88).
city('Plasencia','es','Caceres',40337.0,-2.42,43.17).
city('Algeciras','es','Cadiz',104766.0,-5.45,36.13).
city('Arcos de la Frontera','es','Cadiz',28754.0,-5.81,36.76).
city('Barbate','es','Cadiz',22524.0,-5.93,36.2).
city('Cadiz','es','Cadiz',137698.0,-6.29,36.53).
city('Chiclana','es','Cadiz',63012.0,-6.15,36.42).
city('Chipiona','es','Cadiz',17400.0,-6.44,36.74).
city('Conil','es','Cadiz',18644.0,-6.08,36.29).
city('El Puerto de Santa Maria','es','Cadiz',78714.0,-6.23,36.61).
city('Jerez','es','Cadiz',189230.0,-6.13,36.68).
city('La Linea','es','Cadiz',61369.0,-5.36,36.17).
city('Los Barrios','es','Cadiz',18314.0,-5.5,36.18).
city('Medina-Sidonia','es','Cadiz',11077.0,-5.92,36.45).
city('Puerto Real','es','Cadiz',36946.0,-6.2,36.53).
city('Rota','es','Cadiz',25867.0,-6.36,36.63).
city('San Fernando','es','Cadiz',90936.0,-6.2,36.47).
city('San Roque','es','Cadiz',24198.0,-5.4,36.22).
city('Sanlucar de Barrameda','es','Cadiz',62213.0,-6.36,36.78).
city('Tarifa','es','Cadiz',16179.0,-5.6,36.02).
city('Ubrique','es','Cadiz',17961.0,-5.45,36.68).
city('Vejer de la Frontera','es','Cadiz',12948.0,5.96,36.26).
city('Villamartin','es','Cadiz',12342.0,-5.64,36.86).
city('Camargo','es','Cantabria',25107.0,-3.9,43.4).
city('Castro-Urdiales','es','Cantabria',21605.0,-3.22,43.39).
city('El Astillero','es','Cantabria',14710.0,-3.82,43.4).
city('Laredo','es','Cantabria',12871.0,-3.42,43.41).
city('Los Corrales de Buelna','es','Cantabria',11066.0,-4.07,43.27).
city('Reinosa','es','Cantabria',10960.0,-4.14,43.0).
city('Santander','es','Cantabria',185209.0,-3.8,43.47).
city('Santona','es','Cantabria',11328.0,-3.46,43.44).
city('Torrelavega','es','Cantabria',56856.0,-4.06,43.35).
city('Almassora','es','Castello',19296.0,-0.05,39.95).
city('Benicarlo','es','Castello',22871.0,0.41,40.43).
city('Benicassim','es','Castello',13868.0,0.06,40.05).
city('Burriana','es','Castello',29791.0,-0.1,39.89).
city('Castello','es','Castello',164411.0,-0.05,39.97).
city('La Vall dUixo','es','Castello',32248.0,-0.24,39.82).
city('Nules','es','Castello',12851.0,0.15,39.85).
city('Onda','es','Castello',22289.0,-0.27,39.96).
city('Vila-real','es','Castello',47255.0,-0.1,39.94).
city('Vinaros','es','Castello',24620.0,0.46,40.49).
city('Ceuta','es','Ceuta',71436.0,-5.3,35.91).
city('Alcazar de San Juan','es','Ciudad Real',26976.0,-3.21,39.39).
city('Bolanos de Calatrava','es','Ciudad Real',11535.0,-3.67,38.9).
city('Campo de Criptana','es','Ciudad Real',13470.0,-3.12,39.41).
city('Ciudad Real','es','Ciudad Real',64625.0,-3.94,38.98).
city('Daimiel','es','Ciudad Real',17466.0,-3.62,39.07).
city('La Solana','es','Ciudad Real',15374.0,-3.24,38.94).
city('Manzanares','es','Ciudad Real',18306.0,-3.38,39.0).
city('Puertollano','es','Ciudad Real',49130.0,-4.12,38.68).
city('Socuellamos','es','Ciudad Real',11920.0,-2.8,39.29).
city('Tomelloso','es','Ciudad Real',31320.0,-3.02,39.16).
city('Valdepenas','es','Ciudad Real',26840.0,-3.39,38.76).
city('Villarrubia de los Ojos','es','Ciudad Real',9933.0,-3.61,39.22).
city('Aguilar de la Frontera','es','Cordoba',13557.0,-4.65,37.52).
city('Baena','es','Cordoba',19349.0,-4.34,37.62).
city('Cabra','es','Cordoba',20806.0,-4.45,37.48).
city('Cordoba','es','Cordoba',311186.0,-4.77,37.88).
city('Fernan-Nunez','es','Cordoba',9484.0,-4.73,37.68).
city('Fuente Palmera','es','Cordoba',9925.0,-5.11,37.71).
city('La Carlota','es','Cordoba',10865.0,-4.93,37.69).
city('Lucena','es','Cordoba',37402.0,-4.49,37.41).
city('Montilla','es','Cordoba',23157.0,-4.64,37.6).
city('Montoro','es','Cordoba',9502.0,-4.38,38.03).
city('Palma del Rio','es','Cordoba',19265.0,-5.3,37.7).
city('Penarroya-Pueblonuevo','es','Cordoba',12566.0,-5.27,38.31).
city('Pozoblanco','es','Cordoba',16534.0,-4.85,38.38).
city('Priego de Cordoba','es','Cordoba',22604.0,-4.2,37.43).
city('Puente Genil','es','Cordoba',28287.0,-4.77,37.39).
city('Rute','es','Cordoba',10113.0,-4.37,37.32).
city('Villanueva de Cordoba','es','Cordoba',9880.0,-4.63,38.32).
city('Cuenca','es','Cuenca',47500.0,-2.14,40.08).
city('Tarancon','es','Cuenca',12081.0,-3.01,40.01).
city('Banyoles','es','Girona',16180.0,2.76,42.12).
city('Blanes','es','Girona',34894.0,2.79,41.69).
city('Figueres','es','Girona',37590.0,2.95,42.27).
city('Girona','es','Girona',85128.0,2.81,41.98).
city('Lloret de Mar','es','Girona',23009.0,2.85,41.7).
city('Olot','es','Girona',31901.0,2.48,42.19).
city('Palafrugell','es','Girona',20830.0,3.15,41.93).
city('Palamos','es','Girona',16874.0,3.13,41.86).
city('Ripoll','es','Girona',12047.0,2.19,42.2).
city('Roses','es','Girona',14468.0,3.17,42.27).
city('Salt','es','Girona',24145.0,2.78,41.99).
city('Sant Feliu de Guixols','es','Girona',20457.0,3.02,41.79).
city('Albolote','es','Granada',14355.0,-3.65,37.24).
city('Almunecar','es','Granada',22157.0,-3.69,36.75).
city('Armilla','es','Granada',15934.0,-3.62,37.15).
city('Atarfe','es','Granada',11535.0,-3.69,37.22).
city('Baza','es','Granada',22558.0,-2.79,37.5).
city('Granada','es','Granada',248942.0,-3.59,37.17).
city('Guadix','es','Granada',18814.0,-3.13,37.3).
city('Huescar','es','Granada',8182.0,-2.55,37.81).
city('Illora','es','Granada',10876.0,-3.89,37.29).
city('La Zubia','es','Granada',14643.0,-3.59,37.12).
city('Loja','es','Granada',20750.0,-4.15,37.17).
city('Maracena','es','Granada',17085.0,-3.64,37.2).
city('Motril','es','Granada',54313.0,-3.52,36.76).
city('Pinos Puente','es','Granada',13884.0,-3.75,37.25).
city('Salobrena','es','Granada',10725.0,-3.59,36.74).
city('Santa Fe','es','Granada',13265.0,-3.72,37.19).
city('Azuqueca de Henares','es','Guadalajara',24117.0,-3.27,40.57).
city('Guadalajara','es','Guadalajara',79616.0,-3.17,40.64).
city('Andoain','es','Guipuzcoa',13961.0,-2.02,43.23).
city('Arrasate','es','Guipuzcoa',23365.0,-2.49,43.08).
city('Azkoitia','es','Guipuzcoa',10382.0,-2.31,43.19).
city('Azpeitia','es','Guipuzcoa',13854.0,-2.27,43.19).
city('Beasain','es','Guipuzcoa',12237.0,-2.2,43.07).
city('Bergara','es','Guipuzcoa',15125.0,-2.42,43.12).
city('Donostia','es','Guipuzcoa',180280.0,-1.98,43.32).
city('Eibar','es','Guipuzcoa',28520.0,-2.45,43.19).
city('Elgoibar','es','Guipuzcoa',10551.0,-2.42,43.22).
city('Errenteria','es','Guipuzcoa',38632.0,-1.89,43.32).
city('Hernani','es','Guipuzcoa',18482.0,-1.97,43.27).
city('Hondarribia','es','Guipuzcoa',15205.0,-1.8,43.37).
city('Irun','es','Guipuzcoa',57205.0,-1.8,43.0).
city('Legazpi','es','Guipuzcoa',8834.0,2.34,43.05).
city('Onati','es','Guipuzcoa',10819.0,-2.41,43.05).
city('Oria','es','Guipuzcoa',17378.0,-2.02,43.27).
city('Tolosa','es','Guipuzcoa',17830.0,-2.08,43.14).
city('Zarautz','es','Guipuzcoa',21303.0,-2.17,43.29).
city('Zumarraga','es','Guipuzcoa',10284.0,-2.32,43.09).
city('Almonte','es','Huelva',18280.0,-6.52,37.27).
city('Ayamonte','es','Huelva',17026.0,-7.41,37.22).
city('Bollullos Par del Condado','es','Huelva',13305.0,-6.54,37.33).
city('Cartaya','es','Huelva',13854.0,-7.15,37.29).
city('Gibraleon','es','Huelva',10904.0,-6.98,37.38).
city('Huelva','es','Huelva',145901.0,-6.94,37.25).
city('Isla Cristina','es','Huelva',18651.0,-7.32,37.2).
city('La Palma del Condado','es','Huelva',9904.0,-6.56,37.39).
city('Lepe','es','Huelva',20176.0,-7.2,37.26).
city('Moguer','es','Huelva',15606.0,-6.84,37.28).
city('Punta Umbria','es','Huelva',12578.0,-6.97,37.18).
city('Valverde del Camino','es','Huelva',12747.0,-6.76,37.57).
city('Barbastro','es','Huesca',15598.0,0.12,42.04).
city('Fraga','es','Huesca',12538.0,0.35,41.53).
city('Huesca','es','Huesca',47919.0,-0.41,42.14).
city('Jaca','es','Huesca',11811.0,-0.55,42.57).
city('Monzon','es','Huesca',15461.0,0.18,41.92).
city('Alcala la Real','es','Jaen',21377.0,-3.93,37.46).
city('Alcaudete','es','Jaen',11197.0,-4.08,37.59).
city('Andujar','es','Jaen',36594.0,-4.06,38.04).
city('Baeza','es','Jaen',15149.0,-3.48,38.0).
city('Bailen','es','Jaen',17660.0,-3.78,38.11).
city('Jaen','es','Jaen',116291.0,-3.8,37.77).
city('Jodar','es','Jaen',12031.0,-3.35,37.85).
city('La Carolina','es','Jaen',14836.0,-3.62,38.29).
city('Linares','es','Jaen',56982.0,-3.63,38.1).
city('Martos','es','Jaen',22441.0,-3.98,37.72).
city('Torre del Campo','es','Jaen',13235.0,-3.89,37.77).
city('Torredonjimeno','es','Jaen',13701.0,-3.98,37.76).
city('Ubeda','es','Jaen',33052.0,-3.38,38.02).
city('Villacarrillo','es','Jaen',11063.0,-3.09,38.12).
city('Arnedo','es','La Rioja',14299.0,-2.12,42.23).
city('Calahorra','es','La Rioja',21923.0,-2.08,42.34).
city('Logrono','es','La Rioja',142103.0,-2.44,42.47).
city('Agueimes','es','Las Palmas',21908.0,-15.46,27.9).
city('Arrecife','es','Las Palmas',48968.0,-13.55,28.96).
city('Arucas','es','Las Palmas',35344.0,-15.53,28.11).
city('Galdar','es','Las Palmas',24118.0,-15.66,28.15).
city('Ingenio','es','Las Palmas',26606.0,-15.44,27.92).
city('Las Palmas','es','Las Palmas',365418.0,-15.43,28.1).
city('Mogan','es','Las Palmas',13547.0,-15.2,27.89).
city('Puerto del Rosario','es','Las Palmas',23184.0,-13.86,28.49).
city('San Bartolome','es','Las Palmas',14185.0,-13.62,29.0).
city('San Bartolome de Tirajana','es','Las Palmas',37575.0,-15.57,27.92).
city('Santa Brigida','es','Las Palmas',19158.0,-15.5,28.03).
city('Santa Lucia','es','Las Palmas',51877.0,-15.54,27.92).
city('Santa Maria de Guia de Gran Canaria','es','Las Palmas',15125.0,-15.64,28.14).
city('Teguise','es','Las Palmas',13491.0,-13.57,29.06).
city('Telde','es','Las Palmas',95503.0,-15.42,28.0).
city('Teror','es','Las Palmas',13110.0,-15.55,28.07).
city('Tias','es','Las Palmas',13957.0,-13.65,28.95).
city('Astorga','es','Leon',12037.0,-5.98,42.4).
city('Bembibre','es','Leon',9978.0,-6.43,42.62).
city('La Baneza','es','Leon',10019.0,-5.89,42.31).
city('Leon','es','Leon',127480.0,-5.57,42.59).
city('Ponferrada','es','Leon',61134.0,-6.59,42.55).
city('San Andres del Rabanedo','es','Leon',25618.0,-5.61,42.62).
city('Villablino','es','Leon',12250.0,-6.31,42.95).
city('Balaguer','es','Lleida',14207.0,0.79,41.76).
city('La Seu dUrgell','es','Lleida',115.0,1.45,42.36).
city('Lleida','es','Lleida',119320.0,0.63,41.62).
city('Tarrega','es','Lleida',13663.0,1.14,41.65).
city('Cervo','es','Lugo',4848.0,-7.42,43.67).
city('Chantada','es','Lugo',9086.0,-7.77,42.62).
city('Foz','es','Lugo',9170.0,-7.27,43.57).
city('Lugo','es','Lugo',85450.0,-7.56,43.02).
city('Monforte de Lemos','es','Lugo',18451.0,-7.51,42.53).
city('Sarria','es','Lugo',12455.0,-7.41,42.78).
city('Vilalba','es','Lugo',14850.0,-7.68,43.3).
city('Viveiro','es','Lugo',14729.0,-7.59,43.67).
city('Alcala de Henares','es','Madrid',195152.0,-3.37,40.48).
city('Alcobendas','es','Madrid',101860.0,-3.64,40.54).
city('Alcorcon','es','Madrid',169343.0,-3.82,40.35).
city('Algete','es','Madrid',17554.0,-3.51,40.61).
city('Aranjuez','es','Madrid',45125.0,-3.61,40.03).
city('Arganda del Rey','es','Madrid',36979.0,-3.44,40.3).
city('Boadilla del Monte','es','Madrid',30354.0,-3.89,40.4).
city('Ciempozuelos','es','Madrid',16606.0,-3.63,40.16).
city('Collado Villalba','es','Madrid',51987.0,-4.0,40.64).
city('Colmenar Viejo','es','Madrid',38913.0,-3.76,40.67).
city('Coslada','es','Madrid',85168.0,-3.57,40.43).
city('El Escorial','es','Madrid',12131.0,-4.13,40.59).
city('Fuenlabrada','es','Madrid',202088.0,-3.8,40.27).
city('Galapagar','es','Madrid',28271.0,-4.01,40.59).
city('Getafe','es','Madrid',167550.0,-3.73,40.3).
city('Las Rozas de Madrid','es','Madrid',70110.0,-3.87,40.5).
city('Leganes','es','Madrid',192000.0,-3.77,40.33).
city('Madrid','es','Madrid',3102644.0,-3.71,40.42).
city('Majadahonda','es','Madrid',56060.0,-3.87,40.47).
city('Mejorada del Campo','es','Madrid',19019.0,-3.49,40.4).
city('Mostoles','es','Madrid',212504.0,-3.88,40.32).
city('Navalcarnero','es','Madrid',16396.0,-4.01,40.3).
city('Parla','es','Madrid',88983.0,-3.77,40.25).
city('Pinto','es','Madrid',34665.0,-3.7,40.24).
city('Pozuelo de Alarcon','es','Madrid',83173.0,-3.81,40.44).
city('Rivas-Vaciamadrid','es','Madrid',39534.0,-3.52,40.33).
city('San Fernando de Henares','es','Madrid',40089.0,-3.53,40.43).
city('San Lorenzo de El','es','Madrid',14422.0,-4.15,40.59).
city('San Sebastian de los Reyes','es','Madrid',69954.0,-3.62,40.55).
city('Torrejon de Ardoz','es','Madrid',111998.0,-3.48,40.46).
city('Torrelodones','es','Madrid',17214.0,-3.94,40.59).
city('Tres Cantos','es','Madrid',40845.0,-3.71,40.61).
city('Valdemoro','es','Madrid',36688.0,-3.68,40.19).
city('Villaviciosa de Odon','es','Madrid',24958.0,-3.89,40.36).
city('Alhaurin de la Torre','es','Malaga',25791.0,-4.55,36.67).
city('Alhaurin el Grande','es','Malaga',19605.0,-4.77,36.66).
city('Alora','es','Malaga',13644.0,-4.7,36.83).
city('Antequera','es','Malaga',44464.0,-4.56,37.02).
city('Archidona','es','Malaga',9002.0,-4.4,37.1).
city('Benalmadena','es','Malaga',38147.0,-4.57,36.6).
city('Cartama','es','Malaga',15604.0,-4.65,36.72).
city('Coin','es','Malaga',19190.0,-4.87,36.73).
city('Estepona','es','Malaga',47577.0,-5.16,36.44).
city('Fuengirola','es','Malaga',54823.0,-4.64,36.55).
city('Malaga','es','Malaga',557875.0,-4.42,36.72).
city('Marbella','es','Malaga',115484.0,-4.89,36.52).
city('Mijas','es','Malaga',51023.0,-4.64,36.6).
city('Nerja','es','Malaga',18536.0,-3.88,36.75).
city('Rincon de la Victoria','es','Malaga',27924.0,-4.31,36.72).
city('Ronda','es','Malaga',38040.0,-5.16,36.74).
city('Torremolinos','es','Malaga',49412.0,-4.51,36.63).
city('Torrox','es','Malaga',12610.0,-3.97,36.77).
city('Velez-Malaga','es','Malaga',63064.0,-4.1,36.79).
city('Melilla','es','Melilla',66419.0,-2.95,35.3).
city('Abaran','es','Murcia',13850.0,-1.4,38.2).
city('Aguilas','es','Murcia',30739.0,-1.59,37.41).
city('Alcantarilla','es','Murcia',37969.0,-1.22,37.96).
city('Alhama de Murcia','es','Murcia',18060.0,-1.42,37.86).
city('Archena','es','Murcia',16563.0,-1.3,38.12).
city('Bullas','es','Murcia',12184.0,-1.67,38.05).
city('Caravaca de la Cruz','es','Murcia',25417.0,-1.87,38.11).
city('Cartagena','es','Murcia',201977.0,-0.98,37.61).
city('Cehegin','es','Murcia',15959.0,-1.82,38.11).
city('Cieza','es','Murcia',36545.0,-1.43,38.24).
city('Jumilla','es','Murcia',24476.0,-1.34,38.48).
city('La Union','es','Murcia',16095.0,-0.89,37.62).
city('Las Torres de Cotillas','es','Murcia',18208.0,-1.27,38.04).
city('Lorca','es','Murcia',85756.0,-1.7,37.68).
city('Mazarron','es','Murcia',23068.0,-1.32,37.6).
city('Molina de Segura','es','Murcia',51917.0,-1.22,38.06).
city('Mula','es','Murcia',16172.0,-1.5,38.05).
city('Murcia','es','Murcia',410364.0,-1.13,37.98).
city('Puerto Lumbreras','es','Murcia',12542.0,-1.83,37.56).
city('San Javier','es','Murcia',22276.0,-0.84,37.81).
city('San Pedro del Pinatar','es','Murcia',18460.0,-0.8,37.84).
city('Santomera','es','Murcia',12979.0,-1.05,38.07).
city('Torre-Pacheco','es','Murcia',26932.0,-0.96,37.74).
city('Totana','es','Murcia',27292.0,-1.5,37.77).
city('Yecla','es','Murcia',34118.0,-1.12,38.61).
city('Baranain','es','Navarra',22264.0,-1.67,42.8).
city('Burlata','es','Navarra',18179.0,-1.6,42.82).
city('Lizarra','es','Navarra',13794.0,-2.04,42.69).
city('Pamplona','es','Navarra',191549.0,-1.65,42.82).
city('Tafalla','es','Navarr',10881.0,-1.68,42.53).
city('Tudela','es','Navarra',31687.0,-1.61,42.07).
city('O Barco de Valdeorras','es','Ourense',12704.0,-6.99,42.42).
city('O Carballino','es','Ourense',12275.0,-8.07,42.44).
city('Ourense','es','Ourense',105397.0,-7.87,42.33).
city('Verin','es','Ourense',12663.0,-7.43,41.95).
city('Xinzo de Limia','es','Ourense',9332.0,-7.72,42.07).
city('Palencia','es','Palencia',77438.0,-4.54,42.03).
city('A Estrada','es','Pontevedra',22754.0,-8.5,42.7).
city('A Guarda','es','Pontevedra',10032.0,8.87,41.91).
city('Baiona','es','Pontevedra',11149.0,-8.85,42.12).
city('Bueu','es','Pontevedra',12597.0,-8.78,42.33).
city('Cambados','es','Pontevedra',13653.0,-8.8,42.51).
city('Cangas','es','Pontevedra',24460.0,-8.78,42.28).
city('Gondomar','es','Pontevedra',12419.0,-8.76,42.11).
city('Lalin','es','Pontevedra',20266.0,-8.11,42.67).
city('Marin','es','Pontevedra',25497.0,-8.7,42.4).
city('Moana','es','Pontevedra',18244.0,-8.75,42.29).
city('Nigran','es','Pontevedra',16432.0,-8.79,42.14).
city('O Grove','es','Pontevedra',11260.0,-8.87,42.5).
city('O Porrino','es','Pontevedra',16279.0,-8.62,42.16).
city('Poio','es','Pontevedra',14556.0,-8.68,42.44).
city('Ponteareas','es','Pontevedra',19391.0,-8.5,42.18).
city('Pontevedra','es','Pontevedra',77595.0,-8.66,42.42).
city('Redondela','es','Pontevedra',29583.0,-8.6,42.28).
city('Sanxenxo','es','Pontevedra',16420.0,-8.8,42.4).
city('Silleda','es','Pontevedra',9271.0,-8.24,42.71).
city('Tomino','es','Pontevedra',11598.0,-8.74,41.99).
city('Tui','es','Pontevedra',16363.0,-8.65,42.05).
city('Vigo','es','Pontevedra',286585.0,-8.71,42.22).
city('Vilagarcia de Arousa','es','Pontevedra',34165.0,-8.77,42.61).
city('Vilanova de Arousa','es','Pontevedra',10540.0,-8.82,42.57).
city('Bejar','es','Salamanca',15008.0,-5.76,40.4).
city('Ciudad Rodrigo','es','Salamanca',13884.0,-6.54,40.61).
city('Salamanca','es','Salamanca',155175.0,-5.67,40.97).
city('Santa Marta de Tormes','es','Salamanca',11998.0,-5.63,40.95).
city('Adeje','es','Santa Cruz de Tenerife',22245.0,-16.72,28.12).
city('Arona','es','Santa Cruz de Tenerife',44838.0,-16.67,28.09).
city('Candelaria','es','Santa Cruz de Tenerife',15647.0,-16.37,28.36).
city('Granadilla de Abona','es','Santa Cruz de Tenerife',23212.0,-16.58,28.11).
city('Gueimar','es','Santa Cruz de Tenerife',16772.0,-16.41,28.31).
city('Guia de Isora','es','Santa Cruz de Tenerife',16454.0,-16.78,28.21).
city('Icod de los Vinos','es','Santa Cruz de Tenerife',23885.0,-16.7,28.36).
city('La Orotava','es','Santa Cruz de Tenerife',41446.0,-16.52,28.39).
city('Los Llanos de Aridane','es','Santa Cruz de Tenerife',19461.0,-17.91,28.65).
city('Los Realejos','es','Santa Cruz de Tenerife',36724.0,-16.57,28.39).
city('Puerto de la Cruz','es','Santa Cruz de Tenerife',29039.0,-16.54,28.4).
city('San Cristobal de la Laguna','es','Santa Cruz de Tenerife',141480.0,-16.32,28.48).
city('Santa Cruz de Tenerife','es','Santa Cruz de Tenerife',193852.0,-16.25,28.47).
city('Santa Cruz de la Palma','es','Santa Cruz de Tenerife',20501.0,-17.77,28.68).
city('Santa Ursula','es','Santa Cruz de Tenerife',11864.0,-16.47,28.24).
city('Tacoronte','es','Santa Cruz de Tenerife',22289.0,-16.4,28.47).
city('Segovia','es','Segovia',55902.0,-4.11,40.94).
city('Alcala de Guadaira','es','Sevilla',58934.0,-5.84,37.34).
city('Arahal','es','Sevilla',18847.0,-5.54,37.27).
city('Brenes','es','Sevilla',11078.0,-5.88,37.55).
city('Camas','es','Sevilla',25622.0,-6.02,37.4).
city('Carmona','es','Sevilla',26471.0,-5.63,37.48).
city('Castilleja de la Cuesta','es','Sevilla',16672.0,-6.05,37.39).
city('Coria del Rio','es','Sevilla',24671.0,-6.06,37.3).
city('Dos Hermanas','es','Sevilla',104666.0,-5.93,37.28).
city('Ecija','es','Sevilla',37865.0,-5.09,37.54).
city('El Viso del Alcor','es','Sevilla',16762.0,-5.72,37.39).
city('Estepa','es','Sevilla',12194.0,-4.89,37.29).
city('La Algaba','es','Sevilla',13346.0,-6.01,37.47).
city('La Puebla de Cazalla','es','Sevilla',10794.0,-5.32,37.23).
city('La Puebla del Rio','es','Sevilla',10775.0,-6.07,37.27).
city('La Rinconada','es','Sevilla',30051.0,-5.97,37.49).
city('Las Cabezas de San Juan','es','Sevilla',15979.0,5.94,36.99).
city('Lebrija','es','Sevilla',24754.0,-6.08,36.93).
city('Lora del Rio','es','Sevilla',18761.0,-5.53,37.66).
city('Los Palacios y Villafranca','es','Sevilla',33913.0,-6.0,37.26).
city('Mairena del Alcor','es','Sevilla',17263.0,-5.75,37.37).
city('Mairena del Aljarafe','es','Sevilla',36774.0,-6.07,37.34).
city('Marchena','es','Sevilla',18319.0,-5.42,37.33).
city('Moron de la Frontera','es','Sevilla',28438.0,-5.46,37.13).
city('Osuna','es','Sevilla',17290.0,-5.1,37.24).
city('Pilas','es','Sevilla',11480.0,-6.3,37.31).
city('San Juan de Aznalfarache','es','Sevilla',19848.0,-6.04,37.37).
city('Sanlucar la Mayor','es','Sevilla',11143.0,-6.2,37.39).
city('Sevilla','es','Sevilla',686647.0,-5.98,37.4).
city('Tomares','es','Sevilla',18796.0,-6.04,37.39).
city('Utrera','es','Sevilla',46361.0,-5.78,37.18).
city('Soria','es','Soria',35129.0,-2.46,41.77).
city('Amposta','es','Tarragona',19140.0,0.58,40.72).
city('Calafell','es','Tarragona',15325.0,1.56,41.21).
city('Cambrils','es','Tarragona',23833.0,1.05,41.08).
city('El Vendrell','es','Tarragona',26947.0,1.52,41.23).
city('Reus','es','Tarragona',97508.0,1.11,41.16).
city('Salou','es','Tarragona',16075.0,1.14,41.08).
city('Sant Carles de la Rapita','es','Tarragona',13133.0,0.58,40.63).
city('Tarragona','es','Tarragona',128391.0,1.24,41.12).
city('Tortosa','es','Tarragona',32836.0,0.52,40.83).
city('Valls','es','Tarragona',22961.0,1.25,41.29).
city('Alcaniz','es','Teruel',13884.0,-0.13,41.05).
city('Teruel','es','Teruel',32210.0,-1.11,40.34).
city('Consuegra','es','Toledo',11223.0,-3.61,39.46).
city('Illescas','es','Toledo',13114.0,-3.86,40.14).
city('Madridejos','es','Toledo',11743.0,-3.54,39.47).
city('Talavera de la Reina','es','Toledo',82704.0,-4.83,39.96).
city('Toledo','es','Toledo',75054.0,-4.03,39.86).
city('Torrijos','es','Tol',11284.0,-4.29,39.99).
city('Alaquas','es','Valencia',29607.0,-0.46,39.45).
city('Albal','es','Valencia',13507.0,-0.41,39.4).
city('Alberic','es','Valencia',9894.0,-0.52,39.12).
city('Alboraya','es','Valencia',19431.0,-0.35,39.5).
city('Aldaia','es','Valencia',26475.0,-0.46,39.47).
city('Alfafar','es','Valencia',19880.0,-0.39,39.42).
city('Algemesi','es','Valencia',26222.0,-0.44,39.2).
city('Alginet','es','Valencia',12754.0,-0.47,39.27).
city('Alzira','es','Valencia',42348.0,-0.44,39.16).
city('Benaguasil','es','Valencia',9732.0,-0.59,39.61).
city('Benetusser','es','Valencia',14332.0,-0.4,39.43).
city('Benifaio','es','Valencia',12864.0,-0.43,39.28).
city('Betera','es','Valencia',16267.0,-0.45,39.59).
city('Bunol','es','Valencia',9704.0,-0.79,39.42).
city('Burjassot','es','Valencia',37717.0,-0.39,39.5).
city('Canals','es','Valencia',13569.0,-0.59,38.97).
city('Carcaixent','es','Valencia',20826.0,-0.45,39.14).
city('Carlet','es','Valencia',15173.0,-0.52,39.22).
city('Catarroja','es','Valencia',22408.0,-0.39,39.4).
city('Cullera','es','Valencia',21756.0,-0.25,39.18).
city('Gandia','es','Valencia',63893.0,-0.18,38.98).
city('Godella','es','Valencia',11829.0,-0.43,39.54).
city('LAlcudia','es','Valencia',11260.0,-0.51,39.21).
city('LEliana','es','Valencia',14591.0,-0.54,39.57).
city('La Pobla de Vallbona','es','Valencia',13812.0,-0.54,39.6).
city('Lliria','es','Valencia',18374.0,-0.6,39.62).
city('Manises','es','Valencia',27420.0,-0.45,39.49).
city('Massamagrell','es','Valencia',14018.0,-0.33,39.58).
city('Mislata','es','Valencia',43287.0,-0.4,39.49).
city('Moncada','es','Valencia',19890.0,-0.4,39.55).
city('Oliva','es','Valencia',22422.0,-0.12,38.92).
city('Ontinyent','es','Valencia',34871.0,-0.62,38.82).
city('Paiporta','es','Valencia',20134.0,-0.43,39.44).
city('Paterna','es','Valencia',50148.0,-0.42,39.5).
city('Picassent','es','Valencia',17436.0,-0.46,39.37).
city('Pucol','es','Valencia',15976.0,-0.3,39.62).
city('Quart de Poblet','es','Valencia',27015.0,-0.44,39.49).
city('Requena','es','Valencia',20428.0,-1.11,39.49).
city('Riba-roja de Turia','es','Valencia',15169.0,-0.57,39.55).
city('Sagunt','es','Valencia',59773.0,-0.29,39.68).
city('Silla','es','Valencia',17303.0,-0.42,39.37).
city('Sueca','es','Valencia',27085.0,-0.32,39.21).
city('Tavernes de la Valldigna','es','Valencia',17639.0,-0.27,39.07).
city('Torrent','es','Valencia',69837.0,-0.46,39.44).
city('Utiel','es','Valencia',12277.0,-1.2,39.57).
city('Valencia','es','Valencia',769897.0,-0.39,39.48).
city('Xativa','es','Valencia',27475.0,-0.53,39.0).
city('Xirivella','es','Valencia',28515.0,-0.41,39.48).
city('Laguna de Duero','es','Valladolid',19362.0,-4.72,41.59).
city('Medina del Campo','es','Valladolid',20273.0,-4.92,41.31).
city('Valladolid','es','Valladolid',315859.0,-4.74,41.65).
city('Arrigorriaga','es','Vizcaya',11118.0,-2.89,43.2).
city('Barakaldo','es','Vizcaya',94288.0,-2.98,43.28).
city('Basauri','es','Vizcaya',44995.0,-2.9,43.24).
city('Bermeo','es','Vizcaya',16904.0,-2.73,43.42).
city('Bilbao','es','Vizcaya',349270.0,-2.93,43.25).
city('Durango','es','Vizcaya',24953.0,-2.63,43.18).
city('Erandio','es','Vizcaya',22377.0,-2.96,43.3).
city('Ermua','es','Vizcaya',16761.0,-2.51,43.19).
city('Etxano','es','Vizcaya',16150.0,-2.73,43.23).
city('Galdakao','es','Vizcaya',29485.0,-2.85,43.24).
city('Gernika-Lumo','es','Vizcaya',15233.0,-2.69,43.33).
city('Getxo','es','Vizcaya',82120.0,-3.0,43.36).
city('Leioa','es','Vizcaya',28324.0,-3.0,43.33).
city('Mungia','es','Vizcaya',13779.0,-2.84,43.36).
city('Ondarroa','es','Vizcaya',9712.0,-2.42,43.32).
city('Portugalete','es','Vizcaya',50964.0,-3.02,43.32).
city('Santurtzi','es','Vizcaya',46364.0,-3.04,43.33).
city('Sestao','es','Vizcaya',31709.0,-2.99,43.3).
city('Sopelana','es','Vizcaya',10688.0,-2.97,43.39).
city('Trapagaran','es','Vizcaya',12596.0,-3.03,43.3).
city('Benavente','es','Zamora',16159.0,-5.68,42.02).
city('Toro','es','Zamora',9041.0,-5.4,41.53).
city('Zamora','es','Zamora',63160.0,-5.75,41.52).
city('Calatayud','es','Zaragoza',18623.0,-1.64,41.3).
city('Ejea de los Caballeros','es','Zaragoza',16586.0,-1.15,42.13).
city('Tarazona','es','Zaragoza',10935.0,-1.72,41.9).
city('Zaragoza','es','Zaragoza',635509.0,-0.89,41.65).
city('Amparai','lk','Amparai',18351.0,81.67,7.28).
city('Kalmunai','lk','Amparai',100172.0,81.82,7.41).
city('Anuradhapura','lk','Anuradhapura',60954.0,80.41,8.32).
city('Badulla','lk','Badulla',42237.0,81.05,6.99).
city('Bandarawela','lk','Badulla',7103.0,80.98,6.83).
city('Haputale','lk','Badulla',4722.0,80.97,6.77).
city('Batticaloa','lk','Batticaloa',86743.0,81.69,7.71).
city('Eravur','lk','Batticaloa',22979.0,81.59,7.77).
city('Katankudi','lk','Batticaloa',36723.0,81.73,7.69).
city('Battaramulla','lk','Colombo',75632.0,79.92,6.9).
city('Colombo','lk','Colombo',648119.0,79.85,6.93).
city('Dehiwala-Mount Lavinia','lk','Colombo',215976.0,79.87,6.85).
city('Homagama','lk','Colombo',34664.0,80.0,6.85).
city('Kolonnawa','lk','Colombo',58086.0,79.88,6.93).
city('Kotikawatta','lk','Colombo',64565.0,79.92,6.94).
city('Kotte','lk','Colombo',118199.0,79.9,6.89).
city('Maharagama','lk','Colombo',66575.0,79.92,6.85).
city('Moratuwa','lk','Colombo',185062.0,79.88,6.81).
city('Mulleriyawa','lk','Colombo',33540.0,79.93,6.93).
city('Seethawakapura','lk','Colombo',22922.0,80.06,6.91).
city('Ambalamgoda','lk','Galle',20137.0,80.06,6.24).
city('Galle','lk','Galle',93134.0,80.21,6.05).
city('Daluguma','lk','Gampaha',73635.0,79.9,6.97).
city('Gampaha','lk','Gampaha',9352.0,80.0,7.1).
city('Hendala','lk','Gampaha',56977.0,79.87,6.98).
city('Jaela','lk','Gampaha',32181.0,79.88,7.08).
city('Kandana','lk','Gampaha',33424.0,79.9,7.05).
city('Katunayaka','lk','Gampaha',84658.0,79.87,7.18).
city('Kelaniya','lk','Gampaha',28852.0,79.92,6.96).
city('Minuwangoda','lk','Gampaha',7774.0,79.95,7.17).
city('Negombo','lk','Gampaha',137246.0,79.83,7.22).
city('Peliyagoda','lk','Gampaha',30722.0,79.9,6.95).
city('Ragama','lk','Gampaha',34313.0,79.92,7.03).
city('Wattala','lk','Gampaha',30730.0,79.89,6.97).
city('Welesara','lk','Gampaha',41305.0,79.9,7.03).
city('Hambantota','lk','Hambantota',11598.0,81.12,6.13).
city('Tanggalla','lk','Hambantota',10499.0,80.79,6.03).
city('Chavakachcheri','lk','Jaffna',121897.0,80.16,9.66).
city('Jaffna','lk','Jaffna',169126.0,80.01,9.67).
city('Point Pedro','lk','Jaffna',89944.0,80.23,9.82).
city('Valvedditturai','lk','Jaffna',78324.0,80.17,9.82).
city('Beruwala','lk','Kalatura',34256.0,79.98,6.48).
city('Horana','lk','Kalatura',8984.0,80.05,6.72).
city('Kalutara','lk','Kalatura',38007.0,79.96,6.59).
city('Keselwatta','lk','Kalatura',43883.0,79.95,6.6).
city('Panadraya','lk','Kalatura',33741.0,79.9,6.72).
city('Gampola','lk','Kandy',24734.0,80.57,7.17).
city('Hatton','lk','Kandy',15076.0,80.6,6.89).
city('Kadugannawa','lk','Kandy',1216.0,80.52,7.25).
city('Kandy','lk','Kandy',111720.0,80.63,7.29).
city('Nawalapitiya','lk','Kandy',13751.0,80.53,7.05).
city('Kegalla','lk','Kegalla',17772.0,80.35,7.25).
city('Kilinochchi','lk','Kilinochchi',13006.0,80.41,9.4).
city('Kuliyapitiya','lk','Kurunega',6878.0,80.04,7.47).
city('Kurunegala','lk','Kurunegala',28576.0,80.36,7.5).
city('Mannarama','lk','Mannarama',43803.0,79.89,8.97).
city('Dambulla','lk','Matale',66727.0,80.65,7.85).
city('Matale','lk','Matale',37464.0,80.62,7.47).
city('Sigiriya','lk','Matale',1001.0,80.72,7.93).
city('Matara','lk','Matara',43233.0,80.53,5.96).
city('Weligama','lk','Matara',22183.0,80.42,5.98).
city('Monaragala','lk','Monaragala',10236.0,81.35,6.87).
city('Wattegama','lk','Monaragala',8001.0,81.5,6.8).
city('Mullaitivu','lk','Mullaitivu',7787.0,80.79,9.22).
city('Nuwara Eliya','lk','Nuwara Eliya',25780.0,80.77,6.98).
city('Talawakele','lk','Nuwara Eliya',3546.0,80.65,6.94).
city('Polonnaruwa','lk','Polonnaruwa',15286.0,81.0,7.93).
city('Halawata','lk','Puttalama',24717.0,79.81,7.57).
city('Puttalama','lk','Puttalama',45669.0,79.82,8.04).
city('Balangoda','lk','Ratnapura',12213.0,80.71,6.65).
city('Ratnapura','lk','Ratnapura',47841.0,80.38,6.7).
city('Trincomalee','lk','Trincomalee',108434.0,81.22,8.58).
city('Vavuni','lk','Vavuniya',60174.0,80.49,8.76).
city('Malakal','sd','Aali-an-Nil',160893.0,31.65,9.53).
city('ar-Rank','sd','Aali-an-Nil',26851.0,32.88,11.76).
city('Juba','sd','Bahr-al-Jabal',163455.0,31.6,4.85).
city('Yei','sd','Bahr-al-Jabal',40382.0,30.68,4.09).
city('Raga','sd','Garb Bahr-al-Gazal',3700.0,25.68,8.46).
city('Waw','sd','Garb Bahr-al-Gazal',127400.0,27.99,7.7).
city('Zalinjay','sd','Garb Darfur',28687.0,23.47,12.9).
city('al-Junaynah','sd','Garb Darfur',163000.0,22.44,13.45).
city('Abu Zabad','sd','Garb Kurdufa',15304.0,29.24,12.35).
city('Babanusah','sd','Garb Kurdufan',29637.0,27.8,11.33).
city('Lagawa','sd','Garb Kurdufan',11024.0,29.14,11.41).
city('al-Fulah','sd','Garb Kurdufan',11238.0,28.4,11.8).
city('al-Mijlad','sd','Garb Kurdufan',19997.0,27.74,11.04).
city('an-Nuhud','sd','Garb Kurdufan',108022.0,28.42,12.69).
city('Maridi','sd','Garb-al-Istiwaiyah',14224.0,29.46,4.91).
city('Nzara','sd','Garb-al-Istiwaiyah',0.0,28.25,4.64).
city('Tambura','sd','Garb-al-Istiwaiyah',9484.0,27.46,5.59).
city('Yambio','sd','Garb-al-Istiwaiyah',40382.0,28.39,4.58).
city('Niyala','sd','Janub Darfur',499655.0,24.89,12.06).
city('ad-Duayn','sd','Janub Darfur',210556.0,26.16,11.43).
city('Abu Jubayhah','sd','Janub Kurdufan',21791.0,31.23,11.45).
city('Abu Karsola','sd','Janub Kurdufan',10487.0,30.77,12.15).
city('Kaduqli','sd','Janub Kurdufan',87677.0,29.7,11.01).
city('Talawdi','sd','Janub Kurdufan',13188.0,30.39,10.63).
city('ad-Dillinj','sd','Janub Kurdufan',37114.0,29.66,12.04).
city('al-Abbasiyah','sd','Janub Kurdufan',12207.0,31.3,12.17).
city('Bur','sd','Junqali',26782.0,31.56,6.23).
city('Aruma','sd','Kassala',12708.0,36.13,15.81).
city('Halfa al-Jadidah','sd','Kassala',80455.0,35.58,15.32).
city('Hzasm-al-Qirbah','sd','Kassala',33374.0,35.91,14.97).
city('Kassala','sd','Kassala',401514.0,36.39,15.46).
city('Wagar','sd','Kassala',11950.0,36.2,16.15).
city('Khartoum','sd','Khartoum',1974780.0,32.52,15.58).
city('Umm Durman','sd','Khartoum',2810328.0,32.48,15.65).
city('al-Hzartum Bahri','sd','Khartoum',1530571.0,32.52,15.64).
city('Atbarah','sd','Nahr-an-Nil',107944.0,33.98,17.71).
city('Barbar','sd','Nahr-an-Nil',22395.0,33.99,18.02).
city('Kabusiyah','sd','Nahr-an-Nil',9678.0,33.7,16.88).
city('Sandi','sd','Nahr-an-Nil',53569.0,33.42,16.68).
city('ad-Damir','sd','Nahr-an-Nil',104025.0,33.96,17.59).
city('al-Bawga','sd','Nahr-an-Nil',19141.0,33.92,18.28).
city('al-Matammah','sd','Nahr-an-Nil',11366.0,33.36,16.7).
city('Gogrial','sd','Samal Bahr-al-Gazal',38572.0,28.11,8.53).
city('Uwayl','sd','Samal Bahr-al-Gazal',38745.0,27.39,8.78).
city('Kutum','sd','Samal Darfur',9849.0,24.65,14.2).
city('Umm Kaddadah','sd','Samal Darfur',10979.0,26.69,13.6).
city('al-Fasir','sd','Samal Darfur',252638.0,25.35,13.63).
city('Bara','sd','Samal Kurdufan',16969.0,30.37,13.7).
city('Umm Ruwabah','sd','Samal Kurdufan',55742.0,31.2,12.91).
city('al-Ubayyid','sd','Samal Kurdufan',393355.0,30.22,13.19).
city('ar-Rahad','sd','Samal Kurdufan',26273.0,30.63,12.73).
city('Kapoeta','sd','Sarq-al-Istiwaiyah',7042.0,33.57,4.78).
city('Torit','sd','Sarq-al-Istiwaiyah',20048.0,32.57,4.41).
city('Abu Hijar','sd','Sinnar',8626.0,34.0,12.87).
city('Galgani','sd','Sinnar',9472.0,34.18,12.45).
city('Karkawj','sd','Sinnar',12451.0,34.02,12.93).
city('Mayurnu','sd','Sinnar',28727.0,33.65,13.42).
city('Sinjah','sd','Sinnar',44626.0,33.93,13.16).
city('Sinnar','sd','Sinnar',130138.0,33.6,13.55).
city('Umm Sawkah','sd','Sinnar',18570.0,33.77,13.31).
city('ad-Dindar','sd','Sinnar',15144.0,34.16,13.2).
city('as-Suki','sd','Sinnar',33524.0,33.87,13.32).
city('Tonj','sd','Warab',17338.0,28.68,7.27).
city('Bur Sudan','sd','al-Bahr-al-Ahmar',459101.0,37.12,19.63).
city('Gabait','sd','al-Bahr-al-Ahmar',11095.0,36.32,21.06).
city('Sawakin','sd','al-Bahr-al-Ahmar',28570.0,37.33,19.1).
city('Sinkat','sd','al-Bahr-al-Ahmar',12547.0,36.81,18.85).
city('Tawkar','sd','al-Bahr-al-Ahmar',22251.0,37.72,18.43).
city('Rumbik','sd','al-Buhayrat',32083.0,29.69,6.81).
city('Yirol','sd','al-Buhayrat',11646.0,30.49,6.55).
city('Abu Usar','sd','al-Jazirah',12055.0,33.18,14.92).
city('Maharaybah','sd','al-Jazirah',11000.0,32.93,15.06).
city('Miallayab','sd','al-Jazirah',8300.0,33.62,14.62).
city('Rufaah','sd','al-Jazirah',32533.0,33.36,14.76).
city('Sarafat','sd','al-Jazirah',9037.0,33.62,14.53).
city('Tabat','sd','al-Jazirah',10976.0,33.08,14.67).
city('Tambul','sd','al-Jazirah',10489.0,33.4,14.93).
city('Wad Madani','sd','al-Jazirah',332752.0,33.51,14.4).
city('Wad Rawah','sd','al-Jazirah',10348.0,33.12,15.16).
city('al-Haws','sd','al-Jazirah',10795.0,33.57,14.12).
city('al-Hilaliyah','sd','al-Jazirah',17345.0,33.23,14.94).
city('al-Huda','sd','al-Jazirah',12456.0,32.92,14.55).
city('al-Husahisa','sd','al-Jazirah',28735.0,33.3,14.73).
city('al-Kamilin','sd','al-Jazirah',13690.0,33.18,15.08).
city('al-Karaymat','sd','al-Jazirah',9775.0,32.95,14.35).
city('al-Manaqil','sd','al-Jazirah',128313.0,32.98,14.25).
city('al-Musallamiyah','sd','al-Jazirah',9373.0,33.35,14.57).
city('Doka','sd','al-Qadarif',19821.0,35.77,13.52).
city('Qala-an-Nahl','sd','al-Qadarif',9374.0,34.95,13.63).
city('al-Faw','sd','al-Qadarif',8366.0,34.33,14.15).
city('al-Hawatah','sd','al-Qadarif',24513.0,34.62,13.45).
city('al-Qadarif','sd','al-Qadarif',322626.0,35.38,14.04).
city('as-Suwak','sd','al-Qadarif',14015.0,35.87,14.4).
city('Bentiu','sd','al-Wahdah',7653.0,29.83,9.24).
city('Ler','sd','al-Wahdah',10486.0,30.13,8.3).
city('Gulli','sd','an-Nil-al-Abyad',10177.0,32.52,13.42).
city('Kinanah','sd','an-Nil-al-Abyad',26233.0,33.17,14.03).
city('Kusti','sd','an-Nil-al-Abyad',345102.0,32.66,13.17).
city('Marabba','sd','an-Nil-al-Abyad',12108.0,32.18,12.35).
city('Rabak','sd','an-Nil-al-Abyad',135389.0,32.74,13.18).
city('Sabsah','sd','an-Nil-al-Abyad',15133.0,32.23,14.14).
city('Tandalti','sd','an-Nil-al-Abyad',27275.0,31.86,13.01).
city('Umm Jarr','sd','an-Nil-al-Abyad',9038.0,32.4,13.82).
city('Wad-az-Zaki','sd','an-Nil-al-Abyad',9271.0,32.21,14.47).
city('ad-Duwaym','sd','an-Nil-al-Abyad',87080.0,32.3,13.99).
city('al-Jazirah Aba','sd','an-Nil-al-Abyad',34525.0,32.64,13.2).
city('al-Kawah','sd','an-Nil-al-Abyad',10167.0,32.51,13.76).
city('al-Qutaynah','sd','an-Nil-al-Abyad',18321.0,32.36,14.86).
city('ad-Damazin','sd','an-Nil-al-Azraq',186191.0,34.35,11.77).
city('al-Kurumuk','sd','an-Nil-al-Azraq',10375.0,34.28,10.55).
city('ar-Rusayris','sd','an-Nil-al-Azraq',28862.0,34.37,11.86).
city('Argu','sd','as-Samaliyah',7716.0,30.42,19.52).
city('Dunqula','sd','as-Samaliyah',19007.0,30.47,19.17).
city('Karmah-an-Nuzul','sd','as-Samaliyah',3928.0,30.42,19.64).
city('Kurimah','sd','as-Samaliyah',19593.0,31.86,18.57).
city('Marawi','sd','as-Samaliyah',10234.0,31.83,18.48).
city('Wadi Halfa','sd','as-Samaliyah',14936.0,31.37,21.79).
city('ad-Dabbah','sd','as-Samaliyah',11626.0,30.95,18.05).
city('Brokopondo','sr','Brokopondo',2072.0,-55.02,5.04).
city('Brownsweg','sr','Brokopondo',2410.0,55.17,5.02).
city('Marienburg','sr','Commewijne',4463.0,-55.03,5.9).
city('Meerzorg','sr','Commewijne',6591.0,-55.09,5.81).
city('Nieuw Amsterdam','sr','Commewijne',4935.0,-55.07,5.91).
city('Totness','sr','Coronie',1800.0,-56.32,5.89).
city('Albina','sr','Marowijne',4138.0,-54.08,5.5).
city('Moengo','sr','Marowijne',7345.0,-54.41,5.63).
city('Nieuw Nickerie','sr','Nickerie',13410.0,-56.99,5.95).
city('Wageningen','sr','Nickerie',4229.0,-56.68,5.78).
city('Onverwacht','sr','Para',2009.0,-55.19,5.59).
city('Paramaribo','sr','Paramaribo',220306.0,-55.2,5.85).
city('Groningen','sr','Saramacca',3112.0,-55.48,5.8).
city('Lelydorp','sr','Wanica',17735.0,-55.23,5.72).
city('Barentsburg','sj','Svalbard',576.0,14.23,78.06).
city('Hornsund','sj','Svalbard',7.0,15.47,76.97).
city('Isfjord Radio','sj','Svalbard',3.0,13.38,78.08).
city('Longyearbyen','sj','Svalbard',1232.0,15.61,78.21).
city('Ny-Alesund','sj','Svalbard',40.0,11.95,78.93).
city('Pyramiden','sj','Svalbard',0.0,16.42,78.65).
city('Svea','sj','Svalbard',0.0,16.68,77.9).
city('Bulembu','sz','Hhohho',2263.0,31.13,-25.95).
city('Mbabane','sz','Hhohho',76223.0,31.14,-26.32).
city('Ngwenya','sz','Hhohho',1281.0,31.04,-26.22).
city('Piggs Peak','sz','Hhohho',5750.0,31.24,-25.96).
city('Big Bend','sz','Lubombo',10344.0,31.94,-26.81).
city('Mhlume','sz','Lubombo',8654.0,31.85,-26.03).
city('Mpaka','sz','Lubombo',3587.0,31.77,-26.43).
city('Ngomane','sz','Lubombo',4511.0,31.96,-26.18).
city('Nsoko','sz','Lubombo',1180.0,31.93,-27.04).
city('Simunye','sz','Lubombo',6512.0,31.95,-26.18).
city('Siteki','sz','Lubombo',6153.0,31.95,-26.46).
city('Tabankulu','sz','Lubombo',2825.0,31.93,-26.13).
city('Tjaneni','sz','Lubombo',1901.0,31.72,-25.98).
city('Vuvulane','sz','Lubombo',4155.0,31.88,-26.11).
city('Bhunya','sz','Manzini',3050.0,31.01,-26.56).
city('Kwaluseni','sz','Manzini',3395.0,31.34,-26.48).
city('Lobamba','sz','Manzini',4557.0,31.2,-26.46).
city('Malkerns','sz','Manzini',9726.0,31.18,-26.57).
city('Mankayane','sz','Manzini',1144.0,31.07,-26.49).
city('Manzini','sz','Manzini',110543.0,31.38,-26.49).
city('Mhlambanyatsi','sz','Manzini',2886.0,31.02,-26.45).
city('Sidvokodvo','sz','Manzini',1747.0,31.43,-26.64).
city('Hlatikulu','sz','Shiselweni',2748.0,31.32,-26.96).
city('Hluti','sz','Shiselweni',6763.0,31.61,-27.23).
city('Kubuta','sz','Shiselweni',2038.0,31.47,-26.87).
city('Lavumisa','sz','Shiselweni',1300.0,31.88,-27.29).
city('Nhlangano','sz','Shiselweni',9017.0,31.12,-27.11).
city('Karlshamn','se','Blekinge',18161.0,14.87,56.17).
city('Karlskrona','se','Blekinge',32309.0,15.59,56.18).
city('Ronneby','se','Blekinge',11618.0,15.28,56.21).
city('Avesta','se','Dalarna',14110.0,16.18,60.16).
city('Borlaenge','se','Dalarna',38757.0,15.44,60.49).
city('Falun','se','Dalarna',35385.0,15.62,60.61).
city('Ludvika','se','Dalarna',13638.0,15.18,60.14).
city('Bollnaes','se','Gaevleborg',12145.0,16.39,61.35).
city('Gaevle','se','Gaevleborg',68635.0,17.13,60.69).
city('Hudiksvall','se','Gaevleborg',14621.0,17.11,61.74).
city('Sandviken','se','Gaevleborg',22111.0,16.77,60.62).
city('Soederhamn','se','Gaevleborg',12022.0,17.08,61.31).
city('Visby','se','Gotland',21970.0,18.3,57.64).
city('Falkenberg','se','Halland',18407.0,12.51,56.9).
city('Halmstad','se','Halland',55658.0,12.86,56.67).
city('Varberg','se','Halland',25816.0,12.25,57.11).
city('Oestersund','se','Jaemtland',42940.0,14.65,63.18).
city('Joenkoeping','se','Joenkoeping',83202.0,14.17,57.78).
city('Naessjoe','se','Joenkoeping',15954.0,14.7,57.66).
city('Tranas','se','Joenkoeping',13765.0,14.97,58.04).
city('Vaernamo','se','Joenkoeping',17950.0,14.05,57.18).
city('Vetlanda','se','Joenkoeping',12068.0,15.08,57.43).
city('Kalmar','se','Kalmar',34745.0,16.36,56.67).
city('Nybro','se','Kalmar',12059.0,15.91,56.75).
city('Oskarshamn','se','Kalmar',16613.0,16.45,57.26).
city('Vaestervik','se','Kalmar',19860.0,16.63,57.76).
city('Ljungby','se','Kronoberg',14272.0,13.94,56.84).
city('Vaexjoe','se','Kronoberg',53607.0,14.8,56.88).
city('Boden','se','Norrbotten',18225.0,21.7,65.83).
city('Kiruna','se','Norrbotten',17806.0,20.22,67.86).
city('Lulea','se','Norrbotten',45551.0,22.16,65.6).
city('Pitea','se','Norrbotten',22044.0,21.51,65.32).
city('Karlskoga','se','Oerebro',26949.0,14.5,59.33).
city('Kumla','se','Oerebro',12756.0,15.13,59.13).
city('Oerebro','se','Oerebro',98573.0,15.22,59.28).
city('Finspang','se','Oestergoetland',11989.0,15.78,58.71).
city('Linkoeping','se','Oestergoetland',96732.0,15.63,58.41).
city('Mjoelby','se','Oestergoetland',11560.0,15.13,58.33).
city('Motala','se','Oestergoetland',29715.0,15.04,58.54).
city('Norrkoeping','se','Oestergoetland',82903.0,16.17,58.6).
city('Aengelholm','se','Skane',22385.0,12.87,56.25).
city('Esloev','se','Skane',15898.0,13.3,55.84).
city('Haessleholm','se','Skane',17050.0,13.76,56.16).
city('Helsingborg','se','Skane',91025.0,12.7,56.05).
city('Hoeganaes','se','Skane',13461.0,12.55,56.2).
city('Kristianstad','se','Skane',32188.0,14.15,56.03).
city('Landskrona','se','Skane',27889.0,12.83,55.88).
city('Lund','se','Skane',76263.0,13.2,55.71).
city('Malmoe','se','Skane',261549.0,13.02,55.61).
city('Staffanstorp','se','Skane',14192.0,13.2,55.65).
city('Trelleborg','se','Skane',25494.0,13.15,55.38).
city('Ystad','se','Skane',17266.0,13.84,55.44).
city('Eskilstuna','se','Soedermanland',59016.0,16.51,59.37).
city('Katrineholm','se','Soedermanland',21108.0,16.2,58.99).
city('Nykoeping','se','Soedermanland',27582.0,17.02,58.76).
city('Oxeloesund','se','Soedermanland',10690.0,17.13,58.67).
city('Straengnaes','se','Soedermanland',12555.0,17.02,59.38).
city('Akersberga','se','Stockholm',26785.0,18.31,59.48).
city('Boo','se','Stockholm',21761.0,18.14,59.31).
city('Lidingoe','se','Stockholm',30930.0,18.15,59.37).
city('Maersta','se','Stockholm',23194.0,17.84,59.63).
city('Norrtaelje','se','Stockholm',16914.0,18.7,59.77).
city('Nynaeshamn','se','Stockholm',13616.0,17.95,58.91).
city('Soedertaelje','se','Stockholm',59977.0,17.63,59.2).
city('Stockholm','se','Stockholm',1253309.0,18.07,59.33).
city('Taeby','se','Stockholm',58123.0,18.07,59.5).
city('Tumba','se','Stockholm',35780.0,17.81,59.2).
city('Upplands-Vaesby','se','Stockholm',36535.0,17.92,59.53).
city('Vaesterhaninge','se','Stockholm',14620.0,18.08,59.12).
city('Vallentuna','se','Stockholm',26733.0,18.08,59.54).
city('Balsta','se','Uppsala',13495.0,17.49,59.59).
city('Enkoeping','se','Uppsala',19733.0,17.09,59.65).
city('Uppsala','se','Uppsala',127734.0,17.64,59.86).
city('Arvika','se','Vaermland',13666.0,12.59,59.67).
city('Karlstad','se','Vaermland',57779.0,13.51,59.38).
city('Kristinehamn','se','Vaermland',17000.0,14.11,59.32).
city('Skoghall','se','Vaermland',12845.0,13.48,59.34).
city('Skelleftea','se','Vaesterbotten',30839.0,20.99,64.76).
city('Umea','se','Vaesterbotten',74005.0,20.24,63.83).
city('Haernoesand','se','Vaesternorrland',17016.0,17.93,62.64).
city('Oernskoeldsvik','se','Vaesternorrland',27749.0,18.72,63.3).
city('Sundsvall','se','Vaesternorrland',48463.0,17.33,62.4).
city('Timra','se','Vaesternorrland',10168.0,17.32,62.48).
city('Fagersta','se','Vaestmanland',10432.0,15.81,60.0).
city('Koeping','se','Vaestmanland',16617.0,15.99,59.52).
city('Sala','se','Vaestmanland',12015.0,16.6,59.93).
city('Vaesteras','se','Vaestmanland',107194.0,16.54,59.62).
city('Alingsas','se','Vaestra Goetaland',22788.0,12.54,57.93).
city('Boras','se','Vaestra Goetaland',63223.0,12.94,57.73).
city('Falkoeping','se','Vaestra Goetaland',15054.0,13.56,58.17).
city('Goeteborg','se','Vaestra Goetaland',515253.0,12.01,57.72).
city('Kinna','se','Vaestra Goetaland',14211.0,12.65,57.5).
city('Kungaelv','se','Vaestra Goetaland',21262.0,11.99,57.87).
city('Kungsbacka','se','Vaestra Goetaland',18698.0,12.1,57.51).
city('Lerum','se','Vaestra Goetaland',15949.0,12.28,57.77).
city('Lidkoeping','se','Vaestra Goetaland',24586.0,13.16,58.51).
city('Mariestad','se','Vaestra Goetaland',14891.0,13.82,58.71).
city('Moelnlycke','se','Vaestra Goetaland',14653.0,12.13,57.65).
city('Skara','se','Vaestra Goetaland',10608.0,13.44,58.38).
city('Skoevde','se','Vaestra Goetaland',32639.0,13.84,58.38).
city('Trollhaettan','se','Vaestra Goetaland',44522.0,12.3,58.29).
city('Uddevalla','se','Vaestra Goetaland',30283.0,11.93,58.35).
city('Vaenersborg','se','Vaestra Goetaland',21836.0,12.33,58.37).
city('Aarau','ch','Aargau',15007.0,8.04,47.4).
city('Aarburg','ch','Aargau',6484.0,7.89,47.32).
city('Baden','ch','Aargau',16659.0,8.31,47.48).
city('Bremgarten','ch','Aargau',6702.0,8.33,47.37).
city('Brugg','ch','Aargau',9159.0,8.19,47.49).
city('Buchs','ch','Aargau',6397.0,8.06,47.39).
city('Graenichen','ch','Aargau',6444.0,8.1,47.36).
city('Kuettigen','ch','Aargau',5092.0,8.05,47.42).
city('Lenzburg','ch','Aargau',7616.0,8.18,47.3).
city('Menziken','ch','Aargau',5645.0,8.18,47.26).
city('Moehlin','ch','Aargau',8353.0,7.84,47.55).
city('Muri','ch','Aargau',6307.0,8.34,47.28).
city('Neuenhof','ch','Aargau',7358.0,8.31,47.46).
city('Oberentfelden','ch','Aargau',6981.0,8.03,47.35).
city('Obersiggenthal','ch','Aargau',7683.0,8.3,47.49).
city('Oftringen','ch','Aargau',10062.0,7.91,47.32).
city('Reinach','ch','Aargau',7756.0,8.17,47.27).
city('Rheinfelden','ch','Aargau',10657.0,7.79,47.56).
city('Rothrist','ch','Aargau',7141.0,7.9,47.3).
city('Seon','ch','Aargau',4556.0,8.14,47.35).
city('Spreitenbach','ch','Aargau',10544.0,8.37,47.42).
city('Suhr','ch','Aargau',9522.0,8.07,47.37).
city('Untersiggenthal','ch','Aargau',6551.0,8.31,47.53).
city('Villmergen','ch','Aargau',5244.0,8.24,47.35).
city('Wettingen','ch','Aargau',18509.0,8.31,47.47).
city('Windisch','ch','Aargau',6815.0,8.23,47.47).
city('Wohlen','ch','Aargau',14163.0,8.28,47.37).
city('Zofingen','ch','Aargau',12327.0,7.95,47.29).
city('Appenzell','ch','Appenzell Inner-Rhoden',5541.0,9.4,47.33).
city('Herisau','ch','Appenzell-Outer Rhoden',15444.0,9.28,47.4).
city('Teufen','ch','Appenzell-Outer Rhoden',5621.0,9.37,47.39).
city('Aesch','ch','Basel-Landschaft',10396.0,7.6,47.47).
city('Allschwil','ch','Basel-Landschaft',18745.0,7.53,47.55).
city('Arlesheim','ch','Basel-Landschaft',9737.0,7.61,47.49).
city('Binningen','ch','Basel-Landschaft',15046.0,7.56,47.54).
city('Birsfelden','ch','Basel-Landschaft',10627.0,7.61,47.55).
city('Bottmingen','ch','Basel-Landschaft',5956.0,7.56,47.52).
city('Ettingen','ch','Basel-Landschaft',4917.0,7.54,47.49).
city('Frenkendorf','ch','Basel-Landschaft',5984.0,7.71,47.5).
city('Gelterkinden','ch','Basel-Landschaft',5541.0,7.85,47.47).
city('Laufen','ch','Basel-Landschaft',5223.0,7.5,47.42).
city('Lausen','ch','Basel-Landschaft',5043.0,7.75,47.48).
city('Liestal','ch','Basel-Landschaft',12491.0,7.73,47.49).
city('Muenchenstein','ch','Basel-Landschaft',12059.0,7.61,47.52).
city('Muttenz','ch','Basel-Landschaft',16646.0,7.64,47.52).
city('Oberwil','ch','Basel-Landschaft',9957.0,7.55,47.52).
city('Pra','ch','Basel-Landschaft',14861.0,7.67,47.52).
city('Reinach','ch','Basel-Landschaft',18747.0,7.58,47.5).
city('Sissach','ch','Basel-Landschaft',5680.0,7.79,47.47).
city('Therwil','ch','Basel-Landschaft',8986.0,7.55,47.5).
city('Basel','ch','Basel-Town',164474.0,7.58,47.57).
city('Riehen','ch','Basel-Town',20583.0,7.65,47.59).
city('Belp','ch','Bern',9594.0,7.5,46.89).
city('Bern','ch','Bern',123018.0,7.44,46.95).
city('Biel','ch','Bern',49675.0,7.24,47.15).
city('Bolligen','ch','Bern',6291.0,7.48,46.98).
city('Burgdorf','ch','Bern',14943.0,7.62,47.07).
city('Frutigen','ch','Bern',6668.0,7.65,46.58).
city('Heimberg','ch','Bern',5586.0,7.61,46.79).
city('Herzogenbuchsee','ch','Bern',5734.0,7.7,47.19).
city('Huttwil','ch','Bern',4480.0,7.84,47.12).
city('Interlaken','ch','Bern',5057.0,7.86,46.69).
city('Ittigen','ch','Bern',10610.0,7.49,46.98).
city('Kirchberg','ch','Bern',5279.0,7.58,47.09).
city('Koeniz','ch','Bern',35961.0,7.42,46.94).
city('Konolfingen','ch','Bern',4509.0,7.62,46.88).
city('Langenthal','ch','Bern',14533.0,7.78,47.22).
city('Langnau','ch','Bern',8731.0,7.77,46.94).
city('Lengnau','ch','Bern',4302.0,7.36,47.19).
city('Lyss','ch','Bern',10892.0,7.29,47.08).
city('Meiringen','ch','Bern',4708.0,8.18,46.74).
city('Moutier','ch','Bern',7476.0,7.36,47.29).
city('Muenchenbuchsee','ch','Bern',10774.0,7.45,47.02).
city('Muensingen','ch','Bern',11326.0,7.56,46.89).
city('Muri','ch','Bern',12280.0,7.48,46.94).
city('Nidau','ch','Bern',6932.0,7.22,47.12).
city('Ostermundingen','ch','Bern',14891.0,7.48,46.95).
city('Saanen','ch','Bern',6644.0,7.26,46.5).
city('Saint-Imier','ch','Bern',4701.0,7.0,47.15).
city('Spiez','ch','Bern',12310.0,7.67,46.69).
city('Steffisburg','ch','Bern',15396.0,7.62,46.79).
city('Sumiswald','ch','Bern',5072.0,7.74,47.03).
city('Thun','ch','Bern',41539.0,7.62,46.77).
city('Uetendorf','ch','Bern',5538.0,7.56,46.77).
city('Unterseen','ch','Bern',5283.0,7.84,46.69).
city('Urtenen','ch','Bern',5255.0,7.48,47.02).
city('Wahlern','ch','Bern',6292.0,7.35,46.82).
city('Wohlen','ch','Bern',9310.0,7.36,46.98).
city('Worb','ch','Bern',11586.0,7.56,46.93).
city('Zollikofen','ch','Bern',9144.0,7.44,47.01).
city('Bulle','ch','Fribourg',12460.0,7.04,46.62).
city('Duedingen','ch','Fribourg',7088.0,7.2,46.85).
city('Fribourg','ch','Fribourg',33806.0,7.14,46.81).
city('Marly','ch','Fribourg',6976.0,7.16,46.78).
city('Murten','ch','Fribourg',5377.0,7.11,46.94).
city('Villars-sur-Glane','ch','Fribourg',9379.0,7.11,46.8).
city('Wuennewil-Flamatt','ch','Fribourg',5066.0,7.3,46.89).
city('Bernex','ch','Geneva',9266.0,6.08,46.19).
city('Carouge','ch','Geneva',19688.0,6.13,46.19).
city('Chene-Bougeries','ch','Geneva',9821.0,6.18,46.2).
city('Chene-Bourg','ch','Geneva',8038.0,6.2,46.2).
city('Collonge-Bellerive','ch','Geneva',6857.0,7.03,46.17).
city('Cologny','ch','Geneva',5103.0,6.19,46.23).
city('Geneva','ch','Geneva',181492.0,6.14,46.21).
city('Lancy','ch','Geneva',26982.0,6.12,46.19).
city('Le Grand-Saconnex','ch','Geneva',8457.0,6.12,46.24).
city('Meyrin','ch','Geneva',19691.0,6.07,46.26).
city('Onex','ch','Geneva',16796.0,6.09,46.18).
city('Plan-les-Ouates','ch','Geneva',8135.0,6.12,46.17).
city('Thonex','ch','Geneva',13018.0,6.19,46.19).
city('Vernier','ch','Geneva',29767.0,6.06,46.23).
city('Versoix','ch','Geneva',11660.0,6.16,46.29).
city('Veyrier','ch','Geneva',9375.0,6.16,46.18).
city('Glarus','ch','Glarus',5889.0,9.06,47.05).
city('Arosa','ch','Graubuenden',2162.0,9.66,46.79).
city('Chur','ch','Graubuenden',32874.0,9.53,46.86).
city('Davos','ch','Graubuenden',10713.0,9.82,46.81).
city('Domat','ch','Graubuenden',6818.0,9.45,46.84).
city('Igis','ch','Graubuenden',7078.0,9.57,46.95).
city('Sankt Moritz','ch','Graubuenden',5035.0,9.83,46.51).
city('Delemont','ch','Jura',11567.0,7.33,47.37).
city('Porrentruy','ch','Jura',6453.0,7.06,47.43).
city('Buchrain','ch','Luzern',5802.0,8.35,47.1).
city('Ebikon','ch','Luzern',11473.0,8.34,47.09).
city('Emmen','ch','Luzern',27290.0,8.3,47.09).
city('Hochdorf','ch','Luzern',7793.0,8.29,47.17).
city('Horw','ch','Luzern',12110.0,8.3,47.02).
city('Kriens','ch','Luzern',26117.0,8.27,47.03).
city('Littau','ch','Luzern',16403.0,8.25,47.05).
city('Luzern','ch','Luzern',57269.0,8.3,47.06).
city('Malters','ch','Luzern',6303.0,8.18,47.04).
city('Meggen','ch','Luzern',6593.0,8.38,47.06).
city('Neuenkirc','ch','Luzern',5683.0,8.2,47.1).
city('Rothenburg','ch','Luzern',6390.0,8.27,47.1).
city('Ruswil','ch','Luzern',6441.0,8.11,47.09).
city('Sursee','ch','Luzern',7962.0,8.09,47.17).
city('Boudry','ch','Neuchatel',5038.0,6.82,46.95).
city('Colombier','ch','Neuchatel',5133.0,6.85,46.97).
city('La Chaux-de-Fonds','ch','Neuchatel',36971.0,6.82,47.11).
city('Le Locle','ch','Neuchatel',9933.0,6.77,47.08).
city('Neuchatel','ch','Neuchatel',31216.0,6.92,47.01).
city('Peseux','ch','Neuchatel',5580.0,6.88,46.99).
city('Buochs','ch','Nidwalden',5272.0,8.41,46.97).
city('Hergiswil','ch','Nidwalden',5477.0,8.32,46.99).
city('Stans','ch','Nidwalden',7620.0,8.35,46.96).
city('Alpnach','ch','Obwalden',5139.0,8.27,46.95).
city('Kerns','ch','Obwalden',5375.0,8.27,46.9).
city('Sarnen','ch','Obwalden',9405.0,8.25,46.91).
city('Altstaetten','ch','Saint Gall',10585.0,9.53,47.39).
city('Au','ch','Saint Gall',6864.0,9.63,47.43).
city('Bad Ragaz','ch','Saint Gall',4786.0,9.5,47.0).
city('Buchs','ch','Saint Gall',10361.0,9.46,47.17).
city('Diepoldsau','ch','Saint Gall',5351.0,9.65,47.39).
city('Ebnat-Kappel','ch','Saint Gall',4740.0,9.11,47.25).
city('Eschenbach','ch','Saint Gall',5167.0,8.92,47.24).
city('Flawil','ch','Saint Gall',9878.0,9.17,47.42).
city('Flums','ch','Saint Gall',4936.0,9.34,47.09).
city('Gaiserwald','ch','Saint Gall',8105.0,9.34,47.43).
city('Gossau','ch','Saint Gall',17268.0,9.25,47.43).
city('Grabs','ch','Saint Gall',6244.0,9.44,47.19).
city('Jona','ch','Saint Gall',17806.0,8.85,47.25).
city('Kirchberg','ch','Saint Gall',8073.0,9.04,47.41).
city('Mels','ch','Saint Gall',8252.0,8.41,47.05).
city('Oberriet','ch','Saint Gall',7717.0,9.56,47.33).
city('Oberuzwil','ch','Saint Gall',5600.0,9.11,47.44).
city('Rapperswil','ch','Saint Gall',7959.0,8.83,47.24).
city('Rorschach','ch','Saint Gall',8582.0,9.49,47.48).
city('Rorschacherberg','ch','Saint Gall',6632.0,9.5,47.47).
city('Saint Gall','ch','Saint Gall',72001.0,9.36,47.44).
city('Sankt Margrethen','ch','Saint Gall',4995.0,9.6,47.46).
city('Sargans','ch','Saint Gall',4991.0,9.42,47.06).
city('Sevelen','ch','Saint Gall',4450.0,9.48,47.13).
city('Thal','ch','Saint Gall',6124.0,9.56,47.47).
city('Uznach','ch','Saint Gall',5648.0,8.98,47.23).
city('Uzwil','ch','Saint Gall',12185.0,9.13,47.44).
city('Walenstadt','ch','Saint Gall',4546.0,9.31,47.13).
city('Wattwil','ch','Saint Gall',8129.0,9.08,47.31).
city('Widnau','ch','Saint Gall',7690.0,7.97,47.49).
city('Wil','ch','Saint Gall',17234.0,9.03,47.47).
city('Wittenbach','ch','Saint Gall',8283.0,9.37,47.47).
city('Neuhausen','ch','Schaffhausen',10127.0,8.62,47.69).
city('Schaffhausen','ch','Schaffhausen',34445.0,8.62,47.71).
city('Arth','ch','Schwyz',10100.0,8.51,47.07).
city('Einsiedeln','ch','Schwyz',13188.0,8.75,47.12).
city('Freienbach','ch','Schwyz',14900.0,8.76,47.21).
city('Ingenbohl','ch','Schwyz',7964.0,8.62,47.0).
city('Kuessnacht','ch','Schwyz',11771.0,8.43,47.09).
city('Lachen','ch','Schwyz',6879.0,8.84,47.19).
city('Schuebelbach','ch','Schwyz',8292.0,8.93,47.18).
city('Schwyz','ch','Schwyz',14425.0,8.62,47.03).
city('Wollerau','ch','Schwyz',6891.0,8.72,47.2).
city('Balsthal','ch','Solothurn',5576.0,7.69,47.32).
city('Bellach','ch','Solothurn',5161.0,7.49,47.21).
city('Biberist','ch','Solothurn',7463.0,7.55,47.19).
city('Derendingen','ch','Solothurn',5916.0,7.58,47.2).
city('Dornach','ch','Solothurn',5940.0,7.61,47.47).
city('Gerlafingen','ch','Solothurn',5032.0,7.57,47.17).
city('Grenchen','ch','Solothurn',16135.0,7.39,47.2).
city('Olten','ch','Solothurn',16555.0,7.9,47.37).
city('Schoenenwerd','ch','Solothurn',4470.0,8.0,47.37).
city('Solothurn','ch','Solothurn',15292.0,7.54,47.22).
city('Trimbach','ch','Solothurn',6127.0,7.89,47.37).
city('Zuchwil','ch','Solothurn',8815.0,7.56,47.2).
city('Aadorf','ch','Thurgau',7100.0,8.9,47.49).
city('Amriswil','ch','Thurgau',11543.0,9.29,47.55).
city('Arbon','ch','Thurgau',13125.0,9.42,47.52).
city('Bischofszell','ch','Thurgau',5520.0,9.24,47.49).
city('Frauenfeld','ch','Thurgau',22639.0,8.89,47.56).
city('Kreuzlingen','ch','Thurgau',17233.0,9.17,47.66).
city('Romanshorn','ch','Thurgau',9060.0,9.36,47.57).
city('Sirnach','ch','Thurgau',6658.0,9.0,47.47).
city('Sulgen','ch','Thurgau',3081.0,9.18,47.55).
city('Weinfelden','ch','Thurgau',9529.0,9.09,47.57).
city('Ascona','ch','Ticino',5236.0,8.76,46.17).
city('Bellinzona','ch','Ticino',17006.0,9.02,46.2).
city('Biasca','ch','Ticino',5937.0,8.97,46.37).
city('Chiasso','ch','Ticino',8232.0,9.03,45.84).
city('Giubia','ch','Ticino',7926.0,9.01,46.18).
city('Locarno','ch','Ticino',13998.0,8.79,46.18).
city('Losone','ch','Ticino',6060.0,8.75,46.13).
city('Lugano','ch','Ticino',26327.0,8.94,46.01).
city('Massagno','ch','Ticino',5918.0,8.94,46.02).
city('Mendrisio','ch','Ticino',6192.0,8.98,45.88).
city('Minusio','ch','Ticino',6772.0,8.81,46.19).
city('Pregassona','ch','Ticino',7491.0,8.97,46.04).
city('Viganello','ch','Ticino',6330.0,8.97,46.02).
city('Altdorf','ch','Uri',8833.0,8.64,46.89).
city('Schattdorf','ch','Uri',4779.0,8.64,46.87).
city('Bagnes','ch','Valais',7114.0,7.22,46.08).
city('Brig-Glis','ch','Valais',12137.0,7.98,46.33).
city('Collombey-Muraz','ch','Valais',6231.0,6.94,46.27).
city('Conthey','ch','Valais',6747.0,7.29,46.24).
city('Fully','ch','Valais',5965.0,7.11,46.14).
city('Martigny','ch','Valais',14413.0,7.06,46.11).
city('Monthey','ch','Valais',16002.0,6.93,46.27).
city('Naters','ch','Valais',7472.0,7.99,46.33).
city('Nendaz','ch','Valais',5477.0,7.32,46.19).
city('Saviese','ch','Valais',5653.0,7.34,46.26).
city('Sierre','ch','Valais',14648.0,7.51,46.31).
city('Sion','ch','Valais',28246.0,7.35,46.25).
city('Visp','ch','Valais',6560.0,7.88,46.29).
city('Zermatt','ch','Valais',5607.0,7.75,46.02).
city('Aigle','ch','Vaud',7897.0,6.95,46.32).
city('Bex','ch','Vaud',5995.0,7.01,46.25).
city('Blonay','ch','Vaud',5294.0,6.89,46.47).
city('Bussigny','ch','Vaud',7317.0,6.56,46.55).
city('Chavannes','ch','Vaud',5740.0,6.57,46.53).
city('Crissier','ch','Vaud',6915.0,6.58,46.55).
city('Ecublens','ch','Vaud',10655.0,6.79,46.6).
city('Epalinges','ch','Vaud',7521.0,6.67,46.56).
city('Gland','ch','Vaud',11194.0,6.27,46.43).
city('La Tour-de-Peilz','ch','Vaud',10835.0,6.86,46.46).
city('Lausanne','ch','Vaud',118015.0,6.62,46.52).
city('Le Mont-sur-Lausanne','ch','Vaud',5139.0,6.63,46.56).
city('Lutry','ch','Vaud',8625.0,6.66,46.51).
city('Montreux','ch','Vaud',23703.0,6.88,46.45).
city('Morges','ch','Vaud',13759.0,6.49,46.52).
city('Nyon','ch','Vaud',17071.0,6.21,46.39).
city('Ollon','ch','Vaud',6494.0,6.99,46.3).
city('Orbe','ch','Vaud',5466.0,6.52,46.72).
city('Payerne','ch','Vaud',7758.0,6.92,46.82).
city('Prilly','ch','Vaud',10774.0,6.59,46.54).
city('Pully','ch','Vaud',16640.0,6.64,46.52).
city('Renens','ch','Vaud',17530.0,6.58,46.54).
city('Vevey','ch','Vaud',16014.0,6.82,46.47).
city('Yverdon','ch','Vaud',23756.0,6.63,46.79).
city('Baar','ch','Zug',20752.0,8.51,47.2).
city('Cham','ch','Zug',13431.0,8.46,47.19).
city('Huenenberg','ch','Zug',8060.0,8.42,47.17).
city('Risch','ch','Zug',8645.0,7.33,46.42).
city('Steinhausen','ch','Zug',8640.0,8.48,47.2).
city('Unteraegeri','ch','Zug',7248.0,8.57,47.14).
city('Zug','ch','Zug',24197.0,8.52,47.18).
city('Adliswil','ch','Zurich',16144.0,8.51,47.32).
city('Affoltern','ch','Zurich',10415.0,8.44,47.29).
city('Bassersdorf','ch','Zurich',9860.0,8.61,47.45).
city('Birmensdorf','ch','Zurich',5630.0,8.43,47.36).
city('Bubikon','ch','Zurich',6160.0,8.82,47.28).
city('Buelach','ch','Zurich',14776.0,8.54,47.53).
city('Dietikon','ch','Zurich',22443.0,8.39,47.42).
city('Dietlikon','ch','Zurich',7121.0,8.62,47.44).
city('Duebendorf','ch','Zurich',23051.0,8.63,47.4).
city('Duernten','ch','Zurich',6225.0,8.84,47.28).
city('Egg','ch','Zurich',8585.0,8.69,47.3).
city('Embrach','ch','Zurich',8517.0,8.6,47.51).
city('Faellanden','ch','Zurich',6987.0,8.64,47.37).
city('Fehraltdorf','ch','Zurich',4780.0,8.75,47.39).
city('Gossau','ch','Zurich',9028.0,8.76,47.31).
city('Greifensee','ch','Zurich',5080.0,8.69,47.37).
city('Herrliberg','ch','Zurich',5922.0,8.62,47.29).
city('Hinwil','ch','Zurich',10533.0,8.84,47.31).
city('Hombrechtikon','ch','Zurich',7795.0,8.77,47.26).
city('Horgen','ch','Zurich',18055.0,8.6,47.27).
city('Illnau-Effretikon','ch','Zurich',15840.0,8.73,47.41).
city('Kilchberg','ch','Zurich',6918.0,8.55,47.32).
city('Kloten','ch','Zurich',18141.0,8.58,47.46).
city('Kuesnacht','ch','Zurich',13000.0,8.58,47.33).
city('Langnau','ch','Zurich',6721.0,8.54,47.29).
city('Maennedorf','ch','Zurich',10164.0,8.69,47.27).
city('Maur','ch','Zurich',9577.0,8.67,47.33).
city('Meilen','ch','Zurich',11723.0,8.63,47.28).
city('Niederhasli','ch','Zurich',7489.0,8.49,47.49).
city('Oberengstringen','ch','Zurich',6106.0,8.46,47.42).
city('Oberglatt','ch','Zurich',5346.0,8.5,47.48).
city('Opfikon','ch','Zurich',13395.0,8.57,47.44).
city('Pfaeffikon','ch','Zurich',9987.0,8.79,47.38).
city('Regensdorf','ch','Zurich',15756.0,8.48,47.43).
city('Richterswil','ch','Zurich',11398.0,8.71,47.21).
city('Ruemlang','ch','Zurich',6304.0,8.53,47.46).
city('Rueschlikon','ch','Zurich',5246.0,8.55,47.31).
city('Rueti','ch','Zurich',11361.0,8.83,47.27).
city('Schlieren','ch','Zurich',13762.0,8.45,47.4).
city('Seuzach','ch','Zurich',7061.0,8.73,47.54).
city('Staefa','ch','Zurich',13040.0,8.72,47.25).
city('Thalwil','ch','Zurich',16389.0,8.56,47.31).
city('Urdorf','ch','Zurich',9247.0,8.42,47.39).
city('Uster','ch','Zurich',29583.0,8.71,47.36).
city('Volketswil','ch','Zurich',14592.0,8.7,47.38).
city('Waedenswil','ch','Zurich',19473.0,8.66,47.24).
city('Wald','ch','Zurich',9016.0,8.91,47.29).
city('Wallisellen','ch','Zurich',12820.0,8.58,47.42).
city('Wangen-Bruettisellen','ch','Zurich',6136.0,8.62,47.43).
city('Wetzikon','ch','Zurich',19377.0,8.79,47.33).
city('Winterthur','ch','Zurich',91368.0,8.72,47.51).
city('Zollikon','ch','Zurich',12534.0,8.58,47.34).
city('Zumikon','ch','Zurich',5082.0,8.61,47.34).
city('Zurich','ch','Zurich',346185.0,8.54,47.38).
city('Afrin','sy','Aleppo',19757.0,36.87,36.51).
city('Aleppo','sy','Aleppo',2139878.0,37.17,36.23).
city('Ayn-al-Arab','sy','Aleppo',20552.0,38.37,36.89).
city('Azaz','sy','Aleppo',27457.0,37.06,36.59).
city('Manbij','sy','Aleppo',105420.0,37.96,36.54).
city('al-Bab','sy','Aleppo',49763.0,37.53,36.37).
city('as-Safirah','sy','Aleppo',35152.0,37.38,36.08).
city('Damascus','sy','Damascus',1576843.0,36.32,33.5).
city('Darayya','sy','Damascus',51760.0,36.25,33.43).
city('Duma','sy','Damascus',111709.0,36.39,33.58).
city('Harasta al-Bas','sy','Damascus',39004.0,36.36,33.55).
city('Jaramana','sy','Damascus',189888.0,36.36,33.47).
city('Qatana','sy','Damascus',27254.0,36.09,33.43).
city('Yabrud','sy','Damascus',25941.0,36.66,33.97).
city('al-Qutayfah','sy','Damascus',18636.0,36.6,33.75).
city('an-Nabk','sy','Damascus',29676.0,36.73,34.03).
city('at-Tall','sy','Damascus',27665.0,36.32,33.61).
city('az-Zabadani','sy','Damascus',25029.0,36.08,33.72).
city('Dara','sy','Dara',116368.0,36.1,32.63).
city('Nawa','sy','Dara',50821.0,36.04,32.9).
city('Abu Kamal','sy','Dayr-az-Zawr',62491.0,40.93,34.45).
city('Dayr az-Zawr','sy','Dayr-az-Zawr',187575.0,40.13,35.33).
city('al-Mayadin','sy','Dayr-az-Zawr',53421.0,40.46,35.02).
city('Hamah','sy','Hamah',348949.0,36.73,35.15).
city('Masyaf','sy','Hamah',33001.0,36.35,35.06).
city('Muhradah','sy','Hamah',32592.0,36.58,35.25).
city('Salamiyah','sy','Hamah',91318.0,37.05,35.02).
city('Hims','sy','Hims',736005.0,36.72,34.73).
city('Tudmur','sy','Hims',42283.0,38.28,34.55).
city('al-Qusayr','sy','Hims',34535.0,36.57,34.51).
city('ar-Rastan','sy','Hims',35211.0,36.74,34.93).
city('Ariha','sy','Idlib',54728.0,36.62,35.82).
city('Idlib','sy','Idlib',110503.0,36.63,35.94).
city('Jisr-as-Sugur','sy','Idlib',65966.0,36.32,35.81).
city('Maarrat-an-Numan','sy','Idlib',78624.0,36.67,35.66).
city('Baniyas','sy','Tartus',39718.0,35.96,35.18).
city('Safita','sy','Tartus',20394.0,36.13,34.82).
city('Tartus','sy','Tartus',107081.0,35.89,34.9).
city('Ras-al-Ayn','sy','al-Hasakah',25672.0,40.08,36.85).
city('al-Hasakah','sy','al-Hasakah',132018.0,40.76,36.5).
city('al-Malikiyah','sy','al-Hasakah',23778.0,42.15,37.18).
city('al-Qamisli','sy','al-Hasakah',196508.0,41.23,37.03).
city('Jablah','sy','al-Ladiqiyah',52309.0,35.94,35.37).
city('al-Ladiqiyah','sy','al-Ladiqiyah',431690.0,35.78,35.54).
city('al-Qunaytirah','sy','al-Qunaytirah',36144.0,35.82,33.13).
city('ar-Raqqah','sy','ar-Raqqah',261545.0,39.02,35.93).
city('atz-Tzawrah','sy','ar-Raqqah',125372.0,38.58,35.85).
city('as-Suwayda','sy','as-Suwayda',100634.0,36.56,32.71).
city('Changhwa','tw','Changhwa',227362.0,120.52,24.08).
city('Chihu','tw','Changhwa',56733.0,120.47,23.96).
city('Erhlin','tw','Changhwa',55234.0,120.37,23.9).
city('Homei','tw','Changhwa',88185.0,120.49,24.11).
city('Lukang','tw','Changhwa',83071.0,120.43,24.06).
city('Peitou','tw','Changhwa',34466.0,120.51,23.87).
city('Tienchung','tw','Changhwa',46310.0,120.57,23.86).
city('Yuanlin','tw','Changhwa',127650.0,120.55,23.96).
city('Potzu','tw','Chiayi Hsien',42268.0,120.24,23.47).
city('Putai','tw','Chiayi Hsien',30975.0,120.15,23.38).
city('Taipao','tw','Chiayi Hsien',34737.0,120.32,23.47).
city('Talin','tw','Chiayi Hsien',34975.0,120.45,23.6).
city('Chiayi','tw','Chiayi Shih',266317.0,120.43,23.48).
city('Chupei','tw','Hsinchu Hsien',106065.0,121.0,24.85).
city('Chutung','tw','Hsinchu Hsien',92669.0,121.07,24.73).
city('Hsinpu','tw','Hsinchu Hsien',35417.0,121.07,24.83).
city('Kuanhsi','tw','Hsinchu Hsien',34720.0,121.17,24.79).
city('Hsinchu','tw','Hsinchu Shih',413683.0,120.98,24.82).
city('Fenglin','tw','Hualien',12763.0,121.43,23.75).
city('Hualian','tw','Hualien',108290.0,121.59,23.99).
city('Yuli','tw','Hualien',30038.0,121.3,23.33).
city('Ilan','tw','Ilan',92920.0,121.74,24.77).
city('Lotung','tw','Ilan',70627.0,121.76,24.69).
city('Suao','tw','Ilan',43156.0,121.84,24.6).
city('Toucheng','tw','Ilan',31414.0,121.81,24.86).
city('Chishan','tw','Kaohsiung Hsien',41137.0,120.47,22.89).
city('Fengshan','tw','Kaohsiung Hsien',334443.0,120.35,22.63).
city('Kangshan','tw','Kaohsiung Hsien',97102.0,120.27,22.8).
city('Meinung','tw','Kaohsiung Hsien',43005.0,120.53,22.9).
city('Kaohsiung','tw','Kaohsiung Shih',1512832.0,120.27,22.63).
city('Keelung','tw','Keelung Shih',397516.0,121.73,25.13).
city('Kincheng','tw','Kinmen',18622.0,118.33,24.44).
city('Kinhsia','tw','Kinmen',9442.0,118.43,24.45).
city('Cholan','tw','Miaoli',18806.0,120.82,24.32).
city('Chunan','tw','Miaoli',71204.0,120.92,24.7).
city('Houlung','tw','Miaoli',41120.0,120.78,24.62).
city('Miaoli','tw','Miaoli',88945.0,120.81,24.57).
city('Toufen','tw','Miaoli',92557.0,120.91,24.69).
city('Tunghsiao','tw','Miaoli',39058.0,120.67,24.49).
city('Yuanli','tw','Miaoli',49231.0,120.65,24.45).
city('Chichi','tw','Nantou',11284.0,120.78,23.83).
city('Chushan','tw','Nantou',59640.0,120.66,23.75).
city('Nantou','tw','Nantou',107219.0,120.67,23.92).
city('Puli','tw','Nantou',87642.0,120.96,23.97).
city('Tsaotun','tw','Nantou',99423.0,120.68,23.98).
city('Makung','tw','Penghu',51043.0,119.56,23.57).
city('Chaochou','tw','Pingtung',58795.0,120.53,22.55).
city('Hengchun','tw','Pingtung',29449.0,120.6,24.37).
city('Pingtung','tw','Pingtung',208920.0,120.48,22.68).
city('Tungkang','tw','Pingtung',51500.0,120.44,22.46).
city('Chingshui','tw','Taichung Hsien',82843.0,120.57,24.28).
city('Fengyuan','tw','Taichung Hsien',162757.0,120.3,23.93).
city('Shalu','tw','Taichung Hsien',72263.0,120.55,24.24).
city('Tachia','tw','Taichung Hsien',78670.0,120.62,24.35).
city('Tali','tw','Taichung Hsien',190564.0,120.67,24.1).
city('Wuchi','tw','Taichung Hsien',53919.0,120.52,24.27).
city('Taichung','tw','Taichung Shih',1083582.0,120.68,24.15).
city('Chiali','tw','Tainan Hsien',58438.0,120.17,23.17).
city('Hsinhua','tw','Tainan Hsien',47816.0,120.3,23.04).
city('Hsinying','tw','Tainan Hsien',77207.0,120.31,23.3).
city('Hsuechia','tw','Tainan Hsien',29341.0,120.17,23.24).
city('Matou','tw','Tainan Hsien',46728.0,120.24,23.19).
city('Paiho','tw','Tainan Hsien',32064.0,120.41,23.35).
city('Shanhwa','tw','Tainan Hsien',41446.0,120.28,23.14).
city('Yenshui','tw','Tainan Hsien',28673.0,120.26,23.33).
city('Yungkang','tw','Tainan Hsien',240214.0,121.12,22.94).
city('Tainan','tw','Tainan Shih',734314.0,120.19,23.0).
city('Chungho','tw','Taipei Hsien',378389.0,121.5,24.99).
city('Hsichih','tw','Taipei Hsien',213899.0,121.65,25.07).
city('Hsinchuang','tw','Taipei Hsien',406615.0,121.44,25.04).
city('Hsintien','tw','Taipei Hsien',275698.0,121.53,24.96).
city('Juifang','tw','Taipei Hsien',44657.0,121.81,25.11).
city('Luchou','tw','Taipei Hsien',203059.0,121.47,25.08).
city('Panchiao','tw','Taipei Hsien',491891.0,121.44,25.02).
city('Sanchung','tw','Taipei Hsien',360829.0,121.48,25.07).
city('Sanhsia','tw','Taipei Hsien',100698.0,121.36,24.93).
city('Shulin','tw','Taipei Hsien',179136.0,121.42,25.0).
city('Taipei','tw','Taipei Hsien',2514794.0,121.45,25.02).
city('Tanshui','tw','Taipei Hsien',133001.0,121.42,25.19).
city('Tucheng','tw','Taipei Hsien',332405.0,121.44,24.98).
city('Yingko','tw','Taipei Hsien',86237.0,121.35,24.96).
city('Yungho','tw','Taipei Hsien',207852.0,121.51,25.02).
city('Kuanshan','tw','Taitung',10245.0,121.15,23.05).
city('Taitung','tw','Taitung',109353.0,121.14,22.76).
city('Chengkung','tw','Taoyuan',18621.0,120.83,24.2).
city('Chungli','tw','Taoyuan',351185.0,121.22,24.96).
city('Pate','tw','Taoyuan',176909.0,121.28,24.92).
city('Pingchen','tw','Taoyuan',219163.0,121.21,24.95).
city('Tachi','tw','Taoyuan',84552.0,121.28,24.88).
city('Taoyuan','tw','Taoyuan',375366.0,121.31,25.0).
city('Tungshih','tw','Taoyuan',58779.0,120.82,24.27).
city('Yangmei','tw','Taoyuan',149768.0,121.13,24.91).
city('Hsilo','tw','Yunlin',48180.0,120.45,23.8).
city('Huwei','tw','Yunlin',63693.0,120.39,23.72).
city('Peikang','tw','Yunlin',43945.0,120.29,23.57).
city('Touliu','tw','Yunlin',104726.0,120.53,23.71).
city('Tounan','tw','Yunlin',48112.0,120.47,23.68).
city('Tuku','tw','Yunlin',31038.0,120.37,23.67).
city('Dushanbe','tj','Dushanbe',543105.0,68.78,38.57).
city('Khorug','tj','Gorno-Badakhshan',31847.0,71.55,37.49).
city('Murgob','tj','Gorno-Badakhshan',10815.0,73.94,38.16).
city('Boshkengash','tj','Karotegin',23696.0,68.76,38.44).
city('Chorbog','tj','Karotegin',4237.0,68.19,37.41).
city('Darband','tj','Karotegin',1115.0,69.96,38.87).
city('Garm','tj','Karotegin',10771.0,70.36,39.03).
city('Hisor','tj','Karotegin',23981.0,68.55,38.53).
city('Karakendzha','tj','Karotegin',2899.0,71.52,39.25).
city('Kofarnihon','tj','Karotegin',42909.0,69.01,38.55).
city('Navabad','tj','Karotegin',5352.0,70.17,39.02).
city('Navabadski','tj','Karotegin',6579.0,68.75,38.58).
city('Obigarm','tj','Karotegin',10035.0,69.7,38.72).
city('Oktyabrskiy','tj','Karotegin',7694.0,68.33,38.53).
city('Rogun','tj','Karotegin',7732.0,69.87,38.78).
city('Shakhrinau','tj','Karotegin',5385.0,68.33,38.57).
city('Sharora','tj','Karotegin',8809.0,68.66,38.57).
city('Takob','tj','Karotegin',2565.0,68.95,38.83).
city('Tartki','tj','Karotegin',2342.0,68.13,37.59).
city('Tursunzoda','tj','Karotegin',37999.0,68.22,38.51).
city('Varzob','tj','Karotegin',2154.0,68.82,38.75).
city('Bolshevik','tj','Khatlon',6521.0,68.68,37.43).
city('Bustonkala','tj','Khatlon',4068.0,68.83,37.87).
city('Dangara','tj','Khatlon',22824.0,69.33,38.1).
city('Dusti','tj','Khatlon',8700.0,68.67,37.35).
city('Farkhor','tj','Khatlon',21736.0,69.39,37.49).
city('Garavuti','tj','Khatlon',8474.0,68.43,37.57).
city('Jilikul','tj','Khatlon',5434.0,68.53,37.48).
city('Khojamaston','tj','Khatlon',9781.0,68.62,38.73).
city('Kulob','tj','Khatlon',78794.0,69.78,37.92).
city('Kuybyshev','tj','Khatlon',9943.0,68.82,37.95).
city('Kuybyshevski','tj','Khatlon',7231.0,68.69,37.98).
city('Leningradskiy','tj','Khatlon',11955.0,70.03,38.11).
city('Moskovskiy','tj','Khatlon',19563.0,69.7,37.62).
city('Nurak','tj','Khatlon',18124.0,69.33,38.39).
city('Oktyabrskiy','tj','Khatlon',7909.0,68.75,37.76).
city('Orzu','tj','Khatlon',5988.0,68.82,37.6).
city('Pyanj','tj','Khatlon',8023.0,69.09,37.24).
city('Qurgonteppa','tj','Khatlon',60090.0,68.77,37.84).
city('Sarband','tj','Khatlon',10739.0,68.92,37.87).
city('Shaartuz','tj','Khatlon',13042.0,68.13,37.26).
city('Sovetskiy','tj','Khatlon',8694.0,69.58,38.03).
city('Tugalan','tj','Khatlon',18476.0,68.66,37.59).
city('Vakhsh','tj','Khatlon',15215.0,68.82,37.72).
city('Vose','tj','Khatlon',21736.0,69.64,37.8).
city('Yovon','tj','Khatlon',17480.0,69.04,38.32).
city('Adrasmon','tj','Sughd',13372.0,69.98,40.64).
city('Altyn-Topkan','tj','Sughd',4823.0,69.59,40.64).
city('Asht','tj','Sughd',11705.0,70.33,40.67).
city('Ayni','tj','Sughd',2128.0,68.53,39.38).
city('Buston','tj','Sughd',13043.0,69.33,40.53).
city('Chkalovsk','tj','Sughd',21555.0,69.73,40.24).
city('Chorku','tj','Sughd',2740.0,70.55,39.97).
city('Choruh-Dairon','tj','Sughd',3507.0,69.66,40.4).
city('Gafurov','tj','Sughd',14482.0,69.8,40.2).
city('Ganci','tj','Sughd',8513.0,69.1,39.97).
city('Isfara','tj','Sughd',37742.0,70.64,40.13).
city('Kansay','tj','Sughd',5042.0,69.69,40.48).
city('Khujand','tj','Sughd',144874.0,69.62,40.29).
city('Kim','tj','Sughd',2411.0,70.47,40.2).
city('Konibodom','tj','Sughd',50364.0,70.43,40.29).
city('Kuruksay','tj','Sughd',3288.0,69.4,40.58).
city('Matcha','tj','Sughd',14897.0,69.4,40.35).
city('Mehnatabad','tj','Sughd',8878.0,69.02,40.17).
city('Nau','tj','Sughd',13833.0,69.37,40.15).
city('Naugarzan','tj','Sughd',877.0,70.55,40.93).
city('Nefteabad','tj','Sughd',4603.0,70.56,40.2).
city('Pakhtakoron','tj','Sughd',8220.0,68.75,40.17).
city('Palas','tj','Sughd',3288.0,69.76,40.32).
city('Panjakent','tj','Sughd',35089.0,67.6,39.5).
city('Proletarsk','tj','Sughd',16441.0,69.51,40.17).
city('Qayroqqum','tj','Sughd',9611.0,69.79,40.28).
city('Shurob','tj','Sughd',3988.0,70.54,40.05).
city('Syrdarinskiy','tj','Sughd',2850.0,69.58,40.25).
city('Taboshar','tj','Sughd',11588.0,69.63,40.58).
city('Takeli','tj','Sughd',2302.0,69.58,40.5).
city('Uroteppa','tj','Sughd',52856.0,69.0,39.92).
city('Vorukh','tj','Sughd',3836.0,70.56,39.86).
city('Zafarobod','tj','Sughd',13810.0,68.55,39.39).
city('Arusha','tz','Arusha',341155.0,36.67,-3.36).
city('Karatu','tz','Arusha',19803.0,35.67,-3.33).
city('Kingori','tz','Arusha',22840.0,36.98,-3.28).
city('Longido','tz','Arusha',9403.0,36.68,-2.73).
city('Mbuguni','tz','Arusha',16442.0,36.95,-3.57).
city('Monduli','tz','Arusha',5694.0,36.45,-3.3).
city('Mto wa Mbu','tz','Arusha',17755.0,35.85,-3.35).
city('Namanga','tz','Arusha',12049.0,36.77,-2.55).
city('Ngorongoro','tz','Arusha',10836.0,35.52,-3.25).
city('Nkoaranga','tz','Arusha',14738.0,36.8,-3.36).
city('Poli','tz','Arusha',9568.0,36.8,-3.33).
city('Sokoni','tz','Arusha',25822.0,39.55,-6.43).
city('Usa River','tz','Arusha',18726.0,36.85,-3.37).
city('Dar es Salaam','tz','Dar es Salaam',2698651.0,39.28,-6.82).
city('Dodoma','tz','Dodoma',180551.0,35.74,-6.17).
city('Kibakwe','tz','Dodoma',19526.0,36.37,-6.72).
city('Kondoa','tz','Dodoma',23520.0,35.77,-4.9).
city('Kongwa','tz','Dodoma',11840.0,36.42,-6.2).
city('Mpwapwa','tz','Dodoma',19806.0,36.48,-6.35).
city('Mvumi Mission','tz','Dodoma',13933.0,35.85,-6.35).
city('Ilembula','tz','Iringa',18870.0,34.58,-8.9).
city('Ilula','tz','Iringa',29193.0,36.03,-7.68).
city('Iringa','tz','Iringa',111831.0,35.69,-7.77).
city('Izazi','tz','Iringa',18010.0,35.73,-7.2).
city('Ludewa','tz','Iringa',9082.0,35.3,-10.58).
city('Lugarawa','tz','Iringa',12479.0,34.73,-9.82).
city('Lupembe','tz','Iringa',17085.0,35.25,-9.25).
city('Mafinga','tz','Iringa',34958.0,35.07,-7.25).
city('Makambako','tz','Iringa',53003.0,34.83,-8.85).
city('Makungu','tz','Iringa',10291.0,35.28,-8.73).
city('Malangali','tz','Iringa',7112.0,34.85,-8.57).
city('Matamba','tz','Iringa',10642.0,33.97,-8.98).
city('Mtwango','tz','Iringa',19040.0,34.8,-9.02).
city('Njombe','tz','Iringa',46731.0,34.77,-9.33).
city('Biharamulo','tz','Kagera',34038.0,31.31,-2.63).
city('Bugene','tz','Kagera',10609.0,31.14,-1.59).
city('Bukoba','tz','Kagera',70630.0,31.8,-1.32).
city('Buseresere','tz','Kagera',52870.0,31.87,-3.02).
city('Bwanga','tz','Kagera',20929.0,31.7,-3.03).
city('Chato','tz','Kagera',27776.0,31.77,-2.64).
city('Kabanga','tz','Kagera',19421.0,30.48,-2.63).
city('Kamachumu','tz','Kagera',15701.0,31.62,-1.62).
city('Katerero','tz','Kagera',18430.0,31.73,-1.4).
city('Katoro','tz','Kagera',11925.0,31.5,-1.4).
city('Kayanga','tz','Kagera',12407.0,31.65,-1.22).
city('Kyaka','tz','Kagera',13809.0,31.42,-1.25).
city('Muleba','tz','Kagera',11555.0,31.65,-1.84).
city('Ngara','tz','Kagera',16890.0,30.65,-2.47).
city('Nshamba','tz','Kagera',19815.0,31.55,-1.8).
city('Nsunga','tz','Kagera',20049.0,31.39,-1.14).
city('Nyakahanga','tz','Kagera',14611.0,31.14,-1.6).
city('Rulenge','tz','Kagera',22069.0,30.63,-2.72).
city('Kakonko','tz','Kigoma',24688.0,30.96,-3.28).
city('Kasulu','tz','Kigoma',37347.0,30.1,-4.58).
city('Kibondo','tz','Kigoma',28666.0,30.7,-3.59).
city('Kigoma','tz','Kigoma',164261.0,29.61,-4.88).
city('Mabamba','tz','Kigoma',14140.0,30.5,-3.6).
city('Mwandiga','tz','Kigoma',16822.0,29.66,-4.83).
city('Nguruka','tz','Kigoma',39135.0,31.04,-5.11).
city('Uvinza','tz','Kigoma',24650.0,30.39,-5.12).
city('Hedaru','tz','Kilimanjaro',20231.0,37.9,-4.5).
city('Kihurio','tz','Kilimanjaro',8377.0,38.07,-4.47).
city('Kisiwani','tz','Kilimanjaro',7126.0,37.95,-4.13).
city('Kwakoa','tz','Kilimanjaro',7514.0,37.72,-3.77).
city('Langata','tz','Kilimanjaro',8119.0,38.08,-4.7).
city('Lembeni','tz','Kilimanjaro',16008.0,37.62,-3.78).
city('Makanya','tz','Kilimanjaro',9505.0,37.83,-4.37).
city('Makuyuni','tz','Kilimanjaro',15516.0,38.1,-4.73).
city('Moshi','tz','Kilimanjaro',156970.0,37.34,-3.34).
city('Mwanga','tz','Kilimanjaro',12846.0,38.2,-4.8).
city('Mwembe','tz','Kilimanjaro',9032.0,37.85,-4.15).
city('Ndungu','tz','Kilimanjaro',14545.0,38.05,-4.37).
city('Same','tz','Kilimanjaro',17455.0,37.72,-4.07).
city('Lindi','tz','Lindi',41915.0,39.7,-10.0).
city('Liwale','tz','Lindi',19296.0,37.93,-9.76).
city('Masoko','tz','Lindi',12720.0,33.75,-9.33).
city('Mbekenyera','tz','Lindi',11794.0,38.98,-10.0).
city('Mingoyo','tz','Lindi',10480.0,39.63,-10.1).
city('Mtama','tz','Lindi',11928.0,39.37,-10.3).
city('Nachingwea','tz','Lindi',18058.0,38.76,-10.37).
city('Nkowe','tz','Lindi',5389.0,30.85,-7.95).
city('Nyangao','tz','Lindi',16343.0,39.28,-10.33).
city('Ruangwa','tz','Lindi',11095.0,38.93,-10.07).
city('Babati','tz','Manyara',34292.0,35.75,-4.22).
city('Bashnet','tz','Manyara',19087.0,35.42,-4.23).
city('Bassotu','tz','Manyara',20938.0,35.08,-4.37).
city('Dareda','tz','Manyara',19876.0,35.55,-4.22).
city('Dongobesh','tz','Manyara',18864.0,35.38,-4.07).
city('Endasaki','tz','Manyara',14577.0,35.52,-4.42).
city('Gallapo','tz','Manyara',18528.0,35.85,-4.27).
city('Haidom','tz','Manyara',25365.0,35.02,-4.15).
city('Katesh','tz','Manyara',4943.0,35.38,-4.52).
city('Kibaya','tz','Manyara',5028.0,36.57,-5.3).
city('Magugu','tz','Manyara',26132.0,35.77,-4.02).
city('Matui','tz','Manyara',20242.0,38.25,-4.8).
city('Mbulu','tz','Manyara',13430.0,35.53,-3.85).
city('Naberera','tz','Manyara',13500.0,36.93,-4.2).
city('Nangwa','tz','Manyara',18595.0,35.45,-4.47).
city('Bunda','tz','Mara',50949.0,33.87,-2.05).
city('Butiama','tz','Mara',16376.0,33.97,-1.77).
city('Issenye','tz','Mara',7778.0,34.33,-2.0).
city('Kibara','tz','Mara',17211.0,33.45,-2.15).
city('Kukirango','tz','Mara',21627.0,33.87,-1.75).
city('Matongo','tz','Mara',11828.0,34.08,-2.38).
city('Mugango','tz','Mara',10550.0,33.7,-1.68).
city('Mugumu','tz','Mara',18431.0,34.7,-1.85).
city('Musoma','tz','Mara',121125.0,33.8,-1.49).
city('Nyamuswa','tz','Mara',16507.0,34.02,-1.9).
city('Sirari','tz','Mara',24317.0,34.43,-1.23).
city('Tarime','tz','Mara',33097.0,34.37,-1.35).
city('Chimala','tz','Mbeya',24817.0,34.02,-8.85).
city('Chokaa','tz','Mbeya',12825.0,35.55,-10.45).
city('Igurusi','tz','Mbeya',24895.0,33.85,-8.85).
city('Ipinda','tz','Mbeya',17775.0,33.9,-9.48).
city('Isongole','tz','Mbeya',7603.0,33.62,-9.07).
city('Itewe','tz','Mbeya',6324.0,33.42,-8.57).
city('Itumba','tz','Mbeya',13438.0,33.18,-9.4).
city('Kandete','tz','Mbeya',10318.0,33.8,-9.15).
city('Kiwira','tz','Mbeya',21342.0,33.53,-9.17).
city('Kyela','tz','Mbeya',30684.0,33.85,-9.58).
city('Mbeya','tz','Mbeya',291672.0,33.43,-8.89).
city('Mlowo','tz','Mbeya',18737.0,32.98,-9.0).
city('Rujewa','tz','Mbeya',29228.0,34.38,-8.7).
city('Tukuyu','tz','Mbeya',28398.0,33.64,-9.25).
city('Tunduma','tz','Mbeya',36556.0,32.77,-9.3).
city('Ulenje','tz','Mbeya',12219.0,33.68,-8.93).
city('Utengule Usongwe','tz','Mbeya',46818.0,33.86,-8.68).
city('Vwawa','tz','Mbeya',40144.0,32.93,-9.11).
city('Gairo','tz','Morogoro',37909.0,36.87,-6.15).
city('Ifakara','tz','Morogoro',49532.0,36.68,-8.13).
city('Kidadu','tz','Morogoro',37542.0,36.96,-7.71).
city('Kidodi','tz','Morogoro',35953.0,36.99,-7.61).
city('Kilosa','tz','Morogoro',91889.0,36.99,-6.84).
city('Kimamba','tz','Morogoro',11235.0,37.13,-6.78).
city('Kisanga','tz','Morogoro',10977.0,37.7,-7.43).
city('Lupiro','tz','Morogoro',11430.0,36.67,-8.38).
city('Magole','tz','Morogoro',18753.0,37.37,-6.37).
city('Magomeni','tz','Morogoro',8944.0,38.12,-5.23).
city('Mahenge','tz','Morogoro',7768.0,36.72,-8.68).
city('Malinyi','tz','Morogoro',27041.0,36.13,-8.93).
city('Mbumi','tz','Morogoro',4305.0,39.2,-7.9).
city('Mhonda','tz','Morogoro',17827.0,37.57,-6.12).
city('Mikumi','tz','Morogoro',16780.0,36.98,-7.4).
city('Mlimba','tz','Morogoro',34969.0,35.82,-8.8).
city('Morogoro','tz','Morogoro',250914.0,37.66,-6.82).
city('Msowero','tz','Morogoro',17861.0,37.2,-6.53).
city('Mtibwa','tz','Morogoro',28949.0,37.65,-6.12).
city('Mtimbira','tz','Morogoro',11122.0,36.35,-8.78).
city('Mvomero','tz','Morogoro',31324.0,38.67,-6.25).
city('Mwaya','tz','Morogoro',7558.0,33.95,-9.55).
city('Ngerengere','tz','Morogoro',17181.0,38.12,-6.75).
city('Chiungutwa','tz','Mtwara',12764.0,38.98,-10.88).
city('Kitama','tz','Mtwara',16232.0,39.73,-10.72).
city('Kitangari','tz','Mtwara',10956.0,39.33,-10.65).
city('Luchingu','tz','Mtwara',25145.0,39.33,-10.9).
city('Lukuledi','tz','Mtwara',29699.0,38.8,-10.57).
city('Lulindi','tz','Mtwara',7807.0,39.13,-10.82).
city('Madimba','tz','Mtwara',12507.0,40.33,-1.0).
city('Mahuta','tz','Mtwara',13548.0,39.45,-10.86).
city('Masasi','tz','Mtwara',36034.0,38.8,-10.73).
city('Mtwara','tz','Mtwara',96606.0,40.19,-10.27).
city('Namalenga','tz','Mtwara',11204.0,39.1,-10.95).
city('Namikupa','tz','Mtwara',11733.0,39.62,-10.83).
city('Nanganga','tz','Mtwara',17468.0,39.15,-10.38).
city('Nangomba','tz','Mtwara',23028.0,38.5,-10.9).
city('Nanhyanga','tz','Mtwara',13519.0,39.55,-10.8).
city('Nanyamba','tz','Mtwara',19555.0,39.83,-10.68).
city('Newala','tz','Mtwara',38164.0,39.27,-10.94).
city('Tandahimba','tz','Mtwara',17041.0,39.63,-10.75).
city('Bukongo','tz','Mwanza',4051.0,32.93,-1.95).
city('Kasamwa','tz','Mwanza',27681.0,32.43,-2.85).
city('Katoro','tz','Mwanza',49691.0,31.9,-3.02).
city('Magu','tz','Mwanza',19082.0,33.35,-2.58).
city('Malya','tz','Mwanza',12627.0,33.52,-2.98).
city('Misasi','tz','Mwanza',14170.0,33.08,-3.0).
city('Missungwi','tz','Mwanza',35530.0,33.08,-2.85).
city('Muriti','tz','Mwanza',20254.0,32.92,-1.9).
city('Mwanza','tz','Mwanza',436811.0,32.89,-2.52).
city('Nakatunguru','tz','Mwanza',6064.0,33.07,-2.12).
city('Nansio','tz','Mwanza',6437.0,33.05,-2.1).
city('Ngudu','tz','Mwanza',22658.0,33.33,-2.97).
city('Nyanguge','tz','Mwanza',10746.0,33.2,-2.55).
city('Sengerama','tz','Mwanza',57040.0,32.64,-2.65).
city('Usagara','tz','Mwanza',15514.0,33.0,-2.68).
city('Bagamoyo','tz','Pwani',82578.0,38.89,-6.44).
city('Bungu','tz','Pwani',27873.0,39.05,-7.63).
city('Chalinze','tz','Pwani',34335.0,38.35,-6.6).
city('Dunda','tz','Pwani',14080.0,34.25,-8.12).
city('Ikwiriri','tz','Pwani',13071.0,39.02,-7.98).
city('Kibaha','tz','Pwani',23653.0,38.92,-6.77).
city('Kibiti','tz','Pwani',30165.0,38.95,-7.73).
city('Kilindoni','tz','Pwani',12409.0,39.65,-7.92).
city('Kisarawe','tz','Pwani',12507.0,39.07,-6.9).
city('Lugoba','tz','Pwani',16902.0,38.33,-6.45).
city('Magomeni','tz','Pwani',19086.0,39.25,-6.8).
city('Maneromango','tz','Pwani',9402.0,38.78,-7.2).
city('Mkamba','tz','Pwani',15333.0,37.7,-11.1).
city('Mkuranga','tz','Pwani',28037.0,39.2,-7.12).
city('Mlandizi','tz','Pwani',29394.0,38.73,-6.7).
city('Msanga','tz','Pwani',5527.0,36.05,-6.05).
city('Tumbi','tz','Pwani',32900.0,32.73,-5.07).
city('Utete','tz','Pwani',11889.0,38.78,-7.98).
city('Vikindu','tz','Pwani',23307.0,39.28,-6.98).
city('Chala','tz','Rukwa',22624.0,31.27,-7.58).
city('Ilembo','tz','Rukwa',2607.0,33.38,-9.25).
city('Inyonga','tz','Rukwa',11790.0,32.07,-6.72).
city('Karema','tz','Rukwa',12630.0,30.43,-6.82).
city('Katumba','tz','Rukwa',108558.0,33.62,-9.23).
city('Kirando','tz','Rukwa',33111.0,30.6,-7.42).
city('Laela','tz','Rukwa',19185.0,32.05,-8.57).
city('Matai','tz','Rukwa',24070.0,31.52,-8.3).
city('Mpanda','tz','Rukwa',73338.0,31.05,-6.36).
city('Namanyere','tz','Rukwa',28218.0,31.05,-7.52).
city('Sumbawanga','tz','Rukwa',89169.0,31.62,-7.96).
city('Usevya','tz','Rukwa',17742.0,31.23,-7.1).
city('Kigonsera','tz','Ruvuma',22155.0,35.05,-10.8).
city('Liuli','tz','Ruvuma',13119.0,34.63,-11.08).
city('Maguu','tz','Ruvuma',22296.0,34.85,-11.03).
city('Mahanje','tz','Ruvuma',15009.0,35.33,-9.93).
city('Maposeni','tz','Ruvuma',19472.0,35.4,-10.58).
city('Matiri','tz','Ruvuma',18830.0,34.9,-10.75).
city('Mbamba','tz','Ruvuma',8997.0,34.77,-11.28).
city('Mbinga','tz','Ruvuma',25192.0,35.02,-10.93).
city('Namtumbo','tz','Ruvuma',24189.0,36.03,-10.48).
city('Songea','tz','Ruvuma',126499.0,35.65,-10.68).
city('Tingi','tz','Ruvuma',16315.0,35.03,-11.3).
city('Tunduru','tz','Ruvuma',36796.0,37.37,-11.09).
city('Bariadi','tz','Shinyanga',33865.0,33.98,-2.8).
city('Bugarama','tz','Shinyanga',32494.0,30.53,-2.87).
city('Isaka','tz','Shinyanga',21094.0,32.93,-3.9).
city('Kahama','tz','Shinyanga',36016.0,32.58,-3.82).
city('Kisesa','tz','Shinyanga',29804.0,34.15,-3.08).
city('Kishapu','tz','Shinyanga',16371.0,33.87,-3.62).
city('Lalango','tz','Shinyanga',22551.0,33.95,-3.45).
city('Mal','tz','Shinyanga',16916.0,33.53,-3.13).
city('Masumbwe','tz','Shinyanga',34780.0,32.18,-3.63).
city('Maswa','tz','Shinyanga',22025.0,33.98,-2.68).
city('Mhango','tz','Shinyanga',21553.0,32.85,-3.28).
city('Mwadui','tz','Shinyanga',23298.0,33.6,-3.55).
city('Nyakabindi','tz','Shinyanga',18427.0,33.98,-2.63).
city('Nyalikungu','tz','Shinyanga',24648.0,33.78,-3.18).
city('Old Shinyanga','tz','Shinyanga',23746.0,33.4,-3.55).
city('Shinyanga','tz','Shinyanga',107365.0,33.42,-3.66).
city('Somanda','tz','Shinyanga',33932.0,33.95,-3.37).
city('Songwa','tz','Shinyanga',23618.0,33.52,-3.52).
city('Tinde','tz','Shinyanga',22082.0,33.2,-3.88).
city('Ushirombo','tz','Shinyanga',95052.0,31.96,-3.49).
city('Uyovu','tz','Shinyanga',60849.0,31.53,-3.28).
city('Iguguno','tz','Singida',22810.0,34.63,-4.57).
city('Ikungi','tz','Singida',19692.0,34.77,-5.13).
city('Ilongero','tz','Singida',17342.0,34.87,-4.67).
city('Itigi','tz','Singida',19711.0,34.48,-5.7).
city('Kilimatinde','tz','Singida',5975.0,34.95,-5.0).
city('Kintinku','tz','Singida',7906.0,35.23,-5.88).
city('Kiomboi','tz','Singida',23519.0,34.37,-4.27).
city('Manyoni','tz','Singida',25532.0,34.9,-5.78).
city('Mgandu','tz','Singida',23718.0,34.13,-5.95).
city('Mtinko','tz','Singida',26725.0,34.85,-4.55).
city('Mungaa','tz','Singida',16715.0,34.88,-4.97).
city('Ndago','tz','Singida',13012.0,34.35,-4.6).
city('Puma','tz','Singida',17092.0,34.73,-5.0).
city('Sepuka','tz','Singida',25657.0,34.53,-4.75).
city('Shelui','tz','Singida',24817.0,34.2,-4.37).
city('Singida','tz','Singida',62436.0,34.74,-4.82).
city('Bukene','tz','Tabora',7444.0,32.88,-4.24).
city('Igunga','tz','Tabora',35644.0,33.88,-4.28).
city('Igurubi','tz','Tabora',10083.0,33.7,-4.0).
city('Kaliua','tz','Tabora',12362.0,31.79,-5.06).
city('Mabama','tz','Tabora',15320.0,32.53,-5.13).
city('Nzega','tz','Tabora',26584.0,33.18,-4.21).
city('Sikonge','tz','Tabora',27113.0,32.77,-5.63).
city('Tabora','tz','Tabora',145291.0,32.82,-5.01).
city('Urambo','tz','Tabora',23723.0,32.05,-5.07).
city('Usoke','tz','Tabora',7295.0,32.35,-5.17).
city('Chanika','tz','Tanga',30905.0,38.02,-5.42).
city('Korogwe','tz','Tanga',33919.0,38.54,-5.09).
city('Lusanga','tz','Tanga',9612.0,32.4,-4.27).
city('Lushoto','tz','Tanga',24197.0,38.28,-4.78).
city('Majengo','tz','Tanga',9874.0,38.98,-5.15).
city('Maramba','tz','Tanga',26531.0,38.62,-5.05).
city('Masuguru','tz','Tanga',7946.0,38.42,-11.36).
city('Mazinde','tz','Tanga',20534.0,38.22,-4.8).
city('Mlalo','tz','Tanga',15576.0,38.93,-4.93).
city('Mnyuzi','tz','Tanga',18177.0,38.58,-5.22).
city('Muheza','tz','Tanga',17000.0,38.78,-5.17).
city('Pangani','tz','Tanga',8343.0,38.98,-5.41).
city('Soni','tz','Tanga',12402.0,38.37,-4.85).
city('Tanga','tz','Tanga',224891.0,39.09,-5.07).
city('Chake Chake','tz','Zanzibar and Pemba',21687.0,39.77,-5.24).
city('Dunga Bweni','tz','Zanzibar and Pemba',2753.0,39.33,-6.13).
city('Gamba','tz','Zanzibar and Pemba',3644.0,39.3,-5.9).
city('Kijini','tz','Zanzibar and Pemba',3720.0,39.32,-5.85).
city('Koani','tz','Zanzibar and Pemba',2311.0,39.28,-6.13).
city('Konde','tz','Zanzibar and Pemba',9530.0,39.75,-4.95).
city('Mahonda','tz','Zanzibar and Pemba',5569.0,39.47,-6.45).
city('Micheweni','tz','Zanzibar and Pemba',9838.0,39.83,-4.97).
city('Mkokotoni','tz','Zanzibar and Pemba',2572.0,39.25,-5.87).
city('Mtambile','tz','Zanzibar and Pemba',6797.0,39.7,-5.38).
city('Nganani','tz','Zanzibar and Pemba',1929.0,39.55,-6.4).
city('Uweleni','tz','Zanzibar and Pemba',2472.0,39.68,-5.4).
city('Wete','tz','Zanzibar and Pemba',26452.0,39.71,-5.06).
city('Zanzibar','tz','Zanzibar and Pemba',403670.0,39.2,-6.16).
city('Amnat Charoen','th','Amnat Charoen',34769.0,104.63,15.86).
city('Ang Thong','th','Ang Thong',14430.0,100.48,14.59).
city('Chaiyo','th','Ang Thong',13255.0,100.47,14.66).
city('Pho Thong','th','Ang Thong',12200.0,100.42,14.67).
city('Wiset Chai Chan','th','Ang Thong',19129.0,100.35,14.58).
city('Bangkok','th','Bangkok Metropolitan Area',5104475.0,100.5,13.73).
city('Buri Ram','th','Buri Ram',31563.0,103.11,15.0).
city('Lamplai Mat','th','Buri Ram',21843.0,102.83,15.02).
city('Nang Rong','th','Buri Ram',21961.0,102.8,14.63).
city('Nong Ki','th','Buri Ram',13592.0,102.53,14.67).
city('Pra Khon Chai','th','Buri Ram',15564.0,103.08,14.62).
city('Satuk','th','Buri Ram',11680.0,103.3,15.3).
city('Bang Khla','th','Chachoengsao',13528.0,101.22,13.72).
city('Bang Pakong','th','Chachoengsao',25620.0,101.0,13.55).
city('Chachoengsao','th','Chachoengsao',49741.0,101.07,13.69).
city('Phanom Sarakham','th','Chachoengsao',16057.0,101.35,13.75).
city('Plaeng Yao','th','Chachoe',13139.0,101.17,13.35).
city('Chai Nat','th','Chai Nat',15469.0,100.13,15.18).
city('Bamnet Narong','th','Chaiyaphum',14890.0,101.7,15.5).
city('Chaiyaphum','th','Chaiyaphum',58350.0,102.04,15.8).
city('Kaeng Khlo','th','Chaiyaphum',29056.0,102.27,16.1).
city('Kaset Sombun','th','Chaiyaphum',16996.0,101.95,16.28).
city('Phu Khieo','th','Chaiyaphum',17122.0,102.13,16.37).
city('Chanthaburi','th','Chanthaburi',99819.0,102.11,12.61).
city('Khlung','th','Chanthaburi',13286.0,102.23,12.45).
city('Laem Sing','th','Chanthaburi',16066.0,102.07,12.48).
city('Tha Mai','th','Chanthaburi',22445.0,102.02,12.62).
city('Chiang Mai','th','Chiang Mai',200952.0,98.98,18.8).
city('Chomthong','th','Chiang Mai',12488.0,98.68,18.43).
city('Hangdong','th','Chiang Mai',17931.0,98.92,18.69).
city('Maeai','th','Chiang Mai',15681.0,99.32,20.03).
city('Maerim','th','Chiang Mai',12912.0,98.94,18.91).
city('Maetaeng','th','Chiang Mai',26494.0,98.95,19.12).
city('Sankamphaeng','th','Chiang Mai',32950.0,99.12,18.74).
city('Sanpatong','th','Chiang Mai',17773.0,98.89,18.62).
city('Sansai','th','Chiang Mai',37491.0,99.05,18.85).
city('Chiang Khong','th','Chiang Rai',14505.0,100.4,20.28).
city('Chiang Rai','th','Chiang Rai',78756.0,99.83,19.91).
city('Mae Chan','th','Chiang Rai',37672.0,99.87,20.15).
city('Mae Sai','th','Chiang Rai',27520.0,99.88,20.43).
city('Pa Daet','th','Chiang Rai',13624.0,100.0,19.5).
city('Ban Bung','th','Chon Buri',26113.0,101.0,13.04).
city('Bang Lamung','th','Chon Buri',39620.0,100.9,12.97).
city('Chon Buri','th','Chon Buri',219190.0,101.0,13.4).
city('Pattaya','th','Chon Buri',97296.0,100.9,12.92).
city('Phan Thong','th','Chon Buri',18708.0,101.1,13.47).
city('Phanat Nikhom','th','Chon Buri',21924.0,101.18,13.45).
city('Sattahip','th','Chon Buri',65444.0,100.9,12.67).
city('Si Racha','th','Chon Buri',178916.0,100.93,13.16).
city('Chumphon','th','Chumphon',55835.0,99.19,10.51).
city('Lang Suan','th','Chumphon',16142.0,99.07,9.95).
city('Huai Mek','th','Kalasin',12352.0,103.22,16.6).
city('Kalasin','th','Kalasin',55102.0,103.5,16.43).
city('Kamalasai','th','Kalasin',23393.0,103.58,16.33).
city('Khao Wong','th','Kalasin',15184.0,104.1,16.7).
city('Kuchinarai','th','Kalasin',20532.0,104.07,16.53).
city('Nong Kung Si','th','Kalasin',17001.0,103.3,16.65).
city('Yang Talat','th','Kalasin',13360.0,103.38,16.4).
city('Kamphaeng Phet','th','Kamphaeng Phet',58787.0,99.52,16.47).
city('Khanu Woralaksaburi','th','Kamphaeng Phet',21889.0,99.87,16.07).
city('Bo Phloi','th','Kanchanaburi',16786.0,99.52,14.32).
city('Kanchanaburi','th','Kanchanaburi',63699.0,99.53,14.02).
city('Phanom Thuan','th','Kanchanaburi',12469.0,99.7,14.12).
city('Tha Maka','th','Kanchanaburi',52907.0,99.77,13.9).
city('Tha Muang','th','Kanchanaburi',26746.0,99.63,13.97).
city('Ban Phai','th','Khon Kaen',35583.0,102.73,16.06).
city('Chum Phae','th','Khon Kaen',46335.0,102.11,16.54).
city('Khon Kaen','th','Khon Kaen',147579.0,102.83,16.42).
city('Kranuan','th','Khon Kaen',13475.0,103.05,16.7).
city('Nam Phong','th','Khon Kaen',15759.0,102.83,16.62).
city('Phon','th','Khon Kaen',14596.0,102.6,15.82).
city('Ao Luk','th','Krabi',13263.0,98.72,8.38).
city('Krabi','th','Krabi',31219.0,98.91,8.05).
city('Lampang','th','Lampang',156139.0,99.48,18.29).
city('Thoen','th','Lampang',18459.0,99.21,17.6).
city('Lamphun','th','Lamphun',41791.0,99.08,18.5).
city('Mae Tha','th','Lamphun',10048.0,99.14,18.46).
city('Pa Sang','th','Lamphun',15607.0,98.94,18.52).
city('Loei','th','Loei',35273.0,101.73,17.49).
city('Phu Kra Dung','th','Loei',16079.0,101.88,16.88).
city('Wang Saphung','th','Loei',15747.0,101.77,17.3).
city('Chai Badan','th','Lop Buri',25196.0,101.13,15.2).
city('Lop Buri','th','Lop Buri',57761.0,100.62,14.8).
city('Mae Hong Son','th','Mae Hong Son',9109.0,97.93,19.27).
city('Kosum Phisai','th','Maha Sarakham',10672.0,103.02,16.22).
city('Maha Sarakham','th','Maha Sarakham',51584.0,103.29,16.18).
city('Phayakkhaphum Phisai','th','Maha Sarakham',10212.0,103.2,15.52).
city('Wapi Pathum','th','Maha Sarakham',10198.0,103.38,15.85).
city('Mukdahan','th','Mukdahan',40480.0,104.72,16.54).
city('Nakhon Nayok','th','Nakhon Nayok',21309.0,101.22,14.2).
city('Bang Len','th','Nakhon Pathom',179.0,100.17,14.02).
city('Nakhon Chaisi','th','Nakhon Pathom',11075.0,100.03,13.82).
city('Nakhon Pathom','th','Nakhon Pathom',117927.0,100.06,13.82).
city('Sam Phran','th','Nakhon Pathom',37115.0,100.22,13.72).
city('Na Wa','th','Nakhon Phanom',12989.0,104.1,17.48).
city('Nakhon Phanom','th','Nakhon Phanom',34595.0,104.78,17.4).
city('That Phanom','th','Nakhon Phanom',14424.0,104.73,16.95).
city('Bua Yai','th','Nakhon Ratchasima',16832.0,102.42,15.58).
city('Chok Chai','th','Nakhon Ratchasima',23337.0,102.17,14.73).
city('Dan Khun Thot','th','Nakhon Ratchasima',155.0,101.81,15.21).
city('Huai Thalaeng','th','Nakhon Ratchasima',15352.0,102.66,15.0).
city('Kham Sakae Sarng','th','Nakhon Ratchasima',11018.0,102.18,15.33).
city('Khon Buri','th','Nakhon Ratchasima',18596.0,102.25,14.52).
city('Nakhon Ratchasima','th','Nakhon Ratchasima',208781.0,102.1,15.0).
city('Non Sung','th','Nakhon Ratchasima',18399.0,102.27,15.18).
city('Non Thai','th','Nakhon Ratchasima',11959.0,102.07,15.2).
city('Pak Chong','th','Nakhon Ratchasima',48999.0,101.41,14.7).
city('Pak Thong Chai','th','Nakhon Ratchasima',23412.0,102.01,14.44).
city('Phimai','th','Nakhon Ratchasima',13084.0,102.5,15.22).
city('Sikhiu','th','Nakhon Ratchasima',28681.0,101.73,14.88).
city('Soeng Sang','th','Nakhon Ratchasima',14138.0,102.48,14.42).
city('Sung Noen','th','Nakhon Ratchasima',14365.0,101.81,14.9).
city('Chumsaeng','th','Nakhon Sawan',15346.0,103.35,15.13).
city('Lat Yao','th','Nakhon Sawan',17506.0,99.8,15.75).
city('Nakhon Sawan','th','Nakhon Sawan',99176.0,100.07,15.7).
city('Nong Bua','th','Nakhon Sawan',14160.0,100.58,15.87).
city('Phaisali','th','Nakhon Sawan',13088.0,100.65,15.6).
city('Phayuha Khiri','th','Nakhon Sawan',12271.0,100.13,15.45).
city('Takhli','th','Nakhon Sawan',41745.0,100.35,15.26).
city('Chawang','th','Nakhon Si Thammarat',10923.0,102.05,62.67).
city('Nakhon Si Thammarat','th','Nakhon Si Thammarat',120836.0,99.97,8.4).
city('Pak Phanang','th','Nakhon Si Thammarat',25014.0,100.21,8.35).
city('Ron Phibun','th','Nakhon Si Thammarat',26621.0,99.85,8.15).
city('Thung Song','th','Nakhon Si Thammarat',28223.0,99.73,8.15).
city('Chiang Klang','th','Nan',13244.0,100.87,19.3).
city('Nan','th','Nan',24670.0,100.77,18.78).
city('Bacho','th','Narathiwat',12038.0,101.65,66.17).
city('Narathiwat','th','Narathiwat',47771.0,101.82,6.43).
city('Rangae','th','Narathiwat',16862.0,101.73,6.28).
city('Sungai Kolok','th','Narathiwat',42776.0,101.96,6.02).
city('Sungai Padi','th','Narathiwat',14274.0,101.9,6.15).
city('Tak Bai','th','Narathiwat',17241.0,102.05,6.27).
city('Na Klang','th','Nong Bua Lam Phu',31024.0,102.18,17.31).
city('Non Sang','th','Nong Bua Lam Phu',11819.0,102.57,16.87).
city('Nong Bua Lam Phu','th','Nong Bua Lam Phu',36966.0,102.57,17.17).
city('Si Bun Ruang','th','Nong Bua Lam Phu',12842.0,102.28,16.97).
city('Suwan Khuha','th','Nong Bua Lam Phu',18110.0,102.27,17.58).
city('Nong Khai','th','Nong Khai',63609.0,102.74,17.88).
city('Phon Charoen','th','Nong Khai',15208.0,103.17,18.03).
city('Seka','th','Nong Khai',16493.0,103.95,17.93).
city('Si Chiang Mai','th','Nong Khai',14068.0,102.59,17.96).
city('Tha Bo','th','Nong Khai',35292.0,102.58,17.85).
city('Bang Bo Thong','th','Nonthaburi',41567.0,100.43,13.92).
city('Bang Kruai','th','Nonthaburi',78305.0,100.45,13.81).
city('Bang Yai','th','Nonthaburi',14012.0,100.43,13.85).
city('Nonthaburi','th','Nonthaburi',375826.0,100.18,13.8).
city('Pak Kret','th','Nonthaburi',182926.0,100.51,13.9).
city('Khlong Luang','th','Pathum Thani',118551.0,100.65,14.07).
city('Lam Luk Ka','th','Pathum Thani',60700.0,100.75,13.93).
city('Pathum Thani','th','Pathum Thani',27911.0,100.52,14.02).
city('Thanyaburi','th','Pathum Thani',123382.0,100.71,14.02).
city('Nong Chik','th','Pattani',11385.0,101.18,6.85).
city('Pattani','th','Pattani',49084.0,101.24,6.87).
city('Sai Buri','th','Pattani',14356.0,101.62,6.7).
city('Yaring','th','Pattani',31111.0,101.37,6.87).
city('Phangnga','th','Phangnga',9676.0,98.53,8.45).
city('Phatthalung','th','Phatthalung',43522.0,100.07,7.63).
city('Chiang Kham','th','Phayao',14092.0,100.3,19.53).
city('Dok Kham Tai','th','Phayao',23824.0,99.98,19.17).
city('Phayao','th','Phayao',21058.0,99.91,19.17).
city('Pong','th','Phayao',14392.0,100.28,19.17).
city('Chon Daen','th','Phetchabun',17567.0,100.85,16.18).
city('Lom Sak','th','Phetchabun',17309.0,101.25,16.78).
city('Nong Phai','th','Phetchabun',27756.0,101.07,15.98).
city('Phetchabun','th','Phetchabun',50656.0,101.16,16.42).
city('Wichian Buri','th','Phetchabun',39272.0,101.12,15.65).
city('Ban Laem','th','Phetchaburi',20304.0,99.59,13.13).
city('Chaam','th','Phetchaburi',49375.0,99.97,12.8).
city('Khao Yoi','th','Phetchaburi',18506.0,99.83,13.23).
city('Phetchaburi','th','Phetchaburi',46601.0,99.95,13.11).
city('Tha Yang','th','Phetchaburi',42602.0,100.89,12.97).
city('Bang Mun Nak','th','Phichit',15616.0,100.38,16.03).
city('Phichit','th','Phichit',35760.0,100.35,16.44).
city('Taphan Hin','th','Phichit',21895.0,100.42,16.2).
city('Thap Khlo','th','Phichit',15528.0,100.57,16.17).
city('Bang Krathum','th','Phitsanulok',18874.0,100.3,16.57).
city('Bang Rakam','th','Phitsanulok',16841.0,100.12,16.75).
city('Nakhon Thai','th','Phitsanulok',12345.0,100.83,17.12).
city('Phitsanulok','th','Phitsanulok',103427.0,100.27,16.82).
city('Ayutthaya','th','Phra Nakhon Si Ayutthaya',81962.0,100.57,14.36).
city('Bang Ban','th','Phra Nakhon Si Ayutthaya',16588.0,100.47,14.42).
city('Bang Pa In','th','Phra Nakhon Si Ayutthaya',20484.0,100.58,14.23).
city('Bang Sai','th','Phra Nakhon Si Ayutthaya',13611.0,100.5,14.21).
city('Nakhon Luang','th','Phra Nakhon Si Ayutthaya',15008.0,100.62,14.45).
city('Phak Hai','th','Phra Nakhon Si Ayutthaya',19386.0,100.37,14.45).
city('Se Na','th','Phra Nakhon Si Ayutthaya',22081.0,100.4,14.32).
city('Tha Rua','th','Phra Nakhon Si Ayutthaya',19116.0,100.73,14.57).
city('Wang Noi','th','Phra Nakhon Si Ayutthaya',15865.0,100.73,14.22).
city('Den Chai','th','Phrae',17019.0,100.05,17.98).
city('Long','th','Phrae',11802.0,99.83,18.07).
city('Phrae','th','Phrae',38538.0,100.16,18.15).
city('Rong Kwang','th','Phrae',12087.0,100.32,18.35).
city('Kathu','th','Phuket',34835.0,98.35,7.92).
city('Phuket','th','Phuket',89072.0,98.38,7.88).
city('Kabin Buri','th','Prachin Buri',20212.0,101.72,13.98).
city('Prachin Buri','th','Prachin Buri',32600.0,101.38,14.05).
city('Bang Saphan','th','Prachuap Khiri Khan',15134.0,99.52,11.2).
city('Hua Hin','th','Prachuap Khiri Khan',50456.0,99.95,12.57).
city('Kui Buri','th','Prachuap Khiri Khan',19046.0,99.87,12.05).
city('Prachuap Khiri Khan','th','Prachuap Khiri Khan',33520.0,99.8,11.82).
city('Pran Buri','th','Prachuap Khiri Khan',47293.0,99.92,12.38).
city('Sam Roi Yot','th','Prachuap Khiri Khan',19709.0,99.88,12.2).
city('Ranong','th','Ranong',24560.0,98.63,9.97).
city('Ban Pong','th','Ratchaburi',57559.0,99.87,13.81).
city('Bang Phae','th','Ratchaburi',29548.0,99.93,13.7).
city('Chom Bung','th','Ratchaburi',15143.0,99.6,13.62).
city('Damnoen Saduak','th','Ratchaburi',23296.0,99.93,13.52).
city('Photharam','th','Ratchaburi',36248.0,99.85,13.68).
city('Ratchaburi','th','Ratchaburi',92448.0,99.82,13.54).
city('Ban Chang','th','Rayong',28204.0,101.07,12.72).
city('Klaeng','th','Rayong',55619.0,101.65,12.78).
city('Rayong','th','Rayong',119080.0,101.28,12.68).
city('Kaset','th','Roi Et',18569.0,103.58,15.65).
city('Pho Chai','th','Roi Et',13671.0,103.78,16.32).
city('Phon Thong','th','Roi Et',13317.0,103.98,16.3).
city('Roi Et','th','Roi Et',39328.0,103.65,16.05).
city('Selaphum','th','Roi Et',17412.0,103.95,16.03).
city('Suwannaphum','th','Roi Et',12221.0,103.81,15.6).
city('Aranya Prathet','th','Sa Kaeo',20236.0,102.5,13.68).
city('Sa Kaeo','th','Sa Kaeo',28497.0,102.07,13.82).
city('Wang Nam Yan','th','Sa Kaeo',16299.0,102.17,13.5).
city('Sakhon Nakhon','th','Sakon Nakhon',76237.0,104.15,17.17).
city('Sawang Daen Din','th','Sakon Nakhon',16825.0,103.46,17.47).
city('Bang Bo','th','Samut Prakan',28376.0,100.83,13.57).
city('Bang Sao Thong','th','Samut Prakan',31153.0,100.82,13.67).
city('Phra Pradaeng','th','Samut Prakan',171333.0,100.53,13.67).
city('Samut Prakan','th','Samut Prakan',388921.0,100.61,13.61).
city('Ban Phaeo','th','Samut Sakhon',41904.0,100.12,13.58).
city('Krathum Baen','th','Samut Sakhon',72819.0,100.27,13.65).
city('Samut Sakhon','th','Samut Sakhon',63498.0,100.28,13.54).
city('Samut Songkhram','th','Samut Songkhran',35065.0,100.0,13.42).
city('Ban Mo','th','Saraburi',15959.0,100.75,14.62).
city('Kaeng Khoi','th','Saraburi',30332.0,101.0,14.59).
city('Nong Khae','th','Saraburi',41067.0,100.87,14.33).
city('Phra Phutthabat','th','Saraburi',57008.0,100.79,14.72).
city('Saraburi','th','Saraburi',83015.0,100.88,14.53).
city('Satun','th','Satun',34544.0,100.07,6.62).
city('Katharalak','th','Si Sa Ket',36621.0,104.65,14.65).
city('Khun Han','th','Si Sa Ket',12031.0,104.24,14.38).
city('Phrai Bung','th','Si Sa Ket',11494.0,104.35,14.75).
city('Si Sa Ket','th','Si Sa Ket',44751.0,104.33,15.11).
city('Bang Racham','th','Sing Buri',15313.0,100.32,14.88).
city('Sing Buri','th','Sing Buri',20046.0,100.4,14.89).
city('Tha Chang','th','Sing Buri',9547.0,99.2,9.27).
city('Hat Yai','th','Songkhla',191696.0,100.47,7.0).
city('Ranot','th','Songkhla',19780.0,100.32,7.77).
city('Sadao','th','Songkhla',46236.0,100.43,6.63).
city('Songkhla','th','Songkhla',86899.0,100.56,7.21).
city('Khiri Mat','th','Sukhothai',11272.0,99.8,16.83).
city('Sawankhalok','th','Sukhothai',19805.0,99.83,17.31).
city('Si Satchanalai','th','Sukhothai',25942.0,99.77,17.52).
city('Sukhothai','th','Sukhothai',40174.0,99.75,17.01).
city('Doembang Nangbuat','th','Suphan Buri',14671.0,100.1,14.83).
city('Sam Chuk','th','Suphan Buri',13438.0,100.1,14.75).
city('Song Phi Nong','th','Suphan Buri',19839.0,100.04,14.12).
city('Suphan Buri','th','Suphan Buri',53399.0,100.13,14.47).
city('U Thong','th','Suphan Buri',13753.0,99.53,14.21).
city('Ban Na San','th','Surat Thani',21900.0,9.37,8.8).
city('Chaiya','th','Surat Thani',12223.0,99.23,9.38).
city('Don Sak','th','Surat Thani',12422.0,99.68,9.3).
city('Ko Samui','th','Surat Thani',39681.0,99.93,9.53).
city('Phun Phin','th','Surat Thani',25810.0,99.23,9.1).
city('Surat Thani','th','Surat Thani',127201.0,99.33,9.14).
city('Wiang Sa','th','Surat Thani',11933.0,99.37,8.63).
city('Surin','th','Surin',46673.0,103.49,14.89).
city('Ban Tak','th','Tak',18384.0,99.06,17.04).
city('Mae Ramat','th','Tak',17316.0,98.52,16.97).
city('Mae Sot','th','Tak',44563.0,98.57,16.71).
city('Tak','th','Tak',24149.0,99.13,16.88).
city('Huai Yot','th','Trang',16586.0,99.62,7.75).
city('Kantang','th','Trang',14156.0,99.52,7.42).
city('Trang','th','Trang',66713.0,99.61,7.56).
city('Bo Rai','th','Trat',13620.0,102.53,12.57).
city('Trat','th','Trat',21590.0,102.5,12.23).
city('Det Udom','th','Ubon Ratchathani',35669.0,105.08,14.91).
city('Nam Yun','th','Ubon Ratchathani',12335.0,104.93,14.5).
city('Phibun Mangsahan','th','Ubon Ratchathani',19883.0,105.23,15.23).
city('Ubon Ratchathani','th','Ubon Ratchathani',122533.0,104.83,15.25).
city('Warin Chamrap','th','Ubon Ratchathani',43102.0,104.87,15.2).
city('Ban Dung','th','Udon Thani',19479.0,103.25,17.7).
city('Kumphawapi','th','Udon Thani',29211.0,102.97,17.13).
city('Kut Chap','th','Udon Thani',24696.0,102.57,17.42).
city('Nam Som','th','Udon Thani',19324.0,102.19,17.77).
city('Nong Han','th','Udon Thani',26120.0,103.06,17.36).
city('Nong Wua So','th','Udon Thani',21722.0,103.22,17.27).
city('Udon Thani','th','Udon Thani',247232.0,102.79,17.41).
city('Thap Than','th','Uthai Thani',16615.0,99.9,15.45).
city('Uthai Thani','th','Uthai Thani',22219.0,100.03,15.38).
city('Laplae','th','Uttaradit',21656.0,100.03,17.65).
city('Uttaradit','th','Uttaradit',58313.0,100.1,17.63).
city('Betong','th','Yala',29604.0,101.07,5.78).
city('Yala','th','Yala',93558.0,101.29,6.55).
city('Yasothon','th','Yasothon',21643.0,104.15,15.79).
city('Sokode','tg','Centre',108373.0,1.15,8.99).
city('Sotouboua','tg','Centre',19742.0,0.98,8.56).
city('Tchamba','tg','Centre',24069.0,1.41,9.02).
city('Bafilo','tg','Kara',20870.0,1.24,9.34).
city('Bassar','tg','Kara',55901.0,0.79,9.26).
city('Kande','tg','Kara',10615.0,1.05,9.95).
city('Kara','tg','Kara',94044.0,1.19,9.55).
city('Kpagouda','tg','Kara',7116.0,1.32,9.75).
city('Niamtougou','tg','Kara',21534.0,1.11,9.77).
city('Aneho','tg','Maritime',47174.0,1.58,6.22).
city('Lome','tg','Maritime',726690.0,1.35,6.17).
city('Tabligbo','tg','Maritime',13625.0,1.5,6.58).
city('Tsevie','tg','Maritime',55302.0,1.21,6.42).
city('Vogan','tg','Maritime',20386.0,1.52,6.33).
city('Amlame','tg','Plateaux',10931.0,0.9,7.46).
city('Atakpame','tg','Plateaux',92976.0,1.12,7.53).
city('Badou','tg','Plateaux',22182.0,0.6,7.59).
city('Kpalime','tg','Plateaux',110541.0,0.63,6.9).
city('Notse','tg','Plateaux',24383.0,1.17,6.95).
city('Dapaong','tg','Savanes',31315.0,0.21,10.85).
city('Mango','tg','Savanes',34791.0,0.45,10.35).
city('Atafu','tk','Atafu',134.0,-172.5,-8.57).
city('Fakaofo','tk','Fakaofo',269.0,-171.19,-9.39).
city('Nukunonu','tk','Nukunonu',90.0,-171.87,-9.16).
city('Ohonua','to','Eua',1241.0,-174.95,-21.34).
city('Pangai','to','Haapai',1737.0,-174.36,-19.81).
city('Hihifo','to','Niuas',815.0,-173.76,-15.97).
city('Haveloloto','to','Tongatapu',3417.0,-175.22,-21.15).
city('Mua','to','Tongatapu',4881.0,-175.11,-21.2).
city('Nukualofa','to','Tongatapu',23612.0,-175.22,-21.14).
city('Tofoa-Koloua','to','Tongatapu',2535.0,-175.23,-21.17).
city('Vaini','to','Tongatapu',2976.0,-175.2,-21.2).
city('Neiafu','to','Vavau',4320.0,-173.99,-18.64).
city('Arima','tt','Arima',34996.0,-61.28,10.64).
city('Chaguanas','tt','Chaguanas',72158.0,-61.43,10.52).
city('Couva','tt','Couva-Tabaquite-Talparo',5178.0,-61.44,10.42).
city('Tabaquite','tt','Couva-Tabaquite-Talparo',3314.0,-61.3,10.38).
city('Mucurapo','tt','Diego Martin',4342.0,-61.54,10.67).
city('Rio Claro','tt','Mayaro-Rio Claro',2808.0,-61.15,10.26).
city('Debe','tt','Penal Debe',3127.0,-61.45,10.2).
city('Penal','tt','Penal Debe',4899.0,-61.46,10.17).
city('Point Fortin','tt','Point Fortin',18918.0,-61.68,10.16).
city('Port of Spain','tt','Port of Spain',49658.0,-61.51,10.66).
city('Marabella','tt','Princes Town',26700.0,-61.45,10.29).
city('Princes Town','tt','Princes Town',11000.0,-61.39,10.24).
city('San Fernando','tt','San Fernando',56379.0,-61.46,10.25).
city('Saint Joseph','tt','San Juan-Laventville',4904.0,-61.4,10.46).
city('San Juan','tt','San Juan-Laventville',56590.0,-61.44,10.46).
city('Biche','tt','Sangre Grande',2844.0,-61.13,10.23).
city('Sangre Grande','tt','Sangre Grande',15968.0,-61.12,10.61).
city('Siparia','tt','Siparia',8568.0,-61.5,10.1).
city('Scarborough','tt','Tobago',4595.0,-60.74,11.18).
city('Arouca','tt','Tunapuna-Piarco',12054.0,-61.33,10.65).
city('Tacarigua','tt','Tunapuna-Piarco',15067.0,-61.35,10.65).
city('Tunapuna','tt','Tunapuna-Piarco',17758.0,-61.39,10.65).
city('Aryanah','tn','Aryanah',237401.0,10.18,36.88).
city('Qalat-al-Andalus','tn','Aryanah',17062.0,10.12,37.07).
city('Sidi Tzabit','tn','Aryanah',9212.0,10.05,36.92).
city('Taburbah','tn','Aryanah',26012.0,9.8,36.89).
city('Wadi al-Layl','tn','Aryanah',47102.0,10.05,36.83).
city('al-Battan','tn','Aryanah',6047.0,9.84,36.81).
city('al-Murnaqiyah','tn','Aryanah',13659.0,10.02,36.75).
city('Bajah','tn','Bajah',57211.0,9.19,36.73).
city('Majaz-al-Bab','tn','Bajah',20117.0,9.61,36.65).
city('Quballat','tn','Bajah',3353.0,9.67,36.53).
city('Tabursuq','tn','Bajah',12727.0,9.25,36.47).
city('Tastur','tn','Bajah',13708.0,9.45,36.55).
city('Bin Arus','tn','Bin Arus',78253.0,10.32,36.75).
city('Hammam-al-Anif','tn','Bin Arus',47841.0,10.35,36.73).
city('Maqrin','tn','Bin Arus',31290.0,10.23,36.77).
city('Muhammadiyat Fusanah','tn','Bin Arus',66593.0,10.17,36.68).
city('Murnaq','tn','Bin Arus',33421.0,10.3,36.68).
city('Radis','tn','Bin Arus',44298.0,10.28,36.77).
city('Awsajah','tn','Binzart',3775.0,10.1,37.13).
city('Binzart','tn','Binzart',1152.0,9.87,37.29).
city('Gar-al-Milh','tn','Binzart',5260.0,10.18,37.18).
city('Manzil Abd-ar-Rahman','tn','Binzart',15769.0,9.87,37.24).
city('Manzil Bu Ruqaybah','tn','Binzart',46257.0,9.79,37.16).
city('Manzil Jamil','tn','Binzart',21542.0,9.91,37.24).
city('Matir','tn','Binzart',31005.0,9.66,37.05).
city('Rafraf','tn','Binzart',9255.0,10.18,37.2).
city('Ras-al-Jabal','tn','Binzart',24511.0,10.13,37.22).
city('Sajanan','tn','Binzart',5009.0,9.23,37.05).
city('Tinjah','tn','Binzart',18551.0,9.77,37.17).
city('al-Aliyah','tn','Binzart',16083.0,10.03,37.17).
city('al-Matlin','tn','Binzart',7602.0,10.05,37.25).
city('Ayn Darahim','tn','Jundubah',7094.0,8.69,36.78).
city('Bani Matir','tn','Jundubah',898.0,8.75,36.75).
city('Bu Salim','tn','Jundubah',20310.0,8.97,36.61).
city('Firnanah','tn','Jundubah',1962.0,8.7,36.65).
city('Gar-ad-Dima','tn','Jundubah',19577.0,8.43,36.46).
city('Jundubah','tn','Jundubah',51419.0,8.77,36.5).
city('Tabarqah','tn','Jundubah',13712.0,8.74,36.96).
city('Wadi Maliz','tn','Jundubah',2148.0,8.55,36.47).
city('Bani Hzaddas','tn','Madaniyin',3588.0,10.2,33.25).
city('Bin Qirdan','tn','Madaniyin',13364.0,11.22,33.14).
city('Jarbah Ajim','tn','Madaniyin',25231.0,10.75,33.73).
city('Jarbah Hawmat-as-Suq','tn','Madaniyin',62584.0,10.85,33.88).
city('Jarbah Midun','tn','Madaniyin',48604.0,11.0,33.82).
city('Jarjis','tn','Madaniyin',79334.0,11.11,33.51).
city('Madaniyin','tn','Madaniyin',64281.0,10.49,33.35).
city('Manubah','tn','Manubah',24948.0,10.1,36.8).
city('Bani Hiyar','tn','Nabul',18011.0,10.78,36.47).
city('Bani Hzallad','tn','Nabul',11300.0,10.6,36.65).
city('Bu Urqub','tn','Nabul',10024.0,10.55,36.54).
city('Dar Saban','tn','Nabul',33953.0,10.75,36.47).
city('Hammam-al-Agzaz','tn','Nabul',8159.0,11.12,36.89).
city('Manzil Bu Zalafah','tn','Nabul',16232.0,10.59,36.69).
city('Manzil Hurr','tn','Nabul',4717.0,10.95,36.73).
city('Manzil Tamim','tn','Nabul',34768.0,10.98,36.79).
city('Nabul','tn','Nabul',60207.0,10.73,36.46).
city('Qalibiyah','tn','Nabul',37223.0,11.09,36.86).
city('Qurbah','tn','Nabul',33589.0,10.87,36.58).
city('Qurbus','tn','Nabul',3581.0,10.57,36.82).
city('Qurunbaliyah','tn','Nabul',18965.0,10.5,36.61).
city('Sulayman','tn','Nabul',25634.0,10.48,36.7).
city('Taklisah','tn','Nabul',20659.0,10.63,36.79).
city('Tazirkah','tn','Nabul',7280.0,10.83,36.55).
city('Zawiyat-al-Jadidi','tn','Nabul',6583.0,10.58,36.65).
city('al-Hammamat','tn','Nabul',53733.0,10.62,36.4).
city('al-Huwariyah','tn','Nabul',10678.0,11.01,37.06).
city('al-Mamurah','tn','Nabul',6969.0,10.8,36.47).
city('al-Middah','tn','Nabul',3602.0,10.85,36.73).
city('as-Samaah','tn','Nabul',6529.0,10.78,36.55).
city('Gannus','tn','Qabis',21260.0,10.07,33.93).
city('Maratz','tn','Qabis',10885.0,10.3,33.64).
city('Matmatat-al-Qadimah','tn','Qabis',2406.0,9.96,33.55).
city('Qabis','tn','Qabis',111070.0,10.1,33.9).
city('Sanini an-Nahal','tn','Qabis',13417.0,10.08,33.9).
city('Wadraf','tn','Qabis',9333.0,9.97,33.99).
city('al-Hammah','tn','Qabis',36458.0,9.79,33.89).
city('al-Matwiyah','tn','Qabis',10250.0,10.0,33.97).
city('az-Zarxat','tn','Qabis',5208.0,10.35,33.67).
city('Qafsah','tn','Qafsah',81236.0,8.78,34.42).
city('Umm-al-Arais','tn','Qafsah',27109.0,8.27,34.5).
city('al-Mitlawi','tn','Qafsah',41899.0,8.41,34.33).
city('ar-Rudayyif','tn','Qafsah',30048.0,8.15,34.38).
city('as-Sanad','tn','Qafsah',7859.0,9.27,34.47).
city('Duz','tn','Qibili',28127.0,9.01,33.47).
city('Jamnah','tn','Qibili',6254.0,9.03,33.57).
city('Qibili','tn','Qibili',19880.0,8.97,33.7).
city('al-Qalah','tn','Qibili',7189.0,9.0,33.49).
city('Bir Ali Bin Hzalifah','tn','Safaqis',4864.0,10.1,34.73).
city('Jabinyanah','tn','Safaqis',7349.0,10.91,35.04).
city('Manzil Sakir','tn','Safaqis',2851.0,10.37,34.98).
city('Qarmadah','tn','Safaqis',33744.0,10.78,34.76).
city('Qarqannah','tn','Safaqis',16323.0,10.99,34.66).
city('Safaqis','tn','Safaqis',276293.0,10.72,34.75).
city('Saqiyat-ad-Dair','tn','Safaqis',35886.0,10.78,34.8).
city('Saqiyat-az-Zayt','tn','Safaqis',42320.0,10.77,34.8).
city('al-Ayn','tn','Safaqis',37683.0,10.78,34.77).
city('al-Hanasah','tn','Safaqis',6402.0,10.75,35.14).
city('al-Mahras','tn','Safaqis',16280.0,10.49,34.53).
city('as-Suhzayrah','tn','Safaqis',9211.0,10.09,34.29).
city('Bir-al-Hufayy','tn','Sidi Bu Zayd',5016.0,9.2,34.93).
city('Jilmah','tn','Sidi Bu Zayd',5647.0,9.42,35.27).
city('Sidi Bu Zayd','tn','Sidi Bu Zayd',42109.0,9.5,35.04).
city('al-Mazzunah','tn','Sidi Bu Zayd',5564.0,9.83,34.58).
city('al-Miknassi','tn','Sidi Bu Zayd',14189.0,9.6,34.62).
city('ar-Riqa','tn','Sidi Bu Zayd',6702.0,9.78,34.87).
city('Bu Aradah','tn','Silyanah',12158.0,9.62,36.35).
city('Kasra','tn','Silyanah',2598.0,9.36,35.81).
city('Maktzar','tn','Silyanah',14500.0,9.2,35.87).
city('Qaafur','tn','Silyanah',10556.0,9.32,36.34).
city('Silyanah','tn','Silyanah',26965.0,9.36,36.09).
city('al-Arusah','tn','Silyanah',2742.0,9.45,36.38).
city('al-Karib','tn','Silyanah',7691.0,9.13,36.3).
city('ar-Rawhiyah','tn','Silyanah',4231.0,9.05,35.65).
city('Akkudah','tn','Susah',20027.0,10.57,35.87).
city('Bu Fisah','tn','Susah',7630.0,10.45,36.3).
city('Hammam Susah','tn','Susah',33834.0,10.58,35.87).
city('Harqalah','tn','Susah',6942.0,10.5,36.03).
city('Masakin','tn','Susah',64563.0,10.58,35.73).
city('Sidi Bu Ali','tn','Susah',8855.0,10.46,35.95).
city('Sidi al-Hani','tn','Susah',2820.0,10.31,35.68).
city('Susah','tn','Susah',163704.0,10.64,35.84).
city('Zawiyat Susah','tn','Susah',8789.0,10.63,35.78).
city('al-Masadin','tn','Susah',6931.0,10.6,35.77).
city('al-Qalat-al-Kabirah','tn','Susah',45968.0,10.53,35.88).
city('al-Qalat-as-Sagirah','tn','Susah',22946.0,10.57,35.84).
city('an-Nafidah','tn','Susah',10648.0,10.38,36.14).
city('Dahibah','tn','Tatawin',4700.0,10.7,32.01).
city('Gumrassin','tn','Tatawin',13753.0,10.33,33.07).
city('Rimadah','tn','Tatawin',4322.0,10.4,32.32).
city('Tatawin','tn','Tatawin',62588.0,10.45,32.93).
city('Daqas','tn','Tawzar',8134.0,8.22,33.99).
city('Hammat-al-Jarid','tn','Tawzar',6592.0,8.15,34.0).
city('Naftah','tn','Tawzar',21720.0,7.88,33.88).
city('Tamagzah','tn','Tawzar',2715.0,7.95,34.39).
city('Tawzar','tn','Tawzar',34949.0,8.13,33.93).
city('Bardaw','tn','Tunis',74027.0,10.13,36.82).
city('Carthago','tn','Tunis',17081.0,10.33,36.89).
city('Halq-al-Wadi','tn','Tunis',79815.0,10.32,36.85).
city('Tunis','tn','Tunis',692816.0,10.22,36.84).
city('al-Marsa','tn','Tunis',65640.0,10.34,36.88).
city('Bir Masariqah','tn','Zagwan',6445.0,9.96,36.52).
city('Zagwan','tn','Zagwan',16914.0,10.14,36.4).
city('al-Fahs','tn','Zagwan',18082.0,9.9,36.38).
city('az-Zaribah','tn','Zagwan',8478.0,10.22,36.32).
city('Manzil Salim','tn','al-Kaf',2856.0,8.46,35.87).
city('Nibbar','tn','al-Kaf',3393.0,8.77,36.3).
city('Qalat-as-Sanan','tn','al-Kaf',5601.0,8.35,35.77).
city('Saqiyat Sidi Yussuf','tn','al-Kaf',6442.0,8.35,36.22).
city('Tajarwin','tn','al-Kaf',18909.0,8.55,35.9).
city('ad-Dahmani','tn','al-Kaf',15243.0,8.83,35.95).
city('al-Jarissah','tn','al-Kaf',14564.0,8.63,35.85).
city('al-Kaf','tn','al-Kaf',47989.0,8.71,36.19).
city('al-Qusur','tn','al-Kaf',5034.0,8.88,35.9).
city('as-Sars','tn','al-Kaf',10979.0,9.02,36.08).
city('Bumirdas','tn','al-Mahdiyah',4986.0,10.73,35.45).
city('Mallulas','tn','al-Mahdiyah',6441.0,11.03,35.17).
city('Qusur-as-Saf','tn','al-Mahdiyah',27936.0,10.98,35.43).
city('Rajis','tn','al-Mahdiyah',8934.0,11.03,35.47).
city('Sidi Ulwan','tn','al-Mahdiyah',7051.0,10.93,35.38).
city('Surban','tn','al-Mahdiyah',6430.0,10.38,35.29).
city('al-Jamm','tn','al-Mahdiyah',20029.0,10.71,35.3).
city('al-Mahdiyah','tn','al-Mahdiyah',44359.0,11.07,35.52).
city('as-Sabbah','tn','al-Mahdiyah',21559.0,11.11,35.25).
city('as-Sawasi','tn','al-Mahdiyah',5179.0,10.55,35.35).
city('Banan Budar','tn','al-Munastir',12279.0,10.83,35.68).
city('Banblat wal-Manarah','tn','al-Munastir',12367.0,10.8,35.7).
city('Bani Hassan','tn','al-Munastir',8139.0,10.82,35.57).
city('Bu Hajjar','tn','al-Munastir',4251.0,10.86,35.69).
city('Hzunays','tn','al-Munastir',10005.0,10.82,35.72).
city('Jammal','tn','al-Munastir',39990.0,10.76,35.64).
city('Lamtah','tn','al-Munastir',5382.0,10.88,35.67).
city('Manzil Kamil','tn','al-Munastir',8314.0,10.66,35.63).
city('Qasr Hallal','tn','al-Munastir',39792.0,10.9,35.65).
city('Qusaybat-al-Madyuni','tn','al-Munastir',11313.0,10.85,35.69).
city('Sahilin Maatmar','tn','al-Munastir',13806.0,10.72,35.75).
city('Sayyadah','tn','al-Munastir',13718.0,10.9,35.67).
city('Sidi Bin Nur','tn','al-Munastir',4042.0,10.92,35.53).
city('Tabulbah','tn','al-Munastir',31709.0,10.88,35.65).
city('Tuzah','tn','al-Munastir',6085.0,10.83,35.63).
city('Zaramidin','tn','al-Munastir',17178.0,10.73,35.58).
city('Zawiyat Quntas','tn','al-Munastir',4975.0,10.77,35.63).
city('al-Baqalitah','tn','al-Munastir',15937.0,11.0,35.62).
city('al-Masdur','tn','al-Munastir',3372.0,10.73,35.68).
city('al-Muknin','tn','al-Munastir',49773.0,10.96,35.65).
city('al-Munastir','tn','al-Munastir',64237.0,10.82,35.79).
city('al-Wardanin','tn','al-Munastir',18287.0,10.67,35.72).
city('Firyanah','tn','al-Qasrayn',23230.0,8.57,34.95).
city('Haydrah','tn','al-Qasrayn',3172.0,8.46,35.57).
city('Majal Bal Abbas','tn','al-Qasra',4904.0,8.52,34.75).
city('Sabibah','tn','al-Qasrayn',6291.0,9.08,35.55).
city('Subaytilah','tn','al-Qasrayn',21539.0,9.12,35.24).
city('Talah','tn','al-Qasrayn',16068.0,8.67,35.58).
city('al-Qasrayn','tn','al-Qasrayn',82005.0,8.83,35.18).
city('Ayn Jalulah','tn','al-Qayrawan',1954.0,9.8,35.8).
city('Haffuz','tn','al-Qayrawan',7765.0,9.67,35.63).
city('al-Ala','tn','al-Qayrawan',2957.0,9.55,35.62).
city('al-Qayrawan','tn','al-Qayrawan',119952.0,10.1,35.68).
city('al-Waslatiyah','tn','al-Qayrawan',10102.0,9.5,35.85).
city('as-Sabikah','tn','al-Qayrawan',2554.0,7.94,34.32).
city('as-Subayhzah','tn','al-Qayrawan',7062.0,10.01,35.93).
city('Adana','tr','Adana',1249680.0,35.32,37.0).
city('Ceyhan','tr','Adana',96358.0,35.82,37.04).
city('Imamoglu','tr','Adana',31932.0,35.67,37.26).
city('Kozan','tr','Adana',88160.0,35.83,37.45).
city('Adiyaman','tr','Adiyaman',223817.0,38.28,37.77).
city('Besni','tr','Adiyaman',41913.0,37.87,37.69).
city('Goelbasi','tr','Adiyaman',28092.0,37.66,37.78).
city('Kahta','tr','Adiyaman',73142.0,38.59,37.77).
city('Afyonkarahisar','tr','Afyon',146211.0,30.54,38.77).
city('Bolvadin','tr','Afyon',55898.0,31.04,38.73).
city('Cay','tr','Afyon',34225.0,31.02,38.6).
city('Dinar','tr','Afyon',35376.0,30.16,38.08).
city('Emirdag','tr','Afyon',20073.0,31.15,39.03).
city('Sandikli','tr','Afyon',43003.0,30.27,38.47).
city('Suhut','tr','Afyon',13849.0,30.53,38.53).
city('Dogubeyazit','tr','Agri',70208.0,44.08,39.54).
city('Karakoese','tr','Agri',92069.0,43.07,39.72).
city('Patnos','tr','Agri',87490.0,42.86,39.24).
city('Aksaray','tr','Aksaray',152281.0,34.03,38.37).
city('Eskil','tr','Aksaray',27061.0,33.41,38.32).
city('Ortakoey','tr','Aksaray',31159.0,34.04,38.74).
city('Amasya','tr','Amasya',82939.0,35.83,40.65).
city('Merzifon','tr','Amasya',50685.0,35.45,40.88).
city('Suluova','tr','Amasya',47596.0,35.66,40.81).
city('Ankara','tr','Ankara',3519177.0,32.85,39.93).
city('Beypazari','tr','Ankara',38789.0,31.92,40.18).
city('Cubuk','tr','Ankara',62616.0,33.03,40.25).
city('Elmadag','tr','Ankara',25407.0,33.25,39.93).
city('Polatli','tr','Ankara',93312.0,32.15,39.6).
city('Sereflikochisar','tr','Ankara',44124.0,33.55,38.94).
city('Alanya','tr','Antalya',113027.0,32.0,36.56).
city('Antalya','tr','Antalya',758603.0,30.71,36.89).
city('Kumluca','tr','Antalya',30355.0,30.28,36.37).
city('Manavgat','tr','Antalya',96102.0,31.46,36.79).
city('Serik','tr','Antalya',36945.0,31.1,36.92).
city('Ardahan','tr','Ardahan',21020.0,42.69,41.12).
city('Artvin','tr','Artvin',24278.0,41.82,41.19).
city('Aydin','tr','Aydin',163106.0,27.84,37.86).
city('Cine','tr','Aydin',21339.0,28.06,37.62).
city('Kusadasi','tr','Aydin',63210.0,27.26,37.87).
city('Nazilli','tr','Aydin',119430.0,28.31,37.92).
city('Soeke','tr','Aydin',68265.0,27.4,37.76).
city('Ayvalik','tr','Balikesir',35210.0,26.69,39.33).
city('Balikesir','tr','Balikesir',238273.0,27.88,39.65).
city('Bandirma','tr','Balikesir',107685.0,27.98,40.37).
city('Burhaniye','tr','Balikesir',38102.0,26.98,39.51).
city('Edremit','tr','Balikesir',40797.0,27.02,39.61).
city('Goenen','tr','Balikesir',40785.0,27.65,40.11).
city('Susurluk','tr','Balikesir',24829.0,28.15,39.92).
city('Bartin','tr','Bartin',37446.0,32.34,41.65).
city('Batman','tr','Batman',302204.0,41.13,37.89).
city('Kozluk','tr','Batman',29517.0,41.5,38.2).
city('Bayburt','tr','Bayburt',31274.0,40.22,40.26).
city('Bilecik','tr','Bilecik',40306.0,29.98,40.16).
city('Bozueyuek','tr','Bilecik',55393.0,30.03,39.92).
city('Bingoel','tr','Bingoel',80592.0,40.49,38.89).
city('Genc','tr','Bingoel',22504.0,40.61,38.76).
city('Solhan','tr','Bingoel',15311.0,41.05,38.97).
city('Adilcevaz','tr','Bitlis',52794.0,42.74,38.81).
city('Ahlat','tr','Bitlis',64725.0,42.5,38.76).
city('Bitlis','tr','Bitlis',48258.0,42.14,38.43).
city('Tatvan','tr','Bitlis',73259.0,42.29,38.49).
city('Akcakoca','tr','Bolu',35167.0,31.15,41.09).
city('Bolu','tr','Bolu',96680.0,31.61,40.75).
city('Gerede','tr','Bolu',28596.0,32.19,40.81).
city('Bucak','tr','Burdur',29248.0,30.58,37.46).
city('Burdur','tr','Burdur',66192.0,30.28,37.73).
city('Bursa','tr','Bursa',1413485.0,29.08,40.2).
city('Gemlik','tr','Bursa',71099.0,29.15,40.43).
city('Guersu','tr','Bursa',24523.0,29.22,40.21).
city('Inegoel','tr','Bursa',134030.0,29.52,40.09).
city('Iznik','tr','Bursa',22242.0,29.73,40.43).
city('Karacabey','tr','Bursa',44279.0,28.37,40.23).
city('Kestel','tr','Bursa',36204.0,29.2,40.2).
city('Mudanya','tr','Bursa',23174.0,28.88,40.38).
city('Mustafakemalpasa','tr','Bursa',54519.0,28.41,40.05).
city('Orhangazi','tr','Bursa',51818.0,29.31,40.49).
city('Yenisehir','tr','Bursa',28671.0,29.66,40.27).
city('Biga','tr','Canakkale',30869.0,27.24,40.24).
city('Can','tr','Canakkale',26216.0,27.06,40.05).
city('Canakkale','tr','Canakkale',87836.0,26.41,40.16).
city('Gelibolu','tr','Canakkale',25191.0,26.68,40.42).
city('Cankiri','tr','Cankiri',71416.0,33.62,40.61).
city('Alaca','tr','Corum',27032.0,34.84,40.18).
city('Corum','tr','Corum',183513.0,34.96,40.56).
city('Iskilip','tr','Corum',19840.0,34.46,40.74).
city('Osmancik','tr','Corum',36462.0,34.79,40.98).
city('Sungurlu','tr','Corum',37544.0,34.38,40.18).
city('Denizli','tr','Denizli',313402.0,29.08,37.78).
city('Bismil','tr','Diyarbakir',74530.0,40.67,37.85).
city('Cermik','tr','Diyarbakir',20987.0,39.46,38.14).
city('Diyarbakir','tr','Diyarbakir',645113.0,40.23,37.92).
city('Ergani','tr','Diyarbakir',52710.0,39.76,38.27).
city('Silvan','tr','Diyarbakir',65990.0,41.01,38.15).
city('Duezce','tr','Duezce',57769.0,31.15,40.85).
city('Edirne','tr','Edirne',126535.0,26.56,41.69).
city('Kesan','tr','Edirne',44668.0,26.63,40.87).
city('Uzunkoeprue','tr','Edirne',36488.0,26.7,41.27).
city('Elazig','tr','Elazig',298163.0,39.23,38.68).
city('Kovancilar','tr','Elazig',22985.0,39.86,38.74).
city('Erzincan','tr','Erzincan',114087.0,39.5,39.74).
city('Uezuemlue','tr','Erzincan',39609.0,39.72,39.72).
city('Erzurum','tr','Erzurum',420919.0,41.29,39.91).
city('Hinis','tr','Erzurum',35491.0,41.71,39.36).
city('Horasan','tr','Erzurum',17076.0,42.16,40.04).
city('Oltu','tr','Erzurum',23516.0,41.98,40.54).
city('Pasinler','tr','Erzurum',24565.0,41.69,39.99).
city('Eskisehir','tr','Eskisehir',515155.0,30.52,39.79).
city('Gaziantep','tr','Gaziantep',1066561.0,37.39,37.07).
city('Islahiye','tr','Gaziantep',40783.0,36.3,37.03).
city('Nizip','tr','Gaziantep',82351.0,37.79,37.02).
city('Bulancak','tr','Giresun',36882.0,38.23,40.94).
city('Giresun','tr','Giresun',98916.0,38.39,40.92).
city('Goerele','tr','Giresun',30396.0,39.02,41.03).
city('Sebinkarahisar','tr','Giresun',47384.0,38.42,40.29).
city('Guemueshane','tr','Guemueshane',32266.0,39.48,40.46).
city('Hakkari','tr','Hakkari',77739.0,43.75,37.57).
city('Yueksekova','tr','Hakkari',71763.0,44.29,37.57).
city('Antakya','tr','Hatay',154881.0,36.17,36.2).
city('Belen','tr','Hatay',20123.0,36.2,36.5).
city('Doertyol','tr','Hatay',56542.0,36.22,36.86).
city('Erzin','tr','Hatay',26330.0,-36.19,36.97).
city('Iskenderun','tr','Hatay',160046.0,36.17,36.58).
city('Kirikhan','tr','Hatay',60946.0,36.35,36.5).
city('Reyhanli','tr','Hatay',57024.0,36.53,36.3).
city('Samandag','tr','Hatay',38434.0,35.98,36.09).
city('Anamur','tr','Icel',57157.0,32.84,36.08).
city('Bozyazi','tr','Icel',28470.0,32.98,36.1).
city('Erdemli','tr','Icel',46595.0,34.31,36.61).
city('Mersin','tr','Icel',612540.0,34.63,36.81).
city('Mut','tr','Icel',49423.0,33.45,36.64).
city('Silifke','tr','Icel',75353.0,33.93,36.37).
city('Tarsus','tr','Icel',256617.0,34.9,36.92).
city('Igdir','tr','Igdir',72597.0,44.06,39.92).
city('Isparta','tr','Isparta',172424.0,30.55,37.77).
city('Sarkikaraagac','tr','Isparta',32785.0,31.37,38.08).
city('Yalvac','tr','Isparta',39165.0,31.15,38.31).
city('Agva','tr','Istanbul',3492.0,29.86,41.14).
city('Bahcesehir','tr','Istanbul',21966.0,28.57,41.09).
city('Binklic','tr','Istanbul',3568.0,28.19,41.44).
city('Bueyu','tr','Istanbul',3843.0,28.04,41.24).
city('Bueyuekcekmece','tr','Istanbul',44651.0,28.78,41.0).
city('Canta','tr','Istanbul',5473.0,28.08,41.12).
city('Catalca','tr','Istanbul',19328.0,28.48,41.14).
city('Celaliye','tr','Istanbul',7793.0,28.42,41.05).
city('Ciftlik','tr','Istanbul',2652.0,28.41,41.34).
city('Degirmen','tr','Istanbul',5902.0,28.02,41.11).
city('Durusu','tr','Istanbul',2784.0,28.69,41.33).
city('Esenyurt','tr','Istanbul',211443.0,28.67,41.03).
city('Guemuesyaka','tr','Istanbul',6244.0,28.03,41.06).
city('Guerpinar','tr','Istanbul',29428.0,28.59,41.0).
city('Hadimkoey','tr','Istanbul',11842.0,28.62,41.15).
city('Istanbul','tr','Istanbul',9797536.0,29.0,41.1).
city('Karacakoey','tr','Istanbul',3107.0,28.4,41.41).
city('Kavakli','tr','Istanbul',50532.0,28.34,41.11).
city('Kirac','tr','Istanbul',27970.0,28.63,41.11).
city('Kumburgaz','tr','Istanbul',11956.0,28.48,41.04).
city('Mimarsinan','tr','Istanbul',31021.0,28.55,41.02).
city('Muratbey','tr','Istanbul',2166.0,28.5,41.1).
city('Ortakoey','tr','Istanbul',3837.0,28.38,41.1).
city('Selimpasa','tr','Istanbul',10569.0,28.35,41.07).
city('Sile','tr','Istanbul',11602.0,29.62,41.19).
city('Silivri','tr','Istanbul',53196.0,28.25,41.08).
city('Sultanbeyli','tr','Istanbul',241274.0,29.3,40.92).
city('Tepecik','tr','Istanbul',21711.0,28.54,41.03).
city('Yakuplu','tr','Istanbul',28828.0,28.64,40.99).
city('Aliaga','tr','Izmir',44906.0,26.98,38.8).
city('Bayindir','tr','Izmir',16858.0,27.65,38.23).
city('Bergama','tr','Izmir',57229.0,27.17,39.13).
city('Cesme','tr','Izmir',21329.0,26.31,38.33).
city('Izmir','tr','Izmir',2501895.0,27.15,38.43).
city('Kemalpasa','tr','Izmir',30427.0,27.42,38.43).
city('Menemen','tr','Izmir',53518.0,27.06,38.61).
city('Oedemis','tr','Izmir',67187.0,27.96,38.24).
city('Selcuk','tr','Izmir',29116.0,27.35,37.96).
city('Tire','tr','Izmir',47245.0,27.73,38.09).
city('Torbali','tr','Izmir',50330.0,27.36,38.17).
city('Urla','tr','Izmir',45222.0,26.76,38.33).
city('Afsin','tr','Kahramanmaras',39633.0,36.92,38.26).
city('Elbistan','tr','Kahramanmaras',80496.0,37.21,38.21).
city('Goeksun','tr','Kahramanmaras',34260.0,36.5,38.02).
city('Kahramanmaras','tr','Kahramanmaras',376247.0,36.94,37.61).
city('Pazarcik','tr','Kahramanmaras',23862.0,37.31,37.49).
city('Karabuek','tr','Karabuek',97531.0,32.61,41.21).
city('Safranbolu','tr','Karabuek',35259.0,32.69,41.26).
city('Karaman','tr','Karaman',120464.0,33.22,37.18).
city('Kars','tr','Kars',77525.0,43.07,40.59).
city('Sarikamis','tr','Kars',23677.0,42.59,40.34).
city('Kastamonu','tr','Kastamonu',70438.0,33.78,41.39).
city('Tosya','tr','Kastamonu',24025.0,34.04,41.03).
city('Develi','tr','Kayseri',35886.0,35.49,38.39).
city('Kayseri','tr','Kayseri',593164.0,35.48,38.74).
city('Talas','tr','Kayseri',36908.0,35.58,38.69).
city('Yahyali','tr','Kayseri',25032.0,35.37,38.1).
city('Kilis','tr','Kilis',82304.0,37.11,36.73).
city('Keskin','tr','Kirikkale',49701.0,33.61,39.68).
city('Kirikkale','tr','Kirikkale',211253.0,33.0,39.85).
city('Babaeski','tr','Kirklareli',26737.0,27.09,41.44).
city('Kirklareli','tr','Kirklareli',58253.0,27.22,41.75).
city('Lueleburgaz','tr','Kirklareli',90947.0,27.36,41.42).
city('Kaman','tr','Kirsehir',28619.0,33.72,39.37).
city('Kirsehir','tr','Kirsehir',94385.0,34.16,39.15).
city('Gebze','tr','Kocaeli',281585.0,29.44,40.81).
city('Goelcuek','tr','Kocaeli',56201.0,29.82,40.72).
city('Izmit','tr','Kocaeli',196672.0,29.93,40.77).
city('Karamuersel','tr','Kocaeli',30541.0,29.61,40.69).
city('Koerfez','tr','Kocaeli',90626.0,29.73,40.79).
city('Aksehir','tr','Konya',64478.0,31.41,38.36).
city('Beysehir','tr','Konya',44483.0,31.73,37.69).
city('Cumra','tr','Konya',45681.0,32.78,37.57).
city('Eregli','tr','Konya',92166.0,34.05,37.51).
city('Ilgin','tr','Konya',27437.0,31.91,38.28).
city('Karapinar','tr','Konya',49535.0,33.55,37.72).
city('Konya','tr','Konya',876004.0,32.48,37.88).
city('Kulu','tr','Konya',47061.0,33.08,39.1).
city('Seydisehir','tr','Konya',51114.0,31.84,37.43).
city('Emet','tr','Kuetahya',23824.0,29.26,39.35).
city('Gediz','tr','Kuetahya',22069.0,29.41,39.05).
city('Kuetahya','tr','Kuetahya',185104.0,29.98,39.42).
city('Simav','tr','Kuetahya',34924.0,28.97,39.1).
city('Tavsanli','tr','Kuetahya',52209.0,29.49,39.54).
city('Malatya','tr','Malatya',442046.0,38.31,38.36).
city('Akhisar','tr','Manisa',84702.0,27.83,38.93).
city('Alasehir','tr','Manisa',40755.0,28.51,38.36).
city('Demirci','tr','Manisa',21389.0,28.64,39.05).
city('Kirkagac','tr','Manisa',27068.0,27.66,39.11).
city('Kula','tr','Manisa',31116.0,28.64,38.55).
city('Manisa','tr','Manisa',244095.0,27.43,38.63).
city('Salihli','tr','Manisa',88950.0,28.13,38.49).
city('Soma','tr','Manisa',65967.0,27.61,39.19).
city('Turgutlu','tr','Manisa',103346.0,27.7,38.51).
city('Derik','tr','Mardin',23887.0,40.28,37.36).
city('Kiziltepe','tr','Mardin',150251.0,40.59,37.19).
city('Mardin','tr','Mardin',71409.0,40.78,37.33).
city('Midyat','tr','Mardin',76307.0,41.37,37.42).
city('Nusaybin','tr','Mardin',89022.0,41.23,37.09).
city('Bodrum','tr','Mugla',39337.0,27.43,37.04).
city('Fethiye','tr','Mugla',60469.0,29.11,36.62).
city('Marmaris','tr','Mugla',33749.0,28.26,36.86).
city('Milas','tr','Mugla',43215.0,27.77,37.32).
city('Mugla','tr','Mugla',48208.0,28.36,37.22).
city('Bulanik','tr','Mus',31446.0,42.28,39.1).
city('Malazgirt','tr','Mus',26121.0,42.55,39.15).
city('Mus','tr','Mus',82578.0,41.49,38.74).
city('Nevsehir','tr','Nevsehir',75565.0,34.72,38.63).
city('Bor','tr','Nigde',32452.0,34.57,37.91).
city('Nigde','tr','Nigde',91086.0,34.68,37.98).
city('Aybasti','tr','Ordu',13062.0,37.38,40.73).
city('Fatsa','tr','Ordu',82203.0,37.49,41.03).
city('Goelkoey','tr','Ordu',27418.0,37.62,40.72).
city('Guergentepe','tr','Ordu',18780.0,37.6,40.79).
city('Ordu','tr','Ordu',116846.0,37.88,40.99).
city('Uenye','tr','Ordu',77626.0,37.29,41.13).
city('Bahce','tr','Osmaniye',19575.0,36.61,37.0).
city('Duezici','tr','Osmaniye',50850.0,36.51,37.23).
city('Kadirli','tr','Osmaniye',70283.0,36.11,37.37).
city('Osmaniye','tr','Osmaniye',202944.0,36.25,37.07).
city('Ardesen','tr','Rize',67990.0,40.99,41.2).
city('Cayeli','tr','Rize',24571.0,40.73,41.09).
city('Rize','tr','Rize',92820.0,40.52,41.02).
city('Adapazari','tr','Sakarya',286937.0,30.41,40.79).
city('Akyazi','tr','Sakarya',25081.0,30.63,40.69).
city('Hendek','tr','Sakarya',35275.0,30.75,40.81).
city('Bafra','tr','Samsun',92991.0,35.89,41.57).
city('Carsamba','tr','Samsun',50488.0,36.73,41.2).
city('Samsun','tr','Samsun',394261.0,36.33,41.29).
city('Terme','tr','Samsun',28411.0,36.97,41.21).
city('Vezirkoeprue','tr','Samsun',25168.0,35.45,41.15).
city('Birecik','tr','Sanliurfa',44307.0,38.0,37.04).
city('Bozova','tr','Sanliurfa',21513.0,38.53,37.37).
city('Ceylanpinar','tr','Sanliurfa',31489.0,40.05,36.85).
city('Siverek','tr','Sanliurfa',175432.0,39.33,37.76).
city('Suruc','tr','Sanliurfa',46718.0,38.44,36.98).
city('Urfa','tr','Sanliurfa',449785.0,38.79,37.17).
city('Viransehir','tr','Sanliurfa',154244.0,39.77,37.24).
city('Kurtalan','tr','Siirt',32131.0,41.71,37.93).
city('Siirt','tr','Siirt',114094.0,41.95,37.94).
city('Boyabat','tr','Sinop',27711.0,34.78,41.48).
city('Sinop','tr','Sinop',34827.0,35.15,42.03).
city('Cizre','tr','Sirnak',81039.0,42.2,37.33).
city('Idil','tr','Sirnak',22972.0,41.9,37.34).
city('Silopi','tr','Sirnak',74833.0,42.48,37.25).
city('Sirnak','tr','Si',72439.0,42.46,37.52).
city('Sarkisla','tr','Sivas',23813.0,36.43,39.36).
city('Sivas','tr','Sivas',264163.0,37.02,39.75).
city('Susehri','tr','Sivas',25832.0,38.09,40.16).
city('Cerkezkoey','tr','Tekirdag',67117.0,28.0,41.29).
city('Corlu','tr','Tekirdag',202659.0,27.8,41.17).
city('Hayrabolu','tr','Tekirdag',19803.0,27.12,41.23).
city('Malkara','tr','Tekirdag',27441.0,26.91,40.9).
city('Tekirdag','tr','Tekirdag',122350.0,27.52,40.98).
city('Erbaa','tr','Tokat',52213.0,36.57,40.6).
city('Niksar','tr','Tokat',49890.0,36.95,40.59).
city('Tokat','tr','Tokat',129768.0,36.56,40.3).
city('Turhal','tr','Tokat',110941.0,36.07,40.39).
city('Zile','tr','Tokat',55708.0,35.89,40.3).
city('Akcaabat','tr','Trabzon',45129.0,39.56,41.02).
city('Besikduezue','tr','Trabzon',37003.0,39.23,41.05).
city('Of','tr','Trabzon',31968.0,40.27,40.95).
city('Trabzon','tr','Trabzon',244209.0,39.71,41.0).
city('Vakfikebir','tr','Trabzon',37747.0,39.28,41.05).
city('Tunceli','tr','Tunceli',29042.0,39.55,39.1).
city('Usak','tr','Usak',152943.0,29.41,38.68).
city('Ercis','tr','Van',91962.0,43.37,39.03).
city('Van','tr','Van',371911.0,43.4,38.49).
city('Yalova','tr','Yalova',71327.0,29.28,40.66).
city('Akdagmadeni','tr','Yozgat',23060.0,35.83,39.66).
city('Bogaziliyan','tr','Yozgat',36125.0,35.26,39.2).
city('Sorgun','tr','Yozgat',62894.0,35.17,39.82).
city('Yerkoey','tr','Yozgat',35312.0,34.48,39.64).
city('Yozgat','tr','Yozgat',87926.0,34.81,39.82).
city('Devrek','tr','Zonguldak',24571.0,31.95,41.23).
city('Eregli','tr','Zonguldak',88894.0,31.42,41.3).
city('Zonguldak','tr','Zonguldak',100281.0,31.8,41.46).
city('Annau','tm','Ahal',27527.0,58.51,37.88).
city('Baeherden','tm','Ahal',22991.0,57.43,38.44).
city('Buezmeyin','tm','Ahal',39485.0,58.19,38.05).
city('Goekedepe','tm','Ahal',19688.0,58.01,38.22).
city('Kaka','tm','Ahal',18545.0,59.61,37.35).
city('Tecen','tm','Ahal',67301.0,60.5,37.38).
city('Asgabat','tm','Asgabat',797900.0,58.38,37.95).
city('Balkanabat','tm','Balkan',87830.0,54.36,39.51).
city('Gazanjyk','tm','Balkan',21090.0,55.51,39.24).
city('Gumdag','tm','Balkan',24312.0,54.58,39.21).
city('Khazar','tm','Balkan',17651.0,54.13,39.41).
city('Serdar','tm','Balkan',73413.0,56.27,38.98).
city('Tuerkmenbasi','tm','Balkan',68297.0,52.96,40.02).
city('Akdepe','tm','Dasoguz',14177.0,59.37,42.05).
city('Boldumsaz','tm','Dasoguz',21160.0,59.67,42.14).
city('Dasoguz','tm','Dasoguz',199514.0,59.96,41.85).
city('Gubadag','tm','Dasoguz',15260.0,59.77,42.1).
city('Koehne Uergenc','tm','Dasoguz',31565.0,59.14,42.33).
city('Tahta','tm','Dasoguz',16635.0,59.91,41.66).
city('Yilanli','tm','Dasoguz',24472.0,59.63,41.88).
city('Farap','tm','Lebap',14502.0,63.6,39.17).
city('Gazojak','tm','Lebap',21020.0,61.4,41.18).
city('Govurdak','tm','Lebap',34785.0,66.05,37.81).
city('Kerki','tm','Lebap',33241.0,65.18,37.84).
city('Sayat','tm','Lebap',17761.0,63.88,38.78).
city('Seydi','tm','Lebap',17761.0,62.9,39.42).
city('Tuerkmenabat','tm','Lebap',234828.0,63.57,39.1).
city('Bayramali','tm','Mari',75804.0,62.16,37.62).
city('Eloeten','tm','Mari',32705.0,62.36,37.29).
city('Mari','tm','Mari',114690.0,61.82,37.59).
city('Murgab','tm','Mari',13199.0,61.97,37.5).
city('Cockburn Town','tc','Grand Turk',5525.0,-71.13,21.48).
city('Cockburn Harbour','tc','South Caicos and East Caicos',1744.0,-71.52,21.5).
city('Vaiaku','tv','Funafuti',4749.0,179.19,-8.52).
city('Tonga','tv','Nanumanga',376.0,176.32,-6.28).
city('Lolua','tv','Nanumea',628.0,176.13,-5.67).
city('Kua','tv','Niutao',538.0,177.3,-6.12).
city('Tanrake','tv','Nui',381.0,177.15,-7.25).
city('Savave','tv','Nukufetau',560.0,178.32,-8.03).
city('Fangaua','tv','Nukulaelae',312.0,179.83,-9.37).
city('Asau','tv','Vaitupu',628.0,178.67,-7.5).
city('Bombo','ug','Central',12752.0,32.53,0.59).
city('Bweyogerere','ug','Central',11473.0,32.67,0.37).
city('Entebbe','ug','Central',62971.0,32.46,0.06).
city('Jinja-Kawempe','ug','Central',11076.0,32.55,0.39).
city('Kajansi','ug','Central',7530.0,32.55,0.2).
city('Kalangala','ug','Central',3731.0,32.28,-0.32).
city('Kampala','ug','Central',1353236.0,32.58,0.32).
city('Kayunga','ug','Central',21706.0,32.89,0.71).
city('Kiboga','ug','Central',14512.0,31.77,0.91).
city('Kireka','ug','Central',17947.0,32.63,0.33).
city('Kyotera','ug','Central',8472.0,31.53,-0.63).
city('Lugazi','ug','Central',35038.0,32.93,0.38).
city('Lukaya','ug','Central',17576.0,31.88,-0.13).
city('Luwero','ug','Central',28340.0,32.48,0.85).
city('Lyantonde','ug','Central',8039.0,31.15,-0.4).
city('Masaka','ug','Central',65376.0,31.73,-0.33).
city('Mityana','ug','Central',41146.0,32.05,0.4).
city('Mpigi','ug','Central',11082.0,32.33,0.22).
city('Mubende','ug','Central',18937.0,31.37,0.59).
city('Mukono','ug','Central',67303.0,32.76,0.36).
city('Nakasongola','ug','Central',6922.0,32.45,1.33).
city('Namasuba','ug','Central',22507.0,32.43,0.7).
city('Njeru','ug','Central',61975.0,33.18,0.45).
city('Nkonkonjeru','ug','Central',11963.0,32.92,0.23).
city('Rakai','ug','Central',7613.0,31.4,-0.72).
city('Sembabule','ug','Central',4320.0,31.45,-0.06).
city('Wakiso','ug','Central',20543.0,32.46,0.42).
city('Wobulenzi','ug','Central',24425.0,32.52,0.73).
city('Bugembe','ug','Eastern',11598.0,33.23,0.48).
city('Bugiri','ug','Eastern',24154.0,29.64,-0.86).
city('Busembatia','ug','Eastern',15889.0,33.61,0.78).
city('Busia','ug','Eastern',42596.0,34.01,0.46).
city('Buwenge','ug','Eastern',15130.0,33.18,0.65).
city('Iganga','ug','Eastern',45023.0,33.47,0.62).
city('Jinja','ug','Eastern',93060.0,33.2,0.44).
city('Kaberamaido','ug','Eastern',27789.0,33.15,1.81).
city('Kamuli','ug','Eastern',12763.0,33.11,0.95).
city('Kapchorwa','ug','Eastern',10416.0,34.45,1.41).
city('Katakwi','ug','Eastern',8702.0,33.95,1.93).
city('Kumi','ug','Eastern',8827.0,33.92,1.49).
city('Malaba','ug','Eastern',11962.0,34.26,0.64).
city('Mayuge','ug','Eastern',11501.0,33.48,0.47).
city('Mbale','ug','Eastern',76492.0,34.17,1.09).
city('Ngora','ug','Eastern',9193.0,33.77,1.46).
city('Pallisa','ug','Eastern',30740.0,33.7,1.17).
city('Sironko','ug','Eastern',14698.0,34.23,1.23).
city('Soroti','ug','Eastern',43312.0,33.6,1.71).
city('Tororo','ug','Eastern',47729.0,34.17,0.71).
city('Adjumani','ug','Northern',26774.0,31.79,3.38).
city('Amudat','ug','Northern',1873.0,34.92,1.95).
city('Apac','ug','Northern',11775.0,32.53,1.99).
city('Arua','ug','Northern',55583.0,30.9,3.02).
city('Gulu','ug','Northern',146832.0,32.28,2.78).
city('Kaabong','ug','Northern',9806.0,34.12,3.52).
city('Kitgum','ug','Northern',56881.0,32.87,3.3).
city('Koboko','ug','Northern',39609.0,30.94,3.44).
city('Kotido','ug','Northern',17336.0,34.11,3.01).
city('Lira','ug','Northern',119302.0,32.89,2.26).
city('Moroto','ug','Northern',8490.0,34.64,2.54).
city('Moyo','ug','Northern',14377.0,31.72,3.65).
city('Nakapiripirit','ug','Northern',1800.0,34.67,1.84).
city('Nebbi','ug','Northern',30347.0,31.08,2.48).
city('Pader','ug','Northern',11152.0,33.12,2.82).
city('Paidha','ug','Northern',28346.0,30.98,2.42).
city('Pakwach','ug','Northern',23890.0,31.48,2.47).
city('Yumbe','ug','Northern',17178.0,31.24,3.46).
city('Bundibugyo','ug','Western',16920.0,30.05,0.72).
city('Bushenyi','ug','Western',24810.0,30.18,-0.54).
city('Fort Portal','ug','Western',42671.0,30.27,0.67).
city('Hima','ug','Western',14678.0,30.16,0.3).
city('Hoima','ug','Western',39644.0,31.34,1.44).
city('Ibanda','ug','Western',24704.0,30.5,-0.12).
city('Kabale','ug','Western',50871.0,29.98,-1.25).
city('Kabwohe-Itendero','ug','Western',16854.0,30.42,-0.57).
city('Kagadi','ug','Western',2097.0,30.8,0.95).
city('Kamwenge','ug','Western',17177.0,30.44,0.2).
city('Kanungu','ug','Western',12886.0,29.78,-0.9).
city('Kasese','ug','Western',67279.0,30.01,0.22).
city('Katwe','ug','Western',5860.0,29.92,-0.13).
city('Kibaale','ug','Western',5200.0,31.05,0.8).
city('Kigorobya','ug','Western',5420.0,31.3,1.62).
city('Kilembe','ug','Western',7914.0,30.0,0.2).
city('Kisoro','ug','Western',11554.0,29.68,-1.28).
city('Kyenjojo','ug','Western',19123.0,30.6,0.6).
city('Masindi','ug','Western',31488.0,31.7,1.69).
city('Masindi-Port','ug','Western',7828.0,32.07,1.7).
city('Mbarara','ug','Western',79159.0,30.65,-0.6).
city('Muhororo','ug','Western',1567.0,30.77,0.92).
city('Ntungamo','ug','Western',16922.0,29.64,-0.89).
city('Rukungiri','ug','Western',19837.0,29.92,0.79).
city('Babanka','ua','Cherkaska',2460.0,30.45,48.7).
city('Bilozirya','ua','Cherkaska',8186.0,31.92,49.32).
city('Buky','ua','Cherkaska',2158.0,30.41,49.09).
city('Chapayevka','ua','Cherkaska',3042.0,30.47,49.38).
city('Cherkasy','ua','Cherkaska',297566.0,32.07,49.43).
city('Chervona Sloboda','ua','Cherkaska',9333.0,32.18,49.37).
city('Chornobay','ua','Cherkaska',8053.0,32.33,49.67).
city('Chyhyryn','ua','Cherkaska',11515.0,32.67,49.07).
city('Drabiv','ua','Cherkaska',7011.0,32.13,49.97).
city('Dubiyivka','ua','Cherkaska',3219.0,31.94,49.35).
city('Helmyaziv','ua','Cherkaska',4951.0,31.35,49.82).
city('Horodyshche','ua','Cherkaska',15063.0,31.45,49.3).
city('Irdyn','ua','Cherkaska',996.0,31.73,49.38).
city('Kamyanka','ua','Cherkaska',14547.0,32.1,49.03).
city('Kaniv','ua','Cherkaska',25666.0,31.47,49.75).
city('Katerynopil','ua','Cherkaska',6201.0,30.98,48.94).
city('Khrystynivka','ua','Cherkaska',7028.0,29.98,48.83).
city('Korsun-Shevchenkivskyy','ua','Cherkaska',18593.0,31.25,49.43).
city('Lebedyn','ua','Cherkaska',4402.0,31.53,48.96).
city('Lesky','ua','Cherkaska',4013.0,32.22,49.35).
city('Lysyanka','ua','Cherkaska',7954.0,30.83,49.25).
city('Mankivka','ua','Cherkaska',8323.0,30.34,48.96).
city('Matusiv','ua','Cherkaska',4337.0,31.58,49.05).
city('Mliyiv','ua','Cherkaska',4158.0,31.52,49.35).
city('Monastyryshche','ua','Cherkaska',9111.0,29.82,48.98).
city('Moshny','ua','Cherkaska',4629.0,31.75,49.53).
city('Nove Misto','ua','Cherkaska',3619.0,29.82,48.99).
city('Pishchane','ua','Cherkaska',3658.0,31.85,49.74).
city('Rodnykivka','ua','Cherkaska',3252.0,30.21,48.79).
city('Russkaya Polyana','ua','Cherkaska',7780.0,31.96,49.42).
city('Sahunivka','ua','Cherkaska',3201.0,32.4,49.3).
city('Shramkivka','ua','Cherkaska',3066.0,32.13,50.14).
city('Smila','ua','Cherkaska',67530.0,31.88,49.23).
city('Stebliv','ua','Cherkaska',3859.0,31.09,49.4).
city('Talne','ua','Cherkaska',15779.0,30.7,48.89).
city('Tsvitkove','ua','Cherkaska',1262.0,31.54,49.15).
city('Tsybuliv','ua','Cherkaska',3751.0,29.85,49.07).
city('Uman','ua','Cherkaska',88083.0,30.22,48.75).
city('Vatutine','ua','Cherkaska',19407.0,31.06,49.02).
city('Velyka Sevastyanivka','ua','Cherkaska',2885.0,29.79,48.88).
city('Verkhnyachka','ua','Cherkaska',4130.0,30.04,48.83).
city('Vilshana','ua','Cherkaska',3517.0,31.22,49.22).
city('Yerky','ua','Cherkaska',4159.0,30.99,48.98).
city('Yurkivka','ua','Cherkaska',2887.0,31.11,49.02).
city('Zhashkiv','ua','Cherkaska',15264.0,30.1,49.25).
city('Zolotonosha','ua','Cherkaska',27722.0,32.03,49.67).
city('Zvenyhorodka','ua','Cherkaska',19161.0,30.97,49.08).
city('Bakhmach','ua','Chernihivska',11205.0,32.78,51.2).
city('Baturyn','ua','Chernihivska',2964.0,32.88,51.35).
city('Berezna','ua','Chernihivska',5172.0,31.78,51.57).
city('Bobrovytsya','ua','Chernihivska',11544.0,31.38,50.75).
city('Borzna','ua','Chernihivska',11363.0,32.43,51.25).
city('Chernihiv','ua','Chernihivska',307683.0,31.3,51.5).
city('Desna','ua','Chernihivska',6906.0,30.75,50.92).
city('Dihtyari','ua','Chernihivska',1289.0,32.76,50.59).
city('Dmytrivka','ua','Chernihiv',2700.0,32.96,50.94).
city('Dobryanka','ua','Chernihivska',3250.0,31.18,52.06).
city('Druzhba','ua','Chernihivska',793.0,32.37,50.8).
city('Horodnya','ua','Chernihivska',13601.0,31.6,51.88).
city('Ichnya','ua','Chernihivska',12417.0,32.4,50.87).
city('Kholmy','ua','Chernihivska',3146.0,32.59,51.87).
city('Kobyzhcha','ua','Chernihivska',4332.0,31.5,50.83).
city('Korop','ua','Chernihivska',5478.0,32.97,51.57).
city('Koryukivka','ua','Chernihivska',14214.0,32.27,51.77).
city('Kozelets','ua','Chernihivska',8584.0,31.12,50.92).
city('Kulykivka','ua','Chernihivska',5739.0,31.65,51.37).
city('Kurin','ua','Chernihivska',3907.0,32.75,51.14).
city('Ladan','ua','Chernihivska',6719.0,32.58,50.52).
city('Losynivka','ua','Chernihivska',4347.0,31.92,50.83).
city('Lynovytsya','ua','Chernihivska',2873.0,32.4,50.47).
city('Lyubech','ua','Chernihivska',2550.0,30.65,51.7).
city('Makoshyne','ua','Chernihivska',2596.0,32.33,51.45).
city('Mala Divytsya','ua','Chernihivska',2294.0,32.16,50.7).
city('Mena','ua','Chernihivska',12766.0,32.22,51.52).
city('Mykhaylo-Kotsyubynske','ua','Chernihivska',2938.0,31.07,51.44).
city('Nizhyn','ua','Chernihivska',75498.0,31.88,51.05).
city('Nosivka','ua','Chernihivska',15164.0,31.58,50.93).
city('Nova Basan','ua','Chernihivska',3160.0,31.51,50.56).
city('Olyshivka','ua','Chernihivska',2317.0,31.33,51.22).
city('Oster','ua','Chernihivska',6794.0,30.88,50.95).
city('Parafiyivka','ua','Chernihivska',2660.0,32.63,50.88).
city('Ponornytsya','ua','Chernihivska',2677.0,32.85,51.72).
city('Pryluky','ua','Chernihivska',62822.0,32.4,50.6).
city('Radul','ua','Chernihivska',763.0,30.7,51.83).
city('Ripky','ua','Chernihivska',7708.0,31.1,51.8).
city('Sedniv','ua','Chernihivska',1301.0,31.56,51.65).
city('Semenivka','ua','Chernihivska',9320.0,32.58,52.18).
city('Shchors','ua','Chernihivska',11857.0,31.93,51.82).
city('Sosnytsya','ua','Chernihivska',7825.0,32.5,51.53).
city('Sribne','ua','Chernihivska',3534.0,32.93,50.65).
city('Talalayivka','ua','Chernihivska',5054.0,31.92,50.95).
city('Varva','ua','Chernihivska',8549.0,32.73,50.5).
city('Vertiyivka','ua','Chernihivska',3690.0,31.86,51.17).
city('Zamhlay','ua','Chernihivska',1878.0,31.15,51.8).
city('Zhuravka','ua','Chernihivska',2900.0,32.6,50.48).
city('Banyliv','ua','Chernivetska',3748.0,25.37,48.37).
city('Berehomet','ua','Chernivetska',8227.0,25.34,48.18).
city('Bilousivka','ua','Chernivetska',2921.0,27.35,48.53).
city('Boyany','ua','Chernivetska',4260.0,26.13,48.28).
city('Chahor','ua','Chernivetska',4097.0,25.98,48.25).
city('Chernivtsi','ua','Chernivetska',236249.0,25.93,48.3).
city('Chudey','ua','Chernivetska',5058.0,25.62,48.05).
city('Davydivka','ua','Chernivetska',2981.0,25.56,48.12).
city('Dynivtsi','ua','Chernivetska',3065.0,26.3,48.33).
city('Hertsa','ua','Chernivetska',1991.0,26.25,48.15).
city('Hlyboka','ua','Chernivetska',8942.0,25.92,48.09).
city('Ispas','ua','Chernivetska',4278.0,25.28,48.31).
city('Ivanivtsi','ua','Chernivetska',3117.0,27.05,48.5).
city('Kadubivtsi','ua','Chernivetska',3161.0,25.77,48.58).
city('Kamyanka','ua','Chernivetska',6007.0,25.9,48.04).
city('Kelmentsi','ua','Chernivetska',7818.0,26.83,48.47).
city('Khotyn','ua','Chernivetska',10799.0,26.5,48.48).
city('Kitsman','ua','Chernivetska',7325.0,25.76,48.44).
city('Klishkivtsi','ua','Chernivetska',6272.0,26.27,48.43).
city('Kolinkivtsi','ua','Chernivetska',5046.0,26.13,48.42).
city('Kostryzhivka','ua','Chernivetska',2768.0,25.71,48.65).
city('Krasnoyilsk','ua','Chernivetska',8802.0,25.58,48.02).
city('Luzhany','ua','Chernivetska',4520.0,25.78,48.37).
city('Mamayivtsi','ua','Chernivetska',5594.0,25.81,48.35).
city('Marshyntsi','ua','Chernivetska',5141.0,26.28,48.21).
city('Molodiya','ua','Chernivetska',3691.0,26.03,48.22).
city('Myhove','ua','Chernivetska',3546.0,25.37,48.16).
city('Nedoboyivtsi','ua','Chernivetska',3049.0,26.35,48.43).
city('Nepolokivtsi','ua','Chernivetska',2353.0,25.63,48.39).
city('Novodnistrovsk','ua','Chernivetska',9957.0,27.42,48.6).
city('Novoselytsya','ua','Chernivetska',8088.0,26.28,48.22).
city('Nyzhni Petrivtsi','ua','Chernivetska',2887.0,25.73,48.03).
city('Ostrytsya','ua','Chernivetska',3546.0,26.05,48.27).
city('Putyla','ua','Chernivetska',3208.0,25.04,48.1).
city('Romankivtsi','ua','Chernivetska',4862.0,27.22,48.5).
city('Ropcha','ua','Chernivetska',3189.0,25.77,48.1).
city('Rukshyn','ua','Chernivetska',3303.0,26.4,48.5).
city('Rzhavyntsi','ua','Chernivetska',2961.0,26.08,48.52).
city('Shylivtsi','ua','Chernivetska',2906.0,26.18,48.45).
city('Shypyntsi','ua','Chernivetska',2937.0,25.75,48.37).
city('Sokyryany','ua','Chernivetska',9877.0,27.42,48.45).
city('Storozhynets','ua','Chernivetska',14147.0,25.72,48.16).
city('Toporivtsi','ua','Chernivetska',4247.0,26.12,48.38).
city('Tysovets','ua','Chernivetska',340.0,25.88,48.17).
city('Vashkivtsi','ua','Chernivetska',4604.0,26.31,48.4).
city('Velykyy Kuchuriv','ua','Chernivetska',5826.0,25.89,48.2).
city('Verenchanka','ua','Chernivetska',3560.0,25.74,48.54).
city('Verkhni Petrivtsi','ua','Chernivetska',3603.0,25.71,48.07).
city('Voloka','ua','Chernivetska',2915.0,25.93,48.19).
city('Vyzhnytsya','ua','Chernivetska',4834.0,25.19,48.25).
city('Yizhivtsi','ua','Chernivetska',3240.0,25.66,48.04).
city('Zarozhany','ua','Chernivetska',3156.0,26.3,48.42).
city('Zastavna','ua','Chernivetska',8536.0,25.85,48.52).
city('Apostolove','ua','Dnipropetrovska',15828.0,33.73,47.67).
city('Auly','ua','Dnipropetrovska',4167.0,34.5,48.53).
city('Bohdanivka','ua','Dnipropetrovska',4816.0,36.1,48.51).
city('Bohuslav','ua','Dnipropetrovska',3733.0,36.03,48.45).
city('Brahynivka','ua','Dnipropetrovska',648.0,36.36,48.48).
city('Chaplyne','ua','Dnipropetrovska',3950.0,36.27,48.18).
city('Cherkaske','ua','Dnipropetrovska',3534.0,35.32,48.75).
city('Chervonohryhorivka','ua','Dnipropetrovska',6444.0,34.54,47.62).
city('Chortomlyk','ua','Dnipropetrovska',1275.0,34.14,47.62).
city('Demuryne','ua','Dnipropetrovska',1256.0,36.48,48.17).
city('Dmytrivka','ua','Dnipropetrovska',3637.0,35.1,48.75).
city('Dniprodzerzhynsk','ua','Dnipropetrovska',248573.0,34.62,48.5).
city('Dnipropetrovsk','ua','Dnipropetrovska',1032816.0,34.98,48.45).
city('Dniprovske','ua','Dnipropetrovska',5594.0,34.23,48.59).
city('Hirnytske','ua','Dnipropetrovska',360.0,34.13,47.71).
city('Holubivka','ua','Dnipropetrovska',3629.0,35.33,48.9).
city('Hubynykha','ua','Dnipropetrovska',5745.0,35.25,48.82).
city('Hvardiyske','ua','Dnipropetrovska',4528.0,35.3,48.73).
city('Ilarionove','ua','Dnipropetrovska',8144.0,35.27,48.41).
city('Inhulets','ua','Dnipropetrovska',37536.0,33.25,47.73).
city('Karnaukhivka','ua','Dnipropetrovska',6227.0,34.73,48.48).
city('Khrystoforivka','ua','Dnipropetrovska',1524.0,34.22,47.92).
city('Kirovske','ua','Dnipropetrovska',7942.0,34.85,48.53).
city('Krynychky','ua','Dnipropetrovska',4557.0,34.45,48.37).
city('Kryvyy Rih','ua','Dnipropetrovska',652376.0,33.35,47.92).
city('Kurylivka','ua','Dnipropetrovska',2451.0,34.58,48.57).
city('Leninske','ua','Dnipropetrovska',3835.0,34.02,47.58).
city('Loboykivka','ua','Dnipropetrovska',2929.0,34.65,48.7).
city('Lozuvatka','ua','Dnipropetrovska',6412.0,33.29,48.06).
city('Lykhivka','ua','Dnipropetrovska',2382.0,33.93,48.68).
city('Mahdalynivka','ua','Dnipropetrovska',6567.0,34.93,48.88).
city('Malomykhaylivka','ua','Dnipropetrovska',2888.0,36.42,48.08).
city('Marhanets','ua','Dnipropetrovska',48209.0,34.64,47.64).
city('Maryanske','ua','Dnipropetrovska',4017.0,33.95,47.55).
city('Maryivka','ua','Dnipropetrovska',342.0,35.22,48.93).
city('Melioratyvne','ua','Dnipropetrovska',4351.0,35.37,48.6).
city('Mezhova','ua','Dnipropetrovska',7817.0,36.73,48.25).
city('Mezhyrich','ua','Dnipropetrovska',3952.0,35.75,48.56).
city('Mohyliv','ua','Dnipropetrovska',3923.0,34.5,48.84).
city('Mykolayivka','ua','Dnipropetrovska',4157.0,36.33,48.41).
city('Nikopol','ua','Dnipropetrovska',130346.0,34.4,47.57).
city('Novomoskovsk','ua','Dnipropetrovska',71214.0,35.2,48.62).
city('Novomykolayivka','ua','Dnipropetrovska',3860.0,34.36,48.56).
city('Novopavlivka','ua','Dnipropetrovska',3298.0,36.78,48.14).
city('Novopokrovka','ua','Dnipropetrovska',2092.0,34.62,48.05).
city('Ordzhonikidze','ua','Dnipropetrovska',43167.0,34.02,47.69).
city('Orlivshchyna','ua','Dnipropetrovska',4717.0,35.33,48.64).
city('Pavlohrad','ua','Dnipropetrovska',115931.0,35.87,48.52).
city('Pereshchepyne','ua','Dnipropetrovska',9668.0,35.37,49.02).
city('Pershotravensk','ua','Dnipropetrovska',28056.0,36.38,48.35).
city('Petropavlivka','ua','Dnipropetrovska',8912.0,36.43,48.45).
city('Petrykivka','ua','Dnipropetrovska',4896.0,34.63,48.72).
city('Pidhorodne','ua','Dnipropetrovska',17103.0,35.12,48.58).
city('Pishchanka','ua','Dnipropetrovska',4071.0,35.27,48.6).
city('Pokrovske','ua','Dnipropetrovska',11266.0,36.23,47.97).
city('Prosyana','ua','Dnipropetrovska',5432.0,34.82,47.63).
city('Pushkarivka','ua','Dnipropetrovska',3244.0,34.25,48.67).
city('Pyatykhatky','ua','Dnipropetrovska',19798.0,33.71,48.41).
city('Pysmenne','ua','Dnipropetrovska',1248.0,35.81,48.22).
city('Radushne','ua','Dnipropetrovska',3244.0,33.55,47.8).
city('Rozdory','ua','Dnipropetrovska',1782.0,35.71,48.32).
city('Sad','ua','Dnipropetrovska',461.0,35.27,48.42).
city('Shchorsk','ua','Dnipropetrovska',2979.0,34.12,48.4).
city('Sholokhove','ua','Dnipropetrovska',3097.0,34.05,47.7).
city('Shyroke','ua','Dnipropetrovska',10920.0,33.27,47.68).
city('Slavhorod','ua','Dnipropetrovska',2450.0,35.52,48.1).
city('Sofiyivka','ua','Dnipropetrovska',8017.0,33.89,48.05).
city('Solone','ua','Dnipropetrovska',7304.0,34.87,48.22).
city('Spasskoye','ua','Dnipropetrovska',3017.0,35.03,48.67).
city('Sursko-Lytovske','ua','Dnipropetrovska',4099.0,34.93,48.32).
city('Synelnykove','ua','Dnipropetrovska',31101.0,35.52,48.33).
city('Taromske','ua','Dnipropetrovska',15249.0,34.78,48.45).
city('Ternivka','ua','Dnipropetrovska',28139.0,36.09,48.52).
city('Tomakivka','ua','Dnipropetrovska',8006.0,34.74,47.81).
city('Tsarychanka','ua','Dnipropetrovska',7638.0,34.48,48.95).
city('Vasylkivka','ua','Dnipropetrovska',11661.0,36.03,48.2).
city('Verbky','ua','Dnipropetrovska',3661.0,35.9,48.58).
city('Verkhivtseve','ua','Dnipropetrovska',9765.0,34.26,48.49).
city('Verkhnodniprovsk','ua','Dnipropetrovska',16345.0,34.33,48.65).
city('Vilnohirsk','ua','Dnipropetrovska',22898.0,34.02,48.48).
city('Vyshchetarasivka','ua','Dnipropetrovska',3651.0,34.88,47.57).
city('Vyshneve','ua','Dnipropetrovska',2467.0,33.92,48.44).
city('Yuryivka','ua','Dnipropetrovska',2452.0,36.03,48.73).
city('Zelene','ua','Dnipropetrovska',1009.0,33.25,47.75).
city('Zelenodolsk','ua','Dnipropetrovska',14242.0,33.68,47.6).
city('Zhovti Vody','ua','Dnipropetrovska',51559.0,33.51,48.34).
city('Znamenivka','ua','Dnipropetrovska',4230.0,35.47,48.66).
city('Amvrosiyivka','ua','Donetsk',21307.0,38.48,47.79).
city('Andriyivka','ua','Donetsk',3201.0,37.64,47.42).
city('Artemove','ua','Donetsk',6475.0,37.88,48.37).
city('Artyomovsk','ua','Don',80509.0,38.01,48.59).
city('Avdiyivka','ua','Donetsk',35826.0,37.74,48.14).
city('Bilenke','ua','Donetsk',9760.0,37.63,48.77).
city('Biletske','ua','Donetsk',9718.0,37.18,48.44).
city('Bilozerske','ua','Donetsk',17204.0,37.08,48.52).
city('Blagodatnoye','ua','Donetsk',1263.0,37.43,47.71).
city('Blahodatne','ua','Donetsk',3512.0,38.48,47.88).
city('Bulavynske','ua','Donetsk',3544.0,38.39,48.28).
city('Bylbasivka','ua','Donetsk',6545.0,37.5,48.85).
city('Chasiv Yar','ua','Donetsk',15994.0,37.85,48.58).
city('Cherkaske','ua','Donetsk',3703.0,37.38,48.83).
city('Debaltseve','ua','Donetsk',29121.0,38.4,48.34).
city('Dmytrivka','ua','Donetsk',3170.0,38.93,47.93).
city('Dobropillya','ua','Donetsk',34313.0,37.11,48.48).
city('Dokuchayivsk','ua','Donetsk',23476.0,37.67,47.73).
city('Donetske','ua','Donetsk',678.0,37.67,48.93).
city('Donske','ua','Donetsk',5141.0,37.53,47.52).
city('Drobysheve','ua','Donetsk',3487.0,37.73,49.04).
city('Druzhkivka','ua','Donetsk',62314.0,37.55,48.62).
city('Druzhne','ua','Donetsk',671.0,38.3,48.18).
city('Dymytrov','ua','Donetsk',52480.0,37.28,48.27).
city('Dzerzhinsk','ua','Donetsk',41758.0,37.83,48.4).
city('Gornyak','ua','Donetsk',8846.0,37.37,48.05).
city('Hirne','ua','Donetsk',3741.0,38.2,48.06).
city('Holmovske','ua','Donetsk',7469.0,38.08,48.4).
city('Horbachevo-Mykhaylivka','ua','Donetsk',797.0,38.02,47.85).
city('Horlivka','ua','Donetsk',278548.0,38.05,48.3).
city('Hranitne','ua','Donetsk',3443.0,37.87,47.45).
city('Hrodivka','ua','Donetsk',3004.0,37.49,48.42).
city('Hruzko-Lomivka','ua','Donetsk',685.0,38.1,47.9).
city('Hruzko-Zoryanske','ua','Donetsk',1433.0,38.09,47.94).
city('Ilovaysk','ua','Donetsk',16965.0,38.19,47.93).
city('Karlo-Marksove','ua','Donetsk',10908.0,38.14,48.27).
city('Keramik','ua','Donetsk',469.0,37.68,48.25).
city('Khartsyzk','ua','Donetsk',63175.0,38.14,48.04).
city('Kirove','ua','Donetsk',11310.0,37.94,48.4).
city('Kirovsk','ua','Donetsk',2811.0,37.93,49.02).
city('Kirovske','ua','Donetsk',29761.0,38.36,48.15).
city('Komsomolskoye','ua','Donetsk',12337.0,38.05,47.68).
city('Komsomolskyy','ua','Donetsk',502.0,37.4,47.67).
city('Kontarne','ua','Donetsk',1938.0,38.52,48.08).
city('Korsun','ua','Donetsk',3008.0,38.1,48.2).
city('Kostyantynivka','ua','Donetsk',91258.0,37.72,48.53).
city('Kramatorsk','ua','Donetsk',176106.0,37.53,48.72).
city('Krasna Hora','ua','Donetsk',656.0,38.01,48.66).
city('Krasna Polyana','ua','Donetsk',4393.0,37.07,47.58).
city('Krasnoarmeysk','ua','Donetsk',68263.0,37.18,48.28).
city('Krasnohorivka','ua','Donetsk',16093.0,37.51,48.02).
city('Krasnotorka','ua','Donetsk',3061.0,37.52,48.68).
city('Krasnyy Lyman','ua','Donetsk',27124.0,37.81,48.99).
city('Krasnyy Oktyabr','ua','Donetsk',979.0,38.19,48.24).
city('Krynychna','ua','Donetsk',4530.0,38.04,48.14).
city('Kurakhove','ua','Donetsk',20680.0,37.27,47.98).
city('Kurdyumivka','ua','Donetsk',1118.0,37.97,48.47).
city('Kuteynykove','ua','Donetsk',2076.0,38.29,47.81).
city('Laryne','ua','Donetsk',2854.0,37.93,47.88).
city('Leninske','ua','Donetsk',1878.0,38.44,47.76).
city('Lesnoye','ua','Donetsk',166.0,38.13,48.1).
city('Luhanske','ua','Donetsk',2507.0,37.1,47.37).
city('Lymanchuk','ua','Donetsk',919.0,38.81,48.02).
city('Makiyivka','ua','Donetsk',376607.0,37.97,48.03).
city('Malotaranivka','ua','Donetsk',3729.0,37.52,48.67).
city('Manhush','ua','Donetsk',8153.0,37.3,47.05).
city('Mariupol','ua','Donetsk',481623.0,37.55,47.1).
city('Maryinka','ua','Donetsk',10323.0,37.54,47.93).
city('Moskovske','ua','Donetsk',891.0,38.55,48.12).
city('Mospyne','ua','Donetsk',11300.0,38.06,47.89).
city('Mykolayivka','ua','Donetsk',16002.0,37.68,47.65).
city('Myrne','ua','Donetsk',2032.0,37.73,47.44).
city('Myronivskyy','ua','Donetsk',8457.0,38.27,48.46).
city('Nelipivka','ua','Donetsk',1240.0,37.77,48.33).
city('Novhorodske','ua','Donetsk',11484.0,37.83,48.33).
city('Novoamvrosiyivske','ua','Donetsk',2486.0,38.5,47.84).
city('Novoazovsk','ua','Donetsk',12230.0,38.08,47.12).
city('Novoekonomichna','ua','Donetsk',3375.0,37.34,48.33).
city('Novohrodivka','ua','Donetsk',16823.0,37.35,48.2).
city('Novohryhorivka','ua','Donetsk',390.0,38.42,48.37).
city('Novotroyitske','ua','Donetsk',7414.0,37.22,48.58).
city('Novyy Svit','ua','Donetsk',9488.0,38.02,47.81).
city('Nyzhnya Krynka','ua','Donetsk',14253.0,38.17,48.11).
city('Oleksandrivka','ua','Donetsk',4042.0,37.25,48.31).
city('Oleksiyivo-Druzhkivka','ua','Donetsk',7648.0,37.59,48.62).
city('Olenivka','ua','Donetsk',2812.0,37.97,48.06).
city('Olhinka','ua','Donetsk',3420.0,37.52,47.7).
city('Olkhovatka','ua','Donetsk',3551.0,38.41,48.25).
city('Panteleymonivka','ua','Donetsk',7711.0,37.99,48.2).
city('Pelahiyivka','ua','Donetsk',17509.0,38.58,48.13).
city('Pervomayskyy','ua','Donetsk',2922.0,38.79,47.98).
city('Rayhorodok','ua','Donetsk',3734.0,37.72,48.9).
city('Rayske','ua','Donetsk',1004.0,37.42,48.57).
city('Rodynske','ua','Donetsk',11550.0,37.19,48.34).
city('Rozsypne','ua','Donetsk',4911.0,38.58,48.15).
city('Sartana','ua','Donetsk',10543.0,37.7,47.18).
city('Selidove','ua','Donetsk',25797.0,37.3,48.13).
city('Serdyte','ua','Donetsk',1920.0,38.4,48.04).
city('Shabelkivka','ua','Donetsk',4191.0,37.48,48.75).
city('Shakhtne','ua','Donetsk',975.0,38.27,47.99).
city('Shakhtyorsk','ua','Donetsk',54375.0,38.47,48.05).
city('Shcherbynivka','ua','Donetsk',3868.0,37.78,48.4).
city('Shevchenko','ua','Donetsk',2023.0,38.03,48.69).
city('Shyroke','ua','Donetsk',1001.0,38.23,47.96).
city('Siversk','ua','Donetsk',13858.0,38.11,48.87).
city('Slavyansk','ua','Donetsk',120858.0,37.62,48.87).
city('Slovyanohirsk','ua','Donetsk',4945.0,37.58,49.55).
city('Snizhne','ua','Donetsk',55587.0,38.77,48.02).
city('Soledar','ua','Donetsk',12662.0,38.1,48.68).
city('Starobesheve','ua','Donetsk',6917.0,38.03,47.76).
city('Staromlynivka','ua','Donetsk',3242.0,36.83,47.68).
city('Staromykhaylivka','ua','Donetsk',5126.0,37.58,47.98).
city('Staryy Krym','ua','Donetsk',5977.0,37.5,47.17).
city('Stizhkivske','ua','Donetsk',4480.0,38.5,48.11).
city('Svitlodarske','ua','Donetsk',12694.0,38.22,48.4).
city('Svyatohorivka','ua','Donetsk',2013.0,37.05,48.48).
city('Syedove','ua','Donetsk',2667.0,38.16,47.08).
city('Syeverne','ua','Donetsk',10664.0,38.73,48.07).
city('Talakivka','ua','Donetsk',4005.0,37.72,47.18).
city('Telmanove','ua','Donetsk',5139.0,38.02,47.41).
city('Torez','ua','Donetsk',68037.0,38.59,48.04).
city('Troyitsko-Khartsyzk','ua','Donetsk',1137.0,38.27,47.97).
city('Tsukuryne','ua','Donetsk',2313.0,37.32,48.1).
city('Udachne','ua','Donetsk',1652.0,36.98,48.23).
city('Ukrayinsk','ua','Donetsk',12744.0,37.39,48.1).
city('Velyka Novosilka','ua','Donetsk',7214.0,36.83,47.84).
city('Verkhnotoretske','ua','Donetsk',3026.0,37.89,48.23).
city('Vodyanske','ua','Donetsk',1653.0,37.08,48.4).
city('Volnovakha','ua','Donetsk',23731.0,37.49,47.6).
city('Volodarske','ua','Donetsk',8491.0,37.33,47.2).
city('Volodymyrivka','ua','Donetsk',6974.0,37.39,47.72).
city('Voykove','ua','Donetsk',59.0,38.22,47.97).
city('Voykovskyy','ua','Donetsk',1421.0,38.33,47.77).
city('Vuhledar','ua','Donetsk',16792.0,37.22,47.8).
city('Vuhlehirsk','ua','Donetsk',9926.0,38.27,48.31).
city('Vuhlyar','ua','Donetsk',1196.0,38.15,48.02).
city('Vysoke','ua','Donetsk',553.0,38.06,47.95).
city('Yalta','ua','Donetsk',5519.0,37.28,46.96).
city('Yampil','ua','Donetsk',2209.0,37.97,48.93).
city('Yarova','ua','Donetsk',2106.0,37.64,49.06).
city('Yasna Polyana','ua','Donetsk',2170.0,37.53,48.75).
city('Yasnohirka','ua','Donetsk',8257.0,37.55,48.78).
city('Yasynivka','ua','Donetsk',4005.0,37.96,48.14).
city('Yasynuvata','ua','Donetsk',36156.0,37.88,48.12).
city('Yenakiyive','ua','Donetsk',99423.0,38.22,48.23).
city('Yunokomunarivsk','ua','Donetsk',17151.0,38.29,48.22).
city('Zalisne','ua','Donetsk',2539.0,38.79,48.03).
city('Zaytseve','ua','Donetsk',3868.0,38.06,48.54).
city('Zemlyanky','ua','Donetsk',2130.0,37.92,48.12).
city('Zhdanivka','ua','Donetsk',13179.0,38.26,48.16).
city('Zhelanne','ua','Donetsk',1540.0,37.43,48.22).
city('Zuhres','ua','Donetsk',19121.0,38.27,48.02).
city('Zuyivka','ua','Donetsk',3532.0,38.25,48.06).
city('Bili Oslavy','ua','Ivano-Frankivska',4351.0,24.7,48.49).
city('Bilshivtsi','ua','Ivano-Frankivska',2174.0,24.74,49.18).
city('Bohorodchany','ua','Ivano-Frankivska',7328.0,24.54,48.81).
city('Bolekhiv','ua','Ivano-Frankivska',10238.0,23.87,49.07).
city('Broshniv-Osada','ua','Ivano-Frankivska',5548.0,24.19,48.99).
city('Bukachivtsi','ua','Ivano-Frankivska',1451.0,24.5,49.25).
city('Burshtyn','ua','Ivano-Frankivska',14729.0,24.63,49.27).
city('Bytkiv','ua','Ivano-Frankivska',4112.0,24.46,48.63).
city('Chernelytsya','ua','Ivano-Frankivska',1809.0,25.43,48.81).
city('Cherniyiv','ua','Ivano-Frankivska',3801.0,24.71,48.86).
city('Chernyatyn','ua','Ivano-Frankivska',3046.0,25.45,48.66).
city('Chornoliztsi','ua','Ivano-Frankivska',2965.0,24.89,48.83).
city('Chortovets','ua','Ivano-Frankivska',2904.0,25.28,48.7).
city('Delyatyn','ua','Ivano-Frankivska',7980.0,24.63,48.53).
city('Dolyna','ua','Ivano-Frankivska',20129.0,24.02,48.8).
city('Halych','ua','Ivano-Frankivska',6253.0,24.73,49.12).
city('Holyn','ua','Ivano-Frankivska',4896.0,24.25,49.02).
city('Horodenka','ua','Ivano-Frankivska',9430.0,25.5,48.67).
city('Hvizd','ua','Ivano-Frankivska',3311.0,24.55,48.69).
city('Hvizdets','ua','Ivano-Frankivska',1851.0,25.27,48.59).
city('Ivano-Frankivsk','ua','Ivano-Frankivska',217544.0,24.71,48.92).
city('Kalush','ua','Ivano-Frankivska',67697.0,24.37,49.02).
city('Khymchyn','ua','Ivano-Frankivska',3124.0,25.16,48.38).
city('Kolomyya','ua','Ivano-Frankivska',61780.0,25.04,48.53).
city('Kosiv','ua','Ivano-Frankivska',7992.0,25.1,48.32).
city('Kosmach','ua','Ivano-Frankivska',5822.0,24.83,48.36).
city('Krasna','ua','Ivano-Frankivska',3096.0,24.7,48.58).
city('Kuty','ua','Ivano-Frankivska',4160.0,25.18,48.25).
city('Lanchyn','ua','Ivano-Frankivska',7718.0,24.76,48.55).
city('Lysets','ua','Ivano-Frankivska',2732.0,24.61,48.87).
city('Manyava','ua','Ivano-Frankivska',3333.0,24.37,48.66).
city('Markova','ua','Ivano-Frankivska',2896.0,24.42,48.69).
city('Nadvirna','ua','Ivano-Frankivska',20154.0,24.58,48.63).
city('Nebyliv','ua','Ivano-Frankivska',3282.0,24.22,48.81).
city('Novytsya','ua','Ivano-Frankivska',3564.0,24.33,48.96).
city('Nyzhniy Strutyn','ua','Ivano-Frankivska',2892.0,24.12,48.94).
city('Obertyn','ua','Ivano-Frankivska',3264.0,25.17,48.7).
city('Otyniya','ua','Ivano-Frankivska',5205.0,24.85,48.74).
city('Pasichna','ua','Ivano-Frankivska',4530.0,24.41,48.57).
city('Pechenizhyn','ua','Ivano-Frankivska',5126.0,24.88,48.52).
city('Perehinske','ua','Ivano-Frankivska',11838.0,24.19,48.81).
city('Petranka','ua','Ivano-Frankivska',2929.0,24.3,48.91).
city('Pistyn','ua','Ivano-Frankivska',3761.0,25.03,48.36).
city('Pniv','ua','Ivano-Frankivska',4443.0,24.54,48.62).
city('Porohy','ua','Ivano-Frankivska',3004.0,24.27,48.69).
city('Pyadyky','ua','Ivano-Frankivska',3426.0,25.06,48.0).
city('Radcha','ua','Ivano-Frankivska',2927.0,24.65,48.86).
city('Rohatyn','ua','Ivano-Frankivska',8287.0,24.61,49.41).
city('Rosilna','ua','Ivano-Frankivska',3010.0,24.38,48.77).
city('Rozhniv','ua','Ivano-Frankivska',5351.0,25.23,48.37).
city('Rozhnyativ','ua','Ivano-Frankivska',3983.0,24.16,48.94).
city('Sadzhavka','ua','Ivano-Frankivska',3278.0,24.82,48.58).
city('Snyatyn','ua','Ivano-Frankivska',10089.0,25.57,48.45).
city('Solotvyn','ua','Ivano-Frankivska',3803.0,24.42,48.71).
city('Spas','ua','Ivano-Frankivska',2976.0,24.06,48.88).
city('Stari Bohorodchany','ua','Ivano-Frankivska',3426.0,24.53,48.83).
city('Stari Kuty','ua','Ivano-Frankivska',5068.0,25.18,48.28).
city('Staryy Lysets','ua','Ivano-Frankivska',3617.0,24.59,48.88).
city('Stetseva','ua','Ivano-Frankivska',3076.0,25.57,48.53).
city('Svarychiv','ua','Ivano-Frankivska',4845.0,24.19,48.96).
city('Tysmenychany','ua','Ivano-Frankivska',2944.0,24.67,48.78).
city('Tysmenytsya','ua','Ivano-Frankivska',9426.0,24.85,48.9).
city('Uhryniv','ua','Ivano-Frankivska',3090.0,24.7,48.96).
city('Velykyy Klyuchiv','ua','Ivano-Frankivska',3290.0,24.95,48.47).
city('Verbovets','ua','Ivano-Frankivska',3263.0,25.13,48.33).
city('Verkhovyna','ua','Ivano-Frankivska',5290.0,24.8,48.16).
city('Vorokhta','ua','Ivano-Frankivska',3853.0,24.57,48.29).
city('Voynyliv','ua','Ivano-Frankivska',2673.0,24.5,49.13).
city('Vyhoda','ua','Ivano-Frankivska',2172.0,23.9,48.92).
city('Yabluniv','ua','Ivano-Frankivska',1798.0,24.95,48.4).
city('Yamnytsya','ua','Ivano-Frankivska',3223.0,24.71,48.99).
city('Yaremche','ua','Ivano-Frankivska',7558.0,24.55,48.46).
city('Yasen','ua','Ivano-Frankivska',3427.0,24.15,48.73).
city('Yaseniv-Pilnyy','ua','Ivano-Frankivska',3145.0,25.52,48.63).
city('Zabolotiv','ua','Ivano-Frankivska',4029.0,25.29,48.47).
city('Zahvizdya','ua','Ivano-Frankivska',3546.0,24.65,48.92).
city('Zarechye','ua','Ivano-Frankivska',3832.0,24.65,48.52).
city('Zhovten','ua','Ivano-Frankivska',2960.0,24.78,49.03).
city('Andriyivka','ua','Kharkivska',9335.0,36.64,49.54).
city('Babayi','ua','Kharkivska',7060.0,36.2,49.88).
city('Balakliya','ua','Kharkivska',31156.0,36.86,49.47).
city('Barvinkove','ua','Kharkivska',12344.0,37.02,48.9).
city('Berezivka','ua','Kharkivska',1618.0,35.7,49.45).
city('Bezlyudivka','ua','Kharkivska',9294.0,36.28,49.88).
city('Bilyy Kolodyaz','ua','Kharkivska',4501.0,37.11,50.21).
city('Blyznyuky','ua','Kharkivska',4824.0,36.55,48.87).
city('Bohodukhiv','ua','Kharkivska',17817.0,35.52,50.16).
city('Borova','ua','Kharkivska',6589.0,37.62,49.38).
city('Budy','ua','Kharkivska',6742.0,36.02,49.9).
city('Chapayeve','ua','Kharkivska',2800.0,35.87,49.37).
city('Cherkaska Lozova','ua','Kharkivska',3972.0,36.23,50.1).
city('Chervonyy Oskil','ua','Kharkivska',3081.0,37.42,49.18).
city('Chkalovske','ua','Kharkivska',3924.0,36.92,49.72).
city('Chuhuyiv','ua','Kharkivska',36519.0,36.69,49.84).
city('Dergachi','ua','Kharkivska',19321.0,36.12,50.11).
city('Dvorichna','ua','Kharkivska',4322.0,37.69,49.85).
city('Eskhar','ua','Kharkivska',5349.0,36.59,49.8).
city('Huty','ua','Kharkivska',1978.0,35.34,50.13).
city('Izyum','ua','Kharkivska',53778.0,37.26,49.21).
city('Kehychivka','ua','Kharkivska',6404.0,35.78,49.28).
city('Khorosheve','ua','Kharkivska',4432.0,36.17,49.87).
city('Kivsharivka','ua','Kharkivska',19738.0,37.7,49.62).
city('Kochetok','ua','Kharkivska',3481.0,36.74,49.88).
city('Kolomak','ua','Kharkivska',3712.0,35.3,49.83).
city('Komsomolske','ua','Kharkivska',15342.0,36.5,49.61).
city('Korobochkyne','ua','Kharkivska',2971.0,36.82,49.78).
city('Korotych','ua','Kharkivska',4889.0,36.03,49.94).
city('Kostyantynivka','ua','Kharkivska',1880.0,35.1,49.95).
city('Kovyahy','ua','Kharkivska',3414.0,35.55,49.9).
city('Kozacha Lopan','ua','Kharkivska',5652.0,36.19,50.34).
city('Kr','ua','Kharkivska',21426.0,35.45,49.37).
city('Krasnokutsk','ua','Kharkivska',7844.0,35.16,50.05).
city('Krasnopavlivka','ua','Kharkivska',7495.0,36.33,49.14).
city('Kulynychi','ua','Kharkivska',2981.0,36.38,49.98).
city('Kupyansk','ua','Kharkivska',31397.0,37.6,49.72).
city('Kupyansk-Vuzlovyy','ua','Kharkivska',9311.0,37.67,49.66).
city('Kurylivka','ua','Kharkivska',3226.0,37.72,49.66).
city('Lozova','ua','Kharkivska',62311.0,36.38,48.88).
city('Lyman','ua','Kharkivska',4008.0,36.47,49.6).
city('Lyptsi','ua','Kha',4052.0,36.43,50.21).
city('Lyubotyn','ua','Kharkivska',22545.0,35.97,49.95).
city('Mala Danylivka','ua','Kharkivska',7211.0,36.16,50.07).
city('Malynivka','ua','Kharkivska',7502.0,36.72,49.8).
city('Manchenky','ua','Kharkivska',1147.0,35.87,49.98).
city('Merefa','ua','Kharkivska',23679.0,36.05,49.82).
city('Natalyne','ua','Kharkivska',3420.0,35.53,49.25).
city('Nova Vodolaha','ua','Kharkivska',13112.0,35.87,49.72).
city('Novopokrovka','ua','Kharkivska',4841.0,36.55,49.84).
city('Orilka','ua','Kharkivska',3685.0,36.01,48.99).
city('Panyutyne','ua','Kharkivska',7038.0,36.28,48.93).
city('Parkhomivka','ua','Kharkivska',3485.0,34.99,50.11).
city('Pechenihy','ua','Kharkivska',5814.0,36.93,49.87).
city('Peresichna','ua','Kharkivska',6894.0,35.98,50.02).
city('Pervomayskyy','ua','Kharkivska',30832.0,36.22,49.38).
city('Petrivske','ua','Kharkivska',3163.0,36.9,49.18).
city('Pishchanka','ua','Kharkivska',5195.0,35.44,49.4).
city('Pisochyn','ua','Kharkivska',17489.0,36.1,49.95).
city('Pivdenne','ua','Kharkivska',8053.0,36.07,49.88).
city('Pokotylivka','ua','Kharkivska',9962.0,36.18,49.92).
city('Prudyanka','ua','Kharkivska',1924.0,36.17,50.24).
city('Prykolotne','ua','Kharkivska',2499.0,37.35,50.16).
city('Rohan','ua','Kharkivska',4839.0,36.49,49.94).
city('Ruska Lozova','ua','Kharkivska',4829.0,36.29,50.14).
city('Sakhnovshchyna','ua','Kharkivska',8188.0,35.88,49.13).
city('Savyntsi','ua','Kharkivska',5326.0,37.06,49.4).
city('Sharivka','ua','Kharkivska',1878.0,35.44,50.01).
city('Shevchenkove','ua','Kharkivska',7090.0,37.17,49.7).
city('Slatyne','ua','Kharkivska',6544.0,36.16,50.22).
city('Solonytsivka','ua','Kharkivska',12378.0,36.05,49.99).
city('Starovirivka','ua','Kharkivska',3399.0,35.75,49.55).
city('Staryy Merchyk','ua','Kharkivska',1709.0,35.78,49.97).
city('Staryy Saltiv','ua','Kharkivska',3776.0,36.79,50.08).
city('Taranivka','ua','Kharkivska',4878.0,36.15,49.62).
city('Ternova','ua','Kharkivska',2968.0,36.68,50.18).
city('Utkivka','ua','Kharkivska',1272.0,36.08,49.79).
city('Valky','ua','Kharkivska',10099.0,35.62,49.83).
city('Vasyshcheve','ua','Kharkivska',5862.0,36.33,49.83).
city('Velykyy Burluk','ua','Kharkivska',4821.0,37.38,50.06).
city('Verbivka','ua','Kharkivska',3377.0,35.53,49.42).
city('Volchansk','ua','Kharkivska',19485.0,36.95,50.3).
city('Vvedenka','ua','Kharkivska',2628.0,36.5,49.83).
city('Vysokyy','ua','Kharkivska',10988.0,36.12,49.89).
city('Zachepylivka','ua','Kharkivska',4217.0,35.23,49.2).
city('Zidky','ua','Kharkivska',3933.0,36.42,49.69).
city('Zmiyiv','ua','Kharkivska',16095.0,36.38,49.7).
city('Zolochiv','ua','Kharkivska',11160.0,35.98,50.27).
city('Antonivka','ua','Khersonska',12488.0,32.77,46.69).
city('Arkhanhelske','ua','Khersonska',2162.0,33.4,47.43).
city('Askaniya-Nova','ua','Khersonska',3309.0,33.86,46.45).
city('Bekhtery','ua','Khersonska',2909.0,32.29,46.25).
city('Beryslav','ua','Khersonska',14880.0,33.42,46.84).
city('Bilozerka','ua','Khersonska',9348.0,32.44,46.63).
city('Brylivka','ua','Khersonska',4305.0,33.15,46.43).
city('Chaplynka','ua','Khersonska',10224.0,33.54,46.36).
city('Chornobayivka','ua','Khersonska',8954.0,32.55,46.68).
city('Chornyanka','ua','Khersonska',3363.0,33.36,46.65).
city('Chulakivka','ua','Khersonska',2938.0,32.36,46.36).
city('Dnipryany','ua','Khersonska',4537.0,33.27,46.74).
city('Henichesk','ua','Khersonska',20983.0,34.81,46.18).
city('Hola Prystan','ua','Khersonska',15432.0,32.53,46.52).
city('Hornostayivka','ua','Khersonska',6762.0,33.73,47.02).
city('Ivanivka','ua','Khersonska',5036.0,34.55,46.71).
city('Kakhovka','ua','Khersonska',36816.0,33.48,46.81).
city('Kalanchak','ua','Khersonska',10673.0,33.3,46.25).
city('Kalininske','ua','Khersonska',1521.0,32.98,47.12).
city('Karyerne','ua','Khersonska',474.0,33.22,47.32).
city('Kayiry','ua','Khersonska',3364.0,33.7,46.93).
city('Kherson','ua','Khersonska',320476.0,32.6,46.63).
city('Komyshany','ua','Khersonska',6978.0,32.51,46.64).
city('Kozachi Laheri','ua','Khersonska',3587.0,32.98,46.71).
city('Kozatske','ua','Khersonska',3739.0,33.34,46.78).
city('Krasne','ua','Khersonska',2898.0,32.78,46.12).
city('Lazurne','ua','Khersonska',3127.0,32.53,46.07).
city('Lyubymivka','ua','Khersonska',5786.0,33.59,46.8).
city('Malokakhovka','ua','Khersonska',2862.0,33.45,46.78).
city('Myrne','ua','Khersonska',2036.0,33.45,46.5).
city('Naddnipryanske','ua','Khersonska',1147.0,32.7,46.73).
city('Nova Kakhovka','ua','Khersonska',50672.0,33.38,46.75).
city('Nova Mayachka','ua','Khersonska',7238.0,33.23,46.6).
city('Nova Zburyivka','ua','Khersonska',7263.0,32.46,46.46).
city('Novomykolayivka','ua','Khersonska',3465.0,34.01,46.5).
city('Novooleksiyivka','ua','Khersonska',9852.0,34.64,46.23).
city('Novotroyitske','ua','Khersonska',11424.0,34.33,46.35).
city('Novovorontsovka','ua','Khersonska',6847.0,33.93,47.5).
city('Nyzhni Sirohozy','ua','Khersonska',5797.0,34.38,46.84).
city('Partyzany','ua','Khersonska',3738.0,34.75,46.33).
city('Radensk','ua','Khersonska',3804.0,32.93,46.55).
city('Skadovsk','ua','Khersonska',18911.0,32.92,46.12).
city('Stanislav','ua','Khersonska',4726.0,32.15,46.57).
city('Syvaske','ua','Khersonska',4733.0,34.55,46.39).
city('Tavriysk','ua','Khersonska',11026.0,33.42,46.77).
city('Tsyurupynsk','ua','Khersonska',23226.0,32.71,46.62).
city('Velyka Lepetykha','ua','Khersonska',9511.0,33.95,47.18).
city('Velyka Oleksandrivka','ua','Khersonska',7281.0,33.32,47.32).
city('Velyki Kopani','ua','Khersonska',5464.0,32.98,46.48).
city('Verkhniy Rohachyk','ua','Khersonska',6557.0,34.33,47.25).
city('Vynohradove','ua','Khersonska',4422.0,32.94,46.36).
city('Vysokopillya','ua','Khersonska',4542.0,33.53,47.48).
city('Zelenivka','ua','Khersonska',5465.0,32.64,46.72).
city('Antoniny','ua','Khmelnytska',2592.0,26.87,49.8).
city('Bazaliya','ua','Khmelnytska',2035.0,26.47,49.72).
city('Derazhnya','ua','Khmelnytska',10058.0,27.43,49.27).
city('Dovzhok','ua','Khmelnytska',4044.0,26.51,48.66).
city('Dunayivtsi','ua','Khmelnytska',9246.0,26.82,48.96).
city('Horodok','ua','Khmelnytska',17086.0,26.57,49.17).
city('Hrytsiv','ua','Khmelnytska',3789.0,27.21,49.96).
city('Izyaslav','ua','Khmelnytska',17758.0,26.8,50.12).
city('Kamyanets-Podilskyy','ua','Khmelnytska',99068.0,26.58,48.68).
city('Krasyliv','ua','Khmelnytska',19815.0,26.97,49.65).
city('Letychiv','ua','Khmelnytska',10669.0,27.62,49.38).
city('Lozove','ua','Khmelnytska',1578.0,27.32,49.32).
city('Makiv','ua','Khmelnytska',3373.0,26.72,48.8).
city('Medzhybizh','ua','Khmelnytska',1667.0,27.42,49.43).
city('Narkevychi','ua','Khmelnytska',1631.0,26.63,49.52).
city('Netishyn','ua','Khmelnytska',33063.0,26.63,50.35).
city('Nova Ushytsya','ua','Khmelnytska',4548.0,27.28,48.83).
city('Novoselytsya','ua','Khmelnytska',3185.0,27.55,50.08).
city('Pluzhne','ua','Khmelnytska',3094.0,26.58,50.18).
city('Polonne','ua','Khmelnytska',22348.0,27.52,50.12).
city('Poninka','ua','Khmelnytska',7642.0,27.53,50.18).
city('Sataniv','ua','Khmelnytska',2512.0,26.27,49.25).
city('Shepetivka','ua','Khmelnytska',46419.0,27.07,50.18).
city('Slavuta','ua','Khmelnytska',33080.0,26.87,50.3).
city('Smotrych','ua','Khmelnytska',2009.0,26.55,48.95).
city('Stara Synyava','ua','Khmelnytska',5771.0,27.62,49.6).
city('Starokostyantyniv','ua','Khmelnytska',33897.0,27.22,49.75).
city('Sudylkiv','ua','Khmelnytska',5062.0,27.13,50.17).
city('Teofipol','ua','Khmelnytska',6895.0,26.42,49.83).
city('Vinkivtsi','ua','Khmelnytska',6685.0,27.23,49.03).
city('Volochysk','ua','Khmelnytska',20179.0,26.17,49.53).
city('Vovkovyntsi','ua','Khmelnytska',2790.0,27.66,49.2).
city('Yampil','ua','Khmelnytska',1996.0,26.25,49.97).
city('Yarmolyntsi','ua','Khmelnytska',8583.0,26.83,49.2).
city('Zakupne','ua','Khmelnytska',1398.0,26.35,49.12).
city('Kiev','ua','Kiev',2514227.0,30.52,50.43).
city('Adzhamka','ua','Kirovohradska',3859.0,32.54,48.54).
city('Aleksandriya','ua','Kirovohradska',91206.0,33.12,48.67).
city('Balakhivka','ua','Kirovohradska',946.0,33.18,48.48).
city('Bobrynets','ua','Kirovohradska',11843.0,32.17,48.05).
city('Bohdanivka','ua','Kirovohradska',4354.0,31.72,48.33).
city('Dmytrivka','ua','Kirovohradska',4070.0,32.72,48.79).
city('Dobryanka','ua','Kirovohradska',6774.0,31.18,48.39).
city('Dolynska','ua','Kirovohradska',18070.0,32.77,48.12).
city('Dymytrove','ua','Kirovohradska',5410.0,32.99,48.61).
city('Hayvoron','ua','Kirovohradska',15526.0,29.85,48.35).
city('Holovanivsk','ua','Kirovohradska',6516.0,30.46,48.38).
city('Kapitanivka','ua','Kirovohradska',2945.0,31.71,48.91).
city('Kirovohrad','ua','Kirovohradska',249453.0,32.26,48.5).
city('Kompaniyivka','ua','Kirovohradska',4934.0,32.21,48.25).
city('Lypnyazhka','ua','Kirovohradska',4272.0,31.08,48.45).
city('Mala Vyska','ua','Kirovohradska',12644.0,31.63,48.65).
city('Molodizhne','ua','Kirovohradska',1541.0,32.66,48.18).
city('Nova Praha','ua','Kirovohradska',7513.0,32.91,48.57).
city('Nove','ua','Kirovohradska',8126.0,32.14,48.55).
city('Novhorodka','ua','Kirovohradska',6405.0,32.66,48.37).
city('Novoarkhanhelsk','ua','Kirovohradska',7355.0,30.82,48.66).
city('Novomyrhorod','ua','Kirovohradska',12728.0,31.65,48.78).
city('Novoukrayinka','ua','Kirovohradska',18633.0,31.52,48.32).
city('Novyy Starodub','ua','Kirovohradska',4777.0,33.16,48.52).
city('Oleksandrivka','ua','Kirovohradska',10687.0,32.24,48.97).
city('Onufriyivka','ua','Kirovohradska',4298.0,33.45,48.9).
city('Pantayivka','ua','Kirovohradska',2918.0,32.88,48.68).
city('Pavlysh','ua','Kirovohradska',4693.0,33.36,48.92).
city('Perehonivka','ua','Kirovohradska',3354.0,30.52,48.53).
city('Petrove','ua','Kirovohradska',8252.0,33.25,48.33).
city('Pobuzke','ua','Kirovohradska',5716.0,30.59,48.17).
city('Pomichna','ua','Kirovohradska',10539.0,31.42,48.24).
city('Pryyutivka','ua','Kirovohradska',3238.0,33.07,48.72).
city('Rivne','ua','Kirovohradska',5296.0,31.75,48.25).
city('Salkove','ua','Kirovohradska',1916.0,29.98,48.25).
city('Smoline','ua','Kirovohradska',9102.0,31.25,48.6).
city('Subottsi','ua','Kirovohradska',3095.0,32.52,48.66).
city('Svitlovodsk','ua','Kirovohradska',47946.0,33.25,49.08).
city('Tyshkivka','ua','Kirovohradska',3368.0,30.93,48.49).
city('Ulyanovka','ua','Kirovohradska',7246.0,30.23,48.33).
city('Ustynivka','ua','Kirovohradska',4003.0,32.53,47.95).
city('Vilshanka','ua','Kirovohradska',5501.0,30.87,48.24).
city('Yelyzavethradka','ua','Kirovohradska',1673.0,32.41,48.8).
city('Zavallya','ua','Kirovohradska',5010.0,30.02,48.2).
city('Zlynka','ua','Kirovohradska',4981.0,31.55,48.48).
city('Znamyanka','ua','Kirovohradska',28318.0,32.66,48.71).
city('Znamyanka Druha','ua','Kirovohradska',5591.0,32.6,48.71).
city('Aeroflotske','ua','Krym',1897.0,34.03,45.02).
city('Ahrarne','ua','Krym',3326.0,34.12,45.07).
city('Alushta','ua','Krym',30271.0,34.42,44.67).
city('Armyansk','ua','Krym',22981.0,33.7,46.11).
city('Azovske','ua','Krym',4155.0,34.57,45.58).
city('Baherove','ua','Krym',4382.0,36.3,45.38).
city('Bakhchysaray','ua','Krym',26525.0,33.87,44.75).
city('Berehove','ua','Krym',500.0,33.62,44.9).
city('Bilohirsk','ua','Krym',18091.0,34.6,45.05).
city('Chornomorske','ua','Krym',11274.0,32.7,45.5).
city('Dobroye','ua','Krym',3327.0,34.23,44.88).
city('Dzhankoy','ua','Krym',41.0,34.41,45.72).
city('Feodosiya','ua','Krym',72051.0,35.38,45.03).
city('Frunze','ua','Krym',2958.0,33.63,45.02).
city('Haspra','ua','Krym',10617.0,34.1,44.43).
city('Hresivske','ua','Krym',9664.0,34.02,45.03).
city('Hurzuf','ua','Krym',8810.0,34.28,44.55).
city('Hvardiyske','ua','Krym',12319.0,34.02,45.13).
city('Ishun','ua','Krym',3312.0,33.82,45.92).
city('Katsiveli','ua','Krym',631.0,34.05,44.42).
city('Kerch','ua','Krym',152194.0,36.48,45.36).
city('Kirovske','ua','Krym',7187.0,33.08,45.54).
city('Koktebel','ua','Krym',2675.0,35.25,44.95).
city('Kolchuhyne','ua','Krym',4130.0,33.78,44.93).
city('Komsomolske','ua','Krym',4112.0,33.48,45.33).
city('Koreyiz','ua','Krym',6286.0,34.08,44.43).
city('Krasnohvardiyske','ua','Krym',10699.0,34.29,45.5).
city('Krasnokamyanka','ua','Krym',1019.0,34.28,44.57).
city('Krasnoperekopsk','ua','Krym',29869.0,33.79,45.96).
city('Kurpaty','ua','Krym',399.0,34.12,44.43).
city('Kuybysheve','ua','Krym',2344.0,33.87,44.65).
city('Lenine','ua','Krym',8297.0,35.78,45.3).
city('Livadiya','ua','Krym',1560.0,34.15,44.47).
city('Masandra','ua','Krym',6966.0,34.18,44.52).
city('Mykhaylivka','ua','Krym',3352.0,36.26,45.28).
city('Mykolayivka','ua','Krym',2573.0,33.62,44.97).
city('Myrne','ua','Krym',5990.0,33.44,45.63).
city('Nauchne','ua','Krym',832.0,34.02,44.73).
city('Nikita','ua','Krym',2291.0,34.23,44.53).
city('Novoselivske','ua','Krym',3146.0,33.6,45.44).
city('Novyy Svit','ua','Krym',1017.0,36.3,45.48).
city('Nyzhnohirskyy','ua','Krym',10077.0,34.73,45.45).
city('Oktyabrske','ua','Krym',10499.0,36.36,45.36).
city('Ordzhonikidze','ua','Krym',2773.0,35.33,44.92).
city('Oreanda','ua','Krym',858.0,34.17,44.47).
city('Orikhove','ua','Krym',3000.0,33.63,45.13).
city('Parkove','ua','Krym',463.0,33.95,44.4).
city('Partenit','ua','Krym',6021.0,34.35,44.58).
city('Perevalne','ua','Krym',3450.0,34.33,44.83).
city('Perove','ua','Krym',3746.0,34.07,44.93).
city('Pervomayske','ua','Krym',3329.0,33.7,45.45).
city('Pervomayskoye','ua','Krym',9014.0,33.86,45.72).
city('Petrivka','ua','Krym',6467.0,34.28,45.51).
city('Pionerske','ua','Krym',6995.0,34.2,44.88).
city('Ponyzivka','ua','Krym',348.0,33.97,44.4).
city('Poshtove','ua','Krym',2882.0,33.95,44.83).
city('Prymorskyy','ua','Krym',13561.0,35.5,45.12).
city('Pryozerne','ua','Krym',3013.0,36.34,45.27).
city('Razdolnoye','ua','Krym',7871.0,33.49,45.77).
city('Rodnykove','ua','Krym',3058.0,33.95,45.05).
city('Sadove','ua','Krym',3104.0,34.64,45.3).
city('Saky','ua','Krym',28322.0,33.6,45.14).
city('Shchebetovka','ua','Krym',3213.0,35.15,44.93).
city('Shcholkine','ua','Krym',11264.0,35.85,45.39).
city('Simferopol','ua','Krym',342483.0,34.1,44.95).
city('Sovyetskyy','ua','Krym',10526.0,34.93,45.33).
city('Staryy Krym','ua','Krym',9725.0,35.1,45.03).
city('Strohonivka','ua','Krym',3447.0,34.19,44.93).
city('Sudak','ua','Krym',13956.0,34.97,44.85).
city('Uhlove','ua','Krym',3283.0,33.62,44.82).
city('Urozhayne','ua','Krym',3404.0,34.1,45.07).
city('Uyutne','ua','Krym',3710.0,33.3,45.2).
city('Viline','ua','Krym',6649.0,33.65,44.85).
city('Vladyslavivka','ua','Krym',3326.0,35.38,45.17).
city('Voskhod','ua','Krym',3510.0,35.32,44.93).
city('Voyinka','ua','Krym',4221.0,33.99,45.87).
city('Voykove','ua','Krym',4100.0,36.43,45.39).
city('Vynohradne','ua','Krym',1221.0,34.09,44.48).
city('Yalta','ua','Krym',79509.0,34.17,44.5).
city('Yarke Pole','ua','Krym',4739.0,35.21,45.22).
city('Yevpatoriya','ua','Krym',105222.0,33.36,45.2).
city('Zaozerne','ua','Krym',4396.0,33.26,45.17).
city('Zhelyabovka','ua','Krym',2930.0,34.75,45.4).
city('Zhuravky','ua','Krym',3068.0,35.23,45.13).
city('Zuya','ua','Krym',6677.0,34.33,45.05).
city('Babyntsi','ua','Kyyivska',2523.0,30.03,50.65).
city('Baryshivka','ua','Kyyivska',10762.0,31.33,50.37).
city('Berezan','ua','Kyyivska',18023.0,31.47,50.32).
city('Bila Tserkva','ua','Kyyivska',199161.0,30.12,49.78).
city('Bilohorodka','ua','Kyyivska',5653.0,50.39,30.22).
city('Bohdanivka','ua','Kyyivska',2894.0,30.92,50.63).
city('Bohuslav','ua','Kyyivska',16498.0,30.88,49.55).
city('Borodyanka','ua','Kyyivska',12069.0,29.98,50.65).
city('Borova','ua','Kyyivska',7315.0,30.1,50.17).
city('Boryspil','ua','Kyyivska',54545.0,30.95,50.35).
city('Boyarka','ua','Kyyivska',34631.0,30.32,50.32).
city('Brovary','ua','Kyyivska',88505.0,30.77,50.5).
city('Bucha','ua','Kyyivska',27472.0,30.21,50.37).
city('Chornobyl','ua','Kyyivska',0.0,30.24,51.28).
city('Demydiv','ua','Kyyivska',3539.0,30.33,50.73).
city('Doslidnytske','ua','Kyyivska',2046.0,30.15,49.92).
city('Dymer','ua','Kyyivska',5653.0,30.3,50.78).
city('Fastiv','ua','Kyyivska',51142.0,29.92,50.08).
city('Hatne','ua','Kyyivska',3004.0,30.4,50.37).
city('Hlevakha','ua','Kyyivska',9301.0,30.33,50.28).
city('Hoholiv','ua','Kyyivska',4361.0,31.02,50.51).
city('Hostomel','ua','Kyyivska',12036.0,30.27,50.58).
city('Hrebinky','ua','Kyyivska',6582.0,30.21,49.95).
city('Irpin','ua','Kyyivska',40788.0,30.25,50.52).
city('Ivankiv','ua','Kyyivska',6735.0,29.91,50.94).
city('Kaharlyk','ua','Kyyivska',13245.0,30.83,49.85).
city('Kalynivka','ua','Kyyivska',4618.0,30.53,50.41).
city('Kalyta','ua','Kyyivska',4794.0,31.01,50.77).
city('Karapyshi','ua','Kyyivska',2960.0,30.78,49.65).
city('Kashperivka','ua','Kyyivska',3359.0,29.68,49.43).
city('Katyuzhanka','ua','Kyyivska',4046.0,30.13,50.82).
city('Khotiv','ua','Kyyi',4569.0,30.47,50.33).
city('Klavdiyevo-Tarasove','ua','Kyyivska',4685.0,30.02,50.58).
city('Knyazhychi','ua','Kyyivska',5010.0,30.77,50.46).
city('Kodra','ua','Kyyivska',1685.0,29.57,50.6).
city('Kotsyubynske','ua','Kyyivska',13462.0,30.36,50.5).
city('Kozhanka','ua','Kyyivska',2584.0,29.77,49.97).
city('Kozyn','ua','Kyyivska',3378.0,30.65,50.24).
city('Krasylivka','ua','Kyyivska',3358.0,30.91,50.52).
city('Makariv','ua','Kyyivska',11594.0,29.82,50.47).
city('Medvyn','ua','Kyyivska',3613.0,30.78,49.38).
city('Myronivka','ua','Kyyivska',12871.0,30.98,49.65).
city('Nemishayeve','ua','Kyyivska',6067.0,30.08,50.57).
city('Novi Petrivtsi','ua','Kyyivska',7427.0,30.45,50.62).
city('Obukhiv','ua','Kyyivska',31557.0,30.63,50.1).
city('Pereyaslav-Khmelnytskyy','ua','Kyyivska',32002.0,31.47,50.08).
city('Petropavlivska Borshchahivka','ua','Kyyivska',5911.0,30.33,50.43).
city('Piskivka','ua','Kyyivska',6889.0,29.65,50.68).
city('Plesetske','ua','Kyyivska',3696.0,30.12,50.22).
city('Prypyat','ua','Kyyivska',0.0,30.1,51.39).
city('Rakitnoye','ua','Kyyivska',13277.0,30.39,49.68).
city('Rozkishna','ua','Kyyivska',3140.0,30.18,49.38).
city('Rzhyshchiv','ua','Kyyivska',7993.0,31.05,49.97).
city('Semypolky','ua','Kyyivska',2939.0,30.93,50.72).
city('Shevchenkove','ua','Kyyivska',3260.0,29.82,51.12).
city('Skvyra','ua','Kyyivska',17452.0,29.67,49.73).
city('Slavutych','ua','Kyyivska',27832.0,30.75,51.55).
city('Stavyshche','ua','Kyyivska',7634.0,29.53,50.4).
city('Synyava','ua','Kyyivska',3459.0,30.47,49.66).
city('Tarashcha','ua','Kyyivs',12952.0,30.51,49.57).
city('Tarasivka','ua','Kyyivska',4899.0,30.32,50.35).
city('Tetiyiv','ua','Kyyivska',14388.0,29.67,49.38).
city('Trebukhiv','ua','Kyyivska',6207.0,30.9,50.48).
city('Trypillya','ua','Kyyivska',2767.0,30.77,50.12).
city('Tsybli','ua','Kyyivska',3512.0,31.55,49.97).
city('Ukrayinka','ua','Kyyivska',13636.0,30.73,50.13).
city('Uzyn','ua','Kyyivska',12726.0,30.41,49.83).
city('Vasylkiv','ua','Kyyivska',39162.0,30.32,50.18).
city('Velyka Dymerka','ua','Kyyivska',9699.0,30.91,50.6).
city('Volodarka','ua','Kyyivska',7355.0,29.92,49.52).
city('Voronkiv','ua','Kyyivska',3888.0,30.9,50.22).
city('Vorzel','ua','Kyyivska',5923.0,30.15,50.55).
city('Vyshhorod','ua','Kyyivska',22080.0,30.5,50.58).
city('Vyshneve','ua','Kyyivska',33183.0,30.37,50.38).
city('Yahotyn','ua','Kyyivska',22779.0,31.77,50.28).
city('Zhurivka','ua','Kyyivska',6369.0,31.78,50.5).
city('Alchevsk','ua','Luhanska',116873.0,38.8,48.47).
city('Almazna','ua','Luhanska',4873.0,39.32,48.06).
city('Antratsyt','ua','Luhanska',61640.0,39.09,48.12).
city('Artemivsk','ua','Luhanska',8759.0,38.74,48.44).
city('Bayrachky','ua','Luhanska',1025.0,38.61,48.39).
city('Beloye','ua','Luhanska',6775.0,39.07,48.49).
city('Bilohorivka','ua','Luhanska',1142.0,38.25,48.93).
city('Bilokurakyne','ua','Luhanska',7712.0,38.7,49.54).
city('Bilolutsk','ua','Luhanska',4094.0,39.01,49.7).
city('Bilorichenskyy','ua','Luhanska',3772.0,39.05,48.46).
city('Bilovodsk','ua','Luhanska',8438.0,39.58,49.2).
city('Biryukove','ua','Luhanska',4250.0,39.74,47.96).
city('Bokove-Platove','ua','Luhanska',2965.0,39.01,48.11).
city('Borivske','ua','Luhanska',5745.0,38.38,48.88).
city('Bryanka','ua','Luhanska',51920.0,38.66,48.51).
city('Buhayivka','ua','Luhanska',3666.0,38.88,48.41).
city('Chelyuskinets','ua','Luhanska',1268.0,39.2,48.44).
city('Chernukhyne','ua','Luhanska',7498.0,38.52,48.33).
city('Chervonohvardiyske','ua','Luhanska',1732.0,38.77,48.59).
city('Chervonopartyzansk','ua','Luhanska',17023.0,39.79,48.08).
city('Chmyrivka','ua','Luhanska',4119.0,38.96,49.29).
city('Donetskyy','ua','Luhanska',4596.0,38.63,48.75).
city('Dubivskyy','ua','Luhanska',4387.0,39.13,48.07).
city('Dzerzhynskyy','ua','Luhanska',8394.0,39.43,48.03).
city('Enhelsove','ua','Luhanska',1152.0,39.62,48.29).
city('Fashchivka','ua','Luhanska',5319.0,38.6,48.29).
city('Fedorivka','ua','Luhanska',396.0,38.47,48.71).
city('Frunze','ua','Luhanska',3605.0,38.76,48.66).
city('Hannivka','ua','Luhanska',346.0,38.54,48.48).
city('Heorhiyivka','ua','Luhanska',6241.0,39.25,48.42).
city('Hirne','ua','Luhanska',216.0,39.62,48.27).
city('Hirnyk','ua','Luhanska',869.0,39.21,48.08).
city('Hirske','ua','Luhanska',11046.0,38.5,48.74).
city('Hlybokyy','ua','Luhanska',233.0,38.57,48.46).
city('Horodyshche','ua','Luhanska',3190.0,39.67,49.06).
city('Hrushove','ua','Luhanska',1145.0,38.77,48.26).
city('Ivanivka','ua','Luhanska',7879.0,38.96,48.22).
city('Izvaryne','ua','Luhanska',2013.0,39.89,48.29).
city('Kalininskyy','ua','Luhanska',1862.0,39.59,48.02).
city('Kalynove','ua','Luhanska',3686.0,38.51,48.56).
city('Kamyane','ua','Luhanska',3116.0,39.16,48.17).
city('Khrustalne','ua','Luhanska',1775.0,38.84,48.16).
city('Kirovsk','ua','Luhanska',33890.0,38.65,48.64).
city('Klenovyy','ua','Luhanska',2259.0,39.46,48.12).
city('Knyahynivka','ua','Luhanska',1233.0,38.86,48.12).
city('Komisarivka','ua','Luhanska',2451.0,39.5,48.47).
city('Komsomolskyy','ua','Luhanska',3339.0,39.67,48.13).
city('Komyshuvakha','ua','Luhanska',2748.0,38.37,48.71).
city('Krasnodon','ua','Luhanska',27569.0,39.66,48.31).
city('Kr','ua','Luhanska',5183.0,38.22,49.22).
city('Krasnyy Kut','ua','Luhanska',2983.0,38.79,48.21).
city('Krasnyy Luch','ua','Luhanska',90004.0,38.93,48.13).
city('Kreminna','ua','Luhanska',23538.0,38.22,49.05).
city('Kripenskyy','ua','Luhanska',7487.0,39.06,48.07).
city('Lenina','ua','Luhanska',1228.0,39.15,48.43).
city('Leninske','ua','Luhanska',3948.0,39.55,48.07).
city('Lomuvatka','ua','Luhanska',1002.0,38.55,48.45).
city('Lotykove','ua','Luhanska',3292.0,38.92,48.53).
city('Lozivskyy','ua','Luhanska',5968.0,38.89,48.56).
city('Lozno-Oleksandrivka','ua','Luhanska',1149.0,38.73,49.83).
city('Luhansk','ua','Luhanska',451997.0,39.33,48.57).
city('Lutuhyne','ua','Luhanska',18133.0,39.21,48.4).
city('Lysychansk','ua','Luhanska',111599.0,38.42,48.92).
city('Malomykolayivka','ua','Luhanska',1959.0,39.03,48.31).
city('Maloryazantseve','ua','Luhanska',947.0,38.39,48.88).
city('Markivka','ua','Luhanska',7087.0,39.57,49.53).
city('Metolkine','ua','Luhanska',511.0,38.55,48.93).
city('Milove','ua','Luhanska',5418.0,40.13,49.38).
city('Miusynsk','ua','Luhanska',5805.0,38.9,48.08).
city('Molodohvardiysk','ua','Luhanska',24579.0,39.73,48.35).
city('Mykhaylivka','ua','Luhanska',2952.0,39.09,48.29).
city('Myrna Dolyna','ua','Luhanska',462.0,38.48,48.81).
city('Myrne','ua','Luhanska',453.0,39.65,48.29).
city('Naholno-Tarasivka','ua','Luhanska',2113.0,39.47,48.01).
city('Novodaryivka','ua','Luhanska',4368.0,39.49,48.06).
city('Novodruzhesk','ua','Luhanska',8689.0,38.35,48.97).
city('Novopskov','ua','Luhanska',9739.0,39.12,49.54).
city('Novosvitlivka','ua','Luhanska',3508.0,39.42,48.51).
city('Nyzhniy Naholchyk','ua','Luhanska',1681.0,39.55,48.01).
city('Nyzhnya Duvanka','ua','Luhanska',2353.0,38.16,49.58).
city('Nyzhnye','ua','Luhanska',2999.0,38.6,48.77).
city('Oleksandrivsk','ua','Luhanska',6783.0,39.2,48.58).
city('Pavlivka','ua','Luhanska',1135.0,38.69,49.61).
city('Perevalsk','ua','Luhanska',28562.0,38.82,48.44).
city('Pervomaysk','ua','Luhanska',41480.0,38.52,48.64).
city('Petrivka','ua','Luhanska',5218.0,39.26,48.8).
city('Petrivske','ua','Luhanska',14902.0,38.92,48.3).
city('Pidhorivka','ua','Luhanska',3581.0,38.89,49.3).
city('Popasna','ua','Luhanska',24986.0,38.38,48.63).
city('Proletarskyy','ua','Luhanska',1506.0,39.31,48.12).
city('Pryvillya','ua','Luhanska',8669.0,38.3,49.01).
city('Rodakove','ua','Luhanska',6434.0,39.02,48.56).
city('Rovenky','ua','Luhanska',51983.0,39.37,48.08).
city('Rozkishne','ua','Luhanska',6205.0,39.28,48.49).
city('Rubizhne','ua','Luhanska',62992.0,38.37,49.02).
city('Sadovo-Khrustalnenskyy','ua','Luhanska',678.0,38.73,48.15).
city('Seleznivka','ua','Luhanska',2828.0,38.77,48.38).
city('Shakhtarske','ua','Luhanska',3988.0,39.11,48.13).
city('Shchastya','ua','Luhanska',13258.0,39.23,48.75).
city('Shchotove','ua','Luhanska',4354.0,39.22,48.22).
city('Shterivka','ua','Luhanska',1598.0,38.95,48.22).
city('Simeykyne','ua','Luhanska',2493.0,39.53,48.33).
city('Slovyanoserbsk','ua','Luhanska',8093.0,38.78,48.66).
city('Sofiyivskyy','ua','Luhanska',4556.0,38.88,48.21).
city('Stakhanov','ua','Luhanska',84425.0,38.65,48.56).
city('Stanychno-Luhanske','ua','Luhanska',13903.0,39.49,48.65).
city('Starobilsk','ua','Luhanska',21539.0,38.91,49.28).
city('Sukhodilsk','ua','Luhanska',22763.0,39.7,48.35).
city('Svatove','ua','Luhanska',18770.0,38.15,49.41).
city('Sverdlovsk','ua','Luhanska',69751.0,39.65,48.08).
city('Syevernyy','ua','Luhanska',2243.0,39.88,48.35).
city('Syevero-Hundorivskyy','ua','Luhanska',1430.0,39.88,48.38).
city('Syeverodonetsk','ua','Luhanska',116991.0,38.5,48.95).
city('Syrotyne','ua','Luhanska',1196.0,38.51,48.91).
city('Talove','ua','Luhanska',1441.0,39.67,48.31).
city('Tatsyne','ua','Luhanska',291.0,39.21,48.07).
city('Teplohirsk','ua','Luhanska',12568.0,38.59,48.6).
city('Toshkivka','ua','Luhanska',4926.0,38.57,48.78).
city('Troitske','ua','Luhanska',8172.0,38.29,49.92).
city('Uralo-Kavkaz','ua','Luhanska',3033.0,39.83,48.3).
city('Uspenka','ua','Luhanska',9400.0,39.16,48.39).
city('Vakhrusheve','ua','Luhanska',14224.0,38.8,48.15).
city('Valuyske','ua','Luhanska',3829.0,39.54,48.67).
city('Velykokamyanka','ua','Luhanska',1213.0,39.44,48.13).
city('Verhulivka','ua','Luhanska',1369.0,38.49,48.4).
city('Verkhniy Naholchyk','ua','Luhanska',1910.0,39.09,48.08).
city('Volodarsk','ua','Luhanska',3089.0,39.59,48.13).
city('Voronove','ua','Luhanska',735.0,38.58,48.9).
city('Vovchoyarivka','ua','Luhanska',1229.0,38.35,49.82).
city('Vrubivka','ua','Luhanska',1117.0,38.39,48.77).
city('Vrubivskyy','ua','Luhanska',1675.0,39.11,48.44).
city('Yasenivskyy','ua','Luhanska',8998.0,39.23,48.17).
city('Yashchykove','ua','Luhanska',2327.0,38.74,48.4).
city('Yesaulivka','ua','Luhanska',1606.0,39.02,48.05).
city('Yuryivka','ua','Luhanska',3347.0,38.97,48.5).
city('Yuvileyne','ua','Luhanska',15351.0,39.21,48.5).
city('Yuzhna-Lomuvatka','ua','Luhanska',3395.0,38.53,48.44).
city('Zolote','ua','Luhanska',17173.0,38.52,48.69).
city('Zorynsk','ua','Luhanska',8509.0,38.56,48.41).
city('Zymohirya','ua','Luhanska',10875.0,38.93,48.59).
city('Belz','ua','Lvivska',2386.0,24.02,50.38).
city('Bibrka','ua','Lvivska',3832.0,24.32,49.66).
city('Boryslav','ua','Lvivsk',36704.0,23.42,49.28).
city('Brody','ua','Lvivska',22375.0,25.15,50.08).
city('Bryukhovychi','ua','Lvivska',5590.0,23.97,49.9).
city('Busk','ua','Lvivska',8351.0,24.63,49.97).
city('Chervonohrad','ua','Lvivska',70572.0,24.23,50.38).
city('Davydiv','ua','Lvivska',4340.0,24.13,49.75).
city('Dobromyl','ua','Lvivska',4791.0,22.78,49.57).
city('Dobrotvir','ua','Lvivska',6436.0,24.37,50.23).
city('Drohobych','ua','Lvivska',79406.0,23.5,49.35).
city('Dublyany','ua','Lvivska',5120.0,23.75,49.7).
city('Duliby','ua','Lvivska',3533.0,23.83,49.22).
city('Hirnyk','ua','Lvivska',2794.0,24.2,50.31).
city('Hirske','ua','Lvivska',2972.0,23.8,49.47).
city('Hlynyany','ua','Lvivska',3252.0,24.52,49.82).
city('Hnizdychiv','ua','Lvivska',4026.0,24.12,49.35).
city('Horodok','ua','Lvivska',15484.0,23.65,49.78).
city('Ivano-Frankove','ua','Lvivska',5628.0,23.73,49.92).
city('Kamyanka-Buzka','ua','Lvivska',11240.0,24.35,50.1).
city('Khodoriv','ua','Lvivska',10172.0,24.31,49.41).
city('Khyriv','ua','Lvivska',4419.0,22.85,49.53).
city('Komarno','ua','Lvivska',3845.0,23.7,49.63).
city('Krakovets','ua','Lvivska',1108.0,23.17,49.97).
city('Krasne','ua','Lvivska',6250.0,24.61,49.91).
city('Kulykiv','ua','Lvivska',3763.0,24.82,50.32).
city('Lopatyn','ua','Lvivska',3418.0,24.85,50.22).
city('Maheriv','ua','Lvivska',1883.0,23.72,50.12).
city('Medenychi','ua','Lvivska',3219.0,23.75,49.43).
city('Morshyn','ua','Lvivska',6241.0,23.87,49.15).
city('Mostyska','ua','Lvivska',8810.0,23.15,49.8).
city('Murovane','ua','Lvivska',4251.0,22.93,49.52).
city('Mykolayiv','ua','Lvivska',14251.0,23.98,49.51).
city('Nemyriv','ua','Lvivska',1966.0,23.45,50.1).
city('Novi Strilyshcha','ua','Lvivska',903.0,24.41,49.52).
city('Novoyavorivsk','ua','Lvivska',25498.0,23.73,49.91).
city('Novyy Rozdil','ua','Lvivska',27177.0,24.13,49.47).
city('Novyy Yarychiv','ua','Lvivska',2841.0,24.3,49.92).
city('Nyzhankovychi','ua','Lvivska',1809.0,22.79,49.67).
city('Obroshyne','ua','Lvivska',4021.0,23.87,49.78).
city('Olesko','ua','Lvivska',1726.0,24.88,49.97).
city('Pavliv','ua','Lvivska',3676.0,24.53,50.27).
city('Peremyshlyany','ua','Lvivska',7284.0,24.55,49.67).
city('Pidbuzh','ua','Lvivska',2739.0,23.25,49.35).
city('Pidkamin','ua','Lvivska',2189.0,25.32,49.95).
city('Pomoryany','ua','Lvivska',1449.0,24.93,49.63).
city('Pustomyty','ua','Lvivska',9434.0,23.92,49.72).
city('Radekhiv','ua','Lvivska',8887.0,24.65,50.28).
city('Ralivka','ua','Lvivska',3926.0,23.25,49.52).
city('Rava-Ruska','ua','Lvivska',7770.0,23.62,50.25).
city('Rozdil','ua','Lvivska',2892.0,24.06,49.47).
city('Rozvadiv','ua','Lvivska',3098.0,23.62,49.5).
city('Rudky','ua','Lvivska',4758.0,23.49,49.69).
city('Rudno','ua','Lvivska',6016.0,23.9,49.83).
city('Rudnyky','ua','Lvivska',3062.0,23.92,49.45).
city('Rykhtychi','ua','Lvivska',3115.0,23.55,49.38).
city('Sambir','ua','Lvivska',35197.0,23.2,49.52).
city('Shchyrets','ua','Lvivska',5316.0,23.86,49.65).
city('Shklo','ua','Lvivska',5164.0,23.53,49.95).
city('Silets','ua','Lvivska',3641.0,24.18,50.32).
city('Skhidnytsya','ua','Lvivska',2226.0,23.35,49.23).
city('Skole','ua','Lvivska',6491.0,23.52,49.03).
city('Slavsko','ua','Lvivska',3152.0,23.45,48.85).
city('Sokal','ua','Lvivska',20886.0,24.28,50.48).
city('Sokilnyky','ua','Lvivska',5560.0,23.98,49.78).
city('Sosnivka','ua','Lvivska',11447.0,24.24,50.27).
city('Stara Sil','ua','Lvivska',1183.0,22.97,49.48).
city('Starychi','ua','Lvivska',3293.0,23.55,49.98).
city('Stebnyk','ua','Lvivska',20087.0,23.57,49.3).
city('Stryy','ua','Lvivska',61404.0,23.85,49.25).
city('Sudova Vyshnya','ua','Lvivska',6420.0,23.37,49.78).
city('Sukhovolya','ua','Lvivska',3612.0,23.83,49.82).
city('Truskavets','ua','Lvivska',29883.0,23.5,49.28).
city('Turka','ua','Lvivska',7395.0,23.03,49.15).
city('Uhniv','ua','Lvivska',983.0,23.75,50.37).
city('Ulychne','ua','Lvivska',3671.0,23.65,49.23).
city('Velyki Mosty','ua','Lvivska',5705.0,24.12,50.24).
city('Velykyy Lyubin','ua','Lvivska',4441.0,23.72,49.74).
city('Verkhnye Synovydne','ua','Lvivska',3390.0,23.58,49.09).
city('Voronyaky','ua','Lvivska',2994.0,24.9,49.78).
city('Vynnyky','ua','Lvivska',13146.0,24.09,49.81).
city('Yavoriv','ua','Lvivska',13008.0,23.39,49.95).
city('Zapytiv','ua','Lvivska',2673.0,24.2,49.92).
city('Zhovkva','ua','Lvivska',12973.0,23.97,50.07).
city('Zhovtantsi','ua','Lvivska',3364.0,24.23,49.98).
city('Zhuravne','ua','Lvivska',3656.0,24.28,49.25).
city('Zhvyrka','ua','Lvivska',3527.0,24.27,50.48).
city('Zhydachiv','ua','Lvivska',11359.0,24.14,49.38).
city('Zolochiv','ua','Lvivska',22608.0,24.9,49.8).
city('Zymna Voda','ua','Lvivska',9602.0,23.88,49.81).
city('Arbuzynka','ua','Mykolayivska',7140.0,31.32,47.92).
city('Bashtanka','ua','Mykolayivska',12657.0,32.45,47.4).
city('Berezanka','ua','Mykolayivska',4090.0,31.4,46.87).
city('Bereznehuvate','ua','Mykolayivska',7506.0,32.85,47.3).
city('Bratske','ua','Mykolayivska',5948.0,31.58,47.87).
city('Domanivka','ua','Mykolayivska',6517.0,30.98,47.63).
city('Kalynivka','ua','Mykolayivska',3358.0,32.17,47.05).
city('Kazanka','ua','Mykolayivska',8010.0,32.83,47.83).
city('Kinetspil','ua','Mykolayivska',3330.0,30.79,48.01).
city('Kostyantynivka','ua','Mykolayivska',2705.0,31.15,47.83).
city('Kryve Ozero','ua','Mykolayivska',8258.0,30.35,47.93).
city('Kudryavtsivka','ua','Mykolayivska',2076.0,31.02,47.3).
city('Lysa Hora','ua','Mykolayivska',4312.0,31.09,48.17).
city('Mishkovo-Pohorilove','ua','Mykolayivska',5280.0,32.09,46.99).
city('Nova Odesa','ua','Mykolayivska',13547.0,31.78,47.32).
city('Novyy Buh','ua','Mykolayivska',15646.0,32.52,47.0).
city('Ochakiv','ua','Mykolayivska',16300.0,31.55,46.62).
city('Oleksandrivka','ua','Mykolayivska',5653.0,32.78,46.83).
city('Olshanske','ua','Mykolayivska',3924.0,31.78,47.2).
city('Peresadivka','ua','Mykolayivska',3012.0,32.18,47.12).
city('Pervomaysk','ua','Mykolayivska',67306.0,30.85,48.05).
city('Pidhorodna','ua','Mykolayivska',2481.0,30.88,48.11).
city('Shevchenkove','ua','Mykolayivska',3031.0,32.21,46.87).
city('Snihurivka','ua','Mykolayivska',14873.0,32.82,47.07).
city('Veselynove','ua','Mykolayivska',6997.0,31.23,47.35).
city('Voskresenske','ua','Mykolayivska',4430.0,32.15,47.01).
city('Voznesensk','ua','Mykolayivska',41049.0,31.33,47.58).
city('Vradiyivka','ua','Mykolayivska',9578.0,30.6,47.87).
city('Yelanets','ua','Mykolayivska',5470.0,31.85,47.7).
city('Yuzhnoukrayinsk','ua','Mykolayivska',36785.0,31.19,47.81).
city('Ananyiv','ua','Odeska',9124.0,29.96,47.72).
city('Artsyz','ua','Odeska',15761.0,29.42,45.98).
city('Balta','ua','Odeska',19220.0,29.62,47.94).
city('Berezyne','ua','Odeska',3658.0,29.2,46.23).
city('Beryozovka','ua','Odeska',9128.0,30.91,47.21).
city('Bilhorod-Dnistrovskyy','ua','Odeska',50200.0,30.32,46.2).
city('Bilyayivka','ua','Odeska',13762.0,30.2,46.48).
city('Bolhrad','ua','Odeska',16708.0,28.61,45.68).
city('Borodino','ua','Odeska',1758.0,29.24,46.3).
city('Broska','ua','Odeska',3586.0,28.78,45.37).
city('Chervonoarmiyske','ua','Odeska',5982.0,28.74,45.79).
city('Chervonoznamyanka','ua','Odeska',3944.0,30.3,47.02).
city('Dachne','ua','Odeska',8230.0,30.57,46.58).
city('Dmytrivka','ua','Odeska',3783.0,29.84,46.21).
city('Dolynske','ua','Odeska',3888.0,29.93,47.53).
city('Fontanka','ua','Odeska',6027.0,30.85,46.57).
city('Frunzivka','ua','Odeska',5007.0,29.75,47.33).
city('Horodnye','ua','Odeska',4901.0,28.83,45.9).
city('Illichivsk','ua','Odeska',53369.0,30.67,46.3).
city('Ivanivka','ua','Odeska',3028.0,30.48,46.98).
city('Izmayil','ua','Odeska',82485.0,28.83,45.35).
city('Kalcheva','ua','Odeska',3388.0,28.82,45.73).
city('Kamyanka','ua','Odeska',3347.0,29.64,46.18).
city('Kiliya','ua','Odeska',21754.0,29.27,45.45).
city('Kodyma','ua','Odeska',9276.0,29.12,48.1).
city('Kominternivske','ua','Odeska',6338.0,30.93,46.82).
city('Komyshivka','ua','Odeska',3352.0,29.84,46.25).
city('Kotovsk','ua','Odeska',39204.0,29.53,47.75).
city('Krasni Okny','ua','Odeska',5461.0,29.46,47.54).
city('Krasnosilka','ua','Odeska',4406.0,30.77,46.62).
city('Krynychne','ua','Odeska',4181.0,28.67,45.53).
city('Kryzhanivka','ua','Odeska',3076.0,30.8,46.57).
city('Kuchurhan','ua','Odeska',3183.0,29.79,47.16).
city('Kulevcha','ua','Odeska',3882.0,29.93,46.03).
city('Lymanske','ua','Odeska',5059.0,29.21,46.1).
city('Lypetske','ua','Odeska',3601.0,29.68,47.74).
city('Lyubashivka','ua','Odeska',9426.0,30.25,47.85).
city('Mayaky','ua','Odeska',5716.0,29.56,47.44).
city('Mykolayivka','ua','Odeska',3629.0,30.77,47.54).
city('Nerubayske','ua','Odeska',8199.0,30.62,46.53).
city('Novi Troyany','ua','Odeska',3992.0,28.86,45.94).
city('Novoselivka','ua','Odeska',2860.0,30.83,47.15).
city('Novosilske','ua','Odeska',3450.0,28.56,45.35).
city('Odesa','ua','Odeska',1001553.0,30.73,46.47).
city('Oleksandrivka','ua','Odeska',4990.0,30.62,46.34).
city('Orlivka','ua','Odeska',2869.0,28.46,45.31).
city('Ovidiopol','ua','Odeska',11513.0,30.43,46.27).
city('Ozerne','ua','Odeska',5162.0,28.67,45.4).
city('Pershotravneve','ua','Odeska',3548.0,29.05,45.49).
city('Petrivka','ua','Odeska',4535.0,30.97,46.97).
city('Petrodolynske','ua','Odeska',3007.0,30.4,46.43).
city('Pishchana','ua','Odeska',3094.0,29.73,48.11).
city('Plakhtiyivka','ua','Odeska',5038.0,29.72,46.1).
city('Prylymanske','ua','Odeska',3708.0,30.61,46.41).
city('Reni','ua','Odeska',19719.0,28.28,45.45).
city('Rozdilna','ua','Odeska',17094.0,30.08,46.85).
city('Sarata','ua','Odeska',5035.0,29.67,46.02).
city('Savran','ua','Odeska',6618.0,30.08,48.14).
city('Serhiyivka','ua','Odeska',4911.0,30.38,46.03).
city('Serpneve','ua','Odeska',1768.0,29.02,46.3).
city('Shabo','ua','Odeska',6886.0,30.38,46.13).
city('Shevchenkove','ua','Odeska',5362.0,29.33,45.55).
city('Shyryayeve','ua','Odeska',7018.0,30.2,47.38).
city('Slobidka','ua','Odeska',2530.0,29.35,47.89).
city('Stara Nekrasivka','ua','Odeska',2916.0,28.94,45.32).
city('Starokozache','ua','Odeska',5108.0,29.99,46.34).
city('Suvorove','ua','Odeska',4642.0,28.99,45.58).
city('Tarutyne','ua','Odeska',5988.0,29.15,46.19).
city('Tatarbunary','ua','Odeska',10396.0,29.62,45.85).
city('Tayirove','ua','Odeska',1849.0,30.67,46.37).
city('Teplodar','ua','Odeska',8502.0,30.33,46.5).
city('Troyitske','ua','Odeska',4992.0,30.3,47.63).
city('Tsebrykove','ua','Odeska',2826.0,30.1,47.15).
city('Usatove','ua','Odeska',7732.0,30.67,46.53).
city('Utkonosivka','ua','Odeska',4140.0,28.97,45.5).
city('Velyka Mykhaylivka','ua','Odeska',5777.0,29.85,47.08).
city('Velykodolynske','ua','Odeska',11175.0,30.58,46.33).
city('Velykoploske','ua','Odeska',3192.0,29.67,47.01).
city('Velykyy Dalnyk','ua','Odeska',7387.0,30.56,46.46).
city('Vyhoda','ua','Odeska',3861.0,30.42,46.62).
city('Vylkove','ua','Odeska',8916.0,29.58,45.4).
city('Vynohradivka','ua','Odeska',3386.0,28.96,45.75).
city('Yasky','ua','Odeska',3955.0,30.08,46.52).
city('Yuzhne','ua','Odeska',23085.0,31.05,46.63).
city('Zahnitkiv','ua','Odeska',2893.0,28.9,48.05).
city('Zaliznychne','ua','Odeska',3343.0,28.6,45.75).
city('Zatoka','ua','Odeska',1391.0,30.47,46.07).
city('Zatyshshya','ua','Odeska',3327.0,29.84,47.31).
city('Zelenohirske','ua','Odeska',1646.0,30.1,47.88).
city('Zorya','ua','Odeska',5243.0,29.72,45.99).
city('Artemivka','ua','Poltavska',3410.0,35.06,49.76).
city('Bilyky','ua','Poltavska',5598.0,34.28,29.23).
city('Chervonozavodske','ua','Poltavska',8633.0,33.4,50.4).
city('Chornukhy','ua','Poltavska',3075.0,32.95,50.27).
city('Chutove','ua','Poltavska',6274.0,35.17,49.72).
city('Dykanka','ua','Poltavska',8307.0,34.53,49.82).
city('Hlobyne','ua','Poltavska',12544.0,33.28,49.38).
city('Hoholeve','ua','Poltavska',2564.0,33.83,49.92).
city('Hradyzk','ua','Poltavska',7575.0,33.12,49.0).
city('Hrebinka','ua','Poltavska',11017.0,32.43,50.12).
city('Kamyani Potoky','ua','Poltavska',3516.0,33.51,48.98).
city('Karlivka','ua','Poltavska',17226.0,35.13,49.45).
city('Khorol','ua','Poltavska',14117.0,33.28,49.78).
city('Kobelyaky','ua','Poltavska',11691.0,34.2,49.15).
city('Komsomolsk','ua','Poltavska',51279.0,33.67,49.03).
city('Komyshnya','ua','Poltavska',2539.0,33.68,50.18).
city('Kotelva','ua','Poltavska',12482.0,34.75,50.07).
city('Kozelshchyna','ua','Poltavska',4302.0,33.85,49.22).
city('Kremenchuk','ua','Poltavska',232741.0,33.42,49.07).
city('Lokhvytsya','ua','Poltavska',11950.0,33.27,50.37).
city('Lyutenka','ua','Poltavska',3548.0,34.03,50.21).
city('Machukhy','ua','Poltavska',3203.0,34.43,49.52).
city('Mashivka','ua','Poltavska',3999.0,34.87,49.43).
city('Myrhorod','ua','Poltavska',41376.0,33.6,49.97).
city('Nova Haleshchyna','ua','Poltavska',2443.0,33.74,49.17).
city('Novi Sanzhary','ua','Poltavska',8020.0,34.33,49.33).
city('Orzhytsya','ua','Poltavska',3898.0,32.7,49.8).
city('Pishchane','ua','Poltavska',4723.0,33.99,49.46).
city('Poltava','ua','Poltavska',317845.0,34.57,49.58).
city('Popivka','ua','Poltavska',3153.0,34.58,49.96).
city('Pyryatyn','ua','Poltavska',16089.0,32.52,50.25).
city('Reshetylivka','ua','Poltavska',9336.0,34.07,49.57).
city('Seleshchyna','ua','Poltavska',3319.0,34.83,49.47).
city('Semenivka','ua','Poltavska',7305.0,33.17,49.6).
city('Sencha','ua','Poltavska',2953.0,33.35,50.25).
city('Suprunivka','ua','Poltavska',3817.0,34.45,49.57).
city('Velyka Bahachka','ua','Poltavska',5707.0,33.72,49.78).
city('Velyki Sorochyntsi','ua','Poltavska',4074.0,33.94,50.03).
city('Yaresky','ua','Poltavska',3810.0,33.9,49.85).
city('Zinkiv','ua','Poltavska',10292.0,34.36,50.21).
city('Demydivka','ua','Rivnenska',2701.0,25.33,50.42).
city('Dubno','ua','Rivnenska',37690.0,25.75,50.42).
city('Dubrovytsya','ua','Rivnenska',9285.0,26.57,51.57).
city('Horodyshche','ua','Rivnenska',3757.0,26.37,50.63).
city('Hoshcha','ua','Rivnenska',5084.0,26.67,50.6).
city('Klesiv','ua','Rivnenska',4424.0,26.93,51.33).
city('Klevan','ua','Rivnenska',7755.0,25.98,50.75).
city('Kolodenka','ua','Rivnenska',3052.0,26.32,50.58).
city('Korets','ua','Rivnenska',8327.0,27.17,50.62).
city('Kostopil','ua','Rivnenska',29334.0,26.45,50.88).
city('Kuznetsovsk','ua','Rivnenska',37386.0,25.86,51.37).
city('Kvasyliv','ua','Rivnenska',7200.0,26.25,50.57).
city('Mizoch','ua','Rivnenska',3553.0,26.15,50.4).
city('Mlyniv','ua','Rivnenska',8228.0,25.6,50.5).
city('Nemovychi','ua','Rivnenska',2984.0,26.63,51.27).
city('Orzhiv','ua','Rivnenska',4046.0,26.12,50.8).
city('Ostroh','ua','Rivnenska',14251.0,26.52,50.33).
city('Ozhenyn','ua','Rivnenska',4593.0,26.48,50.45).
city('Radyvyliv','ua','Rivnenska',9928.0,25.25,50.13).
city('Rafalivka','ua','Rivnenska',3292.0,25.99,51.31).
city('Rivne','ua','Rivnenska',255104.0,26.25,50.62).
city('Rokytne','ua','Rivnenska',5864.0,27.23,51.27).
city('Sarny','ua','Rivnenska',27097.0,26.6,51.33).
city('Stepan','ua','Rivnenska',3950.0,26.3,51.13).
city('Tomashhorod','ua','Rivnenska',2395.0,27.08,51.37).
city('Tynne','ua','Rivnenska',4123.0,26.19,50.6).
city('Volodymyrets','ua','Rivnenska',8537.0,26.13,51.42).
city('Zarichne','ua','Rivnenska',6671.0,26.13,51.82).
city('Zdolbuniv','ua','Rivnenska',23697.0,26.25,50.52).
city('Zdovbytsya','ua','Rivnenska',4858.0,26.26,50.5).
city('Sevastopol','ua','Sevastopol',332954.0,33.53,44.6).
city('Bilopillya','ua','Sumska',17824.0,34.3,51.15).
city('Boromlya','ua','Sumska',4070.0,34.97,50.62).
city('Buryn','ua','Sumska',11217.0,33.82,51.2).
city('Chervone','ua','Sumska',1800.0,34.06,51.77).
city('Chupakhivka','ua','Sumska',2612.0,34.58,50.38).
city('Druzhba','ua','Sumska',5220.0,33.94,52.04).
city('Dubovyazivka','ua','Sumska',2892.0,33.37,51.13).
city('Hlukhiv','ua','Sumska',35387.0,33.92,51.68).
city('Khotin','ua','Sumska',2463.0,34.77,51.08).
city('Konotop','ua','Sumska',91797.0,33.21,51.24).
city('Krasnopillya','ua','Sumska',8603.0,35.26,50.77).
city('Krolevets','ua','Sumska',24695.0,33.38,51.55).
city('Kyrykivka','ua','Sumska',3202.0,35.11,50.3).
city('Lebedyn','ua','Sumska',27695.0,34.48,50.59).
city('Lypova Dolyna','ua','Sumska',5199.0,33.8,50.57).
city('Nedryhayliv','ua','Sumska',6031.0,33.88,50.83).
city('Nyzhnya Syrovatka','ua','Sumska',3586.0,34.82,50.73).
city('Nyzy','ua','Sumska',2819.0,34.78,50.78).
city('Okhtyrka','ua','Sumska',49818.0,34.89,50.31).
city('Popivka','ua','Sumska',4178.0,33.1,51.25).
city('Putyvl','ua','Sumska',16635.0,33.87,51.33).
city('Romny','ua','Sumska',48570.0,33.47,50.75).
city('Seredyna-Buda','ua','Sumska',7161.0,34.03,52.19).
city('Shalyhyne','ua','Sumska',3031.0,34.07,51.57).
city('Shostka','ua','Sumska',85431.0,33.48,51.87).
city('Sloboda','ua','Sumska',2949.0,33.62,51.18).
city('Stepanivka','ua','Sumska',5073.0,34.59,50.95).
city('Stetskivka','ua','Sumska',3551.0,34.78,51.02).
city('Sumy','ua','Sumska',294454.0,34.78,50.92).
city('Svesa','ua','Sumska',7361.0,33.95,51.95).
city('Terny','ua','Sumska',3661.0,33.98,50.98).
city('Trostyanets','ua','Sumska',22401.0,34.95,50.47).
city('Uhroyidy','ua','Sumska',2265.0,35.28,50.86).
city('Ulyanivka','ua','Sumska',2715.0,34.29,50.98).
city('Velyka Pysarivka','ua','Sumska',5235.0,35.48,50.42).
city('Verkhnya Syrovatka','ua','Sumska',3669.0,34.96,50.83).
city('Voronizh','ua','Sumska',7266.0,33.47,51.77).
city('Vorozhba','ua','Sumska',7915.0,34.21,51.18).
city('Yampil','ua','Sumska',4988.0,33.78,51.95).
city('Znob-Novhorodske','ua','Sumska',2139.0,33.6,52.27).
city('Berezhany','ua','Ternopilska',16962.0,24.93,49.45).
city('Bila','ua','Ternopilska',3728.0,25.77,49.03).
city('Borshchiv','ua','Ternopilska',10959.0,26.04,48.82).
city('Buchach','ua','Ternopilska',12082.0,25.4,49.08).
city('Chortkiv','ua','Ternopilska',27977.0,25.8,49.02).
city('Druzhba','ua','Ternopilska',1586.0,25.45,49.05).
city('Hrymayliv','ua','Ternopilska',2051.0,26.03,49.33).
city('Husyatyn','ua','Ternopilska',6481.0,26.22,49.07).
city('Khorostkiv','ua','Ternopilska',7034.0,25.92,49.23).
city('Kopychyntsi','ua','Ternopilska',6774.0,25.93,49.1).
city('Koropets','ua','Ternopilska',3621.0,25.18,48.94).
city('Kozliv','ua','Ternopilska',1868.0,25.35,49.56).
city('Kozova','ua','Ternopilska',9019.0,25.15,49.43).
city('Kremenets','ua','Ternopilska',21231.0,25.72,50.1).
city('Lanivtsi','ua','Ternopilska',8357.0,26.08,49.87).
city('Melnytsya-Podilska','ua','Ternopilska',3743.0,26.17,48.62).
city('Monastyryska','ua','Ternopilska',6108.0,25.17,49.08).
city('Ozerna','ua','Ternopilska',3451.0,25.33,49.63).
city('Petrykiv','ua','Ternopilska',3033.0,25.58,49.53).
city('Pidhaytsi','ua','Ternopilska',3158.0,25.13,49.27).
city('Pidvolochysk','ua','Ternopilska',7676.0,26.15,49.53).
city('Pochaiv','ua','Ternopilska',7934.0,25.49,50.01).
city('Shumsk','ua','Ternopilska',4969.0,26.12,50.12).
city('Skala-Podilska','ua','Ternopilska',4307.0,26.2,48.85).
city('Skalat','ua','Ternopilska',3886.0,25.98,49.43).
city('Terebovlya','ua','Ternopilska',13153.0,25.72,49.3).
city('Ternopil','ua','Ternopilska',235674.0,25.58,49.55).
city('Tovste','ua','Ternopilska',3382.0,25.73,48.85).
city('Trybukhivtsi','ua','Ternopilska',4134.0,25.46,49.05).
city('Velyka Berezovytsya','ua','Ternopilska',6247.0,25.6,48.5).
city('Velyki Birky','ua','Ternopilska',3141.0,25.73,49.52).
city('Velyki Hayi','ua','Ternopilska',3797.0,25.67,49.53).
city('Vyshnivets','ua','Ternopilska',3353.0,25.74,49.9).
city('Zalishchyky','ua','Ternopilska',9749.0,25.73,48.64).
city('Zaliztsi','ua','Ternopilska',2612.0,25.37,49.78).
city('Zbarazh','ua','Ternopilska',12736.0,25.78,49.67).
city('Zboriv','ua','Ternopilska',7159.0,25.15,49.67).
city('Zolotyy Potik','ua','Ternopilska',2343.0,25.34,48.91).
city('Balanivka','ua','Vinnytska',3463.0,29.41,48.4).
city('Bar','ua','Vinnytska',16641.0,27.67,49.07).
city('Bershad','ua','Vinnytska',12840.0,29.52,48.37).
city('Borivka','ua','Vinnytska',3483.0,28.25,48.51).
city('Bratslav','ua','Vinnytska',5819.0,28.95,48.83).
city('Brayiliv','ua','Vinnytska',4964.0,28.16,49.09).
city('Brodetske','ua','Vinnytska',2370.0,28.63,49.75).
city('Chechelnyk','ua','Vinnytska',5439.0,29.37,48.22).
city('Chernivtsi','ua','Vinnytska',3065.0,28.12,48.53).
city('Dzhulynka','ua','Vinnytska',3812.0,29.75,48.43).
city('Dzhuryn','ua','Vinnytska',3648.0,28.29,48.69).
city('Dzyhivka','ua','Vinnytska',3973.0,28.33,48.37).
city('Haysyn','ua','Vinnytska',24687.0,29.4,48.81).
city('Hlukhivtsi','ua','Vinnytska',3690.0,28.73,49.77).
city('Hnivan','ua','Vinnytska',12355.0,28.33,49.1).
city('Horodkivka','ua','Vinnytska',6188.0,28.7,48.38).
city('Illintsi','ua','Vinnytska',10770.0,29.2,49.12).
city('Ivaniv','ua','Vinnytska',4451.0,28.35,49.48).
city('Kalynivka','ua','Vinnytska',19315.0,28.53,49.46).
city('Khmilnyk','ua','Vinnytska',26861.0,27.97,49.55).
city('Klembivka','ua','Vinnytska',3692.0,28.42,48.38).
city('Komsomolske','ua','Vinnytska',3357.0,28.68,49.78).
city('Kopayhorod','ua','Vinnytska',1437.0,27.78,48.87).
city('Kovalivka','ua','Vinnytska',3655.0,28.9,49.04).
city('Kozyatyn','ua','Vinnytska',25645.0,28.83,49.72).
city('Kryzhopil','ua','Vinnytska',9235.0,28.88,48.38).
city('Kynashiv','ua','Vinnytska',2989.0,28.92,48.67).
city('Kyrnasivka','ua','Vinnytska',5322.0,28.97,48.58).
city('Ladyzhyn','ua','Vinnytska',21393.0,29.25,48.67).
city('Lityn','ua','Vinnytska',6804.0,28.07,49.33).
city('Luka-Meleshkivska','ua','Vinnytska',3479.0,28.5,49.18).
city('Lypovets','ua','Vinnytska',9056.0,29.05,49.23).
city('Mazurivka','ua','Vinnytska',3259.0,28.1,48.53).
city('Mohyliv-Podilskyy','ua','Vinnytska',31631.0,27.8,48.45).
city('Murovani Kurylivtsi','ua','Vinnytska',5994.0,27.52,48.73).
city('Nemyriv','ua','Vinnytska',11633.0,28.85,48.97).
city('Obodivka','ua','Vinnytska',3378.0,29.25,48.4).
city('Olhopil','ua','Vinnytska',3741.0,29.51,48.19).
city('Orativ','ua','Vinnytska',3170.0,29.53,49.2).
city('Pavlivka','ua','Vinnytska',3635.0,28.48,49.43).
city('Pishchanka','ua','Vinnytska',5484.0,28.9,48.2).
city('Pohrebyshche','ua','Vinnytska',10354.0,29.27,49.48).
city('Rakhny Lisovi','ua','Vinnytska',4912.0,28.48,48.78).
city('Rudnytsya','ua','Vinnytska',1228.0,28.9,48.27).
city('Serebriya','ua','Vinnytska',2906.0,27.7,48.47).
city('Sharhorod','ua','Vinnytska',6895.0,28.08,48.75).
city('Shpykiv','ua','Vinnytska',3638.0,28.57,48.78).
city('Sobolivka','ua','Vinnytska',3605.0,28.65,49.33).
city('Stryzhavka','ua','Vinnytska',8593.0,28.47,49.31).
city('Sutysky','ua','Vinnytska',6111.0,28.43,49.05).
city('Sytkivtsi','ua','Vinnytska',2740.0,29.21,48.91).
city('Teplyk','ua','Vinnytska',6604.0,29.73,48.67).
city('Tomashpil','ua','Vinnytska',5842.0,28.52,48.53).
city('Trostyanets','ua','Vinnytska',8021.0,28.62,49.1).
city('Tulchyn','ua','Vinnytska',15536.0,28.87,48.68).
city('Turbiv','ua','Vinnytska',6740.0,28.73,49.33).
city('Tyvriv','ua','Vinnytska',4570.0,28.5,49.02).
city('Ulaniv','ua','Vinnytska',2980.0,28.13,49.7).
city('Vapnyarka','ua','Vinnytska',8443.0,28.77,48.53).
city('Velyka Kisnytsya','ua','Vinnytska',3088.0,28.47,48.14).
city('Vendychany','ua','Vinnytska',4182.0,27.8,48.63).
city('Vinnytski Khutory','ua','Vinnytska',6511.0,28.55,49.21).
city('Vinnytsya','ua','Vinnytska',352113.0,28.48,49.23).
city('Viytivka','ua','Vinnytska',4245.0,29.53,48.42).
city('Voronovytsya','ua','Vinnytska',6389.0,28.68,49.1).
city('Yampil','ua','Vinnytska',11349.0,28.28,48.25).
city('Zhmerynka','ua','Vinnytska',35960.0,28.1,49.03).
city('Berestechko','ua','Volynska',1830.0,25.12,50.35).
city('Dubyshche','ua','Volynska',1953.0,25.31,50.94).
city('Holoby','ua','Volynska',4203.0,25.02,51.08).
city('Holovne','ua','Volynska',3152.0,24.08,51.33).
city('Horokhiv','ua','Volynska',8842.0,24.77,50.5).
city('Ivanychi','ua','Volynska',6767.0,24.35,50.65).
city('Kamin-Kashyrskyy','ua','Volynska',11041.0,24.97,51.63).
city('Kivertsi','ua','Volynska',16509.0,25.47,50.83).
city('Kolky','ua','Volynska',3963.0,25.67,51.1).
city('Kovel','ua','Volynska',65576.0,24.72,51.22).
city('Lokachi','ua','Volynska',4056.0,24.65,50.73).
city('Lukiv','ua','Volynska',3043.0,25.4,51.05).
city('Lutsk','ua','Volynska',213660.0,25.33,50.75).
city('Lyubeshiv','ua','Volynska',5812.0,25.52,51.77).
city('Lyublynets','ua','Volynska',4155.0,24.62,51.18).
city('Lyuboml','ua','Volynska',10385.0,24.03,51.23).
city('Manevychi','ua','Volynska',10612.0,25.52,51.3).
city('Maryanivka','ua','Volynska',2744.0,24.83,50.45).
city('Novovolynsk','ua','Volynska',52910.0,24.17,50.73).
city('Olyka','ua','Volynska',3074.0,25.82,50.72).
city('Pidhaytsi','ua','Volynska',2970.0,25.4,50.7).
city('Rakiv Lis','ua','Volynska',2958.0,24.91,51.61).
city('Ratne','ua','Volynska',9081.0,24.52,51.68).
city('Rozhyshche','ua','Volynska',13280.0,25.27,50.92).
city('Senkevychivka','ua','Volynska',1312.0,25.03,50.53).
city('Shatsk','ua','Volynska',5567.0,23.95,51.5).
city('Stara Vyzhivka','ua','Volynska',5466.0,24.43,51.43).
city('Tsuman','ua','Volynska',5900.0,25.88,50.83).
city('Turiysk','ua','Volynska',5865.0,24.53,51.1).
city('Ustyluh','ua','Volynska',2226.0,24.15,50.87).
city('Volodymyr-Volynskyy','ua','Volynska',37870.0,24.33,50.85).
city('Zabolottya','ua','Volynska',4267.0,24.25,51.63).
city('Zhovtneve','ua','Volynska',4652.0,24.27,50.65).
city('Batovo','ua','Zakarpatska',2916.0,22.4,48.37).
city('Berehove','ua','Zakarpatska',25741.0,22.63,48.21).
city('Bereznyky','ua','Zakarpatska',3055.0,23.22,48.51).
city('Berezovo','ua','Zakarpatska',2885.0,23.48,48.3).
city('Bilky','ua','Zakarpatska',7778.0,23.13,48.32).
city('Bohdan','ua','Zakarpatska',3155.0,24.36,48.04).
city('Boronyavo','ua','Zakarpatska',3379.0,23.4,48.15).
city('Bushtyno','ua','Zakarpatska',8236.0,23.49,48.05).
city('Chop','ua','Zakarpatska',8587.0,22.2,48.43).
city('Chynadiyovo','ua','Zakarpatska',6564.0,22.83,48.48).
city('Dovhe','ua','Zakarpatska',6541.0,23.28,48.37).
city('Drahovo','ua','Zakarpatska',4262.0,23.55,48.24).
city('Dubove','ua','Zakarpatska',8902.0,23.89,48.17).
city('Hanychi','ua','Zakarpatska',3836.0,23.82,48.13).
city('Hat','ua','Zakarpatska',2966.0,22.63,48.32).
city('Hlybokyy Potik','ua','Zakarpatska',5325.0,23.88,48.05).
city('Horinchovo','ua','Zakarpatska',2959.0,23.44,48.27).
city('Horonda','ua','Zakarpatska',3810.0,22.57,48.37).
city('Ilnytsya','ua','Zakarpatska',8571.0,23.08,48.35).
city('Irshava','ua','Zakarpatska',9161.0,23.05,48.32).
city('Iza','ua','Zakarpatska',5015.0,23.33,48.22).
city('Kalyny','ua','Zakarpatska',5627.0,23.89,48.15).
city('Keretsky','ua','Zakarpatska',4130.0,23.22,48.48).
city('Khust','ua','Zakarpatska',27999.0,23.3,48.18).
city('Kobyletska Polyana','ua','Zakarpatska',3265.0,24.07,48.07).
city('Kolchyno','ua','Zakarpatska',4243.0,22.77,48.47).
city('Kolochava','ua','Zakarpatska',4839.0,23.69,48.44).
city('Kopashnovo','ua','Zakarpatska',3010.0,23.5,48.23).
city('Korolevo','ua','Zakarpatska',7844.0,23.13,48.15).
city('Koshelovo','ua','Zakarpatska',2915.0,23.34,48.24).
city('Kosivska Polyana','ua','Zakarpatska',4064.0,24.11,48.01).
city('Kryva','ua','Zakarpatska',2911.0,23.25,48.17).
city('Kushnytsya','ua','Zakarpatska',4508.0,23.26,48.45).
city('Lazeshchyna','ua','Zakarpatska',4008.0,24.42,48.27).
city('Lazy','ua','Zakarpatska',3660.0,24.21,48.07).
city('Lopukhiv','ua','Zakarpatska',3199.0,23.97,48.37).
city('Lypcha','ua','Zakarpatska',3640.0,23.38,48.26).
city('Lysychovo','ua','Zakarpatska',3068.0,23.28,48.5).
city('Malyy Rakovets','ua','Zakarpatska',2958.0,23.2,48.27).
city('Mezhgorye','ua','Zakarpatska',9297.0,23.5,48.53).
city('Mukacheve','ua','Zakarpatska',81632.0,22.72,48.45).
city('Mynay','ua','Zakarpatska',2973.0,22.28,48.58).
city('Nelipyno','ua','Zakarpatska',3403.0,23.03,48.57).
city('Neresnytsya','ua','Zakarpatska',3617.0,23.77,48.12).
city('Nove Davydkovo','ua','Zakarpatska',3853.0,22.63,48.45).
city('Nyzhnye Selyshche','ua','Zakarpatska',2901.0,23.45,48.19).
city('Oleshnyk','ua','Zakarpatska',4471.0,22.97,48.17).
city('Perechyn','ua','Zakarpatska',6820.0,22.47,48.73).
city('Pidvynohradiv','ua','Zakarpatska',4206.0,22.97,48.13).
city('Poroshkovo','ua','Zakarpatska',3645.0,22.75,48.67).
city('Pryborzhavske','ua','Zakarpatska',3452.0,23.23,48.35).
city('Rakhiv','ua','Zakarpatska',14674.0,24.21,48.05).
city('Rakoshyno','ua','Zakarpatska',3145.0,22.6,48.47).
city('Rokosovo','ua','Zakarpatska',4544.0,23.18,48.22).
city('Serednye','ua','Zakarpatska',3364.0,22.5,48.53).
city('Serednye Vodyane','ua','Zakarpatska',5465.0,23.9,47.98).
city('Shalanky','ua','Zakarpatska',2994.0,22.88,48.22).
city('Sokyrnytsya','ua','Zakarpatska',4962.0,23.39,48.12).
city('Solotvyno','ua','Zakarpatska',8931.0,23.87,47.0).
city('Strabychovo','ua','Zakarpatska',3255.0,22.55,48.38).
city('Svalyava','ua','Zakarpatska',16507.0,22.98,48.55).
city('Synevyr','ua','Zakarpatska',4623.0,23.63,48.49).
city('Turyi Remety','ua','Zakarpatska',3172.0,22.6,48.72).
city('Tyachiv','ua','Zakarpatska',9422.0,23.58,48.02).
city('Ust-Chorna','ua','Zakarpatska',1430.0,23.93,48.33).
city('Uzhhorod','ua','Zakarpatska',117877.0,22.3,48.62).
city('Vary','ua','Zakarpatska',2998.0,22.72,48.13).
city('Velyatyno','ua','Zakarpatska',4338.0,23.32,48.11).
city('Velyka Dobron','ua','Zakarpatska',5476.0,22.38,48.42).
city('Velyka Kopanya','ua','Zakarpatska',3301.0,23.1,48.19).
city('Velyki Komyaty','ua','Zakarpatska',6493.0,22.97,48.24).
city('Velyki Luchky','ua','Zakarpatska',8693.0,22.57,48.41).
city('Velykyy Bereznyy','ua','Zakarpatska',6551.0,22.46,48.9).
city('Velykyy Bychkiv','ua','Zakarpatska',9079.0,24.01,48.97).
city('Velykyy Rakovets','ua','Zakarpatska',4380.0,23.15,48.26).
city('Verkhnye Vodyane','ua','Zakarpatska',5025.0,23.96,47.99).
city('Vilkhivtsi','ua','Zakarpatska',3246.0,23.72,48.07).
city('Volovets','ua','Zakarpatska',4993.0,23.18,48.72).
city('Vylok','ua','Zakarpatska',3292.0,22.83,48.1).
city('Vynohradiv','ua','Zakarpatska',24802.0,23.04,48.14).
city('Vyshkovo','ua','Zakarpatska',7838.0,23.42,48.05).
city('Yasinya','ua','Zakarpatska',7708.0,24.36,48.27).
city('Zhdeniyevo','ua','Zakarpatska',1078.0,22.98,48.77).
city('Zolotarovo','ua','Zakarpatska',4066.0,23.5,48.2).
city('Andriyivka','ua','Zaporizka',3276.0,36.58,47.1).
city('Balabyne','ua','Zaporizka',5447.0,35.21,47.73).
city('Balky','ua','Zaporizka',5717.0,34.95,47.38).
city('Berdyansk','ua','Zaporizka',118283.0,36.79,46.75).
city('Bilenke','ua','Zaporizka',4803.0,35.03,47.63).
city('Chapayevka','ua','Zaporizka',3502.0,36.36,47.47).
city('Chernihivka','ua','Zaporizka',7311.0,36.17,47.2).
city('Dniprorudne','ua','Zaporizka',20271.0,35.02,47.41).
city('Dniprovka','ua','Zaporizka',3873.0,34.62,47.43).
city('Enerhodar','ua','Zaporizka',58824.0,34.47,47.5).
city('Hulyaypole','ua','Zaporizka',16442.0,36.26,47.67).
city('Kamyanka-Dniprovska','ua','Zaporizka',14945.0,34.41,47.49).
city('Kinski Rozdory','ua','Zaporizka',2985.0,36.41,47.42).
city('Kirove','ua','Zaporizka',3291.0,35.7,47.65).
city('Komysh-Zorya','ua','Zaporizka',2321.0,36.67,47.33).
city('Komyshuvakha','ua','Zaporizka',5231.0,35.53,47.72).
city('Kostyantynivka','ua','Zaporizka',11540.0,35.42,46.82).
city('Kushuhum','ua','Zaporizka',7475.0,35.21,47.71).
city('Kuybysheve','ua','Zaporizka',7832.0,36.65,47.35).
city('Kyrylivka','ua','Zaporizka',1422.0,35.37,46.37).
city('Mala Bilozerka','ua','Zaporizka',5717.0,34.93,47.25).
city('Mala Tokmachka','ua','Zaporizka',2912.0,35.89,47.54).
city('Malokaterynivka','ua','Zaporizka',3174.0,35.25,47.65).
city('Matviyivka','ua','Zaporizka',3716.0,35.14,47.08).
city('Melitopol','ua','Zaporizka',156684.0,35.37,46.84).
city('Molochansk','ua','Zaporizka',7668.0,35.59,47.21).
city('Mykhaylivka','ua','Zaporizka',13216.0,35.22,47.27).
city('Novobohdanivka','ua','Zaporizka',3506.0,35.33,47.08).
city('Novomykolayivka','ua','Zaporizka',5568.0,35.92,47.98).
city('Novovasylivka','ua','Zaporizka',2724.0,35.76,46.84).
city('Orikhiv','ua','Zaporizka',17287.0,35.79,47.57).
city('Osypenko','ua','Zaporizka',4477.0,36.84,46.92).
city('Polohy','ua','Zaporizka',21380.0,36.25,47.48).
city('Preobrazhenka','ua','Zaporizka',3550.0,35.8,47.58).
city('Pryazovske','ua','Zaporizka',7067.0,35.64,46.73).
city('Prymorsk','ua','Zaporizka',12491.0,36.35,46.73).
city('Prymorske','ua','Zaporizka',3701.0,35.29,47.62).
city('Pryshyb','ua','Zaporizka',3365.0,35.32,47.26).
city('Rozivka','ua','Zaporizka',4197.0,35.77,46.94).
city('Ternuvate','ua','Zaporizka',151.0,36.13,47.83).
city('Terpinnya','ua','Zaporizka',4656.0,35.42,46.97).
city('Tokmak','ua','Zaporizka',34926.0,35.71,47.25).
city('Tymoshivka','ua','Zaporizka',2975.0,35.11,47.18).
city('Vasylivka','ua','Zaporizka',15012.0,35.27,47.44).
city('Velyka Bilozerka','ua','Zaporizka',3511.0,34.7,47.27).
city('Velyka Znamyanka','ua','Zaporizka',8631.0,34.35,47.44).
city('Vesele','ua','Zaporizka',10683.0,34.91,47.01).
city('Vilnyansk','ua','Zaporizka',15908.0,35.43,47.94).
city('Vodyane','ua','Zaporizka',5685.0,34.5,47.0).
city('Voznesenka','ua','Zaporizka',4917.0,35.46,46.86).
city('Yakymivka','ua','Zaporizka',12353.0,35.15,46.69).
city('Zaliznychne','ua','Zaporizka',1206.0,36.15,47.65).
city('Zaporizhzhya','ua','Zaporizka',796213.0,35.17,47.85).
city('Andrushivka','ua','Zhytomyrska',9522.0,29.02,50.02).
city('Baranivka','ua','Zhytomyrska',12116.0,27.67,50.3).
city('Berdychiv','ua','Zhytomyrska',86250.0,28.58,49.9).
city('Bila Krynytsya','ua','Zhytomyrska',1029.0,29.47,50.65).
city('Brusyliv','ua','Zhytomyrska',5242.0,29.53,50.28).
city('Buch','ua','Zhytomyrska',792.0,28.05,51.05).
city('Bykivka','ua','Zhytomyrska',1911.0,27.98,50.28).
city('Chernyakhiv','ua','Zhytomyrska',10082.0,28.67,50.45).
city('Chervone','ua','Zhytomyrska',2880.0,28.87,49.97).
city('Chervonoarmiysk','ua','Zhytomyrska',5195.0,28.27,50.47).
city('Chopovychi','ua','Zhytomyrska',2183.0,28.95,50.83).
city('Chudniv','ua','Zhytomyrska',6314.0,28.12,50.05).
city('Dibrova','ua','Zhytomyrska',187.0,27.97,51.15).
city('Dovbysh','ua','Zhytomyrska',4559.0,27.98,50.37).
city('Druzhba','ua','Zhytom',531.0,27.92,51.2).
city('Dzerzhynsk','ua','Zhytomyrska',7955.0,27.93,50.15).
city('Holovyne','ua','Zhytomyrska',1891.0,28.83,50.47).
city('Horodnytsya','ua','Zhytomyrska',5238.0,27.32,50.8).
city('Hranitne','ua','Zhytomyrska',1540.0,29.43,50.75).
city('Hryshkivtsi','ua','Zhytomyrska',4427.0,28.6,49.93).
city('Huyva','ua','Zhytomyrska',1126.0,28.63,50.2).
city('Irshansk','ua','Zhytomyrska',6077.0,28.73,50.73).
city('Ivanopil','ua','Zhytomyrska',3841.0,28.22,49.85).
city('Kamyanyy Brid','ua','Zhytomyrska',2699.0,28.95,50.48).
city('Kornyn','ua','Zhytomyrska',2605.0,29.37,50.08).
city('Korosten','ua','Zhytomyrska',64972.0,28.65,50.95).
city('Korostyshiv','ua','Zhytomyrska',25099.0,29.07,50.32).
city('Luhyny','ua','Zhytomyrska',4561.0,28.4,51.08).
city('Lyubar','ua','Zhytomyrska',2351.0,27.75,49.92).
city('Malyn','ua','Zhytomyrska',27068.0,29.23,50.77).
city('Maryanivka','ua','Zhytomyrska',1439.0,27.87,50.3).
city('Myropil','ua','Zhytomyrska',5237.0,27.7,50.12).
city('Narodychi','ua','Zhytomyrska',2521.0,29.08,51.2).
city('Nova Borova','ua','Zhytomyrska',5494.0,28.63,50.7).
city('Novi Bilokorovychi','ua','Zhytomyrska',3251.0,28.05,51.12).
city('Novohrad-Volynskyy','ua','Zhytomyrska',56035.0,27.62,50.6).
city('Novohuyvynske','ua','Zhytomyrska',5070.0,28.67,50.18).
city('Olevsk','ua','Zhytomyrska',10491.0,27.65,51.22).
city('Ovruch','ua','Zhytomyrska',16398.0,28.8,51.32).
city('Ozerne','ua','Zhytomyrska',5646.0,28.72,50.18).
city('Pershotravensk','ua','Zhytomyrska',3465.0,27.67,50.22).
city('Pershotravneve','ua','Zhytomyrska',2523.0,28.88,51.4).
city('Polyanka','ua','Zhytomyrska',1693.0,27.7,50.25).
city('Popilnya','ua','Zhytomyrska',5986.0,29.45,49.97).
city('Radomyshl','ua','Zhytomyrska',14756.0,29.23,50.5).
city('Ruzhyn','ua','Zhytomyrska',4993.0,29.23,49.72).
city('Velyki Korovyntsi','ua','Zhytomyrska',2662.0,28.28,49.98).
city('Volodarsk-Volynskyy','ua','Zhytomyrska',7737.0,28.45,50.6).
city('Yablunets','ua','Zhytomyrska',1304.0,28.07,50.8).
city('Yemilchyne','ua','Zhytomyrska',7156.0,27.8,50.87).
city('Zhovtneve','ua','Zhytomyrska',609.0,29.51,49.99).
city('Zhytomyr','ua','Zhytomyrska',282190.0,28.67,50.25).
city('Abu Dhabi','ae','Abu Dhabi',603687.0,54.37,24.48).
city('al-Ayn','ae','Abu Dhabi',408894.0,55.74,24.23).
city('Ajman','ae','Ajman',226175.0,55.43,25.42).
city('Dubai','ae','Dubai',1137376.0,55.33,25.27).
city('Ras al-Hzaymah','ae','Ras al Khaymah',115976.0,55.94,25.79).
city('Sharjah','ae','Sharjah',543942.0,55.41,25.37).
city('Umm al-Qaywayn','ae','Umm al-Qaywayn',44460.0,55.56,25.59).
city('Hzawr Fakkan','ae','al-Fujayrah',33576.0,56.36,25.34).
city('al-Fujayrah','ae','al-Fujayrah',62607.0,56.34,25.13).
city('Abingdon','uk','England',37192.0,-1.29,51.68).
city('Accrington','uk','England',35318.0,-2.39,53.76).
city('Aldershot','uk','England',61339.0,-0.77,51.26).
city('Alfreton','uk','England',22550.0,-1.37,53.08).
city('Altrincham','uk','England',41548.0,-2.36,53.38).
city('Amersham','uk','England',21731.0,-0.62,51.68).
city('Andover','uk','England',39951.0,-1.49,51.21).
city('Arnold','uk','England',37873.0,-1.13,53.01).
city('Ashford','uk','England',62787.0,0.86,51.15).
city('Ashington','uk','England',27546.0,-1.57,55.19).
city('Ashton-in-Makerfield','uk','England',29039.0,-2.65,53.49).
city('Ashton-under-Lyne','uk','England',43675.0,-2.11,53.5).
city('Atherton','uk','England',20149.0,-2.49,53.52).
city('Aylesbury','uk','England',74565.0,-0.83,51.83).
city('Aylesford-East Malling','uk','England',24842.0,0.46,51.29).
city('Banbury','uk','England',46075.0,-1.35,52.06).
city('Banstead-Tadworth','uk','England',39834.0,-0.22,51.32).
city('Barnsley','uk','England',71448.0,-1.49,53.57).
city('Barnstaple','uk','England',32532.0,-4.06,51.09).
city('Barrow-in-Furness','uk','England',47264.0,-3.22,54.13).
city('Basildon','uk','England',101363.0,0.46,51.57).
city('Basingstoke','uk','England',96349.0,-1.11,51.27).
city('Bath','uk','England',93238.0,-2.38,51.39).
city('Batley','uk','England',50807.0,-1.64,53.72).
city('Bebington','uk','England',56803.0,-3.01,53.35).
city('Bedford','uk','England',86659.0,-0.49,52.15).
city('Bedworth','uk','England',29981.0,-1.47,52.48).
city('Beeston and Stapleford','uk','England',67797.0,-1.22,52.93).
city('Benfleet','uk','England',48824.0,0.55,51.56).
city('Bentley','uk','England',34821.0,-1.15,53.53).
city('Berwick-upon-Tweed','uk','England',13157.0,-2.02,55.78).
city('Beverley','uk','England',31968.0,-0.42,53.83).
city('Bexhill','uk','England',40478.0,0.46,50.85).
city('Bicester','uk','England',35902.0,-1.16,51.91).
city('Bideford','uk','England',16624.0,-4.22,51.02).
city('Billericay','uk','England',34467.0,0.42,51.63).
city('Billingham','uk','England',35709.0,-1.28,54.61).
city('Birkenhead','uk','England',81806.0,-3.04,53.39).
city('Birmingham','uk','England',984336.0,-1.91,52.48).
city('Bishop Auckland','uk','England',25665.0,-1.68,54.65).
city('Bishops Stortford','uk','England',38987.0,0.15,51.88).
city('Blackburn','uk','England',106154.0,-2.49,53.75).
city('Blackpool','uk','England',143101.0,-3.06,53.82).
city('Bletchley','uk','England',50193.0,-0.74,52.0).
city('Blyth','uk','England',36356.0,-1.52,55.12).
city('Bodmin','uk','England',13063.0,-4.74,50.47).
city('Bognor Regis','uk','England',65391.0,-0.69,50.79).
city('Bolton','uk','England',141331.0,-2.43,53.58).
city('Bootle','uk','England',57791.0,-3.01,53.47).
city('Borehamwood','uk','England',32176.0,-0.28,51.66).
city('Boston','uk','England',35859.0,-0.02,52.99).
city('Bourne','uk','England',12060.0,-0.39,52.77).
city('Bournemouth','uk','England',175017.0,-1.88,50.73).
city('Bracknell','uk','England',76103.0,-0.77,51.42).
city('Bradford','uk','England',299310.0,-1.75,53.8).
city('Braintree','uk','England',46765.0,0.57,51.88).
city('Bredbury and Romiley','uk','England',28551.0,-2.08,53.42).
city('Brentwood','uk','England',47606.0,0.31,51.63).
city('Bridgwater','uk','England',38021.0,-3.01,51.13).
city('Bridlington','uk','England',35057.0,-0.21,54.1).
city('Brigg','uk','England',5988.0,-0.5,53.56).
city('Brighouse','uk','England',32873.0,-1.78,53.7).
city('Brighton','uk','England',139001.0,-0.15,50.83).
city('Bristol','uk','England',430714.0,-2.6,51.46).
city('Broadstairs','uk','England',23283.0,1.41,51.37).
city('Bromley Cross-Brads','uk','England',23344.0,-2.4,53.6).
city('Bromsgrove-Catshill','uk','England',30808.0,-2.07,52.34).
city('Burgess Hill','uk','England',31183.0,-0.14,50.96).
city('Burnley','uk','England',73480.0,-2.26,53.8).
city('Burntwood','uk','England',29766.0,-1.9,52.68).
city('Burton-upon-Trent','uk','England',40039.0,-1.65,52.81).
city('Bury','uk','England',61045.0,-2.31,53.6).
city('Bury Saint Edmunds','uk','England',38622.0,0.7,52.24).
city('Buxton','uk','England',21300.0,-1.92,53.26).
city('Camberley-Frimley','uk','England',48655.0,-0.75,51.33).
city('Camborne-Redruth','uk','England',42068.0,-5.3,50.22).
city('Cambridge','uk','England',128489.0,0.13,52.21).
city('Cannock','uk','England',68067.0,-2.04,52.7).
city('Canterbury','uk','England',46978.0,1.07,51.29).
city('Canvey Island','uk','England',38467.0,0.63,51.52).
city('Carlisle','uk','England',72633.0,-2.95,54.91).
city('Carlton','uk','England',49687.0,-1.08,52.98).
city('Castleford','uk','England',37713.0,-1.35,53.72).
city('Caterham and Warlingham','uk','England',32614.0,-0.1,51.29).
city('Chadderton','uk','England',33186.0,-2.17,53.56).
city('Chapeltown','uk','England',22785.0,-1.47,53.46).
city('Chatham','uk','England',75510.0,0.51,51.38).
city('Cheadle and Gatley','uk','England',57995.0,-2.24,53.4).
city('Chelmsford','uk','England',102671.0,0.47,51.73).
city('Cheltenham','uk','England',103249.0,-2.09,51.9).
city('Chesham','uk','England',20649.0,-0.62,51.72).
city('Cheshunt','uk','England',57374.0,-0.03,51.71).
city('Chester','uk','England',81313.0,-2.92,53.2).
city('Chester-le','uk','England',36917.0,-1.58,54.86).
city('Chesterfield','uk','England',70680.0,-1.42,53.25).
city('Chichester','uk','England',28222.0,-0.78,50.83).
city('Chippenham','uk','England',36890.0,-2.13,51.47).
city('Chipping Sodbury','uk','England',36108.0,-2.42,51.54).
city('Chorley','uk','England',33888.0,-2.64,53.65).
city('Christchurch','uk','England',42397.0,-1.76,50.73).
city('Clacton-on-Sea','uk','England',54674.0,1.14,51.8).
city('Clay Cross-North Wingfield','uk','England',21216.0,-1.42,53.15).
city('Cleethorpes','uk','England',32017.0,-0.05,53.56).
city('Clevedon','uk','England',22414.0,-2.86,51.44).
city('Coalville','uk','England',33288.0,-1.37,52.72).
city('Colchester','uk','England',109415.0,0.9,51.88).
city('Congleton','uk','England',26030.0,-2.22,53.17).
city('Consett','uk','England',21016.0,-1.84,54.86).
city('Corby','uk','England',50029.0,-0.73,52.5).
city('Coventry','uk','England',308314.0,-1.5,52.42).
city('Cowes-Northwood','uk','England',19536.0,-1.32,50.77).
city('Cramlington','uk','England',29985.0,-1.6,55.09).
city('Crawley','uk','England',107061.0,-0.2,51.13).
city('Crewe','uk','England',70456.0,-2.45,53.08).
city('Crosby','uk','England',52140.0,-3.03,53.5).
city('Crowthorne','uk','England',25522.0,-0.8,51.37).
city('Darlington','uk','England',87205.0,-1.57,54.52).
city('Dartford','uk','England',56694.0,0.22,51.44).
city('Darwen','uk','England',32566.0,-2.48,53.7).
city('Dawlish','uk','England',10676.0,-3.49,50.59).
city('Deal','uk','England',30065.0,-1.38,51.22).
city('Denton','uk','England',27464.0,-2.12,53.45).
city('Derby','uk','England',235029.0,-1.5,52.92).
city('Dewsbury','uk','England',56641.0,-1.66,53.7).
city('Doncaster','uk','England',67671.0,-1.12,53.53).
city('Dorchester','uk','England',16879.0,-2.45,50.72).
city('Dover','uk','England',34603.0,1.3,52.33).
city('Droitwich','uk','England',23589.0,-2.16,52.26).
city('Dronfield','uk','England',20942.0,-1.47,53.31).
city('Droylsden','uk','England',23689.0,-2.15,53.49).
city('Dudley','uk','England',199060.0,-2.08,52.5).
city('Dunstable','uk','England',51974.0,-0.54,51.89).
city('Durham','uk','England',45696.0,-1.6,54.78).
city('East Grinstead','uk','England',26523.0,-0.02,51.13).
city('East Retford','uk','England',21897.0,-0.95,53.32).
city('Eastbourne','uk','England',112906.0,0.27,50.78).
city('Eastleigh','uk','England',54225.0,-1.35,50.97).
city('Eaton Socon','uk','England',12712.0,-0.29,52.22).
city('Eccles','uk','England',37275.0,-2.33,53.49).
city('Egham','uk','England',29663.0,-0.57,51.43).
city('Ellesmere','uk','England',67768.0,-2.91,53.29).
city('Epsom and Ewell','uk','England',65402.0,-0.29,51.33).
city('Esher-Molesey','uk','England',52393.0,-0.36,51.38).
city('Eston and South Bank','uk','England',31876.0,-1.14,54.57).
city('Exeter','uk','England',113119.0,-3.54,50.73).
city('Exmouth','uk','England',35154.0,-3.41,50.63).
city('Failsworth','uk','England',20210.0,-2.14,53.52).
city('Falmouth','uk','England',22222.0,-5.08,50.15).
city('Fareham','uk','England',57390.0,-1.19,50.85).
city('Farnborough','uk','England',59902.0,-0.76,51.3).
city('Farnham','uk','England',36971.0,-0.8,51.21).
city('Farnworth','uk','England',25680.0,-2.41,53.55).
city('Felixtowe','uk','England',30312.0,-1.33,51.96).
city('Felling','uk','England',34355.0,-1.56,54.95).
city('Ferndown','uk','England',25716.0,-1.9,50.8).
city('Fleet','uk','England',34218.0,-0.85,51.29).
city('Fleetwood','uk','England',27077.0,-3.02,53.93).
city('Folkestone','uk','England',45992.0,1.16,51.1).
city('Formby','uk','England',24225.0,-3.07,53.56).
city('Frome','uk','England',24948.0,-2.33,51.24).
city('Gainsborough','uk','England',19871.0,-0.79,53.4).
city('Gateshead','uk','England',77649.0,-1.62,54.97).
city('Gillingham','uk','England',101187.0,0.55,51.39).
city('Glossop','uk','England',33243.0,-1.96,53.44).
city('Gloucester','uk','England',128722.0,-2.24,51.86).
city('Godalming','uk','England',22199.0,-0.62,51.19).
city('Golborne','uk','England',24021.0,-2.6,53.48).
city('Gosforth','uk','England',23975.0,-1.62,55.0).
city('Gosport','uk','England',70793.0,-1.14,50.8).
city('Grantham','uk','England',35720.0,-0.65,52.91).
city('Gravesend','uk','England',54264.0,0.39,51.44).
city('Grays','uk','England',70935.0,0.32,51.48).
city('Greasby','uk','England',53988.0,-3.12,53.39).
city('Great Malvern','uk','England',37663.0,-2.32,52.11).
city('Great Sankey','uk','England',43793.0,-2.65,53.39).
city('Great Yarmouth','uk','England',59601.0,1.71,52.59).
city('Grimsby','uk','England',87819.0,-0.11,53.57).
city('Guildford','uk','England',71873.0,-0.58,51.24).
city('Guiseley-Yeadon','uk','England',31956.0,-1.72,53.88).
city('Halesowen','uk','England',55265.0,-2.06,52.46).
city('Halifax','uk','England',82625.0,-1.88,53.73).
city('Harlow','uk','England',94365.0,0.11,51.78).
city('Harpenden','uk','England',28966.0,-0.36,51.82).
city('Harrogate','uk','England',87024.0,-1.54,53.99).
city('Hartlepool','uk','England',86713.0,-1.22,54.69).
city('Hastings','uk','England',89100.0,0.57,50.86).
city('Hatfield','uk','England',23622.0,-0.65,52.68).
city('Havant','uk','England',45574.0,-0.99,50.86).
city('Haywards Heath','uk','England',29660.0,-0.12,51.01).
city('Hazel Grove and Bramhill','uk','England',38914.0,-2.12,53.38).
city('Hazlemere','uk','England',20695.0,-0.72,51.65).
city('Heanor','uk','England',23122.0,-1.35,53.02).
city('Hemel Hempstead','uk','England',85630.0,-0.48,51.76).
city('Hereford','uk','England',58281.0,-2.73,52.06).
city('Herne Bay','uk','England',36642.0,1.11,51.37).
city('Hertford','uk','England',25848.0,-0.09,51.8).
city('Heswall','uk','England',30065.0,-3.08,53.32).
city('Heywood','uk','England',28016.0,-2.22,53.59).
city('High Wycombe','uk','England',80357.0,-0.78,51.64).
city('Hinckley','uk','England',45130.0,-1.37,52.54).
city('Hindley','uk','England',24169.0,-2.59,53.54).
city('Hitchin','uk','England',33830.0,-0.28,51.96).
city('Hoddesdon','uk','England',35174.0,-0.02,51.76).
city('Holbeach','uk','England',7408.0,0.02,52.81).
city('Holmfirth-Honley','uk','England',23317.0,-1.79,53.58).
city('Honiton','uk','England',11463.0,-3.2,50.81).
city('Horsham','uk','England',50680.0,-0.33,51.07).
city('Houghton-le-Spring','uk','England',37840.0,-1.47,54.85).
city('Hove','uk','England',75174.0,-0.18,50.84).
city('Hoylake-West Kirby','uk','England',25935.0,-3.18,53.39).
city('Hucknall','uk','England',29729.0,-1.21,53.04).
city('Huddersfield','uk','England',149018.0,-1.8,53.66).
city('Huntingdon','uk','England',21059.0,-0.19,52.34).
city('Huyton-with-Roby','uk','England',54738.0,-2.86,53.41).
city('Hyde','uk','England',31926.0,-2.08,53.45).
city('Ilfracombe','uk','England',10486.0,-4.13,51.21).
city('Ilkeston','uk','England',38587.0,-1.31,52.97).
city('Ipswich','uk','England',143768.0,1.14,52.07).
city('Ivybridge','uk','England',13277.0,-3.93,50.39).
city('Jarrow','uk','England',27264.0,-1.52,54.97).
city('Keighley','uk','England',50171.0,-1.92,53.87).
city('Kendal','uk','England',29468.0,-2.74,54.33).
city('Kenilworth','uk','England',22799.0,-1.58,52.34).
city('Kettering','uk','England',53329.0,-0.73,52.4).
city('Kidderminster','uk','England',56657.0,-2.27,52.4).
city('Kidsgrove','uk','England',29480.0,-2.26,53.09).
city('Kings Lynn','uk','England',41640.0,0.4,52.75).
city('Kingsteignton','uk','England',11360.0,-3.61,50.55).
city('Kingston upon Hull','uk','England',302297.0,-0.36,53.75).
city('Kingswood','uk','England',64793.0,-2.53,51.46).
city('Kirkby','uk','England',39208.0,-2.89,53.49).
city('Kirkby in Ashfield','uk','England',27539.0,-1.26,53.11).
city('Lancaster','uk','England',47162.0,-2.8,54.05).
city('Leatherhead','uk','England',43544.0,-0.34,51.3).
city('Leeds','uk','England',455124.0,-1.55,53.81).
city('Leicester','uk','England',339240.0,-1.13,52.64).
city('Leigh','uk','England',43627.0,-2.53,53.5).
city('Leighton Buzzard','uk','England',33467.0,-0.67,51.93).
city('Letchworth','uk','England',33955.0,-0.23,51.99).
city('Lewes','uk','England',16479.0,0.01,50.88).
city('Leyland','uk','England',37615.0,-2.7,53.7).
city('Lichfield','uk','England',28973.0,-1.84,52.69).
city('Lincoln','uk','England',89228.0,-0.55,53.25).
city('Litherland','uk','England',22971.0,-3.0,53.47).
city('Littlehampton','uk','England',58714.0,-0.54,50.82).
city('Liverpool','uk','England',468946.0,-2.99,53.42).
city('Locks Heath','uk','England',40374.0,-1.28,50.87).
city('London','uk','England',7421228.0,-0.1,51.52).
city('Long Eaton','uk','England',47898.0,-1.27,52.9).
city('Longbenton-Killingworth','uk','England',35362.0,-1.57,55.0).
city('Loughborough','uk','England',59317.0,-1.22,52.77).
city('Loughton','uk','England',42229.0,0.06,51.66).
city('Louth','uk','England',16635.0,-0.01,53.37).
city('Lowestoft','uk','England',71479.0,1.72,52.49).
city('Luton','uk','England',193670.0,-0.44,51.9).
city('Lytham Saint Annes','uk','England',42168.0,-3.02,53.75).
city('Mablethorpe-Sutton on Sea','uk','England',12386.0,0.26,53.33).
city('Macclesfield','uk','England',51739.0,-2.15,53.27).
city('Maghull-Lydiate','uk','England',29079.0,-2.94,53.52).
city('Maidenhead','uk','England',59463.0,-0.74,51.53).
city('Maidstone','uk','England',90894.0,0.51,51.28).
city('Manchester','uk','England',395516.0,-2.25,53.48).
city('Mangotsfield','uk','England',36427.0,-2.5,51.48).
city('Mansfield','uk','England',70447.0,-1.21,53.15).
city('Margate','uk','England',60134.0,1.4,51.39).
city('Matlock','uk','England',11516.0,-1.55,53.14).
city('Melton Mowbray','uk','England',26405.0,-0.9,52.77).
city('Middlesbrough','uk','England',142708.0,-1.23,54.58).
city('Middleton','uk','England',45589.0,-2.21,53.56).
city('Milton Keynes','uk','England',31967.0,-0.75,52.02).
city('Morecambe','uk','England',51645.0,-2.86,54.08).
city('Morley','uk','Engl',57386.0,-1.6,53.74).
city('Nailsea','uk','England',16537.0,-2.77,51.43).
city('Nelson','uk','England',29317.0,-2.22,53.84).
city('New Addington','uk','England',21717.0,-0.01,51.34).
city('New Milton-Barton-on-Sea','uk','England',28162.0,-1.66,50.75).
city('Newark-on-Trent','uk','England',36204.0,-0.82,53.08).
city('Newburn','uk','England',41347.0,-1.73,54.98).
city('Newbury','uk','England',33065.0,-1.33,51.4).
city('Newcastle upon Tyne','uk','England',192382.0,-1.6,55.0).
city('Newcastle-under-Lyme','uk','England',75795.0,-2.23,53.02).
city('Newport','uk','England',24200.0,-1.31,50.71).
city('Newton Abbot','uk','England',25789.0,-3.6,50.54).
city('Newton Aycliffe','uk','England',26269.0,-1.56,54.62).
city('North Shields','uk','England',39747.0,-1.45,55.01).
city('Northallerton','uk','England',16480.0,-1.44,54.34).
city('Northam','uk','England',7668.0,-4.22,51.05).
city('Northampton','uk','England',197323.0,-0.9,52.24).
city('Northfleet','uk','England',24531.0,-0.34,51.45).
city('Northwich','uk','England',42113.0,-2.52,53.26).
city('Norwich','uk','England',177636.0,1.28,52.65).
city('Nottingham','uk','England',246655.0,-1.18,52.97).
city('Nuneaton','uk','England',73555.0,-1.49,52.53).
city('Oakengates-Donnington','uk','England',33145.0,-2.46,52.7).
city('Oakham','uk','England',10150.0,-0.72,52.67).
city('Oldbury-Smethwick','uk','England',139702.0,-2.03,52.51).
city('Oldham','uk','England',104783.0,-2.12,53.55).
city('Ormskirk','uk','England',23792.0,-2.9,53.57).
city('Ossett','uk','England',21616.0,-1.57,53.67).
city('Oxford','uk','England',154567.0,-1.26,51.76).
city('Paignton','uk','England',49886.0,-3.58,50.44).
city('Penzance','uk','England',20812.0,-5.56,50.13).
city('Peterborough','uk','England',140142.0,-0.25,52.59).
city('Peterlee','uk','England',29979.0,-1.34,54.77).
city('Plymouth','uk','England',247298.0,-4.16,50.38).
city('Pontefract','uk','England',28620.0,-1.31,53.69).
city('Poole','uk','England',150092.0,-1.98,50.72).
city('Portsmouth','uk','England',194151.0,-1.09,50.81).
city('Potters Bar','uk','England',22192.0,-0.19,51.7).
city('Prescot','uk','England',40889.0,-2.81,53.43).
city('Preston','uk','England',190688.0,-2.73,53.76).
city('Prestwich','uk','England',32125.0,-2.28,53.53).
city('Pudsey','uk','England',33109.0,-1.67,53.8).
city('Radcliffe','uk','England',35638.0,-2.32,53.57).
city('Ramsgate','uk','England',38624.0,1.4,51.34).
city('Rawtenstall','uk','England',22115.0,-2.29,53.7).
city('Rayleigh','uk','England',31696.0,-0.61,51.59).
city('Reading','uk','England',244071.0,-0.98,51.45).
city('Redcar','uk','England',37203.0,-1.07,54.61).
city('Redditch','uk','England',77129.0,-1.94,52.31).
city('Reigate','uk','England',52123.0,-0.22,51.24).
city('Rochdale','uk','England',97550.0,-2.16,53.62).
city('Rochester','uk','England',28671.0,0.49,51.38).
city('Rotherham','uk','England',117619.0,-1.35,53.44).
city('Rottingdean','uk','England',21756.0,-0.04,50.81).
city('Royal Leamington Spa','uk','England',64641.0,-1.56,52.29).
city('Royal Tunbridge Wells','uk','England',61075.0,0.26,51.14).
city('Royton','uk','England',22848.0,-2.12,53.57).
city('Rugby','uk','England',63323.0,-1.28,52.37).
city('Rugeley','uk','England',22937.0,-1.94,52.76).
city('Runcorn','uk','England',59679.0,-2.75,53.34).
city('Rushden','uk','England',26307.0,-0.6,52.29).
city('Ryde','uk','England',24107.0,-1.17,50.74).
city('Saint Albans','uk','England',84561.0,-0.34,51.75).
city('Saint Austell','uk','England',23432.0,-4.78,50.35).
city('Saint Helens','uk','England',102555.0,-2.75,53.46).
city('Sale','uk','England',55689.0,-2.34,53.42).
city('Salford','uk','England',70905.0,-2.31,53.48).
city('Salisbury','uk','England',45600.0,-1.8,51.08).
city('Scarborough','uk','England',38909.0,-0.43,54.29).
city('Scunthorpe','uk','England',72515.0,-0.67,53.59).
city('Seaham','uk','England',21170.0,-1.34,54.84).
city('Sevenoaks','uk','England',27871.0,0.18,51.28).
city('Sheffield','uk','England',447048.0,-1.48,53.39).
city('Shipley','uk','England',28544.0,-1.78,53.83).
city('Shrewsbury','uk','England',69520.0,-2.75,52.71).
city('Sidmouth','uk','England',11853.0,-3.25,50.69).
city('Sittingbourne','uk','England',41148.0,0.73,51.35).
city('Skegness','uk','England',17072.0,0.33,53.15).
city('Skelmersdale','uk','England',38944.0,-2.8,53.55).
city('Sleaford','uk','England',15558.0,-0.42,53.01).
city('Slough','uk','England',134072.0,-0.61,51.52).
city('Solihull','uk','England',96268.0,-1.78,52.42).
city('Sompting-Lancing','uk','England',31324.0,-0.34,50.84).
city('South Shields','uk','England',83656.0,-1.43,55.0).
city('Southampton','uk','England',246201.0,-1.41,50.91).
city('Southend-on-Sea','uk','England',163378.0,0.71,51.55).
city('Southport','uk','England',93044.0,-3.01,53.66).
city('Spalding','uk','England',22357.0,-0.18,52.79).
city('Stafford','uk','England',65290.0,-2.12,52.81).
city('Staines','uk','England',51040.0,-0.51,51.43).
city('Stalybridge','uk','England',22748.0,-2.07,53.49).
city('Stamford','uk','England',20526.0,-0.49,52.66).
city('Stanford le Hope-Corringham','uk','England',30265.0,0.43,51.52).
city('Stanley','uk','England',19204.0,-1.71,54.87).
city('Staveley','uk','England',25719.0,-1.35,53.27).
city('Stevenage','uk','England',84652.0,-0.21,51.92).
city('Stockport','uk','England',139053.0,-2.17,53.42).
city('Stockton Heath-Thelwall','uk','England',27444.0,-2.52,53.38).
city('Stockton-on-Tees','uk','England',79957.0,-1.32,54.57).
city('Stoke-on-Trent','uk','England',260420.0,-2.19,53.01).
city('Stourbridge','uk','England',56284.0,-2.16,52.46).
city('Stratford-upon-Avon','uk','England',22576.0,-1.71,52.2).
city('Stretford','uk','England',41954.0,-2.31,53.46).
city('Strood','uk','England',33381.0,0.48,51.39).
city('Stroud','uk','England',30600.0,-2.23,51.75).
city('Stubbington','uk','England',13932.0,-1.22,50.83).
city('Sunbury','uk','England',27784.0,-0.42,51.42).
city('Sunderland','uk','England',177965.0,-1.39,54.91).
city('Sutton Coldfield','uk','England',107030.0,-1.84,52.56).
city('Sutton in Ashfield','uk','England',43912.0,-1.27,53.13).
city('Swadlincote','uk','England',40961.0,-1.56,52.78).
city('Swanley-Hextable','uk','England',21276.0,-0.17,51.4).
city('Swindon','uk','England',162439.0,-1.78,51.57).
city('Swinton and Pendlebury','uk','England',41121.0,-2.33,53.52).
city('Tamworth','uk','England',74130.0,-1.69,52.63).
city('Taunton','uk','England',60433.0,-3.11,51.03).
city('Tavistock','uk','England',11493.0,4.16,50.55).
city('Teignmouth','uk','England',15498.0,-3.51,50.56).
city('Telford','uk','England',43244.0,-2.47,52.68).
city('Thatcham','uk','England',24275.0,-1.27,51.41).
city('Thetford','uk','England',22787.0,-0.74,52.42).
city('Thornaby','uk','England',22356.0,-1.3,54.54).
city('Thornton-Cleveleys','uk','England',32808.0,-3.04,53.87).
city('Tiverton','uk','England',16799.0,-3.49,50.92).
city('Tonbridge','uk','England',36894.0,0.28,51.2).
city('Torquay','uk','England',65389.0,-3.52,50.47).
city('Totton','uk','England',29261.0,-1.49,50.92).
city('Trowbridge','uk','England',36922.0,-2.22,51.32).
city('Truro','uk','England',22044.0,-5.05,50.27).
city('Tyldesley','uk','England',35932.0,-2.47,53.51).
city('Urmston','uk','England',41198.0,-2.38,53.45).
city('Wakefield','uk','England',78978.0,-1.5,53.68).
city('Walkden','uk','England',35938.0,-2.4,53.52).
city('Wallasey','uk','England',58794.0,-3.05,53.43).
city('Wallsend','uk','England',42739.0,-1.53,54.99).
city('Walsall','uk','England',172142.0,-1.97,52.6).
city('Walton and Weybridge','uk','England',53864.0,-0.47,51.37).
city('Warrington','uk','England',81238.0,-2.6,53.39).
city('Warwick','uk','England',24040.0,-1.59,52.29).
city('Washington','uk','England',53527.0,-1.53,54.91).
city('Waterlooville','uk','England',64350.0,-1.05,50.89).
city('Watford','uk','England',125708.0,-0.4,51.66).
city('Wellingborough','uk','England',49783.0,-0.7,52.3).
city('Welwyn Garden City','uk','England',44725.0,-0.21,51.8).
city('West Bridgeford','uk','England',48314.0,-1.13,52.93).
city('West Bromwich','uk','England',135618.0,-1.97,52.53).
city('Westhoughton','uk','England',22994.0,-2.5,53.55).
city('Weston-super-Mare','uk','England',82903.0,-2.98,51.36).
city('Weymouth','uk','England',50253.0,-2.48,50.62).
city('Whitefield','uk','England',23546.0,-2.29,53.55).
city('Whitehaven','uk','England',24803.0,-3.59,54.54).
city('Whitley Bay','uk','England',38055.0,-1.47,55.05).
city('Wickford','uk','England',32975.0,0.52,51.61).
city('Widnes','uk','England',56098.0,-2.75,53.36).
city('Wigan','uk','England',80789.0,-2.64,53.55).
city('Wigston','uk','England',33720.0,-1.12,52.59).
city('Wilmslow','uk','England',36618.0,-2.23,53.34).
city('Wimbourne Minster','uk','England',15175.0,-1.98,50.8).
city('Winchester','uk','England',44094.0,-1.33,51.07).
city('Windsor-Eton','uk','England',31128.0,-0.61,51.48).
city('Winsford','uk','England',30812.0,-2.55,53.19).
city('Wisbech','uk','England',27595.0,-0.16,52.67).
city('Witham','uk','England',22995.0,0.63,51.8).
city('Witney','uk','England',24103.0,-1.5,51.79).
city('Woking-Byfleet','uk','England',103933.0,-0.57,51.32).
city('Wokingham','uk','England',41144.0,-0.85,51.42).
city('Wolverhampton','uk','England',252792.0,-2.15,52.59).
city('Wolverton-Stony Stratford','uk','England',63167.0,-0.75,52.03).
city('Worcester','uk','England',100023.0,-2.24,52.2).
city('Workington','uk','England',20618.0,-3.55,54.64).
city('Worksop','uk','England',40443.0,-1.13,53.31).
city('Worthing','uk','England',99110.0,-0.38,50.82).
city('Yeovil','uk','England',43733.0,-2.65,50.95).
city('York','uk','England',144202.0,-1.11,53.96).
city('Antrim','uk','Northern Ireland',25525.0,-6.23,54.72).
city('Ballymena','uk','Northern Ireland',30997.0,-6.29,54.87).
city('Bangor','uk','Northern Ireland',62568.0,-5.68,54.66).
city('Belfast','uk','Northern Ireland',585994.0,-5.93,54.6).
city('Carrickfergus','uk','Northern Ireland',33080.0,-5.8,54.73).
city('Coleraine','uk','Northern Ireland',24509.0,-6.69,55.13).
city('Lisburn','uk','Northern Ireland',45314.0,-6.06,54.52).
city('Londonderry','uk','Northern Ireland',86312.0,-7.33,55.0).
city('Lurgan','uk','Northern Ireland',23602.0,-6.34,54.47).
city('Newry','uk','Northern Ireland',26271.0,-6.35,54.18).
city('Newtonabbey','uk','Northern Ireland',59416.0,-5.93,54.66).
city('Newtownards','uk','Northern Ireland',28878.0,-5.7,54.6).
city('Omagh','uk','Northern Ireland',18463.0,-7.31,54.6).
city('Portadown','uk','Northern Ireland',21617.0,-6.45,54.43).
city('Aberchirder','uk','Scotland',1159.0,-2.62,57.55).
city('Aberdeen','uk','Scotland',183791.0,-2.1,57.15).
city('Aberdour','uk','Scotland',1742.0,-3.3,56.05).
city('Aberfeldy','uk','Scotland',1937.0,-3.85,56.62).
city('Aberfoyle','uk','Scotland',577.0,-4.38,56.18).
city('Aberlady','uk','Scotland',876.0,-2.85,56.0).
city('Aberlour','uk','Scotland',828.0,-3.23,57.47).
city('Abernethy','uk','Scotland',1010.0,-3.33,56.33).
city('Aboyne','uk','Scotland',2236.0,-2.83,57.08).
city('Airdrie','uk','Scotland',35440.0,-3.99,55.87).
city('Airth','uk','Scotland',1414.0,-3.77,56.07).
city('Alford','uk','Scotland',2237.0,-2.7,57.22).
city('Allanton','uk','Scotland',1266.0,-2.22,55.78).
city('Alloa','uk','Scotland',18885.0,-3.79,56.13).
city('Almondbank','uk','Scotland',617.0,-3.55,56.4).
city('Alness','uk','Scotland',4921.0,-4.25,57.68).
city('Alva','uk','Scotland',5130.0,-3.8,56.15).
city('Alyth','uk','Scotland',2354.0,-3.22,56.62).
city('Annan','uk','Scotland',8231.0,-3.27,54.98).
city('Annbank','uk','Scotland',822.0,-4.52,55.47).
city('Anstruther','uk','Scotland',3527.0,-2.7,56.22).
city('Arbroath','uk','Scotland',22291.0,-2.61,56.56).
city('Ardersier','uk','Scotland',930.0,-4.03,57.57).
city('Ardrishaig','uk','Scotland',1261.0,-5.45,56.02).
city('Ardrossan','uk','Scotland',10936.0,-4.86,55.69).
city('Armadale','uk','Scotland',9026.0,-3.7,55.9).
city('Auchinleck','uk','Scotland',3282.0,-4.3,55.47).
city('Auchterarder','uk','Scotland',4220.0,-3.7,56.3).
city('Auchtermuchty','uk','Scotland',2023.0,-3.22,56.28).
city('Aviemore','uk','Scotland',2545.0,-3.83,57.2).
city('Avoch','uk','Scotland',843.0,-4.17,57.57).
city('Avonbridge','uk','Scotland',560.0,-3.75,55.93).
city('Ayr','uk','Scotland',45514.0,-4.64,55.47).
city('Ayton','uk','Scotland',548.0,-2.13,55.85).
city('Baile a Mhainich','uk','Scotland',386.0,-7.39,57.47).
city('Balfron','uk','Scotland',1605.0,-4.33,56.07).
city('Balintore','uk','Scotland',1045.0,-3.9,57.75).
city('Ballachulish','uk','Scotland',633.0,-5.12,56.67).
city('Ballater','uk','Scotland',1466.0,-3.05,57.05).
city('Ballingry','uk','Scotland',5758.0,-3.33,56.15).
city('Balloch','uk','Scotland',1743.0,-4.58,56.0).
city('Balmedie','uk','Scotland',1814.0,-2.05,57.25).
city('Balmullo','uk','Scotland',1085.0,-2.92,56.37).
city('Banchory','uk','Scotland',5978.0,-2.52,57.05).
city('Banff','uk','Scotland',3914.0,-2.53,57.67).
city('Bankfoot','uk','Scotland',1178.0,-3.52,56.5).
city('Bankno','uk','Scotland',2456.0,-3.95,55.98).
city('Bathgate','uk','Scotland',15337.0,-3.65,55.9).
city('Bearsden','uk','Scotland',27839.0,-4.34,55.93).
city('Beauly','uk','Scotland',1169.0,-4.47,57.47).
city('Beith','uk','Scotland',6288.0,-4.63,55.73).
city('Bellshill','uk','Scotland',20201.0,-4.02,55.82).
city('Biggar','uk','Scotland',2120.0,-3.52,55.62).
city('Birkhill-Muirhead','uk','Scotland',1991.0,-3.08,57.02).
city('Birntisland','uk','Scotland',6098.0,-3.24,56.06).
city('Bishopbriggs','uk','Scotland',22668.0,-4.24,55.9).
city('Bishopton','uk','Scotland',5029.0,-4.5,55.9).
city('Blackburn','uk','Scotland',2884.0,-2.96,56.54).
city('Blackford','uk','Scotland',541.0,-3.77,56.25).
city('Blackridge','uk','Scotland',1539.0,-3.77,55.89).
city('Blackwood','uk','Scotland',1901.0,-3.93,55.68).
city('Blairgowrie','uk','Scotland',8081.0,-3.33,56.58).
city('Blairhall','uk','Scotland',651.0,-3.6,56.07).
city('Blantyre','uk','Scotland',16739.0,-4.11,55.79).
city('Boat of Garten','uk','Scotland',517.0,-3.73,57.3).
city('Boddam','uk','Scotland',1327.0,-1.78,57.47).
city('Boness','uk','Scotland',13686.0,-3.51,55.99).
city('Bonnybridge','uk','Scotland',7123.0,-3.89,56.0).
city('Bowmore','uk','Scotland',852.0,-6.28,55.75).
city('Braco','uk','Scotland',455.0,-3.88,56.25).
city('Brae','uk','Scotland',622.0,-1.35,60.38).
city('Brechin','uk','Scotland',6977.0,-2.65,56.73).
city('Bridge of Earn','uk','Scotland',2231.0,-3.4,56.33).
city('Bridge of Weir','uk','Scotland',4418.0,-4.58,55.85).
city('Broadford','uk','Scotland',522.0,-5.92,57.23).
city('Brodick','uk','Scotland',655.0,-5.17,55.58).
city('Brora','uk','Scotland',1095.0,-3.87,58.02).
city('Broxburn','uk','Scotland',13288.0,-3.47,55.93).
city('Buchlyvie','uk','Scotland',448.0,-4.3,56.12).
city('Buckhaven','uk','Scotland',16063.0,-3.04,56.19).
city('Buckie','uk','Scotland',7860.0,-2.97,57.67).
city('Burghead','uk','Scotland',1684.0,-3.48,57.7).
city('Burrelton','uk','Scotland',633.0,-3.3,56.52).
city('Cairnbulg-Inverallochy','uk','Scotland',1250.0,-1.93,57.67).
city('Cairneyhill','uk','Scotland',2660.0,-3.53,56.05).
city('Caldercruix','uk','Scotland',1980.0,-3.88,55.88).
city('California','uk','Scotland',683.0,-3.75,55.97).
city('Callander','uk','Scotland',2782.0,-4.23,56.25).
city('Campbeltown','uk','Scotland',4939.0,-5.63,55.43).
city('Cardenden','uk','Scotland',4913.0,-3.25,56.13).
city('Cardross','uk','Scotland',1897.0,-4.63,55.97).
city('Cargenbridge','uk','Scotland',538.0,-3.64,55.05).
city('Carluke','uk','Scotland',13465.0,-3.84,55.73).
city('Car','uk','Scotland',1080.0,-4.27,55.78).
city('Carnoustie','uk','Scotland',10500.0,-2.71,56.5).
city('Carnwath','uk','Scotland',1471.0,-3.63,55.68).
city('Carradale','uk','Scotland',497.0,-5.48,55.58).
city('Carstairs','uk','Scotland',691.0,-3.7,55.7).
city('Castle Douglas','uk','Scotland',3631.0,-3.95,54.93).
city('Castletown','uk','Scotland',772.0,-3.38,58.58).
city('Catrine','uk','Scotland',1974.0,-4.32,55.48).
city('Catstairs Junction','uk','Scotland',889.0,-3.67,55.68).
city('Ceres','uk','Scotland',1023.0,-2.97,56.28).
city('Chapelton','uk','Scotland',760.0,-4.08,55.72).
city('Chirnside','uk','Scotland',1176.0,-2.2,55.8).
city('Chryston','uk','Scotland',2495.0,-4.1,55.9).
city('Clackmannan','uk','Scotland',3432.0,-3.75,56.1).
city('Cleland','uk','Scotland',2733.0,-3.9,55.8).
city('Clydebank','uk','Scotland',29867.0,-4.39,55.91).
city('Coalburn','uk','Scotland',1267.0,-3.9,55.58).
city('Coaltown of Wemyss','uk','Scotland',524.0,-3.1,56.15).
city('Coatbridge','uk','Scotland',39752.0,-4.14,55.8).
city('Cockenzie','uk','Scotland',5962.0,-2.95,55.95).
city('Col','uk','Scotland',1052.0,-6.32,58.27).
city('Coldingham','uk','Scotland',631.0,-2.17,55.88).
city('Coldstream','uk','Scotland',1823.0,-2.25,55.65).
city('Comrie','uk','Scotland',2033.0,-4.0,56.37).
city('Cononbridge','uk','Scotland',2665.0,-4.43,57.57).
city('Coupar Angus','uk','Scotland',2160.0,-3.27,56.55).
city('Cowdenbeath','uk','Scotland',11350.0,-3.35,56.11).
city('Cowie','uk','Scotland',2506.0,-3.87,56.07).
city('Coylton','uk','Scotland',2607.0,-4.48,55.43).
city('Crail','uk','Scotland',1782.0,-2.63,55.27).
city('Creetown','uk','Scotland',677.0,-4.38,54.9).
city('Crieff','uk','Scotland',6685.0,-3.83,56.37).
city('Crimond','uk','Scotland',758.0,-1.9,57.6).
city('Cromarty','uk','Scotland',712.0,-4.03,57.67).
city('Crossford','uk','Scotland',1575.0,-3.68,55.88).
city('Crossgates','uk','Scotland',2200.0,-3.38,56.07).
city('Crosshill','uk','Scotland',495.0,-4.63,55.32).
city('Crosshouse','uk','Scotland',2418.0,-4.55,55.63).
city('Croy','uk','Scotland',641.0,-4.03,57.52).
city('Cruden Bay','uk','Scotland',1620.0,-1.83,57.42).
city('Cullen','uk','Scotland',1283.0,-2.82,57.68).
city('Cumbernauld','uk','Scotland',49393.0,-3.99,55.96).
city('Cuminestown','uk','Scotland',492.0,-2.33,57.53).
city('Cumnock','uk','Scotland',9189.0,-4.27,55.45).
city('Cupar','uk','Scotland',8822.0,-3.02,56.32).
city('Dailly','uk','Scotland',866.0,-4.72,55.27).
city('Dalbeattie','uk','Scotland',4205.0,-3.83,54.93).
city('Dalkeith','uk','Scotland',11502.0,-3.06,55.89).
city('Dalmellington-Burnton','uk','Scotland',1405.0,-4.38,55.32).
city('Dalry','uk','Scotland',5234.0,-4.72,55.68).
city('Dalrymple','uk','Scotland',1264.0,-4.58,55.38).
city('Danderhall','uk','Scotland',3030.0,-3.1,55.92).
city('Darvel','uk','Scotland',3225.0,-4.28,55.58).
city('Dechmont','uk','Scotland',741.0,-3.54,55.92).
city('Denholm','uk','Scotland',609.0,-2.68,55.45).
city('Dingwall','uk','Scotland',4687.0,-4.45,57.6).
city('Dirleton','uk','Scotland',496.0,-2.77,56.03).
city('Dollar','uk','Scotland',2845.0,-3.67,56.15).
city('Dornoch','uk','Scotland',1261.0,-4.03,57.87).
city('Douglas','uk','Scotland',1685.0,-3.85,55.55).
city('Doune','uk','Scotland',1616.0,-4.08,56.2).
city('Drongan','uk','Scotland',2860.0,-4.45,55.43).
city('Drumnadrochit','uk','Scotland',881.0,-4.48,57.33).
city('Drymen','uk','Scotland',623.0,-4.43,56.07).
city('Dufftown','uk','Scotland',1384.0,-3.13,57.43).
city('Dumbarton','uk','Scotland',19878.0,-4.57,55.95).
city('Dumf','uk','Scotland',30656.0,-3.63,55.07).
city('Dunbar','uk','Scotland',6414.0,-2.52,56.0).
city('Dunbeg','uk','Scotland',716.0,-5.45,56.45).
city('Dunblane','uk','Scotland',8056.0,-3.97,56.2).
city('Dundee','uk','Scotland',151593.0,-3.0,56.47).
city('Dundonald','uk','Scotland',2399.0,-4.58,55.57).
city('Dunfermline','uk','Scotland',38961.0,-3.46,56.07).
city('Dunkeld-Birnam','uk','Scotland',940.0,-3.58,56.57).
city('Dunlop','uk','Scotland',844.0,-4.53,55.7).
city('Dunning','uk','Scotland',955.0,-3.58,56.3).
city('Dunoon','uk','Scotland',7981.0,-4.93,55.95).
city('Duns','uk','Scotland',2630.0,-2.35,55.77).
city('Eaglesfield','uk','Scotland',601.0,-3.2,55.05).
city('Eaglesham','uk','Scotland',3077.0,-4.27,55.73).
city('Earlston','uk','Scotland',1728.0,-2.67,55.63).
city('East Kilbride','uk','Scotland',74231.0,-4.18,55.77).
city('East Linton','uk','Scotland',2008.0,-2.65,55.98).
city('East Wemyss','uk','Scotland',1856.0,-3.07,56.15).
city('East Whitburn','uk','Scotland',1131.0,-3.67,55.87).
city('Eastfield','uk','Scotland',5841.0,-3.77,55.85).
city('Eastriggs','uk','Scotland',1665.0,-3.18,54.98).
city('Ecclefechan','uk','Scotland',705.0,-3.27,55.05).
city('Edinburgh','uk','Scotland',435794.0,-3.22,55.95).
city('Edzell','uk','Scotland',790.0,-2.65,56.8).
city('Elgin','uk','Scotland',21236.0,-3.32,57.65).
city('Elie','uk','Scotland',949.0,-2.82,56.2).
city('Ellon','uk','Scotland',8750.0,-2.09,57.35).
city('Elphinstone','uk','Scotland',502.0,-2.98,55.93).
city('Errol','uk','Scotland',1039.0,-3.2,56.38).
city('Erskine','uk','Scotland',16146.0,-4.52,55.87).
city('Evanton','uk','Scotland',1138.0,-4.33,57.67).
city('Eyemouth','uk','Scotland',3395.0,-2.1,55.87).
city('Fairlie','uk','Scotland',1568.0,-4.85,55.75).
city('Falkirk','uk','Scotland',32479.0,-3.79,56.02).
city('Falkland','uk','Scotland',1168.0,-3.2,56.25).
city('Fauldhouse','uk','Scotland',4610.0,-3.72,55.82).
city('Fenwick','uk','Scotland',828.0,-4.45,55.67).
city('Findhorn','uk','Scotland',1040.0,-3.6,57.6).
city('Findochty','uk','Scotland',1102.0,-2.9,57.68).
city('Flirth-Mossbank','uk','Scotland',564.0,-1.2,60.45).
city('Fochabers','uk','Scotland',1494.0,-3.08,57.62).
city('Forfar','uk','Scotland',13237.0,-2.9,56.65).
city('Forres','uk','Scotland',9134.0,-3.62,57.6).
city('Fort Augustus','uk','Scotland',499.0,-4.68,57.13).
city('Fort William','uk','Scotland',9652.0,-5.12,56.82).
city('Forth','uk','Scotland',2087.0,-3.68,55.75).
city('Fortrose','uk','Scotland',1206.0,-4.13,57.58).
city('Fraserburgh','uk','Scotland',12249.0,-2.03,57.69).
city('Freuchie','uk','Scotland',1120.0,-3.15,56.23).
city('Friockheim','uk','Scotland',787.0,-2.63,56.63).
city('Fyvie','uk','Scotland',499.0,-2.38,57.42).
city('Galashiels','uk','Scotland',14351.0,-2.82,55.62).
city('Galston','uk','Scotland',4902.0,-4.38,55.58).
city('Gardenstown','uk','Scotland',700.0,-2.33,57.67).
city('Garelochhead','uk','Scotland',1296.0,-4.85,56.08).
city('Gargunnock','uk','Scotland',677.0,-4.08,56.12).
city('Gartcosh','uk','Scotland',999.0,-4.08,55.9).
city('Gatehouse of Fleet','uk','Scotland',875.0,-4.18,54.88).
city('Gauldry','uk','Scotland',768.0,-3.0,56.4).
city('Giffnock','uk','Scotland',16038.0,-4.29,55.8).
city('Gifford','uk','Scotland',674.0,-2.73,55.9).
city('Girvan','uk','Scotland',6821.0,-4.87,55.23).
city('Glasgow','uk','Scotland',610271.0,-4.27,55.87).
city('Glassford','uk','Scotland',606.0,-4.03,55.7).
city('Glenboig','uk','Scotland',1468.0,-4.03,55.88).
city('Glenfarg','uk','Scotland',449.0,-3.4,56.27).
city('Glenlu','uk','Scotland',618.0,-4.83,54.87).
city('Glenmavies','uk','Scotland',2294.0,-3.99,55.88).
city('Glenrothes','uk','Scotland',38734.0,-3.16,56.2).
city('Golspie','uk','Scotland',1381.0,-3.97,57.97).
city('Gorebridge','uk','Scotland',5874.0,-3.05,55.83).
city('Gourdon','uk','Scotland',569.0,-2.28,56.82).
city('Grantown-on-Spey','uk','Scotland',2122.0,-3.62,57.31).
city('Greenlaw','uk','Scotland',570.0,-2.47,55.7).
city('Greenock','uk','Scotland',43496.0,-4.79,55.96).
city('Gretna','uk','Scotland',2692.0,-3.07,54.98).
city('Gullane','uk','Scotland',2133.0,-2.82,56.03).
city('Haddington','uk','Scotland',8780.0,-2.79,55.96).
city('Halkirk','uk','Scotland',897.0,-3.5,58.5).
city('Hamnavoe','uk','Scotland',562.0,-1.34,60.1).
city('Harthill','uk','Scotland',3464.0,-3.75,55.87).
city('Hatton of Cruden','uk','Scotland',803.0,-1.91,57.42).
city('Hawick','uk','Scotland',14053.0,-2.8,55.43).
city('Hawkhead','uk','Scotland',968.0,-4.38,55.83).
city('Helensburgh','uk','Scotland',14108.0,-4.73,56.02).
city('Helmsdale','uk','Scotland',637.0,-3.67,58.12).
city('High Valleyfield','uk','Scotland',2837.0,-3.6,56.05).
city('Hillside','uk','Scotland',999.0,-2.48,56.73).
city('Hopeman','uk','Scotland',1675.0,-3.42,57.7).
city('Houston','uk','Scotland',7031.0,-4.55,55.87).
city('Huntly','uk','Scotland',4390.0,-2.78,57.45).
city('Hurlford-Crookedholm','uk','Scotland',4777.0,-4.45,55.58).
city('Inchture','uk','Scotland',715.0,-3.17,56.43).
city('Innellan','uk','Scotland',1132.0,-4.97,55.88).
city('Innerleithen','uk','Scotland',2591.0,-3.07,55.62).
city('Insch','uk','Scotland',1504.0,-2.62,57.33).
city('Inveraray','uk','Scotland',568.0,-5.07,56.23).
city('Inverbervie','uk','Scotland',2162.0,-2.27,56.85).
city('Invergordon','uk','Scotland',3949.0,-4.18,57.68).
city('Inverkeithing','uk','Scotland',5163.0,-3.38,56.03).
city('Inverkip','uk','Scotland',1733.0,-4.87,55.9).
city('Inverness','uk','Scotland',40755.0,-4.24,57.49).
city('Inverurie','uk','Scotland',11324.0,-2.37,57.27).
city('Irvine','uk','Scotland',32749.0,-4.69,55.62).
city('Jedburgh','uk','Scotland',4045.0,-2.57,55.47).
city('Johnshaven','uk','Scotland',641.0,-2.33,56.78).
city('Keith','uk','Scotland',4396.0,-2.93,57.53).
city('Kelso','uk','Scotland',5154.0,-2.43,55.58).
city('Kelty','uk','Scotland',5644.0,-3.38,56.13).
city('Kemnay','uk','Scotland',3889.0,-2.45,57.23).
city('Kennoway','uk','Scotland',4596.0,-3.05,56.2).
city('Kilbirnie','uk','Scotland',6972.0,-4.7,55.75).
city('Kilcreggan','uk','Scotland',1343.0,-4.83,55.98).
city('Killin','uk','Scotland',666.0,-4.32,56.47).
city('Kilmacolm','uk','Scotland',3887.0,-4.62,55.88).
city('Kilmarnock','uk','Scotland',42905.0,-4.5,55.62).
city('Kilmaurs','uk','Scotland',2528.0,-4.53,55.63).
city('Kilsyth','uk','Scotland',9662.0,-4.06,55.98).
city('Kilwinning','uk','Scotland',16000.0,-4.71,55.66).
city('Kincardine','uk','Scotland',3014.0,-3.72,56.07).
city('Kinghorn','uk','Scotland',2776.0,-3.17,56.07).
city('Kinglassie','uk','Scotland',1274.0,-3.23,56.17).
city('Kingseat','uk','Scotland',500.0,-3.4,56.68).
city('Kingskettle','uk','Scotland',993.0,-3.12,56.25).
city('Kingswells','uk','Scotland',4568.0,-2.22,57.15).
city('Kingussie','uk','Scotland',1442.0,-4.05,57.08).
city('Kinlochleven','uk','Scotland',831.0,-4.97,56.7).
city('Kinloss','uk','Scotland',2011.0,-3.57,57.62).
city('Kinross','uk','Scotland',4691.0,-3.42,56.2).
city('Kintore','uk','Scotland',1688.0,-2.35,57.22).
city('Kippen','uk','Scotland',990.0,-4.17,56.12).
city('Kirkcaldy','uk','Scotland',46436.0,-3.16,57.14).
city('Kirkconnel','uk','Scotland',1993.0,-4.0,55.38).
city('Kirkcudbright','uk','Scotland',3367.0,-4.03,54.83).
city('Kirkfieldbank','uk','Scotland',890.0,-3.82,55.67).
city('Kirkintilloch','uk','Scotland',19489.0,-4.17,55.93).
city('Kirkliston','uk','Scotland',3139.0,-3.4,55.95).
city('Kirkmuirhill-Blackwood','uk','Scotland',3656.0,-3.92,55.68).
city('Kirknewton','uk','Scotland',1755.0,-3.42,55.88).
city('Kirkton of Largo','uk','Scotland',496.0,-2.92,56.22).
city('Kirkwall','uk','Scotland',6196.0,-2.96,58.99).
city('Kirriemuir','uk','Scotland',6108.0,-3.0,56.67).
city('Kyle of Lochalsh','uk','Scotland',734.0,-5.72,57.27).
city('Ladybank','uk','Scotland',1519.0,-3.13,56.27).
city('Lamlash','uk','Scotland',1046.0,-5.15,55.53).
city('Lanark','uk','Scotland',8152.0,-3.78,55.67).
city('Langbank','uk','Scotland',884.0,-4.58,55.92).
city('Langholm','uk','Scotland',2213.0,-3.0,55.15).
city('Largs','uk','Scotland',11126.0,-4.86,55.8).
city('Larkhall','uk','Scotland',15410.0,-3.97,55.73).
city('Lauder','uk','Scotland',1078.0,-2.75,55.7).
city('Laurencekirk','uk','Scotland',1916.0,-2.45,56.82).
city('Law','uk','Scotland',2994.0,-3.88,55.75).
city('Lennoxtown','uk','Scotland',3795.0,-4.2,55.97).
city('Lerwick','uk','Scotland',6594.0,-1.16,60.16).
city('Lesmahagow','uk','Scotland',3823.0,-3.9,55.62).
city('Letham','uk','Scotland',1591.0,-2.77,56.62).
city('Leuchars','uk','Scotland',2341.0,-2.88,56.38).
city('Lhanbryde','uk','Scotland',1845.0,-3.22,57.62).
city('Limekilns','uk','Scotland',1329.0,-3.47,56.03).
city('Linlithgow','uk','Scotland',13863.0,-3.62,55.97).
city('Livingston','uk','Scotland',53798.0,-3.5,55.91).
city('Loanhead','uk','Scotland',6358.0,-3.15,55.87).
city('Loans','uk','Scotland',825.0,-4.63,55.55).
city('Locharbriggs','uk','Scotland',6333.0,-3.58,55.1).
city('Lochgilphead','uk','Scotland',2272.0,-5.42,56.03).
city('Lochmaben','uk','Scotland',1910.0,-3.45,55.12).
city('Lochwinnoch','uk','Scotland',2684.0,-4.63,55.78).
city('Lockerbie','uk','Scotland',3986.0,-3.35,55.12).
city('Logan','uk','Scotland',1258.0,-4.23,55.45).
city('Longforgan','uk','Scotland',678.0,-3.12,56.45).
city('Longniddry','uk','Scotland',2482.0,-2.88,55.97).
city('Longridge','uk','Scotland',696.0,-3.67,55.85).
city('Longside','uk','Scotland',722.0,-1.93,57.52).
city('Lossiemouth','uk','Scotland',6841.0,-3.28,57.7).
city('Luncarty','uk','Scotland',1236.0,-3.47,56.45).
city('Lundin Links','uk','Scotland',2124.0,-2.95,56.2).
city('Macduff','uk','Scotland',3747.0,-2.48,57.67).
city('Macmerry','uk','Scotland',1082.0,-2.9,55.93).
city('Maidens','uk','Scotland',530.0,-4.82,55.33).
city('Mallaig','uk','Scotland',742.0,-5.83,57.0).
city('Mauchline','uk','Scotland',4137.0,-4.37,55.52).
city('Maud','uk','Scotland',673.0,-2.1,57.52).
city('Maybole','uk','Scotland',4447.0,-4.7,55.33).
city('Melrose','uk','Scotland',1640.0,-2.72,55.58).
city('Menstrie','uk','Scotland',1899.0,-3.85,56.15).
city('Methven','uk','Scotland',1161.0,-3.57,56.42).
city('Millport','uk','Scotland',1260.0,-4.95,55.75).
city('Milnathort','uk','Scotla',1885.0,-3.42,56.22).
city('Milton of Campsie','uk','Scotland',3932.0,-4.15,55.97).
city('Milton-Kildary','uk','Scotland',545.0,-4.07,57.75).
city('Mintlaw','uk','Scotland',2673.0,-2.0,57.52).
city('Moffat','uk','Scotland',2077.0,-3.45,55.32).
city('Monkton','uk','Scotland',668.0,-4.6,55.5).
city('Montrose','uk','Scotland',10620.0,-2.48,56.72).
city('Moodiesburn','uk','Scotland',6881.0,-4.08,55.92).
city('Mossblown','uk','Scotland',2021.0,-4.54,55.48).
city('Mosstodloch','uk','Scotland',991.0,-3.14,57.63).
city('Motherwell','uk','Scotland',29908.0,-4.0,55.79).
city('Muir of Ord','uk','Scotland',1807.0,-4.45,57.52).
city('Muirkirk','uk','Scotland',1539.0,-4.05,55.52).
city('Muirton-Gleneagles','uk','Scotland',494.0,-3.75,56.29).
city('Musselburgh','uk','Scotland',22656.0,-3.06,55.95).
city('Muthill','uk','Scotland',668.0,-3.83,56.32).
city('Nairn','uk','Scotland',8551.0,-3.87,57.58).
city('Neilston','uk','Scotland',5091.0,-4.42,55.78).
city('Netherburn','uk','Scotland',710.0,-3.92,55.7).
city('Nethy Bridge','uk','Scotland',498.0,-3.63,57.27).
city('New Cumnock','uk','Scotland',2884.0,-4.18,55.4).
city('New Deer','uk','Scotland',559.0,-2.2,57.5).
city('New Pitsligo','uk','Scotland',907.0,-2.18,57.58).
city('New Scone','uk','Scotland',4355.0,-3.4,56.42).
city('Newburgh','uk','Scotland',1643.0,-2.62,56.83).
city('Newcastleton','uk','Scotland',751.0,-2.82,55.17).
city('Newmachar','uk','Scotland',2703.0,-2.18,57.27).
city('Newport-on-Tay','uk','Scotland',4203.0,-2.92,56.43).
city('Newton Stewart','uk','Scotland',3548.0,-4.48,54.97).
city('Newtonhill','uk','Scotland',3284.0,-2.15,57.03).
city('Newtonmore','uk','Scotland',988.0,-4.13,57.07).
city('Newtown Saint Boswells','uk','Scotland',1225.0,-2.69,55.59).
city('Newtyle','uk','Scotland',731.0,-3.13,56.55).
city('North Berwick','uk','Scotland',6439.0,-2.72,56.07).
city('North Kessock','uk','Scotland',881.0,-4.25,57.5).
city('Oakley','uk','Scotland',4067.0,-3.55,56.07).
city('Oban','uk','Scotland',8082.0,-5.47,56.42).
city('Ochiltree','uk','Scotland',665.0,-4.37,55.45).
city('Oldmeldrum','uk','Scotland',2023.0,-2.32,57.32).
city('Ormiston','uk','Scotland',2062.0,-2.93,55.9).
city('Overtown','uk','Scotland',2519.0,-3.92,55.75).
city('Paisley','uk','Scotland',73074.0,-4.43,55.85).
city('Pathhead','uk','Scotland',962.0,-4.19,55.4).
city('Patna','uk','Scotland',2088.0,-4.5,55.35).
city('Peebles','uk','Scotland',8404.0,-3.18,55.63).
city('Pencaitland','uk','Scotland',1671.0,-2.88,55.9).
city('Penicuik','uk','Scotland',14314.0,-3.22,55.84).
city('Perth','uk','Scotland',43634.0,-3.47,56.4).
city('Peterculter-Milltimber','uk','Scotland',6638.0,-2.27,57.08).
city('Peterhead','uk','Scotland',17627.0,-1.86,57.51).
city('Pitlochry','uk','Scotland',2551.0,-3.72,56.7).
city('Pitmedden','uk','Scotland',1246.0,-2.18,57.33).
city('Pittenweem','uk','Scotland',1807.0,-2.73,56.2).
city('Plains','uk','Scotland',2173.0,-3.93,55.88).
city('Plean','uk','Scotland',1752.0,-3.87,56.05).
city('Polbeth','uk','Scotland',2453.0,-3.55,55.87).
city('Port Bannatyne','uk','Scotland',1331.0,-5.07,55.85).
city('Port Ellen','uk','Scotland',779.0,-6.18,55.63).
city('Port William','uk','Scotland',466.0,-4.6,54.75).
city('Portgordon','uk','Scotland',763.0,-3.02,57.65).
city('Portknockie','uk','Scotland',1179.0,-2.85,57.68).
city('Portlethen','uk','Scotland',6841.0,-2.1,57.05).
city('Portpatrick','uk','Scotland',599.0,-5.12,54.85).
city('Portree','uk','Scotland',1886.0,-6.2,57.4).
city('Portsoy','uk','Scotland',1688.0,-2.68,57.68).
city('Potterton','uk','Scotland',799.0,-2.1,57.23).
city('Prestonpans','uk','Scotland',7145.0,-2.97,55.93).
city('Quarter','uk','Scotland',959.0,-4.03,55.73).
city('Queensferry','uk','Scotland',9477.0,-3.4,55.98).
city('Ratho','uk','Scotland',1515.0,-3.37,55.92).
city('Rigside','uk','Scotland',669.0,-3.79,55.6).
city('Rosehearty','uk','Scotland',1320.0,-2.12,57.68).
city('Rosenmarkie','uk','Scotland',652.0,-4.12,57.6).
city('Rosewell','uk','Scotland',1133.0,-3.14,55.85).
city('Roslin','uk','Scotland',1794.0,-3.17,55.85).
city('Rosneath','uk','Scotland',901.0,-4.82,56.02).
city('Rothes','uk','Scotland',1132.0,-3.22,57.52).
city('Rothesay','uk','Scotland',4912.0,-5.07,55.83).
city('Saint Andrews','uk','Scotland',15435.0,-2.8,56.34).
city('Saint Boswells','uk','Scotland',1062.0,-2.65,55.57).
city('Saint Combs','uk','Scotland',719.0,-1.9,57.65).
city('Saint Cyrus','uk','Scotland',914.0,-2.4,56.77).
city('Saint Johns Town of Dalry','uk','Scotland',494.0,-4.16,55.11).
city('Saint Madoes-Glencarse','uk','Scotland',672.0,-3.3,56.38).
city('Saint Monans','uk','Scotland',1447.0,-2.77,56.2).
city('Saline','uk','Scotland',1161.0,-3.57,56.1).
city('Salsburgh','uk','Scotland',1163.0,-3.88,55.85).
city('Sandhaven','uk','Scotland',690.0,-2.07,57.68).
city('Sandwick','uk','Scotland',1217.0,-1.25,60.01).
city('Sanquhar','uk','Scotland',1987.0,-3.92,55.35).
city('Scalloway','uk','Scotland',809.0,-1.3,60.13).
city('Seafield','uk','Scotland',1386.0,-3.15,55.97).
city('Selkirk','uk','Scotland',5629.0,-2.85,55.53).
city('Shieldhill','uk','Scotland',2891.0,-3.77,55.97).
city('Shotts','uk','Scotland',7981.0,-3.81,55.82).
city('Siabost','uk','Scotland',752.0,-6.69,58.32).
city('Skelmorlie','uk','Scotland',1859.0,-4.9,55.87).
city('Slamannan','uk','Scotland',1195.0,-3.83,55.93).
city('Springfield','uk','Scotland',1088.0,-3.07,55.0).
city('Springside','uk','Scotland',1114.0,-4.6,55.62).
city('Stanley','uk','Scotland',1491.0,-3.45,56.47).
city('Stewarton','uk','Scotland',6615.0,-4.5,55.67).
city('Stirling','uk','Scotland',33013.0,-3.94,56.12).
city('Stonehaven','uk','Scotland',9592.0,-2.21,56.96).
city('Stonehouse','uk','Scotland',4950.0,-3.98,55.67).
city('Stoneyburn','uk','Scotland',2004.0,-3.65,55.85).
city('Stornoway','uk','Scotland',5423.0,-6.39,58.21).
city('Stow','uk','Scotland',551.0,-2.85,55.7).
city('Stranraer','uk','Scotland',10582.0,-5.03,54.9).
city('Strathaven','uk','Scotland',8190.0,-4.07,55.67).
city('Strathblane','uk','Scotland',1803.0,-4.3,55.97).
city('Strathkiness','uk','Scotland',1018.0,-2.87,56.33).
city('Strathmiglo','uk','Scotland',926.0,-3.27,56.27).
city('Strathpeffer','uk','Scotland',893.0,-4.55,57.58).
city('Strichen','uk','Scotland',857.0,-2.08,57.57).
city('Stromness','uk','Scotland',1564.0,-3.3,58.95).
city('Strone','uk','Scotland',502.0,-4.9,55.98).
city('Stuartfield','uk','Scotland',649.0,-2.05,57.5).
city('Symbister','uk','Scotland',744.0,-1.02,60.33).
city('Symington','uk','Scotland',997.0,-4.57,55.53).
city('Tain','uk','Scotland',3409.0,-4.07,57.8).
city('Tarbert','uk','Scotland',1364.0,-5.43,55.87).
city('Tarbolton','uk','Scotland',1649.0,-4.48,55.5).
city('Tarland','uk','Scotland',550.0,-2.87,57.13).
city('Tarves','uk','Scotland',978.0,-2.22,57.37).
city('Tayport','uk','Scotland',4093.0,-2.88,56.45).
city('Thornhill','uk','Scotland',1504.0,-3.77,55.23).
city('Thornton','uk','Scotland',1743.0,-3.15,56.17).
city('Thurso','uk','Scotland',7492.0,-3.5,58.6).
city('Tighnabruaich','uk','Scotland',603.0,-5.22,55.9).
city('Tillicoultry','uk','Scotland',5404.0,-3.75,56.15).
city('Tobermory','uk','Scotland',993.0,-6.08,56.63).
city('Torphichen','uk','Scotland',605.0,-3.65,55.93).
city('Torphins','uk','Scotland',1245.0,-2.62,57.1).
city('Torrance','uk','Scotland',2495.0,-4.22,55.94).
city('Townhill','uk','Scotland',1190.0,-3.43,56.08).
city('Tranent','uk','Scotland',9042.0,-2.95,55.93).
city('Troon','uk','Scotland',14900.0,-4.66,55.55).
city('Turriff','uk','Scotland',4711.0,-2.45,57.53).
city('Twechar','uk','Scotland',1304.0,-4.08,55.97).
city('Ullapool','uk','Scotland',1327.0,-5.17,57.9).
city('Uplawmoor','uk','Scotl',581.0,-4.48,55.75).
city('Walkerburn','uk','Scotland',638.0,-3.02,55.63).
city('Wallyford','uk','Scotland',2102.0,-3.02,55.93).
city('Waterfoot','uk','Scotland',1286.0,-6.07,55.05).
city('Wellbank','uk','Scotland',663.0,-2.87,56.52).
city('West Barns','uk','Scotland',591.0,-2.55,56.0).
city('West Calder','uk','Scotland',2769.0,-3.57,55.83).
city('West Kilbride','uk','Scotland',4322.0,-4.85,55.68).
city('West Linton','uk','Scotland',1578.0,-3.35,55.75).
city('Westhill','uk','Scotland',9840.0,-2.28,57.15).
city('Whitburn','uk','Scotland',10137.0,-3.68,55.87).
city('Whitecraig','uk','Scotland',1294.0,-3.05,55.92).
city('Whitecross','uk','Scotland',793.0,-3.65,55.97).
city('Whitehills','uk','Scotland',1019.0,-2.58,57.67).
city('Whithorn','uk','Scotland',830.0,-4.42,54.73).
city('Wick','uk','Scotland',7147.0,-3.08,58.43).
city('Wigtown','uk','Scotland',934.0,-4.45,54.87).
city('Winchburgh','uk','Scotland',2562.0,-3.47,55.95).
city('Wishaw','uk','Scotland',27627.0,-3.93,55.78).
city('Yetholm','uk','Scotland',584.0,-2.27,55.55).
city('Aberdare','uk','Wales',32756.0,-3.46,51.72).
city('Aberystwyth','uk','Wales',18392.0,-4.09,52.42).
city('Barry','uk','Wales',51681.0,-3.29,51.4).
city('Bridgend','uk','Wales',41352.0,-3.58,51.51).
city('Brynmawr','uk','Wales',14924.0,-3.19,51.8).
city('Caernarfon','uk','Wales',9836.0,-4.28,53.15).
city('Caerphily','uk','Wales',32215.0,-3.23,51.58).
city('Cardiff','uk','Wales',302142.0,-3.18,51.48).
city('Carmarthen','uk','Wales',15244.0,-4.0,51.86).
city('Colwyn Bay','uk','Wales',30829.0,-3.75,53.31).
city('Cwmbran','uk','Wales',48157.0,-3.04,51.65).
city('Ebbw Vale','uk','Wales',18345.0,-3.25,51.79).
city('Haverfordwest','uk','Wales',13469.0,-4.97,51.81).
city('Llandrindod Wells','uk','Wales',5350.0,-3.38,52.25).
city('Llanelli','uk','Wales',47206.0,-4.17,51.68).
city('Llangefni','uk','Wales',4361.0,-4.32,53.26).
city('Maesteg','uk','Wales',17830.0,-3.66,51.61).
city('Merthyr Tydfil','uk','Wales',30821.0,-3.38,51.76).
city('Mold','uk','Wales',9995.0,-3.15,53.17).
city('Mountain Ash-Abercynon','uk','Wales',19724.0,-3.38,51.68).
city('Neath','uk','Wales',46126.0,-3.83,51.65).
city('Newport','uk','Wales',117327.0,-3.0,51.59).
city('Penarth','uk','Wales',23438.0,-3.17,51.44).
city('Pontypool','uk','Wales',35687.0,-3.04,51.7).
city('Pontypridd','uk','Wales',30420.0,-3.35,51.61).
city('Port Talbot','uk','Wales',35180.0,-3.84,51.62).
city('Rhondda','uk','Wales',59450.0,-3.46,51.63).
city('Rhyl','uk','Wales',25874.0,-3.48,53.32).
city('Rhymney','uk','Wales',7089.0,-3.29,51.77).
city('Ruthin','uk','Wales',5344.0,-3.31,53.12).
city('Shotton-Hawarden','uk','Wales',25513.0,-3.03,53.19).
city('Swansea','uk','Wales',170885.0,-3.96,51.63).
city('Wrexham','uk','Wales',43650.0,-3.0,53.05).
city('Alabaster','us','Alabama',26738.0,-86.82,33.23).
city('Albertville','us','Alabama',18368.0,-86.21,34.26).
city('Alexander City','us','Alabama',14993.0,-85.93,32.93).
city('Anniston','us','Alabama',23423.0,-85.81,33.66).
city('Athens','us','Alabama',20470.0,-86.96,34.79).
city('Auburn','us','Alabama',49833.0,-85.48,32.59).
city('Bessemer','us','Alabama',28628.0,-86.96,33.38).
city('Birmingham','us','Alabama',231621.0,-86.8,33.53).
city('Center Point','us','Alabama',14907.0,-86.16,33.63).
city('Cullman','us','Alabama',14796.0,-86.84,34.18).
city('Daphne','us','Alabama',18581.0,-87.9,30.63).
city('Decatur','us','Alabama',54621.0,-86.99,34.57).
city('Dothan','us','Alabama',61741.0,-85.41,31.24).
city('Enterprise','us','Alabama',22572.0,-85.85,31.33).
city('Eufaula','us','Alabama',13453.0,-85.15,31.91).
city('Fairfield','us','Alabama',11641.0,-86.92,33.47).
city('Fairhope','us','Alabama',15419.0,-87.88,30.51).
city('Florence','us','Alabama',35733.0,-87.67,34.83).
city('Fort Payne','us','Alabama',13586.0,-85.69,34.45).
city('Gadsden','us','Alabama',36821.0,-86.01,34.01).
city('Gardendale','us','Alabama',12370.0,-86.81,33.66).
city('Hartselle','us','Alabama',13089.0,-86.94,34.44).
city('Helena','us','Alabama',13119.0,-86.86,33.28).
city('Homewood','us','Alabama',23815.0,-86.81,33.46).
city('Hoover','us','Alabama',66752.0,-86.82,33.38).
city('Hueytown','us','Alabama',15308.0,-87.0,33.44).
city('Huntsville','us','Alabama',167528.0,-86.63,34.71).
city('Irondale','us','Alabama',9652.0,-86.69,33.53).
city('Jacksonville','us','Alabama',8603.0,-85.76,33.81).
city('Jasper','us','Alabama',13831.0,-87.27,33.85).
city('Leeds','us','Alabama',11167.0,-86.56,33.55).
city('Madison','us','Alabama',37652.0,-86.75,34.7).
city('Millbrook','us','Alabama',14308.0,-86.37,32.5).
city('Mobile','us','Alabama',190274.0,-88.09,30.68).
city('Montgomery','us','Alabama',198325.0,-86.28,32.35).
city('Mountain Brook','us','Alabama',19509.0,-86.74,33.49).
city('Muscle Shoals','us','Alabama',12314.0,-87.64,34.75).
city('Northport','us','Alabama',20574.0,-87.59,33.24).
city('Opelika','us','Alabama',23625.0,-85.38,32.65).
city('Oxford','us','Alabama',16058.0,-85.83,33.6).
city('Ozark','us','Alabama',14967.0,-85.65,31.44).
city('Pelham','us','Alabama',19438.0,-86.79,33.3).
city('Pell City','us','Alabama',10773.0,-86.27,33.56).
city('Phenix City','us','Alabama',28427.0,-85.01,32.47).
city('Pleasant Grove','us','Alabama',10440.0,-86.97,33.49).
city('Prattville','us','Alabama',28265.0,-86.45,32.46).
city('Prichard','us','Alabama',27505.0,-88.13,30.77).
city('Saraland','us','Alabama',12660.0,-88.1,30.82).
city('Scottsboro','us','Alabama',14737.0,-86.05,34.65).
city('Selma','us','Alabama',18980.0,-87.03,32.42).
city('Sheffield','us','Alabama',9041.0,-87.7,34.76).
city('Smiths','us','Alabama',25897.0,-85.08,32.53).
city('Sylacauga','us','Alabama',12543.0,-86.26,33.18).
city('Talladega','us','Alabama',19408.0,-86.1,33.43).
city('Troy','us','Alabama',13337.0,-85.97,31.8).
city('Trussville','us','Alabama',15903.0,-86.59,33.64).
city('Tuscaloosa','us','Alabama',79816.0,-87.54,33.24).
city('Tuskegee','us','Alabama',11423.0,-85.71,32.44).
city('Valley','us','Alabama',8663.0,-85.18,32.81).
city('Vestavia Hills','us','Alabama',37988.0,-86.79,33.43).
city('Anchorage','us','Alaska',276263.0,-149.19,61.18).
city('Barrow','us','Alaska',4336.0,-156.81,71.27).
city('Bethel','us','Alaska',6228.0,-161.77,60.77).
city('College','us','Alaska',11413.0,-147.8,64.87).
city('Fairbanks','us','Alaska',31351.0,-147.65,64.84).
city('Homer','us','Alaska',6560.0,-151.52,59.64).
city('Juneau','us','Alaska',31796.0,-134.51,58.35).
city('Kenai','us','Alaska',7610.0,-151.21,60.55).
city('Ketchikan','us','Alaska',7172.0,-131.66,55.35).
city('Kodiak','us','Alaska',6148.0,-152.4,57.8).
city('Nome','us','Alaska',3485.0,-165.42,64.51).
city('Palmer','us','Alaska',6585.0,-149.11,61.6).
city('Sitka','us','Alaska',8931.0,-135.33,57.08).
city('Soldotna','us','Alaska',4136.0,-151.06,60.49).
city('Sterling','us','Alaska',5173.0,-150.8,60.52).
city('Valdez','us','Alaska',4052.0,-145.3,61.08).
city('Wasilla','us','Alaska',8521.0,-149.46,61.58).
city('Apache Junction','us','Arizona',34904.0,-111.55,33.41).
city('Avondale','us','Arizona',69679.0,-112.32,33.42).
city('Buckeye','us','Arizona',9039.0,-112.59,33.44).
city('Bullhead City','us','Arizona',37989.0,-114.56,35.11).
city('Camp Verde','us','Arizona',10298.0,-111.86,34.57).
city('Casa Grande','us','Arizona',32138.0,-111.74,32.89).
city('Casas Adobes','us','Arizona',77904.0,-110.99,32.32).
city('Chandler','us','Arizona',234297.0,-111.87,33.3).
city('Chino Valley','us','Arizona',9233.0,-112.45,34.76).
city('Coolidge','us','Arizona',8487.0,-111.52,32.98).
city('Cottonwood','us','Arizona',10681.0,-112.02,34.73).
city('Douglas','us','Arizona',16692.0,-109.53,31.34).
city('Drexel Heights','us','Arizona',35743.0,-111.03,32.14).
city('El Mirage','us','Arizona',32308.0,-112.32,33.6).
city('Eloy','us','Arizona',11019.0,-111.6,32.76).
city('Flagstaff','us','Arizona',57566.0,-111.62,35.19).
city('Florence','us','Arizona',15482.0,-111.37,33.04).
city('Flowing Wells','us','Arizona',15339.0,-111.01,32.29).
city('Fortuna Foothills','us','Arizona',30680.0,-114.41,32.66).
city('Fountain Hills','us','Arizona',23116.0,-111.74,33.61).
city('Gilbert','us','Arizona',170829.0,-111.76,33.33).
city('Glendale','us','Arizona',240112.0,-112.2,33.58).
city('Goodyear','us','Arizona',42738.0,-112.41,33.35).
city('Green Valley','us','Arizona',19310.0,-111.01,31.85).
city('Kingman','us','Arizona',24431.0,-114.03,35.21).
city('Lake Havasu City','us','Arizona',54752.0,-114.31,34.5).
city('Marana','us','Arizona',25553.0,-111.13,32.39).
city('Mesa','us','Arizona',449878.0,-111.74,33.42).
city('New Kingman-Butler','us','Arizona',16352.0,-114.03,35.26).
city('Nogales','us','Arizona',20707.0,-110.93,31.36).
city('Oro','us','Arizona',37221.0,-110.96,32.42).
city('Paradise Valley','us','Arizona',14400.0,-111.95,33.54).
city('Payson','us','Arizona',14737.0,-111.33,34.24).
city('Peoria','us','Arizona',139368.0,-112.24,33.69).
city('Phoenix','us','Arizona',1428509.0,-112.07,33.54).
city('Prescott','us','Arizona',40136.0,-112.45,34.58).
city('Prescott Valley','us','Arizona',32415.0,-112.32,34.61).
city('Safford','us','Arizona',8825.0,-109.7,32.83).
city('San Luis','us','Arizona',21793.0,-114.78,32.49).
city('Scottsdale','us','Arizona',225796.0,-111.87,33.69).
city('Sedona','us','Arizona',11299.0,-111.8,34.86).
city('Show Low','us','Arizona',9564.0,-110.05,34.24).
city('Sierra Vista','us','Arizona',41378.0,-110.32,31.57).
city('Sierra Vista Southeast','us','Arizona',17388.0,-110.22,31.46).
city('Somerton','us','Arizona',9466.0,-114.71,32.6).
city('Sun City','us','Arizona',41078.0,-112.28,33.62).
city('Sun City West','us','Arizona',32813.0,-112.35,33.67).
city('Surprise','us','Arizona',65450.0,-112.47,33.66).
city('Tempe','us','Arizona',158368.0,-111.93,33.39).
city('Tucson','us','Arizona',518907.0,-110.89,32.2).
city('Winslow','us','Arizona',10003.0,-110.71,35.03).
city('Yuma','us','Arizona',84316.0,-114.62,32.68).
city('Arkadelphia','us','Arkansas',11062.0,-93.07,34.12).
city('Batesville','us','Arkansas',9438.0,-91.62,35.77).
city('Bella Vista','us','Arkansas',21436.0,-94.29,36.47).
city('Benton','us','Arkansas',24689.0,-92.58,34.57).
city('Bentonville','us','Arkansas',31470.0,-94.2,36.37).
city('Blytheville','us','Arkansas',16315.0,-89.92,35.93).
city('Bryant','us','Arkansas',15065.0,-92.49,34.61).
city('Cabot','us','Arkansas',20555.0,-92.02,34.97).
city('Camden','us','Arkansas',12218.0,-92.85,33.57).
city('Conway','us','Arkansas',51524.0,-92.45,35.09).
city('El Dorado','us','Arkansas',20353.0,-92.66,33.22).
city('Fayetteville','us','Arkansas',64864.0,-94.16,36.07).
city('Forrest City','us','Arkansas',14084.0,-90.79,35.01).
city('Fort Smith','us','Arkansas',81985.0,-94.38,35.37).
city('Harrison','us','Arkansas',12468.0,-93.12,36.24).
city('Hope','us','Arkansas',10382.0,-93.59,33.67).
city('Hot Springs','us','Arkansas',37470.0,-93.05,34.49).
city('Jacksonville','us','Arkansas',30520.0,-92.13,34.87).
city('Jonesboro','us','Arkansas',58619.0,-90.69,35.82).
city('Little Rock','us','Arkansas',184217.0,-92.35,34.72).
city('Magnolia','us','Arkansas',10300.0,-93.24,33.27).
city('Malvern','us','Arkansas',8965.0,-92.82,34.37).
city('Marion','us','Arkansas',9227.0,-90.2,35.21).
city('Maumelle','us','Arkansas',13822.0,-92.41,34.85).
city('Monticello','us','Arkansas',8954.0,-91.79,33.63).
city('Mountain Home','us','Arkansas',11798.0,-92.38,36.34).
city('North Little Rock','us','Arkansas',59078.0,-92.26,34.79).
city('Paragould','us','Arkansas',23450.0,-90.51,36.06).
city('Pine Bluff','us','Arkansas',53217.0,-92.02,34.21).
city('Rogers','us','Arkansas',45524.0,-94.13,36.33).
city('Russellville','us','Arkansas',24972.0,-93.14,35.27).
city('Searcy','us','Arkansas',20154.0,-91.73,35.24).
city('Sherwood','us','Arkansas',22495.0,-92.21,34.83).
city('Siloam Springs','us','Arkansas',14634.0,-94.54,36.18).
city('Springdale','us','Arkansas',56402.0,-94.15,36.18).
city('Stuttgart','us','Arkansas',9181.0,-91.55,34.49).
city('Texarkana','us','Arkansas',29924.0,-94.02,33.45).
city('Van Buren','us','Arkansas',20932.0,-94.35,35.45).
city('West Helena','us','Arkansas',7679.0,-90.65,34.55).
city('West Memphis','us','Arkansas',28065.0,-90.18,35.15).
city('Adelanto','us','California',21955.0,-117.44,34.57).
city('Agoura Hills','us','California',22222.0,-118.76,34.15).
city('Alameda','us','California',70443.0,-122.26,37.77).
city('Alamo','us','California',17764.0,-122.0,37.86).
city('Albany','us','California',16144.0,-122.33,37.89).
city('Alhambra','us','California',88386.0,-118.13,34.08).
city('Aliso Viejo','us','California',41314.0,-117.73,33.57).
city('Alondra Park','us','California',8028.0,-118.33,33.89).
city('Alpine','us','California',15391.0,-116.76,32.84).
city('Altadena','us','California',43226.0,-118.13,34.19).
city('American Canyon','us','California',15513.0,-122.26,38.18).
city('Anaheim','us','California',333689.0,-117.87,33.84).
city('Anderson','us','California',10684.0,-122.29,40.45).
city('Antioch','us','California',106038.0,-121.8,37.99).
city('Apple Valley','us','California',64271.0,-117.21,34.53).
city('Aptos','us','California',9701.0,-121.9,36.99).
city('Arcadia','us','California',56716.0,-118.04,34.13).
city('Arcata','us','California',17199.0,-124.08,40.87).
city('Arden-Arcade','us','California',99424.0,-121.38,38.6).
city('Arroyo Grande','us','California',16613.0,-120.58,35.13).
city('Artesia','us','California',16992.0,-118.08,33.87).
city('Arvin','us','California',14.0,-118.83,35.2).
city('Ashland','us','California',23467.0,-122.12,37.69).
city('Atascadero','us','California',27308.0,-120.69,35.49).
city('Atwater','us','California',29686.0,-120.6,37.35).
city('Auburn','us','California',12523.0,-121.08,38.89).
city('Avenal','us','California',16727.0,-120.11,36.03).
city('Avocado Heights','us','California',15832.0,-118.0,34.04).
city('Azusa','us','California',48297.0,-117.91,34.14).
city('Bakersfield','us','California',291389.0,-119.0,35.36).
city('Baldwin Park','us','California',80566.0,-117.97,34.08).
city('Banning','us','California',30411.0,-116.89,33.94).
city('Barstow','us','California',24202.0,-117.07,34.88).
city('Bay Point','us','California',24125.0,-121.91,38.02).
city('Baywood-Los Osos','us','California',14554.0,-120.84,35.31).
city('Beaumont','us','California',18593.0,-116.98,33.93).
city('Bell','us','California',38335.0,-118.18,33.98).
city('Bell Gardens','us','California',46119.0,-118.15,33.97).
city('Bellflower','us','California',75847.0,-118.13,33.89).
city('Belmont','us','California',23998.0,-122.3,37.52).
city('Benicia','us','California',26742.0,-122.15,38.07).
city('Berkeley','us','California',100158.0,-122.27,37.87).
city('Beverly Hills','us','California',35355.0,-118.4,34.08).
city('Bloomington','us','California',22003.0,-117.4,34.06).
city('Blythe','us','California',22483.0,-114.59,33.61).
city('Bonita','us','California',12520.0,-117.03,32.67).
city('Bostonia','us','California',16168.0,-116.95,32.82).
city('Brawley','us','California',22185.0,-115.53,32.98).
city('Brea','us','California',39542.0,-117.87,33.92).
city('Brentwood','us','California',46669.0,-121.71,37.93).
city('Buena Park','us','California',79157.0,-118.0,33.86).
city('Burbank','us','California',104690.0,-118.33,34.19).
city('Burlingame','us','California',26777.0,-122.36,37.59).
city('Calabasas','us','California',21368.0,-118.64,34.16).
city('Calexico','us','California',36389.0,-115.5,32.68).
city('California City','us','California',14780.0,-117.87,35.16).
city('Camarillo','us','California',62500.0,-119.03,34.22).
city('Cameron Park','us','California',16232.0,-120.99,38.68).
city('Camp Pendleton North','us','California',7932.0,-117.31,33.31).
city('Camp Pendleton South','us','California',8543.0,-117.37,33.23).
city('Campbell','us','California',36529.0,-121.95,37.28).
city('Canyon Lake','us','California',11582.0,-117.25,33.68).
city('Capitola','us','California',9573.0,-121.95,36.98).
city('Carlsbad','us','California',91070.0,-117.29,33.12).
city('Carmichael','us','California',50992.0,-121.32,38.63).
city('Carpinteria','us','California',13786.0,-119.51,34.39).
city('Carson','us','California',95767.0,-118.26,33.84).
city('Casa de Oro-Mount Helix','us','Cal',18116.0,-116.94,32.77).
city('Castro Valley','us','California',62813.0,-122.06,37.71).
city('Cathedral City','us','California',52991.0,-116.46,33.83).
city('Ceres','us','California',40082.0,-120.96,37.6).
city('Cerritos','us','California',53305.0,-118.07,33.87).
city('Charter Oak','us','California',9244.0,-117.85,34.1).
city('Cherryland','us','California',15585.0,-122.1,37.68).
city('Chico','us','California',70565.0,-121.81,39.75).
city('Chino','us','California',75494.0,-117.69,34.01).
city('Chino Hills','us','California',78211.0,-117.75,33.97).
city('Chowchilla','us','California',14898.0,-120.26,37.12).
city('Chula Vista','us','California',213032.0,-117.04,32.63).
city('Citrus','us','California',11308.0,-117.89,34.11).
city('Citrus Heights','us','California',89430.0,-121.29,38.69).
city('Claremont','us','California',35368.0,-117.72,34.12).
city('Clayton','us','California',11161.0,-121.93,37.94).
city('Clearlake','us','California',14825.0,-122.63,38.96).
city('Clovis','us','California',86324.0,-119.7,36.82).
city('Coachella','us','California',30755.0,-116.15,33.68).
city('Coalinga','us','California',16331.0,-120.35,36.14).
city('Colton','us','California',52335.0,-117.32,34.06).
city('Commerce','us','California',13684.0,-118.15,34.0).
city('Compton','us','California',96749.0,-118.23,33.89).
city('Concord','us','California',125626.0,-122.0,37.97).
city('Corcoran','us','California',22587.0,-119.56,36.08).
city('Corona','us','California',152954.0,-117.57,33.87).
city('Coronado','us','California',23571.0,-117.17,32.63).
city('Corte Madera','us','California',9154.0,-122.52,37.92).
city('Costa Mesa','us','California',109250.0,-117.91,33.67).
city('Country Club','us','California',9670.0,-121.34,37.97).
city('Covina','us','California',48688.0,-117.88,34.09).
city('Crestline','us','California',11250.0,-117.3,34.25).
city('Cudahy','us','California',25606.0,-118.18,33.96).
city('Culver City','us','California',40129.0,-118.4,34.01).
city('Cupertino','us','California',50934.0,-122.05,37.31).
city('Cypress','us','California',47371.0,-118.04,33.82).
city('Daly City','us','California',98959.0,-122.47,37.69).
city('Dana Point','us','California',35870.0,-117.7,33.47).
city('Danville','us','California',42852.0,-121.97,37.81).
city('Davis','us','California',65806.0,-121.74,38.55).
city('Delano','us','California',44757.0,-119.25,35.76).
city('Desert Hot Springs','us','California',18991.0,-116.5,33.96).
city('Diamond Bar','us','California',58935.0,-117.81,34.0).
city('Dinuba','us','California',18511.0,-119.39,36.55).
city('Dixon','us','California',16244.0,-121.82,38.44).
city('Downey','us','California',111862.0,-118.13,33.94).
city('Duarte','us','California',22521.0,-117.95,34.16).
city('Dublin','us','California',38805.0,-121.91,37.72).
city('East Foothills','us','California',8141.0,-121.82,37.38).
city('East Hemet','us','California',13876.0,-116.94,33.74).
city('East La Mirada','us','California',9764.0,-117.99,33.92).
city('East Los Angeles','us','California',125157.0,-118.17,34.03).
city('East Palo Alto','us','California',32906.0,-122.13,37.47).
city('East San Gabriel','us','California',15661.0,-118.08,34.12).
city('El Cajon','us','California',94807.0,-116.96,32.8).
city('El Centro','us','California',38323.0,-115.56,32.79).
city('El Cerrito','us','California',23192.0,-122.3,37.92).
city('El Monte','us','California',125372.0,-118.03,34.07).
city('El Paso de Robles','us','California',27157.0,-120.66,35.63).
city('El Segundo','us','California',16710.0,-118.42,33.91).
city('El Sobrante','us','California',13790.0,-122.29,37.98).
city('Elk Grove','us','California',94497.0,-121.37,38.4).
city('Encinitas','us','California',61585.0,-117.26,33.05).
city('Escondido','us','California',137119.0,-117.07,33.14).
city('Eureka','us','California',25626.0,-124.16,40.8).
city('Exeter','us','California',10078.0,-119.14,36.29).
city('Fair Oaks','us','California',28989.0,-121.25,38.65).
city('Fairfield','us','California',105741.0,-122.04,38.25).
city('Fairview','us','California',9822.0,-122.04,37.68).
city('Fallbrook','us','California',33617.0,-117.24,33.37).
city('Farmersville','us','California',9743.0,-119.21,36.3).
city('Fillmore','us','California',15386.0,-118.92,34.4).
city('Florence-Graham','us','California',62610.0,-118.24,33.97).
city('Florin','us','California',29808.0,-121.4,38.49).
city('Folsom','us','California',67953.0,-121.15,38.68).
city('Fontana','us','California',169160.0,-117.46,34.1).
city('Foothill Farms','us','California',17828.0,-121.35,38.68).
city('Fortuna','us','California',11162.0,-124.15,40.59).
city('Foster City','us','California',28532.0,-122.24,37.56).
city('Fountain Valley','us','California',56133.0,-117.95,33.71).
city('Fremont','us','California',202615.0,-122.0,37.53).
city('Fresno','us','California',465183.0,-119.79,36.78).
city('Fullerton','us','California',135353.0,-117.93,33.88).
city('Galt','us','California',23997.0,-121.3,38.27).
city('Garden Acres','us','California',10523.0,-121.23,37.96).
city('Garden Grove','us','California',167232.0,-117.96,33.78).
city('Gardena','us','California',60915.0,-118.3,33.89).
city('Gilroy','us','California',45309.0,-121.58,37.01).
city('Glen Avon','us','California',16249.0,-117.49,34.02).
city('Glendale','us','California',203201.0,-118.25,34.18).
city('Glendora','us','California',51541.0,-117.84,34.15).
city('Goleta','us','California',28351.0,-119.83,34.44).
city('Gonzales','us','California',9054.0,-121.44,36.51).
city('Grand Terrace','us','California',12518.0,-117.31,34.03).
city('Grass Valley','us','California',12297.0,-121.06,39.22).
city('Greenfield','us','California',13117.0,-121.24,36.32).
city('Grover Beach','us','California',12974.0,-120.62,35.12).
city('Hacienda Heights','us','California',54289.0,-117.97,34.0).
city('Half Moon Bay','us','California',12423.0,-122.44,37.47).
city('Hanford','us','California',47648.0,-119.65,36.33).
city('Hawaiian Gardens','us','California',15652.0,-118.07,33.83).
city('Hawthorne','us','California',87083.0,-118.35,33.91).
city('Hayward','us','California',140494.0,-122.1,37.63).
city('Healdsburg','us','California',11360.0,-122.87,38.62).
city('Hemet','us','California',69039.0,-117.0,33.73).
city('Hercules','us','California',23819.0,-122.3,38.02).
city('Hermosa Beach','us','California',19825.0,-118.42,33.85).
city('Hesperia','us','California',73640.0,-117.3,34.42).
city('Highland','us','California',51312.0,-117.19,34.12).
city('Hillsborough','us','California',10374.0,-122.36,37.56).
city('Hollister','us','California',37485.0,-121.4,36.86).
city('Huntington Beach','us','California',195968.0,-118.01,33.69).
city('Huntington Park','us','California',63831.0,-118.22,33.98).
city('Imperial','us','California',10268.0,-115.57,32.84).
city('Imperial Beach','us','California',27091.0,-117.12,32.57).
city('Indio','us','California',65955.0,-116.23,33.72).
city('Inglewood','us','California',116158.0,-118.34,33.96).
city('Irvine','us','California',189297.0,-117.8,33.66).
city('Isla Vista','us','California',17716.0,-119.86,34.42).
city('Kerman','us','California',10647.0,-120.06,36.73).
city('King City','us','California',11431.0,-121.13,36.21).
city('Kingsburg','us','California',11413.0,-119.55,36.52).
city('La Canada Flintridge','us','California',21293.0,-118.2,34.21).
city('La Crescenta-Montrose','us','California',19605.0,-118.24,34.23).
city('La Habra','us','California',59654.0,-117.95,33.93).
city('La Mesa','us','California',54087.0,-117.02,32.77).
city('La Mirada','us','California',49963.0,-118.01,33.9).
city('La Palma','us','California',16169.0,-118.04,33.85).
city('La Presa','us','California',35119.0,-117.0,32.71).
city('La Puente','us','California',42605.0,-117.95,34.03).
city('La Quinta','us','California',37690.0,-116.29,33.67).
city('La Riviera','us','California',10104.0,-121.36,38.57).
city('La Verne','us','California',33698.0,-117.77,34.12).
city('Lafayette','us','California',24780.0,-122.12,37.89).
city('Laguna','us','California',46621.0,-121.42,38.42).
city('Laguna Beach','us','California',24181.0,-117.76,33.54).
city('Laguna Hills','us','California',30843.0,-117.71,33.6).
city('Laguna Niguel','us','California',66291.0,-117.7,33.53).
city('Laguna Woods','us','California',19862.0,-117.73,33.61).
city('Lake Elsinore','us','California',40630.0,-117.32,33.67).
city('Lake Forest','us','California',76733.0,-117.7,33.63).
city('Lakeside','us','California',19293.0,-116.91,32.85).
city('Lakewood','us','California',82115.0,-118.12,33.85).
city('Lamont','us','California',14438.0,-118.91,35.26).
city('Lancaster','us','California',129548.0,-118.18,34.69).
city('Larkspur','us','California',11667.0,-122.53,37.94).
city('Lathrop','us','California',13250.0,-121.29,37.82).
city('Lawndale','us','California',32841.0,-118.35,33.89).
city('Lemon Grove','us','California',24802.0,-117.03,32.73).
city('Lemoore','us','California',22763.0,-119.79,36.3).
city('Lennox','us','California',23387.0,-118.36,33.94).
city('Lincoln','us','California',33242.0,-121.3,38.89).
city('Linda','us','California',13892.0,-121.55,39.12).
city('Lindsay','us','California',10806.0,-119.09,36.21).
city('Live Oak','us','California',17598.0,-121.98,36.98).
city('Livermore','us','California',80347.0,-121.76,37.69).
city('Livingston','us','California',12080.0,-120.72,37.39).
city('Lodi','us','California',62778.0,-121.29,38.12).
city('Loma Linda','us','California',20802.0,-117.25,34.04).
city('Lomita','us','California',20751.0,-118.32,33.79).
city('Lompoc','us','California',40957.0,-120.47,34.66).
city('Long Beach','us','California',482618.0,-118.16,33.79).
city('Los Alamitos','us','California',11718.0,-118.06,33.8).
city('Los Altos','us','California',26871.0,-122.1,37.37).
city('Los Altos Hills','us','California',8207.0,-122.14,37.37).
city('Los Angeles','us','California',3877129.0,-118.41,34.11).
city('Los Banos','us','California',33317.0,-120.84,37.06).
city('Los Gatos','us','California',27551.0,-121.96,37.23).
city('Lynwood','us','California',72397.0,-118.2,33.92).
city('MacFarland','us','California',10394.0,-119.24,35.69).
city('MacKinleyville','us','California',15416.0,-124.12,40.95).
city('Madera','us','California',51451.0,-120.08,36.97).
city('Magalia','us','California',11577.0,-121.61,39.83).
city('Malibu','us','California',13769.0,-118.7,34.04).
city('Manhattan Beach','us','California',37174.0,-118.41,33.89).
city('Manteca','us','California',65820.0,-121.22,37.8).
city('Marina','us','California',16957.0,-121.79,36.68).
city('Martinez','us','California',36702.0,-122.11,38.0).
city('Marysville','us','California',12530.0,-121.58,39.15).
city('Maywood','us','California',28965.0,-118.19,33.99).
city('Mendota','us','California',8872.0,-120.38,36.76).
city('Menlo Park','us','California',29071.0,-122.14,37.48).
city('Merced','us','California',72619.0,-120.48,37.3).
city('Mill Valley','us','California',13219.0,-122.54,37.91).
city('Millbrae','us','California',19557.0,-122.4,37.6).
city('Milpitas','us','California',62636.0,-121.89,37.43).
city('Mira Loma','us','California',18827.0,-117.51,33.98).
city('Mission Viejo','us','California',96287.0,-117.65,33.61).
city('Modesto','us','California',216008.0,-120.99,37.66).
city('Monrovia','us','California',38439.0,-117.99,34.16).
city('Montclair','us','California',35729.0,-117.7,34.07).
city('Montebello','us','California',64327.0,-118.11,34.02).
city('Monterey','us','California',30307.0,-121.88,36.6).
city('Mo','us','California',63193.0,-118.13,34.05).
city('Moorpark','us','California',37010.0,-118.88,34.29).
city('Moraga','us','California',16826.0,-122.12,37.84).
city('Moreno Valley','us','California',168629.0,-117.21,33.93).
city('Morgan Hill','us','California',34719.0,-121.64,37.13).
city('Morro Bay','us','California',10242.0,-120.87,35.37).
city('Mountain View','us','California',68268.0,-122.08,37.4).
city('Murrieta','us','California',88714.0,-117.21,33.56).
city('Napa','us','California',77015.0,-122.3,38.3).
city('National City','us','California',62490.0,-117.1,32.67).
city('Newark','us','California',42922.0,-122.03,37.52).
city('Newport Beach','us','California',78702.0,-117.87,33.61).
city('Norco','us','California',27346.0,-117.55,33.93).
city('North Auburn','us','California',12841.0,-121.08,38.93).
city('North Fair Oaks','us','California',16458.0,-122.2,37.47).
city('North Highlands','us','California',45878.0,-121.38,38.67).
city('Norwalk','us','California',109111.0,-118.08,33.91).
city('Novato','us','California',48817.0,-122.56,38.09).
city('Oakdale','us','California',18668.0,-120.85,37.77).
city('Oakland','us','California',394579.0,-122.22,37.77).
city('Oakley','us','California',26774.0,-121.72,37.99).
city('Oceanside','us','California',170340.0,-117.31,33.23).
city('Oildale','us','California',28962.0,-119.03,35.42).
city('Olivehurst','us','California',11919.0,-121.55,39.08).
city('Ontario','us','California',172808.0,-117.61,34.05).
city('Orange','us','California',133874.0,-117.82,33.81).
city('Orange Cove','us','California',9768.0,-119.31,36.62).
city('Orangevale','us','California',27318.0,-121.22,38.69).
city('Orcutt','us','California',30943.0,-120.26,34.52).
city('Orinda','us','California',18251.0,-122.18,37.88).
city('Oroville','us','California',13197.0,-121.57,39.5).
city('Oxnard','us','California',187235.0,-119.21,34.2).
city('Pacific Grove','us','California',15196.0,-121.93,36.62).
city('Pacifica','us','California',36472.0,-122.48,37.61).
city('Palm Desert','us','California',48531.0,-116.38,33.73).
city('Palm Springs','us','California',46680.0,-116.53,33.78).
city('Palmdale','us','California',135294.0,-118.09,34.61).
city('Palo Alto','us','California',56508.0,-122.14,37.4).
city('Palos Verdes Estates','us','California',14036.0,-118.4,33.79).
city('Paradise','us','California',26949.0,-121.6,39.76).
city('Paramount','us','California',57275.0,-118.16,33.9).
city('Parkway-South Sacramento','us','California',39415.0,-121.45,38.51).
city('Parlier','us','California',12811.0,-119.54,36.61).
city('Pasadena','us','California',144618.0,-118.14,34.16).
city('Patterson','us','California',15957.0,-121.13,37.47).
city('Pedley','us','California',12697.0,-117.47,33.98).
city('Perris','us','California',46318.0,-117.22,33.79).
city('Petaluma','us','California',55352.0,-122.63,38.24).
city('Pico Rivera','us','California',66332.0,-118.09,33.99).
city('Piedmont','us','California',10619.0,-122.23,37.82).
city('Pinole','us','California',19540.0,-122.32,38.01).
city('Pismo Beach','us','California',8477.0,-120.65,35.15).
city('Pittsburg','us','California',62838.0,-121.89,38.02).
city('Placentia','us','California',49160.0,-117.85,33.88).
city('Placerville','us','California',10274.0,-120.8,38.73).
city('Pleasant H','us','California',34477.0,-122.07,37.95).
city('Pleasanton','us','California',66532.0,-121.89,37.67).
city('Pomona','us','California',156183.0,-117.76,34.06).
city('Port Hueneme','us','California',21417.0,-119.2,34.16).
city('Porterville','us','California',44674.0,-119.03,36.06).
city('Poway','us','California',49635.0,-117.02,32.99).
city('Quartz Hill','us','California',10167.0,-118.21,34.65).
city('Ramona','us','California',17373.0,-116.87,33.04).
city('Rancho Cordova','us','California',59185.0,-121.3,38.6).
city('Rancho Cucamonga','us','California',168557.0,-117.57,34.12).
city('Rancho Mirage','us','California',16742.0,-116.43,33.76).
city('Rancho Palos Verdes','us','California',42693.0,-118.36,33.76).
city('Rancho San Diego','us','California',28267.0,-116.93,32.75).
city('Rancho Santa Margarita','us','California',51344.0,-117.6,33.64).
city('Red Bluff','us','California',14036.0,-122.24,40.17).
city('Redding','us','California',91685.0,-122.36,40.57).
city('Redlands','us','California',70287.0,-117.17,34.06).
city('Redondo Beach','us','California',67791.0,-118.38,33.86).
city('Redwood City','us','California',71969.0,-122.21,37.52).
city('Reedley','us','California',22156.0,-119.45,36.6).
city('Rialto','us','California',101523.0,-117.39,34.11).
city('Richmond','us','California',103041.0,-122.36,37.95).
city('Ridgecrest','us','California',26110.0,-117.66,35.63).
city('Rio Linda','us','California',11128.0,-121.46,38.69).
city('Rio del Mar','us','California',9472.0,-121.88,36.96).
city('Ripon','us','California',13591.0,-121.13,37.74).
city('Riverbank','us','California',18775.0,-120.95,37.73).
city('Riverside','us','California',297554.0,-117.4,33.94).
city('Rocklin','us','California',55007.0,-121.24,38.8).
city('Rohnert Park','us','California',41314.0,-122.7,38.35).
city('Roseland','us','California',5986.0,-122.72,38.42).
city('Rosemead','us','California',56066.0,-118.08,34.07).
city('Rosemont','us','California',23273.0,-121.35,38.55).
city('Roseville','us','California',112647.0,-121.29,38.76).
city('Rossmoor','us','California',10651.0,-118.08,33.79).
city('Rowland Heights','us','California',52377.0,-117.89,33.98).
city('Rubidoux','us','California',32235.0,-117.42,34.0).
city('Sacramento','us','California',467898.0,-121.47,38.57).
city('Salinas','us','California',148691.0,-121.64,36.68).
city('San Anselmo','us','California',11936.0,-122.57,37.98).
city('San Bernardino','us','California',202381.0,-117.29,34.14).
city('San Bruno','us','California',39662.0,-122.43,37.62).
city('San Buenaventura','us','California',105620.0,-119.26,34.27).
city('San Carlos','us','California',26630.0,-122.27,37.5).
city('San Clemente','us','California',62272.0,-117.61,33.45).
city('San Diego','us','California',1287050.0,-117.14,32.81).
city('San Dimas','us','California',36422.0,-117.81,34.11).
city('San Fernando','us','California',24524.0,-118.43,34.29).
city('San Francisco','us','California',732072.0,-122.45,37.77).
city('San Gabriel','us','California',41535.0,-118.1,34.09).
city('San Jacinto','us','California',29376.0,-116.96,33.79).
city('San Jose','us','California',897460.0,-121.85,37.3).
city('San Juan Capistrano','us','California',35301.0,-117.65,33.5).
city('San Leandro','us','California',79904.0,-122.15,37.71).
city('San Lorenzo','us','California',23201.0,-122.13,37.68).
city('San Luis Obispo','us','California',44132.0,-120.66,35.27).
city('San Marcos','us','California',69697.0,-117.17,33.14).
city('San Marino','us','California',13314.0,-118.11,34.12).
city('San Mateo','us','California',89982.0,-122.31,37.56).
city('San Pablo','us','California',31351.0,-122.34,37.96).
city('San Rafael','us','California',55270.0,-122.51,37.98).
city('San Ramon','us','California',45993.0,-121.95,37.76).
city('Sanger','us','California',20772.0,-119.55,36.7).
city('Santa Ana','us','California',343054.0,-117.88,33.74).
city('Santa Barbara','us','California',86681.0,-119.72,34.43).
city('Santa Clara','us','California',102250.0,-121.97,37.37).
city('Santa Clarita','us','California',168927.0,-118.51,34.41).
city('Santa Cruz','us','California',54617.0,-122.04,36.97).
city('Santa Fe Springs','us','California',16330.0,-118.06,33.93).
city('Santa Maria','us','California',85480.0,-120.44,34.94).
city('Santa Monica','us','California',88338.0,-118.49,34.01).
city('Santa Paula','us','California',29015.0,-119.07,34.35).
city('Santa Rosa','us','California',155118.0,-122.7,38.45).
city('Santee','us','California',52600.0,-116.98,32.86).
city('Saratoga','us','California',28956.0,-122.02,37.27).
city('Scotts Valley','us','California',11120.0,-122.01,37.06).
city('Seal Beach','us','California',24404.0,-118.08,33.76).
city('Seaside','us','California',35762.0,-121.82,36.62).
city('Selma','us','California',22426.0,-119.62,36.57).
city('Shafter','us','California',14396.0,-119.27,35.5).
city('Shasta Lake','us','California',10611.0,-122.37,40.68).
city('Sierra Madre','us','California',11090.0,-118.05,34.17).
city('Signal Hill','us','California',10576.0,-118.17,33.8).
city('Simi Valley','us','California',119417.0,-118.75,34.26).
city('Solana Beach','us','California',12909.0,-117.26,33.0).
city('Soledad','us','California',28140.0,-121.32,36.43).
city('Sonoma','us','California',9773.0,-122.46,38.29).
city('Soquel','us','California',5096.0,-121.95,36.99).
city('South El Monte','us','California',22049.0,-118.05,34.05).
city('South Gate','us','California',99922.0,-118.19,33.94).
city('South Lake Tahoe','us','California',23925.0,-119.98,38.94).
city('South Pasadena','us','California',24994.0,-118.16,34.11).
city('South San Francisco','us','California',58555.0,-122.42,37.66).
city('South San Jose Hills','us','California',21779.0,-117.9,34.01).
city('South Whittier','us','California',58952.0,-118.03,33.93).
city('South Yuba City','us','California',15217.0,-121.64,39.12).
city('Spring Valley','us','California',26180.0,-116.99,32.72).
city('Stanford','us','California',12574.0,-122.16,37.42).
city('Stanton','us','California',37914.0,-117.99,33.8).
city('Stockton','us','California',289580.0,-121.31,37.97).
city('Suisun City','us','California',27219.0,-122.01,38.25).
city('Sun City','us','California',19579.0,-117.2,33.71).
city('Sunnyvale','us','California',126499.0,-122.03,37.39).
city('Susanville','us','California',17641.0,-120.65,40.41).
city('Taft','us','California',9295.0,-119.44,35.13).
city('Tamalpais-Homestead Valley','us','California',11414.0,-122.54,37.89).
city('Tehachapi','us','California',12009.0,-118.45,35.13).
city('Temecula','us','California',85145.0,-117.13,33.5).
city('Temple City','us','California',37973.0,-118.06,34.1).
city('Thousand Oaks','us','California',127942.0,-118.87,34.19).
city('Tiburon','us','California',8632.0,-122.47,37.89).
city('Torrance','us','California',144963.0,-118.34,33.83).
city('Tracy','us','California',83216.0,-121.43,37.74).
city('Truckee','us','California',15771.0,-120.2,39.33).
city('Tulare','us','California',50103.0,-119.34,36.2).
city('Turlock','us','California',67940.0,-120.85,37.5).
city('Tustin','us','California',68728.0,-117.81,33.73).
city('Tustin Foothills','us','California',24257.0,-117.79,33.76).
city('Twentynine Palms','us','California',22642.0,-116.07,34.14).
city('Twentynine Palms Base','us','California',8151.0,-116.06,34.23).
city('Ukiah','us','California',15825.0,-123.21,39.15).
city('Union City','us','California',69530.0,-122.02,37.6).
city('Upland','us','California',74230.0,-117.66,34.12).
city('Vacaville','us','California',96469.0,-121.97,38.36).
city('Valinda','us','California',23721.0,-117.93,34.04).
city('Valle Vista','us','California',11591.0,-116.9,33.75).
city('Vallejo','us','California',120446.0,-122.26,38.11).
city('Vandenberg Air Force Base','us','California',5928.0,-120.5,34.74).
city('Victorville','us','California',83496.0,-117.33,34.52).
city('View Park-Windsor Hills','us','California',10756.0,-118.35,34.0).
city('Vincent','us','California',16031.0,-117.92,34.1).
city('Visalia','us','California',107431.0,-119.32,36.33).
city('Vista','us','California',92707.0,-117.24,33.19).
city('Walnut','us','California',31720.0,-117.86,34.03).
city('Walnut Creek','us','California',65179.0,-122.04,37.9).
city('Walnut Park','us','California',17168.0,-118.22,33.97).
city('Wasco','us','California',22813.0,-119.34,35.59).
city('Watsonville','us','California',45724.0,-121.77,36.92).
city('West Athens','us','California',9355.0,-118.3,33.92).
city('West Carson','us','California',21947.0,-118.29,33.82).
city('West Covina','us','California',109756.0,-117.91,34.05).
city('West Hollywood','us','California',37031.0,-118.37,34.09).
city('West Puente Valley','us','California',24134.0,-117.97,34.05).
city('West Sacramento','us','California',41446.0,-121.55,38.56).
city('West Whittier-Los Nietos','us','California',25979.0,-118.07,33.98).
city('Westlake Village','us','California',8663.0,-118.82,34.14).
city('Westminster','us','California',89868.0,-117.99,33.75).
city('Westmont','us','California',32377.0,-118.3,33.94).
city('Whittier','us','California',85778.0,-118.02,33.97).
city('Wildomar','us','California',16442.0,-117.25,33.61).
city('Willowbrook','us','California',35321.0,-118.25,33.92).
city('Windsor','us','California',25262.0,-122.8,38.55).
city('Woodland','us','California',51731.0,-121.77,38.68).
city('Yorba Linda','us','California',64778.0,-117.77,33.89).
city('Yuba City','us','California',52432.0,-121.62,39.14).
city('Yucaipa','us','California',50392.0,-117.04,34.03).
city('Yucca Valley','us','California',19344.0,-116.43,34.11).
city('Air Force Academy','us','Colorado',7284.0,-104.86,38.99).
city('Alamosa','us','Colorado',8771.0,-105.87,37.46).
city('Applewood','us','Colorado',7533.0,-105.16,39.75).
city('Arvada','us','Colorado',101732.0,-105.11,39.82).
city('Aurora','us','Colorado',299780.0,-104.73,39.71).
city('Black Forest','us','Colorado',16096.0,-104.67,39.05).
city('Boulder','us','Colorado',91521.0,-105.25,40.03).
city('Brighton','us','Colorado',29328.0,-104.79,39.96).
city('Broomfield','us','Colorado',44692.0,-105.06,39.94).
city('Canon City','us','Colorado',15972.0,-105.23,38.44).
city('Castle Rock','us','Colorado',38814.0,-104.85,39.38).
city('Castlewood','us','Colorado',25271.0,-104.9,39.58).
city('Centennial','us','Colorado',96930.0,-104.85,39.6).
city('Cimarron Hills','us','Colorado',16981.0,-104.7,38.86).
city('Clifton','us','Colorado',19435.0,-108.46,39.08).
city('Colorado Springs','us','Colorado',373072.0,-104.76,38.86).
city('Columbine','us','Colorado',23353.0,-105.07,39.59).
city('Commerce City','us','Colorado',30707.0,-104.87,39.87).
city('Cortez','us','Colorado',8285.0,-108.58,37.35).
city('Craig','us','Colorado',9391.0,-107.55,40.52).
city('Denver','us','Colorado',555981.0,-104.87,39.77).
city('Durango','us','Colorado',15022.0,-107.87,37.29).
city('Englewood','us','Colorado',32860.0,-104.99,39.65).
city('Erie','us','Colorado',10403.0,-105.06,40.04).
city('Evans','us','Colorado',19623.0,-104.71,40.38).
city('Federal Heights','us','Colorado',11551.0,-105.02,39.87).
city('Fort Carson','us','Colorado',10645.0,-104.78,38.74).
city('Fort Collins','us','Colorado',129252.0,-105.07,40.56).
city('Fort Morgan','us','Colorado',10969.0,-103.79,40.27).
city('Fountain','us','Colorado',15925.0,-104.69,38.67).
city('Glenwood Springs','us','Colorado',8540.0,-107.33,39.54).
city('Golden','us','Colorado',17887.0,-105.22,39.74).
city('Grand Junction','us','Colorado',45938.0,-108.55,39.09).
city('Greeley','us','Colorado',86875.0,-104.74,40.42).
city('Greenwood Village','us','Colorado',13338.0,-104.91,39.62).
city('Gunbarrel','us','Colorado',9144.0,-105.17,40.07).
city('Highlands Ranch','us','Colorado',101565.0,-104.97,39.55).
city('Ken Caryl','us','Colorado',33365.0,-105.11,39.58).
city('Lafayette','us','Colorado',23716.0,-105.1,39.99).
city('Lakewood','us','Colorado',140772.0,-105.11,39.7).
city('Lamar','us','Colorado',8514.0,-102.62,38.08).
city('Littleton','us','Colorado',40947.0,-105.01,39.59).
city('Longmont','us','Colorado',83291.0,-105.11,40.17).
city('Louisville','us','Colorado',17965.0,-105.14,39.97).
city('Loveland','us','Colorado',59618.0,-105.07,40.42).
city('Montrose','us','Colorado',15138.0,-107.87,38.48).
city('Northglenn','us','Colorado',32656.0,-104.98,39.91).
city('Parker','us','Colorado',41059.0,-104.76,39.51).
city('Pueblo','us','Colorado',104293.0,-104.62,38.27).
city('Redlands','us','Colorado',7877.0,-108.65,39.09).
city('Security-Widefield','us','Colorado',32077.0,-104.71,38.74).
city('Sherrelwood','us','Colorado',17556.0,-105.0,39.84).
city('Southglenn','us','Colorado',42268.0,-104.95,39.59).
city('Steamboat Springs','us','Colorado',9349.0,-106.83,40.48).
city('Sterling','us','Colorado',12682.0,-103.2,40.63).
city('Superior','us','Colorado',11186.0,-105.16,39.93).
city('Thornton','us','Colorado',104658.0,-104.96,39.89).
city('Trinidad','us','Colorado',9156.0,-104.51,37.17).
city('Welby','us','Colorado',14031.0,-104.96,39.84).
city('Westminster','us','Colorado',104037.0,-105.05,39.88).
city('Wheat Ridge','us','Colorado',30978.0,-105.1,39.77).
city('Windsor','us','Colorado',14904.0,-104.91,40.48).
city('Ansonia','us','Connecticut',18959.0,-73.07,41.34).
city('Branford','us','Connecticut',29438.0,-72.81,41.28).
city('Bridgeport','us','Connecticut',139090.0,-73.2,41.19).
city('Bristol','us','Connecticut',61033.0,-72.94,41.68).
city('Central Manchester','us','Connecticut',31051.0,-72.52,41.78).
city('Cheshire','us','Connecticut',29443.0,-72.9,41.5).
city('Clinton','us','Connecticut',14064.0,-72.53,41.28).
city('Colchester','us','Connecticut',15502.0,-72.33,41.57).
city('Conning Towers-Nautilus Park','us','Connecticut',10559.0,-72.08,41.37).
city('Coventry','us','Connecticut',12428.0,-72.31,41.77).
city('Cromwell','us','Connecticut',13750.0,-72.65,41.59).
city('Danbury','us','Connecticut',78565.0,-73.47,41.4).
city('Darien','us','Connecticut',20753.0,-73.48,41.05).
city('Derby','us','Connecticut',12717.0,-73.08,41.33).
city('East Haddam','us','Connecticut',9042.0,-72.46,41.46).
city('East Hampton','us','Connecticut',9540.0,-72.5,41.58).
city('East Hartford','us','Connecticut',50160.0,-72.62,41.76).
city('East Haven','us','Connecticut',29006.0,-72.86,41.3).
city('East Lyme','us','Connecticut',19269.0,-72.21,41.37).
city('Ellington','us','Connecticut',14693.0,-72.47,41.9).
city('Fairfield','us','Connecticut',59052.0,-73.26,41.13).
city('Greenwich','us','Connecticut',63652.0,-73.59,41.04).
city('Griswold','us','Connecticut',11267.0,-71.93,41.57).
city('Groton','us','Connecticut',10363.0,-72.07,41.33).
city('Guilford','us','Connecticut',22498.0,-72.68,41.29).
city('Hamden','us','Connecticut',59847.0,-72.89,41.37).
city('Hartford','us','Connecticut',124019.0,-72.68,41.77).
city('Hebron','us','Connecticut',9298.0,-72.36,41.66).
city('Killingly','us','Connecticut',17282.0,-71.87,41.84).
city('Ledyard','us','Connecticut',15212.0,-94.16,43.42).
city('Litchfield','us','Connecticut',409.0,-73.19,41.75).
city('Madison','us','Connecticut',19100.0,-72.6,41.28).
city('Mansfield','us','Connecticut',26439.0,-72.24,41.76).
city('Meriden','us','Connecticut',59395.0,-72.8,41.54).
city('Middletown','us','Connecticut',50362.0,-72.65,41.55).
city('Milford','us','Connecticut',51195.0,-73.06,41.23).
city('Montville','us','Connecticut',20180.0,-72.16,41.49).
city('Naugatuck','us','Connecticut',32161.0,-73.05,41.49).
city('New Britain','us','Connecticut',71455.0,-72.79,41.68).
city('New Haven','us','Connecticut',124922.0,-72.92,41.31).
city('New London','us','Connecticut',26294.0,-72.1,41.33).
city('New Milford','us','Connecticut',42421.0,-73.41,41.58).
city('Newington','us','Connecticut',29945.0,-72.73,41.69).
city('North Branford','us','Connecticut',14454.0,-72.77,41.33).
city('North Haven','us','Connecticut',23960.0,-72.86,41.38).
city('Norwalk','us','Connecticut',84530.0,-73.42,41.09).
city('Norwich','us','Connecticut',36441.0,-72.09,41.55).
city('Old Saybrook','us','Connecticut',10627.0,-72.38,41.29).
city('Orange','us','Connecticut',13860.0,-73.03,41.28).
city('Oxford','us','Connecticut',11345.0,-73.12,41.44).
city('Plainfield','us','Connecticut',15498.0,-71.92,41.68).
city('Plymouth','us','Connecticut',12284.0,-73.06,41.67).
city('Portland','us','Connecticut',14510.0,-72.63,41.58).
city('Prospect','us','Connecticut',9476.0,-72.98,41.5).
city('Putnam','us','Connecticut',9111.0,-71.91,41.92).
city('Seymour','us','Connecticut',16562.0,-73.08,41.4).
city('Shelton','us','Connecticut',39695.0,-73.14,41.3).
city('Somers','us','Connecticut',11291.0,-72.45,41.98).
city('Southbury','us','Connecticut',19836.0,-73.22,41.48).
city('Stafford','us','Connecticut',12029.0,-72.29,41.99).
city('Stamford','us','Connecticut',121230.0,-73.55,41.1).
city('Stonington','us','Connecticut',251.0,-71.9,41.33).
city('Storrs','us','Connecticut',10684.0,-72.26,41.81).
city('Stratford','us','Connecticut',51268.0,-73.13,41.2).
city('Thompson','us','Connecticut',9358.0,-71.87,41.96).
city('Tolland','us','Connecticut',14891.0,-72.37,41.87).
city('Torrington','us','Connecticut',36000.0,-73.13,41.83).
city('Trumbull','us','Connecticut',36065.0,-73.21,41.26).
city('Vernon','us','Connecticut',30064.0,-72.47,41.87).
city('Wallingford Center','us','Connecticut',17712.0,-72.82,41.45).
city('Waterbury','us','Connecticut',108507.0,-73.04,41.56).
city('Waterford','us','Connecticut',18544.0,-72.14,41.34).
city('Watertown','us','Connecticut',22391.0,-73.15,41.61).
city('West Hartford','us','Connecticut',66610.0,-72.75,41.77).
city('West Haven','us','Connecticut',53401.0,-72.97,41.27).
city('Westport','us','Connecticut',26938.0,-73.35,41.12).
city('Wethersfield','us','Connecticut',27104.0,-72.67,41.7).
city('Willimantic','us','Connecticut',16686.0,-72.22,41.72).
city('Winchester','us','Connecticut',10830.0,-73.14,41.9).
city('Windham','us','Connecticut',23072.0,-72.16,41.7).
city('Windsor Locks','us','Connecticut',12138.0,-72.66,41.93).
city('Wolcott','us','Connecticut',16639.0,-72.98,41.6).
city('Woodbridge','us','Connecticut',9355.0,-73.01,41.35).
city('Woodbury','us','Connecticut',9755.0,-73.21,41.55).
city('Brookside','us','Delaware',14519.0,-75.72,39.67).
city('Claymont','us','Delaware',8925.0,-75.46,39.8).
city('Dover','us','Delaware',33286.0,-75.52,39.16).
city('Dover Base Housing','us','Delaware',3226.0,-75.48,39.12).
city('Edgemoor','us','Delaware',6036.0,-75.51,39.76).
city('Elsmere','us','Delaware',5713.0,-75.59,39.74).
city('Georgetown','us','Delaware',4932.0,-75.41,38.69).
city('Middletown','us','Delaware',6781.0,-75.71,39.45).
city('Milford','us','Delaware',7129.0,-75.43,38.91).
city('New Castle','us','Delaware',4718.0,-75.57,39.66).
city('Newark','us','Delaware',30238.0,-75.76,39.68).
city('Pike Creek','us','Delaware',25752.0,-75.7,39.73).
city('Seaford','us','Delaware',7121.0,-75.62,38.65).
city('Smyrna','us','Delaware',6691.0,-75.61,39.3).
city('Wilmington','us','Delaware',71356.0,-75.53,39.74).
city('Wilmington Manor','us','Delaware',8091.0,-75.58,39.69).
city('Washington','us','District of Columbia',552433.0,-77.02,38.91).
city('Altamonte Springs','us','Florida',40819.0,-81.4,28.66).
city('Apopka','us','Florida',33216.0,-81.51,28.69).
city('Atlantic Beach','us','Florida',13644.0,-81.39,30.33).
city('Auburndale','us','Florida',12405.0,-81.8,28.07).
city('Aventura','us','Florida',27892.0,-80.13,25.96).
city('Avon Park','us','Florida',8777.0,-81.51,27.6).
city('Azalea Park','us','Florida',12347.0,-81.3,28.55).
city('Bartow','us','Florida',15718.0,-81.85,27.9).
city('Bayonet Point','us','Florida',24618.0,-82.68,28.33).
city('Bayshore Gardens','us','Florida',17622.0,-82.58,27.43).
city('Bellair-Meadowbrook Terrace','us','Florida',17128.0,-81.74,30.18).
city('Belle Glade','us','Florida',15269.0,-80.67,26.69).
city('Bellview','us','Florida',22282.0,-87.31,30.46).
city('Bloomingdale','us','Florida',23618.0,-82.26,27.88).
city('Boca Raton','us','Florida',80689.0,-80.11,26.37).
city('Boca del Mar','us','Florida',24244.0,-80.15,26.34).
city('Bonita Springs','us','Florida',41840.0,-81.79,26.34).
city('Boynton Beach','us','Florida',66442.0,-80.08,26.53).
city('Bradenton','us','Florida',54608.0,-82.58,27.49).
city('Brandon','us','Florida',90165.0,-82.29,27.93).
city('Brent','us','Florida',22735.0,-87.25,30.47).
city('Brownsville','us','Florida',13964.0,-80.24,25.82).
city('Callaway','us','Florida',14913.0,-85.58,30.14).
city('Cape Canaveral','us','Florida',10101.0,-80.6,28.39).
city('Cape Coral','us','Florida',130807.0,-82.0,26.64).
city('Carol City','us','Florida',63031.0,-80.27,25.94).
city('Casselberry','us','Florida',23821.0,-81.32,28.66).
city('Catalina Foothills','us','Florida',71589.0,-110.92,32.3).
city('Century Village','us','Florida',7839.0,-80.13,26.71).
city('Citrus Park','us','Florida',22364.0,-82.58,28.11).
city('Clearwater','us','Florida',108064.0,-82.77,27.98).
city('Clermont','us','Florida',11473.0,-81.75,28.55).
city('Cocoa','us','Florida',16433.0,-80.75,28.38).
city('Cocoa Beach','us','Florida',12336.0,-80.63,28.34).
city('Coconut Creek','us','Florida',50326.0,-80.18,26.28).
city('Conway','us','Florida',15129.0,-81.33,28.5).
city('Cooper City','us','Florida',29172.0,-80.29,26.04).
city('Coral Gables','us','Florida',42485.0,-80.26,25.7).
city('Coral Springs','us','Florida',131674.0,-80.26,26.27).
city('Coral Terrace','us','Florida',25120.0,-80.3,25.75).
city('Country Club','us','Florida',53746.0,-80.32,25.95).
city('Crestview','us','Florida',16702.0,-86.57,30.75).
city('Cutler','us','Florida',18117.0,-80.32,25.63).
city('Cutler Ridge','us','Florida',26831.0,-80.35,25.58).
city('Cypress Gardens','us','Florida',8755.0,-81.69,28.0).
city('Cypress Lake','us','Florida',12994.0,-81.9,26.54).
city('Dania Beach','us','Florida',28826.0,-80.15,26.06).
city('Davie','us','Florida',82605.0,-80.29,26.08).
city('Daytona Beach','us','Florida',64661.0,-81.05,29.19).
city('De Bary','us','Florida',16638.0,-81.31,28.89).
city('De Land','us','Florida',22721.0,-81.3,29.04).
city('Deerfield Beach','us','Florida',66239.0,-80.12,26.31).
city('Delray Beach','us','Florida',65511.0,-80.09,26.45).
city('Deltona','us','Florida',82008.0,-81.21,28.91).
city('Destin','us','Florida',12115.0,-86.47,30.39).
city('Doctor Phillips','us','Florida',10478.0,-81.49,28.45).
city('Dunedin','us','Florida',37020.0,-82.77,28.04).
city('East Lake','us','Florida',43892.0,-82.38,27.98).
city('Edgewater','us','Florida',21209.0,-80.9,28.97).
city('Egypt Lake-Leto','us','Florida',46140.0,-82.5,28.02).
city('Elfers','us','Florida',13662.0,-82.72,28.21).
city('Englewood','us','Florida',16907.0,-82.35,26.96).
city('Ensley','us','Florida',20146.0,-87.28,30.53).
city('Eustis','us','Florida',17071.0,-81.69,28.85).
city('Fairview Shores','us','Florida',14353.0,-81.39,28.6).
city('Fern Park','us','Florida',8394.0,-81.35,28.65).
city('Fernandina Beach','us','Florida',11257.0,-81.45,30.66).
city('Ferry Pass','us','Florida',27810.0,-87.21,30.52).
city('Florida Ridge','us','Florida',16999.0,-80.39,27.58).
city('Forest City','us','Florida',13767.0,-81.45,28.66).
city('Fort Lauderdale','us','Florida',170510.0,-80.14,26.14).
city('Fort Myers','us','Florida',53015.0,-81.85,26.63).
city('Fort Myers Beach','us','Florida',6876.0,-81.93,26.45).
city('Fort Pierce','us','Florida',37723.0,-80.32,27.44).
city('Fort Walton Beach','us','Florida',19731.0,-86.62,30.42).
city('Fruitville','us','Florida',14518.0,-82.46,27.33).
city('Gainesville','us','Florida',125684.0,-82.34,29.67).
city('Gladeview','us','Florida',14058.0,-80.24,25.84).
city('Glenvar Heights','us','Florida',17087.0,-80.32,25.71).
city('Golden Gate','us','Florida',25388.0,-81.7,26.18).
city('Golden Glades','us','Florida',36924.0,-80.2,25.91).
city('Goldenrod','us','Florida',13219.0,-81.29,28.61).
city('Greater Carrollwood','us','Florida',40949.0,-82.52,28.07).
city('Greater Northdale','us','Florida',22930.0,-82.52,28.1).
city('Greenacres','us','Flor',32963.0,-80.14,26.63).
city('Gulf Gate Estates','us','Florida',11749.0,-82.51,27.26).
city('Gulfport','us','Florida',12612.0,-82.71,27.75).
city('Haines City','us','Florida',14457.0,-81.63,28.11).
city('Hallandale','us','Florida',36220.0,-80.14,25.99).
city('Hallandale Beach','us','Florida',35761.0,-80.16,25.98).
city('Hamptons at Boca Raton','us','Florida',11218.0,-80.19,26.38).
city('Hialeah','us','Florida',224840.0,-80.3,25.86).
city('Hialeah Gardens','us','Florida',20241.0,-80.35,25.88).
city('Hobe Sound','us','Florida',11403.0,-80.14,27.07).
city('Holiday','us','Florida',23391.0,-82.74,28.19).
city('Holly Hill','us','Florida',12738.0,-81.04,29.24).
city('Hollywood','us','Florida',144821.0,-80.16,26.03).
city('Homestead','us','Florida',35379.0,-80.45,25.46).
city('Immokalee','us','Florida',23322.0,-81.42,26.42).
city('Indian Harbour Beach','us','Florida',8579.0,-80.6,28.15).
city('Iona','us','Florida',13052.0,-81.96,26.51).
city('Ives Estates','us','Florida',20043.0,-80.18,25.96).
city('Jacksonville','us','Florida',797557.0,-81.66,30.0).
city('Jacksonville Beach','us','Florida',21552.0,-81.38,30.28).
city('Jasmine Estates','us','Florida',18887.0,-82.69,28.29).
city('Jensen Beach','us','Florida',11812.0,-80.23,27.24).
city('Jupiter','us','Florida',48974.0,-80.1,26.92).
city('Kendale Lakes','us','Florida',61791.0,-80.41,25.71).
city('Kendall','us','Florida',83026.0,-80.34,25.67).
city('Key Biscayne','us','Florida',10122.0,-80.17,25.69).
city('Key Largo','us','Florida',12247.0,-80.44,25.11).
city('Key West','us','Florida',24646.0,-81.78,24.56).
city('Kings Poin','us','Florida',12201.0,-80.14,26.45).
city('Kissimmee','us','Florida',63685.0,-81.41,28.3).
city('Lady Lake','us','Florida',13262.0,-81.93,28.93).
city('Lake City','us','Florida',10924.0,-82.64,30.19).
city('Lake Lucerne','us','Florida',9044.0,-80.26,25.97).
city('Lake Magdalene','us','Florida',38195.0,-82.47,28.07).
city('Lake Mary','us','Florida',14599.0,-81.33,28.76).
city('Lake Park','us','Florida',9656.0,-80.06,26.8).
city('Lake Wales','us','Florida',12407.0,-81.59,27.9).
city('Lake Worth','us','Florida',35817.0,-80.06,26.62).
city('Lakeland','us','Florida',90761.0,-81.96,28.04).
city('Lakeland Highlands','us','Florida',14100.0,-81.95,27.96).
city('Lakeside','us','Florida',32051.0,-81.77,30.13).
city('Land OLakes','us','Florida',31305.0,-82.45,28.22).
city('Lantana','us','Florida',9816.0,-80.06,26.58).
city('Largo','us','Florida',71666.0,-82.78,27.91).
city('Lauderdale Lakes','us','Florida',31589.0,-80.2,26.17).
city('Lauderhill','us','Florida',59861.0,-80.23,26.17).
city('Laurel','us','Florida',8529.0,-82.46,27.14).
city('Leesburg','us','Florida',18284.0,-81.88,28.81).
city('Lehigh Acres','us','Florida',48534.0,-81.63,26.6).
city('Leisure City','us','Florida',23770.0,-80.44,25.49).
city('Lighthouse Point','us','Florida',11237.0,-80.09,26.28).
city('Lockhart','us','Florida',13713.0,-81.44,28.63).
city('Longwood','us','Florida',13594.0,-81.35,28.7).
city('Lutz','us','Florida',21583.0,-82.46,28.14).
city('Lynn Haven','us','Florida',15945.0,-85.65,30.24).
city('Maitland','us','Florida',11686.0,-81.37,28.63).
city('Mango','us','Florida',8979.0,-82.31,27.99).
city('Marathon','us','Florida',10060.0,-81.08,24.71).
city('Marco Island','us','Florida',15853.0,-81.71,25.94).
city('Margate','us','Florida',55510.0,-80.21,26.25).
city('Melbourne','us','Florida',76326.0,-80.64,28.11).
city('Merritt Island','us','Florida',37991.0,-80.66,28.31).
city('Miami','us','Florida',382894.0,-80.21,25.78).
city('Miami Beach','us','Florida',89326.0,-80.14,25.81).
city('Miami Lakes','us','Florida',22582.0,-80.31,25.91).
city('Miami Shores','us','Florida',10056.0,-80.18,25.87).
city('Miami Springs','us','Florida',13383.0,-80.29,25.82).
city('Micco','us','Florida',9944.0,-80.52,27.87).
city('Mims','us','Florida',9095.0,-80.85,28.68).
city('Miramar','us','Florida',112922.0,-80.33,25.98).
city('Mount Dora','us','Florida',10924.0,-81.64,28.81).
city('Myrtle Grove','us','Florida',17255.0,-87.3,30.42).
city('Naples','us','Florida',21498.0,-81.79,26.14).
city('Naples Park','us','Florida',6756.0,-81.82,26.26).
city('New Port Richey','us','Florida',17154.0,-82.71,28.25).
city('New Port Richey East','us','Florida',10105.0,-82.69,28.26).
city('New Smyrna Beach','us','Florida',21234.0,-80.92,29.03).
city('Niceville','us','Florida',12573.0,-86.48,30.53).
city('Norland','us','Florida',23604.0,-80.21,25.95).
city('North Andrews Gardens','us','Florida',10056.0,-80.14,26.19).
city('North Fort Myers','us','Florida',46482.0,-81.89,26.71).
city('North Lauderdale','us','Florida',34267.0,-80.22,26.21).
city('North Miami','us','Florida',58472.0,-80.17,25.9).
city('North Miami Beach','us','Florida',39735.0,-80.17,25.93).
city('North Palm Beach','us','Florida',12863.0,-80.06,26.82).
city('North Port','us','Florida',38054.0,-82.19,27.05).
city('Oak Ridge','us','Florida',26836.0,-81.42,28.47).
city('Oakland Park','us','Florida',31605.0,-80.15,26.17).
city('Ocala','us','Florida',49558.0,-82.13,29.19).
city('Ocoee','us','Florida',28570.0,-81.53,28.57).
city('Ojus','us','Florida',17330.0,-80.16,25.96).
city('Oldsmar','us','Florida',15172.0,-82.68,28.04).
city('Olympia Heights','us','Florida',14874.0,-80.36,25.74).
city('Opa-locka','us','Florida',14563.0,-80.26,25.9).
city('Orange Park','us','Florida',9265.0,-81.7,30.17).
city('Orlando','us','Florida',207970.0,-81.37,28.5).
city('Ormond Beach','us','Florida',38455.0,-81.09,29.29).
city('Oviedo','us','Florida',29056.0,-81.18,28.66).
city('Palatka','us','Florida',10737.0,-81.66,29.65).
city('Palm Bay','us','Florida',89093.0,-80.66,27.99).
city('Palm Beach','us','Florida',9767.0,-80.04,26.72).
city('Palm Beach Gardens','us','Florida',48140.0,-80.12,26.84).
city('Palm City','us','Florida',28165.0,-80.27,27.16).
city('Palm Coast','us','Florida',41483.0,-81.21,29.57).
city('Palm Harbor','us','Florida',64502.0,-82.76,28.09).
city('Palm River-Clair Mel','us','Florida',17913.0,-82.38,27.93).
city('Palm Springs','us','Florida',14329.0,-80.1,26.64).
city('Palm Valley','us','Florida',27680.0,-81.39,30.2).
city('Palmetto','us','Florida',12806.0,-82.58,27.52).
city('Palmetto Estates','us','Florida',14488.0,-80.36,25.62).
city('Panama City','us','Florida',37633.0,-85.67,30.17).
city('Parkland','us','Florida',24693.0,-80.24,26.31).
city('Pembroke Pines','us','Florida',155862.0,-80.34,26.01).
city('Pensacola','us','Florida',54104.0,-87.19,30.44).
city('Pine Castle','us','Florida',9132.0,-81.37,28.47).
city('Pine Hills','us','Florida',45530.0,-81.46,28.58).
city('Pinecrest','us','Florida',19720.0,-80.31,25.66).
city('Pinellas Park','us','Florida',46495.0,-82.71,27.86).
city('Pinewood','us','Florida',17149.0,-80.22,25.87).
city('Plant City','us','Florida',31675.0,-82.13,28.01).
city('Plantation','us','Florida',85739.0,-80.26,26.13).
city('Pom','us','Florida',89715.0,-80.13,26.24).
city('Pompano Beach Highlands','us','Florida',7192.0,-80.12,26.29).
city('Port Charlotte','us','Florida',49333.0,-82.11,26.99).
city('Port Orange','us','Florida',54209.0,-81.01,29.11).
city('Port Saint John','us','Florida',14082.0,-80.79,28.48).
city('Port Saint Lucie','us','Florida',119371.0,-80.35,27.28).
city('Punta Gorda','us','Florida',18306.0,-82.06,26.9).
city('Richmond Heights','us','Florida',8496.0,-80.37,25.63).
city('Richmond West','us','Florida',31541.0,-80.4,25.67).
city('Riviera Beach','us','Florida',33678.0,-80.07,26.78).
city('Rockledge','us','Florida',23511.0,-80.73,28.32).
city('Royal Palm Beach','us','Florida',34750.0,-80.23,26.71).
city('Safety Harbor','us','Florida',17528.0,-82.7,28.01).
city('Saint Augustine','us','Florida',12097.0,-81.31,29.89).
city('Saint Cloud','us','Florida',22947.0,-81.29,28.24).
city('Saint Pete Beach','us','Florida',10065.0,-82.76,27.74).
city('Saint Petersburg','us','Florida',246316.0,-82.64,27.76).
city('San Carlos Park','us','Florida',19158.0,-81.82,26.48).
city('Sandalfoot Cove','us','Florida',17964.0,-80.19,26.34).
city('Sanford','us','Florida',45289.0,-81.28,28.79).
city('Sarasota','us','Florida',53327.0,-82.55,27.34).
city('Sarasota Springs','us','Florida',15898.0,-82.48,27.31).
city('Satellite Beach','us','Florida',9321.0,-80.6,28.18).
city('Scott Lake','us','Florida',14425.0,-80.23,25.94).
city('Sebastian','us','Florida',18953.0,-80.48,27.79).
city('Sebring','us','Florida',10030.0,-81.44,27.5).
city('Seminole','us','Florida',16758.0,-82.79,27.84).
city('South Bradenton','us','Florida',22340.0,-82.58,27.46).
city('South Daytona','us','Florida',14451.0,-81.0,29.16).
city('South Miami','us','Florida',12169.0,-80.3,25.71).
city('South Miami Heights','us','Florida',35571.0,-80.39,25.59).
city('South Patrick Shores','us','Florida',9031.0,-80.61,28.2).
city('South Venice','us','Florida',14467.0,-82.41,27.04).
city('Spring Hill','us','Florida',96767.0,-82.56,28.48).
city('Springfield','us','Florida',9181.0,-85.61,30.17).
city('Stuart','us','Florida',15112.0,-80.24,27.19).
city('Sunny Isles Beach','us','Florida',15216.0,-80.13,25.94).
city('Sunrise','us','Florida',90993.0,-80.3,26.15).
city('Sunset','us','Florida',17956.0,-80.35,25.71).
city('Sweetwater','us','Florida',13937.0,-80.37,25.76).
city('Tallahassee','us','Florida',153583.0,-84.28,30.46).
city('Tamarac','us','Florida',59268.0,-80.26,26.2).
city('Tamiami','us','Florida',69225.0,-80.4,25.76).
city('Tampa','us','Florida',324465.0,-82.48,27.96).
city('Tarpon Springs','us','Florida',22935.0,-82.78,28.15).
city('Tavares','us','Florida',11684.0,-81.73,28.8).
city('Temple Terrace','us','Florida',22036.0,-82.38,28.04).
city('The Crossings','us','Florida',26047.0,-80.39,25.69).
city('The Hammocks','us','Florida',69604.0,-80.44,25.67).
city('Titusville','us','Florida',42700.0,-80.82,28.59).
city('University','us','Florida',34953.0,-82.44,28.07).
city('University Park','us','Florida',28168.0,-81.18,28.59).
city('Venice','us','Florida',20457.0,-82.43,27.1).
city('Vero Beach','us','Florida',17262.0,-80.39,27.65).
city('Vero Beach South','us','Florida',22350.0,-80.41,27.62).
city('Villas','us','Florida',12191.0,-81.87,26.55).
city('Warrington','us','Florida',14946.0,-87.3,30.38).
city('Wekiva Springs','us','Florida',23416.0,-81.43,28.7).
city('Wellington','us','Florida',53164.0,-80.25,26.66).
city('West Lealman','us','Florida',21924.0,-82.69,27.82).
city('West Little River','us','Florida',32252.0,-80.24,25.86).
city('West Melbourne','us','Florida',14159.0,-80.67,28.08).
city('West Palm Beach','us','Florida',93620.0,-80.13,26.75).
city('West Pensacola','us','Florida',22030.0,-87.27,30.43).
city('Westchester','us','Florida',30690.0,-80.34,25.75).
city('Weston','us','Florida',68254.0,-80.4,26.1).
city('Westview','us','Florida',9779.0,-80.24,25.88).
city('Westwood Lakes','us','Florida',12333.0,-80.37,25.72).
city('Wilton Manors','us','Florida',12888.0,-80.14,26.16).
city('Winston','us','Florida',9050.0,-82.01,28.04).
city('Winter Garden','us','Florida',24774.0,-81.58,28.56).
city('Winter Haven','us','Florida',27938.0,-81.72,28.04).
city('Winter Park','us','Florida',28530.0,-81.34,28.6).
city('Winter Springs','us','Florida',32658.0,-81.27,28.68).
city('Wright','us','Florida',23302.0,-86.64,30.45).
city('Yeehaw Junction','us','Florida',24080.0,-80.92,27.7).
city('Zephyrhills','us','Florida',12092.0,-82.18,28.24).
city('Acworth','us','Georgia',19852.0,-84.68,34.07).
city('Albany','us','Georgia',75794.0,-84.18,31.58).
city('Alpharetta','us','Georgia',34869.0,-84.27,34.07).
city('Americus','us','Georgia',16817.0,-84.23,32.07).
city('Athens-Clarke','us','Georgia',103047.0,-83.39,33.95).
city('Atlanta','us','Georgia',422908.0,-84.42,33.76).
city('Augusta-Richmond','us','Georgia',192939.0,-81.99,33.46).
city('Austell','us','Georgia',6945.0,-84.63,33.82).
city('Bainbridge','us','Georgia',11714.0,-84.58,30.91).
city('Belvedere Park','us','Georgia',19149.0,-84.26,33.75).
city('Brunswick','us','Georgia',16486.0,-81.47,31.14).
city('Buford','us','Georgia',10860.0,-84.0,34.12).
city('Cairo','us','Georgia',9471.0,-84.21,30.88).
city('Calhoun','us','Georgia',13707.0,-84.94,34.5).
city('Candler-MacAfee','us','Georgia',27445.0,-84.27,33.73).
city('Canton','us','Georgia',17850.0,-84.49,34.23).
city('Carrollton','us','Georgia',21353.0,-85.08,33.58).
city('Cartersville','us','Georgia',17703.0,-84.8,34.17).
city('Cedartown','us','Georgia',9726.0,-85.25,34.02).
city('Centerville','us','Georgia',5795.0,-83.68,32.63).
city('Chamblee','us','Georgia',8887.0,-84.31,33.89).
city('College Park','us','Georgia',17957.0,-84.46,33.64).
city('Columbus','us','Georgia',185208.0,-84.87,32.51).
city('Conyers','us','Georgia',12528.0,-84.01,33.67).
city('Cordele','us','Georgia',11411.0,-83.77,31.97).
city('Covington','us','Georgia',14379.0,-83.85,33.6).
city('Dallas','us','Georgia',7995.0,-84.84,33.92).
city('Dalton','us','Georgia',31598.0,-84.98,34.77).
city('Dawson','us','Georgia',4991.0,-84.44,31.77).
city('Decatur','us','Georgia',17458.0,-84.3,33.77).
city('Doraville','us','Georgia',10065.0,-84.27,33.91).
city('Douglas','us','Georgia',10877.0,-82.85,31.51).
city('Douglasville','us','Georgia',31791.0,-84.75,33.75).
city('Druid Hills','us','Georgia',12874.0,-84.33,33.79).
city('Dublin','us','Georgia',15894.0,-82.92,32.54).
city('Duluth','us','Georgia',25213.0,-84.15,34.0).
city('Dunwoody','us','Georgia',35997.0,-84.31,33.94).
city('East Point','us','Georgia',35786.0,-84.47,33.67).
city('Eatonton','us','Georgia',6988.0,-83.39,33.33).
city('Evans','us','Georgia',19779.0,-82.15,33.51).
city('Fairburn','us','Georgia',8205.0,-84.58,33.56).
city('Fayetteville','us','Georgia',14878.0,-84.46,33.45).
city('Forest Park','us','Georgia',21153.0,-84.36,33.62).
city('Fort Benning South','us','Georgia',11410.0,-84.95,32.36).
city('Fort Oglethorpe','us','Georgia',8463.0,-85.25,34.95).
city('Fort Stewart','us','Georgia',10941.0,-81.61,31.87).
city('Gainesville','us','Georgia',33297.0,-83.83,34.29).
city('Garden City','us','Georgia',10738.0,-81.16,32.1).
city('Gresham Park','us','Georgia',9216.0,-84.31,33.7).
city('Griffin','us','Georgia',23820.0,-84.27,33.24).
city('Hinesville','us','Georgia',28066.0,-81.6,31.83).
city('Jesup','us','Georgia',9582.0,-81.89,31.6).
city('Kennesaw','us','Georgia',28439.0,-84.62,34.02).
city('Kingsland','us','Georgia',11410.0,-81.66,30.79).
city('LaGrange','us','Georgia',26885.0,-85.03,33.04).
city('Lawrenceville','us','Georgia',29368.0,-83.99,33.95).
city('Lilburn','us','Georgia',11347.0,-84.14,33.89).
city('Lithia Springs','us','Georgia',2012.0,-84.64,33.78).
city('Loganville','us','Georgia',9423.0,-83.9,33.84).
city('Mableton','us','Georgia',31476.0,-84.56,33.81).
city('MacDonough','us','Georgia',14953.0,-84.15,33.44).
city('Macon','us','Georgia',94273.0,-83.66,32.84).
city('Marietta','us','Georgia',61360.0,-84.54,33.95).
city('Martinez','us','Georgia',27195.0,-82.09,33.52).
city('Milledgeville','us','Georgia',19682.0,-83.24,33.09).
city('Monroe','us','Georgia',12189.0,-83.71,33.79).
city('Moultrie','us','Georgia',14644.0,-83.77,31.17).
city('Mountain Park','us','Georgia',496.0,-84.13,33.84).
city('Newnan','us','Georgia',23409.0,-84.79,33.38).
city('Norcross','us','Georgia',9717.0,-84.21,33.94).
city('North Atlanta','us','Georgia',44493.0,-84.33,33.86).
city('North Decatur','us','Georgia',15765.0,-84.29,33.81).
city('North Druid Hills','us','Georgia',21320.0,-84.33,33.82).
city('Panthersville','us','Georgia',12675.0,-84.28,33.71).
city('Peachtree City','us','Georgia',34215.0,-84.57,33.39).
city('Perry','us','Georgia',11234.0,-83.72,32.46).
city('Pooler','us','Georgia',10175.0,-81.25,32.1).
city('Powder Springs','us','Georgia',14616.0,-84.68,33.87).
city('Redan','us','Georgia',39044.0,-84.16,33.74).
city('Richmond Hill','us','Georgia',9414.0,-81.31,31.94).
city('Rincon','us','Georgia',6521.0,-81.23,32.29).
city('Riverdale','us','Georgia',16090.0,-84.41,33.57).
city('Rome','us','Georgia',35452.0,-85.19,34.26).
city('Roswell','us','Georgia',77218.0,-84.36,34.04).
city('Saint Marys','us','Georgia',17040.0,-81.58,30.76).
city('Saint Simons','us','Georgia',13915.0,-81.38,31.18).
city('Sandy Springs','us','Georgia',94717.0,-84.37,33.94).
city('Savannah','us','Georgia',126119.0,-81.13,32.02).
city('Smyrna','us','Georgia',46561.0,-84.52,33.87).
city('Snellville','us','Georgia',18687.0,-84.01,33.86).
city('Statesboro','us','Georgi',24558.0,-81.78,32.44).
city('Stockbridge','us','Georgia',12379.0,-84.23,33.53).
city('Sugar Hill','us','Georgia',15348.0,-84.04,34.1).
city('Suwanee','us','Georgia',11434.0,-84.07,34.05).
city('Thomaston','us','Georgia',9264.0,-84.33,32.89).
city('Thomasville','us','Georgia',18528.0,-83.98,30.84).
city('Tifton','us','Georgia',15902.0,-83.51,31.47).
city('Toccoa','us','Georgia',9178.0,-83.32,34.57).
city('Tucker','us','Georgia',26597.0,-84.22,33.85).
city('Union City','us','Georgia',14196.0,-84.54,33.58).
city('Valdosta','us','Georgia',45661.0,-83.28,30.85).
city('Vidalia','us','Georgia',10743.0,-82.4,32.21).
city('Villa Rica','us','Georgia',11328.0,-84.92,33.73).
city('Warner Robins','us','Georgia',57764.0,-83.63,32.61).
city('Waycross','us','Georgia',15067.0,-82.36,31.21).
city('Wilmington Island','us','Georgia',15702.0,-80.97,32.0).
city('Winder','us','Georgia',12643.0,-83.72,34.0).
city('Woodstock','us','Georgia',18902.0,-84.52,34.1).
city('Ahuimanu','us','Hawaii',8731.0,-157.84,21.44).
city('Aiea','us','Hawaii',9251.0,-157.93,21.39).
city('Ewa Beach','us','Hawaii',15100.0,-158.01,21.32).
city('Halawa','us','Hawaii',14401.0,-157.92,21.38).
city('Hilo','us','Hawaii',43050.0,-155.09,19.7).
city('Honolulu','us','Hawaii',384241.0,-157.8,21.32).
city('Kahului','us','Hawaii',22315.0,-156.46,20.87).
city('Kailua','us','Hawaii',37079.0,-157.75,21.41).
city('Kaneohe','us','Hawaii',35424.0,-157.79,21.41).
city('Kaneohe Station','us','Hawaii',12139.0,-157.75,21.45).
city('Kapaa','us','Hawaii',10365.0,-159.35,22.1).
city('Kihei','us','Hawaii',20707.0,-156.45,20.76).
city('Lahaina','us','Hawaii',9319.0,-156.67,20.89).
city('Makaha','us','Hawaii',7794.0,-158.22,21.47).
city('Makakilo City','us','Hawaii',15383.0,-158.09,21.36).
city('Mililani Town','us','Hawaii',28812.0,-158.02,21.45).
city('Nanakuli','us','Hawaii',11675.0,-158.16,21.39).
city('Pearl City','us','Hawaii',31572.0,-157.97,21.4).
city('Schofield Barracks','us','Hawaii',13553.0,-158.06,21.5).
city('Wahiawa','us','Hawaii',15906.0,-158.02,21.5).
city('Waianae','us','Hawaii',11668.0,-158.18,21.45).
city('Wailuku','us','Hawaii',13391.0,-156.51,20.89).
city('Waimalu','us','Hawaii',29662.0,-157.94,21.4).
city('Waipahu','us','Hawaii',34588.0,-158.01,21.39).
city('Waipio','us','Hawaii',11834.0,-158.0,21.42).
city('Ammon','us','Idaho',10530.0,-111.97,43.47).
city('Blackfoot','us','Idaho',10810.0,-112.34,43.19).
city('Boise City','us','Idaho',192170.0,-116.23,43.61).
city('Burley','us','Idaho',9247.0,-113.79,42.54).
city('Caldwell','us','Idaho',34330.0,-116.67,43.66).
city('Chubbuck','us','Idaho',10455.0,-112.47,42.92).
city('Coeur dAlene','us','Idaho',39269.0,-116.78,47.7).
city('Eagle','us','Idaho',18351.0,-116.35,43.69).
city('Emmett','us','Idaho',6239.0,-116.49,43.87).
city('Garden City','us','Idaho',11366.0,-116.27,43.65).
city('Hailey','us','Idaho',7922.0,-114.31,43.51).
city('Hayden','us','Idaho',11481.0,-116.79,47.76).
city('Idaho Falls','us','Idaho',52175.0,-112.03,43.49).
city('Jerome','us','Idaho',8287.0,-114.52,42.72).
city('Kuna','us','Idaho',11410.0,-116.42,43.49).
city('Lewiston','us','Idaho',31422.0,-116.99,46.39).
city('Meridian','us','Idaho',45803.0,-116.4,43.61).
city('Moscow','us','Idaho',21865.0,-117.0,46.73).
city('Mountain Home','us','Idaho',11287.0,-115.69,43.14).
city('Nampa','us','Idaho',73064.0,-116.56,43.58).
city('Payette','us','Idaho',7525.0,-116.93,44.08).
city('Pocatello','us','Idaho',50656.0,-112.47,42.88).
city('Post Falls','us','Idaho',22287.0,-116.94,47.71).
city('Preston','us','Idaho',4957.0,-111.88,42.1).
city('Rathdrum','us','Idaho',5725.0,-116.89,47.81).
city('Rexburg','us','Idaho',29439.0,-111.79,43.83).
city('Rupert','us','Idaho',5216.0,-113.67,42.62).
city('Sandpoint','us','Idaho',7785.0,-116.56,48.28).
city('Twin Falls','us','Idaho',38602.0,-114.46,42.56).
city('Weiser','us','Idaho',5396.0,-116.97,44.25).
city('Addison','us','Illinois',37394.0,-88.01,41.93).
city('Algonquin','us','Illinois',30394.0,-88.3,42.16).
city('Alsip','us','Illinois',19302.0,-87.0,41.67).
city('Alton','us','Illinois',29251.0,-90.15,38.9).
city('Antioch','us','Illinois',11802.0,-88.09,42.48).
city('Arlington Heights','us','Illinois',74995.0,-87.98,42.09).
city('Aurora','us','Illinois',174276.0,-88.29,41.77).
city('Barrington','us','Illinois',10157.0,-88.13,42.15).
city('Bartlett','us','Illinois',38269.0,-88.21,41.98).
city('Batavia','us','Illinois',28175.0,-88.3,41.85).
city('Beach Park','us','Illinois',12382.0,-87.86,42.42).
city('Belleville','us','Illinois',40919.0,-90.0,38.53).
city('Bellwood','us','Illinois',19751.0,-87.88,41.88).
city('Belvidere','us','Illinois',24547.0,-88.85,42.25).
city('Bensenville','us','Illinois',20496.0,-87.94,41.96).
city('Berwyn','us','Illinois',51376.0,-87.79,41.84).
city('Bethalto','us','Illinois',9727.0,-90.04,38.91).
city('Bloomingdale','us','Illinois',21747.0,-88.09,41.95).
city('Bloomington','us','Illinois',70706.0,-88.97,40.48).
city('Blue Island','us','Illinois',22923.0,-87.68,41.66).
city('Bolingbrook','us','Illinois',73220.0,-88.08,41.7).
city('Bourbonnais','us','Illinois',16495.0,-87.88,41.16).
city('Bradley','us','Illinois',13748.0,-87.86,41.15).
city('Bridgeview','us','Illinois',15126.0,-87.81,41.74).
city('Brookfield','us','Illinois',18908.0,-87.85,41.82).
city('Buffalo Grove','us','Illinois',43281.0,-87.96,42.17).
city('Burbank','us','Illinois',28020.0,-87.77,41.74).
city('Burr Ridge','us','Illinois',10938.0,-87.92,41.75).
city('Cahokia','us','Illinois',15761.0,-90.18,38.56).
city('Calumet City','us','Illinois',38388.0,-87.55,41.61).
city('Canton','us','Illinois',14802.0,-90.04,40.56).
city('Carbondale','us','Illinois',24502.0,-89.22,37.72).
city('Carol Stream','us','Illinois',39839.0,-88.13,41.92).
city('Carpentersville','us','Illinois',36834.0,-88.27,42.12).
city('Cary','us','Illinois',20315.0,-88.25,42.21).
city('Centralia','us','Illinois',13426.0,-89.13,38.52).
city('Champaign','us','Illinois',75670.0,-88.26,40.11).
city('Channahon','us','Illinois',11994.0,-88.22,41.44).
city('Charleston','us','Illinois',19399.0,-88.18,39.48).
city('Chatham','us','Illinois',9837.0,-89.7,39.67).
city('Chicago','us','Illinois',2841952.0,-87.68,41.84).
city('Chicago Heights','us','Illinois',31806.0,-87.64,41.51).
city('Chicago Ridge','us','Illinois',13687.0,-87.78,41.7).
city('Cicero','us','Illinois',81184.0,-87.76,41.84).
city('Collinsville','us','Illinois',25491.0,-90.0,38.68).
city('Country Club Hills','us','Illinois',16350.0,-87.73,41.56).
city('Crest Hill','us','Illinois',16776.0,-88.11,41.57).
city('Crestwood','us','Illinois',11296.0,-87.74,41.65).
city('Crystal Lake','us','Illinois',41188.0,-88.33,42.23).
city('Danvil','us','Illinois',32587.0,-87.62,40.14).
city('Darien','us','Illinois',22677.0,-87.98,41.75).
city('DeKalb','us','Illinois',43383.0,-88.75,41.93).
city('Decatur','us','Illinois',77868.0,-88.93,39.85).
city('Deerfield','us','Illinois',19618.0,-87.85,42.17).
city('Des Plaines','us','Illinois',54067.0,-87.9,42.03).
city('Dixon','us','Illinois',14869.0,-89.48,41.85).
city('Dolton','us','Illinois',24779.0,-87.6,41.63).
city('Downers Grove','us','Illinois',49504.0,-88.02,41.8).
city('East Moline','us','Illinois',21058.0,-90.43,41.51).
city('East Peoria','us','Illinois',22352.0,-89.55,40.67).
city('East Saint Louis','us','Illinois',29773.0,-90.13,38.61).
city('Edwardsville','us','Illinois',24551.0,-89.96,38.8).
city('Effingham','us','Illinois',12616.0,-88.55,39.12).
city('Elgin','us','Illinois',98586.0,-88.29,42.04).
city('Elk Grove Village','us','Illinois',34261.0,-88.0,42.0).
city('Elmhurst','us','Illinois',45060.0,-87.94,41.9).
city('Elmwood Park','us','Illinois',24418.0,-87.82,41.92).
city('Evanston','us','Illinois',75311.0,-87.69,42.05).
city('Evergreen Park','us','Illinois',20139.0,-87.7,41.72).
city('Fairview Heights','us','Illinois',15362.0,-90.0,38.6).
city('Flossmoor','us','Illinois',9462.0,-87.68,41.54).
city('Forest Park','us','Illinois',15171.0,-87.81,41.87).
city('Fox Lake','us','Illinois',10486.0,-88.18,42.4).
city('Frankfort','us','Illinois',15611.0,-87.84,41.5).
city('Franklin Park','us','Illinois',18728.0,-87.88,41.94).
city('Freeport','us','Illinois',25619.0,-89.63,42.29).
city('Galesburg','us','Illinois',32094.0,-90.38,40.95).
city('Geneva','us','Illinois',23974.0,-88.31,41.88).
city('Glen Carbon','us','Illinois',11567.0,-89.97,38.76).
city('Glen Ellyn','us','Illinois',27276.0,-88.06,41.87).
city('Glendale Heights','us','Illinois',33047.0,-88.08,41.92).
city('Glenview','us','Illinois',46539.0,-87.82,42.08).
city('Godfrey','us','Illinois',16844.0,-90.19,38.97).
city('Goodings Grove','us','Illinois',18569.0,-87.94,41.62).
city('Granite City','us','Illinois',30732.0,-90.13,38.71).
city('Grayslake','us','Illinois',22768.0,-88.04,42.35).
city('Gurnee','us','Illinois',31346.0,-87.94,42.38).
city('Hanover Park','us','Illinois',37083.0,-88.14,41.98).
city('Harrisburg','us','Illinois',9594.0,-88.55,37.73).
city('Harvard','us','Illinois',8996.0,-88.62,42.42).
city('Harvey','us','Illinois',28812.0,-87.65,41.61).
city('Hazel Crest','us','Illinois',14606.0,-87.69,41.57).
city('Herrin','us','Illinois',11472.0,-89.03,37.8).
city('Hickory Hills','us','Illinois',13601.0,-87.83,41.72).
city('Highland Park','us','Illinois',31403.0,-87.81,42.18).
city('Hinsdale','us','Illinois',182.0,-87.93,41.8).
city('Hoffman Estates','us','Illinois',50541.0,-88.14,42.06).
city('Homer Glen','us','Illinois',24171.0,-87.95,40.03).
city('Homewood','us','Illinois',19082.0,-87.66,41.56).
city('Huntley','us','Illinois',16700.0,-88.42,42.16).
city('Jacksonville','us','Illinois',19479.0,-90.23,39.73).
city('Joliet','us','Illinois',134957.0,-88.12,41.53).
city('Justice','us','Illinois',12691.0,-87.84,41.75).
city('Kankakee','us','Illinois',26623.0,-87.86,41.12).
city('Kewanee','us','Illinois',12574.0,-89.93,41.24).
city('La Grange','us','Illinois',15717.0,-87.87,41.81).
city('La Grange Park','us','Illinois',12840.0,-87.87,41.83).
city('La Salle','us','Illinois',9480.0,-89.09,41.34).
city('Lake Forest','us','Illinois',21014.0,-87.86,42.24).
city('Lake Zurich','us','Illinois',19903.0,-88.09,42.19).
city('Lake in the Hills','us','Illinois',28541.0,-88.32,42.19).
city('Lansing','us','Illinois',27667.0,-87.55,41.57).
city('Lemont','us','Illinois',15042.0,-87.99,41.67).
city('Libertyville','us','Illinois',21236.0,-87.97,42.28).
city('Linco','us','Illinois',14899.0,-89.37,40.15).
city('Lincolnwood','us','Illinois',12148.0,-87.73,42.01).
city('Lindenhurst','us','Illinois',15038.0,-88.03,42.42).
city('Lisle','us','Illinois',21665.0,-88.09,41.79).
city('Lockport','us','Illinois',22146.0,-88.05,41.59).
city('Lombard','us','Illinois',42836.0,-88.01,41.87).
city('Loves Park','us','Illinois',22650.0,-89.01,42.34).
city('Lyons','us','Illinois',10667.0,-87.82,41.81).
city('MacHenry','us','Illinois',24169.0,-88.29,42.34).
city('Machesney Park','us','Illinois',21494.0,-89.04,42.36).
city('Macomb','us','Illinois',19234.0,-90.68,40.47).
city('Marion','us','Illinois',17265.0,-88.94,37.73).
city('Markham','us','Illinois',12392.0,-87.69,41.6).
city('Matteson','us','Illinois',15209.0,-87.74,41.51).
city('Mattoon','us','Illinois',17711.0,-88.37,39.48).
city('Maywood','us','Illinois',25872.0,-87.84,41.88).
city('Melrose Park','us','Illinois',23054.0,-87.86,41.9).
city('Midlothian','us','Illinois',14125.0,-87.72,41.63).
city('Mokena','us','Illinois',19210.0,-87.88,41.53).
city('Moline','us','Illinois',42668.0,-90.49,41.49).
city('Monmouth','us','Illinois',9443.0,-90.64,40.91).
city('Morris','us','Illinois',12582.0,-88.43,41.37).
city('Morton','us','Illinois',15483.0,-89.47,40.61).
city('Morton Grove','us','Illinois',22968.0,-87.79,42.04).
city('Mount Prospect','us','Illinois',55303.0,-87.94,42.07).
city('Mount Vernon','us','Illinois',16505.0,-88.91,38.32).
city('Mundelein','us','Illinois',33012.0,-88.0,42.27).
city('Naperville','us','Illinois',143850.0,-88.15,41.76).
city('Ne','us','Illinois',24315.0,-87.98,41.52).
city('Niles','us','Illinois',29765.0,-87.81,42.03).
city('Normal','us','Illinois',51331.0,-89.0,40.52).
city('Norridge','us','Illinois',14157.0,-87.82,41.97).
city('North Aurora','us','Illinois',14447.0,-88.33,41.8).
city('North Chicago','us','Illinois',37301.0,-87.86,42.32).
city('Northbrook','us','Illinois',34322.0,-87.83,42.13).
city('Northlake','us','Illinois',11497.0,-87.9,41.91).
city('OFallon','us','Illinois',25715.0,-89.91,38.59).
city('Oak Forest','us','Illinois',28122.0,-87.75,41.61).
city('Oak Lawn','us','Illinois',54767.0,-87.75,41.72).
city('Oak Park','us','Illinois',49509.0,-87.79,41.89).
city('Orland Park','us','Illinois',55741.0,-87.85,41.61).
city('Oswego','us','Illinois',21547.0,-88.34,41.69).
city('Ottawa','us','Illinois',18897.0,-88.84,41.35).
city('Palatine','us','Illinois',67828.0,-88.04,42.11).
city('Palos Heights','us','Illinois',12821.0,-87.8,41.67).
city('Palos Hills','us','Illinois',17501.0,-87.83,41.7).
city('Park Forest','us','Illinois',23401.0,-87.6,41.48).
city('Park Ridge','us','Illinois',37034.0,-87.84,42.01).
city('Pekin','us','Illinois',32743.0,-89.63,40.57).
city('Peoria','us','Illinois',113004.0,-89.61,40.74).
city('Peru','us','Illinois',9829.0,-89.13,41.33).
city('Plainfield','us','Illinois',26488.0,-88.2,41.62).
city('Pontiac','us','Illinois',10982.0,-88.64,40.88).
city('Prospect Heights','us','Illinois',16562.0,-87.92,42.1).
city('Quincy','us','Illinois',39731.0,-91.39,39.93).
city('Rantoul','us','Illinois',12991.0,-88.16,40.3).
city('Richton Park','us','Illinois',13049.0,-87.73,41.48).
city('River Forest','us','Illinois',11238.0,-87.82,41.89).
city('River Grove','us','Illinois',10278.0,-87.84,41.93).
city('Riverdale','us','Illinois',14493.0,-87.63,41.64).
city('Rochelle','us','Illinois',9686.0,-89.06,41.92).
city('Rock Falls','us','Illinois',9374.0,-89.69,41.77).
city('Rock Island','us','Illinois',38383.0,-90.58,41.47).
city('Rockford','us','Illinois',152765.0,-89.06,42.27).
city('Rolling Meadows','us','Illinois',24003.0,-88.03,42.08).
city('Romeoville','us','Illinois',41420.0,-88.09,41.65).
city('Roselle','us','Illinois',23119.0,-88.08,41.98).
city('Round Lake Beach','us','Illinois',29011.0,-88.08,42.38).
city('Saint Charles','us','Illinois',34485.0,-88.3,41.92).
city('Sauk Village','us','Illinois',10591.0,-87.57,41.49).
city('Schaumburg','us','Illinois',73451.0,-88.08,42.03).
city('Schiller Park','us','Illinois',11471.0,-87.87,41.96).
city('Shiloh','us','Illinois',10671.0,-89.91,38.55).
city('Shorewood','us','Illinois',11827.0,-88.21,41.52).
city('Skokie','us','Illinois',64227.0,-87.74,42.04).
city('South Elgin','us','Illinois',22341.0,-88.3,42.0).
city('South Holland','us','Illinois',21937.0,-87.6,41.6).
city('Springfield','us','Illinois',115975.0,-89.64,39.78).
city('Steger','us','Illinois',10209.0,-87.63,41.47).
city('Sterling','us','Illinois',15106.0,-89.69,41.8).
city('Streamwood','us','Illinois',37625.0,-88.17,42.02).
city('Streator','us','Illinois',13960.0,-88.83,41.13).
city('Summit','us','Illinois',10312.0,-87.81,41.79).
city('Swansea','us','Illinois',12058.0,-89.99,38.54).
city('Sycamore','us','Illinois',14145.0,-88.7,41.98).
city('Taylorville','us','Illinois',11197.0,-89.26,39.52).
city('Tinley Park','us','Illinois',57244.0,-87.8,41.57).
city('Urbana','us','Illinois',39511.0,-88.21,40.11).
city('Vernon Hills','us','Illinois',23510.0,-87.96,42.24).
city('Villa Park','us','Illinois',22868.0,-87.98,41.89).
city('Warrenville','us','Illinois',13179.0,-88.19,41.82).
city('Washington','us','Illinois',12294.0,-89.44,40.7).
city('Waterloo','us','Illinois',9315.0,-90.15,38.34).
city('Wauconda','us','Illinois',10269.0,-88.14,42.27).
city('Waukegan','us','Illinois',92695.0,-87.87,42.37).
city('West Chicago','us','Illinois',26014.0,-88.22,41.89).
city('Westchester','us','Illinois',16434.0,-87.89,41.85).
city('Western Springs','us','Illinois',12446.0,-87.9,41.8).
city('Westmont','us','Illinois',24552.0,-87.98,41.8).
city('Wheaton','us','Illinois',54545.0,-88.11,41.86).
city('Wheeling','us','Illinois',35815.0,-87.92,42.13).
city('Willowbrook','us','Illinois',8920.0,-87.54,41.45).
city('Wilmette','us','Illinois',26871.0,-87.73,42.08).
city('Winfield','us','Illinois',9802.0,-88.15,41.88).
city('Winnetka','us','Illinois',12284.0,-87.74,42.11).
city('Wood Dale','us','Illinois',13316.0,-87.98,41.97).
city('Wood River','us','Illinois',10971.0,-90.08,38.86).
city('Woodridge','us','Illinois',34500.0,-88.04,41.74).
city('Woodstock','us','Illinois',21769.0,-88.44,42.31).
city('Worth','us','Illinois',10741.0,-87.79,41.69).
city('Zion','us','Illinois',24316.0,-87.84,42.46).
city('Anderson','us','Indiana',57496.0,-85.69,40.09).
city('Angola','us','Indiana',7932.0,-85.0,41.64).
city('Auburn','us','Indiana',12870.0,-85.06,41.36).
city('Bedford','us','Indiana',13289.0,-86.49,38.86).
city('Beech Grove','us','Indiana',14169.0,-86.09,39.72).
city('Bloomington','us','Indiana',71253.0,-86.52,39.17).
city('Bluffton','us','Indiana',9463.0,-85.17,40.74).
city('Brownsburg','us','Indiana',18528.0,-86.39,39.84).
city('Carmel','us','Indiana',47219.0,-86.11,39.97).
city('Cedar Lake','us','Indiana',9672.0,-87.44,41.37).
city('Chesterton','us','Indiana',11563.0,-87.06,41.6).
city('Clarksville','us','Indiana',21114.0,-85.77,38.32).
city('Columbus','us','Indiana',39395.0,-85.91,39.21).
city('Connersville','us','Indiana',14436.0,-85.14,39.66).
city('Crawfordsville','us','Indiana',15066.0,-86.9,40.04).
city('Crown Point','us','Indiana',21914.0,-87.36,41.42).
city('Decatur','us','Indiana',9444.0,-84.93,40.83).
city('Dyer','us','Indiana',15143.0,-87.51,41.5).
city('East Chicago','us','Indiana',30662.0,-87.45,41.65).
city('Elkhart','us','Indiana',51.0,-85.97,41.69).
city('Elwood','us','Indiana',9051.0,-85.84,40.27).
city('Evansville','us','Indiana',115474.0,-87.54,37.98).
city('Fishers','us','Indiana',54829.0,-86.02,39.95).
city('Fort Wayne','us','Indiana',229715.0,-85.14,41.07).
city('Frankfort','us','Indiana',16315.0,-86.51,40.28).
city('Franklin','us','Indiana',21653.0,-86.06,39.49).
city('Gary','us','Indiana',97966.0,-87.34,41.6).
city('Goshen','us','Indiana',30045.0,-85.84,41.58).
city('Granger','us','Indiana',32749.0,-86.14,41.74).
city('Greencastle','us','Indiana',10092.0,-86.86,39.64).
city('Greenfield','us','Indiana',16257.0,-85.77,39.79).
city('Greensburg','us','Indiana',10601.0,-85.48,39.34).
city('Greenwood','us','Indiana',41244.0,-86.11,39.62).
city('Griffith','us','Indiana',16684.0,-87.42,41.52).
city('Hammond','us','Indiana',78883.0,-87.49,41.62).
city('Highland','us','Indiana',23244.0,-87.46,41.55).
city('Hobart','us','Indiana',28008.0,-87.27,41.53).
city('Huntington','us','Indiana',16932.0,-85.51,40.88).
city('Indianapolis','us','Indiana',773283.0,-86.15,39.78).
city('Jasper','us','Indiana',13850.0,-86.94,38.39).
city('Jeffersonville','us','Indiana',28465.0,-85.73,38.3).
city('Kendallville','us','Indiana',9629.0,-85.26,41.44).
city('Kokomo','us','Indiana',46227.0,-86.13,40.48).
city('La Porte','us','Indiana',20661.0,-86.71,41.61).
city('Lafayette','us','Indiana',62231.0,-86.87,40.41).
city('Lake Station','us','Indiana',13667.0,-87.26,41.57).
city('Lawrence','us','Indiana',41821.0,-85.99,39.87).
city('Lebanon','us','Indiana',14583.0,-86.47,40.05).
city('Logansport','us','Indiana',19064.0,-86.36,40.75).
city('Madison','us','Indiana',12435.0,-85.4,38.76).
city('Marion','us','Indiana',30201.0,-85.67,40.55).
city('Martinsville','us','Indiana',11617.0,-86.42,39.42).
city('Merrillville','us','Indiana',31168.0,-87.33,41.47).
city('Michigan City','us','Indiana',31903.0,-86.88,41.71).
city('Mishawaka','us','Indiana',49055.0,-86.17,41.67).
city('Mooresville','us','Indiana',11417.0,-86.37,39.61).
city('Muncie','us','Indiana',65327.0,-85.39,40.2).
city('Munster','us','Indiana',22586.0,-87.5,41.55).
city('New Albany','us','Indiana',36138.0,-85.83,38.3).
city('New Castle','us','Indiana',18812.0,-85.36,39.92).
city('New Haven','us','Indiana',13843.0,-85.03,41.07).
city('Noblesville','us','Indiana',35840.0,-86.03,40.06).
city('North Vernon','us','Indiana',6324.0,-85.63,39.01).
city('Peru','us','Indiana',12841.0,-86.07,40.75).
city('Plainfield','us','Indiana',23135.0,-86.39,39.7).
city('Plymouth','us','Indiana',11024.0,-86.31,41.35).
city('Portage','us','Indiana',35787.0,-87.18,41.59).
city('Richmond','us','Indiana',37631.0,-84.89,39.83).
city('Saint John','us','Indiana',10391.0,-87.48,41.45).
city('Schererville','us','Indiana',27157.0,-87.45,41.49).
city('Seymour','us','Indiana',18730.0,-85.89,38.96).
city('Shelbyville','us','Indiana',17815.0,-85.78,39.52).
city('South Bend','us','Indiana',103760.0,-86.27,41.68).
city('Speedway','us','Indiana',12642.0,-86.25,39.79).
city('Terre Haute','us','Indiana',57063.0,-87.38,39.47).
city('Valparaiso','us','Indiana',28787.0,-87.05,41.48).
city('Vincennes','us','Indiana',18257.0,-87.51,38.68).
city('Wabash','us','Indiana',11124.0,-85.83,40.8).
city('Warsaw','us','Indiana',13003.0,-85.85,41.24).
city('Washington','us','Indiana',11271.0,-87.17,38.66).
city('West Lafayette','us','Indiana',30950.0,-86.91,40.44).
city('Westfield','us','Indiana',12570.0,-86.13,40.03).
city('Zionsville','us','Indiana',11170.0,-86.27,39.95).
city('Altoona','us','Iowa',12115.0,-93.48,41.65).
city('Ames','us','Iowa',56606.0,-93.63,42.02).
city('Ankeny','us','Iowa',33916.0,-93.61,41.72).
city('Bettendorf','us','Iowa',31421.0,-90.48,41.56).
city('Boone','us','Iowa',12802.0,-93.88,42.05).
city('Burlington','us','Iowa',25608.0,-91.12,40.81).
city('Carroll','us','Iowa',9941.0,-94.86,42.07).
city('Cedar Falls','us','Iowa',36258.0,-92.45,42.52).
city('Cedar Rapids','us','Iowa',122945.0,-91.67,41.97).
city('Clinton','us','Iowa',27294.0,-90.23,41.84).
city('Clive','us','Iowa',14092.0,-93.77,41.61).
city('Coralville','us','Iowa',17645.0,-91.6,41.69).
city('Council Bluffs','us','Iowa',58764.0,-95.86,41.24).
city('Davenport','us','Iowa',96930.0,-90.6,41.56).
city('Des Moines','us','Iowa',193180.0,-93.62,41.58).
city('Dubuque','us','Iowa',57185.0,-90.69,42.5).
city('Fairfield','us','Iowa',9442.0,-91.97,41.01).
city('Fort Dodge','us','Iowa',26879.0,-94.18,42.51).
city('Fort Madison','us','Iowa',10733.0,-91.35,40.62).
city('Grinnell','us','Iowa',9312.0,-92.72,41.74).
city('Indianola','us','Iowa',13353.0,-93.57,41.36).
city('Iowa City','us','Iowa',64170.0,-91.54,41.66).
city('Johnston','us','Iowa',12547.0,-93.71,41.67).
city('Keokuk','us','Iowa',10645.0,-91.4,40.41).
city('Le Mars','us','Iowa',9256.0,-96.17,42.79).
city('Marion','us','Iowa',30785.0,-91.59,42.03).
city('Marshalltown','us','Iowa',25554.0,-92.91,42.04).
city('Mason City','us','Iowa',27802.0,-93.2,43.15).
city('Muscatine','us','Iowa',22529.0,-91.07,41.42).
city('Newton','us','Iowa',16028.0,-93.05,41.7).
city('Oskaloosa','us','Iowa',11104.0,-92.64,41.29).
city('Ottumwa','us','Iowa',24593.0,-92.42,41.02).
city('Pella','us','Iowa',10058.0,-92.92,41.41).
city('Sioux City','us','Iowa',83248.0,-96.39,42.5).
city('Spencer','us','Iowa',11203.0,-95.15,43.15).
city('Storm Lake','us','Iowa',9835.0,-95.2,42.64).
city('Urbandale','us','Iowa',33528.0,-93.74,41.64).
city('Waterloo','us','Iowa',65836.0,-92.35,42.49).
city('Waverly','us','Iowa',9106.0,-92.48,42.73).
city('West Des Moines','us','Iowa',55279.0,-93.75,41.57).
city('Andover','us','Kansas',9201.0,-97.14,37.71).
city('Arkansas City','us','Kansas',11464.0,-97.04,37.07).
city('Atchison','us','Kansas',10068.0,-95.13,39.56).
city('Chanute','us','Kansas',8864.0,-95.46,37.68).
city('Coffeyville','us','Kansas',10150.0,-95.63,37.04).
city('Derby','us','Kansas',19843.0,-97.26,37.55).
city('Dodge City','us','Kansas',25932.0,-100.02,37.76).
city('El Dorado','us','Kansas',12669.0,-96.86,37.82).
city('Emporia','us','Kansas',26545.0,-96.19,38.41).
city('Fort Riley North','us','Kansas',7406.0,-96.82,39.11).
city('Garden City','us','Kansas',26425.0,-100.86,37.98).
city('Gardner','us','Kansas',13511.0,-94.92,38.81).
city('Great Bend','us','Kansas',14654.0,-98.81,38.36).
city('Hays','us','Kansas',19883.0,-99.32,38.88).
city('Haysville','us','Kansas',10012.0,-97.35,37.56).
city('Hutchinson','us','Kansas',40596.0,-97.91,38.07).
city('Independence','us','Kansas',9129.0,-95.71,37.23).
city('Junction City','us','Kansas',17215.0,-96.84,39.03).
city('Kansas City','us','Kansas',144030.0,-94.73,39.12).
city('Lansing','us','Kansas',10846.0,-94.89,39.25).
city('Lawrence','us','Kansas',83314.0,-95.26,38.96).
city('Leavenworth','us','Kansas',34880.0,-94.92,39.32).
city('Leawood','us','Kansas',29978.0,-94.63,38.91).
city('Lenexa','us','Kansas',43331.0,-94.79,38.96).
city('Liberal','us','Kansas',20182.0,-100.94,37.04).
city('MacPherson','us','Kansas',13673.0,-97.66,38.37).
city('Manhattan','us','Kansas',45629.0,-96.59,39.19).
city('Merriam','us','Kansas',10759.0,-94.69,39.02).
city('Mission','us','Kansas',9485.0,-94.66,39.03).
city('Newton','us','Kansas',18113.0,-97.34,38.04).
city('Olathe','us','Kansas',113647.0,-94.81,38.89).
city('Ottawa','us','Kansas',12118.0,-95.27,38.61).
city('Overland Park','us','Kansas',166010.0,-94.68,38.91).
city('Parsons','us','Kansas',11227.0,-95.27,37.34).
city('Pittsburg','us','Kansas',19476.0,-94.7,37.41).
city('Prairie Village','us','Kansas',21564.0,-94.64,38.99).
city('Salina','us','Kansas',45723.0,-97.62,38.82).
city('Shawnee','us','Kansas',57561.0,-94.8,39.02).
city('Topeka','us','Kansas',121570.0,-95.69,39.04).
city('Wichita','us','Kansas',355244.0,-97.34,37.69).
city('Winfield','us','Kansas',11754.0,-96.97,37.27).
city('Ashland','us','Kentucky',21209.0,-82.64,38.46).
city('Bardstown','us','Kentucky',10576.0,-85.47,37.81).
city('Berea','us','Kentucky',12079.0,-84.29,37.58).
city('Bowling Green','us','Kentucky',51558.0,-86.44,36.97).
city('Campbellsville','us','Kentucky',10821.0,-85.35,37.35).
city('Covington','us','Kentucky',42153.0,-84.51,39.04).
city('Danville','us','Kentucky',15164.0,-84.77,37.64).
city('Edgewood','us','Kentucky',9043.0,-84.57,39.01).
city('Elizabethtown','us','Kentucky',23636.0,-85.87,37.7).
city('Erlanger','us','Kentucky',16895.0,-84.59,39.01).
city('Fern Creek','us','Kentucky',18409.0,-85.6,38.16).
city('Florence','us','Kentucky',25487.0,-84.64,38.99).
city('Fort Campbell North','us','Kentucky',13204.0,-87.46,36.65).
city('Fort Knox','us','Kentucky',11183.0,-85.96,37.89).
city('Fort Thomas','us','Kentucky',15654.0,-84.45,39.08).
city('Frankfort','us','Kentucky',27051.0,-84.87,38.19).
city('Georgetown','us','Kentucky',20347.0,-84.55,38.21).
city('Glasgow','us','Kentucky',13972.0,-85.92,37.0).
city('Henderson','us','Kentucky',27495.0,-87.58,37.84).
city('Highview','us','Kentucky',15167.0,-85.64,38.14).
city('Hopkinsville','us','Kentucky',27656.0,-87.49,36.85).
city('Independence','us','Kentucky',18596.0,-84.55,38.95).
city('Jeffersontown','us','Kentucky',26464.0,-85.57,38.21).
city('Lawrenceburg','us','Kentucky',9437.0,-84.9,38.03).
city('Lexington-Fayette','us','Kentucky',272079.0,-84.46,38.04).
city('Louisville','us','Kentucky',243639.0,-85.74,38.22).
city('Lyndon','us','Kentucky',10376.0,-85.59,38.26).
city('Madisonville','us','Kentucky',19423.0,-87.51,37.34).
city('Mayfield','us','Kentucky',10153.0,-88.65,36.74).
city('Middlesborough','us','Kentucky',10136.0,-83.72,36.61).
city('Murray','us','Kentucky',15626.0,-88.32,36.61).
city('Newburg','us','Kentucky',19967.0,-85.69,38.17).
city('Newport','us','Kentucky',15674.0,-84.49,39.09).
city('Nicholasville','us','Kentucky',24004.0,-84.58,37.88).
city('Okolona','us','Kentucky',17134.0,-85.69,38.14).
city('Owensboro','us','Kentucky',54478.0,-87.12,37.76).
city('Paducah','us','Kentucky',25306.0,-88.64,37.07).
city('Paris','us','Kentucky',9332.0,-84.26,38.21).
city('Pleasure Ridge Park','us','Kentucky',25813.0,-85.85,38.15).
city('Radcliff','us','Kentucky',21783.0,-85.94,37.82).
city('Richmond','us','Kentucky',30697.0,-84.29,37.74).
city('Saint Dennis','us','Kentucky',8592.0,-85.85,38.19).
city('Saint Matthews','us','Kentucky',17503.0,-85.64,38.25).
city('Shelbyville','us','Kentucky',10596.0,-85.23,38.21).
city('Shively','us','Kentucky',15426.0,-85.81,38.2).
city('Somerset','us','Kentucky',12142.0,-84.61,37.08).
city('Valley Station','us','Kentucky',22756.0,-85.86,38.1).
city('Winchester','us','Kentucky',16201.0,-84.19,38.0).
city('Abbeville','us','Louisiana',11558.0,-92.12,29.97).
city('Alexandria','us','Louisiana',45187.0,-92.46,31.29).
city('Baker','us','Louisiana',13396.0,-91.16,30.59).
city('Bastrop','us','Louisiana',12725.0,-91.91,32.77).
city('Baton Rouge','us','Louisiana',223349.0,-91.13,30.45).
city('Bayou Cane','us','Louisiana',17368.0,-90.75,29.62).
city('Bogalusa','us','Louisiana',12695.0,-89.86,30.78).
city('Bossier City','us','Louisiana',59580.0,-93.66,32.52).
city('Chalmette','us','Louisiana',31698.0,-89.97,29.94).
city('Crowley','us','Louisiana',13797.0,-92.38,30.21).
city('De Ridder','us','Louisiana',9750.0,-93.29,30.85).
city('Denham Springs','us','Louisiana',9405.0,-90.95,30.48).
city('Estelle','us','Louisiana',16553.0,-90.1,29.84).
city('Eunice','us','Louisiana',11788.0,-92.42,30.49).
city('Fort Polk South','us','Louisiana',10881.0,-93.22,31.05).
city('Gretna','us','Louisiana',17106.0,-90.05,29.91).
city('Hammond','us','Louisiana',17812.0,-90.46,30.51).
city('Harahan','us','Louisiana',9746.0,-90.2,29.94).
city('Harvey','us','Louisiana',22383.0,-90.07,29.89).
city('Houma','us','Louisiana',31800.0,-90.71,29.58).
city('Jefferson','us','Louisiana',10604.0,-90.17,29.96).
city('Jennings','us','Louisiana',10547.0,-92.66,30.22).
city('Kenner','us','Louisiana',69721.0,-90.25,29.99).
city('Lafayette','us','Louisiana',112197.0,-92.03,30.22).
city('Lake Charles','us','Louisiana',70309.0,-93.2,30.21).
city('Laplace','us','Louisiana',29064.0,-90.47,30.07).
city('Mandeville','us','Louisiana',11906.0,-90.08,30.37).
city('Marrero','us','Louisiana',35405.0,-90.11,29.89).
city('Merrydale','us','Louisiana',10290.0,-91.11,30.5).
city('Metairie','us','Louisiana',142489.0,-90.18,30.0).
city('Minden','us','Louisiana',13376.0,-93.28,32.62).
city('Monroe','us','Louisiana',51625.0,-92.08,32.51).
city('Morgan City','us','Louisiana',12162.0,-91.19,29.7).
city('Natchitoches','us','Louisiana',18598.0,-93.1,31.76).
city('New Iberia','us','Louisiana',32430.0,-91.82,30.01).
city('New Orleans','us','Louisiana',459336.0,-89.93,30.07).
city('Opelousas','us','Louisiana',22835.0,-92.08,30.52).
city('Pineville','us','Louisiana',13846.0,-92.41,31.33).
city('River Ridge','us','Louisiana',14278.0,-90.22,29.96).
city('Ruston','us','Louisiana',20686.0,-92.64,32.53).
city('Shenandoah','us','Louisiana',18829.0,-91.0,30.4).
city('Shreveport','us','Louisiana',196980.0,-93.8,32.47).
city('Slidell','us','Louisiana',27799.0,-89.78,30.28).
city('Sulphur','us','Louisiana',19570.0,-93.36,30.23).
city('Terrytown','us','Louisiana',25858.0,-90.03,29.9).
city('Thibodaux','us','Louisiana',14410.0,-90.82,29.79).
city('Timberlane','us','Louisiana',10719.0,-90.03,29.88).
city('Waggaman','us','Louisiana',9311.0,-90.23,29.94).
city('West Monroe','us','Louisiana',12900.0,-92.15,32.51).
city('Westwego','us','Louisiana',10386.0,-90.14,29.9).
city('Zachary','us','Louisiana',12114.0,-91.15,30.66).
city('Auburn','us','Maine',23488.0,-70.25,44.08).
city('Augusta','us','Maine',18661.0,-69.73,44.33).
city('Bangor','us','Maine',31534.0,-68.79,44.83).
city('Bar Harbor','us','Maine',6090.0,-68.21,44.38).
city('Bath','us','Maine',9363.0,-69.84,43.94).
city('Belfast','us','Maine',7052.0,-69.01,44.42).
city('Berwick','us','Maine',7851.0,-70.86,43.27).
city('Biddeford','us','Maine',21885.0,-70.44,43.47).
city('Brewer','us','Maine',9140.0,-68.75,44.79).
city('Bridgton','us','Maine',6351.0,-70.71,44.06).
city('Brunswick','us','Maine',24206.0,-69.94,43.91).
city('Bucksport','us','Maine',5756.0,-68.79,44.58).
city('Buxton','us','Maine',8136.0,-70.52,43.64).
city('Camden','us','Maine',5858.0,-69.07,44.21).
city('Cape Elizabeth','us','Maine',8999.0,-70.24,43.62).
city('Caribou','us','Maine',8336.0,-68.0,46.86).
city('Cumberland','us','Maine',7554.0,-70.55,43.94).
city('Eliot','us','Maine',6528.0,-70.81,43.15).
city('Ellsworth','us','Maine',7055.0,-68.48,44.57).
city('Fairfield','us','Maine',8771.0,-69.6,44.59).
city('Falmouth','us','Maine',10731.0,-70.25,43.74).
city('Farmington','us','Maine',8849.0,-70.15,44.67).
city('Freeport','us','Maine',12415.0,-70.1,43.86).
city('Gardiner','us','Maine',6239.0,-69.79,44.21).
city('Gorham','us','Maine',22308.0,-70.46,43.7).
city('Gray','us','Maine',7396.0,-70.34,43.88).
city('Hampden','us','Maine',7781.0,-68.83,44.75).
city('Harpswell','us','Maine',5281.0,-69.99,43.8).
city('Hermon','us','Maine',4909.0,-68.92,44.82).
city('Hollis','us','Maine',4637.0,-70.59,43.61).
city('Houlton','us','Maine',6703.0,-67.84,46.12).
city('Jay','us','Maine',4988.0,-70.22,44.5).
city('Kennebunk','us','Maine',14651.0,-70.54,43.39).
city('Kittery','us','Maine',13063.0,-70.74,43.09).
city('Lebanon','us','Maine',5446.0,-70.85,43.39).
city('Lewiston','us','Maine',36199.0,-70.17,44.09).
city('Lincoln','us','Maine',6330.0,-68.5,45.37).
city('Lisbon','us','Maine',9392.0,-70.1,44.04).
city('Madawaska','us','Maine',4944.0,-68.33,47.35).
city('Madison','us','Maine',5316.0,-69.88,44.79).
city('Millinocket','us','Maine',5105.0,-68.71,45.66).
city('New Gloucester','us','Maine',5389.0,-70.29,43.97).
city('North Berwick','us','Maine',11436.0,-70.73,43.3).
city('Norway','us','Maine',5731.0,-70.54,44.21).
city('Oakland','us','Maine',7837.0,-69.71,44.55).
city('Old Orchard Beach','us','Maine',9415.0,-70.39,43.51).
city('Old Town','us','Maine',8134.0,-68.68,44.94).
city('Orono','us','Maine',9423.0,-68.68,44.88).
city('Paris','us','Maine',5073.0,-70.5,44.26).
city('Poland','us','Maine',5314.0,-70.4,44.06).
city('Portland','us','Maine',63142.0,-70.28,43.66).
city('Presque Isle','us','Maine',9466.0,-67.99,46.69).
city('Raymond','us','Maine',4649.0,-70.47,43.9).
city('Rockland','us','Maine',7527.0,-69.11,44.11).
city('Rumford','us','Maine',8339.0,-70.55,44.55).
city('Sabattus','us','Maine',4694.0,-70.11,44.12).
city('Saco','us','Maine',18447.0,-70.45,43.54).
city('Sanford','us','Maine',27201.0,-70.78,43.44).
city('Scarborough','us','Maine',27706.0,-70.36,43.58).
city('Skowhegan','us','Maine',9531.0,-69.72,44.77).
city('South Berwick','us','Maine',7480.0,-70.81,43.23).
city('South Portland','us','Maine',23893.0,-70.29,43.63).
city('Standish','us','Maine',9926.0,-70.56,43.74).
city('Topsham','us','Maine',11100.0,-69.95,43.93).
city('Turner','us','Maine',5470.0,-70.25,44.27).
city('Waldoboro','us','Maine',7462.0,-69.38,44.1).
city('Waterboro','us','Maine',7532.0,-70.72,43.54).
city('Waterville','us','Maine',15906.0,-69.66,44.55).
city('Wells','us','Maine',10162.0,-70.62,43.32).
city('Westbrook','us','Maine',15956.0,-70.35,43.69).
city('Windham','us','Maine',15881.0,-70.43,43.82).
city('Winslow','us','Maine',8098.0,-69.61,44.54).
city('Winthrop','us','Maine',8175.0,-69.97,44.31).
city('Yarmouth','us','Maine',10630.0,-70.19,43.8).
city('York','us','Maine',13618.0,-70.67,43.18).
city('Aberdeen','us','Maryland',14437.0,-76.17,39.51).
city('Adelphi','us','Maryland',15988.0,-76.97,39.0).
city('Annapolis','us','Maryland',36252.0,-76.5,38.97).
city('Arbutus','us','Maryland',20603.0,-76.69,39.24).
city('Arnold','us','Maryland',25460.0,-76.5,39.04).
city('Aspen Hill','us','Maryland',53430.0,-77.08,39.09).
city('Baltimore','us','Maryland',610892.0,-76.61,39.3).
city('Bel Air North','us','Maryland',33925.0,-76.37,39.55).
city('Bel Air South','us','Maryland',48828.0,-76.32,39.5).
city('Beltsville','us','Maryland',16546.0,-76.92,39.04).
city('Bethesda','us','Maryland',52801.0,-77.12,38.99).
city('Bowie','us','Maryland',56050.0,-76.74,38.96).
city('Brooklyn Park','us','Maryland',11083.0,-76.61,39.22).
city('Calverton','us','Maryland',13083.0,-76.95,39.06).
city('Cambridge','us','Maryland',10699.0,-76.08,38.56).
city('Camp Springs','us','Maryland',19049.0,-76.92,38.8).
city('Carney','us','Maryland',30078.0,-76.52,39.4).
city('Catonsville','us','Maryland',42827.0,-76.74,39.26).
city('Chillum','us','Maryland',36280.0,-76.98,38.97).
city('Clinton','us','Maryland',29982.0,-76.9,38.76).
city('Cockeysville','us','Maryland',20040.0,-76.63,39.48).
city('Colesville','us','Maryland',20606.0,-77.01,39.09).
city('College Park','us','Maryland',25539.0,-76.93,39.0).
city('Columbia','us','Maryland',96201.0,-76.86,39.2).
city('Coral Hills','us','Maryland',10740.0,-76.92,38.87).
city('Crofton','us','Maryland',25233.0,-76.69,39.01).
city('Cumberland','us','Maryland',20347.0,-78.76,39.65).
city('Damascus','us','Maryland',12466.0,-77.2,39.28).
city('Dundalk','us','Maryland',61659.0,-76.5,39.27).
city('East Riverdale','us','Maryland',15576.0,-76.91,38.96).
city('Easton','us','Maryland',13094.0,-76.07,38.77).
city('Edgemere','us','Maryland',9401.0,-76.46,39.22).
city('Edgewood','us','Maryland',23492.0,-76.3,39.42).
city('Eldersburg','us','Maryland',38366.0,-76.94,39.41).
city('Elkridge','us','Maryland',28734.0,-76.75,39.2).
city('Elkton','us','Maryland',14686.0,-75.82,39.6).
city('Ellicott City','us','Maryland',66215.0,-76.83,39.27).
city('Essex','us','Maryland',38851.0,-76.45,39.3).
city('Fairland','us','Maryland',23048.0,-76.95,39.08).
city('Ferndale','us','Maryland',16163.0,-76.63,39.19).
city('Forestville','us','Maryland',12058.0,-76.87,38.85).
city('Fort Meade','us','Maryland',9505.0,-76.74,39.11).
city('Fort Washington','us','Maryland',24124.0,-77.0,38.74).
city('Frederick','us','Maryland',57297.0,-77.42,39.43).
city('Friendly','us','Maryland',12155.0,-76.97,38.76).
city('Gaithersburg','us','Maryland',60062.0,-77.22,39.14).
city('Germantown','us','Maryland',64720.0,-77.26,39.18).
city('Glen Burnie','us','Maryland',40317.0,-76.6,39.17).
city('Glenn Dale','us','Maryland',14491.0,-76.8,38.99).
city('Greater Landover','us','Maryland',24317.0,-76.9,38.94).
city('Greater Upper Marlboro','us','Maryland',23873.0,-76.75,38.83).
city('Green Haven','us','Maryland',19326.0,-76.54,39.14).
city('Green Valley','us','Maryland',14091.0,-77.25,39.34).
city('Greenbelt','us','Maryland',22390.0,-76.89,38.99).
city('Hagerstown','us','Maryland',37313.0,-77.72,39.64).
city('Havre de Grace','us','Maryland',11505.0,-76.1,39.55).
city('Hillandale','us','Maryland',3239.0,-76.97,39.02).
city('Hillcrest Heights','us','Maryland',16253.0,-76.96,38.84).
city('Hyattsville','us','Maryland',15323.0,-76.95,38.96).
city('Joppatowne','us','Maryland',11716.0,-76.35,39.42).
city('Kettering','us','Maryland',11749.0,-76.79,38.89).
city('La Plata','us','Maryland',8284.0,-76.97,38.53).
city('Lake Shore','us','Maryland',13170.0,-76.49,39.1).
city('Langley Park','us','Maryland',15895.0,-76.98,38.99).
city('Lanham-Seabrook','us','Maryland',19178.0,-76.84,38.97).
city('Lansdowne-Baltimore Highlands','us','Maryland',16070.0,-76.65,39.24).
city('Largo','us','Maryland',8072.0,-76.83,38.88).
city('Laurel','us','Maryland',20860.0,-76.86,39.1).
city('Lexington Park','us','Maryland',11746.0,-76.45,38.26).
city('Lochearn','us','Maryland',25672.0,-76.73,39.35).
city('Lutherville-Timonium','us','Maryland',15767.0,-76.61,39.44).
city('Mays Chapel','us','Maryland',12278.0,-76.65,39.43).
city('Middle River','us','Maryland',24019.0,-76.43,39.33).
city('Milford Mill','us','Maryland',29074.0,-76.77,39.35).
city('Mitchellville','us','Maryland',9135.0,-76.82,38.93).
city('Montgomery Village','us','Maryland',41721.0,-77.19,39.18).
city('Mount Airy','us','Maryland',8714.0,-77.16,39.37).
city('Mount Rainier','us','Maryland',8815.0,-76.96,38.94).
city('New Carrollton','us','Maryland',13233.0,-76.88,38.97).
city('North Bethesda','us','Maryland',44379.0,-77.12,39.04).
city('North Laurel','us','Maryland',24046.0,-76.87,39.14).
city('North Potomac','us','Maryland',25972.0,-77.24,39.1).
city('Odenton','us','Maryland',26005.0,-76.7,39.06).
city('Olney','us','Maryland',36957.0,-77.08,39.15).
city('Overlea','us','Maryland',12341.0,-76.52,39.36).
city('Owings Mills','us','Maryland',27415.0,-76.79,39.41).
city('Oxon Hill-Glassmanor','us','Maryland',35692.0,-76.98,38.8).
city('Parkville','us','Maryland',31362.0,-76.55,39.38).
city('Parole','us','Maryland',16664.0,-76.55,38.98).
city('Pasadena','us','Maryland',13419.0,-76.55,39.11).
city('Perry Hall','us','Maryland',32530.0,-76.48,39.41).
city('Pikesville','us','Maryland',31882.0,-76.7,39.39).
city('Potomac','us','Maryland',45129.0,-77.2,39.03).
city('Randallstown','us','Maryland',33811.0,-76.8,39.37).
city('Redland','us','Maryland',17683.0,-77.15,39.13).
city('Reisterstown','us','Maryland',24447.0,-76.81,39.46).
city('Riviera Beach','us','Maryland',13573.0,-76.52,39.16).
city('Rockville','us','Maryland',60646.0,-77.15,39.08).
city('Rosaryville','us','Maryland',14521.0,-76.83,38.78).
city('Rosedale','us','Maryland',19736.0,-76.51,39.33).
city('Rossville','us','Maryland',12804.0,-76.48,39.35).
city('Saint Charles','us','Maryland',36376.0,-76.92,38.61).
city('Salisbury','us','Maryland',26352.0,-75.59,38.37).
city('Severn','us','Maryland',42157.0,-76.69,39.14).
city('Severna Park','us','Maryland',30292.0,-76.57,39.08).
city('Silver Spring','us','Maryland',77951.0,-77.02,39.01).
city('South Gate','us','Maryland',29658.0,-76.63,39.13).
city('South Laurel','us','Maryland',21762.0,-76.85,39.07).
city('Suitland-Silver Hill','us','Maryland',33295.0,-76.92,38.85).
city('Takoma Park','us','Maryland',17860.0,-77.0,38.98).
city('Towson','us','Maryland',53749.0,-76.62,39.4).
city('Waldorf','us','Maryland',27254.0,-76.9,38.64).
city('Walker Mill','us','Maryland',11364.0,-76.89,38.88).
city('Westminster','us','Maryland',17862.0,-77.01,39.58).
city('Wheaton-Glenmont','us','Maryland',60580.0,-77.05,39.06).
city('White Oak','us','Maryland',22492.0,-76.99,39.04).
city('Woodlawn','us','Maryland',38254.0,-76.9,38.95).
city('Abington','us','Massachusetts',17374.0,-70.96,42.12).
city('Acton','us','Massachusetts',20897.0,-71.43,42.48).
city('Acushnet','us','Massachusetts',10850.0,-70.91,41.69).
city('Agawam','us','Massachusetts',28761.0,-72.62,42.08).
city('Amesb','us','Massachusetts',18313.0,-70.93,42.86).
city('Amherst Center','us','Massachusetts',34618.0,-72.52,42.38).
city('Andover','us','Massachusetts',48286.0,-71.14,42.65).
city('Arlington','us','Massachusetts',41461.0,-71.16,42.42).
city('Ashland','us','Massachusetts',15802.0,-71.47,42.26).
city('Athol','us','Massachusetts',12871.0,-72.23,42.6).
city('Attleboro','us','Massachusetts',44271.0,-71.3,41.93).
city('Barnstable Town','us','Massachusetts',49303.0,-70.3,41.7).
city('Bedford','us','Massachusetts',12502.0,-71.27,42.49).
city('Belchertown','us','Massachusetts',22391.0,-72.41,42.28).
city('Belmont','us','Massachusetts',23546.0,-71.18,42.4).
city('Beverly','us','Massachusetts',40365.0,-70.84,42.56).
city('Billerica','us','Massachusetts',39904.0,-71.26,42.56).
city('Blackstone','us','Massachusetts',9163.0,-71.54,42.02).
city('Boston','us','Massachusetts',571281.0,-71.02,42.34).
city('Bourne','us','Massachusetts',34065.0,-70.61,41.74).
city('Braintree','us','Massachusetts',33509.0,-71.0,42.2).
city('Brewster','us','Massachusetts',37107.0,-70.08,41.77).
city('Bridgewater','us','Massachusetts',36525.0,-70.97,41.99).
city('Brockton','us','Massachusetts',94881.0,-71.03,42.08).
city('Brookline','us','Massachusetts',56079.0,-71.14,42.32).
city('Burlington','us','Massachusetts',22739.0,-71.2,42.5).
city('Cambridge','us','Massachusetts',101382.0,-71.12,42.38).
city('Canton','us','Massachusetts',21679.0,-71.16,42.16).
city('Carver','us','Massachusetts',11718.0,-70.77,41.88).
city('Charlton','us','Massachusetts',12764.0,-71.99,42.15).
city('Chelmsford','us','Massachusetts',33925.0,-71.37,42.6).
city('Chelsea','us','Massachusetts',33062.0,-71.03,42.4).
city('Chicopee','us','Massachusetts',55179.0,-72.57,42.18).
city('Clinton','us','Massachusetts',16317.0,-71.69,42.42).
city('Concord','us','Massachusetts',16810.0,-71.35,42.46).
city('Danvers','us','Massachusetts',25829.0,-70.95,42.57).
city('Dartmouth','us','Massachusetts',31720.0,-71.0,41.57).
city('Dedham','us','Massachusetts',23019.0,-71.18,42.25).
city('Dennis','us','Massachusetts',26780.0,-70.2,41.74).
city('Dracut','us','Massachusetts',28831.0,-71.3,42.67).
city('Dudley','us','Massachusetts',11165.0,-71.93,42.05).
city('Duxbury','us','Massachusetts',27695.0,-70.67,42.04).
city('East Bridgewater','us','Massachusetts',14021.0,-70.95,42.03).
city('East Longmeadow','us','Massachusetts',15102.0,-72.51,42.06).
city('Easthampton','us','Massachusetts',16611.0,-72.67,42.27).
city('Easton','us','Massachusetts',23459.0,-71.1,42.04).
city('Everett','us','Massachusetts',37148.0,-71.05,42.41).
city('Fairhaven','us','Massachusetts',16453.0,-70.9,41.64).
city('Fall River','us','Massachusetts',93000.0,-71.11,41.71).
city('Falmouth','us','Massachusetts',59431.0,-70.6,41.55).
city('Fitchburg','us','Massachusetts',40363.0,-71.82,42.59).
city('Foxborough','us','Massachusetts',22733.0,-71.25,42.07).
city('Framingham','us','Massachusetts',65413.0,-71.44,42.31).
city('Franklin','us','Massachusetts',30636.0,-71.39,42.09).
city('Freetown','us','Massachusetts',8975.0,-71.07,41.77).
city('Gardner','us','Massachusetts',21175.0,-71.99,42.58).
city('Gloucester','us','Massachusetts',30916.0,-70.68,42.63).
city('Grafton','us','Massachusetts',16583.0,-71.69,42.21).
city('Greenfield','us','Massachusetts',19753.0,-72.6,42.59).
city('Groton','us','Massachusetts',18772.0,-71.57,42.61).
city('Hanover','us','Massachusetts',16906.0,-70.81,42.12).
city('Hanson','us','Massachusetts',15315.0,-70.85,42.07).
city('Harwich','us','Massachusetts',13059.0,-70.08,41.69).
city('Haverhill','us','Massachusetts',61465.0,-71.09,42.78).
city('Hingham','us','Massachusetts',30151.0,-70.89,42.24).
city('Holbrook','us','Massachusetts',10876.0,-71.01,42.15).
city('Holden','us','Massachusetts',17016.0,-71.86,42.36).
city('Holliston','us','Massachusetts',14010.0,-71.43,42.2).
city('Holyoke','us','Massachusetts',40141.0,-72.64,42.21).
city('Hopkinton','us','Massachusetts',22601.0,-71.52,42.22).
city('Hudson','us','Massachusetts',19697.0,-71.56,42.39).
city('Hull','us','Massachusetts',11324.0,-70.88,42.3).
city('Ipswich','us','Massachusetts',18768.0,-70.84,42.68).
city('Kingston','us','Massachusetts',15658.0,-70.72,41.99).
city('Lakeville','us','Massachusetts',10787.0,-70.95,41.85).
city('Lawrence','us','Massachusetts',72609.0,-71.16,42.7).
city('Leicester','us','Massachusetts',11064.0,-71.91,42.25).
city('Leominster','us','Massachusetts',42301.0,-71.77,42.52).
city('Lexington','us','Massachusetts',30661.0,-71.22,42.45).
city('Longmeadow','us','Massachusetts',15699.0,-72.57,42.05).
city('Lowell','us','Massachusetts',103469.0,-71.32,42.64).
city('Ludlow','us','Massachusetts',22201.0,-72.48,42.17).
city('Lunenburg','us','Massachusetts',16520.0,-71.72,42.6).
city('Lynn','us','Massachusetts',89691.0,-70.96,42.47).
city('Lynnfield','us','Massachusetts',11748.0,-71.04,42.54).
city('Malden','us','Massachusetts',55290.0,-71.06,42.43).
city('Mansfield','us','Massachusetts',23380.0,-71.22,42.03).
city('Marblehead','us','Massachusetts',20424.0,-70.84,42.49).
city('Marlborough','us','Massachusetts',38334.0,-71.55,42.35).
city('Marshfield','us','Massachusetts',40849.0,-70.71,42.09).
city('Mashpee','us','Massachusetts',14834.0,-70.48,41.65).
city('Maynard','us','Massachusetts',10275.0,-71.46,42.43).
city('Medfield','us','Massachusetts',14846.0,-71.3,42.19).
city('Medford','us','Massachusetts',53963.0,-71.11,42.42).
city('Medway','us','Massachusetts',13042.0,-71.4,42.14).
city('Melrose','us','Massachusetts',26466.0,-71.06,42.45).
city('Methuen','us','Massachusetts',45372.0,-71.19,42.73).
city('Middleborough','us','Massachusetts',21401.0,-70.93,41.89).
city('Middleton','us','Massachusetts',9859.0,-71.02,42.6).
city('Milford','us','Massachusetts',28631.0,-71.52,42.15).
city('Millbury','us','Massachusetts',13606.0,-71.78,42.2).
city('Milton','us','Massachusetts',25586.0,-71.08,42.24).
city('Nantucket','us','Massachusetts',14775.0,-70.1,41.28).
city('Natick','us','Massachusetts',32276.0,-71.35,42.29).
city('Needham','us','Massachusetts',29125.0,-71.24,42.28).
city('New Bedford','us','Massachusetts',94083.0,-70.94,41.66).
city('Newburyport','us','Massachusetts',17575.0,-70.89,42.81).
city('Newton','us','Massachusetts',84851.0,-71.21,42.33).
city('Norfolk','us','Massachusetts',10386.0,-71.33,42.12).
city('North Adams','us','Massachusetts',14106.0,-73.11,42.69).
city('North Andover','us','Massachusetts',28222.0,-71.14,42.7).
city('North Attleborough','us','Massachusetts',34400.0,-71.33,41.97).
city('North Reading','us','Massachusetts',14101.0,-71.08,42.58).
city('Northampton','us','Massachusetts',29665.0,-72.68,42.33).
city('Northborough','us','Massachusetts',18304.0,-71.65,42.31).
city('Northbridge','us','Massachusetts',14061.0,-71.65,42.15).
city('Norton','us','Massachusetts',19808.0,-71.19,41.97).
city('Norwell','us','Massachusetts',10581.0,-70.8,42.16).
city('Norwood','us','Massachusetts',28625.0,-71.2,42.19).
city('Oxford','us','Massachusetts',17746.0,-71.87,42.11).
city('Palmer','us','Massachusetts',18261.0,-72.33,42.16).
city('Peabody','us','Massachusetts',50293.0,-70.97,42.53).
city('Pembroke','us','Massachusetts',18041.0,-70.79,42.07).
city('Pepperell','us','Massachusetts',17453.0,-71.59,42.67).
city('Pittsfield','us','Massachusetts',44174.0,-73.26,42.45).
city('Plymouth','us','Massachusetts',90615.0,-70.67,41.96).
city('Quincy','us','Massachusetts',89168.0,-71.01,42.26).
city('Randolph','us','Massachusetts',30768.0,-71.05,42.18).
city('Raynham','us','Massachusetts',13153.0,-71.05,41.93).
city('Reading','us','Massachusetts',23441.0,-71.11,42.54).
city('Rehoboth','us','Massachusetts',11486.0,-71.24,41.85).
city('Revere','us','Massachusetts',46420.0,-70.99,42.42).
city('Rockland','us','Massachusetts',17982.0,-70.92,42.13).
city('Salem','us','Massachusetts',42455.0,-70.87,42.53).
city('Sandwich','us','Massachusetts',34886.0,-70.5,41.76).
city('Saugus','us','Massachusetts',26668.0,-71.02,42.47).
city('Scituate','us','Massachusetts',26400.0,-70.73,42.19).
city('Seekonk','us','Massachusetts',13966.0,-71.33,41.82).
city('Sharon','us','Massachusetts',24066.0,-71.18,42.12).
city('Shrewsbury','us','Massachusetts',33893.0,-71.72,42.3).
city('Somerset','us','Massachusetts',18943.0,-71.16,41.74).
city('Somerville','us','Massachusetts',75261.0,-71.1,42.39).
city('South Hadley','us','Massachusetts',17652.0,-72.58,42.26).
city('South Yarmouth','us','Massachusetts',12162.0,-70.2,41.67).
city('Southborough','us','Massachusetts',9686.0,-71.53,42.3).
city('Southbridge','us','Massachusetts',19030.0,-72.03,42.08).
city('Southwick','us','Massachusetts',9444.0,-72.77,42.05).
city('Spencer','us','Massachusetts',14814.0,-71.99,42.24).
city('Springfield','us','Massachusetts',152227.0,-72.54,42.12).
city('Stoneham','us','Massachusetts',21796.0,-71.1,42.47).
city('Stoughton','us','Massachusetts',26915.0,-71.1,42.12).
city('Sudbury','us','Massachusetts',17343.0,-71.42,42.38).
city('Sutton','us','Massachusetts',9215.0,-71.77,42.15).
city('Swampscott','us','Massachusetts',14447.0,-70.89,42.47).
city('Swansea','us','Massachusetts',16525.0,-71.19,41.75).
city('Taunton','us','Massachusetts',57160.0,-71.09,41.9).
city('Tewksbury','us','Massachusetts',29326.0,-71.23,42.61).
city('Townsend','us','Massachusetts',16933.0,-71.71,42.67).
city('Tyngsborough','us','Massachusetts',11366.0,-71.43,42.68).
city('Uxbridge','us','Massachusetts',12614.0,-71.63,42.08).
city('Wakefield','us','Massachusetts',24712.0,-71.07,42.5).
city('Walpole','us','Massachusetts',32670.0,-71.25,42.14).
city('Waltham','us','Massachusetts',58570.0,-71.24,42.39).
city('Ware','us','Massachusetts',11610.0,-72.25,42.26).
city('Wareham','us','Massachusetts',21478.0,-70.73,41.77).
city('Watertown','us','Massachusetts',32918.0,-71.18,42.37).
city('Wayland','us','Massachusetts',13155.0,-71.36,42.37).
city('Webster','us','Massachusetts',19028.0,-71.87,42.05).
city('Wellesley','us','Massachusetts',26446.0,-71.29,42.3).
city('West Springfield','us','Massachusetts',27912.0,-72.65,42.12).
city('Westborough','us','Massachusetts',29313.0,-71.62,42.27).
city('Westfield','us','Massachusetts',40932.0,-72.76,42.14).
city('Westford','us','Massachusetts',21587.0,-71.44,42.58).
city('Weston','us','Massachusetts',11682.0,-71.3,42.37).
city('Westport','us','Massachusetts',14809.0,-71.08,41.62).
city('Westwood','us','Massachusetts',14029.0,-71.23,42.22).
city('Weymouth','us','Massachusetts',54395.0,-70.95,42.21).
city('Whitman','us','Massachusetts',14495.0,-70.94,42.08).
city('Wilbraham','us','Massachusetts',20883.0,-72.44,42.14).
city('Wilmington','us','Massachusetts',21704.0,-71.17,42.56).
city('Winchendon','us','Massachusetts',12954.0,-72.05,42.68).
city('Winchester','us','Massachusetts',21366.0,-71.15,42.45).
city('Winthrop','us','Massachusetts',17618.0,-70.97,42.38).
city('Woburn','us','Massachusetts',37746.0,-71.16,42.49).
city('Worcester','us','Massachusetts',177216.0,-71.81,42.27).
city('Wrentham','us','Massachusetts',11251.0,-71.33,42.07).
city('Yarmouth','us','Massachusetts',25243.0,-70.23,41.71).
city('Adrian','us','Michigan',22704.0,-84.04,41.9).
city('Albion','us','Michigan',9154.0,-84.76,42.25).
city('Allen Park','us','Michigan',28157.0,-83.21,42.26).
city('Alma','us','Michigan',9373.0,-84.65,43.38).
city('Alpena','us','Michigan',10718.0,-83.44,45.07).
city('Ann Arbor','us','Michigan',113810.0,-83.73,42.28).
city('Auburn Hills','us','Michigan',20816.0,-83.24,42.67).
city('Battle Creek','us','Michigan',54088.0,-85.23,42.3).
city('Bay City','us','Michigan',34568.0,-83.89,43.59).
city('Beecher','us','Michigan',11971.0,-83.7,43.09).
city('Benton Harbor','us','Michigan',10893.0,-86.45,42.12).
city('Berkley','us','Michigan',14997.0,-83.19,42.5).
city('Beverly Hills','us','Michigan',10032.0,-83.24,42.52).
city('Big Rapids','us','Michigan',10731.0,-85.49,43.7).
city('Birmingham','us','Michigan',18977.0,-83.22,42.54).
city('Bloomfield Township','us','Michigan',43067.0,-83.27,42.58).
city('Burton','us','Michigan',31587.0,-83.62,43.0).
city('Cadillac','us','Michigan',10258.0,-85.42,44.25).
city('Canton','us','Michigan',86825.0,-83.48,42.31).
city('Clawson','us','Michigan',12222.0,-83.15,42.54).
city('Clinton','us','Michigan',99753.0,-82.92,42.59).
city('Coldwater','us','Michigan',10864.0,-85.0,41.94).
city('Cutlerville','us','Michigan',17231.0,-85.66,42.84).
city('Dearborn','us','Michigan',95170.0,-83.21,42.31).
city('Dearborn Heights','us','Michigan',56359.0,-83.27,42.33).
city('Detroit','us','Michigan',884941.0,-83.1,42.38).
city('East Grand Rapids','us','Michigan',10380.0,-85.61,42.95).
city('East Lansing','us','Michigan',48371.0,-84.48,42.74).
city('Eastpointe','us','Michigan',32682.0,-82.95,42.47).
city('Ecorse','us','Michigan',10773.0,-83.14,42.25).
city('Escanaba','us','Michigan',12622.0,-87.08,45.75).
city('Farmington','us','Michigan',9989.0,-83.38,42.46).
city('Farmington Hills','us','Michigan',79955.0,-83.38,42.49).
city('Fenton','us','Michigan',12236.0,-83.71,42.8).
city('Ferndale','us','Michigan',21361.0,-83.13,42.46).
city('Flint','us','Michigan',117258.0,-83.69,43.02).
city('Forest Hills','us','Michigan',23099.0,-85.49,42.96).
city('Fraser','us','Michigan',14878.0,-82.95,42.54).
city('Garden City','us','Michigan',29023.0,-83.34,42.32).
city('Grand Haven','us','Michigan',10644.0,-86.22,43.06).
city('Grand Rapids','us','Michigan',193852.0,-85.66,42.96).
city('Grandville','us','Michigan',16741.0,-85.76,42.9).
city('Grosse Ile','us','Michigan',11361.0,-83.15,42.13).
city('Grosse Pointe Farms','us','Michigan',9360.0,-82.86,42.38).
city('Grosse Pointe Park','us','Michigan',11937.0,-82.92,42.37).
city('Grosse Pointe Woods','us','Michigan',16364.0,-82.9,42.44).
city('Hamtramck','us','Michigan',21994.0,-83.06,42.4).
city('Harper Woods','us','Michigan',13665.0,-82.93,42.44).
city('Harrison','us','Michigan',24146.0,-82.82,42.59).
city('Haslett','us','Michigan',11713.0,-84.41,42.75).
city('Hazel Park','us','Michigan',18261.0,-83.1,42.46).
city('Highland Park','us','Michigan',15568.0,-83.1,42.4).
city('Holland','us','Michigan',34544.0,-86.1,42.77).
city('Holt','us','Michigan',11023.0,-84.53,42.64).
city('Howell','us','Michigan',9860.0,-83.93,42.61).
city('Inkster','us','Michigan',28844.0,-83.32,42.29).
city('Ionia','us','Michigan',13647.0,-85.07,42.98).
city('Jackson','us','Michigan',34416.0,-84.4,42.24).
city('Jenison','us','Michigan',16758.0,-85.83,42.91).
city('Kalamazoo','us','Michigan',74138.0,-85.59,42.27).
city('Kentwood','us','Michigan',47059.0,-85.59,42.88).
city('Lansing','us','Michigan',117691.0,-84.55,42.71).
city('Lapeer','us','Michigan',9372.0,-83.32,43.05).
city('Lincoln Park','us','Michigan',38297.0,-83.18,42.24).
city('Livonia','us','Michigan',98218.0,-83.37,42.4).
city('Madison Heights','us','Michigan',30004.0,-83.1,42.5).
city('Marquette','us','Michigan',20831.0,-87.4,46.55).
city('Marysville','us','Michigan',9881.0,-82.48,42.91).
city('Melvindale','us','Michigan',10492.0,-83.18,42.28).
city('Midland','us','Michigan',42400.0,-84.23,43.62).
city('Monroe','us','Michigan',21076.0,-83.39,41.92).
city('Mount Clemens','us','Michigan',16776.0,-82.88,42.6).
city('Mount Pleasant','us','Michigan',25281.0,-84.78,43.6).
city('Muskegon','us','Michigan',40112.0,-86.26,43.23).
city('Muskegon Heights','us','Michigan',11689.0,-86.24,43.2).
city('New Baltimore','us','Michigan',11453.0,-82.74,42.69).
city('Niles','us','Michigan',11739.0,-86.25,41.83).
city('Northview','us','Michigan',15103.0,-85.6,43.05).
city('Norton Shores','us','Michigan',23486.0,-86.25,43.16).
city('Novi','us','Michigan',53754.0,-83.49,42.48).
city('Oak Park','us','Michigan',28644.0,-83.18,42.46).
city('Okemos','us','Michigan',23926.0,-84.41,42.71).
city('Owosso','us','Michigan',15373.0,-84.18,43.0).
city('Plymouth Township','us','Michigan',29735.0,-83.49,42.37).
city('Pontiac','us','Michigan',67994.0,-83.29,42.65).
city('Port Huron','us','Michigan',30978.0,-82.43,42.99).
city('Portage','us','Michigan',46403.0,-85.59,42.2).
city('Redford','us','Michigan',49936.0,-83.29,42.39).
city('River Rouge','us','Michigan',9117.0,-83.12,42.27).
city('Riverview','us','Michigan',12762.0,-83.19,42.17).
city('Rochester','us','Michigan',11485.0,-83.13,42.68).
city('Rochester Hills','us','Michigan',68895.0,-83.16,42.67).
city('Romulus','us','Michigan',24018.0,-83.37,42.22).
city('Roseville','us','Michigan',47372.0,-82.94,42.51).
city('Royal Oak','us','Michigan',57570.0,-83.15,42.51).
city('Saginaw','us','Michigan',57536.0,-83.95,43.42).
city('Saginaw Township North','us','Michigan',25756.0,-84.01,43.46).
city('Saginaw Township South','us','Michigan',13596.0,-84.02,43.42).
city('Saint Clair Shores','us','Michigan',60604.0,-82.89,42.49).
city('Sault Sainte Marie','us','Michigan',13501.0,-84.35,46.48).
city('South Lyon','us','Michigan',11450.0,-83.65,42.46).
city('Southfield','us','Michigan',76828.0,-83.26,42.48).
city('Southgate','us','Michigan',29669.0,-83.21,42.2).
city('Sterling Heights','us','Michigan',126657.0,-83.03,42.58).
city('Sturgis','us','Michigan',11081.0,-85.42,41.8).
city('Taylor','us','Michigan',65088.0,-83.27,42.23).
city('Traverse City','us','Michigan',14425.0,-85.6,44.75).
city('Trenton','us','Michigan',19604.0,-83.19,42.14).
city('Troy','us','Michigan',81269.0,-83.14,42.58).
city('Walker','us','Michigan',23824.0,-85.75,42.98).
city('Warren','us','Michigan',133517.0,-83.03,42.49).
city('Waterford','us','Michigan',75737.0,-83.39,42.66).
city('Waverly','us','Michigan',16332.0,-84.62,42.74).
city('Wayne','us','Michigan',18785.0,-83.39,42.28).
city('West Bloomfield Township','us','Michigan',69577.0,-83.38,42.57).
city('Westland','us','Michigan',84801.0,-83.38,42.32).
city('Wixom','us','Michigan',13696.0,-83.54,42.52).
city('Woodhaven','us','Michigan',12917.0,-83.24,42.13).
city('Wyandotte','us','Michigan',26802.0,-83.16,42.21).
city('Wyoming','us','Michigan',70308.0,-85.7,42.89).
city('Ypsilanti','us','Michigan',22191.0,-83.62,42.24).
city('Albert Lea','us','Minnesota',17605.0,-93.37,43.66).
city('Alexandria','us','Minnesota',10226.0,-95.38,45.89).
city('Andover','us','Minnesota',30209.0,-93.33,45.26).
city('Anoka','us','Minnesota',17706.0,-93.39,45.21).
city('Apple Valley','us','Minnesota',50540.0,-93.2,44.75).
city('Austin','us','Minnesota',23451.0,-92.97,43.67).
city('Bemidji','us','Minnesota',13331.0,-94.88,47.48).
city('Blaine','us','Minnesota',54207.0,-93.21,45.17).
city('Bloomington','us','Minnesota',81383.0,-93.32,44.83).
city('Brainerd','us','Minnesota',14218.0,-94.19,46.35).
city('Brooklyn Center','us','Minnesota',27718.0,-93.32,45.07).
city('Brooklyn Park','us','Minnesota',67595.0,-93.35,45.11).
city('Buffalo','us','Minnesota',14283.0,-93.87,45.18).
city('Burnsville','us','Minnesota',59492.0,-93.28,44.76).
city('Champlin','us','Minnesota',23364.0,-93.39,45.17).
city('Chanhassen','us','Minnesota',23551.0,-93.56,44.86).
city('Chaska','us','Minnesota',23176.0,-93.61,44.82).
city('Cloquet','us','Minnesota',11548.0,-92.49,46.73).
city('Columbia Heights','us','Minnesota',18235.0,-93.25,45.05).
city('Coon Rapids','us','Minnesota',62528.0,-93.31,45.17).
city('Cottage Grove','us','Minnesota',32975.0,-92.93,44.82).
city('Crystal','us','Minnesota',21834.0,-93.36,45.04).
city('Duluth','us','Minnesota',84800.0,-92.12,46.78).
city('Eagan','us','Minnesota',64218.0,-93.16,44.82).
city('East Bethel','us','Minnesota',11971.0,-93.2,45.34).
city('Eden Prairie','us','Minnesota',63319.0,-93.46,44.85).
city('Edina','us','Minnesota',45945.0,-93.36,44.89).
city('Elk River','us','Minnesota',20377.0,-93.57,45.33).
city('Fairmont','us','Minnesota',10576.0,-94.46,43.64).
city('Faribault','us','Minnesota',22633.0,-93.27,44.3).
city('Farmington','us','Minnesota',18954.0,-93.18,44.66).
city('Fergus Falls','us','Minnesota',14364.0,-96.07,46.28).
city('Forest Lake','us','Minnesota',17449.0,-92.98,45.28).
city('Fridley','us','Minnesota',26834.0,-93.26,45.08).
city('Golden Valley','us','Minnesota',20325.0,-93.36,44.99).
city('Ham Lake','us','Minnesota',14954.0,-93.2,45.26).
city('Hastings','us','Minnes',20833.0,-92.85,44.73).
city('Hibbing','us','Minnesota',16638.0,-92.95,47.4).
city('Hopkins','us','Minnesota',17073.0,-93.41,44.93).
city('Hugo','us','Minnesota',10125.0,-92.96,45.15).
city('Hutchinson','us','Minnesota',13759.0,-94.37,44.89).
city('Inver Grove Heights','us','Minnesota',32363.0,-93.03,44.84).
city('Lakeville','us','Minnesota',50994.0,-93.24,44.68).
city('Lino Lakes','us','Minnesota',20095.0,-93.08,45.16).
city('Little Canada','us','Minnesota',9617.0,-93.09,45.03).
city('Mahtomedi','us','Minnesota',8258.0,-92.96,45.06).
city('Mankato','us','Minnesota',35138.0,-93.99,44.17).
city('Maple Grove','us','Minnesota',59902.0,-93.46,45.11).
city('Maplewood','us','Minnesota',36400.0,-93.02,44.99).
city('Marshall','us','Minnesota',12348.0,-95.79,44.45).
city('Mendota Heights','us','Minnesota',11195.0,-93.14,44.88).
city('Minneapolis','us','Minnesota',367773.0,-93.27,44.96).
city('Minnetonka','us','Minnesota',50117.0,-93.46,44.93).
city('Monticello','us','Minnesota',10871.0,-93.8,45.3).
city('Moorhead','us','Minnesota',33137.0,-96.76,46.0).
city('Mound','us','Minnesota',9354.0,-93.66,44.93).
city('Mounds View','us','Minnesota',12648.0,-93.21,45.11).
city('New Brighton','us','Minnesota',21295.0,-93.2,45.07).
city('New Hope','us','Minnesota',19851.0,-93.39,45.04).
city('New Ulm','us','Minnesota',13273.0,-94.46,44.31).
city('North Branch','us','Minnesota',10389.0,-92.98,45.51).
city('North Mankato','us','Minnesota',12590.0,-94.03,44.18).
city('North Saint Paul','us','Minnesota',11799.0,-93.0,45.01).
city('Northfield','us','Minnesota',18900.0,-93.17,44.45).
city('Oakd','us','Minnesota',28143.0,-92.97,44.99).
city('Owatonna','us','Minnesota',23955.0,-93.22,44.09).
city('Plymouth','us','Minnesota',72239.0,-93.46,45.02).
city('Prior Lake','us','Minnesota',23790.0,-93.43,44.73).
city('Ramsey','us','Minnesota',20362.0,-93.45,45.26).
city('Red Wing','us','Minnesota',15972.0,-92.6,44.58).
city('Richfield','us','Minnesota',33349.0,-93.28,44.88).
city('Robbinsdale','us','Minnesota',13314.0,-93.33,45.03).
city('Rochester','us','Minnesota',96355.0,-92.48,44.01).
city('Rosemount','us','Minnesot',18593.0,-93.07,44.75).
city('Roseville','us','Minnesota',32563.0,-93.15,45.02).
city('Saint Cloud','us','Minnesota',59154.0,-94.17,45.55).
city('Saint Louis Park','us','Minnesota',44071.0,-93.36,44.95).
city('Saint Michael','us','Minnesota',15516.0,-93.67,45.21).
city('Saint Paul','us','Minnesota',274792.0,-93.1,44.95).
city('Saint Peter','us','Minnesota',10584.0,-93.96,44.33).
city('Sartell','us','Minnesota',13553.0,-94.21,45.62).
city('Sauk Rapids','us','Minnesota',12321.0,-94.16,45.59).
city('Savage','us','Minnesota',27096.0,-93.36,44.76).
city('Shakopee','us','Minnesota',30384.0,-93.48,44.77).
city('Shoreview','us','Minnesota',27622.0,-93.14,45.08).
city('South Saint Paul','us','Minnesota',19338.0,-93.04,44.89).
city('Stillwater','us','Minnesota',17746.0,-92.82,45.06).
city('Vadnais Heights','us','Minnesota',13003.0,-93.07,45.06).
city('Waconia','us','Minnesota',8808.0,-93.79,44.85).
city('Waseca','us','Minnesota',9541.0,-93.51,44.08).
city('West Saint Paul','us','Minnesota',19195.0,-93.09,44.9).
city('White Bear Lake','us','Minnesota',24301.0,-93.01,45.07).
city('Willmar','us','Minnesota',18473.0,-95.05,45.12).
city('Winona','us','Minnesota',26618.0,-91.66,44.05).
city('Woodbury','us','Minnesota',50955.0,-92.92,44.91).
city('Worthington','us','Minnesota',11274.0,-95.6,43.63).
city('Bay Saint Louis','us','Mississippi',8134.0,-89.33,30.31).
city('Biloxi','us','Mississippi',47661.0,-88.93,30.41).
city('Brandon','us','Mississippi',19239.0,-90.0,32.28).
city('Brookhaven','us','Mississippi',9786.0,-90.45,31.58).
city('Canton','us','Mississippi',12759.0,-90.03,32.61).
city('Clarksdale','us','Mississippi',19143.0,-90.58,34.2).
city('Cleveland','us','Mississippi',12763.0,-90.73,33.74).
city('Clinton','us','Mississippi',24583.0,-90.33,32.34).
city('Columbus','us','Mississippi',24386.0,-88.4,33.5).
city('Corinth','us','Mississippi',14168.0,-88.52,34.94).
city('Gautier','us','Mississippi',24891.0,-88.64,30.39).
city('Greenville','us','Mississippi',38107.0,-91.05,33.39).
city('Greenwood','us','Mississippi',17162.0,-90.19,33.52).
city('Grenada','us','Mississippi',14558.0,-89.81,33.78).
city('Gulfport','us','Mississippi',71329.0,-89.07,30.39).
city('Hattiesburg','us','Mississippi',48123.0,-89.31,31.31).
city('Horn Lake','us','Mississippi',16036.0,-90.04,34.96).
city('Indianola','us','Mississippi',11201.0,-90.64,33.45).
city('Jackson','us','Mississippi',176696.0,-90.21,32.32).
city('Laurel','us','Mississippi',17891.0,-89.14,31.69).
city('Long Beach','us','Mississippi',16763.0,-89.17,30.36).
city('MacComb','us','Mississippi',13017.0,-90.47,31.24).
city('Madison','us','Mississippi',16786.0,-90.11,32.45).
city('Meridian','us','Mississippi',39437.0,-88.71,32.38).
city('Moss Point','us','Mississippi',14998.0,-88.53,30.43).
city('Natchez','us','Mississippi',17118.0,-91.39,31.55).
city('Ocean Springs','us','Mississippi',17659.0,-88.8,30.41).
city('Olive Branch','us','Mississippi',27748.0,-89.83,34.95).
city('Oxford','us','Mississippi',13348.0,-89.53,34.36).
city('Pascagoula','us','Mississippi',25621.0,-88.55,30.37).
city('Pearl','us','Mississippi',23272.0,-90.11,32.27).
city('Picayune','us','Mississippi',10650.0,-89.68,30.53).
city('Ridgeland','us','Mississippi',22714.0,-90.13,32.42).
city('Southaven','us','Mississippi',38578.0,-90.0,34.97).
city('Starkville','us','Mississippi',22820.0,-88.82,33.46).
city('Tupelo','us','Mississippi',35956.0,-88.73,34.26).
city('Vicksburg','us','Mississippi',25701.0,-90.87,32.33).
city('West Point','us','Mississippi',11674.0,-88.65,33.61).
city('Yazoo City','us','Mississippi',12081.0,-90.41,32.86).
city('Affton','us','Missouri',20092.0,-90.33,38.55).
city('Arnold','us','Missouri',20203.0,-90.37,38.43).
city('Ballwin','us','Missouri',30744.0,-90.55,38.59).
city('Bellefontaine Neighbors','us','Missouri',10668.0,-90.23,38.75).
city('Belton','us','Missouri',24522.0,-94.53,38.82).
city('Berkeley','us','Missouri',9688.0,-90.34,38.74).
city('Blue Springs','us','Missouri',49767.0,-94.27,39.02).
city('Bolivar','us','Missouri',9901.0,-93.41,37.61).
city('Bridgeton','us','Missouri',15421.0,-90.43,38.77).
city('Cape Girardeau','us','Missouri',35904.0,-89.55,37.31).
city('Carthage','us','Missouri',13047.0,-94.31,37.17).
city('Chesterfield','us','Missouri',47128.0,-90.58,38.65).
city('Clayton','us','Missouri',15915.0,-90.33,38.64).
city('Clinton','us','Missouri',9421.0,-93.77,38.37).
city('Columbia','us','Missouri',91415.0,-92.33,38.95).
city('Concord','us','Missouri',15243.0,-90.35,38.51).
city('Crestwood','us','Missouri',11771.0,-90.38,38.56).
city('Creve Coeur','us','Missouri',16695.0,-90.44,38.66).
city('Ellisville','us','Missouri',9362.0,-90.59,38.59).
city('Excelsior Springs','us','Missouri',11422.0,-94.24,39.34).
city('Farmington','us','Missouri',14739.0,-90.43,37.78).
city('Ferguson','us','Missouri',21519.0,-90.3,38.75).
city('Festus','us','Missouri',10205.0,-90.4,38.22).
city('Florissant','us','Missouri',51786.0,-90.32,38.8).
city('Fort Leonard Wood','us','Missouri',12628.0,-92.16,37.71).
city('Fulton','us','Missouri',11936.0,-91.95,38.85).
city('Gladstone','us','Missouri',27601.0,-94.56,39.21).
city('Grandview','us','Missouri',24945.0,-94.52,38.88).
city('Hannibal','us','Missouri',17568.0,-91.38,39.71).
city('Harrisonville','us','Missouri',9722.0,-94.35,38.65).
city('Hazelwood','us','Missouri',25661.0,-9.0,38.78).
city('Independence','us','Missouri',110675.0,-94.35,39.09).
city('Jackson','us','Missouri',12835.0,-89.65,37.38).
city('Jefferson City','us','Missouri',35883.0,-92.19,38.57).
city('Jennings','us','Missouri',14895.0,-90.26,38.72).
city('Joplin','us','Missouri',46818.0,-94.5,37.08).
city('Kansas City','us','Missouri',442028.0,-94.55,39.12).
city('Kennett','us','Missouri',10926.0,-90.05,36.24).
city('Kirksville','us','Missouri',16973.0,-92.58,40.2).
city('Kirkwood','us','Missouri',27126.0,-90.42,38.58).
city('Lake Saint Louis','us','Missouri',14525.0,-90.78,38.78).
city('Lebanon','us','Missouri',13007.0,-92.66,37.67).
city('Lees Summit','us','Missouri',81509.0,-94.38,38.92).
city('Lemay','us','Missouri',16706.0,-90.28,38.53).
city('Liberty','us','Missouri',29027.0,-94.42,39.24).
city('Manchester','us','Missouri',19235.0,-90.51,38.58).
city('Maplewood','us','Missouri',8775.0,-90.32,38.61).
city('Marshall','us','Missouri',11813.0,-93.2,39.11).
city('Maryland Heights','us','Missouri',25311.0,-90.48,38.72).
city('Maryville','us','Missouri',10670.0,-94.87,40.34).
city('Mehlville','us','Missouri',29175.0,-90.32,38.5).
city('Mexico','us','Missouri',10788.0,-91.87,39.17).
city('Moberly','us','Missouri',13849.0,-92.44,39.42).
city('Murphy','us','Missouri',8834.0,-90.49,38.49).
city('Neosho','us','Missouri',10890.0,-94.38,36.86).
city('Nixa','us','Missouri',14973.0,-93.3,37.05).
city('OFallon','us','Missouri',73300.0,-90.71,38.78).
city('Oakville','us','Missouri',36787.0,-90.32,38.44).
city('Overland','us','Missouri',16130.0,-90.37,38.7).
city('Ozark','us','Missouri',15951.0,-93.21,37.03).
city('Poplar Bluff','us','Missouri',16488.0,-90.41,36.76).
city('Raymore','us','Missouri',14620.0,-94.46,38.8).
city('Raytown','us','Missouri',29219.0,-94.47,38.99).
city('Republic','us','Missouri',10423.0,-93.47,37.12).
city('Richmond Heights','us','Missouri',9312.0,-90.33,38.63).
city('Rolla','us','Missouri',17865.0,-91.77,37.95).
city('Saint Ann','us','Missouri',13205.0,-90.39,38.73).
city('Saint Charles','us','Missouri',62011.0,-90.52,38.79).
city('Saint Joseph','us','Missouri',71745.0,-94.82,39.76).
city('Saint Louis','us','Missouri',320916.0,-90.24,38.64).
city('Saint Peters','us','Missouri',53779.0,-90.61,38.78).
city('Sappington','us','Missouri',6426.0,-90.39,38.52).
city('Sedalia','us','Missouri',19772.0,-93.23,38.7).
city('Sikeston','us','Missouri',17026.0,-89.58,36.88).
city('Spanish Lake','us','Missouri',21637.0,-90.21,38.79).
city('Springfield','us','Missouri',150443.0,-93.29,37.2).
city('Town and Country','us','Missouri',10818.0,-90.48,38.62).
city('University City','us','Missouri',37634.0,-90.33,38.67).
city('Warrensburg','us','Missouri',17431.0,-93.73,38.76).
city('Washington','us','Missouri',13890.0,-91.01,38.55).
city('Webb City','us','Missouri',10503.0,-94.47,37.14).
city('Webster Groves','us','Missouri',22875.0,-90.35,38.59).
city('Wentzville','us','Missouri',17610.0,-90.86,38.82).
city('West Plains','us','Missouri',11050.0,-91.86,36.74).
city('Wildwood','us','Missouri',35007.0,-90.64,38.4).
city('Anaconda','us','Montana',8693.0,-113.08,46.07).
city('Belgrade','us','Montana',7452.0,-111.18,45.78).
city('Billings','us','Montana',99751.0,-108.54,45.79).
city('Bozeman','us','Montana',33178.0,-111.04,45.68).
city('Butte','us','Montana',31056.0,-112.66,45.9).
city('Dillon','us','Montana',3964.0,-112.63,45.22).
city('Glendive','us','Montana',4699.0,-104.71,47.11).
city('Great Falls','us','Montana',56075.0,-111.29,47.5).
city('Hamilton','us','Montana',4528.0,-114.16,46.25).
city('Havre','us','Montana',9379.0,-109.68,48.54).
city('Helena','us','Montana',27340.0,-112.02,46.6).
city('Helena Valley Southeast','us','Montana',8582.0,-111.92,46.62).
city('Helena Valley West Central','us','Montana',7151.0,-112.06,46.66).
city('Kalispell','us','Montana',18018.0,-114.32,48.2).
city('Laurel','us','Montana',6334.0,-108.77,45.67).
city('Lewistown','us','Montana',5918.0,-109.43,47.06).
city('Livingston','us','Montana',7155.0,-110.56,45.66).
city('Miles City','us','Montana',8184.0,-105.84,46.41).
city('Missoula','us','Montana',63164.0,-114.01,46.87).
city('Orchard Homes','us','Montana',4897.0,-114.07,46.86).
city('Polson','us','Montana',4832.0,-114.16,47.69).
city('Sidney','us','Montana',4373.0,-104.16,47.71).
city('Whitefish','us','Montana',6338.0,-114.34,48.42).
city('Beatrice','us','Nebraska',13198.0,-96.75,40.27).
city('Bellevue','us','Nebraska',48099.0,-95.92,41.16).
city('Columbus','us','Nebraska',20823.0,-97.36,41.43).
city('Fremont','us','Nebraska',25197.0,-96.49,41.44).
city('Grand Island','us','Nebraska',44766.0,-98.37,40.92).
city('Hastings','us','Nebraska',23001.0,-98.39,40.59).
city('Kearney','us','Nebraska',28758.0,-99.08,40.7).
city('La Vista','us','Nebraska',15695.0,-96.04,41.18).
city('Lexington','us','Nebraska',10169.0,-99.74,40.78).
city('Lincoln','us','Nebraska',242072.0,-96.69,40.82).
city('Norfolk','us','Nebraska',24094.0,-97.42,42.03).
city('North Platte','us','Nebraska',24172.0,-100.77,41.13).
city('Omaha','us','Nebraska',413487.0,-96.01,41.26).
city('Papillion','us','Nebraska',18755.0,-96.04,41.16).
city('Scottsbluff','us','Nebraska',14869.0,-103.66,41.87).
city('South Sioux City','us','Nebraska',12135.0,-96.41,42.47).
city('Boulder City','us','Nevada',15479.0,-114.84,35.97).
city('Carson City','us','Nevada',57341.0,-119.74,39.15).
city('Elko','us','Nevada',15822.0,-115.76,40.84).
city('Fallon','us','Nevada',8126.0,-118.78,39.47).
city('Fernley','us','Nevada',11974.0,-119.22,39.6).
city('Henderson','us','Nevada',239757.0,-115.0,36.03).
city('Las Vegas','us','Nevada',540111.0,-115.22,36.21).
city('Mesquite','us','Nevada',13414.0,114.06,36.86).
city('North Las Vegas','us','Nevada',165416.0,-115.14,36.27).
city('Pah','us','Nevada',40349.0,-115.99,36.2).
city('Paradise','us','Nevada',215120.0,-115.13,36.08).
city('Reno','us','Nevada',202142.0,-119.82,39.54).
city('Sparks','us','Nevada',84662.0,-119.74,39.54).
city('Spring Valley','us','Nevada',165015.0,-115.24,36.11).
city('Sun Valley','us','Nevada',24009.0,-119.78,39.6).
city('Sunrise Manor','us','Nevada',188608.0,-115.05,36.19).
city('West Wendover','us','Nevada',4953.0,-114.07,40.74).
city('Winchester','us','Nevada',30743.0,-115.13,36.14).
city('Winnemucca','us','Nevada',6329.0,-117.73,40.97).
city('Allenstown','us','New Hampshire',5115.0,-71.41,43.15).
city('Alton','us','New Hampshire',5068.0,-71.23,43.46).
city('Amherst','us','New Hampshire',11723.0,-71.63,42.86).
city('Atkinson','us','New Hampshire',6782.0,-71.15,42.84).
city('Auburn','us','New Hampshire',5089.0,-71.35,43.01).
city('Barnstead','us','New Hampshire',4572.0,-71.3,43.33).
city('Barrington','us','New Hampshire',8417.0,-71.05,43.22).
city('Bedford','us','New Hampshire',21188.0,-71.53,42.94).
city('Belmont','us','New Hampshire',7516.0,-71.48,43.44).
city('Berlin','us','New Hampshire',9953.0,-71.26,44.49).
city('Bow','us','New Hampshire',8381.0,-71.52,43.12).
city('Brookline','us','New Hampshire',4650.0,-71.66,42.73).
city('Candia','us','New Hampshire',4405.0,-71.28,43.08).
city('Charlestown','us','New Hampshire',7726.0,-72.42,43.24).
city('Chester','us','New Hampshire',5236.0,-71.26,42.96).
city('Claremont','us','New Hampshire',13562.0,-72.34,43.38).
city('Concord','us','New Hampshire',42605.0,-71.56,43.23).
city('Conway','us','New Hampshire',9257.0,-71.13,43.98).
city('Danville','us','New Hampshire',4537.0,-71.13,42.91).
city('Deerfield','us','New Hampshire',4315.0,-71.62,44.23).
city('Derry','us','New Hampshire',34539.0,-71.29,42.9).
city('Dover','us','New Hampshire',29061.0,-70.88,43.19).
city('Durham','us','New Hampshire',13435.0,-70.92,43.14).
city('Enfield','us','New Hampshire',4969.0,-72.15,43.64).
city('Epping','us','New Hampshire',6251.0,-71.07,43.03).
city('Epsom','us','New Hampshire',4590.0,-71.34,43.22).
city('Exeter','us','New Hampshire',14750.0,-70.95,42.98).
city('Farmington','us','New Hampshire',6444.0,-71.07,43.39).
city('Franklin','us','New Hampshire',8729.0,-71.66,43.45).
city('Gilford','us','New Hampshire',7849.0,-71.41,43.55).
city('Goffstown','us','New Hampshire',17602.0,-71.57,43.02).
city('Hampstead','us','New Hampshire',8650.0,-71.18,42.88).
city('Hampton','us','New Hampshire',15514.0,-70.83,42.94).
city('Hanover','us','New Hampshire',11222.0,-72.28,43.7).
city('Haverhill','us','New Hampshire',4532.0,-72.07,44.04).
city('Henniker','us','New Hampshire',4961.0,-71.82,43.18).
city('Hillsborough','us','New Hampshire',5176.0,-71.9,43.12).
city('Hollis','us','New Hampshire',7711.0,-71.59,42.74).
city('Hooksett','us','New Hampshire',13575.0,-71.46,43.09).
city('Hopkinton','us','New Hampshire',5676.0,-71.68,43.19).
city('Hudson','us','New Hampshire',24474.0,-71.43,42.76).
city('Jaffrey','us','New Hampshire',5784.0,-72.02,42.81).
city('Keene','us','New Hampshire',22891.0,-72.3,42.95).
city('Kingston','us','New Hampshire',6225.0,-71.05,42.94).
city('Laconia','us','New Hampshire',17533.0,-71.48,43.57).
city('Lebanon','us','New',12853.0,-72.25,43.64).
city('Lee','us','New Hampshire',4500.0,-71.0,43.12).
city('Litchfield','us','New Hampshire',8307.0,-71.48,42.85).
city('Littleton','us','New Hampshire',6296.0,-71.77,44.31).
city('Londonderry','us','New Hampshire',24474.0,-71.36,42.85).
city('Loudon','us','New Hampshire',5199.0,-71.47,43.29).
city('Manchester','us','New Hampshire',109877.0,-71.44,42.98).
city('Meredith','us','New Hampshire',6593.0,-71.5,43.66).
city('Merrimack','us','New Hampshire',26726.0,-71.52,42.85).
city('Milford','us','New Hampshire',14661.0,-71.66,42.83).
city('Milton','us','New Hampshire',4472.0,-71.0,43.41).
city('Moultonborough','us','New Hampshire',5034.0,-71.42,43.75).
city('Nashua','us','New Hampshire',87039.0,-71.49,42.75).
city('New Boston','us','New Hampshire',4934.0,-71.7,42.98).
city('New Ipswich','us','New Hampshire',5283.0,-71.86,42.75).
city('New London','us','New Hampshire',4369.0,-71.99,43.42).
city('Newmarket','us','New Hampshire',8931.0,-70.94,43.08).
city('Newport','us','New Hampshire',6593.0,-72.17,43.37).
city('Newton','us','New Hampshire',4513.0,-71.04,42.87).
city('North Hampton','us','New Hampshire',4721.0,-70.84,42.97).
city('Northfield','us','New Hampshire',5049.0,-71.57,43.4).
city('Ossipee','us','New Hampshire',4655.0,-71.12,43.68).
city('Pelham','us','New Hampshire',12676.0,-71.32,42.74).
city('Pembroke','us','New Hampshire',7461.0,-71.46,43.14).
city('Peterborough','us','New Hampshire',6021.0,-71.95,42.88).
city('Pittsfield','us','New Hampshire',4515.0,-71.33,43.31).
city('Plaistow','us','New Hampshire',7885.0,-71.1,42.84).
city('Plymouth','us','New Hampshire',6236.0,-71.69,43.76).
city('Portsmouth','us','New Hampshire',20954.0,-70.78,43.06).
city('Raymond','us','New Hampshire',10241.0,-71.18,43.04).
city('Rindge','us','New Hampshire',6049.0,-72.02,42.75).
city('Rochester','us','New Hampshire',30317.0,-70.98,43.3).
city('Rye','us','New Hampshire',5277.0,-70.77,43.01).
city('Salem','us','New Hampshire',29549.0,-71.22,42.79).
city('Sandown','us','New Hampshire',5827.0,-71.19,42.93).
city('Seabrook','us','New Hampshire',8679.0,-70.86,42.89).
city('Somersworth','us','New Hampshire',11897.0,-70.88,43.26).
city('Stratham','us','New Hampshire',6949.0,-70.9,43.05).
city('Swanzey','us','New Hampshire',7224.0,-72.28,42.87).
city('Wakefield','us','New Hampshire',4705.0,-71.03,43.57).
city('Weare','us','New Hampshire',8583.0,-71.72,43.07).
city('Windham','us','New Hampshire',13091.0,-71.31,42.8).
city('Wolfeboro','us','New Hampshire',6715.0,-71.21,43.59).
city('Asbury Park','us','New Jersey',16507.0,-74.01,40.22).
city('Atlantic City','us','New Jersey',40554.0,-74.45,39.38).
city('Audubon','us','New Jersey',9069.0,-75.07,39.89).
city('Avenel','us','New Jersey',18664.0,-74.27,40.58).
city('Bayonne','us','New Jersey',59878.0,-74.11,40.66).
city('Beachwood','us','New Jersey',10899.0,-74.2,39.93).
city('Belleville','us','New Jersey',36878.0,-74.16,40.79).
city('Bellmawr','us','New Jersey',11234.0,-75.09,39.87).
city('Bergenfield','us','New Jersey',26120.0,-74.0,40.92).
city('Berkeley Heights','us','New Jersey',14179.0,-74.43,40.68).
city('Bloomfield','us','New Jersey',49120.0,-74.19,40.81).
city('Bound Brook','us','New Jersey',10102.0,-74.54,40.57).
city('Brick Township','us','Ne',81376.0,-74.11,40.06).
city('Bridgeton','us','New Jersey',22945.0,-75.23,39.43).
city('Brigantine','us','New Jersey',12670.0,-74.38,39.41).
city('Burlington','us','New Jersey',9847.0,-74.86,40.07).
city('Camden','us','New Jersey',80412.0,-75.11,39.94).
city('Carteret','us','New Jersey',21944.0,-74.23,40.58).
city('Cedar Grove','us','New Jersey',12457.0,-74.23,40.86).
city('Cherry Hill','us','New Jersey',70475.0,-75.0,39.9).
city('Cinnaminson','us','New Jersey',14646.0,-74.99,40.0).
city('Clark','us','New Jersey',14628.0,-74.31,40.62).
city('Cliffside Park','us','New Jersey',22801.0,-73.99,40.82).
city('Clifton','us','New Jersey',80245.0,-74.16,40.86).
city('Collingswood','us','New Jersey',14125.0,-75.08,39.92).
city('Colonia','us','New Jersey',17669.0,-74.32,40.59).
city('Cranford','us','New Jersey',22627.0,-74.3,40.66).
city('Dover','us','New Jersey',18717.0,-74.56,40.89).
city('Dumont','us','New Jersey',17505.0,-73.99,40.95).
city('East Brunswick','us','New Jersey',48495.0,-74.42,40.43).
city('East Hanover','us','New Jersey',12194.0,-74.37,40.82).
city('East Orange','us','New Jersey',68390.0,-74.21,40.77).
city('Eatontown','us','New Jersey',14185.0,-74.06,40.29).
city('Edgewater','us','New Jersey',9875.0,-73.97,40.83).
city('Edison','us','New Jersey',102548.0,-74.37,40.53).
city('Elizabeth','us','New Jersey',123913.0,-74.19,40.67).
city('Elmwood Park','us','New Jersey',18973.0,-74.12,40.9).
city('Englewood','us','New Jersey',26012.0,-73.97,40.89).
city('Ewing','us','New Jersey',36559.0,-74.8,40.27).
city('Fair Lawn','us','New Jersey',31503.0,-74.12,40.94).
city('Fairview','us','New Jersey',13446.0,-74.0,40.82).
city('Florham Park','us','New Jersey',13534.0,-74.39,40.78).
city('Fords','us','New Jersey',15391.0,-74.31,40.54).
city('Fort Dix','us','New Jersey',6868.0,-74.61,40.0).
city('Fort Lee','us','New Jersey',37839.0,-73.97,40.85).
city('Franklin Lakes','us','New Jersey',11445.0,-74.21,41.01).
city('Freehold','us','New Jersey',11558.0,-74.28,40.26).
city('Garfield','us','New Jersey',29614.0,-74.11,40.88).
city('Glassboro','us','New Jersey',19166.0,-75.11,39.7).
city('Glen Rock','us','New Jersey',11459.0,-74.13,40.96).
city('Gloucester City','us','New Jersey',11377.0,-75.12,39.89).
city('Guttenberg','us','New Jersey',11086.0,-74.0,40.79).
city('Hackensack','us','New Jersey',43716.0,-74.05,40.89).
city('Hackettstown','us','New Jersey',8264.0,-74.83,40.85).
city('Haddonfield','us','New Jersey',11568.0,-75.03,39.89).
city('Hamilton','us','New Jersey',90599.0,-74.39,40.09).
city('Hammonton','us','New Jersey',13261.0,-74.77,39.65).
city('Hanover Township','us','New Jersey',13634.0,-74.43,40.82).
city('Harrison','us','New Jersey',14094.0,-74.15,40.74).
city('Hasbrouck Heights','us','New Jersey',11608.0,-74.07,40.86).
city('Hawthorne','us','New Jersey',18413.0,-74.16,40.96).
city('Highland Park','us','New Jersey',14275.0,-74.43,40.5).
city('Hillsdale','us','New Jersey',10075.0,-74.04,41.01).
city('Hillside','us','New Jersey',22155.0,-74.23,40.7).
city('Hoboken','us','New Jersey',39738.0,-74.03,40.74).
city('Holiday City-Berkeley','us','New Jersey',13739.0,-74.28,39.96).
city('Hopatcong','us','New Jersey',16267.0,-74.66,40.96).
city('Irvington','us','New Jersey',61323.0,-74.23,40.72).
city('Iselin','us','New Jersey',17019.0,-74.32,40.57).
city('Jersey City','us','New Jersey',237681.0,-74.06,40.71).
city('Keansburg','us','New Jersey',10631.0,-74.16,40.47).
city('Kearny','us','New Jersey',39234.0,-74.12,40.75).
city('Kinnelon','us','New Jersey',9536.0,-74.37,40.99).
city('Lakewood','us','New Jersey',42120.0,-74.21,40.09).
city('Leisure Village West-Pine Lake Park','us','New Jersey',11596.0,-74.27,40.0).
city('Lincoln Park','us','New Jersey',10845.0,-74.3,40.92).
city('Linden','us','New Jersey',39878.0,-74.24,40.63).
city('Lindenwold','us','New Jersey',17320.0,-74.99,39.82).
city('Little Falls','us','New Jersey',10688.0,-74.22,40.88).
city('Little Ferry','us','New Jersey',10790.0,-74.04,40.85).
city('Livingston','us','New Jersey',27853.0,-74.33,40.79).
city('Lodi','us','New Jersey',24278.0,-74.08,40.88).
city('Long Branch','us','New Jersey',31524.0,-73.99,40.3).
city('Lyndhurst','us','New Jersey',19996.0,-74.11,40.8).
city('Madison','us','New Jersey',15299.0,-74.42,40.76).
city('Manville','us','New Jersey',10357.0,-74.59,40.54).
city('Maple Shade','us','New Jersey',19077.0,-75.0,39.95).
city('Maplewood','us','New Jersey',25008.0,-74.27,40.73).
city('Marlton','us','New Jersey',10307.0,-74.93,39.9).
city('Maywood','us','New Jersey',9460.0,-74.06,40.91).
city('Mercerville-Hamilton Square','us','New Jersey',26290.0,-74.67,40.23).
city('Metuchen','us','New Jersey',13467.0,-74.36,40.54).
city('Middlesex','us','New Jersey',14084.0,-74.5,40.57).
city('Millburn','us','New Jersey',20386.0,-74.32,40.74).
city('Millville','us','New Jersey',27390.0,-75.05,39.39).
city('Montclair','us','New Jersey',39701.0,-74.21,40.82).
city('Moorestown-Lenola','us','New Jersey',14205.0,-74.97,39.96).
city('Morristown','us','New Jersey',18886.0,-74.48,40.8).
city('Mount Holly','us','New Jersey',10804.0,-74.79,40.0).
city('New Brunswick','us','New Jersey',50633.0,-74.45,40.49).
city('New Milford','us','New Jersey',16326.0,-74.02,40.93).
city('New Providence','us','New Jersey',11935.0,-74.4,40.7).
city('Newark','us','New Jersey',280123.0,-74.17,40.72).
city('North Arlington','us','New Jersey',15205.0,-74.13,40.79).
city('North Bergen','us','New Jersey',63484.0,-74.03,40.79).
city('North Brunswick Township','us','New Jersey',39027.0,-74.48,40.45).
city('North Plainfield','us','New Jersey',20991.0,-74.44,40.62).
city('Nutley','us','New Jersey',27572.0,-74.16,40.82).
city('Oakland','us','New Jersey',14318.0,-74.24,41.03).
city('Ocean City','us','New Jersey',15637.0,-74.6,39.27).
city('Old Bridge','us','New Jersey',23233.0,-74.33,40.39).
city('Orange','us','New Jersey',34457.0,-74.24,40.77).
city('Palisades Park','us','New Jersey',18513.0,-74.0,40.85).
city('Paramus','us','New Jersey',26947.0,-74.07,40.95).
city('Parsippany-Troy Hills Township','us','New Jersey',51864.0,-74.42,40.86).
city('Passaic','us','New Jersey',68845.0,-74.13,40.86).
city('Paterson','us','New Jersey',151205.0,-74.16,40.91).
city('Pennsauken','us','New Jersey',36332.0,-75.06,39.96).
city('Pennsville','us','New Jersey',11438.0,-75.51,39.66).
city('Pequannock Township','us','New Jersey',14453.0,-74.3,40.96).
city('Perth Amboy','us','New Jersey',49107.0,-74.27,40.52).
city('Phillipsburg','us','New Jersey',15091.0,-75.18,40.69).
city('Pine Hill','us','New Jersey',11306.0,-74.99,39.79).
city('Pitman','us','New Jersey',9257.0,-75.13,39.73).
city('Plainfield','us','New Jersey',47795.0,-74.42,40.62).
city('Pleasantville','us','New Jersey',19039.0,-74.52,39.39).
city('Point Pleasant','us','New Jersey',20156.0,-74.07,40.08).
city('Pompton Lakes','us','New Jersey',11405.0,-74.29,41.0).
city('Princeton','us','New Jersey',12945.0,-74.66,40.35).
city('Rahway','us','New Jersey',26713.0,-74.28,40.61).
city('Ramsey','us','New Jersey',14520.0,-74.15,41.06).
city('Red Bank','us','New Jersey',11730.0,-74.07,40.35).
city('Ridgefield','us','New Jersey',10932.0,-74.02,40.83).
city('Ridgefield Park','us','New Jersey',12704.0,-74.02,40.85).
city('Ridgewood','us','New Jersey',24738.0,-74.11,40.98).
city('Ringwood','us','New Jersey',12862.0,-74.27,41.11).
city('River Edge','us','New Jersey',10970.0,-74.04,40.93).
city('Roselle','us','New Jersey',21337.0,-74.26,40.65).
city('Roselle Park','us','New Jersey',13231.0,-74.27,40.67).
city('Rutherford','us','New Jersey',17952.0,-74.11,40.82).
city('Saddle Brook','us','New Jersey',13130.0,-74.1,40.9).
city('Sayreville','us','New Jersey',42890.0,-74.32,40.47).
city('Scotch Plains','us','New Jersey',23584.0,-74.37,40.63).
city('Secaucus','us','New Jersey',15534.0,-74.06,40.78).
city('Somers Point','us','New Jersey',11698.0,-74.61,39.32).
city('Somerset','us','New Jersey',23584.0,-74.49,40.5).
city('Somerville','us','New Jersey',12308.0,-74.61,40.57).
city('South Orange','us','New Jersey',17295.0,-74.26,40.75).
city('South Plainfield','us','New Jersey',23373.0,-74.42,40.58).
city('South River','us','New Jersey',16480.0,-74.38,40.45).
city('Springfield','us','New Jersey',14976.0,-74.33,40.7).
city('Succasunna-Kenvil','us','New Jersey',12998.0,-74.65,40.86).
city('Summit','us','New Jersey',21219.0,-74.37,40.71).
city('Teaneck','us','New Jersey',40078.0,-74.01,40.89).
city('Tenafly','us','New Jersey',14335.0,-73.96,40.92).
city('Tinton Falls','us','New Jersey',16549.0,-74.09,40.27).
city('Toms River','us','New Jersey',119088.0,-74.17,39.94).
city('Totowa','us','New Jersey',10078.0,-74.22,40.9).
city('Trenton','us','New Jersey',84833.0,-74.76,40.22).
city('Union','us','New Jersey',56771.0,-74.27,40.7).
city('Union City','us','New Jersey',66121.0,-74.03,40.77).
city('Ventnor City','us','New Jersey',12699.0,-74.48,39.34).
city('Verona','us','New Jersey',13545.0,-74.24,40.83).
city('Vineland','us','New Jersey',58122.0,-75.0,39.46).
city('Waldwick','us','New Jersey',9608.0,-74.13,41.01).
city('Wallington','us','New Jersey',11469.0,-74.11,40.85).
city('Wanaque','us','New Jersey',10512.0,-74.29,41.04).
city('Wayne','us','New Jersey',57915.0,-74.25,40.95).
city('Weehawken','us','New Jersey',14104.0,-74.02,40.77).
city('West Caldwell','us','New Jersey',11672.0,-74.3,40.85).
city('West Freehold','us','New Jersey',13219.0,-74.3,40.23).
city('West Milford','us','New Jersey',26968.0,-74.4,41.11).
city('West New York','us','New Jersey',46010.0,-73.98,40.77).
city('West Orange','us','New Jersey',48131.0,-74.26,40.79).
city('West Paterson','us','New Jersey',11380.0,-74.2,40.89).
city('Westfield','us','New Jersey',29940.0,-74.34,40.65).
city('Westwood','us','New Jersey',11002.0,-74.03,40.99).
city('Williamstown','us','New Jersey',12310.0,-74.98,39.69).
city('Willingboro','us','New Jersey',31668.0,-74.89,40.03).
city('Woodbridge','us','New Jersey',18794.0,-74.29,40.55).
city('Woodbury','us','New Jersey',10462.0,-75.15,39.84).
city('Wyckoff','us','New Jersey',17124.0,-74.17,41.0).
city('Alamogordo','us','New Mexico',36058.0,-105.96,32.88).
city('Albuquerque','us','New Mexico',487378.0,-106.62,35.12).
city('Artesia','us','New Mexico',10500.0,-104.43,32.85).
city('Aztec','us','New Mexico',7001.0,-108.01,36.83).
city('Belen','us','New Mexico',6893.0,-106.77,34.66).
city('Bernalillo','us','New Mexico',7159.0,-106.55,35.31).
city('Bloomfield','us','New Mexico',7469.0,-107.98,36.71).
city('Carlsbad','us','New Mexico',25302.0,-104.24,32.4).
city('Clovis','us','New Mexico',33163.0,-103.2,34.41).
city('Corrales','us','New Mexico',7678.0,-106.62,35.23).
city('Deming','us','New Mexico',14748.0,-107.75,32.26).
city('Espanola','us','New Mexico',9729.0,-106.06,36.0).
city('Farmington','us','New Mexico',43278.0,-108.19,36.75).
city('Gallup','us','New Mexico',19454.0,-108.74,35.52).
city('Grants','us','New Mexico',9067.0,-107.84,35.16).
city('Hobbs','us','New Mexico',28013.0,-103.16,32.73).
city('Las Cruces','us','New Mexico',80184.0,-106.76,32.34).
city('Las Vegas','us','New Mexico',14044.0,-105.22,35.6).
city('Los Alamos','us','New Mexico',11761.0,-106.28,35.89).
city('Los Lunas','us','New Mexico',12115.0,-106.74,34.81).
city('Los Ranchos de Albuquerque','us','New Mexico',5184.0,-106.65,35.16).
city('Lovington','us','New Mexico',9417.0,-103.35,32.95).
city('North Valley','us','New Mexico',11305.0,-106.62,35.17).
city('Portales','us','New Mexico',11035.0,-103.35,34.18).
city('Raton','us','New Mexico',7073.0,-104.44,36.9).
city('Rio Rancho','us','New Mexico',64090.0,-106.66,35.27).
city('Roswell','us','New Mexico',44069.0,-104.53,33.37).
city('Ruidoso','us','New Mexico',8757.0,-105.67,33.34).
city('Santa Fe','us','New Mexico',69205.0,-105.95,35.68).
city('Silver City','us','New Mexico',9745.0,-108.27,32.78).
city('Socorro','us','New Mexico',8668.0,-106.9,34.06).
city('South Valley','us','New Mexico',39508.0,-106.68,35.01).
city('Sunland Park','us','New Mexico',14251.0,-106.58,31.8).
city('Taos','us','New Mexico',5197.0,-105.58,36.39).
city('Truth or Consequences','us','New Mexico',7121.0,-107.25,33.13).
city('Tucumcari','us','New Mexico',5313.0,-103.73,35.17).
city('Albany','us','New York',93794.0,-73.8,42.67).
city('Amityville','us','New York',9566.0,-73.42,40.69).
city('Amsterdam','us','New York',17735.0,-74.19,42.94).
city('Arlington','us','New York',12640.0,-73.88,41.7).
city('Auburn','us','New York',27873.0,-76.57,42.93).
city('Babylon','us','New York',12839.0,-73.33,40.7).
city('Baldwin','us','New York',23622.0,-73.61,40.66).
city('Batavia','us','New York',15831.0,-78.18,43.0).
city('Bay Shore','us','New York',24969.0,-73.25,40.73).
city('Beacon','us','New York',18644.0,-73.97,41.5).
city('Bellmore','us','New York',16313.0,-73.53,40.66).
city('Bethpage','us','New York',16791.0,-73.49,40.75).
city('Binghamton','us','New York',45480.0,-75.91,42.1).
city('Bohemia','us','New York',9944.0,-73.12,40.77).
city('Brentwood','us','New York',58107.0,-73.25,40.78).
city('Brighton','us','New York',35844.0,-77.58,43.12).
city('Buffalo','us','New York',279557.0,-78.86,42.89).
city('Canandaigua','us','New York',11655.0,-77.28,42.89).
city('Centereach','us','New York',27338.0,-73.08,40.87).
city('Central Islip','us','New York',34907.0,-73.2,40.79).
city('Cheektowaga','us','New York',77387.0,-78.75,42.91).
city('Cohoes','us','New York',15183.0,-73.71,42.77).
city('Commack','us','New York',36195.0,-73.28,40.84).
city('Copiague','us','New York',22309.0,-73.39,40.67).
city('Coram','us','New York',37150.0,-73.0,40.88).
city('Corning','us','New York',10451.0,-77.06,42.15).
city('Cortland','us','New York',18017.0,-76.18,42.6).
city('Deer Park','us','New York',27853.0,-73.32,40.76).
city('Depew','us','New York',15892.0,-78.7,42.91).
city('Dix Hills','us','New York',25902.0,-73.34,40.8).
city('Dobbs Ferry','us','New York',11249.0,-73.87,41.01).
city('Dunkirk','us','New York',12451.0,-79.32,42.57).
city('East Islip','us','New York',13854.0,-73.19,40.73).
city('East Massapequa','us','New York',19418.0,-73.44,40.67).
city('East Meadow','us','New York',37427.0,-73.56,40.72).
city('East Northport','us','New York',20887.0,-73.32,40.88).
city('East Patchogue','us','New York',20961.0,-72.98,40.77).
city('East Rockaway','us','New York',10268.0,-73.67,40.64).
city('Eastchester','us','New York',18431.0,-73.81,40.96).
city('Elmira','us','New York',30026.0,-76.81,42.09).
city('Elmont','us','New York',34479.0,-73.71,40.7).
city('Elwood','us','New York',10830.0,-73.34,40.85).
city('Endicott','us','New York',12802.0,-76.06,42.1).
city('Endwell','us','New York',11219.0,-76.02,42.12).
city('Fairmount','us','New York',10086.0,-76.25,43.04).
city('Farmingville','us','New York',17142.0,-73.04,40.84).
city('Floral Park','us','New York',15702.0,-73.7,40.72).
city('Fort Drum','us','New York',12291.0,-75.77,44.05).
city('Franklin Square','us','New York',29658.0,-73.68,40.7).
city('Fredonia','us','New York',10440.0,-79.33,42.44).
city('Freeport','us','New York',43447.0,-73.58,40.65).
city('Fulton','us','New York',11513.0,-76.42,43.32).
city('Garden City','us','New York',21887.0,-73.64,40.73).
city('Gates-North Gates','us','New York',15086.0,-77.7,43.16).
city('Geneva','us','New York',13429.0,-76.98,42.87).
city('Glen Cove','us','New York',26717.0,-73.64,40.89).
city('Glens Falls','us','New York',14169.0,-73.65,43.31).
city('Gloversville','us','New York',15120.0,-74.35,43.05).
city('Great Neck','us','New York',9628.0,-73.73,40.8).
city('Greece','us','New York',14048.0,-77.7,43.21).
city('Greenville','us','New York',8198.0,-73.82,41.0).
city('Hamburg','us','New York',9656.0,-78.83,42.72).
city('Harrison','us','New York',25643.0,-73.72,41.02).
city('Hartsdale','us','New York',9868.0,-73.81,41.03).
city('Hauppauge','us','New York',20108.0,-73.21,40.82).
city('Haverstraw','us','New York',10114.0,-73.97,41.2).
city('Hempstead','us','New York',52837.0,-73.62,40.7).
city('Hicksville','us','New York',41453.0,-73.53,40.76).
city('Holbrook','us','New York',28407.0,-73.07,40.79).
city('Holtsville','us','New York',17914.0,-73.05,40.81).
city('Huntington','us','New York',18334.0,-73.41,40.88).
city('Huntington Station','us','New York',30484.0,-73.41,40.84).
city('Irondequoit','us','New York',51958.0,-77.57,43.21).
city('Islip','us','New York',21232.0,-73.22,40.73).
city('Ithaca','us','New York',31159.0,-76.5,42.44).
city('Jamestown','us','New York',30077.0,-79.24,42.1).
city('Jefferson Valley-Yorktown','us','New York',15149.0,-73.8,41.32).
city('Jericho','us','New York',12898.0,-73.54,40.79).
city('Johnson City','us','New York',15006.0,-75.96,42.12).
city('Kenmore','us','New York',15603.0,-78.87,42.96).
city('Kings Park','us','New York',15313.0,-73.25,40.89).
city('Kingston','us','New York',23174.0,-74.0,41.93).
city('Kiryas Joel','us','New York',19382.0,-74.17,41.34).
city('Lackawanna','us','New York',18293.0,-78.83,42.82).
city('Lake Grove','us','New York',10715.0,-73.12,40.86).
city('Lake Ronkonkoma','us','New York',19884.0,-73.11,40.83).
city('Lancaster','us','New York',11846.0,-78.67,42.9).
city('Levittown','us','New York',52548.0,-73.51,40.72).
city('Lindenhurst','us','New York',29081.0,-73.37,40.69).
city('Lockport','us','New York',21191.0,-78.7,43.17).
city('Long Beach','us','New York',35203.0,-73.67,40.59).
city('Lynbrook','us','New York',19626.0,-73.67,40.66).
city('Mamaroneck','us','New York',18153.0,-73.73,40.93).
city('Massapequa','us','New York',22776.0,-73.47,40.67).
city('Massapequa Park','us','New York',17313.0,-73.45,40.68).
city('Massena','us','New York',10892.0,-74.89,44.93).
city('Mastic','us','New York',16155.0,-72.84,40.8).
city('Mastic Beach','us','New York',12086.0,-72.84,40.76).
city('Medford','us','New York',22152.0,-7.0,40.82).
city('Melville','us','New York',15428.0,-73.41,40.78).
city('Merrick','us','New York',22457.0,-73.55,40.65).
city('Middletown','us','New York',26096.0,-74.42,41.45).
city('Mineola','us','New York',19006.0,-73.64,40.75).
city('Monsey','us','New York',14638.0,-74.07,41.12).
city('Mount Kisco','us','New York',10019.0,-73.73,41.2).
city('Mount Vernon','us','New York',68137.0,-73.83,40.91).
city('Nanuet','us','New York',17973.0,-74.02,41.1).
city('Nesconset','us','New York',12546.0,-73.15,40.85).
city('New Cassel','us','New York',14907.0,-73.57,40.76).
city('New City','us','New York',33942.0,-73.99,41.15).
city('New Hyde Park','us','New York',9477.0,-73.68,40.73).
city('New Rochelle','us','New York',72786.0,-73.78,40.92).
city('New York','us','New York',8107916.0,-73.94,40.67).
city('Newark','us','New York',9365.0,-77.09,43.04).
city('Newburgh','us','New York',28476.0,-74.02,41.5).
city('Niagara Falls','us','New York',53054.0,-79.02,43.09).
city('North Amityville','us','New York',17890.0,-73.41,40.7).
city('North Babylon','us','New York',17642.0,-73.33,40.73).
city('North Bay Shore','us','New York',16023.0,-73.26,40.76).
city('North Bellmore','us','New York',20097.0,-73.54,40.69).
city('North Lindenhurst','us','New York',12282.0,-73.39,40.71).
city('North Massapequa','us','New York',18903.0,-73.47,40.7).
city('North Merrick','us','New York',11628.0,-73.56,40.69).
city('North New Hyde Park','us','New York',14514.0,-73.69,40.75).
city('North Tonawanda','us','New York',31825.0,-78.87,43.04).
city('North Valley Stream','us','New York',16266.0,-73.71,40.68).
city('North Wantagh','us','New York',12005.0,-73.51,40.7).
city('Oceanside','us','New York',32622.0,-73.64,40.63).
city('Ogdensburg','us','New York',11455.0,-75.47,44.71).
city('Olean','us','New York',14823.0,-78.43,42.08).
city('Oneida','us','New York',10945.0,-75.66,43.08).
city('Oneonta','us','New York',12328.0,-75.07,42.45).
city('Ossining','us','New York',24376.0,-73.87,41.16).
city('Oswego','us','New York',18434.0,-76.5,43.46).
city('Patchogue','us','New York',12030.0,-73.02,40.76).
city('Pearl River','us','New York',15544.0,-74.0,41.06).
city('Peekskill','us','New York',24117.0,-73.92,41.29).
city('Plainview','us','New York',25174.0,-73.47,40.78).
city('Plattsburgh','us','New York',19229.0,-73.46,44.7).
city('Port Chester','us','New York',27990.0,-73.67,41.0).
city('Port Jervis','us','New York',9159.0,-74.69,41.38).
city('Port Washington','us','New York',15016.0,-73.68,40.83).
city('Potsdam','us','New York',9666.0,-74.99,44.67).
city('Poughkeepsie','us','New York',30345.0,-73.92,41.7).
city('Ridge','us','New York',14120.0,-72.88,40.91).
city('Rochester','us','New York',211354.0,-77.62,43.17).
city('Rockville Centre','us','New York',24143.0,-74.63,40.66).
city('Rome','us','New York',34074.0,-75.49,43.23).
city('Ronkonkoma','us','New York',19705.0,-73.12,40.8).
city('Roosevelt','us','New York',16129.0,-73.58,40.68).
city('Rotterdam','us','New York',20060.0,-73.95,42.78).
city('Rye','us','New York',15056.0,-73.68,40.95).
city('Rye Brook','us','New York',9620.0,-73.68,41.02).
city('Saint James','us','New York',13436.0,-73.15,40.88).
city('Salisbury','us','New York',12298.0,-73.56,40.75).
city('Saratoga Springs','us','New York',27989.0,-73.78,43.07).
city('Sayville','us','New York',16691.0,-73.09,40.75).
city('Scarsdale','us','New York',17920.0,-73.78,40.99).
city('Schenectady','us','New York',60280.0,-73.93,42.8).
city('Seaford','us','New York',15758.0,-73.49,40.67).
city('Selden','us','New York',22300.0,-73.05,40.87).
city('Setauket-East Setauket','us','New York',17006.0,-73.1,40.93).
city('Shirley','us','New York',26431.0,-72.87,40.8).
city('Sleepy Hollow','us','New York',9286.0,-73.86,41.09).
city('Smithtown','us','New York',27300.0,-73.21,40.86).
city('South Farmingdale','us','New York',14798.0,-73.45,40.72).
city('South Huntington','us','New York',9317.0,-73.39,40.82).
city('Spring Valley','us','New York',25469.0,-74.05,41.11).
city('Stony Brook','us','New York',13620.0,-73.13,40.91).
city('Stony Point','us','New York',12234.0,-74.0,41.23).
city('Suffern','us','New York',10972.0,-74.14,41.11).
city('Syosset','us','New York',18204.0,-73.5,40.82).
city('Syracuse','us','New York',141830.0,-76.14,43.04).
city('Tarrytown','us','New York',11460.0,-73.87,41.06).
city('Terryville','us','New York',10656.0,-73.05,40.91).
city('Tonawanda','us','New York',15401.0,-78.88,43.01).
city('Tonawanda CDP','us','New York',59653.0,-78.88,42.98).
city('Troy','us','New York',48232.0,-73.68,42.73).
city('Uniondale','us','New York',24201.0,-73.59,40.7).
city('Utica','us','New York',58590.0,-75.23,43.1).
city('Valley Stream','us','New York',35934.0,-73.71,40.66).
city('Wantagh','us','New York',19014.0,-73.51,40.67).
city('Watertown','us','New York',28055.0,-75.91,43.97).
city('Watervliet','us','New York',9967.0,-73.71,42.72).
city('West Babylon','us','New York',43606.0,-73.36,40.71).
city('West Haverstraw','us','New York',10356.0,-73.99,41.21).
city('West Hempstead','us','New York',19064.0,-73.65,40.7).
city('West Islip','us','New York',28911.0,-73.3,40.71).
city('West Seneca','us','New York',44712.0,-78.75,42.84).
city('Westbury','us','New York',14198.0,-73.59,40.76).
city('White Plains','us','New York',57260.0,-73.76,41.02).
city('Woodmere','us','New York',16740.0,-73.72,40.64).
city('Yonkers','us','New York',197818.0,-73.87,40.95).
city('Albemarle','us','North Carolina',15281.0,-80.19,35.36).
city('Apex','us','North Carolina',30873.0,-78.85,35.73).
city('Archdale','us','North Carolina',9332.0,-79.97,35.91).
city('Asheboro','us','North Carolina',23443.0,-79.81,35.72).
city('Asheville','us','North Carolina',68795.0,-82.55,35.57).
city('Boone','us','North Carolina',12921.0,-81.67,36.21).
city('Burlington','us','North Carolina',46921.0,-79.45,36.08).
city('Carrboro','us','North Carolina',16626.0,-79.08,35.92).
city('Cary','us','North Carolina',103945.0,-78.8,35.78).
city('Chapel Hill','us','North Carolina',47529.0,-79.04,35.93).
city('Charlotte','us','North Carolina',598351.0,-80.83,35.2).
city('Clayton','us','North Carolina',13177.0,-78.46,35.65).
city('Clemmons','us','North Carolina',16319.0,-80.39,36.03).
city('Concord','us','North Carolina',60592.0,-80.59,35.41).
city('Cornelius','us','North Carolina',21284.0,-80.88,35.48).
city('Dunn','us','North Carolina',10015.0,-78.61,35.31).
city('Durham','us','North Carolina',204734.0,-78.91,35.98).
city('Eden','us','North Carolina',15440.0,-79.74,36.51).
city('Elizabeth City','us','North Carolina',18015.0,-76.22,36.3).
city('Fayetteville','us','North Carolina',124775.0,-78.9,35.07).
city('Fort Bragg','us','North Carolina',28303.0,-79.0,35.14).
city('Fuquay-Varina','us','North Carolina',12127.0,-78.79,35.59).
city('Garner','us','North Carolina',21959.0,-78.63,35.69).
city('Gastonia','us','North Carolina',67869.0,-81.17,35.25).
city('Goldsboro','us','North Carolina',38243.0,-77.98,35.37).
city('Graham','us','North Carolina',13470.0,-79.39,36.06).
city('Greensboro','us','North Carolina',231769.0,-79.83,36.08).
city('Greenville','us','North Carolina',70757.0,-77.37,35.6).
city('Havelock','us','North Carolina',22044.0,-76.89,34.91).
city('Henderson','us','North Carolina',16134.0,-78.42,36.32).
city('Hendersonville','us','North Carolina',11678.0,-82.46,35.32).
city('Hickory','us','North Carolina',40334.0,-81.33,35.74).
city('High Point','us','North Carolina',94281.0,-80.0,35.98).
city('Holly Springs','us','North Carolina',14816.0,-78.82,35.65).
city('Hope Mills','us','North Carolina',12232.0,-78.96,34.97).
city('Huntersville','us','North Carolina',40342.0,-80.86,35.41).
city('Indian Trail','us','North Carolina',15226.0,-80.65,35.07).
city('Jacksonville','us','North Carolina',68015.0,-77.4,34.76).
city('Kannapolis','us','North Carolina',38748.0,-80.62,35.49).
city('Kernersville','us','North Carolina',21007.0,-80.08,36.12).
city('Kings Mountain','us','North Carolina',10638.0,-81.34,35.24).
city('Kinston','us','North Carolina',22475.0,-77.59,35.28).
city('Laurinburg','us','North Carolina',15268.0,-79.47,34.77).
city('Lenoir','us','North Carolina',17806.0,-81.53,35.91).
city('Lewisville','us','North Carolina',9577.0,-80.42,36.1).
city('Lexington','us','North Carolina',20784.0,-80.26,35.81).
city('Lincolnton','us','North Carolina',10279.0,-81.25,35.48).
city('Lumberton','us','North Carolina',21314.0,-79.01,34.63).
city('Matthews','us','North Carolina',23716.0,-80.71,35.12).
city('Mint Hill','us','North Carolina',15772.0,-80.66,35.18).
city('Monroe','us','North Carolina',29681.0,-80.54,34.99).
city('Mooresville','us','North Carolina',20223.0,-80.81,35.58).
city('Morganton','us','North Carolina',17191.0,-81.7,35.74).
city('Mount Holly','us','North Carolina',9512.0,-81.02,35.3).
city('New Bern','us','North Carolina',23623.0,-77.08,35.12).
city('Newton','us','North Carolina',12759.0,-81.22,35.67).
city('Pinehurst','us','North Carolina',11523.0,-79.46,35.2).
city('Piney Green','us','North Carolina',12932.0,-77.32,34.75).
city('Raleigh','us','North Carolina',338759.0,-78.66,35.82).
city('Reidsville','us','North Carolina',14768.0,-79.67,36.35).
city('Roanoke Rapids','us','North Carolina',16299.0,-77.65,36.45).
city('Rockingham','us','North Carolina',9053.0,-79.76,34.94).
city('Rocky Mount','us','North Carolina',55997.0,-77.81,35.96).
city('Salisbury','us','North Carolina',26693.0,-80.05,35.67).
city('Sanford','us','North Carolina',23473.0,-79.18,35.48).
city('Shelby','us','North Carolina',23235.0,-81.54,35.29).
city('Smithfield','us','North Carolina',11208.0,-78.35,35.51).
city('Southern Pines','us','North Carolina',11640.0,-79.4,35.18).
city('Statesville','us','North Carolina',24709.0,-80.89,35.79).
city('Tarboro','us','North Carolina',10601.0,-77.56,35.91).
city('Thomasville','us','North Carolina',30857.0,-80.08,35.89).
city('Wake Forest','us','North Carolina',18832.0,-78.52,35.97).
city('Washington','us','North Carolina',9644.0,-77.05,35.55).
city('Waynesville','us','North Carolina',9463.0,-82.99,35.48).
city('Wilmington','us','North Carolina',92424.0,-77.91,34.21).
city('Wilson','us','North Carolina',46748.0,-77.92,35.73).
city('Winston-Salem','us','North Carolina',193300.0,-80.26,36.1).
city('Bismarck','us','North Dakota',56706.0,-100.77,46.81).
city('Devils Lake','us','North Dakota',6811.0,-98.87,48.11).
city('Dickinson','us','North Dakota',15576.0,-102.78,46.8).
city('Fargo','us','North Dakota',92103.0,-96.82,46.88).
city('Grafton','us','North Dakota',4148.0,-97.4,48.42).
city('Grand Forks','us','North Dakota',48426.0,-97.07,47.92).
city('Jamestown','us','North Dakota',15081.0,-98.7,46.91).
city('Mandan','us','North Dakota',16809.0,-100.89,46.83).
city('Minot','us','North Dakota',34885.0,-101.3,48.23).
city('Valley City','us','North Dakota',6193.0,-98.01,46.92).
city('Wahpeton','us','North Dakota',8395.0,-96.61,46.27).
city('West Fargo','us','North Dakota',17590.0,-96.9,46.87).
city('Williston','us','North Dakota',11971.0,-103.63,48.16).
city('Akron','us','Ohio',208414.0,-81.52,41.08).
city('Alliance','us','Ohio',22676.0,-81.12,40.91).
city('Amherst','us','Ohio',11745.0,-82.23,41.4).
city('Ashland','us','Ohio',21827.0,-82.32,40.87).
city('Ashtabula','us','Ohio',20027.0,-80.8,41.88).
city('Athens','us','Ohio',23180.0,-82.1,39.32).
city('Aurora','us','Ohio',14549.0,-81.34,41.31).
city('Austintown','us','Ohio',30969.0,-80.74,41.09).
city('Avon','us','Ohio',15724.0,-81.99,41.45).
city('Avon Lake','us','Ohio',21004.0,-82.02,41.49).
city('Barberton','us','Ohio',27099.0,-81.61,41.01).
city('Bay Village','us','Ohio',15461.0,-81.93,41.49).
city('Beachwood','us','Ohio',11699.0,-81.5,41.48).
city('Beavercreek','us','Ohio',40788.0,-84.06,39.73).
city('Bedford','us','Ohio',13466.0,-81.54,41.39).
city('Bedford Heights','us','Ohio',11013.0,-81.51,41.41).
city('Bellefontaine','us','Ohio',12958.0,-83.76,40.36).
city('Berea','us','Ohio',18108.0,-81.86,41.37).
city('Bexley','us','Ohio',12244.0,-82.93,39.96).
city('Blacklick Estates','us','Ohio',9172.0,-82.86,39.9).
city('Blue Ash','us','Ohio',11744.0,-84.38,39.25).
city('Boardman','us','Ohio',36216.0,-80.67,41.03).
city('Bowling Green','us','Ohio',29215.0,-83.65,41.38).
city('Brecksville','us','Ohio',13427.0,-81.62,41.31).
city('Bridgetown North','us','Ohio',12844.0,-84.64,39.16).
city('Broadview Heights','us','Ohio',17374.0,-81.68,41.32).
city('Brook Park','us','Ohio',20232.0,-81.83,41.4).
city('Brooklyn','us','Ohio',11037.0,-81.75,41.43).
city('Brunswick','us','Ohio',34790.0,-81.82,41.25).
city('Bucyrus','us','Ohio',12768.0,-82.97,40.8).
city('Cambridge','us','Ohio',11699.0,-81.59,40.03).
city('Campbell','us','Ohio',8755.0,-80.59,41.08).
city('Canton','us','Ohio',78160.0,-81.37,40.81).
city('Celina','us','Ohio',10282.0,-84.57,40.55).
city('Centerville','us','Ohio',23222.0,-84.14,39.64).
city('Chillicothe','us','Ohio',22180.0,-82.99,39.34).
city('Cincinnati','us','Ohio',306382.0,-84.51,39.14).
city('Circleville','us','Ohio',13259.0,-82.94,39.6).
city('Clayton','us','Ohio',13133.0,-84.31,39.85).
city('Cleveland','us','Ohio',449514.0,-81.68,41.48).
city('Cleveland Heights','us','Ohio',47726.0,-81.56,41.51).
city('Columbus','us','Ohio',736836.0,-82.99,39.99).
city('Conneaut','us','Ohio',13064.0,-80.57,41.93).
city('Coshocton','us','Ohio',11687.0,-81.85,40.26).
city('Cuyahoga Falls','us','Ohio',51824.0,-81.52,41.17).
city('Dayton','us','Ohio',159134.0,-84.2,39.78).
city('Defiance','us','Ohio',15926.0,-84.36,41.28).
city('Delaware','us','Ohio',31457.0,-83.08,40.3).
city('Dover','us','Ohio',12450.0,-81.48,40.53).
city('Dublin','us','Ohio',35237.0,-83.13,40.12).
city('East Cleveland','us','Ohio',25513.0,-81.58,41.53).
city('East Liverpool','us','Ohio',12201.0,-80.57,40.63).
city('Eastlake','us','Ohio',19747.0,-81.43,41.66).
city('Elyria','us','Ohio',55873.0,-82.11,41.38).
city('Englewood','us','Ohio',12593.0,-84.31,39.86).
city('Euclid','us','Ohio',50123.0,-81.52,41.59).
city('Fairborn','us','Ohio',32586.0,-84.02,39.8).
city('Fairfield','us','Ohio',43121.0,-84.54,39.33).
city('Fairview Park','us','Ohio',16709.0,-81.85,41.44).
city('Findlay','us','Ohio',40354.0,-83.64,41.04).
city('Finneytown','us','Ohio',13545.0,-84.51,39.22).
city('Forest Park','us','Ohio',18106.0,-84.53,39.29).
city('Fort MacKinley','us','Ohio',3741.0,-84.26,39.81).
city('Fostoria','us','Ohio',13673.0,-83.41,41.16).
city('Franklin','us','Ohio',12596.0,-84.3,39.56).
city('Fremont','us','Ohio',17280.0,-83.11,41.35).
city('Gahanna','us','Ohio',33127.0,-82.88,40.03).
city('Galion','us','Ohio',11349.0,-82.79,40.73).
city('Garfield Heights','us','Ohio',29218.0,-81.6,41.42).
city('Girard','us','Ohio',10456.0,-80.7,41.15).
city('Green','us','Ohio',23894.0,-81.49,40.95).
city('Greenville','us','Ohio',13250.0,-84.62,40.1).
city('Grove City','us','Ohio',30035.0,-83.07,39.87).
city('Hamilton','us','Ohio',61445.0,-84.56,39.39).
city('Hilliard','us','Ohio',26893.0,-83.14,40.04).
city('Huber Heights','us','Ohio',38391.0,-84.11,39.86).
city('Hudson','us','Ohio',23368.0,-81.45,41.24).
city('Ironton','us','Ohio',11209.0,-82.68,38.53).
city('Kent','us','Ohio',28387.0,-81.36,41.15).
city('Kettering','us','Ohio',55880.0,-84.15,39.7).
city('Lakewood','us','Ohio',52756.0,-81.8,41.48).
city('Lancaster','us','Ohio',35883.0,-82.6,39.72).
city('Lebanon','us','Ohio',20345.0,-84.21,39.43).
city('Lima','us','Ohio',39906.0,-84.11,40.74).
city('Lincoln Village','us','Ohio',9173.0,-83.13,39.95).
city('Lorain','us','Ohio',67920.0,-82.18,41.44).
city('Louisville','us','Ohio',9235.0,-81.26,40.84).
city('Loveland','us','Ohio',10993.0,-84.27,39.27).
city('Lyndhurst','us','Ohio',14558.0,-81.49,41.52).
city('Macedonia','us','Ohio',10606.0,-81.5,41.32).
city('Mansfield','us','Ohio',50310.0,-82.53,40.76).
city('Maple Heights','us','Ohio',24961.0,-81.56,41.41).
city('Marietta','us','Ohio',13795.0,-81.45,39.42).
city('Marion','us','Ohio',37482.0,-83.13,40.58).
city('Marysville','us','Ohio',16396.0,-83.37,40.24).
city('Mason','us','Ohio',30988.0,-84.31,39.36).
city('Massillon','us','Ohio',31526.0,-81.52,40.79).
city('Maumee','us','Ohio',14441.0,-83.65,41.57).
city('Mayfield Heights','us','Ohio',18567.0,-81.45,41.52).
city('Medina','us','Ohio',27358.0,-81.87,41.14).
city('Mentor','us','Ohio',49726.0,-81.33,41.69).
city('Miamisburg','us','Ohio',20031.0,-84.27,39.64).
city('Middleburg Heights','us','Ohio',15681.0,-81.81,41.37).
city('Middletown','us','Ohio',52834.0,-84.37,39.51).
city('Montgomery','us','Ohio',9431.0,-84.35,39.25).
city('Mount Vernon','us','Ohio',16965.0,-82.48,40.39).
city('Napoleon','us','Ohio',9198.0,-84.13,41.39).
city('New Philadelphia','us','Ohio',17472.0,-81.44,40.49).
city('Newark','us','Ohio',46812.0,-82.42,40.07).
city('Niles','us','Ohio',19902.0,-80.75,41.19).
city('North Canton','us','Ohio',16886.0,-81.4,40.87).
city('North College Hill','us','Ohio',9361.0,-84.55,39.22).
city('North Olmsted','us','Ohio',32958.0,-81.92,41.41).
city('North Ridgeville','us','Ohio',25851.0,-82.02,41.39).
city('North Royalton','us','Ohio',28920.0,-81.75,41.31).
city('Northbrook','us','Ohio',10786.0,-84.58,39.25).
city('Norton','us','Ohio',11733.0,-81.65,41.03).
city('Norwalk','us','Ohio',16396.0,-82.61,41.24).
city('Norwood','us','Ohio',20288.0,-84.45,39.16).
city('Oregon','us','Ohio',19408.0,-83.42,41.67).
city('Oxford','us','Ohio',20875.0,-84.75,39.51).
city('Painesville','us','Ohio',17251.0,-81.25,41.73).
city('Parma','us','Ohio',82565.0,-81.73,41.38).
city('Parma Heights','us','Ohio',20886.0,-81.76,41.39).
city('Pataskala','us','Ohio',13888.0,-82.7,40.0).
city('Perrysburg','us','Ohio',16793.0,-83.62,41.55).
city('Pickerington','us','Ohio',15408.0,-82.76,39.89).
city('Piqua','us','Ohio',20731.0,-84.25,40.15).
city('Portage Lakes','us','Ohio',8899.0,-81.54,40.99).
city('Portsmouth','us','Ohio',19083.0,-82.95,38.76).
city('Ravenna','us','Ohio',11327.0,-81.24,41.16).
city('Reading','us','Ohio',10317.0,-84.43,39.22).
city('Reynoldsburg','us','Ohio',33237.0,-82.8,39.96).
city('Richmond Heights','us','Ohio',10753.0,-81.5,41.56).
city('Riverside','us','Ohio',22518.0,-84.23,39.77).
city('Rocky River','us','Ohio',19774.0,-81.85,41.47).
city('Salem','us','Ohio',11779.0,-80.85,40.9).
city('Sandusky','us','Ohio',26428.0,-82.71,41.46).
city('Seven Hills','us','Ohio',12046.0,-81.68,41.38).
city('Shaker Heights','us','Ohio',27755.0,-81.55,41.48).
city('Sharonville','us','Ohio',13250.0,-84.41,39.28).
city('Sheffield Lake','us','Ohio',9139.0,-82.1,41.49).
city('Shelby','us','Ohio',9482.0,-82.66,40.88).
city('Sidney','us','Ohio',20161.0,-84.16,40.29).
city('Solon','us','Ohio',22451.0,-81.44,41.39).
city('South Euclid','us','Ohio',22350.0,-81.53,41.52).
city('Springboro','us','Ohio',16947.0,-84.23,39.56).
city('Springdale','us','Ohio',9785.0,-84.48,39.29).
city('Springfield','us','Ohio',64325.0,-83.8,39.93).
city('Steubenville','us','Ohio',19312.0,-80.65,40.37).
city('Stow','us','Ohio',35.0,-81.44,41.18).
city('Streetsboro','us','Ohio',15787.0,-81.35,41.24).
city('Strongsville','us','Ohio',44863.0,-81.83,41.31).
city('Struthers','us','Ohio',11079.0,-80.59,41.05).
city('Sylvania','us','Ohio',19141.0,-83.71,41.71).
city('Tallmadge','us','Ohio',17537.0,-81.42,41.1).
city('Tiffin','us','Ohio',17013.0,-83.18,41.12).
city('Tipp City','us','Ohio',9380.0,-84.18,39.96).
city('Toledo','us','Ohio',306974.0,-83.58,41.66).
city('Trenton','us','Ohio',11000.0,-84.46,39.48).
city('Trotwood','us','Ohio',27197.0,-84.31,39.79).
city('Troy','us','Ohio',22336.0,-84.22,40.04).
city('Twinsburg','us','Ohio',17352.0,-81.45,41.32).
city('University Heights','us','Ohio',13374.0,-81.54,41.49).
city('Upper Arlington','us','Ohio',31474.0,-83.07,40.03).
city('Urbana','us','Ohio',11657.0,-83.75,40.11).
city('Van Wert','us','Ohio',10457.0,-84.58,40.86).
city('Vandalia','us','Ohio',14478.0,-84.19,39.88).
city('Vermilion','us','Ohio',11006.0,-82.31,41.41).
city('Wadsworth','us','Ohio',20187.0,-81.73,41.02).
city('Wapakoneta','us','Ohio',9524.0,-84.19,40.57).
city('Warren','us','Ohio',45475.0,-80.82,41.24).
city('Warrensville Heights','us','Ohio',14409.0,-81.52,41.44).
city('Washington','us','Ohio',13308.0,-83.43,39.54).
city('West Carrollton City','us','Ohio',13297.0,-84.25,39.67).
city('Westerville','us','Ohio',34226.0,-82.92,40.12).
city('Westlake','us','Ohio',31990.0,-81.93,41.45).
city('White Oak','us','Ohio',13557.0,-84.61,39.22).
city('Whitehall','us','Ohio',18173.0,-82.88,39.97).
city('Wickliffe','us','Ohio',13178.0,-81.47,41.61).
city('Willoughby','us','Ohio',22352.0,-81.41,41.65).
city('Willowick','us','Ohio',13850.0,-81.47,41.64).
city('Wilmington','us','Ohio',12312.0,-83.83,39.44).
city('Wooster','us','Ohio',25725.0,-81.93,40.82).
city('Worthington','us','Ohio',13199.0,-83.02,40.1).
city('Xenia','us','Ohio',23351.0,-83.94,39.69).
city('Youngstown','us','Ohio',77540.0,-80.65,41.1).
city('Zanesville','us','Ohio',24976.0,-82.01,39.95).
city('Ada','us','Oklahoma',16144.0,-96.66,34.78).
city('Altus','us','Oklahoma',20278.0,-99.31,34.65).
city('Ardmore','us','Oklahoma',23975.0,-97.12,34.19).
city('Bartlesville','us','Oklahoma',34610.0,-95.95,36.74).
city('Bethany','us','Oklahoma',19673.0,-97.64,35.51).
city('Bixby','us','Oklahoma',18949.0,-95.88,35.94).
city('Broken Arrow','us','Oklahoma',85535.0,-95.79,36.04).
city('Chickasha','us','Oklahoma',16772.0,-97.95,35.04).
city('Choctaw','us','Oklahoma',10530.0,-97.27,35.48).
city('Claremore','us','Oklahoma',17258.0,-9.0,36.31).
city('Clinton','us','Oklahoma',8153.0,-98.97,35.51).
city('Del City','us','Oklahoma',22135.0,-97.44,35.45).
city('Duncan','us','Oklahoma',21788.0,-97.97,34.52).
city('Durant','us','Oklahoma',15483.0,-96.39,33.98).
city('Edmond','us','Oklahoma',73915.0,-97.41,35.67).
city('El Reno','us','Oklahoma',15643.0,-97.97,35.54).
city('Elk City','us','Oklahoma',10522.0,-99.41,35.4).
city('Enid','us','Oklahoma',46138.0,-97.87,36.41).
city('Guthrie','us','Oklahoma',10277.0,-97.43,35.84).
city('Guymon','us','Oklahoma',10509.0,-101.48,36.69).
city('Jenks','us','Oklahoma',12921.0,-95.98,36.01).
city('Lawton','us','Oklahoma',91752.0,-98.42,34.6).
city('MacAlester','us','Oklahoma',18120.0,-95.76,34.92).
city('Miami','us','Oklahoma',13336.0,-94.88,36.89).
city('Midwest City','us','Oklahoma',54958.0,-97.37,35.46).
city('Moore','us','Oklahoma',47475.0,-97.47,35.33).
city('Muskogee','us','Oklahoma',38696.0,-95.35,35.75).
city('Mustang','us','Oklahoma',15612.0,-97.72,35.39).
city('Norman','us','Oklahoma',101742.0,-97.34,35.23).
city('Oklahoma City','us','Oklahoma',532950.0,-97.51,35.47).
city('Okmulgee','us','Oklahoma',12482.0,-95.96,35.63).
city('Owasso','us','Oklahoma',23923.0,-95.84,36.28).
city('Ponca City','us','Oklahoma',25273.0,-97.07,36.72).
city('Pryor Creek','us','Oklahoma',9155.0,-95.31,36.3).
city('Sand Springs','us','Oklahoma',17826.0,-96.13,36.14).
city('Sapulpa','us','Oklahoma',19825.0,-96.1,36.0).
city('Shawnee','us','Oklahoma',29721.0,-96.97,35.37).
city('Stillwater','us','Oklahoma',42757.0,-97.07,36.13).
city('Tahlequah','us','Oklahoma',16146.0,-94.97,35.91).
city('The Village','us','Oklahoma',9979.0,-97.56,35.57).
city('Tulsa','us','Oklahoma',382005.0,-95.92,36.13).
city('Warr Acres','us','Oklahoma',9594.0,-97.62,35.53).
city('Weatherford','us','Oklahoma',9262.0,-98.69,35.54).
city('Woodward','us','Oklahoma',11748.0,-99.4,36.42).
city('Yukon','us','Oklahoma',21196.0,-97.77,35.52).
city('Albany','us','Oregon',44757.0,-123.09,44.62).
city('Aloha','us','Oregon',44915.0,-122.87,45.49).
city('Altamont','us','Oregon',19716.0,-121.72,42.2).
city('Ashland','us','Oregon',20888.0,-122.7,42.19).
city('Astoria','us','Oregon',9535.0,-123.82,46.19).
city('Baker City','us','Oregon',9539.0,-117.83,44.77).
city('Beaverton','us','Oregon',82648.0,-122.82,45.48).
city('Bend','us','Oregon',65756.0,-121.31,44.07).
city('Canby','us','Oregon',15459.0,-122.69,45.27).
city('Cedar Hills','us','Oregon',8625.0,-122.81,45.5).
city('Cedar Mill','us','Oregon',13975.0,-122.8,45.54).
city('Central Point','us','Oregon',16270.0,-122.91,42.37).
city('City of The Dalles','us','Oregon',11676.0,-121.17,45.6).
city('Coos Bay','us','Oregon',15394.0,-124.23,43.38).
city('Cornelius','us','Oregon',10589.0,-123.06,45.52).
city('Corvallis','us','Oregon',50701.0,-123.28,44.57).
city('Dallas','us','Oregon',13852.0,-123.31,44.92).
city('Eugene','us','Oregon',145208.0,-123.11,44.05).
city('Fairview','us','Oregon',9445.0,-122.44,45.54).
city('Forest Grove','us','Oregon',19427.0,-123.1,45.52).
city('Four Corners','us','Oregon',14557.0,-122.97,44.93).
city('Gladstone','us','Oregon',12249.0,-122.59,45.39).
city('Grants Pass','us','Oregon',27191.0,-123.32,42.44).
city('Gresham','us','Oregon',98851.0,-122.44,45.5).
city('Hayesville','us','Oregon',20021.0,-122.97,44.98).
city('Hermiston','us','Oregon',14951.0,-119.28,45.83).
city('Hillsboro','us','Oregon',82320.0,-122.94,45.53).
city('Keizer','us','Oregon',35537.0,-123.02,45.0).
city('Klamath Falls','us','Oregon',19203.0,-121.77,42.22).
city('La Grande','us','Oregon',12288.0,-118.09,45.33).
city('Lake Oswego','us','Oregon',36597.0,-122.7,45.41).
city('Lebanon','us','Oregon',13487.0,-122.9,44.53).
city('MacMinnville','us','Oregon',29759.0,-123.19,45.21).
city('Medford','us','Oregon',69638.0,-122.85,42.34).
city('Milwaukie','us','Oregon',20759.0,-122.62,45.44).
city('Newberg','us','Oregon',20790.0,-122.96,45.31).
city('Newport','us','Oregon',9515.0,-124.05,44.62).
city('North Bend','us','Oregon',9620.0,-124.24,43.41).
city('Oak Grove','us','Oregon',12674.0,-122.64,45.41).
city('Oatfield','us','Oregon',15641.0,-122.6,45.41).
city('Ontario','us','Oregon',10969.0,-116.97,44.02).
city('Oregon City','us','Oregon',29984.0,-122.6,45.34).
city('Pendleton','us','Oregon',16539.0,-118.82,45.67).
city('Portland','us','Oregon',540513.0,-122.66,45.54).
city('Redmond','us','Oregon',18807.0,-121.17,44.26).
city('Roseburg','us','Oregon',20430.0,-123.36,43.22).
city('Saint Helens','us','Oregon',12082.0,-122.81,45.87).
city('Salem','us','Oregon',146922.0,-123.02,44.92).
city('Sherwood','us','Oregon',15157.0,-122.84,45.36).
city('Springfield','us','Oregon',56032.0,-122.98,44.05).
city('Tigard','us','Oregon',47068.0,-122.77,45.43).
city('Troutdale','us','Oregon',15205.0,-122.39,45.54).
city('Tualatin','us','Oregon',26476.0,-122.77,45.38).
city('West Linn','us','Oregon',26067.0,-122.64,45.37).
city('Wilsonville','us','Oregon',16134.0,-122.77,45.31).
city('Woodburn','us','Oregon',22866.0,-122.86,45.15).
city('Aliquippa','us','Pennsylvania',11074.0,-80.26,40.62).
city('Allentown','us','Pennsylvania',105519.0,-75.48,40.6).
city('Altoona','us','Pennsylvania',46962.0,-78.4,40.51).
city('Ardmore','us','Pennsylvania',12554.0,-75.29,40.0).
city('Back Mountain','us','Pennsylvania',26973.0,-75.97,41.32).
city('Baldwin','us','Pennsylvania',18991.0,-79.97,40.36).
city('Beaver Falls','us','Pennsylvania',9504.0,-80.32,40.76).
city('Berwick','us','Pennsylvania',10373.0,-76.25,41.06).
city('Bethel Park','us','Pennsylvania',32474.0,-80.04,40.32).
city('Bethlehem','us','Pennsylvania',73710.0,-75.37,40.63).
city('Bloomsburg','us','Pennsylvania',12943.0,-76.46,41.0).
city('Bradford','us','Pennsylvania',8611.0,-78.64,41.96).
city('Brentwood','us','Pennsylvania',9866.0,-79.98,40.37).
city('Bristol','us','Pennsylvania',9854.0,-74.85,40.1).
city('Broomall','us','Pennsylvania',11058.0,-75.35,39.97).
city('Butler','us','Pennsylvania',14569.0,-79.9,40.86).
city('Carbondale','us','Pennsylvania',9309.0,-75.51,41.57).
city('Carlisle','us','Pennsylvania',18204.0,-77.2,40.2).
city('Chambersburg','us','Pennsylvania',17884.0,-77.66,39.93).
city('Chester','us','Pennsylvania',36938.0,-75.37,39.85).
city('Coatesville','us','Pennsylvania',11430.0,-75.82,39.98).
city('Colonial Park','us','Pennsylvania',12972.0,-76.81,40.3).
city('Columbia','us','Pennsylvania',10121.0,-76.5,40.03).
city('Croydon','us','Pennsylvania',9967.0,-74.9,40.09).
city('Darby','us','Pennsylvania',10021.0,-75.26,39.92).
city('Darby Township','us','Pennsylvania',9018.0,-75.27,39.9).
city('Dormont','us','Pennsylvania',8716.0,-80.04,40.39).
city('Drexel Hill','us','Pennsylvania',29075.0,-75.3,39.95).
city('Dunmore','us','Pennsylvania',13563.0,-75.61,41.42).
city('East Norriton','us','Pennsylvania',13108.0,-75.34,40.15).
city('East Stroudsburg','us','Pennsylvania',10828.0,-75.18,41.0).
city('Easton','us','Pennsylvania',26192.0,-75.22,40.69).
city('Economy','us','Pennsylvania',9334.0,-80.19,40.64).
city('Elizabethtown','us','Pennsylvania',11907.0,-76.6,40.15).
city('Emmaus','us','Pennsylvania',11206.0,-75.5,40.54).
city('Ephrata','us','Pennsylvania',13182.0,-76.18,40.18).
city('Erie','us','Pennsylvania',99801.0,-80.09,42.13).
city('Franklin Park','us','Pennsylvania',11737.0,-80.1,40.59).
city('Fullerton','us','Pennsylvania',14781.0,-75.49,40.63).
city('Greensburg','us','Pennsylvania',15309.0,-79.54,40.31).
city('Hampton Township','us','Pennsylvania',18459.0,-79.95,40.59).
city('Hanover','us','Pennsylvania',15036.0,-76.98,39.81).
city('Harrisburg','us','Pennsylvania',47840.0,-76.88,40.28).
city('Harrison Township','us','Pennsylvania',10524.0,-79.72,40.64).
city('Hazleton','us','Pennsylvania',21961.0,-75.97,40.95).
city('Hermitage','us','Pennsylvania',16784.0,-80.44,41.23).
city('Hershey','us','Pennsylvania',13172.0,-76.65,40.28).
city('Horsham','us','Pennsylvania',14597.0,-75.14,40.18).
city('In','us','Pennsylvania',14357.0,-79.16,40.62).
city('Jeannette','us','Pennsylvania',10185.0,-79.61,40.33).
city('Jefferson Hills','us','Pennsylvania',9698.0,-79.93,40.29).
city('Johnstown','us','Pennsylvania',22357.0,-78.92,40.33).
city('King of Prussia','us','Pennsylvania',18489.0,-75.38,40.1).
city('Kingston','us','Pennsylvania',13067.0,-75.89,41.26).
city('Lancaster','us','Pennsylvania',54735.0,-76.3,40.04).
city('Lansdale','us','Pennsylvania',16094.0,-75.28,40.24).
city('Lansdowne','us','Pennsylvania',10736.0,-75.28,39.94).
city('Lebanon','us','Pennsylvania',23581.0,-76.42,40.34).
city('Levittown','us','Pennsylvania',53117.0,-74.85,40.15).
city('Lock Haven','us','Pennsylvania',8777.0,-77.45,41.13).
city('Lower Burrell','us','Pennsylvania',12476.0,-79.71,40.58).
city('Lower Merion','us','Pennsylvania',60505.0,-75.28,40.03).
city('MacCandless Township','us','Pennsylvania',29024.0,-80.03,40.58).
city('MacKeesport','us','Pennsylvania',22820.0,-79.84,40.34).
city('Meadville','us','Pennsylvania',13225.0,-80.15,41.65).
city('Middletown','us','Pennsylvania',9003.0,-75.33,40.65).
city('Morrisville','us','Pennsylvania',9854.0,-80.17,39.9).
city('Mount Lebanon','us','Pennsylvania',32730.0,-80.05,40.37).
city('Munhall','us','Pennsylvania',11561.0,-79.9,40.39).
city('Municipality of Monroeville','us','Pennsylvania',28251.0,-79.76,40.43).
city('Municipality of Murrysville','us','Pennsylvania',19438.0,-79.66,40.44).
city('Nanticoke','us','Pennsylvania',10265.0,-76.0,41.2).
city('Nether Providence Township','us','Pennsylvania',13512.0,-75.37,39.9).
city('New Castle','us','Pennsylvania',24652.0,-80.35,41.0).
city('New Kensington','us','Pennsylvania',14028.0,-79.75,40.57).
city('Norristown','us','Pennsylvania',30735.0,-75.34,40.12).
city('North Versailles','us','Pennsylvania',10571.0,-79.81,40.38).
city('Northampton','us','Pennsylvania',9760.0,-75.49,40.68).
city('Oil City','us','Pennsylvania',10891.0,-79.7,41.43).
city('Penn Hills','us','Pennsylvania',44610.0,-79.83,40.48).
city('Philadelphia','us','Pennsylvania',1453268.0,-75.13,40.01).
city('Phoenixville','us','Pennsylvania',14660.0,-75.52,40.14).
city('Pittsburgh','us','Pennsylvania',319494.0,-79.98,40.44).
city('Plum','us','Pennsylvania',26550.0,-79.75,40.5).
city('Pottstown','us','Pennsylvania',21720.0,-75.64,40.25).
city('Pottsville','us','Pennsylvania',14631.0,-76.21,40.68).
city('Progress','us','Pennsylvania',9607.0,-76.84,40.29).
city('Radnor Township','us','Pennsylvania',31833.0,-75.37,40.03).
city('Reading','us','Pennsylvania',79799.0,-75.93,40.34).
city('Robinson Township','us','Pennsylvania',12991.0,-80.13,40.46).
city('Ross Township','us','Pennsylvania',31999.0,-80.02,40.53).
city('Saint Marys','us','Pennsylvania',14026.0,-78.56,41.43).
city('Scott Township','us','Pennsylvania',17302.0,-80.08,40.39).
city('Scranton','us','Pennsylvania',73206.0,-75.67,41.4).
city('Shaler Township','us','Pennsylvania',29286.0,-79.96,40.52).
city('Sharon','us','Pennsylvania',15415.0,-80.5,41.23).
city('South Park Township','us','Pennsylvania',14308.0,-79.99,40.3).
city('Springfield','us','Pennsylvania',23363.0,-75.34,39.93).
city('State College','us','Pennsylvania',41835.0,-77.86,40.79).
city('Sunbury','us','Pennsylvania',10084.0,-76.79,40.86).
city('Swissvale','us','Pennsylvania',9069.0,-79.89,40.42).
city('Uniontown','us','Pennsylvania',11878.0,-79.72,39.9).
city('Upper Providence Township','us','Pennsylvania',10856.0,-75.4,39.94).
city('Upper Saint Clair','us','Pennsylvania',20147.0,-80.08,40.34).
city('Warren','us','Pennsylvania',9569.0,-79.14,41.84).
city('Washington','us','Pennsylvania',14637.0,-80.25,40.17).
city('Waynesboro','us','Pennsylvania',9651.0,-77.58,39.75).
city('West Chester','us','Pennsylvania',17545.0,-75.61,39.96).
city('West Mifflin','us','Pennsylvania',21454.0,-79.91,40.36).
city('West Norriton','us','Pennsylvania',14702.0,-75.38,40.13).
city('Whitehall','us','Pennsylvania',13851.0,-79.99,40.36).
city('Wilkes-Barre','us','Penns',40736.0,-75.88,41.25).
city('Wilkinsburg','us','Pennsylvania',18036.0,-79.87,40.44).
city('Williamsport','us','Pennsylvania',29377.0,-77.04,41.24).
city('Willow Grove','us','Pennsylvania',16129.0,-75.12,40.15).
city('Woodlyn','us','Pennsylvania',9944.0,-75.34,39.88).
city('Yeadon','us','Pennsylvania',11469.0,-75.25,39.93).
city('York','us','Pennsylvania',39587.0,-76.73,39.96).
city('Barrington','us','Rhode Island',16669.0,-71.32,41.74).
city('Bristol','us','Rhode Island',22795.0,-71.27,41.68).
city('Burrillville','us','Rhode Island',16886.0,-71.77,42.0).
city('Central Falls','us','Rhode Island',19509.0,-71.39,41.89).
city('Charlestown','us','Rhode Island',8421.0,-71.64,41.38).
city('Coventry','us','Rhode Island',35525.0,-71.66,41.69).
city('Cranston','us','Rhode Island',82926.0,-71.48,41.77).
city('Cumberland','us','Rhode Island',34843.0,-71.42,41.96).
city('East Greenwich','us','Rhode Island',13682.0,-71.46,41.66).
city('East Providence','us','Rhode Island',50453.0,-71.36,41.8).
city('Exeter','us','Rhode Island',6426.0,-71.54,41.58).
city('Foster','us','Rhode Island',4598.0,-71.76,41.85).
city('Glocester','us','Rhode Island',10836.0,-71.64,41.9).
city('Greenville','us','Rhode Island',8964.0,-71.56,41.88).
city('Hopkinton','us','Rhode Island',8261.0,-71.78,41.46).
city('Jamestown','us','Rhode Island',5755.0,-71.39,41.5).
city('Johnston','us','Rhode Island',29864.0,-71.52,41.83).
city('Kingston','us','Rhode Island',5113.0,-71.52,41.47).
city('Lincoln','us','Rhode Island',22791.0,-71.45,41.92).
city('Middletown','us','Rhode Island',17303.0,-71.29,41.52).
city('Narragansett','us','Rhode Island',17236.0,-71.47,41.43).
city('Newport','us','Rhode Island',25818.0,-71.32,41.48).
city('Newport East','us','Rhode Island',11888.0,-71.28,41.51).
city('North Providence','us','Rhode Island',33835.0,-71.46,41.86).
city('North Smithfield','us','Rhode Island',11212.0,-71.55,41.97).
city('Pascoag','us','Rhode Island',4716.0,-71.7,41.95).
city('Pawtucket','us','Rhode Island',74965.0,-71.37,41.87).
city('Portsmouth','us','Rhode Island',17756.0,-71.26,41.61).
city('Providence','us','Rhode Island',177595.0,-71.42,41.82).
city('Richmond','us','Rhode Island',7952.0,-71.67,41.0).
city('Scituate','us','Rhode Island',11171.0,-71.59,41.82).
city('Smithfield','us','Rhode Island',21872.0,-71.56,41.93).
city('South Kingstown','us','Rhode Island',29891.0,-71.55,41.42).
city('Tiverton','us','Rhode Island',19432.0,-71.2,41.65).
city('Valley Falls','us','Rhode Island',12048.0,-71.39,41.92).
city('Wakefield-Peacedale','us','Rhode Island',9368.0,-71.5,41.45).
city('Warren','us','Rhode Island',11280.0,-71.29,41.73).
city('Warwick','us','Rhode Island',88071.0,-71.42,41.7).
city('West Greenwich','us','Rhode Island',5821.0,-71.75,41.64).
city('West Warwick','us','Rhode Island',30146.0,-71.52,41.7).
city('Westerly','us','Rhode Island',26048.0,-71.8,41.33).
city('Woonsocket','us','Rhode Island',45839.0,-71.5,42.0).
city('Aiken','us','South Carolina',27237.0,-81.73,33.54).
city('Anderson','us','South Carolina',25393.0,-82.65,34.52).
city('Beaufort','us','South Carolina',12256.0,-80.69,32.43).
city('Bennettsville','us','South Carolina',9253.0,-79.69,34.63).
city('Berea','us','South Carolina',14331.0,-82.47,34.88).
city('Cayce','us','South Carolina',12450.0,-81.06,33.96).
city('Charles','us','South Carolina',104782.0,-79.99,32.79).
city('Clemson','us','South Carolina',11901.0,-82.81,34.68).
city('Clinton','us','South Carolina',9368.0,-81.88,34.47).
city('Columbia','us','South Carolina',117722.0,-80.89,34.04).
city('Conway','us','South Carolina',13340.0,-79.06,33.84).
city('Dentsville','us','South Carolina',13476.0,-80.96,34.08).
city('Easley','us','South Carolina',18767.0,-82.59,34.82).
city('Florence','us','South Carolina',30517.0,-79.78,34.18).
city('Forest Acres','us','South Carolina',10236.0,-80.97,34.04).
city('Gaffney','us','South Carolina',12791.0,-81.66,35.07).
city('Gantt','us','South Carolina',13870.0,-82.4,34.79).
city('Georgetown','us','South Carolina',8927.0,-79.3,33.36).
city('Goose Creek','us','South Carolina',31399.0,-80.0,32.99).
city('Greenville','us','South Carolina',55559.0,-82.37,34.84).
city('Greenwood','us','South Carolina',22316.0,-82.15,34.19).
city('Greer','us','South Carolina',20703.0,-82.23,34.94).
city('Hanahan','us','South Carolina',13100.0,-80.01,32.93).
city('Hilton Head Island','us','South Carolina',34457.0,-80.75,32.2).
city('Irmo','us','South Carolina',11286.0,-81.19,34.09).
city('Ladson','us','South Carolina',13019.0,-80.11,33.01).
city('Lancaster','us','South Carolina',8349.0,-80.77,34.72).
city('Laurens','us','South Carolina',9737.0,-82.03,34.5).
city('Lexington','us','South Carolina',13991.0,-81.23,33.98).
city('Mauldin','us','South Carolina',19513.0,-82.3,34.79).
city('Mount Pleasant','us','South Carolina',59105.0,-79.86,32.82).
city('Myrtle Beach','us','South Carolina',25310.0,-78.89,33.7).
city('Newberry','us','South Carolina',10526.0,-81.61,34.28).
city('North Augusta','us','South Carolina',19030.0,-81.96,33.52).
city('North Charleston','us','South Carolina',82838.0,-80.04,32.91).
city('North Myrtle Beach','us','South Carolina',13385.0,-78.68,33.82).
city('Orangeburg','us','South Carolina',12913.0,-80.87,33.49).
city('Parker','us','South Carolina',10521.0,-82.45,34.85).
city('Rock Hill','us','South Carolina',59766.0,-81.03,34.94).
city('Saint Andrews','us','South Carolina',21151.0,-81.1,34.05).
city('Seven Oaks','us','South Carolina',15629.0,-81.15,34.05).
city('Simpsonville','us','South Carolina',14988.0,-82.26,34.73).
city('Socastee','us','South Carolina',16431.0,-79.01,33.69).
city('Spartanburg','us','South Carolina',37992.0,-81.93,34.94).
city('Summerville','us','South Carolina',34958.0,-80.18,33.0).
city('Sumter','us','South Carolina',40079.0,-80.39,33.94).
city('Taylors','us','South Carolina',20184.0,-82.31,34.92).
city('Union','us','South Carolina',8175.0,-81.62,34.72).
city('Wade Hampton','us','South Carolina',20484.0,-82.33,34.88).
city('West Columbia','us','South Carolina',12861.0,-81.08,33.99).
city('Aberdeen','us','South Dakota',23667.0,-98.48,45.47).
city('Belle Fourche','us','South',4663.0,-103.85,44.66).
city('Brandon','us','South Dakota',7155.0,-96.58,43.59).
city('Brookings','us','South Dakota',18216.0,-96.79,44.31).
city('Huron','us','South Dakota',11026.0,-98.22,44.36).
city('Madison','us','South Dakota',6035.0,-97.11,44.01).
city('Mitchell','us','South Dakota',14741.0,-98.03,43.73).
city('Pierre','us','South Dakota',13879.0,-100.32,44.37).
city('Rapid City','us','South Dakota',61888.0,-103.23,44.08).
city('Rapid Valley','us','South Dakota',7494.0,-103.13,44.07).
city('Sioux Falls','us','South Dakota',14.0,-96.73,43.54).
city('Spearfish','us','South Dakota',9173.0,-103.85,44.49).
city('Sturgis','us','South Dakota',6362.0,-103.51,44.41).
city('Vermillion','us','South Dakota',10009.0,-96.93,42.78).
city('Watertown','us','South Dakota',20185.0,-97.17,44.91).
city('Yankton','us','South Dakota',13410.0,-97.39,42.89).
city('Alcoa','us','Tennessee',8354.0,-83.99,35.79).
city('Athens','us','Tennessee',13900.0,-84.6,35.45).
city('Atoka','us','Tennessee',5277.0,-89.78,35.44).
city('Bartlett','us','Tennessee',43264.0,-89.84,35.22).
city('Bloomingdale','us','Tennessee',9822.0,-82.51,36.58).
city('Brentwood','us','Tennessee',31279.0,-86.79,36.0).
city('Bristol','us','Tennessee',25110.0,-82.2,36.57).
city('Brownsville','us','Tennessee',10735.0,-89.26,35.59).
city('Chattanooga','us','Tennessee',154024.0,-85.26,35.07).
city('Clarksville','us','Tennessee',111694.0,-87.35,36.56).
city('Cleveland','us','Tennessee',37443.0,-84.87,35.18).
city('Clinton','us','Tennessee',9281.0,-84.13,36.1).
city('Collierville','us','Tennessee',37854.0,-89.68,35.06).
city('Columbia','us','Tennessee',33641.0,-87.05,35.62).
city('Cookeville','us','Tennessee',28668.0,-85.51,36.16).
city('Covington','us','Tennessee',9632.0,-89.65,35.56).
city('Crossville','us','Tennessee',10166.0,-85.04,35.95).
city('Dickson','us','Tennessee',13234.0,-87.38,36.08).
city('Dyersburg','us','Tennessee',17329.0,-89.38,36.04).
city('East Brainerd','us','Tennessee',15114.0,-85.11,35.01).
city('East Ridge','us','Tennessee',19588.0,-85.23,35.0).
city('Elizabethton','us','Tennessee',14958.0,-82.23,36.34).
city('Farragut','us','Tennessee',19312.0,-84.18,35.87).
city('Franklin','us','Tennessee',49706.0,-86.84,35.93).
city('Gallatin','us','Tennessee',26200.0,-86.45,36.38).
city('Germantown','us','Tennessee',37361.0,-89.79,35.09).
city('Goodlettsville','us','Tennessee',14516.0,-86.7,36.33).
city('Greeneville','us','Tennessee',15207.0,-82.82,36.17).
city('Hendersonville','us','Tennessee',44598.0,-86.6,36.29).
city('Humboldt','us','Tennessee',9205.0,-88.91,35.82).
city('Jackson','us','Tennessee',62080.0,-88.83,35.63).
city('Johnson City','us','Tennessee',586.0,-82.37,36.33).
city('Kingsport','us','Tennessee',43952.0,-82.56,36.53).
city('Knoxville','us','Tennessee',172474.0,-83.95,35.97).
city('La Vergne','us','Tennessee',26412.0,-86.57,36.0).
city('Lawrenceburg','us','Tennessee',10943.0,-87.34,35.25).
city('Lebanon','us','Tennessee',22370.0,-86.32,36.21).
city('Lenoir City','us','Tennessee',7548.0,-84.27,35.8).
city('Lewisburg','us','Tennessee',10693.0,-86.79,35.45).
city('MacMinnville','us','Tennessee',13078.0,-85.78,35.69).
city('Manchester','us','Tennessee',9218.0,-86.09,35.47).
city('Martin','us','Tennessee',10209.0,-88.85,36.34).
city('Maryville','us','Tennessee',26719.0,-83.97,35.75).
city('Memphis','us','Tennessee',641608.0,-90.01,35.11).
city('Middle Valley','us','Tennessee',11373.0,-85.19,35.19).
city('Millington','us','Tennessee',10021.0,-89.89,35.33).
city('Morristown','us','Tennessee',25204.0,-83.3,36.21).
city('Mount Juliet','us','Tennessee',18586.0,-86.51,36.2).
city('Murfreesboro','us','Tennessee',84700.0,-86.39,35.85).
city('Nashville-Davidson','us','Tennessee',530852.0,-86.78,36.17).
city('Oak Ridge','us','Tennessee',27414.0,-84.3,35.96).
city('Paris','us','Tennessee',9587.0,-88.31,36.3).
city('Portland','us','Tennessee',10638.0,-86.52,36.58).
city('Red Bank','us','Tennessee',11753.0,-85.29,35.11).
city('Sevierville','us','Tennessee',15655.0,-83.58,35.89).
city('Shelbyville','us','Tennessee',18317.0,-86.45,35.49).
city('Smyrna','us','Tennessee',32963.0,-86.52,35.98).
city('Soddy-Daisy','us','Tennessee',12219.0,-85.18,35.26).
city('Spring Hill','us','Tennessee',15788.0,-86.91,35.75).
city('Springfield','us','Tennessee',15509.0,-86.88,36.5).
city('Tullahoma','us','Tennessee',18692.0,-86.22,35.37).
city('Union City','us','Tennessee',10732.0,-89.05,36.42).
city('Abilene','us','Texas',114247.0,-99.74,32.45).
city('Addison','us','Texas',13628.0,-96.84,32.96).
city('Alamo','us','Texas',16319.0,-98.12,26.19).
city('Aldine','us','Texas',15596.0,-95.38,29.91).
city('Alice','us','Texas',19589.0,-98.07,27.76).
city('Allen','us','Texas',75868.0,-96.67,33.11).
city('Alvin','us','Texas',22103.0,-95.25,29.43).
city('Amarillo','us','Texas',181766.0,-101.82,35.2).
city('Anderson Mill','us','Texas',8744.0,-97.81,30.45).
city('Andrews','us','Texas',9384.0,-102.55,32.32).
city('Angleton','us','Texas',18856.0,-95.43,29.17).
city('Aransas Pass','us','Texas',9121.0,-97.15,27.9).
city('Arlington','us','Texas',367535.0,-97.13,32.69).
city('Atascocita','us','Texas',35102.0,-95.18,30.03).
city('Athens','us','Texas',12387.0,-95.86,32.2).
city('Austin','us','Texas',678368.0,-97.75,30.31).
city('Azle','us','Texas',10504.0,-97.53,32.9).
city('Balch Springs','us','Texas',19401.0,-96.62,32.72).
city('Bay City','us','Texas',18663.0,-95.96,28.98).
city('Baytown','us','Texas',67341.0,-94.97,29.75).
city('Beaumont','us','Texas',111485.0,-94.14,30.09).
city('Bedford','us','Texas',49185.0,-97.13,32.85).
city('Beeville','us','Texas',13004.0,-97.75,28.41).
city('Bellaire','us','Texas',17436.0,-95.46,29.7).
city('Bellmead','us','Texas',9801.0,-97.11,31.6).
city('Belton','us','Texas',15177.0,-97.46,31.07).
city('Benbrook','us','Texas',21590.0,-97.46,32.68).
city('Big Spring','us','Texas',24122.0,-101.48,32.24).
city('Bonham','us','Texas',10782.0,-96.18,33.58).
city('Borger','us','Texas',13408.0,-101.4,35.66).
city('Brenham','us','Texas',14609.0,-96.4,30.16).
city('Bridge City','us','Texas',8693.0,-93.84,30.03).
city('Brownfield','us','Texas',8958.0,-102.27,33.18).
city('Brownsville','us','Texas',168015.0,-97.48,25.93).
city('Brownwood','us','Texas',19534.0,-98.98,31.72).
city('Bry','us','Texas',69621.0,-96.37,30.67).
city('Burkburnett','us','Texas',10629.0,-98.56,34.08).
city('Burleson','us','Texas',28534.0,-97.33,32.53).
city('Canyon','us','Texas',13036.0,-101.92,34.98).
city('Canyon Lake','us','Texas',21649.0,-98.26,29.87).
city('Carrollton','us','Texas',120792.0,-96.9,32.99).
city('Cedar Hill','us','Texas',44049.0,-96.96,32.58).
city('Cedar Park','us','Texas',51695.0,-97.83,30.51).
city('Channelview','us','Texas',31924.0,-95.12,29.79).
city('Cleburne','us','Texas',28981.0,-97.41,32.35).
city('Cloverleaf','us','Texas',26557.0,-95.17,29.79).
city('Clute','us','Texas',10800.0,-95.4,29.02).
city('College Station','us','Texas',78533.0,-96.31,30.6).
city('Colleyville','us','Texas',22325.0,-97.15,32.89).
city('Commerce','us','Texas',9735.0,-95.9,33.24).
city('Conroe','us','Texas',41643.0,-95.47,30.32).
city('Converse','us','Texas',12155.0,-98.31,29.51).
city('Coppell','us','Texas',39574.0,-96.99,32.96).
city('Copperas Cove','us','Texas',30546.0,-97.9,31.12).
city('Corinth','us','Texas',19892.0,-97.07,33.14).
city('Corpus Christi','us','Texas',280382.0,-97.29,27.71).
city('Corsicana','us','Texas',26037.0,-96.46,32.08).
city('Crowley','us','Texas',10034.0,-97.36,32.58).
city('Dallas','us','Texas',1211704.0,-96.77,32.79).
city('DeSoto','us','Texas',45541.0,-96.86,32.6).
city('Deer Park','us','Texas',28772.0,-95.12,29.69).
city('Del Rio','us','Texas',36068.0,-100.9,29.38).
city('Denison','us','Texas',23680.0,-96.56,33.76).
city('Denton','us','Texas',100975.0,-97.13,33.21).
city('Dickinson','us','Texas',18348.0,-95.07,29.45).
city('Donna','us','Texas',15879.0,-98.05,26.17).
city('Dumas','us','Texas',13629.0,-101.96,35.86).
city('Duncanville','us','Texas',34991.0,-96.91,32.65).
city('Eagle Pass','us','Texas',26090.0,-100.49,28.71).
city('Edinburg','us','Texas',60509.0,-98.16,26.3).
city('El Campo','us','Texas',10760.0,-96.28,29.2).
city('El Paso','us','Texas',597181.0,-106.44,31.85).
city('Ennis','us','Texas',19518.0,-96.63,32.34).
city('Euless','us','Texas',53221.0,-97.08,32.85).
city('Farmers Branch','us','Texas',26468.0,-96.88,32.93).
city('Flower Mound','us','Texas',66618.0,-97.09,33.03).
city('Forest Hill','us','Texas',13406.0,-97.27,32.66).
city('Fort Bliss','us','Texas',8666.0,-106.42,31.81).
city('Fort Hood','us','Texas',32952.0,-97.77,31.13).
city('Fort Worth','us','Texas',618119.0,-97.34,32.75).
city('Fredericksburg','us','Texas',10927.0,-98.87,30.27).
city('Freeport','us','Texas',12632.0,-95.36,28.95).
city('Friendswood','us','Texas',34622.0,-95.2,29.51).
city('Frisco','us','Texas',71025.0,-96.81,33.14).
city('Gainesville','us','Texas',16301.0,-97.15,33.64).
city('Galena Park','us','Texas',10252.0,-95.23,29.74).
city('Galveston','us','Texas',56420.0,-94.81,29.3).
city('Garland','us','Texas',217219.0,-96.63,32.91).
city('Gatesville','us','Texas',15489.0,-97.73,31.44).
city('Georgetown','us','Texas',38895.0,-97.69,30.65).
city('Glenn Heights','us','Texas',8569.0,-96.85,32.55).
city('Graham','us','Texas',8636.0,-98.58,33.1).
city('Grand Prairie','us','Texas',141122.0,-97.02,32.69).
city('Grapevine','us','Texas',49666.0,-97.07,32.93).
city('Greenville','us','Texas',25382.0,-96.1,33.12).
city('Groves','us','Texas',15119.0,-93.92,29.95).
city('Haltom City','us','Texas',41556.0,-97.27,32.82).
city('Harker Heights','us','Texas',19049.0,-97.65,31.06).
city('Harlingen','us','Texas',63159.0,-97.69,26.2).
city('Henderson','us','Texas',10921.0,-94.8,32.16).
city('Hereford','us','Texas',14372.0,-102.4,34.82).
city('Hewitt','us','Texas',12981.0,-97.19,31.45).
city('Hidalgo','us','Texas',10343.0,-98.25,26.1).
city('Highland Park','us','Texas',8704.0,-96.8,32.83).
city('Highland Village','us','Texas',15365.0,-97.06,33.09).
city('Hillsboro','us','Texas',8936.0,-97.12,32.01).
city('Hondo','us','Texas',8410.0,-99.15,29.35).
city('Houston','us','Texas',2027712.0,-95.39,29.77).
city('Humble','us','Texas',14723.0,-95.26,29.99).
city('Huntsville','us','Texas',35590.0,-95.55,30.71).
city('Hurst','us','Texas',37749.0,-97.18,32.84).
city('Ingleside','us','Texas',9630.0,-97.2,27.87).
city('Irving','us','Texas',193825.0,-96.97,32.86).
city('Jacinto City','us','Texas',10121.0,-95.24,29.77).
city('Jacksonville','us','Texas',13943.0,-95.26,31.97).
city('Jollyville','us','Texas',16148.0,-97.75,30.45).
city('Katy','us','Texas',13371.0,-95.82,29.8).
city('Keller','us','Texas',37487.0,-97.23,32.93).
city('Kerrville','us','Texas',21894.0,-99.14,30.04).
city('Kilgore','us','Texas',11509.0,-94.87,32.39).
city('Kil','us','Texas',103009.0,-97.72,31.1).
city('Kingsville','us','Texas',25264.0,-97.86,27.51).
city('Kirby','us','Texas',8725.0,-98.39,29.46).
city('Kyle','us','Texas',18035.0,-97.88,29.99).
city('La Marque','us','Texas',13864.0,-94.99,29.37).
city('La Porte','us','Texas',33740.0,-95.04,29.67).
city('Lackland Air Force Base','us','Texas',6850.0,-98.63,29.38).
city('Lake Jackson','us','Texas',27127.0,-95.45,29.04).
city('Lakeway','us','Texas',8235.0,-97.98,30.37).
city('Lamesa','us','Texas',9157.0,-101.96,32.73).
city('Lancaster','us','Texas',29201.0,-96.78,32.6).
city('Laredo','us','Texas',210769.0,-99.49,27.53).
city('League City','us','Texas',61894.0,-95.11,29.49).
city('Leander','us','Texas',19321.0,-97.86,30.56).
city('Leon Valley','us','Texas',9402.0,-98.61,29.5).
city('Levelland','us','Texas',12865.0,-102.36,33.58).
city('Lewisville','us','Texas',93907.0,-96.98,33.04).
city('Liberty','us','Texas',8323.0,-94.8,30.06).
city('Little Elm','us','Texas',19991.0,-96.93,33.16).
city('Live Oak','us','Texas',10193.0,-98.34,29.55).
city('Lockhart','us','Texas',13854.0,-97.68,29.87).
city('Longview','us','Texas',75920.0,-94.76,32.52).
city('Lubbock','us','Texas',211387.0,-101.88,33.58).
city('Lufkin','us','Texas',33667.0,-94.73,31.33).
city('Lumberton','us','Texas',9486.0,-94.2,30.26).
city('MacAllen','us','Texas',122578.0,-98.24,26.22).
city('MacKinney','us','Texas',97651.0,-96.65,33.2).
city('Mansfield','us','Texas',36613.0,-97.12,32.57).
city('Marshall','us','Texas',23882.0,-94.35,32.54).
city('Mercedes','us','Texas',14227.0,-97.92,26.15).
city('Mesquite','us','Texas',131337.0,-96.6,32.77).
city('Midland','us','Texas',97782.0,-102.1,32.03).
city('Midlothian','us','Texas',13676.0,-96.99,32.48).
city('Mineral Wells','us','Texas',16993.0,-98.08,32.82).
city('Mission','us','Texas',61486.0,-98.32,26.21).
city('Mission Bend','us','Texas',34143.0,-95.66,29.69).
city('Missouri City','us','Texas',69715.0,-95.54,29.57).
city('Mount Pleasant','us','Texas',14403.0,-94.98,33.0).
city('Nacogdoches','us','Texas',30691.0,-94.65,31.61).
city('Nederland','us','Texas',16679.0,-94.0,29.97).
city('New Braunfels','us','Texas',45840.0,-98.12,29.7).
city('North Richland Hills','us','Texas',62821.0,-97.22,32.86).
city('Odessa','us','Texas',91256.0,-102.35,31.87).
city('Orange','us','Texas',17767.0,-93.76,30.1).
city('Pampa','us','Texas',16257.0,-100.96,35.55).
city('Paris','us','Texas',27022.0,-95.55,33.67).
city('Pasadena','us','Texas',144696.0,-95.15,29.66).
city('Pearland','us','Texas',55233.0,-95.28,29.56).
city('Pecan Grove','us','Texas',16050.0,-95.73,29.63).
city('Pecos','us','Texas',8372.0,-103.51,31.4).
city('Pflugerville','us','Texas',29541.0,-97.62,30.44).
city('Pharr','us','Texas',60687.0,-98.19,26.18).
city('Plainview','us','Texas',21723.0,-101.72,34.19).
city('Plano','us','Texas',253372.0,-96.75,33.05).
city('Pleasanton','us','Texas',9507.0,-98.48,28.97).
city('Port Arthur','us','Texas',56945.0,-93.93,29.9).
city('Port Lavaca','us','Texas',11743.0,-96.62,28.61).
city('Port Neches','us','Texas',13101.0,-93.94,29.97).
city('Portland','us','Texas',15772.0,-97.33,27.88).
city('Raymondville','us','Texas',9331.0,-97.78,26.48).
city('Richardson','us','Texas',104791.0,-96.71,32.97).
city('Richland Hills','us','Texas',8173.0,-97.23,32.81).
city('Richmond','us','Texas',14136.0,-95.77,29.58).
city('Rio Grande City','us','Texas',13690.0,-98.83,26.38).
city('Robinson','us','Texas',8741.0,-97.12,31.47).
city('Robstown','us','Texas',12590.0,-97.66,27.8).
city('Rockport','us','Texas',8972.0,-97.05,28.03).
city('Rockwall','us','Texas',29930.0,-96.46,32.92).
city('Roma','us','Texas',10734.0,-99.0,26.4).
city('Rosenberg','us','Texas',29753.0,-95.79,29.55).
city('Round Rock','us','Texas',88653.0,-97.67,30.52).
city('Rowlett','us','Texas',54785.0,-96.55,32.91).
city('Sachse','us','Texas',18239.0,-96.59,32.98).
city('Saginaw','us','Texas',18317.0,-97.37,32.87).
city('San Angelo','us','Texas',88256.0,-100.45,31.45).
city('San Antonio','us','Texas',1256810.0,-98.51,29.46).
city('San Benito','us','Texas',24506.0,-97.64,26.14).
city('San Juan','us','Texas',30647.0,-98.15,26.19).
city('San Marcos','us','Texas',46736.0,-97.93,29.88).
city('Santa Fe','us','Texas',10716.0,-95.1,29.38).
city('Schertz','us','Texas',28417.0,-98.26,29.55).
city('Seabrook','us','Texas',12019.0,-95.02,29.57).
city('Seagoville','us','Texas',11007.0,-96.55,32.66).
city('Seguin','us','Texas',24000.0,-97.97,29.58).
city('Sherman','us','Texas',37108.0,-96.61,33.62).
city('Snyder','us','Texas',10600.0,-100.92,32.71).
city('Socorro','us','Texas',28637.0,-106.27,31.64).
city('South Houston','us','Texas',16041.0,-95.23,29.66).
city('Southlake','us','Texas',25755.0,-97.15,32.95).
city('Spring','us','Texas',38129.0,-95.38,30.06).
city('Stafford','us','Texas',19625.0,-95.56,29.62).
city('Stephenville','us','Texas',15637.0,-98.22,32.22).
city('Sugar Land','us','Texas',75777.0,-95.62,29.62).
city('Sulphur Springs','us','Texas',15029.0,-95.61,33.14).
city('Sweetwater','us','Texas',10688.0,-100.4,32.47).
city('Taylor','us','Texas',14551.0,-97.41,30.57).
city('Temple','us','Texas',55703.0,-97.36,31.1).
city('Terrell','us','Texas',17150.0,-96.29,32.73).
city('Texarkana','us','Texas',35315.0,-94.07,33.44).
city('Texas City','us','Texas',43879.0,-94.96,29.41).
city('The Colony','us','Texas',41769.0,-96.89,33.09).
city('The Woodlands','us','Texas',75527.0,-95.49,30.16).
city('Tomball','us','Texas',10080.0,-95.62,30.1).
city('Tyler','us','Texas',90878.0,-95.3,32.33).
city('Universal City','us','Texas',15983.0,-98.31,29.55).
city('University Park','us','Texas',23785.0,-96.79,32.85).
city('Uvalde','us','Texas',17904.0,-99.78,29.22).
city('Vernon','us','Texas',10541.0,-99.3,34.15).
city('Victoria','us','Texas',62044.0,-96.98,28.82).
city('Vidor','us','Texas',11213.0,-94.0,30.13).
city('Waco','us','Texas',118967.0,-97.18,31.57).
city('Watauga','us','Texas',24333.0,-97.25,32.87).
city('Waxahachie','us','Texas',25612.0,-96.85,32.41).
city('Weatherford','us','Texas',23051.0,-97.77,32.76).
city('Webster','us','Texas',9038.0,-95.12,29.54).
city('Weslaco','us','Texas',32732.0,-97.98,26.16).
city('West Odessa','us','Texas',18455.0,-102.5,31.84).
city('West University Place','us','Texas',15107.0,-95.43,29.72).
city('Wharton','us','Texas',9310.0,-96.1,29.32).
city('White Settlement','us','Texas',16174.0,-97.46,32.75).
city('Wichita Falls','us','Texas',101212.0,-98.52,33.9).
city('Woodway','us','Texas',8771.0,-97.23,31.5).
city('Wylie','us','Texas',28505.0,-96.51,33.04).
city('American Fork','us','Utah',23582.0,-111.79,40.38).
city('Bountiful','us','Utah',41581.0,-111.87,40.88).
city('Brigham City','us','Utah',17261.0,-112.01,41.51).
city('Canyon Rim','us','Utah',10062.0,-111.82,40.71).
city('Cedar City','us','Utah',23005.0,-113.07,37.69).
city('Centerville','us','Utah',14879.0,-111.89,40.93).
city('Clearfield','us','Utah',28424.0,-112.02,41.1).
city('Clinton','us','Utah',17295.0,-112.06,41.14).
city('Cottonwood Heights','us','Utah',28021.0,-111.81,40.61).
city('Cottonwood West','us','Utah',18749.0,-111.85,40.65).
city('Draper','us','Utah',35186.0,-111.86,40.5).
city('East Millcreek','us','Utah',20816.0,-111.82,40.69).
city('Farmington','us','Utah',14328.0,-111.89,40.99).
city('Heber','us','Utah',9198.0,-111.41,40.51).
city('Highland','us','Utah',10066.0,-111.79,40.42).
city('Holladay','us','Utah',29737.0,-111.82,40.66).
city('Hurricane','us','Utah',10275.0,-113.33,37.17).
city('Kaysville','us','Utah',22211.0,-111.94,41.03).
city('Kearns','us','Utah',35345.0,-112.01,40.65).
city('Layton','us','Utah',62308.0,-111.95,41.08).
city('Lehi','us','Utah',26401.0,-111.85,40.4).
city('Lindon','us','Utah',8870.0,-111.72,40.34).
city('Logan','us','Utah',44838.0,-111.84,41.74).
city('Magna','us','Utah',24755.0,-112.09,40.7).
city('Midvale','us','Utah',27264.0,-111.9,40.61).
city('Millcreek','us','Utah',30696.0,-111.87,40.69).
city('Murray','us','Utah',54991.0,-111.89,40.65).
city('North Ogden','us','Utah',16717.0,-111.96,41.31).
city('North Salt Lake','us','Utah',9667.0,-111.91,40.85).
city('Ogden','us','Utah',78324.0,-111.97,41.23).
city('Orem','us','Utah',93060.0,-111.7,40.3).
city('Payson','us','Utah',15912.0,-111.73,40.03).
city('Pleasant Grove','us','Utah',24449.0,-111.73,40.37).
city('Price','us','Utah',8069.0,-110.81,39.6).
city('Provo','us','Utah',105764.0,-111.64,40.25).
city('Riverton','us','Utah',31855.0,-111.95,40.52).
city('Roy','us','Utah',36265.0,-112.04,41.17).
city('Saint George','us','Utah',61338.0,-113.58,37.08).
city('Salt Lake City','us','Utah',178026.0,-111.93,40.78).
city('Sandy','us','Utah',89575.0,-111.85,40.57).
city('South Jordan','us','Utah',37141.0,-111.97,40.56).
city('South Ogden','us','Utah',15524.0,-111.96,41.17).
city('South Salt Lake','us','Utah',21598.0,-111.9,40.71).
city('Spanish Fork','us','Utah',24613.0,-111.64,40.11).
city('Springville','us','Utah',22867.0,-111.61,40.16).
city('Syracuse','us','Utah',18206.0,-112.06,41.08).
city('Taylorsville','us','Utah',58284.0,-111.94,40.66).
city('Tooele','us','Utah',29851.0,-112.3,40.54).
city('Washington','us','Utah',12316.0,-113.5,37.12).
city('Washington Terrace','us','Utah',8349.0,-111.98,41.17).
city('West Jordan','us','Utah',101031.0,-111.99,40.6).
city('West Valley City','us','Utah',113112.0,-112.01,40.69).
city('Barre','us','Vermont',9040.0,-72.51,44.2).
city('Bennington','us','Vermont',18272.0,-73.19,42.87).
city('Brattleboro','us','Vermont',13373.0,-72.57,42.86).
city('Burlington','us','Vermont',38601.0,-73.23,44.49).
city('Colchester','us','Vermont',17245.0,-73.21,44.56).
city('Derby','us','Vermont',4957.0,-72.13,44.96).
city('Essex','us','Vermont',19064.0,-73.11,44.49).
city('Georgia','us','Vermont',4421.0,-73.97,44.72).
city('Hartford','us','Vermont',10834.0,-72.39,43.66).
city('Hinesburg','us','Vermont',4441.0,-73.11,44.33).
city('Jericho','us','Vermont',7286.0,-72.99,44.5).
city('Lyndon','us','Vermont',5496.0,-72.01,44.54).
city('Manchester','us','Vermont',216.0,-73.07,43.16).
city('Middlebury','us','Vermont',8862.0,-73.16,44.01).
city('Milton','us','Vermont',480.0,-73.15,44.64).
city('Montpelier','us','Vermont',7828.0,-72.59,44.26).
city('Morristown','us','Vermont',5653.0,-72.63,44.54).
city('Newport','us','Vermont',5167.0,-72.2,44.94).
city('Northfield','us','Vermont',1857.0,-72.66,44.15).
city('Randolph','us','Vermont',5141.0,-72.67,43.93).
city('Rockingham','us','Vermont',5198.0,-72.49,43.19).
city('Rutland','us','Vermont',17043.0,-72.98,43.61).
city('Saint Albans','us','Vermont',7450.0,-73.08,44.81).
city('Saint Johnsbury','us','Vermont',7762.0,-72.01,44.43).
city('Shelburne','us','Vermont',7004.0,-73.23,44.38).
city('South Burlington','us','Vermont',17185.0,-73.22,44.45).
city('Springfield','us','Vermont',11446.0,-72.48,43.29).
city('Stowe','us','Vermont',4846.0,-72.72,44.44).
city('Swanton','us','Vermont',1231.0,-73.12,44.92).
city('Waterbury','us','Vermont',719.0,-72.75,44.34).
city('Williston','us','Vermont',8314.0,-73.08,44.44).
city('Winooski','us','Vermont',6249.0,-73.19,44.5).
city('Alexandria','us','Virginia',127273.0,-77.09,38.82).
city('Annandale','us','Virginia',57512.0,-77.21,38.83).
city('Arlington','us','Virginia',185360.0,-77.1,38.88).
city('Baileys Crossroads','us','Virginia',25345.0,-77.13,38.84).
city('Blacksburg','us','Virginia',40183.0,-80.43,37.23).
city('Bon Air','us','Virginia',16268.0,-77.57,37.52).
city('Bristol','us','Virginia',17226.0,-82.17,36.61).
city('Burke','us','Virginia',58265.0,-77.27,38.78).
city('Cave Spring','us','Virginia',25602.0,-80.01,37.22).
city('Centreville','us','Virginia',65225.0,-77.44,38.85).
city('Chantilly','us','Virginia',48492.0,-77.41,38.88).
city('Charlottesville','us','Virginia',34703.0,-78.49,38.04).
city('Chesapeake','us','Virginia',219124.0,-76.31,36.68).
city('Chester','us','Virginia',19621.0,-77.44,37.35).
city('Christiansburg','us','Virginia',18223.0,-80.4,37.14).
city('Colonial Heights','us','Virginia',17626.0,-77.4,37.26).
city('Culpeper','us','Virginia',11009.0,-78.0,38.47).
city('Dale City','us','Virginia',61211.0,-77.34,38.65).
city('Danville','us','Virginia',45894.0,-79.41,36.58).
city('East Highland Park','us','Virginia',12917.0,-77.38,37.57).
city('Fairfax','us','Virginia',22162.0,-77.3,38.85).
city('Falls Church','us','Virginia',10340.0,-77.17,38.89).
city('Fort Hunt','us','Virginia',13011.0,-77.06,38.73).
city('Franconia','us','Virginia',40213.0,-77.15,38.76).
city('Fredericksburg','us','Virginia',20562.0,-77.49,38.3).
city('Front Royal','us','Virginia',14616.0,-78.18,38.92).
city('Glen Allen','us','Virginia',14820.0,-77.48,37.66).
city('Groveton','us','Virginia',22136.0,-77.1,38.76).
city('Hampton','us','Virginia',147993.0,-76.29,37.05).
city('Harrisonburg','us','Virginia',41725.0,-78.87,38.44).
city('Herndon','us','Virginia',21499.0,-77.39,38.97).
city('Highland Springs','us','Virginia',15942.0,-77.33,37.55).
city('Hollins','us','Virginia',14942.0,-79.95,37.34).
city('Hopewell','us','Virginia',22260.0,-77.3,37.29).
city('Hybla Valley','us','Virginia',17491.0,-77.08,38.75).
city('Idylwood','us','Virginia',16805.0,-77.21,38.89).
city('Jefferson','us','Virginia',28487.0,-77.19,38.86).
city('Lake Ridge','us','Virginia',34382.0,-77.3,38.69).
city('Lakeside','us','Virginia',10847.0,-77.47,37.62).
city('Laurel','us','Virginia',15986.0,-77.51,37.63).
city('Leesburg','us','Virginia',37053.0,-77.56,39.1).
city('Lincolnia','us','Virginia',17430.0,-77.15,38.82).
city('Lorton','us','Virginia',19215.0,-77.24,38.7).
city('Lynchburg','us','Virginia',65517.0,-79.19,37.4).
city('MacLean','us','Virginia',39651.0,-77.18,38.94).
city('Madison Heights','us','Virginia',11636.0,-79.1,37.44).
city('Manassas','us','Virginia',37699.0,-77.49,38.75).
city('Manassas Park','us','Virginia',11323.0,-77.45,38.77).
city('Martinsville','us','Virginia',14874.0,-79.86,36.68).
city('Mechanicsville','us','Virginia',35803.0,-77.36,37.63).
city('Montclair','us','Virginia',18465.0,-77.34,38.61).
city('Mount Vernon','us','Virginia',29379.0,-77.11,38.72).
city('Newington','us','Virginia',20891.0,-77.2,38.74).
city('Newport News','us','Virginia',183444.0,-76.51,37.08).
city('Norfolk','us','Virginia',246216.0,-76.24,36.92).
city('North Springfield','us','Virginia',9342.0,-77.21,38.8).
city('Oakton','us','Virginia',32171.0,-77.3,38.89).
city('Petersburg','us','Virginia',32812.0,-77.39,37.2).
city('Poquoson','us','Virginia',12086.0,-76.29,37.15).
city('Portsmouth','us','Virginia',99049.0,-76.36,36.86).
city('Pulaski','us','Virginia',9016.0,-80.77,37.05).
city('Radford','us','Virginia',14117.0,-80.56,37.12).
city('Reston','us','Virginia',61076.0,-77.35,38.95).
city('Richmond','us','Virginia',190886.0,-77.47,37.53).
city('Roanoke','us','Virginia',91168.0,-79.96,37.28).
city('Rose Hill','us','Virg',16477.0,-77.11,38.79).
city('Salem','us','Virginia',24314.0,-80.06,37.29).
city('Springfield','us','Virginia',34510.0,-77.18,38.79).
city('Staunton','us','Virginia',24040.0,-79.06,38.16).
city('Suffolk','us','Virginia',80690.0,-76.64,36.7).
city('Timberlake','us','Virginia',10961.0,-79.25,37.32).
city('Tuckahoe','us','Virginia',43931.0,-77.59,37.59).
city('Tysons Corner','us','Virginia',22008.0,-77.23,38.92).
city('Vienna','us','Virginia',14986.0,-77.26,38.9).
city('Virginia Beach','us','Virginia',449386.0,-76.04,36.74).
city('Waynesboro','us','Virginia',20904.0,-78.9,38.07).
city('West Springfield','us','Virginia',28758.0,-77.23,38.79).
city('Williamsburg','us','Virginia',11400.0,-76.71,37.27).
city('Winchester','us','Virginia',24895.0,-78.18,39.17).
city('Wolf Trap','us','Virginia',14561.0,-77.29,38.94).
city('Woodbridge','us','Virginia',35252.0,-77.26,38.64).
city('Aberdeen','us','Washington',16055.0,-123.81,46.98).
city('Alderwood Manor','us','Washington',16875.0,-122.24,47.8).
city('Anacortes','us','Washington',16061.0,-122.63,48.49).
city('Auburn','us','Washington',45650.0,-122.21,47.3).
city('Bainbridge Island','us','Washington',22967.0,-122.52,47.66).
city('Bellevue','us','Washington',111927.0,-122.16,47.6).
city('Bellingham','us','Washington',73469.0,-122.47,48.74).
city('Bonney Lake','us','Washington',14873.0,-122.17,47.19).
city('Bothell','us','Washington',30615.0,-122.2,47.76).
city('Bremerton','us','Washington',44053.0,-122.7,47.55).
city('Bryn Mawr-Skyway','us','Washington',14395.0,-122.24,47.5).
city('Burien','us','Washington',30611.0,-122.35,47.46).
city('Burlington','us','Washington',8286.0,-122.33,48.47).
city('Camas','us','Washington',17040.0,-122.42,45.59).
city('Cascade-Fairwood','us','Washington',36084.0,-122.16,47.45).
city('Centralia','us','Washington',15107.0,-122.96,46.72).
city('Cheney','us','Washington',10292.0,-117.58,47.49).
city('College Place','us','Washington',8843.0,-118.38,46.05).
city('Covington','us','Washington',16841.0,-122.1,47.37).
city('Des Moines','us','Washington',28668.0,-122.31,47.4).
city('East Hill-Meridian','us','Washington',28504.0,-122.17,47.39).
city('East Re','us','Washington',12991.0,-122.11,47.49).
city('East Wenatchee','us','Washington',8856.0,-120.29,47.42).
city('East Wenatchee Bench','us','Washington',13902.0,-120.28,47.42).
city('Edgewood','us','Washington',9727.0,-122.29,47.23).
city('Edmonds','us','Washington',39917.0,-122.37,47.83).
city('Elk Plain','us','Washington',17279.0,-122.38,47.05).
city('Ellensburg','us','Washington',17049.0,-120.55,47.0).
city('Enumclaw','us','Washington',10857.0,-121.99,47.2).
city('Esperance','us','Washington',3833.0,-122.35,47.79).
city('Everett','us','Washington',96993.0,-122.2,47.96).
city('Federal Way','us','Washington',80815.0,-122.34,47.31).
city('Ferndale','us','Washington',10098.0,-122.59,48.85).
city('Fort Lewis','us','Washington',18555.0,-122.58,47.11).
city('Grandview','us','Washington',8620.0,-119.91,46.25).
city('Hoquiam','us','Washington',8835.0,-123.89,46.98).
city('Inglewood-Finn Hill','us','Washington',21293.0,-122.23,47.73).
city('Issaquah','us','Washington',16853.0,-122.04,47.53).
city('Kelso','us','Washington',11648.0,-122.89,46.13).
city('Kenmore','us','Washington',19284.0,-122.24,47.76).
city('Kennewick','us','Washington',62158.0,-119.17,46.2).
city('Kent','us','Washington',82276.0,-122.24,47.39).
city('Kingsgate','us','Washington',11873.0,-122.17,47.73).
city('Kirkland','us','Washington',45778.0,-122.19,47.68).
city('Lacey','us','Washington',33755.0,-122.81,47.03).
city('Lake Forest Park','us','Washington',12368.0,-122.29,47.76).
city('Lakeland North','us','Washington',15074.0,-122.28,47.33).
city('Lakeland South','us','Washington',12496.0,-122.28,47.28).
city('Lakewood','us','Washington',58912.0,-122.53,47.16).
city('Longview','us','Washington',36349.0,-122.95,46.15).
city('Lynden','us','Washington',10816.0,-122.46,48.95).
city('Lynnwood','us','Washington',33478.0,-122.3,47.83).
city('Maple Valley','us','Washington',14100.0,-122.04,47.37).
city('Martha Lake','us','Washington',13686.0,-122.24,47.85).
city('Marysville','us','Washington',29824.0,-122.15,48.06).
city('Mercer Island','us','Washington',22476.0,-122.23,47.57).
city('Mill Creek','us','Washington',13466.0,-122.2,47.86).
city('Minnehaha','us','Washington',7283.0,-122.63,45.66).
city('Monroe','us','Washington',15554.0,-121.99,47.86).
city('Moses Lake','us','Washington',16626.0,-119.29,47.12).
city('Mount Vernon','us','Washington',29312.0,-122.31,48.42).
city('Mountlake Terrace','us','Washington',20445.0,-122.31,47.79).
city('Mukilteo','us','Washington',19927.0,-122.31,47.93).
city('Newcastle','us','Washington',9333.0,-122.17,47.53).
city('North Creek','us','Washington',26410.0,-122.19,47.81).
city('North Marysville','us','Washington',21922.0,-122.15,48.1).
city('Oak Harbor','us','Washington',22031.0,-122.62,48.29).
city('Olympia','us','Washington',44916.0,-122.89,47.04).
city('Opportunity','us','Washington',25877.0,-117.24,47.65).
city('Paine Field-Lake Stickney','us','Washington',27026.0,-122.26,47.89).
city('Parkland','us','Washington',25133.0,-122.43,47.14).
city('Pasco','us','Washington',43390.0,-119.13,46.25).
city('Picnic Point-North Lynnwood','us','Washington',24424.0,-122.13,47.83).
city('Port Angeles','us','Washington',18636.0,-123.46,48.19).
city('Port Townsend','us','Washington',8970.0,-122.78,48.12).
city('Pullman','us','Washington',25636.0,-117.16,46.73).
city('Puyallup','us','Washington',36675.0,-122.28,47.18).
city('Redmond','us','Washington',47264.0,-122.11,47.67).
city('Renton','us','Washington',56141.0,-122.2,47.48).
city('Richland','us','Washington',44869.0,-119.29,46.29).
city('Riverton-Boulevard Park','us','Washington',11042.0,-122.31,47.5).
city('Salmon Creek','us','Washington',19192.0,-122.66,45.71).
city('Sammamish','us','Washington',33929.0,-122.1,47.58).
city('SeaTac','us','Washington',24663.0,-122.3,47.44).
city('Seattle','us','Washington',569369.0,-122.35,47.62).
city('Seattle Hill-Silver Firs','us','Washington',41013.0,-121.16,47.88).
city('Sedro-Woolley','us','Washington',10605.0,-122.23,48.5).
city('Shelton','us','Washington',9032.0,-123.11,47.21).
city('Shoreline','us','Washington',51657.0,-122.36,47.75).
city('Snohomish','us','Washington',8708.0,-122.09,47.92).
city('South Hill','us','Washington',44139.0,-122.27,47.14).
city('Spanaway','us','Washington',25045.0,-122.43,47.11).
city('Spokane','us','Washington',197262.0,-117.41,47.67).
city('Sumner','us','Washington',9343.0,-122.24,47.21).
city('Sunnyside','us','Washington',14208.0,-120.01,46.32).
city('Tacoma','us','Washington',196957.0,-122.46,47.25).
city('Toppenish','us','Washington',9186.0,-120.31,46.38).
city('Tukwila','us','Washington',17022.0,-122.27,47.48).
city('Tumwater','us','Washington',13374.0,-122.92,47.0).
city('University Place','us','Washington',30873.0,-122.54,47.22).
city('Vancouver','us','Washington',157517.0,-122.64,45.63).
city('Walla Walla','us','Washington',30578.0,-118.34,46.07).
city('Washougal','us','Washington',10234.0,-122.35,45.58).
city('Wenatchee','us','Washington',29159.0,-120.32,47.43).
city('West Lake Stevens','us','Washington',21047.0,-122.1,47.99).
city('West Richland','us','Washington',9869.0,-119.35,46.29).
city('White Center','us','Washington',20716.0,-122.35,47.5).
city('Woodinville','us','Washington',10126.0,-122.11,47.75).
city('Yakima','us','Washington',88405.0,-120.53,46.59).
city('Beckley','us','West Virginia',16880.0,-81.19,37.79).
city('Bluefield','us','West Virginia',10945.0,-81.22,37.26).
city('Charleston','us','West Virginia',50427.0,-81.63,38.35).
city('Clarksburg','us','West Virginia',16232.0,-80.33,39.28).
city('Cross Lanes','us','West Virginia',10133.0,-81.77,38.44).
city('Fairmont','us','West Virginia',18820.0,-80.15,39.48).
city('Huntington','us','West Virginia',48518.0,-82.43,38.41).
city('Martinsburg','us','West Virginia',15616.0,-77.97,39.46).
city('Morgantown','us','West Virginia',28957.0,-79.95,39.64).
city('Moundsville','us','West Virginia',9638.0,-80.74,39.92).
city('Parkersburg','us','West Virginia',31564.0,-81.54,39.26).
city('Saint Albans','us','West Virginia',10990.0,-81.82,38.38).
city('South Charleston','us','West Virginia',12722.0,-81.71,38.36).
city('Vienna','us','West Virginia',10909.0,-81.54,39.32).
city('Weirton','us','West Virginia',19450.0,-80.56,40.4).
city('Wheeling','us','West Virginia',29388.0,-80.7,40.08).
city('Allouez','us','Wisconsin',14990.0,-88.03,44.47).
city('Appleton','us','Wisconsin',70112.0,-88.4,44.27).
city('Ashwaubenon','us','Wisconsin',16842.0,-88.08,44.49).
city('Baraboo','us','Wisconsin',10907.0,-89.74,43.47).
city('Beaver Dam','us','Wisconsin',14856.0,-88.84,43.46).
city('Bellevue','us','Wisconsin',14394.0,-87.92,44.44).
city('Beloit','us','Wisconsin',35210.0,-89.02,42.52).
city('Brookfield','us','Wisconsin',40056.0,-88.12,43.06).
city('Brown Deer','us','Wisconsin',11911.0,-87.97,43.18).
city('Burlington','us','Wisconsin',11414.0,-88.28,42.68).
city('Caledonia','us','Wisconsin',24282.0,-87.87,42.8).
city('Cedarburg','us','Wisconsin',11220.0,-87.99,43.3).
city('Chippewa Falls','us','Wisconsin',12607.0,-91.39,44.93).
city('Cudahy','us','Wisconsin',18099.0,-87.86,42.95).
city('De Pere','us','Wisconsin',23419.0,-88.07,44.44).
city('Eau Claire','us','Wisconsin',62852.0,-91.49,44.82).
city('Fitchburg','us','Wisconsin',22586.0,-89.43,42.99).
city('Fond du Lac','us','Wisconsin',41860.0,-88.45,43.77).
city('Fort Atkinson','us','Wisconsin',11791.0,-88.84,42.93).
city('Franklin','us','Wisconsin',33272.0,-88.01,42.89).
city('Germantown','us','Wisconsin',19465.0,-88.12,43.24).
city('Glendale','us','Wisconsin',12974.0,-87.93,43.13).
city('Grafton','us','Wisconsin',11833.0,-87.95,43.32).
city('Grand Chute','us','Wisconsin',20868.0,-88.4,44.3).
city('Green Bay','us','Wisconsin',101012.0,-87.99,44.52).
city('Greendale','us','Wisconsin',13990.0,-88.0,42.94).
city('Greenfield','us','Wisconsin',36493.0,-88.01,42.96).
city('Hartford','us','Wisconsin',12525.0,-88.38,43.32).
city('Hartland','us','Wisconsin',8786.0,-88.34,43.1).
city('Howard','us','Wisconsin',16379.0,-88.08,44.57).
city('Hudson','us','Wisconsin',11288.0,-92.74,44.97).
city('Janesville','us','Wisconsin',61675.0,-89.02,42.68).
city('Kaukauna','us','Wisconsin',14788.0,-88.27,44.28).
city('Kenosha','us','Wisconsin',93982.0,-87.85,42.58).
city('La Crosse','us','Wisconsin',50470.0,-91.23,43.83).
city('Lisbon','us','Wisconsin',10230.0,-90.17,43.87).
city('Little Chute','us','Wisconsin',10698.0,-88.31,44.29).
city('Madison','us','Wisconsin',224625.0,-89.39,43.08).
city('Manitowoc','us','Wisconsin',33939.0,-87.68,44.1).
city('Marinette','us','Wisconsin',11171.0,-87.63,45.09).
city('Marshfield','us','Wisconsin',18670.0,-90.17,44.66).
city('Menasha','us','Wisconsin',16621.0,-88.44,44.21).
city('Menomonee Falls','us','Wisconsin',34515.0,-88.13,43.15).
city('Menomonie','us','Wisconsin',15361.0,-91.91,44.89).
city('Mequon','us','Wisconsin',23902.0,-87.99,43.24).
city('Merrill','us','Wisconsin',10184.0,-89.7,45.18).
city('Middleton','us','Wisconsin',16288.0,-89.51,43.1).
city('Milwaukee','us','Wisconsin',579180.0,-87.97,43.06).
city('Monroe','us','Wisconsin',10608.0,-89.64,42.6).
city('Mount Pleasant','us','Wisconsin',26087.0,-87.89,42.72).
city('Muskego','us','Wisconsin',22889.0,-88.12,42.89).
city('Neenah','us','Wisconsin',24810.0,-88.47,44.17).
city('New Berlin','us','Wisconsin',38735.0,-88.13,42.97).
city('Oak Creek','us','Wisconsin',34755.0,-87.9,42.88).
city('Oconomowoc','us','Wisconsin',13757.0,-88.5,43.1).
city('Onalaska','us','Wisconsin',15924.0,-91.22,43.89).
city('Oshkosh','us','Wisconsin',63017.0,-88.55,44.02).
city('Pewaukee','us','Wisconsin',13332.0,-88.25,43.08).
city('Platteville','us','Wisconsin',9786.0,-90.48,42.74).
city('Pleasant Prairie','us','Wisconsin',19458.0,-87.88,42.52).
city('Plover','us','Wisconsin',11464.0,-89.54,44.46).
city('Port Washington','us','Wisconsin',11030.0,-87.88,43.39).
city('Portage','us','Wisconsin',10098.0,-89.47,43.55).
city('Racine','us','Wisconsin',79263.0,-87.81,42.73).
city('Richfield','us','Wisconsin',10892.0,-88.2,43.26).
city('River Falls','us','Wisconsin',13435.0,-92.62,44.86).
city('Salem','us','Wisconsin',11416.0,-88.09,42.56).
city('Sheboygan','us','Wisconsin',48591.0,-87.73,43.75).
city('Shorewood','us','Wisconsin',13192.0,-87.89,43.09).
city('Somers','us','Wisconsin',9454.0,-87.91,42.64).
city('South Milwaukee','us','Wisconsin',21059.0,-87.86,42.91).
city('Stevens Point','us','Wisconsin',24408.0,-89.56,44.53).
city('Stoughton','us','Wisconsin',12735.0,-89.22,42.92).
city('Sturgeon Bay','us','Wisconsin',9492.0,-87.37,44.83).
city('Suamico','us','Wisconsin',10297.0,-88.04,44.63).
city('Sun Prairie','us','Wisconsin',25561.0,-89.23,43.18).
city('Superior','us','Wisconsin',27130.0,-92.06,46.7).
city('Sussex','us','Wisconsin',10152.0,-88.22,43.14).
city('Two Rivers','us','Wisconsin',11985.0,-87.58,44.16).
city('Verona','us','Wisconsin',10649.0,-89.54,42.99).
city('Watertown','us','Wisconsin',23323.0,-88.72,43.19).
city('Waukesha','us','Wisconsin',68112.0,-88.24,43.01).
city('Waunakee','us','Wisconsin',10366.0,-89.45,43.19).
city('Waupun','us','Wisconsin',10480.0,-88.74,43.63).
city('Wausau','us','Wisconsin',36779.0,-89.64,44.96).
city('Wauwatosa','us','Wisconsin',45453.0,-88.03,43.06).
city('West Allis','us','Wisconsin',59363.0,-88.03,43.01).
city('West Bend','us','Wisconsin',29431.0,-88.18,43.42).
city('Weston','us','Wisconsin',13080.0,-89.57,44.9).
city('Whitefish B','us','Wisconsin',13611.0,-87.9,43.11).
city('Whitewater','us','Wisconsin',14536.0,-88.74,42.83).
city('Wisconsin Rapids','us','Wisconsin',17724.0,-89.83,44.39).
city('Casper','us','Wyoming',51507.0,-106.33,42.83).
city('Cheyenne','us','Wyoming',55443.0,-104.79,41.15).
city('Cody','us','Wyoming',9161.0,-109.05,44.52).
city('Douglas','us','Wyoming',5378.0,-105.39,42.76).
city('Evanston','us','Wyoming',11258.0,-110.96,41.26).
city('Gillette','us','Wyoming',23101.0,-105.52,44.28).
city('Green River','us','Wyoming',11358.0,-109.47,41.52).
city('Jackson','us','Wyoming',8989.0,-110.76,43.47).
city('Lander','us','Wyoming',6821.0,-108.73,42.83).
city('Laramie','us','Wyoming',26934.0,-105.58,41.31).
city('Powell','us','Wyoming',5213.0,-108.74,44.79).
city('Rawlins','us','Wyoming',8533.0,-107.23,41.78).
city('Riverton','us','Wyoming',9192.0,-108.41,43.04).
city('Rock Springs','us','Wyoming',18226.0,-109.22,41.6).
city('Sheridan','us','Wyoming',16154.0,-106.96,44.79).
city('Torrington','us','Wyoming',5483.0,-104.18,42.07).
city('Worland','us','Wyoming',4729.0,-107.96,44.01).
city('Artigas','uy','Artigas',44564.0,-56.48,-30.41).
city('Bella Union','uy','Artigas',14639.0,-57.6,-30.26).
city('Camino Maldonado','uy','Canelones',16252.0,-56.02,-34.77).
city('Canelones','uy','Canelones',21081.0,-56.29,-34.53).
city('Ciudad de la Costa','uy','Canelones',112688.0,-55.95,-34.82).
city('Juan Antonio Artigas','uy','Canelones',16166.0,-55.98,-34.75).
city('Las Piedras','uy','Canelones',72965.0,-56.23,-34.69).
city('Pando','uy','Canelones',28775.0,-55.96,-34.72).
city('Paso de Carrasco','uy','Canelones',13846.0,-56.0,-34.85).
city('Progreso','uy','Canelones',17715.0,-56.22,-34.67).
city('Santa Lucia','uy','Canelones',18022.0,-56.4,-34.47).
city('Melo','uy','Cerro Largo',50833.0,-54.18,-32.36).
city('Rio Branco','uy','Cerro Largo',17405.0,-53.43,-32.57).
city('Carmelo','uy','Colonia',18713.0,-58.3,-33.99).
city('Colonia','uy','Colonia',24870.0,-57.84,-34.48).
city('Juan Lacaze','uy','Colonia',13263.0,-57.43,-34.44).
city('Nueva Helvecia','uy','Colonia',10305.0,-57.22,-34.32).
city('Durazno','uy','Durazno',32782.0,-56.51,-33.41).
city('Florida','uy','FLorida',34002.0,-56.22,-34.1).
city('Trinidad','uy','Flores',21110.0,-56.9,-33.54).
city('Minas','uy','Lavalleja',39123.0,-55.23,-34.37).
city('Maldonado','uy','Maldonado',67188.0,-54.96,-34.91).
city('San Carlos','uy','Maldonado',27613.0,-54.91,-34.79).
city('La Paz','uy','Montevideo',22804.0,-56.23,-34.77).
city('Montevideo','uy','Montevideo',1305865.0,-56.17,-34.87).
city('Paysandu','uy','Paysandu',78902.0,-58.08,-32.33).
city('Fray Bentos','uy','Rio Negro',23566.0,-58.31,-33.13).
city('Young','uy','Rio Negro',16600.0,-57.63,-32.71).
city('Rivera','uy','Rivera',68020.0,-55.56,-30.9).
city('Chuy','uy','Rocha',11287.0,-53.45,-33.68).
city('Rocha','uy','Rocha',27695.0,-54.32,-34.5).
city('Salto','uy','Salto',104667.0,-57.96,-31.4).
city('Delta del Tigre','uy','San Jose',17952.0,-56.43,-34.78).
city('San Jose','uy','San Jose',37606.0,-56.71,-34.35).
city('Dolores','uy','Soriano',16205.0,-58.21,-33.55).
city('Mercedes','uy','Soriano',41075.0,-58.03,-33.26).
city('Paso de los Toros','uy','Tacuarembo',13599.0,-56.51,-32.81).
city('Tacuarembo','uy','Tacuarembo',50575.0,-55.98,-31.71).
city('Treinta y Tres','uy','Treinta y Tres',27433.0,-54.38,-33.23).
city('Ahunabayev','uz','Andijon',14514.0,72.63,40.72).
city('Andijon','uz','Andijon',318439.0,72.34,40.79).
city('Asaka','uz','Andijon',56736.0,72.24,40.65).
city('Boz','uz','Andijon',23750.0,71.92,40.69).
city('Hakkulobod','uz','Andijon',26257.0,72.11,40.91).
city('Hocaobod','uz','Andijon',16889.0,72.55,40.67).
city('Ilyichevsk','uz','Andijon',25729.0,72.88,40.73).
city('Karabagis','uz','Andijon',32590.0,72.38,40.52).
city('Kuergontepa','uz','Andijon',25861.0,72.75,40.74).
city('Marhomat','uz','Andijon',14646.0,72.32,40.5).
city('Pahtaobod','uz','Andijon',25070.0,72.49,40.93).
city('Paytug','uz','Andijon',25597.0,72.25,40.88).
city('Sahrihan','uz','Andijon',64784.0,72.06,40.71).
city('Buhoro','uz','Buhoro',247661.0,64.42,39.77).
city('Galaosiye','uz','Buhoro',15620.0,64.44,39.85).
city('Gazli','uz','Buhoro',11446.0,63.44,40.13).
city('Gijduvon','uz','Buhoro',41070.0,64.68,40.1).
city('Kogon','uz','Buhoro',62696.0,64.55,39.72).
city('Korakuel','uz','Buhoro',22488.0,63.86,39.52).
city('Korovulbazar','uz','Buhoro',8618.0,64.8,39.5).
city('Olot','uz','Buhoro',11984.0,63.8,39.43).
city('Romitan','uz','Buhoro',12927.0,64.38,39.93).
city('Safirkon','uz','Buhoro',26527.0,64.5,40.14).
city('Vobkent','uz','Buhoro',16697.0,64.52,40.02).
city('Cizah','uz','Cizah',152651.0,67.84,40.11).
city('Duestlik','uz','Cizah',16524.0,68.03,40.54).
city('Gagarin','uz','Cizah',24856.0,68.16,40.66).
city('Gallaorol','uz','Cizah',23051.0,67.36,40.06).
city('Marcanbulok','uz','Cizah',4305.0,67.38,39.99).
city('Pahtakor','uz','Cizah',21384.0,67.96,40.32).
city('Ulyanovo','uz','Cizah',19718.0,68.5,40.12).
city('Zomin','uz','Cizah',27078.0,68.41,39.96).
city('Altyarik','uz','Fargona',25543.0,71.5,40.38).
city('Besarik2','uz','Fargona',21984.0,70.61,40.44).
city('Fargona','uz','Fargona',164334.0,71.78,40.39).
city('Hamza','uz','Fargona',13470.0,71.5,40.42).
city('Komsomolskiy','uz','Fargona',20459.0,71.75,40.42).
city('Kuekon','uz','Fargona',187485.0,70.94,40.54).
city('Kuva','uz','Fargona',33167.0,72.07,40.54).
city('Kuvasoy','uz','Fargona',32023.0,71.95,40.32).
city('Kuybyshevo','uz','Fargona',30117.0,71.27,40.37).
city('Margilon','uz','Fargona',133499.0,71.71,40.47).
city('Toslok','uz','Fargona',26686.0,71.75,40.47).
city('Yaypan','uz','Fargona',20332.0,70.82,40.38).
city('Druzhba','uz','Horazm',17226.0,61.28,41.19).
city('Gurlan','uz','Horazm',27506.0,60.4,41.84).
city('Hazorasp','uz','Horazm',17643.0,61.07,41.31).
city('Heva','uz','Horazm',55568.0,60.36,41.39).
city('Honko','uz','Horazm',40286.0,60.78,41.47).
city('Kueskuepir','uz','Horazm',16948.0,60.35,41.54).
city('Sovot','uz','Horazm',26950.0,60.29,41.66).
city('Uergenc','uz','Horazm',150120.0,60.64,41.55).
city('Beskent','uz','Kaskadarya',17010.0,65.65,38.82).
city('Cirakci','uz','Kaskadarya',19356.0,66.56,39.04).
city('Guzor','uz','Kaskadarya',25368.0,66.25,38.62).
city('Kamasi','uz','Kaskadarya',32700.0,66.46,38.81).
city('Karsi','uz','Kaskadarya',222910.0,65.8,38.87).
city('Kitob','uz','Kaskadarya',41938.0,66.86,39.12).
city('Koson','uz','Kaskadarya',59681.0,65.57,39.04).
city('Maymanak','uz','Kaskadarya',17010.0,65.42,39.05).
city('Muborak','uz','Kaskadarya',29180.0,65.15,39.26).
city('Oktyabrskiy','uz','Kaskadarya',28154.0,66.82,39.1).
city('Sahrisabz','uz','Kaskadarya',57134.0,66.83,39.06).
city('Talimarcon','uz','Kaskadarya',9825.0,65.62,38.38).
city('Yakkabog','uz','Kaskadarya',25515.0,66.68,38.98).
city('Yaninison','uz','Kaskadarya',10558.0,65.7,38.65).
city('Beruni','uz','Korakalpogiston',50929.0,60.74,41.69).
city('Bueston','uz','Korakalpogiston',11452.0,60.88,41.7).
city('Cimboy','uz','Korakalpogiston',36917.0,59.77,42.93).
city('Halkobod','uz','Korakalpogiston',12395.0,59.73,42.69).
city('Huecayli','uz','Korakalpogiston',73375.0,59.43,42.41).
city('Karauzyak','uz','Korakalpogiston',27081.0,60.02,43.03).
city('Kegayli','uz','Korakalpogiston',14147.0,59.6,42.78).
city('Kizketken','uz','Korakalpogiston',20075.0,59.6,42.38).
city('Kuengirot','uz','Korakalpogiston',59122.0,58.9,43.07).
city('Mangit','uz','Korakalpogiston',30854.0,60.05,42.12).
city('Mueynok','uz','Korakalpogiston',16437.0,59.02,43.78).
city('Nukus','uz','Korakalpogiston',230020.0,59.61,42.47).
city('Tahiatos','uz','Korakalpogiston',57935.0,59.58,42.34).
city('Tahtakuepir','uz','Korakalpogiston',26947.0,60.29,43.03).
city('Tuertkuel','uz','Korakalpogiston',48908.0,61.0,41.56).
city('Cartak','uz','Namangan',49844.0,71.81,41.07).
city('Cust','uz','Namangan',64966.0,71.23,41.0).
city('Kosonsoy','uz','Namangan',43684.0,71.55,41.24).
city('Namangan','uz','Namangan',432479.0,71.67,41.0).
city('Nurota','uz','Namangan',29403.0,65.67,40.57).
city('Pop','uz','Namangan',22122.0,71.08,40.89).
city('Tosbulok','uz','Namangan',28563.0,71.58,40.92).
city('Turakuergon','uz','Namangan',27862.0,71.5,41.0).
city('Uckuergon','uz','Namangan',33323.0,72.09,41.13).
city('Ueyci','uz','Namangan',29683.0,71.85,41.02).
city('Unhoyat','uz','Namangan',15961.0,71.77,41.02).
city('Yanikuergon','uz','Namangan',28423.0,71.72,41.19).
city('Karmana','uz','Navoi',23007.0,65.37,40.21).
city('Kiziltepa','uz','Navoi',13558.0,64.85,40.04).
city('Navoi','uz','Navoi',129734.0,65.35,40.11).
city('Uckuduk','uz','Navoi',32868.0,63.46,42.17).
city('Zarafson','uz','Navoi',63544.0,64.2,41.58).
city('Aktash','uz','Samarkand',38307.0,65.92,39.93).
city('Bulungur','uz','Samarkand',26815.0,67.27,39.76).
city('Camboy','uz','Samarkand',14429.0,67.09,39.7).
city('Carhin','uz','Samarkand',13791.0,66.8,39.68).
city('Celak','uz','Samarkand',16727.0,66.85,39.92).
city('Cuma','uz','Samarkand',19920.0,66.66,39.7).
city('Dahbed','uz','Samarkand',8044.0,66.92,39.77).
city('Istihon','uz','Samarkand',13024.0,66.48,39.97).
city('Kattakuergon','uz','Samarkand',59389.0,66.26,39.9).
city('Nurobod','uz','Samarkand',9960.0,66.33,39.64).
city('Paysanba','uz','Samarkand',24772.0,66.22,40.04).
city('Samarkand','uz','Samarkand',319404.0,66.95,39.66).
city('Superfosfatniy','uz','Samarkand',14812.0,66.87,39.69).
city('Urgut','uz','Samarkand',47373.0,67.25,39.4).
city('Yanirobod','uz','Samarkand',25027.0,65.96,40.04).
city('Ziadin','uz','Samarkand',19153.0,65.77,40.06).
city('Baht','uz','Sirdare',11069.0,68.7,40.72).
city('Guliston','uz','Sirdare',53418.0,68.79,40.5).
city('Hovos','uz','Sirdare',18601.0,68.84,40.22).
city('Sirdare','uz','Sirdare',26817.0,68.67,40.84).
city('Sirin','uz','Sirdare',14036.0,69.05,40.27).
city('Yaniy','uz','Sirdare',32637.0,68.84,40.29).
city('Akkuergon','uz','Surhondar',16800.0,67.01,37.67).
city('Boysun','uz','Surhondar',25050.0,67.2,38.21).
city('Carkurgon','uz','Surhondar',26550.0,67.25,37.55).
city('Denau','uz','Surhondar',69094.0,67.89,38.28).
city('Kumkurgon','uz','Surhondar',18300.0,67.62,37.8).
city('Sargun','uz','Surhondar',16050.0,67.97,38.5).
city('Sariasiya','uz','Surhondar',22350.0,66.95,39.12).
city('Serobod','uz','Surhondar',25500.0,67.07,37.71).
city('Suerci','uz','Surhondar',24900.0,67.79,38.01).
city('Termiz','uz','Surhondar',140404.0,67.27,37.23).
city('Almazar','uz','Tashkent',24781.0,68.89,40.98).
city('Angren','uz','Tashkent',126962.0,70.15,41.03).
city('Bekobod','uz','Tashkent',86266.0,69.24,40.21).
city('Bektemir','uz','Tashkent',26380.0,69.33,41.24).
city('Buka','uz','Tashkent',19642.0,69.18,40.8).
city('Cinoz','uz','Tashkent',24553.0,68.75,40.95).
city('Circik','uz','Tashkent',167856.0,69.56,41.45).
city('Gazalkent','uz','Tashkent',24610.0,69.77,41.57).
city('Iskandar','uz','Tashkent',27636.0,69.68,41.55).
city('Kibray','uz','Tashkent',27750.0,69.47,41.38).
city('Krasnogorskiy','uz','Tashkent',11762.0,69.68,41.15).
city('Ohangaron','uz','Tashkent',35516.0,69.64,40.92).
city('Olmalik','uz','Tashkent',121218.0,69.59,40.85).
city('Parkent','uz','Tashkent',35972.0,69.68,41.3).
city('Pskent','uz','Tashkent',27864.0,69.35,40.89).
city('Salar','uz','Tashkent',26494.0,69.37,41.34).
city('Soldatskiy','uz','Tashkent',14161.0,68.93,40.85).
city('Tashkent','uz','Tashkent',1978078.0,69.3,41.31).
city('Tueytepa','uz','Tashkent',19985.0,69.36,41.04).
city('Urtaaul','uz','Tashkent',14046.0,69.13,41.19).
city('Yaniobod','uz','Tashkent',24096.0,70.09,41.04).
city('Yaniyuel','uz','Tashkent',44316.0,69.05,41.12).
city('Lakatoro','vu','Malampa',705.0,167.4,-16.09).
city('Norsup','vu','Malampa',2998.0,167.39,-16.07).
city('Longana','vu','Penama',711.0,168.0,-15.3).
city('Luganville','vu','Sanma',13398.0,167.15,-15.51).
city('Port Olry','vu','Sanma',1951.0,167.05,-15.05).
city('Vila','vu','Shefa',35903.0,168.31,-17.74).
city('Isangel','vu','Tafea',1437.0,169.28,-19.53).
city('Sola','vu','Torba',1171.0,167.55,-13.87).
city('Puerto Ayacucho','ve','Amazonas',52528.0,-67.64,5.67).
city('Anaco','ve','Anzoategui',117605.0,-64.46,9.44).
city('Barcelona','ve','Anzoategui',424819.0,-64.72,10.13).
city('Cantaura','ve','Anzoategui',33042.0,-64.37,9.31).
city('El Tigre','ve','Anzoategui',151011.0,-64.26,8.89).
city('Puerto la Cruz','ve','Anzoategui',218228.0,-64.68,10.17).
city('San Jose de Guanipa','ve','Anzoategui',62133.0,-64.1,8.88).
city('Guasdualito','ve','Apure',30860.0,-70.74,7.24).
city('San Fernando','ve','Apure',78804.0,-67.47,7.9).
city('Cagua','ve','Aragua',119052.0,-67.46,10.19).
city('El Limon','ve','Aragua',148270.0,-67.63,10.3).
city('La Victoria','ve','Aragua',87060.0,-67.34,10.23).
city('Las Teyerias','ve','Aragua',33320.0,-67.17,10.26).
city('Maracay','ve','Aragua',395412.0,-67.47,10.33).
city('Palo Negro','ve','Aragua',128895.0,-67.58,10.19).
city('San Mateo','ve','Aragua',50409.0,-67.42,10.22).
city('Turmero','ve','Aragua',344746.0,-67.48,10.22).
city('Villa de Cura','ve','Aragua',76627.0,-67.49,10.04).
city('Barinas','ve','Barinas',284305.0,-70.25,8.6).
city('Barinitas','ve','Barinas',34397.0,-70.42,8.77).
city('Ciudad Bolivar','ve','Bolivar',291170.0,-63.6,8.1).
city('Ciudad Guayana','ve','Bolivar',746606.0,-62.62,8.37).
city('Upata','ve','Bolivar',53697.0,-62.41,8.02).
city('Goaigoaza','ve','Carabobo',49767.0,-67.96,10.42).
city('Guacara','ve','Carabobo',151788.0,-67.89,10.24).
city('Gueiguee','ve','Carabobo',71548.0,-67.78,10.08).
city('Mariara','ve','Carabobo',105511.0,-67.72,10.29).
city('Moron','ve','Carabobo',44319.0,-68.2,10.49).
city('Puerto Cabello','ve','Carabobo',163886.0,-68.17,10.47).
city('San Joaquin','ve','Carabobo',41630.0,-67.78,10.27).
city('Tacarigua','ve','Carabobo',39215.0,-67.92,10.1).
city('Valencia','ve','Carabobo',1385202.0,-67.98,10.23).
city('San Carlos','ve','Cojedes',77204.0,-68.6,9.66).
city('Tinaquillo','ve','Cojedes',82157.0,-68.31,9.91).
city('Tucupita','ve','Delta Amacuro',51547.0,-62.06,9.06).
city('Caracas','ve','Distrito Capital',1815681.0,-66.93,10.54).
city('Coro','ve','Falcon',195246.0,-69.68,11.42).
city('Punta Cardon','ve','Falcon',58933.0,-70.22,11.66).
city('Punto Fijo','ve','Falcon',131797.0,-70.21,11.72).
city('Altagracia de Orituco','ve','Guarico',40058.0,-66.38,9.85).
city('Calabozo','ve','Guarico',117148.0,-67.44,8.93).
city('San Juan de los Morros','ve','Guarico',87752.0,-67.36,9.9).
city('Valle de la Pascua','ve','Guarico',89093.0,-66.02,9.21).
city('Zaraza','ve','Guarico',41490.0,-65.32,9.34).
city('Barquisimeto','ve','Lara',809564.0,-69.3,10.05).
city('Cabudare','ve','Lara',131013.0,-69.27,10.03).
city('Carora','ve','Lara',93803.0,-70.08,10.19).
city('El Tocuyo','ve','Lara',53108.0,-69.8,9.78).
city('Los Rastrojos','ve','Lara',34636.0,-69.25,10.04).
city('Quibor','ve','Lara',41533.0,-69.63,9.93).
city('Ejido','ve','Merida',107056.0,-71.23,8.56).
city('El Vigia','ve','Merida',59102.0,-71.65,8.63).
city('Merida','ve','Merida',215289.0,-71.13,8.4).
city('Baruta','ve','Miranda',244216.0,-66.88,10.43).
city('Carrizal','ve','Miranda',40618.0,-66.99,10.35).
city('Catia La Mar','ve','Miranda',106850.0,-67.03,10.56).
city('Caucagueita','ve','Miranda',52555.0,-66.74,10.48).
city('Chacao','ve','Miranda',64755.0,-66.85,10.5).
city('Charallave','ve','Miranda',129213.0,-66.86,10.24).
city('Cua','ve','Miranda',182925.0,-66.9,10.17).
city('El Cafetal','ve','Miranda',80029.0,-66.83,10.43).
city('El Hatillo','ve','Miranda',57591.0,-66.82,10.44).
city('Guar','ve','Miranda',181657.0,-66.62,10.47).
city('Guatire','ve','Miranda',192291.0,-66.53,10.47).
city('La Dolorita','ve','Miranda',56846.0,-66.78,10.48).
city('Los Dos Caminos','ve','Miranda',58300.0,-66.84,10.52).
city('Los Teques','ve','Miranda',173749.0,-67.02,10.42).
city('Ocumare del Tuy','ve','Miranda',166112.0,-66.78,10.12).
city('Petare','ve','Miranda',365959.0,-66.83,10.52).
city('San Antonio de los Altos','ve','Miranda',63873.0,-66.95,10.39).
city('Santa Teresa','ve','Miranda',279424.0,-66.66,10.23).
city('Maturin','ve','Monagas',410967.0,-63.17,9.75).
city('La Asuncion','ve','Nueva Esparta',35089.0,-63.87,11.03).
city('Porlamar','ve','Nueva Esparta',87131.0,-63.85,10.96).
city('Acarigua','ve','Portuguesa',143739.0,-69.2,9.58).
city('Araure','ve','Portuguesa',73074.0,-69.22,9.59).
city('Guanare','ve','Portuguesa',112315.0,-69.75,9.05).
city('Villa Bruzual','ve','Portuguesa',28001.0,-69.13,9.34).
city('Carupano','ve','Sucre',112102.0,-63.23,10.67).
city('Cumana','ve','Sucre',257821.0,-64.18,10.45).
city('La Fria','ve','Tachira',27077.0,-72.25,8.22).
city('Rubio','ve','Tachira',51577.0,-72.36,7.71).
city('San Antonio del Tachira','ve','Tachira',32465.0,-72.45,7.82).
city('San Cristobal','ve','Tachira',246620.0,-72.25,7.77).
city('San Juan de Colon','ve','Tachira',38240.0,-72.26,8.04).
city('Tariba','ve','Tachira',27432.0,-72.24,7.82).
city('Trujillo','ve','Trujillo',38114.0,-70.44,9.38).
city('Valera','ve','Trujillo',93764.0,-70.62,9.32).
city('Caraballeda','ve','Vargas',37831.0,-66.84,10.62).
city('La Guaira','ve','Vargas',25264.0,-66.89,10.61).
city('Maiquetia','ve','Vargas',52573.0,-66.97,10.6).
city('Chivacoa','ve','Yaracuy',45912.0,-68.91,10.16).
city('Nirgua','ve','Yaracuy',30188.0,-68.57,10.16).
city('San Felipe','ve','Yaracuy',76779.0,-68.75,10.34).
city('Yaritagua','ve','Yaracuy',89677.0,-69.13,10.08).
city('Bachaquero','ve','Zulia',30869.0,-71.14,9.93).
city('Cabimas','ve','Zulia',200859.0,-71.45,10.43).
city('Ciudad Ojeda','ve','Zulia',73931.0,-71.34,10.26).
city('Lagunillas','ve','Zulia',44257.0,-71.26,10.16).
city('Machiques','ve','Zulia',62982.0,-72.55,10.07).
city('Maracaibo','ve','Zulia',1948269.0,-71.66,10.73).
city('San Carlos del Zulia','ve','Zulia',56595.0,-71.92,9.01).
city('Santa Rita','ve','Zulia',31817.0,-71.51,10.53).
city('Villa del Rosario','ve','Zulia',65025.0,-72.31,10.33).
city('Bac Lieu','vn','Dong Bang Song Cuu Long',107920.0,105.72,9.3).
city('Ben Tre','vn','Dong Bang Song Cuu Long',59449.0,106.37,10.23).
city('Ca Mau','vn','Dong Bang Song Cuu Long',111903.0,105.15,9.18).
city('Can Tho','vn','Dong Bang Song Cuu Long',259608.0,105.78,10.03).
city('Chau Doc','vn','Dong Bang Song Cuu Long',58039.0,105.11,10.71).
city('Long Xuyen','vn','Dong Bang Song Cuu Long',158159.0,105.43,10.39).
city('My Tho','vn','Dong Bang Song Cuu Long',122315.0,106.36,10.36).
city('Rach Gia','vn','Dong Bang Song Cuu Long',228365.0,105.08,10.02).
city('Sa Dec','vn','Dong Bang Song Cuu Long',50463.0,105.76,10.3).
city('Soc Trang','vn','Dong Bang Song Cuu Long',114462.0,105.97,9.62).
city('Tan An','vn','Dong Bang Song Cuu Long',64806.0,106.41,10.54).
city('Tra Vinh','vn','Dong Bang Song Cuu Long',57413.0,106.34,9.94).
city('Vinh Long','vn','Dong Bang Song Cuu Long',103323.0,105.97,10.25).
city('Ha Dong','vn','Dong Bang Song Hong',50883.0,105.77,20.97).
city('Ha Noi','vn','Dong Bang Song Hong',1431377.0,105.84,21.03).
city('Hai Duong','vn','Dong Bang Song Hong',58035.0,106.32,20.96).
city('Hai Phong','vn','Dong Bang Song Hong',602718.0,106.68,20.86).
city('Huong Yen','vn','Dong Bang Song Hong',41640.0,106.04,20.65).
city('Nam Dinh','vn','Dong Bang Song Hong',193507.0,106.17,20.43).
city('Ninh Binh','vn','Dong Bang Song Hong',36868.0,105.98,20.25).
city('Phu Ly','vn','Dong Bang Song Hong',31818.0,105.92,20.54).
city('Son Tay','vn','Dong Bang Song Hong',40636.0,105.51,21.14).
city('Thai Binh','vn','Dong Bang Song Hong',53095.0,106.34,20.45).
city('Bien Hoa','vn','Dong Nam Bo',407224.0,106.82,10.95).
city('Dong Xoai','vn','Dong Nam Bo',23978.0,106.92,11.54).
city('Ho Chi Minh City','vn','Dong Nam Bo',3467426.0,106.69,10.78).
city('Song Be','vn','Dong Nam Bo',56434.0,106.65,10.98).
city('Tay Ninh','vn','Dong Nam Bo',47971.0,106.13,11.29).
city('Vung Tau','vn','Dong Nam Bo',209699.0,107.08,10.35).
city('Cam Ranh','vn','Duyen Hai Mien Trung',146771.0,109.22,11.9).
city('Da Nang','vn','Duyen Hai Mien Trung',472255.0,108.21,16.07).
city('Hoi An','vn','Duyen Hai Mien Trung',32757.0,108.34,15.88).
city('Nha Trang','vn','Duyen Hai Mien Trung',283452.0,109.19,12.25).
city('Phan Rang','vn','Duyen Hai Mien Trung',91520.0,109.0,11.57).
city('Phan Thiet','vn','Duyen Hai Mien Trung',160665.0,108.11,10.93).
city('Quang Ngai','vn','Duyen Hai Mien Trung',32995.0,108.81,15.12).
city('Qui Nhon','vn','Duyen Hai Mien Trung',210346.0,109.24,13.77).
city('Tam Ky','vn','Duyen Hai Mien Trung',59000.0,108.49,15.57).
city('Tuy Hoa','vn','Duyen Hai Mien Trung',69602.0,109.3,13.09).
city('Bien San','vn','Khu Bon Cu',53754.0,105.85,20.06).
city('Dong Ha','vn','Khu Bon Cu',17662.0,107.11,16.83).
city('Dong Hoi','vn','Khu Bon Cu',31044.0,106.62,17.47).
city('Ha Tinh','vn','Khu Bon Cu',26547.0,105.9,18.37).
city('Hue','vn','Khu Bon Cu',287228.0,107.58,16.48).
city('Thanh Hoa','vn','Khu Bon Cu',112482.0,105.78,19.81).
city('Vinh','vn','Khu Bon Cu',107130.0,105.67,18.68).
city('Bac Can','vn','Mien Nui Va Trung Du',21837.0,105.81,22.16).
city('Bac Giang','vn','Mien Nui Va Trung Du',53732.0,106.19,21.28).
city('Bac Ninh','vn','Mien Nui Va Trung Du',43564.0,106.05,21.19).
city('Cam Pha','vn','Mien Nui Va Trung Du',135487.0,107.29,21.02).
city('Cao Bang','vn','Mien Nui Va Trung Du',41117.0,106.27,22.68).
city('Dien Bien','vn','Mien Nui Va Trung Du',40292.0,103.01,21.37).
city('Ha Giang','vn','Mien Nui Va Trung Du',32690.0,104.98,22.86).
city('Hoa Binh','vn','Mien Nui Va Trung Du',105268.0,105.33,20.84).
city('Hong Gai','vn','Mien Nui Va Trung Du',148072.0,107.08,20.97).
city('Lang Son','vn','Mien Nui Va Trung Du',34964.0,106.76,21.86).
city('Lao Cai','vn','Mien Nui Va Trung Du',36502.0,103.96,22.5).
city('Son La','vn','Mien Nui Va Trung Du',19054.0,103.9,21.33).
city('Thai Nguyen','vn','Mien Nui Va Trung Du',133882.0,105.86,21.56).
city('Tuyen Quang','vn','Mien Nui Va Trung Du',36435.0,105.21,21.82).
city('Uong Bi','vn','Mien Nui Va Trung Du',63829.0,106.77,21.04).
city('Viet Tri','vn','Mien Nui Va Trung Du',71462.0,105.43,21.31).
city('Vinh Yen','vn','Mien Nui Va Trung Du',17876.0,105.61,21.32).
city('Yen Bai','vn','Mien Nui Va Trung Du',96548.0,104.87,21.71).
city('Buon Me Thuot','vn','Thai Nguyen',146986.0,108.04,12.68).
city('Da Lat','vn','Thai Nguyen',131382.0,108.44,11.96).
city('Kon Tum','vn','Thai Nguyen',47414.0,108.01,14.0).
city('Play Cu','vn','Thai Nguyen',114234.0,108.01,13.99).
city('Christiansted','vi','Saint Croix',2666.0,-64.71,17.75).
city('Frederiksted','vi','Saint Croix',649.0,-64.88,17.72).
city('Frederiksted Southeast','vi','Saint Croix',3038.0,-64.88,17.71).
city('Grove Place','vi','Saint Croix',2855.0,-64.83,17.73).
city('Cruz Bay','vi','Saint John',2914.0,-64.8,18.34).
city('Annas Retreat','vi','Saint Thomas',7802.0,-64.89,18.34).
city('Charlotte Amalie','vi','Saint Thomas',10529.0,-64.94,18.35).
city('Charlotte Amalie East','vi','Saint Thomas',2672.0,-64.91,18.34).
city('Charlotte Amalie West','vi','Saint Thomas',5023.0,-64.96,18.34).
city('Kolia','wf','Alo',437.0,-178.08,-14.32).
city('Vele','wf','Alo',309.0,-178.07,-14.32).
city('Ahoa','wf','Hahake',495.0,-176.2,-13.28).
city('Akaaka','wf','Hahake',589.0,-176.14,-13.27).
city('Falaleu','wf','Hahake',659.0,-176.16,-13.3).
city('Haafuasia','wf','Hahake',426.0,-176.15,-13.3).
city('Liku','wf','Hahake',696.0,-176.13,-13.27).
city('Matautu','wf','Hahake',1295.0,-176.13,-13.28).
city('Alele','wf','Hih',901.0,-176.16,-13.23).
city('Vailala','wf','Hihifo',451.0,-176.15,-13.22).
city('Vaitupu','wf','Hihifo',601.0,-176.15,-13.23).
city('Gahi','wf','Mua',280.0,-176.15,-13.34).
city('Haatofo','wf','Mua',236.0,-176.15,-13.33).
city('Halalo','wf','Mua',635.0,-176.18,-13.35).
city('Kolopopo','wf','Mua',171.0,-176.17,-13.35).
city('Teesi','wf','Mua',284.0,-176.17,-13.34).
city('Tepa','wf','Mua',244.0,-176.15,-13.32).
city('Vaimalau','wf','Mua',567.0,-176.2,-13.32).
city('Leava','wf','Sigave',480.0,-178.17,-14.3).
city('Tavai','wf','Sigave',244.0,-178.17,-14.23).
city('Bu Jaydur','eh','Bu Jaydur',21443.0,-14.48,26.13).
city('ad-Dahzlah','eh','Wad-ad-Dahab',35826.0,-15.93,23.71).
city('al-Ayun','eh','al-Ayun',195700.0,-13.2,27.16).
city('as-Samarah','eh','as-Samarah',41314.0,-11.67,26.74).
city('Ahwar','ye','Abyan',5352.0,46.7,13.52).
city('Jaar','ye','Abyan',59848.0,45.31,13.22).
city('Aden','ye','Aden',550744.0,45.03,12.79).
city('Sana','ye','Amanah al-Asmah',1937451.0,44.21,15.38).
city('Damar','ye','Damar',158995.0,44.39,14.56).
city('al-Mukalla','ye','Hadramaut',258428.0,49.13,14.54).
city('as-Sahir','ye','Hadramaut',57745.0,49.61,14.76).
city('Hajjah','ye','Hajjah',43552.0,43.6,15.69).
city('Di Sufal','ye','Ibb',37996.0,44.12,13.85).
city('Ibb','ye','Ibb',234992.0,44.18,13.97).
city('Jiblah','ye','Ibb',9627.0,44.15,13.91).
city('Yarim','ye','Ibb',33049.0,44.38,14.3).
city('Lahij','ye','Lahij',23377.0,44.88,13.06).
city('Marib','ye','Marib',13389.0,45.33,15.42).
city('Ataq','ye','Sabwah',2568.0,46.88,14.55).
city('Habban','ye','Sabwah',18999.0,47.08,14.35).
city('Sadah','ye','Sadah',8356.0,43.76,16.94).
city('Amran','ye','Sana',33537.0,43.94,15.66).
city('Sahar','ye','Sana',31862.0,44.3,15.32).
city('Sayyan','ye','Sana',69402.0,44.33,15.17).
city('Taizz','ye','Taizz',615467.0,44.04,13.6).
city('al-Muhza','ye','Taizz',8379.0,43.24,13.32).
city('Rayda','ye','al-Bayda',46631.0,44.84,14.43).
city('al-Bayda','ye','al-Bayda',37847.0,45.57,13.98).
city('Bajil','ye','al-Hudaydah',48217.0,43.28,15.06).
city('Bayt-al-Faqih','ye','al-Hudaydah',34204.0,43.32,14.52).
city('Zabid','ye','al-Hudaydah',52589.0,43.32,14.22).
city('al-Hudaydah','ye','al-Hudaydah',617888.0,42.95,14.8).
city('al-Marawiah','ye','al-Hudaydah',36261.0,43.15,14.84).
city('az-Zaydiyah','ye','al-Hudaydah',9627.0,43.01,15.33).
city('al-Hazm','ye','al-Jawf',14195.0,45.83,13.84).
city('al-Gaydah','ye','al-Mahrah',2676.0,52.15,16.22).
city('al-Mahwit','ye','al-Mahwit',13087.0,43.57,15.49).
city('Chibombo','zm','Central',4477.0,28.07,-14.66).
city('Kabwe','zm','Central',189006.0,28.45,-14.44).
city('Kapiri Mposhi','zm','Central',37948.0,28.66,-13.97).
city('Mkushi','zm','Central',12308.0,29.39,-13.61).
city('Mumbwa','zm','Central',19090.0,27.07,-14.98).
city('Serenje','zm','Central',8780.0,30.24,-13.22).
city('Chambishi','zm','Copperbelt',11073.0,28.08,-12.67).
city('Chililabombwe','zm','Copperbelt',57335.0,27.82,-12.37).
city('Chingola','zm','Copperbelt',148583.0,27.85,-12.54).
city('Kalulushi','zm','Copperbelt',66583.0,28.09,-12.84).
city('Kitwe','zm','Copperbelt',400955.0,28.22,-12.81).
city('Luanshya','zm','Copperbelt',113379.0,28.39,-13.12).
city('Mpongwe','zm','Copperbelt',8997.0,28.16,-13.51).
city('Mufulira','zm','Copperbelt',120516.0,28.26,-12.55).
city('Ndola','zm','Copperbelt',394559.0,28.64,-12.97).
city('Chadiza','zm','Eastern',3690.0,32.43,-14.07).
city('Chama','zm','Eastern',4061.0,33.14,-11.22).
city('Chipata','zm','Eastern',85973.0,32.64,-13.63).
city('Katete','zm','Eastern',12507.0,32.06,-14.08).
city('Lundazi','zm','Eastern',11637.0,33.17,-12.29).
city('Nyimba','zm','Eastern',1336.0,30.81,-14.55).
city('Petauke','zm','Eastern',19299.0,31.33,-14.25).
city('Kawambwa','zm','Luapala',20589.0,29.08,-9.78).
city('Mansa','zm','Luapala',42280.0,28.89,-11.2).
city('Mwanzakombe','zm','Luapala',11628.0,29.66,-10.87).
city('Mwense','zm','Luapala',4378.0,28.68,-10.38).
city('Nchelenge','zm','Luapala',23695.0,28.73,-9.35).
city('Samfya','zm','Luapala',20472.0,29.54,-11.34).
city('Chilanga','zm','Lusaka',11412.0,28.28,-15.57).
city('Chongwe','zm','Lusaka',6057.0,28.7,-15.35).
city('Kafue','zm','Lusaka',47558.0,28.18,-15.78).
city('Luangwa','zm','Lusaka',3065.0,30.41,-15.62).
city('Lusaka','zm','Lusaka',1267458.0,28.29,-15.42).
city('Kabompo','zm','North-Western',6592.0,24.2,-13.6).
city('Kalengwa','zm','North-Western',7574.0,25.0,-13.47).
city('Kansanshi','zm','North-Western',40711.0,26.42,-12.1).
city('Kasempa','zm','North-Western',5622.0,25.82,-13.46).
city('Mufumbwe','zm','North-Western',6155.0,24.8,-13.68).
city('Mwinilunga','zm','North-Western',13800.0,24.44,-11.74).
city('Solwezi','zm','North-Western',4846.0,26.4,-12.18).
city('Zambezi','zm','North-Western',7075.0,23.11,-13.54).
city('Chilubi','zm','Northern',4043.0,31.23,-10.38).
city('Chinsali','zm','Northern',14016.0,32.06,-10.55).
city('Isoka','zm','Northern',13123.0,32.64,-10.13).
city('Kaputa','zm','Northern',2683.0,29.67,-8.48).
city('Kasama','zm','Northern',91063.0,31.18,-10.2).
city('Luwingu','zm','Northern',6161.0,29.89,-10.26).
city('Mbala','zm','Northern',20572.0,31.37,-8.84).
city('Mpika','zm','Northern',28448.0,31.46,-11.83).
city('Mporokoso','zm','Northern',3401.0,30.11,-9.39).
city('Mpulungu','zm','Northern',8547.0,31.11,-8.76).
city('Mungwi','zm','Northern',6821.0,31.38,-10.17).
city('Nakonde','zm','Northern',10652.0,32.77,-9.33).
city('Choma','zm','Southern',46751.0,26.97,-16.81).
city('Gwembe','zm','Southern',2052.0,27.62,-16.5).
city('Itezhi-Tezhi','zm','Southern',7987.0,26.06,-15.69).
city('Kalomo','zm','Southern',12485.0,26.48,-17.03).
city('Livingstone','zm','Southern',109218.0,25.86,-17.86).
city('Maamba','zm','Southern',12251.0,27.15,-17.37).
city('Mazabuka','zm','Southern',64014.0,27.76,-15.86).
city('Monze','zm','Southern',30261.0,27.48,-16.28).
city('Nakambala','zm','Southern',10425.0,27.77,-15.83).
city('Namwala','zm','Southern',4450.0,26.44,-15.74).
city('Siavonga','zm','Southern',18651.0,28.72,-16.53).
city('Sinazongwe','zm','Southern',11528.0,27.47,-17.25).
city('Kalabo','zm','Western',7732.0,22.68,-14.99).
city('Kaoma','zm','Western',14214.0,24.8,-14.78).
city('Limulunga','zm','Western',7461.0,23.15,-15.1).
city('Lukulu','zm','Western',3349.0,23.24,-14.39).
city('Mongu','zm','Western',52539.0,23.12,-15.28).
city('Senanga','zm','Western',10006.0,23.27,-16.12).
city('Sesheke','zm','Western',20162.0,24.3,-17.47).
city('Shangombo','zm','Western',1789.0,22.28,-14.53).
city('Bulawayo','zw','Bulawayo',897249.0,28.58,-20.17).
city('Chitungwiza','zw','Harare',456206.0,31.1,-18.0).
city('Harare','zw','Harare',2213701.0,31.05,-17.82).
city('Chipinge','zw','Manicaland',11278.0,32.62,-20.2).
city('Mutare','zw','Manicaland',253449.0,32.65,-18.97).
city('Rusape','zw','Manicaland',23761.0,32.12,-18.53).
city('Bindura','zw','Mashonaland Central',22497.0,31.32,-17.31).
city('Mount Darwin','zw','Mashonaland Central',11963.0,31.58,-16.77).
city('Marondera','zw','Mashonaland East',82294.0,31.55,-18.19).
city('Mutoko','zw','Mashonaland East',11380.0,32.21,-17.4).
city('Chegutu','zw','Mashonaland West',45538.0,30.14,-18.13).
city('Chinhoyi','zw','Mashonaland West',77007.0,30.18,-17.36).
city('Kadoma','zw','Mashonaland West',100276.0,29.91,-18.33).
city('Kariba','zw','Mashonaland West',34797.0,28.8,-16.53).
city('Karoi','zw','Mashonaland West',24981.0,29.68,-16.82).
city('Norton','zw','Mashonaland West',19519.0,30.68,-17.88).
city('Chiredzi','zw','Masvingo',13030.0,31.66,-21.05).
city('Masvingo','zw','Masvingo',86772.0,30.82,-20.06).
city('Hwange','zw','Matabeleland North',41632.0,26.5,-18.37).
city('Victoria Falls','zw','Matabeleland North',36702.0,25.84,-17.93).
city('Beitbridge','zw','Matabeleland South',11865.0,29.99,-22.21).
city('Gwanda','zw','Matabeleland South',20731.0,29.01,-20.94).
city('Gweru','zw','Midlands',201879.0,29.82,-19.45).
city('Kwekwe','zw','Midlands',116332.0,29.8,-18.93).
city('Mvuma','zw','Midlands',6498.0,30.52,-19.29).
city('Redcliffe','zw','Midlands',38231.0,29.77,-19.03).
city('Shurugwi','zw','Midlands',17107.0,30.0,-19.66).
city('Zvishavane','zw','Midlands',79876.0,30.05,-20.33).
city('Ramallah','ps','Gaza Strip',48000.0,0.0,0.0).
city('Victoria','cn','Hong Kong',0.0,0.0,0.0).
province('Andreas','im',1113.0,28.2,0.0,0.0).
province('Arbory','im',1635.0,16.8,0.0,0.0).
province('Ballaugh','im',832.0,27.0,0.0,0.0).
province('Braddan','im',3310.0,41.3,0.0,0.0).
province('Bride','im',390.0,22.4,0.0,0.0).
province('Castletown','im',2680.0,2.3,0.0,0.0).
province('Douglas','im',25422.0,6.8,0.0,0.0).
province('German','im',1019.0,46.2,0.0,0.0).
province('Jurby','im',571.0,18.1,0.0,0.0).
province('Laxey','im',1524.0,2.0,0.0,0.0).
province('Lezrayre','im',652.0,60.0,0.0,0.0).
province('Lonan','im',1380.0,32.6,0.0,0.0).
province('Malew','im',2044.0,47.5,0.0,0.0).
province('Marown','im',1651.0,26.7,0.0,0.0).
province('Maughold','im',905.0,33.9,0.0,0.0).
province('Michael','im',1342.0,35.4,0.0,0.0).
province('Onchan','im',8871.0,26.4,0.0,0.0).
province('Patrick','im',1230.0,45.5,0.0,0.0).
province('Peel','im',3765.0,1.4,0.0,0.0).
province('Port Erin','im',3473.0,1.8,0.0,0.0).
province('Port Saint Mary','im',2051.0,1.7,0.0,0.0).
province('Ramsey','im',7526.0,4.2,0.0,0.0).
province('Rushen','im',1430.0,27.3,0.0,0.0).
province('Santon','im',318.0,16.5,0.0,0.0).
province('Hadarom','il',1031112.0,14231.0,0.0,0.0).
province('Haifa','il',872602.0,863.0,'Haifa','Haifa').
province('Hamerkaz','il',1673068.0,1276.0,0.0,0.0).
province('Hazzafon','il',1197992.0,3324.0,0.0,0.0).
province('Jerusalem','il',838130.0,652.0,'Jerusalem','Jerusalem').
province('Judea and Samaria','il',244882.0,5878.0,0.0,0.0).
province('Tel Aviv','il',1128853.0,171.0,0.0,0.0).
province('Abruzzes','it',1321842.0,10795.0,0.0,0.0).
province('Apulia','it',4021956.0,19362.0,0.0,0.0).
province('Basilicata','it',582337.0,9992.0,0.0,0.0).
province('Calabria','it',1988189.0,15080.0,0.0,0.0).
province('Campania','it',5766975.0,13595.0,0.0,0.0).
province('Emilia-Romagna','it',4115321.0,22123.0,0.0,0.0).
province('Friuli-Venezia Giulia','it',1188675.0,7844.0,0.0,0.0).
province('Lazio','it',5501631.0,17227.0,0.0,0.0).
province('Liguria','it',1557777.0,5420.0,0.0,0.0).
province('Lombardy','it',9387203.0,23872.0,0.0,0.0).
province('Marche','it',1501400.0,9694.0,0.0,0.0).
province('Molise','it',324508.0,4438.0,0.0,0.0).
province('Piemonte','it',4294082.0,25399.0,0.0,0.0).
province('Sardegna','it',1701343.0,24090.0,0.0,0.0).
province('Sicily','it',5135871.0,25708.0,0.0,0.0).
province('Toscana','it',3573454.0,22993.0,0.0,0.0).
province('Trentino-Alto Adige','it',961847.0,13607.0,0.0,0.0).
province('Umbria','it',864496.0,8456.0,0.0,0.0).
province('Valle dAosta','it',121882.0,3264.0,0.0,0.0).
province('Veneto','it',4697776.0,18364.0,0.0,0.0).
province('Agneby','ci',777843.0,9080.0,0.0,0.0).
province('Bafing','ci',192532.0,8720.0,'Touba','Bafing').
province('Bas Sassandra','ci',1137330.0,25800.0,0.0,0.0).
province('Denguele','ci',298852.0,20600.0,'Odienne','Denguele').
province('Dix-huit Montagnes','ci',1214771.0,16600.0,0.0,0.0).
province('Fromager','ci',733634.0,6900.0,'Gagnoa','Fromager').
province('Haut-Sassandra','ci',1280369.0,15200.0,'Daloa','Haut-Sassandra').
province('Lacs','ci',644721.0,8920.0,'Yamoussoukro','Lacs').
province('Lagunes','ci',4542761.0,13172.0,'Abidjan','Lagunes').
province('Marahoue','ci',703167.0,8500.0,'Bouafle','Marahoue').
province('Moyen-Cavally','ci',478195.0,14150.0,'Guiglo','Moyen-Cavally').
province('Moyen-Comoe','ci',526780.0,6900.0,'Abengourou','Moyen-Comoe').
province('Nzi-Comoe','ci',981689.0,19560.0,'Dimbokro','Nzi-Comoe').
province('Savanes','ci',1311022.0,40323.0,'Korhogo','Savanes').
province('Sud-Bandama','ci',891580.0,10650.0,'Divo','Sud-Bandama').
province('Sud-Comoe','ci',578829.0,7278.0,'Aboisso','Sud-Comoe').
province('Vallee du Bandama','ci',1440957.0,28530.0,'Bouake','Vallee du Bandama').
province('Worodougou','ci',431863.0,21900.0,'Seguela','Worodougou').
province('Zanzan','ci',905238.0,38000.0,'Bondoukou','Zanzan').
province('Clarendon','jm',243857.0,1196.0,'May Pen','Clarendon').
province('Hanover','jm',66602.0,450.0,'Lucea','Hanover').
province('Kingston','jm',90822.0,22.0,'Kingston','Kingston').
province('Manchester','jm',191796.0,830.0,'Mandeville','Manchester').
province('Portland','jm',80787.0,814.0,'Port Antonio','Portland').
province('Saint Andrew','jm',555994.0,431.0,0.0,0.0).
province('Saint Ann','jm',171740.0,1213.0,0.0,0.0).
province('Saint Catherine','jm',529215.0,1192.0,0.0,0.0).
province('Saint Elizabeth','jm',145409.0,1212.0,0.0,0.0).
province('Saint James','jm',180499.0,595.0,0.0,0.0).
province('Saint Mary','jm',111378.0,611.0,0.0,0.0).
province('Saint Thomas','jm',93328.0,743.0,0.0,0.0).
province('Trelawney','jm',72684.0,875.0,0.0,0.0).
province('Westmoreland','jm',141393.0,807.0,0.0,0.0).
province('Aichi','jp',7233225.0,5155.84,0.0,0.0).
province('Akita','jp',1154125.0,11612.11,0.0,0.0).
province('Aomori','jp',1454514.0,9606.33,0.0,0.0).
province('Chiba','jp',6093374.0,5156.19,0.0,0.0).
province('Ehime','jp',1476750.0,5676.22,0.0,0.0).
province('Fukui','jp',826319.0,4188.75,0.0,0.0).
province('Fukuoka','jp',5077936.0,4971.01,0.0,0.0).
province('Fukushima','jp',2106858.0,13782.48,0.0,0.0).
province('Gifu','jp',2114352.0,10598.18,0.0,0.0).
province('Gumma','jp',2041366.0,6363.16,0.0,0.0).
province('Hiroshima','jp',2878399.0,8476.95,0.0,0.0).
province('Hokkaido','jp',5647230.0,83453.04,'Sapporo','Hokkaido').
province('Hyogo','jp',5612902.0,8392.03,0.0,0.0).
province('Ibaraki','jp',3000459.0,6095.58,0.0,0.0).
province('Ishikawa','jp',1180086.0,4185.22,0.0,0.0).
province('Iwate','jp',1394774.0,15278.4,0.0,0.0).
province('Kagawa','jp',1018355.0,1875.88,0.0,0.0).
province('Kagoshima','jp',1768647.0,9186.71,0.0,0.0).
province('Kanagawa','jp',8815379.0,2415.41,0.0,0.0).
province('Kochi','jp',803045.0,7104.66,0.0,0.0).
province('Kumamoto','jp',1853329.0,7403.68,0.0,0.0).
province('Kyoto','jp',2641108.0,4612.94,0.0,0.0).
province('Mie','jp',1867147.0,5776.4,0.0,0.0).
province('Miyagi','jp',2382349.0,7285.07,0.0,0.0).
province('Miyazaki','jp',1160753.0,7734.4,0.0,0.0).
province('Nagano','jp',2217459.0,13585.22,0.0,0.0).
province('Nagasaki','jp',1490715.0,4092.44,0.0,0.0).
province('Nara','jp',1436252.0,3691.09,0.0,0.0).
province('Niigata','jp',2451693.0,12582.37,0.0,0.0).
province('Oita','jp',1215376.0,6337.97,0.0,0.0).
province('Okayama','jp',1954636.0,7112.13,0.0,0.0).
province('Okinawa','jp',1369253.0,2271.3,0.0,0.0).
province('Osaka','jp',8823297.0,1892.86,0.0,0.0).
province('Saga','jp',869322.0,2439.23,0.0,0.0).
province('Saitama','jp',7103795.0,3797.3,0.0,0.0).
province('Shiga','jp',1384102.0,4017.36,0.0,0.0).
province('Shimane','jp',747838.0,6707.29,0.0,0.0).
province('Shizuoka','jp',3810136.0,7779.46,0.0,0.0).
province('Tochigi','jp',2017549.0,6408.28,0.0,0.0).
province('Tokushima','jp',812960.0,4145.1,0.0,0.0).
province('Tokyo','jp',1.2445324E7,2186.9,0.0,0.0).
province('Tottori','jp',609729.0,3507.17,0.0,0.0).
province('Toyama','jp',1114986.0,4247.22,0.0,0.0).
province('Wakayama','jp',1048462.0,4725.55,0.0,0.0).
province('Yamagata','jp',1222288.0,9323.34,0.0,0.0).
province('Yamaguchi','jp',1501651.0,6110.45,0.0,0.0).
province('Yamanashi','jp',887881.0,4465.37,0.0,0.0).
province('Grouville','je',4771.0,7.8,0.0,0.0).
province('Saint Brelade','je',10569.0,12.8,0.0,0.0).
province('Saint Clement','je',8406.0,4.2,0.0,0.0).
province('Saint Helier','je',28789.0,8.6,0.0,0.0).
province('Saint John','je',2695.0,8.7,0.0,0.0).
province('Saint Lawrence','je',4675.0,9.5,0.0,0.0).
province('Saint Martin','je',3793.0,9.9,0.0,0.0).
province('Saint Mary','je',1678.0,6.5,0.0,0.0).
province('Saint Ouen','je',3893.0,14.9,0.0,0.0).
province('Saint Peter','je',433.0,11.6,0.0,0.0).
province('Saint Saviour','je',12352.0,9.3,0.0,0.0).
province('Trinity','je',2772.0,12.3,0.0,0.0).
province('Ajlun','jo',127618.0,412.0,0.0,0.0).
province('al-Aqabah','jo',117810.0,6583.0,0.0,0.0).
province('al-Balqa','jo',378046.0,1076.0,0.0,0.0).
province('al-Karak','jo',231466.0,3217.0,0.0,0.0).
province('al-Mafraq','jo',271823.0,26435.0,0.0,0.0).
province('Amman','jo',2201199.0,8231.0,0.0,0.0).
province('at-Tafilah','jo',88035.0,2114.0,0.0,0.0).
province('az-Zarqa','jo',915225.0,4080.0,0.0,0.0).
province('Irbid','jo',1027457.0,1621.0,0.0,0.0).
province('Jaras','jo',169585.0,402.0,0.0,0.0).
province('Maan','jo',113140.0,33163.0,0.0,0.0).
province('Madaba','jo',146936.0,2008.0,0.0,0.0).
province('Akmechet','kz',633092.0,226000.0,0.0,0.0).
province('Almaty','kz',2714956.0,224200.0,'Almaty','Almaty').
province('Aqmola','kz',1203269.0,92000.0,'Astana','Aqmola').
province('Aqtoebe','kz',678937.0,300600.0,0.0,0.0).
province('Atyrau','kz',455504.0,118600.0,'Atyrau','Atyrau').
province('Batis Kazakstan','kz',634011.0,151300.0,0.0,0.0).
province('Mankistau','kz',331874.0,156600.0,0.0,0.0).
province('Ontuestik Kazakstan','kz',2141913.0,117300.0,0.0,0.0).
province('Pavlodar','kz',765779.0,124800.0,'Pavlodar','Pavlodar').
province('Qaragandy','kz',1257280.0,428000.0,0.0,0.0).
province('Qostanay','kz',911820.0,225700.0,'Qostanay','Qostanay').
province('Sigis Kazakstan','kz',1464264.0,283300.0,0.0,0.0).
province('Soltuestik Kazakstan','kz',579035.0,123200.0,0.0,0.0).
province('Taraz','kz',986033.0,144300.0,0.0,0.0).
province('Central','ke',4050444.0,13236.0,'Nyeri','Central').
province('Coast','ke',2894459.0,84113.0,'Mombasa','Coast').
province('Eastern','ke',5125537.0,154354.0,'Embu','Eastern').
province('Nairobi','ke',2750561.0,693.0,'Nairobi','Nairobi').
province('North Eastern','ke',1506014.0,126186.0,0.0,0.0).
province('Nyanza','ke',4891303.0,12507.0,'Kisumu','Nyanza').
province('Rift Valley','ke',8319245.0,182413.0,'Nakuru','Rift Valley').
province('Western','ke',3855845.0,8285.0,'Kakamega','Western').
province('Abaiang','ki',5651.0,16.0,0.0,0.0).
province('Abemana','ki',2894.0,27.8,0.0,0.0).
province('Aranuka','ki',910.0,15.5,0.0,0.0).
province('Arorae','ki',1174.0,9.5,0.0,0.0).
province('Banaba','ki',266.0,6.3,0.0,0.0).
province('Beru','ki',2623.0,14.7,0.0,0.0).
province('Butaritari','ki',3094.0,13.6,0.0,0.0).
province('Kiritimati','ki',3710.0,363.4,0.0,0.0).
province('Kuria','ki',927.0,12.3,0.0,0.0).
province('Maiana','ki',1904.0,15.9,0.0,0.0).
province('Makin','ki',1561.0,6.7,0.0,0.0).
province('Marakei','ki',2344.0,13.5,0.0,0.0).
province('Nikunau','ki',1541.0,18.2,0.0,0.0).
province('Nonouti','ki',3247.0,29.2,0.0,0.0).
province('Onotoa','ki',1444.0,13.5,0.0,0.0).
province('Phoenix Islands','ki',53.0,28.7,0.0,0.0).
province('Southern Line Islands','ki',0.0,103.4,0.0,0.0).
province('Tabiteuea North','ki',3305.0,26.0,0.0,0.0).
province('Tabiteuea South','ki',1071.0,12.0,0.0,0.0).
province('Tabuaeran','ki',1987.0,14.2,0.0,0.0).
province('Tamana','ki',803.0,4.8,0.0,0.0).
province('Tarawa North','ki',4879.0,15.9,0.0,0.0).
province('Tarawa South','ki',44428.0,16.0,0.0,0.0).
province('Teraina','ki',1201.0,34.6,0.0,0.0).
province('Chagangdo','kp',1509375.0,16968.0,0.0,0.0).
province('Hamgyongbukto','kp',2615293.0,17570.0,0.0,0.0).
province('Hamgyongnamdo','kp',3325586.0,18970.0,0.0,0.0).
province('Hwanghaebukto','kp',1839714.0,8007.0,0.0,0.0).
province('Hwanghaenamdo','kp',2499086.0,8002.0,0.0,0.0).
province('Kaesong','kp',432183.0,1255.0,0.0,0.0).
province('Kangwon','kp',1602079.0,11152.0,0.0,0.0).
province('Nampo','kp',933567.0,753.0,0.0,0.0).
province('Pyonganbukto','kp',3144096.0,12191.0,0.0,0.0).
province('Pyongannamdo','kp',3463989.0,11577.0,0.0,0.0).
province('Pyongyang','kp',3074895.0,2000.0,0.0,0.0).
province('Yanggang','kp',819972.0,14317.0,0.0,0.0).
province('Cheju','kr',566020.0,1845.36,0.0,0.0).
province('Chollabuk','kr',1976851.0,8058.03,0.0,0.0).
province('Chollanam','kr',1992192.0,11911.3,0.0,0.0).
province('Chungchongbuk','kr',1508979.0,7433.36,0.0,0.0).
province('Chungchongnam','kr',1962435.0,8546.86,0.0,0.0).
province('Inchon','kr',2654790.0,955.0,0.0,0.0).
province('Kangwon','kr',1532342.0,16534.3,0.0,0.0).
province('Kwangju','kr',1416937.0,501.28,0.0,0.0).
province('Kyonggi','kr',1.1202749E7,10114.55,0.0,0.0).
province('Kyongsangbuk','kr',2708785.0,19021.86,0.0,0.0).
province('Kyongsangnam','kr',3231791.0,10510.68,0.0,0.0).
province('Pusan','kr',3678551.0,748.92,0.0,0.0).
province('Soul','kr',1.0349291E7,605.78,0.0,0.0).
province('Taegu','kr',2566537.0,885.51,0.0,0.0).
province('Taejon','kr',1475220.0,539.87,0.0,0.0).
province('Ulsan','kr',1105823.0,1055.7,0.0,0.0).
province('al-Ahmadi','kw',430846.0,5120.0,0.0,0.0).
province('al-Asamah','kw',449515.0,200.0,0.0,0.0).
province('al-Farwaniyah','kw',640259.0,190.0,0.0,0.0).
province('al-Jahra','kw',307263.0,12130.0,0.0,0.0).
province('Hawalli','kw',510780.0,84.0,0.0,0.0).
province('Mubarak al-Kabir','kw',191349.0,94.0,0.0,0.0).
province('Batken','kg',400370.0,17000.0,'Batken','Batken').
province('Biskek','kg',896258.0,100.0,0.0,0.0).
province('Celalabad','kg',962227.0,33700.0,0.0,0.0).
province('Cuy','kg',818019.0,20200.0,0.0,0.0).
province('Issik-Goel','kg',450722.0,43100.0,0.0,0.0).
province('Narin','kg',269652.0,45200.0,0.0,0.0).
province('Os','kg',1299450.0,29200.0,0.0,0.0).
province('Talas','kg',216053.0,11400.0,'Talas','Talas').
province('Attopu','la',102959.0,10320.0,0.0,0.0).
province('Bokeo','la',150130.0,6196.0,0.0,0.0).
province('Bolikhamsay','la',204242.0,14863.0,0.0,0.0).
province('Champasak','la',584234.0,15415.0,0.0,0.0).
province('Houaphanh','la',286259.0,16500.0,0.0,0.0).
province('Khammouane','la',318909.0,16315.0,0.0,0.0).
province('Luang Nam Tha','la',118249.0,9325.0,0.0,0.0).
province('Luang Prabang','la',386994.0,16875.0,0.0,0.0).
province('Oudomxay','la',283957.0,15370.0,0.0,0.0).
province('Phongsaly','la',163371.0,16270.0,0.0,0.0).
province('Saravan','la',319084.0,10691.0,0.0,0.0).
province('Savannakhet','la',769162.0,21774.0,'Savannakhet','Savannakhet').
province('Sekong','la',80848.0,7665.0,0.0,0.0).
province('Viangchan Prefecture','la',646522.0,3920.0,'Vientiane','Viangchan Prefecture').
province('Viangchan Province','la',309545.0,15927.0,0.0,0.0).
province('Xaignabury','la',600838.0,16389.0,0.0,0.0).
province('Xaisombun','la',62014.0,7105.0,0.0,0.0).
province('Xiang Khuang','la',224957.0,15880.0,0.0,0.0).
province('Aizkraukles','lv',40690.0,2505.0,0.0,0.0).
province('Aluksnes','lv',25667.0,2202.0,0.0,0.0).
province('Balvu','lv',29780.0,2398.0,0.0,0.0).
province('Bauskas','lv',51666.0,1854.0,0.0,0.0).
province('Cesu','lv',58890.0,3039.0,0.0,0.0).
province('Daugavpils','lv',41528.0,2574.0,0.0,0.0).
province('Daugavpils pilseta','lv',111564.0,75.0,0.0,0.0).
province('Dobeles','lv',39130.0,1657.0,0.0,0.0).
province('Gulbenes','lv',27424.0,1890.0,0.0,0.0).
province('Jekabspils','lv',54856.0,2926.0,0.0,0.0).
province('Jelgava','lv',61793.0,60.0,0.0,0.0).
province('Jelgavas','lv',36054.0,1631.0,0.0,0.0).
province('Jurmala pilseta','lv',54088.0,100.0,0.0,0.0).
province('Kraslavas','lv',35778.0,2279.0,0.0,0.0).
province('Kuldigas','lv',37112.0,2433.0,0.0,0.0).
province('Liepaja','lv',85263.0,60.0,0.0,0.0).
province('Liepajas','lv',45519.0,3632.0,0.0,0.0).
province('Limbazu','lv',39018.0,2590.0,0.0,0.0).
province('Ludzas','lv',34113.0,2609.0,0.0,0.0).
province('Madonas','lv',45093.0,3330.0,0.0,0.0).
province('Ogres','lv',61120.0,1834.0,0.0,0.0).
province('Preilu','lv',40536.0,2061.0,0.0,0.0).
province('Rezekne','lv',38340.0,17.0,0.0,0.0).
province('Rezeknes','lv',41710.0,2681.0,0.0,0.0).
province('Riga','lv',742594.0,307.0,0.0,0.0).
province('Rigas','lv',139676.0,3041.0,0.0,0.0).
province('Saldus','lv',37891.0,2118.0,0.0,0.0).
province('Talsu','lv',48424.0,2811.0,0.0,0.0).
province('Tukuma','lv',52357.0,2461.0,0.0,0.0).
province('Valkas','lv',33348.0,2475.0,0.0,0.0).
province('Valmieras','lv',58629.0,2336.0,0.0,0.0).
province('Ventspils','lv',14195.0,2567.0,0.0,0.0).
province('Ventspils pilseta','lv',42643.0,45.0,0.0,0.0).
province('al-Biqaa','lb',601079.0,4160.9,0.0,0.0).
province('al-Janub','lb',526056.0,929.6,0.0,0.0).
province('an-Nabatiyah','lb',306861.0,1098.0,0.0,0.0).
province('as-Samal','lb',899339.0,2024.8,0.0,0.0).
province('Bayrut','lb',449440.0,19.6,0.0,0.0).
province('Jabal Lubnan','lb',1679220.0,1968.3,0.0,0.0).
province('Berea','ls',173874.0,2222.0,'Teyateyaneng','Berea').
province('Butha-Buthe','ls',157160.0,1767.0,0.0,0.0).
province('Leribe','ls',408807.0,2828.0,'Hlotse','Leribe').
province('Mafeteng','ls',294046.0,2119.0,'Mafeteng','Mafeteng').
province('Maseru','ls',437019.0,4279.0,'Maseru','Maseru').
province('Mohales Hoek','ls',284584.0,3530.0,'Mohales Hoek','Mohales Hoek').
province('Mokhotlong','ls',116066.0,4075.0,'Mokhotlong','Mokhotlong').
province('Qachas Nek','ls',101797.0,2349.0,'Qachas Nek','Qachas Nek').
province('Quthing','ls',181527.0,2916.0,'Quthing','Quthing').
province('Thaba-Tseka','ls',152257.0,4270.0,'Thaba-Tseka','Thaba-Tseka').
province('Bomi','lr',84278.0,1955.0,'Tubmanburg','Bomi').
province('Bong','lr',344650.0,8099.0,'Gbarnga','Bong').
province('Grand Bassa','lr',218298.0,8759.0,'Buchanan','Grand Bassa').
province('Grand Cape Mount','lr',114515.0,5827.0,0.0,0.0).
province('Grand Gedeh','lr',148602.0,17029.0,'Zwedru','Grand Gedeh').
province('Loffa','lr',339951.0,19360.0,0.0,0.0).
province('Margibi','lr',142200.0,3263.0,0.0,0.0).
province('Maryland and Grand Kru','lr',180061.0,5351.0,0.0,0.0).
province('Montserrado','lr',948107.0,2740.0,'Bensonville','Montserrado').
province('Nimba','lr',407421.0,12043.0,0.0,0.0).
province('Rivercess','lr',54436.0,4385.0,0.0,0.0).
province('Sinoe','lr',83075.0,10254.0,0.0,0.0).
province('Ajdabiya','ly',181454.0,91620.0,0.0,0.0).
province('al-Butnan','ly',161199.0,83860.0,0.0,0.0).
province('al-Hizam al-Ahzdar','ly',113914.0,12800.0,0.0,0.0).
province('al-Jabal al-Ahdar','ly',203501.0,7800.0,0.0,0.0).
province('al-Jifarah','ly',304810.0,1940.0,0.0,0.0).
province('al-Jufrah','ly',47538.0,117410.0,0.0,0.0).
province('al-Kufrah','ly',55690.0,483510.0,0.0,0.0).
province('al-Marj','ly',121289.0,10000.0,0.0,0.0).
province('al-Marqab','ly',345925.0,3000.0,0.0,0.0).
province('al-Qubbah','ly',97886.0,14722.0,0.0,0.0).
province('al-Wahat','ly',30891.0,108670.0,0.0,0.0).
province('an-Nuqat al-Hums','ly',218275.0,5250.0,0.0,0.0).
province('az-Zawiyah','ly',206119.0,1520.0,0.0,0.0).
province('Bangazi','ly',667175.0,800.0,0.0,0.0).
province('Bani Walid','ly',82385.0,19710.0,0.0,0.0).
province('Darnah','ly',83491.0,4908.0,0.0,0.0).
province('Gadamis','ly',19794.0,51750.0,0.0,0.0).
province('Garyan','ly',168885.0,4660.0,0.0,0.0).
province('Gat','ly',24347.0,72700.0,0.0,0.0).
province('Marzuq','ly',72499.0,349790.0,0.0,0.0).
province('Misratah','ly',399711.0,2770.0,0.0,0.0).
province('Mizdah','ly',44445.0,72180.0,0.0,0.0).
province('Nalut','ly',93848.0,15300.0,0.0,0.0).
province('Sabha','ly',134498.0,15330.0,0.0,0.0).
province('Sabratah wa Surman','ly',158258.0,1370.0,0.0,0.0).
province('Surt','ly',170763.0,77660.0,0.0,0.0).
province('Tarhunah wa Masallatah','ly',311082.0,5840.0,0.0,0.0).
province('Tripoli','ly',1178568.0,1830.0,0.0,0.0).
province('Wadi al-Hayat','ly',77839.0,31890.0,0.0,0.0).
province('Wadi as-Sati','ly',81078.0,97160.0,0.0,0.0).
province('Yafran wa Jadu','ly',123536.0,9310.0,0.0,0.0).
province('Balzers','li',4447.0,19.62,0.0,0.0).
province('Eschen','li',4008.0,10.33,0.0,0.0).
province('Gamprin','li',1268.0,6.14,0.0,0.0).
province('Mauren','li',3626.0,7.45,0.0,0.0).
province('Planken','li',377.0,5.3,0.0,0.0).
province('Ruggell','li',1862.0,7.37,0.0,0.0).
province('Schaan','li',5748.0,26.85,0.0,0.0).
province('Schellenberg','li',1004.0,3.55,0.0,0.0).
province('Triesen','li',4701.0,26.35,0.0,0.0).
province('Triesenberg','li',2689.0,29.77,0.0,0.0).
province('Vaduz','li',5197.0,17.28,0.0,0.0).
province('Alytaus','lt',182803.0,5425.0,0.0,0.0).
province('Kauno','lt',695979.0,8170.0,0.0,0.0).
province('Klaipedos','lt',382732.0,5746.0,0.0,0.0).
province('Marijampoles','lt',185267.0,4463.0,0.0,0.0).
province('Panevezio','lt',292001.0,7881.0,0.0,0.0).
province('Siauliu','lt',360041.0,8751.0,0.0,0.0).
province('Taurages','lt',131627.0,3874.0,0.0,0.0).
province('Telsiu','lt',176673.0,4139.0,0.0,0.0).
province('Utenos','lt',178605.0,7201.0,0.0,0.0).
province('Vilniaus','lt',845108.0,9650.0,0.0,0.0).
province('Capellen','lu',37873.0,199.2,0.0,0.0).
province('Clervaux','lu',13237.0,302.3,0.0,0.0).
province('Diekirch','lu',27509.0,239.4,0.0,0.0).
province('Echternach','lu',14612.0,185.5,0.0,0.0).
province('Esch-sur-Alzette','lu',140015.0,242.8,0.0,0.0).
province('Grevenmacher','lu',22971.0,211.4,0.0,0.0).
province('Luxembourg','lu',127305.0,238.5,0.0,0.0).
province('Mersch','lu',24212.0,223.9,0.0,0.0).
province('Redange','lu',14470.0,267.5,0.0,0.0).
province('Remich','lu',17882.0,127.9,0.0,0.0).
province('Vianden','lu',3147.0,54.1,0.0,0.0).
province('Wiltz','lu',12348.0,293.9,0.0,0.0).
province('Berovo','mk',19337.0,807.0,0.0,0.0).
province('Bitola','mk',104796.0,1699.0,0.0,0.0).
province('Brod','mk',11575.0,924.0,0.0,0.0).
province('Debar','mk',24430.0,264.0,0.0,0.0).
province('Delcevo','mk',25558.0,585.0,0.0,0.0).
province('Demir Hisar','mk',9136.0,431.0,0.0,0.0).
province('Gevgelija','mk',35246.0,757.0,0.0,0.0).
province('Gostivar','mk',119527.0,1356.0,0.0,0.0).
province('Kavadarci','mk',43161.0,1134.0,0.0,0.0).
province('Kicevo','mk',58560.0,852.0,0.0,0.0).
province('Kocani','mk',44980.0,571.0,0.0,0.0).
province('Kratovo','mk',10288.0,376.0,0.0,0.0).
province('Kriva Palanka','mk',24918.0,720.0,0.0,0.0).
province('Krusevo','mk',11774.0,201.0,0.0,0.0).
province('Kumanovo','mk',142011.0,1190.0,0.0,0.0).
province('Negotino','mk',23986.0,736.0,0.0,0.0).
province('Ohrid','mk',61461.0,1031.0,0.0,0.0).
province('Prilep','mk',94464.0,1824.0,0.0,0.0).
province('Probistip','mk',12702.0,326.0,0.0,0.0).
province('Radovis','mk',32253.0,736.0,0.0,0.0).
province('Resen','mk',16539.0,739.0,0.0,0.0).
province('Skopje','mk',585311.0,25700.0,0.0,0.0).
province('Stip','mk',52227.0,810.0,0.0,0.0).
province('Struga','mk',66989.0,541.0,0.0,0.0).
province('Strumica','mk',93235.0,953.0,0.0,0.0).
province('Sveti Nikole','mk',21334.0,645.0,0.0,0.0).
province('Tetovo','mk',195518.0,1080.0,0.0,0.0).
province('Valandovo','mk',11825.0,331.0,0.0,0.0).
province('Veles','mk',65776.0,1536.0,0.0,0.0).
province('Vinica','mk',21472.0,438.0,0.0,0.0).
province('Antananarivo','mg',5270709.0,58283.0,'Antananarivo','Antananarivo').
province('Antsiranana','mg',1342330.0,43046.0,'Antsiranana','Antsiranana').
province('Fianarantsoa','mg',3797490.0,102373.0,'Fianarantsoa','Fianarantsoa').
province('Mahajanga','mg',1988799.0,150023.0,'Mahajanga','Mahajanga').
province('Toamasina','mg',3012486.0,71911.0,'Toamasina','Toamasina').
province('Toliary','mg',2543775.0,161405.0,'Toliary','Toliary').
province('Balaka','mw',277071.0,2193.0,0.0,0.0).
province('Blantyre City','mw',584870.0,268.0,0.0,0.0).
province('Blantyre Rural','mw',332969.0,1744.0,0.0,0.0).
province('Chikwawa','mw',362915.0,4755.0,0.0,0.0).
province('Chiradzulu','mw',246488.0,767.0,0.0,0.0).
province('Chitipa','mw',144178.0,4288.0,0.0,0.0).
province('Dedz','mw',526766.0,3624.0,0.0,0.0).
province('Dowa','mw',462726.0,3041.0,0.0,0.0).
province('Karonga','mw',224946.0,3355.0,0.0,0.0).
province('Kasungu','mw',594363.0,7878.0,0.0,0.0).
province('Lilongwe City','mw',646738.0,456.0,0.0,0.0).
province('Lilongwe Rural','mw',984694.0,5703.0,0.0,0.0).
province('Machinga','mw',410409.0,3771.0,0.0,0.0).
province('Mangochi','mw',674216.0,6273.0,0.0,0.0).
province('Mchinji','mw',367480.0,3356.0,0.0,0.0).
province('Mulanje','mw',432416.0,2056.0,0.0,0.0).
province('Mwanza','mw',148763.0,2295.0,0.0,0.0).
province('Mzimba','mw',612080.0,10430.0,0.0,0.0).
province('Mzuzu City','mw',128456.0,46.0,0.0,0.0).
province('Nkhata Bay','mw',191060.0,4043.0,0.0,0.0).
province('Nkhotakota','mw',286517.0,4259.0,0.0,0.0).
province('Nsanje','mw',194767.0,1942.0,0.0,0.0).
province('Ntcheu','mw',382589.0,3424.0,0.0,0.0).
province('Ntchisi','mw',199340.0,1655.0,0.0,0.0).
province('Phalombe','mw',237747.0,1394.0,0.0,0.0).
province('Rumphi','mw',152065.0,4769.0,0.0,0.0).
province('Salima','mw',288027.0,2196.0,0.0,0.0).
province('Thyolo','mw',472142.0,1715.0,0.0,0.0).
province('Zomba Municipality','mw',80932.0,57.0,0.0,0.0).
province('Zomba Rural','mw',518865.0,2523.0,0.0,0.0).
province('Johor','my',3003005.0,18986.0,'Johor Bahru','Johor').
province('Kedah','my',1809593.0,9426.0,'Alor Setar','Kedah').
province('Kelantan','my',1427681.0,14943.0,0.0,0.0).
province('Kuala Lumpur','my',1453978.0,243.0,'Kuala Lumpur','Kuala Lumpur').
province('Labuan','my',86714.0,91.0,0.0,0.0).
province('Melaka','my',688695.0,1650.0,'Melaka','Melaka').
province('Negeri Sembilan','my',956221.0,6643.0,0.0,0.0).
province('Pahang','my',1416772.0,35965.0,'Kuantan','Pahang').
province('Perak','my',2203985.0,21005.0,'Ipoh','Perak').
province('Perlis','my',217512.0,795.0,'Kangar','Perlis').
province('Pulau Pinang','my',1378936.0,1031.0,0.0,0.0).
province('Sabah','my',3105839.0,73620.0,'Kota Kinabalu','Sabah').
province('Sarawak','my',2344138.0,124449.0,'Kuching','Sarawak').
province('Selangor','my',5408841.0,7956.0,'Shah Alam','Selangor').
province('Terengganu','my',998789.0,12955.0,'Kuala Terengganu','Terengganu').
province('Alif Alif','mv',4717.0,0.0,0.0,0.0).
province('Alif Dhaal','mv',10869.0,0.0,0.0,0.0).
province('Baa','mv',10385.0,0.0,'Eydhafushi','Baa').
province('Dhaal','mv',5284.0,0.0,0.0,0.0).
province('Faaf','mv',4513.0,0.0,0.0,0.0).
province('Gaaf Alif','mv',8285.0,0.0,0.0,0.0).
province('Gaaf Dhaal','mv',11707.0,0.0,0.0,0.0).
province('Ghaviyani','mv',7960.0,0.0,0.0,0.0).
province('Haa Alif','mv',14497.0,0.0,0.0,0.0).
province('Haa Dhaal','mv',18446.0,0.0,'Kulhudhuffushi','Haa Dhaal').
province('Kaaf','mv',15169.0,0.0,0.0,0.0).
province('Laam','mv',12868.0,0.0,0.0,0.0).
province('Lhaviyani','mv',10540.0,0.0,'Naifaru','Lhaviyani').
province('Male','mv',84971.0,0.0,'Male','Male').
province('Miim','mv',5266.0,0.0,0.0,0.0).
province('Nuun','mv',10718.0,0.0,0.0,0.0).
province('Raa','mv',15864.0,0.0,'Ugoofaaru','Raa').
province('Shaviyani','mv',12238.0,0.0,'Funadhoo','Shaviyani').
province('Siin','mv',18940.0,0.0,0.0,0.0).
province('Thaa','mv',9071.0,0.0,0.0,0.0).
province('Vaav','mv',1779.0,0.0,0.0,0.0).
province('Bamako','ml',971363.0,267.0,'Bamako','Bamako').
province('Gao','ml',369694.0,170572.0,'Gao','Gao').
province('Kayes','ml',1805960.0,197760.0,'Kayes','Kayes').
province('Kidal','ml',34162.0,151430.0,'Kidal','Kidal').
province('Koulikoro','ml',1798314.0,89833.0,'Koulikoro','Koulikoro').
province('Mopti','ml',1493350.0,88752.0,'Mopti','Mopti').
province('Segou','ml',1877886.0,56127.0,'Segou','Segou').
province('Sikasso','ml',1773521.0,76480.0,'Sikasso','Sikasso').
province('Gozo and Comino','mt',29812.0,68.72,0.0,0.0).
province('Inner Harbour','mt',85183.0,16.88,0.0,0.0).
province('Northern','mt',46405.0,73.66,0.0,0.0).
province('Outer Harbour','mt',114421.0,33.31,0.0,0.0).
province('South Eastern','mt',55218.0,49.71,0.0,0.0).
province('Western','mt',53555.0,72.84,0.0,0.0).
province('Ailinginae','mh',0.0,2.8,0.0,0.0).
province('Ailinlaplap','mh',2065.0,14.69,0.0,0.0).
province('Ailuk','mh',518.0,5.36,0.0,0.0).
province('Arno','mh',2283.0,12.95,0.0,0.0).
province('Aur','mh',587.0,5.62,0.0,0.0).
province('Bikar','mh',0.0,0.49,0.0,0.0).
province('Bikini','mh',15.0,6.01,0.0,0.0).
province('Bokak','mh',0.0,3.24,0.0,0.0).
province('Ebon','mh',983.0,5.75,0.0,0.0).
province('Enewetak','mh',919.0,5.85,0.0,0.0).
province('Erikub','mh',0.0,1.53,0.0,0.0).
province('Jabat','mh',87.0,0.57,0.0,0.0).
province('Jaluit','mh',1623.0,11.34,0.0,0.0).
province('Jemo','mh',0.0,0.16,0.0,0.0).
province('Kili','mh',867.0,0.93,0.0,0.0).
province('Kwajalein','mh',11628.0,16.39,0.0,0.0).
province('Lae','mh',318.0,1.45,0.0,0.0).
province('Lib','mh',164.0,0.93,0.0,0.0).
province('Likiep','mh',543.0,10.26,0.0,0.0).
province('Majuro','mh',25574.0,9.71,0.0,0.0).
province('Maloelap','mh',875.0,9.82,0.0,0.0).
province('Mejit','mh',396.0,1.86,0.0,0.0).
province('Mili','mh',1120.0,15.93,0.0,0.0).
province('Namorik','mh',740.0,2.77,0.0,0.0).
province('Namu','mh',946.0,6.27,0.0,0.0).
province('Rongelap','mh',20.0,7.95,0.0,0.0).
province('Rongrik','mh',0.0,1.68,0.0,0.0).
province('Toke','mh',0.0,0.57,0.0,0.0).
province('Ujae','mh',430.0,1.86,0.0,0.0).
province('Ujelang','mh',0.0,1.74,0.0,0.0).
province('Utrik','mh',440.0,2.43,0.0,0.0).
province('Wotho','mh',182.0,4.33,0.0,0.0).
province('Wotje','mh',990.0,8.18,0.0,0.0).
province('Fort-de-France','mq',167303.0,170.99,0.0,0.0).
province('La Trinite','mq',88803.0,337.61,0.0,0.0).
province('Le Marin','mq',116022.0,409.14,0.0,0.0).
province('Saint-Pierre','mq',23482.0,210.26,0.0,0.0).
province('Adrar','mr',59670.0,215300.0,'Atar','Adrar').
province('Assaba','mr',285139.0,36600.0,0.0,0.0).
province('Brakna','mr',256825.0,37100.0,0.0,0.0).
province('Dakhlet Nouadhibou','mr',80181.0,22300.0,0.0,0.0).
province('Guidimagh','mr',219673.0,10300.0,0.0,0.0).
province('Gurgul','mr',274335.0,13600.0,0.0,0.0).
province('Hodh el Gharbi','mr',243244.0,53400.0,0.0,0.0).
province('Hodh ech Chargui','mr',298622.0,182700.0,0.0,0.0).
province('Inshiri','mr',11235.0,46800.0,0.0,0.0).
province('Takant','mr',64838.0,95200.0,0.0,0.0).
province('Tiris Zemmour','mr',63307.0,252900.0,0.0,0.0).
province('Trarza','mr',269944.0,67800.0,0.0,0.0).
province('Black River','mu',70046.0,258.99,0.0,0.0).
province('Flacq','mu',138447.0,297.84,0.0,0.0).
province('Grand Port','mu',115392.0,260.28,0.0,0.0).
province('Moka','mu',80543.0,230.5,0.0,0.0).
province('Pamplemousses','mu',133871.0,178.7,0.0,0.0).
province('Plaines Wilhelm','mu',382144.0,203.31,0.0,0.0).
province('Port Louis','mu',133789.0,42.73,0.0,0.0).
province('Riviere du Rempart','mu',107250.0,147.62,0.0,0.0).
province('Rodrigues','mu',36404.0,174.82,0.0,0.0).
province('Savanne','mu',70158.0,244.75,0.0,0.0).
province('Mayotte','yt',159039.0,362.29,0.0,0.0).
province('Pamanzi','yt',23036.0,10.95,0.0,0.0).
province('Aguascalientes','mx',1032682.0,5589.0,'Aguascalientes','Aguascalientes').
province('Baja California','mx',2916224.0,70113.0,'Mexicali','Baja California').
province('Baja California Sur','mx',475587.0,73677.0,'La Paz','Baja California Sur').
province('Campeche','mx',743870.0,51833.0,'Campeche','Campeche').
province('Chiapas','mx',4250247.0,73887.0,'Tuxtla Gutierrez','Chiapas').
province('Chihuahua','mx',3316181.0,247087.0,'Chihuahua','Chihuahua').
province('Coahuila','mx',2415865.0,151571.0,0.0,0.0).
province('Colima','mx',597971.0,5455.0,'Colima','Colima').
province('Distrito Federal','mx',8657045.0,1499.0,0.0,0.0).
province('Durango','mx',1460182.0,119648.0,'Durango','Durango').
province('Guanajuato','mx',4908057.0,30589.0,'Guanajuato','Guanajuato').
province('Guerrero','mx',3237582.0,63749.0,'Chilpancingo','Guerrero').
province('Hidalgo','mx',2356137.0,20987.0,0.0,0.0).
province('Jalisco','mx',6653363.0,80137.0,'Guadalajara','Jalisco').
province('Mexico','mx',1.4576626E7,21461.0,0.0,0.0).
province('Michoacan','mx',4091000.0,59864.0,0.0,0.0).
province('Morelos','mx',1680241.0,4941.0,'Cuernavaca','Morelos').
province('Nayarit','mx',941444.0,27621.0,'Tepic','Nayarit').
province('Nuevo Leon','mx',4123420.0,64555.0,'Monterrey','Nuevo Leon').
province('Oaxaca','mx',3625490.0,95364.0,'Oaxaca','Oaxaca').
province('Queretaro','mx',1568612.0,11769.0,0.0,0.0).
province('Quintana Roo','mx',1090282.0,50350.0,'Chetumal','Quintana Roo').
province('San Luis Potosi','mx',2391933.0,62848.0,'San Luis Potosi','San Luis Potosi').
province('Sinaloa','mx',2641699.0,58092.0,'Culiacan','Sinaloa').
province('Sonora','mx',2351430.0,184934.0,'Hermosillo','Sonora').
province('Tabasco','mx',2041289.0,24661.0,'Villahermosa','Tabasco').
province('Tamaulipas','mx',2976341.0,79829.0,0.0,0.0).
province('Tlaxcala','mx',1044371.0,3914.0,'Tlaxcala','Tlaxcala').
province('Veracruz','mx',7058897.0,72815.0,0.0,0.0).
province('Yucatan','mx',1761763.0,39340.0,'Merida','Yucatan').
province('Zacatecas','mx',1363579.0,75040.0,'Zacatecas','Zacatecas').
province('Chuuk','fm',54353.0,116.2,0.0,0.0).
province('Kusaie','fm',8038.0,110.5,0.0,0.0).
province('Pohnpei','fm',35540.0,372.2,0.0,0.0).
province('Yap','fm',11352.0,121.7,0.0,0.0).
province('Balti','md',495747.0,4081.0,'Balti','Balti').
province('Cahul','md',187540.0,2438.0,0.0,0.0).
province('Chisinau','md',376752.0,2780.0,'Chisinau','Chisinau Oras').
province('Chisinau Oras','md',770182.0,490.0,0.0,0.0).
province('Edinet','md',279294.0,3187.0,0.0,0.0).
province('Gagauzia','md',156661.0,1503.0,0.0,0.0).
province('Lapusna','md',272902.0,3436.0,0.0,0.0).
province('Orhei','md',296800.0,2850.0,0.0,0.0).
province('Soroca','md',273296.0,3162.0,0.0,0.0).
province('Taraclia','md',45238.0,1022.0,0.0,0.0).
province('Tighina','md',167183.0,2899.0,0.0,0.0).
province('Transnistria','md',619365.0,3479.0,0.0,0.0).
province('Ungheni','md',256969.0,2516.0,0.0,0.0).
province('Fontvieille','mc',4307.0,0.33,0.0,0.0).
province('La Condamine','mc',11985.0,0.61,0.0,0.0).
province('Monaco-Ville','mc',967.0,0.19,0.0,0.0).
province('Monte Carlo','mc',15825.0,0.82,0.0,0.0).
province('Arhangaj','mn',99841.0,55300.0,0.0,0.0).
province('Bajanhongor','mn',88582.0,116000.0,0.0,0.0).
province('Bajan-Oelgij','mn',94225.0,45700.0,0.0,0.0).
province('Bulgan','mn',65730.0,48700.0,'Bulgan','Bulgan').
province('Darhan-Uul','mn',90481.0,3280.0,0.0,0.0).
province('Dornod','mn',77930.0,123600.0,0.0,0.0).
province('Dornogovd','mn',53273.0,109500.0,0.0,0.0).
province('Dundgovd','mn',53636.0,74700.0,0.0,0.0).
province('Govd-Altaj','mn',64294.0,141400.0,0.0,0.0).
province('Govdsumber','mn',12882.0,5540.0,0.0,0.0).
province('Hentij','mn',74055.0,80300.0,0.0,0.0).
province('Hovd','mn',91167.0,76100.0,0.0,0.0).
province('Hoevsgoel','mn',124516.0,100600.0,0.0,0.0).
province('Oemnoegovd','mn',49507.0,165400.0,0.0,0.0).
province('Orhon','mn',82790.0,840.0,0.0,0.0).
province('Oevoerhangaj','mn',116342.0,62900.0,0.0,0.0).
province('Selenge','mn',107286.0,41200.0,0.0,0.0).
province('Suehbaatar','mn',58342.0,82300.0,0.0,0.0).
province('Toev','mn',102012.0,74000.0,0.0,0.0).
province('Ulaanbaatar','mn',844786.0,4700.0,'Ulaanbaatar','Ulaanbaatar').
province('Uvs','mn',92679.0,69600.0,'Ulaangom','Uvs').
province('Zavhan','mn',90657.0,82500.0,0.0,0.0).
province('Casablanca','ma',3730720.0,1615.0,0.0,0.0).
province('Chaouia-Ouardigha','ma',1736494.0,16760.0,0.0,0.0).
province('Doukkala-Abda','ma',2069561.0,13285.0,0.0,0.0).
province('Fes-Boulemane','ma',1711334.0,19795.0,0.0,0.0).
province('Gharb-Chrarda-Beni Hssen','ma',1983524.0,8805.0,0.0,0.0).
province('Guelmim','ma',398639.0,71970.0,0.0,0.0).
province('Marrakech-Tensift-Al Haouz','ma',3173594.0,31160.0,0.0,0.0).
province('Meknes-Tafilalet','ma',2453346.0,79210.0,0.0,0.0).
province('Oriental','ma',1829438.0,82820.0,0.0,0.0).
province('Rabat-Sale-Zammour-Zaer','ma',2570185.0,9580.0,0.0,0.0).
province('Souss Massa-Draa','ma',3279982.0,70880.0,0.0,0.0).
province('Tadla-Azilal','ma',1544649.0,17125.0,0.0,0.0).
province('Tangier-Tetouan','ma',2609071.0,11570.0,0.0,0.0).
province('Taza-Al Hoceima-Taounate','ma',1912774.0,24155.0,0.0,0.0).
province('Cabo Delgado','mz',1583884.0,82625.0,'Pemba','Cabo Delgado').
province('Gaza','mz',1275495.0,75709.0,'Xai-Xai','Gaza').
province('Inhambane','mz',1371712.0,68615.0,'Inhambane','Inhambane').
province('Manica','mz',1202715.0,61661.0,'Chimoio','Manica').
province('Maputo','mz',1191613.0,602.0,0.0,0.0).
province('Maputo Provincia','mz',997945.0,25756.0,0.0,0.0).
province('Nampula','mz',3780844.0,81606.0,'Nampula','Nampula').
province('Niassa','mz',942435.0,129056.0,'Lichinga','Niassa').
province('Sofala','mz',1702305.0,68018.0,'Beira','Sofala').
province('Tete','mz',1417354.0,100724.0,'Tete','Tete').
province('Zambezia','mz',3949841.0,105008.0,'Quelimane','Zambezia').
province('Ayeyarwady','mm',7523817.0,35138.0,'Pathein','Ayeyarwady').
province('Bago','mm',5728709.0,39404.0,'Bago','Bago').
province('Chin','mm',556230.0,36019.0,0.0,0.0).
province('Kachin','mm',1362716.0,89041.0,'Myitkyina','Kachin').
province('Kayah','mm',253788.0,11733.0,'Loikaw','Kayah').
province('Kayin','mm',1594146.0,30383.0,0.0,0.0).
province('Magway','mm',4885832.0,44820.0,'Magway','Magway').
province('Mandalay','mm',6905557.0,37024.0,'Mandalay','Mandalay').
province('Mon','mm',2535609.0,12297.0,'Mawlamyine','Mon').
province('Rakhine','mm',3084098.0,36778.0,0.0,0.0).
province('Rangoon','mm',5990318.0,10171.0,0.0,0.0).
province('Sagaing','mm',5812751.0,94625.0,'Sagaing','Sagaing').
province('Shan','mm',5605800.0,155801.0,'Taunggyi','Shan').
province('Tanintharyi','mm',1383287.0,43343.0,0.0,0.0).
province('Erongo','na',132030.0,63719.0,'Swakopmund','Erongo').
province('Kavango','na',235788.0,43417.0,'Rundu','Kavango').
province('Kunene','na',67055.0,144254.0,'Outjo','Kunene').
province('Omaheke','na',71056.0,84731.0,'Gobabis','Omaheke').
province('Omusati','na',234688.0,13637.0,0.0,0.0).
province('Oshikoto','na',167523.0,26607.0,'Tsumeb','Oshikoto').
province('Aiwo','nr',1092.0,1.1,0.0,0.0).
province('Anabar','nr',502.0,1.5,0.0,0.0).
province('Anetan','nr',516.0,1.0,0.0,0.0).
province('Anibare','nr',16.0,3.1,0.0,0.0).
province('Baiti','nr',572.0,1.2,0.0,0.0).
province('Boe','nr',795.0,0.5,0.0,0.0).
province('Buada','nr',716.0,2.6,0.0,0.0).
province('Denigomudu','nr',2827.0,0.9,0.0,0.0).
province('Ewa','nr',318.0,1.2,0.0,0.0).
province('Ijuw','nr',303.0,1.1,0.0,0.0).
province('Meneng','nr',1830.0,3.1,0.0,0.0).
province('Nibok','nr',432.0,1.6,0.0,0.0).
province('Uaboe','nr',335.0,0.8,0.0,0.0).
province('Yaren','nr',820.0,1.5,0.0,0.0).
province('Achham','np',239534.0,1680.0,0.0,0.0).
province('Arghakhanchi','np',218013.0,1193.0,0.0,0.0).
province('Baglung','np',278551.0,1784.0,0.0,0.0).
province('Baitadi','np',244725.0,1519.0,0.0,0.0).
province('Bajhang','np',175236.0,3422.0,0.0,0.0).
province('Bajura','np',115674.0,2188.0,0.0,0.0).
province('Banke','np',428385.0,2337.0,0.0,0.0).
province('Bara','np',613427.0,1190.0,0.0,0.0).
province('Bardiya','np',426489.0,2025.0,0.0,0.0).
province('Bhaktapur','np',238425.0,119.0,0.0,0.0).
province('Bhojpur','np',204253.0,1507.0,0.0,0.0).
province('Chitwan','np',521154.0,2218.0,0.0,0.0).
province('Dadeldhura','np',134083.0,1538.0,0.0,0.0).
province('Dailekh','np',236426.0,1502.0,0.0,0.0).
province('Dang Deokhuri','np',506451.0,2955.0,0.0,0.0).
province('Darchula','np',128083.0,2322.0,0.0,0.0).
province('Dhading','np',357244.0,1926.0,0.0,0.0).
province('Dhankuta','np',173216.0,891.0,0.0,0.0).
province('Dhanusa','np',721407.0,1180.0,0.0,0.0).
province('Dolakha','np',214519.0,2191.0,0.0,0.0).
province('Dolpa','np',30974.0,7889.0,0.0,0.0).
province('Doti','np',217385.0,2025.0,0.0,0.0).
province('Gorkha','np',298276.0,3610.0,0.0,0.0).
province('Gulmi','np',307099.0,1149.0,0.0,0.0).
province('Humla','np',45562.0,5655.0,0.0,0.0).
province('Ilam','np',305058.0,1703.0,0.0,0.0).
province('Jajarkot','np',141699.0,2230.0,0.0,0.0).
province('Jhapa','np',729514.0,1606.0,0.0,0.0).
province('Jumla','np',93261.0,2531.0,0.0,0.0).
province('Kailali','np',713086.0,3235.0,0.0,0.0).
province('Kalikot','np',108689.0,1741.0,0.0,0.0).
province('Kanchanpur','np',432167.0,1610.0,0.0,0.0).
province('Kapilvastu','np',530419.0,1738.0,0.0,0.0).
province('Kaski','np',416161.0,2017.0,0.0,0.0).
province('Kathmandu','np',1264676.0,395.0,0.0,0.0).
province('Kavrepalanchok','np',399759.0,1396.0,0.0,0.0).
province('Khotang','np',234084.0,1591.0,0.0,0.0).
province('Lalitpur','np',373438.0,385.0,0.0,0.0).
province('Lamjung','np',181180.0,1692.0,0.0,0.0).
province('Mahottari','np',593521.0,1002.0,0.0,0.0).
province('Makwanpur','np',424705.0,2426.0,0.0,0.0).
province('Manang','np',10083.0,2246.0,0.0,0.0).
province('Morang','np',908457.0,1855.0,0.0,0.0).
province('Mugu','np',43861.0,3535.0,0.0,0.0).
province('Mustang','np',15321.0,3573.0,0.0,0.0).
province('Myagdi','np',117418.0,2297.0,0.0,0.0).
province('Nawalparasi','np',621621.0,2162.0,0.0,0.0).
province('Nuwakot','np',305424.0,1121.0,0.0,0.0).
province('Okhaldhunga','np',159761.0,1074.0,0.0,0.0).
province('Palpa','np',278266.0,1373.0,0.0,0.0).
province('Panchthar','np',211099.0,1241.0,0.0,0.0).
province('Parbat','np',163024.0,494.0,0.0,0.0).
province('Parsa','np',545290.0,1353.0,0.0,0.0).
province('Pyuthan','np',222945.0,1309.0,0.0,0.0).
province('Ramechhap','np',221954.0,1546.0,0.0,0.0).
province('Rasuwa','np',47688.0,1544.0,0.0,0.0).
province('Rautahat','np',591290.0,1126.0,0.0,0.0).
province('Rolpa','np',217498.0,1879.0,0.0,0.0).
province('Rukum','np',199558.0,2877.0,0.0,0.0).
province('Rupandehi','np',785608.0,1360.0,0.0,0.0).
province('Salyan','np',225582.0,1462.0,0.0,0.0).
province('Sankhuwasabha','np',164469.0,3480.0,0.0,0.0).
province('Saptari','np',609581.0,1363.0,0.0,0.0).
province('Sarlahi','np',686221.0,1259.0,0.0,0.0).
province('Sindhuli','np',299780.0,2491.0,0.0,0.0).
province('Sindhupalchok','np',319619.0,2542.0,0.0,0.0).
province('Siraha','np',613253.0,1188.0,0.0,0.0).
province('Solukhumbu','np',111099.0,3312.0,0.0,0.0).
province('Sunsari','np',690453.0,1257.0,0.0,0.0).
province('Surkhet','np',316071.0,2451.0,0.0,0.0).
province('Syangja','np',324856.0,1164.0,0.0,0.0).
province('Tanahu','np',333333.0,1546.0,0.0,0.0).
province('Taplejung','np',136848.0,3646.0,0.0,0.0).
province('Terhathum','np',116746.0,679.0,0.0,0.0).
province('Udayapur','np',317113.0,2063.0,0.0,0.0).
province('Drenthe','nl',483549.0,2652.06,'Assen','Drenthe').
province('Friesland','nl',644909.0,3361.35,'Leeuwarden','Friesland').
province('Groningen','nl',578713.0,2344.14,'Groningen','Groningen').
province('Noord-Holland','nl',2594468.0,2659.78,'Haarlem','Noord-Holland').
province('Overijssel','nl',1110481.0,3337.46,'Zwolle','Overijssel').
province('Zeeland','nl',378637.0,1791.95,'Middelburg','Zeeland').
province('Zuid-Holland','nl',3465564.0,2859.51,0.0,0.0).
province('Curacao','an',136197.0,444.0,'Willemstad','Curacao').
province('Sint Maarten','an',32872.0,34.0,'Phillipsburg','Sint Maarten').
province('Iles','nc',24650.0,1981.0,0.0,0.0).
province('Nord','nc',48898.0,7348.0,0.0,0.0).
province('Sud','nc',158862.0,9407.0,0.0,0.0).
province('Area Outside Region','nz',652.0,963.0,0.0,0.0).
province('Auckland','nz',1366723.0,5048.27,0.0,0.0).
province('Bay of Plenty','nz',259483.0,11427.71,0.0,0.0).
province('Canterbury','nz',524590.0,45845.32,0.0,0.0).
province('Gisborne','nz',47124.0,8354.93,0.0,0.0).
province('Hawkes Bay','nz',148286.0,13763.77,0.0,0.0).
province('Manawatu-Wanganui','nz',225739.0,22686.74,0.0,0.0).
province('Marlborough','nz',42368.0,12493.32,0.0,0.0).
province('Nelson','nz',45841.0,444.29,0.0,0.0).
province('Northland','nz',147514.0,13296.2,0.0,0.0).
province('Otago','nz',195821.0,31476.16,0.0,0.0).
province('Southland','nz',93046.0,25392.0,0.0,0.0).
province('Taranaki','nz',104690.0,7227.05,0.0,0.0).
province('Tasman','nz',46522.0,14537.99,0.0,0.0).
province('Waikato','nz',383407.0,26169.94,0.0,0.0).
province('Wellington','nz',460756.0,8056.01,0.0,0.0).
province('West Coast','nz',30047.0,23351.3,0.0,0.0).
province('Atlantico Norte','ni',264908.0,32195.0,0.0,0.0).
province('Atlantico Sur','ni',404831.0,27407.0,0.0,0.0).
province('Boaco','ni',177514.0,4244.0,0.0,0.0).
province('Carazo','ni',185879.0,1050.0,0.0,0.0).
province('Chinandega','ni',462515.0,4926.0,0.0,0.0).
province('Chontales','ni',191154.0,6378.0,0.0,0.0).
province('Esteli','ni',224117.0,2335.0,0.0,0.0).
province('Granada','ni',200895.0,929.0,0.0,0.0).
province('Jinotega','ni',308137.0,9755.0,0.0,0.0).
province('Leon','ni',408867.0,5107.0,0.0,0.0).
province('Madriz','ni',140577.0,1602.0,0.0,0.0).
province('Managua','ni',1443451.0,3672.0,0.0,0.0).
province('Masaya','ni',334950.0,590.0,0.0,0.0).
province('Matagalpa','ni',511220.0,8523.0,0.0,0.0).
province('Nueva','ni',230398.0,3123.0,0.0,0.0).
province('Rio San Juan','ni',101807.0,7473.0,0.0,0.0).
province('Rivas','ni',175277.0,2155.0,0.0,0.0).
province('Agadez','ne',347330.0,634209.0,'Agadez','Agadez').
province('Diffa','ne',381100.0,140216.0,'Diffa','Diffa').
province('Dosso','ne',1622968.0,31002.0,'Dosso','Dosso').
province('Maradi','ne',2473840.0,38581.0,'Maradi','Maradi').
province('Niamey','ne',774245.0,670.0,0.0,0.0).
province('Tahoua','ne',2095387.0,106677.0,'Tahoua','Tahoua').
province('Tillabery','ne',2017213.0,89623.0,0.0,0.0).
province('Zinder','ne',2213428.0,145430.0,'Zinder','Zinder').
province('Abia','ng',4222492.0,6320.0,'Umuahia','Abia').
province('Abuja Federal Capital Territory','ng',660639.0,7315.0,0.0,0.0).
province('Adamawa','ng',3737239.0,36917.0,'Yola','Adamawa').
province('Akwa Ibom','ng',4805470.0,7081.0,'Uyo','Akwa Ibom').
province('Anambra','ng',4721864.0,4844.0,'Awka','Anambra').
province('Bauchi','ng',4706913.0,45837.0,'Bauchi','Bauchi').
province('Bayelsa','ng',1998358.0,10773.0,'Yenagoa','Bayelsa').
province('Benue','ng',5181652.0,34059.0,'Makurdi','Benue').
province('Borno','ng',4588680.0,70898.0,'Maiduguri','Borno').
province('Cross River','ng',3104458.0,20156.0,'Calabar','Cross River').
province('Delta','ng',4170222.0,17698.0,'Asaba','Delta').
province('Ebonyi','ng',1739152.0,5670.0,'Abakaliki','Ebonyi').
province('Edo','ng',3497514.0,17802.0,0.0,0.0).
province('Ekiti','ng',2737205.0,6353.0,0.0,0.0).
province('Enugu','ng',3590528.0,7161.0,'Enugu','Enugu').
province('Gombe','ng',2448250.0,18768.0,'Gombe','Gombe').
province('Imo','ng',4485075.0,5530.0,'Owerri','Imo').
province('Jigawa','ng',4988892.0,23154.0,'Dutse','Jigawa').
province('Kaduna','ng',6849028.0,46053.0,'Kaduna','Kaduna').
province('Kano','ng',1.0077638E7,20131.0,'Kano','Kano').
province('Katsina','ng',6483412.0,24192.0,'Katsina','Katsina').
province('Kebbi','ng',3630947.0,36800.0,'Birnin Kebbi','Kebbi').
province('Kogi','ng',3595796.0,29833.0,'Lokoja','Kogi').
province('Kwara','ng',2591566.0,36825.0,'Ilorin','Kwara').
province('Lagos','ng',1.060116E7,3345.0,0.0,0.0).
province('Nassarawa','ng',2040112.0,27117.0,0.0,0.0).
province('Niger','ng',4082562.0,76363.0,'Minna','Niger').
province('Ogun','ng',4054285.0,16762.0,'Abeokuta','Ogun').
province('Ondo','ng',4011423.0,14606.0,'Akure','Ondo').
province('Osun','ng',4137647.0,9251.0,'Oshogbo','Osun').
province('Oyo','ng',6617712.0,28454.0,'Ibadan','Oyo').
province('Plateau','ng',3553455.0,30913.0,'Jos','Plateau').
province('Rivers','ng',5689061.0,11077.0,'Port Harcourt','Rivers').
province('Sokoto','ng',4244412.0,25973.0,'Sokoto','Sokoto').
province('Taraba','ng',2688963.0,54473.0,'Jalingo','Taraba').
province('Yobe','ng',2532415.0,45502.0,'Damaturu','Yobe').
province('Zamfara','ng',3602374.0,39762.0,'Gusau','Zamfara').
province('Bocas del Toro','pa',96657.0,4601.3,'Bocas del Toro','Bocas del Toro').
province('Chiriqui','pa',399311.0,6476.5,'David','Chiriqui').
province('Cocle','pa',219217.0,4927.4,'Penonome','Cocle').
province('Colon','pa',221108.0,4890.5,'Colon','Colon').
province('Embera','pa',8928.0,4398.0,0.0,0.0).
province('Herrera','pa',110945.0,2340.8,'Chitre','Herrera').
province('Kuna de Madungandi','pa',3579.0,2318.8,0.0,0.0).
province('Kuna de Wargandi','pa',1227.0,775.0,0.0,0.0).
province('Kuna Yala','pa',35131.0,2393.1,'Nargana','Kuna Yala').
province('Los Santos','pa',90405.0,3805.4,'Las Tablas','Los Santos').
province('Ngoebe Bugle','pa',119190.0,6673.3,0.0,0.0).
province('Panama','pa',1499678.0,9633.1,0.0,0.0).
province('Veraguas','pa',226379.0,10677.2,'Santiago','Veraguas').
province('Central','pg',202087.0,29500.0,'Port Moresby','National Capital District').
province('Eastern Highlands','pg',489442.0,11200.0,'Goroka','Eastern Highlands').
province('East New Britain','pg',236287.0,15500.0,'Rabaul','East New Britain').
province('East Sepik','pg',383588.0,42800.0,'Wewak','East Sepik').
province('Enga','pg',313689.0,12800.0,'Wabag','Enga').
province('Fly River','pg',174395.0,99300.0,0.0,0.0).
province('Gulf','pg',123312.0,34500.0,'Kerema','Gulf').
province('Madang','pg',406883.0,29000.0,'Madang','Madang').
province('Morobe','pg',622512.0,34500.0,'Lae','Morobe').
province('New Ireland','pg',133325.0,9600.0,'Kavieng','New Ireland').
province('North Solomons','pg',132887.0,9300.0,'Arawa','North Solomons').
province('Sandaun','pg',209364.0,36300.0,0.0,0.0).
province('Simbu','pg',291848.0,6100.0,'Kundiawa','Simbu').
province('West New Britain','pg',215574.0,21000.0,'Kimbe','West New Britain').
province('Alto Paraguay','py',14005.0,82349.0,'Fuerte Olimpo','Alto Paraguay').
province('Asuncion','py',508797.0,117.0,'Asuncion','Asuncion').
province('Caaguazu','py',458821.0,11474.0,'Coronel Oviedo','Caaguazu').
province('Canendiyu','py',154225.0,14667.0,0.0,0.0).
province('Central','py',1533573.0,2465.0,'Aregua','Central').
province('Cordillera','py',238118.0,4948.0,'Caacupe','Cordillera').
province('Itapua','py',484310.0,16525.0,'Encarnacion','Itapua').
province('Neembucu','py',775.0,12147.0,'Pilar','Neembucu').
province('San Pedro','py',332397.0,20002.0,0.0,0.0).
province('Amazonas','pe',447529.0,39249.13,'Chachapoyas','Amazonas').
province('Ancash','pe',1125085.0,35825.57,'Huaraz','Ancash').
province('Arequipa','pe',1171894.0,63345.39,'Arequipa','Arequipa').
province('Cajamarca','pe',1478610.0,33247.77,'Cajamarca','Cajamarca').
province('Huanuco','pe',842839.0,36938.09,'Huanuco','Huanuco').
province('Ica','pe',699462.0,21327.83,'Ica','Ica').
province('La Libertad','pe',1597685.0,25569.67,'Trujillo','La Libertad').
province('Lima y Callao','pe',9058592.0,34948.57,0.0,0.0).
province('Loreto','pe',1013106.0,368851.95,'Iquitos','Loreto').
province('Moquegua','pe',159801.0,15733.97,'Moquegua','Moquegua').
province('Piura','pe',1745243.0,35892.49,'Piura','Piura').
province('Puno','pe',1258648.0,71999.0,'Puno','Puno').
province('Tacna','pe',321298.0,16075.89,'Tacna','Tacna').
province('Tumbes','pe',222553.0,4669.2,'Tumbes','Tumbes').
province('Bicol','ph',4993075.0,17632.5,0.0,0.0).
province('Cagayan Valley','ph',3059427.0,26837.7,0.0,0.0).
province('Caraga','ph',2237494.0,18847.0,0.0,0.0).
province('Central Luzon','ph',9103330.0,18230.8,0.0,0.0).
province('Central Mindanao','ph',2846681.0,14454.8,0.0,0.0).
province('Central','ph',6342555.0,14951.5,0.0,0.0).
province('Cordillera','ph',1486049.0,17410.1,0.0,0.0).
province('Eastern Visayas','ph',3827202.0,21422.8,0.0,0.0).
province('Ilocos','ph',4543787.0,12840.2,0.0,0.0).
province('Muslim Mindanao','ph',2801352.0,11638.3,0.0,0.0).
province('National Capital Region','ph',1.0457432E7,636.0,0.0,0.0).
province('Northern Mindanao','ph',2979276.0,14033.0,0.0,0.0).
province('Southern Mindanao','ph',5790652.0,27316.7,0.0,0.0).
province('Southern Tagalog','ph',1.3777354E7,46924.1,0.0,0.0).
province('Western Mindanao','ph',3346062.0,15997.3,0.0,0.0).
province('Western Visayas','ph',6582364.0,20827.6,0.0,0.0).
province('Kujawsko-Pomorskie','pl',2066580.0,17970.0,'Bydgoszcz','Kujawsko-Pomorskie').
province('Lubelskie','pl',2183993.0,25115.0,'Lublin','Lubelskie').
province('Malopolskie','pl',3275680.0,15144.0,0.0,0.0).
province('Mazowieckie','pl',5141709.0,35597.0,0.0,0.0).
province('Opolskie','pl',1046416.0,9412.0,'Opole','Opolskie').
province('Podlaskie','pl',1202028.0,20180.0,'Bialystok','Podlaskie').
province('Slaskie','pl',4686544.0,12294.0,'Katowice','Slaskie').
province('Warminsko-Mazurskie','pl',1428212.0,24203.0,'Olsztyn','Warminsko-Mazurskie').
province('Zachodnio-Pomorskie','pl',1694967.0,22902.0,0.0,0.0).
province('Acores','pt',242902.0,2329.7,0.0,0.0).
province('Alentejo','pt',527298.0,26931.2,0.0,0.0).
province('Algarve','pt',411304.0,4988.5,0.0,0.0).
province('Centro','pt',1796504.0,23668.2,0.0,0.0).
province('Lisboa e Vale do Tejo','pt',3496761.0,11931.1,0.0,0.0).
province('Madeira','pt',238928.0,778.9,'Funchal','Madeira').
province('Norte','pt',3749473.0,21278.3,0.0,0.0).
province('Arecibo','pr',536660.0,1489.51,0.0,0.0).
province('Bayamon','pr',525666.0,316.5,0.0,0.0).
province('Carolina','pr',353076.0,769.23,0.0,0.0).
province('Guayama','pr',540943.0,1703.44,0.0,0.0).
province('Humacao','pr',609846.0,1371.92,0.0,0.0).
province('Mayagueez-Aguadilla','pr',497333.0,1551.41,0.0,0.0).
province('Ponce','pr',445471.0,1633.25,0.0,0.0).
province('San Juan','pr',431285.0,136.23,0.0,0.0).
province('al-Guwayriyah','qa',2332.0,622.74,0.0,0.0).
province('al-Jumayliyah','qa',13424.0,2611.7,0.0,0.0).
province('al-Wakrah','qa',31547.0,777.31,0.0,0.0).
province('ar-Rayyan','qa',286514.0,893.48,0.0,0.0).
province('as-Samal','qa',5510.0,902.11,0.0,0.0).
province('Doha','qa',344939.0,158.71,0.0,0.0).
province('Jariyan al-Batnah','qa',6494.0,3906.53,0.0,0.0).
province('Khor','qa',33690.0,1001.44,0.0,0.0).
province('Musayid','qa',10106.0,176.68,0.0,0.0).
province('Bassas da India','re',0.0,0.2,0.0,0.0).
province('Europa Island','re',0.0,28.0,0.0,0.0).
province('Glorioso Islands','re',0.0,5.0,0.0,0.0).
province('Juan de Nova Island','re',0.0,4.4,0.0,0.0).
province('Saint-Benoit','re',112335.0,738.0,0.0,0.0).
province('Saint-Denis','re',261083.0,421.0,0.0,0.0).
province('Saint-Paul','re',152942.0,466.0,0.0,0.0).
province('Saint-Pierre','re',253028.0,883.0,0.0,0.0).
province('Tromelin Island','re',0.0,1.0,0.0,0.0).
province('Alba','ro',373616.0,6242.0,'Alba Iulia','Alba').
province('Arad','ro',453330.0,7754.0,'Arad','Arad').
province('Bacau','ro',698735.0,6621.0,'Bacau','Bacau').
province('Botosani','ro',450588.0,4986.0,'Botosani','Botosani').
province('Braila','ro',367829.0,4766.0,'Braila','Braila').
province('Bucharest','ro',1877155.0,238.0,0.0,0.0).
province('Buzau','ro',487484.0,6103.0,'Buzau','Buzau').
province('Calarasi','ro',319771.0,5088.0,'Calarasi','Calarasi').
province('Cluj','ro',692149.0,6674.0,'Cluj-Napoca','Cluj').
province('Covasna','ro',218613.0,3710.0,0.0,0.0).
province('Dambovita','ro',534003.0,4054.0,0.0,0.0).
province('Dolj','ro',725102.0,7414.0,'Craiova','Dolj').
province('Galati','ro',611732.0,4466.0,'Galati','Galati').
province('Gorj','ro',381225.0,5602.0,0.0,0.0).
province('Hunedoara','ro',512923.0,7063.0,'Deva','Hunedoara').
province('Ialomita','ro',292920.0,4453.0,'Slobozia','Ialomita').
province('Iasi','ro',818614.0,5476.0,'Iasi','Iasi').
province('Ilfov','ro',302915.0,1583.0,0.0,0.0).
province('Mures','ro',569918.0,6714.0,0.0,0.0).
province('Neamt','ro',549544.0,5896.0,'Piatra Neamt','Neamt').
province('Prahova','ro',814506.0,4716.0,'Ploiesti','Prahova').
province('Satu Mare','ro',359578.0,4418.0,0.0,0.0).
province('Sibiu','ro',412750.0,5432.0,'Sibiu','Sibiu').
province('Timis','ro',669549.0,8697.0,'Timisoara','Timis').
province('Tulcea','ro',254489.0,8499.0,'Tulcea','Tulcea').
province('Valcea','ro',405623.0,5765.0,0.0,0.0).
province('Adygeya','ru',447381.0,7798.4,0.0,0.0).
province('Agin-Buryat','ru',70821.0,19312.3,0.0,0.0).
province('Altai Republic','ru',204064.0,92961.2,0.0,0.0).
province('Altaiski Kray','ru',2586976.0,167816.8,0.0,0.0).
province('Amur','ru',868169.0,361401.6,0.0,0.0).
province('Arkhangelsk','ru',1245685.0,419811.4,0.0,0.0).
province('Astrakhan','ru',1000697.0,47235.9,0.0,0.0).
province('Bashkortostan','ru',4112207.0,142896.7,0.0,0.0).
province('Belgorod','ru',1531045.0,27086.1,0.0,0.0).
province('Bryansk','ru',1351463.0,34835.3,0.0,0.0).
province('Buryatia','ru',963336.0,332013.0,0.0,0.0).
province('Chechnya','ru',1106103.0,15680.4,0.0,0.0).
province('Chelyabinsk','ru',3577253.0,88181.7,0.0,0.0).
province('Chita','ru',1036179.0,412338.1,0.0,0.0).
province('Chukotka','ru',50134.0,719821.0,0.0,0.0).
province('Chuvashia','ru',1301226.0,18343.2,0.0,0.0).
province('Dagestan','ru',2758424.0,50278.0,0.0,0.0).
province('Ingushetia','ru',515587.0,2962.7,0.0,0.0).
province('Irkutsk','ru',2382934.0,739482.3,0.0,0.0).
province('Ivanovo','ru',1109196.0,23896.6,0.0,0.0).
province('Jewish Republic','ru',184934.0,36112.8,0.0,0.0).
province('Kabar','ru',928518.0,11518.0,0.0,0.0).
province('Kaliningrad','ru',967962.0,13612.3,0.0,0.0).
province('Kalmykia','ru',284668.0,74721.3,0.0,0.0).
province('Kaluga','ru',1030146.0,29807.4,0.0,0.0).
province('Kamchatka','ru',314994.0,171265.5,0.0,0.0).
province('Karachai-Cherkess Republic','ru',441394.0,14276.9,0.0,0.0).
province('Karelia','ru',697354.0,156665.2,0.0,0.0).
province('Kemerovo','ru',2827246.0,95801.2,0.0,0.0).
province('Khabarovsk Krai','ru',1394489.0,785730.0,0.0,0.0).
province('Khakasia','ru',538125.0,61610.1,0.0,0.0).
province('Khanty-Mansi','ru',1460892.0,534473.0,0.0,0.0).
province('Kirov','ru',1457863.0,120775.7,0.0,0.0).
province('Komi','ru',968408.0,416774.0,0.0,0.0).
province('Komi-Permyak','ru',130760.0,32876.2,0.0,0.0).
province('Koryak','ru',23513.0,293899.1,0.0,0.0).
province('Kostroma','ru',717819.0,60143.7,0.0,0.0).
province('Krasnodar','ru',5191490.0,75723.7,0.0,0.0).
province('Krasnoyarsk','ru',2845899.0,719234.9,0.0,0.0).
province('Kurgan','ru',996476.0,71910.0,0.0,0.0).
province('Kursk','ru',1207090.0,30088.3,0.0,0.0).
province('Leningrad','ru',1660797.0,74353.4,0.0,0.0).
province('Lipetsk','ru',1202750.0,24040.7,0.0,0.0).
province('Magadan','ru',169503.0,464253.7,0.0,0.0).
province('Mari','ru',719081.0,23372.3,0.0,0.0).
province('Mordovia','ru',868531.0,26159.3,0.0,0.0).
province('Moscow','ru',1.0636981E7,1091.0,0.0,0.0).
province('Moskovskaya Oblast','ru',6564006.0,46058.5,0.0,0.0).
province('Murmansk','ru',841895.0,143193.0,0.0,0.0).
province('Nenets','ru',38949.0,176700.0,0.0,0.0).
province('Nizhni Novgorod','ru',3464526.0,76729.9,0.0,0.0).
province('North Ossetia','ru',722901.0,7953.6,0.0,0.0).
province('Novgorod','ru',678571.0,53894.8,0.0,0.0).
province('Novosibirsk','ru',2657700.0,178677.9,0.0,0.0).
province('Omsk','ru',2054239.0,141083.7,0.0,0.0).
province('Orel','ru',848808.0,24532.2,0.0,0.0).
province('Orenburg','ru',2167498.0,124339.0,0.0,0.0).
province('Penza','ru',1433768.0,43314.3,0.0,0.0).
province('Perm','ru',2616727.0,127360.8,0.0,0.0).
province('Primorski','ru',2021902.0,161872.8,0.0,0.0).
province('Pskov','ru',739639.0,55399.7,0.0,0.0).
province('Rostov','ru',4397303.0,101126.9,0.0,0.0).
province('Ryazan','ru',1197310.0,39770.8,0.0,0.0).
province('Saint Petersburg','ru',4561084.0,1146.2,0.0,0.0).
province('Sakhalin','ru',514554.0,85358.8,0.0,0.0).
province('Samara','ru',3214701.0,53636.8,0.0,0.0).
province('Saratov','ru',2648495.0,100830.8,0.0,0.0).
province('Smolensk','ru',1022034.0,49675.8,0.0,0.0).
province('Stavropol','ru',2784270.0,66127.5,0.0,0.0).
province('Sverdlovsk','ru',4412629.0,194074.5,0.0,0.0).
province('Tambov','ru',1143906.0,34538.8,0.0,0.0).
province('Tatarstan','ru',3786329.0,68020.3,0.0,0.0).
province('Taymir','ru',36964.0,844167.5,0.0,0.0).
province('Tomsk','ru',1049069.0,313908.7,0.0,0.0).
province('Tula','ru',1628465.0,25820.0,0.0,0.0).
province('Tver','ru',1424422.0,84585.8,0.0,0.0).
province('Tyumen','ru',1316577.0,159869.7,0.0,0.0).
province('Tyva','ru',302939.0,168606.3,0.0,0.0).
province('Udmurtia','ru',1552896.0,42100.0,0.0,0.0).
province('Ulyanovsk','ru',1370689.0,37336.8,0.0,0.0).
province('Ust-Ordyn Buryat','ru',134367.0,22138.1,0.0,0.0).
province('Vladimir','ru',1489102.0,29142.4,0.0,0.0).
province('Volgograd','ru',2705208.0,113023.0,0.0,0.0).
province('Vologda','ru',1245038.0,143527.2,0.0,0.0).
province('Voronezh','ru',2345908.0,52322.6,0.0,0.0).
province('Yakutia','ru',918293.0,3078125.1,0.0,0.0).
province('Yamalo-Nenets','ru',508401.0,683975.7,0.0,0.0).
province('Yaroslavl','ru',1338749.0,33139.8,0.0,0.0).
province('Yevenki','ru',16507.0,763092.0,0.0,0.0).
province('Butare','rw',738683.0,1849.0,'Butare','Butare').
province('Byumba','rw',750865.0,1730.0,'Byumba','Byumba').
province('Cyangugu','rw',653022.0,2330.0,'Cyangugu','Cyangugu').
province('Gikongoro','rw',510172.0,2188.0,'Gikongoro','Gikongoro').
province('Gisenyi','rw',928968.0,2145.0,'Gisenyi','Gisenyi').
province('Gitarama','rw',886264.0,2188.0,'Gitarama','Gitarama').
province('Kibungo','rw',744990.0,3253.0,'Kibungo','Kibungo').
province('Kibuye','rw',484387.0,1336.0,'Kibuye','Kibuye').
province('Kigali-ngali','rw',796761.0,3133.0,0.0,0.0).
province('Ruhengeri','rw',953181.0,1762.0,'Ruhengeri','Ruhengeri').
province('Umutara','rw',447285.0,4312.0,0.0,0.0).
province('Ville de Kigali','rw',745526.0,112.0,0.0,0.0).
province('Ascension','sh',1035.0,88.0,0.0,0.0).
province('Gough Island','sh',4.0,90.0,0.0,0.0).
province('Inaccessible Island','sh',0.0,10.0,0.0,0.0).
province('Nightingale Islands','sh',0.0,2.0,0.0,0.0).
province('Saint Helena','sh',3800.0,122.0,0.0,0.0).
province('Tristan da Cunha','sh',271.0,98.0,0.0,0.0).
province('Christ Church Nichola Town','kn',1801.0,18.6,0.0,0.0).
province('Saint Anne Sandy Point','kn',2849.0,12.8,0.0,0.0).
province('Saint George Basseterre','kn',12920.0,28.7,0.0,0.0).
province('Saint George Gingerland','kn',2072.0,18.5,0.0,0.0).
province('Saint James Windward','kn',1529.0,31.1,0.0,0.0).
province('Saint John Capesterre','kn',2859.0,24.8,0.0,0.0).
province('Saint John Figtree','kn',2009.0,21.3,0.0,0.0).
province('Saint Mary Cayon','kn',2994.0,15.1,0.0,0.0).
province('Saint Paul Capesterre','kn',1882.0,13.8,0.0,0.0).
province('Saint Paul Charlestown','kn',1538.0,3.5,0.0,0.0).
province('Saint Peter Basseterre','kn',2262.0,20.7,0.0,0.0).
province('Saint Thomas Lowland','kn',1791.0,18.1,0.0,0.0).
province('Saint Thomas Middle Island','kn',2045.0,24.3,0.0,0.0).
province('Trinity Palmetto Point','kn',1050.0,15.4,0.0,0.0).
province('Anse-la-Raye','lc',6395.0,41.1,0.0,0.0).
province('Canaries','lc',1751.0,21.0,0.0,0.0).
province('Castries','lc',68399.0,96.3,0.0,0.0).
province('Choiseul','lc',5932.0,26.3,0.0,0.0).
province('Dennery','lc',13180.0,75.1,0.0,0.0).
province('Gros Inlet','lc',24083.0,99.3,0.0,0.0).
province('Laborie','lc',7185.0,32.4,0.0,0.0).
province('Micoud','lc',16125.0,112.7,0.0,0.0).
province('Soufriere','lc',7519.0,60.6,0.0,0.0).
province('Vieux Fort','lc',15131.0,51.5,0.0,0.0).
province('Miquelon-Langlade','pm',1141.0,216.0,0.0,0.0).
province('Saint-Pierre','pm',6200.0,26.0,0.0,0.0).
province('Charlotte','vc',39890.0,148.8,'Georgetown','Charlotte').
province('Grenadines','vc',9654.0,45.3,'Port Elizabeth','Grenadines').
province('Saint Andrew','vc',7033.0,28.7,'Layou','Saint Andrew').
province('Saint David','vc',7033.0,80.0,'Chateaubelair','Saint David').
province('Saint George','vc',53957.0,52.1,'Kingstown','Saint George').
province('Saint Patrick','vc',6089.0,36.8,0.0,0.0).
province('Apia Urban Area','ws',40407.0,60.0,0.0,0.0).
province('North West Upolu','ws',56934.0,251.0,0.0,0.0).
province('Rest of Upolu','ws',42654.0,780.0,0.0,0.0).
province('Savaii','ws',41988.0,1694.0,0.0,0.0).
province('Acquaviva','sm',1578.0,4.86,'Acquaviva','Acquaviva').
province('Borgo Maggiore','sm',6828.0,9.01,'Borgo Maggiore','Borgo Maggiore').
province('Chiesanuova','sm',982.0,5.46,'Chiesanuova','Chiesanuova').
province('Domagnano','sm',2808.0,6.62,'Domagnano','Domagnano').
province('Faetano','sm',1010.0,7.75,'Faetano','Faetano').
province('Fiorentino','sm',2147.0,6.56,'Fiorentino','Fiorentino').
province('Montegiardino','sm',796.0,3.31,'Montegiardino','Montegiardino').
province('San Marino','sm',4758.0,7.09,0.0,0.0).
province('Serravalle','sm',9565.0,10.53,'Serravalle','Serravalle').
province('Agua Grande','st',65151.0,17.0,0.0,0.0).
province('Cantagalo','st',14232.0,119.0,0.0,0.0).
province('Caue','st',7051.0,267.0,0.0,0.0).
province('Lemba','st',11737.0,229.0,0.0,0.0).
province('Lobata','st',19867.0,105.0,0.0,0.0).
province('Me-Zochi','st',42186.0,122.0,0.0,0.0).
province('Pague','st',6433.0,142.0,0.0,0.0).
province('al-Bahah','sa',574908.0,9921.0,0.0,0.0).
province('al-Hudud-as-Samaliyah','sa',233579.0,111797.0,0.0,0.0).
province('al-Jawf','sa',380295.0,100212.0,0.0,0.0).
province('al-Madinah','sa',1467264.0,151990.0,0.0,0.0).
province('al-Qasim','sa',1069681.0,58046.0,0.0,0.0).
province('Asir','sa',1699945.0,76693.0,'Abha','Asir').
province('as-Sarqiyah','sa',3035663.0,672522.0,0.0,0.0).
province('Hail','sa',554299.0,103887.0,'Hail','Hail').
province('Jizan','sa',1223911.0,11671.0,'Jizan','Jizan').
province('Makkah','sa',5627381.0,153128.0,0.0,0.0).
province('Najran','sa',415639.0,149511.0,'Najran','Najran').
province('Riyadh','sa',4885639.0,404240.0,'Riyadh','Riyadh').
province('Tabuk','sa',603405.0,146072.0,'Tabuk','Tabuk').
province('Dakar','sn',2702820.0,550.0,'Dakar','Dakar').
province('Diourbel','sn',1032003.0,4359.0,'Diourbel','Diourbel').
province('Fatick','sn',674388.0,7935.0,'Fatick','Fatick').
province('Kaolack','sn',1226311.0,16010.0,'Kaolack','Kaolack').
province('Kolda','sn',908812.0,21011.0,'Kolda','Kolda').
province('Louga','sn',570255.0,29188.0,'Louga','Louga').
province('Saint-Louis','sn',921912.0,44127.0,'Saint-Louis','Saint-Louis').
province('Tambacounda','sn',573362.0,59602.0,'Tambacounda','Tambacounda').
province('Thies','sn',1477564.0,6601.0,'Thies','Thies').
province('Ziguinchor','sn',606795.0,7339.0,'Ziguinchor','Ziguinchor').
province('Central Serbia','yu',5670230.0,55968.0,0.0,0.0).
province('Kosovo and Metohija','yu',2160501.0,10887.0,0.0,0.0).
province('Montenegro','yu',716031.0,13812.0,0.0,0.0).
province('Vojvodina','yu',2134415.0,21506.0,0.0,0.0).
province('Anse aux Pins','sc',3525.0,1.9,0.0,0.0).
province('Anse Boileau','sc',3738.0,11.2,0.0,0.0).
province('Anse Etoile','sc',3892.0,5.3,0.0,0.0).
province('Anse Royale','sc',3715.0,6.0,0.0,0.0).
province('Au Cap','sc',2797.0,8.1,0.0,0.0).
province('Baie Lazare','sc',2662.0,11.5,0.0,0.0).
province('Baie Sainte Anne','sc',3793.0,25.1,0.0,0.0).
province('Beau Vallon','sc',3812.0,3.7,0.0,0.0).
province('Bel Air','sc',3862.0,4.0,0.0,0.0).
province('Belombre','sc',3350.0,8.5,0.0,0.0).
province('Cascade','sc',2996.0,9.7,0.0,0.0).
province('English River','sc',2536.0,1.4,0.0,0.0).
province('Glacis','sc',3633.0,6.6,0.0,0.0).
province('Grand Anse Mahe','sc',2593.0,14.5,0.0,0.0).
province('Grand Anse Praslin','sc',3062.0,14.4,0.0,0.0).
province('La Digue and Inner Islands','sc',3116.0,56.0,0.0,0.0).
province('Les Mamelles','sc',2966.0,4.2,0.0,0.0).
province('Mont Buxton','sc',2771.0,1.0,0.0,0.0).
province('Mont Fleuri','sc',3785.0,1.5,0.0,0.0).
province('Outer Islands','sc',1525.0,211.3,0.0,0.0).
province('Plaisance','sc',3906.0,2.9,0.0,0.0).
province('Pointe Larue','sc',2495.0,3.6,0.0,0.0).
province('Port Glaud','sc',2747.0,25.4,0.0,0.0).
province('Roche Caiman','sc',2176.0,2.6,0.0,0.0).
province('Saint Louis','sc',3672.0,0.8,0.0,0.0).
province('Takamaka','sc',3369.0,13.8,0.0,0.0).
province('Eastern','sl',1293835.0,15553.0,0.0,0.0).
province('Northern','sl',1700183.0,35936.0,0.0,0.0).
province('Southern','sl',997446.0,19694.0,0.0,0.0).
province('Western','sl',1190761.0,557.0,0.0,0.0).
province('Banskobystricky','sk',662121.0,9455.0,0.0,0.0).
province('Bratislavsky','sk',599015.0,2053.0,0.0,0.0).
province('Kosicky','sk',766012.0,6753.0,0.0,0.0).
province('Nitriansky','sk',713422.0,6343.0,0.0,0.0).
province('Presovsky','sk',789968.0,8993.0,0.0,0.0).
province('Trenciansky','sk',605582.0,4501.0,0.0,0.0).
province('Trnavsky','sk',551003.0,4148.0,0.0,0.0).
province('Zilinsky','sk',692332.0,6788.0,0.0,0.0).
province('Gorenjska','si',196012.0,2137.0,0.0,0.0).
province('Goriska','si',117031.0,2326.0,0.0,0.0).
province('Jugovzodna Slovenija','si',136438.0,2685.0,0.0,0.0).
province('Koroska','si',72822.0,1040.0,0.0,0.0).
province('Notranjsko-kraska','si',50258.0,1456.0,0.0,0.0).
province('Obalno-kraska','si',100828.0,1045.0,0.0,0.0).
province('Osrednjeslovenska','si',491407.0,2545.0,0.0,0.0).
province('Podravska','si',307391.0,2169.0,0.0,0.0).
province('Pomurska','si',120046.0,1369.0,0.0,0.0).
province('Savinjska','si',252114.0,2352.0,0.0,0.0).
province('Spodnjeposavska','si',67710.0,885.0,0.0,0.0).
province('Zasavska','si',44859.0,264.0,0.0,0.0).
province('Central','sb',23823.0,615.0,'Tulagi','Central').
province('Choiseul','sb',23051.0,3837.0,'Taro Island','Choiseul').
province('Guadalcanal','sb',65221.0,5336.0,'Honiara','Guadalcanal').
province('Honiara','sb',60406.0,22.0,'Honiara','Guadalcanal').
province('Isabel','sb',23173.0,4136.0,'Buala','Isabel').
province('Makira and Ulawa','sb',35529.0,3188.0,0.0,0.0).
province('Malaita','sb',143107.0,4225.0,'Auki','Malaita').
province('Rennell and Bellona','sb',2565.0,671.0,0.0,0.0).
province('Temotu','sb',20697.0,895.0,'Lata','Temotu').
province('Western','sb',73089.0,5475.0,'Gizo','Western').
province('Awdal','so',401181.0,21374.0,0.0,0.0).
province('Bakol','so',350709.0,26962.0,0.0,0.0).
province('Banadir','so',1226654.0,370.0,0.0,0.0).
province('Bari','so',524293.0,70088.0,0.0,0.0).
province('Bay','so',1063682.0,35156.0,0.0,0.0).
province('Galgudud','so',603539.0,46126.0,0.0,0.0).
province('Gedo','so',554483.0,60389.0,0.0,0.0).
province('Hiran','so',517218.0,31510.0,0.0,0.0).
province('Jubbada Dexe','so',348586.0,9836.0,0.0,0.0).
province('Jubbada Hose','so',642454.0,42876.0,0.0,0.0).
province('Mudug','so',733964.0,72933.0,0.0,0.0).
province('Nugal','so',15377.0,26180.0,0.0,0.0).
province('Sabellaha Dexe','so',830191.0,22663.0,0.0,0.0).
province('Sabellaha Hose','so',1345759.0,25285.0,0.0,0.0).
province('Sanag','so',510614.0,53374.0,0.0,0.0).
province('Sol','so',110849.0,25036.0,0.0,0.0).
province('Togder','so',905427.0,38663.0,0.0,0.0).
province('Woqoyi Galbed','so',1143634.0,28836.0,0.0,0.0).
province('Eastern Cape','za',6490717.0,169580.0,0.0,0.0).
province('Free State','za',2740952.0,129480.0,'Bloemfontein','Free State').
province('KwaZulu Natal','za',1.0154456E7,92100.0,0.0,0.0).
province('Limpopo','za',5494932.0,123910.0,0.0,0.0).
province('Northern Cape','za',819382.0,361830.0,'Kimber','Northern Cape').
province('North West','za',3895130.0,116320.0,0.0,0.0).
province('Western Cape','za',4988159.0,129370.0,'Cape Town','Western Cape').
province('A Coruna','es',1106419.0,7876.0,0.0,0.0).
province('Alacant','es',1707967.0,5863.0,0.0,0.0).
province('Alava','es',296849.0,3047.0,0.0,0.0).
province('Albacete','es',379897.0,14862.0,0.0,0.0).
province('Almeria','es',585679.0,8774.0,0.0,0.0).
province('Asturias','es',1047653.0,10604.0,0.0,0.0).
province('Avila','es',162442.0,8048.0,0.0,0.0).
province('Badajoz','es',652543.0,21657.0,0.0,0.0).
province('Balears','es',972015.0,4992.0,0.0,0.0).
province('Barcelona','es',5192965.0,7733.0,0.0,0.0).
province('Burgos','es',353411.0,14309.0,0.0,0.0).
province('Caceres','es',443741.0,19945.0,0.0,0.0).
province('Cadiz','es',1152782.0,7385.0,0.0,0.0).
province('Cantabria','es',548432.0,5321.0,'Santander','Cantabria').
province('Castello','es',539511.0,6679.0,0.0,0.0).
province('Ceuta','es',71436.0,18.0,0.0,0.0).
province('Ciudad Real','es',489359.0,19749.0,0.0,0.0).
province('Cordoba','es',769355.0,13718.0,0.0,0.0).
province('Cuenca','es',205355.0,17061.0,0.0,0.0).
province('Girona','es',642681.0,5886.0,0.0,0.0).
province('Granada','es',849934.0,12531.0,0.0,0.0).
province('Guadalajara','es',204149.0,12190.0,0.0,0.0).
province('Guipuzcoa','es',680750.0,1997.0,0.0,0.0).
province('Huelva','es',474338.0,10085.0,0.0,0.0).
province('Huesca','es',213985.0,15613.0,0.0,0.0).
province('Jaen','es',646277.0,13498.0,0.0,0.0).
province('La Rioja','es',295512.0,5045.0,'Logrono','La Rioja').
province('Las Palmas','es',966378.0,4072.0,0.0,0.0).
province('Leon','es',480565.0,15468.0,0.0,0.0).
province('Lleida','es',385195.0,12028.0,0.0,0.0).
province('Lugo','es',345658.0,9803.0,0.0,0.0).
province('Madrid','es',5998759.0,8028.0,'Madrid','Madrid').
province('Malaga','es',1420397.0,7276.0,0.0,0.0).
province('Melilla','es',66419.0,14.0,0.0,0.0).
province('Murcia','es',1325630.0,11314.0,0.0,0.0).
province('Navarra','es',588687.0,10391.0,'Pamplona','Navarra').
province('Ourense','es',331793.0,7278.0,0.0,0.0).
province('Palencia','es',168994.0,8035.0,0.0,0.0).
province('Pontevedra','es',921821.0,4477.0,0.0,0.0).
province('Salamanca','es',342972.0,12336.0,0.0,0.0).
province('Santa Cruz de Tenerife','es',886077.0,3170.0,0.0,0.0).
province('Segovia','es',151861.0,6949.0,0.0,0.0).
province('Sevilla','es',1772964.0,14001.0,0.0,0.0).
province('Soria','es',90659.0,10287.0,0.0,0.0).
province('Tarragona','es',691923.0,6283.0,0.0,0.0).
province('Teruel','es',140444.0,14785.0,0.0,0.0).
province('Toledo','es',594201.0,15368.0,0.0,0.0).
province('Valencia','es',2366018.0,10763.0,0.0,0.0).
province('Valladolid','es',507247.0,8202.0,0.0,0.0).
province('Vizcaya','es',1120385.0,2217.0,0.0,0.0).
province('Zamora','es',193918.0,10559.0,0.0,0.0).
province('Zaragoza','es',890734.0,17252.0,0.0,0.0).
province('Amparai','lk',614676.0,4415.0,0.0,0.0).
province('Anuradhapura','lk',755432.0,7179.0,0.0,0.0).
province('Badulla','lk',777264.0,2861.0,0.0,0.0).
province('Batticaloa','lk',515738.0,2854.0,0.0,0.0).
province('Colombo','lk',2273238.0,699.0,0.0,0.0).
province('Galle','lk',994995.0,1652.0,0.0,0.0).
province('Gampaha','lk',2146055.0,1387.0,0.0,0.0).
province('Hambantota','lk',529442.0,2609.0,0.0,0.0).
province('Jaffna','lk',962448.0,1025.0,0.0,0.0).
province('Kalatura','lk',1074696.0,1598.0,0.0,0.0).
province('Kandy','lk',1277645.0,1940.0,0.0,0.0).
province('Kegalla','lk',774545.0,1693.0,0.0,0.0).
province('Kilinochchi','lk',118195.0,1279.0,0.0,0.0).
province('Kurunegala','lk',1455528.0,4816.0,0.0,0.0).
province('Mannarama','lk',160145.0,1996.0,0.0,0.0).
province('Matale','lk',445869.0,1993.0,0.0,0.0).
province('Matara','lk',761063.0,1283.0,0.0,0.0).
province('Monaragala','lk',410076.0,5639.0,0.0,0.0).
province('Mullaitivu','lk',109030.0,2617.0,0.0,0.0).
province('Nuwara Eliya','lk',697638.0,1741.0,0.0,0.0).
province('Polonnaruwa','lk',368460.0,3293.0,0.0,0.0).
province('Puttalama','lk',728607.0,3072.0,0.0,0.0).
province('Ratnapura','lk',1019513.0,3275.0,0.0,0.0).
province('Trincomalee','lk',365845.0,2727.0,0.0,0.0).
province('Vavuniya','lk',130424.0,1967.0,0.0,0.0).
province('Aali-an-Nil','sd',1180975.0,77773.0,0.0,0.0).
province('al-Bahr-al-Ahmar','sd',1102703.0,218887.0,0.0,0.0).
province('al-Buhayrat','sd',555337.0,40235.0,0.0,0.0).
province('al-Jazirah','sd',2743655.0,23373.0,0.0,0.0).
province('al-Qadarif','sd',1341487.0,75263.0,0.0,0.0).
province('al-Wahdah','sd',258458.0,35956.0,0.0,0.0).
province('an-Nil-al-Abyad','sd',1160638.0,30411.0,0.0,0.0).
province('an-Nil-al-Azraq','sd',1164990.0,45844.0,0.0,0.0).
province('as-Samaliyah','sd',811901.0,348765.0,0.0,0.0).
province('Bahr-al-Jabal','sd',327174.0,22956.0,0.0,0.0).
province('Garb-al-Istiwaiyah','sd',1696306.0,79319.0,0.0,0.0).
province('Garb Bahr-al-Gazal','sd',1442280.0,93900.0,0.0,0.0).
province('Garb Darfur','sd',987103.0,79460.0,0.0,0.0).
province('Garb Kurdufan','sd',1295336.0,111373.0,0.0,0.0).
province('Janub Darfur','sd',2815621.0,127300.0,0.0,0.0).
province('Janub Kurdufan','sd',1092725.0,79470.0,0.0,0.0).
province('Junqali','sd',1170062.0,122479.0,0.0,0.0).
province('Kassala','sd',1145879.0,36710.0,'Kassala','Kassala').
province('Khartoum','sd',4199555.0,22142.0,'Khartoum','Khartoum').
province('Nahr-an-Nil','sd',1008497.0,122123.0,0.0,0.0).
province('Samal Bahr-al-Gazal','sd',812338.0,33558.0,0.0,0.0).
province('Samal Darfur','sd',1551432.0,296420.0,0.0,0.0).
province('Samal Kurdufan','sd',2479070.0,185302.0,0.0,0.0).
province('Sarq-al-Istiwaiyah','sd',223201.0,82542.0,0.0,0.0).
province('Sinnar','sd',1502050.0,37844.0,0.0,0.0).
province('Warab','sd',966904.0,31027.0,0.0,0.0).
province('Brokopondo','sr',8553.0,7364.0,'Brokopondo','Brokopondo').
province('Commewijne','sr',25908.0,2353.0,'Nieuw Amsterdam','Commewijne').
province('Coronie','sr',4065.0,3902.0,'Totness','Coronie').
province('Marowijne','sr',20950.0,4627.0,'Albina','Marowijne').
province('Nickerie','sr',42377.0,5353.0,'Nieuw Nickerie','Nickerie').
province('Para','sr',15577.0,5393.0,'Onverwacht','Para').
province('Paramaribo','sr',220306.0,183.0,'Paramaribo','Paramaribo').
province('Saramacca','sr',14107.0,3636.0,'Groningen','Saramacca').
province('Sipaliwini','sr',30203.0,130567.0,0.0,0.0).
province('Wanica','sr',78696.0,442.0,'Lelydorp','Wanica').
province('Jan Mayen','sj',16.0,377.0,0.0,0.0).
province('Svalbard','sj',2265.0,61229.0,0.0,0.0).
province('Hhohho','sz',308365.0,3569.0,0.0,0.0).
province('Lubombo','sz',224437.0,5945.0,0.0,0.0).
province('Manzini','sz',354153.0,4070.0,0.0,0.0).
province('Shiselweni','sz',234982.0,3779.0,0.0,0.0).
province('Blekinge','se',149895.0,2941.0,'Karlskrona','Blekinge').
province('Dalarna','se',276089.0,28193.0,'Falun','Dalarna').
province('Gaevleborg','se',276382.0,18192.0,0.0,0.0).
province('Gotland','se',57810.0,3140.0,'Visby','Gotland').
province('Halland','se',286714.0,5454.0,'Halmstad','Halland').
province('Jaemtland','se',126977.0,49443.0,0.0,0.0).
province('Joenkoeping','se',330231.0,9944.0,0.0,0.0).
province('Kalmar','se',235218.0,11171.0,'Kalmar','Kalmar').
province('Kronoberg','se',178255.0,8458.0,0.0,0.0).
province('Norrbotten','se',251365.0,98911.0,'Lulea','Norrbotten').
province('Oerebro','se',274864.0,8517.0,0.0,0.0).
province('Oestergoetland','se',417655.0,10562.0,0.0,0.0).
province('Skane','se',1167591.0,11027.0,0.0,0.0).
province('Soedermanland','se',262867.0,6062.0,0.0,0.0).
province('Stockholm','se',1883279.0,6490.0,'Stockholm','Stockholm').
province('Uppsala','se',304331.0,6989.0,'Uppsala','Uppsala').
province('Vaermland','se',273634.0,17586.0,0.0,0.0).
province('Vaesterbotten','se',257290.0,55401.0,0.0,0.0).
province('Vaesternorrland','se',243429.0,21678.0,0.0,0.0).
province('Vaestmanland','se',262293.0,6302.0,0.0,0.0).
province('Vaestra Goetaland','se',1527821.0,24473.0,0.0,0.0).
province('Aargau','ch',574172.0,1403.63,'Aarau','Aargau').
province('Appenzell Inner-Rhoden','ch',15499.0,172.51,0.0,0.0).
province('Appenzell-Outer Rhoden','ch',51829.0,242.87,0.0,0.0).
province('Basel-Landschaft','ch',265584.0,517.45,'Liestal','Basel-Landschaft').
province('Basel-Town','ch',182077.0,37.06,0.0,0.0).
province('Bern','ch',955659.0,5960.88,'Bern','Bern').
province('Fribourg','ch',248952.0,1670.81,'Fribourg','Fribourg').
province('Geneva','ch',433977.0,282.25,0.0,0.0).
province('Glarus','ch',37372.0,685.1,'Glarus','Glarus').
province('Graubuenden','ch',181082.0,7105.46,0.0,0.0).
province('Jura','ch',69935.0,836.51,'Delemont','Jura').
province('Luzern','ch',362215.0,1493.4,'Luzern','Luzern').
province('Neuchatel','ch',168810.0,803.06,'Neuchatel','Neuchatel').
province('Nidwalden','ch',40793.0,276.12,'Stans','Nidwalden').
province('Obwalden','ch',33716.0,490.5,'Sarnen','Obwalden').
province('Saint Gall','ch',462877.0,2025.51,0.0,0.0).
province('Schaffhausen','ch',73443.0,298.52,'Schaffhausen','Schaffhausen').
province('Schwyz','ch',135461.0,908.33,'Schwyz','Schwyz').
province('Solothurn','ch',250155.0,790.67,'Solothurn','Solothurn').
province('Thurgau','ch',230600.0,990.98,'Frauenfeld','Thurgau').
province('Ticino','ch',317006.0,2812.48,'Bellinzona','Ticino').
province('Uri','ch',34089.0,1076.58,'Altdorf','Uri').
province('Valais','ch',284653.0,5224.56,'Sion','Valais').
province('Vaud','ch',646234.0,3211.79,'Lausanne','Vaud').
province('Zug','ch',106351.0,238.79,'Zug','Zug').
province('Zurich','ch',1289560.0,1728.76,'Zurich','Zurich').
province('Aleppo','sy',3115516.0,18500.0,0.0,0.0).
province('al-Hasakah','sy',1204443.0,23334.0,0.0,0.0).
province('al-Ladiqiyah','sy',1170086.0,2297.0,0.0,0.0).
province('al-Qunaytirah','sy',36144.0,1861.0,0.0,0.0).
province('ar-Raqqah','sy',742595.0,19616.0,0.0,0.0).
province('as-Suwayda','sy',502461.0,5550.0,0.0,0.0).
province('Damascus','sy',1599599.0,105.0,0.0,0.0).
province('Dara','sy',908287.0,3730.0,'Dara','Dara').
province('Dayr-az-Zawr','sy',1460383.0,33060.0,0.0,0.0).
province('Hamah','sy',1872725.0,8883.0,'Hamah','Hamah').
province('Hims','sy',18958.0,42223.0,'Hims','Hims').
province('Idlib','sy',1781495.0,6097.0,'Idlib','Idlib').
province('Tartus','sy',902617.0,1892.0,'Tartus','Tartus').
province('Changhwa','tw',1248845.0,1074.0,0.0,0.0).
province('Chiayi Hsien','tw',547945.0,1902.0,0.0,0.0).
province('Chiayi Shih','tw',266317.0,60.0,0.0,0.0).
province('Hsinchu Hsien','tw',482993.0,1428.0,0.0,0.0).
province('Hsinchu Shih','tw',413683.0,104.0,0.0,0.0).
province('Hualien','tw',314807.0,4629.0,0.0,0.0).
province('Ilan','tw',438164.0,2137.0,0.0,0.0).
province('Kaohsiung Hsien','tw',1297574.0,2793.0,0.0,0.0).
province('Kaohsiung Shih','tw',1512832.0,154.0,0.0,0.0).
province('Keelung Shih','tw',397516.0,133.0,0.0,0.0).
province('Kinmen','tw',49410.0,148.0,0.0,0.0).
province('Lienkang','tw',15560.0,27.0,0.0,0.0).
province('Miaoli','tw',525339.0,1820.0,0.0,0.0).
province('Nantou','tw',463429.0,4106.0,0.0,0.0).
province('Penghu','tw',76375.0,127.0,0.0,0.0).
province('Pingtung','tw',850751.0,2776.0,0.0,0.0).
province('Taichung Hsien','tw',1590286.0,2051.0,0.0,0.0).
province('Taichung Shih','tw',1083582.0,163.0,0.0,0.0).
province('Tainan Hsien','tw',1141645.0,2016.0,0.0,0.0).
province('Tainan Shih','tw',734314.0,176.0,0.0,0.0).
province('Taipei Hsien','tw',39753.0,2052.0,0.0,0.0).
province('Taipei Shih','tw',2498356.0,272.0,0.0,0.0).
province('Taitung','tw',182454.0,3515.0,0.0,0.0).
province('Taoyuan','tw',2004176.0,1221.0,0.0,0.0).
province('Yunlin','tw',683085.0,1291.0,0.0,0.0).
province('Dushanbe','tj',543105.0,300.0,0.0,0.0).
province('Gorno-Badakhshan','tj',225613.0,63700.0,0.0,0.0).
province('Karotegin','tj',1441133.0,28400.0,0.0,0.0).
province('Khatlon','tj',2337727.0,24600.0,0.0,0.0).
province('Dar es Salaam','tz',2791055.0,1393.0,'Dar es Salaam','Dar es Salaam').
province('Iringa','tz',1552568.0,56864.0,'Iringa','Iringa').
province('Kigoma','tz',1882444.0,37037.0,0.0,0.0).
province('Lindi','tz',816729.0,66046.0,'Lindi','Lindi').
province('Manyara','tz',1148091.0,45820.0,'Babati','Manyara').
province('Mbeya','tz',2195881.0,60350.0,'Mbeya','Mbeya').
province('Mtwara','tz',1168984.0,16707.0,0.0,0.0).
province('Mwanza','tz',3173890.0,19592.0,'Mwanza','Mwanza').
province('Rukwa','tz',1249389.0,68635.0,'Sumbawanga','Rukwa').
province('Shinyanga','tz',3037054.0,50781.0,'Shinyanga','Shinyanga').
province('Tabora','tz',1869318.0,76151.0,'Tabora','Tabora').
province('Zanzibar and Pemba','tz',1060413.0,854.0,0.0,0.0).
province('Amnat Charoen','th',386738.0,3161.2,0.0,0.0).
province('Ang Thong','th',318583.0,968.4,0.0,0.0).
province('Bangkok Metropolitan Area','th',5104475.0,1565.2,0.0,0.0).
province('Buri Ram','th',1612597.0,10321.9,0.0,0.0).
province('Chachoengsao','th',669036.0,5351.0,0.0,0.0).
province('Chai Nat','th',336854.0,2469.7,0.0,0.0).
province('Chaiyaphum','th',1185521.0,12778.3,0.0,0.0).
province('Chanthaburi','th',547887.0,6338.0,0.0,0.0).
province('Chiang Mai','th',1763559.0,20107.1,0.0,0.0).
province('Chiang Rai','th',1494050.0,11678.4,0.0,0.0).
province('Chon Buri','th',1289423.0,4363.0,0.0,0.0).
province('Chumphon','th',511972.0,6009.0,0.0,0.0).
province('Kalasin','th',1084082.0,6946.7,0.0,0.0).
province('Kamphaeng Phet','th',912528.0,8607.5,0.0,0.0).
province('Kanchanaburi','th',896178.0,19483.2,0.0,0.0).
province('Khon Kaen','th',1807627.0,10886.0,0.0,0.0).
province('Krabi','th',442240.0,4708.5,0.0,0.0).
province('Lampang','th',823111.0,12534.0,0.0,0.0).
province('Lamphun','th',398151.0,4505.9,0.0,0.0).
province('Loei','th',676087.0,11424.6,0.0,0.0).
province('Lop Buri','th',795093.0,6199.7,0.0,0.0).
province('Mae Hong Son','th',287828.0,12681.2,0.0,0.0).
province('Maha Sarakham','th',936780.0,5291.7,0.0,0.0).
province('Mukdahan','th',377368.0,4339.8,0.0,0.0).
province('Nakhon Nayok','th',263221.0,2122.0,0.0,0.0).
province('Nakhon Pathom','th',790754.0,2168.3,0.0,0.0).
province('Nakhon Phanom','th',769859.0,5512.7,0.0,0.0).
province('Nakhon Ratchasima','th',2604979.0,20494.0,0.0,0.0).
province('Nakhon Sawan','th',1178742.0,9597.7,0.0,0.0).
province('Nakhon Si Thammarat','th',1544410.0,9942.5,0.0,0.0).
province('Nan','th',530896.0,11472.1,0.0,0.0).
province('Narathiwat','th',751921.0,4475.4,0.0,0.0).
province('Nong Bua Lam Phu','th',518520.0,3859.1,0.0,0.0).
province('Nong Khai','th',939455.0,7332.3,0.0,0.0).
province('Nonthaburi','th',1045340.0,622.3,0.0,0.0).
province('Pathum Thani','th',767951.0,1525.9,0.0,0.0).
province('Pattani','th',671530.0,1940.4,0.0,0.0).
province('Phangnga','th',245236.0,4170.9,0.0,0.0).
province('Phatthalung','th',512156.0,3424.5,0.0,0.0).
province('Phayao','th',512957.0,6335.1,0.0,0.0).
province('Phetchabun','th',1151324.0,12668.4,0.0,0.0).
province('Phetchaburi','th',499811.0,6225.1,0.0,0.0).
province('Phichit','th',614516.0,4531.0,0.0,0.0).
province('Phitsanulok','th',971459.0,10815.8,0.0,0.0).
province('Phrae','th',472464.0,6538.6,0.0,0.0).
province('Phra Nakhon Si Ayutthaya','th',779300.0,2556.6,0.0,0.0).
province('Phuket','th',319230.0,543.0,0.0,0.0).
province('Prachin Buri','th',527152.0,4762.4,0.0,0.0).
province('Prachuap Khiri Khan','th',551706.0,6367.6,0.0,0.0).
province('Ranong','th',166291.0,3298.0,0.0,0.0).
province('Ratchaburi','th',883648.0,5196.5,0.0,0.0).
province('Rayong','th',581051.0,3552.0,0.0,0.0).
province('Roi Et','th',1411066.0,8299.4,0.0,0.0).
province('Sa Kaeo','th',625008.0,7195.1,0.0,0.0).
province('Sakon Nakhon','th',1201903.0,9605.8,0.0,0.0).
province('Samut Prakan','th',1041844.0,1004.1,0.0,0.0).
province('Samut Sakhon','th',424336.0,872.4,0.0,0.0).
province('Samut Songkhran','th',204701.0,416.7,0.0,0.0).
province('Saraburi','th',696090.0,3576.5,0.0,0.0).
province('Satun','th',303695.0,2479.0,0.0,0.0).
province('Sing Buri','th',209502.0,822.5,0.0,0.0).
province('Si Sa Ket','th',1525535.0,8840.0,0.0,0.0).
province('Songkhla','th',1292287.0,7393.9,0.0,0.0).
province('Sukhothai','th',665993.0,6596.1,0.0,0.0).
province('Suphan Buri','th',868149.0,5358.0,0.0,0.0).
province('Surat Thani','th',991523.0,12891.5,0.0,0.0).
province('Surin','th',1491395.0,8124.0,0.0,0.0).
province('Tak','th',540056.0,16406.6,0.0,0.0).
province('Trang','th',612757.0,4917.5,0.0,0.0).
province('Trat','th',234294.0,2819.0,0.0,0.0).
province('Ubon Ratchathani','th',1939213.0,1574.0,0.0,0.0).
province('Udon Thani','th',1636041.0,11730.3,0.0,0.0).
province('Uthai Thani','th',381376.0,6730.2,0.0,0.0).
province('Uttaradit','th',511097.0,7838.6,0.0,0.0).
province('Yala','th',524191.0,4521.1,0.0,0.0).
province('Yasothon','th',543846.0,4161.6,0.0,0.0).
province('Centre','tg',501793.0,13182.0,0.0,0.0).
province('Kara','tg',748662.0,11630.0,'Kara','Kara').
province('Maritime','tg',1882313.0,6396.0,'Lome','Maritime').
province('Plateaux','tg',1536018.0,16975.0,'Atakpame','Plateaux').
province('Savanes','tg',604201.0,8602.0,'Dapaong','Savanes').
province('Atafu','tk',583.0,2.03,0.0,0.0).
province('Fakaofo','tk',470.0,2.63,0.0,0.0).
province('Nukunonu','tk',360.0,5.46,0.0,0.0).
province('Eua','to',5242.0,87.44,'Ohonua','Eua').
province('Haapai','to',8570.0,109.98,'Pangai','Haapai').
province('Niuas','to',2116.0,71.69,'Hihifo','Niuas').
province('Tongatapu','to',70319.0,260.48,'Nukualofa','Tongatapu').
province('Vavau','to',16811.0,121.0,'Neiafu','Vavau').
province('Arima','tt',34996.0,11.0,0.0,0.0).
province('Chaguanas','tt',72158.0,60.0,0.0,0.0).
province('Couva-Tabaquite-Talparo','tt',168560.0,703.0,0.0,0.0).
province('Diego Martin','tt',111964.0,149.0,0.0,0.0).
province('Mayaro-Rio Claro','tt',31337.0,853.0,0.0,0.0).
province('Penal Debe','tt',87154.0,237.0,0.0,0.0).
province('Point Fortin','tt',18918.0,23.0,0.0,0.0).
province('Port of Spain','tt',49658.0,10.0,0.0,0.0).
province('Princes Town','tt',91946.0,617.0,0.0,0.0).
province('San Fernando','tt',56379.0,8.0,0.0,0.0).
province('Sangre Grande','tt',70371.0,895.0,0.0,0.0).
province('San Juan-Laventville','tt',160710.0,232.0,0.0,0.0).
province('Siparia','tt',79760.0,531.0,0.0,0.0).
province('Tobago','tt',57177.0,303.0,0.0,0.0).
province('Tunapuna-Piarco','tt',219527.0,496.0,0.0,0.0).
province('al-Kaf','tn',284196.0,4965.0,0.0,0.0).
province('al-Mahdiyah','tn',391808.0,2966.0,0.0,0.0).
province('al-Munastir','tn',453602.0,1019.0,0.0,0.0).
province('al-Qasrayn','tn',437190.0,8066.0,0.0,0.0).
province('al-Qayrawan','tn',582427.0,6712.0,0.0,0.0).
province('Aryanah','tn',412361.0,498.0,0.0,0.0).
province('Bajah','tn',324555.0,3558.0,0.0,0.0).
province('Bin Arus','tn',501924.0,761.0,0.0,0.0).
province('Binzart','tn',542091.0,3685.0,0.0,0.0).
province('Jundubah','tn',438722.0,3102.0,0.0,0.0).
province('Madaniyin','tn',447400.0,8588.0,0.0,0.0).
province('Manubah','tn',345486.0,1060.0,0.0,0.0).
province('Nabul','tn',677771.0,2788.0,0.0,0.0).
province('Qabis','tn',346141.0,7175.0,0.0,0.0).
province('Qafsah','tn',341647.0,8990.0,0.0,0.0).
province('Qibili','tn',148621.0,22084.0,0.0,0.0).
province('Safaqis','tn',869530.0,7545.0,0.0,0.0).
province('Sidi Bu Zayd','tn',412539.0,6994.0,0.0,0.0).
province('Silyanah','tn',262365.0,4631.0,0.0,0.0).
province('Susah','tn',537838.0,2621.0,0.0,0.0).
province('Tatawin','tn',154522.0,38889.0,0.0,0.0).
province('Tawzar','tn',101730.0,4719.0,0.0,0.0).
province('Tunis','tn',939564.0,346.0,0.0,0.0).
province('Zagwan','tn',162284.0,2768.0,0.0,0.0).
province('Adana','tr',1997380.0,12788.0,0.0,0.0).
province('Adiyaman','tr',678395.0,7614.0,0.0,0.0).
province('Afyon','tr',840927.0,14230.0,0.0,0.0).
province('Agri','tr',572465.0,11376.0,0.0,0.0).
province('Aksaray','tr',433371.0,7626.0,0.0,0.0).
province('Amasya','tr',364418.0,5520.0,0.0,0.0).
province('Ankara','tr',4385932.0,25706.0,0.0,0.0).
province('Antalya','tr',2082437.0,20591.0,0.0,0.0).
province('Ardahan','tr',129450.0,5576.0,0.0,0.0).
province('Artvin','tr',181036.0,7436.0,0.0,0.0).
province('Aydin','tr',1009763.0,8007.0,0.0,0.0).
province('Balikesir','tr',1116652.0,14292.0,0.0,0.0).
province('Bartin','tr',173086.0,2140.0,0.0,0.0).
province('Batman','tr',499961.0,4694.0,0.0,0.0).
province('Bayburt','tr',92087.0,3652.0,0.0,0.0).
province('Bilecik','tr',201677.0,4307.0,0.0,0.0).
province('Bingoel','tr',255863.0,8125.0,0.0,0.0).
province('Bitlis','tr',415510.0,6707.0,0.0,0.0).
province('Bolu','tr',271651.0,10037.0,0.0,0.0).
province('Burdur','tr',255153.0,6887.0,0.0,0.0).
province('Bursa','tr',2375672.0,10963.0,0.0,0.0).
province('Canakkale','tr',476409.0,9737.0,0.0,0.0).
province('Cankiri','tr',276876.0,7388.0,0.0,0.0).
province('Corum','tr',585784.0,12820.0,0.0,0.0).
province('Denizli','tr',881417.0,11868.0,0.0,0.0).
province('Diyarbakir','tr',1496550.0,15355.0,0.0,0.0).
province('Duezce','tr',332037.0,1014.0,0.0,0.0).
province('Edirne','tr',397685.0,6276.0,0.0,0.0).
province('Elazig','tr',605724.0,9153.0,0.0,0.0).
province('Erzincan','tr',320688.0,11903.0,0.0,0.0).
province('Erzurum','tr',980226.0,25066.0,0.0,0.0).
province('Eskisehir','tr',731272.0,13652.0,0.0,0.0).
province('Gaziantep','tr',1438669.0,6207.0,0.0,0.0).
province('Giresun','tr',530550.0,6934.0,0.0,0.0).
province('Guemueshane','tr',194178.0,6575.0,0.0,0.0).
province('Hakkari','tr',270477.0,7121.0,0.0,0.0).
province('Hatay','tr',1282430.0,5403.0,0.0,0.0).
province('Icel','tr',1878683.0,15853.0,0.0,0.0).
province('Igdir','tr',180650.0,3539.0,0.0,0.0).
province('Isparta','tr',551132.0,8933.0,0.0,0.0).
province('Istanbul','tr',1.1588545E7,5220.0,0.0,0.0).
province('Izmir','tr',3734014.0,11973.0,0.0,0.0).
province('Kahramanmaras','tr',1055785.0,14327.0,0.0,0.0).
province('Karabuek','tr',214524.0,4074.0,0.0,0.0).
province('Karaman','tr',255352.0,9163.0,0.0,0.0).
province('Kars','tr',311240.0,9442.0,0.0,0.0).
province('Kastamonu','tr',353139.0,13108.0,0.0,0.0).
province('Kayseri','tr',1092232.0,16917.0,0.0,0.0).
province('Kilis','tr',113942.0,1338.0,0.0,0.0).
province('Kirikkale','tr',396178.0,4365.0,0.0,0.0).
province('Kirklareli','tr',334413.0,6550.0,0.0,0.0).
province('Kirsehir','tr',249148.0,6570.0,0.0,0.0).
province('Kocaeli','tr',1351230.0,3524.0,0.0,0.0).
province('Konya','tr',2452360.0,38157.0,0.0,0.0).
province('Kuetahya','tr',690433.0,11875.0,0.0,0.0).
province('Malatya','tr',925040.0,12313.0,0.0,0.0).
province('Manisa','tr',1299975.0,13810.0,0.0,0.0).
province('Mardin','tr',779008.0,8891.0,0.0,0.0).
province('Mugla','tr',796006.0,13338.0,0.0,0.0).
province('Mus','tr',490234.0,8196.0,0.0,0.0).
province('Nevsehir','tr',316821.0,5467.0,0.0,0.0).
province('Nigde','tr',368584.0,7312.0,0.0,0.0).
province('Ordu','tr',908724.0,6001.0,0.0,0.0).
province('Osmaniye','tr',500766.0,3320.0,0.0,0.0).
province('Rize','tr',370579.0,3920.0,0.0,0.0).
province('Sakarya','tr',769768.0,4817.0,0.0,0.0).
province('Samsun','tr',1211833.0,9579.0,0.0,0.0).
province('Sanliurfa','tr',1685216.0,18584.0,0.0,0.0).
province('Siirt','tr',272714.0,5406.0,0.0,0.0).
province('Sinop','tr',221342.0,5862.0,0.0,0.0).
province('Sirnak','tr',403810.0,7172.0,0.0,0.0).
province('Sivas','tr',738854.0,28488.0,0.0,0.0).
province('Tekirdag','tr',710828.0,6218.0,0.0,0.0).
province('Tokat','tr',876151.0,9958.0,0.0,0.0).
province('Trabzon','tr',1068762.0,4685.0,0.0,0.0).
province('Tunceli','tr',92670.0,7774.0,0.0,0.0).
province('Usak','tr',335663.0,5341.0,0.0,0.0).
province('Van','tr',1009486.0,19069.0,0.0,0.0).
province('Yalova','tr',185214.0,674.0,0.0,0.0).
province('Yozgat','tr',730817.0,14123.0,0.0,0.0).
province('Zonguldak','tr',592458.0,3481.0,0.0,0.0).
province('Ahal','tm',880688.0,95100.0,'Annau','Ahal').
province('Asgabat','tm',840243.0,300.0,0.0,0.0).
province('Balkan','tm',552007.0,138500.0,'Balkanabat','Balkan').
province('Dasoguz','tm',1366342.0,73600.0,0.0,0.0).
province('Lebap','tm',1388432.0,93800.0,0.0,0.0).
province('Mari','tm',1536522.0,86800.0,0.0,0.0).
province('Badakhshan','af',1062923.0,44059.27,0.0,0.0).
province('Badgis','af',792143.0,20590.64,0.0,0.0).
province('Baglan','af',872227.0,21118.4,0.0,0.0).
province('Balhz','af',1866473.0,17248.54,0.0,0.0).
province('Bamiyan','af',484645.0,14175.35,0.0,0.0).
province('Farah','af',470936.0,48470.9,'Farah','Farah').
province('Faryab','af',913858.0,20292.79,0.0,0.0).
province('Gawr','af',656108.0,36478.77,0.0,0.0).
province('Gazni','af',1097746.0,22914.58,0.0,0.0).
province('Herat','af',1382119.0,54778.05,'Herat','Herat').
province('Hilmand','af',925657.0,58583.68,0.0,0.0).
province('Jawzjan','af',747612.0,11798.3,0.0,0.0).
province('Kabul','af',3138232.0,4461.57,0.0,0.0).
province('Kapisa','af',472581.0,1842.14,'Mahmud-e Raqi','Kapisa').
province('Khowst','af',283283.0,4151.5,'Khowst','Khowst').
province('Kunar','af',562405.0,4941.53,'Asadabad','Kunar').
province('Lagman','af',651320.0,3842.58,0.0,0.0).
province('Lawgar','af',317152.0,3879.82,0.0,0.0).
province('Nangarhar','af',1538418.0,7727.36,'Jalalabad','Nangarhar').
province('Nimruz','af',234084.0,41005.39,'Zaranj','Nimruz').
province('Nuristan','af',152173.0,9224.96,0.0,0.0).
province('Paktika','af',476737.0,19482.4,'Sharan','Paktika').
province('Paktiya','af',503569.0,6431.75,0.0,0.0).
province('Parwan','af',786147.0,9584.44,0.0,0.0).
province('Qandahar','af',1665451.0,54021.96,0.0,0.0).
province('Qunduz','af',718819.0,8039.67,0.0,0.0).
province('Samangan','af',599326.0,11261.9,'Aybak','Samangan').
province('Sar-e Pul','af',727269.0,15999.22,0.0,0.0).
province('Tahzar','af',748211.0,12333.03,0.0,0.0).
province('Uruzgan','af',302236.0,30784.49,0.0,0.0).
province('Wardag','af',342048.0,8938.13,0.0,0.0).
province('Zabul','af',444583.0,17343.45,0.0,0.0).
province('Berat','al',128410.0,915.0,'Berat','Berat').
province('Bulqize','al',42985.0,718.0,0.0,0.0).
province('Delvine','al',10859.0,367.0,0.0,0.0).
province('Devoll','al',34744.0,429.0,0.0,0.0).
province('Dibre','al',86144.0,761.0,0.0,0.0).
province('Durres','al',182988.0,455.0,'Durres','Durres').
province('Elbasan','al',224974.0,1290.0,'Elbasan','Elbasan').
province('Fier','al',200154.0,850.0,'Fier','Fier').
province('Gjirokaster','al',55991.0,1137.0,'Gjirokaster','Gjirokaster').
province('Gramsh','al',35723.0,695.0,0.0,0.0).
province('Has','al',19842.0,374.0,0.0,0.0).
province('Kavaje','al',78415.0,393.0,0.0,0.0).
province('Kolonje','al',17179.0,805.0,0.0,0.0).
province('Korce','al',143499.0,1752.0,'Korce','Korce').
province('Kruje','al',64357.0,372.0,0.0,0.0).
province('Kucove','al',35571.0,112.0,0.0,0.0).
province('Kukes','al',64054.0,956.0,'Kukes','Kukes').
province('Kurbin','al',54519.0,235.0,0.0,0.0).
province('Lezhe','al',68218.0,479.0,'Lezhe','Lezhe').
province('Librazhd','al',72520.0,1102.0,0.0,0.0).
province('Lushnje','al',144351.0,712.0,0.0,0.0).
province('Mallakaster','al',39881.0,325.0,0.0,0.0).
province('Malsi e Madhe','al',36770.0,897.0,0.0,0.0).
province('Mat','al',61906.0,1028.0,0.0,0.0).
province('Mirdite','al',37055.0,867.0,0.0,0.0).
province('Peqin','al',32920.0,191.0,0.0,0.0).
province('Permet','al',25837.0,929.0,0.0,0.0).
province('Pogradec','al',70900.0,725.0,0.0,0.0).
province('Puke','al',34454.0,1034.0,0.0,0.0).
province('Sarande','al',35235.0,730.0,0.0,0.0).
province('Shkoder','al',185794.0,1631.0,'Shkoder','Shkoder').
province('Skrapar','al',29874.0,775.0,0.0,0.0).
province('Tepelene','al',32465.0,817.0,0.0,0.0).
province('Tirana','al',523150.0,1238.0,0.0,0.0).
province('Tropoje','al',28154.0,1043.0,0.0,0.0).
province('Vlore','al',147267.0,1609.0,'Vlore','Vlore').
province('Adrar','dz',369825.0,443782.0,0.0,0.0).
province('al-Agwat','dz',401914.0,26941.0,0.0,0.0).
province('al-Bayad','dz',270662.0,88984.0,0.0,0.0).
province('al-Buirah','dz',663946.0,4722.0,0.0,0.0).
province('Algiers','dz',3131443.0,865.0,0.0,0.0).
province('al-Jilfah','dz',1148970.0,33236.0,0.0,0.0).
province('al-Masilah','dz',928550.0,17891.0,0.0,0.0).
province('al-Wad','dz',617060.0,69434.0,0.0,0.0).
province('an-Naamah','dz',198682.0,33852.0,0.0,0.0).
province('Annabah','dz',597816.0,1410.0,0.0,0.0).
province('as-Salif','dz',988394.0,4440.0,0.0,0.0).
province('at-Tarif','dz',391561.0,2968.0,0.0,0.0).
province('Ayn ad-Dafla','dz',711367.0,4885.0,0.0,0.0).
province('Ayn Timusanat','dz',347986.0,2432.0,0.0,0.0).
province('Bassar','dz',251657.0,181020.0,0.0,0.0).
province('Batnah','dz',1070892.0,11855.0,0.0,0.0).
province('Bijayah','dz',909831.0,3404.0,0.0,0.0).
province('Biskrah','dz',678262.0,21094.0,0.0,0.0).
province('Blidah','dz',801917.0,1102.0,0.0,0.0).
province('Bumardas','dz',614419.0,1486.0,0.0,0.0).
province('Burj Bu Arririj','dz',626335.0,3676.0,0.0,0.0).
province('Constantine','dz',880032.0,2204.0,0.0,0.0).
province('Galizan','dz',670644.0,5208.0,0.0,0.0).
province('Gardayah','dz',342689.0,78107.0,0.0,0.0).
province('Hzansalah','dz',411023.0,9624.0,0.0,0.0).
province('Ilizi','dz',44893.0,179011.0,0.0,0.0).
province('Jijili','dz',616556.0,2622.0,0.0,0.0).
province('Medea','dz',732422.0,8330.0,0.0,0.0).
province('Milah','dz',770930.0,3436.0,0.0,0.0).
province('Mostaghanem','dz',685638.0,2165.0,0.0,0.0).
province('Muaskar','dz',721289.0,5699.0,0.0,0.0).
province('Qalmah','dz',465949.0,3842.0,0.0,0.0).
province('Saidah','dz',297679.0,7014.0,0.0,0.0).
province('Sakikdah','dz',866701.0,4197.0,0.0,0.0).
province('Satif','dz',1481161.0,6526.0,0.0,0.0).
province('Sidi balabbas','dz',561433.0,8306.0,0.0,0.0).
province('Suq Ahras','dz',406794.0,4029.0,0.0,0.0).
province('Tamanrasat','dz',192684.0,619360.0,0.0,0.0).
province('Tibazah','dz',476577.0,1700.0,0.0,0.0).
province('Tibissah','dz',626078.0,14207.0,0.0,0.0).
province('Tilimsan','dz',899504.0,9408.0,0.0,0.0).
province('Tinduf','dz',45675.0,182838.0,0.0,0.0).
province('Tisamsilt','dz',270726.0,3208.0,0.0,0.0).
province('Tiyarat','dz',800689.0,19556.0,0.0,0.0).
province('Tizi Wazu','dz',1160372.0,2592.0,0.0,0.0).
province('Umm-al-Bawagi','dz',602533.0,6712.0,0.0,0.0).
province('Wahran','dz',1265604.0,2145.0,0.0,0.0).
province('Warqla','dz',539974.0,230216.0,0.0,0.0).
province('Eastern','as',22191.0,90.0,0.0,0.0).
province('Manua','as',1205.0,49.0,0.0,0.0).
province('Rose Island','as',0.0,1.0,0.0,0.0).
province('Swains Island','as',50.0,5.0,0.0,0.0).
province('Western','as',38851.0,52.0,0.0,0.0).
province('Andorra la Vella','ad',20430.0,12.0,0.0,0.0).
province('Canillo','ad',3292.0,121.0,'Canillo','Canill').
province('Encamp','ad',11224.0,74.0,'Encamp','Encamp').
province('Escaldes-Engordany','ad',15854.0,47.0,0.0,0.0).
province('La Massana','ad',7211.0,61.0,'La Massana','La Massana').
province('Ordino','ad',2553.0,89.0,'Ordino','Ordino').
province('Sant Julia de Loria','ad',8020.0,60.0,'Sant Julia de Loria','Sant Julia de Loria').
province('Bengo','ao',192470.0,31371.0,'Caxito','Bengo').
province('Benguela','ao',720959.0,31788.0,'Benguela','Benguela').
province('Bie','ao',1336542.0,70314.0,'Kuito','Bie').
province('Cabinda','ao',214411.0,7270.0,'Cabinda','Cabinda').
province('Cunene','ao',241960.0,89342.0,'Ondjiva','Cunene').
province('Huambo','ao',1802826.0,34274.0,'Huambo','Huambo').
province('Huila','ao',948403.0,75002.0,'Lubango','Huila').
province('Kuando-Kubango','ao',130002.0,199049.0,0.0,0.0).
province('Kwanza Norte','ao',402361.0,24190.0,0.0,0.0).
province('Kwanza Sul','ao',653127.0,55660.0,0.0,0.0).
province('Luanda','ao',2776125.0,2418.0,'Luanda','Luanda').
province('Lunda Norte','ao',303524.0,102783.0,'Lucapa','Lunda Norte').
province('Lunda Sul','ao',146052.0,45649.0,'Saurimo','Lunda Sul').
province('Malanje','ao',1058413.0,97602.0,'Malanje','Malanje').
province('Moxico','ao',368431.0,223023.0,'Luena','Moxico').
province('Namibe','ao',164717.0,58137.0,'Namibe','Namibe').
province('Uige','ao',1080908.0,58698.0,'Uige','Uige').
province('Zaire','ao',377364.0,40130.0,0.0,0.0).
province('Barbuda','ag',1556.0,160.5,'Codrington','Barbuda').
province('Redonda','ag',0.0,1.5,0.0,0.0).
province('Saint George','ag',5393.0,24.0,'Parham','Saint Peter').
province('Saint John','ag',42721.0,74.0,'Saint Johns','Saint John').
province('Saint Mary','ag',6360.0,57.0,'Bolands','Saint Mary').
province('Saint Paul','ag',7325.0,48.0,0.0,0.0).
province('Saint Peter','ag',4321.0,33.0,'Parham','Saint Peter').
province('Saint Philip','ag',3599.0,44.0,0.0,0.0).
province('Buenos Aires','ar',1.418118E7,307804.0,'La Plata','Buenos Aires').
province('Catamarca','ar',363918.0,99818.0,0.0,0.0).
province('Chaco','ar',1041101.0,99633.0,'Resistencia','Chaco').
province('Chubut','ar',437894.0,224686.0,'Rawson','Chubut').
province('Cordoba','ar',3177715.0,168766.0,'Cordoba','Cordoba').
province('Corrientes','ar',984192.0,88199.0,'Corrientes','Corrientes').
province('Distrito Federal','ar',2703758.0,200.0,0.0,0.0).
province('Entre Rios','ar',1208138.0,76216.0,'Parana','Entre Rios').
province('Formosa','ar',524524.0,72066.0,'Formosa','Formosa').
province('Jujuy','ar',652426.0,53219.0,0.0,0.0).
province('La Pampa','ar',315312.0,143440.0,'Santa Rosa','La Pampa').
province('La Rioja','ar',320111.0,92331.0,'La Rioja','La Rioja').
province('Mendoza','ar',1643905.0,150839.0,'Mendoza','Mendoza').
province('Misiones','ar',1041235.0,29801.0,'Posadas','Misiones').
province('Neuquen','ar',515238.0,94078.0,'Neuquen','Neuquen').
province('Rio Negro','ar',573934.0,203013.0,'Viedma','Rio Negro').
province('Salta','ar',1168930.0,154775.0,'Salta','Salta').
province('San Juan','ar',654027.0,86137.0,'San Juan','San Juan').
province('San Luis','ar',403057.0,76748.0,'San Luis','San Luis').
province('Santa Cruz','ar',213303.0,243943.0,'Rio Gallegos','Santa Cruz').
province('Santa Fe','ar',3073821.0,133007.0,'Santa Fe','Santa Fe').
province('Santiago del Estero','ar',854089.0,135254.0,0.0,0.0).
province('Tierra del Fuego','ar',118765.0,20912.0,'Ushuaia','Tierra del Fuego').
province('Tucuman','ar',1413981.0,22524.0,0.0,0.0).
province('Aragatsotn','am',125367.0,2755.0,'Ashtarak','Aragatsotn').
province('Ararat','am',250842.0,2003.0,'Artashat','Ararat').
province('Armavir','am',254015.0,1241.0,'Armavir','Armavir').
province('Kotayk','am',239596.0,2100.0,'Hrazdan','Kotayk').
province('Lori','am',251523.0,3791.0,'Vanadzor','Lori').
province('Syunik','am',133094.0,4505.0,'Kapan','Syunik').
province('Tavush','am',121083.0,3120.0,0.0,0.0).
province('Vayots Dzor','am',52846.0,2406.0,0.0,0.0).
province('Grand Turk','tc',5967.0,29.7,0.0,0.0).
province('Middle Caicos','tc',437.0,135.9,0.0,0.0).
province('North Caicos','tc',2075.0,116.1,0.0,0.0).
province('Providenciales and West Caicos','tc',8851.0,133.1,0.0,0.0).
province('Salt Cay','tc',339.0,7.1,0.0,0.0).
province('South Caicos and East Caicos','tc',1939.0,75.1,0.0,0.0).
province('Funafuti','tv',4749.0,2.79,0.0,0.0).
province('Nanumanga','tv',570.0,2.78,0.0,0.0).
province('Nanumea','tv',628.0,3.87,'Lolua','Nanumea').
province('Niulakita','tv',35.0,0.42,0.0,0.0).
province('Nui','tv',534.0,2.83,'Tanrake','Nui').
province('Vaitupu','tv',1636.0,5.6,'Asau','Vaitupu').
province('Central','ug',7174237.0,37489.0,0.0,0.0).
province('Eastern','ug',6900400.0,27957.0,0.0,0.0).
province('Northern','ug',5992224.0,82099.0,0.0,0.0).
province('Western','ug',6920839.0,49599.0,0.0,0.0).
province('Cherkaska','ua',1350801.0,20900.0,0.0,0.0).
province('Chernihivska','ua',1198956.0,31865.0,0.0,0.0).
province('Chernivetska','ua',888503.0,8097.0,0.0,0.0).
province('Dnipropetrovska','ua',3434911.0,31974.0,0.0,0.0).
province('Donetsk','ua',4661063.0,26517.0,0.0,0.0).
province('Ivano-Franki','ua',1357339.0,13928.0,0.0,0.0).
province('Kharkivska','ua',2805850.0,31415.0,0.0,0.0).
province('Khersonska','ua',1131426.0,28461.0,0.0,0.0).
province('Khmelnytska','ua',1377573.0,20645.0,0.0,0.0).
province('Kiev','ua',2514227.0,839.0,0.0,0.0).
province('Kirovohradska','ua',1090921.0,24588.0,0.0,0.0).
province('Krym','ua',1958114.0,26081.0,'Simferopol','Krym').
province('Kyyivska','ua',1759926.0,28131.0,0.0,0.0).
province('Luhanska','ua',2451501.0,26684.0,0.0,0.0).
province('Lvivska','ua',2528878.0,21833.0,0.0,0.0).
province('Mykolayivska','ua',1217715.0,24598.0,0.0,0.0).
province('Odeska','ua',2377248.0,33310.0,0.0,0.0).
province('Poltavska','ua',1569479.0,28748.0,0.0,0.0).
province('Rivnenska','ua',1129676.0,20047.0,0.0,0.0).
province('Sevastopol','ua',365381.0,864.0,0.0,0.0).
province('Sumska','ua',1251416.0,23834.0,0.0,0.0).
province('Ternopilska','ua',1099936.0,13823.0,0.0,0.0).
province('Vinnytska','ua',1706467.0,26513.0,0.0,0.0).
province('Volynska','ua',1021253.0,20144.0,0.0,0.0).
province('Zakarpatska','ua',1211477.0,12777.0,0.0,0.0).
province('Zaporizka','ua',1857437.0,27180.0,0.0,0.0).
province('Zhytomyrska','ua',1337798.0,29832.0,0.0,0.0).
province('Abu Dhabi','ae',1395890.0,67340.0,0.0,0.0).
province('Ajman','ae',234908.0,259.0,0.0,0.0).
province('al-Fujayrah','ae',113318.0,1166.0,0.0,0.0).
province('Dubai','ae',1141959.0,3885.0,0.0,0.0).
province('Ras al Khaymah','ae',187538.0,1683.0,0.0,0.0).
province('Sharjah','ae',620187.0,2590.0,0.0,0.0).
province('Umm al-Qaywayn','ae',56254.0,777.0,0.0,0.0).
province('England','uk',5.0233273E7,130439.0,0.0,0.0).
province('Northern Ireland','uk',1716942.0,14120.0,0.0,0.0).
province('Scotland','uk',5003909.0,78783.0,0.0,0.0).
province('Wales','uk',2935283.0,20798.0,0.0,0.0).
province('Alabama','us',4530315.0,131443.0,'Montgomery','Alabama').
province('Alaska','us',660632.0,1477268.0,'Juneau','Alaska').
province('Arkansas','us',2757631.0,134887.0,'Little Rock','Arkansas').
province('Colorado','us',4678630.0,268658.0,'Denver','Colorado').
province('Delaware','us',838549.0,5133.0,'Dover','Delaware').
province('Georgia','us',8975843.0,152577.0,'Atlanta','Georgia').
province('Illinois','us',1.2772889E7,144123.0,'Springfield','Illinois').
province('Indiana','us',6265934.0,92903.0,'Indianapolis','Indiana').
province('Iowa','us',2955010.0,144716.0,'Des Moines','Iowa').
province('Maine','us',1325518.0,79931.0,'Augusta','Maine').
province('Maryland','us',5624246.0,25316.0,'Annapolis','Maryland').
province('Michigan','us',1.0147097E7,150544.0,'Lansing','Michigan').
province('Minnesota','us',5141954.0,206207.0,'Saint Paul','Minnesota').
province('Montana','us',930698.0,376991.0,'Helena','Montana').
province('Nevada','us',2399532.0,284613.0,'Carson City','Nevada').
province('New Hampshire','us',1316217.0,23292.0,'Concord','New Hampshire').
province('New York','us',1.9274243E7,122310.0,'Albany','New York').
province('North Dakota','us',630529.0,178695.0,'Bismarck','North Dakota').
province('Ohio','us',1.1467124E7,106067.0,'Columbus','Ohio').
province('Rhode Island','us',1090291.0,2707.0,'Providence','Rhode Island').
province('South Carolina','us',4229842.0,77988.0,'Columbia','South Carolina').
province('Texas','us',2.2875686E7,678358.0,'Austin','Texas').
province('Utah','us',2427340.0,212816.0,'Salt Lake City','Utah').
province('Washington','us',6271775.0,172447.0,'Olympia','Washington').
province('Wisconsin','us',5535168.0,141712.0,'Madison','Wisconsin').
province('Canelones','uy',547557.0,4536.0,'Canelones','Canelones').
province('Colonia','uy',128995.0,6106.0,'Colonia','Colonia').
province('Flores','uy',25499.0,5144.0,'Trinidad','Flores').
province('FLorida','uy',69307.0,10417.0,0.0,0.0).
province('Montevideo','uy',1393152.0,530.0,'Montevideo','Montevideo').
province('Rio Negro','uy',56196.0,9282.0,'Fray Bentos','Rio Negro').
province('Rocha','uy',73214.0,10551.0,'Rocha','Rocha').
province('San Jose','uy',109638.0,4992.0,0.0,0.0).
province('Soriano','uy',85102.0,9008.0,'Mercedes','Soriano').
province('Andijon','uz',2280010.0,4200.0,0.0,0.0).
province('Buhoro','uz',1536424.0,39400.0,0.0,0.0).
province('Cizah','uz',1033111.0,20500.0,0.0,0.0).
province('Fargona','uz',2735975.0,7100.0,0.0,0.0).
province('Horazm','uz',1411415.0,6300.0,0.0,0.0).
province('Kaskadarya','uz',2337372.0,28400.0,0.0,0.0).
province('Korakalpogiston','uz',1635660.0,164900.0,0.0,0.0).
province('Namangan','uz',2065185.0,7900.0,'Namangan','Namangan').
province('Navoi','uz',880578.0,110800.0,0.0,0.0).
province('Samarkand','uz',2726180.0,16400.0,0.0,0.0).
province('Sirdare','uz',652732.0,5100.0,0.0,0.0).
province('Surhondar','uz',1882469.0,20800.0,0.0,0.0).
province('Tashkent','uz',4837432.0,15600.0,'Tashkent','Tashkent').
province('Penama','vu',29286.0,1198.0,'Longana','Penama').
province('Shefa','vu',63491.0,1455.0,0.0,0.0).
province('Tafea','vu',33459.0,1628.0,'Isangel','Tafea').
province('Anzoategui','ve',1358327.0,43300.0,'Barcelona','Anzoategui').
province('Aragua','ve',1566938.0,7014.0,'Maracay','Aragua').
province('Carabobo','ve',2115679.0,4650.0,'Valencia','Carabobo').
province('Cojedes','ve',280819.0,14800.0,'San Carlos','Cojedes').
province('Dependencias Federales','ve',1860.0,120.0,0.0,0.0).
province('Distrito Capital','ve',1815681.0,433.0,0.0,0.0).
province('Falcon','ve',818503.0,24800.0,'Coro','Falcon').
province('Guarico','ve',675811.0,64986.0,0.0,0.0).
province('Merida','ve',765621.0,11300.0,'Merida','Merida').
province('Monagas','ve',805365.0,28900.0,'Maturin','Monagas').
province('Nueva Esparta','ve',416762.0,1150.0,0.0,0.0).
province('Sucre','ve',819496.0,11800.0,'Cumana','Sucre').
province('Tachira','ve',1055157.0,11100.0,'San Cristobal','Tachira').
province('Trujillo','ve',644639.0,7400.0,'Trujillo','Trujillo').
province('Vargas','ve',301741.0,1497.0,'La Guaira','Vargas').
province('Yaracuy','ve',540576.0,7100.0,'San Felipe','Yaracuy').
province('Zulia','ve',3265269.0,63100.0,'Maracaibo','Zulia').
province('Dong Bang Song Cuu Long','vn',1.7512423E7,39554.0,0.0,0.0).
province('Dong Bang Song Hong','vn',1.6065108E7,12521.0,0.0,0.0).
province('Dong Nam Bo','vn',1.1031187E7,23463.0,0.0,0.0).
province('Duyen Hai Mien Trung','vn',8768550.0,45238.0,0.0,0.0).
province('Khu Bon Cu','vn',1.0862573E7,51232.0,0.0,0.0).
province('Mien Nui Va Trung Du','vn',1.4206716E7,104801.0,0.0,0.0).
province('Thai Nguyen','vn',4405414.0,55569.0,0.0,0.0).
province('Saint Croix','vi',54470.0,212.0,0.0,0.0).
province('Saint John','vi',4621.0,52.0,0.0,0.0).
province('Saint Thomas','vi',52608.0,83.0,0.0,0.0).
province('Alo','wf',2998.0,85.0,0.0,0.0).
province('Hahake','wf',4112.0,57.0,0.0,0.0).
province('Hihifo','wf',2439.0,48.0,0.0,0.0).
province('Mua','wf',3705.0,54.0,0.0,0.0).
province('Sigave','wf',1894.0,30.0,0.0,0.0).
province('al-Ayun','eh',195919.0,33000.0,0.0,0.0).
province('as-Samarah','eh',67215.0,58000.0,0.0,0.0).
province('Bu Jaydur','eh',21443.0,39000.0,0.0,0.0).
province('Wad-ad-Dahab','eh',36135.0,136000.0,0.0,0.0).
province('Abyan','ye',494838.0,24131.0,0.0,0.0).
province('Aden','ye',670848.0,7099.0,0.0,0.0).
province('al-Bayda','ye',601207.0,10711.0,0.0,0.0).
province('al-Hudaydah','ye',2085637.0,16646.0,0.0,0.0).
province('al-Jawf','ye',201420.0,13175.0,0.0,0.0).
province('al-Mahrah','ye',133870.0,98249.0,0.0,0.0).
province('al-Mahwit','ye',479053.0,2501.0,0.0,0.0).
province('Amanah al-Asmah','ye',1937451.0,247.0,0.0,0.0).
province('Damar','ye',1247132.0,8745.0,0.0,0.0).
province('Hadramaut','ye',1035633.0,148178.0,0.0,0.0).
province('Hajjah','ye',1504762.0,10677.0,'Hajjah','Hajjah').
province('Ibb','ye',2334657.0,7632.0,'Ibb','Ibb').
province('Lahij','ye',752085.0,14836.0,'Lahij','Lahij').
province('Marib','ye',217603.0,13466.0,'Marib','Marib').
province('Sabwah','ye',446421.0,78995.0,0.0,0.0).
province('Sadah','ye',575425.0,29617.0,'Sadah','Sadah').
province('Sana','ye',2268079.0,28977.0,'Sana','Amanah al-Asmah').
province('Taizz','ye',2613888.0,14194.0,'Taizz','Taizz').
province('Central','zm',1145813.0,94395.0,'Kabwe','Central').
province('Copperbelt','zm',1623823.0,31328.0,'Ndola','Copperbelt').
province('Eastern','zm',1474710.0,69106.0,'Chipata','Eastern').
province('Luapala','zm',889143.0,50567.0,0.0,0.0).
province('Lusaka','zm',1613226.0,21896.0,'Lusaka','Lusaka').
province('Northern','zm',1436702.0,147826.0,'Kasama','Northern').
province('North-Western','zm',663112.0,125827.0,'Solwezi','North-Western').
province('Southern','zm',1341680.0,85283.0,'Livingstone','Southern').
province('Western','zm',826863.0,126386.0,'Mongu','Western').
province('Bulawayo','zw',897249.0,479.0,'Bulawayo','Bulawayo').
province('Harare','zw',2609012.0,872.0,'Harare','Harare').
province('Manicaland','zw',2039909.0,36459.0,'Mutare','Manicaland').
province('Mashonaland Central','zw',1263328.0,28374.0,'Bindura','Mashonaland Central').
province('Mashonaland East','zw',1564503.0,32230.0,'Marondera','Mashonaland East').
province('Mashonaland West','zw',1352077.0,57441.0,'Chinhoyi','Mashonaland West').
province('Masvingo','zw',1310571.0,56566.0,'Masvingo','Masvingo').
province('Matabeleland North','zw',823330.0,75025.0,'Bulawayo','Bulawayo').
province('Matabeleland South','zw',605470.0,54172.0,'Gwanda','Matabeleland South').
province('Midlands','zw',1409161.0,49166.0,'Gweru','Midlands').
province('Australian Capital Territory','au',324025.0,2452.0,0.0,0.0).
province('New South Wales','au',6819565.0,801428.0,'Sydney','New South Wales').
province('Northern Territory','au',197603.0,1346200.0,'Darwin','Northern Territory').
province('Queensland','au',4039272.0,1727200.0,'Brisbane','Queensland').
province('South Australia','au',1545939.0,984377.0,'Adelaide','South Australia').
province('Tasmania','au',485898.0,67800.0,'Hobart','Tasmania').
province('Victoria','au',5064335.0,227600.0,'Melbourne','Victoria').
province('Western Australia','au',2030627.0,2525500.0,'Perth','Western Australia').
province('Burgenland','at',281022.0,3965.0,'Eisenstadt','Burgenland').
province('Kaernten','at',565762.0,9533.0,0.0,0.0).
province('Niederoesterreich','at',1576622.0,19174.0,0.0,0.0).
province('Oberoesterreich','at',1400851.0,11980.0,0.0,0.0).
province('Salzburg','at',533083.0,7154.0,'Salzburg','Salzburg').
province('Steiermark','at',1185175.0,16388.0,'Graz','Steiermark').
province('Tirol','at',692215.0,12648.0,'Innsbruck','Tirol').
province('Vorarlberg','at',359737.0,2601.0,'Bregenz','Vorarlberg').
province('Wien','at',1569315.0,415.0,'Vienna','Wien').
province('Abseron','az',92050.0,1360.0,0.0,0.0).
province('Agcabedi','az',113355.0,1760.0,0.0,0.0).
province('Agdam','az',165407.0,1150.0,0.0,0.0).
province('Agdas','az',93896.0,1050.0,0.0,0.0).
province('Agstafa','az',76302.0,1500.0,'Agstafa','Agstafa').
province('Agsu','az',66646.0,1020.0,0.0,0.0).
province('Astara','az',90709.0,620.0,0.0,0.0).
province('Babek','az',76101.0,1170.0,0.0,0.0).
province('Baki','az',1850117.0,213.0,0.0,0.0).
province('Balaken','az',86585.0,920.0,0.0,0.0).
province('Berde','az',135985.0,960.0,0.0,0.0).
province('Beyleqan','az',81532.0,1130.0,0.0,0.0).
province('Bilesuvar','az',80814.0,1400.0,0.0,0.0).
province('Cebrayil','az',65367.0,1050.0,0.0,0.0).
province('Celilabad','az',181460.0,1440.0,0.0,0.0).
province('Culfa','az',38554.0,1000.0,0.0,0.0).
province('Daskesen','az',31844.0,1050.0,0.0,0.0).
province('Deveci','az',48660.0,1090.0,0.0,0.0).
province('Eli Bayramli','az',72395.0,30.0,0.0,0.0).
province('Fuezuli','az',144443.0,1390.0,0.0,0.0).
province('Gedebey','az',89927.0,1290.0,0.0,0.0).
province('Gence','az',303771.0,110.0,0.0,0.0).
province('Goranboy','az',90554.0,1790.0,'Goranboy','Goranboy').
province('Goeycay','az',105323.0,740.0,0.0,0.0).
province('Haciqabul','az',61016.0,1640.0,0.0,0.0).
province('Imisli','az',109061.0,1820.0,0.0,0.0).
province('Ismayilli','az',76185.0,2060.0,0.0,0.0).
province('Kelbecer','az',72131.0,3050.0,0.0,0.0).
province('Kuerdemir','az',98865.0,1630.0,0.0,0.0).
province('Lacin','az',68034.0,1840.0,0.0,0.0).
province('Lenkeran','az',197122.0,1540.0,0.0,0.0).
province('Lerik','az',69736.0,1080.0,0.0,0.0).
province('Masalli','az',183531.0,720.0,0.0,0.0).
province('Mingecevir','az',95454.0,130.0,0.0,0.0).
province('Naftalan','az',7403.0,2.0,0.0,0.0).
province('Naxcivan','az',64754.0,130.0,0.0,0.0).
province('Neftcala','az',75356.0,1450.0,0.0,0.0).
province('Oguz','az',38915.0,1220.0,0.0,0.0).
province('Ordubad','az',42638.0,970.0,0.0,0.0).
province('Qax','az',53246.0,1490.0,0.0,0.0).
province('Qazax','az',84013.0,700.0,0.0,0.0).
province('Qebele','az',89438.0,1550.0,0.0,0.0).
province('Qobustan','az',37224.0,1370.0,0.0,0.0).
province('Quba','az',143046.0,2580.0,0.0,0.0).
province('Qubadli','az',35067.0,800.0,0.0,0.0).
province('Qusar','az',84646.0,1540.0,0.0,0.0).
province('Saatli','az',87031.0,1180.0,0.0,0.0).
province('Sabirabad','az',143514.0,1470.0,0.0,0.0).
province('Sahbuz','az',21388.0,920.0,0.0,0.0).
province('Salyan','az',117170.0,1790.0,0.0,0.0).
province('Samaxi','az',85795.0,1610.0,0.0,0.0).
province('Samux','az',50787.0,1450.0,0.0,0.0).
province('Sederek','az',12972.0,150.0,0.0,0.0).
province('Seki','az',164405.0,2430.0,0.0,0.0).
province('Semkir','az',180742.0,1660.0,0.0,0.0).
province('Serur','az',116475.0,1160.0,0.0,0.0).
province('Siyezen','az',35677.0,700.0,0.0,0.0).
province('Sumqayit','az',292577.0,80.0,0.0,0.0).
province('Susa','az',25993.0,290.0,0.0,0.0).
province('Terter','az',95085.0,960.0,0.0,0.0).
province('Ucar','az',74067.0,850.0,0.0,0.0).
province('Xacmaz','az',152359.0,1050.0,0.0,0.0).
province('Xankendi','az',54701.0,8.0,0.0,0.0).
province('Xanlar','az',54861.0,1030.0,0.0,0.0).
province('Xizi','az',13822.0,1850.0,0.0,0.0).
province('Xocali','az',24787.0,940.0,0.0,0.0).
province('Xocavend','az',40560.0,1460.0,0.0,0.0).
province('Yardimli','az',54575.0,670.0,0.0,0.0).
province('Yevlax','az',1120.0,1540.0,0.0,0.0).
province('Zaqatala','az',111418.0,1350.0,0.0,0.0).
province('Zengilan','az',36990.0,710.0,0.0,0.0).
province('Zerdab','az',49368.0,860.0,0.0,0.0).
province('Abaco','bs',14816.0,1681.0,0.0,0.0).
province('Acklins Island','bs',435.0,389.0,0.0,0.0).
province('Andros','bs',7380.0,5957.0,0.0,0.0).
province('Berry Islands','bs',742.0,31.0,0.0,0.0).
province('Biminis','bs',1736.0,23.0,0.0,0.0).
province('Cat Island','bs',1606.0,388.0,0.0,0.0).
province('Crooked Island','bs',342.0,261.0,0.0,0.0).
province('Eleuthera','bs',8545.0,498.0,0.0,0.0).
province('Exuma and Cays','bs',3539.0,290.0,0.0,0.0).
province('Grand Bahama','bs',49566.0,1373.0,0.0,0.0).
province('Harbour Island','bs',1751.0,4.0,0.0,0.0).
province('Inagua Islands','bs',951.0,1671.0,0.0,0.0).
province('Long Island','bs',2978.0,448.0,0.0,0.0).
province('Mayaguana','bs',251.0,285.0,0.0,0.0).
province('New Providence','bs',228329.0,207.0,0.0,0.0).
province('Ragged Island','bs',70.0,23.0,0.0,0.0).
province('Rum Cay','bs',96.0,78.0,0.0,0.0).
province('San Salvador','bs',1294.0,163.0,0.0,0.0).
province('Spanish Wells','bs',1631.0,16.0,0.0,0.0).
province('al-Garbiyah','bh',27901.0,156.1,0.0,0.0).
province('al-Hidd','bh',12797.0,6.0,0.0,0.0).
province('al-Janubiyah','bh',4644.0,50.6,0.0,0.0).
province('al-Muharraq','bh',98117.0,16.0,0.0,0.0).
province('al-Wusta','bh',57878.0,35.2,0.0,0.0).
province('ar-Rifaa','bh',94762.0,291.6,0.0,0.0).
province('as-Samaliyah','bh',47957.0,36.8,0.0,0.0).
province('Isa','bh',38089.0,12.4,0.0,0.0).
province('Jidhafs','bh',55300.0,21.6,0.0,0.0).
province('Madinat Hamad','bh',65467.0,13.1,0.0,0.0).
province('Manama','bh',157368.0,25.8,0.0,0.0).
province('Sitrah','bh',47077.0,28.8,0.0,0.0).
province('Bagar Hat','bd',1607063.0,3256.0,0.0,0.0).
province('Bandarban','bd',329265.0,4479.0,0.0,0.0).
province('Barguna','bd',895852.0,1555.0,0.0,0.0).
province('Barisal','bd',2467443.0,2192.0,0.0,0.0).
province('Bhola','bd',1826227.0,3353.0,0.0,0.0).
province('Bogora','bd',3225257.0,2902.0,0.0,0.0).
province('Brahman Bariya','bd',2531192.0,1879.0,0.0,0.0).
province('Chandpur','bd',2351687.0,1672.0,0.0,0.0).
province('Chattagam','bd',7236072.0,4866.0,0.0,0.0).
province('Chuadanga','bd',1103149.0,1148.0,0.0,0.0).
province('Dhaka','bd',1.0204855E7,1439.0,0.0,0.0).
province('Dinajpur','bd',2860955.0,3449.0,0.0,0.0).
province('Faridpur','bd',1878408.0,2065.0,0.0,0.0).
province('Feni','bd',1275199.0,1032.0,0.0,0.0).
province('Gaybanda','bd',2261538.0,2179.0,0.0,0.0).
province('Gazipur','bd',2287065.0,1798.0,0.0,0.0).
province('Gopalganj','bd',1206330.0,1465.0,0.0,0.0).
province('Habiganj','bd',1911389.0,2566.0,0.0,0.0).
province('Jaipur Hat','bd',907203.0,966.0,0.0,0.0).
province('Jamalpur','bd',2260908.0,2068.0,0.0,0.0).
province('Jessor','bd',2675186.0,2949.0,0.0,0.0).
province('Jhalakati','bd',733893.0,708.0,0.0,0.0).
province('Jhanaydah','bd',1693450.0,1937.0,0.0,0.0).
province('Khagrachhari','bd',632639.0,2596.0,0.0,0.0).
province('Khulna','bd',2543419.0,4746.0,0.0,0.0).
province('Kishorganj','bd',2715442.0,2573.0,0.0,0.0).
province('Koks Bazar','bd',1962488.0,2247.0,0.0,0.0).
province('Komilla','bd',4963675.0,3071.0,0.0,0.0).
province('Kurigram','bd',1918903.0,2248.0,0.0,0.0).
province('Kushtiya','bd',1867662.0,1601.0,0.0,0.0).
province('Lakshmipur','bd',1594282.0,1552.0,0.0,0.0).
province('Lalmanir Hat','bd',1184348.0,1217.0,0.0,0.0).
province('Madaripur','bd',1209900.0,1148.0,0.0,0.0).
province('Magura','bd',878818.0,631.0,0.0,0.0).
province('Maimansingh','bd',4816615.0,4399.0,0.0,0.0).
province('Manikganj','bd',1366517.0,1394.0,0.0,0.0).
province('Maulvi Bazar','bd',1752415.0,2674.0,0.0,0.0).
province('Meherpur','bd',639740.0,719.0,0.0,0.0).
province('Munshiganj','bd',1388608.0,955.0,0.0,0.0).
province('Naral','bd',728456.0,973.0,0.0,0.0).
province('Narayanganj','bd',2392419.0,699.0,0.0,0.0).
province('Narsingdi','bd',2068197.0,892.0,0.0,0.0).
province('Nator','bd',1629148.0,1892.0,0.0,0.0).
province('Naugaon','bd',2555190.0,3480.0,0.0,0.0).
province('Nawabganj','bd',1576738.0,1672.0,0.0,0.0).
province('Netrakona','bd',2101727.0,2744.0,0.0,0.0).
province('Nilphamari','bd',1689505.0,1643.0,0.0,0.0).
province('Noakhali','bd',2741746.0,3093.0,0.0,0.0).
province('Pabna','bd',2324712.0,2388.0,0.0,0.0).
province('Panchagarh','bd',908750.0,1390.0,0.0,0.0).
province('Patuakhali','bd',1571817.0,2760.0,0.0,0.0).
province('Pirojpur','bd',1195411.0,1283.0,0.0,0.0).
province('Rajbari','bd',1021323.0,1093.0,0.0,0.0).
province('Rajshahi','bd',2500626.0,2426.0,0.0,0.0).
province('Rangamati','bd',568138.0,5341.0,0.0,0.0).
province('Rangpur','bd',2780662.0,2300.0,0.0,0.0).
province('Satkhira','bd',2018570.0,3748.0,0.0,0.0).
province('Shariatpur','bd',1142774.0,1019.0,0.0,0.0).
province('Sherpur','bd',1340383.0,1349.0,0.0,0.0).
province('Silhat','bd',2829067.0,3312.0,0.0,0.0).
province('Sirajganj','bd',2994052.0,2464.0,0.0,0.0).
province('Sunamganj','bd',2142950.0,3766.0,0.0,0.0).
province('Tangayal','bd',3485938.0,3381.0,0.0,0.0).
province('Thakurgaon','bd',1318811.0,1813.0,0.0,0.0).
province('Christ Church','bb',48119.0,57.0,0.0,0.0).
province('Saint Andrew','bb',6436.0,36.0,0.0,0.0).
province('Saint George','bb',18287.0,44.0,0.0,0.0).
province('Saint James','bb',21454.0,31.0,0.0,0.0).
province('Saint John','bb',10421.0,34.0,0.0,0.0).
province('Saint Joseph','bb',7764.0,26.0,0.0,0.0).
province('Saint Lucy','bb',9706.0,36.0,0.0,0.0).
province('Saint Michael','bb',99609.0,39.0,0.0,0.0).
province('Saint Peter','bb',11544.0,34.0,0.0,0.0).
province('Saint Philip','bb',20944.0,60.0,0.0,0.0).
province('Saint Thomas','bb',11850.0,34.0,0.0,0.0).
province('Brest','by',1456779.0,32300.0,'Brest','Brest').
province('Homjel','by',1472038.0,40400.0,0.0,0.0).
province('Hrodna','by',1142759.0,25000.0,0.0,0.0).
province('Mahiljow','by',1162955.0,29000.0,0.0,0.0).
province('Minskaja Voblasts','by',1456250.0,38300.0,'Minsk','Minsk').
province('Vicebsk','by',1322121.0,40100.0,0.0,0.0).
province('Antwerp','be',1677574.0,2867.0,0.0,0.0).
province('Brabant Wallon','be',363442.0,1091.0,0.0,0.0).
province('Brussels','be',1019022.0,161.0,0.0,0.0).
province('East Flanders','be',1376407.0,2982.0,0.0,0.0).
province('Flemish Brabant','be',1037334.0,2106.0,0.0,0.0).
province('Hainaut','be',1282435.0,3787.0,0.0,0.0).
province('Liege','be',1028763.0,3862.0,0.0,0.0).
province('Limburg','be',809997.0,2422.0,0.0,0.0).
province('Luxemburg','be',255945.0,4441.0,0.0,0.0).
province('Namur','be',455400.0,3665.0,0.0,0.0).
province('West Flanders','be',1136693.0,3134.0,0.0,0.0).
province('Belize','bz',87589.0,4307.0,0.0,0.0).
province('Cayo','bz',66565.0,5196.0,0.0,0.0).
province('Corozal','bz',35417.0,1860.0,'Co','Corozal').
province('Orange Walk','bz',44853.0,4636.0,'Orange Walk','Orange Walk').
province('Stann Creek','bz',29882.0,2554.0,'Dangriga','Stann Creek').
province('Toledo','bz',27598.0,4413.0,'Punta Gorda','Toledo').
province('Alibori','bj',576251.0,25683.0,'Kandi','Alibori').
province('Atacora','bj',586734.0,20459.0,'Natitingou','Atacora').
province('Atlantique','bj',896899.0,3233.0,'Ouidah','Atlantique').
province('Borgou','bj',802501.0,25310.0,'Parakou','Borgou').
province('Collines','bj',602066.0,13561.0,'Savalou','Collines').
province('Couffo','bj',560182.0,2404.0,0.0,0.0).
province('Donga','bj',384152.0,10691.0,'Djougou','Donga').
province('Littoral','bj',690584.0,79.0,'Cotonou','Littoral').
province('Mono','bj',380080.0,1396.0,'Lokossa','Mono').
province('Oueme','bj',773421.0,2835.0,0.0,0.0).
province('Plateau','bj',435624.0,1865.0,'Sakete','Plateau').
province('Zou','bj',628684.0,5106.0,'Abomey','Zou').
province('Devonshire','bm',7238.0,4.9,0.0,0.0).
province('Hamilton','bm',902.0,0.7,0.0,0.0).
province('Hamilton Parish','bm',5584.0,5.1,0.0,0.0).
province('Paget','bm',5179.0,5.3,0.0,0.0).
province('Pembroke','bm',10249.0,4.7,0.0,0.0).
province('Saint George','bm',1802.0,1.4,0.0,0.0).
province('Saint Georges','bm',4128.0,7.9,0.0,0.0).
province('Sandys','bm',7723.0,6.7,0.0,0.0).
province('Smiths','bm',5852.0,4.9,0.0,0.0).
province('Southampton','bm',6260.0,5.8,0.0,0.0).
province('Warwick','bm',8932.0,5.7,0.0,0.0).
province('Bumthang','bt',35039.0,3189.0,'Jakar','Bumthang').
province('Chhukha','bt',149297.0,1995.0,'Chhukha','Chhukha').
province('Chirang','bt',160447.0,1142.0,'Damphu','Chirang').
province('Daga','bt',42560.0,1232.0,0.0,0.0).
province('Geylegphug','bt',173221.0,2178.0,'Geylegphug','Geylegphug').
province('Ha','bt',26346.0,1998.0,'Ha','Ha').
province('Lhuntshi','bt',56751.0,3319.0,'Lhuntshi','Lhuntshi').
province('Mongar','bt',109592.0,2077.0,'Mongar','Mongar').
province('Pemagatsel','bt',53952.0,640.0,'Pemagatsel','Pemagatsel').
province('Punakha','bt',61146.0,5652.0,'Punakha','Punakha').
province('Rinpung','bt',61146.0,1897.0,0.0,0.0).
province('Samchi','bt',213219.0,1816.0,'Samchi','Samchi').
province('Samdrup Jongkhar','bt',110860.0,2496.0,0.0,0.0).
province('Shemgang','bt',66515.0,2762.0,'Shemgang','Shemgang').
province('Tashigang','bt',260925.0,5003.0,'Tashigang','Tashigang').
province('Timphu','bt',99281.0,2102.0,0.0,0.0).
province('Tongsa','bt',43959.0,2144.0,'Tongsa','Tongsa').
province('Wangdiphodrang','bt',73286.0,5031.0,0.0,0.0).
province('Beni','bo',405186.0,213564.0,'Trinidad','Beni').
province('Chuquisaca','bo',555469.0,51524.0,'Sucre','Chuquisaca').
province('Cochabamba','bo',1607977.0,55631.0,'Cochabamba','Cochabamba').
province('La Paz','bo',2522099.0,133985.0,'La Paz','La Paz').
province('Oruro','bo',408502.0,53588.0,'Oruro','Oruro').
province('Pando','bo',57748.0,63827.0,'Cobija','Pando').
province('Potosi','bo',721327.0,118218.0,'Potosi','Potosi').
province('Santa Cruz','bo',2360896.0,370621.0,0.0,0.0).
province('Tarija','bo',434652.0,37623.0,'Tarija','Tarija').
province('Federacija Bosna i Hercegovina','ba',2930969.0,26076.0,0.0,0.0).
province('Republika Srpska','ba',1521907.0,25053.0,0.0,0.0).
province('Bobonong','bw',72103.0,14242.0,0.0,0.0).
province('Boteti','bw',53329.0,33806.0,0.0,0.0).
province('Chobe','bw',19908.0,20800.0,0.0,0.0).
province('Francistown','bw',89979.0,79.0,0.0,0.0).
province('Gaborone','bw',208411.0,169.0,0.0,0.0).
province('Ghanzi','bw',36675.0,117910.0,'Ghanzi','Ghanzi').
province('Jwaneng','bw',16854.0,100.0,0.0,0.0).
province('Kgalagadi North','bw',18198.0,72400.0,0.0,0.0).
province('Kgalagadi South','bw',28427.0,32800.0,0.0,0.0).
province('Kgatleng','bw',79666.0,7960.0,'Mochudi','Kgatleng').
province('Kweneng','bw',255118.0,31100.0,'Molepolole','Kweneng').
province('Lobatse','bw',30883.0,42.0,0.0,0.0).
province('Mahalapye','bw',114594.0,16507.0,0.0,0.0).
province('Ngamiland','bw',81979.0,86400.0,0.0,0.0).
province('Ngwaketse','bw',179888.0,28470.0,0.0,0.0).
province('North East','bw',51377.0,5120.0,0.0,0.0).
province('Okavango','bw',55034.0,22730.0,0.0,0.0).
province('Orapa','bw',9190.0,17.0,0.0,0.0).
province('Selibe Phikwe','bw',53727.0,50.0,0.0,0.0).
province('Serowe-Palapye','bw',161763.0,31381.0,0.0,0.0).
province('South East','bw',67922.0,1780.0,0.0,0.0).
province('Sowa','bw',3138.0,159.0,0.0,0.0).
province('Tutume','bw',132335.0,46140.0,0.0,0.0).
province('Acre','br',632097.0,153150.0,0.0,0.0).
province('Alagoas','br',2984303.0,27933.0,0.0,0.0).
province('Amapa','br',581338.0,143454.0,0.0,0.0).
province('Amazonas','br',3181861.0,1577820.0,0.0,0.0).
province('Bahia','br',1.3667542E7,567295.0,0.0,0.0).
province('Ceara','br',7989490.0,146348.0,0.0,0.0).
province('Distrito Federal','br',2292559.0,5822.0,0.0,0.0).
province('Espirito Santo','br',3360321.0,46184.0,0.0,0.0).
province('Goias','br',5521524.0,341290.0,0.0,0.0).
province('Maranhao','br',6031345.0,333366.0,0.0,0.0).
province('Mato Grosso','br',2763096.0,906807.0,0.0,0.0).
province('Mato Grosso do Sul','br',2233379.0,358159.0,0.0,0.0).
province('Minas Gerais','br',1.9018848E7,588384.0,0.0,0.0).
province('Para','br',6851163.0,1253165.0,0.0,0.0).
province('Paraiba','br',3567840.0,56585.0,0.0,0.0).
province('Parana','br',1.0130436E7,199709.0,0.0,0.0).
province('Pernambuco','br',8327734.0,98938.0,0.0,0.0).
province('Piaui','br',2978177.0,252378.0,0.0,0.0).
province('Rio de Janeiro','br',1.5220006E7,43910.0,0.0,0.0).
province('Rio Grande do Norte','br',2967615.0,53307.0,0.0,0.0).
province('Rio Grande do Sul','br',1.0723745E7,282062.0,0.0,0.0).
province('Rondonia','br',1515936.0,238513.0,0.0,0.0).
province('Roraima','br',385333.0,225116.0,0.0,0.0).
province('Santa Catarina','br',5793031.0,95443.0,0.0,0.0).
province('Sao Paulo','br',3.9883551E7,248809.0,0.0,0.0).
province('Sergipe','br',1940093.0,22050.0,0.0,0.0).
province('Tocantins','br',1281282.0,278421.0,0.0,0.0).
province('Anegada','vg',194.0,38.6,0.0,0.0).
province('Jost van Dyke','vg',180.0,8.3,0.0,0.0).
province('Other Islands','vg',258.0,23.7,0.0,0.0).
province('Tortola','vg',17652.0,59.2,0.0,0.0).
province('Virgin Gorda','vg',3289.0,21.2,0.0,0.0).
province('Belait','bn',77515.0,2724.0,'Kuala Belait','Belait').
province('Brunei-Muara','bn',253895.0,571.0,'Bandar Seri Begawan','Brunei-Muara').
province('Temburong','bn',10908.0,1304.0,'Bangar','Temburong').
province('Tutong','bn',41426.0,1166.0,'Tutong','Tutong').
province('Blagoevgrad','bg',331640.0,6464.0,0.0,0.0).
province('Burgas','bg',412059.0,7605.0,0.0,0.0).
province('Dobric','bg',197307.0,4689.0,0.0,0.0).
province('Gabrovo','bg',132500.0,2068.0,0.0,0.0).
province('Haskovo','bg',265783.0,4029.0,0.0,0.0).
province('Jambol','bg',141157.0,4162.0,0.0,0.0).
province('Kardzali','bg',144303.0,4020.0,0.0,0.0).
province('Kjustendil','bg',152565.0,3002.0,0.0,0.0).
province('Lovec','bg',153000.0,4128.0,0.0,0.0).
province('Montana','bg',162950.0,3585.0,0.0,0.0).
province('Pazardzik','bg',300207.0,4379.0,0.0,0.0).
province('Pernik','bg',141627.0,2355.0,0.0,0.0).
province('Pleven','bg',336135.0,4184.0,0.0,0.0).
province('Plovdiv','bg',699166.0,5591.0,0.0,0.0).
province('Razgrad','bg',122891.0,2646.0,0.0,0.0).
province('Ruse','bg',257189.0,2624.0,0.0,0.0).
province('Silistra','bg',130504.0,2876.0,0.0,0.0).
province('Sliven','bg',205443.0,3729.0,0.0,0.0).
province('Smoljan','bg',130085.0,3518.0,0.0,0.0).
province('Sofija grad','bg',1138524.0,1038.0,0.0,0.0).
province('Sofijska oblast','bg',260863.0,7384.0,0.0,0.0).
province('Stara Zagora','bg',354155.0,4902.0,0.0,0.0).
province('Sumen','bg',195014.0,3374.0,0.0,0.0).
province('Targoviste','bg',141816.0,2754.0,0.0,0.0).
province('Varna','bg',452393.0,3820.0,0.0,0.0).
province('Veliko Tarnovo','bg',277499.0,4690.0,0.0,0.0).
province('Vidin','bg',112062.0,3110.0,0.0,0.0).
province('Vraca','bg',172229.0,4186.0,0.0,0.0).
province('Bale','bf',198240.0,4595.0,0.0,0.0).
province('Bam','bf',240575.0,4084.0,0.0,0.0).
province('Banwa','bf',229294.0,5882.0,0.0,0.0).
province('Bazega','bf',243588.0,3963.0,0.0,0.0).
province('Bougouriba','bf',84233.0,2812.0,0.0,0.0).
province('Boulgou','bf',458164.0,6692.0,0.0,0.0).
province('Boulkiemde','bf',464052.0,4269.0,0.0,0.0).
province('Comoe','bf',263398.0,15277.0,0.0,0.0).
province('Ganzourgou','bf',291099.0,4178.0,0.0,0.0).
province('Gnagna','bf',340176.0,8468.0,0.0,0.0).
province('Gourma','bf',259823.0,11117.0,0.0,0.0).
province('Houet','bf',767112.0,11568.0,0.0,0.0).
province('Ioba','bf',161804.0,3289.0,0.0,0.0).
province('Kadiogo','bf',1373965.0,2805.0,0.0,0.0).
province('Kenedougou','bf',223139.0,8137.0,0.0,0.0).
province('Komandjari','bf',55738.0,5048.0,0.0,0.0).
province('Kompienga','bf',126159.0,7029.0,0.0,0.0).
province('Kossi','bf',255314.0,7324.0,0.0,0.0).
province('Koulpelogo','bf',328287.0,2497.0,0.0,0.0).
province('Kouritenga','bf',281795.0,2622.0,0.0,0.0).
province('Kourweogo','bf',125351.0,1588.0,0.0,0.0).
province('Leraba','bf',106570.0,3129.0,0.0,0.0).
province('Loroum','bf',126446.0,3592.0,0.0,0.0).
province('Mouhoun','bf',275035.0,6668.0,0.0,0.0).
province('Nahouri','bf',146673.0,3754.0,0.0,0.0).
province('Namentenga','bf',272628.0,6464.0,0.0,0.0).
province('Nayala','bf',149953.0,3919.0,0.0,0.0).
province('Noumbiel','bf',57101.0,2736.0,0.0,0.0).
province('Oubritenga','bf',226064.0,2778.0,0.0,0.0).
province('Oudalan','bf',146950.0,9797.0,0.0,0.0).
province('Passore','bf',295292.0,3867.0,0.0,0.0).
province('Poni','bf',222603.0,7365.0,0.0,0.0).
province('Sanguie','bf',272642.0,5178.0,0.0,0.0).
province('Sanmatenga','bf',485046.0,9281.0,0.0,0.0).
province('Seno','bf',233897.0,6863.0,0.0,0.0).
province('Sissili','bf',170916.0,7136.0,0.0,0.0).
province('Soum','bf',287529.0,12222.0,0.0,0.0).
province('Sourou','bf',219277.0,5765.0,0.0,0.0).
province('Tapoa','bf',262771.0,14594.0,0.0,0.0).
province('Tuy','bf',173880.0,5639.0,0.0,0.0).
province('Yagha','bf',133810.0,6468.0,0.0,0.0).
province('Yatenga','bf',486523.0,6990.0,0.0,0.0).
province('Ziro','bf',120085.0,5139.0,0.0,0.0).
province('Zondoma','bf',140677.0,1758.0,0.0,0.0).
province('Zoundweogo','bf',214471.0,3604.0,0.0,0.0).
province('Bubanza','bi',354430.0,1089.04,'Bubanza','Bubanza').
province('Bujumbura','bi',901348.0,1420.52,0.0,0.0).
province('Bururi','bi',493494.0,2465.12,'Bururi','Bururi').
province('Cankuzo','bi',202286.0,1964.54,'Cankuzo','Cankuzo').
province('Cibitoke','bi',490954.0,1635.52,'Cibitoke','Cibitoke').
province('Gitega','bi',675022.0,1978.96,'Gitega','Gitega').
province('Karuzi','bi',479687.0,1457.4,'Karuzi','Karuzi').
province('Kayanza','bi',486923.0,1233.24,'Kayanza','Kayanza').
province('Kirundo','bi',602093.0,1703.34,'Kirundo','Kirundo').
province('Muramvya','bi',303451.0,596.52,'Muramvya','Muramvya').
province('Mwaro','bi',274862.0,839.6,'Mwaro','Gitega').
province('Rutana','bi',293575.0,1959.45,'Rutana','Rutana').
province('Banteay Mean Chey','kh',725534.0,6679.0,0.0,0.0).
province('Bat Dambang','kh',863822.0,11702.0,0.0,0.0).
province('Kampong Chhnang','kh',556705.0,5521.0,'Kampong Chhnang','Kampong Chhnang').
province('Kampong Spoeu','kh',777585.0,7017.0,0.0,0.0).
province('Kampong Thum','kh',696763.0,13814.0,0.0,0.0).
province('Kandal','kh',1312044.0,3568.0,0.0,0.0).
province('Kaoh Kong','kh',235013.0,11160.0,0.0,0.0).
province('Kracheh','kh',335796.0,11094.0,0.0,0.0).
province('Krong Kaeb','kh',35990.0,336.0,0.0,0.0).
province('Krong Pailin','kh',28763.0,803.0,0.0,0.0).
province('Krong Preah Sihanouk','kh',243968.0,868.0,0.0,0.0).
province('Mondol Kiri','kh',44345.0,14288.0,0.0,0.0).
province('Otdar Mean Chey','kh',85741.0,6158.0,0.0,0.0).
province('Phnum Penh','kh',1573529.0,290.0,0.0,0.0).
province('Pousat','kh',495780.0,12692.0,0.0,0.0).
province('Preah Vihear','kh',153127.0,13788.0,0.0,0.0).
province('Prey Veaeng','kh',1129729.0,4883.0,0.0,0.0).
province('Rotanak Kiri','kh',130527.0,10782.0,0.0,0.0).
province('Siem Reab','kh',843196.0,10299.0,0.0,0.0).
province('Stueng Traeng','kh',111988.0,11092.0,0.0,0.0).
province('Takaev','kh',963750.0,3563.0,0.0,0.0).
province('Adamaoua','cm',801307.0,63691.0,'Ngaoundere','Adamaoua').
province('Centre','cm',2672533.0,68926.0,'Yaounde','Centre').
province('Nord','cm',1346623.0,65576.0,'Garoua','Nord').
province('Nord Extreme','cm',3002797.0,34246.0,0.0,0.0).
province('Nordouest','cm',2002135.0,17810.0,0.0,0.0).
province('Ouest','cm',2167995.0,13872.0,'Bafoussam','Ouest').
province('Sudouest','cm',1356007.0,24471.0,0.0,0.0).
province('British Columbia','ca',4154055.0,948596.0,'Victoria','British Columbia').
province('Newfoundland and Labrador','ca',496400.0,404517.0,0.0,0.0).
province('Northwest Territories','ca',42866.0,1178283.0,'Yellowknife','Northwest Territories').
province('Nunavut','ca',30776.0,2201400.0,'Iqaluit','Nunavut').
province('Quebec','ca',7544935.0,1540680.0,'Quebec','Quebec').
province('Saskatchewan','ca',961416.0,651900.0,'Regina','Saskatchewan').
province('Yukon','ca',33530.0,536324.0,0.0,0.0).
province('Boavista','cv',4391.0,620.0,0.0,0.0).
province('Bra','cv',6517.0,67.0,0.0,0.0).
province('Fogo','cv',37779.0,476.0,0.0,0.0).
province('Maio','cv',7471.0,269.0,0.0,0.0).
province('Sal','cv',18984.0,216.0,0.0,0.0).
province('Santo Antao','cv',46798.0,779.0,0.0,0.0).
province('Sao Nicolau','cv',13005.0,388.0,0.0,0.0).
province('Sao Tiago','cv',260104.0,991.0,0.0,0.0).
province('Sao Vicente','cv',74440.0,227.0,0.0,0.0).
province('Cayman Brac','ky',1316.0,36.0,0.0,0.0).
province('Grand Cayman','ky',45657.0,197.0,0.0,0.0).
province('Little Cayman','ky',402.0,26.0,0.0,0.0).
province('Bamingui-Bangoran','cf',43387.0,58200.0,'Ndele','Bamingui-B').
province('Bangui','cf',684190.0,67.0,'Bangui','Bangui').
province('Basse-Kotto','cf',294994.0,17604.0,'Mobaye','Basse-Kotto').
province('Haute-Kotto','cf',89124.0,86650.0,'Bria','Haute-Kotto').
province('Haut-Mbomou','cf',41069.0,55530.0,'Obo','Haut-Mbomou').
province('Kemo','cf',125547.0,17204.0,'Sibut','Kemo').
province('Lobaye','cf',256829.0,19235.0,'Mbaiki','Lobaye').
province('Mambere-Kadei','cf',348940.0,30203.0,'Berberati','Mambere-Kadei').
province('Mbomou','cf',180635.0,61150.0,'Bangassou','Mbomou').
province('Nana-Gribizi','cf',144652.0,19996.0,'Kaga-Bandoro','Nana-Gribizi').
province('Nana-Mambere','cf',290783.0,26600.0,'Bouar','Nana-Mambere').
province('Ombella Mpoko','cf',273950.0,31835.0,0.0,0.0).
province('Ouaka','cf',315567.0,49900.0,'Bambari','Ouaka').
province('Ouham','cf',398299.0,50250.0,'Bossangoa','Ouham').
province('Ouham-Pende','cf',435718.0,32100.0,'Bozoum','Ouham-Pende').
province('Sangha-Mbaere','cf',99913.0,19412.0,'Nola','Sangha-Mbaere').
province('Vakaga','cf',48651.0,46500.0,'Birao','Vakaga').
province('Batha','td',391742.0,88800.0,0.0,0.0).
province('Biltine','td',250978.0,46850.0,'Biltine','Biltine').
province('Bourkou-Ennedi-Tibesti','td',99389.0,600350.0,0.0,0.0).
province('Chari-Baguirmi','td',1700160.0,82910.0,0.0,0.0).
province('Guera','td',415909.0,58950.0,'Mongo','Guera').
province('Kanem','td',380157.0,114520.0,'Mao','Kanem').
province('Lac','td',343496.0,22320.0,'Bol','Lac').
province('Logone Occidental','td',618580.0,8695.0,0.0,0.0).
province('Logone Oriental','td',598990.0,28035.0,0.0,0.0).
province('Mayo-Kebbi','td',1120612.0,30105.0,0.0,0.0).
province('Moyen-Chari','td',1003054.0,45180.0,0.0,0.0).
province('Ouaddai','td',738647.0,76240.0,'Abeche','Ouaddai').
province('Salamat','td',250430.0,63000.0,0.0,0.0).
province('Tandjile','td',616362.0,18045.0,0.0,0.0).
province('Aisen','cl',88510.0,108997.0,0.0,0.0).
province('Antofagasta','cl',516245.0,125253.0,'Antofagasta','Antofagasta').
province('Araucania','cl',885769.0,31946.0,'Temuco','Araucania').
province('Atacama','cl',258959.0,74705.0,'Copiapo','Atacama').
province('Bio Bio','cl',1883499.0,36939.0,0.0,0.0).
province('Coquimbo','cl',627607.0,40656.0,'La Serena','Coquimbo').
province('Libertador General Bernardo OHiggins','cl',795359.0,16456.0,'Rancagua','Libertador General Bernardo OHiggins').
province('Los Lagos','cl',1090067.0,67247.0,0.0,0.0).
province('Magellanes','cl',153737.0,132034.0,0.0,0.0).
province('Maule','cl',921488.0,30518.0,'Talca','Maule').
province('Metropolitana','cl',6257295.0,15549.0,0.0,0.0).
province('Tarapaca','cl',452012.0,58786.0,0.0,0.0).
province('Valparaiso','cl',1583467.0,16396.0,'Valparaiso','Valparaiso').
province('Anhui','cn',7.3059713E7,139057.0,'Hefei','Anhui').
province('Aomen','cn',482581.0,24.0,'Aomen','Aomen').
province('Chongqing','cn',3.234401E7,82403.0,0.0,0.0).
province('Gansu','cn',2.6316859E7,464186.0,'Lanzhou','Gansu').
province('Guangxi','cn',4.9443331E7,241410.0,'Nanning','Guangxi').
province('Hainan','cn',7940197.0,34353.0,'Haikou','Hainan').
province('Heilongjiang','cn',3.7073415E7,432477.0,'Harbin','Heilongjiang').
province('Hubei','cn',6.1263368E7,185125.0,'Wuhan','Hubei').
province('Jiangsu','cn',7.211746E7,97607.0,'Nanjing','Jiangsu').
province('Jilin','cn',2.740293E7,192105.0,'Changchun','Jilin').
province('Neimenggu','cn',2.4433946E7,1218698.0,'Hohhot','Neimenggu').
province('Peking','cn',1.16537E7,16808.0,0.0,0.0).
province('Qinghai','cn',4928342.0,716693.0,'Xining','Qinghai').
province('Shandong','cn',9.2163194E7,156867.0,'Jinan','Shandong').
province('Shanghai','cn',1.3355925E7,6341.0,0.0,0.0).
province('Sichuan','cn',8.6421728E7,491146.0,'Chengdu','Sichuan').
province('Tianjin','cn',9338819.0,11632.0,0.0,0.0).
province('Xinjiang','cn',1.9514731E7,1774034.0,'Urumqi','Xinjiang').
province('Zhejiang','cn',4.6354322E7,103900.0,'Hangzhou','Zhejiang').
province('Amazonas','co',80360.0,109665.0,'Leticia','Amazonas').
province('Antioquia','co',5750478.0,63612.0,'Medellin','Antioquia').
province('Arauca','co',282302.0,23818.0,'Arauca','Arauca').
province('Atlantico','co',2365663.0,3388.0,'Barranquilla','Atlantico').
province('Bogota','co',7117984.0,1587.0,0.0,0.0).
province('Bolivar','co',2229967.0,25978.0,'Cartagena','Bolivar').
province('Boyaca','co',1411239.0,23189.0,'Tunja','Boyaca').
province('Caldas','co',1170187.0,7888.0,'Manizales','Caldas').
province('Casanare','co',325713.0,44640.0,'Yopal','Casanare').
province('Cauca','co',1363054.0,29308.0,'Popayan','Cauca').
province('Cesar','co',1050303.0,22905.0,'Valledupar','Cesar').
province('Choco','co',413173.0,46530.0,'Quibdo','Choco').
province('Cordoba','co',1392905.0,25020.0,'Monteria','Cordoba').
province('Cundinamarca','co',2349578.0,22623.0,'Bogota','Bogota').
province('Guainia','co',43314.0,72238.0,0.0,0.0).
province('Guaviare','co',133236.0,53460.0,'San Jose del Guaviare','Guaviare').
province('Huila','co',994218.0,19890.0,'Neiva','Huila').
province('La Guajira','co',524619.0,20848.0,'Riohacha','La Guajira').
province('Magdalena','co',1403318.0,23188.0,'Santa Marta','Magdalena').
province('Meta','co',771089.0,85635.0,'Villavicencio','Meta').
province('Narino','co',1775139.0,33268.0,'Pasto','Narino').
province('Putumayo','co',378483.0,24885.0,'Mocoa','Putumayo').
province('Quindio','co',613375.0,1845.0,'Armenia','Quindio').
province('San Andres y Providencia','co',83491.0,44.0,0.0,0.0).
province('Santander','co',2085084.0,30537.0,'Bucaramanga','Santander').
province('Tolima','co',1312972.0,23562.0,'Ibague','Tolima').
province('Valle del Cauca','co',4524678.0,22140.0,0.0,0.0).
province('Mwali','km',34533.0,290.0,'Fomboni','Mwali').
province('Ndzouani','km',270174.0,424.0,0.0,0.0).
province('Ngazidja','km',345599.0,1148.0,'Moroni','Ngazidja').
province('Brazzaville','cg',1186.0,100.0,0.0,0.0).
province('Cuvette','cg',152421.0,74850.0,'Owando','Cuvette').
province('Kouilou','cg',1012146.0,13694.0,0.0,0.0).
province('Likouala','cg',81121.0,66044.0,'Impfondo','Likouala').
province('Niari','cg',240332.0,25940.0,0.0,0.0).
province('Pool','cg',176433.0,33955.0,'Kinkala','Pool').
province('Bandundu','cd',6840451.0,295658.0,'Bandundu','Bandundu').
province('Equateur','cd',6354277.0,403292.0,'Mbandaka','Equateur').
province('Haut-Congo','cd',6828409.0,503239.0,0.0,0.0).
province('Katanga','cd',4542025.0,496877.0,'Lubumbashi','Katanga').
province('Kinshasa','cd',8093048.0,9965.0,'Kinshasa','Kinshasa').
province('Nord-Kivu','cd',4908500.0,59483.0,'Goma','Nord-Kivu').
province('Aitutaki','ck',1808.0,18.3,0.0,0.0).
province('Atiu','ck',511.0,26.9,0.0,0.0).
province('Avarua','ck',50.0,2.1,0.0,0.0).
province('Mangaia','ck',628.0,51.8,0.0,0.0).
province('Manihiki','ck',467.0,5.4,0.0,0.0).
province('Manuae and Teauotu','ck',0.0,6.2,0.0,0.0).
province('Mauke','ck',405.0,18.4,0.0,0.0).
province('Mitiaro','ck',196.0,22.3,0.0,0.0).
province('Nassau','ck',63.0,1.3,0.0,0.0).
province('Pukapuka','ck',632.0,1.3,0.0,0.0).
province('Rakahanga','ck',140.0,4.1,0.0,0.0).
province('Rarotonga','ck',13457.0,67.1,0.0,0.0).
province('Suwarrow','ck',1.0,0.4,0.0,0.0).
province('Takutea','ck',0.0,1.3,0.0,0.0).
province('Tongareva','ck',264.0,9.8,0.0,0.0).
province('Alajuela','cr',810585.0,9753.53,'Alajuela','Alajuela').
province('Guanacaste','cr',297793.0,10140.71,'Liberia','Guanacaste').
province('Limon','cr',390941.0,9188.52,'Limon','Limon').
province('Bjelovar-Bilogora','hr',133734.0,2638.0,0.0,0.0).
province('Dubrovnik-Neretva','hr',123470.0,1782.0,0.0,0.0).
province('Grad Zagreb','hr',782951.0,640.0,0.0,0.0).
province('Istra','hr',207352.0,2813.0,0.0,0.0).
province('Karlovac','hr',142480.0,3622.0,0.0,0.0).
province('Koprivnica-Krizevci','hr',125075.0,1734.0,0.0,0.0).
province('Krapina-Zagorje','hr',143128.0,1230.0,0.0,0.0).
province('Lika-Senj','hr',53939.0,5350.0,0.0,0.0).
province('Medimurje','hr',119005.0,730.0,0.0,0.0).
province('Osijek-Baranja','hr',332121.0,4149.0,0.0,0.0).
province('Pozega-Slavonija','hr',86250.0,1821.0,0.0,0.0).
province('Primorje-Gorski Kotar','hr',306997.0,3590.0,0.0,0.0).
province('Sibenik-Knin','hr',113442.0,2994.0,0.0,0.0).
province('Sisak-Moslavina','hr',186293.0,4448.0,0.0,0.0).
province('Slavonski Brod-Posavina','hr',177628.0,2027.0,0.0,0.0).
province('Split-Dalmacija','hr',465941.0,4524.0,0.0,0.0).
province('Varazdin','hr',185672.0,1260.0,0.0,0.0).
province('Virovitica-Podravina','hr',93845.0,2021.0,0.0,0.0).
province('Vukovar-Srijem','hr',205768.0,2448.0,0.0,0.0).
province('Zadar','hr',162837.0,3643.0,0.0,0.0).
province('Zagreb','hr',311209.0,3078.0,'Zagreb','Grad Zagreb').
province('Camagueey','cu',797329.0,14134.0,0.0,0.0).
province('Cayos Adjacentes','cu',0.0,3715.0,0.0,0.0).
province('Cienfuegos','cu',400983.0,4149.0,'Cienfuegos','Cienfuegos').
province('Ciudad de la Habana','cu',2163822.0,727.0,0.0,0.0).
province('Holguin','cu',1045356.0,9105.0,'Holguin','Holguin').
province('La Habana','cu',718945.0,5671.0,0.0,0.0).
province('Las Tunas','cu',537616.0,6373.0,0.0,0.0).
province('Matanzas','cu',669104.0,11669.0,'Matanzas','Matanzas').
province('Pinar del Rio','cu',744038.0,10860.0,'Pinar del Rio','Pinar del Rio').
province('Villa Clara','cu',837298.0,8069.0,'Santa Clara','Villa Clara').
province('Government controlled area','cy',721735.0,5896.0,0.0,0.0).
province('Turkish controlled area','cy',229212.0,3355.0,0.0,0.0).
province('Jihocesky','cz',615945.0,10056.0,0.0,0.0).
province('Jihomoravsky','cz',1112501.0,7067.0,0.0,0.0).
province('Karlovarsky','cz',299860.0,3315.0,0.0,0.0).
province('Kralovehradecky','cz',543044.0,4757.0,0.0,0.0).
province('Liberecky','cz',422196.0,3163.0,0.0,0.0).
province('Moravskoslezsky','cz',1252301.0,5555.0,0.0,0.0).
province('Olomoucky','cz',630703.0,5139.0,0.0,0.0).
province('Pardubicky','cz',501296.0,4519.0,0.0,0.0).
province('Plzensky','cz',543070.0,7560.0,0.0,0.0).
province('Prague','cz',1154508.0,496.0,0.0,0.0).
province('Stredocesky','cz',1247932.0,11014.0,0.0,0.0).
province('Ustecky','cz',808282.0,5335.0,0.0,0.0).
province('Vysocina','cz',512026.0,6925.0,'Jihlava','Vysocina').
province('Zlinsky','cz',586607.0,3965.0,0.0,0.0).
province('Arhus','dk',652788.0,4561.0,0.0,0.0).
province('Bornholm','dk',43234.0,588.0,0.0,0.0).
province('Frederiksberg Kommune','dk',93792.0,9.0,0.0,0.0).
province('Frederiksborg','dk',378216.0,1347.0,0.0,0.0).
province('Fyn','dk',471361.0,3486.0,0.0,0.0).
province('Kobenhavn','dk',620161.0,526.0,0.0,0.0).
province('Kobenhavns Kommune','dk',511410.0,88.0,0.0,0.0).
province('Nordjylland','dk',496338.0,6173.0,0.0,0.0).
province('Ribe','dk',224339.0,3132.0,0.0,0.0).
province('Ringkobing','dk',275448.0,4853.0,0.0,0.0).
province('Roskilde','dk',239113.0,891.0,0.0,0.0).
province('Sonderjylland','dk',251805.0,3938.0,0.0,0.0).
province('Storstrom','dk',261364.0,3398.0,0.0,0.0).
province('Vejle','dk',354.0,2997.0,0.0,0.0).
province('Vestsjaelland','dk',303144.0,2984.0,0.0,0.0).
province('Viborg','dk',234325.0,4122.0,0.0,0.0).
province('Ali Sabih','dj',59827.0,2400.0,0.0,0.0).
province('Awbuk','dj',26537.0,5700.0,0.0,0.0).
province('Dihzil','dj',17980.0,7200.0,0.0,0.0).
province('Jibuti','dj',629916.0,600.0,0.0,0.0).
province('Tajurah','dj',33133.0,7300.0,0.0,0.0).
province('Saint Andrew','dm',11122.0,180.0,0.0,0.0).
province('Saint David','dm',7014.0,127.0,0.0,0.0).
province('Saint George','dm',20441.0,54.0,0.0,0.0).
province('Saint John','dm',5010.0,59.0,0.0,0.0).
province('Saint Joseph','dm',6213.0,120.0,0.0,0.0).
province('Saint Luke','dm',1603.0,11.0,0.0,0.0).
province('Saint Mark','dm',1904.0,10.0,0.0,0.0).
province('Saint Patrick','dm',8918.0,84.0,0.0,0.0).
province('Saint Paul','dm',7515.0,67.0,0.0,0.0).
province('Saint Peter','dm',1604.0,28.0,0.0,0.0).
province('Baoruco','do',90461.0,1282.23,0.0,0.0).
province('Barahona','do',182738.0,1739.38,'Barahona','Barahona').
province('Duarte','do',282432.0,1605.35,'San Francisco de Macoris','Duarte').
province('El Seibo','do',86448.0,1786.8,0.0,0.0).
province('Espaillat','do',231106.0,839.0,'Moca','Espaillat').
province('Independencia','do',546.0,2006.44,'Jimani','Independencia').
province('La Altagracia','do',208199.0,2474.34,0.0,0.0).
province('La Vega','do',395904.0,2287.0,'La Vega','La Vega').
province('Monsenor Nouel','do',172599.0,992.39,'Bonao','Monsenor Nouel').
province('Monte Cristi','do',115492.0,1924.35,0.0,0.0).
province('Monte Plata','do',183460.0,2632.14,'Monte Plata','Monte Plata').
province('Pedernales','do',22150.0,2074.53,'Pedernales','Pedernales').
province('Peravia','do',179259.0,997.56,'Bani','Peravia').
province('Puerto Plata','do',328401.0,1856.9,'Puerto Plata','Puerto Plata').
province('Salcedo','do',94072.0,440.43,'Salcedo','Salcedo').
province('Samana','do',97121.0,853.74,'Samana','Samana').
province('Sanchez Ramirez','do',146602.0,1196.13,'Cotui','Sanchez Ramirez').
province('San Cristobal','do',569609.0,1265.77,'San Cristobal','San Cristobal').
province('San Jose de Ocoa','do',62071.0,650.17,'San Jose de Ocoa','Peravia').
province('San Juan','do',235950.0,3569.41,'San Juan de la Maguana','San Juan').
province('San Pedro de Macoris','do',334327.0,1255.46,'San Pedro de Macoris','San Pedro de Macoris').
province('Santiago','do',973337.0,2839.0,'Santiago','Santiago').
province('Santiago Rodriguez','do',58469.0,1111.14,'San Ignacio de Sabaneta','Santiago Rodriguez').
province('Santo Domingo','do',2008177.0,1296.35,0.0,0.0).
province('Valverde','do',159135.0,823.38,'Mao','Valverde').
province('Aileu','tp',37825.0,729.0,0.0,0.0).
province('Ainaro','tp',54159.0,797.0,0.0,0.0).
province('Baucau','tp',105437.0,1494.0,0.0,0.0).
province('Bobonaro','tp',82382.0,1368.0,0.0,0.0).
province('Cova Lima','tp',56624.0,1226.0,0.0,0.0).
province('Dili','tp',171347.0,372.0,0.0,0.0).
province('Ermera','tp',104850.0,746.0,0.0,0.0).
province('Lautem','tp',57957.0,1702.0,0.0,0.0).
province('Liquica','tp',55820.0,543.0,0.0,0.0).
province('Manatuto','tp',38980.0,1706.0,0.0,0.0).
province('Manufahi','tp',44837.0,1325.0,0.0,0.0).
province('Oecussi','tp',59087.0,815.0,0.0,0.0).
province('Viqueque','tp',66748.0,1781.0,0.0,0.0).
province('Azuay','ec',598504.0,8124.7,0.0,0.0).
province('Bolivar','ec',168874.0,3939.9,0.0,0.0).
province('Canar','ec',206953.0,3122.1,0.0,0.0).
province('Carchi','ec',152304.0,3605.1,0.0,0.0).
province('Chimborazo','ec',403185.0,6071.9,0.0,0.0).
province('Cotopaxi','ec',350450.0,6569.3,0.0,0.0).
province('El Oro','ec',515664.0,5850.1,0.0,0.0).
province('Esmeraldas','ec',386032.0,15239.1,0.0,0.0).
province('Galapagos','ec',18555.0,8010.0,0.0,0.0).
province('Guayas','ec',3256763.0,20502.5,0.0,0.0).
province('Imbabura','ec',345781.0,4559.3,0.0,0.0).
province('Loja','ec',404085.0,11026.5,0.0,0.0).
province('Los Rios','ec',650709.0,7175.0,0.0,0.0).
province('Manabi','ec',1180375.0,18878.8,0.0,0.0).
province('Morona Santiago','ec',113300.0,25690.0,0.0,0.0).
province('Napo','ec',79610.0,11430.9,0.0,0.0).
province('Orellana','ec',85771.0,22500.0,0.0,0.0).
province('Pastaza','ec',61412.0,29773.7,0.0,0.0).
province('Pichincha','ec',2392409.0,12914.7,0.0,0.0).
province('Sucumbios','ec',130095.0,18327.5,0.0,0.0).
province('Tungurahua','ec',441389.0,3334.8,0.0,0.0).
province('Zamora Chinchipe','ec',76414.0,23110.8,0.0,0.0).
province('Zonas non delimitadas','ec',72170.0,2288.8,0.0,0.0).
province('ad-Daqahliyah','eg',4923279.0,3471.0,0.0,0.0).
province('al-Bahr-al-Ahmar','eg',187554.0,203685.0,0.0,0.0).
province('Alexandria','eg',3811512.0,2679.0,0.0,0.0).
province('al-Qalyubiyah','eg',3881458.0,1001.0,0.0,0.0).
province('al-Wadi al-Jadid','eg',169601.0,376505.0,0.0,0.0).
province('Aswan','eg',1116661.0,679.0,0.0,0.0).
province('Asyut','eg',3425569.0,1553.0,0.0,0.0).
province('Behera','eg',4689627.0,10130.0,0.0,0.0).
province('Beni Suef','eg',2256562.0,1322.0,0.0,0.0).
province('Cairo','eg',7734602.0,214.0,0.0,0.0).
province('Damietta','eg',1076130.0,589.0,0.0,0.0).
province('El Faiyum','eg',2425244.0,1827.0,0.0,0.0).
province('Gharbia','eg',3920797.0,1942.0,0.0,0.0).
province('Gizeh','eg',5649345.0,85153.0,0.0,0.0).
province('Ismailia','eg',863314.0,1442.0,0.0,0.0).
province('Janub Sina','eg',66519.0,33140.0,0.0,0.0).
province('Kafr el Sheikh','eg',2585868.0,3437.0,0.0,0.0).
province('Luxor','eg',422408.0,55.0,0.0,0.0).
province('Matruh','eg',269227.0,212112.0,0.0,0.0).
province('Menia','eg',4047985.0,2262.0,0.0,0.0).
province('Menufia','eg',3228926.0,1532.0,0.0,0.0).
province('North Sinai','eg',314295.0,27574.0,0.0,0.0).
province('Port Said','eg',538377.0,72.0,0.0,0.0).
province('Qena','eg',2936612.0,1796.0,0.0,0.0).
province('Sharkia','eg',5109637.0,4180.0,0.0,0.0).
province('Sohag','eg',3815484.0,1547.0,0.0,0.0).
province('Suez','eg',488124.0,17840.0,0.0,0.0).
province('Ahuachapan','sv',330108.0,1281.0,'Ahuachapan','Ahuachapan').
province('Cabanas','sv',175014.0,1104.0,'Sensuntepeque','Cabanas').
province('Chalatenango','sv',224145.0,2507.0,'Chalatenango','Chalatenango').
province('Cuscatlan','sv',225678.0,766.0,'Cojutepeque','Cuscatlan').
province('La Libertad','sv',649349.0,1653.0,'Nueva San Salvador','La Libertad').
province('La Paz','sv',310798.0,1224.0,'Zacatecoluca','La Paz').
province('La Union','sv',323091.0,2074.0,'La Union','La Union').
province('Morazan','sv',202456.0,1447.0,0.0,0.0).
province('San Miguel','sv',509801.0,2532.0,'San Miguel','San Miguel').
province('San Salvador','sv',1909275.0,892.0,'San Salvador','San Salvador').
province('Santa Ana','sv',579530.0,2023.0,'Santa Ana','Santa Ana').
province('San Vicente','sv',180743.0,1184.0,'San Vicente','San Vicente').
province('Sonsonate','sv',455300.0,1226.0,'Sonsonate','Sonsonate').
province('Usulutan','sv',392260.0,2130.0,'Usulutan','Usulutan').
province('Annobon','gq',4436.0,17.0,0.0,0.0).
province('Bioko Norte','gq',231716.0,776.0,0.0,0.0).
province('Bioko Sur','gq',25988.0,1241.0,0.0,0.0).
province('Centro Sur','gq',129606.0,9931.0,0.0,0.0).
province('Kie-Ntem','gq',161790.0,3943.0,0.0,0.0).
province('Litoral','gq',354282.0,6665.0,0.0,0.0).
province('Wele-Nzas','gq',177460.0,5478.0,0.0,0.0).
province('Anseba','er',611627.0,23200.0,'Keren','Anseba').
province('Debub','er',1072131.0,8000.0,0.0,0.0).
province('Debub-Keih-Bahri','er',289382.0,27600.0,0.0,0.0).
province('Gash-Barka','er',786964.0,33200.0,0.0,0.0).
province('Maekel','er',766534.0,1300.0,0.0,0.0).
province('Semien-Keih-Bahri','er',599304.0,27800.0,0.0,0.0).
province('Harju','ee',519133.0,4331.7,'Tallinn','Harju').
province('Hiiu','ee',10275.0,1023.3,0.0,0.0).
province('Ida-Viru','ee',173514.0,3172.9,'Johvi','Ida-Viru').
province('Jaerva','ee',38142.0,2622.8,0.0,0.0).
province('Jogeva','ee',37547.0,2603.8,'Jogeva','Jogeva').
province('Laeaene','ee',27904.0,2382.8,0.0,0.0).
province('Laeaene-Viru','ee',66409.0,3463.3,0.0,0.0).
province('Paernu','ee',89335.0,4806.3,0.0,0.0).
province('Polva','ee',31730.0,2164.8,'Polva','Polva').
province('Rapla','ee',37100.0,2980.1,'Rapla','Rapla').
province('Saare','ee',35275.0,2922.2,'Kuressaare','Saare').
province('Tartu','ee',148501.0,3089.4,'Tartu','Tartu').
province('Valga','ee',34790.0,2046.5,'Valga','Valga').
province('Viljandi','ee',56499.0,3589.1,'Viljandi','Viljandi').
province('Voru','ee',38686.0,2305.4,'Voru','Voru').
province('Addis Abeba','et',2777241.0,546.0,0.0,0.0).
province('Afar','et',1454366.0,96708.0,0.0,0.0).
province('Amhara','et',1.8185502E7,156960.0,0.0,0.0).
province('Benishangul','et',605284.0,50248.0,0.0,0.0).
province('Diredawa','et',331081.0,1025.0,0.0,0.0).
province('Gambella','et',239062.0,25369.0,0.0,0.0).
province('Harar','et',172385.0,374.0,0.0,0.0).
province('Oromia','et',2.4624336E7,353.0,0.0,0.0).
province('Somali','et',4447248.0,279252.0,0.0,0.0).
province('Southern','et',1.3640842E7,112727.0,0.0,0.0).
province('Tigray','et',4122696.0,50286.0,'Mekele','Tigray').
province('Falkland Islands','fk',2638.0,12173.0,0.0,0.0).
province('South Georgia','fk',23.0,3592.0,0.0,0.0).
province('South Sandwich Islands','fk',0.0,311.0,0.0,0.0).
province('Klaksvik','fo',5268.0,12.65,0.0,0.0).
province('Noreara Eysturoy','fo',1616.0,125.42,0.0,0.0).
province('Noreoy','fo',818.0,228.12,0.0,0.0).
province('Sandoy','fo',1353.0,124.74,0.0,0.0).
province('Streymoy','fo',3356.0,392.29,0.0,0.0).
province('Sueuroy','fo',5285.0,166.83,0.0,0.0).
province('Syera Eysturoy','fo',9395.0,160.91,0.0,0.0).
province('Torshavn','fo',19266.0,15.33,0.0,0.0).
province('Vaga','fo',2972.0,187.89,0.0,0.0).
province('Central','fj',341880.0,4293.0,'Suva','Central').
province('Eastern','fj',40065.0,1422.0,'Levuka','Eastern').
province('Ahvenanmaa','fi',26678.0,1527.0,0.0,0.0).
province('Central Finland','fi',268963.0,16248.0,0.0,0.0).
province('Central Ostrobothnia','fi',70106.0,5286.0,0.0,0.0).
province('Eastern Uusimaa','fi',93024.0,2747.0,0.0,0.0).
province('Kainuu','fi',84498.0,21567.0,0.0,0.0).
province('Kanta-Haeme','fi',167442.0,5204.0,0.0,0.0).
province('Kymenlaakso','fi',184318.0,5106.0,0.0,0.0).
province('Lapland','fi',183481.0,93003.0,0.0,0.0).
province('North Karelia','fi',167565.0,17782.0,0.0,0.0).
province('North Ostrobothnia','fi',376842.0,35291.0,0.0,0.0).
province('North Savo','fi',250294.0,16510.0,0.0,0.0).
province('Ostrobothnia','fi',172987.0,7675.0,0.0,0.0).
province('Paeijaet-Haeme','fi',199059.0,5133.0,0.0,0.0).
province('Region of Tampere','fi',462628.0,12605.0,0.0,0.0).
province('Satakunta','fi',232688.0,8290.0,0.0,0.0).
province('South Karelia','fi',135844.0,5674.0,0.0,0.0).
province('South Ostrobothnia','fi',192675.0,13458.0,0.0,0.0).
province('South Savo','fi',159305.0,14436.0,0.0,0.0).
province('Southwest Finland','fi',456054.0,10624.0,0.0,0.0).
province('Uusimaa','fi',1362469.0,6366.0,0.0,0.0).
province('Ain','fr',551910.0,5762.0,0.0,0.0).
province('Aisne','fr',539303.0,7369.0,0.0,0.0).
province('Allier','fr',339308.0,7340.0,0.0,0.0).
province('Alpes-de-Haute-Provence','fr',146857.0,6925.0,0.0,0.0).
province('Alpes-Maritimes','fr',1046077.0,4299.0,0.0,0.0).
province('Ardeche','fr',294168.0,5529.0,0.0,0.0).
province('Ardennes','fr',288309.0,5229.0,0.0,0.0).
province('Ariege','fr',138542.0,4890.0,0.0,0.0).
province('Aube','fr',296264.0,6004.0,0.0,0.0).
province('Aude','fr',319864.0,6139.0,0.0,0.0).
province('Aveyron','fr',261923.0,8736.0,0.0,0.0).
province('Bas-Rhin','fr',1081568.0,4755.0,0.0,0.0).
province('Bouches-du-Rhone','fr',1900086.0,5087.0,0.0,0.0).
province('Calvados','fr',673823.0,5548.0,0.0,0.0).
province('Cantal','fr',147266.0,5726.0,0.0,0.0).
province('Charente','fr',341113.0,5956.0,0.0,0.0).
province('Charente-Maritime','fr',580569.0,6864.0,0.0,0.0).
province('Cher','fr',313332.0,7235.0,0.0,0.0).
province('Correze','fr',231272.0,5857.0,0.0,0.0).
province('Corse-du-Sud','fr',118954.0,4014.0,0.0,0.0).
province('Cote-dOr','fr',520485.0,8763.0,0.0,0.0).
province('Cotes-dArmor','fr',545187.0,6878.0,0.0,0.0).
province('Creuse','fr',121076.0,5565.0,0.0,0.0).
province('Deux-Sevres','fr',346613.0,5999.0,0.0,0.0).
province('Dordogne','fr',393012.0,9060.0,0.0,0.0).
province('Doubs','fr',510992.0,5234.0,0.0,0.0).
province('Drome','fr',456654.0,6530.0,0.0,0.0).
province('Essonne','fr',1178057.0,1804.0,0.0,0.0).
province('Eure','fr',566400.0,6040.0,0.0,0.0).
province('Eure-et-Loir','fr',420764.0,5880.0,0.0,0.0).
province('Finistere','fr',868465.0,6733.0,0.0,0.0).
province('Gard','fr',655734.0,5853.0,0.0,0.0).
province('Gers','fr',172358.0,6257.0,0.0,0.0).
province('Gironde','fr',1349015.0,10000.0,0.0,0.0).
province('Haute-Corse','fr',147391.0,4666.0,0.0,0.0).
province('Haute-Garonne','fr',1137655.0,6309.0,0.0,0.0).
province('Haute-Loire','fr',212234.0,4977.0,0.0,0.0).
province('Haute-Marne','fr',190910.0,6211.0,0.0,0.0).
province('Hautes-Alpes','fr',128044.0,5549.0,0.0,0.0).
province('Haute-Saone','fr',231897.0,5360.0,0.0,0.0).
province('Haute-Savoie','fr',683165.0,4388.0,0.0,0.0).
province('Hautes-Pyrenees','fr',222615.0,4464.0,0.0,0.0).
province('Haute-Vienne','fr',360559.0,5520.0,0.0,0.0).
province('Haut-Rhin','fr',737147.0,3525.0,0.0,0.0).
province('Hauts-de-Seine','fr',1453877.0,176.0,0.0,0.0).
province('Herault','fr',976058.0,6101.0,0.0,0.0).
province('Ille-et-Vilaine','fr',921418.0,6775.0,0.0,0.0).
province('Indre','fr',228880.0,6791.0,0.0,0.0).
province('Indre-et-Loire','fr',575406.0,6127.0,0.0,0.0).
province('Isere','fr',1157592.0,7431.0,0.0,0.0).
province('Jura','fr',254464.0,4999.0,0.0,0.0).
province('Landes','fr',340462.0,9243.0,0.0,0.0).
province('Loire','fr',723506.0,4781.0,0.0,0.0).
province('Loire-Atlantique','fr',1196406.0,6815.0,0.0,0.0).
province('Loiret','fr',649918.0,6775.0,0.0,0.0).
province('Loir-et-Cher','fr',323842.0,6343.0,0.0,0.0).
province('Lot','fr',164233.0,5217.0,0.0,0.0).
province('Lot-et-Garonne','fr',308016.0,5361.0,0.0,0.0).
province('Lozere','fr',74376.0,5167.0,0.0,0.0).
province('Maine-et-Loire','fr',758397.0,7166.0,0.0,0.0).
province('Manche','fr',487545.0,5938.0,0.0,0.0).
province('Marne','fr',574961.0,8162.0,0.0,0.0).
province('Mayenne','fr',292588.0,5175.0,0.0,0.0).
province('Meurthe-et-Moselle','fr',719691.0,5241.0,0.0,0.0).
province('Meuse','fr',191102.0,6216.0,0.0,0.0).
province('Morbihan','fr',666255.0,6823.0,0.0,0.0).
province('Moselle','fr',1038871.0,6216.0,0.0,0.0).
province('Nievre','fr',221975.0,6817.0,0.0,0.0).
province('Nord','fr',2585765.0,5742.0,0.0,0.0).
province('Oise','fr',803077.0,5860.0,0.0,0.0).
province('Orne','fr',294082.0,6103.0,0.0,0.0).
province('Paris','fr',2110694.0,105.0,0.0,0.0).
province('Pas-de-Calais','fr',1458837.0,6671.0,0.0,0.0).
province('Puy-de-Dome','fr',613235.0,7970.0,0.0,0.0).
province('Pyrenees-Atlantiques','fr',619151.0,7645.0,0.0,0.0).
province('Pyrenees-Orientales','fr',417069.0,4116.0,0.0,0.0).
province('Rhone','fr',1631845.0,3249.0,0.0,0.0).
province('Saone-et-Loire','fr',540093.0,8575.0,0.0,0.0).
province('Sarthe','fr',544545.0,6206.0,0.0,0.0).
province('Savoie','fr',393827.0,6028.0,0.0,0.0).
province('Seine-et-Marne','fr',1295190.0,5915.0,0.0,0.0).
province('Seine-Maritime','fr',1258313.0,6278.0,0.0,0.0).
province('Seine-Saint-Denis','fr',1396682.0,236.0,0.0,0.0).
province('Somme','fr',564694.0,6170.0,0.0,0.0).
province('Tarn','fr',346559.0,5758.0,0.0,0.0).
province('Tarn-et-Garonne','fr',211864.0,3718.0,0.0,0.0).
province('Territoire de Belfort','fr',140684.0,609.0,0.0,0.0).
province('Val-de-Marne','fr',1242789.0,245.0,0.0,0.0).
province('Val-dOise','fr',1158315.0,1246.0,0.0,0.0).
province('Var','fr',964504.0,5973.0,0.0,0.0).
province('Vaucluse','fr',528178.0,3567.0,0.0,0.0).
province('Vendee','fr',565048.0,6720.0,0.0,0.0).
province('Vienne','fr',414452.0,6990.0,0.0,0.0).
province('Vosges','fr',380361.0,5874.0,0.0,0.0).
province('Yonne','fr',342870.0,7427.0,0.0,0.0).
province('Yvelines','fr',1404428.0,2284.0,0.0,0.0).
province('Cayenne','gf',147863.0,45913.0,0.0,0.0).
province('Saint-Laurent-du-Maroni','gf',46414.0,37621.0,0.0,0.0).
province('Clipperton Island','pf',0.0,7.0,0.0,0.0).
province('Iles du Vent','pf',194937.0,1176.0,0.0,0.0).
province('Iles sous le Vent','pf',31816.0,471.0,0.0,0.0).
province('Marquises','pf',8982.0,1276.0,0.0,0.0).
province('Tuamotu-Gambier','pf',16267.0,916.0,0.0,0.0).
province('Tubuai','pf',6288.0,48.0,0.0,0.0).
province('Estuaire','ga',638219.0,20740.0,'Libreville','Estuaire').
province('Haut-Ogooue','ga',143715.0,36547.0,0.0,0.0).
province('Moyen-Ogooue','ga',58307.0,18535.0,'Lambarene','Moyen-Ogooue').
province('Ngounie','ga',107173.0,37750.0,0.0,0.0).
province('Nyanga','ga',54330.0,21285.0,'Tchibanga','Nyanga').
province('Ogooue-Ivindo','ga',67326.0,46075.0,'Makokou','Ogooue-Ivindo').
province('Ogooue-Lolo','ga',60510.0,25380.0,'Koulamoutou','Ogooue-Lolo').
province('Ogooue-Maritime','ga',134913.0,22890.0,'Port-Gentil','Ogooue-Maritime').
province('Woleu-Ntem','ga',134028.0,38465.0,'Oyem','Woleu-N').
province('Banjul','gm',34598.0,12.0,0.0,0.0).
province('Basse','gm',187972.0,2069.0,0.0,0.0).
province('Brikama','gm',428098.0,1764.0,0.0,0.0).
province('Janjanbureh','gm',109905.0,1280.0,0.0,0.0).
province('Kanifing','gm',345189.0,76.0,0.0,0.0).
province('Kerewan','gm',175565.0,2256.0,0.0,0.0).
province('Kuntaur','gm',80710.0,1614.0,0.0,0.0).
province('Mansakonko','gm',73473.0,1618.0,0.0,0.0).
province('Abkhasia','ge',162453.0,8700.0,0.0,0.0).
province('Ajaria','ge',370052.0,2880.0,'Batumi','Ajaria').
province('Guria','ge',141826.0,2000.0,'Ozurgeti','Guria').
province('Imereti','ge',703480.0,6600.0,'Kutaisi','Imereti').
province('Kakheti','ge',395453.0,11400.0,'Telavi','Kakheti').
province('Kvemo Kartli','ge',518116.0,6400.0,'Rustavi','Kvemo Kartli').
province('Mtskheta-Mtianeti','ge',122575.0,6800.0,'Mtskheta','Mtskheta-Mtianeti').
province('Raga-Lechkumi and Kverno Svaneti','ge',48571.0,4900.0,0.0,0.0).
province('Samagrelo and Zemo Svaneti','ge',382030.0,7400.0,0.0,0.0).
province('Samtskhe-Javakheti','ge',207441.0,6400.0,'Akhaltsikhe','Samtskhe-Javakheti').
province('Shida Kartli','ge',320655.0,4800.0,'Gori','Shida Kartli').
province('Tbilisi','ge',1106528.0,1420.0,'Tbilisi','Tbilisi').
province('Baden-Wuerttemberg','de',1.0781006E7,35751.64,'Stuttgart','Baden-Wuerttemberg').
province('Berlin','de',3398362.0,891.75,'Berlin','Berlin').
province('Brandenburg','de',2560028.0,29476.67,'Potsdam','Brandenburg').
province('Bremen','de',666117.0,404.28,'Bremen','Bremen').
province('Hamburg','de',1733846.0,755.26,'Hamburg','Hamburg').
province('Hassia','de',6120010.0,21114.88,'Wiesbaden','Hassia').
province('Lower Saxony','de',8029107.0,47617.97,'Hanover','Lower Saxony').
province('Rhineland-Palatinate','de',4076208.0,19846.91,'Mainz','Rhineland-Palatinate').
province('Saarland','de',1061840.0,2568.53,'Saarbruecken','Saarland').
province('Sachsen-Anhalt','de',2486108.0,20444.72,'Magdeburg','Sachsen-Anhalt').
province('Saxony','de',4278157.0,18413.0,'Dresden','Saxony').
province('Schleswig-Holstein','de',2840122.0,15762.9,'Kiel','Schleswig-Holstein').
province('Ashanti','gh',4105345.0,24535.0,'Kumasi','Ashanti').
province('Brong-Ahafo','gh',1973210.0,39557.0,0.0,0.0).
province('Central','gh',1717556.0,9826.0,'Cape Coast','Central').
province('Eastern','gh',2194271.0,19977.0,'Koforidua','Eastern').
province('Greater Accra','gh',3460757.0,3685.0,'Accra','Greater Accra').
province('Northern','gh',2003161.0,70383.0,'Tamale','Northern').
province('Upper East','gh',948133.0,8842.0,'Bolgatanga','Upper East').
province('Upper West','gh',610463.0,20814.0,'Wa','Upper West').
province('Volta','gh',1738725.0,20572.0,'Ho','Volta').
province('Western','gh',2165352.0,24292.0,0.0,0.0).
province('Ahaia','gr',331316.0,3271.0,0.0,0.0).
province('Aitolia kai Akarnania','gr',223188.0,5461.0,0.0,0.0).
province('Argolis','gr',108637.0,2154.0,0.0,0.0).
province('Arkadia','gr',100611.0,4419.0,0.0,0.0).
province('Arta','gr',77681.0,1662.0,0.0,0.0).
province('Attiki','gr',3841406.0,3808.0,0.0,0.0).
province('Ayion Oros','gr',2567.0,336.0,0.0,0.0).
province('Dodekanisos','gr',200452.0,2714.0,0.0,0.0).
province('Drama','gr',106371.0,3468.0,0.0,0.0).
province('Evritania','gr',34855.0,1869.0,0.0,0.0).
province('Evros','gr',150580.0,4242.0,0.0,0.0).
province('Evvoia','gr',218031.0,4167.0,0.0,0.0).
province('Florina','gr',55210.0,1924.0,0.0,0.0).
province('Fokis','gr',49577.0,2120.0,0.0,0.0).
province('Fthiotis','gr',181383.0,4441.0,0.0,0.0).
province('Grevena','gr',38256.0,2291.0,0.0,0.0).
province('Halkidiki','gr',109586.0,2918.0,0.0,0.0).
province('Hania','gr',156371.0,2376.0,0.0,0.0).
province('Hios','gr',53817.0,904.0,0.0,0.0).
province('Ilia','gr',198762.0,2618.0,0.0,0.0).
province('Imathia','gr',144834.0,1701.0,0.0,0.0).
province('Ioannina','gr',174606.0,4990.0,0.0,0.0).
province('Iraklion','gr',302847.0,2641.0,0.0,0.0).
province('Karditsa','gr',130214.0,2636.0,0.0,0.0).
province('Kastoria','gr',53584.0,1720.0,0.0,0.0).
province('Kavala','gr',147885.0,2111.0,0.0,0.0).
province('Kefallinia','gr',42088.0,904.0,0.0,0.0).
province('Kerkira','gr',113658.0,641.0,0.0,0.0).
province('Kiklades','gr',119549.0,2572.0,0.0,0.0).
province('Kilkis','gr',91828.0,2519.0,0.0,0.0).
province('Korinthia','gr',159928.0,2290.0,0.0,0.0).
province('Kozani','gr',156806.0,3516.0,0.0,0.0).
province('Lakonia','gr',100872.0,3636.0,0.0,0.0).
province('Larisa','gr',282447.0,5381.0,0.0,0.0).
province('Lasithi','gr',77917.0,1823.0,0.0,0.0).
province('Lesvos','gr',110220.0,2154.0,0.0,0.0).
province('Levkas','gr',22879.0,356.0,0.0,0.0).
province('Magnisia','gr',210330.0,2636.0,0.0,0.0).
province('Messinia','gr',180265.0,2991.0,0.0,0.0).
province('Pella','gr',148191.0,2506.0,0.0,0.0).
province('Pieria','gr',134739.0,1516.0,0.0,0.0).
province('Preveza','gr',59600.0,1036.0,0.0,0.0).
province('Rethimni','gr',86532.0,1496.0,0.0,0.0).
province('Rodopi','gr',112884.0,2543.0,0.0,0.0).
province('Samos','gr',44115.0,778.0,0.0,0.0).
province('Serrai','gr',203093.0,3968.0,0.0,0.0).
province('Thesprotia','gr',46811.0,1515.0,0.0,0.0).
province('Thessaloniki','gr',1099599.0,3683.0,0.0,0.0).
province('Trikala','gr',137723.0,3384.0,0.0,0.0).
province('Voiotia','gr',130769.0,2952.0,0.0,0.0).
province('Xanthi','gr',105530.0,1793.0,0.0,0.0).
province('Zakinthos','gr',41468.0,406.0,0.0,0.0).
province('Aasiaat','gl',3330.0,600.0,0.0,0.0).
province('Ammassalik','gl',3068.0,232100.0,0.0,0.0).
province('Illoqqortoormiut','gl',539.0,227800.0,0.0,0.0).
province('Ilulissat','gl',4842.0,36400.0,0.0,0.0).
province('Ivittuut','gl',188.0,100.0,0.0,0.0).
province('Kangaatsiaq','gl',1514.0,38700.0,0.0,0.0).
province('Maniitsoq','gl',3587.0,62600.0,0.0,0.0).
province('Nanortalik','gl',2390.0,18000.0,0.0,0.0).
province('Narsaq','gl',2019.0,28900.0,0.0,0.0).
province('Nuuk','gl',15165.0,88200.0,0.0,0.0).
province('Outside municipalities','gl',289.0,867200.0,0.0,0.0).
province('Paamiut','gl',2003.0,27100.0,0.0,0.0).
province('Qaanaaq','gl',846.0,225500.0,0.0,0.0).
province('Qaqortoq','gl',3513.0,4100.0,0.0,0.0).
province('Qasigiannguit','gl',1432.0,13400.0,0.0,0.0).
province('Qeqertarsuaq','gl',1025.0,9700.0,0.0,0.0).
province('Sisimiut','gl',5931.0,34400.0,0.0,0.0).
province('Upernavik','gl',2907.0,186.0,0.0,0.0).
province('Uummannaq','gl',2436.0,74500.0,0.0,0.0).
province('Carriacou-Petite Martinique','gd',5944.0,34.5,0.0,0.0).
province('Saint Andrew','gd',25339.0,99.0,0.0,0.0).
province('Saint Davids','gd',11471.0,44.0,0.0,0.0).
province('Saint George','gd',33264.0,65.0,0.0,0.0).
province('Saint John','gd',9176.0,35.0,0.0,0.0).
province('Saint Mark','gd',4067.0,25.0,0.0,0.0).
province('Saint Patrick','gd',10533.0,42.0,0.0,0.0).
province('Basse-Terre','gp',178231.0,848.0,0.0,0.0).
province('Grande-Terre','gp',211070.0,590.0,0.0,0.0).
province('Iles des Saintes','gp',2420.0,13.0,0.0,0.0).
province('La Desirade','gp',1914.0,20.0,0.0,0.0).
province('Marie-Galante','gp',16003.0,158.0,0.0,0.0).
province('Saint Barthelemy','gp',5988.0,21.0,0.0,0.0).
province('Saint Martin','gp',33898.0,54.0,0.0,0.0).
province('Agana Heights','gu',3966.0,3.0,0.0,0.0).
province('Agat','gu',5840.0,26.0,0.0,0.0).
province('Asan','gu',2038.0,16.0,0.0,0.0).
province('Barrigada','gu',8305.0,23.0,0.0,0.0).
province('Chalan-Pago-Ordot','gu',6573.0,16.0,0.0,0.0).
province('Dededo','gu',47908.0,78.0,0.0,0.0).
province('Hagatna','gu',1050.0,3.0,0.0,0.0).
province('Inarajan','gu',3273.0,49.0,0.0,0.0).
province('Mangilao','gu',14450.0,26.0,0.0,0.0).
province('Merizo','gu',2325.0,16.0,0.0,0.0).
province('Mongmong-Toto-Maite','gu',7043.0,5.0,0.0,0.0).
province('Piti','gu',1549.0,18.0,0.0,0.0).
province('Santa Rita','gu',7000.0,44.0,0.0,0.0).
province('Sinajana','gu',2863.0,3.0,0.0,0.0).
province('Talofofo','gu',3645.0,44.0,0.0,0.0).
province('Tamuning','gu',18118.0,16.0,0.0,0.0).
province('Umatac','gu',857.0,16.0,0.0,0.0).
province('Yigo','gu',21878.0,91.0,0.0,0.0).
province('Yona','gu',6894.0,52.0,0.0,0.0).
province('Alta Verapaz','gt',174992.0,8686.0,'Coban','Alta Verapaz').
province('Baja Verapa','gt',1160660.0,3124.0,'Salama','Baja Verapaz').
province('Chimaltenango','gt',486420.0,1979.0,'Chimaltenango','Chimaltenango').
province('Chiquimula','gt',321990.0,2376.0,'Chiquimula','Chiquimula').
province('El Progreso','gt',147544.0,1922.0,'Guastatoya','El Progreso').
province('Escuintla','gt',581271.0,4384.0,'Escuintla','Escuintla').
province('Guatemala','gt',2760338.0,2126.0,'Guatemala','Guatemala').
province('Huehuetenango','gt',908054.0,7403.0,'Huehuetenango','Huehuetenango').
province('Izabal','gt',328514.0,9038.0,'Puerto Barrios','Izabal').
province('Peten','gt',420306.0,35854.0,'Flores','Peten').
province('Quezaltenango','gt',653715.0,1951.0,0.0,0.0).
province('Retalhuleu','gt',254328.0,1858.0,'Retalhuleu','Retalhuleu').
province('San Marcos','gt',829953.0,3791.0,'San Marcos','San Marcos').
province('Solola','gt',333662.0,1061.0,'Solola','Solola').
province('Totonicapan','gt',355309.0,1061.0,'Totonicapan','Totonicapan').
province('Alderney','gg',2027.0,7.9,0.0,0.0).
province('Castel','gg',9046.0,10.1,0.0,0.0).
province('Forest','gg',1648.0,4.2,0.0,0.0).
province('Herm and Jethou','gg',96.0,14.8,0.0,0.0).
province('Saint Andrew','gg',2461.0,4.4,0.0,0.0).
province('Saint Martin','gg',6373.0,7.3,0.0,0.0).
province('Saint Peter Port','gg',16688.0,6.5,0.0,0.0).
province('Saint Pierre du Bois','gg',2214.0,6.2,0.0,0.0).
province('Saint Sampson','gg',8736.0,6.0,0.0,0.0).
province('Saint Saviour','gg',2866.0,6.2,0.0,0.0).
province('Sark','gg',644.0,5.5,0.0,0.0).
province('Torteval','gg',987.0,3.1,0.0,0.0).
province('Vale','gg',9670.0,8.8,0.0,0.0).
province('Beyla','gn',188037.0,17452.0,0.0,0.0).
province('Boffa','gn',165188.0,5003.0,0.0,0.0).
province('Boke','gn',289443.0,10053.0,'Boke','Boke').
province('Coyah','gn',156445.0,5576.0,0.0,0.0).
province('Dabola','gn',114244.0,6000.0,0.0,0.0).
province('Dalaba','gn',154812.0,3400.0,0.0,0.0).
province('Dinguiraye','gn',155629.0,11000.0,0.0,0.0).
province('Faranah','gn',166587.0,12400.0,'Faranah','Faranah').
province('Forecariah','gn',135811.0,4265.0,0.0,0.0).
province('Fria','gn',82070.0,2175.0,0.0,0.0).
province('Gaoual','gn',158193.0,11500.0,0.0,0.0).
province('Gueckedou','gn',404739.0,4157.0,0.0,0.0).
province('Kerouane','gn',124620.0,7950.0,0.0,0.0).
province('Kindia','gn',286188.0,8828.0,'Kindia','Kindia').
province('Kissidougou','gn',213567.0,8872.0,0.0,0.0).
province('Koubia','gn',114361.0,1480.0,0.0,0.0).
province('Koundara','gn',109814.0,5500.0,0.0,0.0).
province('Kouroussa','gn',159593.0,12035.0,0.0,0.0).
province('Lelouma','gn',161457.0,2150.0,0.0,0.0).
province('Lola','gn',124387.0,4219.0,0.0,0.0).
province('Macenta','gn',296228.0,8710.0,0.0,0.0).
province('Mali','gn',245859.0,8800.0,0.0,0.0).
province('Mamou','gn',222077.0,6160.0,'Mamou','Mamou').
province('Mandiana','gn',158893.0,12950.0,0.0,0.0).
province('Pita','gn',265676.0,4000.0,0.0,0.0).
province('Siguiri','gn',243877.0,19750.0,0.0,0.0).
province('Telimele','gn',283629.0,8080.0,0.0,0.0).
province('Tougue','gn',132080.0,6200.0,0.0,0.0).
province('Yomou','gn',86730.0,6000.0,0.0,0.0).
province('Bafata','gw',194592.0,5981.0,'Bafata','Bafata').
province('Bissau','gw',396747.0,78.0,'Bissau','Bissau').
province('Bolama','gw',30146.0,2624.0,0.0,0.0).
province('Gabu','gw',192904.0,9150.0,'Gabu','Gabu').
province('Tombali','gw',105485.0,3736.0,'Catio','Tombali').
province('Barima-Waini','gy',21521.0,20339.0,0.0,0.0).
province('Cuyuni-Mazaruni','gy',20798.0,47213.0,0.0,0.0).
province('Demerara-Mahaica','gy',360542.0,2233.0,0.0,0.0).
province('East Berbice-Corentyne','gy',172917.0,36255.0,0.0,0.0).
province('Essequibo Islands-West Demerara','gy',119420.0,3755.0,0.0,0.0).
province('Mahaica-Berbice','gy',64515.0,4170.0,0.0,0.0).
province('Pomeroon-Supenaam','gy',48751.0,6195.0,0.0,0.0).
province('Potaro-Siparuni','gy',6672.0,20052.0,0.0,0.0).
province('Upper Demerara-Berbice','gy',44878.0,17081.0,0.0,0.0).
province('Upper Takutu-Upper Essequibo','gy',17707.0,57790.0,0.0,0.0).
province('Centre','ht',538556.0,3597.0,'Hinche','Centre').
province('GrandAnse','ht',684632.0,3100.0,0.0,0.0).
province('Nord','ht',829603.0,2175.0,'Cap-Haitien','Nord').
province('Ouest','ht',3088962.0,4595.0,'Port-au-Prince','Ouest').
province('Sud','ht',690256.0,2602.0,'Les Cayes','Sud').
province('Choluteca','hn',382339.0,4211.0,'Choluteca','Choluteca').
province('Comayagua','hn',35988.0,5196.0,'Comayagua','Comayagua').
province('Copan','hn',291053.0,3203.0,'Santa Rosa de Copan','Copan').
province('Cortes','hn',1217627.0,3954.0,'San Pedro Sula','Cortes').
province('Distrito Central','hn',936064.0,1648.0,0.0,0.0).
province('El Paraiso','hn',352745.0,7218.0,'Yuscaran','El Paraiso').
province('Francisco Morazan','hn',258889.0,6298.0,'Tegucigalpa','Distrito Central').
province('Gracias a Dios','hn',64157.0,16630.0,'Puerto Lempira','Gracias a Dios').
province('Islas de la Bahia','hn',34490.0,261.0,'Roatan','Islas de la Bahia').
province('La Paz','hn',160405.0,2331.0,'La Paz','La Paz').
province('Lempira','hn',263849.0,4290.0,'Gracias','Lempira').
province('Ocotepeque','hn',110471.0,1680.0,'Ocotepeque','Ocotepeque').
province('Olancho','hn',414287.0,24351.0,0.0,0.0).
province('Santa Barbara','hn',338398.0,5115.0,'Santa Barbara','Santa Barbara').
province('Valle','hn',147058.0,1565.0,'Nacaome','Valle').
province('Yoro','hn',470283.0,7939.0,'Yoro','Yoro').
province('Bacs-Kiskun','hu',539854.0,8445.15,0.0,0.0).
province('Baranya','hu',398363.0,4429.5,0.0,0.0).
province('Bekes','hu',390610.0,5631.05,0.0,0.0).
province('Borsod-Abauj-Zemplen','hu',736875.0,7247.16,0.0,0.0).
province('Budapest','hu',1708088.0,525.16,0.0,0.0).
province('Csongrad','hu',420062.0,4262.68,0.0,0.0).
province('Fejer','hu',427741.0,4358.76,0.0,0.0).
province('Gyor-Moson-Sopron','hu',438297.0,4208.49,0.0,0.0).
province('Hajdu-Bihar','hu',547828.0,6210.56,0.0,0.0).
province('Heves','hu',320808.0,3637.41,0.0,0.0).
province('Jasz-Nagykun-Szolnok','hu',411826.0,5581.7,0.0,0.0).
province('Komarom-Esztergom','hu',313761.0,2265.08,0.0,0.0).
province('Nograd','hu',216104.0,2544.19,0.0,0.0).
province('Pest','hu',1128187.0,6393.52,0.0,0.0).
province('Somogy','hu',330602.0,6035.86,0.0,0.0).
province('Szabolcs-Szatmar-Bereg','hu',587025.0,5936.45,0.0,0.0).
province('Tolna','hu',246557.0,3703.26,0.0,0.0).
province('Vas','hu',263311.0,3336.18,0.0,0.0).
province('Veszprem','hu',364054.0,4429.8,0.0,0.0).
province('Zala','hu',293524.0,3784.1,0.0,0.0).
province('Almenningur','is',0.0,122.0,0.0,0.0).
province('Austurland','is',12153.0,22721.0,0.0,0.0).
province('Hoefueborgarsvaeei','is',186010.0,1062.0,0.0,0.0).
province('Noreurland eystra','is',26900.0,21968.0,0.0,0.0).
province('Noreurland vestra','is',9027.0,12737.0,0.0,0.0).
province('Sueurland','is',21704.0,24526.0,0.0,0.0).
province('Sueurnes','is',17203.0,829.0,0.0,0.0).
province('Vestfireir','is',7648.0,9409.0,0.0,0.0).
province('Vesturland','is',14302.0,9554.0,0.0,0.0).
province('Andhra Prades','in',7.8950682E7,276814.0,'Hyderabad','Andhra Pradesh').
province('Chandigarh','in',1013320.0,114.0,'Chandigarh','Chandigarh').
province('Chhattisgarh','in',2.1957319E7,146361.0,'Raipur','Chhattisgarh').
province('Daman and Diu','in',185043.0,110.0,'Daman','Daman and Diu').
province('Delhi','in',1.5766865E7,1485.0,'Delhi','Delhi').
province('Goa','in',1404863.0,3702.0,'Panaji','Goa').
province('Gujarat','in',5.3957041E7,195984.0,'Gandhinagar','Gujarat').
province('Himachal Pradesh','in',6394018.0,55673.0,'Shimla','Himachal Pradesh').
province('Jammu and Kashmir','in',1.0967895E7,101387.0,'Srinagar','Jammu and Kashmir').
province('Jharkhand','in',2.8866327E7,74677.0,'Ranchi','Jharkhand').
province('Lakshadweep','in',63911.0,32.0,'Kavaratti','Lakshadweep').
province('Manipur','in',2607021.0,22356.0,'Imphal','Manipur').
province('Meghalaya','in',2520136.0,22489.0,0.0,0.0).
province('Nagaland','in',2367467.0,16527.0,'Kohima','Nagaland').
province('Sikkim','in',594054.0,7299.0,'Gangtok','Sikkim').
province('Tamil Nadu','in',6.3995163E7,130069.0,'Madras','Tamil Nadu').
province('Tripura','in',3360263.0,10477.0,'Agartala','Tripura').
province('Uttaranchal','in',8986028.0,51125.0,'Dehra Dun','Uttaranchal').
province('Uttar Pradesh','in',1.79388842E8,243288.0,'Lakhnau','Uttar Pradesh').
province('Aceh','id',4221922.0,55392.0,0.0,0.0).
province('Bali','id',3331485.0,5561.0,0.0,0.0).
province('Bangka-Belitung','id',960327.0,16448.0,0.0,0.0).
province('Banten','id',8639752.0,8235.0,0.0,0.0).
province('Bengkulu','id',1805536.0,21168.0,0.0,0.0).
province('Gorontalo','id',890823.0,7957.0,0.0,0.0).
province('Jakarta','id',8540306.0,661.0,0.0,0.0).
province('Jambi','id',2644397.0,44800.0,0.0,0.0).
province('Jawa Barat','id',3.8116154E7,37994.0,0.0,0.0).
province('Jawa Tengah','id',3.251323E7,34206.0,0.0,0.0).
province('Jawa Timur','id',3.5839269E7,47921.0,0.0,0.0).
province('Kalimantan Barat','id',4480028.0,146760.0,0.0,0.0).
province('Kalimantan Selatan','id',3196446.0,37660.0,0.0,0.0).
province('Kalimantan Tengah','id',2132633.0,152600.0,0.0,0.0).
province('Kalimantan Timur','id',2810030.0,202440.0,0.0,0.0).
province('Lampung','id',7158163.0,33307.0,0.0,0.0).
province('Maluku','id',1286065.0,42853.0,0.0,0.0).
province('Maluku Utara','id',837498.0,31652.0,0.0,0.0).
province('Nusa Tenggara Barat','id',4349795.0,20177.0,0.0,0.0).
province('Nusa Tenggara Timur','id',4306693.0,47876.0,0.0,0.0).
province('Papua','id',2557281.0,421981.0,0.0,0.0).
province('Riau','id',5162023.0,72569.0,0.0,0.0).
province('Riau Kepulauan','id',832399.0,21992.0,0.0,0.0).
province('Sulawesi Selatan','id',8594288.0,72781.0,0.0,0.0).
province('Sulawesi Tengah','id',2505019.0,69726.0,0.0,0.0).
province('Sulawesi Tenggara','id',2101387.0,27686.0,0.0,0.0).
province('Sulawesi Utara','id',2146499.0,11066.0,0.0,0.0).
province('Sumatera Barat','id',4383935.0,49778.0,0.0,0.0).
province('Sumatera Selatan','id',7360551.0,87240.0,0.0,0.0).
province('Sumatera Utara','id',1.2391449E7,70787.0,0.0,0.0).
province('Yogyakarta','id',3211764.0,3169.0,0.0,0.0).
province('Ardabil','ir',1265606.0,17881.0,'Ardabil','Ardabil').
province('Azarbayejan-e Gharbi','ir',2955634.0,39487.0,0.0,0.0).
province('Azarbayejan-e Sharqi','ir',3529129.0,47830.0,0.0,0.0).
province('Bushehr','ir',815167.0,23191.0,'Bushehr','Bushehr').
province('Chahar Mahal-e Bakhtiari','ir',849399.0,16201.0,0.0,0.0).
province('Esfahan','ir',4440427.0,107027.0,'Esfahan','Esfahan').
province('Fars','ir',4409753.0,122416.0,'Shiraz','Fars').
province('Gilan','ir',2421673.0,14106.0,'Rasht','Gilan').
province('Golestan','ir',1642331.0,20891.0,'Gorgan','Golestan').
province('Hamadan','ir',1738484.0,19547.0,0.0,0.0).
province('Hormozgan','ir',1311681.0,71193.0,0.0,0.0).
province('Ilam','ir',536882.0,20151.0,'Ilam','Ilam').
province('Kerman','ir',2454958.0,181814.0,'Kerman','Kerman').
province('Kermanshah','ir',1913209.0,24741.0,'Kermanshah','Kermanshah').
province('Khorasan','ir',6583062.0,302766.0,0.0,0.0).
province('Khuzestan','ir',4225334.0,63238.0,'Ahvaz','Khuzestan').
province('Kohgiluyeh-e Boyerahmad','ir',696132.0,15563.0,0.0,0.0).
province('Kordestan','ir',1573222.0,29151.0,'Sanandaj','Kordestan').
province('Lorestan','ir',1769428.0,28392.0,0.0,0.0).
province('Markazi','ir',1364518.0,29406.0,'Arak','Markazi').
province('Mazandaran','ir',2822034.0,23064.0,'Sari','Mazandaran').
province('Qazvin','ir',1165936.0,15502.0,'Qazvin','Qazvin').
province('Qom','ir',1071475.0,11237.0,'Qom','Qom').
province('Semnan','ir',587080.0,96816.0,'Semnan','Semnan').
province('Sistan-e Baluchestan','ir',2288465.0,178431.0,0.0,0.0).
province('Tehran','ir',1.2066503E7,18637.0,'Tehran','Tehran').
province('Yazd','ir',985463.0,73467.0,'Yazd','Yazd').
province('Zanjan','ir',975695.0,21841.0,'Zanjan','Zanjan').
province('al-Anbar','iq',1170193.0,138501.0,0.0,0.0).
province('al-Basrah','iq',2325325.0,19070.0,0.0,0.0).
province('al-Mutzanna','iq',540360.0,51740.0,0.0,0.0).
province('al-Qadisiyah','iq',908205.0,8153.0,0.0,0.0).
province('an-Najaf','iq',921581.0,28824.0,0.0,0.0).
province('as-Sulaymaniyah','iq',1729388.0,17023.0,0.0,0.0).
province('at-Tamim','iq',863829.0,10282.0,0.0,0.0).
province('Babil','iq',1195824.0,6468.0,0.0,0.0).
province('Baghdad','iq',5960531.0,734.0,'Baghdad','Baghdad').
province('Dahuk','iq',497237.0,6553.0,'Dahuk','Dahuk').
province('Di Qar','iq',1386351.0,12900.0,0.0,0.0).
province('Diyala','iq',1244442.0,19076.0,'Baqubah','Diyala').
province('Irbil','iq',1384336.0,14471.0,0.0,0.0).
province('Karbala','iq',687197.0,5034.0,'Karbala','Karbala').
province('Maysan','iq',754823.0,16072.0,0.0,0.0).
province('Ninawa','iq',2521397.0,35899.0,0.0,0.0).
province('Salah-ad-Din','iq',1032689.0,26175.0,0.0,0.0).
province('Wasit','iq',971575.0,17153.0,0.0,0.0).
province('Carlow','ie',47393.0,896.55,0.0,0.0).
province('Cavan','ie',57473.0,1931.77,0.0,0.0).
province('Clare','ie',106924.0,3450.04,0.0,0.0).
province('Cork','ie',458068.0,7499.95,0.0,0.0).
province('Donegal','ie',139839.0,4860.91,0.0,0.0).
province('Dublin','ie',1146503.0,922.27,0.0,0.0).
province('Galway','ie',216926.0,6148.47,0.0,0.0).
province('Kerry','ie',134656.0,4806.89,0.0,0.0).
province('Kildare','ie',177574.0,1695.4,0.0,0.0).
province('Kilkenny','ie',82284.0,2072.89,0.0,0.0).
province('Laois','ie',60804.0,1719.9,0.0,0.0).
province('Leitrim','ie',25895.0,1590.03,0.0,0.0).
province('Limerick','ie',179071.0,2755.0,0.0,0.0).
province('Longford','ie',31308.0,1091.16,0.0,0.0).
province('Louth','ie',105295.0,826.13,0.0,0.0).
province('Mayo','ie',119088.0,5586.05,0.0,0.0).
province('Meath','ie',144184.0,2342.07,0.0,0.0).
province('Monaghan','ie',53085.0,1295.08,0.0,0.0).
province('Offaly','ie',65231.0,2001.17,0.0,0.0).
province('Roscommon','ie',54173.0,2548.19,0.0,0.0).
province('Sligo','ie',58900.0,1837.52,0.0,0.0).
province('Tipperary North Riding','ie',61926.0,2046.27,0.0,0.0).
province('Tipperary South Riding','ie',80276.0,2258.45,0.0,0.0).
province('Waterford','ie',104132.0,1856.59,0.0,0.0).
province('Westmeath','ie',75298.0,1839.65,0.0,0.0).
province('Wexford','ie',121123.0,2366.85,0.0,0.0).
province('Wicklow','ie',119874.0,2026.62,0.0,0.0).
province('Northern Islands','mp',8.0,171.0,0.0,0.0).
province('Rota','mp',3169.0,83.0,0.0,0.0).
province('Saipan','mp',72058.0,122.0,0.0,0.0).
province('Tinian','mp',4490.0,101.0,0.0,0.0).
province('Akershus','no',493645.0,4587.0,'Oslo','Akershus').
province('Aust-Agder','no',103575.0,8485.0,0.0,0.0).
province('Buskerud','no',243437.0,13856.0,'Drammen','Buskerud').
province('Finnmark','no',72961.0,45879.0,0.0,0.0).
province('Hedmark','no',188463.0,26120.0,0.0,0.0).
province('Hordaland','no',448000.0,14962.0,'Bergen','Hordaland').
province('More og Romsdal','no',244852.0,14596.0,'Molde','More og Romsdal').
province('Nordland','no',236830.0,36302.0,'Bodo','Nordland').
province('Nord-Trondelag','no',128170.0,20777.0,'Steinkjer','Nord-Trondelag').
province('Oppland','no',183847.0,23827.0,'Lillehammer','Oppland').
province('Oslo','no',525971.0,427.0,'Oslo','Akershus').
province('Ostfold','no',258349.0,3889.0,0.0,0.0).
province('Rogaland','no',392163.0,8553.0,'Stavanger','Rogaland').
province('Sogn og Fjordane','no',107190.0,17864.0,0.0,0.0).
province('Sor-Trondelag','no',271957.0,17839.0,'Trondheim','Sor').
province('Telemark','no',166282.0,14186.0,0.0,0.0).
province('Troms','no',153026.0,25147.0,'Tromso','Troms').
province('Vest-Agder','no',161126.0,6817.0,'Kristiansand','Vest-Agder').
province('Vestfold','no',220800.0,2140.0,0.0,0.0).
province('ad-Dahziliyah','om',273659.0,31900.0,0.0,0.0).
province('al-Batinah','om',668615.0,12500.0,0.0,0.0).
province('al-Wusta','om',24196.0,79700.0,0.0,0.0).
province('as-Sarqiyah','om',323917.0,36800.0,0.0,0.0).
province('az-Zahirah','om',211396.0,44000.0,0.0,0.0).
province('Musandam','om',28218.0,1800.0,0.0,0.0).
province('Muscat','om',646024.0,3500.0,0.0,0.0).
province('Zufar','om',220520.0,99300.0,0.0,0.0).
province('Azad Kashmir','pk',3865219.0,11639.0,0.0,0.0).
province('Baluchistan','pk',7707313.0,347190.0,0.0,0.0).
province('Federal Capital Area','pk',1115523.0,907.0,0.0,0.0).
province('Federally administered Tribal Areas','pk',3646348.0,27219.0,0.0,0.0).
province('Northern Areas','pk',1097651.0,72520.0,'Gilgit','Northern Areas').
province('North-West Frontier','pk',2.1165114E7,74521.0,0.0,0.0).
province('Punjab','pk',8.5575495E7,205344.0,0.0,0.0).
province('Sind','pk',3.5994079E7,140914.0,0.0,0.0).
province('Aimeliik','pw',221.0,52.0,'Ulimang','Aimeliik').
province('Airai','pw',2806.0,44.0,'Airai','Airai').
province('Angaur','pw',181.0,8.0,0.0,0.0).
province('Hatobohei','pw',13.0,3.0,0.0,0.0).
province('Kayangel','pw',145.0,3.0,'Kayangel','Kayangel').
province('Koror','pw',14048.0,65.0,'Koror','Koror').
province('Melekeok','pw',217.0,28.0,'Melekeok','Melekeok').
province('Ngaraard','pw',903.0,36.0,'Ngermechau','Ngaraard').
province('Ngardmau','pw',456.0,47.0,'Chol','Ngardmau').
province('Ngaremlengui','pw',209.0,65.0,'Ollei','Ngaremlengui').
province('Ngatpang','pw',537.0,47.0,0.0,0.0).
province('Ngchesar','pw',315.0,41.0,'Ngerkeai','Ngchesar').
province('Ngerchelong','pw',272.0,10.0,0.0,0.0).
province('Ngiwal','pw',198.0,26.0,'Ngetkip','Ngiwal').
province('Peleliu','pw',547.0,13.0,'Kloulklubed','Peleliu').
province('Sonsorol','pw',24.0,3.0,'Dongosaru','Sonsorol').
province('Singapore','sg',3547809.0,683.0,0.0,0.0).
province('Tombouctou','ml',463019.0,408977.0,'Tombouctou','Tombouctou').
province('Nouakchott','mr',709835.0,1000.0,'Nouakchott','Nouakchott').
province('Caprivi','na',78108.0,19532.0,'Katima Mulilo','Caprivi').
province('Hardap','na',65799.0,109888.0,'Mariental','Hardap').
province('Karas','na',70222.0,161324.0,'Keetmanshoop','Karas').
province('Khomas','na',279037.0,36804.0,'Windhoek','Khomas').
province('Ohangwena','na',238741.0,10582.0,'Eenhana','Ohangwena').
province('Oshana','na',210120.0,5290.0,'Oshakati','Oshana').
province('Otjozondjupa','na',144649.0,105327.0,'Otjiwarongo','Otjozondjupa').
province('Flevoland','nl',360833.0,1425.66,'Lelystad','Flevoland').
province('Gelderland','nl',1975063.0,4995.23,'Arnhem','Gelderland').
province('Limburg','nl',1143970.0,2167.46,'Maastricht','Limburg').
province('Noord-Brabant','nl',2413546.0,4938.23,'s-Hertogenbosch','Noord-Brabant').
province('Utrecht','nl',1166286.0,1356.11,'Utrecht','Utrecht').
province('Bonaire','an',10460.0,288.0,'Kralendijk','Bonaire').
province('Saba','an',1426.0,13.0,'The','Saba').
province('Sint Eustatius','an',2506.0,21.0,'Oranjestad','Sint Eustatius').
province('Manus','pg',48634.0,2100.0,'Lorengau','Manus').
province('Milne Bay','pg',232915.0,14000.0,'Alotau','Milne Bay').
province('National Capital District','pg',283733.0,240.0,'Port Moresby','National Capital District').
province('Oro','pg',149967.0,22800.0,'Popondetta','Oro').
province('Southern Highlands','pg',687138.0,23800.0,'Mendi','Southern Highlands').
province('Western Highlands','pg',511371.0,8500.0,'Mount Hagen','Western Highlands').
province('Alto Parana','py',618273.0,14895.0,'Ciudad del Este','Alto Parana').
province('Amambay','py',120681.0,12933.0,'Pedro Juan Caballero','Amambay').
province('Boquer','py',49756.0,91669.0,'Filadelfia','Boqueron').
province('Caazapa','py',141150.0,9496.0,'Caazapa','Caazapa').
province('Concepcion','py',181531.0,18051.0,'Concepcion','Concepcion').
province('Guaira','py',181129.0,3846.0,'Villarrica','Guaira').
province('Misiones','py',105164.0,9556.0,'San Juan Bautista','Misiones').
province('Paraguari','py',227921.0,8705.0,'Paraguari','Paraguari').
province('Presidente Hayes','py',88961.0,72907.0,'Pozo Colorado','Presidente Hayes').
province('Apurimac','pe',449049.0,20895.79,'Abancay','Apurimac').
province('Ayacucho','pe',544566.0,43814.8,'Ayacucho','Ayacucho').
province('Cusco','pe',1214299.0,71891.97,'Cusco','Cusco').
province('Huancavelica','pe',454366.0,22131.47,'Huancavelica','Huancavelica').
province('Junin','pe',1256529.0,44409.67,'Huancayo','Junin').
province('Lambayeque','pe',1196366.0,14231.3,'Chiclayo','Lambayeque').
province('Madre de Dios','pe',95187.0,85182.63,'Puerto Maldonado','Madre de Dios').
province('Pasco','pe',252650.0,25319.59,'Cerro de Pasco','Pasco').
province('San Martin','pe',920966.0,51253.31,'Moyobamba','San Martin').
province('Ucayali','pe',505724.0,102410.55,'Pucallpa','Ucayali').
province('Dolnoslaskie','pl',2889395.0,19948.0,'Wroclaw','Dolnoslaskie').
province('Lodzkie','pl',2581060.0,18219.0,'Lodz','Lodzkie').
province('Lubuskie','pl',1006273.0,13984.0,'Zielona Gora','Lubuskie').
province('Podkarpackie','pl',2084040.0,17926.0,'Rzeszow','Podkarpackie').
province('Pomorskie','pl',2196399.0,18293.0,'Gdansk','Pomorskie').
province('Swietokrzyskie','pl',1285509.0,11672.0,'Kielce','Swietokrzyskie').
province('Wielkopolskie','pl',3364886.0,29826.0,'Poznan','Wielkopolskie').
province('Umm Salal','qa',33908.0,470.37,'Umm Salal','Umm Salal').
province('Arges','ro',644458.0,6826.0,'Pitesti','Arges').
province('Bihor','ro',588020.0,7544.0,'Oradea','Bihor').
province('Bistrita-Nasaud','ro',307427.0,5355.0,'Bistrita','Bistrita-Nasaud').
province('Brasov','ro',572108.0,5363.0,'Brasov','Brasov').
province('Cara','ro',321302.0,8520.0,'Resita','Caras-Severin').
province('Constanta','ro',703863.0,7071.0,'Constanta','Constanta').
province('Giurgiu','ro',292956.0,3526.0,'Giurgiu','Giurgiu').
province('Harghita','ro',320818.0,6639.0,'Miercurea-Ciuc','Harghita').
province('Maramures','ro',501196.0,6304.0,'Baia Mare','Maramures').
province('Mehedinti','ro',298156.0,4933.0,'Drobeta-Turnu Severin','Mehedinti').
province('Salaj','ro',242741.0,3864.0,'Zalau','Salaj').
province('Suceava','ro',685773.0,8553.0,'Suceava','Suceava').
province('Teleorman','ro',423338.0,5790.0,'Alexandria','Teleorman').
province('Vaslui','ro',452508.0,5318.0,'Vaslui','Vaslui').
province('Vrancea','ro',388168.0,4857.0,'Focsani','Vrancea').
province('Gauteng','za',1.0058106E7,17010.0,'Johannesburg','Gauteng').
province('Mpumalanga','za',3409747.0,79490.0,'Nelspruit','Mpumalanga').
province('Sughd','tj',1989842.0,26100.0,'Khujand','Sughd').
province('Arusha','tz',1428690.0,36486.0,'Arusha','Arusha').
province('Dodoma','tz',1791151.0,41311.0,'Dodoma','Dodoma').
province('Kagera','tz',2189846.0,28388.0,'Bukoba','Kagera').
province('Kilimanjaro','tz',1430404.0,13309.0,'Moshi','Kilimanjaro').
province('Mara','tz',1456992.0,19566.0,'Musoma','Mara').
province('Morogoro','tz',1871927.0,70799.0,'Morogoro','Morogoro').
province('Pwani','tz',938922.0,32407.0,'Dar es Salaam','Dar es Salaam').
province('Ruvuma','tz',1190348.0,63498.0,'Songea','Ruvuma').
province('Singida','tz',1150946.0,49341.0,'Singida','Singida').
province('Tanga','tz',1708458.0,26808.0,'Tanga','Tanga').
province('Gegharkunik','am',213817.0,3655.0,'Gavar','Gegharkunik').
province('Shirak','am',255386.0,2679.0,'Gyumri','Shirak').
province('Yerevan','am',1083361.0,210.0,'Yerevan','Yerevan').
province('Niutao','tv',624.0,2.53,'Kua','Niutao').
province('Nukufetau','tv',565.0,2.99,'Savave','Nukufetau').
province('Nukulaelae','tv',402.0,1.82,'Fangaua','Nukulaelae').
province('Artigas','uy',79535.0,11928.0,'Artigas','Artigas').
province('Cerro Largo','uy',87447.0,13648.0,'Melo','Cerro Largo').
province('Durazno','uy',58232.0,11643.0,'Durazno','Durazno').
province('Lavalleja','uy',62824.0,10016.0,'Minas','Lavalleja').
province('Maldonado','uy',164717.0,4793.0,'Maldonado','Maldonado').
province('Paysandu','uy',120906.0,13922.0,'Paysandu','Paysandu').
province('Rivera','uy',108651.0,9370.0,'Rivera','Rivera').
province('Salto','uy',132347.0,14163.0,'Salto','Salto').
province('Tacuarembo','uy',88622.0,15438.0,'Tacuarembo','Tacuarembo').
province('Treinta y Tres','uy',53011.0,9529.0,'Treint','Treinta y Tres').
province('Malampa','vu',35329.0,2779.0,'Lakatoro','Malampa').
province('Sanma','vu',42868.0,4248.0,'Luganville','Sanma').
province('Torba','vu',8931.0,882.0,'Sola','Torba').
province('Amazonas','ve',75538.0,177617.0,'Puerto Ayacucho','Amazonas').
province('Apure','ve',415795.0,76500.0,'San Fernando','Apure').
province('Barinas','ve',702663.0,35200.0,'Barinas','Barinas').
province('Bolivar','ve',1335034.0,240528.0,'Ciudad Bolivar','Bolivar').
province('Delta Amacuro','ve',103602.0,40200.0,'Tucupita','Delta Amacuro').
province('Lara','ve',1686781.0,19800.0,'Barquisimeto','Lara').
province('Miranda','ve',2497804.0,7950.0,'Los Teques','Miranda').
province('Portuguesa','ve',781812.0,15200.0,'Guanare','Portuguesa').
province('Tovuz','az',149760.0,1900.0,'Tovuz','Tovuz').
province('Minsk','by',1742123.0,2500.0,'Minsk','Minsk').
province('Makamba','bi',499686.0,1959.6,'Makamba','Makamba').
province('Muyinga','bi',595952.0,1836.26,'Muyinga','Muyinga').
province('Ngozi','bi',719163.0,1473.86,'Ngozi','Ngozi').
province('Ruyigi','bi',369801.0,2338.88,'Ruyigi','Ruyigi').
province('Kampong Cham','kh',1965921.0,9799.0,'Kampong Cham','Kampong Cham').
province('Kampot','kh',645644.0,4873.0,'Kampot','Kampot').
province('Svay Rieng','kh',604770.0,2966.0,'Svay Rieng','Svay Rieng').
province('Est','cm',836906.0,109011.0,'Bertoua','Est').
province('Littoral','cm',2192267.0,20239.0,'Douala','Littoral').
province('Sud','cm',604864.0,47110.0,'Ebolowa','Sud').
province('Alberta','ca',3231873.0,661185.0,'Edmonton','Alberta').
province('Manitoba','ca',1185870.0,650086.0,'Winnipeg','Manitoba').
province('New Brunswick','ca',738296.0,73437.0,'Fredericton','New Brunswick').
province('Nova Scotia','ca',918312.0,55490.0,'Halifax','Nova Scotia').
province('Ontario','ca',1.2569177E7,1068582.0,'Toronto','Ontario').
province('Prince Edward Island','ca',142863.0,5657.0,'Charlottetown','Prince Edward Island').
province('Norte de Santander','co',1493932.0,21658.0,'Cucuta','Norte de Santander').
province('Risaralda','co',1024362.0,4140.0,'Pereira','Risaralda').
province('Sucre','co',868648.0,10917.0,'Sincelejo','Sucre').
province('Vaupes','co',33152.0,54135.0,'Mitu','Vaupes').
province('Vichada','co',97276.0,100242.0,'Puerto Carreno','Vichada').
province('Bouenza','cg',309059.0,12266.0,'Madingou','Bouenza').
province('Lekoumou','cg',74122.0,20950.0,'Sibiti','Lekoumou').
province('Plateaux','cg',119077.0,38400.0,'Djambala','Plateaux').
province('Sangha','cg',52676.0,55800.0,'Ouesso','Sangha').
province('Bas-Congo','cd',3802499.0,53920.0,'Matadi','Bas-Congo').
province('Kasai-Occidental','cd',4545647.0,154742.0,'Kananga','Kasai-Occidental').
province('Kasai-Oriental','cd',5719300.0,170302.0,'Mbuji-Mayi','Kasai-Oriental').
province('Maniema','cd',1718160.0,132250.0,'Kindu','Maniema').
province('Sud-Kivu','cd',3908889.0,65070.0,'Bukavu','Sud-Kivu').
province('Cartago','cr',485516.0,3124.61,'Cartago','Cartago').
province('Heredia','cr',399581.0,2656.98,'Heredia','Heredia').
province('Puntarenas','cr',406732.0,11265.71,'Puntarenas','Puntarenas').
province('Ciego de Avila','cu',418280.0,6485.0,'Ciego de Avila','Ciego de Avila').
province('Granma','cu',844762.0,8452.0,'Bayamo','Granma').
province('Guantanamo','cu',521680.0,6366.0,'Guantanamo','Guantanamo').
province('Isla de la Juventud','cu',81158.0,2199.0,'Nueva Gerona','Isla de la Juventud').
province('Sancti Spiritus','cu',465026.0,6737.0,'Sancti Spiritus','Sancti Spiritus').
province('Santiago de Cuba','cu',1050572.0,6343.0,'Santiago de Cuba','Santiago de Cuba').
province('Azua','do',210358.0,2531.77,'Azua','Azua').
province('Dajabon','do',59725.0,1020.73,'Dajabon','Dajabon').
province('Distrito Nacional','do',907317.0,104.44,'Santo Domingo','Distrito Nacional').
province('Elias Pina','do',63214.0,1426.2,'Comendador','Elias Pina').
province('Hato Mayor','do',89526.0,1329.28,'Hato Mayor','Hato Mayor').
province('La Romana','do',238053.0,653.95,'La Romana','La Romana').
province('Maria Trinidad Sanchez','do',138333.0,1271.71,'Nagua','Maria Trinidad Sanchez').
province('Northern','fj',152807.0,6199.0,'Labasa','Northern').
province('Western','fj',317068.0,6360.0,'Lautoka','Western').
province('Jalapa','gt',254270.0,2063.0,'Jalapa','Jalapa').
province('Jutiapa','gt',408261.0,3219.0,'Jutiapa','Jutiapa').
province('Quiche','gt',726260.0,8378.0,'Santa Cruz del Quiche','Quiche').
province('Sacatepequez','gt',268547.0,465.0,'Antigua Guatemala','Sacatepequez').
province('Santa Rosa','gt',313191.0,2955.0,'Cuilapa','Santa Rosa').
province('Suchitepequez','gt',429648.0,2510.0,'Mazatenango','Suchitepequez').
province('Zacapa','gt',211220.0,2690.0,'Zacapa','Zacapa').
province('Conakry','gn',1871185.0,308.0,'Conakry','Conakry').
province('Kankan','gn',234815.0,18400.0,'Kankan','Kankan').
province('Labe','gn',204220.0,2520.0,'Labe','Labe').
province('Nzerekore','gn',278070.0,3781.0,'Nzerekore','Nzerekore').
province('Biombo','gw',69752.0,838.0,'Quinhamel','Biombo').
province('Cacheu','gw',179740.0,5175.0,'Cacheu','Cacheu').
province('Oio','gw',196058.0,5403.0,'Farim','Oio').
province('Quinara','gw',62261.0,3138.0,'Fulacunda','Quinara').
province('Artibonite','ht',1128049.0,4895.0,'Gonaives','Artibonite').
province('Nord-Est','ht',263634.0,1698.0,'Fort-Liberte','Nord-Est').
province('Nord-Ouest','ht',482863.0,2094.0,'Port-de-Paix','Nord-Ouest').
province('Sud-Est','ht',469055.0,2077.0,'Jacmel','Sud-Est').
province('Atlantida','hn',336579.0,4251.0,'La Ceiba','Atlantida').
province('Colon','hn',240041.0,8875.0,'Trujillo','Colon').
province('Gaza Strip','ps',1389789.0,365.0,0.0,0.0).
province('West Bank','ps',2372216.0,5655.0,0.0,0.0).
province('Bavaria','de',1.2502158E7,70549.32,'Munich','Bavaria').
province('Thuringia','de',2353016.0,16172.21,'Erfurt','Thuringia').
province('North Rhine-Westphalia','de',1.8125802E7,34082.76,'Duesseldorf','North Rhine-Westphalia').
province('Mecklenburg-West Pommerania','de',1714301.0,23173.46,'Schwerin','Mecklenburg-West Pommerania').
province('Dadra and Nagar Haveli','in',257513.0,491.0,'Silvassa','Dadra and Nagar Haveli').
province('Pondicherry','in',1038875.0,492.0,'Pondicherry','Pondicherry').
province('Andaman and Nicobar Islands','in',388782.0,8293.0,'Port Blair','Andaman and Nicobar Islands').
province('Punjab','in',2.5710906E7,50362.0,'Chandigarh','Chandigarh').
province('Haryana','in',2.2876486E7,44222.0,'Chandigarh','Chandigarh').
province('Rajasthan','in',6.1336965E7,342214.0,'Jaipur','Rajasthan').
province('Bihar','in',9.0268487E7,99199.0,'Patna','Bihar').
province('Arunachal Pradesh','in',1183042.0,83578.0,'Itanagar','Arunachal Pradesh').
province('Mizoram','in',974614.0,21087.0,'Aizawl','Mizoram').
province('Assam','in',2.8019522E7,78523.0,'Dispur','Assam').
province('Bangla','in',8.4599353E7,87853.0,'Calcutta','Bangla').
province('Orissa','in',3.8431586E7,155782.0,'Bhubaneswar','Orissa').
province('Madhya Pradesh','in',6.4989164E7,296480.0,'Bhopal','Madhya Pradesh').
province('Maharashtra','in',1.03390867E8,307762.0,'Bombay','Maharashtra').
province('Karnataka','in',5.5436928E7,191773.0,'Bangalore','Karnataka').
province('Kerala','in',3.2621329E7,38864.0,'Thiruvananthapuram','Kerala').
province('Hong Kong','cn',6983938.0,1085.0,'Victoria','Hong Kong').
province('Fujian','cn',3.4062204E7,123603.0,'Fuzhou','Fujian').
province('Guangdong','cn',7.7333529E7,177933.0,'Guangzhou','Guangdong').
province('Guizhou','cn',3.8090358E7,176505.0,'Guiyang','Guizhou').
province('Hebei','cn',6.894917E7,187991.0,'Shijiazhuang','Hebei').
province('Henan','cn',9.4811791E7,166499.0,'Zhengzhou','Henan').
province('Hunan','cn',6.7787707E7,211836.0,'Changsha','Hunan').
province('Jiangxi','cn',4.2590186E7,167430.0,'Nanchang','Jiangxi').
province('Liaoning','cn',4.1699162E7,147785.0,'Shenyang','Liaoning').
province('Ningxia','cn',6234044.0,55461.0,'Yinchuan','Ningxia').
province('Shaanxi','cn',3.6881993E7,205693.0,'Xian','Shaanxi').
province('Shanxi','cn',3.4024073E7,157023.0,'Taiyuan','Shanxi').
province('Yunnan','cn',4.1997191E7,393734.0,'Kunming','Yunnan').
province('Xizang','cn',2610891.0,1268947.0,'Lasa','Xizang').
province('Arizona','us',5863808.0,294333.0,'Phoenix','Arizona').
province('California','us',3.6354316E7,403971.0,'Sacramento','California').
province('Florida','us',1.7671451E7,139697.0,'Tallahassee','Florida').
province('Hawaii','us',1284220.0,16636.0,'Honolulu','Hawaii').
province('Kansas','us',2740760.0,211922.0,'Topeka','Kansas').
province('Louisiana','us',4515939.0,112836.0,'Baton Rouge','Louisiana').
province('Massachusetts','us',6460024.0,20300.0,'Boston','Massachusetts').
province('Missouri','us',5768152.0,178446.0,'Jefferson City','Missouri').
province('North Carolina','us',8611367.0,126180.0,'Raleigh','North Carolina').
province('Oklahoma','us',3547050.0,177877.0,'Oklahoma City','Oklahoma').
province('South Dakota','us',770185.0,196576.0,'Pierre','South Dakota').
province('Vermont','us',624501.0,23955.0,'Montpelier','Vermont').
province('Wyoming','us',505909.0,251501.0,'Cheyenne','Wyoming').
province('Puebla','mx',5522918.0,33919.0,'Puebla','Puebla').
province('Darien','pa',42391.0,11090.6,'La Palma','Darien').
province('Olt','ro',479933.0,5498.0,'Slatina','Olt').
province('Connecticut','us',3527249.0,12547.0,'Hartford','Connecticut').
province('District of Columbia','us',552433.0,159.0,'Washington','District of').
province('Kentucky','us',4165047.0,102907.0,'Frankfort','Kentucky').
province('Mississippi','us',2901372.0,122331.0,'Jackson','Mississippi').
province('Nebraska','us',1757399.0,199113.0,'Lincoln','Nebraska').
province('New Jersey','us',8751437.0,19210.0,'Trenton','New Jersey').
province('New Mexico','us',1912685.0,314334.0,'Santa Fe','New Mexico').
province('Oregon','us',3642919.0,251385.0,'Salem','Oregon').
province('Pennsylvania','us',1.2411466E7,116083.0,'Harrisburg','Pennsylvania').
province('Virginia','us',7576559.0,102558.0,'Richmond','Virginia').
province('West Virginia','us',1817872.0,62385.0,'Charleston','West Virginia').
province('Caqueta','co',463333.0,88965.0,'Florencia','Caqueta').
province('San Jose','cr',1510024.0,4959.9,'San Jose','San Jose').
province('Intibuca','hn',190402.0,3072.0,'La Esperanza','Intibuca').
province('Idaho','us',1416564.0,214325.0,'Boise City','Idaho').
province('Tennessee','us',5935099.0,106759.0,'Nashville-Davidson','Tennessee').

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
